/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/files/common/files","vs/base/common/types","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/node/pfs","vs/base/common/cancellation","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/process","os","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/map","vs/base/common/stream","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","child_process","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/codicons","vs/base/common/jsonFormatter","fs","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/iterator","net","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/hash","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/mime","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","string_decoder","util","minimist","path","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ie=function(K){for(var e=[],D=0,n=K.length;D<n;D++)e[D]=ne[K[D]];return e};define(ne[99],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function D(n,L){if(!n)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=D}),define(ne[48],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function D(A){return A?A.replace(/\$\((.*?)\)/g,(R,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=D;class n{constructor(R,b,E){this.id=R,this.definition=b,this.description=E,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function L(A,R){const b=["codicon","codicon-"+A];return R&&b.push("codicon-modifier-"+R),b}e.getClassNamesArray=L;var T;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function b(C){if(C instanceof n)return["codicon","codicon-"+C.id];const f=R.exec(C.id);if(!f)return b(n.error);let[,p,u]=f;const m=["codicon","codicon-"+p];return u&&m.push("codicon-modifier-"+u.substr(1)),m}A.asClassNameArray=b;function E(C){return b(C).join(" ")}A.asClassName=E;function I(C){return"."+b(C).join(".")}A.asCSSSelector=I})(T=e.CSSIcon||(e.CSSIcon={}))}),define(ne[67],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const D=Object.prototype.hasOwnProperty;function n(I){const C=[];for(let f in I)D.call(I,f)&&C.push(I[f]);return C}e.values=n;function L(I,C){for(let f in I)if(D.call(I,f)&&C({key:f,value:I[f]},function(){delete I[f]})===!1)return}e.forEach=L;function T(I,C){const f=Object.create(null);for(const p of I){const u=C(p);let m=f[u];m||(m=f[u]=[]),m.push(p)}return f}e.groupBy=T;function A(I){const C=Object.create(null);return I&&I.forEach((f,p)=>{C[p]=f}),C}e.fromMap=A;function R(I,C){const f=[],p=[];for(let u of I)C.has(u)||f.push(u);for(let u of C)I.has(u)||p.push(u);return{removed:f,added:p}}e.diffSets=R;function b(I,C){const f=[],p=[];for(let[u,m]of I)C.has(u)||f.push(m);for(let[u,m]of C)I.has(u)||p.push(m);return{removed:f,added:p}}e.diffMaps=b;class E{constructor(){this.map=new Map}add(C,f){let p=this.map.get(C);p||(p=new Set,this.map.set(C,p)),p.add(f)}delete(C,f){const p=this.map.get(C);!p||(p.delete(f),p.size===0&&this.map.delete(C))}forEach(C,f){const p=this.map.get(C);!p||p.forEach(f)}}e.SetMap=E}),define(ne[54],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(A){return(R,b,E)=>{let I=null,C=null;if(typeof E.value=="function"?(I="value",C=E.value):typeof E.get=="function"&&(I="get",C=E.get),!C)throw new Error("not supported");E[I]=A(C,b)}}e.createDecorator=D;function n(A,R,b){let E=null,I=null;if(typeof b.value=="function"?(E="value",I=b.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(E="get",I=b.get),!I)throw new Error("not supported");const C=`$memoize$${R}`;b[E]=function(...f){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,f)}),this[C]}}e.memoize=n;function L(A,R,b){return D((E,I)=>{const C=`$debounce$${I}`,f=`$debounce$result$${I}`;return function(...p){this[f]||(this[f]=b?b():void 0),clearTimeout(this[C]),R&&(this[f]=R(this[f],...p),p=[this[f]]),this[C]=setTimeout(()=>{E.apply(this,p),this[f]=b?b():void 0},A)}})}e.debounce=L;function T(A,R,b){return D((E,I)=>{const C=`$throttle$timer$${I}`,f=`$throttle$result$${I}`,p=`$throttle$lastRun$${I}`,u=`$throttle$pending$${I}`;return function(...m){if(this[f]||(this[f]=b?b():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),R&&(this[f]=R(this[f],...m)),this[u])return;const d=this[p]+A;d<=Date.now()?(this[p]=Date.now(),E.apply(this,[this[f]]),this[f]=b?b():void 0):(this[u]=!0,this[C]=setTimeout(()=>{this[u]=!1,this[p]=Date.now(),E.apply(this,[this[f]]),this[f]=b?b():void 0},d-Date.now()))}})}e.throttle=T}),define(ne[9],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(c=>{c(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=D,e.errorHandler=new D;function n(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=n;function L(l){b(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=L;function T(l){b(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=T;function A(l){if(l instanceof Error){let{name:r,message:c}=l;const i=l.stacktrace||l.stack;return{$isError:!0,name:r,message:c,stack:i}}return l}e.transformErrorForSerialization=A;const R="Canceled";function b(l){return l instanceof E?!0:l instanceof Error&&l.name===R&&l.message===R}e.isCancellationError=b;class E extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=E;function I(){const l=new Error(R);return l.name=l.message,l}e.canceled=I;function C(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=C;function f(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=f;function p(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function u(l){const r=new Error(`${l} has been disposed`);return r.name="DISPOSED",r}e.disposed=u;function m(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=m;class d extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=d;class g extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=g;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function y(l){const r=l;return r instanceof Error&&Array.isArray(r.actions)}e.isErrorWithActions=y;function S(l,r=Object.create(null)){const c=new Error(l);return r.actions&&(c.actions=r.actions),c}e.createErrorWithActions=S}),define(ne[16],ie([0,1,9]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(W,$=0){return W[W.length-(1+$)]}e.tail=n;function L(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=L;function T(W,$,x=(z,B)=>z===B){if(W===$)return!0;if(!W||!$||W.length!==$.length)return!1;for(let z=0,B=W.length;z<B;z++)if(!x(W[z],$[z]))return!1;return!0}e.equals=T;function A(W,$,x){let z=0,B=W.length-1;for(;z<=B;){const te=(z+B)/2|0,se=x(W[te],$);if(se<0)z=te+1;else if(se>0)B=te-1;else return te}return-(z+1)}e.binarySearch=A;function R(W,$){let x=0,z=W.length;if(z===0)return 0;for(;x<z;){const B=Math.floor((x+z)/2);$(W[B])?z=B:x=B+1}return x}e.findFirstInSorted=R;function b(W,$,x){if(W=W|0,W>=$.length)throw new TypeError("invalid index");let z=$[Math.floor($.length*Math.random())],B=[],te=[],se=[];for(let ce of $){const he=x(ce,z);he<0?B.push(ce):he>0?te.push(ce):se.push(ce)}return W<B.length?b(W,B,x):W<B.length+se.length?se[0]:b(W-(B.length+se.length),te,x)}e.quickSelect=b;function E(W,$){const x=[];let z;for(const B of W.slice(0).sort($))!z||$(z[0],B)!==0?(z=[B],x.push(z)):z.push(B);return x}e.groupBy=E;function I(W,$,x){const z=[];function B(ce,he,ve){if(he===0&&ve.length===0)return;const pe=z[z.length-1];pe&&pe.start+pe.deleteCount===ce?(pe.deleteCount+=he,pe.toInsert.push(...ve)):z.push({start:ce,deleteCount:he,toInsert:ve})}let te=0,se=0;for(;;){if(te===W.length){B(te,0,$.slice(se));break}if(se===$.length){B(te,W.length-te,[]);break}const ce=W[te],he=$[se],ve=x(ce,he);ve===0?(te+=1,se+=1):ve<0?(B(te,1,[]),te+=1):ve>0&&(B(te,0,[he]),se+=1)}return z}e.sortedDiff=I;function C(W,$,x){const z=I(W,$,x),B=[],te=[];for(const se of z)B.push(...W.slice(se.start,se.start+se.deleteCount)),te.push(...se.toInsert);return{removed:B,added:te}}e.delta=C;function f(W,$,x){if(x===0)return[];const z=W.slice(0,x).sort($);return u(W,$,z,x,W.length),z}e.top=f;function p(W,$,x,z,B){return x===0?Promise.resolve([]):new Promise((te,se)=>{(async()=>{const ce=W.length,he=W.slice(0,x).sort($);for(let ve=x,pe=Math.min(x+z,ce);ve<ce;ve=pe,pe=Math.min(pe+z,ce)){if(ve>x&&await new Promise(Ie=>setTimeout(Ie)),B&&B.isCancellationRequested)throw(0,D.canceled)();u(W,$,he,ve,pe)}return he})().then(te,se)})}e.topAsync=p;function u(W,$,x,z,B){for(const te=x.length;z<B;z++){const se=W[z];if($(se,x[te-1])<0){x.pop();const ce=R(x,he=>$(se,he)<0);x.splice(ce,0,se)}}}function m(W){return W.filter($=>!!$)}e.coalesce=m;function d(W){let $=0;for(let x=0;x<W.length;x++)W[x]&&(W[$]=W[x],$+=1);W.length=$}e.coalesceInPlace=d;function g(W,$,x){W.splice(x,0,W.splice($,1)[0])}e.move=g;function w(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=w;function y(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=y;function S(W,$=x=>x){const x=new Set;return W.filter(z=>{const B=$(z);return x.has(B)?!1:(x.add(B),!0)})}e.distinct=S;function l(W){const $=new Set;return x=>{const z=W(x);return $.has(z)?!1:($.add(z),!0)}}e.uniqueFilter=l;function r(W,$){const x=c(W,$);if(x!==-1)return W[x]}e.findLast=r;function c(W,$){for(let x=W.length-1;x>=0;x--){const z=W[x];if($(z))return x}return-1}e.lastIndex=c;function i(W,$){return W.length>0?W[0]:$}e.firstOrDefault=i;function t(W,$,x=(z,B)=>z===B){let z=0;for(let B=0,te=Math.min(W.length,$.length);B<te&&x(W[B],$[B]);B++)z++;return z}e.commonPrefixLength=t;function o(W){return[].concat(...W)}e.flatten=o;function s(W,$){let x=typeof $=="number"?W:0;typeof $=="number"?x=W:(x=0,$=W);const z=[];if(x<=$)for(let B=x;B<$;B++)z.push(B);else for(let B=x;B>$;B--)z.push(B);return z}e.range=s;function a(W,$,x){return W.reduce((z,B)=>(z[$(B)]=x?x(B):B,z),Object.create(null))}e.index=a;function h(W,$){return W.push($),()=>v(W,$)}e.insert=h;function v(W,$){const x=W.indexOf($);if(x>-1)return W.splice(x,1),$}e.remove=v;function P(W,$,x){const z=W.slice(0,$),B=W.slice($);return z.concat(x,B)}e.arrayInsert=P;function _(W,$){let x;if(typeof $=="number"){let z=$;x=()=>{const B=Math.sin(z++)*179426549;return B-Math.floor(B)}}else x=Math.random;for(let z=W.length-1;z>0;z-=1){const B=Math.floor(x()*(z+1)),te=W[z];W[z]=W[B],W[B]=te}}e.shuffle=_;function O(W,$){const x=W.indexOf($);x>-1&&(W.splice(x,1),W.unshift($))}e.pushToStart=O;function U(W,$){const x=W.indexOf($);x>-1&&(W.splice(x,1),W.push($))}e.pushToEnd=U;function k(W,$){return Array.isArray(W)?W.map($):$(W)}e.mapArrayOrNot=k;function M(W){return Array.isArray(W)?W:[W]}e.asArray=M;function F(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=F;function V(W,$){for(const x of W){const z=$(x);if(z!==void 0)return z}}e.mapFind=V;function N(W,$,x){const z=J(W,$),B=W.length,te=x.length;W.length=B+te;for(let se=B-1;se>=z;se--)W[se+te]=W[se];for(let se=0;se<te;se++)W[se+z]=x[se]}e.insertInto=N;function G(W,$,x,z){const B=J(W,$),te=W.splice(B,x);return N(W,B,z),te}e.splice=G;function J(W,$){return $<0?Math.max($+W.length,0):Math.min($,W.length)}function j(W,$){return(x,z)=>$(W(x),W(z))}e.compareBy=j;const q=(W,$)=>W-$;e.numberComparator=q;function X(W,$){if(W.length===0)return;let x=W[0];for(let z=1;z<W.length;z++){const B=W[z];$(B,x)>0&&(x=B)}return x}e.findMaxBy=X;function H(W,$){if(W.length===0)return;let x=W[0];for(let z=1;z<W.length;z++){const B=W[z];$(B,x)>=0&&(x=B)}return x}e.findLastMaxBy=H;function Z(W,$){return X(W,(x,z)=>-$(x,z))}e.findMinBy=Z;class ee{constructor($){this.items=$,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile($){let x=this.firstIdx;for(;x<this.items.length&&$(this.items[x]);)x++;const z=x===this.firstIdx?null:this.items.slice(this.firstIdx,x);return this.firstIdx=x,z}takeFromEndWhile($){let x=this.lastIdx;for(;x>=0&&$(this.items[x]);)x--;const z=x===this.lastIdx?null:this.items.slice(x+1,this.lastIdx+1);return this.lastIdx=x,z}peek(){return this.items[this.firstIdx]}dequeue(){const $=this.items[this.firstIdx];return this.firstIdx++,$}takeCount($){const x=this.items.slice(this.firstIdx,this.firstIdx+$);return this.firstIdx+=$,x}}e.ArrayQueue=ee}),define(ne[68],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(n){const L=this;let T=!1,A;return function(){return T||(T=!0,A=n.apply(L,arguments)),A}}e.once=D}),define(ne[55],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(n){function L(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}n.is=L;const T=Object.freeze([]);function A(){return T}n.empty=A;function*R(l){yield l}n.single=R;function b(l){return l||T}n.from=b;function E(l){return!l||l[Symbol.iterator]().next().done===!0}n.isEmpty=E;function I(l){return l[Symbol.iterator]().next().value}n.first=I;function C(l,r){for(const c of l)if(r(c))return!0;return!1}n.some=C;function f(l,r){for(const c of l)if(r(c))return c}n.find=f;function*p(l,r){for(const c of l)r(c)&&(yield c)}n.filter=p;function*u(l,r){let c=0;for(const i of l)yield r(i,c++)}n.map=u;function*m(...l){for(const r of l)for(const c of r)yield c}n.concat=m;function*d(l){for(const r of l)for(const c of r)yield c}n.concatNested=d;function g(l,r,c){let i=c;for(const t of l)i=r(i,t);return i}n.reduce=g;function*w(l,r,c=l.length){for(r<0&&(r+=l.length),c<0?c+=l.length:c>l.length&&(c=l.length);r<c;r++)yield l[r]}n.slice=w;function y(l,r=Number.POSITIVE_INFINITY){const c=[];if(r===0)return[c,l];const i=l[Symbol.iterator]();for(let t=0;t<r;t++){const o=i.next();if(o.done)return[c,n.empty()];c.push(o.value)}return[c,{[Symbol.iterator](){return i}}]}n.consume=y;function S(l,r,c=(i,t)=>i===t){const i=l[Symbol.iterator](),t=r[Symbol.iterator]();for(;;){const o=i.next(),s=t.next();if(o.done!==s.done)return!1;if(o.done)return!0;if(!c(o.value,s.value))return!1}}n.equals=S})(D=e.Iterable||(e.Iterable={}))}),define(ne[35],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var n;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(r){r.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function A(r,c=!1){let i=0,t=r.length,o="",s=0,a=16,h=0;function v(F){let V=0,N=0;for(;V<F;){const G=r.charCodeAt(i);if(G>=48&&G<=57)N=N*16+G-48;else if(G>=65&&G<=70)N=N*16+G-65+10;else if(G>=97&&G<=102)N=N*16+G-97+10;else break;i++,V++}return V<F&&(N=-1),N}function P(F){i=F,o="",s=0,a=16,h=0}function _(){const F=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&E(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&E(r.charCodeAt(i)))for(i++;i<r.length&&E(r.charCodeAt(i));)i++;else return h=3,r.substring(F,i);let V=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&E(r.charCodeAt(i))){for(i++;i<r.length&&E(r.charCodeAt(i));)i++;V=i}else h=3;return r.substring(F,V)}function O(){let F="",V=i;for(;;){if(i>=t){F+=r.substring(V,i),h=2;break}const N=r.charCodeAt(i);if(N===34){F+=r.substring(V,i),i++;break}if(N===92){if(F+=r.substring(V,i),i++,i>=t){h=2;break}switch(r.charCodeAt(i++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const J=v(4);J>=0?F+=String.fromCharCode(J):h=4;break}default:h=5}V=i;continue}if(N>=0&&N<=31)if(b(N)){F+=r.substring(V,i),h=2;break}else h=6;i++}return F}function U(){if(o="",h=0,s=i,i>=t)return s=t,a=17;let F=r.charCodeAt(i);if(R(F)){do i++,o+=String.fromCharCode(F),F=r.charCodeAt(i);while(R(F));return a=15}if(b(F))return i++,o+=String.fromCharCode(F),F===13&&r.charCodeAt(i)===10&&(i++,o+=`
`),a=14;switch(F){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,o=O(),a=10;case 47:{const V=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<t&&!b(r.charCodeAt(i));)i++;return o=r.substring(V,i),a=12}if(r.charCodeAt(i+1)===42){i+=2;const N=t-1;let G=!1;for(;i<N;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,G=!0;break}i++}return G||(i++,h=1),o=r.substring(V,i),a=13}return o+=String.fromCharCode(F),i++,a=16}case 45:if(o+=String.fromCharCode(F),i++,i===t||!E(r.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=_(),a=11;default:for(;i<t&&k(F);)i++,F=r.charCodeAt(i);if(s!==i){switch(o=r.substring(s,i),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode(F),i++,a=16}}function k(F){if(R(F)||b(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let F;do F=U();while(F>=12&&F<=15);return F}return{setPosition:P,getPosition:()=>i,scan:c?M:U,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>s,getTokenLength:()=>i-s,getTokenError:()=>h}}e.createScanner=A;function R(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function b(r){return r===10||r===13||r===8232||r===8233}function E(r){return r>=48&&r<=57}var I;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(I||(I={}));function C(r,c){const i=[],t=new Object;let o;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function h(v,P,_,O){s.value=v,s.offset=P,s.length=_,s.type=O,s.colonOffset=void 0,o=s}try{y(r,{onObjectBegin:(v,P)=>{if(c<=v)throw t;o=void 0,a=c>v,i.push("")},onObjectProperty:(v,P,_)=>{if(c<P||(h(v,P,_,"property"),i[i.length-1]=v,c<=P+_))throw t},onObjectEnd:(v,P)=>{if(c<=v)throw t;o=void 0,i.pop()},onArrayBegin:(v,P)=>{if(c<=v)throw t;o=void 0,i.push(0)},onArrayEnd:(v,P)=>{if(c<=v)throw t;o=void 0,i.pop()},onLiteralValue:(v,P,_)=>{if(c<P||(h(v,P,_,l(v)),c<=P+_))throw t},onSeparator:(v,P,_)=>{if(c<=P)throw t;if(v===":"&&o&&o.type==="property")o.colonOffset=P,a=!1,o=void 0;else if(v===","){const O=i[i.length-1];typeof O=="number"?i[i.length-1]=O+1:(a=!0,i[i.length-1]=""),o=void 0}}})}catch(v){if(v!==t)throw v}return{path:i,previousNode:o,isAtPropertyKey:a,matches:v=>{let P=0;for(let _=0;P<v.length&&_<i.length;_++)if(v[P]===i[_]||v[P]==="*")P++;else if(v[P]!=="**")return!1;return P===v.length}}}e.getLocation=C;function f(r,c=[],i=T.DEFAULT){let t=null,o=[];const s=[];function a(v){Array.isArray(o)?o.push(v):t!==null&&(o[t]=v)}return y(r,{onObjectBegin:()=>{const v={};a(v),s.push(o),o=v,t=null},onObjectProperty:v=>{t=v},onObjectEnd:()=>{o=s.pop()},onArrayBegin:()=>{const v=[];a(v),s.push(o),o=v,t=null},onArrayEnd:()=>{o=s.pop()},onLiteralValue:a,onError:(v,P,_)=>{c.push({error:v,offset:P,length:_})}},i),o[0]}e.parse=f;function p(r,c=[],i=T.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(v){t.type==="property"&&(t.length=v-t.offset,t=t.parent)}function s(v){return t.children.push(v),v}y(r,{onObjectBegin:v=>{t=s({type:"object",offset:v,length:-1,parent:t,children:[]})},onObjectProperty:(v,P,_)=>{t=s({type:"property",offset:P,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:v,offset:P,length:_,parent:t})},onObjectEnd:(v,P)=>{t.length=v+P-t.offset,t=t.parent,o(v+P)},onArrayBegin:(v,P)=>{t=s({type:"array",offset:v,length:-1,parent:t,children:[]})},onArrayEnd:(v,P)=>{t.length=v+P-t.offset,t=t.parent,o(v+P)},onLiteralValue:(v,P,_)=>{s({type:l(v),offset:P,length:_,parent:t,value:v}),o(P+_)},onSeparator:(v,P,_)=>{t.type==="property"&&(v===":"?t.colonOffset=P:v===","&&o(P))},onError:(v,P,_)=>{c.push({error:v,offset:P,length:_})}},i);const h=t.children[0];return h&&delete h.parent,h}e.parseTree=p;function u(r,c){if(!r)return;let i=r;for(let t of c)if(typeof t=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const s of i.children)if(Array.isArray(s.children)&&s.children[0].value===t){i=s.children[1],o=!0;break}if(!o)return}else{const o=t;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=u;function m(r){if(!r.parent||!r.parent.children)return[];const c=m(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;c.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&c.push(i)}return c}e.getNodePath=m;function d(r){switch(r.type){case"array":return r.children.map(d);case"object":{const c=Object.create(null);for(let i of r.children){const t=i.children[1];t&&(c[i.children[0].value]=d(t))}return c}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=d;function g(r,c,i=!1){return c>=r.offset&&c<r.offset+r.length||i&&c===r.offset+r.length}e.contains=g;function w(r,c,i=!1){if(g(r,c,i)){const t=r.children;if(Array.isArray(t))for(let o=0;o<t.length&&t[o].offset<=c;o++){const s=w(t[o],c,i);if(s)return s}return r}}e.findNodeAtOffset=w;function y(r,c,i=T.DEFAULT){const t=A(r,!1);function o(ee){return ee?()=>ee(t.getTokenOffset(),t.getTokenLength()):()=>!0}function s(ee){return ee?W=>ee(W,t.getTokenOffset(),t.getTokenLength()):()=>!0}const a=o(c.onObjectBegin),h=s(c.onObjectProperty),v=o(c.onObjectEnd),P=o(c.onArrayBegin),_=o(c.onArrayEnd),O=s(c.onLiteralValue),U=s(c.onSeparator),k=o(c.onComment),M=s(c.onError),F=i&&i.disallowComments,V=i&&i.allowTrailingComma;function N(){for(;;){const ee=t.scan();switch(t.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:F||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(ee){case 12:case 13:F?G(10):k();break;case 16:G(1);break;case 15:case 14:break;default:return ee}}}function G(ee,W=[],$=[]){if(M(ee),W.length+$.length>0){let x=t.getToken();for(;x!==17;){if(W.indexOf(x)!==-1){N();break}else if($.indexOf(x)!==-1)break;x=N()}}}function J(ee){const W=t.getTokenValue();return ee?O(W):h(W),N(),!0}function j(){switch(t.getToken()){case 11:{let ee=0;try{ee=JSON.parse(t.getTokenValue()),typeof ee!="number"&&(G(2),ee=0)}catch{G(2)}O(ee);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return N(),!0}function q(){return t.getToken()!==10?(G(3,[],[2,5]),!1):(J(!1),t.getToken()===6?(U(":"),N(),Z()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function X(){a(),N();let ee=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(ee||G(4,[],[]),U(","),N(),t.getToken()===2&&V)break}else ee&&G(6,[],[]);q()||G(4,[],[2,5]),ee=!0}return v(),t.getToken()!==2?G(7,[2],[]):N(),!0}function H(){P(),N();let ee=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(ee||G(4,[],[]),U(","),N(),t.getToken()===4&&V)break}else ee&&G(6,[],[]);Z()||G(4,[],[4,5]),ee=!0}return _(),t.getToken()!==4?G(8,[4],[]):N(),!0}function Z(){switch(t.getToken()){case 3:return H();case 1:return X();case 10:return J(!0);default:return j()}}return N(),t.getToken()===17?i.allowEmptyContent?!0:(G(4,[],[]),!1):Z()?(t.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.visit=y;function S(r,c){let i=A(r),t=[],o,s=0,a;do switch(a=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:s!==a&&t.push(r.substring(s,a)),c!==void 0&&t.push(i.getTokenValue().replace(/[^\r\n]/g,c)),s=i.getPosition();break}while(o!==17);return t.join("")}e.stripComments=S;function l(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(ne[49],ie([0,1,35]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(E,I,C){let f,p,u,m,d;if(I){for(m=I.offset,d=m+I.length,u=m;u>0&&!b(E,u-1);)u--;let a=d;for(;a<E.length&&!b(E,a);)a++;p=E.substring(u,a),f=A(p,C)}else p=E,f=0,u=0,m=0,d=E.length;const g=R(C,E);let w=!1,y=0,S;C.insertSpaces?S=T(" ",C.tabSize||4):S="	";const l=(0,D.createScanner)(p,!1);let r=!1;function c(){return g+T(S,f+y)}function i(){let a=l.scan();for(w=!1;a===15||a===14;)w=w||a===14,a=l.scan();return r=a===16||l.getTokenError()!==0,a}const t=[];function o(a,h,v){!r&&h<d&&v>m&&E.substring(h,v)!==a&&t.push({offset:h,length:v-h,content:a})}let s=i();if(s!==17){const a=l.getTokenOffset()+u,h=T(S,f);o(h,u,a)}for(;s!==17;){let a=l.getTokenOffset()+l.getTokenLength()+u,h=i(),v="";for(;!w&&(h===12||h===13);){const _=l.getTokenOffset()+u;o(" ",a,_),a=l.getTokenOffset()+l.getTokenLength()+u,v=h===12?c():"",h=i()}if(h===2)s!==1&&(y--,v=c());else if(h===4)s!==3&&(y--,v=c());else{switch(s){case 3:case 1:y++,v=c();break;case 5:case 12:v=c();break;case 13:w?v=c():v=" ";break;case 6:v=" ";break;case 10:if(h===6){v="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?v=" ":h!==5&&h!==17&&(r=!0);break;case 16:r=!0;break}w&&(h===12||h===13)&&(v=c())}const P=l.getTokenOffset()+u;o(v,a,P),s=h}return t}e.format=n;function L(E,I){const C=JSON.stringify(E,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?C.replace(/\r\n|\r|\n/g,I.eol):C}e.toFormattedString=L;function T(E,I){let C="";for(let f=0;f<I;f++)C+=E;return C}function A(E,I){let C=0,f=0;const p=I.tabSize||4;for(;C<E.length;){const u=E.charAt(C);if(u===" ")f++;else if(u==="	")f+=p;else break;C++}return Math.floor(f/p)}function R(E,I){for(let C=0;C<I.length;C++){const f=I.charAt(C);if(f==="\r")return C+1<I.length&&I.charAt(C+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=R;function b(E,I){return`\r
`.indexOf(E.charAt(I))!==-1}e.isEOL=b}),define(ne[69],ie([0,1,35,49]),function(K,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(E,I,C){return T(E,I,void 0,C)}e.removeProperty=L;function T(E,I,C,f,p){const u=I.slice(),m=[],d=(0,D.parseTree)(E,m);let g,w;for(;u.length>0&&(w=u.pop(),g=(0,D.findNodeAtLocation)(d,u),g===void 0&&C!==void 0);)typeof w=="string"?C={[w]:C}:C=[C];if(g)if(g.type==="object"&&typeof w=="string"&&Array.isArray(g.children)){const y=(0,D.findNodeAtLocation)(g,[w]);if(y!==void 0)if(C===void 0){if(!y.parent)throw new Error("Malformed AST");const S=g.children.indexOf(y.parent);let l,r=y.parent.offset+y.parent.length;if(S>0){const c=g.children[S-1];l=c.offset+c.length}else l=g.offset+1,g.children.length>1&&(r=g.children[1].offset);return A(E,{offset:l,length:r-l,content:""},f)}else return A(E,{offset:y.offset,length:y.length,content:JSON.stringify(C)},f);else{if(C===void 0)return[];const S=`${JSON.stringify(w)}: ${JSON.stringify(C)}`,l=p?p(g.children.map(c=>c.children[0].value)):g.children.length;let r;if(l>0){const c=g.children[l-1];r={offset:c.offset+c.length,length:0,content:","+S}}else g.children.length===0?r={offset:g.offset+1,length:0,content:S}:r={offset:g.offset+1,length:0,content:S+","};return A(E,r,f)}}else if(g.type==="array"&&typeof w=="number"&&Array.isArray(g.children))if(C!==void 0){const y=`${JSON.stringify(C)}`;let S;if(g.children.length===0||w===0)S={offset:g.offset+1,length:0,content:g.children.length===0?y:y+","};else{const l=w===-1||w>g.children.length?g.children.length:w,r=g.children[l-1];S={offset:r.offset+r.length,length:0,content:","+y}}return A(E,S,f)}else{const y=w,S=g.children[y];let l;if(g.children.length===1)l={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===y){const r=g.children[y-1],c=r.offset+r.length,i=g.offset+g.length;l={offset:c,length:i-2-c,content:""}}else l={offset:S.offset,length:g.children[y+1].offset-S.offset,content:""};return A(E,l,f)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${g.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return A(E,{offset:d?d.offset:0,length:d?d.length:0,content:JSON.stringify(C)},f)}}e.setProperty=T;function A(E,I,C){let f=R(E,I),p=I.offset,u=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;p>0&&!(0,n.isEOL)(f,p-1);)p--;for(;u<f.length&&!(0,n.isEOL)(f,u);)u++}const m=(0,n.format)(f,{offset:p,length:u-p},C);for(let g=m.length-1;g>=0;g--){const w=m[g];f=R(f,w),p=Math.min(p,w.offset),u=Math.max(u,w.offset+w.length),u+=w.content.length-w.length}const d=E.length-(f.length-u)-p;return[{offset:p,length:d,content:f.substring(p,u)}]}e.withFormatting=A;function R(E,I){return E.substring(0,I.offset)+I.content+E.substring(I.offset+I.length)}e.applyEdit=R;function b(E,I){let C=I.slice(0).sort((p,u)=>{const m=p.offset-u.offset;return m===0?p.length-u.length:m}),f=E.length;for(let p=C.length-1;p>=0;p--){let u=C[p];if(u.offset+u.length<=f)E=R(E,u);else throw new Error("Overlapping edit");f=u.offset}return E}e.applyEdits=b}),define(ne[100],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(L){this.executor=L,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(L){this._error=L}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(L){return new D(()=>L(this.getValue()))}}e.Lazy=D}),define(ne[2],ie([0,1,68,55]),function(K,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const L=!1;let T=null;function A(t){T=t}if(e.setDisposableTracker=A,L){const t="__is_disposable_tracked__";A(new class{trackDisposable(o){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[t]||console.log(s)},3e3)}setParent(o,s){if(o&&o!==w.None)try{o[t]=!0}catch{}}markAsDisposed(o){if(o&&o!==w.None)try{o[t]=!0}catch{}}markAsSingleton(o){}})}function R(t){return T?.trackDisposable(t),t}function b(t){T?.markAsDisposed(t)}function E(t,o){T?.setParent(t,o)}function I(t,o){if(!!T)for(const s of t)T.setParent(s,o)}function C(t){return T?.markAsSingleton(t),t}e.markAsSingleton=C;class f extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=f;function p(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=p;function u(t){if(n.Iterable.is(t)){let o=[];for(const s of t)if(s)try{s.dispose()}catch(a){o.push(a)}if(o.length===1)throw o[0];if(o.length>1)throw new f(o);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=u;function m(...t){const o=d(()=>u(t));return I(t,o),o}e.combinedDisposable=m;function d(t){const o=R({dispose:(0,D.once)(()=>{b(o),t()})});return o}e.toDisposable=d;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1,R(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return E(o,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new g,R(this),E(this._store,this)}dispose(){b(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class y{constructor(){this._isDisposed=!1,R(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&E(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&E(o,null),o}}e.MutableDisposable=y;class S{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=S;class l{constructor(){this.references=new Map}acquire(o,...s){let a=this.references.get(o);a||(a={counter:0,object:this.createReferencedObject(o,...s)},this.references.set(o,a));const{object:h}=a,v=(0,D.once)(()=>{--a.counter==0&&(this.destroyReferencedObject(o,a.object),this.references.delete(o))});return a.counter++,{object:h,dispose:v}}}e.ReferenceCollection=l;class r{constructor(o){this.referenceCollection=o}async acquire(o,...s){const a=this.referenceCollection.acquire(o,...s);try{return{object:await a.object,dispose:()=>a.dispose()}}catch(h){throw a.dispose(),h}}}e.AsyncReferenceCollection=r;class c{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=c;function i(t){const o=new g;try{t(o)}finally{o.dispose()}}e.disposeOnReturn=i}),define(ne[101],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(T){this.element=T,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class n{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let T=this._first;for(;T!==D.Undefined;){const A=T.next;T.prev=D.Undefined,T.next=D.Undefined,T=A}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,A){const R=new D(T);if(this._first===D.Undefined)this._first=R,this._last=R;else if(A){const E=this._last;this._last=R,R.prev=E,E.next=R}else{const E=this._first;this._first=R,R.next=E,E.prev=R}this._size+=1;let b=!1;return()=>{b||(b=!0,this._remove(R))}}shift(){if(this._first!==D.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==D.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==D.Undefined&&T.next!==D.Undefined){const A=T.prev;A.next=T.next,T.next.prev=A}else T.prev===D.Undefined&&T.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):T.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):T.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==D.Undefined;)yield T.element,T=T.next}}e.LinkedList=n}),function(){function K(L){const T=[];typeof L=="number"&&T.push("code/timeOrigin",L);function A(b){T.push(b,Date.now())}function R(){const b=[];for(let E=0;E<T.length;E+=2)b.push({name:T[E],startTime:T[E+1]});return b}return{mark:A,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(L+A.startTime)});return T}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function D(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=D(n))}(),define(ne[4],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const D="en";let n=!1,L=!1,T=!1,A=!1,R=!1,b=!1,E=!1,I=!1,C,f=D,p,u;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?m=e.globals.vscode.process:typeof process!="undefined"&&(m=process);const d=typeof m?.versions?.electron=="string",g=d&&m?.type==="renderer";if(e.isElectronSandboxed=g&&m?.sandboxed,typeof navigator=="object"&&!g)u=navigator.userAgent,n=u.indexOf("Windows")>=0,L=u.indexOf("Macintosh")>=0,I=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=u.indexOf("Linux")>=0,b=!0,C=navigator.language,f=C;else if(typeof m=="object"){n=m.platform==="win32",L=m.platform==="darwin",T=m.platform==="linux",A=T&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,E=d,C=D,f=D;const o=m.env.VSCODE_NLS_CONFIG;if(o)try{const s=JSON.parse(o),a=s.availableLanguages["*"];C=s.locale,f=a||D,p=s._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var w;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function y(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=y;let S=0;L?S=1:n?S=3:T&&(S=2),e.isWindows=n,e.isMacintosh=L,e.isLinux=T,e.isLinuxSnap=A,e.isNative=R,e.isElectron=E,e.isWeb=b,e.isIOS=I,e.platform=S,e.userAgent=u,e.language=f;var l;(function(o){function s(){return e.language}o.value=s;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=a;function h(){return e.language==="en"}o.isDefault=h})(l=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=p,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",a=>{if(a.data&&a.data.vscodeScheduleAsyncWork)for(let h=0,v=o.length;h<v;h++){const P=o[h];if(P.id===a.data.vscodeScheduleAsyncWork){o.splice(h,1),P.callback();return}}});let s=0;return a=>{const h=++s;o.push({id:h,callback:a}),e.globals.postMessage({vscodeScheduleAsyncWork:h},"*")}}return o=>setTimeout(o)})();var r;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||I?2:n?1:3;let c=!0,i=!1;function t(){if(!i){i=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,c=new Uint16Array(o.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=t,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ne[32],ie([0,1,4]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const L=D.globals.vscode.process;n={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(ne[10],ie([0,1,32]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,L=97,T=90,A=122,R=46,b=47,E=92,I=58,C=63;class f extends Error{constructor(S,l,r){let c;typeof l=="string"&&l.indexOf("not ")===0?(c="must not be",l=l.replace(/^not /,"")):c="must be";const i=S.indexOf(".")!==-1?"property":"argument";let t=`The "${S}" ${i} ${c} of type ${l}`;t+=`. Received type ${typeof r}`;super(t);this.code="ERR_INVALID_ARG_TYPE"}}function p(y,S){if(typeof y!="string")throw new f(S,"string",y)}function u(y){return y===b||y===E}function m(y){return y===b}function d(y){return y>=n&&y<=T||y>=L&&y<=A}function g(y,S,l,r){let c="",i=0,t=-1,o=0,s=0;for(let a=0;a<=y.length;++a){if(a<y.length)s=y.charCodeAt(a);else{if(r(s))break;s=b}if(r(s)){if(!(t===a-1||o===1))if(o===2){if(c.length<2||i!==2||c.charCodeAt(c.length-1)!==R||c.charCodeAt(c.length-2)!==R){if(c.length>2){const h=c.lastIndexOf(l);h===-1?(c="",i=0):(c=c.slice(0,h),i=c.length-1-c.lastIndexOf(l)),t=a,o=0;continue}else if(c.length!==0){c="",i=0,t=a,o=0;continue}}S&&(c+=c.length>0?`${l}..`:"..",i=2)}else c.length>0?c+=`${l}${y.slice(t+1,a)}`:c=y.slice(t+1,a),i=a-t-1;t=a,o=0}else s===R&&o!==-1?++o:o=-1}return c}function w(y,S){if(S===null||typeof S!="object")throw new f("pathObject","Object",S);const l=S.dir||S.root,r=S.base||`${S.name||""}${S.ext||""}`;return l?l===S.root?`${l}${r}`:`${l}${y}${r}`:r}e.win32={resolve(...y){let S="",l="",r=!1;for(let c=y.length-1;c>=-1;c--){let i;if(c>=0){if(i=y[c],p(i,"path"),i.length===0)continue}else S.length===0?i=D.cwd():(i=D.env[`=${S}`]||D.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==S.toLowerCase()&&i.charCodeAt(2)===E)&&(i=`${S}\\`));const t=i.length;let o=0,s="",a=!1;const h=i.charCodeAt(0);if(t===1)u(h)&&(o=1,a=!0);else if(u(h))if(a=!0,u(i.charCodeAt(1))){let v=2,P=v;for(;v<t&&!u(i.charCodeAt(v));)v++;if(v<t&&v!==P){const _=i.slice(P,v);for(P=v;v<t&&u(i.charCodeAt(v));)v++;if(v<t&&v!==P){for(P=v;v<t&&!u(i.charCodeAt(v));)v++;(v===t||v!==P)&&(s=`\\\\${_}\\${i.slice(P,v)}`,o=v)}}}else o=1;else d(h)&&i.charCodeAt(1)===I&&(s=i.slice(0,2),o=2,t>2&&u(i.charCodeAt(2))&&(a=!0,o=3));if(s.length>0)if(S.length>0){if(s.toLowerCase()!==S.toLowerCase())continue}else S=s;if(r){if(S.length>0)break}else if(l=`${i.slice(o)}\\${l}`,r=a,a&&S.length>0)break}return l=g(l,!r,"\\",u),r?`${S}\\${l}`:`${S}${l}`||"."},normalize(y){p(y,"path");const S=y.length;if(S===0)return".";let l=0,r,c=!1;const i=y.charCodeAt(0);if(S===1)return m(i)?"\\":y;if(u(i))if(c=!0,u(y.charCodeAt(1))){let o=2,s=o;for(;o<S&&!u(y.charCodeAt(o));)o++;if(o<S&&o!==s){const a=y.slice(s,o);for(s=o;o<S&&u(y.charCodeAt(o));)o++;if(o<S&&o!==s){for(s=o;o<S&&!u(y.charCodeAt(o));)o++;if(o===S)return`\\\\${a}\\${y.slice(s)}\\`;o!==s&&(r=`\\\\${a}\\${y.slice(s,o)}`,l=o)}}}else l=1;else d(i)&&y.charCodeAt(1)===I&&(r=y.slice(0,2),l=2,S>2&&u(y.charCodeAt(2))&&(c=!0,l=3));let t=l<S?g(y.slice(l),!c,"\\",u):"";return t.length===0&&!c&&(t="."),t.length>0&&u(y.charCodeAt(S-1))&&(t+="\\"),r===void 0?c?`\\${t}`:t:c?`${r}\\${t}`:`${r}${t}`},isAbsolute(y){p(y,"path");const S=y.length;if(S===0)return!1;const l=y.charCodeAt(0);return u(l)||S>2&&d(l)&&y.charCodeAt(1)===I&&u(y.charCodeAt(2))},join(...y){if(y.length===0)return".";let S,l;for(let i=0;i<y.length;++i){const t=y[i];p(t,"path"),t.length>0&&(S===void 0?S=l=t:S+=`\\${t}`)}if(S===void 0)return".";let r=!0,c=0;if(typeof l=="string"&&u(l.charCodeAt(0))){++c;const i=l.length;i>1&&u(l.charCodeAt(1))&&(++c,i>2&&(u(l.charCodeAt(2))?++c:r=!1))}if(r){for(;c<S.length&&u(S.charCodeAt(c));)c++;c>=2&&(S=`\\${S.slice(c)}`)}return e.win32.normalize(S)},relative(y,S){if(p(y,"from"),p(S,"to"),y===S)return"";const l=e.win32.resolve(y),r=e.win32.resolve(S);if(l===r||(y=l.toLowerCase(),S=r.toLowerCase(),y===S))return"";let c=0;for(;c<y.length&&y.charCodeAt(c)===E;)c++;let i=y.length;for(;i-1>c&&y.charCodeAt(i-1)===E;)i--;const t=i-c;let o=0;for(;o<S.length&&S.charCodeAt(o)===E;)o++;let s=S.length;for(;s-1>o&&S.charCodeAt(s-1)===E;)s--;const a=s-o,h=t<a?t:a;let v=-1,P=0;for(;P<h;P++){const O=y.charCodeAt(c+P);if(O!==S.charCodeAt(o+P))break;O===E&&(v=P)}if(P!==h){if(v===-1)return r}else{if(a>h){if(S.charCodeAt(o+P)===E)return r.slice(o+P+1);if(P===2)return r.slice(o+P)}t>h&&(y.charCodeAt(c+P)===E?v=P:P===2&&(v=3)),v===-1&&(v=0)}let _="";for(P=c+v+1;P<=i;++P)(P===i||y.charCodeAt(P)===E)&&(_+=_.length===0?"..":"\\..");return o+=v,_.length>0?`${_}${r.slice(o,s)}`:(r.charCodeAt(o)===E&&++o,r.slice(o,s))},toNamespacedPath(y){if(typeof y!="string")return y;if(y.length===0)return"";const S=e.win32.resolve(y);if(S.length<=2)return y;if(S.charCodeAt(0)===E){if(S.charCodeAt(1)===E){const l=S.charCodeAt(2);if(l!==C&&l!==R)return`\\\\?\\UNC\\${S.slice(2)}`}}else if(d(S.charCodeAt(0))&&S.charCodeAt(1)===I&&S.charCodeAt(2)===E)return`\\\\?\\${S}`;return y},dirname(y){p(y,"path");const S=y.length;if(S===0)return".";let l=-1,r=0;const c=y.charCodeAt(0);if(S===1)return u(c)?y:".";if(u(c)){if(l=r=1,u(y.charCodeAt(1))){let o=2,s=o;for(;o<S&&!u(y.charCodeAt(o));)o++;if(o<S&&o!==s){for(s=o;o<S&&u(y.charCodeAt(o));)o++;if(o<S&&o!==s){for(s=o;o<S&&!u(y.charCodeAt(o));)o++;if(o===S)return y;o!==s&&(l=r=o+1)}}}}else d(c)&&y.charCodeAt(1)===I&&(l=S>2&&u(y.charCodeAt(2))?3:2,r=l);let i=-1,t=!0;for(let o=S-1;o>=r;--o)if(u(y.charCodeAt(o))){if(!t){i=o;break}}else t=!1;if(i===-1){if(l===-1)return".";i=l}return y.slice(0,i)},basename(y,S){S!==void 0&&p(S,"ext"),p(y,"path");let l=0,r=-1,c=!0,i;if(y.length>=2&&d(y.charCodeAt(0))&&y.charCodeAt(1)===I&&(l=2),S!==void 0&&S.length>0&&S.length<=y.length){if(S===y)return"";let t=S.length-1,o=-1;for(i=y.length-1;i>=l;--i){const s=y.charCodeAt(i);if(u(s)){if(!c){l=i+1;break}}else o===-1&&(c=!1,o=i+1),t>=0&&(s===S.charCodeAt(t)?--t==-1&&(r=i):(t=-1,r=o))}return l===r?r=o:r===-1&&(r=y.length),y.slice(l,r)}for(i=y.length-1;i>=l;--i)if(u(y.charCodeAt(i))){if(!c){l=i+1;break}}else r===-1&&(c=!1,r=i+1);return r===-1?"":y.slice(l,r)},extname(y){p(y,"path");let S=0,l=-1,r=0,c=-1,i=!0,t=0;y.length>=2&&y.charCodeAt(1)===I&&d(y.charCodeAt(0))&&(S=r=2);for(let o=y.length-1;o>=S;--o){const s=y.charCodeAt(o);if(u(s)){if(!i){r=o+1;break}continue}c===-1&&(i=!1,c=o+1),s===R?l===-1?l=o:t!==1&&(t=1):l!==-1&&(t=-1)}return l===-1||c===-1||t===0||t===1&&l===c-1&&l===r+1?"":y.slice(l,c)},format:w.bind(null,"\\"),parse(y){p(y,"path");const S={root:"",dir:"",base:"",ext:"",name:""};if(y.length===0)return S;const l=y.length;let r=0,c=y.charCodeAt(0);if(l===1)return u(c)?(S.root=S.dir=y,S):(S.base=S.name=y,S);if(u(c)){if(r=1,u(y.charCodeAt(1))){let v=2,P=v;for(;v<l&&!u(y.charCodeAt(v));)v++;if(v<l&&v!==P){for(P=v;v<l&&u(y.charCodeAt(v));)v++;if(v<l&&v!==P){for(P=v;v<l&&!u(y.charCodeAt(v));)v++;v===l?r=v:v!==P&&(r=v+1)}}}}else if(d(c)&&y.charCodeAt(1)===I){if(l<=2)return S.root=S.dir=y,S;if(r=2,u(y.charCodeAt(2))){if(l===3)return S.root=S.dir=y,S;r=3}}r>0&&(S.root=y.slice(0,r));let i=-1,t=r,o=-1,s=!0,a=y.length-1,h=0;for(;a>=r;--a){if(c=y.charCodeAt(a),u(c)){if(!s){t=a+1;break}continue}o===-1&&(s=!1,o=a+1),c===R?i===-1?i=a:h!==1&&(h=1):i!==-1&&(h=-1)}return o!==-1&&(i===-1||h===0||h===1&&i===o-1&&i===t+1?S.base=S.name=y.slice(t,o):(S.name=y.slice(t,i),S.base=y.slice(t,o),S.ext=y.slice(i,o))),t>0&&t!==r?S.dir=y.slice(0,t-1):S.dir=S.root,S},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...y){let S="",l=!1;for(let r=y.length-1;r>=-1&&!l;r--){const c=r>=0?y[r]:D.cwd();p(c,"path"),c.length!==0&&(S=`${c}/${S}`,l=c.charCodeAt(0)===b)}return S=g(S,!l,"/",m),l?`/${S}`:S.length>0?S:"."},normalize(y){if(p(y,"path"),y.length===0)return".";const S=y.charCodeAt(0)===b,l=y.charCodeAt(y.length-1)===b;return y=g(y,!S,"/",m),y.length===0?S?"/":l?"./":".":(l&&(y+="/"),S?`/${y}`:y)},isAbsolute(y){return p(y,"path"),y.length>0&&y.charCodeAt(0)===b},join(...y){if(y.length===0)return".";let S;for(let l=0;l<y.length;++l){const r=y[l];p(r,"path"),r.length>0&&(S===void 0?S=r:S+=`/${r}`)}return S===void 0?".":e.posix.normalize(S)},relative(y,S){if(p(y,"from"),p(S,"to"),y===S||(y=e.posix.resolve(y),S=e.posix.resolve(S),y===S))return"";const l=1,r=y.length,c=r-l,i=1,t=S.length-i,o=c<t?c:t;let s=-1,a=0;for(;a<o;a++){const v=y.charCodeAt(l+a);if(v!==S.charCodeAt(i+a))break;v===b&&(s=a)}if(a===o)if(t>o){if(S.charCodeAt(i+a)===b)return S.slice(i+a+1);if(a===0)return S.slice(i+a)}else c>o&&(y.charCodeAt(l+a)===b?s=a:a===0&&(s=0));let h="";for(a=l+s+1;a<=r;++a)(a===r||y.charCodeAt(a)===b)&&(h+=h.length===0?"..":"/..");return`${h}${S.slice(i+s)}`},toNamespacedPath(y){return y},dirname(y){if(p(y,"path"),y.length===0)return".";const S=y.charCodeAt(0)===b;let l=-1,r=!0;for(let c=y.length-1;c>=1;--c)if(y.charCodeAt(c)===b){if(!r){l=c;break}}else r=!1;return l===-1?S?"/":".":S&&l===1?"//":y.slice(0,l)},basename(y,S){S!==void 0&&p(S,"ext"),p(y,"path");let l=0,r=-1,c=!0,i;if(S!==void 0&&S.length>0&&S.length<=y.length){if(S===y)return"";let t=S.length-1,o=-1;for(i=y.length-1;i>=0;--i){const s=y.charCodeAt(i);if(s===b){if(!c){l=i+1;break}}else o===-1&&(c=!1,o=i+1),t>=0&&(s===S.charCodeAt(t)?--t==-1&&(r=i):(t=-1,r=o))}return l===r?r=o:r===-1&&(r=y.length),y.slice(l,r)}for(i=y.length-1;i>=0;--i)if(y.charCodeAt(i)===b){if(!c){l=i+1;break}}else r===-1&&(c=!1,r=i+1);return r===-1?"":y.slice(l,r)},extname(y){p(y,"path");let S=-1,l=0,r=-1,c=!0,i=0;for(let t=y.length-1;t>=0;--t){const o=y.charCodeAt(t);if(o===b){if(!c){l=t+1;break}continue}r===-1&&(c=!1,r=t+1),o===R?S===-1?S=t:i!==1&&(i=1):S!==-1&&(i=-1)}return S===-1||r===-1||i===0||i===1&&S===r-1&&S===l+1?"":y.slice(S,r)},format:w.bind(null,"/"),parse(y){p(y,"path");const S={root:"",dir:"",base:"",ext:"",name:""};if(y.length===0)return S;const l=y.charCodeAt(0)===b;let r;l?(S.root="/",r=1):r=0;let c=-1,i=0,t=-1,o=!0,s=y.length-1,a=0;for(;s>=r;--s){const h=y.charCodeAt(s);if(h===b){if(!o){i=s+1;break}continue}t===-1&&(o=!1,t=s+1),h===R?c===-1?c=s:a!==1&&(a=1):c!==-1&&(a=-1)}if(t!==-1){const h=i===0&&l?1:i;c===-1||a===0||a===1&&c===t-1&&c===i+1?S.base=S.name=y.slice(h,t):(S.name=y.slice(h,c),S.base=y.slice(h,t),S.ext=y.slice(c,t))}return i>0?S.dir=y.slice(0,i-1):l&&(S.dir="/"),S},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ne[102],ie([0,1,10]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var n;(function(C){C.text="text/plain",C.binary="application/octet-stream",C.unknown="application/unknown",C.markdown="text/markdown",C.latex="text/latex"})(n=e.Mimes||(e.Mimes={}));const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(C){const f=(0,D.extname)(C),p=L[f.toLowerCase()];return p!==void 0?p:R(C)}e.getMediaOrTextMime=A;function R(C){const f=(0,D.extname)(C);return T[f.toLowerCase()]}e.getMediaMime=R;function b(C){for(const f in T)if(T[f]===C)return f}e.getExtensionForMimeType=b;const E=/^(.+)\/(.+?)(;.+)?$/;function I(C,f){const p=E.exec(C);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:f?void 0:C}e.normalizeMimeType=I}),define(ne[103],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var D;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(D=e.Source||(e.Source={}));var n;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(T,...A){const R=A.reduce((I,C)=>(I[C]=!0,I),{}),b=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(I=>!R[I]).forEach(I=>{for(let C=0;C<b.length;C++)if(I.search(b[C])!==-1){delete T[I];break}})}e.sanitizeProcessEnvironment=L}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var n in D)(typeof exports=="object"?exports:K)[n]=D[n]}}(typeof self!="undefined"?self:this,function(){return function(K){var e={};function D(n){if(e[n])return e[n].exports;var L=e[n]={i:n,l:!1,exports:{}};return K[n].call(L.exports,L,L.exports,D),L.l=!0,L.exports}return D.m=K,D.c=e,D.d=function(n,L,T){D.o(n,L)||Object.defineProperty(n,L,{enumerable:!0,get:T})},D.r=function(n){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},D.t=function(n,L){if(1&L&&(n=D(n)),8&L||4&L&&typeof n=="object"&&n&&n.__esModule)return n;var T=Object.create(null);if(D.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:n}),2&L&&typeof n!="string")for(var A in n)D.d(T,A,function(R){return n[R]}.bind(null,A));return T},D.n=function(n){var L=n&&n.__esModule?function(){return n.default}:function(){return n};return D.d(L,"a",L),L},D.o=function(n,L){return Object.prototype.hasOwnProperty.call(n,L)},D.p="",D(D.s=0)}([function(K,e,D){(function(n){var L;e=K.exports=$,L=typeof n=="object"&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var re=Array.prototype.slice.call(arguments,0);re.unshift("SEMVER"),console.log.apply(console,re)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],b=e.src=[],E=0,I=E++;b[I]="0|[1-9]\\d*";var C=E++;b[C]="[0-9]+";var f=E++;b[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=E++;b[p]="("+b[I]+")\\.("+b[I]+")\\.("+b[I]+")";var u=E++;b[u]="("+b[C]+")\\.("+b[C]+")\\.("+b[C]+")";var m=E++;b[m]="(?:"+b[I]+"|"+b[f]+")";var d=E++;b[d]="(?:"+b[C]+"|"+b[f]+")";var g=E++;b[g]="(?:-("+b[m]+"(?:\\."+b[m]+")*))";var w=E++;b[w]="(?:-?("+b[d]+"(?:\\."+b[d]+")*))";var y=E++;b[y]="[0-9A-Za-z-]+";var S=E++;b[S]="(?:\\+("+b[y]+"(?:\\."+b[y]+")*))";var l=E++,r="v?"+b[p]+b[g]+"?"+b[S]+"?";b[l]="^"+r+"$";var c="[v=\\s]*"+b[u]+b[w]+"?"+b[S]+"?",i=E++;b[i]="^"+c+"$";var t=E++;b[t]="((?:<|>)?=?)";var o=E++;b[o]=b[C]+"|x|X|\\*";var s=E++;b[s]=b[I]+"|x|X|\\*";var a=E++;b[a]="[v=\\s]*("+b[s]+")(?:\\.("+b[s]+")(?:\\.("+b[s]+")(?:"+b[g]+")?"+b[S]+"?)?)?";var h=E++;b[h]="[v=\\s]*("+b[o]+")(?:\\.("+b[o]+")(?:\\.("+b[o]+")(?:"+b[w]+")?"+b[S]+"?)?)?";var v=E++;b[v]="^"+b[t]+"\\s*"+b[a]+"$";var P=E++;b[P]="^"+b[t]+"\\s*"+b[h]+"$";var _=E++;b[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=E++;b[O]="(?:~>?)";var U=E++;b[U]="(\\s*)"+b[O]+"\\s+",R[U]=new RegExp(b[U],"g");var k=E++;b[k]="^"+b[O]+b[a]+"$";var M=E++;b[M]="^"+b[O]+b[h]+"$";var F=E++;b[F]="(?:\\^)";var V=E++;b[V]="(\\s*)"+b[F]+"\\s+",R[V]=new RegExp(b[V],"g");var N=E++;b[N]="^"+b[F]+b[a]+"$";var G=E++;b[G]="^"+b[F]+b[h]+"$";var J=E++;b[J]="^"+b[t]+"\\s*("+c+")$|^$";var j=E++;b[j]="^"+b[t]+"\\s*("+r+")$|^$";var q=E++;b[q]="(\\s*)"+b[t]+"\\s*("+c+"|"+b[a]+")",R[q]=new RegExp(b[q],"g");var X=E++;b[X]="^\\s*("+b[a]+")\\s+-\\s+("+b[a]+")\\s*$";var H=E++;b[H]="^\\s*("+b[h]+")\\s+-\\s+("+b[h]+")\\s*$";var Z=E++;b[Z]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)L(ee,b[ee]),R[ee]||(R[ee]=new RegExp(b[ee]));function W(re,ae){if(re instanceof $)return re;if(typeof re!="string"||re.length>T||!(ae?R[i]:R[l]).test(re))return null;try{return new $(re,ae)}catch{return null}}function $(re,ae){if(re instanceof $){if(re.loose===ae)return re;re=re.version}else if(typeof re!="string")throw new TypeError("Invalid Version: "+re);if(re.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof $))return new $(re,ae);L("SemVer",re,ae),this.loose=ae;var ue=re.trim().match(ae?R[i]:R[l]);if(!ue)throw new TypeError("Invalid Version: "+re);if(this.raw=re,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(we){if(/^[0-9]+$/.test(we)){var Ce=+we;if(Ce>=0&&Ce<A)return Ce}return we}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=W,e.valid=function(re,ae){var ue=W(re,ae);return ue?ue.version:null},e.clean=function(re,ae){var ue=W(re.trim().replace(/^[=v]+/,""),ae);return ue?ue.version:null},e.SemVer=$,$.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},$.prototype.toString=function(){return this.version},$.prototype.compare=function(re){return L("SemVer.compare",this.version,this.loose,re),re instanceof $||(re=new $(re,this.loose)),this.compareMain(re)||this.comparePre(re)},$.prototype.compareMain=function(re){return re instanceof $||(re=new $(re,this.loose)),z(this.major,re.major)||z(this.minor,re.minor)||z(this.patch,re.patch)},$.prototype.comparePre=function(re){if(re instanceof $||(re=new $(re,this.loose)),this.prerelease.length&&!re.prerelease.length)return-1;if(!this.prerelease.length&&re.prerelease.length)return 1;if(!this.prerelease.length&&!re.prerelease.length)return 0;var ae=0;do{var ue=this.prerelease[ae],we=re.prerelease[ae];if(L("prerelease compare",ae,ue,we),ue===void 0&&we===void 0)return 0;if(we===void 0)return 1;if(ue===void 0)return-1;if(ue!==we)return z(ue,we)}while(++ae)},$.prototype.inc=function(re,ae){switch(re){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+re)}return this.format(),this.raw=this.version,this},e.inc=function(re,ae,ue,we){typeof ue=="string"&&(we=ue,ue=void 0);try{return new $(re,ue).inc(ae,we).version}catch{return null}},e.diff=function(re,ae){if(ce(re,ae))return null;var ue=W(re),we=W(ae);if(ue.prerelease.length||we.prerelease.length){for(var Ce in ue)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&ue[Ce]!==we[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in ue)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&ue[Ce]!==we[Ce])return Ce},e.compareIdentifiers=z;var x=/^[0-9]+$/;function z(re,ae){var ue=x.test(re),we=x.test(ae);return ue&&we&&(re=+re,ae=+ae),ue&&!we?-1:we&&!ue?1:re<ae?-1:re>ae?1:0}function B(re,ae,ue){return new $(re,ue).compare(new $(ae,ue))}function te(re,ae,ue){return B(re,ae,ue)>0}function se(re,ae,ue){return B(re,ae,ue)<0}function ce(re,ae,ue){return B(re,ae,ue)===0}function he(re,ae,ue){return B(re,ae,ue)!==0}function ve(re,ae,ue){return B(re,ae,ue)>=0}function pe(re,ae,ue){return B(re,ae,ue)<=0}function Ie(re,ae,ue,we){var Ce;switch(ae){case"===":typeof re=="object"&&(re=re.version),typeof ue=="object"&&(ue=ue.version),Ce=re===ue;break;case"!==":typeof re=="object"&&(re=re.version),typeof ue=="object"&&(ue=ue.version),Ce=re!==ue;break;case"":case"=":case"==":Ce=ce(re,ue,we);break;case"!=":Ce=he(re,ue,we);break;case">":Ce=te(re,ue,we);break;case">=":Ce=ve(re,ue,we);break;case"<":Ce=se(re,ue,we);break;case"<=":Ce=pe(re,ue,we);break;default:throw new TypeError("Invalid operator: "+ae)}return Ce}function Ee(re,ae){if(re instanceof Ee){if(re.loose===ae)return re;re=re.value}if(!(this instanceof Ee))return new Ee(re,ae);L("comparator",re,ae),this.loose=ae,this.parse(re),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(re,ae){return z(ae,re)},e.major=function(re,ae){return new $(re,ae).major},e.minor=function(re,ae){return new $(re,ae).minor},e.patch=function(re,ae){return new $(re,ae).patch},e.compare=B,e.compareLoose=function(re,ae){return B(re,ae,!0)},e.rcompare=function(re,ae,ue){return B(ae,re,ue)},e.sort=function(re,ae){return re.sort(function(ue,we){return e.compare(ue,we,ae)})},e.rsort=function(re,ae){return re.sort(function(ue,we){return e.rcompare(ue,we,ae)})},e.gt=te,e.lt=se,e.eq=ce,e.neq=he,e.gte=ve,e.lte=pe,e.cmp=Ie,e.Comparator=Ee;var ye={};function be(re,ae){if(re instanceof be)return re.loose===ae?re:new be(re.raw,ae);if(re instanceof Ee)return new be(re.value,ae);if(!(this instanceof be))return new be(re,ae);if(this.loose=ae,this.raw=re,this.set=re.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+re);this.format()}function Re(re){return!re||re.toLowerCase()==="x"||re==="*"}function Ne(re,ae,ue,we,Ce,Fe,Te,Oe,_e,Q,oe,le,fe){return((ae=Re(ue)?"":Re(we)?">="+ue+".0.0":Re(Ce)?">="+ue+"."+we+".0":">="+ae)+" "+(Oe=Re(_e)?"":Re(Q)?"<"+(+_e+1)+".0.0":Re(oe)?"<"+_e+"."+(+Q+1)+".0":le?"<="+_e+"."+Q+"."+oe+"-"+le:"<="+Oe)).trim()}function Ue(re,ae){for(var ue=0;ue<re.length;ue++)if(!re[ue].test(ae))return!1;if(ae.prerelease.length){for(ue=0;ue<re.length;ue++)if(L(re[ue].semver),re[ue].semver!==ye&&re[ue].semver.prerelease.length>0){var we=re[ue].semver;if(we.major===ae.major&&we.minor===ae.minor&&we.patch===ae.patch)return!0}return!1}return!0}function qe(re,ae,ue){try{ae=new be(ae,ue)}catch{return!1}return ae.test(re)}function xe(re,ae,ue,we){var Ce,Fe,Te,Oe,_e;switch(re=new $(re,we),ae=new be(ae,we),ue){case">":Ce=te,Fe=pe,Te=se,Oe=">",_e=">=";break;case"<":Ce=se,Fe=ve,Te=te,Oe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(qe(re,ae,we))return!1;for(var Q=0;Q<ae.set.length;++Q){var oe=ae.set[Q],le=null,fe=null;if(oe.forEach(function(ge){ge.semver===ye&&(ge=new Ee(">=0.0.0")),le=le||ge,fe=fe||ge,Ce(ge.semver,le.semver,we)?le=ge:Te(ge.semver,fe.semver,we)&&(fe=ge)}),le.operator===Oe||le.operator===_e||(!fe.operator||fe.operator===Oe)&&Fe(re,fe.semver)||fe.operator===_e&&Te(re,fe.semver))return!1}return!0}Ee.prototype.parse=function(re){var ae=this.loose?R[J]:R[j],ue=re.match(ae);if(!ue)throw new TypeError("Invalid comparator: "+re);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new $(ue[2],this.loose):this.semver=ye},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(re){return L("Comparator.test",re,this.loose),this.semver===ye||(typeof re=="string"&&(re=new $(re,this.loose)),Ie(re,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(re,ae){if(!(re instanceof Ee))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new be(re.value,ae),qe(this.value,ue,ae);if(re.operator==="")return ue=new be(this.value,ae),qe(re.semver,ue,ae);var we=!(this.operator!==">="&&this.operator!==">"||re.operator!==">="&&re.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||re.operator!=="<="&&re.operator!=="<"),Fe=this.semver.version===re.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||re.operator!==">="&&re.operator!=="<="),Oe=Ie(this.semver,"<",re.semver,ae)&&(this.operator===">="||this.operator===">")&&(re.operator==="<="||re.operator==="<"),_e=Ie(this.semver,">",re.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(re.operator===">="||re.operator===">");return we||Ce||Fe&&Te||Oe||_e},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(re){return re.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(re){var ae=this.loose;re=re.trim(),L("range",re,ae);var ue=ae?R[H]:R[X];re=re.replace(ue,Ne),L("hyphen replace",re),re=re.replace(R[q],"$1$2$3"),L("comparator trim",re,R[q]),re=(re=(re=re.replace(R[U],"$1~")).replace(R[V],"$1^")).split(/\s+/).join(" ");var we=ae?R[J]:R[j],Ce=re.split(" ").map(function(Fe){return function(Te,Oe){return L("comp",Te),Te=function(_e,Q){return _e.trim().split(/\s+/).map(function(oe){return function(le,fe){L("caret",le,fe);var ge=fe?R[G]:R[N];return le.replace(ge,function(Le,Se,De,ke,Pe){var Ae;return L("caret",le,Le,Se,De,ke,Pe),Re(Se)?Ae="":Re(De)?Ae=">="+Se+".0.0 <"+(+Se+1)+".0.0":Re(ke)?Ae=Se==="0"?">="+Se+"."+De+".0 <"+Se+"."+(+De+1)+".0":">="+Se+"."+De+".0 <"+(+Se+1)+".0.0":Pe?(L("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Ae=Se==="0"?De==="0"?">="+Se+"."+De+"."+ke+Pe+" <"+Se+"."+De+"."+(+ke+1):">="+Se+"."+De+"."+ke+Pe+" <"+Se+"."+(+De+1)+".0":">="+Se+"."+De+"."+ke+Pe+" <"+(+Se+1)+".0.0"):(L("no pr"),Ae=Se==="0"?De==="0"?">="+Se+"."+De+"."+ke+" <"+Se+"."+De+"."+(+ke+1):">="+Se+"."+De+"."+ke+" <"+Se+"."+(+De+1)+".0":">="+Se+"."+De+"."+ke+" <"+(+Se+1)+".0.0"),L("caret return",Ae),Ae})}(oe,Q)}).join(" ")}(Te,Oe),L("caret",Te),Te=function(_e,Q){return _e.trim().split(/\s+/).map(function(oe){return function(le,fe){var ge=fe?R[M]:R[k];return le.replace(ge,function(Le,Se,De,ke,Pe){var Ae;return L("tilde",le,Le,Se,De,ke,Pe),Re(Se)?Ae="":Re(De)?Ae=">="+Se+".0.0 <"+(+Se+1)+".0.0":Re(ke)?Ae=">="+Se+"."+De+".0 <"+Se+"."+(+De+1)+".0":Pe?(L("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Ae=">="+Se+"."+De+"."+ke+Pe+" <"+Se+"."+(+De+1)+".0"):Ae=">="+Se+"."+De+"."+ke+" <"+Se+"."+(+De+1)+".0",L("tilde return",Ae),Ae})}(oe,Q)}).join(" ")}(Te,Oe),L("tildes",Te),Te=function(_e,Q){return L("replaceXRanges",_e,Q),_e.split(/\s+/).map(function(oe){return function(le,fe){le=le.trim();var ge=fe?R[P]:R[v];return le.replace(ge,function(Le,Se,De,ke,Pe,Ae){L("xRange",le,Le,Se,De,ke,Pe,Ae);var $e=Re(De),je=$e||Re(ke),Be=je||Re(Pe);return Se==="="&&Be&&(Se=""),$e?Le=Se===">"||Se==="<"?"<0.0.0":"*":Se&&Be?(je&&(ke=0),Be&&(Pe=0),Se===">"?(Se=">=",je?(De=+De+1,ke=0,Pe=0):Be&&(ke=+ke+1,Pe=0)):Se==="<="&&(Se="<",je?De=+De+1:ke=+ke+1),Le=Se+De+"."+ke+"."+Pe):je?Le=">="+De+".0.0 <"+(+De+1)+".0.0":Be&&(Le=">="+De+"."+ke+".0 <"+De+"."+(+ke+1)+".0"),L("xRange return",Le),Le})}(oe,Q)}).join(" ")}(Te,Oe),L("xrange",Te),Te=function(_e,Q){return L("replaceStars",_e,Q),_e.trim().replace(R[Z],"")}(Te,Oe),L("stars",Te),Te}(Fe,ae)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Fe){return!!Fe.match(we)})),Ce=Ce.map(function(Fe){return new Ee(Fe,ae)})},be.prototype.intersects=function(re,ae){if(!(re instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(we){return re.set.some(function(Ce){return Ce.every(function(Fe){return we.intersects(Fe,ae)})})})})},e.toComparators=function(re,ae){return new be(re,ae).set.map(function(ue){return ue.map(function(we){return we.value}).join(" ").trim().split(" ")})},be.prototype.test=function(re){if(!re)return!1;typeof re=="string"&&(re=new $(re,this.loose));for(var ae=0;ae<this.set.length;ae++)if(Ue(this.set[ae],re))return!0;return!1},e.satisfies=qe,e.maxSatisfying=function(re,ae,ue){var we=null,Ce=null;try{var Fe=new be(ae,ue)}catch{return null}return re.forEach(function(Te){Fe.test(Te)&&(we&&Ce.compare(Te)!==-1||(Ce=new $(we=Te,ue)))}),we},e.minSatisfying=function(re,ae,ue){var we=null,Ce=null;try{var Fe=new be(ae,ue)}catch{return null}return re.forEach(function(Te){Fe.test(Te)&&(we&&Ce.compare(Te)!==1||(Ce=new $(we=Te,ue)))}),we},e.validRange=function(re,ae){try{return new be(re,ae).range||"*"}catch{return null}},e.ltr=function(re,ae,ue){return xe(re,ae,"<",ue)},e.gtr=function(re,ae,ue){return xe(re,ae,">",ue)},e.outside=xe,e.prerelease=function(re,ae){var ue=W(re,ae);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(re,ae,ue){return re=new be(re,ue),ae=new be(ae,ue),re.intersects(ae)},e.coerce=function(re){if(re instanceof $)return re;if(typeof re!="string")return null;var ae=re.match(R[_]);return ae==null?null:W((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,D(1))},function(K,e){var D,n,L=K.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function R(d){if(D===setTimeout)return setTimeout(d,0);if((D===T||!D)&&setTimeout)return D=setTimeout,setTimeout(d,0);try{return D(d,0)}catch{try{return D.call(null,d,0)}catch{return D.call(this,d,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:T}catch{D=T}try{n=typeof clearTimeout=="function"?clearTimeout:A}catch{n=A}})();var b,E=[],I=!1,C=-1;function f(){I&&b&&(I=!1,b.length?E=b.concat(E):C=-1,E.length&&p())}function p(){if(!I){var d=R(f);I=!0;for(var g=E.length;g;){for(b=E,E=[];++C<g;)b&&b[C].run();C=-1,g=E.length}b=null,I=!1,function(w){if(n===clearTimeout)return clearTimeout(w);if((n===A||!n)&&clearTimeout)return n=clearTimeout,clearTimeout(w);try{n(w)}catch{try{return n.call(null,w)}catch{return n.call(this,w)}}}(d)}}function u(d,g){this.fun=d,this.array=g}function m(){}L.nextTick=function(d){var g=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)g[w-1]=arguments[w];E.push(new u(d,g)),E.length!==1||I||R(p)},u.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=m,L.addListener=m,L.once=m,L.off=m,L.removeListener=m,L.removeAllListeners=m,L.emit=m,L.prependListener=m,L.prependOnceListener=m,L.listeners=function(d){return[]},L.binding=function(d){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(d){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ne[104],ie([0,1]),function(K,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class n{constructor(R,b,E){this.level=R,this.key=b,this.value=E,this.forward=[]}}const L=void 0;class T{constructor(R,b=2**16){this.comparator=R,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(b)|0),this._header=new n(this._maxLevel,L,L)}get size(){return this._size}clear(){this._header=new n(this._maxLevel,L,L)}has(R){return Boolean(T._search(this,R,this.comparator))}get(R){return T._search(this,R,this.comparator)?.value}set(R,b){return T._insert(this,R,b,this.comparator)&&(this._size+=1),this}delete(R){const b=T._delete(this,R,this.comparator);return b&&(this._size-=1),b}forEach(R,b){let E=this._header.forward[0];for(;E;)R.call(b,E.value,E.key,this),E=E.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",b=this._header.forward[0];for(;b;)R+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return R}static _search(R,b,E){let I=R._header;for(let C=R._level-1;C>=0;C--)for(;I.forward[C]&&E(I.forward[C].key,b)<0;)I=I.forward[C];if(I=I.forward[0],I&&E(I.key,b)===0)return I}static _insert(R,b,E,I){let C=[],f=R._header;for(let p=R._level-1;p>=0;p--){for(;f.forward[p]&&I(f.forward[p].key,b)<0;)f=f.forward[p];C[p]=f}if(f=f.forward[0],f&&I(f.key,b)===0)return f.value=E,!1;{let p=T._randomLevel(R);if(p>R._level){for(let u=R._level;u<p;u++)C[u]=R._header;R._level=p}f=new n(p,b,E);for(let u=0;u<p;u++)f.forward[u]=C[u].forward[u],C[u].forward[u]=f;return!0}}static _randomLevel(R,b=.5){let E=1;for(;Math.random()<b&&E<R._maxLevel;)E+=1;return E}static _delete(R,b,E){let I=[],C=R._header;for(let f=R._level-1;f>=0;f--){for(;C.forward[f]&&E(C.forward[f].key,b)<0;)C=C.forward[f];I[f]=C}if(C=C.forward[0],!C||E(C.key,b)!==0)return!1;for(let f=0;f<R._level&&I[f].forward[f]===C;f++)I[f].forward[f]=C.forward[f];for(;R._level>0&&R._header.forward[R._level-1]===L;)R._level-=1;return!0}}e.SkipList=T}),define(ne[105],ie([0,1,4]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=D.globals.performance&&typeof D.globals.performance.now=="function";class L{constructor(A){this._highResolution=n&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new L(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=L}),define(ne[3],ie([0,1,9,68,2,101,105]),function(K,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var R;(function(S){S.None=()=>L.Disposable.None;function l(J){return(j,q=null,X)=>{let H=!1,Z;return Z=J(ee=>{if(!H)return Z?Z.dispose():H=!0,j.call(q,ee)},null,X),H&&Z.dispose(),Z}}S.once=l;function r(J,j){return a((q,X=null,H)=>J(Z=>q.call(X,j(Z)),null,H))}S.map=r;function c(J,j){return a((q,X=null,H)=>J(Z=>{j(Z),q.call(X,Z)},null,H))}S.forEach=c;function i(J,j){return a((q,X=null,H)=>J(Z=>j(Z)&&q.call(X,Z),null,H))}S.filter=i;function t(J){return J}S.signal=t;function o(...J){return(j,q=null,X)=>(0,L.combinedDisposable)(...J.map(H=>H(Z=>j.call(q,Z),null,X)))}S.any=o;function s(J,j,q){let X=q;return r(J,H=>(X=j(X,H),X))}S.reduce=s;function a(J){let j;const q=new f({onFirstListenerAdd(){j=J(q.fire,q)},onLastListenerRemove(){j.dispose()}});return q.event}function h(J,j,q,X=100,H=!1){let Z,ee,W=0;return J($=>{W++,Z=q(Z,$),H&&!ee&&(j(Z),Z=void 0),clearTimeout(ee),ee=setTimeout(()=>{const x=Z;Z=void 0,ee=void 0,(!H||W>1)&&j(x),W=0},X)})}S.debouncedListener=h;function v(J,j,q=100,X=!1,H){let Z,ee,W,$=0;const x=new f({leakWarningThreshold:H,onFirstListenerAdd(){Z=J(z=>{$++,ee=j(ee,z),X&&!W&&(x.fire(ee),ee=void 0),clearTimeout(W),W=setTimeout(()=>{const B=ee;ee=void 0,W=void 0,(!X||$>1)&&x.fire(B),$=0},q)})},onLastListenerRemove(){Z.dispose()}});return x.event}S.debounce=v;function P(J,j=(q,X)=>q===X){let q=!0,X;return i(J,H=>{const Z=q||!j(H,X);return q=!1,X=H,Z})}S.latch=P;function _(J,j){return[S.filter(J,j),S.filter(J,q=>!j(q))]}S.split=_;function O(J,j=!1,q=[]){let X=q.slice(),H=J(W=>{X?X.push(W):ee.fire(W)});const Z=()=>{X&&X.forEach(W=>ee.fire(W)),X=null},ee=new f({onFirstListenerAdd(){H||(H=J(W=>ee.fire(W)))},onFirstListenerDidAdd(){X&&(j?setTimeout(Z):Z())},onLastListenerRemove(){H&&H.dispose(),H=null}});return ee.event}S.buffer=O;class U{constructor(j){this.event=j}map(j){return new U(r(this.event,j))}forEach(j){return new U(c(this.event,j))}filter(j){return new U(i(this.event,j))}reduce(j,q){return new U(s(this.event,j,q))}latch(){return new U(P(this.event))}debounce(j,q=100,X=!1,H){return new U(v(this.event,j,q,X,H))}on(j,q,X){return this.event(j,q,X)}once(j,q,X){return l(this.event)(j,q,X)}}function k(J){return new U(J)}S.chain=k;function M(J,j,q=X=>X){const X=(...W)=>ee.fire(q(...W)),H=()=>J.on(j,X),Z=()=>J.removeListener(j,X),ee=new f({onFirstListenerAdd:H,onLastListenerRemove:Z});return ee.event}S.fromNodeEventEmitter=M;function F(J,j,q=X=>X){const X=(...W)=>ee.fire(q(...W)),H=()=>J.addEventListener(j,X),Z=()=>J.removeEventListener(j,X),ee=new f({onFirstListenerAdd:H,onLastListenerRemove:Z});return ee.event}S.fromDOMEventEmitter=F;function V(J){return new Promise(j=>l(J)(j))}S.toPromise=V;function N(J,j){return j(void 0),J(q=>j(q))}S.runAndSubscribe=N;function G(J,j){let q=null;function X(Z){q?.dispose(),q=new L.DisposableStore,j(Z,q)}X(void 0);const H=J(Z=>X(Z));return(0,L.toDisposable)(()=>{H.dispose(),q?.dispose()})}S.runAndSubscribeWithStore=G})(R=e.Event||(e.Event={}));class b{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${b._idPool++}`}start(l){this._stopWatch=new A.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}b._idPool=0;let E=-1;function I(S){const l=E;return E=S,{dispose(){E=l}}}e.setGlobalLeakWarningThreshold=I;class C{constructor(l,r=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let r=E;if(typeof this.customThreshold=="number"&&(r=this.customThreshold),r<=0||l<r)return;this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(c)||0;if(this._stacks.set(c,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let t,o=0;for(const[s,a]of this._stacks)(!t||o<a)&&(t=s,o=a);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${o}):`),console.warn(t)}return()=>{const t=this._stacks.get(c)||0;this._stacks.set(c,t-1)}}}class f{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=E>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new b(this._options._profName):void 0}get event(){return this._event||(this._event=(l,r,c)=>{this._listeners||(this._listeners=new T.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(r?[l,r]:l);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,r);const o=this._leakageMon?.check(this._listeners.size),s=(0,L.toDisposable)(()=>{o&&o(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return c instanceof L.DisposableStore?c.add(s):Array.isArray(c)&&c.push(s),s}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,c]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,c):r[0].call(r[1],c)}catch(i){(0,D.onUnexpectedError)(i)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=f;class p extends f{async fireAsync(l,r,c){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const i of this._listeners)this._asyncDeliveryQueue.push([i,l]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[i,t]=this._asyncDeliveryQueue.shift(),o=[],s={...t,token:r,waitUntil:a=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");c&&(a=c(a,typeof i=="function"?i:i[0])),o.push(a)}};try{typeof i=="function"?i.call(void 0,s):i[0].call(i[1],s)}catch(a){(0,D.onUnexpectedError)(a);continue}Object.freeze(o),await Promise.allSettled(o).then(a=>{for(const h of a)h.status==="rejected"&&(0,D.onUnexpectedError)(h.reason)})}}}}e.AsyncEmitter=p;class u extends f{constructor(l){super(l);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=u;class m extends u{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=m;class d extends f{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=d;class g{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const r={event:l,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const c=()=>{this.hasListeners&&this.unhook(r);const i=this.events.indexOf(r);this.events.splice(i,1)};return(0,L.toDisposable)((0,n.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(r=>this.emitter.fire(r))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=g;class w{constructor(){this.buffers=[]}wrapEvent(l){return(r,c,i)=>l(t=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>r.call(c,t)):r.call(c,t)},void 0,i)}bufferEvents(l){const r=[];this.buffers.push(r);const c=l();return this.buffers.pop(),r.forEach(i=>i()),c}}e.EventBufferer=w;class y{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=L.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=y}),define(ne[23],ie([0,1,3]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(R,b){const E=setTimeout(R.bind(b),0);return{dispose(){clearTimeout(E)}}});var L;(function(R){function b(E){return E===R.None||E===R.Cancelled||E instanceof T?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}R.isCancellationToken=b,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(L=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(b){this._token=void 0,this._parentListener=void 0,this._parentListener=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=L.Cancelled}dispose(b=!1){b&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=A}),define(ne[106],ie([0,1,23]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(A){this.task=A,this.result=null}get(){if(this.result)return this.result;const A=new D.CancellationTokenSource,R=this.task(A.token);return this.result={promise:R,dispose:()=>{this.result=null,A.cancel(),A.dispose()}},this.result}}e.Cache=n;class L{constructor(A){this.computeFn=A,this.lastCache=void 0,this.lastArgKey=void 0}get(A){const R=JSON.stringify(A);return this.lastArgKey!==R&&(this.lastArgKey=R,this.lastCache=this.computeFn(A)),this.lastCache}}e.LRUCachedComputed=L}),define(ne[40],ie([0,1,9,2]),function(K,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function L(y){const S=y;return S?[S.on,S.pause,S.resume,S.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=L;function T(y){const S=y;return S?L(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.isReadableBufferedStream=T;function A(y,S){return new R(y,S)}e.newWriteableStream=A;class R{constructor(S,l){this.reducer=S,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(S){if(!this.state.destroyed){if(this.state.flowing)this.emitData(S);else if(this.buffer.data.push(S),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(S){this.state.destroyed||(this.state.flowing?this.emitError(S):this.buffer.error.push(S))}end(S){this.state.destroyed||(typeof S!="undefined"&&this.write(S),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(S){this.listeners.data.slice(0).forEach(l=>l(S))}emitError(S){this.listeners.error.length===0?(0,D.onUnexpectedError)(S):this.listeners.error.slice(0).forEach(l=>l(S))}emitEnd(){this.listeners.end.slice(0).forEach(S=>S())}on(S,l){if(!this.state.destroyed)switch(S){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(S,l){if(this.state.destroyed)return;let r;switch(S){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const c=r.indexOf(l);c>=0&&r.splice(c,1)}}flowData(){if(this.buffer.data.length>0){const S=this.reducer(this.buffer.data);this.emitData(S),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const S of this.buffer.error)this.emitError(S);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function b(y,S){const l=[];let r;for(;(r=y.read())!==null;)l.push(r);return S(l)}e.consumeReadable=b;function E(y,S,l){const r=[];let c;for(;(c=y.read())!==null&&r.length<l;)r.push(c);return c===null&&r.length>0?S(r):{read:()=>{if(r.length>0)return r.shift();if(typeof c!="undefined"){const i=c;return c=void 0,i}return y.read()}}}e.peekReadable=E;function I(y,S){return new Promise((l,r)=>{const c=[];C(y,{onData:i=>{S&&c.push(i)},onError:i=>{S?r(i):l(void 0)},onEnd:()=>{l(S?S(c):void 0)}})})}e.consumeStream=I;function C(y,S){let l=!1;return y.on("error",r=>{l||S.onError(r)}),y.on("end",()=>{l||S.onEnd()}),y.on("data",r=>{l||S.onData(r)}),(0,n.toDisposable)(()=>l=!0)}e.listenStream=C;function f(y,S){return new Promise((l,r)=>{const c=new n.DisposableStore,i=[],t=a=>{if(i.push(a),i.length>S)return c.dispose(),y.pause(),l({stream:y,buffer:i,ended:!1})},o=a=>r(a),s=()=>l({stream:y,buffer:i,ended:!0});c.add((0,n.toDisposable)(()=>y.removeListener("error",o))),y.on("error",o),c.add((0,n.toDisposable)(()=>y.removeListener("end",s))),y.on("end",s),c.add((0,n.toDisposable)(()=>y.removeListener("data",t))),y.on("data",t)})}e.peekStream=f;function p(y,S){const l=A(S);return l.end(y),l}e.toStream=p;function u(){const y=A(()=>{throw new Error("not supported")});return y.end(),y}e.emptyStream=u;function m(y){let S=!1;return{read:()=>S?null:(S=!0,y)}}e.toReadable=m;function d(y,S,l){const r=A(l);return C(y,{onData:c=>r.write(S.data(c)),onError:c=>r.error(S.error?S.error(c):c),onEnd:()=>r.end()}),r}e.transform=d;function g(y,S,l){let r=!1;return{read:()=>{const c=S.read();return r?c:(r=!0,c!==null?l([y,c]):y)}}}e.prefixedReadable=g;function w(y,S,l){let r=!1;const c=A(l);return C(S,{onData:i=>r?c.write(i):(r=!0,c.write(l([y,i]))),onError:i=>c.error(i),onEnd:()=>{r||(r=!0,c.write(y)),c.end()}}),c}e.prefixedStream=w}),define(ne[17],ie([0,1,40]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let L,T;class A{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return n?new A(Buffer.allocUnsafe(h)):new A(new Uint8Array(h))}static wrap(h){return n&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new A(h)}static fromString(h,v){return!(v?.dontUseNodeBuffer||!1)&&n?new A(Buffer.from(h)):(L||(L=new TextEncoder),new A(L.encode(h)))}static fromByteArray(h){const v=A.alloc(h.length);for(let P=0,_=h.length;P<_;P++)v.buffer[P]=h[P];return v}static concat(h,v){if(typeof v=="undefined"){v=0;for(let O=0,U=h.length;O<U;O++)v+=h[O].byteLength}const P=A.alloc(v);let _=0;for(let O=0,U=h.length;O<U;O++){const k=h[O];P.set(k,_),_+=k.byteLength}return P}clone(){const h=A.alloc(this.byteLength);return h.set(this),h}toString(){return n?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(h,v){return new A(this.buffer.subarray(h,v))}set(h,v){if(h instanceof A)this.buffer.set(h.buffer,v);else if(h instanceof Uint8Array)this.buffer.set(h,v);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),v);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),v);else throw new Error("Unkown argument 'array'")}readUInt32BE(h){return E(this.buffer,h)}writeUInt32BE(h,v){I(this.buffer,h,v)}readUInt32LE(h){return C(this.buffer,h)}writeUInt32LE(h,v){f(this.buffer,h,v)}readUInt8(h){return p(this.buffer,h)}writeUInt8(h,v){u(this.buffer,h,v)}}e.VSBuffer=A;function R(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0}e.readUInt16LE=R;function b(a,h,v){a[v+0]=h&255,h=h>>>8,a[v+1]=h&255}e.writeUInt16LE=b;function E(a,h){return a[h]*2**24+a[h+1]*2**16+a[h+2]*2**8+a[h+3]}e.readUInt32BE=E;function I(a,h,v){a[v+3]=h,h=h>>>8,a[v+2]=h,h=h>>>8,a[v+1]=h,h=h>>>8,a[v]=h}e.writeUInt32BE=I;function C(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0|a[h+2]<<16>>>0|a[h+3]<<24>>>0}e.readUInt32LE=C;function f(a,h,v){a[v+0]=h&255,h=h>>>8,a[v+1]=h&255,h=h>>>8,a[v+2]=h&255,h=h>>>8,a[v+3]=h&255}e.writeUInt32LE=f;function p(a,h){return a[h]}e.readUInt8=p;function u(a,h,v){a[v]=h}e.writeUInt8=u;function m(a){return D.consumeReadable(a,h=>A.concat(h))}e.readableToBuffer=m;function d(a){return D.toReadable(a)}e.bufferToReadable=d;function g(a){return D.consumeStream(a,h=>A.concat(h))}e.streamToBuffer=g;async function w(a){return a.ended?A.concat(a.buffer):A.concat([...a.buffer,await g(a.stream)])}e.bufferedStreamToBuffer=w;function y(a){return D.toStream(a,h=>A.concat(h))}e.bufferToStream=y;function S(a){return D.transform(a,{data:h=>typeof h=="string"?A.fromString(h):A.wrap(h)},h=>A.concat(h))}e.streamToBufferReadableStream=S;function l(a){return D.newWriteableStream(h=>A.concat(h),a)}e.newWriteableBufferStream=l;function r(a,h){return D.prefixedReadable(a,h,v=>A.concat(v))}e.prefixedBufferReadable=r;function c(a,h){return D.prefixedStream(a,h,v=>A.concat(v))}e.prefixedBufferStream=c;function i(a){let h=0,v=0,P=0;const _=new Uint8Array(Math.floor(a.length/4*3)),O=k=>{switch(v){case 3:_[P++]=h|k,v=0;break;case 2:_[P++]=h|k>>>2,h=k<<6,v=3;break;case 1:_[P++]=h|k>>>4,h=k<<4,v=2;break;default:h=k<<2,v=1}};for(let k=0;k<a.length;k++){const M=a.charCodeAt(k);if(M>=65&&M<=90)O(M-65);else if(M>=97&&M<=122)O(M-97+26);else if(M>=48&&M<=57)O(M-48+52);else if(M===43||M===45)O(62);else if(M===47||M===95)O(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${a[k]}`)}}const U=P;for(;v>0;)O(0);return A.wrap(_).slice(0,U)}e.decodeBase64=i;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function s({buffer:a},h=!0,v=!1){const P=v?o:t;let _="";const O=a.byteLength%3;let U=0;for(;U<a.byteLength-O;U+=3){const k=a[U+0],M=a[U+1],F=a[U+2];_+=P[k>>>2],_+=P[(k<<4|M>>>4)&63],_+=P[(M<<2|F>>>6)&63],_+=P[F&63]}if(O===1){const k=a[U+0];_+=P[k>>>2],_+=P[k<<4&63],h&&(_+="==")}else if(O===2){const k=a[U+0],M=a[U+1];_+=P[k>>>2],_+=P[(k<<4|M>>>4)&63],_+=P[M<<2&63],h&&(_+="=")}return _}e.encodeBase64=s}),define(ne[26],ie([0,1,106,100]),function(K,e,D,n){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(Q){return!Q||typeof Q!="string"?!0:Q.trim().length===0}e.isFalsyOrWhitespace=T;const A=/{(\d+)}/g;function R(Q,...oe){return oe.length===0?Q:Q.replace(A,function(le,fe){const ge=parseInt(fe,10);return isNaN(ge)||ge<0||ge>=oe.length?le:oe[ge]})}e.format=R;const b=/{([^}]+)}/g;function E(Q,oe){return Q.replace(b,(le,fe)=>oe[fe]??le)}e.format2=E;function I(Q){return Q.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=I;function C(Q){return Q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function f(Q,oe){let le=0;const fe=oe.charCodeAt(0);for(let ge=Q.length-1;ge>=0;ge--)Q.charCodeAt(ge)===fe&&le++;return le}e.count=f;function p(Q,oe,le="\u2026"){return Q.length<=oe?Q:`${Q.substr(0,oe)}${le}`}e.truncate=p;function u(Q,oe=" "){const le=m(Q,oe);return d(le,oe)}e.trim=u;function m(Q,oe){if(!Q||!oe)return Q;const le=oe.length;if(le===0||Q.length===0)return Q;let fe=0;for(;Q.indexOf(oe,fe)===fe;)fe=fe+le;return Q.substring(fe)}e.ltrim=m;function d(Q,oe){if(!Q||!oe)return Q;const le=oe.length,fe=Q.length;if(le===0||fe===0)return Q;let ge=fe,Le=-1;for(;Le=Q.lastIndexOf(oe,ge-1),!(Le===-1||Le+le!==ge);){if(Le===0)return"";ge=Le}return Q.substring(0,ge)}e.rtrim=d;function g(Q){return Q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function w(Q){return Q.replace(/\*/g,"")}e.stripWildcards=w;function y(Q,oe,le={}){if(!Q)throw new Error("Cannot create regex from empty string");oe||(Q=C(Q)),le.wholeWord&&(/\B/.test(Q.charAt(0))||(Q="\\b"+Q),/\B/.test(Q.charAt(Q.length-1))||(Q=Q+"\\b"));let fe="";return le.global&&(fe+="g"),le.matchCase||(fe+="i"),le.multiline&&(fe+="m"),le.unicode&&(fe+="u"),new RegExp(Q,fe)}e.createRegExp=y;function S(Q){return Q.source==="^"||Q.source==="^$"||Q.source==="$"||Q.source==="^\\s*$"?!1:!!(Q.exec("")&&Q.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function l(Q){return!!Q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function r(Q){return(Q.global?"g":"")+(Q.ignoreCase?"i":"")+(Q.multiline?"m":"")+(Q.unicode?"u":"")}e.regExpFlags=r;function c(Q){return Q.split(/\r\n|\r|\n/)}e.splitLines=c;function i(Q){for(let oe=0,le=Q.length;oe<le;oe++){const fe=Q.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.firstNonWhitespaceIndex=i;function t(Q,oe=0,le=Q.length){for(let fe=oe;fe<le;fe++){const ge=Q.charCodeAt(fe);if(ge!==32&&ge!==9)return Q.substring(oe,fe)}return Q.substring(oe,le)}e.getLeadingWhitespace=t;function o(Q,oe=Q.length-1){for(let le=oe;le>=0;le--){const fe=Q.charCodeAt(le);if(fe!==32&&fe!==9)return le}return-1}e.lastNonWhitespaceIndex=o;function s(Q,oe){return Q<oe?-1:Q>oe?1:0}e.compare=s;function a(Q,oe,le=0,fe=Q.length,ge=0,Le=oe.length){for(;le<fe&&ge<Le;le++,ge++){let ke=Q.charCodeAt(le),Pe=oe.charCodeAt(ge);if(ke<Pe)return-1;if(ke>Pe)return 1}const Se=fe-le,De=Le-ge;return Se<De?-1:Se>De?1:0}e.compareSubstring=a;function h(Q,oe){return v(Q,oe,0,Q.length,0,oe.length)}e.compareIgnoreCase=h;function v(Q,oe,le=0,fe=Q.length,ge=0,Le=oe.length){for(;le<fe&&ge<Le;le++,ge++){let ke=Q.charCodeAt(le),Pe=oe.charCodeAt(ge);if(ke===Pe)continue;if(ke>=128||Pe>=128)return a(Q.toLowerCase(),oe.toLowerCase(),le,fe,ge,Le);P(ke)&&(ke-=32),P(Pe)&&(Pe-=32);const Ae=ke-Pe;if(Ae!==0)return Ae}const Se=fe-le,De=Le-ge;return Se<De?-1:Se>De?1:0}e.compareSubstringIgnoreCase=v;function P(Q){return Q>=97&&Q<=122}e.isLowerAsciiLetter=P;function _(Q){return Q>=65&&Q<=90}e.isUpperAsciiLetter=_;function O(Q,oe){return Q.length===oe.length&&v(Q,oe)===0}e.equalsIgnoreCase=O;function U(Q,oe){const le=oe.length;return oe.length>Q.length?!1:v(Q,oe,0,le)===0}e.startsWithIgnoreCase=U;function k(Q,oe){let le,fe=Math.min(Q.length,oe.length);for(le=0;le<fe;le++)if(Q.charCodeAt(le)!==oe.charCodeAt(le))return le;return fe}e.commonPrefixLength=k;function M(Q,oe){let le,fe=Math.min(Q.length,oe.length);const ge=Q.length-1,Le=oe.length-1;for(le=0;le<fe;le++)if(Q.charCodeAt(ge-le)!==oe.charCodeAt(Le-le))return le;return fe}e.commonSuffixLength=M;function F(Q){return 55296<=Q&&Q<=56319}e.isHighSurrogate=F;function V(Q){return 56320<=Q&&Q<=57343}e.isLowSurrogate=V;function N(Q,oe){return(Q-55296<<10)+(oe-56320)+65536}e.computeCodePoint=N;function G(Q,oe,le){const fe=Q.charCodeAt(le);if(F(fe)&&le+1<oe){const ge=Q.charCodeAt(le+1);if(V(ge))return N(fe,ge)}return fe}e.getNextCodePoint=G;function J(Q,oe){const le=Q.charCodeAt(oe-1);if(V(le)&&oe>1){const fe=Q.charCodeAt(oe-2);if(F(fe))return N(fe,le)}return le}class j{constructor(oe,le=0){this._str=oe,this._len=oe.length,this._offset=le}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=J(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=G(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}e.CodePointIterator=j;class q{constructor(oe,le=0){this._iterator=new j(oe,le)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=ae.getInstance(),le=this._iterator,fe=le.offset;let ge=oe.getGraphemeBreakType(le.nextCodePoint());for(;!le.eol();){const Le=le.offset,Se=oe.getGraphemeBreakType(le.nextCodePoint());if(xe(ge,Se)){le.setOffset(Le);break}ge=Se}return le.offset-fe}prevGraphemeLength(){const oe=ae.getInstance(),le=this._iterator,fe=le.offset;let ge=oe.getGraphemeBreakType(le.prevCodePoint());for(;le.offset>0;){const Le=le.offset,Se=oe.getGraphemeBreakType(le.prevCodePoint());if(xe(Se,ge)){le.setOffset(Le);break}ge=Se}return fe-le.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=q;function X(Q,oe){return new q(Q,oe).nextGraphemeLength()}e.nextCharLength=X;function H(Q,oe){return new q(Q,oe).prevGraphemeLength()}e.prevCharLength=H;function Z(Q,oe){oe>0&&V(Q.charCodeAt(oe))&&oe--;const le=oe+X(Q,oe);return[le-H(Q,le),le]}e.getCharContainingOffset=Z;const ee=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(Q){return ee.test(Q)}e.containsRTL=W;const $=/^[\t\n\r\x20-\x7E]*$/;function x(Q){return $.test(Q)}e.isBasicASCII=x,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function z(Q){return e.UNUSUAL_LINE_TERMINATORS.test(Q)}e.containsUnusualLineTerminators=z;function B(Q){return Q>=11904&&Q<=55215||Q>=63744&&Q<=64255||Q>=65281&&Q<=65374}e.isFullWidthCharacter=B;function te(Q){return Q>=127462&&Q<=127487||Q===8986||Q===8987||Q===9200||Q===9203||Q>=9728&&Q<=10175||Q===11088||Q===11093||Q>=127744&&Q<=128591||Q>=128640&&Q<=128764||Q>=128992&&Q<=129008||Q>=129280&&Q<=129535||Q>=129648&&Q<=129782}e.isEmojiImprecise=te;function se(Q,oe){if(Q.length<oe)return Q;const le=/\b/g;let fe=0;for(;le.test(Q)&&!(Q.length-le.lastIndex<oe);)fe=le.lastIndex,le.lastIndex+=1;return Q.substring(fe).replace(/^\s/,"")}e.lcut=se;const ce=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,ve=/\x1b\[0?m/g;function pe(Q){return Q&&(Q=Q.replace(ce,""),Q=Q.replace(he,""),Q=Q.replace(ve,"")),Q}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ie(Q){return!!(Q&&Q.length>0&&Q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ie;function Ee(Q){return Ie(Q)?Q.substr(1):Q}e.stripUTF8BOM=Ee;function ye(Q,oe){if(!Q||!oe||Q.length<oe.length)return!1;const le=oe.length,fe=Q.toLowerCase();let ge=0,Le=-1;for(;ge<le;){const Se=fe.indexOf(oe[ge],Le+1);if(Se<0)return!1;Le=Se,ge++}return!0}e.fuzzyContains=ye;function be(Q,oe=!1){return Q?(oe&&(Q=Q.replace(/\\./g,"")),Q.toLowerCase()!==Q):!1}e.containsUppercaseCharacter=be;function Re(Q){return Q.charAt(0).toUpperCase()+Q.slice(1)}e.uppercaseFirstLetter=Re;function Ne(Q,oe=1){if(oe===0)return"";let le=-1;do le=Q.indexOf(`
`,le+1),oe--;while(oe>0&&le>=0);return le===-1?Q:(Q[le-1]==="\r"&&le--,Q.substr(0,le))}e.getNLines=Ne;function Ue(Q){const oe=90-65+1;return Q=Q%(2*oe),Q<oe?String.fromCharCode(97+Q):String.fromCharCode(65+Q-oe)}e.singleLetterHash=Ue;function qe(Q){return ae.getInstance().getGraphemeBreakType(Q)}e.getGraphemeBreakType=qe;function xe(Q,oe){return Q===0?oe!==5&&oe!==7:Q===2&&oe===3?!1:Q===4||Q===2||Q===3||oe===4||oe===2||oe===3?!0:!(Q===8&&(oe===8||oe===9||oe===11||oe===12)||(Q===11||Q===9)&&(oe===9||oe===10)||(Q===12||Q===10)&&oe===10||oe===5||oe===13||oe===7||Q===1||Q===13&&oe===14||Q===6&&oe===6)}var re;(function(Q){Q[Q.Other=0]="Other",Q[Q.Prepend=1]="Prepend",Q[Q.CR=2]="CR",Q[Q.LF=3]="LF",Q[Q.Control=4]="Control",Q[Q.Extend=5]="Extend",Q[Q.Regional_Indicator=6]="Regional_Indicator",Q[Q.SpacingMark=7]="SpacingMark",Q[Q.L=8]="L",Q[Q.V=9]="V",Q[Q.T=10]="T",Q[Q.LV=11]="LV",Q[Q.LVT=12]="LVT",Q[Q.ZWJ=13]="ZWJ",Q[Q.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ae{constructor(){this._data=ue()}static getInstance(){return ae._INSTANCE||(ae._INSTANCE=new ae),ae._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const le=this._data,fe=le.length/3;let ge=1;for(;ge<=fe;)if(oe<le[3*ge])ge=2*ge;else if(oe>le[3*ge+1])ge=2*ge+1;else return le[3*ge+2];return 0}}ae._INSTANCE=null;function ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function we(Q,oe){if(Q===0)return 0;const le=Ce(Q,oe);if(le!==void 0)return le;const fe=new j(oe,Q);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=we;function Ce(Q,oe){const le=new j(oe,Q);let fe=le.prevCodePoint();for(;Fe(fe)||fe===65039||fe===8419;){if(le.offset===0)return;fe=le.prevCodePoint()}if(!te(fe))return;let ge=le.offset;return ge>0&&le.prevCodePoint()===8205&&(ge=le.offset),ge}function Fe(Q){return 127995<=Q&&Q<=127999}var Te;(function(Q){Q[Q.zwj=8205]="zwj",Q[Q.emojiVariantSelector=65039]="emojiVariantSelector",Q[Q.enclosingKeyCap=8419]="enclosingKeyCap"})(Te||(Te={})),e.noBreakWhitespace="\xA0";class Oe{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return Oe.cache.get(Array.from(oe))}static getLocales(){return Oe._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Oe,L=Oe,Oe.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Oe.cache=new D.LRUCachedComputed(Q=>{function oe(Pe){const Ae=new Map;for(let $e=0;$e<Pe.length;$e+=2)Ae.set(Pe[$e],Pe[$e+1]);return Ae}function le(Pe,Ae){const $e=new Map(Pe);for(const[je,Be]of Ae)$e.set(je,Be);return $e}function fe(Pe,Ae){if(!Pe)return Ae;const $e=new Map;for(const[je,Be]of Pe)Ae.has(je)&&$e.set(je,Be);return $e}const ge=L.ambiguousCharacterData.getValue();let Le=Q.filter(Pe=>!Pe.startsWith("_")&&Pe in ge);Le.length===0&&(Le=["_default"]);let Se;for(const Pe of Le){const Ae=oe(ge[Pe]);Se=fe(Se,Ae)}const De=oe(ge._common),ke=le(De,Se);return new Oe(ke)}),Oe._locales=new n.Lazy(()=>Object.keys(Oe.ambiguousCharacterData.getValue()).filter(Q=>!Q.startsWith("_")));class _e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(_e.getRawData())),this._data}static isInvisibleCharacter(oe){return _e.getData().has(oe)}static get codePoints(){return _e.getData()}}e.InvisibleCharacters=_e,_e._data=void 0}),define(ne[70],ie([0,1,26]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(g){return L(g,0)}e.hash=n;function L(g,w){switch(typeof g){case"object":return g===null?T(349,w):Array.isArray(g)?b(g,w):E(g,w);case"string":return R(g,w);case"boolean":return A(g,w);case"number":return T(g,w);case"undefined":return T(937,w);default:return T(617,w)}}e.doHash=L;function T(g,w){return(w<<5)-w+g|0}e.numberHash=T;function A(g,w){return T(g?433:863,w)}function R(g,w){w=T(149417,w);for(let y=0,S=g.length;y<S;y++)w=T(g.charCodeAt(y),w);return w}e.stringHash=R;function b(g,w){return w=T(104579,w),g.reduce((y,S)=>L(S,y),w)}function E(g,w){return w=T(181387,w),Object.keys(g).sort().reduce((y,S)=>(y=R(S,y),L(g[S],y)),w)}class I{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=L(w,this._value),this._value}}e.Hasher=I;var C;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function f(g,w,y=32){const S=y-w,l=~((1<<S)-1);return(g<<w|(l&g)>>>S)>>>0}function p(g,w=0,y=g.byteLength,S=0){for(let l=0;l<y;l++)g[w+l]=S}function u(g,w,y="0"){for(;g.length<w;)g=y+g;return g}function m(g,w=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(y=>y.toString(16).padStart(2,"0")).join(""):u((g>>>0).toString(16),w/4)}e.toHexString=m;class d{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const y=w.length;if(y===0)return;const S=this._buff;let l=this._buffLen,r=this._leftoverHighSurrogate,c,i;for(r!==0?(c=r,i=-1,r=0):(c=w.charCodeAt(0),i=0);;){let t=c;if(D.isHighSurrogate(c))if(i+1<y){const o=w.charCodeAt(i+1);D.isLowSurrogate(o)?(i++,t=D.computeCodePoint(c,o)):t=65533}else{r=c;break}else D.isLowSurrogate(c)&&(t=65533);if(l=this._push(S,l,t),i++,i<y)c=w.charCodeAt(i);else break}this._buffLen=l,this._leftoverHighSurrogate=r}_push(w,y,S){return S<128?w[y++]=S:S<2048?(w[y++]=192|(S&1984)>>>6,w[y++]=128|(S&63)>>>0):S<65536?(w[y++]=224|(S&61440)>>>12,w[y++]=128|(S&4032)>>>6,w[y++]=128|(S&63)>>>0):(w[y++]=240|(S&1835008)>>>18,w[y++]=128|(S&258048)>>>12,w[y++]=128|(S&4032)>>>6,w[y++]=128|(S&63)>>>0),y>=64&&(this._step(),y-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=d._bigBlock32,y=this._buffDV;for(let a=0;a<64;a+=4)w.setUint32(a,y.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)w.setUint32(a,f(w.getUint32(a-12,!1)^w.getUint32(a-32,!1)^w.getUint32(a-56,!1)^w.getUint32(a-64,!1),1),!1);let S=this._h0,l=this._h1,r=this._h2,c=this._h3,i=this._h4,t,o,s;for(let a=0;a<80;a++)a<20?(t=l&r|~l&c,o=1518500249):a<40?(t=l^r^c,o=1859775393):a<60?(t=l&r|l&c|r&c,o=2400959708):(t=l^r^c,o=3395469782),s=f(S,5)+t+i+o+w.getUint32(a*4,!1)&4294967295,i=c,c=r,r=f(l,30),l=S,S=s;this._h0=this._h0+S&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+c&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=d,d._bigBlock32=new DataView(new ArrayBuffer(320))});var It=this&&this.__classPrivateFieldSet||function(K,e,D,n,L){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!L:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?L.call(K,D):L?L.value=D:e.set(K,D),D},Ke=this&&this.__classPrivateFieldGet||function(K,e,D,n){if(D==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!n:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?n:D==="a"?n.call(K):n?n.value:e.get(K)};define(ne[39],ie([0,1,16,26]),function(K,e,D,n){"use strict";var L,T,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(i,t,o){let s=i.get(t);return s===void 0&&(s=o,i.set(t,s)),s}e.getOrSet=R;function b(i){const t=[];return i.forEach((o,s)=>{t.push(`${s} => ${o}`)}),`Map(${i.size}) {${t.join(", ")}}`}e.mapToString=b;function E(i){const t=[];return i.forEach(o=>{t.push(o)}),`Set(${i.size}) {${t.join(", ")}}`}e.setToString=E;class I{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const o=t.charCodeAt(0),s=this._value.charCodeAt(this._pos);return o-s}value(){return this._value[this._pos]}}e.StringIterator=I;class C{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class f{constructor(t=!0,o=!0){this._splitOnBackslash=t,this._caseSensitive=o}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let o=t.length-1;o>=0;o--,this._valueLen--){const s=this._value.charCodeAt(o);if(!(s===47||this._splitOnBackslash&&s===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var p;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(p||(p={}));class u{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,n.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(d||(d={}));class g{constructor(t){this._iter=t}static forUris(t=()=>!1){return new g(new u(t))}static forPaths(t=!1){return new g(new f(void 0,!t))}static forStrings(){return new g(new I)}static forConfigKeys(){return new g(new C)}clear(){this._root=void 0}fill(t,o){if(o){const s=o.slice(0);(0,D.shuffle)(s);for(let a of s)this.set(a,t)}else{const s=t.slice(0);(0,D.shuffle)(s);for(let a of s)this.set(a[0],a[1])}}set(t,o){const s=this._iter.reset(t);let a;this._root||(this._root=new m,this._root.segment=s.value());const h=[];for(a=this._root;;){const P=s.cmp(a.segment);if(P>0)a.left||(a.left=new m,a.left.segment=s.value()),h.push([-1,a]),a=a.left;else if(P<0)a.right||(a.right=new m,a.right.segment=s.value()),h.push([1,a]),a=a.right;else if(s.hasNext())s.next(),a.mid||(a.mid=new m,a.mid.segment=s.value()),h.push([0,a]),a=a.mid;else break}const v=a.value;a.value=o,a.key=t;for(let P=h.length-1;P>=0;P--){const _=h[P][1];_.updateHeight();const O=_.balanceFactor();if(O<-1||O>1){const U=h[P][0],k=h[P+1][0];if(U===1&&k===1)h[P][1]=_.rotateLeft();else if(U===-1&&k===-1)h[P][1]=_.rotateRight();else if(U===1&&k===-1)_.right=h[P+1][1]=h[P+1][1].rotateRight(),h[P][1]=_.rotateLeft();else if(U===-1&&k===1)_.left=h[P+1][1]=h[P+1][1].rotateLeft(),h[P][1]=_.rotateRight();else throw new Error;if(P>0)switch(h[P-1][0]){case-1:h[P-1][1].left=h[P][1];break;case 1:h[P-1][1].right=h[P][1];break;case 0:h[P-1][1].mid=h[P][1];break}else this._root=h[0][1]}}return v}get(t){return this._getNode(t)?.value}_getNode(t){const o=this._iter.reset(t);let s=this._root;for(;s;){const a=o.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(o.hasNext())o.next(),s=s.mid;else break}return s}has(t){const o=this._getNode(t);return!(o?.value===void 0&&o?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,o){const s=this._iter.reset(t),a=[];let h=this._root;for(;h;){const v=s.cmp(h.segment);if(v>0)a.push([-1,h]),h=h.left;else if(v<0)a.push([1,h]),h=h.right;else if(s.hasNext())s.next(),a.push([0,h]),h=h.mid;else break}if(!!h){if(o?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const v=this._min(h.right),{key:P,value:_,segment:O}=v;this._delete(v.key,!1),h.key=P,h.value=_,h.segment=O}else{const v=h.left??h.right;if(a.length>0){const[P,_]=a[a.length-1];switch(P){case-1:_.left=v;break;case 0:_.mid=v;break;case 1:_.right=v;break}}else this._root=v}for(let v=a.length-1;v>=0;v--){const P=a[v][1];P.updateHeight();const _=P.balanceFactor();if(_>1?(P.right.balanceFactor()>=0||(P.right=P.right.rotateRight()),a[v][1]=P.rotateLeft()):_<-1&&(P.left.balanceFactor()<=0||(P.left=P.left.rotateLeft()),a[v][1]=P.rotateRight()),v>0)switch(a[v-1][0]){case-1:a[v-1][1].left=a[v][1];break;case 1:a[v-1][1].right=a[v][1];break;case 0:a[v-1][1].mid=a[v][1];break}else this._root=a[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const o=this._iter.reset(t);let s=this._root,a;for(;s;){const h=o.cmp(s.segment);if(h>0)s=s.left;else if(h<0)s=s.right;else if(o.hasNext())o.next(),a=s.value||a,s=s.mid;else break}return s&&s.value||a}findSuperstr(t){const o=this._iter.reset(t);let s=this._root;for(;s;){const a=o.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(o.hasNext())o.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(t){for(const[o,s]of this)t(s,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=o=>{if(!o)return!0;const s=o.balanceFactor();return s<-1||s>1?!1:t(o.left)&&t(o.right)};return t(this._root)}}e.TernarySearchTree=g;class w{constructor(t,o){this.uri=t,this.value=o}}class y{constructor(t,o){this[L]="ResourceMap",t instanceof y?(this.map=new Map(t.map),this.toKey=o??y.defaultToKey):(this.map=new Map,this.toKey=t??y.defaultToKey)}set(t,o){return this.map.set(this.toKey(t),new w(t,o)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,o){typeof o!="undefined"&&(t=t.bind(o));for(let[s,a]of this.map)t(a.value,a.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=y,y.defaultToKey=i=>i.toString();var S;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class l{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,o=0){const s=this._map.get(t);if(!!s)return o!==0&&this.touch(s,o),s.value}set(t,o,s=0){let a=this._map.get(t);if(a)a.value=o,s!==0&&this.touch(a,s);else{switch(a={key:t,value:o,next:void 0,previous:void 0},s){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(t,a),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this._map.get(t);if(!!o)return this._map.delete(t),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,o){const s=this._state;let a=this._head;for(;a;){if(o?t.bind(o)(a.value,a.key,this):t(a.value,a.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const t=this,o=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:s.key,done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return a}values(){const t=this,o=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:s.value,done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return a}entries(){const t=this,o=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:[s.key,s.value],done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return a}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this._head,s=this.size;for(;o&&s>t;)this._map.delete(o.key),o=o.next,s--;this._head=o,this._size=s,o&&(o.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const o=t.next,s=t.previous;if(!o||!s)throw new Error("Invalid list");o.previous=s,s.next=o}t.next=void 0,t.previous=void 0,this._state++}touch(t,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(t===this._head)return;const s=t.next,a=t.previous;t===this._tail?(a.next=void 0,this._tail=a):(s.previous=a,a.next=s),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(o===2){if(t===this._tail)return;const s=t.next,a=t.previous;t===this._head?(s.previous=void 0,this._head=s):(s.previous=a,a.next=s),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((o,s)=>{t.push([s,o])}),t}fromJSON(t){this.clear();for(const[o,s]of t)this.set(o,s)}}e.LinkedMap=l;class r extends l{constructor(t,o=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,o=2){return super.get(t,o)}peek(t){return super.get(t,0)}set(t,o){return super.set(t,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class c{constructor(t){A.set(this,void 0),It(this,A,t,"f")}get size(){return Ke(this,A,"f").size}forEach(t,o){Ke(this,A,"f").forEach(t,o)}get(t){return Ke(this,A,"f").get(t)}has(t){return Ke(this,A,"f").has(t)}entries(){return Ke(this,A,"f").entries()}keys(){return Ke(this,A,"f").keys()}values(){return Ke(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return Ke(this,A,"f").entries()}}e.ReadonlyMapView=c}),define(ne[71],ie([0,1,39]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new D.LRUCache(1e4);function L(E){return b(E,"NFC",n)}e.normalizeNFC=L;const T=new D.LRUCache(1e4);function A(E){return b(E,"NFD",T)}e.normalizeNFD=A;const R=/[^\u0000-\u0080]/;function b(E,I,C){if(!E)return E;const f=C.get(E);if(f)return f;let p;return R.test(E)?p=E.normalize(I):p=E,C.set(E,p),p}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(I){return A(I).replace(E,"")}}()}),define(ne[14],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function D(s){return Array.isArray(s)}e.isArray=D;function n(s){return typeof s=="string"}e.isString=n;function L(s){return Array.isArray(s)&&s.every(a=>n(a))}e.isStringArray=L;function T(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=T;function A(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=A;function R(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=R;function b(s){return s===!0||s===!1}e.isBoolean=b;function E(s){return typeof s=="undefined"}e.isUndefined=E;function I(s){return!C(s)}e.isDefined=I;function C(s){return E(s)||s===null}e.isUndefinedOrNull=C;function f(s,a){if(!s)throw new Error(a?`Unexpected type, expected '${a}'`:"Unexpected type")}e.assertType=f;function p(s){if(C(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=p;function u(...s){const a=[];for(let h=0;h<s.length;h++){const v=s[h];if(C(v))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);a.push(v)}return a}e.assertAllDefined=u;const m=Object.prototype.hasOwnProperty;function d(s){if(!T(s))return!1;for(let a in s)if(m.call(s,a))return!1;return!0}e.isEmptyObject=d;function g(s){return typeof s=="function"}e.isFunction=g;function w(...s){return s.length>0&&s.every(g)}e.areFunctions=w;function y(s,a){const h=Math.min(s.length,a.length);for(let v=0;v<h;v++)S(s[v],a[v])}e.validateConstraints=y;function S(s,a){if(n(a)){if(typeof s!==a)throw new Error(`argument does not match constraint: typeof ${a}`)}else if(g(a)){try{if(s instanceof a)return}catch{}if(!C(s)&&s.constructor===a||a.length===1&&a.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=S;function l(s){let a=[],h=Object.getPrototypeOf(s);for(;Object.prototype!==h;)a=a.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return a}e.getAllPropertyNames=l;function r(s){const a=[];for(const h of l(s))typeof s[h]=="function"&&a.push(h);return a}e.getAllMethodNames=r;function c(s,a){const h=P=>function(){const _=Array.prototype.slice.call(arguments,0);return a(P,_)};let v={};for(const P of s)v[P]=h(P);return v}e.createProxyObject=c;function i(s){return s===null?void 0:s}e.withNullAsUndefined=i;function t(s){return typeof s=="undefined"?null:s}e.withUndefinedAsNull=t;function o(s,a="Unreachable"){throw new Error(a)}e.assertNever=o}),define(ne[41],ie([0,1,10,4,26,14]),function(K,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(o){return o===47||o===92}e.isPathSeparator=A;function R(o){return o.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=R;function b(o){return o.indexOf("/")===-1&&(o=R(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=b;function E(o,s=D.posix.sep){if(!o)return"";const a=o.length,h=o.charCodeAt(0);if(A(h)){if(A(o.charCodeAt(1))&&!A(o.charCodeAt(2))){let P=3;const _=P;for(;P<a&&!A(o.charCodeAt(P));P++);if(_!==P&&!A(o.charCodeAt(P+1))){for(P+=1;P<a;P++)if(A(o.charCodeAt(P)))return o.slice(0,P+1).replace(/[\\/]/g,s)}}return s}else if(g(h)&&o.charCodeAt(1)===58)return A(o.charCodeAt(2))?o.slice(0,2)+s:o.slice(0,2);let v=o.indexOf("://");if(v!==-1){for(v+=3;v<a;v++)if(A(o.charCodeAt(v)))return o.slice(0,v+1)}return""}e.getRoot=E;function I(o){if(!n.isWindows||!o||o.length<5)return!1;let s=o.charCodeAt(0);if(s!==92||(s=o.charCodeAt(1),s!==92))return!1;let a=2;const h=a;for(;a<o.length&&(s=o.charCodeAt(a),s!==92);a++);return!(h===a||(s=o.charCodeAt(a+1),isNaN(s)||s===92))}e.isUNC=I;const C=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(o,s=n.isWindows){const a=s?C:f;return!(!o||o.length===0||/^\s+$/.test(o)||(a.lastIndex=0,a.test(o))||s&&p.test(o)||o==="."||o===".."||s&&o[o.length-1]==="."||s&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=u;function m(o,s,a){const h=o===s;return!a||h?h:!o||!s?!1:(0,L.equalsIgnoreCase)(o,s)}e.isEqual=m;function d(o,s,a,h=D.sep){if(o===s)return!0;if(!o||!s||s.length>o.length)return!1;if(a){if(!(0,L.startsWithIgnoreCase)(o,s))return!1;if(s.length===o.length)return!0;let P=s.length;return s.charAt(s.length-1)===h&&P--,o.charAt(P)===h}return s.charAt(s.length-1)!==h&&(s+=h),o.indexOf(s)===0}e.isEqualOrParent=d;function g(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=g;function w(o,s){return n.isWindows&&o.endsWith(":")&&(o+=D.sep),(0,D.isAbsolute)(o)||(o=(0,D.join)(s,o)),o=(0,D.normalize)(o),n.isWindows?(o=(0,L.rtrim)(o,D.sep),o.endsWith(":")&&(o+=D.sep)):(o=(0,L.rtrim)(o,D.sep),o||(o=D.sep)),o}e.sanitizeFilePath=w;function y(o){const s=(0,D.normalize)(o);return n.isWindows?o.length>3?!1:S(s)&&(o.length===2||s.charCodeAt(2)===92):s===D.posix.sep}e.isRootOrDriveLetter=y;function S(o,s){return(s!==void 0?s:n.isWindows)?g(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=S;function l(o){return S(o)?o[0]:void 0}e.getDriveLetter=l;function r(o,s,a){return s.length>o.length?-1:o===s?0:(a&&(o=o.toLowerCase(),s=s.toLowerCase()),o.indexOf(s))}e.indexOfPath=r;function c(o){const s=o.split(":");let a,h,v;for(const P of s){const _=Number(P);(0,T.isNumber)(_)?h===void 0?h=_:v===void 0&&(v=_):a=a?[a,P].join(":"):P}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:h!==void 0?h:void 0,column:v!==void 0?v:h!==void 0?1:void 0}}e.parseLineAndColumnAware=c;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function t(o,s,a=8){let h="";for(let P=0;P<a;P++)h+=i.charAt(Math.floor(Math.random()*i.length));let v;return s?v=`${s}-${h}`:v=h,o?(0,D.join)(o,v):v}e.randomPath=t}),define(ne[28],ie([0,1,14]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const d=Array.isArray(m)?[]:{};return Object.keys(m).forEach(g=>{m[g]&&typeof m[g]=="object"?d[g]=n(m[g]):d[g]=m[g]}),d}e.deepClone=n;function L(m){if(!m||typeof m!="object")return m;const d=[m];for(;d.length>0;){const g=d.shift();Object.freeze(g);for(const w in g)if(T.call(g,w)){const y=g[w];typeof y=="object"&&!Object.isFrozen(y)&&d.push(y)}}return m}e.deepFreeze=L;const T=Object.prototype.hasOwnProperty;function A(m,d){return R(m,d,new Set)}e.cloneAndChange=A;function R(m,d,g){if((0,D.isUndefinedOrNull)(m))return m;const w=d(m);if(typeof w!="undefined")return w;if((0,D.isArray)(m)){const y=[];for(const S of m)y.push(R(S,d,g));return y}if((0,D.isObject)(m)){if(g.has(m))throw new Error("Cannot clone recursive data-structure");g.add(m);const y={};for(let S in m)T.call(m,S)&&(y[S]=R(m[S],d,g));return g.delete(m),y}return m}function b(m,d,g=!0){return(0,D.isObject)(m)?((0,D.isObject)(d)&&Object.keys(d).forEach(w=>{w in m?g&&((0,D.isObject)(m[w])&&(0,D.isObject)(d[w])?b(m[w],d[w],g):m[w]=d[w]):m[w]=d[w]}),m):d}e.mixin=b;function E(m,d){if(m===d)return!0;if(m==null||d===null||d===void 0||typeof m!=typeof d||typeof m!="object"||Array.isArray(m)!==Array.isArray(d))return!1;let g,w;if(Array.isArray(m)){if(m.length!==d.length)return!1;for(g=0;g<m.length;g++)if(!E(m[g],d[g]))return!1}else{const y=[];for(w in m)y.push(w);y.sort();const S=[];for(w in d)S.push(w);if(S.sort(),!E(y,S))return!1;for(g=0;g<y.length;g++)if(!E(m[y[g]],d[y[g]]))return!1}return!0}e.equals=E;function I(m){const d=new Set;return JSON.stringify(m,(g,w)=>{if((0,D.isObject)(w)||Array.isArray(w)){if(d.has(w))return"[Circular]";d.add(w)}return w})}e.safeStringify=I;function C(m,d,g){const w=d(m);return typeof w=="undefined"?g:w}e.getOrDefault=C;function f(m,d){const g=Object.create(null);return!m||!d||Object.keys(d).forEach(y=>{const S=m[y],l=d[y];E(S,l)||(g[y]=l)}),g}e.distinct=f;function p(m,d){const g=d.toLowerCase(),w=Object.keys(m).find(y=>y.toLowerCase()===g);return w?m[w]:m[d]}e.getCaseInsensitive=p;function u(m,d){const g=Object.create(null);for(const[w,y]of Object.entries(m))d(w,y)&&(g[w]=y);return g}e.filter=u}),define(ne[7],ie([0,1,10,4]),function(K,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,T=/^\//,A=/^\/\//;function R(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!L.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!T.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(i,t){return!i&&!t?"file":i}function E(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==C&&(t=C+t):t=C;break}return t}const I="",C="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(t,o,s,a,h,v=!1){typeof t=="object"?(this.scheme=t.scheme||I,this.authority=t.authority||I,this.path=t.path||I,this.query=t.query||I,this.fragment=t.fragment||I):(this.scheme=b(t,v),this.authority=o||I,this.path=E(this.scheme,s||I),this.query=a||I,this.fragment=h||I,R(this,v))}static isUri(t){return t instanceof p?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return y(this,!1)}with(t){if(!t)return this;let{scheme:o,authority:s,path:a,query:h,fragment:v}=t;return o===void 0?o=this.scheme:o===null&&(o=I),s===void 0?s=this.authority:s===null&&(s=I),a===void 0?a=this.path:a===null&&(a=I),h===void 0?h=this.query:h===null&&(h=I),v===void 0?v=this.fragment:v===null&&(v=I),o===this.scheme&&s===this.authority&&a===this.path&&h===this.query&&v===this.fragment?this:new m(o,s,a,h,v)}static parse(t,o=!1){const s=f.exec(t);return s?new m(s[2]||I,c(s[4]||I),c(s[5]||I),c(s[7]||I),c(s[9]||I),o):new m(I,I,I,I,I)}static file(t){let o=I;if(n.isWindows&&(t=t.replace(/\\/g,C)),t[0]===C&&t[1]===C){const s=t.indexOf(C,2);s===-1?(o=t.substring(2),t=C):(o=t.substring(2,s),t=t.substring(s)||C)}return new m("file",o,t,I,I)}static from(t){const o=new m(t.scheme,t.authority,t.path,t.query,t.fragment);return R(o,!0),o}static joinPath(t,...o){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let s;return n.isWindows&&t.scheme==="file"?s=p.file(D.win32.join(y(t,!0),...o)).path:s=D.posix.join(t.path,...o),t.with({path:s})}toString(t=!1){return S(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof p)return t;{const o=new m(t);return o._formatted=t.external,o._fsPath=t._sep===u?t.fsPath:null,o}}else return t}}e.URI=p;const u=n.isWindows?1:void 0;class m extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(t=!1){return t?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=u),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(i,t){let o,s=-1;for(let a=0;a<i.length;a++){const h=i.charCodeAt(a);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||t&&h===47)s!==-1&&(o+=encodeURIComponent(i.substring(s,a)),s=-1),o!==void 0&&(o+=i.charAt(a));else{o===void 0&&(o=i.substr(0,a));const v=d[h];v!==void 0?(s!==-1&&(o+=encodeURIComponent(i.substring(s,a)),s=-1),o+=v):s===-1&&(s=a)}}return s!==-1&&(o+=encodeURIComponent(i.substring(s))),o!==void 0?o:i}function w(i){let t;for(let o=0;o<i.length;o++){const s=i.charCodeAt(o);s===35||s===63?(t===void 0&&(t=i.substr(0,o)),t+=d[s]):t!==void 0&&(t+=i[o])}return t!==void 0?t:i}function y(i,t){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,n.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=y;function S(i,t){const o=t?w:g;let s="",{scheme:a,authority:h,path:v,query:P,fragment:_}=i;if(a&&(s+=a,s+=":"),(h||a==="file")&&(s+=C,s+=C),h){let O=h.indexOf("@");if(O!==-1){const U=h.substr(0,O);h=h.substr(O+1),O=U.indexOf(":"),O===-1?s+=o(U,!1):(s+=o(U.substr(0,O),!1),s+=":",s+=o(U.substr(O+1),!1)),s+="@"}h=h.toLowerCase(),O=h.indexOf(":"),O===-1?s+=o(h,!1):(s+=o(h.substr(0,O),!1),s+=h.substr(O))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const O=v.charCodeAt(1);O>=65&&O<=90&&(v=`/${String.fromCharCode(O+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const O=v.charCodeAt(0);O>=65&&O<=90&&(v=`${String.fromCharCode(O+32)}:${v.substr(2)}`)}s+=o(v,!0)}return P&&(s+="?",s+=o(P,!1)),_&&(s+="#",s+=t?_:g(_,!1)),s}function l(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+l(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(i){return i.match(r)?i.replace(r,t=>l(t)):i}}),define(ne[107],ie([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(E){const I=E;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=n;function L(E){const I=[];let C;try{const f=JSON.parse(E.arguments),p=f[f.length-1];p&&p.__$stack&&(f.pop(),C=p.__$stack),I.push(...f)}catch{I.push("Unable to log remote console arguments",E.arguments)}return{args:I,stack:C}}e.parse=L;function T(E){if(typeof E!="string")return T(L(E).stack);const I=E;if(I){const C=A(I),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(f&&f.length===4)return{uri:D.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}e.getFirstFrame=T;function A(E){if(!E)return E;const I=E.indexOf(`
`);return I===-1?E:E.substring(0,I)}function R(E,I){const{args:C,stack:f}=L(E),p=typeof C[0]=="string"&&C.length===1;let u=A(f);u&&(u=`(${u.trim()})`);let m=[];if(typeof C[0]=="string"?u&&p?m=[`%c[${I}] %c${C[0]} %c${u}`,b("blue"),b(""),b("grey")]:m=[`%c[${I}] %c${C[0]}`,b("blue"),b(""),...C.slice(1)]:m=[`%c[${I}]%`,b("blue"),...C],u&&!p&&m.push(u),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,m)}e.log=R;function b(E){return`color: ${E}`}}),define(ne[108],ie([0,1,17,26,7]),function(K,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(I){return JSON.stringify(I,b)}e.stringify=T;function A(I){let C=JSON.parse(I);return C=E(C),C}e.parse=A;var R;(function(I){I[I.Uri=1]="Uri",I[I.Regexp=2]="Regexp",I[I.ScmResource=3]="ScmResource",I[I.ScmResourceGroup=4]="ScmResourceGroup",I[I.ScmProvider=5]="ScmProvider",I[I.CommentController=6]="CommentController",I[I.CommentThread=7]="CommentThread",I[I.CommentThreadReply=8]="CommentThreadReply",I[I.CommentNode=9]="CommentNode",I[I.CommentThreadNode=10]="CommentThreadNode",I[I.TimelineActionContext=11]="TimelineActionContext",I[I.NotebookCellActionContext=12]="NotebookCellActionContext",I[I.TestItemContext=13]="TestItemContext",I[I.Date=14]="Date"})(R=e.MarshalledId||(e.MarshalledId={}));function b(I,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,n.regExpFlags)(C)}:C}function E(I,C=0){if(!I||C>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return L.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 14:return new Date(I.source)}if(I instanceof D.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let f=0;f<I.length;++f)I[f]=E(I[f],C+1);else for(const f in I)Object.hasOwnProperty.call(I,f)&&(I[f]=E(I[f],C+1))}return I}e.revive=E}),define(ne[18],ie([0,1,4,7]),function(K,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var L;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractive="vscode-interactive",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp",R.vsls="vsls"})(L=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}set(b,E,I){this._hosts[b]=E,this._ports[b]=I}setConnectionToken(b,E){this._connectionTokens[b]=E}rewrite(b){if(this._delegate)return this._delegate(b);const E=b.authority;let I=this._hosts[E];I&&I.indexOf(":")!==-1&&(I=`[${I}]`);const C=this._ports[E],f=this._connectionTokens[E];let p=`path=${encodeURIComponent(b.path)}`;return typeof f=="string"&&(p+=`&tkn=${encodeURIComponent(f)}`),n.URI.from({scheme:D.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${I}:${C}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new T;class A{asBrowserUri(b,E){const I=this.toUri(b,E);return I.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===L.file&&(D.isNative||typeof D.globals.importScripts=="function"&&D.globals.origin===`${L.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?I.with({scheme:L.vscodeFileResource,authority:I.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(b,E){const I=this.toUri(b,E);return I.scheme===L.vscodeFileResource?I.with({scheme:L.file,authority:I.authority!==A.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(b,E){return n.URI.isUri(b)?b:n.URI.parse(E.toUrl(b))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(ne[19],ie([0,1,41,18,10,4,26,7]),function(K,e,D,n,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(p){return(0,R.uriToFsPath)(p,!0)}e.originalFSPath=b;class E{constructor(u){this._ignorePathCasing=u}compare(u,m,d=!1){return u===m?0:(0,A.compare)(this.getComparisonKey(u,d),this.getComparisonKey(m,d))}isEqual(u,m,d=!1){return u===m?!0:!u||!m?!1:this.getComparisonKey(u,d)===this.getComparisonKey(m,d)}getComparisonKey(u,m=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,m,d=!1){if(u.scheme===m.scheme){if(u.scheme===n.Schemas.file)return D.isEqualOrParent(b(u),b(m),this._ignorePathCasing(u))&&u.query===m.query&&(d||u.fragment===m.fragment);if((0,e.isEqualAuthority)(u.authority,m.authority))return D.isEqualOrParent(u.path,m.path,this._ignorePathCasing(u),"/")&&u.query===m.query&&(d||u.fragment===m.fragment)}return!1}joinPath(u,...m){return R.URI.joinPath(u,...m)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return L.posix.basename(u.path)}extname(u){return L.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let m;return u.scheme===n.Schemas.file?m=R.URI.file(L.dirname(b(u))).path:(m=L.posix.dirname(u.path),u.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),m="/")),u.with({path:m})}normalizePath(u){if(!u.path.length)return u;let m;return u.scheme===n.Schemas.file?m=R.URI.file(L.normalize(b(u))).path:m=L.posix.normalize(u.path),u.with({path:m})}relativePath(u,m){if(u.scheme!==m.scheme||!(0,e.isEqualAuthority)(u.authority,m.authority))return;if(u.scheme===n.Schemas.file){const w=L.relative(b(u),b(m));return T.isWindows?D.toSlashes(w):w}let d=u.path||"/",g=m.path||"/";if(this._ignorePathCasing(u)){let w=0;for(const y=Math.min(d.length,g.length);w<y&&!(d.charCodeAt(w)!==g.charCodeAt(w)&&d.charAt(w).toLowerCase()!==g.charAt(w).toLowerCase());w++);d=g.substr(0,w)+d.substr(w)}return L.posix.relative(d,g)}resolvePath(u,m){if(u.scheme===n.Schemas.file){const d=R.URI.file(L.resolve(b(u),m));return u.with({authority:d.authority,path:d.path})}return m=D.toPosixPath(m),u.with({path:L.posix.resolve(u.path,m)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,m){return u===m||u!==void 0&&m!==void 0&&(0,A.equalsIgnoreCase)(u,m)}hasTrailingPathSeparator(u,m=L.sep){if(u.scheme===n.Schemas.file){const d=b(u);return d.length>D.getRoot(d).length&&d[d.length-1]===m}else{const d=u.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,m=L.sep){return(0,e.hasTrailingPathSeparator)(u,m)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,m=L.sep){let d=!1;if(u.scheme===n.Schemas.file){const g=b(u);d=g!==void 0&&g.length===D.getRoot(g).length&&g[g.length-1]===m}else{m="/";const g=u.path;d=g.length===1&&g.charCodeAt(g.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(u,m)?u.with({path:u.path+"/"}):u}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(p=>p.scheme===n.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new E(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(p,u){const m=[];for(let d=0;d<p.length;d++){const g=u(p[d]);p.some((w,y)=>y===d?!1:(0,e.isEqualOrParent)(g,u(w)))||m.push(p[d])}return m}e.distinctParents=I;var C;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function u(m){const d=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(y=>{const[S,l]=y.split(":");S&&l&&d.set(S,l)});const w=m.path.substring(0,m.path.indexOf(";"));return w&&d.set(p.META_DATA_MIME,w),d}p.parseMetaData=u})(C=e.DataUri||(e.DataUri={}));function f(p,u,m){if(u){let d=p.path;return d&&d[0]!==L.posix.sep&&(d=L.posix.sep+d),p.with({scheme:m,authority:u,path:d})}return p.with({scheme:m})}e.toLocalResource=f}),define(ne[5],ie([0,1,23,9,3,2,19,4]),function(K,e,D,n,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(W){return!!W&&typeof W.then=="function"}e.isThenable=b;function E(W){const $=new D.CancellationTokenSource,x=W($.token),z=new Promise((B,te)=>{const se=$.token.onCancellationRequested(()=>{se.dispose(),$.dispose(),te(new n.CancellationError)});Promise.resolve(x).then(ce=>{se.dispose(),$.dispose(),B(ce)},ce=>{se.dispose(),$.dispose(),te(ce)})});return new class{cancel(){$.cancel()}then(B,te){return z.then(B,te)}catch(B){return this.then(void 0,B)}finally(B){return z.finally(B)}}}e.createCancelablePromise=E;function I(W,$,x){return new Promise((z,B)=>{const te=$.onCancellationRequested(()=>{te.dispose(),z(x)});W.then(z,B).finally(()=>te.dispose())})}e.raceCancellation=I;function C(W,$){return new Promise((x,z)=>{const B=$.onCancellationRequested(()=>{B.dispose(),z(new n.CancellationError)});W.then(x,z).finally(()=>B.dispose())})}e.raceCancellationError=C;async function f(W){let $=-1;const x=W.map((B,te)=>B.then(se=>($=te,se))),z=await Promise.race(x);return W.forEach((B,te)=>{te!==$&&B.cancel()}),z}e.raceCancellablePromises=f;function p(W,$,x){let z;const B=setTimeout(()=>{z?.(void 0),x?.()},$);return Promise.race([W.finally(()=>clearTimeout(B)),new Promise(te=>z=te)])}e.raceTimeout=p;function u(W){return new Promise(($,x)=>{const z=W();b(z)?z.then($,x):$(z)})}e.asPromise=u;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue($){if(this.activePromise){if(this.queuedPromiseFactory=$,!this.queuedPromise){const x=()=>{this.queuedPromise=null;const z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,z};this.queuedPromise=new Promise(z=>{this.activePromise.then(x,x).then(z)})}return new Promise((x,z)=>{this.queuedPromise.then(x,z)})}return this.activePromise=$(),new Promise((x,z)=>{this.activePromise.then(B=>{this.activePromise=null,x(B)},B=>{this.activePromise=null,z(B)})})}}e.Throttler=m;class d{constructor(){this.current=Promise.resolve(null)}queue($){return this.current=this.current.then(()=>$(),()=>$())}}e.Sequencer=d;class g{constructor(){this.promiseMap=new Map}queue($,x){const B=(this.promiseMap.get($)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.promiseMap.get($)===B&&this.promiseMap.delete($)});return this.promiseMap.set($,B),B}}e.SequencerByKey=g;const w=(W,$)=>{let x=!0;const z=setTimeout(()=>{x=!1,$()},W);return{isTriggered:()=>x,dispose:()=>{clearTimeout(z),x=!1}}},y=W=>{let $=!0;return queueMicrotask(()=>{$&&($=!1,W())}),{isTriggered:()=>$,dispose:()=>{$=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class S{constructor($){this.defaultDelay=$,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger($,x=this.defaultDelay){this.task=$,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,te)=>{this.doResolve=B,this.doReject=te}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}}));const z=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=x===e.MicrotaskDelay?y(z):w(x,z),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=S;class l{constructor($){this.delayer=new S($),this.throttler=new m}trigger($,x){return this.delayer.trigger(()=>this.throttler.queue($),x)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class r{constructor(){this._isOpen=!1,this._promise=new Promise(($,x)=>{this._completePromise=$})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class c extends r{constructor($){super();this._timeout=setTimeout(()=>this.open(),$)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function i(W,$){return $?new Promise((x,z)=>{const B=setTimeout(()=>{te.dispose(),x()},W),te=$.onCancellationRequested(()=>{clearTimeout(B),te.dispose(),z(new n.CancellationError)})}):E(x=>i(W,x))}e.timeout=i;function t(W,$=0){const x=setTimeout(W,$);return(0,T.toDisposable)(()=>clearTimeout(x))}e.disposableTimeout=t;function o(W){const $=[];let x=0;const z=W.length;function B(){return x<z?W[x++]():null}function te(se){se!=null&&$.push(se);const ce=B();return ce?ce.then(te):Promise.resolve($)}return Promise.resolve(null).then(te)}e.sequence=o;function s(W,$=z=>!!z,x=null){let z=0;const B=W.length,te=()=>{if(z>=B)return Promise.resolve(x);const se=W[z++];return Promise.resolve(se()).then(he=>$(he)?Promise.resolve(he):te())};return te()}e.first=s;function a(W,$=z=>!!z,x=null){if(W.length===0)return Promise.resolve(x);let z=W.length;const B=()=>{z=-1;for(const te of W)te.cancel?.()};return new Promise((te,se)=>{for(const ce of W)ce.then(he=>{--z>=0&&$(he)?(B(),te(he)):z===0&&te(x)}).catch(he=>{--z>=0&&(B(),se(he))})})}e.firstParallel=a;class h{constructor($){this._size=0,this.maxDegreeOfParalellism=$,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new L.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue($){return this._size++,new Promise((x,z)=>{this.outstandingPromises.push({factory:$,c:x,e:z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const $=this.outstandingPromises.shift();this.runningPromises++;const x=$.factory();x.then($.c,$.e),x.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=h;class v extends h{constructor(){super(1)}}e.Queue=v;class P{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const $=new j;return this.drainers.add($),$.p}isDrained(){for(const[,$]of this.queues)if($.size>0)return!1;return!0}queueFor($,x=A.extUri){const z=x.getComparisonKey($);let B=this.queues.get(z);return B||(B=new v,L.Event.once(B.onFinished)(()=>{B?.dispose(),this.queues.delete(z),this.onDidQueueFinish()}),this.queues.set(z,B)),B}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const $ of this.drainers)$.complete();this.drainers.clear()}dispose(){for(const[,$]of this.queues)$.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=P;class _{constructor($,x){this._token=-1,typeof $=="function"&&typeof x=="number"&&this.setIfNotSet($,x)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet($,x){this.cancel(),this._token=setTimeout(()=>{this._token=-1,$()},x)}setIfNotSet($,x){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,$()},x))}}e.TimeoutTimer=_;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet($,x){this.cancel(),this._token=setInterval(()=>{$()},x)}}e.IntervalTimer=O;class U{constructor($,x){this.timeoutToken=-1,this.runner=$,this.timeout=x,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule($=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,$)}get delay(){return this.timeout}set delay($){this.timeout=$}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=U;class k{constructor($,x){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.runner=$,this.timeout=x,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule($=this.timeout){$%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil($/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=k;class M extends U{constructor($,x){super($,x);this.units=[]}work($){this.units.push($),this.isScheduled()||this.schedule()}doRun(){const $=this.units;this.units=[],this.runner&&this.runner($)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=M;class F extends T.Disposable{constructor($,x){super();this.options=$,this.handler=x,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work($){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+$.length>this.options.maxBufferedWork)return!1}else if(this.pending+$.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...$),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new U(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=F,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=W=>{(0,R.setTimeout0)(()=>{if($)return;const x=Date.now()+15;W(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,x-Date.now())}}))});let $=!1;return{dispose(){$||($=!0)}}}:e.runWhenIdle=(W,$)=>{const x=requestIdleCallback(W,typeof $=="number"?{timeout:$}:void 0);let z=!1;return{dispose(){z||(z=!0,cancelIdleCallback(x))}}}}();class V{constructor($){this._didRun=!1,this._executor=()=>{try{this._value=$()}catch(x){this._error=x}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=V;async function N(W,$,x){let z;for(let B=0;B<x;B++)try{return await W()}catch(te){z=te,await i($)}throw z}e.retry=N;class G{hasPending($){return this._pending?typeof $=="number"?this._pending.taskId===$:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending($,x,z){return this._pending={taskId:$,cancel:()=>z?.(),promise:x},x.then(()=>this.donePending($),()=>this.donePending($)),x}donePending($){this._pending&&$===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const $=this._next;this._next=void 0,$.run().then($.promiseResolve,$.promiseReject)}}setNext($){if(this._next)this._next.run=$;else{let x,z;const B=new Promise((te,se)=>{x=te,z=se});this._next={run:$,promise:B,promiseResolve:x,promiseReject:z}}return this._next.promise}}e.TaskSequentializer=G;class J{constructor($,x=()=>Date.now()){this.interval=$,this.nowFn=x,this.lastIncrementTime=0,this.value=0}increment(){const $=this.nowFn();return $-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=$,this.value=0),this.value++,this.value}}e.IntervalCounter=J;class j{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise(($,x)=>{this.completeCallback=$,this.errorCallback=x})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete($){return new Promise(x=>{this.completeCallback($),this.resolved=!0,x()})}error($){return new Promise(x=>{this.errorCallback($),this.rejected=!0,x()})}cancel(){new Promise($=>{this.errorCallback(new n.CancellationError),this.rejected=!0,$()})}}e.DeferredPromise=j;var q;(function(W){async function $(z){let B;const te=await Promise.all(z.map(se=>se.then(ce=>ce,ce=>{B||(B=ce)})));if(typeof B!="undefined")throw B;return te}W.settled=$;function x(z){return new Promise(async(B,te)=>{try{await z(B,te)}catch(se){te(se)}})}W.withAsyncBody=x})(q=e.Promises||(e.Promises={}));var X;(function(W){W[W.Initial=0]="Initial",W[W.DoneOK=1]="DoneOK",W[W.DoneError=2]="DoneError"})(X||(X={}));class H{constructor($){this._state=0,this._results=[],this._error=null,this._onStateChanged=new L.Emitter,queueMicrotask(async()=>{const x={emitOne:z=>this.emitOne(z),emitMany:z=>this.emitMany(z),reject:z=>this.reject(z)};try{await Promise.resolve($(x)),this.resolve()}catch(z){this.reject(z)}finally{x.emitOne=void 0,x.emitMany=void 0,x.reject=void 0}})}static fromArray($){return new H(x=>{x.emitMany($)})}static fromPromise($){return new H(async x=>{x.emitMany(await $)})}static fromPromises($){return new H(async x=>{await Promise.all($.map(async z=>x.emitOne(await z)))})}static merge($){return new H(async x=>{await Promise.all($.map(async z=>{for await(const B of z)x.emitOne(B)}))})}[Symbol.asyncIterator](){let $=0;return{next:async()=>{do{if(this._state===2)throw this._error;if($<this._results.length)return{done:!1,value:this._results[$++]};if(this._state===1)return{done:!0,value:void 0};await L.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map($,x){return new H(async z=>{for await(const B of $)z.emitOne(x(B))})}map($){return H.map(this,$)}static filter($,x){return new H(async z=>{for await(const B of $)x(B)&&z.emitOne(B)})}filter($){return H.filter(this,$)}static coalesce($){return H.filter($,x=>!!x)}coalesce(){return H.coalesce(this)}static async toPromise($){const x=[];for await(const z of $)x.push(z);return x}toPromise(){return H.toPromise(this)}emitOne($){this._state===0&&(this._results.push($),this._onStateChanged.fire())}emitMany($){this._state===0&&(this._results=this._results.concat($),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject($){this._state===0&&(this._state=2,this._error=$,this._onStateChanged.fire())}}e.AsyncIterableObject=H,H.EMPTY=H.fromArray([]);class Z extends H{constructor($,x){super(x);this._source=$}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Z;function ee(W){const $=new D.CancellationTokenSource,x=W($.token);return new Z($,async z=>{const B=$.token.onCancellationRequested(()=>{B.dispose(),$.dispose(),z.reject(new n.CancellationError)});try{for await(const te of x){if($.token.isCancellationRequested)return;z.emitOne(te)}B.dispose(),$.dispose()}catch(te){B.dispose(),$.dispose(),z.reject(te)}})}e.createCancelableAsyncIterable=ee}),define(ne[109],ie([0,1,5,41,39,10,26]),function(K,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function R(){return Object.create(null)}e.getEmptyExpression=R,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const b="[/\\\\]",E="[^/\\\\]",I=/\//g;function C(J){switch(J){case 0:return"";case 1:return`${E}*?`;default:return`(?:${b}|${E}+${b}|${b}${E}+)*?`}}function f(J,j){if(!J)return[];const q=[];let X=!1,H=!1,Z="";for(const ee of J){switch(ee){case j:if(!X&&!H){q.push(Z),Z="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":H=!0;break;case"]":H=!1;break}Z+=ee}return Z&&q.push(Z),q}e.splitGlobAware=f;function p(J){if(!J)return"";let j="";const q=f(J,e.GLOB_SPLIT);if(q.every(X=>X===e.GLOBSTAR))j=".*";else{let X=!1;q.forEach((H,Z)=>{if(H===e.GLOBSTAR){X||(j+=C(2),X=!0);return}let ee=!1,W="",$=!1,x="";for(const z of H){if(z!=="}"&&ee){W+=z;continue}if($&&(z!=="]"||!x)){let B;z==="-"?B=z:(z==="^"||z==="!")&&!x?B="^":z===e.GLOB_SPLIT?B="":B=A.escapeRegExpCharacters(z),x+=B;continue}switch(z){case"{":ee=!0;continue;case"[":$=!0;continue;case"}":{j+=`(?:${f(W,",").map(se=>p(se)).join("|")})`,ee=!1,W="";break}case"]":j+="["+x+"]",$=!1,x="";break;case"?":j+=E;continue;case"*":j+=C(1);continue;default:j+=A.escapeRegExpCharacters(z)}}Z<q.length-1&&(q[Z+1]!==e.GLOBSTAR||Z+2<q.length)&&(j+=b),X=!1})}return j}const u=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,g=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,y=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,S=new L.LRUCache(1e4),l=function(){return!1},r=function(){return null};function c(J,j){if(!J)return r;let q;typeof J!="string"?q=J.pattern:q=J,q=q.trim();const X=`${q}_${!!j.trimForExclusions}`;let H=S.get(X);if(H)return i(H,J);let Z;if(u.test(q)){const ee=q.substr(4);H=function(W,$){return typeof W=="string"&&W.endsWith(ee)?q:null}}else(Z=m.exec(t(q,j)))?H=o(Z[1],q):(j.trimForExclusions?g:d).test(q)?H=s(q,j):(Z=w.exec(t(q,j)))?H=a(Z[1].substr(1),q,!0):(Z=y.exec(t(q,j)))?H=a(Z[1],q,!1):H=h(q);return S.set(X,H),i(H,J)}function i(J,j){return typeof j=="string"?J:function(q,X){return n.isEqualOrParent(q,j.base)?J(T.relative(j.base,q),X):null}}function t(J,j){return j.trimForExclusions&&J.endsWith("/**")?J.substr(0,J.length-2):J}function o(J,j){const q=`/${J}`,X=`\\${J}`,H=function(ee,W){return typeof ee!="string"?null:W?W===J?j:null:ee===J||ee.endsWith(q)||ee.endsWith(X)?j:null},Z=[J];return H.basenames=Z,H.patterns=[j],H.allBasenames=Z,H}function s(J,j){const q=G(J.slice(1,-1).split(",").map(W=>c(W,j)).filter(W=>W!==r),J),X=q.length;if(!X)return r;if(X===1)return q[0];const H=function(W,$){for(let x=0,z=q.length;x<z;x++)if(q[x](W,$))return J;return null},Z=q.find(W=>!!W.allBasenames);Z&&(H.allBasenames=Z.allBasenames);const ee=q.reduce((W,$)=>$.allPaths?W.concat($.allPaths):W,[]);return ee.length&&(H.allPaths=ee),H}function a(J,j,q){const X=T.sep===T.posix.sep,H=X?J:J.replace(I,T.sep),Z=T.sep+H,ee=T.posix.sep+J,W=q?function($,x){return typeof $=="string"&&($===H||$.endsWith(Z)||!X&&($===J||$.endsWith(ee)))?j:null}:function($,x){return typeof $=="string"&&($===H||!X&&$===J)?j:null};return W.allPaths=[(q?"*/":"./")+J],W}function h(J){try{const j=new RegExp(`^${p(J)}$`);return function(q){return j.lastIndex=0,typeof q=="string"&&j.test(q)?J:null}}catch{return r}}function v(J,j,q){return!J||typeof j!="string"?!1:P(J)(j,void 0,q)}e.match=v;function P(J,j={}){if(!J)return l;if(typeof J=="string"||k(J)){const q=c(J,j);if(q===r)return l;const X=function(H,Z){return!!q(H,Z)};return q.allBasenames&&(X.allBasenames=q.allBasenames),q.allPaths&&(X.allPaths=q.allPaths),X}return V(J,j)}e.parse=P;function _(J){if(!J)return;let j;return q=>(j||(j=(J()||Promise.resolve([])).then(X=>X?U(X):{})),j.then(X=>!!X[q]))}e.hasSiblingPromiseFn=_;function O(J){if(!J)return;let j;return q=>{if(!j){const X=J();j=X?U(X):{}}return!!j[q]}}e.hasSiblingFn=O;function U(J){const j={};for(const q of J)j[q]=!0;return j}function k(J){const j=J;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}e.isRelativePattern=k;function M(J){return J.allBasenames||[]}e.getBasenameTerms=M;function F(J){return J.allPaths||[]}e.getPathTerms=F;function V(J,j){const q=G(Object.getOwnPropertyNames(J).map(W=>N(W,J[W],j)).filter(W=>W!==r)),X=q.length;if(!X)return r;if(!q.some(W=>!!W.requiresSiblings)){if(X===1)return q[0];const W=function(z,B){for(let te=0,se=q.length;te<se;te++){const ce=q[te](z,B);if(ce)return ce}return null},$=q.find(z=>!!z.allBasenames);$&&(W.allBasenames=$.allBasenames);const x=q.reduce((z,B)=>B.allPaths?z.concat(B.allPaths):z,[]);return x.length&&(W.allPaths=x),W}const H=function(W,$,x){let z;for(let B=0,te=q.length;B<te;B++){const se=q[B];se.requiresSiblings&&x&&($||($=T.basename(W)),z||(z=$.substr(0,$.length-T.extname(W).length)));const ce=se(W,$,z,x);if(ce)return ce}return null},Z=q.find(W=>!!W.allBasenames);Z&&(H.allBasenames=Z.allBasenames);const ee=q.reduce((W,$)=>$.allPaths?W.concat($.allPaths):W,[]);return ee.length&&(H.allPaths=ee),H}function N(J,j,q){if(j===!1)return r;const X=c(J,q);if(X===r)return r;if(typeof j=="boolean")return X;if(j){const H=j.when;if(typeof H=="string"){const Z=(ee,W,$,x)=>{if(!x||!X(ee,W))return null;const z=H.replace("$(basename)",$),B=x(z);return(0,D.isThenable)(B)?B.then(te=>te?J:null):B?J:null};return Z.requiresSiblings=!0,Z}}return X}function G(J,j){const q=J.filter(W=>!!W.basenames);if(q.length<2)return J;const X=q.reduce((W,$)=>{const x=$.basenames;return x?W.concat(x):W},[]);let H;if(j){H=[];for(let W=0,$=X.length;W<$;W++)H.push(j)}else H=q.reduce((W,$)=>{const x=$.patterns;return x?W.concat(x):W},[]);const Z=function(W,$){if(typeof W!="string")return null;if(!$){let z;for(z=W.length;z>0;z--){const B=W.charCodeAt(z-1);if(B===47||B===92)break}$=W.substr(z)}const x=X.indexOf($);return x!==-1?H[x]:null};Z.basenames=X,Z.patterns=H,Z.allBasenames=X;const ee=J.filter(W=>!W.basenames);return ee.push(Z),ee}}),define(ne[110],ie([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(I){return I.toJSON()}class L{constructor(C){this._uriTransformer=C}transformIncoming(C){const f=this._uriTransformer.transformIncoming(C);return f===C?C:n(D.URI.from(f))}transformOutgoing(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:n(D.URI.from(f))}transformOutgoingURI(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:D.URI.from(f)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function T(I,C,f){if(!I||f>200)return null;if(typeof I=="object"){if(I instanceof D.URI)return C.transformOutgoing(I);for(let p in I)if(Object.hasOwnProperty.call(I,p)){const u=T(I[p],C,f+1);u!==null&&(I[p]=u)}}return null}function A(I,C){const f=T(I,C,0);return f===null?I:f}e.transformOutgoingURIs=A;function R(I,C,f,p){if(!I||p>200)return null;if(typeof I=="object"){if(I.$mid===1)return f?D.URI.revive(C.transformIncoming(I)):C.transformIncoming(I);for(let u in I)if(Object.hasOwnProperty.call(I,u)){const m=R(I[u],C,f,p+1);m!==null&&(I[u]=m)}}return null}function b(I,C){const f=R(I,C,!1,0);return f===null?I:f}e.transformIncomingURIs=b;function E(I,C){const f=R(I,C,!0,0);return f===null?I:f}e.transformAndReviveIncomingURIs=E}),define(ne[29],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(b){return D.test(b)}e.isUUID=n;const L=new Uint8Array(16),T=[];for(let b=0;b<256;b++)T.push(b.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(b){for(let E=0;E<b.length;E++)b[E]=Math.floor(Math.random()*256);return b};function R(){A(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let b=0,E="";return E+=T[L[b++]],E+=T[L[b++]],E+=T[L[b++]],E+=T[L[b++]],E+="-",E+=T[L[b++]],E+=T[L[b++]],E+="-",E+=T[L[b++]],E+=T[L[b++]],E+="-",E+=T[L[b++]],E+=T[L[b++]],E+="-",E+=T[L[b++]],E+=T[L[b++]],E+=T[L[b++]],E+=T[L[b++]],E+=T[L[b++]],E+=T[L[b++]],E}e.generateUuid=R}),define(ne[111],ie([0,1,249]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(T="utf8"){this.stringDecoder=new D.StringDecoder(T),this.remaining=null}write(T){const A=[],R=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(R.length<1)return A;let b=0,E,I=b;for(;I<R.length;)if(E=R.charCodeAt(I),E===13||E===10){if(A.push(R.substring(b,I)),I++,I<R.length){const C=E;E=R.charCodeAt(I),(C===13&&E===10||C===10&&E===13)&&I++}b=I}else I++;return this.remaining=b<R.length?R.substr(b):null,A}end(){return this.remaining}}e.LineDecoder=n}),define(ne[112],ie([0,1,33]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(A){const R=A.replace(/\-/g,":").toLowerCase();return!n.has(R)}function T(){const A=(0,D.networkInterfaces)();for(let R in A){const b=A[R];if(b){for(const{mac:E}of b)if(L(E))return E}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(ne[113],ie([0,1,33,9,39,29,112]),function(K,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,C=0;const f=(0,D.networkInterfaces)();for(let p in f){const u=f[p];if(u)for(const{mac:m,internal:d}of u)d||(C+=1,this._isVirtualMachineMacAddress(m.toUpperCase())&&(I+=1))}this._value=C>0?I/C:0}return this._value}};let R;async function b(){return R||(R=(async()=>await E()||T.generateUuid())()),R}e.getMachineId=b;async function E(){try{const I=await new Promise((f,p)=>{K(["crypto"],f,p)}),C=(0,A.getMac)();return I.createHash("sha256").update(C,"utf8").digest("hex")}catch(I){n.onUnexpectedError(I);return}}}),define(ne[22],ie([0,1,50,33,250,5,41,71,10,4,19,7]),function(K,e,D,n,L,T,A,R,b,E,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var f;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function p(F,V=f.UNLINK){if((0,A.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return V===f.UNLINK?m(F):u(F)}async function u(F){try{const V=(0,A.randomPath)((0,n.tmpdir)());try{await D.promises.rename(F,V)}catch{return m(F)}m(V).catch(N=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function m(F){return(0,L.promisify)(D.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function d(F){if((0,A.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function g(F,V){return S(await(V?w(F):(0,L.promisify)(D.readdir)(F)))}async function w(F){try{return await(0,L.promisify)(D.readdir)(F,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const V=[],N=await g(F);for(const G of N){let J=!1,j=!1,q=!1;try{const X=await e.Promises.lstat((0,b.join)(F,G));J=X.isFile(),j=X.isDirectory(),q=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}V.push({name:G,isFile:()=>J,isDirectory:()=>j,isSymbolicLink:()=>q})}return V}function y(F){return S(D.readdirSync(F))}e.readdirSync=y;function S(F){return F.map(V=>typeof V=="string"?E.isMacintosh?(0,R.normalizeNFC)(V):V:(V.name=E.isMacintosh?(0,R.normalizeNFC)(V.name):V.name,V))}async function l(F){const V=await g(F),N=[];for(const G of V)await c.existsDirectory((0,b.join)(F,G))&&N.push(G);return N}function r(F,V=1e3){return new Promise(N=>{let G=!1;const J=setInterval(()=>{G||(G=!0,D.access(F,j=>{G=!1,j&&(clearInterval(J),N(void 0))}))},V)})}e.whenDeleted=r;var c;(function(F){async function V(J){let j;try{if(j=await e.Promises.lstat(J),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await e.Promises.stat(J),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(E.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(J)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw X}throw q}}F.stat=V;async function N(J){try{const{stat:j,symbolicLink:q}=await F.stat(J);return j.isFile()&&q?.dangling!==!0}catch{}return!1}F.existsFile=N;async function G(J){try{const{stat:j,symbolicLink:q}=await F.stat(J);return j.isDirectory()&&q?.dangling!==!0}catch{}return!1}F.existsDirectory=G})(c=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new T.ResourceQueue;function t(F,V,N){return i.queueFor(C.URI.file(F),I.extUriBiasedIgnorePathCase).queue(()=>{const G=h(N);return new Promise((J,j)=>s(F,V,G,q=>q?j(q):J()))})}let o=!0;function s(F,V,N,G){if(!o)return D.writeFile(F,V,{mode:N.mode,flag:N.flag},G);D.open(F,N.flag,N.mode,(J,j)=>{if(J)return G(J);D.writeFile(j,V,q=>{if(q)return D.close(j,()=>G(q));D.fdatasync(j,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),o=!1),D.close(j,H=>G(H))))})})}function a(F,V,N){const G=h(N);if(!o)return D.writeFileSync(F,V,{mode:G.mode,flag:G.flag});const J=D.openSync(F,G.flag,G.mode);try{D.writeFileSync(J,V);try{D.fdatasyncSync(J)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),o=!1}}finally{D.closeSync(J)}}e.writeFileSync=a;function h(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function v(F,V){if(F===V)return;async function N(G){try{const J=await e.Promises.lstat(G);if(J.isDirectory()||J.isSymbolicLink())return;await e.Promises.utimes(G,J.atime,new Date)}catch{}}try{await e.Promises.rename(F,V),await N(V)}catch(G){if(F.toLowerCase()!==V.toLowerCase()&&G.code==="EXDEV"||F.endsWith("."))await P(F,V,{preserveSymlinks:!1}),await p(F,f.MOVE),await N(V);else throw G}}async function P(F,V,N){return O(F,V,{root:{source:F,target:V},options:N,handledSourcePaths:new Set})}const _=511;async function O(F,V,N){if(N.handledSourcePaths.has(F))return;N.handledSourcePaths.add(F);const{stat:G,symbolicLink:J}=await c.stat(F);if(J){if(N.options.preserveSymlinks)try{return await M(F,V,N)}catch(j){console.warn("[node.js fs] copy of symlink failed: ",j)}if(J.dangling)return}return G.isDirectory()?U(F,V,G.mode&_,N):k(F,V,G.mode&_)}async function U(F,V,N,G){await e.Promises.mkdir(V,{recursive:!0,mode:N});const J=await g(F);for(const j of J)await O((0,b.join)(F,j),(0,b.join)(V,j),G)}async function k(F,V,N){await e.Promises.copyFile(F,V),await e.Promises.chmod(V,N)}async function M(F,V,N){let G=await e.Promises.readlink(F);(0,A.isEqualOrParent)(G,N.root.source,!E.isLinux)&&(G=(0,b.join)(N.root.target,G.substr(N.root.source.length+1))),await e.Promises.symlink(G,V)}e.Promises=new class{get access(){return(0,L.promisify)(D.access)}get stat(){return(0,L.promisify)(D.stat)}get lstat(){return(0,L.promisify)(D.lstat)}get utimes(){return(0,L.promisify)(D.utimes)}get read(){return(F,V,N,G,J)=>new Promise((j,q)=>{D.read(F,V,N,G,J,(X,H,Z)=>X?q(X):j({bytesRead:H,buffer:Z}))})}get readFile(){return(0,L.promisify)(D.readFile)}get write(){return(F,V,N,G,J)=>new Promise((j,q)=>{D.write(F,V,N,G,J,(X,H,Z)=>X?q(X):j({bytesWritten:H,buffer:Z}))})}get appendFile(){return(0,L.promisify)(D.appendFile)}get fdatasync(){return(0,L.promisify)(D.fdatasync)}get truncate(){return(0,L.promisify)(D.truncate)}get rename(){return(0,L.promisify)(D.rename)}get copyFile(){return(0,L.promisify)(D.copyFile)}get open(){return(0,L.promisify)(D.open)}get close(){return(0,L.promisify)(D.close)}get symlink(){return(0,L.promisify)(D.symlink)}get readlink(){return(0,L.promisify)(D.readlink)}get chmod(){return(0,L.promisify)(D.chmod)}get mkdir(){return(0,L.promisify)(D.mkdir)}get unlink(){return(0,L.promisify)(D.unlink)}get rmdir(){return(0,L.promisify)(D.rmdir)}get realpath(){return(0,L.promisify)(D.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return l}get writeFile(){return t}get rm(){return p}get move(){return v}get copy(){return P}}}),define(ne[114],ie([0,1,50,10,4,26,22]),function(K,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(f){if(L.isLinux)return f;const p=(0,n.dirname)(f);if(f===p)return f;const u=((0,n.basename)(f)||f).toLowerCase();try{const d=(0,A.readdirSync)(p).filter(g=>g.toLowerCase()===u);if(d.length===1){const g=R(p);if(g)return(0,n.join)(g,d[0])}else if(d.length>1){const g=d.indexOf(u);if(g>=0){const w=R(p);if(w)return(0,n.join)(w,d[g])}}}catch{}return null}e.realcaseSync=R;async function b(f){if(L.isLinux)return f;const p=(0,n.dirname)(f);if(f===p)return f;const u=((0,n.basename)(f)||f).toLowerCase();try{const d=(await A.Promises.readdir(p)).filter(g=>g.toLowerCase()===u);if(d.length===1){const g=await b(p);if(g)return(0,n.join)(g,d[0])}else if(d.length>1){const g=d.indexOf(u);if(g>=0){const w=await b(p);if(w)return(0,n.join)(w,d[g])}}}catch{}return null}e.realcase=b;async function E(f){try{return await A.Promises.realpath(f)}catch{const u=C(f);return await A.Promises.access(u,D.constants.R_OK),u}}e.realpath=E;function I(f){try{return D.realpathSync(f)}catch{const u=C(f);return D.accessSync(u,D.constants.R_OK),u}}e.realpathSync=I;function C(f){return(0,T.rtrim)((0,n.normalize)(f),n.sep)}}),define(ne[115],ie([0,1,56]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(R,b,E,I=1){let C=!1;return new Promise(f=>{const p=setTimeout(()=>{if(!C)return C=!0,f(0)},E);L(R,b,I,u=>{if(!C)return C=!0,clearTimeout(p),f(u)})})}e.findFreePort=n;function L(R,b,E,I){if(b===0)return I(0);const C=new D.Socket;C.once("connect",()=>(A(C),L(R+E,b-1,E,I))),C.once("data",()=>{}),C.once("error",f=>(A(C),f.code!=="ECONNREFUSED"?L(R+E,b-1,E,I):I(R))),C.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(R,b,E){let I=!1,C,f=1;const p=D.createServer({pauseOnConnect:!0});function u(m,d){I||(I=!0,p.removeAllListeners(),p.close(),C&&clearTimeout(C),d(m))}return new Promise(m=>{C=setTimeout(()=>{u(0,m)},E),p.on("listening",()=>{u(R,m)}),p.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&f<b?(R++,f++,p.listen(R,"127.0.0.1")):u(0,m)}),p.on("close",()=>{u(0,m)}),p.listen(R,"127.0.0.1")})}e.findFreePortFaster=T;function A(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(b){console.error(b)}}}),define(ne[72],ie([0,1,33,10,22]),function(K,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,A=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var b;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(b||(b={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class C{constructor(l,r,c){this.exePath=l,this.displayName=r,this.knownToExist=c}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await L.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:S=!1}={}){return S?E===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:S=!1,findPreview:l=!1}={}){const r=f({useAlternateBitness:S});if(!r)return null;const c=n.join(r,"PowerShell");if(!await L.SymlinkSupport.existsDirectory(c))return null;let i=-1,t=null;for(const a of await L.Promises.readdir(c)){let h=-1;if(l){const P=a.indexOf("-");if(P<0)continue;const _=a.substring(0,P);if(!T.test(_)||a.substring(P+1)!=="preview")continue;h=parseInt(_,10)}else{if(!T.test(a))continue;h=parseInt(a,10)}if(h<=i)continue;const v=n.join(c,a,"pwsh.exe");!await L.SymlinkSupport.existsFile(v)||(t=v,i=h)}if(!t)return null;const o=r.includes("x86")?" (x86)":"",s=l?" Preview":"";return new C(t,`PowerShell${s}${o}`,!0)}async function u({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const l=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await L.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:r,pwshMsixName:c}=S?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const i of await L.Promises.readdir(l))if(r.test(i)){const t=n.join(l,i,"pwsh.exe");return new C(t,c)}return null}function m(){const S=n.join(D.homedir(),".dotnet","tools","pwsh.exe");return new C(S,".NET Core PowerShell Global Tool")}function d(){const S=n.join(process.env.windir,E===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(S,"Windows PowerShell",!0)}async function*g(){let S=await p();S&&(yield S),S=await p({useAlternateBitness:!0}),S&&(yield S),S=await u(),S&&(yield S),S=m(),S&&(yield S),S=await p({findPreview:!0}),S&&(yield S),S=await u({findPreview:!0}),S&&(yield S),S=await p({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=d(),S&&(yield S)}async function*w(){for await(const S of g())await S.exists()&&(yield S)}e.enumeratePowerShellInstallations=w;async function y(){for await(const S of w())return S;return null}e.getFirstAvailablePowerShellInstallation=y}),define(ne[116],ie([0,1,45,18]),function(K,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(A){return new Promise((R,b)=>{let E;const I=new Map;function C(p,u,m,d,g){const w=I.get(u);if(p===A||w){const y={name:f(m),cmd:m,pid:p,ppid:u,load:d,mem:g};I.set(p,y),p===A&&(E=y),w&&(w.children||(w.children=[]),w.children.push(y),w.children.length>1&&(w.children=w.children.sort((S,l)=>S.pid-l.pid)))}}function f(p){const u=/--vscode-window-kind=shared-process/,m=/--vscode-window-kind=issue-reporter/,d=/--vscode-window-kind=process-explorer/,g=/--utility-sub-type=network/,w=/--crashes-directory/,y=/\\pipe\\winpty-control/,S=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(w.exec(p))return"electron-crash-reporter";if(y.exec(p))return"winpty-process";if(S.exec(p))return"console-window-host (Windows internal process)";let r=l.exec(p);if(r&&r.length===2)return r[1]==="renderer"?u.exec(p)?"shared-process":m.exec(p)?"issue-reporter":d.exec(p)?"process-explorer":"window":r[1]==="utility"&&g.exec(p)?"utility-network-service":r[1];const c=/[a-zA-Z-]+\.js/g;let i="";do r=c.exec(p),r&&(i+=r+" ");while(r);return i&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${i}`:p}if(process.platform==="win32"){const p=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substr(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substr(5):u;new Promise((u,m)=>{K(["windows-process-tree"],u,m)}).then(u=>{u.getProcessList(A,m=>{u.getProcessCpuUsage(m,d=>{const g=new Map;d.forEach(w=>{const y=p(w.commandLine||"");g.set(w.pid,{name:f(y),cmd:y,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),E=g.get(A),E?(g.forEach(w=>{const y=g.get(w.ppid);y&&(y.children||(y.children=[]),y.children.push(w))}),g.forEach(w=>{w.children&&(w.children=w.children.sort((y,S)=>y.pid-S.pid))}),R(E)):b(new Error(`Root process ${A} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let p=function(){let u=[E];const m=[];for(;u.length;){const g=u.shift();g&&(m.push(g.pid),g.children&&(u=u.concat(g.children)))}let d=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);d+=" "+m.join(" "),(0,D.exec)(d,{},(g,w,y)=>{if(g||y)b(g||new Error(y.toString()));else{const S=w.toString().split(`
`);for(let l=0;l<m.length;l++){const r=I.get(m[l]);r.load=parseFloat(S[l])}if(!E){b(new Error(`Root process ${A} not found`));return}R(E)}})};(0,D.exec)("which ps",{},(u,m,d)=>{if(u||d)if(process.platform!=="linux")b(u||new Error(d.toString()));else{const g=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,D.exec)(g,{},(w,y,S)=>{w||S?b(w||new Error(S.toString())):(T(y,C),p())})}else{const g=m.toString().trim(),w="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${g} ${w}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(y,S,l)=>{y||l&&!l.includes("screen size is bogus")?b(y||new Error(l.toString())):(T(S,C),process.platform==="linux"?p():E?R(E):b(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=L;function T(A,R){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=A.toString().split(`
`);for(const I of E){const C=b.exec(I.trim());C&&C.length===6&&R(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}});var de=this&&this.__decorate||function(K,e,D,n){var L=arguments.length,T=L<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,D):n,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(K,e,D,n);else for(var R=K.length-1;R>=0;R--)(A=K[R])&&(T=(L<3?A(T):L>3?A(e,D,T):A(e,D))||T);return L>3&&T&&Object.defineProperty(e,D,T),T};define(ne[36],ie([0,1,16,5,17,23,54,9,3,2,108,26,14]),function(K,e,D,n,L,T,A,R,b,E,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function u(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(m=e.ResponseType||(e.ResponseType={}));function d(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(g||(g={}));class w{constructor(q){this.buffer=q,this.pos=0}read(q){const X=this.buffer.slice(this.pos,this.pos+q);return this.pos+=X.byteLength,X}}class y{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}var S;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object"})(S||(S={}));function l(j){const q=L.VSBuffer.alloc(4);return q.writeUInt32BE(j,0),q}function r(j){return j.read(4).readUInt32BE(0)}function c(j){const q=L.VSBuffer.alloc(1);return q.writeUInt8(j,0),q}const i={Undefined:c(S.Undefined),String:c(S.String),Buffer:c(S.Buffer),VSBuffer:c(S.VSBuffer),Array:c(S.Array),Object:c(S.Object)},t=typeof Buffer!="undefined";function o(j,q){if(typeof q=="undefined")j.write(i.Undefined);else if(typeof q=="string"){const X=L.VSBuffer.fromString(q);j.write(i.String),j.write(l(X.byteLength)),j.write(X)}else if(t&&Buffer.isBuffer(q)){const X=L.VSBuffer.wrap(q);j.write(i.Buffer),j.write(l(X.byteLength)),j.write(X)}else if(q instanceof L.VSBuffer)j.write(i.VSBuffer),j.write(l(q.byteLength)),j.write(q);else if(Array.isArray(q)){j.write(i.Array),j.write(l(q.length));for(const X of q)o(j,X)}else{const X=L.VSBuffer.fromString(JSON.stringify(q));j.write(i.Object),j.write(l(X.byteLength)),j.write(X)}}function s(j){switch(j.read(1).readUInt8(0)){case S.Undefined:return;case S.String:return j.read(r(j)).toString();case S.Buffer:return j.read(r(j)).buffer;case S.VSBuffer:return j.read(r(j));case S.Array:{const X=r(j),H=[];for(let Z=0;Z<X;Z++)H.push(s(j));return H}case S.Object:return JSON.parse(j.read(r(j)).toString())}}class a{constructor(q,X,H=null,Z=1e3){this.protocol=q,this.ctx=X,this.logger=H,this.timeoutDelay=Z,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ee=>this.onRawMessage(ee)),this.sendResponse({type:200})}registerChannel(q,X){this.channels.set(q,X),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case 200:{const X=this.send([q.type]);this.logger&&this.logger.logOutgoing(X,0,1,d(q.type));return}case 201:case 202:case 204:case 203:{const X=this.send([q.type,q.id],q.data);this.logger&&this.logger.logOutgoing(X,q.id,1,d(q.type),q.data);return}}}send(q,X=void 0){const H=new y;return o(H,q),o(H,X),this.sendBuffer(H.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const X=new w(q),H=s(X),Z=s(X),ee=H[0];switch(ee){case 100:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${u(ee)}: ${H[2]}.${H[3]}`,Z),this.onPromise({type:ee,id:H[1],channelName:H[2],name:H[3],arg:Z});case 102:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${u(ee)}: ${H[2]}.${H[3]}`,Z),this.onEventListen({type:ee,id:H[1],channelName:H[2],name:H[3],arg:Z});case 101:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${u(ee)}`),this.disposeActiveRequest({type:ee,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${u(ee)}`),this.disposeActiveRequest({type:ee,id:H[1]})}}onPromise(q){const X=this.channels.get(q.channelName);if(!X){this.collectPendingRequest(q);return}const H=new T.CancellationTokenSource;let Z;try{Z=X.call(this.ctx,q.name,q.arg,H.token)}catch($){Z=Promise.reject($)}const ee=q.id;Z.then($=>{this.sendResponse({id:ee,data:$,type:201}),this.activeRequests.delete(q.id)},$=>{$ instanceof Error?this.sendResponse({id:ee,data:{message:$.message,name:$.name,stack:$.stack?$.stack.split?$.stack.split(`
`):$.stack:void 0},type:202}):this.sendResponse({id:ee,data:$,type:203}),this.activeRequests.delete(q.id)});const W=(0,E.toDisposable)(()=>H.cancel());this.activeRequests.set(q.id,W)}onEventListen(q){const X=this.channels.get(q.channelName);if(!X){this.collectPendingRequest(q);return}const H=q.id,ee=X.listen(this.ctx,q.name,q.arg)(W=>this.sendResponse({id:H,data:W,type:204}));this.activeRequests.set(q.id,ee)}disposeActiveRequest(q){const X=this.activeRequests.get(q.id);X&&(X.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let X=this.pendingRequests.get(q.channelName);X||(X=[],this.pendingRequests.set(q.channelName,X));const H=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);X.push({request:q,timeoutTimer:H})}flushPendingRequests(q){const X=this.pendingRequests.get(q);if(X){for(const H of X)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(q=>q.dispose()),this.activeRequests.clear()}}e.ChannelServer=a;var h;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class v{constructor(q,X=null){this.protocol=q,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=X}getChannel(q){const X=this;return{call(H,Z,ee){return X.isDisposed?Promise.reject(R.canceled()):X.requestPromise(q,H,Z,ee)},listen(H,Z){return X.isDisposed?Promise.reject(R.canceled()):X.requestEvent(q,H,Z)}}}requestPromise(q,X,H,Z=T.CancellationToken.None){const ee=this.lastRequestId++,$={id:ee,type:100,channelName:q,name:X,arg:H};if(Z.isCancellationRequested)return Promise.reject(R.canceled());let x;return new Promise((B,te)=>{if(Z.isCancellationRequested)return te(R.canceled());const se=()=>{const pe=Ie=>{switch(Ie.type){case 201:this.handlers.delete(ee),B(Ie.data);break;case 202:{this.handlers.delete(ee);const Ee=new Error(Ie.data.message);Ee.stack=Ie.data.stack,Ee.name=Ie.data.name,te(Ee);break}case 203:this.handlers.delete(ee),te(Ie.data);break}};this.handlers.set(ee,pe),this.sendRequest($)};let ce=null;this.state===g.Idle?se():(ce=(0,n.createCancelablePromise)(pe=>this.whenInitialized()),ce.then(()=>{ce=null,se()}));const he=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:ee,type:101}),te(R.canceled())},ve=Z.onCancellationRequested(he);x=(0,E.combinedDisposable)((0,E.toDisposable)(he),ve),this.activeRequests.add(x)}).finally(()=>{this.activeRequests.delete(x)})}requestEvent(q,X,H){const Z=this.lastRequestId++,W={id:Z,type:102,channelName:q,name:X,arg:H};let $=null;const x=new b.Emitter({onFirstListenerAdd:()=>{$=(0,n.createCancelablePromise)(B=>this.whenInitialized()),$.then(()=>{$=null,this.activeRequests.add(x),this.sendRequest(W)})},onLastListenerRemove:()=>{$?($.cancel(),$=null):(this.activeRequests.delete(x),this.sendRequest({id:Z,type:103}))}}),z=B=>x.fire(B.data);return this.handlers.set(Z,z),x.event}sendRequest(q){switch(q.type){case 100:case 102:{const X=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger&&this.logger.logOutgoing(X,q.id,0,`${u(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const X=this.send([q.type,q.id]);this.logger&&this.logger.logOutgoing(X,q.id,0,u(q.type));return}}}send(q,X=void 0){const H=new y;return o(H,q),o(H,X),this.sendBuffer(H.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const X=new w(q),H=s(X),Z=s(X),ee=H[0];switch(ee){case 200:return this.logger&&this.logger.logIncoming(q.byteLength,0,0,d(ee)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],0,d(ee),Z),this.onResponse({type:H[0],id:H[1],data:Z})}}onResponse(q){if(q.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}const X=this.handlers.get(q.id);X&&X(q)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(q=>q.dispose()),this.activeRequests.clear()}}de([A.memoize],v.prototype,"onDidInitializePromise",null),e.ChannelClient=v;class P{constructor(q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,q(({protocol:X,onDidClientDisconnect:H})=>{b.Event.once(X.onMessage)(ee=>{const W=new w(ee),$=s(W),x=new a(X,$),z=new v(X);this.channels.forEach((te,se)=>x.registerChannel(se,te));const B={channelServer:x,channelClient:z,ctx:$};this._connections.add(B),this._onDidAddConnection.fire(B),H(()=>{x.dispose(),z.dispose(),this._connections.delete(B),this._onDidRemoveConnection.fire(B)})})})}get connections(){const q=[];return this._connections.forEach(X=>q.push(X)),q}getChannel(q,X){const H=this;return{call(Z,ee,W){let $;if((0,f.isFunction)(X)){let z=(0,D.getRandomElement)(H.connections.filter(X));$=z?Promise.resolve(z):b.Event.toPromise(b.Event.filter(H.onDidAddConnection,X))}else $=X.routeCall(H,Z,ee);const x=$.then(z=>z.channelClient.getChannel(q));return O(x).call(Z,ee,W)},listen(Z,ee){if((0,f.isFunction)(X))return H.getMulticastEvent(q,X,Z,ee);const W=X.routeEvent(H,Z,ee).then($=>$.channelClient.getChannel(q));return O(W).listen(Z,ee)}}}getMulticastEvent(q,X,H,Z){const ee=this;let W=new E.DisposableStore;const $=new b.Emitter({onFirstListenerAdd:()=>{W=new E.DisposableStore;const x=new b.EventMultiplexer,z=new Map,B=se=>{const he=se.channelClient.getChannel(q).listen(H,Z),ve=x.add(he);z.set(se,ve)},te=se=>{const ce=z.get(se);!ce||(ce.dispose(),z.delete(se))};ee.connections.filter(X).forEach(B),b.Event.filter(ee.onDidAddConnection,X)(B,void 0,W),ee.onDidRemoveConnection(te,void 0,W),x.event($.fire,$,W),W.add(x)},onLastListenerRemove:()=>{W.dispose()}});return $.event}registerChannel(q,X){this.channels.set(q,X),this._connections.forEach(H=>{H.channelServer.registerChannel(q,X)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=P;class _{constructor(q,X,H=null){const Z=new y;o(Z,X),q.send(Z.buffer),this.channelClient=new v(q,H),this.channelServer=new a(q,X,H)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,X){this.channelServer.registerChannel(q,X)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function O(j){return{call(q,X,H){return j.then(Z=>Z.call(q,X,H))},listen(q,X){const H=new b.Relay;return j.then(Z=>H.input=Z.listen(q,X)),H.event}}}e.getDelayedChannel=O;function U(j){let q=!1;return{call(X,H,Z){return q?j.call(X,H,Z):(0,n.timeout)(0).then(()=>q=!0).then(()=>j.call(X,H,Z))},listen(X,H){if(q)return j.listen(X,H);const Z=new b.Relay;return(0,n.timeout)(0).then(()=>q=!0).then(()=>Z.input=j.listen(X,H)),Z.event}}}e.getNextTickChannel=U;class k{constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const X of q.connections)if(await Promise.resolve(this.fn(X.ctx)))return Promise.resolve(X);return await b.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=k;var M;(function(j){function q(ee,W){const $=ee,x=W&&W.disableMarshalling,z=new Map;for(const B in $)H(B)&&z.set(B,b.Event.buffer($[B],!0));return new class{listen(B,te,se){const ce=z.get(te);if(ce)return ce;if(Z(te)){const he=$[te];if(typeof he=="function")return he.call($,se)}throw new Error(`Event not found: ${te}`)}call(B,te,se){const ce=$[te];if(typeof ce=="function"){if(!x&&Array.isArray(se))for(let he=0;he<se.length;he++)se[he]=(0,I.revive)(se[he]);return ce.apply($,se)}throw new Error(`Method not found: ${te}`)}}}j.fromService=q;function X(ee,W){const $=W&&W.disableMarshalling;return new Proxy({},{get(x,z){if(typeof z=="string")return W?.properties?.has(z)?W.properties.get(z):Z(z)?function(B){return ee.listen(z,B)}:H(z)?ee.listen(z):async function(...B){let te;W&&!(0,f.isUndefinedOrNull)(W.context)?te=[W.context,...B]:te=B;const se=await ee.call(z,te);return $?se:(0,I.revive)(se)};throw new Error(`Property not found: ${String(z)}`)}})}j.toService=X;function H(ee){return ee[0]==="o"&&ee[1]==="n"&&C.isUpperAsciiLetter(ee.charCodeAt(2))}function Z(ee){return/^onDynamic/.test(ee)&&C.isUpperAsciiLetter(ee.charCodeAt(9))}})(M=e.ProxyChannel||(e.ProxyChannel={}));const F=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){let q=j.toString();if(q!=="[object Object]")return q}return j}function N(j){return Array.isArray(j)?j.map(V):V(j)}function G(j,q,X,H,Z,ee,W){W=N(W);const $=F[Z],x=$[H%$.length];let z=[`%c[${j}]%c[${String(q).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${x}`];/\($/.test(ee)?(z=z.concat(W),z.push(")")):z.push(W),console.log.apply(console,z)}e.logWithColors=G;class J{constructor(q,X){this._outgoingPrefix=q,this._incomingPrefix=X,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,X,H,Z,ee){this._totalOutgoing+=q,G(this._outgoingPrefix,this._totalOutgoing,q,X,H,Z,ee)}logIncoming(q,X,H,Z,ee){this._totalIncoming+=q,G(this._incomingPrefix,this._totalIncoming,q,X,H,Z,ee)}}e.IPCLogger=J}),define(ne[117],ie([0,1,17,3,36]),function(K,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(b){this.port=b,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",E=>D.VSBuffer.wrap(E.data)),b.start()}send(b){this.port.postMessage(b.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class A extends L.IPCClient{constructor(b,E){const I=new T(b);super(I,E);this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=A}),define(ne[73],ie([0,1,17,3,2,36]),function(K,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var R;(function(t){t.enableDiagnostics=!1,t.records=[];const o=new WeakMap;let s=0;function a(v,P){if(!o.has(v)){const _=String(++s);o.set(v,_)}return o.get(v)}function h(v,P,_,O){if(!t.enableDiagnostics)return;const U=a(v,P);if(O instanceof D.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const k=D.VSBuffer.alloc(O.byteLength);k.set(O),t.records.push({timestamp:Date.now(),id:U,label:P,type:_,buff:k})}else t.records.push({timestamp:Date.now(),id:U,label:P,type:_,data:O})}t.traceSocketEvent=h})(R=e.SocketDiagnostics||(e.SocketDiagnostics={}));var b;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b=e.SocketCloseEventType||(e.SocketCloseEventType={}));let E=null;function I(){return E||(E=D.VSBuffer.alloc(0)),E}class C{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,s){if(o===0)return I();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const P=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=o),P}if(this._chunks[0].byteLength>o){const P=this._chunks[0].slice(0,o);return s&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),P}let a=D.VSBuffer.alloc(o),h=0,v=0;for(;o>0;){const P=this._chunks[v];if(P.byteLength>o){const _=P.slice(0,o);a.set(_,h),h+=o,s&&(this._chunks[v]=P.slice(o),this._totalLength-=o),o-=o}else a.set(P,h),h+=P.byteLength,s?(this._chunks.shift(),this._totalLength-=P.byteLength):v++,o-=P.byteLength}return a}}e.ChunkStream=C;var f;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(f||(f={}));function p(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var u;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(u=e.ProtocolConstants||(e.ProtocolConstants={}));class m{constructor(o,s,a,h){this.type=o,this.id=s,this.ack=a,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends L.Disposable{constructor(o){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:p(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,h=this._state.id,v=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",s),this._onMessage.fire(new m(a,h,v,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=D.VSBuffer.alloc(13);s.writeUInt8(o.type,0),s.writeUInt32BE(o.id,1),s.writeUInt32BE(o.ack,5),s.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:p(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(s,o.data)}_bufferAdd(o,s){const a=this._totalLength===0;return this._data.push(o,s),this._totalLength+=o.byteLength+s.byteLength,a}_bufferTake(){const o=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,s){this._bufferAdd(o,s)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class w extends L.Disposable{constructor(o){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new d(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new m(1,0,0,o))}}e.Protocol=w;class y extends T.IPCClient{constructor(o,s,a=null){super(o,s,a);this.protocol=o}static fromSocket(o,s){return new y(new w(o),s)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=y;class S{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=S;class l{constructor(o){this.data=o,this.next=null}}class r{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],s=0,a=this._first;for(;a;)o[s++]=a.data,a=a.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const s=new l(o);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class c{constructor(){this.lastRuns=[];const o=Date.now();for(let s=0;s<c._HISTORY_LENGTH;s++)this.lastRuns[s]=o-1e3*s;setInterval(()=>{for(let s=c._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return c._INSTANCE||(c._INSTANCE=new c),c._INSTANCE}load(){const o=Date.now(),s=(1+c._HISTORY_LENGTH)*1e3;let a=0;for(let h=0;h<c._HISTORY_LENGTH;h++)o-this.lastRuns[h]<=s&&a++;return 1-a/c._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}c._HISTORY_LENGTH=10,c._INSTANCE=null;class i{constructor(o,s=null,a=c.getInstance()){this._onControlMessage=new S,this.onControlMessage=this._onControlMessage.event,this._onMessage=new S,this.onMessage=this._onMessage.event,this._onDidDispose=new S,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new S,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new S,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),s&&this._socketReader.acceptChunk(s)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,L.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new m(5,0,0,I());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new m(7,0,0,I());this._socketWriter.write(o)}sendResume(){const o=new m(8,0,0,I());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,s){this._isReconnecting=!0,this._socketDisposables=(0,L.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new m(3,0,this._incomingAckId,I());this._socketWriter.write(o);const s=this._outgoingUnackMsg.toArray();for(let a=0,h=s.length;a<h;a++)this._socketWriter.write(s[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new m(6,0,0,I())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const s=this._outgoingUnackMsg.toArray();for(let a=0,h=s.length;a<h;a++)this._socketWriter.write(s[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new m(1,s,this._incomingAckId,o);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(o){const s=new m(2,0,0,o);this._socketWriter.write(s)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),s=Date.now()-o.writtenTime,a=Date.now()-this._socketReader.lastReadTime,h=Date.now()-this._lastSocketTimeoutTime;if(s>=2e4&&a>=2e4&&h>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const v=Math.max(2e4-s,2e4-a,2e4-h,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},v)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new m(3,0,this._incomingAckId,I());this._socketWriter.write(o)}}e.PersistentProtocol=i}),define(ne[118],ie([0,1,74,3,36,117]),function(K,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends L.IPCServer{static getOnDidClientConnect(){const b=n.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(E,I)=>I);return n.Event.map(b,E=>{const{port1:I,port2:C}=new MessageChannel,p={protocol:new T.Protocol(I),onDidClientDisconnect:n.Event.fromDOMEventEmitter(I,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",E,[C]),p})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(ne[119],ie([0,1,17,9]),function(K,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(R,b){R.proxyAuthorization&&(R.headers={...R.headers||{},"Proxy-Authorization":R.proxyAuthorization});const E=new XMLHttpRequest;return new Promise((I,C)=>{E.open(R.type||"GET",R.url||"",!0,R.user,R.password),T(E,R),E.responseType="arraybuffer",E.onerror=f=>C(new Error(E.statusText&&"XHR failed: "+E.statusText||"XHR failed")),E.onload=f=>{I({res:{statusCode:E.status,headers:A(E)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(E.response)))})},E.ontimeout=f=>C(new Error(`XHR timeout: ${R.timeout}ms`)),R.timeout&&(E.timeout=R.timeout),E.send(R.data),b.onCancellationRequested(()=>{E.abort(),C((0,n.canceled)())})})}e.request=L;function T(R,b){if(b.headers){e:for(let E in b.headers){switch(E){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}R.setRequestHeader(E,b.headers[E])}}}function A(R){const b=Object.create(null);for(const E of R.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(E){const I=E.indexOf(":");b[E.substr(0,I).trim().toLowerCase()]=E.substr(I+1).trim()}return b}}),define(ne[75],ie([0,1,5,3,2,14]),function(K,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));function R(C){const f=C;return f?.changed instanceof Map||f?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var b;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(b||(b={}));class E extends L.Disposable{constructor(f,p=Object.create(null)){super();this.database=f,this.options=p,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=b.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(E.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){f.changed?.forEach((p,u)=>this.accept(u,p)),f.deleted?.forEach(p=>this.accept(p,void 0))}accept(f,p){if(this.state===b.Closed)return;let u=!1;(0,T.isUndefinedOrNull)(p)?u=this.cache.delete(f):this.cache.get(f)!==p&&(this.cache.set(f,p),u=!0),u&&this._onDidChangeStorage.fire(f)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===b.None&&(this.state=b.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,p){const u=this.cache.get(f);return(0,T.isUndefinedOrNull)(u)?p:u}getBoolean(f,p){const u=this.get(f);return(0,T.isUndefinedOrNull)(u)?p:u==="true"}getNumber(f,p){const u=this.get(f);return(0,T.isUndefinedOrNull)(u)?p:parseInt(u,10)}async set(f,p){if(this.state===b.Closed)return;if((0,T.isUndefinedOrNull)(p))return this.delete(f);const u=String(p);if(this.cache.get(f)!==u)return this.cache.set(f,u),this.pendingInserts.set(f,u),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async delete(f){if(!(this.state===b.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=b.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(f){if(!!this.hasPending)return this.doFlush(f)}async doFlush(f){return this.flushDelayer.trigger(()=>this.flushPending(),f)}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=E,E.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((p,u)=>this.items.set(u,p)),f.delete&&f.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=I}),define(ne[120],ie([11,12]),function(K,e){return K.create("vs/base/common/date",e)}),define(ne[57],ie([0,1,120]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,L=n*60,T=L*24,A=T*7,R=T*30,b=T*365;function E(C,f,p){typeof C!="number"&&(C=C.getTime());const u=Math.round((new Date().getTime()-C)/1e3);if(u<-30)return(0,D.localize)(0,null,E(new Date().getTime()+u*1e3,!1));if(u<30)return(0,D.localize)(1,null);let m;return u<n?(m=u,f?m===1?p?(0,D.localize)(2,null,m):(0,D.localize)(3,null,m):p?(0,D.localize)(4,null,m):(0,D.localize)(5,null,m):m===1?p?(0,D.localize)(6,null,m):(0,D.localize)(7,null,m):p?(0,D.localize)(8,null,m):(0,D.localize)(9,null,m)):u<L?(m=Math.floor(u/n),f?m===1?p?(0,D.localize)(10,null,m):(0,D.localize)(11,null,m):p?(0,D.localize)(12,null,m):(0,D.localize)(13,null,m):m===1?p?(0,D.localize)(14,null,m):(0,D.localize)(15,null,m):p?(0,D.localize)(16,null,m):(0,D.localize)(17,null,m)):u<T?(m=Math.floor(u/L),f?m===1?p?(0,D.localize)(18,null,m):(0,D.localize)(19,null,m):p?(0,D.localize)(20,null,m):(0,D.localize)(21,null,m):m===1?p?(0,D.localize)(22,null,m):(0,D.localize)(23,null,m):p?(0,D.localize)(24,null,m):(0,D.localize)(25,null,m)):u<A?(m=Math.floor(u/T),f?m===1?(0,D.localize)(26,null,m):(0,D.localize)(27,null,m):m===1?(0,D.localize)(28,null,m):(0,D.localize)(29,null,m)):u<R?(m=Math.floor(u/A),f?m===1?p?(0,D.localize)(30,null,m):(0,D.localize)(31,null,m):p?(0,D.localize)(32,null,m):(0,D.localize)(33,null,m):m===1?p?(0,D.localize)(34,null,m):(0,D.localize)(35,null,m):p?(0,D.localize)(36,null,m):(0,D.localize)(37,null,m)):u<b?(m=Math.floor(u/R),f?m===1?p?(0,D.localize)(38,null,m):(0,D.localize)(39,null,m):p?(0,D.localize)(40,null,m):(0,D.localize)(41,null,m):m===1?p?(0,D.localize)(42,null,m):(0,D.localize)(43,null,m):p?(0,D.localize)(44,null,m):(0,D.localize)(45,null,m)):(m=Math.floor(u/b),f?m===1?p?(0,D.localize)(46,null,m):(0,D.localize)(47,null,m):p?(0,D.localize)(48,null,m):(0,D.localize)(49,null,m):m===1?p?(0,D.localize)(50,null,m):(0,D.localize)(51,null,m):p?(0,D.localize)(52,null,m):(0,D.localize)(53,null,m))}e.fromNow=E;function I(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(ne[121],ie([11,12]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(ne[37],ie([0,1,16,14,121]),function(K,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(E,I){return I&&(E.stack||E.stacktrace)?L.localize(0,null,R(E),A(E.stack)||A(E.stacktrace)):R(E)}function A(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?L.localize(1,null,E.message):E.message||L.localize(2,null)}function b(E=null,I=!1){if(!E)return L.localize(3,null);if(Array.isArray(E)){const C=D.coalesce(E),f=b(C[0],I);return C.length>1?L.localize(4,null,f,C.length):f}if(n.isString(E))return E;if(E.detail){const C=E.detail;if(C.error)return T(C.error,I);if(C.exception)return T(C.exception,I)}return E.stack?T(E,I):E.message?E.message:L.localize(5,null)}e.toErrorMessage=b}),define(ne[122],ie([11,12]),function(K,e){return K.create("vs/base/node/processes",e)}),define(ne[76],ie([0,1,45,41,18,28,10,4,32,103,14,111,22,122]),function(K,e,D,n,L,T,A,R,b,E,I,C,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return E.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return E.TerminateResponseCode}});function u(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function m(r,c){if(R.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};c&&(i.cwd=c);const t=D.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],i);return new Promise(o=>{t.once("error",s=>{o({success:!1,error:s})}),t.once("exit",(s,a)=>{o(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?u(i.status):1})}else if(R.isLinux||R.isMacintosh)try{const i=L.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(t=>{D.execFile(i,[r.pid.toString()],{encoding:"utf8",shell:!0},(o,s,a)=>{t(o?{success:!1,error:o}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function d(r){!r||(delete r.DEBUG,R.isMacintosh&&delete r.DYLD_LIBRARY_PATH,R.isLinux&&delete r.LD_PRELOAD)}e.removeDangerousEnvVariables=d;function g(r=b.env){return r.comspec||"cmd.exe"}e.getWindowsShell=g;class w{constructor(c,i,t,o){if(i!==void 0&&t!==void 0&&o!==void 0)this.cmd=c,this.args=i,this.shell=t,this.options=o;else{const s=c;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(b.env).forEach(a=>{s[a]=b.env[a]}),Object.keys(this.options.env).forEach(a=>{s[a]=this.options.env[a]}),this.options.env=s}}getSanitizedCommand(){let c=this.cmd.toLowerCase();const i=c.lastIndexOf(A.sep);return i!==-1&&(c=c.substring(i+1)),w.WellKnowCommands[c]?c:"other"}start(c){return R.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(b.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(i=>{let t,o;const s=new Promise((a,h)=>{t=a,o=h});if(i){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=D.exec(a,this.options,(h,v,P)=>{this.childProcess=null;const _=h;_&&_.killed?o({killed:this.terminateRequested,stdout:v.toString(),stderr:P.toString()}):this.handleExec(t,c,h,v,P)})}else{let a=null;const h=v=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(v,t,c,o);const P={terminated:this.terminateRequested};I.isNumber(v)&&(P.cmdCode=v),t(P)};if(this.shell&&R.isWindows){const v=T.deepClone(this.options);v.windowsVerbatimArguments=!0,v.detached=!1;let P=!1,_=!1;const O=[];let U=this.ensureQuotes(this.cmd);O.push(U.value),P=U.quoted,this.args&&this.args.forEach(M=>{U=this.ensureQuotes(M),O.push(U.value),_=_&&U.quoted});const k=["/s","/c"];P?_?k.push('"'+O.join(" ")+'"'):O.length>1?k.push('"'+O[0]+'" '+O.slice(1).join(" ")):k.push('"'+O[0]+'"'):k.push(O.join(" ")),a=D.spawn(g(),k,v)}else this.cmd&&(a=D.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(I.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",v=>{this.childProcess=null,o({terminated:this.terminateRequested,error:v})}),a.pid&&(this.childProcess.on("close",h),this.handleSpawn(a,t,c,o,!0)))}return s})}handleClose(c,i,t,o){}ensureQuotes(c){return w.regexp.test(c)?{value:'"'+c+'"',quoted:!0}:{value:c,quoted:c.length>0&&c[0]==='"'&&c[c.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(c=>c.pid,c=>-1):new Promise(c=>{this.pidResolve=c})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(c=>(this.terminateRequested=!0,m(c,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),c=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(c=>{if(!this.shell||!R.isWindows)return c(!1);const i=D.spawn(g(),["/s","/c"]);i.on("error",t=>c(!0)),i.on("exit",t=>c(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class y extends w{constructor(c,i,t,o){super(c,i,t,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(c,i,t,o,s){[o,s].forEach((a,h)=>{const v=new C.LineDecoder;v.write(a).forEach(O=>{i({line:O,source:h===0?0:1})});const _=v.end();_&&i({line:_,source:h===0?0:1})}),c({terminated:this.terminateRequested,error:t})}handleSpawn(c,i,t,o,s){const a=new C.LineDecoder,h=new C.LineDecoder;c.stdout.on("data",v=>{a.write(v).forEach(_=>t({line:_,source:0}))}),c.stderr.on("data",v=>{h.write(v).forEach(_=>t({line:_,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=h}handleClose(c,i,t,o){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&t({line:s,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&t({line:a,source:1})}}e.LineProcess=y;function S(r){let c=[],i=!1;const t=function(o){if(i){c.push(o);return}(!r.send(o,a=>{if(a&&console.error(a),i=!1,c.length>0){const h=c.slice(0);c=[],h.forEach(v=>t(v))}})||R.isWindows)&&(i=!0)};return{send:t}}e.createQueuedSender=S;var l;(function(r){async function c(i,t,o){if(A.isAbsolute(i))return i;if(t===void 0&&(t=b.cwd()),A.dirname(i)!=="."||(o===void 0&&I.isString(b.env.PATH)&&(o=b.env.PATH.split(A.delimiter)),o===void 0||o.length===0))return A.join(t,i);async function a(h){if(await f.Promises.exists(h)){let v;try{v=await f.Promises.stat(h)}catch(P){P.message.startsWith("EACCES")&&(v=await f.Promises.lstat(h))}return v?!v.isDirectory():!1}return!1}for(let h of o){let v;if(A.isAbsolute(h)?v=A.join(h,i):v=A.join(t,h,i),await a(v))return v;let P=v+".com";if(await a(P)||(P=v+".exe",await a(P)))return P}return A.join(t,i)}r.findExecutable=c})(l=e.win32||(e.win32={}))}),define(ne[123],ie([0,1,33,4,72,76]),function(K,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(p,u){return p===1?n.isWindows?C():T.getWindowsShell(u):E(p,u)}e.getSystemShell=A;function R(p,u){return p===1?n.isWindows?f(u):T.getWindowsShell(u):E(p,u)}e.getSystemShellSync=R;let b=null;function E(p,u){if(n.isLinux&&p===2||n.isMacintosh&&p===3)return"/bin/bash";if(!b){let m;if(n.isWindows)m="/bin/bash";else{if(m=u.SHELL,!m)try{m=(0,D.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}b=m}return b}let I=null;async function C(){return I||(I=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),I}function f(p){if(I)return I;const u=n.isWindows&&parseFloat((0,D.release)())>=10,m=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),d=`${p.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?d:T.getWindowsShell(p)}}),define(ne[58],ie([0,1,45,5,17,23,107,9,3,2,28,76,36]),function(K,e,D,n,L,T,A,R,b,E,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends f.ChannelServer{constructor(d){super({send:g=>{try{process.send&&process.send(g.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",g=>L.VSBuffer.wrap(Buffer.from(g,"base64")))},d);process.once("disconnect",()=>this.dispose())}}e.Server=p;class u{constructor(d,g){this.modulePath=d,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new b.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new n.Delayer(w),this.child=null,this._client=null}getChannel(d){const g=this;return{call(w,y,S){return g.requestPromise(d,w,y,S)},listen(w,y){return g.requestEvent(d,w,y)}}}requestPromise(d,g,w,y=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const S=this.getCachedChannel(d),l=(0,n.createCancelablePromise)(i=>S.call(g,w,i)),r=y.onCancellationRequested(()=>l.cancel()),c=(0,E.toDisposable)(()=>l.cancel());return this.activeRequests.add(c),l.finally(()=>{r.dispose(),this.activeRequests.delete(c),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(d,g,w){if(!this.disposeDelayer)return b.Event.None;this.disposeDelayer.cancel();let y;const S=new b.Emitter({onFirstListenerAdd:()=>{y=this.getCachedChannel(d).listen(g,w)(S.fire,S),this.activeRequests.add(y)},onLastListenerRemove:()=>{this.activeRequests.delete(y),y.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return S.event}get client(){if(!this._client){const d=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,C.removeDangerousEnvVariables)(g.env),this.child=(0,D.fork)(this.modulePath,d,g);const w=new b.Emitter;b.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,A.isRemoteConsoleLog)(t)){(0,A.log)(t,`IPC Library: ${this.options.serverName}`);return}w.fire(L.VSBuffer.wrap(Buffer.from(t,"base64")))});const S=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,l=t=>this.child&&this.child.connected&&S.send(t.buffer.toString("base64")),r=w.event,c={send:l,onMessage:r};this._client=new f.ChannelClient(c);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,o)=>{process.removeListener("exit",i),this.activeRequests.forEach(s=>(0,E.dispose)(s)),this.activeRequests.clear(),t!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:o})})}return this._client}getCachedChannel(d){let g=this.channels.get(d);return g||(g=this.client.getChannel(d),this.channels.set(d,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=u}),define(ne[124],ie([11,12]),function(K,e){return K.create("vs/base/node/zip",e)}),define(ne[125],ie([11,12]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[126],ie([11,12]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(ne[127],ie([11,12]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(ne[128],ie([11,12]),function(K,e){return K.create("vs/platform/environment/node/shellEnv",e)}),define(ne[129],ie([11,12]),function(K,e){return K.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[130],ie([11,12]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[131],ie([11,12]),function(K,e){return K.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ne[132],ie([11,12]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[133],ie([11,12]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[134],ie([11,12]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(ne[135],ie([11,12]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[136],ie([11,12]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(ne[137],ie([11,12]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(ne[138],ie([11,12]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(ne[139],ie([11,12]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[140],ie([11,12]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(ne[141],ie([11,12]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[142],ie([11,12]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[143],ie([11,12]),function(K,e){return K.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ne[144],ie([11,12]),function(K,e){return K.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ne[145],ie([11,12]),function(K,e){return K.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ne[146],ie([11,12]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ne[147],ie([11,12]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ne[148],ie([11,12]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ne[149],ie([0,1,4]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var n;(function(A){A.Team="team",A.Internal="internal",A.Insiders="insider",A.Public="public"})(n=e.TargetPopulation||(e.TargetPopulation={}));var L;(function(A){A.Market="X-MSEdge-Market",A.CorpNet="X-FD-Corpnet",A.ApplicationVersion="X-VSCode-AppVersion",A.Build="X-VSCode-Build",A.ClientId="X-MSEdge-ClientId",A.ExtensionName="X-VSCode-ExtensionName",A.Language="X-VSCode-Language",A.TargetPopulation="X-VSCode-TargetPopulation"})(L=e.Filters||(e.Filters={}));class T{constructor(R,b,E,I){this.version=R,this.appName=b,this.machineId=E,this.targetPopulation=I}getFilterValue(R){switch(R){case L.ApplicationVersion:return this.version;case L.Build:return this.appName;case L.ClientId:return this.machineId;case L.Language:return D.language;case L.ExtensionName:return"vscode-core";case L.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let R=new Map,b=Object.values(L);for(let E of b)R.set(E,this.getFilterValue(E));return R}}e.AssignmentFilterProvider=T}),define(ne[77],ie([0,1,57,54,18,10,32,19,7]),function(K,e,D,n,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class E{constructor(m,d,g){this._args=m,this.paths=d,this.productService=g}get appRoot(){return(0,T.dirname)(L.FileAccess.asFileUri("",K).fsPath)}get userHome(){return b.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return b.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.paths.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const m=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",m)}return this.args.logsPath}get userDataSyncLogResource(){return b.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(b.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return b.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return b.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=A.env.VSCODE_PORTABLE;return m?b.URI.file((0,T.join)(m,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,T.resolve)(m):(0,T.normalize)((0,T.join)(L.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const m=this.args["extensions-download-dir"];return m?(0,T.resolve)(m):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,T.resolve)(m);const d=A.env.VSCODE_EXTENSIONS;if(d)return d;const g=A.env.VSCODE_PORTABLE;return g?(0,T.join)(g,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(d=>/^[^:/?#]+?:\/\//.test(d)?b.URI.parse(d):b.URI.file((0,T.normalize)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?b.URI.parse(m):b.URI.file((0,T.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return b.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([n.memoize],E.prototype,"appRoot",null),de([n.memoize],E.prototype,"userHome",null),de([n.memoize],E.prototype,"userDataPath",null),de([n.memoize],E.prototype,"appSettingsHome",null),de([n.memoize],E.prototype,"tmpDir",null),de([n.memoize],E.prototype,"cacheHome",null),de([n.memoize],E.prototype,"userRoamingDataHome",null),de([n.memoize],E.prototype,"settingsResource",null),de([n.memoize],E.prototype,"userDataSyncHome",null),de([n.memoize],E.prototype,"userDataSyncLogResource",null),de([n.memoize],E.prototype,"sync",null),de([n.memoize],E.prototype,"machineSettingsResource",null),de([n.memoize],E.prototype,"globalStorageHome",null),de([n.memoize],E.prototype,"workspaceStorageHome",null),de([n.memoize],E.prototype,"keybindingsResource",null),de([n.memoize],E.prototype,"keyboardLayoutResource",null),de([n.memoize],E.prototype,"argvResource",null),de([n.memoize],E.prototype,"snippetsHome",null),de([n.memoize],E.prototype,"isExtensionDevelopment",null),de([n.memoize],E.prototype,"untitledWorkspacesHome",null),de([n.memoize],E.prototype,"installSourcePath",null),de([n.memoize],E.prototype,"builtinExtensionsPath",null),de([n.memoize],E.prototype,"extensionsPath",null),de([n.memoize],E.prototype,"extensionDevelopmentLocationURI",null),de([n.memoize],E.prototype,"extensionDevelopmentKind",null),de([n.memoize],E.prototype,"extensionTestsLocationURI",null),de([n.memoize],E.prototype,"debugExtensionHost",null),de([n.memoize],E.prototype,"serviceMachineIdResource",null),de([n.memoize],E.prototype,"telemetryLogResource",null),de([n.memoize],E.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=E;function I(u,m){return p(u["inspect-extensions"],u["inspect-brk-extensions"],5870,m,u.debugId,u.extensionEnvironment)}e.parseExtensionHostPort=I;function C(u,m){return p(u["inspect-search"],u["inspect-brk-search"],5876,m,u.extensionEnvironment)}e.parseSearchPort=C;function f(u,m){return p(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,m,u.extensionEnvironment)}e.parsePtyHostPort=f;function p(u,m,d,g,w,y){const l=Number(m||u)||(g?null:d),r=l?Boolean(!!m):!1;let c;if(y)try{c=JSON.parse(y)}catch{}return{port:l,break:r,debugId:w,env:c}}}),define(ne[150],ie([0,1,251,4,126]),function(K,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,L.localize)(0,null),e:(0,L.localize)(1,null),t:(0,L.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,L.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,L.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,L.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,L.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,L.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,L.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,L.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,L.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,L.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,L.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,L.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,L.localize)(14,null)},category:{type:"string",cat:"e",description:(0,L.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,L.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,L.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,L.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,L.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,L.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,L.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,L.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,L.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,L.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,L.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,L.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,L.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,L.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,L.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,L.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,L.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,L.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function R(u,m,d=A){const g={},w=[],y=[];for(let c in m){const i=m[c];i.alias&&(g[c]=i.alias),i.type==="string"||i.type==="string[]"?(w.push(c),i.deprecates&&w.push(...i.deprecates)):i.type==="boolean"&&(y.push(c),i.deprecates&&y.push(...i.deprecates))}const S=D(u,{string:w,boolean:y,alias:g}),l={},r=S;l._=S._.map(c=>String(c)).filter(c=>c.length>0),delete r._;for(let c in m){const i=m[c];i.alias&&delete r[i.alias];let t=r[c];if(i.deprecates)for(const o of i.deprecates)r.hasOwnProperty(o)&&(t||(t=r[o],t&&d.onDeprecatedOption(o,i.deprecationMessage||(0,L.localize)(33,null))),delete r[o]);typeof t!="undefined"&&(i.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):i.type==="string"&&Array.isArray(t)&&(t=t.pop(),d.onMultipleValues(c,t)),l[c]=t,i.deprecationMessage&&d.onDeprecatedOption(c,i.deprecationMessage)),delete r[c]}for(let c in r)d.onUnknownOption(c);return l}e.parseArgs=R;function b(u,m){let d="";return m.args&&(Array.isArray(m.args)?d=` <${m.args.join("> <")}>`:d=` <${m.args}>`),m.alias?`-${m.alias} --${u}${d}`:`--${u}${d}`}function E(u,m){let d=0,g=[];for(const l in u){const r=u[l],c=b(l,r);d=Math.max(d,c.length),g.push([c,r.description])}let w=d+2+1;if(m-w<25)return g.reduce((l,r)=>l.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);let y=m-w-1,S=[];for(const l of g){let r=l[0],c=C(l[1],y),i=I(w-r.length-2);S.push("  "+r+i+c[0]);for(let t=1;t<c.length;t++)S.push(I(w)+c[t])}return S}e.formatOptions=E;function I(u){return" ".repeat(u)}function C(u,m){let d=[];for(;u.length;){let g=u.length<m?u.length:u.lastIndexOf(" ",m),w=u.slice(0,g).trim();u=u.slice(g),d.push(w)}return d}function f(u,m,d,g,w){const y=process.stdout.isTTY&&process.stdout.columns||80,S=w?.noInputFiles!==!0?`[${(0,L.localize)(34,null)}...]`:"",l=[`${u} ${d}`];l.push(""),l.push(`${(0,L.localize)(35,null)}: ${m} [${(0,L.localize)(36,null)}]${S}`),l.push(""),w?.noPipe!==!0&&(n.isWindows?l.push((0,L.localize)(37,null,m)):l.push((0,L.localize)(38,null,m)),l.push(""));const r={};for(const c in g){const i=g[c];if(i.description&&i.cat){let t=r[i.cat];t||(r[i.cat]=t={}),t[c]=i}}for(let c in r){const i=c;let t=r[i];t&&(l.push(T[i]),l.push(...E(t,y)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=f;function p(u,m){return`${u||(0,L.localize)(39,null)}
${m||(0,L.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=p}),function(){"use strict";function K(e,D,n,L){function T(R){const b=A(R),E=[b];return e.isAbsolute(b)||E.unshift(L),e.resolve(...E)}function A(R){const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,n);const I=R["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(C,"AppData","Roaming")}break;case"darwin":E=e.join(D.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,n)}return{getUserDataPath:T}}if(typeof define=="function")define(ne[151],ie([0,252,33,18,19,32]),function(e,D,n,L,T,A){const R=T.dirname(L.FileAccess.asFileUri("",e)),b=e.__$__nodeRequire(T.joinPath(R,"package.json").fsPath);return K(D,n,b.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),n=require("os");module.exports=K(D,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[152],ie([0,1,33,77,151]),function(K,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends n.AbstractNativeEnvironmentService{constructor(R,b){super(R,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,L.getUserDataPath)(R)},b)}}e.NativeEnvironmentService=T}),define(ne[153],ie([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const n=/^([^@:]+@)?([^:]+):/,L=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,b=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function E(d){const g=d.match(A);return g?g[1]:null}function I(d){if(d.indexOf("://")===-1){const g=d.match(n);return g?E(g[2]):null}try{const g=D.URI.parse(d);if(g.authority)return E(g.authority)}catch{}return null}function C(d,g){const w=new Set;let y;for(;y=R.exec(d);){const l=I(y[1]);l&&w.add(l)}const S=new Set(g);return Array.from(w).map(l=>S.has(l)?l:l.replace(b,"a"))}e.getDomainsOfRemotes=C;function f(d){const g=d.match(T);return g?g[2]:null}function p(d,g,w){return d&&g?(w&&g.endsWith(".git")&&(g=g.substr(0,g.length-4)),g.indexOf("/")===0?`${d}${g}`:`${d}/${g}`):null}function u(d,g){if(d.indexOf("://")===-1){const w=d.match(L);if(w)return p(w[2],w[3],g)}try{const w=D.URI.parse(d);if(w.authority)return p(f(w.authority),w.path,g)}catch{}return null}function m(d,g=!1){const w=[];let y;for(;y=R.exec(d);){const S=u(y[1],g);S&&w.push(S)}return w}e.getRemotes=m}),define(ne[154],ie([0,1,28]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const n=/^%([\w\d.-]+)%$/i;function L(T,A){const R=b=>{if(typeof b!="string")return;const E=n.exec(b);if(!E)return;const I=A[E[1]]??b;return typeof I=="string"?I:typeof I.message=="string"?I.message:b};return(0,D.cloneAndChange)(T,R)}e.localizeManifest=L}),define(ne[155],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,A,R,b){return this.channel.call("promptImportantExtensionsInstallNotification",[T,A,R,b])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class n{constructor(T){this.service=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,R){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=n}),define(ne[78],ie([0,1,135]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const n=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,L=/^-(\d{4})(\d{2})(\d{2})$/;function T(f){return f=f.trim(),f==="*"||n.test(f)}e.isValidVersionStr=T;function A(f){if(!T(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=f.match(n);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=A;function R(f){if(!f)return null;let p=f.majorBase,u=f.majorMustEqual,m=f.minorBase,d=f.minorMustEqual,g=f.patchBase,w=f.patchMustEqual;f.hasCaret&&(p===0||(d=!1),w=!1);let y=0;if(f.preRelease){const S=L.exec(f.preRelease);if(S){const[,l,r,c]=S;y=Date.UTC(Number(l),Number(r)-1,Number(c))}}return{majorBase:p,majorMustEqual:u,minorBase:m,minorMustEqual:d,patchBase:g,patchMustEqual:w,isMinimum:f.hasGreaterEquals,notBefore:y}}e.normalizeVersion=R;function b(f,p,u){let m;typeof f=="string"?m=R(A(f)):m=f;let d;p instanceof Date?d=p.getTime():typeof p=="string"&&(d=new Date(p).getTime());let g;if(typeof u=="string"?g=R(A(u)):g=u,!m||!g)return!1;let w=m.majorBase,y=m.minorBase,S=m.patchBase,l=g.majorBase,r=g.minorBase,c=g.patchBase,i=g.notBefore,t=g.majorMustEqual,o=g.minorMustEqual,s=g.patchMustEqual;return g.isMinimum?w>l?!0:w<l?!1:y>r?!0:y<r||d&&d<i?!1:S>=c:(w===1&&l===0&&(!t||!o||!s)&&(l=1,r=0,c=0,t=!0,o=!1,s=!1),w<l?!1:w>l?!t:y<r?!1:y>r?!o:S<c?!1:S>c?!s:!(d&&d<i))}e.isValidVersion=b;function E(f,p,u,m){return u.isBuiltin||typeof u.main=="undefined"?!0:C(f,p,u.engines.vscode,m)}e.isValidExtensionVersion=E;function I(f,p,u){return f==="*"||C(p,u,f)}e.isEngineValid=I;function C(f,p,u,m=[]){let d=R(A(u));if(!d)return m.push(D.localize(0,null,u)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return m.push(D.localize(1,null,u)),!1}else if(!d.majorMustEqual)return m.push(D.localize(2,null,u)),!1;return b(f,p,d)?!0:(m.push(D.localize(3,null,f,u)),!1)}}),define(ne[51],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(L,T=[],A=!1){this.ctor=L,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=D}),define(ne[79],ie([0,1,51]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function L(A,R,b){R instanceof D.SyncDescriptor||(R=new D.SyncDescriptor(R,[],b)),n.push([A,R])}e.registerSingleton=L;function T(){return n}e.getSingletonServiceDescriptors=T}),define(ne[156],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=D;class n{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let A of this._nodes.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const R=this.lookupOrInsertNode(T),b=this.lookupOrInsertNode(A);R.outgoing.set(this._hashFn(A),b),b.incoming.set(this._hashFn(T),R)}removeNode(T){const A=this._hashFn(T);this._nodes.delete(A);for(let R of this._nodes.values())R.outgoing.delete(A),R.incoming.delete(A)}lookupOrInsertNode(T){const A=this._hashFn(T);let R=this._nodes.get(A);return R||(R=new D(T),this._nodes.set(A,R)),R}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[A,R]of this._nodes)T.push(`${A}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,A]of this._nodes){const R=new Set([T]),b=this._findCycle(A,R);if(b)return b}}_findCycle(T,A){for(let[R,b]of T.outgoing){if(A.has(R))return[...A,R].join(" -> ");A.add(R);const E=this._findCycle(b,A);if(E)return E;A.delete(R)}}}e.Graph=n}),define(ne[6],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function R(b){return b[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=R})(D=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function n(A,R,b,E){R[D.DI_TARGET]===R?R[D.DI_DEPENDENCIES].push({id:A,index:b,optional:E}):(R[D.DI_DEPENDENCIES]=[{id:A,index:b,optional:E}],R[D.DI_TARGET]=R)}function L(A){if(D.serviceIds.has(A))return D.serviceIds.get(A);const R=function(b,E,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(R,b,I,!1)};return R.toString=()=>A,D.serviceIds.set(A,R),R}e.createDecorator=L;function T(A){return A}e.refineServiceDecorator=T}),define(ne[157],ie([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(ne[20],ie([0,1,14,7,6]),function(K,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,L.createDecorator)("configurationService");function T(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof n.URI)}e.isConfigurationOverrides=T;function A(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||D.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=A;var R;(function(d){d[d.USER=1]="USER",d[d.USER_LOCAL=2]="USER_LOCAL",d[d.USER_REMOTE=3]="USER_REMOTE",d[d.WORKSPACE=4]="WORKSPACE",d[d.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",d[d.DEFAULT=6]="DEFAULT",d[d.MEMORY=7]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function b(d){switch(d){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=b;function E(d,g){const w=Object.create(null);for(let y in d)I(w,y,d[y],g);return w}e.toValuesTree=E;function I(d,g,w,y){const S=g.split("."),l=S.pop();let r=d;for(let c=0;c<S.length;c++){let i=S[c],t=r[i];switch(typeof t){case"undefined":t=r[i]=Object.create(null);break;case"object":break;default:y(`Ignoring ${g} as ${S.slice(0,c+1).join(".")} is ${JSON.stringify(t)}`);return}r=t}if(typeof r=="object"&&r!==null)try{r[l]=w}catch{y(`Ignoring ${g} as ${S.join(".")} is ${JSON.stringify(r)}`)}else y(`Ignoring ${g} as ${S.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=I;function C(d,g){const w=g.split(".");f(d,w)}e.removeFromValueTree=C;function f(d,g){const w=g.shift();if(g.length===0){delete d[w];return}if(Object.keys(d).indexOf(w)!==-1){const y=d[w];typeof y=="object"&&!Array.isArray(y)&&(f(y,g),Object.keys(y).length===0&&delete d[w])}}function p(d,g,w){function y(r,c){let i=r;for(const t of c){if(typeof i!="object"||i===null)return;i=i[t]}return i}const S=g.split("."),l=y(d,S);return typeof l=="undefined"?w:l}e.getConfigurationValue=p;function u(d,g,w){Object.keys(g).forEach(y=>{y!=="__proto__"&&(y in d?D.isObject(d[y])&&D.isObject(g[y])?u(d[y],g[y],w):w&&(d[y]=g[y]):d[y]=g[y])})}e.merge=u;function m(d,g,w){const y=d.inspect(g),S=d.inspect(w);return typeof y.userValue!="undefined"||typeof y.workspaceValue!="undefined"||typeof y.workspaceFolderValue!="undefined"?y.value:typeof S.userValue!="undefined"||typeof S.workspaceValue!="undefined"||typeof S.workspaceFolderValue!="undefined"?S.value:y.defaultValue}e.getMigratedSettingValue=m}),define(ne[158],ie([0,1,4,26,6]),function(K,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",D.isMacintosh),T.set("isLinux",D.isLinux),T.set("isWindows",D.isWindows),T.set("isWeb",D.isWeb),T.set("isMacNative",D.isMacintosh&&!D.isWeb),T.set("isEdge",D.isEdge),T.set("isFirefox",D.isFirefox),T.set("isChrome",D.isChrome),T.set("isSafari",D.isSafari);const A=Object.prototype.hasOwnProperty;var R;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(R=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return C.INSTANCE}static true(){return f.INSTANCE}static has(k){return p.create(k)}static equals(k,M){return u.create(k,M)}static notEquals(k,M){return g.create(k,M)}static regex(k,M){return i.create(k,M)}static in(k,M){return m.create(k,M)}static not(k){return w.create(k)}static and(...k){return s.create(k,null)}static or(...k){return a.create(k,null,!0)}static greater(k,M){return S.create(k,M)}static greaterEquals(k,M){return l.create(k,M)}static smaller(k,M){return r.create(k,M)}static smallerEquals(k,M){return c.create(k,M)}static deserialize(k,M=!1){if(!!k)return this._deserializeOrExpression(k,M)}static _deserializeOrExpression(k,M){let F=k.split("||");return a.create(F.map(V=>this._deserializeAndExpression(V,M)),null,!0)}static _deserializeAndExpression(k,M){let F=k.split("&&");return s.create(F.map(V=>this._deserializeOne(V,M)),null)}static _deserializeOne(k,M){if(k=k.trim(),k.indexOf("!=")>=0){let F=k.split("!=");return g.create(F[0].trim(),this._deserializeValue(F[1],M))}if(k.indexOf("==")>=0){let F=k.split("==");return u.create(F[0].trim(),this._deserializeValue(F[1],M))}if(k.indexOf("=~")>=0){let F=k.split("=~");return i.create(F[0].trim(),this._deserializeRegexValue(F[1],M))}if(k.indexOf(" in ")>=0){let F=k.split(" in ");return m.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const F=k.split(">=");return l.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const F=k.split(">");return S.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const F=k.split("<=");return c.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const F=k.split("<");return r.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(k)?w.create(k.substr(1).trim()):p.create(k)}static _deserializeValue(k,M){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;let F=/^'([^']*)'$/.exec(k);return F?F[1].trim():k}static _deserializeRegexValue(k,M){if((0,n.isFalsyOrWhitespace)(k)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=k.indexOf("/"),V=k.lastIndexOf("/");if(F===V||F<0){if(M)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}let N=k.slice(F+1,V),G=k[V+1]==="i"?"i":"";try{return new RegExp(N,G)}catch(J){if(M)throw new Error(`bad regexp-value '${k}', parse error: ${J}`);return console.warn(`bad regexp-value '${k}', parse error: ${J}`),null}}}e.ContextKeyExpr=b;function E(U,k){const M=U?U.substituteConstants():void 0,F=k?k.substituteConstants():void 0;return!M&&!F?!0:!M||!F?!1:M.equals(F)}e.expressionsAreEqualWithConstantSubstitution=E;function I(U,k){return U.cmp(k)}class C{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class f{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class p{constructor(k,M){this.key=k,this.negated=M,this.type=2}static create(k,M=null){const F=T.get(k);return typeof F=="boolean"?F?f.INSTANCE:C.INSTANCE:new p(k,M)}cmp(k){return k.type!==this.type?this.type-k.type:v(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=T.get(this.key);return typeof k=="boolean"?k?f.INSTANCE:C.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=w.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=p;class u{constructor(k,M,F){this.key=k,this.value=M,this.negated=F,this.type=4}static create(k,M,F=null){if(typeof M=="boolean")return M?p.create(k,F):w.create(k,F);const V=T.get(k);return typeof V=="boolean"?M===(V?"true":"false")?f.INSTANCE:C.INSTANCE:new u(k,M,F)}cmp(k){return k.type!==this.type?this.type-k.type:P(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=T.get(this.key);if(typeof k=="boolean"){const M=k?"true":"false";return this.value===M?f.INSTANCE:C.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class m{constructor(k,M){this.key=k,this.valueKey=M,this.type=10,this.negated=null}static create(k,M){return new m(k,M)}cmp(k){return k.type!==this.type?this.type-k.type:P(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const M=k.getValue(this.valueKey),F=k.getValue(this.key);return Array.isArray(M)?M.indexOf(F)>=0:typeof F=="string"&&typeof M=="object"&&M!==null?A.call(M,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=d.create(this)),this.negated}}e.ContextKeyInExpr=m;class d{constructor(k){this._actual=k,this.type=11}static create(k){return new d(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new d(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotInExpr=d;class g{constructor(k,M,F){this.key=k,this.value=M,this.negated=F,this.type=5}static create(k,M,F=null){if(typeof M=="boolean")return M?w.create(k,F):p.create(k,F);const V=T.get(k);return typeof V=="boolean"?M===(V?"true":"false")?C.INSTANCE:f.INSTANCE:new g(k,M,F)}cmp(k){return k.type!==this.type?this.type-k.type:P(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=T.get(this.key);if(typeof k=="boolean"){const M=k?"true":"false";return this.value===M?C.INSTANCE:f.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=g;class w{constructor(k,M){this.key=k,this.negated=M,this.type=3}static create(k,M=null){const F=T.get(k);return typeof F=="boolean"?F?C.INSTANCE:f.INSTANCE:new w(k,M)}cmp(k){return k.type!==this.type?this.type-k.type:v(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=T.get(this.key);return typeof k=="boolean"?k?C.INSTANCE:f.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=w;function y(U,k){if(typeof U=="string"){const M=parseFloat(U);isNaN(M)||(U=M)}return typeof U=="string"||typeof U=="number"?k(U):C.INSTANCE}class S{constructor(k,M,F){this.key=k,this.value=M,this.negated=F,this.type=12}static create(k,M,F=null){return y(M,V=>new S(k,V,F))}cmp(k){return k.type!==this.type?this.type-k.type:P(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=S;class l{constructor(k,M,F){this.key=k,this.value=M,this.negated=F,this.type=13}static create(k,M,F=null){return y(M,V=>new l(k,V,F))}cmp(k){return k.type!==this.type?this.type-k.type:P(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=l;class r{constructor(k,M,F){this.key=k,this.value=M,this.negated=F,this.type=14}static create(k,M,F=null){return y(M,V=>new r(k,V,F))}cmp(k){return k.type!==this.type?this.type-k.type:P(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=r;class c{constructor(k,M,F){this.key=k,this.value=M,this.negated=F,this.type=15}static create(k,M,F=null){return y(M,V=>new c(k,V,F))}cmp(k){return k.type!==this.type?this.type-k.type:P(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=c;class i{constructor(k,M){this.key=k,this.regexp=M,this.type=7,this.negated=null}static create(k,M){return new i(k,M)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const M=this.regexp?this.regexp.source:"",F=k.regexp?k.regexp.source:"";return M<F?-1:M>F?1:0}equals(k){if(k.type===this.type){const M=this.regexp?this.regexp.source:"",F=k.regexp?k.regexp.source:"";return this.key===k.key&&M===F}return!1}substituteConstants(){return this}evaluate(k){let M=k.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=t.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class t{constructor(k){this._actual=k,this.type=8}static create(k){return new t(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new t(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=t;function o(U){let k=null;for(let M=0,F=U.length;M<F;M++){const V=U[M].substituteConstants();if(U[M]!==V&&k===null){k=[];for(let N=0;N<M;N++)k[N]=U[N]}k!==null&&(k[M]=V)}return k===null?U:k}class s{constructor(k,M){this.expr=k,this.negated=M,this.type=6}static create(k,M){return s._normalizeArr(k,M)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let M=0,F=this.expr.length;M<F;M++){const V=I(this.expr[M],k.expr[M]);if(V!==0)return V}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].equals(k.expr[M]))return!1;return!0}return!1}substituteConstants(){const k=o(this.expr);return k===this.expr?this:s.create(k,this.negated)}evaluate(k){for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].evaluate(k))return!1;return!0}static _normalizeArr(k,M){const F=[];let V=!1;for(const N of k)if(!!N){if(N.type===1){V=!0;continue}if(N.type===0)return C.INSTANCE;if(N.type===6){F.push(...N.expr);continue}F.push(N)}if(F.length===0&&V)return f.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(I);for(let N=1;N<F.length;N++)F[N-1].equals(F[N])&&(F.splice(N,1),N--);if(F.length===1)return F[0];for(;F.length>1;){const N=F[F.length-1];if(N.type!==9)break;F.pop();const G=F.pop(),J=F.length===0,j=a.create(N.expr.map(q=>s.create([q,G],null)),null,J);j&&(F.push(j),F.sort(I))}return F.length===1?F[0]:new s(F,M)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(let M of this.expr)k.push(...M.keys());return k}map(k){return new s(this.expr.map(M=>M.map(k)),null)}negate(){if(!this.negated){const k=[];for(let M of this.expr)k.push(M.negate());this.negated=a.create(k,this,!0)}return this.negated}}class a{constructor(k,M){this.expr=k,this.negated=M,this.type=9}static create(k,M,F){return a._normalizeArr(k,M,F)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let M=0,F=this.expr.length;M<F;M++){const V=I(this.expr[M],k.expr[M]);if(V!==0)return V}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].equals(k.expr[M]))return!1;return!0}return!1}substituteConstants(){const k=o(this.expr);return k===this.expr?this:a.create(k,this.negated,!1)}evaluate(k){for(let M=0,F=this.expr.length;M<F;M++)if(this.expr[M].evaluate(k))return!0;return!1}static _normalizeArr(k,M,F){let V=[],N=!1;if(k){for(let G=0,J=k.length;G<J;G++){const j=k[G];if(!!j){if(j.type===0){N=!0;continue}if(j.type===1)return f.INSTANCE;if(j.type===9){V=V.concat(j.expr);continue}V.push(j)}}if(V.length===0&&N)return C.INSTANCE;V.sort(I)}if(V.length!==0){if(V.length===1)return V[0];for(let G=1;G<V.length;G++)V[G-1].equals(V[G])&&(V.splice(G,1),G--);if(V.length===1)return V[0];if(F){for(let G=0;G<V.length;G++)for(let J=G+1;J<V.length;J++)_(V[G],V[J])&&(V.splice(J,1),J--);if(V.length===1)return V[0]}return new a(V,M)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(let M of this.expr)k.push(...M.keys());return k}map(k){return new a(this.expr.map(M=>M.map(k)),null)}negate(){if(!this.negated){let k=[];for(let M of this.expr)k.push(M.negate());for(;k.length>1;){const M=k.shift(),F=k.shift(),V=[];for(const G of O(M))for(const J of O(F))V.push(s.create([G,J],null));const N=k.length===0;k.unshift(a.create(V,null,N))}this.negated=k[0]}return this.negated}}class h extends p{constructor(k,M,F){super(k,null);this._defaultValue=M,typeof F=="object"?h._info.push({...F,key:k}):F!==!0&&h._info.push({key:k,description:F,type:M!=null?typeof M:void 0})}static all(){return h._info.values()}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return u.create(this.key,k)}notEqualsTo(k){return g.create(this.key,k)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(U,k){return U<k?-1:U>k?1:0}function P(U,k,M,F){return U<M?-1:U>M?1:k<F?-1:k>F?1:0}function _(U,k){if(k.type===6&&U.type!==9&&U.type!==6){for(const V of k.expr)if(U.equals(V))return!0}const M=U.negate(),F=O(M).concat(O(k));F.sort(I);for(let V=0;V<F.length;V++){const G=F[V].negate();for(let J=V+1;J<F.length;J++){const j=F[J];if(G.equals(j))return!0}}return!1}e.implies=_;function O(U){return U.type===9?U.expr:[U]}}),define(ne[80],ie([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function n(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=n}),define(ne[81],ie([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(ne[15],ie([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[82],ie([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var n;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(n=e.RecommendationSource||(e.RecommendationSource={}));function L(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=L;var T;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(ne[13],ie([0,1,39,10,26,14,7,137,6]),function(K,e,D,n,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function E(N){return N.create===!0}e.isFileOpenForWriteOptions=E;var I;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var C;(function(N){N[N.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var f;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock",N[N.FileAtomicRead=16384]="FileAtomicRead"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=p;function u(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=u;function m(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function d(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=d;function g(N){return p(N)?!!(N.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var w;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class y extends Error{constructor(G,J){super(G);this.code=J}}e.FileSystemProviderError=y;function S(N,G){const J=new y(N.toString(),G);return r(J,G),J}e.createFileSystemProviderError=S;function l(N){return N||S((0,R.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=l;function r(N,G){return N.name=G?`${G} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=r;function c(N){if(!N)return w.Unknown;if(N instanceof y)return N.code;const G=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!G)return w.Unknown;switch(G[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=c;function i(N){if(N instanceof v)return N.fileOperationResult;switch(c(N)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var t;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class o{constructor(G,J,j){this.resource=G,this.operation=J,this.target=j}isOperation(G){return this.operation===G}}e.FileOperationEvent=o;var s;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class a{constructor(G,J){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=G;const j=new Map;for(const q of G){const X=j.get(q.type);switch(X?X.push([q.resource,q]):j.set(q.type,[[q.resource,q]]),q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}}for(const[q,X]of j)switch(q){case 1:this.added=D.TernarySearchTree.forUris(()=>J),this.added.fill(X);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>J),this.updated.fill(X);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>J),this.deleted.fill(X);break}}contains(G,...J){return this.doContains(G,{includeChildren:!1},...J)}affects(G,...J){return this.doContains(G,{includeChildren:!0},...J)}doContains(G,J,...j){if(!G)return!1;const q=j.length>0;return!!((!q||j.includes(1))&&(this.added?.get(G)||J.includeChildren&&this.added?.findSuperstr(G))||(!q||j.includes(0))&&(this.updated?.get(G)||J.includeChildren&&this.updated?.findSuperstr(G))||(!q||j.includes(2))&&(this.deleted?.findSubstr(G)||J.includeChildren&&this.deleted?.findSuperstr(G)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=a;function h(N,G,J){return!N||!G||N===G||G.length>N.length?!1:(G.charAt(G.length-1)!==n.sep&&(G+=n.sep),J?(0,L.startsWithIgnoreCase)(N,G):N.indexOf(G)===0)}e.isParent=h;class v extends Error{constructor(G,J,j){super(G);this.fileOperationResult=J,this.options=j}}e.FileOperationError=v;class P extends v{constructor(G,J,j){super(G,2,j);this.stat=J}}e.NotModifiedSinceFileOperationError=P;var _;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=U;async function k(N,G){if(!G.hasProvider(A.URI.from({scheme:N.scheme})))return new Promise(J=>{const j=G.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===N.scheme&&q.added&&(j.dispose(),J())})})}e.whenProviderRegistered=k,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(G){return(0,T.isNumber)(G)||(G=0),G<M.KB?(0,R.localize)(1,null,G.toFixed(0)):G<M.MB?(0,R.localize)(2,null,(G/M.KB).toFixed(2)):G<M.GB?(0,R.localize)(3,null,(G/M.MB).toFixed(2)):G<M.TB?(0,R.localize)(4,null,(G/M.GB).toFixed(2)):(0,R.localize)(5,null,(G/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var F;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function V(N){return{maxFileSize:N===0?300*M.MB:16*M.GB,maxHeapSize:N===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=V});var Y=this&&this.__param||function(K,e){return function(D,n){e(D,n,K)}};define(ne[159],ie([0,1,83,40,13]),function(K,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(R){this.fileService=R}async checksum(R){const b=(await this.fileService.readFileStream(R)).value;return new Promise((E,I)=>{const C=(0,D.createHash)("md5");(0,n.listenStream)(b,{onData:f=>C.update(f.buffer),onError:f=>I(f),onEnd:()=>E(C.digest("base64").replace(/=+$/,""))})})}};T=de([Y(0,L.IFileService)],T),e.ChecksumService=T}),define(ne[160],ie([0,1,253,127,150,13]),function(K,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function A(f,p){const u={onUnknownOption:d=>{console.warn((0,n.localize)(0,null,d))},onMultipleValues:(d,g)=>{console.warn((0,n.localize)(1,null,d,g))},onDeprecatedOption:(d,g)=>{console.warn((0,n.localize)(2,null,d,g))}},m=(0,L.parseArgs)(f,L.OPTIONS,p?u:void 0);return m.goto&&m._.forEach(d=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(d),(0,n.localize)(3,null))),m["max-memory"]&&D(parseInt(m["max-memory"])>=T.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${T.MIN_MAX_MEMORY_SIZE_MB} MB.`),m}function R(f){const p=f.findIndex(u=>!/^-/.test(u));if(p>-1)return[...f.slice(0,p),...f.slice(p+1)]}function b(f){let[,...p]=f;process.env.VSCODE_DEV&&(p=R(p)||[]);const u=!C(process.env);return A(p,u)}e.parseMainProcessArgv=b;function E(f){const[,,...p]=f;return A(p,!0)}e.parseCLIProcessArgv=E;function I(f,...p){const u=f.indexOf("--");return u===-1?f.push(...p):f.splice(u,0,...p),f}e.addArg=I;function C(f){return f.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),define(ne[161],ie([0,1,45,10,128,23,37,9,4,29,123,160,5]),function(K,e,D,n,L,T,A,R,b,E,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const p=1e4;let u;async function m(g,w,y){return w["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(y)&&!w["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(y)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=f.Promises.withAsyncBody(async(S,l)=>{const r=new T.CancellationTokenSource,c=setTimeout(()=>{r.dispose(!0),l(new Error((0,L.localize)(0,null)))},p);try{S(await d(g,r.token))}catch(i){!(0,R.isCancellationError)(i)&&!r.token.isCancellationRequested?l(new Error((0,L.localize)(1,null,(0,A.toErrorMessage)(i)))):S({})}finally{clearTimeout(c),r.dispose()}})),u)}e.getResolvedShellEnv=m;async function d(g,w){const y=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",y);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",S);const l=(0,E.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(l+"(.*)"+l),c={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};g.trace("getUnixShellEnvironment#env",c);const i=await(0,I.getSystemShell)(b.OS,c);return g.trace("getUnixShellEnvironment#shell",i),new Promise((t,o)=>{if(w.isCancellationRequested)return o((0,R.canceled)());const s=(0,n.basename)(i);let a,h;const v=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(s)?(a=`& '${process.execPath}' ${v} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,h=["-Login","-Command"]):(a=`'${process.execPath}' ${v} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,s==="tcsh"?h=["-ic"]:h=["-ilc"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),a);const P=(0,D.spawn)(i,[...h,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:c});w.onCancellationRequested(()=>(P.kill(),o((0,R.canceled)()))),P.on("error",U=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(U)),o(U)});const _=[];P.stdout.on("data",U=>_.push(U));const O=[];P.stderr.on("data",U=>O.push(U)),P.on("close",(U,k)=>{const M=Buffer.concat(_).toString("utf8");g.trace("getUnixShellEnvironment#raw",M);const F=Buffer.concat(O).toString("utf8");if(F.trim()&&g.trace("getUnixShellEnvironment#stderr",F),U||k)return o(new Error((0,L.localize)(2,null,U,k)));const V=r.exec(M),N=V?V[1]:"{}";try{const G=JSON.parse(N);y?G.ELECTRON_RUN_AS_NODE=y:delete G.ELECTRON_RUN_AS_NODE,S?G.ELECTRON_NO_ATTACH_CONSOLE=S:delete G.ELECTRON_NO_ATTACH_CONSOLE,delete G.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",G),t(G)}catch(G){g.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(G)),o(G)}})})}}),define(ne[162],ie([0,1,17,37,9,3,2,40,7,29,13]),function(K,e,D,n,L,T,A,R,b,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class C extends A.Disposable{constructor(p,u){super();this.channel=p,this.extraCapabilities=u,this.onDidChangeCapabilities=T.Event.None,this._onDidChange=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,E.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(p){return this.channel.call("stat",[p])}readdir(p){return this.channel.call("readdir",[p])}async readFile(p,u){const{buffer:m}=await this.channel.call("readFile",[p,u]);return m}readFileStream(p,u,m){const d=(0,R.newWriteableStream)(w=>D.VSBuffer.concat(w.map(y=>D.VSBuffer.wrap(y))).buffer),g=this.channel.listen("readFileStream",[p,u])(w=>{if(w instanceof D.VSBuffer)d.write(w.buffer);else{if(w==="end")d.end();else{let y=w;y instanceof Error||(y=(0,I.createFileSystemProviderError)((0,n.toErrorMessage)(y),I.FileSystemProviderErrorCode.Unknown)),d.error(y),d.end()}g.dispose()}});return m.onCancellationRequested(()=>{d.error((0,L.canceled)()),d.end(),g.dispose()}),d}writeFile(p,u,m){return this.channel.call("writeFile",[p,D.VSBuffer.wrap(u),m])}open(p,u){return this.channel.call("open",[p,u])}close(p){return this.channel.call("close",[p])}async read(p,u,m,d,g){const[w,y]=await this.channel.call("read",[p,u,g]);return m.set(w.buffer.slice(0,y),d),y}write(p,u,m,d,g){return this.channel.call("write",[p,u,D.VSBuffer.wrap(m),d,g])}mkdir(p){return this.channel.call("mkdir",[p])}delete(p,u){return this.channel.call("delete",[p,u])}rename(p,u,m){return this.channel.call("rename",[p,u,m])}copy(p,u,m){return this.channel.call("copy",[p,u,m])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(p=>{if(Array.isArray(p)){const u=p;this._onDidChange.fire(u.map(m=>({resource:b.URI.revive(m.resource),type:m.type})))}else{const u=p;this._onDidWatchError.fire(u)}}))}watch(p,u){const m=(0,E.generateUuid)();return this.channel.call("watch",[this.sessionId,m,p,u]),(0,A.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,m]))}}e.DiskFileSystemProviderClient=C}),define(ne[84],ie([0,1,17,9,138,13]),function(K,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(I,C,f,p,u,m){let d;try{await R(I,C,f,p,u,m)}catch(g){d=g}finally{d&&u.errorTransformer&&(d=u.errorTransformer(d)),typeof d!="undefined"&&f.error(d),f.end()}}e.readFileIntoStream=A;async function R(I,C,f,p,u,m){b(m);const d=await I.open(C,{create:!1});try{b(m);let g=0,w=0,y=u&&typeof u.length=="number"?u.length:void 0,S=D.VSBuffer.alloc(Math.min(u.bufferSize,typeof y=="number"?y:u.bufferSize)),l=u&&typeof u.position=="number"?u.position:0,r=0;do w=await I.read(d,l,S.buffer,r,S.byteLength-r),l+=w,r+=w,g+=w,typeof y=="number"&&(y-=w),r===S.byteLength&&(await f.write(p(S)),S=D.VSBuffer.alloc(Math.min(u.bufferSize,typeof y=="number"?y:u.bufferSize)),r=0);while(w>0&&(typeof y!="number"||y>0)&&b(m)&&E(g,u));if(r>0){let c=r;typeof y=="number"&&(c=Math.min(r,y)),f.write(p(S.slice(0,c)))}}catch(g){throw(0,T.ensureFileSystemProviderError)(g)}finally{await I.close(d)}}function b(I){if(I.isCancellationRequested)throw(0,n.canceled)();return!0}function E(I,C){if(C?.limits){if(typeof C.limits.memory=="number"&&I>C.limits.memory)throw(0,T.createFileSystemProviderError)((0,L.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof C.limits.size=="number"&&I>C.limits.size)throw(0,T.createFileSystemProviderError)((0,L.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[52],ie([0,1,2,4,7,13]),function(K,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function A(p){return p.recursive===!0}e.isRecursiveWatchRequest=A;class R extends D.Disposable{constructor(u,m,d,g){super();this.onFileChanges=u,this.onLogMessage=m,this.verboseLogging=d,this.options=g,this.watcherDisposables=this._register(new D.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const u=new D.DisposableStore;this.watcherDisposables.value=u,this.watcher=this.createWatcher(u),this.watcher.setVerboseLogging(this.verboseLogging),u.add(this.watcher.onDidChangeFile(m=>this.onFileChanges(m))),u.add(this.watcher.onDidLogMessage(m=>this.onLogMessage(m))),u.add(this.watcher.onDidError(m=>this.onError(m)))}onError(u){this.options.restartOnError?this.restartCounter<R.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${u}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${u}`):this.error(u)}restart(u){this.restartCounter++,this.init(),this.watch(u)}async watch(u){this.requests=u,await this.watcher?.watch(u)}async setVerboseLogging(u){this.verboseLogging=u,await this.watcher?.setVerboseLogging(u)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${u}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=R,R.MAX_RESTARTS=5;class b extends R{constructor(u,m,d){super(u,m,d,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=b;class E extends R{constructor(u,m,d){super(u,m,d,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=E;function I(p){return p.map(u=>({type:u.type,resource:L.URI.file(u.path)}))}e.toFileChanges=I;function C(p){const u=new f;for(const m of p)u.processEvent(m);return u.coalesce()}e.coalesceEvents=C;class f{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(u){return n.isLinux?u.path:u.path.toLowerCase()}processEvent(u){const m=this.mapPathToChange.get(this.toKey(u));let d=!1;if(m){const g=m.type,w=u.type;m.path!==u.path&&(u.type===2||u.type===1)?d=!0:g===1&&w===2?(this.mapPathToChange.delete(this.toKey(u)),this.coalesced.delete(m)):g===2&&w===1?m.type=0:g===1&&w===0||(m.type=w)}else d=!0;d&&(this.coalesced.add(u),this.mapPathToChange.set(this.toKey(u),u))}coalesce(){const u=[],m=[];return Array.from(this.coalesced).filter(d=>d.type!==2?(u.push(d),!1):!0).sort((d,g)=>d.path.length-g.path.length).filter(d=>m.some(g=>(0,T.isParent)(d.path,g,!n.isLinux))?!1:(m.push(d.path),!0)).concat(u)}}}),define(ne[163],ie([0,1,50,5,23,41,109,2,71,10,4,114,22,52]),function(K,e,D,n,L,T,A,R,b,E,I,C,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class u extends R.Disposable{constructor(g,w,y,S){super();this.request=g,this.onDidFilesChange=w,this.onLogMessage=y,this.verboseLogging=S,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.onDidFilesChange(l)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(u.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(l=>(0,A.parse)(l)),this.cts=new L.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const g=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const w=await f.Promises.stat(g);this._register(await this.doWatch(g,w.isDirectory()))}catch(g){g.code!=="ENOENT"?this.error(g):this.trace(g)}}async normalizePath(g){let w=g.path;try{w=await f.Promises.realpath(g.path),g.path===w&&(w=await(0,C.realcase)(g.path)??g.path),g.path!==w&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${g.path}, real: ${w})`)}catch{}return w}async doWatch(g,w){if(I.isMacintosh&&(0,T.isEqualOrParent)(g,"/Volumes/"))return this.error(`Refusing to watch ${g} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const y=new L.CancellationTokenSource(this.cts.token);let S=new R.DisposableStore;try{const l=(0,E.basename)(g),r=(0,D.watch)(g);S.add((0,R.toDisposable)(()=>{r.removeAllListeners(),r.close()})),this.trace(`Started watching: '${g}'`);const c=new Set;if(w)try{for(const t of await f.Promises.readdir(g))c.add(t)}catch(t){this.error(t)}const i=new Map;S.add((0,R.toDisposable)(()=>{for(const[,t]of i)t.dispose();i.clear()})),r.on("error",(t,o)=>{this.error(`Failed to watch ${g} for changes using fs.watch() (${t}, ${o})`),this.dispose()}),r.on("change",(t,o)=>{if(y.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${o}`);let s="";if(o&&(s=o.toString(),I.isMacintosh&&(s=(0,b.normalizeNFC)(s))),!(!s||t!=="change"&&t!=="rename"))if(w)if(t==="rename"){i.get(s)?.dispose();const a=setTimeout(async()=>{if(i.delete(s),s===l&&!await f.Promises.exists(g)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const h=await this.existsChildStrictCase((0,E.join)(g,s));if(y.token.isCancellationRequested)return;let v;h?c.has(s)?v=0:(v=1,c.add(s)):(c.delete(s),v=2),this.onFileChange({path:(0,E.join)(this.request.path,s),type:v})},u.FILE_DELETE_HANDLER_DELAY);i.set(s,(0,R.toDisposable)(()=>clearTimeout(a)))}else{let a;c.has(s)?a=0:(a=1,c.add(s)),this.onFileChange({path:(0,E.join)(this.request.path,s),type:a})}else if(t==="rename"||s!==l){const a=setTimeout(async()=>{const h=await f.Promises.exists(g);y.token.isCancellationRequested||(h?(this.onFileChange({path:this.request.path,type:0},!0),S.add(await this.doWatch(g,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},u.FILE_DELETE_HANDLER_DELAY);S.clear(),S.add((0,R.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(l){await f.Promises.exists(g)&&!y.token.isCancellationRequested&&this.error(`Failed to watch ${g} for changes using fs.watch() (${l.toString()})`)}return(0,R.toDisposable)(()=>{y.dispose(!0),S.dispose()})}async onFileChange(g,w=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`),!w&&this.excludes.some(y=>y(g.path))?this.verboseLogging&&this.trace(` >> ignored ${g.path}`):this.fileChangesBuffer.push(g);try{await this.fileChangesDelayer.trigger(async()=>{const y=this.fileChangesBuffer;this.fileChangesBuffer=[];const S=(0,p.coalesceEvents)(y);if(S.length>0){if(this.verboseLogging)for(const r of S)this.trace(`>> normalized ${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.path}`);this.throttledFileChangesWorker.work(S)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${S[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${S.length}, most recent change: ${S[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(g){if(I.isLinux)return f.Promises.exists(g);try{const w=(0,E.basename)(g);return(await f.Promises.readdir((0,E.dirname)(g))).some(S=>S===w)}catch(w){return this.trace(w),!1}}setVerboseLogging(g){this.verboseLogging=g}error(g){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${g}`})}warn(g){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${g}`})}trace(g){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=u,u.FILE_DELETE_HANDLER_DELAY=100,u.FILE_CHANGES_HANDLER_DELAY=50;async function m(d,g,w,y,S=512){const l=await f.Promises.open(d,"r"),r=Buffer.allocUnsafe(S),c=new L.CancellationTokenSource(y);let i,t=!1;const o={path:d,excludes:[],recursive:!1},s=new u(o,a=>{(async()=>{for(const{type:h}of a)if(h===0){if(t)return;t=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:v}=await f.Promises.read(l,r,0,S,null);if(!v||c.token.isCancellationRequested)break;g(r.slice(0,v))}}catch(v){i=new Error(v),c.dispose(!0)}finally{t=!1}}})()});return await s.ready,w(),new Promise((a,h)=>{c.token.onCancellationRequested(async()=>{s.dispose();try{await f.Promises.close(l)}catch(v){i=new Error(v)}i?h(i):a()})})}e.watchFileContents=m}),define(ne[164],ie([0,1,16,3,2,4,163]),function(K,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends L.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new n.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=n.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(E){const I=this.normalizeRequests(E),C=I.filter(p=>{const u=this.watchers.get(p.path);return u?!(0,D.equals)(u.request.excludes,p.excludes):!0}),f=Array.from(this.watchers.values()).filter(({request:p})=>!I.find(u=>u.path===p.path&&(0,D.equals)(u.excludes,p.excludes))).map(({request:p})=>p.path);C.length&&this.trace(`Request to start watching: ${C.map(p=>`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"})`).join(",")}`),f.length&&this.trace(`Request to stop watching: ${f.join(",")}`);for(const p of f)this.stopWatching(p);for(const p of C)this.startWatching(p)}startWatching(E){const I=new A.NodeJSFileWatcherLibrary(E,f=>this._onDidChangeFile.fire(f),f=>this._onDidLogMessage.fire(f),this.verboseLogging),C={request:E,instance:I};this.watchers.set(E.path,C)}async stop(){for(const[E]of this.watchers)this.stopWatching(E);this.watchers.clear()}stopWatching(E){const I=this.watchers.get(E);I&&(this.watchers.delete(E),I.instance.dispose())}normalizeRequests(E){const I=new Map;for(const C of E){const f=T.isLinux?C.path:C.path.toLowerCase();I.set(f,C)}return Array.from(I.values())}async setVerboseLogging(E){this.verboseLogging=E;for(const[,I]of this.watchers)I.instance.setVerboseLogging(E)}trace(E){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(E)})}toMessage(E,I){return I?`[File Watcher (node.js)] ${E} (path: ${I.request.path})`:`[File Watcher (node.js)] ${E}`}}e.NodeJSWatcher=R}),define(ne[165],ie([0,1,52,164]),function(K,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class L extends D.AbstractNonRecursiveWatcherClient{constructor(A,R,b){super(A,R,b);this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=L}),define(ne[166],ie([0,1,18,36,58,52]),function(K,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends T.AbstractUniversalWatcherClient{constructor(b,E,I){super(b,E,I);this.init()}createWatcher(b){const E=b.add(new L.Client(D.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(E.onDidProcessExit(({code:I,signal:C})=>this.onError(`terminated by itself with code ${I}, signal: ${C}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(E.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(ne[85],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...L){this._entries=new Map;for(let[T,A]of L)this.set(T,A)}set(L,T){const A=this._entries.get(L);return this._entries.set(L,T),A}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=D}),define(ne[167],ie([0,1,5,9,51,156,6,85]),function(K,e,D,n,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class E extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class I{constructor(u=new R.ServiceCollection,m=!1,d){this._activeInstantiations=new Set,this._services=u,this._strict=m,this._parent=d,this._services.set(A.IInstantiationService,this)}createChild(u){return new I(u,this._strict,this)}invokeFunction(u,...m){let d=f.traceInvocation(u),g=!1;try{return u({get:y=>{if(g)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const S=this._getOrCreateServiceInstance(y,d);if(!S)throw new Error(`[invokeFunction] unknown service '${y}'`);return S}},...m)}finally{g=!0,d.stop()}}createInstance(u,...m){let d,g;return u instanceof L.SyncDescriptor?(d=f.traceCreation(u.ctor),g=this._createInstance(u.ctor,u.staticArguments.concat(m),d)):(d=f.traceCreation(u),g=this._createInstance(u,m,d)),d.stop(),g}_createInstance(u,m=[],d){let g=A._util.getServiceDependencies(u).sort((S,l)=>S.index-l.index),w=[];for(const S of g){let l=this._getOrCreateServiceInstance(S.id,d);if(!l&&this._strict&&!S.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${S.id}.`);w.push(l)}let y=g.length>0?g[0].index:m.length;if(m.length!==y){console.warn(`[createInstance] First service dependency of ${u.name} at position ${y+1} conflicts with ${m.length} static arguments`);let S=y-m.length;S>0?m=m.concat(new Array(S)):m=m.slice(0,y)}return new u(...[...m,...w])}_setServiceInstance(u,m){if(this._services.get(u)instanceof L.SyncDescriptor)this._services.set(u,m);else if(this._parent)this._parent._setServiceInstance(u,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let m=this._services.get(u);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):m}_getOrCreateServiceInstance(u,m){let d=this._getServiceInstanceOrDescriptor(u);return d instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,d,m.branch(u,!0)):(m.branch(u,!1),d)}_safeCreateAndCacheServiceInstance(u,m,d){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,m,d)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,m,d){const g=new T.Graph(S=>S.id.toString());let w=0;const y=[{id:u,desc:m,_trace:d}];for(;y.length;){const S=y.pop();if(g.lookupOrInsertNode(S),w++>1e3)throw new E(g);for(let l of A._util.getServiceDependencies(S.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(l.id);if(!r&&!l.optional&&console.warn(`[createInstance] ${u} depends on ${l.id} which is NOT registered.`),r instanceof L.SyncDescriptor){const c={id:l.id,desc:r,_trace:S._trace.branch(l.id,!0)};g.insertEdge(S,c),y.push(c)}}}for(;;){const S=g.roots();if(S.length===0){if(!g.isEmpty())throw new E(g);break}for(const{data:l}of S){if(this._getServiceInstanceOrDescriptor(l.id)instanceof L.SyncDescriptor){const c=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,c)}g.removeNode(l)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,m,d=[],g,w){if(this._services.get(u)instanceof L.SyncDescriptor)return this._createServiceInstance(m,d,g,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,m,d,g,w);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(u,m=[],d,g){if(d){const w=new D.IdleValue(()=>this._createInstance(u,m,g));return new Proxy(Object.create(null),{get(y,S){if(S in y)return y[S];let l=w.value,r=l[S];return typeof r!="function"||(r=r.bind(l),y[S]=r),r},set(y,S,l){return w.value[S]=l,!0}})}else return this._createInstance(u,m,g)}}e.InstantiationService=I;var C;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(C||(C={}));class f{constructor(u,m){this.type=u,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return b?new f(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(u){return b?new f(0,u.name):f._None}branch(u,m){let d=new f(2,u.toString());return this._dep.push([u,m,d]),d}stop(){let u=Date.now()-this._start;f._totals+=u;let m=!1;function d(w,y){let S=[],l=new Array(w+1).join("	");for(const[r,c,i]of y._dep)if(c&&i){m=!0,S.push(`${l}CREATES -> ${r}`);let t=d(w+1,i);t&&S.push(t)}else S.push(`${l}uses -> ${r}`);return S.join(`
`)}let g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(u>2||m)&&console.log(g.join(`
`))}}e.Trace=f,f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(ne[168],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(L,T){this.server=L,this.router=T}getChannel(L){return this.server.getChannel(L,this.router)}registerChannel(L,T){this.server.registerChannel(L,T)}}e.MessagePortMainProcessService=D}),define(ne[169],ie([0,1,36,51,79,6]),function(K,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(p,u,m){const d=m.getChannel(p);return R(u)?new u.channelClientCtor(d):D.ProxyChannel.toService(d,u?.proxyOptions)}}function R(f){return!!f?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let b=class extends A{constructor(p,u,m){super(p,u,m)}};b=de([Y(2,e.IMainProcessService)],b);function E(f,p,u){(0,L.registerSingleton)(f,new n.SyncDescriptor(b,[p,u],u?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=E,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let I=class extends A{constructor(p,u,m){super(p,u,m)}};I=de([Y(2,e.ISharedProcessService)],I);function C(f,p,u){(0,L.registerSingleton)(f,new n.SyncDescriptor(I,[p,u],u?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=C}),define(ne[59],ie([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,D.createDecorator)("localizationsService");function n(L){if(typeof L.languageId!="string"||!Array.isArray(L.translations)||L.translations.length===0)return!1;for(const T of L.translations)if(typeof T.id!="string"||typeof T.path!="string")return!1;return!(L.languageName&&typeof L.languageName!="string"||L.localizedLanguageName&&typeof L.localizedLanguageName!="string")}e.isValidLocalization=n}),define(ne[170],ie([0,1,2,59]),function(K,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let L=class extends D.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};L=de([Y(0,n.ILocalizationsService)],L),e.LocalizationsUpdater=L}),define(ne[8],ie([0,1,37,3,2,4,6]),function(K,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function R(){return new Date().toISOString()}var b;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function E(c,i,t){switch(i){case b.Trace:c.trace(t);break;case b.Debug:c.debug(t);break;case b.Info:c.info(t);break;case b.Warning:c.warn(t);break;case b.Error:c.error(t);break;case b.Critical:c.critical(t);break;default:throw new Error("Invalid log level")}}e.log=E;function I(c){let i="";for(let t=0;t<c.length;t++){let o=c[t];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}i+=(t>0?" ":"")+o}return i}e.format=I;class C extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class f extends C{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...t){this.checkLogLevel(b.Trace)&&this.log(b.Trace,I([i,...t]))}debug(i,...t){this.checkLogLevel(b.Debug)&&this.log(b.Debug,I([i,...t]))}info(i,...t){this.checkLogLevel(b.Info)&&this.log(b.Info,I([i,...t]))}warn(i,...t){this.checkLogLevel(b.Warning)&&this.log(b.Warning,I([i,...t]))}error(i,...t){if(this.checkLogLevel(b.Error))if(i instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=i.stack,this.log(b.Error,I(o))}else this.log(b.Error,I([i,...t]))}critical(i,...t){this.checkLogLevel(b.Critical)&&this.log(b.Critical,I([i,...t]))}flush(){}}e.AbstractMessageLogger=f;class p extends C{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!T.isWindows}trace(i,...t){this.getLevel()<=b.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...t):console.log(`[main ${R()}]`,i,...t))}debug(i,...t){this.getLevel()<=b.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...t):console.log(`[main ${R()}]`,i,...t))}info(i,...t){this.getLevel()<=b.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...t):console.log(`[main ${R()}]`,i,...t))}warn(i,...t){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,i,...t):console.warn(`[main ${R()}]`,i,...t))}error(i,...t){this.getLevel()<=b.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,i,...t):console.error(`[main ${R()}]`,i,...t))}critical(i,...t){this.getLevel()<=b.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,i,...t):console.error(`[main ${R()}]`,i,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class u extends C{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...t){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",i,...t)}debug(i,...t){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...t)}info(i,...t){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",i,...t)}warn(i,...t){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",i,...t)}error(i,...t){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",i,...t)}critical(i,...t){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...t)}dispose(){}flush(){}}e.ConsoleLogger=u;class m extends C{constructor(i,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(t)}trace(i,...t){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(i),...t])}debug(i,...t){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(i),...t])}info(i,...t){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(i),...t])}warn(i,...t){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(i),...t])}error(i,...t){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(i),...t])}critical(i,...t){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(i),...t])}extractMessage(i){return typeof i=="string"?i:(0,D.toErrorMessage)(i,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class d extends C{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const t of this.logServices)t.setLevel(i);super.setLevel(i)}trace(i,...t){for(const o of this.logServices)o.trace(i,...t)}debug(i,...t){for(const o of this.logServices)o.debug(i,...t)}info(i,...t){for(const o of this.logServices)o.info(i,...t)}warn(i,...t){for(const o of this.logServices)o.warn(i,...t)}error(i,...t){for(const o of this.logServices)o.error(i,...t)}critical(i,...t){for(const o of this.logServices)o.critical(i,...t)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=d;class g extends L.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...t){this.logger.trace(i,...t)}debug(i,...t){this.logger.debug(i,...t)}info(i,...t){this.logger.info(i,...t)}warn(i,...t){this.logger.warn(i,...t)}error(i,...t){this.logger.error(i,...t)}critical(i,...t){this.logger.critical(i,...t)}flush(){this.logger.flush()}}e.LogService=g;class w extends L.Disposable{constructor(i,t){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(o))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,t){let o=this.loggers.get(i.toString());return o||(o=this.doCreateLogger(i,t?.always?b.Trace:this.logLevel,t),this.loggers.set(i.toString(),o),t?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class y{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(i){}getLevel(){return b.Info}trace(i,...t){}debug(i,...t){}info(i,...t){}warn(i,...t){}error(i,...t){}critical(i,...t){}dispose(){}flush(){}}e.NullLogService=y;function S(c){if(c.verbose)return b.Trace;if(typeof c.logLevel=="string"){const i=l(c.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=S;function l(c){switch(c){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=l;function r(c){switch(c){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=r}),define(ne[171],ie([0,1,5,9,2,10,22,15,8]),function(K,e,D,n,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let E=class extends L.Disposable{constructor(C,f){super();this.environmentService=C,this.logService=f,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const C=(0,T.basename)(this.environmentService.logsPath),f=(0,T.dirname)(this.environmentService.logsPath),m=(await A.Promises.readdir(f)).filter(g=>/^\d{8}T\d{6}$/.test(g)).sort().filter(g=>g!==C),d=m.slice(0,Math.max(0,m.length-9));d.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${d.join(", ")}'`),await Promise.all(d.map(g=>A.Promises.rm((0,T.join)(f,g)))))}catch(C){(0,n.onUnexpectedError)(C)}}};E=de([Y(0,R.IEnvironmentService),Y(1,b.ILogService)],E),e.LogsDataCleaner=E}),define(ne[172],ie([0,1,5,9,2,10,22,15,8]),function(K,e,D,n,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let E=class gt extends L.Disposable{constructor(C,f,p){super();this.backupWorkspacesPath=C,this.environmentService=f,this.logService=p,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const C=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),p=JSON.parse(C).emptyWorkspaceInfos.map(m=>m.backupFolder),u=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(u.map(async m=>{m.length===gt.NON_EMPTY_WORKSPACE_ID_LENGTH||m===gt.EXTENSION_DEV_EMPTY_WINDOW_ID||p.indexOf(m)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${m}.`),await A.Promises.rm((0,T.join)(this.environmentService.workspaceStorageHome.fsPath,m)))}))}catch(C){(0,n.onUnexpectedError)(C)}}};E.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,E.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",E=de([Y(1,R.INativeEnvironmentService),Y(2,b.ILogService)],E),e.StorageDataCleaner=E}),define(ne[173],ie([0,1,45,5,37,3,2,18,10,22,15,8]),function(K,e,D,n,L,T,A,R,b,E,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let f=class extends A.Disposable{constructor(u,m){super();this.environmentService=u,this.logService=m,this.processesLimiter=new n.Limiter(5)}async postUninstall(u){const m=this.parseScript(u,"uninstall");return m&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(m.script,"uninstall",m.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),d=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${d}`)))),E.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,d=>this.logService.error("Error while removing extension storage path",d))}parseScript(u,m){const d=`vscode:${m}`;if(u.location.scheme===R.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[d]=="string"){const g=u.manifest.scripts[d].split(" ");return g.length<2||g[0]!=="node"||!g[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${d} should be a node script`),null):{script:(0,b.join)(u.location.fsPath,g[1]),args:g.slice(2)||[]}}return null}runLifecycleHook(u,m,d,g,w){return new Promise((y,S)=>{const l=this.start(u,m,d,w);let r;const c=i=>{r&&(clearTimeout(r),r=null),i?S(i):y(void 0)};l.on("error",i=>{c((0,L.toErrorMessage)(i)||"Unknown")}),l.on("exit",(i,t)=>{c(i?`post-${m} process exited with code ${i}`:void 0)}),g&&(r=setTimeout(()=>{r=null,l.kill(),S("timed out")},5e3))})}start(u,m,d,g){const w={silent:!0,execArgv:void 0},y=(0,D.fork)(u,[`--type=extension-post-${m}`,...d],w);y.stdout.setEncoding("utf8"),y.stderr.setEncoding("utf8");const S=T.Event.fromNodeEventEmitter(y.stdout,"data"),l=T.Event.fromNodeEventEmitter(y.stderr,"data");S(i=>this.logService.info(g.identifier.id,g.manifest.version,`post-${m}`,i)),l(i=>this.logService.error(g.identifier.id,g.manifest.version,`post-${m}`,i));const r=T.Event.any(T.Event.map(S,i=>({data:`%c${i}`,format:[""]})),T.Event.map(l,i=>({data:`%c${i}`,format:["color: red"]})));return T.Event.debounce(r,(i,t)=>i?{data:i.data+t.data,format:[...i.format,...t.format]}:{data:t.data,format:t.format},100)(i=>{console.group(g.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),y}getExtensionStoragePath(u){return(0,b.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};f=de([Y(0,I.IEnvironmentService),Y(1,C.ILogService)],f),e.ExtensionsLifecycle=f}),define(ne[174],ie([0,1,16,5,9,3,2,10,52,8]),function(K,e,D,n,L,T,A,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends A.Disposable{constructor(f,p){super();this.logService=f,this.options=p,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(f,p){return p.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(f,p):this.watchNonRecursive(f,p)}watchUniversal(f,p){const u={path:this.toFilePath(f),excludes:p.excludes,recursive:p.recursive},m=(0,D.insert)(this.universalPathsToWatch,u);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{m(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(f=>(0,L.onUnexpectedError)(f))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(p=>this._onDidChangeFile.fire((0,b.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)})));const f=this.options?.watcher?.recursive?.usePolling;if(f===!0)for(const p of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(p)&&(p.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(f))for(const p of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(p)&&f.includes(p.path)&&(p.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(f,p){const u={path:this.toFilePath(f),excludes:p.excludes,recursive:!1},m=(0,D.insert)(this.nonRecursivePathsToWatch,u);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{m(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(f=>(0,L.onUnexpectedError)(f))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(f=>this._onDidChangeFile.fire((0,b.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(f){f.type==="error"&&this._onDidWatchError.fire(f.message),this.logService[f.type](f.message)}toFilePath(f){return(0,R.normalize)(f.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(ne[175],ie([0,1,16,5,17,23,3,70,55,2,39,18,176,19,40,136,13,84,8]),function(K,e,D,n,L,T,A,R,b,E,I,C,f,p,u,m,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let y=class extends E.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(l,r){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,f.mark)(`code/registerFilesystem/${l}`);const c=new E.DisposableStore;return this.provider.set(l,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:r}),c.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new d.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),typeof r.onDidWatchError=="function"&&c.add(r.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),c.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:l}))),(0,E.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:r}),this.provider.delete(l),(0,E.dispose)(c)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(c){r.push(c)}}),!this.provider.has(l)&&await n.Promises.settled(r)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,r){const c=this.provider.get(l.scheme);return!!(c&&c.capabilities&r)}listCapabilities(){return b.Iterable.map(this.provider,([l,r])=>({scheme:l,capabilities:r.capabilities}))}async withProvider(l){if(!(0,p.isAbsolutePath)(l))throw new d.FileOperationError((0,m.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const r=this.provider.get(l.scheme);if(!r){const c=new Error;throw c.name="ENOPRO",c.message=(0,m.localize)(1,null,l.toString()),c}return r}async withReadProvider(l){const r=await this.withProvider(l);if((0,d.hasOpenReadWriteCloseCapability)(r)||(0,d.hasReadWriteCapability)(r)||(0,d.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const r=await this.withProvider(l);if((0,d.hasOpenReadWriteCloseCapability)(r)||(0,d.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,r){try{return await this.doResolveFile(l,r)}catch(c){throw(0,d.toFileSystemProviderErrorCode)(c)===d.FileSystemProviderErrorCode.FileNotFound?new d.FileOperationError((0,m.localize)(2,null,this.resourceForError(l)),1):(0,d.ensureFileSystemProviderError)(c)}}async doResolveFile(l,r){const c=await this.withProvider(l),i=this.isPathCaseSensitive(c),t=r?.resolveTo,o=r?.resolveSingleChildDescendants,s=r?.resolveMetadata,a=await c.stat(l);let h;return this.toFileStat(c,l,a,void 0,!!s,(v,P)=>(h||(h=I.TernarySearchTree.forUris(()=>!i),h.set(l,!0),t&&h.fill(!0,t)),h.get(v.resource)||h.findSuperstr(v.resource.with({query:null,fragment:null}))?!0:v.isDirectory&&o?P===1:!1))}async toFileStat(l,r,c,i,t,o){const{providerExtUri:s}=this.getExtUri(l),a={resource:r,name:s.basename(r),isFile:(c.type&d.FileType.File)!=0,isDirectory:(c.type&d.FileType.Directory)!=0,isSymbolicLink:(c.type&d.FileType.SymbolicLink)!=0,mtime:c.mtime,ctime:c.ctime,size:c.size,readonly:Boolean((c.permissions??0)&d.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,d.etag)({mtime:c.mtime,size:c.size})};if(a.isDirectory&&o(a,i)){try{const h=await l.readdir(r),v=await n.Promises.settled(h.map(async([P,_])=>{try{const O=s.joinPath(r,P),U=t?await l.stat(O):{type:_};return await this.toFileStat(l,O,U,h.length,t,o)}catch(O){return this.logService.trace(O),null}}));a.children=(0,D.coalesce)(v)}catch(h){this.logService.trace(h),a.children=[]}return a}return a}async resolveAll(l){return n.Promises.settled(l.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(c){return this.logService.trace(c),{stat:void 0,success:!1}}}))}async exists(l){const r=await this.withProvider(l);try{return!!await r.stat(l)}catch{return!1}}async canCreateFile(l,r){try{await this.doValidateCreateFile(l,r)}catch(c){return c}return!0}async doValidateCreateFile(l,r){if(!r?.overwrite&&await this.exists(l))throw new d.FileOperationError((0,m.localize)(3,null,this.resourceForError(l)),3,r)}async createFile(l,r=L.VSBuffer.fromString(""),c){await this.doValidateCreateFile(l,c);const i=await this.writeFile(l,r);return this._onDidRunOperation.fire(new d.FileOperationEvent(l,0,i)),i}async writeFile(l,r,c){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:t}=this.getExtUri(i);try{await this.validateWriteFile(i,l,c)||await this.mkdirp(i,t.dirname(l));let s;if((0,d.hasReadWriteCapability)(i)&&!(r instanceof L.VSBuffer))if((0,u.isReadableStream)(r)){const a=await(0,u.peekStream)(r,3);a.ended?s=L.VSBuffer.concat(a.buffer):s=a}else s=(0,u.peekReadable)(r,a=>L.VSBuffer.concat(a),3);else s=r;!(0,d.hasOpenReadWriteCloseCapability)(i)||(0,d.hasReadWriteCapability)(i)&&s instanceof L.VSBuffer?await this.doWriteUnbuffered(i,l,c,s):await this.doWriteBuffered(i,l,c,s instanceof L.VSBuffer?(0,L.bufferToReadable)(s):s)}catch(o){throw new d.FileOperationError((0,m.localize)(4,null,this.resourceForError(l),(0,d.ensureFileSystemProviderError)(o).toString()),(0,d.toFileOperationResult)(o),c)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,r,c){if(!!c?.unlock&&!(l.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(r)));let t;try{t=await l.stat(r)}catch{return}if((t.type&d.FileType.Directory)!=0)throw new d.FileOperationError((0,m.localize)(6,null,this.resourceForError(r)),0,c);if(this.throwIfFileIsReadonly(r,t),typeof c?.mtime=="number"&&typeof c.etag=="string"&&c.etag!==d.ETAG_DISABLED&&typeof t.mtime=="number"&&typeof t.size=="number"&&c.mtime<t.mtime&&c.etag!==(0,d.etag)({mtime:c.mtime,size:t.size}))throw new d.FileOperationError((0,m.localize)(7,null),3,c);return t}async readFile(l,r,c){const i=await this.withReadProvider(l);return r?.atomic?this.doReadFileAtomic(i,l,r,c):this.doReadFile(i,l,r,c)}async doReadFileAtomic(l,r,c,i){return new Promise((t,o)=>{this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(l,r,c,i);t(s)}catch(s){o(s)}})})}async doReadFile(l,r,c,i){const t=await this.doReadFileStream(l,r,{...c,preferUnbuffered:!0},i);return{...t,value:await(0,L.streamToBuffer)(t.value)}}async readFileStream(l,r,c){const i=await this.withReadProvider(l);return this.doReadFileStream(i,l,r,c)}async doReadFileStream(l,r,c,i){const t=new T.CancellationTokenSource(i),o=this.validateReadFile(r,c).then(a=>a,a=>{throw t.cancel(),a});let s;try{return typeof c?.etag=="string"&&c.etag!==d.ETAG_DISABLED&&await o,c?.atomic&&(0,d.hasFileAtomicReadCapability)(l)||!((0,d.hasOpenReadWriteCloseCapability)(l)||(0,d.hasFileReadStreamCapability)(l))||(0,d.hasReadWriteCapability)(l)&&c?.preferUnbuffered?s=this.readFileUnbuffered(l,r,c):(0,d.hasFileReadStreamCapability)(l)?s=this.readFileStreamed(l,r,t.token,c):s=this.readFileBuffered(l,r,t.token,c),{...await o,value:s}}catch(a){s&&await(0,u.consumeStream)(s);const h=(0,m.localize)(8,null,this.resourceForError(r),(0,d.ensureFileSystemProviderError)(a).toString());throw a instanceof d.NotModifiedSinceFileOperationError?new d.NotModifiedSinceFileOperationError(h,a.stat,c):new d.FileOperationError(h,(0,d.toFileOperationResult)(a),c)}}readFileStreamed(l,r,c,i=Object.create(null)){const t=l.readFileStream(r,i,c);return(0,u.transform)(t,{data:o=>o instanceof L.VSBuffer?o:L.VSBuffer.wrap(o),error:o=>new d.FileOperationError((0,m.localize)(9,null,this.resourceForError(r),(0,d.ensureFileSystemProviderError)(o).toString()),(0,d.toFileOperationResult)(o),i)},o=>L.VSBuffer.concat(o))}readFileBuffered(l,r,c,i=Object.create(null)){const t=(0,L.newWriteableBufferStream)();return(0,g.readFileIntoStream)(l,r,t,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new d.FileOperationError((0,m.localize)(10,null,this.resourceForError(r),(0,d.ensureFileSystemProviderError)(o).toString()),(0,d.toFileOperationResult)(o),i)},c),t}readFileUnbuffered(l,r,c){const i=(0,u.newWriteableStream)(t=>L.VSBuffer.concat(t));return(async()=>{try{let t;c?.atomic&&(0,d.hasFileAtomicReadCapability)(l)?t=await l.readFile(r,{atomic:!0}):t=await l.readFile(r),typeof c?.position=="number"&&(t=t.slice(c.position)),typeof c?.length=="number"&&(t=t.slice(0,c.length)),this.validateReadFileLimits(r,t.byteLength,c),i.end(L.VSBuffer.wrap(t))}catch(t){i.error(t),i.end()}})(),i}async validateReadFile(l,r){const c=await this.resolve(l,{resolveMetadata:!0});if(c.isDirectory)throw new d.FileOperationError((0,m.localize)(11,null,this.resourceForError(l)),0,r);if(typeof r?.etag=="string"&&r.etag!==d.ETAG_DISABLED&&r.etag===c.etag)throw new d.NotModifiedSinceFileOperationError((0,m.localize)(12,null),c,r);return this.validateReadFileLimits(l,c.size,r),c}validateReadFileLimits(l,r,c){if(c?.limits){let i;if(typeof c.limits.memory=="number"&&r>c.limits.memory&&(i=9),typeof c.limits.size=="number"&&r>c.limits.size&&(i=7),typeof i=="number")throw new d.FileOperationError((0,m.localize)(13,null,this.resourceForError(l)),i)}}async canMove(l,r,c){return this.doCanMoveCopy(l,r,"move",c)}async canCopy(l,r,c){return this.doCanMoveCopy(l,r,"copy",c)}async doCanMoveCopy(l,r,c,i){if(l.toString()!==r.toString())try{const t=c==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(t,l,o,r,c,i)}catch(t){return t}return!0}async move(l,r,c){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,l,t,r,"move",!!c),s=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(l,o==="move"?2:3,s)),s}async copy(l,r,c){const i=await this.withReadProvider(l),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,l,t,r,"copy",!!c),s=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(l,o==="copy"?3:2,s)),s}async doMoveCopy(l,r,c,i,t,o){if(r.toString()===i.toString())return t;const{exists:s,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(l,r,c,i,t,o);if(s&&!a&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(c,this.getExtUri(c).providerExtUri.dirname(i)),t==="copy"){if(l===c&&(0,d.hasFileFolderCopyCapability)(l))await l.copy(r,i,{overwrite:o});else{const h=await this.resolve(r);h.isDirectory?await this.doCopyFolder(l,h,c,i):await this.doCopyFile(l,r,c,i)}return t}else return l===c?(await l.rename(r,i,{overwrite:o}),t):(await this.doMoveCopy(l,r,c,i,"copy",o),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(l,r,c,i){if((0,d.hasOpenReadWriteCloseCapability)(l)&&(0,d.hasOpenReadWriteCloseCapability)(c))return this.doPipeBuffered(l,r,c,i);if((0,d.hasOpenReadWriteCloseCapability)(l)&&(0,d.hasReadWriteCapability)(c))return this.doPipeBufferedToUnbuffered(l,r,c,i);if((0,d.hasReadWriteCapability)(l)&&(0,d.hasOpenReadWriteCloseCapability)(c))return this.doPipeUnbufferedToBuffered(l,r,c,i);if((0,d.hasReadWriteCapability)(l)&&(0,d.hasReadWriteCapability)(c))return this.doPipeUnbuffered(l,r,c,i)}async doCopyFolder(l,r,c,i){await c.mkdir(i),Array.isArray(r.children)&&await n.Promises.settled(r.children.map(async t=>{const o=this.getExtUri(c).providerExtUri.joinPath(i,t.name);return t.isDirectory?this.doCopyFolder(l,await this.resolve(t.resource),c,o):this.doCopyFile(l,t.resource,c,o)}))}async doValidateMoveCopy(l,r,c,i,t,o){let s=!1;if(l===c){const{providerExtUri:h,isPathCaseSensitive:v}=this.getExtUri(l);if(v||(s=h.isEqual(r,i)),s&&t==="copy")throw new Error((0,m.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!s&&h.isEqualOrParent(i,r))throw new Error((0,m.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const a=await this.exists(i);if(a&&!s){if(!o)throw new d.FileOperationError((0,m.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(l===c){const{providerExtUri:h}=this.getExtUri(l);if(h.isEqualOrParent(r,i))throw new Error((0,m.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:a,isSameResourceWithDifferentPathCase:s}}getExtUri(l){const r=this.isPathCaseSensitive(l);return{providerExtUri:r?p.extUri:p.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(r,l);const c=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(l,0,c)),c}async mkdirp(l,r){const c=[],{providerExtUri:i}=this.getExtUri(l);for(;!i.isEqual(r,i.dirname(r));)try{if(((await l.stat(r)).type&d.FileType.Directory)==0)throw new Error((0,m.localize)(18,null,this.resourceForError(r)));break}catch(t){if((0,d.toFileSystemProviderErrorCode)(t)!==d.FileSystemProviderErrorCode.FileNotFound)throw t;c.push(i.basename(r)),r=i.dirname(r)}for(let t=c.length-1;t>=0;t--){r=i.joinPath(r,c[t]);try{await l.mkdir(r)}catch(o){if((0,d.toFileSystemProviderErrorCode)(o)!==d.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(l,r){try{await this.doValidateDelete(l,r)}catch(c){return c}return!0}async doValidateDelete(l,r){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!r?.useTrash&&!(c.capabilities&4096))throw new Error((0,m.localize)(19,null,this.resourceForError(l)));let t;try{t=await c.stat(l)}catch{}if(t)this.throwIfFileIsReadonly(l,t);else throw new d.FileOperationError((0,m.localize)(20,null,this.resourceForError(l)),1);if(!!!r?.recursive){const s=await this.resolve(l);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,m.localize)(21,null,this.resourceForError(l)))}return c}async del(l,r){const c=await this.doValidateDelete(l,r),i=!!r?.useTrash,t=!!r?.recursive;await c.delete(l,{recursive:t,useTrash:i}),this._onDidRunOperation.fire(new d.FileOperationEvent(l,1))}watch(l,r={recursive:!1,excludes:[]}){const c=new E.DisposableStore;let i=!1,t=()=>{i=!0};return c.add((0,E.toDisposable)(()=>t())),(async()=>{try{const o=await this.doWatch(l,r);i?(0,E.dispose)(o):t=()=>(0,E.dispose)(o)}catch(o){this.logService.error(o)}})(),c}async doWatch(l,r){const c=await this.withProvider(l),i=(0,R.hash)([this.getExtUri(c).providerExtUri.getComparisonKey(l),r]);let t=this.activeWatchers.get(i);return t||(t={count:0,disposable:c.watch(l,r)},this.activeWatchers.set(i,t)),t.count+=1,(0,E.toDisposable)(()=>{t&&(t.count--,t.count===0&&((0,E.dispose)(t.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,E.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,r,c,i){return this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(async()=>{const t=await l.open(r,{create:!0,unlock:c?.unlock??!1});try{(0,u.isReadableStream)(i)||(0,u.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(l,t,i):await this.doWriteReadableBufferedQueued(l,t,i)}catch(o){throw(0,d.ensureFileSystemProviderError)(o)}finally{await l.close(t)}})}async doWriteStreamBufferedQueued(l,r,c){let i=0,t;if((0,u.isReadableBufferedStream)(c)){if(c.buffer.length>0){const o=L.VSBuffer.concat(c.buffer);await this.doWriteBuffer(l,r,o,o.byteLength,i,0),i+=o.byteLength}if(c.ended)return;t=c.stream}else t=c;return new Promise((o,s)=>{(0,u.listenStream)(t,{onData:async a=>{t.pause();try{await this.doWriteBuffer(l,r,a,a.byteLength,i,0)}catch(h){return s(h)}i+=a.byteLength,setTimeout(()=>t.resume())},onError:a=>s(a),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(l,r,c){let i=0,t;for(;(t=c.read())!==null;)await this.doWriteBuffer(l,r,t,t.byteLength,i,0),i+=t.byteLength}async doWriteBuffer(l,r,c,i,t,o){let s=0;for(;s<i;)s+=await l.write(r,t+s,c.buffer,o+s,i-s)}async doWriteUnbuffered(l,r,c,i){return this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,r,c,i))}async doWriteUnbufferedQueued(l,r,c,i){let t;i instanceof L.VSBuffer?t=i:(0,u.isReadableStream)(i)?t=await(0,L.streamToBuffer)(i):(0,u.isReadableBufferedStream)(i)?t=await(0,L.bufferedStreamToBuffer)(i):t=(0,L.readableToBuffer)(i),await l.writeFile(r,t.buffer,{create:!0,overwrite:!0,unlock:c?.unlock??!1})}async doPipeBuffered(l,r,c,i){return this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,r,c,i))}async doPipeBufferedQueued(l,r,c,i){let t,o;try{t=await l.open(r,{create:!1}),o=await c.open(i,{create:!0,unlock:!1});const s=L.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,h=0,v=0;do v=await l.read(t,a,s.buffer,h,s.byteLength-h),await this.doWriteBuffer(c,o,s,v,a,h),a+=v,h+=v,h===s.byteLength&&(h=0);while(v>0)}catch(s){throw(0,d.ensureFileSystemProviderError)(s)}finally{await n.Promises.settled([typeof t=="number"?l.close(t):Promise.resolve(),typeof o=="number"?c.close(o):Promise.resolve()])}}async doPipeUnbuffered(l,r,c,i){return this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,r,c,i))}async doPipeUnbufferedQueued(l,r,c,i){return c.writeFile(i,await l.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,r,c,i){return this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,r,c,i))}async doPipeUnbufferedToBufferedQueued(l,r,c,i){const t=await c.open(i,{create:!0,unlock:!1});try{const o=await l.readFile(r);await this.doWriteBuffer(c,t,L.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,d.ensureFileSystemProviderError)(o)}finally{await c.close(t)}}async doPipeBufferedToUnbuffered(l,r,c,i){const t=await(0,L.streamToBuffer)(this.readFileBuffered(l,r,T.CancellationToken.None));await this.doWriteUnbuffered(c,i,void 0,t)}throwIfFileSystemIsReadonly(l,r){if(l.capabilities&2048)throw new d.FileOperationError((0,m.localize)(22,null,this.resourceForError(r)),6);return l}throwIfFileIsReadonly(l,r){if((r.permissions??0)&d.FilePermission.Readonly)throw new d.FileOperationError((0,m.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===C.Schemas.file?l.fsPath:l.toString(!0)}};y=de([Y(0,w.ILogService)],y),e.FileService=y}),define(ne[177],ie([0,1,50,254,5,39,17,3,41,2,10,4,19,40,22,139,13,84,174,37,166,165]),function(K,e,D,n,L,T,A,R,b,E,I,C,f,p,u,m,d,g,w,y,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(D)}catch(c){console.error(`Error enabling graceful-fs: ${(0,y.toErrorMessage)(c)}`)}})();class r extends w.AbstractDiskFileSystemProvider{constructor(i,t){super(i,t);this.onDidChangeCapabilities=R.Event.None,this.resourceLocks=new T.ResourceMap(o=>f.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:t,symbolicLink:o}=await u.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(t,o),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(t){throw this.toFileSystemProviderError(t)}}async readdir(i){try{const t=await u.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),o=[];return await Promise.all(t.map(async s=>{try{let a;s.isSymbolicLink()?a=(await this.stat((0,f.joinPath)(i,s.name))).type:a=this.toType(s),o.push([s.name,a])}catch(a){this.logService.trace(a)}})),o}catch(t){throw this.toFileSystemProviderError(t)}}toType(i,t){let o;return t?.dangling?o=d.FileType.Unknown:i.isFile()?o=d.FileType.File:i.isDirectory()?o=d.FileType.Directory:o=d.FileType.Unknown,t&&(o|=d.FileType.SymbolicLink),o}async createResourceLock(i){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(i)})`);let t;for(;t=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(i)})`),await t.wait();const o=new L.Barrier;return this.resourceLocks.set(i,o),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(i)})`),(0,E.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(i)})`),this.resourceLocks.delete(i),o.open()})}async readFile(i,t){let o;try{t?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),o=await this.createResourceLock(i));const s=this.toFilePath(i);return await u.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}finally{o?.dispose()}}readFileStream(i,t,o){const s=(0,p.newWriteableStream)(a=>A.VSBuffer.concat(a.map(h=>A.VSBuffer.wrap(h))).buffer);return(0,g.readFileIntoStream)(this,i,s,a=>a.buffer,{...t,bufferSize:256*1024},o),s}async writeFile(i,t,o){let s;try{const a=this.toFilePath(i);if(!o.create||!o.overwrite){if(await u.Promises.exists(a)){if(!o.overwrite)throw(0,d.createFileSystemProviderError)((0,m.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,d.createFileSystemProviderError)((0,m.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(s,0,t,0,t.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(i,a)}finally{typeof s=="number"&&await this.close(s)}}async open(i,t){let o;(0,d.isFileOpenForWriteOptions)(t)&&(o=await this.createResourceLock(i));let s;try{const a=this.toFilePath(i);if((0,d.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:v}=await u.SymlinkSupport.stat(a);v.mode&128||await u.Promises.chmod(a,v.mode|128)}catch(v){this.logService.trace(v)}let h;if((0,d.isFileOpenForWriteOptions)(t)){if(C.isWindows)try{await u.Promises.truncate(a,0),h="r+"}catch(v){v.code!=="ENOENT"&&this.logService.trace(v)}h||(h="w")}else h="r";s=await u.Promises.open(a,h)}catch(a){throw o?.dispose(),(0,d.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(i,a):this.toFileSystemProviderError(a)}return this.mapHandleToPos.set(s,0),(0,d.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(s,i),o&&this.mapHandleToLock.set(s,o),s}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await u.Promises.fdatasync(i)}catch(t){this.canFlush=!1,this.logService.error(t)}return await u.Promises.close(i)}catch(t){throw this.toFileSystemProviderError(t)}finally{const t=this.mapHandleToLock.get(i);t&&(this.mapHandleToLock.delete(i),t.dispose())}}async read(i,t,o,s,a){const h=this.normalizePos(i,t);let v=null;try{const{bytesRead:P}=await u.Promises.read(i,o,s,a,h);return P}catch(P){throw this.toFileSystemProviderError(P)}finally{this.updatePos(i,h,v)}}normalizePos(i,t){return t===this.mapHandleToPos.get(i)?null:t}updatePos(i,t,o){const s=this.mapHandleToPos.get(i);typeof s=="number"&&(typeof t=="number"||(typeof o=="number"?this.mapHandleToPos.set(i,s+o):this.mapHandleToPos.delete(i)))}async write(i,t,o,s,a){return(0,L.retry)(()=>this.doWrite(i,t,o,s,a),100,3)}async doWrite(i,t,o,s,a){const h=this.normalizePos(i,t);let v=null;try{const{bytesWritten:P}=await u.Promises.write(i,o,s,a,h);return P}catch(P){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),P)}finally{this.updatePos(i,h,v)}}async mkdir(i){try{await u.Promises.mkdir(this.toFilePath(i))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(i,t){try{const o=this.toFilePath(i);t.recursive?await u.Promises.rm(o,u.RimRafMode.MOVE):await u.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(i,t,o){const s=this.toFilePath(i),a=this.toFilePath(t);if(s!==a)try{await this.validateTargetDeleted(i,t,"move",o.overwrite),await u.Promises.move(s,a)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,m.localize)(2,null,(0,I.basename)(s),(0,I.basename)((0,I.dirname)(a)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(i,t,o){const s=this.toFilePath(i),a=this.toFilePath(t);if(s!==a)try{await this.validateTargetDeleted(i,t,"copy",o.overwrite),await u.Promises.copy(s,a,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,m.localize)(3,null,(0,I.basename)(s),(0,I.basename)((0,I.dirname)(a)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(i,t,o,s){const a=this.toFilePath(i),h=this.toFilePath(t);let v=!1;if(!!(this.capabilities&1024)||(v=(0,b.isEqual)(a,h,!0)),v&&o==="copy")throw(0,d.createFileSystemProviderError)((0,m.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(!v&&await u.Promises.exists(h)){if(!s)throw(0,d.createFileSystemProviderError)((0,m.localize)(5,null),d.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}createUniversalWatcher(i,t,o){return new S.UniversalWatcherClient(s=>i(s),s=>t(s),o)}createNonRecursiveWatcher(i,t,o){return new l.NodeJSWatcherClient(s=>i(s),s=>t(s),o)}toFileSystemProviderError(i){if(i instanceof d.FileSystemProviderError)return i;let t;switch(i.code){case"ENOENT":t=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=d.FileSystemProviderErrorCode.NoPermissions;break;default:t=d.FileSystemProviderErrorCode.Unknown}return(0,d.createFileSystemProviderError)(i,t)}async toFileSystemProviderWriteError(i,t){let o=this.toFileSystemProviderError(t);if(i&&o.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await u.SymlinkSupport.stat(this.toFilePath(i));s.mode&128||(o=(0,d.createFileSystemProviderError)(t,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return o}}e.DiskFileSystemProvider=r}),define(ne[86],ie([0,1,3,7,8]),function(K,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(f){this.service=f,this.onDidChangeLogLevel=D.Event.buffer(f.onDidChangeLogLevel,!0)}listen(f,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(f,p,u){switch(p){case"setLevel":return this.service.setLevel(u)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=T;class A{constructor(f){this.channel=f}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(f){A.setLevel(this.channel,f)}static setLevel(f,p){return f.call("setLevel",p)}}e.LogLevelChannelClient=A;class R{constructor(f){this.loggerService=f,this.loggers=new Map}listen(f,p){throw new Error(`Event not found: ${p}`)}async call(f,p,u){switch(p){case"createLogger":this.createLogger(n.URI.revive(u[0]),u[1]);return;case"log":return this.log(n.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1])}throw new Error(`Call not found: ${p}`)}createLogger(f,p){this.loggers.set(f.toString(),this.loggerService.createLogger(f,p))}consoleLog(f,p){let u=console.log;switch(f){case L.LogLevel.Error:u=console.error;break;case L.LogLevel.Warning:u=console.warn;break;case L.LogLevel.Info:u=console.info;break}u.call(console,...p)}log(f,p){const u=this.loggers.get(f.toString());if(!u)throw new Error("Create the logger before logging");for(const[m,d]of p)(0,L.log)(u,m,d)}}e.LoggerChannel=R;class b extends L.AbstractLoggerService{constructor(f,p,u){super(f,p);this.channel=u}createConsoleMainLogger(){return new L.AdapterLogger({log:(f,p)=>{this.channel.call("consoleLog",[f,p])}})}doCreateLogger(f,p,u){return new E(this.channel,f,p,u)}}e.LoggerChannelClient=b;class E extends L.AbstractMessageLogger{constructor(f,p,u,m){super(m?.always);this.channel=f,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[p,m]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(f,p){const u=[[f,p]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(f){this.channel.call("log",[this.file,f])}}class I extends L.LogService{constructor(f,p){super(p);this.parent=f,this._register(f.onDidChangeLogLevel(u=>p.setLevel(u)))}setLevel(f){super.setLevel(f),this.parent.setLevel(f)}}e.FollowerLogService=I}),define(ne[60],ie([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(ne[87],ie([0,1,18,4,32,19]),function(K,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const R=n.globals.vscode.context.configuration();if(R)A=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof K?.__$__nodeRequire=="function"){const R=(0,T.dirname)(D.FileAccess.asFileUri("",K));A=K.__$__nodeRequire((0,T.joinPath)(R,"product.json").fsPath);const b=K.__$__nodeRequire((0,T.joinPath)(R,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:b.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A}),define(ne[27],ie([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[178],ie([0,1,5,9,2,10,22,8,27]),function(K,e,D,n,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let E=class extends L.Disposable{constructor(C,f,p){super();this.productService=f,this.logService=p,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,C&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(C)},30*1e3)).schedule()}async cleanUpCodeCaches(C){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const f=Date.now(),p=(0,T.dirname)(C),u=(0,T.basename)(C),m=await A.Promises.readdir(p);await Promise.all(m.map(async d=>{if(d===u)return;const g=(0,T.join)(p,d),w=await A.Promises.stat(g);if(w.isDirectory()&&f-w.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${d}.`),A.Promises.rm(g)}))}catch(f){(0,n.onUnexpectedError)(f)}}};E=de([Y(1,b.IProductService),Y(2,R.ILogService)],E),e.CodeCacheCleaner=E}),define(ne[179],ie([0,1,5,9,2,10,22,15,8,27]),function(K,e,D,n,L,T,A,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let I=class extends L.Disposable{constructor(f,p,u){super();this.environmentService=f,this.logService=p,this.productService=u,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const f=Object.create(null),p=JSON.parse(await A.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let w of Object.keys(p)){const y=p[w];f[`${y.hash}.${w}`]=!0}const u=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(u))return;const d=await A.Promises.readdir(u);for(const w of d){if(f[w]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${w}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${w}`),await A.Promises.rm((0,T.join)(u,w))}const g=Date.now();for(const w of Object.keys(f)){const y=(0,T.join)(u,w),S=await A.Promises.readdir(y);for(const l of S){if(l==="tcf.json")continue;const r=(0,T.join)(y,l),c=await A.Promises.stat(r);c.isDirectory()&&g-c.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(w,l)}`),await A.Promises.rm(r))}}}catch(f){(0,n.onUnexpectedError)(f)}}};I=de([Y(0,R.INativeEnvironmentService),Y(1,b.ILogService),Y(2,E.IProductService)],I),e.LanguagePackCachedDataCleaner=I}),define(ne[180],ie([0,1,10,6]),function(K,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,n.createDecorator)("IV8InspectProfilingService");var L;(function(T){function A(R,b="noAbsolutePaths"){for(const E of R.nodes)E.callFrame&&E.callFrame.url&&((0,D.isAbsolute)(E.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(E.callFrame.url))&&(E.callFrame.url=(0,D.join)(b,(0,D.basename)(E.callFrame.url)));return R}T.rewriteAbsolutePaths=A})(L=e.Utils||(e.Utils={}))}),define(ne[181],ie([0,1,29]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class n{constructor(){this._sessions=new Map}async startProfiling(T){const R=await(await new Promise((E,I)=>{K(["v8-inspect-profiler"],E,I)})).startProfiling({port:T.port,checkForPaused:!0}),b=(0,D.generateUuid)();return this._sessions.set(b,R),b}async stopProfiling(T){const A=this._sessions.get(T);if(!A)throw new Error(`UNKNOWN session '${T}'`);const R=await A.stop();return this._sessions.delete(T),R.profile}}e.InspectProfilingService=n}),define(ne[38],ie([0,1,99,14]),function(K,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(A,R){D.ok(n.isString(A)),D.ok(n.isObject(R)),D.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,R)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new L}),define(ne[88],ie([0,1,3,38]),function(K,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class T{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,E){this.schemasById[L(b)]=E,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new T;n.Registry.add(e.Extensions.JSONContribution,A)}),define(ne[42],ie([0,1,16,3,14,125,88,38]),function(K,e,D,n,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var b;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(b=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=R.Registry.as(A.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(l,r=!0){this.registerConfigurations([l],r)}registerConfigurations(l,r=!0){const c=this.doRegisterConfigurations(l,r);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c})}deregisterConfigurations(l){const r=this.doDeregisterConfigurations(l);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:l,remove:r}){const c=[];c.push(...this.doDeregisterConfigurations(r)),c.push(...this.doRegisterConfigurations(l,!1)),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(c)})}registerDefaultConfigurations(l){const r=[],c=[];for(const{overrides:i,source:t}of l)for(const o in i)if(r.push(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const s={...this.configurationDefaultsOverrides.get(o)?.value||{},...i[o]};this.configurationDefaultsOverrides.set(o,{source:t,value:s});const a={type:"object",default:s,description:T.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:s,source:L.isString(t)?void 0:t};c.push(...u(o)),this.configurationProperties[o]=a,this.defaultLanguageConfigurationOverridesNode.properties[o]=a}else{this.configurationDefaultsOverrides.set(o,{value:i[o],source:t});const s=this.configurationProperties[o];s&&(this.updatePropertyDefaultValue(o,s),this.updateSchema(o,s))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(l){const r=[];for(const{overrides:c,source:i}of l)for(const t in c){const o=this.configurationDefaultsOverrides.get(t),s=L.isString(i)?i:i?.id,a=L.isString(o?.source)?o?.source:o?.source?.id;if(s===a)if(r.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const h=this.configurationProperties[t];h&&(this.updatePropertyDefaultValue(t,h),this.updateSchema(t,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const r of l)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,r){const c=[];return l.forEach(i=>{c.push(...this.validateAndRegisterProperties(i,r,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),c}doDeregisterConfigurations(l){const r=[],c=i=>{if(i.properties)for(const t in i.properties)r.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,i.properties[t]);i.allOf&&i.allOf.forEach(t=>c(t))};for(const i of l){c(i);const t=this.configurationContributors.indexOf(i);t!==-1&&this.configurationContributors.splice(t,1)}return r}validateAndRegisterProperties(l,r=!0,c,i,t=3){t=L.isUndefinedOrNull(l.scope)?t:l.scope;let o=[],s=l.properties;if(s)for(let h in s){if(r&&w(h)){delete s[h];continue}const v=s[h];if(v.source=c,v.defaultDefaultValue=s[h].default,this.updatePropertyDefaultValue(h,v),e.OVERRIDE_PROPERTY_REGEX.test(h)?v.scope=void 0:(v.scope=L.isUndefinedOrNull(v.scope)?t:v.scope,v.restricted=L.isUndefinedOrNull(v.restricted)?!!i?.includes(h):v.restricted),s[h].hasOwnProperty("included")&&!s[h].included){this.excludedConfigurationProperties[h]=s[h],delete s[h];continue}else this.configurationProperties[h]=s[h];!s[h].deprecationMessage&&s[h].markdownDeprecationMessage&&(s[h].deprecationMessage=s[h].markdownDeprecationMessage),o.push(h)}let a=l.allOf;if(a)for(let h of a)o.push(...this.validateAndRegisterProperties(h,r,c,i,t));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(l){const r=c=>{let i=c.properties;if(i)for(const o in i)this.updateSchema(o,i[o]);let t=c.allOf;t&&t.forEach(r)};r(l)}updateSchema(l,r){switch(e.allSettings.properties[l]=r,r.scope){case 1:e.applicationSettings.properties[l]=r;break;case 2:e.machineSettings.properties[l]=r;break;case 6:e.machineOverridableSettings.properties[l]=r;break;case 3:e.windowSettings.properties[l]=r;break;case 4:e.resourceSettings.properties[l]=r;break;case 5:e.resourceSettings.properties[l]=r,this.resourceLanguageSettingsSchema.properties[l]=r;break}}removeFromSchema(l,r){switch(delete e.allSettings.properties[l],r.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l],delete this.resourceLanguageSettingsSchema.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const r=`[${l}]`,c={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,c),e.allSettings.properties[r]=c,e.applicationSettings.properties[r]=c,e.machineSettings.properties[r]=c,e.machineOverridableSettings.properties[r]=c,e.windowSettings.properties[r]=c,e.resourceSettings.properties[r]=c}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const l={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,r){const c=this.configurationDefaultsOverrides.get(l);let i=c?.value,t=c?.source;L.isUndefined(i)&&(i=r.defaultDefaultValue,t=void 0),L.isUndefined(i)&&(i=d(r.type)),r.default=i,r.defaultValueSource=t}}const f="\\[([^\\]]+)\\]",p=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function u(S){const l=[];if(e.OVERRIDE_PROPERTY_REGEX.test(S)){let r=p.exec(S);for(;r?.length;){const c=r[1].trim();c&&l.push(c),r=p.exec(S)}}return(0,D.distinct)(l)}e.overrideIdentifiersFromKey=u;function m(S){return S.reduce((l,r)=>`${l}[${r}]`,"")}e.keyFromOverrideIdentifiers=m;function d(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const g=new C;R.Registry.add(e.Extensions.Configuration,g);function w(S){return S.trim()?e.OVERRIDE_PROPERTY_REGEX.test(S)?T.localize(7,null,S):g.getConfigurationProperties()[S]!==void 0?T.localize(8,null,S):null:T.localize(6,null)}e.validateProperty=w;function y(){const S=[],l=g.getConfigurationProperties();for(const r of Object.keys(l))S.push([r,l[r].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=y}),define(ne[89],ie([0,1,16,3,35,2,39,28,14,7,20,42,38]),function(K,e,D,n,L,T,A,R,b,E,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(i={},t=[],o=[]){this._contents=i,this._keys=t,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,I.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,t){const o=this.getContentsForOverrideIdentifer(t);return o?i?(0,I.getConfigurationValue)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const t=[];for(const o of this.overrides)o.identifiers.includes(i)&&t.push(...o.keys);return D.distinct(t)}getAllOverrideIdentifiers(){const i=[];for(const t of this.overrides)i.push(...t.identifiers);return D.distinct(i)}override(i){let t=this.overrideConfigurations.get(i);return t||(t=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,t)),t}merge(...i){const t=R.deepClone(this.contents),o=R.deepClone(this.overrides),s=[...this.keys];for(const a of i){this.mergeContents(t,a.contents);for(const h of a.overrides){const[v]=o.filter(P=>D.equals(P.identifiers,h.identifiers));v?(this.mergeContents(v.contents,h.contents),v.keys.push(...h.keys),v.keys=D.distinct(v.keys)):o.push(R.deepClone(h))}for(const h of a.keys)s.indexOf(h)===-1&&s.push(h)}return new p(t,s,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const t=this.getContentsForOverrideIdentifer(i);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let o={};for(const s of D.distinct([...Object.keys(this.contents),...Object.keys(t)])){let a=this.contents[s],h=t[s];h&&(typeof a=="object"&&typeof h=="object"?(a=R.deepClone(a),this.mergeContents(a,h)):a=h),o[s]=a}return new p(o,this.keys,this.overrides)}mergeContents(i,t){for(const o of Object.keys(t)){if(o in i&&b.isObject(i[o])&&b.isObject(t[o])){this.mergeContents(i[o],t[o]);continue}i[o]=R.deepClone(t[o])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?R.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let t=null,o=null;const s=a=>{a&&(o?this.mergeContents(o,a):o=R.deepClone(a))};for(const a of this.overrides)D.equals(a.identifiers,[i])?t=a.contents:a.identifiers.includes(i)&&s(a.contents);return s(t),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,t){this.addKey(i),(0,I.addToValueTree)(this.contents,i,t,o=>{throw new Error(o)})}removeValue(i){this.removeKey(i)&&(0,I.removeFromValueTree)(this.contents,i)}addKey(i){let t=this.keys.length;for(let o=0;o<t;o++)i.indexOf(this.keys[o])===0&&(t=o);this.keys.splice(t,1,i)}removeKey(i){let t=this.keys.indexOf(i);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=p;class u extends p{constructor(i={}){const t=f.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(t),s=Object.create(null),a=[];for(const h in t){const v=i[h],P=v!==void 0?v:t[h].default;(0,I.addToValueTree)(s,h,P,_=>console.error(`Conflict in default settings: ${_}`))}for(const h of Object.keys(s))C.OVERRIDE_PROPERTY_REGEX.test(h)&&a.push({identifiers:(0,C.overrideIdentifiersFromKey)(h),keys:Object.keys(s[h]),contents:(0,I.toValuesTree)(s[h],v=>console.error(`Conflict in default settings file: ${v}`))});super(s,o,a)}}e.DefaultConfigurationModel=u;class m{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,t){if(!b.isUndefinedOrNull(i)){const o=this.doParseContent(i);this.parseRaw(o,t)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,t){this._raw=i;const{contents:o,keys:s,overrides:a,restricted:h}=this.doParseRaw(i,t);this._configurationModel=new p(o,s,a),this._restrictedConfigurations=h||[]}doParseContent(i){let t={},o=null,s=[],a=[],h=[];function v(_){Array.isArray(s)?s.push(_):o!==null&&(s[o]=_)}let P={onObjectBegin:()=>{let _={};v(_),a.push(s),s=_,o=null},onObjectProperty:_=>{o=_},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{let _=[];v(_),a.push(s),s=_,o=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:v,onError:(_,O,U)=>{h.push({error:_,offset:O,length:U})}};if(i)try{L.visit(i,P),t=s[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return t}doParseRaw(i,t){const o=f.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),s=this.filter(i,o,!0,t);i=s.raw;const a=(0,I.toValuesTree)(i,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),h=Object.keys(i),v=this.toOverrides(i,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:a,keys:h,overrides:v,restricted:s.restricted}}filter(i,t,o,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:i,restricted:[]};const a={},h=[];for(let v in i)if(C.OVERRIDE_PROPERTY_REGEX.test(v)&&o){const P=this.filter(i[v],t,!1,s);a[v]=P.raw,h.push(...P.restricted)}else{const P=t[v],_=P?typeof P.scope!="undefined"?P.scope:3:void 0;P?.restricted&&h.push(v),(_===void 0||s.scopes===void 0||s.scopes.includes(_))&&(s.skipRestricted&&P?.restricted||(a[v]=i[v]))}return{raw:a,restricted:h}}toOverrides(i,t){const o=[];for(const s of Object.keys(i))if(C.OVERRIDE_PROPERTY_REGEX.test(s)){const a={};for(const h in i[s])a[h]=i[s][h];o.push({identifiers:(0,C.overrideIdentifiersFromKey)(s),keys:Object.keys(a),contents:(0,I.toValuesTree)(a,t)})}return o}}e.ConfigurationModelParser=m;class d extends T.Disposable{constructor(i,t,o,s){super();this.userSettingsResource=i,this.scopes=t,this.fileService=s,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=d;class g{constructor(i,t,o=new p,s=new p,a=new A.ResourceMap,h=new p,v=new A.ResourceMap,P=!0){this._defaultConfiguration=i,this._localUserConfiguration=t,this._remoteUserConfiguration=o,this._workspaceConfiguration=s,this._folderConfigurations=a,this._memoryConfiguration=h,this._memoryConfigurationByResource=v,this._freeze=P,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(i,t,o){return this.getConsolidateConfigurationModel(t,o).getValue(i)}updateValue(i,t,o={}){let s;o.resource?(s=this._memoryConfigurationByResource.get(o.resource),s||(s=new p,this._memoryConfigurationByResource.set(o.resource,s))):s=this._memoryConfiguration,t===void 0?s.removeValue(i):s.setValue(i,t),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,t,o){const s=this.getConsolidateConfigurationModel(t,o),a=this.getFolderConfigurationModelForResource(t.resource,o),h=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,v=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),P=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),_=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),O=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),U=o?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,k=a?t.overrideIdentifier?a.freeze().override(t.overrideIdentifier).getValue(i):a.freeze().getValue(i):void 0,M=t.overrideIdentifier?h.override(t.overrideIdentifier).getValue(i):h.getValue(i),F=s.getValue(i),V=D.distinct(D.flatten(s.overrides.map(N=>N.identifiers))).filter(N=>s.getOverrideValue(i,N)!==void 0);return{defaultValue:v,userValue:P,userLocalValue:_,userRemoteValue:O,workspaceValue:U,workspaceFolderValue:k,memoryValue:M,value:F,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,user:P!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspaceFolder:k!==void 0?{value:a?.freeze().getValue(i),override:t.overrideIdentifier?a?.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,memory:M!==void 0?{value:h.getValue(i),override:t.overrideIdentifier?h.getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(i){const t=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,t){this._folderConfigurations.set(i,t),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,t){const o=[];if(!t){const{added:s,updated:a,removed:h}=l(this._defaultConfiguration,i);t=[...s,...a,...h]}for(const s of t)for(const a of(0,C.overrideIdentifiersFromKey)(s)){const h=this._defaultConfiguration.getKeysForOverrideIdentifier(a),v=i.getKeysForOverrideIdentifier(a),P=[...v.filter(_=>h.indexOf(_)===-1),...h.filter(_=>v.indexOf(_)===-1),...h.filter(_=>!R.equals(this._defaultConfiguration.override(a).getValue(_),i.override(a).getValue(_)))];o.push([a,P])}return this.updateDefaultConfiguration(i),{keys:t,overrides:o}}compareAndUpdateLocalUserConfiguration(i){const{added:t,updated:o,removed:s,overrides:a}=l(this.localUserConfiguration,i),h=[...t,...o,...s];return h.length&&this.updateLocalUserConfiguration(i),{keys:h,overrides:a}}compareAndUpdateRemoteUserConfiguration(i){const{added:t,updated:o,removed:s,overrides:a}=l(this.remoteUserConfiguration,i);let h=[...t,...o,...s];return h.length&&this.updateRemoteUserConfiguration(i),{keys:h,overrides:a}}compareAndUpdateWorkspaceConfiguration(i){const{added:t,updated:o,removed:s,overrides:a}=l(this.workspaceConfiguration,i);let h=[...t,...o,...s];return h.length&&this.updateWorkspaceConfiguration(i),{keys:h,overrides:a}}compareAndUpdateFolderConfiguration(i,t){const o=this.folderConfigurations.get(i),{added:s,updated:a,removed:h,overrides:v}=l(o,t);let P=[...s,...a,...h];return(P.length||!o)&&this.updateFolderConfiguration(i,t),{keys:P,overrides:v}}compareAndDeleteFolderConfiguration(i){const t=this.folderConfigurations.get(i);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:s,removed:a,overrides:h}=l(t,void 0);return{keys:[...o,...s,...a],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,t){let o=this.getConsolidatedConfigurationModelForResource(i,t);return i.overrideIdentifier?o.override(i.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:i},t){let o=this.getWorkspaceConsolidatedConfiguration();if(t&&i){const s=t.getFolder(i);s&&(o=this.getFolderConsolidatedConfiguration(s.uri)||o);const a=this._memoryConfigurationByResource.get(i);a&&(o=o.merge(a))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let t=this._foldersConsolidatedConfigurations.get(i);if(!t){const o=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(i);s?(t=o.merge(s),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(i,t)):t=o}return t}getFolderConfigurationModelForResource(i,t){if(t&&i){const o=t.getFolder(i);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,t)=>{const{contents:o,overrides:s,keys:a}=this._folderConfigurations.get(t);return i.push([t,{contents:o,overrides:s,keys:a}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>i.add(t)),this.userConfiguration.freeze().keys.forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(o=>i.add(o))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>t.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>t.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>t.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s))),[...t.values()]}static parse(i){const t=this.parseConfigurationModel(i.defaults),o=this.parseConfigurationModel(i.user),s=this.parseConfigurationModel(i.workspace),a=i.folders.reduce((h,v)=>(h.set(E.URI.revive(v[0]),this.parseConfigurationModel(v[1])),h),new A.ResourceMap);return new g(t,o,new p,s,a,new p,new A.ResourceMap,!1)}static parseConfigurationModel(i){return new p(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=g;function w(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const i=new Set,t=new Map;for(const s of c)s.keys.forEach(a=>i.add(a)),s.overrides.forEach(([a,h])=>{const v=(0,A.getOrSet)(t,a,new Set);h.forEach(P=>v.add(P))});const o=[];return t.forEach((s,a)=>o.push([a,[...s.values()]])),{keys:[...i.values()],overrides:o}}e.mergeChanges=w;class y{constructor(i,t,o,s){this.change=i,this.previous=t,this.currentConfiguraiton=o,this.currentWorkspace=s,this._previousConfiguration=void 0;const a=new Set;i.keys.forEach(v=>a.add(v)),i.overrides.forEach(([,v])=>v.forEach(P=>a.add(P))),this.affectedKeys=[...a.values()];const h=new p;this.affectedKeys.forEach(v=>h.setValue(v,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(t){const o=this.previousConfiguration?this.previousConfiguration.getValue(i,t,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(i,t,this.currentWorkspace);return!R.equals(o,s)}return!0}return!1}doesAffectedKeysTreeContains(i,t){let o=(0,I.toValuesTree)({[t]:!0},()=>{}),s;for(;typeof o=="object"&&(s=Object.keys(o)[0]);){if(i=i[s],!i)return!1;o=o[s]}return!0}}e.ConfigurationChangeEvent=y;class S extends y{constructor(i,t,o,s){super({keys:i.allKeys(),overrides:[]},void 0,i,t);this.source=o,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=S;function l(c,i){const{added:t,removed:o,updated:s}=r(i,c),a=[],h=c?.getAllOverrideIdentifiers()||[],v=i?.getAllOverrideIdentifiers()||[];if(i){const P=v.filter(_=>!h.includes(_));for(const _ of P)a.push([_,i.getKeysForOverrideIdentifier(_)])}if(c){const P=h.filter(_=>!v.includes(_));for(const _ of P)a.push([_,c.getKeysForOverrideIdentifier(_)])}if(i&&c){for(const P of h)if(v.includes(P)){const _=r({contents:c.getOverrideValue(void 0,P)||{},keys:c.getKeysForOverrideIdentifier(P)},{contents:i.getOverrideValue(void 0,P)||{},keys:i.getKeysForOverrideIdentifier(P)});a.push([P,[..._.added,..._.removed,..._.updated]])}}return{added:t,removed:o,updated:s,overrides:a}}function r(c,i){const t=c?i?c.keys.filter(a=>i.keys.indexOf(a)===-1):[...c.keys]:[],o=i?c?i.keys.filter(a=>c.keys.indexOf(a)===-1):[...i.keys]:[],s=[];if(c&&i){for(const a of i.keys)if(c.keys.indexOf(a)!==-1){const h=(0,I.getConfigurationValue)(i.contents,a),v=(0,I.getConfigurationValue)(c.contents,a);R.equals(h,v)||s.push(a)}}return{added:t,removed:o,updated:s}}}),define(ne[182],ie([0,1,5,3,2,19,20,89,42,38]),function(K,e,D,n,L,T,A,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends L.Disposable{constructor(f,p){super();this.settingsResource=f,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,p)),this.configuration=new R.Configuration(new R.DefaultConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(E.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(({properties:u})=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const f=await this.userConfiguration.loadConfiguration();this.configuration=new R.Configuration(new R.DefaultConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(f,p){const u=typeof f=="string"?f:void 0,m=(0,A.isConfigurationOverrides)(f)?f:(0,A.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(u,m,void 0)}updateValue(f,p,u,m){return Promise.reject(new Error("not supported"))}inspect(f){return this.configuration.inspect(f,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const p=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(u,p,1)}onDidDefaultConfigurationChange(f){const p=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new R.DefaultConfigurationModel,f);this.trigger(u,p,6)}trigger(f,p,u){const m=new R.ConfigurationChangeEvent(f,{data:p},this.configuration);m.source=u,m.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(f){switch(f){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(ne[183],ie([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,D.createDecorator)("remoteAuthorityResolverService");var n;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends Error{constructor(A,R=n.Unknown,b){super(A);this._message=A,this._code=R,this._detail=b,this.isHandled=R===n.NotAvailable&&b===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(A){return A instanceof L&&A._code===n.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof L&&A._code===n.NoResolverFound}static isHandled(A){return A instanceof L&&A.isHandled}}e.RemoteAuthorityResolverError=L}),define(ne[184],ie([0,1,5,17,23,9,3,2,29,73,183]),function(K,e,D,n,L,T,A,R,b,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const C=30*1e3;var f;(function(H){H[H.Management=1]="Management",H[H.ExtensionHost=2]="ExtensionHost",H[H.Tunnel=3]="Tunnel"})(f=e.ConnectionType||(e.ConnectionType={}));function p(H){switch(H){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(H){const Z=new L.CancellationTokenSource;return setTimeout(()=>Z.cancel(),H),Z.token}function m(H,Z){if(H.isCancellationRequested||Z.isCancellationRequested)return L.CancellationToken.Cancelled;const ee=new L.CancellationTokenSource;return H.onCancellationRequested(()=>ee.cancel()),Z.onCancellationRequested(()=>ee.cancel()),ee.token}class d{constructor(Z){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((ee,W)=>{this._resolvePromise=ee,this._rejectPromise=W}),Z.isCancellationRequested?this._timeout():this._disposables.add(Z.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(Z){this._state==="pending"?this._disposables.add(Z):Z.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const Z=new Error("Time limit reached");return Z.code="ETIMEDOUT",Z.syscall="connect",Z}resolve(Z){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(Z))}reject(Z){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(Z))}}function g(H,Z){const ee=new d(Z);return ee.registerDisposable(H.onControlMessage(W=>{const $=JSON.parse(W.toString()),x=G($);x?ee.reject(x):ee.resolve($)})),ee.promise}function w(H,Z,ee,W,$,x,z){const B=new d(z);return Z.connect(ee,W,$,x,(te,se)=>{B.didTimeout?(te&&H.error(te),se?.dispose()):te||!se?B.reject(te):B.resolve(se)}),B.promise}function y(H,Z){const ee=new d(Z);return H.then(W=>{ee.didTimeout||ee.resolve(W)},W=>{ee.didTimeout||ee.reject(W)}),ee.promise}async function S(H,Z,ee,W){const $=q(H,Z);H.logService.trace(`${$} 1/6. invoking socketFactory.connect().`);let x;try{x=await w(H.logService,H.socketFactory,H.host,H.port,`reconnectionToken=${H.reconnectionToken}&reconnection=${H.reconnectionProtocol?"true":"false"}`,`renderer-${p(Z)}-${H.reconnectionToken}`,W)}catch(ce){throw H.logService.error(`${$} socketFactory.connect() failed or timed out. Error:`),H.logService.error(ce),ce}H.logService.trace(`${$} 2/6. socketFactory.connect() was successful.`);let z,B;H.reconnectionProtocol?(H.reconnectionProtocol.beginAcceptReconnection(x,null),z=H.reconnectionProtocol,B=!1):(z=new E.PersistentProtocol(x,null),B=!0),H.logService.trace(`${$} 3/6. sending AuthRequest control message.`);const te=await y(H.signService.createNewMessage((0,b.generateUuid)()),W),se={type:"auth",auth:H.connectionToken||"00000000000000000000",data:te.data};z.sendControl(n.VSBuffer.fromString(JSON.stringify(se)));try{const ce=await g(z,m(W,u(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const Ie=new Error("Unexpected handshake message");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}if(H.logService.trace(`${$} 4/6. received SignRequest control message.`),!await y(H.signService.validate(te,ce.signedData),W)){const Ie=new Error("Refused to connect to unsupported server");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}const ve=await y(H.signService.sign(ce.data),W),pe={type:"connectionType",commit:H.commit,signedData:ve,desiredConnectionType:Z};return ee&&(pe.args=ee),H.logService.trace(`${$} 5/6. sending ConnectionTypeRequest control message.`),z.sendControl(n.VSBuffer.fromString(JSON.stringify(pe))),{protocol:z,ownsProtocol:B}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(H.logService.error(`${$} the handshake timed out. Error:`),H.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(H.logService.error(`${$} received error control message when negotiating connection. Error:`),H.logService.error(ce)),B&&N(z),ce}}async function l(H,Z,ee,W){const $=Date.now(),x=q(H,Z),{protocol:z,ownsProtocol:B}=await S(H,Z,ee,W),te=new d(W);return te.registerDisposable(z.onControlMessage(se=>{const ce=JSON.parse(se.toString()),he=G(ce);he?(H.logService.error(`${x} received error control message when negotiating connection. Error:`),H.logService.error(he),B&&N(z),te.reject(he)):(H.reconnectionProtocol&&H.reconnectionProtocol.endAcceptReconnection(),H.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${X($)}!`),te.resolve({protocol:z,firstMessage:ce}))})),te.promise}async function r(H,Z){const{protocol:ee}=await l(H,1,void 0,Z);return{protocol:ee}}async function c(H,Z,ee){const{protocol:W,firstMessage:$}=await l(H,2,Z,ee),x=$&&$.debugPort;return{protocol:W,debugPort:x}}async function i(H,Z,ee){const W=Date.now(),$=q(H,3),{protocol:x}=await S(H,3,Z,ee);return H.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${X(W)}!`),x}async function t(H,Z,ee){const{host:W,port:$,connectionToken:x}=await H.addressProvider.getAddress();return{commit:H.commit,host:W,port:$,connectionToken:x,reconnectionToken:Z,reconnectionProtocol:ee,socketFactory:H.socketFactory,signService:H.signService,logService:H.logService}}async function o(H,Z,ee){try{const W=(0,b.generateUuid)(),$=await t(H,W,null),{protocol:x}=await r($,L.CancellationToken.None);return new F(H,Z,ee,W,x)}catch(W){throw H.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),H.logService.error(W),M.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(W)),W}}e.connectRemoteAgentManagement=o;async function s(H,Z){try{const ee=(0,b.generateUuid)(),W=await t(H,ee,null),{protocol:$,debugPort:x}=await c(W,Z,L.CancellationToken.None);return new V(H,Z,ee,$,x)}catch(ee){throw H.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),H.logService.error(ee),M.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(ee)),ee}}e.connectRemoteAgentExtensionHost=s;async function a(H,Z,ee){const W=await t(H,(0,b.generateUuid)(),null);return await i(W,{host:Z,port:ee},L.CancellationToken.None)}e.connectRemoteAgentTunnel=a;function h(H){return(0,D.createCancelablePromise)(Z=>new Promise((ee,W)=>{const $=setTimeout(ee,H*1e3);Z.onCancellationRequested(()=>{clearTimeout($),ee()})}))}var v;(function(H){H[H.ConnectionLost=0]="ConnectionLost",H[H.ReconnectionWait=1]="ReconnectionWait",H[H.ReconnectionRunning=2]="ReconnectionRunning",H[H.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",H[H.ConnectionGain=4]="ConnectionGain"})(v=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class P{constructor(Z,ee){this.reconnectionToken=Z,this.millisSinceLastIncomingData=ee,this.type=0}}e.ConnectionLostEvent=P;class _{constructor(Z,ee,W,$){this.reconnectionToken=Z,this.millisSinceLastIncomingData=ee,this.durationSeconds=W,this.cancellableTimer=$,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class O{constructor(Z,ee,W){this.reconnectionToken=Z,this.millisSinceLastIncomingData=ee,this.attempt=W,this.type=2}}e.ReconnectionRunningEvent=O;class U{constructor(Z,ee,W){this.reconnectionToken=Z,this.millisSinceLastIncomingData=ee,this.attempt=W,this.type=4}}e.ConnectionGainEvent=U;class k{constructor(Z,ee,W,$){this.reconnectionToken=Z,this.millisSinceLastIncomingData=ee,this.attempt=W,this.handled=$,this.type=3}}e.ReconnectionPermanentFailureEvent=k;class M extends R.Disposable{constructor(Z,ee,W,$){super();this._connectionType=Z,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=ee,this.reconnectionToken=W,this.protocol=$,this._isReconnecting=!1,this._onDidStateChange.fire(new U(this.reconnectionToken,0,0)),this._register($.onSocketClose(x=>{const z=j(this._connectionType,this.reconnectionToken,!0);x?x.type===0?(this._options.logService.info(`${z} received socket close event (hadError: ${x.hadError}).`),x.error&&this._options.logService.error(x.error)):(this._options.logService.info(`${z} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this._options.logService.error(x.event)):this._options.logService.info(`${z} received socket close event.`),this._beginReconnecting()})),this._register($.onSocketTimeout(()=>{const x=j(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${x} received socket timeout event.`),this._beginReconnecting()})),M._instances.push(this),M._permanentFailure&&this._gotoPermanentFailure(M._permanentFailureMillisSinceLastIncomingData,M._permanentFailureAttempt,M._permanentFailureHandled)}static triggerPermanentFailure(Z,ee,W){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=Z,this._permanentFailureAttempt=ee,this._permanentFailureHandled=W,this._instances.forEach($=>$._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(Z=>Z._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(Z=>Z._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(M._permanentFailure)return;const Z=j(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Z} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new P(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ee=[0,5,5,10,10,10,10,10,30];let W=-1;do{W++;const $=W<ee.length?ee[W]:ee[ee.length-1];try{if($>0){const z=h($);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$,z)),this._options.logService.info(`${Z} waiting for ${$} seconds before reconnecting...`);try{await z}catch{}}if(M._permanentFailure){this._options.logService.error(`${Z} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1)),this._options.logService.info(`${Z} resolving connection...`);const x=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${Z} connecting to ${x.host}:${x.port}...`),await this._reconnect(x,u(C)),this._options.logService.info(`${Z} reconnected!`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1));break}catch(x){if(x.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${Z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(x),M.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(W>360){this._options.logService.error(`${Z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(x),M.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(x)){this._options.logService.info(`${Z} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(x);continue}if((x.code==="ETIMEDOUT"||x.code==="ENETUNREACH"||x.code==="ECONNREFUSED"||x.code==="ECONNRESET")&&x.syscall==="connect"){this._options.logService.info(`${Z} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(x);continue}if((0,T.isCancellationError)(x)){this._options.logService.info(`${Z} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(x);continue}if(x instanceof I.RemoteAuthorityResolverError){this._options.logService.error(`${Z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(x),M.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,I.RemoteAuthorityResolverError.isHandled(x));break}this._options.logService.error(`${Z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(x),M.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}}while(!M._permanentFailure)}_gotoPermanentFailure(Z,ee,W){this._onDidStateChange.fire(new k(this.reconnectionToken,Z,ee,W)),N(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=M,M._permanentFailure=!1,M._permanentFailureMillisSinceLastIncomingData=0,M._permanentFailureAttempt=0,M._permanentFailureHandled=!1,M._instances=[];class F extends M{constructor(Z,ee,W,$,x){super(1,Z,$,x);this.client=this._register(new E.Client(x,{remoteAuthority:ee,clientId:W},Z.ipcLogger))}async _reconnect(Z,ee){await r(Z,ee)}}e.ManagementPersistentConnection=F;class V extends M{constructor(Z,ee,W,$,x){super(2,Z,W,$);this._startArguments=ee,this.debugPort=x}async _reconnect(Z,ee){await c(Z,this._startArguments,ee)}}e.ExtensionHostPersistentConnection=V;function N(H){try{H.acceptDisconnect();const Z=H.getSocket();H.dispose(),Z.dispose()}catch(Z){(0,T.onUnexpectedError)(Z)}}function G(H){if(H&&H.type==="error"){const Z=new Error(`Connection error: ${H.reason}`);return Z.code="VSCODE_CONNECTION_ERROR",Z}return null}function J(H,Z){for(;H.length<Z;)H+=" ";return H}function j(H,Z,ee){return`[remote-connection][${J(p(H),13)}][${Z.substr(0,5)}\u2026][${ee?"reconnect":"initial"}]`}function q(H,Z){return`${j(Z,H.reconnectionToken,!!H.reconnectionProtocol)}[${H.host}:${H.port}]`}function X(H){return`${Date.now()-H} ms`}}),define(ne[185],ie([0,1,18]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function n(E){return E.scheme===D.Schemas.vscodeRemote?E.authority:void 0}e.getRemoteAuthority=n;function L(E){if(!E)return;const I=E.indexOf("+");return I<0?E:E.substr(0,I)}e.getRemoteName=L;function T(E){return E.scheme!==D.Schemas.file&&E.scheme!==D.Schemas.vscodeRemote}e.isVirtualResource=T;function A(E){if(E.folders.length)return E.folders.every(I=>T(I.uri))?E.folders[0].uri:void 0;if(E.configuration&&T(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=A;function R(E){return A(E)?.scheme}e.getVirtualWorkspaceScheme=R;function b(E){return A(E)!==void 0}e.isVirtualWorkspace=b}),define(ne[90],ie([0,1,26,6,185]),function(K,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=T;function A(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class b{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,u){if(typeof p=="undefined"||p===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof p=="string"||typeof u=="string"){let m=typeof p=="string"?p:p.value,d=typeof u=="string"?u:u.value;return D.equalsIgnoreCase(m,d)}return p._lower===u._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=b;function E(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function I(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=I;function C(f,p){if(p){const u=`onResolveRemoteAuthority:${(0,L.getRemoteName)(p)}`;return f.activationEvents?.indexOf(u)!==-1}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[31],ie([0,1,26,90]),function(K,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function L(u,m){return u.uuid&&m.uuid?u.uuid===m.uuid:u.id===m.id?!0:(0,D.compareIgnoreCase)(u.id,m.id)===0}e.areSameExtensions=L;class T{constructor(m,d){this.version=d,this.id=m.id,this.uuid=m.uuid}key(){return`${this.id}-${this.version}`}equals(m){return m instanceof T?L(this,m)&&this.version===m.version:!1}}e.ExtensionIdentifierWithVersion=T;function A(u,m){return`${u}.${m}`}e.getExtensionId=A;function R(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function b(u,m){return R(A(u,m))}e.getGalleryExtensionId=b;function E(u,m){const d=[],g=w=>{for(const y of d)if(y.some(S=>L(m(S),m(w))))return y;return null};for(const w of u){const y=g(w);y?y.push(w):d.push([w])}return d}e.groupByExtension=E;function I(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=I;function C(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function f(u){const m=new Set;if(u.malicious)for(const d of u.malicious)m.add(d.id);return m}e.getMaliciousExtensionsSet=f;function p(u,m){const d=[],g=m.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const w=g.shift();if(w&&d.every(y=>!L(y.identifier,{id:w}))){const y=u.filter(S=>L(S.identifier,{id:w}));y.length===1&&(d.push(y[0]),g.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}e.getExtensionDependencies=p}),define(ne[30],ie([0,1,18,130,31,6]),function(K,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.getIdAndVersion=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";const A=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function R(r){const c=A.exec(r);return c&&c[1]?[(0,L.adoptToGalleryExtensionId)(c[1]),c[2]]:[(0,L.adoptToGalleryExtensionId)(r),void 0]}e.getIdAndVersion=R;var b;(function(r){r.WIN32_X64="win32-x64",r.WIN32_IA32="win32-ia32",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(b=e.TargetPlatform||(e.TargetPlatform={}));function E(r){switch(r){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=E;function I(r){switch(r){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=I;function C(r,c){switch(r){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function f(r,c){return c==="web"&&!r.includes("web")}e.isNotWebExtensionInWebTargetPlatform=f;function p(r,c,i){return f(c,i)?!1:r==="undefined"||r==="universal"?!0:r==="unknown"?!1:r===i?!0:u(i).includes(r)}e.isTargetPlatformCompatible=p;function u(r){switch(r){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=u;function m(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.isIExtensionIdentifier=m;var d;(function(r){r[r.NoneOrRelevance=0]="NoneOrRelevance",r[r.LastUpdatedDate=1]="LastUpdatedDate",r[r.Title=2]="Title",r[r.PublisherName=3]="PublisherName",r[r.InstallCount=4]="InstallCount",r[r.PublishedDate=10]="PublishedDate",r[r.AverageRating=6]="AverageRating",r[r.WeightedRating=12]="WeightedRating"})(d=e.SortBy||(e.SortBy={}));var g;(function(r){r[r.Default=0]="Default",r[r.Ascending=1]="Ascending",r[r.Descending=2]="Descending"})(g=e.SortOrder||(e.SortOrder={}));var w;(function(r){r.Install="install",r.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var y;(function(r){r[r.None=1]="None",r[r.Install=2]="Install",r[r.Update=3]="Update",r[r.Migrate=4]="Migrate"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var S;(function(r){r.Unsupported="Unsupported",r.UnsupportedPreRelease="UnsupportedPreRelease",r.Malicious="Malicious",r.Incompatible="Incompatible",r.IncompatiblePreRelease="IncompatiblePreRelease",r.IncompatibleTargetPlatform="IncompatibleTargetPlatform",r.ReleaseVersionNotFound="ReleaseVersionNotFound",r.Invalid="Invalid",r.Download="Download",r.Extract="Extract",r.Delete="Delete",r.Rename="Rename",r.CorruptZip="CorruptZip",r.IncompleteZip="IncompleteZip",r.Internal="Internal"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class l extends Error{constructor(c,i){super(c);this.code=i,this.name=i}}e.ExtensionManagementError=l,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,n.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,T.createDecorator)("IExtensionManagementCLIService")}),define(ne[186],ie([0,1,3,2,28,7,110,30]),function(K,e,D,n,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function b(m,d){return T.URI.revive(d?d.transformIncoming(m):m)}function E(m,d){return d?d.transformOutgoingURI(m):m}function I(m,d){d=d||A.DefaultURITransformer;const g=m.manifest;return{...(0,A.transformAndReviveIncomingURIs)({...m,manifest:void 0},d),manifest:g}}function C(m,d){return d?(0,L.cloneAndChange)(m,g=>g instanceof T.URI?d.transformOutgoingURI(g):void 0):m}class f{constructor(d,g){this.service=d,this.getUriTransformer=g,this.onInstallExtension=D.Event.buffer(d.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(d.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(d.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(d.onDidUninstallExtension,!0)}listen(d,g){const w=this.getUriTransformer(d);switch(g){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,y=>y.map(S=>({...S,local:S.local?C(S.local,w):S.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(d,g,w){const y=this.getUriTransformer(d);switch(g){case"zip":return this.service.zip(I(w[0],y)).then(S=>E(S,y));case"unzip":return this.service.unzip(b(w[0],y));case"install":return this.service.install(b(w[0],y),w[1]);case"getManifest":return this.service.getManifest(b(w[0],y));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(w[0]);case"installFromGallery":return this.service.installFromGallery(w[0],w[1]);case"uninstall":return this.service.uninstall(I(w[0],y),w[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(I(w[0],y));case"getInstalled":return this.service.getInstalled(w[0]).then(S=>S.map(l=>C(l,y)));case"updateMetadata":return this.service.updateMetadata(I(w[0],y),w[1]).then(S=>C(S,y));case"updateExtensionScope":return this.service.updateExtensionScope(I(w[0],y),w[1]).then(S=>C(S,y));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class p extends n.Disposable{constructor(d){super();this.channel=d,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(g=>this._onInstallExtension.fire({identifier:g.identifier,source:this.isUriComponents(g.source)?T.URI.revive(g.source):g.source}))),this._register(this.channel.listen("onDidInstallExtensions")(g=>this._onDidInstallExtensions.fire(g.map(w=>({...w,local:w.local?I(w.local,null):w.local,source:this.isUriComponents(w.source)?T.URI.revive(w.source):w.source}))))),this._register(this.channel.listen("onUninstallExtension")(g=>this._onUninstallExtension.fire(g))),this._register(this.channel.listen("onDidUninstallExtension")(g=>this._onDidUninstallExtension.fire(g)))}isUriComponents(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(d){const g=await this.getTargetPlatform();return d.allTargetPlatforms.some(w=>(0,R.isTargetPlatformCompatible)(w,d.allTargetPlatforms,g))}zip(d){return Promise.resolve(this.channel.call("zip",[d]).then(g=>T.URI.revive(g)))}unzip(d){return Promise.resolve(this.channel.call("unzip",[d]))}install(d,g){return Promise.resolve(this.channel.call("install",[d,g])).then(w=>I(w,null))}getManifest(d){return Promise.resolve(this.channel.call("getManifest",[d]))}installFromGallery(d,g){return Promise.resolve(this.channel.call("installFromGallery",[d,g])).then(w=>I(w,null))}uninstall(d,g){return Promise.resolve(this.channel.call("uninstall",[d,g]))}reinstallFromGallery(d){return Promise.resolve(this.channel.call("reinstallFromGallery",[d]))}getInstalled(d=null){return Promise.resolve(this.channel.call("getInstalled",[d])).then(g=>g.map(w=>I(w,null)))}updateMetadata(d,g){return Promise.resolve(this.channel.call("updateMetadata",[d,g])).then(w=>I(w,null))}updateExtensionScope(d,g){return Promise.resolve(this.channel.call("updateExtensionScope",[d,g])).then(w=>I(w,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=p;class u{constructor(d){this.service=d}listen(d,g){throw new Error("Invalid listen")}call(d,g,w){switch(g){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(w[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=u}),define(ne[187],ie([0,1,23,31]),function(K,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function L(T,A,R,b,E){try{const I=await T.getExtensionsControlManifest();if(!I.unsupportedPreReleaseExtensions)return;const C=await T.getInstalled(1);for(const[f,{id:p,migrateStorage:u}]of Object.entries(I.unsupportedPreReleaseExtensions)){const m=C.find(g=>(0,n.areSameExtensions)(g.identifier,{id:f}));if(!m)continue;const d=(await A.getExtensions([{id:p,preRelease:!0}],{targetPlatform:await T.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!d){E.info(`Skipping migrating '${m.identifier.id}' extension because, the comaptible target '${p}' extension is not found`);continue}try{E.info(`Migrating '${m.identifier.id}' extension to '${p}' extension...`);const g=!b.getDisabledExtensions().some(y=>(0,n.areSameExtensions)(y,m.identifier));await T.uninstall(m),E.info(`Uninstalled the unsupported extension '${m.identifier.id}'`);let w=C.find(y=>(0,n.areSameExtensions)(y.identifier,{id:p}));(!w||!w.isPreReleaseVersion&&g)&&(w=await T.installFromGallery(d,{installPreReleaseVersion:!0,isMachineScoped:m.isMachineScoped,operation:4}),E.info(`Installed the pre-release extension '${w.identifier.id}'`),g||(await b.disableExtension(w.identifier),E.info(`Disabled the pre-release extension '${w.identifier.id}' because the unsupported extension '${m.identifier.id}' is disabled`)),u&&(R.addToMigrationList((0,n.getExtensionId)(m.manifest.publisher,m.manifest.name),(0,n.getExtensionId)(w.manifest.publisher,w.manifest.name)),E.info("Added pre-release extension to the storage migration list"))),E.info(`Migrated '${m.identifier.id}' extension to '${p}' extension.`)}catch(g){E.error(g)}}}catch(I){E.error(I)}}e.migrateUnsupportedExtensions=L}),define(ne[188],ie([0,1,5,9,2,4,19,61,7,29,22,15,30,31,13,8]),function(K,e,D,n,L,T,A,R,b,E,I,C,f,p,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const d=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let g=class extends L.Disposable{constructor(y,S,l,r){super();this.fileService=S,this.extensionGalleryService=l,this.logService=r,this.extensionsDownloadDir=b.URI.file(y.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(y,S){await this.cleanUpPromise;const l=this.getName(y),r=(0,A.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(r)){const c=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,E.generateUuid)()}`);await this.fileService.exists(c)||await this.extensionGalleryService.download(y,c,S);try{await this.rename(c,r,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(c)}catch{}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",y.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,c.path),i}}return r}async delete(y){await this.cleanUpPromise,await this.fileService.del(y)}async rename(y,S,l){try{await I.Promises.rename(y.fsPath,S.fsPath)}catch(r){if(T.isWindows&&r&&r.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${y} to ${S} with 'EPERM' error. Trying again...`),this.rename(y,S,l);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const y=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(y.children){const S=[],l=[];for(const i of y.children){const t=this.parse(i.name);t&&l.push([t,i])}const r=(0,p.groupByExtension)(l,([i])=>i),c=[];for(const i of r)i.sort((t,o)=>R.rcompare(t[0].version,o[0].version)),S.push(...i.slice(1).map(t=>t[1].resource)),c.push(i[0][1]);c.sort((i,t)=>i.mtime-t.mtime),S.push(...c.slice(0,Math.max(0,c.length-this.cache)).map(i=>i.resource)),await D.Promises.settled(S.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(y){this.logService.error(y)}}getName(y){return this.cache?`${new p.ExtensionIdentifierWithVersion(y.identifier,y.version).key().toLowerCase()}${y.properties.targetPlatform!=="undefined"?`-${y.properties.targetPlatform}`:""}`:(0,E.generateUuid)()}parse(y){const S=d.exec(y);return S&&S[1]&&S[2]?new p.ExtensionIdentifierWithVersion({id:S[1]},S[2]):null}};g=de([Y(0,C.INativeEnvironmentService),Y(1,u.IFileService),Y(2,f.IExtensionGalleryService),Y(3,m.ILogService)],g),e.ExtensionsDownloader=g}),define(ne[189],ie([0,1,2,10,22,90]),function(K,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends D.Disposable{constructor(b,E){super();this.environmentService=b,this.extensionsManifestCache=(0,n.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(E.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(E.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtensions(b){b.some(E=>!!E.local)&&this.invalidate()}onDidUnInstallExtension(b){b.error||this.invalidate()}invalidate(){L.Promises.rm(this.extensionsManifestCache,L.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(ne[190],ie([0,1,83,16,5,2,18,10,22,15,30,31,59,8]),function(K,e,D,n,L,T,A,R,b,E,I,C,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let u=class extends T.Disposable{constructor(g,w,y){super();this.extensionManagementService=g,this.logService=y,this.cache=this._register(new m(w,y)),this.extensionManagementService.registerParticipant({postInstall:async S=>this.postInstallExtension(S),postUninstall:async S=>this.postUninstallExtension(S)})}async getLanguageIds(){const g=await this.cache.getLanguagePacks(),w=["en",...Object.keys(g)];return(0,n.distinct)(w)}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const w=await this.cache.getLanguagePacks();Object.keys(w).some(y=>w[y]&&w[y].extensions.some(S=>(0,C.areSameExtensions)(S.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,w]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),y=await this.cache.update(w);return!(0,n.equals)(Object.keys(g),Object.keys(y))}};u=de([Y(0,I.IExtensionManagementService),Y(1,E.INativeEnvironmentService),Y(2,p.ILogService)],u),e.LocalizationsService=u;let m=class extends T.Disposable{constructor(g,w){super();this.logService=w,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new L.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(w=>{Object.keys(w).forEach(y=>delete w[y]),this.createLanguagePacksFromExtensions(w,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...w){for(const y of w)y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,y);Object.keys(g).forEach(y=>this.updateHash(g[y]))}createLanguagePacksFromExtension(g,w){const y=w.identifier,S=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const l of S)if(w.location.scheme===A.Schemas.file&&(0,f.isValidLocalization)(l)){let r=g[l.languageId];r||(r={hash:"",extensions:[],translations:{}},g[l.languageId]=r);let c=r.extensions.filter(i=>(0,C.areSameExtensions)(i.extensionIdentifier,y))[0];c?c.version=w.manifest.version:r.extensions.push({extensionIdentifier:y,version:w.manifest.version});for(const i of l.translations)r.translations[i.id]=(0,R.join)(w.location.fsPath,i.path)}}updateHash(g){if(g){const w=(0,D.createHash)("md5");for(const y of g.extensions)w.update(y.extensionIdentifier.uuid||y.extensionIdentifier.id).update(y.version);g.hash=w.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let w=null;return b.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,y=>y.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(y)).then(y=>{try{return JSON.parse(y)}catch{return{}}}).then(y=>(w=g(y),y)).then(y=>{for(const l of Object.keys(y))y[l]||delete y[l];this.languagePacks=y,this.initializedCache=!0;const S=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",S),b.Promises.writeFile(this.languagePacksFilePath,S)}).then(()=>w,y=>this.logService.error(y))})}};m=de([Y(0,E.INativeEnvironmentService),Y(1,p.ILogService)],m)}),define(ne[191],ie([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ne[62],ie([0,1,3,4,6,8]),function(K,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,L.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,L.createDecorator)("sharedTunnelsService");var A;(function(u){u.Http="http",u.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(u){u.ConstantPrivate="constantPrivate",u.Private="private",u.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var b;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(b=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function E(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(!!m)return{address:m[1],port:+m[2]}}e.extractLocalHostUriMetaDataForPortMapping=E,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(u){return e.LOCALHOST_ADDRESSES.indexOf(u)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(u){return e.ALL_INTERFACES_ADDRESSES.indexOf(u)>=0}e.isAllInterfaces=C;function f(u,m){return m?m!==1&&u<1024:!n.isWindows&&u<1024}e.isPortPrivileged=f;let p=class{constructor(m){this.logService=m,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(m){return this._tunnelProvider=m,m?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(m){this._canElevate=m.elevation,this._privacyOptions=m.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const m=[],d=Array.from(this._tunnels.values());for(let g of d){const w=Array.from(g.values());for(let y of w){const S=await y.value;S&&m.push(S)}}return m}async dispose(){for(const m of this._tunnels.values()){for(const{value:d}of m.values())await d.then(g=>g?.dispose());m.clear()}this._tunnels.clear()}openTunnel(m,d,g,w,y=!1,S=R.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${g} on local port ${w}.`),!m)return;d||(d="localhost");const r=this.retainOrCreateTunnel(m,d,g,w,y,S,l);return r?r.then(c=>{if(!c){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(c);return(c.tunnelRemoteHost!==d||c.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const d=this._tunnels.get(m.tunnelRemoteHost);if(d){const g=d.get(m.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(m.tunnelRemoteHost,m.tunnelRemotePort,g))}}}}async tryDisposeTunnel(m,d,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${d}.`);const w=g.value.then(async y=>{y&&(await y.dispose(!0),this._onTunnelClosed.fire({host:y.tunnelRemoteHost,port:y.tunnelRemotePort}))});return this._tunnels.has(m)&&this._tunnels.get(m).delete(d),w}}async closeTunnel(m,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${d} `);const g=this._tunnels.get(m);if(g&&g.has(d)){const w=g.get(d);w.refcount=0,await this.tryDisposeTunnel(m,d,w)}}addTunnelToMap(m,d,g){this._tunnels.has(m)||this._tunnels.set(m,new Map),this._tunnels.get(m).set(d,{refcount:1,value:g})}async removeEmptyTunnelFromMap(m,d){const g=this._tunnels.get(m);g&&(await g.get(d)||g.delete(d),g.size===0&&this._tunnels.delete(m))}getTunnelFromMap(m,d){let g=[m];I(m)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):C(m)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const w=g.map(y=>this._tunnels.get(y));for(const y of w){const S=y?.get(d);if(S)return S}}canTunnel(m){return!!E(m)}createWithProvider(m,d,g,w,y,S,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${g} on local port ${w}.`);const c={elevationRequired:y?f(w===void 0?g:w):!1},i={remoteAddress:{host:d,port:g},localAddressPort:w,privacy:S,public:S!==R.Private,protocol:l},t=m.forwardPort(i,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(d,g,t),t}};p=de([Y(0,T.ILogService)],p),e.AbstractTunnelService=p}),define(ne[192],ie([0,1,8,62,2,9,5]),function(K,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends L.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new A.DeferredPromise),this._addressPromise.p)}setAddress(I){this._address=I,this._addressPromise&&(this._addressPromise.complete(I),this._addressPromise=null)}setTunnel(I){this._register(I)}}let b=class Ct extends L.Disposable{constructor(I,C){super();this._tunnelService=I,this._logService=C,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(I=>I.dispose())}async createTunnel(){return{id:String(++Ct._lastId)}}async startTunnel(I,C,f,p,u,m){const d=new R,g=await Promise.resolve(this._tunnelService.openTunnel(I,d,f,p,u,m));if(!g)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${f}:${p} (remote).`),d.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(C))throw this._disposedTunnels.delete(C),d.dispose(),await g.dispose(),(0,T.canceled)();return d.setTunnel(g),this._tunnels.set(C,d),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${C}: ${g.localAddress} (local) to ${f}:${p} (remote).`),{tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress}}async setAddress(I,C){const f=this._tunnels.get(I);!f||f.setAddress(C)}async destroyTunnel(I){const C=this._tunnels.get(I);if(C){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${I}.`),this._tunnels.delete(I),await C.dispose();return}this._disposedTunnels.add(I)}};b._lastId=0,b=de([Y(0,n.ISharedTunnelsService),Y(1,D.ILogService)],b),e.SharedProcessTunnelService=b}),define(ne[193],ie([0,1,119,20,8]),function(K,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(R,b){this.configurationService=R,this.logService=b}request(R,b){return this.logService.trace("RequestService#request",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,D.request)(R,b)}async resolveProxy(R){}};T=de([Y(0,n.IConfigurationService),Y(1,L.ILogService)],T),e.RequestService=T}),define(ne[43],ie([0,1,17,140,42,6,38]),function(K,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function R(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.isSuccess=R;function b(u){return u.res.statusCode===204}async function E(u){if(!R(u))throw new Error("Server returned "+u.res.statusCode);return b(u)?null:(await(0,D.streamToBuffer)(u.stream)).toString()}e.asText=E;async function I(u){if(!R(u))throw new Error("Server returned "+u.res.statusCode);if(b(u))return null;const d=(await(0,D.streamToBuffer)(u.stream)).toString();try{return JSON.parse(d)}catch(g){throw g.message+=`:
`+d,g}}e.asJson=I;function C(u){p(u)}e.updateProxyConfigurationsScope=C;let f;function p(u){const m=A.Registry.as(L.Extensions.Configuration),d=f;f={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},m.updateConfigurations({add:[f],remove:d?[d]:[]})}p(2)}),define(ne[194],ie([0,1,23,18,13,43]),function(K,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(b,E){this.requestService=b,this.fileService=E}async download(b,E,I=D.CancellationToken.None){if(b.scheme===n.Schemas.file||b.scheme===n.Schemas.vscodeRemote){await this.fileService.copy(b,E);return}const C={type:"GET",url:b.toString()},f=await this.requestService.request(C,I);if(f.res.statusCode===200)await this.fileService.writeFile(E,f.stream);else{const p=await(0,T.asText)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${p}`)}}};A=de([Y(0,T.IRequestService),Y(1,L.IFileService)],A),e.DownloadService=A}),define(ne[195],ie([0,1,16,23,67,2,19,153,13,8,27,43]),function(K,e,D,n,L,T,A,R,b,E,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let f=class extends T.Disposable{constructor(u,m,d,g){super();this.fileService=u,this.productService=m,this.requestService=d,this.logService=g,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,L.forEach)(this.productService.configBasedExtensionTips,({value:w})=>this.allConfigBasedTips.set(w.configPath,w))}getConfigBasedTips(u){return this.getValidConfigBasedTips(u)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(u){const m=[];for(const[d,g]of this.allConfigBasedTips)if(!(g.configScheme&&g.configScheme!==u.scheme))try{const w=await this.fileService.readFile((0,A.joinPath)(u,d)),y=new Map;(0,L.forEach)(g.recommendations,({key:l,value:r})=>{if((0,D.isNonEmptyArray)(r.remotes))for(const c of r.remotes)y.set(c,{extensionId:l,extensionName:r.name,configName:g.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack});else m.push({extensionId:l,extensionName:r.name,configName:g.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack})});const S=(0,R.getDomainsOfRemotes)(w.value.toString(),[...y.keys()]);for(const l of S){const r=y.get(l);r&&m.push(r)}}catch{}return m}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const u=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},n.CancellationToken.None);if(u.res.statusCode!==200)return[];const m=await(0,C.asJson)(u);return m?m.workspaceRecommendations||[]:[]}catch(u){return this.logService.error(u),[]}}};f=de([Y(0,b.IFileService),Y(1,I.IProductService),Y(2,C.IRequestService),Y(3,E.ILogService)],f),e.ExtensionTipsService=f}),define(ne[46],ie([0,1,17,29]),function(K,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(T,A,R){let b=R&&R.get("storage.serviceMachineId",0)||null;if(b)return b;try{const I=(await A.readFile(T.serviceMachineIdResource)).value.toString();b=(0,n.isUUID)(I)?I:null}catch{b=null}if(!b){b=(0,n.generateUuid)();try{await A.writeFile(T.serviceMachineIdResource,D.VSBuffer.fromString(b))}catch{}}return R&&R.store("storage.serviceMachineId",b,0,1),b}e.getServiceMachineId=L}),define(ne[91],ie([0,1,70,6]),function(K,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function L(T){return(0,D.hash)({moduleId:T.process.moduleId,windowId:T.reply.windowId})}e.hash=L,e.ISharedProcessWorkerService=(0,n.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ne[196],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(n){n.Spawn="vscode:shared-process->shared-process-worker=spawn",n.Terminate="vscode:shared-process->shared-process-worker=terminate",n.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",n.Ready="vscode:shared-process-worker->shared-process=ready",n.Ack="vscode:shared-process-worker->shared-process=ack",n.Trace="vscode:shared-process-worker->shared-process=trace",n.Info="vscode:shared-process-worker->shared-process=info",n.Warn="vscode:shared-process-worker->shared-process=warn",n.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ne[197],ie([0,1,74,5,23,3,2,18,29,8,91,196]),function(K,e,D,n,L,T,A,R,b,E,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let f=class{constructor(m){this.logService=m,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(m){const d=`window: ${m.reply.windowId}, moduleId: ${m.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${d})`);const g=(0,I.hash)(m);this.processeDisposables.has(g)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${d})`),this.doDisposeWorker(m));const w=new L.CancellationTokenSource;let y,S,l;this.processeDisposables.set(g,t=>{w.dispose(!0),y?.terminate(m,L.CancellationToken.None),S?.close(),l?.close(),this.processeDisposables.delete(g);const o=this.processResolvers.get(g);o&&(this.processResolvers.delete(g),o({reason:t}))}),y=await this.getOrCreateWebWorker(m);const r=new Promise(t=>{this.processResolvers.set(g,t)});if(w.token.isCancellationRequested)return r;const{port1:c,port2:i}=new MessageChannel;return S=c,l=i,await y.spawn(m,l,w.token),w.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${d})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",m,[S])),r}getOrCreateWebWorker(m){let d=this.workers.get(m.process.moduleId);if(!d){this.logService.trace(`SharedProcess: creating new web worker (${m.process.moduleId})`);const g=new p(m.process.type,this.logService);d=g.init(),g.onDidProcessSelfTerminate(({configuration:w,reason:y})=>{this.doDisposeWorker(w,y)}),this.workers.set(m.process.moduleId,d)}return d}async disposeWorker(m){return this.doDisposeWorker(m)}doDisposeWorker(m,d){const g=this.processeDisposables.get((0,I.hash)(m));g&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${m.reply.windowId}, moduleId: ${m.process.moduleId})`),g(d))}};f=de([Y(0,E.ILogService)],f),e.SharedProcessWorkerService=f;class p extends A.Disposable{constructor(m,d){super();this.type=m,this.logService=d,this._onDidProcessSelfTerminate=this._register(new T.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const m=new n.DeferredPromise,d=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return d.onerror=g=>{this.logService.error(`SharedProcess: worker error (${this.type})`,g.message)},d.onmessageerror=g=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,g)},d.onmessage=g=>{const{id:w,message:y,configuration:S,nonce:l}=g.data;switch(w){case C.SharedProcessWorkerMessages.Ready:m.complete(d);break;case C.SharedProcessWorkerMessages.Ack:if(l){const r=this.mapMessageNonceToPendingMessageResolve.get(l);r&&(this.mapMessageNonceToPendingMessageResolve.delete(l),r())}break;case C.SharedProcessWorkerMessages.SelfTerminated:S&&y&&this._onDidProcessSelfTerminate.fire({configuration:S,reason:JSON.parse(y)});break;case C.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,y);break;case C.SharedProcessWorkerMessages.Info:y&&this.logService.info(y);break;case C.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,y);break;case C.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,y);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,g)}},d.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),m.p}async send(m,d,g){const w=await this.workerReady;if(!d.isCancellationRequested)return new Promise(y=>{const S=(0,b.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(S,y);const l={...m,nonce:S};g?w.postMessage(l,[g]):w.postMessage(l),d.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(S)&&y()})})}spawn(m,d,g){const w={id:C.SharedProcessWorkerMessages.Spawn,configuration:m,environment:{bootstrapPath:R.FileAccess.asFileUri("bootstrap-fork",K).fsPath}};return this.send(w,g,d)}terminate(m,d){const g={id:C.SharedProcessWorkerMessages.Terminate,configuration:m};return this.send(g,d)}}}),define(ne[198],ie([0,1,54,18,152]),function(K,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class T extends L.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:n.Schemas.userData})}}de([D.memoize],T.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=T}),define(ne[92],ie([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(ne[199],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.validators=new Map}vsda(){return new Promise((L,T)=>K(["vsda"],L,T))}async createNewMessage(L){try{const T=await this.vsda(),A=new T.validator;if(A){const R=String(D._nextId++);return this.validators.set(R,A),{id:R,data:A.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,T){if(!L.id)return!0;const A=this.validators.get(L.id);if(!A)return!1;this.validators.delete(L.id);try{return A.validate(T)==="ok"}catch{return!1}}async sign(L){try{const T=await this.vsda(),A=new T.signer;if(A)return A.sign(L)}catch{}return L}}e.SignService=D,D._nextId=1}),define(ne[24],ie([0,1,5,3,2,176,14,75,6]),function(K,e,D,n,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const E="__$__targetStorageMarker";e.IStorageService=(0,b.createDecorator)("storageService");var I;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var C;(function(d){d[d.GLOBAL=0]="GLOBAL",d[d.WORKSPACE=1]="WORKSPACE"})(C=e.StorageScope||(e.StorageScope={}));var f;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(f=e.StorageTarget||(e.StorageTarget={}));class p extends L.Disposable{constructor(g={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super();this.options=g,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,w){w===E?(g===0?this._globalKeyTargets=void 0:g===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:g})):this._onDidChangeValue.fire({scope:g,key:w,target:this.getKeyTargets(g)[w]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,w,y){return this.getStorage(w)?.get(g,y)}getBoolean(g,w,y){return this.getStorage(w)?.getBoolean(g,y)}getNumber(g,w,y){return this.getStorage(w)?.getNumber(g,y)}store(g,w,y,S){if((0,A.isUndefinedOrNull)(w)){this.remove(g,y);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,y,S),this.getStorage(y)?.set(g,w)})}remove(g,w){this.withPausedEmitters(()=>{this.updateKeyTarget(g,w,void 0),this.getStorage(w)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,w){const y=[],S=this.getKeyTargets(g);for(const l of Object.keys(S))S[l]===w&&y.push(l);return y}updateKeyTarget(g,w,y){const S=this.getKeyTargets(w);typeof y=="number"?S[g]!==y&&(S[g]=y,this.getStorage(w)?.set(E,JSON.stringify(S))):typeof S[g]=="number"&&(delete S[g],this.getStorage(w)?.set(E,JSON.stringify(S)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(g){return g===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(g){const w=this.get(E,g);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=I.NONE){this._onWillSaveState.fire({reason:g});const w=this.getStorage(0),y=this.getStorage(1);switch(g){case I.NONE:await D.Promises.settled([w?.whenFlushed()??Promise.resolve(),y?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await D.Promises.settled([w?.flush(0)??Promise.resolve(),y?.flush(0)??Promise.resolve()]);break}}async logStorage(){const g=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return m(g,w,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;class u extends p{constructor(){super();this.globalStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.globalStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g)))}getStorage(g){return g===0?this.globalStorage:this.workspaceStorage}getLogDetails(g){return g===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(g){}}e.InMemoryStorageService=u;async function m(d,g,w,y){const S=s=>{try{return JSON.parse(s)}catch{return s}},l=new Map,r=new Map;d.forEach((s,a)=>{l.set(a,s),r.set(a,S(s))});const c=new Map,i=new Map;g.forEach((s,a)=>{c.set(a,s),i.set(a,S(s))}),console.group(`Storage: Global (path: ${w})`);let t=[];l.forEach((s,a)=>{t.push({key:a,value:s})}),console.table(t),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${y})`);let o=[];c.forEach((s,a)=>{o.push({key:a,value:s})}),console.table(o),console.groupEnd(),console.log(i)}e.logStorage=m}),define(ne[200],ie([0,1,3,2,14,30,31,24]),function(K,e,D,n,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let b=class extends n.Disposable{constructor(C,f){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new E(C)),this._register(this.storageManger.onDidChange(p=>this._onDidChangeEnablement.fire({extensions:p,source:"storage"}))),this._register(f.onDidInstallExtensions(p=>p.forEach(({local:u,operation:m})=>{u&&m===4&&this._removeFromDisabledExtensions(u.identifier)})))}async enableExtension(C,f){return this._removeFromDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:f}),!0):!1}async disableExtension(C,f){return this._addToDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:f}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(C){let f=this.getDisabledExtensions();return f.every(p=>!(0,A.areSameExtensions)(p,C))?(f.push(C),this._setDisabledExtensions(f),!0):!1}_removeFromDisabledExtensions(C){let f=this.getDisabledExtensions();for(let p=0;p<f.length;p++){const u=f[p];if((0,A.areSameExtensions)(u,C))return f.splice(p,1),this._setDisabledExtensions(f),!0}return!1}_setDisabledExtensions(C){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,C)}_getExtensions(C){return this.storageManger.get(C,0)}_setExtensions(C,f){this.storageManger.set(C,f,0)}};b=de([Y(0,R.IStorageService),Y(1,T.IExtensionManagementService)],b),e.GlobalExtensionEnablementService=b;class E extends n.Disposable{constructor(C){super();this.storageService=C,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(C.onDidChangeValue(f=>this.onDidStorageChange(f)))}get(C,f){let p;return f===0?((0,L.isUndefinedOrNull)(this.storage[C])&&(this.storage[C]=this._get(C,f)),p=this.storage[C]):p=this._get(C,f),JSON.parse(p)}set(C,f,p){let u=JSON.stringify(f.map(({id:d,uuid:g})=>({id:d,uuid:g})));this._get(C,p)!==u&&(p===0&&(f.length?this.storage[C]=u:delete this.storage[C]),this._set(C,f.length?u:void 0,p))}onDidStorageChange(C){if(C.scope===0&&!(0,L.isUndefinedOrNull)(this.storage[C.key])&&this._get(C.key,C.scope)!==this.storage[C.key]){const p=this.get(C.key,C.scope);delete this.storage[C.key];const u=this.get(C.key,C.scope),m=p.filter(g=>!u.some(w=>(0,A.areSameExtensions)(g,w))),d=u.filter(g=>!p.some(w=>(0,A.areSameExtensions)(w,g)));(m.length||d.length)&&this._onDidChange.fire([...m,...d])}}_get(C,f){return this.storageService.get(C,f,"[]")}_set(C,f,p){f?this.storageService.store(C,f,p,1):this.storageService.remove(C,p)}}e.StorageManager=E}),define(ne[63],ie([0,1,6,3,2,24,31,27,16,8,14]),function(K,e,D,n,L,T,A,R,b,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const C=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let f=class nt extends L.Disposable{constructor(u,m,d){super();this.storageService=u,this.productService=m,this.logService=d,this._onDidChangeExtensionStorageToSync=this._register(new n.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(g=>this.onDidChangeStorageValue(g)))}static toKey(u){return`extensionKeys/${(0,A.adoptToGalleryExtensionId)(u.id)}@${u.version}`}static fromKey(u){const m=C.exec(u);if(m&&m[1])return{id:m[1],version:m[2]}}initialize(){const u=this.storageService.keys(0,1);for(const m of u){const d=nt.fromKey(m);d&&this.extensionsWithKeysForSync.add(d.id.toLowerCase())}}onDidChangeStorageValue(u){if(u.scope!==0)return;if(this.extensionsWithKeysForSync.has(u.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const m=nt.fromKey(u.key);if(m){this.extensionsWithKeysForSync.add(m.id.toLowerCase()),this._onDidChangeExtensionStorageToSync.fire();return}}getExtensionId(u){if((0,I.isString)(u))return u;const m=u.manifest?u.manifest.publisher:u.publisher,d=u.manifest?u.manifest.name:u.name;return(0,A.getExtensionId)(m,d)}getExtensionState(u,m){const d=this.getExtensionId(u),g=this.storageService.get(d,m?0:1);if(g)try{return JSON.parse(g)}catch(w){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${d}, global: ${m}): ${w}`)}}setExtensionState(u,m,d){const g=this.getExtensionId(u);m===void 0?this.storageService.remove(g,d?0:1):this.storageService.store(g,JSON.stringify(m),d?0:1,1)}setKeysForSync(u,m){this.storageService.store(nt.toKey(u),JSON.stringify(m),0,1)}getKeysForSync(u){const m=this.productService.extensionSyncedKeys?.[u.id.toLowerCase()],d=this.storageService.get(nt.toKey(u),0),g=d?JSON.parse(d):void 0;return g&&m?(0,b.distinct)([...g,...m]):g||m}addToMigrationList(u,m){if(u!==m){const d=this.migrationList.filter(g=>!g.includes(u)&&!g.includes(m));d.push([u,m]),this.migrationList=d}}getSourceExtensionToMigrate(u){const m=this.migrationList.find(([,d])=>u===d);return m?m[0]:void 0}get migrationList(){const u=this.storageService.get("extensionStorage.migrationList",0,"[]");try{const m=JSON.parse(u);if((0,I.isArray)(m))return m}catch{}return[]}set migrationList(u){u.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(u),0,1):this.storageService.remove("extensionStorage.migrationList",0)}};f=de([Y(0,T.IStorageService),Y(1,R.IProductService),Y(2,E.ILogService)],f),e.ExtensionStorageService=f}),define(ne[201],ie([0,1,2,30,63,187,8]),function(K,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;let R=class extends D.Disposable{constructor(E,I,C,f,p){super();E.removeDeprecatedExtensions(),(0,T.migrateUnsupportedExtensions)(E,I,C,f,p)}};R=de([Y(0,n.IExtensionManagementService),Y(1,n.IExtensionGalleryService),Y(2,L.IExtensionStorageService),Y(3,n.IGlobalExtensionEnablementService),Y(4,A.ILogService)],R),e.ExtensionsCleaner=R}),define(ne[202],ie([0,1,3,2]),function(K,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class L extends n.Disposable{constructor(E,I){super();this.channel=E,this.workspace=I}async getItems(){const E={workspace:this.workspace},I=await this.channel.call("getItems",E);return new Map(I)}updateItems(E){const I={workspace:this.workspace};return E.insert&&(I.insert=Array.from(E.insert.entries())),E.delete&&(I.delete=Array.from(E.delete.values())),this.channel.call("updateItems",I)}}class T extends L{constructor(E){super(E,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(E=>this.onDidChangeGlobalStorage(E)))}onDidChangeGlobalStorage(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this._onDidChangeItemsExternal.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}async close(){this.dispose()}}class A extends L{constructor(E,I){super(E,I);this.onDidChangeItemsExternal=D.Event.None}async close(){const E={workspace:this.workspace};return this.channel.call("close",E)}}class R extends n.Disposable{constructor(E,I){super();this.channel=E,this.workspace=I,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new T(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=R}),define(ne[203],ie([0,1,5,2,19,75,24,202]),function(K,e,D,n,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends A.AbstractStorageService{constructor(I,C,f){super();this.mainProcessService=C,this.environmentService=f,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new n.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(I)}createGlobalStorage(){const I=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),C=new T.Storage(I.globalStorage);return this._register(C.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),C}createWorkspaceStorage(I){const C=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),I);if(C.workspaceStorage){const f=new T.Storage(C.workspaceStorage);return this.workspaceStorageDisposable.value=f.onDidChangeStorage(p=>this.emitDidChangeValue(1,p)),this.workspaceStorageId=I?.id,f}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await D.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,L.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(A.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(I){const C=this.workspaceStorage,f=C?.items??new Map;C&&(await C.close(),C.dispose()),this.workspaceStorage=this.createWorkspaceStorage(I),await this.workspaceStorage.init();for(const[p,u]of f)this.workspaceStorage.set(p,u)}}e.NativeStorageService=b}),define(ne[204],ie([0,1,4,32,7,29]),function(K,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(E){if(D.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function R(E,I,C,f,p,u,m,d,g,w){const y=Object.create(null);y["common.machineId"]=m,y.sessionID=(0,T.generateUuid)()+Date.now(),y.commitHash=p,y.version=u,y["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),y["common.platform"]=(0,D.PlatformToString)(D.platform),y["common.nodePlatform"]=n.platform,y["common.nodeArch"]=f,y["common.product"]=w||"desktop";const S=b(d||[]);S&&(y["common.msftInternal"]=S);let l=0;const r=Date.now();Object.defineProperties(y,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),D.isLinuxSnap&&(y["common.snap"]="true");const c=A(C);c&&(y["common.platformDetail"]=c);try{const i=await E.readFile(L.URI.file(g));y["common.source"]=i.value.toString().slice(0,30)}catch{}return y}e.resolveCommonProperties=R;function b(E){const I=n.env.USERDNSDOMAIN;if(!I)return!1;const C=I.toLowerCase();return E.some(f=>C===f)}e.verifyMicrosoftInternalDomain=b}),define(ne[21],ie([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var L;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(L=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[205],ie([0,1,33,55,5,35,18,10,4,7,113,22,116,80,13,27,21]),function(K,e,D,n,L,T,A,R,b,E,I,C,f,p,u,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function g(r,c){const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}];let t;const o=D.homedir().toLowerCase();switch(process.platform){case"win32":t=[{tag:"gdrive",matcher:O=>/^[a-z]:\\(my drive|shared drives)\\/.test(O)||O.startsWith(o+"\\my drive\\")},{tag:"dropbox",matcher:O=>O.startsWith(o+"\\dropbox")},{tag:"onedrive",matcher:O=>O.startsWith(o+"\\onedrive")},{tag:"box",matcher:O=>O.startsWith(o+"\\box\\")},{tag:"nextcloud",matcher:O=>O.startsWith(o+"\\nextcloud\\")},{tag:"owncloud",matcher:O=>O.startsWith(o+"\\owncloud\\")}];break;case"darwin":t=[{tag:"gdrive",matcher:O=>O.startsWith("/volumes/googledrive/")||O.startsWith(o+"/my drive/")},{tag:"dropbox",matcher:O=>O.startsWith(o+"/dropbox")},{tag:"onedrive",matcher:O=>O.startsWith(o+"/onedrive")||O.startsWith(o+"/library/cloudstorage/onedrive")},{tag:"icloud",matcher:O=>O.startsWith(o+"/library/mobile documents/")},{tag:"box",matcher:O=>O.startsWith(o+"/box/")},{tag:"nextcloud",matcher:O=>O.startsWith(o+"/nextcloud/")},{tag:"owncloud",matcher:O=>O.startsWith(o+"/owncloud/")}];break}const s=new Map,a=new Map,h=2e4;function v(O,U,k,M){for(const V of t){const N=O.toLowerCase();V.matcher(N)&&a.set(V.tag,1)}const F=U.substring(O.length+1);return L.Promises.withAsyncBody(async V=>{let N;try{N=await C.Promises.readdir(U,{withFileTypes:!0})}catch{V();return}if(M.count>=h){M.count+=N.length,M.maxReached=!0,V();return}let G=N.length;if(G===0){V();return}let J=N;M.count+N.length>h&&(M.maxReached=!0,G=h-M.count,J=N.slice(0,G)),M.count+=N.length;for(const j of J)if(j.isDirectory()){if(k.includes(j.name)||await v(O,(0,R.join)(U,j.name),k,M),--G==0){V();return}}else{const q=j.name.lastIndexOf(".");if(q>=0){const X=j.name.substring(q+1);X&&s.set(X,(s.get(X)??0)+1)}for(const X of i)X.relativePathPattern?.test(F)!==!1&&X.filePattern.test(j.name)&&a.set(X.tag,(a.get(X.tag)??0)+1);if(--G==0){V();return}}})}const P={count:0,maxReached:!1};await v(r,r,c,P);const _=await S(r);return{configFiles:w(a),fileTypes:w(s),fileCount:P.count,maxFilesReached:P.maxReached,launchConfigFiles:_}}e.collectWorkspaceStats=g;function w(r){return[...n.Iterable.map(r.entries(),([c,i])=>({name:c,count:i}))].sort((c,i)=>i.count-c.count)}function y(){const r={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},c=D.cpus();return c&&c.length>0&&(r.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),r}e.getMachineInfo=y;async function S(r){try{const c=new Map,i=(0,R.join)(r,".vscode","launch.json"),t=await C.Promises.readFile(i),o=[],s=(0,T.parse)(t.toString(),o);if(o.length)return console.log(`Unable to parse ${i}`),[];if((0,T.getNodeType)(s)==="object"&&s.configurations)for(const a of s.configurations){const h=a.type;h&&(c.has(h)?c.set(h,c.get(h)+1):c.set(h,1))}return w(c)}catch{return[]}}e.collectLaunchConfigs=S;let l=class{constructor(c,i){this.telemetryService=c,this.productService=i}formatMachineInfo(c){const i=[];return i.push(`OS Version:       ${c.os}`),i.push(`CPUs:             ${c.cpus}`),i.push(`Memory (System):  ${c.memory}`),i.push(`VM:               ${c.vmHint}`),i.join(`
`)}formatEnvironment(c){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const t=D.cpus();return t&&t.length>0&&i.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),i.push(`Memory (System):  ${(D.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),b.isWindows||i.push(`Load (avg):       ${D.loadavg().map(o=>Math.round(o)).join(", ")}`),i.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${c.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(c.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(c,i){return Promise.all([(0,f.listProcesses)(c.mainPID),this.formatWorkspaceMetadata(c)]).then(async t=>{let[o,s]=t,a=this.formatProcessList(c,o);return i.forEach(h=>{if((0,p.isRemoteDiagnosticError)(h))a+=`
${h.errorMessage}`,s+=`
${h.errorMessage}`;else if(a+=`

Remote: ${h.hostName}`,h.processes&&(a+=`
${this.formatProcessList(c,h.processes)}`),h.workspaceMetadata){s+=`
|  Remote: ${h.hostName}`;for(const v of Object.keys(h.workspaceMetadata)){const P=h.workspaceMetadata[v];let _=`${P.fileCount} files`;P.maxFilesReached&&(_=`more than ${_}`),s+=`|    Folder (${v}): ${_}`,s+=this.formatWorkspaceStats(P)}}}),{processInfo:a,workspaceInfo:s}})}async getSystemInfo(c,i){const{memory:t,vmHint:o,os:s,cpus:a}=y(),h={os:s,memory:t,cpus:a,vmHint:o,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:i};return b.isWindows||(h.load=`${D.loadavg().map(v=>Math.round(v)).join(", ")}`),b.isLinux&&(h.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(h)}async getDiagnostics(c,i){const t=[];return(0,f.listProcesses)(c.mainPID).then(async o=>(t.push(""),t.push(this.formatEnvironment(c)),t.push(""),t.push(this.formatProcessList(c,o)),c.windows.some(s=>s.folderURIs&&s.folderURIs.length>0&&!s.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(c))),i.forEach(s=>{if((0,p.isRemoteDiagnosticError)(s))t.push(`
${s.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${s.hostName}`),t.push(this.formatMachineInfo(s.machineInfo)),s.processes&&t.push(this.formatProcessList(c,s.processes)),s.workspaceMetadata)for(const a of Object.keys(s.workspaceMetadata)){const h=s.workspaceMetadata[a];let v=`${h.fileCount} files`;h.maxFilesReached&&(v=`more than ${v}`),t.push(`Folder (${a}): ${v}`),t.push(this.formatWorkspaceStats(h))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(c){const i=[],t=60;let o=0;const s=(P,_)=>{const O=` ${P}(${_})`;o+O.length>t?(i.push(a),a="|                 ",o=a.length):o+=O.length,a+=O};let a="|      File types:";const h=10;let v=c.fileTypes.length>h?h:c.fileTypes.length;for(let P=0;P<v;P++){const _=c.fileTypes[P];s(_.name,_.count)}if(i.push(a),c.configFiles.length>=0&&(a="|      Conf files:",o=0,c.configFiles.forEach(P=>{s(P.name,P.count)}),i.push(a)),c.launchConfigFiles.length>0){let P="|      Launch Configs:";c.launchConfigFiles.forEach(_=>{P+=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`}),i.push(P)}return i.join(`
`)}expandGPUFeatures(c){const i=Math.max(...Object.keys(c).map(t=>t.length));return Object.keys(c).map(t=>`${t}:  ${" ".repeat(i-t.length)}  ${c[t]}`).join(`
                  `)}formatWorkspaceMetadata(c){const i=[],t=[];return c.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(i.push(`|  Window (${o.title})`),o.folderURIs.forEach(s=>{const a=E.URI.revive(s);if(a.scheme===A.Schemas.file){const h=a.fsPath;t.push(g(h,["node_modules",".git"]).then(v=>{let P=`${v.fileCount} files`;v.maxFilesReached&&(P=`more than ${P}`),i.push(`|    Folder (${(0,R.basename)(h)}): ${P}`),i.push(this.formatWorkspaceStats(v))}).catch(v=>{i.push(`|      Error: Unable to collect workspace stats for folder ${h} (${v.toString()})`)}))}else i.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(o=>i.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(c,i){const t=new Map;c.windows.forEach(s=>t.set(s.pid,s.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(c.mainPID,t,o,i,0),o.join(`
`)}formatProcessItem(c,i,t,o,s){const a=s===0;let h;a?h=o.pid===c?`${this.productService.applicationName} main`:"remote agent":(h=`${"  ".repeat(s)} ${o.name}`,o.name==="window"&&(h=`${h} (${i.get(o.pid)})`));const v=process.platform==="win32"?o.mem:D.totalmem()*(o.mem/100);t.push(`${o.load.toFixed(0).padStart(5," ")}	${(v/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${h}`),Array.isArray(o.children)&&o.children.forEach(P=>this.formatProcessItem(c,i,t,P,s+1))}async reportWorkspaceStats(c){for(const{uri:i}of c.folders){const t=E.URI.revive(i);if(t.scheme!==A.Schemas.file)continue;const o=t.fsPath;try{const s=await g(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),s.fileTypes.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})}),s.launchConfigFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})}),s.configFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};l=de([Y(0,d.ITelemetryService),Y(1,m.IProductService)],l),e.DiagnosticsService=l}),define(ne[206],ie([0,1,16,5,23,9,3,2,4,14,7,129,30,31,8,27,21]),function(K,e,D,n,L,T,A,R,b,E,I,C,f,p,u,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends R.Disposable{constructor(c,i,t,o){super();this.galleryService=c,this.telemetryService=i,this.logService=t,this.productService=o,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(s=>s.cancel()),this.uninstallingExtensions.forEach(s=>s.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(c){const i=await this.getTargetPlatform();return c.allTargetPlatforms.some(t=>(0,f.isTargetPlatformCompatible)(t,c.allTargetPlatforms,i))}async installFromGallery(c,i={}){try{if(!this.galleryService.isEnabled())throw new f.ExtensionManagementError(C.localize(0,null),f.ExtensionManagementErrorCode.Internal);const t=await this.checkAndGetCompatibleVersion(c,!i.installGivenVersion,!!i.installPreReleaseVersion);return await this.installExtension(t.manifest,t.extension,i)}catch(t){throw S(this.telemetryService,"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(c),void 0,t),this.logService.error("Failed to install extension.",c.identifier.id),this.logService.error(t),y(t)}}async uninstall(c,i={}){return this.logService.trace("ExtensionManagementService#uninstall",c.identifier.id),this.unininstallExtension(c,i)}async reinstallFromGallery(c){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",c.identifier.id),!this.galleryService.isEnabled())throw new Error(C.localize(1,null));const i=await this.findGalleryExtension(c);if(!i)throw new Error(C.localize(2,null));await this.createUninstallExtensionTask(c,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(i)}getExtensionsControlManifest(){const c=new Date().getTime();return(!this.extensionsControlManifest||c-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=c),this.extensionsControlManifest}registerParticipant(c){this.participants.push(c)}async installExtension(c,i,t){if(!I.URI.isUri(i)){let v=this.installingExtensions.get(new p.ExtensionIdentifierWithVersion(i.identifier,i.version).key());if(v)return this.logService.info("Extensions is already requested to install",i.identifier.id),v.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const o=[],s=[],a=this.createInstallExtensionTask(c,i,t);I.URI.isUri(i)||this.installingExtensions.set(new p.ExtensionIdentifierWithVersion(a.identifier,c.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:i}),this.logService.info("Installing extension:",a.identifier.id),o.push({task:a,manifest:c});let h=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const P=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,c,!!t.installOnlyNewlyAddedFromExtensionPack,!!t.installPreReleaseVersion);for(const{gallery:_,manifest:O}of P)if(h=h||!!O.extensionDependencies?.some(U=>(0,p.areSameExtensions)({id:U},a.identifier)),this.installingExtensions.has(new p.ExtensionIdentifierWithVersion(_.identifier,_.version).key()))this.logService.info("Extension is already requested to install",_.identifier.id);else{const U=this.createInstallExtensionTask(O,_,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new p.ExtensionIdentifierWithVersion(U.identifier,O.version).key(),U),this._onInstallExtension.fire({identifier:U.identifier,source:_}),this.logService.info("Installing extension:",U.identifier.id),o.push({task:U,manifest:O})}}catch(P){if(I.URI.isUri(a.source))(0,D.isNonEmptyArray)(c.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,P.message),(0,D.isNonEmptyArray)(c.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,P.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),P}const v=o.reduce((P,{task:_,manifest:O})=>(P.set(_.identifier.id.toLowerCase(),{task:_,manifest:O}),P),new Map);for(;v.size;){let P;const _=[...v.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(U=>v.has(U.toLowerCase())));_.length?P=v.size===1?_:_.filter(({task:O})=>!(O===a&&!h)):(this.logService.info("Found extensions with circular dependencies",_.map(({task:O})=>O.identifier.id)),P=[...v.values()]),await this.joinAllSettled(P.map(async({task:O})=>{const U=new Date().getTime(),k=(0,E.isUndefined)(t.operation)?O.operation:t.operation;try{const M=await O.run();if(await this.joinAllSettled(this.participants.map(F=>F.postInstall(M,O.source,t,L.CancellationToken.None))),!I.URI.isUri(O.source)&&(S(this.telemetryService,k===3?"extensionGallery:update":"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-U,void 0),b.isWeb&&k!==3))try{await this.galleryService.reportStatistic(M.manifest.publisher,M.manifest.name,M.manifest.version,"install")}catch{}s.push({local:M,identifier:O.identifier,operation:k,source:O.source})}catch(M){throw I.URI.isUri(O.source)||S(this.telemetryService,k===3?"extensionGallery:update":"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-U,M),this.logService.error("Error while installing the extension:",O.identifier.id),M}finally{v.delete(O.identifier.id.toLowerCase())}}))}return s.forEach(({identifier:P})=>this.logService.info("Extension installed successfully:",P.id)),this._onDidInstallExtensions.fire(s),s.filter(({identifier:P})=>(0,p.areSameExtensions)(P,a.identifier))[0].local}catch(v){if(o.forEach(({task:P})=>P.cancel()),s.length)try{const P=await Promise.allSettled(s.map(({local:_})=>this.createUninstallExtensionTask(_,{versionOnly:!0}).run()));for(let _=0;_<P.length;_++){const O=P[_],{identifier:U}=s[_];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",U.id):this.logService.warn("Rollback: Error while uninstalling extension",U.id,(0,T.getErrorMessage)(O.reason))}}catch(P){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(P),s.map(({identifier:_})=>_.id))}throw this._onDidInstallExtensions.fire(o.map(({task:P})=>({identifier:P.identifier,operation:2,source:P.source}))),v}finally{for(const{task:v,manifest:P}of o)if(!I.URI.isUri(v.source)){const _=new p.ExtensionIdentifierWithVersion(v.identifier,P.version).key();this.installingExtensions.delete(_)||this.logService.warn("Installation task is not found in the cache",_)}}}async joinAllSettled(c){const i=[],t=[],o=await Promise.allSettled(c);for(const s of o)s.status==="fulfilled"?i.push(s.value):t.push(s.reason);if(t.length)throw w(t);return i}async getAllDepsAndPackExtensionsToInstall(c,i,t,o){if(!this.galleryService.isEnabled())return[];let s=await this.getInstalled();const a=[c,...s.map(P=>P.identifier)],h=[],v=async(P,_)=>{const O=_.extensionDependencies||[],U=[...O];if(_.extensionPack){const k=t?s.find(M=>(0,p.areSameExtensions)(M.identifier,P)):void 0;for(const M of _.extensionPack)k&&k.manifest.extensionPack&&k.manifest.extensionPack.some(F=>(0,p.areSameExtensions)({id:F},{id:M}))||U.every(F=>!(0,p.areSameExtensions)({id:F},{id:M}))&&U.push(M)}if(U.length){const k=[...a,...h.map(F=>F.gallery.identifier)],M=U.filter(F=>k.every(V=>!(0,p.areSameExtensions)(V,{id:F})));if(M.length){const F=await this.galleryService.query({names:M,pageSize:U.length},L.CancellationToken.None);for(const V of F.firstPage){if(k.find(J=>(0,p.areSameExtensions)(J,V.identifier)))continue;const N=O.some(J=>(0,p.areSameExtensions)({id:J},V.identifier));let G;try{G=await this.checkAndGetCompatibleVersion(V,!0,o)}catch(J){if(J instanceof f.ExtensionManagementError&&J.code===f.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!N){this.logService.info("Skipping the packed extension as it cannot be installed",V.identifier.id);continue}else throw J}h.push({gallery:G.extension,manifest:G.manifest}),await v(G.extension.identifier,_)}}}};return await v(c,i),s=await this.getInstalled(),h.filter(P=>!s.some(_=>(0,p.areSameExtensions)(_.identifier,P.gallery.identifier)))}async checkAndGetCompatibleVersion(c,i,t){const o=await this.getExtensionsControlManifest();if((0,p.getMaliciousExtensionsSet)(o).has(c.identifier.id))throw new f.ExtensionManagementError(C.localize(3,null,c.identifier.id),f.ExtensionManagementErrorCode.Malicious);if(!!o.unsupportedPreReleaseExtensions&&!!o.unsupportedPreReleaseExtensions[c.identifier.id])throw new f.ExtensionManagementError(C.localize(4,null,c.identifier.id,o.unsupportedPreReleaseExtensions[c.identifier.id].displayName),f.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(c)){const h=await this.getTargetPlatform();throw new f.ExtensionManagementError(C.localize(5,null,c.identifier.id,this.productService.nameLong,(0,f.TargetPlatformToString)(h)),f.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const s=await this.getCompatibleVersion(c,i,t);if(s){if(t&&i&&c.hasPreReleaseVersion&&!s.properties.isPreReleaseVersion)throw new f.ExtensionManagementError(C.localize(6,null,c.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!t&&c.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([c.identifier],L.CancellationToken.None))[0]?new f.ExtensionManagementError(C.localize(7,null,c.identifier.id),f.ExtensionManagementErrorCode.ReleaseVersionNotFound):new f.ExtensionManagementError(C.localize(8,null,c.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",s.identifier.id);const a=await this.galleryService.getManifest(s,L.CancellationToken.None);if(a===null)throw new f.ExtensionManagementError(`Missing manifest for extension ${c.identifier.id}`,f.ExtensionManagementErrorCode.Invalid);if(a.version!==s.version)throw new f.ExtensionManagementError(`Cannot install '${c.identifier.id}' extension because of version mismatch in Marketplace`,f.ExtensionManagementErrorCode.Invalid);return{extension:s,manifest:a}}async getCompatibleVersion(c,i,t){const o=await this.getTargetPlatform();let s=null;return i&&c.hasPreReleaseVersion&&c.properties.isPreReleaseVersion!==t&&(s=(await this.galleryService.getExtensions([{...c.identifier,preRelease:t}],{targetPlatform:o,compatible:!0},L.CancellationToken.None))[0]||null),!s&&await this.galleryService.isExtensionCompatible(c,t,o)&&(s=c),!s&&i&&(s=await this.galleryService.getCompatibleExtension(c,t,o)),s}async unininstallExtension(c,i){const t=this.uninstallingExtensions.get(c.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",c.identifier.id),t.waitUntilTaskIsFinished();const o=(v,P)=>{const _=this.createUninstallExtensionTask(v,P);return this.uninstallingExtensions.set(_.extension.identifier.id.toLowerCase(),_),this.logService.info("Uninstalling extension:",v.identifier.id),this._onUninstallExtension.fire(v.identifier),_},s=(v,P)=>{P?this.logService.error("Failed to uninstall extension:",v.identifier.id,P.message):this.logService.info("Successfully uninstalled extension:",v.identifier.id),S(this.telemetryService,"extensionGallery:uninstall",(0,p.getLocalExtensionTelemetryData)(v),void 0,P),this._onDidUninstallExtension.fire({identifier:v.identifier,error:P?.code})},a=[],h=[];try{a.push(o(c,{}));const v=await this.getInstalled(1);if(i.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",c.identifier.id);else{const P=this.getAllPackExtensionsToUninstall(c,v);for(const _ of P)this.uninstallingExtensions.has(_.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",_.identifier.id):a.push(o(_,{}))}i.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",c.identifier.id):this.checkForDependents(a.map(P=>P.extension),v,c),await this.joinAllSettled(a.map(async P=>{try{if(await P.run(),await this.joinAllSettled(this.participants.map(_=>_.postUninstall(P.extension,i,L.CancellationToken.None))),P.extension.identifier.uuid)try{await this.galleryService.reportStatistic(P.extension.manifest.publisher,P.extension.manifest.name,P.extension.manifest.version,"uninstall")}catch{}s(P.extension)}catch(_){const O=_ instanceof f.ExtensionManagementError?_:new f.ExtensionManagementError((0,T.getErrorMessage)(_),f.ExtensionManagementErrorCode.Internal);throw s(P.extension,O),O}finally{h.push(P)}}))}catch(v){const P=v instanceof f.ExtensionManagementError?v:new f.ExtensionManagementError((0,T.getErrorMessage)(v),f.ExtensionManagementErrorCode.Internal);for(const _ of a){try{_.cancel()}catch{}h.includes(_)||s(_.extension,P)}throw P}finally{for(const v of a)this.uninstallingExtensions.delete(v.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",v.extension.identifier.id)}}checkForDependents(c,i,t){for(const o of c){const s=this.getDependents(o,i);if(s.length){const a=s.filter(h=>!c.some(v=>(0,p.areSameExtensions)(v.identifier,h.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(o,a,t))}}}getDependentsErrorMessage(c,i,t){return t===c?i.length===1?C.localize(9,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?C.localize(10,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):C.localize(11,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?C.localize(12,null,t.manifest.displayName||t.manifest.name,c.manifest.displayName||c.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?C.localize(13,null,t.manifest.displayName||t.manifest.name,c.manifest.displayName||c.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):C.localize(14,null,t.manifest.displayName||t.manifest.name,c.manifest.displayName||c.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(c,i,t=[]){if(t.indexOf(c)!==-1)return[];t.push(c);const o=c.manifest.extensionPack?c.manifest.extensionPack:[];if(o.length){const s=i.filter(h=>!h.isBuiltin&&o.some(v=>(0,p.areSameExtensions)({id:v},h.identifier))),a=[];for(const h of s)a.push(...this.getAllPackExtensionsToUninstall(h,i,t));return[...s,...a]}return[]}getDependents(c,i){return i.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(o=>(0,p.areSameExtensions)({id:o},c.identifier)))}async findGalleryExtension(c){if(c.identifier.uuid){const i=await this.findGalleryExtensionById(c.identifier.uuid);return i||this.findGalleryExtensionByName(c.identifier.id)}return this.findGalleryExtensionByName(c.identifier.id)}async findGalleryExtensionById(c){return(await this.galleryService.query({ids:[c],pageSize:1},L.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(c){return(await this.galleryService.query({names:[c],pageSize:1},L.CancellationToken.None)).firstPage[0]}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const c=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",c),c}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};g=de([Y(0,f.IExtensionGalleryService),Y(1,d.ITelemetryService),Y(2,u.ILogService),Y(3,m.IProductService)],g),e.AbstractExtensionManagementService=g;function w(r){const c=Array.isArray(r)?r:[r];return c.length===1?c[0]instanceof Error?c[0]:new Error(c[0]):c.reduce((i,t)=>new Error(`${i.message}${i.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}e.joinErrors=w;function y(r){if(r instanceof f.ExtensionManagementError)return r;const c=new f.ExtensionManagementError(r.message,f.ExtensionManagementErrorCode.Internal);return c.stack=r.stack,c}function S(r,c,i,t,o){const s=o?o instanceof f.ExtensionManagementError?o.code:f.ExtensionManagementErrorCode.Internal:void 0;r.publicLogError(c,{...i,success:!o,duration:t,errorcode:s})}e.reportTelemetry=S;class l{constructor(){this.barrier=new n.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(c=>this.doRun(c))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(c=>new Promise((i,t)=>{const o=c.onCancellationRequested(()=>{o.dispose(),t((0,T.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=l}),define(ne[207],ie([0,1,16,5,67,3,10,4,32,7,131,15,30,195,82,13,8,60,27,43,24,21]),function(K,e,D,n,L,T,A,R,b,E,I,C,f,p,u,m,d,g,w,y,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const r="extensionTips/promptedExecutableTips",c="extensionTips/lastPromptedMediumImpExeTime";let i=class extends p.ExtensionTipsService{constructor(o,s,a,h,v,P,_,O,U,k){super(_,O,U,k);this.environmentService=o,this.telemetryService=s,this.extensionManagementService=a,this.storageService=h,this.nativeHostService=v,this.extensionRecommendationNotificationService=P,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,L.forEach)(O.exeBasedExtensionTips,({key:M,value:F})=>{const V=[],N=[],G=[];(0,L.forEach)(F.recommendations,({key:J,value:j})=>{j.important?F.important?V.push({extensionId:J,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):N.push({extensionId:J,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):G.push({extensionId:J,extensionName:j.name,isExtensionPack:!!j.isExtensionPack})}),V.length&&this.highImportanceExecutableTips.set(M,{exeFriendlyName:F.friendlyName,windowsPath:F.windowsPath,recommendations:V}),N.length&&this.mediumImportanceExecutableTips.set(M,{exeFriendlyName:F.friendlyName,windowsPath:F.windowsPath,recommendations:N}),G.length&&this.allOtherExecutableTips.set(M,{exeFriendlyName:F.friendlyName,windowsPath:F.windowsPath,recommendations:G})}),(0,n.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),s=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...o,...s]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),s=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),a=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(o,a),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(s,a)}groupImportantTipsByExe(o,s){const a=new Map;o.forEach(O=>a.set(O.extensionId.toLowerCase(),O));const{installed:h,uninstalled:v}=this.groupByInstalled([...a.keys()],s);for(const O of h){const U=a.get(O);U&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:U.exeName})}for(const O of v){const U=a.get(O);U&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:U.exeName})}const P=this.getPromptedExecutableTips(),_=new Map;for(const O of v){const U=a.get(O);if(U&&(!P[U.exeName]||!P[U.exeName].includes(U.extensionId))){let k=_.get(U.exeName);k||(k=[],_.set(U.exeName,k)),k.push(U)}}return _}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[o,s]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(s).then(a=>{switch(a){case"reacted":this.addToRecommendedExecutables(s[0].exeName,s);break;case"ignored":this.highImportanceTipsByExe.delete(o);break;case"incompatibleWindow":{const h=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(h(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const h=this._register((0,n.disposableTimeout)(()=>{h.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const o=this.getLastPromptedMediumExeTime(),s=Date.now()-o,a=7*24*60*60*1e3;if(s<a){const P=this._register((0,n.disposableTimeout)(()=>{P.dispose(),this.promptMediumImportanceExeBasedTip()},a-s));return}const[h,v]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(v).then(P=>{switch(P){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(h),this.addToRecommendedExecutables(v[0].exeName,v);const _=this._register((0,n.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},a));break}case"ignored":this.mediumImportanceTipsByExe.delete(h),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const _=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(_(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const _=this._register((0,n.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}promptExeRecommendations(o){const s=o.map(({extensionId:h})=>h.toLowerCase()),a=(0,I.localize)(0,null,o[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(s,a,`@exe:"${o[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let o=this.storageService.getNumber(c,0);return o||(o=Date.now(),this.updateLastPromptedMediumExeTime(o)),o}updateLastPromptedMediumExeTime(o){this.storageService.store(c,o,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(r,0,"{}"))}addToRecommendedExecutables(o,s){const a=this.getPromptedExecutableTips();a[o]=s.map(({extensionId:h})=>h.toLowerCase()),this.storageService.store(r,JSON.stringify(a),0,0)}groupByInstalled(o,s){const a=[],h=[],v=s.reduce((P,_)=>(P.add(_.identifier.id.toLowerCase()),P),new Set);return o.forEach(P=>{v.has(P.toLowerCase())?a.push(P):h.push(P)}),{installed:a,uninstalled:h}}async getValidExecutableBasedExtensionTips(o){const s=[],a=new Map;for(const h of o.keys()){const v=o.get(h);if(!v||!(0,D.isNonEmptyArray)(v.recommendations))continue;const P=[];R.isWindows?v.windowsPath&&P.push(v.windowsPath.replace("%USERPROFILE%",b.env.USERPROFILE).replace("%ProgramFiles(x86)%",b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",b.env.ProgramFiles).replace("%APPDATA%",b.env.APPDATA).replace("%WINDIR%",b.env.WINDIR)):(P.push((0,A.join)("/usr/local/bin",h)),P.push((0,A.join)("/usr/bin",h)),P.push((0,A.join)(this.environmentService.userHome.fsPath,h)));for(const _ of P){let O=a.get(_);if(O===void 0&&(O=await this.fileService.exists(E.URI.file(_)),a.set(_,O)),O)for(const{extensionId:U,extensionName:k,isExtensionPack:M}of v.recommendations)s.push({extensionId:U,extensionName:k,isExtensionPack:M,exeName:h,exeFriendlyName:v.exeFriendlyName,windowsPath:v.windowsPath})}}return s}};i=de([Y(0,C.INativeEnvironmentService),Y(1,l.ITelemetryService),Y(2,f.IExtensionManagementService),Y(3,S.IStorageService),Y(4,g.INativeHostService),Y(5,u.IExtensionRecommendationNotificationService),Y(6,m.IFileService),Y(7,w.IProductService),Y(8,y.IRequestService),Y(9,d.ILogService)],i),e.ExtensionTipsService=i}),define(ne[93],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(T){this.appenders=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,{eventName:R,data:b}){return this.appenders.forEach(E=>E.log(R,b)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class n{constructor(T){this.channel=T}log(T,A){return this.channel.call("log",{eventName:T,data:A}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(ne[44],ie([0,1,28,14,20,21]),function(K,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class A{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(g,w){return Promise.resolve(void 0)}publicLog2(g,w){return this.publicLog(g,w)}publicLogError(g,w){return Promise.resolve(void 0)}publicLogError2(g,w){return this.publicLogError(g,w)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=A,e.NullTelemetryService=new A;class R{async publicLog(g,w,y){}async publicLogError(g,w,y){}}e.NullEndpointTelemetryService=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(d,g){return g.onDidChangeConfiguration(w=>{w.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(w.source),configurationKeys:u(w.sourceConfig)})})}e.configurationTelemetry=b;function E(d,g){return!(g.disableTelemetry||!d.enableTelemetry||g.extensionTestsLocationURI)}e.supportsTelemetry=E;function I(d){const g=d.getValue(T.TELEMETRY_SETTING_ID),w=d.getValue("telemetry.enableCrashReporter");if(d.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||w===!1)return 0;switch(g??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=I;function C(d){const g=Object.create(null),w=Object.create(null),y=Object.create(null);p(d,y);for(let S in y){S=S.length>150?S.substr(S.length-149):S;const l=y[S];typeof l=="number"?w[S]=l:typeof l=="boolean"?w[S]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${l.length}`),g[S]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(g[S]=l)}return{properties:g,measurements:w}}e.validateTelemetryData=C;function f(d){if(!d)return"none";let g="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(y=>{d.indexOf(`${y}+`)===0&&(g=y)}),g}e.cleanRemoteAuthority=f;function p(d,g,w=0,y){if(!!d)for(let S of Object.getOwnPropertyNames(d)){const l=d[S],r=y?y+S:S;Array.isArray(l)?g[r]=(0,D.safeStringify)(l):l instanceof Date?g[r]=l.toISOString():(0,n.isObject)(l)?w<2?p(l,g,w+1,r+"."):g[r]=(0,D.safeStringify)(l):g[r]=l}}function u(d){if(!d)return[];const g=[];return m(g,"",d),g}function m(d,g,w){w&&typeof w=="object"&&!Array.isArray(w)?Object.keys(w).forEach(y=>m(d,g?`${g}.${y}`:y,w[y])):d.push(g)}}),define(ne[208],ie([0,1,44,149]),function(K,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class L{constructor(){}setSharedProperty(b,E){}postEvent(b,E){}}class T{constructor(b,E,I,C,f){this.getMachineId=b,this.configurationService=E,this.productService=I,this.telemetry=C,this.keyValueStorage=f,this.networkInitialized=!1,I.tasConfig&&this.experimentsEnabled&&(0,D.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const p=this.configurationService.getValue("experiments.overrideDelay"),u=typeof p=="number"?p:0;this.overrideInitDelay=new Promise(m=>setTimeout(m,u))}get experimentsEnabled(){return!0}async getTreatment(b){await this.overrideInitDelay;const E=this.configurationService.getValue("experiments.override."+b);if(E!==void 0)return E;if(!this.tasClient||!this.experimentsEnabled)return;let I;const C=await this.tasClient;return this.networkInitialized?I=C.getTreatmentVariable("vscode",b):I=await C.getTreatmentVariableAsync("vscode",b,!0),I=C.getTreatmentVariable("vscode",b),I}async setupTASClient(){const b=this.productService.quality==="stable"?n.TargetPopulation.Public:n.TargetPopulation.Insiders,E=await this.getMachineId(),I=new n.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,E,b),C=this.productService.tasConfig,f=new(await new Promise((p,u)=>{K(["tas-client-umd"],p,u)})).ExperimentationService({filterProviders:[I],telemetry:this.telemetry,storageKey:n.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:C.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:C.assignmentContextTelemetryPropertyName,telemetryEventName:C.telemetryEventName,endpoint:C.endpoint,refetchInterval:n.ASSIGNMENT_REFETCH_INTERVAL});return await f.initializePromise,f.initialFetch.then(()=>this.networkInitialized=!0),f}}e.BaseAssignmentService=T;class A extends T{constructor(b,E,I){super(()=>Promise.resolve(b),E,I,new L)}}e.AssignmentService=A}),define(ne[209],ie([0,1,16,23,9,28,4,32,14,7,20,15,30,31,78,13,8,27,43,46,24,21,44]),function(K,e,D,n,L,T,A,R,b,E,I,C,f,p,u,m,d,g,w,y,S,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const c=A.isWeb?"web":(0,f.getTargetPlatform)(A.platform,R.arch);var i;(function(z){z[z.None=0]="None",z[z.IncludeVersions=1]="IncludeVersions",z[z.IncludeFiles=2]="IncludeFiles",z[z.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",z[z.IncludeSharedAccounts=8]="IncludeSharedAccounts",z[z.IncludeVersionProperties=16]="IncludeVersionProperties",z[z.ExcludeNonValidated=32]="ExcludeNonValidated",z[z.IncludeInstallationTargets=64]="IncludeInstallationTargets",z[z.IncludeAssetUri=128]="IncludeAssetUri",z[z.IncludeStatistics=256]="IncludeStatistics",z[z.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",z[z.Unpublished=4096]="Unpublished",z[z.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function t(...z){return String(z.reduce((B,te)=>B|te,0))}var o;(function(z){z[z.Tag=1]="Tag",z[z.ExtensionId=4]="ExtensionId",z[z.Category=5]="Category",z[z.ExtensionName=7]="ExtensionName",z[z.Target=8]="Target",z[z.Featured=9]="Featured",z[z.SearchText=10]="SearchText",z[z.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},v={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class P{constructor(B=v){this.state=B}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(B,te=this.state.pageSize){return new P({...this.state,pageNumber:B,pageSize:te})}withFilter(B,...te){const se=[...this.state.criteria,...te.length?te.map(ce=>({filterType:B,value:ce})):[{filterType:B}]];return new P({...this.state,criteria:se})}withSortBy(B){return new P({...this.state,sortBy:B})}withSortOrder(B){return new P({...this.state,sortOrder:B})}withFlags(...B){return new P({...this.state,flags:B.reduce((te,se)=>te|se,0)})}withAssetTypes(...B){return new P({...this.state,assetTypes:B})}get raw(){const{criteria:B,pageNumber:te,pageSize:se,sortBy:ce,sortOrder:he,flags:ve,assetTypes:pe}=this.state;return{filters:[{criteria:B,pageNumber:te,pageSize:se,sortBy:ce,sortOrder:he}],assetTypes:pe,flags:ve}}get searchText(){const B=this.state.criteria.filter(te=>te.filterType===o.SearchText)[0];return B&&B.value?B.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(B=>String(B.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function _(z,B){const te=(z||[]).filter(se=>se.statisticName===B)[0];return te?te.value:0}function O(z){const B="Microsoft.VisualStudio.Code.Translation.";return z.files.filter(se=>se.assetType.indexOf(B)===0).reduce((se,ce)=>{const he=F(z,ce.assetType);return he&&se.push([ce.assetType.substring(B.length),he]),se},[])}function U(z){if(z.properties){const B=z.properties.filter(ce=>ce.key===s.Repository),te=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),se=B.filter(ce=>te.test(ce.value))[0];return se?{uri:se.value,fallbackUri:se.value}:null}return F(z,s.Repository)}function k(z){return{uri:`${z.fallbackAssetUri}/${s.VSIX}?redirect=true${z.targetPlatform?`&targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${s.VSIX}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}}function M(z){const B=F(z,s.Icon);if(B)return B;const te=f.DefaultIconPath;return{uri:te,fallbackUri:te}}function F(z,B){return z.files.filter(se=>se.assetType===B)[0]?{uri:`${z.assetUri}/${B}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${B}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}:null}function V(z,B){const te=z.properties?z.properties.filter(ce=>ce.key===B):[],se=te.length>0&&te[0].value;return se?se.split(",").map(ce=>(0,p.adoptToGalleryExtensionId)(ce)):[]}function N(z){const B=z.properties?z.properties.filter(te=>te.key===a.Engine):[];return B.length>0&&B[0].value||""}function G(z){const B=z.properties?z.properties.filter(te=>te.key===a.PreRelease):[];return B.length>0&&B[0].value==="true"}function J(z){const B=z.properties?z.properties.filter(se=>se.key===a.LocalizedLanguages):[],te=B.length>0&&B[0].value||"";return te?te.split(","):[]}function j(z){return z.indexOf("preview")!==-1}function q(z){return z.targetPlatform?(0,f.toTargetPlatform)(z.targetPlatform):"undefined"}function X(z){const B=(0,D.distinct)(z.versions.map(q)),te=!!z.tags?.includes(f.WEB_EXTENSION_TAG),se=B.indexOf("web");return te?se===-1&&B.push("web"):se!==-1&&B.splice(se,1),B}function H(z,B){const te=(0,f.getFallbackTargetPlarforms)(B);for(let se=0;se<z.length;se++){const ce=z[se];if(ce.version===z[se-1]?.version){let he=se;const ve=q(ce);if(ve===B)for(;he>0&&z[he-1].version===ce.version;)he--;else if(te.includes(ve))for(;he>0&&z[he-1].version===ce.version&&q(z[he-1])!==B;)he--;he!==se&&(z.splice(se,1),z.splice(he,0,ce))}}return z}e.sortExtensionVersions=H;function Z(z,B,te){const se=z.versions[0],ce={manifest:F(B,s.Manifest),readme:F(B,s.Details),changelog:F(B,s.Changelog),license:F(B,s.License),repository:U(B),download:k(B),icon:M(B),coreTranslations:O(B)};return{identifier:{id:(0,p.getGalleryExtensionId)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},name:z.extensionName,version:B.version,displayName:z.displayName,publisherId:z.publisher.publisherId,publisher:z.publisher.publisherName,publisherDisplayName:z.publisher.displayName,publisherDomain:z.publisher.domain?{link:z.publisher.domain,verified:!!z.publisher.isDomainVerified}:void 0,description:z.shortDescription||"",installCount:_(z.statistics,"install"),rating:_(z.statistics,"averagerating"),ratingCount:_(z.statistics,"ratingcount"),categories:z.categories||[],tags:z.tags||[],releaseDate:Date.parse(z.releaseDate),lastUpdated:Date.parse(z.lastUpdated),allTargetPlatforms:te,assets:ce,properties:{dependencies:V(B,a.Dependency),extensionPack:V(B,a.ExtensionPack),engine:N(B),localizedLanguages:J(B),targetPlatform:q(B),isPreReleaseVersion:G(B)},hasPreReleaseVersion:G(se),hasReleaseVersion:!0,preview:j(z.flags)}}let ee=class{constructor(B,te,se,ce,he,ve,pe,Ie){this.requestService=te,this.logService=se,this.environmentService=ce,this.telemetryService=he,this.fileService=ve,this.productService=pe,this.configurationService=Ie;const Ee=pe.extensionsGallery;this.extensionsGalleryUrl=Ee&&Ee.serviceUrl,this.extensionsControlUrl=Ee&&Ee.controlUrl,this.commonHeadersPromise=x(pe.version,pe,this.environmentService,this.configurationService,this.fileService,B)}api(B=""){return`${this.extensionsGalleryUrl}${B}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(B,te,se){const ce=n.CancellationToken.isCancellationToken(te)?{targetPlatform:c}:te,he=n.CancellationToken.isCancellationToken(te)?te:se,ve=[],pe=[],Ie=[],Ee=[];for(const Re of B)Re.uuid?pe.push(Re.uuid):ve.push(Re.id),Ie.push({...Re,preRelease:!!Re.preRelease}),Re.version&&Ee.push({...Re,version:Re.version});if(!pe.length&&!ve.length)return[];let ye=new P().withPage(1,B.length);pe.length&&(ye=ye.withFilter(o.ExtensionId,...pe)),ve.length&&(ye=ye.withFilter(o.ExtensionName,...ve));const{extensions:be}=await this.queryGalleryExtensions(ye,{targetPlatform:ce.targetPlatform,preRelease:Ie,versions:Ee,compatible:!!ce.compatible},he);return be}async getCompatibleExtension(B,te,se){if((0,f.isNotWebExtensionInWebTargetPlatform)(B.allTargetPlatforms,se))return null;if(await this.isExtensionCompatible(B,te,se))return B;const ce=new P().withFlags(i.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,B.identifier.uuid),{extensions:he}=await this.queryGalleryExtensions(ce,{targetPlatform:se,compatible:!0,preRelease:te},n.CancellationToken.None);return he[0]||null}async isExtensionCompatible(B,te,se){if(!(0,f.isTargetPlatformCompatible)(B.properties.targetPlatform,B.allTargetPlatforms,se)||!te&&B.properties.isPreReleaseVersion)return!1;let ce=B.properties.engine;if(!ce){const he=await this.getManifest(B,n.CancellationToken.None);if(!he)throw new Error("Manifest was not found");ce=he.engines.vscode}return(0,u.isEngineValid)(ce,this.productService.version,this.productService.date)}async isValidVersion(B,te,se,ce,he){if(!(0,f.isTargetPlatformCompatible)(q(B),ce,he)||!te&&G(B))return!1;if(se){const ve=await this.getEngine(B);if(!(0,u.isEngineValid)(ve,this.productService.version,this.productService.date))return!1}return!0}async query(B,te){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let se=B.text||"";const ce=(0,T.getOrDefault)(B,ye=>ye.pageSize,50);let he=new P().withPage(1,ce);se?(se=se.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ye,be,Re)=>(he=he.withFilter(o.Category,Re||be),"")),se=se.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ye,be,Re)=>(he=he.withFilter(o.Tag,Re||be),"")),se=se.replace(/\bfeatured(\s+|\b|$)/g,()=>(he=he.withFilter(o.Featured),"")),se=se.trim(),se&&(se=se.length<200?se:se.substring(0,200),he=he.withFilter(o.SearchText,se)),he=he.withSortBy(0)):B.ids?he=he.withFilter(o.ExtensionId,...B.ids):B.names?he=he.withFilter(o.ExtensionName,...B.names):he=he.withSortBy(4),typeof B.sortBy=="number"&&(he=he.withSortBy(B.sortBy)),typeof B.sortOrder=="number"&&(he=he.withSortOrder(B.sortOrder));const ve=async(ye,be)=>{const{extensions:Re,total:Ne}=await this.queryGalleryExtensions(ye,{targetPlatform:c,compatible:!1,preRelease:!!B.includePreRelease},be);return Re.forEach((Ue,qe)=>Ue.telemetryData={index:(ye.pageNumber-1)*ye.pageSize+qe,querySource:B.source}),{extensions:Re,total:Ne}},{extensions:pe,total:Ie}=await ve(he,te),Ee=async(ye,be)=>{if(be.isCancellationRequested)throw new L.CancellationError;const{extensions:Re}=await ve(he.withPage(ye+1),be);return Re};return{firstPage:pe,total:Ie,pageSize:he.pageSize,getPage:Ee}}async queryGalleryExtensions(B,te,se){const ce=B.flags;!!(B.flags&i.IncludeLatestVersionOnly)&&!!(B.flags&i.IncludeVersions)&&(B=B.withFlags(B.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(B.flags&i.IncludeLatestVersionOnly)&&!(B.flags&i.IncludeVersions)&&(B=B.withFlags(B.flags,i.IncludeLatestVersionOnly)),te.versions?.length&&(B=B.withFlags(B.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),B=B.withFlags(B.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:he,total:ve}=await this.queryRawGalleryExtensions(B,se);if(!(B.flags&i.IncludeLatestVersionOnly)){const ye=[];for(const be of he){const Re=await this.toGalleryExtensionWithCriteria(be,te,!0);Re&&ye.push(Re)}return{extensions:ye,total:ve}}const Ie=[],Ee=new Map;for(let ye=0;ye<he.length;ye++){const be=he[ye],Re={id:(0,p.getGalleryExtensionId)(be.publisher.publisherName,be.extensionName),uuid:be.extensionId},Ne=(0,b.isBoolean)(te.preRelease)?te.preRelease:!!te.preRelease.find(qe=>(0,p.areSameExtensions)(qe,Re))?.preRelease;let Ue=await this.toGalleryExtensionWithCriteria(be,te,!1);!Ue||Ue.properties.isPreReleaseVersion&&(!Ne||!Ue.hasReleaseVersion)||!Ue.properties.isPreReleaseVersion&&Ue.properties.targetPlatform!==te.targetPlatform&&Ue.hasPreReleaseVersion?Ee.set(be.extensionId,ye):Ie.push([ye,Ue])}if(Ee.size){const ye=new Date().getTime(),be=new P().withFlags(ce&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,Ee.size).withFilter(o.ExtensionId,...Ee.keys()),{extensions:Re}=await this.queryGalleryExtensions(be,te,se);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ye,count:Ee.size});for(const Ne of Re){const Ue=Ee.get(Ne.identifier.uuid);Ie.push([Ue,Ne])}}return{extensions:Ie.sort((ye,be)=>ye[0]-be[0]).map(([,ye])=>ye),total:ve}}async toGalleryExtensionWithCriteria(B,te,se){const ce={id:(0,p.getGalleryExtensionId)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},he=te.versions?.find(Ee=>(0,p.areSameExtensions)(Ee,ce))?.version,ve=(0,b.isBoolean)(te.preRelease)?te.preRelease:!!te.preRelease.find(Ee=>(0,p.areSameExtensions)(Ee,ce))?.preRelease,pe=X(B),Ie=H(B.versions,te.targetPlatform);if(te.compatible&&se&&(0,f.isNotWebExtensionInWebTargetPlatform)(pe,te.targetPlatform))return null;for(let Ee=0;Ee<Ie.length;Ee++){const ye=Ie[Ee];if(!(he&&ye.version!==he)){if(await this.isValidVersion(ye,ve,te.compatible,pe,te.targetPlatform))return Z(B,ye,pe);if(he&&ye.version===he)return null}}return he||te.compatible?null:Z(B,B.versions[0],pe)}async queryRawGalleryExtensions(B,te){if(!this.isEnabled())throw new Error("No extension gallery service configured.");B=B.withFlags(B.flags,i.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,t(i.Unpublished));const se=await this.commonHeadersPromise,ce=JSON.stringify(B.raw),he={...se,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ce.length)},ve=new Date().getTime();let pe,Ie,Ee=0;try{if(pe=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ce,headers:he},te),pe.res.statusCode&&pe.res.statusCode>=400&&pe.res.statusCode<500)return{galleryExtensions:[],total:Ee};const ye=await(0,w.asJson)(pe);if(ye){const be=ye.results[0],Re=be.extensions,Ne=be.resultMetadata&&be.resultMetadata.filter(Ue=>Ue.metadataType==="ResultCount")[0];return Ee=Ne&&Ne.metadataItems.filter(Ue=>Ue.name==="TotalCount")[0].count||0,{galleryExtensions:Re,total:Ee}}return{galleryExtensions:[],total:Ee}}catch(ye){throw Ie=ye,ye}finally{this.telemetryService.publicLog2("galleryService:query",{...B.telemetryData,requestBodySize:String(ce.length),duration:new Date().getTime()-ve,success:!!pe&&(0,w.isSuccess)(pe),responseBodySize:pe?.res.headers["Content-Length"],statusCode:pe?String(pe.res.statusCode):void 0,errorCode:Ie?(0,L.isCancellationError)(Ie)?"canceled":(0,L.getErrorMessage)(Ie).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ee)})}}async reportStatistic(B,te,se,ce){if(!this.isEnabled())return;const he=A.isWeb?this.api(`/itemName/${B}.${te}/version/${se}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${B}/extensions/${te}/${se}/stats?statType=${ce}`),ve=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ie={...await this.commonHeadersPromise,Accept:ve};try{await this.requestService.request({type:"POST",url:he,headers:Ie},n.CancellationToken.None)}catch{}}async download(B,te,se){this.logService.trace("ExtensionGalleryService#download",B.identifier.id);const ce=(0,p.getGalleryExtensionTelemetryData)(B),he=new Date().getTime(),ve=ye=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:ye}),pe=se===2?"install":se===3?"update":"",Ie=pe?{uri:`${B.assets.download.uri}${E.URI.parse(B.assets.download.uri).query?"&":"?"}${pe}=true`,fallbackUri:`${B.assets.download.fallbackUri}${E.URI.parse(B.assets.download.fallbackUri).query?"&":"?"}${pe}=true`}:B.assets.download,Ee=await this.getAsset(Ie);await this.fileService.writeFile(te,Ee.stream),ve(new Date().getTime()-he)}async getReadme(B,te){if(B.assets.readme){const se=await this.getAsset(B.assets.readme,{},te);return await(0,w.asText)(se)||""}return""}async getManifest(B,te){if(B.assets.manifest){const se=await this.getAsset(B.assets.manifest,{},te),ce=await(0,w.asText)(se);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(B,te){const se=F(B,s.Manifest);if(!se)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},he=await this.getAsset(se,{headers:ce});return await(0,w.asJson)(he)}async getCoreTranslation(B,te){const se=B.assets.coreTranslations.filter(ce=>ce[0]===te.toUpperCase())[0];if(se){const ce=await this.getAsset(se[1]),he=await(0,w.asText)(ce);return he?JSON.parse(he):null}return null}async getChangelog(B,te){if(B.assets.changelog){const se=await this.getAsset(B.assets.changelog,{},te);return await(0,w.asText)(se)||""}return""}async getAllCompatibleVersions(B,te,se){let ce=new P().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);B.identifier.uuid?ce=ce.withFilter(o.ExtensionId,B.identifier.uuid):ce=ce.withFilter(o.ExtensionName,B.identifier.id);const{galleryExtensions:he}=await this.queryRawGalleryExtensions(ce,n.CancellationToken.None);if(!he.length)return[];const ve=X(he[0]);if((0,f.isNotWebExtensionInWebTargetPlatform)(ve,se))return[];const pe=[],Ie=new Set;return await Promise.all(he[0].versions.map(async Ee=>{try{if(Ie.has(Ee.version))return;Ie.add(Ee.version),await this.isValidVersion(Ee,te,!0,ve,se)&&pe.push({version:Ee.version,date:Ee.lastUpdated,isPreReleaseVersion:G(Ee)})}catch{}})),pe}async getAsset(B,te={},se=n.CancellationToken.None){const ce=await this.commonHeadersPromise,he={type:"GET"},ve={...ce,...te.headers||{}};te={...te,...he,headers:ve};const pe=B.uri,Ie=B.fallbackUri,Ee={...te,url:pe};try{const ye=await this.requestService.request(Ee,se);if(ye.res.statusCode===200)return ye;const be=await(0,w.asText)(ye);throw new Error(`Expected 200, got back ${ye.res.statusCode} instead.

${be}`)}catch(ye){if((0,L.isCancellationError)(ye))throw ye;const be=(0,L.getErrorMessage)(ye);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:pe,message:be});const Re={...te,url:Ie};return this.requestService.request(Re,se)}}async getEngine(B){let te=N(B);if(!te){const se=await this.getManifestFromRawExtensionVersion(B,n.CancellationToken.None);if(!se)throw new Error("Manifest was not found");te=se.engines.vscode}return te}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const B=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(B.res.statusCode!==200)throw new Error("Could not get extensions report.");const te=await(0,w.asJson)(B),se=[],ce={};if(te){for(const he of te.malicious)se.push({id:he});if(te.unsupported)for(const he of Object.keys(te.unsupported)){const ve=te.unsupported[he];(0,b.isBoolean)(ve)||(ce[he.toLowerCase()]=ve.preReleaseExtension)}if(te.migrateToPreRelease)for(const[he,ve]of Object.entries(te.migrateToPreRelease))(!ve.engine||(0,u.isEngineValid)(ve.engine,this.productService.version,this.productService.date))&&(ce[he.toLowerCase()]=ve)}return{malicious:se,unsupportedPreReleaseExtensions:ce}}};ee=de([Y(1,w.IRequestService),Y(2,d.ILogService),Y(3,C.IEnvironmentService),Y(4,l.ITelemetryService),Y(5,m.IFileService),Y(6,g.IProductService),Y(7,I.IConfigurationService)],ee);let W=class extends ee{constructor(B,te,se,ce,he,ve,pe,Ie){super(B,te,se,ce,he,ve,pe,Ie)}};W=de([Y(0,S.IStorageService),Y(1,w.IRequestService),Y(2,d.ILogService),Y(3,C.IEnvironmentService),Y(4,l.ITelemetryService),Y(5,m.IFileService),Y(6,g.IProductService),Y(7,I.IConfigurationService)],W),e.ExtensionGalleryService=W;let $=class extends ee{constructor(B,te,se,ce,he,ve,pe){super(void 0,B,te,se,ce,he,ve,pe)}};$=de([Y(0,w.IRequestService),Y(1,d.ILogService),Y(2,C.IEnvironmentService),Y(3,l.ITelemetryService),Y(4,m.IFileService),Y(5,g.IProductService),Y(6,I.IConfigurationService)],$),e.ExtensionGalleryServiceWithNoStorageService=$;async function x(z,B,te,se,ce,he){const ve={"X-Market-Client-Id":`VSCode ${z}`,"User-Agent":`VSCode ${z} (${B.nameShort})`},pe=await(0,y.getServiceMachineId)(te,ce,he);return(0,r.supportsTelemetry)(B,te)&&(0,r.getTelemetryLevel)(se)===3&&(ve["X-Market-User-Id"]=pe),ve}e.resolveMarketplaceHeaders=x}),define(ne[94],ie([0,1,2,15,8,44]),function(K,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends D.Disposable{constructor(b,E,I=""){super();this.prefix=I;const C=b.getLogger(E.telemetryLogResource);C?this.logger=this._register(C):(this.logger=this._register(b.createLogger(E.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(b,E){this.logger.trace(`${this.prefix}telemetry/${b}`,(0,T.validateTelemetryData)(E))}};A=de([Y(0,L.ILoggerService),Y(1,n.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(ne[95],ie([0,1,2,28,4,26,141,20,42,87,38,21,44]),function(K,e,D,n,L,T,A,R,b,E,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(d,g){this._configurationService=g,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=d.appenders,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(w),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(w=>{const y=/^[a-f0-9]+$/i.test(w["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!y})})}setExperimentProperty(d,g){this._experimentProperties[d]=g}_updateTelemetryLevel(){this._telemetryLevel=(0,f.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const d=await this._commonProperties;let g=d.sessionID,w=d["common.machineId"],y=d["common.firstSessionDate"],S=d["common.msftInternal"];return{sessionId:g,machineId:w,firstSessionDate:y,msftInternal:S}}dispose(){this._disposables.dispose()}_log(d,g,w,y){return this.telemetryLevel<g?Promise.resolve(void 0):this._commonProperties.then(S=>{w=(0,n.mixin)(w,S),w=(0,n.mixin)(w,this._experimentProperties),w=(0,n.cloneAndChange)(w,l=>{if(typeof l=="string")return this._cleanupInfo(l,y)}),this._appenders.forEach(l=>l.log(d,w))},S=>{console.error(S)})}publicLog(d,g,w){return this._log(d,3,g,w)}publicLog2(d,g,w){return this.publicLog(d,g,w)}publicLogError(d,g){return this.sendErrorTelemetry?this._log(d,2,g,!0):Promise.resolve(void 0)}publicLogError2(d,g){return this.publicLogError(d,g)}_anonymizeFilePaths(d){let g=d;const w=[];for(let r of this._cleanupPatterns)for(;;){const c=r.exec(d);if(!c)break;w.push([c.index,r.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(g="";;){const r=S.exec(d);if(!r)break;!y.test(r[0])&&w.every(([c,i])=>r.index<c||r.index>=i)&&(g+=d.substring(l,r.index)+"<REDACTED: user-file-path>",l=S.lastIndex)}return l<d.length&&(g+=d.substr(l)),g}_removePropertiesWithPossibleUserInfo(d){if(!d)return d;const g=d.toLowerCase(),w=/@[a-zA-Z0-9-.]+/,y=/(key|token|sig|signature|password|passwd|pwd)[="':\s]/,S=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return y.test(g)?"<REDACTED: secret>":w.test(g)?"<REDACTED: email>":S.test(g)?"<REDACTED: token>":d}_cleanupInfo(d,g){let w=d;g&&(w=this._anonymizeFilePaths(w));for(let y of this._cleanupPatterns)w=w.replace(y,"");return w=this._removePropertiesWithPossibleUserInfo(w),w}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=de([Y(1,R.IConfigurationService)],p),e.TelemetryService=p;function u(){const m=(0,A.localize)(0,null,E.default.nameLong),d=E.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=L.isWeb?"":(0,A.localize)(3,null),w=(0,A.localize)(4,null),y=(0,A.localize)(5,null),S=(0,A.localize)(6,null),l=(0,A.localize)(7,null),r=`
|       | ${w} | ${y} | ${S} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,c=(0,A.localize)(8,null);return`
${m} ${d} ${g}

&nbsp;

${l}
${r}

&nbsp;

${c}
`}I.Registry.as(b.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(9,null),properties:{[C.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:u(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.Registry.as(b.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[C.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,A.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,A.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${C.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[210],ie([0,1,9,28,44]),function(K,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function T(R,b){const E=await new Promise((C,f)=>{K(["applicationinsights"],C,f)});let I;return E.defaultClient?(I=new E.TelemetryClient(R),I.channel.setUseDiskRetryCaching(!0)):(E.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),I=E.defaultClient),R.indexOf("AIF-")===0&&(I.config.endpointUrl=b?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),I}class A{constructor(b,E,I,C,f){this._eventPrefix=b,this._defaultData=E,this.testCollector=C,this.mirrored=f,this._defaultData||(this._defaultData=Object.create(null)),typeof I=="function"?this._aiClient=I():this._aiClient=I,this._asyncAIClient=null}_withAIClient(b){if(!!this._aiClient){if(typeof this._aiClient!="string"){b(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=T(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(E=>{b(E)},E=>{(0,D.onUnexpectedError)(E),console.error(E)})}}log(b,E){if(!!this._aiClient){E=(0,n.mixin)(E,this._defaultData),E=(0,L.validateTelemetryData)(E),this.testCollector&&(E.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++");try{this._withAIClient(I=>I.trackEvent({name:this._eventPrefix+"/"+b,properties:E.properties,measurements:E.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(b=>{this._withAIClient(E=>{try{E.flush({callback:()=>{this._aiClient=void 0,b(void 0)}})}catch{}})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(ne[211],ie([0,1,18,58,20,15,8,21,93,94,95]),function(K,e,D,n,L,T,A,R,b,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let C=class{constructor(p,u,m,d){this.configurationService=p,this.telemetryService=u,this.loggerService=m,this.environmentService=d,this.customTelemetryServices=new Map}async getCustomTelemetryService(p){if(!this.customTelemetryServices.has(p.id)){const{machineId:u,sessionId:m}=await this.telemetryService.getTelemetryInfo(),d=Object.create(null);d["common.vscodemachineid"]=u,d["common.vscodesessionid"]=m;const g=[p.id,JSON.stringify(d),p.aiKey],y=new n.Client(D.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:g,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),S=[new b.TelemetryAppenderClient(y),new E.TelemetryLogAppender(this.loggerService,this.environmentService,`[${p.id}] `)];this.customTelemetryServices.set(p.id,new I.TelemetryService({appenders:S,sendErrorTelemetry:p.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(p.id)}async publicLog(p,u,m){await(await this.getCustomTelemetryService(p)).publicLog(u,m)}async publicLogError(p,u,m){await(await this.getCustomTelemetryService(p)).publicLogError(u,m)}};C=de([Y(0,L.IConfigurationService),Y(1,R.ITelemetryService),Y(2,A.ILoggerService),Y(3,T.IEnvironmentService)],C),e.CustomEndpointTelemetryService=C}),define(ne[212],ie([0,1,5,23,3,2,8]),function(K,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends T.Disposable{constructor(E,I){super();this._logService=I,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new L.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=E===void 0?15e3:E}createRequest(E){return new Promise((I,C)=>{const f=++this._lastRequestId;this._pendingRequests.set(f,I),this._onCreateRequest.fire({requestId:f,...E});const p=new n.CancellationTokenSource;(0,D.timeout)(this._timeout,p.token).then(()=>C(`Request ${f} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(f,[(0,T.toDisposable)(()=>p.cancel())])})}acceptReply(E,I){const C=this._pendingRequests.get(E);C?(this._pendingRequests.delete(E),(0,T.dispose)(this._pendingRequestDisposables.get(E)||[]),this._pendingRequestDisposables.delete(E),C(I)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${E}`)}};R=de([Y(1,A.ILogService)],R),e.RequestStore=R}),define(ne[96],ie([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var n;(function(d){d.Shell="terminal.integrated.shell.",d.ShellArgs="terminal.integrated.shellArgs.",d.DefaultProfile="terminal.integrated.defaultProfile.",d.Profiles="terminal.integrated.profiles."})(n=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var L;(function(d){d.ShellLinux="terminal.integrated.shell.linux",d.ShellMacOs="terminal.integrated.shell.osx",d.ShellWindows="terminal.integrated.shell.windows",d.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",d.AutomationShellLinux="terminal.integrated.automationShell.linux",d.AutomationShellMacOs="terminal.integrated.automationShell.osx",d.AutomationShellWindows="terminal.integrated.automationShell.windows",d.AutomationProfileLinux="terminal.integrated.automationProfile.linux",d.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",d.AutomationProfileWindows="terminal.integrated.automationProfile.windows",d.ShellArgsLinux="terminal.integrated.shellArgs.linux",d.ShellArgsMacOs="terminal.integrated.shellArgs.osx",d.ShellArgsWindows="terminal.integrated.shellArgs.windows",d.ProfilesWindows="terminal.integrated.profiles.windows",d.ProfilesMacOs="terminal.integrated.profiles.osx",d.ProfilesLinux="terminal.integrated.profiles.linux",d.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",d.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",d.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",d.UseWslProfiles="terminal.integrated.useWslProfiles",d.TabsEnabled="terminal.integrated.tabs.enabled",d.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",d.TabsHideCondition="terminal.integrated.tabs.hideCondition",d.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",d.TabsShowActions="terminal.integrated.tabs.showActions",d.TabsLocation="terminal.integrated.tabs.location",d.TabsFocusMode="terminal.integrated.tabs.focusMode",d.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",d.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",d.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",d.CopyOnSelection="terminal.integrated.copyOnSelection",d.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",d.FontFamily="terminal.integrated.fontFamily",d.FontSize="terminal.integrated.fontSize",d.LetterSpacing="terminal.integrated.letterSpacing",d.LineHeight="terminal.integrated.lineHeight",d.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",d.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",d.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",d.BellDuration="terminal.integrated.bellDuration",d.FontWeight="terminal.integrated.fontWeight",d.FontWeightBold="terminal.integrated.fontWeightBold",d.CursorBlinking="terminal.integrated.cursorBlinking",d.CursorStyle="terminal.integrated.cursorStyle",d.CursorWidth="terminal.integrated.cursorWidth",d.Scrollback="terminal.integrated.scrollback",d.DetectLocale="terminal.integrated.detectLocale",d.DefaultLocation="terminal.integrated.defaultLocation",d.GpuAcceleration="terminal.integrated.gpuAcceleration",d.TerminalTitleSeparator="terminal.integrated.tabs.separator",d.TerminalTitle="terminal.integrated.tabs.title",d.TerminalDescription="terminal.integrated.tabs.description",d.RightClickBehavior="terminal.integrated.rightClickBehavior",d.Cwd="terminal.integrated.cwd",d.ConfirmOnExit="terminal.integrated.confirmOnExit",d.ConfirmOnKill="terminal.integrated.confirmOnKill",d.EnableBell="terminal.integrated.enableBell",d.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",d.AllowChords="terminal.integrated.allowChords",d.AllowMnemonics="terminal.integrated.allowMnemonics",d.EnvMacOs="terminal.integrated.env.osx",d.EnvLinux="terminal.integrated.env.linux",d.EnvWindows="terminal.integrated.env.windows",d.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",d.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",d.ShowExitAlert="terminal.integrated.showExitAlert",d.SplitCwd="terminal.integrated.splitCwd",d.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",d.WordSeparators="terminal.integrated.wordSeparators",d.EnableFileLinks="terminal.integrated.enableFileLinks",d.UnicodeVersion="terminal.integrated.unicodeVersion",d.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",d.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",d.LocalEchoEnabled="terminal.integrated.localEchoEnabled",d.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",d.LocalEchoStyle="terminal.integrated.localEchoStyle",d.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",d.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",d.CustomGlyphs="terminal.integrated.customGlyphs",d.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",d.InheritEnv="terminal.integrated.inheritEnv",d.ShowLinkHover="terminal.integrated.showLinkHover",d.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",d.AutoReplies="terminal.integrated.autoReplies",d.EnableShellIntegration="terminal.integrated.enableShellIntegration"})(L=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(d){d.CommandPrompt="cmd",d.PowerShell="pwsh",d.Wsl="wsl",d.GitBash="gitbash"})(T=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(d){d[d.Api=0]="Api",d[d.Process=1]="Process",d[d.Sequence=2]="Sequence",d[d.Config=3]="Config"})(A=e.TitleEventSource||(e.TitleEventSource={}));var R;(function(d){d.LocalPty="localPty",d.PtyHost="ptyHost",d.Log="log",d.Heartbeat="heartbeat"})(R=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var b;(function(d){d.Cwd="cwd",d.InitialCwd="initialCwd",d.FixedDimensions="fixedDimensions",d.Title="title",d.ShellType="shellType",d.HasChildProcesses="hasChildProcesses",d.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",d.OverrideDimensions="overrideDimensions"})(b=e.ProcessPropertyType||(e.ProcessPropertyType={}));var E;(function(d){d[d.BeatInterval=5e3]="BeatInterval",d[d.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",d[d.SecondWaitMultiplier=1]="SecondWaitMultiplier",d[d.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E=e.HeartbeatConstants||(e.HeartbeatConstants={}));var I;(function(d){d[d.Panel=1]="Panel",d[d.Editor=2]="Editor"})(I=e.TerminalLocation||(e.TerminalLocation={}));var C;(function(d){d.TerminalView="view",d.Editor="editor"})(C=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(d){d[d.CwdDetection=0]="CwdDetection",d[d.NaiveCwdDetection=1]="NaiveCwdDetection",d[d.CommandDetection=2]="CommandDetection",d[d.PartialCommandDetection=3]="PartialCommandDetection"})(f=e.TerminalCapability||(e.TerminalCapability={}));var p;(function(d){d[d.GraceTime=6e4]="GraceTime",d[d.ShortGraceTime=6e3]="ShortGraceTime"})(p=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var u;(function(d){d[d.HighWatermarkChars=1e5]="HighWatermarkChars",d[d.LowWatermarkChars=5e3]="LowWatermarkChars",d[d.CharCountAckSize=5e3]="CharCountAckSize"})(u=e.FlowControlConstants||(e.FlowControlConstants={}));var m;(function(d){d.GitBash="Git Bash",d.Pwsh="PowerShell"})(m=e.ProfileSource||(e.ProfileSource={}))}),define(ne[213],ie([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(ne[214],ie([0,1,33,28,10,4,32,14,22]),function(K,e,D,n,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let f=0;return C&&C.length===4&&(f=parseInt(C[3])),f}e.getWindowsBuildNumber=E;async function I(C,f,p,u=A.env,m=b.Promises.exists){if(L.isAbsolute(C))return await m(C)?C:void 0;if(f===void 0&&(f=A.cwd()),L.dirname(C)!=="."){const y=L.join(f,C);return await m(y)?y:void 0}const g=(0,n.getCaseInsensitive)(u,"PATH");if(p===void 0&&(0,R.isString)(g)&&(p=g.split(L.delimiter)),p===void 0||p.length===0){const y=L.join(f,C);return await m(y)?y:void 0}for(let y of p){let S;if(L.isAbsolute(y)?S=L.join(y,C):S=L.join(f,y,C),await m(S))return S;if(T.isWindows){let l=S+".com";if(await m(l)||(l=S+".exe",await m(l)))return l}}const w=L.join(f,C);return await m(w)?w:void 0}e.findExecutable=I}),define(ne[215],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var D;(function(n){n.DARK="dark",n.LIGHT="light",n.HIGH_CONTRAST="hc"})(D=e.ColorScheme||(e.ColorScheme={}))}),define(ne[97],ie([0,1,48,3,2,6,38,215]),function(K,e,D,n,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var b;(function(d){function g(w){return w&&typeof w=="object"&&typeof w.id=="string"}d.isThemeColor=g})(b=e.ThemeColor||(e.ThemeColor={}));function E(d){return{id:d}}e.themeColorFromId=E;var I;(function(d){function g(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||b.isThemeColor(t.color))}d.isThemeIcon=g;const w=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function y(t){const o=w.exec(t);if(!o)return;let[,s]=o;return{id:s}}d.fromString=y;function S(t){return{id:t}}d.fromId=S;function l(t,o){let s=t.id;const a=s.lastIndexOf("~");return a!==-1&&(s=s.substring(0,a)),o&&(s=`${s}~${o}`),{id:s}}d.modify=l;function r(t){const o=t.id.lastIndexOf("~");if(o!==-1)return t.id.substring(o+1)}d.getModifier=r;function c(t,o){return t.id===o.id&&t.color?.id===o.color?.id}d.isEqual=c;function i(t,o){return{id:t.id,color:o?E(o):void 0}}d.asThemeIcon=i,d.asClassNameArray=D.CSSIcon.asClassNameArray,d.asClassName=D.CSSIcon.asClassName,d.asCSSSelector=D.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function C(d){switch(d){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(g){return this.themingParticipants.push(g),this.onThemingParticipantAddedEmitter.fire(g),(0,L.toDisposable)(()=>{const w=this.themingParticipants.indexOf(g);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new f;A.Registry.add(e.Extensions.ThemingContribution,p);function u(d){return p.onColorThemeChange(d)}e.registerThemingParticipant=u;class m extends L.Disposable{constructor(g){super();this.themeService=g,this.theme=g.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(g){this.theme=g,this.updateStyles()}updateStyles(){}getColor(g,w){let y=this.theme.getColor(g);return y&&w&&(y=w(y,this.theme)),y?y.toString():null}}e.Themable=m}),define(ne[216],ie([0,1,48,7,97]),function(K,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(C,f){const p=C.map(u=>({name:u.profileName,description:A(u)}));return f&&p.push(...f.map(u=>({name:u.title,description:R(u)}))),{values:p.map(u=>u.name),markdownDescriptions:p.map(u=>u.description)}}e.createProfileSchemaEnums=T;function A(C){let f=`$(${L.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:D.Codicon.terminal.id}) ${C.profileName}
- path: ${C.path}`;return C.args&&(typeof C.args=="string"?f+=`
- args: "${C.args}"`:f+=`
- args: [${C.args.length===0?"":`'${C.args.join("','")}'`}]`),C.overrideName!==void 0&&(f+=`
- overrideName: ${C.overrideName}`),C.color&&(f+=`
- color: ${C.color}`),C.env&&(f+=`
- env: ${JSON.stringify(C.env)}`),f}function R(C){return`$(${L.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:D.Codicon.terminal.id}) ${C.title}
- extensionIdenfifier: ${C.extensionIdentifier}`}function b(C,f){if(!C&&!f)return!0;if(typeof C=="string"&&typeof f=="string")return C===f;if(Array.isArray(C)&&Array.isArray(f)){if(C.length!==f.length)return!1;for(let p=0;p<C.length;p++)if(C[p]!==f[p])return!1;return!0}return!1}e.terminalProfileArgsMatch=b;function E(C,f){if(!C&&!f)return!0;if(!C||!f)return!1;if(L.ThemeIcon.isThemeIcon(C)&&L.ThemeIcon.isThemeIcon(f))return C.id===f.id&&C.color===f.color;if(typeof C=="object"&&C&&"light"in C&&"dark"in C&&typeof f=="object"&&f&&"light"in f&&"dark"in f){const p=C,u=f;if((n.URI.isUri(p.light)||I(p.light))&&(n.URI.isUri(p.dark)||I(p.dark))&&(n.URI.isUri(u.light)||I(u.light))&&(n.URI.isUri(u.dark)||I(u.dark)))return p.light.path===u.light.path&&p.dark.path===u.dark.path}if(n.URI.isUri(C)&&n.URI.isUri(f)||I(C)||I(f)){const p=C,u=f;return p.path===u.path&&p.scheme===u.scheme}return!1}e.terminalIconsEqual=E;function I(C){return C?typeof C.path=="string"&&typeof C.scheme=="string":!1}e.isUriComponents=I}),define(ne[217],ie([0,1,48,142,42,38,216]),function(K,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const R={args:{description:(0,n.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,n.localize)(1,null),type:"boolean"},icon:{description:(0,n.localize)(2,null),type:"string",enum:Array.from(D.Codicon.getAll(),S=>S.id),markdownEnumDescriptions:Array.from(D.Codicon.getAll(),S=>`$(${S.id})`)},color:{description:(0,n.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,n.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},b={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},E={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(6,null),type:["string"],items:{type:"string"}},...R}},I=(0,n.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),C=(0,n.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),f=(0,n.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),p=(0,n.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),u=(0,n.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),m=(0,n.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),d={id:"terminal",order:100,title:(0,n.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:u},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(17,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,n.localize)(18,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,n.localize)(19,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,n.localize)(26,null)}},{type:"string",markdownDescription:(0,n.localize)(27,null)}],default:[],markdownDeprecationMessage:f},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,n.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(30,null),type:"string"},id:{description:(0,n.localize)(31,null),type:"string"},title:{description:(0,n.localize)(32,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(34,null),type:"string"},id:{description:(0,n.localize)(35,null),type:"string"},title:{description:(0,n.localize)(36,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(38,null),type:"string"},id:{description:(0,n.localize)(39,null),type:"string"},title:{description:(0,n.localize)(40,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.useWslProfiles"]:{description:(0,n.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,n.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,n.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,n.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,n.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function g(){T.Registry.as(L.Extensions.Configuration).registerConfiguration(d),y()}e.registerTerminalPlatformConfiguration=g;let w;function y(S,l){const r=T.Registry.as(L.Extensions.Configuration);let c;S&&(c=(0,A.createProfileSchemaEnums)(S?.profiles,l));const i=w;w={id:"terminal",order:100,title:(0,n.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:S?.os===3?c?.values:void 0,markdownEnumDescriptions:S?.os===3?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:S?.os===2?c?.values:void 0,markdownEnumDescriptions:S?.os===2?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:S?.os===1?c?.values:void 0,markdownEnumDescriptions:S?.os===1?c?.markdownDescriptions:void 0}}},r.updateConfigurations({add:[w],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=y}),define(ne[218],ie([0,1,45,48,10,4,22,72,214,97]),function(K,e,D,n,L,T,A,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let I,C=!0;function f(c,i,t,o,s=process.env,a,h,v,P){return a=a||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},T.isWindows?p(t,a,s,h,o.getValue("terminal.integrated.useWslProfiles")!==!1,c&&typeof c=="object"?{...c}:o.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:o.getValue("terminal.integrated.defaultProfile.windows"),P,v):S(a,h,t,c&&typeof c=="object"?{...c}:o.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:o.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),P,v,s)}e.detectAvailableProfiles=f;async function p(c,i,t,o,s,a,h,v,P){const _=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${_?"Sysnative":"System32"}`;let U=!1;(0,b.getWindowsBuildNumber)()>=16299&&(U=!0),await d(v);const k=new Map;c&&(k.set("PowerShell",{source:"PowerShell",icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),k.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),k.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),k.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),k.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:n.Codicon.terminalCmd,isAutoDetected:!0})),l(a,k);const M=await u(k.entries(),h,i,t,o,P);if(c||!c&&s)try{const F=await w(`${O}\\${U?"wsl":"bash"}.exe`,h);for(const V of F)(!a||!(V.profileName in a))&&M.push(V)}catch{C&&(o?.info("WSL is not installed, so could not detect WSL profiles"),C=!1)}return M}async function u(c,i,t,o=process.env,s,a){const h=[];for(const[v,P]of c){if(P===null)continue;let _,O,U;if("source"in P){const F=I?.get(P.source);if(!F)continue;_=F.paths,O=P.args||F.args,P.icon?U=m(P.icon):F.icon&&(U=F.icon)}else _=Array.isArray(P.path)?P.path:[P.path],O=T.isWindows||Array.isArray(P.args)?P.args:void 0,U=m(P.icon);const k=await a?.(_)||_.slice(),M=await r(v,i,k,t,o,O,P.env,P.overrideName,P.isAutoDetected,s);M?(M.isAutoDetected=P.isAutoDetected,M.icon=U,M.color=P.color,h.push(M)):s?.trace("profile not validated",v,_)}return h}function m(c){return typeof c=="string"?{id:c}:c}async function d(c){I&&!c||(I=new Map,I.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),I.set("PowerShell",{profileName:"PowerShell",paths:c||await g(),icon:E.ThemeIcon.asThemeIcon(n.Codicon.terminalPowershell)}))}async function g(){const c=[];for await(const i of(0,R.enumeratePowerShellInstallations)())c.push(i.exePath);return c}async function w(c,i){const t=[],o=await new Promise((h,v)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(P,_)=>{if(P)return v("Problem occurred when getting wsl distros");h(_)})});if(!o)return[];const s=new RegExp(/[\r?\n]/),a=o.split(s).filter(h=>h.trim().length>0&&h!=="");for(const h of a){if(h===""||h.startsWith("docker-desktop"))continue;const v=`${h} (WSL)`,P={profileName:v,path:c,args:["-d",`${h}`],isDefault:v===i,icon:y(h),isAutoDetected:!1};t.push(P)}return t}function y(c){return c.includes("Ubuntu")?E.ThemeIcon.asThemeIcon(n.Codicon.terminalUbuntu):c.includes("Debian")?E.ThemeIcon.asThemeIcon(n.Codicon.terminalDebian):E.ThemeIcon.asThemeIcon(n.Codicon.terminalLinux)}async function S(c,i,t,o,s,a,h,v){const P=new Map;if(t){const _=(await c.readFile("/etc/shells")).toString(),O=a||_.split(`
`).filter(k=>k.trim().indexOf("#")!==0&&k.trim().length>0),U=new Map;for(const k of O){let M=(0,L.basename)(k),F=U.get(M)||0;F++,F>1&&(M=`${M} (${F})`),U.set(M,F),P.set(M,{path:k,isAutoDetected:!0})}}return l(o,P),await u(P.entries(),s,c,v,i,h)}function l(c,i){if(!!c)for(const[t,o]of Object.entries(c))o===null||!("path"in o)&&!("source"in o)?i.delete(t):(o.icon=o.icon||i.get(t)?.icon,i.set(t,o))}async function r(c,i,t,o,s,a,h,v,P,_){if(t.length===0)return Promise.resolve(void 0);const O=t.shift();if(O==="")return r(c,i,t,o,s,a,h,v,P);const U={profileName:c,path:O,args:a,env:h,overrideName:v,isAutoDetected:P,isDefault:c===i};if((0,L.basename)(O)===O){const M=s.PATH?s.PATH.split(L.delimiter):void 0,F=await(0,b.findExecutable)(O,void 0,M,void 0,o.existsFile);return F?(U.path=F,U.isFromPath=!0,U):r(c,i,t,o,s,a)}return await o.existsFile((0,L.normalize)(O))?U:r(c,i,t,o,s,a,h,v,P)}}),define(ne[219],ie([0,1,3,2,18,4,36,58,20,15,77,161,8,86,21,212,96,217,218]),function(K,e,D,n,L,T,A,R,b,E,I,C,f,p,u,m,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var y;(function(r){r[r.MaxRestarts=5]="MaxRestarts"})(y||(y={}));let S=0,l=class extends n.Disposable{constructor(c,i,t,o,s){super();this._reconnectConstants=c,this._configurationService=i,this._environmentService=t,this._logService=o,this._telemetryService=s,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,(0,g.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,n.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new m.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async a=>{a.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(T.isWindows)return process.env;try{return await(0,C.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(c){return this._logService.error("ptyHost was unable to resolve shell environment",c),{}}}_startPtyHost(){const c={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:S,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},i=(0,I.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);i&&(i.break&&i.port?c.debugBrk=i.port:!i.break&&i.port&&(c.debug=i.port));const t=new R.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,c);this._onPtyHostStart.fire(),A.ProxyChannel.toService(t.getChannel(d.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(h=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(h.code),this._isDisposed||(this._restartCount<=y.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${h.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${h.code}, giving up`))}));const s=t.getChannel(d.TerminalIpcChannels.Log);p.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{p.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const a=A.ProxyChannel.toService(t.getChannel(d.TerminalIpcChannels.PtyHost));return this._register(a.onProcessData(h=>this._onProcessData.fire(h))),this._register(a.onProcessReady(h=>this._onProcessReady.fire(h))),this._register(a.onProcessExit(h=>this._onProcessExit.fire(h))),this._register(a.onDidChangeProperty(h=>this._onDidChangeProperty.fire(h))),this._register(a.onProcessReplay(h=>this._onProcessReplay.fire(h))),this._register(a.onProcessOrphanQuestion(h=>this._onProcessOrphanQuestion.fire(h))),this._register(a.onDidRequestDetach(h=>this._onDidRequestDetach.fire(h))),[t,a]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(c,i,t,o,s,a,h,v,P,_,O){const U=setTimeout(()=>this._handleUnresponsiveCreateProcess(),d.HeartbeatConstants.CreateProcessTimeout),k=await this._proxy.createProcess(c,i,t,o,s,a,h,v,P,_,O);return clearTimeout(U),S=Math.max(S,k),k}updateTitle(c,i,t){return this._proxy.updateTitle(c,i,t)}updateIcon(c,i,t){return this._proxy.updateIcon(c,i,t)}attachToProcess(c){return this._proxy.attachToProcess(c)}detachFromProcess(c){return this._proxy.detachFromProcess(c)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(c){return this._proxy.start(c)}shutdown(c,i){return this._proxy.shutdown(c,i)}input(c,i){return this._proxy.input(c,i)}processBinary(c,i){return this._proxy.processBinary(c,i)}resize(c,i,t){return this._proxy.resize(c,i,t)}acknowledgeDataEvent(c,i){return this._proxy.acknowledgeDataEvent(c,i)}setUnicodeVersion(c,i){return this._proxy.setUnicodeVersion(c,i)}getInitialCwd(c){return this._proxy.getInitialCwd(c)}getCwd(c){return this._proxy.getCwd(c)}getLatency(c){return this._proxy.getLatency(c)}orphanQuestionReply(c){return this._proxy.orphanQuestionReply(c)}installAutoReply(c,i){return this._proxy.installAutoReply(c,i)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(c){return this._proxy.uninstallAutoReply(c)}getDefaultSystemShell(c){return this._proxy.getDefaultSystemShell(c)}async getProfiles(c,i,t,o=!1){const s=await this._shellEnv;return(0,w.detectAvailableProfiles)(i,t,o,this._configurationService,s,void 0,this._logService,this._resolveVariables.bind(this,c))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(c){return this._proxy.getWslPath(c)}setTerminalLayoutInfo(c){return this._proxy.setTerminalLayoutInfo(c)}async getTerminalLayoutInfo(c){return await this._proxy.getTerminalLayoutInfo(c)}async requestDetachInstance(c,i){return this._proxy.requestDetachInstance(c,i)}async acceptDetachInstanceReply(c,i){return this._proxy.acceptDetachInstanceReply(c,i)}async serializeTerminalState(c){return this._proxy.serializeTerminalState(c)}async reviveTerminalProcesses(c,i){return this._proxy.reviveTerminalProcesses(c,i)}async refreshProperty(c,i){return this._proxy.refreshProperty(c,i)}async updateProperty(c,i,t){return this._proxy.updateProperty(c,i,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier+d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${d.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(c,i){return this._resolveVariablesRequestStore.createRequest({workspaceId:c,originalText:i})}async acceptPtyHostResolvedVariables(c,i){this._resolveVariablesRequestStore.acceptReply(c,i)}};l=de([Y(1,b.IConfigurationService),Y(2,E.IEnvironmentService),Y(3,f.ILogService),Y(4,u.ITelemetryService)],l),e.PtyHostService=l}),define(ne[34],ie([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(ne[220],ie([0,1,3,2,7,15,31,13,8,34]),function(K,e,D,n,L,T,A,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let I=class extends n.Disposable{constructor(f,p,u,m,d){super();this.extensionsManagementService=f,this.logService=m,this.uriIdentityService=d,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(w=>{this.installedExtensions=w.map(y=>y.identifier),this.startTimestamp=Date.now()}),this._register(f.onInstallExtension(w=>this.onInstallExtension(w))),this._register(f.onDidInstallExtensions(w=>this.onDidInstallExtensions(w))),this._register(f.onDidUninstallExtension(w=>this.onDidUninstallExtension(w)));const g=L.URI.file(u.extensionsPath);this._register(p.watch(g)),this._register(D.Event.filter(p.onDidFilesChange,w=>w.rawChanges.some(y=>this.doesChangeAffects(y,g)))(()=>this.onDidChange()))}doesChangeAffects(f,p){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(f.resource),p)?this.uriIdentityService.extUri.isEqual(f.resource,this.uriIdentityService.extUri.joinPath(p,".obsolete"))?!0:!(f.type!==1&&f.type!==2||this.uriIdentityService.extUri.basename(f.resource).startsWith(".")):!1}onInstallExtension(f){this.addInstallingExtension(f.identifier)}onDidInstallExtensions(f){for(const p of f)this.removeInstallingExtension(p.identifier),p.local&&this.addInstalledExtension(p.identifier)}onDidUninstallExtension(f){f.error||this.removeInstalledExtension(f.identifier)}addInstallingExtension(f){this.removeInstallingExtension(f),this.installingExtensions.push(f)}removeInstallingExtension(f){this.installingExtensions=this.installingExtensions.filter(p=>!(0,A.areSameExtensions)(p,f))}addInstalledExtension(f){this.installedExtensions&&(this.removeInstalledExtension(f),this.installedExtensions.push(f))}removeInstalledExtension(f){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(p=>!(0,A.areSameExtensions)(p,f)))}async onDidChange(){if(this.installedExtensions){const f=await this.extensionsManagementService.getInstalled(1),p=f.filter(m=>[...this.installingExtensions,...this.installedExtensions].some(d=>(0,A.areSameExtensions)(d,m.identifier))?!1:m.installedTimestamp&&m.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",m.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",m.identifier.id),!1)),u=this.installedExtensions.filter(m=>this.installingExtensions.some(d=>(0,A.areSameExtensions)(d,m))?!1:f.every(d=>!(0,A.areSameExtensions)(d.identifier,m))?(this.logService.info("Detected extension removed from another source",m.id),!0):!1);this.installedExtensions=f.map(m=>m.identifier),(p.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:p,removed:u})}}};I=de([Y(1,R.IFileService),Y(2,T.INativeEnvironmentService),Y(3,b.ILogService),Y(4,E.IUriIdentityService)],I),e.ExtensionsWatcher=I}),define(ne[221],ie([0,1,34,79,13,19,104,3,2]),function(K,e,D,n,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class E{constructor(f){this.uri=f,this.time=E._clock++}touch(){return this.time=E._clock++,this}}E._clock=0;let I=class{constructor(f){this._fileService=f,this._dispooables=new b.DisposableStore,this._limit=2**16;const p=new Map,u=m=>{let d=p.get(m.scheme);return d===void 0&&(d=f.hasProvider(m)&&!this._fileService.hasCapability(m,1024),p.set(m.scheme,d)),d};this._dispooables.add(R.Event.any(f.onDidChangeFileSystemProviderRegistrations,f.onDidChangeFileSystemProviderCapabilities)(m=>{p.delete(m.scheme)})),this.extUri=new T.ExtUri(u),this._canonicalUris=new A.SkipList((m,d)=>this.extUri.compare(m,d,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(f){this._fileService.hasProvider(f)&&(f=(0,T.normalizePath)(f));let p=this._canonicalUris.get(f);return p?p.touch().uri.with({fragment:f.fragment}):(this._canonicalUris.set(f,new E(f)),this._checkTrim(),f)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const f=[...this._canonicalUris.entries()].sort((u,m)=>u[1].touch<m[1].touch?1:u[1].touch>m[1].touch?-1:0);E._clock=0,this._canonicalUris.clear();const p=this._limit*.5;for(let u=0;u<p;u++)this._canonicalUris.set(f[u][0],f[u][1].touch())}};I=de([Y(0,L.IFileService)],I),e.UriIdentityService=I,(0,n.registerSingleton)(D.IUriIdentityService,I,!0)}),define(ne[222],ie([0,1,3,2,40,39,17]),function(K,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class R extends n.Disposable{constructor(E,I,C,f,p){super();this.fileSystemScheme=E,this.fileSystemProvider=I,this.userDataScheme=C,this.logService=p,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(f.onDidFilesChange(u=>this.handleFileChanges(u)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(E,I){this.watchResources.set(E,E);const C=this.fileSystemProvider.watch(this.toFileSystemResource(E),I);return(0,n.toDisposable)(()=>{this.watchResources.delete(E),C.dispose()})}stat(E){return this.fileSystemProvider.stat(this.toFileSystemResource(E))}mkdir(E){return this.fileSystemProvider.mkdir(this.toFileSystemResource(E))}rename(E,I,C){return this.fileSystemProvider.rename(this.toFileSystemResource(E),this.toFileSystemResource(I),C)}readFile(E){return this.fileSystemProvider.readFile(this.toFileSystemResource(E),{atomic:!0})}readFileStream(E,I,C){const f=(0,L.newWriteableStream)(p=>A.VSBuffer.concat(p.map(u=>A.VSBuffer.wrap(u))).buffer);return(async()=>{try{const p=await this.readFile(E);f.end(p)}catch(p){f.error(p),f.end()}})(),f}readdir(E){return this.fileSystemProvider.readdir(this.toFileSystemResource(E))}writeFile(E,I,C){return this.fileSystemProvider.writeFile(this.toFileSystemResource(E),I,C)}delete(E,I){return this.fileSystemProvider.delete(this.toFileSystemResource(E),I)}handleFileChanges(E){const I=[];for(const C of E.rawChanges){if(C.resource.scheme!==this.fileSystemScheme)continue;const f=this.toUserDataResource(C.resource);this.watchResources.findSubstr(f)&&I.push({resource:f,type:C.type})}I.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(I))}toFileSystemResource(E){return E.with({scheme:this.fileSystemScheme})}toUserDataResource(E){return E.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=R}),define(ne[53],ie([0,1,69]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function n(A,R,b,E){const I=(0,D.setProperty)(A,R,b,E)[0];return I&&(A=A.substring(0,I.offset)+I.content+A.substring(I.offset+I.length)),A}e.edit=n;function L(A,R,b){let E=b;for(;E>=0;){if(A.charAt(E)===R.charAt(R.length-1)&&R.length===1)return E+1;if(E--,R.length===2&&E>=0&&A.charAt(E)===R.charAt(0))return E+2}return 0}e.getLineStartOffset=L;function T(A,R,b){let E=b;for(;E>=0;)if(A.charAt(E)===R.charAt(R.length-1)&&R.length===1||(E++,R.length===2&&E>=0&&A.charAt(E)===R.charAt(1)))return E;return A.length-1}e.getLineEndOffset=T}),define(ne[223],ie([0,1,28,61,14]),function(K,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(f,p,u,m,d){const g=[],w=[],y=[];if(!p){const O=f.filter(({identifier:U})=>d.every(k=>k.toLowerCase()!==U.id.toLowerCase()));return{local:{added:g,removed:w,updated:y},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}f=f.map(I),p=p.map(I),u=u?u.map(I):null;const S=new Map,l=O=>{O.uuid&&S.set(O.id.toLowerCase(),O.uuid)};f.forEach(({identifier:O})=>l(O)),p.forEach(({identifier:O})=>l(O)),u&&u.forEach(({identifier:O})=>l(O));const r=O=>{const U=O.identifier.uuid||S.get(O.identifier.id.toLowerCase());return U?`uuid:${U}`:`id:${O.identifier.id.toLowerCase()}`},c=(O,U)=>(O.set(r(U),U),O),i=f.reduce(c,new Map),t=p.reduce(c,new Map),o=p.reduce((O,U)=>{const k=r(U);U=(0,D.deepClone)(U);const M=i.get(k);return M&&(M.installed&&(U.installed=!0),U.version||(U.version=M.version)),c(O,U)},new Map),s=u?u.reduce(c,new Map):null,a=m.reduce(c,new Map),h=d.reduce((O,U)=>{const k=S.get(U.toLowerCase());return O.add(k?`uuid:${k}`:`id:${U.toLowerCase()}`)},new Set),v=A(i,t,h);if(v.added.size>0||v.removed.size>0||v.updated.size>0){const O=A(s,i,h),U=A(s,t,h),k=(M,F)=>{const V=i.get(M);if(V){const N=t.get(M),G=F?N:V;return{...G,version:(N.version&&n.gt(N.version,V.version),V.version),state:R(V,N,s?.get(M)),preRelease:(0,L.isUndefined)(G.preRelease)?V.preRelease:G.preRelease}}};for(const M of U.removed.values()){const F=i.get(M);F&&w.push(F.identifier)}for(const M of U.added.values())if(O.added.has(M)){if(v.updated.has(M)){const F=k(M,!0);F&&(y.push(C(F,M)),o.set(M,F))}}else{const F=t.get(M);F.installed&&g.push(C(F,M))}for(const M of U.updated.values()){const F=k(M,!0);F&&(y.push(C(F,M)),o.set(M,F))}for(const M of O.added.values())U.added.has(M)||o.set(M,i.get(M));for(const M of O.updated.values())if(!U.removed.has(M)&&!U.updated.has(M)){const F=k(M,!1);F&&(o.get(M)?.installed&&(F.installed=!0),o.set(M,F))}for(const M of O.removed.values())!a.has(M)&&!U.updated.has(M)&&s?.get(M)?.installed&&o.delete(M)}const P=[],_=A(t,o,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&o.forEach((O,U)=>P.push(C(O,U))),{local:{added:g,removed:w,updated:y},remote:P.length?{added:[..._.added].map(O=>o.get(O)),updated:[..._.updated].map(O=>o.get(O)),removed:[..._.removed].map(O=>t.get(O)),all:P}:null}}e.merge=T;function A(f,p,u,{checkInstalledProperty:m,checkVersionProperty:d}={checkInstalledProperty:!1,checkVersionProperty:!1}){const g=f?[...f.keys()].filter(r=>!u.has(r)):[],w=[...p.keys()].filter(r=>!u.has(r)),y=w.filter(r=>g.indexOf(r)===-1).reduce((r,c)=>(r.add(c),r),new Set),S=g.filter(r=>w.indexOf(r)===-1).reduce((r,c)=>(r.add(c),r),new Set),l=new Set;for(const r of g){if(S.has(r))continue;const c=f.get(r),i=p.get(r);(!i||c.disabled!==i.disabled||c.preRelease!==i.preRelease||!E(c.state,i.state)||d&&c.version!==i.version||m&&c.installed!==i.installed)&&l.add(r)}return{added:y,removed:S,updated:l}}function R(f,p,u){const m=f.state,d=p.state,g=u?.state;if(!p.version||m&&n.gt(f.version,p.version))return m;if(d&&n.gt(p.version,f.version)||!m)return d;if(!d)return m;const w=(0,D.deepClone)(m),y=g?b(g,d):{added:Object.keys(d).reduce((l,r)=>(l.add(r),l),new Set),removed:new Set,updated:new Set},S=g?b(g,m):{added:Object.keys(m).reduce((l,r)=>(l.add(r),l),new Set),removed:new Set,updated:new Set};for(const l of[...y.added.values(),...y.updated.values()])w[l]=d[l];for(const l of y.removed.values())S.updated.has(l)||delete w[l];return w}function b(f,p){const u=Object.keys(f),m=Object.keys(p),d=m.filter(y=>u.indexOf(y)===-1).reduce((y,S)=>(y.add(S),y),new Set),g=u.filter(y=>m.indexOf(y)===-1).reduce((y,S)=>(y.add(S),y),new Set),w=new Set;for(const y of u){if(g.has(y))continue;const S=f[y],l=p[y];(0,D.equals)(S,l)||w.add(y)}return{added:d,removed:g,updated:w}}function E(f={},p={}){const{added:u,removed:m,updated:d}=b(f,p);return u.size===0&&m.size===0&&d.size===0}function I(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function C(f,p){const u={identifier:{id:f.identifier.id,uuid:p.startsWith("uuid:")?p.substring("uuid:".length):void 0},preRelease:!!f.preRelease};return f.version&&(u.version=f.version),f.disabled&&(u.disabled=!0),f.installed&&(u.installed=!0),f.state&&(u.state=f.state),u}}),define(ne[98],ie([0,1,16,20,6]),function(K,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,L.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,b){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return E=E.filter(I=>I!==R&&I!==`-${R}`),b&&E.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}updateSynchronizedExtensions(R,b){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return E=E.filter(I=>I!==R&&I!==`-${R}`),b&&E.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}getIgnoredExtensions(R){const b=R.filter(f=>f.isMachineScoped).map(f=>f.identifier.id.toLowerCase()),E=this.getConfiguredIgnoredExtensions().map(f=>f.toLowerCase()),I=[],C=[];if(Array.isArray(E))for(const f of E)f.startsWith("-")?C.push(f.substring(1)):I.push(f);return(0,D.distinct)([...b,...I].filter(f=>C.indexOf(f)===-1))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(b=>b.toLowerCase())}};T=de([Y(0,n.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(ne[224],ie([0,1,16,35,28,158,53]),function(K,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(S){return(0,n.parse)(S)||[]}e.parseKeybindings=R;async function b(S,l,r,c,i){const t=R(S),o=R(l),s=r?R(r):null,a=[...t,...o,...s||[]].map(N=>N.key),h=await i.resolveUserBindings(a);let v=I(t,o,s,h);if(!v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:S,hasChanges:!1,hasConflicts:!1};if(!v.hasLocalForwarded&&v.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:S,hasChanges:!0,hasConflicts:!1};const P=f(t),_=f(o),O=s?f(s):null,U=u(P,_,h),k=O?u(O,P,h):{added:[...P.keys()].reduce((N,G)=>(N.add(G),N),new Set),removed:new Set,updated:new Set},M=O?u(O,_,h):{added:[..._.keys()].reduce((N,G)=>(N.add(G),N),new Set),removed:new Set,updated:new Set},F=E(U,k,M);let V=S;for(const N of F.removed.values())F.conflicts.has(N)||(V=w(V,N,c));for(const N of F.added.values()){if(F.conflicts.has(N))continue;const G=_.get(N);if(G.some(J=>J.command!==`-${N}`&&v.conflicts.has(h[J.key]))){F.conflicts.add(N);continue}V=g(V,G,c)}for(const N of F.updated.values()){if(F.conflicts.has(N))continue;const G=_.get(N);if(G.some(J=>J.command!==`-${N}`&&v.conflicts.has(h[J.key]))){F.conflicts.add(N);continue}V=y(V,N,G,c)}return{mergeContent:V,hasChanges:!0,hasConflicts:F.conflicts.size>0}}e.merge=b;function E(S,l,r){const c=new Set,i=new Set,t=new Set,o=new Set;for(const s of l.removed.values())r.updated.has(s)&&o.add(s);for(const s of r.removed.values())o.has(s)||(l.updated.has(s)?o.add(s):i.add(s));for(const s of l.added.values())o.has(s)||r.added.has(s)&&S.updated.has(s)&&o.add(s);for(const s of r.added.values())o.has(s)||(l.added.has(s)?S.updated.has(s)&&o.add(s):c.add(s));for(const s of l.updated.values())o.has(s)||r.updated.has(s)&&S.updated.has(s)&&o.add(s);for(const s of r.updated.values())o.has(s)||(l.updated.has(s)?S.updated.has(s)&&o.add(s):t.add(s));return{added:c,removed:i,updated:t,conflicts:o}}function I(S,l,r,c){const i=new Set,t=C(S,c),o=C(l,c),s=r?C(r,c):null,a=p(t,o);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const h=s?p(s,t):{added:[...t.keys()].reduce((k,M)=>(k.add(M),k),new Set),removed:new Set,updated:new Set};if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const v=s?p(s,o):{added:[...o.keys()].reduce((k,M)=>(k.add(M),k),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:P,removed:_,updated:O,conflicts:U}=E(a,h,v);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:P,removed:_,updated:O,conflicts:U}}function C(S,l){const r=new Map;for(const c of S){const i=l[c.key];let t=r.get(i);t||(t=[],r.set(i,t)),t.push(c)}return r}function f(S){const l=new Map;for(const r of S){const c=r.command[0]==="-"?r.command.substring(1):r.command;let i=l.get(c);i||(i=[],l.set(c,i)),i.push(r)}return l}function p(S,l){const r=[...S.keys()],c=[...l.keys()],i=c.filter(s=>r.indexOf(s)===-1).reduce((s,a)=>(s.add(a),s),new Set),t=r.filter(s=>c.indexOf(s)===-1).reduce((s,a)=>(s.add(a),s),new Set),o=new Set;for(const s of r){if(t.has(s))continue;const a=S.get(s).map(v=>({...v,key:s})),h=l.get(s).map(v=>({...v,key:s}));(0,D.equals)(a,h,(v,P)=>d(v,P))||o.add(s)}return{added:i,removed:t,updated:o}}function u(S,l,r){const c=[...S.keys()],i=[...l.keys()],t=i.filter(a=>c.indexOf(a)===-1).reduce((a,h)=>(a.add(h),a),new Set),o=c.filter(a=>i.indexOf(a)===-1).reduce((a,h)=>(a.add(h),a),new Set),s=new Set;for(const a of c){if(o.has(a))continue;const h=S.get(a).map(P=>({...P,key:r[P.key]})),v=l.get(a).map(P=>({...P,key:r[P.key]}));m(h,v)||s.add(a)}return{added:t,removed:o,updated:s}}function m(S,l){return!(!(0,D.equals)(S.filter(({command:r})=>r[0]!=="-"),l.filter(({command:r})=>r[0]!=="-"),(r,c)=>d(r,c))||!(0,D.equals)(S.filter(({command:r})=>r[0]==="-"),l.filter(({command:r})=>r[0]==="-"),(r,c)=>d(r,c)))}function d(S,l){if(S.command!==l.command||S.key!==l.key)return!1;const r=T.ContextKeyExpr.deserialize(S.when),c=T.ContextKeyExpr.deserialize(l.when);return!(r&&!c||!r&&c||r&&c&&!r.equals(c)||!L.equals(S.args,l.args))}function g(S,l,r){for(const c of l)S=A.edit(S,[-1],c,r);return S}function w(S,l,r){const c=R(S);for(let i=c.length-1;i>=0;i--)(c[i].command===l||c[i].command===`-${l}`)&&(S=A.edit(S,[i],void 0,r));return S}function y(S,l,r,c){const i=R(S),t=i.findIndex(o=>o.command===l||o.command===`-${l}`);for(let o=i.length-1;o>=0;o--)(i[o].command===l||i[o].command===`-${l}`)&&(S=A.edit(S,[o],void 0,c));for(let o=r.length-1;o>=0;o--)S=A.edit(S,[t],r[o],c);return S}}),define(ne[225],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(T,A,R){const b={},E={},I=new Set;if(!A)return{local:{added:b,updated:E,removed:[...I.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const C=n(T,A);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{local:{added:b,updated:E,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const f=n(R,T),p=n(R,A),u={},m={},d=new Set,g=new Set;for(const w of f.removed.values())p.updated.has(w)?b[w]=A[w]:d.add(w);for(const w of p.removed.values())g.has(w)||(f.updated.has(w)?g.add(w):I.add(w));for(const w of f.updated.values())g.has(w)||(p.updated.has(w)?C.updated.has(w)&&g.add(w):m[w]=T[w]);for(const w of p.updated.values())g.has(w)||(f.updated.has(w)?C.updated.has(w)&&g.add(w):T[w]!==void 0&&(E[w]=A[w]));for(const w of f.added.values())g.has(w)||(p.added.has(w)?C.updated.has(w)&&g.add(w):u[w]=T[w]);for(const w of p.added.values())g.has(w)||(f.added.has(w)?C.updated.has(w)&&g.add(w):b[w]=A[w]);return{local:{added:b,removed:[...I.values()],updated:E},remote:{added:u,removed:[...d.values()],updated:m},conflicts:[...g.values()]}}e.merge=D;function n(T,A){const R=T?Object.keys(T):[],b=A?Object.keys(A):[],E=b.filter(f=>R.indexOf(f)===-1).reduce((f,p)=>(f.add(p),f),new Set),I=R.filter(f=>b.indexOf(f)===-1).reduce((f,p)=>(f.add(p),f),new Set),C=new Set;for(const f of R){if(I.has(f))continue;const p=T[f],u=A[f];p!==u&&C.add(f)}return{added:E,removed:I,updated:C}}function L(T,A){const{added:R,removed:b,updated:E}=n(T,A);return R.size===0&&b.size===0&&E.size===0}e.areSame=L}),define(ne[25],ie([0,1,16,19,14,147,42,30,6,88,38]),function(K,e,D,n,L,T,A,R,b,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const s=I.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(a=>!!s[a].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function f(){const s=I.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(s).filter(P=>!!s[P].ignoreSync),h=Object.keys(s).filter(P=>s[P].scope===2||s[P].scope===6),v=C();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...a,...h,...v])}e.getDefaultIgnoredSettings=f,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function p(){const s="vscode://schemas/ignoredSettings",a=I.Registry.as(A.Extensions.Configuration);a.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const h=I.Registry.as(E.Extensions.JSONContribution),v=()=>{const P=C(),_=f().filter(M=>M!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(A.allSettings.properties).filter(M=>_.indexOf(M)===-1),U=_.filter(M=>P.indexOf(M)===-1),k={items:{type:"string",enum:[...O,...U.map(M=>`-${M}`)]}};h.registerSchema(s,k)};return a.onDidUpdateConfiguration(()=>v())}e.registerConfiguration=p;function u(s){return s&&(0,L.isObject)(s)&&(0,L.isString)(s.id)&&(0,L.isArray)(s.scopes)}e.isAuthenticationProvider=u;var m;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Extensions="extensions",s.GlobalState="globalState"})(m=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function d(s,a,h){return h.joinPath(a.userDataSyncHome,s,`lastSync${s}.json`)}e.getLastSyncResourceUri=d,e.IUserDataSyncStoreManagementService=(0,b.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,b.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,b.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function g(s){const a={};return a[e.HEADER_EXECUTION_ID]=s,a}e.createSyncHeaders=g;var w;(function(s){s.Unauthorized="Unauthorized",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.UnresolvedConflicts="UnresolvedConflicts",s.Unknown="Unknown"})(w=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class y extends Error{constructor(a,h,v,P){super(a);this.code=h,this.resource=v,this.operationId=P,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=y;class S extends y{constructor(a,h,v,P,_){super(a,v,void 0,_);this.url=h,this.serverCode=P}}e.UserDataSyncStoreError=S;class l extends y{constructor(a,h){super(a,h)}}e.UserDataAutoSyncError=l,function(s){function a(h){if(h instanceof s)return h;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(h.name);if(v&&v[1]){const P=v[2]==="unknown"?void 0:v[2],_=v[3]==="unknown"?void 0:v[3];return new s(h.message,v[1],P,_)}return new s(h.message,"Unknown")}s.toUserDataSyncError=a}(y=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var c;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(c=e.Change||(e.Change={}));var i;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(s){return`sync.enable.${s}`}e.getEnablementKey=t,e.IUserDataSyncEnablementService=(0,b.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,b.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,b.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,b.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,b.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(s,a){if(s.scheme!==e.USER_DATA_SYNC_SCHEME)return s=s.with({scheme:a.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(h=>(0,n.isEqualOrParent)(s,(0,n.joinPath)(a.userDataSyncHome,h,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(ne[47],ie([0,1,16,5,17,23,3,35,2,26,14,7,143,20,15,13,8,46,24,21,34,25]),function(K,e,D,n,L,T,A,R,b,E,I,C,f,p,u,m,d,g,w,y,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(s){return!!(s&&s.version!==void 0&&typeof s.version=="number"&&s.content!==void 0&&typeof s.content=="string"&&(Object.keys(s).length===2||Object.keys(s).length===3&&s.machineId!==void 0&&typeof s.machineId=="string"))}e.isSyncData=r;let c=class extends b.Disposable{constructor(a,h,v,P,_,O,U,k,M,F,V){super();this.resource=a,this.fileService=h,this.environmentService=v,this.userDataSyncStoreService=_,this.userDataSyncBackupStoreService=O,this.userDataSyncEnablementService=U,this.telemetryService=k,this.logService=M,this.configurationService=F,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new n.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,E.uppercaseFirstLetter)(this.resource),this.extUri=V.extUri,this.syncFolder=this.extUri.joinPath(v.userDataSyncHome,a),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(a,v,this.extUri),this.currentMachineIdPromise=(0,g.getServiceMachineId)(v,h,P)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const a=await this.syncPreviewPromise;this.syncPreviewPromise=null;const h=await this.performSync(a.remoteUserData,a.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(h)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const a=await this.getLastSyncUserData();(a?await this.hasRemoteChanged(a):!0)&&this._onDidChangeLocal.fire()}}setStatus(a){if(this._status!==a){const h=this._status;a==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),h==="hasConflicts"&&a==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=a,this._onDidChangStatus.fire(a)}}async sync(a,h={}){await this._sync(a,!0,this.getUserDataSyncConfiguration(),h)}async preview(a,h,v={}){return this._sync(a,!1,h,v)}async apply(a,h={}){try{this.syncHeaders={...h};const v=await this.doApply(a);return this.setStatus(v),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(a,h,v,P){try{if(this.syncHeaders={...P},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let _="idle";try{const O=await this.getLastSyncUserData(),U=await this.getLatestRemoteUserData(a,O);return _=await this.performSync(U,O,h,v),_==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):_==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(_)}}finally{this.syncHeaders={}}}async replace(a){const h=await this.resolveContent(a);if(!h)return!1;const v=this.parseSyncData(h);if(!v)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const P=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(null,P),O=await this.isRemoteDataFromCurrentMachine(_),U=await this.generateSyncPreview({ref:_.ref,syncData:v},P,O,this.getUserDataSyncConfiguration(),T.CancellationToken.None),k=[];for(const M of U){const F=await this.getAcceptResult(M,M.remoteResource,void 0,T.CancellationToken.None),{remoteChange:V}=await this.getAcceptResult(M,M.previewResource,M.remoteContent,T.CancellationToken.None);k.push([M,{...F,remoteChange:V!==0?V:2}])}await this.applyResult(_,P,k,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(a){const h=await this.currentMachineIdPromise;return!!a.syncData?.machineId&&a.syncData.machineId===h}async getLatestRemoteUserData(a,h){if(h){const v=a&&a.latest?a.latest[this.resource]:void 0;if(h.ref===v||v===void 0&&h.syncData===null)return h}return this.getRemoteUserData(h)}async performSync(a,h,v,P){if(a.syncData&&a.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,f.localize)(0,null,this.resource,this.version,a.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(a,h,v,P)}catch(_){if(_ instanceof l.UserDataSyncError)switch(_.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(a,h,v,P);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),a=await this.getRemoteUserData(null),h=await this.getLastSyncUserData(),this.performSync(a,h,v,P)}throw _}}async doSync(a,h,v,P){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,n.createCancelablePromise)(O=>this.doGenerateSyncResourcePreview(a,h,v,P,O)));const _=await this.syncPreviewPromise;return this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:O})=>O==="conflict")?"hasConflicts":v?await this.doApply(!1):"syncing"}catch(_){throw this.syncPreviewPromise=null,_}}async merge(a){return await this.updateSyncResourcePreview(a,async h=>{const v=await this.getMergeResult(h,T.CancellationToken.None);await this.fileService.writeFile(h.previewResource,L.VSBuffer.fromString(v?.content||""));const P=v&&!v.hasConflicts?await this.getAcceptResult(h,h.previewResource,void 0,T.CancellationToken.None):void 0;return h.acceptResult=P,h.mergeState=v.hasConflicts?"conflict":P?"accepted":"preview",h.localChange=P?P.localChange:v.localChange,h.remoteChange=P?P.remoteChange:v.remoteChange,h}),this.syncPreviewPromise}async accept(a,h){return await this.updateSyncResourcePreview(a,async v=>{const P=await this.getAcceptResult(v,a,h,T.CancellationToken.None);return v.acceptResult=P,v.mergeState="accepted",v.localChange=P.localChange,v.remoteChange=P.remoteChange,v}),this.syncPreviewPromise}async discard(a){return await this.updateSyncResourcePreview(a,async h=>{const v=await this.getMergeResult(h,T.CancellationToken.None);return await this.fileService.writeFile(h.previewResource,L.VSBuffer.fromString(v.content||"")),h.acceptResult=void 0,h.mergeState="preview",h.localChange=v.localChange,h.remoteChange=v.remoteChange,h}),this.syncPreviewPromise}async updateSyncResourcePreview(a,h){if(!this.syncPreviewPromise)return;let v=await this.syncPreviewPromise;const P=v.resourcePreviews.findIndex(({localResource:_,remoteResource:O,previewResource:U})=>this.extUri.isEqual(_,a)||this.extUri.isEqual(O,a)||this.extUri.isEqual(U,a));P!==-1&&(this.syncPreviewPromise=(0,n.createCancelablePromise)(async _=>{const O=[...v.resourcePreviews];return O[P]=await h(O[P]),{...v,resourcePreviews:O}}),v=await this.syncPreviewPromise,this.updateConflicts(v.resourcePreviews),v.resourcePreviews.some(({mergeState:_})=>_==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(a){if(!this.syncPreviewPromise)return"idle";const h=await this.syncPreviewPromise;return h.resourcePreviews.some(({mergeState:v})=>v==="conflict")?"hasConflicts":h.resourcePreviews.some(({mergeState:v})=>v!=="accepted")?"syncing":(await this.applyResult(h.remoteUserData,h.lastSyncUserData,h.resourcePreviews.map(v=>[v,v.acceptResult]),a),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(a){const h=a.filter(({mergeState:v})=>v==="conflict");(0,D.equals)(this._conflicts,h,(v,P)=>this.extUri.isEqual(v.previewResource,P.previewResource))||(this._conflicts=h,this._onDidChangeConflicts.fire(h))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:h,ref:v})=>({created:h,uri:this.toRemoteBackupResource(v)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:h,ref:v})=>({created:h,uri:this.toLocalBackupResource(v)}))}toRemoteBackupResource(a){return C.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${a}`})}toLocalBackupResource(a){return C.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${a}`})}async getMachineId({uri:a}){const h=this.extUri.basename(a);if(this.extUri.isEqual(a,this.toRemoteBackupResource(h))){const{content:v}=await this.getUserData(h);if(v)return this.parseSyncData(v)?.machineId}}async resolveContent(a){const h=this.extUri.basename(a);if(this.extUri.isEqual(a,this.toRemoteBackupResource(h))){const{content:v}=await this.getUserData(h);return v}return this.extUri.isEqual(a,this.toLocalBackupResource(h))?this.userDataSyncBackupStoreService.resolveContent(this.resource,h):null}async resolvePreviewContent(a){const h=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(h)for(const v of h.resourcePreviews){if(this.extUri.isEqual(v.acceptedResource,a))return v.acceptResult?v.acceptResult.content:null;if(this.extUri.isEqual(v.remoteResource,a))return v.remoteContent;if(this.extUri.isEqual(v.localResource,a))return v.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(a,h,v,P,_){const O=await this.isRemoteDataFromCurrentMachine(a),U=await this.generateSyncPreview(a,h,O,P,_),k=[];for(const M of U){const F=M.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(M.localChange===0&&M.remoteChange===0)k.push({...M,acceptedResource:F,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const V=v?await this.getMergeResult(M,_):void 0;if(_.isCancellationRequested)break;await this.fileService.writeFile(M.previewResource,L.VSBuffer.fromString(V?.content||""));const N=V&&!V.hasConflicts?await this.getAcceptResult(M,M.previewResource,void 0,_):void 0;k.push({...M,acceptResult:N,mergeState:V?.hasConflicts?"conflict":N?"accepted":"preview",localChange:N?N.localChange:V?V.localChange:M.localChange,remoteChange:N?N.remoteChange:V?V.remoteChange:M.remoteChange})}}return{remoteUserData:a,lastSyncUserData:h,resourcePreviews:k,isLastSyncFromCurrentMachine:O}}async getLastSyncUserData(){try{const a=await this.fileService.readFile(this.lastSyncResource),h=JSON.parse(a.value.toString()),v=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=h.version&&v&&h.version!==v,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${h.version} is not compatible with current sync state version ${v}.`),await this.resetLocal(),null;const P=h;if(P.content===null)return{ref:h.ref,syncData:null};const _=JSON.parse(P.content);if(r(_))return{...h,syncData:_,content:void 0}}catch(a){a instanceof m.FileOperationError&&a.fileOperationResult===1||this.logService.error(a)}return null}async updateLastSyncUserData(a,h={}){if(h.ref||h.content||h.version)throw new Error("Cannot have core properties as additional");const v=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),P={ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null,version:v,...h};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(P)))}async getRemoteUserData(a){const{ref:h,content:v}=await this.getUserData(a);let P=null;return v!==null&&(P=this.parseSyncData(v)),{ref:h,syncData:P}}parseSyncData(a){try{const h=JSON.parse(a);if(r(h))return h}catch(h){this.logService.error(h)}throw new l.UserDataSyncError((0,f.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(a){if((0,I.isString)(a)){const h=await this.userDataSyncStoreService.resolveContent(this.resource,a);return{ref:a,content:h}}else{const h=a?{ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,h,this.syncHeaders)}}async updateRemoteUserData(a,h){const v=await this.currentMachineIdPromise,P={version:this.version,machineId:v,content:a};return h=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(P),h,this.syncHeaders),{ref:h,syncData:P}}async backupLocal(a){const h={version:this.version,content:a};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(h))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};c=de([Y(1,m.IFileService),Y(2,u.IEnvironmentService),Y(3,w.IStorageService),Y(4,l.IUserDataSyncStoreService),Y(5,l.IUserDataSyncBackupStoreService),Y(6,l.IUserDataSyncEnablementService),Y(7,y.ITelemetryService),Y(8,l.IUserDataSyncLogService),Y(9,p.IConfigurationService),Y(10,S.IUriIdentityService)],c),e.AbstractSynchroniser=c;let i=class extends c{constructor(a,h,v,P,_,O,U,k,M,F,V,N){super(h,v,P,_,O,U,k,M,F,V,N);this.file=a,this._register(this.fileService.watch(this.extUri.dirname(a))),this._register(this.fileService.onDidFilesChange(G=>this.onFileChanges(G)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(a,h,v){try{h?await this.fileService.writeFile(this.file,L.VSBuffer.fromString(a),v?void 0:h):await this.fileService.createFile(this.file,L.VSBuffer.fromString(a),{overwrite:v})}catch(P){throw P instanceof m.FileOperationError&&P.fileOperationResult===1||P instanceof m.FileOperationError&&P.fileOperationResult===3?new l.UserDataSyncError(P.message,"LocalPreconditionFailed"):P}}onFileChanges(a){!a.contains(this.file)||this.triggerLocalChange()}};i=de([Y(2,m.IFileService),Y(3,u.IEnvironmentService),Y(4,w.IStorageService),Y(5,l.IUserDataSyncStoreService),Y(6,l.IUserDataSyncBackupStoreService),Y(7,l.IUserDataSyncEnablementService),Y(8,y.ITelemetryService),Y(9,l.IUserDataSyncLogService),Y(10,p.IConfigurationService),Y(11,S.IUriIdentityService)],i),e.AbstractFileSynchroniser=i;let t=class extends i{constructor(a,h,v,P,_,O,U,k,M,F,V,N,G){super(a,h,v,P,_,O,U,k,M,F,N,G);this.userDataSyncUtilService=V,this._formattingOptions=void 0}hasErrors(a){const h=[];return(0,R.parse)(a,h,{allowEmptyContent:!0,allowTrailingComma:!0}),h.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};t=de([Y(2,m.IFileService),Y(3,u.IEnvironmentService),Y(4,w.IStorageService),Y(5,l.IUserDataSyncStoreService),Y(6,l.IUserDataSyncBackupStoreService),Y(7,l.IUserDataSyncEnablementService),Y(8,y.ITelemetryService),Y(9,l.IUserDataSyncLogService),Y(10,l.IUserDataSyncUtilService),Y(11,p.IConfigurationService),Y(12,S.IUriIdentityService)],t),e.AbstractJsonFileSynchroniser=t;let o=class{constructor(a,h,v,P,_){this.resource=a,this.environmentService=h,this.logService=v,this.fileService=P,this.extUri=_.extUri,this.lastSyncResource=(0,l.getLastSyncResourceUri)(this.resource,h,this.extUri)}async initialize({ref:a,content:h}){if(!h){this.logService.info("Remote content does not exist.",this.resource);return}const v=this.parseSyncData(h);if(!!v)try{await this.doInitialize({ref:a,syncData:v})}catch(P){this.logService.error(P)}}parseSyncData(a){try{const h=JSON.parse(a);if(r(h))return h}catch(h){this.logService.error(h)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(a,h={}){const v={ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null,...h};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(v)))}};o=de([Y(1,u.IEnvironmentService),Y(2,d.ILogService),Y(3,m.IFileService),Y(4,S.IUriIdentityService)],o),e.AbstractInitializer=o}),define(ne[226],ie([0,1,5,23,9,3,49,26,7,20,15,30,31,63,13,8,24,21,34,47,223,98,25]),function(K,e,D,n,L,T,A,R,b,E,I,C,f,p,u,m,d,g,w,y,S,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function c(o,s){const a=JSON.parse(o.content);if(o.version===1||o.version===2){const h=(await s.getInstalled(0)).filter(v=>v.isBuiltin);for(const v of a)o.version===1&&(v.enabled===!1&&(v.disabled=!0),delete v.enabled),o.version===2&&h.every(P=>!(0,f.areSameExtensions)(P.identifier,v.identifier))&&(v.installed=!0)}return a}let i=class mt extends y.AbstractSynchroniser{constructor(s,a,h,v,P,_,O,U,k,M,F,V,N,G,J){super("extensions",a,s,h,v,P,V,N,k,F,J);this.extensionManagementService=_,this.extensionEnablementService=O,this.ignoredExtensionsManagementService=U,this.extensionGalleryService=M,this.extensionStorageService=G,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.debounce(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,j=>j.some(({local:q})=>!!q)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,j=>!j.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync),()=>{},500)(()=>this.triggerLocalChange()))}async generateSyncPreview(s,a){const h=s.syncData?await c(s.syncData,this.extensionManagementService):null,v=a?.skippedExtensions||[],P=a?.syncData?await c(a.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(void 0,!0),O=this.getLocalExtensions(_),U=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);h?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:k,remote:M}=(0,S.merge)(O,h,P,v,U),F={local:k,remote:M,content:this.getPreviewContent(O,k.added,k.updated,k.removed),localChange:k.added.length>0||k.removed.length>0||k.updated.length>0?2:0,remoteChange:M!==null?2:0};return[{skippedExtensions:v,localResource:this.localResource,localContent:this.stringify(O,!1),localExtensions:O,remoteResource:this.remoteResource,remoteContent:h?this.stringify(h,!1):null,previewResource:this.previewResource,previewResult:F,localChange:F.localChange,remoteChange:F.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const a=s.syncData?await c(s.syncData,this.extensionManagementService):null,h=await this.extensionManagementService.getInstalled(void 0,!0),v=this.getLocalExtensions(h),P=this.ignoredExtensionsManagementService.getIgnoredExtensions(h),{remote:_}=(0,S.merge)(v,a,a,s.skippedExtensions||[],P);return _!==null}getPreviewContent(s,a,h,v){const P=[...a,...h],_=new Set,O=U=>{_.add(U.id.toLowerCase()),U.uuid&&_.add(U.uuid)};P.forEach(({identifier:U})=>O(U)),v.forEach(O);for(const U of s)_.has(U.identifier.id.toLowerCase())||U.identifier.uuid&&_.has(U.identifier.uuid)||P.push(U);return this.stringify(P,!1)}async getMergeResult(s,a){return{...s.previewResult,hasConflicts:!1}}async getAcceptResult(s,a,h,v){if(this.extUri.isEqual(a,this.localResource))return this.acceptLocal(s);if(this.extUri.isEqual(a,this.remoteResource))return this.acceptRemote(s);if(this.extUri.isEqual(a,this.previewResource))return s.previewResult;throw new Error(`Invalid Resource: ${a.toString()}`)}async acceptLocal(s){const a=await this.extensionManagementService.getInstalled(),h=this.ignoredExtensionsManagementService.getIgnoredExtensions(a),v=(0,S.merge)(s.localExtensions,null,null,s.skippedExtensions,h),{local:P,remote:_}=v;return{content:s.localContent,local:P,remote:_,localChange:P.added.length>0||P.removed.length>0||P.updated.length>0?2:0,remoteChange:_!==null?2:0}}async acceptRemote(s){const a=await this.extensionManagementService.getInstalled(),h=this.ignoredExtensionsManagementService.getIgnoredExtensions(a),v=s.remoteContent?JSON.parse(s.remoteContent):null;if(v!==null){const P=(0,S.merge)(s.localExtensions,v,s.localExtensions,[],h),{local:_,remote:O}=P;return{content:s.remoteContent,local:_,remote:O,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:s.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(s,a,h,v){let{skippedExtensions:P,localExtensions:_}=h[0][0],{local:O,remote:U,localChange:k,remoteChange:M}=h[0][1];if(k===0&&M===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),k!==0&&(await this.backupLocal(JSON.stringify(_)),P=await this.updateLocalExtensions(O.added,O.removed,O.updated,P)),U){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const F=JSON.stringify(U.all);s=await this.updateRemoteUserData(F,v?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${U.added.length?` Added: ${JSON.stringify(U.added.map(V=>V.identifier.id))}.`:""}${U.updated.length?` Updated: ${JSON.stringify(U.updated.map(V=>V.identifier.id))}.`:""}${U.removed.length?` Removed: ${JSON.stringify(U.removed.map(V=>V.identifier.id))}.`:""}`)}a?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(s,{skippedExtensions:P}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${P.length?` Skipped: ${JSON.stringify(P.map(F=>F.identifier.id))}.`:""}`))}async getAssociatedResources({uri:s}){return[{resource:this.extUri.joinPath(s,"extensions.json"),comparableResource:mt.EXTENSIONS_DATA_URI}]}async resolveContent(s){if(this.extUri.isEqual(s,mt.EXTENSIONS_DATA_URI)){const h=await this.extensionManagementService.getInstalled(),v=this.ignoredExtensionsManagementService.getIgnoredExtensions(h),P=this.getLocalExtensions(h).filter(_=>!v.some(O=>(0,f.areSameExtensions)({id:O},_.identifier)));return this.stringify(P,!0)}if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s)){const h=await this.resolvePreviewContent(s);return h&&this.stringify(JSON.parse(h),!0)}let a=await super.resolveContent(s);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(s)),a){const h=this.parseSyncData(a);if(h)switch(this.extUri.basename(s)){case"extensions.json":return this.stringify(this.parseExtensions(h),!0)}}return null}stringify(s,a){return s.sort((h,v)=>!h.identifier.uuid&&v.identifier.uuid?-1:h.identifier.uuid&&!v.identifier.uuid?1:(0,R.compare)(h.identifier.id,v.identifier.id)),a?(0,A.toFormattedString)(s,{}):JSON.stringify(s)}async hasLocalData(){try{const s=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(s).some(h=>h.installed||h.disabled))return!0}catch{}return!1}async updateLocalExtensions(s,a,h,v){const P=[],_=[],O=await this.extensionManagementService.getInstalled();if(a.length){const k=O.filter(({identifier:M,isBuiltin:F})=>!F&&a.some(V=>(0,f.areSameExtensions)(M,V)));await D.Promises.settled(k.map(async M=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,M.identifier.id),await this.extensionManagementService.uninstall(M,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,M.identifier.id),P.push(M.identifier)}))}(s.length||h.length)&&await D.Promises.settled([...s,...h].map(async k=>{const M=O.find(V=>(0,f.areSameExtensions)(V.identifier,k.identifier));if(M&&M.isBuiltin){k.state&&M.manifest.version===k.version&&this.updateExtensionState(k.state,M,M.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(N=>(0,f.areSameExtensions)(N,k.identifier))!==!!k.disabled&&(k.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,k.identifier.id),await this.extensionEnablementService.disableExtension(k.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,k.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,k.identifier.id),await this.extensionEnablementService.enableExtension(k.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,k.identifier.id))),P.push(k.identifier);return}const F=(await this.extensionGalleryService.getExtensions([{...k.identifier,preRelease:k.preRelease}],n.CancellationToken.None))[0];if(k.state&&(M?M.manifest.version===k.version:!!F)&&this.updateExtensionState(k.state,M||F,M?.manifest.version),F)try{this.extensionEnablementService.getDisabledExtensions().some(N=>(0,f.areSameExtensions)(N,k.identifier))!==!!k.disabled&&(k.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,k.identifier.id,F.version),await this.extensionEnablementService.disableExtension(F.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,k.identifier.id,F.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,k.identifier.id,F.version),await this.extensionEnablementService.enableExtension(F.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,k.identifier.id,F.version))),(!M||M.preRelease!==k.preRelease)&&(await this.extensionManagementService.canInstall(F)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,k.identifier.id,F.version),await this.extensionManagementService.installFromGallery(F,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:k.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,k.identifier.id,F.version),P.push(F.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,F.displayName||F.identifier.id),_.push(k)))}catch(V){_.push(k),V instanceof C.ExtensionManagementError&&[C.ExtensionManagementErrorCode.Incompatible,C.ExtensionManagementErrorCode.IncompatiblePreRelease,C.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(V.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,F.displayName||F.identifier.id):(this.logService.error(V),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,F.displayName||F.identifier.id))}else _.push(k),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,k.identifier.id)}));const U=[];for(const k of v)P.some(M=>(0,f.areSameExtensions)(M,k.identifier))||U.push(k);for(const k of _)U.some(M=>(0,f.areSameExtensions)(M.identifier,k.identifier))||U.push(k);return U}updateExtensionState(s,a,h){const v=this.extensionStorageService.getExtensionState(a,!0)||{},P=h?this.extensionStorageService.getKeysForSync({id:a.identifier.id,version:h}):void 0;P?P.forEach(_=>{v[_]=s[_]}):Object.keys(s).forEach(_=>v[_]=s[_]),this.extensionStorageService.setExtensionState(a,v,!0)}parseExtensions(s){return JSON.parse(s.content)}getLocalExtensions(s){const a=this.extensionEnablementService.getDisabledExtensions();return s.map(h=>{const{identifier:v,isBuiltin:P,manifest:_,preRelease:O}=h,U={identifier:v,preRelease:O,version:_.version};a.some(k=>(0,f.areSameExtensions)(k,v))&&(U.disabled=!0),P||(U.installed=!0);try{const k=this.extensionStorageService.getKeysForSync({id:v.id,version:_.version});if(k){const M=this.extensionStorageService.getExtensionState(h,!0)||{};U.state=Object.keys(M).reduce((F,V)=>(k.includes(V)&&(F[V]=M[V]),F),{})}}catch(k){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,L.getErrorMessage)(k))}return U})}};i.EXTENSIONS_DATA_URI=b.URI.from({scheme:r.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=de([Y(0,I.IEnvironmentService),Y(1,u.IFileService),Y(2,d.IStorageService),Y(3,r.IUserDataSyncStoreService),Y(4,r.IUserDataSyncBackupStoreService),Y(5,C.IExtensionManagementService),Y(6,C.IGlobalExtensionEnablementService),Y(7,l.IIgnoredExtensionsManagementService),Y(8,r.IUserDataSyncLogService),Y(9,C.IExtensionGalleryService),Y(10,E.IConfigurationService),Y(11,r.IUserDataSyncEnablementService),Y(12,g.ITelemetryService),Y(13,p.IExtensionStorageService),Y(14,w.IUriIdentityService)],i),e.ExtensionsSynchroniser=i;let t=class extends y.AbstractInitializer{constructor(s,a,h,v,P,_){super("extensions",v,P,h,_);this.extensionManagementService=s,this.ignoredExtensionsManagementService=a}async parseExtensions(s){return s.syncData?await c(s.syncData,this.extensionManagementService):null}generatePreview(s,a){const h=[],v=[],P=[];for(const _ of s){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(_.identifier.id))continue;const O=a.find(U=>(0,f.areSameExtensions)(U.identifier,_.identifier));O?(h.push(O),_.disabled&&P.push(_.identifier)):_.installed&&(v.push(_.identifier),_.disabled&&P.push(_.identifier))}return{installedExtensions:h,newExtensions:v,disabledExtensions:P,remoteExtensions:s}}};t=de([Y(0,C.IExtensionManagementService),Y(1,l.IIgnoredExtensionsManagementService),Y(2,u.IFileService),Y(3,I.IEnvironmentService),Y(4,m.ILogService),Y(5,w.IUriIdentityService)],t),e.AbstractExtensionsInitializer=t}),define(ne[227],ie([0,1,28,25]),function(K,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(R,b,E,I,C){if(!b)return{remote:Object.keys(R).length>0?R:null,local:{added:{},removed:[],updated:{}}};const f=T(R,b);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const p=E?T(E,b):{added:Object.keys(b).reduce((w,y)=>(w.add(y),w),new Set),removed:new Set,updated:new Set},u=E?T(E,R):{added:Object.keys(R).reduce((w,y)=>(w.add(y),w),new Set),removed:new Set,updated:new Set},m={added:{},removed:[],updated:{}},d=D.deepClone(b),g=!E;for(const w of u.added.values())w!==n.SYNC_SERVICE_URL_TYPE&&g&&p.added.has(w)||(d[w]=R[w]);for(const w of u.updated.values())d[w]=R[w];for(const w of u.removed.values())I.unregistered.includes(w)||delete d[w];for(const w of p.added.values()){const y=b[w];if(I.machine.includes(w)){C.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(E&&u.added.has(w))continue;const S=R[w];S&&S.value===y.value||w===n.SYNC_SERVICE_URL_TYPE&&g&&u.added.has(w)||(S?m.updated[w]=y:m.added[w]=y)}for(const w of p.updated.values()){const y=b[w];if(I.machine.includes(w)){C.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if(u.updated.has(w)||u.removed.has(w))continue;const S=R[w];S&&S.value===y.value||(m.updated[w]=y)}for(const w of p.removed.values()){if(I.machine.includes(w)){C.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}u.updated.has(w)||u.removed.has(w)||m.removed.push(w)}return{local:m,remote:A(d,b)?null:d}}e.merge=L;function T(R,b){const E=Object.keys(R),I=Object.keys(b),C=I.filter(u=>E.indexOf(u)===-1).reduce((u,m)=>(u.add(m),u),new Set),f=E.filter(u=>I.indexOf(u)===-1).reduce((u,m)=>(u.add(m),u),new Set),p=new Set;for(const u of E){if(f.has(u))continue;const m=R[u],d=b[u];D.equals(m,d)||p.add(u)}return{added:C,removed:f,updated:p}}function A(R,b){const{added:E,removed:I,updated:C}=T(R,b);return E.size===0&&I.size===0&&C.size===0}}),define(ne[228],ie([0,1,17,9,3,35,49,4,7,29,20,15,13,8,46,24,21,34,47,53,227,25]),function(K,e,D,n,L,T,A,R,b,E,I,C,f,p,u,m,d,g,w,y,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const r="globalState.argv.",c=["locale"];function i(h,v){const P=h.storage?Object.keys(h.storage).sort():[],_={};return P.forEach(O=>_[O]=h.storage[O]),h.storage=_,v?(0,A.toFormattedString)(h,{}):JSON.stringify(h)}const t=1;let o=class vt extends w.AbstractSynchroniser{constructor(v,P,_,O,U,k,M,F,V,N){super("globalState",v,U,V,P,_,k,M,O,F,N);this.storageService=V,this.version=t,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(v.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(v.onDidFilesChange,G=>G.contains(this.environmentService.argvResource)),L.Event.filter(V.onDidChangeValue,G=>G.scope===0&&G.target!==void 0?G.target===0:V.keys(0,0).includes(G.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(v,P,_){const O=v.syncData?JSON.parse(v.syncData.content):null;P=P===null&&_?v:P;const U=P&&P.syncData?JSON.parse(P.syncData.content):null,k=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const M=this.getStorageKeys(U),{local:F,remote:V}=(0,S.merge)(k.storage,O?O.storage:null,U?U.storage:null,M,this.logService),N={content:null,local:F,remote:V,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:V!==null?2:0};return[{localResource:this.localResource,localContent:i(k,!1),localUserData:k,remoteResource:this.remoteResource,remoteContent:O?i(O,!1):null,previewResource:this.previewResource,previewResult:N,localChange:N.localChange,remoteChange:N.remoteChange,acceptedResource:this.acceptedResource,storageKeys:M}]}async hasRemoteChanged(v){const P=v.syncData?JSON.parse(v.syncData.content):null;if(P===null)return!0;const _=await this.getLocalGlobalState(),O=this.getStorageKeys(P),{remote:U}=(0,S.merge)(_.storage,P.storage,P.storage,O,this.logService);return U!==null}async getMergeResult(v,P){return{...v.previewResult,hasConflicts:!1}}async getAcceptResult(v,P,_,O){if(this.extUri.isEqual(P,this.localResource))return this.acceptLocal(v);if(this.extUri.isEqual(P,this.remoteResource))return this.acceptRemote(v);if(this.extUri.isEqual(P,this.previewResource))return v.previewResult;throw new Error(`Invalid Resource: ${P.toString()}`)}async acceptLocal(v){return{content:v.localContent,local:{added:{},removed:[],updated:{}},remote:v.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(v){if(v.remoteContent!==null){const P=JSON.parse(v.remoteContent),{local:_,remote:O}=(0,S.merge)(v.localUserData.storage,P.storage,null,v.storageKeys,this.logService);return{content:v.remoteContent,local:_,remote:O,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:v.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(v,P,_,O){let{localUserData:U}=_[0][0],{local:k,remote:M,localChange:F,remoteChange:V}=_[0][1];if(F===0&&V===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),F!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(U)),await this.writeLocalGlobalState(k),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),V!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const N=JSON.stringify({storage:M});v=await this.updateRemoteUserData(N,O?null:v.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}P?.ref!==v.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(v),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:v}){return[{resource:this.extUri.joinPath(v,"globalState.json"),comparableResource:vt.GLOBAL_STATE_DATA_URI}]}async resolveContent(v){if(this.extUri.isEqual(v,vt.GLOBAL_STATE_DATA_URI)){const _=await this.getLocalGlobalState();return i(_,!0)}if(this.extUri.isEqual(this.remoteResource,v)||this.extUri.isEqual(this.localResource,v)||this.extUri.isEqual(this.acceptedResource,v)){const _=await this.resolvePreviewContent(v);return _&&i(JSON.parse(_),!0)}let P=await super.resolveContent(v);if(P)return P;if(P=await super.resolveContent(this.extUri.dirname(v)),P){const _=this.parseSyncData(P);if(_)switch(this.extUri.basename(v)){case"globalState.json":return i(JSON.parse(_.content),!0)}}return null}async hasLocalData(){try{const{storage:v}=await this.getLocalGlobalState();if(Object.keys(v).length>1||v[`${r}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const v={},P=await this.getLocalArgvContent(),_=(0,T.parse)(P);for(const O of c)_[O]!==void 0&&(v[`${r}${O}`]={version:1,value:_[O]});for(const O of this.storageService.keys(0,0)){const U=this.storageService.get(O,0);U&&(v[O]={version:1,value:U})}return{storage:v}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const v=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),v.value.toString()}catch(v){this.logService.debug((0,n.getErrorMessage)(v))}return"{}"}async writeLocalGlobalState({added:v,removed:P,updated:_}){const O={},U={},k=(F,V)=>{for(const N of F){if(N.startsWith(r)){O[N.substring(r.length)]=V?V[N].value:void 0;continue}if(V){const G=V[N];G.value!==String(this.storageService.get(N,0))&&(U[N]=G.value)}else this.storageService.get(N,0)!==void 0&&(U[N]=void 0)}};if(k(Object.keys(v),v),k(Object.keys(_),_),k(P),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(U).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const F of Object.keys(U))this.storageService.store(F,U[F],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(U))}}async updateArgv(v){const P=await this.getLocalArgvContent();let _=P;for(const O of Object.keys(v))_=(0,y.edit)(_,[O],v[O],{});P!==_&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(_)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(v){const P=this.storageService.keys(0,0),_=this.storageService.keys(0,1),O=[...P,..._],U=v?.storage?Object.keys(v.storage).filter(k=>!k.startsWith(r)&&!O.includes(k)&&this.storageService.get(k,0)!==void 0):[];if(!R.isWeb){const k=[...l.ALL_SYNC_RESOURCES.map(M=>(0,l.getEnablementKey)(M)),l.SYNC_SERVICE_URL_TYPE];U.push(...k),_.push(...k)}return{user:P,machine:_,unregistered:U}}};o.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),o=de([Y(0,f.IFileService),Y(1,l.IUserDataSyncStoreService),Y(2,l.IUserDataSyncBackupStoreService),Y(3,l.IUserDataSyncLogService),Y(4,C.IEnvironmentService),Y(5,l.IUserDataSyncEnablementService),Y(6,d.ITelemetryService),Y(7,I.IConfigurationService),Y(8,m.IStorageService),Y(9,g.IUriIdentityService)],o),e.GlobalStateSynchroniser=o;let s=class extends w.AbstractInitializer{constructor(v,P,_,O,U){super("globalState",_,O,P,U);this.storageService=v}async doInitialize(v){const P=v.syncData?JSON.parse(v.syncData.content):null;if(!P){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const _={},O={};for(const U of Object.keys(P.storage))U.startsWith(r)?_[U.substring(r.length)]=P.storage[U].value:this.storageService.get(U,0)===void 0&&(O[U]=P.storage[U].value);if(Object.keys(_).length){let U="{}";try{U=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const k of Object.keys(_))U=(0,y.edit)(U,[k],_[k],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(U))}if(Object.keys(O).length)for(const U of Object.keys(O))this.storageService.store(U,O[U],0,0)}};s=de([Y(0,m.IStorageService),Y(1,f.IFileService),Y(2,C.IEnvironmentService),Y(3,l.IUserDataSyncLogService),Y(4,g.IUriIdentityService)],s),e.GlobalStateInitializer=s;let a=class{constructor(v,P,_,O,U){this.userDataSyncStoreClient=v,this.storageService=P,this.environmentService=_,this.fileService=O,this.logService=U}getSyncStoreType(v){return this.parseGlobalState(v)?.storage[l.SYNC_SERVICE_URL_TYPE]?.value}async sync(v){const P=(0,l.createSyncHeaders)((0,E.generateUuid)());try{return await this.doSync(v,P)}catch(_){if(_ instanceof l.UserDataSyncError)switch(_.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(v,P)}throw _}}async doSync(v,P){const _=await this.userDataSyncStoreClient.read("globalState",null,P),O=this.parseGlobalState(_)||{storage:{}};O.storage[l.SYNC_SERVICE_URL_TYPE]={value:v,version:t};const U=await(0,u.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),k={version:t,machineId:U,content:i(O,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(k),_.ref,P)}parseGlobalState({content:v}){if(!v)return null;const P=JSON.parse(v);if((0,w.isSyncData)(P))return P?JSON.parse(P.content):null;throw new Error("Invalid remote data")}};a=de([Y(1,m.IStorageService),Y(2,C.IEnvironmentService),Y(3,f.IFileService),Y(4,p.ILogService)],a),e.UserDataSyncStoreTypeSynchronizer=a}),define(ne[229],ie([0,1,16,17,3,35,4,14,144,20,15,13,24,21,34,47,224,25]),function(K,e,D,n,L,T,A,R,b,E,I,C,f,p,u,m,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function w(l,r,c){try{const i=JSON.parse(l);if(!r)return(0,R.isUndefined)(i.all)?null:i.all;switch(A.OS){case 2:return(0,R.isUndefined)(i.mac)?null:i.mac;case 3:return(0,R.isUndefined)(i.linux)?null:i.linux;case 1:return(0,R.isUndefined)(i.windows)?null:i.windows}}catch(i){return c.error(i),null}}e.getKeybindingsContentFromSyncContent=w;let y=class extends m.AbstractJsonFileSynchroniser{constructor(r,c,i,t,o,s,a,h,v,P,_){super(a.keybindingsResource,"keybindings",s,a,h,r,c,o,P,i,v,t,_);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.filter(t.onDidChangeConfiguration,O=>O.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,c,i,t){const o=r.syncData?w(r.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;c=c===null&&i?r:c;const s=c?this.getKeybindingsContentFromLastSyncUserData(c):null,a=await this.getLocalFileContent(),h=await this.getFormattingOptions();let v=null,P=!1,_=!1,O=!1;if(o){let k=a?a.value.toString():"[]";if(k=k||"[]",this.hasErrors(k))throw new g.UserDataSyncError((0,b.localize)(0,null),"LocalInvalidContent",this.resource);if(!s||s!==k||s!==o){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const M=await(0,d.merge)(k,o,s,h,this.userDataSyncUtilService);M.hasChanges&&(v=M.mergeContent,O=M.hasConflicts,P=O||M.mergeContent!==k,_=O||M.mergeContent!==o)}}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),v=a.value.toString(),_=!0);const U={content:v,localChange:P?a?2:1:0,remoteChange:_?2:0,hasConflicts:O};return[{fileContent:a,localResource:this.localResource,localContent:a?a.value.toString():null,localChange:U.localChange,remoteResource:this.remoteResource,remoteContent:o,remoteChange:U.remoteChange,previewResource:this.previewResource,previewResult:U,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const c=this.getKeybindingsContentFromLastSyncUserData(r);if(c===null)return!0;const i=await this.getLocalFileContent(),t=i?i.value.toString():"",o=await this.getFormattingOptions(),s=await(0,d.merge)(t||"[]",c,c,o,this.userDataSyncUtilService);return s.hasConflicts||s.mergeContent!==c}async getMergeResult(r,c){return r.previewResult}async getAcceptResult(r,c,i,t){if(this.extUri.isEqual(c,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(c,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(c,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async applyResult(r,c,i,t){const{fileContent:o}=i[0][0];let{content:s,localChange:a,remoteChange:h}=i[0][1];if(a===0&&h===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),s!==null&&(s=s.trim(),s=s||"[]",this.hasErrors(s)))throw new g.UserDataSyncError((0,b.localize)(1,null),"LocalInvalidContent",this.resource);if(a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),o&&await this.backupLocal(this.toSyncContent(o.value.toString())),await this.updateLocalFileContent(s||"[]",o,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),h!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const v=this.toSyncContent(s||"[]",r.syncData?.content);r=await this.updateRemoteUserData(v,t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}c?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const c=(0,T.parse)(r.value.toString());if((0,D.isNonEmptyArray)(c))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const c=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:c}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let c=await super.resolveContent(r);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(r)),c){const i=this.parseSyncData(c);if(i)switch(this.extUri.basename(r)){case"keybindings.json":return w(i.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:w(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,c){let i={};try{i=JSON.parse(c||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=r,A.OS){case 2:i.mac=r;break;case 3:i.linux=r;break;case 1:i.windows=r;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};y=de([Y(0,g.IUserDataSyncStoreService),Y(1,g.IUserDataSyncBackupStoreService),Y(2,g.IUserDataSyncLogService),Y(3,E.IConfigurationService),Y(4,g.IUserDataSyncEnablementService),Y(5,C.IFileService),Y(6,I.IEnvironmentService),Y(7,f.IStorageService),Y(8,g.IUserDataSyncUtilService),Y(9,p.ITelemetryService),Y(10,u.IUriIdentityService)],y),e.KeybindingsSynchroniser=y;let S=class extends m.AbstractInitializer{constructor(r,c,i,t){super("keybindings",c,i,r,t)}async doInitialize(r){const c=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!c){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,n.VSBuffer.fromString(c)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource),c=(0,T.parse)(r.value.toString());return!(0,D.isNonEmptyArray)(c)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return w(r,!0,this.logService)}catch(c){return this.logService.error(c),null}}};S=de([Y(0,C.IFileService),Y(1,I.IEnvironmentService),Y(2,g.IUserDataSyncLogService),Y(3,u.IUriIdentityService)],S),e.KeybindingsInitializer=S}),define(ne[230],ie([0,1,16,35,69,49,28,53,25]),function(K,e,D,n,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function E(s,a,h){let v=[];h?v=C(h):v=I(a);const P=[],_=[...(0,b.getDisallowedIgnoredSettings)()];if(Array.isArray(v))for(const O of v)O.startsWith("-")?_.push(O.substring(1)):P.push(O);return(0,D.distinct)([...s,...P].filter(O=>_.indexOf(O)===-1))}e.getIgnoredSettings=E;function I(s){let a=s.inspect("settingsSync.ignoredSettings").userValue;return a!==void 0||(a=s.inspect("sync.ignoredSettings").userValue,a!==void 0)?a:s.getValue("settingsSync.ignoredSettings")||[]}function C(s){const a=(0,n.parse)(s);return a?a["settingsSync.ignoredSettings"]||a["sync.ignoredSettings"]||[]:[]}function f(s,a,h,v){if(h.length){const P=o(a),_=(0,n.parse)(a),O=(0,n.parse)(s),U=[];for(const k of h){const M=_[k],F=O[k];M===void 0?s=R.edit(s,[k],void 0,v):F!==void 0?s=R.edit(s,[k],M,v):U.push(l(k,P))}U.sort((k,M)=>k.startOffset-M.startOffset),U.forEach(k=>s=g(k.setting.key,a,s,v))}return s}e.updateIgnoredSettings=f;function p(s,a,h,v,P,_){const O=f(s,a,v,_),U=h!==O,k=h!==a;if(!U&&!k)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(U&&!k)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(k&&!U)return{conflictsSettings:[],localContent:f(a,s,v,_),remoteContent:null,hasConflicts:!1};if(h===null&&m(s)){const z=u(s,a,v)?null:f(a,s,v,_);return{conflictsSettings:[],localContent:z,remoteContent:null,hasConflicts:!1}}let M=s,F=a;const V=(0,n.parse)(s),N=(0,n.parse)(a),G=h?(0,n.parse)(h):null,J=v.reduce((z,B)=>(z.add(B),z),new Set),j=d(V,N,J),q=d(G,V,J),X=d(G,N,J),H=new Map,Z=new Set,ee=z=>{Z.add(z);const B=P.filter(({key:te})=>te===z)[0];B?(M=R.edit(M,[z],B.value,_),F=R.edit(F,[z],B.value,_)):H.set(z,{key:z,localValue:V[z],remoteValue:N[z]})};for(const z of q.removed.values())X.updated.has(z)?ee(z):F=R.edit(F,[z],void 0,_);for(const z of X.removed.values())Z.has(z)||(q.updated.has(z)?ee(z):M=R.edit(M,[z],void 0,_));for(const z of q.updated.values())Z.has(z)||(X.updated.has(z)?j.updated.has(z)&&ee(z):F=R.edit(F,[z],V[z],_));for(const z of X.updated.values())Z.has(z)||(q.updated.has(z)?j.updated.has(z)&&ee(z):M=R.edit(M,[z],N[z],_));for(const z of q.added.values())Z.has(z)||(X.added.has(z)?j.updated.has(z)&&ee(z):F=g(z,M,F,_));for(const z of X.added.values())Z.has(z)||(q.added.has(z)?j.updated.has(z)&&ee(z):M=g(z,F,M,_));const W=H.size>0||!u(M,F,v),$=W||!u(M,s,[]),x=W||!u(F,a,[]);return{localContent:$?M:null,remoteContent:x?F:null,conflictsSettings:[...H.values()],hasConflicts:W}}e.merge=p;function u(s,a,h){if(s===a)return!0;const v=(0,n.parse)(s),P=(0,n.parse)(a),_=h.reduce((k,M)=>(k.add(M),k),new Set),O=o(s).filter(k=>!(k.setting&&_.has(k.setting.key))),U=o(a).filter(k=>!(k.setting&&_.has(k.setting.key)));if(O.length!==U.length)return!1;for(let k=0;k<O.length;k++){const M=O[k],F=U[k];if(M.setting&&F.setting){if(M.setting.key!==F.setting.key||!A.equals(v[M.setting.key],P[M.setting.key]))return!1}else if(!M.setting&&!F.setting){if(M.value!==F.value)return!1}else return!1}return!0}e.areSame=u;function m(s){return s?o(s).length===0:!0}e.isEmpty=m;function d(s,a,h){const v=s?Object.keys(s).filter(k=>!h.has(k)):[],P=Object.keys(a).filter(k=>!h.has(k)),_=P.filter(k=>v.indexOf(k)===-1).reduce((k,M)=>(k.add(M),k),new Set),O=v.filter(k=>P.indexOf(k)===-1).reduce((k,M)=>(k.add(M),k),new Set),U=new Set;if(s)for(const k of v){if(O.has(k))continue;const M=s[k],F=a[k];A.equals(M,F)||U.add(k)}return{added:_,removed:O,updated:U}}function g(s,a,h,v){const P=(0,n.parse)(a),_=o(a),O=o(h),U=w(s,_,O);return y(h,s,P[s],U,O,v)}e.addSetting=g;function w(s,a,h){const v=a.findIndex(_=>_.setting?.key===s),P=a[v-1];if(P){if(P.setting){const O=l(P.setting.key,h);if(O)return{index:h.indexOf(O),insertAfter:!0}}else{const O=r(v,a);if(O){const U=l(O.setting.key,h);if(U){const k=c(h.indexOf(U),h),M=i(a,O,a[v]);if(k){const F=i(h,U,k),V=t(M,F);return V?{index:h.indexOf(V),insertAfter:!0}:{index:h.indexOf(k),insertAfter:!1}}else{const F=i(h,U,h[h.length-1]),V=t(M,F);return V?{index:h.indexOf(V),insertAfter:!0}:{index:h.length-1,insertAfter:!0}}}}}const _=a[v+1];if(_)if(_.setting){const O=l(_.setting.key,h);if(O)return{index:h.indexOf(O),insertAfter:!1}}else{const O=c(v,a);if(O){const U=l(O.setting.key,h);if(U){const k=r(h.indexOf(U),h),M=i(a,a[v],O);if(k){const F=i(h,k,U),V=t(M.reverse(),F.reverse());return V?{index:h.indexOf(V),insertAfter:!1}:{index:h.indexOf(k),insertAfter:!0}}else{const F=i(h,h[0],U),V=t(M.reverse(),F.reverse());return V?{index:h.indexOf(V),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:h.length-1,insertAfter:!0}}function y(s,a,h,v,P,_){let O;return v.index===-1?O=(0,L.setProperty)(s,[a],h,_):O=S(s,a,h,v,P,_).map(U=>(0,L.withFormatting)(s,U,_)[0]),(0,L.applyEdits)(s,O)}function S(s,a,h,v,P,_){const O=`${JSON.stringify(a)}: ${JSON.stringify(h)}`,U=(0,T.getEOL)(_,s),k=P[v.index];if(v.insertAfter){const M=[];if(k.setting)M.push({offset:k.endOffset,length:0,content:","+O});else{const F=c(v.index,P),V=r(v.index,P),N=V?.setting?.commaOffset;V&&N===void 0&&M.push({offset:V.endOffset,length:0,content:","});const G=N!==void 0&&N>k.endOffset;M.push({offset:G?N+1:k.endOffset,length:0,content:F?U+O+",":U+O})}return M}else{if(k.setting)return[{offset:k.startOffset,length:0,content:O+","}];const M=(P[v.index-1]&&!P[v.index-1].setting?U:"")+O+(c(v.index,P)?",":"")+U;return[{offset:k.startOffset,length:0,content:M}]}}function l(s,a){return a.filter(h=>h.setting?.key===s)[0]}function r(s,a){for(let h=s-1;h>=0;h--)if(a[h].setting)return a[h]}function c(s,a){for(let h=s+1;h<a.length;h++)if(a[h].setting)return a[h]}function i(s,a,h){const v=s.indexOf(a),P=s.indexOf(h);return s.filter((_,O)=>v<O&&O<P)}function t(s,a){if(s.length&&a.length){let h=0;for(;h<a.length&&h<s.length;h++)if(s[h].value!==a[h].value)return a[h-1];return a[h-1]}}function o(s){const a=[];let h=-1,v,P;const _={onObjectBegin:O=>{h++},onObjectProperty:(O,U,k)=>{h===0&&(v=U,P=O)},onObjectEnd:(O,U)=>{h--,h===0&&a.push({startOffset:v,endOffset:O+U,value:s.substring(v,O+U),setting:{key:P,commaOffset:void 0}})},onArrayBegin:(O,U)=>{h++},onArrayEnd:(O,U)=>{h--,h===0&&a.push({startOffset:v,endOffset:O+U,value:s.substring(v,O+U),setting:{key:P,commaOffset:void 0}})},onLiteralValue:(O,U,k)=>{h===0&&a.push({startOffset:v,endOffset:U+k,value:s.substring(v,U+k),setting:{key:P,commaOffset:void 0}})},onSeparator:(O,U,k)=>{if(h===0&&O===","){let M=a.length-1;for(;M>=0&&!a[M].setting;M--);const F=a[M];F&&a.splice(M,1,{startOffset:F.startOffset,endOffset:F.endOffset,value:F.value,setting:{key:F.setting.key,commaOffset:U}})}},onComment:(O,U)=>{h===0&&a.push({startOffset:O,endOffset:O+U,value:s.substring(O,O+U)})}};return(0,n.visit)(s,_),a}}),define(ne[231],ie([0,1,17,3,145,20,89,15,30,13,24,21,34,47,53,230,25]),function(K,e,D,n,L,T,A,R,b,E,I,C,f,p,u,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function g(l){return l&&l.settings&&typeof l.settings=="string"&&Object.keys(l).length===1}function w(l){const r=JSON.parse(l);return g(r)?r:{settings:l}}e.parseSettingsSyncContent=w;let y=class extends p.AbstractJsonFileSynchroniser{constructor(r,c,i,t,o,s,a,h,v,P,_,O){super(c.settingsResource,"settings",r,c,i,t,o,v,P,s,a,h,O);this.extensionManagementService=_,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(r){const c=await this.getLastSyncUserData(),i=await this.getLatestRemoteUserData(r,c),t=this.getSettingsSyncContent(i),o=new A.ConfigurationModelParser(d.USER_DATA_SYNC_CONFIGURATION_SCOPE);return t?.settings&&o.parse(t.settings),o.configurationModel.getValue(d.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(r,c,i){const t=await this.getLocalFileContent(),o=await this.getFormattingOptions(),s=this.getSettingsSyncContent(r);c=c===null&&i?r:c;const a=c?this.getSettingsSyncContent(c):null,h=await this.getIgnoredSettings();let v=null,P=!1,_=!1,O=!1;if(s){let k=t?t.value.toString().trim():"{}";k=k||"{}",this.validateContent(k),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const M=(0,m.merge)(k,s.settings,a?a.settings:null,h,[],o);v=M.localContent||M.remoteContent,P=M.localContent!==null,_=M.remoteContent!==null,O=M.hasConflicts}else t&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),v=t.value.toString(),_=!0);const U={content:v,localChange:P?2:0,remoteChange:_?2:0,hasConflicts:O};return[{fileContent:t,localResource:this.localResource,localContent:t?t.value.toString():null,localChange:U.localChange,remoteResource:this.remoteResource,remoteContent:s?s.settings:null,remoteChange:U.remoteChange,previewResource:this.previewResource,previewResult:U,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const c=this.getSettingsSyncContent(r);if(c===null)return!0;const i=await this.getLocalFileContent(),t=i?i.value.toString().trim():"",o=await this.getIgnoredSettings(),s=await this.getFormattingOptions();return(0,m.merge)(t||"{}",c.settings,c.settings,o,[],s).remoteContent!==null}async getMergeResult(r,c){const i=await this.getFormattingOptions(),t=await this.getIgnoredSettings();return{...r.previewResult,content:r.previewResult.content?(0,m.updateIgnoredSettings)(r.previewResult.content,"{}",t,i):null}}async getAcceptResult(r,c,i,t){const o=await this.getFormattingOptions(),s=await this.getIgnoredSettings();if(this.extUri.isEqual(c,this.localResource))return{content:r.fileContent?(0,m.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",s,o):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(c,this.remoteResource))return{content:r.remoteContent!==null?(0,m.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",s,o):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(c,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i!==null?(0,m.updateIgnoredSettings)(i,r.fileContent?r.fileContent.value.toString():"{}",s,o):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async applyResult(r,c,i,t){const{fileContent:o}=i[0][0];let{content:s,localChange:a,remoteChange:h}=i[0][1];if(a===0&&h===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),s=s?s.trim():"{}",s=s||"{}",this.validateContent(s),a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),o&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(o.value.toString()))),await this.updateLocalFileContent(s,o,t),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),h!==0){const v=await this.getFormattingOptions(),P=this.getSettingsSyncContent(r),_=await this.getIgnoredSettings(s);s=(0,m.updateIgnoredSettings)(s,P?P.settings:"{}",_,v),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),r=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(s)),t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}c?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(r),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const c=await this.getFormattingOptions(),i=(0,u.edit)(r.value.toString(),[d.CONFIGURATION_SYNC_STORE_KEY],void 0,c);return!(0,m.isEmpty)(i)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const c=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"settings.json"),comparableResource:c}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let c=await super.resolveContent(r);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(r)),c){const i=this.parseSyncData(c);if(i){const t=this.parseSettingsSyncContent(i.content);if(t)switch(this.extUri.basename(r)){case"settings.json":return t.settings}}}return null}async resolvePreviewContent(r){let c=await super.resolvePreviewContent(r);if(c){const i=await this.getFormattingOptions(),t=await this.getIgnoredSettings();c=(0,m.updateIgnoredSettings)(c,"{}",t,i)}return c}getSettingsSyncContent(r){return r.syncData?this.parseSettingsSyncContent(r.syncData.content):null}parseSettingsSyncContent(r){try{return w(r)}catch(c){this.logService.error(c)}return null}toSettingsSyncContent(r){return{settings:r}}async getIgnoredSettings(r){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=n.Event.any(n.Event.filter(this.extensionManagementService.onDidInstallExtensions,t=>t.some(({local:o})=>!!o)),n.Event.filter(this.extensionManagementService.onDidUninstallExtension,t=>!t.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const c=await this._defaultIgnoredSettings;return(0,m.getIgnoredSettings)(c,this.configurationService,r)}validateContent(r){if(this.hasErrors(r))throw new d.UserDataSyncError((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};y=de([Y(0,E.IFileService),Y(1,R.IEnvironmentService),Y(2,I.IStorageService),Y(3,d.IUserDataSyncStoreService),Y(4,d.IUserDataSyncBackupStoreService),Y(5,d.IUserDataSyncLogService),Y(6,d.IUserDataSyncUtilService),Y(7,T.IConfigurationService),Y(8,d.IUserDataSyncEnablementService),Y(9,C.ITelemetryService),Y(10,b.IExtensionManagementService),Y(11,f.IUriIdentityService)],y),e.SettingsSynchroniser=y;let S=class extends p.AbstractInitializer{constructor(r,c,i,t){super("settings",c,i,r,t)}async doInitialize(r){const c=r.syncData?this.parseSettingsSyncContent(r.syncData.content):null;if(!c){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(c.settings)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource);return(0,m.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}parseSettingsSyncContent(r){try{return w(r)}catch(c){this.logService.error(c)}return null}};S=de([Y(0,E.IFileService),Y(1,R.IEnvironmentService),Y(2,d.IUserDataSyncLogService),Y(3,f.IUriIdentityService)],S),e.SettingsInitializer=S}),define(ne[232],ie([0,1,17,3,28,20,15,13,24,21,34,47,225,25]),function(K,e,D,n,L,T,A,R,b,E,I,C,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let u=class extends C.AbstractSynchroniser{constructor(g,w,y,S,l,r,c,i,t,o){super("snippets",w,g,y,S,l,i,t,r,c,o);this.version=1,this.snippetsFolder=g.snippetsHome,this._register(this.fileService.watch(g.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(n.Event.filter(this.fileService.onDidFilesChange,s=>s.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(g,w,y){const S=await this.getSnippetsFileContents(),l=this.toSnippetsContents(S),r=g.syncData?this.parseSnippets(g.syncData):null;w=w===null&&y?g:w;const c=w&&w.syncData?this.parseSnippets(w.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,f.merge)(l,r,c);return this.getResourcePreviews(i,S,r||{})}async hasRemoteChanged(g){const w=g.syncData?this.parseSnippets(g.syncData):null;if(w===null)return!0;const y=await this.getSnippetsFileContents(),S=this.toSnippetsContents(y),l=(0,f.merge)(S,w,w);return Object.keys(l.remote.added).length>0||Object.keys(l.remote.updated).length>0||l.remote.removed.length>0||l.conflicts.length>0}async getMergeResult(g,w){return g.previewResult}async getAcceptResult(g,w,y,S){if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder))return y===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:y,localChange:y===null?g.fileContent!==null?3:0:2,remoteChange:y===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async applyResult(g,w,y,S){const l=y.map(([r,c])=>({...r,acceptResult:c}));l.every(({localChange:r,remoteChange:c})=>r===0&&c===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),l.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(l),await this.updateLocalSnippets(l,S)),l.some(({remoteChange:r})=>r!==0)&&(g=await this.updateRemoteSnippets(l,g,S)),w?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of l)try{await this.fileService.del(r)}catch{}}getResourcePreviews(g,w,y){const S=new Map;for(const l of Object.keys(g.local.added)){const r={content:g.local.added[l],hasConflicts:!1,localChange:1,remoteChange:0};S.set(l,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(g.local.updated)){const r={content:g.local.updated[l],hasConflicts:!1,localChange:2,remoteChange:0};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of g.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(g.remote.added)){const r={content:g.remote.added[l],hasConflicts:!1,localChange:0,remoteChange:1};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(g.remote.updated)){const r={content:g.remote.updated[l],hasConflicts:!1,localChange:0,remoteChange:2};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of g.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of g.conflicts){const r={content:w[l]?w[l].value.toString():null,hasConflicts:!0,localChange:w[l]?2:1,remoteChange:y[l]?2:1};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(w))if(!S.has(l)){const r={content:w[l]?w[l].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...S.values()]}async getAssociatedResources({uri:g}){let w=await super.resolveContent(g);if(w){const y=this.parseSyncData(w);if(y){const S=this.parseSnippets(y),l=[];for(const r of Object.keys(S)){const c=this.extUri.joinPath(g,r),i=this.extUri.joinPath(this.snippetsFolder,r),t=await this.fileService.exists(i);l.push({resource:c,comparableResource:t?i:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})})}return l}}return[]}async resolveContent(g){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(g);let w=await super.resolveContent(g);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(g)),w){const y=this.parseSyncData(w);if(y)return this.parseSnippets(y)[this.extUri.basename(g)]||null}return null}async hasLocalData(){try{const g=await this.getSnippetsFileContents();if(Object.keys(g).length)return!0}catch{}return!1}async updateLocalBackup(g){const w={};for(const y of g)y.fileContent&&(w[this.extUri.basename(y.localResource)]=y.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(w)))}async updateLocalSnippets(g,w){for(const{fileContent:y,acceptResult:S,localResource:l,remoteResource:r,localChange:c}of g)if(c!==0){const i=r?this.extUri.basename(r):this.extUri.basename(l),t=this.extUri.joinPath(this.snippetsFolder,i);c===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(t)),await this.fileService.del(t),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(t))):c===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(t)),await this.fileService.createFile(t,D.VSBuffer.fromString(S.content),{overwrite:w}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(t))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(t)),await this.fileService.writeFile(t,D.VSBuffer.fromString(S.content),w?void 0:y),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(t)))}}async updateRemoteSnippets(g,w,y){const S=w.syncData?this.parseSnippets(w.syncData):{},l=(0,L.deepClone)(S);for(const{acceptResult:r,localResource:c,remoteResource:i,remoteChange:t}of g)if(t!==0){const o=c?this.extUri.basename(c):this.extUri.basename(i);t===3?delete l[o]:l[o]=r.content}return(0,f.areSame)(S,l)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),w=await this.updateRemoteUserData(JSON.stringify(l),y?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),w}parseSnippets(g){return JSON.parse(g.content)}toSnippetsContents(g){const w={};for(const y of Object.keys(g))w[y]=g[y].value.toString();return w}async getSnippetsFileContents(){const g={};let w;try{w=await this.fileService.resolve(this.snippetsFolder)}catch(y){if(y instanceof R.FileOperationError&&y.fileOperationResult===1)return g;throw y}for(const y of w.children||[]){const S=y.resource,l=this.extUri.extname(S);if(l===".json"||l===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,S),c=await this.fileService.readFile(S);g[r]=c}}return g}};u=de([Y(0,A.IEnvironmentService),Y(1,R.IFileService),Y(2,b.IStorageService),Y(3,p.IUserDataSyncStoreService),Y(4,p.IUserDataSyncBackupStoreService),Y(5,p.IUserDataSyncLogService),Y(6,T.IConfigurationService),Y(7,p.IUserDataSyncEnablementService),Y(8,E.ITelemetryService),Y(9,I.IUriIdentityService)],u),e.SnippetsSynchroniser=u;let m=class extends C.AbstractInitializer{constructor(g,w,y,S){super("snippets",w,y,g,S)}async doInitialize(g){const w=g.syncData?JSON.parse(g.syncData.content):null;if(!w){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const S of Object.keys(w)){const l=w[S];if(l){const r=this.extUri.joinPath(this.environmentService.snippetsHome,S);await this.fileService.createFile(r,D.VSBuffer.fromString(l)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(g)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};m=de([Y(0,R.IFileService),Y(1,A.IEnvironmentService),Y(2,p.IUserDataSyncLogService),Y(3,I.IUriIdentityService)],m),e.SnippetsInitializer=m}),define(ne[64],ie([0,1,3,2,6,25]),function(K,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,L.createDecorator)("IUserDataSyncAccountService");let A=class extends n.Disposable{constructor(b,E){super();this.userDataSyncStoreService=b,this.logService=E,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(b.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(b.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(b){(b&&this._account?b.token!==this._account.token||b.authenticationProviderId!==this._account.authenticationProviderId:b!==this._account)&&(this._account=b,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(b))}};A=de([Y(0,T.IUserDataSyncStoreService),Y(1,T.IUserDataSyncLogService)],A),e.UserDataSyncAccountService=A}),define(ne[233],ie([0,1,5,17,57,2,19,20,15,13,25]),function(K,e,D,n,L,T,A,R,b,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let C=class extends T.Disposable{constructor(p,u,m,d){super();this.environmentService=p,this.fileService=u,this.configurationService=m,this.logService=d,I.ALL_SYNC_RESOURCES.forEach(g=>this.cleanUpBackup(g))}async getAllRefs(p){const u=(0,A.joinPath)(this.environmentService.userDataSyncHome,p),m=await this.fileService.resolve(u);return m.children?m.children.filter(g=>g.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(g.name)).sort().reverse().map(g=>({ref:g.name,created:this.getCreationTime(g)})):[]}async resolveContent(p,u){if(!u){const m=await this.getAllRefs(p);m.length&&(u=m[m.length-1].ref)}if(u){const m=(0,A.joinPath)(this.environmentService.userDataSyncHome,p,u);return(await this.fileService.readFile(m)).value.toString()}return null}async backup(p,u){const m=(0,A.joinPath)(this.environmentService.userDataSyncHome,p),d=(0,A.joinPath)(m,`${(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(d,n.VSBuffer.fromString(u))}catch(g){this.logService.error(g)}try{this.cleanUpBackup(p)}catch{}}async cleanUpBackup(p){const u=(0,A.joinPath)(this.environmentService.userDataSyncHome,p);try{try{if(!await this.fileService.exists(u))return}catch{return}const m=await this.fileService.resolve(u);if(m.children){const d=m.children.filter(S=>S.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(S.name)).sort(),g=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let w=d.filter(S=>Date.now()-this.getCreationTime(S)>g);const y=d.length-w.length;y<10&&(w=w.slice(10-y)),await D.Promises.settled(w.map(async S=>{this.logService.info("Deleting from backup",S.resource.path),await this.fileService.del(S.resource)}))}}catch(m){this.logService.error(m)}}getCreationTime(p){return p.ctime||new Date(parseInt(p.name.substring(0,4)),parseInt(p.name.substring(4,6))-1,parseInt(p.name.substring(6,8)),parseInt(p.name.substring(9,11)),parseInt(p.name.substring(11,13)),parseInt(p.name.substring(13,15))).getTime()}};C=de([Y(0,b.IEnvironmentService),Y(1,E.IFileService),Y(2,R.IConfigurationService),Y(3,I.IUserDataSyncLogService)],C),e.UserDataSyncBackupStoreService=C}),define(ne[234],ie([0,1,3,2,4,15,24,21,25]),function(K,e,D,n,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const E="sync.enable";let I=class extends n.Disposable{constructor(f,p,u,m){super();this.storageService=f,this.telemetryService=p,this.environmentService=u,this.userDataSyncStoreManagementService=m,this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(f.onDidChangeValue(d=>this.onDidStorageChange(d)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(E,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(f){f&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(E,{enabled:f}),this.storageService.store(E,f,0,1))}isResourceEnabled(f){return this.storageService.getBoolean((0,b.getEnablementKey)(f),0,!0)}setResourceEnablement(f,p){if(this.isResourceEnabled(f)!==p){const u=(0,b.getEnablementKey)(f);this.telemetryService.publicLog2(u,{enabled:p}),this.storeResourceEnablement(u,p)}}getResourceSyncStateVersion(f){}storeResourceEnablement(f,p){this.storageService.store(f,p,0,L.isWeb?0:1)}onDidStorageChange(f){if(f.scope!==0)return;if(E===f.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const p=b.ALL_SYNC_RESOURCES.filter(u=>(0,b.getEnablementKey)(u)===f.key)[0];if(p){this._onDidChangeResourceEnablement.fire([p,this.isResourceEnabled(p)]);return}}};I=de([Y(0,A.IStorageService),Y(1,R.ITelemetryService),Y(2,T.IEnvironmentService),Y(3,b.IUserDataSyncStoreManagementService)],I),e.UserDataSyncEnablementService=I}),define(ne[235],ie([0,1,2,7]),function(K,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class L{constructor(f){this.service=f}listen(f,p){switch(p){case"onError":return this.service.onError}throw new Error(`Event not found: ${p}`)}call(f,p,u){switch(p){case"triggerSync":return this.service.triggerSync(u[0],u[1],u[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(u[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=L;class T{constructor(f){this.service=f}listen(f,p){throw new Error(`Event not found: ${p}`)}call(f,p,u){switch(p){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(u[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(n.URI.revive(u[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class A{constructor(f){this.channel=f}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(f){return this.channel.call("resolveUserKeybindings",[f])}async resolveFormattingOptions(f){return this.channel.call("resolveFormattingOptions",[f])}}e.UserDataSyncUtilServiceClient=A;class R{constructor(f){this.service=f}listen(f,p){switch(p){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${p}`)}async call(f,p,u){switch(p){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(u[0],u[1]);case"setEnablement":return this.service.setEnablement(u[0],u[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class b{constructor(f){this.service=f}listen(f,p){switch(p){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${p}`)}call(f,p,u){switch(p){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(u)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=b;class E{constructor(f){this.service=f}listen(f,p){switch(p){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${p}`)}call(f,p,u){switch(p){case"switch":return this.service.switch(u[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=E;class I extends D.Disposable{constructor(f){super();this.channel=f,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(f){return this.channel.call("switch",[f])}async getPreviousUserDataSyncStore(){const f=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(f)}revive(f){return{url:n.URI.revive(f.url),type:f.type,defaultUrl:n.URI.revive(f.defaultUrl),insidersUrl:n.URI.revive(f.insidersUrl),stableUrl:n.URI.revive(f.stableUrl),canSwitch:f.canSwitch,authenticationProviders:f.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=I}),define(ne[236],ie([0,1,15,8]),function(K,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let L=class extends n.AbstractLogger{constructor(A,R){super();this.logger=this._register(A.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...R){this.logger.trace(A,...R)}debug(A,...R){this.logger.debug(A,...R)}info(A,...R){this.logger.info(A,...R)}warn(A,...R){this.logger.warn(A,...R)}error(A,...R){this.logger.error(A,...R)}critical(A,...R){this.logger.critical(A,...R)}flush(){this.logger.flush()}};L=de([Y(0,n.ILoggerService),Y(1,D.IEnvironmentService)],L),e.UserDataSyncLogService=L}),define(ne[65],ie([0,1,3,2,4,26,148,15,13,6,27,46,24,25]),function(K,e,D,n,L,T,A,R,b,E,I,C,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,E.createDecorator)("IUserDataSyncMachinesService");const u="sync.currentMachineName",m="Safari",d="Chrome",g="Edge",w="Firefox",y="Android";function S(c){switch(c){case m:case d:case g:case w:case y:case(0,L.PlatformToString)(0):return!0}return!1}e.isWebPlatform=S;function l(){return L.isSafari?m:L.isChrome?d:L.isEdge?g:L.isFirefox?w:L.isAndroid?y:(0,L.PlatformToString)(L.isWeb?0:L.platform)}let r=class Ze extends n.Disposable{constructor(i,t,o,s,a,h){super();this.storageService=o,this.userDataSyncStoreService=s,this.logService=a,this.productService=h,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,C.getServiceMachineId)(i,t,o)}async getMachines(i){const t=await this.currentMachineIdPromise;return(await this.readMachinesData(i)).machines.map(s=>({...s,isCurrent:s.id===t}))}async addCurrentMachine(i){const t=await this.currentMachineIdPromise,o=await this.readMachinesData(i);o.machines.some(({id:s})=>s===t)||(o.machines.push({id:t,name:this.computeCurrentMachineName(o.machines),platform:l()}),await this.writeMachinesData(o))}async removeCurrentMachine(i){const t=await this.currentMachineIdPromise,o=await this.readMachinesData(i),s=o.machines.filter(({id:a})=>a!==t);s.length!==o.machines.length&&(o.machines=s,await this.writeMachinesData(o))}async renameMachine(i,t,o){const s=await this.readMachinesData(o),a=s.machines.find(({id:h})=>h===i);if(a){a.name=t,await this.writeMachinesData(s);const h=await this.currentMachineIdPromise;i===h&&this.storageService.store(u,t,0,1)}}async setEnablement(i,t){const o=await this.readMachinesData(),s=o.machines.find(({id:a})=>a===i);s&&(s.disabled=t?void 0:!0,await this.writeMachinesData(o))}computeCurrentMachineName(i){const t=this.storageService.get(u,0);if(t)return t;const o=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${l()} (${this.productService.nameShort})`,s=new RegExp(`${(0,T.escapeRegExpCharacters)(o)}\\s#(\\d+)`);let a=0;for(const h of i){const v=s.exec(h.name),P=v?parseInt(v[1]):0;a=P>a?P:a}return`${o} #${a+1}`}async readMachinesData(i){this.userData=await this.readUserData(i);const t=this.parse(this.userData);if(t.version!==Ze.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return t}async writeMachinesData(i){const t=JSON.stringify(i),o=await this.userDataSyncStoreService.write(Ze.RESOURCE,t,this.userData?.ref||null);this.userData={ref:o,content:t},this._onDidChange.fire()}async readUserData(i){if(this.userData){const t=i&&i.latest?i.latest[Ze.RESOURCE]:void 0;if(this.userData.ref===t)return this.userData;if(t===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ze.RESOURCE,this.userData)}parse(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(t){this.logService.error(t)}return{version:Ze.VERSION,machines:[]}}};r.VERSION=1,r.RESOURCE="machines",r=de([Y(0,R.IEnvironmentService),Y(1,b.IFileService),Y(2,f.IStorageService),Y(3,p.IUserDataSyncStoreService),Y(4,p.IUserDataSyncLogService),Y(5,I.IProductService)],r),e.UserDataSyncMachinesService=r}),define(ne[237],ie([0,1,5,57,37,9,3,2,4,19,7,146,27,24,21,25,64,65]),function(K,e,D,n,L,T,A,R,b,E,I,C,f,p,u,m,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const w="sync.disableMachineEventually",y="sync.sessionId",S="sync.storeUrl",l="sync.productQuality";let r=class extends R.Disposable{constructor(t,o,s,a,h,v,P,_,O,U){super();this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=s,this.userDataSyncEnablementService=a,this.userDataSyncService=h,this.logService=v,this.userDataSyncAccountService=P,this.telemetryService=_,this.userDataSyncMachinesService=O,this.storageService=U,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new D.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=t.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(o.onDidChangeUserDataSyncStore(()=>{(0,E.isEqual)(this.syncUrl,o.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(P.onDidChangeAccount(()=>this.updateAutoSync())),this._register(s.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(A.Event.debounce(h.onDidChangeLocal,(k,M)=>k?[...k,M]:[M],1e3)(k=>this.triggerSync(k,!1,!1))),this._register(A.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,k])=>k)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const t=this.storageService.get(S,0);return t?I.URI.parse(t):void 0}set syncUrl(t){t?this.storageService.store(S,t.toString(),0,1):this.storageService.remove(S,0)}get productQuality(){return this.storageService.get(l,0)}set productQuality(t){t?this.storageService.store(l,t,0,1):this.storageService.remove(l,0)}updateAutoSync(){const{enabled:t,message:o}=this.isAutoSyncEnabled();t?this.autoSync.value===void 0&&(this.autoSync.value=new c(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(s=>this.onDidFinishSync(s))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(o&&this.logService.info(o),this.autoSync.clear()):o&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(o))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,n.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(t,o,s){try{this.userDataSyncAccountService.account&&!s&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(y,0),t?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(o)this.logService.error(a),this.updateEnablement(!1);else throw a}}updateEnablement(t){this.userDataSyncEnablementService.isEnabled()!==t&&(this.userDataSyncEnablementService.setEnablement(t),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(t){if(!t){this.successiveFailures=0;return}const o=m.UserDataSyncError.toUserDataSyncError(t);o instanceof m.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:o.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),o.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):o.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):o.code==="LocalTooManyRequests"||o.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):o.code==="UpgradeRequired"||o.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):o.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with newer version than of client. Requires client upgrade.`)):o.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with older version than of client. Requires server reset.`)):o.code==="ServiceChanged"||o.code==="DefaultServiceChanged"?b.isWeb&&o.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(o),this.successiveFailures++),this._onError.fire(o)}async disableMachineEventually(){this.storageService.store(w,!0,0,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(w,0,!1)}stopDisableMachineEventually(){this.storageService.remove(w,0)}async triggerSync(t,o,s){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(o&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...t),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",s)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};r=de([Y(0,f.IProductService),Y(1,m.IUserDataSyncStoreManagementService),Y(2,m.IUserDataSyncStoreService),Y(3,m.IUserDataSyncEnablementService),Y(4,m.IUserDataSyncService),Y(5,m.IUserDataSyncLogService),Y(6,d.IUserDataSyncAccountService),Y(7,u.ITelemetryService),Y(8,g.IUserDataSyncMachinesService),Y(9,p.IStorageService)],r),e.UserDataAutoSyncService=r;class c extends R.Disposable{constructor(t,o,s,a,h,v,P,_){super();this.lastSyncUrl=t,this.interval=o,this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=a,this.userDataSyncService=h,this.userDataSyncMachinesService=v,this.logService=P,this.storageService=_,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(c.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(c.INTERVAL_SYNCING,!1),this.interval)}sync(t,o){const s=(0,D.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(h){if((0,T.isCancellationError)(h))return}return this.doSync(t,o,a)});return this.syncPromise=s,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,E.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const t=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),o=this.userDataSyncStoreManagementService.userDataSyncStore;return!!o&&!!t&&(!(0,E.isEqual)(o.defaultUrl,t.defaultUrl)||!(0,E.isEqual)(o.insidersUrl,t.insidersUrl)||!(0,E.isEqual)(o.stableUrl,t.stableUrl))}async doSync(t,o,s){this.logService.info(`Auto Sync: Triggered by ${t}`),this._onDidStartSync.fire();let a;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,o),s.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new m.UserDataAutoSyncError((0,C.localize)(0,null),"DefaultServiceChanged"):new m.UserDataAutoSyncError((0,C.localize)(1,null),"ServiceChanged"):new m.UserDataAutoSyncError((0,C.localize)(2,null),"TurnedOff");const h=this.storageService.get(y,0);if(h&&this.manifest&&h!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new m.UserDataAutoSyncError((0,C.localize)(3,null),"DefaultServiceChanged"):new m.UserDataAutoSyncError((0,C.localize)(4,null),"ServiceChanged"):new m.UserDataAutoSyncError((0,C.localize)(5,null),"SessionExpired");const v=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(s.isCancellationRequested)return;const P=v.find(_=>_.isCurrent);if(P?.disabled)throw new m.UserDataAutoSyncError((0,C.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(_){throw new m.UserDataAutoSyncError((0,L.toErrorMessage)(_),_ instanceof m.UserDataSyncError?_.code:"Unknown")}if(this.manifest&&this.manifest.session!==h&&this.storageService.store(y,this.manifest.session,0,1),s.isCancellationRequested)return;P||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(h){this.logService.error(h),a=h}this._onDidFinishSync.fire(a)}register(t){return super._register(t)}}c.INTERVAL_SYNCING="Interval"}),define(ne[238],ie([0,1,16,5,37,3,2,19,14,29,20,30,6,24,21,226,228,229,231,232,25]),function(K,e,D,n,L,T,A,R,b,E,I,C,f,p,u,m,d,g,w,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const l="sync.lastSyncTime";let r=class extends A.Disposable{constructor(s,a,h,v,P,_,O,U){super();this.userDataSyncStoreService=s,this.userDataSyncStoreManagementService=a,this.instantiationService=h,this.configurationService=v,this.logService=P,this.telemetryService=_,this.storageService=O,this.userDataSyncEnablementService=U,this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new T.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new T.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new A.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(l,0,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(s,a){this.checkEnablement();const h=(0,E.generateUuid)();try{const U=(0,S.createSyncHeaders)(h);a&&(U["Cache-Control"]="no-cache"),s=await this.userDataSyncStoreService.manifest(s,U)}catch(U){const k=S.UserDataSyncError.toUserDataSyncError(U);throw this.reportUserDataSyncError(k,h),k}let v=!1;const P=this,_=this.getEnabledSynchronizers();let O;return{manifest:s,async run(){if(v)throw new Error("Can run a task only once");return O=(0,n.createCancelablePromise)(U=>P.sync(_,s,h,U)),O.finally(()=>O=void 0)},async stop(){if(O&&O.cancel(),P.status!=="idle")return P.stop(_)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new S.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const s=(0,E.generateUuid)(),a=(0,S.createSyncHeaders)(s);let h;try{h=await this.userDataSyncStoreService.manifest(null,a)}catch(P){const _=S.UserDataSyncError.toUserDataSyncError(P);throw this.reportUserDataSyncError(_,s),_}await this.resetLocal();const v=this.getEnabledSynchronizers();return new c(s,h,a,v,()=>this.resetLocal(),this.configurationService,this.logService)}async sync(s,a,h,v){if(v.isCancellationRequested||!s.length)return;const P=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const _=(0,S.createSyncHeaders)(h);for(const O of s){if(v.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(O.resource))return;try{await O.sync(a,_)}catch(U){let k=!1;if(U instanceof S.UserDataSyncError)switch(U.code){case"TooLarge":U=new S.UserDataSyncError(U.message,U.code,O.resource),k=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":k=!0;break}const M=S.UserDataSyncError.toUserDataSyncError(U);if(this.reportUserDataSyncError(M,h),k)throw M;this.logService.error(U),this.logService.error(`${O.resource}: ${(0,L.toErrorMessage)(U)}`),this._syncErrors.push([O.resource,M])}}this.logService.info(`Sync done. Took ${new Date().getTime()-P}ms`),this.updateLastSyncTime()}catch(_){const O=S.UserDataSyncError.toUserDataSyncError(_);throw this.reportUserDataSyncError(O,h),O}finally{this.updateStatus(s),this._onSyncErrors.fire(this._syncErrors)}}async stop(s){if(this.status!=="idle")for(const a of s)try{a.status!=="idle"&&await a.stop()}catch(h){this.logService.error(h)}}async replace(s){this.checkEnablement(),await this.performSynchronizerAction(async a=>{if(await a.replace(s))return!0})}async accept(s,a,h,v){this.checkEnablement(),await this.performSynchronizerAction(async P=>{if(P.resource===s)return await P.accept(a,h),v&&await P.apply(!1,(0,S.createSyncHeaders)((0,E.generateUuid)())),!0})}async resolveContent(s){return this.performSynchronizerAction(async a=>{const h=await a.resolveContent(s);if(h)return h})}async getRemoteSyncResourceHandles(s){return await this.performSynchronizerAction(async h=>{if(h.resource===s)return h.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(s){return await this.performSynchronizerAction(async h=>{if(h.resource===s)return h.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(s,a){return await this.performSynchronizerAction(async v=>{if(v.resource===s)return v.getAssociatedResources(a)})||[]}async getMachineId(s,a){return await this.performSynchronizerAction(async v=>{if(v.resource===s)return await v.getMachineId(a)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async a=>{if(a.resource!=="globalState"&&await a.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async a=>{if(await a.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(s){this.logService.error(s)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(l,0),this.synchronizers.value){for(const s of this.synchronizers.value.enabled)try{await s.resetLocal()}catch(a){this.logService.error(`${s.resource}: ${(0,L.toErrorMessage)(a)}`),this.logService.error(a)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(s){const a=new A.DisposableStore;try{const h=this.synchronizers.value||a.add(this.instantiationService.createInstance(i,()=>{},()=>{},()=>{})),v=[...h.enabled,...h.disabled.map(P=>a.add(h.createSynchronizer(P)))];for(const P of v){const _=await s(P);if(!(0,b.isUndefined)(_))return _}return null}finally{a.dispose()}}setStatus(s){const a=this._status;this._status!==s&&(this._status=s,this._onDidChangeStatus.fire(s),a==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(s){this.updateConflicts(s);const a=this.computeStatus(s);this.setStatus(a)}updateConflicts(s){const a=this.computeConflicts(s);(0,D.equals)(this._conflicts,a,([h,v],[P,_])=>h===h&&(0,D.equals)(v,_,(O,U)=>(0,R.isEqual)(O.previewResource,U.previewResource)))||(this._conflicts=this.computeConflicts(s),this._onDidChangeConflicts.fire(a))}computeConflicts(s){return s.filter(a=>a.status==="hasConflicts").map(a=>[a.resource,a.conflicts.map(t)])}computeStatus(s){return this.userDataSyncStoreManagementService.userDataSyncStore?s.some(a=>a.status==="hasConflicts")?"hasConflicts":s.some(a=>a.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(l,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(s,a){this.telemetryService.publicLog2("sync/error",{code:s.code,serverCode:s instanceof S.UserDataSyncStoreError?String(s.serverCode):void 0,url:s instanceof S.UserDataSyncStoreError?s.url:void 0,resource:s.resource,executionId:a,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(i,s=>this.updateStatus(s),s=>this.updateConflicts(s),s=>this._onDidChangeLocal.fire(s))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};r=de([Y(0,S.IUserDataSyncStoreService),Y(1,S.IUserDataSyncStoreManagementService),Y(2,f.IInstantiationService),Y(3,I.IConfigurationService),Y(4,S.IUserDataSyncLogService),Y(5,u.ITelemetryService),Y(6,p.IStorageService),Y(7,S.IUserDataSyncEnablementService)],r),e.UserDataSyncService=r;class c extends A.Disposable{constructor(s,a,h,v,P,_,O){super();this.id=s,this.manifest=a,this.syncHeaders=h,this.synchronisers=v,this.onStop=P,this.configurationService=_,this.logService=O,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new T.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(s=>s.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(s=>s.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,n.createCancelablePromise)(s=>this.getPreviews(s))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(s){throw this.logService.error(s),s}}async accept(s,a){try{return await this.performAction(s,h=>h.accept(s,a))}catch(h){throw this.logService.error(h),h}}async merge(s){try{return s?await this.performAction(s,a=>a.merge(s)):await this.mergeAll()}catch(a){throw this.logService.error(a),a}}async discard(s){try{return await this.performAction(s,a=>a.discard(s))}catch(a){throw this.logService.error(a),a}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const s=[];for(const[,a]of this.previews)for(const h of a.resourcePreviews)h.mergeState==="conflict"&&s.push(h.previewResource);for(const a of s)await this.discard(a);return this.previews}catch(s){throw this.logService.error(s),s}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const s=[];for(const[a,h]of this.previews){this.synchronizingResources.push([a,h.resourcePreviews.map(_=>_.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const v=this.synchronisers.find(_=>_.resource===a);for(const _ of h.resourcePreviews)(_.localChange!==0||_.remoteChange!==0)&&_.mergeState==="preview"&&await v.merge(_.previewResource);const P=await v.apply(!1,this.syncHeaders);P&&s.push(this.toSyncResourcePreview(v.resource,P)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(_=>_[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=s,this.previews}catch(s){throw this.logService.error(s),s}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[s,a]of this.previews){this.synchronizingResources.push([s,a.resourcePreviews.map(v=>v.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(v=>v.resource===s);for(const v of a.resourcePreviews)await h.accept(v.remoteResource);await h.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(v=>v[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(s){throw this.logService.error(s),s}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[s,a]of this.previews){this.synchronizingResources.push([s,a.resourcePreviews.map(v=>v.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(v=>v.resource===s);for(const v of a.resourcePreviews)await h.accept(v.localResource);await h.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(v=>v[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(s){throw this.logService.error(s),s}}async stop(){await this.onStop(),this.reset()}async performAction(s,a){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const h=this.previews.findIndex(([,F])=>F.resourcePreviews.some(({localResource:V,previewResource:N,remoteResource:G})=>(0,R.isEqual)(s,V)||(0,R.isEqual)(s,N)||(0,R.isEqual)(s,G)));if(h===-1)return this.previews;const[v,P]=this.previews[h],_=P.resourcePreviews.find(({localResource:F,remoteResource:V,previewResource:N})=>(0,R.isEqual)(F,s)||(0,R.isEqual)(V,s)||(0,R.isEqual)(N,s));if(!_)return this.previews;let O=this.synchronizingResources.find(F=>F[0]===v);O||(O=[v,[]],this.synchronizingResources.push(O)),O[1].some(F=>(0,R.isEqual)(F,_.localResource))||(O[1].push(_.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const U=this.synchronisers.find(F=>F.resource===this.previews[h][0]),k=await a(U);k?this.previews.splice(h,1,this.toSyncResourcePreview(U.resource,k)):this.previews.splice(h,1);const M=this.synchronizingResources.findIndex(F=>F[0]===v);return this.synchronizingResources[M][1].splice(O[1].findIndex(F=>(0,R.isEqual)(F,_.localResource)),1),O[1].length||(this.synchronizingResources.splice(M,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const s=[];for(const[a,h]of this.previews){this.synchronizingResources.push([a,h.resourcePreviews.map(_=>_.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const v=this.synchronisers.find(_=>_.resource===a);let P=h;for(const _ of h.resourcePreviews)(_.localChange!==0||_.remoteChange!==0)&&_.mergeState==="preview"&&(P=await v.merge(_.previewResource));P&&s.push(this.toSyncResourcePreview(v.resource,P)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(_=>_[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=s,this.previews}async getPreviews(s){const a=[],h=await this.getUserDataSyncConfiguration();for(const v of this.synchronisers){if(s.isCancellationRequested)return[];const P=await v.preview(this.manifest,h,this.syncHeaders);P&&a.push(this.toSyncResourcePreview(v.resource,P))}return a}async getUserDataSyncConfiguration(){const s=this.configurationService.getValue(S.USER_DATA_SYNC_CONFIGURATION_SCOPE),a=await this.synchronisers.find(h=>h instanceof w.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...s,...a}}toSyncResourcePreview(s,a){return[s,{isLastSyncFromCurrentMachine:a.isLastSyncFromCurrentMachine,resourcePreviews:a.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let i=class extends A.Disposable{constructor(s,a,h,v,P,_,O){super();this.onDidChangeStatus=s,this.onDidChangeConflicts=a,this.onDidChangeLocal=h,this.userDataSyncEnablementService=v,this.instantiationService=P,this.extensionGalleryService=_,this.logService=O,this._enabled=[],this._register(v.onDidChangeResourceEnablement(([U,k])=>this.onDidChangeResourceEnablement(U,k))),this._register((0,A.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,U])=>U.dispose())));for(const U of S.ALL_SYNC_RESOURCES)v.isResourceEnabled(U)&&this.registerSynchronizer(U)}get enabled(){return this._enabled.sort((s,a)=>s[1]-a[1]).map(([s])=>s)}get disabled(){return S.ALL_SYNC_RESOURCES.filter(s=>!this.userDataSyncEnablementService.isResourceEnabled(s))}onDidChangeResourceEnablement(s,a){a?this.registerSynchronizer(s):this.deRegisterSynchronizer(s)}registerSynchronizer(s){if(this._enabled.some(([P])=>P.resource===s))return;if(s==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const a=new A.DisposableStore,h=a.add(this.createSynchronizer(s));a.add(h.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),a.add(h.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),a.add(h.onDidChangeLocal(()=>this.onDidChangeLocal(s)));const v=this.getOrder(s);this._enabled.push([h,v,a])}deRegisterSynchronizer(s){const a=this._enabled.findIndex(([h])=>h.resource===s);if(a!==-1){const h=this._enabled.splice(a,1);for(const[v,,P]of h){if(v.status!=="idle"){const _=v.conflicts.length>0;v.stop(),_&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}P.dispose()}}}createSynchronizer(s){switch(s){case"settings":return this.instantiationService.createInstance(w.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(g.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(y.SnippetsSynchroniser);case"globalState":return this.instantiationService.createInstance(d.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(m.ExtensionsSynchroniser)}}getOrder(s){switch(s){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"globalState":return 3;case"extensions":return 4}}};i=de([Y(3,S.IUserDataSyncEnablementService),Y(4,f.IInstantiationService),Y(5,C.IExtensionGalleryService),Y(6,S.IUserDataSyncLogService)],i);function t(o){return{localResource:o.localResource,previewResource:o.previewResource,remoteResource:o.remoteResource,acceptedResource:o.acceptedResource,localChange:o.localChange,remoteChange:o.remoteChange,mergeState:o.mergeState}}}),define(ne[239],ie([0,1,3,2,14,7,25]),function(K,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class R{constructor(C,f){this.service=C,this.logService=f,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(C,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(C,f,p){try{return await this._call(C,f,p)}catch(u){throw this.logService.error(u),u}}async _call(C,f,p){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(T.URI.revive(p[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(p[0],T.URI.revive(p[1]),p[2],p[3]);case"resolveContent":return this.service.resolveContent(T.URI.revive(p[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(p[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(p[0]);case"getAssociatedResources":return this.service.getAssociatedResources(p[0],{created:p[1].created,uri:T.URI.revive(p[1].uri)});case"getMachineId":return this.service.getMachineId(p[0],{created:p[1].created,uri:T.URI.revive(p[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const u=f.substring("manualSync/".length),m=p[0],d=this.getManualSyncTask(m);switch(p=p.slice(1),u){case"preview":return d.preview();case"accept":return d.accept(T.URI.revive(p[0]),p[1]);case"merge":return d.merge(T.URI.revive(p[0]));case"discard":return d.discard(T.URI.revive(p[0]));case"discardConflicts":return d.discardConflicts();case"apply":return d.apply();case"pull":return d.pull();case"push":return d.push();case"stop":return d.stop();case"_getStatus":return d.status;case"dispose":return this.disposeManualSyncTask(d)}}throw new Error("Invalid call")}getManualSyncTask(C){const f=this.manualSyncTasks.get(this.createKey(C));if(!f)throw new Error(`Manual sync taks not found: ${C}`);return f.manualSyncTask}async createManualSyncTask(){const C=new n.DisposableStore,f=C.add(await this.service.createManualSyncTask());return C.add(f.onSynchronizeResources(p=>this.onManualSynchronizeResources.fire({manualSyncTaskId:f.id,data:p}))),this.manualSyncTasks.set(this.createKey(f.id),{manualSyncTask:f,disposables:C}),{id:f.id,manifest:f.manifest,status:f.status}}disposeManualSyncTask(C){C.dispose();const f=this.createKey(C.id);this.manualSyncTasks.get(f)?.disposables.dispose(),this.manualSyncTasks.delete(f)}createKey(C){return`manualSyncTask-${C}`}}e.UserDataSyncChannel=R;class b extends n.Disposable{constructor(C){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(f,p,u){return C.call(f,p,u).then(null,m=>{throw A.UserDataSyncError.toUserDataSyncError(m)})},listen(f,p){return C.listen(f,p)}},this.channel.call("_getInitialData").then(([f,p,u])=>{this.updateStatus(f),this.updateConflicts(p),u&&this.updateLastSyncTime(u),this._register(this.channel.listen("onDidChangeStatus")(m=>this.updateStatus(m))),this._register(this.channel.listen("onDidChangeLastSyncTime")(m=>this.updateLastSyncTime(m)))}),this._register(this.channel.listen("onDidChangeConflicts")(f=>this.updateConflicts(f))),this._register(this.channel.listen("onSyncErrors")(f=>this._onSyncErrors.fire(f.map(([p,u])=>[p,A.UserDataSyncError.toUserDataSyncError(u)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:C,manifest:f,status:p}=await this.channel.call("createManualSyncTask"),u=this,m=new E(C,f,p,{async call(d,g,w){return u.channel.call(`manualSync/${d}`,[C,...(0,L.isArray)(g)?g:[g]],w)},listen(d,g){return D.Event.map(D.Event.filter(u.channel.listen(`manualSync/${d}`,g),w=>!m.isDiposed()&&w.manualSyncTaskId===C),w=>w.data)}});return m}replace(C){return this.channel.call("replace",[C])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(C,f,p,u){return this.channel.call("accept",[C,f,p,u])}resolveContent(C){return this.channel.call("resolveContent",[C])}async getLocalSyncResourceHandles(C){return(await this.channel.call("getLocalSyncResourceHandles",[C])).map(({created:p,uri:u})=>({created:p,uri:T.URI.revive(u)}))}async getRemoteSyncResourceHandles(C){return(await this.channel.call("getRemoteSyncResourceHandles",[C])).map(({created:p,uri:u})=>({created:p,uri:T.URI.revive(u)}))}async getAssociatedResources(C,f){return(await this.channel.call("getAssociatedResources",[C,f])).map(({resource:u,comparableResource:m})=>({resource:T.URI.revive(u),comparableResource:T.URI.revive(m)}))}async getMachineId(C,f){return this.channel.call("getMachineId",[C,f])}async updateStatus(C){this._status=C,this._onDidChangeStatus.fire(C)}async updateConflicts(C){this._conflicts=C.map(([f,p])=>[f,p.map(u=>({...u,localResource:T.URI.revive(u.localResource),remoteResource:T.URI.revive(u.remoteResource),previewResource:T.URI.revive(u.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(C){this._lastSyncTime!==C&&(this._lastSyncTime=C,this._onDidChangeLastSyncTime.fire(C))}}e.UserDataSyncChannelClient=b;class E extends n.Disposable{constructor(C,f,p,u){super();this.id=C,this.manifest=f,this._disposed=!1,this._status=p;const m=this;this.channel={async call(d,g,w){try{const y=await u.call(d,g,w);return m.isDiposed()||(m._status=await u.call("_getStatus")),y}catch(y){throw A.UserDataSyncError.toUserDataSyncError(y)}},listen(d,g){return u.listen(d,g)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const C=await this.channel.call("preview");return this.deserializePreviews(C)}async accept(C,f){const p=await this.channel.call("accept",[C,f]);return this.deserializePreviews(p)}async merge(C){const f=await this.channel.call("merge",[C]);return this.deserializePreviews(f)}async discard(C){const f=await this.channel.call("discard",[C]);return this.deserializePreviews(f)}async discardConflicts(){const C=await this.channel.call("discardConflicts");return this.deserializePreviews(C)}async apply(){const C=await this.channel.call("apply");return this.deserializePreviews(C)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(C){return C.map(([f,p])=>[f,{isLastSyncFromCurrentMachine:p.isLastSyncFromCurrentMachine,resourcePreviews:p.resourcePreviews.map(u=>({...u,localResource:T.URI.revive(u.localResource),remoteResource:T.URI.revive(u.remoteResource),previewResource:T.URI.revive(u.previewResource),acceptedResource:T.URI.revive(u.acceptedResource)}))}])}}}),define(ne[240],ie([0,1,5,23,9,3,2,102,4,19,14,7,29,20,15,13,27,43,46,24,25]),function(K,e,D,n,L,T,A,R,b,E,I,C,f,p,u,m,d,g,w,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",r="sync.donot-make-requests-until",c="sync.user-session-id",i="sync.machine-session-id",t=100,o=1e3*60*5;let s=class extends A.Disposable{constructor(O,U,k){super();this.productService=O,this.configurationService=U,this.storageService=k,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(k.onDidChangeValue,M=>M.key===S.SYNC_SERVICE_URL_TYPE&&M.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(S.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(S.SYNC_SERVICE_URL_TYPE,O,0,b.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[S.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(S.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,U){O=b.isWeb&&O?.web?{...O,...O.web}:O;const k={...O||{},...U||{}};if(k&&(0,I.isString)(k.url)&&(0,I.isObject)(k.authenticationProviders)&&Object.keys(k.authenticationProviders).every(M=>(0,I.isArray)(k.authenticationProviders[M].scopes))){const M=k,F=!!M.canSwitch&&!U?.url,V=M.url===M.insidersUrl?"insiders":"stable",N=(F?this.userDataSyncStoreType:void 0)||V,G=U?.url||(N==="insiders"?M.insidersUrl:N==="stable"?M.stableUrl:M.url);return{url:C.URI.parse(G),type:N,defaultType:V,defaultUrl:C.URI.parse(M.url),stableUrl:C.URI.parse(M.stableUrl),insidersUrl:C.URI.parse(M.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(M.authenticationProviders).reduce((J,j)=>(J.push({id:j,scopes:M.authenticationProviders[j].scopes}),J),[])}}}};s=de([Y(0,d.IProductService),Y(1,p.IConfigurationService),Y(2,y.IStorageService)],s),e.AbstractUserDataSyncStoreManagementService=s;let a=class extends s{constructor(O,U,k){super(O,U,k);const M=this.storageService.get(l,0);M&&(this.previousConfigurationSyncStore=JSON.parse(M));const F=this.productService[S.CONFIGURATION_SYNC_STORE_KEY];F?this.storageService.store(l,JSON.stringify(F),0,1):this.storageService.remove(l,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};a=de([Y(0,d.IProductService),Y(1,p.IConfigurationService),Y(2,y.IStorageService)],a),e.UserDataSyncStoreManagementService=a;let h=class extends A.Disposable{constructor(O,U,k,M,F,V,N){super();this.requestService=k,this.logService=M,this.storageService=N,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,w.getServiceMachineId)(F,V,N).then(G=>{const J={"X-Client-Name":`${U.applicationName}${b.isWeb?"-web":""}`,"X-Client-Version":U.version};return U.commit&&(J["X-Client-Commit"]=U.commit),J}),this.session=new P(t,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,U){this.authToken={token:O,type:U}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,E.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(r,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(U=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),U).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,U=>null)):this.storageService.remove(r,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O),k={},M=await this.request(U.toString(),{type:"GET",headers:k},[],n.CancellationToken.None);return(await(0,g.asJson)(M)||[]).map(({url:V,created:N})=>({ref:(0,E.relativePath)(U,U.with({path:V})),created:N*1e3}))}async resolveContent(O,U){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O,U).toString(),M={};M["Cache-Control"]="no-cache";const F=await this.request(k,{type:"GET",headers:M},[],n.CancellationToken.None);return await(0,g.asText)(F)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),k={};await this.request(U,{type:"DELETE",headers:k},[],n.CancellationToken.None)}async read(O,U,k={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();k={...k},k["Cache-Control"]="no-cache",U&&(k["If-None-Match"]=U.ref);const F=await this.request(M,{type:"GET",headers:k},[304],n.CancellationToken.None);let V=null;if(F.res.statusCode===304&&(V=U),V===null){const N=F.res.headers.etag;if(!N)throw new S.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",F.res.statusCode,F.res.headers[S.HEADER_OPERATION_ID]);const G=await(0,g.asText)(F);if(!G&&F.res.statusCode===304)throw new S.UserDataSyncStoreError("Empty response",M,"EmptyResponse",F.res.statusCode,F.res.headers[S.HEADER_OPERATION_ID]);V={ref:N,content:G}}return V}async write(O,U,k,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();M={...M},M["Content-Type"]=R.Mimes.text,k&&(M["If-Match"]=k);const V=await this.request(F,{type:"POST",data:U,headers:M},[],n.CancellationToken.None),N=V.res.headers.etag;if(!N)throw new S.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",V.res.statusCode,V.res.headers[S.HEADER_OPERATION_ID]);return N}async manifest(O,U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,E.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();U={...U},U["Content-Type"]="application/json",O&&(U["If-None-Match"]=O.ref);const M=await this.request(k,{type:"GET",headers:U},[304],n.CancellationToken.None);let F=null;if(M.res.statusCode===304&&(F=O),!F){const N=M.res.headers.etag;if(!N)throw new S.UserDataSyncStoreError("Server did not return the ref",k,"NoRef",M.res.statusCode,M.res.headers[S.HEADER_OPERATION_ID]);const G=await(0,g.asText)(M);if(!G&&M.res.statusCode===304)throw new S.UserDataSyncStoreError("Empty response",k,"EmptyResponse",M.res.statusCode,M.res.headers[S.HEADER_OPERATION_ID]);G&&(F={...JSON.parse(G),ref:N})}const V=this.storageService.get(c,0);return V&&F&&V!==F.session&&this.clearSession(),F===null&&V&&this.clearSession(),F&&this.storageService.store(c,F.session,0,1),F}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),U={"Content-Type":R.Mimes.text};await this.request(O,{type:"DELETE",headers:U},[],n.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(c,0),this.storageService.remove(i,0)}async request(O,U,k,M){if(!this.authToken)throw new S.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new S.UserDataSyncStoreError(`${U.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const F=await this.commonHeadersPromise;U.headers={...U.headers||{},...F,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(U.headers),this.logService.trace("Sending request to server",{url:O,type:U.type,headers:{...U.headers,authorization:void 0}});let V;try{V=await this.session.request(O,U,M)}catch(j){if(!(j instanceof S.UserDataSyncStoreError)){let q="RequestFailed";const X=(0,L.getErrorMessage)(j).toLowerCase();X.includes("xhr timeout")?q="RequestTimeout":X.includes("protocol")&&X.includes("not supported")?q="RequestProtocolNotSupported":X.includes("request path contains unescaped characters")?q="RequestPathNotEscaped":X.includes("headers must be an object")?q="RequestHeadersNotObject":(0,L.isCancellationError)(j)&&(q="RequestCanceled"),j=new S.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,q,void 0,void 0)}throw this.logService.info("Request failed",O),j}const N=V.res.headers[S.HEADER_OPERATION_ID],G={url:O,status:V.res.statusCode,"execution-id":U.headers[S.HEADER_EXECUTION_ID],"operation-id":N},J=(0,g.isSuccess)(V)||V.res.statusCode&&k.indexOf(V.res.statusCode)!==-1;if(J?this.logService.trace("Request succeeded",G):this.logService.info("Request failed",G),V.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new S.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",V.res.statusCode,N);if(this._onTokenSucceed.fire(),V.res.statusCode===409)throw new S.UserDataSyncStoreError(`${U.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",V.res.statusCode,N);if(V.res.statusCode===410)throw new S.UserDataSyncStoreError(`${U.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",V.res.statusCode,N);if(V.res.statusCode===412)throw new S.UserDataSyncStoreError(`${U.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",V.res.statusCode,N);if(V.res.statusCode===413)throw new S.UserDataSyncStoreError(`${U.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",V.res.statusCode,N);if(V.res.statusCode===426)throw new S.UserDataSyncStoreError(`${U.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",V.res.statusCode,N);if(V.res.statusCode===429){const j=V.res.headers["retry-after"];throw j?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(j)*1e3)),new S.UserDataSyncStoreError(`${U.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",V.res.statusCode,N)):new S.UserDataSyncStoreError(`${U.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",V.res.statusCode,N)}if(!J)throw new S.UserDataSyncStoreError("Server returned "+V.res.statusCode,O,"Unknown",V.res.statusCode,N);return V}addSessionHeaders(O){let U=this.storageService.get(i,0);U===void 0&&(U=(0,f.generateUuid)(),this.storageService.store(i,U,0,1)),O["X-Machine-Session-Id"]=U;const k=this.storageService.get(c,0);k!==void 0&&(O["X-User-Session-Id"]=k)}};h=de([Y(1,d.IProductService),Y(2,g.IRequestService),Y(3,S.IUserDataSyncLogService),Y(4,u.IEnvironmentService),Y(5,m.IFileService),Y(6,y.IStorageService)],h),e.UserDataSyncStoreClient=h;let v=class extends h{constructor(O,U,k,M,F,V,N){super(O.userDataSyncStore?.url,U,k,M,F,V,N);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};v=de([Y(0,S.IUserDataSyncStoreManagementService),Y(1,d.IProductService),Y(2,g.IRequestService),Y(3,S.IUserDataSyncLogService),Y(4,u.IEnvironmentService),Y(5,m.IFileService),Y(6,y.IStorageService)],v),e.UserDataSyncStoreService=v;class P{constructor(O,U,k,M){this.limit=O,this.interval=U,this.requestService=k,this.logService=M,this.requests=[],this.startTime=void 0}request(O,U,k){if(this.isExpired()&&this.reset(),U.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new S.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(U,k)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=P}),define(ne[241],ie([0,1,3,60,27,24,21,237,25,64,65]),function(K,e,D,n,L,T,A,R,b,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let C=class extends R.UserDataAutoSyncService{constructor(p,u,m,d,g,w,y,S,l,r,c){super(p,u,m,d,g,y,S,l,r,c);this._register(D.Event.debounce(D.Event.any(D.Event.map(w.onDidFocusWindow,()=>"windowFocus"),D.Event.map(w.onDidOpenWindow,()=>"windowOpen")),(i,t)=>i?[...i,t]:[t],1e3)(i=>this.triggerSync(i,!0,!1)))}};C=de([Y(0,L.IProductService),Y(1,b.IUserDataSyncStoreManagementService),Y(2,b.IUserDataSyncStoreService),Y(3,b.IUserDataSyncEnablementService),Y(4,b.IUserDataSyncService),Y(5,n.INativeHostService),Y(6,b.IUserDataSyncLogService),Y(7,E.IUserDataSyncAccountService),Y(8,A.ITelemetryService),Y(9,I.IUserDataSyncMachinesService),Y(10,T.IStorageService)],C),e.UserDataAutoSyncService=C}),define(ne[242],ie([0,1,5,3,2]),function(K,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends L.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:b,getActiveWindowId:E}){super();this.disposables=this._register(new L.DisposableStore),n.Event.latch(n.Event.any(R,b))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>E()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(ne[66],ie([0,1,50,5,10,14,22,124,255,256]),function(K,e,D,n,L,T,A,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class I extends Error{constructor(r,c){let i=c.message;switch(r){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=r,this.cause=c}}e.ExtractError=I;function C(l){const r=l.externalFileAttributes>>16||33188;return[448,56,7].map(c=>r&c).reduce((c,i)=>c+i,r&61440)}function f(l){if(l instanceof I)return l;let r;return/end of central directory record signature not found/.test(l.message)&&(r="CorruptZip"),new I(r,l)}function p(l,r,c,i,t,o){const s=L.dirname(r),a=L.join(i,s);if(!a.startsWith(i))return Promise.reject(new Error(R.localize(0,null,r)));const h=L.join(i,r);let v;return o.onCancellationRequested(()=>{v&&v.destroy()}),Promise.resolve(A.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((P,_)=>{if(!o.isCancellationRequested)try{v=(0,D.createWriteStream)(h,{mode:c}),v.once("close",()=>P()),v.once("error",_),l.once("error",_),l.pipe(v)}catch(O){_(O)}}))}function u(l,r,c,i){let t=(0,n.createCancelablePromise)(()=>Promise.resolve()),o=0;return i.onCancellationRequested(()=>{t.cancel(),l.close()}),new Promise((s,a)=>{const h=new n.Sequencer,v=P=>{P.isCancellationRequested||(o++,l.readEntry())};l.once("error",a),l.once("close",()=>t.then(()=>{i.isCancellationRequested||l.entryCount===o?s():a(new I("Incomplete",new Error(R.localize(1,null,o,l.entryCount))))},a)),l.readEntry(),l.on("entry",P=>{if(i.isCancellationRequested)return;if(!c.sourcePathRegex.test(P.fileName)){v(i);return}const _=P.fileName.replace(c.sourcePathRegex,"");if(/\/$/.test(_)){const k=L.join(r,_);t=(0,n.createCancelablePromise)(M=>A.Promises.mkdir(k,{recursive:!0}).then(()=>v(M)).then(void 0,a));return}const O=d(l,P),U=C(P);t=(0,n.createCancelablePromise)(k=>h.queue(()=>O.then(M=>p(M,_,U,r,c,k).then(()=>v(k)))).then(null,a))})})}function m(l,r=!1){return new Promise((c,i)=>{(0,b.open)(l,r?{lazyEntries:!0}:void 0,(t,o)=>{t?i(f(t)):c((0,T.assertIsDefined)(o))})})}function d(l,r){return new Promise((c,i)=>{l.openReadStream(r,(t,o)=>{t?i(f(t)):c((0,T.assertIsDefined)(o))})})}function g(l,r){return new Promise((c,i)=>{const t=new E.ZipFile;r.forEach(s=>{s.contents?t.addBuffer(typeof s.contents=="string"?Buffer.from(s.contents,"utf8"):s.contents,s.path):s.localPath&&t.addFile(s.localPath,s.path)}),t.end();const o=(0,D.createWriteStream)(l);t.outputStream.pipe(o),t.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>c(l))})}e.zip=g;function w(l,r,c={},i){const t=new RegExp(c.sourcePath?`^${c.sourcePath}`:"");let o=m(l,!0);return c.overwrite&&(o=o.then(s=>A.Promises.rm(r).then(()=>s))),o.then(s=>u(s,r,{sourcePathRegex:t},i))}e.extract=w;function y(l,r){return m(l).then(c=>new Promise((i,t)=>{c.on("entry",o=>{o.fileName===r&&d(c,o).then(s=>i(s),s=>t(s))}),c.once("close",()=>t(new Error(R.localize(2,null,r))))}))}function S(l,r){return y(l,r).then(c=>new Promise((i,t)=>{const o=[];c.once("error",t),c.on("data",s=>o.push(s)),c.on("end",()=>i(Buffer.concat(o)))}))}e.buffer=S}),define(ne[243],ie([0,1,66,133]),function(K,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function L(T){return(0,D.buffer)(T,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,n.localize)(0,null))}})}e.getManifest=L}),define(ne[244],ie([0,1,16,5,9,2,18,10,4,19,61,7,29,22,66,134,15,30,31,154,13,8,27]),function(K,e,D,n,L,T,A,R,b,E,I,C,f,p,u,m,d,g,w,y,S,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let c=class extends T.Disposable{constructor(t,o,s,a,h){super();this.beforeRemovingExtension=t,this.fileService=o,this.logService=s,this.environmentService=a,this.productService=h,this._devSystemExtensionsPath=null,this.systemExtensionsPath=a.builtinExtensionsPath,this.extensionsPath=a.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new n.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const o=[];(t===null||t===0)&&o.push(this.scanSystemExtensions().then(null,s=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(s).message,g.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&o.push(this.scanUserExtensions(!0).then(null,s=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(s).message,g.ExtensionManagementErrorCode.Internal))));try{const s=await Promise.all(o);return(0,D.flatten)(s)}catch(s){throw this.joinErrors(s)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[o,s]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return s=s.filter(a=>!o[new w.ExtensionIdentifierWithVersion(a.identifier,a.manifest.version).key()]),t&&(s=(0,w.groupByExtension)(s,h=>h.identifier).map(h=>h.sort((v,P)=>I.rcompare(v.manifest.version,P.manifest.version))[0])),this.logService.trace("Scanned user extensions:",s.length),s}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,o,s,a){const h=t.key(),v=R.join(this.extensionsPath,`.${(0,f.generateUuid)()}`),P=R.join(this.extensionsPath,h);try{await p.Promises.rm(P)}catch{try{await p.Promises.rm(P)}catch{}throw new g.ExtensionManagementError((0,m.localize)(0,null,P,t.id),g.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,o,v,a);let _=await this.scanExtension(C.URI.file(v),1);if(!_)throw new Error((0,m.localize)(1,null,v));await this.storeMetadata(_,{...s,installedTimestamp:Date.now()});try{await this.rename(t,v,P,Date.now()+2*60*1e3),this.logService.info("Renamed to",P)}catch(O){try{await p.Promises.rm(v)}catch{}if(O.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(O)}. Deleted from extracted location`,v),O}try{_=await this.scanExtension(C.URI.file(P),1)}catch{}if(_)return _;throw new Error((0,m.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,o){return this.setMetadata(t,o),await this.storeMetadata(t,{...o,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,o){o.isMachineScoped=o.isMachineScoped||void 0,o.isBuiltin=o.isBuiltin||void 0,o.installedTimestamp=o.installedTimestamp||void 0;const s=R.join(t.location.fsPath,"package.json"),a=await p.Promises.readFile(s,"utf8"),{manifest:h}=await this.parseManifest(a);return h.__metadata=o,await p.Promises.writeFile(s,JSON.stringify(h,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const o=t.map(s=>new w.ExtensionIdentifierWithVersion(s.identifier,s.manifest.version));await this.withUninstalledExtensions(s=>{o.forEach(a=>s[a.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(a=>delete a[t.key()]);const s=(await this.scanExtensions(1)).find(a=>new w.ExtensionIdentifierWithVersion(a.identifier,a.manifest.version).equals(t))||null;return s?(await this.storeMetadata(s,{installedTimestamp:Date.now()}),this.scanExtension(s.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let o;try{o=await p.Promises.readFile(this.uninstalledPath,"utf8")}catch(a){if(a.code!=="ENOENT")throw a}let s={};if(o)try{s=JSON.parse(o)}catch{}return t&&(t(s),Object.keys(s).length?await p.Promises.writeFile(this.uninstalledPath,JSON.stringify(s)):await p.Promises.rm(this.uninstalledPath)),s})}async removeExtension(t,o){this.logService.trace(`Deleting ${o} extension from disk`,t.identifier.id,t.location.fsPath),await p.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(o=>delete o[new w.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,o,s,a){this.logService.trace(`Started extracting the extension from ${o} to ${s}`);try{await p.Promises.rm(s)}catch(h){throw new g.ExtensionManagementError(this.joinErrors(h).message,g.ExtensionManagementErrorCode.Delete)}try{await(0,u.extract)(o,s,{sourcePath:"extension",overwrite:!0},a),this.logService.info(`Extracted extension to ${s}:`,t.id)}catch(h){try{await p.Promises.rm(s)}catch{}let v=g.ExtensionManagementErrorCode.Extract;throw h instanceof u.ExtractError&&(h.type==="CorruptZip"?v=g.ExtensionManagementErrorCode.CorruptZip:h.type==="Incomplete"&&(v=g.ExtensionManagementErrorCode.IncompleteZip)),new g.ExtensionManagementError(h.message,v)}}async rename(t,o,s,a){try{await p.Promises.rename(o,s)}catch(h){if(b.isWindows&&h&&h.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${o} to ${s} with 'EPERM' error. Trying again...`,t.id),this.rename(t,o,s,a);throw new g.ExtensionManagementError(h.message||(0,m.localize)(3,null,o,s),h.code||g.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const o=this.scanDevSystemExtensions(),[s,a]=await Promise.all([t,o]);return[...s,...a]}async scanExtensionsInDir(t,o){const s=new n.Limiter(10),a=await this.fileService.resolve(C.URI.file(t));return a.children?(await Promise.all(a.children.filter(v=>v.isDirectory).map(v=>s.queue(async()=>o===1&&(0,E.basename)(v.resource).indexOf(".")===0?null:this.scanExtension(v.resource,o))))).filter(v=>v&&v.identifier):[]}async scanExtension(t,o){try{const s=await this.fileService.resolve(t);if(s.children){const{manifest:a,metadata:h}=await this.readManifest(t.fsPath),v=s.children.find(({name:U})=>/^readme(\.txt|\.md|)$/i.test(U))?.resource,P=s.children.find(({name:U})=>/^changelog(\.txt|\.md|)$/i.test(U))?.resource,_={id:(0,w.getGalleryExtensionId)(a.publisher,a.name)},O={type:o,identifier:_,manifest:a,location:t,readmeUrl:v,changelogUrl:P,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:o===0};return this.setMetadata(O,h),O}}catch(s){o!==0&&this.logService.trace(s)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const o=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",o.length),o.filter(s=>t.some(a=>(0,w.areSameExtensions)(s.identifier,{id:a})))}else return[]}setMetadata(t,o){t.publisherDisplayName=o?.publisherDisplayName||null,t.publisherId=o?.publisherId||null,t.identifier.uuid=o?.id,t.isMachineScoped=!!o?.isMachineScoped,t.isPreReleaseVersion=!!o?.isPreReleaseVersion,t.preRelease=!!o?.preRelease,t.isBuiltin=t.type===0||!!o?.isBuiltin,t.installedTimestamp=o?.installedTimestamp}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),o=await this.scanAllUserExtensions(),s=new Set;for(const v of o)t[new w.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).key()]||s.add(v.identifier.id.toLowerCase());const a=(0,w.groupByExtension)(o,v=>v.identifier);await n.Promises.settled(a.map(async v=>{const P=v.sort((_,O)=>I.rcompare(_.manifest.version,O.manifest.version))[0];s.has(P.identifier.id.toLowerCase())||await this.beforeRemovingExtension(P)}));const h=o.filter(v=>t[new w.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).key()]);await n.Promises.settled(h.map(v=>this.removeUninstalledExtension(v)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),o=[],s=(0,w.groupByExtension)(t,a=>a.identifier);o.push(...(0,D.flatten)(s.map(a=>a.sort((h,v)=>I.rcompare(h.manifest.version,v.manifest.version)).slice(1)))),await n.Promises.settled(o.map(a=>this.removeExtension(a,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const o=Array.isArray(t)?t:[t];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((s,a)=>new Error(`${s.message}${s.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(A.FileAccess.asFileUri("",K).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const o=[p.Promises.readFile(R.join(t,"package.json"),"utf8").then(v=>this.parseManifest(v)),p.Promises.readFile(R.join(t,"package.nls.json"),"utf8").then(void 0,v=>v.code!=="ENOENT"?Promise.reject(v):"{}").then(v=>JSON.parse(v))],[{manifest:s,metadata:a},h]=await Promise.all(o);return{manifest:(0,y.localizeManifest)(s,h),metadata:a}}parseManifest(t){return new Promise((o,s)=>{try{const a=JSON.parse(t),h=a.__metadata||null;o({manifest:a,metadata:h})}catch{s(new Error((0,m.localize)(4,null)))}})}};c=de([Y(1,S.IFileService),Y(2,l.ILogService),Y(3,d.INativeEnvironmentService),Y(4,r.IProductService)],c),e.ExtensionsScanner=c}),define(ne[245],ie([0,1,37,9,18,10,4,32,19,61,7,29,22,66,132,81,15,206,30,31,188,173,243,189,244,220,78,13,6,8,27,21,34]),function(K,e,D,n,L,T,A,R,b,E,I,C,f,p,u,m,d,g,w,y,S,l,r,c,i,t,o,s,a,h,v,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let O=class extends g.AbstractExtensionManagementService{constructor(N,G,J,j,q,X,H,Z,ee){super(N,G,J,Z);this.environmentService=j,this.downloadService=q,this.fileService=H;const W=this._register(X.createInstance(l.ExtensionsLifecycle));this.extensionsScanner=this._register(X.createInstance(i.ExtensionsScanner,x=>W.postUninstall(x))),this.manifestCache=this._register(new c.ExtensionsManifestCache(j,this)),this.extensionsDownloader=this._register(X.createInstance(S.ExtensionsDownloader));const $=this._register(new t.ExtensionsWatcher(this,H,j,J,ee));this._register($.onDidChangeExtensionsByAnotherSource(({added:x,removed:z})=>{x.length&&this._onDidInstallExtensions.fire(x.map(B=>({identifier:B.identifier,operation:1,local:B}))),z.forEach(B=>this._onDidUninstallExtension.fire({identifier:B}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const N=await this.isAlpineLinux(),G=(0,w.getTargetPlatform)(N?"alpine":A.platform,R.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",G),G})()),this._targetPlatformPromise}async isAlpineLinux(){if(!A.isLinux)return!1;let N;try{N=(await this.fileService.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{N=(await this.fileService.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(J){this.logService.debug("Error while getting the os-release file.",(0,n.getErrorMessage)(J))}}return!!N&&(N.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(N){this.logService.trace("ExtensionManagementService#zip",N.identifier.id);const G=await this.collectFiles(N),J=await(0,p.zip)((0,b.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)()).fsPath,G);return I.URI.file(J)}async unzip(N){return this.logService.trace("ExtensionManagementService#unzip",N.toString()),(await this.install(N)).identifier}async getManifest(N){const G=await this.downloadVsix(N),J=T.resolve(G.fsPath);return(0,r.getManifest)(J)}getInstalled(N=null){return this.extensionsScanner.scanExtensions(N)}async install(N,G={}){this.logService.trace("ExtensionManagementService#install",N.toString());const J=await this.downloadVsix(N),j=await(0,r.getManifest)(T.resolve(J.fsPath));if(j.engines&&j.engines.vscode&&!(0,o.isEngineValid)(j.engines.vscode,this.productService.version,this.productService.date))throw new Error(u.localize(0,null,(0,y.getGalleryExtensionId)(j.publisher,j.name),this.productService.version));return this.installExtension(j,J,G)}async updateMetadata(N,G){this.logService.trace("ExtensionManagementService#updateMetadata",N.identifier.id);const J={...N.manifest.__metadata||{},...G};return G.isPreReleaseVersion&&(J.preRelease=!0),N=await this.extensionsScanner.saveMetadataForLocalExtension(N,J),this.manifestCache.invalidate(),N}async updateExtensionScope(N,G){return this.logService.trace("ExtensionManagementService#updateExtensionScope",N.identifier.id),N=await this.extensionsScanner.saveMetadataForLocalExtension(N,{...N.manifest.__metadata||{},isMachineScoped:G}),this.manifestCache.invalidate(),N}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(N){if(N.scheme===L.Schemas.file)return N;const G=(0,b.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)());return await this.downloadService.download(N,G),G}createInstallExtensionTask(N,G,J){return I.URI.isUri(G)?new M(N,G,J,this.galleryService,this.extensionsScanner,this.logService):new k(G,J,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(N,G){return new F(N,G,this.extensionsScanner)}async collectFiles(N){const G=async j=>{let q=await f.Promises.readdir(j);q=q.map(Z=>T.join(j,Z));const X=await Promise.all(q.map(Z=>f.Promises.stat(Z)));let H=Promise.resolve([]);return X.forEach((Z,ee)=>{const W=q[ee];Z.isFile()&&(H=H.then($=>[...$,W])),Z.isDirectory()&&(H=H.then($=>G(W).then(x=>[...$,...x])))}),H};return(await G(N.location.fsPath)).map(j=>({path:`extension/${T.relative(N.location.fsPath,j)}`,localPath:j}))}};O=de([Y(0,w.IExtensionGalleryService),Y(1,P.ITelemetryService),Y(2,h.ILogService),Y(3,d.INativeEnvironmentService),Y(4,m.IDownloadService),Y(5,a.IInstantiationService),Y(6,s.IFileService),Y(7,v.IProductService),Y(8,_.IUriIdentityService)],O),e.ExtensionManagementService=O;class U extends g.AbstractExtensionTask{constructor(N,G,J,j){super();this.identifier=N,this.source=G,this.extensionsScanner=J,this.logService=j,this._operation=2}get operation(){return this._operation}async installExtension(N,G){try{const J=await this.unsetUninstalledAndGetLocal(N.identifierWithVersion);if(J)return N.metadata?this.extensionsScanner.saveMetadataForLocalExtension(J,{...J.manifest.__metadata||{},...N.metadata}):J}catch{throw A.isMacintosh?new w.ExtensionManagementError(u.localize(1,null),w.ExtensionManagementErrorCode.Internal):new w.ExtensionManagementError(u.localize(2,null),w.ExtensionManagementErrorCode.Internal)}return this.extract(N,G)}async unsetUninstalledAndGetLocal(N){if(!await this.isUninstalled(N))return null;this.logService.trace("Removing the extension from uninstalled list:",N.id);const J=await this.extensionsScanner.setInstalled(N);return this.logService.info("Removed the extension from uninstalled list:",N.id),J}async isUninstalled(N){return!!(await this.extensionsScanner.getUninstalledExtensions())[N.key()]}async extract({zipPath:N,identifierWithVersion:G,metadata:J},j){let q=await this.extensionsScanner.extractUserExtension(G,N,J,j);return this.logService.info("Extracting completed.",G.id),q}}class k extends U{constructor(N,G,J,j,q){super(N.identifier,N,j,q);this.gallery=N,this.options=G,this.extensionsDownloader=J}async doRun(N){const J=(await this.extensionsScanner.scanExtensions(null)).find(q=>(0,y.areSameExtensions)(q.identifier,this.gallery.identifier));J&&(this._operation=3);const j=await this.downloadInstallableExtension(this.gallery,this._operation);j.metadata.isMachineScoped=this.options.isMachineScoped||J?.isMachineScoped,j.metadata.isBuiltin=this.options.isBuiltin||J?.isBuiltin,j.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,j.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:J?.preRelease||this.options.installPreReleaseVersion;try{const q=await this.installExtension(j,N);return J&&E.neq(J.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(J),q}catch(q){throw await this.deleteDownloadedVSIX(j.zipPath),q}}async deleteDownloadedVSIX(N){try{await this.extensionsDownloader.delete(I.URI.file(N))}catch(G){this.logService.warn("Error while deleting the downloaded vsix",N.toString(),(0,n.getErrorMessage)(G))}}async downloadInstallableExtension(N,G){const J={id:N.identifier.uuid,publisherId:N.publisherId,publisherDisplayName:N.publisherDisplayName};let j;try{this.logService.trace("Started downloading extension:",N.identifier.id),j=(await this.extensionsDownloader.downloadExtension(N,G)).fsPath,this.logService.info("Downloaded extension:",N.identifier.id,j)}catch(q){throw new w.ExtensionManagementError((0,g.joinErrors)(q).message,w.ExtensionManagementErrorCode.Download)}try{const q=await(0,r.getManifest)(j);return{zipPath:j,identifierWithVersion:new y.ExtensionIdentifierWithVersion(N.identifier,q.version),metadata:J}}catch(q){throw await this.deleteDownloadedVSIX(j),new w.ExtensionManagementError((0,g.joinErrors)(q).message,w.ExtensionManagementErrorCode.Invalid)}}}class M extends U{constructor(N,G,J,j,q,X){super({id:(0,y.getGalleryExtensionId)(N.publisher,N.name)},G,q,X);this.manifest=N,this.location=G,this.options=J,this.galleryService=j}async doRun(N){const G=new y.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),j=(await this.extensionsScanner.scanExtensions(1)).find(X=>(0,y.areSameExtensions)(this.identifier,X.identifier)),q=await this.getMetadata(this.identifier.id,this.manifest.version,N);if(q.isMachineScoped=this.options.isMachineScoped||j?.isMachineScoped,q.isBuiltin=this.options.isBuiltin||j?.isBuiltin,j)if(this._operation=3,G.equals(new y.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version)))try{await this.extensionsScanner.removeExtension(j,"existing")}catch{throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else E.gt(j.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(j);else{const X=await this.unsetUninstalledAndGetLocal(G);if(X)try{await this.extensionsScanner.removeExtension(X,"existing")}catch{throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:T.resolve(this.location.fsPath),identifierWithVersion:G,metadata:q},N)}async getMetadata(N,G,J){try{let[j]=await this.galleryService.getExtensions([{id:N,version:G}],J);if(j||([j]=await this.galleryService.getExtensions([{id:N}],J)),j)return{id:j.identifier.uuid,publisherDisplayName:j.publisherDisplayName,publisherId:j.publisherId,isPreReleaseVersion:j.properties.isPreReleaseVersion,preRelease:j.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class F extends g.AbstractExtensionTask{constructor(N,G,J){super();this.extension=N,this.options=G,this.extensionsScanner=J}async doRun(N){const G=[],J=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const j=new y.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);G.push(...J.filter(q=>j.equals(new y.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version))))}else G.push(...J.filter(j=>(0,y.areSameExtensions)(j.identifier,this.extension.identifier)));if(!G.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...G),this.options.remove)for(const j of G)try{N.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(j)}catch(q){throw new Error(u.localize(6,null,(0,D.toErrorMessage)(q)))}}}}),define(ne[246],ie([0,1,83,56,33,17,9,3,2,10,4,29,36,73,257]),function(K,e,D,n,L,T,A,R,b,E,I,C,f,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class m{constructor(P,_=""){this.debugLabel=_,this.socket=P,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,A.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener)}traceSocketEvent(P,_){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,P,_)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(P){const _=O=>{this.traceSocketEvent("read",O),P(T.VSBuffer.wrap(O))};return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(P){const _=O=>{this.traceSocketEvent("close",{hadError:O}),P({type:0,hadError:O,error:void 0})};return this.socket.on("close",_),{dispose:()=>this.socket.off("close",_)}}onEnd(P){const _=()=>{this.traceSocketEvent("nodeEndReceived"),P()};return this.socket.on("end",_),{dispose:()=>this.socket.off("end",_)}}write(P){if(!this.socket.destroyed)try{this.traceSocketEvent("write",P),this.socket.write(P.buffer,_=>{if(_){if(_.code==="EPIPE")return;(0,A.onUnexpectedError)(_)}})}catch(_){if(_.code==="EPIPE")return;(0,A.onUnexpectedError)(_)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((P,_)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),P();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),P()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=m;var d;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize"})(d||(d={}));var g;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(g||(g={}));class w extends b.Disposable{constructor(P,_,O,U){super();this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=P,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:_,inflateBytesLength:O?.byteLength||0,recordInflateBytes:U}),this._flowManager=this._register(new y(this,_,O,U,this._onData,(k,M)=>this._write(k,M))),this._register(this._flowManager.onError(k=>{console.error(k),(0,A.onUnexpectedError)(k),this._onClose.fire({type:0,hadError:!0,error:k})})),this._incomingData=new p.ChunkStream,this._register(this.socket.onData(k=>this._acceptChunk(k))),this._register(this.socket.onClose(k=>this._onClose.fire(k)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(P,_){this.socket.traceSocketEvent(P,_)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(P){return this._onData.event(P)}onClose(P){return this._onClose.event(P)}onEnd(P){return this.socket.onEnd(P)}write(P){this._flowManager.writeMessage(P)}_write(P,_){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",P);let O=2;P.byteLength<126?O+=0:P.byteLength<2**16?O+=2:O+=8;const U=T.VSBuffer.alloc(O);if(_?U.writeUInt8(194,0):U.writeUInt8(130,0),P.byteLength<126)U.writeUInt8(P.byteLength,1);else if(P.byteLength<2**16){U.writeUInt8(126,1);let k=1;U.writeUInt8(P.byteLength>>>8&255,++k),U.writeUInt8(P.byteLength>>>0&255,++k)}else{U.writeUInt8(127,1);let k=1;U.writeUInt8(0,++k),U.writeUInt8(0,++k),U.writeUInt8(0,++k),U.writeUInt8(0,++k),U.writeUInt8(P.byteLength>>>24&255,++k),U.writeUInt8(P.byteLength>>>16&255,++k),U.writeUInt8(P.byteLength>>>8&255,++k),U.writeUInt8(P.byteLength>>>0&255,++k)}this.socket.write(T.VSBuffer.concat([U,P]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(P){if(P.byteLength!==0){for(this._incomingData.acceptChunk(P);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),O=_.readUInt8(0),U=(O&128)>>>7,k=(O&64)>>>6,M=_.readUInt8(1),F=(M&128)>>>7,V=M&127;this._state.state=2,this._state.readLen=2+(F?4:0)+(V===126?2:0)+(V===127?8:0),this._state.fin=U,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(k)),this._state.firstFrameOfMessage=Boolean(U),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),O=_.readUInt8(1),U=(O&128)>>>7;let k=O&127,M=1;k===126?k=_.readUInt8(++M)*2**8+_.readUInt8(++M):k===127&&(k=_.readUInt8(++M)*0+_.readUInt8(++M)*0+_.readUInt8(++M)*0+_.readUInt8(++M)*0+_.readUInt8(++M)*2**24+_.readUInt8(++M)*2**16+_.readUInt8(++M)*2**8+_.readUInt8(++M));let F=0;U&&(F=_.readUInt8(++M)*2**24+_.readUInt8(++M)*2**16+_.readUInt8(++M)*2**8+_.readUInt8(++M)),this._state.state=3,this._state.readLen=k,this._state.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",_),r(_,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",_),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(_,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class y extends b.Disposable{constructor(P,_,O,U,k,M){super();this._tracer=P,this._onData=k,this._writeFn=M,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,_?(this._zlibInflateStream=this._register(new S(this._tracer,U,O,{windowBits:15})),this._zlibDeflateStream=this._register(new l(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(F=>this._onError.fire(F))),this._register(this._zlibDeflateStream.onError(F=>this._onError.fire(F)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:T.VSBuffer.alloc(0)}writeMessage(P){this._writeQueue.push(P),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const P=this._writeQueue.shift();if(this._zlibDeflateStream){const _=await this._deflateMessage(this._zlibDeflateStream,P);this._writeFn(_,!0)}else this._writeFn(P,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(P,_){return new Promise((O,U)=>{P.write(_),P.flush(k=>O(k))})}acceptFrame(P,_,O){this._readQueue.push({data:P,isCompressed:_,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const P=this._readQueue.shift();if(this._zlibInflateStream&&P.isCompressed){const _=await this._inflateFrame(this._zlibInflateStream,P.data,P.isLastFrameOfMessage);this._onData.fire(_)}else this._onData.fire(P.data)}this._isProcessingReadQueue=!1}}_inflateFrame(P,_,O){return new Promise((U,k)=>{P.write(_),O&&P.write(T.VSBuffer.fromByteArray([0,0,255,255])),P.flush(M=>U(M))})}}class S extends b.Disposable{constructor(P,_,O,U){super();this._tracer=P,this._recordInflateBytes=_,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=u.createInflateRaw(U),this._zlibInflate.on("error",k=>{this._tracer.traceSocketEvent("zlibInflateError",{message:k?.message,code:k?.code}),this._onError.fire(k)}),this._zlibInflate.on("data",k=>{this._tracer.traceSocketEvent("zlibInflateData",k),this._pendingInflateData.push(T.VSBuffer.wrap(k))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?T.VSBuffer.concat(this._recordedInflateBytes):T.VSBuffer.alloc(0)}write(P){this._recordInflateBytes&&this._recordedInflateBytes.push(P.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",P),this._zlibInflate.write(P.buffer)}flush(P){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const _=T.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,P(_)})}}class l extends b.Disposable{constructor(P,_){super();this._tracer=P,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=u.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(T.VSBuffer.wrap(O))})}write(P){this._tracer.traceSocketEvent("zlibDeflateWrite",P.buffer),this._zlibDeflate.write(P.buffer)}flush(P){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let _=T.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.byteLength-4),P(_)})}}function r(v,P){if(P===0)return;let _=v.byteLength>>>2;for(let V=0;V<_;V++){const N=v.readUInt32BE(V*4);v.writeUInt32BE(N^P,V*4)}let O=_*4,U=v.byteLength-O;const k=P>>>24&255,M=P>>>16&255,F=P>>>8&255;U>=1&&v.writeUInt8(v.readUInt8(O)^k,O),U>=2&&v.writeUInt8(v.readUInt8(O+1)^M,O+1),U>=3&&v.writeUInt8(v.readUInt8(O+2)^F,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function i(){const v=(0,C.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;let P;return e.XDG_RUNTIME_DIR?P=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${v}.sock`):P=(0,E.join)((0,L.tmpdir)(),`vscode-ipc-${v}.sock`),o(P),P}e.createRandomIPCHandle=i;function t(v,P,_){const O=(0,D.createHash)("md5").update(v).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${_}-${P}-sock`;let U;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?U=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-${O.substr(0,8)}-${_}-${P}.sock`):U=(0,E.join)(v,`${_}-${P}.sock`),o(U),U}e.createStaticIPCHandle=t;function o(v){const P=c[I.platform];typeof P=="number"&&v.length>=P&&console.warn(`WARNING: IPC handle "${v}" is longer than ${P} chars, try a shorter --user-data-dir`)}class s extends f.IPCServer{constructor(P){super(s.toClientConnectionEvent(P));this.server=P}static toClientConnectionEvent(P){const _=R.Event.fromNodeEventEmitter(P,"connection");return R.Event.map(_,O=>({protocol:new p.Protocol(new m(O,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(O,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function a(v){return new Promise((P,_)=>{const O=(0,n.createServer)();O.on("error",_),O.listen(v,()=>{O.removeListener("error",_),P(new s(O))})})}e.serve=a;function h(v,P){return new Promise((_,O)=>{const U=(0,n.createConnection)(v,()=>{U.removeListener("error",O),_(p.Client.fromSocket(new m(U,`ipc-client${P}`),P))});U.once("error",O)})}e.connect=h}),define(ne[247],ie([0,1,56,246]),function(K,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(L,T,A,R,b){const E=C=>b(C,void 0),I=D.createConnection({host:L,port:T},()=>{I.removeListener("error",E);const C=Buffer.alloc(16);for(let m=0;m<16;m++)C[m]=Math.round(Math.random()*256);const f=C.toString("base64"),p=[`GET ws://${/:/.test(L)?`[${L}]`:L}:${T}/?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];I.write(p.join(`\r
`)+`\r
\r
`);const u=m=>{m.toString().indexOf(`\r
\r
`)>=0&&(I.off("data",u),b(void 0,new n.NodeSocket(I,R)))};I.on("data",u)});I.setNoDelay(!0),I.once("error",E)}}}),define(ne[248],ie([0,1,56,115,247,5,2,20,8,27,184,62,92]),function(K,e,D,n,L,T,A,R,b,E,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(w,y,S,l,r){let c;for(let i=3;i&&(c&&c.dispose(),c=await new u(w,y,S,l,r).waitForReady(),!(r&&n.BROWSER_RESTRICTED_PORTS[r]||!n.BROWSER_RESTRICTED_PORTS[c.tunnelLocalPort]));i--);return c}class u extends A.Disposable{constructor(y,S,l,r,c){super();this.defaultTunnelHost=S,this.suggestedLocalPort=c,this.privacy=C.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=y,this._server=D.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(S=>{S()})}async waitForReady(){let y=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),S=null;return this._server.listen(y,this.defaultTunnelHost),await this._barrier.wait(),S=this._server.address(),S||(y=0,this._server.listen(y,this.defaultTunnelHost),await this._barrier.wait(),S=this._server.address()),this.tunnelLocalPort=S.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${S.port}`,this}async _onConnection(y){y.pause();const S=(0,C.isLocalhost)(this.tunnelRemoteHost)||(0,C.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,I.connectRemoteAgentTunnel)(this._options,S,this.tunnelRemotePort),r=l.getSocket().socket,c=l.readEntireBuffer();l.dispose(),c.byteLength>0&&y.write(c.buffer),y.on("end",()=>{y.localAddress&&this._socketsDispose.delete(y.localAddress),r.end()}),y.on("close",()=>r.end()),y.on("error",()=>{y.localAddress&&this._socketsDispose.delete(y.localAddress),r.destroy()}),r.on("end",()=>y.end()),r.on("close",()=>y.end()),r.on("error",()=>{y.destroy()}),y.pipe(r),r.pipe(y),y.localAddress&&this._socketsDispose.set(y.localAddress,()=>{y.end(),r.end()})}}let m=class extends C.AbstractTunnelService{constructor(y,S,l,r,c){super(S);this.socketFactory=y,this.signService=l,this.productService=r,this.configurationService=c}get defaultTunnelHost(){const y=this.configurationService.getValue("remote.localPortHost");return!y||y==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(y,S,l,r,c,i,t){const o=this.getTunnelFromMap(S,l);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,S,l,r,c,i,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${S}:${l} on local port ${r}.`);const s={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:y,signService:this.signService,logService:this.logService,ipcLogger:null},a=p(s,this.defaultTunnelHost,S,l,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(S,l,a),a}}};m=de([Y(1,b.ILogService),Y(2,f.ISignService),Y(3,E.IProductService),Y(4,R.IConfigurationService)],m),e.BaseTunnelService=m;let d=class extends m{constructor(y,S,l,r){super(L.nodeSocketFactory,y,S,l,r)}};d=de([Y(0,b.ILogService),Y(1,f.ISignService),Y(2,E.IProductService),Y(3,R.IConfigurationService)],d),e.TunnelService=d;let g=class extends A.Disposable{constructor(y,S,l,r){super();this.logService=y,this.productService=S,this.signService=l,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(y,S,l,r,c,i,t,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${r} on local port ${c}.`),!this._tunnelServices.has(y)){const s=new d(this.logService,this.signService,this.productService,this.configurationService);this._register(s),this._tunnelServices.set(y,s),s.onTunnelClosed(async()=>{(await s.tunnels).length===0&&(s.dispose(),this._tunnelServices.delete(y))})}return this._tunnelServices.get(y).openTunnel(S,l,r,c,i,t,o)}};g=de([Y(0,b.ILogService),Y(1,E.IProductService),Y(2,f.ISignService),Y(3,R.IConfigurationService)],g),e.SharedTunnelsService=g}),define(ne[258],ie([0,1,74,33,37,9,2,18,19,7,36,118,178,201,179,170,171,172,157,159,20,182,80,205,81,194,15,198,200,209,30,186,207,245,82,155,13,175,177,51,6,167,85,168,169,59,190,8,86,60,87,27,193,43,24,203,204,21,93,94,95,44,210,211,96,213,219,63,98,25,64,233,235,236,65,234,238,239,240,241,242,92,199,62,248,191,192,91,197,208,34,221,4,222,162,181,180]),function(K,e,D,n,L,T,A,R,b,E,I,C,f,p,u,m,d,g,w,y,S,l,r,c,i,t,o,s,a,h,v,P,_,O,U,k,M,F,V,N,G,J,j,q,X,H,Z,ee,W,$,x,z,B,te,se,ce,he,ve,pe,Ie,Ee,ye,be,Re,Ne,Ue,qe,xe,re,ae,ue,we,Ce,Fe,Te,Oe,_e,Q,oe,le,fe,ge,Le,Se,De,ke,Pe,Ae,$e,je,Be,Pt,Rt,Dt,pt,kt,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Lt extends A.Disposable{constructor(me){super();this.configuration=me,this.server=this._register(new C.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const me=()=>this.dispose();process.once("exit",me),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",me);const Me="vscode:electron-main->shared-process=disposeWorker",ze=(Ye,We)=>this.onDisposeWorker(We);D.ipcRenderer.on(Me,ze),this._register((0,A.toDisposable)(()=>D.ipcRenderer.removeListener(Me,ze)))}onDisposeWorker(me){this.sharedProcessWorkerService?.disposeWorker(me)}async open(){const me=await this.initServices();(0,ae.registerConfiguration)(),me.invokeFunction(Me=>{const ze=Me.get(ee.ILogService);ze.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Me),this.registerErrorHandler(ze)}),this._register((0,A.combinedDisposable)(me.createInstance(f.CodeCacheCleaner,this.configuration.codeCachePath),me.createInstance(u.LanguagePackCachedDataCleaner),me.createInstance(g.StorageDataCleaner,this.configuration.backupWorkspacesPath),me.createInstance(d.LogsDataCleaner),me.createInstance(m.LocalizationsUpdater),me.createInstance(p.ExtensionsCleaner)))}async initServices(){const me=new j.ServiceCollection,Me={_serviceBrand:void 0,...x.default};me.set(z.IProductService,Me);const ze=new I.StaticRouter(Ge=>Ge==="main"),Ye=new q.MessagePortMainProcessService(this.server,ze);me.set(X.IMainProcessService,Ye);const We=new s.SharedProcessEnvironmentService(this.configuration.args,Me);me.set(o.INativeEnvironmentService,We);const it=new W.LogLevelChannelClient(this.server.getChannel("logLevel",ze)),Xe=new W.LoggerChannelClient(this.configuration.logLevel,it.onDidChangeLogLevel,Ye.getChannel("logger"));me.set(ee.ILoggerService,Xe);const ot=this._register(new ee.MultiplexLogService([this._register(new ee.ConsoleLogger(this.configuration.logLevel)),this._register(Xe.createLogger((0,b.joinPath)(E.URI.file(We.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Je=this._register(new W.FollowerLogService(it,ot));me.set(ee.ILogService,Je),this.sharedProcessWorkerService=new $e.SharedProcessWorkerService(Je),me.set(Ae.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Ve=this._register(new F.FileService(Je));me.set(M.IFileService,Ve);const at=this._register(new V.DiskFileSystemProvider(Je));Ve.registerProvider(R.Schemas.file,at);const ct=this._register(new Dt.FileUserDataProvider(R.Schemas.file,this._register(new pt.DiskFileSystemProviderClient(Ye.getChannel(pt.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Rt.isLinux})),R.Schemas.userData,Ve,Je));Ve.registerProvider(R.Schemas.userData,ct);const He=this._register(new l.ConfigurationService(We.settingsResource,Ve));me.set(S.IConfigurationService,He);const et=new ce.NativeStorageService(void 0,Ye,We);me.set(se.IStorageService,et),this._register((0,A.toDisposable)(()=>et.flush())),await Promise.all([He.initialize(),et.initialize()]),me.set(Be.IUriIdentityService,new Pt.UriIdentityService(Ve)),me.set(te.IRequestService,new N.SyncDescriptor(B.RequestService)),me.set(w.IChecksumService,new N.SyncDescriptor(y.ChecksumService)),me.set(St.IV8InspectProfilingService,new N.SyncDescriptor(kt.InspectProfilingService));const rt=I.ProxyChannel.toService(Ye.getChannel("nativeHost"),{context:this.configuration.windowId});me.set($.INativeHostService,rt),me.set(i.IDownloadService,new N.SyncDescriptor(t.DownloadService));const lt=this._register(new fe.ActiveWindowManager(rt)),ut=new I.StaticRouter(Ge=>lt.getActiveClientId().then(dt=>Ge===dt));me.set(U.IExtensionRecommendationNotificationService,new k.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));const ht=new je.AssignmentService(this.configuration.machineId,He,Me);let tt;const Qe=[];if((0,ye.supportsTelemetry)(Me,We)){const Ge=new Ie.TelemetryLogAppender(Xe,We);Qe.push(Ge);const{appRoot:dt,extensionsPath:_t,installSourcePath:Ot}=We;if(Me.aiConfig&&Me.aiConfig.asimovKey){const st=await ht.getTreatment("telemetryMigration")??!1,ft=Me.quality!=="stable";if(ft&&st){const bt=new be.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey,st,!0);this._register((0,A.toDisposable)(()=>bt.flush())),Qe.push(bt)}const Et=new be.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey,ft?!1:st,st&&ft);this._register((0,A.toDisposable)(()=>Et.flush())),Qe.push(Et)}tt=new Ee.TelemetryService({appenders:Qe,commonProperties:(0,he.resolveCommonProperties)(Ve,(0,n.release)(),(0,n.hostname)(),process.arch,Me.commit,Me.version,this.configuration.machineId,Me.msftInternalDomains,Ot),sendErrorTelemetry:!0,piiPaths:[dt,_t]},He)}else{tt=ye.NullTelemetryService;const Ge=ye.NullAppender;Qe.push(Ge)}this.server.registerChannel("telemetryAppender",new pe.TelemetryAppenderChannel(Qe)),me.set(ve.ITelemetryService,tt);const At=new Re.CustomEndpointTelemetryService(He,tt,Xe,We);me.set(ve.ICustomEndpointTelemetryService,At),me.set(v.IExtensionManagementService,new N.SyncDescriptor(O.ExtensionManagementService)),me.set(v.IExtensionGalleryService,new N.SyncDescriptor(h.ExtensionGalleryService)),me.set(v.IExtensionTipsService,new N.SyncDescriptor(_.ExtensionTipsService)),me.set(H.ILocalizationsService,new N.SyncDescriptor(Z.LocalizationsService)),me.set(r.IDiagnosticsService,new N.SyncDescriptor(c.DiagnosticsService)),me.set(ue.IUserDataSyncAccountService,new N.SyncDescriptor(ue.UserDataSyncAccountService)),me.set(ae.IUserDataSyncLogService,new N.SyncDescriptor(Fe.UserDataSyncLogService)),me.set(ae.IUserDataSyncUtilService,new Ce.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ge=>Ge.ctx!=="main"))),me.set(v.IGlobalExtensionEnablementService,new N.SyncDescriptor(a.GlobalExtensionEnablementService)),me.set(re.IIgnoredExtensionsManagementService,new N.SyncDescriptor(re.IgnoredExtensionsManagementService)),me.set(xe.IExtensionStorageService,new N.SyncDescriptor(xe.ExtensionStorageService)),me.set(ae.IUserDataSyncStoreManagementService,new N.SyncDescriptor(oe.UserDataSyncStoreManagementService)),me.set(ae.IUserDataSyncStoreService,new N.SyncDescriptor(oe.UserDataSyncStoreService)),me.set(Te.IUserDataSyncMachinesService,new N.SyncDescriptor(Te.UserDataSyncMachinesService)),me.set(ae.IUserDataSyncBackupStoreService,new N.SyncDescriptor(we.UserDataSyncBackupStoreService)),me.set(ae.IUserDataSyncEnablementService,new N.SyncDescriptor(Oe.UserDataSyncEnablementService)),me.set(ae.IUserDataSyncService,new N.SyncDescriptor(_e.UserDataSyncService));const wt=new qe.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:He.getValue("terminal.integrated.persistentSessionScrollback")??100},He,We,Je,tt);return await wt.initialize(),me.set(Ue.ILocalPtyService,this._register(wt)),me.set(ge.ISignService,new N.SyncDescriptor(Le.SignService)),me.set(Se.ISharedTunnelsService,new N.SyncDescriptor(De.SharedTunnelsService)),me.set(ke.ISharedProcessTunnelService,new N.SyncDescriptor(Pe.SharedProcessTunnelService)),new J.InstantiationService(me)}initChannels(me){const Me=new P.ExtensionManagementChannel(me.get(v.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Me);const ze=I.ProxyChannel.fromService(me.get(H.ILocalizationsService));this.server.registerChannel("localizations",ze);const Ye=I.ProxyChannel.fromService(me.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",Ye);const We=new P.ExtensionTipsChannel(me.get(v.IExtensionTipsService));this.server.registerChannel("extensionTipsService",We);const it=I.ProxyChannel.fromService(me.get(w.IChecksumService));this.server.registerChannel("checksum",it);const Xe=I.ProxyChannel.fromService(me.get(St.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",Xe);const ot=new Ce.UserDataSyncMachinesServiceChannel(me.get(Te.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ot);const Je=I.ProxyChannel.fromService(me.get(ve.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Je);const Ve=new Ce.UserDataSyncAccountServiceChannel(me.get(ue.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ve);const at=new Ce.UserDataSyncStoreManagementServiceChannel(me.get(ae.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",at);const ct=new Q.UserDataSyncChannel(me.get(ae.IUserDataSyncService),me.get(ee.ILogService));this.server.registerChannel("userDataSync",ct);const He=this._register(me.get(G.IInstantiationService).createInstance(le.UserDataAutoSyncService)),et=new Ce.UserDataAutoSyncChannel(He);this.server.registerChannel("userDataAutoSync",et);const rt=me.get(Ue.ILocalPtyService),lt=I.ProxyChannel.fromService(rt);this.server.registerChannel(Ne.TerminalIpcChannels.LocalPty,lt);const ut=I.ProxyChannel.fromService(me.get(ke.ISharedProcessTunnelService));this.server.registerChannel(ke.ipcSharedProcessTunnelChannelName,ut);const ht=I.ProxyChannel.fromService(me.get(Ae.ISharedProcessWorkerService));this.server.registerChannel(Ae.ipcSharedProcessWorkerChannelName,ht)}registerErrorHandler(me){window.addEventListener("unhandledrejection",Me=>{(0,T.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,T.setUnexpectedErrorHandler)(Me=>{const ze=(0,L.toErrorMessage)(Me,!0);!ze||me.error(`[uncaught exception in sharedProcess]: ${ze}`)})}}async function Tt(yt){const me=new Lt(yt);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await me.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Tt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/865a677399f0c0a1e98e0b9eb7308f1297b6ace4/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
