/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/errors","vs/base/common/resources","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/platform/product/common/productService","vs/platform/environment/electron-main/environmentMainService","vs/base/node/pfs","vs/base/common/strings","os","vs/base/common/arrays","vs/base/common/extpath","fs","vs/platform/telemetry/common/telemetry","vs/platform/workspaces/common/workspaces","vs/base/common/uuid","vs/base/common/labels","vs/base/common/process","vs/base/common/map","vs/platform/windows/electron-main/windows","vs/base/parts/ipc/common/ipc","vs/platform/state/electron-main/state","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/json","child_process","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/objects","vs/platform/environment/common/environment","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/stream","vs/platform/backup/electron-main/backup","vs/platform/environment/node/argvHelper","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/base/parts/ipc/node/ipc.net","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/keybindings","crypto","net","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/hash","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/stopwatch","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/node/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/common/io","vs/platform/credentials/node/credentialsMainService","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/url/common/url","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/keybindingParser","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/common/worker/simpleWorker","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/credentials/common/credentials","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagement","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/extensions/electron-main/workerMainProcessExtensionHostStarter","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","graceful-fs","worker_threads","vs/code/electron-main/main"],te=function(j){for(var e=[],p=0,n=j.length;p<n;p++)e[p]=ee[j[p]];return e};define(ee[104],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(n,D){if(!n)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=p}),define(ee[105],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function p(P){return P?P.replace(/\$\((.*?)\)/g,(E,w)=>` ${w} `).trim():""}e.getCodiconAriaLabel=p;class n{constructor(E,w,S){this.id=E,this.definition=w,this.description=S,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function D(P,E){const w=["codicon","codicon-"+P];return E&&w.push("codicon-modifier-"+E),w}e.getClassNamesArray=D;var M;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function w(k){if(k instanceof n)return["codicon","codicon-"+k.id];const y=E.exec(k.id);if(!y)return w(n.error);let[,g,t]=y;const d=["codicon","codicon-"+g];return t&&d.push("codicon-modifier-"+t.substr(1)),d}P.asClassNameArray=w;function S(k){return w(k).join(" ")}P.asClassName=S;function b(k){return"."+w(k).join(".")}P.asCSSSelector=b})(M=e.CSSIcon||(e.CSSIcon={}))}),define(ee[46],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(P){return(E,w,S)=>{let b=null,k=null;if(typeof S.value=="function"?(b="value",k=S.value):typeof S.get=="function"&&(b="get",k=S.get),!k)throw new Error("not supported");S[b]=P(k,w)}}e.createDecorator=p;function n(P,E,w){let S=null,b=null;if(typeof w.value=="function"?(S="value",b=w.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(S="get",b=w.get),!b)throw new Error("not supported");const k=`$memoize$${E}`;w[S]=function(...y){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,y)}),this[k]}}e.memoize=n;function D(P,E,w){return p((S,b)=>{const k=`$debounce$${b}`,y=`$debounce$result$${b}`;return function(...g){this[y]||(this[y]=w?w():void 0),clearTimeout(this[k]),E&&(this[y]=E(this[y],...g),g=[this[y]]),this[k]=setTimeout(()=>{S.apply(this,g),this[y]=w?w():void 0},P)}})}e.debounce=D;function M(P,E,w){return p((S,b)=>{const k=`$throttle$timer$${b}`,y=`$throttle$result$${b}`,g=`$throttle$lastRun$${b}`,t=`$throttle$pending$${b}`;return function(...d){if(this[y]||(this[y]=w?w():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),E&&(this[y]=E(this[y],...d)),this[t])return;const m=this[g]+P;m<=Date.now()?(this[g]=Date.now(),S.apply(this,[this[y]]),this[y]=w?w():void 0):(this[t]=!0,this[k]=setTimeout(()=>{this[t]=!1,this[g]=Date.now(),S.apply(this,[this[y]]),this[y]=w?w():void 0},m-Date.now()))}})}e.throttle=M}),define(ee[15],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(l=>{l(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=p,e.errorHandler=new p;function n(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=n;function D(c){w(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=D;function M(c){w(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=M;function P(c){if(c instanceof Error){let{name:o,message:l}=c;const s=c.stacktrace||c.stack;return{$isError:!0,name:o,message:l,stack:s}}return c}e.transformErrorForSerialization=P;const E="Canceled";function w(c){return c instanceof S?!0:c instanceof Error&&c.name===E&&c.message===E}e.isCancellationError=w;class S extends Error{constructor(){super(E);this.name=this.message}}e.CancellationError=S;function b(){const c=new Error(E);return c.name=c.message,c}e.canceled=b;function k(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=k;function y(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=y;function g(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function t(c){const o=new Error(`${c} has been disposed`);return o.name="DISPOSED",o}e.disposed=t;function d(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=d;class m extends Error{constructor(o){super("NotImplemented");o&&(this.message=o)}}e.NotImplementedError=m;class v extends Error{constructor(o){super("NotSupported");o&&(this.message=o)}}e.NotSupportedError=v;class C extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=C;function u(c){const o=c;return o instanceof Error&&Array.isArray(o.actions)}e.isErrorWithActions=u;function f(c,o=Object.create(null)){const l=new Error(c);return o.actions&&(l.actions=o.actions),l}e.createErrorWithActions=f}),define(ee[27],te([0,1,15]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(A,T=0){return A[A.length-(1+T)]}e.tail=n;function D(A){if(A.length===0)throw new Error("Invalid tail call");return[A.slice(0,A.length-1),A[A.length-1]]}e.tail2=D;function M(A,T,U=(O,_)=>O===_){if(A===T)return!0;if(!A||!T||A.length!==T.length)return!1;for(let O=0,_=A.length;O<_;O++)if(!U(A[O],T[O]))return!1;return!0}e.equals=M;function P(A,T,U){let O=0,_=A.length-1;for(;O<=_;){const Q=(O+_)/2|0,ie=U(A[Q],T);if(ie<0)O=Q+1;else if(ie>0)_=Q-1;else return Q}return-(O+1)}e.binarySearch=P;function E(A,T){let U=0,O=A.length;if(O===0)return 0;for(;U<O;){const _=Math.floor((U+O)/2);T(A[_])?O=_:U=_+1}return U}e.findFirstInSorted=E;function w(A,T,U){if(A=A|0,A>=T.length)throw new TypeError("invalid index");let O=T[Math.floor(T.length*Math.random())],_=[],Q=[],ie=[];for(let se of T){const x=U(se,O);x<0?_.push(se):x>0?Q.push(se):ie.push(se)}return A<_.length?w(A,_,U):A<_.length+ie.length?ie[0]:w(A-(_.length+ie.length),Q,U)}e.quickSelect=w;function S(A,T){const U=[];let O;for(const _ of A.slice(0).sort(T))!O||T(O[0],_)!==0?(O=[_],U.push(O)):O.push(_);return U}e.groupBy=S;function b(A,T,U){const O=[];function _(se,x,ce){if(x===0&&ce.length===0)return;const le=O[O.length-1];le&&le.start+le.deleteCount===se?(le.deleteCount+=x,le.toInsert.push(...ce)):O.push({start:se,deleteCount:x,toInsert:ce})}let Q=0,ie=0;for(;;){if(Q===A.length){_(Q,0,T.slice(ie));break}if(ie===T.length){_(Q,A.length-Q,[]);break}const se=A[Q],x=T[ie],ce=U(se,x);ce===0?(Q+=1,ie+=1):ce<0?(_(Q,1,[]),Q+=1):ce>0&&(_(Q,0,[x]),ie+=1)}return O}e.sortedDiff=b;function k(A,T,U){const O=b(A,T,U),_=[],Q=[];for(const ie of O)_.push(...A.slice(ie.start,ie.start+ie.deleteCount)),Q.push(...ie.toInsert);return{removed:_,added:Q}}e.delta=k;function y(A,T,U){if(U===0)return[];const O=A.slice(0,U).sort(T);return t(A,T,O,U,A.length),O}e.top=y;function g(A,T,U,O,_){return U===0?Promise.resolve([]):new Promise((Q,ie)=>{(async()=>{const se=A.length,x=A.slice(0,U).sort(T);for(let ce=U,le=Math.min(U+O,se);ce<se;ce=le,le=Math.min(le+O,se)){if(ce>U&&await new Promise(he=>setTimeout(he)),_&&_.isCancellationRequested)throw(0,p.canceled)();t(A,T,x,ce,le)}return x})().then(Q,ie)})}e.topAsync=g;function t(A,T,U,O,_){for(const Q=U.length;O<_;O++){const ie=A[O];if(T(ie,U[Q-1])<0){U.pop();const se=E(U,x=>T(ie,x)<0);U.splice(se,0,ie)}}}function d(A){return A.filter(T=>!!T)}e.coalesce=d;function m(A){let T=0;for(let U=0;U<A.length;U++)A[U]&&(A[T]=A[U],T+=1);A.length=T}e.coalesceInPlace=m;function v(A,T,U){A.splice(U,0,A.splice(T,1)[0])}e.move=v;function C(A){return!Array.isArray(A)||A.length===0}e.isFalsyOrEmpty=C;function u(A){return Array.isArray(A)&&A.length>0}e.isNonEmptyArray=u;function f(A,T=U=>U){const U=new Set;return A.filter(O=>{const _=T(O);return U.has(_)?!1:(U.add(_),!0)})}e.distinct=f;function c(A){const T=new Set;return U=>{const O=A(U);return T.has(O)?!1:(T.add(O),!0)}}e.uniqueFilter=c;function o(A,T){const U=l(A,T);if(U!==-1)return A[U]}e.findLast=o;function l(A,T){for(let U=A.length-1;U>=0;U--){const O=A[U];if(T(O))return U}return-1}e.lastIndex=l;function s(A,T){return A.length>0?A[0]:T}e.firstOrDefault=s;function i(A,T,U=(O,_)=>O===_){let O=0;for(let _=0,Q=Math.min(A.length,T.length);_<Q&&U(A[_],T[_]);_++)O++;return O}e.commonPrefixLength=i;function r(A){return[].concat(...A)}e.flatten=r;function a(A,T){let U=typeof T=="number"?A:0;typeof T=="number"?U=A:(U=0,T=A);const O=[];if(U<=T)for(let _=U;_<T;_++)O.push(_);else for(let _=U;_>T;_--)O.push(_);return O}e.range=a;function h(A,T,U){return A.reduce((O,_)=>(O[T(_)]=U?U(_):_,O),Object.create(null))}e.index=h;function I(A,T){return A.push(T),()=>R(A,T)}e.insert=I;function R(A,T){const U=A.indexOf(T);if(U>-1)return A.splice(U,1),T}e.remove=R;function L(A,T,U){const O=A.slice(0,T),_=A.slice(T);return O.concat(U,_)}e.arrayInsert=L;function W(A,T){let U;if(typeof T=="number"){let O=T;U=()=>{const _=Math.sin(O++)*179426549;return _-Math.floor(_)}}else U=Math.random;for(let O=A.length-1;O>0;O-=1){const _=Math.floor(U()*(O+1)),Q=A[O];A[O]=A[_],A[_]=Q}}e.shuffle=W;function N(A,T){const U=A.indexOf(T);U>-1&&(A.splice(U,1),A.unshift(T))}e.pushToStart=N;function J(A,T){const U=A.indexOf(T);U>-1&&(A.splice(U,1),A.push(T))}e.pushToEnd=J;function oe(A,T){return Array.isArray(A)?A.map(T):T(A)}e.mapArrayOrNot=oe;function re(A){return Array.isArray(A)?A:[A]}e.asArray=re;function V(A){return A[Math.floor(Math.random()*A.length)]}e.getRandomElement=V;function Z(A,T){for(const U of A){const O=T(U);if(O!==void 0)return O}}e.mapFind=Z;function H(A,T,U){const O=G(A,T),_=A.length,Q=U.length;A.length=_+Q;for(let ie=_-1;ie>=O;ie--)A[ie+Q]=A[ie];for(let ie=0;ie<Q;ie++)A[ie+O]=U[ie]}e.insertInto=H;function K(A,T,U,O){const _=G(A,T),Q=A.splice(_,U);return H(A,_,O),Q}e.splice=K;function G(A,T){return T<0?Math.max(T+A.length,0):Math.min(T,A.length)}function z(A,T){return(U,O)=>T(A(U),A(O))}e.compareBy=z;const B=(A,T)=>A-T;e.numberComparator=B;function Y(A,T){if(A.length===0)return;let U=A[0];for(let O=1;O<A.length;O++){const _=A[O];T(_,U)>0&&(U=_)}return U}e.findMaxBy=Y;function q(A,T){if(A.length===0)return;let U=A[0];for(let O=1;O<A.length;O++){const _=A[O];T(_,U)>=0&&(U=_)}return U}e.findLastMaxBy=q;function F(A,T){return Y(A,(U,O)=>-T(U,O))}e.findMinBy=F;class ${constructor(T){this.items=T,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(T){let U=this.firstIdx;for(;U<this.items.length&&T(this.items[U]);)U++;const O=U===this.firstIdx?null:this.items.slice(this.firstIdx,U);return this.firstIdx=U,O}takeFromEndWhile(T){let U=this.lastIdx;for(;U>=0&&T(this.items[U]);)U--;const O=U===this.lastIdx?null:this.items.slice(U+1,this.lastIdx+1);return this.lastIdx=U,O}peek(){return this.items[this.firstIdx]}dequeue(){const T=this.items[this.firstIdx];return this.firstIdx++,T}takeCount(T){const U=this.items.slice(this.firstIdx,this.firstIdx+T);return this.firstIdx+=T,U}}e.ArrayQueue=$}),define(ee[42],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(n){const D=this;let M=!1,P;return function(){return M||(M=!0,P=n.apply(D,arguments)),P}}e.once=p}),define(ee[70],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(n){function D(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}n.is=D;const M=Object.freeze([]);function P(){return M}n.empty=P;function*E(c){yield c}n.single=E;function w(c){return c||M}n.from=w;function S(c){return!c||c[Symbol.iterator]().next().done===!0}n.isEmpty=S;function b(c){return c[Symbol.iterator]().next().value}n.first=b;function k(c,o){for(const l of c)if(o(l))return!0;return!1}n.some=k;function y(c,o){for(const l of c)if(o(l))return l}n.find=y;function*g(c,o){for(const l of c)o(l)&&(yield l)}n.filter=g;function*t(c,o){let l=0;for(const s of c)yield o(s,l++)}n.map=t;function*d(...c){for(const o of c)for(const l of o)yield l}n.concat=d;function*m(c){for(const o of c)for(const l of o)yield l}n.concatNested=m;function v(c,o,l){let s=l;for(const i of c)s=o(s,i);return s}n.reduce=v;function*C(c,o,l=c.length){for(o<0&&(o+=c.length),l<0?l+=c.length:l>c.length&&(l=c.length);o<l;o++)yield c[o]}n.slice=C;function u(c,o=Number.POSITIVE_INFINITY){const l=[];if(o===0)return[l,c];const s=c[Symbol.iterator]();for(let i=0;i<o;i++){const r=s.next();if(r.done)return[l,n.empty()];l.push(r.value)}return[l,{[Symbol.iterator](){return s}}]}n.consume=u;function f(c,o,l=(s,i)=>s===i){const s=c[Symbol.iterator](),i=o[Symbol.iterator]();for(;;){const r=s.next(),a=i.next();if(r.done!==a.done)return!1;if(r.done)return!0;if(!l(r.value,a.value))return!1}}n.equals=f})(p=e.Iterable||(e.Iterable={}))}),define(ee[43],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var n;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(o){o.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function P(o,l=!1){let s=0,i=o.length,r="",a=0,h=16,I=0;function R(V){let Z=0,H=0;for(;Z<V;){const K=o.charCodeAt(s);if(K>=48&&K<=57)H=H*16+K-48;else if(K>=65&&K<=70)H=H*16+K-65+10;else if(K>=97&&K<=102)H=H*16+K-97+10;else break;s++,Z++}return Z<V&&(H=-1),H}function L(V){s=V,r="",a=0,h=16,I=0}function W(){const V=s;if(o.charCodeAt(s)===48)s++;else for(s++;s<o.length&&S(o.charCodeAt(s));)s++;if(s<o.length&&o.charCodeAt(s)===46)if(s++,s<o.length&&S(o.charCodeAt(s)))for(s++;s<o.length&&S(o.charCodeAt(s));)s++;else return I=3,o.substring(V,s);let Z=s;if(s<o.length&&(o.charCodeAt(s)===69||o.charCodeAt(s)===101))if(s++,(s<o.length&&o.charCodeAt(s)===43||o.charCodeAt(s)===45)&&s++,s<o.length&&S(o.charCodeAt(s))){for(s++;s<o.length&&S(o.charCodeAt(s));)s++;Z=s}else I=3;return o.substring(V,Z)}function N(){let V="",Z=s;for(;;){if(s>=i){V+=o.substring(Z,s),I=2;break}const H=o.charCodeAt(s);if(H===34){V+=o.substring(Z,s),s++;break}if(H===92){if(V+=o.substring(Z,s),s++,s>=i){I=2;break}switch(o.charCodeAt(s++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:{const G=R(4);G>=0?V+=String.fromCharCode(G):I=4;break}default:I=5}Z=s;continue}if(H>=0&&H<=31)if(w(H)){V+=o.substring(Z,s),I=2;break}else I=6;s++}return V}function J(){if(r="",I=0,a=s,s>=i)return a=i,h=17;let V=o.charCodeAt(s);if(E(V)){do s++,r+=String.fromCharCode(V),V=o.charCodeAt(s);while(E(V));return h=15}if(w(V))return s++,r+=String.fromCharCode(V),V===13&&o.charCodeAt(s)===10&&(s++,r+=`
`),h=14;switch(V){case 123:return s++,h=1;case 125:return s++,h=2;case 91:return s++,h=3;case 93:return s++,h=4;case 58:return s++,h=6;case 44:return s++,h=5;case 34:return s++,r=N(),h=10;case 47:{const Z=s-1;if(o.charCodeAt(s+1)===47){for(s+=2;s<i&&!w(o.charCodeAt(s));)s++;return r=o.substring(Z,s),h=12}if(o.charCodeAt(s+1)===42){s+=2;const H=i-1;let K=!1;for(;s<H;){if(o.charCodeAt(s)===42&&o.charCodeAt(s+1)===47){s+=2,K=!0;break}s++}return K||(s++,I=1),r=o.substring(Z,s),h=13}return r+=String.fromCharCode(V),s++,h=16}case 45:if(r+=String.fromCharCode(V),s++,s===i||!S(o.charCodeAt(s)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=W(),h=11;default:for(;s<i&&oe(V);)s++,V=o.charCodeAt(s);if(a!==s){switch(r=o.substring(a,s),r){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return r+=String.fromCharCode(V),s++,h=16}}function oe(V){if(E(V)||w(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let V;do V=J();while(V>=12&&V<=15);return V}return{setPosition:L,getPosition:()=>s,scan:l?re:J,getToken:()=>h,getTokenValue:()=>r,getTokenOffset:()=>a,getTokenLength:()=>s-a,getTokenError:()=>I}}e.createScanner=P;function E(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function w(o){return o===10||o===13||o===8232||o===8233}function S(o){return o>=48&&o<=57}var b;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(b||(b={}));function k(o,l){const s=[],i=new Object;let r;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function I(R,L,W,N){a.value=R,a.offset=L,a.length=W,a.type=N,a.colonOffset=void 0,r=a}try{u(o,{onObjectBegin:(R,L)=>{if(l<=R)throw i;r=void 0,h=l>R,s.push("")},onObjectProperty:(R,L,W)=>{if(l<L||(I(R,L,W,"property"),s[s.length-1]=R,l<=L+W))throw i},onObjectEnd:(R,L)=>{if(l<=R)throw i;r=void 0,s.pop()},onArrayBegin:(R,L)=>{if(l<=R)throw i;r=void 0,s.push(0)},onArrayEnd:(R,L)=>{if(l<=R)throw i;r=void 0,s.pop()},onLiteralValue:(R,L,W)=>{if(l<L||(I(R,L,W,c(R)),l<=L+W))throw i},onSeparator:(R,L,W)=>{if(l<=L)throw i;if(R===":"&&r&&r.type==="property")r.colonOffset=L,h=!1,r=void 0;else if(R===","){const N=s[s.length-1];typeof N=="number"?s[s.length-1]=N+1:(h=!0,s[s.length-1]=""),r=void 0}}})}catch(R){if(R!==i)throw R}return{path:s,previousNode:r,isAtPropertyKey:h,matches:R=>{let L=0;for(let W=0;L<R.length&&W<s.length;W++)if(R[L]===s[W]||R[L]==="*")L++;else if(R[L]!=="**")return!1;return L===R.length}}}e.getLocation=k;function y(o,l=[],s=M.DEFAULT){let i=null,r=[];const a=[];function h(R){Array.isArray(r)?r.push(R):i!==null&&(r[i]=R)}return u(o,{onObjectBegin:()=>{const R={};h(R),a.push(r),r=R,i=null},onObjectProperty:R=>{i=R},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const R=[];h(R),a.push(r),r=R,i=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:h,onError:(R,L,W)=>{l.push({error:R,offset:L,length:W})}},s),r[0]}e.parse=y;function g(o,l=[],s=M.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(R){i.type==="property"&&(i.length=R-i.offset,i=i.parent)}function a(R){return i.children.push(R),R}u(o,{onObjectBegin:R=>{i=a({type:"object",offset:R,length:-1,parent:i,children:[]})},onObjectProperty:(R,L,W)=>{i=a({type:"property",offset:L,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:R,offset:L,length:W,parent:i})},onObjectEnd:(R,L)=>{i.length=R+L-i.offset,i=i.parent,r(R+L)},onArrayBegin:(R,L)=>{i=a({type:"array",offset:R,length:-1,parent:i,children:[]})},onArrayEnd:(R,L)=>{i.length=R+L-i.offset,i=i.parent,r(R+L)},onLiteralValue:(R,L,W)=>{a({type:c(R),offset:L,length:W,parent:i,value:R}),r(L+W)},onSeparator:(R,L,W)=>{i.type==="property"&&(R===":"?i.colonOffset=L:R===","&&r(L))},onError:(R,L,W)=>{l.push({error:R,offset:L,length:W})}},s);const I=i.children[0];return I&&delete I.parent,I}e.parseTree=g;function t(o,l){if(!o)return;let s=o;for(let i of l)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const a of s.children)if(Array.isArray(a.children)&&a.children[0].value===i){s=a.children[1],r=!0;break}if(!r)return}else{const r=i;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}e.findNodeAtLocation=t;function d(o){if(!o.parent||!o.parent.children)return[];const l=d(o.parent);if(o.parent.type==="property"){const s=o.parent.children[0].value;l.push(s)}else if(o.parent.type==="array"){const s=o.parent.children.indexOf(o);s!==-1&&l.push(s)}return l}e.getNodePath=d;function m(o){switch(o.type){case"array":return o.children.map(m);case"object":{const l=Object.create(null);for(let s of o.children){const i=s.children[1];i&&(l[s.children[0].value]=m(i))}return l}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=m;function v(o,l,s=!1){return l>=o.offset&&l<o.offset+o.length||s&&l===o.offset+o.length}e.contains=v;function C(o,l,s=!1){if(v(o,l,s)){const i=o.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=l;r++){const a=C(i[r],l,s);if(a)return a}return o}}e.findNodeAtOffset=C;function u(o,l,s=M.DEFAULT){const i=P(o,!1);function r($){return $?()=>$(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a($){return $?A=>$(A,i.getTokenOffset(),i.getTokenLength()):()=>!0}const h=r(l.onObjectBegin),I=a(l.onObjectProperty),R=r(l.onObjectEnd),L=r(l.onArrayBegin),W=r(l.onArrayEnd),N=a(l.onLiteralValue),J=a(l.onSeparator),oe=r(l.onComment),re=a(l.onError),V=s&&s.disallowComments,Z=s&&s.allowTrailingComma;function H(){for(;;){const $=i.scan();switch(i.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:V||K(11);break;case 2:K(12);break;case 6:K(16);break}switch($){case 12:case 13:V?K(10):oe();break;case 16:K(1);break;case 15:case 14:break;default:return $}}}function K($,A=[],T=[]){if(re($),A.length+T.length>0){let U=i.getToken();for(;U!==17;){if(A.indexOf(U)!==-1){H();break}else if(T.indexOf(U)!==-1)break;U=H()}}}function G($){const A=i.getTokenValue();return $?N(A):I(A),H(),!0}function z(){switch(i.getToken()){case 11:{let $=0;try{$=JSON.parse(i.getTokenValue()),typeof $!="number"&&(K(2),$=0)}catch{K(2)}N($);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return H(),!0}function B(){return i.getToken()!==10?(K(3,[],[2,5]),!1):(G(!1),i.getToken()===6?(J(":"),H(),F()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function Y(){h(),H();let $=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if($||K(4,[],[]),J(","),H(),i.getToken()===2&&Z)break}else $&&K(6,[],[]);B()||K(4,[],[2,5]),$=!0}return R(),i.getToken()!==2?K(7,[2],[]):H(),!0}function q(){L(),H();let $=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if($||K(4,[],[]),J(","),H(),i.getToken()===4&&Z)break}else $&&K(6,[],[]);F()||K(4,[],[4,5]),$=!0}return W(),i.getToken()!==4?K(8,[4],[]):H(),!0}function F(){switch(i.getToken()){case 3:return q();case 1:return Y();case 10:return G(!0);default:return z()}}return H(),i.getToken()===17?s.allowEmptyContent?!0:(K(4,[],[]),!1):F()?(i.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.visit=u;function f(o,l){let s=P(o),i=[],r,a=0,h;do switch(h=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:a!==h&&i.push(o.substring(a,h)),l!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,l)),a=s.getPosition();break}while(r!==17);return i.join("")}e.stripComments=f;function c(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(ee[106],te([0,1,43]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(S,b,k){let y,g,t,d,m;if(b){for(d=b.offset,m=d+b.length,t=d;t>0&&!w(S,t-1);)t--;let h=m;for(;h<S.length&&!w(S,h);)h++;g=S.substring(t,h),y=P(g,k)}else g=S,y=0,t=0,d=0,m=S.length;const v=E(k,S);let C=!1,u=0,f;k.insertSpaces?f=M(" ",k.tabSize||4):f="	";const c=(0,p.createScanner)(g,!1);let o=!1;function l(){return v+M(f,y+u)}function s(){let h=c.scan();for(C=!1;h===15||h===14;)C=C||h===14,h=c.scan();return o=h===16||c.getTokenError()!==0,h}const i=[];function r(h,I,R){!o&&I<m&&R>d&&S.substring(I,R)!==h&&i.push({offset:I,length:R-I,content:h})}let a=s();if(a!==17){const h=c.getTokenOffset()+t,I=M(f,y);r(I,t,h)}for(;a!==17;){let h=c.getTokenOffset()+c.getTokenLength()+t,I=s(),R="";for(;!C&&(I===12||I===13);){const W=c.getTokenOffset()+t;r(" ",h,W),h=c.getTokenOffset()+c.getTokenLength()+t,R=I===12?l():"",I=s()}if(I===2)a!==1&&(u--,R=l());else if(I===4)a!==3&&(u--,R=l());else{switch(a){case 3:case 1:u++,R=l();break;case 5:case 12:R=l();break;case 13:C?R=l():R=" ";break;case 6:R=" ";break;case 10:if(I===6){R="";break}case 7:case 8:case 9:case 11:case 2:case 4:I===12||I===13?R=" ":I!==5&&I!==17&&(o=!0);break;case 16:o=!0;break}C&&(I===12||I===13)&&(R=l())}const L=c.getTokenOffset()+t;r(R,h,L),a=I}return i}e.format=n;function D(S,b){const k=JSON.stringify(S,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?k.replace(/\r\n|\r|\n/g,b.eol):k}e.toFormattedString=D;function M(S,b){let k="";for(let y=0;y<b;y++)k+=S;return k}function P(S,b){let k=0,y=0;const g=b.tabSize||4;for(;k<S.length;){const t=S.charAt(k);if(t===" ")y++;else if(t==="	")y+=g;else break;k++}return Math.floor(y/g)}function E(S,b){for(let k=0;k<b.length;k++){const y=b.charAt(k);if(y==="\r")return k+1<b.length&&b.charAt(k+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=E;function w(S,b){return`\r
`.indexOf(S.charAt(b))!==-1}e.isEOL=w}),define(ee[107],te([0,1,43,106]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(S,b,k){return M(S,b,void 0,k)}e.removeProperty=D;function M(S,b,k,y,g){const t=b.slice(),d=[],m=(0,p.parseTree)(S,d);let v,C;for(;t.length>0&&(C=t.pop(),v=(0,p.findNodeAtLocation)(m,t),v===void 0&&k!==void 0);)typeof C=="string"?k={[C]:k}:k=[k];if(v)if(v.type==="object"&&typeof C=="string"&&Array.isArray(v.children)){const u=(0,p.findNodeAtLocation)(v,[C]);if(u!==void 0)if(k===void 0){if(!u.parent)throw new Error("Malformed AST");const f=v.children.indexOf(u.parent);let c,o=u.parent.offset+u.parent.length;if(f>0){const l=v.children[f-1];c=l.offset+l.length}else c=v.offset+1,v.children.length>1&&(o=v.children[1].offset);return P(S,{offset:c,length:o-c,content:""},y)}else return P(S,{offset:u.offset,length:u.length,content:JSON.stringify(k)},y);else{if(k===void 0)return[];const f=`${JSON.stringify(C)}: ${JSON.stringify(k)}`,c=g?g(v.children.map(l=>l.children[0].value)):v.children.length;let o;if(c>0){const l=v.children[c-1];o={offset:l.offset+l.length,length:0,content:","+f}}else v.children.length===0?o={offset:v.offset+1,length:0,content:f}:o={offset:v.offset+1,length:0,content:f+","};return P(S,o,y)}}else if(v.type==="array"&&typeof C=="number"&&Array.isArray(v.children))if(k!==void 0){const u=`${JSON.stringify(k)}`;let f;if(v.children.length===0||C===0)f={offset:v.offset+1,length:0,content:v.children.length===0?u:u+","};else{const c=C===-1||C>v.children.length?v.children.length:C,o=v.children[c-1];f={offset:o.offset+o.length,length:0,content:","+u}}return P(S,f,y)}else{const u=C,f=v.children[u];let c;if(v.children.length===1)c={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===u){const o=v.children[u-1],l=o.offset+o.length,s=v.offset+v.length;c={offset:l,length:s-2-l,content:""}}else c={offset:f.offset,length:v.children[u+1].offset-f.offset,content:""};return P(S,c,y)}else throw new Error(`Can not add ${typeof C!="number"?"index":"property"} to parent of type ${v.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return P(S,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(k)},y)}}e.setProperty=M;function P(S,b,k){let y=E(S,b),g=b.offset,t=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;g>0&&!(0,n.isEOL)(y,g-1);)g--;for(;t<y.length&&!(0,n.isEOL)(y,t);)t++}const d=(0,n.format)(y,{offset:g,length:t-g},k);for(let v=d.length-1;v>=0;v--){const C=d[v];y=E(y,C),g=Math.min(g,C.offset),t=Math.max(t,C.offset+C.length),t+=C.content.length-C.length}const m=S.length-(y.length-t)-g;return[{offset:g,length:m,content:y.substring(g,t)}]}e.withFormatting=P;function E(S,b){return S.substring(0,b.offset)+b.content+S.substring(b.offset+b.length)}e.applyEdit=E;function w(S,b){let k=b.slice(0).sort((g,t)=>{const d=g.offset-t.offset;return d===0?g.length-t.length:d}),y=S.length;for(let g=k.length-1;g>=0;g--){let t=k[g];if(t.offset+t.length<=y)S=E(S,t);else throw new Error("Overlapping edit");y=t.offset}return S}e.applyEdits=w}),define(ee[82],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var p;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(p=e.KeyCode||(e.KeyCode={}));var n;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(n=e.ScanCode||(e.ScanCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(d,m){this._keyCodeToStr[d]=m,this._strToKeyCode[m.toLowerCase()]=d}keyCodeToStr(d){return this._keyCodeToStr[d]}strToKeyCode(d){return this._strToKeyCode[d.toLowerCase()]||0}}const M=new D,P=new D,E=new D;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const w=[],S=Object.create(null),b=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>b[t]||0,toEnum:t=>S[t]||0,toString:t=>w[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=126;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",d=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",0,t,0,t,t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_CLEAR",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let m=[],v=[];for(const C of d){const[u,f,c,o,l,s,i,r,a,h]=C;if(v[c]||(v[c]=!0,w[c]=o,S[o]=c,b[o.toLowerCase()]=c,f&&(e.IMMUTABLE_CODE_TO_KEY_CODE[c]=l,l!==0&&l!==3&&l!==5&&l!==4&&l!==6&&l!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[l]=c))),!m[l]){if(m[l]=!0,!s)throw new Error(`String representation missing for key code ${l} around scan code ${o}`);M.define(l,s),P.define(l,a||s),E.define(l,h||a||s)}i&&(e.EVENT_KEY_CODE_MAP[i]=l),r&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[r]=l)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var k;(function(t){function d(c){return M.keyCodeToStr(c)}t.toString=d;function m(c){return M.strToKeyCode(c)}t.fromString=m;function v(c){return P.keyCodeToStr(c)}t.toUserSettingsUS=v;function C(c){return E.keyCodeToStr(c)}t.toUserSettingsGeneral=C;function u(c){return P.strToKeyCode(c)||E.strToKeyCode(c)}t.fromUserSettings=u;function f(c){if(c>=93&&c<=108)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return M.keyCodeToStr(c)}t.toElectronAccelerator=f})(k=e.KeyCodeUtils||(e.KeyCodeUtils={}));var y;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(y=e.KeyMod||(e.KeyMod={}));function g(t,d){const m=(d&65535)<<16>>>0;return(t|m)>>>0}e.KeyChord=g}),define(ee[59],te([0,1,15]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var n;(function(k){k[k.CtrlCmd=2048]="CtrlCmd",k[k.Shift=1024]="Shift",k[k.Alt=512]="Alt",k[k.WinCtrl=256]="WinCtrl",k[k.KeyCode=255]="KeyCode"})(n||(n={}));function D(k,y){if(k===0)return null;const g=(k&65535)>>>0,t=(k&4294901760)>>>16;return t!==0?new E([M(g,y),M(t,y)]):new E([M(g,y)])}e.createKeybinding=D;function M(k,y){const g=!!(k&2048),t=!!(k&256),d=y===2?t:g,m=!!(k&1024),v=!!(k&512),C=y===2?g:t,u=k&255;return new P(d,m,v,C,u)}e.createSimpleKeybinding=M;class P{constructor(y,g,t,d,m){this.ctrlKey=y,this.shiftKey=g,this.altKey=t,this.metaKey=d,this.keyCode=m}equals(y){return this.ctrlKey===y.ctrlKey&&this.shiftKey===y.shiftKey&&this.altKey===y.altKey&&this.metaKey===y.metaKey&&this.keyCode===y.keyCode}getHashCode(){const y=this.ctrlKey?"1":"0",g=this.shiftKey?"1":"0",t=this.altKey?"1":"0",d=this.metaKey?"1":"0";return`${y}${g}${t}${d}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new E([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=P;class E{constructor(y){if(y.length===0)throw(0,p.illegalArgument)("parts");this.parts=y}getHashCode(){let y="";for(let g=0,t=this.parts.length;g<t;g++)g!==0&&(y+=";"),y+=this.parts[g].getHashCode();return y}equals(y){if(y===null||this.parts.length!==y.parts.length)return!1;for(let g=0;g<this.parts.length;g++)if(!this.parts[g].equals(y.parts[g]))return!1;return!0}}e.ChordKeybinding=E;class w{constructor(y,g,t,d,m){this.ctrlKey=y,this.shiftKey=g,this.altKey=t,this.metaKey=d,this.scanCode=m}equals(y){return this.ctrlKey===y.ctrlKey&&this.shiftKey===y.shiftKey&&this.altKey===y.altKey&&this.metaKey===y.metaKey&&this.scanCode===y.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=w;class S{constructor(y,g,t,d,m,v){this.ctrlKey=y,this.shiftKey=g,this.altKey=t,this.metaKey=d,this.keyLabel=m,this.keyAriaLabel=v}}e.ResolvedKeybindingPart=S;class b{}e.ResolvedKeybinding=b}),define(ee[108],te([0,1,82,59]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class D{static _readModifiers(P){P=P.toLowerCase().trim();let E=!1,w=!1,S=!1,b=!1,k;do k=!1,/^ctrl(\+|\-)/.test(P)&&(E=!0,P=P.substr("ctrl-".length),k=!0),/^shift(\+|\-)/.test(P)&&(w=!0,P=P.substr("shift-".length),k=!0),/^alt(\+|\-)/.test(P)&&(S=!0,P=P.substr("alt-".length),k=!0),/^meta(\+|\-)/.test(P)&&(b=!0,P=P.substr("meta-".length),k=!0),/^win(\+|\-)/.test(P)&&(b=!0,P=P.substr("win-".length),k=!0),/^cmd(\+|\-)/.test(P)&&(b=!0,P=P.substr("cmd-".length),k=!0);while(k);let y;const g=P.indexOf(" ");return g>0?(y=P.substring(0,g),P=P.substring(g)):(y=P,P=""),{remains:P,ctrl:E,shift:w,alt:S,meta:b,key:y}}static parseSimpleKeybinding(P){const E=this._readModifiers(P),w=p.KeyCodeUtils.fromUserSettings(E.key);return[new n.SimpleKeybinding(E.ctrl,E.shift,E.alt,E.meta,w),E.remains]}static parseKeybinding(P,E){if(!P)return null;const w=[];let S;do[S,P]=this.parseSimpleKeybinding(P),w.push(S);while(P.length>0);return new n.ChordKeybinding(w)}static parseSimpleUserBinding(P){const E=this._readModifiers(P),w=E.key.match(/^\[([^\]]+)\]$/);if(w){const b=w[1],k=p.ScanCodeUtils.lowerCaseToEnum(b);return[new n.ScanCodeBinding(E.ctrl,E.shift,E.alt,E.meta,k),E.remains]}const S=p.KeyCodeUtils.fromUserSettings(E.key);return[new n.SimpleKeybinding(E.ctrl,E.shift,E.alt,E.meta,S),E.remains]}static parseUserBinding(P){if(!P)return[];const E=[];let w;for(;P.length>0;)[w,P]=this.parseSimpleUserBinding(P),E.push(w);return E}}e.KeybindingParser=D}),define(ee[109],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class p{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new p(()=>D(this.getValue()))}}e.Lazy=p}),define(ee[2],te([0,1,42,70]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let M=null;function P(i){M=i}if(e.setDisposableTracker=P,D){const i="__is_disposable_tracked__";P(new class{trackDisposable(r){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[i]||console.log(a)},3e3)}setParent(r,a){if(r&&r!==C.None)try{r[i]=!0}catch{}}markAsDisposed(r){if(r&&r!==C.None)try{r[i]=!0}catch{}}markAsSingleton(r){}})}function E(i){return M?.trackDisposable(i),i}function w(i){M?.markAsDisposed(i)}function S(i,r){M?.setParent(i,r)}function b(i,r){if(!!M)for(const a of i)M.setParent(a,r)}function k(i){return M?.markAsSingleton(i),i}e.markAsSingleton=k;class y extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=y;function g(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=g;function t(i){if(n.Iterable.is(i)){let r=[];for(const a of i)if(a)try{a.dispose()}catch(h){r.push(h)}if(r.length===1)throw r[0];if(r.length>1)throw new y(r);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=t;function d(...i){const r=m(()=>t(i));return b(i,r),r}e.combinedDisposable=d;function m(i){const r=E({dispose:(0,p.once)(()=>{w(r),i()})});return r}e.toDisposable=m;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,E(this)}dispose(){this._isDisposed||(w(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return S(r,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class C{constructor(){this._store=new v,E(this),S(this._store,this)}dispose(){w(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=C,C.None=Object.freeze({dispose(){}});class u{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&S(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,w(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&S(r,null),r}}e.MutableDisposable=u;class f{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=f;class c{constructor(){this.references=new Map}acquire(r,...a){let h=this.references.get(r);h||(h={counter:0,object:this.createReferencedObject(r,...a)},this.references.set(r,h));const{object:I}=h,R=(0,p.once)(()=>{--h.counter==0&&(this.destroyReferencedObject(r,h.object),this.references.delete(r))});return h.counter++,{object:I,dispose:R}}}e.ReferenceCollection=c;class o{constructor(r){this.referenceCollection=r}async acquire(r,...a){const h=this.referenceCollection.acquire(r,...a);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(I){throw h.dispose(),I}}}e.AsyncReferenceCollection=o;class l{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=l;function s(i){const r=new v;try{i(r)}finally{r.dispose()}}e.disposeOnReturn=s}),define(ee[110],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(M){this.element=M,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class n{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let M=this._first;for(;M!==p.Undefined;){const P=M.next;M.prev=p.Undefined,M.next=p.Undefined,M=P}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(M){return this._insert(M,!1)}push(M){return this._insert(M,!0)}_insert(M,P){const E=new p(M);if(this._first===p.Undefined)this._first=E,this._last=E;else if(P){const S=this._last;this._last=E,E.prev=S,S.next=E}else{const S=this._first;this._first=E,E.next=S,S.prev=E}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(E))}}shift(){if(this._first!==p.Undefined){const M=this._first.element;return this._remove(this._first),M}}pop(){if(this._last!==p.Undefined){const M=this._last.element;return this._remove(this._last),M}}_remove(M){if(M.prev!==p.Undefined&&M.next!==p.Undefined){const P=M.prev;P.next=M.next,M.next.prev=P}else M.prev===p.Undefined&&M.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):M.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):M.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let M=this._first;for(;M!==p.Undefined;)yield M.element,M=M.next}}e.LinkedList=n}),function(){function j(D){const M=[];typeof D=="number"&&M.push("code/timeOrigin",D);function P(w){M.push(w,Date.now())}function E(){const w=[];for(let S=0;S<M.length;S+=2)w.push({name:M[S],startTime:M[S+1]});return w}return{mark:P,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const P of performance.getEntriesByType("mark"))M.push({name:P.name,startTime:Math.round(D+P.startTime)});return M}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function p(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=p(n))}(),define(ee[3],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const p="en";let n=!1,D=!1,M=!1,P=!1,E=!1,w=!1,S=!1,b=!1,k,y=p,g,t;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const m=typeof d?.versions?.electron=="string",v=m&&d?.type==="renderer";if(e.isElectronSandboxed=v&&d?.sandboxed,typeof navigator=="object"&&!v)t=navigator.userAgent,n=t.indexOf("Windows")>=0,D=t.indexOf("Macintosh")>=0,b=(t.indexOf("Macintosh")>=0||t.indexOf("iPad")>=0||t.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=t.indexOf("Linux")>=0,w=!0,k=navigator.language,y=k;else if(typeof d=="object"){n=d.platform==="win32",D=d.platform==="darwin",M=d.platform==="linux",P=M&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,S=m,k=p,y=p;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const a=JSON.parse(r),h=a.availableLanguages["*"];k=a.locale,y=h||p,g=a._translationsConfigFile}catch{}E=!0}else console.error("Unable to resolve platform.");var C;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(C=e.Platform||(e.Platform={}));function u(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=u;let f=0;D?f=1:n?f=3:M&&(f=2),e.isWindows=n,e.isMacintosh=D,e.isLinux=M,e.isLinuxSnap=P,e.isNative=E,e.isElectron=S,e.isWeb=w,e.isIOS=b,e.platform=f,e.userAgent=t,e.language=y;var c;(function(r){function a(){return e.language}r.value=a;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=h;function I(){return e.language==="en"}r.isDefault=I})(c=e.Language||(e.Language={})),e.locale=k,e.translationsConfigFile=g,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let r=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let I=0,R=r.length;I<R;I++){const L=r[I];if(L.id===h.data.vscodeScheduleAsyncWork){r.splice(I,1),L.callback();return}}});let a=0;return h=>{const I=++a;r.push({id:I,callback:h}),e.globals.postMessage({vscodeScheduleAsyncWork:I},"*")}}return r=>setTimeout(r)})();var o;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||b?2:n?1:3;let l=!0,s=!1;function i(){if(!s){s=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,l=new Uint16Array(r.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=i,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ee[34],te([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const D=p.globals.vscode.process;n={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(ee[9],te([0,1,34]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,D=97,M=90,P=122,E=46,w=47,S=92,b=58,k=63;class y extends Error{constructor(f,c,o){let l;typeof c=="string"&&c.indexOf("not ")===0?(l="must not be",c=c.replace(/^not /,"")):l="must be";const s=f.indexOf(".")!==-1?"property":"argument";let i=`The "${f}" ${s} ${l} of type ${c}`;i+=`. Received type ${typeof o}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function g(u,f){if(typeof u!="string")throw new y(f,"string",u)}function t(u){return u===w||u===S}function d(u){return u===w}function m(u){return u>=n&&u<=M||u>=D&&u<=P}function v(u,f,c,o){let l="",s=0,i=-1,r=0,a=0;for(let h=0;h<=u.length;++h){if(h<u.length)a=u.charCodeAt(h);else{if(o(a))break;a=w}if(o(a)){if(!(i===h-1||r===1))if(r===2){if(l.length<2||s!==2||l.charCodeAt(l.length-1)!==E||l.charCodeAt(l.length-2)!==E){if(l.length>2){const I=l.lastIndexOf(c);I===-1?(l="",s=0):(l=l.slice(0,I),s=l.length-1-l.lastIndexOf(c)),i=h,r=0;continue}else if(l.length!==0){l="",s=0,i=h,r=0;continue}}f&&(l+=l.length>0?`${c}..`:"..",s=2)}else l.length>0?l+=`${c}${u.slice(i+1,h)}`:l=u.slice(i+1,h),s=h-i-1;i=h,r=0}else a===E&&r!==-1?++r:r=-1}return l}function C(u,f){if(f===null||typeof f!="object")throw new y("pathObject","Object",f);const c=f.dir||f.root,o=f.base||`${f.name||""}${f.ext||""}`;return c?c===f.root?`${c}${o}`:`${c}${u}${o}`:o}e.win32={resolve(...u){let f="",c="",o=!1;for(let l=u.length-1;l>=-1;l--){let s;if(l>=0){if(s=u[l],g(s,"path"),s.length===0)continue}else f.length===0?s=p.cwd():(s=p.env[`=${f}`]||p.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==f.toLowerCase()&&s.charCodeAt(2)===S)&&(s=`${f}\\`));const i=s.length;let r=0,a="",h=!1;const I=s.charCodeAt(0);if(i===1)t(I)&&(r=1,h=!0);else if(t(I))if(h=!0,t(s.charCodeAt(1))){let R=2,L=R;for(;R<i&&!t(s.charCodeAt(R));)R++;if(R<i&&R!==L){const W=s.slice(L,R);for(L=R;R<i&&t(s.charCodeAt(R));)R++;if(R<i&&R!==L){for(L=R;R<i&&!t(s.charCodeAt(R));)R++;(R===i||R!==L)&&(a=`\\\\${W}\\${s.slice(L,R)}`,r=R)}}}else r=1;else m(I)&&s.charCodeAt(1)===b&&(a=s.slice(0,2),r=2,i>2&&t(s.charCodeAt(2))&&(h=!0,r=3));if(a.length>0)if(f.length>0){if(a.toLowerCase()!==f.toLowerCase())continue}else f=a;if(o){if(f.length>0)break}else if(c=`${s.slice(r)}\\${c}`,o=h,h&&f.length>0)break}return c=v(c,!o,"\\",t),o?`${f}\\${c}`:`${f}${c}`||"."},normalize(u){g(u,"path");const f=u.length;if(f===0)return".";let c=0,o,l=!1;const s=u.charCodeAt(0);if(f===1)return d(s)?"\\":u;if(t(s))if(l=!0,t(u.charCodeAt(1))){let r=2,a=r;for(;r<f&&!t(u.charCodeAt(r));)r++;if(r<f&&r!==a){const h=u.slice(a,r);for(a=r;r<f&&t(u.charCodeAt(r));)r++;if(r<f&&r!==a){for(a=r;r<f&&!t(u.charCodeAt(r));)r++;if(r===f)return`\\\\${h}\\${u.slice(a)}\\`;r!==a&&(o=`\\\\${h}\\${u.slice(a,r)}`,c=r)}}}else c=1;else m(s)&&u.charCodeAt(1)===b&&(o=u.slice(0,2),c=2,f>2&&t(u.charCodeAt(2))&&(l=!0,c=3));let i=c<f?v(u.slice(c),!l,"\\",t):"";return i.length===0&&!l&&(i="."),i.length>0&&t(u.charCodeAt(f-1))&&(i+="\\"),o===void 0?l?`\\${i}`:i:l?`${o}\\${i}`:`${o}${i}`},isAbsolute(u){g(u,"path");const f=u.length;if(f===0)return!1;const c=u.charCodeAt(0);return t(c)||f>2&&m(c)&&u.charCodeAt(1)===b&&t(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let f,c;for(let s=0;s<u.length;++s){const i=u[s];g(i,"path"),i.length>0&&(f===void 0?f=c=i:f+=`\\${i}`)}if(f===void 0)return".";let o=!0,l=0;if(typeof c=="string"&&t(c.charCodeAt(0))){++l;const s=c.length;s>1&&t(c.charCodeAt(1))&&(++l,s>2&&(t(c.charCodeAt(2))?++l:o=!1))}if(o){for(;l<f.length&&t(f.charCodeAt(l));)l++;l>=2&&(f=`\\${f.slice(l)}`)}return e.win32.normalize(f)},relative(u,f){if(g(u,"from"),g(f,"to"),u===f)return"";const c=e.win32.resolve(u),o=e.win32.resolve(f);if(c===o||(u=c.toLowerCase(),f=o.toLowerCase(),u===f))return"";let l=0;for(;l<u.length&&u.charCodeAt(l)===S;)l++;let s=u.length;for(;s-1>l&&u.charCodeAt(s-1)===S;)s--;const i=s-l;let r=0;for(;r<f.length&&f.charCodeAt(r)===S;)r++;let a=f.length;for(;a-1>r&&f.charCodeAt(a-1)===S;)a--;const h=a-r,I=i<h?i:h;let R=-1,L=0;for(;L<I;L++){const N=u.charCodeAt(l+L);if(N!==f.charCodeAt(r+L))break;N===S&&(R=L)}if(L!==I){if(R===-1)return o}else{if(h>I){if(f.charCodeAt(r+L)===S)return o.slice(r+L+1);if(L===2)return o.slice(r+L)}i>I&&(u.charCodeAt(l+L)===S?R=L:L===2&&(R=3)),R===-1&&(R=0)}let W="";for(L=l+R+1;L<=s;++L)(L===s||u.charCodeAt(L)===S)&&(W+=W.length===0?"..":"\\..");return r+=R,W.length>0?`${W}${o.slice(r,a)}`:(o.charCodeAt(r)===S&&++r,o.slice(r,a))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const f=e.win32.resolve(u);if(f.length<=2)return u;if(f.charCodeAt(0)===S){if(f.charCodeAt(1)===S){const c=f.charCodeAt(2);if(c!==k&&c!==E)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(m(f.charCodeAt(0))&&f.charCodeAt(1)===b&&f.charCodeAt(2)===S)return`\\\\?\\${f}`;return u},dirname(u){g(u,"path");const f=u.length;if(f===0)return".";let c=-1,o=0;const l=u.charCodeAt(0);if(f===1)return t(l)?u:".";if(t(l)){if(c=o=1,t(u.charCodeAt(1))){let r=2,a=r;for(;r<f&&!t(u.charCodeAt(r));)r++;if(r<f&&r!==a){for(a=r;r<f&&t(u.charCodeAt(r));)r++;if(r<f&&r!==a){for(a=r;r<f&&!t(u.charCodeAt(r));)r++;if(r===f)return u;r!==a&&(c=o=r+1)}}}}else m(l)&&u.charCodeAt(1)===b&&(c=f>2&&t(u.charCodeAt(2))?3:2,o=c);let s=-1,i=!0;for(let r=f-1;r>=o;--r)if(t(u.charCodeAt(r))){if(!i){s=r;break}}else i=!1;if(s===-1){if(c===-1)return".";s=c}return u.slice(0,s)},basename(u,f){f!==void 0&&g(f,"ext"),g(u,"path");let c=0,o=-1,l=!0,s;if(u.length>=2&&m(u.charCodeAt(0))&&u.charCodeAt(1)===b&&(c=2),f!==void 0&&f.length>0&&f.length<=u.length){if(f===u)return"";let i=f.length-1,r=-1;for(s=u.length-1;s>=c;--s){const a=u.charCodeAt(s);if(t(a)){if(!l){c=s+1;break}}else r===-1&&(l=!1,r=s+1),i>=0&&(a===f.charCodeAt(i)?--i==-1&&(o=s):(i=-1,o=r))}return c===o?o=r:o===-1&&(o=u.length),u.slice(c,o)}for(s=u.length-1;s>=c;--s)if(t(u.charCodeAt(s))){if(!l){c=s+1;break}}else o===-1&&(l=!1,o=s+1);return o===-1?"":u.slice(c,o)},extname(u){g(u,"path");let f=0,c=-1,o=0,l=-1,s=!0,i=0;u.length>=2&&u.charCodeAt(1)===b&&m(u.charCodeAt(0))&&(f=o=2);for(let r=u.length-1;r>=f;--r){const a=u.charCodeAt(r);if(t(a)){if(!s){o=r+1;break}continue}l===-1&&(s=!1,l=r+1),a===E?c===-1?c=r:i!==1&&(i=1):c!==-1&&(i=-1)}return c===-1||l===-1||i===0||i===1&&c===l-1&&c===o+1?"":u.slice(c,l)},format:C.bind(null,"\\"),parse(u){g(u,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return f;const c=u.length;let o=0,l=u.charCodeAt(0);if(c===1)return t(l)?(f.root=f.dir=u,f):(f.base=f.name=u,f);if(t(l)){if(o=1,t(u.charCodeAt(1))){let R=2,L=R;for(;R<c&&!t(u.charCodeAt(R));)R++;if(R<c&&R!==L){for(L=R;R<c&&t(u.charCodeAt(R));)R++;if(R<c&&R!==L){for(L=R;R<c&&!t(u.charCodeAt(R));)R++;R===c?o=R:R!==L&&(o=R+1)}}}}else if(m(l)&&u.charCodeAt(1)===b){if(c<=2)return f.root=f.dir=u,f;if(o=2,t(u.charCodeAt(2))){if(c===3)return f.root=f.dir=u,f;o=3}}o>0&&(f.root=u.slice(0,o));let s=-1,i=o,r=-1,a=!0,h=u.length-1,I=0;for(;h>=o;--h){if(l=u.charCodeAt(h),t(l)){if(!a){i=h+1;break}continue}r===-1&&(a=!1,r=h+1),l===E?s===-1?s=h:I!==1&&(I=1):s!==-1&&(I=-1)}return r!==-1&&(s===-1||I===0||I===1&&s===r-1&&s===i+1?f.base=f.name=u.slice(i,r):(f.name=u.slice(i,s),f.base=u.slice(i,r),f.ext=u.slice(s,r))),i>0&&i!==o?f.dir=u.slice(0,i-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let f="",c=!1;for(let o=u.length-1;o>=-1&&!c;o--){const l=o>=0?u[o]:p.cwd();g(l,"path"),l.length!==0&&(f=`${l}/${f}`,c=l.charCodeAt(0)===w)}return f=v(f,!c,"/",d),c?`/${f}`:f.length>0?f:"."},normalize(u){if(g(u,"path"),u.length===0)return".";const f=u.charCodeAt(0)===w,c=u.charCodeAt(u.length-1)===w;return u=v(u,!f,"/",d),u.length===0?f?"/":c?"./":".":(c&&(u+="/"),f?`/${u}`:u)},isAbsolute(u){return g(u,"path"),u.length>0&&u.charCodeAt(0)===w},join(...u){if(u.length===0)return".";let f;for(let c=0;c<u.length;++c){const o=u[c];g(o,"path"),o.length>0&&(f===void 0?f=o:f+=`/${o}`)}return f===void 0?".":e.posix.normalize(f)},relative(u,f){if(g(u,"from"),g(f,"to"),u===f||(u=e.posix.resolve(u),f=e.posix.resolve(f),u===f))return"";const c=1,o=u.length,l=o-c,s=1,i=f.length-s,r=l<i?l:i;let a=-1,h=0;for(;h<r;h++){const R=u.charCodeAt(c+h);if(R!==f.charCodeAt(s+h))break;R===w&&(a=h)}if(h===r)if(i>r){if(f.charCodeAt(s+h)===w)return f.slice(s+h+1);if(h===0)return f.slice(s+h)}else l>r&&(u.charCodeAt(c+h)===w?a=h:h===0&&(a=0));let I="";for(h=c+a+1;h<=o;++h)(h===o||u.charCodeAt(h)===w)&&(I+=I.length===0?"..":"/..");return`${I}${f.slice(s+a)}`},toNamespacedPath(u){return u},dirname(u){if(g(u,"path"),u.length===0)return".";const f=u.charCodeAt(0)===w;let c=-1,o=!0;for(let l=u.length-1;l>=1;--l)if(u.charCodeAt(l)===w){if(!o){c=l;break}}else o=!1;return c===-1?f?"/":".":f&&c===1?"//":u.slice(0,c)},basename(u,f){f!==void 0&&g(f,"ext"),g(u,"path");let c=0,o=-1,l=!0,s;if(f!==void 0&&f.length>0&&f.length<=u.length){if(f===u)return"";let i=f.length-1,r=-1;for(s=u.length-1;s>=0;--s){const a=u.charCodeAt(s);if(a===w){if(!l){c=s+1;break}}else r===-1&&(l=!1,r=s+1),i>=0&&(a===f.charCodeAt(i)?--i==-1&&(o=s):(i=-1,o=r))}return c===o?o=r:o===-1&&(o=u.length),u.slice(c,o)}for(s=u.length-1;s>=0;--s)if(u.charCodeAt(s)===w){if(!l){c=s+1;break}}else o===-1&&(l=!1,o=s+1);return o===-1?"":u.slice(c,o)},extname(u){g(u,"path");let f=-1,c=0,o=-1,l=!0,s=0;for(let i=u.length-1;i>=0;--i){const r=u.charCodeAt(i);if(r===w){if(!l){c=i+1;break}continue}o===-1&&(l=!1,o=i+1),r===E?f===-1?f=i:s!==1&&(s=1):f!==-1&&(s=-1)}return f===-1||o===-1||s===0||s===1&&f===o-1&&f===c+1?"":u.slice(f,o)},format:C.bind(null,"/"),parse(u){g(u,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return f;const c=u.charCodeAt(0)===w;let o;c?(f.root="/",o=1):o=0;let l=-1,s=0,i=-1,r=!0,a=u.length-1,h=0;for(;a>=o;--a){const I=u.charCodeAt(a);if(I===w){if(!r){s=a+1;break}continue}i===-1&&(r=!1,i=a+1),I===E?l===-1?l=a:h!==1&&(h=1):l!==-1&&(h=-1)}if(i!==-1){const I=s===0&&c?1:s;l===-1||h===0||h===1&&l===i-1&&l===s+1?f.base=f.name=u.slice(I,i):(f.name=u.slice(I,l),f.base=u.slice(I,i),f.ext=u.slice(l,i))}return s>0?f.dir=u.slice(0,s-1):c&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ee[83],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(M){M[M.stdout=0]="stdout",M[M.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var n;(function(M){M[M.Success=0]="Success",M[M.Unknown=1]="Unknown",M[M.AccessDenied=2]="AccessDenied",M[M.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(M,...P){const E=P.reduce((b,k)=>(b[k]=!0,b),{}),w=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(M).filter(b=>!E[b]).forEach(b=>{for(let k=0;k<w.length;k++)if(b.search(w[k])!==-1){delete M[b];break}})}e.sanitizeProcessEnvironment=D}),define(ee[84],te([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=p.globals.performance&&typeof p.globals.performance.now=="function";class D{constructor(P){this._highResolution=n&&P,this._startTime=this._now(),this._stopTime=-1}static create(P=!0){return new D(P)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=D}),define(ee[4],te([0,1,15,42,2,110,84]),function(j,e,p,n,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var E;(function(f){f.None=()=>D.Disposable.None;function c(G){return(z,B=null,Y)=>{let q=!1,F;return F=G($=>{if(!q)return F?F.dispose():q=!0,z.call(B,$)},null,Y),q&&F.dispose(),F}}f.once=c;function o(G,z){return h((B,Y=null,q)=>G(F=>B.call(Y,z(F)),null,q))}f.map=o;function l(G,z){return h((B,Y=null,q)=>G(F=>{z(F),B.call(Y,F)},null,q))}f.forEach=l;function s(G,z){return h((B,Y=null,q)=>G(F=>z(F)&&B.call(Y,F),null,q))}f.filter=s;function i(G){return G}f.signal=i;function r(...G){return(z,B=null,Y)=>(0,D.combinedDisposable)(...G.map(q=>q(F=>z.call(B,F),null,Y)))}f.any=r;function a(G,z,B){let Y=B;return o(G,q=>(Y=z(Y,q),Y))}f.reduce=a;function h(G){let z;const B=new y({onFirstListenerAdd(){z=G(B.fire,B)},onLastListenerRemove(){z.dispose()}});return B.event}function I(G,z,B,Y=100,q=!1){let F,$,A=0;return G(T=>{A++,F=B(F,T),q&&!$&&(z(F),F=void 0),clearTimeout($),$=setTimeout(()=>{const U=F;F=void 0,$=void 0,(!q||A>1)&&z(U),A=0},Y)})}f.debouncedListener=I;function R(G,z,B=100,Y=!1,q){let F,$,A,T=0;const U=new y({leakWarningThreshold:q,onFirstListenerAdd(){F=G(O=>{T++,$=z($,O),Y&&!A&&(U.fire($),$=void 0),clearTimeout(A),A=setTimeout(()=>{const _=$;$=void 0,A=void 0,(!Y||T>1)&&U.fire(_),T=0},B)})},onLastListenerRemove(){F.dispose()}});return U.event}f.debounce=R;function L(G,z=(B,Y)=>B===Y){let B=!0,Y;return s(G,q=>{const F=B||!z(q,Y);return B=!1,Y=q,F})}f.latch=L;function W(G,z){return[f.filter(G,z),f.filter(G,B=>!z(B))]}f.split=W;function N(G,z=!1,B=[]){let Y=B.slice(),q=G(A=>{Y?Y.push(A):$.fire(A)});const F=()=>{Y&&Y.forEach(A=>$.fire(A)),Y=null},$=new y({onFirstListenerAdd(){q||(q=G(A=>$.fire(A)))},onFirstListenerDidAdd(){Y&&(z?setTimeout(F):F())},onLastListenerRemove(){q&&q.dispose(),q=null}});return $.event}f.buffer=N;class J{constructor(z){this.event=z}map(z){return new J(o(this.event,z))}forEach(z){return new J(l(this.event,z))}filter(z){return new J(s(this.event,z))}reduce(z,B){return new J(a(this.event,z,B))}latch(){return new J(L(this.event))}debounce(z,B=100,Y=!1,q){return new J(R(this.event,z,B,Y,q))}on(z,B,Y){return this.event(z,B,Y)}once(z,B,Y){return c(this.event)(z,B,Y)}}function oe(G){return new J(G)}f.chain=oe;function re(G,z,B=Y=>Y){const Y=(...A)=>$.fire(B(...A)),q=()=>G.on(z,Y),F=()=>G.removeListener(z,Y),$=new y({onFirstListenerAdd:q,onLastListenerRemove:F});return $.event}f.fromNodeEventEmitter=re;function V(G,z,B=Y=>Y){const Y=(...A)=>$.fire(B(...A)),q=()=>G.addEventListener(z,Y),F=()=>G.removeEventListener(z,Y),$=new y({onFirstListenerAdd:q,onLastListenerRemove:F});return $.event}f.fromDOMEventEmitter=V;function Z(G){return new Promise(z=>c(G)(z))}f.toPromise=Z;function H(G,z){return z(void 0),G(B=>z(B))}f.runAndSubscribe=H;function K(G,z){let B=null;function Y(F){B?.dispose(),B=new D.DisposableStore,z(F,B)}Y(void 0);const q=G(F=>Y(F));return(0,D.toDisposable)(()=>{q.dispose(),B?.dispose()})}f.runAndSubscribeWithStore=K})(E=e.Event||(e.Event={}));class w{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${w._idPool++}`}start(c){this._stopWatch=new P.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}w._idPool=0;let S=-1;function b(f){const c=S;return S=f,{dispose(){S=c}}}e.setGlobalLeakWarningThreshold=b;class k{constructor(c,o=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c){let o=S;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||c<o)return;this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(l)||0;if(this._stacks.set(l,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let i,r=0;for(const[a,h]of this._stacks)(!i||r<h)&&(i=a,r=h);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${r}):`),console.warn(i)}return()=>{const i=this._stacks.get(l)||0;this._stacks.set(l,i-1)}}}class y{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=S>0?new k(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new w(this._options._profName):void 0}get event(){return this._event||(this._event=(c,o,l)=>{this._listeners||(this._listeners=new M.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(o?[c,o]:c);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,o);const r=this._leakageMon?.check(this._listeners.size),a=(0,D.toDisposable)(()=>{r&&r(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return l instanceof D.DisposableStore?l.add(a):Array.isArray(l)&&l.push(a),a}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new M.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,c]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,l]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,l):o[0].call(o[1],l)}catch(s){(0,p.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=y;class g extends y{async fireAsync(c,o,l){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,c]);for(;this._asyncDeliveryQueue.size>0&&!o.isCancellationRequested;){const[s,i]=this._asyncDeliveryQueue.shift(),r=[],a={...i,token:o,waitUntil:h=>{if(Object.isFrozen(r))throw new Error("waitUntil can NOT be called asynchronous");l&&(h=l(h,typeof s=="function"?s:s[0])),r.push(h)}};try{typeof s=="function"?s.call(void 0,a):s[0].call(s[1],a)}catch(h){(0,p.onUnexpectedError)(h);continue}Object.freeze(r),await Promise.allSettled(r).then(h=>{for(const I of h)I.status==="rejected"&&(0,p.onUnexpectedError)(I.reason)})}}}}e.AsyncEmitter=g;class t extends y{constructor(c){super(c);this._isPaused=0,this._eventQueue=new M.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=t;class d extends t{constructor(c){super(c);this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=d;class m extends y{constructor(c){super(c);this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(o=>super.fire(o)),this._queuedEvents=[]})}}e.MicrotaskEmitter=m;class v{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const o={event:c,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const l=()=>{this.hasListeners&&this.unhook(o);const s=this.events.indexOf(o);this.events.splice(s,1)};return(0,D.toDisposable)((0,n.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(o=>this.emitter.fire(o))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=v;class C{constructor(){this.buffers=[]}wrapEvent(c){return(o,l,s)=>c(i=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>o.call(l,i)):o.call(l,i)},void 0,s)}bufferEvents(c){const o=[];this.buffers.push(o);const l=c();return this.buffers.pop(),o.forEach(s=>s()),l}}e.EventBufferer=C;class u{constructor(){this.listening=!1,this.inputEvent=E.None,this.inputEventListener=D.Disposable.None,this.emitter=new y({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=u}),define(ee[21],te([0,1,4]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(E,w){const S=setTimeout(E.bind(w),0);return{dispose(){clearTimeout(S)}}});var D;(function(E){function w(S){return S===E.None||S===E.Cancelled||S instanceof M?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}E.isCancellationToken=w,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(D=e.CancellationToken||(e.CancellationToken={}));class M{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class P{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new M),this._token}cancel(){this._token?this._token instanceof M&&this._token.cancel():this._token=D.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof M&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=P}),define(ee[111],te([0,1,21]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(P){this.task=P,this.result=null}get(){if(this.result)return this.result;const P=new p.CancellationTokenSource,E=this.task(P.token);return this.result={promise:E,dispose:()=>{this.result=null,P.cancel(),P.dispose()}},this.result}}e.Cache=n;class D{constructor(P){this.computeFn=P,this.lastCache=void 0,this.lastArgKey=void 0}get(P){const E=JSON.stringify(P);return this.lastArgKey!==E&&(this.lastArgKey=E,this.lastCache=this.computeFn(P)),this.lastCache}}e.LRUCachedComputed=D}),define(ee[51],te([0,1,15,2]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(u){const f=u;return f?[f.on,f.pause,f.resume,f.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=D;function M(u){const f=u;return f?D(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=M;function P(u,f){return new E(u,f)}e.newWriteableStream=P;class E{constructor(f,c){this.reducer=f,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f!="undefined"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(c=>c(f))}emitError(f){this.listeners.error.length===0?(0,p.onUnexpectedError)(f):this.listeners.error.slice(0).forEach(c=>c(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,c){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(f,c){if(this.state.destroyed)return;let o;switch(f){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const l=o.indexOf(c);l>=0&&o.splice(l,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(u,f){const c=[];let o;for(;(o=u.read())!==null;)c.push(o);return f(c)}e.consumeReadable=w;function S(u,f,c){const o=[];let l;for(;(l=u.read())!==null&&o.length<c;)o.push(l);return l===null&&o.length>0?f(o):{read:()=>{if(o.length>0)return o.shift();if(typeof l!="undefined"){const s=l;return l=void 0,s}return u.read()}}}e.peekReadable=S;function b(u,f){return new Promise((c,o)=>{const l=[];k(u,{onData:s=>{f&&l.push(s)},onError:s=>{f?o(s):c(void 0)},onEnd:()=>{c(f?f(l):void 0)}})})}e.consumeStream=b;function k(u,f){let c=!1;return u.on("error",o=>{c||f.onError(o)}),u.on("end",()=>{c||f.onEnd()}),u.on("data",o=>{c||f.onData(o)}),(0,n.toDisposable)(()=>c=!0)}e.listenStream=k;function y(u,f){return new Promise((c,o)=>{const l=new n.DisposableStore,s=[],i=h=>{if(s.push(h),s.length>f)return l.dispose(),u.pause(),c({stream:u,buffer:s,ended:!1})},r=h=>o(h),a=()=>c({stream:u,buffer:s,ended:!0});l.add((0,n.toDisposable)(()=>u.removeListener("error",r))),u.on("error",r),l.add((0,n.toDisposable)(()=>u.removeListener("end",a))),u.on("end",a),l.add((0,n.toDisposable)(()=>u.removeListener("data",i))),u.on("data",i)})}e.peekStream=y;function g(u,f){const c=P(f);return c.end(u),c}e.toStream=g;function t(){const u=P(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=t;function d(u){let f=!1;return{read:()=>f?null:(f=!0,u)}}e.toReadable=d;function m(u,f,c){const o=P(c);return k(u,{onData:l=>o.write(f.data(l)),onError:l=>o.error(f.error?f.error(l):l),onEnd:()=>o.end()}),o}e.transform=m;function v(u,f,c){let o=!1;return{read:()=>{const l=f.read();return o?l:(o=!0,l!==null?c([u,l]):u)}}}e.prefixedReadable=v;function C(u,f,c){let o=!1;const l=P(c);return k(f,{onData:s=>o?l.write(s):(o=!0,l.write(c([u,s]))),onError:s=>l.error(s),onEnd:()=>{o||(o=!0,l.write(u)),l.end()}}),l}e.prefixedStream=C}),define(ee[17],te([0,1,51]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let D,M;class P{constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}static alloc(I){return n?new P(Buffer.allocUnsafe(I)):new P(new Uint8Array(I))}static wrap(I){return n&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new P(I)}static fromString(I,R){return!(R?.dontUseNodeBuffer||!1)&&n?new P(Buffer.from(I)):(D||(D=new TextEncoder),new P(D.encode(I)))}static fromByteArray(I){const R=P.alloc(I.length);for(let L=0,W=I.length;L<W;L++)R.buffer[L]=I[L];return R}static concat(I,R){if(typeof R=="undefined"){R=0;for(let N=0,J=I.length;N<J;N++)R+=I[N].byteLength}const L=P.alloc(R);let W=0;for(let N=0,J=I.length;N<J;N++){const oe=I[N];L.set(oe,W),W+=oe.byteLength}return L}clone(){const I=P.alloc(this.byteLength);return I.set(this),I}toString(){return n?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(I,R){return new P(this.buffer.subarray(I,R))}set(I,R){if(I instanceof P)this.buffer.set(I.buffer,R);else if(I instanceof Uint8Array)this.buffer.set(I,R);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),R);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),R);else throw new Error("Unkown argument 'array'")}readUInt32BE(I){return S(this.buffer,I)}writeUInt32BE(I,R){b(this.buffer,I,R)}readUInt32LE(I){return k(this.buffer,I)}writeUInt32LE(I,R){y(this.buffer,I,R)}readUInt8(I){return g(this.buffer,I)}writeUInt8(I,R){t(this.buffer,I,R)}}e.VSBuffer=P;function E(h,I){return h[I+0]<<0>>>0|h[I+1]<<8>>>0}e.readUInt16LE=E;function w(h,I,R){h[R+0]=I&255,I=I>>>8,h[R+1]=I&255}e.writeUInt16LE=w;function S(h,I){return h[I]*2**24+h[I+1]*2**16+h[I+2]*2**8+h[I+3]}e.readUInt32BE=S;function b(h,I,R){h[R+3]=I,I=I>>>8,h[R+2]=I,I=I>>>8,h[R+1]=I,I=I>>>8,h[R]=I}e.writeUInt32BE=b;function k(h,I){return h[I+0]<<0>>>0|h[I+1]<<8>>>0|h[I+2]<<16>>>0|h[I+3]<<24>>>0}e.readUInt32LE=k;function y(h,I,R){h[R+0]=I&255,I=I>>>8,h[R+1]=I&255,I=I>>>8,h[R+2]=I&255,I=I>>>8,h[R+3]=I&255}e.writeUInt32LE=y;function g(h,I){return h[I]}e.readUInt8=g;function t(h,I,R){h[R]=I}e.writeUInt8=t;function d(h){return p.consumeReadable(h,I=>P.concat(I))}e.readableToBuffer=d;function m(h){return p.toReadable(h)}e.bufferToReadable=m;function v(h){return p.consumeStream(h,I=>P.concat(I))}e.streamToBuffer=v;async function C(h){return h.ended?P.concat(h.buffer):P.concat([...h.buffer,await v(h.stream)])}e.bufferedStreamToBuffer=C;function u(h){return p.toStream(h,I=>P.concat(I))}e.bufferToStream=u;function f(h){return p.transform(h,{data:I=>typeof I=="string"?P.fromString(I):P.wrap(I)},I=>P.concat(I))}e.streamToBufferReadableStream=f;function c(h){return p.newWriteableStream(I=>P.concat(I),h)}e.newWriteableBufferStream=c;function o(h,I){return p.prefixedReadable(h,I,R=>P.concat(R))}e.prefixedBufferReadable=o;function l(h,I){return p.prefixedStream(h,I,R=>P.concat(R))}e.prefixedBufferStream=l;function s(h){let I=0,R=0,L=0;const W=new Uint8Array(Math.floor(h.length/4*3)),N=oe=>{switch(R){case 3:W[L++]=I|oe,R=0;break;case 2:W[L++]=I|oe>>>2,I=oe<<6,R=3;break;case 1:W[L++]=I|oe>>>4,I=oe<<4,R=2;break;default:I=oe<<2,R=1}};for(let oe=0;oe<h.length;oe++){const re=h.charCodeAt(oe);if(re>=65&&re<=90)N(re-65);else if(re>=97&&re<=122)N(re-97+26);else if(re>=48&&re<=57)N(re-48+52);else if(re===43||re===45)N(62);else if(re===47||re===95)N(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${h[oe]}`)}}const J=L;for(;R>0;)N(0);return P.wrap(W).slice(0,J)}e.decodeBase64=s;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:h},I=!0,R=!1){const L=R?r:i;let W="";const N=h.byteLength%3;let J=0;for(;J<h.byteLength-N;J+=3){const oe=h[J+0],re=h[J+1],V=h[J+2];W+=L[oe>>>2],W+=L[(oe<<4|re>>>4)&63],W+=L[(re<<2|V>>>6)&63],W+=L[V&63]}if(N===1){const oe=h[J+0];W+=L[oe>>>2],W+=L[oe<<4&63],I&&(W+="==")}else if(N===2){const oe=h[J+0],re=h[J+1];W+=L[oe>>>2],W+=L[(oe<<4|re>>>4)&63],W+=L[re<<2&63],I&&(W+="=")}return W}e.encodeBase64=a}),define(ee[25],te([0,1,111,109]),function(j,e,p,n){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function M(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=M;const P=/{(\d+)}/g;function E(X,...ae){return ae.length===0?X:X.replace(P,function(ue,ve){const Ee=parseInt(ve,10);return isNaN(Ee)||Ee<0||Ee>=ae.length?ue:ae[Ee]})}e.format=E;const w=/{([^}]+)}/g;function S(X,ae){return X.replace(w,(ue,ve)=>ae[ve]??ue)}e.format2=S;function b(X){return X.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}e.escape=b;function k(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function y(X,ae){let ue=0;const ve=ae.charCodeAt(0);for(let Ee=X.length-1;Ee>=0;Ee--)X.charCodeAt(Ee)===ve&&ue++;return ue}e.count=y;function g(X,ae,ue="\u2026"){return X.length<=ae?X:`${X.substr(0,ae)}${ue}`}e.truncate=g;function t(X,ae=" "){const ue=d(X,ae);return m(ue,ae)}e.trim=t;function d(X,ae){if(!X||!ae)return X;const ue=ae.length;if(ue===0||X.length===0)return X;let ve=0;for(;X.indexOf(ae,ve)===ve;)ve=ve+ue;return X.substring(ve)}e.ltrim=d;function m(X,ae){if(!X||!ae)return X;const ue=ae.length,ve=X.length;if(ue===0||ve===0)return X;let Ee=ve,Le=-1;for(;Le=X.lastIndexOf(ae,Ee-1),!(Le===-1||Le+ue!==Ee);){if(Le===0)return"";Ee=Le}return X.substring(0,Ee)}e.rtrim=m;function v(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=v;function C(X){return X.replace(/\*/g,"")}e.stripWildcards=C;function u(X,ae,ue={}){if(!X)throw new Error("Cannot create regex from empty string");ae||(X=k(X)),ue.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let ve="";return ue.global&&(ve+="g"),ue.matchCase||(ve+="i"),ue.multiline&&(ve+="m"),ue.unicode&&(ve+="u"),new RegExp(X,ve)}e.createRegExp=u;function f(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function c(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function o(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=o;function l(X){return X.split(/\r\n|\r|\n/)}e.splitLines=l;function s(X){for(let ae=0,ue=X.length;ae<ue;ae++){const ve=X.charCodeAt(ae);if(ve!==32&&ve!==9)return ae}return-1}e.firstNonWhitespaceIndex=s;function i(X,ae=0,ue=X.length){for(let ve=ae;ve<ue;ve++){const Ee=X.charCodeAt(ve);if(Ee!==32&&Ee!==9)return X.substring(ae,ve)}return X.substring(ae,ue)}e.getLeadingWhitespace=i;function r(X,ae=X.length-1){for(let ue=ae;ue>=0;ue--){const ve=X.charCodeAt(ue);if(ve!==32&&ve!==9)return ue}return-1}e.lastNonWhitespaceIndex=r;function a(X,ae){return X<ae?-1:X>ae?1:0}e.compare=a;function h(X,ae,ue=0,ve=X.length,Ee=0,Le=ae.length){for(;ue<ve&&Ee<Le;ue++,Ee++){let je=X.charCodeAt(ue),Ae=ae.charCodeAt(Ee);if(je<Ae)return-1;if(je>Ae)return 1}const Fe=ve-ue,Ye=Le-Ee;return Fe<Ye?-1:Fe>Ye?1:0}e.compareSubstring=h;function I(X,ae){return R(X,ae,0,X.length,0,ae.length)}e.compareIgnoreCase=I;function R(X,ae,ue=0,ve=X.length,Ee=0,Le=ae.length){for(;ue<ve&&Ee<Le;ue++,Ee++){let je=X.charCodeAt(ue),Ae=ae.charCodeAt(Ee);if(je===Ae)continue;if(je>=128||Ae>=128)return h(X.toLowerCase(),ae.toLowerCase(),ue,ve,Ee,Le);L(je)&&(je-=32),L(Ae)&&(Ae-=32);const ze=je-Ae;if(ze!==0)return ze}const Fe=ve-ue,Ye=Le-Ee;return Fe<Ye?-1:Fe>Ye?1:0}e.compareSubstringIgnoreCase=R;function L(X){return X>=97&&X<=122}e.isLowerAsciiLetter=L;function W(X){return X>=65&&X<=90}e.isUpperAsciiLetter=W;function N(X,ae){return X.length===ae.length&&R(X,ae)===0}e.equalsIgnoreCase=N;function J(X,ae){const ue=ae.length;return ae.length>X.length?!1:R(X,ae,0,ue)===0}e.startsWithIgnoreCase=J;function oe(X,ae){let ue,ve=Math.min(X.length,ae.length);for(ue=0;ue<ve;ue++)if(X.charCodeAt(ue)!==ae.charCodeAt(ue))return ue;return ve}e.commonPrefixLength=oe;function re(X,ae){let ue,ve=Math.min(X.length,ae.length);const Ee=X.length-1,Le=ae.length-1;for(ue=0;ue<ve;ue++)if(X.charCodeAt(Ee-ue)!==ae.charCodeAt(Le-ue))return ue;return ve}e.commonSuffixLength=re;function V(X){return 55296<=X&&X<=56319}e.isHighSurrogate=V;function Z(X){return 56320<=X&&X<=57343}e.isLowSurrogate=Z;function H(X,ae){return(X-55296<<10)+(ae-56320)+65536}e.computeCodePoint=H;function K(X,ae,ue){const ve=X.charCodeAt(ue);if(V(ve)&&ue+1<ae){const Ee=X.charCodeAt(ue+1);if(Z(Ee))return H(ve,Ee)}return ve}e.getNextCodePoint=K;function G(X,ae){const ue=X.charCodeAt(ae-1);if(Z(ue)&&ae>1){const ve=X.charCodeAt(ae-2);if(V(ve))return H(ve,ue)}return ue}class z{constructor(ae,ue=0){this._str=ae,this._len=ae.length,this._offset=ue}get offset(){return this._offset}setOffset(ae){this._offset=ae}prevCodePoint(){const ae=G(this._str,this._offset);return this._offset-=ae>=65536?2:1,ae}nextCodePoint(){const ae=K(this._str,this._len,this._offset);return this._offset+=ae>=65536?2:1,ae}eol(){return this._offset>=this._len}}e.CodePointIterator=z;class B{constructor(ae,ue=0){this._iterator=new z(ae,ue)}get offset(){return this._iterator.offset}nextGraphemeLength(){const ae=Ve.getInstance(),ue=this._iterator,ve=ue.offset;let Ee=ae.getGraphemeBreakType(ue.nextCodePoint());for(;!ue.eol();){const Le=ue.offset,Fe=ae.getGraphemeBreakType(ue.nextCodePoint());if(_e(Ee,Fe)){ue.setOffset(Le);break}Ee=Fe}return ue.offset-ve}prevGraphemeLength(){const ae=Ve.getInstance(),ue=this._iterator,ve=ue.offset;let Ee=ae.getGraphemeBreakType(ue.prevCodePoint());for(;ue.offset>0;){const Le=ue.offset,Fe=ae.getGraphemeBreakType(ue.prevCodePoint());if(_e(Fe,Ee)){ue.setOffset(Le);break}Ee=Fe}return ve-ue.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=B;function Y(X,ae){return new B(X,ae).nextGraphemeLength()}e.nextCharLength=Y;function q(X,ae){return new B(X,ae).prevGraphemeLength()}e.prevCharLength=q;function F(X,ae){ae>0&&Z(X.charCodeAt(ae))&&ae--;const ue=ae+Y(X,ae);return[ue-q(X,ue),ue]}e.getCharContainingOffset=F;const $=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function A(X){return $.test(X)}e.containsRTL=A;const T=/^[\t\n\r\x20-\x7E]*$/;function U(X){return T.test(X)}e.isBasicASCII=U,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function O(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=O;function _(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=_;function Q(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=Q;function ie(X,ae){if(X.length<ae)return X;const ue=/\b/g;let ve=0;for(;ue.test(X)&&!(X.length-ue.lastIndex<ae);)ve=ue.lastIndex,ue.lastIndex+=1;return X.substring(ve).replace(/^\s/,"")}e.lcut=ie;const se=/\x1B\x5B[12]?K/g,x=/\x1b\[\d+m/g,ce=/\x1b\[0?m/g;function le(X){return X&&(X=X.replace(se,""),X=X.replace(x,""),X=X.replace(ce,"")),X}e.removeAnsiEscapeCodes=le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function he(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=he;function me(X){return he(X)?X.substr(1):X}e.stripUTF8BOM=me;function pe(X,ae){if(!X||!ae||X.length<ae.length)return!1;const ue=ae.length,ve=X.toLowerCase();let Ee=0,Le=-1;for(;Ee<ue;){const Fe=ve.indexOf(ae[Ee],Le+1);if(Fe<0)return!1;Le=Fe,Ee++}return!0}e.fuzzyContains=pe;function ge(X,ae=!1){return X?(ae&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=ge;function fe(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=fe;function Ie(X,ae=1){if(ae===0)return"";let ue=-1;do ue=X.indexOf(`
`,ue+1),ae--;while(ae>0&&ue>=0);return ue===-1?X:(X[ue-1]==="\r"&&ue--,X.substr(0,ue))}e.getNLines=Ie;function Pe(X){const ae=90-65+1;return X=X%(2*ae),X<ae?String.fromCharCode(97+X):String.fromCharCode(65+X-ae)}e.singleLetterHash=Pe;function Te(X){return Ve.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=Te;function _e(X,ae){return X===0?ae!==5&&ae!==7:X===2&&ae===3?!1:X===4||X===2||X===3||ae===4||ae===2||ae===3?!0:!(X===8&&(ae===8||ae===9||ae===11||ae===12)||(X===11||X===9)&&(ae===9||ae===10)||(X===12||X===10)&&ae===10||ae===5||ae===13||ae===7||X===1||X===13&&ae===14||X===6&&ae===6)}var qe;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(qe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ve{constructor(){this._data=xe()}static getInstance(){return Ve._INSTANCE||(Ve._INSTANCE=new Ve),Ve._INSTANCE}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const ue=this._data,ve=ue.length/3;let Ee=1;for(;Ee<=ve;)if(ae<ue[3*Ee])Ee=2*Ee;else if(ae>ue[3*Ee+1])Ee=2*Ee+1;else return ue[3*Ee+2];return 0}}Ve._INSTANCE=null;function xe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Je(X,ae){if(X===0)return 0;const ue=mt(X,ae);if(ue!==void 0)return ue;const ve=new z(ae,X);return ve.prevCodePoint(),ve.offset}e.getLeftDeleteOffset=Je;function mt(X,ae){const ue=new z(ae,X);let ve=ue.prevCodePoint();for(;lt(ve)||ve===65039||ve===8419;){if(ue.offset===0)return;ve=ue.prevCodePoint()}if(!Q(ve))return;let Ee=ue.offset;return Ee>0&&ue.prevCodePoint()===8205&&(Ee=ue.offset),Ee}function lt(X){return 127995<=X&&X<=127999}var st;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(st||(st={})),e.noBreakWhitespace="\xA0";class He{constructor(ae){this.confusableDictionary=ae}static getInstance(ae){return He.cache.get(Array.from(ae))}static getLocales(){return He._locales.getValue()}isAmbiguous(ae){return this.confusableDictionary.has(ae)}getPrimaryConfusable(ae){return this.confusableDictionary.get(ae)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=He,D=He,He.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),He.cache=new p.LRUCachedComputed(X=>{function ae(Ae){const ze=new Map;for(let Ke=0;Ke<Ae.length;Ke+=2)ze.set(Ae[Ke],Ae[Ke+1]);return ze}function ue(Ae,ze){const Ke=new Map(Ae);for(const[et,tt]of ze)Ke.set(et,tt);return Ke}function ve(Ae,ze){if(!Ae)return ze;const Ke=new Map;for(const[et,tt]of Ae)ze.has(et)&&Ke.set(et,tt);return Ke}const Ee=D.ambiguousCharacterData.getValue();let Le=X.filter(Ae=>!Ae.startsWith("_")&&Ae in Ee);Le.length===0&&(Le=["_default"]);let Fe;for(const Ae of Le){const ze=ae(Ee[Ae]);Fe=ve(Fe,ze)}const Ye=ae(Ee._common),je=ue(Ye,Fe);return new He(je)}),He._locales=new n.Lazy(()=>Object.keys(He.ambiguousCharacterData.getValue()).filter(X=>!X.startsWith("_")));class Ge{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ge.getRawData())),this._data}static isInvisibleCharacter(ae){return Ge.getData().has(ae)}static get codePoints(){return Ge.getData()}}e.InvisibleCharacters=Ge,Ge._data=void 0}),define(ee[71],te([0,1,25]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(v){return D(v,0)}e.hash=n;function D(v,C){switch(typeof v){case"object":return v===null?M(349,C):Array.isArray(v)?w(v,C):S(v,C);case"string":return E(v,C);case"boolean":return P(v,C);case"number":return M(v,C);case"undefined":return M(937,C);default:return M(617,C)}}e.doHash=D;function M(v,C){return(C<<5)-C+v|0}e.numberHash=M;function P(v,C){return M(v?433:863,C)}function E(v,C){C=M(149417,C);for(let u=0,f=v.length;u<f;u++)C=M(v.charCodeAt(u),C);return C}e.stringHash=E;function w(v,C){return C=M(104579,C),v.reduce((u,f)=>D(f,u),C)}function S(v,C){return C=M(181387,C),Object.keys(v).sort().reduce((u,f)=>(u=E(f,u),D(v[f],u)),C)}class b{constructor(){this._value=0}get value(){return this._value}hash(C){return this._value=D(C,this._value),this._value}}e.Hasher=b;var k;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function y(v,C,u=32){const f=u-C,c=~((1<<f)-1);return(v<<C|(c&v)>>>f)>>>0}function g(v,C=0,u=v.byteLength,f=0){for(let c=0;c<u;c++)v[C+c]=f}function t(v,C,u="0"){for(;v.length<C;)v=u+v;return v}function d(v,C=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(u=>u.toString(16).padStart(2,"0")).join(""):t((v>>>0).toString(16),C/4)}e.toHexString=d;class m{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(C){const u=C.length;if(u===0)return;const f=this._buff;let c=this._buffLen,o=this._leftoverHighSurrogate,l,s;for(o!==0?(l=o,s=-1,o=0):(l=C.charCodeAt(0),s=0);;){let i=l;if(p.isHighSurrogate(l))if(s+1<u){const r=C.charCodeAt(s+1);p.isLowSurrogate(r)?(s++,i=p.computeCodePoint(l,r)):i=65533}else{o=l;break}else p.isLowSurrogate(l)&&(i=65533);if(c=this._push(f,c,i),s++,s<u)l=C.charCodeAt(s);else break}this._buffLen=c,this._leftoverHighSurrogate=o}_push(C,u,f){return f<128?C[u++]=f:f<2048?(C[u++]=192|(f&1984)>>>6,C[u++]=128|(f&63)>>>0):f<65536?(C[u++]=224|(f&61440)>>>12,C[u++]=128|(f&4032)>>>6,C[u++]=128|(f&63)>>>0):(C[u++]=240|(f&1835008)>>>18,C[u++]=128|(f&258048)>>>12,C[u++]=128|(f&4032)>>>6,C[u++]=128|(f&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,C[0]=C[64+0],C[1]=C[64+1],C[2]=C[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const C=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(C/4294967296),!1),this._buffDV.setUint32(60,C%4294967296,!1),this._step()}_step(){const C=m._bigBlock32,u=this._buffDV;for(let h=0;h<64;h+=4)C.setUint32(h,u.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)C.setUint32(h,y(C.getUint32(h-12,!1)^C.getUint32(h-32,!1)^C.getUint32(h-56,!1)^C.getUint32(h-64,!1),1),!1);let f=this._h0,c=this._h1,o=this._h2,l=this._h3,s=this._h4,i,r,a;for(let h=0;h<80;h++)h<20?(i=c&o|~c&l,r=1518500249):h<40?(i=c^o^l,r=1859775393):h<60?(i=c&o|c&l|o&l,r=2400959708):(i=c^o^l,r=3395469782),a=y(f,5)+i+s+r+C.getUint32(h*4,!1)&4294967295,s=l,l=o,o=y(c,30),c=f,f=a;this._h0=this._h0+f&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=m,m._bigBlock32=new DataView(new ArrayBuffer(320))});var Pt=this&&this.__classPrivateFieldSet||function(j,e,p,n,D){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?j!==e||!D:!e.has(j))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?D.call(j,p):D?D.value=p:e.set(j,p),p},Qe=this&&this.__classPrivateFieldGet||function(j,e,p,n){if(p==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?j!==e||!n:!e.has(j))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?n:p==="a"?n.call(j):n?n.value:e.get(j)};define(ee[35],te([0,1,27,25]),function(j,e,p,n){"use strict";var D,M,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function E(s,i,r){let a=s.get(i);return a===void 0&&(a=r,s.set(i,a)),a}e.getOrSet=E;function w(s){const i=[];return s.forEach((r,a)=>{i.push(`${a} => ${r}`)}),`Map(${s.size}) {${i.join(", ")}}`}e.mapToString=w;function S(s){const i=[];return s.forEach(r=>{i.push(r)}),`Set(${s.size}) {${i.join(", ")}}`}e.setToString=S;class b{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),a=this._value.charCodeAt(this._pos);return r-a}value(){return this._value[this._pos]}}e.StringIterator=b;class k{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class y{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let r=i.length-1;r>=0;r--,this._valueLen--){const a=this._value.charCodeAt(r);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=y;var g;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(g||(g={}));class t{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new y(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,n.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=t;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(m||(m={}));class v{constructor(i){this._iter=i}static forUris(i=()=>!1){return new v(new t(i))}static forPaths(i=!1){return new v(new y(void 0,!i))}static forStrings(){return new v(new b)}static forConfigKeys(){return new v(new k)}clear(){this._root=void 0}fill(i,r){if(r){const a=r.slice(0);(0,p.shuffle)(a);for(let h of a)this.set(h,i)}else{const a=i.slice(0);(0,p.shuffle)(a);for(let h of a)this.set(h[0],h[1])}}set(i,r){const a=this._iter.reset(i);let h;this._root||(this._root=new d,this._root.segment=a.value());const I=[];for(h=this._root;;){const L=a.cmp(h.segment);if(L>0)h.left||(h.left=new d,h.left.segment=a.value()),I.push([-1,h]),h=h.left;else if(L<0)h.right||(h.right=new d,h.right.segment=a.value()),I.push([1,h]),h=h.right;else if(a.hasNext())a.next(),h.mid||(h.mid=new d,h.mid.segment=a.value()),I.push([0,h]),h=h.mid;else break}const R=h.value;h.value=r,h.key=i;for(let L=I.length-1;L>=0;L--){const W=I[L][1];W.updateHeight();const N=W.balanceFactor();if(N<-1||N>1){const J=I[L][0],oe=I[L+1][0];if(J===1&&oe===1)I[L][1]=W.rotateLeft();else if(J===-1&&oe===-1)I[L][1]=W.rotateRight();else if(J===1&&oe===-1)W.right=I[L+1][1]=I[L+1][1].rotateRight(),I[L][1]=W.rotateLeft();else if(J===-1&&oe===1)W.left=I[L+1][1]=I[L+1][1].rotateLeft(),I[L][1]=W.rotateRight();else throw new Error;if(L>0)switch(I[L-1][0]){case-1:I[L-1][1].left=I[L][1];break;case 1:I[L-1][1].right=I[L][1];break;case 0:I[L-1][1].mid=I[L][1];break}else this._root=I[0][1]}}return R}get(i){return this._getNode(i)?.value}_getNode(i){const r=this._iter.reset(i);let a=this._root;for(;a;){const h=r.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else break}return a}has(i){const r=this._getNode(i);return!(r?.value===void 0&&r?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const a=this._iter.reset(i),h=[];let I=this._root;for(;I;){const R=a.cmp(I.segment);if(R>0)h.push([-1,I]),I=I.left;else if(R<0)h.push([1,I]),I=I.right;else if(a.hasNext())a.next(),h.push([0,I]),I=I.mid;else break}if(!!I){if(r?(I.left=void 0,I.mid=void 0,I.right=void 0,I.height=1):(I.key=void 0,I.value=void 0),!I.mid&&!I.value)if(I.left&&I.right){const R=this._min(I.right),{key:L,value:W,segment:N}=R;this._delete(R.key,!1),I.key=L,I.value=W,I.segment=N}else{const R=I.left??I.right;if(h.length>0){const[L,W]=h[h.length-1];switch(L){case-1:W.left=R;break;case 0:W.mid=R;break;case 1:W.right=R;break}}else this._root=R}for(let R=h.length-1;R>=0;R--){const L=h[R][1];L.updateHeight();const W=L.balanceFactor();if(W>1?(L.right.balanceFactor()>=0||(L.right=L.right.rotateRight()),h[R][1]=L.rotateLeft()):W<-1&&(L.left.balanceFactor()<=0||(L.left=L.left.rotateLeft()),h[R][1]=L.rotateRight()),R>0)switch(h[R-1][0]){case-1:h[R-1][1].left=h[R][1];break;case 1:h[R-1][1].right=h[R][1];break;case 0:h[R-1][1].mid=h[R][1];break}else this._root=h[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const r=this._iter.reset(i);let a=this._root,h;for(;a;){const I=r.cmp(a.segment);if(I>0)a=a.left;else if(I<0)a=a.right;else if(r.hasNext())r.next(),h=a.value||h,a=a.mid;else break}return a&&a.value||h}findSuperstr(i){const r=this._iter.reset(i);let a=this._root;for(;a;){const h=r.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(i){for(const[r,a]of this)i(a,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=r=>{if(!r)return!0;const a=r.balanceFactor();return a<-1||a>1?!1:i(r.left)&&i(r.right)};return i(this._root)}}e.TernarySearchTree=v;class C{constructor(i,r){this.uri=i,this.value=r}}class u{constructor(i,r){this[D]="ResourceMap",i instanceof u?(this.map=new Map(i.map),this.toKey=r??u.defaultToKey):(this.map=new Map,this.toKey=i??u.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),new C(i,r)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r!="undefined"&&(i=i.bind(r));for(let[a,h]of this.map)i(h.value,h.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=u,u.defaultToKey=s=>s.toString();var f;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(f=e.Touch||(e.Touch={}));class c{constructor(){this[M]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,r=0){const a=this._map.get(i);if(!!a)return r!==0&&this.touch(a,r),a.value}set(i,r,a=0){let h=this._map.get(i);if(h)h.value=r,a!==0&&this.touch(h,a);else{switch(h={key:i,value:r,next:void 0,previous:void 0},a){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(i,h),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const a=this._state;let h=this._head;for(;h;){if(r?i.bind(r)(h.value,h.key,this):i(h.value,h.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const i=this,r=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const I={value:a.key,done:!1};return a=a.next,I}else return{value:void 0,done:!0}}};return h}values(){const i=this,r=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const I={value:a.value,done:!1};return a=a.next,I}else return{value:void 0,done:!0}}};return h}entries(){const i=this,r=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const I={value:[a.key,a.value],done:!1};return a=a.next,I}else return{value:void 0,done:!0}}};return h}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,a=this.size;for(;r&&a>i;)this._map.delete(r.key),r=r.next,a--;this._head=r,this._size=a,r&&(r.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,a=i.previous;if(!r||!a)throw new Error("Invalid list");r.previous=a,a.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const a=i.next,h=i.previous;i===this._tail?(h.next=void 0,this._tail=h):(a.previous=h,h.next=a),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const a=i.next,h=i.previous;i===this._head?(a.previous=void 0,this._head=a):(a.previous=h,h.next=a),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,a)=>{i.push([a,r])}),i}fromJSON(i){this.clear();for(const[r,a]of i)this.set(r,a)}}e.LinkedMap=c;class o extends c{constructor(i,r=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class l{constructor(i){P.set(this,void 0),Pt(this,P,i,"f")}get size(){return Qe(this,P,"f").size}forEach(i,r){Qe(this,P,"f").forEach(i,r)}get(i){return Qe(this,P,"f").get(i)}has(i){return Qe(this,P,"f").has(i)}entries(){return Qe(this,P,"f").entries()}keys(){return Qe(this,P,"f").keys()}values(){return Qe(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return Qe(this,P,"f").entries()}}e.ReadonlyMapView=l}),define(ee[72],te([0,1,35]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new p.LRUCache(1e4);function D(S){return w(S,"NFC",n)}e.normalizeNFC=D;const M=new p.LRUCache(1e4);function P(S){return w(S,"NFD",M)}e.normalizeNFD=P;const E=/[^\u0000-\u0080]/;function w(S,b,k){if(!S)return S;const y=k.get(S);if(y)return y;let g;return E.test(S)?g=S.normalize(b):g=S,k.set(S,g),g}e.removeAccents=function(){const S=/[\u0300-\u036f]/g;return function(b){return P(b).replace(S,"")}}()}),define(ee[13],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(a){return Array.isArray(a)}e.isArray=p;function n(a){return typeof a=="string"}e.isString=n;function D(a){return Array.isArray(a)&&a.every(h=>n(h))}e.isStringArray=D;function M(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=M;function P(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=P;function E(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=E;function w(a){return a===!0||a===!1}e.isBoolean=w;function S(a){return typeof a=="undefined"}e.isUndefined=S;function b(a){return!k(a)}e.isDefined=b;function k(a){return S(a)||a===null}e.isUndefinedOrNull=k;function y(a,h){if(!a)throw new Error(h?`Unexpected type, expected '${h}'`:"Unexpected type")}e.assertType=y;function g(a){if(k(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=g;function t(...a){const h=[];for(let I=0;I<a.length;I++){const R=a[I];if(k(R))throw new Error(`Assertion Failed: argument at index ${I} is undefined or null`);h.push(R)}return h}e.assertAllDefined=t;const d=Object.prototype.hasOwnProperty;function m(a){if(!M(a))return!1;for(let h in a)if(d.call(a,h))return!1;return!0}e.isEmptyObject=m;function v(a){return typeof a=="function"}e.isFunction=v;function C(...a){return a.length>0&&a.every(v)}e.areFunctions=C;function u(a,h){const I=Math.min(a.length,h.length);for(let R=0;R<I;R++)f(a[R],h[R])}e.validateConstraints=u;function f(a,h){if(n(h)){if(typeof a!==h)throw new Error(`argument does not match constraint: typeof ${h}`)}else if(v(h)){try{if(a instanceof h)return}catch{}if(!k(a)&&a.constructor===h||h.length===1&&h.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function c(a){let h=[],I=Object.getPrototypeOf(a);for(;Object.prototype!==I;)h=h.concat(Object.getOwnPropertyNames(I)),I=Object.getPrototypeOf(I);return h}e.getAllPropertyNames=c;function o(a){const h=[];for(const I of c(a))typeof a[I]=="function"&&h.push(I);return h}e.getAllMethodNames=o;function l(a,h){const I=L=>function(){const W=Array.prototype.slice.call(arguments,0);return h(L,W)};let R={};for(const L of a)R[L]=I(L);return R}e.createProxyObject=l;function s(a){return a===null?void 0:a}e.withNullAsUndefined=s;function i(a){return typeof a=="undefined"?null:a}e.withUndefinedAsNull=i;function r(a,h="Unreachable"){throw new Error(h)}e.assertNever=r}),define(ee[28],te([0,1,9,3,25,13]),function(j,e,p,n,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function P(r){return r===47||r===92}e.isPathSeparator=P;function E(r){return r.replace(/[\\/]/g,p.posix.sep)}e.toSlashes=E;function w(r){return r.indexOf("/")===-1&&(r=E(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=w;function S(r,a=p.posix.sep){if(!r)return"";const h=r.length,I=r.charCodeAt(0);if(P(I)){if(P(r.charCodeAt(1))&&!P(r.charCodeAt(2))){let L=3;const W=L;for(;L<h&&!P(r.charCodeAt(L));L++);if(W!==L&&!P(r.charCodeAt(L+1))){for(L+=1;L<h;L++)if(P(r.charCodeAt(L)))return r.slice(0,L+1).replace(/[\\/]/g,a)}}return a}else if(v(I)&&r.charCodeAt(1)===58)return P(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let R=r.indexOf("://");if(R!==-1){for(R+=3;R<h;R++)if(P(r.charCodeAt(R)))return r.slice(0,R+1)}return""}e.getRoot=S;function b(r){if(!n.isWindows||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let h=2;const I=h;for(;h<r.length&&(a=r.charCodeAt(h),a!==92);h++);return!(I===h||(a=r.charCodeAt(h+1),isNaN(a)||a===92))}e.isUNC=b;const k=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(r,a=n.isWindows){const h=a?k:y;return!(!r||r.length===0||/^\s+$/.test(r)||(h.lastIndex=0,h.test(r))||a&&g.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=t;function d(r,a,h){const I=r===a;return!h||I?I:!r||!a?!1:(0,D.equalsIgnoreCase)(r,a)}e.isEqual=d;function m(r,a,h,I=p.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(h){if(!(0,D.startsWithIgnoreCase)(r,a))return!1;if(a.length===r.length)return!0;let L=a.length;return a.charAt(a.length-1)===I&&L--,r.charAt(L)===I}return a.charAt(a.length-1)!==I&&(a+=I),r.indexOf(a)===0}e.isEqualOrParent=m;function v(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=v;function C(r,a){return n.isWindows&&r.endsWith(":")&&(r+=p.sep),(0,p.isAbsolute)(r)||(r=(0,p.join)(a,r)),r=(0,p.normalize)(r),n.isWindows?(r=(0,D.rtrim)(r,p.sep),r.endsWith(":")&&(r+=p.sep)):(r=(0,D.rtrim)(r,p.sep),r||(r=p.sep)),r}e.sanitizeFilePath=C;function u(r){const a=(0,p.normalize)(r);return n.isWindows?r.length>3?!1:f(a)&&(r.length===2||a.charCodeAt(2)===92):a===p.posix.sep}e.isRootOrDriveLetter=u;function f(r,a){return(a!==void 0?a:n.isWindows)?v(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function c(r){return f(r)?r[0]:void 0}e.getDriveLetter=c;function o(r,a,h){return a.length>r.length?-1:r===a?0:(h&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.indexOfPath=o;function l(r){const a=r.split(":");let h,I,R;for(const L of a){const W=Number(L);(0,M.isNumber)(W)?I===void 0?I=W:R===void 0&&(R=W):h=h?[h,L].join(":"):L}if(!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:I!==void 0?I:void 0,column:R!==void 0?R:I!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(r,a,h=8){let I="";for(let L=0;L<h;L++)I+=s.charAt(Math.floor(Math.random()*s.length));let R;return a?R=`${a}-${I}`:R=I,r?(0,p.join)(r,R):R}e.randomPath=i}),define(ee[47],te([0,1,13]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const m=Array.isArray(d)?[]:{};return Object.keys(d).forEach(v=>{d[v]&&typeof d[v]=="object"?m[v]=n(d[v]):m[v]=d[v]}),m}e.deepClone=n;function D(d){if(!d||typeof d!="object")return d;const m=[d];for(;m.length>0;){const v=m.shift();Object.freeze(v);for(const C in v)if(M.call(v,C)){const u=v[C];typeof u=="object"&&!Object.isFrozen(u)&&m.push(u)}}return d}e.deepFreeze=D;const M=Object.prototype.hasOwnProperty;function P(d,m){return E(d,m,new Set)}e.cloneAndChange=P;function E(d,m,v){if((0,p.isUndefinedOrNull)(d))return d;const C=m(d);if(typeof C!="undefined")return C;if((0,p.isArray)(d)){const u=[];for(const f of d)u.push(E(f,m,v));return u}if((0,p.isObject)(d)){if(v.has(d))throw new Error("Cannot clone recursive data-structure");v.add(d);const u={};for(let f in d)M.call(d,f)&&(u[f]=E(d[f],m,v));return v.delete(d),u}return d}function w(d,m,v=!0){return(0,p.isObject)(d)?((0,p.isObject)(m)&&Object.keys(m).forEach(C=>{C in d?v&&((0,p.isObject)(d[C])&&(0,p.isObject)(m[C])?w(d[C],m[C],v):d[C]=m[C]):d[C]=m[C]}),d):m}e.mixin=w;function S(d,m){if(d===m)return!0;if(d==null||m===null||m===void 0||typeof d!=typeof m||typeof d!="object"||Array.isArray(d)!==Array.isArray(m))return!1;let v,C;if(Array.isArray(d)){if(d.length!==m.length)return!1;for(v=0;v<d.length;v++)if(!S(d[v],m[v]))return!1}else{const u=[];for(C in d)u.push(C);u.sort();const f=[];for(C in m)f.push(C);if(f.sort(),!S(u,f))return!1;for(v=0;v<u.length;v++)if(!S(d[u[v]],m[u[v]]))return!1}return!0}e.equals=S;function b(d){const m=new Set;return JSON.stringify(d,(v,C)=>{if((0,p.isObject)(C)||Array.isArray(C)){if(m.has(C))return"[Circular]";m.add(C)}return C})}e.safeStringify=b;function k(d,m,v){const C=m(d);return typeof C=="undefined"?v:C}e.getOrDefault=k;function y(d,m){const v=Object.create(null);return!d||!m||Object.keys(m).forEach(u=>{const f=d[u],c=m[u];S(f,c)||(v[u]=c)}),v}e.distinct=y;function g(d,m){const v=m.toLowerCase(),C=Object.keys(d).find(u=>u.toLowerCase()===v);return C?d[C]:d[m]}e.getCaseInsensitive=g;function t(d,m){const v=Object.create(null);for(const[C,u]of Object.entries(d))m(C,u)&&(v[C]=u);return v}e.filter=t}),define(ee[7],te([0,1,9,3]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,M=/^\//,P=/^\/\//;function E(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!D.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!M.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(s,i){return!s&&!i?"file":s}function S(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==k&&(i=k+i):i=k;break}return i}const b="",k="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(i,r,a,h,I,R=!1){typeof i=="object"?(this.scheme=i.scheme||b,this.authority=i.authority||b,this.path=i.path||b,this.query=i.query||b,this.fragment=i.fragment||b):(this.scheme=w(i,R),this.authority=r||b,this.path=S(this.scheme,a||b),this.query=h||b,this.fragment=I||b,E(this,R))}static isUri(i){return i instanceof g?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return u(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:a,path:h,query:I,fragment:R}=i;return r===void 0?r=this.scheme:r===null&&(r=b),a===void 0?a=this.authority:a===null&&(a=b),h===void 0?h=this.path:h===null&&(h=b),I===void 0?I=this.query:I===null&&(I=b),R===void 0?R=this.fragment:R===null&&(R=b),r===this.scheme&&a===this.authority&&h===this.path&&I===this.query&&R===this.fragment?this:new d(r,a,h,I,R)}static parse(i,r=!1){const a=y.exec(i);return a?new d(a[2]||b,l(a[4]||b),l(a[5]||b),l(a[7]||b),l(a[9]||b),r):new d(b,b,b,b,b)}static file(i){let r=b;if(n.isWindows&&(i=i.replace(/\\/g,k)),i[0]===k&&i[1]===k){const a=i.indexOf(k,2);a===-1?(r=i.substring(2),i=k):(r=i.substring(2,a),i=i.substring(a)||k)}return new d("file",r,i,b,b)}static from(i){const r=new d(i.scheme,i.authority,i.path,i.query,i.fragment);return E(r,!0),r}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return n.isWindows&&i.scheme==="file"?a=g.file(p.win32.join(u(i,!0),...r)).path:a=p.posix.join(i.path,...r),i.with({path:a})}toString(i=!1){return f(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof g)return i;{const r=new d(i);return r._formatted=i.external,r._fsPath=i._sep===t?i.fsPath:null,r}}else return i}}e.URI=g;const t=n.isWindows?1:void 0;class d extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(i=!1){return i?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=t),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(s,i){let r,a=-1;for(let h=0;h<s.length;h++){const I=s.charCodeAt(h);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||i&&I===47)a!==-1&&(r+=encodeURIComponent(s.substring(a,h)),a=-1),r!==void 0&&(r+=s.charAt(h));else{r===void 0&&(r=s.substr(0,h));const R=m[I];R!==void 0?(a!==-1&&(r+=encodeURIComponent(s.substring(a,h)),a=-1),r+=R):a===-1&&(a=h)}}return a!==-1&&(r+=encodeURIComponent(s.substring(a))),r!==void 0?r:s}function C(s){let i;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(i===void 0&&(i=s.substr(0,r)),i+=m[a]):i!==void 0&&(i+=s[r])}return i!==void 0?i:s}function u(s,i){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,n.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=u;function f(s,i){const r=i?C:v;let a="",{scheme:h,authority:I,path:R,query:L,fragment:W}=s;if(h&&(a+=h,a+=":"),(I||h==="file")&&(a+=k,a+=k),I){let N=I.indexOf("@");if(N!==-1){const J=I.substr(0,N);I=I.substr(N+1),N=J.indexOf(":"),N===-1?a+=r(J,!1):(a+=r(J.substr(0,N),!1),a+=":",a+=r(J.substr(N+1),!1)),a+="@"}I=I.toLowerCase(),N=I.indexOf(":"),N===-1?a+=r(I,!1):(a+=r(I.substr(0,N),!1),a+=I.substr(N))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const N=R.charCodeAt(1);N>=65&&N<=90&&(R=`/${String.fromCharCode(N+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const N=R.charCodeAt(0);N>=65&&N<=90&&(R=`${String.fromCharCode(N+32)}:${R.substr(2)}`)}a+=r(R,!0)}return L&&(a+="?",a+=r(L,!1)),W&&(a+="#",a+=i?W:v(W,!1)),a}function c(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+c(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(s){return s.match(o)?s.replace(o,i=>c(i)):s}}),define(ee[112],te([0,1,7]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(S){const b=S;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=n;function D(S){const b=[];let k;try{const y=JSON.parse(S.arguments),g=y[y.length-1];g&&g.__$stack&&(y.pop(),k=g.__$stack),b.push(...y)}catch{b.push("Unable to log remote console arguments",S.arguments)}return{args:b,stack:k}}e.parse=D;function M(S){if(typeof S!="string")return M(D(S).stack);const b=S;if(b){const k=P(b),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(y&&y.length===4)return{uri:p.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=M;function P(S){if(!S)return S;const b=S.indexOf(`
`);return b===-1?S:S.substring(0,b)}function E(S,b){const{args:k,stack:y}=D(S),g=typeof k[0]=="string"&&k.length===1;let t=P(y);t&&(t=`(${t.trim()})`);let d=[];if(typeof k[0]=="string"?t&&g?d=[`%c[${b}] %c${k[0]} %c${t}`,w("blue"),w(""),w("grey")]:d=[`%c[${b}] %c${k[0]}`,w("blue"),w(""),...k.slice(1)]:d=[`%c[${b}]%`,w("blue"),...k],t&&!g&&d.push(t),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,d)}e.log=E;function w(S){return`color: ${S}`}}),define(ee[113],te([0,1,17,25,7]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function M(b){return JSON.stringify(b,w)}e.stringify=M;function P(b){let k=JSON.parse(b);return k=S(k),k}e.parse=P;var E;(function(b){b[b.Uri=1]="Uri",b[b.Regexp=2]="Regexp",b[b.ScmResource=3]="ScmResource",b[b.ScmResourceGroup=4]="ScmResourceGroup",b[b.ScmProvider=5]="ScmProvider",b[b.CommentController=6]="CommentController",b[b.CommentThread=7]="CommentThread",b[b.CommentThreadReply=8]="CommentThreadReply",b[b.CommentNode=9]="CommentNode",b[b.CommentThreadNode=10]="CommentThreadNode",b[b.TimelineActionContext=11]="TimelineActionContext",b[b.NotebookCellActionContext=12]="NotebookCellActionContext",b[b.TestItemContext=13]="TestItemContext",b[b.Date=14]="Date"})(E=e.MarshalledId||(e.MarshalledId={}));function w(b,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:(0,n.regExpFlags)(k)}:k}function S(b,k=0){if(!b||k>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return D.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 14:return new Date(b.source)}if(b instanceof p.VSBuffer||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let y=0;y<b.length;++y)b[y]=S(b[y],k+1);else for(const y in b)Object.hasOwnProperty.call(b,y)&&(b[y]=S(b[y],k+1))}return b}e.revive=S}),define(ee[10],te([0,1,3,7]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.userData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls"})(D=e.Schemas||(e.Schemas={}));class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}set(w,S,b){this._hosts[w]=S,this._ports[w]=b}setConnectionToken(w,S){this._connectionTokens[w]=S}rewrite(w){if(this._delegate)return this._delegate(w);const S=w.authority;let b=this._hosts[S];b&&b.indexOf(":")!==-1&&(b=`[${b}]`);const k=this._ports[S],y=this._connectionTokens[S];let g=`path=${encodeURIComponent(w.path)}`;return typeof y=="string"&&(g+=`&tkn=${encodeURIComponent(y)}`),n.URI.from({scheme:p.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${b}:${k}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new M;class P{asBrowserUri(w,S){const b=this.toUri(w,S);return b.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(b):b.scheme===D.file&&(p.isNative||typeof p.globals.importScripts=="function"&&p.globals.origin===`${D.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?b.with({scheme:D.vscodeFileResource,authority:b.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):b}asFileUri(w,S){const b=this.toUri(w,S);return b.scheme===D.vscodeFileResource?b.with({scheme:D.file,authority:b.authority!==P.FALLBACK_AUTHORITY?b.authority:null,query:null,fragment:null}):b}toUri(w,S){return n.URI.isUri(w)?w:n.URI.parse(S.toUrl(w))}}P.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new P}),define(ee[16],te([0,1,28,10,9,3,25,7]),function(j,e,p,n,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(g){return(0,E.uriToFsPath)(g,!0)}e.originalFSPath=w;class S{constructor(t){this._ignorePathCasing=t}compare(t,d,m=!1){return t===d?0:(0,P.compare)(this.getComparisonKey(t,m),this.getComparisonKey(d,m))}isEqual(t,d,m=!1){return t===d?!0:!t||!d?!1:this.getComparisonKey(t,m)===this.getComparisonKey(d,m)}getComparisonKey(t,d=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,d,m=!1){if(t.scheme===d.scheme){if(t.scheme===n.Schemas.file)return p.isEqualOrParent(w(t),w(d),this._ignorePathCasing(t))&&t.query===d.query&&(m||t.fragment===d.fragment);if((0,e.isEqualAuthority)(t.authority,d.authority))return p.isEqualOrParent(t.path,d.path,this._ignorePathCasing(t),"/")&&t.query===d.query&&(m||t.fragment===d.fragment)}return!1}joinPath(t,...d){return E.URI.joinPath(t,...d)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return D.posix.basename(t.path)}extname(t){return D.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let d;return t.scheme===n.Schemas.file?d=E.URI.file(D.dirname(w(t))).path:(d=D.posix.dirname(t.path),t.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),d="/")),t.with({path:d})}normalizePath(t){if(!t.path.length)return t;let d;return t.scheme===n.Schemas.file?d=E.URI.file(D.normalize(w(t))).path:d=D.posix.normalize(t.path),t.with({path:d})}relativePath(t,d){if(t.scheme!==d.scheme||!(0,e.isEqualAuthority)(t.authority,d.authority))return;if(t.scheme===n.Schemas.file){const C=D.relative(w(t),w(d));return M.isWindows?p.toSlashes(C):C}let m=t.path||"/",v=d.path||"/";if(this._ignorePathCasing(t)){let C=0;for(const u=Math.min(m.length,v.length);C<u&&!(m.charCodeAt(C)!==v.charCodeAt(C)&&m.charAt(C).toLowerCase()!==v.charAt(C).toLowerCase());C++);m=v.substr(0,C)+m.substr(C)}return D.posix.relative(m,v)}resolvePath(t,d){if(t.scheme===n.Schemas.file){const m=E.URI.file(D.resolve(w(t),d));return t.with({authority:m.authority,path:m.path})}return d=p.toPosixPath(d),t.with({path:D.posix.resolve(t.path,d)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,d){return t===d||t!==void 0&&d!==void 0&&(0,P.equalsIgnoreCase)(t,d)}hasTrailingPathSeparator(t,d=D.sep){if(t.scheme===n.Schemas.file){const m=w(t);return m.length>p.getRoot(m).length&&m[m.length-1]===d}else{const m=t.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,d=D.sep){return(0,e.hasTrailingPathSeparator)(t,d)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,d=D.sep){let m=!1;if(t.scheme===n.Schemas.file){const v=w(t);m=v!==void 0&&v.length===p.getRoot(v).length&&v[v.length-1]===d}else{d="/";const v=t.path;m=v.length===1&&v.charCodeAt(v.length-1)===47}return!m&&!(0,e.hasTrailingPathSeparator)(t,d)?t.with({path:t.path+"/"}):t}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(g=>g.scheme===n.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new S(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function b(g,t){const d=[];for(let m=0;m<g.length;m++){const v=t(g[m]);g.some((C,u)=>u===m?!1:(0,e.isEqualOrParent)(v,t(C)))||d.push(g[m])}return d}e.distinctParents=b;var k;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function t(d){const m=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(u=>{const[f,c]=u.split(":");f&&c&&m.set(f,c)});const C=d.path.substring(0,d.path.indexOf(";"));return C&&m.set(g.META_DATA_MIME,C),m}g.parseMetaData=t})(k=e.DataUri||(e.DataUri={}));function y(g,t,d){if(t){let m=g.path;return m&&m[0]!==D.posix.sep&&(m=D.posix.sep+m),g.with({scheme:d,authority:t,path:m})}return g.with({scheme:d})}e.toLocalResource=y}),define(ee[8],te([0,1,21,15,4,2,16,3]),function(j,e,p,n,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(A){return!!A&&typeof A.then=="function"}e.isThenable=w;function S(A){const T=new p.CancellationTokenSource,U=A(T.token),O=new Promise((_,Q)=>{const ie=T.token.onCancellationRequested(()=>{ie.dispose(),T.dispose(),Q(new n.CancellationError)});Promise.resolve(U).then(se=>{ie.dispose(),T.dispose(),_(se)},se=>{ie.dispose(),T.dispose(),Q(se)})});return new class{cancel(){T.cancel()}then(_,Q){return O.then(_,Q)}catch(_){return this.then(void 0,_)}finally(_){return O.finally(_)}}}e.createCancelablePromise=S;function b(A,T,U){return new Promise((O,_)=>{const Q=T.onCancellationRequested(()=>{Q.dispose(),O(U)});A.then(O,_).finally(()=>Q.dispose())})}e.raceCancellation=b;function k(A,T){return new Promise((U,O)=>{const _=T.onCancellationRequested(()=>{_.dispose(),O(new n.CancellationError)});A.then(U,O).finally(()=>_.dispose())})}e.raceCancellationError=k;async function y(A){let T=-1;const U=A.map((_,Q)=>_.then(ie=>(T=Q,ie))),O=await Promise.race(U);return A.forEach((_,Q)=>{Q!==T&&_.cancel()}),O}e.raceCancellablePromises=y;function g(A,T,U){let O;const _=setTimeout(()=>{O?.(void 0),U?.()},T);return Promise.race([A.finally(()=>clearTimeout(_)),new Promise(Q=>O=Q)])}e.raceTimeout=g;function t(A){return new Promise((T,U)=>{const O=A();w(O)?O.then(T,U):T(O)})}e.asPromise=t;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(T){if(this.activePromise){if(this.queuedPromiseFactory=T,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(U,U).then(O)})}return new Promise((U,O)=>{this.queuedPromise.then(U,O)})}return this.activePromise=T(),new Promise((U,O)=>{this.activePromise.then(_=>{this.activePromise=null,U(_)},_=>{this.activePromise=null,O(_)})})}}e.Throttler=d;class m{constructor(){this.current=Promise.resolve(null)}queue(T){return this.current=this.current.then(()=>T(),()=>T())}}e.Sequencer=m;class v{constructor(){this.promiseMap=new Map}queue(T,U){const _=(this.promiseMap.get(T)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(T)===_&&this.promiseMap.delete(T)});return this.promiseMap.set(T,_),_}}e.SequencerByKey=v;const C=(A,T)=>{let U=!0;const O=setTimeout(()=>{U=!1,T()},A);return{isTriggered:()=>U,dispose:()=>{clearTimeout(O),U=!1}}},u=A=>{let T=!0;return queueMicrotask(()=>{T&&(T=!1,A())}),{isTriggered:()=>T,dispose:()=>{T=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class f{constructor(T){this.defaultDelay=T,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(T,U=this.defaultDelay){this.task=T,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((_,Q)=>{this.doResolve=_,this.doReject=Q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const _=this.task;return this.task=null,_()}}));const O=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=U===e.MicrotaskDelay?u(O):C(U,O),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=f;class c{constructor(T){this.delayer=new f(T),this.throttler=new d}trigger(T,U){return this.delayer.trigger(()=>this.throttler.queue(T),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class o{constructor(){this._isOpen=!1,this._promise=new Promise((T,U)=>{this._completePromise=T})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class l extends o{constructor(T){super();this._timeout=setTimeout(()=>this.open(),T)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function s(A,T){return T?new Promise((U,O)=>{const _=setTimeout(()=>{Q.dispose(),U()},A),Q=T.onCancellationRequested(()=>{clearTimeout(_),Q.dispose(),O(new n.CancellationError)})}):S(U=>s(A,U))}e.timeout=s;function i(A,T=0){const U=setTimeout(A,T);return(0,M.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=i;function r(A){const T=[];let U=0;const O=A.length;function _(){return U<O?A[U++]():null}function Q(ie){ie!=null&&T.push(ie);const se=_();return se?se.then(Q):Promise.resolve(T)}return Promise.resolve(null).then(Q)}e.sequence=r;function a(A,T=O=>!!O,U=null){let O=0;const _=A.length,Q=()=>{if(O>=_)return Promise.resolve(U);const ie=A[O++];return Promise.resolve(ie()).then(x=>T(x)?Promise.resolve(x):Q())};return Q()}e.first=a;function h(A,T=O=>!!O,U=null){if(A.length===0)return Promise.resolve(U);let O=A.length;const _=()=>{O=-1;for(const Q of A)Q.cancel?.()};return new Promise((Q,ie)=>{for(const se of A)se.then(x=>{--O>=0&&T(x)?(_(),Q(x)):O===0&&Q(U)}).catch(x=>{--O>=0&&(_(),ie(x))})})}e.firstParallel=h;class I{constructor(T){this._size=0,this.maxDegreeOfParalellism=T,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(T){return this._size++,new Promise((U,O)=>{this.outstandingPromises.push({factory:T,c:U,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const T=this.outstandingPromises.shift();this.runningPromises++;const U=T.factory();U.then(T.c,T.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=I;class R extends I{constructor(){super(1)}}e.Queue=R;class L{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const T=new z;return this.drainers.add(T),T.p}isDrained(){for(const[,T]of this.queues)if(T.size>0)return!1;return!0}queueFor(T,U=P.extUri){const O=U.getComparisonKey(T);let _=this.queues.get(O);return _||(_=new R,D.Event.once(_.onFinished)(()=>{_?.dispose(),this.queues.delete(O),this.onDidQueueFinish()}),this.queues.set(O,_)),_}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const T of this.drainers)T.complete();this.drainers.clear()}dispose(){for(const[,T]of this.queues)T.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=L;class W{constructor(T,U){this._token=-1,typeof T=="function"&&typeof U=="number"&&this.setIfNotSet(T,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(T,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,T()},U)}setIfNotSet(T,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,T()},U))}}e.TimeoutTimer=W;class N{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(T,U){this.cancel(),this._token=setInterval(()=>{T()},U)}}e.IntervalTimer=N;class J{constructor(T,U){this.timeoutToken=-1,this.runner=T,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(T=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,T)}get delay(){return this.timeout}set delay(T){this.timeout=T}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=J;class oe{constructor(T,U){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.runner=T,this.timeout=U,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(T=this.timeout){T%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(T/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=oe;class re extends J{constructor(T,U){super(T,U);this.units=[]}work(T){this.units.push(T),this.isScheduled()||this.schedule()}doRun(){const T=this.units;this.units=[],this.runner&&this.runner(T)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=re;class V extends M.Disposable{constructor(T,U){super();this.options=T,this.handler=U,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(T){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+T.length>this.options.maxBufferedWork)return!1}else if(this.pending+T.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...T),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new J(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=V,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=A=>{(0,E.setTimeout0)(()=>{if(T)return;const U=Date.now()+15;A(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let T=!1;return{dispose(){T||(T=!0)}}}:e.runWhenIdle=(A,T)=>{const U=requestIdleCallback(A,typeof T=="number"?{timeout:T}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(U))}}}}();class Z{constructor(T){this._didRun=!1,this._executor=()=>{try{this._value=T()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=Z;async function H(A,T,U){let O;for(let _=0;_<U;_++)try{return await A()}catch(Q){O=Q,await s(T)}throw O}e.retry=H;class K{hasPending(T){return this._pending?typeof T=="number"?this._pending.taskId===T:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(T,U,O){return this._pending={taskId:T,cancel:()=>O?.(),promise:U},U.then(()=>this.donePending(T),()=>this.donePending(T)),U}donePending(T){this._pending&&T===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const T=this._next;this._next=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}setNext(T){if(this._next)this._next.run=T;else{let U,O;const _=new Promise((Q,ie)=>{U=Q,O=ie});this._next={run:T,promise:_,promiseResolve:U,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=K;class G{constructor(T,U=()=>Date.now()){this.interval=T,this.nowFn=U,this.lastIncrementTime=0,this.value=0}increment(){const T=this.nowFn();return T-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=T,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((T,U)=>{this.completeCallback=T,this.errorCallback=U})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(T){return new Promise(U=>{this.completeCallback(T),this.resolved=!0,U()})}error(T){return new Promise(U=>{this.errorCallback(T),this.rejected=!0,U()})}cancel(){new Promise(T=>{this.errorCallback(new n.CancellationError),this.rejected=!0,T()})}}e.DeferredPromise=z;var B;(function(A){async function T(O){let _;const Q=await Promise.all(O.map(ie=>ie.then(se=>se,se=>{_||(_=se)})));if(typeof _!="undefined")throw _;return Q}A.settled=T;function U(O){return new Promise(async(_,Q)=>{try{await O(_,Q)}catch(ie){Q(ie)}})}A.withAsyncBody=U})(B=e.Promises||(e.Promises={}));var Y;(function(A){A[A.Initial=0]="Initial",A[A.DoneOK=1]="DoneOK",A[A.DoneError=2]="DoneError"})(Y||(Y={}));class q{constructor(T){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const U={emitOne:O=>this.emitOne(O),emitMany:O=>this.emitMany(O),reject:O=>this.reject(O)};try{await Promise.resolve(T(U)),this.resolve()}catch(O){this.reject(O)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}static fromArray(T){return new q(U=>{U.emitMany(T)})}static fromPromise(T){return new q(async U=>{U.emitMany(await T)})}static fromPromises(T){return new q(async U=>{await Promise.all(T.map(async O=>U.emitOne(await O)))})}static merge(T){return new q(async U=>{await Promise.all(T.map(async O=>{for await(const _ of O)U.emitOne(_)}))})}[Symbol.asyncIterator](){let T=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(T<this._results.length)return{done:!1,value:this._results[T++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(T,U){return new q(async O=>{for await(const _ of T)O.emitOne(U(_))})}map(T){return q.map(this,T)}static filter(T,U){return new q(async O=>{for await(const _ of T)U(_)&&O.emitOne(_)})}filter(T){return q.filter(this,T)}static coalesce(T){return q.filter(T,U=>!!U)}coalesce(){return q.coalesce(this)}static async toPromise(T){const U=[];for await(const O of T)U.push(O);return U}toPromise(){return q.toPromise(this)}emitOne(T){this._state===0&&(this._results.push(T),this._onStateChanged.fire())}emitMany(T){this._state===0&&(this._results=this._results.concat(T),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(T){this._state===0&&(this._state=2,this._error=T,this._onStateChanged.fire())}}e.AsyncIterableObject=q,q.EMPTY=q.fromArray([]);class F extends q{constructor(T,U){super(U);this._source=T}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=F;function $(A){const T=new p.CancellationTokenSource,U=A(T.token);return new F(T,async O=>{const _=T.token.onCancellationRequested(()=>{_.dispose(),T.dispose(),O.reject(new n.CancellationError)});try{for await(const Q of U){if(T.token.isCancellationRequested)return;O.emitOne(Q)}_.dispose(),T.dispose()}catch(Q){_.dispose(),T.dispose(),O.reject(Q)}})}e.createCancelableAsyncIterable=$}),define(ee[114],te([0,1,8,28,35,9,25]),function(j,e,p,n,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function E(){return Object.create(null)}e.getEmptyExpression=E,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const w="[/\\\\]",S="[^/\\\\]",b=/\//g;function k(G){switch(G){case 0:return"";case 1:return`${S}*?`;default:return`(?:${w}|${S}+${w}|${w}${S}+)*?`}}function y(G,z){if(!G)return[];const B=[];let Y=!1,q=!1,F="";for(const $ of G){switch($){case z:if(!Y&&!q){B.push(F),F="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":q=!0;break;case"]":q=!1;break}F+=$}return F&&B.push(F),B}e.splitGlobAware=y;function g(G){if(!G)return"";let z="";const B=y(G,e.GLOB_SPLIT);if(B.every(Y=>Y===e.GLOBSTAR))z=".*";else{let Y=!1;B.forEach((q,F)=>{if(q===e.GLOBSTAR){Y||(z+=k(2),Y=!0);return}let $=!1,A="",T=!1,U="";for(const O of q){if(O!=="}"&&$){A+=O;continue}if(T&&(O!=="]"||!U)){let _;O==="-"?_=O:(O==="^"||O==="!")&&!U?_="^":O===e.GLOB_SPLIT?_="":_=P.escapeRegExpCharacters(O),U+=_;continue}switch(O){case"{":$=!0;continue;case"[":T=!0;continue;case"}":{z+=`(?:${y(A,",").map(ie=>g(ie)).join("|")})`,$=!1,A="";break}case"]":z+="["+U+"]",T=!1,U="";break;case"?":z+=S;continue;case"*":z+=k(1);continue;default:z+=P.escapeRegExpCharacters(O)}}F<B.length-1&&(B[F+1]!==e.GLOBSTAR||F+2<B.length)&&(z+=w),Y=!1})}return z}const t=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,v=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,C=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,f=new D.LRUCache(1e4),c=function(){return!1},o=function(){return null};function l(G,z){if(!G)return o;let B;typeof G!="string"?B=G.pattern:B=G,B=B.trim();const Y=`${B}_${!!z.trimForExclusions}`;let q=f.get(Y);if(q)return s(q,G);let F;if(t.test(B)){const $=B.substr(4);q=function(A,T){return typeof A=="string"&&A.endsWith($)?B:null}}else(F=d.exec(i(B,z)))?q=r(F[1],B):(z.trimForExclusions?v:m).test(B)?q=a(B,z):(F=C.exec(i(B,z)))?q=h(F[1].substr(1),B,!0):(F=u.exec(i(B,z)))?q=h(F[1],B,!1):q=I(B);return f.set(Y,q),s(q,G)}function s(G,z){return typeof z=="string"?G:function(B,Y){return n.isEqualOrParent(B,z.base)?G(M.relative(z.base,B),Y):null}}function i(G,z){return z.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function r(G,z){const B=`/${G}`,Y=`\\${G}`,q=function($,A){return typeof $!="string"?null:A?A===G?z:null:$===G||$.endsWith(B)||$.endsWith(Y)?z:null},F=[G];return q.basenames=F,q.patterns=[z],q.allBasenames=F,q}function a(G,z){const B=K(G.slice(1,-1).split(",").map(A=>l(A,z)).filter(A=>A!==o),G),Y=B.length;if(!Y)return o;if(Y===1)return B[0];const q=function(A,T){for(let U=0,O=B.length;U<O;U++)if(B[U](A,T))return G;return null},F=B.find(A=>!!A.allBasenames);F&&(q.allBasenames=F.allBasenames);const $=B.reduce((A,T)=>T.allPaths?A.concat(T.allPaths):A,[]);return $.length&&(q.allPaths=$),q}function h(G,z,B){const Y=M.sep===M.posix.sep,q=Y?G:G.replace(b,M.sep),F=M.sep+q,$=M.posix.sep+G,A=B?function(T,U){return typeof T=="string"&&(T===q||T.endsWith(F)||!Y&&(T===G||T.endsWith($)))?z:null}:function(T,U){return typeof T=="string"&&(T===q||!Y&&T===G)?z:null};return A.allPaths=[(B?"*/":"./")+G],A}function I(G){try{const z=new RegExp(`^${g(G)}$`);return function(B){return z.lastIndex=0,typeof B=="string"&&z.test(B)?G:null}}catch{return o}}function R(G,z,B){return!G||typeof z!="string"?!1:L(G)(z,void 0,B)}e.match=R;function L(G,z={}){if(!G)return c;if(typeof G=="string"||oe(G)){const B=l(G,z);if(B===o)return c;const Y=function(q,F){return!!B(q,F)};return B.allBasenames&&(Y.allBasenames=B.allBasenames),B.allPaths&&(Y.allPaths=B.allPaths),Y}return Z(G,z)}e.parse=L;function W(G){if(!G)return;let z;return B=>(z||(z=(G()||Promise.resolve([])).then(Y=>Y?J(Y):{})),z.then(Y=>!!Y[B]))}e.hasSiblingPromiseFn=W;function N(G){if(!G)return;let z;return B=>{if(!z){const Y=G();z=Y?J(Y):{}}return!!z[B]}}e.hasSiblingFn=N;function J(G){const z={};for(const B of G)z[B]=!0;return z}function oe(G){const z=G;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}e.isRelativePattern=oe;function re(G){return G.allBasenames||[]}e.getBasenameTerms=re;function V(G){return G.allPaths||[]}e.getPathTerms=V;function Z(G,z){const B=K(Object.getOwnPropertyNames(G).map(A=>H(A,G[A],z)).filter(A=>A!==o)),Y=B.length;if(!Y)return o;if(!B.some(A=>!!A.requiresSiblings)){if(Y===1)return B[0];const A=function(O,_){for(let Q=0,ie=B.length;Q<ie;Q++){const se=B[Q](O,_);if(se)return se}return null},T=B.find(O=>!!O.allBasenames);T&&(A.allBasenames=T.allBasenames);const U=B.reduce((O,_)=>_.allPaths?O.concat(_.allPaths):O,[]);return U.length&&(A.allPaths=U),A}const q=function(A,T,U){let O;for(let _=0,Q=B.length;_<Q;_++){const ie=B[_];ie.requiresSiblings&&U&&(T||(T=M.basename(A)),O||(O=T.substr(0,T.length-M.extname(A).length)));const se=ie(A,T,O,U);if(se)return se}return null},F=B.find(A=>!!A.allBasenames);F&&(q.allBasenames=F.allBasenames);const $=B.reduce((A,T)=>T.allPaths?A.concat(T.allPaths):A,[]);return $.length&&(q.allPaths=$),q}function H(G,z,B){if(z===!1)return o;const Y=l(G,B);if(Y===o)return o;if(typeof z=="boolean")return Y;if(z){const q=z.when;if(typeof q=="string"){const F=($,A,T,U)=>{if(!U||!Y($,A))return null;const O=q.replace("$(basename)",T),_=U(O);return(0,p.isThenable)(_)?_.then(Q=>Q?G:null):_?G:null};return F.requiresSiblings=!0,F}}return Y}function K(G,z){const B=G.filter(A=>!!A.basenames);if(B.length<2)return G;const Y=B.reduce((A,T)=>{const U=T.basenames;return U?A.concat(U):A},[]);let q;if(z){q=[];for(let A=0,T=Y.length;A<T;A++)q.push(z)}else q=B.reduce((A,T)=>{const U=T.patterns;return U?A.concat(U):A},[]);const F=function(A,T){if(typeof A!="string")return null;if(!T){let O;for(O=A.length;O>0;O--){const _=A.charCodeAt(O-1);if(_===47||_===92)break}T=A.substr(O)}const U=Y.indexOf(T);return U!==-1?q[U]:null};F.basenames=Y,F.patterns=q,F.allBasenames=Y;const $=G.filter(A=>!A.basenames);return $.push(F),$}}),define(ee[33],te([0,1,28,10,9,3,16,25,7]),function(j,e,p,n,D,M,P,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function S(i,r,a){if(typeof i=="string"&&(i=w.URI.file(i)),a){const I=a.getWorkspaceFolder(i);if(I){const R=a.getWorkspace().folders.length>1;let L;if((0,P.isEqual)(I.uri,i)?L="":L=(0,P.relativePath)(I.uri,i),R){const W=I.name?I.name:(0,P.basename)(I.uri);L=L?W+" \u2022 "+L:W}return L}}if(i.scheme!==n.Schemas.file&&i.scheme!==n.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,p.hasDriveLetter)(i.fsPath))return(0,D.normalize)(k(i.fsPath));let h=(0,D.normalize)(i.fsPath);return!M.isWindows&&r?.userHome&&(h=g(h,r.userHome.fsPath)),h}e.getPathLabel=S;function b(i){if(!i)return;typeof i=="string"&&(i=w.URI.file(i));const r=(0,P.basename)(i)||(i.scheme===n.Schemas.file?i.fsPath:i.path);return M.isWindows&&(0,p.isRootOrDriveLetter)(r)?k(r):r}e.getBaseLabel=b;function k(i,r){return(0,p.hasDriveLetter)(i,r)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=k;let y=Object.create(null);function g(i,r){if(M.isWindows||!i||!r)return i;let a=y.original===r?y.normalized:void 0;return a||(a=`${(0,E.rtrim)(r,D.posix.sep)}${D.posix.sep}`,y={original:r,normalized:a}),(M.isLinux?i.startsWith(a):(0,E.startsWithIgnoreCase)(i,a))&&(i=`~/${i.substr(a.length)}`),i}e.tildify=g;function t(i,r){return i.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=t;const d="\u2026",m="\\\\",v="~";function C(i,r=D.sep){const a=new Array(i.length);let h=!1;for(let I=0;I<i.length;I++){let R=i[I];if(R===""){a[I]=`.${r}`;continue}if(!R){a[I]=R;continue}h=!0;let L="";R.indexOf(m)===0?(L=R.substr(0,R.indexOf(m)+m.length),R=R.substr(R.indexOf(m)+m.length)):R.indexOf(r)===0?(L=R.substr(0,R.indexOf(r)+r.length),R=R.substr(R.indexOf(r)+r.length)):R.indexOf(v)===0&&(L=R.substr(0,R.indexOf(v)+v.length),R=R.substr(R.indexOf(v)+v.length));const W=R.split(r);for(let N=1;h&&N<=W.length;N++)for(let J=W.length-N;h&&J>=0;J--){h=!1;let oe=W.slice(J,J+N).join(r);for(let re=0;!h&&re<i.length;re++)if(re!==I&&i[re]&&i[re].indexOf(oe)>-1){const V=J+N===W.length,Z=J>0&&i[re].indexOf(r)>-1?r+oe:oe,H=i[re].endsWith(Z);h=!V||H}if(!h){let re="";(W[0].endsWith(":")||L!=="")&&(J===1&&(J=0,N++,oe=W[0]+r+oe),J>0&&(re=W[0]+r),re=L+re),J>0&&(re=re+d+r),re=re+oe,J+N<W.length&&(re=re+r+d),a[I]=re}}h&&(a[I]=R)}return a}e.shorten=C;var u;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function f(i,r=Object.create(null)){const a=[];let h=!1,I="";for(const R of i)if(R==="$"||h&&R==="{")I&&a.push({value:I,type:u.TEXT}),I="",h=!0;else if(R==="}"&&h){const L=r[I];if(typeof L=="string")L.length&&a.push({value:L,type:u.VARIABLE});else if(L){const W=a[a.length-1];(!W||W.type!==u.SEPARATOR)&&a.push({value:L.label,type:u.SEPARATOR})}I="",h=!1}else I+=R;return I&&!h&&a.push({value:I,type:u.TEXT}),a.filter((R,L)=>{if(R.type===u.SEPARATOR){const W=a[L-1],N=a[L+1];return[W,N].every(J=>J&&(J.type===u.VARIABLE||J.type===u.TEXT)&&J.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=f;function c(i,r){return M.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):i.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function o(i,r){return M.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,""):M.isWindows?i.replace(/&&|&/g,a=>a==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=o;function l(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=l;function s(i){const r=i.indexOf("/")!==-1?D.posix:D.win32,a=r.basename(i),h=r.dirname(i);return a.length?{name:a,parentPath:h}:{name:h,parentPath:""}}e.splitName=s}),define(ee[115],te([0,1,7]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(b){return b.toJSON()}class D{constructor(k){this._uriTransformer=k}transformIncoming(k){const y=this._uriTransformer.transformIncoming(k);return y===k?k:n(p.URI.from(y))}transformOutgoing(k){const y=this._uriTransformer.transformOutgoing(k);return y===k?k:n(p.URI.from(y))}transformOutgoingURI(k){const y=this._uriTransformer.transformOutgoing(k);return y===k?k:p.URI.from(y)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function M(b,k,y){if(!b||y>200)return null;if(typeof b=="object"){if(b instanceof p.URI)return k.transformOutgoing(b);for(let g in b)if(Object.hasOwnProperty.call(b,g)){const t=M(b[g],k,y+1);t!==null&&(b[g]=t)}}return null}function P(b,k){const y=M(b,k,0);return y===null?b:y}e.transformOutgoingURIs=P;function E(b,k,y,g){if(!b||g>200)return null;if(typeof b=="object"){if(b.$mid===1)return y?p.URI.revive(k.transformIncoming(b)):k.transformIncoming(b);for(let t in b)if(Object.hasOwnProperty.call(b,t)){const d=E(b[t],k,y,g+1);d!==null&&(b[t]=d)}}return null}function w(b,k){const y=E(b,k,!1,0);return y===null?b:y}e.transformIncomingURIs=w;function S(b,k){const y=E(b,k,!0,0);return y===null?b:y}e.transformAndReviveIncomingURIs=S}),define(ee[32],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(w){return p.test(w)}e.isUUID=n;const D=new Uint8Array(16),M=[];for(let w=0;w<256;w++)M.push(w.toString(16).padStart(2,"0"));let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(w){for(let S=0;S<w.length;S++)w[S]=Math.floor(Math.random()*256);return w};function E(){P(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let w=0,S="";return S+=M[D[w++]],S+=M[D[w++]],S+=M[D[w++]],S+=M[D[w++]],S+="-",S+=M[D[w++]],S+=M[D[w++]],S+="-",S+=M[D[w++]],S+=M[D[w++]],S+="-",S+=M[D[w++]],S+=M[D[w++]],S+="-",S+=M[D[w++]],S+=M[D[w++]],S+=M[D[w++]],S+=M[D[w++]],S+=M[D[w++]],S+=M[D[w++]],S}e.generateUuid=E}),define(ee[116],te([0,1,15,4,2,3,13,25]),function(j,e,p,n,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.SimpleWorkerServer=e.SimpleWorkerClient=e.logOnceWebWorkerWarning=void 0;const w="$initialize";let S=!1;function b(s){!M.isWeb||(S||(S=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(s.message))}e.logOnceWebWorkerWarning=b;var k;(function(s){s[s.Request=0]="Request",s[s.Reply=1]="Reply",s[s.SubscribeEvent=2]="SubscribeEvent",s[s.Event=3]="Event",s[s.UnsubscribeEvent=4]="UnsubscribeEvent"})(k||(k={}));class y{constructor(i,r,a,h){this.vsWorker=i,this.req=r,this.method=a,this.args=h,this.type=0}}class g{constructor(i,r,a,h){this.vsWorker=i,this.seq=r,this.res=a,this.err=h,this.type=1}}class t{constructor(i,r,a,h){this.vsWorker=i,this.req=r,this.eventName=a,this.arg=h,this.type=2}}class d{constructor(i,r,a){this.vsWorker=i,this.req=r,this.event=a,this.type=3}}class m{constructor(i,r){this.vsWorker=i,this.req=r,this.type=4}}class v{constructor(i){this._workerId=-1,this._handler=i,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(i){this._workerId=i}sendMessage(i,r){const a=String(++this._lastSentReq);return new Promise((h,I)=>{this._pendingReplies[a]={resolve:h,reject:I},this._send(new y(this._workerId,a,i,r))})}listen(i,r){let a=null;const h=new n.Emitter({onFirstListenerAdd:()=>{a=String(++this._lastSentReq),this._pendingEmitters.set(a,h),this._send(new t(this._workerId,a,i,r))},onLastListenerRemove:()=>{this._pendingEmitters.delete(a),this._send(new m(this._workerId,a)),a=null}});return h.event}handleMessage(i){!i||!i.vsWorker||this._workerId!==-1&&i.vsWorker!==this._workerId||this._handleMessage(i)}_handleMessage(i){switch(i.type){case 1:return this._handleReplyMessage(i);case 0:return this._handleRequestMessage(i);case 2:return this._handleSubscribeEventMessage(i);case 3:return this._handleEventMessage(i);case 4:return this._handleUnsubscribeEventMessage(i)}}_handleReplyMessage(i){if(!this._pendingReplies[i.seq]){console.warn("Got reply to unknown seq");return}let r=this._pendingReplies[i.seq];if(delete this._pendingReplies[i.seq],i.err){let a=i.err;i.err.$isError&&(a=new Error,a.name=i.err.name,a.message=i.err.message,a.stack=i.err.stack),r.reject(a);return}r.resolve(i.res)}_handleRequestMessage(i){let r=i.req;this._handler.handleMessage(i.method,i.args).then(h=>{this._send(new g(this._workerId,r,h,void 0))},h=>{h.detail instanceof Error&&(h.detail=(0,p.transformErrorForSerialization)(h.detail)),this._send(new g(this._workerId,r,void 0,(0,p.transformErrorForSerialization)(h)))})}_handleSubscribeEventMessage(i){const r=i.req,a=this._handler.handleEvent(i.eventName,i.arg)(h=>{this._send(new d(this._workerId,r,h))});this._pendingEvents.set(r,a)}_handleEventMessage(i){if(!this._pendingEmitters.has(i.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(i.req).fire(i.event)}_handleUnsubscribeEventMessage(i){if(!this._pendingEvents.has(i.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(i.req).dispose(),this._pendingEvents.delete(i.req)}_send(i){let r=[];if(i.type===0)for(let a=0;a<i.args.length;a++)i.args[a]instanceof ArrayBuffer&&r.push(i.args[a]);else i.type===1&&i.res instanceof ArrayBuffer&&r.push(i.res);this._handler.sendMessage(i,r)}}class C extends D.Disposable{constructor(i,r,a){super();let h=null;this._worker=this._register(i.create("vs/base/common/worker/simpleWorker",N=>{this._protocol.handleMessage(N)},N=>{h&&h(N)})),this._protocol=new v({sendMessage:(N,J)=>{this._worker.postMessage(N,J)},handleMessage:(N,J)=>{if(typeof a[N]!="function")return Promise.reject(new Error("Missing method "+N+" on main thread host."));try{return Promise.resolve(a[N].apply(a,J))}catch(oe){return Promise.reject(oe)}},handleEvent:(N,J)=>{if(f(N)){const oe=a[N].call(a,J);if(typeof oe!="function")throw new Error(`Missing dynamic event ${N} on main thread host.`);return oe}if(u(N)){const oe=a[N];if(typeof oe!="function")throw new Error(`Missing event ${N} on main thread host.`);return oe}throw new Error(`Malformed event name ${N}`)}}),this._protocol.setWorkerId(this._worker.getId());let I=null;typeof M.globals.require!="undefined"&&typeof M.globals.require.getConfig=="function"?I=M.globals.require.getConfig():typeof M.globals.requirejs!="undefined"&&(I=M.globals.requirejs.s.contexts._.config);const R=P.getAllMethodNames(a);this._onModuleLoaded=this._protocol.sendMessage(w,[this._worker.getId(),JSON.parse(JSON.stringify(I)),r,R]);const L=(N,J)=>this._request(N,J),W=(N,J)=>this._protocol.listen(N,J);this._lazyProxy=new Promise((N,J)=>{h=J,this._onModuleLoaded.then(oe=>{N(c(oe,L,W))},oe=>{J(oe),this._onError("Worker failed to load "+r,oe)})})}getProxyObject(){return this._lazyProxy}_request(i,r){return new Promise((a,h)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(i,r).then(a,h)},h)})}_onError(i,r){console.error(i),console.info(r)}}e.SimpleWorkerClient=C;function u(s){return s[0]==="o"&&s[1]==="n"&&E.isUpperAsciiLetter(s.charCodeAt(2))}function f(s){return/^onDynamic/.test(s)&&E.isUpperAsciiLetter(s.charCodeAt(9))}function c(s,i,r){const a=R=>function(){const L=Array.prototype.slice.call(arguments,0);return i(R,L)},h=R=>function(L){return r(R,L)};let I={};for(const R of s){if(f(R)){I[R]=h(R);continue}if(u(R)){I[R]=r(R,void 0);continue}I[R]=a(R)}return I}class o{constructor(i,r){this._requestHandlerFactory=r,this._requestHandler=null,this._protocol=new v({sendMessage:(a,h)=>{i(a,h)},handleMessage:(a,h)=>this._handleMessage(a,h),handleEvent:(a,h)=>this._handleEvent(a,h)})}onmessage(i){this._protocol.handleMessage(i)}_handleMessage(i,r){if(i===w)return this.initialize(r[0],r[1],r[2],r[3]);if(!this._requestHandler||typeof this._requestHandler[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._requestHandler[i].apply(this._requestHandler,r))}catch(a){return Promise.reject(a)}}_handleEvent(i,r){if(!this._requestHandler)throw new Error("Missing requestHandler");if(f(i)){const a=this._requestHandler[i].call(this._requestHandler,r);if(typeof a!="function")throw new Error(`Missing dynamic event ${i} on request handler.`);return a}if(u(i)){const a=this._requestHandler[i];if(typeof a!="function")throw new Error(`Missing event ${i} on request handler.`);return a}throw new Error(`Malformed event name ${i}`)}initialize(i,r,a,h){this._protocol.setWorkerId(i);const L=c(h,(W,N)=>this._protocol.sendMessage(W,N),(W,N)=>this._protocol.listen(W,N));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(L),Promise.resolve(P.getAllMethodNames(this._requestHandler))):(r&&(typeof r.baseUrl!="undefined"&&delete r.baseUrl,typeof r.paths!="undefined"&&typeof r.paths.vs!="undefined"&&delete r.paths.vs,typeof r.trustedTypesPolicy!==void 0&&delete r.trustedTypesPolicy,r.catchError=!0,M.globals.require.config(r)),new Promise((W,N)=>{(M.globals.require||j)([a],oe=>{if(this._requestHandler=oe.create(L),!this._requestHandler){N(new Error("No RequestHandler!"));return}W(P.getAllMethodNames(this._requestHandler))},N)}))}}e.SimpleWorkerServer=o;function l(s){return new o(s,null)}e.create=l}),define(ee[117],te([0,1,60,29,42]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function M(P,E){if(await new Promise((b,k)=>{const y=n.createReadStream(P),g=p.createHash("sha1");y.pipe(g);const t=(0,D.once)((d,m)=>{y.removeAllListeners(),g.removeAllListeners(),d?k(d):b(m)});y.once("error",t),y.once("end",t),g.once("error",t),g.once("data",d=>t(void 0,d.toString("hex")))})!==E)throw new Error("Hash mismatch")}e.checksum=M}),define(ee[118],te([0,1,252]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(M="utf8"){this.stringDecoder=new p.StringDecoder(M),this.remaining=null}write(M){const P=[],E=this.remaining?this.remaining+this.stringDecoder.write(M):this.stringDecoder.write(M);if(E.length<1)return P;let w=0,S,b=w;for(;b<E.length;)if(S=E.charCodeAt(b),S===13||S===10){if(P.push(E.substring(w,b)),b++,b<E.length){const k=S;S=E.charCodeAt(b),(k===13&&S===10||k===10&&S===13)&&b++}w=b}else b++;return this.remaining=w<E.length?E.substr(w):null,P}end(){return this.remaining}}e.LineDecoder=n}),define(ee[119],te([0,1,26]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(P){const E=P.replace(/\-/g,":").toLowerCase();return!n.has(E)}function M(){const P=(0,p.networkInterfaces)();for(let E in P){const w=P[E];if(w){for(const{mac:S}of w)if(D(S))return S}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=M}),define(ee[73],te([0,1,26,15,35,32,119]),function(j,e,p,n,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(b){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(b)}value(){if(this._value===void 0){let b=0,k=0;const y=(0,p.networkInterfaces)();for(let g in y){const t=y[g];if(t)for(const{mac:d,internal:m}of t)m||(k+=1,this._isVirtualMachineMacAddress(d.toUpperCase())&&(b+=1))}this._value=k>0?b/k:0}return this._value}};let E;async function w(){return E||(E=(async()=>await S()||M.generateUuid())()),E}e.getMachineId=w;async function S(){try{const b=await new Promise((y,g)=>{j(["crypto"],y,g)}),k=(0,P.getMac)();return b.createHash("sha256").update(k,"utf8").digest("hex")}catch(b){n.onUnexpectedError(b);return}}}),define(ee[24],te([0,1,29,26,120,8,28,72,9,3,16,7]),function(j,e,p,n,D,M,P,E,w,S,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function g(V,Z=y.UNLINK){if((0,P.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");return Z===y.UNLINK?d(V):t(V)}async function t(V){try{const Z=(0,P.randomPath)((0,n.tmpdir)());try{await p.promises.rename(V,Z)}catch{return d(V)}d(Z).catch(H=>{})}catch(Z){if(Z.code!=="ENOENT")throw Z}}async function d(V){return(0,D.promisify)(p.rm)(V,{recursive:!0,force:!0,maxRetries:3})}function m(V){if((0,P.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");p.rmSync(V,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=m;async function v(V,Z){return f(await(Z?C(V):(0,D.promisify)(p.readdir)(V)))}async function C(V){try{return await(0,D.promisify)(p.readdir)(V,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const Z=[],H=await v(V);for(const K of H){let G=!1,z=!1,B=!1;try{const Y=await e.Promises.lstat((0,w.join)(V,K));G=Y.isFile(),z=Y.isDirectory(),B=Y.isSymbolicLink()}catch(Y){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Y)}Z.push({name:K,isFile:()=>G,isDirectory:()=>z,isSymbolicLink:()=>B})}return Z}function u(V){return f(p.readdirSync(V))}e.readdirSync=u;function f(V){return V.map(Z=>typeof Z=="string"?S.isMacintosh?(0,E.normalizeNFC)(Z):Z:(Z.name=S.isMacintosh?(0,E.normalizeNFC)(Z.name):Z.name,Z))}async function c(V){const Z=await v(V),H=[];for(const K of Z)await l.existsDirectory((0,w.join)(V,K))&&H.push(K);return H}function o(V,Z=1e3){return new Promise(H=>{let K=!1;const G=setInterval(()=>{K||(K=!0,p.access(V,z=>{K=!1,z&&(clearInterval(G),H(void 0))}))},Z)})}e.whenDeleted=o;var l;(function(V){async function Z(G){let z;try{if(z=await e.Promises.lstat(G),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(S.isWindows&&B.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(Y){if(Y.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw Y}throw B}}V.stat=Z;async function H(G){try{const{stat:z,symbolicLink:B}=await V.stat(G);return z.isFile()&&B?.dangling!==!0}catch{}return!1}V.existsFile=H;async function K(G){try{const{stat:z,symbolicLink:B}=await V.stat(G);return z.isDirectory()&&B?.dangling!==!0}catch{}return!1}V.existsDirectory=K})(l=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new M.ResourceQueue;function i(V,Z,H){return s.queueFor(k.URI.file(V),b.extUriBiasedIgnorePathCase).queue(()=>{const K=I(H);return new Promise((G,z)=>a(V,Z,K,B=>B?z(B):G()))})}let r=!0;function a(V,Z,H,K){if(!r)return p.writeFile(V,Z,{mode:H.mode,flag:H.flag},K);p.open(V,H.flag,H.mode,(G,z)=>{if(G)return K(G);p.writeFile(z,Z,B=>{if(B)return p.close(z,()=>K(B));p.fdatasync(z,Y=>(Y&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Y),r=!1),p.close(z,q=>K(q))))})})}function h(V,Z,H){const K=I(H);if(!r)return p.writeFileSync(V,Z,{mode:K.mode,flag:K.flag});const G=p.openSync(V,K.flag,K.mode);try{p.writeFileSync(G,Z);try{p.fdatasyncSync(G)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),r=!1}}finally{p.closeSync(G)}}e.writeFileSync=h;function I(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function R(V,Z){if(V===Z)return;async function H(K){try{const G=await e.Promises.lstat(K);if(G.isDirectory()||G.isSymbolicLink())return;await e.Promises.utimes(K,G.atime,new Date)}catch{}}try{await e.Promises.rename(V,Z),await H(Z)}catch(K){if(V.toLowerCase()!==Z.toLowerCase()&&K.code==="EXDEV"||V.endsWith("."))await L(V,Z,{preserveSymlinks:!1}),await g(V,y.MOVE),await H(Z);else throw K}}async function L(V,Z,H){return N(V,Z,{root:{source:V,target:Z},options:H,handledSourcePaths:new Set})}const W=511;async function N(V,Z,H){if(H.handledSourcePaths.has(V))return;H.handledSourcePaths.add(V);const{stat:K,symbolicLink:G}=await l.stat(V);if(G){if(H.options.preserveSymlinks)try{return await re(V,Z,H)}catch(z){console.warn("[node.js fs] copy of symlink failed: ",z)}if(G.dangling)return}return K.isDirectory()?J(V,Z,K.mode&W,H):oe(V,Z,K.mode&W)}async function J(V,Z,H,K){await e.Promises.mkdir(Z,{recursive:!0,mode:H});const G=await v(V);for(const z of G)await N((0,w.join)(V,z),(0,w.join)(Z,z),K)}async function oe(V,Z,H){await e.Promises.copyFile(V,Z),await e.Promises.chmod(Z,H)}async function re(V,Z,H){let K=await e.Promises.readlink(V);(0,P.isEqualOrParent)(K,H.root.source,!S.isLinux)&&(K=(0,w.join)(H.root.target,K.substr(H.root.source.length+1))),await e.Promises.symlink(K,Z)}e.Promises=new class{get access(){return(0,D.promisify)(p.access)}get stat(){return(0,D.promisify)(p.stat)}get lstat(){return(0,D.promisify)(p.lstat)}get utimes(){return(0,D.promisify)(p.utimes)}get read(){return(V,Z,H,K,G)=>new Promise((z,B)=>{p.read(V,Z,H,K,G,(Y,q,F)=>Y?B(Y):z({bytesRead:q,buffer:F}))})}get readFile(){return(0,D.promisify)(p.readFile)}get write(){return(V,Z,H,K,G)=>new Promise((z,B)=>{p.write(V,Z,H,K,G,(Y,q,F)=>Y?B(Y):z({bytesWritten:q,buffer:F}))})}get appendFile(){return(0,D.promisify)(p.appendFile)}get fdatasync(){return(0,D.promisify)(p.fdatasync)}get truncate(){return(0,D.promisify)(p.truncate)}get rename(){return(0,D.promisify)(p.rename)}get copyFile(){return(0,D.promisify)(p.copyFile)}get open(){return(0,D.promisify)(p.open)}get close(){return(0,D.promisify)(p.close)}get symlink(){return(0,D.promisify)(p.symlink)}get readlink(){return(0,D.promisify)(p.readlink)}get chmod(){return(0,D.promisify)(p.chmod)}get mkdir(){return(0,D.promisify)(p.mkdir)}get unlink(){return(0,D.promisify)(p.unlink)}get rmdir(){return(0,D.promisify)(p.rmdir)}get realpath(){return(0,D.promisify)(p.realpath)}async exists(V){try{return await e.Promises.access(V),!0}catch{return!1}}get readdir(){return v}get readDirsInDir(){return c}get writeFile(){return i}get rm(){return g}get move(){return R}get copy(){return L}}}),define(ee[85],te([0,1,29,9,3,25,24]),function(j,e,p,n,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function E(y){if(D.isLinux)return y;const g=(0,n.dirname)(y);if(y===g)return y;const t=((0,n.basename)(y)||y).toLowerCase();try{const m=(0,P.readdirSync)(g).filter(v=>v.toLowerCase()===t);if(m.length===1){const v=E(g);if(v)return(0,n.join)(v,m[0])}else if(m.length>1){const v=m.indexOf(t);if(v>=0){const C=E(g);if(C)return(0,n.join)(C,m[v])}}}catch{}return null}e.realcaseSync=E;async function w(y){if(D.isLinux)return y;const g=(0,n.dirname)(y);if(y===g)return y;const t=((0,n.basename)(y)||y).toLowerCase();try{const m=(await P.Promises.readdir(g)).filter(v=>v.toLowerCase()===t);if(m.length===1){const v=await w(g);if(v)return(0,n.join)(v,m[0])}else if(m.length>1){const v=m.indexOf(t);if(v>=0){const C=await w(g);if(C)return(0,n.join)(C,m[v])}}}catch{}return null}e.realcase=w;async function S(y){try{return await P.Promises.realpath(y)}catch{const t=k(y);return await P.Promises.access(t,p.constants.R_OK),t}}e.realpath=S;function b(y){try{return p.realpathSync(y)}catch{const t=k(y);return p.accessSync(t,p.constants.R_OK),t}}e.realpathSync=b;function k(y){return(0,M.rtrim)((0,n.normalize)(y),n.sep)}}),define(ee[121],te([0,1,61]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(E,w,S,b=1){let k=!1;return new Promise(y=>{const g=setTimeout(()=>{if(!k)return k=!0,y(0)},S);D(E,w,b,t=>{if(!k)return k=!0,clearTimeout(g),y(t)})})}e.findFreePort=n;function D(E,w,S,b){if(w===0)return b(0);const k=new p.Socket;k.once("connect",()=>(P(k),D(E+S,w-1,S,b))),k.once("data",()=>{}),k.once("error",y=>(P(k),y.code!=="ECONNREFUSED"?D(E+S,w-1,S,b):b(E))),k.connect(E,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(E,w,S){let b=!1,k,y=1;const g=p.createServer({pauseOnConnect:!0});function t(d,m){b||(b=!0,g.removeAllListeners(),g.close(),k&&clearTimeout(k),m(d))}return new Promise(d=>{k=setTimeout(()=>{t(0,d)},S),g.on("listening",()=>{t(E,d)}),g.on("error",m=>{m&&(m.code==="EADDRINUSE"||m.code==="EACCES")&&y<w?(E++,y++,g.listen(E,"127.0.0.1")):t(0,d)}),g.on("close",()=>{t(0,d)}),g.listen(E,"127.0.0.1")})}e.findFreePortFaster=M;function P(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(w){console.error(w)}}}),define(ee[122],te([0,1,26,9,24]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const M=/^\d+$/,P=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var w;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(w||(w={}));let S;switch(process.arch){case"ia32":case"x32":S=1;break;case"arm":case"arm64":S=2;break;default:S=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class k{constructor(c,o,l){this.exePath=c,this.displayName=o,this.knownToExist=l}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function y({useAlternateBitness:f=!1}={}){return f?S===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:f=!1,findPreview:c=!1}={}){const o=y({useAlternateBitness:f});if(!o)return null;const l=n.join(o,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(l))return null;let s=-1,i=null;for(const h of await D.Promises.readdir(l)){let I=-1;if(c){const L=h.indexOf("-");if(L<0)continue;const W=h.substring(0,L);if(!M.test(W)||h.substring(L+1)!=="preview")continue;I=parseInt(W,10)}else{if(!M.test(h))continue;I=parseInt(h,10)}if(I<=s)continue;const R=n.join(l,h,"pwsh.exe");!await D.SymlinkSupport.existsFile(R)||(i=R,s=I)}if(!i)return null;const r=o.includes("x86")?" (x86)":"",a=c?" Preview":"";return new k(i,`PowerShell${a}${r}`,!0)}async function t({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const c=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:o,pwshMsixName:l}=f?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:P,pwshMsixName:"PowerShell (Store)"};for(const s of await D.Promises.readdir(c))if(o.test(s)){const i=n.join(c,s,"pwsh.exe");return new k(i,l)}return null}function d(){const f=n.join(p.homedir(),".dotnet","tools","pwsh.exe");return new k(f,".NET Core PowerShell Global Tool")}function m(){const f=n.join(process.env.windir,S===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k(f,"Windows PowerShell",!0)}async function*v(){let f=await g();f&&(yield f),f=await g({useAlternateBitness:!0}),f&&(yield f),f=await t(),f&&(yield f),f=d(),f&&(yield f),f=await g({findPreview:!0}),f&&(yield f),f=await t({findPreview:!0}),f&&(yield f),f=await g({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=m(),f&&(yield f)}async function*C(){for await(const f of v())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=C;async function u(){for await(const f of C())return f;return null}e.getFirstAvailablePowerShellInstallation=u}),define(ee[86],te([0,1,44,10]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(P){return new Promise((E,w)=>{let S;const b=new Map;function k(g,t,d,m,v){const C=b.get(t);if(g===P||C){const u={name:y(d),cmd:d,pid:g,ppid:t,load:m,mem:v};b.set(g,u),g===P&&(S=u),C&&(C.children||(C.children=[]),C.children.push(u),C.children.length>1&&(C.children=C.children.sort((f,c)=>f.pid-c.pid)))}}function y(g){const t=/--vscode-window-kind=shared-process/,d=/--vscode-window-kind=issue-reporter/,m=/--vscode-window-kind=process-explorer/,v=/--utility-sub-type=network/,C=/--crashes-directory/,u=/\\pipe\\winpty-control/,f=/conhost\.exe/,c=/--type=([a-zA-Z-]+)/;if(C.exec(g))return"electron-crash-reporter";if(u.exec(g))return"winpty-process";if(f.exec(g))return"console-window-host (Windows internal process)";let o=c.exec(g);if(o&&o.length===2)return o[1]==="renderer"?t.exec(g)?"shared-process":d.exec(g)?"issue-reporter":m.exec(g)?"process-explorer":"window":o[1]==="utility"&&v.exec(g)?"utility-network-service":o[1];const l=/[a-zA-Z-]+\.js/g;let s="";do o=l.exec(g),o&&(s+=o+" ");while(o);return s&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron_node ${s}`:g}if(process.platform==="win32"){const g=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,d)=>{j(["windows-process-tree"],t,d)}).then(t=>{t.getProcessList(P,d=>{t.getProcessCpuUsage(d,m=>{const v=new Map;m.forEach(C=>{const u=g(C.commandLine||"");v.set(C.pid,{name:y(u),cmd:u,pid:C.pid,ppid:C.ppid,load:C.cpu||0,mem:C.memory||0})}),S=v.get(P),S?(v.forEach(C=>{const u=v.get(C.ppid);u&&(u.children||(u.children=[]),u.children.push(C))}),v.forEach(C=>{C.children&&(C.children=C.children.sort((u,f)=>u.pid-f.pid))}),E(S)):w(new Error(`Root process ${P} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let g=function(){let t=[S];const d=[];for(;t.length;){const v=t.shift();v&&(d.push(v.pid),v.children&&(t=t.concat(v.children)))}let m=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",j).fsPath);m+=" "+d.join(" "),(0,p.exec)(m,{},(v,C,u)=>{if(v||u)w(v||new Error(u.toString()));else{const f=C.toString().split(`
`);for(let c=0;c<d.length;c++){const o=b.get(d[c]);o.load=parseFloat(f[c])}if(!S){w(new Error(`Root process ${P} not found`));return}E(S)}})};(0,p.exec)("which ps",{},(t,d,m)=>{if(t||m)if(process.platform!=="linux")w(t||new Error(m.toString()));else{const v=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",j).fsPath);(0,p.exec)(v,{},(C,u,f)=>{C||f?w(C||new Error(f.toString())):(M(u,k),g())})}else{const v=d.toString().trim(),C="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,p.exec)(`${v} ${C}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,f,c)=>{u||c&&!c.includes("screen size is bogus")?w(u||new Error(c.toString())):(M(f,k),process.platform==="linux"?g():S?E(S):w(new Error(`Root process ${P} not found`)))})}})}})}e.listProcesses=D;function M(P,E){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,S=P.toString().split(`
`);for(const b of S){const k=w.exec(b.trim());k&&k.length===6&&E(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}}),define(ee[123],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[124],te([0,1,14,13,123]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){p.ipcMain.on(D.CONTEXT_MENU_CHANNEL,(E,w,S,b,k)=>{const y=P(E,b,S);y.popup({window:(0,n.withNullAsUndefined)(p.BrowserWindow.fromWebContents(E.sender)),x:k?k.x:void 0,y:k?k.y:void 0,positioningItem:k?k.positioningItem:void 0,callback:()=>{y&&E.sender.send(D.CONTEXT_MENU_CLOSE_CHANNEL,w)}})})}e.registerContextMenuListener=M;function P(E,w,S){const b=new p.Menu;return S.forEach(k=>{let y;k.type==="separator"?y=new p.MenuItem({type:k.type}):Array.isArray(k.submenu)?y=new p.MenuItem({submenu:P(E,w,k.submenu),label:k.label}):y=new p.MenuItem({label:k.label,type:k.type,accelerator:k.accelerator,checked:k.checked,enabled:k.enabled,visible:k.visible,click:(g,t,d)=>E.sender.send(w,k.id,d)}),b.append(y)}),b}});var de=this&&this.__decorate||function(j,e,p,n){var D=arguments.length,M=D<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,p):n,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(j,e,p,n);else for(var E=j.length-1;E>=0;E--)(P=j[E])&&(M=(D<3?P(M):D>3?P(e,p,M):P(e,p))||M);return D>3&&M&&Object.defineProperty(e,p,M),M};define(ee[37],te([0,1,27,8,17,21,46,15,4,2,113,25,13]),function(j,e,p,n,D,M,P,E,w,S,b,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var g;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(g=e.RequestType||(e.RequestType={}));function t(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(d=e.ResponseType||(e.ResponseType={}));function m(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(v||(v={}));class C{constructor(B){this.buffer=B,this.pos=0}read(B){const Y=this.buffer.slice(this.pos,this.pos+B);return this.pos+=Y.byteLength,Y}}class u{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(B){this.buffers.push(B)}}var f;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(f||(f={}));function c(z){const B=D.VSBuffer.alloc(4);return B.writeUInt32BE(z,0),B}function o(z){return z.read(4).readUInt32BE(0)}function l(z){const B=D.VSBuffer.alloc(1);return B.writeUInt8(z,0),B}const s={Undefined:l(f.Undefined),String:l(f.String),Buffer:l(f.Buffer),VSBuffer:l(f.VSBuffer),Array:l(f.Array),Object:l(f.Object)},i=typeof Buffer!="undefined";function r(z,B){if(typeof B=="undefined")z.write(s.Undefined);else if(typeof B=="string"){const Y=D.VSBuffer.fromString(B);z.write(s.String),z.write(c(Y.byteLength)),z.write(Y)}else if(i&&Buffer.isBuffer(B)){const Y=D.VSBuffer.wrap(B);z.write(s.Buffer),z.write(c(Y.byteLength)),z.write(Y)}else if(B instanceof D.VSBuffer)z.write(s.VSBuffer),z.write(c(B.byteLength)),z.write(B);else if(Array.isArray(B)){z.write(s.Array),z.write(c(B.length));for(const Y of B)r(z,Y)}else{const Y=D.VSBuffer.fromString(JSON.stringify(B));z.write(s.Object),z.write(c(Y.byteLength)),z.write(Y)}}function a(z){switch(z.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return z.read(o(z)).toString();case f.Buffer:return z.read(o(z)).buffer;case f.VSBuffer:return z.read(o(z));case f.Array:{const Y=o(z),q=[];for(let F=0;F<Y;F++)q.push(a(z));return q}case f.Object:return JSON.parse(z.read(o(z)).toString())}}class h{constructor(B,Y,q=null,F=1e3){this.protocol=B,this.ctx=Y,this.logger=q,this.timeoutDelay=F,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage($=>this.onRawMessage($)),this.sendResponse({type:200})}registerChannel(B,Y){this.channels.set(B,Y),setTimeout(()=>this.flushPendingRequests(B),0)}sendResponse(B){switch(B.type){case 200:{const Y=this.send([B.type]);this.logger&&this.logger.logOutgoing(Y,0,1,m(B.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([B.type,B.id],B.data);this.logger&&this.logger.logOutgoing(Y,B.id,1,m(B.type),B.data);return}}}send(B,Y=void 0){const q=new u;return r(q,B),r(q,Y),this.sendBuffer(q.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onRawMessage(B){const Y=new C(B),q=a(Y),F=a(Y),$=q[0];switch($){case 100:return this.logger&&this.logger.logIncoming(B.byteLength,q[1],1,`${t($)}: ${q[2]}.${q[3]}`,F),this.onPromise({type:$,id:q[1],channelName:q[2],name:q[3],arg:F});case 102:return this.logger&&this.logger.logIncoming(B.byteLength,q[1],1,`${t($)}: ${q[2]}.${q[3]}`,F),this.onEventListen({type:$,id:q[1],channelName:q[2],name:q[3],arg:F});case 101:return this.logger&&this.logger.logIncoming(B.byteLength,q[1],1,`${t($)}`),this.disposeActiveRequest({type:$,id:q[1]});case 103:return this.logger&&this.logger.logIncoming(B.byteLength,q[1],1,`${t($)}`),this.disposeActiveRequest({type:$,id:q[1]})}}onPromise(B){const Y=this.channels.get(B.channelName);if(!Y){this.collectPendingRequest(B);return}const q=new M.CancellationTokenSource;let F;try{F=Y.call(this.ctx,B.name,B.arg,q.token)}catch(T){F=Promise.reject(T)}const $=B.id;F.then(T=>{this.sendResponse({id:$,data:T,type:201}),this.activeRequests.delete(B.id)},T=>{T instanceof Error?this.sendResponse({id:$,data:{message:T.message,name:T.name,stack:T.stack?T.stack.split?T.stack.split(`
`):T.stack:void 0},type:202}):this.sendResponse({id:$,data:T,type:203}),this.activeRequests.delete(B.id)});const A=(0,S.toDisposable)(()=>q.cancel());this.activeRequests.set(B.id,A)}onEventListen(B){const Y=this.channels.get(B.channelName);if(!Y){this.collectPendingRequest(B);return}const q=B.id,$=Y.listen(this.ctx,B.name,B.arg)(A=>this.sendResponse({id:q,data:A,type:204}));this.activeRequests.set(B.id,$)}disposeActiveRequest(B){const Y=this.activeRequests.get(B.id);Y&&(Y.dispose(),this.activeRequests.delete(B.id))}collectPendingRequest(B){let Y=this.pendingRequests.get(B.channelName);Y||(Y=[],this.pendingRequests.set(B.channelName,Y));const q=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.sendResponse({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:B,timeoutTimer:q})}flushPendingRequests(B){const Y=this.pendingRequests.get(B);if(Y){for(const q of Y)switch(clearTimeout(q.timeoutTimer),q.request.type){case 100:this.onPromise(q.request);break;case 102:this.onEventListen(q.request);break}this.pendingRequests.delete(B)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(B=>B.dispose()),this.activeRequests.clear()}}e.ChannelServer=h;var I;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(I=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(B,Y=null){this.protocol=B,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new w.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(q=>this.onBuffer(q)),this.logger=Y}getChannel(B){const Y=this;return{call(q,F,$){return Y.isDisposed?Promise.reject(E.canceled()):Y.requestPromise(B,q,F,$)},listen(q,F){return Y.isDisposed?Promise.reject(E.canceled()):Y.requestEvent(B,q,F)}}}requestPromise(B,Y,q,F=M.CancellationToken.None){const $=this.lastRequestId++,T={id:$,type:100,channelName:B,name:Y,arg:q};if(F.isCancellationRequested)return Promise.reject(E.canceled());let U;return new Promise((_,Q)=>{if(F.isCancellationRequested)return Q(E.canceled());const ie=()=>{const le=he=>{switch(he.type){case 201:this.handlers.delete($),_(he.data);break;case 202:{this.handlers.delete($);const me=new Error(he.data.message);me.stack=he.data.stack,me.name=he.data.name,Q(me);break}case 203:this.handlers.delete($),Q(he.data);break}};this.handlers.set($,le),this.sendRequest(T)};let se=null;this.state===v.Idle?ie():(se=(0,n.createCancelablePromise)(le=>this.whenInitialized()),se.then(()=>{se=null,ie()}));const x=()=>{se?(se.cancel(),se=null):this.sendRequest({id:$,type:101}),Q(E.canceled())},ce=F.onCancellationRequested(x);U=(0,S.combinedDisposable)((0,S.toDisposable)(x),ce),this.activeRequests.add(U)}).finally(()=>{this.activeRequests.delete(U)})}requestEvent(B,Y,q){const F=this.lastRequestId++,A={id:F,type:102,channelName:B,name:Y,arg:q};let T=null;const U=new w.Emitter({onFirstListenerAdd:()=>{T=(0,n.createCancelablePromise)(_=>this.whenInitialized()),T.then(()=>{T=null,this.activeRequests.add(U),this.sendRequest(A)})},onLastListenerRemove:()=>{T?(T.cancel(),T=null):(this.activeRequests.delete(U),this.sendRequest({id:F,type:103}))}}),O=_=>U.fire(_.data);return this.handlers.set(F,O),U.event}sendRequest(B){switch(B.type){case 100:case 102:{const Y=this.send([B.type,B.id,B.channelName,B.name],B.arg);this.logger&&this.logger.logOutgoing(Y,B.id,0,`${t(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const Y=this.send([B.type,B.id]);this.logger&&this.logger.logOutgoing(Y,B.id,0,t(B.type));return}}}send(B,Y=void 0){const q=new u;return r(q,B),r(q,Y),this.sendBuffer(q.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onBuffer(B){const Y=new C(B),q=a(Y),F=a(Y),$=q[0];switch($){case 200:return this.logger&&this.logger.logIncoming(B.byteLength,0,0,m($)),this.onResponse({type:q[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(B.byteLength,q[1],0,m($),F),this.onResponse({type:q[0],id:q[1],data:F})}}onResponse(B){if(B.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const Y=this.handlers.get(B.id);Y&&Y(B)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(B=>B.dispose()),this.activeRequests.clear()}}de([P.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class L{constructor(B){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new w.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new w.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,B(({protocol:Y,onDidClientDisconnect:q})=>{w.Event.once(Y.onMessage)($=>{const A=new C($),T=a(A),U=new h(Y,T),O=new R(Y);this.channels.forEach((Q,ie)=>U.registerChannel(ie,Q));const _={channelServer:U,channelClient:O,ctx:T};this._connections.add(_),this._onDidAddConnection.fire(_),q(()=>{U.dispose(),O.dispose(),this._connections.delete(_),this._onDidRemoveConnection.fire(_)})})})}get connections(){const B=[];return this._connections.forEach(Y=>B.push(Y)),B}getChannel(B,Y){const q=this;return{call(F,$,A){let T;if((0,y.isFunction)(Y)){let O=(0,p.getRandomElement)(q.connections.filter(Y));T=O?Promise.resolve(O):w.Event.toPromise(w.Event.filter(q.onDidAddConnection,Y))}else T=Y.routeCall(q,F,$);const U=T.then(O=>O.channelClient.getChannel(B));return N(U).call(F,$,A)},listen(F,$){if((0,y.isFunction)(Y))return q.getMulticastEvent(B,Y,F,$);const A=Y.routeEvent(q,F,$).then(T=>T.channelClient.getChannel(B));return N(A).listen(F,$)}}}getMulticastEvent(B,Y,q,F){const $=this;let A=new S.DisposableStore;const T=new w.Emitter({onFirstListenerAdd:()=>{A=new S.DisposableStore;const U=new w.EventMultiplexer,O=new Map,_=ie=>{const x=ie.channelClient.getChannel(B).listen(q,F),ce=U.add(x);O.set(ie,ce)},Q=ie=>{const se=O.get(ie);!se||(se.dispose(),O.delete(ie))};$.connections.filter(Y).forEach(_),w.Event.filter($.onDidAddConnection,Y)(_,void 0,A),$.onDidRemoveConnection(Q,void 0,A),U.event(T.fire,T,A),A.add(U)},onLastListenerRemove:()=>{A.dispose()}});return T.event}registerChannel(B,Y){this.channels.set(B,Y),this._connections.forEach(q=>{q.channelServer.registerChannel(B,Y)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=L;class W{constructor(B,Y,q=null){const F=new u;r(F,Y),B.send(F.buffer),this.channelClient=new R(B,q),this.channelServer=new h(B,Y,q)}getChannel(B){return this.channelClient.getChannel(B)}registerChannel(B,Y){this.channelServer.registerChannel(B,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=W;function N(z){return{call(B,Y,q){return z.then(F=>F.call(B,Y,q))},listen(B,Y){const q=new w.Relay;return z.then(F=>q.input=F.listen(B,Y)),q.event}}}e.getDelayedChannel=N;function J(z){let B=!1;return{call(Y,q,F){return B?z.call(Y,q,F):(0,n.timeout)(0).then(()=>B=!0).then(()=>z.call(Y,q,F))},listen(Y,q){if(B)return z.listen(Y,q);const F=new w.Relay;return(0,n.timeout)(0).then(()=>B=!0).then(()=>F.input=z.listen(Y,q)),F.event}}}e.getNextTickChannel=J;class oe{constructor(B){this.fn=B}routeCall(B){return this.route(B)}routeEvent(B){return this.route(B)}async route(B){for(const Y of B.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await w.Event.toPromise(B.onDidAddConnection),await this.route(B)}}e.StaticRouter=oe;var re;(function(z){function B($,A){const T=$,U=A&&A.disableMarshalling,O=new Map;for(const _ in T)q(_)&&O.set(_,w.Event.buffer(T[_],!0));return new class{listen(_,Q,ie){const se=O.get(Q);if(se)return se;if(F(Q)){const x=T[Q];if(typeof x=="function")return x.call(T,ie)}throw new Error(`Event not found: ${Q}`)}call(_,Q,ie){const se=T[Q];if(typeof se=="function"){if(!U&&Array.isArray(ie))for(let x=0;x<ie.length;x++)ie[x]=(0,b.revive)(ie[x]);return se.apply(T,ie)}throw new Error(`Method not found: ${Q}`)}}}z.fromService=B;function Y($,A){const T=A&&A.disableMarshalling;return new Proxy({},{get(U,O){if(typeof O=="string")return A?.properties?.has(O)?A.properties.get(O):F(O)?function(_){return $.listen(O,_)}:q(O)?$.listen(O):async function(..._){let Q;A&&!(0,y.isUndefinedOrNull)(A.context)?Q=[A.context,..._]:Q=_;const ie=await $.call(O,Q);return T?ie:(0,b.revive)(ie)};throw new Error(`Property not found: ${String(O)}`)}})}z.toService=Y;function q($){return $[0]==="o"&&$[1]==="n"&&k.isUpperAsciiLetter($.charCodeAt(2))}function F($){return/^onDynamic/.test($)&&k.isUpperAsciiLetter($.charCodeAt(9))}})(re=e.ProxyChannel||(e.ProxyChannel={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Z(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){let B=z.toString();if(B!=="[object Object]")return B}return z}function H(z){return Array.isArray(z)?z.map(Z):Z(z)}function K(z,B,Y,q,F,$,A){A=H(A);const T=V[F],U=T[q%T.length];let O=[`%c[${z}]%c[${String(B).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(q).padStart(5," ")} - ${$}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test($)?(O=O.concat(A),O.push(")")):O.push(A),console.log.apply(console,O)}e.logWithColors=K;class G{constructor(B,Y){this._outgoingPrefix=B,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(B,Y,q,F,$){this._totalOutgoing+=B,K(this._outgoingPrefix,this._totalOutgoing,B,Y,q,F,$)}logIncoming(B,Y,q,F,$){this._totalIncoming+=B,K(this._incomingPrefix,this._totalIncoming,B,Y,q,F,$)}}e.IPCLogger=G}),define(ee[125],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class p{constructor(D,M){this.sender=D,this.onMessage=M}send(D){try{this.sender.send("vscode:message",D.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=p}),define(ee[126],te([0,1,17,4,37]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class M{constructor(w){this.port=w,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",S=>p.VSBuffer.wrap(S.data)),w.start()}send(w){this.port.postMessage(w.buffer)}disconnect(){this.port.close()}}e.Protocol=M;class P extends D.IPCClient{constructor(w,S){const b=new M(w);super(b,S);this.protocol=b}dispose(){this.protocol.disconnect()}}e.Client=P}),define(ee[87],te([0,1,17,4,2,37]),function(j,e,p,n,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var E;(function(i){i.enableDiagnostics=!1,i.records=[];const r=new WeakMap;let a=0;function h(R,L){if(!r.has(R)){const W=String(++a);r.set(R,W)}return r.get(R)}function I(R,L,W,N){if(!i.enableDiagnostics)return;const J=h(R,L);if(N instanceof p.VSBuffer||N instanceof Uint8Array||N instanceof ArrayBuffer||ArrayBuffer.isView(N)){const oe=p.VSBuffer.alloc(N.byteLength);oe.set(N),i.records.push({timestamp:Date.now(),id:J,label:L,type:W,buff:oe})}else i.records.push({timestamp:Date.now(),id:J,label:L,type:W,data:N})}i.traceSocketEvent=I})(E=e.SocketDiagnostics||(e.SocketDiagnostics={}));var w;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let S=null;function b(){return S||(S=p.VSBuffer.alloc(0)),S}class k{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,a){if(r===0)return b();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const L=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=r),L}if(this._chunks[0].byteLength>r){const L=this._chunks[0].slice(0,r);return a&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),L}let h=p.VSBuffer.alloc(r),I=0,R=0;for(;r>0;){const L=this._chunks[R];if(L.byteLength>r){const W=L.slice(0,r);h.set(W,I),I+=r,a&&(this._chunks[R]=L.slice(r),this._totalLength-=r),r-=r}else h.set(L,I),I+=L.byteLength,a?(this._chunks.shift(),this._totalLength-=L.byteLength):R++,r-=L.byteLength}return h}}e.ChunkStream=k;var y;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(y||(y={}));function g(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var t;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(t=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(r,a,h,I){this.type=r,this.id=a,this.ack=h,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends D.Disposable{constructor(r){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:g(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const h=this._state.messageType,I=this._state.id,R=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",a),this._onMessage.fire(new d(h,I,R,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class v{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=p.VSBuffer.alloc(13);a.writeUInt8(r.type,0),a.writeUInt32BE(r.id,1),a.writeUInt32BE(r.ack,5),a.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:g(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(a,r.data)}_bufferAdd(r,a){const h=this._totalLength===0;return this._data.push(r,a),this._totalLength+=r.byteLength+a.byteLength,h}_bufferTake(){const r=p.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,a){this._bufferAdd(r,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class C extends D.Disposable{constructor(r){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new v(this._socket)),this._socketReader=this._register(new m(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new d(1,0,0,r))}}e.Protocol=C;class u extends M.IPCClient{constructor(r,a,h=null){super(r,a,h);this.protocol=r}static fromSocket(r,a){return new u(new C(r),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=u;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class c{constructor(r){this.data=r,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],a=0,h=this._first;for(;h;)r[a++]=h.data,h=h.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const a=new c(r);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class l{constructor(){this.lastRuns=[];const r=Date.now();for(let a=0;a<l._HISTORY_LENGTH;a++)this.lastRuns[a]=r-1e3*a;setInterval(()=>{for(let a=l._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return l._INSTANCE||(l._INSTANCE=new l),l._INSTANCE}load(){const r=Date.now(),a=(1+l._HISTORY_LENGTH)*1e3;let h=0;for(let I=0;I<l._HISTORY_LENGTH;I++)r-this.lastRuns[I]<=a&&h++;return 1-h/l._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}l._HISTORY_LENGTH=10,l._INSTANCE=null;class s{constructor(r,a=null,h=l.getInstance()){this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=h,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(I=>this._receiveMessage(I))),this._socketDisposables.push(this._socket.onClose(I=>this._onSocketClose.fire(I))),a&&this._socketReader.acceptChunk(a)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new d(5,0,0,b());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new d(7,0,0,b());this._socketWriter.write(r)}sendResume(){const r=new d(8,0,0,b());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,a){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new d(3,0,this._incomingAckId,b());this._socketWriter.write(r);const a=this._outgoingUnackMsg.toArray();for(let h=0,I=a.length;h<I;h++)this._socketWriter.write(a[h]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new d(6,0,0,b())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const a=this._outgoingUnackMsg.toArray();for(let h=0,I=a.length;h<I;h++)this._socketWriter.write(a[h]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const h=new d(1,a,this._incomingAckId,r);this._outgoingUnackMsg.push(h),this._isReconnecting||(this._socketWriter.write(h),this._recvAckCheck())}sendControl(r){const a=new d(2,0,0,r);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),a=Date.now()-r.writtenTime,h=Date.now()-this._socketReader.lastReadTime,I=Date.now()-this._lastSocketTimeoutTime;if(a>=2e4&&h>=2e4&&I>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const R=Math.max(2e4-a,2e4-h,2e4-I,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},R)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new d(3,0,this._incomingAckId,b());this._socketWriter.write(r)}}e.PersistentProtocol=s}),define(ee[127],te([0,1,14,17,4,2,37,125]),function(j,e,p,n,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function w(b,k){const y=D.Event.fromNodeEventEmitter(p.ipcMain,k,(t,d)=>({event:t,message:d})),g=D.Event.filter(y,({event:t})=>t.sender.id===b);return D.Event.map(g,({message:t})=>t&&n.VSBuffer.wrap(t))}class S extends P.IPCServer{constructor(){super(S.getOnDidClientConnect())}static getOnDidClientConnect(){const k=D.Event.fromNodeEventEmitter(p.ipcMain,"vscode:hello",({sender:y})=>y);return D.Event.map(k,y=>{const g=y.id,t=S.Clients.get(g);t&&t.dispose();const d=new D.Emitter;S.Clients.set(g,(0,M.toDisposable)(()=>d.fire()));const m=w(g,"vscode:message"),v=D.Event.any(D.Event.signal(w(g,"vscode:disconnect")),d.event);return{protocol:new E.Protocol(y,m),onDidClientDisconnect:v}})}}e.Server=S,S.Clients=new Map}),define(ee[88],te([0,1,14,4,32,126]),function(j,e,p,n,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class P extends M.Client{constructor(S,b){super({addEventListener:(k,y)=>S.addListener(k,y),removeEventListener:(k,y)=>S.removeListener(k,y),postMessage:k=>S.postMessage(k),start:()=>S.start(),close:()=>S.close()},b)}}e.Client=P;async function E(w){if(w.isDestroyed()||w.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const S=(0,D.generateUuid)();w.webContents.send("vscode:createMessageChannel",S);const b=n.Event.fromNodeEventEmitter(p.ipcMain,"vscode:createMessageChannelResult",(y,g)=>({nonce:g,port:y.ports[0]})),{port:k}=await n.Event.toPromise(n.Event.once(n.Event.filter(b,y=>y.nonce===S)));return k}e.connect=E}),define(ee[89],te([0,1,8,4,2,13]),function(j,e,p,n,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var P;(function(k){k[k.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(P=e.StorageHint||(e.StorageHint={}));function E(k){const y=k;return y?.changed instanceof Map||y?.deleted instanceof Set}e.isStorageItemsChangeEvent=E;var w;(function(k){k[k.None=0]="None",k[k.Initialized=1]="Initialized",k[k.Closed=2]="Closed"})(w||(w={}));class S extends D.Disposable{constructor(y,g=Object.create(null)){super();this.database=y,this.options=g,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=w.None,this.cache=new Map,this.flushDelayer=new p.ThrottledDelayer(S.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(y=>this.onDidChangeItemsExternal(y)))}onDidChangeItemsExternal(y){y.changed?.forEach((g,t)=>this.accept(t,g)),y.deleted?.forEach(g=>this.accept(g,void 0))}accept(y,g){if(this.state===w.Closed)return;let t=!1;(0,M.isUndefinedOrNull)(g)?t=this.cache.delete(y):this.cache.get(y)!==g&&(this.cache.set(y,g),t=!0),t&&this._onDidChangeStorage.fire(y)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===w.None&&(this.state=w.Initialized,this.options.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(y,g){const t=this.cache.get(y);return(0,M.isUndefinedOrNull)(t)?g:t}getBoolean(y,g){const t=this.get(y);return(0,M.isUndefinedOrNull)(t)?g:t==="true"}getNumber(y,g){const t=this.get(y);return(0,M.isUndefinedOrNull)(t)?g:parseInt(t,10)}async set(y,g){if(this.state===w.Closed)return;if((0,M.isUndefinedOrNull)(g))return this.delete(y);const t=String(g);if(this.cache.get(y)!==t)return this.cache.set(y,t),this.pendingInserts.set(y,t),this.pendingDeletes.delete(y),this._onDidChangeStorage.fire(y),this.doFlush()}async delete(y){if(!(this.state===w.Closed||!this.cache.delete(y)))return this.pendingDeletes.has(y)||this.pendingDeletes.add(y),this.pendingInserts.delete(y),this._onDidChangeStorage.fire(y),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=w.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const y={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(y).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(y){if(!!this.hasPending)return this.doFlush(y)}async doFlush(y){return this.flushDelayer.trigger(()=>this.flushPending(),y)}async whenFlushed(){if(!!this.hasPending)return new Promise(y=>this.whenFlushedCallbacks.push(y))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=S,S.DEFAULT_FLUSH_DELAY=100;class b{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(y){y.insert&&y.insert.forEach((g,t)=>this.items.set(t,g)),y.delete&&y.delete.forEach(g=>this.items.delete(g))}async close(){}}e.InMemoryStorageDatabase=b}),define(ee[128],te([0,1,8,4,35,9,24]),function(j,e,p,n,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class E{constructor(b,k=Object.create(null)){this.path=b,this.options=k,this.name=(0,M.basename)(this.path),this.logger=new w(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return n.Event.None}async getItems(){const b=await this.whenConnected,k=new Map;return(await this.all(b,"SELECT * FROM ItemTable")).forEach(g=>k.set(g.key,g.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${k.size} rows`),k}async updateItems(b){const k=await this.whenConnected;return this.doUpdateItems(k,b)}doUpdateItems(b,k){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${k.insert?(0,D.mapToString)(k.insert):"0"}), delete(${k.delete?(0,D.setToString)(k.delete):"0"})`),this.transaction(b,()=>{const y=k.insert,g=k.delete;if(y&&y.size>0){const t=[];t.push([]);let d=0;y.forEach((m,v)=>{let C=t[d];C.length>E.MAX_HOST_PARAMETERS&&(d++,C=[],t.push(C)),C.push(v,m)}),t.forEach(m=>{this.prepare(b,`INSERT INTO ItemTable VALUES ${new Array(m.length/2).fill("(?,?)").join(",")}`,v=>v.run(m),()=>{const v=[];let C=0;return y.forEach((u,f)=>{v.push(f),C+=u.length}),`Keys: ${v.join(", ")} Length: ${C}`})})}if(g&&g.size){const t=[];t.push([]);let d=0;g.forEach(m=>{let v=t[d];v.length>E.MAX_HOST_PARAMETERS&&(d++,v=[],t.push(v)),v.push(m)}),t.forEach(m=>{this.prepare(b,`DELETE FROM ItemTable WHERE key IN (${new Array(m.length).fill("?").join(",")})`,v=>v.run(m),()=>{const v=[];return g.forEach(C=>{v.push(C)}),`Keys: ${v.join(", ")}`})})}})}async close(b){this.logger.trace(`[storage ${this.name}] close()`);const k=await this.whenConnected;return this.doClose(k,b)}doClose(b,k){return new Promise((y,g)=>{b.db.close(t=>(t&&this.handleSQLiteError(b,`[storage ${this.name}] close(): ${t}`),this.path===E.IN_MEMORY_PATH?y():!b.isErroneous&&!b.isInMemory?this.backup().then(y,d=>(this.logger.error(`[storage ${this.name}] backup(): ${d}`),y())):typeof k=="function"?P.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(d=>{const m=()=>this.doClose(d,void 0);return this.doUpdateItems(d,{insert:k()}).then(()=>m(),v=>(m(),Promise.reject(v)))})).then(y,g):g(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const b=this.toBackupPath(this.path);return P.Promises.copy(this.path,b,{preserveSymlinks:!1})}toBackupPath(b){return`${b}.backup`}async checkIntegrity(b){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${b})`);const k=await this.whenConnected,y=await this.get(k,b?"PRAGMA integrity_check":"PRAGMA quick_check"),g=b?y.integrity_check:y.quick_check;return k.isErroneous?`${g} (last error: ${k.lastError})`:k.isInMemory?`${g} (in-memory!)`:g}async connect(b,k=!0){this.logger.trace(`[storage ${this.name}] open(${b}, retryOnBusy: ${k})`);try{return await this.doConnect(b)}catch(y){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&k)return await(0,p.timeout)(E.BUSY_OPEN_TIMEOUT),this.connect(b,!1);try{await P.Promises.unlink(b);try{await P.Promises.rename(this.toBackupPath(b),b)}catch{}return await this.doConnect(b)}catch(g){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${g}`),this.doConnect(E.IN_MEMORY_PATH)}}}handleSQLiteError(b,k){b.isErroneous=!0,b.lastError=k,this.logger.error(k)}doConnect(b){return new Promise((k,y)=>{new Promise((g,t)=>{j(["@vscode/sqlite3"],g,t)}).then(g=>{const t={db:new(this.logger.isTracing?g.verbose().Database:g.Database)(b,d=>d?t.db?t.db.close(()=>y(d)):y(d):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>k(t),m=>t.db.close(()=>y(m)))),isInMemory:b===E.IN_MEMORY_PATH};t.db.on("error",d=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${d}`)),this.logger.isTracing&&t.db.on("trace",d=>this.logger.trace(`[storage ${this.name}] Trace (event): ${d}`))},y)})}exec(b,k){return new Promise((y,g)=>{b.db.exec(k,t=>t?(this.handleSQLiteError(b,`[storage ${this.name}] exec(): ${t}`),g(t)):y())})}get(b,k){return new Promise((y,g)=>{b.db.get(k,(t,d)=>t?(this.handleSQLiteError(b,`[storage ${this.name}] get(): ${t}`),g(t)):y(d))})}all(b,k){return new Promise((y,g)=>{b.db.all(k,(t,d)=>t?(this.handleSQLiteError(b,`[storage ${this.name}] all(): ${t}`),g(t)):y(d))})}transaction(b,k){return new Promise((y,g)=>{b.db.serialize(()=>{b.db.run("BEGIN TRANSACTION"),k(),b.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(b,`[storage ${this.name}] transaction(): ${t}`),g(t)):y())})})}prepare(b,k,y,g){const t=b.db.prepare(k),d=m=>{this.handleSQLiteError(b,`[storage ${this.name}] prepare(): ${m} (${k}). Details: ${g()}`)};t.on("error",d),y(t),t.finalize(m=>{m&&d(m),t.removeListener("error",d)})}}e.SQLiteStorageDatabase=E,E.IN_MEMORY_PATH=":memory:",E.BUSY_OPEN_TIMEOUT=2e3,E.MAX_HOST_PARAMETERS=256;class w{constructor(b){b&&typeof b.logTrace=="function"&&process.env[w.VSCODE_TRACE_STORAGE]&&(this.logTrace=b.logTrace),b&&typeof b.logError=="function"&&(this.logError=b.logError)}get isTracing(){return!!this.logTrace}trace(b){this.logTrace&&this.logTrace(b)}error(b){this.logError&&this.logError(b)}}w.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[129],te([12,11]),function(j,e){return j.create("vs/base/common/date",e)}),define(ee[130],te([0,1,129]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,D=n*60,M=D*24,P=M*7,E=M*30,w=M*365;function S(k,y,g){typeof k!="number"&&(k=k.getTime());const t=Math.round((new Date().getTime()-k)/1e3);if(t<-30)return(0,p.localize)(0,null,S(new Date().getTime()+t*1e3,!1));if(t<30)return(0,p.localize)(1,null);let d;return t<n?(d=t,y?d===1?g?(0,p.localize)(2,null,d):(0,p.localize)(3,null,d):g?(0,p.localize)(4,null,d):(0,p.localize)(5,null,d):d===1?g?(0,p.localize)(6,null,d):(0,p.localize)(7,null,d):g?(0,p.localize)(8,null,d):(0,p.localize)(9,null,d)):t<D?(d=Math.floor(t/n),y?d===1?g?(0,p.localize)(10,null,d):(0,p.localize)(11,null,d):g?(0,p.localize)(12,null,d):(0,p.localize)(13,null,d):d===1?g?(0,p.localize)(14,null,d):(0,p.localize)(15,null,d):g?(0,p.localize)(16,null,d):(0,p.localize)(17,null,d)):t<M?(d=Math.floor(t/D),y?d===1?g?(0,p.localize)(18,null,d):(0,p.localize)(19,null,d):g?(0,p.localize)(20,null,d):(0,p.localize)(21,null,d):d===1?g?(0,p.localize)(22,null,d):(0,p.localize)(23,null,d):g?(0,p.localize)(24,null,d):(0,p.localize)(25,null,d)):t<P?(d=Math.floor(t/M),y?d===1?(0,p.localize)(26,null,d):(0,p.localize)(27,null,d):d===1?(0,p.localize)(28,null,d):(0,p.localize)(29,null,d)):t<E?(d=Math.floor(t/P),y?d===1?g?(0,p.localize)(30,null,d):(0,p.localize)(31,null,d):g?(0,p.localize)(32,null,d):(0,p.localize)(33,null,d):d===1?g?(0,p.localize)(34,null,d):(0,p.localize)(35,null,d):g?(0,p.localize)(36,null,d):(0,p.localize)(37,null,d)):t<w?(d=Math.floor(t/E),y?d===1?g?(0,p.localize)(38,null,d):(0,p.localize)(39,null,d):g?(0,p.localize)(40,null,d):(0,p.localize)(41,null,d):d===1?g?(0,p.localize)(42,null,d):(0,p.localize)(43,null,d):g?(0,p.localize)(44,null,d):(0,p.localize)(45,null,d)):(d=Math.floor(t/w),y?d===1?g?(0,p.localize)(46,null,d):(0,p.localize)(47,null,d):g?(0,p.localize)(48,null,d):(0,p.localize)(49,null,d):d===1?g?(0,p.localize)(50,null,d):(0,p.localize)(51,null,d):g?(0,p.localize)(52,null,d):(0,p.localize)(53,null,d))}e.fromNow=S;function b(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(ee[131],te([12,11]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(ee[39],te([0,1,27,13,131]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function M(S,b){return b&&(S.stack||S.stacktrace)?D.localize(0,null,E(S),P(S.stack)||P(S.stacktrace)):E(S)}function P(S){return Array.isArray(S)?S.join(`
`):S}function E(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?D.localize(1,null,S.message):S.message||D.localize(2,null)}function w(S=null,b=!1){if(!S)return D.localize(3,null);if(Array.isArray(S)){const k=p.coalesce(S),y=w(k[0],b);return k.length>1?D.localize(4,null,y,k.length):y}if(n.isString(S))return S;if(S.detail){const k=S.detail;if(k.error)return M(k.error,b);if(k.exception)return M(k.exception,b)}return S.stack?M(S,b):S.message?S.message:D.localize(5,null)}e.toErrorMessage=w}),define(ee[132],te([12,11]),function(j,e){return j.create("vs/base/common/keybindingLabels",e)}),define(ee[133],te([0,1,132]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class n{constructor(P,E,w=E){this.modifierLabels=[null],this.modifierLabels[2]=P,this.modifierLabels[1]=E,this.modifierLabels[3]=w}toLabel(P,E,w){if(E.length===0)return null;const S=[];for(let b=0,k=E.length;b<k;b++){const y=E[b],g=w(y);if(g===null)return null;S[b]=D(y,g,this.modifierLabels[P])}return S.join(" ")}}e.ModifierLabelProvider=n,e.UILabelProvider=new n({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:p.localize(0,null),shiftKey:p.localize(1,null),altKey:p.localize(2,null),metaKey:p.localize(3,null),separator:"+"},{ctrlKey:p.localize(4,null),shiftKey:p.localize(5,null),altKey:p.localize(6,null),metaKey:p.localize(7,null),separator:"+"}),e.AriaLabelProvider=new n({ctrlKey:p.localize(8,null),shiftKey:p.localize(9,null),altKey:p.localize(10,null),metaKey:p.localize(11,null),separator:"+"},{ctrlKey:p.localize(12,null),shiftKey:p.localize(13,null),altKey:p.localize(14,null),metaKey:p.localize(15,null),separator:"+"},{ctrlKey:p.localize(16,null),shiftKey:p.localize(17,null),altKey:p.localize(18,null),metaKey:p.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new n({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new n({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function D(M,P,E){if(P===null)return"";const w=[];return M.ctrlKey&&w.push(E.ctrlKey),M.shiftKey&&w.push(E.shiftKey),M.altKey&&w.push(E.altKey),M.metaKey&&w.push(E.metaKey),P!==""&&w.push(P),w.join(E.separator)}}),define(ee[134],te([12,11]),function(j,e){return j.create("vs/base/node/processes",e)}),define(ee[74],te([0,1,44,28,10,47,9,3,34,83,13,118,24,134]),function(j,e,p,n,D,M,P,E,w,S,b,k,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return S.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return S.TerminateResponseCode}});function t(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(o,l){if(E.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};l&&(s.cwd=l);const i=p.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],s);return new Promise(r=>{i.once("error",a=>{r({success:!1,error:a})}),i.once("exit",(a,h)=>{r(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?t(s.status):1})}else if(E.isLinux||E.isMacintosh)try{const s=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",j).fsPath;return new Promise(i=>{p.execFile(s,[o.pid.toString()],{encoding:"utf8",shell:!0},(r,a,h)=>{i(r?{success:!1,error:r}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function m(o){!o||(delete o.DEBUG,E.isMacintosh&&delete o.DYLD_LIBRARY_PATH,E.isLinux&&delete o.LD_PRELOAD)}e.removeDangerousEnvVariables=m;function v(o=w.env){return o.comspec||"cmd.exe"}e.getWindowsShell=v;class C{constructor(l,s,i,r){if(s!==void 0&&i!==void 0&&r!==void 0)this.cmd=l,this.args=s,this.shell=i,this.options=r;else{const a=l;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(w.env).forEach(h=>{a[h]=w.env[h]}),Object.keys(this.options.env).forEach(h=>{a[h]=this.options.env[h]}),this.options.env=a}}getSanitizedCommand(){let l=this.cmd.toLowerCase();const s=l.lastIndexOf(P.sep);return s!==-1&&(l=l.substring(s+1)),C.WellKnowCommands[l]?l:"other"}start(l){return E.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(w.cwd()))?Promise.reject(new Error(g.localize(0,null))):this.useExec().then(s=>{let i,r;const a=new Promise((h,I)=>{i=h,r=I});if(s){let h=this.cmd;this.args&&(h=h+" "+this.args.join(" ")),this.childProcess=p.exec(h,this.options,(I,R,L)=>{this.childProcess=null;const W=I;W&&W.killed?r({killed:this.terminateRequested,stdout:R.toString(),stderr:L.toString()}):this.handleExec(i,l,I,R,L)})}else{let h=null;const I=R=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(R,i,l,r);const L={terminated:this.terminateRequested};b.isNumber(R)&&(L.cmdCode=R),i(L)};if(this.shell&&E.isWindows){const R=M.deepClone(this.options);R.windowsVerbatimArguments=!0,R.detached=!1;let L=!1,W=!1;const N=[];let J=this.ensureQuotes(this.cmd);N.push(J.value),L=J.quoted,this.args&&this.args.forEach(re=>{J=this.ensureQuotes(re),N.push(J.value),W=W&&J.quoted});const oe=["/s","/c"];L?W?oe.push('"'+N.join(" ")+'"'):N.length>1?oe.push('"'+N[0]+'" '+N.slice(1).join(" ")):oe.push('"'+N[0]+'"'):oe.push(N.join(" ")),h=p.spawn(v(),oe,R)}else this.cmd&&(h=p.spawn(this.cmd,this.args,this.options));h&&(this.childProcess=h,this.childProcessPromise=Promise.resolve(h),this.pidResolve&&(this.pidResolve(b.isNumber(h.pid)?h.pid:-1),this.pidResolve=void 0),h.on("error",R=>{this.childProcess=null,r({terminated:this.terminateRequested,error:R})}),h.pid&&(this.childProcess.on("close",I),this.handleSpawn(h,i,l,r,!0)))}return a})}handleClose(l,s,i,r){}ensureQuotes(l){return C.regexp.test(l)?{value:'"'+l+'"',quoted:!0}:{value:l,quoted:l.length>0&&l[0]==='"'&&l[l.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(l=>l.pid,l=>-1):new Promise(l=>{this.pidResolve=l})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(l=>(this.terminateRequested=!0,d(l,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),l=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(l=>{if(!this.shell||!E.isWindows)return l(!1);const s=p.spawn(v(),["/s","/c"]);s.on("error",i=>l(!0)),s.on("exit",i=>l(!1))})}}e.AbstractProcess=C,C.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},C.regexp=/^[^"].* .*[^"]/;class u extends C{constructor(l,s,i,r){super(l,s,i,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(l,s,i,r,a){[r,a].forEach((h,I)=>{const R=new k.LineDecoder;R.write(h).forEach(N=>{s({line:N,source:I===0?0:1})});const W=R.end();W&&s({line:W,source:I===0?0:1})}),l({terminated:this.terminateRequested,error:i})}handleSpawn(l,s,i,r,a){const h=new k.LineDecoder,I=new k.LineDecoder;l.stdout.on("data",R=>{h.write(R).forEach(W=>i({line:W,source:0}))}),l.stderr.on("data",R=>{I.write(R).forEach(W=>i({line:W,source:1}))}),this.stdoutLineDecoder=h,this.stderrLineDecoder=I}handleClose(l,s,i,r){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&i({line:a,source:0});const h=this.stderrLineDecoder?this.stderrLineDecoder.end():null;h&&i({line:h,source:1})}}e.LineProcess=u;function f(o){let l=[],s=!1;const i=function(r){if(s){l.push(r);return}(!o.send(r,h=>{if(h&&console.error(h),s=!1,l.length>0){const I=l.slice(0);l=[],I.forEach(R=>i(R))}})||E.isWindows)&&(s=!0)};return{send:i}}e.createQueuedSender=f;var c;(function(o){async function l(s,i,r){if(P.isAbsolute(s))return s;if(i===void 0&&(i=w.cwd()),P.dirname(s)!=="."||(r===void 0&&b.isString(w.env.PATH)&&(r=w.env.PATH.split(P.delimiter)),r===void 0||r.length===0))return P.join(i,s);async function h(I){if(await y.Promises.exists(I)){let R;try{R=await y.Promises.stat(I)}catch(L){L.message.startsWith("EACCES")&&(R=await y.Promises.lstat(I))}return R?!R.isDirectory():!1}return!1}for(let I of r){let R;if(P.isAbsolute(I)?R=P.join(I,s):R=P.join(i,I,s),await h(R))return R;let L=R+".com";if(await h(L)||(L=R+".exe",await h(L)))return L}return P.join(i,s)}o.findExecutable=l})(c=e.win32||(e.win32={}))}),define(ee[135],te([0,1,26,3,122,74]),function(j,e,p,n,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function P(g,t){return g===1?n.isWindows?k():M.getWindowsShell(t):S(g,t)}e.getSystemShell=P;function E(g,t){return g===1?n.isWindows?y(t):M.getWindowsShell(t):S(g,t)}e.getSystemShellSync=E;let w=null;function S(g,t){if(n.isLinux&&g===2||n.isMacintosh&&g===3)return"/bin/bash";if(!w){let d;if(n.isWindows)d="/bin/bash";else{if(d=t.SHELL,!d)try{d=(0,p.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}w=d}return w}let b=null;async function k(){return b||(b=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),b}function y(g){if(b)return b;const t=n.isWindows&&parseFloat((0,p.release)())>=10,d=g.hasOwnProperty("PROCESSOR_ARCHITEW6432"),m=`${g.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?m:M.getWindowsShell(g)}}),define(ee[136],te([0,1,44,8,17,21,112,15,4,2,47,74,37]),function(j,e,p,n,D,M,P,E,w,S,b,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class g extends y.ChannelServer{constructor(m){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",v=>D.VSBuffer.wrap(Buffer.from(v,"base64")))},m);process.once("disconnect",()=>this.dispose())}}e.Server=g;class t{constructor(m,v){this.modulePath=m,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new w.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const C=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new n.Delayer(C),this.child=null,this._client=null}getChannel(m){const v=this;return{call(C,u,f){return v.requestPromise(m,C,u,f)},listen(C,u){return v.requestEvent(m,C,u)}}}requestPromise(m,v,C,u=M.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const f=this.getCachedChannel(m),c=(0,n.createCancelablePromise)(s=>f.call(v,C,s)),o=u.onCancellationRequested(()=>c.cancel()),l=(0,S.toDisposable)(()=>c.cancel());return this.activeRequests.add(l),c.finally(()=>{o.dispose(),this.activeRequests.delete(l),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),c}requestEvent(m,v,C){if(!this.disposeDelayer)return w.Event.None;this.disposeDelayer.cancel();let u;const f=new w.Emitter({onFirstListenerAdd:()=>{u=this.getCachedChannel(m).listen(v,C)(f.fire,f),this.activeRequests.add(u)},onLastListenerRemove:()=>{this.activeRequests.delete(u),u.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return f.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i))),(0,k.removeDangerousEnvVariables)(v.env),this.child=(0,p.fork)(this.modulePath,m,v);const C=new w.Emitter;w.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,P.isRemoteConsoleLog)(i)){(0,P.log)(i,`IPC Library: ${this.options.serverName}`);return}C.fire(D.VSBuffer.wrap(Buffer.from(i,"base64")))});const f=this.options.useQueue?(0,k.createQueuedSender)(this.child):this.child,c=i=>this.child&&this.child.connected&&f.send(i.buffer.toString("base64")),o=C.event,l={send:c,onMessage:o};this._client=new y.ChannelClient(l);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,r)=>{process.removeListener("exit",s),this.activeRequests.forEach(a=>(0,S.dispose)(a)),this.activeRequests.clear(),i!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+r),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:r})})}return this._client}getCachedChannel(m){let v=this.channels.get(m);return v||(v=this.client.getChannel(m),this.channels.set(m,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(ee[137],te([12,11]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(ee[138],te([12,11]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[139],te([12,11]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[140],te([12,11]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(ee[141],te([12,11]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(ee[142],te([12,11]),function(j,e){return j.create("vs/platform/environment/node/shellEnv",e)}),define(ee[143],te([12,11]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[144],te([12,11]),function(j,e){return j.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[145],te([12,11]),function(j,e){return j.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[146],te([12,11]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(ee[147],te([12,11]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(ee[148],te([12,11]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(ee[149],te([12,11]),function(j,e){return j.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[150],te([12,11]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[151],te([12,11]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[152],te([12,11]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[153],te([12,11]),function(j,e){return j.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[154],te([12,11]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(ee[155],te([12,11]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[156],te([12,11]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[157],te([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/window",e)}),define(ee[158],te([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[159],te([12,11]),function(j,e){return j.create("vs/platform/workspaces/common/workspaces",e)}),define(ee[160],te([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[161],te([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[162],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function p(n){return typeof n?.backupFolder=="string"}e.isEmptyWindowBackupInfo=p}),define(ee[163],te([0,1,4,2]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new p.Emitter,this._onReloadEmitter=new p.Emitter,this._onTerminateEmitter=new p.Emitter,this._onAttachEmitter=new p.Emitter}call(E,w,S){switch(w){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:S[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:S[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:S[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:S[0],port:S[1],subId:S[2]}))}throw new Error("Method not implemented.")}listen(E,w,S){switch(w){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class M extends n.Disposable{constructor(E){super();this.channel=E}reload(E){this.channel.call("reload",[E])}get onReload(){return this.channel.listen("reload")}close(E){this.channel.call("close",[E])}get onClose(){return this.channel.listen("close")}attachSession(E,w,S){this.channel.call("attach",[E,w,S])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(E,w){this.channel.call("terminate",[E,w])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(E,w){return this.channel.call("openExtensionDevelopmentHostWindow",[E,w])}}e.ExtensionHostDebugChannelClient=M}),define(ee[164],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class p{constructor(P){this.driver=P}listen(P,E){throw new Error(`No event found: ${E}`)}call(P,E,w){switch(E){case"click":return this.driver.click(w[0],w[1],w[2]);case"doubleClick":return this.driver.doubleClick(w);case"setValue":return this.driver.setValue(w[0],w[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(w);case"getElements":return this.driver.getElements(w[0],w[1]);case"getElementXY":return this.driver.getElementXY(w[0],w[1],w[2]);case"typeInEditor":return this.driver.typeInEditor(w[0],w[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(w);case"writeInTerminal":return this.driver.writeInTerminal(w[0],w[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${E}`)}}e.WindowDriverChannel=p;class n{constructor(P){this.channel=P}click(P,E,w){return this.channel.call("click",[P,E,w])}doubleClick(P){return this.channel.call("doubleClick",P)}setValue(P,E){return this.channel.call("setValue",[P,E])}getTitle(){return this.channel.call("getTitle")}isActiveElement(P){return this.channel.call("isActiveElement",P)}getElements(P,E){return this.channel.call("getElements",[P,E])}getElementXY(P,E,w){return this.channel.call("getElementXY",[P,E,w])}typeInEditor(P,E){return this.channel.call("typeInEditor",[P,E])}getTerminalBuffer(P){return this.channel.call("getTerminalBuffer",P)}writeInTerminal(P,E){return this.channel.call("writeInTerminal",[P,E])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=n;class D{constructor(P){this.channel=P}registerWindowDriver(P){return this.channel.call("registerWindowDriver",P)}reloadWindowDriver(P){return this.channel.call("reloadWindowDriver",P)}}e.WindowDriverRegistryChannelClient=D}),define(ee[165],te([0,1,130,46,10,9,34,16,7]),function(j,e,p,n,D,M,P,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class S{constructor(d,m,v){this._args=d,this.paths=m,this.productService=v}get appRoot(){return(0,M.dirname)(D.FileAccess.asFileUri("",j).fsPath)}get userHome(){return w.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return w.URI.file((0,M.join)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.paths.tmpDir)}get cacheHome(){return w.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,E.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,E.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,p.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return w.URI.file((0,M.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.joinPath)(w.URI.file((0,M.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return w.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return w.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=P.env.VSCODE_PORTABLE;return d?w.URI.file((0,M.join)(d,"argv.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,E.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,M.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,M.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,M.resolve)(d):(0,M.normalize)((0,M.join)(D.FileAccess.asFileUri("",j).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,M.resolve)(d):(0,M.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,M.resolve)(d);const m=P.env.VSCODE_EXTENSIONS;if(m)return m;const v=P.env.VSCODE_PORTABLE;return v?(0,M.join)(v,"extensions"):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(m=>/^[^:/?#]+?:\/\//.test(m)?w.URI.parse(m):w.URI.file((0,M.normalize)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?w.URI.parse(d):w.URI.file((0,M.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!P.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,E.joinPath)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return w.URI.file((0,M.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([n.memoize],S.prototype,"appRoot",null),de([n.memoize],S.prototype,"userHome",null),de([n.memoize],S.prototype,"userDataPath",null),de([n.memoize],S.prototype,"appSettingsHome",null),de([n.memoize],S.prototype,"tmpDir",null),de([n.memoize],S.prototype,"cacheHome",null),de([n.memoize],S.prototype,"userRoamingDataHome",null),de([n.memoize],S.prototype,"settingsResource",null),de([n.memoize],S.prototype,"userDataSyncHome",null),de([n.memoize],S.prototype,"userDataSyncLogResource",null),de([n.memoize],S.prototype,"sync",null),de([n.memoize],S.prototype,"machineSettingsResource",null),de([n.memoize],S.prototype,"globalStorageHome",null),de([n.memoize],S.prototype,"workspaceStorageHome",null),de([n.memoize],S.prototype,"keybindingsResource",null),de([n.memoize],S.prototype,"keyboardLayoutResource",null),de([n.memoize],S.prototype,"argvResource",null),de([n.memoize],S.prototype,"snippetsHome",null),de([n.memoize],S.prototype,"isExtensionDevelopment",null),de([n.memoize],S.prototype,"untitledWorkspacesHome",null),de([n.memoize],S.prototype,"installSourcePath",null),de([n.memoize],S.prototype,"builtinExtensionsPath",null),de([n.memoize],S.prototype,"extensionsPath",null),de([n.memoize],S.prototype,"extensionDevelopmentLocationURI",null),de([n.memoize],S.prototype,"extensionDevelopmentKind",null),de([n.memoize],S.prototype,"extensionTestsLocationURI",null),de([n.memoize],S.prototype,"debugExtensionHost",null),de([n.memoize],S.prototype,"serviceMachineIdResource",null),de([n.memoize],S.prototype,"telemetryLogResource",null),de([n.memoize],S.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=S;function b(t,d){return g(t["inspect-extensions"],t["inspect-brk-extensions"],5870,d,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=b;function k(t,d){return g(t["inspect-search"],t["inspect-brk-search"],5876,d,t.extensionEnvironment)}e.parseSearchPort=k;function y(t,d){return g(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,d,t.extensionEnvironment)}e.parsePtyHostPort=y;function g(t,d,m,v,C,u){const c=Number(d||t)||(v?null:m),o=c?Boolean(!!d):!1;let l;if(u)try{l=JSON.parse(u)}catch{}return{port:c,break:o,debugId:C,env:l}}}),define(ee[90],te([0,1,253,3,140]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const M={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const P={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function E(t,d,m=P){const v={},C=[],u=[];for(let l in d){const s=d[l];s.alias&&(v[l]=s.alias),s.type==="string"||s.type==="string[]"?(C.push(l),s.deprecates&&C.push(...s.deprecates)):s.type==="boolean"&&(u.push(l),s.deprecates&&u.push(...s.deprecates))}const f=p(t,{string:C,boolean:u,alias:v}),c={},o=f;c._=f._.map(l=>String(l)).filter(l=>l.length>0),delete o._;for(let l in d){const s=d[l];s.alias&&delete o[s.alias];let i=o[l];if(s.deprecates)for(const r of s.deprecates)o.hasOwnProperty(r)&&(i||(i=o[r],i&&m.onDeprecatedOption(r,s.deprecationMessage||(0,D.localize)(33,null))),delete o[r]);typeof i!="undefined"&&(s.type==="string[]"?i&&!Array.isArray(i)&&(i=[i]):s.type==="string"&&Array.isArray(i)&&(i=i.pop(),m.onMultipleValues(l,i)),c[l]=i,s.deprecationMessage&&m.onDeprecatedOption(l,s.deprecationMessage)),delete o[l]}for(let l in o)m.onUnknownOption(l);return c}e.parseArgs=E;function w(t,d){let m="";return d.args&&(Array.isArray(d.args)?m=` <${d.args.join("> <")}>`:m=` <${d.args}>`),d.alias?`-${d.alias} --${t}${m}`:`--${t}${m}`}function S(t,d){let m=0,v=[];for(const c in t){const o=t[c],l=w(c,o);m=Math.max(m,l.length),v.push([l,o.description])}let C=m+2+1;if(d-C<25)return v.reduce((c,o)=>c.concat([`  ${o[0]}`,`      ${o[1]}`]),[]);let u=d-C-1,f=[];for(const c of v){let o=c[0],l=k(c[1],u),s=b(C-o.length-2);f.push("  "+o+s+l[0]);for(let i=1;i<l.length;i++)f.push(b(C)+l[i])}return f}e.formatOptions=S;function b(t){return" ".repeat(t)}function k(t,d){let m=[];for(;t.length;){let v=t.length<d?t.length:t.lastIndexOf(" ",d),C=t.slice(0,v).trim();t=t.slice(v),m.push(C)}return m}function y(t,d,m,v,C){const u=process.stdout.isTTY&&process.stdout.columns||80,f=C?.noInputFiles!==!0?`[${(0,D.localize)(34,null)}...]`:"",c=[`${t} ${m}`];c.push(""),c.push(`${(0,D.localize)(35,null)}: ${d} [${(0,D.localize)(36,null)}]${f}`),c.push(""),C?.noPipe!==!0&&(n.isWindows?c.push((0,D.localize)(37,null,d)):c.push((0,D.localize)(38,null,d)),c.push(""));const o={};for(const l in v){const s=v[l];if(s.description&&s.cat){let i=o[s.cat];i||(o[s.cat]=i={}),i[l]=s}}for(let l in o){const s=l;let i=o[s];i&&(c.push(M[s]),c.push(...S(i,u)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=y;function g(t,d){return`${t||(0,D.localize)(39,null)}
${d||(0,D.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=g}),define(ee[166],te([0,1,61,163,90]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class M extends n.ExtensionHostDebugBroadcastChannel{constructor(E){super();this.windowsMainService=E}call(E,w,S){return w==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(S[0],S[1]):super.call(E,w,S)}async openExtensionDevelopmentHostWindow(E,w){const S=(0,D.parseArgs)(E,D.OPTIONS);S.debugRenderer=w;const b=S.extensionDevelopmentPath;if(!b)return{success:!1};const[k]=this.windowsMainService.openExtensionDevelopmentHostWindow(b,{context:5,cli:S});if(!w)return{success:!0};const y=k.win;if(!y)return{success:!0};const g=y.webContents.debugger;let t=g.isAttached()?1/0:0;const d=(0,p.createServer)(m=>{t++==0&&g.attach();let v=!1;const C=c=>{v||m.write(JSON.stringify(c)+"\0")},u=(c,o,l,s)=>C({method:o,params:l,sessionId:s});y.on("close",()=>{g.removeListener("message",u),m.end(),v=!0}),g.addListener("message",u);let f=Buffer.alloc(0);m.on("data",c=>{f=Buffer.concat([f,c]);for(let o=f.indexOf(0);o!==-1;o=f.indexOf(0)){let l;try{const s=f.slice(0,o).toString("utf8");f=f.slice(o+1),l=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}g.sendCommand(l.method,l.params,l.sessionId).then(s=>C({id:l.id,sessionId:l.sessionId,result:s})).catch(s=>C({id:l.id,sessionId:l.sessionId,error:{code:0,message:s.message}}))}}),m.on("error",c=>{console.error("error on cdp pipe:",c)}),m.on("close",()=>{v=!0,--t==0&&g.detach()})});return await new Promise(m=>d.listen(0,m)),y.on("close",()=>d.close()),{rendererDebugPort:d.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=M}),function(){"use strict";function j(e,p,n,D){function M(E){const w=P(E),S=[w];return e.isAbsolute(w)||S.unshift(D),e.resolve(...S)}function P(E){const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let S=process.env.VSCODE_APPDATA;if(S)return e.join(S,n);const b=E["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(S=process.env.APPDATA,!S){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");S=e.join(k,"AppData","Roaming")}break;case"darwin":S=e.join(p.homedir(),"Library","Application Support");break;case"linux":S=process.env.XDG_CONFIG_HOME||e.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(S,n)}return{getUserDataPath:M}}if(typeof define=="function")define(ee[167],te([0,254,26,10,16,34]),function(e,p,n,D,M,P){const E=M.dirname(D.FileAccess.asFileUri("",e)),w=e.__$__nodeRequire(M.joinPath(E,"package.json").fsPath);return j(p,n,w.name,P.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),p=require("path"),n=require("os");module.exports=j(p,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[168],te([0,1,26,165,167]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class M extends n.AbstractNativeEnvironmentService{constructor(E,w){super(E,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,D.getUserDataPath)(E)},w)}}e.NativeEnvironmentService=M}),define(ee[169],te([0,1,29,26,28]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function M(P){const E=(0,D.randomPath)((0,n.tmpdir)());try{return(0,p.writeFileSync)(E,""),P&&console.log(`Marker file for --wait created: ${E}`),E}catch(w){P&&console.error(`Failed to create marker file for --wait: ${w}`);return}}e.createWaitMarkerFile=M}),define(ee[170],te([0,1,144]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const n=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function M(y){return y=y.trim(),y==="*"||n.test(y)}e.isValidVersionStr=M;function P(y){if(!M(y))return null;if(y=y.trim(),y==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=y.match(n);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=P;function E(y){if(!y)return null;let g=y.majorBase,t=y.majorMustEqual,d=y.minorBase,m=y.minorMustEqual,v=y.patchBase,C=y.patchMustEqual;y.hasCaret&&(g===0||(m=!1),C=!1);let u=0;if(y.preRelease){const f=D.exec(y.preRelease);if(f){const[,c,o,l]=f;u=Date.UTC(Number(c),Number(o)-1,Number(l))}}return{majorBase:g,majorMustEqual:t,minorBase:d,minorMustEqual:m,patchBase:v,patchMustEqual:C,isMinimum:y.hasGreaterEquals,notBefore:u}}e.normalizeVersion=E;function w(y,g,t){let d;typeof y=="string"?d=E(P(y)):d=y;let m;g instanceof Date?m=g.getTime():typeof g=="string"&&(m=new Date(g).getTime());let v;if(typeof t=="string"?v=E(P(t)):v=t,!d||!v)return!1;let C=d.majorBase,u=d.minorBase,f=d.patchBase,c=v.majorBase,o=v.minorBase,l=v.patchBase,s=v.notBefore,i=v.majorMustEqual,r=v.minorMustEqual,a=v.patchMustEqual;return v.isMinimum?C>c?!0:C<c?!1:u>o?!0:u<o||m&&m<s?!1:f>=l:(C===1&&c===0&&(!i||!r||!a)&&(c=1,o=0,l=0,i=!0,r=!1,a=!1),C<c?!1:C>c?!i:u<o?!1:u>o?!r:f<l?!1:f>l?!a:!(m&&m<s))}e.isValidVersion=w;function S(y,g,t,d){return t.isBuiltin||typeof t.main=="undefined"?!0:k(y,g,t.engines.vscode,d)}e.isValidExtensionVersion=S;function b(y,g,t){return y==="*"||k(g,t,y)}e.isEngineValid=b;function k(y,g,t,d=[]){let m=E(P(t));if(!m)return d.push(p.localize(0,null,t)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return d.push(p.localize(1,null,t)),!1}else if(!m.majorMustEqual)return d.push(p.localize(2,null,t)),!1;return w(y,g,m)?!0:(d.push(p.localize(3,null,y,t)),!1)}}),define(ee[62],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class p{constructor(D,M=[],P=!1){this.ctor=D,this.staticArguments=M,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=p}),define(ee[171],te([0,1,62]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function D(P,E,w){E instanceof p.SyncDescriptor||(E=new p.SyncDescriptor(E,[],w)),n.push([P,E])}e.registerSingleton=D;function M(){return n}e.getSingletonServiceDescriptors=M}),define(ee[172],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(M){this.incoming=new Map,this.outgoing=new Map,this.data=M}}e.Node=p;class n{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(let P of this._nodes.values())P.outgoing.size===0&&M.push(P);return M}insertEdge(M,P){const E=this.lookupOrInsertNode(M),w=this.lookupOrInsertNode(P);E.outgoing.set(this._hashFn(P),w),w.incoming.set(this._hashFn(M),E)}removeNode(M){const P=this._hashFn(M);this._nodes.delete(P);for(let E of this._nodes.values())E.outgoing.delete(P),E.incoming.delete(P)}lookupOrInsertNode(M){const P=this._hashFn(M);let E=this._nodes.get(P);return E||(E=new p(M),this._nodes.set(P,E)),E}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){let M=[];for(let[P,E]of this._nodes)M.push(`${P}, (incoming)[${[...E.incoming.keys()].join(", ")}], (outgoing)[${[...E.outgoing.keys()].join(",")}]`);return M.join(`
`)}findCycleSlow(){for(let[M,P]of this._nodes){const E=new Set([M]),w=this._findCycle(P,E);if(w)return w}}_findCycle(M,P){for(let[E,w]of M.outgoing){if(P.has(E))return[...P,E].join(" -> ");P.add(E);const S=this._findCycle(w,P);if(S)return S;P.delete(E)}}}e.Graph=n}),define(ee[5],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function E(w){return w[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=E})(p=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function n(P,E,w,S){E[p.DI_TARGET]===E?E[p.DI_DEPENDENCIES].push({id:P,index:w,optional:S}):(E[p.DI_DEPENDENCIES]=[{id:P,index:w,optional:S}],E[p.DI_TARGET]=E)}function D(P){if(p.serviceIds.has(P))return p.serviceIds.get(P);const E=function(w,S,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(E,w,b,!1)};return E.toString=()=>P,p.serviceIds.set(P,E),E}e.createDecorator=D;function M(P){return P}e.refineServiceDecorator=M}),define(ee[52],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,p.createDecorator)("backupMainService")}),define(ee[19],te([0,1,13,7,5]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function M(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof n.URI)}e.isConfigurationOverrides=M;function P(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||p.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=P;var E;(function(m){m[m.USER=1]="USER",m[m.USER_LOCAL=2]="USER_LOCAL",m[m.USER_REMOTE=3]="USER_REMOTE",m[m.WORKSPACE=4]="WORKSPACE",m[m.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",m[m.DEFAULT=6]="DEFAULT",m[m.MEMORY=7]="MEMORY"})(E=e.ConfigurationTarget||(e.ConfigurationTarget={}));function w(m){switch(m){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=w;function S(m,v){const C=Object.create(null);for(let u in m)b(C,u,m[u],v);return C}e.toValuesTree=S;function b(m,v,C,u){const f=v.split("."),c=f.pop();let o=m;for(let l=0;l<f.length;l++){let s=f[l],i=o[s];switch(typeof i){case"undefined":i=o[s]=Object.create(null);break;case"object":break;default:u(`Ignoring ${v} as ${f.slice(0,l+1).join(".")} is ${JSON.stringify(i)}`);return}o=i}if(typeof o=="object"&&o!==null)try{o[c]=C}catch{u(`Ignoring ${v} as ${f.join(".")} is ${JSON.stringify(o)}`)}else u(`Ignoring ${v} as ${f.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=b;function k(m,v){const C=v.split(".");y(m,C)}e.removeFromValueTree=k;function y(m,v){const C=v.shift();if(v.length===0){delete m[C];return}if(Object.keys(m).indexOf(C)!==-1){const u=m[C];typeof u=="object"&&!Array.isArray(u)&&(y(u,v),Object.keys(u).length===0&&delete m[C])}}function g(m,v,C){function u(o,l){let s=o;for(const i of l){if(typeof s!="object"||s===null)return;s=s[i]}return s}const f=v.split("."),c=u(m,f);return typeof c=="undefined"?C:c}e.getConfigurationValue=g;function t(m,v,C){Object.keys(v).forEach(u=>{u!=="__proto__"&&(u in m?p.isObject(m[u])&&p.isObject(v[u])?t(m[u],v[u],C):C&&(m[u]=v[u]):m[u]=v[u])})}e.merge=t;function d(m,v,C){const u=m.inspect(v),f=m.inspect(C);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:u.defaultValue}e.getMigratedSettingValue=d}),define(ee[173],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ICredentialsService=void 0,e.ICredentialsService=(0,p.createDecorator)("credentialsService")}),define(ee[75],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,p.createDecorator)(e.ID);function n(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=n}),define(ee[91],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,p.createDecorator)("encryptionMainService");class n{constructor(M){this.machineId=M}encryption(){return new Promise((M,P)=>j(["vscode-encrypt"],M,P))}async encrypt(M){try{return(await this.encryption()).encrypt(this.machineId,M)}catch{return M}}async decrypt(M){try{return(await this.encryption()).decrypt(this.machineId,M)}catch{return M}}}e.EncryptionMainService=n}),define(ee[48],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[174],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,p.createDecorator)("extensionUrlTrustService")}),define(ee[175],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,p.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[92],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,p.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,p.createDecorator)("externalTerminal")}),define(ee[176],te([0,1,44,10,9,3,83,24,74,145,92]),function(j,e,p,n,D,M,P,E,w,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=S.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:g.getDefaultTerminalWindows(),linux:await d.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class g extends y{openTerminal(f,c){return this.spawnTerminal(p,f,w.getWindowsShell(),c)}spawnTerminal(f,c,o,l){const s=c.windowsExec||g.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const i=D.basename(s).toLowerCase();if(i==="cmder"||i==="cmder.exe")return f.spawn(s,l?[l]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return s.indexOf(" ")>=0&&r.push('""'),r.push(s),(i==="wt"||i==="wt.exe")&&r.push("-d ."),new Promise((a,h)=>{const I=m(process),R=f.spawn(o,r,{cwd:l,env:I});R.on("error",h),R.on("exit",()=>a())})}runInTerminal(f,c,o,l,s){const i="windowsExec"in s&&s.windowsExec?s.windowsExec:g.getDefaultTerminalWindows();return new Promise((r,a)=>{const h=`"${c} - ${k}"`,I=`""${o.join('" "')}" & pause"`,R=["/c","start",h,"/wait",i,"/c",I],L=Object.assign({},m(process),l);Object.keys(L).filter(J=>L[J]===null).forEach(J=>delete L[J]);const W={cwd:c,env:L,windowsVerbatimArguments:!0};p.spawn(g.CMD,R,W).on("error",J=>{a(v(J))}),r(void 0)})}static getDefaultTerminalWindows(){if(!g._DEFAULT_TERMINAL_WINDOWS){const f=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");g._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${f?"Sysnative":"System32"}\\cmd.exe`}return g._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=g,g.CMD="cmd.exe";class t extends y{openTerminal(f,c){return this.spawnTerminal(p,f,c)}runInTerminal(f,c,o,l,s){const i=s.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((r,a)=>{if(i===b.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const h=i===b.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[n.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${h}.scpt`,j).fsPath,"-t",f||k,"-w",c];for(let N of o)R.push("-a"),R.push(N);if(l){const N=Object.assign({},m(process),l);for(let J in N){const oe=N[J];oe===null?(R.push("-u"),R.push(J)):(R.push("-e"),R.push(`${J}=${oe}`))}}let L="";const W=p.spawn(t.OSASCRIPT,R);W.on("error",N=>{a(v(N))}),W.stderr.on("data",N=>{L+=N.toString()}),W.on("exit",N=>{if(N===0)r(void 0);else if(L){const J=L.split(`
`,1);a(new Error(J[0]))}else a(new Error(S.localize(1,null,h,N)))})}else a(new Error(S.localize(2,null,i)))})}spawnTerminal(f,c,o){const l=c.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((s,i)=>{const r=["-a",l];o&&r.push(o);const a=m(process),h=f.spawn("/usr/bin/open",r,{cwd:o,env:a});h.on("error",i),h.on("exit",()=>s())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class d extends y{openTerminal(f,c){return this.spawnTerminal(p,f,c)}runInTerminal(f,c,o,l,s){const i=s.linuxExec?Promise.resolve(s.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((r,a)=>{let h=[];i.then(I=>{I.indexOf("gnome-terminal")>=0?h.push("-x"):h.push("-e"),h.push("bash"),h.push("-c");const R=`${C(o)}; echo; read -p "${d.WAIT_MESSAGE}" -n1;`;h.push(`''${R}''`);const L=Object.assign({},m(process),l);Object.keys(L).filter(oe=>L[oe]===null).forEach(oe=>delete L[oe]);const W={cwd:c,env:L};let N="";const J=p.spawn(I,h,W);J.on("error",oe=>{a(v(oe))}),J.stderr.on("data",oe=>{N+=oe.toString()}),J.on("exit",oe=>{if(oe===0)r(void 0);else if(N){const re=N.split(`
`,1);a(new Error(re[0]))}else a(new Error(S.localize(4,null,I,oe)))})})})}static async getDefaultTerminalLinuxReady(){if(!d._DEFAULT_TERMINAL_LINUX_READY)if(!M.isLinux)d._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const f=await E.Promises.exists("/etc/debian_version");d._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{f?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return d._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(f,c,o){const l=c.linuxExec?Promise.resolve(c.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((s,i)=>{l.then(r=>{const a=m(process),h=f.spawn(r,[],{cwd:o,env:a});h.on("error",i),h.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=d,d.WAIT_MESSAGE=S.localize(3,null);function m(u){const f={...u.env};return(0,P.sanitizeProcessEnvironment)(f),f}function v(u){return"errno"in u&&u.errno==="ENOENT"&&"path"in u&&typeof u.path=="string"?new Error(S.localize(5,null,u.path)):u}function C(u){let f="";for(let c of u)c.indexOf(" ")>=0?f+='"'+c+'"':f+=c,f+=" ";return f}}),define(ee[18],te([0,1,35,9,25,13,7,147,5]),function(j,e,p,n,D,M,P,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function S(H){return H.create===!0}e.isFileOpenForWriteOptions=S;var b;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var k;(function(H){H[H.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var y;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead"})(y=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=g;function t(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=t;function d(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function m(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=m;function v(H){return g(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var C;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(C=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class u extends Error{constructor(K,G){super(K);this.code=G}}e.FileSystemProviderError=u;function f(H,K){const G=new u(H.toString(),K);return o(G,K),G}e.createFileSystemProviderError=f;function c(H){return H||f((0,E.localize)(0,null),C.Unknown)}e.ensureFileSystemProviderError=c;function o(H,K){return H.name=K?`${K} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=o;function l(H){if(!H)return C.Unknown;if(H instanceof u)return H.code;const K=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!K)return C.Unknown;switch(K[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileExceedsMemoryLimit:return C.FileExceedsMemoryLimit;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}e.toFileSystemProviderErrorCode=l;function s(H){if(H instanceof R)return H.fileOperationResult;switch(l(H)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 10;case C.FileWriteLocked:return 5;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileExceedsMemoryLimit:return 9;case C.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var i;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class r{constructor(K,G,z){this.resource=K,this.operation=G,this.target=z}isOperation(K){return this.operation===K}}e.FileOperationEvent=r;var a;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class h{constructor(K,G){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=K;const z=new Map;for(const B of K){const Y=z.get(B.type);switch(Y?Y.push([B.resource,B]):z.set(B.type,[[B.resource,B]]),B.type){case 1:this.rawAdded.push(B.resource);break;case 0:this.rawUpdated.push(B.resource);break;case 2:this.rawDeleted.push(B.resource);break}}for(const[B,Y]of z)switch(B){case 1:this.added=p.TernarySearchTree.forUris(()=>G),this.added.fill(Y);break;case 0:this.updated=p.TernarySearchTree.forUris(()=>G),this.updated.fill(Y);break;case 2:this.deleted=p.TernarySearchTree.forUris(()=>G),this.deleted.fill(Y);break}}contains(K,...G){return this.doContains(K,{includeChildren:!1},...G)}affects(K,...G){return this.doContains(K,{includeChildren:!0},...G)}doContains(K,G,...z){if(!K)return!1;const B=z.length>0;return!!((!B||z.includes(1))&&(this.added?.get(K)||G.includeChildren&&this.added?.findSuperstr(K))||(!B||z.includes(0))&&(this.updated?.get(K)||G.includeChildren&&this.updated?.findSuperstr(K))||(!B||z.includes(2))&&(this.deleted?.findSubstr(K)||G.includeChildren&&this.deleted?.findSuperstr(K)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=h;function I(H,K,G){return!H||!K||H===K||K.length>H.length?!1:(K.charAt(K.length-1)!==n.sep&&(K+=n.sep),G?(0,D.startsWithIgnoreCase)(H,K):H.indexOf(K)===0)}e.isParent=I;class R extends Error{constructor(K,G,z){super(K);this.fileOperationResult=G,this.options=z}}e.FileOperationError=R;class L extends R{constructor(K,G,z){super(K,2,z);this.stat=G}}e.NotModifiedSinceFileOperationError=L;var W;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(W=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var N;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(N=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function J(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=J;async function oe(H,K){if(!K.hasProvider(P.URI.from({scheme:H.scheme})))return new Promise(G=>{const z=K.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===H.scheme&&B.added&&(z.dispose(),G())})})}e.whenProviderRegistered=oe,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class re{static formatSize(K){return(0,M.isNumber)(K)||(K=0),K<re.KB?(0,E.localize)(1,null,K.toFixed(0)):K<re.MB?(0,E.localize)(2,null,(K/re.KB).toFixed(2)):K<re.GB?(0,E.localize)(3,null,(K/re.MB).toFixed(2)):K<re.TB?(0,E.localize)(4,null,(K/re.GB).toFixed(2)):(0,E.localize)(5,null,(K/re.TB).toFixed(2))}}e.ByteSize=re,re.KB=1024,re.MB=re.KB*re.KB,re.GB=re.MB*re.KB,re.TB=re.GB*re.KB;var V;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function Z(H){return{maxFileSize:H===0?300*re.MB:16*re.GB,maxHeapSize:H===0?700*re.MB:2*700*re.MB}}e.getPlatformLimits=Z}),define(ee[53],te([0,1,255,141,90,18]),function(j,e,p,n,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function P(y,g){const t={onUnknownOption:m=>{console.warn((0,n.localize)(0,null,m))},onMultipleValues:(m,v)=>{console.warn((0,n.localize)(1,null,m,v))},onDeprecatedOption:(m,v)=>{console.warn((0,n.localize)(2,null,m,v))}},d=(0,D.parseArgs)(y,D.OPTIONS,g?t:void 0);return d.goto&&d._.forEach(m=>p(/^(\w:)?[^:]+(:\d*){0,2}$/.test(m),(0,n.localize)(3,null))),d["max-memory"]&&p(parseInt(d["max-memory"])>=M.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${M.MIN_MAX_MEMORY_SIZE_MB} MB.`),d}function E(y){const g=y.findIndex(t=>!/^-/.test(t));if(g>-1)return[...y.slice(0,g),...y.slice(g+1)]}function w(y){let[,...g]=y;process.env.VSCODE_DEV&&(g=E(g)||[]);const t=!k(process.env);return P(g,t)}e.parseMainProcessArgv=w;function S(y){const[,,...g]=y;return P(g,!0)}e.parseCLIProcessArgv=S;function b(y,...g){const t=y.indexOf("--");return t===-1?y.push(...g):y.splice(t,0,...g),y}e.addArg=b;function k(y){return y.VSCODE_CLI==="1"}e.isLaunchedFromCli=k}),define(ee[93],te([0,1,44,9,142,21,39,15,3,32,135,53,8]),function(j,e,p,n,D,M,P,E,w,S,b,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const g=1e4;let t;async function d(v,C,u){return C["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,k.isLaunchedFromCli)(u)&&!C["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,k.isLaunchedFromCli)(u)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=y.Promises.withAsyncBody(async(f,c)=>{const o=new M.CancellationTokenSource,l=setTimeout(()=>{o.dispose(!0),c(new Error((0,D.localize)(0,null)))},g);try{f(await m(v,o.token))}catch(s){!(0,E.isCancellationError)(s)&&!o.token.isCancellationRequested?c(new Error((0,D.localize)(1,null,(0,P.toErrorMessage)(s)))):f({})}finally{clearTimeout(l),o.dispose()}})),t)}e.getResolvedShellEnv=d;async function m(v,C){const u=process.env.ELECTRON_RUN_AS_NODE;v.trace("getUnixShellEnvironment#runAsNode",u);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;v.trace("getUnixShellEnvironment#noAttach",f);const c=(0,S.generateUuid)().replace(/-/g,"").substr(0,12),o=new RegExp(c+"(.*)"+c),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};v.trace("getUnixShellEnvironment#env",l);const s=await(0,b.getSystemShell)(w.OS,l);return v.trace("getUnixShellEnvironment#shell",s),new Promise((i,r)=>{if(C.isCancellationRequested)return r((0,E.canceled)());const a=(0,n.basename)(s);let h,I;const R=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(h=`& '${process.execPath}' ${R} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,I=["-Login","-Command"]):(h=`'${process.execPath}' ${R} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,a==="tcsh"?I=["-ic"]:I=["-ilc"]),v.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),h);const L=(0,p.spawn)(s,[...I,h],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});C.onCancellationRequested(()=>(L.kill(),r((0,E.canceled)()))),L.on("error",J=>{v.error("getUnixShellEnvironment#errorChildProcess",(0,P.toErrorMessage)(J)),r(J)});const W=[];L.stdout.on("data",J=>W.push(J));const N=[];L.stderr.on("data",J=>N.push(J)),L.on("close",(J,oe)=>{const re=Buffer.concat(W).toString("utf8");v.trace("getUnixShellEnvironment#raw",re);const V=Buffer.concat(N).toString("utf8");if(V.trim()&&v.trace("getUnixShellEnvironment#stderr",V),J||oe)return r(new Error((0,D.localize)(2,null,J,oe)));const Z=o.exec(re),H=Z?Z[1]:"{}";try{const K=JSON.parse(H);u?K.ELECTRON_RUN_AS_NODE=u:delete K.ELECTRON_RUN_AS_NODE,f?K.ELECTRON_NO_ATTACH_CONSOLE=f:delete K.ELECTRON_NO_ATTACH_CONSOLE,delete K.XDG_RUNTIME_DIR,v.trace("getUnixShellEnvironment#result",K),i(K)}catch(K){v.error("getUnixShellEnvironment#errorCaught",(0,P.toErrorMessage)(K)),r(K)}})})}}),define(ee[177],te([0,1,17,39,15,4,2,51,7,32,18]),function(j,e,p,n,D,M,P,E,w,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class k extends P.Disposable{constructor(g,t){super();this.channel=g,this.extraCapabilities=t,this.onDidChangeCapabilities=M.Event.None,this._onDidChange=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,S.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(g){return this.channel.call("stat",[g])}readdir(g){return this.channel.call("readdir",[g])}async readFile(g,t){const{buffer:d}=await this.channel.call("readFile",[g,t]);return d}readFileStream(g,t,d){const m=(0,E.newWriteableStream)(C=>p.VSBuffer.concat(C.map(u=>p.VSBuffer.wrap(u))).buffer),v=this.channel.listen("readFileStream",[g,t])(C=>{if(C instanceof p.VSBuffer)m.write(C.buffer);else{if(C==="end")m.end();else{let u=C;u instanceof Error||(u=(0,b.createFileSystemProviderError)((0,n.toErrorMessage)(u),b.FileSystemProviderErrorCode.Unknown)),m.error(u),m.end()}v.dispose()}});return d.onCancellationRequested(()=>{m.error((0,D.canceled)()),m.end(),v.dispose()}),m}writeFile(g,t,d){return this.channel.call("writeFile",[g,p.VSBuffer.wrap(t),d])}open(g,t){return this.channel.call("open",[g,t])}close(g){return this.channel.call("close",[g])}async read(g,t,d,m,v){const[C,u]=await this.channel.call("read",[g,t,v]);return d.set(C.buffer.slice(0,u),m),u}write(g,t,d,m,v){return this.channel.call("write",[g,t,p.VSBuffer.wrap(d),m,v])}mkdir(g){return this.channel.call("mkdir",[g])}delete(g,t){return this.channel.call("delete",[g,t])}rename(g,t,d){return this.channel.call("rename",[g,t,d])}copy(g,t,d){return this.channel.call("copy",[g,t,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(g=>{if(Array.isArray(g)){const t=g;this._onDidChange.fire(t.map(d=>({resource:w.URI.revive(d.resource),type:d.type})))}else{const t=g;this._onDidWatchError.fire(t)}}))}watch(g,t){const d=(0,S.generateUuid)();return this.channel.call("watch",[this.sessionId,d,g,t]),(0,P.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,d]))}}e.DiskFileSystemProviderClient=k}),define(ee[94],te([0,1,17,15,148,18]),function(j,e,p,n,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(b,k,y,g,t,d){let m;try{await E(b,k,y,g,t,d)}catch(v){m=v}finally{m&&t.errorTransformer&&(m=t.errorTransformer(m)),typeof m!="undefined"&&y.error(m),y.end()}}e.readFileIntoStream=P;async function E(b,k,y,g,t,d){w(d);const m=await b.open(k,{create:!1});try{w(d);let v=0,C=0,u=t&&typeof t.length=="number"?t.length:void 0,f=p.VSBuffer.alloc(Math.min(t.bufferSize,typeof u=="number"?u:t.bufferSize)),c=t&&typeof t.position=="number"?t.position:0,o=0;do C=await b.read(m,c,f.buffer,o,f.byteLength-o),c+=C,o+=C,v+=C,typeof u=="number"&&(u-=C),o===f.byteLength&&(await y.write(g(f)),f=p.VSBuffer.alloc(Math.min(t.bufferSize,typeof u=="number"?u:t.bufferSize)),o=0);while(C>0&&(typeof u!="number"||u>0)&&w(d)&&S(v,t));if(o>0){let l=o;typeof u=="number"&&(l=Math.min(o,u)),y.write(g(f.slice(0,l)))}}catch(v){throw(0,M.ensureFileSystemProviderError)(v)}finally{await b.close(m)}}function w(b){if(b.isCancellationRequested)throw(0,n.canceled)();return!0}function S(b,k){if(k?.limits){if(typeof k.limits.memory=="number"&&b>k.limits.memory)throw(0,M.createFileSystemProviderError)((0,D.localize)(0,null),M.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof k.limits.size=="number"&&b>k.limits.size)throw(0,M.createFileSystemProviderError)((0,D.localize)(1,null),M.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[63],te([0,1,2,3,7,18]),function(j,e,p,n,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function P(g){return g.recursive===!0}e.isRecursiveWatchRequest=P;class E extends p.Disposable{constructor(t,d,m,v){super();this.onFileChanges=t,this.onLogMessage=d,this.verboseLogging=m,this.options=v,this.watcherDisposables=this._register(new p.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const t=new p.DisposableStore;this.watcherDisposables.value=t,this.watcher=this.createWatcher(t),this.watcher.setVerboseLogging(this.verboseLogging),t.add(this.watcher.onDidChangeFile(d=>this.onFileChanges(d))),t.add(this.watcher.onDidLogMessage(d=>this.onLogMessage(d))),t.add(this.watcher.onDidError(d=>this.onError(d)))}onError(t){this.options.restartOnError?this.restartCounter<E.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${t}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${t}`):this.error(t)}restart(t){this.restartCounter++,this.init(),this.watch(t)}async watch(t){this.requests=t,await this.watcher?.watch(t)}async setVerboseLogging(t){this.verboseLogging=t,await this.watcher?.setVerboseLogging(t)}error(t){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${t}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=E,E.MAX_RESTARTS=5;class w extends E{constructor(t,d,m){super(t,d,m,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=w;class S extends E{constructor(t,d,m){super(t,d,m,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=S;function b(g){return g.map(t=>({type:t.type,resource:D.URI.file(t.path)}))}e.toFileChanges=b;function k(g){const t=new y;for(const d of g)t.processEvent(d);return t.coalesce()}e.coalesceEvents=k;class y{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(t){return n.isLinux?t.path:t.path.toLowerCase()}processEvent(t){const d=this.mapPathToChange.get(this.toKey(t));let m=!1;if(d){const v=d.type,C=t.type;d.path!==t.path&&(t.type===2||t.type===1)?m=!0:v===1&&C===2?(this.mapPathToChange.delete(this.toKey(t)),this.coalesced.delete(d)):v===2&&C===1?d.type=0:v===1&&C===0||(d.type=C)}else m=!0;m&&(this.coalesced.add(t),this.mapPathToChange.set(this.toKey(t),t))}coalesce(){const t=[],d=[];return Array.from(this.coalesced).filter(m=>m.type!==2?(t.push(m),!1):!0).sort((m,v)=>m.path.length-v.path.length).filter(m=>d.some(v=>(0,M.isParent)(m.path,v,!n.isLinux))?!1:(d.push(m.path),!0)).concat(t)}}}),define(ee[178],te([0,1,29,8,21,28,114,2,72,9,3,85,24,63]),function(j,e,p,n,D,M,P,E,w,S,b,k,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class t extends E.Disposable{constructor(v,C,u,f){super();this.request=v,this.onDidFilesChange=C,this.onLogMessage=u,this.verboseLogging=f,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},c=>this.onDidFilesChange(c)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(t.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(c=>(0,P.parse)(c)),this.cts=new D.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const v=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const C=await y.Promises.stat(v);this._register(await this.doWatch(v,C.isDirectory()))}catch(v){v.code!=="ENOENT"?this.error(v):this.trace(v)}}async normalizePath(v){let C=v.path;try{C=await y.Promises.realpath(v.path),v.path===C&&(C=await(0,k.realcase)(v.path)??v.path),v.path!==C&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${v.path}, real: ${C})`)}catch{}return C}async doWatch(v,C){if(b.isMacintosh&&(0,M.isEqualOrParent)(v,"/Volumes/"))return this.error(`Refusing to watch ${v} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),E.Disposable.None;const u=new D.CancellationTokenSource(this.cts.token);let f=new E.DisposableStore;try{const c=(0,S.basename)(v),o=(0,p.watch)(v);f.add((0,E.toDisposable)(()=>{o.removeAllListeners(),o.close()})),this.trace(`Started watching: '${v}'`);const l=new Set;if(C)try{for(const i of await y.Promises.readdir(v))l.add(i)}catch(i){this.error(i)}const s=new Map;f.add((0,E.toDisposable)(()=>{for(const[,i]of s)i.dispose();s.clear()})),o.on("error",(i,r)=>{this.error(`Failed to watch ${v} for changes using fs.watch() (${i}, ${r})`),this.dispose()}),o.on("change",(i,r)=>{if(u.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${r}`);let a="";if(r&&(a=r.toString(),b.isMacintosh&&(a=(0,w.normalizeNFC)(a))),!(!a||i!=="change"&&i!=="rename"))if(C)if(i==="rename"){s.get(a)?.dispose();const h=setTimeout(async()=>{if(s.delete(a),a===c&&!await y.Promises.exists(v)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const I=await this.existsChildStrictCase((0,S.join)(v,a));if(u.token.isCancellationRequested)return;let R;I?l.has(a)?R=0:(R=1,l.add(a)):(l.delete(a),R=2),this.onFileChange({path:(0,S.join)(this.request.path,a),type:R})},t.FILE_DELETE_HANDLER_DELAY);s.set(a,(0,E.toDisposable)(()=>clearTimeout(h)))}else{let h;l.has(a)?h=0:(h=1,l.add(a)),this.onFileChange({path:(0,S.join)(this.request.path,a),type:h})}else if(i==="rename"||a!==c){const h=setTimeout(async()=>{const I=await y.Promises.exists(v);u.token.isCancellationRequested||(I?(this.onFileChange({path:this.request.path,type:0},!0),f.add(await this.doWatch(v,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},t.FILE_DELETE_HANDLER_DELAY);f.clear(),f.add((0,E.toDisposable)(()=>clearTimeout(h)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(c){await y.Promises.exists(v)&&!u.token.isCancellationRequested&&this.error(`Failed to watch ${v} for changes using fs.watch() (${c.toString()})`)}return(0,E.toDisposable)(()=>{u.dispose(!0),f.dispose()})}async onFileChange(v,C=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`),!C&&this.excludes.some(u=>u(v.path))?this.verboseLogging&&this.trace(` >> ignored ${v.path}`):this.fileChangesBuffer.push(v);try{await this.fileChangesDelayer.trigger(async()=>{const u=this.fileChangesBuffer;this.fileChangesBuffer=[];const f=(0,g.coalesceEvents)(u);if(f.length>0){if(this.verboseLogging)for(const o of f)this.trace(`>> normalized ${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`);this.throttledFileChangesWorker.work(f)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(v){if(b.isLinux)return y.Promises.exists(v);try{const C=(0,S.basename)(v);return(await y.Promises.readdir((0,S.dirname)(v))).some(f=>f===C)}catch(C){return this.trace(C),!1}}setVerboseLogging(v){this.verboseLogging=v}error(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${v}`})}warn(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${v}`})}trace(v){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${v}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=t,t.FILE_DELETE_HANDLER_DELAY=100,t.FILE_CHANGES_HANDLER_DELAY=50;async function d(m,v,C,u,f=512){const c=await y.Promises.open(m,"r"),o=Buffer.allocUnsafe(f),l=new D.CancellationTokenSource(u);let s,i=!1;const r={path:m,excludes:[],recursive:!1},a=new t(r,h=>{(async()=>{for(const{type:I}of h)if(I===0){if(i)return;i=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:R}=await y.Promises.read(c,o,0,f,null);if(!R||l.token.isCancellationRequested)break;v(o.slice(0,R))}}catch(R){s=new Error(R),l.dispose(!0)}finally{i=!1}}})()});return await a.ready,C(),new Promise((h,I)=>{l.token.onCancellationRequested(async()=>{a.dispose();try{await y.Promises.close(c)}catch(R){s=new Error(R)}s?I(s):h()})})}e.watchFileContents=d}),define(ee[179],te([0,1,27,4,2,3,178]),function(j,e,p,n,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class E extends D.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new n.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=n.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(S){const b=this.normalizeRequests(S),k=b.filter(g=>{const t=this.watchers.get(g.path);return t?!(0,p.equals)(t.request.excludes,g.excludes):!0}),y=Array.from(this.watchers.values()).filter(({request:g})=>!b.find(t=>t.path===g.path&&(0,p.equals)(t.excludes,g.excludes))).map(({request:g})=>g.path);k.length&&this.trace(`Request to start watching: ${k.map(g=>`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"})`).join(",")}`),y.length&&this.trace(`Request to stop watching: ${y.join(",")}`);for(const g of y)this.stopWatching(g);for(const g of k)this.startWatching(g)}startWatching(S){const b=new P.NodeJSFileWatcherLibrary(S,y=>this._onDidChangeFile.fire(y),y=>this._onDidLogMessage.fire(y),this.verboseLogging),k={request:S,instance:b};this.watchers.set(S.path,k)}async stop(){for(const[S]of this.watchers)this.stopWatching(S);this.watchers.clear()}stopWatching(S){const b=this.watchers.get(S);b&&(this.watchers.delete(S),b.instance.dispose())}normalizeRequests(S){const b=new Map;for(const k of S){const y=M.isLinux?k.path:k.path.toLowerCase();b.set(y,k)}return Array.from(b.values())}async setVerboseLogging(S){this.verboseLogging=S;for(const[,b]of this.watchers)b.instance.setVerboseLogging(S)}trace(S){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(S)})}toMessage(S,b){return b?`[File Watcher (node.js)] ${S} (path: ${b.request.path})`:`[File Watcher (node.js)] ${S}`}}e.NodeJSWatcher=E}),define(ee[180],te([0,1,63,179]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends p.AbstractNonRecursiveWatcherClient{constructor(P,E,w){super(P,E,w);this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(ee[181],te([0,1,10,37,136,63]),function(j,e,p,n,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class P extends M.AbstractUniversalWatcherClient{constructor(w,S,b){super(w,S,b);this.init()}createWatcher(w){const S=w.add(new D.Client(p.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(S.onDidProcessExit(({code:b,signal:k})=>this.onError(`terminated by itself with code ${b}, signal: ${k}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(S.getChannel("watcher")))}}e.UniversalWatcherClient=P}),define(ee[76],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...D){this._entries=new Map;for(let[M,P]of D)this.set(M,P)}set(D,M){const P=this._entries.get(D);return this._entries.set(D,M),P}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=p}),define(ee[182],te([0,1,8,15,62,172,5,76]),function(j,e,p,n,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const w=!1;class S extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class b{constructor(t=new E.ServiceCollection,d=!1,m){this._activeInstantiations=new Set,this._services=t,this._strict=d,this._parent=m,this._services.set(P.IInstantiationService,this)}createChild(t){return new b(t,this._strict,this)}invokeFunction(t,...d){let m=y.traceInvocation(t),v=!1;try{return t({get:u=>{if(v)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(u,m);if(!f)throw new Error(`[invokeFunction] unknown service '${u}'`);return f}},...d)}finally{v=!0,m.stop()}}createInstance(t,...d){let m,v;return t instanceof D.SyncDescriptor?(m=y.traceCreation(t.ctor),v=this._createInstance(t.ctor,t.staticArguments.concat(d),m)):(m=y.traceCreation(t),v=this._createInstance(t,d,m)),m.stop(),v}_createInstance(t,d=[],m){let v=P._util.getServiceDependencies(t).sort((f,c)=>f.index-c.index),C=[];for(const f of v){let c=this._getOrCreateServiceInstance(f.id,m);if(!c&&this._strict&&!f.optional)throw new Error(`[createInstance] ${t.name} depends on UNKNOWN service ${f.id}.`);C.push(c)}let u=v.length>0?v[0].index:d.length;if(d.length!==u){console.warn(`[createInstance] First service dependency of ${t.name} at position ${u+1} conflicts with ${d.length} static arguments`);let f=u-d.length;f>0?d=d.concat(new Array(f)):d=d.slice(0,u)}return new t(...[...d,...C])}_setServiceInstance(t,d){if(this._services.get(t)instanceof D.SyncDescriptor)this._services.set(t,d);else if(this._parent)this._parent._setServiceInstance(t,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let d=this._services.get(t);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):d}_getOrCreateServiceInstance(t,d){let m=this._getServiceInstanceOrDescriptor(t);return m instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,m,d.branch(t,!0)):(d.branch(t,!1),m)}_safeCreateAndCacheServiceInstance(t,d,m){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,d,m)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,d,m){const v=new M.Graph(f=>f.id.toString());let C=0;const u=[{id:t,desc:d,_trace:m}];for(;u.length;){const f=u.pop();if(v.lookupOrInsertNode(f),C++>1e3)throw new S(v);for(let c of P._util.getServiceDependencies(f.desc.ctor)){let o=this._getServiceInstanceOrDescriptor(c.id);if(!o&&!c.optional&&console.warn(`[createInstance] ${t} depends on ${c.id} which is NOT registered.`),o instanceof D.SyncDescriptor){const l={id:c.id,desc:o,_trace:f._trace.branch(c.id,!0)};v.insertEdge(f,l),u.push(l)}}}for(;;){const f=v.roots();if(f.length===0){if(!v.isEmpty())throw new S(v);break}for(const{data:c}of f){if(this._getServiceInstanceOrDescriptor(c.id)instanceof D.SyncDescriptor){const l=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,l)}v.removeNode(c)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,d,m=[],v,C){if(this._services.get(t)instanceof D.SyncDescriptor)return this._createServiceInstance(d,m,v,C);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,d,m,v,C);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(t,d=[],m,v){if(m){const C=new p.IdleValue(()=>this._createInstance(t,d,v));return new Proxy(Object.create(null),{get(u,f){if(f in u)return u[f];let c=C.value,o=c[f];return typeof o!="function"||(o=o.bind(c),u[f]=o),o},set(u,f,c){return C.value[f]=c,!0}})}else return this._createInstance(t,d,v)}}e.InstantiationService=b;var k;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(k||(k={}));class y{constructor(t,d){this.type=t,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return w?new y(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):y._None}static traceCreation(t){return w?new y(0,t.name):y._None}branch(t,d){let m=new y(2,t.toString());return this._dep.push([t,d,m]),m}stop(){let t=Date.now()-this._start;y._totals+=t;let d=!1;function m(C,u){let f=[],c=new Array(C+1).join("	");for(const[o,l,s]of u._dep)if(l&&s){d=!0,f.push(`${c}CREATES -> ${o}`);let i=m(C+1,s);i&&f.push(i)}else f.push(`${c}uses -> ${o}`);return f.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(t>2||d)&&console.log(v.join(`
`))}}e.Trace=y,y._None=new class extends y{constructor(){super(-1,null)}stop(){}branch(){return this}},y._totals=0}),define(ee[183],te([0,1,15,133,59]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class M extends D.ResolvedKeybinding{constructor(E,w){super();if(w.length===0)throw(0,p.illegalArgument)("parts");this._os=E,this._parts=w}getLabel(){return n.UILabelProvider.toLabel(this._os,this._parts,E=>this._getLabel(E))}getAriaLabel(){return n.AriaLabelProvider.toLabel(this._os,this._parts,E=>this._getAriaLabel(E))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:n.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,E=>this._getElectronAccelerator(E))}getUserSettingsLabel(){return n.UserSettingsLabelProvider.toLabel(this._os,this._parts,E=>this._getUserSettingsLabel(E))}isWYSIWYG(){return this._parts.every(E=>this._isWYSIWYG(E))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(E=>this._getPart(E))}_getPart(E){return new D.ResolvedKeybindingPart(E.ctrlKey,E.shiftKey,E.altKey,E.metaKey,this._getLabel(E),this._getAriaLabel(E))}getDispatchParts(){return this._parts.map(E=>this._getDispatchPart(E))}getSingleModifierDispatchParts(){return this._parts.map(E=>this._getSingleModifierDispatchPart(E))}}e.BaseResolvedKeybinding=M}),define(ee[184],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class p{constructor(M,P,E,w,S,b,k){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=M,this.keypressParts=M?n(M.getDispatchParts()):[],M&&this.keypressParts.length===0&&(this.keypressParts=n(M.getSingleModifierDispatchParts())),this.bubble=P?P.charCodeAt(0)===94:!1,this.command=this.bubble?P.substr(1):P,this.commandArgs=E,this.when=w,this.isDefault=S,this.extensionId=b,this.isBuiltinExtension=k}}e.ResolvedKeybindingItem=p;function n(D){let M=[];for(let P=0,E=D.length;P<E;P++){const w=D[P];if(!w)return M;M.push(w)}return M}e.removeElementsAfterNulls=n}),define(ee[185],te([0,1,82,59,183,184]),function(j,e,p,n,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class P extends D.BaseResolvedKeybinding{constructor(w,S){super(S,w.parts)}_keyCodeToUILabel(w){if(this._os===2)switch(w){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return p.KeyCodeUtils.toString(w)}_getLabel(w){return w.isDuplicateModifierCase()?"":this._keyCodeToUILabel(w.keyCode)}_getAriaLabel(w){return w.isDuplicateModifierCase()?"":p.KeyCodeUtils.toString(w.keyCode)}_getElectronAccelerator(w){return p.KeyCodeUtils.toElectronAccelerator(w.keyCode)}_getUserSettingsLabel(w){if(w.isDuplicateModifierCase())return"";const S=p.KeyCodeUtils.toUserSettingsUS(w.keyCode);return S&&S.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(w){return P.getDispatchStr(w)}static getDispatchStr(w){if(w.isModifierKey())return null;let S="";return w.ctrlKey&&(S+="ctrl+"),w.shiftKey&&(S+="shift+"),w.altKey&&(S+="alt+"),w.metaKey&&(S+="meta+"),S+=p.KeyCodeUtils.toString(w.keyCode),S}_getSingleModifierDispatchPart(w){return w.keyCode===5&&!w.shiftKey&&!w.altKey&&!w.metaKey?"ctrl":w.keyCode===4&&!w.ctrlKey&&!w.altKey&&!w.metaKey?"shift":w.keyCode===6&&!w.ctrlKey&&!w.shiftKey&&!w.metaKey?"alt":w.keyCode===57&&!w.ctrlKey&&!w.shiftKey&&!w.altKey?"meta":null}static _scanCodeToKeyCode(w){const S=p.IMMUTABLE_CODE_TO_KEY_CODE[w];if(S!==-1)return S;switch(w){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(w){if(!w)return null;if(w instanceof n.SimpleKeybinding)return w;const S=this._scanCodeToKeyCode(w.scanCode);return S===0?null:new n.SimpleKeybinding(w.ctrlKey,w.shiftKey,w.altKey,w.metaKey,S)}static resolveUserBinding(w,S){const b=(0,M.removeElementsAfterNulls)(w.map(k=>this._resolveSimpleUserBinding(k)));return b.length>0?[new P(new n.ChordKeybinding(b),S)]:[]}}e.USLayoutResolvedKeybinding=P}),define(ee[186],te([0,1,8]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function n(D,M){if(D.length===0)return Promise.resolve(!1);const P=[];let E=!1;for(let w of D){if(w===!0)return Promise.resolve(!0);(0,p.isThenable)(w)&&P.push(w.then(S=>{S&&(E=!0)},S=>{M(S),E=!0}))}return p.Promises.settled(P).then(()=>E)}e.handleVetos=n}),define(ee[6],te([0,1,39,4,2,3,5]),function(j,e,p,n,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,P.createDecorator)("logService"),e.ILoggerService=(0,P.createDecorator)("loggerService");function E(){return new Date().toISOString()}var w;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;function S(l,s,i){switch(s){case w.Trace:l.trace(i);break;case w.Debug:l.debug(i);break;case w.Info:l.info(i);break;case w.Warning:l.warn(i);break;case w.Error:l.error(i);break;case w.Critical:l.critical(i);break;default:throw new Error("Invalid log level")}}e.log=S;function b(l){let s="";for(let i=0;i<l.length;i++){let r=l[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}s+=(i>0?" ":"")+r}return s}e.format=b;class k extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class y extends k{constructor(s){super();this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...i){this.checkLogLevel(w.Trace)&&this.log(w.Trace,b([s,...i]))}debug(s,...i){this.checkLogLevel(w.Debug)&&this.log(w.Debug,b([s,...i]))}info(s,...i){this.checkLogLevel(w.Info)&&this.log(w.Info,b([s,...i]))}warn(s,...i){this.checkLogLevel(w.Warning)&&this.log(w.Warning,b([s,...i]))}error(s,...i){if(this.checkLogLevel(w.Error))if(s instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=s.stack,this.log(w.Error,b(r))}else this.log(w.Error,b([s,...i]))}critical(s,...i){this.checkLogLevel(w.Critical)&&this.log(w.Critical,b([s,...i]))}flush(){}}e.AbstractMessageLogger=y;class g extends k{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!M.isWindows}trace(s,...i){this.getLevel()<=w.Trace&&(this.useColors?console.log(`[90m[main ${E()}][0m`,s,...i):console.log(`[main ${E()}]`,s,...i))}debug(s,...i){this.getLevel()<=w.Debug&&(this.useColors?console.log(`[90m[main ${E()}][0m`,s,...i):console.log(`[main ${E()}]`,s,...i))}info(s,...i){this.getLevel()<=w.Info&&(this.useColors?console.log(`[90m[main ${E()}][0m`,s,...i):console.log(`[main ${E()}]`,s,...i))}warn(s,...i){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`[93m[main ${E()}][0m`,s,...i):console.warn(`[main ${E()}]`,s,...i))}error(s,...i){this.getLevel()<=w.Error&&(this.useColors?console.error(`[91m[main ${E()}][0m`,s,...i):console.error(`[main ${E()}]`,s,...i))}critical(s,...i){this.getLevel()<=w.Critical&&(this.useColors?console.error(`[90m[main ${E()}][0m`,s,...i):console.error(`[main ${E()}]`,s,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class t extends k{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...i){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",s,...i)}debug(s,...i){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...i)}info(s,...i){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",s,...i)}warn(s,...i){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",s,...i)}error(s,...i){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",s,...i)}critical(s,...i){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...i)}dispose(){}flush(){}}e.ConsoleLogger=t;class d extends k{constructor(s,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(i)}trace(s,...i){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(s),...i])}debug(s,...i){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(s),...i])}info(s,...i){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(s),...i])}warn(s,...i){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(s),...i])}error(s,...i){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(s),...i])}critical(s,...i){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(s),...i])}extractMessage(s){return typeof s=="string"?s:(0,p.toErrorMessage)(s,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class m extends k{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const i of this.logServices)i.setLevel(s);super.setLevel(s)}trace(s,...i){for(const r of this.logServices)r.trace(s,...i)}debug(s,...i){for(const r of this.logServices)r.debug(s,...i)}info(s,...i){for(const r of this.logServices)r.info(s,...i)}warn(s,...i){for(const r of this.logServices)r.warn(s,...i)}error(s,...i){for(const r of this.logServices)r.error(s,...i)}critical(s,...i){for(const r of this.logServices)r.critical(s,...i)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=m;class v extends D.Disposable{constructor(s){super();this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...i){this.logger.trace(s,...i)}debug(s,...i){this.logger.debug(s,...i)}info(s,...i){this.logger.info(s,...i)}warn(s,...i){this.logger.warn(s,...i)}error(s,...i){this.logger.error(s,...i)}critical(s,...i){this.logger.critical(s,...i)}flush(){this.logger.flush()}}e.LogService=v;class C extends D.Disposable{constructor(s,i){super();this.logLevel=s,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(r))}))}getLogger(s){return this.loggers.get(s.toString())}createLogger(s,i){let r=this.loggers.get(s.toString());return r||(r=this.doCreateLogger(s,i?.always?w.Trace:this.logLevel,i),this.loggers.set(s.toString(),r),i?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(s=>s.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=C;class u{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(s){}getLevel(){return w.Info}trace(s,...i){}debug(s,...i){}info(s,...i){}warn(s,...i){}error(s,...i){}critical(s,...i){}dispose(){}flush(){}}e.NullLogService=u;function f(l){if(l.verbose)return w.Trace;if(typeof l.logLevel=="string"){const s=c(l.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=f;function c(l){switch(l){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=c;function o(l){switch(l){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=o});var ne=this&&this.__param||function(j,e){return function(p,n){e(p,n,j)}};define(ee[95],te([0,1,173,171,4,2,6,3,48,5]),function(j,e,p,n,D,M,P,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsMainService=e.ICredentialsMainService=void 0,e.ICredentialsMainService=(0,S.createDecorator)("credentialsMainService");let b=class ft extends M.Disposable{constructor(y,g){super();this.logService=y,this.environmentMainService=g,this._onDidChangePassword=this._register(new D.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(y,g){const t=await this.withKeytar(),d=await t.getPassword(y,g);if(d)try{let{content:m,hasNextChunk:v}=JSON.parse(d);if(!m||!v)return d;let C=1;for(;v;){const u=await t.getPassword(y,`${g}-${C}`),f=JSON.parse(u);m+=f.content,v=f.hasNextChunk,C++}return m}catch{return d}return d}async setPassword(y,g,t){const d=await this.withKeytar(),m=3,v=async(C,u,f)=>{let c=0,o;for(;c<m;)try{await d.setPassword(C,u,f);return}catch(l){o=l,this.logService.warn("Error attempting to set a password: ",l),c++,await new Promise(s=>setTimeout(s,200))}throw o};if(E.isWindows&&t.length>ft.MAX_PASSWORD_LENGTH){let C=0,u=0,f=!0;for(;f;){const c=t.substring(C,C+ft.PASSWORD_CHUNK_SIZE);C+=ft.PASSWORD_CHUNK_SIZE,f=t.length-C>0;const o={content:c,hasNextChunk:f};await v(y,u?`${g}-${u}`:g,JSON.stringify(o)),u++}}else await v(y,g,t);this._onDidChangePassword.fire({service:y,account:g})}async deletePassword(y,g){const d=await(await this.withKeytar()).deletePassword(y,g);return d&&this._onDidChangePassword.fire({service:y,account:g}),d}async findPassword(y){return(await this.withKeytar()).findPassword(y)}async findCredentials(y){return(await this.withKeytar()).findCredentials(y)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((y,g)=>{j(["keytar"],y,g)})}};b.MAX_PASSWORD_LENGTH=2500,b.PASSWORD_CHUNK_SIZE=b.MAX_PASSWORD_LENGTH-100,b=de([ne(0,P.ILogService),ne(1,w.INativeEnvironmentService)],b),e.CredentialsMainService=b,(0,n.registerSingleton)(p.ICredentialsService,b,!0)}),define(ee[187],te([0,1,27,8,15,4,2,9,63,6]),function(j,e,p,n,D,M,P,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends P.Disposable{constructor(y,g){super();this.logService=y,this.options=g,this._onDidChangeFile=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(y,g){return g.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(y,g):this.watchNonRecursive(y,g)}watchUniversal(y,g){const t={path:this.toFilePath(y),excludes:g.excludes,recursive:g.recursive},d=(0,p.insert)(this.universalPathsToWatch,t);return this.refreshUniversalWatchers(),(0,P.toDisposable)(()=>{d(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(y=>(0,D.onUnexpectedError)(y))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(g=>this._onDidChangeFile.fire((0,w.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===S.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)})));const y=this.options?.watcher?.recursive?.usePolling;if(y===!0)for(const g of this.universalPathsToWatch)(0,w.isRecursiveWatchRequest)(g)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const g of this.universalPathsToWatch)(0,w.isRecursiveWatchRequest)(g)&&y.includes(g.path)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(y,g){const t={path:this.toFilePath(y),excludes:g.excludes,recursive:!1},d=(0,p.insert)(this.nonRecursivePathsToWatch,t);return this.refreshNonRecursiveWatchers(),(0,P.toDisposable)(()=>{d(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(y=>(0,D.onUnexpectedError)(y))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(y=>this._onDidChangeFile.fire((0,w.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===S.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(y){y.type==="error"&&this._onDidWatchError.fire(y.message),this.logService[y.type](y.message)}toFilePath(y){return(0,E.normalize)(y.fsPath)}}e.AbstractDiskFileSystemProvider=b}),define(ee[188],te([0,1,27,8,17,21,4,71,70,2,35,10,64,16,51,146,18,94,6]),function(j,e,p,n,D,M,P,E,w,S,b,k,y,g,t,d,m,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let u=class extends S.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new P.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new P.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new P.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new P.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new P.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new P.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(c,o){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${c}`);const l=new S.DisposableStore;return this.provider.set(c,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:o}),l.add(o.onDidChangeFile(s=>this._onDidFilesChange.fire(new m.FileChangesEvent(s,!this.isPathCaseSensitive(o))))),typeof o.onDidWatchError=="function"&&l.add(o.onDidWatchError(s=>this._onDidWatchError.fire(new Error(s)))),l.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:c}))),(0,S.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:o}),this.provider.delete(c),(0,S.dispose)(l)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(l){o.push(l)}}),!this.provider.has(c)&&await n.Promises.settled(o)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,o){const l=this.provider.get(c.scheme);return!!(l&&l.capabilities&o)}listCapabilities(){return w.Iterable.map(this.provider,([c,o])=>({scheme:c,capabilities:o.capabilities}))}async withProvider(c){if(!(0,g.isAbsolutePath)(c))throw new m.FileOperationError((0,d.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const o=this.provider.get(c.scheme);if(!o){const l=new Error;throw l.name="ENOPRO",l.message=(0,d.localize)(1,null,c.toString()),l}return o}async withReadProvider(c){const o=await this.withProvider(c);if((0,m.hasOpenReadWriteCloseCapability)(o)||(0,m.hasReadWriteCapability)(o)||(0,m.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const o=await this.withProvider(c);if((0,m.hasOpenReadWriteCloseCapability)(o)||(0,m.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,o){try{return await this.doResolveFile(c,o)}catch(l){throw(0,m.toFileSystemProviderErrorCode)(l)===m.FileSystemProviderErrorCode.FileNotFound?new m.FileOperationError((0,d.localize)(2,null,this.resourceForError(c)),1):(0,m.ensureFileSystemProviderError)(l)}}async doResolveFile(c,o){const l=await this.withProvider(c),s=this.isPathCaseSensitive(l),i=o?.resolveTo,r=o?.resolveSingleChildDescendants,a=o?.resolveMetadata,h=await l.stat(c);let I;return this.toFileStat(l,c,h,void 0,!!a,(R,L)=>(I||(I=b.TernarySearchTree.forUris(()=>!s),I.set(c,!0),i&&I.fill(!0,i)),I.get(R.resource)||I.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&r?L===1:!1))}async toFileStat(c,o,l,s,i,r){const{providerExtUri:a}=this.getExtUri(c),h={resource:o,name:a.basename(o),isFile:(l.type&m.FileType.File)!=0,isDirectory:(l.type&m.FileType.Directory)!=0,isSymbolicLink:(l.type&m.FileType.SymbolicLink)!=0,mtime:l.mtime,ctime:l.ctime,size:l.size,readonly:Boolean((l.permissions??0)&m.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,m.etag)({mtime:l.mtime,size:l.size})};if(h.isDirectory&&r(h,s)){try{const I=await c.readdir(o),R=await n.Promises.settled(I.map(async([L,W])=>{try{const N=a.joinPath(o,L),J=i?await c.stat(N):{type:W};return await this.toFileStat(c,N,J,I.length,i,r)}catch(N){return this.logService.trace(N),null}}));h.children=(0,p.coalesce)(R)}catch(I){this.logService.trace(I),h.children=[]}return h}return h}async resolveAll(c){return n.Promises.settled(c.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(l){return this.logService.trace(l),{stat:void 0,success:!1}}}))}async exists(c){const o=await this.withProvider(c);try{return!!await o.stat(c)}catch{return!1}}async canCreateFile(c,o){try{await this.doValidateCreateFile(c,o)}catch(l){return l}return!0}async doValidateCreateFile(c,o){if(!o?.overwrite&&await this.exists(c))throw new m.FileOperationError((0,d.localize)(3,null,this.resourceForError(c)),3,o)}async createFile(c,o=D.VSBuffer.fromString(""),l){await this.doValidateCreateFile(c,l);const s=await this.writeFile(c,o);return this._onDidRunOperation.fire(new m.FileOperationEvent(c,0,s)),s}async writeFile(c,o,l){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:i}=this.getExtUri(s);try{await this.validateWriteFile(s,c,l)||await this.mkdirp(s,i.dirname(c));let a;if((0,m.hasReadWriteCapability)(s)&&!(o instanceof D.VSBuffer))if((0,t.isReadableStream)(o)){const h=await(0,t.peekStream)(o,3);h.ended?a=D.VSBuffer.concat(h.buffer):a=h}else a=(0,t.peekReadable)(o,h=>D.VSBuffer.concat(h),3);else a=o;!(0,m.hasOpenReadWriteCloseCapability)(s)||(0,m.hasReadWriteCapability)(s)&&a instanceof D.VSBuffer?await this.doWriteUnbuffered(s,c,l,a):await this.doWriteBuffered(s,c,l,a instanceof D.VSBuffer?(0,D.bufferToReadable)(a):a)}catch(r){throw new m.FileOperationError((0,d.localize)(4,null,this.resourceForError(c),(0,m.ensureFileSystemProviderError)(r).toString()),(0,m.toFileOperationResult)(r),l)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,o,l){if(!!l?.unlock&&!(c.capabilities&8192))throw new Error((0,d.localize)(5,null,this.resourceForError(o)));let i;try{i=await c.stat(o)}catch{return}if((i.type&m.FileType.Directory)!=0)throw new m.FileOperationError((0,d.localize)(6,null,this.resourceForError(o)),0,l);if(this.throwIfFileIsReadonly(o,i),typeof l?.mtime=="number"&&typeof l.etag=="string"&&l.etag!==m.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&l.mtime<i.mtime&&l.etag!==(0,m.etag)({mtime:l.mtime,size:i.size}))throw new m.FileOperationError((0,d.localize)(7,null),3,l);return i}async readFile(c,o,l){const s=await this.withReadProvider(c);return o?.atomic?this.doReadFileAtomic(s,c,o,l):this.doReadFile(s,c,o,l)}async doReadFileAtomic(c,o,l,s){return new Promise((i,r)=>{this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(c,o,l,s);i(a)}catch(a){r(a)}})})}async doReadFile(c,o,l,s){const i=await this.doReadFileStream(c,o,{...l,preferUnbuffered:!0},s);return{...i,value:await(0,D.streamToBuffer)(i.value)}}async readFileStream(c,o,l){const s=await this.withReadProvider(c);return this.doReadFileStream(s,c,o,l)}async doReadFileStream(c,o,l,s){const i=new M.CancellationTokenSource(s),r=this.validateReadFile(o,l).then(h=>h,h=>{throw i.cancel(),h});let a;try{return typeof l?.etag=="string"&&l.etag!==m.ETAG_DISABLED&&await r,l?.atomic&&(0,m.hasFileAtomicReadCapability)(c)||!((0,m.hasOpenReadWriteCloseCapability)(c)||(0,m.hasFileReadStreamCapability)(c))||(0,m.hasReadWriteCapability)(c)&&l?.preferUnbuffered?a=this.readFileUnbuffered(c,o,l):(0,m.hasFileReadStreamCapability)(c)?a=this.readFileStreamed(c,o,i.token,l):a=this.readFileBuffered(c,o,i.token,l),{...await r,value:a}}catch(h){a&&await(0,t.consumeStream)(a);const I=(0,d.localize)(8,null,this.resourceForError(o),(0,m.ensureFileSystemProviderError)(h).toString());throw h instanceof m.NotModifiedSinceFileOperationError?new m.NotModifiedSinceFileOperationError(I,h.stat,l):new m.FileOperationError(I,(0,m.toFileOperationResult)(h),l)}}readFileStreamed(c,o,l,s=Object.create(null)){const i=c.readFileStream(o,s,l);return(0,t.transform)(i,{data:r=>r instanceof D.VSBuffer?r:D.VSBuffer.wrap(r),error:r=>new m.FileOperationError((0,d.localize)(9,null,this.resourceForError(o),(0,m.ensureFileSystemProviderError)(r).toString()),(0,m.toFileOperationResult)(r),s)},r=>D.VSBuffer.concat(r))}readFileBuffered(c,o,l,s=Object.create(null)){const i=(0,D.newWriteableBufferStream)();return(0,v.readFileIntoStream)(c,o,i,r=>r,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new m.FileOperationError((0,d.localize)(10,null,this.resourceForError(o),(0,m.ensureFileSystemProviderError)(r).toString()),(0,m.toFileOperationResult)(r),s)},l),i}readFileUnbuffered(c,o,l){const s=(0,t.newWriteableStream)(i=>D.VSBuffer.concat(i));return(async()=>{try{let i;l?.atomic&&(0,m.hasFileAtomicReadCapability)(c)?i=await c.readFile(o,{atomic:!0}):i=await c.readFile(o),typeof l?.position=="number"&&(i=i.slice(l.position)),typeof l?.length=="number"&&(i=i.slice(0,l.length)),this.validateReadFileLimits(o,i.byteLength,l),s.end(D.VSBuffer.wrap(i))}catch(i){s.error(i),s.end()}})(),s}async validateReadFile(c,o){const l=await this.resolve(c,{resolveMetadata:!0});if(l.isDirectory)throw new m.FileOperationError((0,d.localize)(11,null,this.resourceForError(c)),0,o);if(typeof o?.etag=="string"&&o.etag!==m.ETAG_DISABLED&&o.etag===l.etag)throw new m.NotModifiedSinceFileOperationError((0,d.localize)(12,null),l,o);return this.validateReadFileLimits(c,l.size,o),l}validateReadFileLimits(c,o,l){if(l?.limits){let s;if(typeof l.limits.memory=="number"&&o>l.limits.memory&&(s=9),typeof l.limits.size=="number"&&o>l.limits.size&&(s=7),typeof s=="number")throw new m.FileOperationError((0,d.localize)(13,null,this.resourceForError(c)),s)}}async canMove(c,o,l){return this.doCanMoveCopy(c,o,"move",l)}async canCopy(c,o,l){return this.doCanMoveCopy(c,o,"copy",l)}async doCanMoveCopy(c,o,l,s){if(c.toString()!==o.toString())try{const i=l==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(i,c,r,o,l,s)}catch(i){return i}return!0}async move(c,o,l){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(s,c,i,o,"move",!!l),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(c,r==="move"?2:3,a)),a}async copy(c,o,l){const s=await this.withReadProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(s,c,i,o,"copy",!!l),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(c,r==="copy"?3:2,a)),a}async doMoveCopy(c,o,l,s,i,r){if(o.toString()===s.toString())return i;const{exists:a,isSameResourceWithDifferentPathCase:h}=await this.doValidateMoveCopy(c,o,l,s,i,r);if(a&&!h&&r&&await this.del(s,{recursive:!0}),await this.mkdirp(l,this.getExtUri(l).providerExtUri.dirname(s)),i==="copy"){if(c===l&&(0,m.hasFileFolderCopyCapability)(c))await c.copy(o,s,{overwrite:r});else{const I=await this.resolve(o);I.isDirectory?await this.doCopyFolder(c,I,l,s):await this.doCopyFile(c,o,l,s)}return i}else return c===l?(await c.rename(o,s,{overwrite:r}),i):(await this.doMoveCopy(c,o,l,s,"copy",r),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(c,o,l,s){if((0,m.hasOpenReadWriteCloseCapability)(c)&&(0,m.hasOpenReadWriteCloseCapability)(l))return this.doPipeBuffered(c,o,l,s);if((0,m.hasOpenReadWriteCloseCapability)(c)&&(0,m.hasReadWriteCapability)(l))return this.doPipeBufferedToUnbuffered(c,o,l,s);if((0,m.hasReadWriteCapability)(c)&&(0,m.hasOpenReadWriteCloseCapability)(l))return this.doPipeUnbufferedToBuffered(c,o,l,s);if((0,m.hasReadWriteCapability)(c)&&(0,m.hasReadWriteCapability)(l))return this.doPipeUnbuffered(c,o,l,s)}async doCopyFolder(c,o,l,s){await l.mkdir(s),Array.isArray(o.children)&&await n.Promises.settled(o.children.map(async i=>{const r=this.getExtUri(l).providerExtUri.joinPath(s,i.name);return i.isDirectory?this.doCopyFolder(c,await this.resolve(i.resource),l,r):this.doCopyFile(c,i.resource,l,r)}))}async doValidateMoveCopy(c,o,l,s,i,r){let a=!1;if(c===l){const{providerExtUri:I,isPathCaseSensitive:R}=this.getExtUri(c);if(R||(a=I.isEqual(o,s)),a&&i==="copy")throw new Error((0,d.localize)(14,null,this.resourceForError(o),this.resourceForError(s)));if(!a&&I.isEqualOrParent(s,o))throw new Error((0,d.localize)(15,null,this.resourceForError(o),this.resourceForError(s)))}const h=await this.exists(s);if(h&&!a){if(!r)throw new m.FileOperationError((0,d.localize)(16,null,this.resourceForError(o),this.resourceForError(s)),4);if(c===l){const{providerExtUri:I}=this.getExtUri(c);if(I.isEqualOrParent(o,s))throw new Error((0,d.localize)(17,null,this.resourceForError(o),this.resourceForError(s)))}}return{exists:h,isSameResourceWithDifferentPathCase:a}}getExtUri(c){const o=this.isPathCaseSensitive(c);return{providerExtUri:o?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(o,c);const l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(c,0,l)),l}async mkdirp(c,o){const l=[],{providerExtUri:s}=this.getExtUri(c);for(;!s.isEqual(o,s.dirname(o));)try{if(((await c.stat(o)).type&m.FileType.Directory)==0)throw new Error((0,d.localize)(18,null,this.resourceForError(o)));break}catch(i){if((0,m.toFileSystemProviderErrorCode)(i)!==m.FileSystemProviderErrorCode.FileNotFound)throw i;l.push(s.basename(o)),o=s.dirname(o)}for(let i=l.length-1;i>=0;i--){o=s.joinPath(o,l[i]);try{await c.mkdir(o)}catch(r){if((0,m.toFileSystemProviderErrorCode)(r)!==m.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(c,o){try{await this.doValidateDelete(c,o)}catch(l){return l}return!0}async doValidateDelete(c,o){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!o?.useTrash&&!(l.capabilities&4096))throw new Error((0,d.localize)(19,null,this.resourceForError(c)));let i;try{i=await l.stat(c)}catch{}if(i)this.throwIfFileIsReadonly(c,i);else throw new m.FileOperationError((0,d.localize)(20,null,this.resourceForError(c)),1);if(!!!o?.recursive){const a=await this.resolve(c);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,d.localize)(21,null,this.resourceForError(c)))}return l}async del(c,o){const l=await this.doValidateDelete(c,o),s=!!o?.useTrash,i=!!o?.recursive;await l.delete(c,{recursive:i,useTrash:s}),this._onDidRunOperation.fire(new m.FileOperationEvent(c,1))}watch(c,o={recursive:!1,excludes:[]}){const l=new S.DisposableStore;let s=!1,i=()=>{s=!0};return l.add((0,S.toDisposable)(()=>i())),(async()=>{try{const r=await this.doWatch(c,o);s?(0,S.dispose)(r):i=()=>(0,S.dispose)(r)}catch(r){this.logService.error(r)}})(),l}async doWatch(c,o){const l=await this.withProvider(c),s=(0,E.hash)([this.getExtUri(l).providerExtUri.getComparisonKey(c),o]);let i=this.activeWatchers.get(s);return i||(i={count:0,disposable:l.watch(c,o)},this.activeWatchers.set(s,i)),i.count+=1,(0,S.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,S.dispose)(i.disposable),this.activeWatchers.delete(s)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,S.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,o,l,s){return this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(async()=>{const i=await c.open(o,{create:!0,unlock:l?.unlock??!1});try{(0,t.isReadableStream)(s)||(0,t.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(c,i,s):await this.doWriteReadableBufferedQueued(c,i,s)}catch(r){throw(0,m.ensureFileSystemProviderError)(r)}finally{await c.close(i)}})}async doWriteStreamBufferedQueued(c,o,l){let s=0,i;if((0,t.isReadableBufferedStream)(l)){if(l.buffer.length>0){const r=D.VSBuffer.concat(l.buffer);await this.doWriteBuffer(c,o,r,r.byteLength,s,0),s+=r.byteLength}if(l.ended)return;i=l.stream}else i=l;return new Promise((r,a)=>{(0,t.listenStream)(i,{onData:async h=>{i.pause();try{await this.doWriteBuffer(c,o,h,h.byteLength,s,0)}catch(I){return a(I)}s+=h.byteLength,setTimeout(()=>i.resume())},onError:h=>a(h),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(c,o,l){let s=0,i;for(;(i=l.read())!==null;)await this.doWriteBuffer(c,o,i,i.byteLength,s,0),s+=i.byteLength}async doWriteBuffer(c,o,l,s,i,r){let a=0;for(;a<s;)a+=await c.write(o,i+a,l.buffer,r+a,s-a)}async doWriteUnbuffered(c,o,l,s){return this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,o,l,s))}async doWriteUnbufferedQueued(c,o,l,s){let i;s instanceof D.VSBuffer?i=s:(0,t.isReadableStream)(s)?i=await(0,D.streamToBuffer)(s):(0,t.isReadableBufferedStream)(s)?i=await(0,D.bufferedStreamToBuffer)(s):i=(0,D.readableToBuffer)(s),await c.writeFile(o,i.buffer,{create:!0,overwrite:!0,unlock:l?.unlock??!1})}async doPipeBuffered(c,o,l,s){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,o,l,s))}async doPipeBufferedQueued(c,o,l,s){let i,r;try{i=await c.open(o,{create:!1}),r=await l.open(s,{create:!0,unlock:!1});const a=D.VSBuffer.alloc(this.BUFFER_SIZE);let h=0,I=0,R=0;do R=await c.read(i,h,a.buffer,I,a.byteLength-I),await this.doWriteBuffer(l,r,a,R,h,I),h+=R,I+=R,I===a.byteLength&&(I=0);while(R>0)}catch(a){throw(0,m.ensureFileSystemProviderError)(a)}finally{await n.Promises.settled([typeof i=="number"?c.close(i):Promise.resolve(),typeof r=="number"?l.close(r):Promise.resolve()])}}async doPipeUnbuffered(c,o,l,s){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,o,l,s))}async doPipeUnbufferedQueued(c,o,l,s){return l.writeFile(s,await c.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,o,l,s){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,o,l,s))}async doPipeUnbufferedToBufferedQueued(c,o,l,s){const i=await l.open(s,{create:!0,unlock:!1});try{const r=await c.readFile(o);await this.doWriteBuffer(l,i,D.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,m.ensureFileSystemProviderError)(r)}finally{await l.close(i)}}async doPipeBufferedToUnbuffered(c,o,l,s){const i=await(0,D.streamToBuffer)(this.readFileBuffered(c,o,M.CancellationToken.None));await this.doWriteUnbuffered(l,s,void 0,i)}throwIfFileSystemIsReadonly(c,o){if(c.capabilities&2048)throw new m.FileOperationError((0,d.localize)(22,null,this.resourceForError(o)),6);return c}throwIfFileIsReadonly(c,o){if((o.permissions??0)&m.FilePermission.Readonly)throw new m.FileOperationError((0,d.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===k.Schemas.file?c.fsPath:c.toString(!0)}};u=de([ne(0,C.ILogService)],u),e.FileService=u}),define(ee[77],te([0,1,29,256,8,35,17,4,28,2,9,3,16,51,24,150,18,94,187,39,181,180]),function(j,e,p,n,D,M,P,E,w,S,b,k,y,g,t,d,m,v,C,u,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(p)}catch(l){console.error(`Error enabling graceful-fs: ${(0,u.toErrorMessage)(l)}`)}})();class o extends C.AbstractDiskFileSystemProvider{constructor(s,i){super(s,i);this.onDidChangeCapabilities=E.Event.None,this.resourceLocks=new M.ResourceMap(r=>y.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:i,symbolicLink:r}=await t.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(i,r),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(s){try{const i=await t.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),r=[];return await Promise.all(i.map(async a=>{try{let h;a.isSymbolicLink()?h=(await this.stat((0,y.joinPath)(s,a.name))).type:h=this.toType(a),r.push([a.name,h])}catch(h){this.logService.trace(h)}})),r}catch(i){throw this.toFileSystemProviderError(i)}}toType(s,i){let r;return i?.dangling?r=m.FileType.Unknown:s.isFile()?r=m.FileType.File:s.isDirectory()?r=m.FileType.Directory:r=m.FileType.Unknown,i&&(r|=m.FileType.SymbolicLink),r}async createResourceLock(s){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(s)})`);let i;for(;i=this.resourceLocks.get(s);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(s)})`),await i.wait();const r=new D.Barrier;return this.resourceLocks.set(s,r),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(s)})`),(0,S.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(s)})`),this.resourceLocks.delete(s),r.open()})}async readFile(s,i){let r;try{i?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(s)})`),r=await this.createResourceLock(s));const a=this.toFilePath(s);return await t.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{r?.dispose()}}readFileStream(s,i,r){const a=(0,g.newWriteableStream)(h=>P.VSBuffer.concat(h.map(I=>P.VSBuffer.wrap(I))).buffer);return(0,v.readFileIntoStream)(this,s,a,h=>h.buffer,{...i,bufferSize:256*1024},r),a}async writeFile(s,i,r){let a;try{const h=this.toFilePath(s);if(!r.create||!r.overwrite){if(await t.Promises.exists(h)){if(!r.overwrite)throw(0,m.createFileSystemProviderError)((0,d.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,m.createFileSystemProviderError)((0,d.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(s,{create:!0,unlock:r.unlock}),await this.write(a,0,i,0,i.byteLength)}catch(h){throw await this.toFileSystemProviderWriteError(s,h)}finally{typeof a=="number"&&await this.close(a)}}async open(s,i){let r;(0,m.isFileOpenForWriteOptions)(i)&&(r=await this.createResourceLock(s));let a;try{const h=this.toFilePath(s);if((0,m.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:R}=await t.SymlinkSupport.stat(h);R.mode&128||await t.Promises.chmod(h,R.mode|128)}catch(R){this.logService.trace(R)}let I;if((0,m.isFileOpenForWriteOptions)(i)){if(k.isWindows)try{await t.Promises.truncate(h,0),I="r+"}catch(R){R.code!=="ENOENT"&&this.logService.trace(R)}I||(I="w")}else I="r";a=await t.Promises.open(h,I)}catch(h){throw r?.dispose(),(0,m.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(s,h):this.toFileSystemProviderError(h)}return this.mapHandleToPos.set(a,0),(0,m.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(a,s),r&&this.mapHandleToLock.set(a,r),a}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await t.Promises.fdatasync(s)}catch(i){this.canFlush=!1,this.logService.error(i)}return await t.Promises.close(s)}catch(i){throw this.toFileSystemProviderError(i)}finally{const i=this.mapHandleToLock.get(s);i&&(this.mapHandleToLock.delete(s),i.dispose())}}async read(s,i,r,a,h){const I=this.normalizePos(s,i);let R=null;try{const{bytesRead:L}=await t.Promises.read(s,r,a,h,I);return L}catch(L){throw this.toFileSystemProviderError(L)}finally{this.updatePos(s,I,R)}}normalizePos(s,i){return i===this.mapHandleToPos.get(s)?null:i}updatePos(s,i,r){const a=this.mapHandleToPos.get(s);typeof a=="number"&&(typeof i=="number"||(typeof r=="number"?this.mapHandleToPos.set(s,a+r):this.mapHandleToPos.delete(s)))}async write(s,i,r,a,h){return(0,D.retry)(()=>this.doWrite(s,i,r,a,h),100,3)}async doWrite(s,i,r,a,h){const I=this.normalizePos(s,i);let R=null;try{const{bytesWritten:L}=await t.Promises.write(s,r,a,h,I);return L}catch(L){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),L)}finally{this.updatePos(s,I,R)}}async mkdir(s){try{await t.Promises.mkdir(this.toFilePath(s))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(s,i){try{const r=this.toFilePath(s);i.recursive?await t.Promises.rm(r,t.RimRafMode.MOVE):await t.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(s,i,r){const a=this.toFilePath(s),h=this.toFilePath(i);if(a!==h)try{await this.validateTargetDeleted(s,i,"move",r.overwrite),await t.Promises.move(a,h)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,d.localize)(2,null,(0,b.basename)(a),(0,b.basename)((0,b.dirname)(h)),I.toString()))),this.toFileSystemProviderError(I)}}async copy(s,i,r){const a=this.toFilePath(s),h=this.toFilePath(i);if(a!==h)try{await this.validateTargetDeleted(s,i,"copy",r.overwrite),await t.Promises.copy(a,h,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,d.localize)(3,null,(0,b.basename)(a),(0,b.basename)((0,b.dirname)(h)),I.toString()))),this.toFileSystemProviderError(I)}}async validateTargetDeleted(s,i,r,a){const h=this.toFilePath(s),I=this.toFilePath(i);let R=!1;if(!!(this.capabilities&1024)||(R=(0,w.isEqual)(h,I,!0)),R&&r==="copy")throw(0,m.createFileSystemProviderError)((0,d.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(!R&&await t.Promises.exists(I)){if(!a)throw(0,m.createFileSystemProviderError)((0,d.localize)(5,null),m.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}createUniversalWatcher(s,i,r){return new f.UniversalWatcherClient(a=>s(a),a=>i(a),r)}createNonRecursiveWatcher(s,i,r){return new c.NodeJSWatcherClient(a=>s(a),a=>i(a),r)}toFileSystemProviderError(s){if(s instanceof m.FileSystemProviderError)return s;let i;switch(s.code){case"ENOENT":i=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=m.FileSystemProviderErrorCode.NoPermissions;break;default:i=m.FileSystemProviderErrorCode.Unknown}return(0,m.createFileSystemProviderError)(s,i)}async toFileSystemProviderWriteError(s,i){let r=this.toFileSystemProviderError(i);if(s&&r.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await t.SymlinkSupport.stat(this.toFilePath(s));a.mode&128||(r=(0,m.createFileSystemProviderError)(i,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return r}}e.DiskFileSystemProvider=o}),define(ee[189],te([0,1,4,77,2,17,51,21]),function(j,e,p,n,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class w extends D.Disposable{constructor(k,y){super();this.provider=k,this.logService=y,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(k,y,g){const t=this.getUriTransformer(k);switch(y){case"stat":return this.stat(t,g[0]);case"readdir":return this.readdir(t,g[0]);case"open":return this.open(t,g[0],g[1]);case"close":return this.close(g[0]);case"read":return this.read(g[0],g[1],g[2]);case"readFile":return this.readFile(t,g[0],g[1]);case"write":return this.write(g[0],g[1],g[2],g[3],g[4]);case"writeFile":return this.writeFile(t,g[0],g[1],g[2]);case"rename":return this.rename(t,g[0],g[1],g[2]);case"copy":return this.copy(t,g[0],g[1],g[2]);case"mkdir":return this.mkdir(t,g[0]);case"delete":return this.delete(t,g[0],g[1]);case"watch":return this.watch(t,g[0],g[1],g[2],g[3]);case"unwatch":return this.unwatch(g[0],g[1])}throw new Error(`IPC Command ${y} not found`)}listen(k,y,g){const t=this.getUriTransformer(k);switch(y){case"fileChange":return this.onFileChange(t,g[0]);case"readFileStream":return this.onReadFileStream(t,g[0],g[1])}throw new Error(`Unknown event ${y}`)}stat(k,y){const g=this.transformIncoming(k,y,!0);return this.provider.stat(g)}readdir(k,y){const g=this.transformIncoming(k,y);return this.provider.readdir(g)}async readFile(k,y,g){const t=this.transformIncoming(k,y,!0),d=await this.provider.readFile(t,g);return M.VSBuffer.wrap(d)}onReadFileStream(k,y,g){const t=this.transformIncoming(k,y,!0),d=new E.CancellationTokenSource,m=new p.Emitter({onLastListenerRemove:()=>{d.cancel()}}),v=this.provider.readFileStream(t,g,d.token);return(0,P.listenStream)(v,{onData:C=>m.fire(M.VSBuffer.wrap(C)),onError:C=>m.fire(C),onEnd:()=>{m.fire("end"),m.dispose(),d.dispose()}}),m.event}writeFile(k,y,g,t){const d=this.transformIncoming(k,y);return this.provider.writeFile(d,g.buffer,t)}open(k,y,g){const t=this.transformIncoming(k,y,!0);return this.provider.open(t,g)}close(k){return this.provider.close(k)}async read(k,y,g){const t=M.VSBuffer.alloc(g),d=0,m=await this.provider.read(k,y,t.buffer,d,g);return[t,m]}write(k,y,g,t,d){return this.provider.write(k,y,g.buffer,t,d)}mkdir(k,y){const g=this.transformIncoming(k,y);return this.provider.mkdir(g)}delete(k,y,g){const t=this.transformIncoming(k,y);return this.provider.delete(t,g)}rename(k,y,g,t){const d=this.transformIncoming(k,y),m=this.transformIncoming(k,g);return this.provider.rename(d,m,t)}copy(k,y,g,t){const d=this.transformIncoming(k,y),m=this.transformIncoming(k,g);return this.provider.copy(d,m,t)}onFileChange(k,y){const g=new p.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(y,this.createSessionFileWatcher(k,g))},onLastListenerRemove:()=>{(0,D.dispose)(this.sessionToWatcher.get(y)),this.sessionToWatcher.delete(y)}});return g.event}async watch(k,y,g,t,d){const m=this.sessionToWatcher.get(y);if(m){const v=this.transformIncoming(k,t),C=m.watch(g,v,d);this.watchRequests.set(y+g,C)}}async unwatch(k,y){const g=k+y,t=this.watchRequests.get(g);t&&((0,D.dispose)(t),this.watchRequests.delete(g))}dispose(){super.dispose();for(const[,k]of this.watchRequests)k.dispose();this.watchRequests.clear();for(const[,k]of this.sessionToWatcher)k.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=w;class S extends D.Disposable{constructor(k,y,g,t){super();this.uriTransformer=k,this.logService=g,this.environmentService=t,this.watcherRequests=new Map,this.fileWatcher=this._register(new n.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(y)}registerListeners(k){const y=this._register(new p.Emitter);this._register(y.event(g=>{k.fire(g.map(t=>({resource:this.uriTransformer.transformOutgoingURI(t.resource),type:t.type})))})),this._register(this.fileWatcher.onDidChangeFile(g=>y.fire(g))),this._register(this.fileWatcher.onDidWatchError(g=>k.fire(g)))}getRecursiveWatcherOptions(k){}getExtraExcludes(k){}watch(k,y,g){const t=this.getExtraExcludes(this.environmentService);return Array.isArray(t)&&(g.excludes=[...g.excludes,...t]),this.watcherRequests.set(k,this.fileWatcher.watch(y,g)),(0,D.toDisposable)(()=>{(0,D.dispose)(this.watcherRequests.get(k)),this.watcherRequests.delete(k)})}dispose(){super.dispose();for(const[,k]of this.watcherRequests)k.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=S}),define(ee[190],te([0,1,14,149,3,7,18,9,189,115]),function(j,e,p,n,D,M,P,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class b extends w.AbstractDiskFileSystemProviderChannel{constructor(g,t,d){super(g,t);this.environmentService=d}getUriTransformer(g){return S.DefaultURITransformer}transformIncoming(g,t){return M.URI.revive(t)}async delete(g,t,d){if(!d.useTrash)return super.delete(g,t,d);const m=this.transformIncoming(g,t),v=(0,E.normalize)(m.fsPath);try{await p.shell.trashItem(v)}catch{throw(0,P.createFileSystemProviderError)(D.isWindows?(0,n.localize)(0,null,(0,E.basename)(v)):(0,n.localize)(1,null,(0,E.basename)(v)),P.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(g,t){return new k(g,t,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=b;class k extends w.AbstractSessionFileWatcher{watch(g,t,d){if(d.recursive)throw(0,P.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",P.FileSystemProviderErrorCode.Unavailable);return super.watch(g,t,d)}}}),define(ee[96],te([0,1,6]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function n(M,P){switch(P){case p.LogLevel.Trace:return M.trace;case p.LogLevel.Debug:return M.debug;case p.LogLevel.Info:return M.info;case p.LogLevel.Warning:return M.warn;case p.LogLevel.Error:return M.error;case p.LogLevel.Critical:return M.critical;default:throw new Error("Invalid log level")}}class D extends p.AbstractLogger{constructor(P=p.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(P),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}set logger(P){this._logger=P;for(const{level:E,args:w}of this.buffer)n(P,E).apply(P,w);this.buffer=[]}_log(P,...E){this._logger?n(this._logger,P).apply(this._logger,E):this.getLevel()<=P&&this.buffer.push({level:P,args:E})}trace(P,...E){this._log(p.LogLevel.Trace,P,...E)}debug(P,...E){this._log(p.LogLevel.Debug,P,...E)}info(P,...E){this._log(p.LogLevel.Info,P,...E)}warn(P,...E){this._log(p.LogLevel.Warning,P,...E)}error(P,...E){this._log(p.LogLevel.Error,P,...E)}critical(P,...E){this._log(p.LogLevel.Critical,P,...E)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=D}),define(ee[191],te([0,1,8,17,16,18,5,96,6]),function(j,e,p,n,D,M,P,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const S=5*M.ByteSize.MB;let b=class extends w.AbstractLogger{constructor(g,t,d,m,v){super();this.name=g,this.resource=t,this.donotUseFormatters=m,this.fileService=v,this.backupIndex=1,this.setLevel(d),this.queue=this._register(new p.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=w.LogLevel.Trace&&this._log(w.LogLevel.Trace,(0,w.format)(arguments))}debug(){this.getLevel()<=w.LogLevel.Debug&&this._log(w.LogLevel.Debug,(0,w.format)(arguments))}info(){this.getLevel()<=w.LogLevel.Info&&this._log(w.LogLevel.Info,(0,w.format)(arguments))}warn(){this.getLevel()<=w.LogLevel.Warning&&this._log(w.LogLevel.Warning,(0,w.format)(arguments))}error(){if(this.getLevel()<=w.LogLevel.Error){const g=arguments[0];if(g instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=g.stack,this._log(w.LogLevel.Error,(0,w.format)(t))}else this._log(w.LogLevel.Error,(0,w.format)(arguments))}}critical(){this.getLevel()<=w.LogLevel.Critical&&this._log(w.LogLevel.Critical,(0,w.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(g){if(g.fileOperationResult!==3)throw g}}_log(g,t){this.queue.queue(async()=>{await this.initializePromise;let d=await this.loadContent();d.length>S&&(await this.fileService.writeFile(this.getBackupResource(),n.VSBuffer.fromString(d)),d=""),this.donotUseFormatters?d+=t:d+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(g)}] ${t}
`,await this.fileService.writeFile(this.resource,n.VSBuffer.fromString(d))})}getCurrentTimestamp(){const g=m=>m<10?`0${m}`:m,t=m=>m<10?`00${m}`:m<100?`0${m}`:m,d=new Date;return`${d.getFullYear()}-${g(d.getMonth()+1)}-${g(d.getDate())} ${g(d.getHours())}:${g(d.getMinutes())}:${g(d.getSeconds())}.${t(d.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,D.joinPath)((0,D.dirname)(this.resource),`${(0,D.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(g){switch(g){case w.LogLevel.Critical:return"critical";case w.LogLevel.Debug:return"debug";case w.LogLevel.Error:return"error";case w.LogLevel.Info:return"info";case w.LogLevel.Trace:return"trace";case w.LogLevel.Warning:return"warning"}return""}};b=de([ne(4,M.IFileService)],b),e.FileLogger=b;let k=class extends w.AbstractLoggerService{constructor(g,t,d){super(g.getLevel(),g.onDidChangeLogLevel);this.instantiationService=t,this.fileService=d}doCreateLogger(g,t,d){const m=new E.BufferLogService(t);return(0,M.whenProviderRegistered)(g,this.fileService).then(()=>m.logger=this.instantiationService.createInstance(b,d?.name||(0,D.basename)(g),g,m.getLevel(),!!d?.donotUseFormatters)),m}};k=de([ne(0,w.ILogService),ne(1,P.IInstantiationService),ne(2,M.IFileService)],k),e.FileLoggerService=k}),define(ee[192],te([0,1,4,7,6]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class M{constructor(y){this.service=y,this.onDidChangeLogLevel=p.Event.buffer(y.onDidChangeLogLevel,!0)}listen(y,g){switch(g){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${g}`)}async call(y,g,t){switch(g){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${g}`)}}e.LogLevelChannel=M;class P{constructor(y){this.channel=y}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(y){P.setLevel(this.channel,y)}static setLevel(y,g){return y.call("setLevel",g)}}e.LogLevelChannelClient=P;class E{constructor(y){this.loggerService=y,this.loggers=new Map}listen(y,g){throw new Error(`Event not found: ${g}`)}async call(y,g,t){switch(g){case"createLogger":this.createLogger(n.URI.revive(t[0]),t[1]);return;case"log":return this.log(n.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${g}`)}createLogger(y,g){this.loggers.set(y.toString(),this.loggerService.createLogger(y,g))}consoleLog(y,g){let t=console.log;switch(y){case D.LogLevel.Error:t=console.error;break;case D.LogLevel.Warning:t=console.warn;break;case D.LogLevel.Info:t=console.info;break}t.call(console,...g)}log(y,g){const t=this.loggers.get(y.toString());if(!t)throw new Error("Create the logger before logging");for(const[d,m]of g)(0,D.log)(t,d,m)}}e.LoggerChannel=E;class w extends D.AbstractLoggerService{constructor(y,g,t){super(y,g);this.channel=t}createConsoleMainLogger(){return new D.AdapterLogger({log:(y,g)=>{this.channel.call("consoleLog",[y,g])}})}doCreateLogger(y,g,t){return new S(this.channel,y,g,t)}}e.LoggerChannelClient=w;class S extends D.AbstractMessageLogger{constructor(y,g,t,d){super(d?.always);this.channel=y,this.file=g,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[g,d]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(y,g){const t=[[y,g]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(y){this.channel.call("log",[this.file,y])}}class b extends D.LogService{constructor(y,g){super(g);this.parent=y,this._register(y.onDidChangeLogLevel(t=>g.setLevel(t)))}setLevel(y){super.setLevel(y),this.parent.setLevel(y)}}e.FollowerLogService=b}),define(ee[97],te([0,1,18,6]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(E,w,S,b,k){try{const y=await new Promise((t,d)=>{j(["spdlog"],t,d)});y.setFlushOn(n.LogLevel.Trace);const g=await y.createAsyncRotatingLogger(E,w,S,b);return k&&g.clearFormatters(),g}catch(y){console.error(y)}return null}function M(E,w,S){switch(w){case n.LogLevel.Trace:E.trace(S);break;case n.LogLevel.Debug:E.debug(S);break;case n.LogLevel.Info:E.info(S);break;case n.LogLevel.Warning:E.warn(S);break;case n.LogLevel.Error:E.error(S);break;case n.LogLevel.Critical:E.critical(S);break;default:throw new Error("Invalid log level")}}class P extends n.AbstractMessageLogger{constructor(w,S,b,k,y){super();this.buffer=[],this.setLevel(y),this._loggerCreationPromise=this._createSpdLogLogger(w,S,b,k),this._register(this.onDidChangeLogLevel(g=>{this._logger&&this._logger.setLevel(g)}))}async _createSpdLogLogger(w,S,b,k){const y=b?6:1,g=30/y*p.ByteSize.MB,t=await D(w,S,g,y,k);if(t){this._logger=t,this._logger.setLevel(this.getLevel());for(const{level:d,message:m}of this.buffer)M(this._logger,d,m);this.buffer=[]}}log(w,S){this._logger?M(this._logger,w,S):this.getLevel()<=w&&this.buffer.push({level:w,message:S})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=P}),define(ee[193],te([0,1,10,16,32,18,191,6,97]),function(j,e,p,n,D,M,P,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let S=class extends E.AbstractLoggerService{constructor(k,y){super(k.getLevel(),k.onDidChangeLogLevel);this.fileService=y}doCreateLogger(k,y,g){return k.scheme===p.Schemas.file?new w.SpdLogLogger(g?.name||(0,D.generateUuid)(),k.fsPath,!g?.donotRotate,!!g?.donotUseFormatters,y):new P.FileLogger(g?.name??(0,n.basename)(k),k,y,!!g?.donotUseFormatters,this.fileService)}};S=de([ne(0,E.ILogService),ne(1,M.IFileService)],S),e.LoggerService=S}),define(ee[194],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function p(P){return P.submenu!==void 0}e.isMenubarMenuItemSubmenu=p;function n(P){return P.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=n;function D(P){return P.uri!==void 0}e.isMenubarMenuItemRecentAction=D;function M(P){return!p(P)&&!n(P)&&!D(P)}e.isMenubarMenuItemAction=M}),define(ee[54],te([0,1,10,3,34,16]),function(j,e,p,n,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const E=n.globals.vscode.context.configuration();if(E)P=E.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof j?.__$__nodeRequire=="function"){const E=(0,M.dirname)(p.FileAccess.asFileUri("",j));P=j.__$__nodeRequire((0,M.joinPath)(E,"product.json").fsPath);const w=j.__$__nodeRequire((0,M.joinPath)(E,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`}),Object.assign(P,{version:w.version})}else P={},Object.keys(P).length===0&&Object.assign(P,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=P}),define(ee[22],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,p.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[195],te([0,1,60,6,22]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let M=class{constructor(E,w){this.productService=E,this.logService=w,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(E,w){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const S=/^(.*)#([^#]+)$/.exec(w);if(!S)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",w),!1;const[,b,k]=S;let y=this.trustedExtensionUrlPublicKeys.get(E);if(!y){if(y=this.productService.trustedExtensionUrlPublicKeys[E],!y||y.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",E),!1;this.trustedExtensionUrlPublicKeys.set(E,[...y])}const g=Buffer.from(decodeURIComponent(k),"base64");if(g.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",w),!1;const t=g.slice(0,6),d=g.readUIntBE(0,6),m=Date.now()-d;if(m<0||m>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",w),!1;const v=g.slice(6),C=p.createVerify("SHA256");C.write(t),C.write(Buffer.from(b)),C.end();for(let u=0;u<y.length;u++){let f=y[u];if(f!==null){if(typeof f=="string")try{f=p.createPublicKey({key:Buffer.from(f,"base64"),format:"der",type:"spki"}),y[u]=f}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${u+1} for ${E}:`,c),y[u]=null;continue}if(C.verify(f,v))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",w),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",w),!1}};M=de([ne(0,D.IProductService),ne(1,n.ILogService)],M),e.ExtensionUrlTrustService=M}),define(ee[55],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,p.createDecorator)("protocolMainService")}),define(ee[196],te([0,1,14,2,35,10,3,16,7,32,48,6]),function(j,e,p,n,D,M,P,E,w,S,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let y=class extends n.Disposable{constructor(t,d){super();this.logService=d,this.validRoots=D.TernarySearchTree.forUris(()=>!P.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(w.URI.file(t.appRoot)),this.addValidFileRoot(w.URI.file(t.extensionsPath)),this.addValidFileRoot(t.globalStorageHome),this.addValidFileRoot(t.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=p.session;t.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(d,m)=>this.handleResourceRequest(d,m)),t.protocol.interceptFileProtocol(M.Schemas.file,(d,m)=>this.handleFileRequest(d,m)),this._register((0,n.toDisposable)(()=>{t.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(t){return this.validRoots.get(t)?n.Disposable.None:(this.validRoots.set(t,!0),(0,n.toDisposable)(()=>this.validRoots.delete(t)))}handleFileRequest(t,d){const m=w.URI.parse(t.url);return this.logService.error(`Refused to load resource ${m.fsPath} from ${M.Schemas.file}: protocol (original URL: ${t.url})`),d({error:-3})}handleResourceRequest(t,d){const m=w.URI.parse(t.url),v=M.FileAccess.asFileUri(m);return this.validRoots.findSubstr(v)?d({path:v.fsPath}):this.validExtensions.has((0,E.extname)(v))?d({path:v.fsPath}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${v.fsPath} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),d({error:-3}))}createIPCObjectUrl(){let t;const d=w.URI.from({scheme:"vscode",path:(0,S.generateUuid)()}),m=d.toString(),v=async()=>t;return p.ipcMain.handle(m,v),this.logService.trace(`IPC Object URL: Registered new channel ${m}.`),{resource:d,update:C=>t=C,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${m}.`),p.ipcMain.removeHandler(m)}}}};y=de([ne(0,b.INativeEnvironmentService),ne(1,k.ILogService)],y),e.ProtocolMainService=y}),define(ee[40],te([0,1,104,13]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(P,E){p.ok(n.isString(P)),p.ok(n.isObject(E)),p.ok(!this.data.has(P),"There is already an extension with this id"),this.data.set(P,E)}knows(P){return this.data.has(P)}as(P){return this.data.get(P)||null}}e.Registry=new D}),define(ee[197],te([0,1,4,40]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class M{constructor(){this._onDidChangeSchema=new p.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,S){this.schemasById[D(w)]=S,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const P=new M;n.Registry.add(e.Extensions.JSONContribution,P)}),define(ee[56],te([0,1,27,4,13,138,197,40]),function(j,e,p,n,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var w;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(w=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var S;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=E.Registry.as(P.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(c,o=!0){this.registerConfigurations([c],o)}registerConfigurations(c,o=!0){const l=this.doRegisterConfigurations(c,o);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}deregisterConfigurations(c){const o=this.doDeregisterConfigurations(c);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:c,remove:o}){const l=[];l.push(...this.doDeregisterConfigurations(o)),l.push(...this.doRegisterConfigurations(c,!1)),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,p.distinct)(l)})}registerDefaultConfigurations(c){const o=[],l=[];for(const{overrides:s,source:i}of c)for(const r in s)if(o.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const a={...this.configurationDefaultsOverrides.get(r)?.value||{},...s[r]};this.configurationDefaultsOverrides.set(r,{source:i,value:a});const h={type:"object",default:a,description:M.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:a,source:D.isString(i)?void 0:i};l.push(...t(r)),this.configurationProperties[r]=h,this.defaultLanguageConfigurationOverridesNode.properties[r]=h}else{this.configurationDefaultsOverrides.set(r,{value:s[r],source:i});const a=this.configurationProperties[r];a&&(this.updatePropertyDefaultValue(r,a),this.updateSchema(r,a))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(c){const o=[];for(const{overrides:l,source:s}of c)for(const i in l){const r=this.configurationDefaultsOverrides.get(i),a=D.isString(s)?s:s?.id,h=D.isString(r?.source)?r?.source:r?.source?.id;if(a===h)if(o.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const I=this.configurationProperties[i];I&&(this.updatePropertyDefaultValue(i,I),this.updateSchema(i,I))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...c){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(c){for(const o of c)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(c,o){const l=[];return c.forEach(s=>{l.push(...this.validateAndRegisterProperties(s,o,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),l}doDeregisterConfigurations(c){const o=[],l=s=>{if(s.properties)for(const i in s.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,s.properties[i]);s.allOf&&s.allOf.forEach(i=>l(i))};for(const s of c){l(s);const i=this.configurationContributors.indexOf(s);i!==-1&&this.configurationContributors.splice(i,1)}return o}validateAndRegisterProperties(c,o=!0,l,s,i=3){i=D.isUndefinedOrNull(c.scope)?i:c.scope;let r=[],a=c.properties;if(a)for(let I in a){if(o&&C(I)){delete a[I];continue}const R=a[I];if(R.source=l,R.defaultDefaultValue=a[I].default,this.updatePropertyDefaultValue(I,R),e.OVERRIDE_PROPERTY_REGEX.test(I)?R.scope=void 0:(R.scope=D.isUndefinedOrNull(R.scope)?i:R.scope,R.restricted=D.isUndefinedOrNull(R.restricted)?!!s?.includes(I):R.restricted),a[I].hasOwnProperty("included")&&!a[I].included){this.excludedConfigurationProperties[I]=a[I],delete a[I];continue}else this.configurationProperties[I]=a[I];!a[I].deprecationMessage&&a[I].markdownDeprecationMessage&&(a[I].deprecationMessage=a[I].markdownDeprecationMessage),r.push(I)}let h=c.allOf;if(h)for(let I of h)r.push(...this.validateAndRegisterProperties(I,o,l,s,i));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(c){const o=l=>{let s=l.properties;if(s)for(const r in s)this.updateSchema(r,s[r]);let i=l.allOf;i&&i.forEach(o)};o(c)}updateSchema(c,o){switch(e.allSettings.properties[c]=o,o.scope){case 1:e.applicationSettings.properties[c]=o;break;case 2:e.machineSettings.properties[c]=o;break;case 6:e.machineOverridableSettings.properties[c]=o;break;case 3:e.windowSettings.properties[c]=o;break;case 4:e.resourceSettings.properties[c]=o;break;case 5:e.resourceSettings.properties[c]=o,this.resourceLanguageSettingsSchema.properties[c]=o;break}}removeFromSchema(c,o){switch(delete e.allSettings.properties[c],o.scope){case 1:delete e.applicationSettings.properties[c];break;case 2:delete e.machineSettings.properties[c];break;case 6:delete e.machineOverridableSettings.properties[c];break;case 3:delete e.windowSettings.properties[c];break;case 4:case 5:delete e.resourceSettings.properties[c],delete this.resourceLanguageSettingsSchema.properties[c];break}}updateOverridePropertyPatternKey(){for(const c of this.overrideIdentifiers.values()){const o=`[${c}]`,l={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,l),e.allSettings.properties[o]=l,e.applicationSettings.properties[o]=l,e.machineSettings.properties[o]=l,e.machineOverridableSettings.properties[o]=l,e.windowSettings.properties[o]=l,e.resourceSettings.properties[o]=l}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const c={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(c,o){const l=this.configurationDefaultsOverrides.get(c);let s=l?.value,i=l?.source;D.isUndefined(s)&&(s=o.defaultDefaultValue,i=void 0),D.isUndefined(s)&&(s=m(o.type)),o.default=s,o.defaultValueSource=i}}const y="\\[([^\\]]+)\\]",g=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(f){const c=[];if(e.OVERRIDE_PROPERTY_REGEX.test(f)){let o=g.exec(f);for(;o?.length;){const l=o[1].trim();l&&c.push(l),o=g.exec(f)}}return(0,p.distinct)(c)}e.overrideIdentifiersFromKey=t;function d(f){return f.reduce((c,o)=>`${c}[${o}]`,"")}e.keyFromOverrideIdentifiers=d;function m(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const v=new k;E.Registry.add(e.Extensions.Configuration,v);function C(f){return f.trim()?e.OVERRIDE_PROPERTY_REGEX.test(f)?M.localize(7,null,f):v.getConfigurationProperties()[f]!==void 0?M.localize(8,null,f):null:M.localize(6,null)}e.validateProperty=C;function u(){const f=[],c=v.getConfigurationProperties();for(const o of Object.keys(c))f.push([o,c[o].scope]);return f.push(["launch",4]),f.push(["task",4]),f}e.getScopes=u}),define(ee[198],te([0,1,27,4,43,2,35,47,13,7,19,56,40]),function(j,e,p,n,D,M,P,E,w,S,b,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(s={},i=[],r=[]){this._contents=s,this._keys=i,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,b.getConfigurationValue)(this.contents,s):this.contents}getOverrideValue(s,i){const r=this.getContentsForOverrideIdentifer(i);return r?s?(0,b.getConfigurationValue)(r,s):r:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const r of this.overrides)r.identifiers.includes(s)&&i.push(...r.keys);return p.distinct(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return p.distinct(s)}override(s){let i=this.overrideConfigurations.get(s);return i||(i=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,i)),i}merge(...s){const i=E.deepClone(this.contents),r=E.deepClone(this.overrides),a=[...this.keys];for(const h of s){this.mergeContents(i,h.contents);for(const I of h.overrides){const[R]=r.filter(L=>p.equals(L.identifiers,I.identifiers));R?(this.mergeContents(R.contents,I.contents),R.keys.push(...I.keys),R.keys=p.distinct(R.keys)):r.push(E.deepClone(I))}for(const I of h.keys)a.indexOf(I)===-1&&a.push(I)}return new g(i,a,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(s){const i=this.getContentsForOverrideIdentifer(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let r={};for(const a of p.distinct([...Object.keys(this.contents),...Object.keys(i)])){let h=this.contents[a],I=i[a];I&&(typeof h=="object"&&typeof I=="object"?(h=E.deepClone(h),this.mergeContents(h,I)):h=I),r[a]=h}return new g(r,this.keys,this.overrides)}mergeContents(s,i){for(const r of Object.keys(i)){if(r in s&&w.isObject(s[r])&&w.isObject(i[r])){this.mergeContents(s[r],i[r]);continue}s[r]=E.deepClone(i[r])}}checkAndFreeze(s){return this.isFrozen&&!Object.isFrozen(s)?E.deepFreeze(s):s}getContentsForOverrideIdentifer(s){let i=null,r=null;const a=h=>{h&&(r?this.mergeContents(r,h):r=E.deepClone(h))};for(const h of this.overrides)p.equals(h.identifiers,[s])?i=h.contents:h.identifiers.includes(s)&&a(h.contents);return a(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,i){this.addKey(s),(0,b.addToValueTree)(this.contents,s,i,r=>{throw new Error(r)})}removeValue(s){this.removeKey(s)&&(0,b.removeFromValueTree)(this.contents,s)}addKey(s){let i=this.keys.length;for(let r=0;r<i;r++)s.indexOf(this.keys[r])===0&&(i=r);this.keys.splice(i,1,s)}removeKey(s){let i=this.keys.indexOf(s);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=g;class t extends g{constructor(s={}){const i=y.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(i),a=Object.create(null),h=[];for(const I in i){const R=s[I],L=R!==void 0?R:i[I].default;(0,b.addToValueTree)(a,I,L,W=>console.error(`Conflict in default settings: ${W}`))}for(const I of Object.keys(a))k.OVERRIDE_PROPERTY_REGEX.test(I)&&h.push({identifiers:(0,k.overrideIdentifiersFromKey)(I),keys:Object.keys(a[I]),contents:(0,b.toValuesTree)(a[I],R=>console.error(`Conflict in default settings file: ${R}`))});super(a,r,h)}}e.DefaultConfigurationModel=t;class d{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,i){if(!w.isUndefinedOrNull(s)){const r=this.doParseContent(s);this.parseRaw(r,i)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,i){this._raw=s;const{contents:r,keys:a,overrides:h,restricted:I}=this.doParseRaw(s,i);this._configurationModel=new g(r,a,h),this._restrictedConfigurations=I||[]}doParseContent(s){let i={},r=null,a=[],h=[],I=[];function R(W){Array.isArray(a)?a.push(W):r!==null&&(a[r]=W)}let L={onObjectBegin:()=>{let W={};R(W),h.push(a),a=W,r=null},onObjectProperty:W=>{r=W},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{let W=[];R(W),h.push(a),a=W,r=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:R,onError:(W,N,J)=>{I.push({error:W,offset:N,length:J})}};if(s)try{D.visit(s,L),i=a[0]||{}}catch(W){console.error(`Error while parsing settings file ${this._name}: ${W}`),this._parseErrors=[W]}return i}doParseRaw(s,i){const r=y.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),a=this.filter(s,r,!0,i);s=a.raw;const h=(0,b.toValuesTree)(s,L=>console.error(`Conflict in settings file ${this._name}: ${L}`)),I=Object.keys(s),R=this.toOverrides(s,L=>console.error(`Conflict in settings file ${this._name}: ${L}`));return{contents:h,keys:I,overrides:R,restricted:a.restricted}}filter(s,i,r,a){if(!a?.scopes&&!a?.skipRestricted)return{raw:s,restricted:[]};const h={},I=[];for(let R in s)if(k.OVERRIDE_PROPERTY_REGEX.test(R)&&r){const L=this.filter(s[R],i,!1,a);h[R]=L.raw,I.push(...L.restricted)}else{const L=i[R],W=L?typeof L.scope!="undefined"?L.scope:3:void 0;L?.restricted&&I.push(R),(W===void 0||a.scopes===void 0||a.scopes.includes(W))&&(a.skipRestricted&&L?.restricted||(h[R]=s[R]))}return{raw:h,restricted:I}}toOverrides(s,i){const r=[];for(const a of Object.keys(s))if(k.OVERRIDE_PROPERTY_REGEX.test(a)){const h={};for(const I in s[a])h[I]=s[a][I];r.push({identifiers:(0,k.overrideIdentifiersFromKey)(a),keys:Object.keys(h),contents:(0,b.toValuesTree)(h,i)})}return r}}e.ConfigurationModelParser=d;class m extends M.Disposable{constructor(s,i,r,a){super();this.userSettingsResource=s,this.scopes=i,this.fileService=a,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=m;class v{constructor(s,i,r=new g,a=new g,h=new P.ResourceMap,I=new g,R=new P.ResourceMap,L=!0){this._defaultConfiguration=s,this._localUserConfiguration=i,this._remoteUserConfiguration=r,this._workspaceConfiguration=a,this._folderConfigurations=h,this._memoryConfiguration=I,this._memoryConfigurationByResource=R,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new P.ResourceMap,this._userConfiguration=null}getValue(s,i,r){return this.getConsolidateConfigurationModel(i,r).getValue(s)}updateValue(s,i,r={}){let a;r.resource?(a=this._memoryConfigurationByResource.get(r.resource),a||(a=new g,this._memoryConfigurationByResource.set(r.resource,a))):a=this._memoryConfiguration,i===void 0?a.removeValue(s):a.setValue(s,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,i,r){const a=this.getConsolidateConfigurationModel(i,r),h=this.getFolderConfigurationModelForResource(i.resource,r),I=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,R=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._defaultConfiguration.freeze().getValue(s),L=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.userConfiguration.freeze().getValue(s),W=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.localUserConfiguration.freeze().getValue(s),N=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.remoteUserConfiguration.freeze().getValue(s),J=r?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._workspaceConfiguration.freeze().getValue(s):void 0,oe=h?i.overrideIdentifier?h.freeze().override(i.overrideIdentifier).getValue(s):h.freeze().getValue(s):void 0,re=i.overrideIdentifier?I.override(i.overrideIdentifier).getValue(s):I.getValue(s),V=a.getValue(s),Z=p.distinct(p.flatten(a.overrides.map(H=>H.identifiers))).filter(H=>a.getOverrideValue(s,H)!==void 0);return{defaultValue:R,userValue:L,userLocalValue:W,userRemoteValue:N,workspaceValue:J,workspaceFolderValue:oe,memoryValue:re,value:V,default:R!==void 0?{value:this._defaultConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,user:L!==void 0?{value:this.userConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userLocal:W!==void 0?{value:this.localUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userRemote:N!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspace:J!==void 0?{value:this._workspaceConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspaceFolder:oe!==void 0?{value:h?.freeze().getValue(s),override:i.overrideIdentifier?h?.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,memory:re!==void 0?{value:I.getValue(s),override:i.overrideIdentifier?I.getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:Z.length?Z:void 0}}keys(s){const i=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,i){this._folderConfigurations.set(s,i),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const r=[];if(!i){const{added:a,updated:h,removed:I}=c(this._defaultConfiguration,s);i=[...a,...h,...I]}for(const a of i)for(const h of(0,k.overrideIdentifiersFromKey)(a)){const I=this._defaultConfiguration.getKeysForOverrideIdentifier(h),R=s.getKeysForOverrideIdentifier(h),L=[...R.filter(W=>I.indexOf(W)===-1),...I.filter(W=>R.indexOf(W)===-1),...I.filter(W=>!E.equals(this._defaultConfiguration.override(h).getValue(W),s.override(h).getValue(W)))];r.push([h,L])}return this.updateDefaultConfiguration(s),{keys:i,overrides:r}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:r,removed:a,overrides:h}=c(this.localUserConfiguration,s),I=[...i,...r,...a];return I.length&&this.updateLocalUserConfiguration(s),{keys:I,overrides:h}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:r,removed:a,overrides:h}=c(this.remoteUserConfiguration,s);let I=[...i,...r,...a];return I.length&&this.updateRemoteUserConfiguration(s),{keys:I,overrides:h}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:r,removed:a,overrides:h}=c(this.workspaceConfiguration,s);let I=[...i,...r,...a];return I.length&&this.updateWorkspaceConfiguration(s),{keys:I,overrides:h}}compareAndUpdateFolderConfiguration(s,i){const r=this.folderConfigurations.get(s),{added:a,updated:h,removed:I,overrides:R}=c(r,i);let L=[...a,...h,...I];return(L.length||!r)&&this.updateFolderConfiguration(s,i),{keys:L,overrides:R}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:r,updated:a,removed:h,overrides:I}=c(i,void 0);return{keys:[...r,...a,...h],overrides:I}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(s,i){let r=this.getConsolidatedConfigurationModelForResource(s,i);return s.overrideIdentifier?r.override(s.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:s},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&s){const a=i.getFolder(s);a&&(r=this.getFolderConsolidatedConfiguration(a.uri)||r);const h=this._memoryConfigurationByResource.get(s);h&&(r=r.merge(h))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let i=this._foldersConsolidatedConfigurations.get(s);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(s);a?(i=r.merge(a),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(s,i)):i=r}return i}getFolderConfigurationModelForResource(s,i){if(i&&s){const r=i.getFolder(s);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,i)=>{const{contents:r,overrides:a,keys:h}=this._folderConfigurations.get(i);return s.push([i,{contents:r,overrides:a,keys:h}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>s.add(i)),this.userConfiguration.freeze().keys.forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(r=>s.add(r))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(r=>s.add(r))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(s).forEach(a=>i.add(a))),[...i.values()]}static parse(s){const i=this.parseConfigurationModel(s.defaults),r=this.parseConfigurationModel(s.user),a=this.parseConfigurationModel(s.workspace),h=s.folders.reduce((I,R)=>(I.set(S.URI.revive(R[0]),this.parseConfigurationModel(R[1])),I),new P.ResourceMap);return new v(i,r,new g,a,h,new g,new P.ResourceMap,!1)}static parseConfigurationModel(s){return new g(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=v;function C(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const s=new Set,i=new Map;for(const a of l)a.keys.forEach(h=>s.add(h)),a.overrides.forEach(([h,I])=>{const R=(0,P.getOrSet)(i,h,new Set);I.forEach(L=>R.add(L))});const r=[];return i.forEach((a,h)=>r.push([h,[...a.values()]])),{keys:[...s.values()],overrides:r}}e.mergeChanges=C;class u{constructor(s,i,r,a){this.change=s,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=a,this._previousConfiguration=void 0;const h=new Set;s.keys.forEach(R=>h.add(R)),s.overrides.forEach(([,R])=>R.forEach(L=>h.add(L))),this.affectedKeys=[...h.values()];const I=new g;this.affectedKeys.forEach(R=>I.setValue(R,{})),this.affectedKeysTree=I.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,s)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(s,i,this.currentWorkspace);return!E.equals(r,a)}return!0}return!1}doesAffectedKeysTreeContains(s,i){let r=(0,b.toValuesTree)({[i]:!0},()=>{}),a;for(;typeof r=="object"&&(a=Object.keys(r)[0]);){if(s=s[a],!s)return!1;r=r[a]}return!0}}e.ConfigurationChangeEvent=u;class f extends u{constructor(s,i,r,a){super({keys:s.allKeys(),overrides:[]},void 0,s,i);this.source=r,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=f;function c(l,s){const{added:i,removed:r,updated:a}=o(s,l),h=[],I=l?.getAllOverrideIdentifiers()||[],R=s?.getAllOverrideIdentifiers()||[];if(s){const L=R.filter(W=>!I.includes(W));for(const W of L)h.push([W,s.getKeysForOverrideIdentifier(W)])}if(l){const L=I.filter(W=>!R.includes(W));for(const W of L)h.push([W,l.getKeysForOverrideIdentifier(W)])}if(s&&l){for(const L of I)if(R.includes(L)){const W=o({contents:l.getOverrideValue(void 0,L)||{},keys:l.getKeysForOverrideIdentifier(L)},{contents:s.getOverrideValue(void 0,L)||{},keys:s.getKeysForOverrideIdentifier(L)});h.push([L,[...W.added,...W.removed,...W.updated]])}}return{added:i,removed:r,updated:a,overrides:h}}function o(l,s){const i=l?s?l.keys.filter(h=>s.keys.indexOf(h)===-1):[...l.keys]:[],r=s?l?s.keys.filter(h=>l.keys.indexOf(h)===-1):[...s.keys]:[],a=[];if(l&&s){for(const h of s.keys)if(l.keys.indexOf(h)!==-1){const I=(0,b.getConfigurationValue)(s.contents,h),R=(0,b.getConfigurationValue)(l.contents,h);E.equals(I,R)||a.push(h)}}return{added:i,removed:r,updated:a}}}),define(ee[199],te([0,1,8,4,2,16,19,198,56,40]),function(j,e,p,n,D,M,P,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends D.Disposable{constructor(y,g){super();this.settingsResource=y,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,void 0,M.extUriBiasedIgnorePathCase,g)),this.configuration=new E.Configuration(new E.DefaultConfigurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(S.Registry.as(w.Extensions.Configuration).onDidUpdateConfiguration(({properties:t})=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const y=await this.userConfiguration.loadConfiguration();this.configuration=new E.Configuration(new E.DefaultConfigurationModel,y)}getConfigurationData(){return this.configuration.toData()}getValue(y,g){const t=typeof y=="string"?y:void 0,d=(0,P.isConfigurationOverrides)(y)?y:(0,P.isConfigurationOverrides)(g)?g:{};return this.configuration.getValue(t,d,void 0)}updateValue(y,g,t,d){return Promise.reject(new Error("not supported"))}inspect(y){return this.configuration.inspect(y,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const y=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(y)}onDidChangeUserConfiguration(y){const g=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(y);this.trigger(t,g,1)}onDidDefaultConfigurationChange(y){const g=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new E.DefaultConfigurationModel,y);this.trigger(t,g,6)}trigger(y,g,t){const d=new E.ConfigurationChangeEvent(y,{data:g},this.configuration);d.source=t,d.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(d)}getTargetConfiguration(y){switch(y){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(ee[200],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var n;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(P,E=n.Unknown,w){super(P);this._message=P,this._code=E,this._detail=w,this.isHandled=E===n.NotAvailable&&w===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(P){return P instanceof D&&P._code===n.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof D&&P._code===n.NoResolverFound}static isHandled(P){return P instanceof D&&P.isHandled}}e.RemoteAuthorityResolverError=D}),define(ee[201],te([0,1,8,17,21,15,4,2,32,87,200]),function(j,e,p,n,D,M,P,E,w,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const k=30*1e3;var y;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(y=e.ConnectionType||(e.ConnectionType={}));function g(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t(q){const F=new D.CancellationTokenSource;return setTimeout(()=>F.cancel(),q),F.token}function d(q,F){if(q.isCancellationRequested||F.isCancellationRequested)return D.CancellationToken.Cancelled;const $=new D.CancellationTokenSource;return q.onCancellationRequested(()=>$.cancel()),F.onCancellationRequested(()=>$.cancel()),$.token}class m{constructor(F){this._state="pending",this._disposables=new E.DisposableStore,this.promise=new Promise(($,A)=>{this._resolvePromise=$,this._rejectPromise=A}),F.isCancellationRequested?this._timeout():this._disposables.add(F.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(F){this._state==="pending"?this._disposables.add(F):F.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const F=new Error("Time limit reached");return F.code="ETIMEDOUT",F.syscall="connect",F}resolve(F){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(F))}reject(F){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(F))}}function v(q,F){const $=new m(F);return $.registerDisposable(q.onControlMessage(A=>{const T=JSON.parse(A.toString()),U=K(T);U?$.reject(U):$.resolve(T)})),$.promise}function C(q,F,$,A,T,U,O){const _=new m(O);return F.connect($,A,T,U,(Q,ie)=>{_.didTimeout?(Q&&q.error(Q),ie?.dispose()):Q||!ie?_.reject(Q):_.resolve(ie)}),_.promise}function u(q,F){const $=new m(F);return q.then(A=>{$.didTimeout||$.resolve(A)},A=>{$.didTimeout||$.reject(A)}),$.promise}async function f(q,F,$,A){const T=B(q,F);q.logService.trace(`${T} 1/6. invoking socketFactory.connect().`);let U;try{U=await C(q.logService,q.socketFactory,q.host,q.port,`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,`renderer-${g(F)}-${q.reconnectionToken}`,A)}catch(se){throw q.logService.error(`${T} socketFactory.connect() failed or timed out. Error:`),q.logService.error(se),se}q.logService.trace(`${T} 2/6. socketFactory.connect() was successful.`);let O,_;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(U,null),O=q.reconnectionProtocol,_=!1):(O=new S.PersistentProtocol(U,null),_=!0),q.logService.trace(`${T} 3/6. sending AuthRequest control message.`);const Q=await u(q.signService.createNewMessage((0,w.generateUuid)()),A),ie={type:"auth",auth:q.connectionToken||"00000000000000000000",data:Q.data};O.sendControl(n.VSBuffer.fromString(JSON.stringify(ie)));try{const se=await v(O,d(A,t(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const he=new Error("Unexpected handshake message");throw he.code="VSCODE_CONNECTION_ERROR",he}if(q.logService.trace(`${T} 4/6. received SignRequest control message.`),!await u(q.signService.validate(Q,se.signedData),A)){const he=new Error("Refused to connect to unsupported server");throw he.code="VSCODE_CONNECTION_ERROR",he}const ce=await u(q.signService.sign(se.data),A),le={type:"connectionType",commit:q.commit,signedData:ce,desiredConnectionType:F};return $&&(le.args=$),q.logService.trace(`${T} 5/6. sending ConnectionTypeRequest control message.`),O.sendControl(n.VSBuffer.fromString(JSON.stringify(le))),{protocol:O,ownsProtocol:_}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(q.logService.error(`${T} the handshake timed out. Error:`),q.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${T} received error control message when negotiating connection. Error:`),q.logService.error(se)),_&&H(O),se}}async function c(q,F,$,A){const T=Date.now(),U=B(q,F),{protocol:O,ownsProtocol:_}=await f(q,F,$,A),Q=new m(A);return Q.registerDisposable(O.onControlMessage(ie=>{const se=JSON.parse(ie.toString()),x=K(se);x?(q.logService.error(`${U} received error control message when negotiating connection. Error:`),q.logService.error(x),_&&H(O),Q.reject(x)):(q.reconnectionProtocol&&q.reconnectionProtocol.endAcceptReconnection(),q.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${Y(T)}!`),Q.resolve({protocol:O,firstMessage:se}))})),Q.promise}async function o(q,F){const{protocol:$}=await c(q,1,void 0,F);return{protocol:$}}async function l(q,F,$){const{protocol:A,firstMessage:T}=await c(q,2,F,$),U=T&&T.debugPort;return{protocol:A,debugPort:U}}async function s(q,F,$){const A=Date.now(),T=B(q,3),{protocol:U}=await f(q,3,F,$);return q.logService.trace(`${T} 6/6. handshake finished, connection is up and running after ${Y(A)}!`),U}async function i(q,F,$){const{host:A,port:T,connectionToken:U}=await q.addressProvider.getAddress();return{commit:q.commit,host:A,port:T,connectionToken:U,reconnectionToken:F,reconnectionProtocol:$,socketFactory:q.socketFactory,signService:q.signService,logService:q.logService}}async function r(q,F,$){try{const A=(0,w.generateUuid)(),T=await i(q,A,null),{protocol:U}=await o(T,D.CancellationToken.None);return new V(q,F,$,A,U)}catch(A){throw q.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),q.logService.error(A),re.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled(A)),A}}e.connectRemoteAgentManagement=r;async function a(q,F){try{const $=(0,w.generateUuid)(),A=await i(q,$,null),{protocol:T,debugPort:U}=await l(A,F,D.CancellationToken.None);return new Z(q,F,$,T,U)}catch($){throw q.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),q.logService.error($),re.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled($)),$}}e.connectRemoteAgentExtensionHost=a;async function h(q,F,$){const A=await i(q,(0,w.generateUuid)(),null);return await s(A,{host:F,port:$},D.CancellationToken.None)}e.connectRemoteAgentTunnel=h;function I(q){return(0,p.createCancelablePromise)(F=>new Promise(($,A)=>{const T=setTimeout($,q*1e3);F.onCancellationRequested(()=>{clearTimeout(T),$()})}))}var R;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain"})(R=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class L{constructor(F,$){this.reconnectionToken=F,this.millisSinceLastIncomingData=$,this.type=0}}e.ConnectionLostEvent=L;class W{constructor(F,$,A,T){this.reconnectionToken=F,this.millisSinceLastIncomingData=$,this.durationSeconds=A,this.cancellableTimer=T,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=W;class N{constructor(F,$,A){this.reconnectionToken=F,this.millisSinceLastIncomingData=$,this.attempt=A,this.type=2}}e.ReconnectionRunningEvent=N;class J{constructor(F,$,A){this.reconnectionToken=F,this.millisSinceLastIncomingData=$,this.attempt=A,this.type=4}}e.ConnectionGainEvent=J;class oe{constructor(F,$,A,T){this.reconnectionToken=F,this.millisSinceLastIncomingData=$,this.attempt=A,this.handled=T,this.type=3}}e.ReconnectionPermanentFailureEvent=oe;class re extends E.Disposable{constructor(F,$,A,T){super();this._connectionType=F,this._onDidStateChange=this._register(new P.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=$,this.reconnectionToken=A,this.protocol=T,this._isReconnecting=!1,this._onDidStateChange.fire(new J(this.reconnectionToken,0,0)),this._register(T.onSocketClose(U=>{const O=z(this._connectionType,this.reconnectionToken,!0);U?U.type===0?(this._options.logService.info(`${O} received socket close event (hadError: ${U.hadError}).`),U.error&&this._options.logService.error(U.error)):(this._options.logService.info(`${O} received socket close event (wasClean: ${U.wasClean}, code: ${U.code}, reason: ${U.reason}).`),U.event&&this._options.logService.error(U.event)):this._options.logService.info(`${O} received socket close event.`),this._beginReconnecting()})),this._register(T.onSocketTimeout(()=>{const U=z(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${U} received socket timeout event.`),this._beginReconnecting()})),re._instances.push(this),re._permanentFailure&&this._gotoPermanentFailure(re._permanentFailureMillisSinceLastIncomingData,re._permanentFailureAttempt,re._permanentFailureHandled)}static triggerPermanentFailure(F,$,A){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=F,this._permanentFailureAttempt=$,this._permanentFailureHandled=A,this._instances.forEach(T=>T._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(F=>F._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(F=>F._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(re._permanentFailure)return;const F=z(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${F} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const $=[0,5,5,10,10,10,10,10,30];let A=-1;do{A++;const T=A<$.length?$[A]:$[$.length-1];try{if(T>0){const O=I(T);this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T,O)),this._options.logService.info(`${F} waiting for ${T} seconds before reconnecting...`);try{await O}catch{}}if(re._permanentFailure){this._options.logService.error(`${F} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),A+1)),this._options.logService.info(`${F} resolving connection...`);const U=await i(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${F} connecting to ${U.host}:${U.port}...`),await this._reconnect(U,t(k)),this._options.logService.info(`${F} reconnected!`),this._onDidStateChange.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),A+1));break}catch(U){if(U.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${F} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(U),re.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,!1);break}if(A>360){this._options.logService.error(`${F} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(U),re.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,!1);break}if(b.RemoteAuthorityResolverError.isTemporarilyNotAvailable(U)){this._options.logService.info(`${F} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if((U.code==="ETIMEDOUT"||U.code==="ENETUNREACH"||U.code==="ECONNREFUSED"||U.code==="ECONNRESET")&&U.syscall==="connect"){this._options.logService.info(`${F} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if((0,M.isCancellationError)(U)){this._options.logService.info(`${F} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if(U instanceof b.RemoteAuthorityResolverError){this._options.logService.error(`${F} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(U),re.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,b.RemoteAuthorityResolverError.isHandled(U));break}this._options.logService.error(`${F} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(U),re.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,!1);break}}while(!re._permanentFailure)}_gotoPermanentFailure(F,$,A){this._onDidStateChange.fire(new oe(this.reconnectionToken,F,$,A)),H(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=re,re._permanentFailure=!1,re._permanentFailureMillisSinceLastIncomingData=0,re._permanentFailureAttempt=0,re._permanentFailureHandled=!1,re._instances=[];class V extends re{constructor(F,$,A,T,U){super(1,F,T,U);this.client=this._register(new S.Client(U,{remoteAuthority:$,clientId:A},F.ipcLogger))}async _reconnect(F,$){await o(F,$)}}e.ManagementPersistentConnection=V;class Z extends re{constructor(F,$,A,T,U){super(2,F,A,T);this._startArguments=$,this.debugPort=U}async _reconnect(F,$){await l(F,this._startArguments,$)}}e.ExtensionHostPersistentConnection=Z;function H(q){try{q.acceptDisconnect();const F=q.getSocket();q.dispose(),F.dispose()}catch(F){(0,M.onUnexpectedError)(F)}}function K(q){if(q&&q.type==="error"){const F=new Error(`Connection error: ${q.reason}`);return F.code="VSCODE_CONNECTION_ERROR",F}return null}function G(q,F){for(;q.length<F;)q+=" ";return q}function z(q,F,$){return`[remote-connection][${G(g(q),13)}][${F.substr(0,5)}\u2026][${$?"reconnect":"initial"}]`}function B(q,F){return`${z(F,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.host}:${q.port}]`}function Y(q){return`${Date.now()-q} ms`}}),define(ee[65],te([0,1,10]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function n(S){return S.scheme===p.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=n;function D(S){if(!S)return;const b=S.indexOf("+");return b<0?S:S.substr(0,b)}e.getRemoteName=D;function M(S){return S.scheme!==p.Schemas.file&&S.scheme!==p.Schemas.vscodeRemote}e.isVirtualResource=M;function P(S){if(S.folders.length)return S.folders.every(b=>M(b.uri))?S.folders[0].uri:void 0;if(S.configuration&&M(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=P;function E(S){return P(S)?.scheme}e.getVirtualWorkspaceScheme=E;function w(S){return P(S)!==void 0}e.isVirtualWorkspace=w}),define(ee[202],te([0,1,25,5,65]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.getWorkspaceSupportTypeMessage=M;function P(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=P,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));class w{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,t){if(typeof g=="undefined"||g===null)return typeof t=="undefined"||t===null;if(typeof t=="undefined"||t===null)return!1;if(typeof g=="string"||typeof t=="string"){let d=typeof g=="string"?g:g.value,m=typeof t=="string"?t:t.value;return p.equalsIgnoreCase(d,m)}return g._lower===t._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.ExtensionIdentifier=w;function S(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function b(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=b;function k(y,g){if(g){const t=`onResolveRemoteAuthority:${(0,D.getRemoteName)(g)}`;return y.activationEvents?.indexOf(t)!==-1}return!1}e.isResolverExtension=k,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[98],te([0,1,25,202]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(t,d){return t.uuid&&d.uuid?t.uuid===d.uuid:t.id===d.id?!0:(0,p.compareIgnoreCase)(t.id,d.id)===0}e.areSameExtensions=D;class M{constructor(d,m){this.version=m,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof M?D(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=M;function P(t,d){return`${t}.${d}`}e.getExtensionId=P;function E(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=E;function w(t,d){return E(P(t,d))}e.getGalleryExtensionId=w;function S(t,d){const m=[],v=C=>{for(const u of m)if(u.some(f=>D(d(f),d(C))))return u;return null};for(const C of t){const u=v(C);u?u.push(C):m.push([C])}return m}e.groupByExtension=S;function b(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function k(t){return{id:t.identifier.id,name:t.name,galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),...t.telemetryData}}e.getGalleryExtensionTelemetryData=k,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function y(t){const d=new Set;if(t.malicious)for(const m of t.malicious)d.add(m.id);return d}e.getMaliciousExtensionsSet=y;function g(t,d){const m=[],v=d.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const C=v.shift();if(C&&m.every(u=>!D(u.identifier,{id:C}))){const u=t.filter(f=>D(f.identifier,{id:C}));u.length===1&&(m.push(u[0]),v.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return m}e.getExtensionDependencies=g}),define(ee[203],te([0,1,10,143,98,5]),function(j,e,p,n,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.getIdAndVersion=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";const P=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function E(o){const l=P.exec(o);return l&&l[1]?[(0,D.adoptToGalleryExtensionId)(l[1]),l[2]]:[(0,D.adoptToGalleryExtensionId)(o),void 0]}e.getIdAndVersion=E;var w;(function(o){o.WIN32_X64="win32-x64",o.WIN32_IA32="win32-ia32",o.WIN32_ARM64="win32-arm64",o.LINUX_X64="linux-x64",o.LINUX_ARM64="linux-arm64",o.LINUX_ARMHF="linux-armhf",o.ALPINE_X64="alpine-x64",o.ALPINE_ARM64="alpine-arm64",o.DARWIN_X64="darwin-x64",o.DARWIN_ARM64="darwin-arm64",o.WEB="web",o.UNIVERSAL="universal",o.UNKNOWN="unknown",o.UNDEFINED="undefined"})(w=e.TargetPlatform||(e.TargetPlatform={}));function S(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=S;function b(o){switch(o){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=b;function k(o,l){switch(o){case 3:return l==="x64"?"win32-x64":l==="ia32"?"win32-ia32":l==="arm64"?"win32-arm64":"unknown";case 2:return l==="x64"?"linux-x64":l==="arm64"?"linux-arm64":l==="arm"?"linux-armhf":"unknown";case"alpine":return l==="x64"?"alpine-x64":l==="arm64"?"alpine-arm64":"unknown";case 1:return l==="x64"?"darwin-x64":l==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=k;function y(o,l){return l==="web"&&!o.includes("web")}e.isNotWebExtensionInWebTargetPlatform=y;function g(o,l,s){return y(l,s)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===s?!0:t(s).includes(o)}e.isTargetPlatformCompatible=g;function t(o){switch(o){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=t;function d(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.isIExtensionIdentifier=d;var m;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(m=e.SortBy||(e.SortBy={}));var v;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var C;(function(o){o.Install="install",o.Uninstall="uninstall"})(C=e.StatisticType||(e.StatisticType={}));var u;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(u=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,M.createDecorator)("extensionGalleryService");var f;(function(o){o.Unsupported="Unsupported",o.UnsupportedPreRelease="UnsupportedPreRelease",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatiblePreRelease="IncompatiblePreRelease",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Internal="Internal"})(f=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class c extends Error{constructor(l,s){super(l);this.code=s,this.name=s}}e.ExtensionManagementError=c,e.IExtensionManagementService=(0,M.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,M.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,M.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=p.FileAccess.asBrowserUri("./media/defaultIcon.png",j).toString(!0),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,n.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,M.createDecorator)("IExtensionManagementCLIService")}),define(ee[99],te([0,1,4,3,5,6]),function(j,e,p,n,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var P;(function(t){t.Http="http",t.Https="https"})(P=e.TunnelProtocol||(e.TunnelProtocol={}));var E;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(E=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function S(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=S,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=k;function y(t,d){return d?d!==1&&t<1024:!n.isWindows&&t<1024}e.isPortPrivileged=y;let g=class{constructor(d){this.logService=d,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new p.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d){return this._tunnelProvider=d,d?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this._canElevate=d.elevation,this._privacyOptions=d.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const d=[],m=Array.from(this._tunnels.values());for(let v of m){const C=Array.from(v.values());for(let u of C){const f=await u.value;f&&d.push(f)}}return d}async dispose(){for(const d of this._tunnels.values()){for(const{value:m}of d.values())await m.then(v=>v?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,m,v,C,u=!1,f=E.Private,c){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${v} on local port ${C}.`),!d)return;m||(m="localhost");const o=this.retainOrCreateTunnel(d,m,v,C,u,f,c);return o?o.then(l=>{if(!l){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(m,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(l);return(l.tunnelRemoteHost!==m||l.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const m=this._tunnels.get(d.tunnelRemoteHost);if(m){const v=m.get(d.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,v))}}}}async tryDisposeTunnel(d,m,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${m}.`);const C=v.value.then(async u=>{u&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(m),C}}async closeTunnel(d,m){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${m} `);const v=this._tunnels.get(d);if(v&&v.has(m)){const C=v.get(m);C.refcount=0,await this.tryDisposeTunnel(d,m,C)}}addTunnelToMap(d,m,v){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(m,{refcount:1,value:v})}async removeEmptyTunnelFromMap(d,m){const v=this._tunnels.get(d);v&&(await v.get(m)||v.delete(m),v.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,m){let v=[d];b(d)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):k(d)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const C=v.map(u=>this._tunnels.get(u));for(const u of C){const f=u?.get(m);if(f)return f}}canTunnel(d){return!!S(d)}createWithProvider(d,m,v,C,u,f,c){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${v} on local port ${C}.`);const l={elevationRequired:u?y(C===void 0?v:C):!1},s={remoteAddress:{host:m,port:v},localAddressPort:C,privacy:f,public:f!==E.Private,protocol:c},i=d.forwardPort(s,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(m,v,i),i}};g=de([ne(0,M.ILogService)],g),e.AbstractTunnelService=g}),define(ee[49],te([0,1,17,154,56,5,40]),function(j,e,p,n,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,M.createDecorator)("requestService");function E(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=E;function w(t){return t.res.statusCode===204}async function S(t){if(!E(t))throw new Error("Server returned "+t.res.statusCode);return w(t)?null:(await(0,p.streamToBuffer)(t.stream)).toString()}e.asText=S;async function b(t){if(!E(t))throw new Error("Server returned "+t.res.statusCode);if(w(t))return null;const m=(await(0,p.streamToBuffer)(t.stream)).toString();try{return JSON.parse(m)}catch(v){throw v.message+=`:
`+m,v}}e.asJson=b;function k(t){g(t)}e.updateProxyConfigurationsScope=k;let y;function g(t){const d=P.Registry.as(D.Extensions.Configuration),m=y;y={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},d.updateConfigurations({add:[y],remove:m?[m]:[]})}g(2)}),define(ee[204],te([0,1,205,13]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(P,E){return P.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:P.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function M(P,E,w={}){const S=(0,p.parse)(P),b=w.proxyUrl||D(S,E);if(!b)return null;const k=(0,p.parse)(b);if(!/^https?:$/.test(k.protocol||""))return null;const y={host:k.hostname||"",port:k.port||(k.protocol==="https"?"443":"80"),auth:k.auth,rejectUnauthorized:(0,n.isBoolean)(w.strictSSL)?w.strictSSL:!0};return S.protocol==="http:"?new(await new Promise((g,t)=>{j(["http-proxy-agent"],g,t)}))(y):new(await new Promise((g,t)=>{j(["https-proxy-agent"],g,t)}))(y)}e.getProxyAgent=M}),define(ee[206],te([0,1,17,32]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(M,P,E){let w=E&&E.get("storage.serviceMachineId",0)||null;if(w)return w;try{const b=(await P.readFile(M.serviceMachineIdResource)).value.toString();w=(0,n.isUUID)(b)?b:null}catch{w=null}if(!w){w=(0,n.generateUuid)();try{await P.writeFile(M.serviceMachineIdResource,p.VSBuffer.fromString(w))}catch{}}return E&&E.store("storage.serviceMachineId",w,0,1),w}e.getServiceMachineId=D}),define(ee[78],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,p.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[207],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{constructor(){this.validators=new Map}vsda(){return new Promise((D,M)=>j(["vsda"],D,M))}async createNewMessage(D){try{const M=await this.vsda(),P=new M.validator;if(P){const E=String(p._nextId++);return this.validators.set(E,P),{id:E,data:P.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,M){if(!D.id)return!0;const P=this.validators.get(D.id);if(!P)return!1;this.validators.delete(D.id);try{return P.validate(M)==="ok"}catch{return!1}}async sign(D){try{const M=await this.vsda(),P=new M.signer;if(P)return P.sign(D)}catch{}return D}}e.SignService=p,p._nextId=1}),define(ee[38],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,p.createDecorator)("stateMainService")}),define(ee[20],te([0,1,14,8,4,2,3,34,13,5,186,6,38]),function(j,e,p,n,D,M,P,E,w,S,b,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,S.createDecorator)("lifecycleMainService");var g;(function(d){d[d.Starting=1]="Starting",d[d.Ready=2]="Ready",d[d.AfterWindowOpen=3]="AfterWindowOpen"})(g=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let t=class gt extends M.Disposable{constructor(m,v){super();this.logService=m,this.stateMainService=v,this._onBeforeShutdown=this._register(new D.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new D.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new D.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new D.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new D.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(gt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(gt.QUIT_AND_RESTART_KEY)}registerListeners(){const m=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),P.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown())};p.app.addListener("before-quit",m);const v=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!P.isMacintosh)&&p.app.quit()};p.app.addListener("window-all-closed",v),p.app.once("will-quit",C=>{this.logService.trace("Lifecycle#app.on(will-quit)"),C.preventDefault(),this.fireOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),p.app.removeListener("before-quit",m),p.app.removeListener("window-all-closed",v),p.app.quit()})})}fireOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const m=[];return this._onWillShutdown.fire({join(v){m.push(v)}}),this.pendingWillShutdownPromise=(async()=>{try{await n.Promises.settled(m)}catch(v){this.logService.error(v)}try{await this.stateMainService.close()}catch(v){this.logService.error(v)}})(),this.pendingWillShutdownPromise}set phase(m){if(m<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===m)return;this.logService.trace(`lifecycle (main): phase changed (value: ${m})`),this._phase=m;const v=this.phaseWhen.get(this._phase);v&&(v.open(),this.phaseWhen.delete(this._phase))}async when(m){if(m<=this._phase)return;let v=this.phaseWhen.get(m);v||(v=new n.Barrier,this.phaseWhen.set(m,v)),await v.wait()}registerWindow(m){const v=new M.DisposableStore;this.windowCounter++,v.add(m.onWillLoad(u=>this._onWillLoadWindow.fire({window:m,workspace:u.workspace,reason:u.reason})));const C=(0,w.assertIsDefined)(m.win);C.on("close",u=>{const f=m.id;if(this.windowToCloseRequest.has(f)){this.windowToCloseRequest.delete(f);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${m.id}`),u.preventDefault(),this.unload(m,1).then(c=>{if(c){this.windowToCloseRequest.delete(f);return}this.windowToCloseRequest.add(f),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${f}`),this._onBeforeCloseWindow.fire(m),m.close()})}),C.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${m.id}`),this.windowCounter--,v.dispose(),this.windowCounter===0&&(!P.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown()})}async reload(m,v){await this.unload(m,3)||m.reload(v)}async unload(m,v){if(!m.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${m.id}`);const C=this._quitRequested?2:v;let u=await this.onBeforeUnloadWindowInRenderer(m,C);return u?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${m.id})`),this.handleWindowUnloadVeto(u)):(u=await this.onBeforeUnloadWindowInMain(m,C),u?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${m.id})`),this.handleWindowUnloadVeto(u)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${m.id})`),await this.onWillUnloadWindowInRenderer(m,C),!1))}handleWindowUnloadVeto(m){return m?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(m){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(m),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(m,v){return new Promise(C=>{const u=this.oneTimeListenerTokenGenerator++,f=`vscode:ok${u}`,c=`vscode:cancel${u}`;p.ipcMain.once(f,()=>{C(!1)}),p.ipcMain.once(c,()=>{C(!0)}),m.send("vscode:onBeforeUnload",{okChannel:f,cancelChannel:c,reason:v})})}onBeforeUnloadWindowInMain(m,v){const C=[];return this._onBeforeUnloadWindow.fire({reason:v,window:m,veto(u){C.push(u)}}),(0,b.handleVetos)(C,u=>this.logService.error(u))}onWillUnloadWindowInRenderer(m,v){return new Promise(C=>{const f=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;p.ipcMain.once(f,()=>C()),m.send("vscode:onWillUnload",{replyChannel:f,reason:v})})}quit(m){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${m}`),m&&this.stateMainService.setItem(gt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(v=>{this.pendingQuitPromiseResolve=v,this.logService.trace("Lifecycle#quit() - calling app.quit()"),p.app.quit()}),this.pendingQuitPromise)}async relaunch(m){this.logService.trace("Lifecycle#relaunch()");const v=process.argv.slice(1);if(m?.addArgs&&v.push(...m.addArgs),m?.removeArgs)for(const f of m.removeArgs){const c=v.indexOf(f);c>=0&&v.splice(c,1)}const C=()=>{try{if(P.isWindows){const f=(0,E.cwd)();f!==process.cwd()&&process.chdir(f)}}catch(f){this.logService.error(f)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),p.app.relaunch({args:v})};p.app.once("quit",C),await this.quit(!0)&&p.app.removeListener("quit",C)}async kill(m){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const v of p.BrowserWindow.getAllWindows())if(v&&!v.isDestroyed()){let C;v.webContents&&!v.webContents.isDestroyed()?C=new Promise(u=>v.once("closed",u)):C=Promise.resolve(),v.destroy(),await C}})()]),p.app.exit(m)}};t.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",t=de([ne(0,k.ILogService),ne(1,y.IStateMainService)],t),e.LifecycleMainService=t}),define(ee[208],te([0,1,4,2,5,20]),function(j,e,p,n,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,D.createDecorator)("keyboardLayoutMainService");let P=class extends n.Disposable{constructor(S){super();this._onDidChangeKeyboardLayout=this._register(new p.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,S.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const S=await new Promise((b,k)=>{j(["native-keymap"],b,k)});this._keyboardLayoutData=E(S),S.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=E(S),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};P=de([ne(0,M.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function E(w){const S=w.getKeyMap(),b=w.getCurrentKeyboardLayout();return{keyboardMapping:S,keyboardLayoutInfo:b}}}),define(ee[79],te([0,1,8,4,2,64,13,89,5]),function(j,e,p,n,D,M,P,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const S="__$__targetStorageMarker";e.IStorageService=(0,w.createDecorator)("storageService");var b;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var k;(function(m){m[m.GLOBAL=0]="GLOBAL",m[m.WORKSPACE=1]="WORKSPACE"})(k=e.StorageScope||(e.StorageScope={}));var y;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));class g extends D.Disposable{constructor(v={flushInterval:g.DEFAULT_FLUSH_INTERVAL}){super();this.options=v,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new p.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,p.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,M.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,C){C===S?(v===0?this._globalKeyTargets=void 0:v===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:v})):this._onDidChangeValue.fire({scope:v,key:C,target:this.getKeyTargets(v)[C]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,C,u){return this.getStorage(C)?.get(v,u)}getBoolean(v,C,u){return this.getStorage(C)?.getBoolean(v,u)}getNumber(v,C,u){return this.getStorage(C)?.getNumber(v,u)}store(v,C,u,f){if((0,P.isUndefinedOrNull)(C)){this.remove(v,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,u,f),this.getStorage(u)?.set(v,C)})}remove(v,C){this.withPausedEmitters(()=>{this.updateKeyTarget(v,C,void 0),this.getStorage(C)?.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,C){const u=[],f=this.getKeyTargets(v);for(const c of Object.keys(f))f[c]===C&&u.push(c);return u}updateKeyTarget(v,C,u){const f=this.getKeyTargets(C);typeof u=="number"?f[v]!==u&&(f[v]=u,this.getStorage(C)?.set(S,JSON.stringify(f))):typeof f[v]=="number"&&(delete f[v],this.getStorage(C)?.set(S,JSON.stringify(f)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(v){return v===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(v){const C=this.get(S,v);if(C)try{return JSON.parse(C)}catch{}return Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=b.NONE){this._onWillSaveState.fire({reason:v});const C=this.getStorage(0),u=this.getStorage(1);switch(v){case b.NONE:await p.Promises.settled([C?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await p.Promises.settled([C?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve()]);break}}async logStorage(){const v=this.getStorage(0)?.items??new Map,C=this.getStorage(1)?.items??new Map;return d(v,C,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=g,g.DEFAULT_FLUSH_INTERVAL=60*1e3;class t extends g{constructor(){super();this.globalStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.globalStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v)))}getStorage(v){return v===0?this.globalStorage:this.workspaceStorage}getLogDetails(v){return v===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(v){}}e.InMemoryStorageService=t;async function d(m,v,C,u){const f=a=>{try{return JSON.parse(a)}catch{return a}},c=new Map,o=new Map;m.forEach((a,h)=>{c.set(h,a),o.set(h,f(a))});const l=new Map,s=new Map;v.forEach((a,h)=>{l.set(h,a),s.set(h,f(a))}),console.group(`Storage: Global (path: ${C})`);let i=[];c.forEach((a,h)=>{i.push({key:h,value:a})}),console.table(i),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${u})`);let r=[];l.forEach((a,h)=>{r.push({key:h,value:a})}),console.table(r),console.groupEnd(),console.log(s)}e.logStorage=d}),define(ee[209],te([0,1,3,34,7,32]),function(j,e,p,n,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function P(S){if(p.platform===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}async function E(S,b,k,y,g,t,d,m,v,C){const u=Object.create(null);u["common.machineId"]=d,u.sessionID=(0,M.generateUuid)()+Date.now(),u.commitHash=g,u.version=t,u["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,p.PlatformToString)(p.platform),u["common.nodePlatform"]=n.platform,u["common.nodeArch"]=y,u["common.product"]=C||"desktop";const f=w(m||[]);f&&(u["common.msftInternal"]=f);let c=0;const o=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),p.isLinuxSnap&&(u["common.snap"]="true");const l=P(k);l&&(u["common.platformDetail"]=l);try{const s=await S.readFile(D.URI.file(v));u["common.source"]=s.value.toString().slice(0,30)}catch{}return u}e.resolveCommonProperties=E;function w(S){const b=n.env.USERDNSDOMAIN;if(!b)return!1;const k=b.toLowerCase();return S.some(y=>k===y)}e.verifyMicrosoftInternalDomain=w}),define(ee[30],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,p.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ee[210],te([0,1,26,70,8,43,10,9,3,7,73,24,86,75,18,22,30]),function(j,e,p,n,D,M,P,E,w,S,b,k,y,g,t,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function v(o,l){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}];let i;const r=p.homedir().toLowerCase();switch(process.platform){case"win32":i=[{tag:"gdrive",matcher:N=>/^[a-z]:\\(my drive|shared drives)\\/.test(N)||N.startsWith(r+"\\my drive\\")},{tag:"dropbox",matcher:N=>N.startsWith(r+"\\dropbox")},{tag:"onedrive",matcher:N=>N.startsWith(r+"\\onedrive")},{tag:"box",matcher:N=>N.startsWith(r+"\\box\\")},{tag:"nextcloud",matcher:N=>N.startsWith(r+"\\nextcloud\\")},{tag:"owncloud",matcher:N=>N.startsWith(r+"\\owncloud\\")}];break;case"darwin":i=[{tag:"gdrive",matcher:N=>N.startsWith("/volumes/googledrive/")||N.startsWith(r+"/my drive/")},{tag:"dropbox",matcher:N=>N.startsWith(r+"/dropbox")},{tag:"onedrive",matcher:N=>N.startsWith(r+"/onedrive")||N.startsWith(r+"/library/cloudstorage/onedrive")},{tag:"icloud",matcher:N=>N.startsWith(r+"/library/mobile documents/")},{tag:"box",matcher:N=>N.startsWith(r+"/box/")},{tag:"nextcloud",matcher:N=>N.startsWith(r+"/nextcloud/")},{tag:"owncloud",matcher:N=>N.startsWith(r+"/owncloud/")}];break}const a=new Map,h=new Map,I=2e4;function R(N,J,oe,re){for(const Z of i){const H=N.toLowerCase();Z.matcher(H)&&h.set(Z.tag,1)}const V=J.substring(N.length+1);return D.Promises.withAsyncBody(async Z=>{let H;try{H=await k.Promises.readdir(J,{withFileTypes:!0})}catch{Z();return}if(re.count>=I){re.count+=H.length,re.maxReached=!0,Z();return}let K=H.length;if(K===0){Z();return}let G=H;re.count+H.length>I&&(re.maxReached=!0,K=I-re.count,G=H.slice(0,K)),re.count+=H.length;for(const z of G)if(z.isDirectory()){if(oe.includes(z.name)||await R(N,(0,E.join)(J,z.name),oe,re),--K==0){Z();return}}else{const B=z.name.lastIndexOf(".");if(B>=0){const Y=z.name.substring(B+1);Y&&a.set(Y,(a.get(Y)??0)+1)}for(const Y of s)Y.relativePathPattern?.test(V)!==!1&&Y.filePattern.test(z.name)&&h.set(Y.tag,(h.get(Y.tag)??0)+1);if(--K==0){Z();return}}})}const L={count:0,maxReached:!1};await R(o,o,l,L);const W=await f(o);return{configFiles:C(h),fileTypes:C(a),fileCount:L.count,maxFilesReached:L.maxReached,launchConfigFiles:W}}e.collectWorkspaceStats=v;function C(o){return[...n.Iterable.map(o.entries(),([l,s])=>({name:l,count:s}))].sort((l,s)=>s.count-l.count)}function u(){const o={os:`${p.type()} ${p.arch()} ${p.release()}`,memory:`${(p.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(b.virtualMachineHint.value()*100)}%`},l=p.cpus();return l&&l.length>0&&(o.cpus=`${l[0].model} (${l.length} x ${l[0].speed})`),o}e.getMachineInfo=u;async function f(o){try{const l=new Map,s=(0,E.join)(o,".vscode","launch.json"),i=await k.Promises.readFile(s),r=[],a=(0,M.parse)(i.toString(),r);if(r.length)return console.log(`Unable to parse ${s}`),[];if((0,M.getNodeType)(a)==="object"&&a.configurations)for(const h of a.configurations){const I=h.type;I&&(l.has(I)?l.set(I,l.get(I)+1):l.set(I,1))}return C(l)}catch{return[]}}e.collectLaunchConfigs=f;let c=class{constructor(l,s){this.telemetryService=l,this.productService=s}formatMachineInfo(l){const s=[];return s.push(`OS Version:       ${l.os}`),s.push(`CPUs:             ${l.cpus}`),s.push(`Memory (System):  ${l.memory}`),s.push(`VM:               ${l.vmHint}`),s.join(`
`)}formatEnvironment(l){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${p.type()} ${p.arch()} ${p.release()}`);const i=p.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(p.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),w.isWindows||s.push(`Load (avg):       ${p.loadavg().map(r=>Math.round(r)).join(", ")}`),s.push(`VM:               ${Math.round(b.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${l.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${l.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(l.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(l,s){return Promise.all([(0,y.listProcesses)(l.mainPID),this.formatWorkspaceMetadata(l)]).then(async i=>{let[r,a]=i,h=this.formatProcessList(l,r);return s.forEach(I=>{if((0,g.isRemoteDiagnosticError)(I))h+=`
${I.errorMessage}`,a+=`
${I.errorMessage}`;else if(h+=`

Remote: ${I.hostName}`,I.processes&&(h+=`
${this.formatProcessList(l,I.processes)}`),I.workspaceMetadata){a+=`
|  Remote: ${I.hostName}`;for(const R of Object.keys(I.workspaceMetadata)){const L=I.workspaceMetadata[R];let W=`${L.fileCount} files`;L.maxFilesReached&&(W=`more than ${W}`),a+=`|    Folder (${R}): ${W}`,a+=this.formatWorkspaceStats(L)}}}),{processInfo:h,workspaceInfo:a}})}async getSystemInfo(l,s){const{memory:i,vmHint:r,os:a,cpus:h}=u(),I={os:a,memory:i,cpus:h,vmHint:r,processArgs:`${l.mainArguments.join(" ")}`,gpuStatus:l.gpuFeatureStatus,screenReader:`${l.screenReader?"yes":"no"}`,remoteData:s};return w.isWindows||(I.load=`${p.loadavg().map(R=>Math.round(R)).join(", ")}`),w.isLinux&&(I.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(I)}async getDiagnostics(l,s){const i=[];return(0,y.listProcesses)(l.mainPID).then(async r=>(i.push(""),i.push(this.formatEnvironment(l)),i.push(""),i.push(this.formatProcessList(l,r)),l.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(l))),s.forEach(a=>{if((0,g.isRemoteDiagnosticError)(a))i.push(`
${a.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${a.hostName}`),i.push(this.formatMachineInfo(a.machineInfo)),a.processes&&i.push(this.formatProcessList(l,a.processes)),a.workspaceMetadata)for(const h of Object.keys(a.workspaceMetadata)){const I=a.workspaceMetadata[h];let R=`${I.fileCount} files`;I.maxFilesReached&&(R=`more than ${R}`),i.push(`Folder (${h}): ${R}`),i.push(this.formatWorkspaceStats(I))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(l){const s=[],i=60;let r=0;const a=(L,W)=>{const N=` ${L}(${W})`;r+N.length>i?(s.push(h),h="|                 ",r=h.length):r+=N.length,h+=N};let h="|      File types:";const I=10;let R=l.fileTypes.length>I?I:l.fileTypes.length;for(let L=0;L<R;L++){const W=l.fileTypes[L];a(W.name,W.count)}if(s.push(h),l.configFiles.length>=0&&(h="|      Conf files:",r=0,l.configFiles.forEach(L=>{a(L.name,L.count)}),s.push(h)),l.launchConfigFiles.length>0){let L="|      Launch Configs:";l.launchConfigFiles.forEach(W=>{L+=W.count>1?` ${W.name}(${W.count})`:` ${W.name}`}),s.push(L)}return s.join(`
`)}expandGPUFeatures(l){const s=Math.max(...Object.keys(l).map(i=>i.length));return Object.keys(l).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${l[i]}`).join(`
                  `)}formatWorkspaceMetadata(l){const s=[],i=[];return l.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(s.push(`|  Window (${r.title})`),r.folderURIs.forEach(a=>{const h=S.URI.revive(a);if(h.scheme===P.Schemas.file){const I=h.fsPath;i.push(v(I,["node_modules",".git"]).then(R=>{let L=`${R.fileCount} files`;R.maxFilesReached&&(L=`more than ${L}`),s.push(`|    Folder (${(0,E.basename)(I)}): ${L}`),s.push(this.formatWorkspaceStats(R))}).catch(R=>{s.push(`|      Error: Unable to collect workspace stats for folder ${I} (${R.toString()})`)}))}else s.push(`|    Folder (${h.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(r=>s.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(l,s){const i=new Map;l.windows.forEach(a=>i.set(a.pid,a.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(l.mainPID,i,r,s,0),r.join(`
`)}formatProcessItem(l,s,i,r,a){const h=a===0;let I;h?I=r.pid===l?`${this.productService.applicationName} main`:"remote agent":(I=`${"  ".repeat(a)} ${r.name}`,r.name==="window"&&(I=`${I} (${s.get(r.pid)})`));const R=process.platform==="win32"?r.mem:p.totalmem()*(r.mem/100);i.push(`${r.load.toFixed(0).padStart(5," ")}	${(R/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${I}`),Array.isArray(r.children)&&r.children.forEach(L=>this.formatProcessItem(l,s,i,L,a+1))}async reportWorkspaceStats(l){for(const{uri:s}of l.folders){const i=S.URI.revive(s);if(i.scheme!==P.Schemas.file)continue;const r=i.fsPath;try{const a=await v(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":l.telemetryId,rendererSessionId:l.rendererSessionId}),a.fileTypes.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:l.rendererSessionId,type:h.name,count:h.count})}),a.launchConfigFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:l.rendererSessionId,type:h.name,count:h.count})}),a.configFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:l.rendererSessionId,type:h.name,count:h.count})})}catch{}}}};c=de([ne(0,m.ITelemetryService),ne(1,d.IProductService)],c),e.DiagnosticsService=c}),define(ee[211],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class p{constructor(M){this.appenders=M}listen(M,P){throw new Error(`Event not found: ${P}`)}call(M,P,{eventName:E,data:w}){return this.appenders.forEach(S=>S.log(E,w)),Promise.resolve(null)}}e.TelemetryAppenderChannel=p;class n{constructor(M){this.channel=M}log(M,P){return this.channel.call("log",{eventName:M,data:P}).then(void 0,E=>`Failed to log telemetry: ${console.warn(E)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(ee[66],te([0,1,47,13,19,30]),function(j,e,p,n,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class P{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(v,C){return Promise.resolve(void 0)}publicLog2(v,C){return this.publicLog(v,C)}publicLogError(v,C){return Promise.resolve(void 0)}publicLogError2(v,C){return this.publicLogError(v,C)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class E{async publicLog(v,C,u){}async publicLogError(v,C,u){}}e.NullEndpointTelemetryService=E,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(m,v){return v.onDidChangeConfiguration(C=>{C.source!==6&&m.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(C.source),configurationKeys:t(C.sourceConfig)})})}e.configurationTelemetry=w;function S(m,v){return!(v.disableTelemetry||!m.enableTelemetry||v.extensionTestsLocationURI)}e.supportsTelemetry=S;function b(m){const v=m.getValue(M.TELEMETRY_SETTING_ID),C=m.getValue("telemetry.enableCrashReporter");if(m.getValue(M.TELEMETRY_OLD_SETTING_ID)===!1||C===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=b;function k(m){const v=Object.create(null),C=Object.create(null),u=Object.create(null);g(m,u);for(let f in u){f=f.length>150?f.substr(f.length-149):f;const c=u[f];typeof c=="number"?C[f]=c:typeof c=="boolean"?C[f]=c?1:0:typeof c=="string"?(c.length>8192&&console.warn(`Telemetry property: ${f} has been trimmed to 8192, the original length is ${c.length}`),v[f]=c.substring(0,8191)):typeof c!="undefined"&&c!==null&&(v[f]=c)}return{properties:v,measurements:C}}e.validateTelemetryData=k;function y(m){if(!m)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(u=>{m.indexOf(`${u}+`)===0&&(v=u)}),v}e.cleanRemoteAuthority=y;function g(m,v,C=0,u){if(!!m)for(let f of Object.getOwnPropertyNames(m)){const c=m[f],o=u?u+f:f;Array.isArray(c)?v[o]=(0,p.safeStringify)(c):c instanceof Date?v[o]=c.toISOString():(0,n.isObject)(c)?C<2?g(c,v,C+1,o+"."):v[o]=(0,p.safeStringify)(c):v[o]=c}}function t(m){if(!m)return[];const v=[];return d(v,"",m),v}function d(m,v,C){C&&typeof C=="object"&&!Array.isArray(C)?Object.keys(C).forEach(u=>d(m,v?`${v}.${u}`:u,C[u])):m.push(v)}}),define(ee[212],te([0,1,27,21,15,47,3,34,13,7,19,48,203,98,170,18,6,22,49,206,79,30,66]),function(j,e,p,n,D,M,P,E,w,S,b,k,y,g,t,d,m,v,C,u,f,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const l=P.isWeb?"web":(0,y.getTargetPlatform)(P.platform,E.arch);var s;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished",O[O.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function i(...O){return String(O.reduce((_,Q)=>_|Q,0))}var r;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},h={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},R={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class L{constructor(_=R){this.state=_}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(_,Q=this.state.pageSize){return new L({...this.state,pageNumber:_,pageSize:Q})}withFilter(_,...Q){const ie=[...this.state.criteria,...Q.length?Q.map(se=>({filterType:_,value:se})):[{filterType:_}]];return new L({...this.state,criteria:ie})}withSortBy(_){return new L({...this.state,sortBy:_})}withSortOrder(_){return new L({...this.state,sortOrder:_})}withFlags(..._){return new L({...this.state,flags:_.reduce((Q,ie)=>Q|ie,0)})}withAssetTypes(..._){return new L({...this.state,assetTypes:_})}get raw(){const{criteria:_,pageNumber:Q,pageSize:ie,sortBy:se,sortOrder:x,flags:ce,assetTypes:le}=this.state;return{filters:[{criteria:_,pageNumber:Q,pageSize:ie,sortBy:se,sortOrder:x}],assetTypes:le,flags:ce}}get searchText(){const _=this.state.criteria.filter(Q=>Q.filterType===r.SearchText)[0];return _&&_.value?_.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(_=>String(_.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function W(O,_){const Q=(O||[]).filter(ie=>ie.statisticName===_)[0];return Q?Q.value:0}function N(O){const _="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(ie=>ie.assetType.indexOf(_)===0).reduce((ie,se)=>{const x=V(O,se.assetType);return x&&ie.push([se.assetType.substring(_.length),x]),ie},[])}function J(O){if(O.properties){const _=O.properties.filter(se=>se.key===a.Repository),Q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=_.filter(se=>Q.test(se.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return V(O,a.Repository)}function oe(O){return{uri:`${O.fallbackAssetUri}/${a.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${a.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function re(O){const _=V(O,a.Icon);if(_)return _;const Q=y.DefaultIconPath;return{uri:Q,fallbackUri:Q}}function V(O,_){return O.files.filter(ie=>ie.assetType===_)[0]?{uri:`${O.assetUri}/${_}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${_}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function Z(O,_){const Q=O.properties?O.properties.filter(se=>se.key===_):[],ie=Q.length>0&&Q[0].value;return ie?ie.split(",").map(se=>(0,g.adoptToGalleryExtensionId)(se)):[]}function H(O){const _=O.properties?O.properties.filter(Q=>Q.key===h.Engine):[];return _.length>0&&_[0].value||""}function K(O){const _=O.properties?O.properties.filter(Q=>Q.key===h.PreRelease):[];return _.length>0&&_[0].value==="true"}function G(O){const _=O.properties?O.properties.filter(ie=>ie.key===h.LocalizedLanguages):[],Q=_.length>0&&_[0].value||"";return Q?Q.split(","):[]}function z(O){return O.indexOf("preview")!==-1}function B(O){return O.targetPlatform?(0,y.toTargetPlatform)(O.targetPlatform):"undefined"}function Y(O){const _=(0,p.distinct)(O.versions.map(B)),Q=!!O.tags?.includes(y.WEB_EXTENSION_TAG),ie=_.indexOf("web");return Q?ie===-1&&_.push("web"):ie!==-1&&_.splice(ie,1),_}function q(O,_){const Q=(0,y.getFallbackTargetPlarforms)(_);for(let ie=0;ie<O.length;ie++){const se=O[ie];if(se.version===O[ie-1]?.version){let x=ie;const ce=B(se);if(ce===_)for(;x>0&&O[x-1].version===se.version;)x--;else if(Q.includes(ce))for(;x>0&&O[x-1].version===se.version&&B(O[x-1])!==_;)x--;x!==ie&&(O.splice(ie,1),O.splice(x,0,se))}}return O}e.sortExtensionVersions=q;function F(O,_,Q){const ie=O.versions[0],se={manifest:V(_,a.Manifest),readme:V(_,a.Details),changelog:V(_,a.Changelog),license:V(_,a.License),repository:J(_),download:oe(_),icon:re(_),coreTranslations:N(_)};return{identifier:{id:(0,g.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:_.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,description:O.shortDescription||"",installCount:W(O.statistics,"install"),rating:W(O.statistics,"averagerating"),ratingCount:W(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:Q,assets:se,properties:{dependencies:Z(_,h.Dependency),extensionPack:Z(_,h.ExtensionPack),engine:H(_),localizedLanguages:G(_),targetPlatform:B(_),isPreReleaseVersion:K(_)},hasPreReleaseVersion:K(ie),hasReleaseVersion:!0,preview:z(O.flags)}}let $=class{constructor(_,Q,ie,se,x,ce,le,he){this.requestService=Q,this.logService=ie,this.environmentService=se,this.telemetryService=x,this.fileService=ce,this.productService=le,this.configurationService=he;const me=le.extensionsGallery;this.extensionsGalleryUrl=me&&me.serviceUrl,this.extensionsControlUrl=me&&me.controlUrl,this.commonHeadersPromise=U(le.version,le,this.environmentService,this.configurationService,this.fileService,_)}api(_=""){return`${this.extensionsGalleryUrl}${_}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(_,Q,ie){const se=n.CancellationToken.isCancellationToken(Q)?{targetPlatform:l}:Q,x=n.CancellationToken.isCancellationToken(Q)?Q:ie,ce=[],le=[],he=[],me=[];for(const fe of _)fe.uuid?le.push(fe.uuid):ce.push(fe.id),he.push({...fe,preRelease:!!fe.preRelease}),fe.version&&me.push({...fe,version:fe.version});if(!le.length&&!ce.length)return[];let pe=new L().withPage(1,_.length);le.length&&(pe=pe.withFilter(r.ExtensionId,...le)),ce.length&&(pe=pe.withFilter(r.ExtensionName,...ce));const{extensions:ge}=await this.queryGalleryExtensions(pe,{targetPlatform:se.targetPlatform,preRelease:he,versions:me,compatible:!!se.compatible},x);return ge}async getCompatibleExtension(_,Q,ie){if((0,y.isNotWebExtensionInWebTargetPlatform)(_.allTargetPlatforms,ie))return null;if(await this.isExtensionCompatible(_,Q,ie))return _;const se=new L().withFlags(s.IncludeVersions).withPage(1,1).withFilter(r.ExtensionId,_.identifier.uuid),{extensions:x}=await this.queryGalleryExtensions(se,{targetPlatform:ie,compatible:!0,preRelease:Q},n.CancellationToken.None);return x[0]||null}async isExtensionCompatible(_,Q,ie){if(!(0,y.isTargetPlatformCompatible)(_.properties.targetPlatform,_.allTargetPlatforms,ie)||!Q&&_.properties.isPreReleaseVersion)return!1;let se=_.properties.engine;if(!se){const x=await this.getManifest(_,n.CancellationToken.None);if(!x)throw new Error("Manifest was not found");se=x.engines.vscode}return(0,t.isEngineValid)(se,this.productService.version,this.productService.date)}async isValidVersion(_,Q,ie,se,x){if(!(0,y.isTargetPlatformCompatible)(B(_),se,x)||!Q&&K(_))return!1;if(ie){const ce=await this.getEngine(_);if(!(0,t.isEngineValid)(ce,this.productService.version,this.productService.date))return!1}return!0}async query(_,Q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ie=_.text||"";const se=(0,M.getOrDefault)(_,pe=>pe.pageSize,50);let x=new L().withPage(1,se);ie?(ie=ie.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,ge,fe)=>(x=x.withFilter(r.Category,fe||ge),"")),ie=ie.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,ge,fe)=>(x=x.withFilter(r.Tag,fe||ge),"")),ie=ie.replace(/\bfeatured(\s+|\b|$)/g,()=>(x=x.withFilter(r.Featured),"")),ie=ie.trim(),ie&&(ie=ie.length<200?ie:ie.substring(0,200),x=x.withFilter(r.SearchText,ie)),x=x.withSortBy(0)):_.ids?x=x.withFilter(r.ExtensionId,..._.ids):_.names?x=x.withFilter(r.ExtensionName,..._.names):x=x.withSortBy(4),typeof _.sortBy=="number"&&(x=x.withSortBy(_.sortBy)),typeof _.sortOrder=="number"&&(x=x.withSortOrder(_.sortOrder));const ce=async(pe,ge)=>{const{extensions:fe,total:Ie}=await this.queryGalleryExtensions(pe,{targetPlatform:l,compatible:!1,preRelease:!!_.includePreRelease},ge);return fe.forEach((Pe,Te)=>Pe.telemetryData={index:(pe.pageNumber-1)*pe.pageSize+Te,querySource:_.source}),{extensions:fe,total:Ie}},{extensions:le,total:he}=await ce(x,Q),me=async(pe,ge)=>{if(ge.isCancellationRequested)throw new D.CancellationError;const{extensions:fe}=await ce(x.withPage(pe+1),ge);return fe};return{firstPage:le,total:he,pageSize:x.pageSize,getPage:me}}async queryGalleryExtensions(_,Q,ie){const se=_.flags;!!(_.flags&s.IncludeLatestVersionOnly)&&!!(_.flags&s.IncludeVersions)&&(_=_.withFlags(_.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(_.flags&s.IncludeLatestVersionOnly)&&!(_.flags&s.IncludeVersions)&&(_=_.withFlags(_.flags,s.IncludeLatestVersionOnly)),Q.versions?.length&&(_=_.withFlags(_.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),_=_.withFlags(_.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:x,total:ce}=await this.queryRawGalleryExtensions(_,ie);if(!(_.flags&s.IncludeLatestVersionOnly)){const pe=[];for(const ge of x){const fe=await this.toGalleryExtensionWithCriteria(ge,Q,!0);fe&&pe.push(fe)}return{extensions:pe,total:ce}}const he=[],me=new Map;for(let pe=0;pe<x.length;pe++){const ge=x[pe],fe={id:(0,g.getGalleryExtensionId)(ge.publisher.publisherName,ge.extensionName),uuid:ge.extensionId},Ie=(0,w.isBoolean)(Q.preRelease)?Q.preRelease:!!Q.preRelease.find(Te=>(0,g.areSameExtensions)(Te,fe))?.preRelease;let Pe=await this.toGalleryExtensionWithCriteria(ge,Q,!1);!Pe||Pe.properties.isPreReleaseVersion&&(!Ie||!Pe.hasReleaseVersion)||!Pe.properties.isPreReleaseVersion&&Pe.properties.targetPlatform!==Q.targetPlatform&&Pe.hasPreReleaseVersion?me.set(ge.extensionId,pe):he.push([pe,Pe])}if(me.size){const pe=new Date().getTime(),ge=new L().withFlags(se&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,me.size).withFilter(r.ExtensionId,...me.keys()),{extensions:fe}=await this.queryGalleryExtensions(ge,Q,ie);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-pe,count:me.size});for(const Ie of fe){const Pe=me.get(Ie.identifier.uuid);he.push([Pe,Ie])}}return{extensions:he.sort((pe,ge)=>pe[0]-ge[0]).map(([,pe])=>pe),total:ce}}async toGalleryExtensionWithCriteria(_,Q,ie){const se={id:(0,g.getGalleryExtensionId)(_.publisher.publisherName,_.extensionName),uuid:_.extensionId},x=Q.versions?.find(me=>(0,g.areSameExtensions)(me,se))?.version,ce=(0,w.isBoolean)(Q.preRelease)?Q.preRelease:!!Q.preRelease.find(me=>(0,g.areSameExtensions)(me,se))?.preRelease,le=Y(_),he=q(_.versions,Q.targetPlatform);if(Q.compatible&&ie&&(0,y.isNotWebExtensionInWebTargetPlatform)(le,Q.targetPlatform))return null;for(let me=0;me<he.length;me++){const pe=he[me];if(!(x&&pe.version!==x)){if(await this.isValidVersion(pe,ce,Q.compatible,le,Q.targetPlatform))return F(_,pe,le);if(x&&pe.version===x)return null}}return x||Q.compatible?null:F(_,_.versions[0],le)}async queryRawGalleryExtensions(_,Q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");_=_.withFlags(_.flags,s.ExcludeNonValidated).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExcludeWithFlags,i(s.Unpublished));const ie=await this.commonHeadersPromise,se=JSON.stringify(_.raw),x={...ie,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(se.length)},ce=new Date().getTime();let le,he,me=0;try{if(le=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:se,headers:x},Q),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:me};const pe=await(0,C.asJson)(le);if(pe){const ge=pe.results[0],fe=ge.extensions,Ie=ge.resultMetadata&&ge.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return me=Ie&&Ie.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:fe,total:me}}return{galleryExtensions:[],total:me}}catch(pe){throw he=pe,pe}finally{this.telemetryService.publicLog2("galleryService:query",{..._.telemetryData,requestBodySize:String(se.length),duration:new Date().getTime()-ce,success:!!le&&(0,C.isSuccess)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:he?(0,D.isCancellationError)(he)?"canceled":(0,D.getErrorMessage)(he).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(me)})}}async reportStatistic(_,Q,ie,se){if(!this.isEnabled())return;const x=P.isWeb?this.api(`/itemName/${_}.${Q}/version/${ie}/statType/${se==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${_}/extensions/${Q}/${ie}/stats?statType=${se}`),ce=P.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",he={...await this.commonHeadersPromise,Accept:ce};try{await this.requestService.request({type:"POST",url:x,headers:he},n.CancellationToken.None)}catch{}}async download(_,Q,ie){this.logService.trace("ExtensionGalleryService#download",_.identifier.id);const se=(0,g.getGalleryExtensionTelemetryData)(_),x=new Date().getTime(),ce=pe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...se,duration:pe}),le=ie===2?"install":ie===3?"update":"",he=le?{uri:`${_.assets.download.uri}${S.URI.parse(_.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${_.assets.download.fallbackUri}${S.URI.parse(_.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:_.assets.download,me=await this.getAsset(he);await this.fileService.writeFile(Q,me.stream),ce(new Date().getTime()-x)}async getReadme(_,Q){if(_.assets.readme){const ie=await this.getAsset(_.assets.readme,{},Q);return await(0,C.asText)(ie)||""}return""}async getManifest(_,Q){if(_.assets.manifest){const ie=await this.getAsset(_.assets.manifest,{},Q),se=await(0,C.asText)(ie);return se?JSON.parse(se):null}return null}async getManifestFromRawExtensionVersion(_,Q){const ie=V(_,a.Manifest);if(!ie)throw new Error("Manifest was not found");const se={"Accept-Encoding":"gzip"},x=await this.getAsset(ie,{headers:se});return await(0,C.asJson)(x)}async getCoreTranslation(_,Q){const ie=_.assets.coreTranslations.filter(se=>se[0]===Q.toUpperCase())[0];if(ie){const se=await this.getAsset(ie[1]),x=await(0,C.asText)(se);return x?JSON.parse(x):null}return null}async getChangelog(_,Q){if(_.assets.changelog){const ie=await this.getAsset(_.assets.changelog,{},Q);return await(0,C.asText)(ie)||""}return""}async getAllCompatibleVersions(_,Q,ie){let se=new L().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);_.identifier.uuid?se=se.withFilter(r.ExtensionId,_.identifier.uuid):se=se.withFilter(r.ExtensionName,_.identifier.id);const{galleryExtensions:x}=await this.queryRawGalleryExtensions(se,n.CancellationToken.None);if(!x.length)return[];const ce=Y(x[0]);if((0,y.isNotWebExtensionInWebTargetPlatform)(ce,ie))return[];const le=[],he=new Set;return await Promise.all(x[0].versions.map(async me=>{try{if(he.has(me.version))return;he.add(me.version),await this.isValidVersion(me,Q,!0,ce,ie)&&le.push({version:me.version,date:me.lastUpdated,isPreReleaseVersion:K(me)})}catch{}})),le}async getAsset(_,Q={},ie=n.CancellationToken.None){const se=await this.commonHeadersPromise,x={type:"GET"},ce={...se,...Q.headers||{}};Q={...Q,...x,headers:ce};const le=_.uri,he=_.fallbackUri,me={...Q,url:le};try{const pe=await this.requestService.request(me,ie);if(pe.res.statusCode===200)return pe;const ge=await(0,C.asText)(pe);throw new Error(`Expected 200, got back ${pe.res.statusCode} instead.

${ge}`)}catch(pe){if((0,D.isCancellationError)(pe))throw pe;const ge=(0,D.getErrorMessage)(pe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:le,message:ge});const fe={...Q,url:he};return this.requestService.request(fe,ie)}}async getEngine(_){let Q=H(_);if(!Q){const ie=await this.getManifestFromRawExtensionVersion(_,n.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");Q=ie.engines.vscode}return Q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const _=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(_.res.statusCode!==200)throw new Error("Could not get extensions report.");const Q=await(0,C.asJson)(_),ie=[],se={};if(Q){for(const x of Q.malicious)ie.push({id:x});if(Q.unsupported)for(const x of Object.keys(Q.unsupported)){const ce=Q.unsupported[x];(0,w.isBoolean)(ce)||(se[x.toLowerCase()]=ce.preReleaseExtension)}if(Q.migrateToPreRelease)for(const[x,ce]of Object.entries(Q.migrateToPreRelease))(!ce.engine||(0,t.isEngineValid)(ce.engine,this.productService.version,this.productService.date))&&(se[x.toLowerCase()]=ce)}return{malicious:ie,unsupportedPreReleaseExtensions:se}}};$=de([ne(1,C.IRequestService),ne(2,m.ILogService),ne(3,k.IEnvironmentService),ne(4,c.ITelemetryService),ne(5,d.IFileService),ne(6,v.IProductService),ne(7,b.IConfigurationService)],$);let A=class extends ${constructor(_,Q,ie,se,x,ce,le,he){super(_,Q,ie,se,x,ce,le,he)}};A=de([ne(0,f.IStorageService),ne(1,C.IRequestService),ne(2,m.ILogService),ne(3,k.IEnvironmentService),ne(4,c.ITelemetryService),ne(5,d.IFileService),ne(6,v.IProductService),ne(7,b.IConfigurationService)],A),e.ExtensionGalleryService=A;let T=class extends ${constructor(_,Q,ie,se,x,ce,le){super(void 0,_,Q,ie,se,x,ce,le)}};T=de([ne(0,C.IRequestService),ne(1,m.ILogService),ne(2,k.IEnvironmentService),ne(3,c.ITelemetryService),ne(4,d.IFileService),ne(5,v.IProductService),ne(6,b.IConfigurationService)],T),e.ExtensionGalleryServiceWithNoStorageService=T;async function U(O,_,Q,ie,se,x){const ce={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${_.nameShort})`},le=await(0,u.getServiceMachineId)(Q,se,x);return(0,o.supportsTelemetry)(_,Q)&&(0,o.getTelemetryLevel)(ie)===3&&(ce["X-Market-User-Id"]=le),ce}e.resolveMarketplaceHeaders=U}),define(ee[213],te([0,1,2,47,3,25,155,19,56,54,40,30,66]),function(j,e,p,n,D,M,P,E,w,S,b,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let g=class{constructor(m,v){this._configurationService=v,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appenders=m.appenders,this._commonProperties=m.commonProperties||Promise.resolve({}),this._piiPaths=m.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!m.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let C of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,M.escapeRegExpCharacters)(C),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(C=>{const u=/^[a-f0-9]+$/i.test(C["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!u})})}setExperimentProperty(m,v){this._experimentProperties[m]=v}_updateTelemetryLevel(){this._telemetryLevel=(0,y.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const m=await this._commonProperties;let v=m.sessionID,C=m["common.machineId"],u=m["common.firstSessionDate"],f=m["common.msftInternal"];return{sessionId:v,machineId:C,firstSessionDate:u,msftInternal:f}}dispose(){this._disposables.dispose()}_log(m,v,C,u){return this.telemetryLevel<v?Promise.resolve(void 0):this._commonProperties.then(f=>{C=(0,n.mixin)(C,f),C=(0,n.mixin)(C,this._experimentProperties),C=(0,n.cloneAndChange)(C,c=>{if(typeof c=="string")return this._cleanupInfo(c,u)}),this._appenders.forEach(c=>c.log(m,C))},f=>{console.error(f)})}publicLog(m,v,C){return this._log(m,3,v,C)}publicLog2(m,v,C){return this.publicLog(m,v,C)}publicLogError(m,v){return this.sendErrorTelemetry?this._log(m,2,v,!0):Promise.resolve(void 0)}publicLogError2(m,v){return this.publicLogError(m,v)}_anonymizeFilePaths(m){let v=m;const C=[];for(let o of this._cleanupPatterns)for(;;){const l=o.exec(m);if(!l)break;C.push([l.index,o.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(v="";;){const o=f.exec(m);if(!o)break;!u.test(o[0])&&C.every(([l,s])=>o.index<l||o.index>=s)&&(v+=m.substring(c,o.index)+"<REDACTED: user-file-path>",c=f.lastIndex)}return c<m.length&&(v+=m.substr(c)),v}_removePropertiesWithPossibleUserInfo(m){if(!m)return m;const v=m.toLowerCase(),C=/@[a-zA-Z0-9-.]+/,u=/(key|token|sig|signature|password|passwd|pwd)[="':\s]/,f=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return u.test(v)?"<REDACTED: secret>":C.test(v)?"<REDACTED: email>":f.test(v)?"<REDACTED: token>":m}_cleanupInfo(m,v){let C=m;v&&(C=this._anonymizeFilePaths(C));for(let u of this._cleanupPatterns)C=C.replace(u,"");return C=this._removePropertiesWithPossibleUserInfo(C),C}};g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",g=de([ne(1,E.IConfigurationService)],g),e.TelemetryService=g;function t(){const d=(0,P.localize)(0,null,S.default.nameLong),m=S.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",S.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=D.isWeb?"":(0,P.localize)(3,null),C=(0,P.localize)(4,null),u=(0,P.localize)(5,null),f=(0,P.localize)(6,null),c=(0,P.localize)(7,null),o=`
|       | ${C} | ${u} | ${f} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,l=(0,P.localize)(8,null);return`
${d} ${m} ${v}

&nbsp;

${c}
${o}

&nbsp;

${l}
`}b.Registry.as(w.Extensions.Configuration).registerConfiguration({id:k.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(9,null),properties:{[k.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(w.Extensions.Configuration).registerConfiguration({id:k.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[k.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,P.localize)(16,null,S.default.nameLong,S.default.privacyStatementUrl):(0,P.localize)(15,null,S.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${k.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[214],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(n){n.DARK="dark",n.LIGHT="light",n.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(ee[215],te([0,1,105,4,2,5,40,214]),function(j,e,p,n,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var w;(function(m){function v(C){return C&&typeof C=="object"&&typeof C.id=="string"}m.isThemeColor=v})(w=e.ThemeColor||(e.ThemeColor={}));function S(m){return{id:m}}e.themeColorFromId=S;var b;(function(m){function v(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||w.isThemeColor(i.color))}m.isThemeIcon=v;const C=new RegExp(`^\\$\\((${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?)\\)$`);function u(i){const r=C.exec(i);if(!r)return;let[,a]=r;return{id:a}}m.fromString=u;function f(i){return{id:i}}m.fromId=f;function c(i,r){let a=i.id;const h=a.lastIndexOf("~");return h!==-1&&(a=a.substring(0,h)),r&&(a=`${a}~${r}`),{id:a}}m.modify=c;function o(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}m.getModifier=o;function l(i,r){return i.id===r.id&&i.color?.id===r.color?.id}m.isEqual=l;function s(i,r){return{id:i.id,color:r?S(r):void 0}}m.asThemeIcon=s,m.asClassNameArray=p.CSSIcon.asClassNameArray,m.asClassName=p.CSSIcon.asClassName,m.asCSSSelector=p.CSSIcon.asCSSSelector})(b=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=p.Codicon.file,e.FolderThemeIcon=p.Codicon.folder;function k(m){switch(m){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class y{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,D.toDisposable)(()=>{const C=this.themingParticipants.indexOf(v);this.themingParticipants.splice(C,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let g=new y;P.Registry.add(e.Extensions.ThemingContribution,g);function t(m){return g.onColorThemeChange(m)}e.registerThemingParticipant=t;class d extends D.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(C=>this.onThemeChange(C)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,C){let u=this.theme.getColor(v);return u&&C&&(u=C(u,this.theme)),u?u.toString():null}}e.Themable=d}),define(ee[67],te([0,1,14,3,5,38]),function(j,e,p,n,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const P="#FFFFFF",E="#1E1E1E",w="#000000",S="theme",b="themeBackground",k="windowSplash";e.IThemeMainService=(0,D.createDecorator)("themeMainService");let y=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((n.isWindows||n.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme)return w;let t=this.stateMainService.getItem(b,null);if(!t){let d;(n.isWindows||n.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme?d="hc-black":d=this.stateMainService.getItem(S,"vs-dark").split(" ")[0],t=d==="hc-black"?w:d==="vs"?P:E}return n.isMacintosh&&t.toUpperCase()===E&&(t="#171717"),t}saveWindowSplash(t,d){this.stateMainService.setItems([{key:S,data:d.baseTheme},{key:b,data:d.colorInfo.background},{key:k,data:d}]),typeof t=="number"&&this.updateBackgroundColor(t,d)}updateBackgroundColor(t,d){for(const m of p.BrowserWindow.getAllWindows())if(m.id===t){m.setBackgroundColor(d.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(k)}};y=de([ne(0,M.IStateMainService)],y),e.ThemeMainService=y}),define(ee[41],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var n;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(n=e.StateType||(e.StateType={}));var D;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(M,P)=>({type:"idle",updateType:M,error:P}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,p.createDecorator)("updateService")}),define(ee[216],te([0,1,3,156,56,40]),function(j,e,p,n,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.Registry.as(D.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,n.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,n.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,n.localize)(2,null),(0,n.localize)(3,null),(0,n.localize)(4,null),(0,n.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,n.localize)(6,null),deprecationMessage:(0,n.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,n.localize)(8,null),description:(0,n.localize)(9,null),included:p.isWindows&&!p.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,n.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[217],te([0,1,4,41]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class D{constructor(E){this.service=E}listen(E,w){switch(w){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${w}`)}call(E,w,S){switch(w){case"checkForUpdates":return this.service.checkForUpdates(S);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${w}`)}}e.UpdateChannel=D;class M{constructor(E){this.channel=E,this._onStateChange=new p.Emitter,this.onStateChange=this._onStateChange.event,this._state=n.State.Uninitialized,this.channel.listen("onStateChange")(w=>this.state=w),this.channel.call("_getInitialState").then(w=>this.state=w)}get state(){return this._state}set state(E){this._state=E,this._onStateChange.fire(E)}checkForUpdates(E){return this.channel.call("checkForUpdates",E)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=M}),define(ee[100],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,p.createDecorator)("urlService")}),define(ee[218],te([0,1,7]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class n{constructor(E){this.handler=E}listen(E,w){throw new Error(`Event not found: ${w}`)}call(E,w,S){switch(w){case"handleURL":return this.handler.handleURL(p.URI.revive(S[0]),S[1])}throw new Error(`Call not found: ${w}`)}}e.URLHandlerChannel=n;class D{constructor(E){this.channel=E}handleURL(E,w){return this.channel.call("handleURL",[E.toJSON(),w])}}e.URLHandlerChannelClient=D;class M{constructor(E){this.next=E}async routeCall(E,w,S,b){if(w!=="handleURL")throw new Error(`Call not found: ${w}`);if(S){const k=p.URI.revive(S);if(k&&k.query){const y=/\bwindowId=(\d+)/.exec(k.query);if(y){const g=y[1],t=new RegExp(`window:${g}`),d=E.connections.find(m=>t.test(m.ctx));if(d)return d}}}return this.next.routeCall(E,w,S,b)}routeEvent(E,w){throw new Error(`Event not found: ${w}`)}}e.URLHandlerRouter=M}),define(ee[219],te([0,1,8,2,7,22]),function(j,e,p,n,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class P extends n.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(S,b){const k=[...this.handlers.values()];return(0,p.first)(k.map(y=>()=>y.handleURL(S,b)),void 0,!1).then(y=>y||!1)}registerHandler(S){return this.handlers.add(S),(0,n.toDisposable)(()=>this.handlers.delete(S))}}e.AbstractURLService=P;let E=class extends P{constructor(S){super();this.productService=S}create(S){let{authority:b,path:k,query:y,fragment:g}=S||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return b&&k&&k.indexOf("/")!==0&&(k=`/${k}`),D.URI.from({scheme:this.productService.urlProtocol,authority:b,path:k,query:y,fragment:g})}};E=de([ne(0,M.IProductService)],E),e.NativeURLService=E}),define(ee[220],te([0,1,14,8,4,2,3,7]),function(j,e,p,n,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function w(b){try{return E.URI.parse(b)}catch{return null}}class S{constructor(k,y,g,t,d){if(this.urlService=y,this.uris=[],this.retryCount=0,this.flushDisposable=M.Disposable.None,this.disposables=new M.DisposableStore,this.uris=k,P.isWindows){const C=t.isBuilt?[]:[`"${t.appRoot}"`];C.push("--open-url","--"),p.app.setAsDefaultProtocolClient(d.urlProtocol,process.execPath,C)}const m=D.Event.map(D.Event.fromNodeEventEmitter(p.app,"open-url",(C,u)=>({event:C,url:u})),({event:C,url:u})=>(C.preventDefault(),u));this.disposables.add(m(C=>{const u=w(C);!u||this.urlService.open(u,{originalUrl:C})})),g.getWindows().filter(C=>C.isReady).length>0?this.flush():D.Event.once(g.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const k=[];for(const y of this.uris)await this.urlService.open(y.uri,{originalUrl:y.url})||k.push(y);k.length!==0&&(this.uris=k,this.flushDisposable=(0,n.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=S}),define(ee[221],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,p.createDecorator)("webviewManagerService")}),define(ee[222],te([0,1,14,2,10,7]),function(j,e,p,n,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class P extends n.Disposable{constructor(){super();const w=this.handleWebviewRequest.bind(this);p.protocol.registerFileProtocol(D.Schemas.vscodeWebview,w)}handleWebviewRequest(w,S){try{const b=M.URI.parse(w.url),k=P.validWebviewFilePaths.get(b.path);if(typeof k=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${k}`,g=D.FileAccess.asFileUri(y,j);return S(decodeURIComponent(g.fsPath))}else return S({error:-10})}catch{}return S({error:-2})}}e.WebviewProtocolProvider=P,P.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(ee[68],te([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function n(S){return!!S.workspaceUri}e.isWorkspaceToOpen=n;function D(S){return!!S.folderUri}e.isFolderToOpen=D;function M(S){return!!S.fileUri}e.isFileToOpen=M;function P(S){const b=E(S),k=S.getValue("window.menuBarVisibility");return k==="default"||b==="native"&&k==="compact"||p.isMacintosh&&p.isNative?"classic":k}e.getMenuBarVisibility=P;function E(S){if(p.isWeb)return"custom";const b=S.getValue("window");if(b){if(p.isMacintosh&&b.nativeTabs===!0||p.isMacintosh&&b.nativeFullScreen===!1)return"native";const g=S.getValue("workbench.colorCustomizations");if(g?.["window.activeBorder"]||g?.["window.inactiveBorder"])return"custom";const t=b.titleBarStyle;if(t==="native"||t==="custom")return t}return p.isLinux?"native":"custom"}e.getTitleBarStyle=E;function w(S=0){return Math.pow(1.2,S)}e.zoomLevelToZoomFactor=w}),define(ee[36],te([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var n;(function(S){S[S.INITIAL=1]="INITIAL",S[S.LOAD=2]="LOAD",S[S.RELOAD=3]="RELOAD"})(n=e.LoadReason||(e.LoadReason={}));var D;(function(S){S[S.CLOSE=1]="CLOSE",S[S.QUIT=2]="QUIT",S[S.RELOAD=3]="RELOAD",S[S.LOAD=4]="LOAD"})(D=e.UnloadReason||(e.UnloadReason={}));var M;(function(S){S[S.CLI=0]="CLI",S[S.DOCK=1]="DOCK",S[S.MENU=2]="MENU",S[S.DIALOG=3]="DIALOG",S[S.DESKTOP=4]="DESKTOP",S[S.API=5]="API"})(M=e.OpenContext||(e.OpenContext={}));const P=function(S=1){return{width:1024,height:768,mode:S}};e.defaultWindowState=P;var E;(function(S){S[S.Maximized=0]="Maximized",S[S.Normal=1]="Normal",S[S.Minimized=2]="Minimized",S[S.Fullscreen=3]="Fullscreen"})(E=e.WindowMode||(e.WindowMode={}));var w;(function(S){S[S.UNRESPONSIVE=1]="UNRESPONSIVE",S[S.CRASHED=2]="CRASHED",S[S.LOAD=3]="LOAD"})(w=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,p.createDecorator)("windowsMainService")}),define(ee[223],te([0,1,14,21,4,71,2,32,91,6,22,36,95]),function(j,e,p,n,D,M,P,E,w,S,b,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var g;(function(d){d[d.Initial=1]="Initial",d[d.StoredCredentialsUsed=2]="StoredCredentialsUsed",d[d.LoginDialogShown=3]="LoginDialogShown"})(g||(g={}));let t=class extends P.Disposable{constructor(m,v,C,u,f){super();this.logService=m,this.windowsMainService=v,this.credentialsService=C,this.encryptionMainService=u,this.productService=f,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=g.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const m=D.Event.fromNodeEventEmitter(p.app,"login",(v,C,u,f,c)=>({event:v,webContents:C,req:u,authInfo:f,callback:c}));this._register(m(this.onLogin,this))}async onLogin({event:m,authInfo:v,req:C,callback:u}){if(!v.isProxy)return;if(!this.pendingProxyResolve&&this.state===g.LoginDialogShown&&C.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}m.preventDefault();let f;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),f=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(v);try{f=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}u(f?.username,f?.password)}async resolveProxyCredentials(m){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const v=await this.doResolveProxyCredentials(m);if(v)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),v;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(m){this.logService.trace("auth#doResolveProxyCredentials - enter",m);const v=String((0,M.hash)({scheme:m.scheme,host:m.host,port:m.port}));let C,u;try{const l=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v);if(l){const s=JSON.parse(await this.encryptionMainService.decrypt(l));C=s.username,u=s.password}}catch(l){this.logService.error(l)}if(this.state!==g.StoredCredentialsUsed&&typeof C=="string"&&typeof u=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=g.StoredCredentialsUsed,{username:C,password:u};const f=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!f){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${f.id} to handle proxy login`);const c={authInfo:m,username:this.sessionCredentials?.username??C,password:this.sessionCredentials?.password??u,replyChannel:`vscode:proxyAuthResponse:${(0,E.generateUuid)()}`};f.sendWhenReady("vscode:openProxyAuthenticationDialog",n.CancellationToken.None,c),this.state=g.LoginDialogShown;const o=await new Promise(l=>{const s=async(i,r,a)=>{if(r===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${f.id}`),f.win?.webContents.off("ipc-message",s),a){const h={username:a.username,password:a.password};try{if(a.remember){const I=await this.encryptionMainService.encrypt(JSON.stringify(h));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v,I)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v)}catch(I){this.logService.error(I)}l({username:h.username,password:h.password})}else l(void 0)};f.win?.webContents.on("ipc-message",s)});return this.sessionCredentials=o,o}};t=de([ne(0,S.ILogService),ne(1,k.IWindowsMainService),ne(2,y.ICredentialsMainService),ne(3,w.IEncryptionMainService),ne(4,b.IProductService)],t),e.ProxyAuthHandler=t}),define(ee[224],te([0,1,14,4,2,222,36]),function(j,e,p,n,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let E=class extends D.Disposable{constructor(S){super();this.windowsMainService=S,this._onFoundInFrame=this._register(new n.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new M.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(S,b){let k;if(typeof S.windowId=="number"){const{windowId:y}=S,g=this.windowsMainService.getWindowById(y);if(!g?.win)throw new Error(`Invalid windowId: ${y}`);k=g.win.webContents}else{const{webContentsId:y}=S;if(k=p.webContents.fromId(y),!k)throw new Error(`Invalid webContentsId: ${y}`)}k.isDestroyed()||k.setIgnoreMenuShortcuts(b)}async findInFrame(S,b,k,y){const t=this.getFrameByName(S,b);if(typeof t.findInFrame=="function"){t.findInFrame(k,{findNext:y.findNext,forward:y.forward});const d=(m,v)=>{v.finalUpdate&&(this._onFoundInFrame.fire(v),t.removeListener("found-in-frame",d))};t.on("found-in-frame",d)}}async stopFindInFrame(S,b,k){const g=this.getFrameByName(S,b);typeof g.stopFindInFrame=="function"&&g.stopFindInFrame(k.keepSelection?"keepSelection":"clearSelection")}getFrameByName(S,b){const k=this.windowsMainService.getWindowById(S.windowId);if(!k?.win)throw new Error(`Invalid windowId: ${S}`);const y=k.win.webContents.mainFrame.framesInSubtree.find(g=>g.name===b);if(!y)throw new Error(`Unknown frame: ${b}`);return y}};E=de([ne(0,P.IWindowsMainService)],E),e.WebviewMainService=E}),define(ee[225],te([0,1,8,4,2]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class M extends D.Disposable{constructor({onDidOpenWindow:E,onDidFocusWindow:w,getActiveWindowId:S}){super();this.disposables=this._register(new D.DisposableStore),n.Event.latch(n.Event.any(E,w))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,p.createCancelablePromise)(()=>S()),(async()=>{try{const k=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:k}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(E){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=E}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=M}),define(ee[226],te([0,1,35,16,7,5]),function(j,e,p,n,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,M.createDecorator)("contextService");var P;(function(y){y[y.EMPTY=1]="EMPTY",y[y.FOLDER=2]="FOLDER",y[y.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function E(y){const g=y;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}e.isWorkspace=E;function w(y){const g=y;return!!(g&&typeof g=="object"&&D.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}e.isWorkspaceFolder=w;class S{constructor(g,t,d,m,v){this._id=g,this._transient=d,this._configuration=m,this._ignorePathCasing=v,this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=t}update(g){this._id=g.id,this._configuration=g.configuration,this._transient=g.transient,this._ignorePathCasing=g._ignorePathCasing,this.folders=g.folders}get folders(){return this._folders}set folders(g){this._folders=g,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(g){this._configuration=g}getFolder(g){return g&&this._foldersMap.findSubstr(g.with({scheme:g.scheme,authority:g.authority,path:g.path}))||null}updateFoldersMap(){this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing);for(const g of this.folders)this._foldersMap.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=S;class b{constructor(g,t){this.raw=t,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,n.joinPath)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=b;function k(y){return new b({uri:y,index:0,name:(0,n.basenameOrAuthority)(y)},{uri:y.toString()})}e.toWorkspaceFolder=k}),define(ee[31],te([0,1,28,43,107,33,10,9,3,16,7,159,5,65,226]),function(j,e,p,n,D,M,P,E,w,S,b,k,y,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function m(K){return(typeof K=="string"?(0,E.extname)(K):(0,S.extname)(K))===d}e.hasWorkspaceFileExtension=m,e.IWorkspacesService=(0,y.createDecorator)("workspacesService");function v(K){return K.hasOwnProperty("workspace")}e.isRecentWorkspace=v;function C(K){return K.hasOwnProperty("folderUri")}e.isRecentFolder=C;function u(K){return K.hasOwnProperty("fileUri")}e.isRecentFile=u;function f(K){return K&&K.hasOwnProperty("folderUri")}e.isFolderBackupInfo=f;function c(K){return K&&K.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=c;function o(K){const G=K;return typeof G?.id=="string"&&b.URI.isUri(G.uri)}e.isSingleFolderWorkspaceIdentifier=o;function l(K){if(K.configuration)return{id:K.id,configPath:K.configuration};if(K.folders.length===1)return{id:K.id,uri:K.folders[0].uri}}e.toWorkspaceIdentifier=l;function s(K){const G=K;return typeof G?.id=="string"&&b.URI.isUri(G.configPath)}e.isWorkspaceIdentifier=s;function i(K){const G=K;if(G?.uri)return{id:G.id,uri:b.URI.revive(G.uri)};const z=K;if(z?.configPath)return{id:z.id,configPath:b.URI.revive(z.configPath)};if(K?.id)return{id:K.id}}e.reviveIdentifier=i;function r(K,G){return S.extUriBiasedIgnorePathCase.isEqualOrParent(K,G.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function a(K){return h(K)||I(K)}e.isStoredWorkspaceFolder=a;function h(K){const G=K;return typeof G?.path=="string"&&(!G.name||typeof G.name=="string")}e.isRawFileWorkspaceFolder=h;function I(K){const G=K;return typeof G?.uri=="string"&&(!G.name||typeof G.name=="string")}e.isRawUriWorkspaceFolder=I;function R(K,G,z,B,Y=!w.isWindows,q){if(K.scheme!==B.scheme)return{name:z,uri:K.toString(!0)};let F=G?void 0:q.relativePath(B,K);if(F!==void 0)F.length===0?F=".":w.isWindows&&K.scheme===P.Schemas.file&&!Y&&(F=F.replace(/\//g,"\\"));else if(K.scheme===P.Schemas.file)F=K.fsPath,w.isWindows&&(F=(0,M.normalizeDriveLetter)(F),Y&&(F=(0,p.toSlashes)(F)));else{if(!q.isEqualAuthority(K.authority,B.authority))return{name:z,uri:K.toString(!0)};F=K.path}return{name:z,path:F}}e.getStoredWorkspaceFolder=R;function L(K,G,z){let B=[],Y=new Set;const q=z.dirname(G);for(let F of K){let $;if(h(F))F.path&&($=z.resolvePath(q,F.path));else if(I(F))try{$=b.URI.parse(F.uri),$.path[0]!=="/"&&($=$.with({path:"/"+$.path}))}catch(A){console.warn(A)}if($){let A=z.getComparisonKey($);if(!Y.has(A)){Y.add(A);const T=F.name||z.basenameOrAuthority($);B.push(new t.WorkspaceFolder({uri:$,name:T,index:B.length},F))}}}return B}e.toWorkspaceFolders=L;function W(K,G,z,B,Y){let q=N(G,K);const F=Y.dirname(G),$=Y.dirname(B),A=[],T=J(q.folders);for(const Q of q.folders){const ie=h(Q)?Y.resolvePath(F,Q.path):b.URI.parse(Q.uri);let se;z?se=!1:se=!h(Q)||(0,E.isAbsolute)(Q.path),A.push(R(ie,se,Q.name,$,T,Y))}const U={insertSpaces:!1,tabSize:4,eol:w.isLinux||w.isMacintosh?`
`:`\r
`},O=D.setProperty(K,["folders"],A,U);let _=D.applyEdits(K,O);return(0,S.isEqualAuthority)(q.remoteAuthority,(0,g.getRemoteAuthority)(B))&&(_=D.applyEdits(_,D.removeProperty(_,["remoteAuthority"],U))),_}e.rewriteWorkspaceFileForNewLocation=W;function N(K,G){let z=n.parse(G);if(z&&Array.isArray(z.folders))z.folders=z.folders.filter(B=>a(B));else throw new Error(`${K} looks like an invalid workspace file.`);return z}function J(K){return w.isWindows?K.some(G=>h(G)&&G.path.indexOf("/")>=0):!0}e.useSlashForPath=J;function oe(K){return K.workspace&&typeof K.workspace=="object"&&typeof K.workspace.id=="string"&&typeof K.workspace.configPath=="string"}function re(K){return typeof K.folderUri=="string"}function V(K){return typeof K.fileUri=="string"}function Z(K,G){const z={workspaces:[],files:[]};if(K){const B=function(q,F){for(let $=0;$<q.length;$++)try{F(q[$],$)}catch(A){G.warn(`Error restoring recent entry ${JSON.stringify(q[$])}: ${A.toString()}. Skip entry.`)}},Y=K;if(Array.isArray(Y.entries))B(Y.entries,q=>{const F=q.label,$=q.remoteAuthority;oe(q)?z.workspaces.push({label:F,remoteAuthority:$,workspace:{id:q.workspace.id,configPath:b.URI.parse(q.workspace.configPath)}}):re(q)?z.workspaces.push({label:F,remoteAuthority:$,folderUri:b.URI.parse(q.folderUri)}):V(q)&&z.files.push({label:F,remoteAuthority:$,fileUri:b.URI.parse(q.fileUri)})});else{const q=K;Array.isArray(q.workspaces3)&&B(q.workspaces3,(F,$)=>{const A=Array.isArray(q.workspaceLabels)&&q.workspaceLabels[$]||void 0;typeof F=="object"&&typeof F.id=="string"&&typeof F.configURIPath=="string"?z.workspaces.push({label:A,workspace:{id:F.id,configPath:b.URI.parse(F.configURIPath)}}):typeof F=="string"&&z.workspaces.push({label:A,folderUri:b.URI.parse(F)})}),Array.isArray(q.files2)&&B(q.files2,(F,$)=>{const A=Array.isArray(q.fileLabels)&&q.fileLabels[$]||void 0;typeof F=="string"&&z.files.push({label:A,fileUri:b.URI.parse(F)})})}}return z}e.restoreRecentlyOpened=Z;function H(K){const G={entries:[]};for(const z of K.workspaces)C(z)?G.entries.push({folderUri:z.folderUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority}):G.entries.push({workspace:{id:z.workspace.id,configPath:z.workspace.configPath.toString()},label:z.label,remoteAuthority:z.remoteAuthority});for(const z of K.files)G.entries.push({fileUri:z.fileUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority});return G}e.toStoreData=H}),define(ee[50],te([0,1,14,8,71,33,2,72,9,3,13,24,139,5,6,38,31]),function(j,e,p,n,D,M,P,E,w,S,b,k,y,g,t,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,g.createDecorator)("dialogMainService");let v=class vt{constructor(u,f){this.stateMainService=u,this.logService=f,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new n.Queue}pickFileFolder(u,f){return this.doPick({...u,pickFolders:!0,pickFiles:!0,title:(0,y.localize)(0,null)},f)}pickFolder(u,f){return this.doPick({...u,pickFolders:!0,title:(0,y.localize)(1,null)},f)}pickFile(u,f){return this.doPick({...u,pickFiles:!0,title:(0,y.localize)(2,null)},f)}pickWorkspace(u,f){const c=(0,y.localize)(3,null),o=(0,M.mnemonicButtonLabel)((0,y.localize)(4,null)),l=m.WORKSPACE_FILTER;return this.doPick({...u,pickFiles:!0,title:c,filters:l,buttonLabel:o},f)}async doPick(u,f){const c={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters};c.defaultPath=u.defaultPath||this.stateMainService.getItem(vt.workingDirPickerStorageKey),(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(c.properties=void 0,u.pickFiles&&u.pickFolders&&(c.properties=["multiSelections","openDirectory","openFile","createDirectory"])),c.properties||(c.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),S.isMacintosh&&c.properties.push("treatPackageAsDirectory");const o=f||p.BrowserWindow.getFocusedWindow(),l=await this.showOpenDialog(c,(0,b.withNullAsUndefined)(o));if(l&&l.filePaths&&l.filePaths.length>0)return this.stateMainService.setItem(vt.workingDirPickerStorageKey,(0,w.dirname)(l.filePaths[0])),l.filePaths}getWindowDialogQueue(u){if(u){let f=this.windowDialogQueues.get(u.id);return f||(f=new n.Queue,this.windowDialogQueues.set(u.id,f)),f}else return this.noWindowDialogueQueue}showMessageBox(u,f){return this.getWindowDialogQueue(f).queue(async()=>f?p.dialog.showMessageBox(f,u):p.dialog.showMessageBox(u))}async showSaveDialog(u,f){const c=this.acquireFileDialogLock(u,f);if(!c)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(f).queue(async()=>{let o;return f?o=await p.dialog.showSaveDialog(f,u):o=await p.dialog.showSaveDialog(u),o.filePath=this.normalizePath(o.filePath),o})}finally{(0,P.dispose)(c)}}normalizePath(u){return u&&S.isMacintosh&&(u=(0,E.normalizeNFC)(u)),u}normalizePaths(u){return u.map(f=>this.normalizePath(f))}async showOpenDialog(u,f){u.defaultPath&&(await k.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const c=this.acquireFileDialogLock(u,f);if(!c)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(f).queue(async()=>{let o;return f?o=await p.dialog.showOpenDialog(f,u):o=await p.dialog.showOpenDialog(u),o.filePaths=this.normalizePaths(o.filePaths),o})}finally{(0,P.dispose)(c)}}acquireFileDialogLock(u,f){if(!f)return P.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",u);let c=this.windowFileDialogLocks.get(f.id);c||(c=new Set,this.windowFileDialogLocks.set(f.id,c));const o=(0,D.hash)(u);if(!c.has(o))return this.logService.trace("[DialogMainService]: new file dialog lock created",u),c.add(o),(0,P.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",u),c?.delete(o),c?.size===0&&this.windowFileDialogLocks.delete(f.id)})}};v.workingDirPickerStorageKey="pickerWorkingDir",v=de([ne(0,d.IStateMainService),ne(1,t.ILogService)],v),e.DialogMainService=v}),define(ee[227],te([0,1,4,2,31]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends n.Disposable{constructor(E,w){super();this.logService=E,this.storageMainService=w,this._onDidChangeGlobalStorage=this._register(new p.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(p.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(E,w)=>(E?E.push(w):E=[w],E),M.STORAGE_CHANGE_DEBOUNCE_TIME)(E=>{E.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(E))}))}serializeGlobalStorageEvents(E){const w=new Map,S=new Set;return E.forEach(b=>{const k=this.storageMainService.globalStorage.get(b.key);typeof k=="string"?w.set(b.key,k):S.add(b.key)}),{changed:Array.from(w.entries()),deleted:Array.from(S.values())}}listen(E,w){switch(w){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${w}`)}async call(E,w,S){const b=(0,D.reviveIdentifier)(S.workspace),k=await this.withStorageInitialized(b);switch(w){case"getItems":return Array.from(k.items.entries());case"updateItems":{const y=S;if(y.insert)for(const[g,t]of y.insert)k.set(g,t);y.delete&&y.delete.forEach(g=>k.delete(g));break}case"close":{if(b)return k.close();break}default:throw new Error(`Call not found: ${w}`)}}async withStorageInitialized(E){const w=E?this.storageMainService.workspaceStorage(E):this.storageMainService.globalStorage;try{await w.init()}catch(S){this.logService.error(`StorageIPC#init: Unable to init ${E?"workspace":"global"} storage due to ${S}`)}return w}}e.StorageDatabaseChannel=M,M.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(ee[228],te([0,1,8,4,2,9,24,89,128,6,79,30,31]),function(j,e,p,n,D,M,P,E,w,S,b,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class g extends D.Disposable{constructor(v){super();this.logService=v,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new n.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new E.Storage(new E.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new p.DeferredPromise,this.whenInit=this.whenInitPromise.p}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const v=await this.doCreate();this._storage.dispose(),this._storage=v,this._register(v.onDidChangeStorage(u=>this._onDidChangeStorage.fire({key:u}))),await this.doInit(v);const C=v.getBoolean(b.IS_NEW_KEY);C===void 0?v.set(b.IS_NEW_KEY,!0):C&&v.set(b.IS_NEW_KEY,!1)}catch(v){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${v}`)}finally{this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===S.LogLevel.Trace?v=>this.logService.trace(v):void 0,logError:v=>this.logService.error(v)}}doInit(v){return v.init()}get items(){return this._storage.items}get(v,C){return this._storage.get(v,C)}set(v,C){return this._storage.set(v,C)}delete(v){return this._storage.delete(v)}async close(){this.initializePromise&&await this.initializePromise,await this._storage.close(),this._onDidCloseStorage.fire()}}class t extends g{constructor(v,C,u){super(C);this.options=v,this.environmentService=u}async doCreate(){let v;return this.options.useInMemoryStorage?v=w.SQLiteStorageDatabase.IN_MEMORY_PATH:v=(0,M.join)(this.environmentService.globalStorageHome.fsPath,t.STORAGE_NAME),new E.Storage(new w.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}))}async doInit(v){await super.doInit(v),this.updateTelemetryState(v)}updateTelemetryState(v){v.get(k.firstSessionDateStorageKey,void 0)===void 0&&v.set(k.firstSessionDateStorageKey,new Date().toUTCString());const u=v.get(k.currentSessionDateStorageKey,void 0),f=new Date().toUTCString();v.set(k.lastSessionDateStorageKey,typeof u=="undefined"?null:u),v.set(k.currentSessionDateStorageKey,f)}}e.GlobalStorageMain=t,t.STORAGE_NAME="state.vscdb";class d extends g{constructor(v,C,u,f){super(u);this.workspace=v,this.options=C,this.environmentService=f}async doCreate(){const{storageFilePath:v,wasCreated:C}=await this.prepareWorkspaceStorageFolder();return new E.Storage(new w.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}),{hint:C?E.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:w.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const v=(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),C=(0,M.join)(v,d.WORKSPACE_STORAGE_NAME);return await P.Promises.exists(v)?{storageFilePath:C,wasCreated:!1}:(await P.Promises.mkdir(v,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(v),{storageFilePath:C,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(v){let C;if((0,y.isSingleFolderWorkspaceIdentifier)(this.workspace)?C={folder:this.workspace.uri.toString()}:(0,y.isWorkspaceIdentifier)(this.workspace)&&(C={workspace:this.workspace.configPath.toString()}),C)try{const u=(0,M.join)(v,d.WORKSPACE_META_NAME);await P.Promises.exists(u)||await P.Promises.writeFile(u,JSON.stringify(C,void 0,2))}catch(u){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${u}`)}}}e.WorkspaceStorageMain=d,d.WORKSPACE_STORAGE_NAME="state.vscdb",d.WORKSPACE_META_NAME="workspace.json"}),define(ee[101],te([0,1,16,7,31]),function(j,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function M(w,S,b){for(const y of w){const g=y.openedWorkspace;if((0,D.isWorkspaceIdentifier)(g)){const t=b(g);if(t){if(t.folders.some(d=>p.extUriBiasedIgnorePathCase.isEqualOrParent(S,d.uri)))return y}else if(p.extUriBiasedIgnorePathCase.isEqualOrParent(S,g.configPath))return y}}const k=w.filter(y=>(0,D.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqualOrParent(S,y.openedWorkspace.uri));if(k.length)return k.sort((y,g)=>-(y.openedWorkspace.uri.path.length-g.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=M;function P(w,S){for(const b of w)if((0,D.isWorkspaceIdentifier)(b.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.configPath,S)||(0,D.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.uri,S))return b}e.findWindowOnWorkspaceOrFolder=P;function E(w,S){const b=k=>S.some(y=>p.extUriBiasedIgnorePathCase.isEqual(n.URI.file(y),n.URI.file(k)));for(const k of w)if(k.config?.extensionDevelopmentPath?.some(y=>b(y)))return k}e.findWindowOnExtensionDevelopmentPath=E}),define(ee[229],te([0,1,14,2,3,16,7,19,20,6,38,36,31]),function(j,e,p,n,D,M,P,E,w,S,b,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let g=class St extends n.Disposable{constructor(u,f,c,o,l){super();this.windowsMainService=u,this.stateMainService=f,this.lifecycleMainService=c,this.logService=o,this.configurationService=l,this._state=t(this.stateMainService.getItem(St.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){p.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!u.lastActiveWindow){let o=this.windowsMainService.getLastActiveWindow();(!o||o.isExtensionDevelopmentHost)&&(o=this.windowsMainService.getWindows().find(l=>!l.isExtensionDevelopmentHost)),o&&(u.lastActiveWindow=this.toWindowState(o))}const f=this.windowsMainService.getWindows().find(o=>o.isExtensionDevelopmentHost&&!o.isExtensionTestHost);f&&(u.lastPluginDevelopmentHostWindow=this.toWindowState(f)),this.windowsMainService.getWindowCount()>1&&(u.openedWindows=this.windowsMainService.getWindows().filter(o=>!o.isExtensionDevelopmentHost).map(o=>this.toWindowState(o)));const c=m(u);this.stateMainService.setItem(St.windowsStateStorageKey,c),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",c)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const f=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=f:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(c=>{const o=(0,y.isWorkspaceIdentifier)(u.openedWorkspace)&&c.workspace?.id===u.openedWorkspace.id,l=(0,y.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)&&c.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(c.folderUri,u.openedWorkspace.uri);(o||l)&&(c.uiState=f.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=f)}toWindowState(u){return{workspace:(0,y.isWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,y.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const f=this.doGetNewWindowState(u),c=this.configurationService.getValue("window");let o;return f.hasDefaultState?o=!!(c?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(c.newWindowDimensions)>=0):(o=!!(this.lifecycleMainService.wasRestarted||c?.restoreFullscreen),o&&D.isMacintosh&&this.windowsMainService.getWindows().some(l=>l.isFullScreen)&&(o=!1)),f.mode===3&&!o&&(f.mode=1),f}doGetNewWindowState(u){const f=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const r=u.workspace;if((0,y.isWorkspaceIdentifier)(r)){const h=this.state.openedWindows.filter(I=>I.workspace&&I.workspace.id===r.id).map(I=>I.uiState);if(h.length)return h[0]}if((0,y.isSingleFolderWorkspaceIdentifier)(r)){const h=this.state.openedWindows.filter(I=>I.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(I.folderUri,r.uri)).map(I=>I.uiState);if(h.length)return h[0]}else if(u.backupPath){const h=this.state.openedWindows.filter(I=>I.backupPath===u.backupPath).map(I=>I.uiState);if(h.length)return h[0]}const a=this.lastClosedState||this.state.lastActiveWindow;if(!f&&a)return a.uiState}let c;const o=p.screen.getAllDisplays();if(o.length===1)c=o[0];else{if(D.isMacintosh){const r=p.screen.getCursorScreenPoint();c=p.screen.getDisplayNearestPoint(r)}!c&&f&&(c=p.screen.getDisplayMatching(f.getBounds())),c||(c=p.screen.getPrimaryDisplay()||o[0])}let l=(0,k.defaultWindowState)();l.x=Math.round(c.bounds.x+c.bounds.width/2-l.width/2),l.y=Math.round(c.bounds.y+c.bounds.height/2-l.height/2);const s=this.configurationService.getValue("window");let i=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")l.mode=0,i=!1;else if(s.newWindowDimensions==="fullscreen")l.mode=3,i=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&f){const r=f.serializeWindowState();r.mode===3?l.mode=3:l=r,i=l.mode!==3&&s.newWindowDimensions==="offset"}}return i&&(l=this.ensureNoOverlap(l)),l.hasDefaultState=!0,l}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const f=this.windowsMainService.getWindows().map(c=>c.getBounds());for(;f.some(c=>c.x===u.x||c.y===u.y);)u.x+=30,u.y+=30;return u}};g.windowsStateStorageKey="windowsState",g=de([ne(0,k.IWindowsMainService),ne(1,b.IStateMainService),ne(2,w.ILifecycleMainService),ne(3,S.ILogService),ne(4,E.IConfigurationService)],g),e.WindowsStateHandler=g;function t(C){const u={openedWindows:[]},f=C||{openedWindows:[]};return f.lastActiveWindow&&(u.lastActiveWindow=d(f.lastActiveWindow)),f.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=d(f.lastPluginDevelopmentHostWindow)),Array.isArray(f.openedWindows)&&(u.openedWindows=f.openedWindows.map(c=>d(c))),u}e.restoreWindowsState=t;function d(C){const u={uiState:C.uiState};return C.backupPath&&(u.backupPath=C.backupPath),C.remoteAuthority&&(u.remoteAuthority=C.remoteAuthority),C.folder&&(u.folderUri=P.URI.parse(C.folder)),C.workspaceIdentifier&&(u.workspace={id:C.workspaceIdentifier.id,configPath:P.URI.parse(C.workspaceIdentifier.configURIPath)}),u}function m(C){return{lastActiveWindow:C.lastActiveWindow&&v(C.lastActiveWindow),lastPluginDevelopmentHostWindow:C.lastPluginDevelopmentHostWindow&&v(C.lastPluginDevelopmentHostWindow),openedWindows:C.openedWindows.map(u=>v(u))}}e.getWindowsStateStoreData=m;function v(C){return{workspaceIdentifier:C.workspace&&{id:C.workspace.id,configURIPath:C.workspace.configPath.toString()},folder:C.folderUri&&C.folderUri.toString(),backupPath:C.backupPath,remoteAuthority:C.remoteAuthority,uiState:C.uiState}}}),define(ee[102],te([0,1,60,29,10,3,16]),function(j,e,p,n,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function E(S){function b(){let k=S.scheme===D.Schemas.file?(0,P.originalFSPath)(S):S.toString();return M.isLinux||(k=k.toLowerCase()),(0,p.createHash)("md5").update(k).digest("hex")}return{id:b(),configPath:S}}e.getWorkspaceIdentifier=E;function w(S,b){function k(){if(S.scheme!==D.Schemas.file)return(0,p.createHash)("md5").update(S.toString()).digest("hex");if(!b)try{b=(0,n.statSync)(S.fsPath)}catch{return}let g;return M.isLinux?g=b.ino:M.isMacintosh?g=b.birthtime.getTime():M.isWindows&&(typeof b.birthtimeMs=="number"?g=Math.floor(b.birthtimeMs):g=b.birthtime.getTime()),(0,p.createHash)("md5").update(S.fsPath).update(g?String(g):"").digest("hex")}const y=k();if(typeof y=="string")return{id:y,uri:S}}e.getSingleFolderWorkspaceIdentifier=w}),define(ee[230],te([0,1,15,4,10,6,257,116,20,84]),function(j,e,p,n,D,M,P,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerMainProcessExtensionHostStarter=void 0;class b{constructor(t,d){this._worker=new P.Worker(D.FileAccess.asFileUri("vs/platform/extensions/node/extensionHostStarterWorkerMain.js",j).fsPath),this._worker.on("message",t),this._worker.on("error",d),this.onError=n.Event.fromNodeEventEmitter(this._worker,"error"),this.onExit=n.Event.fromNodeEventEmitter(this._worker,"exit"),this.onMessageError=n.Event.fromNodeEventEmitter(this._worker,"messageerror")}getId(){return 1}postMessage(t,d){this._worker.postMessage(t,d)}dispose(){this._worker.terminate()}}let k=class{constructor(t){this._logService=t}async logInfo(t){this._logService.info(t)}};k=de([ne(0,M.ILogService)],k);let y=class{constructor(t,d){this._logService=t,this._shutdown=!1,this._proxy=null;const m={create:(v,C,u)=>{const f=new b(C,u);return f.onError(c=>{this._logService.error("ExtensionHostStarterWorker has encountered an error:"),this._logService.error(c)}),f.onMessageError(c=>{this._logService.error("ExtensionHostStarterWorker has encountered a message error:"),this._logService.error(c)}),f.onExit(c=>this._logService.info(`ExtensionHostStarterWorker exited with code ${c}.`)),f.postMessage(v,[]),f}};this._worker=new E.SimpleWorkerClient(m,"vs/platform/extensions/node/extensionHostStarterWorker",new k(this._logService)),this._initialize(),d.onWillShutdown(v=>{this._shutdown=!0,this._proxy&&v.join(this._proxy.waitForAllExit(6e3))})}dispose(){}async _initialize(){this._proxy=await this._worker.getProxyObject(),this._logService.info("ExtensionHostStarterWorker created")}onDynamicStdout(t){return this._proxy.onDynamicStdout(t)}onDynamicStderr(t){return this._proxy.onDynamicStderr(t)}onDynamicMessage(t){return this._proxy.onDynamicMessage(t)}onDynamicError(t){return this._proxy.onDynamicError(t)}onDynamicExit(t){return this._proxy.onDynamicExit(t)}async createExtensionHost(){const t=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return t.createExtensionHost()}async start(t,d){const m=S.StopWatch.create(!1),v=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();const C=setTimeout(()=>{this._logService.info("ExtensionHostStarterWorker.start() did not return within 30s. This might be a problem.")},3e4),u=await v.start(t,d),f=m.elapsed();return this._logService.info(`ExtensionHostStarterWorker.start() took ${f} ms.`),clearTimeout(C),u}async enableInspectPort(t){const d=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return d.enableInspectPort(t)}async kill(t){const d=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return d.kill(t)}};y=de([ne(0,M.ILogService),ne(1,w.ILifecycleMainService)],y),e.WorkerMainProcessExtensionHostStarter=y}),define(ee[57],te([0,1,60,61,26,17,15,4,2,9,3,32,37,87,231]),function(j,e,p,n,D,M,P,E,w,S,b,k,y,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class d{constructor(L,W=""){this.debugLabel=W,this.socket=L,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=N=>{if(this.traceSocketEvent("error",{code:N?.code,message:N?.message}),N){if(N.code==="EPIPE")return;(0,P.onUnexpectedError)(N)}},this.socket.on("error",this._errorListener)}traceSocketEvent(L,W){g.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,L,W)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(L){const W=N=>{this.traceSocketEvent("read",N),L(M.VSBuffer.wrap(N))};return this.socket.on("data",W),{dispose:()=>this.socket.off("data",W)}}onClose(L){const W=N=>{this.traceSocketEvent("close",{hadError:N}),L({type:0,hadError:N,error:void 0})};return this.socket.on("close",W),{dispose:()=>this.socket.off("close",W)}}onEnd(L){const W=()=>{this.traceSocketEvent("nodeEndReceived"),L()};return this.socket.on("end",W),{dispose:()=>this.socket.off("end",W)}}write(L){if(!this.socket.destroyed)try{this.traceSocketEvent("write",L),this.socket.write(L.buffer,W=>{if(W){if(W.code==="EPIPE")return;(0,P.onUnexpectedError)(W)}})}catch(W){if(W.code==="EPIPE")return;(0,P.onUnexpectedError)(W)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((L,W)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),L();return}const N=()=>{this.socket.off("close",N),this.socket.off("end",N),this.socket.off("error",N),this.socket.off("timeout",N),this.socket.off("drain",N),this.traceSocketEvent("nodeDrainEnd"),L()};this.socket.on("close",N),this.socket.on("end",N),this.socket.on("error",N),this.socket.on("timeout",N),this.socket.on("drain",N)})}}e.NodeSocket=d;var m;(function(R){R[R.MinHeaderByteSize=2]="MinHeaderByteSize"})(m||(m={}));var v;(function(R){R[R.PeekHeader=1]="PeekHeader",R[R.ReadHeader=2]="ReadHeader",R[R.ReadBody=3]="ReadBody",R[R.Fin=4]="Fin"})(v||(v={}));class C extends w.Disposable{constructor(L,W,N,J){super();this._onData=this._register(new E.Emitter),this._onClose=this._register(new E.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=L,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:W,inflateBytesLength:N?.byteLength||0,recordInflateBytes:J}),this._flowManager=this._register(new u(this,W,N,J,this._onData,(oe,re)=>this._write(oe,re))),this._register(this._flowManager.onError(oe=>{console.error(oe),(0,P.onUnexpectedError)(oe),this._onClose.fire({type:0,hadError:!0,error:oe})})),this._incomingData=new g.ChunkStream,this._register(this.socket.onData(oe=>this._acceptChunk(oe))),this._register(this.socket.onClose(oe=>this._onClose.fire(oe)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(L,W){this.socket.traceSocketEvent(L,W)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(L){return this._onData.event(L)}onClose(L){return this._onClose.event(L)}onEnd(L){return this.socket.onEnd(L)}write(L){this._flowManager.writeMessage(L)}_write(L,W){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",L);let N=2;L.byteLength<126?N+=0:L.byteLength<2**16?N+=2:N+=8;const J=M.VSBuffer.alloc(N);if(W?J.writeUInt8(194,0):J.writeUInt8(130,0),L.byteLength<126)J.writeUInt8(L.byteLength,1);else if(L.byteLength<2**16){J.writeUInt8(126,1);let oe=1;J.writeUInt8(L.byteLength>>>8&255,++oe),J.writeUInt8(L.byteLength>>>0&255,++oe)}else{J.writeUInt8(127,1);let oe=1;J.writeUInt8(0,++oe),J.writeUInt8(0,++oe),J.writeUInt8(0,++oe),J.writeUInt8(0,++oe),J.writeUInt8(L.byteLength>>>24&255,++oe),J.writeUInt8(L.byteLength>>>16&255,++oe),J.writeUInt8(L.byteLength>>>8&255,++oe),J.writeUInt8(L.byteLength>>>0&255,++oe)}this.socket.write(M.VSBuffer.concat([J,L]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(L){if(L.byteLength!==0){for(this._incomingData.acceptChunk(L);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const W=this._incomingData.peek(this._state.readLen),N=W.readUInt8(0),J=(N&128)>>>7,oe=(N&64)>>>6,re=W.readUInt8(1),V=(re&128)>>>7,Z=re&127;this._state.state=2,this._state.readLen=2+(V?4:0)+(Z===126?2:0)+(Z===127?8:0),this._state.fin=J,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(oe)),this._state.firstFrameOfMessage=Boolean(J),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const W=this._incomingData.read(this._state.readLen),N=W.readUInt8(1),J=(N&128)>>>7;let oe=N&127,re=1;oe===126?oe=W.readUInt8(++re)*2**8+W.readUInt8(++re):oe===127&&(oe=W.readUInt8(++re)*0+W.readUInt8(++re)*0+W.readUInt8(++re)*0+W.readUInt8(++re)*0+W.readUInt8(++re)*2**24+W.readUInt8(++re)*2**16+W.readUInt8(++re)*2**8+W.readUInt8(++re));let V=0;J&&(V=W.readUInt8(++re)*2**24+W.readUInt8(++re)*2**16+W.readUInt8(++re)*2**8+W.readUInt8(++re)),this._state.state=3,this._state.readLen=oe,this._state.mask=V,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const W=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",W),o(W,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",W),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(W,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await E.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=C;class u extends w.Disposable{constructor(L,W,N,J,oe,re){super();this._tracer=L,this._onData=oe,this._writeFn=re,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new E.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,W?(this._zlibInflateStream=this._register(new f(this._tracer,J,N,{windowBits:15})),this._zlibDeflateStream=this._register(new c(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(V=>this._onError.fire(V))),this._register(this._zlibDeflateStream.onError(V=>this._onError.fire(V)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:M.VSBuffer.alloc(0)}writeMessage(L){this._writeQueue.push(L),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const L=this._writeQueue.shift();if(this._zlibDeflateStream){const W=await this._deflateMessage(this._zlibDeflateStream,L);this._writeFn(W,!0)}else this._writeFn(L,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(L,W){return new Promise((N,J)=>{L.write(W),L.flush(oe=>N(oe))})}acceptFrame(L,W,N){this._readQueue.push({data:L,isCompressed:W,isLastFrameOfMessage:N}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const L=this._readQueue.shift();if(this._zlibInflateStream&&L.isCompressed){const W=await this._inflateFrame(this._zlibInflateStream,L.data,L.isLastFrameOfMessage);this._onData.fire(W)}else this._onData.fire(L.data)}this._isProcessingReadQueue=!1}}_inflateFrame(L,W,N){return new Promise((J,oe)=>{L.write(W),N&&L.write(M.VSBuffer.fromByteArray([0,0,255,255])),L.flush(re=>J(re))})}}class f extends w.Disposable{constructor(L,W,N,J){super();this._tracer=L,this._recordInflateBytes=W,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=t.createInflateRaw(J),this._zlibInflate.on("error",oe=>{this._tracer.traceSocketEvent("zlibInflateError",{message:oe?.message,code:oe?.code}),this._onError.fire(oe)}),this._zlibInflate.on("data",oe=>{this._tracer.traceSocketEvent("zlibInflateData",oe),this._pendingInflateData.push(M.VSBuffer.wrap(oe))}),N&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",N.buffer),this._zlibInflate.write(N.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?M.VSBuffer.concat(this._recordedInflateBytes):M.VSBuffer.alloc(0)}write(L){this._recordInflateBytes&&this._recordedInflateBytes.push(L.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",L),this._zlibInflate.write(L.buffer)}flush(L){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const W=M.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,L(W)})}}class c extends w.Disposable{constructor(L,W){super();this._tracer=L,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",N=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:N?.message,code:N?.code}),this._onError.fire(N)}),this._zlibDeflate.on("data",N=>{this._tracer.traceSocketEvent("zlibDeflateData",N),this._pendingDeflateData.push(M.VSBuffer.wrap(N))})}write(L){this._tracer.traceSocketEvent("zlibDeflateWrite",L.buffer),this._zlibDeflate.write(L.buffer)}flush(L){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let W=M.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,W=W.slice(0,W.byteLength-4),L(W)})}}function o(R,L){if(L===0)return;let W=R.byteLength>>>2;for(let Z=0;Z<W;Z++){const H=R.readUInt32BE(Z*4);R.writeUInt32BE(H^L,Z*4)}let N=W*4,J=R.byteLength-N;const oe=L>>>24&255,re=L>>>16&255,V=L>>>8&255;J>=1&&R.writeUInt8(R.readUInt8(N)^oe,N),J>=2&&R.writeUInt8(R.readUInt8(N+1)^re,N+1),J>=3&&R.writeUInt8(R.readUInt8(N+2)^V,N+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function s(){const R=(0,k.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${R}-sock`;let L;return e.XDG_RUNTIME_DIR?L=(0,S.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${R}.sock`):L=(0,S.join)((0,D.tmpdir)(),`vscode-ipc-${R}.sock`),r(L),L}e.createRandomIPCHandle=s;function i(R,L,W){const N=(0,p.createHash)("md5").update(R).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${W}-${L}-sock`;let J;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?J=(0,S.join)(e.XDG_RUNTIME_DIR,`vscode-${N.substr(0,8)}-${W}-${L}.sock`):J=(0,S.join)(R,`${W}-${L}.sock`),r(J),J}e.createStaticIPCHandle=i;function r(R){const L=l[b.platform];typeof L=="number"&&R.length>=L&&console.warn(`WARNING: IPC handle "${R}" is longer than ${L} chars, try a shorter --user-data-dir`)}class a extends y.IPCServer{constructor(L){super(a.toClientConnectionEvent(L));this.server=L}static toClientConnectionEvent(L){const W=E.Event.fromNodeEventEmitter(L,"connection");return E.Event.map(W,N=>({protocol:new g.Protocol(new d(N,"ipc-server-connection")),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(N,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=a;function h(R){return new Promise((L,W)=>{const N=(0,n.createServer)();N.on("error",W),N.listen(R,()=>{N.removeListener("error",W),L(new a(N))})})}e.serve=h;function I(R,L){return new Promise((W,N)=>{const J=(0,n.createConnection)(R,()=>{J.removeListener("error",N),W(g.Client.fromSocket(new d(J,`ipc-client${L}`),L))});J.once("error",N)})}e.connect=I}),define(ee[232],te([0,1,57]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class n{constructor(w){this.driver=w}listen(w,S){throw new Error("No event found")}call(w,S,b){switch(S){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(b);case"startTracing":return this.driver.startTracing(b[0],b[1]);case"stopTracing":return this.driver.stopTracing(b[0],b[1],b[2]);case"reloadWindow":return this.driver.reloadWindow(b);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(b[0],b[1]);case"click":return this.driver.click(b[0],b[1],b[2],b[3]);case"doubleClick":return this.driver.doubleClick(b[0],b[1]);case"setValue":return this.driver.setValue(b[0],b[1],b[2]);case"getTitle":return this.driver.getTitle(b[0]);case"isActiveElement":return this.driver.isActiveElement(b[0],b[1]);case"getElements":return this.driver.getElements(b[0],b[1],b[2]);case"getElementXY":return this.driver.getElementXY(b[0],b[1],b[2]);case"typeInEditor":return this.driver.typeInEditor(b[0],b[1],b[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(b[0],b[1]);case"writeInTerminal":return this.driver.writeInTerminal(b[0],b[1],b[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(b);case"getLocalizedStrings":return this.driver.getLocalizedStrings(b)}throw new Error(`Call not found: ${S}`)}}e.DriverChannel=n;class D{constructor(w){this.channel=w}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(w){return this.channel.call("capturePage",w)}startTracing(w,S){return this.channel.call("startTracing",[w,S])}stopTracing(w,S,b){return this.channel.call("stopTracing",[w,S,b])}reloadWindow(w){return this.channel.call("reloadWindow",w)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(w,S){return this.channel.call("dispatchKeybinding",[w,S])}click(w,S,b,k){return this.channel.call("click",[w,S,b,k])}doubleClick(w,S){return this.channel.call("doubleClick",[w,S])}setValue(w,S,b){return this.channel.call("setValue",[w,S,b])}getTitle(w){return this.channel.call("getTitle",[w])}isActiveElement(w,S){return this.channel.call("isActiveElement",[w,S])}getElements(w,S,b){return this.channel.call("getElements",[w,S,b])}getElementXY(w,S,b,k){return this.channel.call("getElementXY",[w,S,b,k])}typeInEditor(w,S,b){return this.channel.call("typeInEditor",[w,S,b])}getTerminalBuffer(w,S){return this.channel.call("getTerminalBuffer",[w,S])}writeInTerminal(w,S,b){return this.channel.call("writeInTerminal",[w,S,b])}getLocaleInfo(w){return this.channel.call("getLocaleInfo",w)}getLocalizedStrings(w){return this.channel.call("getLocalizedStrings",w)}}e.DriverChannelClient=D;class M{constructor(w){this.registry=w}listen(w,S){throw new Error(`Event not found: ${S}`)}call(w,S,b){switch(S){case"registerWindowDriver":return this.registry.registerWindowDriver(b);case"reloadWindowDriver":return this.registry.reloadWindowDriver(b)}throw new Error(`Call not found: ${S}`)}}e.WindowDriverRegistryChannel=M;async function P(E){const w=await(0,p.connect)(E,"driverClient"),S=w.getChannel("driver"),b=new D(S);return{client:w,driver:b}}e.connect=P}),define(ee[23],te([0,1,46,9,57,48,168,5]),function(j,e,p,n,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,E.refineServiceDecorator)(M.IEnvironmentService);class w extends P.NativeEnvironmentService{get cachedLanguagesPath(){return(0,n.join)(this.userDataPath,"clp")}get backupHome(){return(0,n.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,n.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,D.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,n.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}de([p.memoize],w.prototype,"cachedLanguagesPath",null),de([p.memoize],w.prototype,"backupHome",null),de([p.memoize],w.prototype,"backupWorkspacesPath",null),de([p.memoize],w.prototype,"mainIPCHandle",null),de([p.memoize],w.prototype,"mainLockfile",null),de([p.memoize],w.prototype,"sandbox",null),de([p.memoize],w.prototype,"driverVerbose",null),de([p.memoize],w.prototype,"disableUpdates",null),de([p.memoize],w.prototype,"disableKeytar",null),de([p.memoize],w.prototype,"codeCachePath",null),de([p.memoize],w.prototype,"useCodeCache",null),e.EnvironmentMainService=w}),define(ee[233],te([0,1,60,29,28,10,9,3,16,7,24,162,19,23,18,6,31]),function(j,e,p,n,D,M,P,E,w,S,b,k,y,g,t,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class{constructor(u,f,c){this.configurationService=f,this.logService=c,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=w.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(o,l)=>(0,D.isEqual)(o,l,!E.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await b.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{u=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos);let f=[];try{Array.isArray(u.rootURIWorkspaces)&&(f=u.rootURIWorkspaces.map(o=>({workspace:{id:o.id,configPath:S.URI.parse(o.configURIPath)},remoteAuthority:o.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(f);let c=[];try{Array.isArray(u.folderWorkspaceInfos)?c=u.folderWorkspaceInfos.map(o=>({folderUri:S.URI.parse(o.folderUri),remoteAuthority:o.remoteAuthority})):Array.isArray(u.folderURIWorkspaces)&&(c=u.folderURIWorkspaces.map(o=>({folderUri:S.URI.parse(o),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(c),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,f){this.workspaces.some(o=>u.workspace.id===o.workspace.id)||(this.workspaces.push(u),this.saveSync());const c=this.getBackupPath(u.workspace.id);return f&&this.moveBackupFolderSync(c,f),c}moveBackupFolderSync(u,f){if(n.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),n.existsSync(f))try{n.renameSync(f,u)}catch(c){this.logService.error(`Backup: Could not move backup folder to new location: ${c.toString()}`)}}unregisterWorkspaceBackupSync(u){const f=u.id,c=this.workspaces.findIndex(o=>o.workspace.id===f);c!==-1&&(this.workspaces.splice(c,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(f=>this.backupUriComparer.isEqual(u.folderUri,f.folderUri))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const f=this.folders.findIndex(c=>this.backupUriComparer.isEqual(u,c.folderUri));f!==-1&&(this.folders.splice(f,1),this.saveSync())}registerEmptyWindowBackupSync(u,f){const c=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,c))||(this.emptyWindows.push({backupFolder:c,remoteAuthority:f}),this.saveSync()),this.getBackupPath(c)}unregisterEmptyWindowBackupSync(u){const f=this.emptyWindows.findIndex(c=>!!c.backupFolder&&this.backupPathComparer.isEqual(c.backupFolder,u));f!==-1&&(this.emptyWindows.splice(f,1),this.saveSync())}getBackupPath(u){return(0,P.join)(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const f=new Set,c=[];for(let o of u){const l=o.workspace;if(!(0,m.isWorkspaceIdentifier)(l))return[];if(!f.has(l.id)){f.add(l.id);const s=this.getBackupPath(l.id);await this.doHasBackups(s)?l.configPath.scheme!==M.Schemas.file||await b.Promises.exists(l.configPath.fsPath)?c.push(o):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return c}async validateFolders(u){if(!Array.isArray(u))return[];const f=[],c=new Set;for(let o of u){const l=o.folderUri,s=this.backupUriComparer.getComparisonKey(l);if(!c.has(s)){c.add(s);const i=this.getBackupPath(this.getFolderHash(o));await this.doHasBackups(i)?l.scheme!==M.Schemas.file||await b.Promises.exists(l.fsPath)?f.push(o):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return f}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const f=[],c=new Set;for(let o of u){const l=o.backupFolder;if(typeof l!="string")return[];if(!c.has(l)){c.add(l);const s=this.getBackupPath(l);await this.doHasBackups(s)?f.push(o):await this.deleteStaleBackup(s)}}return f}async deleteStaleBackup(u){try{await b.Promises.exists(u)&&await b.Promises.rm(u,b.RimRafMode.MOVE)}catch(f){this.logService.error(`Backup: Could not delete stale backup: ${f.toString()}`)}}async convertToEmptyWindowBackup(u){let f=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,f));)f=this.getRandomEmptyWindowId();const c=this.getBackupPath(f);try{await b.Promises.rename(u,c)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push({backupFolder:f}),!0}convertToEmptyWindowBackupSync(u){let f=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,f));)f=this.getRandomEmptyWindowId();const c=this.getBackupPath(f);try{n.renameSync(u,c)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push({backupFolder:f}),!0}async getDirtyWorkspaces(){const u=[];for(const f of this.workspaces)await this.hasBackups(f)&&u.push(f);for(const f of this.folders)await this.hasBackups(f)&&u.push(f);return u}hasBackups(u){let f;return(0,k.isEmptyWindowBackupInfo)(u)?f=u.backupFolder:(0,m.isFolderBackupInfo)(u)?f=this.getBackupPath(this.getFolderHash(u)):f=this.getBackupPath(u.workspace.id),this.doHasBackups(f)}async doHasBackups(u){try{const f=await b.Promises.readdir(u);for(const c of f)try{if((await b.Promises.readdir((0,P.join)(u,c))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,b.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await b.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderWorkspaceInfos:this.folders.map(u=>({folderUri:u.folderUri.toString(),remoteAuthority:u.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){const f=u.folderUri;let c;return f.scheme===M.Schemas.file?c=E.isLinux?f.fsPath:f.fsPath.toLowerCase():c=f.toString().toLowerCase(),(0,p.createHash)("md5").update(c).digest("hex")}};v=de([ne(0,g.IEnvironmentMainService),ne(1,y.IConfigurationService),ne(2,d.ILogService)],v),e.BackupMainService=v}),define(ee[234],te([0,1,8,4,108,59,2,3,37,57,164,232,23,185,20,36,18,7,9,17,6]),function(j,e,p,n,D,M,P,E,w,S,b,k,y,g,t,d,m,v,C,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function c(s){return s<21}let o=class{constructor(i,r,a,h,I,R,L){this.windowServer=i,this.options=r,this.windowsMainService=a,this.lifecycleMainService=h,this.fileService=I,this.environmentMainService=R,this.logService=L,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new n.Emitter}async registerWindowDriver(i){return this.logService.info(`[driver] registerWindowDriver(${i})`),this.registeredWindowIds.add(i),this.reloadingWindowIds.delete(i),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(i){this.logService.info(`[driver] reloadWindowDriver(${i})`),this.reloadingWindowIds.add(i)}async getWindowIds(){return this.windowsMainService.getWindows().map(r=>r.id).filter(r=>this.registeredWindowIds.has(r)&&!this.reloadingWindowIds.has(r))}async capturePage(i){const r=this.windowsMainService.getWindowById(i)??this.windowsMainService.getLastActiveWindow();if(!r?.win)throw new Error("Invalid window");return(await r.win.webContents.capturePage()).toPNG().toString("base64")}async startTracing(i,r){}async stopTracing(i,r,a){if(!a)return;const h=await this.capturePage(i),I=Buffer.from(h,"base64");await this.fileService.writeFile(v.URI.file((0,C.join)(this.environmentMainService.logsPath,`${r}.png`)),u.VSBuffer.wrap(I))}async reloadWindow(i){this.logService.info(`[driver] reloadWindow(${i})`),await this.whenUnfrozen(i);const r=this.windowsMainService.getWindowById(i);if(!r)throw new Error("Invalid window");this.reloadingWindowIds.add(i),this.lifecycleMainService.reload(r)}exitApplication(){return this.logService.info("[driver] exitApplication()"),this.lifecycleMainService.quit()}async dispatchKeybinding(i,r){await this.whenUnfrozen(i);const a=D.KeybindingParser.parseUserBinding(r);for(let h of a)await this._dispatchKeybinding(i,h)}async _dispatchKeybinding(i,r){if(r instanceof M.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const a=this.windowsMainService.getWindowById(i);if(!a?.win)throw new Error("Invalid window");const h=a.win.webContents,I=new M.SimpleKeybinding(!1,!1,!1,!1,r.keyCode),L=new g.USLayoutResolvedKeybinding(I.toChord(),E.OS).getElectronAccelerator(),W=[];r.ctrlKey&&W.push("ctrl"),r.metaKey&&W.push("meta"),r.shiftKey&&W.push("shift"),r.altKey&&W.push("alt"),h.sendInputEvent({type:"keyDown",keyCode:L,modifiers:W}),c(r.keyCode)||h.sendInputEvent({type:"char",keyCode:L,modifiers:W}),h.sendInputEvent({type:"keyUp",keyCode:L,modifiers:W}),await(0,p.timeout)(100)}async click(i,r,a,h){await(await this.getWindowDriver(i)).click(r,a,h)}async doubleClick(i,r){await(await this.getWindowDriver(i)).doubleClick(r)}async setValue(i,r,a){await(await this.getWindowDriver(i)).setValue(r,a)}async getTitle(i){return await(await this.getWindowDriver(i)).getTitle()}async isActiveElement(i,r){return await(await this.getWindowDriver(i)).isActiveElement(r)}async getElements(i,r,a){return await(await this.getWindowDriver(i)).getElements(r,a)}async getElementXY(i,r,a,h){return await(await this.getWindowDriver(i)).getElementXY(r,a,h)}async typeInEditor(i,r,a){await(await this.getWindowDriver(i)).typeInEditor(r,a)}async getTerminalBuffer(i,r){return await(await this.getWindowDriver(i)).getTerminalBuffer(r)}async writeInTerminal(i,r,a){await(await this.getWindowDriver(i)).writeInTerminal(r,a)}async getLocaleInfo(i){return await(await this.getWindowDriver(i)).getLocaleInfo()}async getLocalizedStrings(i){return await(await this.getWindowDriver(i)).getLocalizedStrings()}async getWindowDriver(i){await this.whenUnfrozen(i);const r=`window:${i}`,a=new w.StaticRouter(I=>I===r),h=this.windowServer.getChannel("windowDriver",a);return new b.WindowDriverChannelClient(h)}async whenUnfrozen(i){for(;this.reloadingWindowIds.has(i);)await n.Event.toPromise(this.onDidReloadingChange.event)}};o=de([ne(2,d.IWindowsMainService),ne(3,t.ILifecycleMainService),ne(4,m.IFileService),ne(5,y.IEnvironmentMainService),ne(6,f.ILogService)],o),e.Driver=o;async function l(s,i,r,a){const h=r.driverVerbose,I=a.createInstance(o,s,{verbose:h}),R=new k.WindowDriverRegistryChannel(I);s.registerChannel("windowDriverRegistry",R);const L=await(0,S.serve)(i),W=new k.DriverChannel(I);return L.registerChannel("driver",W),(0,P.combinedDisposable)(L,s)}e.serve=l}),define(ee[235],te([0,1,61,57]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,M,P,E,w){const S=k=>w(k,void 0),b=p.createConnection({host:D,port:M},()=>{b.removeListener("error",S);const k=Buffer.alloc(16);for(let d=0;d<16;d++)k[d]=Math.round(Math.random()*256);const y=k.toString("base64"),g=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${M}/?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`];b.write(g.join(`\r
`)+`\r
\r
`);const t=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",t),w(void 0,new n.NodeSocket(b,E)))};b.on("data",t)});b.setNoDelay(!0),b.once("error",S)}}}),define(ee[236],te([0,1,61,121,235,8,2,19,6,22,201,99,78]),function(j,e,p,n,D,M,P,E,w,S,b,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function g(C,u,f,c,o){let l;for(let s=3;s&&(l&&l.dispose(),l=await new t(C,u,f,c,o).waitForReady(),!(o&&n.BROWSER_RESTRICTED_PORTS[o]||!n.BROWSER_RESTRICTED_PORTS[l.tunnelLocalPort]));s--);return l}class t extends P.Disposable{constructor(u,f,c,o,l){super();this.defaultTunnelHost=f,this.suggestedLocalPort=l,this.privacy=k.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=u,this._server=p.createServer(),this._barrier=new M.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=o,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(f=>{f()})}async waitForReady(){let u=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),f=null;return this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address(),f||(u=0,this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address()),this.tunnelLocalPort=f.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${f.port}`,this}async _onConnection(u){u.pause();const f=(0,k.isLocalhost)(this.tunnelRemoteHost)||(0,k.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,b.connectRemoteAgentTunnel)(this._options,f,this.tunnelRemotePort),o=c.getSocket().socket,l=c.readEntireBuffer();c.dispose(),l.byteLength>0&&u.write(l.buffer),u.on("end",()=>{u.localAddress&&this._socketsDispose.delete(u.localAddress),o.end()}),u.on("close",()=>o.end()),u.on("error",()=>{u.localAddress&&this._socketsDispose.delete(u.localAddress),o.destroy()}),o.on("end",()=>u.end()),o.on("close",()=>u.end()),o.on("error",()=>{u.destroy()}),u.pipe(o),o.pipe(u),u.localAddress&&this._socketsDispose.set(u.localAddress,()=>{u.end(),o.end()})}}let d=class extends k.AbstractTunnelService{constructor(u,f,c,o,l){super(f);this.socketFactory=u,this.signService=c,this.productService=o,this.configurationService=l}get defaultTunnelHost(){const u=this.configurationService.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(u,f,c,o,l,s,i){const r=this.getTunnelFromMap(f,c);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,f,c,o,l,s,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${f}:${c} on local port ${o}.`);const a={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:u,signService:this.signService,logService:this.logService,ipcLogger:null},h=g(a,this.defaultTunnelHost,f,c,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(f,c,h),h}}};d=de([ne(1,w.ILogService),ne(2,y.ISignService),ne(3,S.IProductService),ne(4,E.IConfigurationService)],d),e.BaseTunnelService=d;let m=class extends d{constructor(u,f,c,o){super(D.nodeSocketFactory,u,f,c,o)}};m=de([ne(0,w.ILogService),ne(1,y.ISignService),ne(2,S.IProductService),ne(3,E.IConfigurationService)],m),e.TunnelService=m;let v=class extends P.Disposable{constructor(u,f,c,o){super();this.logService=u,this.productService=f,this.signService=c,this.configurationService=o,this._tunnelServices=new Map}async openTunnel(u,f,c,o,l,s,i,r){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${o} on local port ${l}.`),!this._tunnelServices.has(u)){const a=new m(this.logService,this.signService,this.productService,this.configurationService);this._register(a),this._tunnelServices.set(u,a),a.onTunnelClosed(async()=>{(await a.tunnels).length===0&&(a.dispose(),this._tunnelServices.delete(u))})}return this._tunnelServices.get(u).openTunnel(f,c,o,l,s,i,r)}};v=de([ne(0,w.ILogService),ne(1,S.IProductService),ne(2,y.ISignService),ne(3,E.IConfigurationService)],v),e.SharedTunnelsService=v}),define(ee[237],te([0,1,205,8,17,15,2,13,19,48,93,6,204,231]),function(j,e,p,n,D,M,P,E,w,S,b,k,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends P.Disposable{constructor(m,v,C){super();this.environmentService=v,this.logService=C,this.configure(m.getValue()),this._register(m.onDidChangeConfiguration(()=>this.configure(m.getValue()),this))}configure(m){this.proxyUrl=m.http&&m.http.proxy,this.strictSSL=!!(m.http&&m.http.proxyStrictSSL),this.authorization=m.http&&m.http.proxyAuthorization}async request(m,v){this.logService.trace("RequestService#request",m.url);const{proxyUrl:C,strictSSL:u}=this;let f;try{f=await(0,b.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(l){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",l))}const c={...process.env,...f},o=m.agent?m.agent:await(0,y.getProxyAgent)(m.url||"",c,{proxyUrl:C,strictSSL:u});return m.agent=o,m.strictSSL=u,this.authorization&&(m.headers={...m.headers||{},"Proxy-Authorization":this.authorization}),this._request(m,v)}async getNodeRequest(m){return((0,p.parse)(m.url).protocol==="https:"?await new Promise((u,f)=>{j(["https"],u,f)}):await new Promise((u,f)=>{j(["http"],u,f)})).request}_request(m,v){return n.Promises.withAsyncBody(async(C,u)=>{let f;const c=(0,p.parse)(m.url),o=m.getRawRequest?m.getRawRequest(m):await this.getNodeRequest(m),l={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,E.isBoolean)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(l.auth=m.user+":"+m.password),f=o(l,s=>{const i=(0,E.isNumber)(m.followRedirects)?m.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&i>0&&s.headers.location)this._request({...m,url:s.headers.location,followRedirects:i-1},v).then(C,u);else{let r=s;s.headers["content-encoding"]==="gzip"&&(r=s.pipe((0,g.createGunzip)())),C({res:s,stream:(0,D.streamToBufferReadableStream)(r)})}}),f.on("error",u),m.timeout&&f.setTimeout(m.timeout),m.data&&typeof m.data=="string"&&f.write(m.data),f.end(),v.onCancellationRequested(()=>{f.abort(),u((0,M.canceled)())})})}async resolveProxy(m){}};t=de([ne(0,w.IConfigurationService),ne(1,S.INativeEnvironmentService),ne(2,k.ILogService)],t),e.RequestService=t}),define(ee[238],te([0,1,14,237]),function(j,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(P){return p.net.request}class M extends n.RequestService{request(E,w){return super.request({...E||{},getRawRequest:D},w)}}e.RequestMainService=M}),define(ee[239],te([0,1,14,8,4,2,10,13,88,23,20,6,54,55,67,39]),function(j,e,p,n,D,M,P,E,w,S,b,k,y,g,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let m=class extends M.Disposable{constructor(C,u,f,c,o,l,s){super();this.machineId=C,this.userEnv=u,this.environmentMainService=f,this.lifecycleMainService=c,this.logService=o,this.themeMainService=l,this.protocolMainService=s,this.firstWindowConnectionBarrier=new n.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new D.Emitter),this.onDidError=D.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:createSharedProcessMessageChannel",(C,u)=>this.onWindowConnection(C,u)),p.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(C,u)=>this.onWorkerConnection(C,u)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(C,u){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const f=await this.connect();if(C.sender.isDestroyed())return f.close();C.sender.postMessage("vscode:createSharedProcessMessageChannelResult",u,[f])}onWorkerConnection(C,u){this.logService.trace("SharedProcess: onWorkerConnection",u);const f=new M.DisposableStore,c=l=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${l}')`,u),f.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",u))},o=p.BrowserWindow.fromId(u.reply.windowId);if(!o||o.isDestroyed()||o.webContents.isDestroyed()||!u.reply.channel){c("unavailable");return}f.add(D.Event.filter(this.lifecycleMainService.onWillLoadWindow,l=>l.window.win===o)(()=>c("load"))),f.add(D.Event.fromNodeEventEmitter(o,"closed")(()=>c("closed"))),o.webContents.postMessage(u.reply.channel,u.reply.nonce,C.ports)}onWillShutdown(){const C=this.window;!C||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(C.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{C.close()}catch{}this.window=void 0},0))}send(C,...u){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${C}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(C,...u)}catch(f){this.logService.warn(`Error sending IPC message to channel '${C}' of shared process: ${(0,d.toErrorMessage)(f)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(C=>p.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),C()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(C=>p.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),C()}))})()),this._whenIpcReady}createWindow(){const C=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new p.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${C.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1}}),C.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:y.default}),this.window.loadURL(P.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",j).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=C=>{this.logService.trace("SharedProcess#close prevented"),C.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(C,u)=>this._onDidError.fire({type:2,details:u})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(C,u,f)=>this._onDidError.fire({type:3,details:{reason:f,exitCode:u}})))}async connect(){await this.whenIpcReady;const C=(0,E.assertIsDefined)(this.window);return(0,w.connect)(C)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const C=this.window;return C?!C.isDestroyed()&&!C.webContents.isDestroyed():!1}};m=de([ne(2,S.IEnvironmentMainService),ne(3,b.ILifecycleMainService),ne(4,k.ILogService),ne(5,t.IThemeMainService),ne(6,g.IProtocolMainService)],m),e.SharedProcess=m}),define(ee[240],te([0,1,8,17,9,13,7,23,18,6]),function(j,e,p,n,D,M,P,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class b{constructor(g,t,d){this.storagePath=g,this.logService=t,this.fileService=d,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new p.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(g){g.fileOperationResult!==1&&this.logService.error(g)}}getItem(g,t){const d=this.storage[g];return(0,M.isUndefinedOrNull)(d)?t:d}setItem(g,t){this.setItems([{key:g,data:t}])}setItems(g){let t=!1;for(const{key:d,data:m}of g)this.storage[d]!==m&&((0,M.isUndefinedOrNull)(m)?(0,M.isUndefined)(this.storage[d])||(this.storage[d]=void 0,t=!0):(this.storage[d]=m,t=!0));t&&this.save()}removeItem(g){(0,M.isUndefined)(this.storage[g])||(this.storage[g]=void 0,this.save())}async save(g){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),g)}async doSave(){if(!this.initializing)return;await this.initializing;const g=JSON.stringify(this.storage,null,4);if(g!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,n.VSBuffer.fromString(g)),this.lastSavedStorageContents=g}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=b;let k=class Et{constructor(g,t,d){this.fileStorage=new b(P.URI.file((0,D.join)(g.userDataPath,Et.STATE_FILE)),t,d)}async init(){return this.fileStorage.init()}getItem(g,t){return this.fileStorage.getItem(g,t)}setItem(g,t){this.fileStorage.setItem(g,t)}setItems(g){this.fileStorage.setItems(g)}removeItem(g){this.fileStorage.removeItem(g)}close(){return this.fileStorage.close()}};k.STATE_FILE="storage.json",k=de([ne(0,E.IEnvironmentMainService),ne(1,S.ILogService),ne(2,w.IFileService)],k),e.StateMainService=k}),define(ee[80],te([0,1,42,2,48,23,5,20,6,79,228]),function(j,e,p,n,D,M,P,E,w,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GlobalStorageMainService=e.IGlobalStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,P.createDecorator)("storageMainService");let k=class extends n.Disposable{constructor(t,d,m){super();this.logService=t,this.environmentService=d,this.lifecycleMainService=m,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async t=>{t.workspace&&this.workspaceStorage(t.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(t=>{t.join(this.globalStorage.close());for(const[,d]of this.mapWorkspaceToStorage)t.join(d.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const t=new b.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,p.once)(t.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),t}createWorkspaceStorage(t){return new b.WorkspaceStorageMain(t,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(t){let d=this.mapWorkspaceToStorage.get(t.id);return d||(this.logService.trace(`StorageMainService: creating workspace storage (${t.id})`),d=this.createWorkspaceStorage(t),this.mapWorkspaceToStorage.set(t.id,d),(0,p.once)(d.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${t.id})`),this.mapWorkspaceToStorage.delete(t.id)})),d}};k=de([ne(0,w.ILogService),ne(1,D.IEnvironmentService),ne(2,E.ILifecycleMainService)],k),e.StorageMainService=k,e.IGlobalStorageMainService=(0,P.createDecorator)("globalStorageMainService");let y=class extends S.AbstractStorageService{constructor(t,d){super();this.environmentMainService=t,this.storageMainService=d,this.whenReady=this.storageMainService.globalStorage.whenInit}doInitialize(){return this.storageMainService.globalStorage.whenInit}getStorage(t){switch(t){case 0:return this.storageMainService.globalStorage.storage;case 1:return}}getLogDetails(t){return t===0?this.environmentMainService.globalStorageHome.fsPath:void 0}shouldFlushWhenIdle(){return!1}migrate(){throw new Error("Migrating storage is unsupported from main process")}};y=de([ne(0,M.IEnvironmentMainService),ne(1,e.IStorageMainService)],y),e.GlobalStorageMainService=y}),define(ee[81],te([0,1,8,21,4,19,23,20,6,22,49,41]),function(j,e,p,n,D,M,P,E,w,S,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function y(t,d,m){return`${m.updateUrl}/api/update/${t}/${d}/${m.commit}`}e.createUpdateURL=y;let g=class{constructor(d,m,v,C,u,f){this.lifecycleMainService=d,this.configurationService=m,this.environmentMainService=v,this.requestService=C,this.logService=u,this.productService=f,this._state=k.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(d){this.logService.info("update#setState",d.type),this._state=d,this._onStateChange.fire(d)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const d=this.getUpdateMode(),m=this.getProductQuality(d);if(!m){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(m),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(k.State.Idle(this.getUpdateType())),d==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}d==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}getUpdateMode(){return(0,M.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(d){return d==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(d=60*60*1e3){return(0,p.timeout)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(d){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(d)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(d){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(d=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},n.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};g=de([ne(0,E.ILifecycleMainService),ne(1,M.IConfigurationService),ne(2,P.IEnvironmentMainService),ne(3,b.IRequestService),ne(4,w.ILogService),ne(5,S.IProductService)],g),e.AbstractUpdateService=g}),define(ee[241],te([0,1,14,46,4,2,19,23,20,6,22,49,30,41,81]),function(j,e,p,n,D,M,P,E,w,S,b,k,y,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let d=class extends t.AbstractUpdateService{constructor(v,C,u,f,c,o,l){super(v,C,f,c,o,l);this.telemetryService=u,this.disposables=new M.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"error",(v,C)=>C)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"update-available",(v,C,u)=>({url:C,version:u,productVersion:u}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"update-downloaded",(v,C,u,f)=>({releaseNotes:C,version:u,productVersion:u,date:f}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(v){this.logService.error("UpdateService error:",v);const u=(this.state.type==="checking for updates"?this.state.explicit:!0)?v:void 0;this.setState(g.State.Idle(1,u))}buildUpdateFeedUrl(v){let C;this.productService.darwinUniversalAssetId?C=this.productService.darwinUniversalAssetId:C=process.arch==="x64"?"darwin":"darwin-arm64";const u=(0,t.createUpdateURL)(C,v,this.productService);try{p.autoUpdater.setFeedURL({url:u})}catch(f){this.logService.error("Failed to set update feed URL",f);return}return u}doCheckForUpdates(v){this.setState(g.State.CheckingForUpdates(v)),p.autoUpdater.checkForUpdates()}onUpdateAvailable(v){this.state.type==="checking for updates"&&this.setState(g.State.Downloading(v))}onUpdateDownloaded(v){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:v.version}),this.setState(g.State.Ready(v)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(g.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),p.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};de([n.memoize],d.prototype,"onRawError",null),de([n.memoize],d.prototype,"onRawUpdateNotAvailable",null),de([n.memoize],d.prototype,"onRawUpdateAvailable",null),de([n.memoize],d.prototype,"onRawUpdateDownloaded",null),d=de([ne(0,w.ILifecycleMainService),ne(1,P.IConfigurationService),ne(2,y.ITelemetryService),ne(3,E.IEnvironmentMainService),ne(4,k.IRequestService),ne(5,S.ILogService),ne(6,b.IProductService)],d),e.DarwinUpdateService=d}),define(ee[242],te([0,1,44,29,8,4,9,23,20,6,30,41]),function(j,e,p,n,D,M,P,E,w,S,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let y=class{constructor(d,m,v){if(this.lifecycleMainService=d,this.logService=v,this._state=k.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event,m.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(k.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,C=>this.logService.error(C))}get state(){return this._state}setState(d){this.logService.info("update#setState",d.type),this._state=d,this._onStateChange.fire(d)}scheduleCheckForUpdates(d=60*60*1e3){return(0,D.timeout)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(d){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(d)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(d){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(d=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};y=de([ne(0,w.ILifecycleMainService),ne(1,E.IEnvironmentMainService),ne(2,S.ILogService)],y);let g=class extends y{constructor(d,m,v,C,u,f){super(v,C,u);this.snap=d,this.snapRevision=m,this.telemetryService=f;const c=(0,n.watch)(P.dirname(this.snap)),o=M.Event.fromNodeEventEmitter(c,"change",(r,a)=>a),l=M.Event.filter(o,r=>r==="current"),i=M.Event.debounce(l,(r,a)=>a,2e3)(()=>this.checkForUpdates(!1));v.onWillShutdown(()=>{i.dispose(),c.close()})}doCheckForUpdates(){this.setState(k.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(d=>{d?this.setState(k.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(k.State.Idle(2)))},d=>{this.logService.error(d),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(k.State.Idle(2,d.message||d))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,p.spawn)("sleep 3 && "+P.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const d=await new Promise((v,C)=>(0,n.realpath)(`${P.dirname(this.snap)}/current`,(u,f)=>u?C(u):v(f))),m=P.basename(d);return this.snapRevision!==m}isLatestVersion(){return this.isUpdateAvailable().then(void 0,d=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};g=de([ne(2,w.ILifecycleMainService),ne(3,E.IEnvironmentMainService),ne(4,S.ILogService),ne(5,b.ITelemetryService)],g),e.SnapUpdateService=g}),define(ee[45],te([0,1,14,29,4,43,33,2,10,9,3,16,13,24,161,52,50,23,5,6,22,101,31,102]),function(j,e,p,n,D,M,P,E,w,S,b,k,y,g,t,d,m,v,C,u,f,c,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,C.createDecorator)("workspacesManagementMainService");let s=class extends E.Disposable{constructor(r,a,h,I,R){super();this.environmentMainService=r,this.logService=a,this.backupMainService=h,this.dialogMainService=I,this.productService=R,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new D.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new D.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(r){return this.doResolveLocalWorkspace(r,a=>(0,n.readFileSync)(a,"utf8"))}resolveLocalWorkspace(r){return this.doResolveLocalWorkspace(r,a=>g.Promises.readFile(a,"utf8"))}doResolveLocalWorkspace(r,a){if(!!this.isWorkspacePath(r)&&r.scheme===w.Schemas.file)try{const h=a(r.fsPath);return h instanceof Promise?h.then(I=>this.doResolveWorkspace(r,I),I=>{}):this.doResolveWorkspace(r,h)}catch{return}}isWorkspacePath(r){return(0,o.isUntitledWorkspace)(r,this.environmentMainService)||(0,o.hasWorkspaceFileExtension)(r)}doResolveWorkspace(r,a){try{const h=this.doParseStoredWorkspace(r,a),I=(0,l.getWorkspaceIdentifier)(r);return{id:I.id,configPath:I.configPath,folders:(0,o.toWorkspaceFolders)(h.folders,I.configPath,k.extUriBiasedIgnorePathCase),remoteAuthority:h.remoteAuthority,transient:h.transient}}catch(h){this.logService.warn(h.toString())}}doParseStoredWorkspace(r,a){const h=(0,M.parse)(a);if(h&&Array.isArray(h.folders))h.folders=h.folders.filter(I=>(0,o.isStoredWorkspaceFolder)(I));else throw new Error(`${r.toString(!0)} looks like an invalid workspace file.`);return h}async createUntitledWorkspace(r,a){const{workspace:h,storedWorkspace:I}=this.newUntitledWorkspace(r,a),R=h.configPath.fsPath;return await g.Promises.mkdir((0,S.dirname)(R),{recursive:!0}),await g.Promises.writeFile(R,JSON.stringify(I,null,"	")),h}createUntitledWorkspaceSync(r,a){const{workspace:h,storedWorkspace:I}=this.newUntitledWorkspace(r,a),R=h.configPath.fsPath;return(0,n.mkdirSync)((0,S.dirname)(R),{recursive:!0}),(0,g.writeFileSync)(R,JSON.stringify(I,null,"	")),h}newUntitledWorkspace(r=[],a){const h=(Date.now()+Math.round(Math.random()*1e3)).toString(),I=(0,k.joinPath)(this.untitledWorkspacesHome,h),R=(0,k.joinPath)(I,o.UNTITLED_WORKSPACE_NAME),L=[];for(const W of r)L.push((0,o.getStoredWorkspaceFolder)(W.uri,!0,W.name,I,!b.isWindows,k.extUriBiasedIgnorePathCase));return{workspace:(0,l.getWorkspaceIdentifier)(R),storedWorkspace:{folders:L,remoteAuthority:a}}}async getWorkspaceIdentifier(r){return(0,l.getWorkspaceIdentifier)(r)}isUntitledWorkspace(r){return(0,o.isUntitledWorkspace)(r.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(r){!this.isUntitledWorkspace(r)||(this.doDeleteUntitledWorkspaceSync(r),this._onDidDeleteUntitledWorkspace.fire(r))}async deleteUntitledWorkspace(r){this.deleteUntitledWorkspaceSync(r)}doDeleteUntitledWorkspaceSync(r){const a=(0,k.originalFSPath)(r.configPath);try{(0,g.rimrafSync)((0,S.dirname)(a));const h=(0,S.join)(this.environmentMainService.workspaceStorageHome.fsPath,r.id);(0,n.existsSync)(h)&&(0,g.writeFileSync)((0,S.join)(h,"obsolete"),"")}catch(h){this.logService.warn(`Unable to delete untitled workspace ${a} (${h}).`)}}getUntitledWorkspacesSync(){const r=[];try{const a=(0,g.readdirSync)(this.untitledWorkspacesHome.fsPath).map(h=>(0,k.joinPath)(this.untitledWorkspacesHome,h,o.UNTITLED_WORKSPACE_NAME));for(const h of a){const I=(0,l.getWorkspaceIdentifier)(h),R=this.resolveLocalWorkspaceSync(h);R?r.push({workspace:I,remoteAuthority:R.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(I)}}catch(a){a.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${a}).`)}return r}async enterWorkspace(r,a,h){if(!r||!r.win||!r.isReady||!await this.isValidTargetWorkspacePath(r,a,h))return;const R=this.doEnterWorkspace(r,(0,l.getWorkspaceIdentifier)(h));if(!!R)return this._onDidEnterWorkspace.fire({window:r,workspace:R.workspace}),R}async isValidTargetWorkspacePath(r,a,h){if(!h)return!0;if((0,o.isWorkspaceIdentifier)(r.openedWorkspace)&&k.extUriBiasedIgnorePathCase.isEqual(r.openedWorkspace.configPath,h))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(a,h)){const I={title:this.productService.nameLong,type:"info",buttons:[(0,P.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,k.basename)(h)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(I,(0,y.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(r,a){if(!r.config)return;r.focus();let h;return r.config.extensionDevelopmentPath||(h=this.backupMainService.registerWorkspaceBackupSync({workspace:a,remoteAuthority:r.remoteAuthority},r.config.backupPath)),(0,o.isWorkspaceIdentifier)(r.openedWorkspace)&&this.isUntitledWorkspace(r.openedWorkspace)&&this.deleteUntitledWorkspaceSync(r.openedWorkspace),r.config.workspace=a,r.config.backupPath=h,{workspace:a,backupPath:h}}};s=de([ne(0,v.IEnvironmentMainService),ne(1,u.ILogService),ne(2,d.IBackupMainService),ne(3,m.IDialogMainService),ne(4,f.IProductService)],s),e.WorkspacesManagementMainService=s}),define(ee[103],te([0,1,14,27,21,3,13,7,24,19,53,5,6,100,36,31,45]),function(j,e,p,n,D,M,P,E,w,S,b,k,y,g,t,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,k.createDecorator)(e.ID);let v=class{constructor(u,f,c,o,l){this.logService=u,this.windowsMainService=f,this.urlService=c,this.workspacesManagementMainService=o,this.configurationService=l}async start(u,f){this.logService.trace("Received data from other instance: ",u,f),M.isMacintosh&&p.app.focus({steal:!0});const c=this.parseOpenUrl(u);if(c.length){let o=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(o=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),o.then(()=>{for(const{uri:l,url:s}of c)this.urlService.open(l,{originalUrl:s})})}else return this.startOpenWindow(u,f)}parseOpenUrl(u){return u["open-url"]&&u._urls&&u._urls.length>0?(0,n.coalesce)(u._urls.map(f=>{try{return{uri:E.URI.parse(f),url:f}}catch{return null}})):[]}async startOpenWindow(u,f){const c=(0,b.isLaunchedFromCli)(f)?0:4;let o=[];const l=u.wait&&u.waitMarkerFilePath?E.URI.file(u.waitMarkerFilePath):void 0,s=u.remote||void 0,i={context:c,cli:u,userEnv:f,waitMarkerFileURI:l,remoteAuthority:s};if(u.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(u.extensionDevelopmentPath,i);else if(!u._.length&&!u["folder-uri"]&&!u["file-uri"]){let r=!1;if(u["new-window"]||u["unity-launch"])r=!0;else if(u["reuse-window"])r=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":r=!0;break;case"off":r=!1;break;default:r=!M.isMacintosh}if(r)o=this.windowsMainService.open({...i,forceNewWindow:!0,forceEmpty:!0});else{const a=this.windowsMainService.getLastActiveWindow();a?(this.windowsMainService.openExistingWindow(a,i),o=[a]):o=this.windowsMainService.open({...i,forceEmpty:!0})}}else o=this.windowsMainService.open({...i,forceNewWindow:u["new-window"],preferNewWindow:!u["reuse-window"]&&!u.wait,forceReuseWindow:u["reuse-window"],diffMode:u.diff,addMode:u.add,noRecentEntry:!!u["skip-add-to-recently-opened"],gotoLineMode:u.goto});if(l&&o.length===1&&o[0])return Promise.race([o[0].whenClosedOrLoaded,(0,w.whenDeleted)(l.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const u=[];return p.BrowserWindow.getAllWindows().forEach(f=>{const c=this.windowsMainService.getWindowById(f.id);c?u.push(this.codeWindowToInfo(c)):u.push(this.browserWindowToInfo(f))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:u,screenReader:!!p.app.accessibilitySupportEnabled,gpuFeatureStatus:p.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(u){const f=this.windowsMainService.getWindows();return(await Promise.all(f.map(o=>new Promise(l=>{const s=o.remoteAuthority;if(s){const i=`vscode:getDiagnosticInfoResponse${o.id}`,r={includeProcesses:u.includeProcesses,folders:u.includeWorkspaceMetadata?this.getFolderURIs(o):void 0};o.sendWhenReady("vscode:getDiagnosticInfo",D.CancellationToken.None,{replyChannel:i,args:r}),p.ipcMain.once(i,(a,h)=>{h||l({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),l(h)}),setTimeout(()=>{l({hostName:s,errorMessage:`Connection to '${s}' could not be established`})},5e3)}else l(void 0)})))).filter(o=>!!o)}getFolderURIs(u){const f=[],c=u.openedWorkspace;if((0,d.isSingleFolderWorkspaceIdentifier)(c))f.push(c.uri);else if((0,d.isWorkspaceIdentifier)(c)){const o=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.configPath);o&&o.folders.forEach(s=>{f.push(s.uri)})}return f}codeWindowToInfo(u){const f=this.getFolderURIs(u),c=(0,P.assertIsDefined)(u.win);return this.browserWindowToInfo(c,f,u.remoteAuthority)}browserWindowToInfo(u,f=[],c){return{pid:u.webContents.getOSProcessId(),title:u.getTitle(),folderURIs:f,remoteAuthority:c}}};v=de([ne(0,y.ILogService),ne(1,t.IWindowsMainService),ne(2,g.IURLService),ne(3,m.IWorkspacesManagementMainService),ne(4,S.IConfigurationService)],v),e.LaunchMainService=v}),define(ee[58],te([0,1,44,14,26,120,46,4,33,2,10,9,3,7,85,73,24,153,50,23,5,20,6,22,30,67,36,31,45]),function(j,e,p,n,D,M,P,E,w,S,b,k,y,g,t,d,m,v,C,u,f,c,o,l,s,i,r,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,f.createDecorator)("nativeHostMainService");let I=class extends S.Disposable{constructor(L,W,N,J,oe,re,V,Z,H,K){super();this.sharedProcess=L,this.windowsMainService=W,this.dialogMainService=N,this.lifecycleMainService=J,this.environmentMainService=oe,this.telemetryService=re,this.logService=V,this.productService=Z,this.themeMainService=H,this.workspacesManagementMainService=K,this.onDidOpenWindow=E.Event.map(this.windowsMainService.onDidOpenWindow,G=>G.id),this.onDidMaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(n.app,"browser-window-maximize",(G,z)=>z.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidUnmaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(n.app,"browser-window-unmaximize",(G,z)=>z.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidBlurWindow=E.Event.filter(E.Event.fromNodeEventEmitter(n.app,"browser-window-blur",(G,z)=>z.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidFocusWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),G=>!!G),G=>G.id),E.Event.filter(E.Event.fromNodeEventEmitter(n.app,"browser-window-focus",(G,z)=>z.id),G=>!!this.windowsMainService.getWindowById(G))),this.onDidResumeOS=E.Event.fromNodeEventEmitter(n.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new E.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new E.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(n.screen,"display-metrics-changed",(G,z,B)=>B),G=>!(Array.isArray(G)&&G.length===1&&G[0]==="workArea")),E.Event.fromNodeEventEmitter(n.screen,"display-added"),E.Event.fromNodeEventEmitter(n.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){n.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(W=>({id:W.id,workspace:W.openedWorkspace,title:W.win?.getTitle()??"",filename:W.getRepresentedFilename(),dirty:W.isDocumentEdited()}))}async getWindowCount(L){return this.windowsMainService.getWindowCount()}async getActiveWindowId(L){const W=n.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(W)return W.id}openWindow(L,W,N){return Array.isArray(W)?this.doOpenWindow(L,W,N):this.doOpenEmptyWindow(L,W)}async doOpenWindow(L,W,N=Object.create(null)){W.length>0&&this.windowsMainService.open({context:5,contextWindowId:L,urisToOpen:W,cli:this.environmentMainService.args,forceNewWindow:N.forceNewWindow,forceReuseWindow:N.forceReuseWindow,preferNewWindow:N.preferNewWindow,diffMode:N.diffMode,addMode:N.addMode,gotoLineMode:N.gotoLineMode,noRecentEntry:N.noRecentEntry,waitMarkerFileURI:N.waitMarkerFileURI,remoteAuthority:N.remoteAuthority||void 0})}async doOpenEmptyWindow(L,W){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:L},W)}async toggleFullScreen(L){const W=this.windowById(L);W&&W.toggleFullScreen()}async handleTitleDoubleClick(L){const W=this.windowById(L);W&&W.handleTitleDoubleClick()}async isMaximized(L){const W=this.windowById(L);return W?.win?W.win.isMaximized():!1}async maximizeWindow(L){const W=this.windowById(L);W?.win&&W.win.maximize()}async unmaximizeWindow(L){const W=this.windowById(L);W?.win&&W.win.unmaximize()}async minimizeWindow(L){const W=this.windowById(L);W?.win&&W.win.minimize()}async focusWindow(L,W){W&&typeof W.windowId=="number"&&(L=W.windowId);const N=this.windowById(L);N&&N.focus({force:W?.force??!1})}async setMinimumSize(L,W,N){const J=this.windowById(L);if(J?.win){const[oe,re]=J.win.getSize(),[V,Z]=J.win.getMinimumSize(),[H,K]=[W??V,N??Z],[G,z]=[Math.max(oe,H),Math.max(re,K)];(V!==H||Z!==K)&&J.win.setMinimumSize(H,K),(oe!==G||re!==z)&&J.win.setSize(G,z)}}async saveWindowSplash(L,W){this.themeMainService.saveWindowSplash(L,W)}async installShellCommand(L){const{source:W,target:N}=await this.getShellCommandLink();try{const{symbolicLink:J}=await m.SymlinkSupport.stat(W);if(J&&!J.dangling){const oe=await(0,t.realpath)(W);if(N===oe)return}await m.Promises.unlink(W)}catch(J){if(J.code!=="ENOENT")throw J}try{await m.Promises.symlink(N,W)}catch(J){if(J.code!=="EACCES"&&J.code!=="ENOENT")throw J;const{response:oe}=await this.showMessageBox(L,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,w.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,w.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(oe===0)try{const re=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${N}' '${W}'\\" with administrator privileges"`;await(0,M.promisify)(p.exec)(re)}catch{throw new Error((0,v.localize)(3,null,W))}}}async uninstallShellCommand(L){const{source:W}=await this.getShellCommandLink();try{await m.Promises.unlink(W)}catch(N){switch(N.code){case"EACCES":{const{response:J}=await this.showMessageBox(L,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,w.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,w.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(J===0)try{const oe=`osascript -e "do shell script \\"rm '${W}'\\" with administrator privileges"`;await(0,M.promisify)(p.exec)(oe)}catch{throw new Error((0,v.localize)(7,null,W))}break}case"ENOENT":break;default:throw N}}}async getShellCommandLink(){const L=(0,k.resolve)(this.environmentMainService.appRoot,"bin","code"),W=`/usr/local/bin/${this.productService.applicationName}`;if(!await m.Promises.exists(L))throw new Error((0,v.localize)(8,null,L));return{source:W,target:L}}async showMessageBox(L,W){return this.dialogMainService.showMessageBox(W,this.toBrowserWindow(L))}async showSaveDialog(L,W){return this.dialogMainService.showSaveDialog(W,this.toBrowserWindow(L))}async showOpenDialog(L,W){return this.dialogMainService.showOpenDialog(W,this.toBrowserWindow(L))}toBrowserWindow(L){const W=this.windowById(L);if(W?.win)return W.win}async pickFileFolderAndOpen(L,W){const N=await this.dialogMainService.pickFileFolder(W);N&&(this.sendPickerTelemetry(N,W.telemetryEventName||"openFileFolder",W.telemetryExtraData),this.doOpenPicked(await Promise.all(N.map(async J=>await m.SymlinkSupport.existsDirectory(J)?{folderUri:g.URI.file(J)}:{fileUri:g.URI.file(J)})),W,L))}async pickFolderAndOpen(L,W){const N=await this.dialogMainService.pickFolder(W);N&&(this.sendPickerTelemetry(N,W.telemetryEventName||"openFolder",W.telemetryExtraData),this.doOpenPicked(N.map(J=>({folderUri:g.URI.file(J)})),W,L))}async pickFileAndOpen(L,W){const N=await this.dialogMainService.pickFile(W);N&&(this.sendPickerTelemetry(N,W.telemetryEventName||"openFile",W.telemetryExtraData),this.doOpenPicked(N.map(J=>({fileUri:g.URI.file(J)})),W,L))}async pickWorkspaceAndOpen(L,W){const N=await this.dialogMainService.pickWorkspace(W);N&&(this.sendPickerTelemetry(N,W.telemetryEventName||"openWorkspace",W.telemetryExtraData),this.doOpenPicked(N.map(J=>({workspaceUri:g.URI.file(J)})),W,L))}doOpenPicked(L,W,N){this.windowsMainService.open({context:3,contextWindowId:N,cli:this.environmentMainService.args,urisToOpen:L,forceNewWindow:W.forceNewWindow})}sendPickerTelemetry(L,W,N){const J=L?L.length:0;this.telemetryService.publicLog(W,{...N,outcome:J?"success":"canceled",numberOfPaths:J})}async showItemInFolder(L,W){n.shell.showItemInFolder(W)}async setRepresentedFilename(L,W){const N=this.windowById(L);N&&N.setRepresentedFilename(W)}async setDocumentEdited(L,W){const N=this.windowById(L);N&&N.setDocumentEdited(W)}async openExternal(L,W){return y.isLinuxSnap?this.safeSnapOpenExternal(W):n.shell.openExternal(W),!0}safeSnapOpenExternal(L){const W=process.env.GDK_PIXBUF_MODULE_FILE,N=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,n.shell.openExternal(L),process.env.GDK_PIXBUF_MODULE_FILE=W,process.env.GDK_PIXBUF_MODULEDIR=N}moveItemToTrash(L,W){return n.shell.trashItem(W)}async isAdmin(){let L;return y.isWindows?L=(await new Promise((W,N)=>{j(["native-is-elevated"],W,N)}))():L=process.getuid()===0,L}async writeElevated(L,W,N,J){const oe=await new Promise((re,V)=>{j(["@vscode/sudo-prompt"],re,V)});return new Promise((re,V)=>{const Z=[`"${this.cliPath}"`];J?.unlock&&Z.push("--file-chmod"),Z.push("--file-write",`"${W.fsPath}"`,`"${N.fsPath}"`);const H={name:this.productService.nameLong.replace("-",""),icns:y.isMacintosh&&this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};oe.exec(Z.join(" "),H,(K,G,z)=>{G&&this.logService.trace(`[sudo-prompt] received stdout: ${G}`),z&&this.logService.trace(`[sudo-prompt] received stderr: ${z}`),K?V(K):re(void 0)})})}get cliPath(){return y.isWindows?this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):y.isLinux?this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,k.join)(this.environmentMainService.appRoot,"bin","code"):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,D.totalmem)(),freemem:(0,D.freemem)(),loadavg:(0,D.loadavg)()}}async getOSProperties(){return{arch:(0,D.arch)(),platform:(0,D.platform)(),release:(0,D.release)(),type:(0,D.type)(),cpus:(0,D.cpus)()}}async getOSVirtualMachineHint(){return d.virtualMachineHint.value()}get osColorScheme(){return{highContrast:n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors,dark:n.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(L,W,N){process.kill(W,N)}async readClipboardText(L,W){return n.clipboard.readText(W)}async writeClipboardText(L,W,N){return n.clipboard.writeText(W,N)}async readClipboardFindText(L){return n.clipboard.readFindText()}async writeClipboardFindText(L,W){return n.clipboard.writeFindText(W)}async writeClipboardBuffer(L,W,N,J){return n.clipboard.writeBuffer(W,Buffer.from(N),J)}async readClipboardBuffer(L,W){return n.clipboard.readBuffer(W)}async hasClipboard(L,W,N){return n.clipboard.has(W,N)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){n.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){n.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){n.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){n.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){n.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(L,W){const N=this.windowById(L);N&&N.updateTouchBar(W)}async notifyReady(L){const W=this.windowById(L);W&&W.setReady()}async relaunch(L,W){return this.lifecycleMainService.relaunch(W)}async reload(L,W){const N=this.windowById(L);if(N){if((0,a.isWorkspaceIdentifier)(N.openedWorkspace)){const J=N.openedWorkspace.configPath;if(J.scheme===b.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(J))?.transient)return this.openWindow(N.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(N,W?.disableExtensions!==void 0?{_:[],"disable-extensions":W.disableExtensions}:void 0)}}async closeWindow(L){this.closeWindowById(L,L)}async closeWindowById(L,W){const N=this.windowById(W);if(N?.win)return N.win.close()}async quit(L){const W=this.windowsMainService.getLastActiveWindow();W?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&W.win?W.win.close():this.lifecycleMainService.quit()}async exit(L,W){await this.lifecycleMainService.kill(W)}async resolveProxy(L,W){const J=this.windowById(L)?.win?.webContents?.session;if(J)return J.resolveProxy(W)}async openDevTools(L,W){const N=this.windowById(L);N?.win&&N.win.webContents.openDevTools(W)}async toggleDevTools(L){const W=this.windowById(L);W?.win&&W.win.webContents.toggleDevTools()}async sendInputEvent(L,W){const N=this.windowById(L);N?.win&&(W.type==="mouseDown"||W.type==="mouseUp")&&N.win.webContents.sendInputEvent(W)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(L,W,N,J){if(!y.isWindows)return;const oe=await new Promise((re,V)=>{j(["@vscode/windows-registry"],re,V)});try{return oe.GetStringRegKey(W,N,J)}catch{return}}windowById(L){if(typeof L=="number")return this.windowsMainService.getWindowById(L)}};de([P.memoize],I.prototype,"cliPath",null),I=de([ne(1,r.IWindowsMainService),ne(2,C.IDialogMainService),ne(3,c.ILifecycleMainService),ne(4,u.IEnvironmentMainService),ne(5,s.ITelemetryService),ne(6,o.ILogService),ne(7,l.IProductService),ne(8,i.IThemeMainService),ne(9,h.IWorkspacesManagementMainService)],I),e.NativeHostMainService=I}),define(ee[243],te([0,1,14,26,33,2,10,3,86,151,75,50,23,5,103,6,58,54,22,55,68]),function(j,e,p,n,D,M,P,E,w,S,b,k,y,g,t,d,m,v,C,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,g.createDecorator)("issueMainService");let c=class It{constructor(l,s,i,r,a,h,I,R,L){this.userEnv=l,this.environmentMainService=s,this.launchMainService=i,this.logService=r,this.diagnosticsService=a,this.dialogMainService=h,this.nativeHostMainService=I,this.protocolMainService=R,this.productService=L,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:issueSystemInfoRequest",async l=>{const[s,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),r=await this.diagnosticsService.getSystemInfo(s,i);this.safeSend(l,"vscode:issueSystemInfoResponse",r)}),p.ipcMain.on("vscode:listProcesses",async l=>{const s=[];try{const i=await this.launchMainService.getMainProcessId();s.push({name:(0,S.localize)(0,null),rootProcess:await(0,w.listProcesses)(i)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(a=>{(0,b.isRemoteDiagnosticError)(a)?s.push({name:a.hostName,rootProcess:a}):a.processes&&s.push({name:a.hostName,rootProcess:a.processes})})}catch(i){this.logService.error(`Listing processes failed: ${i}`)}this.safeSend(l,"vscode:listProcessesResponse",s)}),p.ipcMain.on("vscode:issueReporterClipboard",async l=>{const s={title:this.productService.nameLong,message:(0,S.localize)(1,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,S.localize)(2,null)),(0,D.mnemonicButtonLabel)((0,S.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const i=await this.dialogMainService.showMessageBox(s,this.issueReporterWindow);this.safeSend(l,"vscode:issueReporterClipboardResponse",i.response===0)}}),p.ipcMain.on("vscode:issuePerformanceInfoRequest",async l=>{const s=await this.getPerformanceInfo();this.safeSend(l,"vscode:issuePerformanceInfoResponse",s)}),p.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const l={title:this.productService.nameLong,message:(0,S.localize)(4,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,S.localize)(5,null)),(0,D.mnemonicButtonLabel)((0,S.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(l,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),p.ipcMain.on("vscode:workbenchCommand",(l,s)=>{const{id:i,from:r,args:a}=s;let h;switch(r){case"issueReporter":h=this.issueReporterParentWindow;break;case"processExplorer":h=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${r}`)}h&&h.webContents.send("vscode:runAction",{id:i,from:r,args:a})}),p.ipcMain.on("vscode:openExternal",(l,s)=>{this.nativeHostMainService.openExternal(void 0,s)}),p.ipcMain.on("vscode:closeIssueReporter",l=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),p.ipcMain.on("vscode:closeProcessExplorer",l=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),p.ipcMain.on("vscode:windowsInfoRequest",async l=>{const s=await this.launchMainService.getMainProcessInfo();this.safeSend(l,"vscode:windowsInfoResponse",s.windows)})}safeSend(l,s,...i){l.sender.isDestroyed()||l.sender.send(s,...i)}async openReporter(l){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=p.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const s=new M.DisposableStore,i=s.add(this.protocolMainService.createIPCObjectUrl()),r=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(r,i,{backgroundColor:l.styles.backgroundColor,title:(0,S.localize)(7,null),zoomLevel:l.zoomLevel,alwaysOnTop:!1},"issue-reporter"),i.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:l,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,n.type)(),arch:(0,n.arch)(),release:(0,n.release)()},product:v.default}),this.issueReporterWindow.loadURL(P.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",j).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,s.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,s.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(l){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=p.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const s=new M.DisposableStore,i=s.add(this.protocolMainService.createIPCObjectUrl()),r=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(r,i,{backgroundColor:l.styles.backgroundColor,title:(0,S.localize)(8,null),zoomLevel:l.zoomLevel,alwaysOnTop:!0},"process-explorer"),i.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:l,product:v.default}),this.processExplorerWindow.loadURL(P.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",j).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,s.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,s.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(l){l.isMinimized()&&l.restore(),l.focus()}createBrowserWindow(l,s,i,r){const a=new p.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:l.width,height:l.height,minWidth:300,minHeight:200,x:l.x,y:l.y,title:i.title,backgroundColor:i.backgroundColor||It.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${s.resource.toString()}`,`--vscode-window-kind=${r}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,f.zoomLevelToZoomFactor)(i.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:i.alwaysOnTop,experimentalDarkMode:!0});return a.setMenuBarVisibility(!1),a}async getSystemStatus(){const[l,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(l,s)}getWindowPosition(l,s,i){let r;const a=p.screen.getAllDisplays();if(a.length===1)r=a[0];else{if(E.isMacintosh){const R=p.screen.getCursorScreenPoint();r=p.screen.getDisplayNearestPoint(R)}!r&&l&&(r=p.screen.getDisplayMatching(l.getBounds())),r||(r=p.screen.getPrimaryDisplay()||a[0])}const h={width:s,height:i},I=r.bounds;return h.x=I.x+I.width/2-h.width/2,h.y=I.y+I.height/2-h.height/2,I.width>0&&I.height>0&&(h.x<I.x&&(h.x=I.x),h.y<I.y&&(h.y=I.y),h.x>I.x+I.width&&(h.x=I.x),h.y>I.y+I.height&&(h.y=I.y),h.width>I.width&&(h.width=I.width),h.height>I.height&&(h.height=I.height)),h}async getPerformanceInfo(){try{const[l,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(l,s)}catch(l){throw this.logService.warn("issueService#getPerformanceInfo ",l.message),l}}};c.DEFAULT_BACKGROUND_COLOR="#1E1E1E",c=de([ne(1,y.IEnvironmentMainService),ne(2,t.ILaunchMainService),ne(3,d.ILogService),ne(4,b.IDiagnosticsService),ne(5,k.IDialogMainService),ne(6,m.INativeHostMainService),ne(7,u.IProtocolMainService),ne(8,C.IProductService)],c),e.IssueMainService=c}),define(ee[244],te([0,1,21,19,23,20,6,58,22,49,30,41,81]),function(j,e,p,n,D,M,P,E,w,S,b,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let g=class extends y.AbstractUpdateService{constructor(d,m,v,C,u,f,c,o){super(d,m,C,u,f,o);this.telemetryService=v,this.nativeHostMainService=c}buildUpdateFeedUrl(d){return(0,y.createUpdateURL)(`linux-${process.arch}`,d,this.productService)}doCheckForUpdates(d){!this.url||(this.setState(k.State.CheckingForUpdates(d)),this.requestService.request({url:this.url},p.CancellationToken.None).then(S.asJson).then(m=>{!m||!m.url||!m.version||!m.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d}),this.setState(k.State.Idle(1))):this.setState(k.State.AvailableForDownload(m))}).then(void 0,m=>{this.logService.error(m),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d});const v=d?m.message||m:void 0;this.setState(k.State.Idle(1,v))}))}async doDownloadUpdate(d){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):d.update.url&&this.nativeHostMainService.openExternal(void 0,d.update.url),this.setState(k.State.Idle(1))}};g=de([ne(0,M.ILifecycleMainService),ne(1,n.IConfigurationService),ne(2,b.ITelemetryService),ne(3,D.IEnvironmentMainService),ne(4,S.IRequestService),ne(5,P.ILogService),ne(6,E.INativeHostMainService),ne(7,w.IProductService)],g),e.LinuxUpdateService=g}),define(ee[245],te([0,1,44,29,26,8,21,46,9,7,117,24,19,23,18,20,6,58,22,49,30,41,81]),function(j,e,p,n,D,M,P,E,w,S,b,k,y,g,t,d,m,v,C,u,f,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function l(a,h=1e3){for(;!a();)await(0,M.timeout)(h)}let s;function i(){return typeof s=="undefined"&&(s=n.existsSync(w.join(w.dirname(process.execPath),"unins000.exe"))?0:1),s}let r=class extends o.AbstractUpdateService{constructor(h,I,R,L,W,N,J,oe,re){super(h,I,L,W,N,re);this.telemetryService=R,this.fileService=J,this.nativeHostMainService=oe}get cachePath(){const h=w.join((0,D.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return k.Promises.mkdir(h,{recursive:!0}).then(()=>h)}initialize(){super.initialize(),i()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(h){let I="win32";return process.arch!=="ia32"&&(I+=`-${process.arch}`),i()===1?I+="-archive":this.productService.target==="user"&&(I+="-user"),(0,o.createUpdateURL)(I,h,this.productService)}doCheckForUpdates(h){!this.url||(this.setState(c.State.CheckingForUpdates(h)),this.requestService.request({url:this.url},P.CancellationToken.None).then(u.asJson).then(I=>{const R=i();return!I||!I.url||!I.version||!I.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h}),this.setState(c.State.Idle(R)),Promise.resolve(null)):R===1?(this.setState(c.State.AvailableForDownload(I)),Promise.resolve(null)):(this.setState(c.State.Downloading(I)),this.cleanup(I.version).then(()=>this.getUpdatePackagePath(I.version).then(L=>k.Promises.exists(L).then(W=>{if(W)return Promise.resolve(L);const N=I.url,J=I.hash,oe=`${L}.tmp`;return this.requestService.request({url:N},P.CancellationToken.None).then(re=>this.fileService.writeFile(S.URI.file(oe),re.stream)).then(J?()=>(0,b.checksum)(oe,I.hash):()=>{}).then(()=>k.Promises.rename(oe,L)).then(()=>L)})).then(L=>{const W=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:L},W&&I.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(I)):this.setState(c.State.Ready(I))})))}).then(void 0,I=>{this.logService.error(I),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h});const R=h?I.message||I:void 0;this.setState(c.State.Idle(i(),R))}))}async doDownloadUpdate(h){h.update.url&&this.nativeHostMainService.openExternal(void 0,h.update.url),this.setState(c.State.Idle(i()))}async getUpdatePackagePath(h){const I=await this.cachePath;return w.join(I,`CodeSetup-${this.productService.quality}-${h}.exe`)}async cleanup(h=null){const I=h?N=>!new RegExp(`${this.productService.quality}-${h}\\.exe$`).test(N):()=>!0,R=await this.cachePath,W=(await k.Promises.readdir(R)).filter(I).map(async N=>{try{await k.Promises.unlink(w.join(R,N))}catch{}});await Promise.all(W)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const h=this.state.update;this.setState(c.State.Updating(h));const I=await this.cachePath;this.availableUpdate.updateFilePath=w.join(I,`CodeSetup-${this.productService.quality}-${h.version}.flag`),await k.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,p.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(i()))});const L=`${this.productService.win32MutexName}-ready`,W=await new Promise((N,J)=>{j(["windows-mutex"],N,J)});l(()=>W.isActive(L)).then(()=>this.setState(c.State.Ready(h)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?n.unlinkSync(this.availableUpdate.updateFilePath):(0,p.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}};de([E.memoize],r.prototype,"cachePath",null),r=de([ne(0,d.ILifecycleMainService),ne(1,y.IConfigurationService),ne(2,f.ITelemetryService),ne(3,g.IEnvironmentMainService),ne(4,u.IRequestService),ne(5,m.ILogService),ne(6,t.IFileService),ne(7,v.INativeHostMainService),ne(8,C.IProductService)],r),e.Win32UpdateService=r}),define(ee[246],te([0,1,14,8,21,39,4,33,2,10,9,64,3,7,157,52,19,50,23,53,212,18,20,6,22,55,80,30,215,67,68,36,31,45]),function(j,e,p,n,D,M,P,E,w,S,b,k,y,g,t,d,m,v,C,u,f,c,o,l,s,i,r,a,h,I,R,L,W,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var J;(function(re){re[re.NONE=0]="NONE",re[re.NAVIGATING=1]="NAVIGATING",re[re.READY=2]="READY"})(J||(J={}));let oe=class extends w.Disposable{constructor(V,Z,H,K,G,z,B,Y,q,F,$,A,T,U,O){super();this.logService=Z,this.environmentMainService=H,this.fileService=K,this.globalStorageMainService=G,this.configurationService=z,this.themeMainService=B,this.workspacesManagementMainService=Y,this.backupMainService=q,this.telemetryService=F,this.dialogMainService=$,this.lifecycleMainService=A,this.productService=T,this.protocolMainService=U,this.windowsMainService=O,this._onWillLoad=this._register(new P.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new P.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new P.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new P.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[_,Q]=this.restoreWindowState(V.state);this.windowState=_,this.logService.trace("window#ctor: using window state",_);const ie=this.windowState.mode===0||this.windowState.mode===3,se=this.configurationService.getValue("window"),x={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:R.WindowMinimumSize.WIDTH,minHeight:R.WindowMinimumSize.HEIGHT,show:!ie,title:this.productService.nameLong,webPreferences:{preload:S.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,R.zoomLevelToZoomFactor)(se?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};y.isLinux?x.icon=(0,b.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):y.isWindows&&!this.environmentMainService.isBuilt&&(x.icon=(0,b.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),y.isMacintosh&&!this.useNativeFullScreen()&&(x.fullscreenable=!1),y.isMacintosh&&(x.acceptFirstMouse=!0,se?.clickThroughInactive===!1&&(x.acceptFirstMouse=!1));const ce=y.isMacintosh&&se?.nativeTabs===!0;ce&&(x.tabbingIdentifier=this.productService.nameShort);const le=(0,R.getTitleBarStyle)(this.configurationService)==="custom";if(le&&(x.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,y.isMacintosh||(x.frame=!1)),(0,k.mark)("code/willCreateCodeBrowserWindow"),this._win=new p.BrowserWindow(x),(0,k.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),y.isMacintosh&&le&&this._win.setSheetOffset(22),y.isMacintosh&&Q&&(!ce||p.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(he=>typeof he=="number")){const he=this.windowState;this._win.setBounds({width:he.width,height:he.height,x:he.x,y:he.y})}ie&&((0,k.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,k.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(V){y.isMacintosh?this._win.setRepresentedFilename(V):this.representedFilename=V}getRepresentedFilename(){return y.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(V){y.isMacintosh&&this._win.setDocumentEdited(V),this.documentEdited=V}isDocumentEdited(){return y.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(V){y.isMacintosh&&V?.force&&p.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(V=>{if(this.isReady)return V(this);this.whenReadyCallbacks.push(V)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(V=>{function Z(){H.dispose(),K.dispose(),V()}const H=this.onDidClose(()=>Z()),K=this.onWillLoad(()=>Z())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(Z,H)=>this.onWindowError(2,H)),this._win.webContents.on("did-fail-load",(Z,H,K)=>this.onWindowError(3,{reason:K,exitCode:H})),this._win.webContents.on("will-prevent-unload",Z=>{Z.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",Z=>{this.currentConfig&&(this.currentConfig.maximized=!0),p.app.emit("browser-window-maximize",Z,this._win)}),this._win.on("unmaximize",Z=>{this.currentConfig&&(this.currentConfig.maximized=!1),p.app.emit("browser-window-unmaximize",Z,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",D.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",D.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(Z=>this.onDidDeleteUntitledWorkspace(Z)));const V=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:V},async(Z,H)=>{const K=await this.getMarketplaceHeaders();H({cancel:!1,requestHeaders:Object.assign(Z.requestHeaders,K)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,f.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.globalStorageMainService)),this.marketplaceHeadersPromise}async onWindowError(V,Z){switch(V){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${Z?.reason||"<unknown>"}, code: ${Z?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${Z?.reason||"<unknown>"}, code: ${Z?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:V,reason:Z?.reason,code:Z?.exitCode}),V){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.driverHandle){this.destroyWindow(!1);return}if(V===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const H=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,t.localize)(0,null)),(0,E.mnemonicButtonLabel)((0,t.localize)(1,null)),(0,E.mnemonicButtonLabel)((0,t.localize)(2,null))],message:(0,t.localize)(3,null),detail:(0,t.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(H.response!==1){const K=H.response===0;this.destroyWindow(K)}}else if(V===2){let H;Z?H=(0,t.localize)(6,null,Z.reason,Z.exitCode??"<unknown>"):H=(0,t.localize)(5,null);const G=(await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,t.localize)(7,null)),(0,E.mnemonicButtonLabel)((0,t.localize)(8,null))],message:H,detail:(0,t.localize)(9,null),noLink:!0,defaultId:0},this._win)).response===0;this.destroyWindow(G)}break}}destroyWindow(V){if(this._onDidDestroy.fire(),this._win?.destroy(),V&&this.config){let Z,H;(0,W.isSingleFolderWorkspaceIdentifier)(this.openedWorkspace)?Z={folderUri:this.openedWorkspace.uri}:(0,W.isWorkspaceIdentifier)(this.openedWorkspace)?Z={workspaceUri:this.openedWorkspace.configPath}:H=!0;const[K]=this.windowsMainService.open({context:5,userEnv:this.config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:Z?[Z]:void 0,forceEmpty:H,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});K.focus()}}onDidDeleteUntitledWorkspace(V){this.openedWorkspace?.id===V.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const V=this.getMenuBarVisibility();V!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=V,this.setMenuBarVisibility(V));let Z=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;Z?.endsWith("/")&&(Z=Z.substr(0,Z.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((Z||"").indexOf("@")===-1&&(Z!==this.currentHttpProxy||H!==this.currentNoProxy)){this.currentHttpProxy=Z,this.currentNoProxy=H;const K=Z||"",G=H?`${H},<local>`:"<local>";this.logService.trace(`Setting proxy to '${K}', bypassing '${G}'`),this._win.webContents.session.setProxy({proxyRules:K,proxyBypassRules:G,pacScript:""})}}addTabbedWindow(V){y.isMacintosh&&V.win&&this._win.addTabbedWindow(V.win)}load(V,Z=Object.create(null)){this.isDocumentEdited()&&(!Z.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),Z.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(V,Z),this.readyState===0?this.currentConfig=V:this.pendingLoadConfig=V,this.readyState=1,this._win.loadURL(S.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",j).toString(!0));const H=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new n.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:V.workspace,reason:Z.isReload?3:H?2:1})}updateConfiguration(V,Z){const H=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(H){const K=(0,u.isLaunchedFromCli)(H)&&!(0,u.isLaunchedFromCli)(V.userEnv),G=this.isExtensionDevelopmentHost;(K||G)&&(V.userEnv={...H,...V.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(V.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),Z.disableExtensions!==void 0&&(V["disable-extensions"]=Z.disableExtensions),V.fullscreen=this.isFullScreen,V.maximized=this._win.isMaximized(),V.partsSplash=this.themeMainService.getWindowSplash(),(0,k.mark)("code/willOpenNewWindow"),V.perfMarks=(0,k.getMarks)(),this.configObjectUrl.update(V)}async reload(V){const Z=Object.assign({},this.currentConfig);Z.workspace=await this.validateWorkspaceBeforeReload(Z),delete Z.filesToOpenOrCreate,delete Z.filesToDiff,delete Z.filesToWait,this.isExtensionDevelopmentHost&&V&&(Z.verbose=V.verbose,Z.debugId=V.debugId,Z.extensionEnvironment=V.extensionEnvironment,Z["inspect-extensions"]=V["inspect-extensions"],Z["inspect-brk-extensions"]=V["inspect-brk-extensions"],Z["extensions-dir"]=V["extensions-dir"]),Z.isInitialStartup=!1,this.load(Z,{isReload:!0,disableExtensions:V?.["disable-extensions"]})}async validateWorkspaceBeforeReload(V){if((0,W.isWorkspaceIdentifier)(V.workspace)){const Z=V.workspace.configPath;if(Z.scheme===S.Schemas.file&&!await this.fileService.exists(Z))return}else if((0,W.isSingleFolderWorkspaceIdentifier)(V.workspace)){const Z=V.workspace.uri;if(Z.scheme===S.Schemas.file&&!await this.fileService.exists(Z))return}return V.workspace}serializeWindowState(){if(!this._win)return(0,L.defaultWindowState)();if(this.isFullScreen){let H;try{H=p.screen.getDisplayMatching(this.getBounds())}catch{}const K=(0,L.defaultWindowState)();return{mode:3,display:H?H.id:void 0,width:this.windowState.width||K.width,height:this.windowState.height||K.height,x:this.windowState.x||0,y:this.windowState.y||0}}const V=Object.create(null);let Z;if(!y.isMacintosh&&this._win.isMaximized()?Z=0:Z=1,Z===0?V.mode=0:V.mode=1,Z===1||Z===0){let H;Z===1?H=this.getBounds():H=this._win.getNormalBounds(),V.x=H.x,V.y=H.y,V.width=H.width,V.height=H.height}return V}restoreWindowState(V){(0,k.mark)("code/willRestoreCodeWindowState");let Z=!1;if(V)try{const H=p.screen.getAllDisplays();Z=H.length>1,V=this.validateWindowState(V,H)}catch(H){this.logService.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}return(0,k.mark)("code/didRestoreCodeWindowState"),[V||(0,L.defaultWindowState)(),Z]}validateWindowState(V,Z){if(this.logService.trace(`window#validateWindowState: validating window state on ${Z.length} display(s)`,V),typeof V.x!="number"||typeof V.y!="number"||typeof V.width!="number"||typeof V.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(V.width<=0||V.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(Z.length===1){const G=this.getWorkingArea(Z[0]);if(G){let z=function(){!V||typeof V.x!="number"||typeof V.y!="number"||!G||(V.x<G.x&&(V.x=G.x),V.y<G.y&&(V.y=G.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",G),z(),V.width>G.width&&(V.width=G.width),V.height>G.height&&(V.height=G.height),V.x>G.x+G.width-128&&(V.x=G.x+G.width-V.width),V.y>G.y+G.height-128&&(V.y=G.y+G.height-V.height),z()}return V}if(V.display&&V.mode===3){const G=Z.find(z=>z.id===V.display);if(G&&typeof G.bounds?.x=="number"&&typeof G.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const z=(0,L.defaultWindowState)(3);return z.x=G.bounds.x,z.y=G.bounds.y,z}}let H,K;try{H=p.screen.getDisplayMatching({x:V.x,y:V.y,width:V.width,height:V.height}),K=this.getWorkingArea(H)}catch{}if(H&&K&&V.x+V.width>K.x&&V.y+V.height>K.y&&V.x<K.x+K.width&&V.y<K.y+K.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",K),V}getWorkingArea(V){if(V.workArea.width>0&&V.workArea.height>0)return V.workArea;if(V.bounds.width>0&&V.bounds.height>0)return V.bounds}getBounds(){const[V,Z]=this._win.getPosition(),[H,K]=this._win.getSize();return{x:V,y:Z,width:H,height:K}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(V){this.useNativeFullScreen()?this.setNativeFullScreen(V):this.setSimpleFullScreen(V),this.sendWhenReady(V?"vscode:enterFullScreen":"vscode:leaveFullScreen",D.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(V){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(V)}setSimpleFullScreen(V){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(V),this._win.webContents.focus()}useNativeFullScreen(){const V=this.configurationService.getValue("window");return!V||typeof V.nativeFullScreen!="boolean"||V.nativeTabs?!0:V.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let V=(0,R.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(V)<0&&(V="classic"),V}setMenuBarVisibility(V,Z=!0){y.isMacintosh||(V==="toggle"&&Z&&this.send("vscode:showInfoMessage",(0,t.localize)(10,null)),V==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(V)}):this.doSetMenuBarVisibility(V))}doSetMenuBarVisibility(V){const Z=this.isFullScreen;switch(V){case"classic":this._win.setMenuBarVisibility(!Z),this._win.autoHideMenuBar=Z;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(y.isMacintosh)switch(p.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(V,Z,...H){this.isReady?this.send(V,...H):this.ready().then(()=>{Z.isCancellationRequested||this.send(V,...H)})}send(V,...Z){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${V}' for window that is destroyed`);return}try{this._win.webContents.send(V,...Z)}catch(H){this.logService.warn(`Error sending IPC message to channel '${V}' of window ${this._id}: ${(0,M.toErrorMessage)(H)}`)}}}updateTouchBar(V){!y.isMacintosh||this.touchBarGroups.forEach((Z,H)=>{const K=V[H];Z.segments=this.createTouchBarGroupSegments(K)})}createTouchBar(){if(!!y.isMacintosh){for(let V=0;V<10;V++){const Z=this.createTouchBarGroup();this.touchBarGroups.push(Z)}this._win.setTouchBar(new p.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(V=[]){const Z=this.createTouchBarGroupSegments(V),H=new p.TouchBar.TouchBarSegmentedControl({segments:Z,mode:"buttons",segmentStyle:"automatic",change:K=>{this.sendWhenReady("vscode:runAction",D.CancellationToken.None,{id:H.segments[K].id,from:"touchbar"})}});return H}createTouchBarGroupSegments(V=[]){return V.map(H=>{let K;H.icon&&!h.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===S.Schemas.file&&(K=p.nativeImage.createFromPath(g.URI.revive(H.icon.dark).fsPath),K.isEmpty()&&(K=void 0));let G;return typeof H.title=="string"?G=H.title:G=H.title.value,{id:H.id,label:K?void 0:G,icon:K}})}dispose(){super.dispose(),this._win=null}};oe=de([ne(1,l.ILogService),ne(2,C.IEnvironmentMainService),ne(3,c.IFileService),ne(4,r.IGlobalStorageMainService),ne(5,m.IConfigurationService),ne(6,I.IThemeMainService),ne(7,N.IWorkspacesManagementMainService),ne(8,d.IBackupMainService),ne(9,a.ITelemetryService),ne(10,v.IDialogMainService),ne(11,o.ILifecycleMainService),ne(12,s.IProductService),ne(13,i.IProtocolMainService),ne(14,L.IWindowsMainService)],oe),e.CodeWindow=oe}),define(ee[69],te([0,1,14,27,8,4,33,2,10,3,16,7,24,160,5,20,6,38,80,31,45]),function(j,e,p,n,D,M,P,E,w,S,b,k,y,g,t,d,m,v,C,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let c=class $e extends E.Disposable{constructor(l,s,i,r,a){super();this.stateMainService=l,this.logService=s,this.workspacesManagementMainService=i,this.lifecycleMainService=r,this.globalStorageMainService=a,this._onDidChangeRecentlyOpened=this._register(new M.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new D.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(l=>this.addRecentlyOpened([{workspace:l.workspace,remoteAuthority:l.window.remoteAuthority}])))}async addRecentlyOpened(l){const s=[],i=[];for(let r of l)if((0,u.isRecentWorkspace)(r))!this.workspacesManagementMainService.isUntitledWorkspace(r.workspace)&&this.indexOfWorkspace(s,r.workspace)===-1&&s.push(r);else if((0,u.isRecentFolder)(r))this.indexOfFolder(s,r.folderUri)===-1&&s.push(r);else{const a=this.indexOfFile(i,r.fileUri)>=0,h=r.fileUri.scheme===w.Schemas.file&&$e.COMMON_FILES_FILTER.indexOf((0,b.basename)(r.fileUri))>=0;!a&&!h&&(i.push(r),S.isWindows&&r.fileUri.scheme===w.Schemas.file&&p.app.addRecentDocument(r.fileUri.fsPath))}await this.addEntriesFromStorage(s,i),s.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(s.length=$e.MAX_TOTAL_RECENT_ENTRIES),i.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(i.length=$e.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:s,files:i}),this._onDidChangeRecentlyOpened.fire(),S.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(l){const s=h=>{const I=this.location(h);for(const R of l)if(b.extUriBiasedIgnorePathCase.isEqual(R,I))return!1;return!0},i=await this.getRecentlyOpened(),r=i.workspaces.filter(s),a=i.files.filter(s);(r.length!==i.workspaces.length||a.length!==i.files.length)&&(await this.saveRecentlyOpened({files:a,workspaces:r}),this._onDidChangeRecentlyOpened.fire(),S.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),p.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(l){const s=[],i=[];if(l){const a=l.config?.workspace;(0,u.isWorkspaceIdentifier)(a)&&!this.workspacesManagementMainService.isUntitledWorkspace(a)?s.push({workspace:a,remoteAuthority:l.remoteAuthority}):(0,u.isSingleFolderWorkspaceIdentifier)(a)&&s.push({folderUri:a.uri,remoteAuthority:l.remoteAuthority})}const r=l?.config?.filesToOpenOrCreate;if(r)for(let a of r){const h=a.fileUri;h&&this.indexOfFile(i,h)===-1&&i.push({fileUri:h})}return await this.addEntriesFromStorage(s,i),{workspaces:s,files:i}}async addEntriesFromStorage(l,s){let i=await this.getRecentlyOpenedFromStorage();for(let r of i.workspaces){let a=(0,u.isRecentFolder)(r)?this.indexOfFolder(l,r.folderUri):this.indexOfWorkspace(l,r.workspace);a>=0?l[a].label=l[a].label||r.label:l.push(r)}for(let r of i.files){let a=this.indexOfFile(s,r.fileUri);a>=0?s[a].label=s[a].label||r.label:s.push(r)}}async getRecentlyOpenedFromStorage(){await this.globalStorageMainService.whenReady;let l;const s=this.globalStorageMainService.get($e.RECENTLY_OPENED_STORAGE_KEY,0);if(typeof s=="string")try{l=JSON.parse(s)}catch(i){this.logService.error("Unexpected error parsing opened paths list",i)}else l=this.stateMainService.getItem($e.legacyRecentlyOpenedStorageKey),l&&(this.stateMainService.removeItem($e.legacyRecentlyOpenedStorageKey),this.globalStorageMainService.store($e.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify(l),0,1));return(0,u.restoreRecentlyOpened)(l,this.logService)}async saveRecentlyOpened(l){await this.globalStorageMainService.whenReady,this.globalStorageMainService.store($e.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,u.toStoreData)(l)),0,1)}location(l){return(0,u.isRecentFolder)(l)?l.folderUri:(0,u.isRecentFile)(l)?l.fileUri:l.workspace.configPath}indexOfWorkspace(l,s){return l.findIndex(i=>(0,u.isRecentWorkspace)(i)&&i.workspace.id===s.id)}indexOfFolder(l,s){return l.findIndex(i=>(0,u.isRecentFolder)(i)&&b.extUriBiasedIgnorePathCase.isEqual(i.folderUri,s))}indexOfFile(l,s){return l.findIndex(i=>b.extUriBiasedIgnorePathCase.isEqual(i.fileUri,s))}async handleWindowsJumpList(){!S.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!S.isWindows)return;const l=[];if(l.push({type:"tasks",items:[{type:"task",title:(0,g.localize)(0,null),description:(0,g.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){let s=[];for(let a of p.app.getJumpListSettings().removedItems){const h=a.args;if(h){const I=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(h);I&&s.push(k.URI.parse(I[2]))}}await this.removeRecentlyOpened(s);let i=!1;const r=(0,n.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,$e.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(a=>{const h=(0,u.isRecentWorkspace)(a)?a.workspace:a.folderUri,{title:I,description:R}=this.getWindowsJumpListLabel(h,a.label);let L;return k.URI.isUri(h)?L=`--folder-uri "${h.toString()}"`:(i=!0,L=`--file-uri "${h.configPath.toString()}"`),{type:"task",title:I.substr(0,255),description:R.substr(0,255),program:process.execPath,args:L,iconPath:"explorer.exe",iconIndex:0}}));r.length>0&&l.push({type:"custom",name:i?(0,g.localize)(2,null):(0,g.localize)(3,null),items:r})}l.push({type:"recent"});try{p.app.setJumpList(l)}catch(s){this.logService.warn("updateWindowsJumpList#setJumpList",s)}}getWindowsJumpListLabel(l,s){if(s)return{title:(0,P.splitName)(s).name,description:s};if(k.URI.isUri(l))return{title:(0,b.basename)(l),description:this.renderJumpListPathDescription(l)};if(this.workspacesManagementMainService.isUntitledWorkspace(l))return{title:(0,g.localize)(4,null),description:""};let i=(0,b.basename)(l.configPath);return i.endsWith(u.WORKSPACE_EXTENSION)&&(i=i.substr(0,i.length-u.WORKSPACE_EXTENSION.length-1)),{title:(0,g.localize)(5,null,i),description:this.renderJumpListPathDescription(l.configPath)}}renderJumpListPathDescription(l){return l.scheme==="file"?(0,P.normalizeDriveLetter)(l.fsPath):l.toString()}async updateMacOSRecentDocuments(){if(!S.isMacintosh)return;p.app.clearRecentDocuments();const l=await this.getRecentlyOpened(),s=[];let i=0;for(let a=0;a<l.workspaces.length&&i<$e.MAX_MACOS_DOCK_RECENT_WORKSPACES;a++){const h=this.location(l.workspaces[a]);if(h.scheme===w.Schemas.file){const I=(0,b.originalFSPath)(h);await y.Promises.exists(I)&&(s.push(I),i++)}}const r=[];for(let a=0;a<l.files.length&&i<$e.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;a++){const h=this.location(l.files[a]);if(h.scheme===w.Schemas.file){const I=(0,b.originalFSPath)(h);if($e.COMMON_FILES_FILTER.includes((0,b.basename)(h))||s.includes(I))continue;await y.Promises.exists(I)&&(r.push(I),i++)}}r.reverse().forEach(a=>p.app.addRecentDocument(a)),s.reverse().forEach(a=>p.app.addRecentDocument(a))}};c.MAX_TOTAL_RECENT_ENTRIES=500,c.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",c.legacyRecentlyOpenedStorageKey="openedPathsList",c.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,c.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,c.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,c.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],c=de([ne(0,v.IStateMainService),ne(1,m.ILogService),ne(2,f.IWorkspacesManagementMainService),ne(3,d.ILifecycleMainService),ne(4,C.IGlobalStorageMainService)],c),e.WorkspacesHistoryMainService=c}),define(ee[247],te([0,1,14,8,21,33,3,7,152,19,23,20,6,194,58,22,38,30,41,68,36,69]),function(j,e,p,n,D,M,P,E,w,S,b,k,y,g,t,d,m,v,C,u,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const o="menu";let l=class yt{constructor(r,a,h,I,R,L,W,N,J,oe,re){this.updateService=r,this.configurationService=a,this.windowsMainService=h,this.environmentMainService=I,this.telemetryService=R,this.workspacesHistoryMainService=L,this.stateMainService=W,this.lifecycleMainService=N,this.logService=J,this.nativeHostMainService=oe,this.productService=re,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new n.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new n.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(P.isMacintosh||(0,u.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const r=this.stateMainService.getItem(yt.lastKnownMenubarStorageKey);r&&(r.menus&&(this.menubarMenus=r.menus),r.keybindings&&(this.keybindings=r.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(L,W,N)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(L,W,N)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(L,W,N)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(N),telemetryExtraData:{from:o}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(L,W,N)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(N),telemetryExtraData:{from:o}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const r=this.productService.twitterUrl;r&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(r,"openTwitterUrl"));const a=this.productService.requestFeatureUrl;a&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(a,"openUserVoiceUrl"));const h=this.productService.reportIssueUrl;h&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(h,"openReportIssues"));const I=this.productService.licenseUrl;I&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(P.language){const L=I.indexOf("?")>0?"&":"?";this.openUrl(`${I}${L}lang=${P.language}`,"openLicenseUrl")}else this.openUrl(I,"openLicenseUrl")});const R=this.productService.privacyStatementUrl;R&&I&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(R,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(r=>this.onDidChangeWindowsCount(r)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let r=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof r!="boolean"?!0:r}get currentEnableNativeTabs(){if(!P.isMacintosh)return!1;let r=this.configurationService.getValue("window.nativeTabs");return typeof r!="boolean"?!1:r}updateMenu(r,a){this.menubarMenus=r.menus,this.keybindings=r.keybindings,this.stateMainService.setItem(yt.lastKnownMenubarStorageKey,r),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(r){!P.isMacintosh||(r.oldCount===0&&r.newCount>0||r.oldCount>0&&r.newCount===0)&&(this.closedLastWindow=r.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!P.isMacintosh||(this.noActiveWindow=!p.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const r=p.Menu.getApplicationMenu();if(r&&this.oldMenus.push(r),Object.keys(this.menubarMenus).length===0){p.Menu.setApplicationMenu(P.isMacintosh?new p.Menu:null);return}const a=new p.Menu;let h;if(P.isMacintosh){const R=new p.Menu;h=new p.MenuItem({label:this.productService.nameShort,submenu:R}),this.setMacApplicationMenu(R),a.append(h)}if(P.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const R=new p.Menu;R.append(new p.MenuItem({label:this.mnemonicLabel(w.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),p.app.dock.setMenu(R)}if(this.shouldDrawMenu("File")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(w.localize(1,null)),submenu:R});this.setMenuById(R,"File"),a.append(L)}if(this.shouldDrawMenu("Edit")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(w.localize(2,null)),submenu:R});this.setMenuById(R,"Edit"),a.append(L)}if(this.shouldDrawMenu("Selection")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(w.localize(3,null)),submenu:R});this.setMenuById(R,"Selection"),a.append(L)}if(this.shouldDrawMenu("View")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(w.localize(4,null)),submenu:R});this.setMenuById(R,"View"),a.append(L)}if(this.shouldDrawMenu("Go")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(w.localize(5,null)),submenu:R});this.setMenuById(R,"Go"),a.append(L)}if(this.shouldDrawMenu("Run")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(w.localize(6,null)),submenu:R});this.setMenuById(R,"Run"),a.append(L)}if(this.shouldDrawMenu("Terminal")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(w.localize(7,null)),submenu:R});this.setMenuById(R,"Terminal"),a.append(L)}let I;if(this.shouldDrawMenu("Window")){const R=new p.Menu;I=new p.MenuItem({label:this.mnemonicLabel(w.localize(8,null)),submenu:R,role:"window"}),this.setMacWindowMenu(R)}if(I&&a.append(I),this.shouldDrawMenu("Help")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(w.localize(9,null)),submenu:R,role:"help"});this.setMenuById(R,"Help"),a.append(L)}a.items&&a.items.length>0?p.Menu.setApplicationMenu(a):p.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(r){const a=this.createMenuItem(w.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),h=this.getUpdateMenuItems();let I;if(this.shouldDrawMenu("Preferences")){const V=new p.Menu;this.setMenuById(V,"Preferences"),I=new p.MenuItem({label:this.mnemonicLabel(w.localize(11,null)),submenu:V})}const R=new p.Menu,L=new p.MenuItem({label:w.localize(12,null),role:"services",submenu:R}),W=new p.MenuItem({label:w.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),N=new p.MenuItem({label:w.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),J=new p.MenuItem({label:w.localize(15,null),role:"unhide"}),oe=new p.MenuItem(this.likeAction("workbench.action.quit",{label:w.localize(16,null,this.productService.nameLong),click:()=>{const V=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!p.BrowserWindow.getFocusedWindow()||V?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),re=[a];re.push(...h),I&&re.push(s(),I),re.push(s(),L,s(),W,N,J,s(),oe),re.forEach(V=>r.append(V))}shouldDrawMenu(r){if(!P.isMacintosh&&(0,u.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(r){case"File":case"Help":if(P.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[r];case"Window":if(P.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[r]}}setMenu(r,a){a.forEach(h=>{if((0,g.isMenubarMenuItemSeparator)(h))r.append(s());else if((0,g.isMenubarMenuItemSubmenu)(h)){const I=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(h.label),submenu:I});this.setMenu(I,h.submenu.items),r.append(R)}else(0,g.isMenubarMenuItemRecentAction)(h)?r.append(this.createOpenRecentMenuItem(h)):(0,g.isMenubarMenuItemAction)(h)&&(h.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(r),P.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[h.id]?r.append(new p.MenuItem(this.likeAction(h.id,{label:this.mnemonicLabel(h.label),click:this.fallbackMenuHandlers[h.id]}))):r.append(this.createMenuItem(h.label,h.id,!1,h.checked)):r.append(this.createMenuItem(h.label,h.id,h.enabled!==!1,!!h.checked)):r.append(this.createMenuItem(h.label,h.id,h.enabled!==!1,!!h.checked)))})}setMenuById(r,a){this.menubarMenus&&this.menubarMenus[a]&&this.setMenu(r,this.menubarMenus[a].items)}insertCheckForUpdatesItems(r){const a=this.getUpdateMenuItems();a.length&&(a.forEach(h=>r.append(h)),r.append(s()))}createOpenRecentMenuItem(r){const a=E.URI.revive(r.uri),h=r.id,I=h==="openRecentFile"?{fileUri:a}:h==="openRecentWorkspace"?{workspaceUri:a}:{folderUri:a};return new p.MenuItem(this.likeAction(h,{label:r.label,click:(R,L,W)=>{const N=this.isOptionClick(W);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[I],forceNewWindow:N,gotoLineMode:!1,remoteAuthority:r.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([a])}},!1))}isOptionClick(r){return!!(r&&(!P.isMacintosh&&(r.ctrlKey||r.shiftKey)||P.isMacintosh&&(r.metaKey||r.altKey)))}createRoleMenuItem(r,a,h){const I={label:this.mnemonicLabel(r),role:h,enabled:!0};return new p.MenuItem(this.withKeybinding(a,I))}setMacWindowMenu(r){const a=new p.MenuItem({label:w.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),h=new p.MenuItem({label:w.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),I=new p.MenuItem({label:w.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),R=this.createMenuItem(w.localize(20,null),"workbench.action.switchWindow"),L=[];this.currentEnableNativeTabs&&(L.push(s()),L.push(this.createMenuItem(w.localize(21,null),"workbench.action.newWindowTab")),L.push(this.createRoleMenuItem(w.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.createRoleMenuItem(w.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.createRoleMenuItem(w.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.createRoleMenuItem(w.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[a,h,s(),R,...L,s(),I].forEach(W=>r.append(W))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new p.MenuItem({label:this.mnemonicLabel(w.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new p.MenuItem({label:w.localize(27,null),enabled:!1})];case"available for download":return[new p.MenuItem({label:this.mnemonicLabel(w.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new p.MenuItem({label:w.localize(29,null),enabled:!1})];case"downloaded":return[new p.MenuItem({label:this.mnemonicLabel(w.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new p.MenuItem({label:w.localize(31,null),enabled:!1})];case"ready":return[new p.MenuItem({label:this.mnemonicLabel(w.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(r,a,h,I){const R=this.mnemonicLabel(r),L=typeof a=="function"?a:(re,V,Z)=>{const H=re?re.userSettingsLabel:null;let K=a;Array.isArray(a)&&(K=this.isOptionClick(Z)?a[1]:a[0]),H&&Z.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:H}):this.runActionInRenderer({type:"commandId",commandId:K})},W=typeof h=="boolean"?h:this.windowsMainService.getWindowCount()>0,N=typeof I=="boolean"?I:!1,J={label:R,click:L,enabled:W};N&&(J.type="checkbox",J.checked=N);let oe;return typeof a=="string"?oe=a:Array.isArray(a)&&(oe=a[0]),P.isMacintosh&&(oe==="editor.action.clipboardCutAction"?J.role="cut":oe==="editor.action.clipboardCopyAction"?J.role="copy":oe==="editor.action.clipboardPasteAction"&&(J.role="paste"),oe==="undo"?J.click=this.makeContextAwareClickHandler(L,{inDevTools:re=>re.undo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("undo:")}):oe==="redo"?J.click=this.makeContextAwareClickHandler(L,{inDevTools:re=>re.redo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("redo:")}):oe==="editor.action.selectAll"&&(J.click=this.makeContextAwareClickHandler(L,{inDevTools:re=>re.selectAll(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("selectAll:")}))),new p.MenuItem(this.withKeybinding(oe,J))}makeContextAwareClickHandler(r,a){return(h,I,R)=>{const L=p.BrowserWindow.getFocusedWindow();if(!L)return a.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return a.inDevTools(L.webContents.devToolsWebContents);r(h,I||L,R)}}runActionInRenderer(r){let a=p.BrowserWindow.getFocusedWindow();if(!a){const I=this.windowsMainService.getLastActiveWindow();I?.isMinimized()&&(a=I.win)}const h=a?this.windowsMainService.getWindowById(a.id):void 0;if(h){if(this.logService.trace("menubar#runActionInRenderer",r),P.isMacintosh&&!this.environmentMainService.isBuilt&&!h.isReady&&(r.type==="commandId"&&r.commandId==="workbench.action.toggleDevTools"||r.type!=="commandId"&&r.userSettingsLabel==="alt+cmd+i"))return;if(r.type==="commandId"){const I={id:r.commandId,from:"menu"};h.sendWhenReady("vscode:runAction",D.CancellationToken.None,I)}else{const I={userSettingsLabel:r.userSettingsLabel};h.sendWhenReady("vscode:runKeybinding",D.CancellationToken.None,I)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",r)}withKeybinding(r,a){const h=typeof r=="string"?this.keybindings[r]:void 0;if(h?.label){if(h.isNative!==!1)a.accelerator=h.label,a.userSettingsLabel=h.userSettingsLabel;else if(typeof a.label=="string"){const I=a.label.indexOf("[");I>=0?a.label=`${a.label.substr(0,I)} [${h.label}]`:a.label=`${a.label} [${h.label}]`}}else a.accelerator=void 0;return a}likeAction(r,a,h=!a.accelerator){h&&(a=this.withKeybinding(r,a));const I=a.click;return a.click=(R,L,W)=>{this.reportMenuActionTelemetry(r),I&&I(R,L,W)},a}openUrl(r,a){this.nativeHostMainService.openExternal(void 0,r),this.reportMenuActionTelemetry(a)}reportMenuActionTelemetry(r){this.telemetryService.publicLog2("workbenchActionExecuted",{id:r,from:o})}mnemonicLabel(r){return(0,M.mnemonicMenuLabel)(r,!this.currentEnableMenuBarMnemonics)}};l.lastKnownMenubarStorageKey="lastKnownMenubarData",l=de([ne(0,C.IUpdateService),ne(1,S.IConfigurationService),ne(2,f.IWindowsMainService),ne(3,b.IEnvironmentMainService),ne(4,v.ITelemetryService),ne(5,c.IWorkspacesHistoryMainService),ne(6,m.IStateMainService),ne(7,k.ILifecycleMainService),ne(8,y.ILogService),ne(9,t.INativeHostMainService),ne(10,d.IProductService)],l),e.Menubar=l;function s(){return new p.MenuItem({type:"separator"})}}),define(ee[248],te([0,1,5,20,6,247]),function(j,e,p,n,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,p.createDecorator)("menubarMainService");let P=class{constructor(w,S,b){this.instantiationService=w,this.lifecycleMainService=S,this.logService=b,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(M.Menubar)}async updateMenubar(w,S){this.logService.trace("menubarService#updateMenubar",w),(await this.menubar).updateMenu(S,w)}};P=de([ne(0,p.IInstantiationService),ne(1,n.ILifecycleMainService),ne(2,D.ILogService)],P),e.MenubarMainService=P}),define(ee[249],te([0,1,14,29,26,27,21,4,28,42,33,2,10,9,64,3,34,16,13,7,158,52,19,50,23,18,5,20,6,54,22,55,65,38,68,246,101,229,31,102,69,45]),function(j,e,p,n,D,M,P,E,w,S,b,k,y,g,t,d,m,v,C,u,f,c,o,l,s,i,r,a,h,I,R,L,W,N,J,oe,re,V,Z,H,K,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function z(q){return(0,Z.isWorkspaceIdentifier)(q?.workspace)}function B(q){return(0,Z.isSingleFolderWorkspaceIdentifier)(q?.workspace)}let Y=class rt extends k.Disposable{constructor(F,$,A,T,U,O,_,Q,ie,se,x,ce,le,he,me){super();this.machineId=F,this.initialUserEnv=$,this.logService=A,this.stateMainService=T,this.environmentMainService=U,this.lifecycleMainService=O,this.backupMainService=_,this.configurationService=Q,this.workspacesHistoryMainService=ie,this.workspacesManagementMainService=se,this.instantiationService=x,this.dialogMainService=ce,this.fileService=le,this.productService=he,this.protocolMainService=me,this._onDidOpenWindow=this._register(new E.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new E.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new E.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new E.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new V.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(F=>this._onDidSignalReadyWindow.fire(F.window))),this._register(this.onDidSignalReadyWindow(F=>{if(F.config?.extensionDevelopmentPath||F.config?.extensionTestsPath){const $=new k.DisposableStore;if($.add(E.Event.any(F.onDidClose,F.onDidDestroy)(()=>$.dispose())),F.config.extensionDevelopmentPath)for(const A of F.config.extensionDevelopmentPath)$.add(this.protocolMainService.addValidFileRoot(u.URI.file(A)));F.config.extensionTestsPath&&$.add(this.protocolMainService.addValidFileRoot(u.URI.file(F.config.extensionTestsPath)))}}))}openEmptyWindow(F,$){let A=this.environmentMainService.args;const T=$?.remoteAuthority||void 0,U=!0,O=$?.forceReuseWindow,_=!O;return this.open({...F,cli:A,forceEmpty:U,forceNewWindow:_,forceReuseWindow:O,remoteAuthority:T})}openExistingWindow(F,$){F.focus(),this.handleWaitMarkerFile($,[F])}open(F){this.logService.trace("windowsManager#open"),F.addMode&&(F.initialStartup||!this.getLastActiveWindow())&&(F.addMode=!1);const $=[],A=[],T=[],U=[],O=[];let _,Q=0;const ie=this.getPathsToOpen(F);this.logService.trace("windowsManager#open pathsToOpen",ie);for(const le of ie)B(le)?F.addMode?$.push(le):A.push(le):z(le)?T.push(le):le.fileUri?(_||(_={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:le.remoteAuthority}),_.filesToOpenOrCreate.push(le)):le.backupPath?O.push({backupFolder:(0,g.basename)(le.backupPath),remoteAuthority:le.remoteAuthority}):Q++;F.diffMode&&_&&_.filesToOpenOrCreate.length>=2&&(_.filesToDiff=_.filesToOpenOrCreate.slice(0,2),_.filesToOpenOrCreate=[]),_&&F.waitMarkerFileURI&&(_.filesToWait={paths:[..._.filesToDiff,..._.filesToOpenOrCreate],waitMarkerFileUri:F.waitMarkerFileURI}),F.initialStartup?(U.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),T.push(...U),O.push(...this.backupMainService.getEmptyWindowBackupPaths())):O.length=0;const{windows:se,filesOpenedInWindow:x}=this.doOpen(F,T,A,O,Q,_,$);if(this.logService.trace(`windowsManager#open used window count ${se.length} (workspacesToOpen: ${T.length}, foldersToOpen: ${A.length}, emptyToRestore: ${O.length}, emptyToOpen: ${Q})`),se.length>1)if(x)x.focus();else{const le=this.windowsStateHandler.state.lastActiveWindow&&!F.forceEmpty&&!F.cli._.length&&!F.cli["file-uri"]&&!F.cli["folder-uri"]&&!(F.urisToOpen&&F.urisToOpen.length);let he=!0,me=!0;if(le){const pe=se.filter(ge=>this.windowsStateHandler.state.lastActiveWindow&&ge.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),he=!1,me=!1)}if(he)for(let pe=se.length-1;pe>=0;pe--){const ge=se[pe];if(!(ge.openedWorkspace&&U.some(fe=>ge.openedWorkspace&&fe.workspace.id===ge.openedWorkspace.id)||ge.backupPath&&O.some(fe=>ge.backupPath&&fe.backupFolder===(0,g.basename)(ge.backupPath)))){ge.focus(),me=!1;break}}me&&se[se.length-1].focus()}const ce=_&&_.filesToDiff.length>0;if(!se.some(le=>le.isExtensionDevelopmentHost)&&!ce&&!F.noRecentEntry){const le=[];for(const he of ie)z(he)&&!he.transient?le.push({label:he.label,workspace:he.workspace,remoteAuthority:he.remoteAuthority}):B(he)?le.push({label:he.label,folderUri:he.workspace.uri,remoteAuthority:he.remoteAuthority}):he.fileUri&&le.push({label:he.label,fileUri:he.fileUri,remoteAuthority:he.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(le)}return this.handleWaitMarkerFile(F,se),se}handleWaitMarkerFile(F,$){const A=F.waitMarkerFileURI;F.context===0&&A&&$.length===1&&$[0]&&(async()=>{await $[0].whenClosedOrLoaded;try{await this.fileService.del(A)}catch{}})()}doOpen(F,$,A,T,U,O,_){const Q=[];let ie;function se(ge,fe){Q.push(ge),fe&&(ie=ge,O=void 0)}let{openFolderInNewWindow:x,openFilesInNewWindow:ce}=this.shouldOpenNewWindow(F);if(!F.initialStartup&&_.length>0){const ge=_[0].remoteAuthority,fe=this.getLastActiveWindowForAuthority(ge);fe&&se(this.doAddFoldersToExistingWindow(fe,_.map(Ie=>Ie.workspace.uri)))}const le=A.length+$.length+T.length;if(O&&le===0){const ge=O.filesToOpenOrCreate[0]||O.filesToDiff[0],fe=this.getWindows().filter(Pe=>O&&(0,v.isEqualAuthority)(Pe.remoteAuthority,O.remoteAuthority));let Ie;ge?.fileUri&&!ce&&((F.context===4||F.context===0||F.context===1)&&(Ie=(0,re.findWindowOnFile)(fe,ge.fileUri,Pe=>Pe.configPath.scheme===y.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Pe.configPath):void 0)),Ie||(Ie=this.doGetLastActiveWindow(fe))),Ie?(0,Z.isWorkspaceIdentifier)(Ie.openedWorkspace)?$.push({workspace:Ie.openedWorkspace,remoteAuthority:Ie.remoteAuthority}):(0,Z.isSingleFolderWorkspaceIdentifier)(Ie.openedWorkspace)?A.push({workspace:Ie.openedWorkspace,remoteAuthority:Ie.remoteAuthority}):se(this.doOpenFilesInExistingWindow(F,Ie,O),!0):se(this.openInBrowserWindow({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,filesToOpen:O,forceNewWindow:!0,remoteAuthority:O.remoteAuthority,forceNewTabbedWindow:F.forceNewTabbedWindow}),!0)}const he=(0,M.distinct)($,ge=>ge.workspace.id);if(he.length>0){const ge=(0,M.coalesce)(he.map(fe=>(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe.workspace.configPath)));if(ge.length>0){const fe=ge[0],Ie=(0,v.isEqualAuthority)(O?.remoteAuthority,fe.remoteAuthority)?O:void 0;se(this.doOpenFilesInExistingWindow(F,fe,Ie),!!Ie),x=!0}he.forEach(fe=>{if(ge.some(Te=>Te.openedWorkspace&&Te.openedWorkspace.id===fe.workspace.id))return;const Ie=fe.remoteAuthority,Pe=(0,v.isEqualAuthority)(O?.remoteAuthority,Ie)?O:void 0;se(this.doOpenFolderOrWorkspace(F,fe,x,Pe),!!Pe),x=!0})}const me=(0,M.distinct)(A,ge=>v.extUriBiasedIgnorePathCase.getComparisonKey(ge.workspace.uri));if(me.length>0){const ge=(0,M.coalesce)(me.map(fe=>(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe.workspace.uri)));if(ge.length>0){const fe=ge[0],Ie=(0,v.isEqualAuthority)(O?.remoteAuthority,fe.remoteAuthority)?O:void 0;se(this.doOpenFilesInExistingWindow(F,fe,Ie),!!Ie),x=!0}me.forEach(fe=>{if(ge.some(Te=>(0,Z.isSingleFolderWorkspaceIdentifier)(Te.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(Te.openedWorkspace.uri,fe.workspace.uri)))return;const Ie=fe.remoteAuthority,Pe=(0,v.isEqualAuthority)(O?.remoteAuthority,Ie)?O:void 0;se(this.doOpenFolderOrWorkspace(F,fe,x,Pe),!!Pe),x=!0})}const pe=(0,M.distinct)(T,ge=>ge.backupFolder);if(pe.length>0&&pe.forEach(ge=>{const fe=ge.remoteAuthority,Ie=(0,v.isEqualAuthority)(O?.remoteAuthority,fe)?O:void 0;se(this.doOpenEmpty(F,!0,fe,Ie,ge),!!Ie),x=!0}),Q.length===0||O){O&&!U&&U++;const ge=O?O.remoteAuthority:F.remoteAuthority;for(let fe=0;fe<U;fe++)se(this.doOpenEmpty(F,x,ge,O),!!O),x=!0}return{windows:(0,M.distinct)(Q),filesOpenedInWindow:ie}}doOpenFilesInExistingWindow(F,$,A){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:A}),$.focus();const T={filesToOpenOrCreate:A?.filesToOpenOrCreate,filesToDiff:A?.filesToDiff,filesToWait:A?.filesToWait,termProgram:F?.userEnv?.TERM_PROGRAM};return $.sendWhenReady("vscode:openFiles",P.CancellationToken.None,T),$}doAddFoldersToExistingWindow(F,$){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:$}),F.focus();const A={foldersToAdd:$};return F.sendWhenReady("vscode:addFolders",P.CancellationToken.None,A),F}doOpenEmpty(F,$,A,T,U){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!U,remoteAuthority:A,filesToOpen:T,forceNewWindow:$});let O;return!$&&typeof F.contextWindowId=="number"&&(O=this.getWindowById(F.contextWindowId)),this.openInBrowserWindow({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:A,forceNewWindow:$,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:T,windowToUse:O,emptyWindowBackupInfo:U})}doOpenFolderOrWorkspace(F,$,A,T,U){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:$,filesToOpen:T}),!A&&!U&&typeof F.contextWindowId=="number"&&(U=this.getWindowById(F.contextWindowId)),this.openInBrowserWindow({workspace:$.workspace,userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:$.remoteAuthority,forceNewWindow:A,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:T,windowToUse:U})}getPathsToOpen(F){let $,A=!1,T=!1;if(F.urisToOpen&&F.urisToOpen.length>0?($=this.doExtractPathsFromAPI(F),A=!0):F.forceEmpty?$=[Object.create(null)]:F.cli._.length||F.cli["folder-uri"]||F.cli["file-uri"]?($=this.doExtractPathsFromCLI(F.cli),$.length===0&&$.push(Object.create(null)),A=!0):($=this.doGetPathsFromLastSession(),$.length===0&&$.push(Object.create(null)),T=!0),!F.addMode&&A){const U=$.filter(O=>B(O));if(U.length>1){const O=U[0].remoteAuthority;if(U.every(_=>(0,v.isEqualAuthority)(_.remoteAuthority,O))){const _=this.workspacesManagementMainService.createUntitledWorkspaceSync(U.map(Q=>({uri:Q.workspace.uri})));$.push({workspace:_,remoteAuthority:O}),$=$.filter(Q=>!B(Q))}}}return F.initialStartup&&!T&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&$.unshift(...this.doGetPathsFromLastSession().filter(U=>z(U)||B(U)||U.backupPath)),$}doExtractPathsFromAPI(F){const $=[],A={gotoLineMode:F.gotoLineMode,remoteAuthority:F.remoteAuthority};for(const T of(0,M.coalesce)(F.urisToOpen||[])){const U=this.resolveOpenable(T,A);if(U)U.label=T.label,$.push(U);else{const O=this.resourceFromOpenable(T),_={title:this.productService.nameLong,type:"info",buttons:[(0,b.mnemonicButtonLabel)((0,f.localize)(0,null))],defaultId:0,message:O.scheme===y.Schemas.file?(0,f.localize)(1,null):(0,f.localize)(2,null),detail:O.scheme===y.Schemas.file?(0,f.localize)(3,null,(0,b.getPathLabel)(O.fsPath,this.environmentMainService)):(0,f.localize)(4,null,O.toString()),noLink:!0};this.dialogMainService.showMessageBox(_,(0,C.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))}}return $}doExtractPathsFromCLI(F){const $=[],A={ignoreFileNotFound:!0,gotoLineMode:F.goto,remoteAuthority:F.remote||void 0,forceOpenWorkspaceAsFile:!1},T=F["folder-uri"];if(T)for(const _ of T){const Q=this.cliArgToUri(_);if(Q){const ie=this.resolveOpenable({folderUri:Q},A);ie&&$.push(ie)}}const U=F["file-uri"];if(U)for(const _ of U){const Q=this.cliArgToUri(_);if(Q){const ie=this.resolveOpenable((0,Z.hasWorkspaceFileExtension)(_)?{workspaceUri:Q}:{fileUri:Q},A);ie&&$.push(ie)}}const O=F._;for(const _ of O){const Q=A.remoteAuthority?this.doResolvePathRemote(_,A):this.doResolveFilePath(_,A);Q&&$.push(Q)}return $}cliArgToUri(F){try{const $=u.URI.parse(F);if(!$.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${F}`);return}return $}catch($){this.logService.error(`Invalid URI input string: ${F}, ${$.message}`)}}doGetPathsFromLastSession(){const F=this.getRestoreWindowsSetting();switch(F){case"none":return[];case"one":case"all":case"preserve":case"folders":{const $=[];F!=="one"&&$.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&$.push(this.windowsStateHandler.state.lastActiveWindow);const A=[];for(const T of $)if(T.workspace){const U=this.resolveOpenable({workspaceUri:T.workspace.configPath},{remoteAuthority:T.remoteAuthority,rejectTransientWorkspaces:!0});z(U)&&A.push(U)}else if(T.folderUri){const U=this.resolveOpenable({folderUri:T.folderUri},{remoteAuthority:T.remoteAuthority});B(U)&&A.push(U)}else F!=="folders"&&T.backupPath&&A.push({backupPath:T.backupPath,remoteAuthority:T.remoteAuthority});return A}}}getRestoreWindowsSetting(){let F;return this.lifecycleMainService.wasRestarted?F="all":(F=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(F)||(F="all")),F}resolveOpenable(F,$=Object.create(null)){let A=this.resourceFromOpenable(F);return A.scheme===y.Schemas.file?((0,J.isFileToOpen)(F)&&($={...$,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(A.fsPath,$)):this.doResolveRemoteOpenable(F,$)}doResolveRemoteOpenable(F,$){let A=this.resourceFromOpenable(F);const T=(0,W.getRemoteAuthority)(A)||$.remoteAuthority;if(A=(0,v.removeTrailingPathSeparator)((0,v.normalizePath)(A)),(0,J.isFileToOpen)(F)){if($.gotoLineMode){const{path:U,line:O,column:_}=(0,w.parseLineAndColumnAware)(A.path);return{fileUri:A.with({path:U}),selection:O?{startLineNumber:O,startColumn:_||1}:void 0,remoteAuthority:T}}return{fileUri:A,remoteAuthority:T}}else if((0,J.isWorkspaceToOpen)(F))return{workspace:(0,H.getWorkspaceIdentifier)(A),remoteAuthority:T};return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(A),remoteAuthority:T}}resourceFromOpenable(F){return(0,J.isWorkspaceToOpen)(F)?F.workspaceUri:(0,J.isFolderToOpen)(F)?F.folderUri:F.fileUri}doResolveFilePath(F,$){let A,T;$.gotoLineMode&&({path:F,line:A,column:T}=(0,w.parseLineAndColumnAware)(F)),F=(0,w.sanitizeFilePath)((0,g.normalize)(F),(0,m.cwd)());try{const U=(0,n.statSync)(F);if(U.isFile()){if(!$.forceOpenWorkspaceAsFile){const O=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.URI.file(F));if(O)return O.transient&&$.rejectTransientWorkspaces?void 0:{workspace:{id:O.id,configPath:O.configPath},type:i.FileType.File,exists:!0,remoteAuthority:O.remoteAuthority,transient:O.transient}}return{fileUri:u.URI.file(F),type:i.FileType.File,exists:!0,selection:A?{startLineNumber:A,startColumn:T||1}:void 0}}else{if(U.isDirectory())return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(u.URI.file(F),U),type:i.FileType.Directory,exists:!0};if(!d.isWindows&&F==="/dev/null")return{fileUri:u.URI.file(F),type:i.FileType.File,exists:!0}}}catch{const O=u.URI.file(F);if(this.workspacesHistoryMainService.removeRecentlyOpened([O]),$.ignoreFileNotFound)return{fileUri:O,type:i.FileType.File,exists:!1}}}doResolvePathRemote(F,$){const A=F.charCodeAt(0),T=$.remoteAuthority;let U,O;$.gotoLineMode&&({path:F,line:U,column:O}=(0,w.parseLineAndColumnAware)(F)),A!==47&&((0,w.isWindowsDriveLetter)(A)&&F.charCodeAt(F.charCodeAt(1))===58&&(F=(0,w.toSlashes)(F)),F=`/${F}`);const _=u.URI.from({scheme:y.Schemas.vscodeRemote,authority:T,path:F});if(F.charCodeAt(F.length-1)!==47){if((0,Z.hasWorkspaceFileExtension)(F))return $.forceOpenWorkspaceAsFile?{fileUri:_,selection:U?{startLineNumber:U,startColumn:O||1}:void 0,remoteAuthority:$.remoteAuthority}:{workspace:(0,H.getWorkspaceIdentifier)(_),remoteAuthority:T};if($.gotoLineMode||g.posix.basename(F).indexOf(".")!==-1)return{fileUri:_,selection:U?{startLineNumber:U,startColumn:O||1}:void 0,remoteAuthority:T}}return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(_),remoteAuthority:T}}shouldOpenNewWindow(F){const $=this.configurationService.getValue("window"),A=$?.openFoldersInNewWindow||"default",T=$?.openFilesInNewWindow||"off";let U=(F.preferNewWindow||F.forceNewWindow)&&!F.forceReuseWindow;!F.forceNewWindow&&!F.forceReuseWindow&&(A==="on"||A==="off")&&(U=A==="on");let O=!1;return F.forceNewWindow||F.forceReuseWindow?O=!!F.forceNewWindow&&!F.forceReuseWindow:(d.isMacintosh?F.context===1&&(O=!0):F.context!==3&&F.context!==2&&!(F.userEnv&&F.userEnv.TERM_PROGRAM==="vscode")&&(O=!0),!F.cli.extensionDevelopmentPath&&(T==="on"||T==="off")&&(O=T==="on")),{openFolderInNewWindow:!!U,openFilesInNewWindow:O}}openExtensionDevelopmentHostWindow(F,$){const A=(0,re.findWindowOnExtensionDevelopmentPath)(this.getWindows(),F);if(A)return this.lifecycleMainService.reload(A,$.cli),A.focus(),[A];let T=$.cli["folder-uri"]||[],U=$.cli["file-uri"]||[],O=$.cli._;if(!O.length&&!T.length&&!U.length&&!$.cli.extensionTestsPath){const se=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,x=se&&(se.workspace||se.folderUri);x&&(u.URI.isUri(x)?x.scheme===y.Schemas.file?O=[x.fsPath]:T=[x.toString()]:x.configPath.scheme===y.Schemas.file?O=[(0,v.originalFSPath)(x.configPath)]:U=[x.configPath.toString()])}let _=$.remoteAuthority;for(const se of F)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const x=u.URI.parse(se),ce=(0,W.getRemoteAuthority)(x);ce&&(_?(0,v.isEqualAuthority)(ce,_)||this.logService.error("more than one extension development path authority"):_=ce)}O=O.filter(se=>{const x=u.URI.file(se);return(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),x)?!1:(0,v.isEqualAuthority)((0,W.getRemoteAuthority)(x),_)}),T=T.filter(se=>{const x=this.cliArgToUri(se);return x&&!!(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),x)?!1:x?(0,v.isEqualAuthority)((0,W.getRemoteAuthority)(x),_):!1}),U=U.filter(se=>{const x=this.cliArgToUri(se);return x&&!!(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),x)?!1:x?(0,v.isEqualAuthority)((0,W.getRemoteAuthority)(x),_):!1}),$.cli._=O,$.cli["folder-uri"]=T,$.cli["file-uri"]=U;const Q=!O.length&&!T.length&&!U.length,ie={context:$.context,cli:$.cli,forceNewWindow:!0,forceEmpty:Q,userEnv:$.userEnv,noRecentEntry:!0,waitMarkerFileURI:$.waitMarkerFileURI,remoteAuthority:_};return this.open(ie)}openInBrowserWindow(F){const $=this.configurationService.getValue("window"),A={...this.environmentMainService.args,...F.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:F.emptyWindowBackupInfo?(0,g.join)(this.environmentMainService.backupHome,F.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:F.remoteAuthority,workspace:F.workspace,userEnv:{...this.initialUserEnv,...F.userEnv},filesToOpenOrCreate:F.filesToOpen?.filesToOpenOrCreate,filesToDiff:F.filesToOpen?.filesToDiff,filesToWait:F.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:I.default,isInitialStartup:F.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)()},zoomLevel:typeof $?.zoomLevel=="number"?$.zoomLevel:void 0,autoDetectHighContrast:$?.autoDetectHighContrast??!0,accessibilitySupport:p.app.accessibilitySupportEnabled,colorScheme:{dark:p.nativeTheme.shouldUseDarkColors,highContrast:p.nativeTheme.shouldUseInvertedColorScheme||p.nativeTheme.shouldUseHighContrastColors}};let T;if(!F.forceNewWindow&&!F.forceNewTabbedWindow&&(T=F.windowToUse||this.getLastActiveWindow(),T&&T.focus()),T){const U=T.config;!A.extensionDevelopmentPath&&U&&!!U.extensionDevelopmentPath&&(A.extensionDevelopmentPath=U.extensionDevelopmentPath,A.verbose=U.verbose,A["inspect-brk-extensions"]=U["inspect-brk-extensions"],A.debugId=U.debugId,A.extensionEnvironment=U.extensionEnvironment,A["inspect-extensions"]=U["inspect-extensions"],A["extensions-dir"]=U["extensions-dir"])}else{const U=this.windowsStateHandler.getNewWindowState(A);(0,t.mark)("code/willCreateCodeWindow");const O=T=this.instantiationService.createInstance(oe.CodeWindow,{state:U,extensionDevelopmentPath:A.extensionDevelopmentPath,isExtensionTestHost:!!A.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),F.forceNewTabbedWindow){const Q=this.getLastActiveWindow();Q&&Q.addTabbedWindow(O)}rt.WINDOWS.push(O),this._onDidOpenWindow.fire(O),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,S.once)(O.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(O)),(0,S.once)(O.onDidClose)(()=>this.onWindowClosed(O)),(0,S.once)(O.onDidDestroy)(()=>this._onDidDestroyWindow.fire(O));const _=(0,C.assertIsDefined)(O.win?.webContents);_.removeAllListeners("devtools-reload-page"),_.on("devtools-reload-page",()=>this.lifecycleMainService.reload(O)),this.lifecycleMainService.registerWindow(O)}return A.windowId=T.id,T.isReady?this.lifecycleMainService.unload(T,4).then(U=>{U||this.doOpenInBrowserWindow(T,A,F)}):this.doOpenInBrowserWindow(T,A,F),T}doOpenInBrowserWindow(F,$,A){if(!$.extensionDevelopmentPath)if((0,Z.isWorkspaceIdentifier)($.workspace))$.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:$.workspace,remoteAuthority:$.remoteAuthority});else if((0,Z.isSingleFolderWorkspaceIdentifier)($.workspace))$.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:$.workspace.uri,remoteAuthority:$.remoteAuthority});else{const T=A.emptyWindowBackupInfo&&A.emptyWindowBackupInfo.backupFolder;$.backupPath=this.backupMainService.registerEmptyWindowBackupSync(T,$.remoteAuthority)}F.load($)}onWindowClosed(F){const $=rt.WINDOWS.indexOf(F);rt.WINDOWS.splice($,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const F=p.BrowserWindow.getFocusedWindow();if(F)return this.getWindowById(F.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(F){return this.doGetLastActiveWindow(this.getWindows().filter($=>(0,v.isEqualAuthority)($.remoteAuthority,F)))}doGetLastActiveWindow(F){const $=Math.max.apply(Math,F.map(A=>A.lastFocusTime));return F.find(A=>A.lastFocusTime===$)}sendToFocused(F,...$){const A=this.getFocusedWindow()||this.getLastActiveWindow();A&&A.sendWhenReady(F,P.CancellationToken.None,...$)}sendToAll(F,$,A){for(const T of this.getWindows())A&&A.indexOf(T.id)>=0||T.sendWhenReady(F,P.CancellationToken.None,$)}getWindows(){return rt.WINDOWS}getWindowCount(){return rt.WINDOWS.length}getWindowById(F){const $=this.getWindows().filter(A=>A.id===F);return(0,M.firstOrDefault)($)}getWindowByWebContents(F){const $=p.BrowserWindow.fromWebContents(F);if(!!$)return this.getWindowById($.id)}};Y.WINDOWS=[],Y=de([ne(2,h.ILogService),ne(3,N.IStateMainService),ne(4,s.IEnvironmentMainService),ne(5,a.ILifecycleMainService),ne(6,c.IBackupMainService),ne(7,o.IConfigurationService),ne(8,K.IWorkspacesHistoryMainService),ne(9,G.IWorkspacesManagementMainService),ne(10,r.IInstantiationService),ne(11,l.IDialogMainService),ne(12,i.IFileService),ne(13,R.IProductService),ne(14,L.IProtocolMainService)],Y),e.WindowsMainService=Y}),define(ee[250],te([0,1,52,36,69,45]),function(j,e,p,n,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let P=class{constructor(w,S,b,k){this.workspacesManagementMainService=w,this.windowsMainService=S,this.workspacesHistoryMainService=b,this.backupMainService=k,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(w,S){const b=this.windowsMainService.getWindowById(w);if(b)return this.workspacesManagementMainService.enterWorkspace(b,this.windowsMainService.getWindows(),S)}createUntitledWorkspace(w,S,b){return this.workspacesManagementMainService.createUntitledWorkspace(S,b)}deleteUntitledWorkspace(w,S){return this.workspacesManagementMainService.deleteUntitledWorkspace(S)}getWorkspaceIdentifier(w,S){return this.workspacesManagementMainService.getWorkspaceIdentifier(S)}getRecentlyOpened(w){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(w))}addRecentlyOpened(w,S){return this.workspacesHistoryMainService.addRecentlyOpened(S)}removeRecentlyOpened(w,S){return this.workspacesHistoryMainService.removeRecentlyOpened(S)}clearRecentlyOpened(w){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};P=de([ne(0,M.IWorkspacesManagementMainService),ne(1,n.IWindowsMainService),ne(2,D.IWorkspacesHistoryMainService),ne(3,p.IBackupMainService)],P),e.WorkspacesMainService=P}),define(ee[251],te([0,1,14,29,26,17,39,15,28,42,43,33,2,10,9,3,13,7,32,73,124,37,127,88,223,137,52,233,19,95,166,75,50,234,91,23,53,93,174,195,175,230,92,176,177,18,190,77,62,5,76,243,208,103,20,6,192,248,58,22,65,239,78,38,227,80,209,30,211,213,66,41,217,241,244,242,245,100,218,219,220,221,224,36,249,225,31,69,250,45]),function(j,e,p,n,D,M,P,E,w,S,b,k,y,g,t,d,m,v,C,u,f,c,o,l,s,i,r,a,h,I,R,L,W,N,J,oe,re,V,Z,H,K,G,z,B,Y,q,F,$,A,T,U,O,_,Q,ie,se,x,ce,le,he,me,pe,ge,fe,Ie,Pe,Te,_e,qe,Ve,xe,Je,mt,lt,st,He,Ge,X,ae,ue,ve,Ee,Le,Fe,Ye,je,Ae,ze,Ke,et){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let tt=class extends y.Disposable{constructor(we,ye,be,Se,Me,Re,De,ke,Ce,We){super();this.mainProcessNodeIpcServer=we,this.userEnv=ye,this.mainInstantiationService=be,this.logService=Se,this.environmentMainService=Me,this.lifecycleMainService=Re,this.configurationService=De,this.stateMainService=ke,this.fileService=Ce,this.productService=We,this.configureSession(),this.registerListeners()}configureSession(){const we=ke=>ke?.startsWith(`${g.Schemas.vscodeWebview}://`),ye=new Set(["clipboard-read","clipboard-sanitized-write"]);p.session.defaultSession.setPermissionRequestHandler((ke,Ce,We,Ne)=>we(Ne.requestingUrl)?We(ye.has(Ce)):We(!1)),p.session.defaultSession.setPermissionCheckHandler((ke,Ce,We,Ne)=>we(Ne.requestingUrl)?ye.has(Ce):!1);const be=new Set([g.Schemas.file,g.Schemas.vscodeFileResource,g.Schemas.vscodeRemoteResource,"devtools"]),Se=ke=>{for(let Ce=ke;Ce;Ce=Ce.parent)if(Ce.url.startsWith(`${g.Schemas.vscodeWebview}://`))return!0;return!1},Me=ke=>ke.resourceType==="xhr"||Se(ke.frame),Re=ke=>{const Ce=ke.frame;if(!Ce||!this.windowsMainService)return!1;const We=p.BrowserWindow.getAllWindows();for(const Ne of We)if(Ce.processId===Ne.webContents.mainFrame.processId)return!0;return!1};p.session.defaultSession.webRequest.onBeforeRequest((ke,Ce)=>{const We=v.URI.parse(ke.url);return We.scheme===g.Schemas.vscodeFileResource&&!Re(ke)?(this.logService.error("Blocked vscode-file request",ke.url),Ce({cancel:!0})):We.path.endsWith(".svg")&&!be.has(We.scheme)?Ce({cancel:!Me(ke)}):Ce({cancel:!1})}),p.session.defaultSession.webRequest.onHeadersReceived((ke,Ce)=>{const We=ke.responseHeaders,Ne=We["content-type"]||We["Content-Type"];if(Ne&&Array.isArray(Ne)){const Xe=v.URI.parse(ke.url);if(Xe.path.endsWith(".svg")&&be.has(Xe.scheme))return We["Content-Type"]=["image/svg+xml"],Ce({cancel:!1,responseHeaders:We});if(!Xe.path.includes(g.Schemas.vscodeRemoteResource)&&Ne.some(Ze=>Ze.toLowerCase().includes("image/svg")))return Ce({cancel:!Me(ke)})}return Ce({cancel:!1})});const De=p.session.defaultSession;typeof De.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&De.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,E.setUnexpectedErrorHandler)(be=>this.onUnexpectedError(be)),process.on("uncaughtException",be=>(0,E.onUnexpectedError)(be)),process.on("unhandledRejection",be=>(0,E.onUnexpectedError)(be)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,f.registerContextMenuListener)(),p.app.on("accessibility-support-changed",(be,Se)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Se)}),p.app.on("activate",(be,Se)=>{this.logService.trace("app#activate"),Se||this.windowsMainService?.openEmptyWindow({context:1})}),p.app.on("web-contents-created",(be,Se)=>{Se.on("will-navigate",Me=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Me.preventDefault()}),Se.setWindowOpenHandler(({url:Me})=>(this.nativeHostMainService?.openExternal(void 0,Me),{action:"deny"}))});let we=[],ye;p.app.on("open-file",(be,Se)=>{this.logService.trace("app#open-file: ",Se),be.preventDefault(),we.push(this.getWindowOpenableFromPathSync(Se)),ye!==void 0&&(clearTimeout(ye),ye=void 0),ye=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:we,gotoLineMode:!1,preferNewWindow:!0}),we=[],ye=void 0},100)}),p.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),p.ipcMain.handle("vscode:fetchShellEnv",be=>{const Se=this.windowsMainService?.getWindowByWebContents(be.sender);let Me,Re;return Se?.config?(Me=Se.config,Re={...process.env,...Se.config.userEnv}):(Me=this.environmentMainService.args,Re=process.env),this.resolveShellEnvironment(Me,Re,!1)}),p.ipcMain.handle("vscode:writeNlsFile",(be,Se,Me)=>{const Re=this.validateNlsPath([Se]);if(!Re||typeof Me!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Re,M.VSBuffer.fromString(Me))}),p.ipcMain.handle("vscode:readNlsFile",async(be,...Se)=>{const Me=this.validateNlsPath(Se);if(!Me)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Me)).value.toString()}),p.ipcMain.on("vscode:toggleDevTools",be=>be.sender.toggleDevTools()),p.ipcMain.on("vscode:openDevTools",be=>be.sender.openDevTools()),p.ipcMain.on("vscode:reloadWindow",be=>be.sender.reload())}validateNlsPath(we){let ye;for(const be of we)typeof be=="string"&&(typeof ye!="string"?ye=be:ye=(0,t.join)(ye,be));if(!(typeof ye!="string"||!(0,t.isAbsolute)(ye)||!(0,w.isEqualOrParent)(ye,this.environmentMainService.cachedLanguagesPath,!d.isLinux)))return v.URI.file(ye)}onUnexpectedError(we){if(we){const ye={message:`[uncaught exception in main]: ${we.message}`,stack:we.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ye))}this.logService.error(`[uncaught exception in main]: ${we}`),we.stack&&this.logService.error(we.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const we=this.productService.win32AppUserModelId;d.isWindows&&we&&p.app.setAppUserModelId(we);try{d.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!p.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&p.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ce){this.logService.error(Ce)}const ye=new o.Server;this.logService.trace("Resolving machine identifier...");const be=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${be}`);const{sharedProcess:Se,sharedProcessReady:Me,sharedProcessClient:Re}=this.setupSharedProcess(be),De=await this.initServices(be,Se,Me);if(this.environmentMainService.driverHandle){const Ce=await(0,N.serve)(ye,this.environmentMainService.driverHandle,this.environmentMainService,De);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Ce)}this._register(De.createInstance(s.ProxyAuthHandler)),De.invokeFunction(Ce=>this.initChannels(Ce,ye,Re));const ke=De.invokeFunction(Ce=>this.openFirstWindow(Ce,ye));De.invokeFunction(Ce=>this.afterWindowOpen(Ce,Se)),this.environmentMainService.args.trace&&De.invokeFunction(Ce=>this.stopTracingEventually(Ce,ke))}async resolveMachineId(){let we=this.stateMainService.getItem(_e.machineIdKey);return(!we||d.isMacintosh&&we==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(we=await(0,u.getMachineId)(),this.stateMainService.setItem(_e.machineIdKey,we)),we}setupSharedProcess(we){const ye=this._register(this.mainInstantiationService.createInstance(pe.SharedProcess,we,this.userEnv)),be=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Me=await ye.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new l.Client(Me,"main")})(),Se=(async()=>(await ye.whenReady(),be))();return{sharedProcess:ye,sharedProcessReady:Se,sharedProcessClient:be}}async initServices(we,ye,be){const Se=new U.ServiceCollection;switch(process.platform){case"win32":Se.set(Je.IUpdateService,new A.SyncDescriptor(Ge.Win32UpdateService));break;case"linux":d.isLinuxSnap?Se.set(Je.IUpdateService,new A.SyncDescriptor(He.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Se.set(Je.IUpdateService,new A.SyncDescriptor(st.LinuxUpdateService));break;case"darwin":Se.set(Je.IUpdateService,new A.SyncDescriptor(lt.DarwinUpdateService));break}Se.set(Fe.IWindowsMainService,new A.SyncDescriptor(Ye.WindowsMainService,[we,this.userEnv])),Se.set(W.IDialogMainService,new A.SyncDescriptor(W.DialogMainService)),Se.set(Q.ILaunchMainService,new A.SyncDescriptor(Q.LaunchMainService)),Se.set(L.IDiagnosticsService,c.ProxyChannel.toService((0,c.getDelayedChannel)(be.then(Re=>Re.getChannel("diagnostics"))))),Se.set(O.IIssueMainService,new A.SyncDescriptor(O.IssueMainService,[this.userEnv])),Se.set(J.IEncryptionMainService,new A.SyncDescriptor(J.EncryptionMainService,[we])),Se.set(_.IKeyboardLayoutMainService,new A.SyncDescriptor(_.KeyboardLayoutMainService)),Se.set(le.INativeHostMainService,new A.SyncDescriptor(le.NativeHostMainService,[ye])),Se.set(I.ICredentialsMainService,new A.SyncDescriptor(I.CredentialsMainService)),Se.set(Ee.IWebviewManagerService,new A.SyncDescriptor(Le.WebviewMainService)),Se.set(Ae.IWorkspacesService,new A.SyncDescriptor(Ke.WorkspacesMainService)),Se.set(et.IWorkspacesManagementMainService,new A.SyncDescriptor(et.WorkspacesManagementMainService)),Se.set(ze.IWorkspacesHistoryMainService,new A.SyncDescriptor(ze.WorkspacesHistoryMainService)),Se.set(ce.IMenubarMainService,new A.SyncDescriptor(ce.MenubarMainService)),Se.set(Z.IExtensionUrlTrustService,new A.SyncDescriptor(H.ExtensionUrlTrustService)),Se.set(K.IExtensionHostStarter,new A.SyncDescriptor(G.WorkerMainProcessExtensionHostStarter)),Se.set(Pe.IStorageMainService,new A.SyncDescriptor(Pe.StorageMainService)),Se.set(Pe.IGlobalStorageMainService,new A.SyncDescriptor(Pe.GlobalStorageMainService)),d.isWindows?Se.set(z.IExternalTerminalMainService,new A.SyncDescriptor(B.WindowsExternalTerminalService)):d.isMacintosh?Se.set(z.IExternalTerminalMainService,new A.SyncDescriptor(B.MacExternalTerminalService)):d.isLinux&&Se.set(z.IExternalTerminalMainService,new A.SyncDescriptor(B.LinuxExternalTerminalService));const Me=new a.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(Se.set(r.IBackupMainService,Me),Se.set(X.IURLService,new A.SyncDescriptor(ue.NativeURLService)),(0,xe.supportsTelemetry)(this.productService,this.environmentMainService)){const Re=(0,c.getDelayedChannel)(be.then(Ne=>Ne.getChannel("telemetryAppender"))),De=new qe.TelemetryAppenderClient(Re),ke=(0,Te.resolveCommonProperties)(this.fileService,(0,D.release)(),(0,D.hostname)(),process.arch,this.productService.commit,this.productService.version,we,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Ce=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],We={appenders:[De],commonProperties:ke,piiPaths:Ce,sendErrorTelemetry:!0};Se.set(_e.ITelemetryService,new A.SyncDescriptor(Ve.TelemetryService,[We]))}else Se.set(_e.ITelemetryService,xe.NullTelemetryService);return await Me.initialize(),this.mainInstantiationService.createChild(Se)}initChannels(we,ye,be){const Se=c.ProxyChannel.fromService(we.get(Q.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Se);const Me=this.fileService.getProvider(g.Schemas.file);(0,m.assertType)(Me instanceof $.DiskFileSystemProvider);const Re=new F.DiskFileSystemProviderChannel(Me,this.logService,this.environmentMainService);ye.registerChannel(Y.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Re),be.then(Be=>Be.registerChannel(Y.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Re));const De=new mt.UpdateChannel(we.get(Je.IUpdateService));ye.registerChannel("update",De);const ke=c.ProxyChannel.fromService(we.get(O.IIssueMainService));ye.registerChannel("issue",ke);const Ce=c.ProxyChannel.fromService(we.get(J.IEncryptionMainService));ye.registerChannel("encryption",Ce);const We=c.ProxyChannel.fromService(we.get(I.ICredentialsMainService));ye.registerChannel("credentials",We);const Ne=c.ProxyChannel.fromService(we.get(ge.ISignService));ye.registerChannel("sign",Ne);const Xe=c.ProxyChannel.fromService(we.get(_.IKeyboardLayoutMainService));ye.registerChannel("keyboardLayout",Xe),this.nativeHostMainService=we.get(le.INativeHostMainService);const Ze=c.ProxyChannel.fromService(this.nativeHostMainService);ye.registerChannel("nativeHost",Ze),be.then(Be=>Be.registerChannel("nativeHost",Ze));const wt=c.ProxyChannel.fromService(we.get(Ae.IWorkspacesService));ye.registerChannel("workspaces",wt);const Ue=c.ProxyChannel.fromService(we.get(ce.IMenubarMainService));ye.registerChannel("menubar",Ue);const ut=c.ProxyChannel.fromService(we.get(X.IURLService));ye.registerChannel("url",ut);const ot=c.ProxyChannel.fromService(we.get(Z.IExtensionUrlTrustService));ye.registerChannel("extensionUrlTrust",ot);const at=c.ProxyChannel.fromService(we.get(Ee.IWebviewManagerService));ye.registerChannel("webview",at);const ct=this._register(new Ie.StorageDatabaseChannel(this.logService,we.get(Pe.IStorageMainService)));ye.registerChannel("storage",ct),be.then(Be=>Be.registerChannel("storage",ct));const ht=c.ProxyChannel.fromService(we.get(z.IExternalTerminalMainService));ye.registerChannel("externalTerminal",ht);const it=new x.LogLevelChannel(we.get(se.ILogService));ye.registerChannel("logLevel",it),be.then(Be=>Be.registerChannel("logLevel",it));const nt=new x.LoggerChannel(we.get(se.ILoggerService));ye.registerChannel("logger",nt),be.then(Be=>Be.registerChannel("logger",nt));const dt=new R.ElectronExtensionHostDebugBroadcastChannel(we.get(Fe.IWindowsMainService));ye.registerChannel("extensionhostdebugservice",dt);const Oe=c.ProxyChannel.fromService(we.get(K.IExtensionHostStarter));ye.registerChannel(K.ipcExtensionHostStarterChannelName,Oe)}openFirstWindow(we,ye){const be=this.windowsMainService=we.get(Fe.IWindowsMainService),Se=we.get(X.IURLService),Me=we.get(le.INativeHostMainService);this.lifecycleMainService.phase=2;const Re=[],De=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Oe=>{try{return{uri:v.URI.parse(Oe),url:Oe}}catch{return}}).filter(Oe=>{if(!Oe||this.shouldBlockURI(Oe.uri))return!1;const Be=this.getWindowOpenableFromProtocolLink(Oe.uri);return Be?(Re.push(Be),!1):!0}),ke=this,Ce=this.environmentMainService,We=this.productService;Se.registerHandler({async handleURL(Oe,Be){if(Oe.scheme===We.urlProtocol&&Oe.path==="workspace"&&(Oe=Oe.with({authority:"file",path:v.URI.parse(Oe.query).path,query:""})),ke.shouldBlockURI(Oe))return!0;const bt=ke.getWindowOpenableFromProtocolLink(Oe);if(bt){const[pt]=be.open({context:5,cli:{...Ce.args},urisToOpen:[bt],gotoLineMode:!0});return pt.focus(),!0}if(d.isMacintosh&&be.getWindowCount()===0){const[pt]=be.open({context:5,cli:{...Ce.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,me.getRemoteAuthority)(Oe)});return await pt.ready(),Se.open(Oe,Be)}return!1}});const Ne=this._register(new je.ActiveWindowManager({onDidOpenWindow:Me.onDidOpenWindow,onDidFocusWindow:Me.onDidFocusWindow,getActiveWindowId:()=>Me.getActiveWindowId(-1)})),Xe=new c.StaticRouter(Oe=>Ne.getActiveClientId().then(Be=>Oe===Be)),Ze=new ae.URLHandlerRouter(Xe),wt=ye.getChannel("urlHandler",Ze);Se.registerHandler(new ae.URLHandlerChannelClient(wt)),this._register(new ve.ElectronURLListener(De,Se,be,this.environmentMainService,this.productService));const Ue=this.environmentMainService.args,ut=global.macOpenFiles,ot=(0,re.isLaunchedFromCli)(process.env)?0:4,at=Ue._.length,ct=!!Ue["folder-uri"],ht=!!Ue["file-uri"],it=Ue["skip-add-to-recently-opened"]===!0,nt=Ue.wait&&Ue.waitMarkerFilePath?v.URI.file(Ue.waitMarkerFilePath):void 0,dt=Ue.remote||void 0;return Re.length>0?be.open({context:ot,cli:Ue,urisToOpen:Re,gotoLineMode:!0,initialStartup:!0}):Ue["new-window"]&&!at&&!ct&&!ht?be.open({context:ot,cli:Ue,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:it,waitMarkerFileURI:nt,initialStartup:!0,remoteAuthority:dt}):ut.length&&!at&&!ct&&!ht?be.open({context:1,cli:Ue,urisToOpen:ut.map(Oe=>this.getWindowOpenableFromPathSync(Oe)),noRecentEntry:it,waitMarkerFileURI:nt,initialStartup:!0}):be.open({context:ot,cli:Ue,forceNewWindow:Ue["new-window"]||!at&&Ue["unity-launch"],diffMode:Ue.diff,noRecentEntry:it,waitMarkerFileURI:nt,gotoLineMode:Ue.goto,initialStartup:!0,remoteAuthority:dt})}shouldBlockURI(we){return!!(we.authority===g.Schemas.file&&d.isWindows&&p.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,k.mnemonicButtonLabel)((0,i.localize)(0,null)),(0,k.mnemonicButtonLabel)((0,i.localize)(1,null))],defaultId:0,cancelId:1,message:(0,i.localize)(2,null,(0,k.getPathLabel)(we.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,i.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(we){if(!!we.path){if(we.authority===g.Schemas.file){const ye=v.URI.file(we.fsPath);return(0,Ae.hasWorkspaceFileExtension)(ye)?{workspaceUri:ye}:{fileUri:ye}}else if(we.authority===g.Schemas.vscodeRemote){const ye=we.path.indexOf(t.posix.sep,1);if(ye!==-1){const be=we.path.substring(1,ye),Se=we.path.substring(ye),Me=v.URI.from({scheme:g.Schemas.vscodeRemote,authority:be,path:Se,query:we.query,fragment:we.fragment});return(0,Ae.hasWorkspaceFileExtension)(Se)?{workspaceUri:Me}:/:[\d]+$/.test(Se)?{fileUri:Me}:{folderUri:Me}}}}}getWindowOpenableFromPathSync(we){try{if((0,n.statSync)(we).isDirectory())return{folderUri:v.URI.file(we)};if((0,Ae.hasWorkspaceFileExtension)(we))return{workspaceUri:v.URI.file(we)}}catch{}return{fileUri:v.URI.file(we)}}async afterWindowOpen(we,ye){this.lifecycleMainService.phase=3;let be=!1;(0,S.once)(this.lifecycleMainService.onWillShutdown)(()=>be=!0);const Se=we.get(_e.ITelemetryService);this._register(ye.onDidError(({type:De,details:ke})=>{let Ce;switch(De){case 1:Ce="SharedProcess: detected unresponsive window";break;case 2:Ce=`SharedProcess: crashed (detail: ${ke?.reason??"<unknown>"}, code: ${ke?.exitCode??"<unknown>"})`;break;case 3:Ce=`SharedProcess: failed to load (detail: ${ke?.reason??"<unknown>"}, code: ${ke?.exitCode??"<unknown>"})`;break}(0,E.onUnexpectedError)(new Error(Ce)),Se.publicLog2("sharedprocesserror",{type:De,reason:ke?.reason,code:ke?.exitCode,visible:ye.isVisible(),shuttingdown:be})}));const Me=this.productService.win32MutexName;if(d.isWindows&&Me)try{const De=j.__$__nodeRequire("windows-mutex").Mutex,ke=new De(Me);(0,S.once)(this.lifecycleMainService.onWillShutdown)(()=>ke.release())}catch(De){this.logService.error(De)}p.protocol.registerHttpProtocol(g.Schemas.vscodeRemoteResource,(De,ke)=>{ke({url:De.url.replace(/^vscode-remote-resource:/,"http:"),method:De.method})});const Re=we.get(Je.IUpdateService);(Re instanceof Ge.Win32UpdateService||Re instanceof st.LinuxUpdateService||Re instanceof lt.DarwinUpdateService)&&Re.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const ke=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,b.stripComments)(ke))["enable-crash-reporter"]===void 0){const Ne=(0,xe.getTelemetryLevel)(this.configurationService)>=1,Xe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ne},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,C.generateUuid)()}"`,"}"],Ze=ke.substring(0,ke.length-2).concat(`,
`,Xe.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(Ze))}}catch(De){this.logService.error(De)}}async resolveShellEnvironment(we,ye,be){try{return await(0,V.getResolvedShellEnv)(this.logService,we,ye)}catch(Se){const Me=(0,P.toErrorMessage)(Se);be?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Me):this.logService.error(Me)}return{}}stopTracingEventually(we,ye){this.logService.info("Tracing: waiting for windows to get ready...");const be=we.get(W.IDialogMainService);let Se=!1;const Me=async De=>{if(Se)return;Se=!0;const ke=await p.contentTracing.stopRecording(`${(0,w.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);De?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${ke}`):be.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,i.localize)(4,null),detail:(0,i.localize)(5,null,ke),buttons:[(0,k.mnemonicButtonLabel)((0,i.localize)(6,null))],defaultId:0,noLink:!0},(0,m.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))},Re=setTimeout(()=>Me(!0),3e4);Promise.all(ye.map(De=>De.ready())).then(()=>{clearTimeout(Re),Me(!1)})}};tt=de([ne(2,T.IInstantiationService),ne(3,se.ILogService),ne(4,oe.IEnvironmentMainService),ne(5,ie.ILifecycleMainService),ne(6,h.IConfigurationService),ne(7,fe.IStateMainService),ne(8,q.IFileService),ne(9,he.IProductService)],tt),e.CodeApplication=tt}),define(ee[258],te([0,1,14,29,27,8,39,15,28,42,33,10,9,64,3,34,25,24,37,57,251,11,19,199,210,23,53,169,18,188,77,62,182,76,20,96,6,193,97,54,22,55,196,99,236,49,238,78,207,38,240,66,67,216]),function(j,e,p,n,D,M,P,E,w,S,b,k,y,g,t,d,m,v,C,u,f,c,o,l,s,i,r,a,h,I,R,L,W,N,J,oe,re,V,Z,H,K,G,z,B,Y,q,F,$,A,T,U,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Q{main(){try{this.startup()}catch(x){console.error(x.message),p.app.exit(1)}}async startup(){(0,E.setUnexpectedErrorHandler)(fe=>console.error(fe));const[x,ce,le,he,me,pe,ge]=this.createServices();try{try{await this.initServices(le,he,me)}catch(fe){throw this.handleStartupDataDirError(le,ge.nameLong,fe),fe}await x.invokeFunction(async fe=>{const Ie=fe.get(re.ILogService),Pe=fe.get(J.ILifecycleMainService),Te=fe.get(h.IFileService),_e=await this.claimInstance(Ie,le,Pe,x,ge,!0);return v.Promises.writeFile(le.mainLockfile,String(process.pid)).catch(qe=>{Ie.warn(`Error writing main lockfile: ${qe.stack}`)}),pe.logger=new Z.SpdLogLogger("main",(0,y.join)(le.logsPath,"main.log"),!0,!1,pe.getLevel()),(0,S.once)(Pe.onWillShutdown)(qe=>{Te.dispose(),he.dispose(),qe.join(v.Promises.unlink(le.mainLockfile).catch(()=>{}))}),x.createInstance(f.CodeApplication,_e,ce).startup()})}catch(fe){x.invokeFunction(this.quit,fe)}}createServices(){const x=new N.ServiceCollection,ce={_serviceBrand:void 0,...H.default};x.set(K.IProductService,ce);const le=new i.EnvironmentMainService(this.resolveArgs(),ce),he=this.patchEnvironment(le);x.set(i.IEnvironmentMainService,le);const me=new oe.BufferLogService,pe=new re.MultiplexLogService([new re.ConsoleMainLogger((0,re.getLogLevel)(le)),me]);process.once("exit",()=>pe.dispose()),x.set(re.ILogService,pe);const ge=new I.FileService(pe);x.set(h.IFileService,ge);const fe=new R.DiskFileSystemProvider(pe);ge.registerProvider(k.Schemas.file,fe),x.set(re.ILoggerService,new V.LoggerService(pe,ge));const Ie=new l.ConfigurationService(le.settingsResource,ge);x.set(o.IConfigurationService,Ie),x.set(J.ILifecycleMainService,new L.SyncDescriptor(J.LifecycleMainService));const Pe=new U.StateMainService(le,pe,ge);return x.set(T.IStateMainService,Pe),x.set(q.IRequestService,new L.SyncDescriptor(F.RequestMainService)),x.set(_.IThemeMainService,new L.SyncDescriptor(_.ThemeMainService)),x.set($.ISignService,new L.SyncDescriptor(A.SignService)),x.set(B.ITunnelService,new L.SyncDescriptor(Y.TunnelService)),x.set(G.IProtocolMainService,new L.SyncDescriptor(z.ProtocolMainService)),[new W.InstantiationService(x,!0),he,le,Ie,Pe,me,ce]}patchEnvironment(x){const ce={VSCODE_IPC_HOOK:x.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(le=>{const he=process.env[le];typeof he=="string"&&(ce[le]=he)}),Object.assign(process.env,ce),ce}initServices(x,ce,le){return M.Promises.settled([Promise.all([x.extensionsPath,x.codeCachePath,x.logsPath,x.globalStorageHome.fsPath,x.workspaceStorageHome.fsPath,x.backupHome].map(he=>he?v.Promises.mkdir(he,{recursive:!0}):void 0)),ce.initialize(),le.init()])}async claimInstance(x,ce,le,he,me,pe){let ge;try{(0,g.mark)("code/willStartMainServer"),ge=await(0,u.serve)(ce.mainIPCHandle),(0,g.mark)("code/didStartMainServer"),(0,S.once)(le.onWillShutdown)(()=>ge.dispose())}catch(fe){if(fe.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ce,me.nameLong,fe),fe;let Ie;try{Ie=await(0,u.connect)(ce.mainIPCHandle,"main")}catch(_e){if(!pe||t.isWindows||_e.code!=="ECONNREFUSED")throw _e.code==="EPERM"&&this.showStartupWarningDialog((0,c.localize)(0,null,me.nameShort),(0,c.localize)(1,null),me.nameLong),_e;try{(0,n.unlinkSync)(ce.mainIPCHandle)}catch(qe){throw x.warn("Could not delete obsolete instance handle",qe),qe}return this.claimInstance(x,ce,le,he,me,!1)}if(ce.extensionTestsLocationURI&&!ce.debugExtensionHost.break){const _e="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw x.error(_e),Ie.dispose(),new Error(_e)}let Pe;!ce.args.wait&&!ce.args.status&&(Pe=setTimeout(()=>{this.showStartupWarningDialog((0,c.localize)(2,null,me.nameShort),(0,c.localize)(3,null),me.nameLong)},1e4));const Te=C.ProxyChannel.toService(Ie.getChannel("launch"),{disableMarshalling:!0});if(ce.args.status)return he.invokeFunction(async()=>{const _e=new s.DiagnosticsService(O.NullTelemetryService,me),qe=await Te.getMainProcessInfo(),Ve=await Te.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),xe=await _e.getDiagnostics(qe,Ve);throw console.log(xe),new E.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(Te,x),x.trace("Sending env to running instance..."),await Te.start(ce.args,process.env),Ie.dispose(),Pe&&clearTimeout(Pe),new E.ExpectedError("Sent env to running instance. Terminating...")}if(ce.args.status)throw x.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new E.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),ge}handleStartupDataDirError(x,ce,le){if(le.code==="EACCES"||le.code==="EPERM"){const he=(0,D.coalesce)([x.userDataPath,x.extensionsPath,u.XDG_RUNTIME_DIR]).map(me=>(0,b.getPathLabel)(me,x));this.showStartupWarningDialog((0,c.localize)(4,null),(0,c.localize)(5,null,(0,P.toErrorMessage)(le),he.join(`
`)),ce)}}showStartupWarningDialog(x,ce,le){p.dialog.showMessageBoxSync({title:le,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,c.localize)(6,null))],message:x,detail:ce,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(x,ce){if(t.isWindows){const le=await x.getMainProcessId();ce.trace("Sending some foreground love to the running instance:",le);try{(await new Promise((he,me)=>{j(["windows-foreground-love"],he,me)})).allowSetForegroundWindow(le)}catch(he){ce.error(he)}}}quit(x,ce){const le=x.get(re.ILogService),he=x.get(J.ILifecycleMainService);let me=0;ce&&(ce.isExpected?ce.message&&le.trace(ce.message):(me=1,ce.stack?le.error(ce.stack):le.error(`Startup error: ${ce.toString()}`))),he.kill(me)}resolveArgs(){const x=this.validatePaths((0,r.parseMainProcessArgv)(process.argv));if(x.wait&&!x.waitMarkerFilePath){const ce=(0,a.createWaitMarkerFile)(x.verbose);ce&&((0,r.addArg)(process.argv,"--waitMarkerFilePath",ce),x.waitMarkerFilePath=ce)}return x}validatePaths(x){if(x["open-url"]&&(x._urls=x._,x._=[]),!x.remote){const ce=this.doValidatePaths(x._,x.goto);x._=ce}return x}doValidatePaths(x,ce){const le=(0,d.cwd)(),he=x.map(ge=>{let fe=String(ge),Ie;ce&&(Ie=(0,w.parseLineAndColumnAware)(fe),fe=Ie.path),fe&&(fe=this.preparePath(le,fe));const Pe=(0,w.sanitizeFilePath)(fe,le),Te=(0,y.basename)(Pe);return Te&&!(0,w.isValidBasename)(Te)?null:ce&&Ie?(Ie.path=Pe,this.toPath(Ie)):Pe}),me=t.isWindows||t.isMacintosh,pe=(0,D.distinct)(he,ge=>ge&&me?ge.toLowerCase():ge||"");return(0,D.coalesce)(pe)}preparePath(x,ce){return t.isWindows&&(ce=(0,m.rtrim)(ce,'"')),ce=(0,m.trim)((0,m.trim)(ce," "),"	"),t.isWindows&&(ce=(0,y.resolve)(x,ce),ce=(0,m.rtrim)(ce,".")),ce}toPath(x){const ce=[x.path];return typeof x.line=="number"&&ce.push(String(x.line)),typeof x.column=="number"&&ce.push(String(x.column)),ce.join(":")}}new Q().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/865a677399f0c0a1e98e0b9eb7308f1297b6ace4/core/vs/code/electron-main/main.js.map
