/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/base/common/errors","vs/base/common/types","vs/base/common/uri","vs/base/common/network","vs/base/common/path","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/arrays","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/platform/product/common/productService","os","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","child_process","vs/platform/instantiation/common/descriptors","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/base/common/map","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/skipList","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/environment/node/argvHelper","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/iterator","graceful-fs","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Z=function(z){for(var i=[],C=0,D=z.length;C<D;C++)i[C]=Q[z[C]];return i};define(Q[55],Z([0,1]),function(z,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=void 0;function C(D,P){if(!D)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}i.ok=C}),define(Q[44],Z([0,1]),function(z,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.throttle=i.debounce=i.memoize=i.createDecorator=void 0;function C(L){return(I,c,d)=>{let b=null,T=null;if(typeof d.value=="function"?(b="value",T=d.value):typeof d.get=="function"&&(b="get",T=d.get),!T)throw new Error("not supported");d[b]=L(T,c)}}i.createDecorator=C;function D(L,I,c){let d=null,b=null;if(typeof c.value=="function"?(d="value",b=c.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(d="get",b=c.get),!b)throw new Error("not supported");const T=`$memoize$${I}`;c[d]=function(...h){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,h)}),this[T]}}i.memoize=D;function P(L,I,c){return C((d,b)=>{const T=`$debounce$${b}`,h=`$debounce$result$${b}`;return function(...S){this[h]||(this[h]=c?c():void 0),clearTimeout(this[T]),I&&(this[h]=I(this[h],...S),S=[this[h]]),this[T]=setTimeout(()=>{d.apply(this,S),this[h]=c?c():void 0},L)}})}i.debounce=P;function R(L,I,c){return C((d,b)=>{const T=`$throttle$timer$${b}`,h=`$throttle$result$${b}`,S=`$throttle$lastRun$${b}`,y=`$throttle$pending$${b}`;return function(...g){if(this[h]||(this[h]=c?c():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),I&&(this[h]=I(this[h],...g)),this[y])return;const a=this[S]+L;a<=Date.now()?(this[S]=Date.now(),d.apply(this,[this[h]]),this[h]=c?c():void 0):(this[y]=!0,this[T]=setTimeout(()=>{this[y]=!1,this[S]=Date.now(),d.apply(this,[this[h]]),this[h]=c?c():void 0},a-Date.now()))}})}i.throttle=R}),define(Q[56],Z([0,1]),function(z,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getNodeType=i.stripComments=i.visit=i.findNodeAtOffset=i.contains=i.getNodeValue=i.getNodePath=i.findNodeAtLocation=i.parseTree=i.parse=i.getLocation=i.createScanner=i.ParseOptions=i.ParseErrorCode=i.SyntaxKind=i.ScanError=void 0;var C;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(C=i.ScanError||(i.ScanError={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D=i.SyntaxKind||(i.SyntaxKind={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P=i.ParseErrorCode||(i.ParseErrorCode={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R=i.ParseOptions||(i.ParseOptions={}));function L(t,r=!1){let e=0,n=t.length,s="",l=0,f=16,m=0;function w(te){let ge=0,B=0;for(;ge<te;){const _=t.charCodeAt(e);if(_>=48&&_<=57)B=B*16+_-48;else if(_>=65&&_<=70)B=B*16+_-65+10;else if(_>=97&&_<=102)B=B*16+_-97+10;else break;e++,ge++}return ge<te&&(B=-1),B}function O(te){e=te,s="",l=0,f=16,m=0}function N(){const te=e;if(t.charCodeAt(e)===48)e++;else for(e++;e<t.length&&d(t.charCodeAt(e));)e++;if(e<t.length&&t.charCodeAt(e)===46)if(e++,e<t.length&&d(t.charCodeAt(e)))for(e++;e<t.length&&d(t.charCodeAt(e));)e++;else return m=3,t.substring(te,e);let ge=e;if(e<t.length&&(t.charCodeAt(e)===69||t.charCodeAt(e)===101))if(e++,(e<t.length&&t.charCodeAt(e)===43||t.charCodeAt(e)===45)&&e++,e<t.length&&d(t.charCodeAt(e))){for(e++;e<t.length&&d(t.charCodeAt(e));)e++;ge=e}else m=3;return t.substring(te,ge)}function q(){let te="",ge=e;for(;;){if(e>=n){te+=t.substring(ge,e),m=2;break}const B=t.charCodeAt(e);if(B===34){te+=t.substring(ge,e),e++;break}if(B===92){if(te+=t.substring(ge,e),e++,e>=n){m=2;break}switch(t.charCodeAt(e++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const re=w(4);re>=0?te+=String.fromCharCode(re):m=4;break}default:m=5}ge=e;continue}if(B>=0&&B<=31)if(c(B)){te+=t.substring(ge,e),m=2;break}else m=6;e++}return te}function J(){if(s="",m=0,l=e,e>=n)return l=n,f=17;let te=t.charCodeAt(e);if(I(te)){do e++,s+=String.fromCharCode(te),te=t.charCodeAt(e);while(I(te));return f=15}if(c(te))return e++,s+=String.fromCharCode(te),te===13&&t.charCodeAt(e)===10&&(e++,s+=`
`),f=14;switch(te){case 123:return e++,f=1;case 125:return e++,f=2;case 91:return e++,f=3;case 93:return e++,f=4;case 58:return e++,f=6;case 44:return e++,f=5;case 34:return e++,s=q(),f=10;case 47:{const ge=e-1;if(t.charCodeAt(e+1)===47){for(e+=2;e<n&&!c(t.charCodeAt(e));)e++;return s=t.substring(ge,e),f=12}if(t.charCodeAt(e+1)===42){e+=2;const B=n-1;let _=!1;for(;e<B;){if(t.charCodeAt(e)===42&&t.charCodeAt(e+1)===47){e+=2,_=!0;break}e++}return _||(e++,m=1),s=t.substring(ge,e),f=13}return s+=String.fromCharCode(te),e++,f=16}case 45:if(s+=String.fromCharCode(te),e++,e===n||!d(t.charCodeAt(e)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=N(),f=11;default:for(;e<n&&se(te);)e++,te=t.charCodeAt(e);if(l!==e){switch(s=t.substring(l,e),s){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return s+=String.fromCharCode(te),e++,f=16}}function se(te){if(I(te)||c(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let te;do te=J();while(te>=12&&te<=15);return te}return{setPosition:O,getPosition:()=>e,scan:r?ie:J,getToken:()=>f,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>e-l,getTokenError:()=>m}}i.createScanner=L;function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function c(t){return t===10||t===13||t===8232||t===8233}function d(t){return t>=48&&t<=57}var b;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(b||(b={}));function T(t,r){const e=[],n=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function m(w,O,N,q){l.value=w,l.offset=O,l.length=N,l.type=q,l.colonOffset=void 0,s=l}try{E(t,{onObjectBegin:(w,O)=>{if(r<=w)throw n;s=void 0,f=r>w,e.push("")},onObjectProperty:(w,O,N)=>{if(r<O||(m(w,O,N,"property"),e[e.length-1]=w,r<=O+N))throw n},onObjectEnd:(w,O)=>{if(r<=w)throw n;s=void 0,e.pop()},onArrayBegin:(w,O)=>{if(r<=w)throw n;s=void 0,e.push(0)},onArrayEnd:(w,O)=>{if(r<=w)throw n;s=void 0,e.pop()},onLiteralValue:(w,O,N)=>{if(r<O||(m(w,O,N,o(w)),r<=O+N))throw n},onSeparator:(w,O,N)=>{if(r<=O)throw n;if(w===":"&&s&&s.type==="property")s.colonOffset=O,f=!1,s=void 0;else if(w===","){const q=e[e.length-1];typeof q=="number"?e[e.length-1]=q+1:(f=!0,e[e.length-1]=""),s=void 0}}})}catch(w){if(w!==n)throw w}return{path:e,previousNode:s,isAtPropertyKey:f,matches:w=>{let O=0;for(let N=0;O<w.length&&N<e.length;N++)if(w[O]===e[N]||w[O]==="*")O++;else if(w[O]!=="**")return!1;return O===w.length}}}i.getLocation=T;function h(t,r=[],e=R.DEFAULT){let n=null,s=[];const l=[];function f(w){Array.isArray(s)?s.push(w):n!==null&&(s[n]=w)}return E(t,{onObjectBegin:()=>{const w={};f(w),l.push(s),s=w,n=null},onObjectProperty:w=>{n=w},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const w=[];f(w),l.push(s),s=w,n=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:f,onError:(w,O,N)=>{r.push({error:w,offset:O,length:N})}},e),s[0]}i.parse=h;function S(t,r=[],e=R.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(w){n.type==="property"&&(n.length=w-n.offset,n=n.parent)}function l(w){return n.children.push(w),w}E(t,{onObjectBegin:w=>{n=l({type:"object",offset:w,length:-1,parent:n,children:[]})},onObjectProperty:(w,O,N)=>{n=l({type:"property",offset:O,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:w,offset:O,length:N,parent:n})},onObjectEnd:(w,O)=>{n.length=w+O-n.offset,n=n.parent,s(w+O)},onArrayBegin:(w,O)=>{n=l({type:"array",offset:w,length:-1,parent:n,children:[]})},onArrayEnd:(w,O)=>{n.length=w+O-n.offset,n=n.parent,s(w+O)},onLiteralValue:(w,O,N)=>{l({type:o(w),offset:O,length:N,parent:n,value:w}),s(O+N)},onSeparator:(w,O,N)=>{n.type==="property"&&(w===":"?n.colonOffset=O:w===","&&s(O))},onError:(w,O,N)=>{r.push({error:w,offset:O,length:N})}},e);const m=n.children[0];return m&&delete m.parent,m}i.parseTree=S;function y(t,r){if(!t)return;let e=t;for(let n of r)if(typeof n=="string"){if(e.type!=="object"||!Array.isArray(e.children))return;let s=!1;for(const l of e.children)if(Array.isArray(l.children)&&l.children[0].value===n){e=l.children[1],s=!0;break}if(!s)return}else{const s=n;if(e.type!=="array"||s<0||!Array.isArray(e.children)||s>=e.children.length)return;e=e.children[s]}return e}i.findNodeAtLocation=y;function g(t){if(!t.parent||!t.parent.children)return[];const r=g(t.parent);if(t.parent.type==="property"){const e=t.parent.children[0].value;r.push(e)}else if(t.parent.type==="array"){const e=t.parent.children.indexOf(t);e!==-1&&r.push(e)}return r}i.getNodePath=g;function a(t){switch(t.type){case"array":return t.children.map(a);case"object":{const r=Object.create(null);for(let e of t.children){const n=e.children[1];n&&(r[e.children[0].value]=a(n))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}i.getNodeValue=a;function u(t,r,e=!1){return r>=t.offset&&r<t.offset+t.length||e&&r===t.offset+t.length}i.contains=u;function v(t,r,e=!1){if(u(t,r,e)){const n=t.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=r;s++){const l=v(n[s],r,e);if(l)return l}return t}}i.findNodeAtOffset=v;function E(t,r,e=R.DEFAULT){const n=L(t,!1);function s(K){return K?()=>K(n.getTokenOffset(),n.getTokenLength()):()=>!0}function l(K){return K?ee=>K(ee,n.getTokenOffset(),n.getTokenLength()):()=>!0}const f=s(r.onObjectBegin),m=l(r.onObjectProperty),w=s(r.onObjectEnd),O=s(r.onArrayBegin),N=s(r.onArrayEnd),q=l(r.onLiteralValue),J=l(r.onSeparator),se=s(r.onComment),ie=l(r.onError),te=e&&e.disallowComments,ge=e&&e.allowTrailingComma;function B(){for(;;){const K=n.scan();switch(n.getTokenError()){case 4:_(14);break;case 5:_(15);break;case 3:_(13);break;case 1:te||_(11);break;case 2:_(12);break;case 6:_(16);break}switch(K){case 12:case 13:te?_(10):se();break;case 16:_(1);break;case 15:case 14:break;default:return K}}}function _(K,ee=[],G=[]){if(ie(K),ee.length+G.length>0){let ae=n.getToken();for(;ae!==17;){if(ee.indexOf(ae)!==-1){B();break}else if(G.indexOf(ae)!==-1)break;ae=B()}}}function re(K){const ee=n.getTokenValue();return K?q(ee):m(ee),B(),!0}function M(){switch(n.getToken()){case 11:{let K=0;try{K=JSON.parse(n.getTokenValue()),typeof K!="number"&&(_(2),K=0)}catch{_(2)}q(K);break}case 7:q(null);break;case 8:q(!0);break;case 9:q(!1);break;default:return!1}return B(),!0}function A(){return n.getToken()!==10?(_(3,[],[2,5]),!1):(re(!1),n.getToken()===6?(J(":"),B(),ne()||_(4,[],[2,5])):_(5,[],[2,5]),!0)}function W(){f(),B();let K=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(K||_(4,[],[]),J(","),B(),n.getToken()===2&&ge)break}else K&&_(6,[],[]);A()||_(4,[],[2,5]),K=!0}return w(),n.getToken()!==2?_(7,[2],[]):B(),!0}function H(){O(),B();let K=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(K||_(4,[],[]),J(","),B(),n.getToken()===4&&ge)break}else K&&_(6,[],[]);ne()||_(4,[],[4,5]),K=!0}return N(),n.getToken()!==4?_(8,[4],[]):B(),!0}function ne(){switch(n.getToken()){case 3:return H();case 1:return W();case 10:return re(!0);default:return M()}}return B(),n.getToken()===17?e.allowEmptyContent?!0:(_(4,[],[]),!1):ne()?(n.getToken()!==17&&_(9,[],[]),!0):(_(4,[],[]),!1)}i.visit=E;function p(t,r){let e=L(t),n=[],s,l=0,f;do switch(f=e.getPosition(),s=e.scan(),s){case 12:case 13:case 17:l!==f&&n.push(t.substring(l,f)),r!==void 0&&n.push(e.getTokenValue().replace(/[^\r\n]/g,r)),l=e.getPosition();break}while(s!==17);return n.join("")}i.stripComments=p;function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}i.getNodeType=o}),function(){function z(P){const R=[];typeof P=="number"&&R.push("code/timeOrigin",P);function L(c){R.push(c,Date.now())}function I(){const c=[];for(let d=0;d<R.length;d+=2)c.push({name:R[d],startTime:R[d+1]});return c}return{mark:L,getMarks:I}}function i(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?z():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const L of performance.getEntriesByType("mark"))R.push({name:L.name,startTime:Math.round(P+L.startTime)});return R}};if(typeof process=="object"){const P=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return z(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),z()}function C(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=i()),P.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=C(D))}(),define(Q[57],Z([0,1]),function(z,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.sanitizeProcessEnvironment=i.TerminateResponseCode=i.Source=void 0;var C;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(C=i.Source||(i.Source={}));var D;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(D=i.TerminateResponseCode||(i.TerminateResponseCode={}));function P(R,...L){const I=L.reduce((b,T)=>(b[T]=!0,b),{}),c=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(b=>!I[b]).forEach(b=>{for(let T=0;T<c.length;T++)if(b.search(c[T])!==-1){delete R[b];break}})}i.sanitizeProcessEnvironment=P}),function(z,i){if(typeof exports=="object"&&typeof module=="object")module.exports=i();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],i);else{var C=i();for(var D in C)(typeof exports=="object"?exports:z)[D]=C[D]}}(typeof self!="undefined"?self:this,function(){return function(z){var i={};function C(D){if(i[D])return i[D].exports;var P=i[D]={i:D,l:!1,exports:{}};return z[D].call(P.exports,P,P.exports,C),P.l=!0,P.exports}return C.m=z,C.c=i,C.d=function(D,P,R){C.o(D,P)||Object.defineProperty(D,P,{enumerable:!0,get:R})},C.r=function(D){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},C.t=function(D,P){if(1&P&&(D=C(D)),8&P||4&P&&typeof D=="object"&&D&&D.__esModule)return D;var R=Object.create(null);if(C.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:D}),2&P&&typeof D!="string")for(var L in D)C.d(R,L,function(I){return D[I]}.bind(null,L));return R},C.n=function(D){var P=D&&D.__esModule?function(){return D.default}:function(){return D};return C.d(P,"a",P),P},C.o=function(D,P){return Object.prototype.hasOwnProperty.call(D,P)},C.p="",C(C.s=0)}([function(z,i,C){(function(D){var P;i=z.exports=G,P=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var F=Array.prototype.slice.call(arguments,0);F.unshift("SEMVER"),console.log.apply(console,F)}:function(){},i.SEMVER_SPEC_VERSION="2.0.0";var R=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,I=i.re=[],c=i.src=[],d=0,b=d++;c[b]="0|[1-9]\\d*";var T=d++;c[T]="[0-9]+";var h=d++;c[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=d++;c[S]="("+c[b]+")\\.("+c[b]+")\\.("+c[b]+")";var y=d++;c[y]="("+c[T]+")\\.("+c[T]+")\\.("+c[T]+")";var g=d++;c[g]="(?:"+c[b]+"|"+c[h]+")";var a=d++;c[a]="(?:"+c[T]+"|"+c[h]+")";var u=d++;c[u]="(?:-("+c[g]+"(?:\\."+c[g]+")*))";var v=d++;c[v]="(?:-?("+c[a]+"(?:\\."+c[a]+")*))";var E=d++;c[E]="[0-9A-Za-z-]+";var p=d++;c[p]="(?:\\+("+c[E]+"(?:\\."+c[E]+")*))";var o=d++,t="v?"+c[S]+c[u]+"?"+c[p]+"?";c[o]="^"+t+"$";var r="[v=\\s]*"+c[y]+c[v]+"?"+c[p]+"?",e=d++;c[e]="^"+r+"$";var n=d++;c[n]="((?:<|>)?=?)";var s=d++;c[s]=c[T]+"|x|X|\\*";var l=d++;c[l]=c[b]+"|x|X|\\*";var f=d++;c[f]="[v=\\s]*("+c[l]+")(?:\\.("+c[l]+")(?:\\.("+c[l]+")(?:"+c[u]+")?"+c[p]+"?)?)?";var m=d++;c[m]="[v=\\s]*("+c[s]+")(?:\\.("+c[s]+")(?:\\.("+c[s]+")(?:"+c[v]+")?"+c[p]+"?)?)?";var w=d++;c[w]="^"+c[n]+"\\s*"+c[f]+"$";var O=d++;c[O]="^"+c[n]+"\\s*"+c[m]+"$";var N=d++;c[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var q=d++;c[q]="(?:~>?)";var J=d++;c[J]="(\\s*)"+c[q]+"\\s+",I[J]=new RegExp(c[J],"g");var se=d++;c[se]="^"+c[q]+c[f]+"$";var ie=d++;c[ie]="^"+c[q]+c[m]+"$";var te=d++;c[te]="(?:\\^)";var ge=d++;c[ge]="(\\s*)"+c[te]+"\\s+",I[ge]=new RegExp(c[ge],"g");var B=d++;c[B]="^"+c[te]+c[f]+"$";var _=d++;c[_]="^"+c[te]+c[m]+"$";var re=d++;c[re]="^"+c[n]+"\\s*("+r+")$|^$";var M=d++;c[M]="^"+c[n]+"\\s*("+t+")$|^$";var A=d++;c[A]="(\\s*)"+c[n]+"\\s*("+r+"|"+c[f]+")",I[A]=new RegExp(c[A],"g");var W=d++;c[W]="^\\s*("+c[f]+")\\s+-\\s+("+c[f]+")\\s*$";var H=d++;c[H]="^\\s*("+c[m]+")\\s+-\\s+("+c[m]+")\\s*$";var ne=d++;c[ne]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)P(K,c[K]),I[K]||(I[K]=new RegExp(c[K]));function ee(F,V){if(F instanceof G)return F;if(typeof F!="string"||F.length>R||!(V?I[e]:I[o]).test(F))return null;try{return new G(F,V)}catch{return null}}function G(F,V){if(F instanceof G){if(F.loose===V)return F;F=F.version}else if(typeof F!="string")throw new TypeError("Invalid Version: "+F);if(F.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof G))return new G(F,V);P("SemVer",F,V),this.loose=V;var $=F.trim().match(V?I[e]:I[o]);if(!$)throw new TypeError("Invalid Version: "+F);if(this.raw=F,this.major=+$[1],this.minor=+$[2],this.patch=+$[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");$[4]?this.prerelease=$[4].split(".").map(function(ue){if(/^[0-9]+$/.test(ue)){var ve=+ue;if(ve>=0&&ve<L)return ve}return ue}):this.prerelease=[],this.build=$[5]?$[5].split("."):[],this.format()}i.parse=ee,i.valid=function(F,V){var $=ee(F,V);return $?$.version:null},i.clean=function(F,V){var $=ee(F.trim().replace(/^[=v]+/,""),V);return $?$.version:null},i.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(F){return P("SemVer.compare",this.version,this.loose,F),F instanceof G||(F=new G(F,this.loose)),this.compareMain(F)||this.comparePre(F)},G.prototype.compareMain=function(F){return F instanceof G||(F=new G(F,this.loose)),U(this.major,F.major)||U(this.minor,F.minor)||U(this.patch,F.patch)},G.prototype.comparePre=function(F){if(F instanceof G||(F=new G(F,this.loose)),this.prerelease.length&&!F.prerelease.length)return-1;if(!this.prerelease.length&&F.prerelease.length)return 1;if(!this.prerelease.length&&!F.prerelease.length)return 0;var V=0;do{var $=this.prerelease[V],ue=F.prerelease[V];if(P("prerelease compare",V,$,ue),$===void 0&&ue===void 0)return 0;if(ue===void 0)return 1;if($===void 0)return-1;if($!==ue)return U($,ue)}while(++V)},G.prototype.inc=function(F,V){switch(F){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",V);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",V);break;case"prepatch":this.prerelease.length=0,this.inc("patch",V),this.inc("pre",V);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",V),this.inc("pre",V);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $=this.prerelease.length;--$>=0;)typeof this.prerelease[$]=="number"&&(this.prerelease[$]++,$=-2);$===-1&&this.prerelease.push(0)}V&&(this.prerelease[0]===V?isNaN(this.prerelease[1])&&(this.prerelease=[V,0]):this.prerelease=[V,0]);break;default:throw new Error("invalid increment argument: "+F)}return this.format(),this.raw=this.version,this},i.inc=function(F,V,$,ue){typeof $=="string"&&(ue=$,$=void 0);try{return new G(F,$).inc(V,ue).version}catch{return null}},i.diff=function(F,V){if(Y(F,V))return null;var $=ee(F),ue=ee(V);if($.prerelease.length||ue.prerelease.length){for(var ve in $)if((ve==="major"||ve==="minor"||ve==="patch")&&$[ve]!==ue[ve])return"pre"+ve;return"prerelease"}for(var ve in $)if((ve==="major"||ve==="minor"||ve==="patch")&&$[ve]!==ue[ve])return ve},i.compareIdentifiers=U;var ae=/^[0-9]+$/;function U(F,V){var $=ae.test(F),ue=ae.test(V);return $&&ue&&(F=+F,V=+V),$&&!ue?-1:ue&&!$?1:F<V?-1:F>V?1:0}function k(F,V,$){return new G(F,$).compare(new G(V,$))}function x(F,V,$){return k(F,V,$)>0}function j(F,V,$){return k(F,V,$)<0}function Y(F,V,$){return k(F,V,$)===0}function X(F,V,$){return k(F,V,$)!==0}function he(F,V,$){return k(F,V,$)>=0}function fe(F,V,$){return k(F,V,$)<=0}function ye(F,V,$,ue){var ve;switch(V){case"===":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),ve=F===$;break;case"!==":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),ve=F!==$;break;case"":case"=":case"==":ve=Y(F,$,ue);break;case"!=":ve=X(F,$,ue);break;case">":ve=x(F,$,ue);break;case">=":ve=he(F,$,ue);break;case"<":ve=j(F,$,ue);break;case"<=":ve=fe(F,$,ue);break;default:throw new TypeError("Invalid operator: "+V)}return ve}function le(F,V){if(F instanceof le){if(F.loose===V)return F;F=F.value}if(!(this instanceof le))return new le(F,V);P("comparator",F,V),this.loose=V,this.parse(F),this.semver===ce?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}i.rcompareIdentifiers=function(F,V){return U(V,F)},i.major=function(F,V){return new G(F,V).major},i.minor=function(F,V){return new G(F,V).minor},i.patch=function(F,V){return new G(F,V).patch},i.compare=k,i.compareLoose=function(F,V){return k(F,V,!0)},i.rcompare=function(F,V,$){return k(V,F,$)},i.sort=function(F,V){return F.sort(function($,ue){return i.compare($,ue,V)})},i.rsort=function(F,V){return F.sort(function($,ue){return i.rcompare($,ue,V)})},i.gt=x,i.lt=j,i.eq=Y,i.neq=X,i.gte=he,i.lte=fe,i.cmp=ye,i.Comparator=le;var ce={};function de(F,V){if(F instanceof de)return F.loose===V?F:new de(F.raw,V);if(F instanceof le)return new de(F.value,V);if(!(this instanceof de))return new de(F,V);if(this.loose=V,this.raw=F,this.set=F.split(/\s*\|\|\s*/).map(function($){return this.parseRange($.trim())},this).filter(function($){return $.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+F);this.format()}function me(F){return!F||F.toLowerCase()==="x"||F==="*"}function Fe(F,V,$,ue,ve,De,Se,ke,Ie,Oe,Me,Re,Le){return((V=me($)?"":me(ue)?">="+$+".0.0":me(ve)?">="+$+"."+ue+".0":">="+V)+" "+(ke=me(Ie)?"":me(Oe)?"<"+(+Ie+1)+".0.0":me(Me)?"<"+Ie+"."+(+Oe+1)+".0":Re?"<="+Ie+"."+Oe+"."+Me+"-"+Re:"<="+ke)).trim()}function Ce(F,V){for(var $=0;$<F.length;$++)if(!F[$].test(V))return!1;if(V.prerelease.length){for($=0;$<F.length;$++)if(P(F[$].semver),F[$].semver!==ce&&F[$].semver.prerelease.length>0){var ue=F[$].semver;if(ue.major===V.major&&ue.minor===V.minor&&ue.patch===V.patch)return!0}return!1}return!0}function Ue(F,V,$){try{V=new de(V,$)}catch{return!1}return V.test(F)}function Ve(F,V,$,ue){var ve,De,Se,ke,Ie;switch(F=new G(F,ue),V=new de(V,ue),$){case">":ve=x,De=fe,Se=j,ke=">",Ie=">=";break;case"<":ve=j,De=he,Se=x,ke="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(F,V,ue))return!1;for(var Oe=0;Oe<V.set.length;++Oe){var Me=V.set[Oe],Re=null,Le=null;if(Me.forEach(function(Ae){Ae.semver===ce&&(Ae=new le(">=0.0.0")),Re=Re||Ae,Le=Le||Ae,ve(Ae.semver,Re.semver,ue)?Re=Ae:Se(Ae.semver,Le.semver,ue)&&(Le=Ae)}),Re.operator===ke||Re.operator===Ie||(!Le.operator||Le.operator===ke)&&De(F,Le.semver)||Le.operator===Ie&&Se(F,Le.semver))return!1}return!0}le.prototype.parse=function(F){var V=this.loose?I[re]:I[M],$=F.match(V);if(!$)throw new TypeError("Invalid comparator: "+F);this.operator=$[1],this.operator==="="&&(this.operator=""),$[2]?this.semver=new G($[2],this.loose):this.semver=ce},le.prototype.toString=function(){return this.value},le.prototype.test=function(F){return P("Comparator.test",F,this.loose),this.semver===ce||(typeof F=="string"&&(F=new G(F,this.loose)),ye(F,this.operator,this.semver,this.loose))},le.prototype.intersects=function(F,V){if(!(F instanceof le))throw new TypeError("a Comparator is required");var $;if(this.operator==="")return $=new de(F.value,V),Ue(this.value,$,V);if(F.operator==="")return $=new de(this.value,V),Ue(F.semver,$,V);var ue=!(this.operator!==">="&&this.operator!==">"||F.operator!==">="&&F.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||F.operator!=="<="&&F.operator!=="<"),De=this.semver.version===F.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||F.operator!==">="&&F.operator!=="<="),ke=ye(this.semver,"<",F.semver,V)&&(this.operator===">="||this.operator===">")&&(F.operator==="<="||F.operator==="<"),Ie=ye(this.semver,">",F.semver,V)&&(this.operator==="<="||this.operator==="<")&&(F.operator===">="||F.operator===">");return ue||ve||De&&Se||ke||Ie},i.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(F){return F.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(F){var V=this.loose;F=F.trim(),P("range",F,V);var $=V?I[H]:I[W];F=F.replace($,Fe),P("hyphen replace",F),F=F.replace(I[A],"$1$2$3"),P("comparator trim",F,I[A]),F=(F=(F=F.replace(I[J],"$1~")).replace(I[ge],"$1^")).split(/\s+/).join(" ");var ue=V?I[re]:I[M],ve=F.split(" ").map(function(De){return function(Se,ke){return P("comp",Se),Se=function(Ie,Oe){return Ie.trim().split(/\s+/).map(function(Me){return function(Re,Le){P("caret",Re,Le);var Ae=Le?I[_]:I[B];return Re.replace(Ae,function(Ne,Ee,we,be,Pe){var Te;return P("caret",Re,Ne,Ee,we,be,Pe),me(Ee)?Te="":me(we)?Te=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":me(be)?Te=Ee==="0"?">="+Ee+"."+we+".0 <"+Ee+"."+(+we+1)+".0":">="+Ee+"."+we+".0 <"+(+Ee+1)+".0.0":Pe?(P("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Te=Ee==="0"?we==="0"?">="+Ee+"."+we+"."+be+Pe+" <"+Ee+"."+we+"."+(+be+1):">="+Ee+"."+we+"."+be+Pe+" <"+Ee+"."+(+we+1)+".0":">="+Ee+"."+we+"."+be+Pe+" <"+(+Ee+1)+".0.0"):(P("no pr"),Te=Ee==="0"?we==="0"?">="+Ee+"."+we+"."+be+" <"+Ee+"."+we+"."+(+be+1):">="+Ee+"."+we+"."+be+" <"+Ee+"."+(+we+1)+".0":">="+Ee+"."+we+"."+be+" <"+(+Ee+1)+".0.0"),P("caret return",Te),Te})}(Me,Oe)}).join(" ")}(Se,ke),P("caret",Se),Se=function(Ie,Oe){return Ie.trim().split(/\s+/).map(function(Me){return function(Re,Le){var Ae=Le?I[ie]:I[se];return Re.replace(Ae,function(Ne,Ee,we,be,Pe){var Te;return P("tilde",Re,Ne,Ee,we,be,Pe),me(Ee)?Te="":me(we)?Te=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":me(be)?Te=">="+Ee+"."+we+".0 <"+Ee+"."+(+we+1)+".0":Pe?(P("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Te=">="+Ee+"."+we+"."+be+Pe+" <"+Ee+"."+(+we+1)+".0"):Te=">="+Ee+"."+we+"."+be+" <"+Ee+"."+(+we+1)+".0",P("tilde return",Te),Te})}(Me,Oe)}).join(" ")}(Se,ke),P("tildes",Se),Se=function(Ie,Oe){return P("replaceXRanges",Ie,Oe),Ie.split(/\s+/).map(function(Me){return function(Re,Le){Re=Re.trim();var Ae=Le?I[O]:I[w];return Re.replace(Ae,function(Ne,Ee,we,be,Pe,Te){P("xRange",Re,Ne,Ee,we,be,Pe,Te);var je=me(we),ze=je||me(be),xe=ze||me(Pe);return Ee==="="&&xe&&(Ee=""),je?Ne=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&xe?(ze&&(be=0),xe&&(Pe=0),Ee===">"?(Ee=">=",ze?(we=+we+1,be=0,Pe=0):xe&&(be=+be+1,Pe=0)):Ee==="<="&&(Ee="<",ze?we=+we+1:be=+be+1),Ne=Ee+we+"."+be+"."+Pe):ze?Ne=">="+we+".0.0 <"+(+we+1)+".0.0":xe&&(Ne=">="+we+"."+be+".0 <"+we+"."+(+be+1)+".0"),P("xRange return",Ne),Ne})}(Me,Oe)}).join(" ")}(Se,ke),P("xrange",Se),Se=function(Ie,Oe){return P("replaceStars",Ie,Oe),Ie.trim().replace(I[ne],"")}(Se,ke),P("stars",Se),Se}(De,V)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(De){return!!De.match(ue)})),ve=ve.map(function(De){return new le(De,V)})},de.prototype.intersects=function(F,V){if(!(F instanceof de))throw new TypeError("a Range is required");return this.set.some(function($){return $.every(function(ue){return F.set.some(function(ve){return ve.every(function(De){return ue.intersects(De,V)})})})})},i.toComparators=function(F,V){return new de(F,V).set.map(function($){return $.map(function(ue){return ue.value}).join(" ").trim().split(" ")})},de.prototype.test=function(F){if(!F)return!1;typeof F=="string"&&(F=new G(F,this.loose));for(var V=0;V<this.set.length;V++)if(Ce(this.set[V],F))return!0;return!1},i.satisfies=Ue,i.maxSatisfying=function(F,V,$){var ue=null,ve=null;try{var De=new de(V,$)}catch{return null}return F.forEach(function(Se){De.test(Se)&&(ue&&ve.compare(Se)!==-1||(ve=new G(ue=Se,$)))}),ue},i.minSatisfying=function(F,V,$){var ue=null,ve=null;try{var De=new de(V,$)}catch{return null}return F.forEach(function(Se){De.test(Se)&&(ue&&ve.compare(Se)!==1||(ve=new G(ue=Se,$)))}),ue},i.validRange=function(F,V){try{return new de(F,V).range||"*"}catch{return null}},i.ltr=function(F,V,$){return Ve(F,V,"<",$)},i.gtr=function(F,V,$){return Ve(F,V,">",$)},i.outside=Ve,i.prerelease=function(F,V){var $=ee(F,V);return $&&$.prerelease.length?$.prerelease:null},i.intersects=function(F,V,$){return F=new de(F,$),V=new de(V,$),F.intersects(V)},i.coerce=function(F){if(F instanceof G)return F;if(typeof F!="string")return null;var V=F.match(I[N]);return V==null?null:ee((V[1]||"0")+"."+(V[2]||"0")+"."+(V[3]||"0"))}}).call(this,C(1))},function(z,i){var C,D,P=z.exports={};function R(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function I(a){if(C===setTimeout)return setTimeout(a,0);if((C===R||!C)&&setTimeout)return C=setTimeout,setTimeout(a,0);try{return C(a,0)}catch{try{return C.call(null,a,0)}catch{return C.call(this,a,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:R}catch{C=R}try{D=typeof clearTimeout=="function"?clearTimeout:L}catch{D=L}})();var c,d=[],b=!1,T=-1;function h(){b&&c&&(b=!1,c.length?d=c.concat(d):T=-1,d.length&&S())}function S(){if(!b){var a=I(h);b=!0;for(var u=d.length;u;){for(c=d,d=[];++T<u;)c&&c[T].run();T=-1,u=d.length}c=null,b=!1,function(v){if(D===clearTimeout)return clearTimeout(v);if((D===L||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(v);try{D(v)}catch{try{return D.call(null,v)}catch{return D.call(this,v)}}}(a)}}function y(a,u){this.fun=a,this.array=u}function g(){}P.nextTick=function(a){var u=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)u[v-1]=arguments[v];d.push(new y(a,u)),d.length!==1||b||I(S)},y.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=g,P.addListener=g,P.once=g,P.off=g,P.removeListener=g,P.removeAllListeners=g,P.emit=g,P.prependListener=g,P.prependOnceListener=g,P.listeners=function(a){return[]},P.binding=function(a){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(a){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Q[58],Z([0,1]),function(z,i){"use strict";var C;Object.defineProperty(i,"__esModule",{value:!0}),i.SkipList=void 0;class D{constructor(I,c,d){this.level=I,this.key=c,this.value=d,this.forward=[]}}const P=void 0;class R{constructor(I,c=2**16){this.comparator=I,this[C]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(c)|0),this._header=new D(this._maxLevel,P,P)}get size(){return this._size}clear(){this._header=new D(this._maxLevel,P,P)}has(I){return Boolean(R._search(this,I,this.comparator))}get(I){return R._search(this,I,this.comparator)?.value}set(I,c){return R._insert(this,I,c,this.comparator)&&(this._size+=1),this}delete(I){const c=R._delete(this,I,this.comparator);return c&&(this._size-=1),c}forEach(I,c){let d=this._header.forward[0];for(;d;)I.call(c,d.value,d.key,this),d=d.forward[0]}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this._header.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this._header.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this._header.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",c=this._header.forward[0];for(;c;)I+=`node(${c.key}, ${c.value}, lvl:${c.level})`,c=c.forward[0];return I}static _search(I,c,d){let b=I._header;for(let T=I._level-1;T>=0;T--)for(;b.forward[T]&&d(b.forward[T].key,c)<0;)b=b.forward[T];if(b=b.forward[0],b&&d(b.key,c)===0)return b}static _insert(I,c,d,b){let T=[],h=I._header;for(let S=I._level-1;S>=0;S--){for(;h.forward[S]&&b(h.forward[S].key,c)<0;)h=h.forward[S];T[S]=h}if(h=h.forward[0],h&&b(h.key,c)===0)return h.value=d,!1;{let S=R._randomLevel(I);if(S>I._level){for(let y=I._level;y<S;y++)T[y]=I._header;I._level=S}h=new D(S,c,d);for(let y=0;y<S;y++)h.forward[y]=T[y].forward[y],T[y].forward[y]=h;return!0}}static _randomLevel(I,c=.5){let d=1;for(;Math.random()<c&&d<I._maxLevel;)d+=1;return d}static _delete(I,c,d){let b=[],T=I._header;for(let h=I._level-1;h>=0;h--){for(;T.forward[h]&&d(T.forward[h].key,c)<0;)T=T.forward[h];b[h]=T}if(T=T.forward[0],!T||d(T.key,c)!==0)return!1;for(let h=0;h<I._level&&b[h].forward[h]===T;h++)b[h].forward[h]=T.forward[h];for(;I._level>0&&I._header.forward[I._level-1]===P;)I._level-=1;return!0}}i.SkipList=R}),define(Q[37],Z([0,1,7,2]),function(z,i,C,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedStream=i.prefixedReadable=i.transform=i.toReadable=i.emptyStream=i.toStream=i.peekStream=i.listenStream=i.consumeStream=i.peekReadable=i.consumeReadable=i.newWriteableStream=i.isReadableBufferedStream=i.isReadableStream=void 0;function P(E){const p=E;return p?[p.on,p.pause,p.resume,p.destroy].every(o=>typeof o=="function"):!1}i.isReadableStream=P;function R(E){const p=E;return p?P(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}i.isReadableBufferedStream=R;function L(E,p){return new I(E,p)}i.newWriteableStream=L;class I{constructor(p,o){this.reducer=p,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p!="undefined"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(o=>o(p))}emitError(p){this.listeners.error.length===0?(0,C.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(o=>o(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,o){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(p,o){if(this.state.destroyed)return;let t;switch(p){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(o);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(E,p){const o=[];let t;for(;(t=E.read())!==null;)o.push(t);return p(o)}i.consumeReadable=c;function d(E,p,o){const t=[];let r;for(;(r=E.read())!==null&&t.length<o;)t.push(r);return r===null&&t.length>0?p(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const e=r;return r=void 0,e}return E.read()}}}i.peekReadable=d;function b(E,p){return new Promise((o,t)=>{const r=[];T(E,{onData:e=>{p&&r.push(e)},onError:e=>{p?t(e):o(void 0)},onEnd:()=>{o(p?p(r):void 0)}})})}i.consumeStream=b;function T(E,p){let o=!1;return E.on("error",t=>{o||p.onError(t)}),E.on("end",()=>{o||p.onEnd()}),E.on("data",t=>{o||p.onData(t)}),(0,D.toDisposable)(()=>o=!0)}i.listenStream=T;function h(E,p){return new Promise((o,t)=>{const r=new D.DisposableStore,e=[],n=f=>{if(e.push(f),e.length>p)return r.dispose(),E.pause(),o({stream:E,buffer:e,ended:!1})},s=f=>t(f),l=()=>o({stream:E,buffer:e,ended:!0});r.add((0,D.toDisposable)(()=>E.removeListener("error",s))),E.on("error",s),r.add((0,D.toDisposable)(()=>E.removeListener("end",l))),E.on("end",l),r.add((0,D.toDisposable)(()=>E.removeListener("data",n))),E.on("data",n)})}i.peekStream=h;function S(E,p){const o=L(p);return o.end(E),o}i.toStream=S;function y(){const E=L(()=>{throw new Error("not supported")});return E.end(),E}i.emptyStream=y;function g(E){let p=!1;return{read:()=>p?null:(p=!0,E)}}i.toReadable=g;function a(E,p,o){const t=L(o);return T(E,{onData:r=>t.write(p.data(r)),onError:r=>t.error(p.error?p.error(r):r),onEnd:()=>t.end()}),t}i.transform=a;function u(E,p,o){let t=!1;return{read:()=>{const r=p.read();return t?r:(t=!0,r!==null?o([E,r]):E)}}}i.prefixedReadable=u;function v(E,p,o){let t=!1;const r=L(o);return T(p,{onData:e=>t?r.write(e):(t=!0,r.write(o([E,e]))),onError:e=>r.error(e),onEnd:()=>{t||(t=!0,r.write(E)),r.end()}}),r}i.prefixedStream=v}),define(Q[17],Z([0,1,37]),function(z,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.encodeBase64=i.decodeBase64=i.prefixedBufferStream=i.prefixedBufferReadable=i.newWriteableBufferStream=i.streamToBufferReadableStream=i.bufferToStream=i.bufferedStreamToBuffer=i.streamToBuffer=i.bufferToReadable=i.readableToBuffer=i.writeUInt8=i.readUInt8=i.writeUInt32LE=i.readUInt32LE=i.writeUInt32BE=i.readUInt32BE=i.writeUInt16LE=i.readUInt16LE=i.VSBuffer=void 0;const D=typeof Buffer!="undefined";let P,R;class L{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return D?new L(Buffer.allocUnsafe(m)):new L(new Uint8Array(m))}static wrap(m){return D&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new L(m)}static fromString(m,w){return!(w?.dontUseNodeBuffer||!1)&&D?new L(Buffer.from(m)):(P||(P=new TextEncoder),new L(P.encode(m)))}static fromByteArray(m){const w=L.alloc(m.length);for(let O=0,N=m.length;O<N;O++)w.buffer[O]=m[O];return w}static concat(m,w){if(typeof w=="undefined"){w=0;for(let q=0,J=m.length;q<J;q++)w+=m[q].byteLength}const O=L.alloc(w);let N=0;for(let q=0,J=m.length;q<J;q++){const se=m[q];O.set(se,N),N+=se.byteLength}return O}clone(){const m=L.alloc(this.byteLength);return m.set(this),m}toString(){return D?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(m,w){return new L(this.buffer.subarray(m,w))}set(m,w){if(m instanceof L)this.buffer.set(m.buffer,w);else if(m instanceof Uint8Array)this.buffer.set(m,w);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),w);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),w);else throw new Error("Unkown argument 'array'")}readUInt32BE(m){return d(this.buffer,m)}writeUInt32BE(m,w){b(this.buffer,m,w)}readUInt32LE(m){return T(this.buffer,m)}writeUInt32LE(m,w){h(this.buffer,m,w)}readUInt8(m){return S(this.buffer,m)}writeUInt8(m,w){y(this.buffer,m,w)}}i.VSBuffer=L;function I(f,m){return f[m+0]<<0>>>0|f[m+1]<<8>>>0}i.readUInt16LE=I;function c(f,m,w){f[w+0]=m&255,m=m>>>8,f[w+1]=m&255}i.writeUInt16LE=c;function d(f,m){return f[m]*2**24+f[m+1]*2**16+f[m+2]*2**8+f[m+3]}i.readUInt32BE=d;function b(f,m,w){f[w+3]=m,m=m>>>8,f[w+2]=m,m=m>>>8,f[w+1]=m,m=m>>>8,f[w]=m}i.writeUInt32BE=b;function T(f,m){return f[m+0]<<0>>>0|f[m+1]<<8>>>0|f[m+2]<<16>>>0|f[m+3]<<24>>>0}i.readUInt32LE=T;function h(f,m,w){f[w+0]=m&255,m=m>>>8,f[w+1]=m&255,m=m>>>8,f[w+2]=m&255,m=m>>>8,f[w+3]=m&255}i.writeUInt32LE=h;function S(f,m){return f[m]}i.readUInt8=S;function y(f,m,w){f[w]=m}i.writeUInt8=y;function g(f){return C.consumeReadable(f,m=>L.concat(m))}i.readableToBuffer=g;function a(f){return C.toReadable(f)}i.bufferToReadable=a;function u(f){return C.consumeStream(f,m=>L.concat(m))}i.streamToBuffer=u;async function v(f){return f.ended?L.concat(f.buffer):L.concat([...f.buffer,await u(f.stream)])}i.bufferedStreamToBuffer=v;function E(f){return C.toStream(f,m=>L.concat(m))}i.bufferToStream=E;function p(f){return C.transform(f,{data:m=>typeof m=="string"?L.fromString(m):L.wrap(m)},m=>L.concat(m))}i.streamToBufferReadableStream=p;function o(f){return C.newWriteableStream(m=>L.concat(m),f)}i.newWriteableBufferStream=o;function t(f,m){return C.prefixedReadable(f,m,w=>L.concat(w))}i.prefixedBufferReadable=t;function r(f,m){return C.prefixedStream(f,m,w=>L.concat(w))}i.prefixedBufferStream=r;function e(f){let m=0,w=0,O=0;const N=new Uint8Array(Math.floor(f.length/4*3)),q=se=>{switch(w){case 3:N[O++]=m|se,w=0;break;case 2:N[O++]=m|se>>>2,m=se<<6,w=3;break;case 1:N[O++]=m|se>>>4,m=se<<4,w=2;break;default:m=se<<2,w=1}};for(let se=0;se<f.length;se++){const ie=f.charCodeAt(se);if(ie>=65&&ie<=90)q(ie-65);else if(ie>=97&&ie<=122)q(ie-97+26);else if(ie>=48&&ie<=57)q(ie-48+52);else if(ie===43||ie===45)q(62);else if(ie===47||ie===95)q(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${f[se]}`)}}const J=O;for(;w>0;)q(0);return L.wrap(N).slice(0,J)}i.decodeBase64=e;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:f},m=!0,w=!1){const O=w?s:n;let N="";const q=f.byteLength%3;let J=0;for(;J<f.byteLength-q;J+=3){const se=f[J+0],ie=f[J+1],te=f[J+2];N+=O[se>>>2],N+=O[(se<<4|ie>>>4)&63],N+=O[(ie<<2|te>>>6)&63],N+=O[te&63]}if(q===1){const se=f[J+0];N+=O[se>>>2],N+=O[se<<4&63],m&&(N+="==")}else if(q===2){const se=f[J+0],ie=f[J+1];N+=O[se>>>2],N+=O[(se<<4|ie>>>4)&63],N+=O[ie<<2&63],m&&(N+="=")}return N}i.encodeBase64=l}),define(Q[59],Z([0,1,26]),function(z,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StringSHA1=i.toHexString=i.Hasher=i.stringHash=i.numberHash=i.doHash=i.hash=void 0;function D(u){return P(u,0)}i.hash=D;function P(u,v){switch(typeof u){case"object":return u===null?R(349,v):Array.isArray(u)?c(u,v):d(u,v);case"string":return I(u,v);case"boolean":return L(u,v);case"number":return R(u,v);case"undefined":return R(937,v);default:return R(617,v)}}i.doHash=P;function R(u,v){return(v<<5)-v+u|0}i.numberHash=R;function L(u,v){return R(u?433:863,v)}function I(u,v){v=R(149417,v);for(let E=0,p=u.length;E<p;E++)v=R(u.charCodeAt(E),v);return v}i.stringHash=I;function c(u,v){return v=R(104579,v),u.reduce((E,p)=>P(p,E),v)}function d(u,v){return v=R(181387,v),Object.keys(u).sort().reduce((E,p)=>(E=I(p,E),P(u[p],E)),v)}class b{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=P(v,this._value),this._value}}i.Hasher=b;var T;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function h(u,v,E=32){const p=E-v,o=~((1<<p)-1);return(u<<v|(o&u)>>>p)>>>0}function S(u,v=0,E=u.byteLength,p=0){for(let o=0;o<E;o++)u[v+o]=p}function y(u,v,E="0"){for(;u.length<v;)u=E+u;return u}function g(u,v=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(E=>E.toString(16).padStart(2,"0")).join(""):y((u>>>0).toString(16),v/4)}i.toHexString=g;class a{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const E=v.length;if(E===0)return;const p=this._buff;let o=this._buffLen,t=this._leftoverHighSurrogate,r,e;for(t!==0?(r=t,e=-1,t=0):(r=v.charCodeAt(0),e=0);;){let n=r;if(C.isHighSurrogate(r))if(e+1<E){const s=v.charCodeAt(e+1);C.isLowSurrogate(s)?(e++,n=C.computeCodePoint(r,s)):n=65533}else{t=r;break}else C.isLowSurrogate(r)&&(n=65533);if(o=this._push(p,o,n),e++,e<E)r=v.charCodeAt(e);else break}this._buffLen=o,this._leftoverHighSurrogate=t}_push(v,E,p){return p<128?v[E++]=p:p<2048?(v[E++]=192|(p&1984)>>>6,v[E++]=128|(p&63)>>>0):p<65536?(v[E++]=224|(p&61440)>>>12,v[E++]=128|(p&4032)>>>6,v[E++]=128|(p&63)>>>0):(v[E++]=240|(p&1835008)>>>18,v[E++]=128|(p&258048)>>>12,v[E++]=128|(p&4032)>>>6,v[E++]=128|(p&63)>>>0),E>=64&&(this._step(),E-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),E}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=a._bigBlock32,E=this._buffDV;for(let f=0;f<64;f+=4)v.setUint32(f,E.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)v.setUint32(f,h(v.getUint32(f-12,!1)^v.getUint32(f-32,!1)^v.getUint32(f-56,!1)^v.getUint32(f-64,!1),1),!1);let p=this._h0,o=this._h1,t=this._h2,r=this._h3,e=this._h4,n,s,l;for(let f=0;f<80;f++)f<20?(n=o&t|~o&r,s=1518500249):f<40?(n=o^t^r,s=1859775393):f<60?(n=o&t|o&r|t&r,s=2400959708):(n=o^t^r,s=3395469782),l=h(p,5)+n+e+s+v.getUint32(f*4,!1)&4294967295,e=r,r=t,t=h(o,30),o=p,p=l;this._h0=this._h0+p&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+e&4294967295}}i.StringSHA1=a,a._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Q[22],Z([0,1,8]),function(z,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.filter=i.getCaseInsensitive=i.distinct=i.getOrDefault=i.safeStringify=i.equals=i.mixin=i.cloneAndChange=i.deepFreeze=i.deepClone=void 0;function D(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const a=Array.isArray(g)?[]:{};return Object.keys(g).forEach(u=>{g[u]&&typeof g[u]=="object"?a[u]=D(g[u]):a[u]=g[u]}),a}i.deepClone=D;function P(g){if(!g||typeof g!="object")return g;const a=[g];for(;a.length>0;){const u=a.shift();Object.freeze(u);for(const v in u)if(R.call(u,v)){const E=u[v];typeof E=="object"&&!Object.isFrozen(E)&&a.push(E)}}return g}i.deepFreeze=P;const R=Object.prototype.hasOwnProperty;function L(g,a){return I(g,a,new Set)}i.cloneAndChange=L;function I(g,a,u){if((0,C.isUndefinedOrNull)(g))return g;const v=a(g);if(typeof v!="undefined")return v;if((0,C.isArray)(g)){const E=[];for(const p of g)E.push(I(p,a,u));return E}if((0,C.isObject)(g)){if(u.has(g))throw new Error("Cannot clone recursive data-structure");u.add(g);const E={};for(let p in g)R.call(g,p)&&(E[p]=I(g[p],a,u));return u.delete(g),E}return g}function c(g,a,u=!0){return(0,C.isObject)(g)?((0,C.isObject)(a)&&Object.keys(a).forEach(v=>{v in g?u&&((0,C.isObject)(g[v])&&(0,C.isObject)(a[v])?c(g[v],a[v],u):g[v]=a[v]):g[v]=a[v]}),g):a}i.mixin=c;function d(g,a){if(g===a)return!0;if(g==null||a===null||a===void 0||typeof g!=typeof a||typeof g!="object"||Array.isArray(g)!==Array.isArray(a))return!1;let u,v;if(Array.isArray(g)){if(g.length!==a.length)return!1;for(u=0;u<g.length;u++)if(!d(g[u],a[u]))return!1}else{const E=[];for(v in g)E.push(v);E.sort();const p=[];for(v in a)p.push(v);if(p.sort(),!d(E,p))return!1;for(u=0;u<E.length;u++)if(!d(g[E[u]],a[E[u]]))return!1}return!0}i.equals=d;function b(g){const a=new Set;return JSON.stringify(g,(u,v)=>{if((0,C.isObject)(v)||Array.isArray(v)){if(a.has(v))return"[Circular]";a.add(v)}return v})}i.safeStringify=b;function T(g,a,u){const v=a(g);return typeof v=="undefined"?u:v}i.getOrDefault=T;function h(g,a){const u=Object.create(null);return!g||!a||Object.keys(a).forEach(E=>{const p=g[E],o=a[E];d(p,o)||(u[E]=o)}),u}i.distinct=h;function S(g,a){const u=a.toLowerCase(),v=Object.keys(g).find(E=>E.toLowerCase()===u);return v?g[v]:g[a]}i.getCaseInsensitive=S;function y(g,a){const u=Object.create(null);for(const[v,E]of Object.entries(g))a(v,E)&&(u[v]=E);return u}i.filter=y}),define(Q[60],Z([0,1,9]),function(z,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.log=i.getFirstFrame=i.parse=i.isRemoteConsoleLog=void 0;function D(d){const b=d;return b&&typeof b.type=="string"&&typeof b.severity=="string"}i.isRemoteConsoleLog=D;function P(d){const b=[];let T;try{const h=JSON.parse(d.arguments),S=h[h.length-1];S&&S.__$stack&&(h.pop(),T=S.__$stack),b.push(...h)}catch{b.push("Unable to log remote console arguments",d.arguments)}return{args:b,stack:T}}i.parse=P;function R(d){if(typeof d!="string")return R(P(d).stack);const b=d;if(b){const T=L(b),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(T||"");if(h&&h.length===4)return{uri:C.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}i.getFirstFrame=R;function L(d){if(!d)return d;const b=d.indexOf(`
`);return b===-1?d:d.substring(0,b)}function I(d,b){const{args:T,stack:h}=P(d),S=typeof T[0]=="string"&&T.length===1;let y=L(h);y&&(y=`(${y.trim()})`);let g=[];if(typeof T[0]=="string"?y&&S?g=[`%c[${b}] %c${T[0]} %c${y}`,c("blue"),c(""),c("grey")]:g=[`%c[${b}] %c${T[0]}`,c("blue"),c(""),...T.slice(1)]:g=[`%c[${b}]%`,c("blue"),...T],y&&!S&&g.push(y),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,g)}i.log=I;function c(d){return`color: ${d}`}}),define(Q[61],Z([0,1,17,26,9]),function(z,i,C,D,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.revive=i.MarshalledId=i.parse=i.stringify=void 0;function R(b){return JSON.stringify(b,c)}i.stringify=R;function L(b){let T=JSON.parse(b);return T=d(T),T}i.parse=L;var I;(function(b){b[b.Uri=1]="Uri",b[b.Regexp=2]="Regexp",b[b.ScmResource=3]="ScmResource",b[b.ScmResourceGroup=4]="ScmResourceGroup",b[b.ScmProvider=5]="ScmProvider",b[b.CommentController=6]="CommentController",b[b.CommentThread=7]="CommentThread",b[b.CommentThreadReply=8]="CommentThreadReply",b[b.CommentNode=9]="CommentNode",b[b.CommentThreadNode=10]="CommentThreadNode",b[b.TimelineActionContext=11]="TimelineActionContext",b[b.NotebookCellActionContext=12]="NotebookCellActionContext",b[b.TestItemContext=13]="TestItemContext",b[b.Date=14]="Date"})(I=i.MarshalledId||(i.MarshalledId={}));function c(b,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,D.regExpFlags)(T)}:T}function d(b,T=0){if(!b||T>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return P.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 14:return new Date(b.source)}if(b instanceof C.VSBuffer||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let h=0;h<b.length;++h)b[h]=d(b[h],T+1);else for(const h in b)Object.hasOwnProperty.call(b,h)&&(b[h]=d(b[h],T+1))}return b}i.revive=d}),define(Q[62],Z([0,1,45,10,11,12,19,26,9]),function(z,i,C,D,P,R,L,I,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.splitName=i.unmnemonicLabel=i.mnemonicButtonLabel=i.mnemonicMenuLabel=i.template=i.shorten=i.untildify=i.tildify=i.normalizeDriveLetter=i.getBaseLabel=i.getPathLabel=void 0;function d(n,s,l){if(typeof n=="string"&&(n=c.URI.file(n)),l){const m=l.getWorkspaceFolder(n);if(m){const w=l.getWorkspace().folders.length>1;let O;if((0,L.isEqual)(m.uri,n)?O="":O=(0,L.relativePath)(m.uri,n),w){const N=m.name?m.name:(0,L.basename)(m.uri);O=O?N+" \u2022 "+O:N}return O}}if(n.scheme!==D.Schemas.file&&n.scheme!==D.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,C.hasDriveLetter)(n.fsPath))return(0,P.normalize)(T(n.fsPath));let f=(0,P.normalize)(n.fsPath);return!R.isWindows&&s?.userHome&&(f=S(f,s.userHome.fsPath)),f}i.getPathLabel=d;function b(n){if(!n)return;typeof n=="string"&&(n=c.URI.file(n));const s=(0,L.basename)(n)||(n.scheme===D.Schemas.file?n.fsPath:n.path);return R.isWindows&&(0,C.isRootOrDriveLetter)(s)?T(s):s}i.getBaseLabel=b;function T(n,s){return(0,C.hasDriveLetter)(n,s)?n.charAt(0).toUpperCase()+n.slice(1):n}i.normalizeDriveLetter=T;let h=Object.create(null);function S(n,s){if(R.isWindows||!n||!s)return n;let l=h.original===s?h.normalized:void 0;return l||(l=`${(0,I.rtrim)(s,P.posix.sep)}${P.posix.sep}`,h={original:s,normalized:l}),(R.isLinux?n.startsWith(l):(0,I.startsWithIgnoreCase)(n,l))&&(n=`~/${n.substr(l.length)}`),n}i.tildify=S;function y(n,s){return n.replace(/^~($|\/|\\)/,`${s}$1`)}i.untildify=y;const g="\u2026",a="\\\\",u="~";function v(n,s=P.sep){const l=new Array(n.length);let f=!1;for(let m=0;m<n.length;m++){let w=n[m];if(w===""){l[m]=`.${s}`;continue}if(!w){l[m]=w;continue}f=!0;let O="";w.indexOf(a)===0?(O=w.substr(0,w.indexOf(a)+a.length),w=w.substr(w.indexOf(a)+a.length)):w.indexOf(s)===0?(O=w.substr(0,w.indexOf(s)+s.length),w=w.substr(w.indexOf(s)+s.length)):w.indexOf(u)===0&&(O=w.substr(0,w.indexOf(u)+u.length),w=w.substr(w.indexOf(u)+u.length));const N=w.split(s);for(let q=1;f&&q<=N.length;q++)for(let J=N.length-q;f&&J>=0;J--){f=!1;let se=N.slice(J,J+q).join(s);for(let ie=0;!f&&ie<n.length;ie++)if(ie!==m&&n[ie]&&n[ie].indexOf(se)>-1){const te=J+q===N.length,ge=J>0&&n[ie].indexOf(s)>-1?s+se:se,B=n[ie].endsWith(ge);f=!te||B}if(!f){let ie="";(N[0].endsWith(":")||O!=="")&&(J===1&&(J=0,q++,se=N[0]+s+se),J>0&&(ie=N[0]+s),ie=O+ie),J>0&&(ie=ie+g+s),ie=ie+se,J+q<N.length&&(ie=ie+s+g),l[m]=ie}}f&&(l[m]=w)}return l}i.shorten=v;var E;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(E||(E={}));function p(n,s=Object.create(null)){const l=[];let f=!1,m="";for(const w of n)if(w==="$"||f&&w==="{")m&&l.push({value:m,type:E.TEXT}),m="",f=!0;else if(w==="}"&&f){const O=s[m];if(typeof O=="string")O.length&&l.push({value:O,type:E.VARIABLE});else if(O){const N=l[l.length-1];(!N||N.type!==E.SEPARATOR)&&l.push({value:O.label,type:E.SEPARATOR})}m="",f=!1}else m+=w;return m&&!f&&l.push({value:m,type:E.TEXT}),l.filter((w,O)=>{if(w.type===E.SEPARATOR){const N=l[O-1],q=l[O+1];return[N,q].every(J=>J&&(J.type===E.VARIABLE||J.type===E.TEXT)&&J.value.length>0)}return!0}).map(w=>w.value).join("")}i.template=p;function o(n,s){return R.isMacintosh||s?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):n.replace(/&&|&/g,l=>l==="&"?"&&":"&")}i.mnemonicMenuLabel=o;function t(n,s){return R.isMacintosh||s?n.replace(/\(&&\w\)|&&/g,""):R.isWindows?n.replace(/&&|&/g,l=>l==="&"?"&&":"&"):n.replace(/&&/g,"_")}i.mnemonicButtonLabel=t;function r(n){return n.replace(/&/g,"&&")}i.unmnemonicLabel=r;function e(n){const s=n.indexOf("/")!==-1?P.posix:P.win32,l=s.basename(n),f=s.dirname(n);return l.length?{name:l,parentPath:f}:{name:f,parentPath:""}}i.splitName=e}),define(Q[27],Z([0,1]),function(z,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.generateUuid=i.isUUID=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(c){return C.test(c)}i.isUUID=D;const P=new Uint8Array(16),R=[];for(let c=0;c<256;c++)R.push(c.toString(16).padStart(2,"0"));let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(c){for(let d=0;d<c.length;d++)c[d]=Math.floor(Math.random()*256);return c};function I(){L(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let c=0,d="";return d+=R[P[c++]],d+=R[P[c++]],d+=R[P[c++]],d+=R[P[c++]],d+="-",d+=R[P[c++]],d+=R[P[c++]],d+="-",d+=R[P[c++]],d+=R[P[c++]],d+="-",d+=R[P[c++]],d+=R[P[c++]],d+="-",d+=R[P[c++]],d+=R[P[c++]],d+=R[P[c++]],d+=R[P[c++]],d+=R[P[c++]],d+=R[P[c++]],d}i.generateUuid=I}),define(Q[63],Z([0,1,131]),function(z,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineDecoder=void 0;class D{constructor(R="utf8"){this.stringDecoder=new C.StringDecoder(R),this.remaining=null}write(R){const L=[],I=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(I.length<1)return L;let c=0,d,b=c;for(;b<I.length;)if(d=I.charCodeAt(b),d===13||d===10){if(L.push(I.substring(c,b)),b++,b<I.length){const T=d;d=I.charCodeAt(b),(T===13&&d===10||T===10&&d===13)&&b++}c=b}else b++;return this.remaining=c<I.length?I.substr(c):null,L}end(){return this.remaining}}i.LineDecoder=D}),define(Q[64],Z([0,1,33,11,15]),function(z,i,C,D,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getFirstAvailablePowerShellInstallation=i.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,L=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var c;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(c||(c={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class T{constructor(o,t,r){this.exePath=o,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await P.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function h({useAlternateBitness:p=!1}={}){return p?d===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:p=!1,findPreview:o=!1}={}){const t=h({useAlternateBitness:p});if(!t)return null;const r=D.join(t,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(r))return null;let e=-1,n=null;for(const f of await P.Promises.readdir(r)){let m=-1;if(o){const O=f.indexOf("-");if(O<0)continue;const N=f.substring(0,O);if(!R.test(N)||f.substring(O+1)!=="preview")continue;m=parseInt(N,10)}else{if(!R.test(f))continue;m=parseInt(f,10)}if(m<=e)continue;const w=D.join(r,f,"pwsh.exe");!await P.SymlinkSupport.existsFile(w)||(n=w,e=m)}if(!n)return null;const s=t.includes("x86")?" (x86)":"",l=o?" Preview":"";return new T(n,`PowerShell${l}${s}`,!0)}async function y({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const o=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=p?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const e of await P.Promises.readdir(o))if(t.test(e)){const n=D.join(o,e,"pwsh.exe");return new T(n,r)}return null}function g(){const p=D.join(C.homedir(),".dotnet","tools","pwsh.exe");return new T(p,".NET Core PowerShell Global Tool")}function a(){const p=D.join(process.env.windir,d===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new T(p,"Windows PowerShell",!0)}async function*u(){let p=await S();p&&(yield p),p=await S({useAlternateBitness:!0}),p&&(yield p),p=await y(),p&&(yield p),p=g(),p&&(yield p),p=await S({findPreview:!0}),p&&(yield p),p=await y({findPreview:!0}),p&&(yield p),p=await S({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=a(),p&&(yield p)}async function*v(){for await(const p of u())await p.exists()&&(yield p)}i.enumeratePowerShellInstallations=v;async function E(){for await(const p of v())return p;return null}i.getFirstAvailablePowerShellInstallation=E});var pe=this&&this.__decorate||function(z,i,C,D){var P=arguments.length,R=P<3?i:D===null?D=Object.getOwnPropertyDescriptor(i,C):D,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(z,i,C,D);else for(var I=z.length-1;I>=0;I--)(L=z[I])&&(R=(P<3?L(R):P>3?L(i,C,R):L(i,C))||R);return P>3&&R&&Object.defineProperty(i,C,R),R};define(Q[46],Z([0,1,18,3,17,24,44,7,6,2,61,26,8]),function(z,i,C,D,P,R,L,I,c,d,b,T,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IPCLogger=i.logWithColors=i.ProxyChannel=i.StaticRouter=i.getNextTickChannel=i.getDelayedChannel=i.IPCClient=i.IPCServer=i.ChannelClient=i.RequestInitiator=i.ChannelServer=i.ResponseType=i.RequestType=void 0;var S;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(S=i.RequestType||(i.RequestType={}));function y(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(g=i.ResponseType||(i.ResponseType={}));function a(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(u||(u={}));class v{constructor(A){this.buffer=A,this.pos=0}read(A){const W=this.buffer.slice(this.pos,this.pos+A);return this.pos+=W.byteLength,W}}class E{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var p;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(p||(p={}));function o(M){const A=P.VSBuffer.alloc(4);return A.writeUInt32BE(M,0),A}function t(M){return M.read(4).readUInt32BE(0)}function r(M){const A=P.VSBuffer.alloc(1);return A.writeUInt8(M,0),A}const e={Undefined:r(p.Undefined),String:r(p.String),Buffer:r(p.Buffer),VSBuffer:r(p.VSBuffer),Array:r(p.Array),Object:r(p.Object)},n=typeof Buffer!="undefined";function s(M,A){if(typeof A=="undefined")M.write(e.Undefined);else if(typeof A=="string"){const W=P.VSBuffer.fromString(A);M.write(e.String),M.write(o(W.byteLength)),M.write(W)}else if(n&&Buffer.isBuffer(A)){const W=P.VSBuffer.wrap(A);M.write(e.Buffer),M.write(o(W.byteLength)),M.write(W)}else if(A instanceof P.VSBuffer)M.write(e.VSBuffer),M.write(o(A.byteLength)),M.write(A);else if(Array.isArray(A)){M.write(e.Array),M.write(o(A.length));for(const W of A)s(M,W)}else{const W=P.VSBuffer.fromString(JSON.stringify(A));M.write(e.Object),M.write(o(W.byteLength)),M.write(W)}}function l(M){switch(M.read(1).readUInt8(0)){case p.Undefined:return;case p.String:return M.read(t(M)).toString();case p.Buffer:return M.read(t(M)).buffer;case p.VSBuffer:return M.read(t(M));case p.Array:{const W=t(M),H=[];for(let ne=0;ne<W;ne++)H.push(l(M));return H}case p.Object:return JSON.parse(M.read(t(M)).toString())}}class f{constructor(A,W,H=null,ne=1e3){this.protocol=A,this.ctx=W,this.logger=H,this.timeoutDelay=ne,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(A,W){this.channels.set(A,W),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const W=this.send([A.type]);this.logger&&this.logger.logOutgoing(W,0,1,a(A.type));return}case 201:case 202:case 204:case 203:{const W=this.send([A.type,A.id],A.data);this.logger&&this.logger.logOutgoing(W,A.id,1,a(A.type),A.data);return}}}send(A,W=void 0){const H=new E;return s(H,A),s(H,W),this.sendBuffer(H.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onRawMessage(A){const W=new v(A),H=l(W),ne=l(W),K=H[0];switch(K){case 100:return this.logger&&this.logger.logIncoming(A.byteLength,H[1],1,`${y(K)}: ${H[2]}.${H[3]}`,ne),this.onPromise({type:K,id:H[1],channelName:H[2],name:H[3],arg:ne});case 102:return this.logger&&this.logger.logIncoming(A.byteLength,H[1],1,`${y(K)}: ${H[2]}.${H[3]}`,ne),this.onEventListen({type:K,id:H[1],channelName:H[2],name:H[3],arg:ne});case 101:return this.logger&&this.logger.logIncoming(A.byteLength,H[1],1,`${y(K)}`),this.disposeActiveRequest({type:K,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(A.byteLength,H[1],1,`${y(K)}`),this.disposeActiveRequest({type:K,id:H[1]})}}onPromise(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const H=new R.CancellationTokenSource;let ne;try{ne=W.call(this.ctx,A.name,A.arg,H.token)}catch(G){ne=Promise.reject(G)}const K=A.id;ne.then(G=>{this.sendResponse({id:K,data:G,type:201}),this.activeRequests.delete(A.id)},G=>{G instanceof Error?this.sendResponse({id:K,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.sendResponse({id:K,data:G,type:203}),this.activeRequests.delete(A.id)});const ee=(0,d.toDisposable)(()=>H.cancel());this.activeRequests.set(A.id,ee)}onEventListen(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const H=A.id,K=W.listen(this.ctx,A.name,A.arg)(ee=>this.sendResponse({id:H,data:ee,type:204}));this.activeRequests.set(A.id,K)}disposeActiveRequest(A){const W=this.activeRequests.get(A.id);W&&(W.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let W=this.pendingRequests.get(A.channelName);W||(W=[],this.pendingRequests.set(A.channelName,W));const H=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:A,timeoutTimer:H})}flushPendingRequests(A){const W=this.pendingRequests.get(A);if(W){for(const H of W)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(A=>A.dispose()),this.activeRequests.clear()}}i.ChannelServer=f;var m;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(m=i.RequestInitiator||(i.RequestInitiator={}));class w{constructor(A,W=null){this.protocol=A,this.isDisposed=!1,this.state=u.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=W}getChannel(A){const W=this;return{call(H,ne,K){return W.isDisposed?Promise.reject(I.canceled()):W.requestPromise(A,H,ne,K)},listen(H,ne){return W.isDisposed?Promise.reject(I.canceled()):W.requestEvent(A,H,ne)}}}requestPromise(A,W,H,ne=R.CancellationToken.None){const K=this.lastRequestId++,G={id:K,type:100,channelName:A,name:W,arg:H};if(ne.isCancellationRequested)return Promise.reject(I.canceled());let ae;return new Promise((k,x)=>{if(ne.isCancellationRequested)return x(I.canceled());const j=()=>{const fe=ye=>{switch(ye.type){case 201:this.handlers.delete(K),k(ye.data);break;case 202:{this.handlers.delete(K);const le=new Error(ye.data.message);le.stack=ye.data.stack,le.name=ye.data.name,x(le);break}case 203:this.handlers.delete(K),x(ye.data);break}};this.handlers.set(K,fe),this.sendRequest(G)};let Y=null;this.state===u.Idle?j():(Y=(0,D.createCancelablePromise)(fe=>this.whenInitialized()),Y.then(()=>{Y=null,j()}));const X=()=>{Y?(Y.cancel(),Y=null):this.sendRequest({id:K,type:101}),x(I.canceled())},he=ne.onCancellationRequested(X);ae=(0,d.combinedDisposable)((0,d.toDisposable)(X),he),this.activeRequests.add(ae)}).finally(()=>{this.activeRequests.delete(ae)})}requestEvent(A,W,H){const ne=this.lastRequestId++,ee={id:ne,type:102,channelName:A,name:W,arg:H};let G=null;const ae=new c.Emitter({onFirstListenerAdd:()=>{G=(0,D.createCancelablePromise)(k=>this.whenInitialized()),G.then(()=>{G=null,this.activeRequests.add(ae),this.sendRequest(ee)})},onLastListenerRemove:()=>{G?(G.cancel(),G=null):(this.activeRequests.delete(ae),this.sendRequest({id:ne,type:103}))}}),U=k=>ae.fire(k.data);return this.handlers.set(ne,U),ae.event}sendRequest(A){switch(A.type){case 100:case 102:{const W=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger&&this.logger.logOutgoing(W,A.id,0,`${y(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const W=this.send([A.type,A.id]);this.logger&&this.logger.logOutgoing(W,A.id,0,y(A.type));return}}}send(A,W=void 0){const H=new E;return s(H,A),s(H,W),this.sendBuffer(H.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onBuffer(A){const W=new v(A),H=l(W),ne=l(W),K=H[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(A.byteLength,0,0,a(K)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(A.byteLength,H[1],0,a(K),ne),this.onResponse({type:H[0],id:H[1],data:ne})}}onResponse(A){if(A.type===200){this.state=u.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(A.id);W&&W(A)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(A=>A.dispose()),this.activeRequests.clear()}}pe([L.memoize],w.prototype,"onDidInitializePromise",null),i.ChannelClient=w;class O{constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:W,onDidClientDisconnect:H})=>{c.Event.once(W.onMessage)(K=>{const ee=new v(K),G=l(ee),ae=new f(W,G),U=new w(W);this.channels.forEach((x,j)=>ae.registerChannel(j,x));const k={channelServer:ae,channelClient:U,ctx:G};this._connections.add(k),this._onDidAddConnection.fire(k),H(()=>{ae.dispose(),U.dispose(),this._connections.delete(k),this._onDidRemoveConnection.fire(k)})})})}get connections(){const A=[];return this._connections.forEach(W=>A.push(W)),A}getChannel(A,W){const H=this;return{call(ne,K,ee){let G;if((0,h.isFunction)(W)){let U=(0,C.getRandomElement)(H.connections.filter(W));G=U?Promise.resolve(U):c.Event.toPromise(c.Event.filter(H.onDidAddConnection,W))}else G=W.routeCall(H,ne,K);const ae=G.then(U=>U.channelClient.getChannel(A));return q(ae).call(ne,K,ee)},listen(ne,K){if((0,h.isFunction)(W))return H.getMulticastEvent(A,W,ne,K);const ee=W.routeEvent(H,ne,K).then(G=>G.channelClient.getChannel(A));return q(ee).listen(ne,K)}}}getMulticastEvent(A,W,H,ne){const K=this;let ee=new d.DisposableStore;const G=new c.Emitter({onFirstListenerAdd:()=>{ee=new d.DisposableStore;const ae=new c.EventMultiplexer,U=new Map,k=j=>{const X=j.channelClient.getChannel(A).listen(H,ne),he=ae.add(X);U.set(j,he)},x=j=>{const Y=U.get(j);!Y||(Y.dispose(),U.delete(j))};K.connections.filter(W).forEach(k),c.Event.filter(K.onDidAddConnection,W)(k,void 0,ee),K.onDidRemoveConnection(x,void 0,ee),ae.event(G.fire,G,ee),ee.add(ae)},onLastListenerRemove:()=>{ee.dispose()}});return G.event}registerChannel(A,W){this.channels.set(A,W),this._connections.forEach(H=>{H.channelServer.registerChannel(A,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}i.IPCServer=O;class N{constructor(A,W,H=null){const ne=new E;s(ne,W),A.send(ne.buffer),this.channelClient=new w(A,H),this.channelServer=new f(A,W,H)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,W){this.channelServer.registerChannel(A,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}i.IPCClient=N;function q(M){return{call(A,W,H){return M.then(ne=>ne.call(A,W,H))},listen(A,W){const H=new c.Relay;return M.then(ne=>H.input=ne.listen(A,W)),H.event}}}i.getDelayedChannel=q;function J(M){let A=!1;return{call(W,H,ne){return A?M.call(W,H,ne):(0,D.timeout)(0).then(()=>A=!0).then(()=>M.call(W,H,ne))},listen(W,H){if(A)return M.listen(W,H);const ne=new c.Relay;return(0,D.timeout)(0).then(()=>A=!0).then(()=>ne.input=M.listen(W,H)),ne.event}}}i.getNextTickChannel=J;class se{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const W of A.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await c.Event.toPromise(A.onDidAddConnection),await this.route(A)}}i.StaticRouter=se;var ie;(function(M){function A(K,ee){const G=K,ae=ee&&ee.disableMarshalling,U=new Map;for(const k in G)H(k)&&U.set(k,c.Event.buffer(G[k],!0));return new class{listen(k,x,j){const Y=U.get(x);if(Y)return Y;if(ne(x)){const X=G[x];if(typeof X=="function")return X.call(G,j)}throw new Error(`Event not found: ${x}`)}call(k,x,j){const Y=G[x];if(typeof Y=="function"){if(!ae&&Array.isArray(j))for(let X=0;X<j.length;X++)j[X]=(0,b.revive)(j[X]);return Y.apply(G,j)}throw new Error(`Method not found: ${x}`)}}}M.fromService=A;function W(K,ee){const G=ee&&ee.disableMarshalling;return new Proxy({},{get(ae,U){if(typeof U=="string")return ee?.properties?.has(U)?ee.properties.get(U):ne(U)?function(k){return K.listen(U,k)}:H(U)?K.listen(U):async function(...k){let x;ee&&!(0,h.isUndefinedOrNull)(ee.context)?x=[ee.context,...k]:x=k;const j=await K.call(U,x);return G?j:(0,b.revive)(j)};throw new Error(`Property not found: ${String(U)}`)}})}M.toService=W;function H(K){return K[0]==="o"&&K[1]==="n"&&T.isUpperAsciiLetter(K.charCodeAt(2))}function ne(K){return/^onDynamic/.test(K)&&T.isUpperAsciiLetter(K.charCodeAt(9))}})(ie=i.ProxyChannel||(i.ProxyChannel={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let A=M.toString();if(A!=="[object Object]")return A}return M}function B(M){return Array.isArray(M)?M.map(ge):ge(M)}function _(M,A,W,H,ne,K,ee){ee=B(ee);const G=te[ne],ae=G[H%G.length];let U=[`%c[${M}]%c[${String(A).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${ae}`];/\($/.test(K)?(U=U.concat(ee),U.push(")")):U.push(ee),console.log.apply(console,U)}i.logWithColors=_;class re{constructor(A,W){this._outgoingPrefix=A,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,W,H,ne,K){this._totalOutgoing+=A,_(this._outgoingPrefix,this._totalOutgoing,A,W,H,ne,K)}logIncoming(A,W,H,ne,K){this._totalIncoming+=A,_(this._incomingPrefix,this._totalIncoming,A,W,H,ne,K)}}i.IPCLogger=re}),define(Q[65],Z([0,1,3,6,2,8]),function(z,i,C,D,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InMemoryStorageDatabase=i.Storage=i.isStorageItemsChangeEvent=i.StorageHint=void 0;var L;(function(T){T[T.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(L=i.StorageHint||(i.StorageHint={}));function I(T){const h=T;return h?.changed instanceof Map||h?.deleted instanceof Set}i.isStorageItemsChangeEvent=I;var c;(function(T){T[T.None=0]="None",T[T.Initialized=1]="Initialized",T[T.Closed=2]="Closed"})(c||(c={}));class d extends P.Disposable{constructor(h,S=Object.create(null)){super();this.database=h,this.options=S,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=new C.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){h.changed?.forEach((S,y)=>this.accept(y,S)),h.deleted?.forEach(S=>this.accept(S,void 0))}accept(h,S){if(this.state===c.Closed)return;let y=!1;(0,R.isUndefinedOrNull)(S)?y=this.cache.delete(h):this.cache.get(h)!==S&&(this.cache.set(h,S),y=!0),y&&this._onDidChangeStorage.fire(h)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,S){const y=this.cache.get(h);return(0,R.isUndefinedOrNull)(y)?S:y}getBoolean(h,S){const y=this.get(h);return(0,R.isUndefinedOrNull)(y)?S:y==="true"}getNumber(h,S){const y=this.get(h);return(0,R.isUndefinedOrNull)(y)?S:parseInt(y,10)}async set(h,S){if(this.state===c.Closed)return;if((0,R.isUndefinedOrNull)(S))return this.delete(h);const y=String(S);if(this.cache.get(h)!==y)return this.cache.set(h,y),this.pendingInserts.set(h,y),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async delete(h){if(!(this.state===c.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(h){if(!!this.hasPending)return this.doFlush(h)}async doFlush(h){return this.flushDelayer.trigger(()=>this.flushPending(),h)}async whenFlushed(){if(!!this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}dispose(){this.flushDelayer.dispose(),super.dispose()}}i.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class b{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert&&h.insert.forEach((S,y)=>this.items.set(y,S)),h.delete&&h.delete.forEach(S=>this.items.delete(S))}async close(){}}i.InMemoryStorageDatabase=b}),define(Q[66],Z([4,5]),function(z,i){return z.create("vs/base/common/date",i)}),define(Q[67],Z([0,1,66]),function(z,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toLocalISOString=i.fromNow=void 0;const D=60,P=D*60,R=P*24,L=R*7,I=R*30,c=R*365;function d(T,h,S){typeof T!="number"&&(T=T.getTime());const y=Math.round((new Date().getTime()-T)/1e3);if(y<-30)return(0,C.localize)(0,null,d(new Date().getTime()+y*1e3,!1));if(y<30)return(0,C.localize)(1,null);let g;return y<D?(g=y,h?g===1?S?(0,C.localize)(2,null,g):(0,C.localize)(3,null,g):S?(0,C.localize)(4,null,g):(0,C.localize)(5,null,g):g===1?S?(0,C.localize)(6,null,g):(0,C.localize)(7,null,g):S?(0,C.localize)(8,null,g):(0,C.localize)(9,null,g)):y<P?(g=Math.floor(y/D),h?g===1?S?(0,C.localize)(10,null,g):(0,C.localize)(11,null,g):S?(0,C.localize)(12,null,g):(0,C.localize)(13,null,g):g===1?S?(0,C.localize)(14,null,g):(0,C.localize)(15,null,g):S?(0,C.localize)(16,null,g):(0,C.localize)(17,null,g)):y<R?(g=Math.floor(y/P),h?g===1?S?(0,C.localize)(18,null,g):(0,C.localize)(19,null,g):S?(0,C.localize)(20,null,g):(0,C.localize)(21,null,g):g===1?S?(0,C.localize)(22,null,g):(0,C.localize)(23,null,g):S?(0,C.localize)(24,null,g):(0,C.localize)(25,null,g)):y<L?(g=Math.floor(y/R),h?g===1?(0,C.localize)(26,null,g):(0,C.localize)(27,null,g):g===1?(0,C.localize)(28,null,g):(0,C.localize)(29,null,g)):y<I?(g=Math.floor(y/L),h?g===1?S?(0,C.localize)(30,null,g):(0,C.localize)(31,null,g):S?(0,C.localize)(32,null,g):(0,C.localize)(33,null,g):g===1?S?(0,C.localize)(34,null,g):(0,C.localize)(35,null,g):S?(0,C.localize)(36,null,g):(0,C.localize)(37,null,g)):y<c?(g=Math.floor(y/I),h?g===1?S?(0,C.localize)(38,null,g):(0,C.localize)(39,null,g):S?(0,C.localize)(40,null,g):(0,C.localize)(41,null,g):g===1?S?(0,C.localize)(42,null,g):(0,C.localize)(43,null,g):S?(0,C.localize)(44,null,g):(0,C.localize)(45,null,g)):(g=Math.floor(y/c),h?g===1?S?(0,C.localize)(46,null,g):(0,C.localize)(47,null,g):S?(0,C.localize)(48,null,g):(0,C.localize)(49,null,g):g===1?S?(0,C.localize)(50,null,g):(0,C.localize)(51,null,g):S?(0,C.localize)(52,null,g):(0,C.localize)(53,null,g))}i.fromNow=d;function b(T){return T.getFullYear()+"-"+String(T.getMonth()+1).padStart(2,"0")+"-"+String(T.getDate()).padStart(2,"0")+"T"+String(T.getHours()).padStart(2,"0")+":"+String(T.getMinutes()).padStart(2,"0")+":"+String(T.getSeconds()).padStart(2,"0")+"."+(T.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}i.toLocalISOString=b}),define(Q[68],Z([4,5]),function(z,i){return z.create("vs/base/common/errorMessage",i)}),define(Q[28],Z([0,1,18,8,68]),function(z,i,C,D,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toErrorMessage=void 0;function R(d,b){return b&&(d.stack||d.stacktrace)?P.localize(0,null,I(d),L(d.stack)||L(d.stacktrace)):I(d)}function L(d){return Array.isArray(d)?d.join(`
`):d}function I(d){return typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?P.localize(1,null,d.message):d.message||P.localize(2,null)}function c(d=null,b=!1){if(!d)return P.localize(3,null);if(Array.isArray(d)){const T=C.coalesce(d),h=c(T[0],b);return T.length>1?P.localize(4,null,h,T.length):h}if(D.isString(d))return d;if(d.detail){const T=d.detail;if(T.error)return R(T.error,b);if(T.exception)return R(T.exception,b)}return d.stack?R(d,b):d.message?d.message:P.localize(5,null)}i.toErrorMessage=c}),define(Q[69],Z([4,5]),function(z,i){return z.create("vs/base/node/processes",i)}),define(Q[47],Z([0,1,38,45,10,22,11,12,29,57,8,63,15,69]),function(z,i,C,D,P,R,L,I,c,d,b,T,h,S){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.win32=i.createQueuedSender=i.LineProcess=i.AbstractProcess=i.getWindowsShell=i.removeDangerousEnvVariables=i.TerminateResponseCode=i.Source=void 0,Object.defineProperty(i,"Source",{enumerable:!0,get:function(){return d.Source}}),Object.defineProperty(i,"TerminateResponseCode",{enumerable:!0,get:function(){return d.TerminateResponseCode}});function y(t){switch(t){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(t,r){if(I.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};r&&(e.cwd=r);const n=C.execFile("taskkill",["/T","/F","/PID",t.pid.toString()],e);return new Promise(s=>{n.once("error",l=>{s({success:!1,error:l})}),n.once("exit",(l,f)=>{s(l===0?{success:!0}:{success:!1,code:l!==null?l:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?y(e.status):1})}else if(I.isLinux||I.isMacintosh)try{const e=P.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",z).fsPath;return new Promise(n=>{C.execFile(e,[t.pid.toString()],{encoding:"utf8",shell:!0},(s,l,f)=>{n(s?{success:!1,error:s}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else t.kill("SIGKILL");return Promise.resolve({success:!0})}function a(t){!t||(delete t.DEBUG,I.isMacintosh&&delete t.DYLD_LIBRARY_PATH,I.isLinux&&delete t.LD_PRELOAD)}i.removeDangerousEnvVariables=a;function u(t=c.env){return t.comspec||"cmd.exe"}i.getWindowsShell=u;class v{constructor(r,e,n,s){if(e!==void 0&&n!==void 0&&s!==void 0)this.cmd=r,this.args=e,this.shell=n,this.options=s;else{const l=r;this.cmd=l.command,this.shell=l.isShellCommand,this.args=l.args.slice(0),this.options=l.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const l=Object.create(null);Object.keys(c.env).forEach(f=>{l[f]=c.env[f]}),Object.keys(this.options.env).forEach(f=>{l[f]=this.options.env[f]}),this.options.env=l}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const e=r.lastIndexOf(L.sep);return e!==-1&&(r=r.substring(e+1)),v.WellKnowCommands[r]?r:"other"}start(r){return I.isWindows&&(this.options&&this.options.cwd&&D.isUNC(this.options.cwd)||!this.options&&D.isUNC(c.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(e=>{let n,s;const l=new Promise((f,m)=>{n=f,s=m});if(e){let f=this.cmd;this.args&&(f=f+" "+this.args.join(" ")),this.childProcess=C.exec(f,this.options,(m,w,O)=>{this.childProcess=null;const N=m;N&&N.killed?s({killed:this.terminateRequested,stdout:w.toString(),stderr:O.toString()}):this.handleExec(n,r,m,w,O)})}else{let f=null;const m=w=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(w,n,r,s);const O={terminated:this.terminateRequested};b.isNumber(w)&&(O.cmdCode=w),n(O)};if(this.shell&&I.isWindows){const w=R.deepClone(this.options);w.windowsVerbatimArguments=!0,w.detached=!1;let O=!1,N=!1;const q=[];let J=this.ensureQuotes(this.cmd);q.push(J.value),O=J.quoted,this.args&&this.args.forEach(ie=>{J=this.ensureQuotes(ie),q.push(J.value),N=N&&J.quoted});const se=["/s","/c"];O?N?se.push('"'+q.join(" ")+'"'):q.length>1?se.push('"'+q[0]+'" '+q.slice(1).join(" ")):se.push('"'+q[0]+'"'):se.push(q.join(" ")),f=C.spawn(u(),se,w)}else this.cmd&&(f=C.spawn(this.cmd,this.args,this.options));f&&(this.childProcess=f,this.childProcessPromise=Promise.resolve(f),this.pidResolve&&(this.pidResolve(b.isNumber(f.pid)?f.pid:-1),this.pidResolve=void 0),f.on("error",w=>{this.childProcess=null,s({terminated:this.terminateRequested,error:w})}),f.pid&&(this.childProcess.on("close",m),this.handleSpawn(f,n,r,s,!0)))}return l})}handleClose(r,e,n,s){}ensureQuotes(r){return v.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,g(r,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!I.isWindows)return r(!1);const e=C.spawn(u(),["/s","/c"]);e.on("error",n=>r(!0)),e.on("exit",n=>r(!1))})}}i.AbstractProcess=v,v.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},v.regexp=/^[^"].* .*[^"]/;class E extends v{constructor(r,e,n,s){super(r,e,n,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,e,n,s,l){[s,l].forEach((f,m)=>{const w=new T.LineDecoder;w.write(f).forEach(q=>{e({line:q,source:m===0?0:1})});const N=w.end();N&&e({line:N,source:m===0?0:1})}),r({terminated:this.terminateRequested,error:n})}handleSpawn(r,e,n,s,l){const f=new T.LineDecoder,m=new T.LineDecoder;r.stdout.on("data",w=>{f.write(w).forEach(N=>n({line:N,source:0}))}),r.stderr.on("data",w=>{m.write(w).forEach(N=>n({line:N,source:1}))}),this.stdoutLineDecoder=f,this.stderrLineDecoder=m}handleClose(r,e,n,s){const l=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;l&&n({line:l,source:0});const f=this.stderrLineDecoder?this.stderrLineDecoder.end():null;f&&n({line:f,source:1})}}i.LineProcess=E;function p(t){let r=[],e=!1;const n=function(s){if(e){r.push(s);return}(!t.send(s,f=>{if(f&&console.error(f),e=!1,r.length>0){const m=r.slice(0);r=[],m.forEach(w=>n(w))}})||I.isWindows)&&(e=!0)};return{send:n}}i.createQueuedSender=p;var o;(function(t){async function r(e,n,s){if(L.isAbsolute(e))return e;if(n===void 0&&(n=c.cwd()),L.dirname(e)!=="."||(s===void 0&&b.isString(c.env.PATH)&&(s=c.env.PATH.split(L.delimiter)),s===void 0||s.length===0))return L.join(n,e);async function f(m){if(await h.Promises.exists(m)){let w;try{w=await h.Promises.stat(m)}catch(O){O.message.startsWith("EACCES")&&(w=await h.Promises.lstat(m))}return w?!w.isDirectory():!1}return!1}for(let m of s){let w;if(L.isAbsolute(m)?w=L.join(m,e):w=L.join(n,m,e),await f(w))return w;let O=w+".com";if(await f(O)||(O=w+".exe",await f(O)))return O}return L.join(n,e)}t.findExecutable=r})(o=i.win32||(i.win32={}))}),define(Q[70],Z([0,1,33,12,64,47]),function(z,i,C,D,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSystemShellSync=i.getSystemShell=void 0;async function L(S,y){return S===1?D.isWindows?T():R.getWindowsShell(y):d(S,y)}i.getSystemShell=L;function I(S,y){return S===1?D.isWindows?h(y):R.getWindowsShell(y):d(S,y)}i.getSystemShellSync=I;let c=null;function d(S,y){if(D.isLinux&&S===2||D.isMacintosh&&S===3)return"/bin/bash";if(!c){let g;if(D.isWindows)g="/bin/bash";else{if(g=y.SHELL,!g)try{g=(0,C.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}c=g}return c}let b=null;async function T(){return b||(b=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),b}function h(S){if(b)return b;const y=D.isWindows&&parseFloat((0,C.release)())>=10,g=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),a=`${S.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return y?a:R.getWindowsShell(S)}}),define(Q[71],Z([0,1,38,3,17,24,60,7,6,2,22,47,46]),function(z,i,C,D,P,R,L,I,c,d,b,T,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Client=i.Server=void 0;class S extends h.ChannelServer{constructor(a){super({send:u=>{try{process.send&&process.send(u.buffer.toString("base64"))}catch{}},onMessage:c.Event.fromNodeEventEmitter(process,"message",u=>P.VSBuffer.wrap(Buffer.from(u,"base64")))},a);process.once("disconnect",()=>this.dispose())}}i.Server=S;class y{constructor(a,u){this.modulePath=a,this.options=u,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new c.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=u&&u.timeout?u.timeout:6e4;this.disposeDelayer=new D.Delayer(v),this.child=null,this._client=null}getChannel(a){const u=this;return{call(v,E,p){return u.requestPromise(a,v,E,p)},listen(v,E){return u.requestEvent(a,v,E)}}}requestPromise(a,u,v,E=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const p=this.getCachedChannel(a),o=(0,D.createCancelablePromise)(e=>p.call(u,v,e)),t=E.onCancellationRequested(()=>o.cancel()),r=(0,d.toDisposable)(()=>o.cancel());return this.activeRequests.add(r),o.finally(()=>{t.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),o}requestEvent(a,u,v){if(!this.disposeDelayer)return c.Event.None;this.disposeDelayer.cancel();let E;const p=new c.Emitter({onFirstListenerAdd:()=>{E=this.getCachedChannel(a).listen(u,v)(p.fire,p),this.activeRequests.add(E)},onLastListenerRemove:()=>{this.activeRequests.delete(E),E.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return p.event}get client(){if(!this._client){const a=this.options&&this.options.args?this.options.args:[],u=Object.create(null);u.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(u.env={...u.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(u.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,T.removeDangerousEnvVariables)(u.env),this.child=(0,C.fork)(this.modulePath,a,u);const v=new c.Emitter;c.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,L.isRemoteConsoleLog)(n)){(0,L.log)(n,`IPC Library: ${this.options.serverName}`);return}v.fire(P.VSBuffer.wrap(Buffer.from(n,"base64")))});const p=this.options.useQueue?(0,T.createQueuedSender)(this.child):this.child,o=n=>this.child&&this.child.connected&&p.send(n.buffer.toString("base64")),t=v.event,r={send:o,onMessage:t};this._client=new h.ChannelClient(r);const e=()=>this.disposeClient();process.once("exit",e),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,s)=>{process.removeListener("exit",e),this.activeRequests.forEach(l=>(0,d.dispose)(l)),this.activeRequests.clear(),n!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:s})})}return this._client}getCachedChannel(a){let u=this.channels.get(a);return u||(u=this.client.getChannel(a),this.channels.set(a,u)),u}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}i.Client=y}),define(Q[72],Z([4,5]),function(z,i){return z.create("vs/base/node/zip",i)}),define(Q[73],Z([4,5]),function(z,i){return z.create("vs/platform/configuration/common/configurationRegistry",i)}),define(Q[74],Z([4,5]),function(z,i){return z.create("vs/platform/environment/node/shellEnv",i)}),define(Q[75],Z([4,5]),function(z,i){return z.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",i)}),define(Q[76],Z([4,5]),function(z,i){return z.create("vs/platform/extensionManagement/common/extensionManagement",i)}),define(Q[77],Z([4,5]),function(z,i){return z.create("vs/platform/extensionManagement/common/extensionManagementCLIService",i)}),define(Q[78],Z([4,5]),function(z,i){return z.create("vs/platform/extensionManagement/node/extensionManagementService",i)}),define(Q[79],Z([4,5]),function(z,i){return z.create("vs/platform/extensionManagement/node/extensionManagementUtil",i)}),define(Q[80],Z([4,5]),function(z,i){return z.create("vs/platform/extensionManagement/node/extensionsScanner",i)}),define(Q[81],Z([4,5]),function(z,i){return z.create("vs/platform/extensions/common/extensionValidator",i)}),define(Q[82],Z([4,5]),function(z,i){return z.create("vs/platform/files/common/fileService",i)}),define(Q[83],Z([4,5]),function(z,i){return z.create("vs/platform/files/common/io",i)}),define(Q[84],Z([4,5]),function(z,i){return z.create("vs/platform/files/node/diskFileSystemProvider",i)}),define(Q[85],Z([4,5]),function(z,i){return z.create("vs/platform/request/common/request",i)}),define(Q[86],Z([4,5]),function(z,i){return z.create("vs/platform/telemetry/common/telemetryService",i)}),define(Q[87],Z([0,1,67,44,10,11,29,19,9]),function(z,i,C,D,P,R,L,I,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parsePtyHostPort=i.parseSearchPort=i.parseExtensionHostPort=i.AbstractNativeEnvironmentService=void 0;class d{constructor(g,a,u){this._args=g,this.paths=a,this.productService=u}get appRoot(){return(0,R.dirname)(P.FileAccess.asFileUri("",z).fsPath)}get userHome(){return c.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return c.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return c.URI.file(this.paths.tmpDir)}get cacheHome(){return c.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return c.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(c.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return c.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return c.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=L.env.VSCODE_PORTABLE;return g?c.URI.file((0,R.join)(g,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,I.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return c.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,R.resolve)(g):(0,R.normalize)((0,R.join)(P.FileAccess.asFileUri("",z).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?(0,R.resolve)(g):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,R.resolve)(g);const a=L.env.VSCODE_EXTENSIONS;if(a)return a;const u=L.env.VSCODE_PORTABLE;return u?(0,R.join)(u,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(a=>/^[^:/?#]+?:\/\//.test(a)?c.URI.parse(a):c.URI.file((0,R.normalize)(a)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?c.URI.parse(g):c.URI.file((0,R.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,I.joinPath)(c.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return c.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}pe([D.memoize],d.prototype,"appRoot",null),pe([D.memoize],d.prototype,"userHome",null),pe([D.memoize],d.prototype,"userDataPath",null),pe([D.memoize],d.prototype,"appSettingsHome",null),pe([D.memoize],d.prototype,"tmpDir",null),pe([D.memoize],d.prototype,"cacheHome",null),pe([D.memoize],d.prototype,"userRoamingDataHome",null),pe([D.memoize],d.prototype,"settingsResource",null),pe([D.memoize],d.prototype,"userDataSyncHome",null),pe([D.memoize],d.prototype,"userDataSyncLogResource",null),pe([D.memoize],d.prototype,"sync",null),pe([D.memoize],d.prototype,"machineSettingsResource",null),pe([D.memoize],d.prototype,"globalStorageHome",null),pe([D.memoize],d.prototype,"workspaceStorageHome",null),pe([D.memoize],d.prototype,"keybindingsResource",null),pe([D.memoize],d.prototype,"keyboardLayoutResource",null),pe([D.memoize],d.prototype,"argvResource",null),pe([D.memoize],d.prototype,"snippetsHome",null),pe([D.memoize],d.prototype,"isExtensionDevelopment",null),pe([D.memoize],d.prototype,"untitledWorkspacesHome",null),pe([D.memoize],d.prototype,"installSourcePath",null),pe([D.memoize],d.prototype,"builtinExtensionsPath",null),pe([D.memoize],d.prototype,"extensionsPath",null),pe([D.memoize],d.prototype,"extensionDevelopmentLocationURI",null),pe([D.memoize],d.prototype,"extensionDevelopmentKind",null),pe([D.memoize],d.prototype,"extensionTestsLocationURI",null),pe([D.memoize],d.prototype,"debugExtensionHost",null),pe([D.memoize],d.prototype,"serviceMachineIdResource",null),pe([D.memoize],d.prototype,"telemetryLogResource",null),pe([D.memoize],d.prototype,"disableWorkspaceTrust",null),i.AbstractNativeEnvironmentService=d;function b(y,g){return S(y["inspect-extensions"],y["inspect-brk-extensions"],5870,g,y.debugId,y.extensionEnvironment)}i.parseExtensionHostPort=b;function T(y,g){return S(y["inspect-search"],y["inspect-brk-search"],5876,g,y.extensionEnvironment)}i.parseSearchPort=T;function h(y,g){return S(y["inspect-ptyhost"],y["inspect-brk-ptyhost"],5877,g,y.extensionEnvironment)}i.parsePtyHostPort=h;function S(y,g,a,u,v,E){const o=Number(g||y)||(u?null:a),t=o?Boolean(!!g):!1;let r;if(E)try{r=JSON.parse(E)}catch{}return{port:o,break:t,debugId:v,env:r}}}),function(){"use strict";function z(i,C,D,P){function R(I){const c=L(I),d=[c];return i.isAbsolute(c)||d.unshift(P),i.resolve(...d)}function L(I){const c=process.env.VSCODE_PORTABLE;if(c)return i.join(c,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return i.join(d,D);const b=I["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const T=process.env.USERPROFILE;if(typeof T!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=i.join(T,"AppData","Roaming")}break;case"darwin":d=i.join(C.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||i.join(C.homedir(),".config");break;default:throw new Error("Platform not supported")}return i.join(d,D)}return{getUserDataPath:R}}if(typeof define=="function")define(Q[88],Z([0,132,33,10,19,29]),function(i,C,D,P,R,L){const I=R.dirname(P.FileAccess.asFileUri("",i)),c=i.__$__nodeRequire(R.joinPath(I,"package.json").fsPath);return z(C,D,c.name,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const i=require("../../../../../package.json"),C=require("path"),D=require("os");module.exports=z(C,D,i.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[89],Z([0,1,33,87,88]),function(z,i,C,D,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeEnvironmentService=void 0;class R extends D.AbstractNativeEnvironmentService{constructor(I,c){super(I,{homeDir:(0,C.homedir)(),tmpDir:(0,C.tmpdir)(),userDataDir:(0,P.getUserDataPath)(I)},c)}}i.NativeEnvironmentService=R}),define(Q[90],Z([0,1,22]),function(z,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localizeManifest=void 0;const D=/^%([\w\d.-]+)%$/i;function P(R,L){const I=c=>{if(typeof c!="string")return;const d=D.exec(c);if(!d)return;const b=L[d[1]]??c;return typeof b=="string"?b:typeof b.message=="string"?b.message:c};return(0,C.cloneAndChange)(R,I)}i.localizeManifest=P}),define(Q[48],Z([0,1,81]),function(z,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isEngineValid=i.isValidExtensionVersion=i.isValidVersion=i.normalizeVersion=i.parseVersion=i.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function R(h){return h=h.trim(),h==="*"||D.test(h)}i.isValidVersionStr=R;function L(h){if(!R(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=h.match(D);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}i.parseVersion=L;function I(h){if(!h)return null;let S=h.majorBase,y=h.majorMustEqual,g=h.minorBase,a=h.minorMustEqual,u=h.patchBase,v=h.patchMustEqual;h.hasCaret&&(S===0||(a=!1),v=!1);let E=0;if(h.preRelease){const p=P.exec(h.preRelease);if(p){const[,o,t,r]=p;E=Date.UTC(Number(o),Number(t)-1,Number(r))}}return{majorBase:S,majorMustEqual:y,minorBase:g,minorMustEqual:a,patchBase:u,patchMustEqual:v,isMinimum:h.hasGreaterEquals,notBefore:E}}i.normalizeVersion=I;function c(h,S,y){let g;typeof h=="string"?g=I(L(h)):g=h;let a;S instanceof Date?a=S.getTime():typeof S=="string"&&(a=new Date(S).getTime());let u;if(typeof y=="string"?u=I(L(y)):u=y,!g||!u)return!1;let v=g.majorBase,E=g.minorBase,p=g.patchBase,o=u.majorBase,t=u.minorBase,r=u.patchBase,e=u.notBefore,n=u.majorMustEqual,s=u.minorMustEqual,l=u.patchMustEqual;return u.isMinimum?v>o?!0:v<o?!1:E>t?!0:E<t||a&&a<e?!1:p>=r:(v===1&&o===0&&(!n||!s||!l)&&(o=1,t=0,r=0,n=!0,s=!1,l=!1),v<o?!1:v>o?!n:E<t?!1:E>t?!s:p<r?!1:p>r?!l:!(a&&a<e))}i.isValidVersion=c;function d(h,S,y,g){return y.isBuiltin||typeof y.main=="undefined"?!0:T(h,S,y.engines.vscode,g)}i.isValidExtensionVersion=d;function b(h,S,y){return h==="*"||T(S,y,h)}i.isEngineValid=b;function T(h,S,y,g=[]){let a=I(L(y));if(!a)return g.push(C.localize(0,null,y)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return g.push(C.localize(1,null,y)),!1}else if(!a.majorMustEqual)return g.push(C.localize(2,null,y)),!1;return c(h,S,a)?!0:(g.push(C.localize(3,null,h,y)),!1)}}),define(Q[39],Z([0,1]),function(z,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SyncDescriptor=void 0;class C{constructor(P,R=[],L=!1){this.ctor=P,this.staticArguments=R,this.supportsDelayedInstantiation=L}}i.SyncDescriptor=C}),define(Q[91],Z([0,1,39]),function(z,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSingletonServiceDescriptors=i.registerSingleton=void 0;const D=[];function P(L,I,c){I instanceof C.SyncDescriptor||(I=new C.SyncDescriptor(I,[],c)),D.push([L,I])}i.registerSingleton=P;function R(){return D}i.getSingletonServiceDescriptors=R}),define(Q[92],Z([0,1]),function(z,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Graph=i.Node=void 0;class C{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}i.Node=C;class D{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let L of this._nodes.values())L.outgoing.size===0&&R.push(L);return R}insertEdge(R,L){const I=this.lookupOrInsertNode(R),c=this.lookupOrInsertNode(L);I.outgoing.set(this._hashFn(L),c),c.incoming.set(this._hashFn(R),I)}removeNode(R){const L=this._hashFn(R);this._nodes.delete(L);for(let I of this._nodes.values())I.outgoing.delete(L),I.incoming.delete(L)}lookupOrInsertNode(R){const L=this._hashFn(R);let I=this._nodes.get(L);return I||(I=new C(R),this._nodes.set(L,I)),I}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[L,I]of this._nodes)R.push(`${L}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(let[R,L]of this._nodes){const I=new Set([R]),c=this._findCycle(L,I);if(c)return c}}_findCycle(R,L){for(let[I,c]of R.outgoing){if(L.has(I))return[...L,I].join(" -> ");L.add(I);const d=this._findCycle(c,L);if(d)return d;L.delete(I)}}}i.Graph=D}),define(Q[25],Z([0,1,8,9,13]),function(z,i,C,D,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getMigratedSettingValue=i.merge=i.getConfigurationValue=i.removeFromValueTree=i.addToValueTree=i.toValuesTree=i.ConfigurationTargetToString=i.ConfigurationTarget=i.isConfigurationUpdateOverrides=i.isConfigurationOverrides=i.IConfigurationService=void 0,i.IConfigurationService=(0,P.createDecorator)("configurationService");function R(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof D.URI)}i.isConfigurationOverrides=R;function L(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||C.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof D.URI)}i.isConfigurationUpdateOverrides=L;var I;(function(a){a[a.USER=1]="USER",a[a.USER_LOCAL=2]="USER_LOCAL",a[a.USER_REMOTE=3]="USER_REMOTE",a[a.WORKSPACE=4]="WORKSPACE",a[a.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",a[a.DEFAULT=6]="DEFAULT",a[a.MEMORY=7]="MEMORY"})(I=i.ConfigurationTarget||(i.ConfigurationTarget={}));function c(a){switch(a){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}i.ConfigurationTargetToString=c;function d(a,u){const v=Object.create(null);for(let E in a)b(v,E,a[E],u);return v}i.toValuesTree=d;function b(a,u,v,E){const p=u.split("."),o=p.pop();let t=a;for(let r=0;r<p.length;r++){let e=p[r],n=t[e];switch(typeof n){case"undefined":n=t[e]=Object.create(null);break;case"object":break;default:E(`Ignoring ${u} as ${p.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}t=n}if(typeof t=="object"&&t!==null)try{t[o]=v}catch{E(`Ignoring ${u} as ${p.join(".")} is ${JSON.stringify(t)}`)}else E(`Ignoring ${u} as ${p.join(".")} is ${JSON.stringify(t)}`)}i.addToValueTree=b;function T(a,u){const v=u.split(".");h(a,v)}i.removeFromValueTree=T;function h(a,u){const v=u.shift();if(u.length===0){delete a[v];return}if(Object.keys(a).indexOf(v)!==-1){const E=a[v];typeof E=="object"&&!Array.isArray(E)&&(h(E,u),Object.keys(E).length===0&&delete a[v])}}function S(a,u,v){function E(t,r){let e=t;for(const n of r){if(typeof e!="object"||e===null)return;e=e[n]}return e}const p=u.split("."),o=E(a,p);return typeof o=="undefined"?v:o}i.getConfigurationValue=S;function y(a,u,v){Object.keys(u).forEach(E=>{E!=="__proto__"&&(E in a?C.isObject(a[E])&&C.isObject(u[E])?y(a[E],u[E],v):v&&(a[E]=u[E]):a[E]=u[E])})}i.merge=y;function g(a,u,v){const E=a.inspect(u),p=a.inspect(v);return typeof E.userValue!="undefined"||typeof E.workspaceValue!="undefined"||typeof E.workspaceFolderValue!="undefined"?E.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:E.defaultValue}i.getMigratedSettingValue=g}),define(Q[49],Z([0,1,13]),function(z,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IDownloadService=void 0,i.IDownloadService=(0,C.createDecorator)("downloadService")}),define(Q[20],Z([0,1,13]),function(z,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.INativeEnvironmentService=i.IEnvironmentService=void 0,i.IEnvironmentService=(0,C.createDecorator)("environmentService"),i.INativeEnvironmentService=(0,C.refineServiceDecorator)(i.IEnvironmentService)}),define(Q[93],Z([0,1,38,11,74,24,28,7,12,27,70,133,3]),function(z,i,C,D,P,R,L,I,c,d,b,T,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getResolvedShellEnv=void 0;const S=1e4;let y;async function g(u,v,E){return v["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):c.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,T.isLaunchedFromCli)(E)&&!v["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,T.isLaunchedFromCli)(E)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=h.Promises.withAsyncBody(async(p,o)=>{const t=new R.CancellationTokenSource,r=setTimeout(()=>{t.dispose(!0),o(new Error((0,P.localize)(0,null)))},S);try{p(await a(u,t.token))}catch(e){!(0,I.isCancellationError)(e)&&!t.token.isCancellationRequested?o(new Error((0,P.localize)(1,null,(0,L.toErrorMessage)(e)))):p({})}finally{clearTimeout(r),t.dispose()}})),y)}i.getResolvedShellEnv=g;async function a(u,v){const E=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",E);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",p);const o=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(o+"(.*)"+o),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",r);const e=await(0,b.getSystemShell)(c.OS,r);return u.trace("getUnixShellEnvironment#shell",e),new Promise((n,s)=>{if(v.isCancellationRequested)return s((0,I.canceled)());const l=(0,D.basename)(e);let f,m;const w=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(f=`& '${process.execPath}' ${w} -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,m=["-Login","-Command"]):(f=`'${process.execPath}' ${w} -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,l==="tcsh"?m=["-ic"]:m=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(m),f);const O=(0,C.spawn)(e,[...m,f],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});v.onCancellationRequested(()=>(O.kill(),s((0,I.canceled)()))),O.on("error",J=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(J)),s(J)});const N=[];O.stdout.on("data",J=>N.push(J));const q=[];O.stderr.on("data",J=>q.push(J)),O.on("close",(J,se)=>{const ie=Buffer.concat(N).toString("utf8");u.trace("getUnixShellEnvironment#raw",ie);const te=Buffer.concat(q).toString("utf8");if(te.trim()&&u.trace("getUnixShellEnvironment#stderr",te),J||se)return s(new Error((0,P.localize)(2,null,J,se)));const ge=t.exec(ie),B=ge?ge[1]:"{}";try{const _=JSON.parse(B);E?_.ELECTRON_RUN_AS_NODE=E:delete _.ELECTRON_RUN_AS_NODE,p?_.ELECTRON_NO_ATTACH_CONSOLE=p:delete _.ELECTRON_NO_ATTACH_CONSOLE,delete _.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",_),n(_)}catch(_){u.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(_)),s(_)}})})}}),define(Q[50],Z([0,1,17,7,83,16]),function(z,i,C,D,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.readFileIntoStream=void 0;async function L(b,T,h,S,y,g){let a;try{await I(b,T,h,S,y,g)}catch(u){a=u}finally{a&&y.errorTransformer&&(a=y.errorTransformer(a)),typeof a!="undefined"&&h.error(a),h.end()}}i.readFileIntoStream=L;async function I(b,T,h,S,y,g){c(g);const a=await b.open(T,{create:!1});try{c(g);let u=0,v=0,E=y&&typeof y.length=="number"?y.length:void 0,p=C.VSBuffer.alloc(Math.min(y.bufferSize,typeof E=="number"?E:y.bufferSize)),o=y&&typeof y.position=="number"?y.position:0,t=0;do v=await b.read(a,o,p.buffer,t,p.byteLength-t),o+=v,t+=v,u+=v,typeof E=="number"&&(E-=v),t===p.byteLength&&(await h.write(S(p)),p=C.VSBuffer.alloc(Math.min(y.bufferSize,typeof E=="number"?E:y.bufferSize)),t=0);while(v>0&&(typeof E!="number"||E>0)&&c(g)&&d(u,y));if(t>0){let r=t;typeof E=="number"&&(r=Math.min(t,E)),h.write(S(p.slice(0,r)))}}catch(u){throw(0,R.ensureFileSystemProviderError)(u)}finally{await b.close(a)}}function c(b){if(b.isCancellationRequested)throw(0,D.canceled)();return!0}function d(b,T){if(T?.limits){if(typeof T.limits.memory=="number"&&b>T.limits.memory)throw(0,R.createFileSystemProviderError)((0,P.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof T.limits.size=="number"&&b>T.limits.size)throw(0,R.createFileSystemProviderError)((0,P.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[94],Z([0,1,18,6,2,12,134]),function(z,i,C,D,P,R,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcher=void 0;class I extends P.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(d){const b=this.normalizeRequests(d),T=b.filter(S=>{const y=this.watchers.get(S.path);return y?!(0,C.equals)(y.request.excludes,S.excludes):!0}),h=Array.from(this.watchers.values()).filter(({request:S})=>!b.find(y=>y.path===S.path&&(0,C.equals)(y.excludes,S.excludes))).map(({request:S})=>S.path);T.length&&this.trace(`Request to start watching: ${T.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"})`).join(",")}`),h.length&&this.trace(`Request to stop watching: ${h.join(",")}`);for(const S of h)this.stopWatching(S);for(const S of T)this.startWatching(S)}startWatching(d){const b=new L.NodeJSFileWatcherLibrary(d,h=>this._onDidChangeFile.fire(h),h=>this._onDidLogMessage.fire(h),this.verboseLogging),T={request:d,instance:b};this.watchers.set(d.path,T)}async stop(){for(const[d]of this.watchers)this.stopWatching(d);this.watchers.clear()}stopWatching(d){const b=this.watchers.get(d);b&&(this.watchers.delete(d),b.instance.dispose())}normalizeRequests(d){const b=new Map;for(const T of d){const h=R.isLinux?T.path:T.path.toLowerCase();b.set(h,T)}return Array.from(b.values())}async setVerboseLogging(d){this.verboseLogging=d;for(const[,b]of this.watchers)b.instance.setVerboseLogging(d)}trace(d){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(d)})}toMessage(d,b){return b?`[File Watcher (node.js)] ${d} (path: ${b.request.path})`:`[File Watcher (node.js)] ${d}`}}i.NodeJSWatcher=I}),define(Q[95],Z([0,1,51,94]),function(z,i,C,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcherClient=void 0;class P extends C.AbstractNonRecursiveWatcherClient{constructor(L,I,c){super(L,I,c);this.init()}createWatcher(){return new D.NodeJSWatcher}}i.NodeJSWatcherClient=P}),define(Q[96],Z([0,1,10,46,71,51]),function(z,i,C,D,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UniversalWatcherClient=void 0;class L extends R.AbstractUniversalWatcherClient{constructor(c,d,b){super(c,d,b);this.init()}createWatcher(c){const d=c.add(new P.Client(C.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return c.add(d.onDidProcessExit(({code:b,signal:T})=>this.onError(`terminated by itself with code ${b}, signal: ${T}`))),D.ProxyChannel.toService((0,D.getNextTickChannel)(d.getChannel("watcher")))}}i.UniversalWatcherClient=L}),define(Q[52],Z([0,1]),function(z,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ServiceCollection=void 0;class C{constructor(...P){this._entries=new Map;for(let[R,L]of P)this.set(R,L)}set(P,R){const L=this._entries.get(P);return this._entries.set(P,R),L}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}i.ServiceCollection=C}),define(Q[97],Z([0,1,3,7,39,92,13,52]),function(z,i,C,D,P,R,L,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Trace=i.InstantiationService=void 0;const c=!1;class d extends Error{constructor(y){super("cyclic dependency between services");this.message=y.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${y.toString()}`}}class b{constructor(y=new I.ServiceCollection,g=!1,a){this._activeInstantiations=new Set,this._services=y,this._strict=g,this._parent=a,this._services.set(L.IInstantiationService,this)}createChild(y){return new b(y,this._strict,this)}invokeFunction(y,...g){let a=h.traceInvocation(y),u=!1;try{return y({get:E=>{if(u)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(E,a);if(!p)throw new Error(`[invokeFunction] unknown service '${E}'`);return p}},...g)}finally{u=!0,a.stop()}}createInstance(y,...g){let a,u;return y instanceof P.SyncDescriptor?(a=h.traceCreation(y.ctor),u=this._createInstance(y.ctor,y.staticArguments.concat(g),a)):(a=h.traceCreation(y),u=this._createInstance(y,g,a)),a.stop(),u}_createInstance(y,g=[],a){let u=L._util.getServiceDependencies(y).sort((p,o)=>p.index-o.index),v=[];for(const p of u){let o=this._getOrCreateServiceInstance(p.id,a);if(!o&&this._strict&&!p.optional)throw new Error(`[createInstance] ${y.name} depends on UNKNOWN service ${p.id}.`);v.push(o)}let E=u.length>0?u[0].index:g.length;if(g.length!==E){console.warn(`[createInstance] First service dependency of ${y.name} at position ${E+1} conflicts with ${g.length} static arguments`);let p=E-g.length;p>0?g=g.concat(new Array(p)):g=g.slice(0,E)}return new y(...[...g,...v])}_setServiceInstance(y,g){if(this._services.get(y)instanceof P.SyncDescriptor)this._services.set(y,g);else if(this._parent)this._parent._setServiceInstance(y,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(y){let g=this._services.get(y);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(y):g}_getOrCreateServiceInstance(y,g){let a=this._getServiceInstanceOrDescriptor(y);return a instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(y,a,g.branch(y,!0)):(g.branch(y,!1),a)}_safeCreateAndCacheServiceInstance(y,g,a){if(this._activeInstantiations.has(y))throw new Error(`illegal state - RECURSIVELY instantiating service '${y}'`);this._activeInstantiations.add(y);try{return this._createAndCacheServiceInstance(y,g,a)}finally{this._activeInstantiations.delete(y)}}_createAndCacheServiceInstance(y,g,a){const u=new R.Graph(p=>p.id.toString());let v=0;const E=[{id:y,desc:g,_trace:a}];for(;E.length;){const p=E.pop();if(u.lookupOrInsertNode(p),v++>1e3)throw new d(u);for(let o of L._util.getServiceDependencies(p.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(o.id);if(!t&&!o.optional&&console.warn(`[createInstance] ${y} depends on ${o.id} which is NOT registered.`),t instanceof P.SyncDescriptor){const r={id:o.id,desc:t,_trace:p._trace.branch(o.id,!0)};u.insertEdge(p,r),E.push(r)}}}for(;;){const p=u.roots();if(p.length===0){if(!u.isEmpty())throw new d(u);break}for(const{data:o}of p){if(this._getServiceInstanceOrDescriptor(o.id)instanceof P.SyncDescriptor){const r=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,r)}u.removeNode(o)}}return this._getServiceInstanceOrDescriptor(y)}_createServiceInstanceWithOwner(y,g,a=[],u,v){if(this._services.get(y)instanceof P.SyncDescriptor)return this._createServiceInstance(g,a,u,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(y,g,a,u,v);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(y,g=[],a,u){if(a){const v=new C.IdleValue(()=>this._createInstance(y,g,u));return new Proxy(Object.create(null),{get(E,p){if(p in E)return E[p];let o=v.value,t=o[p];return typeof t!="function"||(t=t.bind(o),E[p]=t),t},set(E,p,o){return v.value[p]=o,!0}})}else return this._createInstance(y,g,u)}}i.InstantiationService=b;var T;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(T||(T={}));class h{constructor(y,g){this.type=y,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(y){return c?new h(1,y.name||y.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(y){return c?new h(0,y.name):h._None}branch(y,g){let a=new h(2,y.toString());return this._dep.push([y,g,a]),a}stop(){let y=Date.now()-this._start;h._totals+=y;let g=!1;function a(v,E){let p=[],o=new Array(v+1).join("	");for(const[t,r,e]of E._dep)if(r&&e){g=!0,p.push(`${o}CREATES -> ${t}`);let n=a(v+1,e);n&&p.push(n)}else p.push(`${o}uses -> ${t}`);return p.join(`
`)}let u=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${a(1,this)}`,`DONE, took ${y.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(y>2||g)&&console.log(u.join(`
`))}}i.Trace=h,h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0}),define(Q[53],Z([0,1,13]),function(z,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isValidLocalization=i.ILocalizationsService=void 0,i.ILocalizationsService=(0,C.createDecorator)("localizationsService");function D(P){if(typeof P.languageId!="string"||!Array.isArray(P.translations)||P.translations.length===0)return!1;for(const R of P.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(P.languageName&&typeof P.languageName!="string"||P.localizedLanguageName&&typeof P.localizedLanguageName!="string")}i.isValidLocalization=D}),define(Q[14],Z([0,1,28,6,2,12,13]),function(z,i,C,D,P,R,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LogLevelToString=i.parseLogLevel=i.getLogLevel=i.NullLogService=i.AbstractLoggerService=i.LogService=i.MultiplexLogService=i.AdapterLogger=i.ConsoleLogger=i.ConsoleMainLogger=i.AbstractMessageLogger=i.AbstractLogger=i.format=i.log=i.DEFAULT_LOG_LEVEL=i.LogLevel=i.ILoggerService=i.ILogService=void 0,i.ILogService=(0,L.createDecorator)("logService"),i.ILoggerService=(0,L.createDecorator)("loggerService");function I(){return new Date().toISOString()}var c;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(c=i.LogLevel||(i.LogLevel={})),i.DEFAULT_LOG_LEVEL=c.Info;function d(r,e,n){switch(e){case c.Trace:r.trace(n);break;case c.Debug:r.debug(n);break;case c.Info:r.info(n);break;case c.Warning:r.warn(n);break;case c.Error:r.error(n);break;case c.Critical:r.critical(n);break;default:throw new Error("Invalid log level")}}i.log=d;function b(r){let e="";for(let n=0;n<r.length;n++){let s=r[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}e+=(n>0?" ":"")+s}return e}i.format=b;class T extends P.Disposable{constructor(){super(...arguments);this.level=i.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}i.AbstractLogger=T;class h extends T{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...n){this.checkLogLevel(c.Trace)&&this.log(c.Trace,b([e,...n]))}debug(e,...n){this.checkLogLevel(c.Debug)&&this.log(c.Debug,b([e,...n]))}info(e,...n){this.checkLogLevel(c.Info)&&this.log(c.Info,b([e,...n]))}warn(e,...n){this.checkLogLevel(c.Warning)&&this.log(c.Warning,b([e,...n]))}error(e,...n){if(this.checkLogLevel(c.Error))if(e instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=e.stack,this.log(c.Error,b(s))}else this.log(c.Error,b([e,...n]))}critical(e,...n){this.checkLogLevel(c.Critical)&&this.log(c.Critical,b([e,...n]))}flush(){}}i.AbstractMessageLogger=h;class S extends T{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!R.isWindows}trace(e,...n){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,e,...n):console.log(`[main ${I()}]`,e,...n))}debug(e,...n){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,e,...n):console.log(`[main ${I()}]`,e,...n))}info(e,...n){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,e,...n):console.log(`[main ${I()}]`,e,...n))}warn(e,...n){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,e,...n):console.warn(`[main ${I()}]`,e,...n))}error(e,...n){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,e,...n):console.error(`[main ${I()}]`,e,...n))}critical(e,...n){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,e,...n):console.error(`[main ${I()}]`,e,...n))}dispose(){}flush(){}}i.ConsoleMainLogger=S;class y extends T{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...n){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",e,...n)}debug(e,...n){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...n)}info(e,...n){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",e,...n)}warn(e,...n){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",e,...n)}error(e,...n){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",e,...n)}critical(e,...n){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...n)}dispose(){}flush(){}}i.ConsoleLogger=y;class g extends T{constructor(e,n=i.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(n)}trace(e,...n){this.getLevel()<=c.Trace&&this.adapter.log(c.Trace,[this.extractMessage(e),...n])}debug(e,...n){this.getLevel()<=c.Debug&&this.adapter.log(c.Debug,[this.extractMessage(e),...n])}info(e,...n){this.getLevel()<=c.Info&&this.adapter.log(c.Info,[this.extractMessage(e),...n])}warn(e,...n){this.getLevel()<=c.Warning&&this.adapter.log(c.Warning,[this.extractMessage(e),...n])}error(e,...n){this.getLevel()<=c.Error&&this.adapter.log(c.Error,[this.extractMessage(e),...n])}critical(e,...n){this.getLevel()<=c.Critical&&this.adapter.log(c.Critical,[this.extractMessage(e),...n])}extractMessage(e){return typeof e=="string"?e:(0,C.toErrorMessage)(e,this.getLevel()<=c.Trace)}dispose(){}flush(){}}i.AdapterLogger=g;class a extends T{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const n of this.logServices)n.setLevel(e);super.setLevel(e)}trace(e,...n){for(const s of this.logServices)s.trace(e,...n)}debug(e,...n){for(const s of this.logServices)s.debug(e,...n)}info(e,...n){for(const s of this.logServices)s.info(e,...n)}warn(e,...n){for(const s of this.logServices)s.warn(e,...n)}error(e,...n){for(const s of this.logServices)s.error(e,...n)}critical(e,...n){for(const s of this.logServices)s.critical(e,...n)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}i.MultiplexLogService=a;class u extends P.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...n){this.logger.trace(e,...n)}debug(e,...n){this.logger.debug(e,...n)}info(e,...n){this.logger.info(e,...n)}warn(e,...n){this.logger.warn(e,...n)}error(e,...n){this.logger.error(e,...n)}critical(e,...n){this.logger.critical(e,...n)}flush(){this.logger.flush()}}i.LogService=u;class v extends P.Disposable{constructor(e,n){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(l=>l.setLevel(s))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,n){let s=this.loggers.get(e.toString());return s||(s=this.doCreateLogger(e,n?.always?c.Trace:this.logLevel,n),this.loggers.set(e.toString(),s),n?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}i.AbstractLoggerService=v;class E{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(e){}getLevel(){return c.Info}trace(e,...n){}debug(e,...n){}info(e,...n){}warn(e,...n){}error(e,...n){}critical(e,...n){}dispose(){}flush(){}}i.NullLogService=E;function p(r){if(r.verbose)return c.Trace;if(typeof r.logLevel=="string"){const e=o(r.logLevel.toLowerCase());if(e!==void 0)return e}return i.DEFAULT_LOG_LEVEL}i.getLogLevel=p;function o(r){switch(r){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}i.parseLogLevel=o;function t(r){switch(r){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Critical:return"critical";case c.Off:return"off"}}i.LogLevelToString=t});var oe=this&&this.__param||function(z,i){return function(C,D){i(C,D,z)}};define(Q[98],Z([0,1,38,3,28,6,2,10,11,15,20,14]),function(z,i,C,D,P,R,L,I,c,d,b,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsLifecycle=void 0;let h=class extends L.Disposable{constructor(y,g){super();this.environmentService=y,this.logService=g,this.processesLimiter=new D.Limiter(5)}async postUninstall(y){const g=this.parseScript(y,"uninstall");return g&&(this.logService.info(y.identifier.id,y.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(g.script,"uninstall",g.args,!0,y).then(()=>this.logService.info(y.identifier.id,y.manifest.version,"Finished running post uninstall script"),a=>this.logService.error(y.identifier.id,y.manifest.version,`Failed to run post uninstall script: ${a}`)))),d.Promises.rm(this.getExtensionStoragePath(y)).then(void 0,a=>this.logService.error("Error while removing extension storage path",a))}parseScript(y,g){const a=`vscode:${g}`;if(y.location.scheme===I.Schemas.file&&y.manifest&&y.manifest.scripts&&typeof y.manifest.scripts[a]=="string"){const u=y.manifest.scripts[a].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.logService.warn(y.identifier.id,y.manifest.version,`${a} should be a node script`),null):{script:(0,c.join)(y.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}runLifecycleHook(y,g,a,u,v){return new Promise((E,p)=>{const o=this.start(y,g,a,v);let t;const r=e=>{t&&(clearTimeout(t),t=null),e?p(e):E(void 0)};o.on("error",e=>{r((0,P.toErrorMessage)(e)||"Unknown")}),o.on("exit",(e,n)=>{r(e?`post-${g} process exited with code ${e}`:void 0)}),u&&(t=setTimeout(()=>{t=null,o.kill(),p("timed out")},5e3))})}start(y,g,a,u){const v={silent:!0,execArgv:void 0},E=(0,C.fork)(y,[`--type=extension-post-${g}`,...a],v);E.stdout.setEncoding("utf8"),E.stderr.setEncoding("utf8");const p=R.Event.fromNodeEventEmitter(E.stdout,"data"),o=R.Event.fromNodeEventEmitter(E.stderr,"data");p(e=>this.logService.info(u.identifier.id,u.manifest.version,`post-${g}`,e)),o(e=>this.logService.error(u.identifier.id,u.manifest.version,`post-${g}`,e));const t=R.Event.any(R.Event.map(p,e=>({data:`%c${e}`,format:[""]})),R.Event.map(o,e=>({data:`%c${e}`,format:["color: red"]})));return R.Event.debounce(t,(e,n)=>e?{data:e.data+n.data,format:[...e.format,...n.format]}:{data:n.data,format:n.format},100)(e=>{console.group(u.identifier.id),console.log(e.data,...e.format),console.groupEnd()}),E}getExtensionStoragePath(y){return(0,c.join)(this.environmentService.globalStorageHome.fsPath,y.identifier.id.toLowerCase())}};h=pe([oe(0,b.IEnvironmentService),oe(1,T.ILogService)],h),i.ExtensionsLifecycle=h}),define(Q[99],Z([0,1,18,3,7,6,2,11,51,14]),function(z,i,C,D,P,R,L,I,c,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractDiskFileSystemProvider=void 0;class b extends L.Disposable{constructor(h,S){super();this.logService=h,this.options=S,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new D.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new D.ThrottledDelayer(0))}watch(h,S){return S.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(h,S):this.watchNonRecursive(h,S)}watchUniversal(h,S){const y={path:this.toFilePath(h),excludes:S.excludes,recursive:S.recursive},g=(0,C.insert)(this.universalPathsToWatch,y);return this.refreshUniversalWatchers(),(0,L.toDisposable)(()=>{g(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(h=>(0,P.onUnexpectedError)(h))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(S=>this._onDidChangeFile.fire((0,c.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)})));const h=this.options?.watcher?.recursive?.usePolling;if(h===!0)for(const S of this.universalPathsToWatch)(0,c.isRecursiveWatchRequest)(S)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(h))for(const S of this.universalPathsToWatch)(0,c.isRecursiveWatchRequest)(S)&&h.includes(S.path)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(h,S){const y={path:this.toFilePath(h),excludes:S.excludes,recursive:!1},g=(0,C.insert)(this.nonRecursivePathsToWatch,y);return this.refreshNonRecursiveWatchers(),(0,L.toDisposable)(()=>{g(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(h=>(0,P.onUnexpectedError)(h))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(h=>this._onDidChangeFile.fire((0,c.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(h){h.type==="error"&&this._onDidWatchError.fire(h.message),this.logService[h.type](h.message)}toFilePath(h){return(0,I.normalize)(h.fsPath)}}i.AbstractDiskFileSystemProvider=b}),define(Q[100],Z([0,1,18,3,17,24,6,59,135,2,54,10,101,19,37,82,16,50,14]),function(z,i,C,D,P,R,L,I,c,d,b,T,h,S,y,g,a,u,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileService=void 0;let E=class extends d.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new D.ResourceQueue)}registerProvider(o,t){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${o}`);const r=new d.DisposableStore;return this.provider.set(o,t),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:t}),r.add(t.onDidChangeFile(e=>this._onDidFilesChange.fire(new a.FileChangesEvent(e,!this.isPathCaseSensitive(t))))),typeof t.onDidWatchError=="function"&&r.add(t.onDidWatchError(e=>this._onDidWatchError.fire(new Error(e)))),r.add(t.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:t,scheme:o}))),(0,d.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:t}),this.provider.delete(o),(0,d.dispose)(r)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const t=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(r){t.push(r)}}),!this.provider.has(o)&&await D.Promises.settled(t)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,t){const r=this.provider.get(o.scheme);return!!(r&&r.capabilities&t)}listCapabilities(){return c.Iterable.map(this.provider,([o,t])=>({scheme:o,capabilities:t.capabilities}))}async withProvider(o){if(!(0,S.isAbsolutePath)(o))throw new a.FileOperationError((0,g.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const t=this.provider.get(o.scheme);if(!t){const r=new Error;throw r.name="ENOPRO",r.message=(0,g.localize)(1,null,o.toString()),r}return t}async withReadProvider(o){const t=await this.withProvider(o);if((0,a.hasOpenReadWriteCloseCapability)(t)||(0,a.hasReadWriteCapability)(t)||(0,a.hasFileReadStreamCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const t=await this.withProvider(o);if((0,a.hasOpenReadWriteCloseCapability)(t)||(0,a.hasReadWriteCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,t){try{return await this.doResolveFile(o,t)}catch(r){throw(0,a.toFileSystemProviderErrorCode)(r)===a.FileSystemProviderErrorCode.FileNotFound?new a.FileOperationError((0,g.localize)(2,null,this.resourceForError(o)),1):(0,a.ensureFileSystemProviderError)(r)}}async doResolveFile(o,t){const r=await this.withProvider(o),e=this.isPathCaseSensitive(r),n=t?.resolveTo,s=t?.resolveSingleChildDescendants,l=t?.resolveMetadata,f=await r.stat(o);let m;return this.toFileStat(r,o,f,void 0,!!l,(w,O)=>(m||(m=b.TernarySearchTree.forUris(()=>!e),m.set(o,!0),n&&m.fill(!0,n)),m.get(w.resource)||m.findSuperstr(w.resource.with({query:null,fragment:null}))?!0:w.isDirectory&&s?O===1:!1))}async toFileStat(o,t,r,e,n,s){const{providerExtUri:l}=this.getExtUri(o),f={resource:t,name:l.basename(t),isFile:(r.type&a.FileType.File)!=0,isDirectory:(r.type&a.FileType.Directory)!=0,isSymbolicLink:(r.type&a.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&a.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,a.etag)({mtime:r.mtime,size:r.size})};if(f.isDirectory&&s(f,e)){try{const m=await o.readdir(t),w=await D.Promises.settled(m.map(async([O,N])=>{try{const q=l.joinPath(t,O),J=n?await o.stat(q):{type:N};return await this.toFileStat(o,q,J,m.length,n,s)}catch(q){return this.logService.trace(q),null}}));f.children=(0,C.coalesce)(w)}catch(m){this.logService.trace(m),f.children=[]}return f}return f}async resolveAll(o){return D.Promises.settled(o.map(async t=>{try{return{stat:await this.doResolveFile(t.resource,t.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async exists(o){const t=await this.withProvider(o);try{return!!await t.stat(o)}catch{return!1}}async canCreateFile(o,t){try{await this.doValidateCreateFile(o,t)}catch(r){return r}return!0}async doValidateCreateFile(o,t){if(!t?.overwrite&&await this.exists(o))throw new a.FileOperationError((0,g.localize)(3,null,this.resourceForError(o)),3,t)}async createFile(o,t=P.VSBuffer.fromString(""),r){await this.doValidateCreateFile(o,r);const e=await this.writeFile(o,t);return this._onDidRunOperation.fire(new a.FileOperationEvent(o,0,e)),e}async writeFile(o,t,r){const e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(e);try{await this.validateWriteFile(e,o,r)||await this.mkdirp(e,n.dirname(o));let l;if((0,a.hasReadWriteCapability)(e)&&!(t instanceof P.VSBuffer))if((0,y.isReadableStream)(t)){const f=await(0,y.peekStream)(t,3);f.ended?l=P.VSBuffer.concat(f.buffer):l=f}else l=(0,y.peekReadable)(t,f=>P.VSBuffer.concat(f),3);else l=t;!(0,a.hasOpenReadWriteCloseCapability)(e)||(0,a.hasReadWriteCapability)(e)&&l instanceof P.VSBuffer?await this.doWriteUnbuffered(e,o,r,l):await this.doWriteBuffered(e,o,r,l instanceof P.VSBuffer?(0,P.bufferToReadable)(l):l)}catch(s){throw new a.FileOperationError((0,g.localize)(4,null,this.resourceForError(o),(0,a.ensureFileSystemProviderError)(s).toString()),(0,a.toFileOperationResult)(s),r)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,t,r){if(!!r?.unlock&&!(o.capabilities&8192))throw new Error((0,g.localize)(5,null,this.resourceForError(t)));let n;try{n=await o.stat(t)}catch{return}if((n.type&a.FileType.Directory)!=0)throw new a.FileOperationError((0,g.localize)(6,null,this.resourceForError(t)),0,r);if(this.throwIfFileIsReadonly(t,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==a.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,a.etag)({mtime:r.mtime,size:n.size}))throw new a.FileOperationError((0,g.localize)(7,null),3,r);return n}async readFile(o,t,r){const e=await this.withReadProvider(o);return t?.atomic?this.doReadFileAtomic(e,o,t,r):this.doReadFile(e,o,t,r)}async doReadFileAtomic(o,t,r,e){return new Promise((n,s)=>{this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(async()=>{try{const l=await this.doReadFile(o,t,r,e);n(l)}catch(l){s(l)}})})}async doReadFile(o,t,r,e){const n=await this.doReadFileStream(o,t,{...r,preferUnbuffered:!0},e);return{...n,value:await(0,P.streamToBuffer)(n.value)}}async readFileStream(o,t,r){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,t,r)}async doReadFileStream(o,t,r,e){const n=new R.CancellationTokenSource(e),s=this.validateReadFile(t,r).then(f=>f,f=>{throw n.cancel(),f});let l;try{return typeof r?.etag=="string"&&r.etag!==a.ETAG_DISABLED&&await s,r?.atomic&&(0,a.hasFileAtomicReadCapability)(o)||!((0,a.hasOpenReadWriteCloseCapability)(o)||(0,a.hasFileReadStreamCapability)(o))||(0,a.hasReadWriteCapability)(o)&&r?.preferUnbuffered?l=this.readFileUnbuffered(o,t,r):(0,a.hasFileReadStreamCapability)(o)?l=this.readFileStreamed(o,t,n.token,r):l=this.readFileBuffered(o,t,n.token,r),{...await s,value:l}}catch(f){l&&await(0,y.consumeStream)(l);const m=(0,g.localize)(8,null,this.resourceForError(t),(0,a.ensureFileSystemProviderError)(f).toString());throw f instanceof a.NotModifiedSinceFileOperationError?new a.NotModifiedSinceFileOperationError(m,f.stat,r):new a.FileOperationError(m,(0,a.toFileOperationResult)(f),r)}}readFileStreamed(o,t,r,e=Object.create(null)){const n=o.readFileStream(t,e,r);return(0,y.transform)(n,{data:s=>s instanceof P.VSBuffer?s:P.VSBuffer.wrap(s),error:s=>new a.FileOperationError((0,g.localize)(9,null,this.resourceForError(t),(0,a.ensureFileSystemProviderError)(s).toString()),(0,a.toFileOperationResult)(s),e)},s=>P.VSBuffer.concat(s))}readFileBuffered(o,t,r,e=Object.create(null)){const n=(0,P.newWriteableBufferStream)();return(0,u.readFileIntoStream)(o,t,n,s=>s,{...e,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new a.FileOperationError((0,g.localize)(10,null,this.resourceForError(t),(0,a.ensureFileSystemProviderError)(s).toString()),(0,a.toFileOperationResult)(s),e)},r),n}readFileUnbuffered(o,t,r){const e=(0,y.newWriteableStream)(n=>P.VSBuffer.concat(n));return(async()=>{try{let n;r?.atomic&&(0,a.hasFileAtomicReadCapability)(o)?n=await o.readFile(t,{atomic:!0}):n=await o.readFile(t),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(t,n.byteLength,r),e.end(P.VSBuffer.wrap(n))}catch(n){e.error(n),e.end()}})(),e}async validateReadFile(o,t){const r=await this.resolve(o,{resolveMetadata:!0});if(r.isDirectory)throw new a.FileOperationError((0,g.localize)(11,null,this.resourceForError(o)),0,t);if(typeof t?.etag=="string"&&t.etag!==a.ETAG_DISABLED&&t.etag===r.etag)throw new a.NotModifiedSinceFileOperationError((0,g.localize)(12,null),r,t);return this.validateReadFileLimits(o,r.size,t),r}validateReadFileLimits(o,t,r){if(r?.limits){let e;if(typeof r.limits.memory=="number"&&t>r.limits.memory&&(e=9),typeof r.limits.size=="number"&&t>r.limits.size&&(e=7),typeof e=="number")throw new a.FileOperationError((0,g.localize)(13,null,this.resourceForError(o)),e)}}async canMove(o,t,r){return this.doCanMoveCopy(o,t,"move",r)}async canCopy(o,t,r){return this.doCanMoveCopy(o,t,"copy",r)}async doCanMoveCopy(o,t,r,e){if(o.toString()!==t.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);await this.doValidateMoveCopy(n,o,s,t,r,e)}catch(n){return n}return!0}async move(o,t,r){const e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),s=await this.doMoveCopy(e,o,n,t,"move",!!r),l=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new a.FileOperationEvent(o,s==="move"?2:3,l)),l}async copy(o,t,r){const e=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),s=await this.doMoveCopy(e,o,n,t,"copy",!!r),l=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new a.FileOperationEvent(o,s==="copy"?3:2,l)),l}async doMoveCopy(o,t,r,e,n,s){if(t.toString()===e.toString())return n;const{exists:l,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(o,t,r,e,n,s);if(l&&!f&&s&&await this.del(e,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(e)),n==="copy"){if(o===r&&(0,a.hasFileFolderCopyCapability)(o))await o.copy(t,e,{overwrite:s});else{const m=await this.resolve(t);m.isDirectory?await this.doCopyFolder(o,m,r,e):await this.doCopyFile(o,t,r,e)}return n}else return o===r?(await o.rename(t,e,{overwrite:s}),n):(await this.doMoveCopy(o,t,r,e,"copy",s),await this.del(t,{recursive:!0}),"copy")}async doCopyFile(o,t,r,e){if((0,a.hasOpenReadWriteCloseCapability)(o)&&(0,a.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(o,t,r,e);if((0,a.hasOpenReadWriteCloseCapability)(o)&&(0,a.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(o,t,r,e);if((0,a.hasReadWriteCapability)(o)&&(0,a.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(o,t,r,e);if((0,a.hasReadWriteCapability)(o)&&(0,a.hasReadWriteCapability)(r))return this.doPipeUnbuffered(o,t,r,e)}async doCopyFolder(o,t,r,e){await r.mkdir(e),Array.isArray(t.children)&&await D.Promises.settled(t.children.map(async n=>{const s=this.getExtUri(r).providerExtUri.joinPath(e,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),r,s):this.doCopyFile(o,n.resource,r,s)}))}async doValidateMoveCopy(o,t,r,e,n,s){let l=!1;if(o===r){const{providerExtUri:m,isPathCaseSensitive:w}=this.getExtUri(o);if(w||(l=m.isEqual(t,e)),l&&n==="copy")throw new Error((0,g.localize)(14,null,this.resourceForError(t),this.resourceForError(e)));if(!l&&m.isEqualOrParent(e,t))throw new Error((0,g.localize)(15,null,this.resourceForError(t),this.resourceForError(e)))}const f=await this.exists(e);if(f&&!l){if(!s)throw new a.FileOperationError((0,g.localize)(16,null,this.resourceForError(t),this.resourceForError(e)),4);if(o===r){const{providerExtUri:m}=this.getExtUri(o);if(m.isEqualOrParent(t,e))throw new Error((0,g.localize)(17,null,this.resourceForError(t),this.resourceForError(e)))}}return{exists:f,isSameResourceWithDifferentPathCase:l}}getExtUri(o){const t=this.isPathCaseSensitive(o);return{providerExtUri:t?S.extUri:S.extUriIgnorePathCase,isPathCaseSensitive:t}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(t,o);const r=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new a.FileOperationEvent(o,0,r)),r}async mkdirp(o,t){const r=[],{providerExtUri:e}=this.getExtUri(o);for(;!e.isEqual(t,e.dirname(t));)try{if(((await o.stat(t)).type&a.FileType.Directory)==0)throw new Error((0,g.localize)(18,null,this.resourceForError(t)));break}catch(n){if((0,a.toFileSystemProviderErrorCode)(n)!==a.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(e.basename(t)),t=e.dirname(t)}for(let n=r.length-1;n>=0;n--){t=e.joinPath(t,r[n]);try{await o.mkdir(t)}catch(s){if((0,a.toFileSystemProviderErrorCode)(s)!==a.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,t){try{await this.doValidateDelete(o,t)}catch(r){return r}return!0}async doValidateDelete(o,t){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!t?.useTrash&&!(r.capabilities&4096))throw new Error((0,g.localize)(19,null,this.resourceForError(o)));let n;try{n=await r.stat(o)}catch{}if(n)this.throwIfFileIsReadonly(o,n);else throw new a.FileOperationError((0,g.localize)(20,null,this.resourceForError(o)),1);if(!!!t?.recursive){const l=await this.resolve(o);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,g.localize)(21,null,this.resourceForError(o)))}return r}async del(o,t){const r=await this.doValidateDelete(o,t),e=!!t?.useTrash,n=!!t?.recursive;await r.delete(o,{recursive:n,useTrash:e}),this._onDidRunOperation.fire(new a.FileOperationEvent(o,1))}watch(o,t={recursive:!1,excludes:[]}){const r=new d.DisposableStore;let e=!1,n=()=>{e=!0};return r.add((0,d.toDisposable)(()=>n())),(async()=>{try{const s=await this.doWatch(o,t);e?(0,d.dispose)(s):n=()=>(0,d.dispose)(s)}catch(s){this.logService.error(s)}})(),r}async doWatch(o,t){const r=await this.withProvider(o),e=(0,I.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(o),t]);let n=this.activeWatchers.get(e);return n||(n={count:0,disposable:r.watch(o,t)},this.activeWatchers.set(e,n)),n.count+=1,(0,d.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,d.dispose)(n.disposable),this.activeWatchers.delete(e)))})}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,d.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,t,r,e){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(t,{create:!0,unlock:r?.unlock??!1});try{(0,y.isReadableStream)(e)||(0,y.isReadableBufferedStream)(e)?await this.doWriteStreamBufferedQueued(o,n,e):await this.doWriteReadableBufferedQueued(o,n,e)}catch(s){throw(0,a.ensureFileSystemProviderError)(s)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,t,r){let e=0,n;if((0,y.isReadableBufferedStream)(r)){if(r.buffer.length>0){const s=P.VSBuffer.concat(r.buffer);await this.doWriteBuffer(o,t,s,s.byteLength,e,0),e+=s.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((s,l)=>{(0,y.listenStream)(n,{onData:async f=>{n.pause();try{await this.doWriteBuffer(o,t,f,f.byteLength,e,0)}catch(m){return l(m)}e+=f.byteLength,setTimeout(()=>n.resume())},onError:f=>l(f),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(o,t,r){let e=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(o,t,n,n.byteLength,e,0),e+=n.byteLength}async doWriteBuffer(o,t,r,e,n,s){let l=0;for(;l<e;)l+=await o.write(t,n+l,r.buffer,s+l,e-l)}async doWriteUnbuffered(o,t,r,e){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,t,r,e))}async doWriteUnbufferedQueued(o,t,r,e){let n;e instanceof P.VSBuffer?n=e:(0,y.isReadableStream)(e)?n=await(0,P.streamToBuffer)(e):(0,y.isReadableBufferedStream)(e)?n=await(0,P.bufferedStreamToBuffer)(e):n=(0,P.readableToBuffer)(e),await o.writeFile(t,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(o,t,r,e){return this.writeQueue.queueFor(e,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,t,r,e))}async doPipeBufferedQueued(o,t,r,e){let n,s;try{n=await o.open(t,{create:!1}),s=await r.open(e,{create:!0,unlock:!1});const l=P.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,m=0,w=0;do w=await o.read(n,f,l.buffer,m,l.byteLength-m),await this.doWriteBuffer(r,s,l,w,f,m),f+=w,m+=w,m===l.byteLength&&(m=0);while(w>0)}catch(l){throw(0,a.ensureFileSystemProviderError)(l)}finally{await D.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof s=="number"?r.close(s):Promise.resolve()])}}async doPipeUnbuffered(o,t,r,e){return this.writeQueue.queueFor(e,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,t,r,e))}async doPipeUnbufferedQueued(o,t,r,e){return r.writeFile(e,await o.readFile(t),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,t,r,e){return this.writeQueue.queueFor(e,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,t,r,e))}async doPipeUnbufferedToBufferedQueued(o,t,r,e){const n=await r.open(e,{create:!0,unlock:!1});try{const s=await o.readFile(t);await this.doWriteBuffer(r,n,P.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,a.ensureFileSystemProviderError)(s)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(o,t,r,e){const n=await(0,P.streamToBuffer)(this.readFileBuffered(o,t,R.CancellationToken.None));await this.doWriteUnbuffered(r,e,void 0,n)}throwIfFileSystemIsReadonly(o,t){if(o.capabilities&2048)throw new a.FileOperationError((0,g.localize)(22,null,this.resourceForError(t)),6);return o}throwIfFileIsReadonly(o,t){if((t.permissions??0)&a.FilePermission.Readonly)throw new a.FileOperationError((0,g.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===T.Schemas.file?o.fsPath:o.toString(!0)}};E=pe([oe(0,v.ILogService)],E),i.FileService=E}),define(Q[102],Z([0,1,103,136,3,54,17,6,45,2,11,12,19,37,15,84,16,50,99,28,96,95]),function(z,i,C,D,P,R,L,I,c,d,b,T,h,S,y,g,a,u,v,E,p,o){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiskFileSystemProvider=void 0,(()=>{try{(0,D.gracefulify)(C)}catch(r){console.error(`Error enabling graceful-fs: ${(0,E.toErrorMessage)(r)}`)}})();class t extends v.AbstractDiskFileSystemProvider{constructor(e,n){super(e,n);this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new R.ResourceMap(s=>h.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,T.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(e){try{const{stat:n,symbolicLink:s}=await y.SymlinkSupport.stat(this.toFilePath(e));return{type:this.toType(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(e){try{const n=await y.Promises.readdir(this.toFilePath(e),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async l=>{try{let f;l.isSymbolicLink()?f=(await this.stat((0,h.joinPath)(e,l.name))).type:f=this.toType(l),s.push([l.name,f])}catch(f){this.logService.trace(f)}})),s}catch(n){throw this.toFileSystemProviderError(n)}}toType(e,n){let s;return n?.dangling?s=a.FileType.Unknown:e.isFile()?s=a.FileType.File:e.isDirectory()?s=a.FileType.Directory:s=a.FileType.Unknown,n&&(s|=a.FileType.SymbolicLink),s}async createResourceLock(e){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(e)})`);let n;for(;n=this.resourceLocks.get(e);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(e)})`),await n.wait();const s=new P.Barrier;return this.resourceLocks.set(e,s),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(e)})`),(0,d.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(e)})`),this.resourceLocks.delete(e),s.open()})}async readFile(e,n){let s;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(e)})`),s=await this.createResourceLock(e));const l=this.toFilePath(e);return await y.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}finally{s?.dispose()}}readFileStream(e,n,s){const l=(0,S.newWriteableStream)(f=>L.VSBuffer.concat(f.map(m=>L.VSBuffer.wrap(m))).buffer);return(0,u.readFileIntoStream)(this,e,l,f=>f.buffer,{...n,bufferSize:256*1024},s),l}async writeFile(e,n,s){let l;try{const f=this.toFilePath(e);if(!s.create||!s.overwrite){if(await y.Promises.exists(f)){if(!s.overwrite)throw(0,a.createFileSystemProviderError)((0,g.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,a.createFileSystemProviderError)((0,g.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(e,{create:!0,unlock:s.unlock}),await this.write(l,0,n,0,n.byteLength)}catch(f){throw await this.toFileSystemProviderWriteError(e,f)}finally{typeof l=="number"&&await this.close(l)}}async open(e,n){let s;(0,a.isFileOpenForWriteOptions)(n)&&(s=await this.createResourceLock(e));let l;try{const f=this.toFilePath(e);if((0,a.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:w}=await y.SymlinkSupport.stat(f);w.mode&128||await y.Promises.chmod(f,w.mode|128)}catch(w){this.logService.trace(w)}let m;if((0,a.isFileOpenForWriteOptions)(n)){if(T.isWindows)try{await y.Promises.truncate(f,0),m="r+"}catch(w){w.code!=="ENOENT"&&this.logService.trace(w)}m||(m="w")}else m="r";l=await y.Promises.open(f,m)}catch(f){throw s?.dispose(),(0,a.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(e,f):this.toFileSystemProviderError(f)}return this.mapHandleToPos.set(l,0),(0,a.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(l,e),s&&this.mapHandleToLock.set(l,s),l}async close(e){try{if(this.mapHandleToPos.delete(e),this.writeHandles.delete(e)&&this.canFlush)try{await y.Promises.fdatasync(e)}catch(n){this.canFlush=!1,this.logService.error(n)}return await y.Promises.close(e)}catch(n){throw this.toFileSystemProviderError(n)}finally{const n=this.mapHandleToLock.get(e);n&&(this.mapHandleToLock.delete(e),n.dispose())}}async read(e,n,s,l,f){const m=this.normalizePos(e,n);let w=null;try{const{bytesRead:O}=await y.Promises.read(e,s,l,f,m);return O}catch(O){throw this.toFileSystemProviderError(O)}finally{this.updatePos(e,m,w)}}normalizePos(e,n){return n===this.mapHandleToPos.get(e)?null:n}updatePos(e,n,s){const l=this.mapHandleToPos.get(e);typeof l=="number"&&(typeof n=="number"||(typeof s=="number"?this.mapHandleToPos.set(e,l+s):this.mapHandleToPos.delete(e)))}async write(e,n,s,l,f){return(0,P.retry)(()=>this.doWrite(e,n,s,l,f),100,3)}async doWrite(e,n,s,l,f){const m=this.normalizePos(e,n);let w=null;try{const{bytesWritten:O}=await y.Promises.write(e,s,l,f,m);return O}catch(O){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(e),O)}finally{this.updatePos(e,m,w)}}async mkdir(e){try{await y.Promises.mkdir(this.toFilePath(e))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(e,n){try{const s=this.toFilePath(e);n.recursive?await y.Promises.rm(s,y.RimRafMode.MOVE):await y.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(e,n,s){const l=this.toFilePath(e),f=this.toFilePath(n);if(l!==f)try{await this.validateTargetDeleted(e,n,"move",s.overwrite),await y.Promises.move(l,f)}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,g.localize)(2,null,(0,b.basename)(l),(0,b.basename)((0,b.dirname)(f)),m.toString()))),this.toFileSystemProviderError(m)}}async copy(e,n,s){const l=this.toFilePath(e),f=this.toFilePath(n);if(l!==f)try{await this.validateTargetDeleted(e,n,"copy",s.overwrite),await y.Promises.copy(l,f,{preserveSymlinks:!0})}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,g.localize)(3,null,(0,b.basename)(l),(0,b.basename)((0,b.dirname)(f)),m.toString()))),this.toFileSystemProviderError(m)}}async validateTargetDeleted(e,n,s,l){const f=this.toFilePath(e),m=this.toFilePath(n);let w=!1;if(!!(this.capabilities&1024)||(w=(0,c.isEqual)(f,m,!0)),w&&s==="copy")throw(0,a.createFileSystemProviderError)((0,g.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(!w&&await y.Promises.exists(m)){if(!l)throw(0,a.createFileSystemProviderError)((0,g.localize)(5,null),a.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}createUniversalWatcher(e,n,s){return new p.UniversalWatcherClient(l=>e(l),l=>n(l),s)}createNonRecursiveWatcher(e,n,s){return new o.NodeJSWatcherClient(l=>e(l),l=>n(l),s)}toFileSystemProviderError(e){if(e instanceof a.FileSystemProviderError)return e;let n;switch(e.code){case"ENOENT":n=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=a.FileSystemProviderErrorCode.NoPermissions;break;default:n=a.FileSystemProviderErrorCode.Unknown}return(0,a.createFileSystemProviderError)(e,n)}async toFileSystemProviderWriteError(e,n){let s=this.toFileSystemProviderError(n);if(e&&s.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await y.SymlinkSupport.stat(this.toFilePath(e));l.mode&128||(s=(0,a.createFileSystemProviderError)(n,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return s}}i.DiskFileSystemProvider=t}),define(Q[104],Z([0,1,16,14]),function(z,i,C,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SpdLogLogger=void 0;async function P(I,c,d,b,T){try{const h=await new Promise((y,g)=>{z(["spdlog"],y,g)});h.setFlushOn(D.LogLevel.Trace);const S=await h.createAsyncRotatingLogger(I,c,d,b);return T&&S.clearFormatters(),S}catch(h){console.error(h)}return null}function R(I,c,d){switch(c){case D.LogLevel.Trace:I.trace(d);break;case D.LogLevel.Debug:I.debug(d);break;case D.LogLevel.Info:I.info(d);break;case D.LogLevel.Warning:I.warn(d);break;case D.LogLevel.Error:I.error(d);break;case D.LogLevel.Critical:I.critical(d);break;default:throw new Error("Invalid log level")}}class L extends D.AbstractMessageLogger{constructor(c,d,b,T,h){super();this.buffer=[],this.setLevel(h),this._loggerCreationPromise=this._createSpdLogLogger(c,d,b,T),this._register(this.onDidChangeLogLevel(S=>{this._logger&&this._logger.setLevel(S)}))}async _createSpdLogLogger(c,d,b,T){const h=b?6:1,S=30/h*C.ByteSize.MB,y=await P(c,d,S,h,T);if(y){this._logger=y,this._logger.setLevel(this.getLevel());for(const{level:g,message:a}of this.buffer)R(this._logger,g,a);this.buffer=[]}}log(c,d){this._logger?R(this._logger,c,d):this.getLevel()<=c&&this.buffer.push({level:c,message:d})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}i.SpdLogLogger=L}),define(Q[32],Z([0,1,13]),function(z,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.productSchemaId=i.IProductService=void 0,i.IProductService=(0,C.createDecorator)("productService"),i.productSchemaId="vscode://schemas/vscode-product"}),define(Q[30],Z([0,1,55,8]),function(z,i,C,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Registry=void 0;class P{constructor(){this.data=new Map}add(L,I){C.ok(D.isString(L)),C.ok(D.isObject(I)),C.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,I)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}i.Registry=new P}),define(Q[105],Z([0,1,6,30]),function(z,i,C,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Extensions=void 0,i.Extensions={JSONContribution:"base.contributions.json"};function P(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class R{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,d){this.schemasById[P(c)]=d,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new R;D.Registry.add(i.Extensions.JSONContribution,L)}),define(Q[34],Z([0,1,18,6,8,73,105,30]),function(z,i,C,D,P,R,L,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getScopes=i.validateProperty=i.getDefaultValue=i.keyFromOverrideIdentifiers=i.overrideIdentifiersFromKey=i.OVERRIDE_PROPERTY_REGEX=i.OVERRIDE_PROPERTY_PATTERN=i.configurationDefaultsSchemaId=i.resourceLanguageSettingsSchemaId=i.resourceSettings=i.windowSettings=i.machineOverridableSettings=i.machineSettings=i.applicationSettings=i.allSettings=i.ConfigurationScope=i.Extensions=i.EditPresentationTypes=void 0;var c;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(c=i.EditPresentationTypes||(i.EditPresentationTypes={})),i.Extensions={Configuration:"base.contributions.configuration"};var d;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(d=i.ConfigurationScope||(i.ConfigurationScope={})),i.allSettings={properties:{},patternProperties:{}},i.applicationSettings={properties:{},patternProperties:{}},i.machineSettings={properties:{},patternProperties:{}},i.machineOverridableSettings={properties:{},patternProperties:{}},i.windowSettings={properties:{},patternProperties:{}},i.resourceSettings={properties:{},patternProperties:{}},i.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",i.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=I.Registry.as(L.Extensions.JSONContribution);class T{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},b.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(o,t=!0){this.registerConfigurations([o],t)}registerConfigurations(o,t=!0){const r=this.doRegisterConfigurations(o,t);b.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(o){const t=this.doDeregisterConfigurations(o);b.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}updateConfigurations({add:o,remove:t}){const r=[];r.push(...this.doDeregisterConfigurations(t)),r.push(...this.doRegisterConfigurations(o,!1)),b.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,C.distinct)(r)})}registerDefaultConfigurations(o){const t=[],r=[];for(const{overrides:e,source:n}of o)for(const s in e)if(t.push(s),i.OVERRIDE_PROPERTY_REGEX.test(s)){const l={...this.configurationDefaultsOverrides.get(s)?.value||{},...e[s]};this.configurationDefaultsOverrides.set(s,{source:n,value:l});const f={type:"object",default:l,description:R.localize(1,null,s),$ref:i.resourceLanguageSettingsSchemaId,defaultDefaultValue:l,source:P.isString(n)?void 0:n};r.push(...y(s)),this.configurationProperties[s]=f,this.defaultLanguageConfigurationOverridesNode.properties[s]=f}else{this.configurationDefaultsOverrides.set(s,{value:e[s],source:n});const l=this.configurationProperties[s];l&&(this.updatePropertyDefaultValue(s,l),this.updateSchema(s,l))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:!0})}deregisterDefaultConfigurations(o){const t=[];for(const{overrides:r,source:e}of o)for(const n in r){const s=this.configurationDefaultsOverrides.get(n),l=P.isString(e)?e:e?.id,f=P.isString(s?.source)?s?.source:s?.source?.id;if(l===f)if(t.push(n),this.configurationDefaultsOverrides.delete(n),i.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const m=this.configurationProperties[n];m&&(this.updatePropertyDefaultValue(n,m),this.updateSchema(n,m))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const t of o)this.overrideIdentifiers.add(t);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,t){const r=[];return o.forEach(e=>{r.push(...this.validateAndRegisterProperties(e,t,e.extensionInfo,e.restrictedProperties)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),r}doDeregisterConfigurations(o){const t=[],r=e=>{if(e.properties)for(const n in e.properties)t.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,e.properties[n]);e.allOf&&e.allOf.forEach(n=>r(n))};for(const e of o){r(e);const n=this.configurationContributors.indexOf(e);n!==-1&&this.configurationContributors.splice(n,1)}return t}validateAndRegisterProperties(o,t=!0,r,e,n=3){n=P.isUndefinedOrNull(o.scope)?n:o.scope;let s=[],l=o.properties;if(l)for(let m in l){if(t&&v(m)){delete l[m];continue}const w=l[m];if(w.source=r,w.defaultDefaultValue=l[m].default,this.updatePropertyDefaultValue(m,w),i.OVERRIDE_PROPERTY_REGEX.test(m)?w.scope=void 0:(w.scope=P.isUndefinedOrNull(w.scope)?n:w.scope,w.restricted=P.isUndefinedOrNull(w.restricted)?!!e?.includes(m):w.restricted),l[m].hasOwnProperty("included")&&!l[m].included){this.excludedConfigurationProperties[m]=l[m],delete l[m];continue}else this.configurationProperties[m]=l[m];!l[m].deprecationMessage&&l[m].markdownDeprecationMessage&&(l[m].deprecationMessage=l[m].markdownDeprecationMessage),s.push(m)}let f=o.allOf;if(f)for(let m of f)s.push(...this.validateAndRegisterProperties(m,t,r,e,n));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(o){const t=r=>{let e=r.properties;if(e)for(const s in e)this.updateSchema(s,e[s]);let n=r.allOf;n&&n.forEach(t)};t(o)}updateSchema(o,t){switch(i.allSettings.properties[o]=t,t.scope){case 1:i.applicationSettings.properties[o]=t;break;case 2:i.machineSettings.properties[o]=t;break;case 6:i.machineOverridableSettings.properties[o]=t;break;case 3:i.windowSettings.properties[o]=t;break;case 4:i.resourceSettings.properties[o]=t;break;case 5:i.resourceSettings.properties[o]=t,this.resourceLanguageSettingsSchema.properties[o]=t;break}}removeFromSchema(o,t){switch(delete i.allSettings.properties[o],t.scope){case 1:delete i.applicationSettings.properties[o];break;case 2:delete i.machineSettings.properties[o];break;case 6:delete i.machineOverridableSettings.properties[o];break;case 3:delete i.windowSettings.properties[o];break;case 4:case 5:delete i.resourceSettings.properties[o],delete this.resourceLanguageSettingsSchema.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const t=`[${o}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:i.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(t,r),i.allSettings.properties[t]=r,i.applicationSettings.properties[t]=r,i.machineSettings.properties[t]=r,i.machineOverridableSettings.properties[t]=r,i.windowSettings.properties[t]=r,i.resourceSettings.properties[t]=r}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const o={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:i.resourceLanguageSettingsSchemaId};i.allSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=o,i.applicationSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=o,i.machineSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=o,i.machineOverridableSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=o,i.windowSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=o,i.resourceSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=o,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,t){const r=this.configurationDefaultsOverrides.get(o);let e=r?.value,n=r?.source;P.isUndefined(e)&&(e=t.defaultDefaultValue,n=void 0),P.isUndefined(e)&&(e=a(t.type)),t.default=e,t.defaultValueSource=n}}const h="\\[([^\\]]+)\\]",S=new RegExp(h,"g");i.OVERRIDE_PROPERTY_PATTERN=`^(${h})+$`,i.OVERRIDE_PROPERTY_REGEX=new RegExp(i.OVERRIDE_PROPERTY_PATTERN);function y(p){const o=[];if(i.OVERRIDE_PROPERTY_REGEX.test(p)){let t=S.exec(p);for(;t?.length;){const r=t[1].trim();r&&o.push(r),t=S.exec(p)}}return(0,C.distinct)(o)}i.overrideIdentifiersFromKey=y;function g(p){return p.reduce((o,t)=>`${o}[${t}]`,"")}i.keyFromOverrideIdentifiers=g;function a(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}i.getDefaultValue=a;const u=new T;I.Registry.add(i.Extensions.Configuration,u);function v(p){return p.trim()?i.OVERRIDE_PROPERTY_REGEX.test(p)?R.localize(7,null,p):u.getConfigurationProperties()[p]!==void 0?R.localize(8,null,p):null:R.localize(6,null)}i.validateProperty=v;function E(){const p=[],o=u.getConfigurationProperties();for(const t of Object.keys(o))p.push([t,o[t].scope]);return p.push(["launch",4]),p.push(["task",4]),p}i.getScopes=E}),define(Q[106],Z([0,1,18,6,56,2,54,22,8,9,25,34,30]),function(z,i,C,D,P,R,L,I,c,d,b,T,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AllKeysConfigurationChangeEvent=i.ConfigurationChangeEvent=i.mergeChanges=i.Configuration=i.UserSettings=i.ConfigurationModelParser=i.DefaultConfigurationModel=i.ConfigurationModel=void 0;class S{constructor(e={},n=[],s=[]){this._contents=e,this._keys=n,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,b.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,n){const s=this.getContentsForOverrideIdentifer(n);return s?e?(0,b.getConfigurationValue)(s,e):s:void 0}getKeysForOverrideIdentifier(e){const n=[];for(const s of this.overrides)s.identifiers.includes(e)&&n.push(...s.keys);return C.distinct(n)}getAllOverrideIdentifiers(){const e=[];for(const n of this.overrides)e.push(...n.identifiers);return C.distinct(e)}override(e){let n=this.overrideConfigurations.get(e);return n||(n=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,n)),n}merge(...e){const n=I.deepClone(this.contents),s=I.deepClone(this.overrides),l=[...this.keys];for(const f of e){this.mergeContents(n,f.contents);for(const m of f.overrides){const[w]=s.filter(O=>C.equals(O.identifiers,m.identifiers));w?(this.mergeContents(w.contents,m.contents),w.keys.push(...m.keys),w.keys=C.distinct(w.keys)):s.push(I.deepClone(m))}for(const m of f.keys)l.indexOf(m)===-1&&l.push(m)}return new S(n,l,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const n=this.getContentsForOverrideIdentifer(e);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let s={};for(const l of C.distinct([...Object.keys(this.contents),...Object.keys(n)])){let f=this.contents[l],m=n[l];m&&(typeof f=="object"&&typeof m=="object"?(f=I.deepClone(f),this.mergeContents(f,m)):f=m),s[l]=f}return new S(s,this.keys,this.overrides)}mergeContents(e,n){for(const s of Object.keys(n)){if(s in e&&c.isObject(e[s])&&c.isObject(n[s])){this.mergeContents(e[s],n[s]);continue}e[s]=I.deepClone(n[s])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?I.deepFreeze(e):e}getContentsForOverrideIdentifer(e){let n=null,s=null;const l=f=>{f&&(s?this.mergeContents(s,f):s=I.deepClone(f))};for(const f of this.overrides)C.equals(f.identifiers,[e])?n=f.contents:f.identifiers.includes(e)&&l(f.contents);return l(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,n){this.addKey(e),(0,b.addToValueTree)(this.contents,e,n,s=>{throw new Error(s)})}removeValue(e){this.removeKey(e)&&(0,b.removeFromValueTree)(this.contents,e)}addKey(e){let n=this.keys.length;for(let s=0;s<n;s++)e.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,e)}removeKey(e){let n=this.keys.indexOf(e);return n!==-1?(this.keys.splice(n,1),!0):!1}}i.ConfigurationModel=S;class y extends S{constructor(e={}){const n=h.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(n),l=Object.create(null),f=[];for(const m in n){const w=e[m],O=w!==void 0?w:n[m].default;(0,b.addToValueTree)(l,m,O,N=>console.error(`Conflict in default settings: ${N}`))}for(const m of Object.keys(l))T.OVERRIDE_PROPERTY_REGEX.test(m)&&f.push({identifiers:(0,T.overrideIdentifiersFromKey)(m),keys:Object.keys(l[m]),contents:(0,b.toValuesTree)(l[m],w=>console.error(`Conflict in default settings file: ${w}`))});super(l,s,f)}}i.DefaultConfigurationModel=y;class g{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,n){if(!c.isUndefinedOrNull(e)){const s=this.doParseContent(e);this.parseRaw(s,n)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,n){this._raw=e;const{contents:s,keys:l,overrides:f,restricted:m}=this.doParseRaw(e,n);this._configurationModel=new S(s,l,f),this._restrictedConfigurations=m||[]}doParseContent(e){let n={},s=null,l=[],f=[],m=[];function w(N){Array.isArray(l)?l.push(N):s!==null&&(l[s]=N)}let O={onObjectBegin:()=>{let N={};w(N),f.push(l),l=N,s=null},onObjectProperty:N=>{s=N},onObjectEnd:()=>{l=f.pop()},onArrayBegin:()=>{let N=[];w(N),f.push(l),l=N,s=null},onArrayEnd:()=>{l=f.pop()},onLiteralValue:w,onError:(N,q,J)=>{m.push({error:N,offset:q,length:J})}};if(e)try{P.visit(e,O),n=l[0]||{}}catch(N){console.error(`Error while parsing settings file ${this._name}: ${N}`),this._parseErrors=[N]}return n}doParseRaw(e,n){const s=h.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),l=this.filter(e,s,!0,n);e=l.raw;const f=(0,b.toValuesTree)(e,O=>console.error(`Conflict in settings file ${this._name}: ${O}`)),m=Object.keys(e),w=this.toOverrides(e,O=>console.error(`Conflict in settings file ${this._name}: ${O}`));return{contents:f,keys:m,overrides:w,restricted:l.restricted}}filter(e,n,s,l){if(!l?.scopes&&!l?.skipRestricted)return{raw:e,restricted:[]};const f={},m=[];for(let w in e)if(T.OVERRIDE_PROPERTY_REGEX.test(w)&&s){const O=this.filter(e[w],n,!1,l);f[w]=O.raw,m.push(...O.restricted)}else{const O=n[w],N=O?typeof O.scope!="undefined"?O.scope:3:void 0;O?.restricted&&m.push(w),(N===void 0||l.scopes===void 0||l.scopes.includes(N))&&(l.skipRestricted&&O?.restricted||(f[w]=e[w]))}return{raw:f,restricted:m}}toOverrides(e,n){const s=[];for(const l of Object.keys(e))if(T.OVERRIDE_PROPERTY_REGEX.test(l)){const f={};for(const m in e[l])f[m]=e[l][m];s.push({identifiers:(0,T.overrideIdentifiersFromKey)(l),keys:Object.keys(f),contents:(0,b.toValuesTree)(f,n)})}return s}}i.ConfigurationModelParser=g;class a extends R.Disposable{constructor(e,n,s,l){super();this.userSettingsResource=e,this.scopes=n,this.fileService=l,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(D.Event.filter(this.fileService.onDidFilesChange,f=>f.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}i.UserSettings=a;class u{constructor(e,n,s=new S,l=new S,f=new L.ResourceMap,m=new S,w=new L.ResourceMap,O=!0){this._defaultConfiguration=e,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=l,this._folderConfigurations=f,this._memoryConfiguration=m,this._memoryConfigurationByResource=w,this._freeze=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(e,n,s){return this.getConsolidateConfigurationModel(n,s).getValue(e)}updateValue(e,n,s={}){let l;s.resource?(l=this._memoryConfigurationByResource.get(s.resource),l||(l=new S,this._memoryConfigurationByResource.set(s.resource,l))):l=this._memoryConfiguration,n===void 0?l.removeValue(e):l.setValue(e,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,n,s){const l=this.getConsolidateConfigurationModel(n,s),f=this.getFolderConfigurationModelForResource(n.resource,s),m=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,w=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),O=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),N=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),q=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),J=s?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,se=f?n.overrideIdentifier?f.freeze().override(n.overrideIdentifier).getValue(e):f.freeze().getValue(e):void 0,ie=n.overrideIdentifier?m.override(n.overrideIdentifier).getValue(e):m.getValue(e),te=l.getValue(e),ge=C.distinct(C.flatten(l.overrides.map(B=>B.identifiers))).filter(B=>l.getOverrideValue(e,B)!==void 0);return{defaultValue:w,userValue:O,userLocalValue:N,userRemoteValue:q,workspaceValue:J,workspaceFolderValue:se,memoryValue:ie,value:te,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,user:O!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userLocal:N!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userRemote:q!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspace:J!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspaceFolder:se!==void 0?{value:f?.freeze().getValue(e),override:n.overrideIdentifier?f?.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,memory:ie!==void 0?{value:m.getValue(e),override:n.overrideIdentifier?m.getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ge.length?ge:void 0}}keys(e){const n=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,n){this._folderConfigurations.set(e,n),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,n){const s=[];if(!n){const{added:l,updated:f,removed:m}=o(this._defaultConfiguration,e);n=[...l,...f,...m]}for(const l of n)for(const f of(0,T.overrideIdentifiersFromKey)(l)){const m=this._defaultConfiguration.getKeysForOverrideIdentifier(f),w=e.getKeysForOverrideIdentifier(f),O=[...w.filter(N=>m.indexOf(N)===-1),...m.filter(N=>w.indexOf(N)===-1),...m.filter(N=>!I.equals(this._defaultConfiguration.override(f).getValue(N),e.override(f).getValue(N)))];s.push([f,O])}return this.updateDefaultConfiguration(e),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(e){const{added:n,updated:s,removed:l,overrides:f}=o(this.localUserConfiguration,e),m=[...n,...s,...l];return m.length&&this.updateLocalUserConfiguration(e),{keys:m,overrides:f}}compareAndUpdateRemoteUserConfiguration(e){const{added:n,updated:s,removed:l,overrides:f}=o(this.remoteUserConfiguration,e);let m=[...n,...s,...l];return m.length&&this.updateRemoteUserConfiguration(e),{keys:m,overrides:f}}compareAndUpdateWorkspaceConfiguration(e){const{added:n,updated:s,removed:l,overrides:f}=o(this.workspaceConfiguration,e);let m=[...n,...s,...l];return m.length&&this.updateWorkspaceConfiguration(e),{keys:m,overrides:f}}compareAndUpdateFolderConfiguration(e,n){const s=this.folderConfigurations.get(e),{added:l,updated:f,removed:m,overrides:w}=o(s,n);let O=[...l,...f,...m];return(O.length||!s)&&this.updateFolderConfiguration(e,n),{keys:O,overrides:w}}compareAndDeleteFolderConfiguration(e){const n=this.folderConfigurations.get(e);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:s,updated:l,removed:f,overrides:m}=o(n,void 0);return{keys:[...s,...l,...f],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,n){let s=this.getConsolidatedConfigurationModelForResource(e,n);return e.overrideIdentifier?s.override(e.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:e},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&e){const l=n.getFolder(e);l&&(s=this.getFolderConsolidatedConfiguration(l.uri)||s);const f=this._memoryConfigurationByResource.get(e);f&&(s=s.merge(f))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let n=this._foldersConsolidatedConfigurations.get(e);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(e);l?(n=s.merge(l),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(e,n)):n=s}return n}getFolderConfigurationModelForResource(e,n){if(n&&e){const s=n.getFolder(e);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,n)=>{const{contents:s,overrides:l,keys:f}=this._folderConfigurations.get(n);return e.push([n,{contents:s,overrides:l,keys:f}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>e.add(n)),this.userConfiguration.freeze().keys.forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>e.add(s))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(s=>e.add(s))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(e).forEach(l=>n.add(l))),[...n.values()]}static parse(e){const n=this.parseConfigurationModel(e.defaults),s=this.parseConfigurationModel(e.user),l=this.parseConfigurationModel(e.workspace),f=e.folders.reduce((m,w)=>(m.set(d.URI.revive(w[0]),this.parseConfigurationModel(w[1])),m),new L.ResourceMap);return new u(n,s,new S,l,f,new S,new L.ResourceMap,!1)}static parseConfigurationModel(e){return new S(e.contents,e.keys,e.overrides).freeze()}}i.Configuration=u;function v(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const e=new Set,n=new Map;for(const l of r)l.keys.forEach(f=>e.add(f)),l.overrides.forEach(([f,m])=>{const w=(0,L.getOrSet)(n,f,new Set);m.forEach(O=>w.add(O))});const s=[];return n.forEach((l,f)=>s.push([f,[...l.values()]])),{keys:[...e.values()],overrides:s}}i.mergeChanges=v;class E{constructor(e,n,s,l){this.change=e,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=l,this._previousConfiguration=void 0;const f=new Set;e.keys.forEach(w=>f.add(w)),e.overrides.forEach(([,w])=>w.forEach(O=>f.add(O))),this.affectedKeys=[...f.values()];const m=new S;this.affectedKeys.forEach(w=>m.setValue(w,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=u.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(n){const s=this.previousConfiguration?this.previousConfiguration.getValue(e,n,this.previous?.workspace):void 0,l=this.currentConfiguraiton.getValue(e,n,this.currentWorkspace);return!I.equals(s,l)}return!0}return!1}doesAffectedKeysTreeContains(e,n){let s=(0,b.toValuesTree)({[n]:!0},()=>{}),l;for(;typeof s=="object"&&(l=Object.keys(s)[0]);){if(e=e[l],!e)return!1;s=s[l]}return!0}}i.ConfigurationChangeEvent=E;class p extends E{constructor(e,n,s,l){super({keys:e.allKeys(),overrides:[]},void 0,e,n);this.source=s,this.sourceConfig=l}}i.AllKeysConfigurationChangeEvent=p;function o(r,e){const{added:n,removed:s,updated:l}=t(e,r),f=[],m=r?.getAllOverrideIdentifiers()||[],w=e?.getAllOverrideIdentifiers()||[];if(e){const O=w.filter(N=>!m.includes(N));for(const N of O)f.push([N,e.getKeysForOverrideIdentifier(N)])}if(r){const O=m.filter(N=>!w.includes(N));for(const N of O)f.push([N,r.getKeysForOverrideIdentifier(N)])}if(e&&r){for(const O of m)if(w.includes(O)){const N=t({contents:r.getOverrideValue(void 0,O)||{},keys:r.getKeysForOverrideIdentifier(O)},{contents:e.getOverrideValue(void 0,O)||{},keys:e.getKeysForOverrideIdentifier(O)});f.push([O,[...N.added,...N.removed,...N.updated]])}}return{added:n,removed:s,updated:l,overrides:f}}function t(r,e){const n=r?e?r.keys.filter(f=>e.keys.indexOf(f)===-1):[...r.keys]:[],s=e?r?e.keys.filter(f=>r.keys.indexOf(f)===-1):[...e.keys]:[],l=[];if(r&&e){for(const f of e.keys)if(r.keys.indexOf(f)!==-1){const m=(0,b.getConfigurationValue)(e.contents,f),w=(0,b.getConfigurationValue)(r.contents,f);I.equals(m,w)||l.push(f)}}return{added:n,removed:s,updated:l}}}),define(Q[107],Z([0,1,3,6,2,19,25,106,34,30]),function(z,i,C,D,P,R,L,I,c,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationService=void 0;class b extends P.Disposable{constructor(h,S){super();this.settingsResource=h,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,S)),this.configuration=new I.Configuration(new I.DefaultConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new C.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(d.Registry.as(c.Extensions.Configuration).onDidUpdateConfiguration(({properties:y})=>this.onDidDefaultConfigurationChange(y))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const h=await this.userConfiguration.loadConfiguration();this.configuration=new I.Configuration(new I.DefaultConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(h,S){const y=typeof h=="string"?h:void 0,g=(0,L.isConfigurationOverrides)(h)?h:(0,L.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(y,g,void 0)}updateValue(h,S,y,g){return Promise.reject(new Error("not supported"))}inspect(h){return this.configuration.inspect(h,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const h=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(h)}onDidChangeUserConfiguration(h){const S=this.configuration.toData(),y=this.configuration.compareAndUpdateLocalUserConfiguration(h);this.trigger(y,S,1)}onDidDefaultConfigurationChange(h){const S=this.configuration.toData(),y=this.configuration.compareAndUpdateDefaultConfiguration(new I.DefaultConfigurationModel,h);this.trigger(y,S,6)}trigger(h,S,y){const g=new I.ConfigurationChangeEvent(h,{data:S},this.configuration);g.source=y,g.sourceConfig=this.getTargetConfiguration(y),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(h){switch(h){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}i.ConfigurationService=b}),define(Q[108],Z([0,1,10]),function(z,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isVirtualWorkspace=i.getVirtualWorkspaceScheme=i.getVirtualWorkspaceLocation=i.isVirtualResource=i.getRemoteName=i.getRemoteAuthority=void 0;function D(d){return d.scheme===C.Schemas.vscodeRemote?d.authority:void 0}i.getRemoteAuthority=D;function P(d){if(!d)return;const b=d.indexOf("+");return b<0?d:d.substr(0,b)}i.getRemoteName=P;function R(d){return d.scheme!==C.Schemas.file&&d.scheme!==C.Schemas.vscodeRemote}i.isVirtualResource=R;function L(d){if(d.folders.length)return d.folders.every(b=>R(b.uri))?d.folders[0].uri:void 0;if(d.configuration&&R(d.configuration))return d.configuration}i.getVirtualWorkspaceLocation=L;function I(d){return L(d)?.scheme}i.getVirtualWorkspaceScheme=I;function c(d){return L(d)!==void 0}i.isVirtualWorkspace=c}),define(Q[40],Z([0,1,26,13,108]),function(z,i,C,D,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IBuiltinExtensionsScannerService=i.isResolverExtension=i.isAuthenticationProviderExtension=i.isLanguagePackExtension=i.ExtensionIdentifier=i.ExtensionType=i.EXTENSION_CATEGORIES=i.isIExtensionIdentifier=i.getWorkspaceSupportTypeMessage=i.ALL_EXTENSION_KINDS=i.BUILTIN_MANIFEST_CACHE_FILE=i.USER_MANIFEST_CACHE_FILE=i.MANIFEST_CACHE_FOLDER=void 0,i.MANIFEST_CACHE_FOLDER="CachedExtensions",i.USER_MANIFEST_CACHE_FILE="user",i.BUILTIN_MANIFEST_CACHE_FILE="builtin",i.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}i.getWorkspaceSupportTypeMessage=R;function L(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}i.isIExtensionIdentifier=L,i.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(I=i.ExtensionType||(i.ExtensionType={}));class c{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,y){if(typeof S=="undefined"||S===null)return typeof y=="undefined"||y===null;if(typeof y=="undefined"||y===null)return!1;if(typeof S=="string"||typeof y=="string"){let g=typeof S=="string"?S:S.value,a=typeof y=="string"?y:y.value;return C.equalsIgnoreCase(g,a)}return S._lower===y._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}i.ExtensionIdentifier=c;function d(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}i.isLanguagePackExtension=d;function b(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}i.isAuthenticationProviderExtension=b;function T(h,S){if(S){const y=`onResolveRemoteAuthority:${(0,P.getRemoteName)(S)}`;return h.activationEvents?.indexOf(y)!==-1}return!1}i.isResolverExtension=T,i.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[21],Z([0,1,26,40]),function(z,i,C,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getExtensionDependencies=i.getMaliciousExtensionsSet=i.BetterMergeId=i.getGalleryExtensionTelemetryData=i.getLocalExtensionTelemetryData=i.groupByExtension=i.getGalleryExtensionId=i.adoptToGalleryExtensionId=i.getExtensionId=i.ExtensionIdentifierWithVersion=i.areSameExtensions=void 0;function P(y,g){return y.uuid&&g.uuid?y.uuid===g.uuid:y.id===g.id?!0:(0,C.compareIgnoreCase)(y.id,g.id)===0}i.areSameExtensions=P;class R{constructor(g,a){this.version=a,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof R?P(this,g)&&this.version===g.version:!1}}i.ExtensionIdentifierWithVersion=R;function L(y,g){return`${y}.${g}`}i.getExtensionId=L;function I(y){return y.toLocaleLowerCase()}i.adoptToGalleryExtensionId=I;function c(y,g){return I(L(y,g))}i.getGalleryExtensionId=c;function d(y,g){const a=[],u=v=>{for(const E of a)if(E.some(p=>P(g(p),g(v))))return E;return null};for(const v of y){const E=u(v);E?E.push(v):a.push([v])}return a}i.groupByExtension=d;function b(y){return{id:y.identifier.id,name:y.manifest.name,galleryId:null,publisherId:y.publisherId,publisherName:y.manifest.publisher,publisherDisplayName:y.publisherDisplayName,dependencies:y.manifest.extensionDependencies&&y.manifest.extensionDependencies.length>0}}i.getLocalExtensionTelemetryData=b;function T(y){return{id:y.identifier.id,name:y.name,galleryId:y.identifier.uuid,publisherId:y.publisherId,publisherName:y.publisher,publisherDisplayName:y.publisherDisplayName,isPreReleaseVersion:y.properties.isPreReleaseVersion,dependencies:!!(y.properties.dependencies&&y.properties.dependencies.length>0),...y.telemetryData}}i.getGalleryExtensionTelemetryData=T,i.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function h(y){const g=new Set;if(y.malicious)for(const a of y.malicious)g.add(a.id);return g}i.getMaliciousExtensionsSet=h;function S(y,g){const a=[],u=g.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const v=u.shift();if(v&&a.every(E=>!P(E.identifier,{id:v}))){const E=y.filter(p=>P(p.identifier,{id:v}));E.length===1&&(a.push(E[0]),u.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}i.getExtensionDependencies=S}),define(Q[23],Z([0,1,10,76,21,13]),function(z,i,C,D,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IExtensionManagementCLIService=i.PreferencesLocalizedLabel=i.PreferencesLabel=i.ExtensionsChannelId=i.ExtensionsLocalizedLabel=i.ExtensionsLabel=i.DefaultIconPath=i.IExtensionTipsService=i.IGlobalExtensionEnablementService=i.ENABLED_EXTENSIONS_STORAGE_PATH=i.DISABLED_EXTENSIONS_STORAGE_PATH=i.IExtensionManagementService=i.ExtensionManagementError=i.ExtensionManagementErrorCode=i.IExtensionGalleryService=i.InstallOperation=i.StatisticType=i.SortOrder=i.SortBy=i.isIExtensionIdentifier=i.getFallbackTargetPlarforms=i.isTargetPlatformCompatible=i.isNotWebExtensionInWebTargetPlatform=i.getTargetPlatform=i.toTargetPlatform=i.TargetPlatformToString=i.TargetPlatform=i.getIdAndVersion=i.WEB_EXTENSION_TAG=i.EXTENSION_IDENTIFIER_REGEX=i.EXTENSION_IDENTIFIER_PATTERN=void 0,i.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",i.EXTENSION_IDENTIFIER_REGEX=new RegExp(i.EXTENSION_IDENTIFIER_PATTERN),i.WEB_EXTENSION_TAG="__web_extension";const L=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function I(t){const r=L.exec(t);return r&&r[1]?[(0,P.adoptToGalleryExtensionId)(r[1]),r[2]]:[(0,P.adoptToGalleryExtensionId)(t),void 0]}i.getIdAndVersion=I;var c;(function(t){t.WIN32_X64="win32-x64",t.WIN32_IA32="win32-ia32",t.WIN32_ARM64="win32-arm64",t.LINUX_X64="linux-x64",t.LINUX_ARM64="linux-arm64",t.LINUX_ARMHF="linux-armhf",t.ALPINE_X64="alpine-x64",t.ALPINE_ARM64="alpine-arm64",t.DARWIN_X64="darwin-x64",t.DARWIN_ARM64="darwin-arm64",t.WEB="web",t.UNIVERSAL="universal",t.UNKNOWN="unknown",t.UNDEFINED="undefined"})(c=i.TargetPlatform||(i.TargetPlatform={}));function d(t){switch(t){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}i.TargetPlatformToString=d;function b(t){switch(t){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}i.toTargetPlatform=b;function T(t,r){switch(t){case 3:return r==="x64"?"win32-x64":r==="ia32"?"win32-ia32":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}i.getTargetPlatform=T;function h(t,r){return r==="web"&&!t.includes("web")}i.isNotWebExtensionInWebTargetPlatform=h;function S(t,r,e){return h(r,e)?!1:t==="undefined"||t==="universal"?!0:t==="unknown"?!1:t===e?!0:y(e).includes(t)}i.isTargetPlatformCompatible=S;function y(t){switch(t){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}i.getFallbackTargetPlarforms=y;function g(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}i.isIExtensionIdentifier=g;var a;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(a=i.SortBy||(i.SortBy={}));var u;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(u=i.SortOrder||(i.SortOrder={}));var v;(function(t){t.Install="install",t.Uninstall="uninstall"})(v=i.StatisticType||(i.StatisticType={}));var E;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(E=i.InstallOperation||(i.InstallOperation={})),i.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var p;(function(t){t.Unsupported="Unsupported",t.UnsupportedPreRelease="UnsupportedPreRelease",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatiblePreRelease="IncompatiblePreRelease",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.Extract="Extract",t.Delete="Delete",t.Rename="Rename",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Internal="Internal"})(p=i.ExtensionManagementErrorCode||(i.ExtensionManagementErrorCode={}));class o extends Error{constructor(r,e){super(r);this.code=e,this.name=e}}i.ExtensionManagementError=o,i.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),i.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",i.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",i.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),i.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),i.DefaultIconPath=C.FileAccess.asBrowserUri("./media/defaultIcon.png",z).toString(!0),i.ExtensionsLabel=(0,D.localize)(0,null),i.ExtensionsLocalizedLabel={value:i.ExtensionsLabel,original:"Extensions"},i.ExtensionsChannelId="extensions",i.PreferencesLabel=(0,D.localize)(1,null),i.PreferencesLocalizedLabel={value:i.PreferencesLabel,original:"Preferences"},i.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")}),define(Q[109],Z([0,1,24,7,62,10,41,9,77,23,21,40]),function(z,i,C,D,P,R,L,I,c,d,b,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementCLIService=void 0;const h=a=>(0,c.localize)(0,null,a),S=(0,c.localize)(1,null,"ms-dotnettools.csharp");function y(a,u){return u?`${a.publisher}.${a.name}@${a.version}`:`${a.publisher}.${a.name}`}let g=class{constructor(u,v){this.extensionManagementService=u,this.extensionGalleryService=v}get location(){}async listExtensions(u,v,E=console){let p=await this.extensionManagementService.getInstalled(1);const o=T.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(v&&v!==""){if(o.indexOf(v.toLowerCase())<0){E.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(r=>r.manifest.categories?r.manifest.categories.map(n=>n.toLowerCase()).indexOf(v.toLowerCase())>-1:!1)}else if(v===""){E.log("Possible Categories: "),o.forEach(r=>{E.log(r)});return}this.location&&E.log((0,c.localize)(2,null,this.location)),p=p.sort((r,e)=>r.identifier.id.localeCompare(e.identifier.id));let t;for(let r of p)t!==r.identifier.id&&(t=r.identifier.id,E.log(y(r.manifest,u)))}async installExtensions(u,v,E,p,o=console){const t=[],r=[];u.length&&o.log(this.location?(0,c.localize)(3,null,this.location):(0,c.localize)(4,null));const e=await this.extensionManagementService.getInstalled(1),n=(f,m)=>{const w=e.find(O=>(0,b.areSameExtensions)(O.identifier,{id:f}));if(w){if(!m&&!p)return o.log((0,c.localize)(5,null,f,w.manifest.version,f)),!1;if(m&&w.manifest.version===m)return o.log((0,c.localize)(6,null,`${f}@${m}`)),!1}return!0},s=[],l=[];for(const f of u)if(f instanceof I.URI)s.push(f);else{const[m,w]=(0,d.getIdAndVersion)(f);n(m,w)&&l.push({id:m,version:w,installOptions:{...E,isBuiltin:!1}})}for(const f of v){const[m,w]=(0,d.getIdAndVersion)(f);n(m,w)&&l.push({id:m,version:w,installOptions:{...E,isBuiltin:!0}})}if(s.length&&await Promise.all(s.map(async f=>{try{const m=await this.installVSIX(f,{...E,isBuiltin:!1},p,o);m&&r.push(m)}catch(m){o.error(m.message||m.stack||m),t.push(f.toString())}})),l.length){const f=await this.getGalleryExtensions(l);await Promise.all(l.map(async m=>{const w=f.get(m.id.toLowerCase());if(w)try{const O=await this.installFromGallery(m,w,e,p,o);O&&r.push(O)}catch(O){o.error(O.message||O.stack||O),t.push(m.id)}else o.error(`${h(m.version?`${m.id}@${m.version}`:m.id)}
${S}`),t.push(m.id)}))}if(t.length)throw new Error((0,c.localize)(7,null,t.join(", ")))}async installVSIX(u,v,E,p){const o=await this.extensionManagementService.getManifest(u);if(!o)throw new Error("Invalid vsix");if(await this.validateVSIX(o,E,p))try{return await this.extensionManagementService.install(u,v),p.log((0,c.localize)(8,null,(0,P.getBaseLabel)(u))),o}catch(r){if((0,D.isCancellationError)(r))return p.log((0,c.localize)(9,null,(0,P.getBaseLabel)(u))),null;throw r}return null}async getGalleryExtensions(u){const v=new Map,E=u.some(o=>o.installOptions.installPreReleaseVersion),p=await this.extensionGalleryService.getExtensions(u.map(o=>({...o,preRelease:E})),C.CancellationToken.None);for(const o of p)v.set(o.identifier.id.toLowerCase(),o);return v}async installFromGallery({id:u,version:v,installOptions:E},p,o,t,r){const e=await this.extensionGalleryService.getManifest(p,C.CancellationToken.None);if(e&&!this.validateExtensionKind(e,r))return null;const n=o.find(s=>(0,b.areSameExtensions)(s.identifier,p.identifier));if(n){if(p.version===n.manifest.version)return r.log((0,c.localize)(10,null,v?`${u}@${v}`:u)),null;r.log((0,c.localize)(11,null,u,p.version))}try{return E.isBuiltin?r.log(v?(0,c.localize)(12,null,u,v):(0,c.localize)(13,null,u)):r.log(v?(0,c.localize)(14,null,u,v):(0,c.localize)(15,null,u)),await this.extensionManagementService.installFromGallery(p,{...E,installGivenVersion:!!v}),r.log((0,c.localize)(16,null,u,p.version)),e}catch(s){if((0,D.isCancellationError)(s))return r.log((0,c.localize)(17,null,u)),null;throw s}}validateExtensionKind(u,v){return!0}async validateVSIX(u,v,E){const p={id:(0,b.getGalleryExtensionId)(u.publisher,u.name)},t=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,b.areSameExtensions)(p,r.identifier)&&(0,L.gt)(r.manifest.version,u.version));return t&&!v?(E.log((0,c.localize)(18,null,t.identifier.id,t.manifest.version,u.version)),!1):this.validateExtensionKind(u,E)}async uninstallExtensions(u,v,E=console){const p=async t=>{if(t instanceof I.URI){const r=await this.extensionManagementService.getManifest(t);return y(r)}return t},o=[];for(const t of u){const r=await p(t),n=(await this.extensionManagementService.getInstalled()).filter(s=>(0,b.areSameExtensions)(s.identifier,{id:r}));if(!n.length)throw new Error(`${this.notInstalled(r)}
${S}`);if(n.some(s=>s.type===0)){E.log((0,c.localize)(19,null,r));return}if(!v&&n.some(s=>s.isBuiltin)){E.log((0,c.localize)(20,null,r));return}E.log((0,c.localize)(21,null,r));for(const s of n)await this.extensionManagementService.uninstall(s),o.push(s);this.location?E.log((0,c.localize)(22,null,r,this.location)):E.log((0,c.localize)(23,null,r))}}async locateExtension(u,v=console){const E=await this.extensionManagementService.getInstalled();u.forEach(p=>{E.forEach(o=>{if(o.identifier.id===p&&o.location.scheme===R.Schemas.file){v.log(o.location.fsPath);return}})})}notInstalled(u){return this.location?(0,c.localize)(24,null,u,this.location):(0,c.localize)(25,null,u)}};g=pe([oe(0,d.IExtensionManagementService),oe(1,d.IExtensionGalleryService)],g),i.ExtensionManagementCLIService=g}),define(Q[110],Z([0,1,3,7,2,12,19,41,9,27,15,20,23,21,16,14]),function(z,i,C,D,P,R,L,I,c,d,b,T,h,S,y,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsDownloader=void 0;const a=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let u=class extends P.Disposable{constructor(E,p,o,t){super();this.fileService=p,this.extensionGalleryService=o,this.logService=t,this.extensionsDownloadDir=c.URI.file(E.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(E,p){await this.cleanUpPromise;const o=this.getName(E),t=(0,L.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(t)){const r=(0,L.joinPath)(this.extensionsDownloadDir,`.${(0,d.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(E,r,p);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(e){try{await this.fileService.del(r)}catch{}if(e.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",E.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(e)}. Deleted the vsix from downloaded location`,r.path),e}}return t}async delete(E){await this.cleanUpPromise,await this.fileService.del(E)}async rename(E,p,o){try{await b.Promises.rename(E.fsPath,p.fsPath)}catch(t){if(R.isWindows&&t&&t.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${E} to ${p} with 'EPERM' error. Trying again...`),this.rename(E,p,o);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const E=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(E.children){const p=[],o=[];for(const e of E.children){const n=this.parse(e.name);n&&o.push([n,e])}const t=(0,S.groupByExtension)(o,([e])=>e),r=[];for(const e of t)e.sort((n,s)=>I.rcompare(n[0].version,s[0].version)),p.push(...e.slice(1).map(n=>n[1].resource)),r.push(e[0][1]);r.sort((e,n)=>e.mtime-n.mtime),p.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(e=>e.resource)),await C.Promises.settled(p.map(e=>(this.logService.trace("Deleting vsix from cache",e.path),this.fileService.del(e))))}}catch(E){this.logService.error(E)}}getName(E){return this.cache?`${new S.ExtensionIdentifierWithVersion(E.identifier,E.version).key().toLowerCase()}${E.properties.targetPlatform!=="undefined"?`-${E.properties.targetPlatform}`:""}`:(0,d.generateUuid)()}parse(E){const p=a.exec(E);return p&&p[1]&&p[2]?new S.ExtensionIdentifierWithVersion({id:p[1]},p[2]):null}};u=pe([oe(0,T.INativeEnvironmentService),oe(1,y.IFileService),oe(2,h.IExtensionGalleryService),oe(3,g.ILogService)],u),i.ExtensionsDownloader=u}),define(Q[111],Z([0,1,2,11,15,40]),function(z,i,C,D,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsManifestCache=void 0;class L extends C.Disposable{constructor(c,d){super();this.environmentService=c,this.extensionsManifestCache=(0,D.join)(this.environmentService.userDataPath,R.MANIFEST_CACHE_FOLDER,R.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtensions(b=>this.onDidInstallExtensions(b))),this._register(d.onDidUninstallExtension(b=>this.onDidUnInstallExtension(b)))}onDidInstallExtensions(c){c.some(d=>!!d.local)&&this.invalidate()}onDidUnInstallExtension(c){c.error||this.invalidate()}invalidate(){P.Promises.rm(this.extensionsManifestCache,P.RimRafMode.MOVE).then(()=>{},()=>{})}}i.ExtensionsManifestCache=L}),define(Q[112],Z([0,1,137,18,3,2,10,11,15,20,23,21,53,14]),function(z,i,C,D,P,R,L,I,c,d,b,T,h,S){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LocalizationsService=void 0;let y=class extends R.Disposable{constructor(u,v,E){super();this.extensionManagementService=u,this.logService=E,this.cache=this._register(new g(v,E)),this.extensionManagementService.registerParticipant({postInstall:async p=>this.postInstallExtension(p),postUninstall:async p=>this.postUninstallExtension(p)})}async getLanguageIds(){const u=await this.cache.getLanguagePacks(),v=["en",...Object.keys(u)];return(0,D.distinct)(v)}async postInstallExtension(u){u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",u.identifier.id),await this.update())}async postUninstallExtension(u){const v=await this.cache.getLanguagePacks();Object.keys(v).some(E=>v[E]&&v[E].extensions.some(p=>(0,T.areSameExtensions)(p.extensionIdentifier,u.identifier)))&&(this.logService.info("Removing language packs from the extension",u.identifier.id),await this.update())}async update(){const[u,v]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),E=await this.cache.update(v);return!(0,D.equals)(Object.keys(u),Object.keys(E))}};y=pe([oe(0,b.IExtensionManagementService),oe(1,d.INativeEnvironmentService),oe(2,S.ILogService)],y),i.LocalizationsService=y;let g=class extends R.Disposable{constructor(u,v){super();this.logService=v,this.languagePacks={},this.languagePacksFilePath=(0,I.join)(u.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new P.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(u){return this.withLanguagePacks(v=>{Object.keys(v).forEach(E=>delete v[E]),this.createLanguagePacksFromExtensions(v,...u)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(u,...v){for(const E of v)E&&E.manifest&&E.manifest.contributes&&E.manifest.contributes.localizations&&E.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(u,E);Object.keys(u).forEach(E=>this.updateHash(u[E]))}createLanguagePacksFromExtension(u,v){const E=v.identifier,p=v.manifest.contributes&&v.manifest.contributes.localizations?v.manifest.contributes.localizations:[];for(const o of p)if(v.location.scheme===L.Schemas.file&&(0,h.isValidLocalization)(o)){let t=u[o.languageId];t||(t={hash:"",extensions:[],translations:{}},u[o.languageId]=t);let r=t.extensions.filter(e=>(0,T.areSameExtensions)(e.extensionIdentifier,E))[0];r?r.version=v.manifest.version:t.extensions.push({extensionIdentifier:E,version:v.manifest.version});for(const e of o.translations)t.translations[e.id]=(0,I.join)(v.location.fsPath,e.path)}}updateHash(u){if(u){const v=(0,C.createHash)("md5");for(const E of u.extensions)v.update(E.extensionIdentifier.uuid||E.extensionIdentifier.id).update(E.version);u.hash=v.digest("hex")}}withLanguagePacks(u=()=>null){return this.languagePacksFileLimiter.queue(()=>{let v=null;return c.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,E=>E.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(E)).then(E=>{try{return JSON.parse(E)}catch{return{}}}).then(E=>(v=u(E),E)).then(E=>{for(const o of Object.keys(E))E[o]||delete E[o];this.languagePacks=E,this.initializedCache=!0;const p=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",p),c.Promises.writeFile(this.languagePacksFilePath,p)}).then(()=>v,E=>this.logService.error(E))})}};g=pe([oe(0,d.INativeEnvironmentService),oe(1,S.ILogService)],g)}),define(Q[42],Z([0,1,17,85,34,13,30]),function(z,i,C,D,P,R,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.updateProxyConfigurationsScope=i.asJson=i.asText=i.isSuccess=i.IRequestService=void 0,i.IRequestService=(0,R.createDecorator)("requestService");function I(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}i.isSuccess=I;function c(y){return y.res.statusCode===204}async function d(y){if(!I(y))throw new Error("Server returned "+y.res.statusCode);return c(y)?null:(await(0,C.streamToBuffer)(y.stream)).toString()}i.asText=d;async function b(y){if(!I(y))throw new Error("Server returned "+y.res.statusCode);if(c(y))return null;const a=(await(0,C.streamToBuffer)(y.stream)).toString();try{return JSON.parse(a)}catch(u){throw u.message+=`:
`+a,u}}i.asJson=b;function T(y){S(y)}i.updateProxyConfigurationsScope=T;let h;function S(y){const g=L.Registry.as(P.Extensions.Configuration),a=h;h={id:"http",order:15,title:(0,D.localize)(0,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(4,null),(0,D.localize)(5,null),(0,D.localize)(6,null),(0,D.localize)(7,null)],default:"override",description:(0,D.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(9,null),restricted:!0}}},g.updateConfigurations({add:[h],remove:a?[a]:[]})}S(2)}),define(Q[113],Z([0,1,24,10,16,42]),function(z,i,C,D,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DownloadService=void 0;let L=class{constructor(c,d){this.requestService=c,this.fileService=d}async download(c,d,b=C.CancellationToken.None){if(c.scheme===D.Schemas.file||c.scheme===D.Schemas.vscodeRemote){await this.fileService.copy(c,d);return}const T={type:"GET",url:c.toString()},h=await this.requestService.request(T,b);if(h.res.statusCode===200)await this.fileService.writeFile(d,h.stream);else{const S=await(0,R.asText)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${S}`)}}};L=pe([oe(0,R.IRequestService),oe(1,P.IFileService)],L),i.DownloadService=L}),define(Q[114],Z([0,1,115,8]),function(z,i,C,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getProxyAgent=void 0;function P(L,I){return L.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:L.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function R(L,I,c={}){const d=(0,C.parse)(L),b=c.proxyUrl||P(d,I);if(!b)return null;const T=(0,C.parse)(b);if(!/^https?:$/.test(T.protocol||""))return null;const h={host:T.hostname||"",port:T.port||(T.protocol==="https"?"443":"80"),auth:T.auth,rejectUnauthorized:(0,D.isBoolean)(c.strictSSL)?c.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((S,y)=>{z(["http-proxy-agent"],S,y)}))(h):new(await new Promise((S,y)=>{z(["https-proxy-agent"],S,y)}))(h)}i.getProxyAgent=R}),define(Q[116],Z([0,1,17,27]),function(z,i,C,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getServiceMachineId=void 0;async function P(R,L,I){let c=I&&I.get("storage.serviceMachineId",0)||null;if(c)return c;try{const b=(await L.readFile(R.serviceMachineIdResource)).value.toString();c=(0,D.isUUID)(b)?b:null}catch{c=null}if(!c){c=(0,D.generateUuid)();try{await L.writeFile(R.serviceMachineIdResource,C.VSBuffer.fromString(c))}catch{}}return I&&I.store("storage.serviceMachineId",c,0,1),c}i.getServiceMachineId=P}),define(Q[117],Z([0,1,3,6,2,101,8,65,13]),function(z,i,C,D,P,R,L,I,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.logStorage=i.InMemoryStorageService=i.AbstractStorageService=i.StorageTarget=i.StorageScope=i.WillSaveStateReason=i.IStorageService=i.IS_NEW_KEY=void 0,i.IS_NEW_KEY="__$__isNewStorageMarker";const d="__$__targetStorageMarker";i.IStorageService=(0,c.createDecorator)("storageService");var b;(function(a){a[a.NONE=0]="NONE",a[a.SHUTDOWN=1]="SHUTDOWN"})(b=i.WillSaveStateReason||(i.WillSaveStateReason={}));var T;(function(a){a[a.GLOBAL=0]="GLOBAL",a[a.WORKSPACE=1]="WORKSPACE"})(T=i.StorageScope||(i.StorageScope={}));var h;(function(a){a[a.USER=0]="USER",a[a.MACHINE=1]="MACHINE"})(h=i.StorageTarget||(i.StorageTarget={}));class S extends P.Disposable{constructor(u={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super();this.options=u,this._onDidChangeValue=this._register(new D.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new D.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new D.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new P.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,C.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,P.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(u,v){v===d?(u===0?this._globalKeyTargets=void 0:u===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:u})):this._onDidChangeValue.fire({scope:u,key:v,target:this.getKeyTargets(u)[v]})}emitWillSaveState(u){this._onWillSaveState.fire({reason:u})}get(u,v,E){return this.getStorage(v)?.get(u,E)}getBoolean(u,v,E){return this.getStorage(v)?.getBoolean(u,E)}getNumber(u,v,E){return this.getStorage(v)?.getNumber(u,E)}store(u,v,E,p){if((0,L.isUndefinedOrNull)(v)){this.remove(u,E);return}this.withPausedEmitters(()=>{this.updateKeyTarget(u,E,p),this.getStorage(E)?.set(u,v)})}remove(u,v){this.withPausedEmitters(()=>{this.updateKeyTarget(u,v,void 0),this.getStorage(v)?.delete(u)})}withPausedEmitters(u){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{u()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(u,v){const E=[],p=this.getKeyTargets(u);for(const o of Object.keys(p))p[o]===v&&E.push(o);return E}updateKeyTarget(u,v,E){const p=this.getKeyTargets(v);typeof E=="number"?p[u]!==E&&(p[u]=E,this.getStorage(v)?.set(d,JSON.stringify(p))):typeof p[u]=="number"&&(delete p[u],this.getStorage(v)?.set(d,JSON.stringify(p)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(u){return u===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(u){const v=this.get(d,u);if(v)try{return JSON.parse(v)}catch{}return Object.create(null)}isNew(u){return this.getBoolean(i.IS_NEW_KEY,u)===!0}async flush(u=b.NONE){this._onWillSaveState.fire({reason:u});const v=this.getStorage(0),E=this.getStorage(1);switch(u){case b.NONE:await C.Promises.settled([v?.whenFlushed()??Promise.resolve(),E?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await C.Promises.settled([v?.flush(0)??Promise.resolve(),E?.flush(0)??Promise.resolve()]);break}}async logStorage(){const u=this.getStorage(0)?.items??new Map,v=this.getStorage(1)?.items??new Map;return g(u,v,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}i.AbstractStorageService=S,S.DEFAULT_FLUSH_INTERVAL=60*1e3;class y extends S{constructor(){super();this.globalStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(u=>this.emitDidChangeValue(1,u))),this._register(this.globalStorage.onDidChangeStorage(u=>this.emitDidChangeValue(0,u)))}getStorage(u){return u===0?this.globalStorage:this.workspaceStorage}getLogDetails(u){return u===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(u){}}i.InMemoryStorageService=y;async function g(a,u,v,E){const p=l=>{try{return JSON.parse(l)}catch{return l}},o=new Map,t=new Map;a.forEach((l,f)=>{o.set(f,l),t.set(f,p(l))});const r=new Map,e=new Map;u.forEach((l,f)=>{r.set(f,l),e.set(f,p(l))}),console.group(`Storage: Global (path: ${v})`);let n=[];o.forEach((l,f)=>{n.push({key:f,value:l})}),console.table(n),console.groupEnd(),console.log(t),console.group(`Storage: Workspace (path: ${E})`);let s=[];r.forEach((l,f)=>{s.push({key:f,value:l})}),console.table(s),console.groupEnd(),console.log(e)}i.logStorage=g}),define(Q[118],Z([0,1,12,29,9,27]),function(z,i,C,D,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.verifyMicrosoftInternalDomain=i.resolveCommonProperties=void 0;function L(d){if(C.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function I(d,b,T,h,S,y,g,a,u,v){const E=Object.create(null);E["common.machineId"]=g,E.sessionID=(0,R.generateUuid)()+Date.now(),E.commitHash=S,E.version=y,E["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,C.PlatformToString)(C.platform),E["common.nodePlatform"]=D.platform,E["common.nodeArch"]=h,E["common.product"]=v||"desktop";const p=c(a||[]);p&&(E["common.msftInternal"]=p);let o=0;const t=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),C.isLinuxSnap&&(E["common.snap"]="true");const r=L(T);r&&(E["common.platformDetail"]=r);try{const e=await d.readFile(P.URI.file(u));E["common.source"]=e.value.toString().slice(0,30)}catch{}return E}i.resolveCommonProperties=I;function c(d){const b=D.env.USERDNSDOMAIN;if(!b)return!1;const T=b.toLowerCase();return d.some(h=>T===h)}i.verifyMicrosoftInternalDomain=c}),define(Q[31],Z([0,1,13]),function(z,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryConfiguration=i.TelemetryLevel=i.TELEMETRY_OLD_SETTING_ID=i.TELEMETRY_SETTING_ID=i.TELEMETRY_SECTION_ID=i.machineIdKey=i.lastSessionDateStorageKey=i.firstSessionDateStorageKey=i.currentSessionDateStorageKey=i.ICustomEndpointTelemetryService=i.ITelemetryService=void 0,i.ITelemetryService=(0,C.createDecorator)("telemetryService"),i.ICustomEndpointTelemetryService=(0,C.createDecorator)("customEndpointTelemetryService"),i.currentSessionDateStorageKey="telemetry.currentSessionDate",i.firstSessionDateStorageKey="telemetry.firstSessionDate",i.lastSessionDateStorageKey="telemetry.lastSessionDate",i.machineIdKey="telemetry.machineId",i.TELEMETRY_SECTION_ID="telemetry",i.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",i.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var D;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(D=i.TelemetryLevel||(i.TelemetryLevel={}));var P;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(P=i.TelemetryConfiguration||(i.TelemetryConfiguration={}))}),define(Q[119],Z([0,1,18,3,24,7,6,2,12,8,9,75,23,21,14,32,31]),function(z,i,C,D,P,R,L,I,c,d,b,T,h,S,y,g,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractExtensionTask=i.reportTelemetry=i.joinErrors=i.AbstractExtensionManagementService=void 0;let u=class extends I.Disposable{constructor(r,e,n,s){super();this.galleryService=r,this.telemetryService=e,this.logService=n,this.productService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new L.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new L.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new L.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new L.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,I.toDisposable)(()=>{this.installingExtensions.forEach(l=>l.cancel()),this.uninstallingExtensions.forEach(l=>l.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(r){const e=await this.getTargetPlatform();return r.allTargetPlatforms.some(n=>(0,h.isTargetPlatformCompatible)(n,r.allTargetPlatforms,e))}async installFromGallery(r,e={}){try{if(!this.galleryService.isEnabled())throw new h.ExtensionManagementError(T.localize(0,null),h.ExtensionManagementErrorCode.Internal);const n=await this.checkAndGetCompatibleVersion(r,!e.installGivenVersion,!!e.installPreReleaseVersion);return await this.installExtension(n.manifest,n.extension,e)}catch(n){throw p(this.telemetryService,"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(r),void 0,n),this.logService.error("Failed to install extension.",r.identifier.id),this.logService.error(n),E(n)}}async uninstall(r,e={}){return this.logService.trace("ExtensionManagementService#uninstall",r.identifier.id),this.unininstallExtension(r,e)}async reinstallFromGallery(r){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",r.identifier.id),!this.galleryService.isEnabled())throw new Error(T.localize(1,null));const e=await this.findGalleryExtension(r);if(!e)throw new Error(T.localize(2,null));await this.createUninstallExtensionTask(r,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsControlManifest(){const r=new Date().getTime();return(!this.extensionsControlManifest||r-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=r),this.extensionsControlManifest}registerParticipant(r){this.participants.push(r)}async installExtension(r,e,n){if(!b.URI.isUri(e)){let w=this.installingExtensions.get(new S.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(w)return this.logService.info("Extensions is already requested to install",e.identifier.id),w.waitUntilTaskIsFinished();n={...n,installOnlyNewlyAddedFromExtensionPack:!0}}const s=[],l=[],f=this.createInstallExtensionTask(r,e,n);b.URI.isUri(e)||this.installingExtensions.set(new S.ExtensionIdentifierWithVersion(f.identifier,r.version).key(),f),this._onInstallExtension.fire({identifier:f.identifier,source:e}),this.logService.info("Installing extension:",f.identifier.id),s.push({task:f,manifest:r});let m=!1;try{if(n.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",f.identifier.id);else try{const O=await this.getAllDepsAndPackExtensionsToInstall(f.identifier,r,!!n.installOnlyNewlyAddedFromExtensionPack,!!n.installPreReleaseVersion);for(const{gallery:N,manifest:q}of O)if(m=m||!!q.extensionDependencies?.some(J=>(0,S.areSameExtensions)({id:J},f.identifier)),this.installingExtensions.has(new S.ExtensionIdentifierWithVersion(N.identifier,N.version).key()))this.logService.info("Extension is already requested to install",N.identifier.id);else{const J=this.createInstallExtensionTask(q,N,{...n,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new S.ExtensionIdentifierWithVersion(J.identifier,q.version).key(),J),this._onInstallExtension.fire({identifier:J.identifier,source:N}),this.logService.info("Installing extension:",J.identifier.id),s.push({task:J,manifest:q})}}catch(O){if(b.URI.isUri(f.source))(0,C.isNonEmptyArray)(r.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",f.identifier.id,O.message),(0,C.isNonEmptyArray)(r.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",f.identifier.id,O.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",f.identifier.id),O}const w=s.reduce((O,{task:N,manifest:q})=>(O.set(N.identifier.id.toLowerCase(),{task:N,manifest:q}),O),new Map);for(;w.size;){let O;const N=[...w.values()].filter(({manifest:q})=>!q.extensionDependencies?.some(J=>w.has(J.toLowerCase())));N.length?O=w.size===1?N:N.filter(({task:q})=>!(q===f&&!m)):(this.logService.info("Found extensions with circular dependencies",N.map(({task:q})=>q.identifier.id)),O=[...w.values()]),await this.joinAllSettled(O.map(async({task:q})=>{const J=new Date().getTime(),se=(0,d.isUndefined)(n.operation)?q.operation:n.operation;try{const ie=await q.run();if(await this.joinAllSettled(this.participants.map(te=>te.postInstall(ie,q.source,n,P.CancellationToken.None))),!b.URI.isUri(q.source)&&(p(this.telemetryService,se===3?"extensionGallery:update":"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(q.source),new Date().getTime()-J,void 0),c.isWeb&&se!==3))try{await this.galleryService.reportStatistic(ie.manifest.publisher,ie.manifest.name,ie.manifest.version,"install")}catch{}l.push({local:ie,identifier:q.identifier,operation:se,source:q.source})}catch(ie){throw b.URI.isUri(q.source)||p(this.telemetryService,se===3?"extensionGallery:update":"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(q.source),new Date().getTime()-J,ie),this.logService.error("Error while installing the extension:",q.identifier.id),ie}finally{w.delete(q.identifier.id.toLowerCase())}}))}return l.forEach(({identifier:O})=>this.logService.info("Extension installed successfully:",O.id)),this._onDidInstallExtensions.fire(l),l.filter(({identifier:O})=>(0,S.areSameExtensions)(O,f.identifier))[0].local}catch(w){if(s.forEach(({task:O})=>O.cancel()),l.length)try{const O=await Promise.allSettled(l.map(({local:N})=>this.createUninstallExtensionTask(N,{versionOnly:!0}).run()));for(let N=0;N<O.length;N++){const q=O[N],{identifier:J}=l[N];q.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",J.id):this.logService.warn("Rollback: Error while uninstalling extension",J.id,(0,R.getErrorMessage)(q.reason))}}catch(O){this.logService.warn("Error while rolling back extensions",(0,R.getErrorMessage)(O),l.map(({identifier:N})=>N.id))}throw this._onDidInstallExtensions.fire(s.map(({task:O})=>({identifier:O.identifier,operation:2,source:O.source}))),w}finally{for(const{task:w,manifest:O}of s)if(!b.URI.isUri(w.source)){const N=new S.ExtensionIdentifierWithVersion(w.identifier,O.version).key();this.installingExtensions.delete(N)||this.logService.warn("Installation task is not found in the cache",N)}}}async joinAllSettled(r){const e=[],n=[],s=await Promise.allSettled(r);for(const l of s)l.status==="fulfilled"?e.push(l.value):n.push(l.reason);if(n.length)throw v(n);return e}async getAllDepsAndPackExtensionsToInstall(r,e,n,s){if(!this.galleryService.isEnabled())return[];let l=await this.getInstalled();const f=[r,...l.map(O=>O.identifier)],m=[],w=async(O,N)=>{const q=N.extensionDependencies||[],J=[...q];if(N.extensionPack){const se=n?l.find(ie=>(0,S.areSameExtensions)(ie.identifier,O)):void 0;for(const ie of N.extensionPack)se&&se.manifest.extensionPack&&se.manifest.extensionPack.some(te=>(0,S.areSameExtensions)({id:te},{id:ie}))||J.every(te=>!(0,S.areSameExtensions)({id:te},{id:ie}))&&J.push(ie)}if(J.length){const se=[...f,...m.map(te=>te.gallery.identifier)],ie=J.filter(te=>se.every(ge=>!(0,S.areSameExtensions)(ge,{id:te})));if(ie.length){const te=await this.galleryService.query({names:ie,pageSize:J.length},P.CancellationToken.None);for(const ge of te.firstPage){if(se.find(re=>(0,S.areSameExtensions)(re,ge.identifier)))continue;const B=q.some(re=>(0,S.areSameExtensions)({id:re},ge.identifier));let _;try{_=await this.checkAndGetCompatibleVersion(ge,!0,s)}catch(re){if(re instanceof h.ExtensionManagementError&&re.code===h.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!B){this.logService.info("Skipping the packed extension as it cannot be installed",ge.identifier.id);continue}else throw re}m.push({gallery:_.extension,manifest:_.manifest}),await w(_.extension.identifier,N)}}}};return await w(r,e),l=await this.getInstalled(),m.filter(O=>!l.some(N=>(0,S.areSameExtensions)(N.identifier,O.gallery.identifier)))}async checkAndGetCompatibleVersion(r,e,n){const s=await this.getExtensionsControlManifest();if((0,S.getMaliciousExtensionsSet)(s).has(r.identifier.id))throw new h.ExtensionManagementError(T.localize(3,null,r.identifier.id),h.ExtensionManagementErrorCode.Malicious);if(!!s.unsupportedPreReleaseExtensions&&!!s.unsupportedPreReleaseExtensions[r.identifier.id])throw new h.ExtensionManagementError(T.localize(4,null,r.identifier.id,s.unsupportedPreReleaseExtensions[r.identifier.id].displayName),h.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(r)){const m=await this.getTargetPlatform();throw new h.ExtensionManagementError(T.localize(5,null,r.identifier.id,this.productService.nameLong,(0,h.TargetPlatformToString)(m)),h.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const l=await this.getCompatibleVersion(r,e,n);if(l){if(n&&e&&r.hasPreReleaseVersion&&!l.properties.isPreReleaseVersion)throw new h.ExtensionManagementError(T.localize(6,null,r.identifier.id,this.productService.nameLong,this.productService.version),h.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!n&&r.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([r.identifier],P.CancellationToken.None))[0]?new h.ExtensionManagementError(T.localize(7,null,r.identifier.id),h.ExtensionManagementErrorCode.ReleaseVersionNotFound):new h.ExtensionManagementError(T.localize(8,null,r.identifier.id,this.productService.nameLong,this.productService.version),h.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",l.identifier.id);const f=await this.galleryService.getManifest(l,P.CancellationToken.None);if(f===null)throw new h.ExtensionManagementError(`Missing manifest for extension ${r.identifier.id}`,h.ExtensionManagementErrorCode.Invalid);if(f.version!==l.version)throw new h.ExtensionManagementError(`Cannot install '${r.identifier.id}' extension because of version mismatch in Marketplace`,h.ExtensionManagementErrorCode.Invalid);return{extension:l,manifest:f}}async getCompatibleVersion(r,e,n){const s=await this.getTargetPlatform();let l=null;return e&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==n&&(l=(await this.galleryService.getExtensions([{...r.identifier,preRelease:n}],{targetPlatform:s,compatible:!0},P.CancellationToken.None))[0]||null),!l&&await this.galleryService.isExtensionCompatible(r,n,s)&&(l=r),!l&&e&&(l=await this.galleryService.getCompatibleExtension(r,n,s)),l}async unininstallExtension(r,e){const n=this.uninstallingExtensions.get(r.identifier.id.toLowerCase());if(n)return this.logService.info("Extensions is already requested to uninstall",r.identifier.id),n.waitUntilTaskIsFinished();const s=(w,O)=>{const N=this.createUninstallExtensionTask(w,O);return this.uninstallingExtensions.set(N.extension.identifier.id.toLowerCase(),N),this.logService.info("Uninstalling extension:",w.identifier.id),this._onUninstallExtension.fire(w.identifier),N},l=(w,O)=>{O?this.logService.error("Failed to uninstall extension:",w.identifier.id,O.message):this.logService.info("Successfully uninstalled extension:",w.identifier.id),p(this.telemetryService,"extensionGallery:uninstall",(0,S.getLocalExtensionTelemetryData)(w),void 0,O),this._onDidUninstallExtension.fire({identifier:w.identifier,error:O?.code})},f=[],m=[];try{f.push(s(r,{}));const w=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",r.identifier.id);else{const O=this.getAllPackExtensionsToUninstall(r,w);for(const N of O)this.uninstallingExtensions.has(N.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",N.identifier.id):f.push(s(N,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",r.identifier.id):this.checkForDependents(f.map(O=>O.extension),w,r),await this.joinAllSettled(f.map(async O=>{try{if(await O.run(),await this.joinAllSettled(this.participants.map(N=>N.postUninstall(O.extension,e,P.CancellationToken.None))),O.extension.identifier.uuid)try{await this.galleryService.reportStatistic(O.extension.manifest.publisher,O.extension.manifest.name,O.extension.manifest.version,"uninstall")}catch{}l(O.extension)}catch(N){const q=N instanceof h.ExtensionManagementError?N:new h.ExtensionManagementError((0,R.getErrorMessage)(N),h.ExtensionManagementErrorCode.Internal);throw l(O.extension,q),q}finally{m.push(O)}}))}catch(w){const O=w instanceof h.ExtensionManagementError?w:new h.ExtensionManagementError((0,R.getErrorMessage)(w),h.ExtensionManagementErrorCode.Internal);for(const N of f){try{N.cancel()}catch{}m.includes(N)||l(N.extension,O)}throw O}finally{for(const w of f)this.uninstallingExtensions.delete(w.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",w.extension.identifier.id)}}checkForDependents(r,e,n){for(const s of r){const l=this.getDependents(s,e);if(l.length){const f=l.filter(m=>!r.some(w=>(0,S.areSameExtensions)(w.identifier,m.identifier)));if(f.length)throw new Error(this.getDependentsErrorMessage(s,f,n))}}}getDependentsErrorMessage(r,e,n){return n===r?e.length===1?T.localize(9,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?T.localize(10,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):T.localize(11,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?T.localize(12,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?T.localize(13,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):T.localize(14,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(r,e,n=[]){if(n.indexOf(r)!==-1)return[];n.push(r);const s=r.manifest.extensionPack?r.manifest.extensionPack:[];if(s.length){const l=e.filter(m=>!m.isBuiltin&&s.some(w=>(0,S.areSameExtensions)({id:w},m.identifier))),f=[];for(const m of l)f.push(...this.getAllPackExtensionsToUninstall(m,e,n));return[...l,...f]}return[]}getDependents(r,e){return e.filter(n=>n.manifest.extensionDependencies&&n.manifest.extensionDependencies.some(s=>(0,S.areSameExtensions)({id:s},r.identifier)))}async findGalleryExtension(r){if(r.identifier.uuid){const e=await this.findGalleryExtensionById(r.identifier.uuid);return e||this.findGalleryExtensionByName(r.identifier.id)}return this.findGalleryExtensionByName(r.identifier.id)}async findGalleryExtensionById(r){return(await this.galleryService.query({ids:[r],pageSize:1},P.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(r){return(await this.galleryService.query({names:[r],pageSize:1},P.CancellationToken.None)).firstPage[0]}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const r=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",r),r}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};u=pe([oe(0,h.IExtensionGalleryService),oe(1,a.ITelemetryService),oe(2,y.ILogService),oe(3,g.IProductService)],u),i.AbstractExtensionManagementService=u;function v(t){const r=Array.isArray(t)?t:[t];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((e,n)=>new Error(`${e.message}${e.message?",":""}${n instanceof Error?n.message:n}`),new Error(""))}i.joinErrors=v;function E(t){if(t instanceof h.ExtensionManagementError)return t;const r=new h.ExtensionManagementError(t.message,h.ExtensionManagementErrorCode.Internal);return r.stack=t.stack,r}function p(t,r,e,n,s){const l=s?s instanceof h.ExtensionManagementError?s.code:h.ExtensionManagementErrorCode.Internal:void 0;t.publicLogError(r,{...e,success:!s,duration:n,errorcode:l})}i.reportTelemetry=p;class o{constructor(){this.barrier=new D.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,D.createCancelablePromise)(r=>this.doRun(r))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,D.createCancelablePromise)(r=>new Promise((e,n)=>{const s=r.onCancellationRequested(()=>{s.dispose(),n((0,R.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}i.AbstractExtensionTask=o}),define(Q[35],Z([0,1,22,8,25,31]),function(z,i,C,D,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.cleanRemoteAuthority=i.validateTelemetryData=i.getTelemetryLevel=i.supportsTelemetry=i.configurationTelemetry=i.NullAppender=i.NullEndpointTelemetryService=i.NullTelemetryService=i.NullTelemetryServiceShape=void 0;class L{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(u,v){return Promise.resolve(void 0)}publicLog2(u,v){return this.publicLog(u,v)}publicLogError(u,v){return Promise.resolve(void 0)}publicLogError2(u,v){return this.publicLogError(u,v)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}i.NullTelemetryServiceShape=L,i.NullTelemetryService=new L;class I{async publicLog(u,v,E){}async publicLogError(u,v,E){}}i.NullEndpointTelemetryService=I,i.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function c(a,u){return u.onDidChangeConfiguration(v=>{v.source!==6&&a.publicLog2("updateConfiguration",{configurationSource:(0,P.ConfigurationTargetToString)(v.source),configurationKeys:y(v.sourceConfig)})})}i.configurationTelemetry=c;function d(a,u){return!(u.disableTelemetry||!a.enableTelemetry||u.extensionTestsLocationURI)}i.supportsTelemetry=d;function b(a){const u=a.getValue(R.TELEMETRY_SETTING_ID),v=a.getValue("telemetry.enableCrashReporter");if(a.getValue(R.TELEMETRY_OLD_SETTING_ID)===!1||v===!1)return 0;switch(u??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}i.getTelemetryLevel=b;function T(a){const u=Object.create(null),v=Object.create(null),E=Object.create(null);S(a,E);for(let p in E){p=p.length>150?p.substr(p.length-149):p;const o=E[p];typeof o=="number"?v[p]=o:typeof o=="boolean"?v[p]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${p} has been trimmed to 8192, the original length is ${o.length}`),u[p]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(u[p]=o)}return{properties:u,measurements:v}}i.validateTelemetryData=T;function h(a){if(!a)return"none";let u="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(E=>{a.indexOf(`${E}+`)===0&&(u=E)}),u}i.cleanRemoteAuthority=h;function S(a,u,v=0,E){if(!!a)for(let p of Object.getOwnPropertyNames(a)){const o=a[p],t=E?E+p:p;Array.isArray(o)?u[t]=(0,C.safeStringify)(o):o instanceof Date?u[t]=o.toISOString():(0,D.isObject)(o)?v<2?S(o,u,v+1,t+"."):u[t]=(0,C.safeStringify)(o):u[t]=o}}function y(a){if(!a)return[];const u=[];return g(u,"",a),u}function g(a,u,v){v&&typeof v=="object"&&!Array.isArray(v)?Object.keys(v).forEach(E=>g(a,u?`${u}.${E}`:E,v[E])):a.push(u)}}),define(Q[120],Z([0,1,18,24,7,22,12,29,8,9,25,20,23,21,48,16,14,32,42,116,117,31,35]),function(z,i,C,D,P,R,L,I,c,d,b,T,h,S,y,g,a,u,v,E,p,o,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveMarketplaceHeaders=i.ExtensionGalleryServiceWithNoStorageService=i.ExtensionGalleryService=i.sortExtensionVersions=void 0;const r=L.isWeb?"web":(0,h.getTargetPlatform)(L.platform,I.arch);var e;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(e||(e={}));function n(...U){return String(U.reduce((k,x)=>k|x,0))}var s;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const l={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},f={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},w={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:e.None,criteria:[],assetTypes:[]};class O{constructor(k=w){this.state=k}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(k,x=this.state.pageSize){return new O({...this.state,pageNumber:k,pageSize:x})}withFilter(k,...x){const j=[...this.state.criteria,...x.length?x.map(Y=>({filterType:k,value:Y})):[{filterType:k}]];return new O({...this.state,criteria:j})}withSortBy(k){return new O({...this.state,sortBy:k})}withSortOrder(k){return new O({...this.state,sortOrder:k})}withFlags(...k){return new O({...this.state,flags:k.reduce((x,j)=>x|j,0)})}withAssetTypes(...k){return new O({...this.state,assetTypes:k})}get raw(){const{criteria:k,pageNumber:x,pageSize:j,sortBy:Y,sortOrder:X,flags:he,assetTypes:fe}=this.state;return{filters:[{criteria:k,pageNumber:x,pageSize:j,sortBy:Y,sortOrder:X}],assetTypes:fe,flags:he}}get searchText(){const k=this.state.criteria.filter(x=>x.filterType===s.SearchText)[0];return k&&k.value?k.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(k=>String(k.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function N(U,k){const x=(U||[]).filter(j=>j.statisticName===k)[0];return x?x.value:0}function q(U){const k="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(j=>j.assetType.indexOf(k)===0).reduce((j,Y)=>{const X=te(U,Y.assetType);return X&&j.push([Y.assetType.substring(k.length),X]),j},[])}function J(U){if(U.properties){const k=U.properties.filter(Y=>Y.key===l.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),j=k.filter(Y=>x.test(Y.value))[0];return j?{uri:j.value,fallbackUri:j.value}:null}return te(U,l.Repository)}function se(U){return{uri:`${U.fallbackAssetUri}/${l.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${l.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function ie(U){const k=te(U,l.Icon);if(k)return k;const x=h.DefaultIconPath;return{uri:x,fallbackUri:x}}function te(U,k){return U.files.filter(j=>j.assetType===k)[0]?{uri:`${U.assetUri}/${k}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${k}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function ge(U,k){const x=U.properties?U.properties.filter(Y=>Y.key===k):[],j=x.length>0&&x[0].value;return j?j.split(",").map(Y=>(0,S.adoptToGalleryExtensionId)(Y)):[]}function B(U){const k=U.properties?U.properties.filter(x=>x.key===f.Engine):[];return k.length>0&&k[0].value||""}function _(U){const k=U.properties?U.properties.filter(x=>x.key===f.PreRelease):[];return k.length>0&&k[0].value==="true"}function re(U){const k=U.properties?U.properties.filter(j=>j.key===f.LocalizedLanguages):[],x=k.length>0&&k[0].value||"";return x?x.split(","):[]}function M(U){return U.indexOf("preview")!==-1}function A(U){return U.targetPlatform?(0,h.toTargetPlatform)(U.targetPlatform):"undefined"}function W(U){const k=(0,C.distinct)(U.versions.map(A)),x=!!U.tags?.includes(h.WEB_EXTENSION_TAG),j=k.indexOf("web");return x?j===-1&&k.push("web"):j!==-1&&k.splice(j,1),k}function H(U,k){const x=(0,h.getFallbackTargetPlarforms)(k);for(let j=0;j<U.length;j++){const Y=U[j];if(Y.version===U[j-1]?.version){let X=j;const he=A(Y);if(he===k)for(;X>0&&U[X-1].version===Y.version;)X--;else if(x.includes(he))for(;X>0&&U[X-1].version===Y.version&&A(U[X-1])!==k;)X--;X!==j&&(U.splice(j,1),U.splice(X,0,Y))}}return U}i.sortExtensionVersions=H;function ne(U,k,x){const j=U.versions[0],Y={manifest:te(k,l.Manifest),readme:te(k,l.Details),changelog:te(k,l.Changelog),license:te(k,l.License),repository:J(k),download:se(k),icon:ie(k),coreTranslations:q(k)};return{identifier:{id:(0,S.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:k.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,description:U.shortDescription||"",installCount:N(U.statistics,"install"),rating:N(U.statistics,"averagerating"),ratingCount:N(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:x,assets:Y,properties:{dependencies:ge(k,f.Dependency),extensionPack:ge(k,f.ExtensionPack),engine:B(k),localizedLanguages:re(k),targetPlatform:A(k),isPreReleaseVersion:_(k)},hasPreReleaseVersion:_(j),hasReleaseVersion:!0,preview:M(U.flags)}}let K=class{constructor(k,x,j,Y,X,he,fe,ye){this.requestService=x,this.logService=j,this.environmentService=Y,this.telemetryService=X,this.fileService=he,this.productService=fe,this.configurationService=ye;const le=fe.extensionsGallery;this.extensionsGalleryUrl=le&&le.serviceUrl,this.extensionsControlUrl=le&&le.controlUrl,this.commonHeadersPromise=ae(fe.version,fe,this.environmentService,this.configurationService,this.fileService,k)}api(k=""){return`${this.extensionsGalleryUrl}${k}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(k,x,j){const Y=D.CancellationToken.isCancellationToken(x)?{targetPlatform:r}:x,X=D.CancellationToken.isCancellationToken(x)?x:j,he=[],fe=[],ye=[],le=[];for(const me of k)me.uuid?fe.push(me.uuid):he.push(me.id),ye.push({...me,preRelease:!!me.preRelease}),me.version&&le.push({...me,version:me.version});if(!fe.length&&!he.length)return[];let ce=new O().withPage(1,k.length);fe.length&&(ce=ce.withFilter(s.ExtensionId,...fe)),he.length&&(ce=ce.withFilter(s.ExtensionName,...he));const{extensions:de}=await this.queryGalleryExtensions(ce,{targetPlatform:Y.targetPlatform,preRelease:ye,versions:le,compatible:!!Y.compatible},X);return de}async getCompatibleExtension(k,x,j){if((0,h.isNotWebExtensionInWebTargetPlatform)(k.allTargetPlatforms,j))return null;if(await this.isExtensionCompatible(k,x,j))return k;const Y=new O().withFlags(e.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,k.identifier.uuid),{extensions:X}=await this.queryGalleryExtensions(Y,{targetPlatform:j,compatible:!0,preRelease:x},D.CancellationToken.None);return X[0]||null}async isExtensionCompatible(k,x,j){if(!(0,h.isTargetPlatformCompatible)(k.properties.targetPlatform,k.allTargetPlatforms,j)||!x&&k.properties.isPreReleaseVersion)return!1;let Y=k.properties.engine;if(!Y){const X=await this.getManifest(k,D.CancellationToken.None);if(!X)throw new Error("Manifest was not found");Y=X.engines.vscode}return(0,y.isEngineValid)(Y,this.productService.version,this.productService.date)}async isValidVersion(k,x,j,Y,X){if(!(0,h.isTargetPlatformCompatible)(A(k),Y,X)||!x&&_(k))return!1;if(j){const he=await this.getEngine(k);if(!(0,y.isEngineValid)(he,this.productService.version,this.productService.date))return!1}return!0}async query(k,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let j=k.text||"";const Y=(0,R.getOrDefault)(k,ce=>ce.pageSize,50);let X=new O().withPage(1,Y);j?(j=j.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ce,de,me)=>(X=X.withFilter(s.Category,me||de),"")),j=j.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ce,de,me)=>(X=X.withFilter(s.Tag,me||de),"")),j=j.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(s.Featured),"")),j=j.trim(),j&&(j=j.length<200?j:j.substring(0,200),X=X.withFilter(s.SearchText,j)),X=X.withSortBy(0)):k.ids?X=X.withFilter(s.ExtensionId,...k.ids):k.names?X=X.withFilter(s.ExtensionName,...k.names):X=X.withSortBy(4),typeof k.sortBy=="number"&&(X=X.withSortBy(k.sortBy)),typeof k.sortOrder=="number"&&(X=X.withSortOrder(k.sortOrder));const he=async(ce,de)=>{const{extensions:me,total:Fe}=await this.queryGalleryExtensions(ce,{targetPlatform:r,compatible:!1,preRelease:!!k.includePreRelease},de);return me.forEach((Ce,Ue)=>Ce.telemetryData={index:(ce.pageNumber-1)*ce.pageSize+Ue,querySource:k.source}),{extensions:me,total:Fe}},{extensions:fe,total:ye}=await he(X,x),le=async(ce,de)=>{if(de.isCancellationRequested)throw new P.CancellationError;const{extensions:me}=await he(X.withPage(ce+1),de);return me};return{firstPage:fe,total:ye,pageSize:X.pageSize,getPage:le}}async queryGalleryExtensions(k,x,j){const Y=k.flags;!!(k.flags&e.IncludeLatestVersionOnly)&&!!(k.flags&e.IncludeVersions)&&(k=k.withFlags(k.flags&~e.IncludeVersions,e.IncludeLatestVersionOnly)),!(k.flags&e.IncludeLatestVersionOnly)&&!(k.flags&e.IncludeVersions)&&(k=k.withFlags(k.flags,e.IncludeLatestVersionOnly)),x.versions?.length&&(k=k.withFlags(k.flags&~e.IncludeLatestVersionOnly,e.IncludeVersions)),k=k.withFlags(k.flags,e.IncludeAssetUri,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeStatistics,e.IncludeVersionProperties);const{galleryExtensions:X,total:he}=await this.queryRawGalleryExtensions(k,j);if(!(k.flags&e.IncludeLatestVersionOnly)){const ce=[];for(const de of X){const me=await this.toGalleryExtensionWithCriteria(de,x,!0);me&&ce.push(me)}return{extensions:ce,total:he}}const ye=[],le=new Map;for(let ce=0;ce<X.length;ce++){const de=X[ce],me={id:(0,S.getGalleryExtensionId)(de.publisher.publisherName,de.extensionName),uuid:de.extensionId},Fe=(0,c.isBoolean)(x.preRelease)?x.preRelease:!!x.preRelease.find(Ue=>(0,S.areSameExtensions)(Ue,me))?.preRelease;let Ce=await this.toGalleryExtensionWithCriteria(de,x,!1);!Ce||Ce.properties.isPreReleaseVersion&&(!Fe||!Ce.hasReleaseVersion)||!Ce.properties.isPreReleaseVersion&&Ce.properties.targetPlatform!==x.targetPlatform&&Ce.hasPreReleaseVersion?le.set(de.extensionId,ce):ye.push([ce,Ce])}if(le.size){const ce=new Date().getTime(),de=new O().withFlags(Y&~e.IncludeLatestVersionOnly,e.IncludeVersions).withPage(1,le.size).withFilter(s.ExtensionId,...le.keys()),{extensions:me}=await this.queryGalleryExtensions(de,x,j);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ce,count:le.size});for(const Fe of me){const Ce=le.get(Fe.identifier.uuid);ye.push([Ce,Fe])}}return{extensions:ye.sort((ce,de)=>ce[0]-de[0]).map(([,ce])=>ce),total:he}}async toGalleryExtensionWithCriteria(k,x,j){const Y={id:(0,S.getGalleryExtensionId)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},X=x.versions?.find(le=>(0,S.areSameExtensions)(le,Y))?.version,he=(0,c.isBoolean)(x.preRelease)?x.preRelease:!!x.preRelease.find(le=>(0,S.areSameExtensions)(le,Y))?.preRelease,fe=W(k),ye=H(k.versions,x.targetPlatform);if(x.compatible&&j&&(0,h.isNotWebExtensionInWebTargetPlatform)(fe,x.targetPlatform))return null;for(let le=0;le<ye.length;le++){const ce=ye[le];if(!(X&&ce.version!==X)){if(await this.isValidVersion(ce,he,x.compatible,fe,x.targetPlatform))return ne(k,ce,fe);if(X&&ce.version===X)return null}}return X||x.compatible?null:ne(k,k.versions[0],fe)}async queryRawGalleryExtensions(k,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");k=k.withFlags(k.flags,e.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,n(e.Unpublished));const j=await this.commonHeadersPromise,Y=JSON.stringify(k.raw),X={...j,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Y.length)},he=new Date().getTime();let fe,ye,le=0;try{if(fe=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Y,headers:X},x),fe.res.statusCode&&fe.res.statusCode>=400&&fe.res.statusCode<500)return{galleryExtensions:[],total:le};const ce=await(0,v.asJson)(fe);if(ce){const de=ce.results[0],me=de.extensions,Fe=de.resultMetadata&&de.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return le=Fe&&Fe.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:me,total:le}}return{galleryExtensions:[],total:le}}catch(ce){throw ye=ce,ce}finally{this.telemetryService.publicLog2("galleryService:query",{...k.telemetryData,requestBodySize:String(Y.length),duration:new Date().getTime()-he,success:!!fe&&(0,v.isSuccess)(fe),responseBodySize:fe?.res.headers["Content-Length"],statusCode:fe?String(fe.res.statusCode):void 0,errorCode:ye?(0,P.isCancellationError)(ye)?"canceled":(0,P.getErrorMessage)(ye).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(le)})}}async reportStatistic(k,x,j,Y){if(!this.isEnabled())return;const X=L.isWeb?this.api(`/itemName/${k}.${x}/version/${j}/statType/${Y==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${k}/extensions/${x}/${j}/stats?statType=${Y}`),he=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ye={...await this.commonHeadersPromise,Accept:he};try{await this.requestService.request({type:"POST",url:X,headers:ye},D.CancellationToken.None)}catch{}}async download(k,x,j){this.logService.trace("ExtensionGalleryService#download",k.identifier.id);const Y=(0,S.getGalleryExtensionTelemetryData)(k),X=new Date().getTime(),he=ce=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...Y,duration:ce}),fe=j===2?"install":j===3?"update":"",ye=fe?{uri:`${k.assets.download.uri}${d.URI.parse(k.assets.download.uri).query?"&":"?"}${fe}=true`,fallbackUri:`${k.assets.download.fallbackUri}${d.URI.parse(k.assets.download.fallbackUri).query?"&":"?"}${fe}=true`}:k.assets.download,le=await this.getAsset(ye);await this.fileService.writeFile(x,le.stream),he(new Date().getTime()-X)}async getReadme(k,x){if(k.assets.readme){const j=await this.getAsset(k.assets.readme,{},x);return await(0,v.asText)(j)||""}return""}async getManifest(k,x){if(k.assets.manifest){const j=await this.getAsset(k.assets.manifest,{},x),Y=await(0,v.asText)(j);return Y?JSON.parse(Y):null}return null}async getManifestFromRawExtensionVersion(k,x){const j=te(k,l.Manifest);if(!j)throw new Error("Manifest was not found");const Y={"Accept-Encoding":"gzip"},X=await this.getAsset(j,{headers:Y});return await(0,v.asJson)(X)}async getCoreTranslation(k,x){const j=k.assets.coreTranslations.filter(Y=>Y[0]===x.toUpperCase())[0];if(j){const Y=await this.getAsset(j[1]),X=await(0,v.asText)(Y);return X?JSON.parse(X):null}return null}async getChangelog(k,x){if(k.assets.changelog){const j=await this.getAsset(k.assets.changelog,{},x);return await(0,v.asText)(j)||""}return""}async getAllCompatibleVersions(k,x,j){let Y=new O().withFlags(e.IncludeVersions,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1);k.identifier.uuid?Y=Y.withFilter(s.ExtensionId,k.identifier.uuid):Y=Y.withFilter(s.ExtensionName,k.identifier.id);const{galleryExtensions:X}=await this.queryRawGalleryExtensions(Y,D.CancellationToken.None);if(!X.length)return[];const he=W(X[0]);if((0,h.isNotWebExtensionInWebTargetPlatform)(he,j))return[];const fe=[],ye=new Set;return await Promise.all(X[0].versions.map(async le=>{try{if(ye.has(le.version))return;ye.add(le.version),await this.isValidVersion(le,x,!0,he,j)&&fe.push({version:le.version,date:le.lastUpdated,isPreReleaseVersion:_(le)})}catch{}})),fe}async getAsset(k,x={},j=D.CancellationToken.None){const Y=await this.commonHeadersPromise,X={type:"GET"},he={...Y,...x.headers||{}};x={...x,...X,headers:he};const fe=k.uri,ye=k.fallbackUri,le={...x,url:fe};try{const ce=await this.requestService.request(le,j);if(ce.res.statusCode===200)return ce;const de=await(0,v.asText)(ce);throw new Error(`Expected 200, got back ${ce.res.statusCode} instead.

${de}`)}catch(ce){if((0,P.isCancellationError)(ce))throw ce;const de=(0,P.getErrorMessage)(ce);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:fe,message:de});const me={...x,url:ye};return this.requestService.request(me,j)}}async getEngine(k){let x=B(k);if(!x){const j=await this.getManifestFromRawExtensionVersion(k,D.CancellationToken.None);if(!j)throw new Error("Manifest was not found");x=j.engines.vscode}return x}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const k=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},D.CancellationToken.None);if(k.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,v.asJson)(k),j=[],Y={};if(x){for(const X of x.malicious)j.push({id:X});if(x.unsupported)for(const X of Object.keys(x.unsupported)){const he=x.unsupported[X];(0,c.isBoolean)(he)||(Y[X.toLowerCase()]=he.preReleaseExtension)}if(x.migrateToPreRelease)for(const[X,he]of Object.entries(x.migrateToPreRelease))(!he.engine||(0,y.isEngineValid)(he.engine,this.productService.version,this.productService.date))&&(Y[X.toLowerCase()]=he)}return{malicious:j,unsupportedPreReleaseExtensions:Y}}};K=pe([oe(1,v.IRequestService),oe(2,a.ILogService),oe(3,T.IEnvironmentService),oe(4,o.ITelemetryService),oe(5,g.IFileService),oe(6,u.IProductService),oe(7,b.IConfigurationService)],K);let ee=class extends K{constructor(k,x,j,Y,X,he,fe,ye){super(k,x,j,Y,X,he,fe,ye)}};ee=pe([oe(0,p.IStorageService),oe(1,v.IRequestService),oe(2,a.ILogService),oe(3,T.IEnvironmentService),oe(4,o.ITelemetryService),oe(5,g.IFileService),oe(6,u.IProductService),oe(7,b.IConfigurationService)],ee),i.ExtensionGalleryService=ee;let G=class extends K{constructor(k,x,j,Y,X,he,fe){super(void 0,k,x,j,Y,X,he,fe)}};G=pe([oe(0,v.IRequestService),oe(1,a.ILogService),oe(2,T.IEnvironmentService),oe(3,o.ITelemetryService),oe(4,g.IFileService),oe(5,u.IProductService),oe(6,b.IConfigurationService)],G),i.ExtensionGalleryServiceWithNoStorageService=G;async function ae(U,k,x,j,Y,X){const he={"X-Market-Client-Id":`VSCode ${U}`,"User-Agent":`VSCode ${U} (${k.nameShort})`},fe=await(0,E.getServiceMachineId)(x,Y,X);return(0,t.supportsTelemetry)(k,x)&&(0,t.getTelemetryLevel)(j)===3&&(he["X-Market-User-Id"]=fe),he}i.resolveMarketplaceHeaders=ae}),define(Q[121],Z([0,1,2,22,12,26,86,25,34,122,30,31,35]),function(z,i,C,D,P,R,L,I,c,d,b,T,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryService=void 0;let S=class{constructor(a,u){this._configurationService=u,this._experimentProperties={},this._disposables=new C.DisposableStore,this._cleanupPatterns=[],this._appenders=a.appenders,this._commonProperties=a.commonProperties||Promise.resolve({}),this._piiPaths=a.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!a.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let v of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(v),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(v=>{const E=/^[a-f0-9]+$/i.test(v["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!E})})}setExperimentProperty(a,u){this._experimentProperties[a]=u}_updateTelemetryLevel(){this._telemetryLevel=(0,h.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const a=await this._commonProperties;let u=a.sessionID,v=a["common.machineId"],E=a["common.firstSessionDate"],p=a["common.msftInternal"];return{sessionId:u,machineId:v,firstSessionDate:E,msftInternal:p}}dispose(){this._disposables.dispose()}_log(a,u,v,E){return this.telemetryLevel<u?Promise.resolve(void 0):this._commonProperties.then(p=>{v=(0,D.mixin)(v,p),v=(0,D.mixin)(v,this._experimentProperties),v=(0,D.cloneAndChange)(v,o=>{if(typeof o=="string")return this._cleanupInfo(o,E)}),this._appenders.forEach(o=>o.log(a,v))},p=>{console.error(p)})}publicLog(a,u,v){return this._log(a,3,u,v)}publicLog2(a,u,v){return this.publicLog(a,u,v)}publicLogError(a,u){return this.sendErrorTelemetry?this._log(a,2,u,!0):Promise.resolve(void 0)}publicLogError2(a,u){return this.publicLogError(a,u)}_anonymizeFilePaths(a){let u=a;const v=[];for(let t of this._cleanupPatterns)for(;;){const r=t.exec(a);if(!r)break;v.push([r.index,t.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(u="";;){const t=p.exec(a);if(!t)break;!E.test(t[0])&&v.every(([r,e])=>t.index<r||t.index>=e)&&(u+=a.substring(o,t.index)+"<REDACTED: user-file-path>",o=p.lastIndex)}return o<a.length&&(u+=a.substr(o)),u}_removePropertiesWithPossibleUserInfo(a){if(!a)return a;const u=a.toLowerCase(),v=/@[a-zA-Z0-9-.]+/,E=/(key|token|sig|signature|password|passwd|pwd)[="':\s]/,p=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return E.test(u)?"<REDACTED: secret>":v.test(u)?"<REDACTED: email>":p.test(u)?"<REDACTED: token>":a}_cleanupInfo(a,u){let v=a;u&&(v=this._anonymizeFilePaths(v));for(let E of this._cleanupPatterns)v=v.replace(E,"");return v=this._removePropertiesWithPossibleUserInfo(v),v}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=pe([oe(1,I.IConfigurationService)],S),i.TelemetryService=S;function y(){const g=(0,L.localize)(0,null,d.default.nameLong),a=d.default.privacyStatementUrl?(0,L.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,L.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=P.isWeb?"":(0,L.localize)(3,null),v=(0,L.localize)(4,null),E=(0,L.localize)(5,null),p=(0,L.localize)(6,null),o=(0,L.localize)(7,null),t=`
|       | ${v} | ${E} | ${p} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,L.localize)(8,null);return`
${g} ${a} ${u}

&nbsp;

${o}
${t}

&nbsp;

${r}
`}b.Registry.as(c.Extensions.Configuration).registerConfiguration({id:T.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(9,null),properties:{[T.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,L.localize)(10,null),(0,L.localize)(11,null),(0,L.localize)(12,null),(0,L.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(c.Extensions.Configuration).registerConfiguration({id:T.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(14,null),properties:{[T.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,L.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,L.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(17,null,`\`#${T.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[123],Z([0,1,7,22,35]),function(z,i,C,D,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AppInsightsAppender=void 0;async function R(I,c){const d=await new Promise((T,h)=>{z(["applicationinsights"],T,h)});let b;return d.defaultClient?(b=new d.TelemetryClient(I),b.channel.setUseDiskRetryCaching(!0)):(d.setup(I).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),b=d.defaultClient),I.indexOf("AIF-")===0&&(b.config.endpointUrl=c?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),b}class L{constructor(c,d,b,T,h){this._eventPrefix=c,this._defaultData=d,this.testCollector=T,this.mirrored=h,this._defaultData||(this._defaultData=Object.create(null)),typeof b=="function"?this._aiClient=b():this._aiClient=b,this._asyncAIClient=null}_withAIClient(c){if(!!this._aiClient){if(typeof this._aiClient!="string"){c(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=R(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(d=>{c(d)},d=>{(0,C.onUnexpectedError)(d),console.error(d)})}}log(c,d){if(!!this._aiClient){d=(0,D.mixin)(d,this._defaultData),d=(0,P.validateTelemetryData)(d),this.testCollector&&(d.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++");try{this._withAIClient(b=>b.trackEvent({name:this._eventPrefix+"/"+c,properties:d.properties,measurements:d.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(c=>{this._withAIClient(d=>{try{d.flush({callback:()=>{this._aiClient=void 0,c(void 0)}})}catch{}})}):Promise.resolve(void 0)}}i.AppInsightsAppender=L}),define(Q[124],Z([0,1,11,15]),function(z,i,C,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buildTelemetryMessage=void 0;async function P(R,L){const I=Object.create(null),c=(b,T)=>{const h=JSON.parse(b);I[T]=h};if(L){const b=[],T=await D.Promises.readdir(L);for(const S of T)try{(await D.Promises.stat((0,C.join)(L,S))).isDirectory()&&b.push(S)}catch{}const h=[];for(const S of b)(await D.Promises.readdir((0,C.join)(L,S))).filter(g=>g==="telemetry.json").length===1&&h.push(S);for(const S of h){const y=(await D.Promises.readFile((0,C.join)(L,S,"telemetry.json"))).toString();c(y,S)}}let d=(await D.Promises.readFile((0,C.join)(R,"telemetry-core.json"))).toString();return c(d,"vscode-core"),d=(await D.Promises.readFile((0,C.join)(R,"telemetry-extensions.json"))).toString(),c(d,"vscode-extensions"),JSON.stringify(I,null,4)}i.buildTelemetryMessage=P}),define(Q[36],Z([0,1,13]),function(z,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IUriIdentityService=void 0,i.IUriIdentityService=(0,C.createDecorator)("IUriIdentityService")}),define(Q[125],Z([0,1,6,2,9,20,21,16,14,36]),function(z,i,C,D,P,R,L,I,c,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsWatcher=void 0;let b=class extends D.Disposable{constructor(h,S,y,g,a){super();this.extensionsManagementService=h,this.logService=g,this.uriIdentityService=a,this._onDidChangeExtensionsByAnotherSource=this._register(new C.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(v=>{this.installedExtensions=v.map(E=>E.identifier),this.startTimestamp=Date.now()}),this._register(h.onInstallExtension(v=>this.onInstallExtension(v))),this._register(h.onDidInstallExtensions(v=>this.onDidInstallExtensions(v))),this._register(h.onDidUninstallExtension(v=>this.onDidUninstallExtension(v)));const u=P.URI.file(y.extensionsPath);this._register(S.watch(u)),this._register(C.Event.filter(S.onDidFilesChange,v=>v.rawChanges.some(E=>this.doesChangeAffects(E,u)))(()=>this.onDidChange()))}doesChangeAffects(h,S){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(h.resource),S)?this.uriIdentityService.extUri.isEqual(h.resource,this.uriIdentityService.extUri.joinPath(S,".obsolete"))?!0:!(h.type!==1&&h.type!==2||this.uriIdentityService.extUri.basename(h.resource).startsWith(".")):!1}onInstallExtension(h){this.addInstallingExtension(h.identifier)}onDidInstallExtensions(h){for(const S of h)this.removeInstallingExtension(S.identifier),S.local&&this.addInstalledExtension(S.identifier)}onDidUninstallExtension(h){h.error||this.removeInstalledExtension(h.identifier)}addInstallingExtension(h){this.removeInstallingExtension(h),this.installingExtensions.push(h)}removeInstallingExtension(h){this.installingExtensions=this.installingExtensions.filter(S=>!(0,L.areSameExtensions)(S,h))}addInstalledExtension(h){this.installedExtensions&&(this.removeInstalledExtension(h),this.installedExtensions.push(h))}removeInstalledExtension(h){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(S=>!(0,L.areSameExtensions)(S,h)))}async onDidChange(){if(this.installedExtensions){const h=await this.extensionsManagementService.getInstalled(1),S=h.filter(g=>[...this.installingExtensions,...this.installedExtensions].some(a=>(0,L.areSameExtensions)(a,g.identifier))?!1:g.installedTimestamp&&g.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",g.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",g.identifier.id),!1)),y=this.installedExtensions.filter(g=>this.installingExtensions.some(a=>(0,L.areSameExtensions)(a,g))?!1:h.every(a=>!(0,L.areSameExtensions)(a.identifier,g))?(this.logService.info("Detected extension removed from another source",g.id),!0):!1);this.installedExtensions=h.map(g=>g.identifier),(S.length||y.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:S,removed:y})}}};b=pe([oe(1,I.IFileService),oe(2,R.INativeEnvironmentService),oe(3,c.ILogService),oe(4,d.IUriIdentityService)],b),i.ExtensionsWatcher=b}),define(Q[126],Z([0,1,36,91,16,19,58,6,2]),function(z,i,C,D,P,R,L,I,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UriIdentityService=void 0;class d{constructor(h){this.uri=h,this.time=d._clock++}touch(){return this.time=d._clock++,this}}d._clock=0;let b=class{constructor(h){this._fileService=h,this._dispooables=new c.DisposableStore,this._limit=2**16;const S=new Map,y=g=>{let a=S.get(g.scheme);return a===void 0&&(a=h.hasProvider(g)&&!this._fileService.hasCapability(g,1024),S.set(g.scheme,a)),a};this._dispooables.add(I.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(g=>{S.delete(g.scheme)})),this.extUri=new R.ExtUri(y),this._canonicalUris=new L.SkipList((g,a)=>this.extUri.compare(g,a,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(h){this._fileService.hasProvider(h)&&(h=(0,R.normalizePath)(h));let S=this._canonicalUris.get(h);return S?S.touch().uri.with({fragment:h.fragment}):(this._canonicalUris.set(h,new d(h)),this._checkTrim(),h)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const h=[...this._canonicalUris.entries()].sort((y,g)=>y[1].touch<g[1].touch?1:y[1].touch>g[1].touch?-1:0);d._clock=0,this._canonicalUris.clear();const S=this._limit*.5;for(let y=0;y<S;y++)this._canonicalUris.set(h[y][0],h[y][1].touch())}};b=pe([oe(0,P.IFileService)],b),i.UriIdentityService=b,(0,D.registerSingleton)(C.IUriIdentityService,b,!0)}),define(Q[43],Z([0,1,103,3,11,8,15,72,138,139]),function(z,i,C,D,P,R,L,I,c,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buffer=i.extract=i.zip=i.ExtractError=void 0;class b extends Error{constructor(t,r){let e=r.message;switch(t){case"CorruptZip":e=`Corrupt ZIP: ${e}`;break}super(e);this.type=t,this.cause=r}}i.ExtractError=b;function T(o){const t=o.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,e)=>r+e,t&61440)}function h(o){if(o instanceof b)return o;let t;return/end of central directory record signature not found/.test(o.message)&&(t="CorruptZip"),new b(t,o)}function S(o,t,r,e,n,s){const l=P.dirname(t),f=P.join(e,l);if(!f.startsWith(e))return Promise.reject(new Error(I.localize(0,null,t)));const m=P.join(e,t);let w;return s.onCancellationRequested(()=>{w&&w.destroy()}),Promise.resolve(L.Promises.mkdir(f,{recursive:!0})).then(()=>new Promise((O,N)=>{if(!s.isCancellationRequested)try{w=(0,C.createWriteStream)(m,{mode:r}),w.once("close",()=>O()),w.once("error",N),o.once("error",N),o.pipe(w)}catch(q){N(q)}}))}function y(o,t,r,e){let n=(0,D.createCancelablePromise)(()=>Promise.resolve()),s=0;return e.onCancellationRequested(()=>{n.cancel(),o.close()}),new Promise((l,f)=>{const m=new D.Sequencer,w=O=>{O.isCancellationRequested||(s++,o.readEntry())};o.once("error",f),o.once("close",()=>n.then(()=>{e.isCancellationRequested||o.entryCount===s?l():f(new b("Incomplete",new Error(I.localize(1,null,s,o.entryCount))))},f)),o.readEntry(),o.on("entry",O=>{if(e.isCancellationRequested)return;if(!r.sourcePathRegex.test(O.fileName)){w(e);return}const N=O.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(N)){const se=P.join(t,N);n=(0,D.createCancelablePromise)(ie=>L.Promises.mkdir(se,{recursive:!0}).then(()=>w(ie)).then(void 0,f));return}const q=a(o,O),J=T(O);n=(0,D.createCancelablePromise)(se=>m.queue(()=>q.then(ie=>S(ie,N,J,t,r,se).then(()=>w(se)))).then(null,f))})})}function g(o,t=!1){return new Promise((r,e)=>{(0,c.open)(o,t?{lazyEntries:!0}:void 0,(n,s)=>{n?e(h(n)):r((0,R.assertIsDefined)(s))})})}function a(o,t){return new Promise((r,e)=>{o.openReadStream(t,(n,s)=>{n?e(h(n)):r((0,R.assertIsDefined)(s))})})}function u(o,t){return new Promise((r,e)=>{const n=new d.ZipFile;t.forEach(l=>{l.contents?n.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&n.addFile(l.localPath,l.path)}),n.end();const s=(0,C.createWriteStream)(o);n.outputStream.pipe(s),n.outputStream.once("error",e),s.once("error",e),s.once("finish",()=>r(o))})}i.zip=u;function v(o,t,r={},e){const n=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let s=g(o,!0);return r.overwrite&&(s=s.then(l=>L.Promises.rm(t).then(()=>l))),s.then(l=>y(l,t,{sourcePathRegex:n},e))}i.extract=v;function E(o,t){return g(o).then(r=>new Promise((e,n)=>{r.on("entry",s=>{s.fileName===t&&a(r,s).then(l=>e(l),l=>n(l))}),r.once("close",()=>n(new Error(I.localize(2,null,t))))}))}function p(o,t){return E(o,t).then(r=>new Promise((e,n)=>{const s=[];r.once("error",n),r.on("data",l=>s.push(l)),r.on("end",()=>e(Buffer.concat(s)))}))}i.buffer=p}),define(Q[127],Z([0,1,43,79]),function(z,i,C,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getManifest=void 0;function P(R){return(0,C.buffer)(R,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}i.getManifest=P}),define(Q[128],Z([0,1,18,3,7,2,10,11,12,19,41,9,27,15,43,80,20,23,21,90,16,14,32]),function(z,i,C,D,P,R,L,I,c,d,b,T,h,S,y,g,a,u,v,E,p,o,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsScanner=void 0;let r=class extends R.Disposable{constructor(n,s,l,f,m){super();this.beforeRemovingExtension=n,this.fileService=s,this.logService=l,this.environmentService=f,this.productService=m,this._devSystemExtensionsPath=null,this.systemExtensionsPath=f.builtinExtensionsPath,this.extensionsPath=f.extensionsPath,this.uninstalledPath=I.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new D.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(n){const s=[];(n===null||n===0)&&s.push(this.scanSystemExtensions().then(null,l=>Promise.reject(new u.ExtensionManagementError(this.joinErrors(l).message,u.ExtensionManagementErrorCode.Internal)))),(n===null||n===1)&&s.push(this.scanUserExtensions(!0).then(null,l=>Promise.reject(new u.ExtensionManagementError(this.joinErrors(l).message,u.ExtensionManagementErrorCode.Internal))));try{const l=await Promise.all(s);return(0,C.flatten)(l)}catch(l){throw this.joinErrors(l)}}async scanUserExtensions(n){this.logService.trace("Started scanning user extensions");let[s,l]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return l=l.filter(f=>!s[new v.ExtensionIdentifierWithVersion(f.identifier,f.manifest.version).key()]),n&&(l=(0,v.groupByExtension)(l,m=>m.identifier).map(m=>m.sort((w,O)=>b.rcompare(w.manifest.version,O.manifest.version))[0])),this.logService.trace("Scanned user extensions:",l.length),l}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(n,s,l,f){const m=n.key(),w=I.join(this.extensionsPath,`.${(0,h.generateUuid)()}`),O=I.join(this.extensionsPath,m);try{await S.Promises.rm(O)}catch{try{await S.Promises.rm(O)}catch{}throw new u.ExtensionManagementError((0,g.localize)(0,null,O,n.id),u.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(n,s,w,f);let N=await this.scanExtension(T.URI.file(w),1);if(!N)throw new Error((0,g.localize)(1,null,w));await this.storeMetadata(N,{...l,installedTimestamp:Date.now()});try{await this.rename(n,w,O,Date.now()+2*60*1e3),this.logService.info("Renamed to",O)}catch(q){try{await S.Promises.rm(w)}catch{}if(q.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",n.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(q)}. Deleted from extracted location`,w),q}try{N=await this.scanExtension(T.URI.file(O),1)}catch{}if(N)return N;throw new Error((0,g.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(n,s){return this.setMetadata(n,s),await this.storeMetadata(n,{...s,installedTimestamp:n.installedTimestamp}),n}async storeMetadata(n,s){s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.installedTimestamp=s.installedTimestamp||void 0;const l=I.join(n.location.fsPath,"package.json"),f=await S.Promises.readFile(l,"utf8"),{manifest:m}=await this.parseManifest(f);return m.__metadata=s,await S.Promises.writeFile(l,JSON.stringify(m,null,"	")),n}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...n){const s=n.map(l=>new v.ExtensionIdentifierWithVersion(l.identifier,l.manifest.version));await this.withUninstalledExtensions(l=>{s.forEach(f=>l[f.key()]=!0)})}async setInstalled(n){await this.withUninstalledExtensions(f=>delete f[n.key()]);const l=(await this.scanExtensions(1)).find(f=>new v.ExtensionIdentifierWithVersion(f.identifier,f.manifest.version).equals(n))||null;return l?(await this.storeMetadata(l,{installedTimestamp:Date.now()}),this.scanExtension(l.location,1)):null}async withUninstalledExtensions(n){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=await S.Promises.readFile(this.uninstalledPath,"utf8")}catch(f){if(f.code!=="ENOENT")throw f}let l={};if(s)try{l=JSON.parse(s)}catch{}return n&&(n(l),Object.keys(l).length?await S.Promises.writeFile(this.uninstalledPath,JSON.stringify(l)):await S.Promises.rm(this.uninstalledPath)),l})}async removeExtension(n,s){this.logService.trace(`Deleting ${s} extension from disk`,n.identifier.id,n.location.fsPath),await S.Promises.rm(n.location.fsPath),this.logService.info("Deleted from disk",n.identifier.id,n.location.fsPath)}async removeUninstalledExtension(n){await this.removeExtension(n,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[new v.ExtensionIdentifierWithVersion(n.identifier,n.manifest.version).key()])}async extractAtLocation(n,s,l,f){this.logService.trace(`Started extracting the extension from ${s} to ${l}`);try{await S.Promises.rm(l)}catch(m){throw new u.ExtensionManagementError(this.joinErrors(m).message,u.ExtensionManagementErrorCode.Delete)}try{await(0,y.extract)(s,l,{sourcePath:"extension",overwrite:!0},f),this.logService.info(`Extracted extension to ${l}:`,n.id)}catch(m){try{await S.Promises.rm(l)}catch{}let w=u.ExtensionManagementErrorCode.Extract;throw m instanceof y.ExtractError&&(m.type==="CorruptZip"?w=u.ExtensionManagementErrorCode.CorruptZip:m.type==="Incomplete"&&(w=u.ExtensionManagementErrorCode.IncompleteZip)),new u.ExtensionManagementError(m.message,w)}}async rename(n,s,l,f){try{await S.Promises.rename(s,l)}catch(m){if(c.isWindows&&m&&m.code==="EPERM"&&Date.now()<f)return this.logService.info(`Failed renaming ${s} to ${l} with 'EPERM' error. Trying again...`,n.id),this.rename(n,s,l,f);throw new u.ExtensionManagementError(m.message||(0,g.localize)(3,null,s,l),m.code||u.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const n=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return n;const s=this.scanDevSystemExtensions(),[l,f]=await Promise.all([n,s]);return[...l,...f]}async scanExtensionsInDir(n,s){const l=new D.Limiter(10),f=await this.fileService.resolve(T.URI.file(n));return f.children?(await Promise.all(f.children.filter(w=>w.isDirectory).map(w=>l.queue(async()=>s===1&&(0,d.basename)(w.resource).indexOf(".")===0?null:this.scanExtension(w.resource,s))))).filter(w=>w&&w.identifier):[]}async scanExtension(n,s){try{const l=await this.fileService.resolve(n);if(l.children){const{manifest:f,metadata:m}=await this.readManifest(n.fsPath),w=l.children.find(({name:J})=>/^readme(\.txt|\.md|)$/i.test(J))?.resource,O=l.children.find(({name:J})=>/^changelog(\.txt|\.md|)$/i.test(J))?.resource,N={id:(0,v.getGalleryExtensionId)(f.publisher,f.name)},q={type:s,identifier:N,manifest:f,location:n,readmeUrl:w,changelogUrl:O,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:s===0};return this.setMetadata(q,m),q}}catch(l){s!==0&&this.logService.trace(l)}return null}async scanDefaultSystemExtensions(){const n=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",n.length),n}async scanDevSystemExtensions(){const n=this.getDevSystemExtensionsList();if(n.length){const s=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",s.length),s.filter(l=>n.some(f=>(0,v.areSameExtensions)(l.identifier,{id:f})))}else return[]}setMetadata(n,s){n.publisherDisplayName=s?.publisherDisplayName||null,n.publisherId=s?.publisherId||null,n.identifier.uuid=s?.id,n.isMachineScoped=!!s?.isMachineScoped,n.isPreReleaseVersion=!!s?.isPreReleaseVersion,n.preRelease=!!s?.preRelease,n.isBuiltin=n.type===0||!!s?.isBuiltin,n.installedTimestamp=s?.installedTimestamp}async removeUninstalledExtensions(){const n=await this.getUninstalledExtensions(),s=await this.scanAllUserExtensions(),l=new Set;for(const w of s)n[new v.ExtensionIdentifierWithVersion(w.identifier,w.manifest.version).key()]||l.add(w.identifier.id.toLowerCase());const f=(0,v.groupByExtension)(s,w=>w.identifier);await D.Promises.settled(f.map(async w=>{const O=w.sort((N,q)=>b.rcompare(N.manifest.version,q.manifest.version))[0];l.has(O.identifier.id.toLowerCase())||await this.beforeRemovingExtension(O)}));const m=s.filter(w=>n[new v.ExtensionIdentifierWithVersion(w.identifier,w.manifest.version).key()]);await D.Promises.settled(m.map(w=>this.removeUninstalledExtension(w)))}async removeOutdatedExtensions(){const n=await this.scanAllUserExtensions(),s=[],l=(0,v.groupByExtension)(n,f=>f.identifier);s.push(...(0,C.flatten)(l.map(f=>f.sort((m,w)=>b.rcompare(m.manifest.version,w.manifest.version)).slice(1)))),await D.Promises.settled(s.map(f=>this.removeExtension(f,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(n=>n.name)}joinErrors(n){const s=Array.isArray(n)?n:[n];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((l,f)=>new Error(`${l.message}${l.message?",":""}${f instanceof Error?f.message:f}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=I.normalize(I.join(L.FileAccess.asFileUri("",z).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(n){const s=[S.Promises.readFile(I.join(n,"package.json"),"utf8").then(w=>this.parseManifest(w)),S.Promises.readFile(I.join(n,"package.nls.json"),"utf8").then(void 0,w=>w.code!=="ENOENT"?Promise.reject(w):"{}").then(w=>JSON.parse(w))],[{manifest:l,metadata:f},m]=await Promise.all(s);return{manifest:(0,E.localizeManifest)(l,m),metadata:f}}parseManifest(n){return new Promise((s,l)=>{try{const f=JSON.parse(n),m=f.__metadata||null;s({manifest:f,metadata:m})}catch{l(new Error((0,g.localize)(4,null)))}})}};r=pe([oe(1,p.IFileService),oe(2,o.ILogService),oe(3,a.INativeEnvironmentService),oe(4,t.IProductService)],r),i.ExtensionsScanner=r}),define(Q[129],Z([0,1,28,7,10,11,12,29,19,41,9,27,15,43,78,49,20,119,23,21,110,98,127,111,128,125,48,16,13,14,32,31,36]),function(z,i,C,D,P,R,L,I,c,d,b,T,h,S,y,g,a,u,v,E,p,o,t,r,e,n,s,l,f,m,w,O,N){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementService=void 0;let q=class extends u.AbstractExtensionManagementService{constructor(B,_,re,M,A,W,H,ne,K){super(B,_,re,ne);this.environmentService=M,this.downloadService=A,this.fileService=H;const ee=this._register(W.createInstance(o.ExtensionsLifecycle));this.extensionsScanner=this._register(W.createInstance(e.ExtensionsScanner,ae=>ee.postUninstall(ae))),this.manifestCache=this._register(new r.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(W.createInstance(p.ExtensionsDownloader));const G=this._register(new n.ExtensionsWatcher(this,H,M,re,K));this._register(G.onDidChangeExtensionsByAnotherSource(({added:ae,removed:U})=>{ae.length&&this._onDidInstallExtensions.fire(ae.map(k=>({identifier:k.identifier,operation:1,local:k}))),U.forEach(k=>this._onDidUninstallExtension.fire({identifier:k}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const B=await this.isAlpineLinux(),_=(0,v.getTargetPlatform)(B?"alpine":L.platform,I.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",_),_})()),this._targetPlatformPromise}async isAlpineLinux(){if(!L.isLinux)return!1;let B;try{B=(await this.fileService.readFile(b.URI.file("/etc/os-release"))).value.toString()}catch{try{B=(await this.fileService.readFile(b.URI.file("/usr/lib/os-release"))).value.toString()}catch(re){this.logService.debug("Error while getting the os-release file.",(0,D.getErrorMessage)(re))}}return!!B&&(B.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(B){this.logService.trace("ExtensionManagementService#zip",B.identifier.id);const _=await this.collectFiles(B),re=await(0,S.zip)((0,c.joinPath)(this.environmentService.tmpDir,(0,T.generateUuid)()).fsPath,_);return b.URI.file(re)}async unzip(B){return this.logService.trace("ExtensionManagementService#unzip",B.toString()),(await this.install(B)).identifier}async getManifest(B){const _=await this.downloadVsix(B),re=R.resolve(_.fsPath);return(0,t.getManifest)(re)}getInstalled(B=null){return this.extensionsScanner.scanExtensions(B)}async install(B,_={}){this.logService.trace("ExtensionManagementService#install",B.toString());const re=await this.downloadVsix(B),M=await(0,t.getManifest)(R.resolve(re.fsPath));if(M.engines&&M.engines.vscode&&!(0,s.isEngineValid)(M.engines.vscode,this.productService.version,this.productService.date))throw new Error(y.localize(0,null,(0,E.getGalleryExtensionId)(M.publisher,M.name),this.productService.version));return this.installExtension(M,re,_)}async updateMetadata(B,_){this.logService.trace("ExtensionManagementService#updateMetadata",B.identifier.id);const re={...B.manifest.__metadata||{},..._};return _.isPreReleaseVersion&&(re.preRelease=!0),B=await this.extensionsScanner.saveMetadataForLocalExtension(B,re),this.manifestCache.invalidate(),B}async updateExtensionScope(B,_){return this.logService.trace("ExtensionManagementService#updateExtensionScope",B.identifier.id),B=await this.extensionsScanner.saveMetadataForLocalExtension(B,{...B.manifest.__metadata||{},isMachineScoped:_}),this.manifestCache.invalidate(),B}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(B){if(B.scheme===P.Schemas.file)return B;const _=(0,c.joinPath)(this.environmentService.tmpDir,(0,T.generateUuid)());return await this.downloadService.download(B,_),_}createInstallExtensionTask(B,_,re){return b.URI.isUri(_)?new ie(B,_,re,this.galleryService,this.extensionsScanner,this.logService):new se(_,re,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(B,_){return new te(B,_,this.extensionsScanner)}async collectFiles(B){const _=async M=>{let A=await h.Promises.readdir(M);A=A.map(ne=>R.join(M,ne));const W=await Promise.all(A.map(ne=>h.Promises.stat(ne)));let H=Promise.resolve([]);return W.forEach((ne,K)=>{const ee=A[K];ne.isFile()&&(H=H.then(G=>[...G,ee])),ne.isDirectory()&&(H=H.then(G=>_(ee).then(ae=>[...G,...ae])))}),H};return(await _(B.location.fsPath)).map(M=>({path:`extension/${R.relative(B.location.fsPath,M)}`,localPath:M}))}};q=pe([oe(0,v.IExtensionGalleryService),oe(1,O.ITelemetryService),oe(2,m.ILogService),oe(3,a.INativeEnvironmentService),oe(4,g.IDownloadService),oe(5,f.IInstantiationService),oe(6,l.IFileService),oe(7,w.IProductService),oe(8,N.IUriIdentityService)],q),i.ExtensionManagementService=q;class J extends u.AbstractExtensionTask{constructor(B,_,re,M){super();this.identifier=B,this.source=_,this.extensionsScanner=re,this.logService=M,this._operation=2}get operation(){return this._operation}async installExtension(B,_){try{const re=await this.unsetUninstalledAndGetLocal(B.identifierWithVersion);if(re)return B.metadata?this.extensionsScanner.saveMetadataForLocalExtension(re,{...re.manifest.__metadata||{},...B.metadata}):re}catch{throw L.isMacintosh?new v.ExtensionManagementError(y.localize(1,null),v.ExtensionManagementErrorCode.Internal):new v.ExtensionManagementError(y.localize(2,null),v.ExtensionManagementErrorCode.Internal)}return this.extract(B,_)}async unsetUninstalledAndGetLocal(B){if(!await this.isUninstalled(B))return null;this.logService.trace("Removing the extension from uninstalled list:",B.id);const re=await this.extensionsScanner.setInstalled(B);return this.logService.info("Removed the extension from uninstalled list:",B.id),re}async isUninstalled(B){return!!(await this.extensionsScanner.getUninstalledExtensions())[B.key()]}async extract({zipPath:B,identifierWithVersion:_,metadata:re},M){let A=await this.extensionsScanner.extractUserExtension(_,B,re,M);return this.logService.info("Extracting completed.",_.id),A}}class se extends J{constructor(B,_,re,M,A){super(B.identifier,B,M,A);this.gallery=B,this.options=_,this.extensionsDownloader=re}async doRun(B){const re=(await this.extensionsScanner.scanExtensions(null)).find(A=>(0,E.areSameExtensions)(A.identifier,this.gallery.identifier));re&&(this._operation=3);const M=await this.downloadInstallableExtension(this.gallery,this._operation);M.metadata.isMachineScoped=this.options.isMachineScoped||re?.isMachineScoped,M.metadata.isBuiltin=this.options.isBuiltin||re?.isBuiltin,M.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,M.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:re?.preRelease||this.options.installPreReleaseVersion;try{const A=await this.installExtension(M,B);return re&&d.neq(re.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(re),A}catch(A){throw await this.deleteDownloadedVSIX(M.zipPath),A}}async deleteDownloadedVSIX(B){try{await this.extensionsDownloader.delete(b.URI.file(B))}catch(_){this.logService.warn("Error while deleting the downloaded vsix",B.toString(),(0,D.getErrorMessage)(_))}}async downloadInstallableExtension(B,_){const re={id:B.identifier.uuid,publisherId:B.publisherId,publisherDisplayName:B.publisherDisplayName};let M;try{this.logService.trace("Started downloading extension:",B.identifier.id),M=(await this.extensionsDownloader.downloadExtension(B,_)).fsPath,this.logService.info("Downloaded extension:",B.identifier.id,M)}catch(A){throw new v.ExtensionManagementError((0,u.joinErrors)(A).message,v.ExtensionManagementErrorCode.Download)}try{const A=await(0,t.getManifest)(M);return{zipPath:M,identifierWithVersion:new E.ExtensionIdentifierWithVersion(B.identifier,A.version),metadata:re}}catch(A){throw await this.deleteDownloadedVSIX(M),new v.ExtensionManagementError((0,u.joinErrors)(A).message,v.ExtensionManagementErrorCode.Invalid)}}}class ie extends J{constructor(B,_,re,M,A,W){super({id:(0,E.getGalleryExtensionId)(B.publisher,B.name)},_,A,W);this.manifest=B,this.location=_,this.options=re,this.galleryService=M}async doRun(B){const _=new E.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),M=(await this.extensionsScanner.scanExtensions(1)).find(W=>(0,E.areSameExtensions)(this.identifier,W.identifier)),A=await this.getMetadata(this.identifier.id,this.manifest.version,B);if(A.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,A.isBuiltin=this.options.isBuiltin||M?.isBuiltin,M)if(this._operation=3,_.equals(new E.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version)))try{await this.extensionsScanner.removeExtension(M,"existing")}catch{throw new Error(y.localize(3,null,this.manifest.displayName||this.manifest.name))}else d.gt(M.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(M);else{const W=await this.unsetUninstalledAndGetLocal(_);if(W)try{await this.extensionsScanner.removeExtension(W,"existing")}catch{throw new Error(y.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:R.resolve(this.location.fsPath),identifierWithVersion:_,metadata:A},B)}async getMetadata(B,_,re){try{let[M]=await this.galleryService.getExtensions([{id:B,version:_}],re);if(M||([M]=await this.galleryService.getExtensions([{id:B}],re)),M)return{id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId,isPreReleaseVersion:M.properties.isPreReleaseVersion,preRelease:M.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class te extends u.AbstractExtensionTask{constructor(B,_,re){super();this.extension=B,this.options=_,this.extensionsScanner=re}async doRun(B){const _=[],re=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const M=new E.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);_.push(...re.filter(A=>M.equals(new E.ExtensionIdentifierWithVersion(A.identifier,A.manifest.version))))}else _.push(...re.filter(M=>(0,E.areSameExtensions)(M.identifier,this.extension.identifier)));if(!_.length)throw new Error(y.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(..._),this.options.remove)for(const M of _)try{B.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(M)}catch(A){throw new Error(y.localize(6,null,(0,C.toErrorMessage)(A)))}}}}),define(Q[130],Z([0,1,115,3,17,7,2,8,25,20,93,14,114,140]),function(z,i,C,D,P,R,L,I,c,d,b,T,h,S){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.RequestService=void 0;let y=class extends L.Disposable{constructor(a,u,v){super();this.environmentService=u,this.logService=v,this.configure(a.getValue()),this._register(a.onDidChangeConfiguration(()=>this.configure(a.getValue()),this))}configure(a){this.proxyUrl=a.http&&a.http.proxy,this.strictSSL=!!(a.http&&a.http.proxyStrictSSL),this.authorization=a.http&&a.http.proxyAuthorization}async request(a,u){this.logService.trace("RequestService#request",a.url);const{proxyUrl:v,strictSSL:E}=this;let p;try{p=await(0,b.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",r))}const o={...process.env,...p},t=a.agent?a.agent:await(0,h.getProxyAgent)(a.url||"",o,{proxyUrl:v,strictSSL:E});return a.agent=t,a.strictSSL=E,this.authorization&&(a.headers={...a.headers||{},"Proxy-Authorization":this.authorization}),this._request(a,u)}async getNodeRequest(a){return((0,C.parse)(a.url).protocol==="https:"?await new Promise((E,p)=>{z(["https"],E,p)}):await new Promise((E,p)=>{z(["http"],E,p)})).request}_request(a,u){return D.Promises.withAsyncBody(async(v,E)=>{let p;const o=(0,C.parse)(a.url),t=a.getRawRequest?a.getRawRequest(a):await this.getNodeRequest(a),r={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:a.type||"GET",headers:a.headers,agent:a.agent,rejectUnauthorized:(0,I.isBoolean)(a.strictSSL)?a.strictSSL:!0};a.user&&a.password&&(r.auth=a.user+":"+a.password),p=t(r,e=>{const n=(0,I.isNumber)(a.followRedirects)?a.followRedirects:3;if(e.statusCode&&e.statusCode>=300&&e.statusCode<400&&n>0&&e.headers.location)this._request({...a,url:e.headers.location,followRedirects:n-1},u).then(v,E);else{let s=e;e.headers["content-encoding"]==="gzip"&&(s=e.pipe((0,S.createGunzip)())),v({res:e,stream:(0,P.streamToBufferReadableStream)(s)})}}),p.on("error",E),a.timeout&&p.setTimeout(a.timeout),a.data&&typeof a.data=="string"&&p.write(a.data),p.end(),u.onCancellationRequested(()=>{p.abort(),E((0,R.canceled)())})})}async resolveProxy(a){}};y=pe([oe(0,c.IConfigurationService),oe(1,d.INativeEnvironmentService),oe(2,T.ILogService)],y),i.RequestService=y}),define(Q[141],Z([0,1,33,3,17,28,7,2,10,11,29,9,15,25,107,49,113,20,89,120,23,109,129,16,100,102,39,97,52,53,112,14,104,122,32,42,130,118,31,121,35,123,124,36,126]),function(z,i,C,D,P,R,L,I,c,d,b,T,h,S,y,g,a,u,v,E,p,o,t,r,e,n,s,l,f,m,w,O,N,q,J,se,ie,te,ge,B,_,re,M,A,W){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.main=void 0;class H extends I.Disposable{constructor(ee){super();this.argv=ee,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[ee,G]=await this.initServices();return ee.invokeFunction(async ae=>{const U=ae.get(O.ILogService),k=ae.get(r.IFileService),x=ae.get(u.INativeEnvironmentService),j=ae.get(p.IExtensionManagementCLIService);U.info("CLI main",this.argv),this.registerErrorHandler(U),await this.doRun(x,j,k),await Promise.all(G.map(Y=>{(0,D.raceTimeout)(Y.flush(),1e3)}))})}async initServices(){const ee=new f.ServiceCollection,G={_serviceBrand:void 0,...q.default};ee.set(J.IProductService,G);const ae=new v.NativeEnvironmentService(this.argv,G);ee.set(u.INativeEnvironmentService,ae),await Promise.all([ae.appSettingsHome.fsPath,ae.extensionsPath].map(fe=>fe?h.Promises.mkdir(fe,{recursive:!0}):void 0));const U=(0,O.getLogLevel)(ae),k=[];k.push(new N.SpdLogLogger("cli",(0,d.join)(ae.logsPath,"cli.log"),!0,!1,U)),U===O.LogLevel.Trace&&k.push(new O.ConsoleLogger(U));const x=this._register(new O.MultiplexLogService(k));ee.set(O.ILogService,x);const j=this._register(new e.FileService(x));ee.set(r.IFileService,j);const Y=this._register(new n.DiskFileSystemProvider(x));j.registerProvider(c.Schemas.file,Y);const X=this._register(new y.ConfigurationService(ae.settingsResource,j));ee.set(S.IConfigurationService,X),await X.initialize(),ee.set(A.IUriIdentityService,new W.UriIdentityService(j)),ee.set(se.IRequestService,new s.SyncDescriptor(ie.RequestService)),ee.set(g.IDownloadService,new s.SyncDescriptor(a.DownloadService)),ee.set(p.IExtensionManagementService,new s.SyncDescriptor(t.ExtensionManagementService)),ee.set(p.IExtensionGalleryService,new s.SyncDescriptor(E.ExtensionGalleryServiceWithNoStorageService)),ee.set(p.IExtensionManagementCLIService,new s.SyncDescriptor(o.ExtensionManagementCLIService)),ee.set(m.ILocalizationsService,new s.SyncDescriptor(w.LocalizationsService));const he=[];if((0,_.supportsTelemetry)(G,ae)){G.aiConfig&&G.aiConfig.asimovKey&&he.push(new re.AppInsightsAppender("monacoworkbench",null,G.aiConfig.asimovKey));const{appRoot:fe,extensionsPath:ye,installSourcePath:le}=ae,ce={appenders:he,sendErrorTelemetry:!1,commonProperties:(async()=>{let de;try{const me=await h.Promises.readFile((0,d.join)(ae.userDataPath,"storage.json"));de=JSON.parse(me.toString())[ge.machineIdKey]}catch(me){me.code!=="ENOENT"&&x.error(me)}return(0,te.resolveCommonProperties)(j,(0,C.release)(),(0,C.hostname)(),process.arch,G.commit,G.version,de,G.msftInternalDomains,le)})(),piiPaths:[fe,ye]};ee.set(ge.ITelemetryService,new s.SyncDescriptor(B.TelemetryService,[ce]))}else ee.set(ge.ITelemetryService,_.NullTelemetryService);return[new l.InstantiationService(ee),he]}registerErrorHandler(ee){(0,L.setUnexpectedErrorHandler)(G=>{const ae=(0,R.toErrorMessage)(G,!0);!ae||ee.error(`[uncaught exception in CLI]: ${ae}`)}),process.on("uncaughtException",G=>(0,L.onUnexpectedError)(G)),process.on("unhandledRejection",G=>(0,L.onUnexpectedError)(G))}async doRun(ee,G,ae){if(this.argv["install-source"])return this.setInstallSource(ee,ae,this.argv["install-source"]);if(this.argv["list-extensions"])return G.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const U={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return G.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],U,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return G.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return G.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(ee.appRoot,ee.extensionsPath))}}asExtensionIdOrVSIX(ee){return ee.map(G=>/\.vsix$/i.test(G)?T.URI.file((0,d.isAbsolute)(G)?G:(0,d.join)((0,b.cwd)(),G)):G)}async setInstallSource(ee,G,ae){await G.writeFile(T.URI.file(ee.installSourcePath),P.VSBuffer.fromString(ae.slice(0,30)))}}async function ne(K){const ee=new H(K);try{await ee.run()}finally{ee.dispose()}}i.main=ne})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/865a677399f0c0a1e98e0b9eb7308f1297b6ace4/core/vs/code/node/cliProcessMain.js.map
