/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/arrays","vs/base/common/types","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/extpath","vs/base/node/pfs","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/hash","vs/base/common/marshalling","fs","vs/platform/instantiation/common/extensions","vs/platform/contextkey/common/contextkey","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/languages/languageSelector","vs/editor/common/languages","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/cache","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/languages/tokenizationRegistry","vs/editor/common/model/textModelSearch","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/model","vs/editor/common/languages/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsDragAndDropService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ve=function(Z){for(var e=[],f=0,t=Z.length;f<t;f++)e[f]=pe[Z[f]];return e};define(pe[55],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function f(t,I){if(!t)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=f}),define(pe[74],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function f(R){return R?R.replace(/\$\((.*?)\)/g,(k,y)=>` ${y} `).trim():""}e.getCodiconAriaLabel=f;class t{constructor(k,y,P){this.id=k,this.definition=y,this.description=P,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function I(R,k){const y=["codicon","codicon-"+R];return k&&y.push("codicon-modifier-"+k),y}e.getClassNamesArray=I;var _;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function y(C){if(C instanceof t)return["codicon","codicon-"+C.id];const l=k.exec(C.id);if(!l)return y(t.error);let[,b,p]=l;const g=["codicon","codicon-"+b];return p&&g.push("codicon-modifier-"+p.substr(1)),g}R.asClassNameArray=y;function P(C){return y(C).join(" ")}R.asClassName=P;function L(C){return"."+y(C).join(".")}R.asCSSSelector=L})(_=e.CSSIcon||(e.CSSIcon={}))}),define(pe[75],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const f=Object.prototype.hasOwnProperty;function t(L){const C=[];for(let l in L)f.call(L,l)&&C.push(L[l]);return C}e.values=t;function I(L,C){for(let l in L)if(f.call(L,l)&&C({key:l,value:L[l]},function(){delete L[l]})===!1)return}e.forEach=I;function _(L,C){const l=Object.create(null);for(const b of L){const p=C(b);let g=l[p];g||(g=l[p]=[]),g.push(b)}return l}e.groupBy=_;function R(L){const C=Object.create(null);return L&&L.forEach((l,b)=>{C[b]=l}),C}e.fromMap=R;function k(L,C){const l=[],b=[];for(let p of L)C.has(p)||l.push(p);for(let p of C)L.has(p)||b.push(p);return{removed:l,added:b}}e.diffSets=k;function y(L,C){const l=[],b=[];for(let[p,g]of L)C.has(p)||l.push(g);for(let[p,g]of C)L.has(p)||b.push(g);return{removed:l,added:b}}e.diffMaps=y;class P{constructor(){this.map=new Map}add(C,l){let b=this.map.get(C);b||(b=new Set,this.map.set(C,b)),b.add(l)}delete(C,l){const b=this.map.get(C);!b||(b.delete(l),b.size===0&&this.map.delete(C))}forEach(C,l){const b=this.map.get(C);!b||b.forEach(l)}}e.SetMap=P}),define(pe[56],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function f(R){return(k,y,P)=>{let L=null,C=null;if(typeof P.value=="function"?(L="value",C=P.value):typeof P.get=="function"&&(L="get",C=P.get),!C)throw new Error("not supported");P[L]=R(C,y)}}e.createDecorator=f;function t(R,k,y){let P=null,L=null;if(typeof y.value=="function"?(P="value",L=y.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(P="get",L=y.get),!L)throw new Error("not supported");const C=`$memoize$${k}`;y[P]=function(...l){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,l)}),this[C]}}e.memoize=t;function I(R,k,y){return f((P,L)=>{const C=`$debounce$${L}`,l=`$debounce$result$${L}`;return function(...b){this[l]||(this[l]=y?y():void 0),clearTimeout(this[C]),k&&(this[l]=k(this[l],...b),b=[this[l]]),this[C]=setTimeout(()=>{P.apply(this,b),this[l]=y?y():void 0},R)}})}e.debounce=I;function _(R,k,y){return f((P,L)=>{const C=`$throttle$timer$${L}`,l=`$throttle$result$${L}`,b=`$throttle$lastRun$${L}`,p=`$throttle$pending$${L}`;return function(...g){if(this[l]||(this[l]=y?y():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),k&&(this[l]=k(this[l],...g)),this[p])return;const E=this[b]+R;E<=Date.now()?(this[b]=Date.now(),P.apply(this,[this[l]]),this[l]=y?y():void 0):(this[p]=!0,this[C]=setTimeout(()=>{this[p]=!1,this[b]=Date.now(),P.apply(this,[this[l]]),this[l]=y?y():void 0},E-Date.now()))}})}e.throttle=_}),define(pe[16],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class f{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(S=>{S(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=f,e.errorHandler=new f;function t(h){e.errorHandler.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=t;function I(h){y(h)||e.errorHandler.onUnexpectedError(h)}e.onUnexpectedError=I;function _(h){y(h)||e.errorHandler.onUnexpectedExternalError(h)}e.onUnexpectedExternalError=_;function R(h){if(h instanceof Error){let{name:n,message:S}=h;const a=h.stacktrace||h.stack;return{$isError:!0,name:n,message:S,stack:a}}return h}e.transformErrorForSerialization=R;const k="Canceled";function y(h){return h instanceof P?!0:h instanceof Error&&h.name===k&&h.message===k}e.isCancellationError=y;class P extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=P;function L(){const h=new Error(k);return h.name=h.message,h}e.canceled=L;function C(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.illegalArgument=C;function l(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.illegalState=l;function b(h){return h?new Error(`readonly property '${h} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function p(h){const n=new Error(`${h} has been disposed`);return n.name="DISPOSED",n}e.disposed=p;function g(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.getErrorMessage=g;class E extends Error{constructor(n){super("NotImplemented");n&&(this.message=n)}}e.NotImplementedError=E;class F extends Error{constructor(n){super("NotSupported");n&&(this.message=n)}}e.NotSupportedError=F;class D extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=D;function u(h){const n=h;return n instanceof Error&&Array.isArray(n.actions)}e.isErrorWithActions=u;function s(h,n=Object.create(null)){const S=new Error(h);return n.actions&&(S.actions=n.actions),S}e.createErrorWithActions=s}),define(pe[17],ve([0,1,16]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(K,X=0){return K[K.length-(1+X)]}e.tail=t;function I(K){if(K.length===0)throw new Error("Invalid tail call");return[K.slice(0,K.length-1),K[K.length-1]]}e.tail2=I;function _(K,X,ae=(fe,be)=>fe===be){if(K===X)return!0;if(!K||!X||K.length!==X.length)return!1;for(let fe=0,be=K.length;fe<be;fe++)if(!ae(K[fe],X[fe]))return!1;return!0}e.equals=_;function R(K,X,ae){let fe=0,be=K.length-1;for(;fe<=be;){const Me=(fe+be)/2|0,xe=ae(K[Me],X);if(xe<0)fe=Me+1;else if(xe>0)be=Me-1;else return Me}return-(fe+1)}e.binarySearch=R;function k(K,X){let ae=0,fe=K.length;if(fe===0)return 0;for(;ae<fe;){const be=Math.floor((ae+fe)/2);X(K[be])?fe=be:ae=be+1}return ae}e.findFirstInSorted=k;function y(K,X,ae){if(K=K|0,K>=X.length)throw new TypeError("invalid index");let fe=X[Math.floor(X.length*Math.random())],be=[],Me=[],xe=[];for(let Ge of X){const Je=ae(Ge,fe);Je<0?be.push(Ge):Je>0?Me.push(Ge):xe.push(Ge)}return K<be.length?y(K,be,ae):K<be.length+xe.length?xe[0]:y(K-(be.length+xe.length),Me,ae)}e.quickSelect=y;function P(K,X){const ae=[];let fe;for(const be of K.slice(0).sort(X))!fe||X(fe[0],be)!==0?(fe=[be],ae.push(fe)):fe.push(be);return ae}e.groupBy=P;function L(K,X,ae){const fe=[];function be(Ge,Je,q){if(Je===0&&q.length===0)return;const te=fe[fe.length-1];te&&te.start+te.deleteCount===Ge?(te.deleteCount+=Je,te.toInsert.push(...q)):fe.push({start:Ge,deleteCount:Je,toInsert:q})}let Me=0,xe=0;for(;;){if(Me===K.length){be(Me,0,X.slice(xe));break}if(xe===X.length){be(Me,K.length-Me,[]);break}const Ge=K[Me],Je=X[xe],q=ae(Ge,Je);q===0?(Me+=1,xe+=1):q<0?(be(Me,1,[]),Me+=1):q>0&&(be(Me,0,[Je]),xe+=1)}return fe}e.sortedDiff=L;function C(K,X,ae){const fe=L(K,X,ae),be=[],Me=[];for(const xe of fe)be.push(...K.slice(xe.start,xe.start+xe.deleteCount)),Me.push(...xe.toInsert);return{removed:be,added:Me}}e.delta=C;function l(K,X,ae){if(ae===0)return[];const fe=K.slice(0,ae).sort(X);return p(K,X,fe,ae,K.length),fe}e.top=l;function b(K,X,ae,fe,be){return ae===0?Promise.resolve([]):new Promise((Me,xe)=>{(async()=>{const Ge=K.length,Je=K.slice(0,ae).sort(X);for(let q=ae,te=Math.min(ae+fe,Ge);q<Ge;q=te,te=Math.min(te+fe,Ge)){if(q>ae&&await new Promise(G=>setTimeout(G)),be&&be.isCancellationRequested)throw(0,f.canceled)();p(K,X,Je,q,te)}return Je})().then(Me,xe)})}e.topAsync=b;function p(K,X,ae,fe,be){for(const Me=ae.length;fe<be;fe++){const xe=K[fe];if(X(xe,ae[Me-1])<0){ae.pop();const Ge=k(ae,Je=>X(xe,Je)<0);ae.splice(Ge,0,xe)}}}function g(K){return K.filter(X=>!!X)}e.coalesce=g;function E(K){let X=0;for(let ae=0;ae<K.length;ae++)K[ae]&&(K[X]=K[ae],X+=1);K.length=X}e.coalesceInPlace=E;function F(K,X,ae){K.splice(ae,0,K.splice(X,1)[0])}e.move=F;function D(K){return!Array.isArray(K)||K.length===0}e.isFalsyOrEmpty=D;function u(K){return Array.isArray(K)&&K.length>0}e.isNonEmptyArray=u;function s(K,X=ae=>ae){const ae=new Set;return K.filter(fe=>{const be=X(fe);return ae.has(be)?!1:(ae.add(be),!0)})}e.distinct=s;function h(K){const X=new Set;return ae=>{const fe=K(ae);return X.has(fe)?!1:(X.add(fe),!0)}}e.uniqueFilter=h;function n(K,X){const ae=S(K,X);if(ae!==-1)return K[ae]}e.findLast=n;function S(K,X){for(let ae=K.length-1;ae>=0;ae--){const fe=K[ae];if(X(fe))return ae}return-1}e.lastIndex=S;function a(K,X){return K.length>0?K[0]:X}e.firstOrDefault=a;function i(K,X,ae=(fe,be)=>fe===be){let fe=0;for(let be=0,Me=Math.min(K.length,X.length);be<Me&&ae(K[be],X[be]);be++)fe++;return fe}e.commonPrefixLength=i;function r(K){return[].concat(...K)}e.flatten=r;function c(K,X){let ae=typeof X=="number"?K:0;typeof X=="number"?ae=K:(ae=0,X=K);const fe=[];if(ae<=X)for(let be=ae;be<X;be++)fe.push(be);else for(let be=ae;be>X;be--)fe.push(be);return fe}e.range=c;function o(K,X,ae){return K.reduce((fe,be)=>(fe[X(be)]=ae?ae(be):be,fe),Object.create(null))}e.index=o;function d(K,X){return K.push(X),()=>m(K,X)}e.insert=d;function m(K,X){const ae=K.indexOf(X);if(ae>-1)return K.splice(ae,1),X}e.remove=m;function v(K,X,ae){const fe=K.slice(0,X),be=K.slice(X);return fe.concat(ae,be)}e.arrayInsert=v;function w(K,X){let ae;if(typeof X=="number"){let fe=X;ae=()=>{const be=Math.sin(fe++)*179426549;return be-Math.floor(be)}}else ae=Math.random;for(let fe=K.length-1;fe>0;fe-=1){const be=Math.floor(ae()*(fe+1)),Me=K[fe];K[fe]=K[be],K[be]=Me}}e.shuffle=w;function A(K,X){const ae=K.indexOf(X);ae>-1&&(K.splice(ae,1),K.unshift(X))}e.pushToStart=A;function M(K,X){const ae=K.indexOf(X);ae>-1&&(K.splice(ae,1),K.push(X))}e.pushToEnd=M;function T(K,X){return Array.isArray(K)?K.map(X):X(K)}e.mapArrayOrNot=T;function O(K){return Array.isArray(K)?K:[K]}e.asArray=O;function U(K){return K[Math.floor(Math.random()*K.length)]}e.getRandomElement=U;function V(K,X){for(const ae of K){const fe=X(ae);if(fe!==void 0)return fe}}e.mapFind=V;function x(K,X,ae){const fe=B(K,X),be=K.length,Me=ae.length;K.length=be+Me;for(let xe=be-1;xe>=fe;xe--)K[xe+Me]=K[xe];for(let xe=0;xe<Me;xe++)K[xe+fe]=ae[xe]}e.insertInto=x;function N(K,X,ae,fe){const be=B(K,X),Me=K.splice(be,ae);return x(K,be,fe),Me}e.splice=N;function B(K,X){return X<0?Math.max(X+K.length,0):Math.min(X,K.length)}function W(K,X){return(ae,fe)=>X(K(ae),K(fe))}e.compareBy=W;const H=(K,X)=>K-X;e.numberComparator=H;function z(K,X){if(K.length===0)return;let ae=K[0];for(let fe=1;fe<K.length;fe++){const be=K[fe];X(be,ae)>0&&(ae=be)}return ae}e.findMaxBy=z;function J(K,X){if(K.length===0)return;let ae=K[0];for(let fe=1;fe<K.length;fe++){const be=K[fe];X(be,ae)>=0&&(ae=be)}return ae}e.findLastMaxBy=J;function ie(K,X){return z(K,(ae,fe)=>-X(ae,fe))}e.findMinBy=ie;class se{constructor(X){this.items=X,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(X){let ae=this.firstIdx;for(;ae<this.items.length&&X(this.items[ae]);)ae++;const fe=ae===this.firstIdx?null:this.items.slice(this.firstIdx,ae);return this.firstIdx=ae,fe}takeFromEndWhile(X){let ae=this.lastIdx;for(;ae>=0&&X(this.items[ae]);)ae--;const fe=ae===this.lastIdx?null:this.items.slice(ae+1,this.lastIdx+1);return this.lastIdx=ae,fe}peek(){return this.items[this.firstIdx]}dequeue(){const X=this.items[this.firstIdx];return this.firstIdx++,X}takeCount(X){const ae=this.items.slice(this.firstIdx,this.firstIdx+X);return this.firstIdx+=X,ae}}e.ArrayQueue=se}),define(pe[76],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function f(t){const I=this;let _=!1,R;return function(){return _||(_=!0,R=t.apply(I,arguments)),R}}e.once=f}),define(pe[77],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class f{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=f,e.defaultGenerator=new f("id#")}),define(pe[78],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var f;(function(t){function I(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}t.is=I;const _=Object.freeze([]);function R(){return _}t.empty=R;function*k(h){yield h}t.single=k;function y(h){return h||_}t.from=y;function P(h){return!h||h[Symbol.iterator]().next().done===!0}t.isEmpty=P;function L(h){return h[Symbol.iterator]().next().value}t.first=L;function C(h,n){for(const S of h)if(n(S))return!0;return!1}t.some=C;function l(h,n){for(const S of h)if(n(S))return S}t.find=l;function*b(h,n){for(const S of h)n(S)&&(yield S)}t.filter=b;function*p(h,n){let S=0;for(const a of h)yield n(a,S++)}t.map=p;function*g(...h){for(const n of h)for(const S of n)yield S}t.concat=g;function*E(h){for(const n of h)for(const S of n)yield S}t.concatNested=E;function F(h,n,S){let a=S;for(const i of h)a=n(a,i);return a}t.reduce=F;function*D(h,n,S=h.length){for(n<0&&(n+=h.length),S<0?S+=h.length:S>h.length&&(S=h.length);n<S;n++)yield h[n]}t.slice=D;function u(h,n=Number.POSITIVE_INFINITY){const S=[];if(n===0)return[S,h];const a=h[Symbol.iterator]();for(let i=0;i<n;i++){const r=a.next();if(r.done)return[S,t.empty()];S.push(r.value)}return[S,{[Symbol.iterator](){return a}}]}t.consume=u;function s(h,n,S=(a,i)=>a===i){const a=h[Symbol.iterator](),i=n[Symbol.iterator]();for(;;){const r=a.next(),c=i.next();if(r.done!==c.done)return!1;if(r.done)return!0;if(!S(r.value,c.value))return!1}}t.equals=s})(f=e.Iterable||(e.Iterable={}))}),define(pe[57],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var f;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(f=e.ScanError||(e.ScanError={}));var t;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var _;(function(n){n.DEFAULT={allowTrailingComma:!0}})(_=e.ParseOptions||(e.ParseOptions={}));function R(n,S=!1){let a=0,i=n.length,r="",c=0,o=16,d=0;function m(U){let V=0,x=0;for(;V<U;){const N=n.charCodeAt(a);if(N>=48&&N<=57)x=x*16+N-48;else if(N>=65&&N<=70)x=x*16+N-65+10;else if(N>=97&&N<=102)x=x*16+N-97+10;else break;a++,V++}return V<U&&(x=-1),x}function v(U){a=U,r="",c=0,o=16,d=0}function w(){const U=a;if(n.charCodeAt(a)===48)a++;else for(a++;a<n.length&&P(n.charCodeAt(a));)a++;if(a<n.length&&n.charCodeAt(a)===46)if(a++,a<n.length&&P(n.charCodeAt(a)))for(a++;a<n.length&&P(n.charCodeAt(a));)a++;else return d=3,n.substring(U,a);let V=a;if(a<n.length&&(n.charCodeAt(a)===69||n.charCodeAt(a)===101))if(a++,(a<n.length&&n.charCodeAt(a)===43||n.charCodeAt(a)===45)&&a++,a<n.length&&P(n.charCodeAt(a))){for(a++;a<n.length&&P(n.charCodeAt(a));)a++;V=a}else d=3;return n.substring(U,V)}function A(){let U="",V=a;for(;;){if(a>=i){U+=n.substring(V,a),d=2;break}const x=n.charCodeAt(a);if(x===34){U+=n.substring(V,a),a++;break}if(x===92){if(U+=n.substring(V,a),a++,a>=i){d=2;break}switch(n.charCodeAt(a++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const B=m(4);B>=0?U+=String.fromCharCode(B):d=4;break}default:d=5}V=a;continue}if(x>=0&&x<=31)if(y(x)){U+=n.substring(V,a),d=2;break}else d=6;a++}return U}function M(){if(r="",d=0,c=a,a>=i)return c=i,o=17;let U=n.charCodeAt(a);if(k(U)){do a++,r+=String.fromCharCode(U),U=n.charCodeAt(a);while(k(U));return o=15}if(y(U))return a++,r+=String.fromCharCode(U),U===13&&n.charCodeAt(a)===10&&(a++,r+=`
`),o=14;switch(U){case 123:return a++,o=1;case 125:return a++,o=2;case 91:return a++,o=3;case 93:return a++,o=4;case 58:return a++,o=6;case 44:return a++,o=5;case 34:return a++,r=A(),o=10;case 47:{const V=a-1;if(n.charCodeAt(a+1)===47){for(a+=2;a<i&&!y(n.charCodeAt(a));)a++;return r=n.substring(V,a),o=12}if(n.charCodeAt(a+1)===42){a+=2;const x=i-1;let N=!1;for(;a<x;){if(n.charCodeAt(a)===42&&n.charCodeAt(a+1)===47){a+=2,N=!0;break}a++}return N||(a++,d=1),r=n.substring(V,a),o=13}return r+=String.fromCharCode(U),a++,o=16}case 45:if(r+=String.fromCharCode(U),a++,a===i||!P(n.charCodeAt(a)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=w(),o=11;default:for(;a<i&&T(U);)a++,U=n.charCodeAt(a);if(c!==a){switch(r=n.substring(c,a),r){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return r+=String.fromCharCode(U),a++,o=16}}function T(U){if(k(U)||y(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function O(){let U;do U=M();while(U>=12&&U<=15);return U}return{setPosition:v,getPosition:()=>a,scan:S?O:M,getToken:()=>o,getTokenValue:()=>r,getTokenOffset:()=>c,getTokenLength:()=>a-c,getTokenError:()=>d}}e.createScanner=R;function k(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function y(n){return n===10||n===13||n===8232||n===8233}function P(n){return n>=48&&n<=57}var L;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(L||(L={}));function C(n,S){const a=[],i=new Object;let r;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function d(m,v,w,A){c.value=m,c.offset=v,c.length=w,c.type=A,c.colonOffset=void 0,r=c}try{u(n,{onObjectBegin:(m,v)=>{if(S<=m)throw i;r=void 0,o=S>m,a.push("")},onObjectProperty:(m,v,w)=>{if(S<v||(d(m,v,w,"property"),a[a.length-1]=m,S<=v+w))throw i},onObjectEnd:(m,v)=>{if(S<=m)throw i;r=void 0,a.pop()},onArrayBegin:(m,v)=>{if(S<=m)throw i;r=void 0,a.push(0)},onArrayEnd:(m,v)=>{if(S<=m)throw i;r=void 0,a.pop()},onLiteralValue:(m,v,w)=>{if(S<v||(d(m,v,w,h(m)),S<=v+w))throw i},onSeparator:(m,v,w)=>{if(S<=v)throw i;if(m===":"&&r&&r.type==="property")r.colonOffset=v,o=!1,r=void 0;else if(m===","){const A=a[a.length-1];typeof A=="number"?a[a.length-1]=A+1:(o=!0,a[a.length-1]=""),r=void 0}}})}catch(m){if(m!==i)throw m}return{path:a,previousNode:r,isAtPropertyKey:o,matches:m=>{let v=0;for(let w=0;v<m.length&&w<a.length;w++)if(m[v]===a[w]||m[v]==="*")v++;else if(m[v]!=="**")return!1;return v===m.length}}}e.getLocation=C;function l(n,S=[],a=_.DEFAULT){let i=null,r=[];const c=[];function o(m){Array.isArray(r)?r.push(m):i!==null&&(r[i]=m)}return u(n,{onObjectBegin:()=>{const m={};o(m),c.push(r),r=m,i=null},onObjectProperty:m=>{i=m},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{const m=[];o(m),c.push(r),r=m,i=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:o,onError:(m,v,w)=>{S.push({error:m,offset:v,length:w})}},a),r[0]}e.parse=l;function b(n,S=[],a=_.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(m){i.type==="property"&&(i.length=m-i.offset,i=i.parent)}function c(m){return i.children.push(m),m}u(n,{onObjectBegin:m=>{i=c({type:"object",offset:m,length:-1,parent:i,children:[]})},onObjectProperty:(m,v,w)=>{i=c({type:"property",offset:v,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:m,offset:v,length:w,parent:i})},onObjectEnd:(m,v)=>{i.length=m+v-i.offset,i=i.parent,r(m+v)},onArrayBegin:(m,v)=>{i=c({type:"array",offset:m,length:-1,parent:i,children:[]})},onArrayEnd:(m,v)=>{i.length=m+v-i.offset,i=i.parent,r(m+v)},onLiteralValue:(m,v,w)=>{c({type:h(m),offset:v,length:w,parent:i,value:m}),r(v+w)},onSeparator:(m,v,w)=>{i.type==="property"&&(m===":"?i.colonOffset=v:m===","&&r(v))},onError:(m,v,w)=>{S.push({error:m,offset:v,length:w})}},a);const d=i.children[0];return d&&delete d.parent,d}e.parseTree=b;function p(n,S){if(!n)return;let a=n;for(let i of S)if(typeof i=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let r=!1;for(const c of a.children)if(Array.isArray(c.children)&&c.children[0].value===i){a=c.children[1],r=!0;break}if(!r)return}else{const r=i;if(a.type!=="array"||r<0||!Array.isArray(a.children)||r>=a.children.length)return;a=a.children[r]}return a}e.findNodeAtLocation=p;function g(n){if(!n.parent||!n.parent.children)return[];const S=g(n.parent);if(n.parent.type==="property"){const a=n.parent.children[0].value;S.push(a)}else if(n.parent.type==="array"){const a=n.parent.children.indexOf(n);a!==-1&&S.push(a)}return S}e.getNodePath=g;function E(n){switch(n.type){case"array":return n.children.map(E);case"object":{const S=Object.create(null);for(let a of n.children){const i=a.children[1];i&&(S[a.children[0].value]=E(i))}return S}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=E;function F(n,S,a=!1){return S>=n.offset&&S<n.offset+n.length||a&&S===n.offset+n.length}e.contains=F;function D(n,S,a=!1){if(F(n,S,a)){const i=n.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=S;r++){const c=D(i[r],S,a);if(c)return c}return n}}e.findNodeAtOffset=D;function u(n,S,a=_.DEFAULT){const i=R(n,!1);function r(se){return se?()=>se(i.getTokenOffset(),i.getTokenLength()):()=>!0}function c(se){return se?K=>se(K,i.getTokenOffset(),i.getTokenLength()):()=>!0}const o=r(S.onObjectBegin),d=c(S.onObjectProperty),m=r(S.onObjectEnd),v=r(S.onArrayBegin),w=r(S.onArrayEnd),A=c(S.onLiteralValue),M=c(S.onSeparator),T=r(S.onComment),O=c(S.onError),U=a&&a.disallowComments,V=a&&a.allowTrailingComma;function x(){for(;;){const se=i.scan();switch(i.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:U||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(se){case 12:case 13:U?N(10):T();break;case 16:N(1);break;case 15:case 14:break;default:return se}}}function N(se,K=[],X=[]){if(O(se),K.length+X.length>0){let ae=i.getToken();for(;ae!==17;){if(K.indexOf(ae)!==-1){x();break}else if(X.indexOf(ae)!==-1)break;ae=x()}}}function B(se){const K=i.getTokenValue();return se?A(K):d(K),x(),!0}function W(){switch(i.getToken()){case 11:{let se=0;try{se=JSON.parse(i.getTokenValue()),typeof se!="number"&&(N(2),se=0)}catch{N(2)}A(se);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return x(),!0}function H(){return i.getToken()!==10?(N(3,[],[2,5]),!1):(B(!1),i.getToken()===6?(M(":"),x(),ie()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function z(){o(),x();let se=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(se||N(4,[],[]),M(","),x(),i.getToken()===2&&V)break}else se&&N(6,[],[]);H()||N(4,[],[2,5]),se=!0}return m(),i.getToken()!==2?N(7,[2],[]):x(),!0}function J(){v(),x();let se=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(se||N(4,[],[]),M(","),x(),i.getToken()===4&&V)break}else se&&N(6,[],[]);ie()||N(4,[],[4,5]),se=!0}return w(),i.getToken()!==4?N(8,[4],[]):x(),!0}function ie(){switch(i.getToken()){case 3:return J();case 1:return z();case 10:return B(!0);default:return W()}}return x(),i.getToken()===17?a.allowEmptyContent?!0:(N(4,[],[]),!1):ie()?(i.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=u;function s(n,S){let a=R(n),i=[],r,c=0,o;do switch(o=a.getPosition(),r=a.scan(),r){case 12:case 13:case 17:c!==o&&i.push(n.substring(c,o)),S!==void 0&&i.push(a.getTokenValue().replace(/[^\r\n]/g,S)),c=a.getPosition();break}while(r!==17);return i.join("")}e.stripComments=s;function h(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=h}),define(pe[140],ve([0,1,57]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(P,L,C){let l,b,p,g,E;if(L){for(g=L.offset,E=g+L.length,p=g;p>0&&!y(P,p-1);)p--;let o=E;for(;o<P.length&&!y(P,o);)o++;b=P.substring(p,o),l=R(b,C)}else b=P,l=0,p=0,g=0,E=P.length;const F=k(C,P);let D=!1,u=0,s;C.insertSpaces?s=_(" ",C.tabSize||4):s="	";const h=(0,f.createScanner)(b,!1);let n=!1;function S(){return F+_(s,l+u)}function a(){let o=h.scan();for(D=!1;o===15||o===14;)D=D||o===14,o=h.scan();return n=o===16||h.getTokenError()!==0,o}const i=[];function r(o,d,m){!n&&d<E&&m>g&&P.substring(d,m)!==o&&i.push({offset:d,length:m-d,content:o})}let c=a();if(c!==17){const o=h.getTokenOffset()+p,d=_(s,l);r(d,p,o)}for(;c!==17;){let o=h.getTokenOffset()+h.getTokenLength()+p,d=a(),m="";for(;!D&&(d===12||d===13);){const w=h.getTokenOffset()+p;r(" ",o,w),o=h.getTokenOffset()+h.getTokenLength()+p,m=d===12?S():"",d=a()}if(d===2)c!==1&&(u--,m=S());else if(d===4)c!==3&&(u--,m=S());else{switch(c){case 3:case 1:u++,m=S();break;case 5:case 12:m=S();break;case 13:D?m=S():m=" ";break;case 6:m=" ";break;case 10:if(d===6){m="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?m=" ":d!==5&&d!==17&&(n=!0);break;case 16:n=!0;break}D&&(d===12||d===13)&&(m=S())}const v=h.getTokenOffset()+p;r(m,o,v),c=d}return i}e.format=t;function I(P,L){const C=JSON.stringify(P,void 0,L.insertSpaces?L.tabSize||4:"	");return L.eol!==void 0?C.replace(/\r\n|\r|\n/g,L.eol):C}e.toFormattedString=I;function _(P,L){let C="";for(let l=0;l<L;l++)C+=P;return C}function R(P,L){let C=0,l=0;const b=L.tabSize||4;for(;C<P.length;){const p=P.charAt(C);if(p===" ")l++;else if(p==="	")l+=b;else break;C++}return Math.floor(l/b)}function k(P,L){for(let C=0;C<L.length;C++){const l=L.charAt(C);if(l==="\r")return C+1<L.length&&L.charAt(C+1)===`
`?`\r
`:"\r";if(l===`
`)return`
`}return P&&P.eol||`
`}e.getEOL=k;function y(P,L){return`\r
`.indexOf(P.charAt(L))!==-1}e.isEOL=y}),define(pe[141],ve([0,1,57,140]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function I(P,L,C){return _(P,L,void 0,C)}e.removeProperty=I;function _(P,L,C,l,b){const p=L.slice(),g=[],E=(0,f.parseTree)(P,g);let F,D;for(;p.length>0&&(D=p.pop(),F=(0,f.findNodeAtLocation)(E,p),F===void 0&&C!==void 0);)typeof D=="string"?C={[D]:C}:C=[C];if(F)if(F.type==="object"&&typeof D=="string"&&Array.isArray(F.children)){const u=(0,f.findNodeAtLocation)(F,[D]);if(u!==void 0)if(C===void 0){if(!u.parent)throw new Error("Malformed AST");const s=F.children.indexOf(u.parent);let h,n=u.parent.offset+u.parent.length;if(s>0){const S=F.children[s-1];h=S.offset+S.length}else h=F.offset+1,F.children.length>1&&(n=F.children[1].offset);return R(P,{offset:h,length:n-h,content:""},l)}else return R(P,{offset:u.offset,length:u.length,content:JSON.stringify(C)},l);else{if(C===void 0)return[];const s=`${JSON.stringify(D)}: ${JSON.stringify(C)}`,h=b?b(F.children.map(S=>S.children[0].value)):F.children.length;let n;if(h>0){const S=F.children[h-1];n={offset:S.offset+S.length,length:0,content:","+s}}else F.children.length===0?n={offset:F.offset+1,length:0,content:s}:n={offset:F.offset+1,length:0,content:s+","};return R(P,n,l)}}else if(F.type==="array"&&typeof D=="number"&&Array.isArray(F.children))if(C!==void 0){const u=`${JSON.stringify(C)}`;let s;if(F.children.length===0||D===0)s={offset:F.offset+1,length:0,content:F.children.length===0?u:u+","};else{const h=D===-1||D>F.children.length?F.children.length:D,n=F.children[h-1];s={offset:n.offset+n.length,length:0,content:","+u}}return R(P,s,l)}else{const u=D,s=F.children[u];let h;if(F.children.length===1)h={offset:F.offset+1,length:F.length-2,content:""};else if(F.children.length-1===u){const n=F.children[u-1],S=n.offset+n.length,a=F.offset+F.length;h={offset:S,length:a-2-S,content:""}}else h={offset:s.offset,length:F.children[u+1].offset-s.offset,content:""};return R(P,h,l)}else throw new Error(`Can not add ${typeof D!="number"?"index":"property"} to parent of type ${F.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return R(P,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(C)},l)}}e.setProperty=_;function R(P,L,C){let l=k(P,L),b=L.offset,p=L.offset+L.content.length;if(L.length===0||L.content.length===0){for(;b>0&&!(0,t.isEOL)(l,b-1);)b--;for(;p<l.length&&!(0,t.isEOL)(l,p);)p++}const g=(0,t.format)(l,{offset:b,length:p-b},C);for(let F=g.length-1;F>=0;F--){const D=g[F];l=k(l,D),b=Math.min(b,D.offset),p=Math.max(p,D.offset+D.length),p+=D.content.length-D.length}const E=P.length-(l.length-p)-b;return[{offset:b,length:E,content:l.substring(b,p)}]}e.withFormatting=R;function k(P,L){return P.substring(0,L.offset)+L.content+P.substring(L.offset+L.length)}e.applyEdit=k;function y(P,L){let C=L.slice(0).sort((b,p)=>{const g=b.offset-p.offset;return g===0?b.length-p.length:g}),l=P.length;for(let b=C.length-1;b>=0;b--){let p=C[b];if(p.offset+p.length<=l)P=k(P,p);else throw new Error("Overlapping edit");l=p.offset}return P}e.applyEdits=y}),define(pe[92],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class f{constructor(I){this.executor=I,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(I){return new f(()=>I(this.getValue()))}}e.Lazy=f}),define(pe[6],ve([0,1,76,78]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const I=!1;let _=null;function R(i){_=i}if(e.setDisposableTracker=R,I){const i="__is_disposable_tracked__";R(new class{trackDisposable(r){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[i]||console.log(c)},3e3)}setParent(r,c){if(r&&r!==D.None)try{r[i]=!0}catch{}}markAsDisposed(r){if(r&&r!==D.None)try{r[i]=!0}catch{}}markAsSingleton(r){}})}function k(i){return _?.trackDisposable(i),i}function y(i){_?.markAsDisposed(i)}function P(i,r){_?.setParent(i,r)}function L(i,r){if(!!_)for(const c of i)_.setParent(c,r)}function C(i){return _?.markAsSingleton(i),i}e.markAsSingleton=C;class l extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=l;function b(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=b;function p(i){if(t.Iterable.is(i)){let r=[];for(const c of i)if(c)try{c.dispose()}catch(o){r.push(o)}if(r.length===1)throw r[0];if(r.length>1)throw new l(r);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=p;function g(...i){const r=E(()=>p(i));return L(i,r),r}e.combinedDisposable=g;function E(i){const r=k({dispose:(0,f.once)(()=>{y(r),i()})});return r}e.toDisposable=E;class F{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{p(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return P(r,this),this._isDisposed?F.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=F,F.DISABLE_DISPOSED_WARNING=!1;class D{constructor(){this._store=new F,k(this),P(this._store,this)}dispose(){y(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=D,D.None=Object.freeze({dispose(){}});class u{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&P(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&P(r,null),r}}e.MutableDisposable=u;class s{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=s;class h{constructor(){this.references=new Map}acquire(r,...c){let o=this.references.get(r);o||(o={counter:0,object:this.createReferencedObject(r,...c)},this.references.set(r,o));const{object:d}=o,m=(0,f.once)(()=>{--o.counter==0&&(this.destroyReferencedObject(r,o.object),this.references.delete(r))});return o.counter++,{object:d,dispose:m}}}e.ReferenceCollection=h;class n{constructor(r){this.referenceCollection=r}async acquire(r,...c){const o=this.referenceCollection.acquire(r,...c);try{return{object:await o.object,dispose:()=>o.dispose()}}catch(d){throw o.dispose(),d}}}e.AsyncReferenceCollection=n;class S{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=S;function a(i){const r=new F;try{i(r)}finally{r.dispose()}}e.disposeOnReturn=a}),define(pe[93],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class f{constructor(_){this.element=_,this.next=f.Undefined,this.prev=f.Undefined}}f.Undefined=new f(void 0);class t{constructor(){this._first=f.Undefined,this._last=f.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===f.Undefined}clear(){let _=this._first;for(;_!==f.Undefined;){const R=_.next;_.prev=f.Undefined,_.next=f.Undefined,_=R}this._first=f.Undefined,this._last=f.Undefined,this._size=0}unshift(_){return this._insert(_,!1)}push(_){return this._insert(_,!0)}_insert(_,R){const k=new f(_);if(this._first===f.Undefined)this._first=k,this._last=k;else if(R){const P=this._last;this._last=k,k.prev=P,P.next=k}else{const P=this._first;this._first=k,k.next=P,P.prev=k}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(k))}}shift(){if(this._first!==f.Undefined){const _=this._first.element;return this._remove(this._first),_}}pop(){if(this._last!==f.Undefined){const _=this._last.element;return this._remove(this._last),_}}_remove(_){if(_.prev!==f.Undefined&&_.next!==f.Undefined){const R=_.prev;R.next=_.next,_.next.prev=R}else _.prev===f.Undefined&&_.next===f.Undefined?(this._first=f.Undefined,this._last=f.Undefined):_.next===f.Undefined?(this._last=this._last.prev,this._last.next=f.Undefined):_.prev===f.Undefined&&(this._first=this._first.next,this._first.prev=f.Undefined);this._size-=1}*[Symbol.iterator](){let _=this._first;for(;_!==f.Undefined;)yield _.element,_=_.next}}e.LinkedList=t}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,Z.marked=e())}(this,function(){"use strict";function Z(Re,Ae){for(var De=0;De<Ae.length;De++){var ce=Ae[De];ce.enumerable=ce.enumerable||!1,ce.configurable=!0,"value"in ce&&(ce.writable=!0),Object.defineProperty(Re,ce.key,ce)}}function e(Re,Ae,De){return Ae&&Z(Re.prototype,Ae),De&&Z(Re,De),Re}function f(Re,Ae){if(!!Re){if(typeof Re=="string")return t(Re,Ae);var De=Object.prototype.toString.call(Re).slice(8,-1);if(De==="Object"&&Re.constructor&&(De=Re.constructor.name),De==="Map"||De==="Set")return Array.from(Re);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return t(Re,Ae)}}function t(Re,Ae){(Ae==null||Ae>Re.length)&&(Ae=Re.length);for(var De=0,ce=new Array(Ae);De<Ae;De++)ce[De]=Re[De];return ce}function I(Re,Ae){var De=typeof Symbol!="undefined"&&Re[Symbol.iterator]||Re["@@iterator"];if(De)return(De=De.call(Re)).next.bind(De);if(Array.isArray(Re)||(De=f(Re))||Ae&&Re&&typeof Re.length=="number"){De&&(Re=De);var ce=0;return function(){return ce>=Re.length?{done:!0}:{done:!1,value:Re[ce++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var _={exports:{}};function R(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function k(Re){_.exports.defaults=Re}_.exports={defaults:R(),getDefaults:R,changeDefaults:k};var y=/[&<>"']/,P=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(Ae){return l[Ae]};function p(Re,Ae){if(Ae){if(y.test(Re))return Re.replace(P,b)}else if(L.test(Re))return Re.replace(C,b);return Re}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function E(Re){return Re.replace(g,function(Ae,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var F=/(^|[^\[])\^/g;function D(Re,Ae){Re=Re.source||Re,Ae=Ae||"";var De={replace:function(de,we){return we=we.source||we,we=we.replace(F,"$1"),Re=Re.replace(de,we),De},getRegex:function(){return new RegExp(Re,Ae)}};return De}var u=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Re,Ae,De){if(Re){var ce;try{ce=decodeURIComponent(E(De)).replace(u,"").toLowerCase()}catch{return null}if(ce.indexOf("javascript:")===0||ce.indexOf("vbscript:")===0||ce.indexOf("data:")===0)return null}Ae&&!s.test(De)&&(De=r(Ae,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var n={},S=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(Re,Ae){n[" "+Re]||(S.test(Re)?n[" "+Re]=Re+"/":n[" "+Re]=m(Re,"/",!0)),Re=n[" "+Re];var De=Re.indexOf(":")===-1;return Ae.substring(0,2)==="//"?De?Ae:Re.replace(a,"$1")+Ae:Ae.charAt(0)==="/"?De?Ae:Re.replace(i,"$1")+Ae:Re+Ae}var c={exec:function(){}};function o(Re){for(var Ae=1,De,ce;Ae<arguments.length;Ae++){De=arguments[Ae];for(ce in De)Object.prototype.hasOwnProperty.call(De,ce)&&(Re[ce]=De[ce])}return Re}function d(Re,Ae){var De=Re.replace(/\|/g,function(we,Ce,Oe){for(var Ke=!1,$e=Ce;--$e>=0&&Oe[$e]==="\\";)Ke=!Ke;return Ke?"|":" |"}),ce=De.split(/ \|/),de=0;if(ce[0].trim()||ce.shift(),ce[ce.length-1].trim()||ce.pop(),ce.length>Ae)ce.splice(Ae);else for(;ce.length<Ae;)ce.push("");for(;de<ce.length;de++)ce[de]=ce[de].trim().replace(/\\\|/g,"|");return ce}function m(Re,Ae,De){var ce=Re.length;if(ce===0)return"";for(var de=0;de<ce;){var we=Re.charAt(ce-de-1);if(we===Ae&&!De)de++;else if(we!==Ae&&De)de++;else break}return Re.substr(0,ce-de)}function v(Re,Ae){if(Re.indexOf(Ae[1])===-1)return-1;for(var De=Re.length,ce=0,de=0;de<De;de++)if(Re[de]==="\\")de++;else if(Re[de]===Ae[0])ce++;else if(Re[de]===Ae[1]&&(ce--,ce<0))return de;return-1}function w(Re){Re&&Re.sanitize&&!Re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(Re,Ae){if(Ae<1)return"";for(var De="";Ae>1;)Ae&1&&(De+=Re),Ae>>=1,Re+=Re;return De+Re}var M={escape:p,unescape:E,edit:D,cleanUrl:h,resolveUrl:r,noopTest:c,merge:o,splitCells:d,rtrim:m,findClosingBracket:v,checkSanitizeDeprecation:w,repeatString:A},T=_.exports.defaults,O=M.rtrim,U=M.splitCells,V=M.escape,x=M.findClosingBracket;function N(Re,Ae,De,ce){var de=Ae.href,we=Ae.title?V(Ae.title):null,Ce=Re[1].replace(/\\([\[\]])/g,"$1");if(Re[0].charAt(0)!=="!"){ce.state.inLink=!0;var Oe={type:"link",raw:De,href:de,title:we,text:Ce,tokens:ce.inlineTokens(Ce,[])};return ce.state.inLink=!1,Oe}else return{type:"image",raw:De,href:de,title:we,text:V(Ce)}}function B(Re,Ae){var De=Re.match(/^(\s+)(?:```)/);if(De===null)return Ae;var ce=De[1];return Ae.split(`
`).map(function(de){var we=de.match(/^\s+/);if(we===null)return de;var Ce=we[0];return Ce.length>=ce.length?de.slice(ce.length):de}).join(`
`)}var W=function(){function Re(De){this.options=De||T}var Ae=Re.prototype;return Ae.space=function(ce){var de=this.rules.block.newline.exec(ce);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},Ae.code=function(ce){var de=this.rules.block.code.exec(ce);if(de){var we=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?we:O(we,`
`)}}},Ae.fences=function(ce){var de=this.rules.block.fences.exec(ce);if(de){var we=de[0],Ce=B(we,de[3]||"");return{type:"code",raw:we,lang:de[2]?de[2].trim():de[2],text:Ce}}},Ae.heading=function(ce){var de=this.rules.block.heading.exec(ce);if(de){var we=de[2].trim();if(/#$/.test(we)){var Ce=O(we,"#");(this.options.pedantic||!Ce||/ $/.test(Ce))&&(we=Ce.trim())}var Oe={type:"heading",raw:de[0],depth:de[1].length,text:we,tokens:[]};return this.lexer.inline(Oe.text,Oe.tokens),Oe}},Ae.hr=function(ce){var de=this.rules.block.hr.exec(ce);if(de)return{type:"hr",raw:de[0]}},Ae.blockquote=function(ce){var de=this.rules.block.blockquote.exec(ce);if(de){var we=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(we,[]),text:we}}},Ae.list=function(ce){var de=this.rules.block.list.exec(ce);if(de){var we,Ce,Oe,Ke,$e,Ze,lt,ct,He,Ee,_e=de[1].trim(),he=_e.length>1,Y={type:"list",raw:"",ordered:he,start:he?+_e.slice(0,-1):"",loose:!1,items:[]};_e=he?"\\d{1,9}\\"+_e.slice(-1):"\\"+_e,this.options.pedantic&&(_e=he?_e:"[*+-]");for(var ke=new RegExp("^( {0,3}"+_e+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ce&&!(this.rules.block.hr.test(ce)||!(de=ke.exec(ce)));){He=de[2].split(`
`),this.options.pedantic?(Ke=2,Ee=He[0].trimLeft()):(Ke=de[2].search(/[^ ]/),Ke=de[1].length+(Ke>4?1:Ke),Ee=He[0].slice(Ke-de[1].length)),Ze=!1,we=de[0],!He[0]&&/^ *$/.test(He[1])&&(we=de[1]+He.slice(0,2).join(`
`)+`
`,Y.loose=!0,He=[]);var Ne=new RegExp("^ {0,"+Math.min(3,Ke-1)+"}(?:[*+-]|\\d{1,9}[.)])");for($e=1;$e<He.length;$e++){if(ct=He[$e],this.options.pedantic&&(ct=ct.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Ne.test(ct)){we=de[1]+He.slice(0,$e).join(`
`)+`
`;break}if(!Ze){ct.trim()||(Ze=!0),ct.search(/[^ ]/)>=Ke?Ee+=`
`+ct.slice(Ke):Ee+=`
`+ct;continue}if(ct.search(/[^ ]/)>=Ke||!ct.trim()){Ee+=`
`+ct.slice(Ke);continue}else{we=de[1]+He.slice(0,$e).join(`
`)+`
`;break}}Y.loose||(lt?Y.loose=!0:/\n *\n *$/.test(we)&&(lt=!0)),this.options.gfm&&(Ce=/^\[[ xX]\] /.exec(Ee),Ce&&(Oe=Ce[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),Y.items.push({type:"list_item",raw:we,task:!!Ce,checked:Oe,loose:!1,text:Ee}),Y.raw+=we,ce=ce.slice(we.length)}Y.items[Y.items.length-1].raw=we.trimRight(),Y.items[Y.items.length-1].text=Ee.trimRight(),Y.raw=Y.raw.trimRight();var Xe=Y.items.length;for($e=0;$e<Xe;$e++)this.lexer.state.top=!1,Y.items[$e].tokens=this.lexer.blockTokens(Y.items[$e].text,[]),Y.items[$e].tokens.some(function(Qe){return Qe.type==="space"})&&(Y.loose=!0,Y.items[$e].loose=!0);return Y}},Ae.html=function(ce){var de=this.rules.block.html.exec(ce);if(de){var we={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};return this.options.sanitize&&(we.type="paragraph",we.text=this.options.sanitizer?this.options.sanitizer(de[0]):V(de[0]),we.tokens=[],this.lexer.inline(we.text,we.tokens)),we}},Ae.def=function(ce){var de=this.rules.block.def.exec(ce);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var we=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:we,raw:de[0],href:de[2],title:de[3]}}},Ae.table=function(ce){var de=this.rules.block.table.exec(ce);if(de){var we={type:"table",header:U(de[1]).map(function(lt){return{text:lt}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(we.header.length===we.align.length){we.raw=de[0];var Ce=we.align.length,Oe,Ke,$e,Ze;for(Oe=0;Oe<Ce;Oe++)/^ *-+: *$/.test(we.align[Oe])?we.align[Oe]="right":/^ *:-+: *$/.test(we.align[Oe])?we.align[Oe]="center":/^ *:-+ *$/.test(we.align[Oe])?we.align[Oe]="left":we.align[Oe]=null;for(Ce=we.rows.length,Oe=0;Oe<Ce;Oe++)we.rows[Oe]=U(we.rows[Oe],we.header.length).map(function(lt){return{text:lt}});for(Ce=we.header.length,Ke=0;Ke<Ce;Ke++)we.header[Ke].tokens=[],this.lexer.inlineTokens(we.header[Ke].text,we.header[Ke].tokens);for(Ce=we.rows.length,Ke=0;Ke<Ce;Ke++)for(Ze=we.rows[Ke],$e=0;$e<Ze.length;$e++)Ze[$e].tokens=[],this.lexer.inlineTokens(Ze[$e].text,Ze[$e].tokens);return we}}},Ae.lheading=function(ce){var de=this.rules.block.lheading.exec(ce);if(de){var we={type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},Ae.paragraph=function(ce){var de=this.rules.block.paragraph.exec(ce);if(de){var we={type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},Ae.text=function(ce){var de=this.rules.block.text.exec(ce);if(de){var we={type:"text",raw:de[0],text:de[0],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},Ae.escape=function(ce){var de=this.rules.inline.escape.exec(ce);if(de)return{type:"escape",raw:de[0],text:V(de[1])}},Ae.tag=function(ce){var de=this.rules.inline.tag.exec(ce);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):V(de[0]):de[0]}},Ae.link=function(ce){var de=this.rules.inline.link.exec(ce);if(de){var we=de[2].trim();if(!this.options.pedantic&&/^</.test(we)){if(!/>$/.test(we))return;var Ce=O(we.slice(0,-1),"\\");if((we.length-Ce.length)%2==0)return}else{var Oe=x(de[2],"()");if(Oe>-1){var Ke=de[0].indexOf("!")===0?5:4,$e=Ke+de[1].length+Oe;de[2]=de[2].substring(0,Oe),de[0]=de[0].substring(0,$e).trim(),de[3]=""}}var Ze=de[2],lt="";if(this.options.pedantic){var ct=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ze);ct&&(Ze=ct[1],lt=ct[3])}else lt=de[3]?de[3].slice(1,-1):"";return Ze=Ze.trim(),/^</.test(Ze)&&(this.options.pedantic&&!/>$/.test(we)?Ze=Ze.slice(1):Ze=Ze.slice(1,-1)),N(de,{href:Ze&&Ze.replace(this.rules.inline._escapes,"$1"),title:lt&&lt.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},Ae.reflink=function(ce,de){var we;if((we=this.rules.inline.reflink.exec(ce))||(we=this.rules.inline.nolink.exec(ce))){var Ce=(we[2]||we[1]).replace(/\s+/g," ");if(Ce=de[Ce.toLowerCase()],!Ce||!Ce.href){var Oe=we[0].charAt(0);return{type:"text",raw:Oe,text:Oe}}return N(we,Ce,we[0],this.lexer)}},Ae.emStrong=function(ce,de,we){we===void 0&&(we="");var Ce=this.rules.inline.emStrong.lDelim.exec(ce);if(!!Ce&&!(Ce[3]&&we.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Oe=Ce[1]||Ce[2]||"";if(!Oe||Oe&&(we===""||this.rules.inline.punctuation.exec(we))){var Ke=Ce[0].length-1,$e,Ze,lt=Ke,ct=0,He=Ce[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(He.lastIndex=0,de=de.slice(-1*ce.length+Ke);(Ce=He.exec(de))!=null;)if($e=Ce[1]||Ce[2]||Ce[3]||Ce[4]||Ce[5]||Ce[6],!!$e){if(Ze=$e.length,Ce[3]||Ce[4]){lt+=Ze;continue}else if((Ce[5]||Ce[6])&&Ke%3&&!((Ke+Ze)%3)){ct+=Ze;continue}if(lt-=Ze,!(lt>0)){if(Ze=Math.min(Ze,Ze+lt+ct),Math.min(Ke,Ze)%2){var Ee=ce.slice(1,Ke+Ce.index+Ze);return{type:"em",raw:ce.slice(0,Ke+Ce.index+Ze+1),text:Ee,tokens:this.lexer.inlineTokens(Ee,[])}}var _e=ce.slice(2,Ke+Ce.index+Ze-1);return{type:"strong",raw:ce.slice(0,Ke+Ce.index+Ze+1),text:_e,tokens:this.lexer.inlineTokens(_e,[])}}}}}},Ae.codespan=function(ce){var de=this.rules.inline.code.exec(ce);if(de){var we=de[2].replace(/\n/g," "),Ce=/[^ ]/.test(we),Oe=/^ /.test(we)&&/ $/.test(we);return Ce&&Oe&&(we=we.substring(1,we.length-1)),we=V(we,!0),{type:"codespan",raw:de[0],text:we}}},Ae.br=function(ce){var de=this.rules.inline.br.exec(ce);if(de)return{type:"br",raw:de[0]}},Ae.del=function(ce){var de=this.rules.inline.del.exec(ce);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2],[])}},Ae.autolink=function(ce,de){var we=this.rules.inline.autolink.exec(ce);if(we){var Ce,Oe;return we[2]==="@"?(Ce=V(this.options.mangle?de(we[1]):we[1]),Oe="mailto:"+Ce):(Ce=V(we[1]),Oe=Ce),{type:"link",raw:we[0],text:Ce,href:Oe,tokens:[{type:"text",raw:Ce,text:Ce}]}}},Ae.url=function(ce,de){var we;if(we=this.rules.inline.url.exec(ce)){var Ce,Oe;if(we[2]==="@")Ce=V(this.options.mangle?de(we[0]):we[0]),Oe="mailto:"+Ce;else{var Ke;do Ke=we[0],we[0]=this.rules.inline._backpedal.exec(we[0])[0];while(Ke!==we[0]);Ce=V(we[0]),we[1]==="www."?Oe="http://"+Ce:Oe=Ce}return{type:"link",raw:we[0],text:Ce,href:Oe,tokens:[{type:"text",raw:Ce,text:Ce}]}}},Ae.inlineText=function(ce,de){var we=this.rules.inline.text.exec(ce);if(we){var Ce;return this.lexer.state.inRawBlock?Ce=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(we[0]):V(we[0]):we[0]:Ce=V(this.options.smartypants?de(we[0]):we[0]),{type:"text",raw:we[0],text:Ce}}},Re}(),H=M.noopTest,z=M.edit,J=M.merge,ie={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:H,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};ie._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,ie._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ie.def=z(ie.def).replace("label",ie._label).replace("title",ie._title).getRegex(),ie.bullet=/(?:[*+-]|\d{1,9}[.)])/,ie.listItemStart=z(/^( *)(bull) */).replace("bull",ie.bullet).getRegex(),ie.list=z(ie.list).replace(/bull/g,ie.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ie.def.source+")").getRegex(),ie._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ie._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ie.html=z(ie.html,"i").replace("comment",ie._comment).replace("tag",ie._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ie.paragraph=z(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.blockquote=z(ie.blockquote).replace("paragraph",ie.paragraph).getRegex(),ie.normal=J({},ie),ie.gfm=J({},ie.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ie.gfm.table=z(ie.gfm.table).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.pedantic=J({},ie.normal,{html:z(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ie._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:H,paragraph:z(ie.normal._paragraph).replace("hr",ie.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ie.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var se={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:H,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:H,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};se._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",se.punctuation=z(se.punctuation).replace(/punctuation/g,se._punctuation).getRegex(),se.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,se.escapedEmSt=/\\\*|\\_/g,se._comment=z(ie._comment).replace("(?:-->|$)","-->").getRegex(),se.emStrong.lDelim=z(se.emStrong.lDelim).replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimAst=z(se.emStrong.rDelimAst,"g").replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimUnd=z(se.emStrong.rDelimUnd,"g").replace(/punct/g,se._punctuation).getRegex(),se._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,se._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,se._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,se.autolink=z(se.autolink).replace("scheme",se._scheme).replace("email",se._email).getRegex(),se._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,se.tag=z(se.tag).replace("comment",se._comment).replace("attribute",se._attribute).getRegex(),se._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,se._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,se._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,se.link=z(se.link).replace("label",se._label).replace("href",se._href).replace("title",se._title).getRegex(),se.reflink=z(se.reflink).replace("label",se._label).getRegex(),se.reflinkSearch=z(se.reflinkSearch,"g").replace("reflink",se.reflink).replace("nolink",se.nolink).getRegex(),se.normal=J({},se),se.pedantic=J({},se.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:z(/^!?\[(label)\]\((.*?)\)/).replace("label",se._label).getRegex(),reflink:z(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",se._label).getRegex()}),se.gfm=J({},se.normal,{escape:z(se.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),se.gfm.url=z(se.gfm.url,"i").replace("email",se.gfm._extended_email).getRegex(),se.breaks=J({},se.gfm,{br:z(se.br).replace("{2,}","*").getRegex(),text:z(se.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var K={block:ie,inline:se},X=W,ae=_.exports.defaults,fe=K.block,be=K.inline,Me=M.repeatString;function xe(Re){return Re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ge(Re){var Ae="",De,ce,de=Re.length;for(De=0;De<de;De++)ce=Re.charCodeAt(De),Math.random()>.5&&(ce="x"+ce.toString(16)),Ae+="&#"+ce+";";return Ae}var Je=function(){function Re(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||ae,this.options.tokenizer=this.options.tokenizer||new X,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ce={block:fe.normal,inline:be.normal};this.options.pedantic?(ce.block=fe.pedantic,ce.inline=be.pedantic):this.options.gfm&&(ce.block=fe.gfm,this.options.breaks?ce.inline=be.breaks:ce.inline=be.gfm),this.tokenizer.rules=ce}Re.lex=function(ce,de){var we=new Re(de);return we.lex(ce)},Re.lexInline=function(ce,de){var we=new Re(de);return we.inlineTokens(ce)};var Ae=Re.prototype;return Ae.lex=function(ce){ce=ce.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ce,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},Ae.blockTokens=function(ce,de){var we=this;de===void 0&&(de=[]),this.options.pedantic&&(ce=ce.replace(/^ +$/gm,""));for(var Ce,Oe,Ke,$e;ce;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(lt){return(Ce=lt.call({lexer:we},ce,de))?(ce=ce.substring(Ce.raw.length),de.push(Ce),!0):!1}))){if(Ce=this.tokenizer.space(ce)){ce=ce.substring(Ce.raw.length),Ce.type&&de.push(Ce);continue}if(Ce=this.tokenizer.code(ce)){ce=ce.substring(Ce.raw.length),Oe=de[de.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+Ce.raw,Oe.text+=`
`+Ce.text,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):de.push(Ce);continue}if(Ce=this.tokenizer.fences(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.heading(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.hr(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.blockquote(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.list(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.html(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.def(ce)){ce=ce.substring(Ce.raw.length),Oe=de[de.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+Ce.raw,Oe.text+=`
`+Ce.raw,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):this.tokens.links[Ce.tag]||(this.tokens.links[Ce.tag]={href:Ce.href,title:Ce.title});continue}if(Ce=this.tokenizer.table(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.lheading(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ke=ce,this.options.extensions&&this.options.extensions.startBlock&&function(){var lt=1/0,ct=ce.slice(1),He=void 0;we.options.extensions.startBlock.forEach(function(Ee){He=Ee.call({lexer:this},ct),typeof He=="number"&&He>=0&&(lt=Math.min(lt,He))}),lt<1/0&&lt>=0&&(Ke=ce.substring(0,lt+1))}(),this.state.top&&(Ce=this.tokenizer.paragraph(Ke))){Oe=de[de.length-1],$e&&Oe.type==="paragraph"?(Oe.raw+=`
`+Ce.raw,Oe.text+=`
`+Ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):de.push(Ce),$e=Ke.length!==ce.length,ce=ce.substring(Ce.raw.length);continue}if(Ce=this.tokenizer.text(ce)){ce=ce.substring(Ce.raw.length),Oe=de[de.length-1],Oe&&Oe.type==="text"?(Oe.raw+=`
`+Ce.raw,Oe.text+=`
`+Ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):de.push(Ce);continue}if(ce){var Ze="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(Ze);break}else throw new Error(Ze)}}return this.state.top=!0,de},Ae.inline=function(ce,de){this.inlineQueue.push({src:ce,tokens:de})},Ae.inlineTokens=function(ce,de){var we=this;de===void 0&&(de=[]);var Ce,Oe,Ke,$e=ce,Ze,lt,ct;if(this.tokens.links){var He=Object.keys(this.tokens.links);if(He.length>0)for(;(Ze=this.tokenizer.rules.inline.reflinkSearch.exec($e))!=null;)He.includes(Ze[0].slice(Ze[0].lastIndexOf("[")+1,-1))&&($e=$e.slice(0,Ze.index)+"["+Me("a",Ze[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ze=this.tokenizer.rules.inline.blockSkip.exec($e))!=null;)$e=$e.slice(0,Ze.index)+"["+Me("a",Ze[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ze=this.tokenizer.rules.inline.escapedEmSt.exec($e))!=null;)$e=$e.slice(0,Ze.index)+"++"+$e.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ce;)if(lt||(ct=""),lt=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(_e){return(Ce=_e.call({lexer:we},ce,de))?(ce=ce.substring(Ce.raw.length),de.push(Ce),!0):!1}))){if(Ce=this.tokenizer.escape(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.tag(ce)){ce=ce.substring(Ce.raw.length),Oe=de[de.length-1],Oe&&Ce.type==="text"&&Oe.type==="text"?(Oe.raw+=Ce.raw,Oe.text+=Ce.text):de.push(Ce);continue}if(Ce=this.tokenizer.link(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.reflink(ce,this.tokens.links)){ce=ce.substring(Ce.raw.length),Oe=de[de.length-1],Oe&&Ce.type==="text"&&Oe.type==="text"?(Oe.raw+=Ce.raw,Oe.text+=Ce.text):de.push(Ce);continue}if(Ce=this.tokenizer.emStrong(ce,$e,ct)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.codespan(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.br(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.del(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.autolink(ce,Ge)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(!this.state.inLink&&(Ce=this.tokenizer.url(ce,Ge))){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ke=ce,this.options.extensions&&this.options.extensions.startInline&&function(){var _e=1/0,he=ce.slice(1),Y=void 0;we.options.extensions.startInline.forEach(function(ke){Y=ke.call({lexer:this},he),typeof Y=="number"&&Y>=0&&(_e=Math.min(_e,Y))}),_e<1/0&&_e>=0&&(Ke=ce.substring(0,_e+1))}(),Ce=this.tokenizer.inlineText(Ke,xe)){ce=ce.substring(Ce.raw.length),Ce.raw.slice(-1)!=="_"&&(ct=Ce.raw.slice(-1)),lt=!0,Oe=de[de.length-1],Oe&&Oe.type==="text"?(Oe.raw+=Ce.raw,Oe.text+=Ce.text):de.push(Ce);continue}if(ce){var Ee="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(Ee);break}else throw new Error(Ee)}}return de},e(Re,null,[{key:"rules",get:function(){return{block:fe,inline:be}}}]),Re}(),q=_.exports.defaults,te=M.cleanUrl,G=M.escape,Q=function(){function Re(De){this.options=De||q}var Ae=Re.prototype;return Ae.code=function(ce,de,we){var Ce=(de||"").match(/\S*/)[0];if(this.options.highlight){var Oe=this.options.highlight(ce,Ce);Oe!=null&&Oe!==ce&&(we=!0,ce=Oe)}return ce=ce.replace(/\n$/,"")+`
`,Ce?'<pre><code class="'+this.options.langPrefix+G(Ce,!0)+'">'+(we?ce:G(ce,!0))+`</code></pre>
`:"<pre><code>"+(we?ce:G(ce,!0))+`</code></pre>
`},Ae.blockquote=function(ce){return`<blockquote>
`+ce+`</blockquote>
`},Ae.html=function(ce){return ce},Ae.heading=function(ce,de,we,Ce){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+Ce.slug(we)+'">'+ce+"</h"+de+`>
`:"<h"+de+">"+ce+"</h"+de+`>
`},Ae.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ae.list=function(ce,de,we){var Ce=de?"ol":"ul",Oe=de&&we!==1?' start="'+we+'"':"";return"<"+Ce+Oe+`>
`+ce+"</"+Ce+`>
`},Ae.listitem=function(ce){return"<li>"+ce+`</li>
`},Ae.checkbox=function(ce){return"<input "+(ce?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ae.paragraph=function(ce){return"<p>"+ce+`</p>
`},Ae.table=function(ce,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ce+`</thead>
`+de+`</table>
`},Ae.tablerow=function(ce){return`<tr>
`+ce+`</tr>
`},Ae.tablecell=function(ce,de){var we=de.header?"th":"td",Ce=de.align?"<"+we+' align="'+de.align+'">':"<"+we+">";return Ce+ce+"</"+we+`>
`},Ae.strong=function(ce){return"<strong>"+ce+"</strong>"},Ae.em=function(ce){return"<em>"+ce+"</em>"},Ae.codespan=function(ce){return"<code>"+ce+"</code>"},Ae.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ae.del=function(ce){return"<del>"+ce+"</del>"},Ae.link=function(ce,de,we){if(ce=te(this.options.sanitize,this.options.baseUrl,ce),ce===null)return we;var Ce='<a href="'+G(ce)+'"';return de&&(Ce+=' title="'+de+'"'),Ce+=">"+we+"</a>",Ce},Ae.image=function(ce,de,we){if(ce=te(this.options.sanitize,this.options.baseUrl,ce),ce===null)return we;var Ce='<img src="'+ce+'" alt="'+we+'"';return de&&(Ce+=' title="'+de+'"'),Ce+=this.options.xhtml?"/>":">",Ce},Ae.text=function(ce){return ce},Re}(),oe=function(){function Re(){}var Ae=Re.prototype;return Ae.strong=function(ce){return ce},Ae.em=function(ce){return ce},Ae.codespan=function(ce){return ce},Ae.del=function(ce){return ce},Ae.html=function(ce){return ce},Ae.text=function(ce){return ce},Ae.link=function(ce,de,we){return""+we},Ae.image=function(ce,de,we){return""+we},Ae.br=function(){return""},Re}(),me=function(){function Re(){this.seen={}}var Ae=Re.prototype;return Ae.serialize=function(ce){return ce.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ae.getNextSafeSlug=function(ce,de){var we=ce,Ce=0;if(this.seen.hasOwnProperty(we)){Ce=this.seen[ce];do Ce++,we=ce+"-"+Ce;while(this.seen.hasOwnProperty(we))}return de||(this.seen[ce]=Ce,this.seen[we]=0),we},Ae.slug=function(ce,de){de===void 0&&(de={});var we=this.serialize(ce);return this.getNextSafeSlug(we,de.dryrun)},Re}(),Ie=Q,We=oe,Ye=me,it=_.exports.defaults,st=M.unescape,ot=function(){function Re(De){this.options=De||it,this.options.renderer=this.options.renderer||new Ie,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new We,this.slugger=new Ye}Re.parse=function(ce,de){var we=new Re(de);return we.parse(ce)},Re.parseInline=function(ce,de){var we=new Re(de);return we.parseInline(ce)};var Ae=Re.prototype;return Ae.parse=function(ce,de){de===void 0&&(de=!0);var we="",Ce,Oe,Ke,$e,Ze,lt,ct,He,Ee,_e,he,Y,ke,Ne,Xe,Qe,pt,St,yt,ft=ce.length;for(Ce=0;Ce<ft;Ce++){if(_e=ce[Ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[_e.type]&&(yt=this.options.extensions.renderers[_e.type].call({parser:this},_e),yt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(_e.type))){we+=yt||"";continue}switch(_e.type){case"space":continue;case"hr":{we+=this.renderer.hr();continue}case"heading":{we+=this.renderer.heading(this.parseInline(_e.tokens),_e.depth,st(this.parseInline(_e.tokens,this.textRenderer)),this.slugger);continue}case"code":{we+=this.renderer.code(_e.text,_e.lang,_e.escaped);continue}case"table":{for(He="",ct="",$e=_e.header.length,Oe=0;Oe<$e;Oe++)ct+=this.renderer.tablecell(this.parseInline(_e.header[Oe].tokens),{header:!0,align:_e.align[Oe]});for(He+=this.renderer.tablerow(ct),Ee="",$e=_e.rows.length,Oe=0;Oe<$e;Oe++){for(lt=_e.rows[Oe],ct="",Ze=lt.length,Ke=0;Ke<Ze;Ke++)ct+=this.renderer.tablecell(this.parseInline(lt[Ke].tokens),{header:!1,align:_e.align[Ke]});Ee+=this.renderer.tablerow(ct)}we+=this.renderer.table(He,Ee);continue}case"blockquote":{Ee=this.parse(_e.tokens),we+=this.renderer.blockquote(Ee);continue}case"list":{for(he=_e.ordered,Y=_e.start,ke=_e.loose,$e=_e.items.length,Ee="",Oe=0;Oe<$e;Oe++)Xe=_e.items[Oe],Qe=Xe.checked,pt=Xe.task,Ne="",Xe.task&&(St=this.renderer.checkbox(Qe),ke?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=St+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=St+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:St}):Ne+=St),Ne+=this.parse(Xe.tokens,ke),Ee+=this.renderer.listitem(Ne,pt,Qe);we+=this.renderer.list(Ee,he,Y);continue}case"html":{we+=this.renderer.html(_e.text);continue}case"paragraph":{we+=this.renderer.paragraph(this.parseInline(_e.tokens));continue}case"text":{for(Ee=_e.tokens?this.parseInline(_e.tokens):_e.text;Ce+1<ft&&ce[Ce+1].type==="text";)_e=ce[++Ce],Ee+=`
`+(_e.tokens?this.parseInline(_e.tokens):_e.text);we+=de?this.renderer.paragraph(Ee):Ee;continue}default:{var wt='Token with "'+_e.type+'" type was not found.';if(this.options.silent){console.error(wt);return}else throw new Error(wt)}}}return we},Ae.parseInline=function(ce,de){de=de||this.renderer;var we="",Ce,Oe,Ke,$e=ce.length;for(Ce=0;Ce<$e;Ce++){if(Oe=ce[Ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Oe.type]&&(Ke=this.options.extensions.renderers[Oe.type].call({parser:this},Oe),Ke!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Oe.type))){we+=Ke||"";continue}switch(Oe.type){case"escape":{we+=de.text(Oe.text);break}case"html":{we+=de.html(Oe.text);break}case"link":{we+=de.link(Oe.href,Oe.title,this.parseInline(Oe.tokens,de));break}case"image":{we+=de.image(Oe.href,Oe.title,Oe.text);break}case"strong":{we+=de.strong(this.parseInline(Oe.tokens,de));break}case"em":{we+=de.em(this.parseInline(Oe.tokens,de));break}case"codespan":{we+=de.codespan(Oe.text);break}case"br":{we+=de.br();break}case"del":{we+=de.del(this.parseInline(Oe.tokens,de));break}case"text":{we+=de.text(Oe.text);break}default:{var Ze='Token with "'+Oe.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}}return we},Re}(),tt=Je,rt=ot,gt=W,Ue=Q,It=oe,ee=me,ne=M.merge,Se=M.checkSanitizeDeprecation,re=M.escape,ye=_.exports.getDefaults,Fe=_.exports.changeDefaults,qe=_.exports.defaults;function Ve(Re,Ae,De){if(typeof Re=="undefined"||Re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");if(typeof Ae=="function"&&(De=Ae,Ae=null),Ae=ne({},Ve.defaults,Ae||{}),Se(Ae),De){var ce=Ae.highlight,de;try{de=tt.lex(Re,Ae)}catch(Ke){return De(Ke)}var we=function($e){var Ze;if(!$e)try{Ae.walkTokens&&Ve.walkTokens(de,Ae.walkTokens),Ze=rt.parse(de,Ae)}catch(lt){$e=lt}return Ae.highlight=ce,$e?De($e):De(null,Ze)};if(!ce||ce.length<3||(delete Ae.highlight,!de.length))return we();var Ce=0;Ve.walkTokens(de,function(Ke){Ke.type==="code"&&(Ce++,setTimeout(function(){ce(Ke.text,Ke.lang,function($e,Ze){if($e)return we($e);Ze!=null&&Ze!==Ke.text&&(Ke.text=Ze,Ke.escaped=!0),Ce--,Ce===0&&we()})},0))}),Ce===0&&we();return}try{var Oe=tt.lex(Re,Ae);return Ae.walkTokens&&Ve.walkTokens(Oe,Ae.walkTokens),rt.parse(Oe,Ae)}catch(Ke){if(Ke.message+=`
Please report this to https://github.com/markedjs/marked.`,Ae.silent)return"<p>An error occurred:</p><pre>"+re(Ke.message+"",!0)+"</pre>";throw Ke}}Ve.options=Ve.setOptions=function(Re){return ne(Ve.defaults,Re),Fe(Ve.defaults),Ve},Ve.getDefaults=ye,Ve.defaults=qe,Ve.use=function(){for(var Re=this,Ae=arguments.length,De=new Array(Ae),ce=0;ce<Ae;ce++)De[ce]=arguments[ce];var de=ne.apply(void 0,[{}].concat(De)),we=Ve.defaults.extensions||{renderers:{},childTokens:{}},Ce;De.forEach(function(Oe){if(Oe.extensions&&(Ce=!0,Oe.extensions.forEach(function($e){if(!$e.name)throw new Error("extension name required");if($e.renderer){var Ze=we.renderers?we.renderers[$e.name]:null;Ze?we.renderers[$e.name]=function(){for(var lt=arguments.length,ct=new Array(lt),He=0;He<lt;He++)ct[He]=arguments[He];var Ee=$e.renderer.apply(this,ct);return Ee===!1&&(Ee=Ze.apply(this,ct)),Ee}:we.renderers[$e.name]=$e.renderer}if($e.tokenizer){if(!$e.level||$e.level!=="block"&&$e.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");we[$e.level]?we[$e.level].unshift($e.tokenizer):we[$e.level]=[$e.tokenizer],$e.start&&($e.level==="block"?we.startBlock?we.startBlock.push($e.start):we.startBlock=[$e.start]:$e.level==="inline"&&(we.startInline?we.startInline.push($e.start):we.startInline=[$e.start]))}$e.childTokens&&(we.childTokens[$e.name]=$e.childTokens)})),Oe.renderer&&function(){var $e=Ve.defaults.renderer||new Ue,Ze=function(He){var Ee=$e[He];$e[He]=function(){for(var _e=arguments.length,he=new Array(_e),Y=0;Y<_e;Y++)he[Y]=arguments[Y];var ke=Oe.renderer[He].apply($e,he);return ke===!1&&(ke=Ee.apply($e,he)),ke}};for(var lt in Oe.renderer)Ze(lt);de.renderer=$e}(),Oe.tokenizer&&function(){var $e=Ve.defaults.tokenizer||new gt,Ze=function(He){var Ee=$e[He];$e[He]=function(){for(var _e=arguments.length,he=new Array(_e),Y=0;Y<_e;Y++)he[Y]=arguments[Y];var ke=Oe.tokenizer[He].apply($e,he);return ke===!1&&(ke=Ee.apply($e,he)),ke}};for(var lt in Oe.tokenizer)Ze(lt);de.tokenizer=$e}(),Oe.walkTokens){var Ke=Ve.defaults.walkTokens;de.walkTokens=function($e){Oe.walkTokens.call(Re,$e),Ke&&Ke($e)}}Ce&&(de.extensions=we),Ve.setOptions(de)})},Ve.walkTokens=function(Re,Ae){for(var De=function(){var Ce=de.value;switch(Ae(Ce),Ce.type){case"table":{for(var Oe=I(Ce.header),Ke;!(Ke=Oe()).done;){var $e=Ke.value;Ve.walkTokens($e.tokens,Ae)}for(var Ze=I(Ce.rows),lt;!(lt=Ze()).done;)for(var ct=lt.value,He=I(ct),Ee;!(Ee=He()).done;){var _e=Ee.value;Ve.walkTokens(_e.tokens,Ae)}break}case"list":{Ve.walkTokens(Ce.items,Ae);break}default:Ve.defaults.extensions&&Ve.defaults.extensions.childTokens&&Ve.defaults.extensions.childTokens[Ce.type]?Ve.defaults.extensions.childTokens[Ce.type].forEach(function(he){Ve.walkTokens(Ce[he],Ae)}):Ce.tokens&&Ve.walkTokens(Ce.tokens,Ae)}},ce=I(Re),de;!(de=ce()).done;)De()},Ve.parseInline=function(Re,Ae){if(typeof Re=="undefined"||Re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");Ae=ne({},Ve.defaults,Ae||{}),Se(Ae);try{var De=tt.lexInline(Re,Ae);return Ae.walkTokens&&Ve.walkTokens(De,Ae.walkTokens),rt.parseInline(De,Ae)}catch(ce){if(ce.message+=`
Please report this to https://github.com/markedjs/marked.`,Ae.silent)return"<p>An error occurred:</p><pre>"+re(ce.message+"",!0)+"</pre>";throw ce}},Ve.Parser=rt,Ve.parser=rt.parse,Ve.Renderer=Ue,Ve.TextRenderer=It,Ve.Lexer=tt,Ve.lexer=tt.lex,Ve.Tokenizer=gt,Ve.Slugger=ee,Ve.parse=Ve;var ut=Ve;return ut}),define(pe[94],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function f(k,y,P){return Math.min(Math.max(k,y),P)}e.clamp=f;function t(k,y){return(y+k%y)%y}e.rot=t;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class _{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=_;class R{constructor(y){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(y),this._values.fill(0,0,y)}update(y){const P=this._values[this._index];return this._values[this._index]=y,this._index=(this._index+1)%this._values.length,this._sum-=P,this._sum+=y,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=R}),function(){function Z(I){const _=[];typeof I=="number"&&_.push("code/timeOrigin",I);function R(y){_.push(y,Date.now())}function k(){const y=[];for(let P=0;P<_.length;P+=2)y.push({name:_[P],startTime:_[P+1]});return y}return{mark:R,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const _=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const R of performance.getEntriesByType("mark"))_.push({name:R.name,startTime:Math.round(I+R.startTime)});return _}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function f(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return f(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=f(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=f(t))}(),define(pe[12],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const f="en";let t=!1,I=!1,_=!1,R=!1,k=!1,y=!1,P=!1,L=!1,C,l=f,b,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?g=e.globals.vscode.process:typeof process!="undefined"&&(g=process);const E=typeof g?.versions?.electron=="string",F=E&&g?.type==="renderer";if(e.isElectronSandboxed=F&&g?.sandboxed,typeof navigator=="object"&&!F)p=navigator.userAgent,t=p.indexOf("Windows")>=0,I=p.indexOf("Macintosh")>=0,L=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=p.indexOf("Linux")>=0,y=!0,C=navigator.language,l=C;else if(typeof g=="object"){t=g.platform==="win32",I=g.platform==="darwin",_=g.platform==="linux",R=_&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,P=E,C=f,l=f;const r=g.env.VSCODE_NLS_CONFIG;if(r)try{const c=JSON.parse(r),o=c.availableLanguages["*"];C=c.locale,l=o||f,b=c._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var D;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(D=e.Platform||(e.Platform={}));function u(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=u;let s=0;I?s=1:t?s=3:_&&(s=2),e.isWindows=t,e.isMacintosh=I,e.isLinux=_,e.isLinuxSnap=R,e.isNative=k,e.isElectron=P,e.isWeb=y,e.isIOS=L,e.platform=s,e.userAgent=p,e.language=l;var h;(function(r){function c(){return e.language}r.value=c;function o(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=o;function d(){return e.language==="en"}r.isDefault=d})(h=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=b,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let r=[];e.globals.addEventListener("message",o=>{if(o.data&&o.data.vscodeScheduleAsyncWork)for(let d=0,m=r.length;d<m;d++){const v=r[d];if(v.id===o.data.vscodeScheduleAsyncWork){r.splice(d,1),v.callback();return}}});let c=0;return o=>{const d=++c;r.push({id:d,callback:o}),e.globals.postMessage({vscodeScheduleAsyncWork:d},"*")}}return r=>setTimeout(r)})();var n;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||L?2:t?1:3;let S=!0,a=!1;function i(){if(!a){a=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,S=new Uint16Array(r.buffer)[0]===(2<<8)+1}return S}e.isLittleEndian=i,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(pe[40],ve([0,1,12]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof f.globals.vscode!="undefined"&&typeof f.globals.vscode.process!="undefined"){const I=f.globals.vscode.process;t={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return f.isWindows?"win32":f.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(pe[9],ve([0,1,40]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,I=97,_=90,R=122,k=46,y=47,P=92,L=58,C=63;class l extends Error{constructor(s,h,n){let S;typeof h=="string"&&h.indexOf("not ")===0?(S="must not be",h=h.replace(/^not /,"")):S="must be";const a=s.indexOf(".")!==-1?"property":"argument";let i=`The "${s}" ${a} ${S} of type ${h}`;i+=`. Received type ${typeof n}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function b(u,s){if(typeof u!="string")throw new l(s,"string",u)}function p(u){return u===y||u===P}function g(u){return u===y}function E(u){return u>=t&&u<=_||u>=I&&u<=R}function F(u,s,h,n){let S="",a=0,i=-1,r=0,c=0;for(let o=0;o<=u.length;++o){if(o<u.length)c=u.charCodeAt(o);else{if(n(c))break;c=y}if(n(c)){if(!(i===o-1||r===1))if(r===2){if(S.length<2||a!==2||S.charCodeAt(S.length-1)!==k||S.charCodeAt(S.length-2)!==k){if(S.length>2){const d=S.lastIndexOf(h);d===-1?(S="",a=0):(S=S.slice(0,d),a=S.length-1-S.lastIndexOf(h)),i=o,r=0;continue}else if(S.length!==0){S="",a=0,i=o,r=0;continue}}s&&(S+=S.length>0?`${h}..`:"..",a=2)}else S.length>0?S+=`${h}${u.slice(i+1,o)}`:S=u.slice(i+1,o),a=o-i-1;i=o,r=0}else c===k&&r!==-1?++r:r=-1}return S}function D(u,s){if(s===null||typeof s!="object")throw new l("pathObject","Object",s);const h=s.dir||s.root,n=s.base||`${s.name||""}${s.ext||""}`;return h?h===s.root?`${h}${n}`:`${h}${u}${n}`:n}e.win32={resolve(...u){let s="",h="",n=!1;for(let S=u.length-1;S>=-1;S--){let a;if(S>=0){if(a=u[S],b(a,"path"),a.length===0)continue}else s.length===0?a=f.cwd():(a=f.env[`=${s}`]||f.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==s.toLowerCase()&&a.charCodeAt(2)===P)&&(a=`${s}\\`));const i=a.length;let r=0,c="",o=!1;const d=a.charCodeAt(0);if(i===1)p(d)&&(r=1,o=!0);else if(p(d))if(o=!0,p(a.charCodeAt(1))){let m=2,v=m;for(;m<i&&!p(a.charCodeAt(m));)m++;if(m<i&&m!==v){const w=a.slice(v,m);for(v=m;m<i&&p(a.charCodeAt(m));)m++;if(m<i&&m!==v){for(v=m;m<i&&!p(a.charCodeAt(m));)m++;(m===i||m!==v)&&(c=`\\\\${w}\\${a.slice(v,m)}`,r=m)}}}else r=1;else E(d)&&a.charCodeAt(1)===L&&(c=a.slice(0,2),r=2,i>2&&p(a.charCodeAt(2))&&(o=!0,r=3));if(c.length>0)if(s.length>0){if(c.toLowerCase()!==s.toLowerCase())continue}else s=c;if(n){if(s.length>0)break}else if(h=`${a.slice(r)}\\${h}`,n=o,o&&s.length>0)break}return h=F(h,!n,"\\",p),n?`${s}\\${h}`:`${s}${h}`||"."},normalize(u){b(u,"path");const s=u.length;if(s===0)return".";let h=0,n,S=!1;const a=u.charCodeAt(0);if(s===1)return g(a)?"\\":u;if(p(a))if(S=!0,p(u.charCodeAt(1))){let r=2,c=r;for(;r<s&&!p(u.charCodeAt(r));)r++;if(r<s&&r!==c){const o=u.slice(c,r);for(c=r;r<s&&p(u.charCodeAt(r));)r++;if(r<s&&r!==c){for(c=r;r<s&&!p(u.charCodeAt(r));)r++;if(r===s)return`\\\\${o}\\${u.slice(c)}\\`;r!==c&&(n=`\\\\${o}\\${u.slice(c,r)}`,h=r)}}}else h=1;else E(a)&&u.charCodeAt(1)===L&&(n=u.slice(0,2),h=2,s>2&&p(u.charCodeAt(2))&&(S=!0,h=3));let i=h<s?F(u.slice(h),!S,"\\",p):"";return i.length===0&&!S&&(i="."),i.length>0&&p(u.charCodeAt(s-1))&&(i+="\\"),n===void 0?S?`\\${i}`:i:S?`${n}\\${i}`:`${n}${i}`},isAbsolute(u){b(u,"path");const s=u.length;if(s===0)return!1;const h=u.charCodeAt(0);return p(h)||s>2&&E(h)&&u.charCodeAt(1)===L&&p(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let s,h;for(let a=0;a<u.length;++a){const i=u[a];b(i,"path"),i.length>0&&(s===void 0?s=h=i:s+=`\\${i}`)}if(s===void 0)return".";let n=!0,S=0;if(typeof h=="string"&&p(h.charCodeAt(0))){++S;const a=h.length;a>1&&p(h.charCodeAt(1))&&(++S,a>2&&(p(h.charCodeAt(2))?++S:n=!1))}if(n){for(;S<s.length&&p(s.charCodeAt(S));)S++;S>=2&&(s=`\\${s.slice(S)}`)}return e.win32.normalize(s)},relative(u,s){if(b(u,"from"),b(s,"to"),u===s)return"";const h=e.win32.resolve(u),n=e.win32.resolve(s);if(h===n||(u=h.toLowerCase(),s=n.toLowerCase(),u===s))return"";let S=0;for(;S<u.length&&u.charCodeAt(S)===P;)S++;let a=u.length;for(;a-1>S&&u.charCodeAt(a-1)===P;)a--;const i=a-S;let r=0;for(;r<s.length&&s.charCodeAt(r)===P;)r++;let c=s.length;for(;c-1>r&&s.charCodeAt(c-1)===P;)c--;const o=c-r,d=i<o?i:o;let m=-1,v=0;for(;v<d;v++){const A=u.charCodeAt(S+v);if(A!==s.charCodeAt(r+v))break;A===P&&(m=v)}if(v!==d){if(m===-1)return n}else{if(o>d){if(s.charCodeAt(r+v)===P)return n.slice(r+v+1);if(v===2)return n.slice(r+v)}i>d&&(u.charCodeAt(S+v)===P?m=v:v===2&&(m=3)),m===-1&&(m=0)}let w="";for(v=S+m+1;v<=a;++v)(v===a||u.charCodeAt(v)===P)&&(w+=w.length===0?"..":"\\..");return r+=m,w.length>0?`${w}${n.slice(r,c)}`:(n.charCodeAt(r)===P&&++r,n.slice(r,c))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const s=e.win32.resolve(u);if(s.length<=2)return u;if(s.charCodeAt(0)===P){if(s.charCodeAt(1)===P){const h=s.charCodeAt(2);if(h!==C&&h!==k)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(E(s.charCodeAt(0))&&s.charCodeAt(1)===L&&s.charCodeAt(2)===P)return`\\\\?\\${s}`;return u},dirname(u){b(u,"path");const s=u.length;if(s===0)return".";let h=-1,n=0;const S=u.charCodeAt(0);if(s===1)return p(S)?u:".";if(p(S)){if(h=n=1,p(u.charCodeAt(1))){let r=2,c=r;for(;r<s&&!p(u.charCodeAt(r));)r++;if(r<s&&r!==c){for(c=r;r<s&&p(u.charCodeAt(r));)r++;if(r<s&&r!==c){for(c=r;r<s&&!p(u.charCodeAt(r));)r++;if(r===s)return u;r!==c&&(h=n=r+1)}}}}else E(S)&&u.charCodeAt(1)===L&&(h=s>2&&p(u.charCodeAt(2))?3:2,n=h);let a=-1,i=!0;for(let r=s-1;r>=n;--r)if(p(u.charCodeAt(r))){if(!i){a=r;break}}else i=!1;if(a===-1){if(h===-1)return".";a=h}return u.slice(0,a)},basename(u,s){s!==void 0&&b(s,"ext"),b(u,"path");let h=0,n=-1,S=!0,a;if(u.length>=2&&E(u.charCodeAt(0))&&u.charCodeAt(1)===L&&(h=2),s!==void 0&&s.length>0&&s.length<=u.length){if(s===u)return"";let i=s.length-1,r=-1;for(a=u.length-1;a>=h;--a){const c=u.charCodeAt(a);if(p(c)){if(!S){h=a+1;break}}else r===-1&&(S=!1,r=a+1),i>=0&&(c===s.charCodeAt(i)?--i==-1&&(n=a):(i=-1,n=r))}return h===n?n=r:n===-1&&(n=u.length),u.slice(h,n)}for(a=u.length-1;a>=h;--a)if(p(u.charCodeAt(a))){if(!S){h=a+1;break}}else n===-1&&(S=!1,n=a+1);return n===-1?"":u.slice(h,n)},extname(u){b(u,"path");let s=0,h=-1,n=0,S=-1,a=!0,i=0;u.length>=2&&u.charCodeAt(1)===L&&E(u.charCodeAt(0))&&(s=n=2);for(let r=u.length-1;r>=s;--r){const c=u.charCodeAt(r);if(p(c)){if(!a){n=r+1;break}continue}S===-1&&(a=!1,S=r+1),c===k?h===-1?h=r:i!==1&&(i=1):h!==-1&&(i=-1)}return h===-1||S===-1||i===0||i===1&&h===S-1&&h===n+1?"":u.slice(h,S)},format:D.bind(null,"\\"),parse(u){b(u,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return s;const h=u.length;let n=0,S=u.charCodeAt(0);if(h===1)return p(S)?(s.root=s.dir=u,s):(s.base=s.name=u,s);if(p(S)){if(n=1,p(u.charCodeAt(1))){let m=2,v=m;for(;m<h&&!p(u.charCodeAt(m));)m++;if(m<h&&m!==v){for(v=m;m<h&&p(u.charCodeAt(m));)m++;if(m<h&&m!==v){for(v=m;m<h&&!p(u.charCodeAt(m));)m++;m===h?n=m:m!==v&&(n=m+1)}}}}else if(E(S)&&u.charCodeAt(1)===L){if(h<=2)return s.root=s.dir=u,s;if(n=2,p(u.charCodeAt(2))){if(h===3)return s.root=s.dir=u,s;n=3}}n>0&&(s.root=u.slice(0,n));let a=-1,i=n,r=-1,c=!0,o=u.length-1,d=0;for(;o>=n;--o){if(S=u.charCodeAt(o),p(S)){if(!c){i=o+1;break}continue}r===-1&&(c=!1,r=o+1),S===k?a===-1?a=o:d!==1&&(d=1):a!==-1&&(d=-1)}return r!==-1&&(a===-1||d===0||d===1&&a===r-1&&a===i+1?s.base=s.name=u.slice(i,r):(s.name=u.slice(i,a),s.base=u.slice(i,r),s.ext=u.slice(a,r))),i>0&&i!==n?s.dir=u.slice(0,i-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let s="",h=!1;for(let n=u.length-1;n>=-1&&!h;n--){const S=n>=0?u[n]:f.cwd();b(S,"path"),S.length!==0&&(s=`${S}/${s}`,h=S.charCodeAt(0)===y)}return s=F(s,!h,"/",g),h?`/${s}`:s.length>0?s:"."},normalize(u){if(b(u,"path"),u.length===0)return".";const s=u.charCodeAt(0)===y,h=u.charCodeAt(u.length-1)===y;return u=F(u,!s,"/",g),u.length===0?s?"/":h?"./":".":(h&&(u+="/"),s?`/${u}`:u)},isAbsolute(u){return b(u,"path"),u.length>0&&u.charCodeAt(0)===y},join(...u){if(u.length===0)return".";let s;for(let h=0;h<u.length;++h){const n=u[h];b(n,"path"),n.length>0&&(s===void 0?s=n:s+=`/${n}`)}return s===void 0?".":e.posix.normalize(s)},relative(u,s){if(b(u,"from"),b(s,"to"),u===s||(u=e.posix.resolve(u),s=e.posix.resolve(s),u===s))return"";const h=1,n=u.length,S=n-h,a=1,i=s.length-a,r=S<i?S:i;let c=-1,o=0;for(;o<r;o++){const m=u.charCodeAt(h+o);if(m!==s.charCodeAt(a+o))break;m===y&&(c=o)}if(o===r)if(i>r){if(s.charCodeAt(a+o)===y)return s.slice(a+o+1);if(o===0)return s.slice(a+o)}else S>r&&(u.charCodeAt(h+o)===y?c=o:o===0&&(c=0));let d="";for(o=h+c+1;o<=n;++o)(o===n||u.charCodeAt(o)===y)&&(d+=d.length===0?"..":"/..");return`${d}${s.slice(a+c)}`},toNamespacedPath(u){return u},dirname(u){if(b(u,"path"),u.length===0)return".";const s=u.charCodeAt(0)===y;let h=-1,n=!0;for(let S=u.length-1;S>=1;--S)if(u.charCodeAt(S)===y){if(!n){h=S;break}}else n=!1;return h===-1?s?"/":".":s&&h===1?"//":u.slice(0,h)},basename(u,s){s!==void 0&&b(s,"ext"),b(u,"path");let h=0,n=-1,S=!0,a;if(s!==void 0&&s.length>0&&s.length<=u.length){if(s===u)return"";let i=s.length-1,r=-1;for(a=u.length-1;a>=0;--a){const c=u.charCodeAt(a);if(c===y){if(!S){h=a+1;break}}else r===-1&&(S=!1,r=a+1),i>=0&&(c===s.charCodeAt(i)?--i==-1&&(n=a):(i=-1,n=r))}return h===n?n=r:n===-1&&(n=u.length),u.slice(h,n)}for(a=u.length-1;a>=0;--a)if(u.charCodeAt(a)===y){if(!S){h=a+1;break}}else n===-1&&(S=!1,n=a+1);return n===-1?"":u.slice(h,n)},extname(u){b(u,"path");let s=-1,h=0,n=-1,S=!0,a=0;for(let i=u.length-1;i>=0;--i){const r=u.charCodeAt(i);if(r===y){if(!S){h=i+1;break}continue}n===-1&&(S=!1,n=i+1),r===k?s===-1?s=i:a!==1&&(a=1):s!==-1&&(a=-1)}return s===-1||n===-1||a===0||a===1&&s===n-1&&s===h+1?"":u.slice(s,n)},format:D.bind(null,"/"),parse(u){b(u,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return s;const h=u.charCodeAt(0)===y;let n;h?(s.root="/",n=1):n=0;let S=-1,a=0,i=-1,r=!0,c=u.length-1,o=0;for(;c>=n;--c){const d=u.charCodeAt(c);if(d===y){if(!r){a=c+1;break}continue}i===-1&&(r=!1,i=c+1),d===k?S===-1?S=c:o!==1&&(o=1):S!==-1&&(o=-1)}if(i!==-1){const d=a===0&&h?1:a;S===-1||o===0||o===1&&S===i-1&&S===a+1?s.base=s.name=u.slice(d,i):(s.name=u.slice(d,S),s.base=u.slice(d,i),s.ext=u.slice(S,i))}return a>0?s.dir=u.slice(0,a-1):h&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=f.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=f.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=f.platform==="win32"?e.win32.join:e.posix.join,e.resolve=f.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=f.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=f.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=f.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=f.platform==="win32"?e.win32.extname:e.posix.extname,e.format=f.platform==="win32"?e.win32.format:e.posix.format,e.parse=f.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=f.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=f.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=f.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(pe[95],ve([0,1,9]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(C){C.text="text/plain",C.binary="application/octet-stream",C.unknown="application/unknown",C.markdown="text/markdown",C.latex="text/latex"})(t=e.Mimes||(e.Mimes={}));const I={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},_={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(C){const l=(0,f.extname)(C),b=I[l.toLowerCase()];return b!==void 0?b:k(C)}e.getMediaOrTextMime=R;function k(C){const l=(0,f.extname)(C);return _[l.toLowerCase()]}e.getMediaMime=k;function y(C){for(const l in _)if(_[l]===C)return l}e.getExtensionForMimeType=y;const P=/^(.+)\/(.+?)(;.+)?$/;function L(C,l){const b=P.exec(C);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:l?void 0:C}e.normalizeMimeType=L}),define(pe[96],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var f;(function(_){_[_.stdout=0]="stdout",_[_.stderr=1]="stderr"})(f=e.Source||(e.Source={}));var t;(function(_){_[_.Success=0]="Success",_[_.Unknown=1]="Unknown",_[_.AccessDenied=2]="AccessDenied",_[_.ProcessNotFound=3]="ProcessNotFound"})(t=e.TerminateResponseCode||(e.TerminateResponseCode={}));function I(_,...R){const k=R.reduce((L,C)=>(L[C]=!0,L),{}),y=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(_).filter(L=>!k[L]).forEach(L=>{for(let C=0;C<y.length;C++)if(L.search(y[C])!==-1){delete _[L];break}})}e.sanitizeProcessEnvironment=I}),define(pe[46],ve([0,1,12]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=f.globals.performance&&typeof f.globals.performance.now=="function";class I{constructor(R){this._highResolution=t&&R,this._startTime=this._now(),this._stopTime=-1}static create(R=!0){return new I(R)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?f.globals.performance.now():Date.now()}}e.StopWatch=I}),define(pe[3],ve([0,1,16,76,6,93,46]),function(Z,e,f,t,I,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(s){s.None=()=>I.Disposable.None;function h(B){return(W,H=null,z)=>{let J=!1,ie;return ie=B(se=>{if(!J)return ie?ie.dispose():J=!0,W.call(H,se)},null,z),J&&ie.dispose(),ie}}s.once=h;function n(B,W){return o((H,z=null,J)=>B(ie=>H.call(z,W(ie)),null,J))}s.map=n;function S(B,W){return o((H,z=null,J)=>B(ie=>{W(ie),H.call(z,ie)},null,J))}s.forEach=S;function a(B,W){return o((H,z=null,J)=>B(ie=>W(ie)&&H.call(z,ie),null,J))}s.filter=a;function i(B){return B}s.signal=i;function r(...B){return(W,H=null,z)=>(0,I.combinedDisposable)(...B.map(J=>J(ie=>W.call(H,ie),null,z)))}s.any=r;function c(B,W,H){let z=H;return n(B,J=>(z=W(z,J),z))}s.reduce=c;function o(B){let W;const H=new l({onFirstListenerAdd(){W=B(H.fire,H)},onLastListenerRemove(){W.dispose()}});return H.event}function d(B,W,H,z=100,J=!1){let ie,se,K=0;return B(X=>{K++,ie=H(ie,X),J&&!se&&(W(ie),ie=void 0),clearTimeout(se),se=setTimeout(()=>{const ae=ie;ie=void 0,se=void 0,(!J||K>1)&&W(ae),K=0},z)})}s.debouncedListener=d;function m(B,W,H=100,z=!1,J){let ie,se,K,X=0;const ae=new l({leakWarningThreshold:J,onFirstListenerAdd(){ie=B(fe=>{X++,se=W(se,fe),z&&!K&&(ae.fire(se),se=void 0),clearTimeout(K),K=setTimeout(()=>{const be=se;se=void 0,K=void 0,(!z||X>1)&&ae.fire(be),X=0},H)})},onLastListenerRemove(){ie.dispose()}});return ae.event}s.debounce=m;function v(B,W=(H,z)=>H===z){let H=!0,z;return a(B,J=>{const ie=H||!W(J,z);return H=!1,z=J,ie})}s.latch=v;function w(B,W){return[s.filter(B,W),s.filter(B,H=>!W(H))]}s.split=w;function A(B,W=!1,H=[]){let z=H.slice(),J=B(K=>{z?z.push(K):se.fire(K)});const ie=()=>{z&&z.forEach(K=>se.fire(K)),z=null},se=new l({onFirstListenerAdd(){J||(J=B(K=>se.fire(K)))},onFirstListenerDidAdd(){z&&(W?setTimeout(ie):ie())},onLastListenerRemove(){J&&J.dispose(),J=null}});return se.event}s.buffer=A;class M{constructor(W){this.event=W}map(W){return new M(n(this.event,W))}forEach(W){return new M(S(this.event,W))}filter(W){return new M(a(this.event,W))}reduce(W,H){return new M(c(this.event,W,H))}latch(){return new M(v(this.event))}debounce(W,H=100,z=!1,J){return new M(m(this.event,W,H,z,J))}on(W,H,z){return this.event(W,H,z)}once(W,H,z){return h(this.event)(W,H,z)}}function T(B){return new M(B)}s.chain=T;function O(B,W,H=z=>z){const z=(...K)=>se.fire(H(...K)),J=()=>B.on(W,z),ie=()=>B.removeListener(W,z),se=new l({onFirstListenerAdd:J,onLastListenerRemove:ie});return se.event}s.fromNodeEventEmitter=O;function U(B,W,H=z=>z){const z=(...K)=>se.fire(H(...K)),J=()=>B.addEventListener(W,z),ie=()=>B.removeEventListener(W,z),se=new l({onFirstListenerAdd:J,onLastListenerRemove:ie});return se.event}s.fromDOMEventEmitter=U;function V(B){return new Promise(W=>h(B)(W))}s.toPromise=V;function x(B,W){return W(void 0),B(H=>W(H))}s.runAndSubscribe=x;function N(B,W){let H=null;function z(ie){H?.dispose(),H=new I.DisposableStore,W(ie,H)}z(void 0);const J=B(ie=>z(ie));return(0,I.toDisposable)(()=>{J.dispose(),H?.dispose()})}s.runAndSubscribeWithStore=N})(k=e.Event||(e.Event={}));class y{constructor(h){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${h}_${y._idPool++}`}start(h){this._stopWatch=new R.StopWatch(!0),this._listenerCount=h}stop(){if(this._stopWatch){const h=this._stopWatch.elapsed();this._elapsedOverall+=h,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${h.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let P=-1;function L(s){const h=P;return P=s,{dispose(){P=h}}}e.setGlobalLeakWarningThreshold=L;class C{constructor(h,n=Math.random().toString(18).slice(2,5)){this.customThreshold=h,this.name=n,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(h){let n=P;if(typeof this.customThreshold=="number"&&(n=this.customThreshold),n<=0||h<n)return;this._stacks||(this._stacks=new Map);const S=new Error().stack.split(`
`).slice(3).join(`
`),a=this._stacks.get(S)||0;if(this._stacks.set(S,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=n*.5;let i,r=0;for(const[c,o]of this._stacks)(!i||r<o)&&(i=c,r=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${r}):`),console.warn(i)}return()=>{const i=this._stacks.get(S)||0;this._stacks.set(S,i-1)}}}class l{constructor(h){this._disposed=!1,this._options=h,this._leakageMon=P>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(h,n,S)=>{this._listeners||(this._listeners=new _.LinkedList);const a=this._listeners.isEmpty();a&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(n?[h,n]:h);a&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,h,n);const r=this._leakageMon?.check(this._listeners.size),c=(0,I.toDisposable)(()=>{r&&r(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return S instanceof I.DisposableStore?S.add(c):Array.isArray(S)&&S.push(c),c}),this._event}fire(h){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new _.LinkedList);for(let n of this._listeners)this._deliveryQueue.push([n,h]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[n,S]=this._deliveryQueue.shift();try{typeof n=="function"?n.call(void 0,S):n[0].call(n[1],S)}catch(a){(0,f.onUnexpectedError)(a)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=l;class b extends l{async fireAsync(h,n,S){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new _.LinkedList);for(const a of this._listeners)this._asyncDeliveryQueue.push([a,h]);for(;this._asyncDeliveryQueue.size>0&&!n.isCancellationRequested;){const[a,i]=this._asyncDeliveryQueue.shift(),r=[],c={...i,token:n,waitUntil:o=>{if(Object.isFrozen(r))throw new Error("waitUntil can NOT be called asynchronous");S&&(o=S(o,typeof a=="function"?a:a[0])),r.push(o)}};try{typeof a=="function"?a.call(void 0,c):a[0].call(a[1],c)}catch(o){(0,f.onUnexpectedError)(o);continue}Object.freeze(r),await Promise.allSettled(r).then(o=>{for(const d of o)d.status==="rejected"&&(0,f.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=b;class p extends l{constructor(h){super(h);this._isPaused=0,this._eventQueue=new _.LinkedList,this._mergeFn=h?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const h=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(h))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(h){this._listeners&&(this._isPaused!==0?this._eventQueue.push(h):super.fire(h))}}e.PauseableEmitter=p;class g extends p{constructor(h){super(h);this._delay=h.delay??100}fire(h){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(h)}}e.DebounceEmitter=g;class E extends l{constructor(h){super(h);this._queuedEvents=[],this._mergeFn=h?.merge}fire(h){this._queuedEvents.push(h),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(n=>super.fire(n)),this._queuedEvents=[]})}}e.MicrotaskEmitter=E;class F{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(h){const n={event:h,listener:null};this.events.push(n),this.hasListeners&&this.hook(n);const S=()=>{this.hasListeners&&this.unhook(n);const a=this.events.indexOf(n);this.events.splice(a,1)};return(0,I.toDisposable)((0,t.once)(S))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(h=>this.hook(h))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(h=>this.unhook(h))}hook(h){h.listener=h.event(n=>this.emitter.fire(n))}unhook(h){h.listener&&h.listener.dispose(),h.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=F;class D{constructor(){this.buffers=[]}wrapEvent(h){return(n,S,a)=>h(i=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>n.call(S,i)):n.call(S,i)},void 0,a)}bufferEvents(h){const n=[];this.buffers.push(n);const S=h();return this.buffers.pop(),n.forEach(a=>a()),S}}e.EventBufferer=D;class u{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=I.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(h){this.inputEvent=h,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=h(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=u}),define(pe[21],ve([0,1,3]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(k,y){const P=setTimeout(k.bind(y),0);return{dispose(){clearTimeout(P)}}});var I;(function(k){function y(P){return P===k.None||P===k.Cancelled||P instanceof _?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}k.isCancellationToken=y,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:f.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(I=e.CancellationToken||(e.CancellationToken={}));class _{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new f.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class R{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new _),this._token}cancel(){this._token?this._token instanceof _&&this._token.cancel():this._token=I.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof _&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=R}),define(pe[142],ve([0,1,21]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class t{constructor(R){this.task=R,this.result=null}get(){if(this.result)return this.result;const R=new f.CancellationTokenSource,k=this.task(R.token);return this.result={promise:k,dispose:()=>{this.result=null,R.cancel(),R.dispose()}},this.result}}e.Cache=t;class I{constructor(R){this.computeFn=R,this.lastCache=void 0,this.lastArgKey=void 0}get(R){const k=JSON.stringify(R);return this.lastArgKey!==k&&(this.lastArgKey=k,this.lastCache=this.computeFn(R)),this.lastCache}}e.LRUCachedComputed=I}),define(pe[97],ve([0,1,16,6]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function I(u){const s=u;return s?[s.on,s.pause,s.resume,s.destroy].every(h=>typeof h=="function"):!1}e.isReadableStream=I;function _(u){const s=u;return s?I(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=_;function R(u,s){return new k(u,s)}e.newWriteableStream=R;class k{constructor(s,h){this.reducer=s,this.options=h,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(h=>this.pendingWritePromises.push(h))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(h=>h(s))}emitError(s){this.listeners.error.length===0?(0,f.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(h=>h(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,h){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(h),this.resume();break;case"end":this.listeners.end.push(h),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(h),this.state.flowing&&this.flowErrors();break}}removeListener(s,h){if(this.state.destroyed)return;let n;switch(s){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const S=n.indexOf(h);S>=0&&n.splice(S,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const h=[...this.pendingWritePromises];this.pendingWritePromises.length=0,h.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(u,s){const h=[];let n;for(;(n=u.read())!==null;)h.push(n);return s(h)}e.consumeReadable=y;function P(u,s,h){const n=[];let S;for(;(S=u.read())!==null&&n.length<h;)n.push(S);return S===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof S!="undefined"){const a=S;return S=void 0,a}return u.read()}}}e.peekReadable=P;function L(u,s){return new Promise((h,n)=>{const S=[];C(u,{onData:a=>{s&&S.push(a)},onError:a=>{s?n(a):h(void 0)},onEnd:()=>{h(s?s(S):void 0)}})})}e.consumeStream=L;function C(u,s){let h=!1;return u.on("error",n=>{h||s.onError(n)}),u.on("end",()=>{h||s.onEnd()}),u.on("data",n=>{h||s.onData(n)}),(0,t.toDisposable)(()=>h=!0)}e.listenStream=C;function l(u,s){return new Promise((h,n)=>{const S=new t.DisposableStore,a=[],i=o=>{if(a.push(o),a.length>s)return S.dispose(),u.pause(),h({stream:u,buffer:a,ended:!1})},r=o=>n(o),c=()=>h({stream:u,buffer:a,ended:!0});S.add((0,t.toDisposable)(()=>u.removeListener("error",r))),u.on("error",r),S.add((0,t.toDisposable)(()=>u.removeListener("end",c))),u.on("end",c),S.add((0,t.toDisposable)(()=>u.removeListener("data",i))),u.on("data",i)})}e.peekStream=l;function b(u,s){const h=R(s);return h.end(u),h}e.toStream=b;function p(){const u=R(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=p;function g(u){let s=!1;return{read:()=>s?null:(s=!0,u)}}e.toReadable=g;function E(u,s,h){const n=R(h);return C(u,{onData:S=>n.write(s.data(S)),onError:S=>n.error(s.error?s.error(S):S),onEnd:()=>n.end()}),n}e.transform=E;function F(u,s,h){let n=!1;return{read:()=>{const S=s.read();return n?S:(n=!0,S!==null?h([u,S]):u)}}}e.prefixedReadable=F;function D(u,s,h){let n=!1;const S=R(h);return C(s,{onData:a=>n?S.write(a):(n=!0,S.write(h([u,a]))),onError:a=>S.error(a),onEnd:()=>{n||(n=!0,S.write(u)),S.end()}}),S}e.prefixedStream=D}),define(pe[22],ve([0,1,97]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let I,_;class R{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return t?new R(Buffer.allocUnsafe(d)):new R(new Uint8Array(d))}static wrap(d){return t&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new R(d)}static fromString(d,m){return!(m?.dontUseNodeBuffer||!1)&&t?new R(Buffer.from(d)):(I||(I=new TextEncoder),new R(I.encode(d)))}static fromByteArray(d){const m=R.alloc(d.length);for(let v=0,w=d.length;v<w;v++)m.buffer[v]=d[v];return m}static concat(d,m){if(typeof m=="undefined"){m=0;for(let A=0,M=d.length;A<M;A++)m+=d[A].byteLength}const v=R.alloc(m);let w=0;for(let A=0,M=d.length;A<M;A++){const T=d[A];v.set(T,w),w+=T.byteLength}return v}clone(){const d=R.alloc(this.byteLength);return d.set(this),d}toString(){return t?this.buffer.toString():(_||(_=new TextDecoder),_.decode(this.buffer))}slice(d,m){return new R(this.buffer.subarray(d,m))}set(d,m){if(d instanceof R)this.buffer.set(d.buffer,m);else if(d instanceof Uint8Array)this.buffer.set(d,m);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),m);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),m);else throw new Error("Unkown argument 'array'")}readUInt32BE(d){return P(this.buffer,d)}writeUInt32BE(d,m){L(this.buffer,d,m)}readUInt32LE(d){return C(this.buffer,d)}writeUInt32LE(d,m){l(this.buffer,d,m)}readUInt8(d){return b(this.buffer,d)}writeUInt8(d,m){p(this.buffer,d,m)}}e.VSBuffer=R;function k(o,d){return o[d+0]<<0>>>0|o[d+1]<<8>>>0}e.readUInt16LE=k;function y(o,d,m){o[m+0]=d&255,d=d>>>8,o[m+1]=d&255}e.writeUInt16LE=y;function P(o,d){return o[d]*2**24+o[d+1]*2**16+o[d+2]*2**8+o[d+3]}e.readUInt32BE=P;function L(o,d,m){o[m+3]=d,d=d>>>8,o[m+2]=d,d=d>>>8,o[m+1]=d,d=d>>>8,o[m]=d}e.writeUInt32BE=L;function C(o,d){return o[d+0]<<0>>>0|o[d+1]<<8>>>0|o[d+2]<<16>>>0|o[d+3]<<24>>>0}e.readUInt32LE=C;function l(o,d,m){o[m+0]=d&255,d=d>>>8,o[m+1]=d&255,d=d>>>8,o[m+2]=d&255,d=d>>>8,o[m+3]=d&255}e.writeUInt32LE=l;function b(o,d){return o[d]}e.readUInt8=b;function p(o,d,m){o[m]=d}e.writeUInt8=p;function g(o){return f.consumeReadable(o,d=>R.concat(d))}e.readableToBuffer=g;function E(o){return f.toReadable(o)}e.bufferToReadable=E;function F(o){return f.consumeStream(o,d=>R.concat(d))}e.streamToBuffer=F;async function D(o){return o.ended?R.concat(o.buffer):R.concat([...o.buffer,await F(o.stream)])}e.bufferedStreamToBuffer=D;function u(o){return f.toStream(o,d=>R.concat(d))}e.bufferToStream=u;function s(o){return f.transform(o,{data:d=>typeof d=="string"?R.fromString(d):R.wrap(d)},d=>R.concat(d))}e.streamToBufferReadableStream=s;function h(o){return f.newWriteableStream(d=>R.concat(d),o)}e.newWriteableBufferStream=h;function n(o,d){return f.prefixedReadable(o,d,m=>R.concat(m))}e.prefixedBufferReadable=n;function S(o,d){return f.prefixedStream(o,d,m=>R.concat(m))}e.prefixedBufferStream=S;function a(o){let d=0,m=0,v=0;const w=new Uint8Array(Math.floor(o.length/4*3)),A=T=>{switch(m){case 3:w[v++]=d|T,m=0;break;case 2:w[v++]=d|T>>>2,d=T<<6,m=3;break;case 1:w[v++]=d|T>>>4,d=T<<4,m=2;break;default:d=T<<2,m=1}};for(let T=0;T<o.length;T++){const O=o.charCodeAt(T);if(O>=65&&O<=90)A(O-65);else if(O>=97&&O<=122)A(O-97+26);else if(O>=48&&O<=57)A(O-48+52);else if(O===43||O===45)A(62);else if(O===47||O===95)A(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${o[T]}`)}}const M=v;for(;m>0;)A(0);return R.wrap(w).slice(0,M)}e.decodeBase64=a;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:o},d=!0,m=!1){const v=m?r:i;let w="";const A=o.byteLength%3;let M=0;for(;M<o.byteLength-A;M+=3){const T=o[M+0],O=o[M+1],U=o[M+2];w+=v[T>>>2],w+=v[(T<<4|O>>>4)&63],w+=v[(O<<2|U>>>6)&63],w+=v[U&63]}if(A===1){const T=o[M+0];w+=v[T>>>2],w+=v[T<<4&63],d&&(w+="==")}else if(A===2){const T=o[M+0],O=o[M+1];w+=v[T>>>2],w+=v[(T<<4|O>>>4)&63],w+=v[O<<2&63],d&&(w+="=")}return w}e.encodeBase64=c}),define(pe[8],ve([0,1,142,92]),function(Z,e,f,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function _(re){return!re||typeof re!="string"?!0:re.trim().length===0}e.isFalsyOrWhitespace=_;const R=/{(\d+)}/g;function k(re,...ye){return ye.length===0?re:re.replace(R,function(Fe,qe){const Ve=parseInt(qe,10);return isNaN(Ve)||Ve<0||Ve>=ye.length?Fe:ye[Ve]})}e.format=k;const y=/{([^}]+)}/g;function P(re,ye){return re.replace(y,(Fe,qe)=>ye[qe]??Fe)}e.format2=P;function L(re){return re.replace(/[<>&]/g,function(ye){switch(ye){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ye}})}e.escape=L;function C(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function l(re,ye){let Fe=0;const qe=ye.charCodeAt(0);for(let Ve=re.length-1;Ve>=0;Ve--)re.charCodeAt(Ve)===qe&&Fe++;return Fe}e.count=l;function b(re,ye,Fe="\u2026"){return re.length<=ye?re:`${re.substr(0,ye)}${Fe}`}e.truncate=b;function p(re,ye=" "){const Fe=g(re,ye);return E(Fe,ye)}e.trim=p;function g(re,ye){if(!re||!ye)return re;const Fe=ye.length;if(Fe===0||re.length===0)return re;let qe=0;for(;re.indexOf(ye,qe)===qe;)qe=qe+Fe;return re.substring(qe)}e.ltrim=g;function E(re,ye){if(!re||!ye)return re;const Fe=ye.length,qe=re.length;if(Fe===0||qe===0)return re;let Ve=qe,ut=-1;for(;ut=re.lastIndexOf(ye,Ve-1),!(ut===-1||ut+Fe!==Ve);){if(ut===0)return"";Ve=ut}return re.substring(0,Ve)}e.rtrim=E;function F(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=F;function D(re){return re.replace(/\*/g,"")}e.stripWildcards=D;function u(re,ye,Fe={}){if(!re)throw new Error("Cannot create regex from empty string");ye||(re=C(re)),Fe.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let qe="";return Fe.global&&(qe+="g"),Fe.matchCase||(qe+="i"),Fe.multiline&&(qe+="m"),Fe.unicode&&(qe+="u"),new RegExp(re,qe)}e.createRegExp=u;function s(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}e.regExpLeadsToEndlessLoop=s;function h(re){return!!re.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=h;function n(re){return(re.global?"g":"")+(re.ignoreCase?"i":"")+(re.multiline?"m":"")+(re.unicode?"u":"")}e.regExpFlags=n;function S(re){return re.split(/\r\n|\r|\n/)}e.splitLines=S;function a(re){for(let ye=0,Fe=re.length;ye<Fe;ye++){const qe=re.charCodeAt(ye);if(qe!==32&&qe!==9)return ye}return-1}e.firstNonWhitespaceIndex=a;function i(re,ye=0,Fe=re.length){for(let qe=ye;qe<Fe;qe++){const Ve=re.charCodeAt(qe);if(Ve!==32&&Ve!==9)return re.substring(ye,qe)}return re.substring(ye,Fe)}e.getLeadingWhitespace=i;function r(re,ye=re.length-1){for(let Fe=ye;Fe>=0;Fe--){const qe=re.charCodeAt(Fe);if(qe!==32&&qe!==9)return Fe}return-1}e.lastNonWhitespaceIndex=r;function c(re,ye){return re<ye?-1:re>ye?1:0}e.compare=c;function o(re,ye,Fe=0,qe=re.length,Ve=0,ut=ye.length){for(;Fe<qe&&Ve<ut;Fe++,Ve++){let De=re.charCodeAt(Fe),ce=ye.charCodeAt(Ve);if(De<ce)return-1;if(De>ce)return 1}const Re=qe-Fe,Ae=ut-Ve;return Re<Ae?-1:Re>Ae?1:0}e.compareSubstring=o;function d(re,ye){return m(re,ye,0,re.length,0,ye.length)}e.compareIgnoreCase=d;function m(re,ye,Fe=0,qe=re.length,Ve=0,ut=ye.length){for(;Fe<qe&&Ve<ut;Fe++,Ve++){let De=re.charCodeAt(Fe),ce=ye.charCodeAt(Ve);if(De===ce)continue;if(De>=128||ce>=128)return o(re.toLowerCase(),ye.toLowerCase(),Fe,qe,Ve,ut);v(De)&&(De-=32),v(ce)&&(ce-=32);const de=De-ce;if(de!==0)return de}const Re=qe-Fe,Ae=ut-Ve;return Re<Ae?-1:Re>Ae?1:0}e.compareSubstringIgnoreCase=m;function v(re){return re>=97&&re<=122}e.isLowerAsciiLetter=v;function w(re){return re>=65&&re<=90}e.isUpperAsciiLetter=w;function A(re,ye){return re.length===ye.length&&m(re,ye)===0}e.equalsIgnoreCase=A;function M(re,ye){const Fe=ye.length;return ye.length>re.length?!1:m(re,ye,0,Fe)===0}e.startsWithIgnoreCase=M;function T(re,ye){let Fe,qe=Math.min(re.length,ye.length);for(Fe=0;Fe<qe;Fe++)if(re.charCodeAt(Fe)!==ye.charCodeAt(Fe))return Fe;return qe}e.commonPrefixLength=T;function O(re,ye){let Fe,qe=Math.min(re.length,ye.length);const Ve=re.length-1,ut=ye.length-1;for(Fe=0;Fe<qe;Fe++)if(re.charCodeAt(Ve-Fe)!==ye.charCodeAt(ut-Fe))return Fe;return qe}e.commonSuffixLength=O;function U(re){return 55296<=re&&re<=56319}e.isHighSurrogate=U;function V(re){return 56320<=re&&re<=57343}e.isLowSurrogate=V;function x(re,ye){return(re-55296<<10)+(ye-56320)+65536}e.computeCodePoint=x;function N(re,ye,Fe){const qe=re.charCodeAt(Fe);if(U(qe)&&Fe+1<ye){const Ve=re.charCodeAt(Fe+1);if(V(Ve))return x(qe,Ve)}return qe}e.getNextCodePoint=N;function B(re,ye){const Fe=re.charCodeAt(ye-1);if(V(Fe)&&ye>1){const qe=re.charCodeAt(ye-2);if(U(qe))return x(qe,Fe)}return Fe}class W{constructor(ye,Fe=0){this._str=ye,this._len=ye.length,this._offset=Fe}get offset(){return this._offset}setOffset(ye){this._offset=ye}prevCodePoint(){const ye=B(this._str,this._offset);return this._offset-=ye>=65536?2:1,ye}nextCodePoint(){const ye=N(this._str,this._len,this._offset);return this._offset+=ye>=65536?2:1,ye}eol(){return this._offset>=this._len}}e.CodePointIterator=W;class H{constructor(ye,Fe=0){this._iterator=new W(ye,Fe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const ye=tt.getInstance(),Fe=this._iterator,qe=Fe.offset;let Ve=ye.getGraphemeBreakType(Fe.nextCodePoint());for(;!Fe.eol();){const ut=Fe.offset,Re=ye.getGraphemeBreakType(Fe.nextCodePoint());if(st(Ve,Re)){Fe.setOffset(ut);break}Ve=Re}return Fe.offset-qe}prevGraphemeLength(){const ye=tt.getInstance(),Fe=this._iterator,qe=Fe.offset;let Ve=ye.getGraphemeBreakType(Fe.prevCodePoint());for(;Fe.offset>0;){const ut=Fe.offset,Re=ye.getGraphemeBreakType(Fe.prevCodePoint());if(st(Re,Ve)){Fe.setOffset(ut);break}Ve=Re}return qe-Fe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=H;function z(re,ye){return new H(re,ye).nextGraphemeLength()}e.nextCharLength=z;function J(re,ye){return new H(re,ye).prevGraphemeLength()}e.prevCharLength=J;function ie(re,ye){ye>0&&V(re.charCodeAt(ye))&&ye--;const Fe=ye+z(re,ye);return[Fe-J(re,Fe),Fe]}e.getCharContainingOffset=ie;const se=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function K(re){return se.test(re)}e.containsRTL=K;const X=/^[\t\n\r\x20-\x7E]*$/;function ae(re){return X.test(re)}e.isBasicASCII=ae,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function fe(re){return e.UNUSUAL_LINE_TERMINATORS.test(re)}e.containsUnusualLineTerminators=fe;function be(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}e.isFullWidthCharacter=be;function Me(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}e.isEmojiImprecise=Me;function xe(re,ye){if(re.length<ye)return re;const Fe=/\b/g;let qe=0;for(;Fe.test(re)&&!(re.length-Fe.lastIndex<ye);)qe=Fe.lastIndex,Fe.lastIndex+=1;return re.substring(qe).replace(/^\s/,"")}e.lcut=xe;const Ge=/\x1B\x5B[12]?K/g,Je=/\x1b\[\d+m/g,q=/\x1b\[0?m/g;function te(re){return re&&(re=re.replace(Ge,""),re=re.replace(Je,""),re=re.replace(q,"")),re}e.removeAnsiEscapeCodes=te,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function G(re){return!!(re&&re.length>0&&re.charCodeAt(0)===65279)}e.startsWithUTF8BOM=G;function Q(re){return G(re)?re.substr(1):re}e.stripUTF8BOM=Q;function oe(re,ye){if(!re||!ye||re.length<ye.length)return!1;const Fe=ye.length,qe=re.toLowerCase();let Ve=0,ut=-1;for(;Ve<Fe;){const Re=qe.indexOf(ye[Ve],ut+1);if(Re<0)return!1;ut=Re,Ve++}return!0}e.fuzzyContains=oe;function me(re,ye=!1){return re?(ye&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}e.containsUppercaseCharacter=me;function Ie(re){return re.charAt(0).toUpperCase()+re.slice(1)}e.uppercaseFirstLetter=Ie;function We(re,ye=1){if(ye===0)return"";let Fe=-1;do Fe=re.indexOf(`
`,Fe+1),ye--;while(ye>0&&Fe>=0);return Fe===-1?re:(re[Fe-1]==="\r"&&Fe--,re.substr(0,Fe))}e.getNLines=We;function Ye(re){const ye=90-65+1;return re=re%(2*ye),re<ye?String.fromCharCode(97+re):String.fromCharCode(65+re-ye)}e.singleLetterHash=Ye;function it(re){return tt.getInstance().getGraphemeBreakType(re)}e.getGraphemeBreakType=it;function st(re,ye){return re===0?ye!==5&&ye!==7:re===2&&ye===3?!1:re===4||re===2||re===3||ye===4||ye===2||ye===3?!0:!(re===8&&(ye===8||ye===9||ye===11||ye===12)||(re===11||re===9)&&(ye===9||ye===10)||(re===12||re===10)&&ye===10||ye===5||ye===13||ye===7||re===1||re===13&&ye===14||re===6&&ye===6)}var ot;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(ot=e.GraphemeBreakType||(e.GraphemeBreakType={}));class tt{constructor(){this._data=rt()}static getInstance(){return tt._INSTANCE||(tt._INSTANCE=new tt),tt._INSTANCE}getGraphemeBreakType(ye){if(ye<32)return ye===10?3:ye===13?2:4;if(ye<127)return 0;const Fe=this._data,qe=Fe.length/3;let Ve=1;for(;Ve<=qe;)if(ye<Fe[3*Ve])Ve=2*Ve;else if(ye>Fe[3*Ve+1])Ve=2*Ve+1;else return Fe[3*Ve+2];return 0}}tt._INSTANCE=null;function rt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function gt(re,ye){if(re===0)return 0;const Fe=Ue(re,ye);if(Fe!==void 0)return Fe;const qe=new W(ye,re);return qe.prevCodePoint(),qe.offset}e.getLeftDeleteOffset=gt;function Ue(re,ye){const Fe=new W(ye,re);let qe=Fe.prevCodePoint();for(;It(qe)||qe===65039||qe===8419;){if(Fe.offset===0)return;qe=Fe.prevCodePoint()}if(!Me(qe))return;let Ve=Fe.offset;return Ve>0&&Fe.prevCodePoint()===8205&&(Ve=Fe.offset),Ve}function It(re){return 127995<=re&&re<=127999}var ee;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(ee||(ee={})),e.noBreakWhitespace="\xA0";class ne{constructor(ye){this.confusableDictionary=ye}static getInstance(ye){return ne.cache.get(Array.from(ye))}static getLocales(){return ne._locales.getValue()}isAmbiguous(ye){return this.confusableDictionary.has(ye)}getPrimaryConfusable(ye){return this.confusableDictionary.get(ye)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ne,I=ne,ne.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ne.cache=new f.LRUCachedComputed(re=>{function ye(ce){const de=new Map;for(let we=0;we<ce.length;we+=2)de.set(ce[we],ce[we+1]);return de}function Fe(ce,de){const we=new Map(ce);for(const[Ce,Oe]of de)we.set(Ce,Oe);return we}function qe(ce,de){if(!ce)return de;const we=new Map;for(const[Ce,Oe]of ce)de.has(Ce)&&we.set(Ce,Oe);return we}const Ve=I.ambiguousCharacterData.getValue();let ut=re.filter(ce=>!ce.startsWith("_")&&ce in Ve);ut.length===0&&(ut=["_default"]);let Re;for(const ce of ut){const de=ye(Ve[ce]);Re=qe(Re,de)}const Ae=ye(Ve._common),De=Fe(Ae,Re);return new ne(De)}),ne._locales=new t.Lazy(()=>Object.keys(ne.ambiguousCharacterData.getValue()).filter(re=>!re.startsWith("_")));class Se{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Se.getRawData())),this._data}static isInvisibleCharacter(ye){return Se.getData().has(ye)}static get codePoints(){return Se.getData()}}e.InvisibleCharacters=Se,Se._data=void 0}),define(pe[58],ve([0,1,8]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(F){return I(F,0)}e.hash=t;function I(F,D){switch(typeof F){case"object":return F===null?_(349,D):Array.isArray(F)?y(F,D):P(F,D);case"string":return k(F,D);case"boolean":return R(F,D);case"number":return _(F,D);case"undefined":return _(937,D);default:return _(617,D)}}e.doHash=I;function _(F,D){return(D<<5)-D+F|0}e.numberHash=_;function R(F,D){return _(F?433:863,D)}function k(F,D){D=_(149417,D);for(let u=0,s=F.length;u<s;u++)D=_(F.charCodeAt(u),D);return D}e.stringHash=k;function y(F,D){return D=_(104579,D),F.reduce((u,s)=>I(s,u),D)}function P(F,D){return D=_(181387,D),Object.keys(F).sort().reduce((u,s)=>(u=k(s,u),I(F[s],u)),D)}class L{constructor(){this._value=0}get value(){return this._value}hash(D){return this._value=I(D,this._value),this._value}}e.Hasher=L;var C;(function(F){F[F.BLOCK_SIZE=64]="BLOCK_SIZE",F[F.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function l(F,D,u=32){const s=u-D,h=~((1<<s)-1);return(F<<D|(h&F)>>>s)>>>0}function b(F,D=0,u=F.byteLength,s=0){for(let h=0;h<u;h++)F[D+h]=s}function p(F,D,u="0"){for(;F.length<D;)F=u+F;return F}function g(F,D=32){return F instanceof ArrayBuffer?Array.from(new Uint8Array(F)).map(u=>u.toString(16).padStart(2,"0")).join(""):p((F>>>0).toString(16),D/4)}e.toHexString=g;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(D){const u=D.length;if(u===0)return;const s=this._buff;let h=this._buffLen,n=this._leftoverHighSurrogate,S,a;for(n!==0?(S=n,a=-1,n=0):(S=D.charCodeAt(0),a=0);;){let i=S;if(f.isHighSurrogate(S))if(a+1<u){const r=D.charCodeAt(a+1);f.isLowSurrogate(r)?(a++,i=f.computeCodePoint(S,r)):i=65533}else{n=S;break}else f.isLowSurrogate(S)&&(i=65533);if(h=this._push(s,h,i),a++,a<u)S=D.charCodeAt(a);else break}this._buffLen=h,this._leftoverHighSurrogate=n}_push(D,u,s){return s<128?D[u++]=s:s<2048?(D[u++]=192|(s&1984)>>>6,D[u++]=128|(s&63)>>>0):s<65536?(D[u++]=224|(s&61440)>>>12,D[u++]=128|(s&4032)>>>6,D[u++]=128|(s&63)>>>0):(D[u++]=240|(s&1835008)>>>18,D[u++]=128|(s&258048)>>>12,D[u++]=128|(s&4032)>>>6,D[u++]=128|(s&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,D[0]=D[64+0],D[1]=D[64+1],D[2]=D[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,b(this._buff,this._buffLen),this._buffLen>56&&(this._step(),b(this._buff));const D=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(D/4294967296),!1),this._buffDV.setUint32(60,D%4294967296,!1),this._step()}_step(){const D=E._bigBlock32,u=this._buffDV;for(let o=0;o<64;o+=4)D.setUint32(o,u.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)D.setUint32(o,l(D.getUint32(o-12,!1)^D.getUint32(o-32,!1)^D.getUint32(o-56,!1)^D.getUint32(o-64,!1),1),!1);let s=this._h0,h=this._h1,n=this._h2,S=this._h3,a=this._h4,i,r,c;for(let o=0;o<80;o++)o<20?(i=h&n|~h&S,r=1518500249):o<40?(i=h^n^S,r=1859775393):o<60?(i=h&n|h&S|n&S,r=2400959708):(i=h^n^S,r=3395469782),c=l(s,5)+i+a+r+D.getUint32(o*4,!1)&4294967295,a=S,S=n,n=l(h,30),h=s,s=c;this._h0=this._h0+s&4294967295,this._h1=this._h1+h&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+S&4294967295,this._h4=this._h4+a&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[24],ve([0,1,17,8]),function(Z,e,f,t){"use strict";var I,_,R;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(a,i,r){let c=a.get(i);return c===void 0&&(c=r,a.set(i,c)),c}e.getOrSet=k;function y(a){const i=[];return a.forEach((r,c)=>{i.push(`${c} => ${r}`)}),`Map(${a.size}) {${i.join(", ")}}`}e.mapToString=y;function P(a){const i=[];return a.forEach(r=>{i.push(r)}),`Set(${a.size}) {${i.join(", ")}}`}e.setToString=P;class L{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),c=this._value.charCodeAt(this._pos);return r-c}value(){return this._value[this._pos]}}e.StringIterator=L;class C{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class l{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let r=i.length-1;r>=0;r--,this._valueLen--){const c=this._value.charCodeAt(r);if(!(c===47||this._splitOnBackslash&&c===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var b;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(b||(b={}));class p{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(E||(E={}));class F{constructor(i){this._iter=i}static forUris(i=()=>!1){return new F(new p(i))}static forPaths(i=!1){return new F(new l(void 0,!i))}static forStrings(){return new F(new L)}static forConfigKeys(){return new F(new C)}clear(){this._root=void 0}fill(i,r){if(r){const c=r.slice(0);(0,f.shuffle)(c);for(let o of c)this.set(o,i)}else{const c=i.slice(0);(0,f.shuffle)(c);for(let o of c)this.set(o[0],o[1])}}set(i,r){const c=this._iter.reset(i);let o;this._root||(this._root=new g,this._root.segment=c.value());const d=[];for(o=this._root;;){const v=c.cmp(o.segment);if(v>0)o.left||(o.left=new g,o.left.segment=c.value()),d.push([-1,o]),o=o.left;else if(v<0)o.right||(o.right=new g,o.right.segment=c.value()),d.push([1,o]),o=o.right;else if(c.hasNext())c.next(),o.mid||(o.mid=new g,o.mid.segment=c.value()),d.push([0,o]),o=o.mid;else break}const m=o.value;o.value=r,o.key=i;for(let v=d.length-1;v>=0;v--){const w=d[v][1];w.updateHeight();const A=w.balanceFactor();if(A<-1||A>1){const M=d[v][0],T=d[v+1][0];if(M===1&&T===1)d[v][1]=w.rotateLeft();else if(M===-1&&T===-1)d[v][1]=w.rotateRight();else if(M===1&&T===-1)w.right=d[v+1][1]=d[v+1][1].rotateRight(),d[v][1]=w.rotateLeft();else if(M===-1&&T===1)w.left=d[v+1][1]=d[v+1][1].rotateLeft(),d[v][1]=w.rotateRight();else throw new Error;if(v>0)switch(d[v-1][0]){case-1:d[v-1][1].left=d[v][1];break;case 1:d[v-1][1].right=d[v][1];break;case 0:d[v-1][1].mid=d[v][1];break}else this._root=d[0][1]}}return m}get(i){return this._getNode(i)?.value}_getNode(i){const r=this._iter.reset(i);let c=this._root;for(;c;){const o=r.cmp(c.segment);if(o>0)c=c.left;else if(o<0)c=c.right;else if(r.hasNext())r.next(),c=c.mid;else break}return c}has(i){const r=this._getNode(i);return!(r?.value===void 0&&r?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const c=this._iter.reset(i),o=[];let d=this._root;for(;d;){const m=c.cmp(d.segment);if(m>0)o.push([-1,d]),d=d.left;else if(m<0)o.push([1,d]),d=d.right;else if(c.hasNext())c.next(),o.push([0,d]),d=d.mid;else break}if(!!d){if(r?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const m=this._min(d.right),{key:v,value:w,segment:A}=m;this._delete(m.key,!1),d.key=v,d.value=w,d.segment=A}else{const m=d.left??d.right;if(o.length>0){const[v,w]=o[o.length-1];switch(v){case-1:w.left=m;break;case 0:w.mid=m;break;case 1:w.right=m;break}}else this._root=m}for(let m=o.length-1;m>=0;m--){const v=o[m][1];v.updateHeight();const w=v.balanceFactor();if(w>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),o[m][1]=v.rotateLeft()):w<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),o[m][1]=v.rotateRight()),m>0)switch(o[m-1][0]){case-1:o[m-1][1].left=o[m][1];break;case 1:o[m-1][1].right=o[m][1];break;case 0:o[m-1][1].mid=o[m][1];break}else this._root=o[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const r=this._iter.reset(i);let c=this._root,o;for(;c;){const d=r.cmp(c.segment);if(d>0)c=c.left;else if(d<0)c=c.right;else if(r.hasNext())r.next(),o=c.value||o,c=c.mid;else break}return c&&c.value||o}findSuperstr(i){const r=this._iter.reset(i);let c=this._root;for(;c;){const o=r.cmp(c.segment);if(o>0)c=c.left;else if(o<0)c=c.right;else if(r.hasNext())r.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(i){for(const[r,c]of this)i(c,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=r=>{if(!r)return!0;const c=r.balanceFactor();return c<-1||c>1?!1:i(r.left)&&i(r.right)};return i(this._root)}}e.TernarySearchTree=F;class D{constructor(i,r){this.uri=i,this.value=r}}class u{constructor(i,r){this[I]="ResourceMap",i instanceof u?(this.map=new Map(i.map),this.toKey=r??u.defaultToKey):(this.map=new Map,this.toKey=i??u.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),new D(i,r)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r!="undefined"&&(i=i.bind(r));for(let[c,o]of this.map)i(o.value,o.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=u,u.defaultToKey=a=>a.toString();var s;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(s=e.Touch||(e.Touch={}));class h{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,r=0){const c=this._map.get(i);if(!!c)return r!==0&&this.touch(c,r),c.value}set(i,r,c=0){let o=this._map.get(i);if(o)o.value=r,c!==0&&this.touch(o,c);else{switch(o={key:i,value:r,next:void 0,previous:void 0},c){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(i,o),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const c=this._state;let o=this._head;for(;o;){if(r?i.bind(r)(o.value,o.key,this):i(o.value,o.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const i=this,r=this._state;let c=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const d={value:c.key,done:!1};return c=c.next,d}else return{value:void 0,done:!0}}};return o}values(){const i=this,r=this._state;let c=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const d={value:c.value,done:!1};return c=c.next,d}else return{value:void 0,done:!0}}};return o}entries(){const i=this,r=this._state;let c=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const d={value:[c.key,c.value],done:!1};return c=c.next,d}else return{value:void 0,done:!0}}};return o}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,c=this.size;for(;r&&c>i;)this._map.delete(r.key),r=r.next,c--;this._head=r,this._size=c,r&&(r.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,c=i.previous;if(!r||!c)throw new Error("Invalid list");r.previous=c,c.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const c=i.next,o=i.previous;i===this._tail?(o.next=void 0,this._tail=o):(c.previous=o,o.next=c),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const c=i.next,o=i.previous;i===this._head?(c.previous=void 0,this._head=c):(c.previous=o,o.next=c),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,c)=>{i.push([c,r])}),i}fromJSON(i){this.clear();for(const[r,c]of i)this.set(r,c)}}e.LinkedMap=h;class n extends h{constructor(i,r=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=n;class S{constructor(i){R.set(this,void 0),nt(this,R,i,"f")}get size(){return Le(this,R,"f").size}forEach(i,r){Le(this,R,"f").forEach(i,r)}get(i){return Le(this,R,"f").get(i)}has(i){return Le(this,R,"f").has(i)}entries(){return Le(this,R,"f").entries()}keys(){return Le(this,R,"f").keys()}values(){return Le(this,R,"f").values()}[(R=new WeakMap,Symbol.iterator)](){return Le(this,R,"f").entries()}}e.ReadonlyMapView=S}),define(pe[98],ve([0,1,24,8]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...G){return function(Q,oe){for(let me=0,Ie=G.length;me<Ie;me++){const We=G[me](Q,oe);if(We)return We}return null}}e.or=I,e.matchesStrictPrefix=_.bind(void 0,!1),e.matchesPrefix=_.bind(void 0,!0);function _(G,Q,oe){if(!oe||oe.length<Q.length)return null;let me;return G?me=t.startsWithIgnoreCase(oe,Q):me=oe.indexOf(Q)===0,me?Q.length>0?[{start:0,end:Q.length}]:[]:null}function R(G,Q){const oe=Q.toLowerCase().indexOf(G.toLowerCase());return oe===-1?null:[{start:oe,end:oe+G.length}]}e.matchesContiguousSubString=R;function k(G,Q){return y(G.toLowerCase(),Q.toLowerCase(),0,0)}e.matchesSubString=k;function y(G,Q,oe,me){if(oe===G.length)return[];if(me===Q.length)return null;if(G[oe]===Q[me]){let Ie=null;return(Ie=y(G,Q,oe+1,me+1))?F({start:me,end:me+1},Ie):null}return y(G,Q,oe,me+1)}function P(G){return 97<=G&&G<=122}function L(G){return 65<=G&&G<=90}e.isUpper=L;function C(G){return 48<=G&&G<=57}function l(G){return G===32||G===9||G===10||G===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>b.add(G.charCodeAt(0)));function p(G){return l(G)||b.has(G)}function g(G,Q){return G===Q||p(G)&&p(Q)}function E(G){return P(G)||L(G)||C(G)}function F(G,Q){return Q.length===0?Q=[G]:G.end===Q[0].start?Q[0].start=G.start:Q.unshift(G),Q}function D(G,Q){for(let oe=Q;oe<G.length;oe++){const me=G.charCodeAt(oe);if(L(me)||C(me)||oe>0&&!E(G.charCodeAt(oe-1)))return oe}return G.length}function u(G,Q,oe,me){if(oe===G.length)return[];if(me===Q.length)return null;if(G[oe]!==Q[me].toLowerCase())return null;{let Ie=null,We=me+1;for(Ie=u(G,Q,oe+1,me+1);!Ie&&(We=D(Q,We))<Q.length;)Ie=u(G,Q,oe+1,We),We++;return Ie===null?null:F({start:me,end:me+1},Ie)}}function s(G){let Q=0,oe=0,me=0,Ie=0,We=0;for(let tt=0;tt<G.length;tt++)We=G.charCodeAt(tt),L(We)&&Q++,P(We)&&oe++,E(We)&&me++,C(We)&&Ie++;const Ye=Q/G.length,it=oe/G.length,st=me/G.length,ot=Ie/G.length;return{upperPercent:Ye,lowerPercent:it,alphaPercent:st,numericPercent:ot}}function h(G){const{upperPercent:Q,lowerPercent:oe}=G;return oe===0&&Q>.6}function n(G){const{upperPercent:Q,lowerPercent:oe,alphaPercent:me,numericPercent:Ie}=G;return oe>.2&&Q<.8&&me>.6&&Ie<.2}function S(G){let Q=0,oe=0,me=0,Ie=0;for(let We=0;We<G.length;We++)me=G.charCodeAt(We),L(me)&&Q++,P(me)&&oe++,l(me)&&Ie++;return(Q===0||oe===0)&&Ie===0?G.length<=30:Q<=5}function a(G,Q){if(!Q||(Q=Q.trim(),Q.length===0)||!S(G)||Q.length>60)return null;const oe=s(Q);if(!n(oe)){if(!h(oe))return null;Q=Q.toLowerCase()}let me=null,Ie=0;for(G=G.toLowerCase();Ie<Q.length&&(me=u(G,Q,0,Ie))===null;)Ie=D(Q,Ie+1);return me}e.matchesCamelCase=a;function i(G,Q,oe=!1){if(!Q||Q.length===0)return null;let me=null,Ie=0;for(G=G.toLowerCase(),Q=Q.toLowerCase();Ie<Q.length&&(me=r(G,Q,0,Ie,oe))===null;)Ie=c(Q,Ie+1);return me}e.matchesWords=i;function r(G,Q,oe,me,Ie){if(oe===G.length)return[];if(me===Q.length)return null;if(g(G.charCodeAt(oe),Q.charCodeAt(me))){let We=null,Ye=me+1;if(We=r(G,Q,oe+1,me+1,Ie),!Ie)for(;!We&&(Ye=c(Q,Ye))<Q.length;)We=r(G,Q,oe+1,Ye,Ie),Ye++;return We===null?null:F({start:me,end:me+1},We)}else return null}function c(G,Q){for(let oe=Q;oe<G.length;oe++)if(p(G.charCodeAt(oe))||oe>0&&p(G.charCodeAt(oe-1)))return oe;return G.length}const o=I(e.matchesPrefix,a,R),d=I(e.matchesPrefix,a,k),m=new f.LRUCache(1e4);function v(G,Q,oe=!1){if(typeof G!="string"||typeof Q!="string")return null;let me=m.get(G);me||(me=new RegExp(t.convertSimple2RegExpPattern(G),"i"),m.set(G,me));const Ie=me.exec(Q);return Ie?[{start:Ie.index,end:Ie.index+Ie[0].length}]:oe?d(G,Q):o(G,Q)}e.matchesFuzzy=v;function w(G,Q){const oe=be(G,G.toLowerCase(),0,Q,Q.toLowerCase(),0,!0);return oe?M(oe):null}e.matchesFuzzy2=w;function A(G,Q,oe,me,Ie,We){const Ye=Math.min(13,G.length);for(;oe<Ye;oe++){const it=be(G,Q,oe,me,Ie,We,!1);if(it)return it}return[0,We]}e.anyScore=A;function M(G){if(typeof G=="undefined")return[];const Q=[],oe=G[1];for(let me=G.length-1;me>1;me--){const Ie=G[me]+oe,We=Q[Q.length-1];We&&We.end===Ie?We.end=Ie+1:Q.push({start:Ie,end:Ie+1})}return Q}e.createMatches=M;const T=128;function O(){const G=[],Q=[];for(let oe=0;oe<=T;oe++)Q[oe]=0;for(let oe=0;oe<=T;oe++)G.push(Q.slice(0));return G}function U(G){const Q=[];for(let oe=0;oe<=G;oe++)Q[oe]=0;return Q}const V=U(2*T),x=U(2*T),N=O(),B=O(),W=O(),H=!1;function z(G,Q,oe,me,Ie){function We(it,st,ot=" "){for(;it.length<st;)it=ot+it;return it}let Ye=` |   |${me.split("").map(it=>We(it,3)).join("|")}
`;for(let it=0;it<=oe;it++)it===0?Ye+=" |":Ye+=`${Q[it-1]}|`,Ye+=G[it].slice(0,Ie+1).map(st=>We(st.toString(),3)).join("|")+`
`;return Ye}function J(G,Q,oe,me){G=G.substr(Q),oe=oe.substr(me),console.log(z(B,G,G.length,oe,oe.length)),console.log(z(W,G,G.length,oe,oe.length)),console.log(z(N,G,G.length,oe,oe.length))}function ie(G,Q){if(Q<0||Q>=G.length)return!1;const oe=G.codePointAt(Q);switch(oe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(oe)}}function se(G,Q){if(Q<0||Q>=G.length)return!1;switch(G.charCodeAt(Q)){case 32:case 9:return!0;default:return!1}}function K(G,Q,oe){return Q[G]!==oe[G]}function X(G,Q,oe,me,Ie,We,Ye=!1){for(;Q<oe&&Ie<We;)G[Q]===me[Ie]&&(Ye&&(V[Q]=Ie),Q+=1),Ie+=1;return Q===oe}e.isPatternInWord=X;var ae;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(ae||(ae={}));var fe;(function(G){G.Default=[-100,0];function Q(oe){return!oe||oe.length===2&&oe[0]===-100&&oe[1]===0}G.isDefault=Q})(fe=e.FuzzyScore||(e.FuzzyScore={}));function be(G,Q,oe,me,Ie,We,Ye){const it=G.length>T?T:G.length,st=me.length>T?T:me.length;if(oe>=it||We>=st||it-oe>st-We||!X(Q,oe,it,Ie,We,st,!0))return;Me(it,st,oe,We,Q,Ie);let ot=1,tt=1,rt=oe,gt=We;const Ue=[!1];for(ot=1,rt=oe;rt<it;ot++,rt++){const re=V[rt],ye=x[rt],Fe=rt+1<it?x[rt+1]:st;for(tt=re-We+1,gt=re;gt<Fe;tt++,gt++){let qe=Number.MIN_SAFE_INTEGER,Ve=!1;gt<=ye&&(qe=xe(G,Q,rt,oe,me,Ie,gt,st,We,N[ot-1][tt-1]===0,Ue));let ut=0;qe!==Number.MAX_SAFE_INTEGER&&(Ve=!0,ut=qe+B[ot-1][tt-1]);const Re=gt>re,Ae=Re?B[ot][tt-1]+(N[ot][tt-1]>0?-5:0):0,De=gt>re+1&&N[ot][tt-1]>0,ce=De?B[ot][tt-2]+(N[ot][tt-2]>0?-5:0):0;if(De&&(!Re||ce>=Ae)&&(!Ve||ce>=ut))B[ot][tt]=ce,W[ot][tt]=3,N[ot][tt]=0;else if(Re&&(!Ve||Ae>=ut))B[ot][tt]=Ae,W[ot][tt]=2,N[ot][tt]=0;else if(Ve)B[ot][tt]=ut,W[ot][tt]=1,N[ot][tt]=N[ot-1][tt-1]+1;else throw new Error("not possible")}}if(H&&J(G,oe,me,We),!Ue[0]&&!Ye)return;ot--,tt--;const It=[B[ot][tt],We];let ee=0,ne=0;for(;ot>=1;){let re=tt;do{const ye=W[ot][re];if(ye===3)re=re-2;else if(ye===2)re=re-1;else break}while(re>=1);ee>1&&Q[oe+ot-1]===Ie[We+tt-1]&&!K(re+We-1,me,Ie)&&ee+1>N[ot][re]&&(re=tt),re===tt?ee++:ee=1,ne||(ne=re),ot--,tt=re-1,It.push(tt)}st===it&&(It[0]+=2);const Se=ne-it;return It[0]-=Se,It}e.fuzzyScore=be;function Me(G,Q,oe,me,Ie,We){let Ye=G-1,it=Q-1;for(;Ye>=oe&&it>=me;)Ie[Ye]===We[it]&&(x[Ye]=it,Ye--),it--}function xe(G,Q,oe,me,Ie,We,Ye,it,st,ot,tt){if(Q[oe]!==We[Ye])return Number.MIN_SAFE_INTEGER;let rt=1,gt=!1;return Ye===oe-me?rt=G[oe]===Ie[Ye]?7:5:K(Ye,Ie,We)&&(Ye===0||!K(Ye-1,Ie,We))?(rt=G[oe]===Ie[Ye]?7:5,gt=!0):ie(We,Ye)&&(Ye===0||!ie(We,Ye-1))?rt=5:(ie(We,Ye-1)||se(We,Ye-1))&&(rt=5,gt=!0),rt>1&&oe===me&&(tt[0]=!0),gt||(gt=K(Ye,Ie,We)||ie(We,Ye-1)||se(We,Ye-1)),oe===me?Ye>st&&(rt-=gt?3:5):ot?rt+=gt?2:0:rt+=gt?0:1,Ye+1===it&&(rt-=gt?3:5),rt}function Ge(G,Q,oe,me,Ie,We,Ye){return q(G,Q,oe,me,Ie,We,!0,Ye)}e.fuzzyScoreGracefulAggressive=Ge;function Je(G,Q,oe,me,Ie,We,Ye){return q(G,Q,oe,me,Ie,We,!1,Ye)}e.fuzzyScoreGraceful=Je;function q(G,Q,oe,me,Ie,We,Ye,it){let st=be(G,Q,oe,me,Ie,We,it);if(st&&!Ye)return st;if(G.length>=3){const ot=Math.min(7,G.length-1);for(let tt=oe+1;tt<ot;tt++){const rt=te(G,tt);if(rt){const gt=be(rt,rt.toLowerCase(),oe,me,Ie,We,it);gt&&(gt[0]-=3,(!st||gt[0]>st[0])&&(st=gt))}}}return st}function te(G,Q){if(Q+1>=G.length)return;const oe=G[Q],me=G[Q+1];if(oe!==me)return G.slice(0,Q)+me+oe+G.slice(Q+2)}}),define(pe[143],ve([0,1,74,98,8]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const _=new RegExp(`\\$\\(${f.CSSIcon.iconNameExpression}(?:${f.CSSIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(f.CSSIcon.iconNameCharacter),k=new RegExp(`(\\\\)?${_.source}`,"g");function y(E){return E.replace(k,(F,D)=>D?F:`\\${F}`)}e.escapeIcons=y;const P=new RegExp(`\\\\${_.source}`,"g");function L(E){return E.replace(P,F=>`\\${F}`)}e.markdownEscapeEscapedIcons=L;const C=new RegExp(`(\\s)?(\\\\)?${_.source}(\\s)?`,"g");function l(E){return E.indexOf(e.iconStartMarker)===-1?E:E.replace(C,(F,D,u,s)=>u?F:D||s||"")}e.stripIcons=l;function b(E){const F=E.indexOf(e.iconStartMarker);return F===-1?{text:E}:p(E,F)}e.parseLabelWithIcons=b;function p(E,F){const D=[];let u="";function s(o){if(o){u+=o;for(const d of o)D.push(S)}}let h=-1,n="",S=0,a,i,r=F;const c=E.length;for(s(E.substr(0,F));r<c;)a=E[r],i=E[r+1],a===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(h=r,s(n),n=e.iconStartMarker,r++):a===")"&&h!==-1?(S+=r-h+1,h=-1,n=""):h!==-1?R.test(a)?n+=a:(s(n),h=-1,n=""):s(a),r++;return s(n),{text:u,iconOffsets:D}}function g(E,F,D=!1){const{text:u,iconOffsets:s}=F;if(!s||s.length===0)return(0,t.matchesFuzzy)(E,u,D);const h=(0,I.ltrim)(u," "),n=u.length-h.length,S=(0,t.matchesFuzzy)(E,h,D);if(S)for(const a of S){const i=s[a.start+n]+n;a.start+=i,a.end+=i}return S}e.matchesFuzzyIconAware=g}),define(pe[99],ve([0,1,16,143]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(I=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class _{constructor(b="",p=!1){if(this.value=b,typeof this.value!="string")throw(0,f.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(b,p=0){return this.value+=P(this.supportThemeIcons?(0,t.escapeIcons)(b):b).replace(/([ \t]+)/g,(g,E)=>"&nbsp;".repeat(E.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(b){return this.value+=b,this}appendCodeblock(b,p){return this.value+="\n```",this.value+=b,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}}e.MarkdownString=_;function R(l){return k(l)?!l.value:Array.isArray(l)?l.every(R):!0}e.isEmptyMarkdownString=R;function k(l){return l instanceof _?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function y(l,b){return l===b?!0:!l||!b?!1:l.value===b.value&&l.isTrusted===b.isTrusted&&l.supportThemeIcons===b.supportThemeIcons}e.markdownStringEqual=y;function P(l){return l.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function L(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=L;function C(l){const b=[],p=l.split("|").map(E=>E.trim());l=p[0];const g=p[1];if(g){const E=/height=(\d+)/.exec(g),F=/width=(\d+)/.exec(g),D=E?E[1]:"",u=F?F[1]:"",s=isFinite(parseInt(u)),h=isFinite(parseInt(D));s&&b.push(`width="${u}"`),h&&b.push(`height="${D}"`)}return{href:l,dimensions:b}}e.parseHrefAndDimensions=C}),define(pe[79],ve([0,1,24]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new f.LRUCache(1e4);function I(P){return y(P,"NFC",t)}e.normalizeNFC=I;const _=new f.LRUCache(1e4);function R(P){return y(P,"NFD",_)}e.normalizeNFD=R;const k=/[^\u0000-\u0080]/;function y(P,L,C){if(!P)return P;const l=C.get(P);if(l)return l;let b;return k.test(P)?b=P.normalize(L):b=P,C.set(P,b),b}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(L){return R(L).replace(P,"")}}()}),define(pe[47],ve([0,1,8]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(t||(t={})),function(I){const _="error",R="warning",k="warn",y="info",P="ignore";function L(l){return l?f.equalsIgnoreCase(_,l)?I.Error:f.equalsIgnoreCase(R,l)||f.equalsIgnoreCase(k,l)?I.Warning:f.equalsIgnoreCase(y,l)?I.Info:I.Ignore:I.Ignore}I.fromValue=L;function C(l){switch(l){case I.Error:return _;case I.Warning:return R;case I.Info:return y;default:return P}}I.toString=C}(t||(t={})),e.default=t}),define(pe[18],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function f(c){return Array.isArray(c)}e.isArray=f;function t(c){return typeof c=="string"}e.isString=t;function I(c){return Array.isArray(c)&&c.every(o=>t(o))}e.isStringArray=I;function _(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=_;function R(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=R;function k(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=k;function y(c){return c===!0||c===!1}e.isBoolean=y;function P(c){return typeof c=="undefined"}e.isUndefined=P;function L(c){return!C(c)}e.isDefined=L;function C(c){return P(c)||c===null}e.isUndefinedOrNull=C;function l(c,o){if(!c)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}e.assertType=l;function b(c){if(C(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=b;function p(...c){const o=[];for(let d=0;d<c.length;d++){const m=c[d];if(C(m))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);o.push(m)}return o}e.assertAllDefined=p;const g=Object.prototype.hasOwnProperty;function E(c){if(!_(c))return!1;for(let o in c)if(g.call(c,o))return!1;return!0}e.isEmptyObject=E;function F(c){return typeof c=="function"}e.isFunction=F;function D(...c){return c.length>0&&c.every(F)}e.areFunctions=D;function u(c,o){const d=Math.min(c.length,o.length);for(let m=0;m<d;m++)s(c[m],o[m])}e.validateConstraints=u;function s(c,o){if(t(o)){if(typeof c!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(F(o)){try{if(c instanceof o)return}catch{}if(!C(c)&&c.constructor===o||o.length===1&&o.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=s;function h(c){let o=[],d=Object.getPrototypeOf(c);for(;Object.prototype!==d;)o=o.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return o}e.getAllPropertyNames=h;function n(c){const o=[];for(const d of h(c))typeof c[d]=="function"&&o.push(d);return o}e.getAllMethodNames=n;function S(c,o){const d=v=>function(){const w=Array.prototype.slice.call(arguments,0);return o(v,w)};let m={};for(const v of c)m[v]=d(v);return m}e.createProxyObject=S;function a(c){return c===null?void 0:c}e.withNullAsUndefined=a;function i(c){return typeof c=="undefined"?null:c}e.withUndefinedAsNull=i;function r(c,o="Unreachable"){throw new Error(o)}e.assertNever=r}),define(pe[29],ve([0,1,9,12,8,18]),function(Z,e,f,t,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(r){return r===47||r===92}e.isPathSeparator=R;function k(r){return r.replace(/[\\/]/g,f.posix.sep)}e.toSlashes=k;function y(r){return r.indexOf("/")===-1&&(r=k(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=y;function P(r,c=f.posix.sep){if(!r)return"";const o=r.length,d=r.charCodeAt(0);if(R(d)){if(R(r.charCodeAt(1))&&!R(r.charCodeAt(2))){let v=3;const w=v;for(;v<o&&!R(r.charCodeAt(v));v++);if(w!==v&&!R(r.charCodeAt(v+1))){for(v+=1;v<o;v++)if(R(r.charCodeAt(v)))return r.slice(0,v+1).replace(/[\\/]/g,c)}}return c}else if(F(d)&&r.charCodeAt(1)===58)return R(r.charCodeAt(2))?r.slice(0,2)+c:r.slice(0,2);let m=r.indexOf("://");if(m!==-1){for(m+=3;m<o;m++)if(R(r.charCodeAt(m)))return r.slice(0,m+1)}return""}e.getRoot=P;function L(r){if(!t.isWindows||!r||r.length<5)return!1;let c=r.charCodeAt(0);if(c!==92||(c=r.charCodeAt(1),c!==92))return!1;let o=2;const d=o;for(;o<r.length&&(c=r.charCodeAt(o),c!==92);o++);return!(d===o||(c=r.charCodeAt(o+1),isNaN(c)||c===92))}e.isUNC=L;const C=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(r,c=t.isWindows){const o=c?C:l;return!(!r||r.length===0||/^\s+$/.test(r)||(o.lastIndex=0,o.test(r))||c&&b.test(r)||r==="."||r===".."||c&&r[r.length-1]==="."||c&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=p;function g(r,c,o){const d=r===c;return!o||d?d:!r||!c?!1:(0,I.equalsIgnoreCase)(r,c)}e.isEqual=g;function E(r,c,o,d=f.sep){if(r===c)return!0;if(!r||!c||c.length>r.length)return!1;if(o){if(!(0,I.startsWithIgnoreCase)(r,c))return!1;if(c.length===r.length)return!0;let v=c.length;return c.charAt(c.length-1)===d&&v--,r.charAt(v)===d}return c.charAt(c.length-1)!==d&&(c+=d),r.indexOf(c)===0}e.isEqualOrParent=E;function F(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=F;function D(r,c){return t.isWindows&&r.endsWith(":")&&(r+=f.sep),(0,f.isAbsolute)(r)||(r=(0,f.join)(c,r)),r=(0,f.normalize)(r),t.isWindows?(r=(0,I.rtrim)(r,f.sep),r.endsWith(":")&&(r+=f.sep)):(r=(0,I.rtrim)(r,f.sep),r||(r=f.sep)),r}e.sanitizeFilePath=D;function u(r){const c=(0,f.normalize)(r);return t.isWindows?r.length>3?!1:s(c)&&(r.length===2||c.charCodeAt(2)===92):c===f.posix.sep}e.isRootOrDriveLetter=u;function s(r,c){return(c!==void 0?c:t.isWindows)?F(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=s;function h(r){return s(r)?r[0]:void 0}e.getDriveLetter=h;function n(r,c,o){return c.length>r.length?-1:r===c?0:(o&&(r=r.toLowerCase(),c=c.toLowerCase()),r.indexOf(c))}e.indexOfPath=n;function S(r){const c=r.split(":");let o,d,m;for(const v of c){const w=Number(v);(0,_.isNumber)(w)?d===void 0?d=w:m===void 0&&(m=w):o=o?[o,v].join(":"):v}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:d!==void 0?d:void 0,column:m!==void 0?m:d!==void 0?1:void 0}}e.parseLineAndColumnAware=S;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(r,c,o=8){let d="";for(let v=0;v<o;v++)d+=a.charAt(Math.floor(Math.random()*a.length));let m;return c?m=`${c}-${d}`:m=d,r?(0,f.join)(r,m):m}e.randomPath=i}),define(pe[25],ve([0,1,18]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const E=Array.isArray(g)?[]:{};return Object.keys(g).forEach(F=>{g[F]&&typeof g[F]=="object"?E[F]=t(g[F]):E[F]=g[F]}),E}e.deepClone=t;function I(g){if(!g||typeof g!="object")return g;const E=[g];for(;E.length>0;){const F=E.shift();Object.freeze(F);for(const D in F)if(_.call(F,D)){const u=F[D];typeof u=="object"&&!Object.isFrozen(u)&&E.push(u)}}return g}e.deepFreeze=I;const _=Object.prototype.hasOwnProperty;function R(g,E){return k(g,E,new Set)}e.cloneAndChange=R;function k(g,E,F){if((0,f.isUndefinedOrNull)(g))return g;const D=E(g);if(typeof D!="undefined")return D;if((0,f.isArray)(g)){const u=[];for(const s of g)u.push(k(s,E,F));return u}if((0,f.isObject)(g)){if(F.has(g))throw new Error("Cannot clone recursive data-structure");F.add(g);const u={};for(let s in g)_.call(g,s)&&(u[s]=k(g[s],E,F));return F.delete(g),u}return g}function y(g,E,F=!0){return(0,f.isObject)(g)?((0,f.isObject)(E)&&Object.keys(E).forEach(D=>{D in g?F&&((0,f.isObject)(g[D])&&(0,f.isObject)(E[D])?y(g[D],E[D],F):g[D]=E[D]):g[D]=E[D]}),g):E}e.mixin=y;function P(g,E){if(g===E)return!0;if(g==null||E===null||E===void 0||typeof g!=typeof E||typeof g!="object"||Array.isArray(g)!==Array.isArray(E))return!1;let F,D;if(Array.isArray(g)){if(g.length!==E.length)return!1;for(F=0;F<g.length;F++)if(!P(g[F],E[F]))return!1}else{const u=[];for(D in g)u.push(D);u.sort();const s=[];for(D in E)s.push(D);if(s.sort(),!P(u,s))return!1;for(F=0;F<u.length;F++)if(!P(g[u[F]],E[u[F]]))return!1}return!0}e.equals=P;function L(g){const E=new Set;return JSON.stringify(g,(F,D)=>{if((0,f.isObject)(D)||Array.isArray(D)){if(E.has(D))return"[Circular]";E.add(D)}return D})}e.safeStringify=L;function C(g,E,F){const D=E(g);return typeof D=="undefined"?F:D}e.getOrDefault=C;function l(g,E){const F=Object.create(null);return!g||!E||Object.keys(E).forEach(u=>{const s=g[u],h=E[u];P(s,h)||(F[u]=h)}),F}e.distinct=l;function b(g,E){const F=E.toLowerCase(),D=Object.keys(g).find(u=>u.toLowerCase()===F);return D?g[D]:g[E]}e.getCaseInsensitive=b;function p(g,E){const F=Object.create(null);for(const[D,u]of Object.entries(g))E(D,u)&&(F[D]=u);return F}e.filter=p}),define(pe[100],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var f;(function(_){_[_.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",_[_.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",_[_.MAX_UINT_8=255]="MAX_UINT_8",_[_.MAX_UINT_16=65535]="MAX_UINT_16",_[_.MAX_UINT_32=4294967295]="MAX_UINT_32",_[_.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(f=e.Constants||(e.Constants={}));function t(_){return _<0?0:_>255?255:_|0}e.toUint8=t;function I(_){return _<0?0:_>4294967295?4294967295:_|0}e.toUint32=I}),define(pe[2],ve([0,1,9,12]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,_=/^\//,R=/^\/\//;function k(a,i){if(!a.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!I.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!_.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(a,i){return!a&&!i?"file":a}function P(a,i){switch(a){case"https":case"http":case"file":i?i[0]!==C&&(i=C+i):i=C;break}return i}const L="",C="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(i,r,c,o,d,m=!1){typeof i=="object"?(this.scheme=i.scheme||L,this.authority=i.authority||L,this.path=i.path||L,this.query=i.query||L,this.fragment=i.fragment||L):(this.scheme=y(i,m),this.authority=r||L,this.path=P(this.scheme,c||L),this.query=o||L,this.fragment=d||L,k(this,m))}static isUri(i){return i instanceof b?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return u(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:c,path:o,query:d,fragment:m}=i;return r===void 0?r=this.scheme:r===null&&(r=L),c===void 0?c=this.authority:c===null&&(c=L),o===void 0?o=this.path:o===null&&(o=L),d===void 0?d=this.query:d===null&&(d=L),m===void 0?m=this.fragment:m===null&&(m=L),r===this.scheme&&c===this.authority&&o===this.path&&d===this.query&&m===this.fragment?this:new g(r,c,o,d,m)}static parse(i,r=!1){const c=l.exec(i);return c?new g(c[2]||L,S(c[4]||L),S(c[5]||L),S(c[7]||L),S(c[9]||L),r):new g(L,L,L,L,L)}static file(i){let r=L;if(t.isWindows&&(i=i.replace(/\\/g,C)),i[0]===C&&i[1]===C){const c=i.indexOf(C,2);c===-1?(r=i.substring(2),i=C):(r=i.substring(2,c),i=i.substring(c)||C)}return new g("file",r,i,L,L)}static from(i){const r=new g(i.scheme,i.authority,i.path,i.query,i.fragment);return k(r,!0),r}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return t.isWindows&&i.scheme==="file"?c=b.file(f.win32.join(u(i,!0),...r)).path:c=f.posix.join(i.path,...r),i.with({path:c})}toString(i=!1){return s(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof b)return i;{const r=new g(i);return r._formatted=i.external,r._fsPath=i._sep===p?i.fsPath:null,r}}else return i}}e.URI=b;const p=t.isWindows?1:void 0;class g extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(i=!1){return i?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=p),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function F(a,i){let r,c=-1;for(let o=0;o<a.length;o++){const d=a.charCodeAt(o);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||i&&d===47)c!==-1&&(r+=encodeURIComponent(a.substring(c,o)),c=-1),r!==void 0&&(r+=a.charAt(o));else{r===void 0&&(r=a.substr(0,o));const m=E[d];m!==void 0?(c!==-1&&(r+=encodeURIComponent(a.substring(c,o)),c=-1),r+=m):c===-1&&(c=o)}}return c!==-1&&(r+=encodeURIComponent(a.substring(c))),r!==void 0?r:a}function D(a){let i;for(let r=0;r<a.length;r++){const c=a.charCodeAt(r);c===35||c===63?(i===void 0&&(i=a.substr(0,r)),i+=E[c]):i!==void 0&&(i+=a[r])}return i!==void 0?i:a}function u(a,i){let r;return a.authority&&a.path.length>1&&a.scheme==="file"?r=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?i?r=a.path.substr(1):r=a.path[1].toLowerCase()+a.path.substr(2):r=a.path,t.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=u;function s(a,i){const r=i?D:F;let c="",{scheme:o,authority:d,path:m,query:v,fragment:w}=a;if(o&&(c+=o,c+=":"),(d||o==="file")&&(c+=C,c+=C),d){let A=d.indexOf("@");if(A!==-1){const M=d.substr(0,A);d=d.substr(A+1),A=M.indexOf(":"),A===-1?c+=r(M,!1):(c+=r(M.substr(0,A),!1),c+=":",c+=r(M.substr(A+1),!1)),c+="@"}d=d.toLowerCase(),A=d.indexOf(":"),A===-1?c+=r(d,!1):(c+=r(d.substr(0,A),!1),c+=d.substr(A))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const A=m.charCodeAt(1);A>=65&&A<=90&&(m=`/${String.fromCharCode(A+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const A=m.charCodeAt(0);A>=65&&A<=90&&(m=`${String.fromCharCode(A+32)}:${m.substr(2)}`)}c+=r(m,!0)}return v&&(c+="?",c+=r(v,!1)),w&&(c+="#",c+=i?w:F(w,!1)),c}function h(a){try{return decodeURIComponent(a)}catch{return a.length>3?a.substr(0,3)+h(a.substr(3)):a}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function S(a){return a.match(n)?a.replace(n,i=>h(i)):a}}),define(pe[59],ve([0,1,22,8,2]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function _(L){return JSON.stringify(L,y)}e.stringify=_;function R(L){let C=JSON.parse(L);return C=P(C),C}e.parse=R;var k;(function(L){L[L.Uri=1]="Uri",L[L.Regexp=2]="Regexp",L[L.ScmResource=3]="ScmResource",L[L.ScmResourceGroup=4]="ScmResourceGroup",L[L.ScmProvider=5]="ScmProvider",L[L.CommentController=6]="CommentController",L[L.CommentThread=7]="CommentThread",L[L.CommentThreadReply=8]="CommentThreadReply",L[L.CommentNode=9]="CommentNode",L[L.CommentThreadNode=10]="CommentThreadNode",L[L.TimelineActionContext=11]="TimelineActionContext",L[L.NotebookCellActionContext=12]="NotebookCellActionContext",L[L.TestItemContext=13]="TestItemContext",L[L.Date=14]="Date"})(k=e.MarshalledId||(e.MarshalledId={}));function y(L,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,t.regExpFlags)(C)}:C}function P(L,C=0){if(!L||C>200)return L;if(typeof L=="object"){switch(L.$mid){case 1:return I.URI.revive(L);case 2:return new RegExp(L.source,L.flags);case 14:return new Date(L.source)}if(L instanceof f.VSBuffer||L instanceof Uint8Array)return L;if(Array.isArray(L))for(let l=0;l<L.length;++l)L[l]=P(L[l],C+1);else for(const l in L)Object.hasOwnProperty.call(L,l)&&(L[l]=P(L[l],C+1))}return L}e.revive=P}),define(pe[10],ve([0,1,12,2]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var I;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls"})(I=e.Schemas||(e.Schemas={}));class _{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,P,L){this._hosts[y]=P,this._ports[y]=L}setConnectionToken(y,P){this._connectionTokens[y]=P}rewrite(y){if(this._delegate)return this._delegate(y);const P=y.authority;let L=this._hosts[P];L&&L.indexOf(":")!==-1&&(L=`[${L}]`);const C=this._ports[P],l=this._connectionTokens[P];let b=`path=${encodeURIComponent(y.path)}`;return typeof l=="string"&&(b+=`&tkn=${encodeURIComponent(l)}`),t.URI.from({scheme:f.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${L}:${C}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new _;class R{asBrowserUri(y,P){const L=this.toUri(y,P);return L.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===I.file&&(f.isNative||typeof f.globals.importScripts=="function"&&f.globals.origin===`${I.vscodeFileResource}://${R.FALLBACK_AUTHORITY}`)?L.with({scheme:I.vscodeFileResource,authority:L.authority||R.FALLBACK_AUTHORITY,query:null,fragment:null}):L}asFileUri(y,P){const L=this.toUri(y,P);return L.scheme===I.vscodeFileResource?L.with({scheme:I.file,authority:L.authority!==R.FALLBACK_AUTHORITY?L.authority:null,query:null,fragment:null}):L}toUri(y,P){return t.URI.isUri(y)?y:t.URI.parse(P.toUrl(y))}}R.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new R}),define(pe[23],ve([0,1,29,10,9,12,8,2]),function(Z,e,f,t,I,_,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(b){return(0,k.uriToFsPath)(b,!0)}e.originalFSPath=y;class P{constructor(p){this._ignorePathCasing=p}compare(p,g,E=!1){return p===g?0:(0,R.compare)(this.getComparisonKey(p,E),this.getComparisonKey(g,E))}isEqual(p,g,E=!1){return p===g?!0:!p||!g?!1:this.getComparisonKey(p,E)===this.getComparisonKey(g,E)}getComparisonKey(p,g=!1){return p.with({path:this._ignorePathCasing(p)?p.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(p){return this._ignorePathCasing(p)}isEqualOrParent(p,g,E=!1){if(p.scheme===g.scheme){if(p.scheme===t.Schemas.file)return f.isEqualOrParent(y(p),y(g),this._ignorePathCasing(p))&&p.query===g.query&&(E||p.fragment===g.fragment);if((0,e.isEqualAuthority)(p.authority,g.authority))return f.isEqualOrParent(p.path,g.path,this._ignorePathCasing(p),"/")&&p.query===g.query&&(E||p.fragment===g.fragment)}return!1}joinPath(p,...g){return k.URI.joinPath(p,...g)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return I.posix.basename(p.path)}extname(p){return I.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let g;return p.scheme===t.Schemas.file?g=k.URI.file(I.dirname(y(p))).path:(g=I.posix.dirname(p.path),p.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),g="/")),p.with({path:g})}normalizePath(p){if(!p.path.length)return p;let g;return p.scheme===t.Schemas.file?g=k.URI.file(I.normalize(y(p))).path:g=I.posix.normalize(p.path),p.with({path:g})}relativePath(p,g){if(p.scheme!==g.scheme||!(0,e.isEqualAuthority)(p.authority,g.authority))return;if(p.scheme===t.Schemas.file){const D=I.relative(y(p),y(g));return _.isWindows?f.toSlashes(D):D}let E=p.path||"/",F=g.path||"/";if(this._ignorePathCasing(p)){let D=0;for(const u=Math.min(E.length,F.length);D<u&&!(E.charCodeAt(D)!==F.charCodeAt(D)&&E.charAt(D).toLowerCase()!==F.charAt(D).toLowerCase());D++);E=F.substr(0,D)+E.substr(D)}return I.posix.relative(E,F)}resolvePath(p,g){if(p.scheme===t.Schemas.file){const E=k.URI.file(I.resolve(y(p),g));return p.with({authority:E.authority,path:E.path})}return g=f.toPosixPath(g),p.with({path:I.posix.resolve(p.path,g)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,g){return p===g||p!==void 0&&g!==void 0&&(0,R.equalsIgnoreCase)(p,g)}hasTrailingPathSeparator(p,g=I.sep){if(p.scheme===t.Schemas.file){const E=y(p);return E.length>f.getRoot(E).length&&E[E.length-1]===g}else{const E=p.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,g=I.sep){return(0,e.hasTrailingPathSeparator)(p,g)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,g=I.sep){let E=!1;if(p.scheme===t.Schemas.file){const F=y(p);E=F!==void 0&&F.length===f.getRoot(F).length&&F[F.length-1]===g}else{g="/";const F=p.path;E=F.length===1&&F.charCodeAt(F.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(p,g)?p.with({path:p.path+"/"}):p}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(b=>b.scheme===t.Schemas.file?!_.isLinux:!0),e.extUriIgnorePathCase=new P(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(b,p){const g=[];for(let E=0;E<b.length;E++){const F=p(b[E]);b.some((D,u)=>u===E?!1:(0,e.isEqualOrParent)(F,p(D)))||g.push(b[E])}return g}e.distinctParents=L;var C;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function p(g){const E=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(u=>{const[s,h]=u.split(":");s&&h&&E.set(s,h)});const D=g.path.substring(0,g.path.indexOf(";"));return D&&E.set(b.META_DATA_MIME,D),E}b.parseMetaData=p})(C=e.DataUri||(e.DataUri={}));function l(b,p,g){if(p){let E=b.path;return E&&E[0]!==I.posix.sep&&(E=I.posix.sep+E),b.with({scheme:g,authority:p,path:E})}return b.with({scheme:g})}e.toLocalResource=l}),define(pe[13],ve([0,1,21,16,3,6,23,12]),function(Z,e,f,t,I,_,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(K){return!!K&&typeof K.then=="function"}e.isThenable=y;function P(K){const X=new f.CancellationTokenSource,ae=K(X.token),fe=new Promise((be,Me)=>{const xe=X.token.onCancellationRequested(()=>{xe.dispose(),X.dispose(),Me(new t.CancellationError)});Promise.resolve(ae).then(Ge=>{xe.dispose(),X.dispose(),be(Ge)},Ge=>{xe.dispose(),X.dispose(),Me(Ge)})});return new class{cancel(){X.cancel()}then(be,Me){return fe.then(be,Me)}catch(be){return this.then(void 0,be)}finally(be){return fe.finally(be)}}}e.createCancelablePromise=P;function L(K,X,ae){return new Promise((fe,be)=>{const Me=X.onCancellationRequested(()=>{Me.dispose(),fe(ae)});K.then(fe,be).finally(()=>Me.dispose())})}e.raceCancellation=L;function C(K,X){return new Promise((ae,fe)=>{const be=X.onCancellationRequested(()=>{be.dispose(),fe(new t.CancellationError)});K.then(ae,fe).finally(()=>be.dispose())})}e.raceCancellationError=C;async function l(K){let X=-1;const ae=K.map((be,Me)=>be.then(xe=>(X=Me,xe))),fe=await Promise.race(ae);return K.forEach((be,Me)=>{Me!==X&&be.cancel()}),fe}e.raceCancellablePromises=l;function b(K,X,ae){let fe;const be=setTimeout(()=>{fe?.(void 0),ae?.()},X);return Promise.race([K.finally(()=>clearTimeout(be)),new Promise(Me=>fe=Me)])}e.raceTimeout=b;function p(K){return new Promise((X,ae)=>{const fe=K();y(fe)?fe.then(X,ae):X(fe)})}e.asPromise=p;class g{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(X){if(this.activePromise){if(this.queuedPromiseFactory=X,!this.queuedPromise){const ae=()=>{this.queuedPromise=null;const fe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,fe};this.queuedPromise=new Promise(fe=>{this.activePromise.then(ae,ae).then(fe)})}return new Promise((ae,fe)=>{this.queuedPromise.then(ae,fe)})}return this.activePromise=X(),new Promise((ae,fe)=>{this.activePromise.then(be=>{this.activePromise=null,ae(be)},be=>{this.activePromise=null,fe(be)})})}}e.Throttler=g;class E{constructor(){this.current=Promise.resolve(null)}queue(X){return this.current=this.current.then(()=>X(),()=>X())}}e.Sequencer=E;class F{constructor(){this.promiseMap=new Map}queue(X,ae){const be=(this.promiseMap.get(X)??Promise.resolve()).catch(()=>{}).then(ae).finally(()=>{this.promiseMap.get(X)===be&&this.promiseMap.delete(X)});return this.promiseMap.set(X,be),be}}e.SequencerByKey=F;const D=(K,X)=>{let ae=!0;const fe=setTimeout(()=>{ae=!1,X()},K);return{isTriggered:()=>ae,dispose:()=>{clearTimeout(fe),ae=!1}}},u=K=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,K())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class s{constructor(X){this.defaultDelay=X,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(X,ae=this.defaultDelay){this.task=X,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((be,Me)=>{this.doResolve=be,this.doReject=Me}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const be=this.task;return this.task=null,be()}}));const fe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ae===e.MicrotaskDelay?u(fe):D(ae,fe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=s;class h{constructor(X){this.delayer=new s(X),this.throttler=new g}trigger(X,ae){return this.delayer.trigger(()=>this.throttler.queue(X),ae)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=h;class n{constructor(){this._isOpen=!1,this._promise=new Promise((X,ae)=>{this._completePromise=X})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class S extends n{constructor(X){super();this._timeout=setTimeout(()=>this.open(),X)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=S;function a(K,X){return X?new Promise((ae,fe)=>{const be=setTimeout(()=>{Me.dispose(),ae()},K),Me=X.onCancellationRequested(()=>{clearTimeout(be),Me.dispose(),fe(new t.CancellationError)})}):P(ae=>a(K,ae))}e.timeout=a;function i(K,X=0){const ae=setTimeout(K,X);return(0,_.toDisposable)(()=>clearTimeout(ae))}e.disposableTimeout=i;function r(K){const X=[];let ae=0;const fe=K.length;function be(){return ae<fe?K[ae++]():null}function Me(xe){xe!=null&&X.push(xe);const Ge=be();return Ge?Ge.then(Me):Promise.resolve(X)}return Promise.resolve(null).then(Me)}e.sequence=r;function c(K,X=fe=>!!fe,ae=null){let fe=0;const be=K.length,Me=()=>{if(fe>=be)return Promise.resolve(ae);const xe=K[fe++];return Promise.resolve(xe()).then(Je=>X(Je)?Promise.resolve(Je):Me())};return Me()}e.first=c;function o(K,X=fe=>!!fe,ae=null){if(K.length===0)return Promise.resolve(ae);let fe=K.length;const be=()=>{fe=-1;for(const Me of K)Me.cancel?.()};return new Promise((Me,xe)=>{for(const Ge of K)Ge.then(Je=>{--fe>=0&&X(Je)?(be(),Me(Je)):fe===0&&Me(ae)}).catch(Je=>{--fe>=0&&(be(),xe(Je))})})}e.firstParallel=o;class d{constructor(X){this._size=0,this.maxDegreeOfParalellism=X,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new I.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(X){return this._size++,new Promise((ae,fe)=>{this.outstandingPromises.push({factory:X,c:ae,e:fe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const X=this.outstandingPromises.shift();this.runningPromises++;const ae=X.factory();ae.then(X.c,X.e),ae.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=d;class m extends d{constructor(){super(1)}}e.Queue=m;class v{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const X=new W;return this.drainers.add(X),X.p}isDrained(){for(const[,X]of this.queues)if(X.size>0)return!1;return!0}queueFor(X,ae=R.extUri){const fe=ae.getComparisonKey(X);let be=this.queues.get(fe);return be||(be=new m,I.Event.once(be.onFinished)(()=>{be?.dispose(),this.queues.delete(fe),this.onDidQueueFinish()}),this.queues.set(fe,be)),be}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const X of this.drainers)X.complete();this.drainers.clear()}dispose(){for(const[,X]of this.queues)X.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=v;class w{constructor(X,ae){this._token=-1,typeof X=="function"&&typeof ae=="number"&&this.setIfNotSet(X,ae)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(X,ae){this.cancel(),this._token=setTimeout(()=>{this._token=-1,X()},ae)}setIfNotSet(X,ae){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,X()},ae))}}e.TimeoutTimer=w;class A{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(X,ae){this.cancel(),this._token=setInterval(()=>{X()},ae)}}e.IntervalTimer=A;class M{constructor(X,ae){this.timeoutToken=-1,this.runner=X,this.timeout=ae,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(X=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,X)}get delay(){return this.timeout}set delay(X){this.timeout=X}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=M;class T{constructor(X,ae){ae%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ae}ms is not a multiple of 1000ms.`),this.runner=X,this.timeout=ae,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(X=this.timeout){X%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(X/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=T;class O extends M{constructor(X,ae){super(X,ae);this.units=[]}work(X){this.units.push(X),this.isScheduled()||this.schedule()}doRun(){const X=this.units;this.units=[],this.runner&&this.runner(X)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O;class U extends _.Disposable{constructor(X,ae){super();this.options=X,this.handler=ae,this.pendingWork=[],this.throttler=this._register(new _.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(X){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+X.length>this.options.maxBufferedWork)return!1}else if(this.pending+X.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...X),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new M(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=K=>{(0,k.setTimeout0)(()=>{if(X)return;const ae=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ae-Date.now())}}))});let X=!1;return{dispose(){X||(X=!0)}}}:e.runWhenIdle=(K,X)=>{const ae=requestIdleCallback(K,typeof X=="number"?{timeout:X}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,cancelIdleCallback(ae))}}}}();class V{constructor(X){this._didRun=!1,this._executor=()=>{try{this._value=X()}catch(ae){this._error=ae}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=V;async function x(K,X,ae){let fe;for(let be=0;be<ae;be++)try{return await K()}catch(Me){fe=Me,await a(X)}throw fe}e.retry=x;class N{hasPending(X){return this._pending?typeof X=="number"?this._pending.taskId===X:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(X,ae,fe){return this._pending={taskId:X,cancel:()=>fe?.(),promise:ae},ae.then(()=>this.donePending(X),()=>this.donePending(X)),ae}donePending(X){this._pending&&X===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const X=this._next;this._next=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}setNext(X){if(this._next)this._next.run=X;else{let ae,fe;const be=new Promise((Me,xe)=>{ae=Me,fe=xe});this._next={run:X,promise:be,promiseResolve:ae,promiseReject:fe}}return this._next.promise}}e.TaskSequentializer=N;class B{constructor(X,ae=()=>Date.now()){this.interval=X,this.nowFn=ae,this.lastIncrementTime=0,this.value=0}increment(){const X=this.nowFn();return X-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=X,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((X,ae)=>{this.completeCallback=X,this.errorCallback=ae})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(X){return new Promise(ae=>{this.completeCallback(X),this.resolved=!0,ae()})}error(X){return new Promise(ae=>{this.errorCallback(X),this.rejected=!0,ae()})}cancel(){new Promise(X=>{this.errorCallback(new t.CancellationError),this.rejected=!0,X()})}}e.DeferredPromise=W;var H;(function(K){async function X(fe){let be;const Me=await Promise.all(fe.map(xe=>xe.then(Ge=>Ge,Ge=>{be||(be=Ge)})));if(typeof be!="undefined")throw be;return Me}K.settled=X;function ae(fe){return new Promise(async(be,Me)=>{try{await fe(be,Me)}catch(xe){Me(xe)}})}K.withAsyncBody=ae})(H=e.Promises||(e.Promises={}));var z;(function(K){K[K.Initial=0]="Initial",K[K.DoneOK=1]="DoneOK",K[K.DoneError=2]="DoneError"})(z||(z={}));class J{constructor(X){this._state=0,this._results=[],this._error=null,this._onStateChanged=new I.Emitter,queueMicrotask(async()=>{const ae={emitOne:fe=>this.emitOne(fe),emitMany:fe=>this.emitMany(fe),reject:fe=>this.reject(fe)};try{await Promise.resolve(X(ae)),this.resolve()}catch(fe){this.reject(fe)}finally{ae.emitOne=void 0,ae.emitMany=void 0,ae.reject=void 0}})}static fromArray(X){return new J(ae=>{ae.emitMany(X)})}static fromPromise(X){return new J(async ae=>{ae.emitMany(await X)})}static fromPromises(X){return new J(async ae=>{await Promise.all(X.map(async fe=>ae.emitOne(await fe)))})}static merge(X){return new J(async ae=>{await Promise.all(X.map(async fe=>{for await(const be of fe)ae.emitOne(be)}))})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(X<this._results.length)return{done:!1,value:this._results[X++]};if(this._state===1)return{done:!0,value:void 0};await I.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(X,ae){return new J(async fe=>{for await(const be of X)fe.emitOne(ae(be))})}map(X){return J.map(this,X)}static filter(X,ae){return new J(async fe=>{for await(const be of X)ae(be)&&fe.emitOne(be)})}filter(X){return J.filter(this,X)}static coalesce(X){return J.filter(X,ae=>!!ae)}coalesce(){return J.coalesce(this)}static async toPromise(X){const ae=[];for await(const fe of X)ae.push(fe);return ae}toPromise(){return J.toPromise(this)}emitOne(X){this._state===0&&(this._results.push(X),this._onStateChanged.fire())}emitMany(X){this._state===0&&(this._results=this._results.concat(X),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(X){this._state===0&&(this._state=2,this._error=X,this._onStateChanged.fire())}}e.AsyncIterableObject=J,J.EMPTY=J.fromArray([]);class ie extends J{constructor(X,ae){super(ae);this._source=X}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ie;function se(K){const X=new f.CancellationTokenSource,ae=K(X.token);return new ie(X,async fe=>{const be=X.token.onCancellationRequested(()=>{be.dispose(),X.dispose(),fe.reject(new t.CancellationError)});try{for await(const Me of ae){if(X.token.isCancellationRequested)return;fe.emitOne(Me)}be.dispose(),X.dispose()}catch(Me){be.dispose(),X.dispose(),fe.reject(Me)}})}e.createCancelableAsyncIterable=se}),define(pe[101],ve([0,1,13,9]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new f.IdleValue(()=>{const m=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:m,collatorIsNumeric:m.resolvedOptions().numeric}}),_=new f.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new f.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(m,v,w=!1){const A=m||"",M=v||"",T=I.value.collator.compare(A,M);return I.value.collatorIsNumeric&&T===0&&A!==M?A<M?-1:1:T}e.compareFileNames=k;function y(m,v){const w=_.value.collator;return m=m||"",v=v||"",h(w,m,v)}e.compareFileNamesDefault=y;function P(m,v){const w=_.value.collator;return m=m||"",v=v||"",i(m,v)||h(w,m,v)}e.compareFileNamesUpper=P;function L(m,v){const w=_.value.collator;return m=m||"",v=v||"",a(m,v)||h(w,m,v)}e.compareFileNamesLower=L;function C(m,v){return m=m||"",v=v||"",m===v?0:m<v?-1:1}e.compareFileNamesUnicode=C;function l(m,v,w=!1){w||(m=m&&m.toLowerCase(),v=v&&v.toLowerCase());const[A,M]=u(m),[T,O]=u(v);return A!==T?A<T?-1:1:M===O?0:M<O?-1:1}e.noIntlCompareFileNames=l;function b(m,v){const[w,A]=u(m),[M,T]=u(v);let O=I.value.collator.compare(A,T);if(O===0){if(I.value.collatorIsNumeric&&A!==T)return A<T?-1:1;if(O=I.value.collator.compare(w,M),I.value.collatorIsNumeric&&O===0&&w!==M)return w<M?-1:1}return O}e.compareFileExtensions=b;function p(m,v){m=m||"",v=v||"";const w=s(m),A=s(v),M=_.value.collator,T=R.value.collator;return h(T,w,A)||h(M,m,v)}e.compareFileExtensionsDefault=p;function g(m,v){m=m||"",v=v||"";const w=s(m),A=s(v),M=_.value.collator,T=R.value.collator;return h(T,w,A)||i(m,v)||h(M,m,v)}e.compareFileExtensionsUpper=g;function E(m,v){m=m||"",v=v||"";const w=s(m),A=s(v),M=_.value.collator,T=R.value.collator;return h(T,w,A)||a(m,v)||h(M,m,v)}e.compareFileExtensionsLower=E;function F(m,v){m=m||"",v=v||"";const w=s(m).toLowerCase(),A=s(v).toLowerCase();return w!==A?w<A?-1:1:m!==v?m<v?-1:1:0}e.compareFileExtensionsUnicode=F;const D=/^(.*?)(\.([^.]*))?$/;function u(m,v=!1){const w=m?D.exec(m):[];let A=[w&&w[1]||"",w&&w[3]||""];return v&&(!A[0]&&A[1]||A[0]&&A[0].charAt(0)===".")&&(A=[A[0]+"."+A[1],""]),A}function s(m){const v=m?D.exec(m):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function h(m,v,w){let A=m.compare(v,w);return A!==0?A:v.length!==w.length?v.length<w.length?-1:1:0}function n(m){const v=m.charAt(0);return v.toLocaleUpperCase()!==v}function S(m){const v=m.charAt(0);return v.toLocaleLowerCase()!==v}function a(m,v){return n(m)&&S(v)?-1:S(m)&&n(v)?1:0}function i(m,v){return S(m)&&n(v)?-1:n(m)&&S(v)?1:0}function r(m,v,w=!1){return w||(m=m&&m.toLowerCase(),v=v&&v.toLowerCase()),m===v?0:m<v?-1:1}function c(m,v,w=!1){const A=m.split(t.sep),M=v.split(t.sep),T=A.length-1,O=M.length-1;let U,V;for(let x=0;;x++){if(U=T===x,V=O===x,U&&V)return k(A[x],M[x],w);if(U)return-1;if(V)return 1;const N=r(A[x],M[x],w);if(N!==0)return N}}e.comparePaths=c;function o(m,v,w){const A=m.toLowerCase(),M=v.toLowerCase(),T=d(m,v,w);if(T)return T;const O=A.endsWith(w),U=M.endsWith(w);if(O!==U)return O?-1:1;const V=k(A,M);return V!==0?V:A.localeCompare(M)}e.compareAnything=o;function d(m,v,w){const A=m.toLowerCase(),M=v.toLowerCase(),T=A.startsWith(w),O=M.startsWith(w);if(T!==O)return T?-1:1;if(T&&O){if(A.length<M.length)return-1;if(A.length>M.length)return 1}return 0}e.compareByPrefix=d}),define(pe[102],ve([0,1,101,98,58,9,12,8]),function(Z,e,f,t,I,_,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,P=[y,[]];function L(N,B,W,H){if(!N||!B)return P;const z=N.length,J=B.length;if(z<J)return P;const ie=N.toLowerCase();return C(B,W,J,N,ie,z,H)}e.scoreFuzzy=L;function C(N,B,W,H,z,J,ie){const se=[],K=[];for(let be=0;be<W;be++){const Me=be*J,xe=Me-J,Ge=be>0,Je=N[be],q=B[be];for(let te=0;te<J;te++){const G=te>0,Q=Me+te,oe=Q-1,me=xe+te-1,Ie=G?se[oe]:0,We=Ge&&G?se[me]:0,Ye=Ge&&G?K[me]:0;let it;!We&&Ge?it=0:it=l(Je,q,H,z,te,Ye),it&&We+it>=Ie&&(ie||Ge||z.startsWith(B,te))?(K[Q]=Ye+1,se[Q]=We+it):(K[Q]=y,se[Q]=Ie)}}const X=[];let ae=W-1,fe=J-1;for(;ae>=0&&fe>=0;){const be=ae*J+fe;K[be]===y||(X.push(fe),ae--),fe--}return[se[W*J-1],X.reverse()]}function l(N,B,W,H,z,J){let ie=0;if(!b(B,H[z]))return ie;if(ie+=1,J>0&&(ie+=J*5),N===W[z]&&(ie+=1),z===0)ie+=8;else{const se=p(W.charCodeAt(z-1));se?ie+=se:(0,t.isUpper)(W.charCodeAt(z))&&J===0&&(ie+=2)}return ie}function b(N,B){return N===B?!0:N==="/"||N==="\\"?B==="/"||B==="\\":!1}function p(N){switch(N){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const g=[void 0,[]];function E(N,B,W=0,H=0){const z=B;return z.values&&z.values.length>1?F(N,z.values,W,H):D(N,B,W,H)}e.scoreFuzzy2=E;function F(N,B,W,H){let z=0;const J=[];for(const ie of B){const[se,K]=D(N,ie,W,H);if(typeof se!="number")return g;z+=se,J.push(...K)}return[z,d(J)]}function D(N,B,W,H){const z=(0,t.fuzzyScore)(B.original,B.originalLowercase,W,N,N.toLowerCase(),H,!0);return z?[z[0],(0,t.createMatches)(z)]:g}const u=Object.freeze({score:0}),s=1<<18,h=1<<17,n=1<<16;function S(N,B,W,H){const z=H.values?H.values:[H];return(0,I.hash)({[H.normalized]:{values:z.map(ie=>({value:ie.normalized,expectContiguousMatch:ie.expectContiguousMatch})),label:N,description:B,allowNonContiguousMatches:W}})}function a(N,B,W,H,z){if(!N||!B.normalized)return u;const J=H.getItemLabel(N);if(!J)return u;const ie=H.getItemDescription(N),se=S(J,ie,W,B),K=z[se];if(K)return K;const X=i(J,ie,H.getItemPath(N),B,W);return z[se]=X,X}e.scoreItemFuzzy=a;function i(N,B,W,H,z){const J=!W||!H.containsPathSeparator;return W&&(R.isLinux?H.pathNormalized===W:(0,k.equalsIgnoreCase)(H.pathNormalized,W))?{score:s,labelMatch:[{start:0,end:N.length}],descriptionMatch:B?[{start:0,end:B.length}]:void 0}:H.values&&H.values.length>1?r(N,B,W,H.values,J,z):c(N,B,W,H,J,z)}function r(N,B,W,H,z,J){let ie=0;const se=[],K=[];for(const X of H){const{score:ae,labelMatch:fe,descriptionMatch:be}=c(N,B,W,X,z,J);if(ae===y)return u;ie+=ae,fe&&se.push(...fe),be&&K.push(...be)}return{score:ie,labelMatch:d(se),descriptionMatch:d(K)}}function c(N,B,W,H,z,J){if(z||!B){const[ie,se]=L(N,H.normalized,H.normalizedLowercase,J&&!H.expectContiguousMatch);if(ie){const K=(0,t.matchesPrefix)(H.normalized,N);let X;return K?(X=h,X+=Math.round(H.normalized.length/N.length*100)):X=n,{score:X+ie,labelMatch:K||o(se)}}}if(B){let ie=B;W&&(ie=`${B}${_.sep}`);const se=ie.length,K=`${ie}${N}`,[X,ae]=L(K,H.normalized,H.normalizedLowercase,J&&!H.expectContiguousMatch);if(X){const fe=o(ae),be=[],Me=[];return fe.forEach(xe=>{xe.start<se&&xe.end>se?(be.push({start:0,end:xe.end-se}),Me.push({start:xe.start,end:se})):xe.start>=se?be.push({start:xe.start-se,end:xe.end-se}):Me.push(xe)}),{score:X,labelMatch:be,descriptionMatch:Me}}}return u}function o(N){const B=[];if(!N)return B;let W;for(const H of N)W&&W.end===H?W.end+=1:(W={start:H,end:H+1},B.push(W));return B}function d(N){const B=N.sort((z,J)=>z.start-J.start),W=[];let H;for(const z of B)!H||!m(H,z)?(H=z,W.push(z)):(H.start=Math.min(H.start,z.start),H.end=Math.max(H.end,z.end));return W}function m(N,B){return!(N.end<B.start||B.end<N.start)}function v(N,B,W,H,z,J){const ie=a(N,W,H,z,J),se=a(B,W,H,z,J),K=ie.score,X=se.score;if((K===s||X===s)&&K!==X)return K===s?-1:1;if(K>n||X>n){if(K!==X)return K>X?-1:1;if(K<h&&X<h){const Je=A(ie.labelMatch,se.labelMatch);if(Je!==0)return Je}const xe=z.getItemLabel(N)||"",Ge=z.getItemLabel(B)||"";if(xe.length!==Ge.length)return xe.length-Ge.length}if(K!==X)return K>X?-1:1;const ae=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0,fe=Array.isArray(se.labelMatch)&&se.labelMatch.length>0;if(ae&&!fe)return-1;if(fe&&!ae)return 1;const be=w(N,ie,z),Me=w(B,se,z);return be&&Me&&be!==Me?Me>be?-1:1:M(N,B,W,z)}e.compareItemsByFuzzyScore=v;function w(N,B,W){let H=-1,z=-1;if(B.descriptionMatch&&B.descriptionMatch.length?H=B.descriptionMatch[0].start:B.labelMatch&&B.labelMatch.length&&(H=B.labelMatch[0].start),B.labelMatch&&B.labelMatch.length){if(z=B.labelMatch[B.labelMatch.length-1].end,B.descriptionMatch&&B.descriptionMatch.length){const J=W.getItemDescription(N);J&&(z+=J.length)}}else B.descriptionMatch&&B.descriptionMatch.length&&(z=B.descriptionMatch[B.descriptionMatch.length-1].end);return z-H}function A(N,B){if(!N&&!B||(!N||!N.length)&&(!B||!B.length))return 0;if(!B||!B.length)return-1;if(!N||!N.length)return 1;const W=N[0].start,z=N[N.length-1].end-W,J=B[0].start,se=B[B.length-1].end-J;return z===se?0:se<z?1:-1}function M(N,B,W,H){const z=H.getItemLabel(N)||"",J=H.getItemLabel(B)||"",ie=H.getItemDescription(N),se=H.getItemDescription(B),K=z.length+(ie?ie.length:0),X=J.length+(se?se.length:0);if(K!==X)return K-X;const ae=H.getItemPath(N),fe=H.getItemPath(B);return ae&&fe&&ae.length!==fe.length?ae.length-fe.length:z!==J?(0,f.compareAnything)(z,J,W.normalized):ie&&se&&ie!==se?(0,f.compareAnything)(ie,se,W.normalized):ae&&fe&&ae!==fe?(0,f.compareAnything)(ae,fe,W.normalized):0}function T(N){return N.startsWith('"')&&N.endsWith('"')}const O=" ";function U(N){typeof N!="string"&&(N="");const B=N.toLowerCase(),{pathNormalized:W,normalized:H,normalizedLowercase:z}=V(N),J=W.indexOf(_.sep)>=0,ie=T(N);let se;const K=N.split(O);if(K.length>1)for(const X of K){const ae=T(X),{pathNormalized:fe,normalized:be,normalizedLowercase:Me}=V(X);be&&(se||(se=[]),se.push({original:X,originalLowercase:X.toLowerCase(),pathNormalized:fe,normalized:be,normalizedLowercase:Me,expectContiguousMatch:ae}))}return{original:N,originalLowercase:B,pathNormalized:W,normalized:H,normalizedLowercase:z,values:se,containsPathSeparator:J,expectContiguousMatch:ie}}e.prepareQuery=U;function V(N){let B;R.isWindows?B=N.replace(/\//g,_.sep):B=N.replace(/\\/g,_.sep);const W=(0,k.stripWildcards)(B).replace(/\s|"/g,"");return{pathNormalized:B,normalized:W,normalizedLowercase:W.toLowerCase()}}function x(N){return Array.isArray(N)?U(N.map(B=>B.original).join(O)):U(N.original)}e.pieceToQuery=x}),define(pe[32],ve([0,1,13,29,24,9,8]),function(Z,e,f,t,I,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const y="[/\\\\]",P="[^/\\\\]",L=/\//g;function C(B){switch(B){case 0:return"";case 1:return`${P}*?`;default:return`(?:${y}|${P}+${y}|${y}${P}+)*?`}}function l(B,W){if(!B)return[];const H=[];let z=!1,J=!1,ie="";for(const se of B){switch(se){case W:if(!z&&!J){H.push(ie),ie="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":J=!0;break;case"]":J=!1;break}ie+=se}return ie&&H.push(ie),H}e.splitGlobAware=l;function b(B){if(!B)return"";let W="";const H=l(B,e.GLOB_SPLIT);if(H.every(z=>z===e.GLOBSTAR))W=".*";else{let z=!1;H.forEach((J,ie)=>{if(J===e.GLOBSTAR){z||(W+=C(2),z=!0);return}let se=!1,K="",X=!1,ae="";for(const fe of J){if(fe!=="}"&&se){K+=fe;continue}if(X&&(fe!=="]"||!ae)){let be;fe==="-"?be=fe:(fe==="^"||fe==="!")&&!ae?be="^":fe===e.GLOB_SPLIT?be="":be=R.escapeRegExpCharacters(fe),ae+=be;continue}switch(fe){case"{":se=!0;continue;case"[":X=!0;continue;case"}":{W+=`(?:${l(K,",").map(xe=>b(xe)).join("|")})`,se=!1,K="";break}case"]":W+="["+ae+"]",X=!1,ae="";break;case"?":W+=P;continue;case"*":W+=C(1);continue;default:W+=R.escapeRegExpCharacters(fe)}}ie<H.length-1&&(H[ie+1]!==e.GLOBSTAR||ie+2<H.length)&&(W+=y),z=!1})}return W}const p=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,F=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,D=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new I.LRUCache(1e4),h=function(){return!1},n=function(){return null};function S(B,W){if(!B)return n;let H;typeof B!="string"?H=B.pattern:H=B,H=H.trim();const z=`${H}_${!!W.trimForExclusions}`;let J=s.get(z);if(J)return a(J,B);let ie;if(p.test(H)){const se=H.substr(4);J=function(K,X){return typeof K=="string"&&K.endsWith(se)?H:null}}else(ie=g.exec(i(H,W)))?J=r(ie[1],H):(W.trimForExclusions?F:E).test(H)?J=c(H,W):(ie=D.exec(i(H,W)))?J=o(ie[1].substr(1),H,!0):(ie=u.exec(i(H,W)))?J=o(ie[1],H,!1):J=d(H);return s.set(z,J),a(J,B)}function a(B,W){return typeof W=="string"?B:function(H,z){return t.isEqualOrParent(H,W.base)?B(_.relative(W.base,H),z):null}}function i(B,W){return W.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function r(B,W){const H=`/${B}`,z=`\\${B}`,J=function(se,K){return typeof se!="string"?null:K?K===B?W:null:se===B||se.endsWith(H)||se.endsWith(z)?W:null},ie=[B];return J.basenames=ie,J.patterns=[W],J.allBasenames=ie,J}function c(B,W){const H=N(B.slice(1,-1).split(",").map(K=>S(K,W)).filter(K=>K!==n),B),z=H.length;if(!z)return n;if(z===1)return H[0];const J=function(K,X){for(let ae=0,fe=H.length;ae<fe;ae++)if(H[ae](K,X))return B;return null},ie=H.find(K=>!!K.allBasenames);ie&&(J.allBasenames=ie.allBasenames);const se=H.reduce((K,X)=>X.allPaths?K.concat(X.allPaths):K,[]);return se.length&&(J.allPaths=se),J}function o(B,W,H){const z=_.sep===_.posix.sep,J=z?B:B.replace(L,_.sep),ie=_.sep+J,se=_.posix.sep+B,K=H?function(X,ae){return typeof X=="string"&&(X===J||X.endsWith(ie)||!z&&(X===B||X.endsWith(se)))?W:null}:function(X,ae){return typeof X=="string"&&(X===J||!z&&X===B)?W:null};return K.allPaths=[(H?"*/":"./")+B],K}function d(B){try{const W=new RegExp(`^${b(B)}$`);return function(H){return W.lastIndex=0,typeof H=="string"&&W.test(H)?B:null}}catch{return n}}function m(B,W,H){return!B||typeof W!="string"?!1:v(B)(W,void 0,H)}e.match=m;function v(B,W={}){if(!B)return h;if(typeof B=="string"||T(B)){const H=S(B,W);if(H===n)return h;const z=function(J,ie){return!!H(J,ie)};return H.allBasenames&&(z.allBasenames=H.allBasenames),H.allPaths&&(z.allPaths=H.allPaths),z}return V(B,W)}e.parse=v;function w(B){if(!B)return;let W;return H=>(W||(W=(B()||Promise.resolve([])).then(z=>z?M(z):{})),W.then(z=>!!z[H]))}e.hasSiblingPromiseFn=w;function A(B){if(!B)return;let W;return H=>{if(!W){const z=B();W=z?M(z):{}}return!!W[H]}}e.hasSiblingFn=A;function M(B){const W={};for(const H of B)W[H]=!0;return W}function T(B){const W=B;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}e.isRelativePattern=T;function O(B){return B.allBasenames||[]}e.getBasenameTerms=O;function U(B){return B.allPaths||[]}e.getPathTerms=U;function V(B,W){const H=N(Object.getOwnPropertyNames(B).map(K=>x(K,B[K],W)).filter(K=>K!==n)),z=H.length;if(!z)return n;if(!H.some(K=>!!K.requiresSiblings)){if(z===1)return H[0];const K=function(fe,be){for(let Me=0,xe=H.length;Me<xe;Me++){const Ge=H[Me](fe,be);if(Ge)return Ge}return null},X=H.find(fe=>!!fe.allBasenames);X&&(K.allBasenames=X.allBasenames);const ae=H.reduce((fe,be)=>be.allPaths?fe.concat(be.allPaths):fe,[]);return ae.length&&(K.allPaths=ae),K}const J=function(K,X,ae){let fe;for(let be=0,Me=H.length;be<Me;be++){const xe=H[be];xe.requiresSiblings&&ae&&(X||(X=_.basename(K)),fe||(fe=X.substr(0,X.length-_.extname(K).length)));const Ge=xe(K,X,fe,ae);if(Ge)return Ge}return null},ie=H.find(K=>!!K.allBasenames);ie&&(J.allBasenames=ie.allBasenames);const se=H.reduce((K,X)=>X.allPaths?K.concat(X.allPaths):K,[]);return se.length&&(J.allPaths=se),J}function x(B,W,H){if(W===!1)return n;const z=S(B,H);if(z===n)return n;if(typeof W=="boolean")return z;if(W){const J=W.when;if(typeof J=="string"){const ie=(se,K,X,ae)=>{if(!ae||!z(se,K))return null;const fe=J.replace("$(basename)",X),be=ae(fe);return(0,f.isThenable)(be)?be.then(Me=>Me?B:null):be?B:null};return ie.requiresSiblings=!0,ie}}return z}function N(B,W){const H=B.filter(K=>!!K.basenames);if(H.length<2)return B;const z=H.reduce((K,X)=>{const ae=X.basenames;return ae?K.concat(ae):K},[]);let J;if(W){J=[];for(let K=0,X=z.length;K<X;K++)J.push(W)}else J=H.reduce((K,X)=>{const ae=X.patterns;return ae?K.concat(ae):K},[]);const ie=function(K,X){if(typeof K!="string")return null;if(!X){let fe;for(fe=K.length;fe>0;fe--){const be=K.charCodeAt(fe-1);if(be===47||be===92)break}X=K.substr(fe)}const ae=z.indexOf(X);return ae!==-1?J[ae]:null};ie.basenames=z,ie.patterns=J,ie.allBasenames=z;const se=B.filter(K=>!K.basenames);return se.push(ie),se}}),define(pe[80],ve([0,1,29,10,9,12,23,8,2]),function(Z,e,f,t,I,_,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(i,r,c){if(typeof i=="string"&&(i=y.URI.file(i)),c){const d=c.getWorkspaceFolder(i);if(d){const m=c.getWorkspace().folders.length>1;let v;if((0,R.isEqual)(d.uri,i)?v="":v=(0,R.relativePath)(d.uri,i),m){const w=d.name?d.name:(0,R.basename)(d.uri);v=v?w+" \u2022 "+v:w}return v}}if(i.scheme!==t.Schemas.file&&i.scheme!==t.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,f.hasDriveLetter)(i.fsPath))return(0,I.normalize)(C(i.fsPath));let o=(0,I.normalize)(i.fsPath);return!_.isWindows&&r?.userHome&&(o=b(o,r.userHome.fsPath)),o}e.getPathLabel=P;function L(i){if(!i)return;typeof i=="string"&&(i=y.URI.file(i));const r=(0,R.basename)(i)||(i.scheme===t.Schemas.file?i.fsPath:i.path);return _.isWindows&&(0,f.isRootOrDriveLetter)(r)?C(r):r}e.getBaseLabel=L;function C(i,r){return(0,f.hasDriveLetter)(i,r)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=C;let l=Object.create(null);function b(i,r){if(_.isWindows||!i||!r)return i;let c=l.original===r?l.normalized:void 0;return c||(c=`${(0,k.rtrim)(r,I.posix.sep)}${I.posix.sep}`,l={original:r,normalized:c}),(_.isLinux?i.startsWith(c):(0,k.startsWithIgnoreCase)(i,c))&&(i=`~/${i.substr(c.length)}`),i}e.tildify=b;function p(i,r){return i.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=p;const g="\u2026",E="\\\\",F="~";function D(i,r=I.sep){const c=new Array(i.length);let o=!1;for(let d=0;d<i.length;d++){let m=i[d];if(m===""){c[d]=`.${r}`;continue}if(!m){c[d]=m;continue}o=!0;let v="";m.indexOf(E)===0?(v=m.substr(0,m.indexOf(E)+E.length),m=m.substr(m.indexOf(E)+E.length)):m.indexOf(r)===0?(v=m.substr(0,m.indexOf(r)+r.length),m=m.substr(m.indexOf(r)+r.length)):m.indexOf(F)===0&&(v=m.substr(0,m.indexOf(F)+F.length),m=m.substr(m.indexOf(F)+F.length));const w=m.split(r);for(let A=1;o&&A<=w.length;A++)for(let M=w.length-A;o&&M>=0;M--){o=!1;let T=w.slice(M,M+A).join(r);for(let O=0;!o&&O<i.length;O++)if(O!==d&&i[O]&&i[O].indexOf(T)>-1){const U=M+A===w.length,V=M>0&&i[O].indexOf(r)>-1?r+T:T,x=i[O].endsWith(V);o=!U||x}if(!o){let O="";(w[0].endsWith(":")||v!=="")&&(M===1&&(M=0,A++,T=w[0]+r+T),M>0&&(O=w[0]+r),O=v+O),M>0&&(O=O+g+r),O=O+T,M+A<w.length&&(O=O+r+g),c[d]=O}}o&&(c[d]=m)}return c}e.shorten=D;var u;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function s(i,r=Object.create(null)){const c=[];let o=!1,d="";for(const m of i)if(m==="$"||o&&m==="{")d&&c.push({value:d,type:u.TEXT}),d="",o=!0;else if(m==="}"&&o){const v=r[d];if(typeof v=="string")v.length&&c.push({value:v,type:u.VARIABLE});else if(v){const w=c[c.length-1];(!w||w.type!==u.SEPARATOR)&&c.push({value:v.label,type:u.SEPARATOR})}d="",o=!1}else d+=m;return d&&!o&&c.push({value:d,type:u.TEXT}),c.filter((m,v)=>{if(m.type===u.SEPARATOR){const w=c[v-1],A=c[v+1];return[w,A].every(M=>M&&(M.type===u.VARIABLE||M.type===u.TEXT)&&M.value.length>0)}return!0}).map(m=>m.value).join("")}e.template=s;function h(i,r){return _.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,_.isMacintosh?"&":"&&"):i.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=h;function n(i,r){return _.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,""):_.isWindows?i.replace(/&&|&/g,c=>c==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=n;function S(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=S;function a(i){const r=i.indexOf("/")!==-1?I.posix:I.win32,c=r.basename(i),o=r.dirname(i);return c.length?{name:c,parentPath:o}:{name:o,parentPath:""}}e.splitName=a}),define(pe[103],ve([0,1,2]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(L){return L.toJSON()}class I{constructor(C){this._uriTransformer=C}transformIncoming(C){const l=this._uriTransformer.transformIncoming(C);return l===C?C:t(f.URI.from(l))}transformOutgoing(C){const l=this._uriTransformer.transformOutgoing(C);return l===C?C:t(f.URI.from(l))}transformOutgoingURI(C){const l=this._uriTransformer.transformOutgoing(C);return l===C?C:f.URI.from(l)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(L){return L}transformOutgoing(L){return L}transformOutgoingURI(L){return L}transformOutgoingScheme(L){return L}};function _(L,C,l){if(!L||l>200)return null;if(typeof L=="object"){if(L instanceof f.URI)return C.transformOutgoing(L);for(let b in L)if(Object.hasOwnProperty.call(L,b)){const p=_(L[b],C,l+1);p!==null&&(L[b]=p)}}return null}function R(L,C){const l=_(L,C,0);return l===null?L:l}e.transformOutgoingURIs=R;function k(L,C,l,b){if(!L||b>200)return null;if(typeof L=="object"){if(L.$mid===1)return l?f.URI.revive(C.transformIncoming(L)):C.transformIncoming(L);for(let p in L)if(Object.hasOwnProperty.call(L,p)){const g=k(L[p],C,l,b+1);g!==null&&(L[p]=g)}}return null}function y(L,C){const l=k(L,C,!1,0);return l===null?L:l}e.transformIncomingURIs=y;function P(L,C){const l=k(L,C,!0,0);return l===null?L:l}e.transformAndReviveIncomingURIs=P}),define(pe[33],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const f=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(y){return f.test(y)}e.isUUID=t;const I=new Uint8Array(16),_=[];for(let y=0;y<256;y++)_.push(y.toString(16).padStart(2,"0"));let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(y){for(let P=0;P<y.length;P++)y[P]=Math.floor(Math.random()*256);return y};function k(){R(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let y=0,P="";return P+=_[I[y++]],P+=_[I[y++]],P+=_[I[y++]],P+=_[I[y++]],P+="-",P+=_[I[y++]],P+=_[I[y++]],P+="-",P+=_[I[y++]],P+=_[I[y++]],P+="-",P+=_[I[y++]],P+=_[I[y++]],P+="-",P+=_[I[y++]],P+=_[I[y++]],P+=_[I[y++]],P+=_[I[y++]],P+=_[I[y++]],P+=_[I[y++]],P}e.generateUuid=k}),define(pe[144],ve([0,1,104]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(_="utf8"){this.stringDecoder=new f.StringDecoder(_),this.remaining=null}write(_){const R=[],k=this.remaining?this.remaining+this.stringDecoder.write(_):this.stringDecoder.write(_);if(k.length<1)return R;let y=0,P,L=y;for(;L<k.length;)if(P=k.charCodeAt(L),P===13||P===10){if(R.push(k.substring(y,L)),L++,L<k.length){const C=P;P=k.charCodeAt(L),(C===13&&P===10||C===10&&P===13)&&L++}y=L}else L++;return this.remaining=y<k.length?k.substr(y):null,R}end(){return this.remaining}}e.LineDecoder=t}),define(pe[30],ve([0,1,60,81,291,13,29,79,9,12,23,2]),function(Z,e,f,t,I,_,R,k,y,P,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var l;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(l=e.RimRafMode||(e.RimRafMode={}));async function b(U,V=l.UNLINK){if((0,R.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return V===l.UNLINK?g(U):p(U)}async function p(U){try{const V=(0,R.randomPath)((0,t.tmpdir)());try{await f.promises.rename(U,V)}catch{return g(U)}g(V).catch(x=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function g(U){return(0,I.promisify)(f.rm)(U,{recursive:!0,force:!0,maxRetries:3})}function E(U){if((0,R.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");f.rmSync(U,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=E;async function F(U,V){return s(await(V?D(U):(0,I.promisify)(f.readdir)(U)))}async function D(U){try{return await(0,I.promisify)(f.readdir)(U,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const V=[],x=await F(U);for(const N of x){let B=!1,W=!1,H=!1;try{const z=await e.Promises.lstat((0,y.join)(U,N));B=z.isFile(),W=z.isDirectory(),H=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}V.push({name:N,isFile:()=>B,isDirectory:()=>W,isSymbolicLink:()=>H})}return V}function u(U){return s(f.readdirSync(U))}e.readdirSync=u;function s(U){return U.map(V=>typeof V=="string"?P.isMacintosh?(0,k.normalizeNFC)(V):V:(V.name=P.isMacintosh?(0,k.normalizeNFC)(V.name):V.name,V))}async function h(U){const V=await F(U),x=[];for(const N of V)await S.existsDirectory((0,y.join)(U,N))&&x.push(N);return x}function n(U,V=1e3){return new Promise(x=>{let N=!1;const B=setInterval(()=>{N||(N=!0,f.access(U,W=>{N=!1,W&&(clearInterval(B),x(void 0))}))},V)})}e.whenDeleted=n;var S;(function(U){async function V(B){let W;try{if(W=await e.Promises.lstat(B),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(B),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(P.isWindows&&H.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw z}throw H}}U.stat=V;async function x(B){try{const{stat:W,symbolicLink:H}=await U.stat(B);return W.isFile()&&H?.dangling!==!0}catch{}return!1}U.existsFile=x;async function N(B){try{const{stat:W,symbolicLink:H}=await U.stat(B);return W.isDirectory()&&H?.dangling!==!0}catch{}return!1}U.existsDirectory=N})(S=e.SymlinkSupport||(e.SymlinkSupport={}));const a=new _.ResourceQueue;function i(U,V,x){return a.queueFor(C.URI.file(U),L.extUriBiasedIgnorePathCase).queue(()=>{const N=d(x);return new Promise((B,W)=>c(U,V,N,H=>H?W(H):B()))})}let r=!0;function c(U,V,x,N){if(!r)return f.writeFile(U,V,{mode:x.mode,flag:x.flag},N);f.open(U,x.flag,x.mode,(B,W)=>{if(B)return N(B);f.writeFile(W,V,H=>{if(H)return f.close(W,()=>N(H));f.fdatasync(W,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),r=!1),f.close(W,J=>N(J))))})})}function o(U,V,x){const N=d(x);if(!r)return f.writeFileSync(U,V,{mode:N.mode,flag:N.flag});const B=f.openSync(U,N.flag,N.mode);try{f.writeFileSync(B,V);try{f.fdatasyncSync(B)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),r=!1}}finally{f.closeSync(B)}}e.writeFileSync=o;function d(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function m(U,V){if(U===V)return;async function x(N){try{const B=await e.Promises.lstat(N);if(B.isDirectory()||B.isSymbolicLink())return;await e.Promises.utimes(N,B.atime,new Date)}catch{}}try{await e.Promises.rename(U,V),await x(V)}catch(N){if(U.toLowerCase()!==V.toLowerCase()&&N.code==="EXDEV"||U.endsWith("."))await v(U,V,{preserveSymlinks:!1}),await b(U,l.MOVE),await x(V);else throw N}}async function v(U,V,x){return A(U,V,{root:{source:U,target:V},options:x,handledSourcePaths:new Set})}const w=511;async function A(U,V,x){if(x.handledSourcePaths.has(U))return;x.handledSourcePaths.add(U);const{stat:N,symbolicLink:B}=await S.stat(U);if(B){if(x.options.preserveSymlinks)try{return await O(U,V,x)}catch(W){console.warn("[node.js fs] copy of symlink failed: ",W)}if(B.dangling)return}return N.isDirectory()?M(U,V,N.mode&w,x):T(U,V,N.mode&w)}async function M(U,V,x,N){await e.Promises.mkdir(V,{recursive:!0,mode:x});const B=await F(U);for(const W of B)await A((0,y.join)(U,W),(0,y.join)(V,W),N)}async function T(U,V,x){await e.Promises.copyFile(U,V),await e.Promises.chmod(V,x)}async function O(U,V,x){let N=await e.Promises.readlink(U);(0,R.isEqualOrParent)(N,x.root.source,!P.isLinux)&&(N=(0,y.join)(x.root.target,N.substr(x.root.source.length+1))),await e.Promises.symlink(N,V)}e.Promises=new class{get access(){return(0,I.promisify)(f.access)}get stat(){return(0,I.promisify)(f.stat)}get lstat(){return(0,I.promisify)(f.lstat)}get utimes(){return(0,I.promisify)(f.utimes)}get read(){return(U,V,x,N,B)=>new Promise((W,H)=>{f.read(U,V,x,N,B,(z,J,ie)=>z?H(z):W({bytesRead:J,buffer:ie}))})}get readFile(){return(0,I.promisify)(f.readFile)}get write(){return(U,V,x,N,B)=>new Promise((W,H)=>{f.write(U,V,x,N,B,(z,J,ie)=>z?H(z):W({bytesWritten:J,buffer:ie}))})}get appendFile(){return(0,I.promisify)(f.appendFile)}get fdatasync(){return(0,I.promisify)(f.fdatasync)}get truncate(){return(0,I.promisify)(f.truncate)}get rename(){return(0,I.promisify)(f.rename)}get copyFile(){return(0,I.promisify)(f.copyFile)}get open(){return(0,I.promisify)(f.open)}get close(){return(0,I.promisify)(f.close)}get symlink(){return(0,I.promisify)(f.symlink)}get readlink(){return(0,I.promisify)(f.readlink)}get chmod(){return(0,I.promisify)(f.chmod)}get mkdir(){return(0,I.promisify)(f.mkdir)}get unlink(){return(0,I.promisify)(f.unlink)}get rmdir(){return(0,I.promisify)(f.rmdir)}get realpath(){return(0,I.promisify)(f.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return F}get readDirsInDir(){return h}get writeFile(){return i}get rm(){return b}get move(){return m}get copy(){return v}}}),define(pe[105],ve([0,1,60,9,12,8,30]),function(Z,e,f,t,I,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(l){if(I.isLinux)return l;const b=(0,t.dirname)(l);if(l===b)return l;const p=((0,t.basename)(l)||l).toLowerCase();try{const E=(0,R.readdirSync)(b).filter(F=>F.toLowerCase()===p);if(E.length===1){const F=k(b);if(F)return(0,t.join)(F,E[0])}else if(E.length>1){const F=E.indexOf(p);if(F>=0){const D=k(b);if(D)return(0,t.join)(D,E[F])}}}catch{}return null}e.realcaseSync=k;async function y(l){if(I.isLinux)return l;const b=(0,t.dirname)(l);if(l===b)return l;const p=((0,t.basename)(l)||l).toLowerCase();try{const E=(await R.Promises.readdir(b)).filter(F=>F.toLowerCase()===p);if(E.length===1){const F=await y(b);if(F)return(0,t.join)(F,E[0])}else if(E.length>1){const F=E.indexOf(p);if(F>=0){const D=await y(b);if(D)return(0,t.join)(D,E[F])}}}catch{}return null}e.realcase=y;async function P(l){try{return await R.Promises.realpath(l)}catch{const p=C(l);return await R.Promises.access(p,f.constants.R_OK),p}}e.realpath=P;function L(l){try{return f.realpathSync(l)}catch{const p=C(l);return f.accessSync(p,f.constants.R_OK),p}}e.realpathSync=L;function C(l){return(0,_.rtrim)((0,t.normalize)(l),t.sep)}});var je=this&&this.__decorate||function(Z,e,f,t){var I=arguments.length,_=I<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,f):t,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")_=Reflect.decorate(Z,e,f,t);else for(var k=Z.length-1;k>=0;k--)(R=Z[k])&&(_=(I<3?R(_):I>3?R(e,f,_):R(e,f))||_);return I>3&&_&&Object.defineProperty(e,f,_),_};define(pe[106],ve([0,1,17,13,22,21,56,16,3,6,59,8,18]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function p(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function E(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var F;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(F||(F={}));class D{constructor(H){this.buffer=H,this.pos=0}read(H){const z=this.buffer.slice(this.pos,this.pos+H);return this.pos+=z.byteLength,z}}class u{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(H){this.buffers.push(H)}}var s;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(s||(s={}));function h(W){const H=I.VSBuffer.alloc(4);return H.writeUInt32BE(W,0),H}function n(W){return W.read(4).readUInt32BE(0)}function S(W){const H=I.VSBuffer.alloc(1);return H.writeUInt8(W,0),H}const a={Undefined:S(s.Undefined),String:S(s.String),Buffer:S(s.Buffer),VSBuffer:S(s.VSBuffer),Array:S(s.Array),Object:S(s.Object)},i=typeof Buffer!="undefined";function r(W,H){if(typeof H=="undefined")W.write(a.Undefined);else if(typeof H=="string"){const z=I.VSBuffer.fromString(H);W.write(a.String),W.write(h(z.byteLength)),W.write(z)}else if(i&&Buffer.isBuffer(H)){const z=I.VSBuffer.wrap(H);W.write(a.Buffer),W.write(h(z.byteLength)),W.write(z)}else if(H instanceof I.VSBuffer)W.write(a.VSBuffer),W.write(h(H.byteLength)),W.write(H);else if(Array.isArray(H)){W.write(a.Array),W.write(h(H.length));for(const z of H)r(W,z)}else{const z=I.VSBuffer.fromString(JSON.stringify(H));W.write(a.Object),W.write(h(z.byteLength)),W.write(z)}}function c(W){switch(W.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return W.read(n(W)).toString();case s.Buffer:return W.read(n(W)).buffer;case s.VSBuffer:return W.read(n(W));case s.Array:{const z=n(W),J=[];for(let ie=0;ie<z;ie++)J.push(c(W));return J}case s.Object:return JSON.parse(W.read(n(W)).toString())}}class o{constructor(H,z,J=null,ie=1e3){this.protocol=H,this.ctx=z,this.logger=J,this.timeoutDelay=ie,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(se=>this.onRawMessage(se)),this.sendResponse({type:200})}registerChannel(H,z){this.channels.set(H,z),setTimeout(()=>this.flushPendingRequests(H),0)}sendResponse(H){switch(H.type){case 200:{const z=this.send([H.type]);this.logger&&this.logger.logOutgoing(z,0,1,E(H.type));return}case 201:case 202:case 204:case 203:{const z=this.send([H.type,H.id],H.data);this.logger&&this.logger.logOutgoing(z,H.id,1,E(H.type),H.data);return}}}send(H,z=void 0){const J=new u;return r(J,H),r(J,z),this.sendBuffer(J.buffer)}sendBuffer(H){try{return this.protocol.send(H),H.byteLength}catch{return 0}}onRawMessage(H){const z=new D(H),J=c(z),ie=c(z),se=J[0];switch(se){case 100:return this.logger&&this.logger.logIncoming(H.byteLength,J[1],1,`${p(se)}: ${J[2]}.${J[3]}`,ie),this.onPromise({type:se,id:J[1],channelName:J[2],name:J[3],arg:ie});case 102:return this.logger&&this.logger.logIncoming(H.byteLength,J[1],1,`${p(se)}: ${J[2]}.${J[3]}`,ie),this.onEventListen({type:se,id:J[1],channelName:J[2],name:J[3],arg:ie});case 101:return this.logger&&this.logger.logIncoming(H.byteLength,J[1],1,`${p(se)}`),this.disposeActiveRequest({type:se,id:J[1]});case 103:return this.logger&&this.logger.logIncoming(H.byteLength,J[1],1,`${p(se)}`),this.disposeActiveRequest({type:se,id:J[1]})}}onPromise(H){const z=this.channels.get(H.channelName);if(!z){this.collectPendingRequest(H);return}const J=new _.CancellationTokenSource;let ie;try{ie=z.call(this.ctx,H.name,H.arg,J.token)}catch(X){ie=Promise.reject(X)}const se=H.id;ie.then(X=>{this.sendResponse({id:se,data:X,type:201}),this.activeRequests.delete(H.id)},X=>{X instanceof Error?this.sendResponse({id:se,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split?X.stack.split(`
`):X.stack:void 0},type:202}):this.sendResponse({id:se,data:X,type:203}),this.activeRequests.delete(H.id)});const K=(0,P.toDisposable)(()=>J.cancel());this.activeRequests.set(H.id,K)}onEventListen(H){const z=this.channels.get(H.channelName);if(!z){this.collectPendingRequest(H);return}const J=H.id,se=z.listen(this.ctx,H.name,H.arg)(K=>this.sendResponse({id:J,data:K,type:204}));this.activeRequests.set(H.id,se)}disposeActiveRequest(H){const z=this.activeRequests.get(H.id);z&&(z.dispose(),this.activeRequests.delete(H.id))}collectPendingRequest(H){let z=this.pendingRequests.get(H.channelName);z||(z=[],this.pendingRequests.set(H.channelName,z));const J=setTimeout(()=>{console.error(`Unknown channel: ${H.channelName}`),H.type===100&&this.sendResponse({id:H.id,data:{name:"Unknown channel",message:`Channel name '${H.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:H,timeoutTimer:J})}flushPendingRequests(H){const z=this.pendingRequests.get(H);if(z){for(const J of z)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.onPromise(J.request);break;case 102:this.onEventListen(J.request);break}this.pendingRequests.delete(H)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(H=>H.dispose()),this.activeRequests.clear()}}e.ChannelServer=o;var d;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class m{constructor(H,z=null){this.protocol=H,this.isDisposed=!1,this.state=F.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(J=>this.onBuffer(J)),this.logger=z}getChannel(H){const z=this;return{call(J,ie,se){return z.isDisposed?Promise.reject(k.canceled()):z.requestPromise(H,J,ie,se)},listen(J,ie){return z.isDisposed?Promise.reject(k.canceled()):z.requestEvent(H,J,ie)}}}requestPromise(H,z,J,ie=_.CancellationToken.None){const se=this.lastRequestId++,X={id:se,type:100,channelName:H,name:z,arg:J};if(ie.isCancellationRequested)return Promise.reject(k.canceled());let ae;return new Promise((be,Me)=>{if(ie.isCancellationRequested)return Me(k.canceled());const xe=()=>{const te=G=>{switch(G.type){case 201:this.handlers.delete(se),be(G.data);break;case 202:{this.handlers.delete(se);const Q=new Error(G.data.message);Q.stack=G.data.stack,Q.name=G.data.name,Me(Q);break}case 203:this.handlers.delete(se),Me(G.data);break}};this.handlers.set(se,te),this.sendRequest(X)};let Ge=null;this.state===F.Idle?xe():(Ge=(0,t.createCancelablePromise)(te=>this.whenInitialized()),Ge.then(()=>{Ge=null,xe()}));const Je=()=>{Ge?(Ge.cancel(),Ge=null):this.sendRequest({id:se,type:101}),Me(k.canceled())},q=ie.onCancellationRequested(Je);ae=(0,P.combinedDisposable)((0,P.toDisposable)(Je),q),this.activeRequests.add(ae)}).finally(()=>{this.activeRequests.delete(ae)})}requestEvent(H,z,J){const ie=this.lastRequestId++,K={id:ie,type:102,channelName:H,name:z,arg:J};let X=null;const ae=new y.Emitter({onFirstListenerAdd:()=>{X=(0,t.createCancelablePromise)(be=>this.whenInitialized()),X.then(()=>{X=null,this.activeRequests.add(ae),this.sendRequest(K)})},onLastListenerRemove:()=>{X?(X.cancel(),X=null):(this.activeRequests.delete(ae),this.sendRequest({id:ie,type:103}))}}),fe=be=>ae.fire(be.data);return this.handlers.set(ie,fe),ae.event}sendRequest(H){switch(H.type){case 100:case 102:{const z=this.send([H.type,H.id,H.channelName,H.name],H.arg);this.logger&&this.logger.logOutgoing(z,H.id,0,`${p(H.type)}: ${H.channelName}.${H.name}`,H.arg);return}case 101:case 103:{const z=this.send([H.type,H.id]);this.logger&&this.logger.logOutgoing(z,H.id,0,p(H.type));return}}}send(H,z=void 0){const J=new u;return r(J,H),r(J,z),this.sendBuffer(J.buffer)}sendBuffer(H){try{return this.protocol.send(H),H.byteLength}catch{return 0}}onBuffer(H){const z=new D(H),J=c(z),ie=c(z),se=J[0];switch(se){case 200:return this.logger&&this.logger.logIncoming(H.byteLength,0,0,E(se)),this.onResponse({type:J[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(H.byteLength,J[1],0,E(se),ie),this.onResponse({type:J[0],id:J[1],data:ie})}}onResponse(H){if(H.type===200){this.state=F.Idle,this._onDidInitialize.fire();return}const z=this.handlers.get(H.id);z&&z(H)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===F.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(H=>H.dispose()),this.activeRequests.clear()}}je([R.memoize],m.prototype,"onDidInitializePromise",null),e.ChannelClient=m;class v{constructor(H){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,H(({protocol:z,onDidClientDisconnect:J})=>{y.Event.once(z.onMessage)(se=>{const K=new D(se),X=c(K),ae=new o(z,X),fe=new m(z);this.channels.forEach((Me,xe)=>ae.registerChannel(xe,Me));const be={channelServer:ae,channelClient:fe,ctx:X};this._connections.add(be),this._onDidAddConnection.fire(be),J(()=>{ae.dispose(),fe.dispose(),this._connections.delete(be),this._onDidRemoveConnection.fire(be)})})})}get connections(){const H=[];return this._connections.forEach(z=>H.push(z)),H}getChannel(H,z){const J=this;return{call(ie,se,K){let X;if((0,l.isFunction)(z)){let fe=(0,f.getRandomElement)(J.connections.filter(z));X=fe?Promise.resolve(fe):y.Event.toPromise(y.Event.filter(J.onDidAddConnection,z))}else X=z.routeCall(J,ie,se);const ae=X.then(fe=>fe.channelClient.getChannel(H));return A(ae).call(ie,se,K)},listen(ie,se){if((0,l.isFunction)(z))return J.getMulticastEvent(H,z,ie,se);const K=z.routeEvent(J,ie,se).then(X=>X.channelClient.getChannel(H));return A(K).listen(ie,se)}}}getMulticastEvent(H,z,J,ie){const se=this;let K=new P.DisposableStore;const X=new y.Emitter({onFirstListenerAdd:()=>{K=new P.DisposableStore;const ae=new y.EventMultiplexer,fe=new Map,be=xe=>{const Je=xe.channelClient.getChannel(H).listen(J,ie),q=ae.add(Je);fe.set(xe,q)},Me=xe=>{const Ge=fe.get(xe);!Ge||(Ge.dispose(),fe.delete(xe))};se.connections.filter(z).forEach(be),y.Event.filter(se.onDidAddConnection,z)(be,void 0,K),se.onDidRemoveConnection(Me,void 0,K),ae.event(X.fire,X,K),K.add(ae)},onLastListenerRemove:()=>{K.dispose()}});return X.event}registerChannel(H,z){this.channels.set(H,z),this._connections.forEach(J=>{J.channelServer.registerChannel(H,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=v;class w{constructor(H,z,J=null){const ie=new u;r(ie,z),H.send(ie.buffer),this.channelClient=new m(H,J),this.channelServer=new o(H,z,J)}getChannel(H){return this.channelClient.getChannel(H)}registerChannel(H,z){this.channelServer.registerChannel(H,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=w;function A(W){return{call(H,z,J){return W.then(ie=>ie.call(H,z,J))},listen(H,z){const J=new y.Relay;return W.then(ie=>J.input=ie.listen(H,z)),J.event}}}e.getDelayedChannel=A;function M(W){let H=!1;return{call(z,J,ie){return H?W.call(z,J,ie):(0,t.timeout)(0).then(()=>H=!0).then(()=>W.call(z,J,ie))},listen(z,J){if(H)return W.listen(z,J);const ie=new y.Relay;return(0,t.timeout)(0).then(()=>H=!0).then(()=>ie.input=W.listen(z,J)),ie.event}}}e.getNextTickChannel=M;class T{constructor(H){this.fn=H}routeCall(H){return this.route(H)}routeEvent(H){return this.route(H)}async route(H){for(const z of H.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await y.Event.toPromise(H.onDidAddConnection),await this.route(H)}}e.StaticRouter=T;var O;(function(W){function H(se,K){const X=se,ae=K&&K.disableMarshalling,fe=new Map;for(const be in X)J(be)&&fe.set(be,y.Event.buffer(X[be],!0));return new class{listen(be,Me,xe){const Ge=fe.get(Me);if(Ge)return Ge;if(ie(Me)){const Je=X[Me];if(typeof Je=="function")return Je.call(X,xe)}throw new Error(`Event not found: ${Me}`)}call(be,Me,xe){const Ge=X[Me];if(typeof Ge=="function"){if(!ae&&Array.isArray(xe))for(let Je=0;Je<xe.length;Je++)xe[Je]=(0,L.revive)(xe[Je]);return Ge.apply(X,xe)}throw new Error(`Method not found: ${Me}`)}}}W.fromService=H;function z(se,K){const X=K&&K.disableMarshalling;return new Proxy({},{get(ae,fe){if(typeof fe=="string")return K?.properties?.has(fe)?K.properties.get(fe):ie(fe)?function(be){return se.listen(fe,be)}:J(fe)?se.listen(fe):async function(...be){let Me;K&&!(0,l.isUndefinedOrNull)(K.context)?Me=[K.context,...be]:Me=be;const xe=await se.call(fe,Me);return X?xe:(0,L.revive)(xe)};throw new Error(`Property not found: ${String(fe)}`)}})}W.toService=z;function J(se){return se[0]==="o"&&se[1]==="n"&&C.isUpperAsciiLetter(se.charCodeAt(2))}function ie(se){return/^onDynamic/.test(se)&&C.isUpperAsciiLetter(se.charCodeAt(9))}})(O=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){let H=W.toString();if(H!=="[object Object]")return H}return W}function x(W){return Array.isArray(W)?W.map(V):V(W)}function N(W,H,z,J,ie,se,K){K=x(K);const X=U[ie],ae=X[J%X.length];let fe=[`%c[${W}]%c[${String(H).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${ae}`];/\($/.test(se)?(fe=fe.concat(K),fe.push(")")):fe.push(K),console.log.apply(console,fe)}e.logWithColors=N;class B{constructor(H,z){this._outgoingPrefix=H,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(H,z,J,ie,se){this._totalOutgoing+=H,N(this._outgoingPrefix,this._totalOutgoing,H,z,J,ie,se)}logIncoming(H,z,J,ie,se){this._totalIncoming+=H,N(this._incomingPrefix,this._totalIncoming,H,z,J,ie,se)}}e.IPCLogger=B}),define(pe[107],ve([0,1,22,3,6,106]),function(Z,e,f,t,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(R=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var k;(function(i){i.enableDiagnostics=!1,i.records=[];const r=new WeakMap;let c=0;function o(m,v){if(!r.has(m)){const w=String(++c);r.set(m,w)}return r.get(m)}function d(m,v,w,A){if(!i.enableDiagnostics)return;const M=o(m,v);if(A instanceof f.VSBuffer||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const T=f.VSBuffer.alloc(A.byteLength);T.set(A),i.records.push({timestamp:Date.now(),id:M,label:v,type:w,buff:T})}else i.records.push({timestamp:Date.now(),id:M,label:v,type:w,data:A})}i.traceSocketEvent=d})(k=e.SocketDiagnostics||(e.SocketDiagnostics={}));var y;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function L(){return P||(P=f.VSBuffer.alloc(0)),P}class C{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,c){if(r===0)return L();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const v=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=r),v}if(this._chunks[0].byteLength>r){const v=this._chunks[0].slice(0,r);return c&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),v}let o=f.VSBuffer.alloc(r),d=0,m=0;for(;r>0;){const v=this._chunks[m];if(v.byteLength>r){const w=v.slice(0,r);o.set(w,d),d+=r,c&&(this._chunks[m]=v.slice(r),this._totalLength-=r),r-=r}else o.set(v,d),d+=v.byteLength,c?(this._chunks.shift(),this._totalLength-=v.byteLength):m++,r-=v.byteLength}return o}}e.ChunkStream=C;var l;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(l||(l={}));function b(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var p;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(r,c,o,d){this.type=r,this.id=c,this.ack=o,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class E extends I.Disposable{constructor(r){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:b(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const o=this._state.messageType,d=this._state.id,m=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",c),this._onMessage.fire(new g(o,d,m,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class F{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=f.VSBuffer.alloc(13);c.writeUInt8(r.type,0),c.writeUInt32BE(r.id,1),c.writeUInt32BE(r.ack,5),c.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:b(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(c,r.data)}_bufferAdd(r,c){const o=this._totalLength===0;return this._data.push(r,c),this._totalLength+=r.byteLength+c.byteLength,o}_bufferTake(){const r=f.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,c){this._bufferAdd(r,c)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class D extends I.Disposable{constructor(r){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new F(this._socket)),this._socketReader=this._register(new E(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new g(1,0,0,r))}}e.Protocol=D;class u extends _.IPCClient{constructor(r,c,o=null){super(r,c,o);this.protocol=r}static fromSocket(r,c){return new u(new D(r),c)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=u;class s{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=s;class h{constructor(r){this.data=r,this.next=null}}class n{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],c=0,o=this._first;for(;o;)r[c++]=o.data,o=o.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const c=new h(r);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class S{constructor(){this.lastRuns=[];const r=Date.now();for(let c=0;c<S._HISTORY_LENGTH;c++)this.lastRuns[c]=r-1e3*c;setInterval(()=>{for(let c=S._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return S._INSTANCE||(S._INSTANCE=new S),S._INSTANCE}load(){const r=Date.now(),c=(1+S._HISTORY_LENGTH)*1e3;let o=0;for(let d=0;d<S._HISTORY_LENGTH;d++)r-this.lastRuns[d]<=c&&o++;return 1-o/S._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}S._HISTORY_LENGTH=10,S._INSTANCE=null;class a{constructor(r,c=null,o=S.getInstance()){this._onControlMessage=new s,this.onControlMessage=this._onControlMessage.event,this._onMessage=new s,this.onMessage=this._onMessage.event,this._onDidDispose=new s,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new s,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new s,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new F(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new E(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),c&&this._socketReader.acceptChunk(c)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,I.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new g(5,0,0,L());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new g(7,0,0,L());this._socketWriter.write(r)}sendResume(){const r=new g(8,0,0,L());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,c){this._isReconnecting=!0,this._socketDisposables=(0,I.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new F(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new E(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new g(3,0,this._incomingAckId,L());this._socketWriter.write(r);const c=this._outgoingUnackMsg.toArray();for(let o=0,d=c.length;o<d;o++)this._socketWriter.write(c[o]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new g(6,0,0,L())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const c=this._outgoingUnackMsg.toArray();for(let o=0,d=c.length;o<d;o++)this._socketWriter.write(c[o]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new g(1,c,this._incomingAckId,r);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(r){const c=new g(2,0,0,r);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),c=Date.now()-r.writtenTime,o=Date.now()-this._socketReader.lastReadTime,d=Date.now()-this._lastSocketTimeoutTime;if(c>=2e4&&o>=2e4&&d>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const m=Math.max(2e4-c,2e4-o,2e4-d,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},m)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new g(3,0,this._incomingAckId,L());this._socketWriter.write(r)}}e.PersistentProtocol=a}),define(pe[108],ve([0,1,100]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(k){const y=(0,f.toUint8)(k);this._defaultValue=y,this._asciiMap=t._createAsciiMap(y),this._map=new Map}static _createAsciiMap(k){const y=new Uint8Array(256);for(let P=0;P<256;P++)y[P]=k;return y}set(k,y){const P=(0,f.toUint8)(y);k>=0&&k<256?this._asciiMap[k]=P:this._map.set(k,P)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=t;var I;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(I||(I={}));class _{constructor(){this._actual=new t(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=_}),define(pe[145],ve([0,1,108]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends f.CharacterClassifier{constructor(k){super(0);for(let y=0,P=k.length;y<P;y++)this.set(k.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function _(R){const k={};return y=>(k.hasOwnProperty(y)||(k[y]=R(y)),k[y])}e.getMapForWordSeparators=_(R=>new I(R))}),define(pe[48],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class f{constructor(I,_){this.lineNumber=I,this.column=_}with(I=this.lineNumber,_=this.column){return I===this.lineNumber&&_===this.column?this:new f(I,_)}delta(I=0,_=0){return this.with(this.lineNumber+I,this.column+_)}equals(I){return f.equals(this,I)}static equals(I,_){return!I&&!_?!0:!!I&&!!_&&I.lineNumber===_.lineNumber&&I.column===_.column}isBefore(I){return f.isBefore(this,I)}static isBefore(I,_){return I.lineNumber<_.lineNumber?!0:_.lineNumber<I.lineNumber?!1:I.column<_.column}isBeforeOrEqual(I){return f.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,_){return I.lineNumber<_.lineNumber?!0:_.lineNumber<I.lineNumber?!1:I.column<=_.column}static compare(I,_){const R=I.lineNumber|0,k=_.lineNumber|0;if(R===k){const y=I.column|0,P=_.column|0;return y-P}return R-k}clone(){return new f(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new f(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=f}),define(pe[41],ve([0,1,48]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(_,R,k,y){_>k||_===k&&R>y?(this.startLineNumber=k,this.startColumn=y,this.endLineNumber=_,this.endColumn=R):(this.startLineNumber=_,this.startColumn=R,this.endLineNumber=k,this.endColumn=y)}isEmpty(){return t.isEmpty(this)}static isEmpty(_){return _.startLineNumber===_.endLineNumber&&_.startColumn===_.endColumn}containsPosition(_){return t.containsPosition(this,_)}static containsPosition(_,R){return!(R.lineNumber<_.startLineNumber||R.lineNumber>_.endLineNumber||R.lineNumber===_.startLineNumber&&R.column<_.startColumn||R.lineNumber===_.endLineNumber&&R.column>_.endColumn)}static strictContainsPosition(_,R){return!(R.lineNumber<_.startLineNumber||R.lineNumber>_.endLineNumber||R.lineNumber===_.startLineNumber&&R.column<=_.startColumn||R.lineNumber===_.endLineNumber&&R.column>=_.endColumn)}containsRange(_){return t.containsRange(this,_)}static containsRange(_,R){return!(R.startLineNumber<_.startLineNumber||R.endLineNumber<_.startLineNumber||R.startLineNumber>_.endLineNumber||R.endLineNumber>_.endLineNumber||R.startLineNumber===_.startLineNumber&&R.startColumn<_.startColumn||R.endLineNumber===_.endLineNumber&&R.endColumn>_.endColumn)}strictContainsRange(_){return t.strictContainsRange(this,_)}static strictContainsRange(_,R){return!(R.startLineNumber<_.startLineNumber||R.endLineNumber<_.startLineNumber||R.startLineNumber>_.endLineNumber||R.endLineNumber>_.endLineNumber||R.startLineNumber===_.startLineNumber&&R.startColumn<=_.startColumn||R.endLineNumber===_.endLineNumber&&R.endColumn>=_.endColumn)}plusRange(_){return t.plusRange(this,_)}static plusRange(_,R){let k,y,P,L;return R.startLineNumber<_.startLineNumber?(k=R.startLineNumber,y=R.startColumn):R.startLineNumber===_.startLineNumber?(k=R.startLineNumber,y=Math.min(R.startColumn,_.startColumn)):(k=_.startLineNumber,y=_.startColumn),R.endLineNumber>_.endLineNumber?(P=R.endLineNumber,L=R.endColumn):R.endLineNumber===_.endLineNumber?(P=R.endLineNumber,L=Math.max(R.endColumn,_.endColumn)):(P=_.endLineNumber,L=_.endColumn),new t(k,y,P,L)}intersectRanges(_){return t.intersectRanges(this,_)}static intersectRanges(_,R){let k=_.startLineNumber,y=_.startColumn,P=_.endLineNumber,L=_.endColumn,C=R.startLineNumber,l=R.startColumn,b=R.endLineNumber,p=R.endColumn;return k<C?(k=C,y=l):k===C&&(y=Math.max(y,l)),P>b?(P=b,L=p):P===b&&(L=Math.min(L,p)),k>P||k===P&&y>L?null:new t(k,y,P,L)}equalsRange(_){return t.equalsRange(this,_)}static equalsRange(_,R){return!!_&&!!R&&_.startLineNumber===R.startLineNumber&&_.startColumn===R.startColumn&&_.endLineNumber===R.endLineNumber&&_.endColumn===R.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(_){return new f.Position(_.endLineNumber,_.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(_){return new f.Position(_.startLineNumber,_.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(_,R){return new t(this.startLineNumber,this.startColumn,_,R)}setStartPosition(_,R){return new t(_,R,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(_){return new t(_.startLineNumber,_.startColumn,_.startLineNumber,_.startColumn)}static fromPositions(_,R=_){return new t(_.lineNumber,_.column,R.lineNumber,R.column)}static lift(_){return _?new t(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn):null}static isIRange(_){return _&&typeof _.startLineNumber=="number"&&typeof _.startColumn=="number"&&typeof _.endLineNumber=="number"&&typeof _.endColumn=="number"}static areIntersectingOrTouching(_,R){return!(_.endLineNumber<R.startLineNumber||_.endLineNumber===R.startLineNumber&&_.endColumn<R.startColumn||R.endLineNumber<_.startLineNumber||R.endLineNumber===_.startLineNumber&&R.endColumn<_.startColumn)}static areIntersecting(_,R){return!(_.endLineNumber<R.startLineNumber||_.endLineNumber===R.startLineNumber&&_.endColumn<=R.startColumn||R.endLineNumber<_.startLineNumber||R.endLineNumber===_.startLineNumber&&R.endColumn<=_.startColumn)}static compareRangesUsingStarts(_,R){if(_&&R){const P=_.startLineNumber|0,L=R.startLineNumber|0;if(P===L){const C=_.startColumn|0,l=R.startColumn|0;if(C===l){const b=_.endLineNumber|0,p=R.endLineNumber|0;if(b===p){const g=_.endColumn|0,E=R.endColumn|0;return g-E}return b-p}return C-l}return P-L}return(_?1:0)-(R?1:0)}static compareRangesUsingEnds(_,R){return _.endLineNumber===R.endLineNumber?_.endColumn===R.endColumn?_.startLineNumber===R.startLineNumber?_.startColumn-R.startColumn:_.startLineNumber-R.startLineNumber:_.endColumn-R.endColumn:_.endLineNumber-R.endLineNumber}static spansMultipleLines(_){return _.endLineNumber>_.startLineNumber}}e.Range=t}),define(pe[146],ve([0,1,48,41]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class _ extends t.Range{constructor(k,y,P,L){super(k,y,P,L);this.selectionStartLineNumber=k,this.selectionStartColumn=y,this.positionLineNumber=P,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return _.selectionsEqual(this,k)}static selectionsEqual(k,y){return k.selectionStartLineNumber===y.selectionStartLineNumber&&k.selectionStartColumn===y.selectionStartColumn&&k.positionLineNumber===y.positionLineNumber&&k.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,y){return this.getDirection()===0?new _(this.startLineNumber,this.startColumn,k,y):new _(k,y,this.startLineNumber,this.startColumn)}getPosition(){return new f.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new f.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,y){return this.getDirection()===0?new _(k,y,this.endLineNumber,this.endColumn):new _(this.endLineNumber,this.endColumn,k,y)}static fromPositions(k,y=k){return new _(k.lineNumber,k.column,y.lineNumber,y.column)}static fromRange(k,y){return y===0?new _(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new _(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new _(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,y){if(k&&!y||!k&&y)return!1;if(!k&&!y)return!0;if(k.length!==y.length)return!1;for(let P=0,L=k.length;P<L;P++)if(!this.selectionsEqual(k[P],y[P]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,y,P,L,C){return C===0?new _(k,y,P,L):new _(P,L,k,y)}}e.Selection=_}),define(pe[147],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var f;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(f=e.IndentAction||(e.IndentAction={}));class t{constructor(k){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=k.open,this.close=k.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(k.notIn))for(let y=0,P=k.notIn.length;y<P;y++)switch(k.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(k){switch(k){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(k,y){if(k.getTokenCount()===0)return!0;const P=k.findTokenIndexAtOffset(y-2),L=k.getStandardTokenType(P);return this.isOK(L)}_findNeutralCharacterInRange(k,y){for(let P=k;P<=y;P++){const L=String.fromCharCode(P);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class I{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of k)_(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),_(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),_(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),_(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&_(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=I;function _(R,k,y){R.has(k)?R.get(k).push(y):R.set(k,[y])}}),define(pe[82],ve([0,1,32,9]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(_,R,k,y){if(Array.isArray(_)){let P=0;for(const L of _){const C=I(L,R,k,y);if(C===10)return C;C>P&&(P=C)}return P}else{if(typeof _=="string")return y?_==="*"?5:_===k?10:0:0;if(_){const{language:P,pattern:L,scheme:C,hasAccessToAllModels:l}=_;if(!y&&!l)return 0;let b=0;if(C)if(C===R.scheme)b=10;else if(C==="*")b=5;else return 0;if(P)if(P===k)b=10;else if(P==="*")b=Math.max(b,5);else return 0;if(L){let p;if(typeof L=="string"?p=L:p={...L,base:(0,t.normalize)(L.base)},p===R.fsPath||(0,f.match)(p,R.fsPath))b=10;else return 0}return b}else return 0}}e.score=I}),define(pe[148],ve([0,1,108]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var t;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class I{constructor(p,g,E){const F=new Uint8Array(p*g);for(let D=0,u=p*g;D<u;D++)F[D]=E;this._data=F,this.rows=p,this.cols=g}get(p,g){return this._data[p*this.cols+g]}set(p,g,E){this._data[p*this.cols+g]=E}}e.Uint8Matrix=I;class _{constructor(p){let g=0,E=0;for(let D=0,u=p.length;D<u;D++){const[s,h,n]=p[D];h>g&&(g=h),s>E&&(E=s),n>E&&(E=n)}g++,E++;const F=new I(E,g,0);for(let D=0,u=p.length;D<u;D++){const[s,h,n]=p[D];F.set(s,h,n)}this._states=F,this._maxCharCode=g}nextState(p,g){return g<0||g>=this._maxCharCode?0:this._states.get(p,g)}}e.StateMachine=_;let R=null;function k(){return R===null&&(R=new _([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var y;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let P=null;function L(){if(P===null){P=new f.CharacterClassifier(0);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let g=0;g<b.length;g++)P.set(b.charCodeAt(g),1);const p=".,;";for(let g=0;g<p.length;g++)P.set(p.charCodeAt(g),2)}return P}class C{static _createLink(p,g,E,F,D){let u=D-1;do{const s=g.charCodeAt(u);if(p.get(s)!==2)break;u--}while(u>F);if(F>0){const s=g.charCodeAt(F-1),h=g.charCodeAt(u);(s===40&&h===41||s===91&&h===93||s===123&&h===125)&&u--}return{range:{startLineNumber:E,startColumn:F+1,endLineNumber:E,endColumn:u+2},url:g.substring(F,u+1)}}static computeLinks(p,g=k()){const E=L(),F=[];for(let D=1,u=p.getLineCount();D<=u;D++){const s=p.getLineContent(D),h=s.length;let n=0,S=0,a=0,i=1,r=!1,c=!1,o=!1,d=!1;for(;n<h;){let m=!1;const v=s.charCodeAt(n);if(i===13){let w;switch(v){case 40:r=!0,w=0;break;case 41:w=r?0:1;break;case 91:o=!0,c=!0,w=0;break;case 93:o=!1,w=c?0:1;break;case 123:d=!0,w=0;break;case 125:w=d?0:1;break;case 39:w=a===34||a===96?0:1;break;case 34:w=a===39||a===96?0:1;break;case 96:w=a===39||a===34?0:1;break;case 42:w=a===42?1:0;break;case 124:w=a===124?1:0;break;case 32:w=o?0:1;break;default:w=E.get(v)}w===1&&(F.push(C._createLink(E,s,D,S,n)),m=!0)}else if(i===12){let w;v===91?(c=!0,w=0):w=E.get(v),w===1?m=!0:i=13}else i=g.nextState(i,v),i===0&&(m=!0);m&&(i=1,r=!1,c=!1,d=!1,S=n+1,a=v),n++}i===13&&F.push(C._createLink(E,s,D,S,h))}return F}}e.LinkComputer=C;function l(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:C.computeLinks(b)}e.computeLinks=l}),define(pe[149],ve([0,1,3,6]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class I{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new f.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,y){return this._map.set(k,y),this.fire([k]),(0,t.toDisposable)(()=>{this._map.get(k)===y&&(this._map.delete(k),this.fire([k]))})}registerFactory(k,y){this._factories.get(k)?.dispose();const P=new _(this,k,y);return this._factories.set(k,P),(0,t.toDisposable)(()=>{const L=this._factories.get(k);!L||L!==P||(this._factories.delete(k),L.dispose())})}async getOrCreate(k){const y=this.get(k);if(y)return y;const P=this._factories.get(k);return!P||P.isResolved?null:(await P.resolve(),this.get(k))}get(k){return this._map.get(k)||null}isResolved(k){if(this.get(k))return!0;const P=this._factories.get(k);return!!(!P||P.isResolved)}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=I;class _ extends t.Disposable{constructor(k,y,P){super();this._registry=k,this._languageId=y,this._factory=P,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const k=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,k&&!this._isDisposed&&this._register(this._registry.register(this._languageId,k))}}}),define(pe[109],ve([0,1,25]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(E){E[E.Left=1]="Left",E[E.Center=2]="Center",E[E.Right=4]="Right",E[E.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(E){E[E.Inline=1]="Inline",E[E.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var _;(function(E){E[E.Both=0]="Both",E[E.Right=1]="Right",E[E.Left=2]="Left",E[E.None=3]="None"})(_=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var R;(function(E){E[E.TextDefined=0]="TextDefined",E[E.LF=1]="LF",E[E.CRLF=2]="CRLF"})(R=e.EndOfLinePreference||(e.EndOfLinePreference={}));var k;(function(E){E[E.LF=1]="LF",E[E.CRLF=2]="CRLF"})(k=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(E){E[E.LF=0]="LF",E[E.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class P{constructor(F){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,F.tabSize|0),this.indentSize=F.tabSize|0,this.insertSpaces=Boolean(F.insertSpaces),this.defaultEOL=F.defaultEOL|0,this.trimAutoWhitespace=Boolean(F.trimAutoWhitespace),this.bracketPairColorizationOptions=F.bracketPairColorizationOptions}equals(F){return this.tabSize===F.tabSize&&this.indentSize===F.indentSize&&this.insertSpaces===F.insertSpaces&&this.defaultEOL===F.defaultEOL&&this.trimAutoWhitespace===F.trimAutoWhitespace&&(0,f.equals)(this.bracketPairColorizationOptions,F.bracketPairColorizationOptions)}createChangeEvent(F){return{tabSize:this.tabSize!==F.tabSize,indentSize:this.indentSize!==F.indentSize,insertSpaces:this.insertSpaces!==F.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==F.trimAutoWhitespace}}}e.TextModelResolvedOptions=P;class L{constructor(F,D){this._findMatchBrand=void 0,this.range=F,this.matches=D}}e.FindMatch=L;var C;(function(E){E[E.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",E[E.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",E[E.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",E[E.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var l;(function(E){E[E.Left=0]="Left",E[E.Right=1]="Right",E[E.None=2]="None"})(l=e.PositionAffinity||(e.PositionAffinity={}));var b;(function(E){E[E.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(b=e.ModelConstants||(e.ModelConstants={}));class p{constructor(F,D,u,s,h,n){this.identifier=F,this.range=D,this.text=u,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=h,this._isTracked=n}}e.ValidAnnotatedEditOperation=p;class g{constructor(F,D,u){this.reverseEdits=F,this.changes=D,this.trimAutoWhitespaceLineNumbers=u}}e.ApplyEditsResult=g}),define(pe[150],ve([0,1,8,145,48,41,109]),function(Z,e,f,t,I,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class y{constructor(u,s,h,n){this.searchString=u,this.isRegex=s,this.matchCase=h,this.wordSeparators=n}parseSearchRequest(){if(this.searchString==="")return null;let u;this.isRegex?u=P(this.searchString):u=this.searchString.indexOf(`
`)>=0;let s=null;try{s=f.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:u,global:!0,unicode:!0})}catch{return null}if(!s)return null;let h=!this.isRegex&&!u;return h&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(h=this.matchCase),new L(s,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,h?this.searchString:null)}}e.SearchParams=y;function P(D){if(!D||D.length===0)return!1;for(let u=0,s=D.length;u<s;u++)if(D.charCodeAt(u)===92){if(u++,u>=s)break;const n=D.charCodeAt(u);if(n===110||n===114||n===87)return!0}return!1}e.isMultilineRegexSource=P;class L{constructor(u,s,h){this.regex=u,this.wordSeparators=s,this.simpleSearch=h}}e.SearchData=L;function C(D,u,s){if(!s)return new R.FindMatch(D,null);const h=[];for(let n=0,S=u.length;n<S;n++)h[n]=u[n];return new R.FindMatch(D,h)}e.createFindMatch=C;class l{constructor(u){const s=[];let h=0;for(let n=0,S=u.length;n<S;n++)u.charCodeAt(n)===10&&(s[h++]=n);this._lineFeedsOffsets=s}findLineFeedCountBeforeOffset(u){const s=this._lineFeedsOffsets;let h=0,n=s.length-1;if(n===-1||u<=s[0])return 0;for(;h<n;){const S=h+((n-h)/2>>0);s[S]>=u?n=S-1:s[S+1]>=u?(h=S,n=S):h=S+1}return h+1}}class b{static findMatches(u,s,h,n,S){const a=s.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(u,h,new F(a.wordSeparators,a.regex),n,S):this._doFindMatchesLineByLine(u,h,a,n,S):[]}static _getMultilineMatchRange(u,s,h,n,S,a){let i,r=0;n?(r=n.findLineFeedCountBeforeOffset(S),i=s+S+r):i=s+S;let c;if(n){const v=n.findLineFeedCountBeforeOffset(S+a.length)-r;c=i+a.length+v}else c=i+a.length;const o=u.getPositionAt(i),d=u.getPositionAt(c);return new _.Range(o.lineNumber,o.column,d.lineNumber,d.column)}static _doFindMatchesMultiline(u,s,h,n,S){const a=u.getOffsetAt(s.getStartPosition()),i=u.getValueInRange(s,1),r=u.getEOL()===`\r
`?new l(i):null,c=[];let o=0,d;for(h.reset(0);d=h.next(i);)if(c[o++]=C(this._getMultilineMatchRange(u,a,i,r,d.index,d[0]),d,n),o>=S)return c;return c}static _doFindMatchesLineByLine(u,s,h,n,S){const a=[];let i=0;if(s.startLineNumber===s.endLineNumber){const c=u.getLineContent(s.startLineNumber).substring(s.startColumn-1,s.endColumn-1);return i=this._findMatchesInLine(h,c,s.startLineNumber,s.startColumn-1,i,a,n,S),a}const r=u.getLineContent(s.startLineNumber).substring(s.startColumn-1);i=this._findMatchesInLine(h,r,s.startLineNumber,s.startColumn-1,i,a,n,S);for(let c=s.startLineNumber+1;c<s.endLineNumber&&i<S;c++)i=this._findMatchesInLine(h,u.getLineContent(c),c,0,i,a,n,S);if(i<S){const c=u.getLineContent(s.endLineNumber).substring(0,s.endColumn-1);i=this._findMatchesInLine(h,c,s.endLineNumber,0,i,a,n,S)}return a}static _findMatchesInLine(u,s,h,n,S,a,i,r){const c=u.wordSeparators;if(!i&&u.simpleSearch){const m=u.simpleSearch,v=m.length,w=s.length;let A=-v;for(;(A=s.indexOf(m,A+v))!==-1;)if((!c||E(c,s,w,A,v))&&(a[S++]=new R.FindMatch(new _.Range(h,A+1+n,h,A+1+v+n),null),S>=r))return S;return S}const o=new F(u.wordSeparators,u.regex);let d;o.reset(0);do if(d=o.next(s),d&&(a[S++]=C(new _.Range(h,d.index+1+n,h,d.index+1+d[0].length+n),d,i),S>=r))return S;while(d);return S}static findNextMatch(u,s,h,n){const S=s.parseSearchRequest();if(!S)return null;const a=new F(S.wordSeparators,S.regex);return S.regex.multiline?this._doFindNextMatchMultiline(u,h,a,n):this._doFindNextMatchLineByLine(u,h,a,n)}static _doFindNextMatchMultiline(u,s,h,n){const S=new I.Position(s.lineNumber,1),a=u.getOffsetAt(S),i=u.getLineCount(),r=u.getValueInRange(new _.Range(S.lineNumber,S.column,i,u.getLineMaxColumn(i)),1),c=u.getEOL()===`\r
`?new l(r):null;h.reset(s.column-1);let o=h.next(r);return o?C(this._getMultilineMatchRange(u,a,r,c,o.index,o[0]),o,n):s.lineNumber!==1||s.column!==1?this._doFindNextMatchMultiline(u,new I.Position(1,1),h,n):null}static _doFindNextMatchLineByLine(u,s,h,n){const S=u.getLineCount(),a=s.lineNumber,i=u.getLineContent(a),r=this._findFirstMatchInLine(h,i,a,s.column,n);if(r)return r;for(let c=1;c<=S;c++){const o=(a+c-1)%S,d=u.getLineContent(o+1),m=this._findFirstMatchInLine(h,d,o+1,1,n);if(m)return m}return null}static _findFirstMatchInLine(u,s,h,n,S){u.reset(n-1);const a=u.next(s);return a?C(new _.Range(h,a.index+1,h,a.index+1+a[0].length),a,S):null}static findPreviousMatch(u,s,h,n){const S=s.parseSearchRequest();if(!S)return null;const a=new F(S.wordSeparators,S.regex);return S.regex.multiline?this._doFindPreviousMatchMultiline(u,h,a,n):this._doFindPreviousMatchLineByLine(u,h,a,n)}static _doFindPreviousMatchMultiline(u,s,h,n){const S=this._doFindMatchesMultiline(u,new _.Range(1,1,s.lineNumber,s.column),h,n,10*k);if(S.length>0)return S[S.length-1];const a=u.getLineCount();return s.lineNumber!==a||s.column!==u.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(u,new I.Position(a,u.getLineMaxColumn(a)),h,n):null}static _doFindPreviousMatchLineByLine(u,s,h,n){const S=u.getLineCount(),a=s.lineNumber,i=u.getLineContent(a).substring(0,s.column-1),r=this._findLastMatchInLine(h,i,a,n);if(r)return r;for(let c=1;c<=S;c++){const o=(S+a-c-1)%S,d=u.getLineContent(o+1),m=this._findLastMatchInLine(h,d,o+1,n);if(m)return m}return null}static _findLastMatchInLine(u,s,h,n){let S=null,a;for(u.reset(0);a=u.next(s);)S=C(new _.Range(h,a.index+1,h,a.index+1+a[0].length),a,n);return S}}e.TextModelSearch=b;function p(D,u,s,h,n){if(h===0)return!0;const S=u.charCodeAt(h-1);if(D.get(S)!==0||S===13||S===10)return!0;if(n>0){const a=u.charCodeAt(h);if(D.get(a)!==0)return!0}return!1}function g(D,u,s,h,n){if(h+n===s)return!0;const S=u.charCodeAt(h+n);if(D.get(S)!==0||S===13||S===10)return!0;if(n>0){const a=u.charCodeAt(h+n-1);if(D.get(a)!==0)return!0}return!1}function E(D,u,s,h,n){return p(D,u,s,h,n)&&g(D,u,s,h,n)}e.isValidMatch=E;class F{constructor(u,s){this._wordSeparators=u,this._searchRegex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(u){this._searchRegex.lastIndex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(u){const s=u.length;let h;do{if(this._prevMatchStartIndex+this._prevMatchLength===s||(h=this._searchRegex.exec(u),!h))return null;const n=h.index,S=h[0].length;if(n===this._prevMatchStartIndex&&S===this._prevMatchLength){if(S===0){f.getNextCodePoint(u,s,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=n,this._prevMatchLength=S,!this._wordSeparators||E(this._wordSeparators,u,s,n,S))return h}while(h);return null}}e.Searcher=F}),define(pe[110],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function f(k=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)k.indexOf(P)>=0||(y+="\\"+P);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=f();function t(k){let y=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)y=k;else{let P="g";k.ignoreCase&&(P+="i"),k.multiline&&(P+="m"),k.unicode&&(P+="u"),y=new RegExp(k.source,P)}return y.lastIndex=0,y}e.ensureValidWordDefinition=t;const I={maxLen:1e3,windowSize:15,timeBudget:150};function _(k,y,P,L,C=I){if(P.length>C.maxLen){let E=k-C.maxLen/2;return E<0?E=0:L+=E,P=P.substring(E,k+C.maxLen/2),_(k,y,P,L,C)}const l=Date.now(),b=k-1-L;let p=-1,g=null;for(let E=1;!(Date.now()-l>=C.timeBudget);E++){const F=b-C.windowSize*E;y.lastIndex=Math.max(0,F);const D=R(y,P,b,p);if(!D&&g||(g=D,F<=0))break;p=F}if(g){const E={word:g[0],startColumn:L+1+g.index,endColumn:L+1+g.index+g[0].length};return y.lastIndex=0,E}return null}e.getWordAtText=_;function R(k,y,P,L){let C;for(;C=k.exec(y);){const l=C.index||0;if(l<=P&&k.lastIndex>=P)return C;if(L>0&&l>L)return null}return null}}),define(pe[111],ve([0,1,22,12]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(I||(I={}));function _(C){for(let l=0,b=C.length;l<b;l+=4){const p=C[l+0],g=C[l+1],E=C[l+2],F=C[l+3];C[l+0]=F,C[l+1]=E,C[l+2]=g,C[l+3]=p}}function R(C){const l=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return t.isLittleEndian()||_(l),f.VSBuffer.wrap(l)}function k(C){const l=C.buffer;if(t.isLittleEndian()||_(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const b=new Uint8Array(l.byteLength);return b.set(l),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function y(C){const l=new Uint32Array(P(C));let b=0;if(l[b++]=C.id,C.type==="full")l[b++]=1,l[b++]=C.data.length,l.set(C.data,b),b+=C.data.length;else{l[b++]=2,l[b++]=C.deltas.length;for(const p of C.deltas)l[b++]=p.start,l[b++]=p.deleteCount,p.data?(l[b++]=p.data.length,l.set(p.data,b),b+=p.data.length):l[b++]=0}return R(l)}e.encodeSemanticTokensDto=y;function P(C){let l=0;if(l+=1+1,C.type==="full")l+=1+C.data.length;else{l+=1,l+=(1+1+1)*C.deltas.length;for(const b of C.deltas)b.data&&(l+=b.data.length)}return l}function L(C){const l=k(C);let b=0;const p=l[b++];if(l[b++]===1){const D=l[b++],u=l.subarray(b,b+D);return b+=D,{id:p,type:"full",data:u}}const E=l[b++],F=[];for(let D=0;D<E;D++){const u=l[b++],s=l[b++],h=l[b++];let n;h>0&&(n=l.subarray(b,b+h),b+=h),F[D]={start:u,deleteCount:s,data:n}}return{id:p,type:"delta",deltas:F}}e.decodeSemanticTokensDto=L}),define(pe[112],ve([0,1,17,100]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class I{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,P){y=(0,t.toUint32)(y);const L=this.values,C=this.prefixSum,l=P.length;return l===0?!1:(this.values=new Uint32Array(L.length+l),this.values.set(L.subarray(0,y),0),this.values.set(L.subarray(y),y+l),this.values.set(P,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(y,P){return y=(0,t.toUint32)(y),P=(0,t.toUint32)(P),this.values[y]===P?!1:(this.values[y]=P,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,P){y=(0,t.toUint32)(y),P=(0,t.toUint32)(P);const L=this.values,C=this.prefixSum;if(y>=L.length)return!1;const l=L.length-y;return P>=l&&(P=l),P===0?!1:(this.values=new Uint32Array(L.length-P),this.values.set(L.subarray(0,y),0),this.values.set(L.subarray(y+P),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(y){return y<0?0:(y=(0,t.toUint32)(y),this._getPrefixSum(y))}_getPrefixSum(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let P=this.prefixSumValidIndex[0]+1;P===0&&(this.prefixSum[0]=this.values[0],P++),y>=this.values.length&&(y=this.values.length-1);for(let L=P;L<=y;L++)this.prefixSum[L]=this.prefixSum[L-1]+this.values[L];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalSum();let P=0,L=this.values.length-1,C=0,l=0,b=0;for(;P<=L;)if(C=P+(L-P)/2|0,l=this.prefixSum[C],b=l-this.values[C],y<b)L=C-1;else if(y>=l)P=C+1;else break;return new R(C,y-b)}}e.PrefixSumComputer=I;class _{constructor(y){this._values=y,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(y){return this._ensureValid(),y===0?0:this._prefixSum[y-1]}getIndexOf(y){this._ensureValid();const P=this._indexBySum[y],L=P>0?this._prefixSum[P-1]:0;return new R(P,y-L)}removeValues(y,P){this._values.splice(y,P),this._invalidate(y)}insertValues(y,P){this._values=(0,f.arrayInsert)(this._values,y,P),this._invalidate(y)}_invalidate(y){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,y-1)}_ensureValid(){if(!this._isValid){for(let y=this._validEndIndex+1,P=this._values.length;y<P;y++){const L=this._values[y],C=y>0?this._prefixSum[y-1]:0;this._prefixSum[y]=C+L;for(let l=0;l<L;l++)this._indexBySum[C+l]=y}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(y,P){this._values[y]!==P&&(this._values[y]=P,this._invalidate(y))}}e.ConstantTimePrefixSumComputer=_;class R{constructor(y,P){this.index=y,this.remainder=P,this._prefixSumIndexOfResultBrand=void 0,this.index=y,this.remainder=P}}e.PrefixSumIndexOfResult=R}),define(pe[151],ve([0,1,8,48,112]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class _{constructor(k,y,P,L){this._uri=k,this._lines=y,this._eol=P,this._versionId=L,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const y=k.changes;for(const P of y)this._acceptDeleteRange(P.range),this._acceptInsertText(new t.Position(P.range.startLineNumber,P.range.startColumn),P.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,y=this._lines.length,P=new Uint32Array(y);for(let L=0;L<y;L++)P[L]=this._lines[L].length+k;this._lineStarts=new I.PrefixSumComputer(P)}}_setLineText(k,y){this._lines[k]=y,this._lineStarts&&this._lineStarts.setValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,y){if(y.length===0)return;const P=(0,f.splitLines)(y);if(P.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+P[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}P[P.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+P[0]);const L=new Uint32Array(P.length-1);for(let C=1;C<P.length;C++)this._lines.splice(k.lineNumber+C-1,0,P[C]),L[C-1]=P[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,L)}}e.MirrorTextModel=_}),define(pe[152],ve([19,20]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(pe[153],ve([0,1,152]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,I=t*60,_=I*24,R=_*7,k=_*30,y=_*365;function P(C,l,b){typeof C!="number"&&(C=C.getTime());const p=Math.round((new Date().getTime()-C)/1e3);if(p<-30)return(0,f.localize)(0,null,P(new Date().getTime()+p*1e3,!1));if(p<30)return(0,f.localize)(1,null);let g;return p<t?(g=p,l?g===1?b?(0,f.localize)(2,null,g):(0,f.localize)(3,null,g):b?(0,f.localize)(4,null,g):(0,f.localize)(5,null,g):g===1?b?(0,f.localize)(6,null,g):(0,f.localize)(7,null,g):b?(0,f.localize)(8,null,g):(0,f.localize)(9,null,g)):p<I?(g=Math.floor(p/t),l?g===1?b?(0,f.localize)(10,null,g):(0,f.localize)(11,null,g):b?(0,f.localize)(12,null,g):(0,f.localize)(13,null,g):g===1?b?(0,f.localize)(14,null,g):(0,f.localize)(15,null,g):b?(0,f.localize)(16,null,g):(0,f.localize)(17,null,g)):p<_?(g=Math.floor(p/I),l?g===1?b?(0,f.localize)(18,null,g):(0,f.localize)(19,null,g):b?(0,f.localize)(20,null,g):(0,f.localize)(21,null,g):g===1?b?(0,f.localize)(22,null,g):(0,f.localize)(23,null,g):b?(0,f.localize)(24,null,g):(0,f.localize)(25,null,g)):p<R?(g=Math.floor(p/_),l?g===1?(0,f.localize)(26,null,g):(0,f.localize)(27,null,g):g===1?(0,f.localize)(28,null,g):(0,f.localize)(29,null,g)):p<k?(g=Math.floor(p/R),l?g===1?b?(0,f.localize)(30,null,g):(0,f.localize)(31,null,g):b?(0,f.localize)(32,null,g):(0,f.localize)(33,null,g):g===1?b?(0,f.localize)(34,null,g):(0,f.localize)(35,null,g):b?(0,f.localize)(36,null,g):(0,f.localize)(37,null,g)):p<y?(g=Math.floor(p/k),l?g===1?b?(0,f.localize)(38,null,g):(0,f.localize)(39,null,g):b?(0,f.localize)(40,null,g):(0,f.localize)(41,null,g):g===1?b?(0,f.localize)(42,null,g):(0,f.localize)(43,null,g):b?(0,f.localize)(44,null,g):(0,f.localize)(45,null,g)):(g=Math.floor(p/y),l?g===1?b?(0,f.localize)(46,null,g):(0,f.localize)(47,null,g):b?(0,f.localize)(48,null,g):(0,f.localize)(49,null,g):g===1?b?(0,f.localize)(50,null,g):(0,f.localize)(51,null,g):b?(0,f.localize)(52,null,g):(0,f.localize)(53,null,g))}e.fromNow=P;function L(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(pe[154],ve([19,20]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(pe[49],ve([0,1,17,18,154]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function _(P,L){return L&&(P.stack||P.stacktrace)?I.localize(0,null,k(P),R(P.stack)||R(P.stacktrace)):k(P)}function R(P){return Array.isArray(P)?P.join(`
`):P}function k(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?I.localize(1,null,P.message):P.message||I.localize(2,null)}function y(P=null,L=!1){if(!P)return I.localize(3,null);if(Array.isArray(P)){const C=f.coalesce(P),l=y(C[0],L);return C.length>1?I.localize(4,null,l,C.length):l}if(t.isString(P))return P;if(P.detail){const C=P.detail;if(C.error)return _(C.error,L);if(C.exception)return _(C.exception,L)}return P.stack?_(P,L):P.message?P.message:I.localize(5,null)}e.toErrorMessage=y}),define(pe[155],ve([19,20]),function(Z,e){return Z.create("vs/base/node/processes",e)}),define(pe[113],ve([0,1,37,29,10,25,9,12,40,96,18,144,30,155]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function p(n){switch(n){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(n,S){if(k.isWindows)try{const a={stdio:["pipe","pipe","ignore"]};S&&(a.cwd=S);const i=f.execFile("taskkill",["/T","/F","/PID",n.pid.toString()],a);return new Promise(r=>{i.once("error",c=>{r({success:!1,error:c})}),i.once("exit",(c,o)=>{r(c===0?{success:!0}:{success:!1,code:c!==null?c:1})})})}catch(a){return Promise.resolve({success:!1,error:a,code:a.status?p(a.status):1})}else if(k.isLinux||k.isMacintosh)try{const a=I.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Z).fsPath;return new Promise(i=>{f.execFile(a,[n.pid.toString()],{encoding:"utf8",shell:!0},(r,c,o)=>{i(r?{success:!1,error:r}:{success:!0})})})}catch(a){return Promise.resolve({success:!1,error:a})}else n.kill("SIGKILL");return Promise.resolve({success:!0})}function E(n){!n||(delete n.DEBUG,k.isMacintosh&&delete n.DYLD_LIBRARY_PATH,k.isLinux&&delete n.LD_PRELOAD)}e.removeDangerousEnvVariables=E;function F(n=y.env){return n.comspec||"cmd.exe"}e.getWindowsShell=F;class D{constructor(S,a,i,r){if(a!==void 0&&i!==void 0&&r!==void 0)this.cmd=S,this.args=a,this.shell=i,this.options=r;else{const c=S;this.cmd=c.command,this.shell=c.isShellCommand,this.args=c.args.slice(0),this.options=c.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const c=Object.create(null);Object.keys(y.env).forEach(o=>{c[o]=y.env[o]}),Object.keys(this.options.env).forEach(o=>{c[o]=this.options.env[o]}),this.options.env=c}}getSanitizedCommand(){let S=this.cmd.toLowerCase();const a=S.lastIndexOf(R.sep);return a!==-1&&(S=S.substring(a+1)),D.WellKnowCommands[S]?S:"other"}start(S){return k.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(y.cwd()))?Promise.reject(new Error(b.localize(0,null))):this.useExec().then(a=>{let i,r;const c=new Promise((o,d)=>{i=o,r=d});if(a){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=f.exec(o,this.options,(d,m,v)=>{this.childProcess=null;const w=d;w&&w.killed?r({killed:this.terminateRequested,stdout:m.toString(),stderr:v.toString()}):this.handleExec(i,S,d,m,v)})}else{let o=null;const d=m=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(m,i,S,r);const v={terminated:this.terminateRequested};L.isNumber(m)&&(v.cmdCode=m),i(v)};if(this.shell&&k.isWindows){const m=_.deepClone(this.options);m.windowsVerbatimArguments=!0,m.detached=!1;let v=!1,w=!1;const A=[];let M=this.ensureQuotes(this.cmd);A.push(M.value),v=M.quoted,this.args&&this.args.forEach(O=>{M=this.ensureQuotes(O),A.push(M.value),w=w&&M.quoted});const T=["/s","/c"];v?w?T.push('"'+A.join(" ")+'"'):A.length>1?T.push('"'+A[0]+'" '+A.slice(1).join(" ")):T.push('"'+A[0]+'"'):T.push(A.join(" ")),o=f.spawn(F(),T,m)}else this.cmd&&(o=f.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(L.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",m=>{this.childProcess=null,r({terminated:this.terminateRequested,error:m})}),o.pid&&(this.childProcess.on("close",d),this.handleSpawn(o,i,S,r,!0)))}return c})}handleClose(S,a,i,r){}ensureQuotes(S){return D.regexp.test(S)?{value:'"'+S+'"',quoted:!0}:{value:S,quoted:S.length>0&&S[0]==='"'&&S[S.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(S=>S.pid,S=>-1):new Promise(S=>{this.pidResolve=S})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(S=>(this.terminateRequested=!0,g(S,this.options.cwd).then(a=>(a.success&&(this.childProcess=null),a))),S=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(S=>{if(!this.shell||!k.isWindows)return S(!1);const a=f.spawn(F(),["/s","/c"]);a.on("error",i=>S(!0)),a.on("exit",i=>S(!1))})}}e.AbstractProcess=D,D.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},D.regexp=/^[^"].* .*[^"]/;class u extends D{constructor(S,a,i,r){super(S,a,i,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(S,a,i,r,c){[r,c].forEach((o,d)=>{const m=new C.LineDecoder;m.write(o).forEach(A=>{a({line:A,source:d===0?0:1})});const w=m.end();w&&a({line:w,source:d===0?0:1})}),S({terminated:this.terminateRequested,error:i})}handleSpawn(S,a,i,r,c){const o=new C.LineDecoder,d=new C.LineDecoder;S.stdout.on("data",m=>{o.write(m).forEach(w=>i({line:w,source:0}))}),S.stderr.on("data",m=>{d.write(m).forEach(w=>i({line:w,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=d}handleClose(S,a,i,r){const c=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;c&&i({line:c,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&i({line:o,source:1})}}e.LineProcess=u;function s(n){let S=[],a=!1;const i=function(r){if(a){S.push(r);return}(!n.send(r,o=>{if(o&&console.error(o),a=!1,S.length>0){const d=S.slice(0);S=[],d.forEach(m=>i(m))}})||k.isWindows)&&(a=!0)};return{send:i}}e.createQueuedSender=s;var h;(function(n){async function S(a,i,r){if(R.isAbsolute(a))return a;if(i===void 0&&(i=y.cwd()),R.dirname(a)!=="."||(r===void 0&&L.isString(y.env.PATH)&&(r=y.env.PATH.split(R.delimiter)),r===void 0||r.length===0))return R.join(i,a);async function o(d){if(await l.Promises.exists(d)){let m;try{m=await l.Promises.stat(d)}catch(v){v.message.startsWith("EACCES")&&(m=await l.Promises.lstat(d))}return m?!m.isDirectory():!1}return!1}for(let d of r){let m;if(R.isAbsolute(d)?m=R.join(d,a):m=R.join(i,d,a),await o(m))return m;let v=m+".com";if(await o(v)||(v=m+".exe",await o(v)))return v}return R.join(i,a)}n.findExecutable=S})(h=e.win32||(e.win32={}))}),define(pe[156],ve([19,20]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(pe[114],ve([0,1,156,12,110,17,25]),function(Z,e,f,t,I,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var k;(function(ee){ee[ee.None=0]="None",ee[ee.Keep=1]="Keep",ee[ee.Brackets=2]="Brackets",ee[ee.Advanced=3]="Advanced",ee[ee.Full=4]="Full"})(k=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ne){this._values=ne}hasChanged(ne){return this._values[ne]}}e.ConfigurationChangedEvent=y;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class L{constructor(ne,Se,re,ye){this.id=ne,this.name=Se,this.defaultValue=re,this.schema=ye}applyUpdate(ne,Se){return l(ne,Se)}compute(ne,Se,re){return re}}class C{constructor(ne,Se){this.newValue=ne,this.didChange=Se}}e.ApplyUpdateResult=C;function l(ee,ne){if(typeof ee!="object"||typeof ne!="object"||!ee||!ne)return new C(ne,ee!==ne);if(Array.isArray(ee)||Array.isArray(ne)){const re=Array.isArray(ee)&&Array.isArray(ne)&&_.equals(ee,ne);return new C(ne,re)}let Se=!1;for(const re in ne)if(ne.hasOwnProperty(re)){const ye=l(ee[re],ne[re]);ye.didChange&&(ee[re]=ye.newValue,Se=!0)}return new C(ee,Se)}class b{constructor(ne){this.schema=void 0,this.id=ne,this.name="_never_",this.defaultValue=void 0}applyUpdate(ne,Se){return l(ne,Se)}validate(ne){return this.defaultValue}}class p{constructor(ne,Se,re,ye){this.id=ne,this.name=Se,this.defaultValue=re,this.schema=ye}applyUpdate(ne,Se){return l(ne,Se)}validate(ne){return typeof ne=="undefined"?this.defaultValue:ne}compute(ne,Se,re){return re}}function g(ee,ne){return typeof ee=="undefined"?ne:ee==="false"?!1:Boolean(ee)}e.boolean=g;class E extends p{constructor(ne,Se,re,ye=void 0){typeof ye!="undefined"&&(ye.type="boolean",ye.default=re);super(ne,Se,re,ye)}validate(ne){return g(ne,this.defaultValue)}}function F(ee,ne,Se,re){if(typeof ee=="undefined")return ne;let ye=parseInt(ee,10);return isNaN(ye)?ne:(ye=Math.max(Se,ye),ye=Math.min(re,ye),ye|0)}e.clampedInt=F;class D extends p{constructor(ne,Se,re,ye,Fe,qe=void 0){typeof qe!="undefined"&&(qe.type="integer",qe.default=re,qe.minimum=ye,qe.maximum=Fe);super(ne,Se,re,qe);this.minimum=ye,this.maximum=Fe}static clampedInt(ne,Se,re,ye){return F(ne,Se,re,ye)}validate(ne){return D.clampedInt(ne,this.defaultValue,this.minimum,this.maximum)}}class u extends p{constructor(ne,Se,re,ye,Fe){typeof Fe!="undefined"&&(Fe.type="number",Fe.default=re);super(ne,Se,re,Fe);this.validationFn=ye}static clamp(ne,Se,re){return ne<Se?Se:ne>re?re:ne}static float(ne,Se){if(typeof ne=="number")return ne;if(typeof ne=="undefined")return Se;const re=parseFloat(ne);return isNaN(re)?Se:re}validate(ne){return this.validationFn(u.float(ne,this.defaultValue))}}class s extends p{static string(ne,Se){return typeof ne!="string"?Se:ne}constructor(ne,Se,re,ye=void 0){typeof ye!="undefined"&&(ye.type="string",ye.default=re);super(ne,Se,re,ye)}validate(ne){return s.string(ne,this.defaultValue)}}function h(ee,ne,Se){return typeof ee!="string"||Se.indexOf(ee)===-1?ne:ee}e.stringSet=h;class n extends p{constructor(ne,Se,re,ye,Fe=void 0){typeof Fe!="undefined"&&(Fe.type="string",Fe.enum=ye,Fe.default=re);super(ne,Se,re,Fe);this._allowedValues=ye}validate(ne){return h(ne,this.defaultValue,this._allowedValues)}}class S extends L{constructor(ne,Se,re,ye,Fe,qe,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.enum=Fe,Ve.default=ye);super(ne,Se,re,Ve);this._allowedValues=Fe,this._convert=qe}validate(ne){return typeof ne!="string"?this.defaultValue:this._allowedValues.indexOf(ne)===-1?this.defaultValue:this._convert(ne)}}function a(ee){switch(ee){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends L{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[f.localize(0,null),f.localize(1,null),f.localize(2,null)],default:"auto",description:f.localize(3,null)})}validate(ne){switch(ne){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ne,Se,re){return re===0?ne.accessibilitySupport:re}}class r extends L{constructor(){const ne={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",ne,{"editor.comments.insertSpace":{type:"boolean",default:ne.insertSpace,description:f.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ne.ignoreEmptyLines,description:f.localize(5,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Se=ne;return{insertSpace:g(Se.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(Se.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var c;(function(ee){ee[ee.Hidden=0]="Hidden",ee[ee.Blink=1]="Blink",ee[ee.Smooth=2]="Smooth",ee[ee.Phase=3]="Phase",ee[ee.Expand=4]="Expand",ee[ee.Solid=5]="Solid"})(c=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function o(ee){switch(ee){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(ee){ee[ee.Line=1]="Line",ee[ee.Block=2]="Block",ee[ee.Underline=3]="Underline",ee[ee.LineThin=4]="LineThin",ee[ee.BlockOutline=5]="BlockOutline",ee[ee.UnderlineThin=6]="UnderlineThin"})(d=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function m(ee){switch(ee){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=m;function v(ee){switch(ee){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class w extends b{constructor(){super(128)}compute(ne,Se,re){const ye=["monaco-editor"];return Se.get(33)&&ye.push(Se.get(33)),ne.extraEditorClassName&&ye.push(ne.extraEditorClassName),Se.get(66)==="default"?ye.push("mouse-default"):Se.get(66)==="copy"&&ye.push("mouse-copy"),Se.get(100)&&ye.push("showUnused"),Se.get(126)&&ye.push("showDeprecated"),ye.join(" ")}}class A extends E{constructor(){super(32,"emptySelectionClipboard",!0,{description:f.localize(6,null)})}compute(ne,Se,re){return re&&ne.emptySelectionClipboard}}class M extends L{constructor(){const ne={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",ne,{"editor.find.cursorMoveOnType":{type:"boolean",default:ne.cursorMoveOnType,description:f.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ne.seedSearchStringFromSelection,enumDescriptions:[f.localize(8,null),f.localize(9,null),f.localize(10,null)],description:f.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ne.autoFindInSelection,enumDescriptions:[f.localize(12,null),f.localize(13,null),f.localize(14,null)],description:f.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ne.globalFindClipboard,description:f.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ne.addExtraSpaceOnTop,description:f.localize(17,null)},"editor.find.loop":{type:"boolean",default:ne.loop,description:f.localize(18,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Se=ne;return{cursorMoveOnType:g(Se.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ne.seedSearchStringFromSelection=="boolean"?ne.seedSearchStringFromSelection?"always":"never":h(Se.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ne.autoFindInSelection=="boolean"?ne.autoFindInSelection?"always":"never":h(Se.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(Se.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(Se.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(Se.loop,this.defaultValue.loop)}}}class T extends L{constructor(){super(45,"fontLigatures",T.OFF,{anyOf:[{type:"boolean",description:f.localize(19,null)},{type:"string",description:f.localize(20,null)}],description:f.localize(21,null),default:!1})}validate(ne){return typeof ne=="undefined"?this.defaultValue:typeof ne=="string"?ne==="false"?T.OFF:ne==="true"?T.ON:ne:Boolean(ne)?T.ON:T.OFF}}e.EditorFontLigatures=T,T.OFF='"liga" off, "calt" off',T.ON='"liga" on, "calt" on';class O extends b{constructor(){super(44)}compute(ne,Se,re){return ne.fontInfo}}class U extends p{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:f.localize(22,null)})}validate(ne){const Se=u.float(ne,this.defaultValue);return Se===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp(Se,6,100)}compute(ne,Se,re){return ne.fontInfo.fontSize}}class V extends L{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.MINIMUM_VALUE,maximum:V.MAXIMUM_VALUE,errorMessage:f.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:f.localize(24,null)})}validate(ne){return ne==="normal"||ne==="bold"?ne:String(D.clampedInt(ne,e.EDITOR_FONT_DEFAULTS.fontWeight,V.MINIMUM_VALUE,V.MAXIMUM_VALUE))}}V.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],V.MINIMUM_VALUE=1,V.MAXIMUM_VALUE=1e3;class x extends L{constructor(){const ne={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Se={type:"string",enum:["peek","gotoAndPeek","goto"],default:ne.multiple,enumDescriptions:[f.localize(25,null),f.localize(26,null),f.localize(27,null)]},re=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",ne,{"editor.gotoLocation.multiple":{deprecationMessage:f.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:f.localize(29,null),...Se},"editor.gotoLocation.multipleTypeDefinitions":{description:f.localize(30,null),...Se},"editor.gotoLocation.multipleDeclarations":{description:f.localize(31,null),...Se},"editor.gotoLocation.multipleImplementations":{description:f.localize(32,null),...Se},"editor.gotoLocation.multipleReferences":{description:f.localize(33,null),...Se},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ne.alternativeDefinitionCommand,enum:re,description:f.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ne.alternativeTypeDefinitionCommand,enum:re,description:f.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ne.alternativeDeclarationCommand,enum:re,description:f.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ne.alternativeImplementationCommand,enum:re,description:f.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ne.alternativeReferenceCommand,enum:re,description:f.localize(38,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Se=ne;return{multiple:h(Se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Se.multipleDefinitions??h(Se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Se.multipleTypeDefinitions??h(Se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Se.multipleDeclarations??h(Se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Se.multipleImplementations??h(Se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Se.multipleReferences??h(Se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:s.string(Se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:s.string(Se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:s.string(Se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:s.string(Se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:s.string(Se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class N extends L{constructor(){const ne={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",ne,{"editor.hover.enabled":{type:"boolean",default:ne.enabled,description:f.localize(39,null)},"editor.hover.delay":{type:"number",default:ne.delay,minimum:0,maximum:1e4,description:f.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:ne.sticky,description:f.localize(41,null)},"editor.hover.above":{type:"boolean",default:ne.above,description:f.localize(42,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Se=ne;return{enabled:g(Se.enabled,this.defaultValue.enabled),delay:D.clampedInt(Se.delay,this.defaultValue.delay,0,1e4),sticky:g(Se.sticky,this.defaultValue.sticky),above:g(Se.above,this.defaultValue.above)}}}var B;(function(ee){ee[ee.None=0]="None",ee[ee.Text=1]="Text",ee[ee.Blocks=2]="Blocks"})(B=e.RenderMinimap||(e.RenderMinimap={}));class W extends b{constructor(){super(131)}compute(ne,Se,re){return W.computeLayout(Se,{memory:ne.memory,outerWidth:ne.outerWidth,outerHeight:ne.outerHeight,isDominatedByLongLines:ne.isDominatedByLongLines,lineHeight:ne.fontInfo.lineHeight,viewLineCount:ne.viewLineCount,lineNumbersDigitCount:ne.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ne.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ne.fontInfo.maxDigitWidth,pixelRatio:ne.pixelRatio})}static computeContainedMinimapLineCount(ne){const Se=ne.height/ne.lineHeight,re=ne.scrollBeyondLastLine?Se-1:0,ye=(ne.viewLineCount+re)/(ne.pixelRatio*ne.height),Fe=Math.floor(ne.viewLineCount/ye);return{typicalViewportLineCount:Se,extraLinesBeyondLastLine:re,desiredRatio:ye,minimapLineCount:Fe}}static _computeMinimapLayout(ne,Se){const re=ne.outerWidth,ye=ne.outerHeight,Fe=ne.pixelRatio;if(!ne.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Fe*ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ye};const qe=Se.stableMinimapLayoutInput,Ve=qe&&ne.outerHeight===qe.outerHeight&&ne.lineHeight===qe.lineHeight&&ne.typicalHalfwidthCharacterWidth===qe.typicalHalfwidthCharacterWidth&&ne.pixelRatio===qe.pixelRatio&&ne.scrollBeyondLastLine===qe.scrollBeyondLastLine&&ne.minimap.enabled===qe.minimap.enabled&&ne.minimap.side===qe.minimap.side&&ne.minimap.size===qe.minimap.size&&ne.minimap.showSlider===qe.minimap.showSlider&&ne.minimap.renderCharacters===qe.minimap.renderCharacters&&ne.minimap.maxColumn===qe.minimap.maxColumn&&ne.minimap.scale===qe.minimap.scale&&ne.verticalScrollbarWidth===qe.verticalScrollbarWidth&&ne.isViewportWrapping===qe.isViewportWrapping,ut=ne.lineHeight,Re=ne.typicalHalfwidthCharacterWidth,Ae=ne.scrollBeyondLastLine,De=ne.minimap.renderCharacters;let ce=Fe>=2?Math.round(ne.minimap.scale*2):ne.minimap.scale;const de=ne.minimap.maxColumn,we=ne.minimap.size,Ce=ne.minimap.side,Oe=ne.verticalScrollbarWidth,Ke=ne.viewLineCount,$e=ne.remainingWidth,Ze=ne.isViewportWrapping,lt=De?2:3;let ct=Math.floor(Fe*ye);const He=ct/Fe;let Ee=!1,_e=!1,he=lt*ce,Y=ce/Fe,ke=1;if(we==="fill"||we==="fit"){const{typicalViewportLineCount:ft,extraLinesBeyondLastLine:wt,desiredRatio:bt,minimapLineCount:Ut}=W.computeContainedMinimapLineCount({viewLineCount:Ke,scrollBeyondLastLine:Ae,height:ye,lineHeight:ut,pixelRatio:Fe});if(Ke/Ut>1)Ee=!0,_e=!0,ce=1,he=1,Y=ce/Fe;else{let Ft=!1,kt=ce+1;if(we==="fit"){const Ct=Math.ceil((Ke+wt)*he);Ze&&Ve&&$e<=Se.stableFitRemainingWidth?(Ft=!0,kt=Se.stableFitMaxMinimapScale):Ft=Ct>ct}if(we==="fill"||Ft){Ee=!0;const Ct=ce;he=Math.min(ut*Fe,Math.max(1,Math.floor(1/bt))),Ze&&Ve&&$e<=Se.stableFitRemainingWidth&&(kt=Se.stableFitMaxMinimapScale),ce=Math.min(kt,Math.max(1,Math.floor(he/lt))),ce>Ct&&(ke=Math.min(2,ce/Ct)),Y=ce/Fe/ke,ct=Math.ceil(Math.max(ft,Ke+wt)*he),Ze?(Se.stableMinimapLayoutInput=ne,Se.stableFitRemainingWidth=$e,Se.stableFitMaxMinimapScale=ce):(Se.stableMinimapLayoutInput=null,Se.stableFitRemainingWidth=0)}}}const Ne=Math.floor(de*Y),Xe=Math.min(Ne,Math.max(0,Math.floor(($e-Oe-2)*Y/(Re+Y)))+e.MINIMAP_GUTTER_WIDTH);let Qe=Math.floor(Fe*Xe);const pt=Qe/Fe;Qe=Math.floor(Qe*ke);const St=De?1:2,yt=Ce==="left"?0:re-Xe-Oe;return{renderMinimap:St,minimapLeft:yt,minimapWidth:Xe,minimapHeightIsEditorHeight:Ee,minimapIsSampling:_e,minimapScale:ce,minimapLineHeight:he,minimapCanvasInnerWidth:Qe,minimapCanvasInnerHeight:ct,minimapCanvasOuterWidth:pt,minimapCanvasOuterHeight:He}}static computeLayout(ne,Se){const re=Se.outerWidth|0,ye=Se.outerHeight|0,Fe=Se.lineHeight|0,qe=Se.lineNumbersDigitCount|0,Ve=Se.typicalHalfwidthCharacterWidth,ut=Se.maxDigitWidth,Re=Se.pixelRatio,Ae=Se.viewLineCount,De=ne.get(123),ce=De==="inherit"?ne.get(122):De,de=ce==="inherit"?ne.get(118):ce,we=ne.get(121),Ce=ne.get(2),Oe=Se.isDominatedByLongLines,Ke=ne.get(50),$e=ne.get(60).renderType!==0,Ze=ne.get(61),lt=ne.get(94),ct=ne.get(65),He=ne.get(92),Ee=He.verticalScrollbarSize,_e=He.verticalHasArrows,he=He.arrowSize,Y=He.horizontalScrollbarSize,ke=ne.get(58),Ne=ne.get(37);let Xe;if(typeof ke=="string"&&/^\d+(\.\d+)?ch$/.test(ke)){const Et=parseFloat(ke.substr(0,ke.length-2));Xe=D.clampedInt(Et*Ve,0,0,1e3)}else Xe=D.clampedInt(ke,0,0,1e3);Ne&&(Xe+=16);let Qe=0;if($e){const Et=Math.max(qe,Ze);Qe=Math.round(Et*ut)}let pt=0;Ke&&(pt=Fe);let St=0,yt=St+pt,ft=yt+Qe,wt=ft+Xe;const bt=re-pt-Qe-Xe;let Ut=!1,Pt=!1,Ft=-1;Ce!==2&&(ce==="inherit"&&Oe?(Ut=!0,Pt=!0):de==="on"||de==="bounded"?Pt=!0:de==="wordWrapColumn"&&(Ft=we));const kt=W._computeMinimapLayout({outerWidth:re,outerHeight:ye,lineHeight:Fe,typicalHalfwidthCharacterWidth:Ve,pixelRatio:Re,scrollBeyondLastLine:lt,minimap:ct,verticalScrollbarWidth:Ee,viewLineCount:Ae,remainingWidth:bt,isViewportWrapping:Pt},Se.memory||new P);kt.renderMinimap!==0&&kt.minimapLeft===0&&(St+=kt.minimapWidth,yt+=kt.minimapWidth,ft+=kt.minimapWidth,wt+=kt.minimapWidth);const Ct=bt-kt.minimapWidth,Qt=Math.max(1,Math.floor((Ct-Ee-2)/Ve)),Vt=_e?he:0;return Pt&&(Ft=Math.max(1,Qt),de==="bounded"&&(Ft=Math.min(Ft,we))),{width:re,height:ye,glyphMarginLeft:St,glyphMarginWidth:pt,lineNumbersLeft:yt,lineNumbersWidth:Qe,decorationsLeft:ft,decorationsWidth:Xe,contentLeft:wt,contentWidth:Ct,minimap:kt,viewportColumn:Qt,isWordWrapMinified:Ut,isViewportWrapping:Pt,wrappingColumn:Ft,verticalScrollbarWidth:Ee,horizontalScrollbarHeight:Y,overviewRuler:{top:Vt,width:Ee,height:ye-2*Vt,right:0}}}}e.EditorLayoutInfoComputer=W;class H extends L{constructor(){const ne={enabled:!0};super(57,"lightbulb",ne,{"editor.lightbulb.enabled":{type:"boolean",default:ne.enabled,description:f.localize(43,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:g(ne.enabled,this.defaultValue.enabled)}}}class z extends L{constructor(){const ne={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",ne,{"editor.inlayHints.enabled":{type:"boolean",default:ne.enabled,description:f.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:ne.fontSize,markdownDescription:f.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:ne.fontFamily,markdownDescription:f.localize(46,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Se=ne;return{enabled:g(Se.enabled,this.defaultValue.enabled),fontSize:D.clampedInt(Se.fontSize,this.defaultValue.fontSize,0,100),fontFamily:s.string(Se.fontFamily,this.defaultValue.fontFamily)}}}class J extends u{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ne=>u.clamp(ne,0,150),{markdownDescription:f.localize(47,null)})}compute(ne,Se,re){return ne.fontInfo.lineHeight}}class ie extends L{constructor(){const ne={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",ne,{"editor.minimap.enabled":{type:"boolean",default:ne.enabled,description:f.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[f.localize(49,null),f.localize(50,null),f.localize(51,null)],default:ne.size,description:f.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ne.side,description:f.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ne.showSlider,description:f.localize(54,null)},"editor.minimap.scale":{type:"number",default:ne.scale,minimum:1,maximum:3,enum:[1,2,3],description:f.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ne.renderCharacters,description:f.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:ne.maxColumn,description:f.localize(57,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Se=ne;return{enabled:g(Se.enabled,this.defaultValue.enabled),size:h(Se.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(Se.side,this.defaultValue.side,["right","left"]),showSlider:h(Se.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(Se.renderCharacters,this.defaultValue.renderCharacters),scale:D.clampedInt(Se.scale,1,1,3),maxColumn:D.clampedInt(Se.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function se(ee){return ee==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class K extends L{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(59,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Se=ne;return{top:D.clampedInt(Se.top,0,0,1e3),bottom:D.clampedInt(Se.bottom,0,0,1e3)}}}class X extends L{constructor(){const ne={enabled:!0,cycle:!1};super(76,"parameterHints",ne,{"editor.parameterHints.enabled":{type:"boolean",default:ne.enabled,description:f.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:ne.cycle,description:f.localize(61,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Se=ne;return{enabled:g(Se.enabled,this.defaultValue.enabled),cycle:g(Se.cycle,this.defaultValue.cycle)}}}class ae extends b{constructor(){super(129)}compute(ne,Se,re){return ne.pixelRatio}}class fe extends L{constructor(){const ne={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",ne,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ne.strings,description:f.localize(62,null)},comments:{type:"boolean",default:ne.comments,description:f.localize(63,null)},other:{type:"boolean",default:ne.other,description:f.localize(64,null)}}}],default:ne,description:f.localize(65,null)});this.defaultValue=ne}validate(ne){if(typeof ne=="boolean")return ne;if(ne&&typeof ne=="object"){const Se=ne,re={other:g(Se.other,this.defaultValue.other),comments:g(Se.comments,this.defaultValue.comments),strings:g(Se.strings,this.defaultValue.strings)};return re.other&&re.comments&&re.strings?!0:!re.other&&!re.comments&&!re.strings?!1:re}return this.defaultValue}}var be;(function(ee){ee[ee.Off=0]="Off",ee[ee.On=1]="On",ee[ee.Relative=2]="Relative",ee[ee.Interval=3]="Interval",ee[ee.Custom=4]="Custom"})(be=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Me extends L{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[f.localize(66,null),f.localize(67,null),f.localize(68,null),f.localize(69,null)],default:"on",description:f.localize(70,null)})}validate(ne){let Se=this.defaultValue.renderType,re=this.defaultValue.renderFn;return typeof ne!="undefined"&&(typeof ne=="function"?(Se=4,re=ne):ne==="interval"?Se=3:ne==="relative"?Se=2:ne==="on"?Se=1:Se=0),{renderType:Se,renderFn:re}}}function xe(ee){const ne=ee.get(87);return ne==="editable"?ee.get(81):ne!=="on"}e.filterValidationDecorations=xe;class Ge extends L{constructor(){const ne=[],Se={type:"number",description:f.localize(71,null)};super(91,"rulers",ne,{type:"array",items:{anyOf:[Se,{type:["object"],properties:{column:Se,color:{type:"string",description:f.localize(72,null),format:"color-hex"}}}]},default:ne,description:f.localize(73,null)})}validate(ne){if(Array.isArray(ne)){const Se=[];for(let re of ne)if(typeof re=="number")Se.push({column:D.clampedInt(re,0,0,1e4),color:null});else if(re&&typeof re=="object"){const ye=re;Se.push({column:D.clampedInt(ye.column,0,0,1e4),color:ye.color})}return Se.sort((re,ye)=>re.column-ye.column),Se}return this.defaultValue}}function Je(ee,ne){if(typeof ee!="string")return ne;switch(ee){case"hidden":return 2;case"visible":return 3;default:return 1}}class q extends L{constructor(){const ne={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",ne,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(74,null),f.localize(75,null),f.localize(76,null)],default:"auto",description:f.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(78,null),f.localize(79,null),f.localize(80,null)],default:"auto",description:f.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ne.verticalScrollbarSize,description:f.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ne.horizontalScrollbarSize,description:f.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ne.scrollByPage,description:f.localize(84,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Se=ne,re=D.clampedInt(Se.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ye=D.clampedInt(Se.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:D.clampedInt(Se.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Je(Se.vertical,this.defaultValue.vertical),horizontal:Je(Se.horizontal,this.defaultValue.horizontal),useShadows:g(Se.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(Se.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(Se.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(Se.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(Se.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:re,horizontalSliderSize:D.clampedInt(Se.horizontalSliderSize,re,0,1e3),verticalScrollbarSize:ye,verticalSliderSize:D.clampedInt(Se.verticalSliderSize,ye,0,1e3),scrollByPage:g(Se.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class te extends L{constructor(){const ne={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",ne,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ne.nonBasicASCII,description:f.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ne.invisibleCharacters,description:f.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ne.ambiguousCharacters,description:f.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ne.includeComments,description:f.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ne.includeStrings,description:f.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ne.allowedCharacters,description:f.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ne.allowedLocales,description:f.localize(91,null)}})}applyUpdate(ne,Se){let re=!1;Se.allowedCharacters&&(R.equals(ne.allowedCharacters,Se.allowedCharacters)||(ne={...ne,allowedCharacters:Se.allowedCharacters},re=!0)),Se.allowedLocales&&(R.equals(ne.allowedLocales,Se.allowedLocales)||(ne={...ne,allowedLocales:Se.allowedLocales},re=!0));const ye=super.applyUpdate(ne,Se);return re?new C(ye.newValue,!0):ye}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Se=ne;return{nonBasicASCII:me(Se.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:g(Se.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:g(Se.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:me(Se.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:me(Se.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(ne.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(ne.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(ne,Se){if(typeof ne!="object"||!ne)return Se;const re={};for(const[ye,Fe]of Object.entries(ne))Fe===!0&&(re[ye]=!0);return re}}class G extends L{constructor(){const ne={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",ne,{"editor.inlineSuggest.enabled":{type:"boolean",default:ne.enabled,description:f.localize(92,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Se=ne;return{enabled:g(Se.enabled,this.defaultValue.enabled),mode:h(Se.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class Q extends L{constructor(){const ne={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",ne,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ne.enabled,description:f.localize(93,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:g(ne.enabled,this.defaultValue.enabled)}}}class oe extends L{constructor(){const ne={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",ne,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[f.localize(94,null),f.localize(95,null),f.localize(96,null)],default:ne.bracketPairs,description:f.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[f.localize(98,null),f.localize(99,null),f.localize(100,null)],default:ne.bracketPairsHorizontal,description:f.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ne.highlightActiveBracketPair,description:f.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:ne.indentation,description:f.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:ne.highlightActiveIndentation,description:f.localize(104,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Se=ne;return{bracketPairs:me(Se.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:me(Se.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:g(Se.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:g(Se.indentation,this.defaultValue.indentation),highlightActiveIndentation:g(Se.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function me(ee,ne,Se){const re=Se.indexOf(ee);return re===-1?ne:Se[re]}class Ie extends L{constructor(){const ne={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",ne,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[f.localize(105,null),f.localize(106,null)],default:ne.insertMode,description:f.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ne.filterGraceful,description:f.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:ne.localityBonus,description:f.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ne.shareSuggestSelections,markdownDescription:f.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ne.snippetsPreventQuickSuggestions,description:f.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:ne.showIcons,description:f.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ne.showStatusBar,description:f.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:ne.preview,description:f.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ne.showInlineDetails,description:f.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:f.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:f.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:f.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:f.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:f.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:f.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:f.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:f.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:f.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:f.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:f.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:f.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:f.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:f.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:f.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:f.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:f.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:f.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:f.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:f.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:f.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:f.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:f.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:f.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:f.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:f.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:f.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:f.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:f.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:f.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:f.localize(146,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Se=ne;return{insertMode:h(Se.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(Se.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(Se.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(Se.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(Se.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:g(Se.showIcons,this.defaultValue.showIcons),showStatusBar:g(Se.showStatusBar,this.defaultValue.showStatusBar),preview:g(Se.preview,this.defaultValue.preview),previewMode:h(Se.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:g(Se.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(Se.showMethods,this.defaultValue.showMethods),showFunctions:g(Se.showFunctions,this.defaultValue.showFunctions),showConstructors:g(Se.showConstructors,this.defaultValue.showConstructors),showDeprecated:g(Se.showDeprecated,this.defaultValue.showDeprecated),showFields:g(Se.showFields,this.defaultValue.showFields),showVariables:g(Se.showVariables,this.defaultValue.showVariables),showClasses:g(Se.showClasses,this.defaultValue.showClasses),showStructs:g(Se.showStructs,this.defaultValue.showStructs),showInterfaces:g(Se.showInterfaces,this.defaultValue.showInterfaces),showModules:g(Se.showModules,this.defaultValue.showModules),showProperties:g(Se.showProperties,this.defaultValue.showProperties),showEvents:g(Se.showEvents,this.defaultValue.showEvents),showOperators:g(Se.showOperators,this.defaultValue.showOperators),showUnits:g(Se.showUnits,this.defaultValue.showUnits),showValues:g(Se.showValues,this.defaultValue.showValues),showConstants:g(Se.showConstants,this.defaultValue.showConstants),showEnums:g(Se.showEnums,this.defaultValue.showEnums),showEnumMembers:g(Se.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(Se.showKeywords,this.defaultValue.showKeywords),showWords:g(Se.showWords,this.defaultValue.showWords),showColors:g(Se.showColors,this.defaultValue.showColors),showFiles:g(Se.showFiles,this.defaultValue.showFiles),showReferences:g(Se.showReferences,this.defaultValue.showReferences),showFolders:g(Se.showFolders,this.defaultValue.showFolders),showTypeParameters:g(Se.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(Se.showSnippets,this.defaultValue.showSnippets),showUsers:g(Se.showUsers,this.defaultValue.showUsers),showIssues:g(Se.showIssues,this.defaultValue.showIssues)}}}class We extends L{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:f.localize(147,null),default:!0,type:"boolean"}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(ne.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Ye extends b{constructor(){super(130)}compute(ne,Se,re){return Se.get(81)?!0:ne.tabFocusMode}}var it;(function(ee){ee[ee.None=0]="None",ee[ee.Same=1]="Same",ee[ee.Indent=2]="Indent",ee[ee.DeepIndent=3]="DeepIndent"})(it=e.WrappingIndent||(e.WrappingIndent={}));function st(ee){switch(ee){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ot extends b{constructor(){super(132)}compute(ne,Se,re){const ye=Se.get(131);return{isDominatedByLongLines:ne.isDominatedByLongLines,isWordWrapMinified:ye.isWordWrapMinified,isViewportWrapping:ye.isViewportWrapping,wrappingColumn:ye.wrappingColumn}}}const tt="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",gt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?rt:t.isLinux?gt:tt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Ue(ee){return e.editorOptionsRegistry[ee.id]=ee,ee}var It;(function(ee){ee[ee.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ee[ee.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ee[ee.accessibilitySupport=2]="accessibilitySupport",ee[ee.accessibilityPageSize=3]="accessibilityPageSize",ee[ee.ariaLabel=4]="ariaLabel",ee[ee.autoClosingBrackets=5]="autoClosingBrackets",ee[ee.autoClosingDelete=6]="autoClosingDelete",ee[ee.autoClosingOvertype=7]="autoClosingOvertype",ee[ee.autoClosingQuotes=8]="autoClosingQuotes",ee[ee.autoIndent=9]="autoIndent",ee[ee.automaticLayout=10]="automaticLayout",ee[ee.autoSurround=11]="autoSurround",ee[ee.bracketPairColorization=12]="bracketPairColorization",ee[ee.guides=13]="guides",ee[ee.codeLens=14]="codeLens",ee[ee.codeLensFontFamily=15]="codeLensFontFamily",ee[ee.codeLensFontSize=16]="codeLensFontSize",ee[ee.colorDecorators=17]="colorDecorators",ee[ee.columnSelection=18]="columnSelection",ee[ee.comments=19]="comments",ee[ee.contextmenu=20]="contextmenu",ee[ee.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",ee[ee.cursorBlinking=22]="cursorBlinking",ee[ee.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",ee[ee.cursorStyle=24]="cursorStyle",ee[ee.cursorSurroundingLines=25]="cursorSurroundingLines",ee[ee.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",ee[ee.cursorWidth=27]="cursorWidth",ee[ee.disableLayerHinting=28]="disableLayerHinting",ee[ee.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",ee[ee.domReadOnly=30]="domReadOnly",ee[ee.dragAndDrop=31]="dragAndDrop",ee[ee.emptySelectionClipboard=32]="emptySelectionClipboard",ee[ee.extraEditorClassName=33]="extraEditorClassName",ee[ee.fastScrollSensitivity=34]="fastScrollSensitivity",ee[ee.find=35]="find",ee[ee.fixedOverflowWidgets=36]="fixedOverflowWidgets",ee[ee.folding=37]="folding",ee[ee.foldingStrategy=38]="foldingStrategy",ee[ee.foldingHighlight=39]="foldingHighlight",ee[ee.foldingImportsByDefault=40]="foldingImportsByDefault",ee[ee.foldingMaximumRegions=41]="foldingMaximumRegions",ee[ee.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",ee[ee.fontFamily=43]="fontFamily",ee[ee.fontInfo=44]="fontInfo",ee[ee.fontLigatures=45]="fontLigatures",ee[ee.fontSize=46]="fontSize",ee[ee.fontWeight=47]="fontWeight",ee[ee.formatOnPaste=48]="formatOnPaste",ee[ee.formatOnType=49]="formatOnType",ee[ee.glyphMargin=50]="glyphMargin",ee[ee.gotoLocation=51]="gotoLocation",ee[ee.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",ee[ee.hover=53]="hover",ee[ee.inDiffEditor=54]="inDiffEditor",ee[ee.inlineSuggest=55]="inlineSuggest",ee[ee.letterSpacing=56]="letterSpacing",ee[ee.lightbulb=57]="lightbulb",ee[ee.lineDecorationsWidth=58]="lineDecorationsWidth",ee[ee.lineHeight=59]="lineHeight",ee[ee.lineNumbers=60]="lineNumbers",ee[ee.lineNumbersMinChars=61]="lineNumbersMinChars",ee[ee.linkedEditing=62]="linkedEditing",ee[ee.links=63]="links",ee[ee.matchBrackets=64]="matchBrackets",ee[ee.minimap=65]="minimap",ee[ee.mouseStyle=66]="mouseStyle",ee[ee.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",ee[ee.mouseWheelZoom=68]="mouseWheelZoom",ee[ee.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",ee[ee.multiCursorModifier=70]="multiCursorModifier",ee[ee.multiCursorPaste=71]="multiCursorPaste",ee[ee.occurrencesHighlight=72]="occurrencesHighlight",ee[ee.overviewRulerBorder=73]="overviewRulerBorder",ee[ee.overviewRulerLanes=74]="overviewRulerLanes",ee[ee.padding=75]="padding",ee[ee.parameterHints=76]="parameterHints",ee[ee.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",ee[ee.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",ee[ee.quickSuggestions=79]="quickSuggestions",ee[ee.quickSuggestionsDelay=80]="quickSuggestionsDelay",ee[ee.readOnly=81]="readOnly",ee[ee.renameOnType=82]="renameOnType",ee[ee.renderControlCharacters=83]="renderControlCharacters",ee[ee.renderFinalNewline=84]="renderFinalNewline",ee[ee.renderLineHighlight=85]="renderLineHighlight",ee[ee.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",ee[ee.renderValidationDecorations=87]="renderValidationDecorations",ee[ee.renderWhitespace=88]="renderWhitespace",ee[ee.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",ee[ee.roundedSelection=90]="roundedSelection",ee[ee.rulers=91]="rulers",ee[ee.scrollbar=92]="scrollbar",ee[ee.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",ee[ee.scrollBeyondLastLine=94]="scrollBeyondLastLine",ee[ee.scrollPredominantAxis=95]="scrollPredominantAxis",ee[ee.selectionClipboard=96]="selectionClipboard",ee[ee.selectionHighlight=97]="selectionHighlight",ee[ee.selectOnLineNumbers=98]="selectOnLineNumbers",ee[ee.showFoldingControls=99]="showFoldingControls",ee[ee.showUnused=100]="showUnused",ee[ee.snippetSuggestions=101]="snippetSuggestions",ee[ee.smartSelect=102]="smartSelect",ee[ee.smoothScrolling=103]="smoothScrolling",ee[ee.stickyTabStops=104]="stickyTabStops",ee[ee.stopRenderingLineAfter=105]="stopRenderingLineAfter",ee[ee.suggest=106]="suggest",ee[ee.suggestFontSize=107]="suggestFontSize",ee[ee.suggestLineHeight=108]="suggestLineHeight",ee[ee.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",ee[ee.suggestSelection=110]="suggestSelection",ee[ee.tabCompletion=111]="tabCompletion",ee[ee.tabIndex=112]="tabIndex",ee[ee.unicodeHighlighting=113]="unicodeHighlighting",ee[ee.unusualLineTerminators=114]="unusualLineTerminators",ee[ee.useShadowDOM=115]="useShadowDOM",ee[ee.useTabStops=116]="useTabStops",ee[ee.wordSeparators=117]="wordSeparators",ee[ee.wordWrap=118]="wordWrap",ee[ee.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",ee[ee.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",ee[ee.wordWrapColumn=121]="wordWrapColumn",ee[ee.wordWrapOverride1=122]="wordWrapOverride1",ee[ee.wordWrapOverride2=123]="wordWrapOverride2",ee[ee.wrappingIndent=124]="wrappingIndent",ee[ee.wrappingStrategy=125]="wrappingStrategy",ee[ee.showDeprecated=126]="showDeprecated",ee[ee.inlayHints=127]="inlayHints",ee[ee.editorClassName=128]="editorClassName",ee[ee.pixelRatio=129]="pixelRatio",ee[ee.tabFocusMode=130]="tabFocusMode",ee[ee.layoutInfo=131]="layoutInfo",ee[ee.wrappingInfo=132]="wrappingInfo"})(It=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new E(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:f.localize(148,null)})),acceptSuggestionOnEnter:Ue(new n(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",f.localize(149,null),""],markdownDescription:f.localize(150,null)})),accessibilitySupport:Ue(new i),accessibilityPageSize:Ue(new D(3,"accessibilityPageSize",10,1,1073741824,{description:f.localize(151,null)})),ariaLabel:Ue(new s(4,"ariaLabel",f.localize(152,null))),autoClosingBrackets:Ue(new n(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(153,null),f.localize(154,null),""],description:f.localize(155,null)})),autoClosingDelete:Ue(new n(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",f.localize(156,null),""],description:f.localize(157,null)})),autoClosingOvertype:Ue(new n(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",f.localize(158,null),""],description:f.localize(159,null)})),autoClosingQuotes:Ue(new n(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(160,null),f.localize(161,null),""],description:f.localize(162,null)})),autoIndent:Ue(new S(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[f.localize(163,null),f.localize(164,null),f.localize(165,null),f.localize(166,null),f.localize(167,null)],description:f.localize(168,null)})),automaticLayout:Ue(new E(10,"automaticLayout",!1)),autoSurround:Ue(new n(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[f.localize(169,null),f.localize(170,null),f.localize(171,null),""],description:f.localize(172,null)})),bracketPairColorization:Ue(new Q),bracketPairGuides:Ue(new oe),stickyTabStops:Ue(new E(104,"stickyTabStops",!1,{description:f.localize(173,null)})),codeLens:Ue(new E(14,"codeLens",!0,{description:f.localize(174,null)})),codeLensFontFamily:Ue(new s(15,"codeLensFontFamily","",{description:f.localize(175,null)})),codeLensFontSize:Ue(new D(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:f.localize(176,null)})),colorDecorators:Ue(new E(17,"colorDecorators",!0,{description:f.localize(177,null)})),columnSelection:Ue(new E(18,"columnSelection",!1,{description:f.localize(178,null)})),comments:Ue(new r),contextmenu:Ue(new E(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new E(21,"copyWithSyntaxHighlighting",!0,{description:f.localize(179,null)})),cursorBlinking:Ue(new S(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],o,{description:f.localize(180,null)})),cursorSmoothCaretAnimation:Ue(new E(23,"cursorSmoothCaretAnimation",!1,{description:f.localize(181,null)})),cursorStyle:Ue(new S(24,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],v,{description:f.localize(182,null)})),cursorSurroundingLines:Ue(new D(25,"cursorSurroundingLines",0,0,1073741824,{description:f.localize(183,null)})),cursorSurroundingLinesStyle:Ue(new n(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[f.localize(184,null),f.localize(185,null)],description:f.localize(186,null)})),cursorWidth:Ue(new D(27,"cursorWidth",0,0,1073741824,{markdownDescription:f.localize(187,null)})),disableLayerHinting:Ue(new E(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new E(29,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new E(30,"domReadOnly",!1)),dragAndDrop:Ue(new E(31,"dragAndDrop",!0,{description:f.localize(188,null)})),emptySelectionClipboard:Ue(new A),extraEditorClassName:Ue(new s(33,"extraEditorClassName","")),fastScrollSensitivity:Ue(new u(34,"fastScrollSensitivity",5,ee=>ee<=0?5:ee,{markdownDescription:f.localize(189,null)})),find:Ue(new M),fixedOverflowWidgets:Ue(new E(36,"fixedOverflowWidgets",!1)),folding:Ue(new E(37,"folding",!0,{description:f.localize(190,null)})),foldingStrategy:Ue(new n(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[f.localize(191,null),f.localize(192,null)],description:f.localize(193,null)})),foldingHighlight:Ue(new E(39,"foldingHighlight",!0,{description:f.localize(194,null)})),foldingImportsByDefault:Ue(new E(40,"foldingImportsByDefault",!1,{description:f.localize(195,null)})),foldingMaximumRegions:Ue(new D(41,"foldingMaximumRegions",5e3,10,65e3,{description:f.localize(196,null)})),unfoldOnClickAfterEndOfLine:Ue(new E(42,"unfoldOnClickAfterEndOfLine",!1,{description:f.localize(197,null)})),fontFamily:Ue(new s(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:f.localize(198,null)})),fontInfo:Ue(new O),fontLigatures2:Ue(new T),fontSize:Ue(new U),fontWeight:Ue(new V),formatOnPaste:Ue(new E(48,"formatOnPaste",!1,{description:f.localize(199,null)})),formatOnType:Ue(new E(49,"formatOnType",!1,{description:f.localize(200,null)})),glyphMargin:Ue(new E(50,"glyphMargin",!0,{description:f.localize(201,null)})),gotoLocation:Ue(new x),hideCursorInOverviewRuler:Ue(new E(52,"hideCursorInOverviewRuler",!1,{description:f.localize(202,null)})),hover:Ue(new N),inDiffEditor:Ue(new E(54,"inDiffEditor",!1)),letterSpacing:Ue(new u(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ee=>u.clamp(ee,-5,20),{description:f.localize(203,null)})),lightbulb:Ue(new H),lineDecorationsWidth:Ue(new p(58,"lineDecorationsWidth",10)),lineHeight:Ue(new J),lineNumbers:Ue(new Me),lineNumbersMinChars:Ue(new D(61,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new E(62,"linkedEditing",!1,{description:f.localize(204,null)})),links:Ue(new E(63,"links",!0,{description:f.localize(205,null)})),matchBrackets:Ue(new n(64,"matchBrackets","always",["always","near","never"],{description:f.localize(206,null)})),minimap:Ue(new ie),mouseStyle:Ue(new n(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new u(67,"mouseWheelScrollSensitivity",1,ee=>ee===0?1:ee,{markdownDescription:f.localize(207,null)})),mouseWheelZoom:Ue(new E(68,"mouseWheelZoom",!1,{markdownDescription:f.localize(208,null)})),multiCursorMergeOverlapping:Ue(new E(69,"multiCursorMergeOverlapping",!0,{description:f.localize(209,null)})),multiCursorModifier:Ue(new S(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],se,{markdownEnumDescriptions:[f.localize(210,null),f.localize(211,null)],markdownDescription:f.localize(212,null)})),multiCursorPaste:Ue(new n(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[f.localize(213,null),f.localize(214,null)],markdownDescription:f.localize(215,null)})),occurrencesHighlight:Ue(new E(72,"occurrencesHighlight",!0,{description:f.localize(216,null)})),overviewRulerBorder:Ue(new E(73,"overviewRulerBorder",!0,{description:f.localize(217,null)})),overviewRulerLanes:Ue(new D(74,"overviewRulerLanes",3,0,3)),padding:Ue(new K),parameterHints:Ue(new X),peekWidgetDefaultFocus:Ue(new n(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[f.localize(218,null),f.localize(219,null)],description:f.localize(220,null)})),definitionLinkOpensInPeek:Ue(new E(78,"definitionLinkOpensInPeek",!1,{description:f.localize(221,null)})),quickSuggestions:Ue(new fe),quickSuggestionsDelay:Ue(new D(80,"quickSuggestionsDelay",10,0,1073741824,{description:f.localize(222,null)})),readOnly:Ue(new E(81,"readOnly",!1)),renameOnType:Ue(new E(82,"renameOnType",!1,{description:f.localize(223,null),markdownDeprecationMessage:f.localize(224,null)})),renderControlCharacters:Ue(new E(83,"renderControlCharacters",!0,{description:f.localize(225,null),restricted:!0})),renderFinalNewline:Ue(new E(84,"renderFinalNewline",!0,{description:f.localize(226,null)})),renderLineHighlight:Ue(new n(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",f.localize(227,null)],description:f.localize(228,null)})),renderLineHighlightOnlyWhenFocus:Ue(new E(86,"renderLineHighlightOnlyWhenFocus",!1,{description:f.localize(229,null)})),renderValidationDecorations:Ue(new n(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new n(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",f.localize(230,null),f.localize(231,null),f.localize(232,null),""],description:f.localize(233,null)})),revealHorizontalRightPadding:Ue(new D(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ue(new E(90,"roundedSelection",!0,{description:f.localize(234,null)})),rulers:Ue(new Ge),scrollbar:Ue(new q),scrollBeyondLastColumn:Ue(new D(93,"scrollBeyondLastColumn",5,0,1073741824,{description:f.localize(235,null)})),scrollBeyondLastLine:Ue(new E(94,"scrollBeyondLastLine",!0,{description:f.localize(236,null)})),scrollPredominantAxis:Ue(new E(95,"scrollPredominantAxis",!0,{description:f.localize(237,null)})),selectionClipboard:Ue(new E(96,"selectionClipboard",!0,{description:f.localize(238,null),included:t.isLinux})),selectionHighlight:Ue(new E(97,"selectionHighlight",!0,{description:f.localize(239,null)})),selectOnLineNumbers:Ue(new E(98,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new n(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[f.localize(240,null),f.localize(241,null)],description:f.localize(242,null)})),showUnused:Ue(new E(100,"showUnused",!0,{description:f.localize(243,null)})),showDeprecated:Ue(new E(126,"showDeprecated",!0,{description:f.localize(244,null)})),inlayHints:Ue(new z),snippetSuggestions:Ue(new n(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[f.localize(245,null),f.localize(246,null),f.localize(247,null),f.localize(248,null)],description:f.localize(249,null)})),smartSelect:Ue(new We),smoothScrolling:Ue(new E(103,"smoothScrolling",!1,{description:f.localize(250,null)})),stopRenderingLineAfter:Ue(new D(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new Ie),inlineSuggest:Ue(new G),suggestFontSize:Ue(new D(107,"suggestFontSize",0,0,1e3,{markdownDescription:f.localize(251,null)})),suggestLineHeight:Ue(new D(108,"suggestLineHeight",0,0,1e3,{markdownDescription:f.localize(252,null)})),suggestOnTriggerCharacters:Ue(new E(109,"suggestOnTriggerCharacters",!0,{description:f.localize(253,null)})),suggestSelection:Ue(new n(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[f.localize(254,null),f.localize(255,null),f.localize(256,null)],description:f.localize(257,null)})),tabCompletion:Ue(new n(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[f.localize(258,null),f.localize(259,null),f.localize(260,null)],description:f.localize(261,null)})),tabIndex:Ue(new D(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new te),unusualLineTerminators:Ue(new n(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[f.localize(262,null),f.localize(263,null),f.localize(264,null)],description:f.localize(265,null)})),useShadowDOM:Ue(new E(115,"useShadowDOM",!0)),useTabStops:Ue(new E(116,"useTabStops",!0,{description:f.localize(266,null)})),wordSeparators:Ue(new s(117,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:f.localize(267,null)})),wordWrap:Ue(new n(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[f.localize(268,null),f.localize(269,null),f.localize(270,null),f.localize(271,null)],description:f.localize(272,null)})),wordWrapBreakAfterCharacters:Ue(new s(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new s(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new D(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:f.localize(273,null)})),wordWrapOverride1:Ue(new n(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new n(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ue(new S(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],st,{enumDescriptions:[f.localize(274,null),f.localize(275,null),f.localize(276,null),f.localize(277,null)],description:f.localize(278,null)})),wrappingStrategy:Ue(new n(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[f.localize(279,null),f.localize(280,null)],description:f.localize(281,null)})),editorClassName:Ue(new w),pixelRatio:Ue(new ae),tabFocusMode:Ue(new Ye),layoutInfo:Ue(new W),wrappingInfo:Ue(new ot)}}),define(pe[157],ve([19,20]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(pe[158],ve([19,20]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(pe[159],ve([19,20]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(pe[160],ve([19,20]),function(Z,e){return Z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(pe[161],ve([19,20]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(pe[162],ve([19,20]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(pe[163],ve([19,20]),function(Z,e){return Z.create("vs/platform/workspaces/common/workspaces",e)}),define(pe[164],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(pe[165],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(pe[166],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(pe[167],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(pe[168],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(pe[169],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(pe[170],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(pe[171],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/node/extHostDebugService",e)}),define(pe[172],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/node/extHostTunnelService",e)}),define(pe[173],ve([19,20]),function(Z,e){return Z.create("vs/workbench/common/editor",e)}),define(pe[174],ve([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(pe[175],ve([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(pe[176],ve([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(pe[177],ve([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(pe[178],ve([19,20]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(pe[179],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var f;(function(R){R[R.ACTIVATE=1]="ACTIVATE",R[R.RESTORE=2]="RESTORE",R[R.PRESERVE=3]="PRESERVE"})(f=e.EditorActivation||(e.EditorActivation={}));var t;(function(R){R[R.PICK=0]="PICK",R[R.DISABLED=1]="DISABLED",R[R.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var I;(function(R){R[R.API=0]="API",R[R.USER=1]="USER"})(I=e.EditorOpenContext||(e.EditorOpenContext={}));var _;(function(R){R[R.Center=0]="Center",R[R.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",R[R.NearTop=2]="NearTop",R[R.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(_=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(pe[180],ve([0,1,159]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function _(l){return l=l.trim(),l==="*"||t.test(l)}e.isValidVersionStr=_;function R(l){if(!_(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=l.match(t);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=R;function k(l){if(!l)return null;let b=l.majorBase,p=l.majorMustEqual,g=l.minorBase,E=l.minorMustEqual,F=l.patchBase,D=l.patchMustEqual;l.hasCaret&&(b===0||(E=!1),D=!1);let u=0;if(l.preRelease){const s=I.exec(l.preRelease);if(s){const[,h,n,S]=s;u=Date.UTC(Number(h),Number(n)-1,Number(S))}}return{majorBase:b,majorMustEqual:p,minorBase:g,minorMustEqual:E,patchBase:F,patchMustEqual:D,isMinimum:l.hasGreaterEquals,notBefore:u}}e.normalizeVersion=k;function y(l,b,p){let g;typeof l=="string"?g=k(R(l)):g=l;let E;b instanceof Date?E=b.getTime():typeof b=="string"&&(E=new Date(b).getTime());let F;if(typeof p=="string"?F=k(R(p)):F=p,!g||!F)return!1;let D=g.majorBase,u=g.minorBase,s=g.patchBase,h=F.majorBase,n=F.minorBase,S=F.patchBase,a=F.notBefore,i=F.majorMustEqual,r=F.minorMustEqual,c=F.patchMustEqual;return F.isMinimum?D>h?!0:D<h?!1:u>n?!0:u<n||E&&E<a?!1:s>=S:(D===1&&h===0&&(!i||!r||!c)&&(h=1,n=0,S=0,i=!0,r=!1,c=!1),D<h?!1:D>h?!i:u<n?!1:u>n?!r:s<S?!1:s>S?!c:!(E&&E<a))}e.isValidVersion=y;function P(l,b,p,g){return p.isBuiltin||typeof p.main=="undefined"?!0:C(l,b,p.engines.vscode,g)}e.isValidExtensionVersion=P;function L(l,b,p){return l==="*"||C(b,p,l)}e.isEngineValid=L;function C(l,b,p,g=[]){let E=k(R(p));if(!E)return g.push(f.localize(0,null,p)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return g.push(f.localize(1,null,p)),!1}else if(!E.majorMustEqual)return g.push(f.localize(2,null,p)),!1;return y(l,b,E)?!0:(g.push(f.localize(3,null,l,p)),!1)}}),define(pe[115],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class f{constructor(I,_=[],R=!1){this.ctor=I,this.staticArguments=_,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=f}),define(pe[61],ve([0,1,115]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function I(R,k,y){k instanceof f.SyncDescriptor||(k=new f.SyncDescriptor(k,[],y)),t.push([R,k])}e.registerSingleton=I;function _(){return t}e.getSingletonServiceDescriptors=_}),define(pe[181],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class f{constructor(_){this.incoming=new Map,this.outgoing=new Map,this.data=_}}e.Node=f;class t{constructor(_){this._hashFn=_,this._nodes=new Map}roots(){const _=[];for(let R of this._nodes.values())R.outgoing.size===0&&_.push(R);return _}insertEdge(_,R){const k=this.lookupOrInsertNode(_),y=this.lookupOrInsertNode(R);k.outgoing.set(this._hashFn(R),y),y.incoming.set(this._hashFn(_),k)}removeNode(_){const R=this._hashFn(_);this._nodes.delete(R);for(let k of this._nodes.values())k.outgoing.delete(R),k.incoming.delete(R)}lookupOrInsertNode(_){const R=this._hashFn(_);let k=this._nodes.get(R);return k||(k=new f(_),this._nodes.set(R,k)),k}lookup(_){return this._nodes.get(this._hashFn(_))}isEmpty(){return this._nodes.size===0}toString(){let _=[];for(let[R,k]of this._nodes)_.push(`${R}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return _.join(`
`)}findCycleSlow(){for(let[_,R]of this._nodes){const k=new Set([_]),y=this._findCycle(R,k);if(y)return y}}_findCycle(_,R){for(let[k,y]of _.outgoing){if(R.has(k))return[...R,k].join(" -> ");R.add(k);const P=this._findCycle(y,R);if(P)return P;R.delete(k)}}}e.Graph=t}),define(pe[4],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var f;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function k(y){return y[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=k})(f=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function t(R,k,y,P){k[f.DI_TARGET]===k?k[f.DI_DEPENDENCIES].push({id:R,index:y,optional:P}):(k[f.DI_DEPENDENCIES]=[{id:R,index:y,optional:P}],k[f.DI_TARGET]=k)}function I(R){if(f.serviceIds.has(R))return f.serviceIds.get(R);const k=function(y,P,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(k,y,L,!1)};return k.toString=()=>R,f.serviceIds.set(R,k),k}e.createDecorator=I;function _(R){return R}e.refineServiceDecorator=_}),define(pe[182],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,f.createDecorator)("modelService");function t(I){return!I.isTooLargeForSyncing()&&!I.isForSimpleWidget}e.shouldSynchronizeModel=t}),define(pe[183],ve([0,1,3,6,82,182]),function(Z,e,f,t,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRegistry=void 0;function R(y){return typeof y=="string"?!1:Array.isArray(y)?y.every(R):!!y.exclusive}class k{constructor(){this._clock=0,this._entries=[],this._onDidChange=new f.Emitter}get onDidChange(){return this._onDidChange.event}register(P,L){let C={selector:P,provider:L,_score:-1,_time:this._clock++};return this._entries.push(C),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,t.toDisposable)(()=>{if(C){const l=this._entries.indexOf(C);l>=0&&(this._entries.splice(l,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),C=void 0)}})}has(P){return this.all(P).length>0}all(P){if(!P)return[];this._updateScores(P);const L=[];for(let C of this._entries)C._score>0&&L.push(C.provider);return L}ordered(P){const L=[];return this._orderedForEach(P,C=>L.push(C.provider)),L}orderedGroups(P){const L=[];let C,l;return this._orderedForEach(P,b=>{C&&l===b._score?C.push(b.provider):(l=b._score,C=[b.provider],L.push(C))}),L}_orderedForEach(P,L){if(!!P){this._updateScores(P);for(const C of this._entries)C._score>0&&L(C)}}_updateScores(P){const L={uri:P.uri.toString(),language:P.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===L.language&&this._lastCandidate.uri===L.uri)){this._lastCandidate=L;for(let C of this._entries)if(C._score=(0,I.score)(C.selector,P.uri,P.getLanguageId(),(0,_.shouldSynchronizeModel)(P)),R(C.selector)&&C._score>0){for(let l of this._entries)l._score=0;C._score=1e3;break}this._entries.sort(k._compareByScoreAndTime)}}static _compareByScoreAndTime(P,L){return P._score<L._score?1:P._score>L._score?-1:P._time<L._time?1:P._time>L._time?-1:0}}e.LanguageFeatureRegistry=k}),define(pe[83],ve([0,1,2,41,183,149,74]),function(Z,e,f,t,I,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var k;(function(w){w[w.Null=0]="Null",w[w.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));var y;(function(w){w[w.NotSet=-1]="NotSet",w[w.None=0]="None",w[w.Italic=1]="Italic",w[w.Bold=2]="Bold",w[w.Underline=4]="Underline",w[w.Strikethrough=8]="Strikethrough"})(y=e.FontStyle||(e.FontStyle={}));var P;(function(w){w[w.None=0]="None",w[w.DefaultForeground=1]="DefaultForeground",w[w.DefaultBackground=2]="DefaultBackground"})(P=e.ColorId||(e.ColorId={}));var L;(function(w){w[w.Other=0]="Other",w[w.Comment=1]="Comment",w[w.String=2]="String",w[w.RegEx=3]="RegEx"})(L=e.StandardTokenType||(e.StandardTokenType={}));var C;(function(w){w[w.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",w[w.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",w[w.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",w[w.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",w[w.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",w[w.ITALIC_MASK=1024]="ITALIC_MASK",w[w.BOLD_MASK=2048]="BOLD_MASK",w[w.UNDERLINE_MASK=4096]="UNDERLINE_MASK",w[w.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",w[w.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",w[w.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",w[w.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",w[w.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",w[w.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",w[w.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",w[w.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",w[w.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",w[w.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",w[w.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",w[w.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(C=e.MetadataConsts||(e.MetadataConsts={}));class l{static getLanguageId(A){return(A&255)>>>0}static getTokenType(A){return(A&768)>>>8}static getFontStyle(A){return(A&15360)>>>10}static getForeground(A){return(A&8372224)>>>14}static getBackground(A){return(A&4286578688)>>>23}static getClassNameFromMetadata(A){const M=this.getForeground(A);let T="mtk"+M;const O=this.getFontStyle(A);return O&1&&(T+=" mtki"),O&2&&(T+=" mtkb"),O&4&&(T+=" mtku"),O&8&&(T+=" mtks"),T}static getInlineStyleFromMetadata(A,M){const T=this.getForeground(A),O=this.getFontStyle(A);let U=`color: ${M[T]};`;O&1&&(U+="font-style: italic;"),O&2&&(U+="font-weight: bold;");let V="";return O&4&&(V+=" underline"),O&8&&(V+=" line-through"),V&&(U+=`text-decoration:${V};`),U}static getPresentationFromMetadata(A){const M=this.getForeground(A),T=this.getFontStyle(A);return{foreground:M,italic:Boolean(T&1),bold:Boolean(T&2),underline:Boolean(T&4),strikethrough:Boolean(T&8)}}}e.TokenMetadata=l;var b;(function(w){w[w.Method=0]="Method",w[w.Function=1]="Function",w[w.Constructor=2]="Constructor",w[w.Field=3]="Field",w[w.Variable=4]="Variable",w[w.Class=5]="Class",w[w.Struct=6]="Struct",w[w.Interface=7]="Interface",w[w.Module=8]="Module",w[w.Property=9]="Property",w[w.Event=10]="Event",w[w.Operator=11]="Operator",w[w.Unit=12]="Unit",w[w.Value=13]="Value",w[w.Constant=14]="Constant",w[w.Enum=15]="Enum",w[w.EnumMember=16]="EnumMember",w[w.Keyword=17]="Keyword",w[w.Text=18]="Text",w[w.Color=19]="Color",w[w.File=20]="File",w[w.Reference=21]="Reference",w[w.Customcolor=22]="Customcolor",w[w.Folder=23]="Folder",w[w.TypeParameter=24]="TypeParameter",w[w.User=25]="User",w[w.Issue=26]="Issue",w[w.Snippet=27]="Snippet"})(b=e.CompletionItemKind||(e.CompletionItemKind={}));var p;(function(w){const A=new Map;A.set(0,R.Codicon.symbolMethod),A.set(1,R.Codicon.symbolFunction),A.set(2,R.Codicon.symbolConstructor),A.set(3,R.Codicon.symbolField),A.set(4,R.Codicon.symbolVariable),A.set(5,R.Codicon.symbolClass),A.set(6,R.Codicon.symbolStruct),A.set(7,R.Codicon.symbolInterface),A.set(8,R.Codicon.symbolModule),A.set(9,R.Codicon.symbolProperty),A.set(10,R.Codicon.symbolEvent),A.set(11,R.Codicon.symbolOperator),A.set(12,R.Codicon.symbolUnit),A.set(13,R.Codicon.symbolValue),A.set(15,R.Codicon.symbolEnum),A.set(14,R.Codicon.symbolConstant),A.set(15,R.Codicon.symbolEnum),A.set(16,R.Codicon.symbolEnumMember),A.set(17,R.Codicon.symbolKeyword),A.set(27,R.Codicon.symbolSnippet),A.set(18,R.Codicon.symbolText),A.set(19,R.Codicon.symbolColor),A.set(20,R.Codicon.symbolFile),A.set(21,R.Codicon.symbolReference),A.set(22,R.Codicon.symbolCustomColor),A.set(23,R.Codicon.symbolFolder),A.set(24,R.Codicon.symbolTypeParameter),A.set(25,R.Codicon.account),A.set(26,R.Codicon.issues);function M(U){let V=A.get(U);return V||(console.info("No codicon found for CompletionItemKind "+U),V=R.Codicon.symbolProperty),V}w.toIcon=M;const T=new Map;T.set("method",0),T.set("function",1),T.set("constructor",2),T.set("field",3),T.set("variable",4),T.set("class",5),T.set("struct",6),T.set("interface",7),T.set("module",8),T.set("property",9),T.set("event",10),T.set("operator",11),T.set("unit",12),T.set("value",13),T.set("constant",14),T.set("enum",15),T.set("enum-member",16),T.set("enumMember",16),T.set("keyword",17),T.set("snippet",27),T.set("text",18),T.set("color",19),T.set("file",20),T.set("reference",21),T.set("customcolor",22),T.set("folder",23),T.set("type-parameter",24),T.set("typeParameter",24),T.set("account",25),T.set("issue",26);function O(U,V){let x=T.get(U);return typeof x=="undefined"&&!V&&(x=9),x}w.fromString=O})(p=e.CompletionItemKinds||(e.CompletionItemKinds={}));var g;(function(w){w[w.Deprecated=1]="Deprecated"})(g=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(w){w[w.KeepWhitespace=1]="KeepWhitespace",w[w.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var F;(function(w){w[w.Invoke=0]="Invoke",w[w.TriggerCharacter=1]="TriggerCharacter",w[w.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(F=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var D;(function(w){w[w.Automatic=0]="Automatic",w[w.Explicit=1]="Explicit"})(D=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var u;(function(w){w[w.Invoke=1]="Invoke",w[w.Auto=2]="Auto"})(u=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var s;(function(w){w[w.Invoke=1]="Invoke",w[w.TriggerCharacter=2]="TriggerCharacter",w[w.ContentChange=3]="ContentChange"})(s=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var h;(function(w){w[w.Text=0]="Text",w[w.Read=1]="Read",w[w.Write=2]="Write"})(h=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function n(w){return w&&f.URI.isUri(w.uri)&&t.Range.isIRange(w.range)&&(t.Range.isIRange(w.originSelectionRange)||t.Range.isIRange(w.targetSelectionRange))}e.isLocationLink=n;var S;(function(w){w[w.File=0]="File",w[w.Module=1]="Module",w[w.Namespace=2]="Namespace",w[w.Package=3]="Package",w[w.Class=4]="Class",w[w.Method=5]="Method",w[w.Property=6]="Property",w[w.Field=7]="Field",w[w.Constructor=8]="Constructor",w[w.Enum=9]="Enum",w[w.Interface=10]="Interface",w[w.Function=11]="Function",w[w.Variable=12]="Variable",w[w.Constant=13]="Constant",w[w.String=14]="String",w[w.Number=15]="Number",w[w.Boolean=16]="Boolean",w[w.Array=17]="Array",w[w.Object=18]="Object",w[w.Key=19]="Key",w[w.Null=20]="Null",w[w.EnumMember=21]="EnumMember",w[w.Struct=22]="Struct",w[w.Event=23]="Event",w[w.Operator=24]="Operator",w[w.TypeParameter=25]="TypeParameter"})(S=e.SymbolKind||(e.SymbolKind={}));var a;(function(w){w[w.Deprecated=1]="Deprecated"})(a=e.SymbolTag||(e.SymbolTag={}));var i;(function(w){const A=new Map;A.set(0,R.Codicon.symbolFile),A.set(1,R.Codicon.symbolModule),A.set(2,R.Codicon.symbolNamespace),A.set(3,R.Codicon.symbolPackage),A.set(4,R.Codicon.symbolClass),A.set(5,R.Codicon.symbolMethod),A.set(6,R.Codicon.symbolProperty),A.set(7,R.Codicon.symbolField),A.set(8,R.Codicon.symbolConstructor),A.set(9,R.Codicon.symbolEnum),A.set(10,R.Codicon.symbolInterface),A.set(11,R.Codicon.symbolFunction),A.set(12,R.Codicon.symbolVariable),A.set(13,R.Codicon.symbolConstant),A.set(14,R.Codicon.symbolString),A.set(15,R.Codicon.symbolNumber),A.set(16,R.Codicon.symbolBoolean),A.set(17,R.Codicon.symbolArray),A.set(18,R.Codicon.symbolObject),A.set(19,R.Codicon.symbolKey),A.set(20,R.Codicon.symbolNull),A.set(21,R.Codicon.symbolEnumMember),A.set(22,R.Codicon.symbolStruct),A.set(23,R.Codicon.symbolEvent),A.set(24,R.Codicon.symbolOperator),A.set(25,R.Codicon.symbolTypeParameter);function M(T){let O=A.get(T);return O||(console.info("No codicon found for SymbolKind "+T),O=R.Codicon.symbolProperty),O}w.toIcon=M})(i=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(A){this.value=A}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var c;(function(w){function A(M){return!M||typeof M!="object"?!1:typeof M.id=="string"&&typeof M.title=="string"}w.is=A})(c=e.Command||(e.Command={}));var o;(function(w){w[w.Collapsed=0]="Collapsed",w[w.Expanded=1]="Expanded"})(o=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(w){w[w.Editing=0]="Editing",w[w.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var m;(function(w){w[w.Other=0]="Other",w[w.Type=1]="Type",w[w.Parameter=2]="Parameter"})(m=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new I.LanguageFeatureRegistry,e.RenameProviderRegistry=new I.LanguageFeatureRegistry,e.CompletionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new I.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new I.LanguageFeatureRegistry,e.HoverProviderRegistry=new I.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new I.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new I.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new I.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new I.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new I.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.LinkProviderRegistry=new I.LanguageFeatureRegistry,e.ColorProviderRegistry=new I.LanguageFeatureRegistry,e.SelectionRangeRegistry=new I.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.TokenizationRegistry=new _.TokenizationRegistry;var v;(function(w){w[w.None=0]="None",w[w.Option=1]="Option",w[w.Default=2]="Default",w[w.Preferred=3]="Preferred"})(v=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(pe[116],ve([0,1,18,2,4]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function _(E){return E&&typeof E=="object"&&(!E.overrideIdentifier||typeof E.overrideIdentifier=="string")&&(!E.resource||E.resource instanceof t.URI)}e.isConfigurationOverrides=_;function R(E){return E&&typeof E=="object"&&(!E.overrideIdentifiers||f.isArray(E.overrideIdentifiers))&&!E.overrideIdentifier&&(!E.resource||E.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=R;var k;(function(E){E[E.USER=1]="USER",E[E.USER_LOCAL=2]="USER_LOCAL",E[E.USER_REMOTE=3]="USER_REMOTE",E[E.WORKSPACE=4]="WORKSPACE",E[E.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",E[E.DEFAULT=6]="DEFAULT",E[E.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(E){switch(E){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=y;function P(E,F){const D=Object.create(null);for(let u in E)L(D,u,E[u],F);return D}e.toValuesTree=P;function L(E,F,D,u){const s=F.split("."),h=s.pop();let n=E;for(let S=0;S<s.length;S++){let a=s[S],i=n[a];switch(typeof i){case"undefined":i=n[a]=Object.create(null);break;case"object":break;default:u(`Ignoring ${F} as ${s.slice(0,S+1).join(".")} is ${JSON.stringify(i)}`);return}n=i}if(typeof n=="object"&&n!==null)try{n[h]=D}catch{u(`Ignoring ${F} as ${s.join(".")} is ${JSON.stringify(n)}`)}else u(`Ignoring ${F} as ${s.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=L;function C(E,F){const D=F.split(".");l(E,D)}e.removeFromValueTree=C;function l(E,F){const D=F.shift();if(F.length===0){delete E[D];return}if(Object.keys(E).indexOf(D)!==-1){const u=E[D];typeof u=="object"&&!Array.isArray(u)&&(l(u,F),Object.keys(u).length===0&&delete E[D])}}function b(E,F,D){function u(n,S){let a=n;for(const i of S){if(typeof a!="object"||a===null)return;a=a[i]}return a}const s=F.split("."),h=u(E,s);return typeof h=="undefined"?D:h}e.getConfigurationValue=b;function p(E,F,D){Object.keys(F).forEach(u=>{u!=="__proto__"&&(u in E?f.isObject(E[u])&&f.isObject(F[u])?p(E[u],F[u],D):D&&(E[u]=F[u]):E[u]=F[u])})}e.merge=p;function g(E,F,D){const u=E.inspect(F),s=E.inspect(D);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:u.defaultValue}e.getMigratedSettingValue=g}),define(pe[62],ve([0,1,12,8,4]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const _=new Map;_.set("false",!1),_.set("true",!0),_.set("isMac",f.isMacintosh),_.set("isLinux",f.isLinux),_.set("isWindows",f.isWindows),_.set("isWeb",f.isWeb),_.set("isMacNative",f.isMacintosh&&!f.isWeb),_.set("isEdge",f.isEdge),_.set("isFirefox",f.isFirefox),_.set("isChrome",f.isChrome),_.set("isSafari",f.isSafari);const R=Object.prototype.hasOwnProperty;var k;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(k=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return C.INSTANCE}static true(){return l.INSTANCE}static has(T){return b.create(T)}static equals(T,O){return p.create(T,O)}static notEquals(T,O){return F.create(T,O)}static regex(T,O){return a.create(T,O)}static in(T,O){return g.create(T,O)}static not(T){return D.create(T)}static and(...T){return c.create(T,null)}static or(...T){return o.create(T,null,!0)}static greater(T,O){return s.create(T,O)}static greaterEquals(T,O){return h.create(T,O)}static smaller(T,O){return n.create(T,O)}static smallerEquals(T,O){return S.create(T,O)}static deserialize(T,O=!1){if(!!T)return this._deserializeOrExpression(T,O)}static _deserializeOrExpression(T,O){let U=T.split("||");return o.create(U.map(V=>this._deserializeAndExpression(V,O)),null,!0)}static _deserializeAndExpression(T,O){let U=T.split("&&");return c.create(U.map(V=>this._deserializeOne(V,O)),null)}static _deserializeOne(T,O){if(T=T.trim(),T.indexOf("!=")>=0){let U=T.split("!=");return F.create(U[0].trim(),this._deserializeValue(U[1],O))}if(T.indexOf("==")>=0){let U=T.split("==");return p.create(U[0].trim(),this._deserializeValue(U[1],O))}if(T.indexOf("=~")>=0){let U=T.split("=~");return a.create(U[0].trim(),this._deserializeRegexValue(U[1],O))}if(T.indexOf(" in ")>=0){let U=T.split(" in ");return g.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(T)){const U=T.split(">=");return h.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(T)){const U=T.split(">");return s.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(T)){const U=T.split("<=");return S.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(T)){const U=T.split("<");return n.create(U[0].trim(),U[1].trim())}return/^\!\s*/.test(T)?D.create(T.substr(1).trim()):b.create(T)}static _deserializeValue(T,O){if(T=T.trim(),T==="true")return!0;if(T==="false")return!1;let U=/^'([^']*)'$/.exec(T);return U?U[1].trim():T}static _deserializeRegexValue(T,O){if((0,t.isFalsyOrWhitespace)(T)){if(O)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let U=T.indexOf("/"),V=T.lastIndexOf("/");if(U===V||U<0){if(O)throw new Error(`bad regexp-value '${T}', missing /-enclosure`);return console.warn(`bad regexp-value '${T}', missing /-enclosure`),null}let x=T.slice(U+1,V),N=T[V+1]==="i"?"i":"";try{return new RegExp(x,N)}catch(B){if(O)throw new Error(`bad regexp-value '${T}', parse error: ${B}`);return console.warn(`bad regexp-value '${T}', parse error: ${B}`),null}}}e.ContextKeyExpr=y;function P(M,T){const O=M?M.substituteConstants():void 0,U=T?T.substituteConstants():void 0;return!O&&!U?!0:!O||!U?!1:O.equals(U)}e.expressionsAreEqualWithConstantSubstitution=P;function L(M,T){return M.cmp(T)}class C{constructor(){this.type=0}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!1}serialize(){return"false"}keys(){return[]}map(T){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class l{constructor(){this.type=1}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!0}serialize(){return"true"}keys(){return[]}map(T){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=l,l.INSTANCE=new l;class b{constructor(T,O){this.key=T,this.negated=O,this.type=2}static create(T,O=null){const U=_.get(T);return typeof U=="boolean"?U?l.INSTANCE:C.INSTANCE:new b(T,O)}cmp(T){return T.type!==this.type?this.type-T.type:m(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=_.get(this.key);return typeof T=="boolean"?T?l.INSTANCE:C.INSTANCE:this}evaluate(T){return!!T.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(T){return T.mapDefined(this.key)}negate(){return this.negated||(this.negated=D.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=b;class p{constructor(T,O,U){this.key=T,this.value=O,this.negated=U,this.type=4}static create(T,O,U=null){if(typeof O=="boolean")return O?b.create(T,U):D.create(T,U);const V=_.get(T);return typeof V=="boolean"?O===(V?"true":"false")?l.INSTANCE:C.INSTANCE:new p(T,O,U)}cmp(T){return T.type!==this.type?this.type-T.type:v(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){const T=_.get(this.key);if(typeof T=="boolean"){const O=T?"true":"false";return this.value===O?l.INSTANCE:C.INSTANCE}return this}evaluate(T){return T.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(T){return T.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=p;class g{constructor(T,O){this.key=T,this.valueKey=O,this.type=10,this.negated=null}static create(T,O){return new g(T,O)}cmp(T){return T.type!==this.type?this.type-T.type:v(this.key,this.valueKey,T.key,T.valueKey)}equals(T){return T.type===this.type?this.key===T.key&&this.valueKey===T.valueKey:!1}substituteConstants(){return this}evaluate(T){const O=T.getValue(this.valueKey),U=T.getValue(this.key);return Array.isArray(O)?O.indexOf(U)>=0:typeof U=="string"&&typeof O=="object"&&O!==null?R.call(O,U):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(T){return T.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=E.create(this)),this.negated}}e.ContextKeyInExpr=g;class E{constructor(T){this._actual=T,this.type=11}static create(T){return new E(T)}cmp(T){return T.type!==this.type?this.type-T.type:this._actual.cmp(T._actual)}equals(T){return T.type===this.type?this._actual.equals(T._actual):!1}substituteConstants(){return this}evaluate(T){return!this._actual.evaluate(T)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(T){return new E(this._actual.map(T))}negate(){return this._actual}}e.ContextKeyNotInExpr=E;class F{constructor(T,O,U){this.key=T,this.value=O,this.negated=U,this.type=5}static create(T,O,U=null){if(typeof O=="boolean")return O?D.create(T,U):b.create(T,U);const V=_.get(T);return typeof V=="boolean"?O===(V?"true":"false")?C.INSTANCE:l.INSTANCE:new F(T,O,U)}cmp(T){return T.type!==this.type?this.type-T.type:v(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){const T=_.get(this.key);if(typeof T=="boolean"){const O=T?"true":"false";return this.value===O?C.INSTANCE:l.INSTANCE}return this}evaluate(T){return T.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(T){return T.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=F;class D{constructor(T,O){this.key=T,this.negated=O,this.type=3}static create(T,O=null){const U=_.get(T);return typeof U=="boolean"?U?C.INSTANCE:l.INSTANCE:new D(T,O)}cmp(T){return T.type!==this.type?this.type-T.type:m(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=_.get(this.key);return typeof T=="boolean"?T?C.INSTANCE:l.INSTANCE:this}evaluate(T){return!T.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(T){return T.mapNot(this.key)}negate(){return this.negated||(this.negated=b.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=D;function u(M,T){if(typeof M=="string"){const O=parseFloat(M);isNaN(O)||(M=O)}return typeof M=="string"||typeof M=="number"?T(M):C.INSTANCE}class s{constructor(T,O,U){this.key=T,this.value=O,this.negated=U,this.type=12}static create(T,O,U=null){return u(O,V=>new s(T,V,U))}cmp(T){return T.type!==this.type?this.type-T.type:v(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(T){return T.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=s;class h{constructor(T,O,U){this.key=T,this.value=O,this.negated=U,this.type=13}static create(T,O,U=null){return u(O,V=>new h(T,V,U))}cmp(T){return T.type!==this.type?this.type-T.type:v(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(T){return T.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=h;class n{constructor(T,O,U){this.key=T,this.value=O,this.negated=U,this.type=14}static create(T,O,U=null){return u(O,V=>new n(T,V,U))}cmp(T){return T.type!==this.type?this.type-T.type:v(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(T){return T.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=n;class S{constructor(T,O,U){this.key=T,this.value=O,this.negated=U,this.type=15}static create(T,O,U=null){return u(O,V=>new S(T,V,U))}cmp(T){return T.type!==this.type?this.type-T.type:v(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(T){return T.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=S;class a{constructor(T,O){this.key=T,this.regexp=O,this.type=7,this.negated=null}static create(T,O){return new a(T,O)}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.key<T.key)return-1;if(this.key>T.key)return 1;const O=this.regexp?this.regexp.source:"",U=T.regexp?T.regexp.source:"";return O<U?-1:O>U?1:0}equals(T){if(T.type===this.type){const O=this.regexp?this.regexp.source:"",U=T.regexp?T.regexp.source:"";return this.key===T.key&&O===U}return!1}substituteConstants(){return this}evaluate(T){let O=T.getValue(this.key);return this.regexp?this.regexp.test(O):!1}serialize(){const T=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${T}`}keys(){return[this.key]}map(T){return T.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=a;class i{constructor(T){this._actual=T,this.type=8}static create(T){return new i(T)}cmp(T){return T.type!==this.type?this.type-T.type:this._actual.cmp(T._actual)}equals(T){return T.type===this.type?this._actual.equals(T._actual):!1}substituteConstants(){return this}evaluate(T){return!this._actual.evaluate(T)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(T){return new i(this._actual.map(T))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function r(M){let T=null;for(let O=0,U=M.length;O<U;O++){const V=M[O].substituteConstants();if(M[O]!==V&&T===null){T=[];for(let x=0;x<O;x++)T[x]=M[x]}T!==null&&(T[O]=V)}return T===null?M:T}class c{constructor(T,O){this.expr=T,this.negated=O,this.type=6}static create(T,O){return c._normalizeArr(T,O)}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let O=0,U=this.expr.length;O<U;O++){const V=L(this.expr[O],T.expr[O]);if(V!==0)return V}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let O=0,U=this.expr.length;O<U;O++)if(!this.expr[O].equals(T.expr[O]))return!1;return!0}return!1}substituteConstants(){const T=r(this.expr);return T===this.expr?this:c.create(T,this.negated)}evaluate(T){for(let O=0,U=this.expr.length;O<U;O++)if(!this.expr[O].evaluate(T))return!1;return!0}static _normalizeArr(T,O){const U=[];let V=!1;for(const x of T)if(!!x){if(x.type===1){V=!0;continue}if(x.type===0)return C.INSTANCE;if(x.type===6){U.push(...x.expr);continue}U.push(x)}if(U.length===0&&V)return l.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(L);for(let x=1;x<U.length;x++)U[x-1].equals(U[x])&&(U.splice(x,1),x--);if(U.length===1)return U[0];for(;U.length>1;){const x=U[U.length-1];if(x.type!==9)break;U.pop();const N=U.pop(),B=U.length===0,W=o.create(x.expr.map(H=>c.create([H,N],null)),null,B);W&&(U.push(W),U.sort(L))}return U.length===1?U[0]:new c(U,O)}}serialize(){return this.expr.map(T=>T.serialize()).join(" && ")}keys(){const T=[];for(let O of this.expr)T.push(...O.keys());return T}map(T){return new c(this.expr.map(O=>O.map(T)),null)}negate(){if(!this.negated){const T=[];for(let O of this.expr)T.push(O.negate());this.negated=o.create(T,this,!0)}return this.negated}}class o{constructor(T,O){this.expr=T,this.negated=O,this.type=9}static create(T,O,U){return o._normalizeArr(T,O,U)}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let O=0,U=this.expr.length;O<U;O++){const V=L(this.expr[O],T.expr[O]);if(V!==0)return V}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let O=0,U=this.expr.length;O<U;O++)if(!this.expr[O].equals(T.expr[O]))return!1;return!0}return!1}substituteConstants(){const T=r(this.expr);return T===this.expr?this:o.create(T,this.negated,!1)}evaluate(T){for(let O=0,U=this.expr.length;O<U;O++)if(this.expr[O].evaluate(T))return!0;return!1}static _normalizeArr(T,O,U){let V=[],x=!1;if(T){for(let N=0,B=T.length;N<B;N++){const W=T[N];if(!!W){if(W.type===0){x=!0;continue}if(W.type===1)return l.INSTANCE;if(W.type===9){V=V.concat(W.expr);continue}V.push(W)}}if(V.length===0&&x)return C.INSTANCE;V.sort(L)}if(V.length!==0){if(V.length===1)return V[0];for(let N=1;N<V.length;N++)V[N-1].equals(V[N])&&(V.splice(N,1),N--);if(V.length===1)return V[0];if(U){for(let N=0;N<V.length;N++)for(let B=N+1;B<V.length;B++)w(V[N],V[B])&&(V.splice(B,1),B--);if(V.length===1)return V[0]}return new o(V,O)}}serialize(){return this.expr.map(T=>T.serialize()).join(" || ")}keys(){const T=[];for(let O of this.expr)T.push(...O.keys());return T}map(T){return new o(this.expr.map(O=>O.map(T)),null)}negate(){if(!this.negated){let T=[];for(let O of this.expr)T.push(O.negate());for(;T.length>1;){const O=T.shift(),U=T.shift(),V=[];for(const N of A(O))for(const B of A(U))V.push(c.create([N,B],null));const x=T.length===0;T.unshift(o.create(V,null,x))}this.negated=T[0]}return this.negated}}class d extends b{constructor(T,O,U){super(T,null);this._defaultValue=O,typeof U=="object"?d._info.push({...U,key:T}):U!==!0&&d._info.push({key:T,description:U,type:O!=null?typeof O:void 0})}static all(){return d._info.values()}bindTo(T){return T.createKey(this.key,this._defaultValue)}getValue(T){return T.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(T){return p.create(this.key,T)}notEqualsTo(T){return F.create(this.key,T)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(M,T){return M<T?-1:M>T?1:0}function v(M,T,O,U){return M<O?-1:M>O?1:T<U?-1:T>U?1:0}function w(M,T){if(T.type===6&&M.type!==9&&M.type!==6){for(const V of T.expr)if(M.equals(V))return!0}const O=M.negate(),U=A(O).concat(A(T));U.sort(L);for(let V=0;V<U.length;V++){const N=U[V].negate();for(let B=V+1;B<U.length;B++){const W=U[B];if(N.equals(W))return!0}}return!1}e.implies=w;function A(M){return M.type===9?M.expr:[M]}}),define(pe[184],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,f.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,f.refineServiceDecorator)(e.IEnvironmentService)}),define(pe[185],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,f.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,f.createDecorator)("externalTerminal")}),define(pe[186],ve([0,1,37,10,9,12,96,30,113,160,185]),function(Z,e,f,t,I,_,R,k,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const C=P.localize(0,null);class l{async getDefaultTerminalForPlatforms(){return{windows:b.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class b extends l{openTerminal(s,h){return this.spawnTerminal(f,s,y.getWindowsShell(),h)}spawnTerminal(s,h,n,S){const a=h.windowsExec||b.getDefaultTerminalWindows();S&&S[1]===":"&&(S=S[0].toUpperCase()+S.substr(1));const i=I.basename(a).toLowerCase();if(i==="cmder"||i==="cmder.exe")return s.spawn(a,S?[S]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return a.indexOf(" ")>=0&&r.push('""'),r.push(a),(i==="wt"||i==="wt.exe")&&r.push("-d ."),new Promise((c,o)=>{const d=E(process),m=s.spawn(n,r,{cwd:S,env:d});m.on("error",o),m.on("exit",()=>c())})}runInTerminal(s,h,n,S,a){const i="windowsExec"in a&&a.windowsExec?a.windowsExec:b.getDefaultTerminalWindows();return new Promise((r,c)=>{const o=`"${h} - ${C}"`,d=`""${n.join('" "')}" & pause"`,m=["/c","start",o,"/wait",i,"/c",d],v=Object.assign({},E(process),S);Object.keys(v).filter(M=>v[M]===null).forEach(M=>delete v[M]);const w={cwd:h,env:v,windowsVerbatimArguments:!0};f.spawn(b.CMD,m,w).on("error",M=>{c(F(M))}),r(void 0)})}static getDefaultTerminalWindows(){if(!b._DEFAULT_TERMINAL_WINDOWS){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");b._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return b._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=b,b.CMD="cmd.exe";class p extends l{openTerminal(s,h){return this.spawnTerminal(f,s,h)}runInTerminal(s,h,n,S,a){const i=a.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((r,c)=>{if(i===L.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const o=i===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",m=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${o}.scpt`,Z).fsPath,"-t",s||C,"-w",h];for(let A of n)m.push("-a"),m.push(A);if(S){const A=Object.assign({},E(process),S);for(let M in A){const T=A[M];T===null?(m.push("-u"),m.push(M)):(m.push("-e"),m.push(`${M}=${T}`))}}let v="";const w=f.spawn(p.OSASCRIPT,m);w.on("error",A=>{c(F(A))}),w.stderr.on("data",A=>{v+=A.toString()}),w.on("exit",A=>{if(A===0)r(void 0);else if(v){const M=v.split(`
`,1);c(new Error(M[0]))}else c(new Error(P.localize(1,null,o,A)))})}else c(new Error(P.localize(2,null,i)))})}spawnTerminal(s,h,n){const S=h.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((a,i)=>{const r=["-a",S];n&&r.push(n);const c=E(process),o=s.spawn("/usr/bin/open",r,{cwd:n,env:c});o.on("error",i),o.on("exit",()=>a())})}}e.MacExternalTerminalService=p,p.OSASCRIPT="/usr/bin/osascript";class g extends l{openTerminal(s,h){return this.spawnTerminal(f,s,h)}runInTerminal(s,h,n,S,a){const i=a.linuxExec?Promise.resolve(a.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((r,c)=>{let o=[];i.then(d=>{d.indexOf("gnome-terminal")>=0?o.push("-x"):o.push("-e"),o.push("bash"),o.push("-c");const m=`${D(n)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;o.push(`''${m}''`);const v=Object.assign({},E(process),S);Object.keys(v).filter(T=>v[T]===null).forEach(T=>delete v[T]);const w={cwd:h,env:v};let A="";const M=f.spawn(d,o,w);M.on("error",T=>{c(F(T))}),M.stderr.on("data",T=>{A+=T.toString()}),M.on("exit",T=>{if(T===0)r(void 0);else if(A){const O=A.split(`
`,1);c(new Error(O[0]))}else c(new Error(P.localize(4,null,d,T)))})})})}static async getDefaultTerminalLinuxReady(){if(!g._DEFAULT_TERMINAL_LINUX_READY)if(!_.isLinux)g._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const s=await k.Promises.exists("/etc/debian_version");g._DEFAULT_TERMINAL_LINUX_READY=new Promise(h=>{s?h("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?h("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?h("konsole"):process.env.COLORTERM?h(process.env.COLORTERM):process.env.TERM?h(process.env.TERM):h("xterm")})}return g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(s,h,n){const S=h.linuxExec?Promise.resolve(h.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((a,i)=>{S.then(r=>{const c=E(process),o=s.spawn(r,[],{cwd:n,env:c});o.on("error",i),o.on("exit",()=>a())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=P.localize(3,null);function E(u){const s={...u.env};return(0,R.sanitizeProcessEnvironment)(s),s}function F(u){return"errno"in u&&u.errno==="ENOENT"&&"path"in u&&typeof u.path=="string"?new Error(P.localize(5,null,u.path)):u}function D(u){let s="";for(let h of u)h.indexOf(" ")>=0?s+='"'+h+'"':s+=h,s+=" ";return s}}),define(pe[42],ve([0,1,24,9,8,18,2,161,4]),function(Z,e,f,t,I,_,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function P(x){return x.create===!0}e.isFileOpenForWriteOptions=P;var L;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(L=e.FileType||(e.FileType={}));var C;(function(x){x[x.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var l;(function(x){x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(x){return!!(x.capabilities&2)}e.hasReadWriteCapability=b;function p(x){return!!(x.capabilities&8)}e.hasFileFolderCopyCapability=p;function g(x){return!!(x.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function E(x){return!!(x.capabilities&16)}e.hasFileReadStreamCapability=E;function F(x){return b(x)?!!(x.capabilities&16384):!1}e.hasFileAtomicReadCapability=F;var D;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(D=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class u extends Error{constructor(N,B){super(N);this.code=B}}e.FileSystemProviderError=u;function s(x,N){const B=new u(x.toString(),N);return n(B,N),B}e.createFileSystemProviderError=s;function h(x){return x||s((0,k.localize)(0,null),D.Unknown)}e.ensureFileSystemProviderError=h;function n(x,N){return x.name=N?`${N} (FileSystemError)`:"FileSystemError",x}e.markAsFileSystemProviderError=n;function S(x){if(!x)return D.Unknown;if(x instanceof u)return x.code;const N=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!N)return D.Unknown;switch(N[1]){case D.FileExists:return D.FileExists;case D.FileIsADirectory:return D.FileIsADirectory;case D.FileNotADirectory:return D.FileNotADirectory;case D.FileNotFound:return D.FileNotFound;case D.FileExceedsMemoryLimit:return D.FileExceedsMemoryLimit;case D.FileTooLarge:return D.FileTooLarge;case D.FileWriteLocked:return D.FileWriteLocked;case D.NoPermissions:return D.NoPermissions;case D.Unavailable:return D.Unavailable}return D.Unknown}e.toFileSystemProviderErrorCode=S;function a(x){if(x instanceof m)return x.fileOperationResult;switch(S(x)){case D.FileNotFound:return 1;case D.FileIsADirectory:return 0;case D.FileNotADirectory:return 10;case D.FileWriteLocked:return 5;case D.NoPermissions:return 6;case D.FileExists:return 4;case D.FileExceedsMemoryLimit:return 9;case D.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var i;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class r{constructor(N,B,W){this.resource=N,this.operation=B,this.target=W}isOperation(N){return this.operation===N}}e.FileOperationEvent=r;var c;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class o{constructor(N,B){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=N;const W=new Map;for(const H of N){const z=W.get(H.type);switch(z?z.push([H.resource,H]):W.set(H.type,[[H.resource,H]]),H.type){case 1:this.rawAdded.push(H.resource);break;case 0:this.rawUpdated.push(H.resource);break;case 2:this.rawDeleted.push(H.resource);break}}for(const[H,z]of W)switch(H){case 1:this.added=f.TernarySearchTree.forUris(()=>B),this.added.fill(z);break;case 0:this.updated=f.TernarySearchTree.forUris(()=>B),this.updated.fill(z);break;case 2:this.deleted=f.TernarySearchTree.forUris(()=>B),this.deleted.fill(z);break}}contains(N,...B){return this.doContains(N,{includeChildren:!1},...B)}affects(N,...B){return this.doContains(N,{includeChildren:!0},...B)}doContains(N,B,...W){if(!N)return!1;const H=W.length>0;return!!((!H||W.includes(1))&&(this.added?.get(N)||B.includeChildren&&this.added?.findSuperstr(N))||(!H||W.includes(0))&&(this.updated?.get(N)||B.includeChildren&&this.updated?.findSuperstr(N))||(!H||W.includes(2))&&(this.deleted?.findSubstr(N)||B.includeChildren&&this.deleted?.findSuperstr(N)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=o;function d(x,N,B){return!x||!N||x===N||N.length>x.length?!1:(N.charAt(N.length-1)!==t.sep&&(N+=t.sep),B?(0,I.startsWithIgnoreCase)(x,N):x.indexOf(N)===0)}e.isParent=d;class m extends Error{constructor(N,B,W){super(N);this.fileOperationResult=B,this.options=W}}e.FileOperationError=m;class v extends m{constructor(N,B,W){super(N,2,W);this.stat=B}}e.NotModifiedSinceFileOperationError=v;var w;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",x[x.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(w=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function M(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}e.etag=M;async function T(x,N){if(!N.hasProvider(R.URI.from({scheme:x.scheme})))return new Promise(B=>{const W=N.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===x.scheme&&H.added&&(W.dispose(),B())})})}e.whenProviderRegistered=T,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize(N){return(0,_.isNumber)(N)||(N=0),N<O.KB?(0,k.localize)(1,null,N.toFixed(0)):N<O.MB?(0,k.localize)(2,null,(N/O.KB).toFixed(2)):N<O.GB?(0,k.localize)(3,null,(N/O.MB).toFixed(2)):N<O.TB?(0,k.localize)(4,null,(N/O.GB).toFixed(2)):(0,k.localize)(5,null,(N/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB;var U;(function(x){x[x.IA32=0]="IA32",x[x.OTHER=1]="OTHER"})(U=e.Arch||(e.Arch={}));function V(x){return{maxFileSize:x===0?300*O.MB:16*O.GB,maxHeapSize:x===0?700*O.MB:2*700*O.MB}}e.getPlatformLimits=V}),define(pe[84],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class f{constructor(...I){this._entries=new Map;for(let[_,R]of I)this.set(_,R)}set(I,_){const R=this._entries.get(I);return this._entries.set(I,_),R}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=f}),define(pe[187],ve([0,1,13,16,115,181,4,84]),function(Z,e,f,t,I,_,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const y=!1;class P extends Error{constructor(p){super("cyclic dependency between services");this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class L{constructor(p=new k.ServiceCollection,g=!1,E){this._activeInstantiations=new Set,this._services=p,this._strict=g,this._parent=E,this._services.set(R.IInstantiationService,this)}createChild(p){return new L(p,this._strict,this)}invokeFunction(p,...g){let E=l.traceInvocation(p),F=!1;try{return p({get:u=>{if(F)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(u,E);if(!s)throw new Error(`[invokeFunction] unknown service '${u}'`);return s}},...g)}finally{F=!0,E.stop()}}createInstance(p,...g){let E,F;return p instanceof I.SyncDescriptor?(E=l.traceCreation(p.ctor),F=this._createInstance(p.ctor,p.staticArguments.concat(g),E)):(E=l.traceCreation(p),F=this._createInstance(p,g,E)),E.stop(),F}_createInstance(p,g=[],E){let F=R._util.getServiceDependencies(p).sort((s,h)=>s.index-h.index),D=[];for(const s of F){let h=this._getOrCreateServiceInstance(s.id,E);if(!h&&this._strict&&!s.optional)throw new Error(`[createInstance] ${p.name} depends on UNKNOWN service ${s.id}.`);D.push(h)}let u=F.length>0?F[0].index:g.length;if(g.length!==u){console.warn(`[createInstance] First service dependency of ${p.name} at position ${u+1} conflicts with ${g.length} static arguments`);let s=u-g.length;s>0?g=g.concat(new Array(s)):g=g.slice(0,u)}return new p(...[...g,...D])}_setServiceInstance(p,g){if(this._services.get(p)instanceof I.SyncDescriptor)this._services.set(p,g);else if(this._parent)this._parent._setServiceInstance(p,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(p){let g=this._services.get(p);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(p):g}_getOrCreateServiceInstance(p,g){let E=this._getServiceInstanceOrDescriptor(p);return E instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(p,E,g.branch(p,!0)):(g.branch(p,!1),E)}_safeCreateAndCacheServiceInstance(p,g,E){if(this._activeInstantiations.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this._activeInstantiations.add(p);try{return this._createAndCacheServiceInstance(p,g,E)}finally{this._activeInstantiations.delete(p)}}_createAndCacheServiceInstance(p,g,E){const F=new _.Graph(s=>s.id.toString());let D=0;const u=[{id:p,desc:g,_trace:E}];for(;u.length;){const s=u.pop();if(F.lookupOrInsertNode(s),D++>1e3)throw new P(F);for(let h of R._util.getServiceDependencies(s.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(h.id);if(!n&&!h.optional&&console.warn(`[createInstance] ${p} depends on ${h.id} which is NOT registered.`),n instanceof I.SyncDescriptor){const S={id:h.id,desc:n,_trace:s._trace.branch(h.id,!0)};F.insertEdge(s,S),u.push(S)}}}for(;;){const s=F.roots();if(s.length===0){if(!F.isEmpty())throw new P(F);break}for(const{data:h}of s){if(this._getServiceInstanceOrDescriptor(h.id)instanceof I.SyncDescriptor){const S=this._createServiceInstanceWithOwner(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this._setServiceInstance(h.id,S)}F.removeNode(h)}}return this._getServiceInstanceOrDescriptor(p)}_createServiceInstanceWithOwner(p,g,E=[],F,D){if(this._services.get(p)instanceof I.SyncDescriptor)return this._createServiceInstance(g,E,F,D);if(this._parent)return this._parent._createServiceInstanceWithOwner(p,g,E,F,D);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(p,g=[],E,F){if(E){const D=new f.IdleValue(()=>this._createInstance(p,g,F));return new Proxy(Object.create(null),{get(u,s){if(s in u)return u[s];let h=D.value,n=h[s];return typeof n!="function"||(n=n.bind(h),u[s]=n),n},set(u,s,h){return D.value[s]=h,!0}})}else return this._createInstance(p,g,F)}}e.InstantiationService=L;var C;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(C||(C={}));class l{constructor(p,g){this.type=p,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(p){return y?new l(1,p.name||p.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(p){return y?new l(0,p.name):l._None}branch(p,g){let E=new l(2,p.toString());return this._dep.push([p,g,E]),E}stop(){let p=Date.now()-this._start;l._totals+=p;let g=!1;function E(D,u){let s=[],h=new Array(D+1).join("	");for(const[n,S,a]of u._dep)if(S&&a){g=!0,s.push(`${h}CREATES -> ${n}`);let i=E(D+1,a);i&&s.push(i)}else s.push(`${h}uses -> ${n}`);return s.join(`
`)}let F=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(p>2||g)&&console.log(F.join(`
`))}}e.Trace=l,l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(pe[11],ve([0,1,49,3,6,12,4]),function(Z,e,f,t,I,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,R.createDecorator)("logService"),e.ILoggerService=(0,R.createDecorator)("loggerService");function k(){return new Date().toISOString()}var y;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;function P(S,a,i){switch(a){case y.Trace:S.trace(i);break;case y.Debug:S.debug(i);break;case y.Info:S.info(i);break;case y.Warning:S.warn(i);break;case y.Error:S.error(i);break;case y.Critical:S.critical(i);break;default:throw new Error("Invalid log level")}}e.log=P;function L(S){let a="";for(let i=0;i<S.length;i++){let r=S[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}a+=(i>0?" ":"")+r}return a}e.format=L;class C extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class l extends C{constructor(a){super();this.logAlways=a}checkLogLevel(a){return this.logAlways||this.getLevel()<=a}trace(a,...i){this.checkLogLevel(y.Trace)&&this.log(y.Trace,L([a,...i]))}debug(a,...i){this.checkLogLevel(y.Debug)&&this.log(y.Debug,L([a,...i]))}info(a,...i){this.checkLogLevel(y.Info)&&this.log(y.Info,L([a,...i]))}warn(a,...i){this.checkLogLevel(y.Warning)&&this.log(y.Warning,L([a,...i]))}error(a,...i){if(this.checkLogLevel(y.Error))if(a instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=a.stack,this.log(y.Error,L(r))}else this.log(y.Error,L([a,...i]))}critical(a,...i){this.checkLogLevel(y.Critical)&&this.log(y.Critical,L([a,...i]))}flush(){}}e.AbstractMessageLogger=l;class b extends C{constructor(a=e.DEFAULT_LOG_LEVEL){super();this.setLevel(a),this.useColors=!_.isWindows}trace(a,...i){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,a,...i):console.log(`[main ${k()}]`,a,...i))}debug(a,...i){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,a,...i):console.log(`[main ${k()}]`,a,...i))}info(a,...i){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,a,...i):console.log(`[main ${k()}]`,a,...i))}warn(a,...i){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,a,...i):console.warn(`[main ${k()}]`,a,...i))}error(a,...i){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,a,...i):console.error(`[main ${k()}]`,a,...i))}critical(a,...i){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,a,...i):console.error(`[main ${k()}]`,a,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class p extends C{constructor(a=e.DEFAULT_LOG_LEVEL){super();this.setLevel(a)}trace(a,...i){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",a,...i)}debug(a,...i){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",a,...i)}info(a,...i){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",a,...i)}warn(a,...i){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",a,...i)}error(a,...i){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",a,...i)}critical(a,...i){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",a,...i)}dispose(){}flush(){}}e.ConsoleLogger=p;class g extends C{constructor(a,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=a,this.setLevel(i)}trace(a,...i){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(a),...i])}debug(a,...i){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(a),...i])}info(a,...i){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(a),...i])}warn(a,...i){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(a),...i])}error(a,...i){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(a),...i])}critical(a,...i){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(a),...i])}extractMessage(a){return typeof a=="string"?a:(0,f.toErrorMessage)(a,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class E extends C{constructor(a){super();this.logServices=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const i of this.logServices)i.setLevel(a);super.setLevel(a)}trace(a,...i){for(const r of this.logServices)r.trace(a,...i)}debug(a,...i){for(const r of this.logServices)r.debug(a,...i)}info(a,...i){for(const r of this.logServices)r.info(a,...i)}warn(a,...i){for(const r of this.logServices)r.warn(a,...i)}error(a,...i){for(const r of this.logServices)r.error(a,...i)}critical(a,...i){for(const r of this.logServices)r.critical(a,...i)}flush(){for(const a of this.logServices)a.flush()}dispose(){for(const a of this.logServices)a.dispose()}}e.MultiplexLogService=E;class F extends I.Disposable{constructor(a){super();this.logger=a,this._register(a)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(a){this.logger.setLevel(a)}getLevel(){return this.logger.getLevel()}trace(a,...i){this.logger.trace(a,...i)}debug(a,...i){this.logger.debug(a,...i)}info(a,...i){this.logger.info(a,...i)}warn(a,...i){this.logger.warn(a,...i)}error(a,...i){this.logger.error(a,...i)}critical(a,...i){this.logger.critical(a,...i)}flush(){this.logger.flush()}}e.LogService=F;class D extends I.Disposable{constructor(a,i){super();this.logLevel=a,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(r))}))}getLogger(a){return this.loggers.get(a.toString())}createLogger(a,i){let r=this.loggers.get(a.toString());return r||(r=this.doCreateLogger(a,i?.always?y.Trace:this.logLevel,i),this.loggers.set(a.toString(),r),i?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(a=>a.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=D;class u{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(a){}getLevel(){return y.Info}trace(a,...i){}debug(a,...i){}info(a,...i){}warn(a,...i){}error(a,...i){}critical(a,...i){}dispose(){}flush(){}}e.NullLogService=u;function s(S){if(S.verbose)return y.Trace;if(typeof S.logLevel=="string"){const a=h(S.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=s;function h(S){switch(S){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=h;function n(S){switch(S){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=n}),define(pe[188],ve([0,1,42,11]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function I(k,y,P,L,C){try{const l=await new Promise((p,g)=>{Z(["spdlog"],p,g)});l.setFlushOn(t.LogLevel.Trace);const b=await l.createAsyncRotatingLogger(k,y,P,L);return C&&b.clearFormatters(),b}catch(l){console.error(l)}return null}function _(k,y,P){switch(y){case t.LogLevel.Trace:k.trace(P);break;case t.LogLevel.Debug:k.debug(P);break;case t.LogLevel.Info:k.info(P);break;case t.LogLevel.Warning:k.warn(P);break;case t.LogLevel.Error:k.error(P);break;case t.LogLevel.Critical:k.critical(P);break;default:throw new Error("Invalid log level")}}class R extends t.AbstractMessageLogger{constructor(y,P,L,C,l){super();this.buffer=[],this.setLevel(l),this._loggerCreationPromise=this._createSpdLogLogger(y,P,L,C),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}async _createSpdLogLogger(y,P,L,C){const l=L?6:1,b=30/l*f.ByteSize.MB,p=await I(y,P,b,l,C);if(p){this._logger=p,this._logger.setLevel(this.getLevel());for(const{level:g,message:E}of this.buffer)_(this._logger,g,E);this.buffer=[]}}log(y,P){this._logger?_(this._logger,y,P):this.getLevel()<=y&&this.buffer.push({level:y,message:P})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=R}),define(pe[117],ve([0,1,47,162,4]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var _;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(_=e.MarkerTag||(e.MarkerTag={}));var R;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(R=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function P(p,g){return g-p}y.compare=P;const L=Object.create(null);L[y.Error]=(0,t.localize)(0,null),L[y.Warning]=(0,t.localize)(1,null),L[y.Info]=(0,t.localize)(2,null);function C(p){return L[p]||""}y.toString=C;function l(p){switch(p){case f.default.Error:return y.Error;case f.default.Warning:return y.Warning;case f.default.Info:return y.Info;case f.default.Ignore:return y.Hint}}y.fromSeverity=l;function b(p){switch(p){case y.Error:return f.default.Error;case y.Warning:return f.default.Warning;case y.Info:return f.default.Info;case y.Hint:return f.default.Ignore}}y.toSeverity=b}(R=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(y){const P="";function L(l){return C(l,!0)}y.makeKey=L;function C(l,b){let p=[P];return l.source?p.push(l.source.replace("\xA6","\\\xA6")):p.push(P),l.code?typeof l.code=="string"?p.push(l.code.replace("\xA6","\\\xA6")):p.push(l.code.value.replace("\xA6","\\\xA6")):p.push(P),l.severity!==void 0&&l.severity!==null?p.push(R.toString(l.severity)):p.push(P),l.message&&b?p.push(l.message.replace("\xA6","\\\xA6")):p.push(P),l.startLineNumber!==void 0&&l.startLineNumber!==null?p.push(l.startLineNumber.toString()):p.push(P),l.startColumn!==void 0&&l.startColumn!==null?p.push(l.startColumn.toString()):p.push(P),l.endLineNumber!==void 0&&l.endLineNumber!==null?p.push(l.endLineNumber.toString()):p.push(P),l.endColumn!==void 0&&l.endColumn!==null?p.push(l.endColumn.toString()):p.push(P),p.push(P),p.join("\xA6")}y.makeKeyOptionalMessage=C})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(pe[189],ve([0,1,3,47,4]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,I.createDecorator)("notificationService");var _;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(_=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var R;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(R=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new y,this.onDidClose=f.Event.None,this.onDidChangeVisibility=f.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=k;class y{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=y}),define(pe[190],ve([0,1,6,8,2,4]),function(Z,e,f,t,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,_.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return f.Disposable.None},registerValidator(){return f.Disposable.None},registerExternalUriResolver(){return f.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return f.Disposable.None},async open(){return!1},async resolveExternalUri(y){return{resolved:y,dispose(){}}}});function R(y,P){return I.URI.isUri(y)?(0,t.equalsIgnoreCase)(y.scheme,P):(0,t.startsWithIgnoreCase)(y,P+":")}e.matchesScheme=R;function k(y,...P){return P.some(L=>R(y,L))}e.matchesSomeScheme=k}),define(pe[191],ve([0,1,10,12,40,23]),function(Z,e,f,t,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let R;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const k=t.globals.vscode.context.configuration();if(k)R=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Z?.__$__nodeRequire=="function"){const k=(0,_.dirname)(f.FileAccess.asFileUri("",Z));R=Z.__$__nodeRequire((0,_.joinPath)(k,"product.json").fsPath);const y=Z.__$__nodeRequire((0,_.joinPath)(k,"package.json").fsPath);I.env.VSCODE_DEV&&Object.assign(R,{nameShort:`${R.nameShort} Dev`,nameLong:`${R.nameLong} Dev`,dataFolderName:`${R.dataFolderName}-dev`}),Object.assign(R,{version:y.version})}else R={},Object.keys(R).length===0&&Object.assign(R,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=R});var ze=this&&this.__param||function(Z,e){return function(f,t){e(f,t,Z)}};define(pe[118],ve([0,1,13,21,6,4]),function(Z,e,f,t,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,_.createDecorator)("progressService");var R;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(R=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let y=class extends I.Disposable{constructor(C,l){super();this.deferred=new f.DeferredPromise,l.withProgress(C,b=>(this.reporter=b,this.lastStep&&b.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};y=je([ze(1,e.IProgressService)],y),e.UnmanagedProgress=y;class P extends I.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(C){this.stop();const l=++this.currentOperationId,b=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>b.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:b.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,_.createDecorator)("editorProgressService")}),define(pe[50],ve([0,1,55,18]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(R,k){f.ok(t.isString(R)),f.ok(t.isObject(k)),f.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,k)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new I}),define(pe[192],ve([0,1,3,50]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class _{constructor(){this._onDidChangeSchema=new f.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,P){this.schemasById[I(y)]=P,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new _;t.Registry.add(e.Extensions.JSONContribution,R)}),define(pe[119],ve([0,1,17,3,18,157,192,50]),function(Z,e,f,t,I,_,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const L=k.Registry.as(R.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(h,n=!0){this.registerConfigurations([h],n)}registerConfigurations(h,n=!0){const S=this.doRegisterConfigurations(h,n);L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:S})}deregisterConfigurations(h){const n=this.doDeregisterConfigurations(h);L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:h,remove:n}){const S=[];S.push(...this.doDeregisterConfigurations(n)),S.push(...this.doRegisterConfigurations(h,!1)),L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,f.distinct)(S)})}registerDefaultConfigurations(h){const n=[],S=[];for(const{overrides:a,source:i}of h)for(const r in a)if(n.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const c={...this.configurationDefaultsOverrides.get(r)?.value||{},...a[r]};this.configurationDefaultsOverrides.set(r,{source:i,value:c});const o={type:"object",default:c,description:_.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:c,source:I.isString(i)?void 0:i};S.push(...p(r)),this.configurationProperties[r]=o,this.defaultLanguageConfigurationOverridesNode.properties[r]=o}else{this.configurationDefaultsOverrides.set(r,{value:a[r],source:i});const c=this.configurationProperties[r];c&&(this.updatePropertyDefaultValue(r,c),this.updateSchema(r,c))}this.registerOverrideIdentifiers(S),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(h){const n=[];for(const{overrides:S,source:a}of h)for(const i in S){const r=this.configurationDefaultsOverrides.get(i),c=I.isString(a)?a:a?.id,o=I.isString(r?.source)?r?.source:r?.source?.id;if(c===o)if(n.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const d=this.configurationProperties[i];d&&(this.updatePropertyDefaultValue(i,d),this.updateSchema(i,d))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...h){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(h){for(const n of h)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(h,n){const S=[];return h.forEach(a=>{S.push(...this.validateAndRegisterProperties(a,n,a.extensionInfo,a.restrictedProperties)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),S}doDeregisterConfigurations(h){const n=[],S=a=>{if(a.properties)for(const i in a.properties)n.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,a.properties[i]);a.allOf&&a.allOf.forEach(i=>S(i))};for(const a of h){S(a);const i=this.configurationContributors.indexOf(a);i!==-1&&this.configurationContributors.splice(i,1)}return n}validateAndRegisterProperties(h,n=!0,S,a,i=3){i=I.isUndefinedOrNull(h.scope)?i:h.scope;let r=[],c=h.properties;if(c)for(let d in c){if(n&&D(d)){delete c[d];continue}const m=c[d];if(m.source=S,m.defaultDefaultValue=c[d].default,this.updatePropertyDefaultValue(d,m),e.OVERRIDE_PROPERTY_REGEX.test(d)?m.scope=void 0:(m.scope=I.isUndefinedOrNull(m.scope)?i:m.scope,m.restricted=I.isUndefinedOrNull(m.restricted)?!!a?.includes(d):m.restricted),c[d].hasOwnProperty("included")&&!c[d].included){this.excludedConfigurationProperties[d]=c[d],delete c[d];continue}else this.configurationProperties[d]=c[d];!c[d].deprecationMessage&&c[d].markdownDeprecationMessage&&(c[d].deprecationMessage=c[d].markdownDeprecationMessage),r.push(d)}let o=h.allOf;if(o)for(let d of o)r.push(...this.validateAndRegisterProperties(d,n,S,a,i));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(h){const n=S=>{let a=S.properties;if(a)for(const r in a)this.updateSchema(r,a[r]);let i=S.allOf;i&&i.forEach(n)};n(h)}updateSchema(h,n){switch(e.allSettings.properties[h]=n,n.scope){case 1:e.applicationSettings.properties[h]=n;break;case 2:e.machineSettings.properties[h]=n;break;case 6:e.machineOverridableSettings.properties[h]=n;break;case 3:e.windowSettings.properties[h]=n;break;case 4:e.resourceSettings.properties[h]=n;break;case 5:e.resourceSettings.properties[h]=n,this.resourceLanguageSettingsSchema.properties[h]=n;break}}removeFromSchema(h,n){switch(delete e.allSettings.properties[h],n.scope){case 1:delete e.applicationSettings.properties[h];break;case 2:delete e.machineSettings.properties[h];break;case 6:delete e.machineOverridableSettings.properties[h];break;case 3:delete e.windowSettings.properties[h];break;case 4:case 5:delete e.resourceSettings.properties[h],delete this.resourceLanguageSettingsSchema.properties[h];break}}updateOverridePropertyPatternKey(){for(const h of this.overrideIdentifiers.values()){const n=`[${h}]`,S={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,S),e.allSettings.properties[n]=S,e.applicationSettings.properties[n]=S,e.machineSettings.properties[n]=S,e.machineOverridableSettings.properties[n]=S,e.windowSettings.properties[n]=S,e.resourceSettings.properties[n]=S}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const h={type:"object",description:_.localize(4,null),errorMessage:_.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=h,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=h,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=h,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=h,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=h,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=h,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(h,n){const S=this.configurationDefaultsOverrides.get(h);let a=S?.value,i=S?.source;I.isUndefined(a)&&(a=n.defaultDefaultValue,i=void 0),I.isUndefined(a)&&(a=E(n.type)),n.default=a,n.defaultValueSource=i}}const l="\\[([^\\]]+)\\]",b=new RegExp(l,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${l})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(s){const h=[];if(e.OVERRIDE_PROPERTY_REGEX.test(s)){let n=b.exec(s);for(;n?.length;){const S=n[1].trim();S&&h.push(S),n=b.exec(s)}}return(0,f.distinct)(h)}e.overrideIdentifiersFromKey=p;function g(s){return s.reduce((h,n)=>`${h}[${n}]`,"")}e.keyFromOverrideIdentifiers=g;function E(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=E;const F=new C;k.Registry.add(e.Extensions.Configuration,F);function D(s){return s.trim()?e.OVERRIDE_PROPERTY_REGEX.test(s)?_.localize(7,null,s):F.getConfigurationProperties()[s]!==void 0?_.localize(8,null,s):null:_.localize(6,null)}e.validateProperty=D;function u(){const s=[],h=F.getConfigurationProperties();for(const n of Object.keys(h))s.push([n,h[n].scope]);return s.push(["launch",4]),s.push(["task",4]),s}e.getScopes=u}),define(pe[193],ve([0,1,17,3,57,6,24,25,18,2,116,119,50]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(a={},i=[],r=[]){this._contents=a,this._keys=i,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(a){return a?(0,L.getConfigurationValue)(this.contents,a):this.contents}getOverrideValue(a,i){const r=this.getContentsForOverrideIdentifer(i);return r?a?(0,L.getConfigurationValue)(r,a):r:void 0}getKeysForOverrideIdentifier(a){const i=[];for(const r of this.overrides)r.identifiers.includes(a)&&i.push(...r.keys);return f.distinct(i)}getAllOverrideIdentifiers(){const a=[];for(const i of this.overrides)a.push(...i.identifiers);return f.distinct(a)}override(a){let i=this.overrideConfigurations.get(a);return i||(i=this.createOverrideConfigurationModel(a),this.overrideConfigurations.set(a,i)),i}merge(...a){const i=k.deepClone(this.contents),r=k.deepClone(this.overrides),c=[...this.keys];for(const o of a){this.mergeContents(i,o.contents);for(const d of o.overrides){const[m]=r.filter(v=>f.equals(v.identifiers,d.identifiers));m?(this.mergeContents(m.contents,d.contents),m.keys.push(...d.keys),m.keys=f.distinct(m.keys)):r.push(k.deepClone(d))}for(const d of o.keys)c.indexOf(d)===-1&&c.push(d)}return new b(i,c,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(a){const i=this.getContentsForOverrideIdentifer(a);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let r={};for(const c of f.distinct([...Object.keys(this.contents),...Object.keys(i)])){let o=this.contents[c],d=i[c];d&&(typeof o=="object"&&typeof d=="object"?(o=k.deepClone(o),this.mergeContents(o,d)):o=d),r[c]=o}return new b(r,this.keys,this.overrides)}mergeContents(a,i){for(const r of Object.keys(i)){if(r in a&&y.isObject(a[r])&&y.isObject(i[r])){this.mergeContents(a[r],i[r]);continue}a[r]=k.deepClone(i[r])}}checkAndFreeze(a){return this.isFrozen&&!Object.isFrozen(a)?k.deepFreeze(a):a}getContentsForOverrideIdentifer(a){let i=null,r=null;const c=o=>{o&&(r?this.mergeContents(r,o):r=k.deepClone(o))};for(const o of this.overrides)f.equals(o.identifiers,[a])?i=o.contents:o.identifiers.includes(a)&&c(o.contents);return c(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(a,i){this.addKey(a),(0,L.addToValueTree)(this.contents,a,i,r=>{throw new Error(r)})}removeValue(a){this.removeKey(a)&&(0,L.removeFromValueTree)(this.contents,a)}addKey(a){let i=this.keys.length;for(let r=0;r<i;r++)a.indexOf(this.keys[r])===0&&(i=r);this.keys.splice(i,1,a)}removeKey(a){let i=this.keys.indexOf(a);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=b;class p extends b{constructor(a={}){const i=l.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(i),c=Object.create(null),o=[];for(const d in i){const m=a[d],v=m!==void 0?m:i[d].default;(0,L.addToValueTree)(c,d,v,w=>console.error(`Conflict in default settings: ${w}`))}for(const d of Object.keys(c))C.OVERRIDE_PROPERTY_REGEX.test(d)&&o.push({identifiers:(0,C.overrideIdentifiersFromKey)(d),keys:Object.keys(c[d]),contents:(0,L.toValuesTree)(c[d],m=>console.error(`Conflict in default settings file: ${m}`))});super(c,r,o)}}e.DefaultConfigurationModel=p;class g{constructor(a){this._name=a,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(a,i){if(!y.isUndefinedOrNull(a)){const r=this.doParseContent(a);this.parseRaw(r,i)}}reparse(a){this._raw&&this.parseRaw(this._raw,a)}parseRaw(a,i){this._raw=a;const{contents:r,keys:c,overrides:o,restricted:d}=this.doParseRaw(a,i);this._configurationModel=new b(r,c,o),this._restrictedConfigurations=d||[]}doParseContent(a){let i={},r=null,c=[],o=[],d=[];function m(w){Array.isArray(c)?c.push(w):r!==null&&(c[r]=w)}let v={onObjectBegin:()=>{let w={};m(w),o.push(c),c=w,r=null},onObjectProperty:w=>{r=w},onObjectEnd:()=>{c=o.pop()},onArrayBegin:()=>{let w=[];m(w),o.push(c),c=w,r=null},onArrayEnd:()=>{c=o.pop()},onLiteralValue:m,onError:(w,A,M)=>{d.push({error:w,offset:A,length:M})}};if(a)try{I.visit(a,v),i=c[0]||{}}catch(w){console.error(`Error while parsing settings file ${this._name}: ${w}`),this._parseErrors=[w]}return i}doParseRaw(a,i){const r=l.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),c=this.filter(a,r,!0,i);a=c.raw;const o=(0,L.toValuesTree)(a,v=>console.error(`Conflict in settings file ${this._name}: ${v}`)),d=Object.keys(a),m=this.toOverrides(a,v=>console.error(`Conflict in settings file ${this._name}: ${v}`));return{contents:o,keys:d,overrides:m,restricted:c.restricted}}filter(a,i,r,c){if(!c?.scopes&&!c?.skipRestricted)return{raw:a,restricted:[]};const o={},d=[];for(let m in a)if(C.OVERRIDE_PROPERTY_REGEX.test(m)&&r){const v=this.filter(a[m],i,!1,c);o[m]=v.raw,d.push(...v.restricted)}else{const v=i[m],w=v?typeof v.scope!="undefined"?v.scope:3:void 0;v?.restricted&&d.push(m),(w===void 0||c.scopes===void 0||c.scopes.includes(w))&&(c.skipRestricted&&v?.restricted||(o[m]=a[m]))}return{raw:o,restricted:d}}toOverrides(a,i){const r=[];for(const c of Object.keys(a))if(C.OVERRIDE_PROPERTY_REGEX.test(c)){const o={};for(const d in a[c])o[d]=a[c][d];r.push({identifiers:(0,C.overrideIdentifiersFromKey)(c),keys:Object.keys(o),contents:(0,L.toValuesTree)(o,i)})}return r}}e.ConfigurationModelParser=g;class E extends _.Disposable{constructor(a,i,r,c){super();this.userSettingsResource=a,this.scopes=i,this.fileService=c,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const a=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(a.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class F{constructor(a,i,r=new b,c=new b,o=new R.ResourceMap,d=new b,m=new R.ResourceMap,v=!0){this._defaultConfiguration=a,this._localUserConfiguration=i,this._remoteUserConfiguration=r,this._workspaceConfiguration=c,this._folderConfigurations=o,this._memoryConfiguration=d,this._memoryConfigurationByResource=m,this._freeze=v,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(a,i,r){return this.getConsolidateConfigurationModel(i,r).getValue(a)}updateValue(a,i,r={}){let c;r.resource?(c=this._memoryConfigurationByResource.get(r.resource),c||(c=new b,this._memoryConfigurationByResource.set(r.resource,c))):c=this._memoryConfiguration,i===void 0?c.removeValue(a):c.setValue(a,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(a,i,r){const c=this.getConsolidateConfigurationModel(i,r),o=this.getFolderConfigurationModelForResource(i.resource,r),d=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,m=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(a):this._defaultConfiguration.freeze().getValue(a),v=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(a):this.userConfiguration.freeze().getValue(a),w=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(a):this.localUserConfiguration.freeze().getValue(a),A=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(a):this.remoteUserConfiguration.freeze().getValue(a),M=r?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(a):this._workspaceConfiguration.freeze().getValue(a):void 0,T=o?i.overrideIdentifier?o.freeze().override(i.overrideIdentifier).getValue(a):o.freeze().getValue(a):void 0,O=i.overrideIdentifier?d.override(i.overrideIdentifier).getValue(a):d.getValue(a),U=c.getValue(a),V=f.distinct(f.flatten(c.overrides.map(x=>x.identifiers))).filter(x=>c.getOverrideValue(a,x)!==void 0);return{defaultValue:m,userValue:v,userLocalValue:w,userRemoteValue:A,workspaceValue:M,workspaceFolderValue:T,memoryValue:O,value:U,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(a),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,user:v!==void 0?{value:this.userConfiguration.freeze().getValue(a),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,userLocal:w!==void 0?{value:this.localUserConfiguration.freeze().getValue(a),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(a),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,workspace:M!==void 0?{value:this._workspaceConfiguration.freeze().getValue(a),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,workspaceFolder:T!==void 0?{value:o?.freeze().getValue(a),override:i.overrideIdentifier?o?.freeze().getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,memory:O!==void 0?{value:d.getValue(a),override:i.overrideIdentifier?d.getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(a){const i=this.getFolderConfigurationModelForResource(void 0,a);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(a){this._defaultConfiguration=a,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(a){this._localUserConfiguration=a,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(a){this._remoteUserConfiguration=a,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(a){this._workspaceConfiguration=a,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(a,i){this._folderConfigurations.set(a,i),this._foldersConsolidatedConfigurations.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this._foldersConsolidatedConfigurations.delete(a)}compareAndUpdateDefaultConfiguration(a,i){const r=[];if(!i){const{added:c,updated:o,removed:d}=h(this._defaultConfiguration,a);i=[...c,...o,...d]}for(const c of i)for(const o of(0,C.overrideIdentifiersFromKey)(c)){const d=this._defaultConfiguration.getKeysForOverrideIdentifier(o),m=a.getKeysForOverrideIdentifier(o),v=[...m.filter(w=>d.indexOf(w)===-1),...d.filter(w=>m.indexOf(w)===-1),...d.filter(w=>!k.equals(this._defaultConfiguration.override(o).getValue(w),a.override(o).getValue(w)))];r.push([o,v])}return this.updateDefaultConfiguration(a),{keys:i,overrides:r}}compareAndUpdateLocalUserConfiguration(a){const{added:i,updated:r,removed:c,overrides:o}=h(this.localUserConfiguration,a),d=[...i,...r,...c];return d.length&&this.updateLocalUserConfiguration(a),{keys:d,overrides:o}}compareAndUpdateRemoteUserConfiguration(a){const{added:i,updated:r,removed:c,overrides:o}=h(this.remoteUserConfiguration,a);let d=[...i,...r,...c];return d.length&&this.updateRemoteUserConfiguration(a),{keys:d,overrides:o}}compareAndUpdateWorkspaceConfiguration(a){const{added:i,updated:r,removed:c,overrides:o}=h(this.workspaceConfiguration,a);let d=[...i,...r,...c];return d.length&&this.updateWorkspaceConfiguration(a),{keys:d,overrides:o}}compareAndUpdateFolderConfiguration(a,i){const r=this.folderConfigurations.get(a),{added:c,updated:o,removed:d,overrides:m}=h(r,i);let v=[...c,...o,...d];return(v.length||!r)&&this.updateFolderConfiguration(a,i),{keys:v,overrides:m}}compareAndDeleteFolderConfiguration(a){const i=this.folderConfigurations.get(a);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:r,updated:c,removed:o,overrides:d}=h(i,void 0);return{keys:[...r,...c,...o],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(a,i){let r=this.getConsolidatedConfigurationModelForResource(a,i);return a.overrideIdentifier?r.override(a.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:a},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&a){const c=i.getFolder(a);c&&(r=this.getFolderConsolidatedConfiguration(c.uri)||r);const o=this._memoryConfigurationByResource.get(a);o&&(r=r.merge(o))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(a){let i=this._foldersConsolidatedConfigurations.get(a);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(a);c?(i=r.merge(c),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(a,i)):i=r}return i}getFolderConfigurationModelForResource(a,i){if(i&&a){const r=i.getFolder(a);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((a,i)=>{const{contents:r,overrides:c,keys:o}=this._folderConfigurations.get(i);return a.push([i,{contents:r,overrides:c,keys:o}]),a},[])}}allKeys(){const a=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>a.add(i)),this.userConfiguration.freeze().keys.forEach(i=>a.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>a.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(r=>a.add(r))),[...a.values()]}allOverrideIdentifiers(){const a=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>a.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>a.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>a.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(r=>a.add(r))),[...a.values()]}getAllKeysForOverrideIdentifier(a){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(a).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(a).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(a).forEach(c=>i.add(c))),[...i.values()]}static parse(a){const i=this.parseConfigurationModel(a.defaults),r=this.parseConfigurationModel(a.user),c=this.parseConfigurationModel(a.workspace),o=a.folders.reduce((d,m)=>(d.set(P.URI.revive(m[0]),this.parseConfigurationModel(m[1])),d),new R.ResourceMap);return new F(i,r,new b,c,o,new b,new R.ResourceMap,!1)}static parseConfigurationModel(a){return new b(a.contents,a.keys,a.overrides).freeze()}}e.Configuration=F;function D(...S){if(S.length===0)return{keys:[],overrides:[]};if(S.length===1)return S[0];const a=new Set,i=new Map;for(const c of S)c.keys.forEach(o=>a.add(o)),c.overrides.forEach(([o,d])=>{const m=(0,R.getOrSet)(i,o,new Set);d.forEach(v=>m.add(v))});const r=[];return i.forEach((c,o)=>r.push([o,[...c.values()]])),{keys:[...a.values()],overrides:r}}e.mergeChanges=D;class u{constructor(a,i,r,c){this.change=a,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=c,this._previousConfiguration=void 0;const o=new Set;a.keys.forEach(m=>o.add(m)),a.overrides.forEach(([,m])=>m.forEach(v=>o.add(v))),this.affectedKeys=[...o.values()];const d=new b;this.affectedKeys.forEach(m=>d.setValue(m,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=F.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(a,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,a)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(a,i,this.previous?.workspace):void 0,c=this.currentConfiguraiton.getValue(a,i,this.currentWorkspace);return!k.equals(r,c)}return!0}return!1}doesAffectedKeysTreeContains(a,i){let r=(0,L.toValuesTree)({[i]:!0},()=>{}),c;for(;typeof r=="object"&&(c=Object.keys(r)[0]);){if(a=a[c],!a)return!1;r=r[c]}return!0}}e.ConfigurationChangeEvent=u;class s extends u{constructor(a,i,r,c){super({keys:a.allKeys(),overrides:[]},void 0,a,i);this.source=r,this.sourceConfig=c}}e.AllKeysConfigurationChangeEvent=s;function h(S,a){const{added:i,removed:r,updated:c}=n(a,S),o=[],d=S?.getAllOverrideIdentifiers()||[],m=a?.getAllOverrideIdentifiers()||[];if(a){const v=m.filter(w=>!d.includes(w));for(const w of v)o.push([w,a.getKeysForOverrideIdentifier(w)])}if(S){const v=d.filter(w=>!m.includes(w));for(const w of v)o.push([w,S.getKeysForOverrideIdentifier(w)])}if(a&&S){for(const v of d)if(m.includes(v)){const w=n({contents:S.getOverrideValue(void 0,v)||{},keys:S.getKeysForOverrideIdentifier(v)},{contents:a.getOverrideValue(void 0,v)||{},keys:a.getKeysForOverrideIdentifier(v)});o.push([v,[...w.added,...w.removed,...w.updated]])}}return{added:i,removed:r,updated:c,overrides:o}}function n(S,a){const i=S?a?S.keys.filter(o=>a.keys.indexOf(o)===-1):[...S.keys]:[],r=a?S?a.keys.filter(o=>S.keys.indexOf(o)===-1):[...a.keys]:[],c=[];if(S&&a){for(const o of a.keys)if(S.keys.indexOf(o)!==-1){const d=(0,L.getConfigurationValue)(a.contents,o),m=(0,L.getConfigurationValue)(S.contents,o);k.equals(d,m)||c.push(o)}}return{added:i,removed:r,updated:c}}}),define(pe[120],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,f.createDecorator)("remoteAuthorityResolverService");var t;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class I extends Error{constructor(R,k=t.Unknown,y){super(R);this._message=R,this._code=k,this._detail=y,this.isHandled=k===t.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,I.prototype)}static isTemporarilyNotAvailable(R){return R instanceof I&&R._code===t.TemporarilyNotAvailable}static isNoResolverFound(R){return R instanceof I&&R._code===t.NoResolverFound}static isHandled(R){return R instanceof I&&R.isHandled}}e.RemoteAuthorityResolverError=I}),define(pe[63],ve([0,1,10]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function t(P){return P.scheme===f.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=t;function I(P){if(!P)return;const L=P.indexOf("+");return L<0?P:P.substr(0,L)}e.getRemoteName=I;function _(P){return P.scheme!==f.Schemas.file&&P.scheme!==f.Schemas.vscodeRemote}e.isVirtualResource=_;function R(P){if(P.folders.length)return P.folders.every(L=>_(L.uri))?P.folders[0].uri:void 0;if(P.configuration&&_(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=R;function k(P){return R(P)?.scheme}e.getVirtualWorkspaceScheme=k;function y(P){return R(P)!==void 0}e.isVirtualWorkspace=y}),define(pe[27],ve([0,1,8,4,63]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function _(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.getWorkspaceSupportTypeMessage=_;function R(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class y{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,p){if(typeof b=="undefined"||b===null)return typeof p=="undefined"||p===null;if(typeof p=="undefined"||p===null)return!1;if(typeof b=="string"||typeof p=="string"){let g=typeof b=="string"?b:b.value,E=typeof p=="string"?p:p.value;return f.equalsIgnoreCase(g,E)}return b._lower===p._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=y;function P(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function L(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=L;function C(l,b){if(b){const p=`onResolveRemoteAuthority:${(0,I.getRemoteName)(b)}`;return l.activationEvents?.indexOf(p)!==-1}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(pe[121],ve([0,1,8,27]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function I(p,g){return p.uuid&&g.uuid?p.uuid===g.uuid:p.id===g.id?!0:(0,f.compareIgnoreCase)(p.id,g.id)===0}e.areSameExtensions=I;class _{constructor(g,E){this.version=E,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof _?I(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=_;function R(p,g){return`${p}.${g}`}e.getExtensionId=R;function k(p){return p.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function y(p,g){return k(R(p,g))}e.getGalleryExtensionId=y;function P(p,g){const E=[],F=D=>{for(const u of E)if(u.some(s=>I(g(s),g(D))))return u;return null};for(const D of p){const u=F(D);u?u.push(D):E.push([D])}return E}e.groupByExtension=P;function L(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=L;function C(p){return{id:p.identifier.id,name:p.name,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,isPreReleaseVersion:p.properties.isPreReleaseVersion,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0),...p.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function l(p){const g=new Set;if(p.malicious)for(const E of p.malicious)g.add(E.id);return g}e.getMaliciousExtensionsSet=l;function b(p,g){const E=[],F=g.manifest.extensionDependencies?.slice(0)??[];for(;F.length;){const D=F.shift();if(D&&E.every(u=>!I(u.identifier,{id:D}))){const u=p.filter(s=>I(s.identifier,{id:D}));u.length===1&&(E.push(u[0]),F.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return E}e.getExtensionDependencies=b}),define(pe[194],ve([0,1,10,158,121,4]),function(Z,e,f,t,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.getIdAndVersion=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";const R=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function k(n){const S=R.exec(n);return S&&S[1]?[(0,I.adoptToGalleryExtensionId)(S[1]),S[2]]:[(0,I.adoptToGalleryExtensionId)(n),void 0]}e.getIdAndVersion=k;var y;(function(n){n.WIN32_X64="win32-x64",n.WIN32_IA32="win32-ia32",n.WIN32_ARM64="win32-arm64",n.LINUX_X64="linux-x64",n.LINUX_ARM64="linux-arm64",n.LINUX_ARMHF="linux-armhf",n.ALPINE_X64="alpine-x64",n.ALPINE_ARM64="alpine-arm64",n.DARWIN_X64="darwin-x64",n.DARWIN_ARM64="darwin-arm64",n.WEB="web",n.UNIVERSAL="universal",n.UNKNOWN="unknown",n.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));function P(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function L(n){switch(n){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function C(n,S){switch(n){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function l(n,S){return S==="web"&&!n.includes("web")}e.isNotWebExtensionInWebTargetPlatform=l;function b(n,S,a){return l(S,a)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===a?!0:p(a).includes(n)}e.isTargetPlatformCompatible=b;function p(n){switch(n){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=p;function g(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=g;var E;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var F;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(F=e.SortOrder||(e.SortOrder={}));var D;(function(n){n.Install="install",n.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var u;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(u=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,_.createDecorator)("extensionGalleryService");var s;(function(n){n.Unsupported="Unsupported",n.UnsupportedPreRelease="UnsupportedPreRelease",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatiblePreRelease="IncompatiblePreRelease",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.Extract="Extract",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Internal="Internal"})(s=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class h extends Error{constructor(S,a){super(S);this.code=a,this.name=a}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,_.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,_.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,_.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=f.FileAccess.asBrowserUri("./media/defaultIcon.png",Z).toString(!0),e.ExtensionsLabel=(0,t.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,t.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,_.createDecorator)("IExtensionManagementCLIService")}),define(pe[122],ve([0,1,3,12,4,11]),function(Z,e,f,t,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,I.createDecorator)("sharedTunnelsService");var R;(function(p){p.Http="http",p.Https="https"})(R=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=C;function l(p,g){return g?g!==1&&p<1024:!t.isWindows&&p<1024}e.isPortPrivileged=l;let b=class{constructor(g){this.logService=g,this._onTunnelOpened=new f.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new f.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new f.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(g){return this._tunnelProvider=g,g?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this._canElevate=g.elevation,this._privacyOptions=g.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const g=[],E=Array.from(this._tunnels.values());for(let F of E){const D=Array.from(F.values());for(let u of D){const s=await u.value;s&&g.push(s)}}return g}async dispose(){for(const g of this._tunnels.values()){for(const{value:E}of g.values())await E.then(F=>F?.dispose());g.clear()}this._tunnels.clear()}openTunnel(g,E,F,D,u=!1,s=k.Private,h){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${E}:${F} on local port ${D}.`),!g)return;E||(E="localhost");const n=this.retainOrCreateTunnel(g,E,F,D,u,s,h);return n?n.then(S=>{if(!S){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(E,F);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(S);return(S.tunnelRemoteHost!==E||S.tunnelRemotePort!==F)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const E=this._tunnels.get(g.tunnelRemoteHost);if(E){const F=E.get(g.tunnelRemotePort);F&&(F.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,F))}}}}async tryDisposeTunnel(g,E,F){if(F.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${E}.`);const D=F.value.then(async u=>{u&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(E),D}}async closeTunnel(g,E){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${E} `);const F=this._tunnels.get(g);if(F&&F.has(E)){const D=F.get(E);D.refcount=0,await this.tryDisposeTunnel(g,E,D)}}addTunnelToMap(g,E,F){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(E,{refcount:1,value:F})}async removeEmptyTunnelFromMap(g,E){const F=this._tunnels.get(g);F&&(await F.get(E)||F.delete(E),F.size===0&&this._tunnels.delete(g))}getTunnelFromMap(g,E){let F=[g];L(g)?(F.push(...e.LOCALHOST_ADDRESSES),F.push(...e.ALL_INTERFACES_ADDRESSES)):C(g)&&F.push(...e.ALL_INTERFACES_ADDRESSES);const D=F.map(u=>this._tunnels.get(u));for(const u of D){const s=u?.get(E);if(s)return s}}canTunnel(g){return!!P(g)}createWithProvider(g,E,F,D,u,s,h){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${E}:${F} on local port ${D}.`);const S={elevationRequired:u?l(D===void 0?F:D):!1},a={remoteAddress:{host:E,port:F},localAddressPort:D,privacy:s,public:s!==k.Private,protocol:h},i=g.forwardPort(a,S);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(E,F,i),i}};b=je([ze(0,_.ILogService)],b),e.AbstractTunnelService=b}),define(pe[195],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class f{constructor(){this.validators=new Map}vsda(){return new Promise((I,_)=>Z(["vsda"],I,_))}async createNewMessage(I){try{const _=await this.vsda(),R=new _.validator;if(R){const k=String(f._nextId++);return this.validators.set(k,R),{id:k,data:R.createNewMessage(I)}}}catch{}return{id:"",data:I}}async validate(I,_){if(!I.id)return!0;const R=this.validators.get(I.id);if(!R)return!1;this.validators.delete(I.id);try{return R.validate(_)==="ok"}catch{return!1}}async sign(I){try{const _=await this.vsda(),R=new _.signer;if(R)return R.sign(I)}catch{}return I}}e.SignService=f,f._nextId=1}),define(pe[196],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class f{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,_,R=5){let k;return k=_(y=>{const P=typeof y=="string"?y:y.data;let L=this._terminalBufferMap.get(I);if(L){L.data.push(P);return}const C=setTimeout(()=>this.flushBuffer(I),R);L={data:[P],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(I),k.dispose()}},this._terminalBufferMap.set(I,L)}),k}stopBuffering(I){const _=this._terminalBufferMap.get(I);_&&_.dispose()}flushBuffer(I){const _=this._terminalBufferMap.get(I);_&&(this._terminalBufferMap.delete(I),this._callback(I,_.data.join("")))}}e.TerminalDataBufferer=f}),define(pe[197],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var f;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(f=e.ColorScheme||(e.ColorScheme={}))}),define(pe[85],ve([0,1,74,3,6,4,50,197]),function(Z,e,f,t,I,_,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,_.createDecorator)("themeService");var y;(function(E){function F(D){return D&&typeof D=="object"&&typeof D.id=="string"}E.isThemeColor=F})(y=e.ThemeColor||(e.ThemeColor={}));function P(E){return{id:E}}e.themeColorFromId=P;var L;(function(E){function F(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||y.isThemeColor(i.color))}E.isThemeIcon=F;const D=new RegExp(`^\\$\\((${f.CSSIcon.iconNameExpression}(?:${f.CSSIcon.iconModifierExpression})?)\\)$`);function u(i){const r=D.exec(i);if(!r)return;let[,c]=r;return{id:c}}E.fromString=u;function s(i){return{id:i}}E.fromId=s;function h(i,r){let c=i.id;const o=c.lastIndexOf("~");return o!==-1&&(c=c.substring(0,o)),r&&(c=`${c}~${r}`),{id:c}}E.modify=h;function n(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}E.getModifier=n;function S(i,r){return i.id===r.id&&i.color?.id===r.color?.id}E.isEqual=S;function a(i,r){return{id:i.id,color:r?P(r):void 0}}E.asThemeIcon=a,E.asClassNameArray=f.CSSIcon.asClassNameArray,E.asClassName=f.CSSIcon.asClassName,E.asCSSSelector=f.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=f.Codicon.file,e.FolderThemeIcon=f.Codicon.folder;function C(E){switch(E){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class l{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(F){return this.themingParticipants.push(F),this.onThemingParticipantAddedEmitter.fire(F),(0,I.toDisposable)(()=>{const D=this.themingParticipants.indexOf(F);this.themingParticipants.splice(D,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let b=new l;R.Registry.add(e.Extensions.ThemingContribution,b);function p(E){return b.onColorThemeChange(E)}e.registerThemingParticipant=p;class g extends I.Disposable{constructor(F){super();this.themeService=F,this.theme=F.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(D=>this.onThemeChange(D)))}onThemeChange(F){this.theme=F,this.updateStyles()}updateStyles(){}getColor(F,D){let u=this.theme.getColor(F);return u&&D&&(u=D(u,this.theme)),u?u.toString():null}}e.Themable=g}),define(pe[43],ve([0,1,24,23,2,4]),function(Z,e,f,t,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,_.createDecorator)("contextService");var R;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(R=e.WorkbenchState||(e.WorkbenchState={}));function k(l){const b=l;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}e.isWorkspace=k;function y(l){const b=l;return!!(b&&typeof b=="object"&&I.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}e.isWorkspaceFolder=y;class P{constructor(b,p,g,E,F){this._id=b,this._transient=g,this._configuration=E,this._ignorePathCasing=F,this._foldersMap=f.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=p}update(b){this._id=b.id,this._configuration=b.configuration,this._transient=b.transient,this._ignorePathCasing=b._ignorePathCasing,this.folders=b.folders}get folders(){return this._folders}set folders(b){this._folders=b,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(b){this._configuration=b}getFolder(b){return b&&this._foldersMap.findSubstr(b.with({scheme:b.scheme,authority:b.authority,path:b.path}))||null}updateFoldersMap(){this._foldersMap=f.TernarySearchTree.forUris(this._ignorePathCasing);for(const b of this.folders)this._foldersMap.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=P;class L{constructor(b,p){this.raw=p,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,t.joinPath)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=L;function C(l){return new L({uri:l,index:0,name:(0,t.basenameOrAuthority)(l)},{uri:l.toString()})}e.toWorkspaceFolder=C}),define(pe[198],ve([0,1,29,57,141,80,10,9,12,23,2,163,4,63,43]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,C.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(N){return(typeof N=="string"?(0,k.extname)(N):(0,P.extname)(N))===g}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,l.createDecorator)("workspacesService");function F(N){return N.hasOwnProperty("workspace")}e.isRecentWorkspace=F;function D(N){return N.hasOwnProperty("folderUri")}e.isRecentFolder=D;function u(N){return N.hasOwnProperty("fileUri")}e.isRecentFile=u;function s(N){return N&&N.hasOwnProperty("folderUri")}e.isFolderBackupInfo=s;function h(N){return N&&N.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=h;function n(N){const B=N;return typeof B?.id=="string"&&L.URI.isUri(B.uri)}e.isSingleFolderWorkspaceIdentifier=n;function S(N){if(N.configuration)return{id:N.id,configPath:N.configuration};if(N.folders.length===1)return{id:N.id,uri:N.folders[0].uri}}e.toWorkspaceIdentifier=S;function a(N){const B=N;return typeof B?.id=="string"&&L.URI.isUri(B.configPath)}e.isWorkspaceIdentifier=a;function i(N){const B=N;if(B?.uri)return{id:B.id,uri:L.URI.revive(B.uri)};const W=N;if(W?.configPath)return{id:W.id,configPath:L.URI.revive(W.configPath)};if(N?.id)return{id:N.id}}e.reviveIdentifier=i;function r(N,B){return P.extUriBiasedIgnorePathCase.isEqualOrParent(N,B.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function c(N){return o(N)||d(N)}e.isStoredWorkspaceFolder=c;function o(N){const B=N;return typeof B?.path=="string"&&(!B.name||typeof B.name=="string")}e.isRawFileWorkspaceFolder=o;function d(N){const B=N;return typeof B?.uri=="string"&&(!B.name||typeof B.name=="string")}e.isRawUriWorkspaceFolder=d;function m(N,B,W,H,z=!y.isWindows,J){if(N.scheme!==H.scheme)return{name:W,uri:N.toString(!0)};let ie=B?void 0:J.relativePath(H,N);if(ie!==void 0)ie.length===0?ie=".":y.isWindows&&N.scheme===R.Schemas.file&&!z&&(ie=ie.replace(/\//g,"\\"));else if(N.scheme===R.Schemas.file)ie=N.fsPath,y.isWindows&&(ie=(0,_.normalizeDriveLetter)(ie),z&&(ie=(0,f.toSlashes)(ie)));else{if(!J.isEqualAuthority(N.authority,H.authority))return{name:W,uri:N.toString(!0)};ie=N.path}return{name:W,path:ie}}e.getStoredWorkspaceFolder=m;function v(N,B,W){let H=[],z=new Set;const J=W.dirname(B);for(let ie of N){let se;if(o(ie))ie.path&&(se=W.resolvePath(J,ie.path));else if(d(ie))try{se=L.URI.parse(ie.uri),se.path[0]!=="/"&&(se=se.with({path:"/"+se.path}))}catch(K){console.warn(K)}if(se){let K=W.getComparisonKey(se);if(!z.has(K)){z.add(K);const X=ie.name||W.basenameOrAuthority(se);H.push(new p.WorkspaceFolder({uri:se,name:X,index:H.length},ie))}}}return H}e.toWorkspaceFolders=v;function w(N,B,W,H,z){let J=A(B,N);const ie=z.dirname(B),se=z.dirname(H),K=[],X=M(J.folders);for(const Me of J.folders){const xe=o(Me)?z.resolvePath(ie,Me.path):L.URI.parse(Me.uri);let Ge;W?Ge=!1:Ge=!o(Me)||(0,k.isAbsolute)(Me.path),K.push(m(xe,Ge,Me.name,se,X,z))}const ae={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},fe=I.setProperty(N,["folders"],K,ae);let be=I.applyEdits(N,fe);return(0,P.isEqualAuthority)(J.remoteAuthority,(0,b.getRemoteAuthority)(H))&&(be=I.applyEdits(be,I.removeProperty(be,["remoteAuthority"],ae))),be}e.rewriteWorkspaceFileForNewLocation=w;function A(N,B){let W=t.parse(B);if(W&&Array.isArray(W.folders))W.folders=W.folders.filter(H=>c(H));else throw new Error(`${N} looks like an invalid workspace file.`);return W}function M(N){return y.isWindows?N.some(B=>o(B)&&B.path.indexOf("/")>=0):!0}e.useSlashForPath=M;function T(N){return N.workspace&&typeof N.workspace=="object"&&typeof N.workspace.id=="string"&&typeof N.workspace.configPath=="string"}function O(N){return typeof N.folderUri=="string"}function U(N){return typeof N.fileUri=="string"}function V(N,B){const W={workspaces:[],files:[]};if(N){const H=function(J,ie){for(let se=0;se<J.length;se++)try{ie(J[se],se)}catch(K){B.warn(`Error restoring recent entry ${JSON.stringify(J[se])}: ${K.toString()}. Skip entry.`)}},z=N;if(Array.isArray(z.entries))H(z.entries,J=>{const ie=J.label,se=J.remoteAuthority;T(J)?W.workspaces.push({label:ie,remoteAuthority:se,workspace:{id:J.workspace.id,configPath:L.URI.parse(J.workspace.configPath)}}):O(J)?W.workspaces.push({label:ie,remoteAuthority:se,folderUri:L.URI.parse(J.folderUri)}):U(J)&&W.files.push({label:ie,remoteAuthority:se,fileUri:L.URI.parse(J.fileUri)})});else{const J=N;Array.isArray(J.workspaces3)&&H(J.workspaces3,(ie,se)=>{const K=Array.isArray(J.workspaceLabels)&&J.workspaceLabels[se]||void 0;typeof ie=="object"&&typeof ie.id=="string"&&typeof ie.configURIPath=="string"?W.workspaces.push({label:K,workspace:{id:ie.id,configPath:L.URI.parse(ie.configURIPath)}}):typeof ie=="string"&&W.workspaces.push({label:K,folderUri:L.URI.parse(ie)})}),Array.isArray(J.files2)&&H(J.files2,(ie,se)=>{const K=Array.isArray(J.fileLabels)&&J.fileLabels[se]||void 0;typeof ie=="string"&&W.files.push({label:K,fileUri:L.URI.parse(ie)})})}}return W}e.restoreRecentlyOpened=V;function x(N){const B={entries:[]};for(const W of N.workspaces)D(W)?B.entries.push({folderUri:W.folderUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority}):B.entries.push({workspace:{id:W.workspace.id,configPath:W.workspace.configPath.toString()},label:W.label,remoteAuthority:W.remoteAuthority});for(const W of N.files)B.entries.push({fileUri:W.fileUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority});return B}e.toStoreData=x}),define(pe[86],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class f{constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const _=this._idPool++;return this._data.set(_,I),this.logDebugInfo(),_}get(I,_){return this._data.has(I)?this._data.get(I)[_]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){!f.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=f,f.enableDebugLogging=!1}),define(pe[44],ve([0,1,10,23,4]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class _{constructor(){this._systemSchemes=new Set(Object.keys(f.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(k=>{const y=this._providerInfo.get(k.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(k,y){y===null?this._providerInfo.delete(k.scheme):this._providerInfo.set(k.scheme,y)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=_,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(pe[26],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,f.createDecorator)("IExtHostInitDataService")}),define(pe[199],ve([0,1,13]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(R,k,y){this._deferredPromises=new Map,this._id=R,this._shared=k,this._storage=y,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new f.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const L of P.values())L.complete()}catch(L){for(const C of P.values())C.error(L)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this._init}get(R,k){let y=this._value[R];return typeof y=="undefined"&&(y=k),y}update(R,k){this._value[R]=k;let y=this._deferredPromises.get(R);if(y!==void 0)return y.p;const P=new f.DeferredPromise;return this._deferredPromises.set(R,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class I extends t{constructor(R,k){super(R.identifier.value,!0,k);this._extension=R}setKeysForSync(R){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},R)}}e.ExtensionGlobalMemento=I}),define(pe[200],ve([0,1,3,2,11]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let _=class{constructor(k,y){this._logService=k,this._notebooksAndEditors=y,this._onDidChangeNotebookDocumentMetadata=new f.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new f.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,y,P){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k)).acceptModelChanged(y.value,P)}$acceptDirtyStateChanged(k,y){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k)).acceptDirty(y)}$acceptModelSaved(k){const y=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}$acceptDocumentPropertiesChanged(k,y){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,y);const P=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k));P.acceptDocumentPropertiesChanged(y),y.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};_=je([ze(0,I.ILogService)],_),e.ExtHostNotebookDocuments=_}),define(pe[14],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,f.createDecorator)("IExtHostRpcService");class t{constructor(_){this.getProxy=_.getProxy.bind(_),this.set=_.set.bind(_),this.assertRegistered=_.assertRegistered.bind(_),this.drain=_.drain.bind(_)}}e.ExtHostRpcService=t});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[201],ve([0,1,27,3]),function(Z,e,f,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class _{constructor(k,y){I.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=f.ExtensionIdentifier.toKey(k.identifier),nt(this,I,y,"f"),Le(this,I,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(k){return Le(this,I,"f").get(this._id,k)}store(k,y){return Le(this,I,"f").store(this._id,k,y)}delete(k){return Le(this,I,"f").delete(this._id,k)}}e.ExtensionSecrets=_,I=new WeakMap}),define(pe[123],ve([0,1,4,3]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class I{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(R){this._enabled=R}$onDidChangeTelemetryEnabled(R){this._enabled=R,this._onDidChangeTelemetryEnabled.fire(R)}}e.ExtHostTelemetry=I,e.IExtHostTelemetry=(0,f.createDecorator)("IExtHostTelemetry")}),define(pe[64],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var f;(function(D){D[D.Upsert=0]="Upsert",D[D.RemoveChild=1]="RemoveChild",D[D.Invalidated=2]="Invalidated",D[D.SetProp=3]="SetProp",D[D.Bulk=4]="Bulk"})(f=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,I=(D,u)=>{const s={controllerId:u};return t.set(D,s),s};e.createPrivateApiFor=I;const _=D=>t.get(D);e.getPrivateApiFor=_;const R=(D,u,s,h)=>{let n=s;return{enumerable:!0,configurable:!1,get(){return n},set(S){if(!h(n,S)){const a=n;n=S,D.listener?.({op:3,key:u,value:S,previous:a})}}}},k=(D,u)=>D===u,y={range:(D,u)=>D===u?!0:!D||!u?!1:D.isEqual(u),label:k,description:k,busy:k,error:k,canResolveChildren:k,tags:(D,u)=>!(D.length!==u.length||D.some(s=>!u.find(h=>s.id===h.id)))},P=Object.keys(y),L=(D,u)=>({range:R(D,"range",void 0,y.range),label:R(D,"label",u,y.label),description:R(D,"description",void 0,y.description),canResolveChildren:R(D,"canResolveChildren",!1,y.canResolveChildren),busy:R(D,"busy",!1,y.busy),error:R(D,"error",void 0,y.error),tags:R(D,"tags",[],y.tags)}),C=(D,u)=>{const s=new Map;for(const h of P)y[h](D[h],u[h])||s.set(h,u[h]);return s};e.diffTestItems=C;class l extends Error{constructor(u){super(`Attempted to insert a duplicate test item ID ${u}`)}}e.DuplicateTestItemError=l;class b extends Error{constructor(u){super(`TestItem with ID "${u}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=b;class p extends Error{constructor(u,s,h){super(`TestItem with ID "${u}" is from controller "${s}" and cannot be added as a child of an item from controller "${h}".`)}}e.MixedTestItemController=p;const g=D=>{const u=(0,e.getPrivateApiFor)(D);let s=new Map;return{get size(){return s.size},forEach(h,n){for(const S of s.values())h.call(n,S,this)},replace(h){const n=new Map,S=new Set(s.keys()),a={op:4,ops:[]};for(const i of h){if(!(i instanceof E))throw new b(i.id);const r=(0,e.getPrivateApiFor)(i).controllerId;if(r!==u.controllerId)throw new p(i.id,r,u.controllerId);if(n.has(i.id))throw new l(i.id);n.set(i.id,i),S.delete(i.id),a.ops.push({op:0,item:i})}for(const i of S.keys())a.ops.push({op:1,id:i});u.listener?.(a),s=n},add(h){if(!(h instanceof E))throw new b(h.id);s.set(h.id,h),u.listener?.({op:0,item:h})},delete(h){s.delete(h)&&u.listener?.({op:1,id:h})},get(h){return s.get(h)},toJSON(){return Array.from(s.values())},[Symbol.iterator](){return s.values()}}};class E{constructor(u,s,h,n){if(s.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(s)} symbol`);const S=(0,e.createPrivateApiFor)(this,u);Object.defineProperties(this,{id:{value:s,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return S.parent instanceof F?void 0:S.parent}},children:{value:g(this),enumerable:!0,writable:!1},...L(S,h)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=E;class F extends E{constructor(u,s){super(u,u,s,void 0)}}e.TestItemRootImpl=F}),define(pe[51],ve([0,1,4,122,3,14]),function(Z,e,f,t,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var R;(function(y){function P(C){return{remoteAddress:C.remoteAddress,localAddress:C.localAddress,public:!!C.public,privacy:C.privacy??(C.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:C.protocol}}y.fromApiTunnel=P;function L(C){return{remoteAddress:{host:C.tunnelRemoteHost,port:C.tunnelRemotePort},localAddress:C.localAddress,public:C.privacy!==t.TunnelPrivacyId.ConstantPrivate&&C.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:C.privacy,protocol:C.protocol}}y.fromServiceTunnel=L})(R=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,f.createDecorator)("IExtHostTunnelService");let k=class{constructor(P){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,L){}async getTunnels(){return[]}async setTunnelFactory(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,L){return{dispose:()=>{}}}async $providePortAttributes(P,L,C,l,b){return[]}async $forwardPort(P,L){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=je([ze(0,_.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[7],ve([0,1,17,16,99,24,95,8,18,2,33,42,120]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l){"use strict";var b,p,g,E,F,D,u,s,h,n,S,a,i,r,c,o,d,m,v,w;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function A(j){function $(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty($,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf($,j),Object.setPrototypeOf($.prototype,j.prototype),$}let M=F=class{constructor($){b.set(this,void 0),nt(this,b,$,"f")}static from(...$){let ue=$;return new F(function(){if(ue){for(const Pe of ue)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();ue=void 0}})}dispose(){typeof Le(this,b,"f")=="function"&&(Le(this,b,"f").call(this),nt(this,b,void 0,"f"))}};b=new WeakMap,M=F=je([A],M),e.Disposable=M;let T=D=class{constructor($,ue){if($<0)throw(0,t.illegalArgument)("line must be non-negative");if(ue<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=$,this._character=ue}static Min(...$){if($.length===0)throw new TypeError;let ue=$[0];for(let Pe=1;Pe<$.length;Pe++){const et=$[Pe];et.isBefore(ue)&&(ue=et)}return ue}static Max(...$){if($.length===0)throw new TypeError;let ue=$[0];for(let Pe=1;Pe<$.length;Pe++){const et=$[Pe];et.isAfter(ue)&&(ue=et)}return ue}static isPosition($){if(!$)return!1;if($ instanceof D)return!0;let{line:ue,character:Pe}=$;return typeof ue=="number"&&typeof Pe=="number"}get line(){return this._line}get character(){return this._character}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,ue=0){if($===null||ue===null)throw(0,t.illegalArgument)();let Pe;return typeof $=="undefined"?Pe=0:typeof $=="number"?Pe=$:(Pe=typeof $.lineDelta=="number"?$.lineDelta:0,ue=typeof $.characterDelta=="number"?$.characterDelta:0),Pe===0&&ue===0?this:new D(this.line+Pe,this.character+ue)}with($,ue=this.character){if($===null||ue===null)throw(0,t.illegalArgument)();let Pe;return typeof $=="undefined"?Pe=this.line:typeof $=="number"?Pe=$:(Pe=typeof $.line=="number"?$.line:this.line,ue=typeof $.character=="number"?$.character:this.character),Pe===this.line&&ue===this.character?this:new D(Pe,ue)}toJSON(){return{line:this.line,character:this.character}}};T=D=je([A],T),e.Position=T;let O=u=class{constructor($,ue,Pe,et){let at,dt;if(typeof $=="number"&&typeof ue=="number"&&typeof Pe=="number"&&typeof et=="number"?(at=new T($,ue),dt=new T(Pe,et)):$ instanceof T&&ue instanceof T&&(at=$,dt=ue),!at||!dt)throw new Error("Invalid arguments");at.isBefore(dt)?(this._start=at,this._end=dt):(this._start=dt,this._end=at)}static isRange($){return $ instanceof u?!0:$?T.isPosition($.start)&&T.isPosition($.end):!1}get start(){return this._start}get end(){return this._end}contains($){return $ instanceof u?this.contains($._start)&&this.contains($._end):$ instanceof T?!($.isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const ue=T.Max($.start,this._start),Pe=T.Min($.end,this._end);if(!ue.isAfter(Pe))return new u(ue,Pe)}union($){if(this.contains($))return this;if($.contains(this))return $;const ue=T.Min($.start,this._start),Pe=T.Max($.end,this.end);return new u(ue,Pe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,ue=this.end){if($===null||ue===null)throw(0,t.illegalArgument)();let Pe;return $?T.isPosition($)?Pe=$:(Pe=$.start||this.start,ue=$.end||this.end):Pe=this.start,Pe.isEqual(this._start)&&ue.isEqual(this.end)?this:new u(Pe,ue)}toJSON(){return[this.start,this.end]}};O=u=je([A],O),e.Range=O;let U=s=class extends O{constructor($,ue,Pe,et){let at,dt;if(typeof $=="number"&&typeof ue=="number"&&typeof Pe=="number"&&typeof et=="number"?(at=new T($,ue),dt=new T(Pe,et)):$ instanceof T&&ue instanceof T&&(at=$,dt=ue),!at||!dt)throw new Error("Invalid arguments");super(at,dt);this._anchor=at,this._active=dt}static isSelection($){return $ instanceof s?!0:$?O.isRange($)&&T.isPosition($.anchor)&&T.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};U=s=je([A],U),e.Selection=U;class V{constructor($,ue,Pe){if(typeof $!="string"||$.length===0)throw(0,t.illegalArgument)("host");if(typeof ue!="number"||ue===0||Math.round(ue)!==ue)throw(0,t.illegalArgument)("port");if(typeof Pe!="undefined"&&(typeof Pe!="string"||Pe.length===0||!/^[0-9A-Za-z\-]+$/.test(Pe)))throw(0,t.illegalArgument)("connectionToken");this.host=$,this.port=Math.round(ue),this.connectionToken=Pe}}e.ResolvedAuthority=V;class x extends Error{constructor($,ue=l.RemoteAuthorityResolverErrorCode.Unknown,Pe){super($);this._message=$,this._code=ue,this._detail=Pe,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,x.prototype)}static NotAvailable($,ue){return new x($,l.RemoteAuthorityResolverErrorCode.NotAvailable,ue)}static TemporarilyNotAvailable($){return new x($,l.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=x;var N;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(N=e.EndOfLine||(e.EndOfLine={}));var B;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(B=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let W=h=class{constructor($,ue){this._range=$,this._newText=ue}static isTextEdit($){return $ instanceof h?!0:$?O.isRange($)&&typeof $.newText=="string":!1}static replace($,ue){return new h($,ue)}static insert($,ue){return h.replace(new O($,$),ue)}static delete($){return h.replace($,"")}static setEndOfLine($){const ue=new h(new O(new T(0,0),new T(0,0)),"");return ue.newEol=$,ue}get range(){return this._range}set range($){if($&&!O.isRange($))throw(0,t.illegalArgument)("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw(0,t.illegalArgument)("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw(0,t.illegalArgument)("newEol");this._newEol=$}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};W=h=je([A],W),e.TextEdit=W;var H;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace"})(H=e.FileEditType||(e.FileEditType={}));let z=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,ue,Pe,et){this._edits.push({_type:1,from:$,to:ue,options:Pe,metadata:et})}createFile($,ue,Pe){this._edits.push({_type:1,from:void 0,to:$,options:ue,metadata:Pe})}deleteFile($,ue,Pe){this._edits.push({_type:1,from:$,to:void 0,options:ue,metadata:Pe})}replaceNotebookMetadata($,ue,Pe){this._edits.push({_type:3,metadata:Pe,uri:$,edit:{editType:5,metadata:ue},notebookMetadata:ue})}replaceNotebookCells($,ue,Pe,et,at){let dt,mt,At=[],Lt;if(Ht.isNotebookRange(ue)&&Bt.isNotebookCellDataArray(Pe)&&!Bt.isNotebookCellDataArray(et)?(dt=ue.start,mt=ue.end,At=Pe,Lt=et):typeof ue=="number"&&typeof Pe=="number"&&Bt.isNotebookCellDataArray(et)&&(dt=ue,mt=Pe,At=et,Lt=at),dt===void 0||mt===void 0)throw new Error("Invalid arguments");(dt!==mt||At.length>0)&&this._edits.push({_type:5,uri:$,index:dt,count:mt-dt,cells:At,metadata:Lt})}replaceNotebookCellMetadata($,ue,Pe,et){this._edits.push({_type:3,metadata:et,uri:$,edit:{editType:8,index:ue,metadata:Pe}})}replace($,ue,Pe,et){this._edits.push({_type:2,uri:$,edit:new W(ue,Pe),metadata:et})}insert($,ue,Pe,et){this.replace($,new O(ue,ue),Pe,et)}delete($,ue,Pe){this.replace($,ue,"",Pe)}has($){return this._edits.some(ue=>ue._type===2&&ue.uri.toString()===$.toString())}set($,ue){if(ue)for(const Pe of ue)Pe&&this._edits.push({_type:2,uri:$,edit:Pe});else{for(let Pe=0;Pe<this._edits.length;Pe++){const et=this._edits[Pe];et._type===2&&et.uri.toString()===$.toString()&&(this._edits[Pe]=void 0)}(0,f.coalesceInPlace)(this._edits)}}get($){const ue=[];for(let Pe of this._edits)Pe._type===2&&Pe.uri.toString()===$.toString()&&ue.push(Pe.edit);return ue}entries(){const $=new _.ResourceMap;for(let ue of this._edits)if(ue._type===2){let Pe=$.get(ue.uri);Pe||(Pe=[ue.uri,[]],$.set(ue.uri,Pe)),Pe[1].push(ue.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};z=je([A],z),e.WorkspaceEdit=z;let J=n=class{constructor($){this._tabstop=1,this.value=$||""}static isSnippetString($){return $ instanceof n?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}appendText($){return this.value+=n._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,ue=this._tabstop++){if(typeof $=="function"){const Pe=new n;Pe._tabstop=this._tabstop,$(Pe),this._tabstop=Pe._tabstop,$=Pe.value}else $=n._escape($);return this.value+="${",this.value+=ue,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,ue=this._tabstop++){const Pe=$.map(et=>et.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ue,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable($,ue){if(typeof ue=="function"){const Pe=new n;Pe._tabstop=this._tabstop,ue(Pe),this._tabstop=Pe._tabstop,ue=Pe.value}else typeof ue=="string"&&(ue=ue.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,ue&&(this.value+=":",this.value+=ue),this.value+="}",this}};J=n=je([A],J),e.SnippetString=J;var ie;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(ie=e.DiagnosticTag||(e.DiagnosticTag={}));var se;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(se=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let K=S=class{constructor($,ue){if(this.uri=$,ue)if(ue instanceof O)this.range=ue;else if(ue instanceof T)this.range=new O(ue,ue);else throw new Error("Illegal argument")}static isLocation($){return $ instanceof S?!0:$?O.isRange($.range)&&P.URI.isUri($.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};K=S=je([A],K),e.Location=K;let X=class{constructor($,ue){this.location=$,this.message=ue}static is($){return $?typeof $.message=="string"&&$.location&&O.isRange($.location.range)&&P.URI.isUri($.location.uri):!1}static isEqual($,ue){return $===ue?!0:!$||!ue?!1:$.message===ue.message&&$.location.range.isEqual(ue.location.range)&&$.location.uri.toString()===ue.location.uri.toString()}};X=je([A],X),e.DiagnosticRelatedInformation=X;let ae=class{constructor($,ue,Pe=se.Error){if(!O.isRange($))throw new TypeError("range must be set");if(!ue)throw new TypeError("message must be set");this.range=$,this.message=ue,this.severity=Pe}toJSON(){return{severity:se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,ue){return $===ue?!0:!$||!ue?!1:$.message===ue.message&&$.severity===ue.severity&&$.code===ue.code&&$.severity===ue.severity&&$.source===ue.source&&$.range.isEqual(ue.range)&&(0,f.equals)($.tags,ue.tags)&&(0,f.equals)($.relatedInformation,ue.relatedInformation,X.isEqual)}};ae=je([A],ae),e.Diagnostic=ae;let fe=class{constructor($,ue){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:this.contents=[$],this.range=ue}};fe=je([A],fe),e.Hover=fe;var be;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(be=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Me=class{constructor($,ue=be.Text){this.range=$,this.kind=ue}toJSON(){return{range:this.range,kind:be[this.kind]}}};Me=je([A],Me),e.DocumentHighlight=Me;var xe;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(xe=e.SymbolKind||(e.SymbolKind={}));var Ge;(function(j){j[j.Deprecated=1]="Deprecated"})(Ge=e.SymbolTag||(e.SymbolTag={}));let Je=a=class{constructor($,ue,Pe,et,at){this.name=$,this.kind=ue,this.containerName=at,typeof Pe=="string"&&(this.containerName=Pe),et instanceof K?this.location=et:Pe instanceof O&&(this.location=new K(et,Pe)),a.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:xe[this.kind],location:this.location,containerName:this.containerName}}};Je=a=je([A],Je),e.SymbolInformation=Je;let q=i=class{constructor($,ue,Pe,et,at){this.name=$,this.detail=ue,this.kind=Pe,this.range=et,this.selectionRange=at,this.children=[],i.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children&&$.children.forEach(i.validate)}};q=i=je([A],q),e.DocumentSymbol=q;var te;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let G=class{constructor($,ue){this.title=$,this.kind=ue}};G=je([A],G),e.CodeAction=G;let Q=r=class{constructor($){this.value=$}append($){return new r(this.value?this.value+r.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+r.sep)}};Q.sep=".",Q=r=je([A],Q),e.CodeActionKind=Q,Q.Empty=new Q(""),Q.QuickFix=Q.Empty.append("quickfix"),Q.Refactor=Q.Empty.append("refactor"),Q.RefactorExtract=Q.Refactor.append("extract"),Q.RefactorInline=Q.Refactor.append("inline"),Q.RefactorRewrite=Q.Refactor.append("rewrite"),Q.Source=Q.Empty.append("source"),Q.SourceOrganizeImports=Q.Source.append("organizeImports"),Q.SourceFixAll=Q.Source.append("fixAll");let oe=class{constructor($,ue){if(this.range=$,this.parent=ue,ue&&!ue.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};oe=je([A],oe),e.SelectionRange=oe;class me{constructor($,ue,Pe,et,at,dt){this.kind=$,this.name=ue,this.detail=Pe,this.uri=et,this.range=at,this.selectionRange=dt}}e.CallHierarchyItem=me;class Ie{constructor($,ue){this.fromRanges=ue,this.from=$}}e.CallHierarchyIncomingCall=Ie;class We{constructor($,ue){this.fromRanges=ue,this.to=$}}e.CallHierarchyOutgoingCall=We;var Ye;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Ye=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let it=class{constructor($,ue){this.range=$,this.command=ue}get isResolved(){return!!this.command}};it=je([A],it),e.CodeLens=it;let st=c=class{constructor($,ue=!1){p.set(this,void 0),nt(this,p,new I.MarkdownString($,{supportThemeIcons:ue}),"f")}static isMarkdownString($){return $ instanceof c?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}get value(){return Le(this,p,"f").value}set value($){Le(this,p,"f").value=$}get isTrusted(){return Le(this,p,"f").isTrusted}set isTrusted($){Le(this,p,"f").isTrusted=$}get supportThemeIcons(){return Le(this,p,"f").supportThemeIcons}set supportThemeIcons($){Le(this,p,"f").supportThemeIcons=$}get supportHtml(){return Le(this,p,"f").supportHtml}set supportHtml($){Le(this,p,"f").supportHtml=$}appendText($){return Le(this,p,"f").appendText($),this}appendMarkdown($){return Le(this,p,"f").appendMarkdown($),this}appendCodeblock($,ue){return Le(this,p,"f").appendCodeblock(ue??"",$),this}};p=new WeakMap,st=c=je([A],st),e.MarkdownString=st;let ot=class{constructor($,ue){this.label=$,this.documentation=ue}};ot=je([A],ot),e.ParameterInformation=ot;let tt=class{constructor($,ue){this.label=$,this.documentation=ue,this.parameters=[]}};tt=je([A],tt),e.SignatureInformation=tt;let rt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};rt=je([A],rt),e.SignatureHelp=rt;var gt;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(gt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ue;(function(j){j[j.Other=0]="Other",j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(Ue=e.InlayHintKind||(e.InlayHintKind={}));let It=class{constructor($){this.label=$}};It=je([A],It),e.InlayHintLabelPart=It;let ee=class{constructor($,ue,Pe){this.label=$,this.position=ue,this.kind=Pe}};ee=je([A],ee),e.InlayHint=ee;var ne;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ne=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Se;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Se=e.CompletionItemKind||(e.CompletionItemKind={}));var re;(function(j){j[j.Deprecated=1]="Deprecated"})(re=e.CompletionItemTag||(e.CompletionItemTag={}));let ye=class{constructor($,ue){this.label=$,this.kind=ue}toJSON(){return{label:this.label,kind:this.kind&&Se[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ye=je([A],ye),e.CompletionItem=ye;let Fe=class{constructor($=[],ue=!1){this.items=$,this.isIncomplete=ue}};Fe=je([A],Fe),e.CompletionList=Fe;let qe=class{constructor($,ue,Pe){this.text=$,this.range=ue,this.command=Pe}};qe=je([A],qe),e.InlineSuggestion=qe;let Ve=class{constructor($){this.items=$}};Ve=je([A],Ve),e.InlineSuggestions=Ve;var ut;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(ut=e.ViewColumn||(e.ViewColumn={}));var Re;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Re=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ae;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Ae=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var De;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(De=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ce;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(ce=e.TextEditorRevealType||(e.TextEditorRevealType={}));var de;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(de=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var we;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(we=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ce;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Ce=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function $(ue){switch(ue){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=$}(de=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Oe=class{constructor($,ue){if(ue&&!P.URI.isUri(ue))throw(0,t.illegalArgument)("target");if(!O.isRange($)||$.isEmpty)throw(0,t.illegalArgument)("range");this.range=$,this.target=ue}};Oe=je([A],Oe),e.DocumentLink=Oe;let Ke=class{constructor($,ue,Pe,et){this.red=$,this.green=ue,this.blue=Pe,this.alpha=et}};Ke=je([A],Ke),e.Color=Ke;let $e=class{constructor($,ue){if(ue&&!(ue instanceof Ke))throw(0,t.illegalArgument)("color");if(!O.isRange($)||$.isEmpty)throw(0,t.illegalArgument)("range");this.range=$,this.color=ue}};$e=je([A],$e),e.ColorInformation=$e;let Ze=class{constructor($){if(!$||typeof $!="string")throw(0,t.illegalArgument)("label");this.label=$}};Ze=je([A],Ze),e.ColorPresentation=Ze;var lt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(lt=e.ColorFormat||(e.ColorFormat={}));var ct;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(ct=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class He{constructor($,ue,Pe){if(this.startIndex=$,this.length=ue,this.tooltip=Pe,typeof $!="number"||$<0)throw(0,t.illegalArgument)("startIndex");if(typeof ue!="number"||ue<1)throw(0,t.illegalArgument)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=He;var Ee;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Ee=e.TerminalLocation||(e.TerminalLocation={}));class _e{constructor($){this.options=$,typeof $!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=_e;var he;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(he=e.TaskRevealKind||(e.TaskRevealKind={}));var Y;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Y=e.TaskPanelKind||(e.TaskPanelKind={}));let ke=o=class{constructor($,ue){if(this.label=ue,typeof $!="string"||typeof ue!="string")throw(0,t.illegalArgument)("name");this._id=$}static from($){switch($){case"clean":return o.Clean;case"build":return o.Build;case"rebuild":return o.Rebuild;case"test":return o.Test;default:return}}get id(){return this._id}};ke.Clean=new o("clean","Clean"),ke.Build=new o("build","Build"),ke.Rebuild=new o("rebuild","Rebuild"),ke.Test=new o("test","Test"),ke=o=je([A],ke),e.TaskGroup=ke;function Ne(j){let $="";for(let ue=0;ue<j.length;ue++)$+=j[ue].replace(/,/g,",,")+",";return $}let Xe=class{constructor($,ue,Pe){if(typeof $!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=$,ue!==void 0&&(Array.isArray(ue)?(this._args=ue,this._options=Pe):this._options=ue)}get process(){return this._process}set process($){if(typeof $!="string")throw(0,t.illegalArgument)("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(let ue of this._args)$.push(ue);return Ne($)}};Xe=je([A],Xe),e.ProcessExecution=Xe;let Qe=class{constructor($,ue,Pe){if(this._args=[],Array.isArray(ue)){if(!$)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw(0,t.illegalArgument)("command");this._command=$,this._args=ue,this._options=Pe}else{if(typeof $!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=$,this._options=ue}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw(0,t.illegalArgument)("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ue of this._args)$.push(typeof ue=="string"?ue:ue.value);return Ne($)}};Qe=je([A],Qe),e.ShellExecution=Qe;var pt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(pt=e.ShellQuoting||(e.ShellQuoting={}));var St;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(St=e.TaskScope||(e.TaskScope={}));class yt{constructor($){this._callback=$}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=yt;let ft=d=class{constructor($,ue,Pe,et,at,dt){this.__deprecated=!1,this._definition=this.definition=$;let mt;typeof ue=="string"?(this._name=this.name=ue,this._source=this.source=Pe,this.execution=et,mt=at,this.__deprecated=!0):ue===St.Global||ue===St.Workspace?(this.target=ue,this._name=this.name=Pe,this._source=this.source=et,this.execution=at,mt=dt):(this.target=ue,this._name=this.name=Pe,this._source=this.source=et,this.execution=at,mt=dt),typeof mt=="string"?(this._problemMatchers=[mt],this._hasDefinedMatchers=!0):Array.isArray(mt)?(this._problemMatchers=mt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Xe?this._definition={type:d.ProcessType,id:this._execution.computeId()}:this._execution instanceof Qe?this._definition={type:d.ShellType,id:this._execution.computeId()}:this._execution instanceof yt?this._definition={type:d.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:d.EmptyType,id:(0,L.generateUuid)()}}get definition(){return this._definition}set definition($){if($==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const ue=this._definition.type;(d.EmptyType===ue||d.ProcessType===ue||d.ShellType===ue||d.ExtensionCallbackType===ue)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};ft.ExtensionCallbackType="customExecution",ft.ProcessType="process",ft.ShellType="shell",ft.EmptyType="$empty",ft=d=je([A],ft),e.Task=ft;var wt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(wt=e.ProgressLocation||(e.ProgressLocation={}));let bt=class{constructor($,ue=Ut.None){this.collapsibleState=ue,P.URI.isUri($)?this.resourceUri=$:this.label=$}};bt=je([A],bt),e.TreeItem=bt;var Ut;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Ut=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Pt=class{constructor($){this._value=$}async asString(){return JSON.stringify(this._value)}};Pt=je([A],Pt),e.TreeDataTransferItem=Pt;let Ft=class{constructor(){this._items=new Map}get($){return this._items.get($)}set($,ue){this._items.set($,ue)}forEach($){this._items.forEach($)}};Ft=je([A],Ft),e.TreeDataTransfer=Ft;let kt=class{constructor($,ue){this.id=$,this.color=ue}};kt=je([A],kt),e.ThemeIcon=kt,kt.File=new kt("file"),kt.Folder=new kt("folder");let Ct=class{constructor($){this.id=$}};Ct=je([A],Ct),e.ThemeColor=Ct;var Qt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Qt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Vt=class{constructor($,ue){if(typeof $!="string"&&(!$||!P.URI.isUri($)&&!P.URI.isUri($.uri)))throw(0,t.illegalArgument)("base");if(typeof ue!="string")throw(0,t.illegalArgument)("pattern");typeof $=="string"?this.baseUri=P.URI.file($):P.URI.isUri($)?this.baseUri=$:this.baseUri=$.uri,this.pattern=ue}get base(){return this._base}set base($){this._base=$,this._baseUri=P.URI.file($)}get baseUri(){return this._baseUri}set baseUri($){this._baseUri=$,this._base=$.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Vt=je([A],Vt),e.RelativePattern=Vt;let Et=class{constructor($,ue,Pe,et){this.enabled=typeof $=="boolean"?$:!0,typeof ue=="string"&&(this.condition=ue),typeof Pe=="string"&&(this.hitCondition=Pe),typeof et=="string"&&(this.logMessage=et)}get id(){return this._id||(this._id=(0,L.generateUuid)()),this._id}};Et=je([A],Et),e.Breakpoint=Et;let Xt=class extends Et{constructor($,ue,Pe,et,at){super(ue,Pe,et,at);if($===null)throw(0,t.illegalArgument)("location");this.location=$}};Xt=je([A],Xt),e.SourceBreakpoint=Xt;let qt=class extends Et{constructor($,ue,Pe,et,at){super(ue,Pe,et,at);this.functionName=$}};qt=je([A],qt),e.FunctionBreakpoint=qt;let Yt=class extends Et{constructor($,ue,Pe,et,at,dt,mt){super(et,at,dt,mt);if(!ue)throw(0,t.illegalArgument)("dataId");this.label=$,this.dataId=ue,this.canPersist=Pe}};Yt=je([A],Yt),e.DataBreakpoint=Yt;let ai=class{constructor($,ue,Pe){this.command=$,this.args=ue||[],this.options=Pe}};ai=je([A],ai),e.DebugAdapterExecutable=ai;let Rt=class{constructor($,ue){this.port=$,this.host=ue}};Rt=je([A],Rt),e.DebugAdapterServer=Rt;let Jt=class{constructor($){this.path=$}};Jt=je([A],Jt),e.DebugAdapterNamedPipeServer=Jt;let li=class{constructor($){this.implementation=$}};li=je([A],li),e.DebugAdapterInlineImplementation=li;let jt=class{constructor($,ue){this.range=$,this.expression=ue}};jt=je([A],jt),e.EvaluatableExpression=jt;var Zt;(function(j){j[j.Automatic=0]="Automatic",j[j.Explicit=1]="Explicit"})(Zt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let vt=class{constructor($,ue){this.range=$,this.text=ue}};vt=je([A],vt),e.InlineValueText=vt;let ci=class{constructor($,ue,Pe=!0){this.range=$,this.variableName=ue,this.caseSensitiveLookup=Pe}};ci=je([A],ci),e.InlineValueVariableLookup=ci;let Ot=class{constructor($,ue){this.range=$,this.expression=ue}};Ot=je([A],Ot),e.InlineValueEvaluatableExpression=Ot;let $t=class{constructor($,ue){this.frameId=$,this.stoppedLocation=ue}};$t=je([A],$t),e.InlineValueContext=$t;var vi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(vi=e.FileChangeType||(e.FileChangeType={}));let ui=m=class extends Error{constructor($,ue=C.FileSystemProviderErrorCode.Unknown,Pe){super(P.URI.isUri($)?$.toString(!0):$);this.code=Pe?.name??"Unknown",(0,C.markAsFileSystemProviderError)(this,ue),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,m.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}static FileExists($){return new m($,C.FileSystemProviderErrorCode.FileExists,m.FileExists)}static FileNotFound($){return new m($,C.FileSystemProviderErrorCode.FileNotFound,m.FileNotFound)}static FileNotADirectory($){return new m($,C.FileSystemProviderErrorCode.FileNotADirectory,m.FileNotADirectory)}static FileIsADirectory($){return new m($,C.FileSystemProviderErrorCode.FileIsADirectory,m.FileIsADirectory)}static NoPermissions($){return new m($,C.FileSystemProviderErrorCode.NoPermissions,m.NoPermissions)}static Unavailable($){return new m($,C.FileSystemProviderErrorCode.Unavailable,m.Unavailable)}};ui=m=je([A],ui),e.FileSystemError=ui;let ei=class{constructor($,ue,Pe){this.start=$,this.end=ue,this.kind=Pe}};ei=je([A],ei),e.FoldingRange=ei;var Ci;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Ci=e.FoldingRangeKind||(e.FoldingRangeKind={}));var wi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var ti;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(ti=e.CommentMode||(e.CommentMode={}));class Di{constructor($,ue=[]){this.tokenTypes=$,this.tokenModifiers=ue}}e.SemanticTokensLegend=Di;function di(j){return typeof j=="undefined"||(0,y.isStringArray)(j)}class Gt{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let ue=0,Pe=$.tokenTypes.length;ue<Pe;ue++)this._tokenTypeStrToInt.set($.tokenTypes[ue],ue);for(let ue=0,Pe=$.tokenModifiers.length;ue<Pe;ue++)this._tokenModifierStrToInt.set($.tokenModifiers[ue],ue)}}push($,ue,Pe,et,at){if(typeof $=="number"&&typeof ue=="number"&&typeof Pe=="number"&&typeof et=="number"&&(typeof at=="number"||typeof at=="undefined"))return typeof at=="undefined"&&(at=0),this._pushEncoded($,ue,Pe,et,at);if(O.isRange($)&&typeof ue=="string"&&di(Pe))return this._push($,ue,Pe);throw(0,t.illegalArgument)()}_push($,ue,Pe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ue))throw new Error("`tokenType` is not in the provided legend");const et=$.start.line,at=$.start.character,dt=$.end.character-$.start.character,mt=this._tokenTypeStrToInt.get(ue);let At=0;if(Pe)for(const Lt of Pe){if(!this._tokenModifierStrToInt.has(Lt))throw new Error("`tokenModifier` is not in the provided legend");const Nt=this._tokenModifierStrToInt.get(Lt);At|=1<<Nt>>>0}this._pushEncoded(et,at,dt,mt,At)}_pushEncoded($,ue,Pe,et,at){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&ue<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const At=this._data.length/5|0;let Lt=0,Nt=0;for(let Wt=0;Wt<At;Wt++){let zt=this._data[5*Wt],gi=this._data[5*Wt+1];zt===0?(zt=Lt,gi+=Nt):zt+=Lt,this._data[5*Wt]=zt,this._data[5*Wt+1]=gi,Lt=zt,Nt=gi}}let dt=$,mt=ue;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(dt-=this._prevLine,dt===0&&(mt-=this._prevChar)),this._data[this._dataLen++]=dt,this._data[this._dataLen++]=mt,this._data[this._dataLen++]=Pe,this._data[this._dataLen++]=et,this._data[this._dataLen++]=at,this._prevLine=$,this._prevChar=ue}static _sortAndDeltaEncode($){let ue=[];const Pe=$.length/5|0;for(let mt=0;mt<Pe;mt++)ue[mt]=mt;ue.sort((mt,At)=>{const Lt=$[5*mt],Nt=$[5*At];if(Lt===Nt){const Wt=$[5*mt+1],zt=$[5*At+1];return Wt-zt}return Lt-Nt});const et=new Uint32Array($.length);let at=0,dt=0;for(let mt=0;mt<Pe;mt++){const At=5*ue[mt],Lt=$[At+0],Nt=$[At+1],Wt=$[At+2],zt=$[At+3],gi=$[At+4],xi=Lt-at,Ji=xi===0?Nt-dt:Nt,pi=5*mt;et[pi+0]=xi,et[pi+1]=Ji,et[pi+2]=Wt,et[pi+3]=zt,et[pi+4]=gi,at=Lt,dt=Nt}return et}build($){return this._dataIsSortedAndDeltaEncoded?new hi(new Uint32Array(this._data),$):new hi(Gt._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=Gt;class hi{constructor($,ue){this.resultId=ue,this.data=$}}e.SemanticTokens=hi;class ki{constructor($,ue,Pe){this.start=$,this.deleteCount=ue,this.data=Pe}}e.SemanticTokensEdit=ki;class Kt{constructor($,ue){this.resultId=ue,this.edits=$}}e.SemanticTokensEdits=Kt;var Ii;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Ii=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Pi;(function(j){j[j.Initial=1]="Initial",j[j.Dynamic=2]="Dynamic"})(Pi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ii=class{constructor(){}};ii.Back={iconPath:new kt("arrow-left")},ii=je([A],ii),e.QuickInputButtons=ii;var Ai;(function(j){j[j.Separator=-1]="Separator",j[j.Default=1]="Default"})(Ai=e.QuickPickItemKind||(e.QuickPickItemKind={}));var fi;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(fi=e.ExtensionKind||(e.ExtensionKind={}));class bi{constructor($,ue,Pe){this.badge=$,this.tooltip=ue,this.color=Pe}static validate($){if($.badge){let ue=(0,k.nextCharLength)($.badge,0);if(ue<$.badge.length&&(ue+=(0,k.nextCharLength)($.badge,ue)),$.badge.length>ue)throw new Error("The 'badge'-property must be undefined or a short character")}if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=bi;let ni=class{constructor($){this.kind=$}};ni=je([A],ni),e.ColorTheme=ni;var Be;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast"})(Be=e.ColorThemeKind||(e.ColorThemeKind={}));class Ht{constructor($,ue){if($<0)throw(0,t.illegalArgument)("start must be positive");if(ue<0)throw(0,t.illegalArgument)("end must be positive");$<=ue?(this._start=$,this._end=ue):(this._start=ue,this._end=$)}static isNotebookRange($){return $ instanceof Ht?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with($){let ue=this._start,Pe=this._end;return $.start!==void 0&&(ue=$.start),$.end!==void 0&&(Pe=$.end),ue===this._start&&Pe===this._end?this:new Ht(ue,Pe)}}e.NotebookRange=Ht;class Bt{constructor($,ue,Pe,et,at,dt,mt){this.kind=$,this.value=ue,this.languageId=Pe,this.mime=et,this.outputs=at??[],this.metadata=dt,this.executionSummary=mt,Bt.validate(this)}static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(ue=>Bt.isNotebookCellData(ue))}static isNotebookCellData($){return!0}}e.NotebookCellData=Bt;class _t{constructor($){this.cells=$}}e.NotebookData=_t;class Mt{constructor($,ue){this.data=$,this.mime=ue;const Pe=(0,R.normalizeMimeType)(ue,!0);if(!Pe)throw new Error(`INVALID mime type: ${ue}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}static isNotebookCellOutputItem($){return $ instanceof Mt?!0:$?typeof $.mime=="string"&&$.data instanceof Uint8Array:!1}static error($){const ue={name:$.name,message:$.message,stack:$.stack};return Mt.json(ue,"application/vnd.code.notebook.error")}static stdout($){return Mt.text($,"application/vnd.code.notebook.stdout")}static stderr($){return Mt.text($,"application/vnd.code.notebook.stderr")}static bytes($,ue="application/octet-stream"){return new Mt($,ue)}static text($,ue=R.Mimes.text){const Pe=Le(Mt,g,"f",E).encode(String($));return new Mt(Pe,ue)}static json($,ue="application/json"){const Pe=JSON.stringify($,void 0,"	");return Mt.text(Pe,ue)}}e.NotebookCellOutputItem=Mt,g=Mt,E={value:new TextEncoder};class ri{constructor($,ue,Pe){this.items=ri.ensureUniqueMimeTypes($,!0),typeof ue=="string"?(this.id=ue,this.metadata=Pe):(this.id=(0,L.generateUuid)(),this.metadata=ue??Pe)}static isNotebookCellOutput($){return $ instanceof ri?!0:!$||typeof $!="object"?!1:typeof $.id=="string"&&(0,y.isArray)($.items)}static ensureUniqueMimeTypes($,ue=!1){const Pe=new Set,et=new Set;for(let at=0;at<$.length;at++){const dt=$[at],mt=(0,R.normalizeMimeType)(dt.mime);if(!Pe.has(mt)){Pe.add(mt);continue}et.add(at),ue&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return et.size===0?$:$.filter((at,dt)=>!et.has(dt))}}e.NotebookCellOutput=ri;var Ei;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Ei=e.NotebookCellKind||(e.NotebookCellKind={}));var Si;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Si=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ti;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ti=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ri;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ri=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Li{constructor($,ue){this.text=$,this.alignment=ue}}e.NotebookCellStatusBarItem=Li;var Fi;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(Fi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class _i{constructor($,ue=[]){this.uri=$,this.provides=(0,f.asArray)(ue)}}e.NotebookRendererScript=_i;let mi=class{constructor($,ue){this.label=$,this.timestamp=ue}};mi=je([A],mi),e.TimelineItem=mi;var Mi;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(Mi=e.ExtensionMode||(e.ExtensionMode={}));var Oi;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(Oi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ni;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Ni=e.StandardTokenType||(e.StandardTokenType={}));class Ui{constructor($,ue){this.ranges=$,this.wordPattern=ue}}e.LinkedEditingRanges=Ui;class le{constructor($,ue){this._port=$,this._autoForwardAction=ue}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=le;var ge;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(ge=e.TestResultState||(e.TestResultState={}));var Te;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(Te=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ht=class{constructor($=void 0,ue=void 0,Pe=void 0){this.include=$,this.exclude=ue,this.profile=Pe}};ht=je([A],ht),e.TestRunRequest=ht;let Dt=v=class{constructor($){this.message=$}static diff($,ue,Pe){const et=new v($);return et.expectedOutput=ue,et.actualOutput=Pe,et}};Dt=v=je([A],Dt),e.TestMessage=Dt;let Tt=class{constructor($){this.id=$}};Tt=je([A],Tt),e.TestTag=Tt;let si=class{constructor($,ue){this.covered=$,this.total=ue}};si=je([A],si),e.CoveredCount=si;let Bi=w=class{constructor($,ue,Pe,et){this.uri=$,this.statementCoverage=ue,this.branchCoverage=Pe,this.functionCoverage=et}static fromDetails($,ue){const Pe=new si(0,0),et=new si(0,0),at=new si(0,0);for(const mt of ue)if("branches"in mt){Pe.total+=1,Pe.covered+=mt.executionCount>0?1:0;for(const At of mt.branches)et.total+=1,et.covered+=At.executionCount>0?1:0}else at.total+=1,at.covered+=mt.executionCount>0?1:0;const dt=new w($,Pe,et.total>0?et:void 0,at.total>0?at:void 0);return dt.detailedCoverage=ue,dt}};Bi=w=je([A],Bi),e.FileCoverage=Bi;let Wi=class{constructor($,ue,Pe=[]){this.executionCount=$,this.location=ue,this.branches=Pe}};Wi=je([A],Wi),e.StatementCoverage=Wi;let $i=class{constructor($,ue){this.executionCount=$,this.location=ue}};$i=je([A],$i),e.BranchCoverage=$i;let Hi=class{constructor($,ue){this.executionCount=$,this.location=ue}};Hi=je([A],Hi),e.FunctionCoverage=Hi;var Ki;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(Ki=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Qi;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Qi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Xi;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(Xi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Yi{constructor($,ue,Pe,et,at,dt){this.kind=$,this.name=ue,this.detail=Pe,this.uri=et,this.range=at,this.selectionRange=dt}}e.TypeHierarchyItem=Yi}),define(pe[124],ve([0,1,55,10,8,151,110,7,17]),function(Z,e,f,t,I,_,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function L(p,g){g?P.set(p,g):P.delete(p)}e.setWordDefinitionFor=L;function C(p){return P.get(p)}e.getWordDefinitionFor=C;class l extends _.MirrorTextModel{constructor(g,E,F,D,u,s,h,n){super(E,F,D,u);this._proxy=g,this._languageId=s,this._isDirty=h,this._notebook=n,this._isDisposed=!1}dispose(){(0,f.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(g){return(0,y.equals)(this._lines,g)}get document(){if(!this._document){const g=this;this._document={get uri(){return g._uri},get fileName(){return g._uri.fsPath},get isUntitled(){return g._uri.scheme===t.Schemas.untitled},get languageId(){return g._languageId},get version(){return g._versionId},get isClosed(){return g._isDisposed},get isDirty(){return g._isDirty},get notebook(){return g._notebook},save(){return g._save()},getText(E){return E?g._getTextInRange(E):g.getText()},get eol(){return g._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return g._lines.length},lineAt(E){return g._lineAt(E)},offsetAt(E){return g._offsetAt(E)},positionAt(E){return g._positionAt(E)},validateRange(E){return g._validateRange(E)},validatePosition(E){return g._validatePosition(E)},getWordRangeAtPosition(E,F){return g._getWordRangeAtPosition(E,F)}}}return Object.freeze(this._document)}_acceptLanguageId(g){(0,f.ok)(!this._isDisposed),this._languageId=g}_acceptIsDirty(g){(0,f.ok)(!this._isDisposed),this._isDirty=g}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(g){const E=this._validateRange(g);if(E.isEmpty)return"";if(E.isSingleLine)return this._lines[E.start.line].substring(E.start.character,E.end.character);const F=this._eol,D=E.start.line,u=E.end.line,s=[];s.push(this._lines[D].substring(E.start.character));for(let h=D+1;h<u;h++)s.push(this._lines[h]);return s.push(this._lines[u].substring(0,E.end.character)),s.join(F)}_lineAt(g){let E;if(g instanceof k.Position?E=g.line:typeof g=="number"&&(E=g),typeof E!="number"||E<0||E>=this._lines.length||Math.floor(E)!==E)throw new Error("Illegal value for `line`");return new b(E,this._lines[E],E===this._lines.length-1)}_offsetAt(g){return g=this._validatePosition(g),this._ensureLineStarts(),this._lineStarts.getPrefixSum(g.line-1)+g.character}_positionAt(g){g=Math.floor(g),g=Math.max(0,g),this._ensureLineStarts();const E=this._lineStarts.getIndexOf(g),F=this._lines[E.index].length;return new k.Position(E.index,Math.min(E.remainder,F))}_validateRange(g){if(!(g instanceof k.Range))throw new Error("Invalid argument");const E=this._validatePosition(g.start),F=this._validatePosition(g.end);return E===g.start&&F===g.end?g:new k.Range(E.line,E.character,F.line,F.character)}_validatePosition(g){if(!(g instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return g.with(0,0);let{line:E,character:F}=g,D=!1;if(E<0)E=0,F=0,D=!0;else if(E>=this._lines.length)E=this._lines.length-1,F=this._lines[E].length,D=!0;else{const u=this._lines[E].length;F<0?(F=0,D=!0):F>u&&(F=u,D=!0)}return D?new k.Position(E,F):g}_getWordRangeAtPosition(g,E){const F=this._validatePosition(g);if(!E)E=C(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(E))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${E.source}' because it matches the empty string.`);const D=(0,R.getWordAtText)(F.character+1,(0,R.ensureValidWordDefinition)(E),this._lines[F.line],0);if(D)return new k.Range(F.line,D.startColumn-1,F.line,D.endColumn-1)}}e.ExtHostDocumentData=l;class b{constructor(g,E,F){this._line=g,this._text=E,this._isLastLine=F}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=b}),define(pe[202],ve([0,1,7,3,112,6,82,24,2,33]),function(Z,e,f,t,I,_,R,k,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class L{constructor(l,b,p,g){this._notebook=p,this._selector=g,this._disposables=new _.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(b.onDidChangeDocument(F=>{const D=this._cellUris.get(F.document.uri);D!==void 0&&(this._cellLengths.setValue(D,this._cells[D].document.getText().length+1),this._cellLines.setValue(D,this._cells[D].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const E=F=>{F===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(F=>E(F.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const l=[],b=[];for(const p of this._notebook.getCells())p.kind===f.NotebookCellKind.Code&&(!this._selector||(0,R.score)(this._selector,p.document.uri,p.document.languageId,!0))&&(this._cellUris.set(p.document.uri,this._cells.length),this._cells.push(p),l.push(p.document.getText().length+1),b.push(p.document.lineCount));this._cellLengths=new I.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new I.PrefixSumComputer(new Uint32Array(b))}get version(){return this._versionId}getText(l){if(!l){let D="";for(const u of this._cells)D+=u.document.getText()+`
`;return D=D.slice(0,-1),D}if(l.isEmpty)return"";const b=this.locationAt(l.start),p=this.locationAt(l.end),g=this._cellUris.get(b.uri),E=this._cellUris.get(p.uri);if(g===void 0||E===void 0)return"";if(g===E)return this._cells[g].document.getText(new f.Range(b.range.start,p.range.end));const F=[this._cells[g].document.getText(new f.Range(b.range.start,new f.Position(this._cells[g].document.lineCount,0)))];for(let D=g+1;D<E;D++)F.push(this._cells[D].document.getText());return F.push(this._cells[E].document.getText(new f.Range(new f.Position(0,0),p.range.end))),F.join(`
`)}offsetAt(l){const b=this._cellLines.getIndexOf(l.line),p=this._cellLengths.getPrefixSum(b.index-1),g=this._cells[b.index].document.offsetAt(l.with(b.remainder));return p+g}positionAt(l){if(typeof l=="number"){const p=this._cellLengths.getIndexOf(l),g=this._cellLines.getPrefixSum(p.index-1);return this._cells[p.index].document.positionAt(p.remainder).translate(g)}const b=this._cellUris.get(l.uri);if(b!==void 0){const p=this._cellLines.getPrefixSum(b-1);return new f.Position(p+l.range.start.line,l.range.start.character)}return new f.Position(0,0)}locationAt(l){f.Range.isRange(l)||(l=new f.Range(l,l));const b=this._cellLines.getIndexOf(l.start.line);let p=b;l.isEmpty||(p=this._cellLines.getIndexOf(l.end.line));const g=new f.Position(b.remainder,l.start.character),E=new f.Position(p.remainder,l.end.character),F=new f.Range(g,E),D=this._cells[b.index];return new f.Location(D.document.uri,D.document.validateRange(F))}contains(l){return this._cellUris.has(l)}validateRange(l){const b=this.validatePosition(l.start),p=this.validatePosition(l.end);return l.with(b,p)}validatePosition(l){const b=this._cellLines.getIndexOf(l.line),p=new f.Position(b.remainder,l.character),g=this._cells[b.index].document.validatePosition(p),E=this._cellLines.getPrefixSum(b.index-1);return new f.Position(E+g.line,g.character)}}e.ExtHostNotebookConcatDocument=L}),define(pe[203],ve([0,1,7,14,3]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let _=class{constructor(k){this._actual=new f.ColorTheme(f.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let y=k==="light"?f.ColorThemeKind.Light:k==="dark"?f.ColorThemeKind.Dark:f.ColorThemeKind.HighContrast;this._actual=new f.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};_=je([ze(0,t.IExtHostRpcService)],_),e.ExtHostTheming=_}),define(pe[65],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,f.createDecorator)("IURITransformerService");class t{constructor(_){_?(this.transformIncoming=_.transformIncoming.bind(_),this.transformOutgoing=_.transformOutgoing.bind(_),this.transformOutgoingURI=_.transformOutgoingURI.bind(_),this.transformOutgoingScheme=_.transformOutgoingScheme.bind(_)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=t}),define(pe[204],ve([0,1,22]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(y){let P=this.buffers.indexOf(y);return P<0&&(P=this.buffers.length,this.buffers.push(y)),P}}function I(k,y){if(y.serializeBuffersForPostMessage){const P=new t,L=(b,p)=>{if(p instanceof ArrayBuffer){const g=P.add(p);return{$$vscode_array_buffer_reference$$:!0,index:g}}else if(ArrayBuffer.isView(p)){const g=_(p);if(g){const E=P.add(p.buffer);return{$$vscode_array_buffer_reference$$:!0,index:E,view:{type:g,byteLength:p.byteLength,byteOffset:p.byteOffset}}}}return p},C=JSON.stringify(k,L),l=P.buffers.map(b=>{const p=new Uint8Array(b);return f.VSBuffer.wrap(p)});return{message:C,buffers:l}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=I;function _(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(k,y){const P=y.map(l=>{const b=new ArrayBuffer(l.byteLength);return new Uint8Array(b).set(l.buffer),b}),L=y.length?(l,b)=>{if(typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const p=b,{index:g}=p,E=P[g];if(p.view)switch(p.view.type){case 1:return new Int8Array(E,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(E,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(E,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(E,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(E,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(E,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(E,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(E,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(E,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(E,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(E,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return E}return b}:void 0;return{message:JSON.parse(k,L),arrayBuffers:P}}e.deserializeWebviewMessage=R}),define(pe[205],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var f;(function(t){function I(R){const k=new Map;return R.types.forEach((y,P)=>{k.set(y,{asString:async()=>R.items[P].asString})}),k}t.toITreeDataTransfer=I;async function _(R){const k={types:[],items:[]},y=Array.from(R.entries());for(const P of y)k.types.push(P[0]),k.items.push({asString:await P[1].asString()});return k}t.toTreeDataTransferDTO=_})(f=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(pe[87],ve([0,1,10,2]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function I(k,y){return k.scheme===f.Schemas.http||k.scheme===f.Schemas.https?k:(y&&y.authority&&y.isRemote&&k.scheme===f.Schemas.file&&(k=t.URI.from({scheme:f.Schemas.vscodeRemote,authority:y.authority,path:k.path})),t.URI.from({scheme:f.Schemas.https,authority:`${k.scheme}+${_(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=I;function _(k){return k.replace(/./g,y=>{const P=y.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?y:"-"+P.toString(16).padStart(4,"0")})}function R(k){return k.replace(/-([0-9a-f]{4})/g,(y,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=R}),define(pe[206],ve([0,1,3,6,87]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class _{constructor(k,y,P){this._proxy=k,this._editors=y,this._initData=P,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const L=y.getVisibleTextEditors();for(const C of this._insets.values())L.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,y,P,L,C){let l;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===k){l=u;break}if(!l)throw new Error("not a visible editor");const b=this,p=this._handlePool++,g=new f.Emitter,E=new f.Emitter,F=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,I.asWebviewUri)(u,b._initData.remote)}get cspSource(){return I.webviewGenericCspSource}set options(u){this._options=u,b._proxy.$setOptions(p,u)}get options(){return this._options}set html(u){this._html=u,b._proxy.$setHtml(p,u)}get html(){return this._html}get onDidReceiveMessage(){return g.event}postMessage(u){return b._proxy.$postMessage(p,u)}},D=new class{constructor(){this.editor=k,this.line=y,this.height=P,this.webview=F,this.onDidDispose=E.event}dispose(){b._insets.has(p)&&(b._insets.delete(p),b._proxy.$disposeEditorInset(p),E.fire(),E.dispose(),g.dispose())}};return this._proxy.$createEditorInset(p,l.id,l.value.document.uri,y+1,P,L||{},C.identifier,C.extensionLocation),this._insets.set(p,{editor:k,inset:D,onDidReceiveMessage:g}),D}$onDidDispose(k){const y=this._insets.get(k);y&&y.inset.dispose()}$onDidReceiveMessage(k,y){const P=this._insets.get(k);P&&P.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=_}),define(pe[207],ve([0,1,173,18,2,6,4,62,50,42,17,10]),function(Z,e,f,t,I,_,R,k,y,P,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorTabsVisibleContext=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,f.localize)(0,null),providerDisplayName:(0,f.localize)(1,null)},e.ActiveEditorDirtyContext=new k.RawContextKey("activeEditorIsDirty",!1,(0,f.localize)(2,null)),e.ActiveEditorPinnedContext=new k.RawContextKey("activeEditorIsNotPreview",!1,(0,f.localize)(3,null)),e.ActiveEditorStickyContext=new k.RawContextKey("activeEditorIsPinned",!1,(0,f.localize)(4,null)),e.ActiveEditorReadonlyContext=new k.RawContextKey("activeEditorIsReadonly",!1,(0,f.localize)(5,null)),e.ActiveEditorCanRevertContext=new k.RawContextKey("activeEditorCanRevert",!1,(0,f.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new k.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new k.RawContextKey("activeEditor",null,{type:"string",description:(0,f.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new k.RawContextKey("activeEditorAvailableEditorIds","",(0,f.localize)(8,null)),e.TextCompareEditorVisibleContext=new k.RawContextKey("textCompareEditorVisible",!1,(0,f.localize)(9,null)),e.TextCompareEditorActiveContext=new k.RawContextKey("textCompareEditorActive",!1,(0,f.localize)(10,null)),e.SideBySideEditorActiveContext=new k.RawContextKey("sideBySideEditorActive",!1,(0,f.localize)(11,null)),e.EditorGroupEditorsCountContext=new k.RawContextKey("groupEditorsCount",0,(0,f.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new k.RawContextKey("activeEditorGroupEmpty",!1,(0,f.localize)(13,null)),e.ActiveEditorGroupIndexContext=new k.RawContextKey("activeEditorGroupIndex",0,(0,f.localize)(14,null)),e.ActiveEditorGroupLastContext=new k.RawContextKey("activeEditorGroupLast",!1,(0,f.localize)(15,null)),e.ActiveEditorGroupLockedContext=new k.RawContextKey("activeEditorGroupLocked",!1,(0,f.localize)(16,null)),e.MultipleEditorGroupsContext=new k.RawContextKey("multipleEditorGroups",!1,(0,f.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new k.RawContextKey("editorIsOpen",!1,(0,f.localize)(18,null)),e.InEditorZenModeContext=new k.RawContextKey("inZenMode",!1,(0,f.localize)(19,null)),e.IsCenteredLayoutContext=new k.RawContextKey("isCenteredLayout",!1,(0,f.localize)(20,null)),e.SplitEditorsVertically=new k.RawContextKey("splitEditorsVertically",!1,(0,f.localize)(21,null)),e.EditorAreaVisibleContext=new k.RawContextKey("editorAreaVisible",!0,(0,f.localize)(22,null)),e.EditorTabsVisibleContext=new k.RawContextKey("editorTabsVisible",!0,(0,f.localize)(23,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function l(O,U,V){for(const x of V.visibleEditorPanes)if(x.group.id===U&&O.matches(x.input))return x.getViewState()}e.findViewStateForEditor=l;function b(O){if(h(O))return!1;const U=O;return I.URI.isUri(U?.resource)}e.isResourceEditorInput=b;function p(O){if(h(O))return!1;const U=O;return U?.original!==void 0&&U.modified!==void 0}e.isResourceDiffEditorInput=p;function g(O){if(h(O)||p(O))return!1;const U=O;return U?.primary!==void 0&&U.secondary!==void 0}e.isResourceSideBySideEditorInput=g;function E(O){if(h(O))return!1;const U=O;return U?U.resource===void 0||U.resource.scheme===C.Schemas.untitled||U.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=E;var F;(function(O){O[O.SHORT=0]="SHORT",O[O.MEDIUM=1]="MEDIUM",O[O.LONG=2]="LONG"})(F=e.Verbosity||(e.Verbosity={}));var D;(function(O){O[O.EXPLICIT=1]="EXPLICIT",O[O.AUTO=2]="AUTO",O[O.FOCUS_CHANGE=3]="FOCUS_CHANGE",O[O.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(D=e.SaveReason||(e.SaveReason={}));var u;(function(O){O[O.None=0]="None",O[O.Readonly=2]="Readonly",O[O.Untitled=4]="Untitled",O[O.Singleton=8]="Singleton",O[O.RequiresTrust=16]="RequiresTrust",O[O.CanSplitInGroup=32]="CanSplitInGroup",O[O.ForceDescription=64]="ForceDescription"})(u=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class s extends _.Disposable{}e.AbstractEditorInput=s;function h(O){return O instanceof s}e.isEditorInput=h;function n(O){const U=O;return I.URI.isUri(U?.preferredResource)}function S(O){const U=O;return h(U?.primary)&&h(U?.secondary)}e.isSideBySideEditorInput=S;function a(O){const U=O;return h(U?.modified)&&h(U?.original)}e.isDiffEditorInput=a;function i(O){return h(O?.editor)}e.isEditorInputWithOptions=i;function r(O){const U=O;return i(O)&&U?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function c(O){const U=O;return typeof U?.groupId=="number"&&h(U.editor)}e.isEditorIdentifier=c;var o;(function(O){O[O.UNKNOWN=0]="UNKNOWN",O[O.REPLACE=1]="REPLACE",O[O.MOVE=2]="MOVE",O[O.UNPIN=3]="UNPIN"})(o=e.EditorCloseContext||(e.EditorCloseContext={}));var d;(function(O){O[O.GROUP_ACTIVE=0]="GROUP_ACTIVE",O[O.GROUP_INDEX=1]="GROUP_INDEX",O[O.GROUP_LOCKED=2]="GROUP_LOCKED",O[O.EDITOR_OPEN=3]="EDITOR_OPEN",O[O.EDITOR_CLOSE=4]="EDITOR_CLOSE",O[O.EDITOR_MOVE=5]="EDITOR_MOVE",O[O.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",O[O.EDITOR_LABEL=7]="EDITOR_LABEL",O[O.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",O[O.EDITOR_PIN=9]="EDITOR_PIN",O[O.EDITOR_STICKY=10]="EDITOR_STICKY",O[O.EDITOR_DIRTY=11]="EDITOR_DIRTY",O[O.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(d=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var m;(function(O){O[O.PRIMARY=1]="PRIMARY",O[O.SECONDARY=2]="SECONDARY",O[O.BOTH=3]="BOTH",O[O.ANY=4]="ANY"})(m=e.SideBySideEditor||(e.SideBySideEditor={}));class v{getOriginalUri(U,V){if(!U)return;if(V?.supportSideBySide){const{primary:N,secondary:B}=this.getSideEditors(U);if(N&&B){if(V?.supportSideBySide===m.BOTH)return{primary:this.getOriginalUri(N,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(B,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===m.ANY)return this.getOriginalUri(N,{filterByScheme:V.filterByScheme})??this.getOriginalUri(B,{filterByScheme:V.filterByScheme});U=V.supportSideBySide===m.PRIMARY?N:B}}if(p(U)||g(U))return;const x=n(U)?U.preferredResource:U.resource;return!x||!V||!V.filterByScheme?x:this.filterUri(x,V.filterByScheme)}getSideEditors(U){return S(U)||g(U)?{primary:U.primary,secondary:U.secondary}:a(U)||p(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,V){if(!U)return;if(V?.supportSideBySide){const{primary:N,secondary:B}=this.getSideEditors(U);if(N&&B){if(V?.supportSideBySide===m.BOTH)return{primary:this.getCanonicalUri(N,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(B,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===m.ANY)return this.getCanonicalUri(N,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(B,{filterByScheme:V.filterByScheme});U=V.supportSideBySide===m.PRIMARY?N:B}}if(p(U)||g(U))return;const x=U.resource;return!x||!V||!V.filterByScheme?x:this.filterUri(x,V.filterByScheme)}filterUri(U,V){if(Array.isArray(V)){if(V.some(x=>U.scheme===x))return U}else if(V===U.scheme)return U}}e.EditorResourceAccessor=new v;var w;(function(O){O[O.LEFT=0]="LEFT",O[O.RIGHT=1]="RIGHT"})(w=e.CloseDirection||(e.CloseDirection={}));class A{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(U){const V=this.instantiationService=U.get(R.IInstantiationService);for(const[x,N]of this.editorSerializerConstructors)this.createEditorSerializer(x,N,V);this.editorSerializerConstructors.clear()}createEditorSerializer(U,V,x){const N=x.createInstance(V);this.editorSerializerInstances.set(U,N)}registerFileEditorFactory(U){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=U}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(U,V){if(this.editorSerializerConstructors.has(U)||this.editorSerializerInstances.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.instantiationService?this.createEditorSerializer(U,V,this.instantiationService):this.editorSerializerConstructors.set(U,V),(0,_.toDisposable)(()=>{this.editorSerializerConstructors.delete(U),this.editorSerializerInstances.delete(U)})}getEditorSerializer(U){return this.editorSerializerInstances.get(typeof U=="string"?U:U.typeId)}}y.Registry.add(e.EditorExtensions.EditorFactory,new A);async function M(O,U){if(!O||!O.length)return[];const V=await Promise.all(O.map(async x=>{const N=I.URI.revive(x.fileUri);if(!N||!await U.canHandleResource(N))return;let W=x.exists,H=x.type;if(typeof W!="boolean"||typeof H!="number")try{H=(await U.resolve(N)).isDirectory?P.FileType.Directory:P.FileType.Unknown,W=!0}catch{W=!1}if(!W&&x.openOnlyIfExists||H===P.FileType.Directory)return;const z={selection:W?x.selection:void 0,pinned:!0,override:x.editorOverrideId};let J;return W?J={resource:N,options:z}:J={resource:N,options:z,forceUntitled:!0},J}));return(0,L.coalesce)(V)}e.pathsToEditors=M;var T;(function(O){O[O.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",O[O.SEQUENTIAL=1]="SEQUENTIAL"})(T=e.EditorsOrder||(e.EditorsOrder={}))}),define(pe[125],ve([0,1,3,13,174]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class _{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new f.Emitter,this._onExit=new f.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,y,P,L){const C={command:k};if(y&&Object.keys(y).length>0&&(C.arguments=y),this.internalSend("request",C),typeof L=="number"){const l=setTimeout(()=>{clearTimeout(l);const b=this.pendingRequests.get(C.seq);if(b){this.pendingRequests.delete(C.seq);const p={type:"response",seq:0,request_seq:C.seq,success:!1,command:k,message:(0,I.localize)(0,null,L,k)};b(p)}},L)}return P&&this.pendingRequests.set(C.seq,P),C.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,y){return k.type!=="event"||y.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,t.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":{const y=k,P=this.pendingRequests.get(y.request_seq);P&&(this.pendingRequests.delete(y.request_seq),P(y));break}}}}internalSend(k,y){y.type=k,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((y,P)=>k.set(P,y)),await(0,t.timeout)(500),k.forEach((y,P)=>{y({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=_}),define(pe[208],ve([0,1,8,2,9,25,10]),function(Z,e,f,t,I,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function y(a,i,r){return a.replace(k,function(c,o){return i&&o.length>0&&o[0]!=="_"?c:r&&r.hasOwnProperty(o)?r[o]:c})}e.formatPII=y;function P(a){const i={};for(const r of Object.keys(a))r.startsWith("!")||(i[r]=a[r]);return i}e.filterExceptionsFromTelemetry=P;function L(a){return a.configuration.request==="attach"&&!C(a)&&(!a.parentSession||L(a.parentSession))}e.isSessionAttach=L;function C(a){let i=a.configuration.type;if(!!i)return i==="vslsShare"&&(i=a.configuration.adapterProxy.configuration.type),(0,f.equalsIgnoreCase)(i,"extensionhost")||(0,f.equalsIgnoreCase)(i,"pwa-extensionhost")?a:a.parentSession?C(a.parentSession):void 0}e.getExtensionHostDebugSession=C;function l(a){return a.type&&(a.label||a.program||a.runtime)}e.isDebuggerMainContribution=l;function b(a,i,r){let c,o=0;const d=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let m=null;for(;m=d.exec(a);){const v=m.index+1,w=v+m[0].length;if(v<=i&&w>=r){c=m[0],o=v;break}}if(c){const v=/\w+/g;let w=null;for(;(w=v.exec(c))&&!(w.index+1+o+w[0].length>=r););w&&(c=c.substring(0,v.lastIndex))}return c?{start:o,end:o+c.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=b;const p=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function g(a){return!!(a&&a.match(p))}e.isUri=g;function E(a){if(typeof a.path=="string"&&!(typeof a.sourceReference=="number"&&a.sourceReference>0)){if(g(a.path))return t.URI.parse(a.path);if((0,I.isAbsolute)(a.path))return t.URI.file(a.path)}return a.path}function F(a){if(typeof a.path=="object"){const i=t.URI.revive(a.path);if(i)return i.scheme===R.Schemas.file?i.fsPath:i.toString()}return a.path}function D(a,i){const r=i?E:F,c=(0,_.deepClone)(a);return s(c,(o,d)=>{o&&d&&(d.path=r(d))}),c}e.convertToDAPaths=D;function u(a,i){const r=i?E:F,c=(0,_.deepClone)(a);return s(c,(o,d)=>{!o&&d&&(d.path=r(d))}),c}e.convertToVSCPaths=u;function s(a,i){switch(a.type){case"event":{const r=a;switch(r.event){case"output":i(!1,r.body.source);break;case"loadedSource":i(!1,r.body.source);break;case"breakpoint":i(!1,r.body.breakpoint.source);break;default:break}break}case"request":{const r=a;switch(r.command){case"setBreakpoints":i(!0,r.arguments.source);break;case"breakpointLocations":i(!0,r.arguments.source);break;case"source":i(!0,r.arguments.source);break;case"gotoTargets":i(!0,r.arguments.source);break;case"launchVSCode":r.arguments.args.forEach(c=>i(!1,c));break;default:break}break}case"response":{const r=a;if(r.success&&r.body)switch(r.command){case"stackTrace":r.body.stackFrames.forEach(c=>i(!1,c.source));break;case"loadedSources":r.body.sources.forEach(c=>i(!1,c));break;case"scopes":r.body.scopes.forEach(c=>i(!1,c.source));break;case"setFunctionBreakpoints":r.body.breakpoints.forEach(c=>i(!1,c.source));break;case"setBreakpoints":r.body.breakpoints.forEach(c=>i(!1,c.source));break;default:break}break}}}function h(a){return a.filter(i=>!i.presentation?.hidden).sort((i,r)=>i.presentation?r.presentation?i.presentation.group?r.presentation.group?i.presentation.group!==r.presentation.group?i.presentation.group.localeCompare(r.presentation.group):n(i.presentation.order,r.presentation.order):-1:r.presentation.group?1:n(i.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=h;function n(a,i){return typeof a!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:a-i}async function S(a,i){const r=a.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(r!=="none"&&(await i.saveAll(),r==="allEditorsInActiveGroup")){const c=i.activeEditorPane;c&&c.input.resource?.scheme===R.Schemas.untitled&&await i.save({editor:c.input,groupId:c.group.id})}await a.reloadConfiguration()}e.saveAllBeforeDebugStart=S}),define(pe[209],ve([0,1,30,37,175,126,9,8,25,12,194,125]),function(Z,e,f,t,I,_,R,k,y,P,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class l extends C.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(D,u){this.outputStream=u,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,D.on("data",s=>this.handleData(s))}sendMessage(D){if(this.outputStream){const u=JSON.stringify(D);this.outputStream.write(`Content-Length: ${Buffer.byteLength(u,"utf8")}${l.TWO_CRLF}${u}`,"utf8")}}handleData(D){for(this.rawData=Buffer.concat([this.rawData,D]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const u=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,u.length>0)try{this.acceptMessage(JSON.parse(u))}catch(s){this._onError.fire(new Error((s.message||s)+`
`+u))}continue}}else{const u=this.rawData.indexOf(l.TWO_CRLF);if(u!==-1){const h=this.rawData.toString("utf8",0,u).split(l.HEADER_LINESEPARATOR);for(const n of h){const S=n.split(l.HEADER_FIELDSEPARATOR);S[0]==="Content-Length"&&(this.contentLength=Number(S[1]))}this.rawData=this.rawData.slice(u+l.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=l,l.TWO_CRLF=`\r
\r
`,l.HEADER_LINESEPARATOR=/\r?\n/,l.HEADER_FIELDSEPARATOR=/: */;class b extends l{startSession(){return new Promise((D,u)=>{let s=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),D(),s=!0}),this.socket.on("close",()=>{s?this._onError.fire(new Error("connection closed")):u(new Error("connection closed"))}),this.socket.on("error",h=>{s?this._onError.fire(h):u(h)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=b;class p extends b{constructor(D){super();this.adapterServer=D}createConnection(D){return _.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",D)}}e.SocketDebugAdapter=p;class g extends b{constructor(D){super();this.adapterServer=D}createConnection(D){return _.createConnection(this.adapterServer.path,D)}}e.NamedPipeDebugAdapter=g;class E extends l{constructor(D,u,s){super();this.adapterExecutable=D,this.debugType=u,this.outputService=s}async startSession(){const D=this.adapterExecutable.command,u=this.adapterExecutable.args,s=this.adapterExecutable.options||{};try{if(D)if(R.isAbsolute(D)){if(!await f.Promises.exists(D))throw new Error(I.localize(0,null,D))}else D.indexOf("/")<0&&D.indexOf("\\")<0;else throw new Error(I.localize(1,null,this.debugType));let h=process.env;if(s.env&&Object.keys(s.env).length>0&&(h=y.mixin(y.deepClone(process.env),s.env)),D==="node")if(Array.isArray(u)&&u.length>0){const S=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,a={env:h,execArgv:S?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};s.cwd&&(a.cwd=s.cwd);const i=t.fork(u[0],u.slice(1),a);if(!i.pid)throw new Error(I.localize(2,null,u[0]));this.serverProcess=i}else throw new Error(I.localize(3,null));else{const S={env:h};s.cwd&&(S.cwd=s.cwd),this.serverProcess=t.spawn(D,u,S)}this.serverProcess.on("error",S=>{this._onError.fire(S)}),this.serverProcess.on("exit",(S,a)=>{this._onExit.fire(S)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",S=>{this._onError.fire(S)}),this.serverProcess.stdin.on("error",S=>{this._onError.fire(S)});const n=this.outputService;if(n){const S=a=>a.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",a=>{const i=n.getChannel(L.ExtensionsChannelId);i&&i.append(S(a))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(h){this._onError.fire(h)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),P.isWindows?new Promise((D,u)=>{const s=t.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(h,n,S){if(h)return u(h)});s.on("exit",D),s.on("error",u)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(D,u){if(!D)return;const s=Object.create(null);D.runtime&&(D.runtime.indexOf("./")===0?s.runtime=R.join(u,D.runtime):s.runtime=D.runtime),D.runtimeArgs&&(s.runtimeArgs=D.runtimeArgs),D.program&&(R.isAbsolute(D.program)?s.program=D.program:s.program=R.join(u,D.program)),D.args&&(s.args=D.args);const h=D;return h.win&&(s.win=E.extract(h.win,u)),h.winx86&&(s.winx86=E.extract(h.winx86,u)),h.windows&&(s.windows=E.extract(h.windows,u)),h.osx&&(s.osx=E.extract(h.osx,u)),h.linux&&(s.linux=E.extract(h.linux,u)),s}static platformAdapterExecutable(D,u){let s=Object.create(null);u=u.toLowerCase();for(const r of D)if(r.contributes){const c=r.contributes.debuggers;c&&c.length>0&&c.filter(o=>typeof o.type=="string"&&k.equalsIgnoreCase(o.type,u)).forEach(o=>{const d=E.extract(o,r.extensionLocation.fsPath);s=y.mixin(s,d,r.isBuiltin)})}let h;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?h=s.winx86||s.win||s.windows:P.isWindows?h=s.win||s.windows:P.isMacintosh?h=s.osx:P.isLinux&&(h=s.linux),h=h||s;const n=h.program||s.program,S=h.args||s.args,a=h.runtime||s.runtime,i=h.runtimeArgs||s.runtimeArgs;if(a)return{type:"executable",command:a,args:(i||[]).concat(typeof n=="string"?[n]:[]).concat(S||[])};if(n)return{type:"executable",command:n,args:S||[]}}}e.ExecutableDebugAdapter=E}),define(pe[210],ve([0,1,37,12,29,186]),function(Z,e,f,t,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function R(l,b){return new Promise((p,g)=>{let E="";const F=f.spawn(l,b);F.pid&&F.stdout.on("data",D=>{E+=D.toString()}),F.on("error",D=>{g(D)}),F.on("close",D=>{p(E)})})}let k;function y(l,b){if(!k)if(t.isWindows)k=new _.WindowsExternalTerminalService;else if(t.isMacintosh)k=new _.MacExternalTerminalService;else if(t.isLinux)k=new _.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const p=b.getConfiguration("terminal");return k.runInTerminal(l.title,l.cwd,l.args,l.env||{},p.external||{})}e.runInExternalTerminal=y;async function P(l){if(l)if(t.isWindows){const b=await new Promise((p,g)=>{Z(["windows-process-tree"],p,g)});return new Promise(p=>{b.getProcessTree(l,g=>{p(g.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(l)]).then(b=>{const p=b.trim();return!(p.length===0||p.indexOf(" tmux")>=0)},b=>!0);return Promise.resolve(!0)}e.hasChildProcesses=P;var L;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(L||(L={}));function C(l,b,p,g){l=l.trim().toLowerCase();let E;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?E=1:l.indexOf("cmd.exe")>=0?E=0:l.indexOf("bash")>=0?E=2:t.isWindows?E=0:E=2;let F,D=" ";switch(E){case 1:if(F=u=>(u=u.replace(/\'/g,"''"),u.length>0&&u.charAt(u.length-1)==="\\"?`'${u}\\'`:`'${u}'`),p){const u=(0,I.getDriveLetter)(p);u&&(D+=`${u}:; `),D+=`cd ${F(p)}; `}if(g)for(const u in g){const s=g[u];s===null?D+=`Remove-Item env:${u}; `:D+=`\${env:${u}}='${s}'; `}if(b.length>0){const u=F(b.shift());D+=u[0]==="'"?`& ${u} `:`${u} `;for(const s of b)D+=`${F(s)} `}break;case 0:if(F=u=>(u=u.replace(/\"/g,'""'),u.indexOf(" ")>=0||u.indexOf('"')>=0||u.length===0?`"${u}"`:u),p){const u=(0,I.getDriveLetter)(p);u&&(D+=`${u}: && `),D+=`cd ${F(p)} && `}if(g){D+='cmd /C "';for(const u in g){let s=g[u];s===null?D+=`set "${u}=" && `:(s=s.replace(/[\^\&\|\<\>]/g,h=>`^${h}`),D+=`set "${u}=${s}" && `)}}for(const u of b)D+=`${F(u)} `;g&&(D+='"');break;case 2:{F=s=>(s=s.replace(/(["'\\\$])/g,"\\$1"),s.indexOf(" ")>=0||s.indexOf(";")>=0||s.length===0?`"${s}"`:s);const u=s=>/[^\w@%\/+=,.:^-]/.test(s)?`'${s.replace(/'/g,"'\\''")}'`:s;if(p&&(D+=`cd ${F(p)} ; `),g){D+="/usr/bin/env";for(const s in g){const h=g[s];h===null?D+=` -u ${u(s)}`:D+=` ${u(`${s}=${h}`)}`}D+=" "}for(const s of b)D+=`${F(s)} `;break}}return D}e.prepareCommand=C}),define(pe[127],ve([0,1,32,78,95,10,9,12,62]),function(Z,e,f,t,I,_,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var P;(function(v){v[v.Markup=1]="Markup",v[v.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",I.Mimes.latex,I.Mimes.markdown,"image/png","image/jpeg",I.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[I.Mimes.latex,I.Mimes.markdown,"application/json",I.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var L;(function(v){v[v.Running=1]="Running",v[v.Idle=2]="Idle"})(L=e.NotebookRunState||(e.NotebookRunState={}));var C;(function(v){v[v.Pending=2]="Pending",v[v.Executing=3]="Executing"})(C=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var l;(function(v){v[v.WithHardKernelDependency=0]="WithHardKernelDependency",v[v.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",v[v.Pure=2]="Pure",v[v.Never=3]="Never"})(l=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var b;(function(v){v.Always="always",v.Never="never",v.Optional="optional"})(b=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var p;(function(v){v[v.ModelChange=1]="ModelChange",v[v.Move=2]="Move",v[v.ChangeLanguage=5]="ChangeLanguage",v[v.Initialize=6]="Initialize",v[v.ChangeCellMetadata=7]="ChangeCellMetadata",v[v.Output=8]="Output",v[v.OutputItem=9]="OutputItem",v[v.ChangeCellContent=10]="ChangeCellContent",v[v.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",v[v.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",v[v.ChangeCellMime=13]="ChangeCellMime",v[v.Unknown=100]="Unknown"})(p=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var g;(function(v){v[v.Handle=0]="Handle",v[v.Index=1]="Index"})(g=e.SelectionStateType||(e.SelectionStateType={}));var E;(function(v){v[v.Replace=1]="Replace",v[v.Output=2]="Output",v[v.Metadata=3]="Metadata",v[v.CellLanguage=4]="CellLanguage",v[v.DocumentMetadata=5]="DocumentMetadata",v[v.Move=6]="Move",v[v.OutputItems=7]="OutputItems",v[v.PartialMetadata=8]="PartialMetadata",v[v.PartialInternalMetadata=9]="PartialInternalMetadata"})(E=e.CellEditType||(e.CellEditType={}));var F;(function(v){v.scheme=_.Schemas.vscodeNotebookCell;const w=/^ch(\d{7,})/;function A(x,N){return x.with({scheme:v.scheme,fragment:`ch${N.toString().padStart(7,"0")}${x.scheme!==_.Schemas.file?x.scheme:""}`})}v.generate=A;function M(x){if(x.scheme!==v.scheme)return;const N=w.exec(x.fragment);return N?{handle:Number(N[1]),notebook:x.with({scheme:x.fragment.substring(N[0].length)||_.Schemas.file,fragment:null})}:void 0}v.parse=M;function T(x,N,B){return x.with({scheme:_.Schemas.vscodeNotebookCellOutput,fragment:`ch${N.toString().padStart(7,"0")},${B??""},${x.scheme!==_.Schemas.file?x.scheme:""}`})}v.generateCellOutputUri=T;function O(x){if(x.scheme!==_.Schemas.vscodeNotebookCellOutput)return;const N=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(x.fragment);if(!N)return;const B=Number(N[1]),W=N[2]&&N[2]!==""?N[2]:void 0,H=N[3];return{handle:B,outputId:W,notebook:x.with({scheme:H||_.Schemas.file,fragment:null})}}v.parseCellOutputUri=O;function U(x,N,B){return x.with({scheme:B,fragment:`ch${N.toString().padStart(7,"0")}${x.scheme!==_.Schemas.file?x.scheme:""}`})}v.generateCellUri=U;function V(x,N){if(x.scheme!==N)return;const B=w.exec(x.fragment);return B?{handle:Number(B[1]),notebook:x.with({scheme:x.fragment.substring(B[0].length)||_.Schemas.file,fragment:null})}:void 0}v.parseCellUri=V})(F=e.CellUri||(e.CellUri={}));const D=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[I.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[I.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function u(v){return D.get(v)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=u;function s(v){return D.get(v)?.supportedByCore??!1}e.mimeTypeSupportedByCore=s;function h(v){return D.get(v)?.mergeable??!1}e.mimeTypeIsMergeable=h;const n=v=>k.isWindows?v.replace(/\//g,"\\"):v;class S{constructor(w=[],A=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=A,this.order=[...new Set(w)].map(M=>({pattern:M,matches:f.parse(n(M))}))}sort(w){const A=new Map(t.Iterable.map(w,T=>[T,n(T)]));let M=[];for(const{matches:T}of this.order)for(const[O,U]of A)if(T(U)){M.push(O),A.delete(O);break}return A.size&&(M=M.concat([...A.keys()].sort((T,O)=>this.defaultOrder.indexOf(T)-this.defaultOrder.indexOf(O)))),M}prioritize(w,A){const M=this.findIndex(w);if(M===-1){this.order.unshift({pattern:w,matches:f.parse(n(w))});return}const T=new Set(A.map(U=>this.findIndex(U,M)));T.delete(-1);const O=Array.from(T).sort();this.order.splice(M+1,0,...O.map(U=>this.order[U]));for(let U=O.length-1;U>=0;U--)this.order.splice(O[U],1)}toArray(){return this.order.map(w=>w.pattern)}findIndex(w,A=this.order.length){const M=n(w);for(let T=0;T<A;T++)if(this.order[T].matches(M))return T;return-1}}e.MimeTypeDisplayOrder=S;function a(v,w,A,M=(T,O)=>T===O){const T=[];function O(x,N,B){if(N===0&&B.length===0)return;const W=T[T.length-1];W&&W.start+W.deleteCount===x?(W.deleteCount+=N,W.toInsert.push(...B)):T.push({start:x,deleteCount:N,toInsert:B})}let U=0,V=0;for(;;){if(U===v.length){O(U,0,w.slice(V));break}if(V===w.length){O(U,v.length-U,[]);break}const x=v[U],N=w[V];if(M(x,N)){U+=1,V+=1;continue}A(N)?(O(U,1,[]),U+=1):(O(U,0,[N]),V+=1)}return T}e.diff=a,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(v){v.default="default",v.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(v){const w=v;return!!((typeof w.include=="string"||f.isRelativePattern(w.include))&&(typeof w.exclude=="string"||f.isRelativePattern(w.exclude)))}e.isDocumentExcludePattern=r;function c(v,w,A){if(Array.isArray(v.viewType)&&v.viewType.indexOf(w)>=0||v.viewType===w)return!0;if(v.filenamePattern){const M=r(v.filenamePattern)?v.filenamePattern.include:v.filenamePattern,T=r(v.filenamePattern)?v.filenamePattern.exclude:void 0;if(f.match(M,(0,R.basename)(A.fsPath).toLowerCase()))return!(T&&f.match(T,(0,R.basename)(A.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=c;class o{constructor(w){this.textModel=w}getElements(){const w=new Int32Array(this.textModel.cells.length);for(let A=0;A<this.textModel.cells.length;A++)w[A]=this.textModel.cells[A].getHashValue();return w}}e.CellSequence=o,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var d;(function(v){v[v.Left=1]="Left",v[v.Right=2]="Right"})(d=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class m{static create(w){return`${m._prefix}${w}`}static parse(w){if(w.startsWith(m._prefix))return w.substring(m._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=m,m._prefix="notebook/"}),define(pe[211],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,f.createDecorator)("INotebookExecutionService")}),define(pe[212],ve([0,1,4,62]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new t.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new t.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new t.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,f.createDecorator)(e.OUTPUT_SERVICE_ID);var I;(function(_){_[_.Append=1]="Append",_[_.Replace=2]="Replace",_[_.Clear=3]="Clear"})(I=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(pe[213],ve([0,1,177,4,62]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new I.RawContextKey("customExecutionSupported",!0,f.localize(0,null)),e.ShellExecutionSupportedContext=new I.RawContextKey("shellExecutionSupported",!1,f.localize(1,null)),e.ProcessExecutionSupportedContext=new I.RawContextKey("processExecutionSupported",!1,f.localize(2,null)),e.ITaskService=(0,t.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(pe[214],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function f(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=f;function t(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=t}),define(pe[128],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var f;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(f=e.TestResultState||(e.TestResultState={}));var t;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable"})(t=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var I;(function(C){C[C.Error=0]="Error",C[C.Info=1]="Info"})(I=e.TestMessageType||(e.TestMessageType={}));var _;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(_=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(C,l)=>{l.expand!==void 0&&(C.expand=l.expand),l.item!==void 0&&(C.item=C.item?Object.assign(C.item,l.item):l.item)};e.applyTestItemUpdate=R;var k;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(k=e.DetailType||(e.DetailType={}));var y;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.Remove=2]="Remove",C[C.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",C[C.Retire=4]="Retire",C[C.AddTag=5]="AddTag",C[C.RemoveTag=6]="RemoveTag"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(l){}update(l){}remove(l,b){}complete(){}}e.IncrementalChangeCollector=P;class L{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(l){const b=this.createChangeCollector();for(const p of l)switch(p[0]){case 0:{const g=p[1];if(g.parent){if(this.items.has(g.parent)){const E=this.items.get(g.parent);E.children.add(g.item.extId);const F=this.createItem(g,E);this.items.set(g.item.extId,F),b.add(F)}}else{const E=this.createItem(g);this.roots.add(E),this.items.set(g.item.extId,E),b.add(E)}g.expand===2&&this.busyControllerCount++;break}case 1:{const g=p[1],E=this.items.get(g.extId);if(!E)break;g.expand!==void 0&&(E.expand===2&&this.busyControllerCount--,g.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(E,g),b.update(E);break}case 2:{const g=this.items.get(p[1]);if(!g)break;g.parent?this.items.get(g.parent).children.delete(g.item.extId):this.roots.delete(g);const E=[[p[1]]];for(;E.length;)for(const F of E.pop()){const D=this.items.get(F);D&&(E.push(D.children),this.items.delete(F),b.remove(D,D!==g),D.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(p[1]);break;case 3:this.updatePendingRoots(p[1]);break;case 5:this._tags.set(p[1].id,p[1]);break;case 6:this._tags.delete(p[1]);break}b.complete()}retireTest(l){}updatePendingRoots(l){this.pendingRootCount+=l}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=L}),define(pe[88],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var f;(function(_){_.Delimiter="\0"})(f=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(_){_[_.IsSame=0]="IsSame",_[_.Disconnected=1]="Disconnected",_[_.IsChild=2]="IsChild",_[_.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class I{constructor(R,k=R.length){if(this.path=R,this.viewEnd=k,R.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(R,k,y=R.parent){if(R.id===k)return new I([k]);let P=[R.id];for(let L=y;L&&L.id!==k;L=L.parent)P.push(L.id);return P.push(k),new I(P.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const k=R.indexOf("\0");return k===-1?R:R.slice(0,k)}static fromString(R){return new I(R.split("\0"))}static join(R,k){return new I([...R.path,k])}static joinToString(R,k){return R.toString()+"\0"+k}static compare(R,k){return R===k?0:k.startsWith(R+"\0")?2:R.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new I(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let R=1;R<=this.viewEnd;R++)yield new I(this.path,R)}compare(R){if(typeof R=="string")return I.compare(this.toString(),R);for(let k=0;k<R.viewEnd&&k<this.viewEnd;k++)if(R.path[k]!==this.path[k])return 1;return R.viewEnd>this.viewEnd?2:R.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let R=1;R<this.viewEnd;R++)this.stringifed+="\0",this.stringifed+=this.path[R]}return this.stringifed}}e.TestId=I}),define(pe[215],ve([0,1,9,40,18,25,12,80,178]),function(Z,e,f,t,I,_,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(C,l,b){this._contributedVariables=new Map,this._context=C,this._labelService=l,b&&(this._envVariablesPromise=b.then(p=>this.prepareEnv(p)))}prepareEnv(C){if(R.isWindows){const l=Object.create(null);return Object.keys(C).forEach(b=>{l[b.toLowerCase()]=C[b]}),l}return C}resolveWithEnvironment(C,l,b){return this.recursiveResolve(this.prepareEnv(C),l?l.uri:void 0,b)}async resolveAsync(C,l){return this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,l)}async resolveAnyBase(C,l,b,p){const g=_.deepClone(l);return R.isWindows&&g.windows?Object.keys(g.windows).forEach(E=>g[E]=g.windows[E]):R.isMacintosh&&g.osx?Object.keys(g.osx).forEach(E=>g[E]=g.osx[E]):R.isLinux&&g.linux&&Object.keys(g.linux).forEach(E=>g[E]=g.linux[E]),delete g.windows,delete g.osx,delete g.linux,this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,g,b,p)}async resolveAnyAsync(C,l,b){return this.resolveAnyBase(C,l,b)}async resolveAnyMap(C,l,b){const p=new Map;return{newConfig:await this.resolveAnyBase(C,l,b,p),resolvedVariables:p}}resolveWithInteractionReplace(C,l,b,p){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,l,b,p){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,l){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,l)}recursiveResolve(C,l,b,p,g){if(I.isString(b))return this.resolveString(C,l,b,p,g);if(I.isArray(b))return b.map(E=>this.recursiveResolve(C,l,E,p,g));if(I.isObject(b)){let E=Object.create(null);return Object.keys(b).forEach(F=>{const D=this.resolveString(C,l,F,p,g);E[D]=this.recursiveResolve(C,l,b[F],p,g)}),E}return b}resolveString(C,l,b,p,g){return b.replace(P.VARIABLE_REGEXP,(F,D)=>{if(D.includes(P.VARIABLE_LHS))return F;let u=this.evaluateSingleVariable(C,F,D,l,p);return g&&g.set(D,u),u!==F&&I.isString(u)&&u.match(P.VARIABLE_REGEXP)&&(u=this.resolveString(C,l,u,p,g)),u})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,l,b,p,g){let E;const F=b.split(":");F.length>1&&(b=F[0],E=F[1]);const D=()=>{const h=this._context.getFilePath();if(h)return h;throw new Error((0,y.localize)(0,null,l))},u=()=>{const h=D();if(this._context.getWorkspaceFolderPathForFile){const n=this._context.getWorkspaceFolderPathForFile();if(n)return n}throw new Error((0,y.localize)(1,null,l,f.basename(h)))},s=()=>{if(E){const h=this._context.getFolderUri(E);if(h)return h;throw new Error((0,y.localize)(2,null,l,E))}if(p)return p;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,l)):new Error((0,y.localize)(4,null,l))};switch(b){case"env":if(E){if(C){const h=C[R.isWindows?E.toLowerCase():E];if(I.isString(h))return h}return""}throw new Error((0,y.localize)(5,null,l));case"config":if(E){const h=this._context.getConfigurationValue(p,E);if(I.isUndefinedOrNull(h))throw new Error((0,y.localize)(6,null,l,E));if(I.isObject(h))throw new Error((0,y.localize)(7,null,l,E));return h}throw new Error((0,y.localize)(8,null,l));case"command":return this.resolveFromMap(l,E,g,"command");case"input":return this.resolveFromMap(l,E,g,"input");default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(s()));case"cwd":return p||E?(0,k.normalizeDriveLetter)(this.fsPath(s())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return f.basename(this.fsPath(s()));case"lineNumber":{const h=this._context.getLineNumber();if(h)return h;throw new Error((0,y.localize)(9,null,l))}case"selectedText":{const h=this._context.getSelectedText();if(h)return h;throw new Error((0,y.localize)(10,null,l))}case"file":return D();case"fileWorkspaceFolder":return u();case"relativeFile":return p||E?f.relative(this.fsPath(s()),D()):D();case"relativeFileDirname":{const h=f.dirname(D());if(p||E){const n=f.relative(this.fsPath(s()),h);return n.length===0?".":n}return h}case"fileDirname":return f.dirname(D());case"fileExtname":return f.extname(D());case"fileBasename":return f.basename(D());case"fileBasenameNoExtension":{const h=f.basename(D());return h.slice(0,h.length-f.extname(h).length)}case"fileDirnameBasename":return f.basename(f.dirname(D()));case"execPath":{const h=this._context.getExecPath();return h||l}case"execInstallFolder":{const h=this._context.getAppRoot();return h||l}case"pathSeparator":return f.sep;default:try{const h=E?`${b}:${E}`:b;return this.resolveFromMap(l,h,g,void 0)}catch{return l}}}}resolveFromMap(C,l,b,p){if(l&&b){const g=p===void 0?b[l]:b[p+":"+l];if(typeof g=="string")return g;throw new Error((0,y.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(pe[129],ve([0,1,4,207]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,f.createDecorator)("editorGroupsService");var I;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var _;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(_=e.GroupOrientation||(e.GroupOrientation={}));var R;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(R=e.GroupLocation||(e.GroupLocation={}));var k;(function(p){p[p.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function P(p){const g=p;return(0,t.isEditorInput)(g?.editor)&&(0,t.isEditorInput)(g?.replacement)}e.isEditorReplacement=P;var L;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var C;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(C=e.OpenEditorContext||(e.OpenEditorContext={}));function l(p){const g=p;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.isEditorGroup=l;function b(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=b}),define(pe[216],ve([0,1,4,129]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,f.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(_){const R=_;return typeof _=="number"||(0,t.isEditorGroup)(R)}e.isPreferredGroup=I}),define(pe[15],ve([0,1,17,22,99,292,59,25,18,2,41,83,179,117,64,127,88,216,7]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p,g,E,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var u;(function(Ee){function _e(Y){const{selectionStartLineNumber:ke,selectionStartColumn:Ne,positionLineNumber:Xe,positionColumn:Qe}=Y,pt=new D.Position(ke-1,Ne-1),St=new D.Position(Xe-1,Qe-1);return new D.Selection(pt,St)}Ee.to=_e;function he(Y){const{anchor:ke,active:Ne}=Y;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:Ne.line+1,positionColumn:Ne.character+1}}Ee.from=he})(u=e.Selection||(e.Selection={}));var s;(function(Ee){function _e(Y){if(!Y)return;const{start:ke,end:Ne}=Y;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:Ne.line+1,endColumn:Ne.character+1}}Ee.from=_e;function he(Y){if(!Y)return;const{startLineNumber:ke,startColumn:Ne,endLineNumber:Xe,endColumn:Qe}=Y;return new D.Range(ke-1,Ne-1,Xe-1,Qe-1)}Ee.to=he})(s=e.Range||(e.Range={}));var h;(function(Ee){function _e(he){switch(he){case 1:return D.StandardTokenType.Comment;case 0:return D.StandardTokenType.Other;case 3:return D.StandardTokenType.RegEx;case 2:return D.StandardTokenType.String}}Ee.to=_e})(h=e.TokenType||(e.TokenType={}));var n;(function(Ee){function _e(Y){return new D.Position(Y.lineNumber-1,Y.column-1)}Ee.to=_e;function he(Y){return{lineNumber:Y.line+1,column:Y.character+1}}Ee.from=he})(n=e.Position||(e.Position={}));var S;(function(Ee){function _e(ke,Ne){return(0,f.coalesce)((0,f.asArray)(ke).map(Xe=>he(Xe,Ne)))}Ee.from=_e;function he(ke,Ne){if(typeof ke=="string")return{$serialized:!0,language:ke};if(ke)return{$serialized:!0,language:ke.language,scheme:Y(ke.scheme,Ne),pattern:Se.from(ke.pattern)??void 0,exclusive:ke.exclusive}}function Y(ke,Ne){return Ne&&typeof ke=="string"?Ne.transformOutgoingScheme(ke):ke}})(S=e.DocumentSelector||(e.DocumentSelector={}));var a;(function(Ee){function _e(Y){switch(Y){case D.DiagnosticTag.Unnecessary:return 1;case D.DiagnosticTag.Deprecated:return 2}}Ee.from=_e;function he(Y){switch(Y){case 1:return D.DiagnosticTag.Unnecessary;case 2:return D.DiagnosticTag.Deprecated;default:return}}Ee.to=he})(a=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(Ee){function _e(Y){let ke;return Y.code&&((0,y.isString)(Y.code)||(0,y.isNumber)(Y.code)?ke=String(Y.code):ke={value:String(Y.code.value),target:Y.code.target}),{...s.from(Y.range),message:Y.message,source:Y.source,code:ke,severity:c.from(Y.severity),relatedInformation:Y.relatedInformation&&Y.relatedInformation.map(r.from),tags:Array.isArray(Y.tags)?(0,f.coalesce)(Y.tags.map(a.from)):void 0}}Ee.from=_e;function he(Y){const ke=new D.Diagnostic(s.to(Y),Y.message,c.to(Y.severity));return ke.source=Y.source,ke.code=(0,y.isString)(Y.code)?Y.code:Y.code?.value,ke.relatedInformation=Y.relatedInformation&&Y.relatedInformation.map(r.to),ke.tags=Y.tags&&(0,f.coalesce)(Y.tags.map(a.to)),ke}Ee.to=he})(i=e.Diagnostic||(e.Diagnostic={}));var r;(function(Ee){function _e(Y){return{...s.from(Y.location.range),message:Y.message,resource:Y.location.uri}}Ee.from=_e;function he(Y){return new D.DiagnosticRelatedInformation(new D.Location(Y.resource,s.to(Y)),Y.message)}Ee.to=he})(r=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var c;(function(Ee){function _e(Y){switch(Y){case D.DiagnosticSeverity.Error:return b.MarkerSeverity.Error;case D.DiagnosticSeverity.Warning:return b.MarkerSeverity.Warning;case D.DiagnosticSeverity.Information:return b.MarkerSeverity.Info;case D.DiagnosticSeverity.Hint:return b.MarkerSeverity.Hint}return b.MarkerSeverity.Error}Ee.from=_e;function he(Y){switch(Y){case b.MarkerSeverity.Info:return D.DiagnosticSeverity.Information;case b.MarkerSeverity.Warning:return D.DiagnosticSeverity.Warning;case b.MarkerSeverity.Error:return D.DiagnosticSeverity.Error;case b.MarkerSeverity.Hint:return D.DiagnosticSeverity.Hint;default:return D.DiagnosticSeverity.Error}}Ee.to=he})(c=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var o;(function(Ee){function _e(Y){return typeof Y=="number"&&Y>=D.ViewColumn.One?Y-1:Y===D.ViewColumn.Beside?F.SIDE_GROUP:F.ACTIVE_GROUP}Ee.from=_e;function he(Y){if(typeof Y=="number"&&Y>=0)return Y+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=he})(o=e.ViewColumn||(e.ViewColumn={}));function d(Ee){return typeof Ee.range!="undefined"}function m(Ee){return Ee.length===0?!0:!!d(Ee[0])}e.isDecorationOptionsArr=m;var v;(function(Ee){function _e(Qe){return Qe.map(Ee.from)}Ee.fromMany=_e;function he(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function Y(Qe){let pt;if(he(Qe)){const{language:wt,value:bt}=Qe;pt={value:"```"+wt+`
`+bt+"\n```\n"}}else D.MarkdownString.isMarkdownString(Qe)?pt={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml}:typeof Qe=="string"?pt={value:Qe}:pt={value:""};const St=Object.create(null);pt.uris=St;const yt=wt=>{try{let bt=P.URI.parse(wt,!0);bt=bt.with({query:ke(bt.query,St)}),St[wt]=bt}catch{}return""},ft=new _.Renderer;return ft.link=yt,ft.image=wt=>yt(I.parseHrefAndDimensions(wt).href),_(pt.value,{renderer:ft}),pt}Ee.from=Y;function ke(Qe,pt){if(!Qe)return Qe;let St;try{St=(0,R.parse)(Qe)}catch{}if(!St)return Qe;let yt=!1;return St=(0,k.cloneAndChange)(St,ft=>{if(P.URI.isUri(ft)){const wt=`__uri_${Math.random().toString(16).slice(2,8)}`;return pt[wt]=ft,yt=!0,wt}else return}),yt?JSON.stringify(St):Qe}function Ne(Qe){const pt=new D.MarkdownString(Qe.value,Qe.supportThemeIcons);return pt.isTrusted=Qe.isTrusted,pt.supportHtml=Qe.supportHtml,pt}Ee.to=Ne;function Xe(Qe){if(!!Qe)return typeof Qe=="string"?Qe:Ee.from(Qe)}Ee.fromStrict=Xe})(v=e.MarkdownString||(e.MarkdownString={}));function w(Ee){return m(Ee)?Ee.map(_e=>({range:s.from(_e.range),hoverMessage:Array.isArray(_e.hoverMessage)?v.fromMany(_e.hoverMessage):_e.hoverMessage?v.from(_e.hoverMessage):void 0,renderOptions:_e.renderOptions})):Ee.map(_e=>({range:s.from(_e)}))}e.fromRangeOrRangeWithMessage=w;function A(Ee){return typeof Ee=="undefined"?Ee:typeof Ee=="string"?P.URI.file(Ee):Ee}e.pathOrURIToURI=A;var M;(function(Ee){function _e(he){return typeof he=="undefined"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?A(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}Ee.from=_e})(M=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var T;(function(Ee){function _e(he){return typeof he=="undefined"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?A(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?M.from(he.before):void 0,after:he.after?M.from(he.after):void 0}}Ee.from=_e})(T=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var O;(function(Ee){function _e(he){if(typeof he=="undefined")return he;switch(he){case D.DecorationRangeBehavior.OpenOpen:return 0;case D.DecorationRangeBehavior.ClosedClosed:return 1;case D.DecorationRangeBehavior.OpenClosed:return 2;case D.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=_e})(O=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var U;(function(Ee){function _e(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?O.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?T.from(he.light):void 0,dark:he.dark?T.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?A(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?M.from(he.before):void 0,after:he.after?M.from(he.after):void 0}}Ee.from=_e})(U=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var V;(function(Ee){function _e(Y){return{text:Y.newText,eol:Y.newEol&&gt.from(Y.newEol),range:s.from(Y.range)}}Ee.from=_e;function he(Y){const ke=new D.TextEdit(s.to(Y.range),Y.text);return ke.newEol=typeof Y.eol=="undefined"?void 0:gt.to(Y.eol),ke}Ee.to=he})(V=e.TextEdit||(e.TextEdit={}));var x;(function(Ee){function _e(Y,ke,Ne){const Xe={edits:[]};if(Y instanceof D.WorkspaceEdit)for(let Qe of Y._allEntries())if(Qe._type===1)Xe.edits.push({_type:1,oldUri:Qe.from,newUri:Qe.to,options:Qe.options,metadata:Qe.metadata});else if(Qe._type===2){const pt=ke?.getDocument(Qe.uri);Xe.edits.push({_type:2,resource:Qe.uri,edit:V.from(Qe.edit),modelVersionId:pt?.version,metadata:Qe.metadata})}else Qe._type===3?Xe.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Ne?.getNotebookDocument(Qe.uri,!0)?.apiNotebook.version}):Qe._type===5&&Xe.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Ne?.getNotebookDocument(Qe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(ut.from)}});return Xe}Ee.from=_e;function he(Y){const ke=new D.WorkspaceEdit;for(const Ne of Y.edits)Ne.edit?ke.replace(P.URI.revive(Ne.resource),s.to(Ne.edit.range),Ne.edit.text):ke.renameFile(P.URI.revive(Ne.oldUri),P.URI.revive(Ne.newUri),Ne.options);return ke}Ee.to=he})(x=e.WorkspaceEdit||(e.WorkspaceEdit={}));var N;(function(Ee){const _e=Object.create(null);_e[D.SymbolKind.File]=0,_e[D.SymbolKind.Module]=1,_e[D.SymbolKind.Namespace]=2,_e[D.SymbolKind.Package]=3,_e[D.SymbolKind.Class]=4,_e[D.SymbolKind.Method]=5,_e[D.SymbolKind.Property]=6,_e[D.SymbolKind.Field]=7,_e[D.SymbolKind.Constructor]=8,_e[D.SymbolKind.Enum]=9,_e[D.SymbolKind.Interface]=10,_e[D.SymbolKind.Function]=11,_e[D.SymbolKind.Variable]=12,_e[D.SymbolKind.Constant]=13,_e[D.SymbolKind.String]=14,_e[D.SymbolKind.Number]=15,_e[D.SymbolKind.Boolean]=16,_e[D.SymbolKind.Array]=17,_e[D.SymbolKind.Object]=18,_e[D.SymbolKind.Key]=19,_e[D.SymbolKind.Null]=20,_e[D.SymbolKind.EnumMember]=21,_e[D.SymbolKind.Struct]=22,_e[D.SymbolKind.Event]=23,_e[D.SymbolKind.Operator]=24,_e[D.SymbolKind.TypeParameter]=25;function he(ke){return typeof _e[ke]=="number"?_e[ke]:6}Ee.from=he;function Y(ke){for(const Ne in _e)if(_e[Ne]===ke)return Number(Ne);return D.SymbolKind.Property}Ee.to=Y})(N=e.SymbolKind||(e.SymbolKind={}));var B;(function(Ee){function _e(Y){switch(Y){case D.SymbolTag.Deprecated:return 1}}Ee.from=_e;function he(Y){switch(Y){case 1:return D.SymbolTag.Deprecated}}Ee.to=he})(B=e.SymbolTag||(e.SymbolTag={}));var W;(function(Ee){function _e(Y){return{name:Y.name,kind:N.from(Y.kind),tags:Y.tags&&Y.tags.map(B.from),containerName:Y.containerName,location:se.from(Y.location)}}Ee.from=_e;function he(Y){const ke=new D.SymbolInformation(Y.name,N.to(Y.kind),Y.containerName,se.to(Y.location));return ke.tags=Y.tags&&Y.tags.map(B.to),ke}Ee.to=he})(W=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var H;(function(Ee){function _e(Y){const ke={name:Y.name||"!!MISSING: name!!",detail:Y.detail,range:s.from(Y.range),selectionRange:s.from(Y.selectionRange),kind:N.from(Y.kind),tags:Y.tags?.map(B.from)??[]};return Y.children&&(ke.children=Y.children.map(_e)),ke}Ee.from=_e;function he(Y){const ke=new D.DocumentSymbol(Y.name,Y.detail,N.to(Y.kind),s.to(Y.range),s.to(Y.selectionRange));return(0,f.isNonEmptyArray)(Y.tags)&&(ke.tags=Y.tags.map(B.to)),Y.children&&(ke.children=Y.children.map(he)),ke}Ee.to=he})(H=e.DocumentSymbol||(e.DocumentSymbol={}));var z;(function(Ee){function _e(Y){const ke=new D.CallHierarchyItem(N.to(Y.kind),Y.name,Y.detail||"",P.URI.revive(Y.uri),s.to(Y.range),s.to(Y.selectionRange));return ke._sessionId=Y._sessionId,ke._itemId=Y._itemId,ke}Ee.to=_e;function he(Y,ke,Ne){if(ke=ke??Y._sessionId,Ne=Ne??Y._itemId,ke===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Ne,name:Y.name,detail:Y.detail,kind:N.from(Y.kind),uri:Y.uri,range:s.from(Y.range),selectionRange:s.from(Y.selectionRange),tags:Y.tags?.map(B.from)}}Ee.from=he})(z=e.CallHierarchyItem||(e.CallHierarchyItem={}));var J;(function(Ee){function _e(he){return new D.CallHierarchyIncomingCall(z.to(he.from),he.fromRanges.map(Y=>s.to(Y)))}Ee.to=_e})(J=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ie;(function(Ee){function _e(he){return new D.CallHierarchyOutgoingCall(z.to(he.to),he.fromRanges.map(Y=>s.to(Y)))}Ee.to=_e})(ie=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var se;(function(Ee){function _e(Y){return{range:Y.range&&s.from(Y.range),uri:Y.uri}}Ee.from=_e;function he(Y){return new D.Location(P.URI.revive(Y.uri),s.to(Y.range))}Ee.to=he})(se=e.location||(e.location={}));var K;(function(Ee){function _e(Y){const ke=Y,Ne=Y;return{originSelectionRange:ke.originSelectionRange?s.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:Ne.uri,range:s.from(ke.targetRange?ke.targetRange:Ne.range),targetSelectionRange:ke.targetSelectionRange?s.from(ke.targetSelectionRange):void 0}}Ee.from=_e;function he(Y){return{targetUri:P.URI.revive(Y.uri),targetRange:s.to(Y.range),targetSelectionRange:Y.targetSelectionRange?s.to(Y.targetSelectionRange):void 0,originSelectionRange:Y.originSelectionRange?s.to(Y.originSelectionRange):void 0}}Ee.to=he})(K=e.DefinitionLink||(e.DefinitionLink={}));var X;(function(Ee){function _e(Y){return{range:s.from(Y.range),contents:v.fromMany(Y.contents)}}Ee.from=_e;function he(Y){return new D.Hover(Y.contents.map(v.to),s.to(Y.range))}Ee.to=he})(X=e.Hover||(e.Hover={}));var ae;(function(Ee){function _e(Y){return{range:s.from(Y.range),expression:Y.expression}}Ee.from=_e;function he(Y){return new D.EvaluatableExpression(s.to(Y.range),Y.expression)}Ee.to=he})(ae=e.EvaluatableExpression||(e.EvaluatableExpression={}));var fe;(function(Ee){function _e(Y){if(Y instanceof D.InlineValueText)return{type:"text",range:s.from(Y.range),text:Y.text};if(Y instanceof D.InlineValueVariableLookup)return{type:"variable",range:s.from(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};if(Y instanceof D.InlineValueEvaluatableExpression)return{type:"expression",range:s.from(Y.range),expression:Y.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=_e;function he(Y){switch(Y.type){case"text":return{range:s.to(Y.range),text:Y.text};case"variable":return{range:s.to(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};case"expression":return{range:s.to(Y.range),expression:Y.expression}}}Ee.to=he})(fe=e.InlineValue||(e.InlineValue={}));var be;(function(Ee){function _e(Y){return{frameId:Y.frameId,stoppedLocation:s.from(Y.stoppedLocation)}}Ee.from=_e;function he(Y){return new D.InlineValueContext(Y.frameId,s.to(Y.stoppedLocation))}Ee.to=he})(be=e.InlineValueContext||(e.InlineValueContext={}));var Me;(function(Ee){function _e(Y){return{range:s.from(Y.range),kind:Y.kind}}Ee.from=_e;function he(Y){return new D.DocumentHighlight(s.to(Y.range),Y.kind)}Ee.to=he})(Me=e.DocumentHighlight||(e.DocumentHighlight={}));var xe;(function(Ee){function _e(he){switch(he){case 1:return D.CompletionTriggerKind.TriggerCharacter;case 2:return D.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return D.CompletionTriggerKind.Invoke}}Ee.to=_e})(xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ge;(function(Ee){function _e(he){return{triggerKind:xe.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}Ee.to=_e})(Ge=e.CompletionContext||(e.CompletionContext={}));var Je;(function(Ee){function _e(Y){switch(Y){case D.CompletionItemTag.Deprecated:return 1}}Ee.from=_e;function he(Y){switch(Y){case 1:return D.CompletionItemTag.Deprecated}}Ee.to=he})(Je=e.CompletionItemTag||(e.CompletionItemTag={}));var q;(function(Ee){const _e=new Map([[D.CompletionItemKind.Method,0],[D.CompletionItemKind.Function,1],[D.CompletionItemKind.Constructor,2],[D.CompletionItemKind.Field,3],[D.CompletionItemKind.Variable,4],[D.CompletionItemKind.Class,5],[D.CompletionItemKind.Interface,7],[D.CompletionItemKind.Struct,6],[D.CompletionItemKind.Module,8],[D.CompletionItemKind.Property,9],[D.CompletionItemKind.Unit,12],[D.CompletionItemKind.Value,13],[D.CompletionItemKind.Constant,14],[D.CompletionItemKind.Enum,15],[D.CompletionItemKind.EnumMember,16],[D.CompletionItemKind.Keyword,17],[D.CompletionItemKind.Snippet,27],[D.CompletionItemKind.Text,18],[D.CompletionItemKind.Color,19],[D.CompletionItemKind.File,20],[D.CompletionItemKind.Reference,21],[D.CompletionItemKind.Folder,23],[D.CompletionItemKind.Event,10],[D.CompletionItemKind.Operator,11],[D.CompletionItemKind.TypeParameter,24],[D.CompletionItemKind.Issue,26],[D.CompletionItemKind.User,25]]);function he(Ne){return _e.get(Ne)??9}Ee.from=he;const Y=new Map([[0,D.CompletionItemKind.Method],[1,D.CompletionItemKind.Function],[2,D.CompletionItemKind.Constructor],[3,D.CompletionItemKind.Field],[4,D.CompletionItemKind.Variable],[5,D.CompletionItemKind.Class],[7,D.CompletionItemKind.Interface],[6,D.CompletionItemKind.Struct],[8,D.CompletionItemKind.Module],[9,D.CompletionItemKind.Property],[12,D.CompletionItemKind.Unit],[13,D.CompletionItemKind.Value],[14,D.CompletionItemKind.Constant],[15,D.CompletionItemKind.Enum],[16,D.CompletionItemKind.EnumMember],[17,D.CompletionItemKind.Keyword],[27,D.CompletionItemKind.Snippet],[18,D.CompletionItemKind.Text],[19,D.CompletionItemKind.Color],[20,D.CompletionItemKind.File],[21,D.CompletionItemKind.Reference],[23,D.CompletionItemKind.Folder],[10,D.CompletionItemKind.Event],[11,D.CompletionItemKind.Operator],[24,D.CompletionItemKind.TypeParameter],[25,D.CompletionItemKind.User],[26,D.CompletionItemKind.Issue]]);function ke(Ne){return Y.get(Ne)??D.CompletionItemKind.Property}Ee.to=ke})(q=e.CompletionItemKind||(e.CompletionItemKind={}));var te;(function(Ee){function _e(he,Y){const ke=new D.CompletionItem(he.label);return ke.insertText=he.insertText,ke.kind=q.to(he.kind),ke.tags=he.tags?.map(Je.to),ke.detail=he.detail,ke.documentation=I.isMarkdownString(he.documentation)?v.to(he.documentation):he.documentation,ke.sortText=he.sortText,ke.filterText=he.filterText,ke.preselect=he.preselect,ke.commitCharacters=he.commitCharacters,L.Range.isIRange(he.range)?ke.range=s.to(he.range):typeof he.range=="object"&&(ke.range={inserting:s.to(he.range.insert),replacing:s.to(he.range.replace)}),ke.keepWhitespace=typeof he.insertTextRules=="undefined"?!1:Boolean(he.insertTextRules&1),typeof he.insertTextRules!="undefined"&&he.insertTextRules&4?ke.insertText=new D.SnippetString(he.insertText):(ke.insertText=he.insertText,ke.textEdit=ke.range instanceof D.Range?new D.TextEdit(ke.range,ke.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(ke.additionalTextEdits=he.additionalTextEdits.map(Ne=>V.to(Ne))),ke.command=Y&&he.command?Y.fromInternal(he.command):void 0,ke}Ee.to=_e})(te=e.CompletionItem||(e.CompletionItem={}));var G;(function(Ee){function _e(Y){return{label:Y.label,documentation:Y.documentation?v.fromStrict(Y.documentation):void 0}}Ee.from=_e;function he(Y){return{label:Y.label,documentation:I.isMarkdownString(Y.documentation)?v.to(Y.documentation):Y.documentation}}Ee.to=he})(G=e.ParameterInformation||(e.ParameterInformation={}));var Q;(function(Ee){function _e(Y){return{label:Y.label,documentation:Y.documentation?v.fromStrict(Y.documentation):void 0,parameters:Array.isArray(Y.parameters)?Y.parameters.map(G.from):[],activeParameter:Y.activeParameter}}Ee.from=_e;function he(Y){return{label:Y.label,documentation:I.isMarkdownString(Y.documentation)?v.to(Y.documentation):Y.documentation,parameters:Array.isArray(Y.parameters)?Y.parameters.map(G.to):[],activeParameter:Y.activeParameter}}Ee.to=he})(Q=e.SignatureInformation||(e.SignatureInformation={}));var oe;(function(Ee){function _e(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(Q.from):[]}}Ee.from=_e;function he(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(Q.to):[]}}Ee.to=he})(oe=e.SignatureHelp||(e.SignatureHelp={}));var me;(function(Ee){function _e(he,Y){const ke=new D.InlayHint(typeof Y.label=="string"?Y.label:Y.label.map(Ie.to.bind(void 0,he)),n.to(Y.position),We.to(Y.kind));return ke.tooltip=I.isMarkdownString(Y.tooltip)?v.to(Y.tooltip):Y.tooltip,ke.paddingLeft=Y.paddingLeft,ke.paddingRight=Y.paddingRight,ke}Ee.to=_e})(me=e.InlayHint||(e.InlayHint={}));var Ie;(function(Ee){function _e(he,Y){const ke=new D.InlayHintLabelPart(Y.label);return ke.tooltip=I.isMarkdownString(Y.tooltip)?v.to(Y.tooltip):Y.tooltip,C.Command.is(Y.command)?ke.command=he.fromInternal(Y.command):Y.location&&(ke.location=se.to(Y.location)),ke}Ee.to=_e})(Ie=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var We;(function(Ee){function _e(Y){return Y}Ee.from=_e;function he(Y){return Y}Ee.to=he})(We=e.InlayHintKind||(e.InlayHintKind={}));var Ye;(function(Ee){function _e(Y){return{range:s.from(Y.range),url:Y.target,tooltip:Y.tooltip}}Ee.from=_e;function he(Y){let ke;if(Y.url)try{ke=typeof Y.url=="string"?P.URI.parse(Y.url,!0):P.URI.revive(Y.url)}catch{}return new D.DocumentLink(s.to(Y.range),ke)}Ee.to=he})(Ye=e.DocumentLink||(e.DocumentLink={}));var it;(function(Ee){function _e(Y){const ke=new D.ColorPresentation(Y.label);return Y.textEdit&&(ke.textEdit=V.to(Y.textEdit)),Y.additionalTextEdits&&(ke.additionalTextEdits=Y.additionalTextEdits.map(Ne=>V.to(Ne))),ke}Ee.to=_e;function he(Y){return{label:Y.label,textEdit:Y.textEdit?V.from(Y.textEdit):void 0,additionalTextEdits:Y.additionalTextEdits?Y.additionalTextEdits.map(ke=>V.from(ke)):void 0}}Ee.from=he})(it=e.ColorPresentation||(e.ColorPresentation={}));var st;(function(Ee){function _e(Y){return new D.Color(Y[0],Y[1],Y[2],Y[3])}Ee.to=_e;function he(Y){return[Y.red,Y.green,Y.blue,Y.alpha]}Ee.from=he})(st=e.Color||(e.Color={}));var ot;(function(Ee){function _e(Y){return{range:s.from(Y.range)}}Ee.from=_e;function he(Y){return new D.SelectionRange(s.to(Y.range))}Ee.to=he})(ot=e.SelectionRange||(e.SelectionRange={}));var tt;(function(Ee){function _e(he){switch(he){case 2:return D.TextDocumentSaveReason.AfterDelay;case 1:return D.TextDocumentSaveReason.Manual;case 3:case 4:return D.TextDocumentSaveReason.FocusOut}}Ee.to=_e})(tt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var rt;(function(Ee){function _e(Y){switch(Y){case D.TextEditorLineNumbersStyle.Off:return 0;case D.TextEditorLineNumbersStyle.Relative:return 2;case D.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=_e;function he(Y){switch(Y){case 0:return D.TextEditorLineNumbersStyle.Off;case 2:return D.TextEditorLineNumbersStyle.Relative;case 1:default:return D.TextEditorLineNumbersStyle.On}}Ee.to=he})(rt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var gt;(function(Ee){function _e(Y){if(Y===D.EndOfLine.CRLF)return 1;if(Y===D.EndOfLine.LF)return 0}Ee.from=_e;function he(Y){if(Y===1)return D.EndOfLine.CRLF;if(Y===0)return D.EndOfLine.LF}Ee.to=he})(gt=e.EndOfLine||(e.EndOfLine={}));var Ue;(function(Ee){function _e(he){if(typeof he=="object")return he.viewId;switch(he){case D.ProgressLocation.SourceControl:return 3;case D.ProgressLocation.Window:return 10;case D.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=_e})(Ue=e.ProgressLocation||(e.ProgressLocation={}));var It;(function(Ee){function _e(he){const Y={start:he.start+1,end:he.end+1};return he.kind&&(Y.kind=ee.from(he.kind)),Y}Ee.from=_e})(It=e.FoldingRange||(e.FoldingRange={}));var ee;(function(Ee){function _e(he){if(he)switch(he){case D.FoldingRangeKind.Comment:return C.FoldingRangeKind.Comment;case D.FoldingRangeKind.Imports:return C.FoldingRangeKind.Imports;case D.FoldingRangeKind.Region:return C.FoldingRangeKind.Region}}Ee.from=_e})(ee=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ne;(function(Ee){function _e(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?s.from(he.selection):void 0,override:typeof he.override=="boolean"?l.EditorResolution.DISABLED:void 0}}Ee.from=_e})(ne=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Se;(function(Ee){function _e(Ne){return Ne instanceof D.RelativePattern?Ne.toJSON():typeof Ne=="string"?Ne:he(Ne)||Y(Ne)?new D.RelativePattern(Ne.baseUri??Ne.base,Ne.pattern).toJSON():Ne}Ee.from=_e;function he(Ne){const Xe=Ne;return Xe?P.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function Y(Ne){const Xe=Ne;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function ke(Ne){return typeof Ne=="string"?Ne:new D.RelativePattern(P.URI.revive(Ne.baseUri),Ne.pattern)}Ee.to=ke})(Se=e.GlobPattern||(e.GlobPattern={}));var re;(function(Ee){function _e(he){if(he){if(Array.isArray(he))return he.map(_e);if(typeof he=="string")return he;{const Y=he;return{language:Y.language,scheme:Y.scheme,pattern:Se.from(Y.pattern),exclusive:Y.exclusive}}}else return}Ee.from=_e})(re=e.LanguageSelector||(e.LanguageSelector={}));var ye;(function(Ee){function _e(Y){return{start:Y.start,end:Y.end}}Ee.from=_e;function he(Y){return new D.NotebookRange(Y.start,Y.end)}Ee.to=he})(ye=e.NotebookRange||(e.NotebookRange={}));var Fe;(function(Ee){function _e(Y){return{timing:typeof Y.runStartTime=="number"&&typeof Y.runEndTime=="number"?{startTime:Y.runStartTime,endTime:Y.runEndTime}:void 0,executionOrder:Y.executionOrder,success:Y.lastRunSuccess}}Ee.to=_e;function he(Y){return{lastRunSuccess:Y.success,runStartTime:Y.timing?.startTime,runEndTime:Y.timing?.endTime,executionOrder:Y.executionOrder}}Ee.from=he})(Fe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var qe;(function(Ee){function _e(Y){switch(Y){case D.NotebookCellKind.Markup:return g.CellKind.Markup;case D.NotebookCellKind.Code:default:return g.CellKind.Code}}Ee.from=_e;function he(Y){switch(Y){case g.CellKind.Markup:return D.NotebookCellKind.Markup;case g.CellKind.Code:default:return D.NotebookCellKind.Code}}Ee.to=he})(qe=e.NotebookCellKind||(e.NotebookCellKind={}));var Ve;(function(Ee){function _e(Y){const ke={metadata:Y.metadata??Object.create(null),cells:[]};for(let Ne of Y.cells)D.NotebookCellData.validate(Ne),ke.cells.push(ut.from(Ne));return ke}Ee.from=_e;function he(Y){const ke=new D.NotebookData(Y.cells.map(ut.to));return(0,y.isEmptyObject)(Y.metadata)||(ke.metadata=Y.metadata),ke}Ee.to=he})(Ve=e.NotebookData||(e.NotebookData={}));var ut;(function(Ee){function _e(Y){return{cellKind:qe.from(Y.kind),language:Y.languageId,mime:Y.mime,source:Y.value,metadata:Y.metadata,internalMetadata:Fe.from(Y.executionSummary??{}),outputs:Y.outputs?Y.outputs.map(Ae.from):[]}}Ee.from=_e;function he(Y){return new D.NotebookCellData(qe.to(Y.cellKind),Y.source,Y.language,Y.mime,Y.outputs?Y.outputs.map(Ae.to):void 0,Y.metadata,Y.internalMetadata?Fe.to(Y.internalMetadata):void 0)}Ee.to=he})(ut=e.NotebookCellData||(e.NotebookCellData={}));var Re;(function(Ee){function _e(Y){return{mime:Y.mime,valueBytes:t.VSBuffer.wrap(Y.data)}}Ee.from=_e;function he(Y){return new D.NotebookCellOutputItem(Y.valueBytes.buffer,Y.mime)}Ee.to=he})(Re=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ae;(function(Ee){function _e(Y){return{outputId:Y.id,items:Y.items.map(Re.from),metadata:Y.metadata}}Ee.from=_e;function he(Y){const ke=Y.items.map(Re.to);return new D.NotebookCellOutput(ke,Y.outputId,Y.metadata)}Ee.to=he})(Ae=e.NotebookCellOutput||(e.NotebookCellOutput={}));var De;(function(Ee){function _e(ke){return Y(ke)?{include:(0,y.withNullAsUndefined)(Se.from(ke.include)),exclude:(0,y.withNullAsUndefined)(Se.from(ke.exclude))}:(0,y.withNullAsUndefined)(Se.from(ke))}Ee.from=_e;function he(ke){return Y(ke)?{include:Se.to(ke.include),exclude:Se.to(ke.exclude)}:Se.to(ke)}Ee.to=he;function Y(ke){const Ne=ke;return Ne?!!Ne.include&&!!Ne.exclude:!1}})(De=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ce;(function(Ee){function _e(he){return{backgroundColor:he.backgroundColor,borderColor:he.borderColor,top:he.top?M.from(he.top):void 0}}Ee.from=_e})(ce=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var de;(function(Ee){function _e(he,Y,ke){const Ne=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===D.NotebookCellStatusBarAlignment.Left?1:2,command:Y.toInternal(Ne,ke),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}Ee.from=_e})(de=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var we;(function(Ee){function _e(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{}}}Ee.from=_e})(we=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ce;(function(Ee){function _e(Y){return{uri:Y.uri,provides:Y.provides}}Ee.from=_e;function he(Y){return new D.NotebookRendererScript(P.URI.revive(Y.uri),Y.provides)}Ee.to=he})(Ce=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Oe;(function(Ee){function _e(Y){return{message:v.fromStrict(Y.message)||"",type:0,expected:Y.expectedOutput,actual:Y.actualOutput,location:Y.location?se.from(Y.location):void 0}}Ee.from=_e;function he(Y){const ke=new D.TestMessage(typeof Y.message=="string"?Y.message:v.to(Y.message));return ke.actualOutput=Y.actual,ke.expectedOutput=Y.expected,ke.location=Y.location?se.to(Y.location):void 0,ke}Ee.to=he})(Oe=e.TestMessage||(e.TestMessage={}));var Ke;(function(Ee){let _e;(function(he){he.Delimiter="\0"})(_e||(_e={})),Ee.namespace=(he,Y)=>he+"\0"+Y,Ee.denamespace=he=>{const Y=he.indexOf("\0");return{ctrlId:he.slice(0,Y),tagId:he.slice(Y+1)}}})(Ke=e.TestTag||(e.TestTag={}));var $e;(function(Ee){function _e(Ne){const Xe=(0,p.getPrivateApiFor)(Ne).controllerId;return{extId:E.TestId.fromExtHostTestItem(Ne,Xe).toString(),label:Ne.label,uri:Ne.uri,tags:Ne.tags.map(Qe=>Ke.namespace(Xe,Qe.id)),range:s.from(Ne.range)||null,description:Ne.description||null,error:Ne.error&&v.fromStrict(Ne.error)||null}}Ee.from=_e;function he(Ne){return{parent:void 0,error:void 0,id:E.TestId.fromString(Ne.extId).localId,label:Ne.label,uri:P.URI.revive(Ne.uri),tags:(Ne.tags||[]).map(Xe=>{const{tagId:Qe}=Ke.denamespace(Xe);return new D.TestTag(Qe)}),range:s.to(Ne.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ne.description||void 0}}Ee.toPlain=he;function Y(Ne){const Xe=E.TestId.fromString(Ne.extId),Qe=new p.TestItemImpl(Xe.controllerId,Xe.localId,Ne.label,P.URI.revive(Ne.uri));return Qe.range=s.to(Ne.range||void 0),Qe.description=Ne.description||void 0,Qe}function ke(Ne){let Xe;for(const Qe of Ne.tests){const pt=Y(Qe.item);(0,p.getPrivateApiFor)(pt).parent=Xe,Xe=pt}return Xe}Ee.toItemFromContext=ke})($e=e.TestItem||(e.TestItem={})),function(Ee){function _e(Y){return{id:Y.id}}Ee.from=_e;function he(Y){return new D.TestTag(Y.id)}Ee.to=he}(Ke=e.TestTag||(e.TestTag={}));var Ze;(function(Ee){const _e=(Y,ke)=>{const Ne={...$e.toPlain(Y.item),parent:void 0,taskStates:Y.tasks.map(Xe=>({state:Xe.state,duration:Xe.duration,messages:Xe.messages.filter(Qe=>Qe.type===0).map(Oe.to)})),children:Y.children.map(Xe=>ke.get(Xe)).filter(y.isDefined).map(Xe=>_e(Xe,ke))};for(const Xe of Ne.children)Xe.parent=Ne;return Ne};function he(Y){const ke=[],Ne=new Map;for(const Xe of Y.items)Ne.set(Xe.item.extId,Xe),Y.request.targets.some(Qe=>Qe.controllerId===Xe.controllerId&&Qe.testIds.includes(Xe.item.extId))&&ke.push(Xe);return{completedAt:Y.completedAt,results:ke.map(Xe=>_e(Xe,Ne))}}Ee.to=he})(Ze=e.TestResults||(e.TestResults={}));var lt;(function(Ee){function _e(Ne){return{covered:Ne.covered,total:Ne.covered}}function he(Ne){return"line"in Ne?n.from(Ne):s.from(Ne)}function Y(Ne){return"branches"in Ne?{count:Ne.executionCount,location:he(Ne.location),type:1,branches:Ne.branches.length?Ne.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&he(Xe.location)})):void 0}:{type:0,count:Ne.executionCount,location:he(Ne.location)}}Ee.fromDetailed=Y;function ke(Ne){return{uri:Ne.uri,statement:_e(Ne.statementCoverage),branch:Ne.branchCoverage&&_e(Ne.branchCoverage),function:Ne.functionCoverage&&_e(Ne.functionCoverage),details:Ne.detailedCoverage?.map(Y)}}Ee.fromFile=ke})(lt=e.TestCoverage||(e.TestCoverage={}));var ct;(function(Ee){function _e(he){switch(he){case 1:return D.CodeActionTriggerKind.Invoke;case 2:return D.CodeActionTriggerKind.Automatic}}Ee.to=_e})(ct=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var He;(function(Ee){function _e(Y){const ke=new D.TypeHierarchyItem(N.to(Y.kind),Y.name,Y.detail||"",P.URI.revive(Y.uri),s.to(Y.range),s.to(Y.selectionRange));return ke._sessionId=Y._sessionId,ke._itemId=Y._itemId,ke}Ee.to=_e;function he(Y,ke,Ne){if(ke=ke??Y._sessionId,Ne=Ne??Y._itemId,ke===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Ne,kind:N.from(Y.kind),name:Y.name,detail:Y.detail??"",uri:Y.uri,range:s.from(Y.range),selectionRange:s.from(Y.selectionRange),tags:Y.tags?.map(B.from)}}Ee.from=he})(He=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(pe[217],ve([0,1,2,16,7,15,93]),function(Z,e,f,t,I,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(P,L,C,l={timeout:1500,errors:3}){this._logService=P,this._documents=L,this._mainThreadBulkEdits=C,this._thresholds=l,this._callbacks=new R.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(L,C,l)=>{const p={dispose:this._callbacks.push([L,C,P])};return Array.isArray(l)&&l.push(p),p}}async $participateInSave(P,L){const C=f.URI.revive(P);let l=!1;const b=setTimeout(()=>l=!0,this._thresholds.timeout),p=[];try{for(let g of[...this._callbacks]){if(l)break;const E=this._documents.getDocument(C),F=await this._deliverEventAsyncAndBlameBadListeners(g,{document:E,reason:_.TextDocumentSaveReason.to(L)});p.push(F)}}finally{clearTimeout(b)}return p}_deliverEventAsyncAndBlameBadListeners([P,L,C],l){const b=this._badListeners.get(P);return typeof b=="number"&&b>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,P,L,l).then(()=>!0,p=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const g=this._badListeners.get(P);this._badListeners.set(P,g?g+1:1),typeof g=="number"&&g>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,L,C,l){const b=[],p=Date.now(),{document:g,reason:E}=l,{version:F}=g,D=Object.freeze({document:g,reason:E,waitUntil(u){if(Object.isFrozen(b))throw(0,t.illegalState)("waitUntil can not be called async");b.push(Promise.resolve(u))}});try{L.apply(C,[D])}catch(u){return Promise.reject(u)}return Object.freeze(b),new Promise((u,s)=>{const h=setTimeout(()=>s(new Error("timeout")),this._thresholds.timeout);return Promise.all(b).then(n=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(h),u(n)}).catch(n=>{clearTimeout(h),s(n)})}).then(u=>{const s={edits:[]};for(const h of u)if(Array.isArray(h)&&h.every(n=>n instanceof I.TextEdit))for(const{newText:n,newEol:S,range:a}of h)s.edits.push({_type:2,resource:g.uri,edit:{range:a&&_.Range.from(a),text:n,eol:S&&_.EndOfLine.from(S)}});if(s.edits.length!==0)return F===g.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(s):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(pe[218],ve([0,1,10,25,2,15,127]),function(Z,e,f,t,I,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class k{constructor(C,l,b,p){this.start=C,this.deletedCount=l,this.deletedItems=b,this.items=p}static asApiEvents(C){return C.map(l=>({start:l.start,deletedCount:l.deletedCount,deletedItems:l.deletedItems,items:l.items.map(b=>b.apiCell)}))}}class y{constructor(C,l,b){this.notebook=C,this._extHostDocument=l,this._cellData=b,this.handle=b.handle,this.uri=I.URI.revive(b.uri),this.cellKind=b.cellKind,this._outputs=b.outputs.map(_.NotebookCellOutput.to),this._internalMetadata=b.internalMetadata??{},this._metadata=Object.freeze(b.metadata??{}),this._previousResult=Object.freeze(_.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}static asModelAddData(C,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:C}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const C=this,l=this._extHostDocument.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:_.NotebookCellKind.to(this._cellData.cellKind),document:l.document,get mime(){return C._mime},set mime(b){C._mime=b},get outputs(){return C._outputs.slice(0)},get metadata(){return C._metadata},get executionSummary(){return C._previousResult}})}return this._apiCell}setOutputs(C){this._outputs=C.map(_.NotebookCellOutput.to)}setOutputItems(C,l,b){const p=b.map(_.NotebookCellOutputItem.to),g=this._outputs.find(E=>E.id===C);g&&(l||(g.items.length=0),g.items.push(...p))}setMetadata(C){this._metadata=Object.freeze(C)}setInternalMetadata(C){this._internalMetadata=C,this._previousResult=Object.freeze(_.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.ExtHostCell=y;class P{constructor(C,l,b,p,g,E){this._proxy=C,this._textDocumentsAndEditors=l,this._textDocuments=b,this._emitter=p,this.uri=g,this.handle=P._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=E.viewType,this._metadata=Object.freeze(E.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,E.cells]],!0),this._versionId=E.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const C=this;this._notebook={get uri(){return C.uri},get version(){return C._versionId},get notebookType(){return C._notebookType},get isDirty(){return C._isDirty},get isUntitled(){return C.uri.scheme===f.Schemas.untitled},get isClosed(){return C._disposed},get metadata(){return C._metadata},get cellCount(){return C._cells.length},cellAt(l){return l=C._validateIndex(l),C._cells[l].apiCell},getCells(l){return(l?C._getCells(l):C._cells).map(p=>p.apiCell)},save(){return C._save()}}}return this._notebook}updateBackup(C){this._backup?.delete(),this._backup=C}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(C){C.metadata&&(this._metadata=Object.freeze({...this._metadata,...C.metadata}))}acceptDirty(C){this._isDirty=C}acceptModelChanged(C,l){this._versionId=C.versionId,this._isDirty=l;for(const b of C.rawEvents)b.kind===R.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(b.changes,!1):b.kind===R.NotebookCellsChangeType.Move?this._moveCell(b.index,b.newIdx):b.kind===R.NotebookCellsChangeType.Output?this._setCellOutputs(b.index,b.outputs):b.kind===R.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(b.index,b.outputId,b.append,b.outputItems):b.kind===R.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(b.index,b.language):b.kind===R.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(b.index,b.mime):b.kind===R.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(b.index,b.metadata):b.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(b.index,b.internalMetadata)}_validateIndex(C){return C=C|0,C<0?0:C>=this._cells.length?this._cells.length-1:C}_validateRange(C){let l=C.start|0,b=C.end|0;return l<0&&(l=0),b>this._cells.length&&(b=this._cells.length),C.with({start:l,end:b})}_getCells(C){C=this._validateRange(C);const l=[];for(let b=C.start;b<C.end;b++)l.push(this._cells[b]);return l}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(C,l){if(this._disposed)return;const b=[],p=[],g=[];C.reverse().forEach(E=>{const D=E[2].map(h=>{const n=new y(this,this._textDocumentsAndEditors,h);return l||p.push(y.asModelAddData(this.apiNotebook,h)),n}),u=new k(E[0],E[1],[],D),s=this._cells.splice(E[0],E[1],...D);for(const h of s)g.push(h.uri),u.deletedItems.push(h.apiCell);b.push(u)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:g}),l||this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:k.asApiEvents(b)}))}_moveCell(C,l){const b=this._cells.splice(C,1);this._cells.splice(l,0,...b);const p=[new k(C,1,b.map(g=>g.apiCell),[]),new k(l,0,[],b)];this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:k.asApiEvents(p)}))}_setCellOutputs(C,l){const b=this._cells[C];b.setOutputs(l),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[b.apiCell]}))}_setCellOutputItems(C,l,b,p){const g=this._cells[C];g.setOutputItems(l,b,p),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[g.apiCell]}))}_changeCellLanguage(C,l){const b=this._cells[C];b.apiCell.document.languageId!==l&&this._textDocuments.$acceptModelLanguageChanged(b.uri,l)}_changeCellMime(C,l){const b=this._cells[C];b.apiCell.mime=l}_changeCellMetadata(C,l){const b=this._cells[C],p=b.apiCell.metadata;b.setMetadata(l);const g=b.apiCell.metadata;(0,t.equals)(p,g)||this._emitter.emitCellMetadataChange((0,t.deepFreeze)({document:this.apiNotebook,cell:b.apiCell}))}_changeCellInternalMetadata(C,l){this._cells[C].setInternalMetadata(l)}getCellFromApiCell(C){return this._cells.find(l=>l.apiCell===C)}getCellFromIndex(C){return this._cells[C]}getCell(C){return this._cells.find(l=>l.handle===C)}getCellIndex(C){return this._cells.indexOf(C)}}e.ExtHostNotebookDocument=P,P._handlePool=0}),define(pe[130],ve([0,1,7,15,16]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class _{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:y,metadata:P})}replaceCells(y,P,L){this._throwIfFinalized(),!(y===P&&L.length===0)&&this._collectedEdits.push({editType:1,index:y,count:P-y,cells:L.map(t.NotebookCellData.from)})}}class R{constructor(y,P,L,C,l,b){this.id=y,this._proxy=P,this.notebookData=L,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=C,this._viewColumn=b}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},set selections(P){if(!Array.isArray(P)||!P.every(f.NotebookRange.isNotebookRange))throw(0,I.illegalArgument)("selections");y._selections=P,y._trySetSelections(P)},get visibleRanges(){return y._visibleRanges},revealRange(P,L){y._proxy.$tryRevealRange(y.id,t.NotebookRange.from(P),L??f.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(P){const L=new _(this.document.version);return P(L),y._applyEdit(L.finalize())},setDecorations(P,L){return y.setDecorations(P,L)}},R.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_trySetSelections(y){this._proxy.$trySetSelections(this.id,y.map(t.NotebookRange.from))}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const P=[];let L=-1;for(let C=0;C<y.cellEdits.length;C++){if(L<0){P.push(y.cellEdits[C]),L++;continue}const b=P[L],p=y.cellEdits[C];if(b.editType===1&&p.editType===1&&b.index===p.index){b.cells.push(...y.cellEdits[C].cells),b.count+=y.cellEdits[C].count;continue}P.push(y.cellEdits[C]),L++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,P)}setDecorations(y,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return P.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,t.NotebookRange.from(P),y.key)}}e.ExtHostNotebookEditor=R,R.apiEditorsToExtHost=new WeakMap}),define(pe[219],ve([0,1,15,118,166,21,56,16]),function(Z,e,f,t,I,_,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(l){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=l}async withProgress(l,b,p){const g=this._handles++,{title:E,location:F,cancellable:D}=b,u={label:(0,I.localize)(0,null,l.displayName||l.name),id:l.identifier.value};return this._proxy.$startProgress(g,{location:f.ProgressLocation.from(F),title:E,source:u,cancellable:D},l.isUnderDevelopment?void 0:l.identifier.value).catch(k.onUnexpectedExternalError),this._withProgress(g,p,!!D)}_withProgress(l,b,p){let g;p&&(g=new _.CancellationTokenSource,this._mapHandleToCancellationSource.set(l,g));const E=D=>{this._proxy.$progressEnd(D),this._mapHandleToCancellationSource.delete(D),g&&g.dispose()};let F;try{F=b(new L(this._proxy,l),p&&g?g.token:_.CancellationToken.None)}catch(D){throw E(l),D}return F.then(D=>E(l),D=>E(l)),F}$acceptProgressCanceled(l){const b=this._mapHandleToCancellationSource.get(l);b&&(b.cancel(),this._mapHandleToCancellationSource.delete(l))}}e.ExtHostProgress=y;function P(C,l){return C.message=l.message,typeof l.increment=="number"&&(typeof C.increment=="number"?C.increment+=l.increment:C.increment=l.increment),C}class L extends t.Progress{constructor(l,b){super(p=>this.throttledReport(p));this._proxy=l,this._handle=b}throttledReport(l){this._proxy.$progressReport(this._handle,l)}}je([(0,R.throttle)(100,(C,l)=>P(C,l),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(pe[131],ve([0,1,55,16,77,15,7]),function(Z,e,f,t,I,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(l,b,p){const g=k._Keys.nextId();l.$registerTextEditorDecorationType(b.identifier,g,_.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:g,dispose(){l.$removeTextEditorDecorationType(g)}})}}e.TextEditorDecorationType=k,k._Keys=new I.IdGenerator("TextEditorDecorationType");class y{constructor(l,b){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=b.undoStopBefore,this._undoStopAfter=b.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,b){this._throwIfFinalized();let p=null;if(l instanceof R.Position)p=new R.Range(l,l);else if(l instanceof R.Range)p=l;else throw new Error("Unrecognized location");this._pushEdit(p,b,!1)}insert(l,b){this._throwIfFinalized(),this._pushEdit(new R.Range(l,l),b,!0)}delete(l){this._throwIfFinalized();let b=null;if(l instanceof R.Range)b=l;else throw new Error("Unrecognized location");this._pushEdit(b,null,!0)}_pushEdit(l,b,p){const g=this._document.validateRange(l);this._collectedEdits.push({range:g,text:b,forceMoveMarkers:p})}setEndOfLine(l){if(this._throwIfFinalized(),l!==R.EndOfLine.LF&&l!==R.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=y;class P{constructor(l,b,p,g){this._proxy=l,this._id=b,this._accept(p),this._logService=g;const E=this;this.value={get tabSize(){return E._tabSize},set tabSize(F){E._setTabSize(F)},get insertSpaces(){return E._insertSpaces},set insertSpaces(F){E._setInsertSpaces(F)},get cursorStyle(){return E._cursorStyle},set cursorStyle(F){E._setCursorStyle(F)},get lineNumbers(){return E._lineNumbers},set lineNumbers(F){E._setLineNumbers(F)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=_.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const b=Math.floor(l);return b>0?b:null}if(typeof l=="string"){const b=parseInt(l,10);return isNaN(b)?null:b>0?b:null}return null}_setTabSize(l){const b=this._validateTabSize(l);if(b!==null){if(typeof b=="number"){if(this._tabSize===b)return;this._tabSize=b}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:b}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const b=this._validateInsertSpaces(l);if(typeof b=="boolean"){if(this._insertSpaces===b)return;this._insertSpaces=b}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:b}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:_.TextEditorLineNumbersStyle.from(l)})))}assign(l){const b={};let p=!1;if(typeof l.tabSize!="undefined"){const g=this._validateTabSize(l.tabSize);g==="auto"?(p=!0,b.tabSize=g):typeof g=="number"&&this._tabSize!==g&&(this._tabSize=g,p=!0,b.tabSize=g)}if(typeof l.insertSpaces!="undefined"){const g=this._validateInsertSpaces(l.insertSpaces);g==="auto"?(p=!0,b.insertSpaces=g):this._insertSpaces!==g&&(this._insertSpaces=g,p=!0,b.insertSpaces=g)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,p=!0,b.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,p=!0,b.lineNumbers=_.TextEditorLineNumbersStyle.from(l.lineNumbers)),p&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,b))}_warnOnError(l,b){b.catch(p=>{this._logService.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this._logService.warn(p)})}}e.ExtHostTextEditorOptions=P;class L{constructor(l,b,p,g,E,F,D,u){this.id=l,this._proxy=b,this._logService=p,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=E,this._options=new P(this._proxy,this.id,F,p),this._visibleRanges=D,this._viewColumn=u;const s=this;this.value=Object.freeze({get document(){return g.getValue()},set document(h){throw(0,t.readonly)("document")},get selection(){return s._selections&&s._selections[0]},set selection(h){if(!(h instanceof R.Selection))throw(0,t.illegalArgument)("selection");s._selections=[h],s._trySetSelection()},get selections(){return s._selections},set selections(h){if(!Array.isArray(h)||h.some(n=>!(n instanceof R.Selection)))throw(0,t.illegalArgument)("selections");s._selections=h,s._trySetSelection()},get visibleRanges(){return s._visibleRanges},set visibleRanges(h){throw(0,t.readonly)("visibleRanges")},get options(){return s._options.value},set options(h){s._disposed||s._options.assign(h)},get viewColumn(){return s._viewColumn},set viewColumn(h){throw(0,t.readonly)("viewColumn")},edit(h,n={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const S=new y(g.getValue(),n);return h(S),s._applyEdit(S)},insertSnippet(h,n,S={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!n||Array.isArray(n)&&n.length===0)a=s._selections.map(i=>_.Range.from(i));else if(n instanceof R.Position){const{lineNumber:i,column:r}=_.Position.from(n);a=[{startLineNumber:i,startColumn:r,endLineNumber:i,endColumn:r}]}else if(n instanceof R.Range)a=[_.Range.from(n)];else{a=[];for(const i of n)if(i instanceof R.Range)a.push(_.Range.from(i));else{const{lineNumber:r,column:c}=_.Position.from(i);a.push({startLineNumber:r,startColumn:c,endLineNumber:r,endColumn:c})}}return b.$tryInsertSnippet(l,h.value,a,S)},setDecorations(h,n){const S=n.length===0;S&&!s._hasDecorationsForKey.has(h.key)||(S?s._hasDecorationsForKey.delete(h.key):s._hasDecorationsForKey.add(h.key),s._runOnProxy(()=>{if(_.isDecorationOptionsArr(n))return b.$trySetDecorations(l,h.key,_.fromRangeOrRangeWithMessage(n));{const a=new Array(4*n.length);for(let i=0,r=n.length;i<r;i++){const c=n[i];a[4*i]=c.start.line+1,a[4*i+1]=c.start.character+1,a[4*i+2]=c.end.line+1,a[4*i+3]=c.end.character+1}return b.$trySetDecorationsFast(l,h.key,a)}}))},revealRange(h,n){s._runOnProxy(()=>b.$tryRevealRange(l,_.Range.from(h),n||R.TextEditorRevealType.Default))},show(h){b.$tryShowEditor(l,_.ViewColumn.from(h))},hide(){b.$tryHideEditor(l)}})}dispose(){(0,f.ok)(!this._disposed),this._disposed=!0}_acceptOptions(l){(0,f.ok)(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){(0,f.ok)(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){(0,f.ok)(!this._disposed),this._viewColumn=l}_acceptSelections(l){(0,f.ok)(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(_.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const b=l.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const p=b.edits.map(E=>E.range);p.sort((E,F)=>E.end.line===F.end.line?E.end.character===F.end.character?E.start.line===F.start.line?E.start.character-F.start.character:E.start.line-F.start.line:E.end.character-F.end.character:E.end.line-F.end.line);for(let E=0,F=p.length-1;E<F;E++){const D=p[E].end;if(p[E+1].start.isBefore(D))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=b.edits.map(E=>({range:_.Range.from(E.range),text:E.text,forceMoveMarkers:E.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,b.documentVersionId,g,{setEndOfLine:typeof b.setEndOfLine=="number"?_.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this._logService.warn(b),null))}}e.ExtHostTextEditor=L}),define(pe[220],ve([0,1,13,3,6,18,64,15,128,88]),function(Z,e,f,t,I,_,R,k,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class L extends I.Disposable{constructor(l){super();this.controllerId=l,this.debounceSendDiff=this._register(new f.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.root=new R.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(l){this._resolveHandler=l;for(const b of this.tree.values())this.updateExpandability(b)}collectDiff(){const l=this.diff;return this.diff=[],l}pushDiff(l){const b=this.diff[this.diff.length-1];if(b&&l[0]===1){if(b[0]===1&&b[1].extId===l[1].extId){(0,y.applyTestItemUpdate)(b[1],l[1]);return}if(b[0]===0&&b[1].item.extId===l[1].extId){(0,y.applyTestItemUpdate)(b[1],l[1]);return}}this.diff.push(l),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(l,b){const p=this.tree.get(l);if(!!p){if((p.expandLevels===void 0||b>p.expandLevels)&&(p.expandLevels=b),p.expand===1){const g=this.resolveChildren(p);return g.isOpen()?this.expandChildren(p,b-1):g.wait().then(()=>this.expandChildren(p,b-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.expandChildren(p,b-1)):this.expandChildren(p,b-1)}}dispose(){for(const l of this.tree.values())(0,R.getPrivateApiFor)(l.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(l,b){switch(b.op){case 2:this.pushDiff([4,l.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(l.fullId,b.id));break;case 0:this.upsertItem(b.item,l);break;case 4:for(const p of b.ops)this.onTestItemEvent(l,p);break;case 3:{const{key:p,value:g,previous:E}=b,F=l.fullId.toString();switch(p){case"canResolveChildren":this.updateExpandability(l);break;case"tags":this.diffTagRefs(g,E,F);break;case"range":this.pushDiff([1,{extId:F,item:{range:k.Range.from(g)}}]);break;case"error":this.pushDiff([1,{extId:F,item:{error:k.MarkdownString.fromStrict(g)||null}}]);break;default:this.pushDiff([1,{extId:F,item:{[p]:g??null}}]);break}break}default:(0,_.assertNever)(b)}}upsertItem(l,b){if(!(l instanceof R.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${l.id} did not`);const p=P.TestId.fromExtHostTestItem(l,this.root.id,b?.actual),g=(0,R.getPrivateApiFor)(l);g.parent&&g.parent!==b?.actual&&g.parent.children.delete(l.id);let E=this.tree.get(p.toString());if(!E){E={fullId:p,actual:l,parent:b?p.parentId:null,expandLevels:b?.expandLevels?b.expandLevels-1:void 0,expand:0},l.tags.forEach(this.incrementTagRefs,this),this.tree.set(E.fullId.toString(),E),this.setItemParent(l,b),this.pushDiff([0,{parent:E.parent&&E.parent.toString(),controllerId:this.controllerId,expand:E.expand,item:k.TestItem.from(l)}]),this.connectItemAndChildren(l,E,b);return}if(E.actual===l){this.connectItem(l,E,b);return}const F=E.actual.children,D=E.actual,u=(0,R.diffTestItems)(D,l);(0,R.getPrivateApiFor)(D).listener=void 0,E.actual=l,E.expand=0;for(const[s,h]of u)this.onTestItemEvent(E,{op:3,key:s,value:h,previous:D[s]});this.connectItemAndChildren(l,E,b);for(const s of F)l.children.get(s.id)||this.removeItem(P.TestId.joinToString(p,s.id))}diffTagRefs(l,b,p){const g=new Set(b.map(E=>E.id));for(const E of l)g.delete(E.id)||this.incrementTagRefs(E);this.pushDiff([1,{extId:p,item:{tags:l.map(E=>k.TestTag.namespace(this.controllerId,E.id))}}]),g.forEach(this.decrementTagRefs,this)}incrementTagRefs(l){const b=this.tags.get(l.id);b?b.refCount++:(this.tags.set(l.id,{refCount:1}),this.pushDiff([5,{id:k.TestTag.namespace(this.controllerId,l.id),ctrlLabel:this.root.label}]))}decrementTagRefs(l){const b=this.tags.get(l);b&&!--b.refCount&&(this.tags.delete(l),this.pushDiff([6,k.TestTag.namespace(this.controllerId,l)]))}setItemParent(l,b){(0,R.getPrivateApiFor)(l).parent=b&&b.actual!==this.root?b.actual:void 0}connectItem(l,b,p){this.setItemParent(l,p);const g=(0,R.getPrivateApiFor)(l);g.parent=p?.actual,g.listener=E=>this.onTestItemEvent(b,E),this.updateExpandability(b)}connectItemAndChildren(l,b,p){this.connectItem(l,b,p);for(const g of l.children)this.upsertItem(g,b)}updateExpandability(l){let b;this._resolveHandler?l.resolveBarrier?b=l.resolveBarrier.isOpen()?3:2:b=l.actual.canResolveChildren?1:0:b=0,b!==l.expand&&(l.expand=b,this.pushDiff([1,{extId:l.fullId.toString(),expand:b}]),b===1&&l.expandLevels!==void 0&&this.resolveChildren(l))}expandChildren(l,b){if(b<0)return;const p=[];for(const g of l.actual.children){const E=this.expand(P.TestId.joinToString(l.fullId,g.id),b);(0,f.isThenable)(E)&&p.push(E)}if(p.length)return Promise.all(p).then(()=>{})}resolveChildren(l){if(l.resolveBarrier)return l.resolveBarrier;if(!this._resolveHandler){const E=new f.Barrier;return E.open(),E}l.expand=2,this.pushExpandStateUpdate(l);const b=l.resolveBarrier=new f.Barrier,p=E=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),l.actual!==this.root&&(l.actual.error=E.stack||E.message||String(E))};let g;try{g=this._resolveHandler(l.actual===this.root?void 0:l.actual)}catch(E){p(E)}return(0,f.isThenable)(g)?g.catch(p).then(()=>{b.open(),this.updateExpandability(l)}):(b.open(),this.updateExpandability(l)),l.resolveBarrier}pushExpandStateUpdate(l){this.pushDiff([1,{extId:l.fullId.toString(),expand:l.expand}])}removeItem(l){const b=this.tree.get(l);if(!b)throw new Error("attempting to remove non-existent child");this.pushDiff([2,l]);const p=[b];for(;p.length;){const g=p.pop();if(!!g){(0,R.getPrivateApiFor)(g.actual).listener=void 0;for(const E of g.actual.tags)this.decrementTagRefs(E.id);this.tree.delete(g.fullId.toString());for(const E of g.actual.children)p.push(this.tree.get(P.TestId.joinToString(g.fullId,E.id)))}}}flushDiff(){const l=this.collectDiff();l.length&&this.diffOpEmitter.fire(l)}}e.SingleUseTestCollection=L}),define(pe[221],ve([0,1,4,184]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,f.refineServiceDecorator)(t.IEnvironmentService)}),define(pe[222],ve([0,1,27,3,9]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class _{constructor(L){this.removedDueToLooping=L}}e.DeltaExtensionsResult=_;class R{constructor(L){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=L,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const L of this._extensionDescriptions){if(this._extensionsMap.has(f.ExtensionIdentifier.toKey(L.identifier))){console.error("Extension `"+L.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(f.ExtensionIdentifier.toKey(L.identifier),L),this._extensionsArr.push(L),Array.isArray(L.activationEvents))for(let C of L.activationEvents)C==="onUri"&&(C=`onUri:${f.ExtensionIdentifier.toKey(L.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(L)}}keepOnly(L){const C=new Set;L.forEach(l=>C.add(f.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>C.has(f.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(L,C){L.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(L));const l=R._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(l.map(b=>b.identifier)),C.length>0){const b=new Set;C.forEach(p=>b.add(f.ExtensionIdentifier.toKey(p))),this._extensionDescriptions=this._extensionDescriptions.filter(p=>!b.has(f.ExtensionIdentifier.toKey(p.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new _(l)}static _findLoopingExtensions(L){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(E){this._nodesSet.has(E)||(this._nodesSet.add(E),this._nodesArr.push(E))}addArc(E,F){this.addNode(E),this.addNode(F),this._arcs.has(E)?this._arcs.get(E).push(F):this._arcs.set(E,[F])}getArcs(E){return this._arcs.has(E)?this._arcs.get(E):[]}hasOnlyGoodArcs(E,F){const D=C.getArcs(E);for(let u=0;u<D.length;u++)if(!F.has(D[u]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let E of L){const F=f.ExtensionIdentifier.toKey(E.identifier);if(l.set(F,E),E.extensionDependencies)for(let D of E.extensionDependencies){const u=f.ExtensionIdentifier.toKey(D);C.addArc(F,u)}}let b=new Set;C.getNodes().filter(E=>C.getArcs(E).length===0).forEach(E=>b.add(E));let p=C.getNodes().filter(E=>!b.has(E)),g;do{g=!1;for(let E=0;E<p.length;E++){const F=p[E];C.hasOnlyGoodArcs(F,b)&&(p.splice(E,1),E--,b.add(F),g=!0)}}while(g);return p.map(E=>l.get(E))}containsActivationEvent(L){return this._activationMap.has(L)}containsExtension(L){return this._extensionsMap.has(f.ExtensionIdentifier.toKey(L))}getExtensionDescriptionsForActivationEvent(L){const C=this._activationMap.get(L);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(L){const C=this._extensionsMap.get(f.ExtensionIdentifier.toKey(L));return C||void 0}}e.ExtensionDescriptionRegistry=R;var k;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(k||(k={}));function y(P,L){const C=P.isBuiltin?0:P.isUnderDevelopment?2:1,l=L.isBuiltin?0:L.isUnderDevelopment?2:1;if(C!==l)return C-l;const b=I.posix.basename(P.extensionLocation.path),p=I.posix.basename(L.extensionLocation.path);return b<p?-1:b>p?1:0}}),define(pe[223],ve([0,1,22]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var t;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(t=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var I;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(I=e.MessageType||(e.MessageType={}));function _(k){const y=f.VSBuffer.alloc(1);switch(k){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=_;function R(k,y){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=R}),define(pe[28],ve([0,1,3,2,4,27,121]),function(Z,e,f,t,I,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new _.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");var k;(function(s){s[s.None=0]="None",s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function y(s){switch(s){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=y;class P{constructor(h){this.dependency=h}}e.MissingExtensionDependency=P;var L;(function(s){s[s.LocalProcess=0]="LocalProcess",s[s.LocalWebWorker=1]="LocalWebWorker",s[s.Remote=2]="Remote"})(L=e.ExtensionHostKind||(e.ExtensionHostKind={}));function C(s){switch(s){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=C;function l(s,h){return s.enabledApiProposals?s.enabledApiProposals.includes(h):!1}e.isProposedApiEnabled=l;function b(s,h){if(!l(s,h))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.checkProposedApiEnabled=b;class p{constructor(h,n,S,a){this.codeLoadingTime=h,this.activateCallTime=n,this.activateResolvedTime=S,this.activationReason=a}}e.ActivationTimes=p;class g{constructor(h,n){this.description=h,this.value=n}}e.ExtensionPointContribution=g,e.ExtensionHostLogFileName="exthost";var E;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(E=e.ActivationKind||(e.ActivationKind={}));function F(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,R.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation}}e.toExtension=F;function D(s,h){return{identifier:new _.ExtensionIdentifier((0,R.getExtensionId)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!h,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid}}e.toExtensionDescription=D;class u{constructor(){this.onDidRegisterExtensions=f.Event.None,this.onDidChangeExtensionsStatus=f.Event.None,this.onDidChangeExtensions=f.Event.None,this.onWillActivateByEvent=f.Event.None,this.onDidChangeResponsiveChange=f.Event.None}activateByEvent(h){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(h){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(h,n){return Promise.resolve()}_onWillActivateExtension(h){}_onDidActivateExtension(h,n,S,a,i){}_onDidActivateExtensionError(h,n){}_onExtensionRuntimeError(h,n){}_onExtensionHostExit(h){}}e.NullExtensionService=u}),define(pe[224],ve([0,1,16,27,28,11]),function(Z,e,f,t,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const R=Promise.resolve(void 0);class k{constructor(g,E,F,D){this.startup=g,this.codeLoadingTime=E,this.activateCallTime=F,this.activateResolvedTime=D}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class y{constructor(g){this._startup=g,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(g,E){return g===-1||E===-1?-1:E-g}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class P{constructor(g,E,F,D,u,s){this.activationFailed=g,this.activationFailedError=E,this.activationTimes=F,this.module=D,this.exports=u,this.subscriptions=s}}e.ActivatedExtension=P;class L extends P{constructor(g){super(!1,null,g,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=L;class C extends P{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=C;class l extends P{constructor(g){super(!0,g,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=l;let b=class{constructor(g,E,F,D,u){this._logService=u,this._isDisposed=!1,this._registry=g,this._resolvedExtensionsSet=new Set,E.forEach(s=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(s))),this._hostExtensionsMap=new Map,F.forEach(s=>this._hostExtensionsMap.set(t.ExtensionIdentifier.toKey(s),s)),this._host=D,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(g){const E=t.ExtensionIdentifier.toKey(g);return this._activatedExtensions.has(E)}getActivatedExtension(g){const E=t.ExtensionIdentifier.toKey(g),F=this._activatedExtensions.get(E);if(!F)throw new Error("Extension `"+g.value+"` is not known or not activated");return F}activateByEvent(g,E){if(this._alreadyActivatedEvents[g])return R;const F=this._registry.getExtensionDescriptionsForActivationEvent(g);return this._activateExtensions(F.map(D=>({id:D.identifier,reason:{startup:E,extensionId:D.identifier,activationEvent:g}}))).then(()=>{this._alreadyActivatedEvents[g]=!0})}activateById(g,E){const F=this._registry.getExtensionDescription(g);if(!F)throw new Error("Extension `"+g+"` is not known");return this._activateExtensions([{id:F.identifier,reason:E}])}_handleActivateRequest(g,E,F){if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(g.id))){E[t.ExtensionIdentifier.toKey(g.id)]=g;return}const D=this._registry.getExtensionDescription(g.id);if(!D){const h=new Error(`Cannot activate unknown extension '${g.id.value}'`);this._host.onExtensionActivationError(g.id,h,new I.MissingExtensionDependency(g.id.value)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(g.id),new l(h));return}const u=typeof D.extensionDependencies=="undefined"?[]:D.extensionDependencies;let s=!0;for(let h=0,n=u.length;h<n;h++){const S=u[h];if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(S)))continue;const a=this._activatedExtensions.get(t.ExtensionIdentifier.toKey(S));if(a&&!a.activationFailed)continue;if(a&&a.activationFailed){const o=D.displayName||D.identifier.value,d=this._registry.getExtensionDescription(S),m=d&&d.displayName||S,v=new Error(`Cannot activate the '${o}' extension because its dependency '${m}' failed to activate`);v.detail=a.activationFailedError,this._host.onExtensionActivationError(D.identifier,v,null),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(D.identifier),new l(v));return}if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(S))){s=!1,E[t.ExtensionIdentifier.toKey(S)]={id:this._hostExtensionsMap.get(t.ExtensionIdentifier.toKey(S)),reason:g.reason};continue}const i=this._registry.getExtensionDescription(S);if(i){if(!i.main&&!i.browser)continue;s=!1,E[t.ExtensionIdentifier.toKey(S)]={id:i.identifier,reason:g.reason};continue}const r=D.displayName||D.identifier.value,c=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${S}'`);this._host.onExtensionActivationError(D.identifier,c,new I.MissingExtensionDependency(S)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(D.identifier),new l(c));return}s?E[t.ExtensionIdentifier.toKey(D.identifier)]=g:F.push(g)}_activateExtensions(g){if(g.length===0||(g=g.filter(u=>!this._activatedExtensions.has(t.ExtensionIdentifier.toKey(u.id))),g.length===0))return Promise.resolve(void 0);const E=Object.create(null),F=[];for(let u=0,s=g.length;u<s;u++)this._handleActivateRequest(g[u],E,F);for(let u=0,s=F.length;u<s;u++){const h=t.ExtensionIdentifier.toKey(F[u].id);E[h]&&delete E[h]}const D=Object.keys(E).map(u=>E[u]);return F.length===0?Promise.all(D.map(u=>this._activateExtension(u.id,u.reason))).then(u=>{}):this._activateExtensions(D).then(u=>this._activateExtensions(F))}_activateExtension(g,E){const F=t.ExtensionIdentifier.toKey(g);if(this._activatedExtensions.has(F))return Promise.resolve(void 0);const D=this._activatingExtensions.get(F);if(D)return D;const u=this._host.actualActivateExtension(g,E).then(void 0,s=>{const h=new Error;return s&&s.name&&(h.name=s.name),s&&s.message?h.message=`Activating extension '${g.value}' failed: ${s.message}.`:h.message=`Activating extension '${g.value}' failed: ${s}.`,s&&s.stack&&(h.stack=s.stack),this._isDisposed&&f.isCancellationError(s)?new l(s):(this._host.onExtensionActivationError(g,h,null),this._logService.error(`Activating extension ${g.value} failed due to an error:`),this._logService.error(s),new l(s))}).then(s=>{this._activatedExtensions.set(F,s),this._activatingExtensions.delete(F)});return this._activatingExtensions.set(F,u),u}};b=je([ze(4,_.ILogService)],b),e.ExtensionsActivator=b}),define(pe[225],ve([0,1,11,26,28]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let _=class extends f.LogService{constructor(k,y){super(k.createLogger(y.logFile,{name:I.ExtensionHostLogFileName}))}};_=je([ze(0,f.ILoggerService),ze(1,t.IExtHostInitDataService)],_),e.ExtHostLogService=_}),define(pe[226],ve([0,1,16]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((_,R)=>{this._actualOk=_,this._actualErr=R,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(_){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=_,this._actual&&this._actualOk(_))}resolveErr(_){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=_,this._actual?this._actualErr(_):(0,f.onUnexpectedError)(_))}then(_,R){return this._ensureActual().then(_,R)}catch(_){return this._ensureActual().then(void 0,_)}finally(_){return this._ensureActual().finally(_)}}e.LazyPromise=t}),define(pe[52],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class f{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++f.count}}e.ProxyIdentifier=f,f.count=0;const t=[];function I(k){const y=new f(k);return t[y.nid]=y,y}e.createProxyIdentifier=I;function _(k){return t[k].sid}e.getStringIdentifierForProxy=_;class R{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=R}),define(pe[5],ve([0,1,59,2,52]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var _;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(_=e.UIKind||(e.UIKind={}));var R;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(R=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var L;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(L=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var C;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(C=e.CandidatePortSource||(e.CandidatePortSource={}));var l;(function(u){u.name="$ident";function s(n,S){return Object.defineProperty(n,u.name,{value:S,enumerable:!0}),n}u.mixin=s;function h(n){return n[u.name]}u.of=h})(l=e.ObjectIdentifier||(e.ObjectIdentifier={}));class b{static mixin(s){return s._id=b._n++,s}}e.IdObject=b,b._n=0;var p;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n"})(p=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var E;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(E=e.WorkspaceEditType||(e.WorkspaceEditType={}));function F(u){if(u&&u.edits)for(const s of u.edits)typeof s.resource=="object"?s.resource=t.URI.revive(s.resource):(s.newUri=t.URI.revive(s.newUri),s.oldUri=t.URI.revive(s.oldUri)),s.metadata&&s.metadata.iconPath&&(s.metadata=(0,f.revive)(s.metadata));return u}e.reviveWorkspaceEditDto=F;var D;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(D=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,I.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,I.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,I.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,I.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,I.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createProxyIdentifier)("ExtHostTelemetry")}}),define(pe[89],ve([0,1,5,3,4]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class _{constructor(k){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(f.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,y){return this._proxy.$getPassword(k,y)}store(k,y,P){return this._proxy.$setPassword(k,y,P)}delete(k,y){return this._proxy.$deletePassword(k,y)}}e.ExtHostSecretState=_,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")}),define(pe[66],ve([0,1,4,11,5,14]),function(Z,e,f,t,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,f.createDecorator)("IExtHostApiDeprecationService");let R=class{constructor(y,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(I.MainContext.MainThreadTelemetry)}report(y,P,L){const C=this.getUsageKey(y,P);this._reportedUsages.has(C)||(this._reportedUsages.add(C),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${L}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:y}))}getUsageKey(y,P){return`${y}-${P.identifier.value}`}};R=je([ze(0,_.IExtHostRpcService),ze(1,t.ILogService)],R),e.ExtHostApiDeprecationService=R,e.NullApiDeprecationService=Object.freeze(new class{report(k,y,P){}})}),define(pe[227],ve([0,1,3,5,7,27]),function(Z,e,f,t,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class R{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new f.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,P,L,C={}){const l=_.ExtensionIdentifier.toKey(y.identifier),b=this._inFlightRequests.get(l)||[],p=[...L].sort().join(" ");let g=b.find(E=>E.scopes===p);if(g)return g.result;{const E=this._getSession(y,l,P,L,C);g={scopes:p,result:E},b.push(g),this._inFlightRequests.set(l,b);try{await E}finally{const F=b.findIndex(D=>D.scopes===p);F>-1&&(b.splice(F),this._inFlightRequests.set(l,b))}return E}}async _getSession(y,P,L,C,l={}){await this._proxy.$ensureProvider(L);const b=y.displayName||y.name;return this._proxy.$getSession(L,C,P,b,l)}async removeSession(y,P){const L=this._authenticationProviders.get(y);return L?L.provider.removeSession(P):this._proxy.$removeSession(y,P)}registerAuthenticationProvider(y,P,L,C){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:P,provider:L,options:C??{supportsMultipleAccounts:!1}}),this._providers.find(b=>b.id===y)||this._providers.push({id:y,label:P});const l=L.onDidChangeSessions(b=>{this._proxy.$sendDidChangeSessions(y,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,P,C?.supportsMultipleAccounts??!1),new I.Disposable(()=>{l.dispose(),this._authenticationProviders.delete(y);const b=this._providers.findIndex(p=>p.id===y);b>-1&&this._providers.splice(b),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,P){const L=this._authenticationProviders.get(y);if(L)return Promise.resolve(L.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,P){const L=this._authenticationProviders.get(y);if(L)return Promise.resolve(L.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,P){const L=this._authenticationProviders.get(y);if(L)return Promise.resolve(L.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,P){return this._onDidChangeSessions.fire({provider:{id:y,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=R}),define(pe[228],ve([0,1,5,14,15]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let _=class{constructor(k,y){this._extHostDocumentsAndEditors=y,this._proxy=k.getProxy(f.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const y=I.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};_=je([ze(0,t.IExtHostRpcService)],_),e.ExtHostBulkEdits=_}),define(pe[229],ve([0,1,5]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(_){const R=_.getProxy(f.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(k){return R.$writeText(k)}})}}e.ExtHostClipboard=t});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[38],ve([0,1,18,7,15,25,5,17,11,59,41,48,2,6,4,14,64,22,52,49]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p,g,E,F,D,u){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let h=class{constructor(c,o){s.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,nt(this,s,c.getProxy(R.MainContext.MainThreadCommands),"f"),this._logService=o,this.converter=new n(this,d=>{const m=this._apiCommands.get(d);return m?.result===a.Void?m:void 0},o),this._argumentProcessors=[{processArgument(d){return(0,P.revive)(d)}},{processArgument(d){return(0,_.cloneAndChange)(d,function(m){if(L.Range.isIRange(m))return I.Range.to(m);if(C.Position.isIPosition(m))return I.Position.to(m);if(L.Range.isIRange(m.range)&&l.URI.isUri(m.uri))return I.location.to(m);if(m instanceof F.VSBuffer)return m.buffer.buffer;if(!Array.isArray(m))return m})}}]}registerArgumentProcessor(c){this._argumentProcessors.push(c)}registerApiCommand(c){const o=this.registerCommand(!1,c.id,async(...d)=>{const m=c.args.map((w,A)=>{if(!w.validate(d[A]))throw new Error(`Invalid argument '${w.name}' when running '${c.id}', received: ${d[A]}`);return w.convert(d[A])}),v=await this.executeCommand(c.internalId,...m);return c.result.convert(v,d,this.converter)},void 0,{description:c.description,args:c.args,returns:c.result.description});return this._apiCommands.set(c.id,c),new t.Disposable(()=>{o.dispose(),this._apiCommands.delete(c.id)})}registerCommand(c,o,d,m,v,w){if(this._logService.trace("ExtHostCommands#registerCommand",o),!o.trim().length)throw new Error("invalid id");if(this._commands.has(o))throw new Error(`command '${o}' already exists`);return this._commands.set(o,{callback:d,thisArg:m,description:v,extension:w}),c&&Le(this,s,"f").$registerCommand(o),new t.Disposable(()=>{this._commands.delete(o)&&c&&Le(this,s,"f").$unregisterCommand(o)})}executeCommand(c,...o){return this._logService.trace("ExtHostCommands#executeCommand",c),this._doExecuteCommand(c,o,!0)}async _doExecuteCommand(c,o,d){if(this._commands.has(c))return this._executeContributedCommand(c,o,!1);{let m=!1;const v=(0,_.cloneAndChange)(o,function(w){if(w instanceof t.Position)return I.Position.from(w);if(w instanceof t.Range)return I.Range.from(w);if(w instanceof t.Location)return I.location.from(w);if(t.NotebookRange.isNotebookRange(w))return I.NotebookRange.from(w);if(w instanceof ArrayBuffer)return m=!0,F.VSBuffer.wrap(new Uint8Array(w));if(w instanceof Uint8Array)return m=!0,F.VSBuffer.wrap(w);if(!Array.isArray(w))return w});try{const w=await Le(this,s,"f").$executeCommand(c,m?new D.SerializableObjectWithBuffers(v):v,d);return(0,P.revive)(w)}catch(w){if(w instanceof Error&&w.message==="$executeCommand:retry")return this._doExecuteCommand(c,o,!1);throw w}}}async _executeContributedCommand(c,o,d){const m=this._commands.get(c);if(!m)throw new Error("Unknown command");let{callback:v,thisArg:w,description:A}=m;if(A)for(let M=0;M<A.args.length;M++)try{(0,f.validateConstraint)(o[M],A.args[M].constraint)}catch{throw new Error(`Running the contributed command: '${c}' failed. Illegal argument '${A.args[M].name}' - ${A.args[M].description}`)}try{return await v.apply(w,o)}catch(M){if(c===this.converter.delegatingCommandId){const T=this.converter.getActualCommand(...o);T&&(c=T.command)}throw this._logService.error(M,c,m.extension?.identifier),d?new class extends Error{constructor(){super((0,u.toErrorMessage)(M));this.id=c,this.source=m.extension?.displayName??m.extension?.name}}:M}}$executeContributedCommand(c,...o){return this._logService.trace("ExtHostCommands#$executeContributedCommand",c),this._commands.has(c)?(o=o.map(d=>this._argumentProcessors.reduce((m,v)=>v.processArgument(m),d)),this._executeContributedCommand(c,o,!0)):Promise.reject(new Error(`Contributed command '${c}' does not exist.`))}getCommands(c=!1){return this._logService.trace("ExtHostCommands#getCommands",c),Le(this,s,"f").$getCommands().then(o=>(c&&(o=o.filter(d=>d[0]!=="_")),o))}$getContributedCommandHandlerDescriptions(){const c=Object.create(null);for(let[o,d]of this._commands){let{description:m}=d;m&&(c[o]=m)}return Promise.resolve(c)}};s=new WeakMap,h=je([ze(0,g.IExtHostRpcService),ze(1,y.ILogService)],h),e.ExtHostCommands=h,e.IExtHostCommands=(0,p.createDecorator)("IExtHostCommands");class n{constructor(c,o,d){this._commands=c,this._lookupApiCommand=o,this._logService=d,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(c,o){if(!c)return;const d={$ident:void 0,id:c.command,title:c.title,tooltip:c.tooltip};if(!c.command)return d;const m=this._lookupApiCommand(c.command);if(m)d.id=m.internalId,d.arguments=m.args.map((v,w)=>v.convert(c.arguments&&c.arguments[w]));else if((0,k.isNonEmptyArray)(c.arguments)){const v=++this._cachIdPool;this._cache.set(v,c),o.add((0,b.toDisposable)(()=>{this._cache.delete(v),this._logService.trace("CommandsConverter#DISPOSE",v)})),d.$ident=v,d.id=this.delegatingCommandId,d.arguments=[v],this._logService.trace("CommandsConverter#CREATE",c.command,v)}return d}fromInternal(c){const o=R.ObjectIdentifier.of(c);return typeof o=="number"?this._cache.get(o):{command:c.id,title:c.title,arguments:c.arguments}}getActualCommand(...c){return this._cache.get(c[0])}_executeConvertedCommand(...c){const o=this.getActualCommand(...c);return this._logService.trace("CommandsConverter#EXECUTE",c[0],o?o.command:"MISSING"),o?this._commands.executeCommand(o.command,...o.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=n;class S{constructor(c,o,d,m){this.name=c,this.description=o,this.validate=d,this.convert=m}optional(){return new S(this.name,`(optional) ${this.description}`,c=>c==null||this.validate(c),c=>c===void 0?void 0:c===null?null:this.convert(c))}with(c,o){return new S(c??this.name,o??this.description,this.validate,this.convert)}}e.ApiCommandArgument=S,S.Uri=new S("uri","Uri of a text document",r=>l.URI.isUri(r),r=>r),S.Position=new S("position","A position in a text document",r=>t.Position.isPosition(r),I.Position.from),S.Range=new S("range","A range in a text document",r=>t.Range.isRange(r),I.Range.from),S.Selection=new S("selection","A selection in a text document",r=>t.Selection.isSelection(r),I.Selection.from),S.Number=new S("number","",r=>typeof r=="number",r=>r),S.String=new S("string","",r=>typeof r=="string",r=>r),S.CallHierarchyItem=new S("item","A call hierarchy item",r=>r instanceof t.CallHierarchyItem,I.CallHierarchyItem.from),S.TypeHierarchyItem=new S("item","A type hierarchy item",r=>r instanceof t.TypeHierarchyItem,I.TypeHierarchyItem.from),S.TestItem=new S("testItem","A VS Code TestItem",r=>r instanceof E.TestItemImpl,I.TestItem.from);class a{constructor(c,o){this.description=c,this.convert=o}}e.ApiCommandResult=a,a.Void=new a("no result",r=>r);class i{constructor(c,o,d,m,v){this.id=c,this.internalId=o,this.description=d,this.args=m,this.result=v}}e.ApiCommand=i}),define(pe[230],ve([0,1,15,7,83,38,17,111]),function(Z,e,f,t,I,_,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new _.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",L(f.DocumentHighlight.to))),new _.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,b)=>{if((0,R.isFalsyOrEmpty)(l))return;class p extends t.SymbolInformation{static to(E){const F=new p(E.name,f.SymbolKind.to(E.kind),E.containerName||"",new t.Location(b[0],f.Range.to(E.range)));return F.detail=E.detail,F.range=F.location.range,F.selectionRange=f.Range.to(E.selectionRange),F.children=E.children?E.children.map(p.to):[],F}}return l.map(p.to)})),new _.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",L(f.TextEdit.to))),new _.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range,new _.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",L(f.TextEdit.to))),new _.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,new _.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new _.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",L(f.TextEdit.to))),new _.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new _.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new _.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new _.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new _.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location-instances.",L(f.location.to))),new _.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Hover-instances.",L(f.Hover.to))),new _.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(b=>t.Position.isPosition(b)),l=>l.map(f.Position.from))],new _.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(b=>{let p;for(const g of b.reverse())p=new t.SelectionRange(f.Range.to(g),p);return p}))),new _.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[_.ApiCommandArgument.String.with("query","Search string")],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(f.WorkspaceSymbol.to))),new _.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(f.CallHierarchyItem.to))),new _.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(f.CallHierarchyIncomingCall.to))),new _.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(f.CallHierarchyOutgoingCall.to))),new _.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to a range and placeholder text.",l=>{if(!!l)return{range:f.Range.to(l.range),placeholder:l.text}})),new _.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("newName","The new symbol name")],new _.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return f.WorkspaceEdit.to(l)}})),new _.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new _.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(f.DocumentLink.to))),new _.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new t.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const b=(0,k.decodeSemanticTokensDto)(l);if(b.type==="full")return new t.SemanticTokens(b.data,void 0)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range.optional()],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new t.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const b=(0,k.decodeSemanticTokensDto)(l);if(b.type==="full")return new t.SemanticTokens(b.data,void 0)})),new _.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new _.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,b,p)=>{if(!l)return new t.CompletionList([]);const g=l.suggestions.map(E=>f.CompletionItem.to(E,p));return new t.CompletionList(g,l.incomplete)})),new _.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new _.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return f.SignatureHelp.to(l)})),new _.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new _.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,b,p)=>L(g=>new t.CodeLens(f.Range.to(g.range),g.command&&p.fromInternal(g.command)))(l))),new _.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>t.Range.isRange(l),l=>t.Selection.isSelection(l)?f.Selection.from(l):f.Range.from(l)),_.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new _.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,b,p)=>L(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return p.fromInternal(g.command)}else{const E=new t.CodeAction(g.title,g.kind?new t.CodeActionKind(g.kind):void 0);return g.edit&&(E.edit=f.WorkspaceEdit.to(g.edit)),g.command&&(E.command=p.fromInternal(g.command)),E.isPreferred=g.isPreferred,E}})(l))),new _.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(b=>new t.ColorInformation(f.Range.to(b.range),f.Color.to(b.color))):[])),new _.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new _.ApiCommandArgument("color","The color to show and insert",l=>l instanceof t.Color,f.Color.from),new _.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:f.Range.from(l.range)}))],new _.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(f.ColorPresentation.to):[])),new _.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of Inlay objects",(l,b,p)=>l.map(f.InlayHint.to.bind(void 0,p)))),new _.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new _.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",L(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(b=>f.NotebookExclusiveDocumentPattern.to(b))})))),new _.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(f.InlineValue.to))),new _.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[f.ViewColumn.from(l),void 0]:[f.ViewColumn.from(l.viewColumn),f.TextEditorOpenOptions.from(l)])).optional(),_.ApiCommandArgument.String.with("label","").optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[_.ApiCommandArgument.Uri.with("resource","Resource to open"),_.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[f.ViewColumn.from(l),void 0]:[f.ViewColumn.from(l.viewColumn),f.TextEditorOpenOptions.from(l)])).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[_.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),_.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),_.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[f.ViewColumn.from(l.viewColumn),f.TextEditorOpenOptions.from(l)]).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(f.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(f.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(f.TypeHierarchyItem.to))),new _.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[_.ApiCommandArgument.TestItem],_.ApiCommandResult.Void)];class P{static register(b){y.forEach(b.registerApiCommand,b)}}e.ExtHostApiCommands=P;function L(l){return b=>{if(Array.isArray(b))return b.map(l)}}function C(l){if(!Array.isArray(l))return;const b=[];for(const p of l)I.isLocationLink(p)?b.push(f.DefinitionLink.to(p)):b.push(f.location.to(p));return b}}),define(pe[231],ve([0,1,13,56,3,6,2,83,27,15,7,28,5]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function b(p,g,E){const F=p.getProxy(l.MainContext.MainThreadComments);class D{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,g.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const c=this._commentControllers.get(r.handle);return c||r}else if(r&&r.$mid===7){const c=this._commentControllers.get(r.commentControlHandle);if(!c)return r;const o=c.getCommentThread(r.commentThreadHandle);return o||r}else if(r&&r.$mid===8){const c=this._commentControllers.get(r.thread.commentControlHandle);if(!c)return r;const o=c.getCommentThread(r.thread.commentThreadHandle);return o?{thread:o,text:r.text}:r}else if(r&&r.$mid===9){const c=this._commentControllers.get(r.thread.commentControlHandle);if(!c)return r;const o=c.getCommentThread(r.thread.commentThreadHandle);if(!o)return r;let d=r.commentUniqueId,m=o.getCommentByUniqueId(d);return m||r}else if(r&&r.$mid===10){const c=this._commentControllers.get(r.thread.commentControlHandle);if(!c)return r;const o=c.getCommentThread(r.thread.commentThreadHandle);if(!o)return r;let d=r.text,m=r.commentUniqueId,v=o.getCommentByUniqueId(m);return v?(v.body=d,v):r}return r}})}createCommentController(r,c,o){const d=D.handlePool++,m=new s(r,d,c,o);this._commentControllers.set(m.handle,m);const v=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(r.identifier))||[];return v.push(m),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(r.identifier),v),m.value}$createCommentThreadTemplate(r,c,o){const d=this._commentControllers.get(r);!d||d.$createCommentThreadTemplate(c,o)}async $updateCommentThreadTemplate(r,c,o){const d=this._commentControllers.get(r);!d||d.$updateCommentThreadTemplate(c,o)}$deleteCommentThread(r,c){const o=this._commentControllers.get(r);o&&o.$deleteCommentThread(c)}$provideCommentingRanges(r,c,o){const d=this._commentControllers.get(r);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const m=E.getDocument(R.URI.revive(c));return(0,f.asPromise)(()=>d.commentingRangeProvider.provideCommentingRanges(m,o)).then(v=>v?v.map(w=>P.Range.from(w)):void 0)}$toggleReaction(r,c,o,d,m){const v=this._commentControllers.get(r);return!v||!v.reactionHandler?Promise.resolve(void 0):(0,f.asPromise)(()=>{const w=v.getCommentThread(c);if(w){const A=w.getCommentByUniqueId(d.uniqueIdInThread);if(v!==void 0&&A&&v.reactionHandler)return v.reactionHandler(A,S(m))}return Promise.resolve(void 0)})}dispose(){}}D.handlePool=0;class u{constructor(r,c,o,d,m,v,w){this._commentControllerHandle=c,this._id=o,this._uri=d,this._range=m,this._comments=v,this.extensionDescription=w,this.handle=u._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new _.MutableDisposable,this._acceptInputDisposables.value=new _.DisposableStore,this._id===void 0&&(this._id=`${r}.${this.handle}`),F.$createCommentThread(c,this.handle,this._id,this._uri,P.Range.from(this._range),w.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=v,this._localDisposables.push({dispose:()=>{F.$deleteCommentThread(c,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(M){A.range=M},get comments(){return A.comments},set comments(M){A.comments=M},get collapsibleState(){return A.collapsibleState},set collapsibleState(M){A.collapsibleState=M},get canReply(){return A.canReply},set canReply(M){A.canReply=M},get contextValue(){return A.contextValue},set contextValue(M){A.contextValue=M},get label(){return A.label},set label(M){A.label=M},dispose:()=>{A.dispose()}}}set threadId(r){this._id=r}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(r){r.isEqual(this._range)||(this._range=r,this.modifications.range=r,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(r){this._canReply!==r&&(this._canReply=r,this.modifications.canReply=r,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(r){this._label=r,this.modifications.label=r,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(r){this._contextValue=r,this.modifications.contextValue=r,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(r){this._comments=r,this.modifications.comments=r,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(r){this._collapseState=r,this.modifications.collapsibleState=r,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new _.DisposableStore);const r=o=>Object.prototype.hasOwnProperty.call(this.modifications,o),c={};r("range")&&(c.range=P.Range.from(this._range)),r("label")&&(c.label=this.label),r("contextValue")&&(c.contextValue=this.contextValue??null),r("comments")&&(c.comments=this._comments.map(o=>h(this,o,this._commentsMap))),r("collapsibleState")&&(c.collapseState=a(this._collapseState)),r("canReply")&&(c.canReply=this.canReply),this.modifications={},F.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(r){for(let c of this._commentsMap){let o=c[0],d=c[1];if(r===d)return o}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(r=>r.dispose())}}u._handlePool=0,je([(0,t.debounce)(100)],u.prototype,"eventuallyUpdateCommentThread",null);class s{constructor(r,c,o,d){this._extension=r,this._handle=c,this._id=o,this._label=d,this._threads=new Map,F.$registerCommentController(this.handle,o,d);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(v){m.options=v},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(v){m.commentingRangeProvider=v},get reactionHandler(){return m.reactionHandler},set reactionHandler(v){m.reactionHandler=v},createCommentThread(v,w,A){return m.createCommentThread(v,w,A).value},dispose:()=>{m.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{F.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(r){this._commentingRangeProvider=r,F.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(r){this._reactionHandler=r,F.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!r})}get options(){return this._options}set options(r){this._options=r,F.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(r,c,o,d){if(typeof r=="string"){const m=new u(this.id,this.handle,r,c,o,d,this._extension);return this._threads.set(m.handle,m),m}else{const m=new u(this.id,this.handle,void 0,r,c,o,this._extension);return this._threads.set(m.handle,m),m}}$createCommentThreadTemplate(r,c){const o=new u(this.id,this.handle,void 0,R.URI.revive(r),P.Range.to(c),[],this._extension);return o.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(o.handle,o),o}$updateCommentThreadTemplate(r,c){let o=this._threads.get(r);o&&(o.range=P.Range.to(c))}$deleteCommentThread(r){let c=this._threads.get(r);c&&c.dispose(),this._threads.delete(r)}getCommentThread(r){return this._threads.get(r)}dispose(){this._threads.forEach(r=>{r.dispose()}),this._localDisposables.forEach(r=>r.dispose())}}function h(i,r,c){let o=c.get(r);o||(o=++i.commentHandle,c.set(r,o));const d=r.author&&r.author.iconPath?r.author.iconPath.toString():void 0;r.detail&&(0,C.checkProposedApiEnabled)(i.extensionDescription,"commentTimestamp");let m;return r.detail&&typeof r.detail!="string"?m={source:r.detail,$mid:14}:m=r.detail,{mode:r.mode,contextValue:r.contextValue,uniqueIdInThread:o,body:P.MarkdownString.from(r.body),userName:r.author.name,userIconPath:d,label:r.label,commentReactions:r.reactions?r.reactions.map(v=>n(v)):void 0,detail:m}}function n(i){return{label:i.label,iconPath:i.iconPath?P.pathOrURIToURI(i.iconPath):void 0,count:i.count,hasReacted:i.authorHasReacted}}function S(i){return{label:i.label||"",count:i.count||0,iconPath:i.iconPath?R.URI.revive(i.iconPath):"",authorHasReacted:i.hasReacted||!1}}function a(i){if(i!==void 0)switch(i){case L.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new D}e.createExtHostComments=b}),define(pe[132],ve([0,1,2,5,7,4,14,11,17,8,9]),function(Z,e,f,t,I,_,R,k,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class yi{constructor(b,p){this._logService=p,this._provider=new Map,this._proxy=b.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(b,p){const g=yi._handlePool++;this._provider.set(g,{provider:b,extensionId:p}),this._proxy.$registerDecorationProvider(g,p.value);const E=b.onDidChangeFileDecorations&&b.onDidChangeFileDecorations(F=>{if(!F){this._proxy.$onDidChange(g,null);return}let D=(0,y.asArray)(F);if(D.length<=yi._maxEventSize){this._proxy.$onDidChange(g,D);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",p.value,D.length);const u=D.map(n=>({uri:n,rank:(0,P.count)(n.path,"/")})),s=(0,y.groupBy)(u,(n,S)=>n.rank-S.rank||(0,P.compare)(n.uri.path,S.uri.path));let h=[];e:for(let n of s){let S;for(let a of n){let i=(0,L.dirname)(a.uri.path);if(S!==i&&(S=i,h.push(a.uri)>=yi._maxEventSize))break e}}this._proxy.$onDidChange(g,h)});return new I.Disposable(()=>{E?.dispose(),this._proxy.$unregisterDecorationProvider(g),this._provider.delete(g)})}async $provideDecorations(b,p,g){if(!this._provider.has(b))return Object.create(null);const E=Object.create(null),{provider:F,extensionId:D}=this._provider.get(b);return await Promise.all(p.map(async u=>{try{const{uri:s,id:h}=u,n=await Promise.resolve(F.provideFileDecoration(f.URI.revive(s),g));if(!n)return;try{I.FileDecoration.validate(n),E[h]=[n.propagate,n.tooltip,n.badge,n.color]}catch(S){this._logService.warn(`INVALID decoration from extension '${D.value}': ${S}`)}}catch(s){this._logService.error(s)}})),E}};C._handlePool=0,C._maxEventSize=250,C=je([ze(0,R.IExtHostRpcService),ze(1,k.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,_.createDecorator)("IExtHostDecorations")});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[232],ve([0,1,164,117,2,5,7,15,3,11,24,44]),function(Z,e,f,t,I,_,R,k,y,P,L,C){"use strict";var l,b,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class g{constructor(D,u,s,h,n,S){this._name=D,this._owner=u,this._maxDiagnosticsPerFile=s,l.set(this,void 0),b.set(this,void 0),p.set(this,void 0),this._isDisposed=!1,nt(this,p,new L.ResourceMap(a=>h.getComparisonKey(a)),"f"),nt(this,l,n,"f"),nt(this,b,S,"f")}dispose(){this._isDisposed||(Le(this,b,"f").fire([...Le(this,p,"f").keys()]),Le(this,l,"f")&&Le(this,l,"f").$clear(this._owner),Le(this,p,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(D,u){if(!D){this.clear();return}this._checkDisposed();let s=[];if(I.URI.isUri(D)){if(!u){this.delete(D);return}Le(this,p,"f").set(D,u.slice()),s=[D]}else if(Array.isArray(D)){s=[];let n;D=[...D].sort(g._compareIndexedTuplesByUri);for(const S of D){const[a,i]=S;if((!n||a.toString()!==n.toString())&&(n&&Le(this,p,"f").get(n).length===0&&Le(this,p,"f").delete(n),n=a,s.push(a),Le(this,p,"f").set(a,[])),i){const r=Le(this,p,"f").get(a);r&&r.push(...i)}else{const r=Le(this,p,"f").get(a);r&&(r.length=0)}}}if(Le(this,b,"f").fire(s),!Le(this,l,"f"))return;const h=[];for(let n of s){let S=[];const a=Le(this,p,"f").get(n);if(a)if(a.length>this._maxDiagnosticsPerFile){S=[];const i=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(let c of a)if(c.severity===i[r]&&S.push(k.Diagnostic.from(c))===this._maxDiagnosticsPerFile)break e;S.push({severity:t.MarkerSeverity.Info,message:(0,f.localize)(0,null,a.length-this._maxDiagnosticsPerFile),startLineNumber:S[S.length-1].startLineNumber,startColumn:S[S.length-1].startColumn,endLineNumber:S[S.length-1].endLineNumber,endColumn:S[S.length-1].endColumn})}else S=a.map(i=>k.Diagnostic.from(i));h.push([n,S])}Le(this,l,"f").$changeMany(this._owner,h)}delete(D){this._checkDisposed(),Le(this,b,"f").fire([D]),Le(this,p,"f").delete(D),Le(this,l,"f")&&Le(this,l,"f").$changeMany(this._owner,[[D,void 0]])}clear(){this._checkDisposed(),Le(this,b,"f").fire([...Le(this,p,"f").keys()]),Le(this,p,"f").clear(),Le(this,l,"f")&&Le(this,l,"f").$clear(this._owner)}forEach(D,u){this._checkDisposed();for(let s of Le(this,p,"f").keys())D.apply(u,[s,this.get(s),this])}get(D){this._checkDisposed();const u=Le(this,p,"f").get(D);return Array.isArray(u)?Object.freeze(u.slice(0)):[]}has(D){return this._checkDisposed(),Array.isArray(Le(this,p,"f").get(D))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(D,u){return D[0].toString()<u[0].toString()?-1:D[0].toString()>u[0].toString()?1:0}}e.DiagnosticCollection=g,l=new WeakMap,b=new WeakMap,p=new WeakMap;let E=class oi{constructor(D,u,s){this._logService=u,this._fileSystemInfoService=s,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:h=>h.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,oi._mapper),this._proxy=D.getProxy(_.MainContext.MainThreadDiagnostics)}static _mapper(D){const u=new L.ResourceMap;for(const s of D)u.set(s,s);return{uris:Object.freeze(Array.from(u.values()))}}createDiagnosticCollection(D,u){const{_collections:s,_proxy:h,_onDidChangeDiagnostics:n,_logService:S,_fileSystemInfoService:a}=this,i=new class{$changeMany(o,d){h.$changeMany(o,d),S.trace("[DiagnosticCollection] change many (extension, owner, uris)",D.value,o,d.length===0?"CLEARING":d)}$clear(o){h.$clear(o),S.trace("[DiagnosticCollection] remove all (extension, owner)",D.value,o)}dispose(){h.dispose()}};let r;if(!u)u="_generated_diagnostic_collection_name_#"+oi._idPool++,r=u;else if(!s.has(u))r=u;else{this._logService.warn(`DiagnosticCollection with name '${u}' does already exist.`);do r=u+oi._idPool++;while(s.has(r))}return new class extends g{constructor(){super(u,r,oi._maxDiagnosticsPerFile,a.extUri,i,n);s.set(r,this)}dispose(){super.dispose(),s.delete(r)}}}getDiagnostics(D){if(D)return this._getDiagnostics(D);{const u=new Map,s=[];for(const h of this._collections.values())h.forEach((n,S)=>{let a=u.get(n.toString());typeof a=="undefined"&&(a=s.length,u.set(n.toString(),a),s.push([n,[]])),s[a][1]=s[a][1].concat(...S)});return s}}_getDiagnostics(D){let u=[];for(let s of this._collections.values())s.has(D)&&(u=u.concat(s.get(D)));return u}$acceptMarkersChange(D){if(!this._mirrorCollection){const u="_generated_mirror",s=new g(u,u,oi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(u,s),this._mirrorCollection=s}for(const[u,s]of D)this._mirrorCollection.set(I.URI.revive(u),s.map(k.Diagnostic.to))}};E._idPool=0,E._maxDiagnosticsPerFile=1e3,E=je([ze(1,P.ILogService),ze(2,C.IExtHostFileSystemInfo)],E),e.ExtHostDiagnostics=E}),define(pe[233],ve([0,1,2,5]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(R){this._proxy=R.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(R){return this._proxy.$showOpenDialog(R).then(k=>k?k.map(y=>f.URI.revive(y)):void 0)}showSaveDialog(R){return this._proxy.$showSaveDialog(R).then(k=>k?f.URI.revive(k):void 0)}}e.ExtHostDialogs=I}),define(pe[234],ve([0,1,16,2,7,5,10,21,8]),function(Z,e,f,t,I,_,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(C,l,b){this._documentsAndEditors=l,this._logService=b,this._documentContentProviders=new Map,this._proxy=C.getProxy(_.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,l){if(Object.keys(R.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const b=P._handlePool++;this._documentContentProviders.set(b,l),this._proxy.$registerTextContentProvider(b,C);let p;return typeof l.onDidChange=="function"&&(p=l.onDidChange(g=>{if(g.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(g)&&this.$provideTextDocumentContent(b,g).then(E=>{if(!E&&typeof E!="string")return;const F=this._documentsAndEditors.getDocument(g);if(!F)return;const D=(0,y.splitLines)(E);if(!F.equalLines(D))return this._proxy.$onVirtualDocumentChange(g,E)},f.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(b)&&this._proxy.$unregisterTextContentProvider(b),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(C,l){const b=this._documentContentProviders.get(C);return b?Promise.resolve(b.provideTextDocumentContent(t.URI.revive(l),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(pe[235],ve([0,1,3,6,2,5,124,15,18,25,7]),function(Z,e,f,t,I,_,R,k,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class C{constructor(b,p){this._onDidAddDocument=new f.Emitter,this._onDidRemoveDocument=new f.Emitter,this._onDidChangeDocument=new f.Emitter,this._onDidSaveDocument=new f.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=b.getProxy(_.MainContext.MainThreadDocuments),this._documentsAndEditors=p,this._documentsAndEditors.onDidRemoveDocuments(g=>{for(const E of g)this._onDidRemoveDocument.fire(E.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(g=>{for(const E of g)this._onDidAddDocument.fire(E.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(b){if(!b)return;const p=this._documentsAndEditors.getDocument(b);if(p)return p}getDocument(b){const p=this.getDocumentData(b);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return p.document}ensureDocumentData(b){const p=this._documentsAndEditors.getDocument(b);if(p)return Promise.resolve(p);let g=this._documentLoader.get(b.toString());return g||(g=this._proxy.$tryOpenDocument(b).then(E=>{this._documentLoader.delete(b.toString());const F=I.URI.revive(E);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(F))},E=>(this._documentLoader.delete(b.toString()),Promise.reject(E))),this._documentLoader.set(b.toString(),g)),g}createDocumentData(b){return this._proxy.$tryCreateDocument(b).then(p=>I.URI.revive(p))}$acceptModelLanguageChanged(b,p){const g=I.URI.revive(b),E=this._documentsAndEditors.getDocument(g);if(!E)throw new Error("unknown document");this._onDidRemoveDocument.fire(E.document),E._acceptLanguageId(p),this._onDidAddDocument.fire(E.document)}$acceptModelSaved(b){const p=I.URI.revive(b),g=this._documentsAndEditors.getDocument(p);if(!g)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this._onDidSaveDocument.fire(g.document)}$acceptDirtyStateChanged(b,p){const g=I.URI.revive(b),E=this._documentsAndEditors.getDocument(g);if(!E)throw new Error("unknown document");E._acceptIsDirty(p),this._onDidChangeDocument.fire({document:E.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,p,g){const E=I.URI.revive(b),F=this._documentsAndEditors.getDocument(E);if(!F)throw new Error("unknown document");F._acceptIsDirty(g),F.onEvents(p);let D;p.isUndoing?D=L.TextDocumentChangeReason.Undo:p.isRedoing&&(D=L.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:F.document,contentChanges:p.changes.map(u=>({range:k.Range.to(u.range),rangeOffset:u.rangeOffset,rangeLength:u.rangeLength,text:u.text})),reason:D}))}setWordDefinitionFor(b,p){(0,R.setWordDefinitionFor)(b,p)}}e.ExtHostDocuments=C}),define(pe[45],ve([0,1,55,3,6,2,4,5,124,14,131,15,11,24,10,78,92]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class F{constructor(s){this.value=s,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let D=class{constructor(s,h){this._extHostRpc=s,this._logService=h,this._activeEditorId=null,this._editors=new Map,this._documents=new b.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const h=[],n=[],S=[];if(s.removedDocuments)for(const a of s.removedDocuments){const i=_.URI.revive(a),r=this._documents.get(i);r?.unref()&&(this._documents.delete(i),h.push(r.value))}if(s.addedDocuments)for(const a of s.addedDocuments){const i=_.URI.revive(a.uri);let r=this._documents.get(i);if(r&&i.scheme!==p.Schemas.vscodeNotebookCell&&i.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);r||(r=new F(new y.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),i,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this._documents.set(i,r),n.push(r.value)),r.ref()}if(s.removedEditors)for(const a of s.removedEditors){const i=this._editors.get(a);this._editors.delete(a),i&&S.push(i)}if(s.addedEditors)for(const a of s.addedEditors){const i=_.URI.revive(a.documentUri);f.ok(this._documents.has(i),`document '${i}' does not exist`),f.ok(!this._editors.has(a.id),`editor '${a.id}' already exists!`);const r=this._documents.get(i).value,c=new L.ExtHostTextEditor(a.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new E.Lazy(()=>r.document),a.selections.map(C.Selection.to),a.options,a.visibleRanges.map(o=>C.Range.to(o)),typeof a.editorPosition=="number"?C.ViewColumn.to(a.editorPosition):void 0);this._editors.set(a.id,c)}s.newActiveEditor!==void 0&&(f.ok(s.newActiveEditor===null||this._editors.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this._activeEditorId=s.newActiveEditor),(0,I.dispose)(h),(0,I.dispose)(S),s.removedDocuments&&this._onDidRemoveDocuments.fire(h),s.addedDocuments&&this._onDidAddDocuments.fire(n),(s.removedEditors||s.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(a=>a.value)),s.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(s){return this._documents.get(s)?.value}allDocuments(){return g.Iterable.map(this._documents.values(),s=>s.value)}getEditor(s){return this._editors.get(s)}activeEditor(s){if(!this._activeEditorId)return;const h=this._editors.get(this._activeEditorId);return s?h:h?.value}allEditors(){return[...this._editors.values()]}};D=je([ze(0,P.IExtHostRpcService),ze(1,l.ILogService)],D),e.ExtHostDocumentsAndEditors=D,e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(pe[53],ve([0,1,15,5,2,3,4,14,13]),function(Z,e,f,t,I,_,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,R.createDecorator)("IExtHostEditorTabs");let P=class{constructor(C){this._onDidChangeTabs=new _.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new _.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=C.getProxy(t.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(C){let l=-1;this._tabs=C.map((p,g)=>(p.isActive&&(l=g),Object.freeze({label:p.label,viewColumn:f.ViewColumn.to(p.viewColumn),index:g,resource:I.URI.revive(p.resource),additionalResourcesAndViewIds:p.additionalResourcesAndViewIds.map(({resource:E,viewId:F})=>({resource:I.URI.revive(E),viewId:F})),viewId:p.editorId,isActive:p.isActive,move:async(E,F)=>{this._proxy.$moveTab(p,E,f.ViewColumn.from(F)),await(0,y.raceTimeout)(_.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(p),await(0,y.raceTimeout)(_.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((p,g)=>p.viewColumn===g.viewColumn?p.index-g.index:p.viewColumn-g.viewColumn);const b=this._activeTab;this._activeTab=l===-1?void 0:this._tabs[l],this._activeTab!==b&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};P=je([ze(0,k.IExtHostRpcService)],P),e.ExtHostEditorTabs=P}),define(pe[236],ve([0,1,2,5,6,7,15,148,8,22,28]),function(Z,e,f,t,I,_,R,k,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class C{constructor(){this._schemes=[]}add(p){this._stateMachine=void 0,this._schemes.push(p)}delete(p){const g=this._schemes.indexOf(p);g>=0&&(this._schemes.splice(g,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const p=this._schemes.sort(),g=[];let E,F,D=14,u=14;for(const s of p){let h=E?(0,y.commonPrefixLength)(E,s):0;for(h===0?F=1:F=u;h<s.length;h++)h+1===s.length?(D=u,u=9):u+=1,g.push([F,s.toUpperCase().charCodeAt(h),u]),g.push([F,s.toLowerCase().charCodeAt(h),u]),F=u;E=s,u=D}g.push([9,58,10]),g.push([10,47,12]),this._stateMachine=new k.StateMachine(g)}}provideDocumentLinks(p){this._initStateMachine();const g=[],E=k.LinkComputer.computeLinks({getLineContent(F){return p.lineAt(F-1).text},getLineCount(){return p.lineCount}},this._stateMachine);for(const F of E){const D=R.DocumentLink.to(F);D.target&&g.push(D)}return g}}class l{constructor(p,g){this._extHostLanguageFeatures=g,this._linkProvider=new C,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=p.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(p,g,E,F={}){if(this._registeredSchemes.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(p,"*",this._linkProvider));const D=this._handlePool++;this._linkProvider.add(g),this._registeredSchemes.add(g),this._fsProvider.set(D,E);let u=2;F.isCaseSensitive&&(u+=1024),F.isReadonly&&(u+=2048),typeof E.copy=="function"&&(u+=8),typeof E.open=="function"&&typeof E.close=="function"&&typeof E.read=="function"&&typeof E.write=="function"&&((0,L.checkProposedApiEnabled)(p,"fsChunks"),u+=4),this._proxy.$registerFileSystemProvider(D,g,u).catch(h=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${g}`),console.error(h)});const s=E.onDidChangeFile(h=>{const n=[];for(const S of h){let{uri:a,type:i}=S;if(a.scheme!==g)continue;let r;switch(i){case _.FileChangeType.Changed:r=0;break;case _.FileChangeType.Created:r=1;break;case _.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:a,type:r})}this._proxy.$onFileSystemChange(D,n)});return(0,I.toDisposable)(()=>{s.dispose(),this._linkProvider.delete(g),this._registeredSchemes.delete(g),this._fsProvider.delete(D),this._proxy.$unregisterProvider(D)})}static _asIStat(p){const{type:g,ctime:E,mtime:F,size:D,permissions:u}=p;return{type:g,ctime:E,mtime:F,size:D,permissions:u}}$stat(p,g){return Promise.resolve(this._getFsProvider(p).stat(f.URI.revive(g))).then(E=>l._asIStat(E))}$readdir(p,g){return Promise.resolve(this._getFsProvider(p).readDirectory(f.URI.revive(g)))}$readFile(p,g){return Promise.resolve(this._getFsProvider(p).readFile(f.URI.revive(g))).then(E=>P.VSBuffer.wrap(E))}$writeFile(p,g,E,F){return Promise.resolve(this._getFsProvider(p).writeFile(f.URI.revive(g),E.buffer,F))}$delete(p,g,E){return Promise.resolve(this._getFsProvider(p).delete(f.URI.revive(g),E))}$rename(p,g,E,F){return Promise.resolve(this._getFsProvider(p).rename(f.URI.revive(g),f.URI.revive(E),F))}$copy(p,g,E,F){const D=this._getFsProvider(p);if(!D.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(D.copy(f.URI.revive(g),f.URI.revive(E),F))}$mkdir(p,g){return Promise.resolve(this._getFsProvider(p).createDirectory(f.URI.revive(g)))}$watch(p,g,E,F){const D=this._getFsProvider(p).watch(f.URI.revive(E),F);this._watches.set(g,D)}$unwatch(p,g){const E=this._watches.get(g);E&&(E.dispose(),this._watches.delete(g))}$open(p,g,E){const F=this._getFsProvider(p);if(!F.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(F.open(f.URI.revive(g),E))}$close(p,g){const E=this._getFsProvider(p);if(!E.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(E.close(g))}$read(p,g,E,F){const D=this._getFsProvider(p);if(!D.read)throw new Error('FileSystemProvider does not implement "read"');const u=P.VSBuffer.alloc(F);return Promise.resolve(D.read(g,E,u.buffer,0,F)).then(s=>u.slice(0,s))}$write(p,g,E,F){const D=this._getFsProvider(p);if(!D.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(D.write(g,E,F.buffer,0,F.byteLength))}_getFsProvider(p){const g=this._fsProvider.get(p);if(!g){const E=new Error;throw E.name="ENOPRO",E.message="no provider",E}return g}}e.ExtHostFileSystem=l}),define(pe[67],ve([0,1,5,42,7,22,4,14,44,6]),function(Z,e,f,t,I,_,R,k,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class xt{constructor(l,b){this._fileSystemProvider=new Map,this._proxy=l.getProxy(f.MainContext.MainThreadFileSystem);const p=this;this.value=Object.freeze({async stat(g){try{const E=p._fileSystemProvider.get(g.scheme);if(!E)return await p._proxy.$stat(g);await p._proxy.$ensureActivation(g.scheme);const F=await E.stat(g);return{type:F.type,ctime:F.ctime,mtime:F.mtime,size:F.size,permissions:F.permissions}}catch(E){xt._handleError(E)}},async readDirectory(g){try{const E=p._fileSystemProvider.get(g.scheme);return E?(await p._proxy.$ensureActivation(g.scheme),(await E.readDirectory(g)).slice()):await p._proxy.$readdir(g)}catch(E){return xt._handleError(E)}},async createDirectory(g){try{return await p._proxy.$mkdir(g)}catch(E){return xt._handleError(E)}},async readFile(g){try{const E=p._fileSystemProvider.get(g.scheme);return E?(await p._proxy.$ensureActivation(g.scheme),(await E.readFile(g)).slice()):(await p._proxy.$readFile(g)).buffer}catch(E){return xt._handleError(E)}},async writeFile(g,E){try{return await p._proxy.$writeFile(g,_.VSBuffer.wrap(E))}catch(F){return xt._handleError(F)}},async delete(g,E){try{const F=p._fileSystemProvider.get(g.scheme);return F?(await p._proxy.$ensureActivation(g.scheme),await F.delete(g,{recursive:!1,...E})):await p._proxy.$delete(g,{recursive:!1,useTrash:!1,...E})}catch(F){return xt._handleError(F)}},async rename(g,E,F){try{return await p._proxy.$rename(g,E,{overwrite:!1,...F})}catch(D){return xt._handleError(D)}},async copy(g,E,F){try{return await p._proxy.$copy(g,E,{overwrite:!1,...F})}catch(D){return xt._handleError(D)}},isWritableFileSystem(g){const E=b.getCapabilities(g);if(typeof E=="number")return!(E&2048)}})}static _handleError(l){if(l instanceof I.FileSystemError)throw l;if(!(l instanceof Error))throw new I.FileSystemError(String(l));if(l.name==="ENOPRO")throw I.FileSystemError.Unavailable(l.message);switch(l.name){case t.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(l.message);case t.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(l.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(l.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(l.message);case t.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(l.message);case t.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(l.message);default:throw new I.FileSystemError(l.message,l.name)}}addFileSystemProvider(l,b){return this._fileSystemProvider.set(l,b),(0,P.toDisposable)(()=>this._fileSystemProvider.delete(l))}};L=je([ze(0,k.IExtHostRpcService),ze(1,y.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(pe[237],ve([0,1,3,32,2,5,15,7]),function(Z,e,f,t,I,_,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(C,l,b,p,g,E,F,D){this._onDidCreate=new f.Emitter,this._onDidChange=new f.Emitter,this._onDidDelete=new f.Emitter;const u=this.ensureWatching(C,b,g);this._config=0,E&&(this._config+=1),F&&(this._config+=2),D&&(this._config+=4);const s=(0,t.parse)(g),h=typeof g=="string",n=p(S=>{if(!E)for(let a of S.created){const i=I.URI.revive(a);s(i.fsPath)&&(!h||l.getWorkspaceFolder(i))&&this._onDidCreate.fire(i)}if(!F)for(let a of S.changed){const i=I.URI.revive(a);s(i.fsPath)&&(!h||l.getWorkspaceFolder(i))&&this._onDidChange.fire(i)}if(!D)for(let a of S.deleted){const i=I.URI.revive(a);s(i.fsPath)&&(!h||l.getWorkspaceFolder(i))&&this._onDidDelete.fire(i)}});this._disposable=k.Disposable.from(u,this._onDidCreate,this._onDidChange,this._onDidDelete,n)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(C,l,b){let p=k.Disposable.from();if(typeof b=="string")return p;const g=C.getProxy(_.MainContext.MainThreadFileSystem);let E=!1;(b.pattern.includes(t.GLOBSTAR)||b.pattern.includes(t.GLOB_SPLIT))&&(E=!0);const F=Math.random();return g.$watch(l.identifier.value,F,b.baseUri,{recursive:E,excludes:[]}),k.Disposable.from({dispose:()=>g.$unwatch(F)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class P{constructor(C,l,b){this._mainContext=C,this._logService=l,this._extHostDocumentsAndEditors=b,this._onFileSystemEvent=new f.Emitter,this._onDidRenameFile=new f.Emitter,this._onDidCreateFile=new f.Emitter,this._onDidDeleteFile=new f.Emitter,this._onWillRenameFile=new f.AsyncEmitter,this._onWillCreateFile=new f.AsyncEmitter,this._onWillDeleteFile=new f.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,l,b,p,g,E){return new y(this._mainContext,C,l,this._onFileSystemEvent.event,R.GlobPattern.from(b),p,g,E)}$onFileEvent(C){this._onFileSystemEvent.fire(C)}$onDidRunFileOperation(C,l){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:l.map(b=>({oldUri:I.URI.revive(b.source),newUri:I.URI.revive(b.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:l.map(b=>I.URI.revive(b.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:l.map(b=>I.URI.revive(b.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,l){return(b,p,g)=>{const E=function(D){b.call(p,D)};return E.extension=C,l.event(E,void 0,g)}}async $onWillRunFileOperation(C,l,b,p){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:l.map(g=>({oldUri:I.URI.revive(g.source),newUri:I.URI.revive(g.target)}))},b,p);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:l.map(g=>I.URI.revive(g.target))},b,p);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:l.map(g=>I.URI.revive(g.target))},b,p)}}async _fireWillEvent(C,l,b,p){const g=new Set,E=[];if(await C.fireAsync(l,p,async(D,u)=>{const s=Date.now(),h=await Promise.resolve(D);h instanceof k.WorkspaceEdit&&(E.push(h),g.add(u.extension.displayName??u.extension.identifier.value)),Date.now()-s>b&&this._logService.warn("SLOW file-participant",u.extension.identifier)}),p.isCancellationRequested||E.length===0)return;const F={edits:[]};for(let D of E){let{edits:u}=R.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);F.edits=F.edits.concat(u)}return{edit:F,extensionNames:Array.from(g)}}}e.ExtHostFileSystemEventService=P}),define(pe[238],ve([0,1,2,38]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(R,k,y,P){this._extHostNotebooks=k,this._textDocumentsAndEditors=y,this._commands=P;const L=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",C=>!0,C=>C),new t.ApiCommandArgument("resource","Interactive resource Uri",C=>!0,C=>C),new t.ApiCommandArgument("controllerId","Notebook controller Id",C=>!0,C=>C),new t.ApiCommandArgument("title","Interactive editor title",C=>!0,C=>C)],new t.ApiCommandResult("Notebook and input URI",C=>{if(C.notebookEditorId!==void 0){const l=this._extHostNotebooks.getEditorById(C.notebookEditorId);return{notebookUri:f.URI.revive(C.notebookUri),inputUri:f.URI.revive(C.inputUri),notebookEditor:l.apiEditor}}return{notebookUri:f.URI.revive(C.notebookUri),inputUri:f.URI.revive(C.inputUri)}}));this._commands.registerApiCommand(L)}$willAddInteractiveDocument(R,k,y,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:y,uri:R,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(f.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=I}),define(pe[239],ve([0,1,6,5]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(R){this._handlePool=0,this._proxy=R.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,R),(0,f.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=I}),define(pe[240],ve([0,1,2,25,15,7,5,8,41,17,18,146,21,6,111,77,86,46,16,3,13]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p,g,E,F,D,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class h{constructor(q,te){this._documents=q,this._provider=te}async provideDocumentSymbols(q,te){const G=this._documents.getDocument(q),Q=await this._provider.provideDocumentSymbols(G,te);if(!(0,P.isFalsyOrEmpty)(Q))return Q[0]instanceof _.DocumentSymbol?Q.map(I.DocumentSymbol.from):h._asDocumentSymbolTree(Q)}static _asDocumentSymbolTree(q){q=q.slice(0).sort((Q,oe)=>{let me=Q.location.range.start.compareTo(oe.location.range.start);return me===0&&(me=oe.location.range.end.compareTo(Q.location.range.end)),me});const te=[],G=[];for(const Q of q){const oe={name:Q.name||"!!MISSING: name!!",kind:I.SymbolKind.from(Q.kind),tags:Q.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:I.Range.from(Q.location.range),selectionRange:I.Range.from(Q.location.range),children:[]};for(;;){if(G.length===0){G.push(oe),te.push(oe);break}const me=G[G.length-1];if(y.Range.containsRange(me.range,oe.range)&&!y.Range.equalsRange(me.range,oe.range)){me.children&&me.children.push(oe),G.push(oe);break}G.pop()}}return te}}class n{constructor(q,te,G){this._documents=q,this._commands=te,this._provider=G,this._cache=new E.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(q,te){const G=this._documents.getDocument(q),Q=await this._provider.provideCodeLenses(G,te);if(!Q||te.isCancellationRequested)return;const oe=this._cache.add(Q),me=new b.DisposableStore;this._disposables.set(oe,me);const Ie={cacheId:oe,lenses:[]};for(let We=0;We<Q.length;We++)Ie.lenses.push({cacheId:[oe,We],range:I.Range.from(Q[We].range),command:this._commands.toInternal(Q[We].command,me)});return Ie}async resolveCodeLens(q,te){const G=q.cacheId&&this._cache.get(...q.cacheId);if(!G)return;let Q;if(typeof this._provider.resolveCodeLens!="function"||G.isResolved?Q=G:Q=await this._provider.resolveCodeLens(G,te),Q||(Q=G),te.isCancellationRequested)return;const oe=q.cacheId&&this._disposables.get(q.cacheId[0]);if(!!oe)return q.command=this._commands.toInternal(Q.command??n._badCmd,oe),q}releaseCodeLenses(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}}n._badCmd={command:"missing",title:"!!MISSING: command!!"};function S(Je){return Array.isArray(Je)?Je.map(I.DefinitionLink.from):Je?[I.DefinitionLink.from(Je)]:[]}class a{constructor(q,te){this._documents=q,this._provider=te}async provideDefinition(q,te,G){const Q=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.provideDefinition(Q,oe,G);return S(me)}}class i{constructor(q,te){this._documents=q,this._provider=te}async provideDeclaration(q,te,G){const Q=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.provideDeclaration(Q,oe,G);return S(me)}}class r{constructor(q,te){this._documents=q,this._provider=te}async provideImplementation(q,te,G){const Q=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.provideImplementation(Q,oe,G);return S(me)}}class c{constructor(q,te){this._documents=q,this._provider=te}async provideTypeDefinition(q,te,G){const Q=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.provideTypeDefinition(Q,oe,G);return S(me)}}class o{constructor(q,te){this._documents=q,this._provider=te}async provideHover(q,te,G){const Q=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.provideHover(Q,oe,G);if(!(!me||(0,P.isFalsyOrEmpty)(me.contents)))return me.range||(me.range=Q.getWordRangeAtPosition(oe)),me.range||(me.range=new _.Range(oe,oe)),I.Hover.from(me)}}class d{constructor(q,te){this._documents=q,this._provider=te}async provideEvaluatableExpression(q,te,G){const Q=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.provideEvaluatableExpression(Q,oe,G);if(me)return I.EvaluatableExpression.from(me)}}class m{constructor(q,te){this._documents=q,this._provider=te}async provideInlineValues(q,te,G,Q){const oe=this._documents.getDocument(q),me=await this._provider.provideInlineValues(oe,I.Range.to(te),I.InlineValueContext.to(G),Q);if(Array.isArray(me))return me.map(Ie=>I.InlineValue.from(Ie))}}class v{constructor(q,te){this._documents=q,this._provider=te}async provideDocumentHighlights(q,te,G){const Q=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.provideDocumentHighlights(Q,oe,G);if(Array.isArray(me))return me.map(I.DocumentHighlight.from)}}class w{constructor(q,te){this._documents=q,this._provider=te}async provideLinkedEditingRanges(q,te,G){const Q=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.provideLinkedEditingRanges(Q,oe,G);if(me&&Array.isArray(me.ranges))return{ranges:(0,P.coalesce)(me.ranges.map(I.Range.from)),wordPattern:me.wordPattern}}}class A{constructor(q,te){this._documents=q,this._provider=te}async provideReferences(q,te,G,Q){const oe=this._documents.getDocument(q),me=I.Position.to(te),Ie=await this._provider.provideReferences(oe,me,G,Q);if(Array.isArray(Ie))return Ie.map(I.location.from)}}class M{constructor(q,te,G,Q,oe,me,Ie){this._documents=q,this._commands=te,this._diagnostics=G,this._provider=Q,this._logService=oe,this._extension=me,this._apiDeprecation=Ie,this._cache=new E.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(q,te,G,Q){const oe=this._documents.getDocument(q),me=C.Selection.isISelection(te)?I.Selection.to(te):I.Range.to(te),Ie=[];for(const tt of this._diagnostics.getDiagnostics(q))if(me.intersection(tt.range)&&Ie.push(tt)>M._maxCodeActionsPerFile)break;const We={diagnostics:Ie,only:G.only?new _.CodeActionKind(G.only):void 0,triggerKind:I.CodeActionTriggerKind.to(G.trigger)},Ye=await this._provider.provideCodeActions(oe,me,We,Q);if(!(0,P.isNonEmptyArray)(Ye)||Q.isCancellationRequested)return;const it=this._cache.add(Ye),st=new b.DisposableStore;this._disposables.set(it,st);const ot=[];for(let tt=0;tt<Ye.length;tt++){const rt=Ye[tt];!rt||(M._isCommand(rt)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ot.push({_isSynthetic:!0,title:rt.title,command:this._commands.toInternal(rt,st)})):(We.only&&(rt.kind?We.only.contains(rt.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${We.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${We.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ot.push({cacheId:[it,tt],title:rt.title,command:rt.command&&this._commands.toInternal(rt.command,st),diagnostics:rt.diagnostics&&rt.diagnostics.map(I.Diagnostic.from),edit:rt.edit&&I.WorkspaceEdit.from(rt.edit),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,disabled:rt.disabled?.reason})))}return{cacheId:it,actions:ot}}async resolveCodeAction(q,te){const[G,Q]=q,oe=this._cache.get(G,Q);if(!oe||M._isCommand(oe)||!this._provider.resolveCodeAction)return;const me=await this._provider.resolveCodeAction(oe,te)??oe;return me?.edit?I.WorkspaceEdit.from(me.edit):void 0}releaseCodeActions(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}static _isCommand(q){return typeof q.command=="string"&&typeof q.title=="string"}}M._maxCodeActionsPerFile=1e3;class T{constructor(q,te){this._documents=q,this._provider=te}async provideDocumentFormattingEdits(q,te,G){const Q=this._documents.getDocument(q),oe=await this._provider.provideDocumentFormattingEdits(Q,te,G);if(Array.isArray(oe))return oe.map(I.TextEdit.from)}}class O{constructor(q,te){this._documents=q,this._provider=te}async provideDocumentRangeFormattingEdits(q,te,G,Q){const oe=this._documents.getDocument(q),me=I.Range.to(te),Ie=await this._provider.provideDocumentRangeFormattingEdits(oe,me,G,Q);if(Array.isArray(Ie))return Ie.map(I.TextEdit.from)}}class U{constructor(q,te){this._documents=q,this._provider=te,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,te,G,Q,oe){const me=this._documents.getDocument(q),Ie=I.Position.to(te),We=await this._provider.provideOnTypeFormattingEdits(me,Ie,G,Q,oe);if(Array.isArray(We))return We.map(I.TextEdit.from)}}class V{constructor(q,te){this._provider=q,this._logService=te,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(q,te){const G=R.IdObject.mixin({symbols:[]}),Q=await this._provider.provideWorkspaceSymbols(q,te);if((0,P.isNonEmptyArray)(Q))for(const oe of Q){if(!oe)continue;if(!oe.name){this._logService.warn("INVALID SymbolInformation, lacks name",oe);continue}const me=R.IdObject.mixin(I.WorkspaceSymbol.from(oe));this._symbolCache.set(me._id,oe),G.symbols.push(me)}return G.symbols.length>0&&this._resultCache.set(G._id,[G.symbols[0]._id,G.symbols[G.symbols.length-1]._id]),G}async resolveWorkspaceSymbol(q,te){if(typeof this._provider.resolveWorkspaceSymbol!="function")return q;const G=this._symbolCache.get(q._id);if(G){const Q=await this._provider.resolveWorkspaceSymbol(G,te);return Q&&(0,t.mixin)(q,I.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(q){const te=this._resultCache.get(q);if(te){for(let[G,Q]=te;G<=Q;G++)this._symbolCache.delete(G);this._resultCache.delete(q)}}}class x{constructor(q,te,G){this._documents=q,this._provider=te,this._logService=G}static supportsResolving(q){return typeof q.prepareRename=="function"}async provideRenameEdits(q,te,G,Q){const oe=this._documents.getDocument(q),me=I.Position.to(te);try{const Ie=await this._provider.provideRenameEdits(oe,me,G,Q);return Ie?I.WorkspaceEdit.from(Ie):void 0}catch(Ie){const We=x._asMessage(Ie);return We?{rejectReason:We,edits:void 0}:Promise.reject(Ie)}}async resolveRenameLocation(q,te,G){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const Q=this._documents.getDocument(q),oe=I.Position.to(te);try{const me=await this._provider.prepareRename(Q,oe,G);let Ie,We;if(_.Range.isRange(me)?(Ie=me,We=Q.getText(me)):(0,L.isObject)(me)&&(Ie=me.range,We=me.placeholder),!Ie||!We)return;if(Ie.start.line>oe.line||Ie.end.line<oe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(Ie),text:We}}catch(me){const Ie=x._asMessage(me);return Ie?{rejectReason:Ie,range:void 0,text:void 0}:Promise.reject(me)}}static _asMessage(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class N{constructor(q,te){this.resultId=q,this.tokens=te}}class B{constructor(q,te){this._documents=q,this._provider=te,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(q,te,G){const Q=this._documents.getDocument(q),oe=te!==0?this._previousResults.get(te):null;let me=typeof oe?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(Q,oe.resultId,G):await this._provider.provideDocumentSemanticTokens(Q,G);return oe&&this._previousResults.delete(te),me?(me=B._fixProvidedSemanticTokens(me),this._send(B._convertToEdits(oe,me),me)):null}async releaseDocumentSemanticColoring(q){this._previousResults.delete(q)}static _fixProvidedSemanticTokens(q){return B._isSemanticTokens(q)?B._isCorrectSemanticTokens(q)?q:new _.SemanticTokens(new Uint32Array(q.data),q.resultId):B._isSemanticTokensEdits(q)?B._isCorrectSemanticTokensEdits(q)?q:new _.SemanticTokensEdits(q.edits.map(te=>new _.SemanticTokensEdit(te.start,te.deleteCount,te.data?new Uint32Array(te.data):te.data)),q.resultId):q}static _isSemanticTokens(q){return q&&!!q.data}static _isCorrectSemanticTokens(q){return q.data instanceof Uint32Array}static _isSemanticTokensEdits(q){return q&&Array.isArray(q.edits)}static _isCorrectSemanticTokensEdits(q){for(const te of q.edits)if(!(te.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(q,te){if(!B._isSemanticTokens(te)||!q||!q.tokens)return te;const G=q.tokens,Q=G.length,oe=te.data,me=oe.length;let Ie=0;const We=Math.min(Q,me);for(;Ie<We&&G[Ie]===oe[Ie];)Ie++;if(Ie===Q&&Ie===me)return new _.SemanticTokensEdits([],te.resultId);let Ye=0;const it=We-Ie;for(;Ye<it&&G[Q-Ye-1]===oe[me-Ye-1];)Ye++;return new _.SemanticTokensEdits([{start:Ie,deleteCount:Q-Ie-Ye,data:oe.subarray(Ie,me-Ye)}],te.resultId)}_send(q,te){if(B._isSemanticTokens(q)){const G=this._nextResultId++;return this._previousResults.set(G,new N(q.resultId,q.data)),(0,p.encodeSemanticTokensDto)({id:G,type:"full",data:q.data})}if(B._isSemanticTokensEdits(q)){const G=this._nextResultId++;return B._isSemanticTokens(te)?this._previousResults.set(G,new N(te.resultId,te.data)):this._previousResults.set(G,new N(q.resultId)),(0,p.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(q.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}e.DocumentSemanticTokensAdapter=B;class W{constructor(q,te){this._documents=q,this._provider=te}async provideDocumentRangeSemanticTokens(q,te,G){const Q=this._documents.getDocument(q),oe=await this._provider.provideDocumentRangeSemanticTokens(Q,I.Range.to(te),G);return oe?this._send(oe):null}_send(q){return(0,p.encodeSemanticTokensDto)({id:0,type:"full",data:q.data})}}e.DocumentRangeSemanticTokensAdapter=W;class H{constructor(q,te,G,Q,oe){this._documents=q,this._commands=te,this._provider=G,this._apiDeprecation=Q,this._extension=oe,this._cache=new E.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}async provideCompletionItems(q,te,G,Q){const oe=this._documents.getDocument(q),me=I.Position.to(te),Ie=oe.getWordRangeAtPosition(me)||new _.Range(me,me),We=Ie.with({end:me}),Ye=new F.StopWatch(!0),it=await this._provider.provideCompletionItems(oe,me,Q,I.CompletionContext.to(G));if(!it||Q.isCancellationRequested)return;const st=Array.isArray(it)?new _.CompletionList(it):it,ot=H.supportsResolving(this._provider)?this._cache.add(st.items):this._cache.add([]),tt=new b.DisposableStore;this._disposables.set(ot,tt);const rt=[],gt={x:ot,b:rt,a:{replace:I.Range.from(Ie),insert:I.Range.from(We)},c:st.isIncomplete||void 0,d:Ye.elapsed()};for(let Ue=0;Ue<st.items.length;Ue++){const It=st.items[Ue],ee=this._convertCompletionItem(It,[ot,Ue],We,Ie);rt.push(ee)}return gt}async resolveCompletionItem(q,te){if(typeof this._provider.resolveCompletionItem!="function")return;const G=this._cache.get(...q);if(!G)return;const Q=await this._provider.resolveCompletionItem(G,te);if(!!Q)return this._convertCompletionItem(Q,q)}releaseCompletionItems(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}_convertCompletionItem(q,te,G,Q){const oe=this._disposables.get(te[0]);if(!oe)throw Error("DisposableStore is missing...");const me={x:te,a:q.label,b:q.kind!==void 0?I.CompletionItemKind.from(q.kind):void 0,n:q.tags&&q.tags.map(I.CompletionItemTag.from),c:q.detail,d:typeof q.documentation=="undefined"?void 0:I.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters,l:q.additionalTextEdits&&q.additionalTextEdits.map(I.TextEdit.from),m:this._commands.toInternal(q.command,oe)};q.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),me.h=q.textEdit.newText):typeof q.insertText=="string"?me.h=q.insertText:q.insertText instanceof _.SnippetString&&(me.h=q.insertText.value,me.i|=4);let Ie;return q.textEdit?Ie=q.textEdit.range:q.range&&(Ie=q.range),_.Range.isRange(Ie)?me.j=I.Range.from(Ie):Ie&&(!G?.isEqual(Ie.inserting)||!Q?.isEqual(Ie.replacing))&&(me.j={insert:I.Range.from(Ie.inserting),replace:I.Range.from(Ie.replacing)}),me}}class z{constructor(q,te,G){this._documents=q,this._provider=te,this._commands=G,this._cache=new E.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(q,te,G,Q){const oe=this._documents.getDocument(q),me=I.Position.to(te),Ie=await this._provider.provideInlineCompletionItems(oe,me,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:I.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text,isSnippetText:G.selectedSuggestionInfo.isSnippetText,completionKind:I.CompletionItemKind.to(G.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:G.triggerKind},Q);if(!Ie||Q.isCancellationRequested)return;const We=(0,L.isArray)(Ie)?{items:Ie}:Ie,Ye=this._cache.add(We.items);let it;return{pid:Ye,items:We.items.map((st,ot)=>{let tt;return st.command&&(it||(it=new b.DisposableStore,this._disposables.set(Ye,it)),tt=this._commands.toInternal(st.command,it)),{text:st.text,range:st.range?I.Range.from(st.range):void 0,command:tt,idx:ot}})}}disposeCompletions(q){this._cache.delete(q);const te=this._disposables.get(q);te&&te.clear(),this._disposables.delete(q)}handleDidShowCompletionItem(q,te){const G=this._cache.get(q,te);G&&J.get(this._provider).fireOnDidShowCompletionItem({completionItem:G})}}class J{constructor(){this._onDidShowCompletionItemEmitter=new u.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(q){let te=J.map.get(q);return te||(te=new J,J.map.set(q,te)),te}fireOnDidShowCompletionItem(q){this._onDidShowCompletionItemEmitter.fire(q)}}e.InlineCompletionController=J,J.map=new WeakMap;class ie{constructor(q,te){this._documents=q,this._provider=te,this._cache=new E.Cache("SignatureHelp")}async provideSignatureHelp(q,te,G,Q){const oe=this._documents.getDocument(q),me=I.Position.to(te),Ie=this.reviveContext(G),We=await this._provider.provideSignatureHelp(oe,me,Q,Ie);if(We){const Ye=this._cache.add([We]);return{...I.SignatureHelp.from(We),id:Ye}}}reviveContext(q){let te;if(q.activeSignatureHelp){const G=I.SignatureHelp.to(q.activeSignatureHelp),Q=this._cache.get(q.activeSignatureHelp.id,0);Q?(te=Q,te.activeSignature=G.activeSignature,te.activeParameter=G.activeParameter):te=G}return{...q,activeSignatureHelp:te}}releaseSignatureHelp(q){this._cache.delete(q)}}class se{constructor(q,te,G,Q,oe){this._documents=q,this._commands=te,this._provider=G,this._logService=Q,this._extension=oe,this._cache=new E.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(q,te,G){const Q=this._documents.getDocument(q),oe=I.Range.to(te),me=await this._provider.provideInlayHints(Q,oe,G);if(!Array.isArray(me)||me.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${te}`);return}if(G.isCancellationRequested)return;const Ie=this._cache.add(me);this._disposables.set(Ie,new b.DisposableStore);const We={hints:[],cacheId:Ie};for(let Ye=0;Ye<me.length;Ye++)this._isValidInlayHint(me[Ye],oe)&&We.hints.push(this._convertInlayHint(me[Ye],[Ie,Ye]));return this._logService.trace(`[InlayHints] ${We.hints.length} inlay hints from '${this._extension.identifier.value}' for ${te}`),We}async resolveInlayHint(q,te){if(typeof this._provider.resolveInlayHint!="function")return;const G=this._cache.get(...q);if(!G)return;const Q=await this._provider.resolveInlayHint(G,te);if(!!Q&&!!this._isValidInlayHint(Q))return this._convertInlayHint(Q,q)}releaseHints(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}_isValidInlayHint(q,te){return q.label.length===0||Array.isArray(q.label)&&q.label.every(G=>G.label.length===0)?(console.log("INVALID inlay hint, empty label",q),!1):!(te&&!te.contains(q.position))}_convertInlayHint(q,te){const G=this._disposables.get(te[0]);if(!G)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:te,tooltip:q.tooltip&&I.MarkdownString.from(q.tooltip),position:I.Position.from(q.position),kind:I.InlayHintKind.from(q.kind??_.InlayHintKind.Other),whitespaceBefore:q.paddingLeft,whitespaceAfter:q.paddingRight};return typeof q.label=="string"?Q.label=q.label:Q.label=q.label.map(oe=>{let me={label:oe.label};return me.tooltip=oe.tooltip&&I.MarkdownString.from(oe.tooltip),_.Location.isLocation(oe.location)?me.location=I.location.from(oe.location):oe.command&&(me.command=this._commands.toInternal(oe.command,G)),me}),Q}}class K{constructor(q,te){this._documents=q,this._provider=te,this._cache=new E.Cache("DocumentLink")}async provideLinks(q,te){const G=this._documents.getDocument(q),Q=await this._provider.provideDocumentLinks(G,te);if(!(!Array.isArray(Q)||Q.length===0)&&!te.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:Q.filter(K._validateLink).map(I.DocumentLink.from)};{const oe=this._cache.add(Q),me={links:[],id:oe};for(let Ie=0;Ie<Q.length;Ie++){if(!K._validateLink(Q[Ie]))continue;const We=I.DocumentLink.from(Q[Ie]);We.cacheId=[oe,Ie],me.links.push(We)}return me}}}static _validateLink(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,te){if(typeof this._provider.resolveDocumentLink!="function")return;const G=this._cache.get(...q);if(!G)return;const Q=await this._provider.resolveDocumentLink(G,te);if(!(!Q||!K._validateLink(Q)))return I.DocumentLink.from(Q)}releaseLinks(q){this._cache.delete(q)}}class X{constructor(q,te){this._documents=q,this._provider=te}async provideColors(q,te){const G=this._documents.getDocument(q),Q=await this._provider.provideDocumentColors(G,te);return Array.isArray(Q)?Q.map(me=>({color:I.Color.from(me.color),range:I.Range.from(me.range)})):[]}async provideColorPresentations(q,te,G){const Q=this._documents.getDocument(q),oe=I.Range.to(te.range),me=I.Color.to(te.color),Ie=await this._provider.provideColorPresentations(me,{document:Q,range:oe},G);if(!!Array.isArray(Ie))return Ie.map(I.ColorPresentation.from)}}class ae{constructor(q,te){this._documents=q,this._provider=te}async provideFoldingRanges(q,te,G){const Q=this._documents.getDocument(q),oe=await this._provider.provideFoldingRanges(Q,te,G);if(!!Array.isArray(oe))return oe.map(I.FoldingRange.from)}}class fe{constructor(q,te,G){this._documents=q,this._provider=te,this._logService=G}async provideSelectionRanges(q,te,G){const Q=this._documents.getDocument(q),oe=te.map(I.Position.to),me=await this._provider.provideSelectionRanges(Q,oe,G);if(!(0,P.isNonEmptyArray)(me))return[];if(me.length!==oe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ie=[];for(let We=0;We<oe.length;We++){const Ye=[];Ie.push(Ye);let it=oe[We],st=me[We];for(;;){if(!st.range.contains(it))throw new Error("INVALID selection range, must contain the previous range");if(Ye.push(I.SelectionRange.from(st)),!st.parent)break;it=st.range,st=st.parent}}return Ie}}class be{constructor(q,te){this._documents=q,this._provider=te,this._idPool=new g.IdGenerator(""),this._cache=new Map}async prepareSession(q,te,G){const Q=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.prepareCallHierarchy(Q,oe,G);if(!me)return;const Ie=this._idPool.nextId();return this._cache.set(Ie,new Map),Array.isArray(me)?me.map(We=>this._cacheAndConvertItem(Ie,We)):[this._cacheAndConvertItem(Ie,me)]}async provideCallsTo(q,te,G){const Q=this._itemFromCache(q,te);if(!Q)throw new Error("missing call hierarchy item");const oe=await this._provider.provideCallHierarchyIncomingCalls(Q,G);if(!!oe)return oe.map(me=>({from:this._cacheAndConvertItem(q,me.from),fromRanges:me.fromRanges.map(Ie=>I.Range.from(Ie))}))}async provideCallsFrom(q,te,G){const Q=this._itemFromCache(q,te);if(!Q)throw new Error("missing call hierarchy item");const oe=await this._provider.provideCallHierarchyOutgoingCalls(Q,G);if(!!oe)return oe.map(me=>({to:this._cacheAndConvertItem(q,me.to),fromRanges:me.fromRanges.map(Ie=>I.Range.from(Ie))}))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,te){const G=this._cache.get(q),Q=I.CallHierarchyItem.from(te,q,G.size.toString(36));return G.set(Q._itemId,te),Q}_itemFromCache(q,te){return this._cache.get(q)?.get(te)}}class Me{constructor(q,te){this._documents=q,this._provider=te,this._idPool=new g.IdGenerator(""),this._cache=new Map}async prepareSession(q,te,G){const Q=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.prepareTypeHierarchy(Q,oe,G);if(!me)return;const Ie=this._idPool.nextId();return this._cache.set(Ie,new Map),Array.isArray(me)?me.map(We=>this._cacheAndConvertItem(Ie,We)):[this._cacheAndConvertItem(Ie,me)]}async provideSupertypes(q,te,G){const Q=this._itemFromCache(q,te);if(!Q)throw new Error("missing type hierarchy item");const oe=await this._provider.provideTypeHierarchySupertypes(Q,G);if(!!oe)return oe.map(me=>this._cacheAndConvertItem(q,me))}async provideSubtypes(q,te,G){const Q=this._itemFromCache(q,te);if(!Q)throw new Error("missing type hierarchy item");const oe=await this._provider.provideTypeHierarchySubtypes(Q,G);if(!!oe)return oe.map(me=>this._cacheAndConvertItem(q,me))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,te){const G=this._cache.get(q),Q=I.TypeHierarchyItem.from(te,q,G.size.toString(36));return G.set(Q._itemId,te),Q}_itemFromCache(q,te){return this._cache.get(q)?.get(te)}}class xe{constructor(q,te){this.adapter=q,this.extension=te}}class Ge{constructor(q,te,G,Q,oe,me,Ie){this._adapter=new Map,this._uriTransformer=te,this._proxy=q.getProxy(R.MainContext.MainThreadLanguageFeatures),this._documents=G,this._commands=Q,this._diagnostics=oe,this._logService=me,this._apiDeprecation=Ie}_transformDocumentSelector(q){return I.DocumentSelector.from(q,this._uriTransformer)}_createDisposable(q){return new _.Disposable(()=>{this._adapter.delete(q),this._proxy.$unregister(q)})}_nextHandle(){return Ge._handlePool++}async _withAdapter(q,te,G,Q,oe){const me=this._adapter.get(q);if(!me||!(me.adapter instanceof te))return Q;const Ie=Date.now();this._logService.trace(`[${me.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const We=G(me.adapter,me.extension);return Promise.resolve(We).catch(Ye=>{(0,D.isCancellationError)(Ye)||(this._logService.error(`[${me.extension.identifier.value}] provider FAILED`),this._logService.error(Ye))}).finally(()=>{this._logService.trace(`[${me.extension.identifier.value}] provider DONE after ${Date.now()-Ie}ms`)}),l.CancellationToken.isCancellationToken(oe)?(0,s.raceCancellationError)(We,oe):We}_addNewAdapter(q,te){const G=this._nextHandle();return this._adapter.set(G,new xe(q,te)),G}static _extLabel(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,te,G,Q){const oe=this._addNewAdapter(new h(this._documents,G),q),me=Q&&Q.label||Ge._extLabel(q);return this._proxy.$registerDocumentSymbolProvider(oe,this._transformDocumentSelector(te),me),this._createDisposable(oe)}$provideDocumentSymbols(q,te,G){return this._withAdapter(q,h,Q=>Q.provideDocumentSymbols(f.URI.revive(te),G),void 0,G)}registerCodeLensProvider(q,te,G){const Q=this._nextHandle(),oe=typeof G.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(Q,new xe(new n(this._documents,this._commands.converter,G),q)),this._proxy.$registerCodeLensSupport(Q,this._transformDocumentSelector(te),oe);let me=this._createDisposable(Q);if(oe!==void 0){const Ie=G.onDidChangeCodeLenses(We=>this._proxy.$emitCodeLensEvent(oe));me=_.Disposable.from(me,Ie)}return me}$provideCodeLenses(q,te,G){return this._withAdapter(q,n,Q=>Q.provideCodeLenses(f.URI.revive(te),G),void 0,void 0)}$resolveCodeLens(q,te,G){return this._withAdapter(q,n,Q=>Q.resolveCodeLens(te,G),void 0,void 0)}$releaseCodeLenses(q,te){this._withAdapter(q,n,G=>Promise.resolve(G.releaseCodeLenses(te)),void 0,void 0)}registerDefinitionProvider(q,te,G){const Q=this._addNewAdapter(new a(this._documents,G),q);return this._proxy.$registerDefinitionSupport(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideDefinition(q,te,G,Q){return this._withAdapter(q,a,oe=>oe.provideDefinition(f.URI.revive(te),G,Q),[],Q)}registerDeclarationProvider(q,te,G){const Q=this._addNewAdapter(new i(this._documents,G),q);return this._proxy.$registerDeclarationSupport(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideDeclaration(q,te,G,Q){return this._withAdapter(q,i,oe=>oe.provideDeclaration(f.URI.revive(te),G,Q),[],Q)}registerImplementationProvider(q,te,G){const Q=this._addNewAdapter(new r(this._documents,G),q);return this._proxy.$registerImplementationSupport(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideImplementation(q,te,G,Q){return this._withAdapter(q,r,oe=>oe.provideImplementation(f.URI.revive(te),G,Q),[],Q)}registerTypeDefinitionProvider(q,te,G){const Q=this._addNewAdapter(new c(this._documents,G),q);return this._proxy.$registerTypeDefinitionSupport(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideTypeDefinition(q,te,G,Q){return this._withAdapter(q,c,oe=>oe.provideTypeDefinition(f.URI.revive(te),G,Q),[],Q)}registerHoverProvider(q,te,G,Q){const oe=this._addNewAdapter(new o(this._documents,G),q);return this._proxy.$registerHoverProvider(oe,this._transformDocumentSelector(te)),this._createDisposable(oe)}$provideHover(q,te,G,Q){return this._withAdapter(q,o,oe=>oe.provideHover(f.URI.revive(te),G,Q),void 0,void 0)}registerEvaluatableExpressionProvider(q,te,G,Q){const oe=this._addNewAdapter(new d(this._documents,G),q);return this._proxy.$registerEvaluatableExpressionProvider(oe,this._transformDocumentSelector(te)),this._createDisposable(oe)}$provideEvaluatableExpression(q,te,G,Q){return this._withAdapter(q,d,oe=>oe.provideEvaluatableExpression(f.URI.revive(te),G,Q),void 0,void 0)}registerInlineValuesProvider(q,te,G,Q){const oe=typeof G.onDidChangeInlineValues=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new m(this._documents,G),q);this._proxy.$registerInlineValuesProvider(me,this._transformDocumentSelector(te),oe);let Ie=this._createDisposable(me);if(oe!==void 0){const We=G.onDidChangeInlineValues(Ye=>this._proxy.$emitInlineValuesEvent(oe));Ie=_.Disposable.from(Ie,We)}return Ie}$provideInlineValues(q,te,G,Q,oe){return this._withAdapter(q,m,me=>me.provideInlineValues(f.URI.revive(te),G,Q,oe),void 0,void 0)}registerDocumentHighlightProvider(q,te,G){const Q=this._addNewAdapter(new v(this._documents,G),q);return this._proxy.$registerDocumentHighlightProvider(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideDocumentHighlights(q,te,G,Q){return this._withAdapter(q,v,oe=>oe.provideDocumentHighlights(f.URI.revive(te),G,Q),void 0,void 0)}registerLinkedEditingRangeProvider(q,te,G){const Q=this._addNewAdapter(new w(this._documents,G),q);return this._proxy.$registerLinkedEditingRangeProvider(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideLinkedEditingRanges(q,te,G,Q){return this._withAdapter(q,w,async oe=>{const me=await oe.provideLinkedEditingRanges(f.URI.revive(te),G,Q);if(me)return{ranges:me.ranges,wordPattern:me.wordPattern?Ge._serializeRegExp(me.wordPattern):void 0}},void 0,void 0)}registerReferenceProvider(q,te,G){const Q=this._addNewAdapter(new A(this._documents,G),q);return this._proxy.$registerReferenceSupport(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideReferences(q,te,G,Q,oe){return this._withAdapter(q,A,me=>me.provideReferences(f.URI.revive(te),G,Q,oe),void 0,oe)}registerCodeActionProvider(q,te,G,Q){const oe=new b.DisposableStore,me=this._addNewAdapter(new M(this._documents,this._commands.converter,this._diagnostics,G,this._logService,q,this._apiDeprecation),q);return this._proxy.$registerQuickFixSupport(me,this._transformDocumentSelector(te),{providedKinds:Q?.providedCodeActionKinds?.map(Ie=>Ie.value),documentation:Q?.documentation?.map(Ie=>({kind:Ie.kind.value,command:this._commands.converter.toInternal(Ie.command,oe)}))},Ge._extLabel(q),Boolean(G.resolveCodeAction)),oe.add(this._createDisposable(me)),oe}$provideCodeActions(q,te,G,Q,oe){return this._withAdapter(q,M,me=>me.provideCodeActions(f.URI.revive(te),G,Q,oe),void 0,void 0)}$resolveCodeAction(q,te,G){return this._withAdapter(q,M,Q=>Q.resolveCodeAction(te,G),void 0,void 0)}$releaseCodeActions(q,te){this._withAdapter(q,M,G=>Promise.resolve(G.releaseCodeActions(te)),void 0,void 0)}registerDocumentFormattingEditProvider(q,te,G){const Q=this._addNewAdapter(new T(this._documents,G),q);return this._proxy.$registerDocumentFormattingSupport(Q,this._transformDocumentSelector(te),q.identifier,q.displayName||q.name),this._createDisposable(Q)}$provideDocumentFormattingEdits(q,te,G,Q){return this._withAdapter(q,T,oe=>oe.provideDocumentFormattingEdits(f.URI.revive(te),G,Q),void 0,void 0)}registerDocumentRangeFormattingEditProvider(q,te,G){const Q=this._addNewAdapter(new O(this._documents,G),q);return this._proxy.$registerRangeFormattingSupport(Q,this._transformDocumentSelector(te),q.identifier,q.displayName||q.name),this._createDisposable(Q)}$provideDocumentRangeFormattingEdits(q,te,G,Q,oe){return this._withAdapter(q,O,me=>me.provideDocumentRangeFormattingEdits(f.URI.revive(te),G,Q,oe),void 0,void 0)}registerOnTypeFormattingEditProvider(q,te,G,Q){const oe=this._addNewAdapter(new U(this._documents,G),q);return this._proxy.$registerOnTypeFormattingSupport(oe,this._transformDocumentSelector(te),Q,q.identifier),this._createDisposable(oe)}$provideOnTypeFormattingEdits(q,te,G,Q,oe,me){return this._withAdapter(q,U,Ie=>Ie.provideOnTypeFormattingEdits(f.URI.revive(te),G,Q,oe,me),void 0,void 0)}registerWorkspaceSymbolProvider(q,te){const G=this._addNewAdapter(new V(te,this._logService),q);return this._proxy.$registerNavigateTypeSupport(G,typeof te.resolveWorkspaceSymbol=="function"),this._createDisposable(G)}$provideWorkspaceSymbols(q,te,G){return this._withAdapter(q,V,Q=>Q.provideWorkspaceSymbols(te,G),{symbols:[]},G)}$resolveWorkspaceSymbol(q,te,G){return this._withAdapter(q,V,Q=>Q.resolveWorkspaceSymbol(te,G),void 0,void 0)}$releaseWorkspaceSymbols(q,te){this._withAdapter(q,V,G=>G.releaseWorkspaceSymbols(te),void 0,void 0)}registerRenameProvider(q,te,G){const Q=this._addNewAdapter(new x(this._documents,G,this._logService),q);return this._proxy.$registerRenameSupport(Q,this._transformDocumentSelector(te),x.supportsResolving(G)),this._createDisposable(Q)}$provideRenameEdits(q,te,G,Q,oe){return this._withAdapter(q,x,me=>me.provideRenameEdits(f.URI.revive(te),G,Q,oe),void 0,void 0)}$resolveRenameLocation(q,te,G,Q){return this._withAdapter(q,x,oe=>oe.resolveRenameLocation(f.URI.revive(te),G,Q),void 0,void 0)}registerDocumentSemanticTokensProvider(q,te,G,Q){const oe=this._addNewAdapter(new B(this._documents,G),q),me=typeof G.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(oe,this._transformDocumentSelector(te),Q,me);let Ie=this._createDisposable(oe);if(me){const We=G.onDidChangeSemanticTokens(Ye=>this._proxy.$emitDocumentSemanticTokensEvent(me));Ie=_.Disposable.from(Ie,We)}return Ie}$provideDocumentSemanticTokens(q,te,G,Q){return this._withAdapter(q,B,oe=>oe.provideDocumentSemanticTokens(f.URI.revive(te),G,Q),null,void 0)}$releaseDocumentSemanticTokens(q,te){this._withAdapter(q,B,G=>G.releaseDocumentSemanticColoring(te),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(q,te,G,Q){const oe=this._addNewAdapter(new W(this._documents,G),q);return this._proxy.$registerDocumentRangeSemanticTokensProvider(oe,this._transformDocumentSelector(te),Q),this._createDisposable(oe)}$provideDocumentRangeSemanticTokens(q,te,G,Q){return this._withAdapter(q,W,oe=>oe.provideDocumentRangeSemanticTokens(f.URI.revive(te),G,Q),null,void 0)}registerCompletionItemProvider(q,te,G,Q){const oe=this._addNewAdapter(new H(this._documents,this._commands.converter,G,this._apiDeprecation,q),q);return this._proxy.$registerSuggestSupport(oe,this._transformDocumentSelector(te),Q,H.supportsResolving(G),`${q.identifier.value}(${Q.join("")})`),this._createDisposable(oe)}$provideCompletionItems(q,te,G,Q,oe){return this._withAdapter(q,H,me=>me.provideCompletionItems(f.URI.revive(te),G,Q,oe),void 0,oe)}$resolveCompletionItem(q,te,G){return this._withAdapter(q,H,Q=>Q.resolveCompletionItem(te,G),void 0,G)}$releaseCompletionItems(q,te){this._withAdapter(q,H,G=>G.releaseCompletionItems(te),void 0,void 0)}registerInlineCompletionsProvider(q,te,G){const Q=this._addNewAdapter(new z(this._documents,G,this._commands.converter),q);return this._proxy.$registerInlineCompletionsSupport(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideInlineCompletions(q,te,G,Q,oe){return this._withAdapter(q,z,me=>me.provideInlineCompletions(f.URI.revive(te),G,Q,oe),void 0,void 0)}$handleInlineCompletionDidShow(q,te,G){this._withAdapter(q,z,async Q=>{Q.handleDidShowCompletionItem(te,G)},void 0,void 0)}$freeInlineCompletionsList(q,te){this._withAdapter(q,z,async G=>{G.disposeCompletions(te)},void 0,void 0)}registerSignatureHelpProvider(q,te,G,Q){const oe=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,me=this._addNewAdapter(new ie(this._documents,G),q);return this._proxy.$registerSignatureHelpProvider(me,this._transformDocumentSelector(te),oe),this._createDisposable(me)}$provideSignatureHelp(q,te,G,Q,oe){return this._withAdapter(q,ie,me=>me.provideSignatureHelp(f.URI.revive(te),G,Q,oe),void 0,void 0)}$releaseSignatureHelp(q,te){this._withAdapter(q,ie,G=>G.releaseSignatureHelp(te),void 0,void 0)}registerInlayHintsProvider(q,te,G){const Q=typeof G.onDidChangeInlayHints=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new se(this._documents,this._commands.converter,G,this._logService,q),q);this._proxy.$registerInlayHintsProvider(oe,this._transformDocumentSelector(te),typeof G.resolveInlayHint=="function",Q);let me=this._createDisposable(oe);if(Q!==void 0){const Ie=G.onDidChangeInlayHints(We=>this._proxy.$emitInlayHintsEvent(Q));me=_.Disposable.from(me,Ie)}return me}$provideInlayHints(q,te,G,Q){return this._withAdapter(q,se,oe=>oe.provideInlayHints(f.URI.revive(te),G,Q),void 0,Q)}$resolveInlayHint(q,te,G){return this._withAdapter(q,se,Q=>Q.resolveInlayHint(te,G),void 0,G)}$releaseInlayHints(q,te){this._withAdapter(q,se,G=>G.releaseHints(te),void 0,void 0)}registerDocumentLinkProvider(q,te,G){const Q=this._addNewAdapter(new K(this._documents,G),q);return this._proxy.$registerDocumentLinkProvider(Q,this._transformDocumentSelector(te),typeof G.resolveDocumentLink=="function"),this._createDisposable(Q)}$provideDocumentLinks(q,te,G){return this._withAdapter(q,K,Q=>Q.provideLinks(f.URI.revive(te),G),void 0,void 0)}$resolveDocumentLink(q,te,G){return this._withAdapter(q,K,Q=>Q.resolveLink(te,G),void 0,void 0)}$releaseDocumentLinks(q,te){this._withAdapter(q,K,G=>G.releaseLinks(te),void 0,void 0)}registerColorProvider(q,te,G){const Q=this._addNewAdapter(new X(this._documents,G),q);return this._proxy.$registerDocumentColorProvider(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideDocumentColors(q,te,G){return this._withAdapter(q,X,Q=>Q.provideColors(f.URI.revive(te),G),[],void 0)}$provideColorPresentations(q,te,G,Q){return this._withAdapter(q,X,oe=>oe.provideColorPresentations(f.URI.revive(te),G,Q),void 0,void 0)}registerFoldingRangeProvider(q,te,G){const Q=this._nextHandle(),oe=typeof G.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(Q,new xe(new ae(this._documents,G),q)),this._proxy.$registerFoldingRangeProvider(Q,this._transformDocumentSelector(te),oe);let me=this._createDisposable(Q);if(oe!==void 0){const Ie=G.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(oe));me=_.Disposable.from(me,Ie)}return me}$provideFoldingRanges(q,te,G,Q){return this._withAdapter(q,ae,oe=>oe.provideFoldingRanges(f.URI.revive(te),G,Q),void 0,void 0)}registerSelectionRangeProvider(q,te,G){const Q=this._addNewAdapter(new fe(this._documents,G,this._logService),q);return this._proxy.$registerSelectionRangeProvider(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideSelectionRanges(q,te,G,Q){return this._withAdapter(q,fe,oe=>oe.provideSelectionRanges(f.URI.revive(te),G,Q),[],Q)}registerCallHierarchyProvider(q,te,G){const Q=this._addNewAdapter(new be(this._documents,G),q);return this._proxy.$registerCallHierarchyProvider(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$prepareCallHierarchy(q,te,G,Q){return this._withAdapter(q,be,oe=>Promise.resolve(oe.prepareSession(f.URI.revive(te),G,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(q,te,G,Q){return this._withAdapter(q,be,oe=>oe.provideCallsTo(te,G,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(q,te,G,Q){return this._withAdapter(q,be,oe=>oe.provideCallsFrom(te,G,Q),void 0,Q)}$releaseCallHierarchy(q,te){this._withAdapter(q,be,G=>Promise.resolve(G.releaseSession(te)),void 0,void 0)}registerTypeHierarchyProvider(q,te,G){const Q=this._addNewAdapter(new Me(this._documents,G),q);return this._proxy.$registerTypeHierarchyProvider(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$prepareTypeHierarchy(q,te,G,Q){return this._withAdapter(q,Me,oe=>Promise.resolve(oe.prepareSession(f.URI.revive(te),G,Q)),void 0,Q)}$provideTypeHierarchySupertypes(q,te,G,Q){return this._withAdapter(q,Me,oe=>oe.provideSupertypes(te,G,Q),void 0,Q)}$provideTypeHierarchySubtypes(q,te,G,Q){return this._withAdapter(q,Me,oe=>oe.provideSubtypes(te,G,Q),void 0,Q)}$releaseTypeHierarchy(q,te){this._withAdapter(q,Me,G=>Promise.resolve(G.releaseSession(te)),void 0,void 0)}static _serializeRegExp(q){return{pattern:q.source,flags:(0,k.regExpFlags)(q)}}static _serializeIndentationRule(q){return{decreaseIndentPattern:Ge._serializeRegExp(q.decreaseIndentPattern),increaseIndentPattern:Ge._serializeRegExp(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Ge._serializeRegExp(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Ge._serializeRegExp(q.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(q){return{beforeText:Ge._serializeRegExp(q.beforeText),afterText:q.afterText?Ge._serializeRegExp(q.afterText):void 0,previousLineText:q.previousLineText?Ge._serializeRegExp(q.previousLineText):void 0,action:q.action}}static _serializeOnEnterRules(q){return q.map(Ge._serializeOnEnterRule)}setLanguageConfiguration(q,te,G){let{wordPattern:Q}=G;if(Q&&(0,k.regExpLeadsToEndlessLoop)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this._documents.setWordDefinitionFor(te,Q):this._documents.setWordDefinitionFor(te,void 0),G.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),G.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const oe=this._nextHandle(),me={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?Ge._serializeRegExp(G.wordPattern):void 0,indentationRules:G.indentationRules?Ge._serializeIndentationRule(G.indentationRules):void 0,onEnterRules:G.onEnterRules?Ge._serializeOnEnterRules(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport};return this._proxy.$setLanguageConfiguration(oe,te,me),this._createDisposable(oe)}$setWordDefinitions(q){for(const te of q)this._documents.setWordDefinitionFor(te.languageId,new RegExp(te.regexSource,te.regexFlags))}}e.ExtHostLanguageFeatures=Ge,Ge._handlePool=0}),define(pe[241],ve([0,1,5,15,7,47,13,6]),function(Z,e,f,t,I,_,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(L,C,l,b){this._documents=C,this._commands=l,this._uriTransformer=b,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=L.getProxy(f.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this._languageIds=L}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(L,C){await this._proxy.$changeLanguage(L,C);const l=this._documents.getDocumentData(L);if(!l)throw new Error(`document '${L.toString}' NOT found`);return l.document}async tokenAtPosition(L,C){const l=L.version,b=t.Position.from(C),p=await this._proxy.$tokensAtPosition(L.uri,b),g={type:I.StandardTokenType.Other,range:L.getWordRangeAtPosition(C)??new I.Range(C.line,C.character,C.line,C.character)};if(!p)return g;const E={range:t.Range.to(p.range),type:t.TokenType.to(p.type)};return!E.range.contains(C)||l!==L.version?g:E}createLanguageStatusItem(L,C,l){const b=this._handlePool++,p=this._proxy,g=this._ids,E=`${L.identifier.value}/${C}`;if(g.has(E))throw new Error(`LanguageStatusItem with id '${C}' ALREADY exists`);g.add(E);const F={selector:l,id:C,name:L.displayName??L.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let D,u=new k.DisposableStore;const s=()=>{D?.dispose(),D=(0,R.disposableTimeout)(()=>{u.clear(),this._proxy.$setLanguageStatus(b,{id:E,name:F.name??L.displayName??L.name,source:L.displayName??L.name,selector:t.DocumentSelector.from(F.selector,this._uriTransformer),label:F.text,detail:F.detail??"",severity:F.severity===I.LanguageStatusSeverity.Error?_.default.Error:F.severity===I.LanguageStatusSeverity.Warning?_.default.Warning:_.default.Info,command:F.command&&this._commands.toInternal(F.command,u),accessibilityInfo:F.accessibilityInformation,busy:F.busy})},0)},h={dispose(){u.dispose(),D?.dispose(),p.$removeLanguageStatus(b),g.delete(E)},get id(){return F.id},get name(){return F.name},set name(n){F.name=n,s()},get selector(){return F.selector},set selector(n){F.selector=n,s()},get text(){return F.text},set text(n){F.text=n,s()},get detail(){return F.detail},set detail(n){F.detail=n,s()},get severity(){return F.severity},set severity(n){F.severity=n,s()},get accessibilityInformation(){return F.accessibilityInformation},set accessibilityInformation(n){F.accessibilityInformation=n,s()},get command(){return F.command},set command(n){F.command=n,s()},get busy(){return F.busy},set busy(n){F.busy=n,s()}};return s(),h}}e.ExtHostLanguages=y}),define(pe[133],ve([0,1,11,5,26,14,3]),function(Z,e,f,t,I,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends f.AbstractLoggerService{constructor(L,C){const l=new R.Emitter;super(C.logLevel,l.event);this._proxy=L.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(l)}$setLevel(L){this._onDidChangeLogLevel.fire(L)}doCreateLogger(L,C,l){return new y(this._proxy,L,C,l)}};k=je([ze(0,_.IExtHostRpcService),ze(1,I.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class y extends f.AbstractMessageLogger{constructor(L,C,l,b){super(b?.always);this.proxy=L,this.file=C,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(l),this.proxy.$createLogger(C,b).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(L,C){const l=[[L,C]];this.isLoggerCreated?this.doLog(l):this.buffer.push(...l)}doLog(L){this.proxy.$log(this.file,L)}}}),define(pe[242],ve([0,1,5,11,28]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function _(k){return k&&k.title}let R=class{constructor(y,P){this._logService=P,this._proxy=y.getProxy(f.MainContext.MainThreadMessageService)}showMessage(y,P,L,C,l){const b={source:{identifier:y.identifier,label:y.displayName||y.name}};let p;typeof C=="string"||_(C)?p=[C,...l]:(b.modal=C?.modal,b.useCustom=C?.useCustom,b.detail=C?.detail,p=l),b.useCustom&&(0,I.checkProposedApiEnabled)(y,"resolvers");const g=[];for(let E=0;E<p.length;E++){const F=p[E];if(typeof F=="string")g.push({title:F,handle:E,isCloseAffordance:!1});else if(typeof F=="object"){let{title:D,isCloseAffordance:u}=F;g.push({title:D,isCloseAffordance:!!u,handle:E})}else this._logService.warn("Invalid message item:",F)}return this._proxy.$showMessage(P,L,b,g).then(E=>{if(typeof E=="number")return p[E]})}};R=je([ze(1,t.ILogService)],R),e.ExtHostMessageService=R}),define(pe[243],ve([0,1,22,3,58,6,24,8,18,2,86,5,15,7,52,218,130]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class F{constructor(u,s,h,n,S){this._textDocumentsAndEditors=h,this._textDocuments=n,this._extensionStoragePaths=S,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new R.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new t.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new t.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new t.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new L.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=u.getProxy(C.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=u.getProxy(C.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=u.getProxy(C.MainContext.MainThreadNotebookEditors),this._commandsConverter=s.converter,s.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===12){const i=a.notebookEditor?.notebookUri,r=a.cell.handle,o=this._documents.get(i)?.getCell(r);if(o)return o.apiCell}return a}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(u=>u.apiEditor)}getEditorById(u){const s=this._editors.get(u);if(!s)throw new Error(`unknown text editor: ${u}. known editors: ${[...this._editors.keys()]} `);return s}getIdByEditor(u){for(const[s,h]of this._editors)if(h.apiEditor===u)return s}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(u,s){const h=this._documents.get(u);if(!h&&!s)throw new Error(`NO notebook document for '${u}'`);return h}_getProviderData(u){const s=this._notebookContentProviders.get(u);if(!s)throw new Error(`NO provider for '${u}'`);return s}registerNotebookContentProvider(u,s,h,n,S){if((0,k.isFalsyOrWhitespace)(s))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(s))throw new Error(`Notebook provider for '${s}' already registered`);this._notebookContentProviders.set(s,{extension:u,provider:h});let a;return h.onDidChangeNotebookContentOptions&&(a=h.onDidChangeNotebookContentOptions(()=>{const i=l.NotebookDocumentContentOptions.from(h.options);this._notebookProxy.$updateNotebookProviderOptions(s,i)})),this._notebookProxy.$registerNotebookProvider({id:u.identifier,location:u.extensionLocation},s,l.NotebookDocumentContentOptions.from(n),F._convertNotebookRegistrationData(u,S)),new b.Disposable(()=>{a?.dispose(),this._notebookContentProviders.delete(s),this._notebookProxy.$unregisterNotebookProvider(s)})}static _convertNotebookRegistrationData(u,s){if(!s)return;const h=s.filenamePattern.map(n=>l.NotebookExclusiveDocumentPattern.from(n)).filter(n=>n!==void 0);if(s.filenamePattern&&!h){console.warn(`Notebook content provider view options file name pattern is invalid ${s.filenamePattern}`);return}return{extension:u.identifier,providerDisplayName:u.displayName||u.name,displayName:s.displayName,filenamePattern:h,exclusive:s.exclusive||!1}}registerNotebookCellStatusBarItemProvider(u,s,h){const n=F._notebookStatusBarItemProviderHandlePool++,S=typeof h.onDidChangeCellStatusBarItems=="function"?F._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(n,h),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(n,S,s);let a;return S!==void 0&&(a=h.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(S))),new b.Disposable(()=>{this._notebookStatusBarItemProviders.delete(n),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(n,S),a&&a.dispose()})}async createNotebookDocument(u){const s=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:u.viewType,content:u.content&&l.NotebookData.from(u.content)});return P.URI.revive(s)}async openNotebookDocument(u){const s=this._documents.get(u);if(s)return s.apiNotebook;const h=await this._notebookDocumentsProxy.$tryOpenNotebook(u),n=this._documents.get(P.URI.revive(h));return(0,y.assertIsDefined)(n?.apiNotebook)}async showNotebookDocument(u,s){P.URI.isUri(u)&&(u=await this.openNotebookDocument(u));let h;typeof s=="object"?h={position:l.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus,selections:s.selections&&s.selections.map(l.NotebookRange.from),pinned:typeof s.preview=="boolean"?!s.preview:void 0}:h={preserveFocus:!1};const n=await this._notebookEditorsProxy.$tryShowNotebookDocument(u.uri,u.notebookType,h),S=n&&this._editors.get(n)?.apiEditor;if(S)return S;throw n?new Error(`Could NOT open editor for "${u.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${u.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(u,s,h,n){const S=this._notebookStatusBarItemProviders.get(u),a=P.URI.revive(s),i=this._documents.get(a);if(!i||!S)return;const r=i.getCellFromIndex(h);if(!r)return;const c=await S.provideCellStatusBarItems(r.apiCell,n);if(!c)return;const o=new _.DisposableStore,d=this._statusBarCache.add([o]),v=(Array.isArray(c)?c:[c]).map(w=>l.NotebookStatusBarItem.from(w,this._commandsConverter,o));return{cacheId:d,items:v}}$releaseNotebookCellStatusBarItems(u){this._statusBarCache.delete(u)}registerNotebookSerializer(u,s,h,n,S){if((0,k.isFalsyOrWhitespace)(s))throw new Error("viewType cannot be empty or just whitespace");const a=this._handlePool++;return this._notebookSerializer.set(a,h),this._notebookProxy.$registerNotebookSerializer(a,{id:u.identifier,location:u.extensionLocation},s,l.NotebookDocumentContentOptions.from(n),F._convertNotebookRegistrationData(u,S)),(0,_.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(a)})}async $dataToNotebook(u,s,h){const n=this._notebookSerializer.get(u);if(!n)throw new Error("NO serializer found");const S=await n.deserializeNotebook(s.buffer,h);return new p.SerializableObjectWithBuffers(l.NotebookData.from(S))}async $notebookToData(u,s,h){const n=this._notebookSerializer.get(u);if(!n)throw new Error("NO serializer found");const S=await n.serializeNotebook(l.NotebookData.to(s.value),h);return f.VSBuffer.wrap(S)}async $openNotebook(u,s,h,n,S){const{provider:a}=this._getProviderData(u),i=await a.openNotebook(P.URI.revive(s),{backupId:h,untitledDocumentData:n?.buffer},S);return new p.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(l.NotebookCellData.from)})}async $saveNotebook(u,s,h){const n=this.getNotebookDocument(P.URI.revive(s)),{provider:S}=this._getProviderData(u);return await S.saveNotebook(n.apiNotebook,h),!0}async $saveNotebookAs(u,s,h,n){const S=this.getNotebookDocument(P.URI.revive(s)),{provider:a}=this._getProviderData(u);return await a.saveNotebookAs(P.URI.revive(h),S.apiNotebook,n),!0}async $backupNotebook(u,s,h){const n=this.getNotebookDocument(P.URI.revive(s)),S=this._getProviderData(u),a=this._extensionStoragePaths.workspaceValue(S.extension)??this._extensionStoragePaths.globalValue(S.extension),i=String((0,I.hash)([n.uri.toString(),this._backupIdPool++])),r=P.URI.joinPath(a,i),c=await S.provider.backupNotebook(n.apiNotebook,{destination:r},h);return n.updateBackup(c),c.id}_createExtHostEditor(u,s,h){if(this._editors.has(s))throw new Error(`editor with id ALREADY EXSIST: ${s}`);const n=new E.ExtHostNotebookEditor(s,this._notebookEditorsProxy,u,h.visibleRanges.map(l.NotebookRange.to),h.selections.map(l.NotebookRange.to),typeof h.viewColumn=="number"?l.ViewColumn.to(h.viewColumn):void 0);this._editors.set(s,n)}$acceptDocumentAndEditorsDelta(u){if(u.value.removedDocuments)for(const h of u.value.removedDocuments){const n=P.URI.revive(h),S=this._documents.get(n);S&&(S.dispose(),this._documents.delete(n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:S.apiNotebook.getCells().map(a=>a.document.uri)}),this._onDidCloseNotebookDocument.fire(S.apiNotebook));for(const a of this._editors.values())a.notebookData.uri.toString()===n.toString()&&this._editors.delete(a.id)}if(u.value.addedDocuments){const h=[];for(const n of u.value.addedDocuments){const S=P.URI.revive(n.uri);if(this._documents.has(S))throw new Error(`adding EXISTING notebook ${S} `);const a=this,i=new g.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(r){a._onDidChangeNotebookCells.fire(r)},emitCellOutputsChange(r){a._onDidChangeCellOutputs.fire(r)},emitCellMetadataChange(r){a._onDidChangeCellMetadata.fire(r)}},S,n);h.push(...n.cells.map(r=>g.ExtHostCell.asModelAddData(i.apiNotebook,r))),this._documents.get(S)?.dispose(),this._documents.set(S,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:h}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(u.value.addedEditors)for(const h of u.value.addedEditors){if(this._editors.has(h.id))return;const n=P.URI.revive(h.documentUri),S=this._documents.get(n);S&&this._createExtHostEditor(S,h.id,h)}const s=[];if(u.value.removedEditors)for(const h of u.value.removedEditors){const n=this._editors.get(h);n&&(this._editors.delete(h),this._activeNotebookEditor?.id===n.id&&(this._activeNotebookEditor=void 0),s.push(n))}if(u.value.visibleEditors){this._visibleNotebookEditors=u.value.visibleEditors.map(n=>this._editors.get(n)).filter(n=>!!n);const h=new Set;this._visibleNotebookEditors.forEach(n=>h.add(n.id));for(const n of this._editors.values()){const S=h.has(n.id);n._acceptVisibility(S)}this._visibleNotebookEditors=[...this._editors.values()].map(n=>n).filter(n=>n.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}u.value.newActiveEditor===null?this._activeNotebookEditor=void 0:u.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(u.value.newActiveEditor)),u.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=F,F._notebookStatusBarItemProviderHandlePool=0}),define(pe[244],ve([0,1,3,77,11,5,14,15]),function(Z,e,f,t,I,_,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class y{constructor(C,l){const b=y._Keys.nextId();C.$registerNotebookEditorDecorationType(b,k.NotebookDecorationRenderOptions.from(l)),this.value={key:b,dispose(){C.$removeNotebookEditorDecorationType(b)}}}}y._Keys=new t.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(C,l,b){this._logService=C,this._extHostRpc=l,this._notebooksAndEditors=b,this._onDidChangeNotebookEditorSelection=new f.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new f.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(C){return new y(this._extHostRpc.getProxy(_.MainContext.MainThreadNotebookEditors),C).value}$acceptEditorPropertiesChanged(C,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",C,l);const b=this._notebooksAndEditors.getEditorById(C);l.visibleRanges&&b._acceptVisibleRanges(l.visibleRanges.ranges.map(k.NotebookRange.to)),l.selections&&b._acceptSelections(l.selections.selections.map(k.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:b.apiEditor,visibleRanges:b.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:b.apiEditor,selections:b.apiEditor.selections}))}$acceptEditorViewColumns(C){for(const l in C)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(k.ViewColumn.to(C[l]))}};P=je([ze(0,I.ILogService),ze(1,R.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(pe[245],ve([0,1,17,13,21,3,6,24,2,27,11,5,38,15,7,87,211,28,52]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p,g,E,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let u=class{constructor(i,r,c,o,d){this._initData=r,this._extHostNotebook=c,this._commands=o,this._logService=d,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new _.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(C.MainContext.MainThreadNotebookKernels);const m=new l.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.ApiCommandArgument("options","Select kernel options",v=>!0,v=>{if(v&&"notebookEditor"in v&&"id"in v){const w=this._extHostNotebook.getIdByEditor(v.notebookEditor);return{id:v.id,extension:v.extension,notebookEditorId:w}}else if(v&&"notebookEditor"in v){const w=this._extHostNotebook.getIdByEditor(v.notebookEditor);if(w===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${v.notebookEditor.document.uri.toString()}`);return{notebookEditorId:w}}return v})],l.ApiCommandResult.Void);this._commands.registerApiCommand(m)}createNotebookController(i,r,c,o,d,m){for(const J of this._kernelData.values())if(J.controller.id===r&&P.ExtensionIdentifier.equals(i.identifier,J.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const v=this._handlePool++,w=this;this._logService.trace(`NotebookController[${v}], CREATED by ${i.identifier.value}, ${r}`);const A=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${i.identifier}'`);let M=!1;const T=new R.DisposableStore,O=new _.Emitter,U=new _.Emitter,V={id:S(i,r),notebookType:c,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:o||i.identifier.value,preloads:m?m.map(b.NotebookRendererScript.from):[]};let x=d??A,N;this._proxy.$addKernel(v,V).catch(J=>{console.log(J),M=!0});let B=0;const W=()=>{if(M)return;const J=++B;Promise.resolve().then(()=>{J===B&&this._proxy.$updateKernel(v,V)})},H=new k.ResourceMap,z={get id(){return r},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return V.label},set label(J){V.label=J??i.displayName??i.name,W()},get detail(){return V.detail??""},set detail(J){V.detail=J,W()},get description(){return V.description??""},set description(J){V.description=J,W()},get kind(){return(0,F.checkProposedApiEnabled)(i,"notebookControllerKind"),V.kind??""},set kind(J){(0,F.checkProposedApiEnabled)(i,"notebookControllerKind"),V.kind=J,W()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages(J){V.supportedLanguages=J,W()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder(J){V.supportsExecutionOrder=J,W()},get rendererScripts(){return V.preloads?V.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return x},set executeHandler(J){x=J??A},get interruptHandler(){return N},set interruptHandler(J){N=J,V.supportsInterrupt=Boolean(J),W()},createNotebookCellExecution(J){if(M)throw new Error("notebook controller is DISPOSED");if(!H.has(J.notebook.uri))throw w._logService.trace(`NotebookController[${v}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(H.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${J.notebook.uri.toString()}`);return w._createNotebookCellExecution(J,S(i,this.id))},dispose:()=>{M||(this._logService.trace(`NotebookController[${v}], DISPOSED`),M=!0,this._kernelData.delete(v),T.dispose(),O.dispose(),U.dispose(),this._proxy.$removeKernel(v))},updateNotebookAffinity(J,ie){w._proxy.$updateNotebookPriority(v,J.uri,ie)},onDidReceiveMessage:U.event,postMessage(J,ie){return(0,F.checkProposedApiEnabled)(i,"notebookMessaging"),w._proxy.$postMessage(v,ie&&w._extHostNotebook.getIdByEditor(ie),J)},asWebviewUri(J){return(0,F.checkProposedApiEnabled)(i,"notebookMessaging"),(0,g.asWebviewUri)(J,w._initData.remote)}};return this._kernelData.set(v,{extensionId:i.identifier,controller:z,onDidReceiveMessage:U,onDidChangeSelection:O,associatedNotebooks:H}),z}$acceptNotebookAssociation(i,r,c){const o=this._kernelData.get(i);if(o){const d=this._extHostNotebook.getNotebookDocument(y.URI.revive(r));c?o.associatedNotebooks.set(d.uri,!0):o.associatedNotebooks.delete(d.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,d.uri.toString(),c),o.onDidChangeSelection.fire({selected:c,notebook:d.apiNotebook})}}async $executeCells(i,r,c){const o=this._kernelData.get(i);if(!o)return;const d=this._extHostNotebook.getNotebookDocument(y.URI.revive(r)),m=[];for(const v of c){const w=d.getCell(v);w&&m.push(w.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,d.uri.toString(),m.length),await o.controller.executeHandler.call(o.controller,m,d.apiNotebook,o.controller)}catch(v){this._logService.error(`NotebookController[${i}] execute cells FAILED`,v),console.error(v)}}async $cancelCells(i,r,c){const o=this._kernelData.get(i);if(!o)return;const d=this._extHostNotebook.getNotebookDocument(y.URI.revive(r));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,d.apiNotebook);else for(const m of c){const v=d.getCell(m);v&&this._activeExecutions.get(v.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,r,c){const o=this._kernelData.get(i);if(!o)return;const d=this._extHostNotebook.getEditorById(r);o.onDidReceiveMessage.fire(Object.freeze({editor:d.apiEditor,message:c}))}$cellExecutionChanged(i,r,c){const d=this._extHostNotebook.getNotebookDocument(y.URI.revive(i)).getCell(r);d&&this._onDidChangeCellExecutionState.fire({cell:d.apiCell,state:c??p.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(i,r){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const d=new h(r,o,this._proxy);this._activeExecutions.set(o.uri,d);const m=d.onDidChangeState(()=>{d.state===s.Resolved&&(d.dispose(),m.dispose(),this._activeExecutions.delete(o.uri))});return d.asApiObject()}};u=je([ze(4,L.ILogService)],u),e.ExtHostNotebookKernels=u;var s;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(s||(s={}));class h extends R.Disposable{constructor(i,r,c){super();this._cell=r,this._proxy=c,this._handle=h.HANDLE++,this._onDidChangeState=new _.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=s.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new n(10,o=>this.update(o)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const r=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new D.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===s.Init)throw new Error("Must call start before modifying cell output");if(this._state===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(i){return i.map(r=>{const c=p.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return c===r.items?b.NotebookCellOutput.from(r):b.NotebookCellOutput.from({items:c,id:r.id,metadata:r.metadata})})}async updateOutputs(i,r,c){const o=this.validateAndConvertOutputs((0,f.asArray)(i));return this.updateSoon({editType:E.CellExecutionUpdateType.Output,append:c,outputs:o})}async updateOutputItems(i,r,c){return i=p.NotebookCellOutput.ensureUniqueMimeTypes((0,f.asArray)(i),!0),this.updateSoon({editType:E.CellExecutionUpdateType.OutputItems,items:i.map(b.NotebookCellOutputItem.from),outputId:r.id,append:c})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(c){i._executionOrder=c,i.update([{editType:E.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(c){if(i._state===s.Resolved||i._state===s.Started)throw new Error("Cannot call start again");i._state=s.Started,i._onDidChangeState.fire(),i.update({editType:E.CellExecutionUpdateType.ExecutionState,runStartTime:c})},end(c,o){if(i._state===s.Resolved)throw new Error("Cannot call resolve twice");i._state=s.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new D.SerializableObjectWithBuffers({runEndTime:o,lastRunSuccess:c}))},clearOutput(c){return i.verifyStateForOutput(),i.updateOutputs([],c,!1)},appendOutput(c,o){return i.verifyStateForOutput(),i.updateOutputs(c,o,!0)},replaceOutput(c,o){return i.verifyStateForOutput(),i.updateOutputs(c,o,!1)},appendOutputItems(c,o){return i.verifyStateForOutput(),i.updateOutputItems(c,o,!0)},replaceOutputItems(c,o){return i.verifyStateForOutput(),i.updateOutputItems(c,o,!1)}})}}h.HANDLE=0;class n{constructor(i,r){this.delay=i,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>i.complete())}}function S(a,i){return`${a.identifier.value}/${i}`}}),define(pe[246],ve([0,1,3,5,130,28]),function(Z,e,f,t,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(y,P){this._extHostNotebook=P,this._rendererMessageEmitters=new Map,this.proxy=y.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(y,P,L){const C=this._extHostNotebook.getEditorById(y);this._rendererMessageEmitters.get(P)?.fire({editor:C.apiEditor,message:L})}createRendererMessaging(y,P){if(!y.contributes?.notebookRenderer?.some(b=>b.id===P))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${P})`);const L=(0,_.isProposedApiEnabled)(y,"notebookEditor"),C=new WeakMap;return{onDidReceiveMessage:(b,p,g)=>{const E=L?b:F=>{const D={};C.set(D,F.editor),b({editor:D,message:F.message})};return this.getOrCreateEmitterFor(P).event(E,p,g)},postMessage:(b,p)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(b)&&([b,p]=[p,b]);const g=L?p:C.get(p),E=g&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(g);return this.proxy.$postMessage(E?.id,P,b)}}}getOrCreateEmitterFor(y){let P=this._rendererMessageEmitters.get(y);return P||(P=new f.Emitter({onLastListenerRemove:()=>{P?.dispose(),this._rendererMessageEmitters.delete(y)}}),this._rendererMessageEmitters.set(y,P),P)}}e.ExtHostNotebookRenderers=R}),define(pe[134],ve([0,1,5,6,4,14,11,212,67,26,44,153,22]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class b extends t.Disposable{constructor(E,F,D,u){super();this.id=E,this.name=F,this.logger=D,this.proxy=u,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(E){this.append(E+`
`)}append(E){this.write(E),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}clear(){const E=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,E)}replace(E){const F=this.offset;this.write(E),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,F),this.visible&&this.logger.flush()}show(E,F){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof E=="boolean"?E:F))}hide(){this.proxy.$close(this.id)}write(E){this.offset+=l.VSBuffer.fromString(E).byteLength,this.logger.info(E)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=b;let p=class{constructor(E,F,D,u,s){this.extHostFileSystem=D,this.extHostFileSystemInfo=u,this.loggerService=s,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=E.getProxy(f.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(F.logsLocation,`output_logging_${(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(E){this.visibleChannelId=E;for(const[F,D]of this.channels)D.visible=F===this.visibleChannelId}createOutputChannel(E,F){if(E=E.trim(),!E)throw new Error("illegal argument `name`. must not be falsy");const D=this.doCreateOutputChannel(E,F);return D.then(u=>{this.channels.set(u.id,u),u.visible=u.id===this.visibleChannelId}),this.createExtHostOutputChannel(E,D)}async doCreateOutputChannel(E,F){const D=await this.createOutputDirectory(),u=this.extHostFileSystemInfo.extUri.joinPath(D,`${this.namePool++}-${E.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.loggerService.createLogger(u,{always:!0,donotRotate:!0,donotUseFormatters:!0}),h=await this.proxy.$register(E,!1,u,F.identifier.value);return new b(h,E,s,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(E,F){let D=!1;const u=()=>{if(D)throw new Error("Channel has been closed")};return{get name(){return E},append(s){u(),F.then(h=>h.append(s))},appendLine(s){u(),F.then(h=>h.appendLine(s))},clear(){u(),F.then(s=>s.clear())},replace(s){u(),F.then(h=>h.replace(s))},show(s,h){u(),F.then(n=>n.show(s,h))},hide(){u(),F.then(s=>s.hide())},dispose(){D=!0,F.then(s=>s.dispose())}}}};p=je([ze(0,_.IExtHostRpcService),ze(1,P.IExtHostInitDataService),ze(2,y.IExtHostConsumerFileSystem),ze(3,L.IExtHostFileSystemInfo),ze(4,R.ILoggerService)],p),e.ExtHostOutputService=p,e.IExtHostOutputService=(0,I.createDecorator)("IExtHostOutputService")}),define(pe[247],ve([0,1,13,21,3,6,5,2,7,16,17,47,85,28]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function p(g,E,F){const D=g.getProxy(R.MainContext.MainThreadQuickOpen);class u{constructor(o,d){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=d}showQuickPick(o,d,m=t.CancellationToken.None){this._onDidSelectItem=void 0;const v=Promise.resolve(o),w=++this._instances,A=D.$show(w,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},m),M={},T=A.then(()=>M);return Promise.race([T,v]).then(O=>{if(O!==M)return v.then(U=>{const V=[];for(let x=0;x<U.length;x++){const N=U[x];typeof N=="string"?V.push({label:N,handle:x}):N.kind===y.QuickPickItemKind.Separator?V.push({type:"separator",label:N.label}):V.push({label:N.label,description:N.description,detail:N.detail,picked:N.picked,alwaysShow:N.alwaysShow,handle:x})}return d&&typeof d.onDidSelectItem=="function"&&(this._onDidSelectItem=x=>{d.onDidSelectItem(U[x])}),D.$setItems(w,V),A.then(x=>{if(typeof x=="number")return U[x];if(Array.isArray(x))return x.map(N=>U[N])})})}).then(void 0,O=>{if(!(0,P.isCancellationError)(O))return D.$setError(w,O),Promise.reject(O)})}$onItemSelected(o){this._onDidSelectItem&&this._onDidSelectItem(o)}showInput(o,d=t.CancellationToken.None){return this._validateInput=o?o.validateInput:void 0,D.$input(o,typeof this._validateInput=="function",d).then(void 0,m=>{if(!(0,P.isCancellationError)(m))return Promise.reject(m)})}$validateInput(o){return this._validateInput?(0,f.asPromise)(()=>this._validateInput(o)):Promise.resolve(void 0)}async showWorkspaceFolderPick(o,d=t.CancellationToken.None){const m=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!m)return;const v=await this._workspace.getWorkspaceFolders2();if(!!v)return v.find(w=>w.uri.toString()===m.uri.toString())}createQuickPick(o){const d=new i(o,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}createInputBox(o){const d=new r(o,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}$onDidChangeValue(o,d){const m=this._sessions.get(o);m&&m._fireDidChangeValue(d)}$onDidAccept(o){const d=this._sessions.get(o);d&&d._fireDidAccept()}$onDidChangeActive(o,d){const m=this._sessions.get(o);m instanceof i&&m._fireDidChangeActive(d)}$onDidChangeSelection(o,d){const m=this._sessions.get(o);m instanceof i&&m._fireDidChangeSelection(d)}$onDidTriggerButton(o,d){const m=this._sessions.get(o);m&&m._fireDidTriggerButton(d)}$onDidTriggerItemButton(o,d,m){const v=this._sessions.get(o);v instanceof i&&v._fireDidTriggerItemButton(d,m)}$onDidHide(o){const d=this._sessions.get(o);d&&d._fireDidHide()}}class s{constructor(o,d){this._extensionId=o,this._onDidDispose=d,this._id=i._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new I.Emitter,this._onDidChangeValueEmitter=new I.Emitter,this._onDidTriggerButtonEmitter=new I.Emitter,this._onDidHideEmitter=new I.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((d,m)=>{const v=d===y.QuickInputButtons.Back?-1:m;this._handlesToButtons.set(v,d)}),this.update({buttons:o.map((d,m)=>({...a(d),tooltip:d.tooltip,handle:d===y.QuickInputButtons.Back?-1:m}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const d=this._handlesToButtons.get(o);d&&this._onDidTriggerButtonEmitter.fire(d)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,_.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),D.$dispose(this._id))}update(o){if(!this._disposed){for(const d of Object.keys(o)){const m=o[d];this._pendingUpdate[d]=m===void 0?null:m}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){D.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}s._nextId=1;function h(c){if(c instanceof y.ThemeIcon)return{id:c.id};const o=S(c),d=n(c);return{dark:typeof o=="string"?k.URI.file(o):o,light:typeof d=="string"?k.URI.file(d):d}}function n(c){return typeof c=="object"&&"light"in c?c.light:c}function S(c){return typeof c=="object"&&"dark"in c?c.dark:c}function a(c){const o=h(c.iconPath);let d,m;return"id"in o?m=l.ThemeIcon.asClassName(o):d=o,{iconPath:d,iconClass:m}}class i extends s{constructor(o,d){super(o.identifier,d);this.extension=o,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new I.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new I.Emitter,this._onDidTriggerItemButtonEmitter=new I.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){o.some(m=>m.kind!==void 0)&&(0,b.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((m,v)=>{this._handlesToItems.set(v,m),this._itemsToHandles.set(m,v)});const d=[];for(let m=0;m<o.length;m++){const v=o[m];v.kind===y.QuickPickItemKind.Separator?d.push({type:"separator",label:v.label}):d.push({handle:m,label:v.label,description:v.description,detail:v.detail,picked:v.picked,alwaysShow:v.alwaysShow,buttons:v.buttons?.map((w,A)=>({...a(w),tooltip:w.tooltip,handle:A}))})}this.update({items:d})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(o){this._keepScrollPosition=o,this.update({keepScrollPosition:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(d=>this._itemsToHandles.has(d)),this.update({activeItems:this._activeItems.map(d=>this._itemsToHandles.get(d))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(d=>this._itemsToHandles.has(d)),this.update({selectedItems:this._selectedItems.map(d=>this._itemsToHandles.get(d))})}_fireDidChangeActive(o){const d=(0,L.coalesce)(o.map(m=>this._handlesToItems.get(m)));this._activeItems=d,this._onDidChangeActiveEmitter.fire(d)}_fireDidChangeSelection(o){const d=(0,L.coalesce)(o.map(m=>this._handlesToItems.get(m)));this._selectedItems=d,this._onDidChangeSelectionEmitter.fire(d)}_fireDidTriggerItemButton(o,d){const m=this._handlesToItems.get(o);if(!m||!m.buttons||!m.buttons.length)return;const v=m.buttons[d];v&&this._onDidTriggerItemButtonEmitter.fire({button:v,item:m})}}class r extends s{constructor(o,d){super(o,d);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,this.update({validationMessage:o,severity:o?C.default.Error:C.default.Ignore})}}return new u(E,F)}e.createExtHostQuickOpen=p});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[248],ve([0,1,2,3,56,6,13,5,17,101,11,27,85,15,28]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p){"use strict";var g,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function F(d){if(d)return typeof d.iconPath=="string"?f.URI.file(d.iconPath):f.URI.isUri(d.iconPath)||l.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function D(d,m){if(!d.iconPath&&!m.iconPath)return 0;if(d.iconPath){if(!m.iconPath)return 1}else return-1;const v=typeof d.iconPath=="string"?d.iconPath:f.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,w=typeof m.iconPath=="string"?m.iconPath:f.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id;return(0,P.comparePaths)(v,w)}function u(d,m){let v=0;if(d.strikeThrough!==m.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==m.faded)return d.faded?1:-1;if(d.tooltip!==m.tooltip)return(d.tooltip||"").localeCompare(m.tooltip||"");if(v=D(d,m),v!==0)return v;if(d.light&&m.light)v=D(d.light,m.light);else{if(d.light)return 1;if(m.light)return-1}if(v!==0)return v;if(d.dark&&m.dark)v=D(d.dark,m.dark);else{if(d.dark)return 1;if(m.dark)return-1}return v}function s(d,m){if(d.command!==m.command)return d.command<m.command?-1:1;if(d.title!==m.title)return d.title<m.title?-1:1;if(d.tooltip!==m.tooltip){if(d.tooltip!==void 0&&m.tooltip!==void 0)return d.tooltip<m.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(m.tooltip!==void 0)return-1}if(d.arguments===m.arguments)return 0;if(d.arguments)if(m.arguments){if(d.arguments.length!==m.arguments.length)return d.arguments.length-m.arguments.length}else return 1;else return-1;for(let v=0;v<d.arguments.length;v++){const w=d.arguments[v],A=m.arguments[v];if(w!==A)return w<A?-1:1}return 0}function h(d,m){let v=(0,P.comparePaths)(d.resourceUri.fsPath,m.resourceUri.fsPath,!0);if(v!==0)return v;if(d.command&&m.command)v=s(d.command,m.command);else{if(d.command)return 1;if(m.command)return-1}if(v!==0)return v;if(d.decorations&&m.decorations)v=u(d.decorations,m.decorations);else{if(d.decorations)return 1;if(m.decorations)return-1}return v}function n(d,m){for(let v=0;v<d.length;v++)if(d[v]!==m[v])return!1;return!0}function S(d,m){return d.command===m.command&&d.title===m.title&&d.tooltip===m.tooltip&&(d.arguments&&m.arguments?n(d.arguments,m.arguments):d.arguments===m.arguments)}function a(d,m){return(0,y.equals)(d,m,S)}class i{constructor(m,v,w){this._extension=m,this._sourceControlHandle=w,g.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._visible=!0,nt(this,g,v,"f")}get value(){return this._value}set value(m){m=m??"",Le(this,g,"f").$setInputBoxValue(this._sourceControlHandle,m),this.updateValue(m)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(m){Le(this,g,"f").$setInputBoxPlaceholder(this._sourceControlHandle,m),this._placeholder=m}get validateInput(){return(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(m){if((0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),m&&typeof m!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=m,Le(this,g,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!m)}get visible(){return this._visible}set visible(m){m=!!m,this._visible!==m&&(this._visible=m,Le(this,g,"f").$setInputBoxVisibility(this._sourceControlHandle,m))}showValidationMessage(m,v){(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),Le(this,g,"f").$showValidationMessage(this._sourceControlHandle,m,v)}$onInputBoxValueChange(m){this.updateValue(m)}updateValue(m){this._value=m,this._onDidChange.fire(m)}}e.ExtHostSCMInputBox=i,g=new WeakMap;class r{constructor(m,v,w,A,M){this._proxy=m,this._commands=v,this._sourceControlHandle=w,this._id=A,this._label=M,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(m){this._label=m,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,m)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(m){this._hideWhenEmpty=m,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(m){this._resourceStates=[...m],this._onDidUpdateResourceStates.fire()}getResourceState(m){return this._resourceStatesMap.get(m)}$executeResourceCommand(m,v){const w=this._resourceStatesCommandsMap.get(m);return w?(0,R.asPromise)(()=>this._commands.executeCommand(w.command,...w.arguments||[],v)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const m=[...this._resourceStates].sort(h),w=(0,y.sortedDiff)(this._resourceSnapshot,m,h).map(T=>{const O=T.toInsert.map(U=>{const V=this._resourceHandlePool++;this._resourceStatesMap.set(V,U);const x=U.resourceUri;let N;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"){const ae=new _.DisposableStore;N=this._commands.converter.toInternal(U.command,ae),this._resourceStatesDisposablesMap.set(V,ae)}else this._resourceStatesCommandsMap.set(V,U.command);const B=F(U.decorations),W=U.decorations&&F(U.decorations.light)||B,H=U.decorations&&F(U.decorations.dark)||B,z=[W,H],J=U.decorations&&U.decorations.tooltip||"",ie=U.decorations&&!!U.decorations.strikeThrough,se=U.decorations&&!!U.decorations.faded,K=U.contextValue||"";return{rawResource:[V,x,z,J,ie,se,K,N],handle:V}});return{start:T.start,deleteCount:T.deleteCount,toInsert:O}}),A=w.map(({start:T,deleteCount:O,toInsert:U})=>[T,O,U.map(V=>V.rawResource)]),M=w.reverse();for(const{start:T,deleteCount:O,toInsert:U}of M){const V=U.map(N=>N.handle),x=this._handlesSnapshot.splice(T,O,...V);for(const N of x)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),this._resourceStatesDisposablesMap.get(N)?.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=m,A}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class c{constructor(m,v,w,A,M,T){this._extension=m,this._commands=w,this._id=A,this._label=M,this._rootUri=T,E.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new _.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new _.MutableDisposable,this._statusBarDisposables=new _.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=c._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,nt(this,E,v,"f"),this._inputBox=new i(m,Le(this,E,"f"),this.handle),Le(this,E,"f").$registerSourceControl(this.handle,A,M,T)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(m){this._count!==m&&(this._count=m,Le(this,E,"f").$updateSourceControl(this.handle,{count:m}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(m){this._quickDiffProvider=m,Le(this,E,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!m})}get commitTemplate(){return this._commitTemplate}set commitTemplate(m){m!==this._commitTemplate&&(this._commitTemplate=m,Le(this,E,"f").$updateSourceControl(this.handle,{commitTemplate:m}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(m){this._acceptInputDisposables.value=new _.DisposableStore,this._acceptInputCommand=m;const v=this._commands.converter.toInternal(m,this._acceptInputDisposables.value);Le(this,E,"f").$updateSourceControl(this.handle,{acceptInputCommand:v})}get actionButton(){return(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(m){(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new _.DisposableStore,this._actionButton=m;const v=m!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;Le(this,E,"f").$updateSourceControl(this.handle,{actionButton:v??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(m){if(this._statusBarCommands&&m&&a(this._statusBarCommands,m))return;this._statusBarDisposables.value=new _.DisposableStore,this._statusBarCommands=m;const v=(m||[]).map(w=>this._commands.converter.toInternal(w,this._statusBarDisposables.value));Le(this,E,"f").$updateSourceControl(this.handle,{statusBarCommands:v})}get selected(){return this._selected}createResourceGroup(m,v){const w=new r(Le(this,E,"f"),this._commands,this.handle,m,v),A=t.Event.once(w.onDidDispose)(()=>this.createdResourceGroups.delete(w));return this.createdResourceGroups.set(w,A),this.eventuallyAddResourceGroups(),w}eventuallyAddResourceGroups(){const m=[],v=[];for(const[w,A]of this.createdResourceGroups){A.dispose();const M=w.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(w),this.eventuallyUpdateResourceStates()});t.Event.once(w.onDidDispose)(()=>{this.updatedResourceGroups.delete(w),M.dispose(),this._groups.delete(w.handle),Le(this,E,"f").$unregisterGroup(this.handle,w.handle)}),m.push([w.handle,w.id,w.label,w.features]);const T=w._takeResourceStateSnapshot();T.length>0&&v.push([w.handle,T]),this._groups.set(w.handle,w)}Le(this,E,"f").$registerGroups(this.handle,m,v),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const m=[];this.updatedResourceGroups.forEach(v=>{const w=v._takeResourceStateSnapshot();w.length!==0&&m.push([v.handle,w])}),m.length>0&&Le(this,E,"f").$spliceResourceStates(this.handle,m),this.updatedResourceGroups.clear()}getResourceGroup(m){return this._groups.get(m)}setSelectionState(m){this._selected=m,this._onDidChangeSelection.fire(m)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(m=>m.dispose()),Le(this,E,"f").$unregisterSourceControl(this.handle)}}E=new WeakMap,c._handlePool=0,je([(0,I.debounce)(100)],c.prototype,"eventuallyAddResourceGroups",null),je([(0,I.debounce)(100)],c.prototype,"eventuallyUpdateResourceStates",null);let o=class Vi{constructor(m,v,w){this._commands=v,this.logService=w,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=m.getProxy(k.MainContext.MainThreadSCM),this._telemetry=m.getProxy(k.MainContext.MainThreadTelemetry),v.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const M=this._sourceControls.get(A.sourceControlHandle);if(!M)return A;const T=M.getResourceGroup(A.groupHandle);return T?T.getResourceState(A.handle):A}else if(A&&A.$mid===4){const M=this._sourceControls.get(A.sourceControlHandle);return M?M.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const M=this._sourceControls.get(A.handle);return M||A}return A}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(m,v,w,A){this.logService.trace("ExtHostSCM#createSourceControl",m.identifier.value,v,w,A),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:m.identifier.value});const M=Vi._handlePool++,T=new c(m,this._proxy,this._commands,v,w,A);this._sourceControls.set(M,T);const O=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(m.identifier))||[];return O.push(T),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(m.identifier),O),T}getLastInputBox(m){this.logService.trace("ExtHostSCM#getLastInputBox",m.identifier.value);const v=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(m.identifier)),w=v&&v[v.length-1];return w&&w.inputBox}$provideOriginalResource(m,v,w){const A=f.URI.revive(v);this.logService.trace("ExtHostSCM#$provideOriginalResource",m,A.toString());const M=this._sourceControls.get(m);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>M.quickDiffProvider.provideOriginalResource(A,w)).then(T=>T||null)}$onInputBoxValueChange(m,v){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",m);const w=this._sourceControls.get(m);return w&&w.inputBox.$onInputBoxValueChange(v),Promise.resolve(void 0)}$executeResourceCommand(m,v,w,A){this.logService.trace("ExtHostSCM#$executeResourceCommand",m,v,w);const M=this._sourceControls.get(m);if(!M)return Promise.resolve(void 0);const T=M.getResourceGroup(v);return T?T.$executeResourceCommand(w,A):Promise.resolve(void 0)}$validateInput(m,v,w){this.logService.trace("ExtHostSCM#$validateInput",m);const A=this._sourceControls.get(m);return!A||!A.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>A.inputBox.validateInput(v,w)).then(M=>{if(!M)return Promise.resolve(void 0);const T=b.MarkdownString.fromStrict(M.message);return T?Promise.resolve([T,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(m){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",m),m!==void 0&&this._sourceControls.get(m)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=m,Promise.resolve(void 0)}};o._handlePool=0,o=je([ze(2,L.ILogService)],o),e.ExtHostSCM=o});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[249],ve([0,1,7,5,167,6,15,18]),function(Z,e,f,t,I,_,R,k){"use strict";var y,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(p,g,E,F,D=f.StatusBarAlignment.Left,u){y.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new _.DisposableStore,nt(this,y,p,"f"),nt(this,P,g,"f"),this._entryId=L.ID_GEN++,this._extension=E,this._id=F,this._alignment=D,this._priority=this.validatePriority(u)}validatePriority(p){if(!!(0,k.isNumber)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(p){this._text=p,this.update()}set name(p){this._name=p,this.update()}set tooltip(p){this._tooltip=p,this.update()}set color(p){this._color=p,this.update()}set backgroundColor(p){p&&!L.ALLOWED_BACKGROUND_COLORS.has(p.id)&&(p=void 0),this._backgroundColor=p,this.update()}set command(p){this._command?.fromApi!==p&&(this._internalCommandRegistration.clear(),typeof p=="string"?this._command={fromApi:p,internal:Le(this,P,"f").toInternal({title:"",command:p},this._internalCommandRegistration)}:p?this._command={fromApi:p,internal:Le(this,P,"f").toInternal(p,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(p){this._accessibilityInformation=p,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Le(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let p;this._extension?this._id?p=`${this._extension.identifier.value}.${this._id}`:p=this._extension.identifier.value:p=this._id;let g;this._name?g=this._name:g=(0,I.localize)(0,null,this._extension.displayName||this._extension.name);let E=this._color;this._backgroundColor&&(E=L.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const F=this._tooltip?R.MarkdownString.fromStrict(this._tooltip):void 0;Le(this,y,"f").$setEntry(this._entryId,p,g,this._text,F,this._command?.internal,E,this._backgroundColor,this._alignment===f.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=L,y=new WeakMap,P=new WeakMap,L.ID_GEN=0,L.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new f.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new f.ThemeColor("statusBarItem.warningForeground")]]);class C{constructor(p){this._messages=[],this._item=p.createStatusBarEntry(void 0,"status.extensionMessage",f.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,I.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(p){const g={message:p};return this._messages.unshift(g),this._update(),new f.Disposable(()=>{const E=this._messages.indexOf(g);E>=0&&(this._messages.splice(E,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class l{constructor(p,g){this._proxy=p.getProxy(t.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new C(this)}createStatusBarEntry(p,g,E,F){return new L(this._proxy,this._commands,p,g,E,F)}setStatusBarMessage(p,g){const E=this._statusMessage.setMessage(p);let F;return typeof g=="number"?F=setTimeout(()=>E.dispose(),g):typeof g!="undefined"&&g.then(()=>E.dispose(),()=>E.dispose()),new f.Disposable(()=>{E.dispose(),clearTimeout(F)})}}e.ExtHostStatusBar=l}),define(pe[90],ve([0,1,5,3,4]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class _{constructor(k){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(f.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,y){this._proxy.$registerExtensionStorageKeysToSync(k,y)}initializeExtensionStorage(k,y,P){return this._proxy.$initializeExtensionStorage(k,y).then(L=>L||P)}setValue(k,y,P){return this._proxy.$setValue(k,y,P)}$acceptValue(k,y,P){this._onDidChangeStorage.fire({shared:k,key:y,value:P})}}e.ExtHostStorage=_,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(pe[68],ve([0,1,4,26,11,67,2]),function(Z,e,f,t,I,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,f.createDecorator)("IExtensionStoragePaths");let k=class{constructor(P,L,C){this._logService=L,this._extHostFileSystem=C,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(l=>this._value=l)}async _getWorkspaceStorageURI(P){return R.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,L=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(L),this._logService.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",L),await this._extHostFileSystem.value.createDirectory(L),await this._extHostFileSystem.value.writeFile(R.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:R.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),L}catch(C){this._logService.error("[ExtHostStorage]",C);return}}workspaceValue(P){if(this._value)return R.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return R.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=je([ze(0,t.IExtHostInitDataService),ze(1,I.ILogService),ze(2,_.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(pe[34],ve([0,1,3,5,4,2,14,6,7,168,16,214,21,33,196,85,18,13]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p,g,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class D{constructor(c,o,d,m){this._proxy=c,this._id=o,this._creationOptions=d,this._name=m,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(w=>this._pidPromiseComplete=w);const v=this;this.value={get name(){return v._name||""},get processId(){return v._pidPromise},get creationOptions(){return v._creationOptions},get exitStatus(){return v._exitStatus},get state(){return v._state},sendText(w,A=!0){v._checkDisposed(),v._proxy.$sendText(v._id,w,A)},show(w){v._checkDisposed(),v._proxy.$show(v._id,w)},hide(){v._checkDisposed(),v._proxy.$hide(v._id)},dispose(){v._disposed||(v._disposed=!0,v._proxy.$dispose(v._id))},get dimensions(){if(!(v._cols===void 0||v._rows===void 0))return{columns:v._cols,rows:v._rows}}}}async create(c,o){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:c.name,shellPath:(0,E.withNullAsUndefined)(c.shellPath),shellArgs:(0,E.withNullAsUndefined)(c.shellArgs),cwd:(0,E.withNullAsUndefined)(c.cwd),env:(0,E.withNullAsUndefined)(c.env),icon:(0,E.withNullAsUndefined)(a(c.iconPath)),color:g.ThemeColor.isThemeColor(c.color)?c.color.id:void 0,initialText:(0,E.withNullAsUndefined)(c.message),strictEnv:(0,E.withNullAsUndefined)(c.strictEnv),hideFromUser:(0,E.withNullAsUndefined)(c.hideFromUser),isFeatureTerminal:(0,E.withNullAsUndefined)(o?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,E.withNullAsUndefined)(o?.useShellEnvironment),location:o?.location||this._serializeParentTerminal(c.location,o?.resolvedExtHostIdentifier),disablePersistence:(0,E.withNullAsUndefined)(c.disablePersistence)})}async createExtensionTerminal(c,o,d,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:d,color:g.ThemeColor.isThemeColor(m)?m.id:void 0,location:this._serializeParentTerminal(c,o),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(c,o){return typeof c=="object"?"parentTerminal"in c&&c.parentTerminal&&o?{parentTerminal:o}:"viewColumn"in c?{viewColumn:c.viewColumn,preserveFocus:c.preserveFocus}:void 0:c}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(c){this._name=c}setExitCode(c){this._exitStatus=Object.freeze({code:c})}setDimensions(c,o){return c===this._cols&&o===this._rows||c===0||o===0?!1:(this._cols=c,this._rows=o,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(c){this._pidPromiseComplete?(this._pidPromiseComplete(c),this._pidPromiseComplete=void 0):this._pidPromise.then(o=>{o!==c&&(this._pidPromise=Promise.resolve(c))})}}e.ExtHostTerminal=D;class u{constructor(c){this._pty=c,this.id=0,this.shouldPersist=!1,this._onProcessData=new f.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new f.Emitter,this._onDidChangeProperty=new f.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new f.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(c){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${c}`)}updateProperty(c,o){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${c}, value: ${o}`)}async start(){}shutdown(){this._pty.close()}input(c){this._pty.handleInput?.(c)}resize(c,o){this._pty.setDimensions?.({columns:c,rows:o})}async processBinary(c){}acknowledgeDataEvent(c){}async setUnicodeVersion(c){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(c){this._pty.onDidWrite(o=>this._onProcessData.fire(o)),this._pty.onDidClose?.((o=void 0)=>{this._onProcessExit.fire(o===void 0?void 0:o)}),this._pty.onDidOverrideDimensions?.(o=>{o&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:o.columns,rows:o.rows}})}),this._pty.onDidChangeName?.(o=>{this._onDidChangeProperty.fire({type:"title",value:o})}),this._pty.open(c||void 0),c&&this._pty.setDimensions?.(c),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=u;let s=1,h=class extends k.Disposable{constructor(c,o){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new f.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new f.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new f.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new f.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new f.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=o.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new p.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new f.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(c),this._register({dispose:()=>{for(const[d,m]of this._terminalProcesses)m.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(c=>c.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(c,o){const d=new D(this._proxy,(0,b.generateUuid)(),c,c.name),m=new u(c.pty);return d.createExtensionTerminal(c.location,this._serializeParentTerminal(c,o).resolvedExtHostIdentifier,a(c.iconPath),i(c.color)).then(v=>{const w=this._setupExtHostProcessListeners(v,m);this._terminalProcessDisposables[v]=w}),this._terminals.push(d),d.value}_serializeParentTerminal(c,o){if(o=o||{},c.location&&typeof c.location=="object"&&"parentTerminal"in c.location){const d=c.location.parentTerminal;if(d){const m=this._terminals.find(v=>v.value===d);m&&(o.resolvedExtHostIdentifier=m._id)}}else c.location&&typeof c.location!="object"?o.location=c.location:o.location&&typeof o.location=="object"&&"splitActiveTerminal"in o.location&&(o.location={splitActiveTerminal:!0});return o}attachPtyToTerminal(c,o){if(!this._getTerminalById(c))throw new Error(`Cannot resolve terminal with id ${c} for virtual process`);const m=new u(o),v=this._setupExtHostProcessListeners(c,m);this._terminalProcessDisposables[c]=v}async $acceptActiveTerminalChanged(c){const o=this._activeTerminal;if(c===null){this._activeTerminal=void 0,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const d=this._getTerminalById(c);d&&(this._activeTerminal=d,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(c,o){const d=this._getTerminalById(c);d&&this._onDidWriteTerminalData.fire({terminal:d.value,data:o})}async $acceptTerminalDimensions(c,o,d){const m=this._getTerminalById(c);m&&m.setDimensions(o,d)&&this._onDidChangeTerminalDimensions.fire({terminal:m.value,dimensions:m.value.dimensions})}async $acceptTerminalMaximumDimensions(c,o,d){this._terminalProcesses.get(c)?.resize(o,d)}async $acceptTerminalTitleChange(c,o){const d=this._getTerminalById(c);d&&(d.name=o)}async $acceptTerminalClosed(c,o){const d=this._getTerminalObjectIndexById(this._terminals,c);if(d!==null){const m=this._terminals.splice(d,1)[0];m.setExitCode(o),this._onDidCloseTerminal.fire(m.value)}}$acceptTerminalOpened(c,o,d,m){if(o){const A=this._getTerminalObjectIndexById(this._terminals,o);if(A!==null){this._terminals[A]._id=c,this._onDidOpenTerminal.fire(this.terminals[A]),this._terminals[A].isOpen=!0;return}}const v={name:m.name,shellPath:m.executable,shellArgs:m.args,cwd:typeof m.cwd=="string"?m.cwd:_.URI.revive(m.cwd),env:m.env,hideFromUser:m.hideFromUser},w=new D(this._proxy,c,v,d);this._terminals.push(w),this._onDidOpenTerminal.fire(w.value),w.isOpen=!0}async $acceptTerminalProcessId(c,o){const d=this._getTerminalById(c);d&&d._setProcessId(o)}async $startExtensionTerminal(c,o){const d=this._getTerminalById(c);if(!d)return{message:(0,P.localize)(0,null,c)};d.isOpen||await new Promise(v=>{const w=this.onDidOpenTerminal(async A=>{A===d.value&&(w.dispose(),v())})});const m=this._terminalProcesses.get(c);m?m.startSendingEvents(o):this._extensionTerminalAwaitingStart[c]={initialDimensions:o}}_setupExtHostProcessListeners(c,o){const d=new k.DisposableStore;d.add(o.onProcessReady(v=>this._proxy.$sendProcessReady(c,v.pid,v.cwd))),d.add(o.onDidChangeProperty(v=>this._proxy.$sendProcessProperty(c,v))),this._bufferer.startBuffering(c,o.onProcessData),d.add(o.onProcessExit(v=>this._onProcessExit(c,v))),this._terminalProcesses.set(c,o);const m=this._extensionTerminalAwaitingStart[c];return m&&o instanceof u&&(o.startSendingEvents(m.initialDimensions),delete this._extensionTerminalAwaitingStart[c]),d}$acceptProcessAckDataEvent(c,o){this._terminalProcesses.get(c)?.acknowledgeDataEvent(o)}$acceptProcessInput(c,o){this._terminalProcesses.get(c)?.input(o)}$acceptTerminalInteraction(c){const o=this._getTerminalById(c);o?.setInteractedWith()&&this._onDidChangeTerminalState.fire(o.value)}$acceptProcessResize(c,o,d){try{this._terminalProcesses.get(c)?.resize(o,d)}catch(m){if(m.code!=="EPIPE"&&m.code!=="ERR_IPC_CHANNEL_CLOSED")throw m}}$acceptProcessShutdown(c,o){this._terminalProcesses.get(c)?.shutdown(o)}$acceptProcessRequestInitialCwd(c){this._terminalProcesses.get(c)?.getInitialCwd().then(o=>this._proxy.$sendProcessProperty(c,{type:"initialCwd",value:o}))}$acceptProcessRequestCwd(c){this._terminalProcesses.get(c)?.getCwd().then(o=>this._proxy.$sendProcessProperty(c,{type:"cwd",value:o}))}$acceptProcessRequestLatency(c){return Promise.resolve(c)}registerLinkProvider(c){return this._linkProviders.add(c),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(c),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(c,o,d){if(this._profileProviders.has(o))throw new Error(`Terminal profile provider "${o}" already registered`);return this._profileProviders.set(o,d),this._proxy.$registerProfileProvider(o,c.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(o),this._proxy.$unregisterProfileProvider(o)})}async $createContributedProfileTerminal(c,o){const d=new l.CancellationTokenSource().token;let m=await this._profileProviders.get(c)?.provideTerminalProfile(d);if(!d.isCancellationRequested){if(m&&!("options"in m)&&(m={options:m}),!m||!("options"in m))throw new Error(`No terminal profile options provided for id "${c}"`);if("pty"in m.options){this.createExtensionTerminal(m.options,o);return}this.createTerminalFromOptions(m.options,o)}}async $provideLinks(c,o){const d=this._getTerminalById(c);if(!d)return[];this._terminalLinkCache.delete(c);const m=this._terminalLinkCancellationSource.get(c);m&&m.dispose(!0);const v=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(c,v);const w=[],A={terminal:d.value,line:o},M=[];for(const U of this._linkProviders)M.push(F.Promises.withAsyncBody(async V=>{v.token.onCancellationRequested(()=>V({provider:U,links:[]}));const x=await U.provideTerminalLinks(A,v.token)||[];v.token.isCancellationRequested||V({provider:U,links:x})}));const T=await Promise.all(M);if(v.token.isCancellationRequested)return[];const O=new Map;for(const U of T)U&&U.links.length>0&&w.push(...U.links.map(V=>{const x={id:s++,startIndex:V.startIndex,length:V.length,label:V.tooltip};return O.set(x.id,{provider:U.provider,link:V}),x}));return this._terminalLinkCache.set(c,O),w}$activateLink(c,o){const d=this._terminalLinkCache.get(c)?.get(o);!d||d.provider.handleTerminalLink(d.link)}_onProcessExit(c,o){this._bufferer.stopBuffering(c),this._terminalProcesses.delete(c),delete this._extensionTerminalAwaitingStart[c];const d=this._terminalProcessDisposables[c];d&&(d.dispose(),delete this._terminalProcessDisposables[c]),this._proxy.$sendProcessExit(c,o)}_getTerminalById(c){return this._getTerminalObjectById(this._terminals,c)}_getTerminalObjectById(c,o){const d=this._getTerminalObjectIndexById(c,o);return d!==null?c[d]:null}_getTerminalObjectIndexById(c,o){let d=null;return c.some((m,v)=>m._id===o?(d=v,!0):!1),d}getEnvironmentVariableCollection(c){let o=this._environmentVariableCollections.get(c.identifier.value);return o||(o=new n,this._setEnvironmentVariableCollection(c.identifier.value,o)),o}_syncEnvironmentVariableCollection(c,o){const d=(0,C.serializeEnvironmentVariableCollection)(o.map);this._proxy.$setEnvironmentVariableCollection(c,o.persistent,d.length===0?void 0:d)}$initEnvironmentVariableCollections(c){c.forEach(o=>{const d=o[0],m=new n(o[1]);this._setEnvironmentVariableCollection(d,m)})}$acceptDefaultProfile(c,o){this._defaultProfile=c,this._defaultAutomationProfile=o}_setEnvironmentVariableCollection(c,o){this._environmentVariableCollections.set(c,o),o.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(c,o)})}};h=je([ze(1,R.IExtHostRpcService)],h),e.BaseExtHostTerminalService=h;class n{constructor(c){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new f.Emitter,this.map=new Map(c)}get persistent(){return this._persistent}set persistent(c){this._persistent=c,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(c,o){this._setIfDiffers(c,{value:o,type:y.EnvironmentVariableMutatorType.Replace})}append(c,o){this._setIfDiffers(c,{value:o,type:y.EnvironmentVariableMutatorType.Append})}prepend(c,o){this._setIfDiffers(c,{value:o,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(c,o){const d=this.map.get(c);(!d||d.value!==o.value||d.type!==o.type)&&(this.map.set(c,o),this._onDidChangeCollection.fire())}get(c){return this.map.get(c)}forEach(c,o){this.map.forEach((d,m)=>c.call(o,m,d,this))}delete(c){this.map.delete(c),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=n;let S=class extends h{constructor(c){super(!1,c)}createTerminal(c,o,d){throw new L.NotSupportedError}createTerminalFromOptions(c,o){throw new L.NotSupportedError}};S=je([ze(0,R.IExtHostRpcService)],S),e.WorkerExtHostTerminalService=S;function a(r){if(!(!r||typeof r=="string"))return"id"in r?{id:r.id,color:r.color}:r}function i(r){return g.ThemeColor.isThemeColor(r)?r:void 0}});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[250],ve([0,1,17,22,21,3,76,58,6,25,18,33,5,14,64,15,7,220,128,88]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p,g,E,F,D,u){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let h=class{constructor(A,M){this.resultsChangedEmitter=new _.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=A.getProxy(l.MainContext.MainThreadTesting),this.observer=new d(this.proxy),this.runTracker=new S(this.proxy),M.registerArgumentProcessor({processArgument:T=>T?.$mid===13?g.TestItem.toItemFromContext(T):T})}createTestController(A,M,T){if(this.controllers.has(A))throw new Error(`Attempt to insert a duplicate controller with ID "${A}"`);const O=new y.DisposableStore,U=O.add(new F.SingleUseTestCollection(A));U.root.label=M;const V=new Map,x=this.proxy,N={items:U.root.children,get label(){return M},set label(W){M=W,U.root.label=W,x.$updateController(A,{label:M})},get refreshHandler(){return T},set refreshHandler(W){T=W,x.$updateController(A,{canRefresh:!!W})},get id(){return A},createRunProfile:(W,H,z,J,ie)=>{let se=(0,k.hash)(W);for(;V.has(se);)se++;const K=new m(this.proxy,A,se,W,H,z,J,ie);return V.set(se,K),K},createTestItem(W,H,z){return new p.TestItemImpl(A,W,H,z)},createTestRun:(W,H,z=!0)=>this.runTracker.createTestRun(A,U,W,H,z),set resolveHandler(W){U.resolveHandler=W},get resolveHandler(){return U.resolveHandler},dispose:()=>{O.dispose()}};x.$registerTestController(A,M,!!T),O.add((0,y.toDisposable)(()=>x.$unregisterTestController(A)));const B={controller:N,collection:U,profiles:V};return this.controllers.set(A,B),O.add((0,y.toDisposable)(()=>this.controllers.delete(A))),O.add(U.onDidGenerateDiff(W=>x.$publishDiff(A,W))),N}createTestObserver(){return this.observer.checkout()}async runTests(A,M=I.CancellationToken.None){const T=a(A);if(!T)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const O=this.controllers.get(T.controllerId);if(!O)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:A.include?.map(U=>U.id)??[O.collection.root.id],profileGroup:v[T.kind],profileId:T.profileId,controllerId:T.controllerId}],exclude:A.exclude?.map(U=>U.id)},M)}$provideFileCoverage(A,M,T){return(0,f.mapFind)(this.runTracker.trackers,U=>U.id===A?U.getCoverage(M):void 0)?.provideFileCoverage(T)??Promise.resolve([])}$resolveFileCoverage(A,M,T,O){return(0,f.mapFind)(this.runTracker.trackers,V=>V.id===A?V.getCoverage(M):void 0)?.resolveFileCoverage(T,O)??Promise.resolve([])}$configureRunProfile(A,M){this.controllers.get(A)?.profiles.get(M)?.configureHandler?.()}async $refreshTests(A,M){await this.controllers.get(A)?.controller.refreshHandler?.(M)}$publishTestResults(A){this.results=Object.freeze(A.map(M=>(0,P.deepFreeze)(g.TestResults.to(M))).concat(this.results).sort((M,T)=>T.completedAt-M.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(A,M){const T=this.controllers.get(u.TestId.fromString(A).controllerId)?.collection;T&&(await T.expand(A,M<0?1/0:M),T.flushDiff())}$acceptDiff(A){this.observer.applyDiff(A)}async $runControllerTests(A,M){const T=this.controllers.get(A.controllerId);if(!T)return;const{collection:O,profiles:U}=T,V=U.get(A.profileId);if(!V)return;const x=A.testIds.map(H=>O.tree.get(H)).filter(L.isDefined),N=A.excludeExtIds.map(H=>T.collection.tree.get(H)).filter(L.isDefined).filter(H=>x.some(z=>z.fullId.compare(H.fullId)===2));if(!x.length)return;const B=new E.TestRunRequest(x.some(H=>H.actual instanceof p.TestItemRootImpl)?void 0:x.map(H=>H.actual),N.map(H=>H.actual),V),W=this.runTracker.prepareForMainThreadTestRun(B,i.fromInternal(A,T.collection),M);try{await V.runHandler(B,M)}finally{W.isRunning&&!M.isCancellationRequested&&await _.Event.toPromise(W.onEnd),W.dispose()}}$cancelExtensionTestRun(A){A===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(A)}};h=je([ze(0,b.IExtHostRpcService)],h),e.ExtHostTesting=h;class n extends y.Disposable{constructor(A,M,T){super();this.dto=A,this.proxy=M,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new _.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new I.CancellationTokenSource(T)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:O}of this.tasks.values())O.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(A){return this.tasks.get(A)?.coverage}createRun(A){const M=this.dto.id,T=this.dto.controllerId,O=(0,C.generateUuid)(),U=new r(this.proxy,M,O),V=W=>(H,...z)=>{if(N){console.warn(`Setting the state of test "${H.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(H)||(this.ensureTestIsKnown(H),W(H,...z))},x=(W,H)=>{const z=H instanceof Array?H.map(g.TestMessage.from):[g.TestMessage.from(H)];if(W.uri&&W.range){const J={range:g.Range.from(W.range),uri:W.uri};for(const ie of z)ie.location=ie.location||J}this.proxy.$appendTestMessagesInRun(M,O,u.TestId.fromExtHostTestItem(W,T).toString(),z)};let N=!1;const B={isPersisted:this.dto.isPersisted,token:this.cts.token,name:A,get coverageProvider(){return U.coverageProvider},set coverageProvider(W){U.coverageProvider=W},enqueued:V(W=>{this.proxy.$updateTestStateInRun(M,O,u.TestId.fromExtHostTestItem(W,T).toString(),1)}),skipped:V(W=>{this.proxy.$updateTestStateInRun(M,O,u.TestId.fromExtHostTestItem(W,T).toString(),5)}),started:V(W=>{this.proxy.$updateTestStateInRun(M,O,u.TestId.fromExtHostTestItem(W,T).toString(),2)}),errored:V((W,H,z)=>{x(W,H),this.proxy.$updateTestStateInRun(M,O,u.TestId.fromExtHostTestItem(W,T).toString(),6,z)}),failed:V((W,H,z)=>{x(W,H),this.proxy.$updateTestStateInRun(M,O,u.TestId.fromExtHostTestItem(W,T).toString(),4,z)}),passed:V((W,H)=>{this.proxy.$updateTestStateInRun(M,O,u.TestId.fromExtHostTestItem(W,this.dto.controllerId).toString(),3,H)}),appendOutput:(W,H,z)=>{N||(z&&(this.dto.isIncluded(z)?this.ensureTestIsKnown(z):z=void 0),this.proxy.$appendOutputToRun(M,O,t.VSBuffer.fromString(W),H&&g.location.from(H),z&&u.TestId.fromExtHostTestItem(z,T).toString()))},end:()=>{N||(N=!0,this.proxy.$finishedTestRunTask(M,O),this.tasks.delete(O),this.isRunning||this.dispose())}};return this.tasks.set(O,{run:B,coverage:U}),this.proxy.$startedTestRunTask(M,{id:O,name:A,running:!0}),B}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(A){if(!(A instanceof p.TestItemImpl))throw new p.InvalidTestItemError(A.id);if(this.sharedTestIds.has(u.TestId.fromExtHostTestItem(A,this.dto.controllerId).toString()))return;const M=[],T=this.dto.colllection.root;for(;;){const O=g.TestItem.from(A);if(M.unshift(O),this.sharedTestIds.has(O.extId)||(this.sharedTestIds.add(O.extId),A===T))break;A=A.parent||T}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,M)}}class S{constructor(A){this.proxy=A,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(A,M,T){return this.getTracker(A,M,T)}cancelRunById(A){for(const M of this.tracked.values())if(M.id===A){M.dispose();return}}cancelAllRuns(){for(const A of this.tracked.values())A.dispose()}createTestRun(A,M,T,O,U){const V=this.tracked.get(T);if(V)return V.createRun(O);const x=i.fromPublic(A,M,T,U),N=a(T);this.proxy.$startedExtensionTestRun({controllerId:A,profile:N&&{group:v[N.kind],id:N.profileId},exclude:T.exclude?.map(W=>W.id)??[],id:x.id,include:T.include?.map(W=>W.id)??[M.root.id],persist:U});const B=this.getTracker(T,x);return B.onEnd(()=>this.proxy.$finishedExtensionTestRun(x.id)),B.createRun(O)}getTracker(A,M,T){const O=new n(M,this.proxy,T);return this.tracked.set(A,O),O.onEnd(()=>this.tracked.delete(A)),O}}e.TestRunCoordinator=S;const a=w=>{if(!!w.profile){if(!(w.profile instanceof m))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return w.profile}};class i{constructor(A,M,T,O,U,V){this.controllerId=A,this.id=M,this.isPersisted=U,this.colllection=V,this.includePrefix=T.map(x=>x+"\0"),this.excludePrefix=O.map(x=>x+"\0")}static fromPublic(A,M,T,O){return new i(A,(0,C.generateUuid)(),T.include?.map(U=>u.TestId.fromExtHostTestItem(U,A).toString())??[A],T.exclude?.map(U=>u.TestId.fromExtHostTestItem(U,A).toString())??[],O,M)}static fromInternal(A,M){return new i(A.controllerId,A.runId,A.testIds,A.excludeExtIds,!0,M)}isIncluded(A){const M=u.TestId.fromExtHostTestItem(A,this.controllerId).toString()+"\0";for(const T of this.excludePrefix)if(M===T||M.startsWith(T))return!1;for(const T of this.includePrefix)if(M===T||M.startsWith(T))return!0;return!1}}e.TestRunDto=i;class r{constructor(A,M,T){this.proxy=A,this.runId=M,this.taskId=T}set coverageProvider(A){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!A||(this._coverageProvider=A,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(A){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(A))());try{return(await this.fileCoverage)?.map(g.TestCoverage.fromFile)??[]}catch(M){throw this.fileCoverage=void 0,M}}async resolveFileCoverage(A,M){const T=await this.fileCoverage;let O=T?.[A];return!this._coverageProvider||!T||!O?[]:(O.detailedCoverage||(O=T[A]=await this._coverageProvider.resolveFileCoverage?.(O,M)??O),O.detailedCoverage?.map(g.TestCoverage.fromDetailed)??[])}}class c extends D.IncrementalChangeCollector{constructor(A){super();this.emitter=A,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(A){this.added.add(A)}update(A){Object.assign(A.revived,g.TestItem.toPlain(A.item)),this.added.has(A)||this.updated.add(A)}remove(A){if(this.added.has(A)){this.added.delete(A);return}if(this.updated.delete(A),A.parent&&this.alreadyRemoved.has(A.parent)){this.alreadyRemoved.add(A.item.extId);return}this.removed.add(A)}getChangeEvent(){const{added:A,updated:M,removed:T}=this;return{get added(){return[...A].map(O=>O.revived)},get updated(){return[...M].map(O=>O.revived)},get removed(){return[...T].map(O=>O.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class o extends D.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new _.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(A){return this.items.get(A)}getMirroredTestDataByReference(A){return this.items.get(A.id)}createItem(A,M){return{...A,revived:g.TestItem.toPlain(A.item),depth:M?M.depth+1:0,children:new Set}}createChangeCollector(){return new c(this.changeEmitter)}}e.MirroredTestCollection=o;class d{constructor(A){this.proxy=A}checkout(){this.current||(this.current=this.createObserverData());const A=this.current;return A.observers++,{onDidChangeTest:A.tests.onDidChangeTests,get tests(){return[...A.tests.rootTests].map(M=>M.revived)},dispose:(0,R.once)(()=>{--A.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(A){return this.current?.tests.getMirroredTestDataByReference(A)}applyDiff(A){this.current?.tests.apply(A)}createObserverData(){const A=new o;return this.proxy.$subscribeToDiffs(),{observers:0,tests:A}}}class m{constructor(A,M,T,O,U,V,x=!1,N=void 0){this.controllerId=M,this.profileId=T,this._label=O,this.kind=U,this.runHandler=V,this._isDefault=x,this._tag=N,s.set(this,void 0),nt(this,s,A,"f");const B=v[U];if(typeof B!="number")throw new Error(`Unknown TestRunProfile.group ${U}`);Le(this,s,"f").$publishTestRunProfile({profileId:T,controllerId:M,tag:N?g.TestTag.namespace(this.controllerId,N.id):null,label:O,group:B,isDefault:x,hasConfigurationHandler:!1})}get label(){return this._label}set label(A){A!==this._label&&(this._label=A,Le(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:A}))}get isDefault(){return this._isDefault}set isDefault(A){A!==this._isDefault&&(this._isDefault=A,Le(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:A}))}get tag(){return this._tag}set tag(A){A?.id!==this._tag?.id&&(this._tag=A,Le(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:A?g.TestTag.namespace(this.controllerId,A.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(A){A!==this._configureHandler&&(this._configureHandler=A,Le(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!A}))}dispose(){Le(this,s,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=m,s=new WeakMap;const v={[E.TestRunProfileKind.Coverage]:8,[E.TestRunProfileKind.Debug]:4,[E.TestRunProfileKind.Run]:2}}),define(pe[251],ve([0,1,3,17,5,131,15,7]),function(Z,e,f,t,I,_,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(L,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new f.Emitter,this._onDidChangeTextEditorOptions=new f.Emitter,this._onDidChangeTextEditorVisibleRanges=new f.Emitter,this._onDidChangeTextEditorViewColumn=new f.Emitter,this._onDidChangeActiveTextEditor=new f.Emitter,this._onDidChangeVisibleTextEditors=new f.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=L.getProxy(I.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(L){const C=this._extHostDocumentsAndEditors.allEditors();return L?C:C.map(l=>l.value)}async showTextDocument(L,C,l){let b;typeof C=="number"?b={position:R.ViewColumn.from(C),preserveFocus:l}:typeof C=="object"?b={position:R.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?R.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:b={preserveFocus:!1};const p=await this._proxy.$tryShowTextDocument(L.uri,b),g=p&&this._extHostDocumentsAndEditors.getEditor(p);if(g)return g.value;throw p?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,C){return new _.TextEditorDecorationType(this._proxy,L,C).value}$acceptEditorPropertiesChanged(L,C){const l=this._extHostDocumentsAndEditors.getEditor(L);if(!l)throw new Error("unknown text editor");if(C.options&&l._acceptOptions(C.options),C.selections){const b=C.selections.selections.map(R.Selection.to);l._acceptSelections(b)}if(C.visibleRanges){const b=t.coalesce(C.visibleRanges.map(R.Range.to));l._acceptVisibleRanges(b)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:{...C.options,lineNumbers:R.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const b=k.TextEditorSelectionChangeKind.fromValue(C.selections.source),p=C.selections.selections.map(R.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:p,kind:b})}if(C.visibleRanges){const b=t.coalesce(C.visibleRanges.map(R.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:b})}}$acceptEditorPositionData(L){for(const C in L){const l=this._extHostDocumentsAndEditors.getEditor(C);if(!l)throw new Error("Unknown text editor");const b=R.ViewColumn.to(L[C]);l.value.viewColumn!==b&&(l._acceptViewColumn(b),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:b}))}}getDiffInformation(L){return Promise.resolve(this._proxy.$getDiffInformation(L))}}e.ExtHostEditors=y}),define(pe[252],ve([0,1,2,4,5,6,7]),function(Z,e,f,t,I,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class k{constructor(L,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=L.getProxy(I.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===11){const b=l.uri===void 0?void 0:f.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(y(b))?.get(l.handle)}return l}})}async $getTimeline(L,C,l,b,p){return this._providers.get(L)?.provideTimeline(f.URI.revive(C),l,b,p)}registerTimelineProvider(L,C,l,b){const p=new _.DisposableStore,g=this.convertTimelineItem(C.id,b,p).bind(this);let E;C.onDidChange&&(E=C.onDidChange(D=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...D,id:C.id}),this));const F=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...C,scheme:L,onDidChange:void 0,async provideTimeline(D,u,s,h){h?.resetCache&&(p.clear(),F.get(C.id)?.clear());const n=await C.provideTimeline(D,u,s);if(n==null)return;const S=g(D,h);return{...n,source:C.id,items:n.items.map(S)}},dispose(){for(const D of F.values())D.get(C.id)?.clear();E?.dispose(),p.dispose()}})}convertTimelineItem(L,C,l){return(b,p)=>{let g;if(p?.cacheResults){let E=this._itemsBySourceAndUriMap.get(L);E===void 0&&(E=new Map,this._itemsBySourceAndUriMap.set(L,E));const F=y(b);g=E.get(F),g===void 0&&(g=new Map,E.set(F,g))}return E=>{const{iconPath:F,...D}=E,u=`${L}|${E.id??E.timestamp}`;g?.set(u,E);let s,h,n;return E.iconPath&&(F instanceof R.ThemeIcon?n={id:F.id,color:F.color}:f.URI.isUri(F)?(s=F,h=F):{light:s,dark:h}=F),{...D,id:D.id??void 0,handle:u,source:L,command:E.command?C.toInternal(E.command,l):void 0,icon:s,iconDark:h,themeIcon:n,accessibilityInformation:E.accessibilityInformation}}}}registerTimelineProviderCore(L){if(this._providers.get(L.id))throw new Error(`Timeline Provider ${L.id} already exists.`);return this._proxy.$registerTimelineProvider({id:L.id,label:L.label,scheme:L.scheme}),this._providers.set(L.id,L),(0,_.toDisposable)(()=>{for(const l of this._itemsBySourceAndUriMap.values())l.get(L.id)?.clear();this._providers.delete(L.id),this._proxy.$unregisterTimelineProvider(L.id),L.dispose()})}}e.ExtHostTimeline=k;function y(P){return P?.toString()}}),define(pe[253],ve([0,1,6,10,2,5]),function(Z,e,f,t,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{constructor(y){this._openers=new Map,this._proxy=y.getProxy(_.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,P,L,C){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const l=C.schemes.find(b=>!R.supportedSchemes.has(b));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,L),this._proxy.$registerUriOpener(P,C.schemes,y,C.label),(0,f.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(y,P,L){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener with id: ${y}`);const l=I.URI.revive(P);return C.canOpenExternalUri(l,L)}async $openUri(y,P,L){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener id: '${y}'`);return C.openExternalUri(I.URI.revive(P.resolvedUri),{sourceUri:I.URI.revive(P.sourceUri)},L)}}e.ExtHostUriOpeners=R,R.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(pe[254],ve([0,1,5,2,6,16,27]),function(Z,e,f,t,I,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(f.MainContext.MainThreadUrls)}registerUriHandler(P,L){if(this.handles.has(R.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const C=k.HandlePool++;return this.handles.add(R.ExtensionIdentifier.toKey(P)),this.handlers.set(C,L),this._proxy.$registerUriHandler(C,P),(0,I.toDisposable)(()=>{this.handles.delete(R.ExtensionIdentifier.toKey(P)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(P,L){const C=this.handlers.get(P);if(!C)return Promise.resolve(void 0);try{C.handleUri(t.URI.revive(L))}catch(l){(0,_.onUnexpectedError)(l)}return Promise.resolve(void 0)}async createAppUri(P){return t.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=k,k.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[69],ve([0,1,3,10,2,180,204,87,5]),function(Z,e,f,t,I,_,R,k,y){"use strict";var P,L,C,l,b,p,g,E,F,D,u,s;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class h{constructor(d,m,v,w,A,M,T){P.set(this,void 0),L.set(this,void 0),C.set(this,void 0),l.set(this,void 0),b.set(this,void 0),p.set(this,void 0),g.set(this,""),E.set(this,void 0),F.set(this,!1),D.set(this,!1),u.set(this,!1),this._onMessageEmitter=new f.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,s.set(this,new f.Emitter),this._onDidDispose=Le(this,s,"f").event,nt(this,P,d,"f"),nt(this,L,m,"f"),nt(this,E,v,"f"),nt(this,l,w,"f"),nt(this,b,A,"f"),nt(this,p,M,"f"),nt(this,u,n(M),"f"),nt(this,C,T,"f")}dispose(){nt(this,F,!0,"f"),Le(this,s,"f").fire(),Le(this,s,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(d){return nt(this,D,!0,"f"),(0,k.asWebviewUri)(d,Le(this,l,"f").remote)}get cspSource(){const d=Le(this,p,"f").extensionLocation;if(d.scheme===t.Schemas.https||d.scheme===t.Schemas.http){let m=d.toString();return m.endsWith("/")||(m+="/"),m+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Le(this,g,"f")}set html(d){this.assertNotDisposed(),Le(this,g,"f")!==d&&(nt(this,g,d,"f"),!Le(this,D,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(d)&&(nt(this,D,!0,"f"),Le(this,C,"f").report("Webview vscode-resource: uris",Le(this,p,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Le(this,L,"f").$setHtml(Le(this,P,"f"),d))}get options(){return this.assertNotDisposed(),Le(this,E,"f")}set options(d){this.assertNotDisposed(),Le(this,L,"f").$setOptions(Le(this,P,"f"),i(Le(this,p,"f"),Le(this,b,"f"),d)),nt(this,E,d,"f")}async postMessage(d){if(Le(this,F,"f"))return!1;const m=(0,R.serializeWebviewMessage)(d,{serializeBuffersForPostMessage:Le(this,u,"f")});return Le(this,L,"f").$postMessage(Le(this,P,"f"),m.message,...m.buffers)}assertNotDisposed(){if(Le(this,F,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=h,P=new WeakMap,L=new WeakMap,C=new WeakMap,l=new WeakMap,b=new WeakMap,p=new WeakMap,g=new WeakMap,E=new WeakMap,F=new WeakMap,D=new WeakMap,u=new WeakMap,s=new WeakMap;function n(o){try{const d=(0,_.normalizeVersion)((0,_.parseVersion)(o.engines.vscode));return!!d&&d.majorBase>=1&&d.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=n;class S{constructor(d,m,v,w,A){this.initData=m,this.workspace=v,this._logService=w,this._deprecationService=A,this._webviews=new Map,this._webviewProxy=d.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(d,m,v){const w=this.getWebview(d);if(w){const{message:A}=(0,R.deserializeWebviewMessage)(m,v.value);w._onMessageEmitter.fire(A)}}$onMissingCsp(d,m){this._logService.warn(`${m} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(d,m,v){const w=new h(d,this._webviewProxy,r(m),this.initData,this.workspace,v,this._deprecationService);return this._webviews.set(d,w),w._onDidDispose(()=>{this._webviews.delete(d)}),w}deleteWebview(d){this._webviews.delete(d)}getWebview(d){return this._webviews.get(d)}}e.ExtHostWebviews=S;function a(o){return{id:o.identifier,location:o.extensionLocation}}e.toExtensionData=a;function i(o,d,m){return{enableCommandUris:m.enableCommandUris,enableScripts:m.enableScripts,enableForms:m.enableForms,portMapping:m.portMapping,localResourceRoots:m.localResourceRoots||c(o,d)}}e.serializeWebviewOptions=i;function r(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(d=>I.URI.from(d))}}e.reviveOptions=r;function c(o,d){return[...(d?.getWorkspaceFolders()||[]).map(m=>m.uri),o.extensionLocation]}}),define(pe[255],ve([0,1,21,58,6,10,23,2,15,69,86,5,7]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class b{constructor(n,S){this.document=n,this._storagePath=S,this._backupCounter=1,this._edits=new L.Cache("custom documents")}addEdit(n){return this._edits.add([n])}async undo(n,S){await this.getEdit(n).undo(),S||this.disposeBackup()}async redo(n,S){await this.getEdit(n).redo(),S||this.disposeBackup()}disposeEdits(n){for(const S of n)this._edits.delete(S)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const n=s(this.document.uri)+this._backupCounter++;return(0,R.joinPath)(this._storagePath,n)}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(n){const S=this._edits.get(n,0);if(!S)throw new Error("No edit found");return S}}class p{constructor(){this._documents=new Map}get(n,S){return this._documents.get(this.key(n,S))}add(n,S,a){const i=this.key(n,S.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${n} resource:${S.uri}`);const r=new b(S,a);return this._documents.set(i,r),r}delete(n,S){const a=this.key(n,S.uri);this._documents.delete(a)}key(n,S){return`${n}@@@${S}`}}var g;(function(h){h[h.Text=0]="Text",h[h.Custom=1]="Custom"})(g||(g={}));class E{constructor(){this._providers=new Map}addTextProvider(n,S,a){return this.add(0,n,S,a)}addCustomProvider(n,S,a){return this.add(1,n,S,a)}get(n){return this._providers.get(n)}add(n,S,a,i){if(this._providers.has(S))throw new Error(`Provider for viewType:${S} already registered`);return this._providers.set(S,{type:n,extension:a,provider:i}),new l.Disposable(()=>this._providers.delete(S))}}class F{constructor(n,S,a,i,r){this._extHostDocuments=S,this._extensionStoragePaths=a,this._extHostWebview=i,this._extHostWebviewPanels=r,this._editorProviders=new E,this._documents=new p,this._proxy=n.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(n,S,a,i){const r=new I.DisposableStore;return D(a)?(r.add(this._editorProviders.addTextProvider(S,n,a)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(n),S,i.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(n))):(r.add(this._editorProviders.addCustomProvider(S,n,a)),this.supportEditing(a)&&r.add(a.onDidChangeCustomDocument(c=>{const o=this.getCustomDocumentEntry(S,c.document.uri);if(u(c)){const d=o.addEdit(c);this._proxy.$onDidEdit(c.document.uri,S,d,c.label)}else this._proxy.$onContentChange(c.document.uri,S)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(n),S,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(n))),l.Disposable.from(r,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(S)}))}async $createCustomDocument(n,S,a,i,r){const c=this._editorProviders.get(S);if(!c)throw new Error(`No provider found for '${S}'`);if(c.type!==1)throw new Error(`Invalid provide type for '${S}'`);const o=k.URI.revive(n),d=await c.provider.openCustomDocument(o,{backupId:a,untitledDocumentData:i?.buffer},r);let m;return this.supportEditing(c.provider)&&this._extensionStoragePaths&&(m=this._extensionStoragePaths.workspaceValue(c.extension)??this._extensionStoragePaths.globalValue(c.extension)),this._documents.add(S,d,m),{editable:this.supportEditing(c.provider)}}async $disposeCustomDocument(n,S){const a=this._editorProviders.get(S);if(!a)throw new Error(`No provider found for '${S}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${S}'`);const i=k.URI.revive(n),{document:r}=this.getCustomDocumentEntry(S,i);this._documents.delete(S,r),r.dispose()}async $resolveWebviewEditor(n,S,a,i,r,c){const o=this._editorProviders.get(a);if(!o)throw new Error(`No provider found for '${a}'`);const d=y.ViewColumn.to(r),m=this._extHostWebview.createNewWebview(S,i.webviewOptions,o.extension),v=this._extHostWebviewPanels.createNewWebviewPanel(S,a,i.title,d,i.panelOptions,m),w=k.URI.revive(n);switch(o.type){case 1:{const{document:A}=this.getCustomDocumentEntry(a,w);return o.provider.resolveCustomEditor(A,v,c)}case 0:{const A=this._extHostDocuments.getDocument(w);return o.provider.resolveCustomTextEditor(A,v,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,S,a){this.getCustomDocumentEntry(S,n).disposeEdits(a)}async $onMoveCustomEditor(n,S,a){const i=this._editorProviders.get(a);if(!i)throw new Error(`No provider found for '${a}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const r=this._extHostWebviewPanels.getWebviewPanel(n);if(!r)throw new Error("No webview found");const c=k.URI.revive(S),o=this._extHostDocuments.getDocument(c);await i.provider.moveCustomTextEditor(o,r,f.CancellationToken.None)}async $undo(n,S,a,i){return this.getCustomDocumentEntry(S,n).undo(a,i)}async $redo(n,S,a,i){return this.getCustomDocumentEntry(S,n).redo(a,i)}async $revert(n,S,a){const i=this.getCustomDocumentEntry(S,n);await this.getCustomEditorProvider(S).revertCustomDocument(i.document,a),i.disposeBackup()}async $onSave(n,S,a){const i=this.getCustomDocumentEntry(S,n);await this.getCustomEditorProvider(S).saveCustomDocument(i.document,a),i.disposeBackup()}async $onSaveAs(n,S,a,i){const r=this.getCustomDocumentEntry(S,n);return this.getCustomEditorProvider(S).saveCustomDocumentAs(r.document,k.URI.revive(a),i)}async $backup(n,S,a){const i=this.getCustomDocumentEntry(S,n),c=await this.getCustomEditorProvider(S).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},a);return i.updateBackup(c),c.id}getCustomDocumentEntry(n,S){const a=this._documents.get(n,k.URI.revive(S));if(!a)throw new Error("No custom document found");return a}getCustomEditorProvider(n){const a=this._editorProviders.get(n)?.provider;if(!a||!this.supportEditing(a))throw new Error("Custom document is not editable");return a}supportEditing(n){return!!n.onDidChangeCustomDocument}}e.ExtHostCustomEditors=F;function D(h){return typeof h.resolveCustomTextEditor=="function"}function u(h){return typeof h.undo=="function"&&typeof h.redo=="function"}function s(h){const n=h.scheme===_.Schemas.file||h.scheme===_.Schemas.untitled?h.fsPath:h.toString();return(0,t.hash)(n)+""}});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[256],ve([0,1,3,6,2,33,15,69,5,7]),function(Z,e,f,t,I,_,R,k,y,P){"use strict";var L,C,l,b,p,g,E,F,D,u,s,h,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class S extends t.Disposable{constructor(c,o,d,m,v,w,A){super();L.set(this,void 0),C.set(this,void 0),l.set(this,void 0),b.set(this,void 0),p.set(this,void 0),g.set(this,void 0),E.set(this,void 0),F.set(this,void 0),D.set(this,!0),u.set(this,!0),s.set(this,!1),h.set(this,this._register(new f.Emitter)),this.onDidDispose=Le(this,h,"f").event,n.set(this,this._register(new f.Emitter)),this.onDidChangeViewState=Le(this,n,"f").event,nt(this,L,c,"f"),nt(this,C,o,"f"),nt(this,l,d,"f"),nt(this,p,w,"f"),nt(this,F,v,"f"),nt(this,g,m,"f"),nt(this,b,A,"f")}dispose(){Le(this,s,"f")||(nt(this,s,!0,"f"),Le(this,h,"f").fire(),Le(this,C,"f").$disposeWebview(Le(this,L,"f")),Le(this,b,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Le(this,b,"f")}get viewType(){return this.assertNotDisposed(),Le(this,l,"f")}get title(){return this.assertNotDisposed(),Le(this,g,"f")}set title(c){this.assertNotDisposed(),Le(this,g,"f")!==c&&(nt(this,g,c,"f"),Le(this,C,"f").$setTitle(Le(this,L,"f"),c))}get iconPath(){return this.assertNotDisposed(),Le(this,E,"f")}set iconPath(c){this.assertNotDisposed(),Le(this,E,"f")!==c&&(nt(this,E,c,"f"),Le(this,C,"f").$setIconPath(Le(this,L,"f"),I.URI.isUri(c)?{light:c,dark:c}:c))}get options(){return Le(this,p,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Le(this,F,"f")=="number"&&Le(this,F,"f")<0))return Le(this,F,"f")}get active(){return this.assertNotDisposed(),Le(this,u,"f")}get visible(){return this.assertNotDisposed(),Le(this,D,"f")}_updateViewState(c){Le(this,s,"f")||(this.active!==c.active||this.visible!==c.visible||this.viewColumn!==c.viewColumn)&&(nt(this,u,c.active,"f"),nt(this,D,c.visible,"f"),nt(this,F,c.viewColumn,"f"),Le(this,n,"f").fire({webviewPanel:this}))}reveal(c,o){this.assertNotDisposed(),Le(this,C,"f").$reveal(Le(this,L,"f"),{viewColumn:c?R.ViewColumn.from(c):void 0,preserveFocus:!!o})}assertNotDisposed(){if(Le(this,s,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,C=new WeakMap,l=new WeakMap,b=new WeakMap,p=new WeakMap,g=new WeakMap,E=new WeakMap,F=new WeakMap,D=new WeakMap,u=new WeakMap,s=new WeakMap,h=new WeakMap,n=new WeakMap;class a{constructor(c,o,d){this.webviews=o,this.workspace=d,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=c.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,_.generateUuid)()}createWebviewPanel(c,o,d,m,v={}){const w=typeof m=="object"?m.viewColumn:m,A={viewColumn:R.ViewColumn.from(w),preserveFocus:typeof m=="object"&&!!m.preserveFocus},M=(0,k.shouldSerializeBuffersForPostMessage)(c),T=a.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(c),T,o,{title:d,panelOptions:i(v),webviewOptions:(0,k.serializeWebviewOptions)(c,this.workspace,v),serializeBuffersForPostMessage:M},A);const O=this.webviews.createNewWebview(T,v,c);return this.createNewWebviewPanel(T,o,d,w,v,O)}$onDidChangeWebviewPanelViewStates(c){const o=Object.keys(c);o.sort((d,m)=>{const v=c[d],w=c[m];return v.active?1:w.active?-1:+v.visible-+w.visible});for(const d of o){const m=this.getWebviewPanel(d);if(!m)continue;const v=c[d];m._updateViewState({active:v.active,visible:v.visible,viewColumn:R.ViewColumn.to(v.position)})}}async $onDidDisposeWebviewPanel(c){this.getWebviewPanel(c)?.dispose(),this._webviewPanels.delete(c),this.webviews.deleteWebview(c)}registerWebviewPanelSerializer(c,o,d){if(this._serializers.has(o))throw new Error(`Serializer for '${o}' already registered`);return this._serializers.set(o,{serializer:d,extension:c}),this._proxy.$registerSerializer(o,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(c)}),new P.Disposable(()=>{this._serializers.delete(o),this._proxy.$unregisterSerializer(o)})}async $deserializeWebviewPanel(c,o,d,m){const v=this._serializers.get(o);if(!v)throw new Error(`No serializer found for '${o}'`);const{serializer:w,extension:A}=v,M=this.webviews.createNewWebview(c,d.webviewOptions,A),T=this.createNewWebviewPanel(c,o,d.title,m,d.panelOptions,M);await w.deserializeWebviewPanel(T,d.state)}createNewWebviewPanel(c,o,d,m,v,w){const A=new S(c,this._proxy,o,d,m,v,w);return this._webviewPanels.set(c,A),A}getWebviewPanel(c){return this._webviewPanels.get(c)}}e.ExtHostWebviewPanels=a;function i(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[257],ve([0,1,3,6,69,5,7]),function(Z,e,f,t,I,_,R){"use strict";var k,y,P,L,C,l,b,p,g,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class F extends t.Disposable{constructor(s,h,n,S,a,i){super();k.set(this,void 0),y.set(this,void 0),P.set(this,void 0),L.set(this,void 0),C.set(this,!1),l.set(this,void 0),b.set(this,void 0),p.set(this,void 0),g.set(this,this._register(new f.Emitter)),this.onDidChangeVisibility=Le(this,g,"f").event,E.set(this,this._register(new f.Emitter)),this.onDidDispose=Le(this,E,"f").event,nt(this,P,n,"f"),nt(this,b,S,"f"),nt(this,k,s,"f"),nt(this,y,h,"f"),nt(this,L,a,"f"),nt(this,l,i,"f")}dispose(){Le(this,C,"f")||(nt(this,C,!0,"f"),Le(this,E,"f").fire(),Le(this,L,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Le(this,b,"f")}set title(s){this.assertNotDisposed(),Le(this,b,"f")!==s&&(nt(this,b,s,"f"),Le(this,y,"f").$setWebviewViewTitle(Le(this,k,"f"),s))}get description(){return this.assertNotDisposed(),Le(this,p,"f")}set description(s){this.assertNotDisposed(),Le(this,p,"f")!==s&&(nt(this,p,s,"f"),Le(this,y,"f").$setWebviewViewDescription(Le(this,k,"f"),s))}get visible(){return Le(this,l,"f")}get webview(){return Le(this,L,"f")}get viewType(){return Le(this,P,"f")}_setVisible(s){s===Le(this,l,"f")||Le(this,C,"f")||(nt(this,l,s,"f"),Le(this,g,"f").fire())}show(s){this.assertNotDisposed(),Le(this,y,"f").$show(Le(this,k,"f"),!!s)}assertNotDisposed(){if(Le(this,C,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,y=new WeakMap,P=new WeakMap,L=new WeakMap,C=new WeakMap,l=new WeakMap,b=new WeakMap,p=new WeakMap,g=new WeakMap,E=new WeakMap;class D{constructor(s,h){this._extHostWebview=h,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=s.getProxy(_.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,h,n,S){if(this._viewProviders.has(h))throw new Error(`View provider for '${h}' already registered`);return this._viewProviders.set(h,{provider:n,extension:s}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(s),h,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new R.Disposable(()=>{this._viewProviders.delete(h),this._proxy.$unregisterWebviewViewProvider(h)})}async $resolveWebviewView(s,h,n,S,a){const i=this._viewProviders.get(h);if(!i)throw new Error(`No view provider found for '${h}'`);const{provider:r,extension:c}=i,o=this._extHostWebview.createNewWebview(s,{},c),d=new F(s,this._proxy,h,n,o,!0);this._webviewViews.set(s,d),await r.resolveWebviewView(d,{state:S},a)}async $onDidChangeWebviewViewVisibility(s,h){this.getWebviewView(s)._setVisible(h)}async $disposeWebviewView(s){const h=this.getWebviewView(s);this._webviewViews.delete(s),h.dispose(),this._extHostWebview.deleteWebview(s)}getWebviewView(s){const h=this._webviewViews.get(s);if(!h)throw new Error("No webview found");return h}}e.ExtHostWebviewViews=D}),define(pe[135],ve([0,1,3,5,2,10,8,4,14]),function(Z,e,f,t,I,_,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class ji{constructor(C){this._onDidChangeWindowState=new f.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ji.InitialState,this._proxy=C.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state={...this._state,focused:C},this._onDidChangeWindowState.fire(this._state))}openUri(C,l){let b;if(typeof C=="string"){b=C;try{C=I.URI.parse(C)}catch{return Promise.reject(`Invalid uri - '${C}'`)}}return(0,R.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===_.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,b,l)}async asExternalUri(C,l){if((0,R.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this._proxy.$asExternalUri(C,l);return I.URI.from(b)}};P.InitialState={focused:!0},P=je([ze(0,y.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(pe[258],ve([0,1,9,81,33,38,6,5,2,14]),function(Z,e,f,t,I,_,R,k,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends R.Disposable{constructor(l,b){super();const p=l.getProxy(k.MainContext.MainThreadDownloadService);b.registerCommand(!1,"_workbench.downloadResource",async g=>{const E=y.URI.file((0,f.join)((0,t.tmpdir)(),(0,I.generateUuid)()));return await p.$download(g,E),E})}};L=je([ze(0,P.IExtHostRpcService),ze(1,_.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(pe[259],ve([0,1,133,10,188,33]),function(Z,e,f,t,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class R extends f.ExtHostLoggerService{doCreateLogger(y,P,L){return y.scheme===t.Schemas.file?new I.SpdLogLogger(L?.name||(0,_.generateUuid)(),y.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,P):super.doCreateLogger(y,P,L)}}e.ExtHostLoggerService=R}),define(pe[260],ve([0,1,60,9,2,68,6,10,13,30]),function(Z,e,f,t,I,_,R,k,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends _.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(n){const S=await super._getWorkspaceStorageURI(n);if(S.scheme!==k.Schemas.file)return S;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${S.fsPath}.`),S;const a=S.fsPath;let i=0;do{let r;i===0?r=a:r=/[/\\]$/.test(a)?`${a.substr(0,a.length-1)}-${i}`:`${a}-${i}`,await C(r);const c=t.join(r,"vscode.lock"),o=await g(this._logService,c,!1);if(o)return this._workspaceStorageLock=o,process.on("exit",()=>{o.dispose()}),I.URI.file(r);i++}while(i<10);return S}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function C(h){try{await P.Promises.stat(h);return}catch{}try{await P.Promises.mkdir(h,{recursive:!0})}catch{}}const l=1e3,b=10*60*1e3;class p extends R.Disposable{constructor(n,S){super();this.logService=n,this.filename=S,this._timer=this._register(new y.IntervalTimer),this._timer.cancelAndSet(async()=>{const a=await E(n,S);(!a||a.pid!==process.pid)&&(n.info(`Lock '${S}': The lock was lost unexpectedly.`),this._timer.cancel());try{await P.Promises.utimes(S,new Date,new Date)}catch(i){n.error(i),n.info(`Lock '${S}': Could not update mtime.`)}},l)}dispose(){super.dispose();try{f.unlinkSync(this.filename)}catch{}}async setWillRelease(n){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${n} ms.`);try{const S={pid:process.pid,willReleaseAt:Date.now()+n};await P.Promises.writeFile(this.filename,JSON.stringify(S),{flag:"w"})}catch(S){this.logService.error(S)}}}async function g(h,n,S){try{const i={pid:process.pid,willReleaseAt:0};await P.Promises.writeFile(n,JSON.stringify(i),{flag:"wx"})}catch(i){h.error(i)}const a=await E(h,n);return!a||a.pid!==process.pid?S?(h.info(`Lock '${n}': Could not acquire lock, giving up.`),null):(h.info(`Lock '${n}': Could not acquire lock, checking if the file is stale.`),u(h,n)):(h.info(`Lock '${n}': Lock acquired.`),new p(h,n))}async function E(h,n){let S;try{S=await P.Promises.readFile(n)}catch(a){return h.error(a),null}try{return JSON.parse(String(S))}catch(a){return h.error(a),null}}async function F(h,n){let S;try{S=await P.Promises.stat(n)}catch(a){return h.error(a),0}return S.mtime.getTime()}function D(h){try{return process.kill(h,0),!0}catch{return!1}}async function u(h,n){const S=await E(h,n);if(!S)return h.info(`Lock '${n}': Could not read pid of lock holder.`),s(h,n);if(S.willReleaseAt){let o=S.willReleaseAt-Date.now();if(o<5e3){for(o>0?h.info(`Lock '${n}': The lockfile is scheduled to be released in ${o} ms.`):h.info(`Lock '${n}': The lockfile is scheduled to have been released.`);o>0;){if(await(0,y.timeout)(Math.min(100,o)),await F(h,n)===0)return s(h,n);o=S.willReleaseAt-Date.now()}return s(h,n)}}if(!D(S.pid))return h.info(`Lock '${n}': The pid ${S.pid} appears to be gone.`),s(h,n);const a=await F(h,n),i=Date.now()-a;if(i<=b)return h.info(`Lock '${n}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;h.info(`Lock '${n}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const r=await F(h,n),c=Date.now()-r;return c<=b?(h.info(`Lock '${n}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null):(h.info(`Lock '${n}': The lock looks stale even after waiting for 2s.`),s(h,n))}async function s(h,n){h.info(`Lock '${n}': Deleting a stale lock.`);try{await P.Promises.unlink(n)}catch{}return g(h,n,!0)}}),define(pe[261],ve([0,1,33,14,34]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let _=class extends I.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,y,P){return this.createTerminalFromOptions({name:k,shellPath:y,shellArgs:P})}createTerminalFromOptions(k,y){const P=new I.ExtHostTerminal(this._proxy,(0,f.generateUuid)(),k,k.name);return this._terminals.push(P),P.create(k,this._serializeParentTerminal(k,y)),P.value}};_=je([ze(0,t.IExtHostRpcService)],_),e.ExtHostTerminalService=_}),define(pe[262],ve([0,1,5,14,172,6,26,2,37,23,30,7,12,51,3,122,94,11]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p,g,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class D{constructor(d,m,v){this.remoteAddress=d,this.localAddress=m,this._dispose=v,this._onDispose=new p.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function u(o){const d=o.trim().split(`
`),m=[];return d.forEach(w=>{const A=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(w);A&&A.length>=3&&m.push({pid:parseInt(A[1],10),socket:parseInt(A[2],10)})}),m.reduce((w,A)=>(w[A.socket]=A,w),{})}e.getSockets=u;function s(...o){const d=[].concat(...o.map(n));return[...new Map(d.filter(m=>m.st==="0A").map(m=>{const v=m.local_address.split(":");return{socket:parseInt(m.inode,10),ip:h(v[0]),port:parseInt(v[1],16)}}).map(m=>[m.ip+":"+m.port,m])).values()]}e.loadListeningPorts=s;function h(o){let d="";if(o.length===8)for(let m=o.length-2;m>=0;m-=2)d+=parseInt(o.substr(m,2),16),m!==0&&(d+=".");else for(let m=o.length-4;m>=0;m-=4)d+=parseInt(o.substr(m,4),16).toString(16),m!==0&&(d+=":");return d}e.parseIpAddress=h;function n(o){const d=o.trim().split(`
`),m=d.shift().trim().split(/\s+/).filter(w=>w!=="rx_queue"&&w!=="tm->when");return d.map(w=>w.trim().split(/\s+/).reduce((A,M,T)=>(A[m[T]||T]=M,A),{}))}e.loadConnectionTable=n;function S(o){return!!o.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||o.indexOf("out/vs/server/main.js")!==-1||o.indexOf("_productName=VSCode")!==-1}function a(o){const d=o.trim().split(`
`),m=[];return d.forEach(v=>{const w=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(v);w&&w.length>=4&&m.push({pid:parseInt(w[1],10),ppid:parseInt(w[2]),cmd:w[3]})}),m}e.getRootProcesses=a;async function i(o,d,m){const v=m.reduce((A,M)=>(A[M.pid]=M,A),{}),w=[];return o.forEach(({socket:A,ip:M,port:T})=>{const O=d[A]?d[A].pid:void 0,U=O?v[O]?.cmd:void 0;O&&U&&!S(U)&&w.push({host:M,port:T,detail:U,pid:O})}),w}e.findPorts=i;function r(o,d,m){const v=new Map,w=a(d);for(const A of o){const M=m.get(A.port);if(M){v.set(A.port,M);continue}const T=w.find(O=>O.cmd.includes(`${A.port}`));if(T){let O=T,U;do U=w.find(V=>V.ppid===O.pid),U&&(O=U);while(U);v.set(A.port,{host:A.ip,port:A.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else v.set(A.port,{host:A.ip,port:A.port,ppid:Number.MAX_VALUE})}return v}e.tryFindRootPorts=r;let c=class extends _.Disposable{constructor(d,m,v){super();this.logService=v,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new p.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=d.getProxy(f.MainContext.MainThreadTunnelService),l.isLinux&&m.remote.isRemote&&m.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(d,m){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${d.identifier.value} called openTunnel API for ${m.remoteAddress.host}:${m.remoteAddress.port}.`);const v=await this._proxy.$openTunnel(m,d.displayName);if(v){const w=new D(v.remoteAddress,v.localAddress,()=>this._proxy.$closeTunnel(v.remoteAddress));return this._register(w),w}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(d){return Math.max(d*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(d,m){const v=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(v,{selector:d,provider:m}),this._proxy.$registerPortsAttributesProvider(d,v),new C.Disposable(()=>{this._portAttributesProviders.delete(v),this._proxy.$unregisterPortsAttributesProvider(v)})}async $providePortAttributes(d,m,v,w,A){const M=[];for(const O of d){const U=this._portAttributesProviders.get(O);if(!U)return[];M.push(...await Promise.all(m.map(async V=>U.provider.providePortAttributes(V,v,w,A))))}const T=M.filter(O=>!!O);return T.length>0?T.map(O=>({autoForwardAction:O.autoForwardAction,port:O.port})):[]}async $registerCandidateFinder(d){if(d&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=d;let m=new E.MovingAverage,v;for(;this._candidateFindingEnabled;){const w=new Date().getTime(),A=(await this.findCandidatePorts()).filter(T=>(0,g.isLocalhost)(T.host)||(0,g.isAllInterfaces)(T.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${A.map(T=>T.port).join(", ")}`);const M=new Date().getTime()-w;m.update(M),(!v||JSON.stringify(v)!==JSON.stringify(A))&&(v=A,await this._proxy.$onFoundNewCandidates(v)),await new Promise(T=>setTimeout(()=>T(),this.calculateDelay(m.value)))}}async setTunnelFactory(d){if(d){if(d.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(d.candidatePortSource),d.showCandidatePort&&(this._showCandidatePort=d.showCandidatePort,this._proxy.$setCandidateFilter()),d.tunnelFactory){this._forwardPortProvider=d.tunnelFactory;let m=d.tunnelFeatures?.privacyOptions??[];d.tunnelFeatures?.public&&m.length===0&&(m=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const v=d.tunnelFeatures?{elevation:!!d.tunnelFeatures?.elevation,public:!!d.tunnelFeatures?.public,privacyOptions:m}:void 0;this._proxy.$setTunnelProvider(v)}}else this._forwardPortProvider=void 0;return(0,_.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(d,m){if(this._extensionTunnels.has(d.host)){const v=this._extensionTunnels.get(d.host);v.has(d.port)&&(m&&v.get(d.port).disposeListener.dispose(),await v.get(d.port).tunnel.dispose(),v.delete(d.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(d,m){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const v=this._forwardPortProvider(d,m);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),v!==void 0){const w=await v;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(d.remoteAddress.host)||this._extensionTunnels.set(d.remoteAddress.host,new Map);const A=this._register(w.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(w.remoteAddress))));return this._extensionTunnels.get(d.remoteAddress.host).set(d.remoteAddress.port,{tunnel:w,disposeListener:A}),b.TunnelDto.fromApiTunnel(w)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(d){const m=await Promise.all(d.map(w=>this._showCandidatePort(w.host,w.port,w.detail??""))),v=d.filter((w,A)=>m[A]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${d.map(w=>w.port).join(", ")} to ${v.map(w=>w.port).join(", ")}`),v}async findCandidatePorts(){let d="",m="";try{d=await L.Promises.readFile("/proc/net/tcp","utf8"),m=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const v=s(d,m),w=await new Promise(N=>{(0,y.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(B,W,H)=>{N(W)})}),A=u(w),M=await L.Promises.readdir("/proc"),T=[];for(let N of M)try{const B=Number(N),W=P.joinPath(k.URI.file("/proc"),N);if((await L.Promises.stat(W.fsPath)).isDirectory()&&!isNaN(B)){const z=await L.Promises.readlink(P.joinPath(W,"cwd").fsPath),J=await L.Promises.readFile(P.joinPath(W,"cmdline").fsPath,"utf8");T.push({pid:B,cwd:z,cmd:J})}}catch{}const O=[],U=v.filter(N=>{const B=A[N.socket];return B||O.push(N),B}),V=i(U,A,T);let x;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const N=await new Promise(B=>{(0,y.exec)("ps -F -A -l | grep root",(W,H,z)=>{B(H)})});this._foundRootPorts=r(O,N,this._foundRootPorts),x=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${x.join(", ")}`)}return V.then(N=>x?N.concat(x):N)}};c=je([ze(0,t.IExtHostRpcService),ze(1,R.IExtHostInitDataService),ze(2,F.ILogService)],c),e.ExtHostTunnelService=c}),define(pe[263],ve([0,1,13,22,21,16,3,6,103,226,52]),function(Z,e,f,t,I,_,R,k,y,P,L){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function l(v,w){try{return JSON.stringify(v,w)}catch{return"null"}}const b="$$ref$$",p={[b]:-1};class g{constructor(w,A){this.jsonString=w,this.referencedBuffers=A}}function E(v,w=null,A=!1){const M=[];return{jsonString:(A?l:JSON.stringify)(v,(O,U)=>{if(typeof U=="undefined")return p;if(typeof U=="object"){if(U instanceof t.VSBuffer){const V=M.push(U)-1;return{[b]:V}}if(w)return w(O,U)}return U}),referencedBuffers:M}}e.stringifyJsonWithBufferRefs=E;function F(v,w,A){return JSON.parse(v,(M,T)=>{if(T){const O=T[b];if(typeof O=="number")return w[O];if(A&&T.$mid===1)return A.transformIncoming(T)}return T})}e.parseJsonAndRestoreBufferRefs=F;function D(v,w){return JSON.stringify(v,w)}function u(v){return v?(w,A)=>A&&A.$mid===1?v.transformOutgoing(A):A:null}var s;(function(v){v[v.LocalSide=0]="LocalSide",v[v.OtherSide=1]="OtherSide"})(s=e.RequestInitiator||(e.RequestInitiator={}));var h;(function(v){v[v.Responsive=0]="Responsive",v[v.Unresponsive=1]="Unresponsive"})(h=e.ResponsiveState||(e.ResponsiveState={}));const n=()=>{},S=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class i extends k.Disposable{constructor(w,A=null,M=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=w,this._logger=A,this._uriTransformer=M,this._uriReplacer=u(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let T=0,O=L.ProxyIdentifier.count;T<O;T++)this._locals[T]=null,this._proxies[T]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new f.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(T=>this._receiveOneMessage(T))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(w=>{this._pendingRPCReplies[w].resolveErr(_.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(w){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(w){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(w){this._responsiveState!==w&&(this._responsiveState=w,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(w){return this._uriTransformer?(0,y.transformIncomingURIs)(w,this._uriTransformer):w}getProxy(w){const{nid:A,sid:M}=w;return this._proxies[A]||(this._proxies[A]=this._createProxy(A,M)),this._proxies[A]}_createProxy(w,A){let M={get:(T,O)=>(typeof O=="string"&&!T[O]&&O.charCodeAt(0)===36&&(T[O]=(...U)=>this._remoteCall(w,O,U)),O===a?A:T[O])};return new Proxy(Object.create(null),M)}set(w,A){return this._locals[w.nid]=A,A}assertRegistered(w){for(let A=0,M=w.length;A<M;A++){const T=w[A];if(!this._locals[T.nid])throw new Error(`Missing proxy instance ${T.sid}`)}}_receiveOneMessage(w){if(this._isDisposed)return;const A=w.byteLength,M=r.read(w,0),T=M.readUInt8(),O=M.readUInt32();switch(T){case 1:case 2:{let{rpcId:U,method:V,args:x}=o.deserializeRequestJSONArgs(M);this._uriTransformer&&(x=(0,y.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(A,O,U,V,x,T===2);break}case 3:case 4:{let{rpcId:U,method:V,args:x}=o.deserializeRequestMixedArgs(M);this._uriTransformer&&(x=(0,y.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(A,O,U,V,x,T===4);break}case 5:{this._logger&&this._logger.logIncoming(A,O,0,"ack"),this._onDidReceiveAcknowledge(O);break}case 6:{this._receiveCancel(A,O);break}case 7:{this._receiveReply(A,O,void 0);break}case 9:{let U=o.deserializeReplyOKJSON(M);this._uriTransformer&&(U=(0,y.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReply(A,O,U);break}case 10:{const U=o.deserializeReplyOKJSONWithBuffers(M,this._uriTransformer);this._receiveReply(A,O,U);break}case 8:{let U=o.deserializeReplyOKVSBuffer(M);this._receiveReply(A,O,U);break}case 11:{let U=o.deserializeReplyErrError(M);this._uriTransformer&&(U=(0,y.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReplyErr(A,O,U);break}case 12:{this._receiveReplyErr(A,O,void 0);break}default:console.error("received unexpected message"),console.error(w)}}_receiveRequest(w,A,M,T,O,U){this._logger&&this._logger.logIncoming(w,A,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(M)}.${T}(`,O);const V=String(A);let x,N;if(U){const W=new I.CancellationTokenSource;O.push(W.token),x=this._invokeHandler(M,T,O),N=()=>W.cancel()}else x=this._invokeHandler(M,T,O),N=n;this._cancelInvokedHandlers[V]=N;const B=o.serializeAcknowledged(A);this._logger&&this._logger.logOutgoing(B.byteLength,A,1,"ack"),this._protocol.send(B),x.then(W=>{delete this._cancelInvokedHandlers[V];const H=o.serializeReplyOK(A,W,this._uriReplacer);this._logger&&this._logger.logOutgoing(H.byteLength,A,1,"reply:",W),this._protocol.send(H)},W=>{delete this._cancelInvokedHandlers[V];const H=o.serializeReplyErr(A,W);this._logger&&this._logger.logOutgoing(H.byteLength,A,1,"replyErr:",W),this._protocol.send(H)})}_receiveCancel(w,A){this._logger&&this._logger.logIncoming(w,A,1,"receiveCancel");const M=String(A);this._cancelInvokedHandlers[M]&&this._cancelInvokedHandlers[M]()}_receiveReply(w,A,M){this._logger&&this._logger.logIncoming(w,A,0,"receiveReply:",M);const T=String(A);if(!this._pendingRPCReplies.hasOwnProperty(T))return;const O=this._pendingRPCReplies[T];delete this._pendingRPCReplies[T],O.resolveOk(M)}_receiveReplyErr(w,A,M){this._logger&&this._logger.logIncoming(w,A,0,"receiveReplyErr:",M);const T=String(A);if(!this._pendingRPCReplies.hasOwnProperty(T))return;const O=this._pendingRPCReplies[T];delete this._pendingRPCReplies[T];let U;M&&(M.$isError?(U=new Error,U.name=M.name,U.message=M.message,U.stack=M.stack):U=M),O.resolveErr(U)}_invokeHandler(w,A,M){try{return Promise.resolve(this._doInvokeHandler(w,A,M))}catch(T){return Promise.reject(T)}}_doInvokeHandler(w,A,M){const T=this._locals[w];if(!T)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(w));let O=T[A];if(typeof O!="function")throw new Error("Unknown method "+A+" on actor "+(0,L.getStringIdentifierForProxy)(w));return O.apply(T,M)}_remoteCall(w,A,M){if(this._isDisposed)return Promise.reject(_.canceled());let T=null;if(M.length>0&&I.CancellationToken.isCancellationToken(M[M.length-1])&&(T=M.pop()),T&&T.isCancellationRequested)return Promise.reject(_.canceled());const O=o.serializeRequestArguments(M,this._uriReplacer),U=++this._lastMessageId,V=String(U),x=new P.LazyPromise;T&&T.onCancellationRequested(()=>{const B=o.serializeCancel(U);this._logger&&this._logger.logOutgoing(B.byteLength,U,0,"cancel"),this._protocol.send(o.serializeCancel(U))}),this._pendingRPCReplies[V]=x,this._onWillSendRequest(U);const N=o.serializeRequest(U,w,A,O,!!T);return this._logger&&this._logger.logOutgoing(N.byteLength,U,0,`request: ${(0,L.getStringIdentifierForProxy)(w)}.${A}(`,M),this._protocol.send(N),x}}e.RPCProtocol=i,C=S,i.UNRESPONSIVE_TIME=3*1e3;class r{constructor(w,A){this._buff=w,this._offset=A}static alloc(w,A,M){let T=new r(t.VSBuffer.alloc(M+1+4),0);return T.writeUInt8(w),T.writeUInt32(A),T}static read(w,A){return new r(w,A)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(w){this._buff.writeUInt8(w,this._offset),this._offset+=1}readUInt8(){const w=this._buff.readUInt8(this._offset);return this._offset+=1,w}writeUInt32(w){this._buff.writeUInt32BE(w,this._offset),this._offset+=4}readUInt32(){const w=this._buff.readUInt32BE(this._offset);return this._offset+=4,w}static sizeShortString(w){return 1+w.byteLength}writeShortString(w){this._buff.writeUInt8(w.byteLength,this._offset),this._offset+=1,this._buff.set(w,this._offset),this._offset+=w.byteLength}readShortString(){const w=this._buff.readUInt8(this._offset);this._offset+=1;const M=this._buff.slice(this._offset,this._offset+w).toString();return this._offset+=w,M}static sizeLongString(w){return 4+w.byteLength}writeLongString(w){this._buff.writeUInt32BE(w.byteLength,this._offset),this._offset+=4,this._buff.set(w,this._offset),this._offset+=w.byteLength}readLongString(){const w=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+w).toString();return this._offset+=w,M}writeBuffer(w){this._buff.writeUInt32BE(w.byteLength,this._offset),this._offset+=4,this._buff.set(w,this._offset),this._offset+=w.byteLength}static sizeVSBuffer(w){return 4+w.byteLength}writeVSBuffer(w){this._buff.writeUInt32BE(w.byteLength,this._offset),this._offset+=4,this._buff.set(w,this._offset),this._offset+=w.byteLength}readVSBuffer(){const w=this._buff.readUInt32BE(this._offset);this._offset+=4;const A=this._buff.slice(this._offset,this._offset+w);return this._offset+=w,A}static sizeMixedArray(w){let A=0;A+=1;for(let M=0,T=w.length;M<T;M++){const O=w[M];switch(A+=1,O.type){case 1:A+=this.sizeLongString(O.value);break;case 2:A+=this.sizeVSBuffer(O.value);break;case 3:A+=this.sizeUInt32,A+=this.sizeLongString(O.value);for(let U=0;U<O.buffers.length;++U)A+=this.sizeVSBuffer(O.buffers[U]);break;case 4:break}}return A}writeMixedArray(w){this._buff.writeUInt8(w.length,this._offset),this._offset+=1;for(let A=0,M=w.length;A<M;A++){const T=w[A];switch(T.type){case 1:this.writeUInt8(1),this.writeLongString(T.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(T.value);break;case 3:this.writeUInt8(3),this.writeUInt32(T.buffers.length),this.writeLongString(T.value);for(let O=0;O<T.buffers.length;++O)this.writeBuffer(T.buffers[O]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const w=this._buff.readUInt8(this._offset);this._offset+=1;let A=new Array(w);for(let M=0;M<w;M++)switch(this.readUInt8()){case 1:A[M]=this.readLongString();break;case 2:A[M]=this.readVSBuffer();break;case 3:{const O=this.readUInt32(),U=this.readLongString(),V=[];for(let x=0;x<O;++x)V.push(this.readVSBuffer());A[M]=new L.SerializableObjectWithBuffers(F(U,V,null));break}case 4:A[M]=void 0;break}return A}}r.sizeUInt32=4;var c;(function(v){v[v.Simple=0]="Simple",v[v.Mixed=1]="Mixed"})(c||(c={}));class o{static _useMixedArgSerialization(w){for(let A=0,M=w.length;A<M;A++)if(w[A]instanceof t.VSBuffer||w[A]instanceof L.SerializableObjectWithBuffers||typeof w[A]=="undefined")return!0;return!1}static serializeRequestArguments(w,A){if(this._useMixedArgSerialization(w)){const M=[];for(let T=0,O=w.length;T<O;T++){const U=w[T];if(U instanceof t.VSBuffer)M[T]={type:2,value:U};else if(typeof U=="undefined")M[T]={type:4};else if(U instanceof L.SerializableObjectWithBuffers){const{jsonString:V,referencedBuffers:x}=E(U.value,A);M[T]={type:3,value:t.VSBuffer.fromString(V),buffers:x}}else M[T]={type:1,value:t.VSBuffer.fromString(D(U,A))}}return{type:1,args:M}}return{type:0,args:D(w,A)}}static serializeRequest(w,A,M,T,O){switch(T.type){case 0:return this._requestJSONArgs(w,A,M,T.args,O);case 1:return this._requestMixedArgs(w,A,M,T.args,O)}}static _requestJSONArgs(w,A,M,T,O){const U=t.VSBuffer.fromString(M),V=t.VSBuffer.fromString(T);let x=0;x+=r.sizeUInt8(),x+=r.sizeShortString(U),x+=r.sizeLongString(V);let N=r.alloc(O?2:1,w,x);return N.writeUInt8(A),N.writeShortString(U),N.writeLongString(V),N.buffer}static deserializeRequestJSONArgs(w){const A=w.readUInt8(),M=w.readShortString(),T=w.readLongString();return{rpcId:A,method:M,args:JSON.parse(T)}}static _requestMixedArgs(w,A,M,T,O){const U=t.VSBuffer.fromString(M);let V=0;V+=r.sizeUInt8(),V+=r.sizeShortString(U),V+=r.sizeMixedArray(T);let x=r.alloc(O?4:3,w,V);return x.writeUInt8(A),x.writeShortString(U),x.writeMixedArray(T),x.buffer}static deserializeRequestMixedArgs(w){const A=w.readUInt8(),M=w.readShortString(),T=w.readMixedArray(),O=new Array(T.length);for(let U=0,V=T.length;U<V;U++){const x=T[U];typeof x=="string"?O[U]=JSON.parse(x):O[U]=x}return{rpcId:A,method:M,args:O}}static serializeAcknowledged(w){return r.alloc(5,w,0).buffer}static serializeCancel(w){return r.alloc(6,w,0).buffer}static serializeReplyOK(w,A,M){if(typeof A=="undefined")return this._serializeReplyOKEmpty(w);if(A instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(w,A);if(A instanceof L.SerializableObjectWithBuffers){const{jsonString:T,referencedBuffers:O}=E(A.value,M,!0);return this._serializeReplyOKJSONWithBuffers(w,T,O)}else return this._serializeReplyOKJSON(w,l(A,M))}static _serializeReplyOKEmpty(w){return r.alloc(7,w,0).buffer}static _serializeReplyOKVSBuffer(w,A){let M=0;M+=r.sizeVSBuffer(A);let T=r.alloc(8,w,M);return T.writeVSBuffer(A),T.buffer}static deserializeReplyOKVSBuffer(w){return w.readVSBuffer()}static _serializeReplyOKJSON(w,A){const M=t.VSBuffer.fromString(A);let T=0;T+=r.sizeLongString(M);let O=r.alloc(9,w,T);return O.writeLongString(M),O.buffer}static _serializeReplyOKJSONWithBuffers(w,A,M){const T=t.VSBuffer.fromString(A);let O=0;O+=r.sizeUInt32,O+=r.sizeLongString(T);for(const V of M)O+=r.sizeVSBuffer(V);let U=r.alloc(10,w,O);U.writeUInt32(M.length),U.writeLongString(T);for(const V of M)U.writeBuffer(V);return U.buffer}static deserializeReplyOKJSON(w){const A=w.readLongString();return JSON.parse(A)}static deserializeReplyOKJSONWithBuffers(w,A){const M=w.readUInt32(),T=w.readLongString(),O=[];for(let U=0;U<M;++U)O.push(w.readVSBuffer());return new L.SerializableObjectWithBuffers(F(T,O,A))}static serializeReplyErr(w,A){return A?this._serializeReplyErrEror(w,A):this._serializeReplyErrEmpty(w)}static _serializeReplyErrEror(w,A){const M=t.VSBuffer.fromString(l(_.transformErrorForSerialization(A),null));let T=0;T+=r.sizeLongString(M);let O=r.alloc(11,w,T);return O.writeLongString(M),O.buffer}static deserializeReplyErrError(w){const A=w.readLongString();return JSON.parse(A)}static _serializeReplyErrEmpty(w){return r.alloc(12,w,0).buffer}}var d;(function(v){v[v.RequestJSONArgs=1]="RequestJSONArgs",v[v.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",v[v.RequestMixedArgs=3]="RequestMixedArgs",v[v.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",v[v.Acknowledged=5]="Acknowledged",v[v.Cancel=6]="Cancel",v[v.ReplyOKEmpty=7]="ReplyOKEmpty",v[v.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",v[v.ReplyOKJSON=9]="ReplyOKJSON",v[v.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",v[v.ReplyErrError=11]="ReplyErrError",v[v.ReplyErrEmpty=12]="ReplyErrEmpty"})(d||(d={}));var m;(function(v){v[v.String=1]="String",v[v.VSBuffer=2]="VSBuffer",v[v.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",v[v.Undefined=4]="Undefined"})(m||(m={}))}),define(pe[264],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,f.createDecorator)("remoteAgentService")}),define(pe[265],ve([0,1,29,10,9,12,23,2,4,63,43,221,264]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let b=class qi{constructor(g,E,F,D){this.localUserHome=g,this.remoteAgentService=E,this.environmentService=F,this.contextService=D,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||_.OS)(),this.resolveUserHome=(async()=>{const u=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=u?.userHome||g})()}hasValidBasename(g,E,F){return typeof E=="string"||typeof E=="undefined"?this.resolveOS.then(D=>this.doHasValidBasename(g,D,E)):this.doHasValidBasename(g,E,F)}doHasValidBasename(g,E,F){return g.scheme===t.Schemas.file||g.scheme===t.Schemas.vscodeRemote?(0,f.isValidBasename)(F??(0,R.basename)(g),E===1):!0}get defaultUriScheme(){return qi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(g,E){if(g.remoteAuthority)return t.Schemas.vscodeRemote;const F=(0,P.getVirtualWorkspaceScheme)(E.getWorkspace());if(F)return F;const D=E.getWorkspace().folders[0];if(D)return D.uri.scheme;const u=E.getWorkspace().configuration;return u?u.scheme:t.Schemas.file}async userHome(g){return g?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(g=>g===1?I.win32:I.posix)}async fileURI(g){let E="";if(await this.resolveOS===1&&(g=g.replace(/\\/g,"/")),g[0]==="/"&&g[1]==="/"){const D=g.indexOf("/",2);D===-1?(E=g.substring(2),g="/"):(E=g.substring(2,D),g=g.substring(D)||"/")}return k.URI.from({scheme:t.Schemas.file,authority:E,path:g,query:"",fragment:""})}};b=je([ze(1,l.IRemoteAgentService),ze(2,C.IWorkbenchEnvironmentService),ze(3,L.IWorkspaceContextService)],b),e.AbstractPathService=b}),define(pe[70],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class f{constructor(R,k){this.line=R,this.character=k}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,k){return new f(0,0)}with(R){return new f(0,0)}}e.Position=f;class t{constructor(R,k,y,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new f(R,k),this.end=new f(y,P)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new t(0,0,0,0)}with(R){return new t(0,0,0,0)}}e.Range=t;var I;(function(_){_[_.Information=1]="Information",_[_.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(pe[31],ve([0,1,17,32,25,29,8,4,9,16,70,13]),function(Z,e,f,t,I,_,R,k,y,P,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const l="\u27EA ",b=" characters skipped \u27EB",p=(l.length+b.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var g;(function(B){B[B.file=0]="file",B[B.text=1]="text"})(g=e.SearchProviderType||(e.SearchProviderType={}));var E;(function(B){B[B.File=1]="File",B[B.Text=2]="Text"})(E=e.QueryType||(e.QueryType={}));function F(B){return!!B.preview}e.resultIsMatch=F;function D(B){return!!B.resource}e.isFileMatch=D;function u(B){return!!B.message}e.isProgressMessage=u;var s;(function(B){B[B.Normal=0]="Normal",B[B.NewSearchStarted=1]="NewSearchStarted"})(s=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class h{constructor(W){this.resource=W,this.results=[]}}e.FileMatch=h;class n{constructor(W,H,z){this.ranges=H;const J=Array.isArray(H)?H:[H];if(z&&z.matchLines===1&&S(J)){W=(0,R.getNLines)(W,z.matchLines);let ie="",se=0,K=0;const X=Math.floor(z.charsPerLine/5),ae=[];for(const fe of J){const be=Math.max(fe.startColumn-X,0),Me=fe.startColumn+z.charsPerLine;if(be>K+X+p){const xe=l+(be-K)+b;ie+=xe+W.slice(be,Me),se+=be-(K+xe.length)}else ie+=W.slice(K,Me);ae.push(new i(0,fe.startColumn-se,fe.endColumn-se)),K=Me}this.preview={text:ie,matches:Array.isArray(this.ranges)?ae:ae[0]}}else{const ie=Array.isArray(H)?H[0].startLineNumber:H.startLineNumber;this.preview={text:W,matches:(0,f.mapArrayOrNot)(H,se=>new a(se.startLineNumber-ie,se.startColumn,se.endLineNumber-ie,se.endColumn))}}}}e.TextSearchMatch=n;function S(B){const W=B[0].startLineNumber;for(const H of B)if(H.startLineNumber!==W||H.endLineNumber!==W)return!1;return!0}class a{constructor(W,H,z,J){this.startLineNumber=W,this.startColumn=H,this.endLineNumber=z,this.endColumn=J}}e.SearchRange=a;class i extends a{constructor(W,H,z){super(W,H,W,z)}}e.OneLineRange=i;var r;(function(B){B.Default="default",B.FileNames="fileNames",B.Type="type",B.Modified="modified",B.CountDescending="countDescending",B.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function c(B,W=!0){const H=B&&B.files&&B.files.exclude,z=W&&B&&B.search&&B.search.exclude;if(!H&&!z)return;if(!H||!z)return H||z;let J=Object.create(null);return J=I.mixin(J,I.deepClone(H)),J=I.mixin(J,I.deepClone(z),!0),J}e.getExcludes=c;function o(B,W){return B.excludePattern&&t.match(B.excludePattern,W)?!1:B.includePattern||B.usingSearchPaths?B.includePattern&&t.match(B.includePattern,W)?!0:B.usingSearchPaths?!!B.folderQueries&&B.folderQueries.some(H=>{const z=H.folder.fsPath;if(_.isEqualOrParent(W,z)){const J=y.relative(z,W);return!H.includePattern||!!t.match(H.includePattern,J)}else return!1}):!1:!0}e.pathIncludedInQuery=o;var d;(function(B){B[B.unknownEncoding=1]="unknownEncoding",B[B.regexParseError=2]="regexParseError",B[B.globParseError=3]="globParseError",B[B.invalidLiteral=4]="invalidLiteral",B[B.rgProcessError=5]="rgProcessError",B[B.other=6]="other",B[B.canceled=7]="canceled"})(d=e.SearchErrorCode||(e.SearchErrorCode={}));class m extends Error{constructor(W,H){super(W);this.code=H}}e.SearchError=m;function v(B){const W=B.message;if((0,P.isCancellationError)(B))return new m(W,d.canceled);try{const H=JSON.parse(W);return new m(H.message,H.code)}catch{return new m(W,d.other)}}e.deserializeSearchError=v;function w(B){const W={message:B.message,code:B.code};return new Error(JSON.stringify(W))}e.serializeSearchError=w;function A(B){return B.type==="error"?!0:B.type==="success"}e.isSerializedSearchComplete=A;function M(B){return B.type==="success"}e.isSerializedSearchSuccess=M;function T(B){return!!B.path}e.isSerializedFileMatch=T;function O(B,W){const H=B.searchPath?B.searchPath:B.relativePath;return(0,R.fuzzyContains)(H,W)}e.isFilePatternMatch=O;class U{constructor(W){this.path=W,this.results=[]}addMatch(W){this.results.push(W)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=U;function V(B,W){const H={...B||{},...W||{}};return Object.keys(H).filter(z=>{const J=H[z];return typeof J=="boolean"&&J})}e.resolvePatternsForProvider=V;class x{constructor(W,H){this._parsedIncludeExpression=null,this._excludeExpression={...W.excludePattern||{},...H.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let z=W.includePattern;H.includePattern&&(z?z={...z,...H.includePattern}:z=H.includePattern),z&&(this._parsedIncludeExpression=t.parse(z))}matchesExcludesSync(W,H,z){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(W,H,z))}includedInQuerySync(W,H,z){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(W,H,z)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(W,H,z))}includedInQuery(W,H,z){const J=this._parsedExcludeExpression(W,H,z),ie=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(W,H,z):!0;return(0,C.isThenable)(J)?J.then(se=>se?!1:ie()):ie()}hasSiblingExcludeClauses(){return N(this._excludeExpression)}}e.QueryGlobTester=x;function N(B){for(const W in B)if(typeof B[W]!="boolean")return!0;return!1}}),define(pe[35],ve([0,1,17,13,21,3,24,10,94,23,8,18,2,170,4,11,189,43,44,26,14,15,7,31,5]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p,g,E,F,D,u,s,h,n,S,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(A,M,T){return new P.ExtUri(O=>d(O,T)).isEqual(A,M)}function r(A,M,T){return i(A.uri,M.uri,T)?0:(0,L.compare)(A.uri.toString(),M.uri.toString())}function c(A,M,T){return A.index!==M.index?A.index<M.index?-1:1:i(A.uri,M.uri,T)?(0,L.compare)(A.name,M.name):(0,L.compare)(A.uri.toString(),M.uri.toString())}function o(A,M,T,O){const U=A.slice(0).sort((x,N)=>T(x,N,O)),V=M.slice(0).sort((x,N)=>T(x,N,O));return(0,f.delta)(U,V,(x,N)=>T(x,N,O))}function d(A,M){const T=M.getCapabilities(A.scheme);return!(T&&T&1024)}class m extends F.Workspace{constructor(M,T,O,U,V,x,N){super(M,O.map(B=>new F.WorkspaceFolder(B)),U,V,N);this._name=T,this._isUntitled=x,this._workspaceFolders=[],this._structure=R.TernarySearchTree.forUris(N),O.forEach(B=>{this._workspaceFolders.push(B),this._structure.set(B.uri,B)})}static toExtHostWorkspace(M,T,O,U){if(!M)return{workspace:null,added:[],removed:[]};const{id:V,name:x,folders:N,configuration:B,transient:W,isUntitled:H}=M,z=[],J=T;T?N.forEach((X,ae)=>{const fe=l.URI.revive(X.uri),be=m._findFolder(O||T,fe,U);be?(be.name=X.name,be.index=X.index,z.push(be)):z.push({uri:fe,name:X.name,index:ae})}):z.push(...N.map(({uri:X,name:ae,index:fe})=>({uri:l.URI.revive(X),name:ae,index:fe}))),z.sort((X,ae)=>X.index<ae.index?-1:1);const ie=new m(V,x,z,!!W,B?l.URI.revive(B):null,!!H,X=>d(X,U)),{added:se,removed:K}=o(J?J.workspaceFolders:[],ie.workspaceFolders,r,U);return{workspace:ie,added:se,removed:K}}static _findFolder(M,T,O){for(let U=0;U<M.folders.length;U++){const V=M.workspaceFolders[U];if(i(V.uri,T,O))return V}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(M,T){return T&&this._structure.get(M)&&(M=(0,P.dirname)(M)),this._structure.findSubstr(M)}resolveWorkspaceFolder(M){return this._structure.get(M)}}let v=class{constructor(M,T,O,U){this._onDidChangeWorkspace=new _.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new _.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=U,this._extHostFileSystemInfo=O,this._requestIdProvider=new y.Counter,this._barrier=new t.Barrier,this._proxy=M.getProxy(a.MainContext.MainThreadWorkspace),this._messageService=M.getProxy(a.MainContext.MainThreadMessageService);const V=T.workspace;this._confirmedWorkspace=V?new m(V.id,V.name,[],!!V.transient,V.configuration?l.URI.revive(V.configuration):null,!!V.isUntitled,x=>d(x,O)):void 0}$initializeWorkspace(M,T){this._trusted=T,this.$acceptWorkspaceData(M),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:k.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(M,T,O,...U){const V=[];if(Array.isArray(U)&&U.forEach(H=>{l.URI.isUri(H.uri)&&!V.some(z=>i(z.uri,H.uri,this._extHostFileSystemInfo))&&V.push({uri:H.uri,name:H.name||(0,P.basenameOrAuthority)(H.uri)})}),this._unconfirmedWorkspace||[T,O].some(H=>typeof H!="number"||H<0)||O===0&&V.length===0)return!1;const x=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(T+O>x.length)return!1;const N=x.slice(0);N.splice(T,O,...V.map(H=>({uri:H.uri,name:H.name||(0,P.basenameOrAuthority)(H.uri),index:void 0})));for(let H=0;H<N.length;H++){const z=N[H];if(N.some((J,ie)=>ie!==H&&i(z.uri,J.uri,this._extHostFileSystemInfo)))return!1}N.forEach((H,z)=>H.index=z);const{added:B,removed:W}=o(x,N,c,this._extHostFileSystemInfo);if(B.length===0&&W.length===0)return!1;if(this._proxy){const H=M.displayName||M.name;this._proxy.$updateWorkspaceFolders(H,T,O,V).then(void 0,z=>{this._unconfirmedWorkspace=void 0;const J={source:{identifier:M.identifier,label:M.displayName||M.name}};this._messageService.$showMessage(E.Severity.Error,(0,b.localize)(0,null,H,z.toString()),J,[])})}return this.trySetWorkspaceFolders(N),!0}getWorkspaceFolder(M,T){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(M,T)}async getWorkspaceFolder2(M,T){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(M,T)}async resolveWorkspaceFolder(M){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(M)}getPath(){if(!this._actualWorkspace)return;const{folders:M}=this._actualWorkspace;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,T){let O,U="";if(typeof M=="string"?(O=l.URI.file(M),U=M):typeof M!="undefined"&&(O=M,U=M.fsPath),!O)return U;const V=this.getWorkspaceFolder(O,!0);if(!V)return U;typeof T=="undefined"&&this._actualWorkspace&&(T=this._actualWorkspace.folders.length>1);let x=(0,P.relativePath)(V.uri,O);return T&&V.name&&(x=`${V.name}/${x}`),x}trySetWorkspaceFolders(M){this._actualWorkspace&&(this._unconfirmedWorkspace=m.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:M,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:T,added:O,removed:U}=m.toExtHostWorkspace(M,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=T||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:U}))}findFiles(M,T,O,U,V=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let x;if(T===null?x=!1:T&&(typeof T=="string"?x=T:x=T.pattern),V&&V.isCancellationRequested)return Promise.resolve([]);const{includePattern:N,folder:B}=w(h.GlobPattern.from(M));return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(N),(0,C.withUndefinedAsNull)(B),(0,C.withUndefinedAsNull)(x),(0,C.withUndefinedAsNull)(O),V).then(W=>Array.isArray(W)?W.map(H=>l.URI.revive(H)):[])}async findTextInFiles(M,T,O,U,V=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const x=this._requestIdProvider.getNext(),N=typeof T.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:T.previewOptions,{includePattern:B,folder:W}=w(h.GlobPattern.from(T.include)),H=typeof T.exclude=="string"?T.exclude:T.exclude?T.exclude.pattern:void 0,z={ignoreSymlinks:typeof T.followSymlinks=="boolean"?!T.followSymlinks:void 0,disregardIgnoreFiles:typeof T.useIgnoreFiles=="boolean"?!T.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof T.useGlobalIgnoreFiles=="boolean"?!T.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof T.useParentIgnoreFiles=="boolean"?!T.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof T.useDefaultExcludes=="boolean"?!T.useDefaultExcludes:!0,fileEncoding:T.encoding,maxResults:T.maxResults,previewOptions:N,afterContext:T.afterContext,beforeContext:T.beforeContext,includePattern:B,excludePattern:H},J=!1;if(this._activeSearchCallbacks[x]=ie=>{if(J)return;const se=l.URI.revive(ie.resource);ie.results.forEach(K=>{(0,S.resultIsMatch)(K)?O({uri:se,preview:{text:K.preview.text,matches:(0,f.mapArrayOrNot)(K.preview.matches,X=>new n.Range(X.startLineNumber,X.startColumn,X.endLineNumber,X.endColumn))},ranges:(0,f.mapArrayOrNot)(K.ranges,X=>new n.Range(X.startLineNumber,X.startColumn,X.endLineNumber,X.endColumn))}):O({uri:se,text:K.text,lineNumber:K.lineNumber})})},V.isCancellationRequested)return{};try{const ie=await this._proxy.$startTextSearch(M,(0,C.withUndefinedAsNull)(W),z,x,V);return delete this._activeSearchCallbacks[x],ie||{}}catch(ie){throw delete this._activeSearchCallbacks[x],ie}}$handleTextSearchResult(M,T){this._activeSearchCallbacks[T]&&this._activeSearchCallbacks[T](M)}saveAll(M){return this._proxy.$saveAll(M)}resolveProxy(M){return this._proxy.$resolveProxy(M)}get trusted(){return this._trusted}requestWorkspaceTrust(M){return this._proxy.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};v=je([ze(0,s.IExtHostRpcService),ze(1,u.IExtHostInitDataService),ze(2,D.IExtHostFileSystemInfo),ze(3,g.ILogService)],v),e.ExtHostWorkspace=v,e.IExtHostWorkspace=(0,p.createDecorator)("IExtHostWorkspace");function w(A){let M,T;return A&&(typeof A=="string"?M=A:(M=A.pattern,T=l.URI.revive(A.baseUri))),{includePattern:M,folder:T}}}),define(pe[36],ve([0,1,25,3,35,5,7,193,119,18,13,4,14,11,2]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function g(S,a){if(a){const i=a.split(".");let r=S;for(let c=0;r&&c<i.length;c++)r=r[i[c]];return r}}function E(S){return S instanceof p.URI}function F(S){return S&&S.uri instanceof p.URI&&S.languageId&&typeof S.languageId=="string"}function D(S){return S&&!S.uri&&S.languageId&&typeof S.languageId=="string"}function u(S){return S&&S.uri instanceof p.URI&&(!S.name||typeof S.name=="string")&&(!S.index||typeof S.index=="number")}function s(S){if(E(S))return{resource:S};if(F(S))return{resource:S.uri,overrideIdentifier:S.languageId};if(D(S))return{overrideIdentifier:S.languageId};if(u(S))return{resource:S.uri};if(S===null)return{resource:null}}let h=class{constructor(a,i,r){this._proxy=a.getProxy(_.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=r,this._barrier=new L.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(a=>this._actual)}$initializeConfiguration(a){this._actual=new n(this._proxy,this._extHostWorkspace,a,this._logService),this._barrier.open()}$acceptConfigurationChanged(a,i){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(a,i))}};h=je([ze(0,l.IExtHostRpcService),ze(1,I.IExtHostWorkspace),ze(2,b.ILogService)],h),e.ExtHostConfiguration=h;class n{constructor(a,i,r,c){this._onDidChangeConfiguration=new t.Emitter,this._proxy=a,this._logService=c,this._extHostWorkspace=i,this._configuration=k.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(a,i){const r={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,r))}getConfiguration(a,i,r){const c=s(i)||{},o=this._toReadonlyValue(a?g(this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace),a):this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace));a&&this._validateConfigurationAccess(a,c,r?.identifier);function d(v){if(v==null)return null;if(typeof v=="boolean")return v?1:4;switch(v){case R.ConfigurationTarget.Global:return 1;case R.ConfigurationTarget.Workspace:return 4;case R.ConfigurationTarget.WorkspaceFolder:return 5}}const m={has(v){return typeof g(o,v)!="undefined"},get:(v,w)=>{this._validateConfigurationAccess(a?`${a}.${v}`:v,c,r?.identifier);let A=g(o,v);if(typeof A=="undefined")A=w;else{let M;const T=(O,U)=>{let V;const x=()=>{M=M||(0,f.deepClone)(o),V=V||g(M,U)};return(0,P.isObject)(O)?new Proxy(O,{get:(N,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return x(),()=>V;if(M)return V=V||g(M,U),V[B];const W=N[B];return typeof B=="string"?T(W,`${U}.${B}`):W},set:(N,B,W)=>(x(),V&&(V[B]=W),!0),deleteProperty:(N,B)=>(x(),V&&delete V[B],!0),defineProperty:(N,B,W)=>(x(),V&&Object.defineProperty(V,B,W),!0)}):O};A=T(A,v)}return A},update:(v,w,A,M)=>{v=a?`${a}.${v}`:v;const T=d(A);return w!==void 0?this._proxy.$updateConfigurationOption(T,v,w,c,M):this._proxy.$removeConfigurationOption(T,v,c,M)},inspect:v=>{v=a?`${a}.${v}`:v;const w=(0,f.deepClone)(this._configuration.inspect(v,c,this._extHostWorkspace.workspace));if(w)return{key:v,defaultValue:w.default?.value,globalValue:w.user?.value,workspaceValue:w.workspace?.value,workspaceFolderValue:w.workspaceFolder?.value,defaultLanguageValue:w.default?.override,globalLanguageValue:w.user?.override,workspaceLanguageValue:w.workspace?.override,workspaceFolderLanguageValue:w.workspaceFolder?.override,languageIds:w.overrideIdentifiers}}};return typeof o=="object"&&(0,f.mixin)(m,o,!1),Object.freeze(m)}_toReadonlyValue(a){const i=r=>(0,P.isObject)(r)?new Proxy(r,{get:(c,o)=>i(c[o]),set:(c,o,d)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(o)}' of object`)},deleteProperty:(c,o)=>{throw new Error(`TypeError: Cannot delete read only property '${String(o)}' of object`)},defineProperty:(c,o)=>{throw new Error(`TypeError: Cannot define property '${String(o)}' for a readonly object`)},setPrototypeOf:c=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return i(a)}_validateConfigurationAccess(a,i,r){const c=y.OVERRIDE_PROPERTY_REGEX.test(a)?4:this._configurationScopes.get(a),o=r?`[${r.value}] `:"";if(c===4){typeof i?.resource=="undefined"&&this._logService.warn(`${o}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(c===3){i?.resource&&this._logService.warn(`${o}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(a,i){const r=new k.ConfigurationChangeEvent(a,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(c,o)=>r.affectsConfiguration(c,s(o))})}_toMap(a){return a.reduce((i,r)=>(i.set(r[0],r[1]),i),new Map)}}e.ExtHostConfigProvider=n,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[71],ve([0,1,2,13,3,5,7,35,45,36,21,34,14,26,4,10,12,11,66,213,16]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p,g,E,F,D,u,s){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var n;(function(U){function V(N){if(N!=null)return N}U.from=V;function x(N){if(N!=null)return N}U.to=x})(n=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var S;(function(U){function V(N){if(N!=null)return N}U.from=V;function x(N){if(N!=null)return N}U.to=x})(S=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var a;(function(U){function V(N){if(N!=null)return N}U.from=V;function x(N){if(N!=null)return N}U.to=x})(a=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(U){function V(B){if(B){const W=B;return W&&!!W.process}else return!1}U.is=V;function x(B){if(B==null)return;const W={process:B.process,args:B.args};return B.options&&(W.options=a.from(B.options)),W}U.from=x;function N(B){if(B!=null)return new R.ProcessExecution(B.process,B.args,B.options)}U.to=N})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var r;(function(U){function V(N){if(N!=null)return N}U.from=V;function x(N){if(N!=null)return N}U.to=x})(r=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var c;(function(U){function V(B){if(B){const W=B;return W&&(!!W.commandLine||!!W.command)}else return!1}U.is=V;function x(B){if(B==null)return;const W={};return B.commandLine!==void 0?W.commandLine=B.commandLine:(W.command=B.command,W.args=B.args),B.options&&(W.options=r.from(B.options)),W}U.from=x;function N(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new R.ShellExecution(B.commandLine,B.options):new R.ShellExecution(B.command,B.args?B.args:[],B.options)}U.to=N})(c=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var o;(function(U){function V(B){if(B){let W=B;return W&&W.customExecution==="customExecution"}else return!1}U.is=V;function x(B){return{customExecution:"customExecution"}}U.from=x;function N(B,W){return W.get(B)}U.to=N})(o=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var d;(function(U){function V(x,N){let B;return x.scope!==void 0&&typeof x.scope!="number"?B=x.scope.uri:x.scope!==void 0&&typeof x.scope=="number"&&(x.scope===R.TaskScope.Workspace&&N&&N.workspaceFile?B=N.workspaceFile:B=u.USER_TASKS_GROUP_KEY),{id:x._id,workspaceFolder:B}}U.from=V})(d=e.TaskHandleDTO||(e.TaskHandleDTO={}));var m;(function(U){function V(x){if(x!=null)return{_id:x.id,isDefault:x.isDefault}}U.from=V})(m=e.TaskGroupDTO||(e.TaskGroupDTO={}));var v;(function(U){function V(B,W){if(B==null)return[];const H=[];for(let z of B){const J=x(z,W);J&&H.push(J)}return H}U.fromMany=V;function x(B,W){if(B==null)return;let H;B.execution instanceof R.ProcessExecution?H=i.from(B.execution):B.execution instanceof R.ShellExecution?H=c.from(B.execution):B.execution&&B.execution instanceof R.CustomExecution&&(H=o.from(B.execution));const z=n.from(B.definition);let J;return B.scope?typeof B.scope=="number"?J=B.scope:J=B.scope.uri:J=R.TaskScope.Workspace,!z||!J?void 0:{_id:B._id,definition:z,name:B.name,source:{extensionId:W.identifier.value,label:B.source,scope:J},execution:H,isBackground:B.isBackground,group:m.from(B.group),presentationOptions:S.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}U.from=x;async function N(B,W,H){if(B==null)return;let z;i.is(B.execution)?z=i.to(B.execution):c.is(B.execution)?z=c.to(B.execution):o.is(B.execution)&&(z=o.to(B._id,H));const J=n.to(B.definition);let ie;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?ie=B.source.scope:ie=await W.resolveWorkspaceFolder(f.URI.revive(B.source.scope)):ie=R.TaskScope.Workspace),!J||!ie)return;const se=new R.Task(J,ie,B.name,B.source.label,z,B.problemMatchers);return B.isBackground!==void 0&&(se.isBackground=B.isBackground),B.group!==void 0&&(se.group=R.TaskGroup.from(B.group._id),se.group&&B.group.isDefault&&(se.group=new R.TaskGroup(se.group.id,se.group.label),B.group.isDefault&&(se.group.isDefault=B.group.isDefault))),B.presentationOptions&&(se.presentationOptions=S.to(B.presentationOptions)),B._id&&(se._id=B._id),B.detail&&(se.detail=B.detail),se}U.to=N})(v=e.TaskDTO||(e.TaskDTO={}));var w;(function(U){function V(N){return N}U.from=V;function x(N){if(!!N)return Object.assign(Object.create(null),N)}U.to=x})(w=e.TaskFilterDTO||(e.TaskFilterDTO={}));class A{constructor(V,x,N){this._id=x,this._task=N,h.set(this,void 0),nt(this,h,V,"f")}get task(){return this._task}terminate(){Le(this,h,"f").terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}h=new WeakMap;var M;(function(U){function V(x){return{id:x._id,task:void 0}}U.from=V})(M=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let T=class{constructor(V,x,N,B,W,H,z,J){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=V.getProxy(_.MainContext.MainThreadTask),this._workspaceProvider=N,this._editorService=B,this._configurationService=W,this._terminalService=H,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=z,this._deprecationService=J,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(V,x,N){if(!N)return new R.Disposable(()=>{});const B=this.nextHandle();return this._handlers.set(B,{type:x,provider:N,extension:V}),this._proxy.$registerTaskProvider(B,x),new R.Disposable(()=>{this._handlers.delete(B),this._proxy.$unregisterTaskProvider(B)})}registerTaskSystem(V,x){this._proxy.$registerTaskSystem(V,x)}fetchTasks(V){return this._proxy.$fetchTasks(w.from(V)).then(async x=>{const N=[];for(let B of x){const W=await v.to(B,this._workspaceProvider,this._providedCustomExecutions2);W&&N.push(W)}return N})}get taskExecutions(){const V=[];return this._taskExecutions.forEach(x=>V.push(x)),V}terminateTask(V){if(!(V instanceof A))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(V._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(V,x,N){const B=this._providedCustomExecutions2.get(V.id);B&&(this._activeCustomExecutions2.set(V.id,B),this._terminalService.attachPtyToTerminal(x,await B.callback(N))),this._lastStartedTask=V.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(V)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(V){const x=await this.getTaskExecution(V);this._taskExecutionPromises.delete(V.id),this._taskExecutions.delete(V.id),this.customExecutionComplete(V),this._onDidTerminateTask.fire({execution:x})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(V){const x=await this.getTaskExecution(V.id);this._onDidTaskProcessStarted.fire({execution:x,processId:V.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(V){const x=await this.getTaskExecution(V.id);this._onDidTaskProcessEnded.fire({execution:x,exitCode:V.exitCode})}$provideTasks(V,x){const N=this._handlers.get(V);if(!N)return Promise.reject(new Error("no handler found"));const B=[],W=(0,t.asPromise)(()=>N.provider.provideTasks(L.CancellationToken.None)).then(H=>this.provideTasksInternal(x,B,N,H));return new Promise(H=>{W.then(z=>{Promise.all(B).then(()=>{H(z)})})})}async $resolveTask(V,x){const N=this._handlers.get(V);if(!N)return Promise.reject(new Error("no handler found"));if(x.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${x.definition.type}] cannot be resolved by provider of type [${N.type}].`);const B=await v.to(x,this._workspaceProvider,this._providedCustomExecutions2);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const W=await N.provider.resolveTask(B,L.CancellationToken.None);if(!W)return;this.checkDeprecation(W,N);const H=v.from(W,N.extension);if(!H)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return o.is(H.execution)&&await this.addCustomExecution(H,W,!0),await this.resolveTaskInternal(H)}nextHandle(){return this._handleCounter++}async addCustomExecution(V,x,N){const B=await this._proxy.$createTaskId(V);!N&&!this._providedCustomExecutions2.has(B)&&(this._notProvidedCustomExecutions.add(B),this._activeCustomExecutions2.set(B,x.execution)),this._providedCustomExecutions2.set(B,x.execution)}async getTaskExecution(V,x){if(typeof V=="string"){const W=this._taskExecutionPromises.get(V);if(!W)throw new Error("Unexpected: The specified task is missing an execution");return W}let N=this._taskExecutionPromises.get(V.id);if(N)return N;const B=new Promise((W,H)=>{function z(J,ie,se){se?W(new A(J,ie.id,se)):H("Unexpected: Task does not exist.")}x?z(this,V,x):v.to(V.task,this._workspaceProvider,this._providedCustomExecutions2).then(J=>z(this,V,J))});return this._taskExecutionPromises.set(V.id,B),B.then(W=>(this._taskExecutions.set(V.id,W),W),W=>Promise.reject(W))}checkDeprecation(V,x){V._deprecated&&this._deprecationService.report("Task.constructor",x.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(V){this._activeCustomExecutions2.get(V.id)&&this._activeCustomExecutions2.delete(V.id),this._notProvidedCustomExecutions.has(V.id)&&this._lastStartedTask!==V.id&&(this._providedCustomExecutions2.delete(V.id),this._notProvidedCustomExecutions.delete(V.id));let N=this._notProvidedCustomExecutions.values(),B=N.next();for(;!B.done;)!this._activeCustomExecutions2.has(B.value)&&this._lastStartedTask!==B.value&&(this._providedCustomExecutions2.delete(B.value),this._notProvidedCustomExecutions.delete(B.value)),B=N.next()}};T=je([ze(0,l.IExtHostRpcService),ze(1,b.IExtHostInitDataService),ze(2,k.IExtHostWorkspace),ze(3,y.IExtHostDocumentsAndEditors),ze(4,P.IExtHostConfiguration),ze(5,C.IExtHostTerminalService),ze(6,F.ILogService),ze(7,D.IExtHostApiDeprecationService)],T),e.ExtHostTaskBase=T;let O=class extends T{constructor(V,x,N,B,W,H,z,J){super(V,x,N,B,W,H,z,J);this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:"",platform:E.PlatformToString(0)})}async executeTask(V,x){if(!x.execution)throw new Error("Tasks to execute must include an execution");const N=v.from(x,V);if(N===void 0)throw new Error("Task is not valid");if(o.is(N.execution))await this.addCustomExecution(N,x,!1);else throw new s.NotSupportedError;const B=await this.getTaskExecution(await this._proxy.$getTaskExecution(N),x);return this._proxy.$executeTask(N).catch(W=>{throw new Error(W)}),B}provideTasksInternal(V,x,N,B){const W=[];if(B)for(let H of B){this.checkDeprecation(H,N),(!H.definition||!V[H.definition.type])&&this._logService.warn(`The task [${H.source}, ${H.name}] uses an undefined task type. The task will be ignored in the future.`);const z=v.from(H,N.extension);z&&o.is(z.execution)?(W.push(z),x.push(this.addCustomExecution(z,H,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:W,extension:N.extension}}async resolveTaskInternal(V){if(o.is(V.execution))return V;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(V,x){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,x,N){}};O=je([ze(0,l.IExtHostRpcService),ze(1,b.IExtHostInitDataService),ze(2,k.IExtHostWorkspace),ze(3,y.IExtHostDocumentsAndEditors),ze(4,P.IExtHostConfiguration),ze(5,C.IExtHostTerminalService),ze(6,F.ILogService),ze(7,D.IExtHostApiDeprecationService)],O),e.WorkerExtHostTask=O,e.IExtHostTask=(0,p.createDecorator)("IExtHostTask")}),define(pe[266],ve([0,1,17,75,32,80,24,10,9,23,8,18,2,150,176,116,43,129,265,31]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p,g,E,F,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let s=class{constructor(d,m,v,w){this.configurationService=d,this.workspaceContextService=m,this.editorGroupsService=v,this.pathService=w}text(d,m,v={}){d=this.getContentPattern(d,v);const w=this.configurationService.getValue(),A=m&&m.some(T=>!this.configurationService.getValue({resource:T}).search.useRipgrep);return{...this.commonQuery(m?.map(E.toWorkspaceFolder),v),type:2,contentPattern:d,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:w.search.usePCRE2||A||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles}}getContentPattern(d,m){const v=this.configurationService.getValue();d.isRegExp&&(d.pattern=d.pattern.replace(/\r?\n/g,"\\n"));const w={...d,wordSeparators:v.editor.wordSeparators};return this.isCaseSensitive(d,m)&&(w.isCaseSensitive=!0),this.isMultiline(d)&&(w.isMultiline=!0),w}file(d,m={}){return{...this.commonQuery(d,m),type:1,filePattern:m.filePattern?m.filePattern.trim():m.filePattern,exists:m.exists,sortByScore:m.sortByScore,cacheKey:m.cacheKey}}handleIncludeExclude(d,m){return d?(d=Array.isArray(d)?d.map(i):i(d),m?this.parseSearchPaths(d):{pattern:n(...Array.isArray(d)?d:[d])}):{}}commonQuery(d=[],m={}){const v=this.handleIncludeExclude(m.includePattern,m.expandPatterns),w=this.handleIncludeExclude(m.excludePattern,m.expandPatterns),A=d.length>1,M=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(U=>this.getFolderQueryForSearchPath(U,m,w)):d.map(U=>this.getFolderQueryForRoot(U,m,w,A))).filter(U=>!!U),T={_reason:m._reason,folderQueries:M,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:m.extraFileResources,excludePattern:w.pattern,includePattern:v.pattern,onlyOpenEditors:m.onlyOpenEditors,maxResults:m.maxResults};if(m.onlyOpenEditors){const V=f.coalesce(f.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(B=>B.resource)))).filter(N=>(0,u.pathIncludedInQuery)(T,N.fsPath)),x=this.commonQueryFromFileList(V);return{...T,...x}}const O=m.extraFileResources&&m.extraFileResources.filter(U=>(0,u.pathIncludedInQuery)(T,U.fsPath));return T.extraFileResources=O&&O.length?O:void 0,T}commonQueryFromFileList(d){const m=[],v=new R.ResourceMap,w={};let A=!1;return d.forEach(M=>{if(M.scheme===k.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(M)){const O=this.workspaceContextService.getWorkspaceFolder(M)?.uri??M.with({path:y.dirname(M.fsPath)});let U=v.get(O);U||(A=!0,U={folder:O,includePattern:{}},m.push(U),v.set(O,U));const V=y.relative(O.fsPath,M.fsPath);(0,C.assertIsDefined)(U.includePattern)[V.replace(/\\/g,"/")]=!0}else M.fsPath&&(A=!0,w[M.fsPath]=!0)}),{folderQueries:m,includePattern:w,usingSearchPaths:!0,excludePattern:A?void 0:{"**/*":!0}}}isCaseSensitive(d,m){if(m.isSmartCase){if(d.isRegExp){if(L.containsUppercaseCharacter(d.pattern,!0))return!0}else if(L.containsUppercaseCharacter(d.pattern))return!0}return!!d.isCaseSensitive}isMultiline(d){return d.isMultiline||d.isRegExp&&(0,b.isMultilineRegexSource)(d.pattern)||d.pattern.indexOf(`
`)>=0?!0:!!d.isMultiline}parseSearchPaths(d){const m=x=>y.isAbsolute(x)||/^\.\.?([\/\\]|$)/.test(x),w=(Array.isArray(d)?d:S(d)).map(x=>{const N=this.pathService.resolvedUserHome;return N?(0,_.untildify)(x,N.scheme===k.Schemas.file?N.fsPath:N.path):x}),A=t.groupBy(w,x=>m(x)?"searchPaths":"exprSegments"),M=(A.exprSegments||[]).map(x=>L.rtrim(x,"/")).map(x=>L.rtrim(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),a(x))),T={},O=this.expandSearchPathPatterns(A.searchPaths||[]);O&&O.length&&(T.searchPaths=O);const U=f.flatten(M),V=n(...U);return V&&(T.pattern=V),T}getExcludesForFolder(d,m){return m.disregardExcludeSettings?void 0:(0,u.getExcludes)(d,!m.disregardSearchExcludeSettings)}expandSearchPathPatterns(d){if(!d||!d.length)return[];const m=f.flatten(d.map(w=>{let{pathPortion:A,globPortion:M}=h(w);M&&(M=r(M));const T=this.expandOneSearchPath(A);return f.flatten(T.map(O=>this.resolveOneSearchPathPattern(O,M)))})),v=new Map;return m.forEach(w=>{const A=w.searchPath.toString(),M=v.get(A);M?w.pattern&&(M.pattern=M.pattern||{},M.pattern[w.pattern]=!0):v.set(A,{searchPath:w.searchPath,pattern:w.pattern?n(w.pattern):void 0})}),Array.from(v.values())}expandOneSearchPath(d){if(y.isAbsolute(d)){const m=this.workspaceContextService.getWorkspace().folders;return m[0]&&m[0].uri.scheme!==k.Schemas.file?[{searchPath:m[0].uri.with({path:d})}]:[{searchPath:l.URI.file(y.normalize(d))}]}if(this.workspaceContextService.getWorkbenchState()===2){const m=this.workspaceContextService.getWorkspace().folders[0].uri;if(d=i(d),d.startsWith("../")||d===".."){const w=y.posix.resolve(m.path,d);return[{searchPath:m.with({path:w})}]}const v=r(d);return[{searchPath:m,pattern:v}]}else{if(d==="./"||d===".\\")return[];{const m=d.replace(/^\.[\/\\]/,""),w=this.workspaceContextService.getWorkspace().folders.map(A=>{const M=m.match(new RegExp(`^${L.escapeRegExpCharacters(A.name)}(?:/(.*)|$)`));return M?{match:M,folder:A}:null}).filter(C.isDefined);if(w.length)return w.map(A=>{const M=A.match[1];return{searchPath:A.folder.uri,pattern:M&&r(M)}});{const A=d.match(/\.[\/\\](.+)[\/\\]?/),M=A?A[1]:d,T=p.localize(0,null,M);throw new Error(T)}}}}resolveOneSearchPathPattern(d,m){const v=d.pattern&&m?`${d.pattern}/${m}`:d.pattern||m,w=[{searchPath:d.searchPath,pattern:v}];return v&&!v.endsWith("**")&&w.push({searchPath:d.searchPath,pattern:v+"/**"}),w}getFolderQueryForSearchPath(d,m,v){const w=this.getFolderQueryForRoot((0,E.toWorkspaceFolder)(d.searchPath),m,v,!1);return w?{...w,includePattern:d.pattern}:null}getFolderQueryForRoot(d,m,v,w){let A;const M=l.URI.isUri(d)?d:d.uri;if(v.searchPaths){const x=v.searchPaths.filter(N=>(0,P.isEqual)(N.searchPath,M))[0];if(x&&!x.pattern)return null;x&&(A=x.pattern)}const T=this.configurationService.getValue({resource:M}),U={...this.getExcludesForFolder(T,m)||{},...A||{}},V=l.URI.isUri(d)?(0,P.basename)(d):d.name;return{folder:M,folderName:w?V:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:T.files&&T.files.encoding,disregardIgnoreFiles:typeof m.disregardIgnoreFiles=="boolean"?m.disregardIgnoreFiles:!T.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof m.disregardGlobalIgnoreFiles=="boolean"?m.disregardGlobalIgnoreFiles:!T.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof m.disregardParentIgnoreFiles=="boolean"?m.disregardParentIgnoreFiles:!T.search.useParentIgnoreFiles,ignoreSymlinks:typeof m.ignoreSymlinks=="boolean"?m.ignoreSymlinks:!T.search.followSymlinks}}};s=je([ze(0,g.IConfigurationService),ze(1,E.IWorkspaceContextService),ze(2,F.IEditorGroupsService),ze(3,D.IPathService)],s),e.QueryBuilder=s;function h(o){const d=o.match(/[\*\{\}\(\)\[\]\?]/);if(d){const m=d.index,v=o.substr(0,m).match(/[/|\\][^/\\]*$/);if(v){let w=o.substr(0,v.index);return w.match(/[/\\]/)||(w+="/"),{pathPortion:w,globPortion:o.substr((v.index||0)+1)}}}return{pathPortion:o}}function n(...o){return o.length?o.reduce((d,m)=>(d[m]=!0,d),Object.create(null)):void 0}function S(o){return I.splitGlobAware(o,",").map(d=>d.trim()).filter(d=>!!d.length)}function a(o){return[`**/${o}/**`,`**/${o}`].map(m=>m.replace(/\*\*\/\*\*/g,"**"))}function i(o){return o.replace(/\\/g,"/")}function r(o){return i(o).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(o,d){o=f.distinct(o,w=>w.toString());const m=[],v=d.getWorkspace();return o&&o.forEach(w=>{let A;if(d.getWorkbenchState()===2)A=(0,P.relativePath)(v.folders[0].uri,w),A&&A!=="."&&(A="./"+A);else{const M=d.getWorkspaceFolder(w);if(M){const T=M.name;if(v.folders.filter(U=>U.name===T).length===1){const U=(0,P.relativePath)(M.uri,w);U===""?A=`./${M.name}`:A=`./${M.name}/${U}`}else A=w.fsPath}}A&&m.push(A)}),m}e.resolveResourcesForSearchIncludes=c}),define(pe[267],ve([0,1,23,2,21,16,4,266,31,43]),function(Z,e,f,t,I,_,R,k,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function C(g,E){const F=E.activationEvents;if(!F)return Promise.resolve(void 0);const D=[],u=[];for(const i of F)if(/^workspaceContains:/.test(i)){const r=i.substr("workspaceContains:".length);r.indexOf("*")>=0||r.indexOf("?")>=0||g.forceUsingSearch?u.push(r):D.push(r)}if(D.length===0&&u.length===0)return Promise.resolve(void 0);let s;const h=new Promise((i,r)=>{s=i}),n=i=>s({activationEvent:i}),S=Promise.all(D.map(i=>l(g,i,n))).then(()=>{}),a=b(g,E.identifier,u,n);return Promise.all([S,a]).then(()=>{s(void 0)}),h}e.checkActivateWorkspaceContainsExtension=C;async function l(g,E,F){for(const D of g.folders)if(await g.exists(f.joinPath(t.URI.revive(D),E))){F(`workspaceContains:${E}`);return}}async function b(g,E,F,D){if(F.length===0)return Promise.resolve(void 0);const u=new I.CancellationTokenSource,s=g.checkExists(g.folders,F,u.token),h=setTimeout(async()=>{u.cancel(),g.logService.info(`Not activating extension '${E.value}': Timed out while searching for 'workspaceContains' pattern ${F.join(",")}`)},L);let n=!1;try{n=await s}catch(S){_.isCancellationError(S)||_.onUnexpectedError(S)}u.dispose(),clearTimeout(h),n&&D(`workspaceContains:${F.join(",")}`)}function p(g,E,F,D){const u=g.get(R.IInstantiationService),s=g.get(y.ISearchService),n=u.createInstance(k.QueryBuilder).file(E.map(S=>(0,P.toWorkspaceFolder)(t.URI.revive(S))),{_reason:"checkExists",includePattern:F,exists:!0});return s.fileSearch(n,D).then(S=>!!S.limitHit,S=>_.isCancellationError(S)?!1:Promise.reject(S))}e.checkGlobFileExists=p});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[39],ve([0,1,165,9,72,23,13,6,24,2,11,5,36,224,90,35,28,222,16,27,22,199,7,120,4,26,68,14,84,51,34,3,267,89,201,10]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p,g,E,F,D,u,s,h,n,S,a,i,r,c,o,d,m,v,w,A,M,T){"use strict";var O,U,V;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let x=class Gi extends k.Disposable{constructor(z,J,ie,se,K,X,ae,fe,be,Me){super();this._onDidChangeRemoteConnectionData=this._register(new v.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=J,this._extHostContext=ie,this._initData=ae,this._extHostWorkspace=se,this._extHostConfiguration=K,this._logService=X,this._extHostTunnelService=be,this._extHostTerminalService=Me,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new R.Barrier,this._readyToStartExtensionHost=new R.Barrier,this._readyToRunExtensions=new R.Barrier,this._eagerExtensionsActivated=new R.Barrier,this._registry=new F.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new p.ExtHostStorage(this._extHostContext),this._secretState=new A.ExtHostSecretState(this._extHostContext),this._storagePath=fe,this._instaService=z.createChild(new o.ServiceCollection([p.IExtHostStorage,this._storage],[A.IExtHostSecretState,this._secretState]));const xe=new Set;this._initData.hostExtensions.forEach(Ge=>xe.add(u.ExtensionIdentifier.toKey(Ge))),this._activator=this._register(new b.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ge,Je,q)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ge,D.transformErrorForSerialization(Je),q)},actualActivateExtension:async(Ge,Je)=>{if(xe.has(u.ExtensionIdentifier.toKey(Ge)))return await this._mainThreadExtensionsProxy.$activateExtension(Ge,Je),new b.HostExtension;const q=this._registry.getExtensionDescription(Ge);return this._activateExtension(q,Je)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(z){D.onUnexpectedError(z)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let z=[];try{z=this._registry.getAllExtensionDescriptions().map(K=>K.identifier).filter(K=>this.isActivated(K)).map(K=>this._deactivate(K))}catch{}await Promise.all(z)}isActivated(z){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(z):!1}_activateByEvent(z,J){return this._activator.activateByEvent(z,J)}_activateById(z,J){return this._activator.activateById(z,J)}activateByIdWithErrors(z,J){return this._activateById(z,J).then(()=>{const ie=this._activator.getActivatedExtension(z);if(ie.activationFailed)return Promise.reject(ie.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(z=>this._registry)}getExtensionExports(z){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(z).exports:null}async _realPathExtensionUri(z){if(z.scheme!==T.Schemas.file)return z;const J=await this._hostUtils.realpath(z.fsPath);return P.URI.file(J)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const z=y.TernarySearchTree.forUris(J=>_.extUriBiasedIgnorePathCase.ignorePathCasing(J));for(const J of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(J)){const ie=await this._realPathExtensionUri(J.extensionLocation);z.set(ie,J)}return z})()),this._extensionPathIndex}_deactivate(z){let J=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(z))return J;const ie=this._activator.getActivatedExtension(z);if(!ie)return J;try{typeof ie.module.deactivate=="function"&&(J=Promise.resolve(ie.module.deactivate()).then(void 0,se=>(this._logService.error(se),Promise.resolve(void 0))))}catch(se){this._logService.error(`An error occurred when deactivating the extension '${z.value}':`),this._logService.error(se)}try{(0,k.dispose)(ie.subscriptions)}catch(se){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${z.value}':`),this._logService.error(se)}return J}async _activateExtension(z,J){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(z.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(z.identifier),this._doActivateExtension(z,J).then(ie=>{const se=ie.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(z.identifier,se.codeLoadingTime,se.activateCallTime,se.activateResolvedTime,J),this._logExtensionActivationTimes(z,J,"success",se),ie},ie=>{throw this._logExtensionActivationTimes(z,J,"failure"),ie})}_logExtensionActivationTimes(z,J,ie,se){const K=N(z,J);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...K,...se||{},outcome:ie})}_doActivateExtension(z,J){const ie=N(z,J);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ie);const se=this._getEntryPoint(z);if(!se)return Promise.resolve(new b.EmptyExtension(b.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${z.identifier.value}, startup: ${J.startup}, activationEvent: '${J.activationEvent}'${z.identifier.value!==J.extensionId.value?`, root cause: ${J.extensionId.value}`:""}`),this._logService.flush();const K=new b.ExtensionActivationTimesBuilder(J.startup);return Promise.all([this._loadCommonJSModule(z.identifier,(0,_.joinPath)(z.extensionLocation,se),K),this._loadExtensionContext(z)]).then(X=>(I.mark(`code/extHost/willActivateExtension/${z.identifier.value}`),Gi._callActivate(this._logService,z.identifier,X[0],X[1],K))).then(X=>(I.mark(`code/extHost/didActivateExtension/${z.identifier.value}`),X))}_loadExtensionContext(z){const J=new h.ExtensionGlobalMemento(z,this._storage),ie=new h.ExtensionMemento(z.identifier.value,!1,this._storage),se=new M.ExtensionSecrets(z,this._secretState),K=z.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,X=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${z.identifier.value}`),Promise.all([J.whenReady,ie.whenReady,this._storagePath.whenReady]).then(()=>{const ae=this;let fe,be;const Me=(0,E.isProposedApiEnabled)(z,"ipc")?this._initData.messagePorts?.get(u.ExtensionIdentifier.toKey(z.identifier)):void 0;return Object.freeze({globalState:J,workspaceState:ie,secrets:se,subscriptions:[],get extensionUri(){return z.extensionLocation},get extensionPath(){return z.extensionLocation.fsPath},asAbsolutePath(xe){return t.join(z.extensionLocation.fsPath,xe)},get storagePath(){return ae._storagePath.workspaceValue(z)?.fsPath},get globalStoragePath(){return ae._storagePath.globalValue(z).fsPath},get logPath(){return t.join(ae._initData.logsLocation.fsPath,z.identifier.value)},get logUri(){return P.URI.joinPath(ae._initData.logsLocation,z.identifier.value)},get storageUri(){return ae._storagePath.workspaceValue(z)},get globalStorageUri(){return ae._storagePath.globalValue(z)},get extensionMode(){return K},get extension(){return fe===void 0&&(fe=new B(ae,z.identifier,z,X)),fe},get extensionRuntime(){return(0,E.checkProposedApiEnabled)(z,"extensionRuntime"),ae.extensionRuntime},get environmentVariableCollection(){return ae._extHostTerminalService.getEnvironmentVariableCollection(z)},get messagePassingProtocol(){if(!be){if(!Me)return;const xe=v.Event.buffer(v.Event.fromDOMEventEmitter(Me,"message",Ge=>Ge.data));Me.start(),be={onDidReceiveMessage:xe,postMessage:Me.postMessage.bind(Me)}}return be}})})}static _callActivate(z,J,ie,se,K){return ie=ie||{activate:void 0,deactivate:void 0},this._callActivateOptional(z,J,ie,se,K).then(X=>new b.ActivatedExtension(!1,null,K.build(),ie,X,se.subscriptions))}static _callActivateOptional(z,J,ie,se,K){if(typeof ie.activate=="function")try{K.activateCallStart(),z.trace(`ExtensionService#_callActivateOptional ${J.value}`);const X=typeof global=="object"?global:self,ae=ie.activate.apply(X,[se]);return K.activateCallStop(),K.activateResolveStart(),Promise.resolve(ae).then(fe=>(K.activateResolveStop(),fe))}catch(X){return Promise.reject(X)}else return Promise.resolve(ie)}_activateOneStartupFinished(z,J){this._activateById(z.identifier,{startup:!1,extensionId:z.identifier,activationEvent:J}).then(void 0,ie=>{this._logService.error(ie)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks());for(const z of this._registry.getAllExtensionDescriptions())if(z.activationEvents)for(const J of z.activationEvents)J==="onStartupFinished"&&this._activateOneStartupFinished(z,J)}_handleEagerExtensions(){const z=this._activateByEvent("*",!0).then(void 0,K=>{this._logService.error(K)});this._register(this._extHostWorkspace.onDidChangeWorkspace(K=>this._handleWorkspaceContainsEagerExtensions(K.added)));const J=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ie=this._handleWorkspaceContainsEagerExtensions(J),se=Promise.all([z,ie]).then(()=>{});return Promise.race([se,(0,R.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),se}_handleWorkspaceContainsEagerExtensions(z){return z.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(J=>this._handleWorkspaceContainsEagerExtension(z,J))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(z,J){if(this.isActivated(J.identifier))return;const ie=!this._initData.remote.isRemote&&!!this._initData.remote.authority,se={logService:this._logService,folders:z.map(X=>X.uri),forceUsingSearch:ie,exists:X=>this._hostUtils.exists(X.fsPath),checkExists:(X,ae,fe)=>this._mainThreadWorkspaceProxy.$checkExists(X,ae,fe)},K=await(0,w.checkActivateWorkspaceContainsExtension)(se,J);if(!!K)return this._activateById(J.identifier,{startup:!0,extensionId:J.identifier,activationEvent:K.activationEvent}).then(void 0,X=>this._logService.error(X))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(z){throw console.error(z),z}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:z,extensionTestsLocationURI:J}=this._initData.environment;if(!z||!J)throw new Error(f.localize(0,null));const ie=await this._loadCommonJSModule(null,J,new b.ExtensionActivationTimesBuilder(!1));if(!ie||typeof ie.run!="function")throw new Error(f.localize(1,null,J.toString()));return new Promise((se,K)=>{const X=(be,Me)=>{be?K(be):se(typeof Me=="number"&&Me>0?1:0)},ae=(0,_.originalFSPath)(J),fe=ie.run(ae,X);fe&&fe.then&&fe.then(()=>{se(0)}).catch(be=>{K(be instanceof Error&&be.stack?be.stack:String(be))})})}async $extensionTestsExit(z){this._logService.info(`Extension host terminating: test runner requested exit with code ${z}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${z}`),this._logService.flush(),this._hostUtils.exit(z)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(z,J){return this._resolvers[z]=J,(0,k.toDisposable)(()=>{delete this._resolvers[z]})}async _activateAndGetResolver(z){const J=z.indexOf("+");if(J===-1)throw new Error("Not an authority that can be resolved!");const ie=z.substr(0,J);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ie}`,!1),{authorityPrefix:ie,resolver:this._resolvers[ie]}}async $resolveAuthority(z,J){this._logService.info(`$resolveAuthority invoked for authority (${W(z)})`);const{authorityPrefix:ie,resolver:se}=await this._activateAndGetResolver(z);if(!se)return{type:"error",error:{code:S.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ie}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(se)),I.mark(`code/extHost/willResolveAuthority/${ie}`);const K=await se.resolve(z,{resolveAttempt:J});I.mark(`code/extHost/didResolveAuthorityOK/${ie}`);const X={authority:z,host:K.host,port:K.port,connectionToken:K.connectionToken},ae={extensionHostEnv:K.extensionHostEnv,isTrusted:K.isTrusted,authenticationSession:K.authenticationSessionForInitializingExtensions?{id:K.authenticationSessionForInitializingExtensions.id,providerId:K.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:X,options:ae,tunnelInformation:{environmentTunnels:K.environmentTunnels,features:K.tunnelFeatures}}}}catch(K){if(I.mark(`code/extHost/didResolveAuthorityError/${ie}`),K instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K}}async $getCanonicalURI(z,J){this._logService.info(`$getCanonicalURI invoked for authority (${W(z)})`);const{authorityPrefix:ie,resolver:se}=await this._activateAndGetResolver(z);if(!se)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ie}`);const K=P.URI.revive(J);if(typeof se.getCanonicalURI=="undefined")return K;const X=await(0,R.asPromise)(()=>se.getCanonicalURI(K));return X||K}$startExtensionHost(z){return this._registry.keepOnly(z),this._startExtensionHost()}$activateByEvent(z,J){return J===1?this._activateByEvent(z,!1):this._readyToRunExtensions.wait().then(ie=>this._activateByEvent(z,!1))}async $activate(z,J){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(z)?(await this._activateById(z,J),!0):!1}async $deltaExtensions(z,J){z.forEach(se=>se.extensionLocation=P.URI.revive(se.extensionLocation));const ie=await this.getExtensionPathIndex();return await Promise.all(J.map(async se=>{const K=this._registry.getExtensionDescription(se);K&&ie.delete(await this._realPathExtensionUri(K.extensionLocation))})),await Promise.all(z.map(async se=>{const K=await this._realPathExtensionUri(se.extensionLocation);ie.set(K,se)})),this._registry.deltaExtensions(z,J),Promise.resolve(void 0)}async $test_latency(z){return z}async $test_up(z){return z.byteLength}async $test_down(z){let J=s.VSBuffer.alloc(z),ie=Math.random()%256;for(let se=0;se<z;se++)J.writeUInt8(ie,se);return J}async $updateRemoteConnectionData(z){this._remoteConnectionData=z,this._onDidChangeRemoteConnectionData.fire()}};x=je([ze(0,a.IInstantiationService),ze(1,e.IHostUtils),ze(2,c.IExtHostRpcService),ze(3,g.IExtHostWorkspace),ze(4,l.IExtHostConfiguration),ze(5,L.ILogService),ze(6,i.IExtHostInitDataService),ze(7,r.IExtensionStoragePaths),ze(8,d.IExtHostTunnelService),ze(9,m.IExtHostTerminalService)],x),e.AbstractExtHostExtensionService=x;function N(H,z){return{id:H.identifier.value,name:H.name,extensionVersion:H.version,publisherDisplayName:H.publisher,activationEvents:H.activationEvents?H.activationEvents.join(","):null,isBuiltin:H.isBuiltin,reason:z.activationEvent,reasonId:z.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class B{constructor(z,J,ie,se){O.set(this,void 0),U.set(this,void 0),V.set(this,void 0),nt(this,O,z,"f"),nt(this,U,J,"f"),nt(this,V,ie.identifier,"f"),this.id=ie.identifier.value,this.extensionUri=ie.extensionLocation,this.extensionPath=t.normalize((0,_.originalFSPath)(ie.extensionLocation)),this.packageJSON=ie,this.extensionKind=se}get isActive(){return Le(this,O,"f").isActivated(Le(this,V,"f"))}get exports(){if(this.packageJSON.api!=="none")return Le(this,O,"f").getExtensionExports(Le(this,V,"f"))}activate(){return Le(this,O,"f").activateByIdWithErrors(Le(this,V,"f"),{startup:!1,extensionId:Le(this,U,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=B,O=new WeakMap,U=new WeakMap,V=new WeakMap;function W(H){const z=H.indexOf("+");return z===-1?H:H.substring(0,z)}}),define(pe[54],ve([0,1,9,2,3,13,5,7,125,35,39,45,215,36,208,14,4,18,40,53]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p,g,E,F,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,E.createDecorator)("IExtHostDebugService");let s=class{constructor(o,d,m,v,w,A){this._workspaceService=d,this._extensionService=m,this._editorsService=v,this._configurationService=w,this._editorTabs=A,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new I.Emitter,this._onDidTerminateDebugSession=new I.Emitter,this._onDidChangeActiveDebugSession=new I.Emitter,this._onDidReceiveDebugSessionCustomEvent=new I.Emitter,this._debugServiceProxy=o.getProxy(R.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new I.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new n(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(M=>{M.onDidChange(T=>{this.registerAllDebugTypes(M)}),this.registerAllDebugTypes(M)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(o,d){const m=o;if(typeof m.sourceReference=="number"&&m.sourceReference>0){let v=`debug:${encodeURIComponent(m.path||"")}`,w="?";return d&&(v+=`${w}session=${encodeURIComponent(d.id)}`,w="&"),v+=`${w}ref=${m.sourceReference}`,t.URI.parse(v)}else{if(m.path)return t.URI.file(m.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(o){const d=[];for(const m of o.getAllExtensionDescriptions())if(m.contributes){const v=m.contributes.debuggers;if(v&&v.length>0)for(const w of v)(0,p.isDebuggerMainContribution)(w)&&d.push(w.type)}this._debugServiceProxy.$registerDebugTypes(d)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const o=[];return this._breakpoints.forEach(d=>o.push(d)),o}addBreakpoints(o){this.startBreakpoints();const d=o.filter(w=>{const A=w.id;return this._breakpoints.has(A)?!1:(this._breakpoints.set(A,w),!0)});this.fireBreakpointChanges(d,[],[]);const m=[],v=new Map;for(const w of d)if(w instanceof k.SourceBreakpoint){let A=v.get(w.location.uri.toString());A||(A={type:"sourceMulti",uri:w.location.uri,lines:[]},v.set(w.location.uri.toString(),A),m.push(A)),A.lines.push({id:w.id,enabled:w.enabled,condition:w.condition,hitCondition:w.hitCondition,logMessage:w.logMessage,line:w.location.range.start.line,character:w.location.range.start.character})}else w instanceof k.FunctionBreakpoint&&m.push({type:"function",id:w.id,enabled:w.enabled,hitCondition:w.hitCondition,logMessage:w.logMessage,condition:w.condition,functionName:w.functionName});return this._debugServiceProxy.$registerBreakpoints(m)}removeBreakpoints(o){this.startBreakpoints();const d=o.filter(A=>this._breakpoints.delete(A.id));this.fireBreakpointChanges([],d,[]);const m=d.filter(A=>A instanceof k.SourceBreakpoint).map(A=>A.id),v=d.filter(A=>A instanceof k.FunctionBreakpoint).map(A=>A.id),w=d.filter(A=>A instanceof k.DataBreakpoint).map(A=>A.id);return this._debugServiceProxy.$unregisterBreakpoints(m,v,w)}startDebugging(o,d,m){return this._debugServiceProxy.$startDebugging(o?o.uri:void 0,d,{parentSessionID:m.parentSession?m.parentSession.id:void 0,lifecycleManagedByParent:m.lifecycleManagedByParent,repl:m.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:m.noDebug,compact:m.compact,debugUI:m.debugUI,suppressSaveBeforeStart:m.suppressSaveBeforeStart})}stopDebugging(o){return this._debugServiceProxy.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,d,m){if(!d)return new k.Disposable(()=>{});const v=this._configProviderHandleCounter++;return this._configProviders.push({type:o,handle:v,provider:d}),this._debugServiceProxy.$registerDebugConfigurationProvider(o,m,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,v),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(w=>w.provider!==d),this._debugServiceProxy.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(o,d,m){if(!m)return new k.Disposable(()=>{});if(!this.definesDebugType(o,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.getAdapterDescriptorFactoryByType(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:d,handle:v,factory:m}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(d,v),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(w=>w.factory!==m),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(o,d){if(!d)return new k.Disposable(()=>{});const m=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:o,handle:m,factory:d}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(v=>v.factory!==d)})}async $runInTerminal(o,d){return Promise.resolve(void 0)}async $substituteVariables(o,d){if(!this._variableResolver){const[w,A]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(w||[],this._editorsService,A)}let m;const v=await this.getFolder(o);return v&&(m={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(m,d)}createDebugAdapter(o,d){if(o.type==="implementation")return new i(o.implementation)}createSignService(){}async $startDASession(o,d){const m=this,v=await this.getSession(d);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(v.type),v).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const A=this.convertToDto(w),M=this.createDebugAdapter(A,v);if(!M)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const T=M;return this._debugAdapters.set(o,T),this.getDebugAdapterTrackers(v).then(O=>(O&&this._debugAdaptersTrackers.set(o,O),T.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const V=U,x={type:"response",seq:0,command:V.command,request_seq:V.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const N=await this._signService.sign(V.arguments.value);x.body={signature:N},T.sendResponse(x)}else throw new Error("no signer")}catch(N){x.success=!1,x.message=N.message,T.sendResponse(x)}}else O&&O.onDidSendMessage&&O.onDidSendMessage(U),U=(0,p.convertToVSCPaths)(U,!0),m._debugServiceProxy.$acceptDAMessage(o,U)}),T.onError(U=>{O&&O.onError&&O.onError(U),this._debugServiceProxy.$acceptDAError(o,U.name,U.message,U.stack)}),T.onExit(U=>{O&&O.onExit&&O.onExit((0,F.withNullAsUndefined)(U),void 0),this._debugServiceProxy.$acceptDAExit(o,(0,F.withNullAsUndefined)(U),void 0)}),O&&O.onWillStartSession&&O.onWillStartSession(),T.startSession()))})}$sendDAMessage(o,d){d=(0,p.convertToDAPaths)(d,!1);const m=this._debugAdaptersTrackers.get(o);m&&m.onWillReceiveMessage&&m.onWillReceiveMessage(d);const v=this._debugAdapters.get(o);v&&v.sendMessage(d)}$stopDASession(o){const d=this._debugAdaptersTrackers.get(o);this._debugAdaptersTrackers.delete(o),d&&d.onWillStopSession&&d.onWillStopSession();const m=this._debugAdapters.get(o);return this._debugAdapters.delete(o),m?m.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const d=[],m=[],v=[];if(o.added)for(const w of o.added){const A=w.id;if(A&&!this._breakpoints.has(A)){let M;if(w.type==="function")M=new k.FunctionBreakpoint(w.functionName,w.enabled,w.condition,w.hitCondition,w.logMessage);else if(w.type==="data")M=new k.DataBreakpoint(w.label,w.dataId,w.canPersist,w.enabled,w.hitCondition,w.condition,w.logMessage);else{const T=t.URI.revive(w.uri);M=new k.SourceBreakpoint(new k.Location(T,new k.Position(w.line,w.character)),w.enabled,w.condition,w.hitCondition,w.logMessage)}M._id=A,this._breakpoints.set(A,M),d.push(M)}}if(o.removed)for(const w of o.removed){const A=this._breakpoints.get(w);A&&(this._breakpoints.delete(w),m.push(A))}if(o.changed){for(const w of o.changed)if(w.id){const A=this._breakpoints.get(w.id);if(A){if(A instanceof k.FunctionBreakpoint&&w.type==="function"){const M=A;M.enabled=w.enabled,M.condition=w.condition,M.hitCondition=w.hitCondition,M.logMessage=w.logMessage,M.functionName=w.functionName}else if(A instanceof k.SourceBreakpoint&&w.type==="source"){const M=A;M.enabled=w.enabled,M.condition=w.condition,M.hitCondition=w.hitCondition,M.logMessage=w.logMessage,M.location=new k.Location(t.URI.revive(w.uri),new k.Position(w.line,w.character))}v.push(A)}}}this.fireBreakpointChanges(d,m,v)}$provideDebugConfigurations(o,d,m){return(0,_.asPromise)(async()=>{const v=this.getConfigProviderByHandle(o);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const w=await this.getFolder(d);return v.provideDebugConfigurations(w,m)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(o,d,m,v){return(0,_.asPromise)(async()=>{const w=this.getConfigProviderByHandle(o);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const A=await this.getFolder(d);return w.resolveDebugConfiguration(A,m,v)})}$resolveDebugConfigurationWithSubstitutedVariables(o,d,m,v){return(0,_.asPromise)(async()=>{const w=this.getConfigProviderByHandle(o);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const A=await this.getFolder(d);return w.resolveDebugConfigurationWithSubstitutedVariables(A,m,v)})}async $provideDebugAdapter(o,d){const m=this.getAdapterDescriptorFactoryByHandle(o);if(!m)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.getSession(d);return this.getAdapterDescriptor(m,v).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.convertToDto(w)})}async $acceptDebugSessionStarted(o){const d=await this.getSession(o);this._onDidStartDebugSession.fire(d)}async $acceptDebugSessionTerminated(o){const d=await this.getSession(o);d&&(this._onDidTerminateDebugSession.fire(d),this._debugSessions.delete(d.id))}async $acceptDebugSessionActiveChanged(o){this._activeDebugSession=o?await this.getSession(o):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(o,d){const m=await this.getSession(o);m&&m._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(o,d){const v={session:await this.getSession(o),event:d.event,body:d.body};this._onDidReceiveDebugSessionCustomEvent.fire(v)}convertToDto(o){if(o instanceof k.DebugAdapterExecutable)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof k.DebugAdapterServer)return{type:"server",port:o.port,host:o.host};if(o instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:o.path};if(o instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(o){const d=this._adapterFactories.filter(m=>m.type===o);if(d.length>0)return d[0].factory}getAdapterDescriptorFactoryByHandle(o){const d=this._adapterFactories.filter(m=>m.handle===o);if(d.length>0)return d[0].factory}getConfigProviderByHandle(o){const d=this._configProviders.filter(m=>m.handle===o);if(d.length>0)return d[0].provider}definesDebugType(o,d){if(o.contributes){const m=o.contributes.debuggers;if(m&&m.length>0){for(const v of m)if(v.label&&v.type&&v.type===d)return!0}}return!1}getDebugAdapterTrackers(o){const m=o.configuration.type,v=this._trackerFactories.filter(w=>w.type===m||w.type==="*").map(w=>(0,_.asPromise)(()=>w.factory.createDebugAdapterTracker(o)).then(A=>A,A=>null));return Promise.race([Promise.all(v).then(w=>{const A=w.filter(M=>!!M);if(A.length>0)return new a(A)}),new Promise((w,A)=>{const M=setTimeout(()=>{clearTimeout(M),A(new Error("timeout"))},1e3)})]).catch(w=>{})}async getAdapterDescriptor(o,d){const m=d.configuration.debugServer;if(typeof m=="number")return Promise.resolve(new k.DebugAdapterServer(m));if(o){const w=await this._extensionService.getExtensionRegistry();return(0,_.asPromise)(()=>o.createDebugAdapterDescriptor(d,this.daExecutableFromPackage(d,w))).then(A=>{if(A)return A})}const v=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(d,v))}daExecutableFromPackage(o,d){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(o,d,m){(o.length>0||d.length>0||m.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:o,removed:d,changed:m}))}async getSession(o){if(o)if(typeof o=="string"){const d=this._debugSessions.get(o);if(d)return d}else{let d=this._debugSessions.get(o.id);if(!d){const m=await this.getFolder(o.folderUri),v=o.parent?this._debugSessions.get(o.parent):void 0;d=new h(this._debugServiceProxy,o.id,o.type,o.name,m,o.configuration,v),this._debugSessions.set(d.id,d),this._debugServiceProxy.$sessionCached(d.id)}return d}throw new Error("cannot find session")}getFolder(o){if(o){const d=t.URI.revive(o);return this._workspaceService.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};s=je([ze(0,g.IExtHostRpcService),ze(1,P.IExtHostWorkspace),ze(2,L.IExtHostExtensionService),ze(3,C.IExtHostDocumentsAndEditors),ze(4,b.IExtHostConfiguration),ze(5,u.IExtHostEditorTabs)],s),e.ExtHostDebugServiceBase=s;class h{constructor(o,d,m,v,w,A,M){this._debugServiceProxy=o,this._id=d,this._type=m,this._name=v,this._workspaceFolder=w,this._configuration=A,this._parentSession=M}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(o){this._name=o,this._debugServiceProxy.$setDebugSessionName(this._id,o)}get parentSession(){return this._parentSession}_acceptNameChanged(o){this._name=o}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(o,d){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,o,d)}getDebugProtocolBreakpoint(o){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,o.id)}}e.ExtHostDebugSession=h;class n{constructor(o){this.value=Object.freeze({append(d){o.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.ExtHostDebugConsole=n;class S extends l.AbstractVariableResolverService{constructor(o,d,m,v,w){function A(){if(d){const M=d.activeEditor();if(M)return M.document.uri;const T=v.tabs.filter(O=>O.isActive);if(T.length>0){const O=T[0].resource;return O&&(O.primary||O.secondary)?O.primary??O.secondary:T[0].resource}}}super({getFolderUri:M=>{const T=o.filter(O=>O.name===M);if(T&&T.length>0)return T[0].uri},getWorkspaceFolderCount:()=>o.length,getConfigurationValue:(M,T)=>m.getConfiguration(void 0,M).get(T),getAppRoot:()=>D.cwd(),getExecPath:()=>D.env.VSCODE_EXEC_PATH,getFilePath:()=>{const M=A();if(M)return f.normalize(M.fsPath)},getWorkspaceFolderPathForFile:()=>{if(w){const M=A();if(M){const T=w.getWorkspaceFolder(M);if(T)return f.normalize(T.uri.fsPath)}}},getSelectedText:()=>{if(d){const M=d.activeEditor();if(M&&!M.selection.isEmpty)return M.document.getText(M.selection)}},getLineNumber:()=>{if(d){const M=d.activeEditor();if(M)return String(M.selection.end.line+1)}}},void 0,Promise.resolve(D.env))}}e.ExtHostVariableResolverService=S;class a{constructor(o){this.trackers=o}onWillStartSession(){this.trackers.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.trackers.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.trackers.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(o):void 0)}onWillStopSession(){this.trackers.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.trackers.forEach(d=>d.onError?d.onError(o):void 0)}onExit(o,d){this.trackers.forEach(m=>m.onExit?m.onExit(o,d):void 0)}}class i extends y.AbstractDebugAdapter{constructor(o){super();this.implementation=o,o.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.implementation.handleMessage(o)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends s{constructor(o,d,m,v,w,A){super(o,d,m,v,w,A)}createVariableResolver(o,d,m){return new S(o,d,m,this._editorTabs)}};r=je([ze(0,g.IExtHostRpcService),ze(1,P.IExtHostWorkspace),ze(2,L.IExtHostExtensionService),ze(3,C.IExtHostDocumentsAndEditors),ze(4,b.IExtHostConfiguration),ze(5,u.IExtHostEditorTabs)],r),e.WorkerExtHostDebugService=r}),define(pe[268],ve([0,1,72,2,5,36,28,27,14,26,4,39,40,11,8]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let g=class{constructor(h,n,S,a,i,r,c){this._apiFactory=h,this._extensionRegistry=n,this._instaService=S,this._extHostConfiguration=a,this._extHostExtensionService=i,this._initData=r,this._logService=c,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),f.mark("code/extHost/willWaitForConfig");const h=await this._extHostConfiguration.getConfigProvider();f.mark("code/extHost/didWaitForConfig");const n=await this._extHostExtensionService.getExtensionPathIndex();this.register(new F(this._apiFactory,n,this._extensionRegistry,h,this._logService)),this.register(this._instaService.createInstance(D,n)),this.register(this._instaService.createInstance(E)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(u,n,this._initData.environment.appUriScheme))}register(h){if("nodeModuleName"in h)if(Array.isArray(h.nodeModuleName))for(let n of h.nodeModuleName)this._factories.set(n,h);else this._factories.set(h.nodeModuleName,h);typeof h.alternativeModuleName=="function"&&this._alternatives.push(n=>h.alternativeModuleName(n))}};g=je([ze(2,L.IInstantiationService),ze(3,_.IExtHostConfiguration),ze(4,C.IExtHostExtensionService),ze(5,P.IExtHostInitDataService),ze(6,b.ILogService)],g),e.RequireInterceptor=g;let E=class zi{constructor(h){if(h.environment.appRoot&&zi.aliased.size){const n=(0,p.escapeRegExpCharacters)(this.forceForwardSlashes(h.environment.appRoot.fsPath)),S="[a-z0-9_.-]",a=`@${S}+\\/${S}+|${S}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${n}/${i}\\/)(${a})(.*)$`,"i")}}alternativeModuleName(h){if(!this.re)return;const n=this.re.exec(this.forceForwardSlashes(h));if(!n)return;const[,S,a,i]=n,r=zi.aliased.get(a);if(r!==void 0)return console.warn(`${a} as been renamed to ${r}, please update your imports`),S+r+i}forceForwardSlashes(h){return h.replace(/\\/g,"/")}};E.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"]]),E=je([ze(0,P.IExtHostInitDataService)],E);class F{constructor(h,n,S,a,i){this._apiFactory=h,this._extensionPaths=n,this._extensionRegistry=S,this._configProvider=a,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(h,n){const S=this._extensionPaths.findSubstr(n);if(S){let a=this._extApiImpl.get(k.ExtensionIdentifier.toKey(S.identifier));return a||(a=this._apiFactory(S,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(S.identifier),a)),a}if(!this._defaultApiImpl){let a="";this._extensionPaths.forEach((i,r)=>a+=`	${r} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${n}. These are the extension path mappings: 
${a}`),this._defaultApiImpl=this._apiFactory(R.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let D=class{constructor(h,n,S){this._extensionPaths=h,this.nodeModuleName="keytar",this._mainThreadTelemetry=n.getProxy(I.MainContext.MainThreadTelemetry);const{environment:a}=S,i=n.getProxy(I.MainContext.MainThreadKeytar);if(a.appRoot){let r=a.appRoot.fsPath;l.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,c)=>i.$getPassword(r,c),setPassword:(r,c,o)=>i.$setPassword(r,c,o),deletePassword:(r,c)=>i.$deletePassword(r,c),findPassword:r=>i.$findPassword(r),findCredentials(r){return i.$findCredentials(r)}}}load(h,n){const S=this._extensionPaths.findSubstr(n);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:S?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(h){const n=h.length;if(n<=7||!this.alternativeNames)return;const S=n-7;if((h.charAt(S)==="/"||h.charAt(S)==="\\")&&h.endsWith("keytar")&&(h=h.replace(/\\/g,"/"),this.alternativeNames.has(h)))return"keytar"}};D=je([ze(1,y.IExtHostRpcService),ze(2,P.IExtHostInitDataService)],D);let u=class{constructor(h,n,S){this._extensionPaths=h,this._appUriScheme=n,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=S.getProxy(I.MainContext.MainThreadTelemetry);const a=S.getProxy(I.MainContext.MainThreadWindow);this._impl=(i,r)=>{const c=t.URI.parse(i);return r?this.callOriginal(i,r):c.scheme==="http"||c.scheme==="https"?a.$openUri(c,i,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this._appUriScheme?a.$openUri(c,i,{}):this.callOriginal(i,r)}}load(h,n,S){const a=this._extensionPaths.findSubstr(n);return a&&(this._extensionId=a.identifier.value,this.sendShimmingTelemetry()),this._original=S(h),this._impl}callOriginal(h,n){return this.sendNoForwardTelemetry(),this._original(h,n)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};u=je([ze(2,y.IExtHostRpcService)],u)}),define(pe[269],ve([0,1,171,12,7,209,35,39,45,36,34,14,54,195,13,210,53]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let F=class extends l.ExtHostDebugServiceBase{constructor(s,h,n,S,a,i,r){super(s,h,n,S,a,r);this._terminalService=i,this._integratedTerminalInstances=new D}createDebugAdapter(s,h){switch(s.type){case"server":return new _.SocketDebugAdapter(s);case"pipeServer":return new _.NamedPipeDebugAdapter(s);case"executable":return new _.ExecutableDebugAdapter(s,h.type)}return super.createDebugAdapter(s,h)}daExecutableFromPackage(s,h){const n=_.ExecutableDebugAdapter.platformAdapterExecutable(h.getAllExtensionDescriptions(),s.type);if(n)return new I.DebugAdapterExecutable(n.command,n.args,n.options)}createSignService(){return new b.SignService}async $runInTerminal(s,h){if(s.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(A=>{this._integratedTerminalInstances.onTerminalClosed(A)}));const n=await this._configurationService.getConfigProvider(),S=this._terminalService.getDefaultShell(!0),a=this._terminalService.getDefaultShellArgs(!0),i=s.title||f.localize(0,null),r=JSON.stringify({shell:S,shellArgs:a});let c=await this._integratedTerminalInstances.checkout(r,i),o,d=!1;if(c)o=s.cwd;else{const A={shellPath:S,shellArgs:a,cwd:s.cwd,name:i,iconPath:new I.ThemeIcon("debug")};d=!0,c=this._terminalService.createTerminalFromOptions(A,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(c,r)}c.show(!0);const m=await c.processId;d?await new Promise(A=>setTimeout(A,1e3)):n.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0||S.indexOf("cmd.exe")>=0?c.sendText("cls"):S.indexOf("bash")>=0?c.sendText("clear"):t.isWindows?c.sendText("cls"):c.sendText("clear"));const v=(0,g.prepareCommand)(S,s.args,o,s.env);c.sendText(v);const w=this.onDidTerminateDebugSession(A=>{A.id===h&&(this._integratedTerminalInstances.free(c),w.dispose())});return m}else if(s.kind==="external")return(0,g.runInExternalTerminal)(s,await this._configurationService.getConfigProvider());return super.$runInTerminal(s,h)}createVariableResolver(s,h,n){return new l.ExtHostVariableResolverService(s,h,n,this._editorTabs,this._workspaceService)}};F=je([ze(0,C.IExtHostRpcService),ze(1,R.IExtHostWorkspace),ze(2,k.IExtHostExtensionService),ze(3,y.IExtHostDocumentsAndEditors),ze(4,P.IExtHostConfiguration),ze(5,L.IExtHostTerminalService),ze(6,E.IExtHostEditorTabs)],F),e.ExtHostDebugService=F;class D{constructor(){this._terminalInstances=new Map}async checkout(s,h){const S=[...this._terminalInstances.entries()].map(([a,i])=>(0,p.createCancelablePromise)(async r=>{if(a.name!==h||i.lastUsedAt!==-1&&await(0,g.hasChildProcesses)(await a.processId))return null;const c=Date.now();return i.lastUsedAt+D.minUseDelay>c||r.isCancellationRequested||i.config!==s?null:(i.lastUsedAt=c,a)}));return await(0,p.firstParallel)(S,a=>!!a)}insert(s,h){this._terminalInstances.set(s,{lastUsedAt:Date.now(),config:h})}free(s){const h=this._terminalInstances.get(s);h&&(h.lastUsedAt=-1)}onTerminalClosed(s){this._terminalInstances.delete(s)}}D.minUseDelay=1e3}),define(pe[270],ve([0,1,9,2,113,35,54,45,36,43,34,14,26,71,10,11,66,53,23,81]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p,g,E,F,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let s=class extends b.ExtHostTaskBase{constructor(n,S,a,i,r,c,o,d,m){super(n,S,a,i,r,c,o,d);this.workspaceService=a,this.editorTabs=m,S.remote.isRemote&&S.remote.authority?this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:S.remote.authority,platform:process.platform}):this.registerTaskSystem(p.Schemas.file,{scheme:p.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(n,S){const a=S;if(!S.execution&&a._id===void 0)throw new Error("Tasks to execute must include an execution");if(a._id!==void 0){const i=b.TaskHandleDTO.from(a,this.workspaceService),r=await this._proxy.$getTaskExecution(i);if(r.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.getTaskExecution(r,S);return this._proxy.$executeTask(i).catch(()=>{}),c}else{const i=b.TaskDTO.from(S,n);if(i===void 0)return Promise.reject(new Error("Task is not valid"));b.CustomExecutionDTO.is(i.execution)&&await this.addCustomExecution(i,S,!1);const r=await this.getTaskExecution(await this._proxy.$getTaskExecution(i),S);return this._proxy.$executeTask(i).catch(()=>{}),r}}provideTasksInternal(n,S,a,i){const r=[];if(i)for(let c of i){this.checkDeprecation(c,a),(!c.definition||!n[c.definition.type])&&this._logService.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const o=b.TaskDTO.from(c,a.extension);o&&(r.push(o),b.CustomExecutionDTO.is(o.execution)&&S.push(this.addCustomExecution(o,c,!0)))}return{tasks:r,extension:a.extension}}async resolveTaskInternal(n){return n}async getVariableResolver(n){if(this._variableResolver===void 0){const S=await this._configurationService.getConfigProvider();this._variableResolver=new R.ExtHostVariableResolverService(n,this._editorService,S,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(n){let S=n&&n.length>0?n[0]:void 0;if(!S){const a=t.URI.file((0,u.homedir)());S=new P.WorkspaceFolder({uri:a,name:D.basename(a),index:0})}return{uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(n,S){const a=t.URI.revive(n),i={process:void 0,variables:Object.create(null)},r=await this._workspaceProvider.resolveWorkspaceFolder(a),c=await this._workspaceProvider.getWorkspaceFolders2()??[],o=await this.getVariableResolver(c),d=r?{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(c);for(let m of S.variables)i.variables[m]=await o.resolveAsync(d,m);if(S.process!==void 0){let m;if(S.process.path!==void 0){m=S.process.path.split(f.delimiter);for(let v=0;v<m.length;v++)m[v]=await o.resolveAsync(d,m[v])}i.process=await I.win32.findExecutable(await o.resolveAsync(d,S.process.name),S.process.cwd!==void 0?await o.resolveAsync(d,S.process.cwd):void 0,m)}return i}async $jsonTasksSupported(){return!0}async $findExecutable(n,S,a){return I.win32.findExecutable(n,S,a)}};s=je([ze(0,C.IExtHostRpcService),ze(1,l.IExtHostInitDataService),ze(2,_.IExtHostWorkspace),ze(3,k.IExtHostDocumentsAndEditors),ze(4,y.IExtHostConfiguration),ze(5,L.IExtHostTerminalService),ze(6,g.ILogService),ze(7,E.IExtHostApiDeprecationService),ze(8,F.IExtHostEditorTabs)],s),e.ExtHostTask=s}),define(pe[271],ve([0,1,13,16,72,6,2,5,263,11,61,84,26,187,14,65,39,34]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p,g,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class D{constructor(s,h,n,S,a){this._disposables=new _.DisposableStore,this._isTerminating=!1,this._hostUtils=n,this._rpcProtocol=new y.RPCProtocol(s,null,S),h=D._transform(h,this._rpcProtocol);const i=new C.ServiceCollection(...(0,L.getSingletonServiceDescriptors)());i.set(l.IExtHostInitDataService,{_serviceBrand:void 0,...h,messagePorts:a}),i.set(p.IExtHostRpcService,new p.ExtHostRpcService(this._rpcProtocol)),i.set(g.IURITransformerService,new g.URITransformerService(S)),i.set(E.IHostUtils,n);const r=new b.InstantiationService(i,!0);this._disposables.add(r.invokeFunction(m=>m.get(F.IExtHostTerminalService))),this._disposables.add(r.invokeFunction(m=>m.get(E.IExtHostExtensionService))),this._logService=r.invokeFunction(m=>m.get(P.ILogService)),I.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",h),this._extensionService=r.invokeFunction(m=>m.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const c=new WeakMap;this._extensionService.getExtensionPathIndex().then(m=>{Error.prepareStackTrace=(v,w)=>{let A="",M,T;for(const O of w)A+=`
	at ${O.toString()}`,T=O.getFileName(),!M&&T&&(M=m.findSubstr(R.URI.file(T)));return c.set(v,M),`${v.name||"Error"}: ${v.message||""}${A}`}});const o=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),d=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);t.setUnexpectedErrorHandler(m=>{const v=t.transformErrorForSerialization(m),w=c.get(m);w?o.$onExtensionRuntimeError(w.identifier,v):d.$onUnexpectedError(v)})}terminate(s){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${s}`),this._logService.flush(),this._disposables.dispose(),t.setUnexpectedErrorHandler(n=>{this._logService.error(n)}),this._rpcProtocol.dispose();const h=this._extensionService.deactivateAll();Promise.race([(0,f.timeout)(5e3),h]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(s,h){s.extensions.forEach(S=>S.extensionLocation=R.URI.revive(h.transformIncomingURIs(S.extensionLocation))),s.environment.appRoot=R.URI.revive(h.transformIncomingURIs(s.environment.appRoot));const n=s.environment.extensionDevelopmentLocationURI;return n&&(s.environment.extensionDevelopmentLocationURI=n.map(S=>R.URI.revive(h.transformIncomingURIs(S)))),s.environment.extensionTestsLocationURI=R.URI.revive(h.transformIncomingURIs(s.environment.extensionTestsLocationURI)),s.environment.globalStorageHome=R.URI.revive(h.transformIncomingURIs(s.environment.globalStorageHome)),s.environment.workspaceStorageHome=R.URI.revive(h.transformIncomingURIs(s.environment.workspaceStorageHome)),s.logsLocation=R.URI.revive(h.transformIncomingURIs(s.logsLocation)),s.logFile=R.URI.revive(h.transformIncomingURIs(s.logFile)),s.workspace=h.transformIncomingURIs(s.workspace),s}}e.ExtensionHostMain=D}),define(pe[272],ve([0,1,9,21,49,32,23,46,31]),function(Z,e,f,t,I,_,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(l,b,p){this.config=l,this.provider=b,this.sessionToken=p,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&_.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&_.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const b=this.config.folderQueries||[];return new Promise((p,g)=>{const E=F=>{this.resultCount++,l(F)};if(this.isCanceled)return p({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(F=>{const D=F.toString(),u=f.basename(D);this.globalExcludePattern&&this.globalExcludePattern(D,u)||this.matchFile(E,{base:F,basename:u})}),Promise.all(b.map(F=>this.searchInFolder(F,E))).then(F=>{p({limitHit:this.isLimitHit,stats:F[0]||void 0})},F=>{g(new Error((0,I.toErrorMessage)(F)))})})}async searchInFolder(l,b){const p=new t.CancellationTokenSource,g=this.getSearchOptionsForFolder(l),E=this.initDirectoryTree(),F=new y.QueryGlobTester(this.config,l),D=!F.hasSiblingExcludeClauses();let u;try{this.activeCancellationTokens.add(p),u=k.StopWatch.create();const s=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},g,p.token),h=u.elapsed(),n=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(s&&s.forEach(S=>{const a=f.posix.relative(l.folder.path,S.path);if(D){const i=f.basename(S.path);this.matchFile(b,{base:l.folder,relativePath:a,basename:i});return}this.addDirectoryEntries(E,l.folder,a,b)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(E,F,b),{providerTime:h,postProcessTime:n.elapsed()})}finally{p.dispose(),this.activeCancellationTokens.delete(p)}}getSearchOptionsForFolder(l){const b=(0,y.resolvePatternsForProvider)(this.config.includePattern,l.includePattern),p=(0,y.resolvePatternsForProvider)(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:p,includes:b,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},b,p,g){if(p===this.filePattern){const F=f.basename(this.filePattern);this.matchFile(g,{base:b,relativePath:this.filePattern,basename:F})}function E(F){const D=f.basename(F),u=f.dirname(F);let s=l[u];s||(s=l[u]=[],E(u)),s.push({base:b,relativePath:F,basename:D})}E(p)}matchDirectoryTree({rootEntries:l,pathToEntries:b},p,g){const E=this,F=this.filePattern;function D(u){const s=_.hasSiblingFn(()=>u.map(h=>h.basename));for(let h=0,n=u.length;h<n;h++){const S=u[h],{relativePath:a,basename:i}=S;if(p.matchesExcludesSync(a,i,F!==i?s:void 0))continue;const r=b[a];if(r)D(r);else{if(a===F)continue;E.matchFile(g,S)}if(E.isLimitHit)break}}D(l)}matchFile(l,b){(!this.includePattern||b.relativePath&&this.includePattern(b.relativePath,b.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(b))}}class L{constructor(){this.sessions=new Map}fileSearch(l,b,p,g){const E=this.getSessionTokenSource(l.cacheKey),F=new P(l,b,E&&E.token);let D=0;const u=s=>{D+=s.length,p(s.map(h=>this.rawMatchToSearchItem(h)))};return this.doSearch(F,L.BATCH_SIZE,u,g).then(s=>({limitHit:s.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:D,detailStats:s.stats}}))}clearCache(l){const b=this.getSessionTokenSource(l);b&&b.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new t.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:R.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,b,p,g){g.onCancellationRequested(()=>{l.cancel()});const E=D=>{D&&(F.push(D),b>0&&F.length>=b&&(p(F),F=[]))};let F=[];return l.search(E).then(D=>(F.length&&p(F),D),D=>(F.length&&p(F),Promise.reject(D)))}}e.FileSearchManager=L,L.BATCH_SIZE=512}),define(pe[136],ve([0,1,17,13,21,49,32,10,9,23,18,2,31]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class b{constructor(s,h,n,S){this.query=s,this.provider=h,this.fileUtils=n,this.processType=S,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(s,h){const n=this.query.folderQueries||[],S=new I.CancellationTokenSource;return h.onCancellationRequested(()=>S.cancel()),new Promise((a,i)=>{this.collector=new g(s);let r=!1;const c=(o,d)=>{if(!r&&!this.isLimitHit){const m=this.resultSize(o);F(o)&&typeof this.query.maxResults=="number"&&this.resultCount+m>this.query.maxResults&&(this.isLimitHit=!0,r=!0,S.cancel(),o=this.trimResultToSize(o,this.query.maxResults-this.resultCount));const v=this.resultSize(o);this.resultCount+=v,(v>0||!F(o))&&this.collector.add(o,d)}};Promise.all(n.map((o,d)=>this.searchInFolder(o,m=>c(m,d),S.token))).then(o=>{S.dispose(),this.collector.flush();const d=o.some(m=>!!m&&!!m.limitHit);a({limitHit:this.isLimitHit||d,messages:(0,f.flatten)(o.map(m=>m?.message?(0,L.isArray)(m.message)?m.message:[m.message]:[])),stats:{type:this.processType}})},o=>{S.dispose();const d=(0,_.toErrorMessage)(o);i(new Error(d))})})}resultSize(s){return F(s)?Array.isArray(s.ranges)?s.ranges.length:1:0}trimResultToSize(s,h){const n=Array.isArray(s.ranges)?s.ranges:[s.ranges],S=Array.isArray(s.preview.matches)?s.preview.matches:[s.preview.matches];return{ranges:n.slice(0,h),preview:{matches:S.slice(0,h),text:s.preview.text},uri:s.uri}}async searchInFolder(s,h,n){const S=new l.QueryGlobTester(this.query,s),a=[],i={report:o=>{if(!this.validateProviderResult(o))return;const d=s.folder.scheme===k.Schemas.file?R.hasSiblingPromiseFn(()=>this.fileUtils.readdir(P.dirname(o.uri))):void 0,m=P.relativePath(s.folder,o.uri);if(m){const v=S.includedInQuery(m,y.basename(m),d);(0,t.isThenable)(v)?a.push(v.then(w=>{w&&h(o)})):v&&h(o)}}},r=this.getSearchOptionsForFolder(s),c=await this.provider.provideTextSearchResults(p(this.query.contentPattern),r,i,n);return a.length&&await Promise.all(a),c}validateProviderResult(s){if(F(s)){if(Array.isArray(s.ranges)){if(!Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(s.preview.matches.length!==s.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(s){const h=(0,l.resolvePatternsForProvider)(this.query.includePattern,s.includePattern),n=(0,l.resolvePatternsForProvider)(this.query.excludePattern,s.excludePattern),S={folder:C.URI.from(s.folder),excludes:n,includes:h,useIgnoreFiles:!s.disregardIgnoreFiles,useGlobalIgnoreFiles:!s.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!s.disregardParentIgnoreFiles,followSymlinks:!s.ignoreSymlinks,encoding:s.fileEncoding&&this.fileUtils.toCanonicalName(s.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return S.usePCRE2=this.query.usePCRE2,S}}e.TextSearchManager=b;function p(u){return{isCaseSensitive:u.isCaseSensitive||!1,isRegExp:u.isRegExp||!1,isWordMatch:u.isWordMatch||!1,isMultiline:u.isMultiline||!1,pattern:u.pattern}}class g{constructor(s){this._onResult=s,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new D(512,h=>this.sendItems(h))}add(s,h){this._currentFileMatch&&(this._currentFolderIdx!==h||!P.isEqual(this._currentUri,s.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=h,this._currentFileMatch={resource:s.uri,results:[]}),this._currentFileMatch.results.push(E(s))}pushToCollector(){const s=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,s)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(s){this._onResult(s)}}e.TextSearchResultsCollector=g;function E(u){return F(u)?{preview:{matches:(0,f.mapArrayOrNot)(u.preview.matches,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character})),text:u.preview.text},ranges:(0,f.mapArrayOrNot)(u.ranges,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character}))}:{text:u.text,lineNumber:u.lineNumber}}function F(u){return!!u.preview}e.extensionResultIsMatch=F;class D{constructor(s,h){this.maxBatchSize=s,this.cb=h,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(s,h){!s||this.addItemToBatch(s,h)}addItems(s,h){!s||this.addItemsToBatch(s,h)}addItemToBatch(s,h){this.batch.push(s),this.batchSize+=h,this.onUpdate()}addItemsToBatch(s,h){this.batch=this.batch.concat(s),this.batchSize+=h,this.onUpdate()}onUpdate(){this.totalNumberCompleted<D.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},D.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=D,D.TIMEOUT=4e3,D.START_BATCH_AFTER_COUNT=50}),define(pe[73],ve([0,1,6,5,4,272,14,65,11,2,136]),function(Z,e,f,t,I,_,R,k,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let C=class{constructor(g,E,F){this.extHostRpc=g,this._uriTransformer=E,this._logService=F,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new _.FileSearchManager}_transformScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}registerTextSearchProvider(g,E){if(this._textSearchUsedSchemes.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this._textSearchUsedSchemes.add(g);const F=this._handlePool++;return this._textSearchProvider.set(F,E),this._proxy.$registerTextSearchProvider(F,this._transformScheme(g)),(0,f.toDisposable)(()=>{this._textSearchUsedSchemes.delete(g),this._textSearchProvider.delete(F),this._proxy.$unregisterProvider(F)})}registerFileSearchProvider(g,E){if(this._fileSearchUsedSchemes.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this._fileSearchUsedSchemes.add(g);const F=this._handlePool++;return this._fileSearchProvider.set(F,E),this._proxy.$registerFileSearchProvider(F,this._transformScheme(g)),(0,f.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(g),this._fileSearchProvider.delete(F),this._proxy.$unregisterProvider(F)})}$provideFileSearchResults(g,E,F,D){const u=l(F),s=this._fileSearchProvider.get(g);if(s)return this._fileSearchManager.fileSearch(u,s,h=>{this._proxy.$handleFileMatch(g,E,h.map(n=>n.resource))},D);throw new Error("unknown provider: "+g)}$clearCache(g){return this._fileSearchManager.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,E,F,D){const u=this._textSearchProvider.get(g);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const s=l(F);return this.createTextSearchManager(s,u).search(n=>this._proxy.$handleTextMatch(g,E,n),D)}$enableExtensionHostSearch(){}createTextSearchManager(g,E){return new L.TextSearchManager(g,E,{readdir:F=>Promise.resolve([]),toCanonicalName:F=>F},"textSearchProvider")}};C=je([ze(0,R.IExtHostRpcService),ze(1,k.IURITransformerService),ze(2,y.ILogService)],C),e.ExtHostSearch=C;function l(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(b),extraFileResources:p.extraFileResources&&p.extraFileResources.map(g=>P.URI.revive(g))}}e.reviveQuery=l;function b(p){return{...p,folder:P.URI.revive(p.folder)}}}),define(pe[273],ve([0,1,61,134,35,132,36,38,45,34,71,54,73,90,51,66,135,67,44,89,123,53,133,11,225]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p,g,E,F,D,u,s,h,n,S,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.registerSingleton)(S.ILoggerService,n.ExtHostLoggerService),(0,f.registerSingleton)(S.ILogService,a.ExtHostLogService),(0,f.registerSingleton)(g.IExtHostApiDeprecationService,g.ExtHostApiDeprecationService),(0,f.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,f.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration),(0,f.registerSingleton)(F.IExtHostConsumerFileSystem,F.ExtHostConsumerFileSystem),(0,f.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,f.registerSingleton)(_.IExtHostDecorations,_.ExtHostDecorations),(0,f.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,f.registerSingleton)(D.IExtHostFileSystemInfo,D.ExtHostFileSystemInfo),(0,f.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService),(0,f.registerSingleton)(l.IExtHostSearch,l.ExtHostSearch),(0,f.registerSingleton)(b.IExtHostStorage,b.ExtHostStorage),(0,f.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask),(0,f.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,f.registerSingleton)(p.IExtHostTunnelService,p.ExtHostTunnelService),(0,f.registerSingleton)(E.IExtHostWindow,E.ExtHostWindow),(0,f.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace),(0,f.registerSingleton)(u.IExtHostSecretState,u.ExtHostSecretState),(0,f.registerSingleton)(s.IExtHostTelemetry,s.ExtHostTelemetry),(0,f.registerSingleton)(h.IExtHostEditorTabs,h.ExtHostEditorTabs)}),define(pe[91],ve([0,1,17,11,31,70]),function(Z,e,f,t,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function R(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.anchorGlob=R;function k(C,l,b,p){const g=(0,f.mapArrayOrNot)(b,y),E=new I.TextSearchMatch(l,g,p),F=E.preview.matches;return{ranges:(0,f.mapArrayOrNot)(g,P),uri:C,preview:{text:E.preview.text,matches:(0,f.mapArrayOrNot)(F,P)}}}e.createTextSearchResult=k;function y(C){return new I.SearchRange(C.start.line,C.start.character,C.end.line,C.end.character)}function P(C){return new _.Range(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let L=class{constructor(l,b){this.prefix=l,this.logService=b}appendLine(l){this.logService.debug(`${this.prefix}#search`,l)}};L=je([ze(1,t.ILogService)],L),e.OutputChannel=L}),define(pe[274],ve([0,1,37,9,79,29,12,8,91,275]),function(Z,e,f,t,I,_,R,k,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const L=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(u,s,h,n){const S=l(u,s,h,n),a=s.folder.fsPath;return{cmd:f.spawn(L,S.args,{cwd:a}),rgDiskPath:L,siblingClauses:S.siblingClauses,rgArgs:S,cwd:a}}e.spawnRipgrepCmd=C;function l(u,s,h,n){const S=["--files","--hidden","--case-sensitive"];p([s],h,!1).forEach(i=>{const r=(0,y.anchorGlob)(i);if(S.push("-g",r),R.isMacintosh){const c=(0,I.normalizeNFD)(r);c!==r&&S.push("-g",c)}});const a=b([s],n,void 0,!1);return a.globArgs.forEach(i=>{const r=`!${(0,y.anchorGlob)(i)}`;if(S.push("-g",r),R.isMacintosh){const c=(0,I.normalizeNFD)(r);c!==r&&S.push("-g",c)}}),s.disregardIgnoreFiles!==!1?S.push("--no-ignore"):s.disregardParentIgnoreFiles!==!1&&S.push("--no-ignore-parent"),s.ignoreSymlinks||S.push("--follow"),u.exists&&S.push("--quiet"),S.push("--no-config"),s.disregardGlobalIgnoreFiles&&S.push("--no-ignore-global"),{args:S,siblingClauses:a.siblingClauses}}function b(u,s,h,n=!0){const S=[];let a={};return u.forEach(i=>{const r=Object.assign({},i.excludePattern||{},s||{}),c=g(r,n?i.folder.fsPath:void 0,h);S.push(...c.globArgs),c.siblingClauses&&(a=Object.assign(a,c.siblingClauses))}),{globArgs:S,siblingClauses:a}}e.foldersToRgExcludeGlobs=b;function p(u,s,h=!0){const n=[];return u.forEach(S=>{const a=Object.assign({},s||{},S.includePattern||{}),i=g(a,h?S.folder.fsPath:void 0);n.push(...i.globArgs)}),n}e.foldersToIncludeGlobs=p;function g(u,s,h){const n=[],S={};return Object.keys(u).forEach(a=>{if(h&&h.has(a)||!a)return;const i=u[a];a=F(s?E(s,a):a),a.startsWith("\\\\")?a="\\\\"+a.substr(2).replace(/\\/g,"/"):a=a.replace(/\\/g,"/"),typeof i=="boolean"&&i?(a.startsWith("\\\\")&&(a+="**"),n.push(D(a))):i&&i.when&&(S[a]=i)}),{globArgs:n,siblingClauses:S}}function E(u,s){return t.isAbsolute(s)?s:t.join(u,s)}e.getAbsoluteGlob=E;function F(u){return u=k.rtrim(u,"\\"),k.rtrim(u,"/")}function D(u){return _.getRoot(u).toLowerCase()==="c:/"?u.replace(/^c:[/\\]/i,"/"):u}e.fixDriveC=D}),define(pe[276],ve([0,1,37,60,9,104,17,49,32,79,29,12,46,8,18,30,31,274,102]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p,g,E,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const u=new Set;process.on("exit",()=>{u.forEach(a=>a())});class s{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&y.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,D.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&y.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(r=>{const c=Object.assign({},r.excludePattern||{},this.config.excludePattern||{}),o=r.folder.fsPath;i.folderQueries.map(d=>d.folder.fsPath).filter(d=>d!==o).forEach(d=>{(0,L.isEqualOrParent)(d,o)&&(c[I.relative(o,d)]=!0)}),this.folderExcludePatterns.set(o,new n(c,o))})}cancel(){this.isCanceled=!0,u.forEach(i=>i())}walk(i,r,c,o,d){if(this.fileWalkSW=l.StopWatch.create(!1),this.isCanceled)return d(null,this.isLimitHit);r.forEach(m=>{const v=I.basename(m.fsPath);this.globalExcludePattern&&this.globalExcludePattern(m.fsPath,v)||this.matchFile(c,{relativePath:m.fsPath,searchPath:void 0})}),this.cmdSW=l.StopWatch.create(!1),this.parallel(i,(m,v)=>{this.call(this.cmdTraversal,this,m,c,o,w=>{if(w){const A=(0,k.toErrorMessage)(w);console.error(A),this.errors.push(A),v(w,void 0)}else v(null,void 0)})},(m,v)=>{this.fileWalkSW.stop();const w=m?R.coalesce(m)[0]:null;d(w,this.isLimitHit)})}parallel(i,r,c){const o=new Array(i.length),d=new Array(i.length);let m=!1,v=0;if(i.length===0)return c(null,[]);i.forEach((w,A)=>{r(w,(M,T)=>{if(M?(m=!0,o[A]=null,d[A]=M):(o[A]=T,d[A]=null),++v===i.length)return c(m?d:null,o)})})}call(i,r,...c){try{i.apply(r,c)}catch(o){c[c.length-1](o)}}cmdTraversal(i,r,c,o){const d=i.folder.fsPath,m=C.isMacintosh;let v;const w=()=>v&&v.kill();u.add(w);let A=N=>{u.delete(w),A=()=>{},o(N)},M="";const T=this.initDirectoryTree();let O;const U=(0,F.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);v=U.cmd,O=!Object.keys(U.siblingClauses).length;const V=U.rgArgs.args.map(N=>N.match(/^-/)?N:`'${N}'`).join(" ");let x=`${U.rgDiskPath} ${V}
 - cwd: ${U.cwd}`;U.rgArgs.siblingClauses&&(x+=`
 - Sibling clauses: ${JSON.stringify(U.rgArgs.siblingClauses)}`),c({message:x}),this.cmdResultCount=0,this.collectStdout(v,"utf8",c,(N,B,W)=>{if(N){A(N);return}if(this.isLimitHit){A();return}const z=(M+(m?P.normalizeNFC(B||""):B)).split(`
`);if(W){const J=z.length;z[J-1]=z[J-1].trim(),z[J-1]||z.pop()}else M=z.pop()||"";if(z.length&&z[0].indexOf(`
`)!==-1){A(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=z.length,O){for(const J of z)if(this.matchFile(r,{base:d,relativePath:J,searchPath:this.getSearchPath(i,J)}),this.isLimitHit){w();break}(W||this.isLimitHit)&&A();return}this.addDirectoryEntries(i,T,d,z,r),W&&(this.matchDirectoryTree(T,d,r),A())})}spawnFindCmd(i){const r=this.folderExcludePatterns.get(i.folder.fsPath),c=r.getBasenameTerms(),o=r.getPathTerms(),d=["-L","."];if(c.length||o.length){d.push("-not","(","(");for(const m of c)d.push("-name",m),d.push("-o");for(const m of o)d.push("-path",m),d.push("-o");d.pop(),d.push(")","-prune",")")}return d.push("-type","f"),f.spawn("find",d,{cwd:i.folder.fsPath})}readStdout(i,r,c){let o="";this.collectStdout(i,r,()=>{},(d,m,v)=>{if(d){c(d);return}o+=m,v&&c(null,o)})}collectStdout(i,r,c,o){let d=(w,A,M)=>{(w||M)&&(d=()=>{},this.cmdSW&&this.cmdSW.stop()),o(w,A,M)},m=!1;i.stdout?(this.forwardData(i.stdout,r,d),i.stdout.once("data",()=>m=!0)):c({message:"stdout is null"});let v;i.stderr?v=this.collectData(i.stderr):c({message:"stderr is null"}),i.on("error",w=>{d(w)}),i.on("close",w=>{let A;!m&&(A=this.decodeData(v,r))&&S(A)?d(new Error(`command failed with error code ${w}: ${this.decodeData(v,r)}`)):(this.exists&&w===0&&(this.isLimitHit=!0),d(null,"",!0))})}forwardData(i,r,c){const o=new _.StringDecoder(r);return i.on("data",d=>{c(null,o.write(d))}),o}collectData(i){const r=[];return i.on("data",c=>{r.push(c)}),r}decodeData(i,r){const c=new _.StringDecoder(r);return i.map(o=>c.write(o)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:r},c,o,d){o.indexOf(this.filePattern)!==-1&&this.matchFile(d,{base:c,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const m=v=>{const w=I.basename(v),A=I.dirname(v);let M=r[A];M||(M=r[A]=[],m(A)),M.push({base:c,relativePath:v,basename:w,searchPath:this.getSearchPath(i,v)})};o.forEach(m)}matchDirectoryTree({rootEntries:i,pathToEntries:r},c,o){const d=this,m=this.folderExcludePatterns.get(c),v=this.filePattern;function w(A){d.directoriesWalked++;const M=y.hasSiblingFn(()=>A.map(T=>T.basename));for(let T=0,O=A.length;T<O;T++){const U=A[T],{relativePath:V,basename:x}=U;if(m.test(V,x,v!==x?M:void 0))continue;const N=r[V];if(N)w(N);else{if(d.filesWalked++,V===v)continue;d.matchFile(o,U)}if(d.isLimitHit)break}}w(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,r,c,o,d){const m=i.folder,v=y.hasSiblingFn(()=>c);this.parallel(c,(w,A)=>{if(this.isCanceled||this.isLimitHit)return A(null);const M=r?[r,w].join(I.sep):w;if(this.folderExcludePatterns.get(i.folder.fsPath).test(M,w,this.config.filePattern!==w?v:void 0))return A(null);const T=[m.fsPath,M].join(I.sep);t.lstat(T,(O,U)=>{if(O||this.isCanceled||this.isLimitHit)return A(null);this.statLinkIfNeeded(T,U,(V,x)=>V||this.isCanceled||this.isLimitHit?A(null):x.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(T,U,(N,B)=>N||this.isCanceled||this.isLimitHit||(B=B||"",this.walkedPaths[B])?A(null):(this.walkedPaths[B]=!0,g.Promises.readdir(T).then(W=>{if(this.isCanceled||this.isLimitHit)return A(null);this.doWalk(i,M,W,o,H=>A(H||null))},W=>{A(null)})))):(this.filesWalked++,M===this.filePattern||this.maxFilesize&&p.isNumber(x.size)&&x.size>this.maxFilesize||this.matchFile(o,{base:m.fsPath,relativePath:M,searchPath:this.getSearchPath(i,M)}),A(null,void 0)))})},w=>{const A=w&&R.coalesce(w);return d(A&&A.length>0?A[0]:void 0)})}matchFile(i,r){this.isFileMatch(r)&&(!this.includePattern||this.includePattern(r.relativePath,I.basename(r.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(r))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,E.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,r,c){return r.isSymbolicLink()?t.stat(i,c):c(null,r)}realPathIfNeeded(i,r,c){return r.isSymbolicLink()?t.realpath(i,(o,d)=>o?c(o):c(null,d)):c(null,i)}getSearchPath(i,r){return i.folderName?I.join(i.folderName,r):r}}e.FileWalker=s;class h{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new s(i)}search(i,r,c){this.walker.walk(this.folderQueries,this.extraFiles,i,r,(o,d)=>{c(o,{limitHit:d,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=h;class n{constructor(i,r){this.expression=i,this.root=r,this.init(i)}init(i){let r,c;Object.keys(i).filter(o=>i[o]).forEach(o=>{I.isAbsolute(o)?(r=r||y.getEmptyExpression(),r[o]=i[o]):(c=c||y.getEmptyExpression(),c[o]=i[o])}),this.absoluteParsedExpr=r&&y.parse(r,{trimForExclusions:!0}),this.relativeParsedExpr=c&&y.parse(c,{trimForExclusions:!0})}test(i,r,c){return this.relativeParsedExpr&&this.relativeParsedExpr(i,r,c)||this.absoluteParsedExpr&&this.absoluteParsedExpr(I.join(this.root,i),r,c)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...y.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...y.getPathTerms(this.relativeParsedExpr)),i}}function S(a){const i=a.trim().split(`
`),r=i[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return b.uppercaseFirstLetter(i[i.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}e.rgErrorMsgForDisplay=S}),define(pe[277],ve([0,1,97,22]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(a){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===a)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const _=512,R=512,k=512*8,y=512*128;var P;(function(a){a[a.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(i,r){super(i);this.decodeStreamErrorKind=r}}e.DecodeStreamError=L;class C{constructor(i){this.iconvLiteDecoder=i}static async create(i){let r;if(i!==e.UTF8)r=(await new Promise((o,d)=>{Z(["@vscode/iconv-lite-umd"],o,d)})).getDecoder(g(i));else{const c=new TextDecoder;r={write(o){return c.decode(o,{stream:!0})},end(){return c.decode()}}}return new C(r)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function l(a,i){const r=i.minBytesRequiredForDetection??i.guessEncoding?k:R;return new Promise((c,o)=>{const d=(0,f.newWriteableStream)(T=>T.join("")),m=[];let v=0,w,A;const M=async()=>{try{const T=await S({buffer:t.VSBuffer.concat(m),bytesRead:v},i.guessEncoding);if(T.seemsBinary&&i.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);T.encoding=await i.overwriteEncoding(T.encoding),w=await C.create(T.encoding);const O=w.write(t.VSBuffer.concat(m).buffer);d.write(O),m.length=0,v=0,c({stream:d,detected:T})}catch(T){A?.dispose(),d.destroy(),o(T)}};A=(0,f.listenStream)(a,{onData:async T=>{w?d.write(w.write(T.buffer)):(m.push(T),v+=T.byteLength,v>=r&&(a.pause(),await M(),setTimeout(()=>a.resume())))},onError:T=>d.error(T),onEnd:async()=>{w||await M(),d.end(w?.end())}})})}e.toDecodeStream=l;async function b(a,i,r){const o=(await new Promise((v,w)=>{Z(["@vscode/iconv-lite-umd"],v,w)})).getEncoder(g(i),r);let d=!1,m=!1;return{read(){if(m)return null;const v=a.read();if(typeof v!="string"){if(m=!0,!d&&r?.addBOM)switch(i){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const w=o.end();return w&&w.length>0?(d=!0,t.VSBuffer.wrap(w)):null}return d=!0,t.VSBuffer.wrap(o.write(v))}}}e.toEncodeReadable=b;async function p(a){return(await new Promise((r,c)=>{Z(["@vscode/iconv-lite-umd"],r,c)})).encodingExists(g(a))}e.encodingExists=p;function g(a){return a===e.UTF8_with_bom||a===null?e.UTF8:a}e.toNodeEncoding=g;function E(a,i){if(!a||i<e.UTF16be_BOM.length)return null;const r=a.readUInt8(0),c=a.readUInt8(1);if(r===e.UTF16be_BOM[0]&&c===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&c===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const o=a.readUInt8(2);return r===e.UTF8_BOM[0]&&c===e.UTF8_BOM[1]&&o===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=E;const F=["ascii","utf-16","utf-32"];async function D(a){const i=await new Promise((m,v)=>{Z(["jschardet"],m,v)}),r=a.slice(0,y),c=h(r.buffer),o=i.detect(c);if(!o||!o.encoding)return null;const d=o.encoding.toLowerCase();return 0<=F.indexOf(d)?null:s(o.encoding)}const u={ibm866:"cp866",big5:"cp950"};function s(a){const i=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return u[i]||i}function h(a){let i="";for(let r=0;r<a.length;r++)i+=String.fromCharCode(a[r]);return i}function n(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const i=a.match(/windows(\d+)/);return i?"windows-"+i[1]:a}}}e.toCanonicalName=n;function S({buffer:a,bytesRead:i},r){let c=E(a,i),o=!1;if(c!==e.UTF16be&&c!==e.UTF16le&&a){let d=!0,m=!0,v=!1;for(let w=0;w<i&&w<_;w++){const A=w%2==1,M=a.readUInt8(w)===0;if(M&&(v=!0),d&&(A&&!M||!A&&M)&&(d=!1),m&&(A&&M||!A&&!M)&&(m=!1),M&&!d&&!m)break}v&&(d?c=e.UTF16le:m?c=e.UTF16be:o=!0)}return r&&!o&&!c&&a?D(a.slice(0,i)).then(d=>({seemsBinary:!1,encoding:d})):{seemsBinary:o,encoding:c}}e.detectEncodingFromBuffer=S,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(pe[137],ve([0,1,277,30,136]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class _ extends I.TextSearchManager{constructor(k,y,P=t,L="searchProcess"){super(k,y,{readdir:C=>P.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,f.toCanonicalName)(C)},L)}}e.NativeTextSearchManager=_}),define(pe[278],ve([0,1,61,4]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDragAndDropService=e.ITreeViewsDragAndDropService=void 0,e.ITreeViewsDragAndDropService=(0,t.createDecorator)("treeViewsDragAndDropService");class I{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(R){if(R&&this._dragOperations.has(R)){const k=this._dragOperations.get(R);return this._dragOperations.delete(R),k}}addDragOperationTransfer(R,k){this._dragOperations.set(R,k)}}e.TreeViewsDragAndDropService=I,(0,f.registerSingleton)(e.ITreeViewsDragAndDropService,I)}),define(pe[279],ve([0,1,169,23,2,3,6,13,7,18,17,15,21,205,278]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(D,u){if((0,P.isString)(D))return{label:D};if(D&&typeof D=="object"&&typeof D.label=="string"){let s;return Array.isArray(D.highlights)&&(s=D.highlights.filter(h=>h.length===2&&typeof h[0]=="number"&&typeof h[1]=="number"),s=s.length?s:void 0),{label:D.label,highlights:s}}}class E{constructor(u,s,h){this._proxy=u,this.commands=s,this.logService=h,this.treeViews=new Map,this.treeDragAndDropService=new p.TreeViewsDragAndDropService;function n(S){return S&&S.$treeViewId&&S.$treeItemHandle}s.registerArgumentProcessor({processArgument:S=>n(S)?this.convertArgument(S):Array.isArray(S)&&S.length>0?S.map(a=>n(a)?this.convertArgument(a):a):S})}registerTreeDataProvider(u,s,h){const n=this.createTreeView(u,{treeDataProvider:s},h);return{dispose:()=>n.dispose()}}createTreeView(u,s,h){if(!s||!s.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const n=s.dragAndDropController?.supportedMimeTypes,S=!!s.dragAndDropController?.handleDrag,a=this._proxy.$registerTreeViewDataProvider(u,{showCollapseAll:!!s.showCollapseAll,canSelectMany:!!s.canSelectMany,dragAndDropMimeTypes:n,hasHandleDrag:S}),i=this.createExtHostTreeView(u,s,h);return{get onDidCollapseElement(){return i.onDidCollapseElement},get onDidExpandElement(){return i.onDidExpandElement},get selection(){return i.selectedElements},get onDidChangeSelection(){return i.onDidChangeSelection},get visible(){return i.visible},get onDidChangeVisibility(){return i.onDidChangeVisibility},get message(){return i.message},set message(r){i.message=r},get title(){return i.title},set title(r){i.title=r},get description(){return i.description},set description(r){i.description=r},reveal:(r,c)=>i.reveal(r,c),dispose:async()=>{await a,this.treeViews.delete(u),i.dispose()}}}$getChildren(u,s){const h=this.treeViews.get(u);return h?h.getChildren(s):Promise.reject(new Error((0,f.localize)(0,null,u)))}async $handleDrop(u,s,h,n,S,a){const i=this.treeViews.get(u);if(!i)return Promise.reject(new Error((0,f.localize)(1,null,u)));const r=b.TreeDataTransferConverter.toITreeDataTransfer(s);return S===u&&a&&await this.addAdditionalTransferItems(r,i,a,n),i.onDrop(r,h)}async addAdditionalTransferItems(u,s,h,n){const S=this.treeDragAndDropService.removeDragOperationTransfer(n);if(S)(await S)?.forEach((a,i)=>{a&&u.set(i,a)});else if(n&&s.handleDrag){const a=s.handleDrag(h,u);this.treeDragAndDropService.addDragOperationTransfer(n,a),await a}return u}async $handleDrag(u,s,h){const n=this.treeViews.get(u);if(!n)return Promise.reject(new Error((0,f.localize)(2,null,u)));const S=await this.addAdditionalTransferItems(new Map,n,s,h);if(!!S)return b.TreeDataTransferConverter.toTreeDataTransferDTO(S)}async $hasResolve(u){const s=this.treeViews.get(u);if(!s)throw new Error((0,f.localize)(3,null,u));return s.hasResolve}$resolve(u,s,h){const n=this.treeViews.get(u);if(!n)throw new Error((0,f.localize)(4,null,u));return n.resolveTreeItem(s,h)}$setExpanded(u,s,h){const n=this.treeViews.get(u);if(!n)throw new Error((0,f.localize)(5,null,u));n.setExpanded(s,h)}$setSelection(u,s){const h=this.treeViews.get(u);if(!h)throw new Error((0,f.localize)(6,null,u));h.setSelection(s)}$setVisible(u,s){const h=this.treeViews.get(u);if(!h)throw new Error((0,f.localize)(7,null,u));h.setVisible(s)}createExtHostTreeView(u,s,h){const n=new F(u,s,this._proxy,this.commands.converter,this.logService,h);return this.treeViews.set(u,n),n}convertArgument(u){const s=this.treeViews.get(u.$treeViewId);return s?s.getExtensionElement(u.$treeItemHandle):null}}e.ExtHostTreeViews=E;class F extends R.Disposable{constructor(u,s,h,n,S,a){super();if(this.viewId=u,this.proxy=h,this.commands=n,this.logService=S,this.extension=a,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new _.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new _.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new _.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new _.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new _.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new l.CancellationTokenSource,a.contributes&&a.contributes.views)for(const c in a.contributes.views)for(const o of a.contributes.views[c])o.id===u&&(this._title=o.name);this.dataProvider=s.treeDataProvider,this.dndController=s.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(c=>this._onDidChangeData.fire({message:!1,element:c}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(c=>this._onDidChangeData.fire({message:!1,element:c})));let i,r;this._register(_.Event.debounce(this._onDidChangeData.event,(c,o)=>(c||(c={message:!1,elements:[]}),o.element!==!1&&(i||(i=new Promise(d=>r=d),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(o.element)?c.elements.push(...o.element):c.elements.push(o.element)),o.message&&(c.message=!0),c),200,!0)(({message:c,elements:o})=>{o.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const d=r;return i=null,this.refresh(o).then(()=>d())})),c&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(u=>this.getExtensionElement(u)).filter(u=>!(0,P.isUndefinedOrNull)(u))}async getChildren(u){const s=u?this.getExtensionElement(u):void 0;if(u&&!s)return this.logService.error(`No tree item with id '${u}' found.`),Promise.resolve([]);let h=this.getChildrenNodes(u);return h||(h=await this.fetchChildrenNodes(s)),h?h.map(n=>n.item):void 0}getExtensionElement(u){return this.elements.get(u)}reveal(u,s){s=s||{select:!0,focus:!1};const h=(0,P.isUndefinedOrNull)(s.select)?!0:s.select,n=(0,P.isUndefinedOrNull)(s.focus)?!1:s.focus,S=(0,P.isUndefinedOrNull)(s.expand)?!1:s.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):u?this.refreshPromise.then(()=>this.resolveUnknownParentChain(u)).then(a=>this.resolveTreeNode(u,a[a.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:a.map(r=>r.item)},{select:h,focus:n,expand:S})),a=>this.logService.error(a)):this.proxy.$reveal(this.viewId,void 0,{select:h,focus:n,expand:S})}get message(){return this._message}set message(u){this._message=u,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(u){this._title=u,this.proxy.$setTitle(this.viewId,u,this._description)}get description(){return this._description}set description(u){this._description=u,this.proxy.$setTitle(this.viewId,this._title,u)}setExpanded(u,s){const h=this.getExtensionElement(u);h&&(s?this._onDidExpandElement.fire(Object.freeze({element:h})):this._onDidCollapseElement.fire(Object.freeze({element:h})))}setSelection(u){(0,L.equals)(this._selectedHandles,u)||(this._selectedHandles=u,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(u){u!==this._visible&&(this._visible=u,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(u,s){const h=[];for(const n of u){const S=this.getExtensionElement(n);S&&h.push(S)}if(!(!this.dndController?.handleDrag||h.length===0))return await this.dndController.handleDrag(h,s),s}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(u,s){const h=this.getExtensionElement(s);if(!!h)return(0,k.asPromise)(()=>this.dndController?.handleDrop(u,h))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(u,s){if(!this.dataProvider.resolveTreeItem)return;const h=this.elements.get(u);if(h){const n=this.nodes.get(h);if(n){const S=await this.dataProvider.resolveTreeItem(n.extensionItem,h,s)??n.extensionItem;return n.item.tooltip=this.getTooltip(S.tooltip),n.item.command=this.getCommand(n.disposableStore,S.command),n.item}}}resolveUnknownParentChain(u){return this.resolveParent(u).then(s=>s?this.resolveUnknownParentChain(s).then(h=>this.resolveTreeNode(s,h[h.length-1]).then(n=>(h.push(n),h))):Promise.resolve([]))}resolveParent(u){const s=this.nodes.get(u);return s?Promise.resolve(s.parent?this.elements.get(s.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(u))}resolveTreeNode(u,s){const h=this.nodes.get(u);return h?Promise.resolve(h):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(u)).then(n=>this.createHandle(u,n,s,!0)).then(n=>this.getChildren(s?s.item.handle:void 0).then(()=>{const S=this.getExtensionElement(n);if(S){const a=this.nodes.get(S);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${n}`)}))}getChildrenNodes(u){if(u){let s;if(typeof u=="string"){const h=this.getExtensionElement(u);s=h?this.nodes.get(h):void 0}else s=u;return s&&s.children||void 0}return this.roots}async fetchChildrenNodes(u){this.clearChildren(u);const s=new l.CancellationTokenSource(this._refreshCancellationSource.token);try{const h=u?this.nodes.get(u):void 0,n=await this.dataProvider.getChildren(u);if(s.token.isCancellationRequested)return;const S=await Promise.all((0,L.coalesce)(n||[]).map(async a=>{const i=await this.dataProvider.getTreeItem(a);return i&&!s.token.isCancellationRequested?this.createAndRegisterTreeNode(a,i,h):null}));return s.token.isCancellationRequested?void 0:(0,L.coalesce)(S)}finally{s.dispose()}}refresh(u){if(u.some(h=>!h))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new l.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const h=this.getHandlesToRefresh(u);if(h.length)return this.refreshHandles(h)}return Promise.resolve(void 0)}getHandlesToRefresh(u){const s=new Set,h=u.map(S=>this.nodes.get(S));for(const S of h)if(S&&!s.has(S.item.handle)){let a=S;for(;a&&a.parent&&h.findIndex(i=>a&&a.parent&&i&&i.item.handle===a.parent.item.handle)===-1;){const i=this.elements.get(a.parent.item.handle);a=i?this.nodes.get(i):void 0}a&&!a.parent&&s.add(S.item.handle)}const n=[];return s.forEach(S=>{const a=this.elements.get(S);if(a){const i=this.nodes.get(a);i&&(!i.parent||!s.has(i.parent.item.handle))&&n.push(S)}}),n}refreshHandles(u){const s={};return Promise.all(u.map(h=>this.refreshNode(h).then(n=>{n&&(s[h]=n.item)}))).then(()=>Object.keys(s).length?this.proxy.$refresh(this.viewId,s):void 0)}refreshNode(u){const s=this.getExtensionElement(u);if(s){const h=this.nodes.get(s);if(h)return this.clearChildren(s),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(s)).then(n=>{if(n){const S=this.createTreeNode(s,n,h.parent);return this.updateNodeCache(s,S,h,h.parent),h.dispose(),S}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(u,s,h){const n=this.createTreeNode(u,s,h);if(s.id&&this.elements.has(n.item.handle))throw new Error((0,f.localize)(8,null,s.id));return this.addNodeToCache(u,n),this.addNodeToParentCache(n,h),n}getTooltip(u){return y.MarkdownString.isMarkdownString(u)?C.MarkdownString.from(u):u}getCommand(u,s){return s?this.commands.toInternal(s,u):void 0}createTreeNode(u,s,h){const n=new R.DisposableStore,S=this.createHandle(u,s,h),a=this.getLightIconPath(s);return{item:{handle:S,parentHandle:h?h.item.handle:void 0,label:g(s.label,this.extension),description:s.description,resourceUri:s.resourceUri,tooltip:this.getTooltip(s.tooltip),command:this.getCommand(n,s.command),contextValue:s.contextValue,icon:a,iconDark:this.getDarkIconPath(s)||a,themeIcon:this.getThemeIcon(s),collapsibleState:(0,P.isUndefinedOrNull)(s.collapsibleState)?y.TreeItemCollapsibleState.None:s.collapsibleState,accessibilityInformation:s.accessibilityInformation},extensionItem:s,parent:h,children:void 0,disposableStore:n,dispose(){n.dispose()}}}getThemeIcon(u){return u.iconPath instanceof y.ThemeIcon?u.iconPath:void 0}createHandle(u,{id:s,label:h,resourceUri:n},S,a){if(s)return`${F.ID_HANDLE_PREFIX}/${s}`;const i=g(h,this.extension),r=S?S.item.handle:F.LABEL_HANDLE_PREFIX;let c=i?i.label:n?(0,t.basename)(n):"";c=c.indexOf("/")!==-1?c.replace("/","//"):c;const o=this.nodes.has(u)?this.nodes.get(u).item.handle:void 0,d=this.getChildrenNodes(S)||[];let m,v=0;do{if(m=`${r}/${v}:${c}`,a||!this.elements.has(m)||o===m)break;v++}while(v<=d.length);return m}getLightIconPath(u){if(u.iconPath&&!(u.iconPath instanceof y.ThemeIcon))return typeof u.iconPath=="string"||I.URI.isUri(u.iconPath)?this.getIconPath(u.iconPath):this.getIconPath(u.iconPath.light)}getDarkIconPath(u){if(u.iconPath&&!(u.iconPath instanceof y.ThemeIcon)&&u.iconPath.dark)return this.getIconPath(u.iconPath.dark)}getIconPath(u){return I.URI.isUri(u)?u:I.URI.file(u)}addNodeToCache(u,s){this.elements.set(s.item.handle,u),this.nodes.set(u,s)}updateNodeCache(u,s,h,n){this.elements.delete(s.item.handle),this.nodes.delete(u),s.item.handle!==h.item.handle&&this.elements.delete(h.item.handle),this.addNodeToCache(u,s);const S=this.getChildrenNodes(n)||[],a=S.filter(i=>i.item.handle===h.item.handle)[0];a&&S.splice(S.indexOf(a),1,s)}addNodeToParentCache(u,s){s?(s.children||(s.children=[]),s.children.push(u)):(this.roots||(this.roots=[]),this.roots.push(u))}clearChildren(u){if(u){const s=this.nodes.get(u);if(s){if(s.children)for(const h of s.children){const n=this.elements.get(h.item.handle);n&&this.clear(n)}s.children=void 0}}else this.clearAll()}clear(u){const s=this.nodes.get(u);if(s){if(s.children)for(const h of s.children){const n=this.elements.get(h.item.handle);n&&this.clear(n)}this.nodes.delete(u),this.elements.delete(s.item.handle),s.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(u=>u.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}F.LABEL_HANDLE_PREFIX="0",F.ID_HANDLE_PREFIX="1"}),define(pe[280],ve([0,1,21,16,3,47,2,114,109,147,82,42,5,230,229,38,231,36,232,233,234,217,235,45,39,236,237,240,241,242,134,219,247,248,249,90,34,251,279,15,7,254,69,135,35,75,206,239,63,132,71,54,73,11,65,14,26,243,203,51,66,227,252,202,68,67,257,255,256,228,44,250,253,89,53,123,245,70,246,10,190,244,200,238,6,28]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p,g,E,F,D,u,s,h,n,S,a,i,r,c,o,d,m,v,w,A,M,T,O,U,V,x,N,B,W,H,z,J,ie,se,K,X,ae,fe,be,Me,xe,Ge,Je,q,te,G,Q,oe,me,Ie,We,Ye,it,st,ot,tt,rt,gt,Ue,It,ee,ne,Se,re,ye,Fe,qe,Ve,ut,Re,Ae,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ce(de){const we=de.get(Je.IExtHostInitDataService),Ce=de.get(rt.IExtHostFileSystemInfo),Oe=de.get(Ye.IExtHostConsumerFileSystem),Ke=de.get(a.IExtHostExtensionService),$e=de.get(z.IExtHostWorkspace),Ze=de.get(ne.IExtHostTelemetry),lt=de.get(F.IExtHostConfiguration),ct=de.get(xe.IURITransformerService),He=de.get(Ge.IExtHostRpcService),Ee=de.get(T.IExtHostStorage),_e=de.get(We.IExtensionStoragePaths),he=de.get(Me.ILoggerService),Y=de.get(Me.ILogService),ke=de.get(G.IExtHostTunnelService),Ne=de.get(Q.IExtHostApiDeprecationService),Xe=de.get(H.IExtHostWindow),Qe=de.get(It.IExtHostSecretState),pt=de.get(ee.IExtHostEditorTabs);He.set(l.ExtHostContext.ExtHostFileSystemInfo,Ce),He.set(l.ExtHostContext.ExtHostLogLevelServiceShape,he),He.set(l.ExtHostContext.ExtHostWorkspace,$e),He.set(l.ExtHostContext.ExtHostConfiguration,lt),He.set(l.ExtHostContext.ExtHostExtensionService,Ke),He.set(l.ExtHostContext.ExtHostStorage,Ee),He.set(l.ExtHostContext.ExtHostTunnelService,ke),He.set(l.ExtHostContext.ExtHostWindow,Xe),He.set(l.ExtHostContext.ExtHostSecretState,Qe),He.set(l.ExtHostContext.ExtHostTelemetry,Ze),He.set(l.ExtHostContext.ExtHostEditorTabs,pt);const St=He.set(l.ExtHostContext.ExtHostDecorations,de.get(X.IExtHostDecorations)),yt=He.set(l.ExtHostContext.ExtHostDocumentsAndEditors,de.get(S.IExtHostDocumentsAndEditors)),ft=He.set(l.ExtHostContext.ExtHostCommands,de.get(g.IExtHostCommands)),wt=He.set(l.ExtHostContext.ExtHostTerminalService,de.get(O.IExtHostTerminalService)),bt=He.set(l.ExtHostContext.ExtHostDebugService,de.get(fe.IExtHostDebugService)),Ut=He.set(l.ExtHostContext.ExtHostSearch,de.get(be.IExtHostSearch)),Pt=He.set(l.ExtHostContext.ExtHostTask,de.get(ae.IExtHostTask)),Ft=He.set(l.ExtHostContext.ExtHostOutputService,de.get(m.IExtHostOutputService)),kt=He.set(l.ExtHostContext.ExtHostUrls,new B.ExtHostUrls(He)),Ct=He.set(l.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(He,yt)),Qt=He.set(l.ExtHostContext.ExtHostDocumentContentProviders,new s.ExtHostDocumentContentProvider(He,yt,Y)),Vt=He.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new h.ExtHostDocumentSaveParticipant(Y,Ct,He.getProxy(l.MainContext.MainThreadBulkEdits))),Et=He.set(l.ExtHostContext.ExtHostNotebook,new q.ExtHostNotebookController(He,ft,yt,Ct,_e)),Xt=He.set(l.ExtHostContext.ExtHostNotebookDocuments,new ut.ExtHostNotebookDocuments(Y,Et)),qt=He.set(l.ExtHostContext.ExtHostNotebookEditors,new Ve.ExtHostNotebookEditors(Y,He,Et)),Yt=He.set(l.ExtHostContext.ExtHostNotebookKernels,new Se.ExtHostNotebookKernels(He,we,Et,ft,Y)),ai=He.set(l.ExtHostContext.ExtHostNotebookRenderers,new ye.ExtHostNotebookRenderers(He,Et)),Rt=He.set(l.ExtHostContext.ExtHostEditors,new U.ExtHostEditors(He,yt)),Jt=He.set(l.ExtHostContext.ExtHostTreeViews,new V.ExtHostTreeViews(He.getProxy(l.MainContext.MainThreadTreeViews),ft,Y)),li=He.set(l.ExtHostContext.ExtHostEditorInsets,new ie.ExtHostEditorInsets(He.getProxy(l.MainContext.MainThreadEditorInsets),Rt,we)),jt=He.set(l.ExtHostContext.ExtHostDiagnostics,new D.ExtHostDiagnostics(He,Y,Ce)),Zt=He.set(l.ExtHostContext.ExtHostLanguages,new o.ExtHostLanguages(He,Ct,ft.converter,ct)),vt=He.set(l.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(He,ct,Ct,ft,jt,Y,Ne)),ci=He.set(l.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(He,vt)),Ot=He.set(l.ExtHostContext.ExtHostFileSystemEventService,new r.ExtHostFileSystemEventService(He,Y,yt)),$t=He.set(l.ExtHostContext.ExtHostQuickOpen,(0,w.createExtHostQuickOpen)(He,$e,ft)),vi=He.set(l.ExtHostContext.ExtHostSCM,new A.ExtHostSCM(He,ft,Y)),ui=He.set(l.ExtHostContext.ExtHostComments,(0,E.createExtHostComments)(He,ft,Ct)),ei=He.set(l.ExtHostContext.ExtHostProgress,new v.ExtHostProgress(He.getProxy(l.MainContext.MainThreadProgress))),Ci=He.set(l.ExtHostContext.ExtHosLabelService,new se.ExtHostLabelService(He)),wi=He.set(l.ExtHostContext.ExtHostTheming,new te.ExtHostTheming(He)),ti=He.set(l.ExtHostContext.ExtHostAuthentication,new oe.ExtHostAuthentication(He)),Di=He.set(l.ExtHostContext.ExtHostTimeline,new me.ExtHostTimeline(He,ft)),di=He.set(l.ExtHostContext.ExtHostWebviews,new W.ExtHostWebviews(He,{remote:we.remote},$e,Y,Ne)),Gt=He.set(l.ExtHostContext.ExtHostWebviewPanels,new ot.ExtHostWebviewPanels(He,di,$e)),hi=He.set(l.ExtHostContext.ExtHostCustomEditors,new st.ExtHostCustomEditors(He,Ct,_e,di,Gt)),ki=He.set(l.ExtHostContext.ExtHostWebviewViews,new it.ExtHostWebviewViews(He,di)),Kt=He.set(l.ExtHostContext.ExtHostTesting,new gt.ExtHostTesting(He,ft)),Ii=He.set(l.ExtHostContext.ExtHostUriOpeners,new Ue.ExtHostUriOpeners(He));He.set(l.ExtHostContext.ExtHostInteractive,new Re.ExtHostInteractive(He,Et,yt,ft));const Pi=(0,J.values)(l.ExtHostContext);He.assertRegistered(Pi);const ii=new tt.ExtHostBulkEdits(He,yt),Ai=new p.ExtHostClipboard(He),fi=new d.ExtHostMessageService(He,Y),bi=new u.ExtHostDialogs(He),ni=new M.ExtHostStatusBar(He,ft.converter);return b.ExtHostApiCommands.register(ft),function(Be,Ht,Bt){const _t=function(){let le=!Be.isUnderDevelopment;function ge(){le||(Y.info(`Extension '${Be.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),le=!0)}return function Te(ht){if(Array.isArray(ht))ht.forEach(Te);else if(typeof ht=="string")ge();else{const Dt=ht;typeof Dt.scheme=="undefined"&&ge(),typeof Dt.exclusive=="boolean"&&(0,De.checkProposedApiEnabled)(Be,"documentFiltersExclusive")}return ht}}(),Mt={getSession(le,ge,Te){return ti.getSession(Be,le,ge,Te)},async hasSession(le,ge){return(0,De.checkProposedApiEnabled)(Be,"authSession"),!!await ti.getSession(Be,le,ge,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(le,ge,Te,ht){return ti.registerAuthenticationProvider(le,ge,Te,ht)}},ri={registerCommand(le,ge,Te){return ft.registerCommand(!0,le,ge,Te,void 0,Be)},registerTextEditorCommand(le,ge,Te){return ft.registerCommand(!0,le,(...ht)=>{const Dt=Rt.getActiveTextEditor();if(!Dt){Y.warn("Cannot execute "+le+" because there is no active text editor.");return}return Dt.edit(Tt=>{ge.apply(Te,[Dt,Tt,...ht])}).then(Tt=>{Tt||Y.warn("Edits from command "+le+" were not applied.")},Tt=>{Y.warn("An error occurred while running command "+le,Tt)})},void 0,void 0,Be)},registerDiffInformationCommand:(le,ge,Te)=>((0,De.checkProposedApiEnabled)(Be,"diffCommand"),ft.registerCommand(!0,le,async(...ht)=>{const Dt=yt.activeEditor(!0);if(!Dt){Y.warn("Cannot execute "+le+" because there is no active text editor.");return}const Tt=await Rt.getDiffInformation(Dt.id);ge.apply(Te,[Tt,...ht])},void 0,void 0,Be)),executeCommand(le,...ge){return ft.executeCommand(le,...ge)},getCommands(le=!1){return ft.getCommands(le)}},Ei={get machineId(){return we.telemetryInfo.machineId},get sessionId(){return we.telemetryInfo.sessionId},get language(){return we.environment.appLanguage},get appName(){return we.environment.appName},get appRoot(){return we.environment.appRoot?.fsPath??""},get appHost(){return we.environment.appHost},get uriScheme(){return we.environment.appUriScheme},get clipboard(){return Ai.value},get shell(){return wt.getDefaultShell(!1)},get isTelemetryEnabled(){return Ze.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ze.onDidChangeTelemetryEnabled},get isNewAppInstall(){const le=Date.now()-new Date(we.telemetryInfo.firstSessionDate).getTime();return isNaN(le)?!1:le<1e3*60*60*24},openExternal(le,ge){return Xe.openUri(le,{allowTunneling:!!we.remote.authority,allowContributedOpeners:ge?.allowContributedOpeners})},async asExternalUri(le){if(le.scheme===we.environment.appUriScheme)return kt.createAppUri(le);try{return await Xe.asExternalUri(le,{allowTunneling:!!we.remote.authority})}catch(ge){if((0,qe.matchesScheme)(le,Fe.Schemas.http)||(0,qe.matchesScheme)(le,Fe.Schemas.https))return le;throw ge}},get remoteName(){return(0,K.getRemoteName)(we.remote.authority)},get remoteAuthority(){return(0,De.checkProposedApiEnabled)(Be,"resolvers"),we.remote.authority},get uiKind(){return we.uiKind}};we.environment.extensionTestsLocationURI||Object.freeze(Ei);const Si=we.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,Ti={createTestController(le,ge,Te){return Te&&(0,De.checkProposedApiEnabled)(Be,"testRefresh"),Kt.createTestController(le,ge,Te)},createTestObserver(){return(0,De.checkProposedApiEnabled)(Be,"testObserver"),Kt.createTestObserver()},runTests(le){return(0,De.checkProposedApiEnabled)(Be,"testObserver"),Kt.runTests(le)},get onDidChangeTestResults(){return(0,De.checkProposedApiEnabled)(Be,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,De.checkProposedApiEnabled)(Be,"testObserver"),Kt.results}},Ri={getExtension(le){const ge=Ht.getExtensionDescription(le);if(ge)return new a.Extension(Ke,Be.identifier,ge,Si)},get all(){return Ht.getAllExtensionDescriptions().map(le=>new a.Extension(Ke,Be.identifier,le,Si))},get onDidChange(){return Ht.onDidChange}},Li={createDiagnosticCollection(le){return jt.createDiagnosticCollection(Be.identifier,le)},get onDidChangeDiagnostics(){return jt.onDidChangeDiagnostics},getDiagnostics:le=>jt.getDiagnostics(le),getLanguages(){return Zt.getLanguages()},setTextDocumentLanguage(le,ge){return Zt.changeLanguage(le.uri,ge)},match(le,ge){return(0,L.score)(x.LanguageSelector.from(le),ge.uri,ge.languageId,!0)},registerCodeActionsProvider(le,ge,Te){return vt.registerCodeActionProvider(Be,_t(le),ge,Te)},registerCodeLensProvider(le,ge){return vt.registerCodeLensProvider(Be,_t(le),ge)},registerDefinitionProvider(le,ge){return vt.registerDefinitionProvider(Be,_t(le),ge)},registerDeclarationProvider(le,ge){return vt.registerDeclarationProvider(Be,_t(le),ge)},registerImplementationProvider(le,ge){return vt.registerImplementationProvider(Be,_t(le),ge)},registerTypeDefinitionProvider(le,ge){return vt.registerTypeDefinitionProvider(Be,_t(le),ge)},registerHoverProvider(le,ge){return vt.registerHoverProvider(Be,_t(le),ge,Be.identifier)},registerEvaluatableExpressionProvider(le,ge){return vt.registerEvaluatableExpressionProvider(Be,_t(le),ge,Be.identifier)},registerInlineValuesProvider(le,ge){return vt.registerInlineValuesProvider(Be,_t(le),ge,Be.identifier)},registerDocumentHighlightProvider(le,ge){return vt.registerDocumentHighlightProvider(Be,_t(le),ge)},registerLinkedEditingRangeProvider(le,ge){return vt.registerLinkedEditingRangeProvider(Be,_t(le),ge)},registerReferenceProvider(le,ge){return vt.registerReferenceProvider(Be,_t(le),ge)},registerRenameProvider(le,ge){return vt.registerRenameProvider(Be,_t(le),ge)},registerDocumentSymbolProvider(le,ge,Te){return vt.registerDocumentSymbolProvider(Be,_t(le),ge,Te)},registerWorkspaceSymbolProvider(le){return vt.registerWorkspaceSymbolProvider(Be,le)},registerDocumentFormattingEditProvider(le,ge){return vt.registerDocumentFormattingEditProvider(Be,_t(le),ge)},registerDocumentRangeFormattingEditProvider(le,ge){return vt.registerDocumentRangeFormattingEditProvider(Be,_t(le),ge)},registerOnTypeFormattingEditProvider(le,ge,Te,...ht){return vt.registerOnTypeFormattingEditProvider(Be,_t(le),ge,[Te].concat(ht))},registerDocumentSemanticTokensProvider(le,ge,Te){return vt.registerDocumentSemanticTokensProvider(Be,_t(le),ge,Te)},registerDocumentRangeSemanticTokensProvider(le,ge,Te){return vt.registerDocumentRangeSemanticTokensProvider(Be,_t(le),ge,Te)},registerSignatureHelpProvider(le,ge,Te,...ht){return typeof Te=="object"?vt.registerSignatureHelpProvider(Be,_t(le),ge,Te):vt.registerSignatureHelpProvider(Be,_t(le),ge,typeof Te=="undefined"?[]:[Te,...ht])},registerCompletionItemProvider(le,ge,...Te){return vt.registerCompletionItemProvider(Be,_t(le),ge,Te)},registerInlineCompletionItemProvider(le,ge){return(0,De.checkProposedApiEnabled)(Be,"inlineCompletions"),vt.registerInlineCompletionsProvider(Be,_t(le),ge)},registerDocumentLinkProvider(le,ge){return vt.registerDocumentLinkProvider(Be,_t(le),ge)},registerColorProvider(le,ge){return vt.registerColorProvider(Be,_t(le),ge)},registerFoldingRangeProvider(le,ge){return vt.registerFoldingRangeProvider(Be,_t(le),ge)},registerSelectionRangeProvider(le,ge){return vt.registerSelectionRangeProvider(Be,le,ge)},registerCallHierarchyProvider(le,ge){return vt.registerCallHierarchyProvider(Be,le,ge)},registerTypeHierarchyProvider(le,ge){return vt.registerTypeHierarchyProvider(Be,le,ge)},setLanguageConfiguration:(le,ge)=>vt.setLanguageConfiguration(Be,le,ge),getTokenInformationAtPosition(le,ge){return(0,De.checkProposedApiEnabled)(Be,"tokenInformation"),Zt.tokenAtPosition(le,ge)},registerInlayHintsProvider(le,ge){return(0,De.checkProposedApiEnabled)(Be,"inlayHints"),vt.registerInlayHintsProvider(Be,le,ge)},createLanguageStatusItem(le,ge){return(0,De.checkProposedApiEnabled)(Be,"languageStatus"),Zt.createLanguageStatusItem(Be,le,ge)}},Fi={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return wt.activeTerminal},get terminals(){return wt.terminals},async showTextDocument(le,ge,Te){const ht=await(R.URI.isUri(le)?Promise.resolve(_i.openTextDocument(le)):Promise.resolve(le));return Rt.showTextDocument(ht,ge,Te)},createTextEditorDecorationType(le){return Rt.createTextEditorDecorationType(Be,le)},onDidChangeActiveTextEditor(le,ge,Te){return Rt.onDidChangeActiveTextEditor(le,ge,Te)},onDidChangeVisibleTextEditors(le,ge,Te){return Rt.onDidChangeVisibleTextEditors(le,ge,Te)},onDidChangeTextEditorSelection(le,ge,Te){return Rt.onDidChangeTextEditorSelection(le,ge,Te)},onDidChangeTextEditorOptions(le,ge,Te){return Rt.onDidChangeTextEditorOptions(le,ge,Te)},onDidChangeTextEditorVisibleRanges(le,ge,Te){return Rt.onDidChangeTextEditorVisibleRanges(le,ge,Te)},onDidChangeTextEditorViewColumn(le,ge,Te){return Rt.onDidChangeTextEditorViewColumn(le,ge,Te)},onDidCloseTerminal(le,ge,Te){return wt.onDidCloseTerminal(le,ge,Te)},onDidOpenTerminal(le,ge,Te){return wt.onDidOpenTerminal(le,ge,Te)},onDidChangeActiveTerminal(le,ge,Te){return wt.onDidChangeActiveTerminal(le,ge,Te)},onDidChangeTerminalDimensions(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"terminalDimensions"),wt.onDidChangeTerminalDimensions(le,ge,Te)},onDidChangeTerminalState(le,ge,Te){return wt.onDidChangeTerminalState(le,ge,Te)},onDidWriteTerminalData(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"terminalDataWriteEvent"),wt.onDidWriteTerminalData(le,ge,Te)},get state(){return Xe.state},onDidChangeWindowState(le,ge,Te){return Xe.onDidChangeWindowState(le,ge,Te)},showInformationMessage(le,...ge){return fi.showMessage(Be,_.default.Info,le,ge[0],ge.slice(1))},showWarningMessage(le,...ge){return fi.showMessage(Be,_.default.Warning,le,ge[0],ge.slice(1))},showErrorMessage(le,...ge){return fi.showMessage(Be,_.default.Error,le,ge[0],ge.slice(1))},showQuickPick(le,ge,Te){return Array.isArray(le)&&le.some(ht=>ht.kind===N.QuickPickItemKind.Separator)&&(0,De.checkProposedApiEnabled)(Be,"quickPickSeparators"),$t.showQuickPick(le,ge,Te)},showWorkspaceFolderPick(le){return $t.showWorkspaceFolderPick(le)},showInputBox(le,ge){return $t.showInput(le,ge)},showOpenDialog(le){return bi.showOpenDialog(le)},showSaveDialog(le){return bi.showSaveDialog(le)},createStatusBarItem(le,ge,Te){let ht,Dt,Tt;return typeof le=="string"?(ht=le,Dt=ge,Tt=Te):(Dt=le,Tt=ge),ni.createStatusBarEntry(Be,ht,Dt,Tt)},setStatusBarMessage(le,ge){return ni.setStatusBarMessage(le,ge)},withScmProgress(le){return Ne.report("window.withScmProgress",Be,"Use 'withProgress' instead."),ei.withProgress(Be,{location:N.ProgressLocation.SourceControl},(ge,Te)=>le({report(ht){}}))},withProgress(le,ge){return ei.withProgress(Be,le,ge)},createOutputChannel(le){return Ft.createOutputChannel(le,Be)},createWebviewPanel(le,ge,Te,ht){return Gt.createWebviewPanel(Be,le,ge,Te,ht)},createWebviewTextEditorInset(le,ge,Te,ht){return(0,De.checkProposedApiEnabled)(Be,"editorInsets"),li.createWebviewEditorInset(le,ge,Te,ht,Be)},createTerminal(le,ge,Te){return typeof le=="object"?"pty"in le?wt.createExtensionTerminal(le):wt.createTerminalFromOptions(le):wt.createTerminal(le,ge,Te)},registerTerminalLinkProvider(le){return wt.registerLinkProvider(le)},registerTerminalProfileProvider(le,ge){return wt.registerProfileProvider(Be,le,ge)},registerTreeDataProvider(le,ge){return Jt.registerTreeDataProvider(le,ge,Be)},createTreeView(le,ge){return Jt.createTreeView(le,ge,Be)},registerWebviewPanelSerializer:(le,ge)=>Gt.registerWebviewPanelSerializer(Be,le,ge),registerCustomEditorProvider:(le,ge,Te={})=>hi.registerCustomEditorProvider(Be,le,ge,Te),registerFileDecorationProvider(le){return St.registerFileDecorationProvider(le,Be.identifier)},registerUriHandler(le){return kt.registerUriHandler(Be.identifier,le)},createQuickPick(){return $t.createQuickPick(Be)},createInputBox(){return $t.createInputBox(Be.identifier)},get activeColorTheme(){return wi.activeColorTheme},onDidChangeActiveColorTheme(le,ge,Te){return wi.onDidChangeActiveColorTheme(le,ge,Te)},registerWebviewViewProvider(le,ge,Te){return ki.registerWebviewViewProvider(Be,le,ge,Te?.webviewOptions)},get activeNotebookEditor(){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.onDidChangeActiveNotebookEditor(le,ge,Te)},get visibleNotebookEditors(){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),qt.onDidChangeNotebookEditorSelection(le,ge,Te)},onDidChangeNotebookEditorVisibleRanges(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),qt.onDidChangeNotebookEditorVisibleRanges(le,ge,Te)},showNotebookDocument(le,ge){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.showNotebookDocument(le,ge)},registerExternalUriOpener(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"externalUriOpener"),Ii.registerExternalUriOpener(Be.identifier,le,ge,Te)},get tabs(){return(0,De.checkProposedApiEnabled)(Be,"tabs"),pt.tabs},get activeTab(){return(0,De.checkProposedApiEnabled)(Be,"tabs"),pt.activeTab},get onDidChangeTabs(){return(0,De.checkProposedApiEnabled)(Be,"tabs"),pt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,De.checkProposedApiEnabled)(Be,"tabs"),pt.onDidChangeActiveTab},getInlineCompletionItemController(le){return(0,De.checkProposedApiEnabled)(Be,"inlineCompletions"),c.InlineCompletionController.get(le)}},_i={get rootPath(){return Ne.report("workspace.rootPath",Be,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),$e.getPath()},set rootPath(le){throw t.readonly()},getWorkspaceFolder(le){return $e.getWorkspaceFolder(le)},get workspaceFolders(){return $e.getWorkspaceFolders()},get name(){return $e.name},set name(le){throw t.readonly()},get workspaceFile(){return $e.workspaceFile},set workspaceFile(le){throw t.readonly()},updateWorkspaceFolders:(le,ge,...Te)=>$e.updateWorkspaceFolders(Be,le,ge||0,...Te),onDidChangeWorkspaceFolders:function(le,ge,Te){return $e.onDidChangeWorkspace(le,ge,Te)},asRelativePath:(le,ge)=>$e.getRelativePath(le,ge),findFiles:(le,ge,Te,ht)=>$e.findFiles(le,ge,Te,Be.identifier,ht),findTextInFiles:(le,ge,Te,ht)=>{(0,De.checkProposedApiEnabled)(Be,"findTextInFiles");let Dt,Tt;return typeof ge=="object"?(Dt=ge,Tt=Te):(Dt={},Tt=ge,ht=Te),$e.findTextInFiles(le,Dt||{},Tt,Be.identifier,ht)},saveAll:le=>$e.saveAll(le),applyEdit(le){return ii.applyWorkspaceEdit(le)},createFileSystemWatcher:(le,ge,Te,ht)=>Ot.createFileSystemWatcher($e,Be,le,ge,Te,ht),get textDocuments(){return Ct.getAllDocumentData().map(le=>le.document)},set textDocuments(le){throw t.readonly()},openTextDocument(le){let ge;const Te=le;if(typeof le=="string")ge=Promise.resolve(R.URI.file(le));else if(R.URI.isUri(le))ge=Promise.resolve(le);else if(!Te||typeof Te=="object")ge=Ct.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ge.then(ht=>Ct.ensureDocumentData(ht).then(Dt=>Dt.document))},onDidOpenTextDocument:(le,ge,Te)=>Ct.onDidAddDocument(le,ge,Te),onDidCloseTextDocument:(le,ge,Te)=>Ct.onDidRemoveDocument(le,ge,Te),onDidChangeTextDocument:(le,ge,Te)=>Ct.onDidChangeDocument(le,ge,Te),onDidSaveTextDocument:(le,ge,Te)=>Ct.onDidSaveDocument(le,ge,Te),onWillSaveTextDocument:(le,ge,Te)=>Vt.getOnWillSaveTextDocumentEvent(Be)(le,ge,Te),get notebookDocuments(){return Et.notebookDocuments.map(le=>le.apiNotebook)},async openNotebookDocument(le,ge){let Te;if(R.URI.isUri(le))Te=le,await Et.openNotebookDocument(le);else if(typeof le=="string")Te=R.URI.revive(await Et.createNotebookDocument({viewType:le,content:ge}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Te).apiNotebook},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(le,ge,Te,ht){return Et.registerNotebookSerializer(Be,le,ge,Te,(0,De.isProposedApiEnabled)(Be,"notebookLiveShare")?ht:void 0)},registerNotebookContentProvider:(le,ge,Te,ht)=>((0,De.checkProposedApiEnabled)(Be,"notebookContentProvider"),Et.registerNotebookContentProvider(Be,le,ge,Te,(0,De.isProposedApiEnabled)(Be,"notebookLiveShare")?ht:void 0)),onDidChangeConfiguration:(le,ge,Te)=>Bt.onDidChangeConfiguration(le,ge,Te),getConfiguration(le,ge){return ge=arguments.length===1?void 0:ge,Bt.getConfiguration(le,ge,Be)},registerTextDocumentContentProvider(le,ge){return Qt.registerTextDocumentContentProvider(le,ge)},registerTaskProvider:(le,ge)=>(Ne.report("window.registerTaskProvider",Be,"Use the corresponding function on the 'tasks' namespace instead"),Pt.registerTaskProvider(Be,le,ge)),registerFileSystemProvider(le,ge,Te){return(0,Ae.combinedDisposable)(ci.registerFileSystemProvider(Be,le,ge,Te),Oe.addFileSystemProvider(le,ge))},get fs(){return Oe.value},registerFileSearchProvider:(le,ge)=>((0,De.checkProposedApiEnabled)(Be,"fileSearchProvider"),Ut.registerFileSearchProvider(le,ge)),registerTextSearchProvider:(le,ge)=>((0,De.checkProposedApiEnabled)(Be,"textSearchProvider"),Ut.registerTextSearchProvider(le,ge)),registerRemoteAuthorityResolver:(le,ge)=>((0,De.checkProposedApiEnabled)(Be,"resolvers"),Ke.registerRemoteAuthorityResolver(le,ge)),registerResourceLabelFormatter:le=>((0,De.checkProposedApiEnabled)(Be,"resolvers"),Ci.$registerResourceLabelFormatter(le)),onDidCreateFiles:(le,ge,Te)=>Ot.onDidCreateFile(le,ge,Te),onDidDeleteFiles:(le,ge,Te)=>Ot.onDidDeleteFile(le,ge,Te),onDidRenameFiles:(le,ge,Te)=>Ot.onDidRenameFile(le,ge,Te),onWillCreateFiles:(le,ge,Te)=>Ot.getOnWillCreateFileEvent(Be)(le,ge,Te),onWillDeleteFiles:(le,ge,Te)=>Ot.getOnWillDeleteFileEvent(Be)(le,ge,Te),onWillRenameFiles:(le,ge,Te)=>Ot.getOnWillRenameFileEvent(Be)(le,ge,Te),openTunnel:le=>((0,De.checkProposedApiEnabled)(Be,"resolvers"),ke.openTunnel(Be,le).then(ge=>{if(!ge)throw new Error("cannot open tunnel");return ge})),get tunnels(){return(0,De.checkProposedApiEnabled)(Be,"resolvers"),ke.getTunnels()},onDidChangeTunnels:(le,ge,Te)=>((0,De.checkProposedApiEnabled)(Be,"resolvers"),ke.onDidChangeTunnels(le,ge,Te)),registerPortAttributesProvider:(le,ge)=>((0,De.checkProposedApiEnabled)(Be,"portsAttributes"),ke.registerPortsAttributesProvider(le,ge)),registerTimelineProvider:(le,ge)=>((0,De.checkProposedApiEnabled)(Be,"timeline"),Di.registerTimelineProvider(le,ge,Be.identifier,ft.converter)),get isTrusted(){return $e.trusted},requestWorkspaceTrust:le=>((0,De.checkProposedApiEnabled)(Be,"workspaceTrust"),$e.requestWorkspaceTrust(le)),onDidGrantWorkspaceTrust:(le,ge,Te)=>$e.onDidGrantWorkspaceTrust(le,ge,Te)},mi={get inputBox(){return Ne.report("scm.inputBox",Be,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(Be)},createSourceControl(le,ge,Te){return vi.createSourceControl(Be,le,ge,Te)}},Mi={createCommentController(le,ge){return ui.createCommentController(Be,le,ge)}},Oi={get activeDebugSession(){return bt.activeDebugSession},get activeDebugConsole(){return bt.activeDebugConsole},get breakpoints(){return bt.breakpoints},onDidStartDebugSession(le,ge,Te){return bt.onDidStartDebugSession(le,ge,Te)},onDidTerminateDebugSession(le,ge,Te){return bt.onDidTerminateDebugSession(le,ge,Te)},onDidChangeActiveDebugSession(le,ge,Te){return bt.onDidChangeActiveDebugSession(le,ge,Te)},onDidReceiveDebugSessionCustomEvent(le,ge,Te){return bt.onDidReceiveDebugSessionCustomEvent(le,ge,Te)},onDidChangeBreakpoints(le,ge,Te){return bt.onDidChangeBreakpoints(le,ge,Te)},registerDebugConfigurationProvider(le,ge,Te){return bt.registerDebugConfigurationProvider(le,ge,Te||N.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(le,ge){return bt.registerDebugAdapterDescriptorFactory(Be,le,ge)},registerDebugAdapterTrackerFactory(le,ge){return bt.registerDebugAdapterTrackerFactory(le,ge)},startDebugging(le,ge,Te){return!Te||typeof Te=="object"&&"configuration"in Te?bt.startDebugging(le,ge,{parentSession:Te}):bt.startDebugging(le,ge,Te||{})},stopDebugging(le){return bt.stopDebugging(le)},addBreakpoints(le){return bt.addBreakpoints(le)},removeBreakpoints(le){return bt.removeBreakpoints(le)},asDebugSourceUri(le,ge){return bt.asDebugSourceUri(le,ge)}},Ni={registerTaskProvider:(le,ge)=>Pt.registerTaskProvider(Be,le,ge),fetchTasks:le=>Pt.fetchTasks(le),executeTask:le=>Pt.executeTask(Be,le),get taskExecutions(){return Pt.taskExecutions},onDidStartTask:(le,ge,Te)=>Pt.onDidStartTask(le,ge,Te),onDidEndTask:(le,ge,Te)=>Pt.onDidEndTask(le,ge,Te),onDidStartTaskProcess:(le,ge,Te)=>Pt.onDidStartTaskProcess(le,ge,Te),onDidEndTaskProcess:(le,ge,Te)=>Pt.onDidEndTaskProcess(le,ge,Te)},Ui={createNotebookController(le,ge,Te,ht,Dt){return Yt.createNotebookController(Be,le,ge,Te,ht,(0,De.isProposedApiEnabled)(Be,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(le,ge)=>Et.registerNotebookCellStatusBarItemProvider(Be,le,ge),get onDidSaveNotebookDocument(){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Xt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(le){return(0,De.checkProposedApiEnabled)(Be,"notebookEditorDecorationType"),qt.createNotebookEditorDecorationType(le)},createRendererMessaging(le){return ai.createRendererMessaging(Be,le)},onDidChangeNotebookDocumentMetadata(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Xt.onDidChangeNotebookDocumentMetadata(le,ge,Te)},onDidChangeNotebookCells(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.onDidChangeNotebookCells(le,ge,Te)},onDidChangeNotebookCellExecutionState(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"notebookCellExecutionState"),Yt.onDidChangeNotebookCellExecutionState(le,ge,Te)},onDidChangeCellOutputs(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.onDidChangeCellOutputs(le,ge,Te)},onDidChangeCellMetadata(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.onDidChangeCellMetadata(le,ge,Te)},createConcatTextDocument(le,ge){return(0,De.checkProposedApiEnabled)(Be,"notebookConcatTextDocument"),new Ie.ExtHostNotebookConcatDocument(Et,Ct,le,ge)}};return{version:we.version,authentication:Mt,commands:ri,comments:Mi,debug:Oi,env:Ei,extensions:Ri,languages:Li,notebooks:Ui,scm:mi,tasks:Ni,tests:Ti,window:Fi,workspace:_i,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:f.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:N.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:N.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:C.FileType,FilePermission:C.FilePermission,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,InlineCompletionItem:N.InlineSuggestion,InlineCompletionList:N.InlineSuggestions,Hover:N.Hover,IndentAction:P.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TerminalLink:N.TerminalLink,TerminalLocation:N.TerminalLocation,TerminalProfile:N.TerminalProfile,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,TextDocumentChangeReason:N.TextDocumentChangeReason,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,TypeHierarchyItem:N.TypeHierarchyItem,UIKind:l.UIKind,Uri:R.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,InlayHint:N.InlayHint,InlayHintLabelPart:N.InlayHintLabelPart,InlayHintKind:N.InlayHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookRendererScript:N.NotebookRendererScript,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,NotebookControllerAffinity:N.NotebookControllerAffinity,PortAttributes:N.PortAttributes,LinkedEditingRanges:N.LinkedEditingRanges,TestResultState:N.TestResultState,TestRunRequest:N.TestRunRequest,TestMessage:N.TestMessage,TestTag:N.TestTag,TestRunProfileKind:N.TestRunProfileKind,TextSearchCompleteMessageType:re.TextSearchCompleteMessageType,TreeDataTransfer:N.TreeDataTransfer,TreeDataTransferItem:N.TreeDataTransferItem,CoveredCount:N.CoveredCount,FileCoverage:N.FileCoverage,StatementCoverage:N.StatementCoverage,BranchCoverage:N.BranchCoverage,FunctionCoverage:N.FunctionCoverage,WorkspaceTrustState:N.WorkspaceTrustState,LanguageStatusSeverity:N.LanguageStatusSeverity,QuickPickItemKind:N.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=ce}),define(pe[281],ve([0,1,282,293,294,2,295]),function(Z,e,f,t,I,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(C,l,b,p,g,E){const F=E.environment.useHostProxy,D=typeof F=="boolean"?F:!E.remote.isRemote,u=(0,R.createProxyResolver)({resolveProxy:h=>C.resolveProxy(h),getHttpProxySetting:()=>l.getConfiguration("http").get("proxy"),log:(h,n,...S)=>{switch(h){case R.LogLevel.Trace:p.trace(n,...S);break;case R.LogLevel.Debug:p.debug(n,...S);break;case R.LogLevel.Info:p.info(n,...S);break;case R.LogLevel.Warning:p.warn(n,...S);break;case R.LogLevel.Error:p.error(n,...S);break;case R.LogLevel.Critical:p.critical(n,...S);break;case R.LogLevel.Off:break;default:a(h,n,S);break}function a(i,r,...c){p.error("Unknown log level",i),p.error(r,...c)}},getLogLevel:()=>p.getLevel(),proxyResolveTelemetry:h=>{g.$publicLog2("resolveProxy",h)},useHostProxy:D,env:process.env}),s=y(l,u);return L(b,s)}e.connectProxyResolver=k;function y(C,l){const b={config:C.getConfiguration("http").get("proxySupport")||"off"};C.onDidChangeConfiguration(g=>{b.config=C.getConfiguration("http").get("proxySupport")||"off"});const p={config:!!C.getConfiguration("http").get("systemCertificates")};return C.onDidChangeConfiguration(g=>{p.config=!!C.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},f,(0,R.createHttpPatch)(f,l,{config:"off"},p,!0)),on:Object.assign({},f,(0,R.createHttpPatch)(f,l,{config:"on"},p,!0)),override:Object.assign({},f,(0,R.createHttpPatch)(f,l,{config:"override"},p,!0)),onRequest:Object.assign({},f,(0,R.createHttpPatch)(f,l,b,p,!0)),default:Object.assign(f,(0,R.createHttpPatch)(f,l,b,p,!1))},https:{off:Object.assign({},t,(0,R.createHttpPatch)(t,l,{config:"off"},p,!0)),on:Object.assign({},t,(0,R.createHttpPatch)(t,l,{config:"on"},p,!0)),override:Object.assign({},t,(0,R.createHttpPatch)(t,l,{config:"override"},p,!0)),onRequest:Object.assign({},t,(0,R.createHttpPatch)(t,l,b,p,!0)),default:Object.assign(t,(0,R.createHttpPatch)(t,l,b,p,!1))},tls:Object.assign(I,(0,R.createTlsPatch)(I))}}const P=new Map;function L(C,l){return C.getExtensionPathIndex().then(b=>{const p=Z.__$__nodeRequire("module"),g=p._load;p._load=function(F,D,u){if(F==="tls")return l.tls;if(F!=="http"&&F!=="https")return g.apply(this,arguments);const s=l[F],h=b.findSubstr(_.URI.file(D.filename));let n=P.get(h);if(n||P.set(h,n={}),!n[F]){let S=s.default;n[F]={...S}}return n[F]}})}}),define(pe[138],ve([0,1,37,296,104,17,75,32,9,8,2,31,70,297,275,91]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const E=p.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class F{constructor(m){this.outputChannel=m}provideTextSearchResults(m,v,w,A){return this.outputChannel.appendLine(`provideTextSearchResults ${m.pattern}, ${JSON.stringify({...v,folder:v.folder.toString()})}`),new Promise((M,T)=>{A.onCancellationRequested(()=>H());const O=S(m,v),U=v.folder.fsPath,V=O.map(K=>K.match(/^-/)?K:`'${K}'`).join(" ");this.outputChannel.appendLine(`${E} ${V}
 - cwd: ${U}`);let x=f.spawn(E,O,{cwd:U});x.on("error",K=>{console.error(K),this.outputChannel.appendLine("Error: "+(K&&K.message)),T((0,C.serializeSearchError)(new C.SearchError(K&&K.message,C.SearchErrorCode.rgProcessError)))});let N=!1;const B=new s(v.maxResults,U,v.previewOptions);B.on("result",K=>{N=!0,J="",w.report(K)});let W=!1;const H=()=>{W=!0,x&&x.kill(),B&&B.cancel()};let z=!1;B.on("hitLimit",()=>{z=!0,H()});let J="";x.stdout.on("data",K=>{B.handleData(K),N||(J+=K)});let ie=!1;x.stdout.once("data",()=>ie=!0);let se="";x.stderr.on("data",K=>{const X=K.toString();this.outputChannel.appendLine(X),se+=X}),x.on("close",()=>{if(this.outputChannel.appendLine(ie?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(N?"Got result from parser":"No result from parser"),J&&this.outputChannel.appendLine(`Got data without result: ${J}`),this.outputChannel.appendLine(""),W)M({limitHit:z});else{B.flush(),x=null;let K;se&&!ie&&(K=D(se))?T((0,C.serializeSearchError)(new C.SearchError(K.message,K.code))):M({limitHit:z})}})})}}e.RipgrepTextSearchEngine=F;function D(d){const m=d.split(`
`),v=m[0].trim();if(m.some(A=>A.startsWith("regex parse error")))return new C.SearchError(u(m),C.SearchErrorCode.regexParseError);const w=v.match(/grep config error: unknown encoding: (.*)/);if(w)return new C.SearchError(`Unknown encoding: ${w[1]}`,C.SearchErrorCode.unknownEncoding);if(v.startsWith("error parsing glob"))return new C.SearchError(v.charAt(0).toUpperCase()+v.substr(1),C.SearchErrorCode.globParseError);if(v.startsWith("the literal"))return new C.SearchError(v.charAt(0).toUpperCase()+v.substr(1),C.SearchErrorCode.invalidLiteral);if(v.startsWith("PCRE2: error compiling pattern"))return new C.SearchError(v,C.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=D;function u(d){const m=["Regex parse error"],v=d.filter(w=>w.startsWith("PCRE2:"));if(v.length>=1){const w=v[0].replace("PCRE2:","");if(w.indexOf(":")!==-1&&w.split(":").length>=2){const A=w.split(":")[1];m.push(":"+A)}}return m.join("")}e.buildRegexParseError=u;class s extends t.EventEmitter{constructor(m,v,w){super();this.maxResults=m,this.rootFolder=v,this.previewOptions=w,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new I.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(m,v){return super.on(m,v),this}handleData(m){if(this.isDone)return;const v=typeof m=="string"?m:this.stringDecoder.write(m);this.handleDecodedData(v)}handleDecodedData(m){let v=m.indexOf(`
`);const w=this.remainder+m;if(v>=0)v+=this.remainder.length;else{this.remainder=w;return}let A=0;for(;v>=0;)this.handleLine(w.substring(A,v).trim()),A=v+1,v=w.indexOf(`
`,A);this.remainder=w.substring(A)}handleLine(m){if(this.isDone||!m)return;let v;try{v=JSON.parse(m)}catch{throw new Error(`malformed line from rg: ${m}`)}if(v.type==="match"){const w=h(v.data.path),A=L.URI.file(y.join(this.rootFolder,w)),M=this.createTextSearchMatch(v.data,A);this.onResult(M),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(v.type==="context"){const w=h(v.data.path),A=L.URI.file(y.join(this.rootFolder,w));this.createTextSearchContext(v.data,A).forEach(T=>this.onResult(T))}}createTextSearchMatch(m,v){const w=m.line_number-1,A=h(m.lines),M=Buffer.from(A);let T=0,O=0,U=w;m.submatches.length===0&&m.submatches.push(A.length?{start:0,end:1,match:{text:A[0]}}:{start:0,end:0,match:{text:""}});const V=(0,_.coalesce)(m.submatches.map((x,N)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const B=h(x.match),W=M.slice(T,x.start).toString().length,H=O+W,z=n(B),J=U,ie=z.numLines+J,se=z.numLines>0?z.lastLineLength:z.lastLineLength+H;return T=x.end,O=se,U=ie,new l.Range(J,H,ie,se)}));return(0,g.createTextSearchResult)(v,A,V,this.previewOptions)}createTextSearchContext(m,v){const w=h(m.lines),A=m.line_number;return w.replace(/\r?\n$/,"").split(`
`).map((M,T)=>({text:M,uri:v,lineNumber:A+T}))}onResult(m){this.emit("result",m)}}e.RipgrepParser=s;function h(d){return d.bytes?Buffer.from(d.bytes,"base64").toString():d.text}function n(d){const m=/\n/g;let v=0,w=-1,A;for(;A=m.exec(d);)v++,w=A.index;const M=w>=0?d.length-w-1:d.length;return{numLines:v,lastLineLength:M}}function S(d,m){const v=["--hidden"];v.push(d.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:w,otherIncludes:A}=(0,R.groupBy)(m.includes,T=>T.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(A&&A.length){const T=new Set;A.forEach(O=>{T.add(O)}),v.push("-g","!*"),T.forEach(O=>{a(O).map(g.anchorGlob).forEach(U=>{v.push("-g",U)})})}w&&w.length&&w.forEach(T=>{v.push("-g",T)}),m.excludes.map(g.anchorGlob).forEach(T=>v.push("-g",`!${T}`)),m.maxFileSize&&v.push("--max-filesize",m.maxFileSize+""),m.useIgnoreFiles?m.useParentIgnoreFiles||v.push("--no-ignore-parent"):v.push("--no-ignore"),m.followSymlinks&&v.push("--follow"),m.encoding&&m.encoding!=="utf8"&&v.push("--encoding",m.encoding),d.pattern==="--"&&(d.isRegExp=!0,d.pattern="\\-\\-"),d.isMultiline&&!d.isRegExp&&(d.pattern=(0,P.escapeRegExpCharacters)(d.pattern),d.isRegExp=!0),m.usePCRE2&&v.push("--pcre2"),v.push("--crlf"),d.isRegExp&&(d.pattern=i(d.pattern),v.push("--engine","auto"));let M;if(d.isWordMatch){const O=(0,P.createRegExp)(d.pattern,!!d.isRegExp,{wholeWord:d.isWordMatch}).source.replace(/\\\//g,"/");v.push("--regexp",O)}else if(d.isRegExp){let T=c(d.pattern);T=o(T),v.push("--regexp",T)}else M=d.pattern,v.push("--fixed-strings");return v.push("--no-config"),m.useGlobalIgnoreFiles||v.push("--no-ignore-global"),v.push("--json"),d.isMultiline&&v.push("--multiline"),m.beforeContext&&v.push("--before-context",m.beforeContext+""),m.afterContext&&v.push("--after-context",m.afterContext+""),v.push("--"),M&&v.push(M),v.push("."),v}function a(d){const m=(0,k.splitGlobAware)(d,"/");return m.map((v,w)=>m.slice(0,w+1).join("/"))}e.spreadGlobComponents=a;function i(d){const m=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;d.match(m);)d=d.replace(m,"$1\\x{$2}");const v=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;d.match(v);)d=d.replace(v,"$1\\x{$2}");return d}e.unicodeEscapesToPCRE2=i;const r=d=>d.type==="Assertion"&&d.kind==="lookbehind";function c(d){let m;try{m=new b.RegExpParser().parsePattern(d)}catch{return d}let v="",w=0;const A=(O,U,V)=>{v+=d.slice(w,O)+V,w=U},M=[];return new b.RegExpVisitor({onCharacterEnter(O){if(O.raw!=="\\n")return;const U=M[0];if(!U)A(O.start,O.end,"\\r?\\n");else if(!M.some(r))if(U.type==="CharacterClass")if(U.negate){const V=d.slice(U.start+2,O.start)+d.slice(O.end,U.end-1);if(U.parent?.type==="Quantifier"){const x=U.parent;A(x.start,x.end,(V?`[^${V}]`:".")+(x.greedy?"+":"*"))}else A(U.start,U.end,"(?!\\r?\\n"+(V?`|[${V}]`:"")+")")}else{const V=d.slice(U.start+1,O.start)+d.slice(O.end,U.end-1);A(U.start,U.end,V===""?"\\r?\\n":`(?:[${V}]|\\r?\\n)`)}else U.type==="Quantifier"&&A(O.start,O.end,"(?:\\r?\\n)")},onQuantifierEnter(O){M.unshift(O)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(O){M.unshift(O)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(O){M.unshift(O)},onCharacterClassLeave(){M.shift()},onAssertionEnter(O){r(O)&&M.push(O)},onAssertionLeave(O){M[0]===O&&M.shift()}}).visit(m),v+=d.slice(w),v}e.fixRegexNewline=c;function o(d){return d.replace(/\n/g,"\\r?\\n")}e.fixNewline=o}),define(pe[283],ve([0,1,21,138,118,10]),function(Z,e,f,t,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class R{constructor(P){this.outputChannel=P,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(P,L,C,l){const b=new t.RipgrepTextSearchEngine(this.outputChannel);if(L.folder.scheme===_.Schemas.userData){const p={...L,folder:L.folder.with({scheme:_.Schemas.file})},g=new I.Progress(E=>C.report({...E,uri:E.uri.with({scheme:L.folder.scheme})}));return this.withToken(l,E=>b.provideTextSearchResults(P,p,g,E))}else return this.withToken(l,p=>b.provideTextSearchResults(P,L,C,p))}async withToken(P,L){const C=k(P);this.inProgress.add(C);const l=await L(C.token);return this.inProgress.delete(C),l}dispose(){this.inProgress.forEach(P=>P.cancel())}}e.RipgrepSearchProvider=R;function k(y){const P=new f.CancellationTokenSource;return y.onCancellationRequested(()=>P.cancel()),P}}),define(pe[284],ve([0,1,30,138,137]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class _{constructor(y){this.query=y}search(y,P,L){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(b){L({message:b})}},l=new I.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(C),f);return new Promise((b,p)=>l.search(g=>{P(g.map(R))},y).then(g=>b({limitHit:g.limitHit,type:"success",stats:g.stats}),p))}}e.TextSearchEngineAdapter=_;function R(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((y,P)=>{if(P.ranges){const L=P;return y+(Array.isArray(L.ranges)?L.ranges.length:1)}else return y+1},0)}}}),define(pe[285],ve([0,1,17,13,16,3,102,9,46,2,42,31,276,284]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class p{constructor(s="searchProcess"){this.processType=s,this.caches=Object.create(null)}fileSearch(s){let h;const n=F(s),S=new _.Emitter({onFirstListenerDidAdd:()=>{h=(0,t.createCancelablePromise)(a=>this.doFileSearchWithEngine(l.Engine,n,i=>S.fire(i),a)),h.then(a=>S.fire(a),a=>S.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{h.cancel()}});return S.event}textSearch(s){let h;const n=F(s),S=new _.Emitter({onFirstListenerDidAdd:()=>{h=(0,t.createCancelablePromise)(a=>this.ripgrepTextSearch(n,i=>S.fire(i),a)),h.then(a=>S.fire(a),a=>S.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{h.cancel()}});return S.event}ripgrepTextSearch(s,h,n){return s.maxFileSize=(0,L.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new b.TextSearchEngineAdapter(s).search(n,h,h)}doFileSearch(s,h,n){return this.doFileSearchWithEngine(l.Engine,s,h,n)}doFileSearchWithEngine(s,h,n,S,a=p.BATCH_SIZE){let i=0;const r=o=>{Array.isArray(o)?(i+=o.length,n(o.map(d=>this.rawMatchToSearchItem(d)))):o.relativePath?(i++,n(this.rawMatchToSearchItem(o))):n(o)};if(h.sortByScore){let o=this.trySortedSearchFromCache(h,r,S);if(!o){const d=h.maxResults?Object.assign({},h,{maxResults:null}):h,m=new s(d);o=this.doSortedSearch(m,h,n,r,S)}return new Promise((d,m)=>{o.then(([v,w])=>{const A=w.map(M=>this.rawMatchToSearchItem(M));this.sendProgress(A,n,a),d(v)},m)})}const c=new s(h);return this.doSearch(c,r,a,S).then(o=>({limitHit:o.limitHit,type:"success",stats:{detailStats:o.stats,type:this.processType,fromCache:!1,resultCount:i,sortingTime:void 0}}))}rawMatchToSearchItem(s){return{path:s.base?(0,k.join)(s.base,s.relativePath):s.relativePath}}doSortedSearch(s,h,n,S,a){const i=new _.Emitter;let r=(0,t.createCancelablePromise)(o=>{let d=[];const m=v=>{Array.isArray(v)?d=v:(S(v),i.fire(v))};return this.doSearch(s,m,-1,o).then(v=>[v,d])}),c;if(h.cacheKey){c=this.getOrCreateCache(h.cacheKey);const o={promise:r,event:i.event,resolved:!1};c.resultsToSearchCache[h.filePattern||""]=o,r.then(()=>{o.resolved=!0},d=>{delete c.resultsToSearchCache[h.filePattern||""]}),r=this.preventCancellation(r)}return r.then(([o,d])=>{const m=c?c.scorerCache:Object.create(null),v=(typeof h.maxResults!="number"||h.maxResults>0)&&y.StopWatch.create(!1);return this.sortResults(h,d,m,a).then(w=>{const A=v?v.elapsed():-1;return[{type:"success",stats:{detailStats:o.stats,sortingTime:A,fromCache:!1,type:this.processType,workspaceFolderCount:h.folderQueries.length,resultCount:w.length},messages:o.messages,limitHit:o.limitHit||typeof h.maxResults=="number"&&d.length>h.maxResults},w]})})}getOrCreateCache(s){const h=this.caches[s];return h||(this.caches[s]=new g)}trySortedSearchFromCache(s,h,n){const S=s.cacheKey&&this.caches[s.cacheKey];if(!S)return;const a=this.getResultsFromCache(S,s.filePattern||"",h,n);if(a)return a.then(([i,r,c])=>{const o=y.StopWatch.create(!1);return this.sortResults(s,r,S.scorerCache,n).then(d=>{const m=o.elapsed(),v={fromCache:!0,detailStats:c,type:this.processType,resultCount:r.length,sortingTime:m};return[{type:"success",limitHit:i.limitHit||typeof s.maxResults=="number"&&r.length>s.maxResults,stats:v},d]})})}sortResults(s,h,n,S){const a=(0,R.prepareQuery)(s.filePattern||""),i=(c,o)=>(0,R.compareItemsByFuzzyScore)(c,o,a,!0,E,n),r=typeof s.maxResults=="number"?s.maxResults:Number.MAX_VALUE;return f.topAsync(h,i,r,1e4,S)}sendProgress(s,h,n){if(n&&n>0)for(let S=0;S<s.length;S+=n)h(s.slice(S,S+n));else h(s)}getResultsFromCache(s,h,n,S){const a=y.StopWatch.create(!1),i=h.indexOf(k.sep)>=0;let r;for(const m in s.resultsToSearchCache)if(h.startsWith(m)){if(i&&m.indexOf(k.sep)<0&&m!=="")continue;const v=s.resultsToSearchCache[m];r={promise:this.preventCancellation(v.promise),event:v.event,resolved:v.resolved};break}if(!r)return null;const c=a.elapsed(),o=y.StopWatch.create(!1),d=r.event(n);return S&&S.onCancellationRequested(()=>{d.dispose()}),r.promise.then(([m,v])=>{if(S&&S.isCancellationRequested)throw(0,I.canceled)();const w=[],A=(0,R.prepareQuery)(h).normalizedLowercase;for(const M of v)!(0,C.isFilePatternMatch)(M,A)||w.push(M);return[m,w,{cacheWasResolved:r.resolved,cacheLookupTime:c,cacheFilterTime:o.elapsed(),cacheEntryCount:v.length}]})}doSearch(s,h,n,S){return new Promise((a,i)=>{let r=[];S&&S.onCancellationRequested(()=>s.cancel()),s.search(c=>{c&&(n?(r.push(c),n>0&&r.length>=n&&(h(r),r=[])):h(c))},c=>{h(c)},(c,o)=>{r.length&&h(r),c?i(c):a(o)})})}clearCache(s){return delete this.caches[s],Promise.resolve(void 0)}preventCancellation(s){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(h,n){return s.then(h,n)}catch(h){return this.then(void 0,h)}finally(h){return s.finally(h)}}}}e.SearchService=p,p.BATCH_SIZE=512;class g{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const E=new class{getItemLabel(u){return(0,k.basename)(u.relativePath)}getItemDescription(u){return(0,k.dirname)(u.relativePath)}getItemPath(u){return u.relativePath}};function F(u){return{...u,folderQueries:u.folderQueries&&u.folderQueries.map(D),extraFileResources:u.extraFileResources&&u.extraFileResources.map(s=>P.URI.revive(s))}}function D(u){return{...u,folder:P.URI.revive(u.folder)}}}),define(pe[286],ve([0,1,6,10,2,30,11,26,14,73,65,31,285,283,91,137]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let E=class extends P.ExtHostSearch{constructor(D,u,s,h){super(D,s,h);this._pfs=_,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const n=new p.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.userData,new b.RipgrepSearchProvider(n)),u.remote.isRemote&&u.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const D=new p.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new b.RipgrepSearchProvider(D)),this.registerInternalFileSearchProvider(t.Schemas.file,new l.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(D,u){const s=this._handlePool++;return this._internalFileSearchProvider=u,this._internalFileSearchHandle=s,this._proxy.$registerFileSearchProvider(s,this._transformScheme(D)),(0,f.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(s)})}$provideFileSearchResults(D,u,s,h){const n=(0,P.reviveQuery)(s);return D===this._internalFileSearchHandle?this.doInternalFileSearch(D,u,n,h):super.$provideFileSearchResults(D,u,s,h)}doInternalFileSearch(D,u,s,h){const n=S=>{if((0,C.isSerializedFileMatch)(S)&&(S=[S]),Array.isArray(S)){this._proxy.$handleFileMatch(D,u,S.map(a=>I.URI.file(a.path)));return}S.message&&this._logService.debug("ExtHostSearch",S.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(s,n,h)}$clearCache(D){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(D),super.$clearCache(D)}createTextSearchManager(D,u){return new g.NativeTextSearchManager(D,u,void 0,"textSearchProvider")}};E=je([ze(0,y.IExtHostRpcService),ze(1,k.IExtHostInitDataService),ze(2,L.IURITransformerService),ze(3,R.ILogService)],E),e.NativeExtHostSearch=E}),define(pe[139],ve([0,1,298,126,81,22,16,3,6,9,12,33,106,107,299]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(v,w=""){this.debugLabel=w,this.socket=v,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=A=>{if(this.traceSocketEvent("error",{code:A?.code,message:A?.message}),A){if(A.code==="EPIPE")return;(0,R.onUnexpectedError)(A)}},this.socket.on("error",this._errorListener)}traceSocketEvent(v,w){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,v,w)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(v){const w=A=>{this.traceSocketEvent("read",A),v(_.VSBuffer.wrap(A))};return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(v){const w=A=>{this.traceSocketEvent("close",{hadError:A}),v({type:0,hadError:A,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(v){const w=()=>{this.traceSocketEvent("nodeEndReceived"),v()};return this.socket.on("end",w),{dispose:()=>this.socket.off("end",w)}}write(v){if(!this.socket.destroyed)try{this.traceSocketEvent("write",v),this.socket.write(v.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,R.onUnexpectedError)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,R.onUnexpectedError)(w)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((v,w)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),v();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),this.traceSocketEvent("nodeDrainEnd"),v()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.NodeSocket=g;var E;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var F;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(F||(F={}));class D extends y.Disposable{constructor(v,w,A,M){super();this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=v,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:w,inflateBytesLength:A?.byteLength||0,recordInflateBytes:M}),this._flowManager=this._register(new u(this,w,A,M,this._onData,(T,O)=>this._write(T,O))),this._register(this._flowManager.onError(T=>{console.error(T),(0,R.onUnexpectedError)(T),this._onClose.fire({type:0,hadError:!0,error:T})})),this._incomingData=new b.ChunkStream,this._register(this.socket.onData(T=>this._acceptChunk(T))),this._register(this.socket.onClose(T=>this._onClose.fire(T)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(v,w){this.socket.traceSocketEvent(v,w)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(v){return this._onData.event(v)}onClose(v){return this._onClose.event(v)}onEnd(v){return this.socket.onEnd(v)}write(v){this._flowManager.writeMessage(v)}_write(v,w){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",v);let A=2;v.byteLength<126?A+=0:v.byteLength<2**16?A+=2:A+=8;const M=_.VSBuffer.alloc(A);if(w?M.writeUInt8(194,0):M.writeUInt8(130,0),v.byteLength<126)M.writeUInt8(v.byteLength,1);else if(v.byteLength<2**16){M.writeUInt8(126,1);let T=1;M.writeUInt8(v.byteLength>>>8&255,++T),M.writeUInt8(v.byteLength>>>0&255,++T)}else{M.writeUInt8(127,1);let T=1;M.writeUInt8(0,++T),M.writeUInt8(0,++T),M.writeUInt8(0,++T),M.writeUInt8(0,++T),M.writeUInt8(v.byteLength>>>24&255,++T),M.writeUInt8(v.byteLength>>>16&255,++T),M.writeUInt8(v.byteLength>>>8&255,++T),M.writeUInt8(v.byteLength>>>0&255,++T)}this.socket.write(_.VSBuffer.concat([M,v]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(v){if(v.byteLength!==0){for(this._incomingData.acceptChunk(v);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const w=this._incomingData.peek(this._state.readLen),A=w.readUInt8(0),M=(A&128)>>>7,T=(A&64)>>>6,O=w.readUInt8(1),U=(O&128)>>>7,V=O&127;this._state.state=2,this._state.readLen=2+(U?4:0)+(V===126?2:0)+(V===127?8:0),this._state.fin=M,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(T)),this._state.firstFrameOfMessage=Boolean(M),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const w=this._incomingData.read(this._state.readLen),A=w.readUInt8(1),M=(A&128)>>>7;let T=A&127,O=1;T===126?T=w.readUInt8(++O)*2**8+w.readUInt8(++O):T===127&&(T=w.readUInt8(++O)*0+w.readUInt8(++O)*0+w.readUInt8(++O)*0+w.readUInt8(++O)*0+w.readUInt8(++O)*2**24+w.readUInt8(++O)*2**16+w.readUInt8(++O)*2**8+w.readUInt8(++O));let U=0;M&&(U=w.readUInt8(++O)*2**24+w.readUInt8(++O)*2**16+w.readUInt8(++O)*2**8+w.readUInt8(++O)),this._state.state=3,this._state.readLen=T,this._state.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const w=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",w),n(w,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",w),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(w,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=D;class u extends y.Disposable{constructor(v,w,A,M,T,O){super();this._tracer=v,this._onData=T,this._writeFn=O,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,w?(this._zlibInflateStream=this._register(new s(this._tracer,M,A,{windowBits:15})),this._zlibDeflateStream=this._register(new h(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(U=>this._onError.fire(U))),this._register(this._zlibDeflateStream.onError(U=>this._onError.fire(U)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:_.VSBuffer.alloc(0)}writeMessage(v){this._writeQueue.push(v),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const v=this._writeQueue.shift();if(this._zlibDeflateStream){const w=await this._deflateMessage(this._zlibDeflateStream,v);this._writeFn(w,!0)}else this._writeFn(v,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(v,w){return new Promise((A,M)=>{v.write(w),v.flush(T=>A(T))})}acceptFrame(v,w,A){this._readQueue.push({data:v,isCompressed:w,isLastFrameOfMessage:A}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const v=this._readQueue.shift();if(this._zlibInflateStream&&v.isCompressed){const w=await this._inflateFrame(this._zlibInflateStream,v.data,v.isLastFrameOfMessage);this._onData.fire(w)}else this._onData.fire(v.data)}this._isProcessingReadQueue=!1}}_inflateFrame(v,w,A){return new Promise((M,T)=>{v.write(w),A&&v.write(_.VSBuffer.fromByteArray([0,0,255,255])),v.flush(O=>M(O))})}}class s extends y.Disposable{constructor(v,w,A,M){super();this._tracer=v,this._recordInflateBytes=w,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=p.createInflateRaw(M),this._zlibInflate.on("error",T=>{this._tracer.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this._onError.fire(T)}),this._zlibInflate.on("data",T=>{this._tracer.traceSocketEvent("zlibInflateData",T),this._pendingInflateData.push(_.VSBuffer.wrap(T))}),A&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",A.buffer),this._zlibInflate.write(A.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?_.VSBuffer.concat(this._recordedInflateBytes):_.VSBuffer.alloc(0)}write(v){this._recordInflateBytes&&this._recordedInflateBytes.push(v.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",v),this._zlibInflate.write(v.buffer)}flush(v){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const w=_.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,v(w)})}}class h extends y.Disposable{constructor(v,w){super();this._tracer=v,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=p.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:A?.message,code:A?.code}),this._onError.fire(A)}),this._zlibDeflate.on("data",A=>{this._tracer.traceSocketEvent("zlibDeflateData",A),this._pendingDeflateData.push(_.VSBuffer.wrap(A))})}write(v){this._tracer.traceSocketEvent("zlibDeflateWrite",v.buffer),this._zlibDeflate.write(v.buffer)}flush(v){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let w=_.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,w=w.slice(0,w.byteLength-4),v(w)})}}function n(m,v){if(v===0)return;let w=m.byteLength>>>2;for(let V=0;V<w;V++){const x=m.readUInt32BE(V*4);m.writeUInt32BE(x^v,V*4)}let A=w*4,M=m.byteLength-A;const T=v>>>24&255,O=v>>>16&255,U=v>>>8&255;M>=1&&m.writeUInt8(m.readUInt8(A)^T,A),M>=2&&m.writeUInt8(m.readUInt8(A+1)^O,A+1),M>=3&&m.writeUInt8(m.readUInt8(A+2)^U,A+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const S={[2]:107,[1]:103};function a(){const m=(0,C.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let v;return e.XDG_RUNTIME_DIR?v=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):v=(0,P.join)((0,I.tmpdir)(),`vscode-ipc-${m}.sock`),r(v),v}e.createRandomIPCHandle=a;function i(m,v,w){const A=(0,f.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${A}-${w}-${v}-sock`;let M;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?M=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${A.substr(0,8)}-${w}-${v}.sock`):M=(0,P.join)(m,`${w}-${v}.sock`),r(M),M}e.createStaticIPCHandle=i;function r(m){const v=S[L.platform];typeof v=="number"&&m.length>=v&&console.warn(`WARNING: IPC handle "${m}" is longer than ${v} chars, try a shorter --user-data-dir`)}class c extends l.IPCServer{constructor(v){super(c.toClientConnectionEvent(v));this.server=v}static toClientConnectionEvent(v){const w=k.Event.fromNodeEventEmitter(v,"connection");return k.Event.map(w,A=>({protocol:new b.Protocol(new g(A,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(A,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=c;function o(m){return new Promise((v,w)=>{const A=(0,t.createServer)();A.on("error",w),A.listen(m,()=>{A.removeListener("error",w),v(new c(A))})})}e.serve=o;function d(m,v){return new Promise((w,A)=>{const M=(0,t.createConnection)(m,()=>{M.removeListener("error",A),w(b.Client.fromSocket(new g(M,`ipc-client${v}`),v))});M.once("error",A)})}e.connect=d}),define(pe[287],ve([0,1,139,282,60,38,2,198,11]),function(Z,e,f,t,I,_,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(l,b,p){this._commands=l,this.logService=b,this._ipcHandlePath=p,this._server=t.createServer((g,E)=>this.onRequest(g,E)),this.setup().catch(g=>(b.error(g),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",l=>this.logService.error(l))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(l,b){const p=[];l.setEncoding("utf8"),l.on("data",g=>p.push(g)),l.on("end",()=>{const g=JSON.parse(p.join(""));switch(g.type){case"open":this.open(g,b);break;case"openExternal":this.openExternal(g,b);break;case"status":this.getStatus(g,b);break;case"extensionManagement":this.manageExtensions(g,b).catch(this.logService.error);break;default:b.writeHead(404),b.write(`Unknown message type: ${g.type}`,E=>{E&&this.logService.error(E)}),b.end();break}})}open(l,b){const{fileURIs:p,folderURIs:g,forceNewWindow:E,diffMode:F,addMode:D,forceReuseWindow:u,gotoLineMode:s,waitMarkerFilePath:h,remoteAuthority:n}=l,S=[];if(Array.isArray(g))for(const c of g)try{S.push({folderUri:R.URI.parse(c)})}catch{}if(Array.isArray(p))for(const c of p)try{(0,k.hasWorkspaceFileExtension)(c)?S.push({workspaceUri:R.URI.parse(c)}):S.push({fileUri:R.URI.parse(c)})}catch{}const a=h?R.URI.file(h):void 0,r={forceNewWindow:E,diffMode:F,addMode:D,gotoLineMode:s,forceReuseWindow:u,preferNewWindow:!u&&!a&&!D,waitMarkerFileURI:a,remoteAuthority:n};this._commands.executeCommand("_remoteCLI.windowOpen",S,r),b.writeHead(200),b.end()}async openExternal(l,b){for(const p of l.uris){const g=R.URI.parse(p),E=g.scheme==="file"?g:p;await this._commands.executeCommand("_remoteCLI.openExternal",E)}b.writeHead(200),b.end()}async manageExtensions(l,b){try{const p=F=>F?.map(D=>/\.vsix$/i.test(D)?R.URI.parse(D):D),g={list:l.list,install:p(l.install),uninstall:p(l.uninstall),force:l.force},E=await this._commands.executeCommand("_remoteCLI.manageExtensions",g);b.writeHead(200),b.write(E)}catch(p){b.writeHead(500),b.write(String(p),g=>{g&&this.logService.error(g)})}b.end()}async getStatus(l,b){try{const p=await this._commands.executeCommand("_remoteCLI.getSystemStatus");b.writeHead(200),b.write(p),b.end()}catch(p){b.writeHead(500),b.write(String(p),g=>{g&&this.logService.error(g)}),b.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&I.existsSync(this._ipcHandlePath)&&I.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let L=class extends P{constructor(l,b){super(l,b,(0,f.createRandomIPCHandle)())}};L=je([ze(0,_.IExtHostCommands),ze(1,y.ILogService)],L),e.CLIServer=L}),define(pe[288],ve([0,1,72,280,268,5,281,39,258,2,10,7,287,105]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class p extends I.RequireInterceptor{_installInterceptor(){const F=this,D=Z.__$__nodeRequire("module"),u=D._load;D._load=function(S,a,i){return S=h(S),F._factories.has(S)?F._factories.get(S).load(S,P.URI.file((0,b.realpathSync)(a.filename)),r=>u.apply(this,[r,a,i])):u.apply(this,arguments)};const s=D._resolveLookupPaths;D._resolveLookupPaths=(n,S)=>s.call(this,h(n),S);const h=n=>{for(let S of F._alternatives){let a=S(n);if(a){n=a;break}}return n}}}class g extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=C.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const F=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(y.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const n=this._instaService.createInstance(l.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=n.ipcHandlePath}await this._instaService.createInstance(p,F,this._registry).install(),f.mark("code/extHost/didInitAPI");const u=await this._extHostConfiguration.getConfigProvider();await(0,R.connectProxyResolver)(this._extHostWorkspace,u,this,this._logService,this._mainThreadTelemetryProxy,this._initData),f.mark("code/extHost/didInitProxyResolver");const s=process.send,h=this._extHostContext.getProxy(_.MainContext.MainThreadConsole);process.send=(...n)=>n.length===0||!n[0]||n[0].type!=="__$console"?s.apply(process,n):(h.$logExtensionHostMessage(n[0]),!1)}_getEntryPoint(F){return F.main}_loadCommonJSModule(F,D,u){if(D.scheme!==L.Schemas.file)throw new Error(`Cannot load URI: '${D}', must be of file-scheme`);let s=null;u.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${D.toString(!0)}`),this._logService.flush();try{F&&f.mark(`code/extHost/willLoadExtensionCode/${F.value}`),s=Z.__$__nodeRequire(D.fsPath)}catch(h){return Promise.reject(h)}finally{F&&f.mark(`code/extHost/didLoadExtensionCode/${F.value}`),u.codeLoadingStop()}return Promise.resolve(s)}async $setRemoteEnvironment(F){if(!!this._initData.remote.isRemote)for(const D in F){const u=F[D];u===null?delete process.env[D]:process.env[D]=u}}}e.ExtHostExtensionService=g}),define(pe[289],ve([0,1,61,261,270,269,286,288,262,54,39,73,71,34,51,68,260,259,11]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p,g,E,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.registerSingleton)(L.IExtHostExtensionService,k.ExtHostExtensionService),(0,f.registerSingleton)(D.ILoggerService,F.ExtHostLoggerService),(0,f.registerSingleton)(g.IExtensionStoragePaths,E.ExtensionStoragePaths),(0,f.registerSingleton)(P.IExtHostDebugService,_.ExtHostDebugService),(0,f.registerSingleton)(C.IExtHostSearch,R.NativeExtHostSearch),(0,f.registerSingleton)(l.IExtHostTask,I.ExtHostTask),(0,f.registerSingleton)(b.IExtHostTerminalService,t.ExtHostTerminalService),(0,f.registerSingleton)(p.IExtHostTunnelService,y.ExtHostTunnelService)}),define(pe[290],ve([0,1,126,300,72,16,107,139,191,223,271,22,103,30,105,13,114,273,289]),function(Z,e,f,t,I,_,R,k,y,P,L,C,l,b,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const F=t(process.argv.slice(2),{string:["uriTransformerPath"],boolean:["skipWorkspaceStorageLock","useHostProxy"]});(function(){const i=Z.__$__nodeRequire("module"),r=i._load;i._load=function(c){if(c==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return r.apply(this,arguments)}})();const D=process.exit.bind(process);function u(i){process.exit=function(r){if(i)D(r);else{const c=new Error("An extension called process.exit() and this was prevented.");console.warn(c.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let s=function(i){D()};function h(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,r)=>{let c=null,o=setTimeout(()=>{s("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const d=108e5,m=3e5,v=new g.ProcessTimeRunOnceScheduler(()=>s("renderer disconnected for too long (1)"),d),w=new g.ProcessTimeRunOnceScheduler(()=>s("renderer disconnected for too long (2)"),m);process.on("message",(M,T)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){T.setNoDelay(!0);const O=C.VSBuffer.wrap(Buffer.from(M.initialDataChunk,"base64"));let U;if(M.skipWebSocketFrames)U=new k.NodeSocket(T,"extHost-socket");else{const V=C.VSBuffer.wrap(Buffer.from(M.inflateBytes,"base64"));U=new k.WebSocketNodeSocket(new k.NodeSocket(T,"extHost-socket"),M.permessageDeflate,V,!1)}c?(v.cancel(),w.cancel(),c.beginAcceptReconnection(U,O),c.endAcceptReconnection(),c.sendResume()):(clearTimeout(o),c=new R.PersistentProtocol(U,O),c.sendResume(),c.onDidDispose(()=>s("renderer disconnected")),i(c),c.onSocketClose(()=>{v.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(w.isScheduled())return;v.isScheduled()&&w.schedule()}});const A={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(A)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,c)=>{const o=f.createConnection(i,()=>{o.removeListener("error",c),r(new R.PersistentProtocol(new k.NodeSocket(o,"extHost-renderer")))});o.once("error",c),o.on("close",()=>{s("renderer closed the socket")})})}}async function n(){const i=await h();return new class{constructor(){this._onMessage=new R.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(r=>{(0,P.isMessageOfType)(r,2)?(this._terminating=!0,s("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||i.send(r)}drain(){return i.drain()}}}function S(i){return new Promise(r=>{const c=i.onMessage(o=>{c.dispose();const d=JSON.parse(o.toString()),m=d.commit,v=y.default.commit;m&&v&&m!==v&&D(55);let w=0;setInterval(function(){try{process.kill(d.parentPid,0),w=0}catch(M){M&&M.code==="EPERM"?(w++,w>=3&&s(`parent process ${d.parentPid} does not exist anymore (3 x EPERM): ${M.message} (code: ${M.code}) (errno: ${M.errno})`)):s(`parent process ${d.parentPid} does not exist anymore: ${M.message} (code: ${M.code}) (errno: ${M.errno})`)}},1e3);let A;try{A=Z.__$__nodeRequire("native-watchdog"),A.start(d.parentPid)}catch(M){(0,_.onUnexpectedError)(M)}i.send((0,P.createMessageOfType)(0)),r({protocol:i,initData:d})});i.send((0,P.createMessageOfType)(1))})}async function a(){const i=[];process.on("unhandledRejection",(w,A)=>{i.push(A),setTimeout(()=>{const M=i.indexOf(A);M>=0&&A.catch(T=>{i.splice(M,1),(0,_.isCancellationError)(T)||(console.warn(`rejected promise not handled within 1 second: ${T}`),T&&T.stack&&console.warn(`stack trace: ${T.stack}`),w&&(0,_.onUnexpectedError)(w))})},1e3)}),process.on("rejectionHandled",w=>{const A=i.indexOf(w);A>=0&&i.splice(A,1)}),process.on("uncaughtException",function(w){(0,_.onUnexpectedError)(w)}),I.mark("code/extHost/willConnectToRenderer");const r=await n();I.mark("code/extHost/didConnectToRenderer");const c=await S(r);I.mark("code/extHost/didWaitForInitData");const{initData:o}=c;u(!!o.environment.extensionTestsLocationURI),o.environment.useHostProxy=!!F.useHostProxy,o.environment.skipWorkspaceStorageLock=(0,E.boolean)(F.skipWorkspaceStorageLock,!1);const d=new class{constructor(){this.pid=process.pid}exit(A){D(A)}exists(A){return b.Promises.exists(A)}realpath(A){return(0,p.realpath)(A)}};let m=null;if(o.remote.authority&&F.uriTransformerPath)try{const A=Z.__$__nodeRequire(F.uriTransformerPath)(o.remote.authority);m=new l.URITransformer(A)}catch(w){console.error(w)}const v=new L.ExtensionHostMain(c.protocol,o,d,m);s=w=>v.terminate(w)}e.startExtensionHostProcess=a}),define(pe[301],ve([0,1,290]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.startExtensionHostProcess)().catch(t=>console.log(t))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/865a677399f0c0a1e98e0b9eb7308f1297b6ace4/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
