/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["require","exports","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/base/common/platform","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/extpath","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/codicons","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/languages/languageSelector","vs/editor/common/languages","vs/editor/common/core/range","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/base/common/hash","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/model","vs/editor/common/languages/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsDragAndDropService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/core/position","vs/base/common/lazy","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/services/extensions/worker/extensionHostWorker"],Se=function(Z){for(var e=[],r=0,t=Z.length;r<t;r++)e[r]=ye[Z[r]];return e};define(ye[42],Se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function r(t,S){if(!t)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=r}),define(ye[52],Se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function r(A){return A?A.replace(/\$\((.*?)\)/g,(I,D)=>` ${D} `).trim():""}e.getCodiconAriaLabel=r;class t{constructor(I,D,T){this.id=I,this.definition=D,this.description=T,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function S(A,I){const D=["codicon","codicon-"+A];return I&&D.push("codicon-modifier-"+I),D}e.getClassNamesArray=S;var P;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function D(b){if(b instanceof t)return["codicon","codicon-"+b.id];const i=I.exec(b.id);if(!i)return D(t.error);let[,h,l]=i;const o=["codicon","codicon-"+h];return l&&o.push("codicon-modifier-"+l.substr(1)),o}A.asClassNameArray=D;function T(b){return D(b).join(" ")}A.asClassName=T;function R(b){return"."+D(b).join(".")}A.asCSSSelector=R})(P=e.CSSIcon||(e.CSSIcon={}))}),define(ye[73],Se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const r=Object.prototype.hasOwnProperty;function t(R){const b=[];for(let i in R)r.call(R,i)&&b.push(R[i]);return b}e.values=t;function S(R,b){for(let i in R)if(r.call(R,i)&&b({key:i,value:R[i]},function(){delete R[i]})===!1)return}e.forEach=S;function P(R,b){const i=Object.create(null);for(const h of R){const l=b(h);let o=i[l];o||(o=i[l]=[]),o.push(h)}return i}e.groupBy=P;function A(R){const b=Object.create(null);return R&&R.forEach((i,h)=>{b[h]=i}),b}e.fromMap=A;function I(R,b){const i=[],h=[];for(let l of R)b.has(l)||i.push(l);for(let l of b)R.has(l)||h.push(l);return{removed:i,added:h}}e.diffSets=I;function D(R,b){const i=[],h=[];for(let[l,o]of R)b.has(l)||i.push(o);for(let[l,o]of b)R.has(l)||h.push(o);return{removed:i,added:h}}e.diffMaps=D;class T{constructor(){this.map=new Map}add(b,i){let h=this.map.get(b);h||(h=new Set,this.map.set(b,h)),h.add(i)}delete(b,i){const h=this.map.get(b);!h||(h.delete(i),h.size===0&&this.map.delete(b))}forEach(b,i){const h=this.map.get(b);!h||h.forEach(i)}}e.SetMap=T}),define(ye[53],Se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function r(A){return(I,D,T)=>{let R=null,b=null;if(typeof T.value=="function"?(R="value",b=T.value):typeof T.get=="function"&&(R="get",b=T.get),!b)throw new Error("not supported");T[R]=A(b,D)}}e.createDecorator=r;function t(A,I,D){let T=null,R=null;if(typeof D.value=="function"?(T="value",R=D.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(T="get",R=D.get),!R)throw new Error("not supported");const b=`$memoize$${I}`;D[T]=function(...i){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,i)}),this[b]}}e.memoize=t;function S(A,I,D){return r((T,R)=>{const b=`$debounce$${R}`,i=`$debounce$result$${R}`;return function(...h){this[i]||(this[i]=D?D():void 0),clearTimeout(this[b]),I&&(this[i]=I(this[i],...h),h=[this[i]]),this[b]=setTimeout(()=>{T.apply(this,h),this[i]=D?D():void 0},A)}})}e.debounce=S;function P(A,I,D){return r((T,R)=>{const b=`$throttle$timer$${R}`,i=`$throttle$result$${R}`,h=`$throttle$lastRun$${R}`,l=`$throttle$pending$${R}`;return function(...o){if(this[i]||(this[i]=D?D():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),I&&(this[i]=I(this[i],...o)),this[l])return;const m=this[h]+A;m<=Date.now()?(this[h]=Date.now(),T.apply(this,[this[i]]),this[i]=D?D():void 0):(this[l]=!0,this[b]=setTimeout(()=>{this[l]=!1,this[h]=Date.now(),T.apply(this,[this[i]]),this[i]=D?D():void 0},m-Date.now()))}})}e.throttle=P}),define(ye[54],Se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class r{constructor(S){this._prefix=S,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=r,e.defaultGenerator=new r("id#")}),define(ye[99],Se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var r;(function(a){a[a.None=0]="None",a[a.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=2]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",a[a.InvalidUnicode=4]="InvalidUnicode",a[a.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",a[a.InvalidCharacter=6]="InvalidCharacter"})(r=e.ScanError||(e.ScanError={}));var t;(function(a){a[a.OpenBraceToken=1]="OpenBraceToken",a[a.CloseBraceToken=2]="CloseBraceToken",a[a.OpenBracketToken=3]="OpenBracketToken",a[a.CloseBracketToken=4]="CloseBracketToken",a[a.CommaToken=5]="CommaToken",a[a.ColonToken=6]="ColonToken",a[a.NullKeyword=7]="NullKeyword",a[a.TrueKeyword=8]="TrueKeyword",a[a.FalseKeyword=9]="FalseKeyword",a[a.StringLiteral=10]="StringLiteral",a[a.NumericLiteral=11]="NumericLiteral",a[a.LineCommentTrivia=12]="LineCommentTrivia",a[a.BlockCommentTrivia=13]="BlockCommentTrivia",a[a.LineBreakTrivia=14]="LineBreakTrivia",a[a.Trivia=15]="Trivia",a[a.Unknown=16]="Unknown",a[a.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var S;(function(a){a[a.InvalidSymbol=1]="InvalidSymbol",a[a.InvalidNumberFormat=2]="InvalidNumberFormat",a[a.PropertyNameExpected=3]="PropertyNameExpected",a[a.ValueExpected=4]="ValueExpected",a[a.ColonExpected=5]="ColonExpected",a[a.CommaExpected=6]="CommaExpected",a[a.CloseBraceExpected=7]="CloseBraceExpected",a[a.CloseBracketExpected=8]="CloseBracketExpected",a[a.EndOfFileExpected=9]="EndOfFileExpected",a[a.InvalidCommentToken=10]="InvalidCommentToken",a[a.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=12]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",a[a.InvalidUnicode=14]="InvalidUnicode",a[a.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",a[a.InvalidCharacter=16]="InvalidCharacter"})(S=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(a){a.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function A(a,F=!1){let c=0,n=a.length,f="",g=0,s=16,d=0;function p(U){let q=0,H=0;for(;q<U;){const z=a.charCodeAt(c);if(z>=48&&z<=57)H=H*16+z-48;else if(z>=65&&z<=70)H=H*16+z-65+10;else if(z>=97&&z<=102)H=H*16+z-97+10;else break;c++,q++}return q<U&&(H=-1),H}function E(U){c=U,f="",g=0,s=16,d=0}function v(){const U=c;if(a.charCodeAt(c)===48)c++;else for(c++;c<a.length&&T(a.charCodeAt(c));)c++;if(c<a.length&&a.charCodeAt(c)===46)if(c++,c<a.length&&T(a.charCodeAt(c)))for(c++;c<a.length&&T(a.charCodeAt(c));)c++;else return d=3,a.substring(U,c);let q=c;if(c<a.length&&(a.charCodeAt(c)===69||a.charCodeAt(c)===101))if(c++,(c<a.length&&a.charCodeAt(c)===43||a.charCodeAt(c)===45)&&c++,c<a.length&&T(a.charCodeAt(c))){for(c++;c<a.length&&T(a.charCodeAt(c));)c++;q=c}else d=3;return a.substring(U,q)}function k(){let U="",q=c;for(;;){if(c>=n){U+=a.substring(q,c),d=2;break}const H=a.charCodeAt(c);if(H===34){U+=a.substring(q,c),c++;break}if(H===92){if(U+=a.substring(q,c),c++,c>=n){d=2;break}switch(a.charCodeAt(c++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const j=p(4);j>=0?U+=String.fromCharCode(j):d=4;break}default:d=5}q=c;continue}if(H>=0&&H<=31)if(D(H)){U+=a.substring(q,c),d=2;break}else d=6;c++}return U}function L(){if(f="",d=0,g=c,c>=n)return g=n,s=17;let U=a.charCodeAt(c);if(I(U)){do c++,f+=String.fromCharCode(U),U=a.charCodeAt(c);while(I(U));return s=15}if(D(U))return c++,f+=String.fromCharCode(U),U===13&&a.charCodeAt(c)===10&&(c++,f+=`
`),s=14;switch(U){case 123:return c++,s=1;case 125:return c++,s=2;case 91:return c++,s=3;case 93:return c++,s=4;case 58:return c++,s=6;case 44:return c++,s=5;case 34:return c++,f=k(),s=10;case 47:{const q=c-1;if(a.charCodeAt(c+1)===47){for(c+=2;c<n&&!D(a.charCodeAt(c));)c++;return f=a.substring(q,c),s=12}if(a.charCodeAt(c+1)===42){c+=2;const H=n-1;let z=!1;for(;c<H;){if(a.charCodeAt(c)===42&&a.charCodeAt(c+1)===47){c+=2,z=!0;break}c++}return z||(c++,d=1),f=a.substring(q,c),s=13}return f+=String.fromCharCode(U),c++,s=16}case 45:if(f+=String.fromCharCode(U),c++,c===n||!T(a.charCodeAt(c)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return f+=v(),s=11;default:for(;c<n&&y(U);)c++,U=a.charCodeAt(c);if(g!==c){switch(f=a.substring(g,c),f){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return f+=String.fromCharCode(U),c++,s=16}}function y(U){if(I(U)||D(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function O(){let U;do U=L();while(U>=12&&U<=15);return U}return{setPosition:E,getPosition:()=>c,scan:F?O:L,getToken:()=>s,getTokenValue:()=>f,getTokenOffset:()=>g,getTokenLength:()=>c-g,getTokenError:()=>d}}e.createScanner=A;function I(a){return a===32||a===9||a===11||a===12||a===160||a===5760||a>=8192&&a<=8203||a===8239||a===8287||a===12288||a===65279}function D(a){return a===10||a===13||a===8232||a===8233}function T(a){return a>=48&&a<=57}var R;(function(a){a[a.nullCharacter=0]="nullCharacter",a[a.maxAsciiCharacter=127]="maxAsciiCharacter",a[a.lineFeed=10]="lineFeed",a[a.carriageReturn=13]="carriageReturn",a[a.lineSeparator=8232]="lineSeparator",a[a.paragraphSeparator=8233]="paragraphSeparator",a[a.nextLine=133]="nextLine",a[a.space=32]="space",a[a.nonBreakingSpace=160]="nonBreakingSpace",a[a.enQuad=8192]="enQuad",a[a.emQuad=8193]="emQuad",a[a.enSpace=8194]="enSpace",a[a.emSpace=8195]="emSpace",a[a.threePerEmSpace=8196]="threePerEmSpace",a[a.fourPerEmSpace=8197]="fourPerEmSpace",a[a.sixPerEmSpace=8198]="sixPerEmSpace",a[a.figureSpace=8199]="figureSpace",a[a.punctuationSpace=8200]="punctuationSpace",a[a.thinSpace=8201]="thinSpace",a[a.hairSpace=8202]="hairSpace",a[a.zeroWidthSpace=8203]="zeroWidthSpace",a[a.narrowNoBreakSpace=8239]="narrowNoBreakSpace",a[a.ideographicSpace=12288]="ideographicSpace",a[a.mathematicalSpace=8287]="mathematicalSpace",a[a.ogham=5760]="ogham",a[a._=95]="_",a[a.$=36]="$",a[a._0=48]="_0",a[a._1=49]="_1",a[a._2=50]="_2",a[a._3=51]="_3",a[a._4=52]="_4",a[a._5=53]="_5",a[a._6=54]="_6",a[a._7=55]="_7",a[a._8=56]="_8",a[a._9=57]="_9",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.ampersand=38]="ampersand",a[a.asterisk=42]="asterisk",a[a.at=64]="at",a[a.backslash=92]="backslash",a[a.bar=124]="bar",a[a.caret=94]="caret",a[a.closeBrace=125]="closeBrace",a[a.closeBracket=93]="closeBracket",a[a.closeParen=41]="closeParen",a[a.colon=58]="colon",a[a.comma=44]="comma",a[a.dot=46]="dot",a[a.doubleQuote=34]="doubleQuote",a[a.equals=61]="equals",a[a.exclamation=33]="exclamation",a[a.greaterThan=62]="greaterThan",a[a.lessThan=60]="lessThan",a[a.minus=45]="minus",a[a.openBrace=123]="openBrace",a[a.openBracket=91]="openBracket",a[a.openParen=40]="openParen",a[a.percent=37]="percent",a[a.plus=43]="plus",a[a.question=63]="question",a[a.semicolon=59]="semicolon",a[a.singleQuote=39]="singleQuote",a[a.slash=47]="slash",a[a.tilde=126]="tilde",a[a.backspace=8]="backspace",a[a.formFeed=12]="formFeed",a[a.byteOrderMark=65279]="byteOrderMark",a[a.tab=9]="tab",a[a.verticalTab=11]="verticalTab"})(R||(R={}));function b(a,F){const c=[],n=new Object;let f;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function d(p,E,v,k){g.value=p,g.offset=E,g.length=v,g.type=k,g.colonOffset=void 0,f=g}try{w(a,{onObjectBegin:(p,E)=>{if(F<=p)throw n;f=void 0,s=F>p,c.push("")},onObjectProperty:(p,E,v)=>{if(F<E||(d(p,E,v,"property"),c[c.length-1]=p,F<=E+v))throw n},onObjectEnd:(p,E)=>{if(F<=p)throw n;f=void 0,c.pop()},onArrayBegin:(p,E)=>{if(F<=p)throw n;f=void 0,c.push(0)},onArrayEnd:(p,E)=>{if(F<=p)throw n;f=void 0,c.pop()},onLiteralValue:(p,E,v)=>{if(F<E||(d(p,E,v,_(p)),F<=E+v))throw n},onSeparator:(p,E,v)=>{if(F<=E)throw n;if(p===":"&&f&&f.type==="property")f.colonOffset=E,s=!1,f=void 0;else if(p===","){const k=c[c.length-1];typeof k=="number"?c[c.length-1]=k+1:(s=!0,c[c.length-1]=""),f=void 0}}})}catch(p){if(p!==n)throw p}return{path:c,previousNode:f,isAtPropertyKey:s,matches:p=>{let E=0;for(let v=0;E<p.length&&v<c.length;v++)if(p[E]===c[v]||p[E]==="*")E++;else if(p[E]!=="**")return!1;return E===p.length}}}e.getLocation=b;function i(a,F=[],c=P.DEFAULT){let n=null,f=[];const g=[];function s(p){Array.isArray(f)?f.push(p):n!==null&&(f[n]=p)}return w(a,{onObjectBegin:()=>{const p={};s(p),g.push(f),f=p,n=null},onObjectProperty:p=>{n=p},onObjectEnd:()=>{f=g.pop()},onArrayBegin:()=>{const p=[];s(p),g.push(f),f=p,n=null},onArrayEnd:()=>{f=g.pop()},onLiteralValue:s,onError:(p,E,v)=>{F.push({error:p,offset:E,length:v})}},c),f[0]}e.parse=i;function h(a,F=[],c=P.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function f(p){n.type==="property"&&(n.length=p-n.offset,n=n.parent)}function g(p){return n.children.push(p),p}w(a,{onObjectBegin:p=>{n=g({type:"object",offset:p,length:-1,parent:n,children:[]})},onObjectProperty:(p,E,v)=>{n=g({type:"property",offset:E,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:p,offset:E,length:v,parent:n})},onObjectEnd:(p,E)=>{n.length=p+E-n.offset,n=n.parent,f(p+E)},onArrayBegin:(p,E)=>{n=g({type:"array",offset:p,length:-1,parent:n,children:[]})},onArrayEnd:(p,E)=>{n.length=p+E-n.offset,n=n.parent,f(p+E)},onLiteralValue:(p,E,v)=>{g({type:_(p),offset:E,length:v,parent:n,value:p}),f(E+v)},onSeparator:(p,E,v)=>{n.type==="property"&&(p===":"?n.colonOffset=E:p===","&&f(E))},onError:(p,E,v)=>{F.push({error:p,offset:E,length:v})}},c);const d=n.children[0];return d&&delete d.parent,d}e.parseTree=h;function l(a,F){if(!a)return;let c=a;for(let n of F)if(typeof n=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let f=!1;for(const g of c.children)if(Array.isArray(g.children)&&g.children[0].value===n){c=g.children[1],f=!0;break}if(!f)return}else{const f=n;if(c.type!=="array"||f<0||!Array.isArray(c.children)||f>=c.children.length)return;c=c.children[f]}return c}e.findNodeAtLocation=l;function o(a){if(!a.parent||!a.parent.children)return[];const F=o(a.parent);if(a.parent.type==="property"){const c=a.parent.children[0].value;F.push(c)}else if(a.parent.type==="array"){const c=a.parent.children.indexOf(a);c!==-1&&F.push(c)}return F}e.getNodePath=o;function m(a){switch(a.type){case"array":return a.children.map(m);case"object":{const F=Object.create(null);for(let c of a.children){const n=c.children[1];n&&(F[c.children[0].value]=m(n))}return F}case"null":case"string":case"number":case"boolean":return a.value;default:return}}e.getNodeValue=m;function M(a,F,c=!1){return F>=a.offset&&F<a.offset+a.length||c&&F===a.offset+a.length}e.contains=M;function C(a,F,c=!1){if(M(a,F,c)){const n=a.children;if(Array.isArray(n))for(let f=0;f<n.length&&n[f].offset<=F;f++){const g=C(n[f],F,c);if(g)return g}return a}}e.findNodeAtOffset=C;function w(a,F,c=P.DEFAULT){const n=A(a,!1);function f(pe){return pe?()=>pe(n.getTokenOffset(),n.getTokenLength()):()=>!0}function g(pe){return pe?me=>pe(me,n.getTokenOffset(),n.getTokenLength()):()=>!0}const s=f(F.onObjectBegin),d=g(F.onObjectProperty),p=f(F.onObjectEnd),E=f(F.onArrayBegin),v=f(F.onArrayEnd),k=g(F.onLiteralValue),L=g(F.onSeparator),y=f(F.onComment),O=g(F.onError),U=c&&c.disallowComments,q=c&&c.allowTrailingComma;function H(){for(;;){const pe=n.scan();switch(n.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:U||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(pe){case 12:case 13:U?z(10):y();break;case 16:z(1);break;case 15:case 14:break;default:return pe}}}function z(pe,me=[],oe=[]){if(O(pe),me.length+oe.length>0){let Ee=n.getToken();for(;Ee!==17;){if(me.indexOf(Ee)!==-1){H();break}else if(oe.indexOf(Ee)!==-1)break;Ee=H()}}}function j(pe){const me=n.getTokenValue();return pe?k(me):d(me),H(),!0}function ie(){switch(n.getToken()){case 11:{let pe=0;try{pe=JSON.parse(n.getTokenValue()),typeof pe!="number"&&(z(2),pe=0)}catch{z(2)}k(pe);break}case 7:k(null);break;case 8:k(!0);break;case 9:k(!1);break;default:return!1}return H(),!0}function ae(){return n.getToken()!==10?(z(3,[],[2,5]),!1):(j(!1),n.getToken()===6?(L(":"),H(),be()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function te(){s(),H();let pe=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(pe||z(4,[],[]),L(","),H(),n.getToken()===2&&q)break}else pe&&z(6,[],[]);ae()||z(4,[],[2,5]),pe=!0}return p(),n.getToken()!==2?z(7,[2],[]):H(),!0}function ue(){E(),H();let pe=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(pe||z(4,[],[]),L(","),H(),n.getToken()===4&&q)break}else pe&&z(6,[],[]);be()||z(4,[],[4,5]),pe=!0}return v(),n.getToken()!==4?z(8,[4],[]):H(),!0}function be(){switch(n.getToken()){case 3:return ue();case 1:return te();case 10:return j(!0);default:return ie()}}return H(),n.getToken()===17?c.allowEmptyContent?!0:(z(4,[],[]),!1):be()?(n.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=w;function u(a,F){let c=A(a),n=[],f,g=0,s;do switch(s=c.getPosition(),f=c.scan(),f){case 12:case 13:case 17:g!==s&&n.push(a.substring(g,s)),F!==void 0&&n.push(c.getTokenValue().replace(/[^\r\n]/g,F)),g=c.getPosition();break}while(f!==17);return n.join("")}e.stripComments=u;function _(a){switch(typeof a){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(a){if(Array.isArray(a))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=_}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,Z.marked=e())}(this,function(){"use strict";function Z(Ae,De){for(var ve=0;ve<De.length;ve++){var ee=De[ve];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(Ae,ee.key,ee)}}function e(Ae,De,ve){return De&&Z(Ae.prototype,De),ve&&Z(Ae,ve),Ae}function r(Ae,De){if(!!Ae){if(typeof Ae=="string")return t(Ae,De);var ve=Object.prototype.toString.call(Ae).slice(8,-1);if(ve==="Object"&&Ae.constructor&&(ve=Ae.constructor.name),ve==="Map"||ve==="Set")return Array.from(Ae);if(ve==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ve))return t(Ae,De)}}function t(Ae,De){(De==null||De>Ae.length)&&(De=Ae.length);for(var ve=0,ee=new Array(De);ve<De;ve++)ee[ve]=Ae[ve];return ee}function S(Ae,De){var ve=typeof Symbol!="undefined"&&Ae[Symbol.iterator]||Ae["@@iterator"];if(ve)return(ve=ve.call(Ae)).next.bind(ve);if(Array.isArray(Ae)||(ve=r(Ae))||De&&Ae&&typeof Ae.length=="number"){ve&&(Ae=ve);var ee=0;return function(){return ee>=Ae.length?{done:!0}:{done:!1,value:Ae[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var P={exports:{}};function A(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function I(Ae){P.exports.defaults=Ae}P.exports={defaults:A(),getDefaults:A,changeDefaults:I};var D=/[&<>"']/,T=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,b=/[<>"']|&(?!#?\w+;)/g,i={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(De){return i[De]};function l(Ae,De){if(De){if(D.test(Ae))return Ae.replace(T,h)}else if(R.test(Ae))return Ae.replace(b,h);return Ae}var o=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(Ae){return Ae.replace(o,function(De,ve){return ve=ve.toLowerCase(),ve==="colon"?":":ve.charAt(0)==="#"?ve.charAt(1)==="x"?String.fromCharCode(parseInt(ve.substring(2),16)):String.fromCharCode(+ve.substring(1)):""})}var M=/(^|[^\[])\^/g;function C(Ae,De){Ae=Ae.source||Ae,De=De||"";var ve={replace:function(ne,de){return de=de.source||de,de=de.replace(M,"$1"),Ae=Ae.replace(ne,de),ve},getRegex:function(){return new RegExp(Ae,De)}};return ve}var w=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function _(Ae,De,ve){if(Ae){var ee;try{ee=decodeURIComponent(m(ve)).replace(w,"").toLowerCase()}catch{return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}De&&!u.test(ve)&&(ve=f(De,ve));try{ve=encodeURI(ve).replace(/%25/g,"%")}catch{return null}return ve}var a={},F=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function f(Ae,De){a[" "+Ae]||(F.test(Ae)?a[" "+Ae]=Ae+"/":a[" "+Ae]=p(Ae,"/",!0)),Ae=a[" "+Ae];var ve=Ae.indexOf(":")===-1;return De.substring(0,2)==="//"?ve?De:Ae.replace(c,"$1")+De:De.charAt(0)==="/"?ve?De:Ae.replace(n,"$1")+De:Ae+De}var g={exec:function(){}};function s(Ae){for(var De=1,ve,ee;De<arguments.length;De++){ve=arguments[De];for(ee in ve)Object.prototype.hasOwnProperty.call(ve,ee)&&(Ae[ee]=ve[ee])}return Ae}function d(Ae,De){var ve=Ae.replace(/\|/g,function(de,ge,Te){for(var ze=!1,Le=ge;--Le>=0&&Te[Le]==="\\";)ze=!ze;return ze?"|":" |"}),ee=ve.split(/ \|/),ne=0;if(ee[0].trim()||ee.shift(),ee[ee.length-1].trim()||ee.pop(),ee.length>De)ee.splice(De);else for(;ee.length<De;)ee.push("");for(;ne<ee.length;ne++)ee[ne]=ee[ne].trim().replace(/\\\|/g,"|");return ee}function p(Ae,De,ve){var ee=Ae.length;if(ee===0)return"";for(var ne=0;ne<ee;){var de=Ae.charAt(ee-ne-1);if(de===De&&!ve)ne++;else if(de!==De&&ve)ne++;else break}return Ae.substr(0,ee-ne)}function E(Ae,De){if(Ae.indexOf(De[1])===-1)return-1;for(var ve=Ae.length,ee=0,ne=0;ne<ve;ne++)if(Ae[ne]==="\\")ne++;else if(Ae[ne]===De[0])ee++;else if(Ae[ne]===De[1]&&(ee--,ee<0))return ne;return-1}function v(Ae){Ae&&Ae.sanitize&&!Ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function k(Ae,De){if(De<1)return"";for(var ve="";De>1;)De&1&&(ve+=Ae),De>>=1,Ae+=Ae;return ve+Ae}var L={escape:l,unescape:m,edit:C,cleanUrl:_,resolveUrl:f,noopTest:g,merge:s,splitCells:d,rtrim:p,findClosingBracket:E,checkSanitizeDeprecation:v,repeatString:k},y=P.exports.defaults,O=L.rtrim,U=L.splitCells,q=L.escape,H=L.findClosingBracket;function z(Ae,De,ve,ee){var ne=De.href,de=De.title?q(De.title):null,ge=Ae[1].replace(/\\([\[\]])/g,"$1");if(Ae[0].charAt(0)!=="!"){ee.state.inLink=!0;var Te={type:"link",raw:ve,href:ne,title:de,text:ge,tokens:ee.inlineTokens(ge,[])};return ee.state.inLink=!1,Te}else return{type:"image",raw:ve,href:ne,title:de,text:q(ge)}}function j(Ae,De){var ve=Ae.match(/^(\s+)(?:```)/);if(ve===null)return De;var ee=ve[1];return De.split(`
`).map(function(ne){var de=ne.match(/^\s+/);if(de===null)return ne;var ge=de[0];return ge.length>=ee.length?ne.slice(ee.length):ne}).join(`
`)}var ie=function(){function Ae(ve){this.options=ve||y}var De=Ae.prototype;return De.space=function(ee){var ne=this.rules.block.newline.exec(ee);if(ne)return ne[0].length>1?{type:"space",raw:ne[0]}:{raw:`
`}},De.code=function(ee){var ne=this.rules.block.code.exec(ee);if(ne){var de=ne[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ne[0],codeBlockStyle:"indented",text:this.options.pedantic?de:O(de,`
`)}}},De.fences=function(ee){var ne=this.rules.block.fences.exec(ee);if(ne){var de=ne[0],ge=j(de,ne[3]||"");return{type:"code",raw:de,lang:ne[2]?ne[2].trim():ne[2],text:ge}}},De.heading=function(ee){var ne=this.rules.block.heading.exec(ee);if(ne){var de=ne[2].trim();if(/#$/.test(de)){var ge=O(de,"#");(this.options.pedantic||!ge||/ $/.test(ge))&&(de=ge.trim())}var Te={type:"heading",raw:ne[0],depth:ne[1].length,text:de,tokens:[]};return this.lexer.inline(Te.text,Te.tokens),Te}},De.hr=function(ee){var ne=this.rules.block.hr.exec(ee);if(ne)return{type:"hr",raw:ne[0]}},De.blockquote=function(ee){var ne=this.rules.block.blockquote.exec(ee);if(ne){var de=ne[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ne[0],tokens:this.lexer.blockTokens(de,[]),text:de}}},De.list=function(ee){var ne=this.rules.block.list.exec(ee);if(ne){var de,ge,Te,ze,Le,Ge,ot,at,Ne,ce,fe=ne[1].trim(),re=fe.length>1,W={type:"list",raw:"",ordered:re,start:re?+fe.slice(0,-1):"",loose:!1,items:[]};fe=re?"\\d{1,9}\\"+fe.slice(-1):"\\"+fe,this.options.pedantic&&(fe=re?fe:"[*+-]");for(var we=new RegExp("^( {0,3}"+fe+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ee&&!(this.rules.block.hr.test(ee)||!(ne=we.exec(ee)));){Ne=ne[2].split(`
`),this.options.pedantic?(ze=2,ce=Ne[0].trimLeft()):(ze=ne[2].search(/[^ ]/),ze=ne[1].length+(ze>4?1:ze),ce=Ne[0].slice(ze-ne[1].length)),Ge=!1,de=ne[0],!Ne[0]&&/^ *$/.test(Ne[1])&&(de=ne[1]+Ne.slice(0,2).join(`
`)+`
`,W.loose=!0,Ne=[]);var Re=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Le=1;Le<Ne.length;Le++){if(at=Ne[Le],this.options.pedantic&&(at=at.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Re.test(at)){de=ne[1]+Ne.slice(0,Le).join(`
`)+`
`;break}if(!Ge){at.trim()||(Ge=!0),at.search(/[^ ]/)>=ze?ce+=`
`+at.slice(ze):ce+=`
`+at;continue}if(at.search(/[^ ]/)>=ze||!at.trim()){ce+=`
`+at.slice(ze);continue}else{de=ne[1]+Ne.slice(0,Le).join(`
`)+`
`;break}}W.loose||(ot?W.loose=!0:/\n *\n *$/.test(de)&&(ot=!0)),this.options.gfm&&(ge=/^\[[ xX]\] /.exec(ce),ge&&(Te=ge[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),W.items.push({type:"list_item",raw:de,task:!!ge,checked:Te,loose:!1,text:ce}),W.raw+=de,ee=ee.slice(de.length)}W.items[W.items.length-1].raw=de.trimRight(),W.items[W.items.length-1].text=ce.trimRight(),W.raw=W.raw.trimRight();var We=W.items.length;for(Le=0;Le<We;Le++)this.lexer.state.top=!1,W.items[Le].tokens=this.lexer.blockTokens(W.items[Le].text,[]),W.items[Le].tokens.some(function(He){return He.type==="space"})&&(W.loose=!0,W.items[Le].loose=!0);return W}},De.html=function(ee){var ne=this.rules.block.html.exec(ee);if(ne){var de={type:"html",raw:ne[0],pre:!this.options.sanitizer&&(ne[1]==="pre"||ne[1]==="script"||ne[1]==="style"),text:ne[0]};return this.options.sanitize&&(de.type="paragraph",de.text=this.options.sanitizer?this.options.sanitizer(ne[0]):q(ne[0]),de.tokens=[],this.lexer.inline(de.text,de.tokens)),de}},De.def=function(ee){var ne=this.rules.block.def.exec(ee);if(ne){ne[3]&&(ne[3]=ne[3].substring(1,ne[3].length-1));var de=ne[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:de,raw:ne[0],href:ne[2],title:ne[3]}}},De.table=function(ee){var ne=this.rules.block.table.exec(ee);if(ne){var de={type:"table",header:U(ne[1]).map(function(ot){return{text:ot}}),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[]};if(de.header.length===de.align.length){de.raw=ne[0];var ge=de.align.length,Te,ze,Le,Ge;for(Te=0;Te<ge;Te++)/^ *-+: *$/.test(de.align[Te])?de.align[Te]="right":/^ *:-+: *$/.test(de.align[Te])?de.align[Te]="center":/^ *:-+ *$/.test(de.align[Te])?de.align[Te]="left":de.align[Te]=null;for(ge=de.rows.length,Te=0;Te<ge;Te++)de.rows[Te]=U(de.rows[Te],de.header.length).map(function(ot){return{text:ot}});for(ge=de.header.length,ze=0;ze<ge;ze++)de.header[ze].tokens=[],this.lexer.inlineTokens(de.header[ze].text,de.header[ze].tokens);for(ge=de.rows.length,ze=0;ze<ge;ze++)for(Ge=de.rows[ze],Le=0;Le<Ge.length;Le++)Ge[Le].tokens=[],this.lexer.inlineTokens(Ge[Le].text,Ge[Le].tokens);return de}}},De.lheading=function(ee){var ne=this.rules.block.lheading.exec(ee);if(ne){var de={type:"heading",raw:ne[0],depth:ne[2].charAt(0)==="="?1:2,text:ne[1],tokens:[]};return this.lexer.inline(de.text,de.tokens),de}},De.paragraph=function(ee){var ne=this.rules.block.paragraph.exec(ee);if(ne){var de={type:"paragraph",raw:ne[0],text:ne[1].charAt(ne[1].length-1)===`
`?ne[1].slice(0,-1):ne[1],tokens:[]};return this.lexer.inline(de.text,de.tokens),de}},De.text=function(ee){var ne=this.rules.block.text.exec(ee);if(ne){var de={type:"text",raw:ne[0],text:ne[0],tokens:[]};return this.lexer.inline(de.text,de.tokens),de}},De.escape=function(ee){var ne=this.rules.inline.escape.exec(ee);if(ne)return{type:"escape",raw:ne[0],text:q(ne[1])}},De.tag=function(ee){var ne=this.rules.inline.tag.exec(ee);if(ne)return!this.lexer.state.inLink&&/^<a /i.test(ne[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ne[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ne[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ne[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ne[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):q(ne[0]):ne[0]}},De.link=function(ee){var ne=this.rules.inline.link.exec(ee);if(ne){var de=ne[2].trim();if(!this.options.pedantic&&/^</.test(de)){if(!/>$/.test(de))return;var ge=O(de.slice(0,-1),"\\");if((de.length-ge.length)%2==0)return}else{var Te=H(ne[2],"()");if(Te>-1){var ze=ne[0].indexOf("!")===0?5:4,Le=ze+ne[1].length+Te;ne[2]=ne[2].substring(0,Te),ne[0]=ne[0].substring(0,Le).trim(),ne[3]=""}}var Ge=ne[2],ot="";if(this.options.pedantic){var at=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ge);at&&(Ge=at[1],ot=at[3])}else ot=ne[3]?ne[3].slice(1,-1):"";return Ge=Ge.trim(),/^</.test(Ge)&&(this.options.pedantic&&!/>$/.test(de)?Ge=Ge.slice(1):Ge=Ge.slice(1,-1)),z(ne,{href:Ge&&Ge.replace(this.rules.inline._escapes,"$1"),title:ot&&ot.replace(this.rules.inline._escapes,"$1")},ne[0],this.lexer)}},De.reflink=function(ee,ne){var de;if((de=this.rules.inline.reflink.exec(ee))||(de=this.rules.inline.nolink.exec(ee))){var ge=(de[2]||de[1]).replace(/\s+/g," ");if(ge=ne[ge.toLowerCase()],!ge||!ge.href){var Te=de[0].charAt(0);return{type:"text",raw:Te,text:Te}}return z(de,ge,de[0],this.lexer)}},De.emStrong=function(ee,ne,de){de===void 0&&(de="");var ge=this.rules.inline.emStrong.lDelim.exec(ee);if(!!ge&&!(ge[3]&&de.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Te=ge[1]||ge[2]||"";if(!Te||Te&&(de===""||this.rules.inline.punctuation.exec(de))){var ze=ge[0].length-1,Le,Ge,ot=ze,at=0,Ne=ge[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ne.lastIndex=0,ne=ne.slice(-1*ee.length+ze);(ge=Ne.exec(ne))!=null;)if(Le=ge[1]||ge[2]||ge[3]||ge[4]||ge[5]||ge[6],!!Le){if(Ge=Le.length,ge[3]||ge[4]){ot+=Ge;continue}else if((ge[5]||ge[6])&&ze%3&&!((ze+Ge)%3)){at+=Ge;continue}if(ot-=Ge,!(ot>0)){if(Ge=Math.min(Ge,Ge+ot+at),Math.min(ze,Ge)%2){var ce=ee.slice(1,ze+ge.index+Ge);return{type:"em",raw:ee.slice(0,ze+ge.index+Ge+1),text:ce,tokens:this.lexer.inlineTokens(ce,[])}}var fe=ee.slice(2,ze+ge.index+Ge-1);return{type:"strong",raw:ee.slice(0,ze+ge.index+Ge+1),text:fe,tokens:this.lexer.inlineTokens(fe,[])}}}}}},De.codespan=function(ee){var ne=this.rules.inline.code.exec(ee);if(ne){var de=ne[2].replace(/\n/g," "),ge=/[^ ]/.test(de),Te=/^ /.test(de)&&/ $/.test(de);return ge&&Te&&(de=de.substring(1,de.length-1)),de=q(de,!0),{type:"codespan",raw:ne[0],text:de}}},De.br=function(ee){var ne=this.rules.inline.br.exec(ee);if(ne)return{type:"br",raw:ne[0]}},De.del=function(ee){var ne=this.rules.inline.del.exec(ee);if(ne)return{type:"del",raw:ne[0],text:ne[2],tokens:this.lexer.inlineTokens(ne[2],[])}},De.autolink=function(ee,ne){var de=this.rules.inline.autolink.exec(ee);if(de){var ge,Te;return de[2]==="@"?(ge=q(this.options.mangle?ne(de[1]):de[1]),Te="mailto:"+ge):(ge=q(de[1]),Te=ge),{type:"link",raw:de[0],text:ge,href:Te,tokens:[{type:"text",raw:ge,text:ge}]}}},De.url=function(ee,ne){var de;if(de=this.rules.inline.url.exec(ee)){var ge,Te;if(de[2]==="@")ge=q(this.options.mangle?ne(de[0]):de[0]),Te="mailto:"+ge;else{var ze;do ze=de[0],de[0]=this.rules.inline._backpedal.exec(de[0])[0];while(ze!==de[0]);ge=q(de[0]),de[1]==="www."?Te="http://"+ge:Te=ge}return{type:"link",raw:de[0],text:ge,href:Te,tokens:[{type:"text",raw:ge,text:ge}]}}},De.inlineText=function(ee,ne){var de=this.rules.inline.text.exec(ee);if(de){var ge;return this.lexer.state.inRawBlock?ge=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):q(de[0]):de[0]:ge=q(this.options.smartypants?ne(de[0]):de[0]),{type:"text",raw:de[0],text:ge}}},Ae}(),ae=L.noopTest,te=L.edit,ue=L.merge,be={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:ae,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};be._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,be._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,be.def=te(be.def).replace("label",be._label).replace("title",be._title).getRegex(),be.bullet=/(?:[*+-]|\d{1,9}[.)])/,be.listItemStart=te(/^( *)(bull) */).replace("bull",be.bullet).getRegex(),be.list=te(be.list).replace(/bull/g,be.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+be.def.source+")").getRegex(),be._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",be._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,be.html=te(be.html,"i").replace("comment",be._comment).replace("tag",be._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),be.paragraph=te(be._paragraph).replace("hr",be.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",be._tag).getRegex(),be.blockquote=te(be.blockquote).replace("paragraph",be.paragraph).getRegex(),be.normal=ue({},be),be.gfm=ue({},be.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),be.gfm.table=te(be.gfm.table).replace("hr",be.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",be._tag).getRegex(),be.pedantic=ue({},be.normal,{html:te(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",be._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:ae,paragraph:te(be.normal._paragraph).replace("hr",be.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",be.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var pe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:ae,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:ae,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};pe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",pe.punctuation=te(pe.punctuation).replace(/punctuation/g,pe._punctuation).getRegex(),pe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,pe.escapedEmSt=/\\\*|\\_/g,pe._comment=te(be._comment).replace("(?:-->|$)","-->").getRegex(),pe.emStrong.lDelim=te(pe.emStrong.lDelim).replace(/punct/g,pe._punctuation).getRegex(),pe.emStrong.rDelimAst=te(pe.emStrong.rDelimAst,"g").replace(/punct/g,pe._punctuation).getRegex(),pe.emStrong.rDelimUnd=te(pe.emStrong.rDelimUnd,"g").replace(/punct/g,pe._punctuation).getRegex(),pe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,pe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,pe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,pe.autolink=te(pe.autolink).replace("scheme",pe._scheme).replace("email",pe._email).getRegex(),pe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,pe.tag=te(pe.tag).replace("comment",pe._comment).replace("attribute",pe._attribute).getRegex(),pe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,pe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,pe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,pe.link=te(pe.link).replace("label",pe._label).replace("href",pe._href).replace("title",pe._title).getRegex(),pe.reflink=te(pe.reflink).replace("label",pe._label).getRegex(),pe.reflinkSearch=te(pe.reflinkSearch,"g").replace("reflink",pe.reflink).replace("nolink",pe.nolink).getRegex(),pe.normal=ue({},pe),pe.pedantic=ue({},pe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:te(/^!?\[(label)\]\((.*?)\)/).replace("label",pe._label).getRegex(),reflink:te(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",pe._label).getRegex()}),pe.gfm=ue({},pe.normal,{escape:te(pe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),pe.gfm.url=te(pe.gfm.url,"i").replace("email",pe.gfm._extended_email).getRegex(),pe.breaks=ue({},pe.gfm,{br:te(pe.br).replace("{2,}","*").getRegex(),text:te(pe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var me={block:be,inline:pe},oe=ie,Ee=P.exports.defaults,Pe=me.block,Oe=me.inline,je=L.repeatString;function st(Ae){return Ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function et(Ae){var De="",ve,ee,ne=Ae.length;for(ve=0;ve<ne;ve++)ee=Ae.charCodeAt(ve),Math.random()>.5&&(ee="x"+ee.toString(16)),De+="&#"+ee+";";return De}var tt=function(){function Ae(ve){this.tokens=[],this.tokens.links=Object.create(null),this.options=ve||Ee,this.options.tokenizer=this.options.tokenizer||new oe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:Pe.normal,inline:Oe.normal};this.options.pedantic?(ee.block=Pe.pedantic,ee.inline=Oe.pedantic):this.options.gfm&&(ee.block=Pe.gfm,this.options.breaks?ee.inline=Oe.breaks:ee.inline=Oe.gfm),this.tokenizer.rules=ee}Ae.lex=function(ee,ne){var de=new Ae(ne);return de.lex(ee)},Ae.lexInline=function(ee,ne){var de=new Ae(ne);return de.inlineTokens(ee)};var De=Ae.prototype;return De.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ee,this.tokens);for(var ne;ne=this.inlineQueue.shift();)this.inlineTokens(ne.src,ne.tokens);return this.tokens},De.blockTokens=function(ee,ne){var de=this;ne===void 0&&(ne=[]),this.options.pedantic&&(ee=ee.replace(/^ +$/gm,""));for(var ge,Te,ze,Le;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ot){return(ge=ot.call({lexer:de},ee,ne))?(ee=ee.substring(ge.raw.length),ne.push(ge),!0):!1}))){if(ge=this.tokenizer.space(ee)){ee=ee.substring(ge.raw.length),ge.type&&ne.push(ge);continue}if(ge=this.tokenizer.code(ee)){ee=ee.substring(ge.raw.length),Te=ne[ne.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+ge.raw,Te.text+=`
`+ge.text,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):ne.push(ge);continue}if(ge=this.tokenizer.fences(ee)){ee=ee.substring(ge.raw.length),ne.push(ge);continue}if(ge=this.tokenizer.heading(ee)){ee=ee.substring(ge.raw.length),ne.push(ge);continue}if(ge=this.tokenizer.hr(ee)){ee=ee.substring(ge.raw.length),ne.push(ge);continue}if(ge=this.tokenizer.blockquote(ee)){ee=ee.substring(ge.raw.length),ne.push(ge);continue}if(ge=this.tokenizer.list(ee)){ee=ee.substring(ge.raw.length),ne.push(ge);continue}if(ge=this.tokenizer.html(ee)){ee=ee.substring(ge.raw.length),ne.push(ge);continue}if(ge=this.tokenizer.def(ee)){ee=ee.substring(ge.raw.length),Te=ne[ne.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+ge.raw,Te.text+=`
`+ge.raw,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):this.tokens.links[ge.tag]||(this.tokens.links[ge.tag]={href:ge.href,title:ge.title});continue}if(ge=this.tokenizer.table(ee)){ee=ee.substring(ge.raw.length),ne.push(ge);continue}if(ge=this.tokenizer.lheading(ee)){ee=ee.substring(ge.raw.length),ne.push(ge);continue}if(ze=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var ot=1/0,at=ee.slice(1),Ne=void 0;de.options.extensions.startBlock.forEach(function(ce){Ne=ce.call({lexer:this},at),typeof Ne=="number"&&Ne>=0&&(ot=Math.min(ot,Ne))}),ot<1/0&&ot>=0&&(ze=ee.substring(0,ot+1))}(),this.state.top&&(ge=this.tokenizer.paragraph(ze))){Te=ne[ne.length-1],Le&&Te.type==="paragraph"?(Te.raw+=`
`+ge.raw,Te.text+=`
`+ge.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):ne.push(ge),Le=ze.length!==ee.length,ee=ee.substring(ge.raw.length);continue}if(ge=this.tokenizer.text(ee)){ee=ee.substring(ge.raw.length),Te=ne[ne.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+ge.raw,Te.text+=`
`+ge.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):ne.push(ge);continue}if(ee){var Ge="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(Ge);break}else throw new Error(Ge)}}return this.state.top=!0,ne},De.inline=function(ee,ne){this.inlineQueue.push({src:ee,tokens:ne})},De.inlineTokens=function(ee,ne){var de=this;ne===void 0&&(ne=[]);var ge,Te,ze,Le=ee,Ge,ot,at;if(this.tokens.links){var Ne=Object.keys(this.tokens.links);if(Ne.length>0)for(;(Ge=this.tokenizer.rules.inline.reflinkSearch.exec(Le))!=null;)Ne.includes(Ge[0].slice(Ge[0].lastIndexOf("[")+1,-1))&&(Le=Le.slice(0,Ge.index)+"["+je("a",Ge[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ge=this.tokenizer.rules.inline.blockSkip.exec(Le))!=null;)Le=Le.slice(0,Ge.index)+"["+je("a",Ge[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ge=this.tokenizer.rules.inline.escapedEmSt.exec(Le))!=null;)Le=Le.slice(0,Ge.index)+"++"+Le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(ot||(at=""),ot=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(fe){return(ge=fe.call({lexer:de},ee,ne))?(ee=ee.substring(ge.raw.length),ne.push(ge),!0):!1}))){if(ge=this.tokenizer.escape(ee)){ee=ee.substring(ge.raw.length),ne.push(ge);continue}if(ge=this.tokenizer.tag(ee)){ee=ee.substring(ge.raw.length),Te=ne[ne.length-1],Te&&ge.type==="text"&&Te.type==="text"?(Te.raw+=ge.raw,Te.text+=ge.text):ne.push(ge);continue}if(ge=this.tokenizer.link(ee)){ee=ee.substring(ge.raw.length),ne.push(ge);continue}if(ge=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(ge.raw.length),Te=ne[ne.length-1],Te&&ge.type==="text"&&Te.type==="text"?(Te.raw+=ge.raw,Te.text+=ge.text):ne.push(ge);continue}if(ge=this.tokenizer.emStrong(ee,Le,at)){ee=ee.substring(ge.raw.length),ne.push(ge);continue}if(ge=this.tokenizer.codespan(ee)){ee=ee.substring(ge.raw.length),ne.push(ge);continue}if(ge=this.tokenizer.br(ee)){ee=ee.substring(ge.raw.length),ne.push(ge);continue}if(ge=this.tokenizer.del(ee)){ee=ee.substring(ge.raw.length),ne.push(ge);continue}if(ge=this.tokenizer.autolink(ee,et)){ee=ee.substring(ge.raw.length),ne.push(ge);continue}if(!this.state.inLink&&(ge=this.tokenizer.url(ee,et))){ee=ee.substring(ge.raw.length),ne.push(ge);continue}if(ze=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var fe=1/0,re=ee.slice(1),W=void 0;de.options.extensions.startInline.forEach(function(we){W=we.call({lexer:this},re),typeof W=="number"&&W>=0&&(fe=Math.min(fe,W))}),fe<1/0&&fe>=0&&(ze=ee.substring(0,fe+1))}(),ge=this.tokenizer.inlineText(ze,st)){ee=ee.substring(ge.raw.length),ge.raw.slice(-1)!=="_"&&(at=ge.raw.slice(-1)),ot=!0,Te=ne[ne.length-1],Te&&Te.type==="text"?(Te.raw+=ge.raw,Te.text+=ge.text):ne.push(ge);continue}if(ee){var ce="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(ce);break}else throw new Error(ce)}}return ne},e(Ae,null,[{key:"rules",get:function(){return{block:Pe,inline:Oe}}}]),Ae}(),$=P.exports.defaults,K=L.cleanUrl,x=L.escape,V=function(){function Ae(ve){this.options=ve||$}var De=Ae.prototype;return De.code=function(ee,ne,de){var ge=(ne||"").match(/\S*/)[0];if(this.options.highlight){var Te=this.options.highlight(ee,ge);Te!=null&&Te!==ee&&(de=!0,ee=Te)}return ee=ee.replace(/\n$/,"")+`
`,ge?'<pre><code class="'+this.options.langPrefix+x(ge,!0)+'">'+(de?ee:x(ee,!0))+`</code></pre>
`:"<pre><code>"+(de?ee:x(ee,!0))+`</code></pre>
`},De.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},De.html=function(ee){return ee},De.heading=function(ee,ne,de,ge){return this.options.headerIds?"<h"+ne+' id="'+this.options.headerPrefix+ge.slug(de)+'">'+ee+"</h"+ne+`>
`:"<h"+ne+">"+ee+"</h"+ne+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(ee,ne,de){var ge=ne?"ol":"ul",Te=ne&&de!==1?' start="'+de+'"':"";return"<"+ge+Te+`>
`+ee+"</"+ge+`>
`},De.listitem=function(ee){return"<li>"+ee+`</li>
`},De.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(ee){return"<p>"+ee+`</p>
`},De.table=function(ee,ne){return ne&&(ne="<tbody>"+ne+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+ne+`</table>
`},De.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},De.tablecell=function(ee,ne){var de=ne.header?"th":"td",ge=ne.align?"<"+de+' align="'+ne.align+'">':"<"+de+">";return ge+ee+"</"+de+`>
`},De.strong=function(ee){return"<strong>"+ee+"</strong>"},De.em=function(ee){return"<em>"+ee+"</em>"},De.codespan=function(ee){return"<code>"+ee+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(ee){return"<del>"+ee+"</del>"},De.link=function(ee,ne,de){if(ee=K(this.options.sanitize,this.options.baseUrl,ee),ee===null)return de;var ge='<a href="'+x(ee)+'"';return ne&&(ge+=' title="'+ne+'"'),ge+=">"+de+"</a>",ge},De.image=function(ee,ne,de){if(ee=K(this.options.sanitize,this.options.baseUrl,ee),ee===null)return de;var ge='<img src="'+ee+'" alt="'+de+'"';return ne&&(ge+=' title="'+ne+'"'),ge+=this.options.xhtml?"/>":">",ge},De.text=function(ee){return ee},Ae}(),Y=function(){function Ae(){}var De=Ae.prototype;return De.strong=function(ee){return ee},De.em=function(ee){return ee},De.codespan=function(ee){return ee},De.del=function(ee){return ee},De.html=function(ee){return ee},De.text=function(ee){return ee},De.link=function(ee,ne,de){return""+de},De.image=function(ee,ne,de){return""+de},De.br=function(){return""},Ae}(),se=function(){function Ae(){this.seen={}}var De=Ae.prototype;return De.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(ee,ne){var de=ee,ge=0;if(this.seen.hasOwnProperty(de)){ge=this.seen[ee];do ge++,de=ee+"-"+ge;while(this.seen.hasOwnProperty(de))}return ne||(this.seen[ee]=ge,this.seen[de]=0),de},De.slug=function(ee,ne){ne===void 0&&(ne={});var de=this.serialize(ee);return this.getNextSafeSlug(de,ne.dryrun)},Ae}(),_e=V,Ue=Y,Ve=se,Qe=P.exports.defaults,nt=L.unescape,rt=function(){function Ae(ve){this.options=ve||Qe,this.options.renderer=this.options.renderer||new _e,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ue,this.slugger=new Ve}Ae.parse=function(ee,ne){var de=new Ae(ne);return de.parse(ee)},Ae.parseInline=function(ee,ne){var de=new Ae(ne);return de.parseInline(ee)};var De=Ae.prototype;return De.parse=function(ee,ne){ne===void 0&&(ne=!0);var de="",ge,Te,ze,Le,Ge,ot,at,Ne,ce,fe,re,W,we,Re,We,He,mt,Et,St,dt=ee.length;for(ge=0;ge<dt;ge++){if(fe=ee[ge],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(St=this.options.extensions.renderers[fe.type].call({parser:this},fe),St!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(fe.type))){de+=St||"";continue}switch(fe.type){case"space":continue;case"hr":{de+=this.renderer.hr();continue}case"heading":{de+=this.renderer.heading(this.parseInline(fe.tokens),fe.depth,nt(this.parseInline(fe.tokens,this.textRenderer)),this.slugger);continue}case"code":{de+=this.renderer.code(fe.text,fe.lang,fe.escaped);continue}case"table":{for(Ne="",at="",Le=fe.header.length,Te=0;Te<Le;Te++)at+=this.renderer.tablecell(this.parseInline(fe.header[Te].tokens),{header:!0,align:fe.align[Te]});for(Ne+=this.renderer.tablerow(at),ce="",Le=fe.rows.length,Te=0;Te<Le;Te++){for(ot=fe.rows[Te],at="",Ge=ot.length,ze=0;ze<Ge;ze++)at+=this.renderer.tablecell(this.parseInline(ot[ze].tokens),{header:!1,align:fe.align[ze]});ce+=this.renderer.tablerow(at)}de+=this.renderer.table(Ne,ce);continue}case"blockquote":{ce=this.parse(fe.tokens),de+=this.renderer.blockquote(ce);continue}case"list":{for(re=fe.ordered,W=fe.start,we=fe.loose,Le=fe.items.length,ce="",Te=0;Te<Le;Te++)We=fe.items[Te],He=We.checked,mt=We.task,Re="",We.task&&(Et=this.renderer.checkbox(He),we?We.tokens.length>0&&We.tokens[0].type==="paragraph"?(We.tokens[0].text=Et+" "+We.tokens[0].text,We.tokens[0].tokens&&We.tokens[0].tokens.length>0&&We.tokens[0].tokens[0].type==="text"&&(We.tokens[0].tokens[0].text=Et+" "+We.tokens[0].tokens[0].text)):We.tokens.unshift({type:"text",text:Et}):Re+=Et),Re+=this.parse(We.tokens,we),ce+=this.renderer.listitem(Re,mt,He);de+=this.renderer.list(ce,re,W);continue}case"html":{de+=this.renderer.html(fe.text);continue}case"paragraph":{de+=this.renderer.paragraph(this.parseInline(fe.tokens));continue}case"text":{for(ce=fe.tokens?this.parseInline(fe.tokens):fe.text;ge+1<dt&&ee[ge+1].type==="text";)fe=ee[++ge],ce+=`
`+(fe.tokens?this.parseInline(fe.tokens):fe.text);de+=ne?this.renderer.paragraph(ce):ce;continue}default:{var vt='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(vt);return}else throw new Error(vt)}}}return de},De.parseInline=function(ee,ne){ne=ne||this.renderer;var de="",ge,Te,ze,Le=ee.length;for(ge=0;ge<Le;ge++){if(Te=ee[ge],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(ze=this.options.extensions.renderers[Te.type].call({parser:this},Te),ze!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Te.type))){de+=ze||"";continue}switch(Te.type){case"escape":{de+=ne.text(Te.text);break}case"html":{de+=ne.html(Te.text);break}case"link":{de+=ne.link(Te.href,Te.title,this.parseInline(Te.tokens,ne));break}case"image":{de+=ne.image(Te.href,Te.title,Te.text);break}case"strong":{de+=ne.strong(this.parseInline(Te.tokens,ne));break}case"em":{de+=ne.em(this.parseInline(Te.tokens,ne));break}case"codespan":{de+=ne.codespan(Te.text);break}case"br":{de+=ne.br();break}case"del":{de+=ne.del(this.parseInline(Te.tokens,ne));break}case"text":{de+=ne.text(Te.text);break}default:{var Ge='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(Ge);return}else throw new Error(Ge)}}}return de},Ae}(),Je=tt,Ze=rt,pt=ie,Fe=V,At=Y,G=se,Q=L.merge,he=L.checkSanitizeDeprecation,Be=L.escape,qe=P.exports.getDefaults,lt=P.exports.changeDefaults,ht=P.exports.defaults;function Ye(Ae,De,ve){if(typeof Ae=="undefined"||Ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ae)+", string expected");if(typeof De=="function"&&(ve=De,De=null),De=Q({},Ye.defaults,De||{}),he(De),ve){var ee=De.highlight,ne;try{ne=Je.lex(Ae,De)}catch(ze){return ve(ze)}var de=function(Le){var Ge;if(!Le)try{De.walkTokens&&Ye.walkTokens(ne,De.walkTokens),Ge=Ze.parse(ne,De)}catch(ot){Le=ot}return De.highlight=ee,Le?ve(Le):ve(null,Ge)};if(!ee||ee.length<3||(delete De.highlight,!ne.length))return de();var ge=0;Ye.walkTokens(ne,function(ze){ze.type==="code"&&(ge++,setTimeout(function(){ee(ze.text,ze.lang,function(Le,Ge){if(Le)return de(Le);Ge!=null&&Ge!==ze.text&&(ze.text=Ge,ze.escaped=!0),ge--,ge===0&&de()})},0))}),ge===0&&de();return}try{var Te=Je.lex(Ae,De);return De.walkTokens&&Ye.walkTokens(Te,De.walkTokens),Ze.parse(Te,De)}catch(ze){if(ze.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+Be(ze.message+"",!0)+"</pre>";throw ze}}Ye.options=Ye.setOptions=function(Ae){return Q(Ye.defaults,Ae),lt(Ye.defaults),Ye},Ye.getDefaults=qe,Ye.defaults=ht,Ye.use=function(){for(var Ae=this,De=arguments.length,ve=new Array(De),ee=0;ee<De;ee++)ve[ee]=arguments[ee];var ne=Q.apply(void 0,[{}].concat(ve)),de=Ye.defaults.extensions||{renderers:{},childTokens:{}},ge;ve.forEach(function(Te){if(Te.extensions&&(ge=!0,Te.extensions.forEach(function(Le){if(!Le.name)throw new Error("extension name required");if(Le.renderer){var Ge=de.renderers?de.renderers[Le.name]:null;Ge?de.renderers[Le.name]=function(){for(var ot=arguments.length,at=new Array(ot),Ne=0;Ne<ot;Ne++)at[Ne]=arguments[Ne];var ce=Le.renderer.apply(this,at);return ce===!1&&(ce=Ge.apply(this,at)),ce}:de.renderers[Le.name]=Le.renderer}if(Le.tokenizer){if(!Le.level||Le.level!=="block"&&Le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");de[Le.level]?de[Le.level].unshift(Le.tokenizer):de[Le.level]=[Le.tokenizer],Le.start&&(Le.level==="block"?de.startBlock?de.startBlock.push(Le.start):de.startBlock=[Le.start]:Le.level==="inline"&&(de.startInline?de.startInline.push(Le.start):de.startInline=[Le.start]))}Le.childTokens&&(de.childTokens[Le.name]=Le.childTokens)})),Te.renderer&&function(){var Le=Ye.defaults.renderer||new Fe,Ge=function(Ne){var ce=Le[Ne];Le[Ne]=function(){for(var fe=arguments.length,re=new Array(fe),W=0;W<fe;W++)re[W]=arguments[W];var we=Te.renderer[Ne].apply(Le,re);return we===!1&&(we=ce.apply(Le,re)),we}};for(var ot in Te.renderer)Ge(ot);ne.renderer=Le}(),Te.tokenizer&&function(){var Le=Ye.defaults.tokenizer||new pt,Ge=function(Ne){var ce=Le[Ne];Le[Ne]=function(){for(var fe=arguments.length,re=new Array(fe),W=0;W<fe;W++)re[W]=arguments[W];var we=Te.tokenizer[Ne].apply(Le,re);return we===!1&&(we=ce.apply(Le,re)),we}};for(var ot in Te.tokenizer)Ge(ot);ne.tokenizer=Le}(),Te.walkTokens){var ze=Ye.defaults.walkTokens;ne.walkTokens=function(Le){Te.walkTokens.call(Ae,Le),ze&&ze(Le)}}ge&&(ne.extensions=de),Ye.setOptions(ne)})},Ye.walkTokens=function(Ae,De){for(var ve=function(){var ge=ne.value;switch(De(ge),ge.type){case"table":{for(var Te=S(ge.header),ze;!(ze=Te()).done;){var Le=ze.value;Ye.walkTokens(Le.tokens,De)}for(var Ge=S(ge.rows),ot;!(ot=Ge()).done;)for(var at=ot.value,Ne=S(at),ce;!(ce=Ne()).done;){var fe=ce.value;Ye.walkTokens(fe.tokens,De)}break}case"list":{Ye.walkTokens(ge.items,De);break}default:Ye.defaults.extensions&&Ye.defaults.extensions.childTokens&&Ye.defaults.extensions.childTokens[ge.type]?Ye.defaults.extensions.childTokens[ge.type].forEach(function(re){Ye.walkTokens(ge[re],De)}):ge.tokens&&Ye.walkTokens(ge.tokens,De)}},ee=S(Ae),ne;!(ne=ee()).done;)ve()},Ye.parseInline=function(Ae,De){if(typeof Ae=="undefined"||Ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ae)+", string expected");De=Q({},Ye.defaults,De||{}),he(De);try{var ve=Je.lexInline(Ae,De);return De.walkTokens&&Ye.walkTokens(ve,De.walkTokens),Ze.parseInline(ve,De)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+Be(ee.message+"",!0)+"</pre>";throw ee}},Ye.Parser=Ze,Ye.parser=Ze.parse,Ye.Renderer=Fe,Ye.TextRenderer=At,Ye.Lexer=Je,Ye.lexer=Je.lex,Ye.Tokenizer=pt,Ye.Slugger=G,Ye.parse=Ye;var kt=Ye;return kt}),define(ye[100],Se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function r(I,D,T){return Math.min(Math.max(I,D),T)}e.clamp=r;function t(I,D){return(D+I%D)%D}e.rot=t;class S{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=S;class P{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=P;class A{constructor(D){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(D),this._values.fill(0,0,D)}update(D){const T=this._values[this._index];return this._values[this._index]=D,this._index=(this._index+1)%this._values.length,this._sum-=T,this._sum+=D,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=A}),function(){function Z(S){const P=[];typeof S=="number"&&P.push("code/timeOrigin",S);function A(D){P.push(D,Date.now())}function I(){const D=[];for(let T=0;T<P.length;T+=2)D.push({name:P[T],startTime:P[T+1]});return D}return{mark:A,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const A of performance.getEntriesByType("mark"))P.push({name:A.name,startTime:Math.round(S+A.startTime)});return P}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function r(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=r(t))}(),define(ye[74],Se([0,1,17]),function(Z,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(b){b.text="text/plain",b.binary="application/octet-stream",b.unknown="application/unknown",b.markdown="text/markdown",b.latex="text/latex"})(t=e.Mimes||(e.Mimes={}));const S={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(b){const i=(0,r.extname)(b),h=S[i.toLowerCase()];return h!==void 0?h:I(b)}e.getMediaOrTextMime=A;function I(b){const i=(0,r.extname)(b);return P[i.toLowerCase()]}e.getMediaMime=I;function D(b){for(const i in P)if(P[i]===b)return i}e.getExtensionForMimeType=D;const T=/^(.+)\/(.+?)(;.+)?$/;function R(b,i){const h=T.exec(b);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:i?void 0:b}e.normalizeMimeType=R}),define(ye[101],Se([0,1,15,6]),function(Z,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function S(w){const u=w;return u?[u.on,u.pause,u.resume,u.destroy].every(_=>typeof _=="function"):!1}e.isReadableStream=S;function P(w){const u=w;return u?S(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=P;function A(w,u){return new I(w,u)}e.newWriteableStream=A;class I{constructor(u,_){this.reducer=u,this.options=_,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(_=>this.pendingWritePromises.push(_))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u!="undefined"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(_=>_(u))}emitError(u){this.listeners.error.length===0?(0,r.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(_=>_(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,_){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(_),this.resume();break;case"end":this.listeners.end.push(_),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(_),this.state.flowing&&this.flowErrors();break}}removeListener(u,_){if(this.state.destroyed)return;let a;switch(u){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const F=a.indexOf(_);F>=0&&a.splice(F,1)}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const _=[...this.pendingWritePromises];this.pendingWritePromises.length=0,_.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(w,u){const _=[];let a;for(;(a=w.read())!==null;)_.push(a);return u(_)}e.consumeReadable=D;function T(w,u,_){const a=[];let F;for(;(F=w.read())!==null&&a.length<_;)a.push(F);return F===null&&a.length>0?u(a):{read:()=>{if(a.length>0)return a.shift();if(typeof F!="undefined"){const c=F;return F=void 0,c}return w.read()}}}e.peekReadable=T;function R(w,u){return new Promise((_,a)=>{const F=[];b(w,{onData:c=>{u&&F.push(c)},onError:c=>{u?a(c):_(void 0)},onEnd:()=>{_(u?u(F):void 0)}})})}e.consumeStream=R;function b(w,u){let _=!1;return w.on("error",a=>{_||u.onError(a)}),w.on("end",()=>{_||u.onEnd()}),w.on("data",a=>{_||u.onData(a)}),(0,t.toDisposable)(()=>_=!0)}e.listenStream=b;function i(w,u){return new Promise((_,a)=>{const F=new t.DisposableStore,c=[],n=s=>{if(c.push(s),c.length>u)return F.dispose(),w.pause(),_({stream:w,buffer:c,ended:!1})},f=s=>a(s),g=()=>_({stream:w,buffer:c,ended:!0});F.add((0,t.toDisposable)(()=>w.removeListener("error",f))),w.on("error",f),F.add((0,t.toDisposable)(()=>w.removeListener("end",g))),w.on("end",g),F.add((0,t.toDisposable)(()=>w.removeListener("data",n))),w.on("data",n)})}e.peekStream=i;function h(w,u){const _=A(u);return _.end(w),_}e.toStream=h;function l(){const w=A(()=>{throw new Error("not supported")});return w.end(),w}e.emptyStream=l;function o(w){let u=!1;return{read:()=>u?null:(u=!0,w)}}e.toReadable=o;function m(w,u,_){const a=A(_);return b(w,{onData:F=>a.write(u.data(F)),onError:F=>a.error(u.error?u.error(F):F),onEnd:()=>a.end()}),a}e.transform=m;function M(w,u,_){let a=!1;return{read:()=>{const F=u.read();return a?F:(a=!0,F!==null?_([w,F]):w)}}}e.prefixedReadable=M;function C(w,u,_){let a=!1;const F=A(_);return b(u,{onData:c=>a?F.write(c):(a=!0,F.write(_([w,c]))),onError:c=>F.error(c),onEnd:()=>{a||(a=!0,F.write(w)),F.end()}}),F}e.prefixedStream=C}),define(ye[21],Se([0,1,101]),function(Z,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let S,P;class A{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return t?new A(Buffer.allocUnsafe(d)):new A(new Uint8Array(d))}static wrap(d){return t&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new A(d)}static fromString(d,p){return!(p?.dontUseNodeBuffer||!1)&&t?new A(Buffer.from(d)):(S||(S=new TextEncoder),new A(S.encode(d)))}static fromByteArray(d){const p=A.alloc(d.length);for(let E=0,v=d.length;E<v;E++)p.buffer[E]=d[E];return p}static concat(d,p){if(typeof p=="undefined"){p=0;for(let k=0,L=d.length;k<L;k++)p+=d[k].byteLength}const E=A.alloc(p);let v=0;for(let k=0,L=d.length;k<L;k++){const y=d[k];E.set(y,v),v+=y.byteLength}return E}clone(){const d=A.alloc(this.byteLength);return d.set(this),d}toString(){return t?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(d,p){return new A(this.buffer.subarray(d,p))}set(d,p){if(d instanceof A)this.buffer.set(d.buffer,p);else if(d instanceof Uint8Array)this.buffer.set(d,p);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),p);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),p);else throw new Error("Unkown argument 'array'")}readUInt32BE(d){return T(this.buffer,d)}writeUInt32BE(d,p){R(this.buffer,d,p)}readUInt32LE(d){return b(this.buffer,d)}writeUInt32LE(d,p){i(this.buffer,d,p)}readUInt8(d){return h(this.buffer,d)}writeUInt8(d,p){l(this.buffer,d,p)}}e.VSBuffer=A;function I(s,d){return s[d+0]<<0>>>0|s[d+1]<<8>>>0}e.readUInt16LE=I;function D(s,d,p){s[p+0]=d&255,d=d>>>8,s[p+1]=d&255}e.writeUInt16LE=D;function T(s,d){return s[d]*2**24+s[d+1]*2**16+s[d+2]*2**8+s[d+3]}e.readUInt32BE=T;function R(s,d,p){s[p+3]=d,d=d>>>8,s[p+2]=d,d=d>>>8,s[p+1]=d,d=d>>>8,s[p]=d}e.writeUInt32BE=R;function b(s,d){return s[d+0]<<0>>>0|s[d+1]<<8>>>0|s[d+2]<<16>>>0|s[d+3]<<24>>>0}e.readUInt32LE=b;function i(s,d,p){s[p+0]=d&255,d=d>>>8,s[p+1]=d&255,d=d>>>8,s[p+2]=d&255,d=d>>>8,s[p+3]=d&255}e.writeUInt32LE=i;function h(s,d){return s[d]}e.readUInt8=h;function l(s,d,p){s[p]=d}e.writeUInt8=l;function o(s){return r.consumeReadable(s,d=>A.concat(d))}e.readableToBuffer=o;function m(s){return r.toReadable(s)}e.bufferToReadable=m;function M(s){return r.consumeStream(s,d=>A.concat(d))}e.streamToBuffer=M;async function C(s){return s.ended?A.concat(s.buffer):A.concat([...s.buffer,await M(s.stream)])}e.bufferedStreamToBuffer=C;function w(s){return r.toStream(s,d=>A.concat(d))}e.bufferToStream=w;function u(s){return r.transform(s,{data:d=>typeof d=="string"?A.fromString(d):A.wrap(d)},d=>A.concat(d))}e.streamToBufferReadableStream=u;function _(s){return r.newWriteableStream(d=>A.concat(d),s)}e.newWriteableBufferStream=_;function a(s,d){return r.prefixedReadable(s,d,p=>A.concat(p))}e.prefixedBufferReadable=a;function F(s,d){return r.prefixedStream(s,d,p=>A.concat(p))}e.prefixedBufferStream=F;function c(s){let d=0,p=0,E=0;const v=new Uint8Array(Math.floor(s.length/4*3)),k=y=>{switch(p){case 3:v[E++]=d|y,p=0;break;case 2:v[E++]=d|y>>>2,d=y<<6,p=3;break;case 1:v[E++]=d|y>>>4,d=y<<4,p=2;break;default:d=y<<2,p=1}};for(let y=0;y<s.length;y++){const O=s.charCodeAt(y);if(O>=65&&O<=90)k(O-65);else if(O>=97&&O<=122)k(O-97+26);else if(O>=48&&O<=57)k(O-48+52);else if(O===43||O===45)k(62);else if(O===47||O===95)k(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${s[y]}`)}}const L=E;for(;p>0;)k(0);return A.wrap(v).slice(0,L)}e.decodeBase64=c;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:s},d=!0,p=!1){const E=p?f:n;let v="";const k=s.byteLength%3;let L=0;for(;L<s.byteLength-k;L+=3){const y=s[L+0],O=s[L+1],U=s[L+2];v+=E[y>>>2],v+=E[(y<<4|O>>>4)&63],v+=E[(O<<2|U>>>6)&63],v+=E[U&63]}if(k===1){const y=s[L+0];v+=E[y>>>2],v+=E[y<<4&63],d&&(v+="==")}else if(k===2){const y=s[L+0],O=s[L+1];v+=E[y>>>2],v+=E[(y<<4|O>>>4)&63],v+=E[O<<2&63],d&&(v+="=")}return v}e.encodeBase64=g});var Xe=this&&this.__classPrivateFieldSet||function(Z,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(Z,r):S?S.value=r:e.set(Z,r),r},Ie=this&&this.__classPrivateFieldGet||function(Z,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[22],Se([0,1,16,9]),function(Z,e,r,t){"use strict";var S,P,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(c,n,f){let g=c.get(n);return g===void 0&&(g=f,c.set(n,g)),g}e.getOrSet=I;function D(c){const n=[];return c.forEach((f,g)=>{n.push(`${g} => ${f}`)}),`Map(${c.size}) {${n.join(", ")}}`}e.mapToString=D;function T(c){const n=[];return c.forEach(f=>{n.push(f)}),`Set(${c.size}) {${n.join(", ")}}`}e.setToString=T;class R{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const f=n.charCodeAt(0),g=this._value.charCodeAt(this._pos);return f-g}value(){return this._value[this._pos]}}e.StringIterator=R;class b{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class i{constructor(n=!0,f=!0){this._splitOnBackslash=n,this._caseSensitive=f}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let f=n.length-1;f>=0;f--,this._valueLen--){const g=this._value.charCodeAt(f);if(!(g===47||this._splitOnBackslash&&g===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const f=this._value.charCodeAt(this._to);if(f===47||this._splitOnBackslash&&f===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=i;var h;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(h||(h={}));class l{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new i(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,t.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=l;class o{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(m||(m={}));class M{constructor(n){this._iter=n}static forUris(n=()=>!1){return new M(new l(n))}static forPaths(n=!1){return new M(new i(void 0,!n))}static forStrings(){return new M(new R)}static forConfigKeys(){return new M(new b)}clear(){this._root=void 0}fill(n,f){if(f){const g=f.slice(0);(0,r.shuffle)(g);for(let s of g)this.set(s,n)}else{const g=n.slice(0);(0,r.shuffle)(g);for(let s of g)this.set(s[0],s[1])}}set(n,f){const g=this._iter.reset(n);let s;this._root||(this._root=new o,this._root.segment=g.value());const d=[];for(s=this._root;;){const E=g.cmp(s.segment);if(E>0)s.left||(s.left=new o,s.left.segment=g.value()),d.push([-1,s]),s=s.left;else if(E<0)s.right||(s.right=new o,s.right.segment=g.value()),d.push([1,s]),s=s.right;else if(g.hasNext())g.next(),s.mid||(s.mid=new o,s.mid.segment=g.value()),d.push([0,s]),s=s.mid;else break}const p=s.value;s.value=f,s.key=n;for(let E=d.length-1;E>=0;E--){const v=d[E][1];v.updateHeight();const k=v.balanceFactor();if(k<-1||k>1){const L=d[E][0],y=d[E+1][0];if(L===1&&y===1)d[E][1]=v.rotateLeft();else if(L===-1&&y===-1)d[E][1]=v.rotateRight();else if(L===1&&y===-1)v.right=d[E+1][1]=d[E+1][1].rotateRight(),d[E][1]=v.rotateLeft();else if(L===-1&&y===1)v.left=d[E+1][1]=d[E+1][1].rotateLeft(),d[E][1]=v.rotateRight();else throw new Error;if(E>0)switch(d[E-1][0]){case-1:d[E-1][1].left=d[E][1];break;case 1:d[E-1][1].right=d[E][1];break;case 0:d[E-1][1].mid=d[E][1];break}else this._root=d[0][1]}}return p}get(n){return this._getNode(n)?.value}_getNode(n){const f=this._iter.reset(n);let g=this._root;for(;g;){const s=f.cmp(g.segment);if(s>0)g=g.left;else if(s<0)g=g.right;else if(f.hasNext())f.next(),g=g.mid;else break}return g}has(n){const f=this._getNode(n);return!(f?.value===void 0&&f?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,f){const g=this._iter.reset(n),s=[];let d=this._root;for(;d;){const p=g.cmp(d.segment);if(p>0)s.push([-1,d]),d=d.left;else if(p<0)s.push([1,d]),d=d.right;else if(g.hasNext())g.next(),s.push([0,d]),d=d.mid;else break}if(!!d){if(f?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const p=this._min(d.right),{key:E,value:v,segment:k}=p;this._delete(p.key,!1),d.key=E,d.value=v,d.segment=k}else{const p=d.left??d.right;if(s.length>0){const[E,v]=s[s.length-1];switch(E){case-1:v.left=p;break;case 0:v.mid=p;break;case 1:v.right=p;break}}else this._root=p}for(let p=s.length-1;p>=0;p--){const E=s[p][1];E.updateHeight();const v=E.balanceFactor();if(v>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),s[p][1]=E.rotateLeft()):v<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),s[p][1]=E.rotateRight()),p>0)switch(s[p-1][0]){case-1:s[p-1][1].left=s[p][1];break;case 1:s[p-1][1].right=s[p][1];break;case 0:s[p-1][1].mid=s[p][1];break}else this._root=s[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const f=this._iter.reset(n);let g=this._root,s;for(;g;){const d=f.cmp(g.segment);if(d>0)g=g.left;else if(d<0)g=g.right;else if(f.hasNext())f.next(),s=g.value||s,g=g.mid;else break}return g&&g.value||s}findSuperstr(n){const f=this._iter.reset(n);let g=this._root;for(;g;){const s=f.cmp(g.segment);if(s>0)g=g.left;else if(s<0)g=g.right;else if(f.hasNext())f.next(),g=g.mid;else return g.mid?this._entries(g.mid):void 0}}forEach(n){for(const[f,g]of this)n(g,f)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){!n||(n.left&&(yield*this._entries(n.left)),n.value&&(yield[n.key,n.value]),n.mid&&(yield*this._entries(n.mid)),n.right&&(yield*this._entries(n.right)))}_isBalanced(){const n=f=>{if(!f)return!0;const g=f.balanceFactor();return g<-1||g>1?!1:n(f.left)&&n(f.right)};return n(this._root)}}e.TernarySearchTree=M;class C{constructor(n,f){this.uri=n,this.value=f}}class w{constructor(n,f){this[S]="ResourceMap",n instanceof w?(this.map=new Map(n.map),this.toKey=f??w.defaultToKey):(this.map=new Map,this.toKey=n??w.defaultToKey)}set(n,f){return this.map.set(this.toKey(n),new C(n,f)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,f){typeof f!="undefined"&&(n=n.bind(f));for(let[g,s]of this.map)n(s.value,s.uri,this)}*values(){for(let n of this.map.values())yield n.value}*keys(){for(let n of this.map.values())yield n.uri}*entries(){for(let n of this.map.values())yield[n.uri,n.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(let[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=w,w.defaultToKey=c=>c.toString();var u;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(u=e.Touch||(e.Touch={}));class _{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,f=0){const g=this._map.get(n);if(!!g)return f!==0&&this.touch(g,f),g.value}set(n,f,g=0){let s=this._map.get(n);if(s)s.value=f,g!==0&&this.touch(s,g);else{switch(s={key:n,value:f,next:void 0,previous:void 0},g){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(n,s),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const f=this._map.get(n);if(!!f)return this._map.delete(n),this.removeItem(f),this._size--,f.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,f){const g=this._state;let s=this._head;for(;s;){if(f?n.bind(f)(s.value,s.key,this):n(s.value,s.key,this),this._state!==g)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const n=this,f=this._state;let g=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==f)throw new Error("LinkedMap got modified during iteration.");if(g){const d={value:g.key,done:!1};return g=g.next,d}else return{value:void 0,done:!0}}};return s}values(){const n=this,f=this._state;let g=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==f)throw new Error("LinkedMap got modified during iteration.");if(g){const d={value:g.value,done:!1};return g=g.next,d}else return{value:void 0,done:!0}}};return s}entries(){const n=this,f=this._state;let g=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==f)throw new Error("LinkedMap got modified during iteration.");if(g){const d={value:[g.key,g.value],done:!1};return g=g.next,d}else return{value:void 0,done:!0}}};return s}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let f=this._head,g=this.size;for(;f&&g>n;)this._map.delete(f.key),f=f.next,g--;this._head=f,this._size=g,f&&(f.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const f=n.next,g=n.previous;if(!f||!g)throw new Error("Invalid list");f.previous=g,g.next=f}n.next=void 0,n.previous=void 0,this._state++}touch(n,f){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(n===this._head)return;const g=n.next,s=n.previous;n===this._tail?(s.next=void 0,this._tail=s):(g.previous=s,s.next=g),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(f===2){if(n===this._tail)return;const g=n.next,s=n.previous;n===this._head?(g.previous=void 0,this._head=g):(g.previous=s,s.next=g),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((f,g)=>{n.push([g,f])}),n}fromJSON(n){this.clear();for(const[f,g]of n)this.set(f,g)}}e.LinkedMap=_;class a extends _{constructor(n,f=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,f),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,f=2){return super.get(n,f)}peek(n){return super.get(n,0)}set(n,f){return super.set(n,f,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class F{constructor(n){A.set(this,void 0),Xe(this,A,n,"f")}get size(){return Ie(this,A,"f").size}forEach(n,f){Ie(this,A,"f").forEach(n,f)}get(n){return Ie(this,A,"f").get(n)}has(n){return Ie(this,A,"f").has(n)}entries(){return Ie(this,A,"f").entries()}keys(){return Ie(this,A,"f").keys()}values(){return Ie(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return Ie(this,A,"f").entries()}}e.ReadonlyMapView=F}),define(ye[102],Se([0,1,22,9]),function(Z,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function S(...x){return function(V,Y){for(let se=0,_e=x.length;se<_e;se++){const Ue=x[se](V,Y);if(Ue)return Ue}return null}}e.or=S,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(x,V,Y){if(!Y||Y.length<V.length)return null;let se;return x?se=t.startsWithIgnoreCase(Y,V):se=Y.indexOf(V)===0,se?V.length>0?[{start:0,end:V.length}]:[]:null}function A(x,V){const Y=V.toLowerCase().indexOf(x.toLowerCase());return Y===-1?null:[{start:Y,end:Y+x.length}]}e.matchesContiguousSubString=A;function I(x,V){return D(x.toLowerCase(),V.toLowerCase(),0,0)}e.matchesSubString=I;function D(x,V,Y,se){if(Y===x.length)return[];if(se===V.length)return null;if(x[Y]===V[se]){let _e=null;return(_e=D(x,V,Y+1,se+1))?M({start:se,end:se+1},_e):null}return D(x,V,Y,se+1)}function T(x){return 97<=x&&x<=122}function R(x){return 65<=x&&x<=90}e.isUpper=R;function b(x){return 48<=x&&x<=57}function i(x){return x===32||x===9||x===10||x===13}const h=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(x=>h.add(x.charCodeAt(0)));function l(x){return i(x)||h.has(x)}function o(x,V){return x===V||l(x)&&l(V)}function m(x){return T(x)||R(x)||b(x)}function M(x,V){return V.length===0?V=[x]:x.end===V[0].start?V[0].start=x.start:V.unshift(x),V}function C(x,V){for(let Y=V;Y<x.length;Y++){const se=x.charCodeAt(Y);if(R(se)||b(se)||Y>0&&!m(x.charCodeAt(Y-1)))return Y}return x.length}function w(x,V,Y,se){if(Y===x.length)return[];if(se===V.length)return null;if(x[Y]!==V[se].toLowerCase())return null;{let _e=null,Ue=se+1;for(_e=w(x,V,Y+1,se+1);!_e&&(Ue=C(V,Ue))<V.length;)_e=w(x,V,Y+1,Ue),Ue++;return _e===null?null:M({start:se,end:se+1},_e)}}function u(x){let V=0,Y=0,se=0,_e=0,Ue=0;for(let Je=0;Je<x.length;Je++)Ue=x.charCodeAt(Je),R(Ue)&&V++,T(Ue)&&Y++,m(Ue)&&se++,b(Ue)&&_e++;const Ve=V/x.length,Qe=Y/x.length,nt=se/x.length,rt=_e/x.length;return{upperPercent:Ve,lowerPercent:Qe,alphaPercent:nt,numericPercent:rt}}function _(x){const{upperPercent:V,lowerPercent:Y}=x;return Y===0&&V>.6}function a(x){const{upperPercent:V,lowerPercent:Y,alphaPercent:se,numericPercent:_e}=x;return Y>.2&&V<.8&&se>.6&&_e<.2}function F(x){let V=0,Y=0,se=0,_e=0;for(let Ue=0;Ue<x.length;Ue++)se=x.charCodeAt(Ue),R(se)&&V++,T(se)&&Y++,i(se)&&_e++;return(V===0||Y===0)&&_e===0?x.length<=30:V<=5}function c(x,V){if(!V||(V=V.trim(),V.length===0)||!F(x)||V.length>60)return null;const Y=u(V);if(!a(Y)){if(!_(Y))return null;V=V.toLowerCase()}let se=null,_e=0;for(x=x.toLowerCase();_e<V.length&&(se=w(x,V,0,_e))===null;)_e=C(V,_e+1);return se}e.matchesCamelCase=c;function n(x,V,Y=!1){if(!V||V.length===0)return null;let se=null,_e=0;for(x=x.toLowerCase(),V=V.toLowerCase();_e<V.length&&(se=f(x,V,0,_e,Y))===null;)_e=g(V,_e+1);return se}e.matchesWords=n;function f(x,V,Y,se,_e){if(Y===x.length)return[];if(se===V.length)return null;if(o(x.charCodeAt(Y),V.charCodeAt(se))){let Ue=null,Ve=se+1;if(Ue=f(x,V,Y+1,se+1,_e),!_e)for(;!Ue&&(Ve=g(V,Ve))<V.length;)Ue=f(x,V,Y+1,Ve,_e),Ve++;return Ue===null?null:M({start:se,end:se+1},Ue)}else return null}function g(x,V){for(let Y=V;Y<x.length;Y++)if(l(x.charCodeAt(Y))||Y>0&&l(x.charCodeAt(Y-1)))return Y;return x.length}const s=S(e.matchesPrefix,c,A),d=S(e.matchesPrefix,c,I),p=new r.LRUCache(1e4);function E(x,V,Y=!1){if(typeof x!="string"||typeof V!="string")return null;let se=p.get(x);se||(se=new RegExp(t.convertSimple2RegExpPattern(x),"i"),p.set(x,se));const _e=se.exec(V);return _e?[{start:_e.index,end:_e.index+_e[0].length}]:Y?d(x,V):s(x,V)}e.matchesFuzzy=E;function v(x,V){const Y=Oe(x,x.toLowerCase(),0,V,V.toLowerCase(),0,!0);return Y?L(Y):null}e.matchesFuzzy2=v;function k(x,V,Y,se,_e,Ue){const Ve=Math.min(13,x.length);for(;Y<Ve;Y++){const Qe=Oe(x,V,Y,se,_e,Ue,!1);if(Qe)return Qe}return[0,Ue]}e.anyScore=k;function L(x){if(typeof x=="undefined")return[];const V=[],Y=x[1];for(let se=x.length-1;se>1;se--){const _e=x[se]+Y,Ue=V[V.length-1];Ue&&Ue.end===_e?Ue.end=_e+1:V.push({start:_e,end:_e+1})}return V}e.createMatches=L;const y=128;function O(){const x=[],V=[];for(let Y=0;Y<=y;Y++)V[Y]=0;for(let Y=0;Y<=y;Y++)x.push(V.slice(0));return x}function U(x){const V=[];for(let Y=0;Y<=x;Y++)V[Y]=0;return V}const q=U(2*y),H=U(2*y),z=O(),j=O(),ie=O(),ae=!1;function te(x,V,Y,se,_e){function Ue(Qe,nt,rt=" "){for(;Qe.length<nt;)Qe=rt+Qe;return Qe}let Ve=` |   |${se.split("").map(Qe=>Ue(Qe,3)).join("|")}
`;for(let Qe=0;Qe<=Y;Qe++)Qe===0?Ve+=" |":Ve+=`${V[Qe-1]}|`,Ve+=x[Qe].slice(0,_e+1).map(nt=>Ue(nt.toString(),3)).join("|")+`
`;return Ve}function ue(x,V,Y,se){x=x.substr(V),Y=Y.substr(se),console.log(te(j,x,x.length,Y,Y.length)),console.log(te(ie,x,x.length,Y,Y.length)),console.log(te(z,x,x.length,Y,Y.length))}function be(x,V){if(V<0||V>=x.length)return!1;const Y=x.codePointAt(V);switch(Y){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(Y)}}function pe(x,V){if(V<0||V>=x.length)return!1;switch(x.charCodeAt(V)){case 32:case 9:return!0;default:return!1}}function me(x,V,Y){return V[x]!==Y[x]}function oe(x,V,Y,se,_e,Ue,Ve=!1){for(;V<Y&&_e<Ue;)x[V]===se[_e]&&(Ve&&(q[V]=_e),V+=1),_e+=1;return V===Y}e.isPatternInWord=oe;var Ee;(function(x){x[x.Diag=1]="Diag",x[x.Left=2]="Left",x[x.LeftLeft=3]="LeftLeft"})(Ee||(Ee={}));var Pe;(function(x){x.Default=[-100,0];function V(Y){return!Y||Y.length===2&&Y[0]===-100&&Y[1]===0}x.isDefault=V})(Pe=e.FuzzyScore||(e.FuzzyScore={}));function Oe(x,V,Y,se,_e,Ue,Ve){const Qe=x.length>y?y:x.length,nt=se.length>y?y:se.length;if(Y>=Qe||Ue>=nt||Qe-Y>nt-Ue||!oe(V,Y,Qe,_e,Ue,nt,!0))return;je(Qe,nt,Y,Ue,V,_e);let rt=1,Je=1,Ze=Y,pt=Ue;const Fe=[!1];for(rt=1,Ze=Y;Ze<Qe;rt++,Ze++){const Be=q[Ze],qe=H[Ze],lt=Ze+1<Qe?H[Ze+1]:nt;for(Je=Be-Ue+1,pt=Be;pt<lt;Je++,pt++){let ht=Number.MIN_SAFE_INTEGER,Ye=!1;pt<=qe&&(ht=st(x,V,Ze,Y,se,_e,pt,nt,Ue,z[rt-1][Je-1]===0,Fe));let kt=0;ht!==Number.MAX_SAFE_INTEGER&&(Ye=!0,kt=ht+j[rt-1][Je-1]);const Ae=pt>Be,De=Ae?j[rt][Je-1]+(z[rt][Je-1]>0?-5:0):0,ve=pt>Be+1&&z[rt][Je-1]>0,ee=ve?j[rt][Je-2]+(z[rt][Je-2]>0?-5:0):0;if(ve&&(!Ae||ee>=De)&&(!Ye||ee>=kt))j[rt][Je]=ee,ie[rt][Je]=3,z[rt][Je]=0;else if(Ae&&(!Ye||De>=kt))j[rt][Je]=De,ie[rt][Je]=2,z[rt][Je]=0;else if(Ye)j[rt][Je]=kt,ie[rt][Je]=1,z[rt][Je]=z[rt-1][Je-1]+1;else throw new Error("not possible")}}if(ae&&ue(x,Y,se,Ue),!Fe[0]&&!Ve)return;rt--,Je--;const At=[j[rt][Je],Ue];let G=0,Q=0;for(;rt>=1;){let Be=Je;do{const qe=ie[rt][Be];if(qe===3)Be=Be-2;else if(qe===2)Be=Be-1;else break}while(Be>=1);G>1&&V[Y+rt-1]===_e[Ue+Je-1]&&!me(Be+Ue-1,se,_e)&&G+1>z[rt][Be]&&(Be=Je),Be===Je?G++:G=1,Q||(Q=Be),rt--,Je=Be-1,At.push(Je)}nt===Qe&&(At[0]+=2);const he=Q-Qe;return At[0]-=he,At}e.fuzzyScore=Oe;function je(x,V,Y,se,_e,Ue){let Ve=x-1,Qe=V-1;for(;Ve>=Y&&Qe>=se;)_e[Ve]===Ue[Qe]&&(H[Ve]=Qe,Ve--),Qe--}function st(x,V,Y,se,_e,Ue,Ve,Qe,nt,rt,Je){if(V[Y]!==Ue[Ve])return Number.MIN_SAFE_INTEGER;let Ze=1,pt=!1;return Ve===Y-se?Ze=x[Y]===_e[Ve]?7:5:me(Ve,_e,Ue)&&(Ve===0||!me(Ve-1,_e,Ue))?(Ze=x[Y]===_e[Ve]?7:5,pt=!0):be(Ue,Ve)&&(Ve===0||!be(Ue,Ve-1))?Ze=5:(be(Ue,Ve-1)||pe(Ue,Ve-1))&&(Ze=5,pt=!0),Ze>1&&Y===se&&(Je[0]=!0),pt||(pt=me(Ve,_e,Ue)||be(Ue,Ve-1)||pe(Ue,Ve-1)),Y===se?Ve>nt&&(Ze-=pt?3:5):rt?Ze+=pt?2:0:Ze+=pt?0:1,Ve+1===Qe&&(Ze-=pt?3:5),Ze}function et(x,V,Y,se,_e,Ue,Ve){return $(x,V,Y,se,_e,Ue,!0,Ve)}e.fuzzyScoreGracefulAggressive=et;function tt(x,V,Y,se,_e,Ue,Ve){return $(x,V,Y,se,_e,Ue,!1,Ve)}e.fuzzyScoreGraceful=tt;function $(x,V,Y,se,_e,Ue,Ve,Qe){let nt=Oe(x,V,Y,se,_e,Ue,Qe);if(nt&&!Ve)return nt;if(x.length>=3){const rt=Math.min(7,x.length-1);for(let Je=Y+1;Je<rt;Je++){const Ze=K(x,Je);if(Ze){const pt=Oe(Ze,Ze.toLowerCase(),Y,se,_e,Ue,Qe);pt&&(pt[0]-=3,(!nt||pt[0]>nt[0])&&(nt=pt))}}}return nt}function K(x,V){if(V+1>=x.length)return;const Y=x[V],se=x[V+1];if(Y!==se)return x.slice(0,V)+se+Y+x.slice(V+2)}}),define(ye[103],Se([0,1,52,102,9]),function(Z,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(r.CSSIcon.iconNameCharacter),I=new RegExp(`(\\\\)?${P.source}`,"g");function D(m){return m.replace(I,(M,C)=>C?M:`\\${M}`)}e.escapeIcons=D;const T=new RegExp(`\\\\${P.source}`,"g");function R(m){return m.replace(T,M=>`\\${M}`)}e.markdownEscapeEscapedIcons=R;const b=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function i(m){return m.indexOf(e.iconStartMarker)===-1?m:m.replace(b,(M,C,w,u)=>w?M:C||u||"")}e.stripIcons=i;function h(m){const M=m.indexOf(e.iconStartMarker);return M===-1?{text:m}:l(m,M)}e.parseLabelWithIcons=h;function l(m,M){const C=[];let w="";function u(s){if(s){w+=s;for(const d of s)C.push(F)}}let _=-1,a="",F=0,c,n,f=M;const g=m.length;for(u(m.substr(0,M));f<g;)c=m[f],n=m[f+1],c===e.iconStartMarker[0]&&n===e.iconStartMarker[1]?(_=f,u(a),a=e.iconStartMarker,f++):c===")"&&_!==-1?(F+=f-_+1,_=-1,a=""):_!==-1?A.test(c)?a+=c:(u(a),_=-1,a=""):u(c),f++;return u(a),{text:w,iconOffsets:C}}function o(m,M,C=!1){const{text:w,iconOffsets:u}=M;if(!u||u.length===0)return(0,t.matchesFuzzy)(m,w,C);const _=(0,S.ltrim)(w," "),a=w.length-_.length,F=(0,t.matchesFuzzy)(m,_,C);if(F)for(const c of F){const n=u[c.start+a]+a;c.start+=n,c.end+=n}return F}e.matchesFuzzyIconAware=o}),define(ye[75],Se([0,1,15,103]),function(Z,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var S;(function(i){i[i.Paragraph=0]="Paragraph",i[i.Break=1]="Break"})(S=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class P{constructor(h="",l=!1){if(this.value=h,typeof this.value!="string")throw(0,r.illegalArgument)("value");typeof l=="boolean"?(this.isTrusted=l,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=l.isTrusted??void 0,this.supportThemeIcons=l.supportThemeIcons??!1,this.supportHtml=l.supportHtml??!1)}appendText(h,l=0){return this.value+=T(this.supportThemeIcons?(0,t.escapeIcons)(h):h).replace(/([ \t]+)/g,(o,m)=>"&nbsp;".repeat(m.length)).replace(/\>/gm,"\\>").replace(/\n/g,l===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,l){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=l,this.value+="\n```\n",this}}e.MarkdownString=P;function A(i){return I(i)?!i.value:Array.isArray(i)?i.every(A):!0}e.isEmptyMarkdownString=A;function I(i){return i instanceof P?!0:i&&typeof i=="object"?typeof i.value=="string"&&(typeof i.isTrusted=="boolean"||i.isTrusted===void 0)&&(typeof i.supportThemeIcons=="boolean"||i.supportThemeIcons===void 0):!1}e.isMarkdownString=I;function D(i,h){return i===h?!0:!i||!h?!1:i.value===h.value&&i.isTrusted===h.isTrusted&&i.supportThemeIcons===h.supportThemeIcons}e.markdownStringEqual=D;function T(i){return i.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=T;function R(i){return i&&i.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=R;function b(i){const h=[],l=i.split("|").map(m=>m.trim());i=l[0];const o=l[1];if(o){const m=/height=(\d+)/.exec(o),M=/width=(\d+)/.exec(o),C=m?m[1]:"",w=M?M[1]:"",u=isFinite(parseInt(w)),_=isFinite(parseInt(C));u&&h.push(`width="${w}"`),_&&h.push(`height="${C}"`)}return{href:i,dimensions:h}}e.parseHrefAndDimensions=b}),define(ye[34],Se([0,1,9]),function(Z,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(t||(t={})),function(S){const P="error",A="warning",I="warn",D="info",T="ignore";function R(i){return i?r.equalsIgnoreCase(P,i)?S.Error:r.equalsIgnoreCase(A,i)||r.equalsIgnoreCase(I,i)?S.Warning:r.equalsIgnoreCase(D,i)?S.Info:S.Ignore:S.Ignore}S.fromValue=R;function b(i){switch(i){case S.Error:return P;case S.Warning:return A;case S.Info:return D;default:return T}}S.toString=b}(t||(t={})),e.default=t}),define(ye[35],Se([0,1,17,23,9,13]),function(Z,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(f){return f===47||f===92}e.isPathSeparator=A;function I(f){return f.replace(/[\\/]/g,r.posix.sep)}e.toSlashes=I;function D(f){return f.indexOf("/")===-1&&(f=I(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.toPosixPath=D;function T(f,g=r.posix.sep){if(!f)return"";const s=f.length,d=f.charCodeAt(0);if(A(d)){if(A(f.charCodeAt(1))&&!A(f.charCodeAt(2))){let E=3;const v=E;for(;E<s&&!A(f.charCodeAt(E));E++);if(v!==E&&!A(f.charCodeAt(E+1))){for(E+=1;E<s;E++)if(A(f.charCodeAt(E)))return f.slice(0,E+1).replace(/[\\/]/g,g)}}return g}else if(M(d)&&f.charCodeAt(1)===58)return A(f.charCodeAt(2))?f.slice(0,2)+g:f.slice(0,2);let p=f.indexOf("://");if(p!==-1){for(p+=3;p<s;p++)if(A(f.charCodeAt(p)))return f.slice(0,p+1)}return""}e.getRoot=T;function R(f){if(!t.isWindows||!f||f.length<5)return!1;let g=f.charCodeAt(0);if(g!==92||(g=f.charCodeAt(1),g!==92))return!1;let s=2;const d=s;for(;s<f.length&&(g=f.charCodeAt(s),g!==92);s++);return!(d===s||(g=f.charCodeAt(s+1),isNaN(g)||g===92))}e.isUNC=R;const b=/[\\/:\*\?"<>\|]/g,i=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(f,g=t.isWindows){const s=g?b:i;return!(!f||f.length===0||/^\s+$/.test(f)||(s.lastIndex=0,s.test(f))||g&&h.test(f)||f==="."||f===".."||g&&f[f.length-1]==="."||g&&f.length!==f.trim().length||f.length>255)}e.isValidBasename=l;function o(f,g,s){const d=f===g;return!s||d?d:!f||!g?!1:(0,S.equalsIgnoreCase)(f,g)}e.isEqual=o;function m(f,g,s,d=r.sep){if(f===g)return!0;if(!f||!g||g.length>f.length)return!1;if(s){if(!(0,S.startsWithIgnoreCase)(f,g))return!1;if(g.length===f.length)return!0;let E=g.length;return g.charAt(g.length-1)===d&&E--,f.charAt(E)===d}return g.charAt(g.length-1)!==d&&(g+=d),f.indexOf(g)===0}e.isEqualOrParent=m;function M(f){return f>=65&&f<=90||f>=97&&f<=122}e.isWindowsDriveLetter=M;function C(f,g){return t.isWindows&&f.endsWith(":")&&(f+=r.sep),(0,r.isAbsolute)(f)||(f=(0,r.join)(g,f)),f=(0,r.normalize)(f),t.isWindows?(f=(0,S.rtrim)(f,r.sep),f.endsWith(":")&&(f+=r.sep)):(f=(0,S.rtrim)(f,r.sep),f||(f=r.sep)),f}e.sanitizeFilePath=C;function w(f){const g=(0,r.normalize)(f);return t.isWindows?f.length>3?!1:u(g)&&(f.length===2||g.charCodeAt(2)===92):g===r.posix.sep}e.isRootOrDriveLetter=w;function u(f,g){return(g!==void 0?g:t.isWindows)?M(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function _(f){return u(f)?f[0]:void 0}e.getDriveLetter=_;function a(f,g,s){return g.length>f.length?-1:f===g?0:(s&&(f=f.toLowerCase(),g=g.toLowerCase()),f.indexOf(g))}e.indexOfPath=a;function F(f){const g=f.split(":");let s,d,p;for(const E of g){const v=Number(E);(0,P.isNumber)(v)?d===void 0?d=v:p===void 0&&(p=v):s=s?[s,E].join(":"):E}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:d!==void 0?d:void 0,column:p!==void 0?p:d!==void 0?1:void 0}}e.parseLineAndColumnAware=F;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(f,g,s=8){let d="";for(let E=0;E<s;E++)d+=c.charAt(Math.floor(Math.random()*c.length));let p;return g?p=`${g}-${d}`:p=d,f?(0,r.join)(f,p):p}e.randomPath=n}),define(ye[55],Se([0,1,21,9,2]),function(Z,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function P(R){return JSON.stringify(R,D)}e.stringify=P;function A(R){let b=JSON.parse(R);return b=T(b),b}e.parse=A;var I;(function(R){R[R.Uri=1]="Uri",R[R.Regexp=2]="Regexp",R[R.ScmResource=3]="ScmResource",R[R.ScmResourceGroup=4]="ScmResourceGroup",R[R.ScmProvider=5]="ScmProvider",R[R.CommentController=6]="CommentController",R[R.CommentThread=7]="CommentThread",R[R.CommentThreadReply=8]="CommentThreadReply",R[R.CommentNode=9]="CommentNode",R[R.CommentThreadNode=10]="CommentThreadNode",R[R.TimelineActionContext=11]="TimelineActionContext",R[R.NotebookCellActionContext=12]="NotebookCellActionContext",R[R.TestItemContext=13]="TestItemContext",R[R.Date=14]="Date"})(I=e.MarshalledId||(e.MarshalledId={}));function D(R,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,t.regExpFlags)(b)}:b}function T(R,b=0){if(!R||b>200)return R;if(typeof R=="object"){switch(R.$mid){case 1:return S.URI.revive(R);case 2:return new RegExp(R.source,R.flags);case 14:return new Date(R.source)}if(R instanceof r.VSBuffer||R instanceof Uint8Array)return R;if(Array.isArray(R))for(let i=0;i<R.length;++i)R[i]=T(R[i],b+1);else for(const i in R)Object.hasOwnProperty.call(R,i)&&(R[i]=T(R[i],b+1))}return R}e.revive=T}),define(ye[11],Se([0,1,23,2]),function(Z,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var S;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls"})(S=e.Schemas||(e.Schemas={}));class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,T,R){this._hosts[D]=T,this._ports[D]=R}setConnectionToken(D,T){this._connectionTokens[D]=T}rewrite(D){if(this._delegate)return this._delegate(D);const T=D.authority;let R=this._hosts[T];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const b=this._ports[T],i=this._connectionTokens[T];let h=`path=${encodeURIComponent(D.path)}`;return typeof i=="string"&&(h+=`&tkn=${encodeURIComponent(i)}`),t.URI.from({scheme:r.isWeb?this._preferredWebSchema:S.vscodeRemoteResource,authority:`${R}:${b}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new P;class A{asBrowserUri(D,T){const R=this.toUri(D,T);return R.scheme===S.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===S.file&&(r.isNative||typeof r.globals.importScripts=="function"&&r.globals.origin===`${S.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?R.with({scheme:S.vscodeFileResource,authority:R.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(D,T){const R=this.toUri(D,T);return R.scheme===S.vscodeFileResource?R.with({scheme:S.file,authority:R.authority!==A.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(D,T){return t.URI.isUri(D)?D:t.URI.parse(T.toUrl(D))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(ye[24],Se([0,1,35,11,17,23,9,2]),function(Z,e,r,t,S,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(h){return(0,I.uriToFsPath)(h,!0)}e.originalFSPath=D;class T{constructor(l){this._ignorePathCasing=l}compare(l,o,m=!1){return l===o?0:(0,A.compare)(this.getComparisonKey(l,m),this.getComparisonKey(o,m))}isEqual(l,o,m=!1){return l===o?!0:!l||!o?!1:this.getComparisonKey(l,m)===this.getComparisonKey(o,m)}getComparisonKey(l,o=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,o,m=!1){if(l.scheme===o.scheme){if(l.scheme===t.Schemas.file)return r.isEqualOrParent(D(l),D(o),this._ignorePathCasing(l))&&l.query===o.query&&(m||l.fragment===o.fragment);if((0,e.isEqualAuthority)(l.authority,o.authority))return r.isEqualOrParent(l.path,o.path,this._ignorePathCasing(l),"/")&&l.query===o.query&&(m||l.fragment===o.fragment)}return!1}joinPath(l,...o){return I.URI.joinPath(l,...o)}basenameOrAuthority(l){return(0,e.basename)(l)||l.authority}basename(l){return S.posix.basename(l.path)}extname(l){return S.posix.extname(l.path)}dirname(l){if(l.path.length===0)return l;let o;return l.scheme===t.Schemas.file?o=I.URI.file(S.dirname(D(l))).path:(o=S.posix.dirname(l.path),l.authority&&o.length&&o.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),o="/")),l.with({path:o})}normalizePath(l){if(!l.path.length)return l;let o;return l.scheme===t.Schemas.file?o=I.URI.file(S.normalize(D(l))).path:o=S.posix.normalize(l.path),l.with({path:o})}relativePath(l,o){if(l.scheme!==o.scheme||!(0,e.isEqualAuthority)(l.authority,o.authority))return;if(l.scheme===t.Schemas.file){const C=S.relative(D(l),D(o));return P.isWindows?r.toSlashes(C):C}let m=l.path||"/",M=o.path||"/";if(this._ignorePathCasing(l)){let C=0;for(const w=Math.min(m.length,M.length);C<w&&!(m.charCodeAt(C)!==M.charCodeAt(C)&&m.charAt(C).toLowerCase()!==M.charAt(C).toLowerCase());C++);m=M.substr(0,C)+m.substr(C)}return S.posix.relative(m,M)}resolvePath(l,o){if(l.scheme===t.Schemas.file){const m=I.URI.file(S.resolve(D(l),o));return l.with({authority:m.authority,path:m.path})}return o=r.toPosixPath(o),l.with({path:S.posix.resolve(l.path,o)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,o){return l===o||l!==void 0&&o!==void 0&&(0,A.equalsIgnoreCase)(l,o)}hasTrailingPathSeparator(l,o=S.sep){if(l.scheme===t.Schemas.file){const m=D(l);return m.length>r.getRoot(m).length&&m[m.length-1]===o}else{const m=l.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,o=S.sep){return(0,e.hasTrailingPathSeparator)(l,o)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,o=S.sep){let m=!1;if(l.scheme===t.Schemas.file){const M=D(l);m=M!==void 0&&M.length===r.getRoot(M).length&&M[M.length-1]===o}else{o="/";const M=l.path;m=M.length===1&&M.charCodeAt(M.length-1)===47}return!m&&!(0,e.hasTrailingPathSeparator)(l,o)?l.with({path:l.path+"/"}):l}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(h=>h.scheme===t.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new T(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(h,l){const o=[];for(let m=0;m<h.length;m++){const M=l(h[m]);h.some((C,w)=>w===m?!1:(0,e.isEqualOrParent)(M,l(C)))||o.push(h[m])}return o}e.distinctParents=R;var b;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function l(o){const m=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(w=>{const[u,_]=w.split(":");u&&_&&m.set(u,_)});const C=o.path.substring(0,o.path.indexOf(";"));return C&&m.set(h.META_DATA_MIME,C),m}h.parseMetaData=l})(b=e.DataUri||(e.DataUri={}));function i(h,l,o){if(l){let m=h.path;return m&&m[0]!==S.posix.sep&&(m=S.posix.sep+m),h.with({scheme:o,authority:l,path:m})}return h.with({scheme:o})}e.toLocalResource=i}),define(ye[10],Se([0,1,20,15,4,6,24,23]),function(Z,e,r,t,S,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(me){return!!me&&typeof me.then=="function"}e.isThenable=D;function T(me){const oe=new r.CancellationTokenSource,Ee=me(oe.token),Pe=new Promise((Oe,je)=>{const st=oe.token.onCancellationRequested(()=>{st.dispose(),oe.dispose(),je(new t.CancellationError)});Promise.resolve(Ee).then(et=>{st.dispose(),oe.dispose(),Oe(et)},et=>{st.dispose(),oe.dispose(),je(et)})});return new class{cancel(){oe.cancel()}then(Oe,je){return Pe.then(Oe,je)}catch(Oe){return this.then(void 0,Oe)}finally(Oe){return Pe.finally(Oe)}}}e.createCancelablePromise=T;function R(me,oe,Ee){return new Promise((Pe,Oe)=>{const je=oe.onCancellationRequested(()=>{je.dispose(),Pe(Ee)});me.then(Pe,Oe).finally(()=>je.dispose())})}e.raceCancellation=R;function b(me,oe){return new Promise((Ee,Pe)=>{const Oe=oe.onCancellationRequested(()=>{Oe.dispose(),Pe(new t.CancellationError)});me.then(Ee,Pe).finally(()=>Oe.dispose())})}e.raceCancellationError=b;async function i(me){let oe=-1;const Ee=me.map((Oe,je)=>Oe.then(st=>(oe=je,st))),Pe=await Promise.race(Ee);return me.forEach((Oe,je)=>{je!==oe&&Oe.cancel()}),Pe}e.raceCancellablePromises=i;function h(me,oe,Ee){let Pe;const Oe=setTimeout(()=>{Pe?.(void 0),Ee?.()},oe);return Promise.race([me.finally(()=>clearTimeout(Oe)),new Promise(je=>Pe=je)])}e.raceTimeout=h;function l(me){return new Promise((oe,Ee)=>{const Pe=me();D(Pe)?Pe.then(oe,Ee):oe(Pe)})}e.asPromise=l;class o{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(oe){if(this.activePromise){if(this.queuedPromiseFactory=oe,!this.queuedPromise){const Ee=()=>{this.queuedPromise=null;const Pe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Pe};this.queuedPromise=new Promise(Pe=>{this.activePromise.then(Ee,Ee).then(Pe)})}return new Promise((Ee,Pe)=>{this.queuedPromise.then(Ee,Pe)})}return this.activePromise=oe(),new Promise((Ee,Pe)=>{this.activePromise.then(Oe=>{this.activePromise=null,Ee(Oe)},Oe=>{this.activePromise=null,Pe(Oe)})})}}e.Throttler=o;class m{constructor(){this.current=Promise.resolve(null)}queue(oe){return this.current=this.current.then(()=>oe(),()=>oe())}}e.Sequencer=m;class M{constructor(){this.promiseMap=new Map}queue(oe,Ee){const Oe=(this.promiseMap.get(oe)??Promise.resolve()).catch(()=>{}).then(Ee).finally(()=>{this.promiseMap.get(oe)===Oe&&this.promiseMap.delete(oe)});return this.promiseMap.set(oe,Oe),Oe}}e.SequencerByKey=M;const C=(me,oe)=>{let Ee=!0;const Pe=setTimeout(()=>{Ee=!1,oe()},me);return{isTriggered:()=>Ee,dispose:()=>{clearTimeout(Pe),Ee=!1}}},w=me=>{let oe=!0;return queueMicrotask(()=>{oe&&(oe=!1,me())}),{isTriggered:()=>oe,dispose:()=>{oe=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class u{constructor(oe){this.defaultDelay=oe,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(oe,Ee=this.defaultDelay){this.task=oe,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Oe,je)=>{this.doResolve=Oe,this.doReject=je}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Oe=this.task;return this.task=null,Oe()}}));const Pe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=Ee===e.MicrotaskDelay?w(Pe):C(Ee,Pe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=u;class _{constructor(oe){this.delayer=new u(oe),this.throttler=new o}trigger(oe,Ee){return this.delayer.trigger(()=>this.throttler.queue(oe),Ee)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=_;class a{constructor(){this._isOpen=!1,this._promise=new Promise((oe,Ee)=>{this._completePromise=oe})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class F extends a{constructor(oe){super();this._timeout=setTimeout(()=>this.open(),oe)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=F;function c(me,oe){return oe?new Promise((Ee,Pe)=>{const Oe=setTimeout(()=>{je.dispose(),Ee()},me),je=oe.onCancellationRequested(()=>{clearTimeout(Oe),je.dispose(),Pe(new t.CancellationError)})}):T(Ee=>c(me,Ee))}e.timeout=c;function n(me,oe=0){const Ee=setTimeout(me,oe);return(0,P.toDisposable)(()=>clearTimeout(Ee))}e.disposableTimeout=n;function f(me){const oe=[];let Ee=0;const Pe=me.length;function Oe(){return Ee<Pe?me[Ee++]():null}function je(st){st!=null&&oe.push(st);const et=Oe();return et?et.then(je):Promise.resolve(oe)}return Promise.resolve(null).then(je)}e.sequence=f;function g(me,oe=Pe=>!!Pe,Ee=null){let Pe=0;const Oe=me.length,je=()=>{if(Pe>=Oe)return Promise.resolve(Ee);const st=me[Pe++];return Promise.resolve(st()).then(tt=>oe(tt)?Promise.resolve(tt):je())};return je()}e.first=g;function s(me,oe=Pe=>!!Pe,Ee=null){if(me.length===0)return Promise.resolve(Ee);let Pe=me.length;const Oe=()=>{Pe=-1;for(const je of me)je.cancel?.()};return new Promise((je,st)=>{for(const et of me)et.then(tt=>{--Pe>=0&&oe(tt)?(Oe(),je(tt)):Pe===0&&je(Ee)}).catch(tt=>{--Pe>=0&&(Oe(),st(tt))})})}e.firstParallel=s;class d{constructor(oe){this._size=0,this.maxDegreeOfParalellism=oe,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new S.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(oe){return this._size++,new Promise((Ee,Pe)=>{this.outstandingPromises.push({factory:oe,c:Ee,e:Pe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const oe=this.outstandingPromises.shift();this.runningPromises++;const Ee=oe.factory();Ee.then(oe.c,oe.e),Ee.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=d;class p extends d{constructor(){super(1)}}e.Queue=p;class E{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const oe=new ie;return this.drainers.add(oe),oe.p}isDrained(){for(const[,oe]of this.queues)if(oe.size>0)return!1;return!0}queueFor(oe,Ee=A.extUri){const Pe=Ee.getComparisonKey(oe);let Oe=this.queues.get(Pe);return Oe||(Oe=new p,S.Event.once(Oe.onFinished)(()=>{Oe?.dispose(),this.queues.delete(Pe),this.onDidQueueFinish()}),this.queues.set(Pe,Oe)),Oe}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const oe of this.drainers)oe.complete();this.drainers.clear()}dispose(){for(const[,oe]of this.queues)oe.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=E;class v{constructor(oe,Ee){this._token=-1,typeof oe=="function"&&typeof Ee=="number"&&this.setIfNotSet(oe,Ee)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(oe,Ee){this.cancel(),this._token=setTimeout(()=>{this._token=-1,oe()},Ee)}setIfNotSet(oe,Ee){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,oe()},Ee))}}e.TimeoutTimer=v;class k{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(oe,Ee){this.cancel(),this._token=setInterval(()=>{oe()},Ee)}}e.IntervalTimer=k;class L{constructor(oe,Ee){this.timeoutToken=-1,this.runner=oe,this.timeout=Ee,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(oe=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,oe)}get delay(){return this.timeout}set delay(oe){this.timeout=oe}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=L;class y{constructor(oe,Ee){Ee%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Ee}ms is not a multiple of 1000ms.`),this.runner=oe,this.timeout=Ee,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(oe=this.timeout){oe%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(oe/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=y;class O extends L{constructor(oe,Ee){super(oe,Ee);this.units=[]}work(oe){this.units.push(oe),this.isScheduled()||this.schedule()}doRun(){const oe=this.units;this.units=[],this.runner&&this.runner(oe)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O;class U extends P.Disposable{constructor(oe,Ee){super();this.options=oe,this.handler=Ee,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(oe){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+oe.length>this.options.maxBufferedWork)return!1}else if(this.pending+oe.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...oe),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new L(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=me=>{(0,I.setTimeout0)(()=>{if(oe)return;const Ee=Date.now()+15;me(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Ee-Date.now())}}))});let oe=!1;return{dispose(){oe||(oe=!0)}}}:e.runWhenIdle=(me,oe)=>{const Ee=requestIdleCallback(me,typeof oe=="number"?{timeout:oe}:void 0);let Pe=!1;return{dispose(){Pe||(Pe=!0,cancelIdleCallback(Ee))}}}}();class q{constructor(oe){this._didRun=!1,this._executor=()=>{try{this._value=oe()}catch(Ee){this._error=Ee}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=q;async function H(me,oe,Ee){let Pe;for(let Oe=0;Oe<Ee;Oe++)try{return await me()}catch(je){Pe=je,await c(oe)}throw Pe}e.retry=H;class z{hasPending(oe){return this._pending?typeof oe=="number"?this._pending.taskId===oe:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(oe,Ee,Pe){return this._pending={taskId:oe,cancel:()=>Pe?.(),promise:Ee},Ee.then(()=>this.donePending(oe),()=>this.donePending(oe)),Ee}donePending(oe){this._pending&&oe===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const oe=this._next;this._next=void 0,oe.run().then(oe.promiseResolve,oe.promiseReject)}}setNext(oe){if(this._next)this._next.run=oe;else{let Ee,Pe;const Oe=new Promise((je,st)=>{Ee=je,Pe=st});this._next={run:oe,promise:Oe,promiseResolve:Ee,promiseReject:Pe}}return this._next.promise}}e.TaskSequentializer=z;class j{constructor(oe,Ee=()=>Date.now()){this.interval=oe,this.nowFn=Ee,this.lastIncrementTime=0,this.value=0}increment(){const oe=this.nowFn();return oe-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=oe,this.value=0),this.value++,this.value}}e.IntervalCounter=j;class ie{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((oe,Ee)=>{this.completeCallback=oe,this.errorCallback=Ee})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(oe){return new Promise(Ee=>{this.completeCallback(oe),this.resolved=!0,Ee()})}error(oe){return new Promise(Ee=>{this.errorCallback(oe),this.rejected=!0,Ee()})}cancel(){new Promise(oe=>{this.errorCallback(new t.CancellationError),this.rejected=!0,oe()})}}e.DeferredPromise=ie;var ae;(function(me){async function oe(Pe){let Oe;const je=await Promise.all(Pe.map(st=>st.then(et=>et,et=>{Oe||(Oe=et)})));if(typeof Oe!="undefined")throw Oe;return je}me.settled=oe;function Ee(Pe){return new Promise(async(Oe,je)=>{try{await Pe(Oe,je)}catch(st){je(st)}})}me.withAsyncBody=Ee})(ae=e.Promises||(e.Promises={}));var te;(function(me){me[me.Initial=0]="Initial",me[me.DoneOK=1]="DoneOK",me[me.DoneError=2]="DoneError"})(te||(te={}));class ue{constructor(oe){this._state=0,this._results=[],this._error=null,this._onStateChanged=new S.Emitter,queueMicrotask(async()=>{const Ee={emitOne:Pe=>this.emitOne(Pe),emitMany:Pe=>this.emitMany(Pe),reject:Pe=>this.reject(Pe)};try{await Promise.resolve(oe(Ee)),this.resolve()}catch(Pe){this.reject(Pe)}finally{Ee.emitOne=void 0,Ee.emitMany=void 0,Ee.reject=void 0}})}static fromArray(oe){return new ue(Ee=>{Ee.emitMany(oe)})}static fromPromise(oe){return new ue(async Ee=>{Ee.emitMany(await oe)})}static fromPromises(oe){return new ue(async Ee=>{await Promise.all(oe.map(async Pe=>Ee.emitOne(await Pe)))})}static merge(oe){return new ue(async Ee=>{await Promise.all(oe.map(async Pe=>{for await(const Oe of Pe)Ee.emitOne(Oe)}))})}[Symbol.asyncIterator](){let oe=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(oe<this._results.length)return{done:!1,value:this._results[oe++]};if(this._state===1)return{done:!0,value:void 0};await S.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(oe,Ee){return new ue(async Pe=>{for await(const Oe of oe)Pe.emitOne(Ee(Oe))})}map(oe){return ue.map(this,oe)}static filter(oe,Ee){return new ue(async Pe=>{for await(const Oe of oe)Ee(Oe)&&Pe.emitOne(Oe)})}filter(oe){return ue.filter(this,oe)}static coalesce(oe){return ue.filter(oe,Ee=>!!Ee)}coalesce(){return ue.coalesce(this)}static async toPromise(oe){const Ee=[];for await(const Pe of oe)Ee.push(Pe);return Ee}toPromise(){return ue.toPromise(this)}emitOne(oe){this._state===0&&(this._results.push(oe),this._onStateChanged.fire())}emitMany(oe){this._state===0&&(this._results=this._results.concat(oe),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(oe){this._state===0&&(this._state=2,this._error=oe,this._onStateChanged.fire())}}e.AsyncIterableObject=ue,ue.EMPTY=ue.fromArray([]);class be extends ue{constructor(oe,Ee){super(Ee);this._source=oe}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=be;function pe(me){const oe=new r.CancellationTokenSource,Ee=me(oe.token);return new be(oe,async Pe=>{const Oe=oe.token.onCancellationRequested(()=>{Oe.dispose(),oe.dispose(),Pe.reject(new t.CancellationError)});try{for await(const je of Ee){if(oe.token.isCancellationRequested)return;Pe.emitOne(je)}Oe.dispose(),oe.dispose()}catch(je){Oe.dispose(),oe.dispose(),Pe.reject(je)}})}e.createCancelableAsyncIterable=pe}),define(ye[104],Se([0,1,10,17]),function(Z,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const S=new r.IdleValue(()=>{const p=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:p,collatorIsNumeric:p.resolvedOptions().numeric}}),P=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(p,E,v=!1){const k=p||"",L=E||"",y=S.value.collator.compare(k,L);return S.value.collatorIsNumeric&&y===0&&k!==L?k<L?-1:1:y}e.compareFileNames=I;function D(p,E){const v=P.value.collator;return p=p||"",E=E||"",_(v,p,E)}e.compareFileNamesDefault=D;function T(p,E){const v=P.value.collator;return p=p||"",E=E||"",n(p,E)||_(v,p,E)}e.compareFileNamesUpper=T;function R(p,E){const v=P.value.collator;return p=p||"",E=E||"",c(p,E)||_(v,p,E)}e.compareFileNamesLower=R;function b(p,E){return p=p||"",E=E||"",p===E?0:p<E?-1:1}e.compareFileNamesUnicode=b;function i(p,E,v=!1){v||(p=p&&p.toLowerCase(),E=E&&E.toLowerCase());const[k,L]=w(p),[y,O]=w(E);return k!==y?k<y?-1:1:L===O?0:L<O?-1:1}e.noIntlCompareFileNames=i;function h(p,E){const[v,k]=w(p),[L,y]=w(E);let O=S.value.collator.compare(k,y);if(O===0){if(S.value.collatorIsNumeric&&k!==y)return k<y?-1:1;if(O=S.value.collator.compare(v,L),S.value.collatorIsNumeric&&O===0&&v!==L)return v<L?-1:1}return O}e.compareFileExtensions=h;function l(p,E){p=p||"",E=E||"";const v=u(p),k=u(E),L=P.value.collator,y=A.value.collator;return _(y,v,k)||_(L,p,E)}e.compareFileExtensionsDefault=l;function o(p,E){p=p||"",E=E||"";const v=u(p),k=u(E),L=P.value.collator,y=A.value.collator;return _(y,v,k)||n(p,E)||_(L,p,E)}e.compareFileExtensionsUpper=o;function m(p,E){p=p||"",E=E||"";const v=u(p),k=u(E),L=P.value.collator,y=A.value.collator;return _(y,v,k)||c(p,E)||_(L,p,E)}e.compareFileExtensionsLower=m;function M(p,E){p=p||"",E=E||"";const v=u(p).toLowerCase(),k=u(E).toLowerCase();return v!==k?v<k?-1:1:p!==E?p<E?-1:1:0}e.compareFileExtensionsUnicode=M;const C=/^(.*?)(\.([^.]*))?$/;function w(p,E=!1){const v=p?C.exec(p):[];let k=[v&&v[1]||"",v&&v[3]||""];return E&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function u(p){const E=p?C.exec(p):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function _(p,E,v){let k=p.compare(E,v);return k!==0?k:E.length!==v.length?E.length<v.length?-1:1:0}function a(p){const E=p.charAt(0);return E.toLocaleUpperCase()!==E}function F(p){const E=p.charAt(0);return E.toLocaleLowerCase()!==E}function c(p,E){return a(p)&&F(E)?-1:F(p)&&a(E)?1:0}function n(p,E){return F(p)&&a(E)?-1:a(p)&&F(E)?1:0}function f(p,E,v=!1){return v||(p=p&&p.toLowerCase(),E=E&&E.toLowerCase()),p===E?0:p<E?-1:1}function g(p,E,v=!1){const k=p.split(t.sep),L=E.split(t.sep),y=k.length-1,O=L.length-1;let U,q;for(let H=0;;H++){if(U=y===H,q=O===H,U&&q)return I(k[H],L[H],v);if(U)return-1;if(q)return 1;const z=f(k[H],L[H],v);if(z!==0)return z}}e.comparePaths=g;function s(p,E,v){const k=p.toLowerCase(),L=E.toLowerCase(),y=d(p,E,v);if(y)return y;const O=k.endsWith(v),U=L.endsWith(v);if(O!==U)return O?-1:1;const q=I(k,L);return q!==0?q:k.localeCompare(L)}e.compareAnything=s;function d(p,E,v){const k=p.toLowerCase(),L=E.toLowerCase(),y=k.startsWith(v),O=L.startsWith(v);if(y!==O)return y?-1:1;if(y&&O){if(k.length<L.length)return-1;if(k.length>L.length)return 1}return 0}e.compareByPrefix=d}),define(ye[29],Se([0,1,10,35,22,17,9]),function(Z,e,r,t,S,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const D="[/\\\\]",T="[^/\\\\]",R=/\//g;function b(j){switch(j){case 0:return"";case 1:return`${T}*?`;default:return`(?:${D}|${T}+${D}|${D}${T}+)*?`}}function i(j,ie){if(!j)return[];const ae=[];let te=!1,ue=!1,be="";for(const pe of j){switch(pe){case ie:if(!te&&!ue){ae.push(be),be="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}be+=pe}return be&&ae.push(be),ae}e.splitGlobAware=i;function h(j){if(!j)return"";let ie="";const ae=i(j,e.GLOB_SPLIT);if(ae.every(te=>te===e.GLOBSTAR))ie=".*";else{let te=!1;ae.forEach((ue,be)=>{if(ue===e.GLOBSTAR){te||(ie+=b(2),te=!0);return}let pe=!1,me="",oe=!1,Ee="";for(const Pe of ue){if(Pe!=="}"&&pe){me+=Pe;continue}if(oe&&(Pe!=="]"||!Ee)){let Oe;Pe==="-"?Oe=Pe:(Pe==="^"||Pe==="!")&&!Ee?Oe="^":Pe===e.GLOB_SPLIT?Oe="":Oe=A.escapeRegExpCharacters(Pe),Ee+=Oe;continue}switch(Pe){case"{":pe=!0;continue;case"[":oe=!0;continue;case"}":{ie+=`(?:${i(me,",").map(st=>h(st)).join("|")})`,pe=!1,me="";break}case"]":ie+="["+Ee+"]",oe=!1,Ee="";break;case"?":ie+=T;continue;case"*":ie+=b(1);continue;default:ie+=A.escapeRegExpCharacters(Pe)}}be<ae.length-1&&(ae[be+1]!==e.GLOBSTAR||be+2<ae.length)&&(ie+=D),te=!1})}return ie}const l=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,M=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,C=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,u=new S.LRUCache(1e4),_=function(){return!1},a=function(){return null};function F(j,ie){if(!j)return a;let ae;typeof j!="string"?ae=j.pattern:ae=j,ae=ae.trim();const te=`${ae}_${!!ie.trimForExclusions}`;let ue=u.get(te);if(ue)return c(ue,j);let be;if(l.test(ae)){const pe=ae.substr(4);ue=function(me,oe){return typeof me=="string"&&me.endsWith(pe)?ae:null}}else(be=o.exec(n(ae,ie)))?ue=f(be[1],ae):(ie.trimForExclusions?M:m).test(ae)?ue=g(ae,ie):(be=C.exec(n(ae,ie)))?ue=s(be[1].substr(1),ae,!0):(be=w.exec(n(ae,ie)))?ue=s(be[1],ae,!1):ue=d(ae);return u.set(te,ue),c(ue,j)}function c(j,ie){return typeof ie=="string"?j:function(ae,te){return t.isEqualOrParent(ae,ie.base)?j(P.relative(ie.base,ae),te):null}}function n(j,ie){return ie.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function f(j,ie){const ae=`/${j}`,te=`\\${j}`,ue=function(pe,me){return typeof pe!="string"?null:me?me===j?ie:null:pe===j||pe.endsWith(ae)||pe.endsWith(te)?ie:null},be=[j];return ue.basenames=be,ue.patterns=[ie],ue.allBasenames=be,ue}function g(j,ie){const ae=z(j.slice(1,-1).split(",").map(me=>F(me,ie)).filter(me=>me!==a),j),te=ae.length;if(!te)return a;if(te===1)return ae[0];const ue=function(me,oe){for(let Ee=0,Pe=ae.length;Ee<Pe;Ee++)if(ae[Ee](me,oe))return j;return null},be=ae.find(me=>!!me.allBasenames);be&&(ue.allBasenames=be.allBasenames);const pe=ae.reduce((me,oe)=>oe.allPaths?me.concat(oe.allPaths):me,[]);return pe.length&&(ue.allPaths=pe),ue}function s(j,ie,ae){const te=P.sep===P.posix.sep,ue=te?j:j.replace(R,P.sep),be=P.sep+ue,pe=P.posix.sep+j,me=ae?function(oe,Ee){return typeof oe=="string"&&(oe===ue||oe.endsWith(be)||!te&&(oe===j||oe.endsWith(pe)))?ie:null}:function(oe,Ee){return typeof oe=="string"&&(oe===ue||!te&&oe===j)?ie:null};return me.allPaths=[(ae?"*/":"./")+j],me}function d(j){try{const ie=new RegExp(`^${h(j)}$`);return function(ae){return ie.lastIndex=0,typeof ae=="string"&&ie.test(ae)?j:null}}catch{return a}}function p(j,ie,ae){return!j||typeof ie!="string"?!1:E(j)(ie,void 0,ae)}e.match=p;function E(j,ie={}){if(!j)return _;if(typeof j=="string"||y(j)){const ae=F(j,ie);if(ae===a)return _;const te=function(ue,be){return!!ae(ue,be)};return ae.allBasenames&&(te.allBasenames=ae.allBasenames),ae.allPaths&&(te.allPaths=ae.allPaths),te}return q(j,ie)}e.parse=E;function v(j){if(!j)return;let ie;return ae=>(ie||(ie=(j()||Promise.resolve([])).then(te=>te?L(te):{})),ie.then(te=>!!te[ae]))}e.hasSiblingPromiseFn=v;function k(j){if(!j)return;let ie;return ae=>{if(!ie){const te=j();ie=te?L(te):{}}return!!ie[ae]}}e.hasSiblingFn=k;function L(j){const ie={};for(const ae of j)ie[ae]=!0;return ie}function y(j){const ie=j;return ie?typeof ie.base=="string"&&typeof ie.pattern=="string":!1}e.isRelativePattern=y;function O(j){return j.allBasenames||[]}e.getBasenameTerms=O;function U(j){return j.allPaths||[]}e.getPathTerms=U;function q(j,ie){const ae=z(Object.getOwnPropertyNames(j).map(me=>H(me,j[me],ie)).filter(me=>me!==a)),te=ae.length;if(!te)return a;if(!ae.some(me=>!!me.requiresSiblings)){if(te===1)return ae[0];const me=function(Pe,Oe){for(let je=0,st=ae.length;je<st;je++){const et=ae[je](Pe,Oe);if(et)return et}return null},oe=ae.find(Pe=>!!Pe.allBasenames);oe&&(me.allBasenames=oe.allBasenames);const Ee=ae.reduce((Pe,Oe)=>Oe.allPaths?Pe.concat(Oe.allPaths):Pe,[]);return Ee.length&&(me.allPaths=Ee),me}const ue=function(me,oe,Ee){let Pe;for(let Oe=0,je=ae.length;Oe<je;Oe++){const st=ae[Oe];st.requiresSiblings&&Ee&&(oe||(oe=P.basename(me)),Pe||(Pe=oe.substr(0,oe.length-P.extname(me).length)));const et=st(me,oe,Pe,Ee);if(et)return et}return null},be=ae.find(me=>!!me.allBasenames);be&&(ue.allBasenames=be.allBasenames);const pe=ae.reduce((me,oe)=>oe.allPaths?me.concat(oe.allPaths):me,[]);return pe.length&&(ue.allPaths=pe),ue}function H(j,ie,ae){if(ie===!1)return a;const te=F(j,ae);if(te===a)return a;if(typeof ie=="boolean")return te;if(ie){const ue=ie.when;if(typeof ue=="string"){const be=(pe,me,oe,Ee)=>{if(!Ee||!te(pe,me))return null;const Pe=ue.replace("$(basename)",oe),Oe=Ee(Pe);return(0,r.isThenable)(Oe)?Oe.then(je=>je?j:null):Oe?j:null};return be.requiresSiblings=!0,be}}return te}function z(j,ie){const ae=j.filter(me=>!!me.basenames);if(ae.length<2)return j;const te=ae.reduce((me,oe)=>{const Ee=oe.basenames;return Ee?me.concat(Ee):me},[]);let ue;if(ie){ue=[];for(let me=0,oe=te.length;me<oe;me++)ue.push(ie)}else ue=ae.reduce((me,oe)=>{const Ee=oe.patterns;return Ee?me.concat(Ee):me},[]);const be=function(me,oe){if(typeof me!="string")return null;if(!oe){let Pe;for(Pe=me.length;Pe>0;Pe--){const Oe=me.charCodeAt(Pe-1);if(Oe===47||Oe===92)break}oe=me.substr(Pe)}const Ee=te.indexOf(oe);return Ee!==-1?ue[Ee]:null};be.basenames=te,be.patterns=ue,be.allBasenames=te;const pe=j.filter(me=>!me.basenames);return pe.push(be),pe}}),define(ye[76],Se([0,1,35,11,17,23,24,9,2]),function(Z,e,r,t,S,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function T(n,f,g){if(typeof n=="string"&&(n=D.URI.file(n)),g){const d=g.getWorkspaceFolder(n);if(d){const p=g.getWorkspace().folders.length>1;let E;if((0,A.isEqual)(d.uri,n)?E="":E=(0,A.relativePath)(d.uri,n),p){const v=d.name?d.name:(0,A.basename)(d.uri);E=E?v+" \u2022 "+E:v}return E}}if(n.scheme!==t.Schemas.file&&n.scheme!==t.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,r.hasDriveLetter)(n.fsPath))return(0,S.normalize)(b(n.fsPath));let s=(0,S.normalize)(n.fsPath);return!P.isWindows&&f?.userHome&&(s=h(s,f.userHome.fsPath)),s}e.getPathLabel=T;function R(n){if(!n)return;typeof n=="string"&&(n=D.URI.file(n));const f=(0,A.basename)(n)||(n.scheme===t.Schemas.file?n.fsPath:n.path);return P.isWindows&&(0,r.isRootOrDriveLetter)(f)?b(f):f}e.getBaseLabel=R;function b(n,f){return(0,r.hasDriveLetter)(n,f)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=b;let i=Object.create(null);function h(n,f){if(P.isWindows||!n||!f)return n;let g=i.original===f?i.normalized:void 0;return g||(g=`${(0,I.rtrim)(f,S.posix.sep)}${S.posix.sep}`,i={original:f,normalized:g}),(P.isLinux?n.startsWith(g):(0,I.startsWithIgnoreCase)(n,g))&&(n=`~/${n.substr(g.length)}`),n}e.tildify=h;function l(n,f){return n.replace(/^~($|\/|\\)/,`${f}$1`)}e.untildify=l;const o="\u2026",m="\\\\",M="~";function C(n,f=S.sep){const g=new Array(n.length);let s=!1;for(let d=0;d<n.length;d++){let p=n[d];if(p===""){g[d]=`.${f}`;continue}if(!p){g[d]=p;continue}s=!0;let E="";p.indexOf(m)===0?(E=p.substr(0,p.indexOf(m)+m.length),p=p.substr(p.indexOf(m)+m.length)):p.indexOf(f)===0?(E=p.substr(0,p.indexOf(f)+f.length),p=p.substr(p.indexOf(f)+f.length)):p.indexOf(M)===0&&(E=p.substr(0,p.indexOf(M)+M.length),p=p.substr(p.indexOf(M)+M.length));const v=p.split(f);for(let k=1;s&&k<=v.length;k++)for(let L=v.length-k;s&&L>=0;L--){s=!1;let y=v.slice(L,L+k).join(f);for(let O=0;!s&&O<n.length;O++)if(O!==d&&n[O]&&n[O].indexOf(y)>-1){const U=L+k===v.length,q=L>0&&n[O].indexOf(f)>-1?f+y:y,H=n[O].endsWith(q);s=!U||H}if(!s){let O="";(v[0].endsWith(":")||E!=="")&&(L===1&&(L=0,k++,y=v[0]+f+y),L>0&&(O=v[0]+f),O=E+O),L>0&&(O=O+o+f),O=O+y,L+k<v.length&&(O=O+f+o),g[d]=O}}s&&(g[d]=p)}return g}e.shorten=C;var w;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(w||(w={}));function u(n,f=Object.create(null)){const g=[];let s=!1,d="";for(const p of n)if(p==="$"||s&&p==="{")d&&g.push({value:d,type:w.TEXT}),d="",s=!0;else if(p==="}"&&s){const E=f[d];if(typeof E=="string")E.length&&g.push({value:E,type:w.VARIABLE});else if(E){const v=g[g.length-1];(!v||v.type!==w.SEPARATOR)&&g.push({value:E.label,type:w.SEPARATOR})}d="",s=!1}else d+=p;return d&&!s&&g.push({value:d,type:w.TEXT}),g.filter((p,E)=>{if(p.type===w.SEPARATOR){const v=g[E-1],k=g[E+1];return[v,k].every(L=>L&&(L.type===w.VARIABLE||L.type===w.TEXT)&&L.value.length>0)}return!0}).map(p=>p.value).join("")}e.template=u;function _(n,f){return P.isMacintosh||f?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):n.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.mnemonicMenuLabel=_;function a(n,f){return P.isMacintosh||f?n.replace(/\(&&\w\)|&&/g,""):P.isWindows?n.replace(/&&|&/g,g=>g==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function F(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=F;function c(n){const f=n.indexOf("/")!==-1?S.posix:S.win32,g=f.basename(n),s=f.dirname(n);return g.length?{name:g,parentPath:s}:{name:s,parentPath:""}}e.splitName=c}),define(ye[105],Se([0,1,2]),function(Z,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(R){return R.toJSON()}class S{constructor(b){this._uriTransformer=b}transformIncoming(b){const i=this._uriTransformer.transformIncoming(b);return i===b?b:t(r.URI.from(i))}transformOutgoing(b){const i=this._uriTransformer.transformOutgoing(b);return i===b?b:t(r.URI.from(i))}transformOutgoingURI(b){const i=this._uriTransformer.transformOutgoing(b);return i===b?b:r.URI.from(i)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=S,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function P(R,b,i){if(!R||i>200)return null;if(typeof R=="object"){if(R instanceof r.URI)return b.transformOutgoing(R);for(let h in R)if(Object.hasOwnProperty.call(R,h)){const l=P(R[h],b,i+1);l!==null&&(R[h]=l)}}return null}function A(R,b){const i=P(R,b,0);return i===null?R:i}e.transformOutgoingURIs=A;function I(R,b,i,h){if(!R||h>200)return null;if(typeof R=="object"){if(R.$mid===1)return i?r.URI.revive(b.transformIncoming(R)):b.transformIncoming(R);for(let l in R)if(Object.hasOwnProperty.call(R,l)){const o=I(R[l],b,i,h+1);o!==null&&(R[l]=o)}}return null}function D(R,b){const i=I(R,b,!1,0);return i===null?R:i}e.transformIncomingURIs=D;function T(R,b){const i=I(R,b,!0,0);return i===null?R:i}e.transformAndReviveIncomingURIs=T}),define(ye[36],Se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(D){return r.test(D)}e.isUUID=t;const S=new Uint8Array(16),P=[];for(let D=0;D<256;D++)P.push(D.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(D){for(let T=0;T<D.length;T++)D[T]=Math.floor(Math.random()*256);return D};function I(){A(S),S[6]=S[6]&15|64,S[8]=S[8]&63|128;let D=0,T="";return T+=P[S[D++]],T+=P[S[D++]],T+=P[S[D++]],T+=P[S[D++]],T+="-",T+=P[S[D++]],T+=P[S[D++]],T+="-",T+=P[S[D++]],T+=P[S[D++]],T+="-",T+=P[S[D++]],T+=P[S[D++]],T+="-",T+=P[S[D++]],T+=P[S[D++]],T+=P[S[D++]],T+=P[S[D++]],T+=P[S[D++]],T+=P[S[D++]],T}e.generateUuid=I}),define(ye[106],Se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var r;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(r=e.IndentAction||(e.IndentAction={}));class t{constructor(I){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=I.open,this.close=I.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(I.notIn))for(let D=0,T=I.notIn.length;D<T;D++)switch(I.notIn[D]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(I){switch(I){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(I,D){if(I.getTokenCount()===0)return!0;const T=I.findTokenIndexAtOffset(D-2),R=I.getStandardTokenType(T);return this.isOK(R)}_findNeutralCharacterInRange(I,D){for(let T=I;T<=D;T++){const R=String.fromCharCode(T);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class S{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of I)P(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),P(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),P(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),P(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&P(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=S;function P(A,I,D){A.has(I)?A.get(I).push(D):A.set(I,[D])}}),define(ye[56],Se([0,1,29,17]),function(Z,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function S(P,A,I,D){if(Array.isArray(P)){let T=0;for(const R of P){const b=S(R,A,I,D);if(b===10)return b;b>T&&(T=b)}return T}else{if(typeof P=="string")return D?P==="*"?5:P===I?10:0:0;if(P){const{language:T,pattern:R,scheme:b,hasAccessToAllModels:i}=P;if(!D&&!i)return 0;let h=0;if(b)if(b===A.scheme)h=10;else if(b==="*")h=5;else return 0;if(T)if(T===I)h=10;else if(T==="*")h=Math.max(h,5);else return 0;if(R){let l;if(typeof R=="string"?l=R:l={...R,base:(0,t.normalize)(R.base)},l===A.fsPath||(0,r.match)(l,A.fsPath))h=10;else return 0}return h}else return 0}}e.score=S}),define(ye[107],Se([0,1,4,6]),function(Z,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class S{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new r.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(I){this._onDidChange.fire({changedLanguages:I,changedColorMap:!1})}register(I,D){return this._map.set(I,D),this.fire([I]),(0,t.toDisposable)(()=>{this._map.get(I)===D&&(this._map.delete(I),this.fire([I]))})}registerFactory(I,D){this._factories.get(I)?.dispose();const T=new P(this,I,D);return this._factories.set(I,T),(0,t.toDisposable)(()=>{const R=this._factories.get(I);!R||R!==T||(this._factories.delete(I),R.dispose())})}async getOrCreate(I){const D=this.get(I);if(D)return D;const T=this._factories.get(I);return!T||T.isResolved?null:(await T.resolve(),this.get(I))}get(I){return this._map.get(I)||null}isResolved(I){if(this.get(I))return!0;const T=this._factories.get(I);return!!(!T||T.isResolved)}setColorMap(I){this._colorMap=I,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=S;class P extends t.Disposable{constructor(I,D,T){super();this._registry=I,this._languageId=D,this._factory=T,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const I=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,I&&!this._isDisposed&&this._register(this._registry.register(this._languageId,I))}}}),define(ye[77],Se([0,1,21,23]),function(Z,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var S;(function(b){b[b.Full=1]="Full",b[b.Delta=2]="Delta"})(S||(S={}));function P(b){for(let i=0,h=b.length;i<h;i+=4){const l=b[i+0],o=b[i+1],m=b[i+2],M=b[i+3];b[i+0]=M,b[i+1]=m,b[i+2]=o,b[i+3]=l}}function A(b){const i=new Uint8Array(b.buffer,b.byteOffset,b.length*4);return t.isLittleEndian()||P(i),r.VSBuffer.wrap(i)}function I(b){const i=b.buffer;if(t.isLittleEndian()||P(i),i.byteOffset%4==0)return new Uint32Array(i.buffer,i.byteOffset,i.length/4);{const h=new Uint8Array(i.byteLength);return h.set(i),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function D(b){const i=new Uint32Array(T(b));let h=0;if(i[h++]=b.id,b.type==="full")i[h++]=1,i[h++]=b.data.length,i.set(b.data,h),h+=b.data.length;else{i[h++]=2,i[h++]=b.deltas.length;for(const l of b.deltas)i[h++]=l.start,i[h++]=l.deleteCount,l.data?(i[h++]=l.data.length,i.set(l.data,h),h+=l.data.length):i[h++]=0}return A(i)}e.encodeSemanticTokensDto=D;function T(b){let i=0;if(i+=1+1,b.type==="full")i+=1+b.data.length;else{i+=1,i+=(1+1+1)*b.deltas.length;for(const h of b.deltas)h.data&&(i+=h.data.length)}return i}function R(b){const i=I(b);let h=0;const l=i[h++];if(i[h++]===1){const C=i[h++],w=i.subarray(h,h+C);return h+=C,{id:l,type:"full",data:w}}const m=i[h++],M=[];for(let C=0;C<m;C++){const w=i[h++],u=i[h++],_=i[h++];let a;_>0&&(a=i.subarray(h,h+_),h+=_),M[C]={start:w,deleteCount:u,data:a}}return{id:l,type:"delta",deltas:M}}e.decodeSemanticTokensDto=R}),define(ye[108],Se([18,19]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(ye[109],Se([0,1,108]),function(Z,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,S=t*60,P=S*24,A=P*7,I=P*30,D=P*365;function T(b,i,h){typeof b!="number"&&(b=b.getTime());const l=Math.round((new Date().getTime()-b)/1e3);if(l<-30)return(0,r.localize)(0,null,T(new Date().getTime()+l*1e3,!1));if(l<30)return(0,r.localize)(1,null);let o;return l<t?(o=l,i?o===1?h?(0,r.localize)(2,null,o):(0,r.localize)(3,null,o):h?(0,r.localize)(4,null,o):(0,r.localize)(5,null,o):o===1?h?(0,r.localize)(6,null,o):(0,r.localize)(7,null,o):h?(0,r.localize)(8,null,o):(0,r.localize)(9,null,o)):l<S?(o=Math.floor(l/t),i?o===1?h?(0,r.localize)(10,null,o):(0,r.localize)(11,null,o):h?(0,r.localize)(12,null,o):(0,r.localize)(13,null,o):o===1?h?(0,r.localize)(14,null,o):(0,r.localize)(15,null,o):h?(0,r.localize)(16,null,o):(0,r.localize)(17,null,o)):l<P?(o=Math.floor(l/S),i?o===1?h?(0,r.localize)(18,null,o):(0,r.localize)(19,null,o):h?(0,r.localize)(20,null,o):(0,r.localize)(21,null,o):o===1?h?(0,r.localize)(22,null,o):(0,r.localize)(23,null,o):h?(0,r.localize)(24,null,o):(0,r.localize)(25,null,o)):l<A?(o=Math.floor(l/P),i?o===1?(0,r.localize)(26,null,o):(0,r.localize)(27,null,o):o===1?(0,r.localize)(28,null,o):(0,r.localize)(29,null,o)):l<I?(o=Math.floor(l/A),i?o===1?h?(0,r.localize)(30,null,o):(0,r.localize)(31,null,o):h?(0,r.localize)(32,null,o):(0,r.localize)(33,null,o):o===1?h?(0,r.localize)(34,null,o):(0,r.localize)(35,null,o):h?(0,r.localize)(36,null,o):(0,r.localize)(37,null,o)):l<D?(o=Math.floor(l/I),i?o===1?h?(0,r.localize)(38,null,o):(0,r.localize)(39,null,o):h?(0,r.localize)(40,null,o):(0,r.localize)(41,null,o):o===1?h?(0,r.localize)(42,null,o):(0,r.localize)(43,null,o):h?(0,r.localize)(44,null,o):(0,r.localize)(45,null,o)):(o=Math.floor(l/D),i?o===1?h?(0,r.localize)(46,null,o):(0,r.localize)(47,null,o):h?(0,r.localize)(48,null,o):(0,r.localize)(49,null,o):o===1?h?(0,r.localize)(50,null,o):(0,r.localize)(51,null,o):h?(0,r.localize)(52,null,o):(0,r.localize)(53,null,o))}e.fromNow=T;function R(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(ye[110],Se([18,19]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(ye[43],Se([0,1,16,13,110]),function(Z,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function P(T,R){return R&&(T.stack||T.stacktrace)?S.localize(0,null,I(T),A(T.stack)||A(T.stacktrace)):I(T)}function A(T){return Array.isArray(T)?T.join(`
`):T}function I(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?S.localize(1,null,T.message):T.message||S.localize(2,null)}function D(T=null,R=!1){if(!T)return S.localize(3,null);if(Array.isArray(T)){const b=r.coalesce(T),i=D(b[0],R);return b.length>1?S.localize(4,null,i,b.length):i}if(t.isString(T))return T;if(T.detail){const b=T.detail;if(b.error)return P(b.error,R);if(b.exception)return P(b.exception,R)}return T.stack?P(T,R):T.message?T.message:S.localize(5,null)}e.toErrorMessage=D}),define(ye[111],Se([18,19]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(ye[112],Se([0,1,111,23,113,16,27]),function(Z,e,r,t,S,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var I;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(I=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=D;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class R{constructor(Q,he,Be,qe){this.id=Q,this.name=he,this.defaultValue=Be,this.schema=qe}applyUpdate(Q,he){return i(Q,he)}compute(Q,he,Be){return Be}}class b{constructor(Q,he){this.newValue=Q,this.didChange=he}}e.ApplyUpdateResult=b;function i(G,Q){if(typeof G!="object"||typeof Q!="object"||!G||!Q)return new b(Q,G!==Q);if(Array.isArray(G)||Array.isArray(Q)){const Be=Array.isArray(G)&&Array.isArray(Q)&&P.equals(G,Q);return new b(Q,Be)}let he=!1;for(const Be in Q)if(Q.hasOwnProperty(Be)){const qe=i(G[Be],Q[Be]);qe.didChange&&(G[Be]=qe.newValue,he=!0)}return new b(G,he)}class h{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,he){return i(Q,he)}validate(Q){return this.defaultValue}}class l{constructor(Q,he,Be,qe){this.id=Q,this.name=he,this.defaultValue=Be,this.schema=qe}applyUpdate(Q,he){return i(Q,he)}validate(Q){return typeof Q=="undefined"?this.defaultValue:Q}compute(Q,he,Be){return Be}}function o(G,Q){return typeof G=="undefined"?Q:G==="false"?!1:Boolean(G)}e.boolean=o;class m extends l{constructor(Q,he,Be,qe=void 0){typeof qe!="undefined"&&(qe.type="boolean",qe.default=Be);super(Q,he,Be,qe)}validate(Q){return o(Q,this.defaultValue)}}function M(G,Q,he,Be){if(typeof G=="undefined")return Q;let qe=parseInt(G,10);return isNaN(qe)?Q:(qe=Math.max(he,qe),qe=Math.min(Be,qe),qe|0)}e.clampedInt=M;class C extends l{constructor(Q,he,Be,qe,lt,ht=void 0){typeof ht!="undefined"&&(ht.type="integer",ht.default=Be,ht.minimum=qe,ht.maximum=lt);super(Q,he,Be,ht);this.minimum=qe,this.maximum=lt}static clampedInt(Q,he,Be,qe){return M(Q,he,Be,qe)}validate(Q){return C.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class w extends l{constructor(Q,he,Be,qe,lt){typeof lt!="undefined"&&(lt.type="number",lt.default=Be);super(Q,he,Be,lt);this.validationFn=qe}static clamp(Q,he,Be){return Q<he?he:Q>Be?Be:Q}static float(Q,he){if(typeof Q=="number")return Q;if(typeof Q=="undefined")return he;const Be=parseFloat(Q);return isNaN(Be)?he:Be}validate(Q){return this.validationFn(w.float(Q,this.defaultValue))}}class u extends l{static string(Q,he){return typeof Q!="string"?he:Q}constructor(Q,he,Be,qe=void 0){typeof qe!="undefined"&&(qe.type="string",qe.default=Be);super(Q,he,Be,qe)}validate(Q){return u.string(Q,this.defaultValue)}}function _(G,Q,he){return typeof G!="string"||he.indexOf(G)===-1?Q:G}e.stringSet=_;class a extends l{constructor(Q,he,Be,qe,lt=void 0){typeof lt!="undefined"&&(lt.type="string",lt.enum=qe,lt.default=Be);super(Q,he,Be,lt);this._allowedValues=qe}validate(Q){return _(Q,this.defaultValue,this._allowedValues)}}class F extends R{constructor(Q,he,Be,qe,lt,ht,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.enum=lt,Ye.default=qe);super(Q,he,Be,Ye);this._allowedValues=lt,this._convert=ht}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function c(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class n extends R{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[r.localize(0,null),r.localize(1,null),r.localize(2,null)],default:"auto",description:r.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,he,Be){return Be===0?Q.accessibilitySupport:Be}}class f extends R{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:r.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:r.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{insertSpace:o(he.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(he.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var g;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(g=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(d=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function p(G){switch(G){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=p;function E(G){switch(G){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class v extends h{constructor(){super(128)}compute(Q,he,Be){const qe=["monaco-editor"];return he.get(33)&&qe.push(he.get(33)),Q.extraEditorClassName&&qe.push(Q.extraEditorClassName),he.get(66)==="default"?qe.push("mouse-default"):he.get(66)==="copy"&&qe.push("mouse-copy"),he.get(100)&&qe.push("showUnused"),he.get(126)&&qe.push("showDeprecated"),qe.join(" ")}}class k extends m{constructor(){super(32,"emptySelectionClipboard",!0,{description:r.localize(6,null)})}compute(Q,he,Be){return Be&&Q.emptySelectionClipboard}}class L extends R{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:r.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[r.localize(8,null),r.localize(9,null),r.localize(10,null)],description:r.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[r.localize(12,null),r.localize(13,null),r.localize(14,null)],description:r.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:r.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:r.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:r.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{cursorMoveOnType:o(he.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":_(he.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":_(he.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(he.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(he.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(he.loop,this.defaultValue.loop)}}}class y extends R{constructor(){super(45,"fontLigatures",y.OFF,{anyOf:[{type:"boolean",description:r.localize(19,null)},{type:"string",description:r.localize(20,null)}],description:r.localize(21,null),default:!1})}validate(Q){return typeof Q=="undefined"?this.defaultValue:typeof Q=="string"?Q==="false"?y.OFF:Q==="true"?y.ON:Q:Boolean(Q)?y.ON:y.OFF}}e.EditorFontLigatures=y,y.OFF='"liga" off, "calt" off',y.ON='"liga" on, "calt" on';class O extends h{constructor(){super(44)}compute(Q,he,Be){return Q.fontInfo}}class U extends l{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:r.localize(22,null)})}validate(Q){const he=w.float(Q,this.defaultValue);return he===0?e.EDITOR_FONT_DEFAULTS.fontSize:w.clamp(he,6,100)}compute(Q,he,Be){return Q.fontInfo.fontSize}}class q extends R{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:q.MINIMUM_VALUE,maximum:q.MAXIMUM_VALUE,errorMessage:r.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:q.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:r.localize(24,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(C.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,q.MINIMUM_VALUE,q.MAXIMUM_VALUE))}}q.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],q.MINIMUM_VALUE=1,q.MAXIMUM_VALUE=1e3;class H extends R{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},he={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[r.localize(25,null),r.localize(26,null),r.localize(27,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:r.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:r.localize(29,null),...he},"editor.gotoLocation.multipleTypeDefinitions":{description:r.localize(30,null),...he},"editor.gotoLocation.multipleDeclarations":{description:r.localize(31,null),...he},"editor.gotoLocation.multipleImplementations":{description:r.localize(32,null),...he},"editor.gotoLocation.multipleReferences":{description:r.localize(33,null),...he},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Be,description:r.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Be,description:r.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Be,description:r.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Be,description:r.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Be,description:r.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{multiple:_(he.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:he.multipleDefinitions??_(he.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:he.multipleTypeDefinitions??_(he.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:he.multipleDeclarations??_(he.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:he.multipleImplementations??_(he.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:he.multipleReferences??_(he.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:u.string(he.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:u.string(he.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:u.string(he.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:u.string(he.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:u.string(he.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class z extends R{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:r.localize(39,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:r.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:r.localize(41,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:r.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:o(he.enabled,this.defaultValue.enabled),delay:C.clampedInt(he.delay,this.defaultValue.delay,0,1e4),sticky:o(he.sticky,this.defaultValue.sticky),above:o(he.above,this.defaultValue.above)}}}var j;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(j=e.RenderMinimap||(e.RenderMinimap={}));class ie extends h{constructor(){super(131)}compute(Q,he,Be){return ie.computeLayout(he,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const he=Q.height/Q.lineHeight,Be=Q.scrollBeyondLastLine?he-1:0,qe=(Q.viewLineCount+Be)/(Q.pixelRatio*Q.height),lt=Math.floor(Q.viewLineCount/qe);return{typicalViewportLineCount:he,extraLinesBeyondLastLine:Be,desiredRatio:qe,minimapLineCount:lt}}static _computeMinimapLayout(Q,he){const Be=Q.outerWidth,qe=Q.outerHeight,lt=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(lt*qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:qe};const ht=he.stableMinimapLayoutInput,Ye=ht&&Q.outerHeight===ht.outerHeight&&Q.lineHeight===ht.lineHeight&&Q.typicalHalfwidthCharacterWidth===ht.typicalHalfwidthCharacterWidth&&Q.pixelRatio===ht.pixelRatio&&Q.scrollBeyondLastLine===ht.scrollBeyondLastLine&&Q.minimap.enabled===ht.minimap.enabled&&Q.minimap.side===ht.minimap.side&&Q.minimap.size===ht.minimap.size&&Q.minimap.showSlider===ht.minimap.showSlider&&Q.minimap.renderCharacters===ht.minimap.renderCharacters&&Q.minimap.maxColumn===ht.minimap.maxColumn&&Q.minimap.scale===ht.minimap.scale&&Q.verticalScrollbarWidth===ht.verticalScrollbarWidth&&Q.isViewportWrapping===ht.isViewportWrapping,kt=Q.lineHeight,Ae=Q.typicalHalfwidthCharacterWidth,De=Q.scrollBeyondLastLine,ve=Q.minimap.renderCharacters;let ee=lt>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const ne=Q.minimap.maxColumn,de=Q.minimap.size,ge=Q.minimap.side,Te=Q.verticalScrollbarWidth,ze=Q.viewLineCount,Le=Q.remainingWidth,Ge=Q.isViewportWrapping,ot=ve?2:3;let at=Math.floor(lt*qe);const Ne=at/lt;let ce=!1,fe=!1,re=ot*ee,W=ee/lt,we=1;if(de==="fill"||de==="fit"){const{typicalViewportLineCount:dt,extraLinesBeyondLastLine:vt,desiredRatio:bt,minimapLineCount:Ut}=ie.computeContainedMinimapLineCount({viewLineCount:ze,scrollBeyondLastLine:De,height:qe,lineHeight:kt,pixelRatio:lt});if(ze/Ut>1)ce=!0,fe=!0,ee=1,re=1,W=ee/lt;else{let Mt=!1,Dt=ee+1;if(de==="fit"){const _t=Math.ceil((ze+vt)*re);Ge&&Ye&&Le<=he.stableFitRemainingWidth?(Mt=!0,Dt=he.stableFitMaxMinimapScale):Mt=_t>at}if(de==="fill"||Mt){ce=!0;const _t=ee;re=Math.min(kt*lt,Math.max(1,Math.floor(1/bt))),Ge&&Ye&&Le<=he.stableFitRemainingWidth&&(Dt=he.stableFitMaxMinimapScale),ee=Math.min(Dt,Math.max(1,Math.floor(re/ot))),ee>_t&&(we=Math.min(2,ee/_t)),W=ee/lt/we,at=Math.ceil(Math.max(dt,ze+vt)*re),Ge?(he.stableMinimapLayoutInput=Q,he.stableFitRemainingWidth=Le,he.stableFitMaxMinimapScale=ee):(he.stableMinimapLayoutInput=null,he.stableFitRemainingWidth=0)}}}const Re=Math.floor(ne*W),We=Math.min(Re,Math.max(0,Math.floor((Le-Te-2)*W/(Ae+W)))+e.MINIMAP_GUTTER_WIDTH);let He=Math.floor(lt*We);const mt=He/lt;He=Math.floor(He*we);const Et=ve?1:2,St=ge==="left"?0:Be-We-Te;return{renderMinimap:Et,minimapLeft:St,minimapWidth:We,minimapHeightIsEditorHeight:ce,minimapIsSampling:fe,minimapScale:ee,minimapLineHeight:re,minimapCanvasInnerWidth:He,minimapCanvasInnerHeight:at,minimapCanvasOuterWidth:mt,minimapCanvasOuterHeight:Ne}}static computeLayout(Q,he){const Be=he.outerWidth|0,qe=he.outerHeight|0,lt=he.lineHeight|0,ht=he.lineNumbersDigitCount|0,Ye=he.typicalHalfwidthCharacterWidth,kt=he.maxDigitWidth,Ae=he.pixelRatio,De=he.viewLineCount,ve=Q.get(123),ee=ve==="inherit"?Q.get(122):ve,ne=ee==="inherit"?Q.get(118):ee,de=Q.get(121),ge=Q.get(2),Te=he.isDominatedByLongLines,ze=Q.get(50),Le=Q.get(60).renderType!==0,Ge=Q.get(61),ot=Q.get(94),at=Q.get(65),Ne=Q.get(92),ce=Ne.verticalScrollbarSize,fe=Ne.verticalHasArrows,re=Ne.arrowSize,W=Ne.horizontalScrollbarSize,we=Q.get(58),Re=Q.get(37);let We;if(typeof we=="string"&&/^\d+(\.\d+)?ch$/.test(we)){const wt=parseFloat(we.substr(0,we.length-2));We=C.clampedInt(wt*Ye,0,0,1e3)}else We=C.clampedInt(we,0,0,1e3);Re&&(We+=16);let He=0;if(Le){const wt=Math.max(ht,Ge);He=Math.round(wt*kt)}let mt=0;ze&&(mt=lt);let Et=0,St=Et+mt,dt=St+He,vt=dt+We;const bt=Be-mt-He-We;let Ut=!1,It=!1,Mt=-1;ge!==2&&(ee==="inherit"&&Te?(Ut=!0,It=!0):ne==="on"||ne==="bounded"?It=!0:ne==="wordWrapColumn"&&(Mt=de));const Dt=ie._computeMinimapLayout({outerWidth:Be,outerHeight:qe,lineHeight:lt,typicalHalfwidthCharacterWidth:Ye,pixelRatio:Ae,scrollBeyondLastLine:ot,minimap:at,verticalScrollbarWidth:ce,viewLineCount:De,remainingWidth:bt,isViewportWrapping:It},he.memory||new T);Dt.renderMinimap!==0&&Dt.minimapLeft===0&&(Et+=Dt.minimapWidth,St+=Dt.minimapWidth,dt+=Dt.minimapWidth,vt+=Dt.minimapWidth);const _t=bt-Dt.minimapWidth,Qt=Math.max(1,Math.floor((_t-ce-2)/Ye)),Vt=fe?re:0;return It&&(Mt=Math.max(1,Qt),ne==="bounded"&&(Mt=Math.min(Mt,de))),{width:Be,height:qe,glyphMarginLeft:Et,glyphMarginWidth:mt,lineNumbersLeft:St,lineNumbersWidth:He,decorationsLeft:dt,decorationsWidth:We,contentLeft:vt,contentWidth:_t,minimap:Dt,viewportColumn:Qt,isWordWrapMinified:Ut,isViewportWrapping:It,wrappingColumn:Mt,verticalScrollbarWidth:ce,horizontalScrollbarHeight:W,overviewRuler:{top:Vt,width:ce,height:qe-2*Vt,right:0}}}}e.EditorLayoutInfoComputer=ie;class ae extends R{constructor(){const Q={enabled:!0};super(57,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:r.localize(43,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:o(Q.enabled,this.defaultValue.enabled)}}}class te extends R{constructor(){const Q={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"boolean",default:Q.enabled,description:r.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:r.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:r.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:o(he.enabled,this.defaultValue.enabled),fontSize:C.clampedInt(he.fontSize,this.defaultValue.fontSize,0,100),fontFamily:u.string(he.fontFamily,this.defaultValue.fontFamily)}}}class ue extends w{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>w.clamp(Q,0,150),{markdownDescription:r.localize(47,null)})}compute(Q,he,Be){return Q.fontInfo.lineHeight}}class be extends R{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:r.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[r.localize(49,null),r.localize(50,null),r.localize(51,null)],default:Q.size,description:r.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:r.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:r.localize(54,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:r.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:r.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:r.localize(57,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:o(he.enabled,this.defaultValue.enabled),size:_(he.size,this.defaultValue.size,["proportional","fill","fit"]),side:_(he.side,this.defaultValue.side,["right","left"]),showSlider:_(he.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(he.renderCharacters,this.defaultValue.renderCharacters),scale:C.clampedInt(he.scale,1,1,3),maxColumn:C.clampedInt(he.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function pe(G){return G==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class me extends R{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{top:C.clampedInt(he.top,0,0,1e3),bottom:C.clampedInt(he.bottom,0,0,1e3)}}}class oe extends R{constructor(){const Q={enabled:!0,cycle:!1};super(76,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:r.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:r.localize(61,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:o(he.enabled,this.defaultValue.enabled),cycle:o(he.cycle,this.defaultValue.cycle)}}}class Ee extends h{constructor(){super(129)}compute(Q,he,Be){return Q.pixelRatio}}class Pe extends R{constructor(){const Q={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",Q,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Q.strings,description:r.localize(62,null)},comments:{type:"boolean",default:Q.comments,description:r.localize(63,null)},other:{type:"boolean",default:Q.other,description:r.localize(64,null)}}}],default:Q,description:r.localize(65,null)});this.defaultValue=Q}validate(Q){if(typeof Q=="boolean")return Q;if(Q&&typeof Q=="object"){const he=Q,Be={other:o(he.other,this.defaultValue.other),comments:o(he.comments,this.defaultValue.comments),strings:o(he.strings,this.defaultValue.strings)};return Be.other&&Be.comments&&Be.strings?!0:!Be.other&&!Be.comments&&!Be.strings?!1:Be}return this.defaultValue}}var Oe;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(Oe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class je extends R{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[r.localize(66,null),r.localize(67,null),r.localize(68,null),r.localize(69,null)],default:"on",description:r.localize(70,null)})}validate(Q){let he=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof Q!="undefined"&&(typeof Q=="function"?(he=4,Be=Q):Q==="interval"?he=3:Q==="relative"?he=2:Q==="on"?he=1:he=0),{renderType:he,renderFn:Be}}}function st(G){const Q=G.get(87);return Q==="editable"?G.get(81):Q!=="on"}e.filterValidationDecorations=st;class et extends R{constructor(){const Q=[],he={type:"number",description:r.localize(71,null)};super(91,"rulers",Q,{type:"array",items:{anyOf:[he,{type:["object"],properties:{column:he,color:{type:"string",description:r.localize(72,null),format:"color-hex"}}}]},default:Q,description:r.localize(73,null)})}validate(Q){if(Array.isArray(Q)){const he=[];for(let Be of Q)if(typeof Be=="number")he.push({column:C.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const qe=Be;he.push({column:C.clampedInt(qe.column,0,0,1e4),color:qe.color})}return he.sort((Be,qe)=>Be.column-qe.column),he}return this.defaultValue}}function tt(G,Q){if(typeof G!="string")return Q;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class $ extends R{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(74,null),r.localize(75,null),r.localize(76,null)],default:"auto",description:r.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(78,null),r.localize(79,null),r.localize(80,null)],default:"auto",description:r.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:r.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:r.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:r.localize(84,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q,Be=C.clampedInt(he.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),qe=C.clampedInt(he.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:C.clampedInt(he.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:tt(he.vertical,this.defaultValue.vertical),horizontal:tt(he.horizontal,this.defaultValue.horizontal),useShadows:o(he.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(he.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(he.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(he.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(he.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:C.clampedInt(he.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:qe,verticalSliderSize:C.clampedInt(he.verticalSliderSize,qe,0,1e3),scrollByPage:o(he.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends R{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:r.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:r.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:r.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:r.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:r.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:r.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:r.localize(91,null)}})}applyUpdate(Q,he){let Be=!1;he.allowedCharacters&&(A.equals(Q.allowedCharacters,he.allowedCharacters)||(Q={...Q,allowedCharacters:he.allowedCharacters},Be=!0)),he.allowedLocales&&(A.equals(Q.allowedLocales,he.allowedLocales)||(Q={...Q,allowedLocales:he.allowedLocales},Be=!0));const qe=super.applyUpdate(Q,he);return Be?new b(qe.newValue,!0):qe}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{nonBasicASCII:se(he.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(he.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(he.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:se(he.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:se(he.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Q,he){if(typeof Q!="object"||!Q)return he;const Be={};for(const[qe,lt]of Object.entries(Q))lt===!0&&(Be[qe]=!0);return Be}}class x extends R{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:r.localize(92,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:o(he.enabled,this.defaultValue.enabled),mode:_(he.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class V extends R{constructor(){const Q={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,description:r.localize(93,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:o(Q.enabled,this.defaultValue.enabled)}}}class Y extends R{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(94,null),r.localize(95,null),r.localize(96,null)],default:Q.bracketPairs,description:r.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(98,null),r.localize(99,null),r.localize(100,null)],default:Q.bracketPairsHorizontal,description:r.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:r.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:r.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:Q.highlightActiveIndentation,description:r.localize(104,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{bracketPairs:se(he.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:se(he.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(he.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(he.indentation,this.defaultValue.indentation),highlightActiveIndentation:o(he.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function se(G,Q,he){const Be=he.indexOf(G);return Be===-1?Q:he[Be]}class _e extends R{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[r.localize(105,null),r.localize(106,null)],default:Q.insertMode,description:r.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:r.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:r.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:r.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:r.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:r.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:r.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:r.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:r.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:r.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:r.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:r.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:r.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:r.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:r.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:r.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:r.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:r.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:r.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:r.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:r.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:r.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:r.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:r.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:r.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:r.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:r.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:r.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:r.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:r.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:r.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:r.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:r.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:r.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:r.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:r.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:r.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:r.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:r.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:r.localize(146,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{insertMode:_(he.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(he.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(he.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(he.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(he.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:o(he.showIcons,this.defaultValue.showIcons),showStatusBar:o(he.showStatusBar,this.defaultValue.showStatusBar),preview:o(he.preview,this.defaultValue.preview),previewMode:_(he.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(he.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(he.showMethods,this.defaultValue.showMethods),showFunctions:o(he.showFunctions,this.defaultValue.showFunctions),showConstructors:o(he.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(he.showDeprecated,this.defaultValue.showDeprecated),showFields:o(he.showFields,this.defaultValue.showFields),showVariables:o(he.showVariables,this.defaultValue.showVariables),showClasses:o(he.showClasses,this.defaultValue.showClasses),showStructs:o(he.showStructs,this.defaultValue.showStructs),showInterfaces:o(he.showInterfaces,this.defaultValue.showInterfaces),showModules:o(he.showModules,this.defaultValue.showModules),showProperties:o(he.showProperties,this.defaultValue.showProperties),showEvents:o(he.showEvents,this.defaultValue.showEvents),showOperators:o(he.showOperators,this.defaultValue.showOperators),showUnits:o(he.showUnits,this.defaultValue.showUnits),showValues:o(he.showValues,this.defaultValue.showValues),showConstants:o(he.showConstants,this.defaultValue.showConstants),showEnums:o(he.showEnums,this.defaultValue.showEnums),showEnumMembers:o(he.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(he.showKeywords,this.defaultValue.showKeywords),showWords:o(he.showWords,this.defaultValue.showWords),showColors:o(he.showColors,this.defaultValue.showColors),showFiles:o(he.showFiles,this.defaultValue.showFiles),showReferences:o(he.showReferences,this.defaultValue.showReferences),showFolders:o(he.showFolders,this.defaultValue.showFolders),showTypeParameters:o(he.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(he.showSnippets,this.defaultValue.showSnippets),showUsers:o(he.showUsers,this.defaultValue.showUsers),showIssues:o(he.showIssues,this.defaultValue.showIssues)}}}class Ue extends R{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:r.localize(147,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Ve extends h{constructor(){super(130)}compute(Q,he,Be){return he.get(81)?!0:Q.tabFocusMode}}var Qe;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(Qe=e.WrappingIndent||(e.WrappingIndent={}));function nt(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class rt extends h{constructor(){super(132)}compute(Q,he,Be){const qe=he.get(131);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:qe.isWordWrapMinified,isViewportWrapping:qe.isViewportWrapping,wrappingColumn:qe.wrappingColumn}}}const Je="Consolas, 'Courier New', monospace",Ze="Menlo, Monaco, 'Courier New', monospace",pt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?Ze:t.isLinux?pt:Je,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Fe(G){return e.editorOptionsRegistry[G.id]=G,G}var At;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.bracketPairColorization=12]="bracketPairColorization",G[G.guides=13]="guides",G[G.codeLens=14]="codeLens",G[G.codeLensFontFamily=15]="codeLensFontFamily",G[G.codeLensFontSize=16]="codeLensFontSize",G[G.colorDecorators=17]="colorDecorators",G[G.columnSelection=18]="columnSelection",G[G.comments=19]="comments",G[G.contextmenu=20]="contextmenu",G[G.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",G[G.cursorBlinking=22]="cursorBlinking",G[G.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",G[G.cursorStyle=24]="cursorStyle",G[G.cursorSurroundingLines=25]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",G[G.cursorWidth=27]="cursorWidth",G[G.disableLayerHinting=28]="disableLayerHinting",G[G.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",G[G.domReadOnly=30]="domReadOnly",G[G.dragAndDrop=31]="dragAndDrop",G[G.emptySelectionClipboard=32]="emptySelectionClipboard",G[G.extraEditorClassName=33]="extraEditorClassName",G[G.fastScrollSensitivity=34]="fastScrollSensitivity",G[G.find=35]="find",G[G.fixedOverflowWidgets=36]="fixedOverflowWidgets",G[G.folding=37]="folding",G[G.foldingStrategy=38]="foldingStrategy",G[G.foldingHighlight=39]="foldingHighlight",G[G.foldingImportsByDefault=40]="foldingImportsByDefault",G[G.foldingMaximumRegions=41]="foldingMaximumRegions",G[G.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=43]="fontFamily",G[G.fontInfo=44]="fontInfo",G[G.fontLigatures=45]="fontLigatures",G[G.fontSize=46]="fontSize",G[G.fontWeight=47]="fontWeight",G[G.formatOnPaste=48]="formatOnPaste",G[G.formatOnType=49]="formatOnType",G[G.glyphMargin=50]="glyphMargin",G[G.gotoLocation=51]="gotoLocation",G[G.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",G[G.hover=53]="hover",G[G.inDiffEditor=54]="inDiffEditor",G[G.inlineSuggest=55]="inlineSuggest",G[G.letterSpacing=56]="letterSpacing",G[G.lightbulb=57]="lightbulb",G[G.lineDecorationsWidth=58]="lineDecorationsWidth",G[G.lineHeight=59]="lineHeight",G[G.lineNumbers=60]="lineNumbers",G[G.lineNumbersMinChars=61]="lineNumbersMinChars",G[G.linkedEditing=62]="linkedEditing",G[G.links=63]="links",G[G.matchBrackets=64]="matchBrackets",G[G.minimap=65]="minimap",G[G.mouseStyle=66]="mouseStyle",G[G.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=68]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",G[G.multiCursorModifier=70]="multiCursorModifier",G[G.multiCursorPaste=71]="multiCursorPaste",G[G.occurrencesHighlight=72]="occurrencesHighlight",G[G.overviewRulerBorder=73]="overviewRulerBorder",G[G.overviewRulerLanes=74]="overviewRulerLanes",G[G.padding=75]="padding",G[G.parameterHints=76]="parameterHints",G[G.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",G[G.quickSuggestions=79]="quickSuggestions",G[G.quickSuggestionsDelay=80]="quickSuggestionsDelay",G[G.readOnly=81]="readOnly",G[G.renameOnType=82]="renameOnType",G[G.renderControlCharacters=83]="renderControlCharacters",G[G.renderFinalNewline=84]="renderFinalNewline",G[G.renderLineHighlight=85]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=87]="renderValidationDecorations",G[G.renderWhitespace=88]="renderWhitespace",G[G.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",G[G.roundedSelection=90]="roundedSelection",G[G.rulers=91]="rulers",G[G.scrollbar=92]="scrollbar",G[G.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=94]="scrollBeyondLastLine",G[G.scrollPredominantAxis=95]="scrollPredominantAxis",G[G.selectionClipboard=96]="selectionClipboard",G[G.selectionHighlight=97]="selectionHighlight",G[G.selectOnLineNumbers=98]="selectOnLineNumbers",G[G.showFoldingControls=99]="showFoldingControls",G[G.showUnused=100]="showUnused",G[G.snippetSuggestions=101]="snippetSuggestions",G[G.smartSelect=102]="smartSelect",G[G.smoothScrolling=103]="smoothScrolling",G[G.stickyTabStops=104]="stickyTabStops",G[G.stopRenderingLineAfter=105]="stopRenderingLineAfter",G[G.suggest=106]="suggest",G[G.suggestFontSize=107]="suggestFontSize",G[G.suggestLineHeight=108]="suggestLineHeight",G[G.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",G[G.suggestSelection=110]="suggestSelection",G[G.tabCompletion=111]="tabCompletion",G[G.tabIndex=112]="tabIndex",G[G.unicodeHighlighting=113]="unicodeHighlighting",G[G.unusualLineTerminators=114]="unusualLineTerminators",G[G.useShadowDOM=115]="useShadowDOM",G[G.useTabStops=116]="useTabStops",G[G.wordSeparators=117]="wordSeparators",G[G.wordWrap=118]="wordWrap",G[G.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=121]="wordWrapColumn",G[G.wordWrapOverride1=122]="wordWrapOverride1",G[G.wordWrapOverride2=123]="wordWrapOverride2",G[G.wrappingIndent=124]="wrappingIndent",G[G.wrappingStrategy=125]="wrappingStrategy",G[G.showDeprecated=126]="showDeprecated",G[G.inlayHints=127]="inlayHints",G[G.editorClassName=128]="editorClassName",G[G.pixelRatio=129]="pixelRatio",G[G.tabFocusMode=130]="tabFocusMode",G[G.layoutInfo=131]="layoutInfo",G[G.wrappingInfo=132]="wrappingInfo"})(At=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:r.localize(148,null)})),acceptSuggestionOnEnter:Fe(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",r.localize(149,null),""],markdownDescription:r.localize(150,null)})),accessibilitySupport:Fe(new n),accessibilityPageSize:Fe(new C(3,"accessibilityPageSize",10,1,1073741824,{description:r.localize(151,null)})),ariaLabel:Fe(new u(4,"ariaLabel",r.localize(152,null))),autoClosingBrackets:Fe(new a(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(153,null),r.localize(154,null),""],description:r.localize(155,null)})),autoClosingDelete:Fe(new a(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",r.localize(156,null),""],description:r.localize(157,null)})),autoClosingOvertype:Fe(new a(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",r.localize(158,null),""],description:r.localize(159,null)})),autoClosingQuotes:Fe(new a(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(160,null),r.localize(161,null),""],description:r.localize(162,null)})),autoIndent:Fe(new F(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[r.localize(163,null),r.localize(164,null),r.localize(165,null),r.localize(166,null),r.localize(167,null)],description:r.localize(168,null)})),automaticLayout:Fe(new m(10,"automaticLayout",!1)),autoSurround:Fe(new a(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[r.localize(169,null),r.localize(170,null),r.localize(171,null),""],description:r.localize(172,null)})),bracketPairColorization:Fe(new V),bracketPairGuides:Fe(new Y),stickyTabStops:Fe(new m(104,"stickyTabStops",!1,{description:r.localize(173,null)})),codeLens:Fe(new m(14,"codeLens",!0,{description:r.localize(174,null)})),codeLensFontFamily:Fe(new u(15,"codeLensFontFamily","",{description:r.localize(175,null)})),codeLensFontSize:Fe(new C(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:r.localize(176,null)})),colorDecorators:Fe(new m(17,"colorDecorators",!0,{description:r.localize(177,null)})),columnSelection:Fe(new m(18,"columnSelection",!1,{description:r.localize(178,null)})),comments:Fe(new f),contextmenu:Fe(new m(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new m(21,"copyWithSyntaxHighlighting",!0,{description:r.localize(179,null)})),cursorBlinking:Fe(new F(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:r.localize(180,null)})),cursorSmoothCaretAnimation:Fe(new m(23,"cursorSmoothCaretAnimation",!1,{description:r.localize(181,null)})),cursorStyle:Fe(new F(24,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],E,{description:r.localize(182,null)})),cursorSurroundingLines:Fe(new C(25,"cursorSurroundingLines",0,0,1073741824,{description:r.localize(183,null)})),cursorSurroundingLinesStyle:Fe(new a(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[r.localize(184,null),r.localize(185,null)],description:r.localize(186,null)})),cursorWidth:Fe(new C(27,"cursorWidth",0,0,1073741824,{markdownDescription:r.localize(187,null)})),disableLayerHinting:Fe(new m(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new m(29,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new m(30,"domReadOnly",!1)),dragAndDrop:Fe(new m(31,"dragAndDrop",!0,{description:r.localize(188,null)})),emptySelectionClipboard:Fe(new k),extraEditorClassName:Fe(new u(33,"extraEditorClassName","")),fastScrollSensitivity:Fe(new w(34,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:r.localize(189,null)})),find:Fe(new L),fixedOverflowWidgets:Fe(new m(36,"fixedOverflowWidgets",!1)),folding:Fe(new m(37,"folding",!0,{description:r.localize(190,null)})),foldingStrategy:Fe(new a(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[r.localize(191,null),r.localize(192,null)],description:r.localize(193,null)})),foldingHighlight:Fe(new m(39,"foldingHighlight",!0,{description:r.localize(194,null)})),foldingImportsByDefault:Fe(new m(40,"foldingImportsByDefault",!1,{description:r.localize(195,null)})),foldingMaximumRegions:Fe(new C(41,"foldingMaximumRegions",5e3,10,65e3,{description:r.localize(196,null)})),unfoldOnClickAfterEndOfLine:Fe(new m(42,"unfoldOnClickAfterEndOfLine",!1,{description:r.localize(197,null)})),fontFamily:Fe(new u(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:r.localize(198,null)})),fontInfo:Fe(new O),fontLigatures2:Fe(new y),fontSize:Fe(new U),fontWeight:Fe(new q),formatOnPaste:Fe(new m(48,"formatOnPaste",!1,{description:r.localize(199,null)})),formatOnType:Fe(new m(49,"formatOnType",!1,{description:r.localize(200,null)})),glyphMargin:Fe(new m(50,"glyphMargin",!0,{description:r.localize(201,null)})),gotoLocation:Fe(new H),hideCursorInOverviewRuler:Fe(new m(52,"hideCursorInOverviewRuler",!1,{description:r.localize(202,null)})),hover:Fe(new z),inDiffEditor:Fe(new m(54,"inDiffEditor",!1)),letterSpacing:Fe(new w(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>w.clamp(G,-5,20),{description:r.localize(203,null)})),lightbulb:Fe(new ae),lineDecorationsWidth:Fe(new l(58,"lineDecorationsWidth",10)),lineHeight:Fe(new ue),lineNumbers:Fe(new je),lineNumbersMinChars:Fe(new C(61,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new m(62,"linkedEditing",!1,{description:r.localize(204,null)})),links:Fe(new m(63,"links",!0,{description:r.localize(205,null)})),matchBrackets:Fe(new a(64,"matchBrackets","always",["always","near","never"],{description:r.localize(206,null)})),minimap:Fe(new be),mouseStyle:Fe(new a(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new w(67,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:r.localize(207,null)})),mouseWheelZoom:Fe(new m(68,"mouseWheelZoom",!1,{markdownDescription:r.localize(208,null)})),multiCursorMergeOverlapping:Fe(new m(69,"multiCursorMergeOverlapping",!0,{description:r.localize(209,null)})),multiCursorModifier:Fe(new F(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],pe,{markdownEnumDescriptions:[r.localize(210,null),r.localize(211,null)],markdownDescription:r.localize(212,null)})),multiCursorPaste:Fe(new a(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[r.localize(213,null),r.localize(214,null)],markdownDescription:r.localize(215,null)})),occurrencesHighlight:Fe(new m(72,"occurrencesHighlight",!0,{description:r.localize(216,null)})),overviewRulerBorder:Fe(new m(73,"overviewRulerBorder",!0,{description:r.localize(217,null)})),overviewRulerLanes:Fe(new C(74,"overviewRulerLanes",3,0,3)),padding:Fe(new me),parameterHints:Fe(new oe),peekWidgetDefaultFocus:Fe(new a(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[r.localize(218,null),r.localize(219,null)],description:r.localize(220,null)})),definitionLinkOpensInPeek:Fe(new m(78,"definitionLinkOpensInPeek",!1,{description:r.localize(221,null)})),quickSuggestions:Fe(new Pe),quickSuggestionsDelay:Fe(new C(80,"quickSuggestionsDelay",10,0,1073741824,{description:r.localize(222,null)})),readOnly:Fe(new m(81,"readOnly",!1)),renameOnType:Fe(new m(82,"renameOnType",!1,{description:r.localize(223,null),markdownDeprecationMessage:r.localize(224,null)})),renderControlCharacters:Fe(new m(83,"renderControlCharacters",!0,{description:r.localize(225,null),restricted:!0})),renderFinalNewline:Fe(new m(84,"renderFinalNewline",!0,{description:r.localize(226,null)})),renderLineHighlight:Fe(new a(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",r.localize(227,null)],description:r.localize(228,null)})),renderLineHighlightOnlyWhenFocus:Fe(new m(86,"renderLineHighlightOnlyWhenFocus",!1,{description:r.localize(229,null)})),renderValidationDecorations:Fe(new a(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new a(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",r.localize(230,null),r.localize(231,null),r.localize(232,null),""],description:r.localize(233,null)})),revealHorizontalRightPadding:Fe(new C(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Fe(new m(90,"roundedSelection",!0,{description:r.localize(234,null)})),rulers:Fe(new et),scrollbar:Fe(new $),scrollBeyondLastColumn:Fe(new C(93,"scrollBeyondLastColumn",5,0,1073741824,{description:r.localize(235,null)})),scrollBeyondLastLine:Fe(new m(94,"scrollBeyondLastLine",!0,{description:r.localize(236,null)})),scrollPredominantAxis:Fe(new m(95,"scrollPredominantAxis",!0,{description:r.localize(237,null)})),selectionClipboard:Fe(new m(96,"selectionClipboard",!0,{description:r.localize(238,null),included:t.isLinux})),selectionHighlight:Fe(new m(97,"selectionHighlight",!0,{description:r.localize(239,null)})),selectOnLineNumbers:Fe(new m(98,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new a(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[r.localize(240,null),r.localize(241,null)],description:r.localize(242,null)})),showUnused:Fe(new m(100,"showUnused",!0,{description:r.localize(243,null)})),showDeprecated:Fe(new m(126,"showDeprecated",!0,{description:r.localize(244,null)})),inlayHints:Fe(new te),snippetSuggestions:Fe(new a(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[r.localize(245,null),r.localize(246,null),r.localize(247,null),r.localize(248,null)],description:r.localize(249,null)})),smartSelect:Fe(new Ue),smoothScrolling:Fe(new m(103,"smoothScrolling",!1,{description:r.localize(250,null)})),stopRenderingLineAfter:Fe(new C(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new _e),inlineSuggest:Fe(new x),suggestFontSize:Fe(new C(107,"suggestFontSize",0,0,1e3,{markdownDescription:r.localize(251,null)})),suggestLineHeight:Fe(new C(108,"suggestLineHeight",0,0,1e3,{markdownDescription:r.localize(252,null)})),suggestOnTriggerCharacters:Fe(new m(109,"suggestOnTriggerCharacters",!0,{description:r.localize(253,null)})),suggestSelection:Fe(new a(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[r.localize(254,null),r.localize(255,null),r.localize(256,null)],description:r.localize(257,null)})),tabCompletion:Fe(new a(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[r.localize(258,null),r.localize(259,null),r.localize(260,null)],description:r.localize(261,null)})),tabIndex:Fe(new C(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new K),unusualLineTerminators:Fe(new a(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[r.localize(262,null),r.localize(263,null),r.localize(264,null)],description:r.localize(265,null)})),useShadowDOM:Fe(new m(115,"useShadowDOM",!0)),useTabStops:Fe(new m(116,"useTabStops",!0,{description:r.localize(266,null)})),wordSeparators:Fe(new u(117,"wordSeparators",S.USUAL_WORD_SEPARATORS,{description:r.localize(267,null)})),wordWrap:Fe(new a(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[r.localize(268,null),r.localize(269,null),r.localize(270,null),r.localize(271,null)],description:r.localize(272,null)})),wordWrapBreakAfterCharacters:Fe(new u(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new u(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new C(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:r.localize(273,null)})),wordWrapOverride1:Fe(new a(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new a(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Fe(new F(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],nt,{enumDescriptions:[r.localize(274,null),r.localize(275,null),r.localize(276,null),r.localize(277,null)],description:r.localize(278,null)})),wrappingStrategy:Fe(new a(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[r.localize(279,null),r.localize(280,null)],description:r.localize(281,null)})),editorClassName:Fe(new v),pixelRatio:Fe(new Ee),tabFocusMode:Fe(new Ve),layoutInfo:Fe(new ie),wrappingInfo:Fe(new rt)}}),define(ye[114],Se([18,19]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[115],Se([18,19]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[116],Se([18,19]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(ye[117],Se([18,19]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(ye[118],Se([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[119],Se([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[120],Se([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[121],Se([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[122],Se([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[123],Se([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[124],Se([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[125],Se([18,19]),function(Z,e){return Z.create("vs/workbench/common/editor",e)}),define(ye[126],Se([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[127],Se([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ye[128],Se([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ye[129],Se([18,19]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[130],Se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var r;(function(A){A[A.ACTIVATE=1]="ACTIVATE",A[A.RESTORE=2]="RESTORE",A[A.PRESERVE=3]="PRESERVE"})(r=e.EditorActivation||(e.EditorActivation={}));var t;(function(A){A[A.PICK=0]="PICK",A[A.DISABLED=1]="DISABLED",A[A.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var S;(function(A){A[A.API=0]="API",A[A.USER=1]="USER"})(S=e.EditorOpenContext||(e.EditorOpenContext={}));var P;(function(A){A[A.Center=0]="Center",A[A.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",A[A.NearTop=2]="NearTop",A[A.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ye[131],Se([0,1,115]),function(Z,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function P(i){return i=i.trim(),i==="*"||t.test(i)}e.isValidVersionStr=P;function A(i){if(!P(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let h=i.match(t);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=A;function I(i){if(!i)return null;let h=i.majorBase,l=i.majorMustEqual,o=i.minorBase,m=i.minorMustEqual,M=i.patchBase,C=i.patchMustEqual;i.hasCaret&&(h===0||(m=!1),C=!1);let w=0;if(i.preRelease){const u=S.exec(i.preRelease);if(u){const[,_,a,F]=u;w=Date.UTC(Number(_),Number(a)-1,Number(F))}}return{majorBase:h,majorMustEqual:l,minorBase:o,minorMustEqual:m,patchBase:M,patchMustEqual:C,isMinimum:i.hasGreaterEquals,notBefore:w}}e.normalizeVersion=I;function D(i,h,l){let o;typeof i=="string"?o=I(A(i)):o=i;let m;h instanceof Date?m=h.getTime():typeof h=="string"&&(m=new Date(h).getTime());let M;if(typeof l=="string"?M=I(A(l)):M=l,!o||!M)return!1;let C=o.majorBase,w=o.minorBase,u=o.patchBase,_=M.majorBase,a=M.minorBase,F=M.patchBase,c=M.notBefore,n=M.majorMustEqual,f=M.minorMustEqual,g=M.patchMustEqual;return M.isMinimum?C>_?!0:C<_?!1:w>a?!0:w<a||m&&m<c?!1:u>=F:(C===1&&_===0&&(!n||!f||!g)&&(_=1,a=0,F=0,n=!0,f=!1,g=!1),C<_?!1:C>_?!n:w<a?!1:w>a?!f:u<F?!1:u>F?!g:!(m&&m<c))}e.isValidVersion=D;function T(i,h,l,o){return l.isBuiltin||typeof l.main=="undefined"?!0:b(i,h,l.engines.vscode,o)}e.isValidExtensionVersion=T;function R(i,h,l){return i==="*"||b(h,l,i)}e.isEngineValid=R;function b(i,h,l,o=[]){let m=I(A(l));if(!m)return o.push(r.localize(0,null,l)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return o.push(r.localize(1,null,l)),!1}else if(!m.majorMustEqual)return o.push(r.localize(2,null,l)),!1;return D(i,h,m)?!0:(o.push(r.localize(3,null,i,l)),!1)}}),define(ye[78],Se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class r{constructor(S,P=[],A=!1){this.ctor=S,this.staticArguments=P,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=r}),define(ye[44],Se([0,1,78]),function(Z,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function S(A,I,D){I instanceof r.SyncDescriptor||(I=new r.SyncDescriptor(I,[],D)),t.push([A,I])}e.registerSingleton=S;function P(){return t}e.getSingletonServiceDescriptors=P}),define(ye[132],Se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class r{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=r;class t{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let A of this._nodes.values())A.outgoing.size===0&&P.push(A);return P}insertEdge(P,A){const I=this.lookupOrInsertNode(P),D=this.lookupOrInsertNode(A);I.outgoing.set(this._hashFn(A),D),D.incoming.set(this._hashFn(P),I)}removeNode(P){const A=this._hashFn(P);this._nodes.delete(A);for(let I of this._nodes.values())I.outgoing.delete(A),I.incoming.delete(A)}lookupOrInsertNode(P){const A=this._hashFn(P);let I=this._nodes.get(A);return I||(I=new r(P),this._nodes.set(A,I)),I}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[A,I]of this._nodes)P.push(`${A}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return P.join(`
`)}findCycleSlow(){for(let[P,A]of this._nodes){const I=new Set([P]),D=this._findCycle(A,I);if(D)return D}}_findCycle(P,A){for(let[I,D]of P.outgoing){if(A.has(I))return[...A,I].join(" -> ");A.add(I);const T=this._findCycle(D,A);if(T)return T;A.delete(I)}}}e.Graph=t}),define(ye[3],Se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var r;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function I(D){return D[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=I})(r=e._util||(e._util={})),e.IInstantiationService=S("instantiationService");function t(A,I,D,T){I[r.DI_TARGET]===I?I[r.DI_DEPENDENCIES].push({id:A,index:D,optional:T}):(I[r.DI_DEPENDENCIES]=[{id:A,index:D,optional:T}],I[r.DI_TARGET]=I)}function S(A){if(r.serviceIds.has(A))return r.serviceIds.get(A);const I=function(D,T,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(I,D,R,!1)};return I.toString=()=>A,r.serviceIds.set(A,I),I}e.createDecorator=S;function P(A){return A}e.refineServiceDecorator=P}),define(ye[133],Se([0,1,3]),function(Z,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,r.createDecorator)("modelService");function t(S){return!S.isTooLargeForSyncing()&&!S.isForSimpleWidget}e.shouldSynchronizeModel=t}),define(ye[134],Se([0,1,4,6,56,133]),function(Z,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRegistry=void 0;function A(D){return typeof D=="string"?!1:Array.isArray(D)?D.every(A):!!D.exclusive}class I{constructor(){this._clock=0,this._entries=[],this._onDidChange=new r.Emitter}get onDidChange(){return this._onDidChange.event}register(T,R){let b={selector:T,provider:R,_score:-1,_time:this._clock++};return this._entries.push(b),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,t.toDisposable)(()=>{if(b){const i=this._entries.indexOf(b);i>=0&&(this._entries.splice(i,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),b=void 0)}})}has(T){return this.all(T).length>0}all(T){if(!T)return[];this._updateScores(T);const R=[];for(let b of this._entries)b._score>0&&R.push(b.provider);return R}ordered(T){const R=[];return this._orderedForEach(T,b=>R.push(b.provider)),R}orderedGroups(T){const R=[];let b,i;return this._orderedForEach(T,h=>{b&&i===h._score?b.push(h.provider):(i=h._score,b=[h.provider],R.push(b))}),R}_orderedForEach(T,R){if(!!T){this._updateScores(T);for(const b of this._entries)b._score>0&&R(b)}}_updateScores(T){const R={uri:T.uri.toString(),language:T.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===R.language&&this._lastCandidate.uri===R.uri)){this._lastCandidate=R;for(let b of this._entries)if(b._score=(0,S.score)(b.selector,T.uri,T.getLanguageId(),(0,P.shouldSynchronizeModel)(T)),A(b.selector)&&b._score>0){for(let i of this._entries)i._score=0;b._score=1e3;break}this._entries.sort(I._compareByScoreAndTime)}}static _compareByScoreAndTime(T,R){return T._score<R._score?1:T._score>R._score?-1:T._time<R._time?1:T._time>R._time?-1:0}}e.LanguageFeatureRegistry=I}),define(ye[57],Se([0,1,2,58,134,107,52]),function(Z,e,r,t,S,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var I;(function(v){v[v.Null=0]="Null",v[v.PlainText=1]="PlainText"})(I=e.LanguageId||(e.LanguageId={}));var D;(function(v){v[v.NotSet=-1]="NotSet",v[v.None=0]="None",v[v.Italic=1]="Italic",v[v.Bold=2]="Bold",v[v.Underline=4]="Underline",v[v.Strikethrough=8]="Strikethrough"})(D=e.FontStyle||(e.FontStyle={}));var T;(function(v){v[v.None=0]="None",v[v.DefaultForeground=1]="DefaultForeground",v[v.DefaultBackground=2]="DefaultBackground"})(T=e.ColorId||(e.ColorId={}));var R;(function(v){v[v.Other=0]="Other",v[v.Comment=1]="Comment",v[v.String=2]="String",v[v.RegEx=3]="RegEx"})(R=e.StandardTokenType||(e.StandardTokenType={}));var b;(function(v){v[v.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",v[v.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",v[v.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",v[v.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",v[v.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",v[v.ITALIC_MASK=1024]="ITALIC_MASK",v[v.BOLD_MASK=2048]="BOLD_MASK",v[v.UNDERLINE_MASK=4096]="UNDERLINE_MASK",v[v.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",v[v.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",v[v.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",v[v.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",v[v.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",v[v.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",v[v.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",v[v.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",v[v.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",v[v.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",v[v.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",v[v.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(b=e.MetadataConsts||(e.MetadataConsts={}));class i{static getLanguageId(k){return(k&255)>>>0}static getTokenType(k){return(k&768)>>>8}static getFontStyle(k){return(k&15360)>>>10}static getForeground(k){return(k&8372224)>>>14}static getBackground(k){return(k&4286578688)>>>23}static getClassNameFromMetadata(k){const L=this.getForeground(k);let y="mtk"+L;const O=this.getFontStyle(k);return O&1&&(y+=" mtki"),O&2&&(y+=" mtkb"),O&4&&(y+=" mtku"),O&8&&(y+=" mtks"),y}static getInlineStyleFromMetadata(k,L){const y=this.getForeground(k),O=this.getFontStyle(k);let U=`color: ${L[y]};`;O&1&&(U+="font-style: italic;"),O&2&&(U+="font-weight: bold;");let q="";return O&4&&(q+=" underline"),O&8&&(q+=" line-through"),q&&(U+=`text-decoration:${q};`),U}static getPresentationFromMetadata(k){const L=this.getForeground(k),y=this.getFontStyle(k);return{foreground:L,italic:Boolean(y&1),bold:Boolean(y&2),underline:Boolean(y&4),strikethrough:Boolean(y&8)}}}e.TokenMetadata=i;var h;(function(v){v[v.Method=0]="Method",v[v.Function=1]="Function",v[v.Constructor=2]="Constructor",v[v.Field=3]="Field",v[v.Variable=4]="Variable",v[v.Class=5]="Class",v[v.Struct=6]="Struct",v[v.Interface=7]="Interface",v[v.Module=8]="Module",v[v.Property=9]="Property",v[v.Event=10]="Event",v[v.Operator=11]="Operator",v[v.Unit=12]="Unit",v[v.Value=13]="Value",v[v.Constant=14]="Constant",v[v.Enum=15]="Enum",v[v.EnumMember=16]="EnumMember",v[v.Keyword=17]="Keyword",v[v.Text=18]="Text",v[v.Color=19]="Color",v[v.File=20]="File",v[v.Reference=21]="Reference",v[v.Customcolor=22]="Customcolor",v[v.Folder=23]="Folder",v[v.TypeParameter=24]="TypeParameter",v[v.User=25]="User",v[v.Issue=26]="Issue",v[v.Snippet=27]="Snippet"})(h=e.CompletionItemKind||(e.CompletionItemKind={}));var l;(function(v){const k=new Map;k.set(0,A.Codicon.symbolMethod),k.set(1,A.Codicon.symbolFunction),k.set(2,A.Codicon.symbolConstructor),k.set(3,A.Codicon.symbolField),k.set(4,A.Codicon.symbolVariable),k.set(5,A.Codicon.symbolClass),k.set(6,A.Codicon.symbolStruct),k.set(7,A.Codicon.symbolInterface),k.set(8,A.Codicon.symbolModule),k.set(9,A.Codicon.symbolProperty),k.set(10,A.Codicon.symbolEvent),k.set(11,A.Codicon.symbolOperator),k.set(12,A.Codicon.symbolUnit),k.set(13,A.Codicon.symbolValue),k.set(15,A.Codicon.symbolEnum),k.set(14,A.Codicon.symbolConstant),k.set(15,A.Codicon.symbolEnum),k.set(16,A.Codicon.symbolEnumMember),k.set(17,A.Codicon.symbolKeyword),k.set(27,A.Codicon.symbolSnippet),k.set(18,A.Codicon.symbolText),k.set(19,A.Codicon.symbolColor),k.set(20,A.Codicon.symbolFile),k.set(21,A.Codicon.symbolReference),k.set(22,A.Codicon.symbolCustomColor),k.set(23,A.Codicon.symbolFolder),k.set(24,A.Codicon.symbolTypeParameter),k.set(25,A.Codicon.account),k.set(26,A.Codicon.issues);function L(U){let q=k.get(U);return q||(console.info("No codicon found for CompletionItemKind "+U),q=A.Codicon.symbolProperty),q}v.toIcon=L;const y=new Map;y.set("method",0),y.set("function",1),y.set("constructor",2),y.set("field",3),y.set("variable",4),y.set("class",5),y.set("struct",6),y.set("interface",7),y.set("module",8),y.set("property",9),y.set("event",10),y.set("operator",11),y.set("unit",12),y.set("value",13),y.set("constant",14),y.set("enum",15),y.set("enum-member",16),y.set("enumMember",16),y.set("keyword",17),y.set("snippet",27),y.set("text",18),y.set("color",19),y.set("file",20),y.set("reference",21),y.set("customcolor",22),y.set("folder",23),y.set("type-parameter",24),y.set("typeParameter",24),y.set("account",25),y.set("issue",26);function O(U,q){let H=y.get(U);return typeof H=="undefined"&&!q&&(H=9),H}v.fromString=O})(l=e.CompletionItemKinds||(e.CompletionItemKinds={}));var o;(function(v){v[v.Deprecated=1]="Deprecated"})(o=e.CompletionItemTag||(e.CompletionItemTag={}));var m;(function(v){v[v.KeepWhitespace=1]="KeepWhitespace",v[v.InsertAsSnippet=4]="InsertAsSnippet"})(m=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var M;(function(v){v[v.Invoke=0]="Invoke",v[v.TriggerCharacter=1]="TriggerCharacter",v[v.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(M=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var C;(function(v){v[v.Automatic=0]="Automatic",v[v.Explicit=1]="Explicit"})(C=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var w;(function(v){v[v.Invoke=1]="Invoke",v[v.Auto=2]="Auto"})(w=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var u;(function(v){v[v.Invoke=1]="Invoke",v[v.TriggerCharacter=2]="TriggerCharacter",v[v.ContentChange=3]="ContentChange"})(u=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var _;(function(v){v[v.Text=0]="Text",v[v.Read=1]="Read",v[v.Write=2]="Write"})(_=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function a(v){return v&&r.URI.isUri(v.uri)&&t.Range.isIRange(v.range)&&(t.Range.isIRange(v.originSelectionRange)||t.Range.isIRange(v.targetSelectionRange))}e.isLocationLink=a;var F;(function(v){v[v.File=0]="File",v[v.Module=1]="Module",v[v.Namespace=2]="Namespace",v[v.Package=3]="Package",v[v.Class=4]="Class",v[v.Method=5]="Method",v[v.Property=6]="Property",v[v.Field=7]="Field",v[v.Constructor=8]="Constructor",v[v.Enum=9]="Enum",v[v.Interface=10]="Interface",v[v.Function=11]="Function",v[v.Variable=12]="Variable",v[v.Constant=13]="Constant",v[v.String=14]="String",v[v.Number=15]="Number",v[v.Boolean=16]="Boolean",v[v.Array=17]="Array",v[v.Object=18]="Object",v[v.Key=19]="Key",v[v.Null=20]="Null",v[v.EnumMember=21]="EnumMember",v[v.Struct=22]="Struct",v[v.Event=23]="Event",v[v.Operator=24]="Operator",v[v.TypeParameter=25]="TypeParameter"})(F=e.SymbolKind||(e.SymbolKind={}));var c;(function(v){v[v.Deprecated=1]="Deprecated"})(c=e.SymbolTag||(e.SymbolTag={}));var n;(function(v){const k=new Map;k.set(0,A.Codicon.symbolFile),k.set(1,A.Codicon.symbolModule),k.set(2,A.Codicon.symbolNamespace),k.set(3,A.Codicon.symbolPackage),k.set(4,A.Codicon.symbolClass),k.set(5,A.Codicon.symbolMethod),k.set(6,A.Codicon.symbolProperty),k.set(7,A.Codicon.symbolField),k.set(8,A.Codicon.symbolConstructor),k.set(9,A.Codicon.symbolEnum),k.set(10,A.Codicon.symbolInterface),k.set(11,A.Codicon.symbolFunction),k.set(12,A.Codicon.symbolVariable),k.set(13,A.Codicon.symbolConstant),k.set(14,A.Codicon.symbolString),k.set(15,A.Codicon.symbolNumber),k.set(16,A.Codicon.symbolBoolean),k.set(17,A.Codicon.symbolArray),k.set(18,A.Codicon.symbolObject),k.set(19,A.Codicon.symbolKey),k.set(20,A.Codicon.symbolNull),k.set(21,A.Codicon.symbolEnumMember),k.set(22,A.Codicon.symbolStruct),k.set(23,A.Codicon.symbolEvent),k.set(24,A.Codicon.symbolOperator),k.set(25,A.Codicon.symbolTypeParameter);function L(y){let O=k.get(y);return O||(console.info("No codicon found for SymbolKind "+y),O=A.Codicon.symbolProperty),O}v.toIcon=L})(n=e.SymbolKinds||(e.SymbolKinds={}));class f{constructor(k){this.value=k}}e.FoldingRangeKind=f,f.Comment=new f("comment"),f.Imports=new f("imports"),f.Region=new f("region");var g;(function(v){function k(L){return!L||typeof L!="object"?!1:typeof L.id=="string"&&typeof L.title=="string"}v.is=k})(g=e.Command||(e.Command={}));var s;(function(v){v[v.Collapsed=0]="Collapsed",v[v.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(v){v[v.Editing=0]="Editing",v[v.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var p;(function(v){v[v.Other=0]="Other",v[v.Type=1]="Type",v[v.Parameter=2]="Parameter"})(p=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new S.LanguageFeatureRegistry,e.RenameProviderRegistry=new S.LanguageFeatureRegistry,e.CompletionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new S.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new S.LanguageFeatureRegistry,e.HoverProviderRegistry=new S.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new S.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new S.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new S.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new S.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new S.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.LinkProviderRegistry=new S.LanguageFeatureRegistry,e.ColorProviderRegistry=new S.LanguageFeatureRegistry,e.SelectionRangeRegistry=new S.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.TokenizationRegistry=new P.TokenizationRegistry;var E;(function(v){v[v.None=0]="None",v[v.Option=1]="Option",v[v.Default=2]="Default",v[v.Preferred=3]="Preferred"})(E=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ye[79],Se([0,1,13,2,3]),function(Z,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,S.createDecorator)("configurationService");function P(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationOverrides=P;function A(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||r.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=A;var I;(function(m){m[m.USER=1]="USER",m[m.USER_LOCAL=2]="USER_LOCAL",m[m.USER_REMOTE=3]="USER_REMOTE",m[m.WORKSPACE=4]="WORKSPACE",m[m.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",m[m.DEFAULT=6]="DEFAULT",m[m.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function D(m){switch(m){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=D;function T(m,M){const C=Object.create(null);for(let w in m)R(C,w,m[w],M);return C}e.toValuesTree=T;function R(m,M,C,w){const u=M.split("."),_=u.pop();let a=m;for(let F=0;F<u.length;F++){let c=u[F],n=a[c];switch(typeof n){case"undefined":n=a[c]=Object.create(null);break;case"object":break;default:w(`Ignoring ${M} as ${u.slice(0,F+1).join(".")} is ${JSON.stringify(n)}`);return}a=n}if(typeof a=="object"&&a!==null)try{a[_]=C}catch{w(`Ignoring ${M} as ${u.join(".")} is ${JSON.stringify(a)}`)}else w(`Ignoring ${M} as ${u.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=R;function b(m,M){const C=M.split(".");i(m,C)}e.removeFromValueTree=b;function i(m,M){const C=M.shift();if(M.length===0){delete m[C];return}if(Object.keys(m).indexOf(C)!==-1){const w=m[C];typeof w=="object"&&!Array.isArray(w)&&(i(w,M),Object.keys(w).length===0&&delete m[C])}}function h(m,M,C){function w(a,F){let c=a;for(const n of F){if(typeof c!="object"||c===null)return;c=c[n]}return c}const u=M.split("."),_=w(m,u);return typeof _=="undefined"?C:_}e.getConfigurationValue=h;function l(m,M,C){Object.keys(M).forEach(w=>{w!=="__proto__"&&(w in m?r.isObject(m[w])&&r.isObject(M[w])?l(m[w],M[w],C):C&&(m[w]=M[w]):m[w]=M[w])})}e.merge=l;function o(m,M,C){const w=m.inspect(M),u=m.inspect(C);return typeof w.userValue!="undefined"||typeof w.workspaceValue!="undefined"||typeof w.workspaceFolderValue!="undefined"?w.value:typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:w.defaultValue}e.getMigratedSettingValue=o}),define(ye[45],Se([0,1,23,9,3]),function(Z,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",r.isMacintosh),P.set("isLinux",r.isLinux),P.set("isWindows",r.isWindows),P.set("isWeb",r.isWeb),P.set("isMacNative",r.isMacintosh&&!r.isWeb),P.set("isEdge",r.isEdge),P.set("isFirefox",r.isFirefox),P.set("isChrome",r.isChrome),P.set("isSafari",r.isSafari);const A=Object.prototype.hasOwnProperty;var I;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(I=e.ContextKeyExprType||(e.ContextKeyExprType={}));class D{static false(){return b.INSTANCE}static true(){return i.INSTANCE}static has(y){return h.create(y)}static equals(y,O){return l.create(y,O)}static notEquals(y,O){return M.create(y,O)}static regex(y,O){return c.create(y,O)}static in(y,O){return o.create(y,O)}static not(y){return C.create(y)}static and(...y){return g.create(y,null)}static or(...y){return s.create(y,null,!0)}static greater(y,O){return u.create(y,O)}static greaterEquals(y,O){return _.create(y,O)}static smaller(y,O){return a.create(y,O)}static smallerEquals(y,O){return F.create(y,O)}static deserialize(y,O=!1){if(!!y)return this._deserializeOrExpression(y,O)}static _deserializeOrExpression(y,O){let U=y.split("||");return s.create(U.map(q=>this._deserializeAndExpression(q,O)),null,!0)}static _deserializeAndExpression(y,O){let U=y.split("&&");return g.create(U.map(q=>this._deserializeOne(q,O)),null)}static _deserializeOne(y,O){if(y=y.trim(),y.indexOf("!=")>=0){let U=y.split("!=");return M.create(U[0].trim(),this._deserializeValue(U[1],O))}if(y.indexOf("==")>=0){let U=y.split("==");return l.create(U[0].trim(),this._deserializeValue(U[1],O))}if(y.indexOf("=~")>=0){let U=y.split("=~");return c.create(U[0].trim(),this._deserializeRegexValue(U[1],O))}if(y.indexOf(" in ")>=0){let U=y.split(" in ");return o.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(y)){const U=y.split(">=");return _.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(y)){const U=y.split(">");return u.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(y)){const U=y.split("<=");return F.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(y)){const U=y.split("<");return a.create(U[0].trim(),U[1].trim())}return/^\!\s*/.test(y)?C.create(y.substr(1).trim()):h.create(y)}static _deserializeValue(y,O){if(y=y.trim(),y==="true")return!0;if(y==="false")return!1;let U=/^'([^']*)'$/.exec(y);return U?U[1].trim():y}static _deserializeRegexValue(y,O){if((0,t.isFalsyOrWhitespace)(y)){if(O)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let U=y.indexOf("/"),q=y.lastIndexOf("/");if(U===q||U<0){if(O)throw new Error(`bad regexp-value '${y}', missing /-enclosure`);return console.warn(`bad regexp-value '${y}', missing /-enclosure`),null}let H=y.slice(U+1,q),z=y[q+1]==="i"?"i":"";try{return new RegExp(H,z)}catch(j){if(O)throw new Error(`bad regexp-value '${y}', parse error: ${j}`);return console.warn(`bad regexp-value '${y}', parse error: ${j}`),null}}}e.ContextKeyExpr=D;function T(L,y){const O=L?L.substituteConstants():void 0,U=y?y.substituteConstants():void 0;return!O&&!U?!0:!O||!U?!1:O.equals(U)}e.expressionsAreEqualWithConstantSubstitution=T;function R(L,y){return L.cmp(y)}class b{constructor(){this.type=0}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!1}serialize(){return"false"}keys(){return[]}map(y){return this}negate(){return i.INSTANCE}}e.ContextKeyFalseExpr=b,b.INSTANCE=new b;class i{constructor(){this.type=1}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!0}serialize(){return"true"}keys(){return[]}map(y){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=i,i.INSTANCE=new i;class h{constructor(y,O){this.key=y,this.negated=O,this.type=2}static create(y,O=null){const U=P.get(y);return typeof U=="boolean"?U?i.INSTANCE:b.INSTANCE:new h(y,O)}cmp(y){return y.type!==this.type?this.type-y.type:p(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=P.get(this.key);return typeof y=="boolean"?y?i.INSTANCE:b.INSTANCE:this}evaluate(y){return!!y.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(y){return y.mapDefined(this.key)}negate(){return this.negated||(this.negated=C.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class l{constructor(y,O,U){this.key=y,this.value=O,this.negated=U,this.type=4}static create(y,O,U=null){if(typeof O=="boolean")return O?h.create(y,U):C.create(y,U);const q=P.get(y);return typeof q=="boolean"?O===(q?"true":"false")?i.INSTANCE:b.INSTANCE:new l(y,O,U)}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=P.get(this.key);if(typeof y=="boolean"){const O=y?"true":"false";return this.value===O?i.INSTANCE:b.INSTANCE}return this}evaluate(y){return y.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(y){return y.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=l;class o{constructor(y,O){this.key=y,this.valueKey=O,this.type=10,this.negated=null}static create(y,O){return new o(y,O)}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,this.valueKey,y.key,y.valueKey)}equals(y){return y.type===this.type?this.key===y.key&&this.valueKey===y.valueKey:!1}substituteConstants(){return this}evaluate(y){const O=y.getValue(this.valueKey),U=y.getValue(this.key);return Array.isArray(O)?O.indexOf(U)>=0:typeof U=="string"&&typeof O=="object"&&O!==null?A.call(O,U):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(y){return y.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=m.create(this)),this.negated}}e.ContextKeyInExpr=o;class m{constructor(y){this._actual=y,this.type=11}static create(y){return new m(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new m(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotInExpr=m;class M{constructor(y,O,U){this.key=y,this.value=O,this.negated=U,this.type=5}static create(y,O,U=null){if(typeof O=="boolean")return O?C.create(y,U):h.create(y,U);const q=P.get(y);return typeof q=="boolean"?O===(q?"true":"false")?b.INSTANCE:i.INSTANCE:new M(y,O,U)}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=P.get(this.key);if(typeof y=="boolean"){const O=y?"true":"false";return this.value===O?b.INSTANCE:i.INSTANCE}return this}evaluate(y){return y.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(y){return y.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=M;class C{constructor(y,O){this.key=y,this.negated=O,this.type=3}static create(y,O=null){const U=P.get(y);return typeof U=="boolean"?U?b.INSTANCE:i.INSTANCE:new C(y,O)}cmp(y){return y.type!==this.type?this.type-y.type:p(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=P.get(this.key);return typeof y=="boolean"?y?b.INSTANCE:i.INSTANCE:this}evaluate(y){return!y.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(y){return y.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=C;function w(L,y){if(typeof L=="string"){const O=parseFloat(L);isNaN(O)||(L=O)}return typeof L=="string"||typeof L=="number"?y(L):b.INSTANCE}class u{constructor(y,O,U){this.key=y,this.value=O,this.negated=U,this.type=12}static create(y,O,U=null){return w(O,q=>new u(y,q,U))}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=u;class _{constructor(y,O,U){this.key=y,this.value=O,this.negated=U,this.type=13}static create(y,O,U=null){return w(O,q=>new _(y,q,U))}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=_;class a{constructor(y,O,U){this.key=y,this.value=O,this.negated=U,this.type=14}static create(y,O,U=null){return w(O,q=>new a(y,q,U))}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class F{constructor(y,O,U){this.key=y,this.value=O,this.negated=U,this.type=15}static create(y,O,U=null){return w(O,q=>new F(y,q,U))}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=F;class c{constructor(y,O){this.key=y,this.regexp=O,this.type=7,this.negated=null}static create(y,O){return new c(y,O)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.key<y.key)return-1;if(this.key>y.key)return 1;const O=this.regexp?this.regexp.source:"",U=y.regexp?y.regexp.source:"";return O<U?-1:O>U?1:0}equals(y){if(y.type===this.type){const O=this.regexp?this.regexp.source:"",U=y.regexp?y.regexp.source:"";return this.key===y.key&&O===U}return!1}substituteConstants(){return this}evaluate(y){let O=y.getValue(this.key);return this.regexp?this.regexp.test(O):!1}serialize(){const y=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${y}`}keys(){return[this.key]}map(y){return y.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=c;class n{constructor(y){this._actual=y,this.type=8}static create(y){return new n(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new n(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function f(L){let y=null;for(let O=0,U=L.length;O<U;O++){const q=L[O].substituteConstants();if(L[O]!==q&&y===null){y=[];for(let H=0;H<O;H++)y[H]=L[H]}y!==null&&(y[O]=q)}return y===null?L:y}class g{constructor(y,O){this.expr=y,this.negated=O,this.type=6}static create(y,O){return g._normalizeArr(y,O)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let O=0,U=this.expr.length;O<U;O++){const q=R(this.expr[O],y.expr[O]);if(q!==0)return q}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let O=0,U=this.expr.length;O<U;O++)if(!this.expr[O].equals(y.expr[O]))return!1;return!0}return!1}substituteConstants(){const y=f(this.expr);return y===this.expr?this:g.create(y,this.negated)}evaluate(y){for(let O=0,U=this.expr.length;O<U;O++)if(!this.expr[O].evaluate(y))return!1;return!0}static _normalizeArr(y,O){const U=[];let q=!1;for(const H of y)if(!!H){if(H.type===1){q=!0;continue}if(H.type===0)return b.INSTANCE;if(H.type===6){U.push(...H.expr);continue}U.push(H)}if(U.length===0&&q)return i.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(R);for(let H=1;H<U.length;H++)U[H-1].equals(U[H])&&(U.splice(H,1),H--);if(U.length===1)return U[0];for(;U.length>1;){const H=U[U.length-1];if(H.type!==9)break;U.pop();const z=U.pop(),j=U.length===0,ie=s.create(H.expr.map(ae=>g.create([ae,z],null)),null,j);ie&&(U.push(ie),U.sort(R))}return U.length===1?U[0]:new g(U,O)}}serialize(){return this.expr.map(y=>y.serialize()).join(" && ")}keys(){const y=[];for(let O of this.expr)y.push(...O.keys());return y}map(y){return new g(this.expr.map(O=>O.map(y)),null)}negate(){if(!this.negated){const y=[];for(let O of this.expr)y.push(O.negate());this.negated=s.create(y,this,!0)}return this.negated}}class s{constructor(y,O){this.expr=y,this.negated=O,this.type=9}static create(y,O,U){return s._normalizeArr(y,O,U)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let O=0,U=this.expr.length;O<U;O++){const q=R(this.expr[O],y.expr[O]);if(q!==0)return q}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let O=0,U=this.expr.length;O<U;O++)if(!this.expr[O].equals(y.expr[O]))return!1;return!0}return!1}substituteConstants(){const y=f(this.expr);return y===this.expr?this:s.create(y,this.negated,!1)}evaluate(y){for(let O=0,U=this.expr.length;O<U;O++)if(this.expr[O].evaluate(y))return!0;return!1}static _normalizeArr(y,O,U){let q=[],H=!1;if(y){for(let z=0,j=y.length;z<j;z++){const ie=y[z];if(!!ie){if(ie.type===0){H=!0;continue}if(ie.type===1)return i.INSTANCE;if(ie.type===9){q=q.concat(ie.expr);continue}q.push(ie)}}if(q.length===0&&H)return b.INSTANCE;q.sort(R)}if(q.length!==0){if(q.length===1)return q[0];for(let z=1;z<q.length;z++)q[z-1].equals(q[z])&&(q.splice(z,1),z--);if(q.length===1)return q[0];if(U){for(let z=0;z<q.length;z++)for(let j=z+1;j<q.length;j++)v(q[z],q[j])&&(q.splice(j,1),j--);if(q.length===1)return q[0]}return new s(q,O)}}serialize(){return this.expr.map(y=>y.serialize()).join(" || ")}keys(){const y=[];for(let O of this.expr)y.push(...O.keys());return y}map(y){return new s(this.expr.map(O=>O.map(y)),null)}negate(){if(!this.negated){let y=[];for(let O of this.expr)y.push(O.negate());for(;y.length>1;){const O=y.shift(),U=y.shift(),q=[];for(const z of k(O))for(const j of k(U))q.push(g.create([z,j],null));const H=y.length===0;y.unshift(s.create(q,null,H))}this.negated=y[0]}return this.negated}}class d extends h{constructor(y,O,U){super(y,null);this._defaultValue=O,typeof U=="object"?d._info.push({...U,key:y}):U!==!0&&d._info.push({key:y,description:U,type:O!=null?typeof O:void 0})}static all(){return d._info.values()}bindTo(y){return y.createKey(this.key,this._defaultValue)}getValue(y){return y.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(y){return l.create(this.key,y)}notEqualsTo(y){return M.create(this.key,y)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,S.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(L,y){return L<y?-1:L>y?1:0}function E(L,y,O,U){return L<O?-1:L>O?1:y<U?-1:y>U?1:0}function v(L,y){if(y.type===6&&L.type!==9&&L.type!==6){for(const q of y.expr)if(L.equals(q))return!0}const O=L.negate(),U=k(O).concat(k(y));U.sort(R);for(let q=0;q<U.length;q++){const z=U[q].negate();for(let j=q+1;j<U.length;j++){const ie=U[j];if(z.equals(ie))return!0}}return!1}e.implies=v;function k(L){return L.type===9?L.expr:[L]}}),define(ye[135],Se([0,1,3]),function(Z,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,r.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,r.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[46],Se([0,1,22,17,9,13,2,116,3]),function(Z,e,r,t,S,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,D.createDecorator)("fileService");function T(H){return H.create===!0}e.isFileOpenForWriteOptions=T;var R;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var b;(function(H){H[H.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var i;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead"})(i=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=h;function l(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=l;function o(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=o;function m(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=m;function M(H){return h(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=M;var C;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(C=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(z,j){super(z);this.code=j}}e.FileSystemProviderError=w;function u(H,z){const j=new w(H.toString(),z);return a(j,z),j}e.createFileSystemProviderError=u;function _(H){return H||u((0,I.localize)(0,null),C.Unknown)}e.ensureFileSystemProviderError=_;function a(H,z){return H.name=z?`${z} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=a;function F(H){if(!H)return C.Unknown;if(H instanceof w)return H.code;const z=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!z)return C.Unknown;switch(z[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileExceedsMemoryLimit:return C.FileExceedsMemoryLimit;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}e.toFileSystemProviderErrorCode=F;function c(H){if(H instanceof p)return H.fileOperationResult;switch(F(H)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 10;case C.FileWriteLocked:return 5;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileExceedsMemoryLimit:return 9;case C.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=c;var n;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class f{constructor(z,j,ie){this.resource=z,this.operation=j,this.target=ie}isOperation(z){return this.operation===z}}e.FileOperationEvent=f;var g;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(g=e.FileChangeType||(e.FileChangeType={}));class s{constructor(z,j){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=z;const ie=new Map;for(const ae of z){const te=ie.get(ae.type);switch(te?te.push([ae.resource,ae]):ie.set(ae.type,[[ae.resource,ae]]),ae.type){case 1:this.rawAdded.push(ae.resource);break;case 0:this.rawUpdated.push(ae.resource);break;case 2:this.rawDeleted.push(ae.resource);break}}for(const[ae,te]of ie)switch(ae){case 1:this.added=r.TernarySearchTree.forUris(()=>j),this.added.fill(te);break;case 0:this.updated=r.TernarySearchTree.forUris(()=>j),this.updated.fill(te);break;case 2:this.deleted=r.TernarySearchTree.forUris(()=>j),this.deleted.fill(te);break}}contains(z,...j){return this.doContains(z,{includeChildren:!1},...j)}affects(z,...j){return this.doContains(z,{includeChildren:!0},...j)}doContains(z,j,...ie){if(!z)return!1;const ae=ie.length>0;return!!((!ae||ie.includes(1))&&(this.added?.get(z)||j.includeChildren&&this.added?.findSuperstr(z))||(!ae||ie.includes(0))&&(this.updated?.get(z)||j.includeChildren&&this.updated?.findSuperstr(z))||(!ae||ie.includes(2))&&(this.deleted?.findSubstr(z)||j.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=s;function d(H,z,j){return!H||!z||H===z||z.length>H.length?!1:(z.charAt(z.length-1)!==t.sep&&(z+=t.sep),j?(0,S.startsWithIgnoreCase)(H,z):H.indexOf(z)===0)}e.isParent=d;class p extends Error{constructor(z,j,ie){super(z);this.fileOperationResult=j,this.options=ie}}e.FileOperationError=p;class E extends p{constructor(z,j,ie){super(z,2,ie);this.stat=j}}e.NotModifiedSinceFileOperationError=E;var v;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(v=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var k;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(k=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=L;async function y(H,z){if(!z.hasProvider(A.URI.from({scheme:H.scheme})))return new Promise(j=>{const ie=z.onDidChangeFileSystemProviderRegistrations(ae=>{ae.scheme===H.scheme&&ae.added&&(ie.dispose(),j())})})}e.whenProviderRegistered=y,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize(z){return(0,P.isNumber)(z)||(z=0),z<O.KB?(0,I.localize)(1,null,z.toFixed(0)):z<O.MB?(0,I.localize)(2,null,(z/O.KB).toFixed(2)):z<O.GB?(0,I.localize)(3,null,(z/O.MB).toFixed(2)):z<O.TB?(0,I.localize)(4,null,(z/O.GB).toFixed(2)):(0,I.localize)(5,null,(z/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB;var U;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(U=e.Arch||(e.Arch={}));function q(H){return{maxFileSize:H===0?300*O.MB:16*O.GB,maxHeapSize:H===0?700*O.MB:2*700*O.MB}}e.getPlatformLimits=q}),define(ye[59],Se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class r{constructor(...S){this._entries=new Map;for(let[P,A]of S)this.set(P,A)}set(S,P){const A=this._entries.get(S);return this._entries.set(S,P),A}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}e.ServiceCollection=r}),define(ye[136],Se([0,1,10,15,78,132,3,59]),function(Z,e,r,t,S,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const D=!1;class T extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class R{constructor(l=new I.ServiceCollection,o=!1,m){this._activeInstantiations=new Set,this._services=l,this._strict=o,this._parent=m,this._services.set(A.IInstantiationService,this)}createChild(l){return new R(l,this._strict,this)}invokeFunction(l,...o){let m=i.traceInvocation(l),M=!1;try{return l({get:w=>{if(M)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(w,m);if(!u)throw new Error(`[invokeFunction] unknown service '${w}'`);return u}},...o)}finally{M=!0,m.stop()}}createInstance(l,...o){let m,M;return l instanceof S.SyncDescriptor?(m=i.traceCreation(l.ctor),M=this._createInstance(l.ctor,l.staticArguments.concat(o),m)):(m=i.traceCreation(l),M=this._createInstance(l,o,m)),m.stop(),M}_createInstance(l,o=[],m){let M=A._util.getServiceDependencies(l).sort((u,_)=>u.index-_.index),C=[];for(const u of M){let _=this._getOrCreateServiceInstance(u.id,m);if(!_&&this._strict&&!u.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${u.id}.`);C.push(_)}let w=M.length>0?M[0].index:o.length;if(o.length!==w){console.warn(`[createInstance] First service dependency of ${l.name} at position ${w+1} conflicts with ${o.length} static arguments`);let u=w-o.length;u>0?o=o.concat(new Array(u)):o=o.slice(0,w)}return new l(...[...o,...C])}_setServiceInstance(l,o){if(this._services.get(l)instanceof S.SyncDescriptor)this._services.set(l,o);else if(this._parent)this._parent._setServiceInstance(l,o);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let o=this._services.get(l);return!o&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):o}_getOrCreateServiceInstance(l,o){let m=this._getServiceInstanceOrDescriptor(l);return m instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,m,o.branch(l,!0)):(o.branch(l,!1),m)}_safeCreateAndCacheServiceInstance(l,o,m){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,o,m)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,o,m){const M=new P.Graph(u=>u.id.toString());let C=0;const w=[{id:l,desc:o,_trace:m}];for(;w.length;){const u=w.pop();if(M.lookupOrInsertNode(u),C++>1e3)throw new T(M);for(let _ of A._util.getServiceDependencies(u.desc.ctor)){let a=this._getServiceInstanceOrDescriptor(_.id);if(!a&&!_.optional&&console.warn(`[createInstance] ${l} depends on ${_.id} which is NOT registered.`),a instanceof S.SyncDescriptor){const F={id:_.id,desc:a,_trace:u._trace.branch(_.id,!0)};M.insertEdge(u,F),w.push(F)}}}for(;;){const u=M.roots();if(u.length===0){if(!M.isEmpty())throw new T(M);break}for(const{data:_}of u){if(this._getServiceInstanceOrDescriptor(_.id)instanceof S.SyncDescriptor){const F=this._createServiceInstanceWithOwner(_.id,_.desc.ctor,_.desc.staticArguments,_.desc.supportsDelayedInstantiation,_._trace);this._setServiceInstance(_.id,F)}M.removeNode(_)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,o,m=[],M,C){if(this._services.get(l)instanceof S.SyncDescriptor)return this._createServiceInstance(o,m,M,C);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,o,m,M,C);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}_createServiceInstance(l,o=[],m,M){if(m){const C=new r.IdleValue(()=>this._createInstance(l,o,M));return new Proxy(Object.create(null),{get(w,u){if(u in w)return w[u];let _=C.value,a=_[u];return typeof a!="function"||(a=a.bind(_),w[u]=a),a},set(w,u,_){return C.value[u]=_,!0}})}else return this._createInstance(l,o,M)}}e.InstantiationService=R;var b;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(b||(b={}));class i{constructor(l,o){this.type=l,this.name=o,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return D?new i(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):i._None}static traceCreation(l){return D?new i(0,l.name):i._None}branch(l,o){let m=new i(2,l.toString());return this._dep.push([l,o,m]),m}stop(){let l=Date.now()-this._start;i._totals+=l;let o=!1;function m(C,w){let u=[],_=new Array(C+1).join("	");for(const[a,F,c]of w._dep)if(F&&c){o=!0,u.push(`${_}CREATES -> ${a}`);let n=m(C+1,c);n&&u.push(n)}else u.push(`${_}uses -> ${a}`);return u.join(`
`)}let M=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${i._totals.toFixed(2)}ms)`];(l>2||o)&&console.log(M.join(`
`))}}e.Trace=i,i._None=new class extends i{constructor(){super(-1,null)}stop(){}branch(){return this}},i._totals=0}),define(ye[12],Se([0,1,43,4,6,23,3]),function(Z,e,r,t,S,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function I(){return new Date().toISOString()}var D;(function(F){F[F.Trace=0]="Trace",F[F.Debug=1]="Debug",F[F.Info=2]="Info",F[F.Warning=3]="Warning",F[F.Error=4]="Error",F[F.Critical=5]="Critical",F[F.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;function T(F,c,n){switch(c){case D.Trace:F.trace(n);break;case D.Debug:F.debug(n);break;case D.Info:F.info(n);break;case D.Warning:F.warn(n);break;case D.Error:F.error(n);break;case D.Critical:F.critical(n);break;default:throw new Error("Invalid log level")}}e.log=T;function R(F){let c="";for(let n=0;n<F.length;n++){let f=F[n];if(typeof f=="object")try{f=JSON.stringify(f)}catch{}c+=(n>0?" ":"")+f}return c}e.format=R;class b extends S.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(c){this.level!==c&&(this.level=c,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class i extends b{constructor(c){super();this.logAlways=c}checkLogLevel(c){return this.logAlways||this.getLevel()<=c}trace(c,...n){this.checkLogLevel(D.Trace)&&this.log(D.Trace,R([c,...n]))}debug(c,...n){this.checkLogLevel(D.Debug)&&this.log(D.Debug,R([c,...n]))}info(c,...n){this.checkLogLevel(D.Info)&&this.log(D.Info,R([c,...n]))}warn(c,...n){this.checkLogLevel(D.Warning)&&this.log(D.Warning,R([c,...n]))}error(c,...n){if(this.checkLogLevel(D.Error))if(c instanceof Error){const f=Array.prototype.slice.call(arguments);f[0]=c.stack,this.log(D.Error,R(f))}else this.log(D.Error,R([c,...n]))}critical(c,...n){this.checkLogLevel(D.Critical)&&this.log(D.Critical,R([c,...n]))}flush(){}}e.AbstractMessageLogger=i;class h extends b{constructor(c=e.DEFAULT_LOG_LEVEL){super();this.setLevel(c),this.useColors=!P.isWindows}trace(c,...n){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,c,...n):console.log(`[main ${I()}]`,c,...n))}debug(c,...n){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,c,...n):console.log(`[main ${I()}]`,c,...n))}info(c,...n){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,c,...n):console.log(`[main ${I()}]`,c,...n))}warn(c,...n){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,c,...n):console.warn(`[main ${I()}]`,c,...n))}error(c,...n){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,c,...n):console.error(`[main ${I()}]`,c,...n))}critical(c,...n){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,c,...n):console.error(`[main ${I()}]`,c,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=h;class l extends b{constructor(c=e.DEFAULT_LOG_LEVEL){super();this.setLevel(c)}trace(c,...n){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",c,...n)}debug(c,...n){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",c,...n)}info(c,...n){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",c,...n)}warn(c,...n){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",c,...n)}error(c,...n){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",c,...n)}critical(c,...n){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",c,...n)}dispose(){}flush(){}}e.ConsoleLogger=l;class o extends b{constructor(c,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=c,this.setLevel(n)}trace(c,...n){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(c),...n])}debug(c,...n){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(c),...n])}info(c,...n){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(c),...n])}warn(c,...n){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(c),...n])}error(c,...n){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(c),...n])}critical(c,...n){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(c),...n])}extractMessage(c){return typeof c=="string"?c:(0,r.toErrorMessage)(c,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=o;class m extends b{constructor(c){super();this.logServices=c,c.length&&this.setLevel(c[0].getLevel())}setLevel(c){for(const n of this.logServices)n.setLevel(c);super.setLevel(c)}trace(c,...n){for(const f of this.logServices)f.trace(c,...n)}debug(c,...n){for(const f of this.logServices)f.debug(c,...n)}info(c,...n){for(const f of this.logServices)f.info(c,...n)}warn(c,...n){for(const f of this.logServices)f.warn(c,...n)}error(c,...n){for(const f of this.logServices)f.error(c,...n)}critical(c,...n){for(const f of this.logServices)f.critical(c,...n)}flush(){for(const c of this.logServices)c.flush()}dispose(){for(const c of this.logServices)c.dispose()}}e.MultiplexLogService=m;class M extends S.Disposable{constructor(c){super();this.logger=c,this._register(c)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(c){this.logger.setLevel(c)}getLevel(){return this.logger.getLevel()}trace(c,...n){this.logger.trace(c,...n)}debug(c,...n){this.logger.debug(c,...n)}info(c,...n){this.logger.info(c,...n)}warn(c,...n){this.logger.warn(c,...n)}error(c,...n){this.logger.error(c,...n)}critical(c,...n){this.logger.critical(c,...n)}flush(){this.logger.flush()}}e.LogService=M;class C extends S.Disposable{constructor(c,n){super();this.logLevel=c,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(f=>{this.logLevel=f,this.logLevelChangeableLoggers.forEach(g=>g.setLevel(f))}))}getLogger(c){return this.loggers.get(c.toString())}createLogger(c,n){let f=this.loggers.get(c.toString());return f||(f=this.doCreateLogger(c,n?.always?D.Trace:this.logLevel,n),this.loggers.set(c.toString(),f),n?.always||this.logLevelChangeableLoggers.push(f)),f}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(c=>c.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=C;class w{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(c){}getLevel(){return D.Info}trace(c,...n){}debug(c,...n){}info(c,...n){}warn(c,...n){}error(c,...n){}critical(c,...n){}dispose(){}flush(){}}e.NullLogService=w;function u(F){if(F.verbose)return D.Trace;if(typeof F.logLevel=="string"){const c=_(F.logLevel.toLowerCase());if(c!==void 0)return c}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function _(F){switch(F){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=_;function a(F){switch(F){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=a}),define(ye[80],Se([0,1,34,117,3]),function(Z,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var A;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(A=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function T(l,o){return o-l}D.compare=T;const R=Object.create(null);R[D.Error]=(0,t.localize)(0,null),R[D.Warning]=(0,t.localize)(1,null),R[D.Info]=(0,t.localize)(2,null);function b(l){return R[l]||""}D.toString=b;function i(l){switch(l){case r.default.Error:return D.Error;case r.default.Warning:return D.Warning;case r.default.Info:return D.Info;case r.default.Ignore:return D.Hint}}D.fromSeverity=i;function h(l){switch(l){case D.Error:return r.default.Error;case D.Warning:return r.default.Warning;case D.Info:return r.default.Info;case D.Hint:return r.default.Ignore}}D.toSeverity=h}(A=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(D){const T="";function R(i){return b(i,!0)}D.makeKey=R;function b(i,h){let l=[T];return i.source?l.push(i.source.replace("\xA6","\\\xA6")):l.push(T),i.code?typeof i.code=="string"?l.push(i.code.replace("\xA6","\\\xA6")):l.push(i.code.value.replace("\xA6","\\\xA6")):l.push(T),i.severity!==void 0&&i.severity!==null?l.push(A.toString(i.severity)):l.push(T),i.message&&h?l.push(i.message.replace("\xA6","\\\xA6")):l.push(T),i.startLineNumber!==void 0&&i.startLineNumber!==null?l.push(i.startLineNumber.toString()):l.push(T),i.startColumn!==void 0&&i.startColumn!==null?l.push(i.startColumn.toString()):l.push(T),i.endLineNumber!==void 0&&i.endLineNumber!==null?l.push(i.endLineNumber.toString()):l.push(T),i.endColumn!==void 0&&i.endColumn!==null?l.push(i.endColumn.toString()):l.push(T),l.push(T),l.join("\xA6")}D.makeKeyOptionalMessage=b})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,S.createDecorator)("markerService")}),define(ye[137],Se([0,1,4,34,3]),function(Z,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,S.createDecorator)("notificationService");var P;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.GLOBAL=1]="GLOBAL"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var A;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(A=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new D,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=I;class D{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=D}),define(ye[138],Se([0,1,6,9,2,3]),function(Z,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,P.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return r.Disposable.None},registerValidator(){return r.Disposable.None},registerExternalUriResolver(){return r.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return r.Disposable.None},async open(){return!1},async resolveExternalUri(D){return{resolved:D,dispose(){}}}});function A(D,T){return S.URI.isUri(D)?(0,t.equalsIgnoreCase)(D.scheme,T):(0,t.startsWithIgnoreCase)(D,T+":")}e.matchesScheme=A;function I(D,...T){return T.some(R=>A(D,R))}e.matchesSomeScheme=I});var xe=this&&this.__decorate||function(Z,e,r,t){var S=arguments.length,P=S<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,r):t,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(Z,e,r,t);else for(var I=Z.length-1;I>=0;I--)(A=Z[I])&&(P=(S<3?A(P):S>3?A(e,r,P):A(e,r))||P);return S>3&&P&&Object.defineProperty(e,r,P),P},$e=this&&this.__param||function(Z,e){return function(r,t){e(r,t,Z)}};define(ye[139],Se([0,1,10,20,6,3]),function(Z,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,P.createDecorator)("progressService");var A;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(A=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{constructor(b){this.callback=b}get value(){return this._value}report(b){this._value=b,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let D=class extends S.Disposable{constructor(b,i){super();this.deferred=new r.DeferredPromise,i.withProgress(b,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,S.toDisposable)(()=>this.deferred.complete()))}report(b){this.reporter?this.reporter.report(b):this.lastStep=b}};D=xe([$e(1,e.IProgressService)],D),e.UnmanagedProgress=D;class T extends S.Disposable{constructor(b){super();this.progressIndicator=b,this.currentOperationId=0,this.currentOperationDisposables=this._register(new S.DisposableStore)}start(b){this.stop();const i=++this.currentOperationId,h=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{i===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},b),this.currentOperationDisposables.add((0,S.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,S.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,S.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:i,token:h.token,stop:()=>this.doStop(i),isCurrent:()=>this.currentOperationId===i}}stop(){this.doStop(this.currentOperationId)}doStop(b){this.currentOperationId===b&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,P.createDecorator)("editorProgressService")}),define(ye[37],Se([0,1,42,13]),function(Z,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.data=new Map}add(A,I){r.ok(t.isString(A)),r.ok(t.isObject(I)),r.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,I)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new S}),define(ye[140],Se([0,1,4,37]),function(Z,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function S(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class P{constructor(){this._onDidChangeSchema=new r.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,T){this.schemasById[S(D)]=T,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new P;t.Registry.add(e.Extensions.JSONContribution,A)}),define(ye[81],Se([0,1,16,4,13,114,140,37]),function(Z,e,r,t,S,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const R=I.Registry.as(A.Extensions.JSONContribution);class b{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(_,a=!0){this.registerConfigurations([_],a)}registerConfigurations(_,a=!0){const F=this.doRegisterConfigurations(_,a);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:F})}deregisterConfigurations(_){const a=this.doDeregisterConfigurations(_);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:_,remove:a}){const F=[];F.push(...this.doDeregisterConfigurations(a)),F.push(...this.doRegisterConfigurations(_,!1)),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,r.distinct)(F)})}registerDefaultConfigurations(_){const a=[],F=[];for(const{overrides:c,source:n}of _)for(const f in c)if(a.push(f),e.OVERRIDE_PROPERTY_REGEX.test(f)){const g={...this.configurationDefaultsOverrides.get(f)?.value||{},...c[f]};this.configurationDefaultsOverrides.set(f,{source:n,value:g});const s={type:"object",default:g,description:P.localize(1,null,f),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:g,source:S.isString(n)?void 0:n};F.push(...l(f)),this.configurationProperties[f]=s,this.defaultLanguageConfigurationOverridesNode.properties[f]=s}else{this.configurationDefaultsOverrides.set(f,{value:c[f],source:n});const g=this.configurationProperties[f];g&&(this.updatePropertyDefaultValue(f,g),this.updateSchema(f,g))}this.registerOverrideIdentifiers(F),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}deregisterDefaultConfigurations(_){const a=[];for(const{overrides:F,source:c}of _)for(const n in F){const f=this.configurationDefaultsOverrides.get(n),g=S.isString(c)?c:c?.id,s=S.isString(f?.source)?f?.source:f?.source?.id;if(g===s)if(a.push(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const d=this.configurationProperties[n];d&&(this.updatePropertyDefaultValue(n,d),this.updateSchema(n,d))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(..._){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(_){for(const a of _)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(_,a){const F=[];return _.forEach(c=>{F.push(...this.validateAndRegisterProperties(c,a,c.extensionInfo,c.restrictedProperties)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),F}doDeregisterConfigurations(_){const a=[],F=c=>{if(c.properties)for(const n in c.properties)a.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,c.properties[n]);c.allOf&&c.allOf.forEach(n=>F(n))};for(const c of _){F(c);const n=this.configurationContributors.indexOf(c);n!==-1&&this.configurationContributors.splice(n,1)}return a}validateAndRegisterProperties(_,a=!0,F,c,n=3){n=S.isUndefinedOrNull(_.scope)?n:_.scope;let f=[],g=_.properties;if(g)for(let d in g){if(a&&C(d)){delete g[d];continue}const p=g[d];if(p.source=F,p.defaultDefaultValue=g[d].default,this.updatePropertyDefaultValue(d,p),e.OVERRIDE_PROPERTY_REGEX.test(d)?p.scope=void 0:(p.scope=S.isUndefinedOrNull(p.scope)?n:p.scope,p.restricted=S.isUndefinedOrNull(p.restricted)?!!c?.includes(d):p.restricted),g[d].hasOwnProperty("included")&&!g[d].included){this.excludedConfigurationProperties[d]=g[d],delete g[d];continue}else this.configurationProperties[d]=g[d];!g[d].deprecationMessage&&g[d].markdownDeprecationMessage&&(g[d].deprecationMessage=g[d].markdownDeprecationMessage),f.push(d)}let s=_.allOf;if(s)for(let d of s)f.push(...this.validateAndRegisterProperties(d,a,F,c,n));return f}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(_){const a=F=>{let c=F.properties;if(c)for(const f in c)this.updateSchema(f,c[f]);let n=F.allOf;n&&n.forEach(a)};a(_)}updateSchema(_,a){switch(e.allSettings.properties[_]=a,a.scope){case 1:e.applicationSettings.properties[_]=a;break;case 2:e.machineSettings.properties[_]=a;break;case 6:e.machineOverridableSettings.properties[_]=a;break;case 3:e.windowSettings.properties[_]=a;break;case 4:e.resourceSettings.properties[_]=a;break;case 5:e.resourceSettings.properties[_]=a,this.resourceLanguageSettingsSchema.properties[_]=a;break}}removeFromSchema(_,a){switch(delete e.allSettings.properties[_],a.scope){case 1:delete e.applicationSettings.properties[_];break;case 2:delete e.machineSettings.properties[_];break;case 6:delete e.machineOverridableSettings.properties[_];break;case 3:delete e.windowSettings.properties[_];break;case 4:case 5:delete e.resourceSettings.properties[_],delete this.resourceLanguageSettingsSchema.properties[_];break}}updateOverridePropertyPatternKey(){for(const _ of this.overrideIdentifiers.values()){const a=`[${_}]`,F={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,F),e.allSettings.properties[a]=F,e.applicationSettings.properties[a]=F,e.machineSettings.properties[a]=F,e.machineOverridableSettings.properties[a]=F,e.windowSettings.properties[a]=F,e.resourceSettings.properties[a]=F}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const _={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=_,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=_,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=_,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=_,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=_,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=_,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(_,a){const F=this.configurationDefaultsOverrides.get(_);let c=F?.value,n=F?.source;S.isUndefined(c)&&(c=a.defaultDefaultValue,n=void 0),S.isUndefined(c)&&(c=m(a.type)),a.default=c,a.defaultValueSource=n}}const i="\\[([^\\]]+)\\]",h=new RegExp(i,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${i})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function l(u){const _=[];if(e.OVERRIDE_PROPERTY_REGEX.test(u)){let a=h.exec(u);for(;a?.length;){const F=a[1].trim();F&&_.push(F),a=h.exec(u)}}return(0,r.distinct)(_)}e.overrideIdentifiersFromKey=l;function o(u){return u.reduce((_,a)=>`${_}[${a}]`,"")}e.keyFromOverrideIdentifiers=o;function m(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const M=new b;I.Registry.add(e.Extensions.Configuration,M);function C(u){return u.trim()?e.OVERRIDE_PROPERTY_REGEX.test(u)?P.localize(7,null,u):M.getConfigurationProperties()[u]!==void 0?P.localize(8,null,u):null:P.localize(6,null)}e.validateProperty=C;function w(){const u=[],_=M.getConfigurationProperties();for(const a of Object.keys(_))u.push([a,_[a].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.getScopes=w}),define(ye[141],Se([0,1,16,4,99,6,22,27,13,2,79,81,37]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(c={},n=[],f=[]){this._contents=c,this._keys=n,this._overrides=f,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(c){return c?(0,R.getConfigurationValue)(this.contents,c):this.contents}getOverrideValue(c,n){const f=this.getContentsForOverrideIdentifer(n);return f?c?(0,R.getConfigurationValue)(f,c):f:void 0}getKeysForOverrideIdentifier(c){const n=[];for(const f of this.overrides)f.identifiers.includes(c)&&n.push(...f.keys);return r.distinct(n)}getAllOverrideIdentifiers(){const c=[];for(const n of this.overrides)c.push(...n.identifiers);return r.distinct(c)}override(c){let n=this.overrideConfigurations.get(c);return n||(n=this.createOverrideConfigurationModel(c),this.overrideConfigurations.set(c,n)),n}merge(...c){const n=I.deepClone(this.contents),f=I.deepClone(this.overrides),g=[...this.keys];for(const s of c){this.mergeContents(n,s.contents);for(const d of s.overrides){const[p]=f.filter(E=>r.equals(E.identifiers,d.identifiers));p?(this.mergeContents(p.contents,d.contents),p.keys.push(...d.keys),p.keys=r.distinct(p.keys)):f.push(I.deepClone(d))}for(const d of s.keys)g.indexOf(d)===-1&&g.push(d)}return new h(n,g,f)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(c){const n=this.getContentsForOverrideIdentifer(c);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let f={};for(const g of r.distinct([...Object.keys(this.contents),...Object.keys(n)])){let s=this.contents[g],d=n[g];d&&(typeof s=="object"&&typeof d=="object"?(s=I.deepClone(s),this.mergeContents(s,d)):s=d),f[g]=s}return new h(f,this.keys,this.overrides)}mergeContents(c,n){for(const f of Object.keys(n)){if(f in c&&D.isObject(c[f])&&D.isObject(n[f])){this.mergeContents(c[f],n[f]);continue}c[f]=I.deepClone(n[f])}}checkAndFreeze(c){return this.isFrozen&&!Object.isFrozen(c)?I.deepFreeze(c):c}getContentsForOverrideIdentifer(c){let n=null,f=null;const g=s=>{s&&(f?this.mergeContents(f,s):f=I.deepClone(s))};for(const s of this.overrides)r.equals(s.identifiers,[c])?n=s.contents:s.identifiers.includes(c)&&g(s.contents);return g(n),f}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(c,n){this.addKey(c),(0,R.addToValueTree)(this.contents,c,n,f=>{throw new Error(f)})}removeValue(c){this.removeKey(c)&&(0,R.removeFromValueTree)(this.contents,c)}addKey(c){let n=this.keys.length;for(let f=0;f<n;f++)c.indexOf(this.keys[f])===0&&(n=f);this.keys.splice(n,1,c)}removeKey(c){let n=this.keys.indexOf(c);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=h;class l extends h{constructor(c={}){const n=i.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(n),g=Object.create(null),s=[];for(const d in n){const p=c[d],E=p!==void 0?p:n[d].default;(0,R.addToValueTree)(g,d,E,v=>console.error(`Conflict in default settings: ${v}`))}for(const d of Object.keys(g))b.OVERRIDE_PROPERTY_REGEX.test(d)&&s.push({identifiers:(0,b.overrideIdentifiersFromKey)(d),keys:Object.keys(g[d]),contents:(0,R.toValuesTree)(g[d],p=>console.error(`Conflict in default settings file: ${p}`))});super(g,f,s)}}e.DefaultConfigurationModel=l;class o{constructor(c){this._name=c,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(c,n){if(!D.isUndefinedOrNull(c)){const f=this.doParseContent(c);this.parseRaw(f,n)}}reparse(c){this._raw&&this.parseRaw(this._raw,c)}parseRaw(c,n){this._raw=c;const{contents:f,keys:g,overrides:s,restricted:d}=this.doParseRaw(c,n);this._configurationModel=new h(f,g,s),this._restrictedConfigurations=d||[]}doParseContent(c){let n={},f=null,g=[],s=[],d=[];function p(v){Array.isArray(g)?g.push(v):f!==null&&(g[f]=v)}let E={onObjectBegin:()=>{let v={};p(v),s.push(g),g=v,f=null},onObjectProperty:v=>{f=v},onObjectEnd:()=>{g=s.pop()},onArrayBegin:()=>{let v=[];p(v),s.push(g),g=v,f=null},onArrayEnd:()=>{g=s.pop()},onLiteralValue:p,onError:(v,k,L)=>{d.push({error:v,offset:k,length:L})}};if(c)try{S.visit(c,E),n=g[0]||{}}catch(v){console.error(`Error while parsing settings file ${this._name}: ${v}`),this._parseErrors=[v]}return n}doParseRaw(c,n){const f=i.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),g=this.filter(c,f,!0,n);c=g.raw;const s=(0,R.toValuesTree)(c,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),d=Object.keys(c),p=this.toOverrides(c,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:s,keys:d,overrides:p,restricted:g.restricted}}filter(c,n,f,g){if(!g?.scopes&&!g?.skipRestricted)return{raw:c,restricted:[]};const s={},d=[];for(let p in c)if(b.OVERRIDE_PROPERTY_REGEX.test(p)&&f){const E=this.filter(c[p],n,!1,g);s[p]=E.raw,d.push(...E.restricted)}else{const E=n[p],v=E?typeof E.scope!="undefined"?E.scope:3:void 0;E?.restricted&&d.push(p),(v===void 0||g.scopes===void 0||g.scopes.includes(v))&&(g.skipRestricted&&E?.restricted||(s[p]=c[p]))}return{raw:s,restricted:d}}toOverrides(c,n){const f=[];for(const g of Object.keys(c))if(b.OVERRIDE_PROPERTY_REGEX.test(g)){const s={};for(const d in c[g])s[d]=c[g][d];f.push({identifiers:(0,b.overrideIdentifiersFromKey)(g),keys:Object.keys(s),contents:(0,R.toValuesTree)(s,n)})}return f}}e.ConfigurationModelParser=o;class m extends P.Disposable{constructor(c,n,f,g){super();this.userSettingsResource=c,this.scopes=n,this.fileService=g,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new o(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(f.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const c=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(c.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=m;class M{constructor(c,n,f=new h,g=new h,s=new A.ResourceMap,d=new h,p=new A.ResourceMap,E=!0){this._defaultConfiguration=c,this._localUserConfiguration=n,this._remoteUserConfiguration=f,this._workspaceConfiguration=g,this._folderConfigurations=s,this._memoryConfiguration=d,this._memoryConfigurationByResource=p,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(c,n,f){return this.getConsolidateConfigurationModel(n,f).getValue(c)}updateValue(c,n,f={}){let g;f.resource?(g=this._memoryConfigurationByResource.get(f.resource),g||(g=new h,this._memoryConfigurationByResource.set(f.resource,g))):g=this._memoryConfiguration,n===void 0?g.removeValue(c):g.setValue(c,n),f.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(c,n,f){const g=this.getConsolidateConfigurationModel(n,f),s=this.getFolderConfigurationModelForResource(n.resource,f),d=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,p=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(c):this._defaultConfiguration.freeze().getValue(c),E=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(c):this.userConfiguration.freeze().getValue(c),v=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(c):this.localUserConfiguration.freeze().getValue(c),k=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(c):this.remoteUserConfiguration.freeze().getValue(c),L=f?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(c):this._workspaceConfiguration.freeze().getValue(c):void 0,y=s?n.overrideIdentifier?s.freeze().override(n.overrideIdentifier).getValue(c):s.freeze().getValue(c):void 0,O=n.overrideIdentifier?d.override(n.overrideIdentifier).getValue(c):d.getValue(c),U=g.getValue(c),q=r.distinct(r.flatten(g.overrides.map(H=>H.identifiers))).filter(H=>g.getOverrideValue(c,H)!==void 0);return{defaultValue:p,userValue:E,userLocalValue:v,userRemoteValue:k,workspaceValue:L,workspaceFolderValue:y,memoryValue:O,value:U,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(c),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(c,n.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(c),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(c,n.overrideIdentifier):void 0}:void 0,userLocal:v!==void 0?{value:this.localUserConfiguration.freeze().getValue(c),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(c,n.overrideIdentifier):void 0}:void 0,userRemote:k!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(c),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(c,n.overrideIdentifier):void 0}:void 0,workspace:L!==void 0?{value:this._workspaceConfiguration.freeze().getValue(c),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(c,n.overrideIdentifier):void 0}:void 0,workspaceFolder:y!==void 0?{value:s?.freeze().getValue(c),override:n.overrideIdentifier?s?.freeze().getOverrideValue(c,n.overrideIdentifier):void 0}:void 0,memory:O!==void 0?{value:d.getValue(c),override:n.overrideIdentifier?d.getOverrideValue(c,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(c){const n=this.getFolderConfigurationModelForResource(void 0,c);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(c){this._defaultConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(c){this._localUserConfiguration=c,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(c){this._remoteUserConfiguration=c,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(c){this._workspaceConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(c,n){this._folderConfigurations.set(c,n),this._foldersConsolidatedConfigurations.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this._foldersConsolidatedConfigurations.delete(c)}compareAndUpdateDefaultConfiguration(c,n){const f=[];if(!n){const{added:g,updated:s,removed:d}=_(this._defaultConfiguration,c);n=[...g,...s,...d]}for(const g of n)for(const s of(0,b.overrideIdentifiersFromKey)(g)){const d=this._defaultConfiguration.getKeysForOverrideIdentifier(s),p=c.getKeysForOverrideIdentifier(s),E=[...p.filter(v=>d.indexOf(v)===-1),...d.filter(v=>p.indexOf(v)===-1),...d.filter(v=>!I.equals(this._defaultConfiguration.override(s).getValue(v),c.override(s).getValue(v)))];f.push([s,E])}return this.updateDefaultConfiguration(c),{keys:n,overrides:f}}compareAndUpdateLocalUserConfiguration(c){const{added:n,updated:f,removed:g,overrides:s}=_(this.localUserConfiguration,c),d=[...n,...f,...g];return d.length&&this.updateLocalUserConfiguration(c),{keys:d,overrides:s}}compareAndUpdateRemoteUserConfiguration(c){const{added:n,updated:f,removed:g,overrides:s}=_(this.remoteUserConfiguration,c);let d=[...n,...f,...g];return d.length&&this.updateRemoteUserConfiguration(c),{keys:d,overrides:s}}compareAndUpdateWorkspaceConfiguration(c){const{added:n,updated:f,removed:g,overrides:s}=_(this.workspaceConfiguration,c);let d=[...n,...f,...g];return d.length&&this.updateWorkspaceConfiguration(c),{keys:d,overrides:s}}compareAndUpdateFolderConfiguration(c,n){const f=this.folderConfigurations.get(c),{added:g,updated:s,removed:d,overrides:p}=_(f,n);let E=[...g,...s,...d];return(E.length||!f)&&this.updateFolderConfiguration(c,n),{keys:E,overrides:p}}compareAndDeleteFolderConfiguration(c){const n=this.folderConfigurations.get(c);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:f,updated:g,removed:s,overrides:d}=_(n,void 0);return{keys:[...f,...g,...s],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(c,n){let f=this.getConsolidatedConfigurationModelForResource(c,n);return c.overrideIdentifier?f.override(c.overrideIdentifier):f}getConsolidatedConfigurationModelForResource({resource:c},n){let f=this.getWorkspaceConsolidatedConfiguration();if(n&&c){const g=n.getFolder(c);g&&(f=this.getFolderConsolidatedConfiguration(g.uri)||f);const s=this._memoryConfigurationByResource.get(c);s&&(f=f.merge(s))}return f}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(c){let n=this._foldersConsolidatedConfigurations.get(c);if(!n){const f=this.getWorkspaceConsolidatedConfiguration(),g=this._folderConfigurations.get(c);g?(n=f.merge(g),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(c,n)):n=f}return n}getFolderConfigurationModelForResource(c,n){if(n&&c){const f=n.getFolder(c);if(f)return this._folderConfigurations.get(f.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((c,n)=>{const{contents:f,overrides:g,keys:s}=this._folderConfigurations.get(n);return c.push([n,{contents:f,overrides:g,keys:s}]),c},[])}}allKeys(){const c=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>c.add(n)),this.userConfiguration.freeze().keys.forEach(n=>c.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>c.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(f=>c.add(f))),[...c.values()]}allOverrideIdentifiers(){const c=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>c.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>c.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>c.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(f=>c.add(f))),[...c.values()]}getAllKeysForOverrideIdentifier(c){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(c).forEach(f=>n.add(f)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(f=>n.add(f)),this._workspaceConfiguration.getKeysForOverrideIdentifier(c).forEach(f=>n.add(f)),this._folderConfigurations.forEach(f=>f.getKeysForOverrideIdentifier(c).forEach(g=>n.add(g))),[...n.values()]}static parse(c){const n=this.parseConfigurationModel(c.defaults),f=this.parseConfigurationModel(c.user),g=this.parseConfigurationModel(c.workspace),s=c.folders.reduce((d,p)=>(d.set(T.URI.revive(p[0]),this.parseConfigurationModel(p[1])),d),new A.ResourceMap);return new M(n,f,new h,g,s,new h,new A.ResourceMap,!1)}static parseConfigurationModel(c){return new h(c.contents,c.keys,c.overrides).freeze()}}e.Configuration=M;function C(...F){if(F.length===0)return{keys:[],overrides:[]};if(F.length===1)return F[0];const c=new Set,n=new Map;for(const g of F)g.keys.forEach(s=>c.add(s)),g.overrides.forEach(([s,d])=>{const p=(0,A.getOrSet)(n,s,new Set);d.forEach(E=>p.add(E))});const f=[];return n.forEach((g,s)=>f.push([s,[...g.values()]])),{keys:[...c.values()],overrides:f}}e.mergeChanges=C;class w{constructor(c,n,f,g){this.change=c,this.previous=n,this.currentConfiguraiton=f,this.currentWorkspace=g,this._previousConfiguration=void 0;const s=new Set;c.keys.forEach(p=>s.add(p)),c.overrides.forEach(([,p])=>p.forEach(E=>s.add(E))),this.affectedKeys=[...s.values()];const d=new h;this.affectedKeys.forEach(p=>d.setValue(p,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=M.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(c,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,c)){if(n){const f=this.previousConfiguration?this.previousConfiguration.getValue(c,n,this.previous?.workspace):void 0,g=this.currentConfiguraiton.getValue(c,n,this.currentWorkspace);return!I.equals(f,g)}return!0}return!1}doesAffectedKeysTreeContains(c,n){let f=(0,R.toValuesTree)({[n]:!0},()=>{}),g;for(;typeof f=="object"&&(g=Object.keys(f)[0]);){if(c=c[g],!c)return!1;f=f[g]}return!0}}e.ConfigurationChangeEvent=w;class u extends w{constructor(c,n,f,g){super({keys:c.allKeys(),overrides:[]},void 0,c,n);this.source=f,this.sourceConfig=g}}e.AllKeysConfigurationChangeEvent=u;function _(F,c){const{added:n,removed:f,updated:g}=a(c,F),s=[],d=F?.getAllOverrideIdentifiers()||[],p=c?.getAllOverrideIdentifiers()||[];if(c){const E=p.filter(v=>!d.includes(v));for(const v of E)s.push([v,c.getKeysForOverrideIdentifier(v)])}if(F){const E=d.filter(v=>!p.includes(v));for(const v of E)s.push([v,F.getKeysForOverrideIdentifier(v)])}if(c&&F){for(const E of d)if(p.includes(E)){const v=a({contents:F.getOverrideValue(void 0,E)||{},keys:F.getKeysForOverrideIdentifier(E)},{contents:c.getOverrideValue(void 0,E)||{},keys:c.getKeysForOverrideIdentifier(E)});s.push([E,[...v.added,...v.removed,...v.updated]])}}return{added:n,removed:f,updated:g,overrides:s}}function a(F,c){const n=F?c?F.keys.filter(s=>c.keys.indexOf(s)===-1):[...F.keys]:[],f=c?F?c.keys.filter(s=>F.keys.indexOf(s)===-1):[...c.keys]:[],g=[];if(F&&c){for(const s of c.keys)if(F.keys.indexOf(s)!==-1){const d=(0,R.getConfigurationValue)(c.contents,s),p=(0,R.getConfigurationValue)(F.contents,s);I.equals(d,p)||g.push(s)}}return{added:n,removed:f,updated:g}}}),define(ye[82],Se([0,1,3]),function(Z,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,r.createDecorator)("remoteAuthorityResolverService");var t;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class S extends Error{constructor(A,I=t.Unknown,D){super(A);this._message=A,this._code=I,this._detail=D,this.isHandled=I===t.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,S.prototype)}static isTemporarilyNotAvailable(A){return A instanceof S&&A._code===t.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof S&&A._code===t.NoResolverFound}static isHandled(A){return A instanceof S&&A.isHandled}}e.RemoteAuthorityResolverError=S}),define(ye[60],Se([0,1,11]),function(Z,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function t(T){return T.scheme===r.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=t;function S(T){if(!T)return;const R=T.indexOf("+");return R<0?T:T.substr(0,R)}e.getRemoteName=S;function P(T){return T.scheme!==r.Schemas.file&&T.scheme!==r.Schemas.vscodeRemote}e.isVirtualResource=P;function A(T){if(T.folders.length)return T.folders.every(R=>P(R.uri))?T.folders[0].uri:void 0;if(T.configuration&&P(T.configuration))return T.configuration}e.getVirtualWorkspaceLocation=A;function I(T){return A(T)?.scheme}e.getVirtualWorkspaceScheme=I;function D(T){return A(T)!==void 0}e.isVirtualWorkspace=D}),define(ye[25],Se([0,1,9,3,60]),function(Z,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=P;function A(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class D{constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,l){if(typeof h=="undefined"||h===null)return typeof l=="undefined"||l===null;if(typeof l=="undefined"||l===null)return!1;if(typeof h=="string"||typeof l=="string"){let o=typeof h=="string"?h:h.value,m=typeof l=="string"?l:l.value;return r.equalsIgnoreCase(o,m)}return h._lower===l._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}e.ExtensionIdentifier=D;function T(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=T;function R(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=R;function b(i,h){if(h){const l=`onResolveRemoteAuthority:${(0,S.getRemoteName)(h)}`;return i.activationEvents?.indexOf(l)!==-1}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[142],Se([0,1,9,25]),function(Z,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function S(l,o){return l.uuid&&o.uuid?l.uuid===o.uuid:l.id===o.id?!0:(0,r.compareIgnoreCase)(l.id,o.id)===0}e.areSameExtensions=S;class P{constructor(o,m){this.version=m,this.id=o.id,this.uuid=o.uuid}key(){return`${this.id}-${this.version}`}equals(o){return o instanceof P?S(this,o)&&this.version===o.version:!1}}e.ExtensionIdentifierWithVersion=P;function A(l,o){return`${l}.${o}`}e.getExtensionId=A;function I(l){return l.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function D(l,o){return I(A(l,o))}e.getGalleryExtensionId=D;function T(l,o){const m=[],M=C=>{for(const w of m)if(w.some(u=>S(o(u),o(C))))return w;return null};for(const C of l){const w=M(C);w?w.push(C):m.push([C])}return m}e.groupByExtension=T;function R(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function b(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,isPreReleaseVersion:l.properties.isPreReleaseVersion,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function i(l){const o=new Set;if(l.malicious)for(const m of l.malicious)o.add(m.id);return o}e.getMaliciousExtensionsSet=i;function h(l,o){const m=[],M=o.manifest.extensionDependencies?.slice(0)??[];for(;M.length;){const C=M.shift();if(C&&m.every(w=>!S(w.identifier,{id:C}))){const w=l.filter(u=>S(u.identifier,{id:C}));w.length===1&&(m.push(w[0]),M.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return m}e.getExtensionDependencies=h}),define(ye[143],Se([0,1,4,23,3,12]),function(Z,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,S.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,S.createDecorator)("sharedTunnelsService");var A;(function(l){l.Http="http",l.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(l){l.ConstantPrivate="constantPrivate",l.Private="private",l.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var D;(function(l){l[l.Notify=1]="Notify",l[l.OpenBrowser=2]="OpenBrowser",l[l.OpenPreview=3]="OpenPreview",l[l.Silent=4]="Silent",l[l.Ignore=5]="Ignore",l[l.OpenBrowserOnce=6]="OpenBrowserOnce"})(D=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function T(l){if(l.scheme!=="http"&&l.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(l.authority);if(!!o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=T,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(l){return e.LOCALHOST_ADDRESSES.indexOf(l)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(l){return e.ALL_INTERFACES_ADDRESSES.indexOf(l)>=0}e.isAllInterfaces=b;function i(l,o){return o?o!==1&&l<1024:!t.isWindows&&l<1024}e.isPortPrivileged=i;let h=class{constructor(o){this.logService=o,this._onTunnelOpened=new r.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new r.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new r.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(o){return this._tunnelProvider=o,o?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this._canElevate=o.elevation,this._privacyOptions=o.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const o=[],m=Array.from(this._tunnels.values());for(let M of m){const C=Array.from(M.values());for(let w of C){const u=await w.value;u&&o.push(u)}}return o}async dispose(){for(const o of this._tunnels.values()){for(const{value:m}of o.values())await m.then(M=>M?.dispose());o.clear()}this._tunnels.clear()}openTunnel(o,m,M,C,w=!1,u=I.Private,_){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${M} on local port ${C}.`),!o)return;m||(m="localhost");const a=this.retainOrCreateTunnel(o,m,M,C,w,u,_);return a?a.then(F=>{if(!F){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(m,M);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const c=this.makeTunnel(F);return(F.tunnelRemoteHost!==m||F.tunnelRemotePort!==M)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(c),c}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const m=this._tunnels.get(o.tunnelRemoteHost);if(m){const M=m.get(o.tunnelRemotePort);M&&(M.refcount--,await this.tryDisposeTunnel(o.tunnelRemoteHost,o.tunnelRemotePort,M))}}}}async tryDisposeTunnel(o,m,M){if(M.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${m}.`);const C=M.value.then(async w=>{w&&(await w.dispose(!0),this._onTunnelClosed.fire({host:w.tunnelRemoteHost,port:w.tunnelRemotePort}))});return this._tunnels.has(o)&&this._tunnels.get(o).delete(m),C}}async closeTunnel(o,m){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${m} `);const M=this._tunnels.get(o);if(M&&M.has(m)){const C=M.get(m);C.refcount=0,await this.tryDisposeTunnel(o,m,C)}}addTunnelToMap(o,m,M){this._tunnels.has(o)||this._tunnels.set(o,new Map),this._tunnels.get(o).set(m,{refcount:1,value:M})}async removeEmptyTunnelFromMap(o,m){const M=this._tunnels.get(o);M&&(await M.get(m)||M.delete(m),M.size===0&&this._tunnels.delete(o))}getTunnelFromMap(o,m){let M=[o];R(o)?(M.push(...e.LOCALHOST_ADDRESSES),M.push(...e.ALL_INTERFACES_ADDRESSES)):b(o)&&M.push(...e.ALL_INTERFACES_ADDRESSES);const C=M.map(w=>this._tunnels.get(w));for(const w of C){const u=w?.get(m);if(u)return u}}canTunnel(o){return!!T(o)}createWithProvider(o,m,M,C,w,u,_){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${M} on local port ${C}.`);const F={elevationRequired:w?i(C===void 0?M:C):!1},c={remoteAddress:{host:m,port:M},localAddressPort:C,privacy:u,public:u!==I.Private,protocol:_},n=o.forwardPort(c,F);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),n&&this.addTunnelToMap(m,M,n),n}};h=xe([$e(0,P.ILogService)],h),e.AbstractTunnelService=h}),define(ye[144],Se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class r{constructor(S){this._callback=S,this._terminalBufferMap=new Map}dispose(){for(const S of this._terminalBufferMap.values())S.dispose()}startBuffering(S,P,A=5){let I;return I=P(D=>{const T=typeof D=="string"?D:D.data;let R=this._terminalBufferMap.get(S);if(R){R.data.push(T);return}const b=setTimeout(()=>this.flushBuffer(S),A);R={data:[T],timeoutId:b,dispose:()=>{clearTimeout(b),this.flushBuffer(S),I.dispose()}},this._terminalBufferMap.set(S,R)}),I}stopBuffering(S){const P=this._terminalBufferMap.get(S);P&&P.dispose()}flushBuffer(S){const P=this._terminalBufferMap.get(S);P&&(this._terminalBufferMap.delete(S),this._callback(S,P.data.join("")))}}e.TerminalDataBufferer=r}),define(ye[145],Se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var r;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(r=e.ColorScheme||(e.ColorScheme={}))}),define(ye[61],Se([0,1,52,4,6,3,37,145]),function(Z,e,r,t,S,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var D;(function(m){function M(C){return C&&typeof C=="object"&&typeof C.id=="string"}m.isThemeColor=M})(D=e.ThemeColor||(e.ThemeColor={}));function T(m){return{id:m}}e.themeColorFromId=T;var R;(function(m){function M(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||D.isThemeColor(n.color))}m.isThemeIcon=M;const C=new RegExp(`^\\$\\((${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?)\\)$`);function w(n){const f=C.exec(n);if(!f)return;let[,g]=f;return{id:g}}m.fromString=w;function u(n){return{id:n}}m.fromId=u;function _(n,f){let g=n.id;const s=g.lastIndexOf("~");return s!==-1&&(g=g.substring(0,s)),f&&(g=`${g}~${f}`),{id:g}}m.modify=_;function a(n){const f=n.id.lastIndexOf("~");if(f!==-1)return n.id.substring(f+1)}m.getModifier=a;function F(n,f){return n.id===f.id&&n.color?.id===f.color?.id}m.isEqual=F;function c(n,f){return{id:n.id,color:f?T(f):void 0}}m.asThemeIcon=c,m.asClassNameArray=r.CSSIcon.asClassNameArray,m.asClassName=r.CSSIcon.asClassName,m.asCSSSelector=r.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=r.Codicon.file,e.FolderThemeIcon=r.Codicon.folder;function b(m){switch(m){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class i{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(M){return this.themingParticipants.push(M),this.onThemingParticipantAddedEmitter.fire(M),(0,S.toDisposable)(()=>{const C=this.themingParticipants.indexOf(M);this.themingParticipants.splice(C,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let h=new i;A.Registry.add(e.Extensions.ThemingContribution,h);function l(m){return h.onColorThemeChange(m)}e.registerThemingParticipant=l;class o extends S.Disposable{constructor(M){super();this.themeService=M,this.theme=M.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(C=>this.onThemeChange(C)))}onThemeChange(M){this.theme=M,this.updateStyles()}updateStyles(){}getColor(M,C){let w=this.theme.getColor(M);return w&&C&&(w=C(w,this.theme)),w?w.toString():null}}e.Themable=o}),define(ye[47],Se([0,1,22,24,2,3]),function(Z,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");var A;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(A=e.WorkbenchState||(e.WorkbenchState={}));function I(i){const h=i;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=I;function D(i){const h=i;return!!(h&&typeof h=="object"&&S.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=D;class T{constructor(h,l,o,m,M){this._id=h,this._transient=o,this._configuration=m,this._ignorePathCasing=M,this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=l}update(h){this._id=h.id,this._configuration=h.configuration,this._transient=h.transient,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=T;class R{constructor(h,l){this.raw=l,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,t.joinPath)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=R;function b(i){return new R({uri:i,index:0,name:(0,t.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=b}),define(ye[62],Se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class r{constructor(S){this.id=S,this._data=new Map,this._idPool=1}add(S){const P=this._idPool++;return this._data.set(P,S),this.logDebugInfo(),P}get(S,P){return this._data.has(S)?this._data.get(S)[P]:void 0}delete(S){this._data.delete(S),this.logDebugInfo()}logDebugInfo(){!r.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=r,r.enableDebugLogging=!1}),define(ye[30],Se([0,1,11,24,3]),function(Z,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(r.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(I=>{const D=this._providerInfo.get(I.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(I,D){D===null?this._providerInfo.delete(I.scheme):this._providerInfo.set(I.scheme,D)}isFreeScheme(I){return!this._providerInfo.has(I)&&!this._systemSchemes.has(I)}getCapabilities(I){return this._providerInfo.get(I)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,S.createDecorator)("IExtHostFileSystemInfo")}),define(ye[28],Se([0,1,3]),function(Z,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,r.createDecorator)("IExtHostInitDataService")}),define(ye[146],Se([0,1,10]),function(Z,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(A,I,D){this._deferredPromises=new Map,this._id=A,this._shared=I,this._storage=D,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(T=>(this._value=T,this)),this._storageListener=this._storage.onDidChangeStorage(T=>{T.shared===this._shared&&T.key===this._id&&(this._value=T.value)}),this._scheduler=new r.RunOnceScheduler(()=>{const T=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of T.values())R.complete()}catch(R){for(const b of T.values())b.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this._init}get(A,I){let D=this._value[A];return typeof D=="undefined"&&(D=I),D}update(A,I){this._value[A]=I;let D=this._deferredPromises.get(A);if(D!==void 0)return D.p;const T=new r.DeferredPromise;return this._deferredPromises.set(A,T),this._scheduler.isScheduled()||this._scheduler.schedule(),T.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class S extends t{constructor(A,I){super(A.identifier.value,!0,I);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=S}),define(ye[147],Se([0,1,4,2,12]),function(Z,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let P=class{constructor(I,D){this._logService=I,this._notebooksAndEditors=D,this._onDidChangeNotebookDocumentMetadata=new r.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new r.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(I,D,T){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(I)).acceptModelChanged(D.value,T)}$acceptDirtyStateChanged(I,D){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(I)).acceptDirty(D)}$acceptModelSaved(I){const D=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(I));this._onDidSaveNotebookDocument.fire(D.apiNotebook)}$acceptDocumentPropertiesChanged(I,D){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",I.path,D);const T=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(I));T.acceptDocumentPropertiesChanged(D),D.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:T.apiNotebook})}};P=xe([$e(0,S.ILogService)],P),e.ExtHostNotebookDocuments=P}),define(ye[14],Se([0,1,3]),function(Z,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,r.createDecorator)("IExtHostRpcService");class t{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=t});var Xe=this&&this.__classPrivateFieldSet||function(Z,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(Z,r):S?S.value=r:e.set(Z,r),r},Ie=this&&this.__classPrivateFieldGet||function(Z,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[148],Se([0,1,25,4]),function(Z,e,r,t){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(I,D){S.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=r.ExtensionIdentifier.toKey(I.identifier),Xe(this,S,D,"f"),Ie(this,S,"f").onDidChangePassword(T=>{T.extensionId===this._id&&this._onDidChange.fire({key:T.key})})}get(I){return Ie(this,S,"f").get(this._id,I)}store(I,D){return Ie(this,S,"f").store(this._id,I,D)}delete(I){return Ie(this,S,"f").delete(this._id,I)}}e.ExtensionSecrets=P,S=new WeakMap}),define(ye[83],Se([0,1,3,4]),function(Z,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class S{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(A){this._enabled=A}$onDidChangeTelemetryEnabled(A){this._enabled=A,this._onDidChangeTelemetryEnabled.fire(A)}}e.ExtHostTelemetry=S,e.IExtHostTelemetry=(0,r.createDecorator)("IExtHostTelemetry")}),define(ye[48],Se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var r;(function(C){C[C.Upsert=0]="Upsert",C[C.RemoveChild=1]="RemoveChild",C[C.Invalidated=2]="Invalidated",C[C.SetProp=3]="SetProp",C[C.Bulk=4]="Bulk"})(r=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,S=(C,w)=>{const u={controllerId:w};return t.set(C,u),u};e.createPrivateApiFor=S;const P=C=>t.get(C);e.getPrivateApiFor=P;const A=(C,w,u,_)=>{let a=u;return{enumerable:!0,configurable:!1,get(){return a},set(F){if(!_(a,F)){const c=a;a=F,C.listener?.({op:3,key:w,value:F,previous:c})}}}},I=(C,w)=>C===w,D={range:(C,w)=>C===w?!0:!C||!w?!1:C.isEqual(w),label:I,description:I,busy:I,error:I,canResolveChildren:I,tags:(C,w)=>!(C.length!==w.length||C.some(u=>!w.find(_=>u.id===_.id)))},T=Object.keys(D),R=(C,w)=>({range:A(C,"range",void 0,D.range),label:A(C,"label",w,D.label),description:A(C,"description",void 0,D.description),canResolveChildren:A(C,"canResolveChildren",!1,D.canResolveChildren),busy:A(C,"busy",!1,D.busy),error:A(C,"error",void 0,D.error),tags:A(C,"tags",[],D.tags)}),b=(C,w)=>{const u=new Map;for(const _ of T)D[_](C[_],w[_])||u.set(_,w[_]);return u};e.diffTestItems=b;class i extends Error{constructor(w){super(`Attempted to insert a duplicate test item ID ${w}`)}}e.DuplicateTestItemError=i;class h extends Error{constructor(w){super(`TestItem with ID "${w}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=h;class l extends Error{constructor(w,u,_){super(`TestItem with ID "${w}" is from controller "${u}" and cannot be added as a child of an item from controller "${_}".`)}}e.MixedTestItemController=l;const o=C=>{const w=(0,e.getPrivateApiFor)(C);let u=new Map;return{get size(){return u.size},forEach(_,a){for(const F of u.values())_.call(a,F,this)},replace(_){const a=new Map,F=new Set(u.keys()),c={op:4,ops:[]};for(const n of _){if(!(n instanceof m))throw new h(n.id);const f=(0,e.getPrivateApiFor)(n).controllerId;if(f!==w.controllerId)throw new l(n.id,f,w.controllerId);if(a.has(n.id))throw new i(n.id);a.set(n.id,n),F.delete(n.id),c.ops.push({op:0,item:n})}for(const n of F.keys())c.ops.push({op:1,id:n});w.listener?.(c),u=a},add(_){if(!(_ instanceof m))throw new h(_.id);u.set(_.id,_),w.listener?.({op:0,item:_})},delete(_){u.delete(_)&&w.listener?.({op:1,id:_})},get(_){return u.get(_)},toJSON(){return Array.from(u.values())},[Symbol.iterator](){return u.values()}}};class m{constructor(w,u,_,a){if(u.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(u)} symbol`);const F=(0,e.createPrivateApiFor)(this,w);Object.defineProperties(this,{id:{value:u,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return F.parent instanceof M?void 0:F.parent}},children:{value:o(this),enumerable:!0,writable:!1},...R(F,_)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=m;class M extends m{constructor(w,u){super(w,w,u,void 0)}}e.TestItemRootImpl=M}),define(ye[63],Se([0,1,3,143,4,14]),function(Z,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(D){function T(b){return{remoteAddress:b.remoteAddress,localAddress:b.localAddress,public:!!b.public,privacy:b.privacy??(b.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:b.protocol}}D.fromApiTunnel=T;function R(b){return{remoteAddress:{host:b.tunnelRemoteHost,port:b.tunnelRemotePort},localAddress:b.localAddress,public:b.privacy!==t.TunnelPrivacyId.ConstantPrivate&&b.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:b.privacy,protocol:b.protocol}}D.fromServiceTunnel=R})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,r.createDecorator)("IExtHostTunnelService");let I=class{constructor(T){this.onDidChangeTunnels=new S.Emitter().event}async $applyCandidateFilter(T){return T}async openTunnel(T,R){}async getTunnels(){return[]}async setTunnelFactory(T){return{dispose:()=>{}}}registerPortsAttributesProvider(T,R){return{dispose:()=>{}}}async $providePortAttributes(T,R,b,i,h){return[]}async $forwardPort(T,R){}async $closeTunnel(T){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};I=xe([$e(0,P.IExtHostRpcService)],I),e.ExtHostTunnelService=I});var Xe=this&&this.__classPrivateFieldSet||function(Z,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(Z,r):S?S.value=r:e.set(Z,r),r},Ie=this&&this.__classPrivateFieldGet||function(Z,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[7],Se([0,1,16,15,75,22,74,9,13,2,36,46,82]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i){"use strict";var h,l,o,m,M,C,w,u,_,a,F,c,n,f,g,s,d,p,E,v;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function k(B){function N(){return Reflect.construct(B,arguments,this.constructor)}return Object.defineProperty(N,"name",Object.getOwnPropertyDescriptor(B,"name")),Object.setPrototypeOf(N,B),Object.setPrototypeOf(N.prototype,B.prototype),N}let L=M=class{constructor(N){h.set(this,void 0),Xe(this,h,N,"f")}static from(...N){let J=N;return new M(function(){if(J){for(const Ce of J)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();J=void 0}})}dispose(){typeof Ie(this,h,"f")=="function"&&(Ie(this,h,"f").call(this),Xe(this,h,void 0,"f"))}};h=new WeakMap,L=M=xe([k],L),e.Disposable=L;let y=C=class{constructor(N,J){if(N<0)throw(0,t.illegalArgument)("line must be non-negative");if(J<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=N,this._character=J}static Min(...N){if(N.length===0)throw new TypeError;let J=N[0];for(let Ce=1;Ce<N.length;Ce++){const Ke=N[Ce];Ke.isBefore(J)&&(J=Ke)}return J}static Max(...N){if(N.length===0)throw new TypeError;let J=N[0];for(let Ce=1;Ce<N.length;Ce++){const Ke=N[Ce];Ke.isAfter(J)&&(J=Ke)}return J}static isPosition(N){if(!N)return!1;if(N instanceof C)return!0;let{line:J,character:Ce}=N;return typeof J=="number"&&typeof Ce=="number"}get line(){return this._line}get character(){return this._character}isBefore(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<N._character}isBeforeOrEqual(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<=N._character}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this._line===N._line&&this._character===N._character}compareTo(N){return this._line<N._line?-1:this._line>N.line?1:this._character<N._character?-1:this._character>N._character?1:0}translate(N,J=0){if(N===null||J===null)throw(0,t.illegalArgument)();let Ce;return typeof N=="undefined"?Ce=0:typeof N=="number"?Ce=N:(Ce=typeof N.lineDelta=="number"?N.lineDelta:0,J=typeof N.characterDelta=="number"?N.characterDelta:0),Ce===0&&J===0?this:new C(this.line+Ce,this.character+J)}with(N,J=this.character){if(N===null||J===null)throw(0,t.illegalArgument)();let Ce;return typeof N=="undefined"?Ce=this.line:typeof N=="number"?Ce=N:(Ce=typeof N.line=="number"?N.line:this.line,J=typeof N.character=="number"?N.character:this.character),Ce===this.line&&J===this.character?this:new C(Ce,J)}toJSON(){return{line:this.line,character:this.character}}};y=C=xe([k],y),e.Position=y;let O=w=class{constructor(N,J,Ce,Ke){let it,ct;if(typeof N=="number"&&typeof J=="number"&&typeof Ce=="number"&&typeof Ke=="number"?(it=new y(N,J),ct=new y(Ce,Ke)):N instanceof y&&J instanceof y&&(it=N,ct=J),!it||!ct)throw new Error("Invalid arguments");it.isBefore(ct)?(this._start=it,this._end=ct):(this._start=ct,this._end=it)}static isRange(N){return N instanceof w?!0:N?y.isPosition(N.start)&&y.isPosition(N.end):!1}get start(){return this._start}get end(){return this._end}contains(N){return N instanceof w?this.contains(N._start)&&this.contains(N._end):N instanceof y?!(N.isBefore(this._start)||this._end.isBefore(N)):!1}isEqual(N){return this._start.isEqual(N._start)&&this._end.isEqual(N._end)}intersection(N){const J=y.Max(N.start,this._start),Ce=y.Min(N.end,this._end);if(!J.isAfter(Ce))return new w(J,Ce)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const J=y.Min(N.start,this._start),Ce=y.Max(N.end,this.end);return new w(J,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(N,J=this.end){if(N===null||J===null)throw(0,t.illegalArgument)();let Ce;return N?y.isPosition(N)?Ce=N:(Ce=N.start||this.start,J=N.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&J.isEqual(this.end)?this:new w(Ce,J)}toJSON(){return[this.start,this.end]}};O=w=xe([k],O),e.Range=O;let U=u=class extends O{constructor(N,J,Ce,Ke){let it,ct;if(typeof N=="number"&&typeof J=="number"&&typeof Ce=="number"&&typeof Ke=="number"?(it=new y(N,J),ct=new y(Ce,Ke)):N instanceof y&&J instanceof y&&(it=N,ct=J),!it||!ct)throw new Error("Invalid arguments");super(it,ct);this._anchor=it,this._active=ct}static isSelection(N){return N instanceof u?!0:N?O.isRange(N)&&y.isPosition(N.anchor)&&y.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};U=u=xe([k],U),e.Selection=U;class q{constructor(N,J,Ce){if(typeof N!="string"||N.length===0)throw(0,t.illegalArgument)("host");if(typeof J!="number"||J===0||Math.round(J)!==J)throw(0,t.illegalArgument)("port");if(typeof Ce!="undefined"&&(typeof Ce!="string"||Ce.length===0||!/^[0-9A-Za-z\-]+$/.test(Ce)))throw(0,t.illegalArgument)("connectionToken");this.host=N,this.port=Math.round(J),this.connectionToken=Ce}}e.ResolvedAuthority=q;class H extends Error{constructor(N,J=i.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(N);this._message=N,this._code=J,this._detail=Ce,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,H.prototype)}static NotAvailable(N,J){return new H(N,i.RemoteAuthorityResolverErrorCode.NotAvailable,J)}static TemporarilyNotAvailable(N){return new H(N,i.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=H;var z;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(z=e.EndOfLine||(e.EndOfLine={}));var j;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(j=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ie=_=class{constructor(N,J){this._range=N,this._newText=J}static isTextEdit(N){return N instanceof _?!0:N?O.isRange(N)&&typeof N.newText=="string":!1}static replace(N,J){return new _(N,J)}static insert(N,J){return _.replace(new O(N,N),J)}static delete(N){return _.replace(N,"")}static setEndOfLine(N){const J=new _(new O(new y(0,0),new y(0,0)),"");return J.newEol=N,J}get range(){return this._range}set range(N){if(N&&!O.isRange(N))throw(0,t.illegalArgument)("range");this._range=N}get newText(){return this._newText||""}set newText(N){if(N&&typeof N!="string")throw(0,t.illegalArgument)("newText");this._newText=N}get newEol(){return this._newEol}set newEol(N){if(N&&typeof N!="number")throw(0,t.illegalArgument)("newEol");this._newEol=N}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ie=_=xe([k],ie),e.TextEdit=ie;var ae;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace"})(ae=e.FileEditType||(e.FileEditType={}));let te=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(N,J,Ce,Ke){this._edits.push({_type:1,from:N,to:J,options:Ce,metadata:Ke})}createFile(N,J,Ce){this._edits.push({_type:1,from:void 0,to:N,options:J,metadata:Ce})}deleteFile(N,J,Ce){this._edits.push({_type:1,from:N,to:void 0,options:J,metadata:Ce})}replaceNotebookMetadata(N,J,Ce){this._edits.push({_type:3,metadata:Ce,uri:N,edit:{editType:5,metadata:J},notebookMetadata:J})}replaceNotebookCells(N,J,Ce,Ke,it){let ct,ft,Pt=[],Ft;if(zt.isNotebookRange(J)&&Bt.isNotebookCellDataArray(Ce)&&!Bt.isNotebookCellDataArray(Ke)?(ct=J.start,ft=J.end,Pt=Ce,Ft=Ke):typeof J=="number"&&typeof Ce=="number"&&Bt.isNotebookCellDataArray(Ke)&&(ct=J,ft=Ce,Pt=Ke,Ft=it),ct===void 0||ft===void 0)throw new Error("Invalid arguments");(ct!==ft||Pt.length>0)&&this._edits.push({_type:5,uri:N,index:ct,count:ft-ct,cells:Pt,metadata:Ft})}replaceNotebookCellMetadata(N,J,Ce,Ke){this._edits.push({_type:3,metadata:Ke,uri:N,edit:{editType:8,index:J,metadata:Ce}})}replace(N,J,Ce,Ke){this._edits.push({_type:2,uri:N,edit:new ie(J,Ce),metadata:Ke})}insert(N,J,Ce,Ke){this.replace(N,new O(J,J),Ce,Ke)}delete(N,J,Ce){this.replace(N,J,"",Ce)}has(N){return this._edits.some(J=>J._type===2&&J.uri.toString()===N.toString())}set(N,J){if(J)for(const Ce of J)Ce&&this._edits.push({_type:2,uri:N,edit:Ce});else{for(let Ce=0;Ce<this._edits.length;Ce++){const Ke=this._edits[Ce];Ke._type===2&&Ke.uri.toString()===N.toString()&&(this._edits[Ce]=void 0)}(0,r.coalesceInPlace)(this._edits)}}get(N){const J=[];for(let Ce of this._edits)Ce._type===2&&Ce.uri.toString()===N.toString()&&J.push(Ce.edit);return J}entries(){const N=new P.ResourceMap;for(let J of this._edits)if(J._type===2){let Ce=N.get(J.uri);Ce||(Ce=[J.uri,[]],N.set(J.uri,Ce)),Ce[1].push(J.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};te=xe([k],te),e.WorkspaceEdit=te;let ue=a=class{constructor(N){this._tabstop=1,this.value=N||""}static isSnippetString(N){return N instanceof a?!0:N?typeof N.value=="string":!1}static _escape(N){return N.replace(/\$|}|\\/g,"\\$&")}appendText(N){return this.value+=a._escape(N),this}appendTabstop(N=this._tabstop++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,J=this._tabstop++){if(typeof N=="function"){const Ce=new a;Ce._tabstop=this._tabstop,N(Ce),this._tabstop=Ce._tabstop,N=Ce.value}else N=a._escape(N);return this.value+="${",this.value+=J,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,J=this._tabstop++){const Ce=N.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=J,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(N,J){if(typeof J=="function"){const Ce=new a;Ce._tabstop=this._tabstop,J(Ce),this._tabstop=Ce._tabstop,J=Ce.value}else typeof J=="string"&&(J=J.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,J&&(this.value+=":",this.value+=J),this.value+="}",this}};ue=a=xe([k],ue),e.SnippetString=ue;var be;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(be=e.DiagnosticTag||(e.DiagnosticTag={}));var pe;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(pe=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let me=F=class{constructor(N,J){if(this.uri=N,J)if(J instanceof O)this.range=J;else if(J instanceof y)this.range=new O(J,J);else throw new Error("Illegal argument")}static isLocation(N){return N instanceof F?!0:N?O.isRange(N.range)&&T.URI.isUri(N.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};me=F=xe([k],me),e.Location=me;let oe=class{constructor(N,J){this.location=N,this.message=J}static is(N){return N?typeof N.message=="string"&&N.location&&O.isRange(N.location.range)&&T.URI.isUri(N.location.uri):!1}static isEqual(N,J){return N===J?!0:!N||!J?!1:N.message===J.message&&N.location.range.isEqual(J.location.range)&&N.location.uri.toString()===J.location.uri.toString()}};oe=xe([k],oe),e.DiagnosticRelatedInformation=oe;let Ee=class{constructor(N,J,Ce=pe.Error){if(!O.isRange(N))throw new TypeError("range must be set");if(!J)throw new TypeError("message must be set");this.range=N,this.message=J,this.severity=Ce}toJSON(){return{severity:pe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,J){return N===J?!0:!N||!J?!1:N.message===J.message&&N.severity===J.severity&&N.code===J.code&&N.severity===J.severity&&N.source===J.source&&N.range.isEqual(J.range)&&(0,r.equals)(N.tags,J.tags)&&(0,r.equals)(N.relatedInformation,J.relatedInformation,oe.isEqual)}};Ee=xe([k],Ee),e.Diagnostic=Ee;let Pe=class{constructor(N,J){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=J}};Pe=xe([k],Pe),e.Hover=Pe;var Oe;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(Oe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let je=class{constructor(N,J=Oe.Text){this.range=N,this.kind=J}toJSON(){return{range:this.range,kind:Oe[this.kind]}}};je=xe([k],je),e.DocumentHighlight=je;var st;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(st=e.SymbolKind||(e.SymbolKind={}));var et;(function(B){B[B.Deprecated=1]="Deprecated"})(et=e.SymbolTag||(e.SymbolTag={}));let tt=c=class{constructor(N,J,Ce,Ke,it){this.name=N,this.kind=J,this.containerName=it,typeof Ce=="string"&&(this.containerName=Ce),Ke instanceof me?this.location=Ke:Ce instanceof O&&(this.location=new me(Ke,Ce)),c.validate(this)}static validate(N){if(!N.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:st[this.kind],location:this.location,containerName:this.containerName}}};tt=c=xe([k],tt),e.SymbolInformation=tt;let $=n=class{constructor(N,J,Ce,Ke,it){this.name=N,this.detail=J,this.kind=Ce,this.range=Ke,this.selectionRange=it,this.children=[],n.validate(this)}static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children&&N.children.forEach(n.validate)}};$=n=xe([k],$),e.DocumentSymbol=$;var K;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(K=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let x=class{constructor(N,J){this.title=N,this.kind=J}};x=xe([k],x),e.CodeAction=x;let V=f=class{constructor(N){this.value=N}append(N){return new f(this.value?this.value+f.sep+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+f.sep)}};V.sep=".",V=f=xe([k],V),e.CodeActionKind=V,V.Empty=new V(""),V.QuickFix=V.Empty.append("quickfix"),V.Refactor=V.Empty.append("refactor"),V.RefactorExtract=V.Refactor.append("extract"),V.RefactorInline=V.Refactor.append("inline"),V.RefactorRewrite=V.Refactor.append("rewrite"),V.Source=V.Empty.append("source"),V.SourceOrganizeImports=V.Source.append("organizeImports"),V.SourceFixAll=V.Source.append("fixAll");let Y=class{constructor(N,J){if(this.range=N,this.parent=J,J&&!J.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Y=xe([k],Y),e.SelectionRange=Y;class se{constructor(N,J,Ce,Ke,it,ct){this.kind=N,this.name=J,this.detail=Ce,this.uri=Ke,this.range=it,this.selectionRange=ct}}e.CallHierarchyItem=se;class _e{constructor(N,J){this.fromRanges=J,this.from=N}}e.CallHierarchyIncomingCall=_e;class Ue{constructor(N,J){this.fromRanges=J,this.to=N}}e.CallHierarchyOutgoingCall=Ue;var Ve;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(Ve=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Qe=class{constructor(N,J){this.range=N,this.command=J}get isResolved(){return!!this.command}};Qe=xe([k],Qe),e.CodeLens=Qe;let nt=g=class{constructor(N,J=!1){l.set(this,void 0),Xe(this,l,new S.MarkdownString(N,{supportThemeIcons:J}),"f")}static isMarkdownString(N){return N instanceof g?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}get value(){return Ie(this,l,"f").value}set value(N){Ie(this,l,"f").value=N}get isTrusted(){return Ie(this,l,"f").isTrusted}set isTrusted(N){Ie(this,l,"f").isTrusted=N}get supportThemeIcons(){return Ie(this,l,"f").supportThemeIcons}set supportThemeIcons(N){Ie(this,l,"f").supportThemeIcons=N}get supportHtml(){return Ie(this,l,"f").supportHtml}set supportHtml(N){Ie(this,l,"f").supportHtml=N}appendText(N){return Ie(this,l,"f").appendText(N),this}appendMarkdown(N){return Ie(this,l,"f").appendMarkdown(N),this}appendCodeblock(N,J){return Ie(this,l,"f").appendCodeblock(J??"",N),this}};l=new WeakMap,nt=g=xe([k],nt),e.MarkdownString=nt;let rt=class{constructor(N,J){this.label=N,this.documentation=J}};rt=xe([k],rt),e.ParameterInformation=rt;let Je=class{constructor(N,J){this.label=N,this.documentation=J,this.parameters=[]}};Je=xe([k],Je),e.SignatureInformation=Je;let Ze=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ze=xe([k],Ze),e.SignatureHelp=Ze;var pt;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(pt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Fe;(function(B){B[B.Other=0]="Other",B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(Fe=e.InlayHintKind||(e.InlayHintKind={}));let At=class{constructor(N){this.label=N}};At=xe([k],At),e.InlayHintLabelPart=At;let G=class{constructor(N,J,Ce){this.label=N,this.position=J,this.kind=Ce}};G=xe([k],G),e.InlayHint=G;var Q;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Q=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var he;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(he=e.CompletionItemKind||(e.CompletionItemKind={}));var Be;(function(B){B[B.Deprecated=1]="Deprecated"})(Be=e.CompletionItemTag||(e.CompletionItemTag={}));let qe=class{constructor(N,J){this.label=N,this.kind=J}toJSON(){return{label:this.label,kind:this.kind&&he[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};qe=xe([k],qe),e.CompletionItem=qe;let lt=class{constructor(N=[],J=!1){this.items=N,this.isIncomplete=J}};lt=xe([k],lt),e.CompletionList=lt;let ht=class{constructor(N,J,Ce){this.text=N,this.range=J,this.command=Ce}};ht=xe([k],ht),e.InlineSuggestion=ht;let Ye=class{constructor(N){this.items=N}};Ye=xe([k],Ye),e.InlineSuggestions=Ye;var kt;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(kt=e.ViewColumn||(e.ViewColumn={}));var Ae;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Ae=e.StatusBarAlignment||(e.StatusBarAlignment={}));var De;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(De=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ve;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(ve=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ee;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(ee=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ne;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(ne=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var de;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(de=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ge;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(ge=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(B){function N(J){switch(J){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=N}(ne=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Te=class{constructor(N,J){if(J&&!T.URI.isUri(J))throw(0,t.illegalArgument)("target");if(!O.isRange(N)||N.isEmpty)throw(0,t.illegalArgument)("range");this.range=N,this.target=J}};Te=xe([k],Te),e.DocumentLink=Te;let ze=class{constructor(N,J,Ce,Ke){this.red=N,this.green=J,this.blue=Ce,this.alpha=Ke}};ze=xe([k],ze),e.Color=ze;let Le=class{constructor(N,J){if(J&&!(J instanceof ze))throw(0,t.illegalArgument)("color");if(!O.isRange(N)||N.isEmpty)throw(0,t.illegalArgument)("range");this.range=N,this.color=J}};Le=xe([k],Le),e.ColorInformation=Le;let Ge=class{constructor(N){if(!N||typeof N!="string")throw(0,t.illegalArgument)("label");this.label=N}};Ge=xe([k],Ge),e.ColorPresentation=Ge;var ot;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(ot=e.ColorFormat||(e.ColorFormat={}));var at;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(at=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Ne{constructor(N,J,Ce){if(this.startIndex=N,this.length=J,this.tooltip=Ce,typeof N!="number"||N<0)throw(0,t.illegalArgument)("startIndex");if(typeof J!="number"||J<1)throw(0,t.illegalArgument)("length");if(Ce!==void 0&&typeof Ce!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Ne;var ce;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(ce=e.TerminalLocation||(e.TerminalLocation={}));class fe{constructor(N){this.options=N,typeof N!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=fe;var re;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(re=e.TaskRevealKind||(e.TaskRevealKind={}));var W;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(W=e.TaskPanelKind||(e.TaskPanelKind={}));let we=s=class{constructor(N,J){if(this.label=J,typeof N!="string"||typeof J!="string")throw(0,t.illegalArgument)("name");this._id=N}static from(N){switch(N){case"clean":return s.Clean;case"build":return s.Build;case"rebuild":return s.Rebuild;case"test":return s.Test;default:return}}get id(){return this._id}};we.Clean=new s("clean","Clean"),we.Build=new s("build","Build"),we.Rebuild=new s("rebuild","Rebuild"),we.Test=new s("test","Test"),we=s=xe([k],we),e.TaskGroup=we;function Re(B){let N="";for(let J=0;J<B.length;J++)N+=B[J].replace(/,/g,",,")+",";return N}let We=class{constructor(N,J,Ce){if(typeof N!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=N,J!==void 0&&(Array.isArray(J)?(this._args=J,this._options=Ce):this._options=J)}get process(){return this._process}set process(N){if(typeof N!="string")throw(0,t.illegalArgument)("process");this._process=N}get args(){return this._args}set args(N){Array.isArray(N)||(N=[]),this._args=N}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("process"),this._process!==void 0&&N.push(this._process),this._args&&this._args.length>0)for(let J of this._args)N.push(J);return Re(N)}};We=xe([k],We),e.ProcessExecution=We;let He=class{constructor(N,J,Ce){if(this._args=[],Array.isArray(J)){if(!N)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,t.illegalArgument)("command");this._command=N,this._args=J,this._options=Ce}else{if(typeof N!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=N,this._options=J}}get commandLine(){return this._commandLine}set commandLine(N){if(typeof N!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=N}get command(){return this._command?this._command:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,t.illegalArgument)("command");this._command=N}get args(){return this._args}set args(N){this._args=N||[]}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("shell"),this._commandLine!==void 0&&N.push(this._commandLine),this._command!==void 0&&N.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let J of this._args)N.push(typeof J=="string"?J:J.value);return Re(N)}};He=xe([k],He),e.ShellExecution=He;var mt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(mt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class St{constructor(N){this._callback=N}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(N){this._callback=N}get callback(){return this._callback}}e.CustomExecution=St;let dt=d=class{constructor(N,J,Ce,Ke,it,ct){this.__deprecated=!1,this._definition=this.definition=N;let ft;typeof J=="string"?(this._name=this.name=J,this._source=this.source=Ce,this.execution=Ke,ft=it,this.__deprecated=!0):J===Et.Global||J===Et.Workspace?(this.target=J,this._name=this.name=Ce,this._source=this.source=Ke,this.execution=it,ft=ct):(this.target=J,this._name=this.name=Ce,this._source=this.source=Ke,this.execution=it,ft=ct),typeof ft=="string"?(this._problemMatchers=[ft],this._hasDefinedMatchers=!0):Array.isArray(ft)?(this._problemMatchers=ft,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(N){this.__id=N}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof We?this._definition={type:d.ProcessType,id:this._execution.computeId()}:this._execution instanceof He?this._definition={type:d.ShellType,id:this._execution.computeId()}:this._execution instanceof St?this._definition={type:d.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:d.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(N){if(N==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=N}get scope(){return this._scope}set target(N){this.clear(),this._scope=N}get name(){return this._name}set name(N){if(typeof N!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=N}get execution(){return this._execution}set execution(N){N===null&&(N=void 0),this.clear(),this._execution=N;const J=this._definition.type;(d.EmptyType===J||d.ProcessType===J||d.ShellType===J||d.ExtensionCallbackType===J)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(N){if(Array.isArray(N))this.clear(),this._problemMatchers=N,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.clear(),this._isBackground=N}get source(){return this._source}set source(N){if(typeof N!="string"||N.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=N}get group(){return this._group}set group(N){N===null&&(N=void 0),this.clear(),this._group=N}get detail(){return this._detail}set detail(N){N===null&&(N=void 0),this._detail=N}get presentationOptions(){return this._presentationOptions}set presentationOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._presentationOptions=N}get runOptions(){return this._runOptions}set runOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._runOptions=N}};dt.ExtensionCallbackType="customExecution",dt.ProcessType="process",dt.ShellType="shell",dt.EmptyType="$empty",dt=d=xe([k],dt),e.Task=dt;var vt;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(vt=e.ProgressLocation||(e.ProgressLocation={}));let bt=class{constructor(N,J=Ut.None){this.collapsibleState=J,T.URI.isUri(N)?this.resourceUri=N:this.label=N}};bt=xe([k],bt),e.TreeItem=bt;var Ut;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Ut=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let It=class{constructor(N){this._value=N}async asString(){return JSON.stringify(this._value)}};It=xe([k],It),e.TreeDataTransferItem=It;let Mt=class{constructor(){this._items=new Map}get(N){return this._items.get(N)}set(N,J){this._items.set(N,J)}forEach(N){this._items.forEach(N)}};Mt=xe([k],Mt),e.TreeDataTransfer=Mt;let Dt=class{constructor(N,J){this.id=N,this.color=J}};Dt=xe([k],Dt),e.ThemeIcon=Dt,Dt.File=new Dt("file"),Dt.Folder=new Dt("folder");let _t=class{constructor(N){this.id=N}};_t=xe([k],_t),e.ThemeColor=_t;var Qt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Qt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Vt=class{constructor(N,J){if(typeof N!="string"&&(!N||!T.URI.isUri(N)&&!T.URI.isUri(N.uri)))throw(0,t.illegalArgument)("base");if(typeof J!="string")throw(0,t.illegalArgument)("pattern");typeof N=="string"?this.baseUri=T.URI.file(N):T.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=J}get base(){return this._base}set base(N){this._base=N,this._baseUri=T.URI.file(N)}get baseUri(){return this._baseUri}set baseUri(N){this._baseUri=N,this._base=N.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Vt=xe([k],Vt),e.RelativePattern=Vt;let wt=class{constructor(N,J,Ce,Ke){this.enabled=typeof N=="boolean"?N:!0,typeof J=="string"&&(this.condition=J),typeof Ce=="string"&&(this.hitCondition=Ce),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};wt=xe([k],wt),e.Breakpoint=wt;let Yt=class extends wt{constructor(N,J,Ce,Ke,it){super(J,Ce,Ke,it);if(N===null)throw(0,t.illegalArgument)("location");this.location=N}};Yt=xe([k],Yt),e.SourceBreakpoint=Yt;let qt=class extends wt{constructor(N,J,Ce,Ke,it){super(J,Ce,Ke,it);this.functionName=N}};qt=xe([k],qt),e.FunctionBreakpoint=qt;let Xt=class extends wt{constructor(N,J,Ce,Ke,it,ct,ft){super(Ke,it,ct,ft);if(!J)throw(0,t.illegalArgument)("dataId");this.label=N,this.dataId=J,this.canPersist=Ce}};Xt=xe([k],Xt),e.DataBreakpoint=Xt;let ai=class{constructor(N,J,Ce){this.command=N,this.args=J||[],this.options=Ce}};ai=xe([k],ai),e.DebugAdapterExecutable=ai;let Rt=class{constructor(N,J){this.port=N,this.host=J}};Rt=xe([k],Rt),e.DebugAdapterServer=Rt;let Jt=class{constructor(N){this.path=N}};Jt=xe([k],Jt),e.DebugAdapterNamedPipeServer=Jt;let li=class{constructor(N){this.implementation=N}};li=xe([k],li),e.DebugAdapterInlineImplementation=li;let jt=class{constructor(N,J){this.range=N,this.expression=J}};jt=xe([k],jt),e.EvaluatableExpression=jt;var Zt;(function(B){B[B.Automatic=0]="Automatic",B[B.Explicit=1]="Explicit"})(Zt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let gt=class{constructor(N,J){this.range=N,this.text=J}};gt=xe([k],gt),e.InlineValueText=gt;let ci=class{constructor(N,J,Ce=!0){this.range=N,this.variableName=J,this.caseSensitiveLookup=Ce}};ci=xe([k],ci),e.InlineValueVariableLookup=ci;let Lt=class{constructor(N,J){this.range=N,this.expression=J}};Lt=xe([k],Lt),e.InlineValueEvaluatableExpression=Lt;let $t=class{constructor(N,J){this.frameId=N,this.stoppedLocation=J}};$t=xe([k],$t),e.InlineValueContext=$t;var vi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(vi=e.FileChangeType||(e.FileChangeType={}));let ui=p=class extends Error{constructor(N,J=b.FileSystemProviderErrorCode.Unknown,Ce){super(T.URI.isUri(N)?N.toString(!0):N);this.code=Ce?.name??"Unknown",(0,b.markAsFileSystemProviderError)(this,J),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}static FileExists(N){return new p(N,b.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound(N){return new p(N,b.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory(N){return new p(N,b.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory(N){return new p(N,b.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions(N){return new p(N,b.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable(N){return new p(N,b.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}};ui=p=xe([k],ui),e.FileSystemError=ui;let ei=class{constructor(N,J,Ce){this.start=N,this.end=J,this.kind=Ce}};ei=xe([k],ei),e.FoldingRange=ei;var Ci;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Ci=e.FoldingRangeKind||(e.FoldingRangeKind={}));var bi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(bi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var ti;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(ti=e.CommentMode||(e.CommentMode={}));class Di{constructor(N,J=[]){this.tokenTypes=N,this.tokenModifiers=J}}e.SemanticTokensLegend=Di;function di(B){return typeof B=="undefined"||(0,D.isStringArray)(B)}class Gt{constructor(N){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,N){this._hasLegend=!0;for(let J=0,Ce=N.tokenTypes.length;J<Ce;J++)this._tokenTypeStrToInt.set(N.tokenTypes[J],J);for(let J=0,Ce=N.tokenModifiers.length;J<Ce;J++)this._tokenModifierStrToInt.set(N.tokenModifiers[J],J)}}push(N,J,Ce,Ke,it){if(typeof N=="number"&&typeof J=="number"&&typeof Ce=="number"&&typeof Ke=="number"&&(typeof it=="number"||typeof it=="undefined"))return typeof it=="undefined"&&(it=0),this._pushEncoded(N,J,Ce,Ke,it);if(O.isRange(N)&&typeof J=="string"&&di(Ce))return this._push(N,J,Ce);throw(0,t.illegalArgument)()}_push(N,J,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(J))throw new Error("`tokenType` is not in the provided legend");const Ke=N.start.line,it=N.start.character,ct=N.end.character-N.start.character,ft=this._tokenTypeStrToInt.get(J);let Pt=0;if(Ce)for(const Ft of Ce){if(!this._tokenModifierStrToInt.has(Ft))throw new Error("`tokenModifier` is not in the provided legend");const Nt=this._tokenModifierStrToInt.get(Ft);Pt|=1<<Nt>>>0}this._pushEncoded(Ke,it,ct,ft,Pt)}_pushEncoded(N,J,Ce,Ke,it){if(this._dataIsSortedAndDeltaEncoded&&(N<this._prevLine||N===this._prevLine&&J<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Pt=this._data.length/5|0;let Ft=0,Nt=0;for(let xt=0;xt<Pt;xt++){let Ht=this._data[5*xt],gi=this._data[5*xt+1];Ht===0?(Ht=Ft,gi+=Nt):Ht+=Ft,this._data[5*xt]=Ht,this._data[5*xt+1]=gi,Ft=Ht,Nt=gi}}let ct=N,ft=J;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ct-=this._prevLine,ct===0&&(ft-=this._prevChar)),this._data[this._dataLen++]=ct,this._data[this._dataLen++]=ft,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=it,this._prevLine=N,this._prevChar=J}static _sortAndDeltaEncode(N){let J=[];const Ce=N.length/5|0;for(let ft=0;ft<Ce;ft++)J[ft]=ft;J.sort((ft,Pt)=>{const Ft=N[5*ft],Nt=N[5*Pt];if(Ft===Nt){const xt=N[5*ft+1],Ht=N[5*Pt+1];return xt-Ht}return Ft-Nt});const Ke=new Uint32Array(N.length);let it=0,ct=0;for(let ft=0;ft<Ce;ft++){const Pt=5*J[ft],Ft=N[Pt+0],Nt=N[Pt+1],xt=N[Pt+2],Ht=N[Pt+3],gi=N[Pt+4],Wi=Ft-it,Ji=Wi===0?Nt-ct:Nt,pi=5*ft;Ke[pi+0]=Wi,Ke[pi+1]=Ji,Ke[pi+2]=xt,Ke[pi+3]=Ht,Ke[pi+4]=gi,it=Ft,ct=Nt}return Ke}build(N){return this._dataIsSortedAndDeltaEncoded?new hi(new Uint32Array(this._data),N):new hi(Gt._sortAndDeltaEncode(this._data),N)}}e.SemanticTokensBuilder=Gt;class hi{constructor(N,J){this.resultId=J,this.data=N}}e.SemanticTokens=hi;class ki{constructor(N,J,Ce){this.start=N,this.deleteCount=J,this.data=Ce}}e.SemanticTokensEdit=ki;class Kt{constructor(N,J){this.resultId=J,this.edits=N}}e.SemanticTokensEdits=Kt;var Ii;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Ii=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Pi;(function(B){B[B.Initial=1]="Initial",B[B.Dynamic=2]="Dynamic"})(Pi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ii=class{constructor(){}};ii.Back={iconPath:new Dt("arrow-left")},ii=xe([k],ii),e.QuickInputButtons=ii;var Ti;(function(B){B[B.Separator=-1]="Separator",B[B.Default=1]="Default"})(Ti=e.QuickPickItemKind||(e.QuickPickItemKind={}));var fi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(fi=e.ExtensionKind||(e.ExtensionKind={}));class wi{constructor(N,J,Ce){this.badge=N,this.tooltip=J,this.color=Ce}static validate(N){if(N.badge){let J=(0,I.nextCharLength)(N.badge,0);if(J<N.badge.length&&(J+=(0,I.nextCharLength)(N.badge,J)),N.badge.length>J)throw new Error("The 'badge'-property must be undefined or a short character")}if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=wi;let ni=class{constructor(N){this.kind=N}};ni=xe([k],ni),e.ColorTheme=ni;var Me;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast"})(Me=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(N,J){if(N<0)throw(0,t.illegalArgument)("start must be positive");if(J<0)throw(0,t.illegalArgument)("end must be positive");N<=J?(this._start=N,this._end=J):(this._start=J,this._end=N)}static isNotebookRange(N){return N instanceof zt?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(N){let J=this._start,Ce=this._end;return N.start!==void 0&&(J=N.start),N.end!==void 0&&(Ce=N.end),J===this._start&&Ce===this._end?this:new zt(J,Ce)}}e.NotebookRange=zt;class Bt{constructor(N,J,Ce,Ke,it,ct,ft){this.kind=N,this.value=J,this.languageId=Ce,this.mime=Ke,this.outputs=it??[],this.metadata=ct,this.executionSummary=ft,Bt.validate(this)}static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(J=>Bt.isNotebookCellData(J))}static isNotebookCellData(N){return!0}}e.NotebookCellData=Bt;class yt{constructor(N){this.cells=N}}e.NotebookData=yt;class Ot{constructor(N,J){this.data=N,this.mime=J;const Ce=(0,A.normalizeMimeType)(J,!0);if(!Ce)throw new Error(`INVALID mime type: ${J}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ce}static isNotebookCellOutputItem(N){return N instanceof Ot?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const J={name:N.name,message:N.message,stack:N.stack};return Ot.json(J,"application/vnd.code.notebook.error")}static stdout(N){return Ot.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return Ot.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,J="application/octet-stream"){return new Ot(N,J)}static text(N,J=A.Mimes.text){const Ce=Ie(Ot,o,"f",m).encode(String(N));return new Ot(Ce,J)}static json(N,J="application/json"){const Ce=JSON.stringify(N,void 0,"	");return Ot.text(Ce,J)}}e.NotebookCellOutputItem=Ot,o=Ot,m={value:new TextEncoder};class ri{constructor(N,J,Ce){this.items=ri.ensureUniqueMimeTypes(N,!0),typeof J=="string"?(this.id=J,this.metadata=Ce):(this.id=(0,R.generateUuid)(),this.metadata=J??Ce)}static isNotebookCellOutput(N){return N instanceof ri?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&(0,D.isArray)(N.items)}static ensureUniqueMimeTypes(N,J=!1){const Ce=new Set,Ke=new Set;for(let it=0;it<N.length;it++){const ct=N[it],ft=(0,A.normalizeMimeType)(ct.mime);if(!Ce.has(ft)){Ce.add(ft);continue}Ke.add(it),J&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ke.size===0?N:N.filter((it,ct)=>!Ke.has(ct))}}e.NotebookCellOutput=ri;var Ei;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(Ei=e.NotebookCellKind||(e.NotebookCellKind={}));var yi;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(yi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ai;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Ai=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ri;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Ri=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Fi{constructor(N,J){this.text=N,this.alignment=J}}e.NotebookCellStatusBarItem=Fi;var Mi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(Mi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Si{constructor(N,J=[]){this.uri=N,this.provides=(0,r.asArray)(J)}}e.NotebookRendererScript=Si;let mi=class{constructor(N,J){this.label=N,this.timestamp=J}};mi=xe([k],mi),e.TimelineItem=mi;var Oi;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(Oi=e.ExtensionMode||(e.ExtensionMode={}));var Li;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(Li=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ni;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Ni=e.StandardTokenType||(e.StandardTokenType={}));class Ui{constructor(N,J){this.ranges=N,this.wordPattern=J}}e.LinkedEditingRanges=Ui;class X{constructor(N,J){this._port=N,this._autoForwardAction=J}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=X;var le;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(le=e.TestResultState||(e.TestResultState={}));var ke;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(ke=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ut=class{constructor(N=void 0,J=void 0,Ce=void 0){this.include=N,this.exclude=J,this.profile=Ce}};ut=xe([k],ut),e.TestRunRequest=ut;let Ct=E=class{constructor(N){this.message=N}static diff(N,J,Ce){const Ke=new E(N);return Ke.expectedOutput=J,Ke.actualOutput=Ce,Ke}};Ct=E=xe([k],Ct),e.TestMessage=Ct;let Tt=class{constructor(N){this.id=N}};Tt=xe([k],Tt),e.TestTag=Tt;let oi=class{constructor(N,J){this.covered=N,this.total=J}};oi=xe([k],oi),e.CoveredCount=oi;let Bi=v=class{constructor(N,J,Ce,Ke){this.uri=N,this.statementCoverage=J,this.branchCoverage=Ce,this.functionCoverage=Ke}static fromDetails(N,J){const Ce=new oi(0,0),Ke=new oi(0,0),it=new oi(0,0);for(const ft of J)if("branches"in ft){Ce.total+=1,Ce.covered+=ft.executionCount>0?1:0;for(const Pt of ft.branches)Ke.total+=1,Ke.covered+=Pt.executionCount>0?1:0}else it.total+=1,it.covered+=ft.executionCount>0?1:0;const ct=new v(N,Ce,Ke.total>0?Ke:void 0,it.total>0?it:void 0);return ct.detailedCoverage=J,ct}};Bi=v=xe([k],Bi),e.FileCoverage=Bi;let xi=class{constructor(N,J,Ce=[]){this.executionCount=N,this.location=J,this.branches=Ce}};xi=xe([k],xi),e.StatementCoverage=xi;let $i=class{constructor(N,J){this.executionCount=N,this.location=J}};$i=xe([k],$i),e.BranchCoverage=$i;let zi=class{constructor(N,J){this.executionCount=N,this.location=J}};zi=xe([k],zi),e.FunctionCoverage=zi;var Ki;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(Ki=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Qi;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(Qi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Yi;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(Yi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Xi{constructor(N,J,Ce,Ke,it,ct){this.kind=N,this.name=J,this.detail=Ce,this.uri=Ke,this.range=it,this.selectionRange=ct}}e.TypeHierarchyItem=Xi}),define(ye[84],Se([0,1,42,11,9,223,113,7,16]),function(Z,e,r,t,S,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const T=new Map;function R(l,o){o?T.set(l,o):T.delete(l)}e.setWordDefinitionFor=R;function b(l){return T.get(l)}e.getWordDefinitionFor=b;class i extends P.MirrorTextModel{constructor(o,m,M,C,w,u,_,a){super(m,M,C,w);this._proxy=o,this._languageId=u,this._isDirty=_,this._notebook=a,this._isDisposed=!1}dispose(){(0,r.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(o){return(0,D.equals)(this._lines,o)}get document(){if(!this._document){const o=this;this._document={get uri(){return o._uri},get fileName(){return o._uri.fsPath},get isUntitled(){return o._uri.scheme===t.Schemas.untitled},get languageId(){return o._languageId},get version(){return o._versionId},get isClosed(){return o._isDisposed},get isDirty(){return o._isDirty},get notebook(){return o._notebook},save(){return o._save()},getText(m){return m?o._getTextInRange(m):o.getText()},get eol(){return o._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return o._lines.length},lineAt(m){return o._lineAt(m)},offsetAt(m){return o._offsetAt(m)},positionAt(m){return o._positionAt(m)},validateRange(m){return o._validateRange(m)},validatePosition(m){return o._validatePosition(m)},getWordRangeAtPosition(m,M){return o._getWordRangeAtPosition(m,M)}}}return Object.freeze(this._document)}_acceptLanguageId(o){(0,r.ok)(!this._isDisposed),this._languageId=o}_acceptIsDirty(o){(0,r.ok)(!this._isDisposed),this._isDirty=o}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(o){const m=this._validateRange(o);if(m.isEmpty)return"";if(m.isSingleLine)return this._lines[m.start.line].substring(m.start.character,m.end.character);const M=this._eol,C=m.start.line,w=m.end.line,u=[];u.push(this._lines[C].substring(m.start.character));for(let _=C+1;_<w;_++)u.push(this._lines[_]);return u.push(this._lines[w].substring(0,m.end.character)),u.join(M)}_lineAt(o){let m;if(o instanceof I.Position?m=o.line:typeof o=="number"&&(m=o),typeof m!="number"||m<0||m>=this._lines.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new h(m,this._lines[m],m===this._lines.length-1)}_offsetAt(o){return o=this._validatePosition(o),this._ensureLineStarts(),this._lineStarts.getPrefixSum(o.line-1)+o.character}_positionAt(o){o=Math.floor(o),o=Math.max(0,o),this._ensureLineStarts();const m=this._lineStarts.getIndexOf(o),M=this._lines[m.index].length;return new I.Position(m.index,Math.min(m.remainder,M))}_validateRange(o){if(!(o instanceof I.Range))throw new Error("Invalid argument");const m=this._validatePosition(o.start),M=this._validatePosition(o.end);return m===o.start&&M===o.end?o:new I.Range(m.line,m.character,M.line,M.character)}_validatePosition(o){if(!(o instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return o.with(0,0);let{line:m,character:M}=o,C=!1;if(m<0)m=0,M=0,C=!0;else if(m>=this._lines.length)m=this._lines.length-1,M=this._lines[m].length,C=!0;else{const w=this._lines[m].length;M<0?(M=0,C=!0):M>w&&(M=w,C=!0)}return C?new I.Position(m,M):o}_getWordRangeAtPosition(o,m){const M=this._validatePosition(o);if(!m)m=b(this._languageId);else if((0,S.regExpLeadsToEndlessLoop)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const C=(0,A.getWordAtText)(M.character+1,(0,A.ensureValidWordDefinition)(m),this._lines[M.line],0);if(C)return new I.Range(M.line,C.startColumn-1,M.line,C.endColumn-1)}}e.ExtHostDocumentData=i;class h{constructor(o,m,M){this._line=o,this._text=m,this._isLastLine=M}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(ye[149],Se([0,1,7,4,224,6,56,22,2,36]),function(Z,e,r,t,S,P,A,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class R{constructor(i,h,l,o){this._notebook=l,this._selector=o,this._disposables=new P.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,T.generateUuid)()}),this._init(),this._disposables.add(h.onDidChangeDocument(M=>{const C=this._cellUris.get(M.document.uri);C!==void 0&&(this._cellLengths.setValue(C,this._cells[C].document.getText().length+1),this._cellLines.setValue(C,this._cells[C].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const m=M=>{M===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(i.onDidChangeNotebookCells(M=>m(M.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new I.ResourceMap;const i=[],h=[];for(const l of this._notebook.getCells())l.kind===r.NotebookCellKind.Code&&(!this._selector||(0,A.score)(this._selector,l.document.uri,l.document.languageId,!0))&&(this._cellUris.set(l.document.uri,this._cells.length),this._cells.push(l),i.push(l.document.getText().length+1),h.push(l.document.lineCount));this._cellLengths=new S.PrefixSumComputer(new Uint32Array(i)),this._cellLines=new S.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(i){if(!i){let C="";for(const w of this._cells)C+=w.document.getText()+`
`;return C=C.slice(0,-1),C}if(i.isEmpty)return"";const h=this.locationAt(i.start),l=this.locationAt(i.end),o=this._cellUris.get(h.uri),m=this._cellUris.get(l.uri);if(o===void 0||m===void 0)return"";if(o===m)return this._cells[o].document.getText(new r.Range(h.range.start,l.range.end));const M=[this._cells[o].document.getText(new r.Range(h.range.start,new r.Position(this._cells[o].document.lineCount,0)))];for(let C=o+1;C<m;C++)M.push(this._cells[C].document.getText());return M.push(this._cells[m].document.getText(new r.Range(new r.Position(0,0),l.range.end))),M.join(`
`)}offsetAt(i){const h=this._cellLines.getIndexOf(i.line),l=this._cellLengths.getPrefixSum(h.index-1),o=this._cells[h.index].document.offsetAt(i.with(h.remainder));return l+o}positionAt(i){if(typeof i=="number"){const l=this._cellLengths.getIndexOf(i),o=this._cellLines.getPrefixSum(l.index-1);return this._cells[l.index].document.positionAt(l.remainder).translate(o)}const h=this._cellUris.get(i.uri);if(h!==void 0){const l=this._cellLines.getPrefixSum(h-1);return new r.Position(l+i.range.start.line,i.range.start.character)}return new r.Position(0,0)}locationAt(i){r.Range.isRange(i)||(i=new r.Range(i,i));const h=this._cellLines.getIndexOf(i.start.line);let l=h;i.isEmpty||(l=this._cellLines.getIndexOf(i.end.line));const o=new r.Position(h.remainder,i.start.character),m=new r.Position(l.remainder,i.end.character),M=new r.Range(o,m),C=this._cells[h.index];return new r.Location(C.document.uri,C.document.validateRange(M))}contains(i){return this._cellUris.has(i)}validateRange(i){const h=this.validatePosition(i.start),l=this.validatePosition(i.end);return i.with(h,l)}validatePosition(i){const h=this._cellLines.getIndexOf(i.line),l=new r.Position(h.remainder,i.character),o=this._cells[h.index].document.validatePosition(l),m=this._cellLines.getPrefixSum(h.index-1);return new r.Position(m+o.line,o.character)}}e.ExtHostNotebookConcatDocument=R}),define(ye[150],Se([0,1,7,14,4]),function(Z,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(I){this._actual=new r.ColorTheme(r.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new S.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let D=I==="light"?r.ColorThemeKind.Light:I==="dark"?r.ColorThemeKind.Dark:r.ColorThemeKind.HighContrast;this._actual=new r.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=xe([$e(0,t.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(ye[64],Se([0,1,3]),function(Z,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,r.createDecorator)("IURITransformerService");class t{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=t}),define(ye[151],Se([0,1,21]),function(Z,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(D){let T=this.buffers.indexOf(D);return T<0&&(T=this.buffers.length,this.buffers.push(D)),T}}function S(I,D){if(D.serializeBuffersForPostMessage){const T=new t,R=(h,l)=>{if(l instanceof ArrayBuffer){const o=T.add(l);return{$$vscode_array_buffer_reference$$:!0,index:o}}else if(ArrayBuffer.isView(l)){const o=P(l);if(o){const m=T.add(l.buffer);return{$$vscode_array_buffer_reference$$:!0,index:m,view:{type:o,byteLength:l.byteLength,byteOffset:l.byteOffset}}}}return l},b=JSON.stringify(I,R),i=T.buffers.map(h=>{const l=new Uint8Array(h);return r.VSBuffer.wrap(l)});return{message:b,buffers:i}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeWebviewMessage=S;function P(I){switch(I.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(I,D){const T=D.map(i=>{const h=new ArrayBuffer(i.byteLength);return new Uint8Array(h).set(i.buffer),h}),R=D.length?(i,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const l=h,{index:o}=l,m=T[o];if(l.view)switch(l.view.type){case 1:return new Int8Array(m,l.view.byteOffset,l.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(m,l.view.byteOffset,l.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(m,l.view.byteOffset,l.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(m,l.view.byteOffset,l.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(m,l.view.byteOffset,l.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(m,l.view.byteOffset,l.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(m,l.view.byteOffset,l.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(m,l.view.byteOffset,l.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(m,l.view.byteOffset,l.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(m,l.view.byteOffset,l.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(m,l.view.byteOffset,l.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return m}return h}:void 0;return{message:JSON.parse(I,R),arrayBuffers:T}}e.deserializeWebviewMessage=A}),define(ye[152],Se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var r;(function(t){function S(A){const I=new Map;return A.types.forEach((D,T)=>{I.set(D,{asString:async()=>A.items[T].asString})}),I}t.toITreeDataTransfer=S;async function P(A){const I={types:[],items:[]},D=Array.from(A.entries());for(const T of D)I.types.push(T[0]),I.items.push({asString:await T[1].asString()});return I}t.toTreeDataTransferDTO=P})(r=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(ye[65],Se([0,1,11,2]),function(Z,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function S(I,D){return I.scheme===r.Schemas.http||I.scheme===r.Schemas.https?I:(D&&D.authority&&D.isRemote&&I.scheme===r.Schemas.file&&(I=t.URI.from({scheme:r.Schemas.vscodeRemote,authority:D.authority,path:I.path})),t.URI.from({scheme:r.Schemas.https,authority:`${I.scheme}+${P(I.authority)}.${e.webviewRootResourceAuthority}`,path:I.path,fragment:I.fragment,query:I.query}))}e.asWebviewUri=S;function P(I){return I.replace(/./g,D=>{const T=D.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?D:"-"+T.toString(16).padStart(4,"0")})}function A(I){return I.replace(/-([0-9a-f]{4})/g,(D,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=A}),define(ye[153],Se([0,1,4,6,65]),function(Z,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class P{constructor(I,D,T){this._proxy=I,this._editors=D,this._initData=T,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const R=D.getVisibleTextEditors();for(const b of this._insets.values())R.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this._insets.forEach(I=>I.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(I,D,T,R,b){let i;for(const w of this._editors.getVisibleTextEditors(!0))if(w.value===I){i=w;break}if(!i)throw new Error("not a visible editor");const h=this,l=this._handlePool++,o=new r.Emitter,m=new r.Emitter,M=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(w){return(0,S.asWebviewUri)(w,h._initData.remote)}get cspSource(){return S.webviewGenericCspSource}set options(w){this._options=w,h._proxy.$setOptions(l,w)}get options(){return this._options}set html(w){this._html=w,h._proxy.$setHtml(l,w)}get html(){return this._html}get onDidReceiveMessage(){return o.event}postMessage(w){return h._proxy.$postMessage(l,w)}},C=new class{constructor(){this.editor=I,this.line=D,this.height=T,this.webview=M,this.onDidDispose=m.event}dispose(){h._insets.has(l)&&(h._insets.delete(l),h._proxy.$disposeEditorInset(l),m.fire(),m.dispose(),o.dispose())}};return this._proxy.$createEditorInset(l,i.id,i.value.document.uri,D+1,T,R||{},b.identifier,b.extensionLocation),this._insets.set(l,{editor:I,inset:C,onDidReceiveMessage:o}),C}$onDidDispose(I){const D=this._insets.get(I);D&&D.inset.dispose()}$onDidReceiveMessage(I,D){const T=this._insets.get(I);T&&T.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=P}),define(ye[154],Se([0,1,125,13,2,6,3,45,37,46,16,11]),function(Z,e,r,t,S,P,A,I,D,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorTabsVisibleContext=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,r.localize)(0,null),providerDisplayName:(0,r.localize)(1,null)},e.ActiveEditorDirtyContext=new I.RawContextKey("activeEditorIsDirty",!1,(0,r.localize)(2,null)),e.ActiveEditorPinnedContext=new I.RawContextKey("activeEditorIsNotPreview",!1,(0,r.localize)(3,null)),e.ActiveEditorStickyContext=new I.RawContextKey("activeEditorIsPinned",!1,(0,r.localize)(4,null)),e.ActiveEditorReadonlyContext=new I.RawContextKey("activeEditorIsReadonly",!1,(0,r.localize)(5,null)),e.ActiveEditorCanRevertContext=new I.RawContextKey("activeEditorCanRevert",!1,(0,r.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new I.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new I.RawContextKey("activeEditor",null,{type:"string",description:(0,r.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new I.RawContextKey("activeEditorAvailableEditorIds","",(0,r.localize)(8,null)),e.TextCompareEditorVisibleContext=new I.RawContextKey("textCompareEditorVisible",!1,(0,r.localize)(9,null)),e.TextCompareEditorActiveContext=new I.RawContextKey("textCompareEditorActive",!1,(0,r.localize)(10,null)),e.SideBySideEditorActiveContext=new I.RawContextKey("sideBySideEditorActive",!1,(0,r.localize)(11,null)),e.EditorGroupEditorsCountContext=new I.RawContextKey("groupEditorsCount",0,(0,r.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new I.RawContextKey("activeEditorGroupEmpty",!1,(0,r.localize)(13,null)),e.ActiveEditorGroupIndexContext=new I.RawContextKey("activeEditorGroupIndex",0,(0,r.localize)(14,null)),e.ActiveEditorGroupLastContext=new I.RawContextKey("activeEditorGroupLast",!1,(0,r.localize)(15,null)),e.ActiveEditorGroupLockedContext=new I.RawContextKey("activeEditorGroupLocked",!1,(0,r.localize)(16,null)),e.MultipleEditorGroupsContext=new I.RawContextKey("multipleEditorGroups",!1,(0,r.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new I.RawContextKey("editorIsOpen",!1,(0,r.localize)(18,null)),e.InEditorZenModeContext=new I.RawContextKey("inZenMode",!1,(0,r.localize)(19,null)),e.IsCenteredLayoutContext=new I.RawContextKey("isCenteredLayout",!1,(0,r.localize)(20,null)),e.SplitEditorsVertically=new I.RawContextKey("splitEditorsVertically",!1,(0,r.localize)(21,null)),e.EditorAreaVisibleContext=new I.RawContextKey("editorAreaVisible",!0,(0,r.localize)(22,null)),e.EditorTabsVisibleContext=new I.RawContextKey("editorTabsVisible",!0,(0,r.localize)(23,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function i(O,U,q){for(const H of q.visibleEditorPanes)if(H.group.id===U&&O.matches(H.input))return H.getViewState()}e.findViewStateForEditor=i;function h(O){if(_(O))return!1;const U=O;return S.URI.isUri(U?.resource)}e.isResourceEditorInput=h;function l(O){if(_(O))return!1;const U=O;return U?.original!==void 0&&U.modified!==void 0}e.isResourceDiffEditorInput=l;function o(O){if(_(O)||l(O))return!1;const U=O;return U?.primary!==void 0&&U.secondary!==void 0}e.isResourceSideBySideEditorInput=o;function m(O){if(_(O))return!1;const U=O;return U?U.resource===void 0||U.resource.scheme===b.Schemas.untitled||U.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=m;var M;(function(O){O[O.SHORT=0]="SHORT",O[O.MEDIUM=1]="MEDIUM",O[O.LONG=2]="LONG"})(M=e.Verbosity||(e.Verbosity={}));var C;(function(O){O[O.EXPLICIT=1]="EXPLICIT",O[O.AUTO=2]="AUTO",O[O.FOCUS_CHANGE=3]="FOCUS_CHANGE",O[O.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(C=e.SaveReason||(e.SaveReason={}));var w;(function(O){O[O.None=0]="None",O[O.Readonly=2]="Readonly",O[O.Untitled=4]="Untitled",O[O.Singleton=8]="Singleton",O[O.RequiresTrust=16]="RequiresTrust",O[O.CanSplitInGroup=32]="CanSplitInGroup",O[O.ForceDescription=64]="ForceDescription"})(w=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class u extends P.Disposable{}e.AbstractEditorInput=u;function _(O){return O instanceof u}e.isEditorInput=_;function a(O){const U=O;return S.URI.isUri(U?.preferredResource)}function F(O){const U=O;return _(U?.primary)&&_(U?.secondary)}e.isSideBySideEditorInput=F;function c(O){const U=O;return _(U?.modified)&&_(U?.original)}e.isDiffEditorInput=c;function n(O){return _(O?.editor)}e.isEditorInputWithOptions=n;function f(O){const U=O;return n(O)&&U?.group!==void 0}e.isEditorInputWithOptionsAndGroup=f;function g(O){const U=O;return typeof U?.groupId=="number"&&_(U.editor)}e.isEditorIdentifier=g;var s;(function(O){O[O.UNKNOWN=0]="UNKNOWN",O[O.REPLACE=1]="REPLACE",O[O.MOVE=2]="MOVE",O[O.UNPIN=3]="UNPIN"})(s=e.EditorCloseContext||(e.EditorCloseContext={}));var d;(function(O){O[O.GROUP_ACTIVE=0]="GROUP_ACTIVE",O[O.GROUP_INDEX=1]="GROUP_INDEX",O[O.GROUP_LOCKED=2]="GROUP_LOCKED",O[O.EDITOR_OPEN=3]="EDITOR_OPEN",O[O.EDITOR_CLOSE=4]="EDITOR_CLOSE",O[O.EDITOR_MOVE=5]="EDITOR_MOVE",O[O.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",O[O.EDITOR_LABEL=7]="EDITOR_LABEL",O[O.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",O[O.EDITOR_PIN=9]="EDITOR_PIN",O[O.EDITOR_STICKY=10]="EDITOR_STICKY",O[O.EDITOR_DIRTY=11]="EDITOR_DIRTY",O[O.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(d=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var p;(function(O){O[O.PRIMARY=1]="PRIMARY",O[O.SECONDARY=2]="SECONDARY",O[O.BOTH=3]="BOTH",O[O.ANY=4]="ANY"})(p=e.SideBySideEditor||(e.SideBySideEditor={}));class E{getOriginalUri(U,q){if(!U)return;if(q?.supportSideBySide){const{primary:z,secondary:j}=this.getSideEditors(U);if(z&&j){if(q?.supportSideBySide===p.BOTH)return{primary:this.getOriginalUri(z,{filterByScheme:q.filterByScheme}),secondary:this.getOriginalUri(j,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===p.ANY)return this.getOriginalUri(z,{filterByScheme:q.filterByScheme})??this.getOriginalUri(j,{filterByScheme:q.filterByScheme});U=q.supportSideBySide===p.PRIMARY?z:j}}if(l(U)||o(U))return;const H=a(U)?U.preferredResource:U.resource;return!H||!q||!q.filterByScheme?H:this.filterUri(H,q.filterByScheme)}getSideEditors(U){return F(U)||o(U)?{primary:U.primary,secondary:U.secondary}:c(U)||l(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,q){if(!U)return;if(q?.supportSideBySide){const{primary:z,secondary:j}=this.getSideEditors(U);if(z&&j){if(q?.supportSideBySide===p.BOTH)return{primary:this.getCanonicalUri(z,{filterByScheme:q.filterByScheme}),secondary:this.getCanonicalUri(j,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===p.ANY)return this.getCanonicalUri(z,{filterByScheme:q.filterByScheme})??this.getCanonicalUri(j,{filterByScheme:q.filterByScheme});U=q.supportSideBySide===p.PRIMARY?z:j}}if(l(U)||o(U))return;const H=U.resource;return!H||!q||!q.filterByScheme?H:this.filterUri(H,q.filterByScheme)}filterUri(U,q){if(Array.isArray(q)){if(q.some(H=>U.scheme===H))return U}else if(q===U.scheme)return U}}e.EditorResourceAccessor=new E;var v;(function(O){O[O.LEFT=0]="LEFT",O[O.RIGHT=1]="RIGHT"})(v=e.CloseDirection||(e.CloseDirection={}));class k{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(U){const q=this.instantiationService=U.get(A.IInstantiationService);for(const[H,z]of this.editorSerializerConstructors)this.createEditorSerializer(H,z,q);this.editorSerializerConstructors.clear()}createEditorSerializer(U,q,H){const z=H.createInstance(q);this.editorSerializerInstances.set(U,z)}registerFileEditorFactory(U){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=U}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(U,q){if(this.editorSerializerConstructors.has(U)||this.editorSerializerInstances.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.instantiationService?this.createEditorSerializer(U,q,this.instantiationService):this.editorSerializerConstructors.set(U,q),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete(U),this.editorSerializerInstances.delete(U)})}getEditorSerializer(U){return this.editorSerializerInstances.get(typeof U=="string"?U:U.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new k);async function L(O,U){if(!O||!O.length)return[];const q=await Promise.all(O.map(async H=>{const z=S.URI.revive(H.fileUri);if(!z||!await U.canHandleResource(z))return;let ie=H.exists,ae=H.type;if(typeof ie!="boolean"||typeof ae!="number")try{ae=(await U.resolve(z)).isDirectory?T.FileType.Directory:T.FileType.Unknown,ie=!0}catch{ie=!1}if(!ie&&H.openOnlyIfExists||ae===T.FileType.Directory)return;const te={selection:ie?H.selection:void 0,pinned:!0,override:H.editorOverrideId};let ue;return ie?ue={resource:z,options:te}:ue={resource:z,options:te,forceUntitled:!0},ue}));return(0,R.coalesce)(q)}e.pathsToEditors=L;var y;(function(O){O[O.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",O[O.SEQUENTIAL=1]="SEQUENTIAL"})(y=e.EditorsOrder||(e.EditorsOrder={}))}),define(ye[155],Se([0,1,4,10,126]),function(Z,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new r.Emitter,this._onExit=new r.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,D,T,R){const b={command:I};if(D&&Object.keys(D).length>0&&(b.arguments=D),this.internalSend("request",b),typeof R=="number"){const i=setTimeout(()=>{clearTimeout(i);const h=this.pendingRequests.get(b.seq);if(h){this.pendingRequests.delete(b.seq);const l={type:"response",seq:0,request_seq:b.seq,success:!1,command:I,message:(0,S.localize)(0,null,R,I)};h(l)}},R)}return T&&this.pendingRequests.set(b.seq,T),b.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,D){return I.type!=="event"||D.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await(0,t.timeout)(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback&&this.eventCallback(I);break;case"request":this.requestCallback&&this.requestCallback(I);break;case"response":{const D=I,T=this.pendingRequests.get(D.request_seq);T&&(this.pendingRequests.delete(D.request_seq),T(D));break}}}}internalSend(I,D){D.type=I,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((D,T)=>I.set(T,D)),await(0,t.timeout)(500),I.forEach((D,T)=>{D({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(T)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(ye[156],Se([0,1,9,2,17,27,11]),function(Z,e,r,t,S,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function D(c,n,f){return c.replace(I,function(g,s){return n&&s.length>0&&s[0]!=="_"?g:f&&f.hasOwnProperty(s)?f[s]:g})}e.formatPII=D;function T(c){const n={};for(const f of Object.keys(c))f.startsWith("!")||(n[f]=c[f]);return n}e.filterExceptionsFromTelemetry=T;function R(c){return c.configuration.request==="attach"&&!b(c)&&(!c.parentSession||R(c.parentSession))}e.isSessionAttach=R;function b(c){let n=c.configuration.type;if(!!n)return n==="vslsShare"&&(n=c.configuration.adapterProxy.configuration.type),(0,r.equalsIgnoreCase)(n,"extensionhost")||(0,r.equalsIgnoreCase)(n,"pwa-extensionhost")?c:c.parentSession?b(c.parentSession):void 0}e.getExtensionHostDebugSession=b;function i(c){return c.type&&(c.label||c.program||c.runtime)}e.isDebuggerMainContribution=i;function h(c,n,f){let g,s=0;const d=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let p=null;for(;p=d.exec(c);){const E=p.index+1,v=E+p[0].length;if(E<=n&&v>=f){g=p[0],s=E;break}}if(g){const E=/\w+/g;let v=null;for(;(v=E.exec(g))&&!(v.index+1+s+v[0].length>=f););v&&(g=g.substring(0,E.lastIndex))}return g?{start:s,end:s+g.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(c){return!!(c&&c.match(l))}e.isUri=o;function m(c){if(typeof c.path=="string"&&!(typeof c.sourceReference=="number"&&c.sourceReference>0)){if(o(c.path))return t.URI.parse(c.path);if((0,S.isAbsolute)(c.path))return t.URI.file(c.path)}return c.path}function M(c){if(typeof c.path=="object"){const n=t.URI.revive(c.path);if(n)return n.scheme===A.Schemas.file?n.fsPath:n.toString()}return c.path}function C(c,n){const f=n?m:M,g=(0,P.deepClone)(c);return u(g,(s,d)=>{s&&d&&(d.path=f(d))}),g}e.convertToDAPaths=C;function w(c,n){const f=n?m:M,g=(0,P.deepClone)(c);return u(g,(s,d)=>{!s&&d&&(d.path=f(d))}),g}e.convertToVSCPaths=w;function u(c,n){switch(c.type){case"event":{const f=c;switch(f.event){case"output":n(!1,f.body.source);break;case"loadedSource":n(!1,f.body.source);break;case"breakpoint":n(!1,f.body.breakpoint.source);break;default:break}break}case"request":{const f=c;switch(f.command){case"setBreakpoints":n(!0,f.arguments.source);break;case"breakpointLocations":n(!0,f.arguments.source);break;case"source":n(!0,f.arguments.source);break;case"gotoTargets":n(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(g=>n(!1,g));break;default:break}break}case"response":{const f=c;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(g=>n(!1,g.source));break;case"loadedSources":f.body.sources.forEach(g=>n(!1,g));break;case"scopes":f.body.scopes.forEach(g=>n(!1,g.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(g=>n(!1,g.source));break;case"setBreakpoints":f.body.breakpoints.forEach(g=>n(!1,g.source));break;default:break}break}}}function _(c){return c.filter(n=>!n.presentation?.hidden).sort((n,f)=>n.presentation?f.presentation?n.presentation.group?f.presentation.group?n.presentation.group!==f.presentation.group?n.presentation.group.localeCompare(f.presentation.group):a(n.presentation.order,f.presentation.order):-1:f.presentation.group?1:a(n.presentation.order,f.presentation.order):-1:f.presentation?1:0)}e.getVisibleAndSorted=_;function a(c,n){return typeof c!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:c-n}async function F(c,n){const f=c.getValue("debug.saveBeforeStart",{overrideIdentifier:n.activeTextEditorLanguageId});if(f!=="none"&&(await n.saveAll(),f==="allEditorsInActiveGroup")){const g=n.activeEditorPane;g&&g.input.resource?.scheme===A.Schemas.untitled&&await n.save({editor:g.input,groupId:g.group.id})}await c.reloadConfiguration()}e.saveAllBeforeDebugStart=F}),define(ye[85],Se([0,1,29,157,74,11,17,23,45]),function(Z,e,r,t,S,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var T;(function(E){E[E.Markup=1]="Markup",E[E.Code=2]="Code"})(T=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",S.Mimes.latex,S.Mimes.markdown,"image/png","image/jpeg",S.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[S.Mimes.latex,S.Mimes.markdown,"application/json",S.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(E){E[E.Running=1]="Running",E[E.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={}));var b;(function(E){E[E.Pending=2]="Pending",E[E.Executing=3]="Executing"})(b=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var i;(function(E){E[E.WithHardKernelDependency=0]="WithHardKernelDependency",E[E.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",E[E.Pure=2]="Pure",E[E.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var h;(function(E){E.Always="always",E.Never="never",E.Optional="optional"})(h=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var l;(function(E){E[E.ModelChange=1]="ModelChange",E[E.Move=2]="Move",E[E.ChangeLanguage=5]="ChangeLanguage",E[E.Initialize=6]="Initialize",E[E.ChangeCellMetadata=7]="ChangeCellMetadata",E[E.Output=8]="Output",E[E.OutputItem=9]="OutputItem",E[E.ChangeCellContent=10]="ChangeCellContent",E[E.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",E[E.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",E[E.ChangeCellMime=13]="ChangeCellMime",E[E.Unknown=100]="Unknown"})(l=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function(E){E[E.Handle=0]="Handle",E[E.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var m;(function(E){E[E.Replace=1]="Replace",E[E.Output=2]="Output",E[E.Metadata=3]="Metadata",E[E.CellLanguage=4]="CellLanguage",E[E.DocumentMetadata=5]="DocumentMetadata",E[E.Move=6]="Move",E[E.OutputItems=7]="OutputItems",E[E.PartialMetadata=8]="PartialMetadata",E[E.PartialInternalMetadata=9]="PartialInternalMetadata"})(m=e.CellEditType||(e.CellEditType={}));var M;(function(E){E.scheme=P.Schemas.vscodeNotebookCell;const v=/^ch(\d{7,})/;function k(H,z){return H.with({scheme:E.scheme,fragment:`ch${z.toString().padStart(7,"0")}${H.scheme!==P.Schemas.file?H.scheme:""}`})}E.generate=k;function L(H){if(H.scheme!==E.scheme)return;const z=v.exec(H.fragment);return z?{handle:Number(z[1]),notebook:H.with({scheme:H.fragment.substring(z[0].length)||P.Schemas.file,fragment:null})}:void 0}E.parse=L;function y(H,z,j){return H.with({scheme:P.Schemas.vscodeNotebookCellOutput,fragment:`ch${z.toString().padStart(7,"0")},${j??""},${H.scheme!==P.Schemas.file?H.scheme:""}`})}E.generateCellOutputUri=y;function O(H){if(H.scheme!==P.Schemas.vscodeNotebookCellOutput)return;const z=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(H.fragment);if(!z)return;const j=Number(z[1]),ie=z[2]&&z[2]!==""?z[2]:void 0,ae=z[3];return{handle:j,outputId:ie,notebook:H.with({scheme:ae||P.Schemas.file,fragment:null})}}E.parseCellOutputUri=O;function U(H,z,j){return H.with({scheme:j,fragment:`ch${z.toString().padStart(7,"0")}${H.scheme!==P.Schemas.file?H.scheme:""}`})}E.generateCellUri=U;function q(H,z){if(H.scheme!==z)return;const j=v.exec(H.fragment);return j?{handle:Number(j[1]),notebook:H.with({scheme:H.fragment.substring(j[0].length)||P.Schemas.file,fragment:null})}:void 0}E.parseCellUri=q})(M=e.CellUri||(e.CellUri={}));const C=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[S.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[S.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function w(E){return C.get(E)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=w;function u(E){return C.get(E)?.supportedByCore??!1}e.mimeTypeSupportedByCore=u;function _(E){return C.get(E)?.mergeable??!1}e.mimeTypeIsMergeable=_;const a=E=>I.isWindows?E.replace(/\//g,"\\"):E;class F{constructor(v=[],k=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=k,this.order=[...new Set(v)].map(L=>({pattern:L,matches:r.parse(a(L))}))}sort(v){const k=new Map(t.Iterable.map(v,y=>[y,a(y)]));let L=[];for(const{matches:y}of this.order)for(const[O,U]of k)if(y(U)){L.push(O),k.delete(O);break}return k.size&&(L=L.concat([...k.keys()].sort((y,O)=>this.defaultOrder.indexOf(y)-this.defaultOrder.indexOf(O)))),L}prioritize(v,k){const L=this.findIndex(v);if(L===-1){this.order.unshift({pattern:v,matches:r.parse(a(v))});return}const y=new Set(k.map(U=>this.findIndex(U,L)));y.delete(-1);const O=Array.from(y).sort();this.order.splice(L+1,0,...O.map(U=>this.order[U]));for(let U=O.length-1;U>=0;U--)this.order.splice(O[U],1)}toArray(){return this.order.map(v=>v.pattern)}findIndex(v,k=this.order.length){const L=a(v);for(let y=0;y<k;y++)if(this.order[y].matches(L))return y;return-1}}e.MimeTypeDisplayOrder=F;function c(E,v,k,L=(y,O)=>y===O){const y=[];function O(H,z,j){if(z===0&&j.length===0)return;const ie=y[y.length-1];ie&&ie.start+ie.deleteCount===H?(ie.deleteCount+=z,ie.toInsert.push(...j)):y.push({start:H,deleteCount:z,toInsert:j})}let U=0,q=0;for(;;){if(U===E.length){O(U,0,v.slice(q));break}if(q===v.length){O(U,E.length-U,[]);break}const H=E[U],z=v[q];if(L(H,z)){U+=1,q+=1;continue}k(z)?(O(U,1,[]),U+=1):(O(U,0,[z]),q+=1)}return y}e.diff=c,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(E){E.default="default",E.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function f(E){const v=E;return!!((typeof v.include=="string"||r.isRelativePattern(v.include))&&(typeof v.exclude=="string"||r.isRelativePattern(v.exclude)))}e.isDocumentExcludePattern=f;function g(E,v,k){if(Array.isArray(E.viewType)&&E.viewType.indexOf(v)>=0||E.viewType===v)return!0;if(E.filenamePattern){const L=f(E.filenamePattern)?E.filenamePattern.include:E.filenamePattern,y=f(E.filenamePattern)?E.filenamePattern.exclude:void 0;if(r.match(L,(0,A.basename)(k.fsPath).toLowerCase()))return!(y&&r.match(y,(0,A.basename)(k.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=g;class s{constructor(v){this.textModel=v}getElements(){const v=new Int32Array(this.textModel.cells.length);for(let k=0;k<this.textModel.cells.length;k++)v[k]=this.textModel.cells[k].getHashValue();return v}}e.CellSequence=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var d;(function(E){E[E.Left=1]="Left",E[E.Right=2]="Right"})(d=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class p{static create(v){return`${p._prefix}${v}`}static parse(v){if(v.startsWith(p._prefix))return v.substring(p._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=p,p._prefix="notebook/"}),define(ye[158],Se([0,1,3]),function(Z,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(S){S[S.Output=1]="Output",S[S.OutputItems=2]="OutputItems",S[S.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,r.createDecorator)("INotebookExecutionService")}),define(ye[159],Se([0,1,3,45]),function(Z,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new t.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new t.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new t.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,r.createDecorator)(e.OUTPUT_SERVICE_ID);var S;(function(P){P[P.Append=1]="Append",P[P.Replace=2]="Replace",P[P.Clear=3]="Clear"})(S=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(ye[160],Se([0,1,128,3,45]),function(Z,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new S.RawContextKey("customExecutionSupported",!0,r.localize(0,null)),e.ShellExecutionSupportedContext=new S.RawContextKey("shellExecutionSupported",!1,r.localize(1,null)),e.ProcessExecutionSupportedContext=new S.RawContextKey("processExecutionSupported",!1,r.localize(2,null)),e.ITaskService=(0,t.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ye[161],Se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function r(S){return[...S.entries()]}e.serializeEnvironmentVariableCollection=r;function t(S){return new Map(S)}e.deserializeEnvironmentVariableCollection=t}),define(ye[86],Se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var r;(function(b){b[b.Unset=0]="Unset",b[b.Queued=1]="Queued",b[b.Running=2]="Running",b[b.Passed=3]="Passed",b[b.Failed=4]="Failed",b[b.Skipped=5]="Skipped",b[b.Errored=6]="Errored"})(r=e.TestResultState||(e.TestResultState={}));var t;(function(b){b[b.Run=2]="Run",b[b.Debug=4]="Debug",b[b.Coverage=8]="Coverage",b[b.HasNonDefaultProfile=16]="HasNonDefaultProfile",b[b.HasConfigurable=32]="HasConfigurable"})(t=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var S;(function(b){b[b.Error=0]="Error",b[b.Info=1]="Info"})(S=e.TestMessageType||(e.TestMessageType={}));var P;(function(b){b[b.NotExpandable=0]="NotExpandable",b[b.Expandable=1]="Expandable",b[b.BusyExpanding=2]="BusyExpanding",b[b.Expanded=3]="Expanded"})(P=e.TestItemExpandState||(e.TestItemExpandState={}));const A=(b,i)=>{i.expand!==void 0&&(b.expand=i.expand),i.item!==void 0&&(b.item=b.item?Object.assign(b.item,i.item):i.item)};e.applyTestItemUpdate=A;var I;(function(b){b[b.Function=0]="Function",b[b.Statement=1]="Statement"})(I=e.DetailType||(e.DetailType={}));var D;(function(b){b[b.Add=0]="Add",b[b.Update=1]="Update",b[b.Remove=2]="Remove",b[b.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",b[b.Retire=4]="Retire",b[b.AddTag=5]="AddTag",b[b.RemoveTag=6]="RemoveTag"})(D=e.TestDiffOpType||(e.TestDiffOpType={}));class T{add(i){}update(i){}remove(i,h){}complete(){}}e.IncrementalChangeCollector=T;class R{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(i){const h=this.createChangeCollector();for(const l of i)switch(l[0]){case 0:{const o=l[1];if(o.parent){if(this.items.has(o.parent)){const m=this.items.get(o.parent);m.children.add(o.item.extId);const M=this.createItem(o,m);this.items.set(o.item.extId,M),h.add(M)}}else{const m=this.createItem(o);this.roots.add(m),this.items.set(o.item.extId,m),h.add(m)}o.expand===2&&this.busyControllerCount++;break}case 1:{const o=l[1],m=this.items.get(o.extId);if(!m)break;o.expand!==void 0&&(m.expand===2&&this.busyControllerCount--,o.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(m,o),h.update(m);break}case 2:{const o=this.items.get(l[1]);if(!o)break;o.parent?this.items.get(o.parent).children.delete(o.item.extId):this.roots.delete(o);const m=[[l[1]]];for(;m.length;)for(const M of m.pop()){const C=this.items.get(M);C&&(m.push(C.children),this.items.delete(M),h.remove(C,C!==o),C.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(l[1]);break;case 3:this.updatePendingRoots(l[1]);break;case 5:this._tags.set(l[1].id,l[1]);break;case 6:this._tags.delete(l[1]);break}h.complete()}retireTest(i){}updatePendingRoots(i){this.pendingRootCount+=i}createChangeCollector(){return new T}}e.AbstractIncrementalTestCollection=R}),define(ye[66],Se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(P){P.Delimiter="\0"})(r=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class S{constructor(A,I=A.length){if(this.path=A,this.viewEnd=I,A.length===0||I<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(A,I,D=A.parent){if(A.id===I)return new S([I]);let T=[A.id];for(let R=D;R&&R.id!==I;R=R.parent)T.push(R.id);return T.push(I),new S(T.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const I=A.indexOf("\0");return I===-1?A:A.slice(0,I)}static fromString(A){return new S(A.split("\0"))}static join(A,I){return new S([...A.path,I])}static joinToString(A,I){return A.toString()+"\0"+I}static compare(A,I){return A===I?0:I.startsWith(A+"\0")?2:A.startsWith(I+"\0")?3:1}get parentId(){return this.viewEnd>1?new S(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let A=1;A<=this.viewEnd;A++)yield new S(this.path,A)}compare(A){if(typeof A=="string")return S.compare(this.toString(),A);for(let I=0;I<A.viewEnd&&I<this.viewEnd;I++)if(A.path[I]!==this.path[I])return 1;return A.viewEnd>this.viewEnd?2:A.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let A=1;A<this.viewEnd;A++)this.stringifed+="\0",this.stringifed+=this.path[A]}return this.stringifed}}e.TestId=S}),define(ye[162],Se([0,1,17,87,13,27,23,76,129]),function(Z,e,r,t,S,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(b,i,h){this._contributedVariables=new Map,this._context=b,this._labelService=i,h&&(this._envVariablesPromise=h.then(l=>this.prepareEnv(l)))}prepareEnv(b){if(A.isWindows){const i=Object.create(null);return Object.keys(b).forEach(h=>{i[h.toLowerCase()]=b[h]}),i}return b}resolveWithEnvironment(b,i,h){return this.recursiveResolve(this.prepareEnv(b),i?i.uri:void 0,h)}async resolveAsync(b,i){return this.recursiveResolve(await this._envVariablesPromise,b?b.uri:void 0,i)}async resolveAnyBase(b,i,h,l){const o=P.deepClone(i);return A.isWindows&&o.windows?Object.keys(o.windows).forEach(m=>o[m]=o.windows[m]):A.isMacintosh&&o.osx?Object.keys(o.osx).forEach(m=>o[m]=o.osx[m]):A.isLinux&&o.linux&&Object.keys(o.linux).forEach(m=>o[m]=o.linux[m]),delete o.windows,delete o.osx,delete o.linux,this.recursiveResolve(await this._envVariablesPromise,b?b.uri:void 0,o,h,l)}async resolveAnyAsync(b,i,h){return this.resolveAnyBase(b,i,h)}async resolveAnyMap(b,i,h){const l=new Map;return{newConfig:await this.resolveAnyBase(b,i,h,l),resolvedVariables:l}}resolveWithInteractionReplace(b,i,h,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,i,h,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,i){if(this._contributedVariables.has(b))throw new Error("Variable "+b+" is contributed twice.");this._contributedVariables.set(b,i)}recursiveResolve(b,i,h,l,o){if(S.isString(h))return this.resolveString(b,i,h,l,o);if(S.isArray(h))return h.map(m=>this.recursiveResolve(b,i,m,l,o));if(S.isObject(h)){let m=Object.create(null);return Object.keys(h).forEach(M=>{const C=this.resolveString(b,i,M,l,o);m[C]=this.recursiveResolve(b,i,h[M],l,o)}),m}return h}resolveString(b,i,h,l,o){return h.replace(T.VARIABLE_REGEXP,(M,C)=>{if(C.includes(T.VARIABLE_LHS))return M;let w=this.evaluateSingleVariable(b,M,C,i,l);return o&&o.set(C,w),w!==M&&S.isString(w)&&w.match(T.VARIABLE_REGEXP)&&(w=this.resolveString(b,i,w,l,o)),w})}fsPath(b){return this._labelService?this._labelService.getUriLabel(b,{noPrefix:!0}):b.fsPath}evaluateSingleVariable(b,i,h,l,o){let m;const M=h.split(":");M.length>1&&(h=M[0],m=M[1]);const C=()=>{const _=this._context.getFilePath();if(_)return _;throw new Error((0,D.localize)(0,null,i))},w=()=>{const _=C();if(this._context.getWorkspaceFolderPathForFile){const a=this._context.getWorkspaceFolderPathForFile();if(a)return a}throw new Error((0,D.localize)(1,null,i,r.basename(_)))},u=()=>{if(m){const _=this._context.getFolderUri(m);if(_)return _;throw new Error((0,D.localize)(2,null,i,m))}if(l)return l;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,i)):new Error((0,D.localize)(4,null,i))};switch(h){case"env":if(m){if(b){const _=b[A.isWindows?m.toLowerCase():m];if(S.isString(_))return _}return""}throw new Error((0,D.localize)(5,null,i));case"config":if(m){const _=this._context.getConfigurationValue(l,m);if(S.isUndefinedOrNull(_))throw new Error((0,D.localize)(6,null,i,m));if(S.isObject(_))throw new Error((0,D.localize)(7,null,i,m));return _}throw new Error((0,D.localize)(8,null,i));case"command":return this.resolveFromMap(i,m,o,"command");case"input":return this.resolveFromMap(i,m,o,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(u()));case"cwd":return l||m?(0,I.normalizeDriveLetter)(this.fsPath(u())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return r.basename(this.fsPath(u()));case"lineNumber":{const _=this._context.getLineNumber();if(_)return _;throw new Error((0,D.localize)(9,null,i))}case"selectedText":{const _=this._context.getSelectedText();if(_)return _;throw new Error((0,D.localize)(10,null,i))}case"file":return C();case"fileWorkspaceFolder":return w();case"relativeFile":return l||m?r.relative(this.fsPath(u()),C()):C();case"relativeFileDirname":{const _=r.dirname(C());if(l||m){const a=r.relative(this.fsPath(u()),_);return a.length===0?".":a}return _}case"fileDirname":return r.dirname(C());case"fileExtname":return r.extname(C());case"fileBasename":return r.basename(C());case"fileBasenameNoExtension":{const _=r.basename(C());return _.slice(0,_.length-r.extname(_).length)}case"fileDirnameBasename":return r.basename(r.dirname(C()));case"execPath":{const _=this._context.getExecPath();return _||i}case"execInstallFolder":{const _=this._context.getAppRoot();return _||i}case"pathSeparator":return r.sep;default:try{const _=m?`${h}:${m}`:h;return this.resolveFromMap(i,_,o,void 0)}catch{return i}}}}resolveFromMap(b,i,h,l){if(i&&h){const o=l===void 0?h[i]:h[l+":"+i];if(typeof o=="string")return o;throw new Error((0,D.localize)(11,null,b))}return b}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ye[88],Se([0,1,3,154]),function(Z,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,r.createDecorator)("editorGroupsService");var S;(function(l){l[l.UP=0]="UP",l[l.DOWN=1]="DOWN",l[l.LEFT=2]="LEFT",l[l.RIGHT=3]="RIGHT"})(S=e.GroupDirection||(e.GroupDirection={}));var P;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(l){l[l.FIRST=0]="FIRST",l[l.LAST=1]="LAST",l[l.NEXT=2]="NEXT",l[l.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var I;(function(l){l[l.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",l[l.EVEN=1]="EVEN",l[l.TOGGLE=2]="TOGGLE"})(I=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(l){l[l.COPY_EDITORS=0]="COPY_EDITORS",l[l.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));function T(l){const o=l;return(0,t.isEditorInput)(o?.editor)&&(0,t.isEditorInput)(o?.replacement)}e.isEditorReplacement=T;var R;(function(l){l[l.CREATION_TIME=0]="CREATION_TIME",l[l.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",l[l.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var b;(function(l){l[l.NEW_EDITOR=1]="NEW_EDITOR",l[l.MOVE_EDITOR=2]="MOVE_EDITOR",l[l.COPY_EDITOR=3]="COPY_EDITOR"})(b=e.OpenEditorContext||(e.OpenEditorContext={}));function i(l){const o=l;return!!o&&typeof o.id=="number"&&Array.isArray(o.editors)}e.isEditorGroup=i;function h(l){return l.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=h}),define(ye[163],Se([0,1,3,88]),function(Z,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,r.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function S(P){const A=P;return typeof P=="number"||(0,t.isEditorGroup)(A)}e.isPreferredGroup=S}),define(ye[8],Se([0,1,16,21,75,225,55,27,13,2,58,57,130,80,48,85,66,163,7]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i,h,l,o,m,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var w;(function(ce){function fe(W){const{selectionStartLineNumber:we,selectionStartColumn:Re,positionLineNumber:We,positionColumn:He}=W,mt=new C.Position(we-1,Re-1),Et=new C.Position(We-1,He-1);return new C.Selection(mt,Et)}ce.to=fe;function re(W){const{anchor:we,active:Re}=W;return{selectionStartLineNumber:we.line+1,selectionStartColumn:we.character+1,positionLineNumber:Re.line+1,positionColumn:Re.character+1}}ce.from=re})(w=e.Selection||(e.Selection={}));var u;(function(ce){function fe(W){if(!W)return;const{start:we,end:Re}=W;return{startLineNumber:we.line+1,startColumn:we.character+1,endLineNumber:Re.line+1,endColumn:Re.character+1}}ce.from=fe;function re(W){if(!W)return;const{startLineNumber:we,startColumn:Re,endLineNumber:We,endColumn:He}=W;return new C.Range(we-1,Re-1,We-1,He-1)}ce.to=re})(u=e.Range||(e.Range={}));var _;(function(ce){function fe(re){switch(re){case 1:return C.StandardTokenType.Comment;case 0:return C.StandardTokenType.Other;case 3:return C.StandardTokenType.RegEx;case 2:return C.StandardTokenType.String}}ce.to=fe})(_=e.TokenType||(e.TokenType={}));var a;(function(ce){function fe(W){return new C.Position(W.lineNumber-1,W.column-1)}ce.to=fe;function re(W){return{lineNumber:W.line+1,column:W.character+1}}ce.from=re})(a=e.Position||(e.Position={}));var F;(function(ce){function fe(we,Re){return(0,r.coalesce)((0,r.asArray)(we).map(We=>re(We,Re)))}ce.from=fe;function re(we,Re){if(typeof we=="string")return{$serialized:!0,language:we};if(we)return{$serialized:!0,language:we.language,scheme:W(we.scheme,Re),pattern:he.from(we.pattern)??void 0,exclusive:we.exclusive}}function W(we,Re){return Re&&typeof we=="string"?Re.transformOutgoingScheme(we):we}})(F=e.DocumentSelector||(e.DocumentSelector={}));var c;(function(ce){function fe(W){switch(W){case C.DiagnosticTag.Unnecessary:return 1;case C.DiagnosticTag.Deprecated:return 2}}ce.from=fe;function re(W){switch(W){case 1:return C.DiagnosticTag.Unnecessary;case 2:return C.DiagnosticTag.Deprecated;default:return}}ce.to=re})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var n;(function(ce){function fe(W){let we;return W.code&&((0,D.isString)(W.code)||(0,D.isNumber)(W.code)?we=String(W.code):we={value:String(W.code.value),target:W.code.target}),{...u.from(W.range),message:W.message,source:W.source,code:we,severity:g.from(W.severity),relatedInformation:W.relatedInformation&&W.relatedInformation.map(f.from),tags:Array.isArray(W.tags)?(0,r.coalesce)(W.tags.map(c.from)):void 0}}ce.from=fe;function re(W){const we=new C.Diagnostic(u.to(W),W.message,g.to(W.severity));return we.source=W.source,we.code=(0,D.isString)(W.code)?W.code:W.code?.value,we.relatedInformation=W.relatedInformation&&W.relatedInformation.map(f.to),we.tags=W.tags&&(0,r.coalesce)(W.tags.map(c.to)),we}ce.to=re})(n=e.Diagnostic||(e.Diagnostic={}));var f;(function(ce){function fe(W){return{...u.from(W.location.range),message:W.message,resource:W.location.uri}}ce.from=fe;function re(W){return new C.DiagnosticRelatedInformation(new C.Location(W.resource,u.to(W)),W.message)}ce.to=re})(f=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var g;(function(ce){function fe(W){switch(W){case C.DiagnosticSeverity.Error:return h.MarkerSeverity.Error;case C.DiagnosticSeverity.Warning:return h.MarkerSeverity.Warning;case C.DiagnosticSeverity.Information:return h.MarkerSeverity.Info;case C.DiagnosticSeverity.Hint:return h.MarkerSeverity.Hint}return h.MarkerSeverity.Error}ce.from=fe;function re(W){switch(W){case h.MarkerSeverity.Info:return C.DiagnosticSeverity.Information;case h.MarkerSeverity.Warning:return C.DiagnosticSeverity.Warning;case h.MarkerSeverity.Error:return C.DiagnosticSeverity.Error;case h.MarkerSeverity.Hint:return C.DiagnosticSeverity.Hint;default:return C.DiagnosticSeverity.Error}}ce.to=re})(g=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(ce){function fe(W){return typeof W=="number"&&W>=C.ViewColumn.One?W-1:W===C.ViewColumn.Beside?M.SIDE_GROUP:M.ACTIVE_GROUP}ce.from=fe;function re(W){if(typeof W=="number"&&W>=0)return W+1;throw new Error("invalid 'EditorGroupColumn'")}ce.to=re})(s=e.ViewColumn||(e.ViewColumn={}));function d(ce){return typeof ce.range!="undefined"}function p(ce){return ce.length===0?!0:!!d(ce[0])}e.isDecorationOptionsArr=p;var E;(function(ce){function fe(He){return He.map(ce.from)}ce.fromMany=fe;function re(He){return He&&typeof He=="object"&&typeof He.language=="string"&&typeof He.value=="string"}function W(He){let mt;if(re(He)){const{language:vt,value:bt}=He;mt={value:"```"+vt+`
`+bt+"\n```\n"}}else C.MarkdownString.isMarkdownString(He)?mt={value:He.value,isTrusted:He.isTrusted,supportThemeIcons:He.supportThemeIcons,supportHtml:He.supportHtml}:typeof He=="string"?mt={value:He}:mt={value:""};const Et=Object.create(null);mt.uris=Et;const St=vt=>{try{let bt=T.URI.parse(vt,!0);bt=bt.with({query:we(bt.query,Et)}),Et[vt]=bt}catch{}return""},dt=new P.Renderer;return dt.link=St,dt.image=vt=>St(S.parseHrefAndDimensions(vt).href),P(mt.value,{renderer:dt}),mt}ce.from=W;function we(He,mt){if(!He)return He;let Et;try{Et=(0,A.parse)(He)}catch{}if(!Et)return He;let St=!1;return Et=(0,I.cloneAndChange)(Et,dt=>{if(T.URI.isUri(dt)){const vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return mt[vt]=dt,St=!0,vt}else return}),St?JSON.stringify(Et):He}function Re(He){const mt=new C.MarkdownString(He.value,He.supportThemeIcons);return mt.isTrusted=He.isTrusted,mt.supportHtml=He.supportHtml,mt}ce.to=Re;function We(He){if(!!He)return typeof He=="string"?He:ce.from(He)}ce.fromStrict=We})(E=e.MarkdownString||(e.MarkdownString={}));function v(ce){return p(ce)?ce.map(fe=>({range:u.from(fe.range),hoverMessage:Array.isArray(fe.hoverMessage)?E.fromMany(fe.hoverMessage):fe.hoverMessage?E.from(fe.hoverMessage):void 0,renderOptions:fe.renderOptions})):ce.map(fe=>({range:u.from(fe)}))}e.fromRangeOrRangeWithMessage=v;function k(ce){return typeof ce=="undefined"?ce:typeof ce=="string"?T.URI.file(ce):ce}e.pathOrURIToURI=k;var L;(function(ce){function fe(re){return typeof re=="undefined"?re:{contentText:re.contentText,contentIconPath:re.contentIconPath?k(re.contentIconPath):void 0,border:re.border,borderColor:re.borderColor,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,color:re.color,backgroundColor:re.backgroundColor,margin:re.margin,width:re.width,height:re.height}}ce.from=fe})(L=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var y;(function(ce){function fe(re){return typeof re=="undefined"?re:{backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?k(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?L.from(re.before):void 0,after:re.after?L.from(re.after):void 0}}ce.from=fe})(y=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var O;(function(ce){function fe(re){if(typeof re=="undefined")return re;switch(re){case C.DecorationRangeBehavior.OpenOpen:return 0;case C.DecorationRangeBehavior.ClosedClosed:return 1;case C.DecorationRangeBehavior.OpenClosed:return 2;case C.DecorationRangeBehavior.ClosedOpen:return 3}}ce.from=fe})(O=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var U;(function(ce){function fe(re){return{isWholeLine:re.isWholeLine,rangeBehavior:re.rangeBehavior?O.from(re.rangeBehavior):void 0,overviewRulerLane:re.overviewRulerLane,light:re.light?y.from(re.light):void 0,dark:re.dark?y.from(re.dark):void 0,backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?k(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?L.from(re.before):void 0,after:re.after?L.from(re.after):void 0}}ce.from=fe})(U=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var q;(function(ce){function fe(W){return{text:W.newText,eol:W.newEol&&pt.from(W.newEol),range:u.from(W.range)}}ce.from=fe;function re(W){const we=new C.TextEdit(u.to(W.range),W.text);return we.newEol=typeof W.eol=="undefined"?void 0:pt.to(W.eol),we}ce.to=re})(q=e.TextEdit||(e.TextEdit={}));var H;(function(ce){function fe(W,we,Re){const We={edits:[]};if(W instanceof C.WorkspaceEdit)for(let He of W._allEntries())if(He._type===1)We.edits.push({_type:1,oldUri:He.from,newUri:He.to,options:He.options,metadata:He.metadata});else if(He._type===2){const mt=we?.getDocument(He.uri);We.edits.push({_type:2,resource:He.uri,edit:q.from(He.edit),modelVersionId:mt?.version,metadata:He.metadata})}else He._type===3?We.edits.push({_type:3,metadata:He.metadata,resource:He.uri,edit:He.edit,notebookMetadata:He.notebookMetadata,notebookVersionId:Re?.getNotebookDocument(He.uri,!0)?.apiNotebook.version}):He._type===5&&We.edits.push({_type:3,metadata:He.metadata,resource:He.uri,notebookVersionId:Re?.getNotebookDocument(He.uri,!0)?.apiNotebook.version,edit:{editType:1,index:He.index,count:He.count,cells:He.cells.map(kt.from)}});return We}ce.from=fe;function re(W){const we=new C.WorkspaceEdit;for(const Re of W.edits)Re.edit?we.replace(T.URI.revive(Re.resource),u.to(Re.edit.range),Re.edit.text):we.renameFile(T.URI.revive(Re.oldUri),T.URI.revive(Re.newUri),Re.options);return we}ce.to=re})(H=e.WorkspaceEdit||(e.WorkspaceEdit={}));var z;(function(ce){const fe=Object.create(null);fe[C.SymbolKind.File]=0,fe[C.SymbolKind.Module]=1,fe[C.SymbolKind.Namespace]=2,fe[C.SymbolKind.Package]=3,fe[C.SymbolKind.Class]=4,fe[C.SymbolKind.Method]=5,fe[C.SymbolKind.Property]=6,fe[C.SymbolKind.Field]=7,fe[C.SymbolKind.Constructor]=8,fe[C.SymbolKind.Enum]=9,fe[C.SymbolKind.Interface]=10,fe[C.SymbolKind.Function]=11,fe[C.SymbolKind.Variable]=12,fe[C.SymbolKind.Constant]=13,fe[C.SymbolKind.String]=14,fe[C.SymbolKind.Number]=15,fe[C.SymbolKind.Boolean]=16,fe[C.SymbolKind.Array]=17,fe[C.SymbolKind.Object]=18,fe[C.SymbolKind.Key]=19,fe[C.SymbolKind.Null]=20,fe[C.SymbolKind.EnumMember]=21,fe[C.SymbolKind.Struct]=22,fe[C.SymbolKind.Event]=23,fe[C.SymbolKind.Operator]=24,fe[C.SymbolKind.TypeParameter]=25;function re(we){return typeof fe[we]=="number"?fe[we]:6}ce.from=re;function W(we){for(const Re in fe)if(fe[Re]===we)return Number(Re);return C.SymbolKind.Property}ce.to=W})(z=e.SymbolKind||(e.SymbolKind={}));var j;(function(ce){function fe(W){switch(W){case C.SymbolTag.Deprecated:return 1}}ce.from=fe;function re(W){switch(W){case 1:return C.SymbolTag.Deprecated}}ce.to=re})(j=e.SymbolTag||(e.SymbolTag={}));var ie;(function(ce){function fe(W){return{name:W.name,kind:z.from(W.kind),tags:W.tags&&W.tags.map(j.from),containerName:W.containerName,location:pe.from(W.location)}}ce.from=fe;function re(W){const we=new C.SymbolInformation(W.name,z.to(W.kind),W.containerName,pe.to(W.location));return we.tags=W.tags&&W.tags.map(j.to),we}ce.to=re})(ie=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var ae;(function(ce){function fe(W){const we={name:W.name||"!!MISSING: name!!",detail:W.detail,range:u.from(W.range),selectionRange:u.from(W.selectionRange),kind:z.from(W.kind),tags:W.tags?.map(j.from)??[]};return W.children&&(we.children=W.children.map(fe)),we}ce.from=fe;function re(W){const we=new C.DocumentSymbol(W.name,W.detail,z.to(W.kind),u.to(W.range),u.to(W.selectionRange));return(0,r.isNonEmptyArray)(W.tags)&&(we.tags=W.tags.map(j.to)),W.children&&(we.children=W.children.map(re)),we}ce.to=re})(ae=e.DocumentSymbol||(e.DocumentSymbol={}));var te;(function(ce){function fe(W){const we=new C.CallHierarchyItem(z.to(W.kind),W.name,W.detail||"",T.URI.revive(W.uri),u.to(W.range),u.to(W.selectionRange));return we._sessionId=W._sessionId,we._itemId=W._itemId,we}ce.to=fe;function re(W,we,Re){if(we=we??W._sessionId,Re=Re??W._itemId,we===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:Re,name:W.name,detail:W.detail,kind:z.from(W.kind),uri:W.uri,range:u.from(W.range),selectionRange:u.from(W.selectionRange),tags:W.tags?.map(j.from)}}ce.from=re})(te=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ue;(function(ce){function fe(re){return new C.CallHierarchyIncomingCall(te.to(re.from),re.fromRanges.map(W=>u.to(W)))}ce.to=fe})(ue=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var be;(function(ce){function fe(re){return new C.CallHierarchyOutgoingCall(te.to(re.to),re.fromRanges.map(W=>u.to(W)))}ce.to=fe})(be=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var pe;(function(ce){function fe(W){return{range:W.range&&u.from(W.range),uri:W.uri}}ce.from=fe;function re(W){return new C.Location(T.URI.revive(W.uri),u.to(W.range))}ce.to=re})(pe=e.location||(e.location={}));var me;(function(ce){function fe(W){const we=W,Re=W;return{originSelectionRange:we.originSelectionRange?u.from(we.originSelectionRange):void 0,uri:we.targetUri?we.targetUri:Re.uri,range:u.from(we.targetRange?we.targetRange:Re.range),targetSelectionRange:we.targetSelectionRange?u.from(we.targetSelectionRange):void 0}}ce.from=fe;function re(W){return{targetUri:T.URI.revive(W.uri),targetRange:u.to(W.range),targetSelectionRange:W.targetSelectionRange?u.to(W.targetSelectionRange):void 0,originSelectionRange:W.originSelectionRange?u.to(W.originSelectionRange):void 0}}ce.to=re})(me=e.DefinitionLink||(e.DefinitionLink={}));var oe;(function(ce){function fe(W){return{range:u.from(W.range),contents:E.fromMany(W.contents)}}ce.from=fe;function re(W){return new C.Hover(W.contents.map(E.to),u.to(W.range))}ce.to=re})(oe=e.Hover||(e.Hover={}));var Ee;(function(ce){function fe(W){return{range:u.from(W.range),expression:W.expression}}ce.from=fe;function re(W){return new C.EvaluatableExpression(u.to(W.range),W.expression)}ce.to=re})(Ee=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Pe;(function(ce){function fe(W){if(W instanceof C.InlineValueText)return{type:"text",range:u.from(W.range),text:W.text};if(W instanceof C.InlineValueVariableLookup)return{type:"variable",range:u.from(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};if(W instanceof C.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(W.range),expression:W.expression};throw new Error("Unknown 'InlineValue' type")}ce.from=fe;function re(W){switch(W.type){case"text":return{range:u.to(W.range),text:W.text};case"variable":return{range:u.to(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};case"expression":return{range:u.to(W.range),expression:W.expression}}}ce.to=re})(Pe=e.InlineValue||(e.InlineValue={}));var Oe;(function(ce){function fe(W){return{frameId:W.frameId,stoppedLocation:u.from(W.stoppedLocation)}}ce.from=fe;function re(W){return new C.InlineValueContext(W.frameId,u.to(W.stoppedLocation))}ce.to=re})(Oe=e.InlineValueContext||(e.InlineValueContext={}));var je;(function(ce){function fe(W){return{range:u.from(W.range),kind:W.kind}}ce.from=fe;function re(W){return new C.DocumentHighlight(u.to(W.range),W.kind)}ce.to=re})(je=e.DocumentHighlight||(e.DocumentHighlight={}));var st;(function(ce){function fe(re){switch(re){case 1:return C.CompletionTriggerKind.TriggerCharacter;case 2:return C.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return C.CompletionTriggerKind.Invoke}}ce.to=fe})(st=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var et;(function(ce){function fe(re){return{triggerKind:st.to(re.triggerKind),triggerCharacter:re.triggerCharacter}}ce.to=fe})(et=e.CompletionContext||(e.CompletionContext={}));var tt;(function(ce){function fe(W){switch(W){case C.CompletionItemTag.Deprecated:return 1}}ce.from=fe;function re(W){switch(W){case 1:return C.CompletionItemTag.Deprecated}}ce.to=re})(tt=e.CompletionItemTag||(e.CompletionItemTag={}));var $;(function(ce){const fe=new Map([[C.CompletionItemKind.Method,0],[C.CompletionItemKind.Function,1],[C.CompletionItemKind.Constructor,2],[C.CompletionItemKind.Field,3],[C.CompletionItemKind.Variable,4],[C.CompletionItemKind.Class,5],[C.CompletionItemKind.Interface,7],[C.CompletionItemKind.Struct,6],[C.CompletionItemKind.Module,8],[C.CompletionItemKind.Property,9],[C.CompletionItemKind.Unit,12],[C.CompletionItemKind.Value,13],[C.CompletionItemKind.Constant,14],[C.CompletionItemKind.Enum,15],[C.CompletionItemKind.EnumMember,16],[C.CompletionItemKind.Keyword,17],[C.CompletionItemKind.Snippet,27],[C.CompletionItemKind.Text,18],[C.CompletionItemKind.Color,19],[C.CompletionItemKind.File,20],[C.CompletionItemKind.Reference,21],[C.CompletionItemKind.Folder,23],[C.CompletionItemKind.Event,10],[C.CompletionItemKind.Operator,11],[C.CompletionItemKind.TypeParameter,24],[C.CompletionItemKind.Issue,26],[C.CompletionItemKind.User,25]]);function re(Re){return fe.get(Re)??9}ce.from=re;const W=new Map([[0,C.CompletionItemKind.Method],[1,C.CompletionItemKind.Function],[2,C.CompletionItemKind.Constructor],[3,C.CompletionItemKind.Field],[4,C.CompletionItemKind.Variable],[5,C.CompletionItemKind.Class],[7,C.CompletionItemKind.Interface],[6,C.CompletionItemKind.Struct],[8,C.CompletionItemKind.Module],[9,C.CompletionItemKind.Property],[12,C.CompletionItemKind.Unit],[13,C.CompletionItemKind.Value],[14,C.CompletionItemKind.Constant],[15,C.CompletionItemKind.Enum],[16,C.CompletionItemKind.EnumMember],[17,C.CompletionItemKind.Keyword],[27,C.CompletionItemKind.Snippet],[18,C.CompletionItemKind.Text],[19,C.CompletionItemKind.Color],[20,C.CompletionItemKind.File],[21,C.CompletionItemKind.Reference],[23,C.CompletionItemKind.Folder],[10,C.CompletionItemKind.Event],[11,C.CompletionItemKind.Operator],[24,C.CompletionItemKind.TypeParameter],[25,C.CompletionItemKind.User],[26,C.CompletionItemKind.Issue]]);function we(Re){return W.get(Re)??C.CompletionItemKind.Property}ce.to=we})($=e.CompletionItemKind||(e.CompletionItemKind={}));var K;(function(ce){function fe(re,W){const we=new C.CompletionItem(re.label);return we.insertText=re.insertText,we.kind=$.to(re.kind),we.tags=re.tags?.map(tt.to),we.detail=re.detail,we.documentation=S.isMarkdownString(re.documentation)?E.to(re.documentation):re.documentation,we.sortText=re.sortText,we.filterText=re.filterText,we.preselect=re.preselect,we.commitCharacters=re.commitCharacters,R.Range.isIRange(re.range)?we.range=u.to(re.range):typeof re.range=="object"&&(we.range={inserting:u.to(re.range.insert),replacing:u.to(re.range.replace)}),we.keepWhitespace=typeof re.insertTextRules=="undefined"?!1:Boolean(re.insertTextRules&1),typeof re.insertTextRules!="undefined"&&re.insertTextRules&4?we.insertText=new C.SnippetString(re.insertText):(we.insertText=re.insertText,we.textEdit=we.range instanceof C.Range?new C.TextEdit(we.range,we.insertText):void 0),re.additionalTextEdits&&re.additionalTextEdits.length>0&&(we.additionalTextEdits=re.additionalTextEdits.map(Re=>q.to(Re))),we.command=W&&re.command?W.fromInternal(re.command):void 0,we}ce.to=fe})(K=e.CompletionItem||(e.CompletionItem={}));var x;(function(ce){function fe(W){return{label:W.label,documentation:W.documentation?E.fromStrict(W.documentation):void 0}}ce.from=fe;function re(W){return{label:W.label,documentation:S.isMarkdownString(W.documentation)?E.to(W.documentation):W.documentation}}ce.to=re})(x=e.ParameterInformation||(e.ParameterInformation={}));var V;(function(ce){function fe(W){return{label:W.label,documentation:W.documentation?E.fromStrict(W.documentation):void 0,parameters:Array.isArray(W.parameters)?W.parameters.map(x.from):[],activeParameter:W.activeParameter}}ce.from=fe;function re(W){return{label:W.label,documentation:S.isMarkdownString(W.documentation)?E.to(W.documentation):W.documentation,parameters:Array.isArray(W.parameters)?W.parameters.map(x.to):[],activeParameter:W.activeParameter}}ce.to=re})(V=e.SignatureInformation||(e.SignatureInformation={}));var Y;(function(ce){function fe(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(V.from):[]}}ce.from=fe;function re(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(V.to):[]}}ce.to=re})(Y=e.SignatureHelp||(e.SignatureHelp={}));var se;(function(ce){function fe(re,W){const we=new C.InlayHint(typeof W.label=="string"?W.label:W.label.map(_e.to.bind(void 0,re)),a.to(W.position),Ue.to(W.kind));return we.tooltip=S.isMarkdownString(W.tooltip)?E.to(W.tooltip):W.tooltip,we.paddingLeft=W.paddingLeft,we.paddingRight=W.paddingRight,we}ce.to=fe})(se=e.InlayHint||(e.InlayHint={}));var _e;(function(ce){function fe(re,W){const we=new C.InlayHintLabelPart(W.label);return we.tooltip=S.isMarkdownString(W.tooltip)?E.to(W.tooltip):W.tooltip,b.Command.is(W.command)?we.command=re.fromInternal(W.command):W.location&&(we.location=pe.to(W.location)),we}ce.to=fe})(_e=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ue;(function(ce){function fe(W){return W}ce.from=fe;function re(W){return W}ce.to=re})(Ue=e.InlayHintKind||(e.InlayHintKind={}));var Ve;(function(ce){function fe(W){return{range:u.from(W.range),url:W.target,tooltip:W.tooltip}}ce.from=fe;function re(W){let we;if(W.url)try{we=typeof W.url=="string"?T.URI.parse(W.url,!0):T.URI.revive(W.url)}catch{}return new C.DocumentLink(u.to(W.range),we)}ce.to=re})(Ve=e.DocumentLink||(e.DocumentLink={}));var Qe;(function(ce){function fe(W){const we=new C.ColorPresentation(W.label);return W.textEdit&&(we.textEdit=q.to(W.textEdit)),W.additionalTextEdits&&(we.additionalTextEdits=W.additionalTextEdits.map(Re=>q.to(Re))),we}ce.to=fe;function re(W){return{label:W.label,textEdit:W.textEdit?q.from(W.textEdit):void 0,additionalTextEdits:W.additionalTextEdits?W.additionalTextEdits.map(we=>q.from(we)):void 0}}ce.from=re})(Qe=e.ColorPresentation||(e.ColorPresentation={}));var nt;(function(ce){function fe(W){return new C.Color(W[0],W[1],W[2],W[3])}ce.to=fe;function re(W){return[W.red,W.green,W.blue,W.alpha]}ce.from=re})(nt=e.Color||(e.Color={}));var rt;(function(ce){function fe(W){return{range:u.from(W.range)}}ce.from=fe;function re(W){return new C.SelectionRange(u.to(W.range))}ce.to=re})(rt=e.SelectionRange||(e.SelectionRange={}));var Je;(function(ce){function fe(re){switch(re){case 2:return C.TextDocumentSaveReason.AfterDelay;case 1:return C.TextDocumentSaveReason.Manual;case 3:case 4:return C.TextDocumentSaveReason.FocusOut}}ce.to=fe})(Je=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ze;(function(ce){function fe(W){switch(W){case C.TextEditorLineNumbersStyle.Off:return 0;case C.TextEditorLineNumbersStyle.Relative:return 2;case C.TextEditorLineNumbersStyle.On:default:return 1}}ce.from=fe;function re(W){switch(W){case 0:return C.TextEditorLineNumbersStyle.Off;case 2:return C.TextEditorLineNumbersStyle.Relative;case 1:default:return C.TextEditorLineNumbersStyle.On}}ce.to=re})(Ze=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var pt;(function(ce){function fe(W){if(W===C.EndOfLine.CRLF)return 1;if(W===C.EndOfLine.LF)return 0}ce.from=fe;function re(W){if(W===1)return C.EndOfLine.CRLF;if(W===0)return C.EndOfLine.LF}ce.to=re})(pt=e.EndOfLine||(e.EndOfLine={}));var Fe;(function(ce){function fe(re){if(typeof re=="object")return re.viewId;switch(re){case C.ProgressLocation.SourceControl:return 3;case C.ProgressLocation.Window:return 10;case C.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ce.from=fe})(Fe=e.ProgressLocation||(e.ProgressLocation={}));var At;(function(ce){function fe(re){const W={start:re.start+1,end:re.end+1};return re.kind&&(W.kind=G.from(re.kind)),W}ce.from=fe})(At=e.FoldingRange||(e.FoldingRange={}));var G;(function(ce){function fe(re){if(re)switch(re){case C.FoldingRangeKind.Comment:return b.FoldingRangeKind.Comment;case C.FoldingRangeKind.Imports:return b.FoldingRangeKind.Imports;case C.FoldingRangeKind.Region:return b.FoldingRangeKind.Region}}ce.from=fe})(G=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Q;(function(ce){function fe(re){if(re)return{pinned:typeof re.preview=="boolean"?!re.preview:void 0,inactive:re.background,preserveFocus:re.preserveFocus,selection:typeof re.selection=="object"?u.from(re.selection):void 0,override:typeof re.override=="boolean"?i.EditorResolution.DISABLED:void 0}}ce.from=fe})(Q=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var he;(function(ce){function fe(Re){return Re instanceof C.RelativePattern?Re.toJSON():typeof Re=="string"?Re:re(Re)||W(Re)?new C.RelativePattern(Re.baseUri??Re.base,Re.pattern).toJSON():Re}ce.from=fe;function re(Re){const We=Re;return We?T.URI.isUri(We.baseUri)&&typeof We.pattern=="string":!1}function W(Re){const We=Re;return We?typeof We.base=="string"&&typeof We.pattern=="string":!1}function we(Re){return typeof Re=="string"?Re:new C.RelativePattern(T.URI.revive(Re.baseUri),Re.pattern)}ce.to=we})(he=e.GlobPattern||(e.GlobPattern={}));var Be;(function(ce){function fe(re){if(re){if(Array.isArray(re))return re.map(fe);if(typeof re=="string")return re;{const W=re;return{language:W.language,scheme:W.scheme,pattern:he.from(W.pattern),exclusive:W.exclusive}}}else return}ce.from=fe})(Be=e.LanguageSelector||(e.LanguageSelector={}));var qe;(function(ce){function fe(W){return{start:W.start,end:W.end}}ce.from=fe;function re(W){return new C.NotebookRange(W.start,W.end)}ce.to=re})(qe=e.NotebookRange||(e.NotebookRange={}));var lt;(function(ce){function fe(W){return{timing:typeof W.runStartTime=="number"&&typeof W.runEndTime=="number"?{startTime:W.runStartTime,endTime:W.runEndTime}:void 0,executionOrder:W.executionOrder,success:W.lastRunSuccess}}ce.to=fe;function re(W){return{lastRunSuccess:W.success,runStartTime:W.timing?.startTime,runEndTime:W.timing?.endTime,executionOrder:W.executionOrder}}ce.from=re})(lt=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var ht;(function(ce){function fe(W){switch(W){case C.NotebookCellKind.Markup:return o.CellKind.Markup;case C.NotebookCellKind.Code:default:return o.CellKind.Code}}ce.from=fe;function re(W){switch(W){case o.CellKind.Markup:return C.NotebookCellKind.Markup;case o.CellKind.Code:default:return C.NotebookCellKind.Code}}ce.to=re})(ht=e.NotebookCellKind||(e.NotebookCellKind={}));var Ye;(function(ce){function fe(W){const we={metadata:W.metadata??Object.create(null),cells:[]};for(let Re of W.cells)C.NotebookCellData.validate(Re),we.cells.push(kt.from(Re));return we}ce.from=fe;function re(W){const we=new C.NotebookData(W.cells.map(kt.to));return(0,D.isEmptyObject)(W.metadata)||(we.metadata=W.metadata),we}ce.to=re})(Ye=e.NotebookData||(e.NotebookData={}));var kt;(function(ce){function fe(W){return{cellKind:ht.from(W.kind),language:W.languageId,mime:W.mime,source:W.value,metadata:W.metadata,internalMetadata:lt.from(W.executionSummary??{}),outputs:W.outputs?W.outputs.map(De.from):[]}}ce.from=fe;function re(W){return new C.NotebookCellData(ht.to(W.cellKind),W.source,W.language,W.mime,W.outputs?W.outputs.map(De.to):void 0,W.metadata,W.internalMetadata?lt.to(W.internalMetadata):void 0)}ce.to=re})(kt=e.NotebookCellData||(e.NotebookCellData={}));var Ae;(function(ce){function fe(W){return{mime:W.mime,valueBytes:t.VSBuffer.wrap(W.data)}}ce.from=fe;function re(W){return new C.NotebookCellOutputItem(W.valueBytes.buffer,W.mime)}ce.to=re})(Ae=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var De;(function(ce){function fe(W){return{outputId:W.id,items:W.items.map(Ae.from),metadata:W.metadata}}ce.from=fe;function re(W){const we=W.items.map(Ae.to);return new C.NotebookCellOutput(we,W.outputId,W.metadata)}ce.to=re})(De=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ve;(function(ce){function fe(we){return W(we)?{include:(0,D.withNullAsUndefined)(he.from(we.include)),exclude:(0,D.withNullAsUndefined)(he.from(we.exclude))}:(0,D.withNullAsUndefined)(he.from(we))}ce.from=fe;function re(we){return W(we)?{include:he.to(we.include),exclude:he.to(we.exclude)}:he.to(we)}ce.to=re;function W(we){const Re=we;return Re?!!Re.include&&!!Re.exclude:!1}})(ve=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ee;(function(ce){function fe(re){return{backgroundColor:re.backgroundColor,borderColor:re.borderColor,top:re.top?L.from(re.top):void 0}}ce.from=fe})(ee=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ne;(function(ce){function fe(re,W,we){const Re=typeof re.command=="string"?{title:"",command:re.command}:re.command;return{alignment:re.alignment===C.NotebookCellStatusBarAlignment.Left?1:2,command:W.toInternal(Re,we),text:re.text,tooltip:re.tooltip,accessibilityInformation:re.accessibilityInformation,priority:re.priority}}ce.from=fe})(ne=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var de;(function(ce){function fe(re){return{transientOutputs:re?.transientOutputs??!1,transientCellMetadata:re?.transientCellMetadata??{},transientDocumentMetadata:re?.transientDocumentMetadata??{}}}ce.from=fe})(de=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ge;(function(ce){function fe(W){return{uri:W.uri,provides:W.provides}}ce.from=fe;function re(W){return new C.NotebookRendererScript(T.URI.revive(W.uri),W.provides)}ce.to=re})(ge=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Te;(function(ce){function fe(W){return{message:E.fromStrict(W.message)||"",type:0,expected:W.expectedOutput,actual:W.actualOutput,location:W.location?pe.from(W.location):void 0}}ce.from=fe;function re(W){const we=new C.TestMessage(typeof W.message=="string"?W.message:E.to(W.message));return we.actualOutput=W.actual,we.expectedOutput=W.expected,we.location=W.location?pe.to(W.location):void 0,we}ce.to=re})(Te=e.TestMessage||(e.TestMessage={}));var ze;(function(ce){let fe;(function(re){re.Delimiter="\0"})(fe||(fe={})),ce.namespace=(re,W)=>re+"\0"+W,ce.denamespace=re=>{const W=re.indexOf("\0");return{ctrlId:re.slice(0,W),tagId:re.slice(W+1)}}})(ze=e.TestTag||(e.TestTag={}));var Le;(function(ce){function fe(Re){const We=(0,l.getPrivateApiFor)(Re).controllerId;return{extId:m.TestId.fromExtHostTestItem(Re,We).toString(),label:Re.label,uri:Re.uri,tags:Re.tags.map(He=>ze.namespace(We,He.id)),range:u.from(Re.range)||null,description:Re.description||null,error:Re.error&&E.fromStrict(Re.error)||null}}ce.from=fe;function re(Re){return{parent:void 0,error:void 0,id:m.TestId.fromString(Re.extId).localId,label:Re.label,uri:T.URI.revive(Re.uri),tags:(Re.tags||[]).map(We=>{const{tagId:He}=ze.denamespace(We);return new C.TestTag(He)}),range:u.to(Re.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Re.description||void 0}}ce.toPlain=re;function W(Re){const We=m.TestId.fromString(Re.extId),He=new l.TestItemImpl(We.controllerId,We.localId,Re.label,T.URI.revive(Re.uri));return He.range=u.to(Re.range||void 0),He.description=Re.description||void 0,He}function we(Re){let We;for(const He of Re.tests){const mt=W(He.item);(0,l.getPrivateApiFor)(mt).parent=We,We=mt}return We}ce.toItemFromContext=we})(Le=e.TestItem||(e.TestItem={})),function(ce){function fe(W){return{id:W.id}}ce.from=fe;function re(W){return new C.TestTag(W.id)}ce.to=re}(ze=e.TestTag||(e.TestTag={}));var Ge;(function(ce){const fe=(W,we)=>{const Re={...Le.toPlain(W.item),parent:void 0,taskStates:W.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(He=>He.type===0).map(Te.to)})),children:W.children.map(We=>we.get(We)).filter(D.isDefined).map(We=>fe(We,we))};for(const We of Re.children)We.parent=Re;return Re};function re(W){const we=[],Re=new Map;for(const We of W.items)Re.set(We.item.extId,We),W.request.targets.some(He=>He.controllerId===We.controllerId&&He.testIds.includes(We.item.extId))&&we.push(We);return{completedAt:W.completedAt,results:we.map(We=>fe(We,Re))}}ce.to=re})(Ge=e.TestResults||(e.TestResults={}));var ot;(function(ce){function fe(Re){return{covered:Re.covered,total:Re.covered}}function re(Re){return"line"in Re?a.from(Re):u.from(Re)}function W(Re){return"branches"in Re?{count:Re.executionCount,location:re(Re.location),type:1,branches:Re.branches.length?Re.branches.map(We=>({count:We.executionCount,location:We.location&&re(We.location)})):void 0}:{type:0,count:Re.executionCount,location:re(Re.location)}}ce.fromDetailed=W;function we(Re){return{uri:Re.uri,statement:fe(Re.statementCoverage),branch:Re.branchCoverage&&fe(Re.branchCoverage),function:Re.functionCoverage&&fe(Re.functionCoverage),details:Re.detailedCoverage?.map(W)}}ce.fromFile=we})(ot=e.TestCoverage||(e.TestCoverage={}));var at;(function(ce){function fe(re){switch(re){case 1:return C.CodeActionTriggerKind.Invoke;case 2:return C.CodeActionTriggerKind.Automatic}}ce.to=fe})(at=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ne;(function(ce){function fe(W){const we=new C.TypeHierarchyItem(z.to(W.kind),W.name,W.detail||"",T.URI.revive(W.uri),u.to(W.range),u.to(W.selectionRange));return we._sessionId=W._sessionId,we._itemId=W._itemId,we}ce.to=fe;function re(W,we,Re){if(we=we??W._sessionId,Re=Re??W._itemId,we===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:Re,kind:z.from(W.kind),name:W.name,detail:W.detail??"",uri:W.uri,range:u.from(W.range),selectionRange:u.from(W.selectionRange),tags:W.tags?.map(j.from)}}ce.from=re})(Ne=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ye[164],Se([0,1,2,15,7,8,226]),function(Z,e,r,t,S,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(T,R,b,i={timeout:1500,errors:3}){this._logService=T,this._documents=R,this._mainThreadBulkEdits=b,this._thresholds=i,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(R,b,i)=>{const l={dispose:this._callbacks.push([R,b,T])};return Array.isArray(i)&&i.push(l),l}}async $participateInSave(T,R){const b=r.URI.revive(T);let i=!1;const h=setTimeout(()=>i=!0,this._thresholds.timeout),l=[];try{for(let o of[...this._callbacks]){if(i)break;const m=this._documents.getDocument(b),M=await this._deliverEventAsyncAndBlameBadListeners(o,{document:m,reason:P.TextDocumentSaveReason.to(R)});l.push(M)}}finally{clearTimeout(h)}return l}_deliverEventAsyncAndBlameBadListeners([T,R,b],i){const h=this._badListeners.get(T);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(b,T,R,i).then(()=>!0,l=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' threw ERROR`),this._logService.error(l),!(l instanceof Error)||l.message!=="concurrent_edits"){const o=this._badListeners.get(T);this._badListeners.set(T,o?o+1:1),typeof o=="number"&&o>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,R,b,i){const h=[],l=Date.now(),{document:o,reason:m}=i,{version:M}=o,C=Object.freeze({document:o,reason:m,waitUntil(w){if(Object.isFrozen(h))throw(0,t.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(w))}});try{R.apply(b,[C])}catch(w){return Promise.reject(w)}return Object.freeze(h),new Promise((w,u)=>{const _=setTimeout(()=>u(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(a=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-l}ms`),clearTimeout(_),w(a)}).catch(a=>{clearTimeout(_),u(a)})}).then(w=>{const u={edits:[]};for(const _ of w)if(Array.isArray(_)&&_.every(a=>a instanceof S.TextEdit))for(const{newText:a,newEol:F,range:c}of _)u.edits.push({_type:2,resource:o.uri,edit:{range:c&&P.Range.from(c),text:a,eol:F&&P.EndOfLine.from(F)}});if(u.edits.length!==0)return M===o.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(u):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(ye[165],Se([0,1,11,27,2,8,85]),function(Z,e,r,t,S,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class I{constructor(b,i,h,l){this.start=b,this.deletedCount=i,this.deletedItems=h,this.items=l}static asApiEvents(b){return b.map(i=>({start:i.start,deletedCount:i.deletedCount,deletedItems:i.deletedItems,items:i.items.map(h=>h.apiCell)}))}}class D{constructor(b,i,h){this.notebook=b,this._extHostDocument=i,this._cellData=h,this.handle=h.handle,this.uri=S.URI.revive(h.uri),this.cellKind=h.cellKind,this._outputs=h.outputs.map(P.NotebookCellOutput.to),this._internalMetadata=h.internalMetadata??{},this._metadata=Object.freeze(h.metadata??{}),this._previousResult=Object.freeze(P.NotebookCellExecutionSummary.to(h.internalMetadata??{}))}static asModelAddData(b,i){return{EOL:i.eol,lines:i.source,languageId:i.language,uri:i.uri,isDirty:!1,versionId:1,notebook:b}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const b=this,i=this._extHostDocument.getDocument(this.uri);if(!i)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return b.notebook.getCellIndex(b)},notebook:b.notebook.apiNotebook,kind:P.NotebookCellKind.to(this._cellData.cellKind),document:i.document,get mime(){return b._mime},set mime(h){b._mime=h},get outputs(){return b._outputs.slice(0)},get metadata(){return b._metadata},get executionSummary(){return b._previousResult}})}return this._apiCell}setOutputs(b){this._outputs=b.map(P.NotebookCellOutput.to)}setOutputItems(b,i,h){const l=h.map(P.NotebookCellOutputItem.to),o=this._outputs.find(m=>m.id===b);o&&(i||(o.items.length=0),o.items.push(...l))}setMetadata(b){this._metadata=Object.freeze(b)}setInternalMetadata(b){this._internalMetadata=b,this._previousResult=Object.freeze(P.NotebookCellExecutionSummary.to(b))}setMime(b){}}e.ExtHostCell=D;class T{constructor(b,i,h,l,o,m){this._proxy=b,this._textDocumentsAndEditors=i,this._textDocuments=h,this._emitter=l,this.uri=o,this.handle=T._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=m.viewType,this._metadata=Object.freeze(m.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,m.cells]],!0),this._versionId=m.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const b=this;this._notebook={get uri(){return b.uri},get version(){return b._versionId},get notebookType(){return b._notebookType},get isDirty(){return b._isDirty},get isUntitled(){return b.uri.scheme===r.Schemas.untitled},get isClosed(){return b._disposed},get metadata(){return b._metadata},get cellCount(){return b._cells.length},cellAt(i){return i=b._validateIndex(i),b._cells[i].apiCell},getCells(i){return(i?b._getCells(i):b._cells).map(l=>l.apiCell)},save(){return b._save()}}}return this._notebook}updateBackup(b){this._backup?.delete(),this._backup=b}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(b){b.metadata&&(this._metadata=Object.freeze({...this._metadata,...b.metadata}))}acceptDirty(b){this._isDirty=b}acceptModelChanged(b,i){this._versionId=b.versionId,this._isDirty=i;for(const h of b.rawEvents)h.kind===A.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(h.changes,!1):h.kind===A.NotebookCellsChangeType.Move?this._moveCell(h.index,h.newIdx):h.kind===A.NotebookCellsChangeType.Output?this._setCellOutputs(h.index,h.outputs):h.kind===A.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(h.index,h.outputId,h.append,h.outputItems):h.kind===A.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(h.index,h.language):h.kind===A.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(h.index,h.mime):h.kind===A.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(h.index,h.metadata):h.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(h.index,h.internalMetadata)}_validateIndex(b){return b=b|0,b<0?0:b>=this._cells.length?this._cells.length-1:b}_validateRange(b){let i=b.start|0,h=b.end|0;return i<0&&(i=0),h>this._cells.length&&(h=this._cells.length),b.with({start:i,end:h})}_getCells(b){b=this._validateRange(b);const i=[];for(let h=b.start;h<b.end;h++)i.push(this._cells[h]);return i}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(b,i){if(this._disposed)return;const h=[],l=[],o=[];b.reverse().forEach(m=>{const C=m[2].map(_=>{const a=new D(this,this._textDocumentsAndEditors,_);return i||l.push(D.asModelAddData(this.apiNotebook,_)),a}),w=new I(m[0],m[1],[],C),u=this._cells.splice(m[0],m[1],...C);for(const _ of u)o.push(_.uri),w.deletedItems.push(_.apiCell);h.push(w)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:o}),i||this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:I.asApiEvents(h)}))}_moveCell(b,i){const h=this._cells.splice(b,1);this._cells.splice(i,0,...h);const l=[new I(b,1,h.map(o=>o.apiCell),[]),new I(i,0,[],h)];this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:I.asApiEvents(l)}))}_setCellOutputs(b,i){const h=this._cells[b];h.setOutputs(i),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[h.apiCell]}))}_setCellOutputItems(b,i,h,l){const o=this._cells[b];o.setOutputItems(i,h,l),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[o.apiCell]}))}_changeCellLanguage(b,i){const h=this._cells[b];h.apiCell.document.languageId!==i&&this._textDocuments.$acceptModelLanguageChanged(h.uri,i)}_changeCellMime(b,i){const h=this._cells[b];h.apiCell.mime=i}_changeCellMetadata(b,i){const h=this._cells[b],l=h.apiCell.metadata;h.setMetadata(i);const o=h.apiCell.metadata;(0,t.equals)(l,o)||this._emitter.emitCellMetadataChange((0,t.deepFreeze)({document:this.apiNotebook,cell:h.apiCell}))}_changeCellInternalMetadata(b,i){this._cells[b].setInternalMetadata(i)}getCellFromApiCell(b){return this._cells.find(i=>i.apiCell===b)}getCellFromIndex(b){return this._cells[b]}getCell(b){return this._cells.find(i=>i.handle===b)}getCellIndex(b){return this._cells.indexOf(b)}}e.ExtHostNotebookDocument=T,T._handlePool=0}),define(ye[89],Se([0,1,7,8,15]),function(Z,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,T){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:D,metadata:T})}replaceCells(D,T,R){this._throwIfFinalized(),!(D===T&&R.length===0)&&this._collectedEdits.push({editType:1,index:D,count:T-D,cells:R.map(t.NotebookCellData.from)})}}class A{constructor(D,T,R,b,i,h){this.id=D,this._proxy=T,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=i,this._visibleRanges=b,this._viewColumn=h}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get selections(){return D._selections},set selections(T){if(!Array.isArray(T)||!T.every(r.NotebookRange.isNotebookRange))throw(0,S.illegalArgument)("selections");D._selections=T,D._trySetSelections(T)},get visibleRanges(){return D._visibleRanges},revealRange(T,R){D._proxy.$tryRevealRange(D.id,t.NotebookRange.from(T),R??r.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(T){const R=new P(this.document.version);return T(R),D._applyEdit(R.finalize())},setDecorations(T,R){return D.setDecorations(T,R)}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_trySetSelections(D){this._proxy.$trySetSelections(this.id,D.map(t.NotebookRange.from))}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const T=[];let R=-1;for(let b=0;b<D.cellEdits.length;b++){if(R<0){T.push(D.cellEdits[b]),R++;continue}const h=T[R],l=D.cellEdits[b];if(h.editType===1&&l.editType===1&&h.index===l.index){h.cells.push(...D.cellEdits[b].cells),h.count+=D.cellEdits[b].count;continue}T.push(D.cellEdits[b]),R++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,T)}setDecorations(D,T){if(!(T.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return T.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,t.NotebookRange.from(T),D.key)}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(ye[166],Se([0,1,8,139,120,20,53,15]),function(Z,e,r,t,S,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(i){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=i}async withProgress(i,h,l){const o=this._handles++,{title:m,location:M,cancellable:C}=h,w={label:(0,S.localize)(0,null,i.displayName||i.name),id:i.identifier.value};return this._proxy.$startProgress(o,{location:r.ProgressLocation.from(M),title:m,source:w,cancellable:C},i.isUnderDevelopment?void 0:i.identifier.value).catch(I.onUnexpectedExternalError),this._withProgress(o,l,!!C)}_withProgress(i,h,l){let o;l&&(o=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(i,o));const m=C=>{this._proxy.$progressEnd(C),this._mapHandleToCancellationSource.delete(C),o&&o.dispose()};let M;try{M=h(new R(this._proxy,i),l&&o?o.token:P.CancellationToken.None)}catch(C){throw m(i),C}return M.then(C=>m(i),C=>m(i)),M}$acceptProgressCanceled(i){const h=this._mapHandleToCancellationSource.get(i);h&&(h.cancel(),this._mapHandleToCancellationSource.delete(i))}}e.ExtHostProgress=D;function T(b,i){return b.message=i.message,typeof i.increment=="number"&&(typeof b.increment=="number"?b.increment+=i.increment:b.increment=i.increment),b}class R extends t.Progress{constructor(i,h){super(l=>this.throttledReport(l));this._proxy=i,this._handle=h}throttledReport(i){this._proxy.$progressReport(this._handle,i)}}xe([(0,A.throttle)(100,(b,i)=>T(b,i),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(ye[90],Se([0,1,42,15,54,8,7]),function(Z,e,r,t,S,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(i,h,l){const o=I._Keys.nextId();i.$registerTextEditorDecorationType(h.identifier,o,P.DecorationRenderOptions.from(l)),this.value=Object.freeze({key:o,dispose(){i.$removeTextEditorDecorationType(o)}})}}e.TextEditorDecorationType=I,I._Keys=new S.IdGenerator("TextEditorDecorationType");class D{constructor(i,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=i,this._documentVersionId=i.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(i,h){this._throwIfFinalized();let l=null;if(i instanceof A.Position)l=new A.Range(i,i);else if(i instanceof A.Range)l=i;else throw new Error("Unrecognized location");this._pushEdit(l,h,!1)}insert(i,h){this._throwIfFinalized(),this._pushEdit(new A.Range(i,i),h,!0)}delete(i){this._throwIfFinalized();let h=null;if(i instanceof A.Range)h=i;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(i,h,l){const o=this._document.validateRange(i);this._collectedEdits.push({range:o,text:h,forceMoveMarkers:l})}setEndOfLine(i){if(this._throwIfFinalized(),i!==A.EndOfLine.LF&&i!==A.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=i}}e.TextEditorEdit=D;class T{constructor(i,h,l,o){this._proxy=i,this._id=h,this._accept(l),this._logService=o;const m=this;this.value={get tabSize(){return m._tabSize},set tabSize(M){m._setTabSize(M)},get insertSpaces(){return m._insertSpaces},set insertSpaces(M){m._setInsertSpaces(M)},get cursorStyle(){return m._cursorStyle},set cursorStyle(M){m._setCursorStyle(M)},get lineNumbers(){return m._lineNumbers},set lineNumbers(M){m._setLineNumbers(M)}}}_accept(i){this._tabSize=i.tabSize,this._insertSpaces=i.insertSpaces,this._cursorStyle=i.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(i.lineNumbers)}_validateTabSize(i){if(i==="auto")return"auto";if(typeof i=="number"){const h=Math.floor(i);return h>0?h:null}if(typeof i=="string"){const h=parseInt(i,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(i){const h=this._validateTabSize(i);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(i){return i==="auto"?"auto":i==="false"?!1:Boolean(i)}_setInsertSpaces(i){const h=this._validateInsertSpaces(i);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(i){this._cursorStyle!==i&&(this._cursorStyle=i,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:i})))}_setLineNumbers(i){this._lineNumbers!==i&&(this._lineNumbers=i,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(i)})))}assign(i){const h={};let l=!1;if(typeof i.tabSize!="undefined"){const o=this._validateTabSize(i.tabSize);o==="auto"?(l=!0,h.tabSize=o):typeof o=="number"&&this._tabSize!==o&&(this._tabSize=o,l=!0,h.tabSize=o)}if(typeof i.insertSpaces!="undefined"){const o=this._validateInsertSpaces(i.insertSpaces);o==="auto"?(l=!0,h.insertSpaces=o):this._insertSpaces!==o&&(this._insertSpaces=o,l=!0,h.insertSpaces=o)}typeof i.cursorStyle!="undefined"&&this._cursorStyle!==i.cursorStyle&&(this._cursorStyle=i.cursorStyle,l=!0,h.cursorStyle=i.cursorStyle),typeof i.lineNumbers!="undefined"&&this._lineNumbers!==i.lineNumbers&&(this._lineNumbers=i.lineNumbers,l=!0,h.lineNumbers=P.TextEditorLineNumbersStyle.from(i.lineNumbers)),l&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,h))}_warnOnError(i,h){h.catch(l=>{this._logService.warn(`ExtHostTextEditorOptions '${i}' failed:'`),this._logService.warn(l)})}}e.ExtHostTextEditorOptions=T;class R{constructor(i,h,l,o,m,M,C,w){this.id=i,this._proxy=h,this._logService=l,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=m,this._options=new T(this._proxy,this.id,M,l),this._visibleRanges=C,this._viewColumn=w;const u=this;this.value=Object.freeze({get document(){return o.getValue()},set document(_){throw(0,t.readonly)("document")},get selection(){return u._selections&&u._selections[0]},set selection(_){if(!(_ instanceof A.Selection))throw(0,t.illegalArgument)("selection");u._selections=[_],u._trySetSelection()},get selections(){return u._selections},set selections(_){if(!Array.isArray(_)||_.some(a=>!(a instanceof A.Selection)))throw(0,t.illegalArgument)("selections");u._selections=_,u._trySetSelection()},get visibleRanges(){return u._visibleRanges},set visibleRanges(_){throw(0,t.readonly)("visibleRanges")},get options(){return u._options.value},set options(_){u._disposed||u._options.assign(_)},get viewColumn(){return u._viewColumn},set viewColumn(_){throw(0,t.readonly)("viewColumn")},edit(_,a={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const F=new D(o.getValue(),a);return _(F),u._applyEdit(F)},insertSnippet(_,a,F={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!a||Array.isArray(a)&&a.length===0)c=u._selections.map(n=>P.Range.from(n));else if(a instanceof A.Position){const{lineNumber:n,column:f}=P.Position.from(a);c=[{startLineNumber:n,startColumn:f,endLineNumber:n,endColumn:f}]}else if(a instanceof A.Range)c=[P.Range.from(a)];else{c=[];for(const n of a)if(n instanceof A.Range)c.push(P.Range.from(n));else{const{lineNumber:f,column:g}=P.Position.from(n);c.push({startLineNumber:f,startColumn:g,endLineNumber:f,endColumn:g})}}return h.$tryInsertSnippet(i,_.value,c,F)},setDecorations(_,a){const F=a.length===0;F&&!u._hasDecorationsForKey.has(_.key)||(F?u._hasDecorationsForKey.delete(_.key):u._hasDecorationsForKey.add(_.key),u._runOnProxy(()=>{if(P.isDecorationOptionsArr(a))return h.$trySetDecorations(i,_.key,P.fromRangeOrRangeWithMessage(a));{const c=new Array(4*a.length);for(let n=0,f=a.length;n<f;n++){const g=a[n];c[4*n]=g.start.line+1,c[4*n+1]=g.start.character+1,c[4*n+2]=g.end.line+1,c[4*n+3]=g.end.character+1}return h.$trySetDecorationsFast(i,_.key,c)}}))},revealRange(_,a){u._runOnProxy(()=>h.$tryRevealRange(i,P.Range.from(_),a||A.TextEditorRevealType.Default))},show(_){h.$tryShowEditor(i,P.ViewColumn.from(_))},hide(){h.$tryHideEditor(i)}})}dispose(){(0,r.ok)(!this._disposed),this._disposed=!0}_acceptOptions(i){(0,r.ok)(!this._disposed),this._options._accept(i)}_acceptVisibleRanges(i){(0,r.ok)(!this._disposed),this._visibleRanges=i}_acceptViewColumn(i){(0,r.ok)(!this._disposed),this._viewColumn=i}_acceptSelections(i){(0,r.ok)(!this._disposed),this._selections=i}async _trySetSelection(){const i=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,i)),this.value}_applyEdit(i){const h=i.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const l=h.edits.map(m=>m.range);l.sort((m,M)=>m.end.line===M.end.line?m.end.character===M.end.character?m.start.line===M.start.line?m.start.character-M.start.character:m.start.line-M.start.line:m.end.character-M.end.character:m.end.line-M.end.line);for(let m=0,M=l.length-1;m<M;m++){const C=l[m].end;if(l[m+1].start.isBefore(C))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const o=h.edits.map(m=>({range:P.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,o,{setEndOfLine:typeof h.setEndOfLine=="number"?P.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(i){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):i().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=R}),define(ye[167],Se([0,1,10,4,6,13,48,8,86,66]),function(Z,e,r,t,S,P,A,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class R extends S.Disposable{constructor(i){super();this.controllerId=i,this.debounceSendDiff=this._register(new r.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.root=new A.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(i){this._resolveHandler=i;for(const h of this.tree.values())this.updateExpandability(h)}collectDiff(){const i=this.diff;return this.diff=[],i}pushDiff(i){const h=this.diff[this.diff.length-1];if(h&&i[0]===1){if(h[0]===1&&h[1].extId===i[1].extId){(0,D.applyTestItemUpdate)(h[1],i[1]);return}if(h[0]===0&&h[1].item.extId===i[1].extId){(0,D.applyTestItemUpdate)(h[1],i[1]);return}}this.diff.push(i),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(i,h){const l=this.tree.get(i);if(!!l){if((l.expandLevels===void 0||h>l.expandLevels)&&(l.expandLevels=h),l.expand===1){const o=this.resolveChildren(l);return o.isOpen()?this.expandChildren(l,h-1):o.wait().then(()=>this.expandChildren(l,h-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,h-1)):this.expandChildren(l,h-1)}}dispose(){for(const i of this.tree.values())(0,A.getPrivateApiFor)(i.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(i,h){switch(h.op){case 2:this.pushDiff([4,i.fullId.toString()]);break;case 1:this.removeItem(T.TestId.joinToString(i.fullId,h.id));break;case 0:this.upsertItem(h.item,i);break;case 4:for(const l of h.ops)this.onTestItemEvent(i,l);break;case 3:{const{key:l,value:o,previous:m}=h,M=i.fullId.toString();switch(l){case"canResolveChildren":this.updateExpandability(i);break;case"tags":this.diffTagRefs(o,m,M);break;case"range":this.pushDiff([1,{extId:M,item:{range:I.Range.from(o)}}]);break;case"error":this.pushDiff([1,{extId:M,item:{error:I.MarkdownString.fromStrict(o)||null}}]);break;default:this.pushDiff([1,{extId:M,item:{[l]:o??null}}]);break}break}default:(0,P.assertNever)(h)}}upsertItem(i,h){if(!(i instanceof A.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${i.id} did not`);const l=T.TestId.fromExtHostTestItem(i,this.root.id,h?.actual),o=(0,A.getPrivateApiFor)(i);o.parent&&o.parent!==h?.actual&&o.parent.children.delete(i.id);let m=this.tree.get(l.toString());if(!m){m={fullId:l,actual:i,parent:h?l.parentId:null,expandLevels:h?.expandLevels?h.expandLevels-1:void 0,expand:0},i.tags.forEach(this.incrementTagRefs,this),this.tree.set(m.fullId.toString(),m),this.setItemParent(i,h),this.pushDiff([0,{parent:m.parent&&m.parent.toString(),controllerId:this.controllerId,expand:m.expand,item:I.TestItem.from(i)}]),this.connectItemAndChildren(i,m,h);return}if(m.actual===i){this.connectItem(i,m,h);return}const M=m.actual.children,C=m.actual,w=(0,A.diffTestItems)(C,i);(0,A.getPrivateApiFor)(C).listener=void 0,m.actual=i,m.expand=0;for(const[u,_]of w)this.onTestItemEvent(m,{op:3,key:u,value:_,previous:C[u]});this.connectItemAndChildren(i,m,h);for(const u of M)i.children.get(u.id)||this.removeItem(T.TestId.joinToString(l,u.id))}diffTagRefs(i,h,l){const o=new Set(h.map(m=>m.id));for(const m of i)o.delete(m.id)||this.incrementTagRefs(m);this.pushDiff([1,{extId:l,item:{tags:i.map(m=>I.TestTag.namespace(this.controllerId,m.id))}}]),o.forEach(this.decrementTagRefs,this)}incrementTagRefs(i){const h=this.tags.get(i.id);h?h.refCount++:(this.tags.set(i.id,{refCount:1}),this.pushDiff([5,{id:I.TestTag.namespace(this.controllerId,i.id),ctrlLabel:this.root.label}]))}decrementTagRefs(i){const h=this.tags.get(i);h&&!--h.refCount&&(this.tags.delete(i),this.pushDiff([6,I.TestTag.namespace(this.controllerId,i)]))}setItemParent(i,h){(0,A.getPrivateApiFor)(i).parent=h&&h.actual!==this.root?h.actual:void 0}connectItem(i,h,l){this.setItemParent(i,l);const o=(0,A.getPrivateApiFor)(i);o.parent=l?.actual,o.listener=m=>this.onTestItemEvent(h,m),this.updateExpandability(h)}connectItemAndChildren(i,h,l){this.connectItem(i,h,l);for(const o of i.children)this.upsertItem(o,h)}updateExpandability(i){let h;this._resolveHandler?i.resolveBarrier?h=i.resolveBarrier.isOpen()?3:2:h=i.actual.canResolveChildren?1:0:h=0,h!==i.expand&&(i.expand=h,this.pushDiff([1,{extId:i.fullId.toString(),expand:h}]),h===1&&i.expandLevels!==void 0&&this.resolveChildren(i))}expandChildren(i,h){if(h<0)return;const l=[];for(const o of i.actual.children){const m=this.expand(T.TestId.joinToString(i.fullId,o.id),h);(0,r.isThenable)(m)&&l.push(m)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this._resolveHandler){const m=new r.Barrier;return m.open(),m}i.expand=2,this.pushExpandStateUpdate(i);const h=i.resolveBarrier=new r.Barrier,l=m=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),i.actual!==this.root&&(i.actual.error=m.stack||m.message||String(m))};let o;try{o=this._resolveHandler(i.actual===this.root?void 0:i.actual)}catch(m){l(m)}return(0,r.isThenable)(o)?o.catch(l).then(()=>{h.open(),this.updateExpandability(i)}):(h.open(),this.updateExpandability(i)),i.resolveBarrier}pushExpandStateUpdate(i){this.pushDiff([1,{extId:i.fullId.toString(),expand:i.expand}])}removeItem(i){const h=this.tree.get(i);if(!h)throw new Error("attempting to remove non-existent child");this.pushDiff([2,i]);const l=[h];for(;l.length;){const o=l.pop();if(!!o){(0,A.getPrivateApiFor)(o.actual).listener=void 0;for(const m of o.actual.tags)this.decrementTagRefs(m.id);this.tree.delete(o.fullId.toString());for(const m of o.actual.children)l.push(this.tree.get(T.TestId.joinToString(o.fullId,m.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.diffOpEmitter.fire(i)}}e.SingleUseTestCollection=R}),define(ye[168],Se([0,1,3,135]),function(Z,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,r.refineServiceDecorator)(t.IEnvironmentService)}),define(ye[169],Se([0,1,25,4,17]),function(Z,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(R){this.removedDueToLooping=R}}e.DeltaExtensionsResult=P;class A{constructor(R){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=R,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const R of this._extensionDescriptions){if(this._extensionsMap.has(r.ExtensionIdentifier.toKey(R.identifier))){console.error("Extension `"+R.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(r.ExtensionIdentifier.toKey(R.identifier),R),this._extensionsArr.push(R),Array.isArray(R.activationEvents))for(let b of R.activationEvents)b==="onUri"&&(b=`onUri:${r.ExtensionIdentifier.toKey(R.identifier)}`),this._activationMap.has(b)||this._activationMap.set(b,[]),this._activationMap.get(b).push(R)}}keepOnly(R){const b=new Set;R.forEach(i=>b.add(r.ExtensionIdentifier.toKey(i))),this._extensionDescriptions=this._extensionDescriptions.filter(i=>b.has(r.ExtensionIdentifier.toKey(i.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(R,b){R.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(R));const i=A._findLoopingExtensions(this._extensionDescriptions);if(b=b.concat(i.map(h=>h.identifier)),b.length>0){const h=new Set;b.forEach(l=>h.add(r.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>!h.has(r.ExtensionIdentifier.toKey(l.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new P(i)}static _findLoopingExtensions(R){const b=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(m){this._nodesSet.has(m)||(this._nodesSet.add(m),this._nodesArr.push(m))}addArc(m,M){this.addNode(m),this.addNode(M),this._arcs.has(m)?this._arcs.get(m).push(M):this._arcs.set(m,[M])}getArcs(m){return this._arcs.has(m)?this._arcs.get(m):[]}hasOnlyGoodArcs(m,M){const C=b.getArcs(m);for(let w=0;w<C.length;w++)if(!M.has(C[w]))return!1;return!0}getNodes(){return this._nodesArr}};let i=new Map;for(let m of R){const M=r.ExtensionIdentifier.toKey(m.identifier);if(i.set(M,m),m.extensionDependencies)for(let C of m.extensionDependencies){const w=r.ExtensionIdentifier.toKey(C);b.addArc(M,w)}}let h=new Set;b.getNodes().filter(m=>b.getArcs(m).length===0).forEach(m=>h.add(m));let l=b.getNodes().filter(m=>!h.has(m)),o;do{o=!1;for(let m=0;m<l.length;m++){const M=l[m];b.hasOnlyGoodArcs(M,h)&&(l.splice(m,1),m--,h.add(M),o=!0)}}while(o);return l.map(m=>i.get(m))}containsActivationEvent(R){return this._activationMap.has(R)}containsExtension(R){return this._extensionsMap.has(r.ExtensionIdentifier.toKey(R))}getExtensionDescriptionsForActivationEvent(R){const b=this._activationMap.get(R);return b?b.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(R){const b=this._extensionsMap.get(r.ExtensionIdentifier.toKey(R));return b||void 0}}e.ExtensionDescriptionRegistry=A;var I;(function(T){T[T.Builtin=0]="Builtin",T[T.User=1]="User",T[T.Dev=2]="Dev"})(I||(I={}));function D(T,R){const b=T.isBuiltin?0:T.isUnderDevelopment?2:1,i=R.isBuiltin?0:R.isUnderDevelopment?2:1;if(b!==i)return b-i;const h=S.posix.basename(T.extensionLocation.path),l=S.posix.basename(R.extensionLocation.path);return h<l?-1:h>l?1:0}}),define(ye[170],Se([0,1,21]),function(Z,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var t;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(t=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var S;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(S=e.MessageType||(e.MessageType={}));function P(I){const D=r.VSBuffer.alloc(1);switch(I){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=P;function A(I,D){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=A}),define(ye[26],Se([0,1,4,2,3,25,142]),function(Z,e,r,t,S,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,S.createDecorator)("extensionService");var I;(function(u){u[u.None=0]="None",u[u.LocalProcess=1]="LocalProcess",u[u.LocalWebWorker=2]="LocalWebWorker",u[u.Remote=3]="Remote"})(I=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function D(u){switch(u){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=D;class T{constructor(_){this.dependency=_}}e.MissingExtensionDependency=T;var R;(function(u){u[u.LocalProcess=0]="LocalProcess",u[u.LocalWebWorker=1]="LocalWebWorker",u[u.Remote=2]="Remote"})(R=e.ExtensionHostKind||(e.ExtensionHostKind={}));function b(u){switch(u){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=b;function i(u,_){return u.enabledApiProposals?u.enabledApiProposals.includes(_):!1}e.isProposedApiEnabled=i;function h(u,_){if(!i(u,_))throw new Error(`Extension '${u.identifier.value}' CANNOT use API proposal: ${_}.
Its package.json#enabledApiProposals-property declares: ${u.enabledApiProposals?.join(", ")??"[]"} but NOT ${_}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${u.identifier.value}`)}e.checkProposedApiEnabled=h;class l{constructor(_,a,F,c){this.codeLoadingTime=_,this.activateCallTime=a,this.activateResolvedTime=F,this.activationReason=c}}e.ActivationTimes=l;class o{constructor(_,a){this.description=_,this.value=a}}e.ExtensionPointContribution=o,e.ExtensionHostLogFileName="exthost";var m;(function(u){u[u.Normal=0]="Normal",u[u.Immediate=1]="Immediate"})(m=e.ActivationKind||(e.ActivationKind={}));function M(u){return{type:u.isBuiltin?0:1,isBuiltin:u.isBuiltin||u.isUserBuiltin,identifier:{id:(0,A.getGalleryExtensionId)(u.publisher,u.name),uuid:u.uuid},manifest:u,location:u.extensionLocation}}e.toExtension=M;function C(u,_){return{identifier:new P.ExtensionIdentifier((0,A.getExtensionId)(u.manifest.publisher,u.manifest.name)),isBuiltin:u.type===0,isUserBuiltin:u.type===1&&u.isBuiltin,isUnderDevelopment:!!_,extensionLocation:u.location,...u.manifest,uuid:u.identifier.uuid}}e.toExtensionDescription=C;class w{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None}activateByEvent(_){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(_){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(_){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(_){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(_,a){return Promise.resolve()}_onWillActivateExtension(_){}_onDidActivateExtension(_,a,F,c,n){}_onDidActivateExtensionError(_,a){}_onExtensionRuntimeError(_,a){}_onExtensionHostExit(_){}}e.NullExtensionService=w}),define(ye[171],Se([0,1,15,25,26,12]),function(Z,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const A=Promise.resolve(void 0);class I{constructor(o,m,M,C){this.startup=o,this.codeLoadingTime=m,this.activateCallTime=M,this.activateResolvedTime=C}}e.ExtensionActivationTimes=I,I.NONE=new I(!1,-1,-1,-1);class D{constructor(o){this._startup=o,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(o,m){return o===-1||m===-1?-1:m-o}build(){return new I(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class T{constructor(o,m,M,C,w,u){this.activationFailed=o,this.activationFailedError=m,this.activationTimes=M,this.module=C,this.exports=w,this.subscriptions=u}}e.ActivatedExtension=T;class R extends T{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class b extends T{constructor(){super(!1,null,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=b;class i extends T{constructor(o){super(!0,o,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=i;let h=class{constructor(o,m,M,C,w){this._logService=w,this._isDisposed=!1,this._registry=o,this._resolvedExtensionsSet=new Set,m.forEach(u=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,M.forEach(u=>this._hostExtensionsMap.set(t.ExtensionIdentifier.toKey(u),u)),this._host=C,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(o){const m=t.ExtensionIdentifier.toKey(o);return this._activatedExtensions.has(m)}getActivatedExtension(o){const m=t.ExtensionIdentifier.toKey(o),M=this._activatedExtensions.get(m);if(!M)throw new Error("Extension `"+o.value+"` is not known or not activated");return M}activateByEvent(o,m){if(this._alreadyActivatedEvents[o])return A;const M=this._registry.getExtensionDescriptionsForActivationEvent(o);return this._activateExtensions(M.map(C=>({id:C.identifier,reason:{startup:m,extensionId:C.identifier,activationEvent:o}}))).then(()=>{this._alreadyActivatedEvents[o]=!0})}activateById(o,m){const M=this._registry.getExtensionDescription(o);if(!M)throw new Error("Extension `"+o+"` is not known");return this._activateExtensions([{id:M.identifier,reason:m}])}_handleActivateRequest(o,m,M){if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(o.id))){m[t.ExtensionIdentifier.toKey(o.id)]=o;return}const C=this._registry.getExtensionDescription(o.id);if(!C){const _=new Error(`Cannot activate unknown extension '${o.id.value}'`);this._host.onExtensionActivationError(o.id,_,new S.MissingExtensionDependency(o.id.value)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(o.id),new i(_));return}const w=typeof C.extensionDependencies=="undefined"?[]:C.extensionDependencies;let u=!0;for(let _=0,a=w.length;_<a;_++){const F=w[_];if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(F)))continue;const c=this._activatedExtensions.get(t.ExtensionIdentifier.toKey(F));if(c&&!c.activationFailed)continue;if(c&&c.activationFailed){const s=C.displayName||C.identifier.value,d=this._registry.getExtensionDescription(F),p=d&&d.displayName||F,E=new Error(`Cannot activate the '${s}' extension because its dependency '${p}' failed to activate`);E.detail=c.activationFailedError,this._host.onExtensionActivationError(C.identifier,E,null),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(C.identifier),new i(E));return}if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(F))){u=!1,m[t.ExtensionIdentifier.toKey(F)]={id:this._hostExtensionsMap.get(t.ExtensionIdentifier.toKey(F)),reason:o.reason};continue}const n=this._registry.getExtensionDescription(F);if(n){if(!n.main&&!n.browser)continue;u=!1,m[t.ExtensionIdentifier.toKey(F)]={id:n.identifier,reason:o.reason};continue}const f=C.displayName||C.identifier.value,g=new Error(`Cannot activate the '${f}' extension because it depends on unknown extension '${F}'`);this._host.onExtensionActivationError(C.identifier,g,new S.MissingExtensionDependency(F)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(C.identifier),new i(g));return}u?m[t.ExtensionIdentifier.toKey(C.identifier)]=o:M.push(o)}_activateExtensions(o){if(o.length===0||(o=o.filter(w=>!this._activatedExtensions.has(t.ExtensionIdentifier.toKey(w.id))),o.length===0))return Promise.resolve(void 0);const m=Object.create(null),M=[];for(let w=0,u=o.length;w<u;w++)this._handleActivateRequest(o[w],m,M);for(let w=0,u=M.length;w<u;w++){const _=t.ExtensionIdentifier.toKey(M[w].id);m[_]&&delete m[_]}const C=Object.keys(m).map(w=>m[w]);return M.length===0?Promise.all(C.map(w=>this._activateExtension(w.id,w.reason))).then(w=>{}):this._activateExtensions(C).then(w=>this._activateExtensions(M))}_activateExtension(o,m){const M=t.ExtensionIdentifier.toKey(o);if(this._activatedExtensions.has(M))return Promise.resolve(void 0);const C=this._activatingExtensions.get(M);if(C)return C;const w=this._host.actualActivateExtension(o,m).then(void 0,u=>{const _=new Error;return u&&u.name&&(_.name=u.name),u&&u.message?_.message=`Activating extension '${o.value}' failed: ${u.message}.`:_.message=`Activating extension '${o.value}' failed: ${u}.`,u&&u.stack&&(_.stack=u.stack),this._isDisposed&&r.isCancellationError(u)?new i(u):(this._host.onExtensionActivationError(o,_,null),this._logService.error(`Activating extension ${o.value} failed due to an error:`),this._logService.error(u),new i(u))}).then(u=>{this._activatedExtensions.set(M,u),this._activatingExtensions.delete(M)});return this._activatingExtensions.set(M,w),w}};h=xe([$e(4,P.ILogService)],h),e.ExtensionsActivator=h}),define(ye[172],Se([0,1,12,28,26]),function(Z,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends r.LogService{constructor(I,D){super(I.createLogger(D.logFile,{name:S.ExtensionHostLogFileName}))}};P=xe([$e(0,r.ILoggerService),$e(1,t.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(ye[173],Se([0,1,15]),function(Z,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((P,A)=>{this._actualOk=P,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(P){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=P,this._actual&&this._actualOk(P))}resolveErr(P){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=P,this._actual?this._actualErr(P):(0,r.onUnexpectedError)(P))}then(P,A){return this._ensureActual().then(P,A)}catch(P){return this._ensureActual().then(void 0,P)}finally(P){return this._ensureActual().finally(P)}}e.LazyPromise=t}),define(ye[38],Se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class r{constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++r.count}}e.ProxyIdentifier=r,r.count=0;const t=[];function S(I){const D=new r(I);return t[D.nid]=D,D}e.createProxyIdentifier=S;function P(I){return t[I].sid}e.getStringIdentifierForProxy=P;class A{constructor(D){this.value=D}}e.SerializableObjectWithBuffers=A}),define(ye[5],Se([0,1,55,2,38]),function(Z,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var P;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(P=e.UIKind||(e.UIKind={}));var A;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(w){w[w.Editable=0]="Editable",w[w.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(w){w[w.Int8Array=1]="Int8Array",w[w.Uint8Array=2]="Uint8Array",w[w.Uint8ClampedArray=3]="Uint8ClampedArray",w[w.Int16Array=4]="Int16Array",w[w.Uint16Array=5]="Uint16Array",w[w.Int32Array=6]="Int32Array",w[w.Uint32Array=7]="Uint32Array",w[w.Float32Array=8]="Float32Array",w[w.Float64Array=9]="Float64Array",w[w.BigInt64Array=10]="BigInt64Array",w[w.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var T;(function(w){w[w.Text=1]="Text",w[w.Error=2]="Error",w[w.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var b;(function(w){w[w.None=0]="None",w[w.Process=1]="Process",w[w.Output=2]="Output"})(b=e.CandidatePortSource||(e.CandidatePortSource={}));var i;(function(w){w.name="$ident";function u(a,F){return Object.defineProperty(a,w.name,{value:F,enumerable:!0}),a}w.mixin=u;function _(a){return a[w.name]}w.of=_})(i=e.ObjectIdentifier||(e.ObjectIdentifier={}));class h{static mixin(u){return u._id=h._n++,u}}e.IdObject=h,h._n=0;var l;(function(w){w.label="a",w.kind="b",w.detail="c",w.documentation="d",w.sortText="e",w.filterText="f",w.preselect="g",w.insertText="h",w.insertTextRules="i",w.range="j",w.commitCharacters="k",w.additionalTextEdits="l",w.command="m",w.kindModifier="n"})(l=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var o;(function(w){w.defaultRanges="a",w.completions="b",w.isIncomplete="c",w.duration="d"})(o=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(w){w[w.File=1]="File",w[w.Text=2]="Text",w[w.Cell=3]="Cell"})(m=e.WorkspaceEditType||(e.WorkspaceEditType={}));function M(w){if(w&&w.edits)for(const u of w.edits)typeof u.resource=="object"?u.resource=t.URI.revive(u.resource):(u.newUri=t.URI.revive(u.newUri),u.oldUri=t.URI.revive(u.oldUri)),u.metadata&&u.metadata.iconPath&&(u.metadata=(0,r.revive)(u.metadata));return w}e.reviveWorkspaceEditDto=M;var C;(function(w){w[w.Workspace=0]="Workspace",w[w.TextDocument=1]="TextDocument"})(C=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,S.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,S.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,S.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,S.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,S.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,S.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,S.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,S.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,S.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,S.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,S.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,S.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,S.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,S.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,S.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,S.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,S.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,S.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,S.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,S.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,S.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,S.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,S.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,S.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,S.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,S.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,S.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,S.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,S.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,S.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,S.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,S.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,S.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,S.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,S.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,S.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,S.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,S.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,S.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,S.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,S.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,S.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,S.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,S.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,S.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,S.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,S.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,S.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,S.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,S.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,S.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,S.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,S.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,S.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,S.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,S.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,S.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,S.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,S.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,S.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,S.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,S.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,S.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,S.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,S.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,S.createProxyIdentifier)("ExtHostTelemetry")}}),define(ye[67],Se([0,1,5,4,3]),function(Z,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(I){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(r.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,D){return this._proxy.$getPassword(I,D)}store(I,D,T){return this._proxy.$setPassword(I,D,T)}delete(I,D){return this._proxy.$deletePassword(I,D)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,S.createDecorator)("IExtHostSecretState")}),define(ye[68],Se([0,1,3,12,5,14]),function(Z,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,r.createDecorator)("IExtHostApiDeprecationService");let A=class{constructor(D,T){this._extHostLogService=T,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(S.MainContext.MainThreadTelemetry)}report(D,T,R){const b=this.getUsageKey(D,T);this._reportedUsages.has(b)||(this._reportedUsages.add(b),T.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:D}))}getUsageKey(D,T){return`${D}-${T.identifier.value}`}};A=xe([$e(0,P.IExtHostRpcService),$e(1,t.ILogService)],A),e.ExtHostApiDeprecationService=A,e.NullApiDeprecationService=Object.freeze(new class{report(I,D,T){}})}),define(ye[174],Se([0,1,4,5,7,25]),function(Z,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new r.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}async getSession(D,T,R,b={}){const i=P.ExtensionIdentifier.toKey(D.identifier),h=this._inFlightRequests.get(i)||[],l=[...R].sort().join(" ");let o=h.find(m=>m.scopes===l);if(o)return o.result;{const m=this._getSession(D,i,T,R,b);o={scopes:l,result:m},h.push(o),this._inFlightRequests.set(i,h);try{await m}finally{const M=h.findIndex(C=>C.scopes===l);M>-1&&(h.splice(M),this._inFlightRequests.set(i,h))}return m}}async _getSession(D,T,R,b,i={}){await this._proxy.$ensureProvider(R);const h=D.displayName||D.name;return this._proxy.$getSession(R,b,T,h,i)}async removeSession(D,T){const R=this._authenticationProviders.get(D);return R?R.provider.removeSession(T):this._proxy.$removeSession(D,T)}registerAuthenticationProvider(D,T,R,b){if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:T,provider:R,options:b??{supportsMultipleAccounts:!1}}),this._providers.find(h=>h.id===D)||this._providers.push({id:D,label:T});const i=R.onDidChangeSessions(h=>{this._proxy.$sendDidChangeSessions(D,{added:h.added??[],changed:h.changed??[],removed:h.removed??[]})});return this._proxy.$registerAuthenticationProvider(D,T,b?.supportsMultipleAccounts??!1),new S.Disposable(()=>{i.dispose(),this._authenticationProviders.delete(D);const h=this._providers.findIndex(l=>l.id===D);h>-1&&this._providers.splice(h),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,T){const R=this._authenticationProviders.get(D);if(R)return Promise.resolve(R.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,T){const R=this._authenticationProviders.get(D);if(R)return Promise.resolve(R.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,T){const R=this._authenticationProviders.get(D);if(R)return Promise.resolve(R.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,T){return this._onDidChangeSessions.fire({provider:{id:D,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=A}),define(ye[175],Se([0,1,5,14,8]),function(Z,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(I,D){this._extHostDocumentsAndEditors=D,this._proxy=I.getProxy(r.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(I){const D=S.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};P=xe([$e(0,t.IExtHostRpcService)],P),e.ExtHostBulkEdits=P}),define(ye[176],Se([0,1,5]),function(Z,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(P){const A=P.getProxy(r.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(I){return A.$writeText(I)}})}}e.ExtHostClipboard=t});var Xe=this&&this.__classPrivateFieldSet||function(Z,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(Z,r):S?S.value=r:e.set(Z,r),r},Ie=this&&this.__classPrivateFieldGet||function(Z,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[39],Se([0,1,13,7,8,27,5,16,12,55,58,227,2,6,3,14,48,21,38,43]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i,h,l,o,m,M,C,w){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let _=class{constructor(g,s){u.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,Xe(this,u,g.getProxy(A.MainContext.MainThreadCommands),"f"),this._logService=s,this.converter=new a(this,d=>{const p=this._apiCommands.get(d);return p?.result===c.Void?p:void 0},s),this._argumentProcessors=[{processArgument(d){return(0,T.revive)(d)}},{processArgument(d){return(0,P.cloneAndChange)(d,function(p){if(R.Range.isIRange(p))return S.Range.to(p);if(b.Position.isIPosition(p))return S.Position.to(p);if(R.Range.isIRange(p.range)&&i.URI.isUri(p.uri))return S.location.to(p);if(p instanceof M.VSBuffer)return p.buffer.buffer;if(!Array.isArray(p))return p})}}]}registerArgumentProcessor(g){this._argumentProcessors.push(g)}registerApiCommand(g){const s=this.registerCommand(!1,g.id,async(...d)=>{const p=g.args.map((v,k)=>{if(!v.validate(d[k]))throw new Error(`Invalid argument '${v.name}' when running '${g.id}', received: ${d[k]}`);return v.convert(d[k])}),E=await this.executeCommand(g.internalId,...p);return g.result.convert(E,d,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this._apiCommands.set(g.id,g),new t.Disposable(()=>{s.dispose(),this._apiCommands.delete(g.id)})}registerCommand(g,s,d,p,E,v){if(this._logService.trace("ExtHostCommands#registerCommand",s),!s.trim().length)throw new Error("invalid id");if(this._commands.has(s))throw new Error(`command '${s}' already exists`);return this._commands.set(s,{callback:d,thisArg:p,description:E,extension:v}),g&&Ie(this,u,"f").$registerCommand(s),new t.Disposable(()=>{this._commands.delete(s)&&g&&Ie(this,u,"f").$unregisterCommand(s)})}executeCommand(g,...s){return this._logService.trace("ExtHostCommands#executeCommand",g),this._doExecuteCommand(g,s,!0)}async _doExecuteCommand(g,s,d){if(this._commands.has(g))return this._executeContributedCommand(g,s,!1);{let p=!1;const E=(0,P.cloneAndChange)(s,function(v){if(v instanceof t.Position)return S.Position.from(v);if(v instanceof t.Range)return S.Range.from(v);if(v instanceof t.Location)return S.location.from(v);if(t.NotebookRange.isNotebookRange(v))return S.NotebookRange.from(v);if(v instanceof ArrayBuffer)return p=!0,M.VSBuffer.wrap(new Uint8Array(v));if(v instanceof Uint8Array)return p=!0,M.VSBuffer.wrap(v);if(!Array.isArray(v))return v});try{const v=await Ie(this,u,"f").$executeCommand(g,p?new C.SerializableObjectWithBuffers(E):E,d);return(0,T.revive)(v)}catch(v){if(v instanceof Error&&v.message==="$executeCommand:retry")return this._doExecuteCommand(g,s,!1);throw v}}}async _executeContributedCommand(g,s,d){const p=this._commands.get(g);if(!p)throw new Error("Unknown command");let{callback:E,thisArg:v,description:k}=p;if(k)for(let L=0;L<k.args.length;L++)try{(0,r.validateConstraint)(s[L],k.args[L].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${k.args[L].name}' - ${k.args[L].description}`)}try{return await E.apply(v,s)}catch(L){if(g===this.converter.delegatingCommandId){const y=this.converter.getActualCommand(...s);y&&(g=y.command)}throw this._logService.error(L,g,p.extension?.identifier),d?new class extends Error{constructor(){super((0,w.toErrorMessage)(L));this.id=g,this.source=p.extension?.displayName??p.extension?.name}}:L}}$executeContributedCommand(g,...s){return this._logService.trace("ExtHostCommands#$executeContributedCommand",g),this._commands.has(g)?(s=s.map(d=>this._argumentProcessors.reduce((p,E)=>E.processArgument(p),d)),this._executeContributedCommand(g,s,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this._logService.trace("ExtHostCommands#getCommands",g),Ie(this,u,"f").$getCommands().then(s=>(g&&(s=s.filter(d=>d[0]!=="_")),s))}$getContributedCommandHandlerDescriptions(){const g=Object.create(null);for(let[s,d]of this._commands){let{description:p}=d;p&&(g[s]=p)}return Promise.resolve(g)}};u=new WeakMap,_=xe([$e(0,o.IExtHostRpcService),$e(1,D.ILogService)],_),e.ExtHostCommands=_,e.IExtHostCommands=(0,l.createDecorator)("IExtHostCommands");class a{constructor(g,s,d){this._commands=g,this._lookupApiCommand=s,this._logService=d,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(g,s){if(!g)return;const d={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return d;const p=this._lookupApiCommand(g.command);if(p)d.id=p.internalId,d.arguments=p.args.map((E,v)=>E.convert(g.arguments&&g.arguments[v]));else if((0,I.isNonEmptyArray)(g.arguments)){const E=++this._cachIdPool;this._cache.set(E,g),s.add((0,h.toDisposable)(()=>{this._cache.delete(E),this._logService.trace("CommandsConverter#DISPOSE",E)})),d.$ident=E,d.id=this.delegatingCommandId,d.arguments=[E],this._logService.trace("CommandsConverter#CREATE",g.command,E)}return d}fromInternal(g){const s=A.ObjectIdentifier.of(g);return typeof s=="number"?this._cache.get(s):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this._cache.get(g[0])}_executeConvertedCommand(...g){const s=this.getActualCommand(...g);return this._logService.trace("CommandsConverter#EXECUTE",g[0],s?s.command:"MISSING"),s?this._commands.executeCommand(s.command,...s.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=a;class F{constructor(g,s,d,p){this.name=g,this.description=s,this.validate=d,this.convert=p}optional(){return new F(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,s){return new F(g??this.name,s??this.description,this.validate,this.convert)}}e.ApiCommandArgument=F,F.Uri=new F("uri","Uri of a text document",f=>i.URI.isUri(f),f=>f),F.Position=new F("position","A position in a text document",f=>t.Position.isPosition(f),S.Position.from),F.Range=new F("range","A range in a text document",f=>t.Range.isRange(f),S.Range.from),F.Selection=new F("selection","A selection in a text document",f=>t.Selection.isSelection(f),S.Selection.from),F.Number=new F("number","",f=>typeof f=="number",f=>f),F.String=new F("string","",f=>typeof f=="string",f=>f),F.CallHierarchyItem=new F("item","A call hierarchy item",f=>f instanceof t.CallHierarchyItem,S.CallHierarchyItem.from),F.TypeHierarchyItem=new F("item","A type hierarchy item",f=>f instanceof t.TypeHierarchyItem,S.TypeHierarchyItem.from),F.TestItem=new F("testItem","A VS Code TestItem",f=>f instanceof m.TestItemImpl,S.TestItem.from);class c{constructor(g,s){this.description=g,this.convert=s}}e.ApiCommandResult=c,c.Void=new c("no result",f=>f);class n{constructor(g,s,d,p,E){this.id=g,this.internalId=s,this.description=d,this.args=p,this.result=E}}e.ApiCommand=n}),define(ye[177],Se([0,1,8,7,57,39,16,77]),function(Z,e,r,t,S,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new P.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",R(r.DocumentHighlight.to))),new P.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(i,h)=>{if((0,A.isFalsyOrEmpty)(i))return;class l extends t.SymbolInformation{static to(m){const M=new l(m.name,r.SymbolKind.to(m.kind),m.containerName||"",new t.Location(h[0],r.Range.to(m.range)));return M.detail=m.detail,M.range=M.location.range,M.selectionRange=r.Range.to(m.selectionRange),M.children=m.children?m.children.map(l.to):[],M}}return i.map(l.to)})),new P.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new P.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(r.TextEdit.to))),new P.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range,new P.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new P.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(r.TextEdit.to))),new P.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,new P.ApiCommandArgument("ch","Trigger character",i=>typeof i=="string",i=>i),new P.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new P.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(r.TextEdit.to))),new P.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new P.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new P.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new P.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new P.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location-instances.",R(r.location.to))),new P.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Hover-instances.",R(r.Hover.to))),new P.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("position","A position in a text document",i=>Array.isArray(i)&&i.every(h=>t.Position.isPosition(h)),i=>i.map(r.Position.from))],new P.ApiCommandResult("A promise that resolves to an array of ranges.",i=>i.map(h=>{let l;for(const o of h.reverse())l=new t.SelectionRange(r.Range.to(o),l);return l}))),new P.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[P.ApiCommandArgument.String.with("query","Search string")],new P.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",i=>i.map(r.WorkspaceSymbol.to))),new P.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(r.CallHierarchyItem.to))),new P.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[P.ApiCommandArgument.CallHierarchyItem],new P.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(r.CallHierarchyIncomingCall.to))),new P.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[P.ApiCommandArgument.CallHierarchyItem],new P.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(r.CallHierarchyOutgoingCall.to))),new P.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to a range and placeholder text.",i=>{if(!!i)return{range:r.Range.to(i.range),placeholder:i.text}})),new P.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,P.ApiCommandArgument.String.with("newName","The new symbol name")],new P.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",i=>{if(!!i){if(i.rejectReason)throw new Error(i.rejectReason);return r.WorkspaceEdit.to(i)}})),new P.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new P.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",i=>i.map(r.DocumentLink.to))),new P.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new t.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new P.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const h=(0,I.decodeSemanticTokensDto)(i);if(h.type==="full")return new t.SemanticTokens(h.data,void 0)})),new P.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range.optional()],new P.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new t.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new P.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range],new P.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const h=(0,I.decodeSemanticTokensDto)(i);if(h.type==="full")return new t.SemanticTokens(h.data,void 0)})),new P.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,P.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),P.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new P.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(i,h,l)=>{if(!i)return new t.CompletionList([]);const o=i.suggestions.map(m=>r.CompletionItem.to(m,l));return new t.CompletionList(o,i.incomplete)})),new P.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,P.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new P.ApiCommandResult("A promise that resolves to SignatureHelp.",i=>{if(i)return r.SignatureHelp.to(i)})),new P.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new P.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(i,h,l)=>R(o=>new t.CodeLens(r.Range.to(o.range),o.command&&l.fromInternal(o.command)))(i))),new P.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",i=>t.Range.isRange(i),i=>t.Selection.isSelection(i)?r.Selection.from(i):r.Range.from(i)),P.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),P.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new P.ApiCommandResult("A promise that resolves to an array of Command-instances.",(i,h,l)=>R(o=>{if(o._isSynthetic){if(!o.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(o.command)}else{const m=new t.CodeAction(o.title,o.kind?new t.CodeActionKind(o.kind):void 0);return o.edit&&(m.edit=r.WorkspaceEdit.to(o.edit)),o.command&&(m.command=l.fromInternal(o.command)),m.isPreferred=o.isPreferred,m}})(i))),new P.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",i=>i?i.map(h=>new t.ColorInformation(r.Range.to(h.range),r.Color.to(h.color))):[])),new P.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new P.ApiCommandArgument("color","The color to show and insert",i=>i instanceof t.Color,r.Color.from),new P.ApiCommandArgument("context","Context object with uri and range",i=>!0,i=>({uri:i.uri,range:r.Range.from(i.range)}))],new P.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",i=>i?i.map(r.ColorPresentation.to):[])),new P.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range],new P.ApiCommandResult("A promise that resolves to an array of Inlay objects",(i,h,l)=>i.map(r.InlayHint.to.bind(void 0,l)))),new P.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new P.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",R(i=>({viewType:i.viewType,displayName:i.displayName,options:{transientOutputs:i.options.transientOutputs,transientCellMetadata:i.options.transientCellMetadata,transientDocumentMetadata:i.options.transientDocumentMetadata},filenamePattern:i.filenamePattern.map(h=>r.NotebookExclusiveDocumentPattern.to(h))})))),new P.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range],new P.ApiCommandResult("A promise that resolves to an array of InlineValue objects",i=>i.map(r.InlineValue.to))),new P.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[r.ViewColumn.from(i),void 0]:[r.ViewColumn.from(i.viewColumn),r.TextEditorOpenOptions.from(i)])).optional(),P.ApiCommandArgument.String.with("label","").optional()],P.ApiCommandResult.Void),new P.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[P.ApiCommandArgument.Uri.with("resource","Resource to open"),P.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new P.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[r.ViewColumn.from(i),void 0]:[r.ViewColumn.from(i.viewColumn),r.TextEditorOpenOptions.from(i)])).optional()],P.ApiCommandResult.Void),new P.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[P.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),P.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),P.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new P.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="object",i=>i&&[r.ViewColumn.from(i.viewColumn),r.TextEditorOpenOptions.from(i)]).optional()],P.ApiCommandResult.Void),new P.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(r.TypeHierarchyItem.to))),new P.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[P.ApiCommandArgument.TypeHierarchyItem],new P.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(r.TypeHierarchyItem.to))),new P.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[P.ApiCommandArgument.TypeHierarchyItem],new P.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(r.TypeHierarchyItem.to))),new P.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[P.ApiCommandArgument.TestItem],P.ApiCommandResult.Void)];class T{static register(h){D.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=T;function R(i){return h=>{if(Array.isArray(h))return h.map(i)}}function b(i){if(!Array.isArray(i))return;const h=[];for(const l of i)S.isLocationLink(l)?h.push(r.DefinitionLink.to(l)):h.push(r.location.to(l));return h}}),define(ye[178],Se([0,1,10,53,4,6,2,57,25,8,7,26,5]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function h(l,o,m){const M=l.getProxy(i.MainContext.MainThreadComments);class C{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,o.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const g=this._commentControllers.get(f.handle);return g||f}else if(f&&f.$mid===7){const g=this._commentControllers.get(f.commentControlHandle);if(!g)return f;const s=g.getCommentThread(f.commentThreadHandle);return s||f}else if(f&&f.$mid===8){const g=this._commentControllers.get(f.thread.commentControlHandle);if(!g)return f;const s=g.getCommentThread(f.thread.commentThreadHandle);return s?{thread:s,text:f.text}:f}else if(f&&f.$mid===9){const g=this._commentControllers.get(f.thread.commentControlHandle);if(!g)return f;const s=g.getCommentThread(f.thread.commentThreadHandle);if(!s)return f;let d=f.commentUniqueId,p=s.getCommentByUniqueId(d);return p||f}else if(f&&f.$mid===10){const g=this._commentControllers.get(f.thread.commentControlHandle);if(!g)return f;const s=g.getCommentThread(f.thread.commentThreadHandle);if(!s)return f;let d=f.text,p=f.commentUniqueId,E=s.getCommentByUniqueId(p);return E?(E.body=d,E):f}return f}})}createCommentController(f,g,s){const d=C.handlePool++,p=new u(f,d,g,s);this._commentControllers.set(p.handle,p);const E=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(f.identifier))||[];return E.push(p),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(f.identifier),E),p.value}$createCommentThreadTemplate(f,g,s){const d=this._commentControllers.get(f);!d||d.$createCommentThreadTemplate(g,s)}async $updateCommentThreadTemplate(f,g,s){const d=this._commentControllers.get(f);!d||d.$updateCommentThreadTemplate(g,s)}$deleteCommentThread(f,g){const s=this._commentControllers.get(f);s&&s.$deleteCommentThread(g)}$provideCommentingRanges(f,g,s){const d=this._commentControllers.get(f);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const p=m.getDocument(A.URI.revive(g));return(0,r.asPromise)(()=>d.commentingRangeProvider.provideCommentingRanges(p,s)).then(E=>E?E.map(v=>T.Range.from(v)):void 0)}$toggleReaction(f,g,s,d,p){const E=this._commentControllers.get(f);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,r.asPromise)(()=>{const v=E.getCommentThread(g);if(v){const k=v.getCommentByUniqueId(d.uniqueIdInThread);if(E!==void 0&&k&&E.reactionHandler)return E.reactionHandler(k,F(p))}return Promise.resolve(void 0)})}dispose(){}}C.handlePool=0;class w{constructor(f,g,s,d,p,E,v){this._commentControllerHandle=g,this._id=s,this._uri=d,this._range=p,this._comments=E,this.extensionDescription=v,this.handle=w._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new S.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${f}.${this.handle}`),M.$createCommentThread(g,this.handle,this._id,this._uri,T.Range.from(this._range),v.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this._localDisposables.push({dispose:()=>{M.$deleteCommentThread(g,this.handle)}});const k=this;this.value={get uri(){return k.uri},get range(){return k.range},set range(L){k.range=L},get comments(){return k.comments},set comments(L){k.comments=L},get collapsibleState(){return k.collapsibleState},set collapsibleState(L){k.collapsibleState=L},get canReply(){return k.canReply},set canReply(L){k.canReply=L},get contextValue(){return k.contextValue},set contextValue(L){k.contextValue=L},get label(){return k.label},set label(L){k.label=L},dispose:()=>{k.dispose()}}}set threadId(f){this._id=f}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(f){f.isEqual(this._range)||(this._range=f,this.modifications.range=f,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(f){this._canReply!==f&&(this._canReply=f,this.modifications.canReply=f,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(f){this._label=f,this.modifications.label=f,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(f){this._contextValue=f,this.modifications.contextValue=f,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(f){this._comments=f,this.modifications.comments=f,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(f){this._collapseState=f,this.modifications.collapsibleState=f,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const f=s=>Object.prototype.hasOwnProperty.call(this.modifications,s),g={};f("range")&&(g.range=T.Range.from(this._range)),f("label")&&(g.label=this.label),f("contextValue")&&(g.contextValue=this.contextValue??null),f("comments")&&(g.comments=this._comments.map(s=>_(this,s,this._commentsMap))),f("collapsibleState")&&(g.collapseState=c(this._collapseState)),f("canReply")&&(g.canReply=this.canReply),this.modifications={},M.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,g)}getCommentByUniqueId(f){for(let g of this._commentsMap){let s=g[0],d=g[1];if(f===d)return s}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(f=>f.dispose())}}w._handlePool=0,xe([(0,t.debounce)(100)],w.prototype,"eventuallyUpdateCommentThread",null);class u{constructor(f,g,s,d){this._extension=f,this._handle=g,this._id=s,this._label=d,this._threads=new Map,M.$registerCommentController(this.handle,s,d);const p=this;this.value=Object.freeze({id:p.id,label:p.label,get options(){return p.options},set options(E){p.options=E},get commentingRangeProvider(){return p.commentingRangeProvider},set commentingRangeProvider(E){p.commentingRangeProvider=E},get reactionHandler(){return p.reactionHandler},set reactionHandler(E){p.reactionHandler=E},createCommentThread(E,v,k){return p.createCommentThread(E,v,k).value},dispose:()=>{p.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{M.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(f){this._commentingRangeProvider=f,M.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(f){this._reactionHandler=f,M.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this._options}set options(f){this._options=f,M.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(f,g,s,d){if(typeof f=="string"){const p=new w(this.id,this.handle,f,g,s,d,this._extension);return this._threads.set(p.handle,p),p}else{const p=new w(this.id,this.handle,void 0,f,g,s,this._extension);return this._threads.set(p.handle,p),p}}$createCommentThreadTemplate(f,g){const s=new w(this.id,this.handle,void 0,A.URI.revive(f),T.Range.to(g),[],this._extension);return s.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(s.handle,s),s}$updateCommentThreadTemplate(f,g){let s=this._threads.get(f);s&&(s.range=T.Range.to(g))}$deleteCommentThread(f){let g=this._threads.get(f);g&&g.dispose(),this._threads.delete(f)}getCommentThread(f){return this._threads.get(f)}dispose(){this._threads.forEach(f=>{f.dispose()}),this._localDisposables.forEach(f=>f.dispose())}}function _(n,f,g){let s=g.get(f);s||(s=++n.commentHandle,g.set(f,s));const d=f.author&&f.author.iconPath?f.author.iconPath.toString():void 0;f.detail&&(0,b.checkProposedApiEnabled)(n.extensionDescription,"commentTimestamp");let p;return f.detail&&typeof f.detail!="string"?p={source:f.detail,$mid:14}:p=f.detail,{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:s,body:T.MarkdownString.from(f.body),userName:f.author.name,userIconPath:d,label:f.label,commentReactions:f.reactions?f.reactions.map(E=>a(E)):void 0,detail:p}}function a(n){return{label:n.label,iconPath:n.iconPath?T.pathOrURIToURI(n.iconPath):void 0,count:n.count,hasReacted:n.authorHasReacted}}function F(n){return{label:n.label||"",count:n.count||0,iconPath:n.iconPath?A.URI.revive(n.iconPath):"",authorHasReacted:n.hasReacted||!1}}function c(n){if(n!==void 0)switch(n){case R.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}return new C}e.createExtHostComments=h}),define(ye[91],Se([0,1,2,5,7,3,14,12,16,9,17]),function(Z,e,r,t,S,P,A,I,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let b=class _i{constructor(h,l){this._logService=l,this._provider=new Map,this._proxy=h.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,l){const o=_i._handlePool++;this._provider.set(o,{provider:h,extensionId:l}),this._proxy.$registerDecorationProvider(o,l.value);const m=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(M=>{if(!M){this._proxy.$onDidChange(o,null);return}let C=(0,D.asArray)(M);if(C.length<=_i._maxEventSize){this._proxy.$onDidChange(o,C);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",l.value,C.length);const w=C.map(a=>({uri:a,rank:(0,T.count)(a.path,"/")})),u=(0,D.groupBy)(w,(a,F)=>a.rank-F.rank||(0,T.compare)(a.uri.path,F.uri.path));let _=[];e:for(let a of u){let F;for(let c of a){let n=(0,R.dirname)(c.uri.path);if(F!==n&&(F=n,_.push(c.uri)>=_i._maxEventSize))break e}}this._proxy.$onDidChange(o,_)});return new S.Disposable(()=>{m?.dispose(),this._proxy.$unregisterDecorationProvider(o),this._provider.delete(o)})}async $provideDecorations(h,l,o){if(!this._provider.has(h))return Object.create(null);const m=Object.create(null),{provider:M,extensionId:C}=this._provider.get(h);return await Promise.all(l.map(async w=>{try{const{uri:u,id:_}=w,a=await Promise.resolve(M.provideFileDecoration(r.URI.revive(u),o));if(!a)return;try{S.FileDecoration.validate(a),m[_]=[a.propagate,a.tooltip,a.badge,a.color]}catch(F){this._logService.warn(`INVALID decoration from extension '${C.value}': ${F}`)}}catch(u){this._logService.error(u)}})),m}};b._handlePool=0,b._maxEventSize=250,b=xe([$e(0,A.IExtHostRpcService),$e(1,I.ILogService)],b),e.ExtHostDecorations=b,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")});var Xe=this&&this.__classPrivateFieldSet||function(Z,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(Z,r):S?S.value=r:e.set(Z,r),r},Ie=this&&this.__classPrivateFieldGet||function(Z,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[179],Se([0,1,118,80,2,5,7,8,4,12,22,30]),function(Z,e,r,t,S,P,A,I,D,T,R,b){"use strict";var i,h,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class o{constructor(C,w,u,_,a,F){this._name=C,this._owner=w,this._maxDiagnosticsPerFile=u,i.set(this,void 0),h.set(this,void 0),l.set(this,void 0),this._isDisposed=!1,Xe(this,l,new R.ResourceMap(c=>_.getComparisonKey(c)),"f"),Xe(this,i,a,"f"),Xe(this,h,F,"f")}dispose(){this._isDisposed||(Ie(this,h,"f").fire([...Ie(this,l,"f").keys()]),Ie(this,i,"f")&&Ie(this,i,"f").$clear(this._owner),Ie(this,l,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(C,w){if(!C){this.clear();return}this._checkDisposed();let u=[];if(S.URI.isUri(C)){if(!w){this.delete(C);return}Ie(this,l,"f").set(C,w.slice()),u=[C]}else if(Array.isArray(C)){u=[];let a;C=[...C].sort(o._compareIndexedTuplesByUri);for(const F of C){const[c,n]=F;if((!a||c.toString()!==a.toString())&&(a&&Ie(this,l,"f").get(a).length===0&&Ie(this,l,"f").delete(a),a=c,u.push(c),Ie(this,l,"f").set(c,[])),n){const f=Ie(this,l,"f").get(c);f&&f.push(...n)}else{const f=Ie(this,l,"f").get(c);f&&(f.length=0)}}}if(Ie(this,h,"f").fire(u),!Ie(this,i,"f"))return;const _=[];for(let a of u){let F=[];const c=Ie(this,l,"f").get(a);if(c)if(c.length>this._maxDiagnosticsPerFile){F=[];const n=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let f=0;f<4;f++)for(let g of c)if(g.severity===n[f]&&F.push(I.Diagnostic.from(g))===this._maxDiagnosticsPerFile)break e;F.push({severity:t.MarkerSeverity.Info,message:(0,r.localize)(0,null,c.length-this._maxDiagnosticsPerFile),startLineNumber:F[F.length-1].startLineNumber,startColumn:F[F.length-1].startColumn,endLineNumber:F[F.length-1].endLineNumber,endColumn:F[F.length-1].endColumn})}else F=c.map(n=>I.Diagnostic.from(n));_.push([a,F])}Ie(this,i,"f").$changeMany(this._owner,_)}delete(C){this._checkDisposed(),Ie(this,h,"f").fire([C]),Ie(this,l,"f").delete(C),Ie(this,i,"f")&&Ie(this,i,"f").$changeMany(this._owner,[[C,void 0]])}clear(){this._checkDisposed(),Ie(this,h,"f").fire([...Ie(this,l,"f").keys()]),Ie(this,l,"f").clear(),Ie(this,i,"f")&&Ie(this,i,"f").$clear(this._owner)}forEach(C,w){this._checkDisposed();for(let u of Ie(this,l,"f").keys())C.apply(w,[u,this.get(u),this])}get(C){this._checkDisposed();const w=Ie(this,l,"f").get(C);return Array.isArray(w)?Object.freeze(w.slice(0)):[]}has(C){return this._checkDisposed(),Array.isArray(Ie(this,l,"f").get(C))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(C,w){return C[0].toString()<w[0].toString()?-1:C[0].toString()>w[0].toString()?1:0}}e.DiagnosticCollection=o,i=new WeakMap,h=new WeakMap,l=new WeakMap;let m=class si{constructor(C,w,u){this._logService=w,this._fileSystemInfoService=u,this._collections=new Map,this._onDidChangeDiagnostics=new D.DebounceEmitter({merge:_=>_.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this._onDidChangeDiagnostics.event,si._mapper),this._proxy=C.getProxy(P.MainContext.MainThreadDiagnostics)}static _mapper(C){const w=new R.ResourceMap;for(const u of C)w.set(u,u);return{uris:Object.freeze(Array.from(w.values()))}}createDiagnosticCollection(C,w){const{_collections:u,_proxy:_,_onDidChangeDiagnostics:a,_logService:F,_fileSystemInfoService:c}=this,n=new class{$changeMany(s,d){_.$changeMany(s,d),F.trace("[DiagnosticCollection] change many (extension, owner, uris)",C.value,s,d.length===0?"CLEARING":d)}$clear(s){_.$clear(s),F.trace("[DiagnosticCollection] remove all (extension, owner)",C.value,s)}dispose(){_.dispose()}};let f;if(!w)w="_generated_diagnostic_collection_name_#"+si._idPool++,f=w;else if(!u.has(w))f=w;else{this._logService.warn(`DiagnosticCollection with name '${w}' does already exist.`);do f=w+si._idPool++;while(u.has(f))}return new class extends o{constructor(){super(w,f,si._maxDiagnosticsPerFile,c.extUri,n,a);u.set(f,this)}dispose(){super.dispose(),u.delete(f)}}}getDiagnostics(C){if(C)return this._getDiagnostics(C);{const w=new Map,u=[];for(const _ of this._collections.values())_.forEach((a,F)=>{let c=w.get(a.toString());typeof c=="undefined"&&(c=u.length,w.set(a.toString(),c),u.push([a,[]])),u[c][1]=u[c][1].concat(...F)});return u}}_getDiagnostics(C){let w=[];for(let u of this._collections.values())u.has(C)&&(w=w.concat(u.get(C)));return w}$acceptMarkersChange(C){if(!this._mirrorCollection){const w="_generated_mirror",u=new o(w,w,si._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(w,u),this._mirrorCollection=u}for(const[w,u]of C)this._mirrorCollection.set(S.URI.revive(w),u.map(I.Diagnostic.to))}};m._idPool=0,m._maxDiagnosticsPerFile=1e3,m=xe([$e(1,T.ILogService),$e(2,b.IExtHostFileSystemInfo)],m),e.ExtHostDiagnostics=m}),define(ye[180],Se([0,1,2,5]),function(Z,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class S{constructor(A){this._proxy=A.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(A){return this._proxy.$showOpenDialog(A).then(I=>I?I.map(D=>r.URI.revive(D)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(I=>I?r.URI.revive(I):void 0)}}e.ExtHostDialogs=S}),define(ye[181],Se([0,1,15,2,7,5,11,20,9]),function(Z,e,r,t,S,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(b,i,h){this._documentsAndEditors=i,this._logService=h,this._documentContentProviders=new Map,this._proxy=b.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(b,i){if(Object.keys(A.Schemas).indexOf(b)>=0)throw new Error(`scheme '${b}' already registered`);const h=T._handlePool++;this._documentContentProviders.set(h,i),this._proxy.$registerTextContentProvider(h,b);let l;return typeof i.onDidChange=="function"&&(l=i.onDidChange(o=>{if(o.scheme!==b){this._logService.warn(`Provider for scheme '${b}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(o)&&this.$provideTextDocumentContent(h,o).then(m=>{if(!m&&typeof m!="string")return;const M=this._documentsAndEditors.getDocument(o);if(!M)return;const C=(0,D.splitLines)(m);if(!M.equalLines(C))return this._proxy.$onVirtualDocumentChange(o,m)},r.onUnexpectedError)})),new S.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),l&&(l.dispose(),l=void 0)})}$provideTextDocumentContent(b,i){const h=this._documentContentProviders.get(b);return h?Promise.resolve(h.provideTextDocumentContent(t.URI.revive(i),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${i.scheme}`))}}e.ExtHostDocumentContentProvider=T,T._handlePool=0}),define(ye[182],Se([0,1,4,6,2,5,84,8,13,27,7]),function(Z,e,r,t,S,P,A,I,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class b{constructor(h,l){this._onDidAddDocument=new r.Emitter,this._onDidRemoveDocument=new r.Emitter,this._onDidChangeDocument=new r.Emitter,this._onDidSaveDocument=new r.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=h.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=l,this._documentsAndEditors.onDidRemoveDocuments(o=>{for(const m of o)this._onDidRemoveDocument.fire(m.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(o=>{for(const m of o)this._onDidAddDocument.fire(m.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(h){if(!h)return;const l=this._documentsAndEditors.getDocument(h);if(l)return l}getDocument(h){const l=this.getDocumentData(h);if(!l?.document)throw new Error(`Unable to retrieve document from URI '${h}'`);return l.document}ensureDocumentData(h){const l=this._documentsAndEditors.getDocument(h);if(l)return Promise.resolve(l);let o=this._documentLoader.get(h.toString());return o||(o=this._proxy.$tryOpenDocument(h).then(m=>{this._documentLoader.delete(h.toString());const M=S.URI.revive(m);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(M))},m=>(this._documentLoader.delete(h.toString()),Promise.reject(m))),this._documentLoader.set(h.toString(),o)),o}createDocumentData(h){return this._proxy.$tryCreateDocument(h).then(l=>S.URI.revive(l))}$acceptModelLanguageChanged(h,l){const o=S.URI.revive(h),m=this._documentsAndEditors.getDocument(o);if(!m)throw new Error("unknown document");this._onDidRemoveDocument.fire(m.document),m._acceptLanguageId(l),this._onDidAddDocument.fire(m.document)}$acceptModelSaved(h){const l=S.URI.revive(h),o=this._documentsAndEditors.getDocument(l);if(!o)throw new Error("unknown document");this.$acceptDirtyStateChanged(h,!1),this._onDidSaveDocument.fire(o.document)}$acceptDirtyStateChanged(h,l){const o=S.URI.revive(h),m=this._documentsAndEditors.getDocument(o);if(!m)throw new Error("unknown document");m._acceptIsDirty(l),this._onDidChangeDocument.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(h,l,o){const m=S.URI.revive(h),M=this._documentsAndEditors.getDocument(m);if(!M)throw new Error("unknown document");M._acceptIsDirty(o),M.onEvents(l);let C;l.isUndoing?C=R.TextDocumentChangeReason.Undo:l.isRedoing&&(C=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,T.deepFreeze)({document:M.document,contentChanges:l.changes.map(w=>({range:I.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text})),reason:C}))}setWordDefinitionFor(h,l){(0,A.setWordDefinitionFor)(h,l)}}e.ExtHostDocuments=b}),define(ye[49],Se([0,1,42,4,6,2,3,5,84,14,90,8,12,22,11,157,228]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i,h,l,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class M{constructor(u){this.value=u,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let C=class{constructor(u,_){this._extHostRpc=u,this._logService=_,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const _=[],a=[],F=[];if(u.removedDocuments)for(const c of u.removedDocuments){const n=P.URI.revive(c),f=this._documents.get(n);f?.unref()&&(this._documents.delete(n),_.push(f.value))}if(u.addedDocuments)for(const c of u.addedDocuments){const n=P.URI.revive(c.uri);let f=this._documents.get(n);if(f&&n.scheme!==l.Schemas.vscodeNotebookCell&&n.scheme!==l.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);f||(f=new M(new D.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),n,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty,c.notebook)),this._documents.set(n,f),a.push(f.value)),f.ref()}if(u.removedEditors)for(const c of u.removedEditors){const n=this._editors.get(c);this._editors.delete(c),n&&F.push(n)}if(u.addedEditors)for(const c of u.addedEditors){const n=P.URI.revive(c.documentUri);r.ok(this._documents.has(n),`document '${n}' does not exist`),r.ok(!this._editors.has(c.id),`editor '${c.id}' already exists!`);const f=this._documents.get(n).value,g=new R.ExtHostTextEditor(c.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new m.Lazy(()=>f.document),c.selections.map(b.Selection.to),c.options,c.visibleRanges.map(s=>b.Range.to(s)),typeof c.editorPosition=="number"?b.ViewColumn.to(c.editorPosition):void 0);this._editors.set(c.id,g)}u.newActiveEditor!==void 0&&(r.ok(u.newActiveEditor===null||this._editors.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this._activeEditorId=u.newActiveEditor),(0,S.dispose)(_),(0,S.dispose)(F),u.removedDocuments&&this._onDidRemoveDocuments.fire(_),u.addedDocuments&&this._onDidAddDocuments.fire(a),(u.removedEditors||u.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(c=>c.value)),u.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(u){return this._documents.get(u)?.value}allDocuments(){return o.Iterable.map(this._documents.values(),u=>u.value)}getEditor(u){return this._editors.get(u)}activeEditor(u){if(!this._activeEditorId)return;const _=this._editors.get(this._activeEditorId);return u?_:_?.value}allEditors(){return[...this._editors.values()]}};C=xe([$e(0,T.IExtHostRpcService),$e(1,i.ILogService)],C),e.ExtHostDocumentsAndEditors=C,e.IExtHostDocumentsAndEditors=(0,A.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[69],Se([0,1,8,5,2,4,3,14,10]),function(Z,e,r,t,S,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,A.createDecorator)("IExtHostEditorTabs");let T=class{constructor(b){this._onDidChangeTabs=new P.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new P.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=b.getProxy(t.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(b){let i=-1;this._tabs=b.map((l,o)=>(l.isActive&&(i=o),Object.freeze({label:l.label,viewColumn:r.ViewColumn.to(l.viewColumn),index:o,resource:S.URI.revive(l.resource),additionalResourcesAndViewIds:l.additionalResourcesAndViewIds.map(({resource:m,viewId:M})=>({resource:S.URI.revive(m),viewId:M})),viewId:l.editorId,isActive:l.isActive,move:async(m,M)=>{this._proxy.$moveTab(l,m,r.ViewColumn.from(M)),await(0,D.raceTimeout)(P.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(l),await(0,D.raceTimeout)(P.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((l,o)=>l.viewColumn===o.viewColumn?l.index-o.index:l.viewColumn-o.viewColumn);const h=this._activeTab;this._activeTab=i===-1?void 0:this._tabs[i],this._activeTab!==h&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};T=xe([$e(0,I.IExtHostRpcService)],T),e.ExtHostEditorTabs=T}),define(ye[183],Se([0,1,2,5,6,7,8,229,9,21,26]),function(Z,e,r,t,S,P,A,I,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class b{constructor(){this._schemes=[]}add(l){this._stateMachine=void 0,this._schemes.push(l)}delete(l){const o=this._schemes.indexOf(l);o>=0&&(this._schemes.splice(o,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const l=this._schemes.sort(),o=[];let m,M,C=14,w=14;for(const u of l){let _=m?(0,D.commonPrefixLength)(m,u):0;for(_===0?M=1:M=w;_<u.length;_++)_+1===u.length?(C=w,w=9):w+=1,o.push([M,u.toUpperCase().charCodeAt(_),w]),o.push([M,u.toLowerCase().charCodeAt(_),w]),M=w;m=u,w=C}o.push([9,58,10]),o.push([10,47,12]),this._stateMachine=new I.StateMachine(o)}}provideDocumentLinks(l){this._initStateMachine();const o=[],m=I.LinkComputer.computeLinks({getLineContent(M){return l.lineAt(M-1).text},getLineCount(){return l.lineCount}},this._stateMachine);for(const M of m){const C=A.DocumentLink.to(M);C.target&&o.push(C)}return o}}class i{constructor(l,o){this._extHostLanguageFeatures=o,this._linkProvider=new b,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=l.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(l,o,m,M={}){if(this._registeredSchemes.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(l,"*",this._linkProvider));const C=this._handlePool++;this._linkProvider.add(o),this._registeredSchemes.add(o),this._fsProvider.set(C,m);let w=2;M.isCaseSensitive&&(w+=1024),M.isReadonly&&(w+=2048),typeof m.copy=="function"&&(w+=8),typeof m.open=="function"&&typeof m.close=="function"&&typeof m.read=="function"&&typeof m.write=="function"&&((0,R.checkProposedApiEnabled)(l,"fsChunks"),w+=4),this._proxy.$registerFileSystemProvider(C,o,w).catch(_=>{console.error(`FAILED to register filesystem provider of ${l.identifier.value}-extension for the scheme ${o}`),console.error(_)});const u=m.onDidChangeFile(_=>{const a=[];for(const F of _){let{uri:c,type:n}=F;if(c.scheme!==o)continue;let f;switch(n){case P.FileChangeType.Changed:f=0;break;case P.FileChangeType.Created:f=1;break;case P.FileChangeType.Deleted:f=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:c,type:f})}this._proxy.$onFileSystemChange(C,a)});return(0,S.toDisposable)(()=>{u.dispose(),this._linkProvider.delete(o),this._registeredSchemes.delete(o),this._fsProvider.delete(C),this._proxy.$unregisterProvider(C)})}static _asIStat(l){const{type:o,ctime:m,mtime:M,size:C,permissions:w}=l;return{type:o,ctime:m,mtime:M,size:C,permissions:w}}$stat(l,o){return Promise.resolve(this._getFsProvider(l).stat(r.URI.revive(o))).then(m=>i._asIStat(m))}$readdir(l,o){return Promise.resolve(this._getFsProvider(l).readDirectory(r.URI.revive(o)))}$readFile(l,o){return Promise.resolve(this._getFsProvider(l).readFile(r.URI.revive(o))).then(m=>T.VSBuffer.wrap(m))}$writeFile(l,o,m,M){return Promise.resolve(this._getFsProvider(l).writeFile(r.URI.revive(o),m.buffer,M))}$delete(l,o,m){return Promise.resolve(this._getFsProvider(l).delete(r.URI.revive(o),m))}$rename(l,o,m,M){return Promise.resolve(this._getFsProvider(l).rename(r.URI.revive(o),r.URI.revive(m),M))}$copy(l,o,m,M){const C=this._getFsProvider(l);if(!C.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(C.copy(r.URI.revive(o),r.URI.revive(m),M))}$mkdir(l,o){return Promise.resolve(this._getFsProvider(l).createDirectory(r.URI.revive(o)))}$watch(l,o,m,M){const C=this._getFsProvider(l).watch(r.URI.revive(m),M);this._watches.set(o,C)}$unwatch(l,o){const m=this._watches.get(o);m&&(m.dispose(),this._watches.delete(o))}$open(l,o,m){const M=this._getFsProvider(l);if(!M.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(M.open(r.URI.revive(o),m))}$close(l,o){const m=this._getFsProvider(l);if(!m.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(m.close(o))}$read(l,o,m,M){const C=this._getFsProvider(l);if(!C.read)throw new Error('FileSystemProvider does not implement "read"');const w=T.VSBuffer.alloc(M);return Promise.resolve(C.read(o,m,w.buffer,0,M)).then(u=>w.slice(0,u))}$write(l,o,m,M){const C=this._getFsProvider(l);if(!C.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(C.write(o,m,M.buffer,0,M.byteLength))}_getFsProvider(l){const o=this._fsProvider.get(l);if(!o){const m=new Error;throw m.name="ENOPRO",m.message="no provider",m}return o}}e.ExtHostFileSystem=i}),define(ye[50],Se([0,1,5,46,7,21,3,14,30,6]),function(Z,e,r,t,S,P,A,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Wt{constructor(i,h){this._fileSystemProvider=new Map,this._proxy=i.getProxy(r.MainContext.MainThreadFileSystem);const l=this;this.value=Object.freeze({async stat(o){try{const m=l._fileSystemProvider.get(o.scheme);if(!m)return await l._proxy.$stat(o);await l._proxy.$ensureActivation(o.scheme);const M=await m.stat(o);return{type:M.type,ctime:M.ctime,mtime:M.mtime,size:M.size,permissions:M.permissions}}catch(m){Wt._handleError(m)}},async readDirectory(o){try{const m=l._fileSystemProvider.get(o.scheme);return m?(await l._proxy.$ensureActivation(o.scheme),(await m.readDirectory(o)).slice()):await l._proxy.$readdir(o)}catch(m){return Wt._handleError(m)}},async createDirectory(o){try{return await l._proxy.$mkdir(o)}catch(m){return Wt._handleError(m)}},async readFile(o){try{const m=l._fileSystemProvider.get(o.scheme);return m?(await l._proxy.$ensureActivation(o.scheme),(await m.readFile(o)).slice()):(await l._proxy.$readFile(o)).buffer}catch(m){return Wt._handleError(m)}},async writeFile(o,m){try{return await l._proxy.$writeFile(o,P.VSBuffer.wrap(m))}catch(M){return Wt._handleError(M)}},async delete(o,m){try{const M=l._fileSystemProvider.get(o.scheme);return M?(await l._proxy.$ensureActivation(o.scheme),await M.delete(o,{recursive:!1,...m})):await l._proxy.$delete(o,{recursive:!1,useTrash:!1,...m})}catch(M){return Wt._handleError(M)}},async rename(o,m,M){try{return await l._proxy.$rename(o,m,{overwrite:!1,...M})}catch(C){return Wt._handleError(C)}},async copy(o,m,M){try{return await l._proxy.$copy(o,m,{overwrite:!1,...M})}catch(C){return Wt._handleError(C)}},isWritableFileSystem(o){const m=h.getCapabilities(o);if(typeof m=="number")return!(m&2048)}})}static _handleError(i){if(i instanceof S.FileSystemError)throw i;if(!(i instanceof Error))throw new S.FileSystemError(String(i));if(i.name==="ENOPRO")throw S.FileSystemError.Unavailable(i.message);switch(i.name){case t.FileSystemProviderErrorCode.FileExists:throw S.FileSystemError.FileExists(i.message);case t.FileSystemProviderErrorCode.FileNotFound:throw S.FileSystemError.FileNotFound(i.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw S.FileSystemError.FileNotADirectory(i.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw S.FileSystemError.FileIsADirectory(i.message);case t.FileSystemProviderErrorCode.NoPermissions:throw S.FileSystemError.NoPermissions(i.message);case t.FileSystemProviderErrorCode.Unavailable:throw S.FileSystemError.Unavailable(i.message);default:throw new S.FileSystemError(i.message,i.name)}}addFileSystemProvider(i,h){return this._fileSystemProvider.set(i,h),(0,T.toDisposable)(()=>this._fileSystemProvider.delete(i))}};R=xe([$e(0,I.IExtHostRpcService),$e(1,D.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,A.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[184],Se([0,1,4,29,2,5,8,7]),function(Z,e,r,t,S,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(b,i,h,l,o,m,M,C){this._onDidCreate=new r.Emitter,this._onDidChange=new r.Emitter,this._onDidDelete=new r.Emitter;const w=this.ensureWatching(b,h,o);this._config=0,m&&(this._config+=1),M&&(this._config+=2),C&&(this._config+=4);const u=(0,t.parse)(o),_=typeof o=="string",a=l(F=>{if(!m)for(let c of F.created){const n=S.URI.revive(c);u(n.fsPath)&&(!_||i.getWorkspaceFolder(n))&&this._onDidCreate.fire(n)}if(!M)for(let c of F.changed){const n=S.URI.revive(c);u(n.fsPath)&&(!_||i.getWorkspaceFolder(n))&&this._onDidChange.fire(n)}if(!C)for(let c of F.deleted){const n=S.URI.revive(c);u(n.fsPath)&&(!_||i.getWorkspaceFolder(n))&&this._onDidDelete.fire(n)}});this._disposable=I.Disposable.from(w,this._onDidCreate,this._onDidChange,this._onDidDelete,a)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(b,i,h){let l=I.Disposable.from();if(typeof h=="string")return l;const o=b.getProxy(P.MainContext.MainThreadFileSystem);let m=!1;(h.pattern.includes(t.GLOBSTAR)||h.pattern.includes(t.GLOB_SPLIT))&&(m=!0);const M=Math.random();return o.$watch(i.identifier.value,M,h.baseUri,{recursive:m,excludes:[]}),I.Disposable.from({dispose:()=>o.$unwatch(M)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class T{constructor(b,i,h){this._mainContext=b,this._logService=i,this._extHostDocumentsAndEditors=h,this._onFileSystemEvent=new r.Emitter,this._onDidRenameFile=new r.Emitter,this._onDidCreateFile=new r.Emitter,this._onDidDeleteFile=new r.Emitter,this._onWillRenameFile=new r.AsyncEmitter,this._onWillCreateFile=new r.AsyncEmitter,this._onWillDeleteFile=new r.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(b,i,h,l,o,m){return new D(this._mainContext,b,i,this._onFileSystemEvent.event,A.GlobPattern.from(h),l,o,m)}$onFileEvent(b){this._onFileSystemEvent.fire(b)}$onDidRunFileOperation(b,i){switch(b){case 2:this._onDidRenameFile.fire(Object.freeze({files:i.map(h=>({oldUri:S.URI.revive(h.source),newUri:S.URI.revive(h.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:i.map(h=>S.URI.revive(h.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:i.map(h=>S.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(b){return this._createWillExecuteEvent(b,this._onWillRenameFile)}getOnWillCreateFileEvent(b){return this._createWillExecuteEvent(b,this._onWillCreateFile)}getOnWillDeleteFileEvent(b){return this._createWillExecuteEvent(b,this._onWillDeleteFile)}_createWillExecuteEvent(b,i){return(h,l,o)=>{const m=function(C){h.call(l,C)};return m.extension=b,i.event(m,void 0,o)}}async $onWillRunFileOperation(b,i,h,l){switch(b){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:i.map(o=>({oldUri:S.URI.revive(o.source),newUri:S.URI.revive(o.target)}))},h,l);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:i.map(o=>S.URI.revive(o.target))},h,l);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:i.map(o=>S.URI.revive(o.target))},h,l)}}async _fireWillEvent(b,i,h,l){const o=new Set,m=[];if(await b.fireAsync(i,l,async(C,w)=>{const u=Date.now(),_=await Promise.resolve(C);_ instanceof I.WorkspaceEdit&&(m.push(_),o.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-u>h&&this._logService.warn("SLOW file-participant",w.extension.identifier)}),l.isCancellationRequested||m.length===0)return;const M={edits:[]};for(let C of m){let{edits:w}=A.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);M.edits=M.edits.concat(w)}return{edit:M,extensionNames:Array.from(o)}}}e.ExtHostFileSystemEventService=T}),define(ye[185],Se([0,1,2,39]),function(Z,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class S{constructor(A,I,D,T){this._extHostNotebooks=I,this._textDocumentsAndEditors=D,this._commands=T;const R=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",b=>!0,b=>b),new t.ApiCommandArgument("resource","Interactive resource Uri",b=>!0,b=>b),new t.ApiCommandArgument("controllerId","Notebook controller Id",b=>!0,b=>b),new t.ApiCommandArgument("title","Interactive editor title",b=>!0,b=>b)],new t.ApiCommandResult("Notebook and input URI",b=>{if(b.notebookEditorId!==void 0){const i=this._extHostNotebooks.getEditorById(b.notebookEditorId);return{notebookUri:r.URI.revive(b.notebookUri),inputUri:r.URI.revive(b.inputUri),notebookEditor:i.apiEditor}}return{notebookUri:r.URI.revive(b.notebookUri),inputUri:r.URI.revive(b.inputUri)}}));this._commands.registerApiCommand(R)}$willAddInteractiveDocument(A,I,D,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:I,lines:[""],languageId:D,uri:A,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(r.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.ExtHostInteractive=S}),define(ye[186],Se([0,1,6,5]),function(Z,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class S{constructor(A){this._handlePool=0,this._proxy=A.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,A),(0,r.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=S}),define(ye[187],Se([0,1,2,27,8,7,5,9,58,16,13,230,20,6,77,54,62,188,15,4,10]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i,h,l,o,m,M,C,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class _{constructor($,K){this._documents=$,this._provider=K}async provideDocumentSymbols($,K){const x=this._documents.getDocument($),V=await this._provider.provideDocumentSymbols(x,K);if(!(0,T.isFalsyOrEmpty)(V))return V[0]instanceof P.DocumentSymbol?V.map(S.DocumentSymbol.from):_._asDocumentSymbolTree(V)}static _asDocumentSymbolTree($){$=$.slice(0).sort((V,Y)=>{let se=V.location.range.start.compareTo(Y.location.range.start);return se===0&&(se=Y.location.range.end.compareTo(V.location.range.end)),se});const K=[],x=[];for(const V of $){const Y={name:V.name||"!!MISSING: name!!",kind:S.SymbolKind.from(V.kind),tags:V.tags?.map(S.SymbolTag.from)||[],detail:"",containerName:V.containerName,range:S.Range.from(V.location.range),selectionRange:S.Range.from(V.location.range),children:[]};for(;;){if(x.length===0){x.push(Y),K.push(Y);break}const se=x[x.length-1];if(D.Range.containsRange(se.range,Y.range)&&!D.Range.equalsRange(se.range,Y.range)){se.children&&se.children.push(Y),x.push(Y);break}x.pop()}}return K}}class a{constructor($,K,x){this._documents=$,this._commands=K,this._provider=x,this._cache=new m.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses($,K){const x=this._documents.getDocument($),V=await this._provider.provideCodeLenses(x,K);if(!V||K.isCancellationRequested)return;const Y=this._cache.add(V),se=new h.DisposableStore;this._disposables.set(Y,se);const _e={cacheId:Y,lenses:[]};for(let Ue=0;Ue<V.length;Ue++)_e.lenses.push({cacheId:[Y,Ue],range:S.Range.from(V[Ue].range),command:this._commands.toInternal(V[Ue].command,se)});return _e}async resolveCodeLens($,K){const x=$.cacheId&&this._cache.get(...$.cacheId);if(!x)return;let V;if(typeof this._provider.resolveCodeLens!="function"||x.isResolved?V=x:V=await this._provider.resolveCodeLens(x,K),V||(V=x),K.isCancellationRequested)return;const Y=$.cacheId&&this._disposables.get($.cacheId[0]);if(!!Y)return $.command=this._commands.toInternal(V.command??a._badCmd,Y),$}releaseCodeLenses($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}}a._badCmd={command:"missing",title:"!!MISSING: command!!"};function F(tt){return Array.isArray(tt)?tt.map(S.DefinitionLink.from):tt?[S.DefinitionLink.from(tt)]:[]}class c{constructor($,K){this._documents=$,this._provider=K}async provideDefinition($,K,x){const V=this._documents.getDocument($),Y=S.Position.to(K),se=await this._provider.provideDefinition(V,Y,x);return F(se)}}class n{constructor($,K){this._documents=$,this._provider=K}async provideDeclaration($,K,x){const V=this._documents.getDocument($),Y=S.Position.to(K),se=await this._provider.provideDeclaration(V,Y,x);return F(se)}}class f{constructor($,K){this._documents=$,this._provider=K}async provideImplementation($,K,x){const V=this._documents.getDocument($),Y=S.Position.to(K),se=await this._provider.provideImplementation(V,Y,x);return F(se)}}class g{constructor($,K){this._documents=$,this._provider=K}async provideTypeDefinition($,K,x){const V=this._documents.getDocument($),Y=S.Position.to(K),se=await this._provider.provideTypeDefinition(V,Y,x);return F(se)}}class s{constructor($,K){this._documents=$,this._provider=K}async provideHover($,K,x){const V=this._documents.getDocument($),Y=S.Position.to(K),se=await this._provider.provideHover(V,Y,x);if(!(!se||(0,T.isFalsyOrEmpty)(se.contents)))return se.range||(se.range=V.getWordRangeAtPosition(Y)),se.range||(se.range=new P.Range(Y,Y)),S.Hover.from(se)}}class d{constructor($,K){this._documents=$,this._provider=K}async provideEvaluatableExpression($,K,x){const V=this._documents.getDocument($),Y=S.Position.to(K),se=await this._provider.provideEvaluatableExpression(V,Y,x);if(se)return S.EvaluatableExpression.from(se)}}class p{constructor($,K){this._documents=$,this._provider=K}async provideInlineValues($,K,x,V){const Y=this._documents.getDocument($),se=await this._provider.provideInlineValues(Y,S.Range.to(K),S.InlineValueContext.to(x),V);if(Array.isArray(se))return se.map(_e=>S.InlineValue.from(_e))}}class E{constructor($,K){this._documents=$,this._provider=K}async provideDocumentHighlights($,K,x){const V=this._documents.getDocument($),Y=S.Position.to(K),se=await this._provider.provideDocumentHighlights(V,Y,x);if(Array.isArray(se))return se.map(S.DocumentHighlight.from)}}class v{constructor($,K){this._documents=$,this._provider=K}async provideLinkedEditingRanges($,K,x){const V=this._documents.getDocument($),Y=S.Position.to(K),se=await this._provider.provideLinkedEditingRanges(V,Y,x);if(se&&Array.isArray(se.ranges))return{ranges:(0,T.coalesce)(se.ranges.map(S.Range.from)),wordPattern:se.wordPattern}}}class k{constructor($,K){this._documents=$,this._provider=K}async provideReferences($,K,x,V){const Y=this._documents.getDocument($),se=S.Position.to(K),_e=await this._provider.provideReferences(Y,se,x,V);if(Array.isArray(_e))return _e.map(S.location.from)}}class L{constructor($,K,x,V,Y,se,_e){this._documents=$,this._commands=K,this._diagnostics=x,this._provider=V,this._logService=Y,this._extension=se,this._apiDeprecation=_e,this._cache=new m.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions($,K,x,V){const Y=this._documents.getDocument($),se=b.Selection.isISelection(K)?S.Selection.to(K):S.Range.to(K),_e=[];for(const Je of this._diagnostics.getDiagnostics($))if(se.intersection(Je.range)&&_e.push(Je)>L._maxCodeActionsPerFile)break;const Ue={diagnostics:_e,only:x.only?new P.CodeActionKind(x.only):void 0,triggerKind:S.CodeActionTriggerKind.to(x.trigger)},Ve=await this._provider.provideCodeActions(Y,se,Ue,V);if(!(0,T.isNonEmptyArray)(Ve)||V.isCancellationRequested)return;const Qe=this._cache.add(Ve),nt=new h.DisposableStore;this._disposables.set(Qe,nt);const rt=[];for(let Je=0;Je<Ve.length;Je++){const Ze=Ve[Je];!Ze||(L._isCommand(Ze)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),rt.push({_isSynthetic:!0,title:Ze.title,command:this._commands.toInternal(Ze,nt)})):(Ue.only&&(Ze.kind?Ue.only.contains(Ze.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ue.only.value} 'requested but returned code action is of kind '${Ze.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ue.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),rt.push({cacheId:[Qe,Je],title:Ze.title,command:Ze.command&&this._commands.toInternal(Ze.command,nt),diagnostics:Ze.diagnostics&&Ze.diagnostics.map(S.Diagnostic.from),edit:Ze.edit&&S.WorkspaceEdit.from(Ze.edit),kind:Ze.kind&&Ze.kind.value,isPreferred:Ze.isPreferred,disabled:Ze.disabled?.reason})))}return{cacheId:Qe,actions:rt}}async resolveCodeAction($,K){const[x,V]=$,Y=this._cache.get(x,V);if(!Y||L._isCommand(Y)||!this._provider.resolveCodeAction)return;const se=await this._provider.resolveCodeAction(Y,K)??Y;return se?.edit?S.WorkspaceEdit.from(se.edit):void 0}releaseCodeActions($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}static _isCommand($){return typeof $.command=="string"&&typeof $.title=="string"}}L._maxCodeActionsPerFile=1e3;class y{constructor($,K){this._documents=$,this._provider=K}async provideDocumentFormattingEdits($,K,x){const V=this._documents.getDocument($),Y=await this._provider.provideDocumentFormattingEdits(V,K,x);if(Array.isArray(Y))return Y.map(S.TextEdit.from)}}class O{constructor($,K){this._documents=$,this._provider=K}async provideDocumentRangeFormattingEdits($,K,x,V){const Y=this._documents.getDocument($),se=S.Range.to(K),_e=await this._provider.provideDocumentRangeFormattingEdits(Y,se,x,V);if(Array.isArray(_e))return _e.map(S.TextEdit.from)}}class U{constructor($,K){this._documents=$,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits($,K,x,V,Y){const se=this._documents.getDocument($),_e=S.Position.to(K),Ue=await this._provider.provideOnTypeFormattingEdits(se,_e,x,V,Y);if(Array.isArray(Ue))return Ue.map(S.TextEdit.from)}}class q{constructor($,K){this._provider=$,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols($,K){const x=A.IdObject.mixin({symbols:[]}),V=await this._provider.provideWorkspaceSymbols($,K);if((0,T.isNonEmptyArray)(V))for(const Y of V){if(!Y)continue;if(!Y.name){this._logService.warn("INVALID SymbolInformation, lacks name",Y);continue}const se=A.IdObject.mixin(S.WorkspaceSymbol.from(Y));this._symbolCache.set(se._id,Y),x.symbols.push(se)}return x.symbols.length>0&&this._resultCache.set(x._id,[x.symbols[0]._id,x.symbols[x.symbols.length-1]._id]),x}async resolveWorkspaceSymbol($,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return $;const x=this._symbolCache.get($._id);if(x){const V=await this._provider.resolveWorkspaceSymbol(x,K);return V&&(0,t.mixin)($,S.WorkspaceSymbol.from(V),!0)}}releaseWorkspaceSymbols($){const K=this._resultCache.get($);if(K){for(let[x,V]=K;x<=V;x++)this._symbolCache.delete(x);this._resultCache.delete($)}}}class H{constructor($,K,x){this._documents=$,this._provider=K,this._logService=x}static supportsResolving($){return typeof $.prepareRename=="function"}async provideRenameEdits($,K,x,V){const Y=this._documents.getDocument($),se=S.Position.to(K);try{const _e=await this._provider.provideRenameEdits(Y,se,x,V);return _e?S.WorkspaceEdit.from(_e):void 0}catch(_e){const Ue=H._asMessage(_e);return Ue?{rejectReason:Ue,edits:void 0}:Promise.reject(_e)}}async resolveRenameLocation($,K,x){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const V=this._documents.getDocument($),Y=S.Position.to(K);try{const se=await this._provider.prepareRename(V,Y,x);let _e,Ue;if(P.Range.isRange(se)?(_e=se,Ue=V.getText(se)):(0,R.isObject)(se)&&(_e=se.range,Ue=se.placeholder),!_e||!Ue)return;if(_e.start.line>Y.line||_e.end.line<Y.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(_e),text:Ue}}catch(se){const _e=H._asMessage(se);return _e?{rejectReason:_e,range:void 0,text:void 0}:Promise.reject(se)}}static _asMessage($){return typeof $=="string"?$:$ instanceof Error&&typeof $.message=="string"?$.message:void 0}}class z{constructor($,K){this.resultId=$,this.tokens=K}}class j{constructor($,K){this._documents=$,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens($,K,x){const V=this._documents.getDocument($),Y=K!==0?this._previousResults.get(K):null;let se=typeof Y?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(V,Y.resultId,x):await this._provider.provideDocumentSemanticTokens(V,x);return Y&&this._previousResults.delete(K),se?(se=j._fixProvidedSemanticTokens(se),this._send(j._convertToEdits(Y,se),se)):null}async releaseDocumentSemanticColoring($){this._previousResults.delete($)}static _fixProvidedSemanticTokens($){return j._isSemanticTokens($)?j._isCorrectSemanticTokens($)?$:new P.SemanticTokens(new Uint32Array($.data),$.resultId):j._isSemanticTokensEdits($)?j._isCorrectSemanticTokensEdits($)?$:new P.SemanticTokensEdits($.edits.map(K=>new P.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),$.resultId):$}static _isSemanticTokens($){return $&&!!$.data}static _isCorrectSemanticTokens($){return $.data instanceof Uint32Array}static _isSemanticTokensEdits($){return $&&Array.isArray($.edits)}static _isCorrectSemanticTokensEdits($){for(const K of $.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits($,K){if(!j._isSemanticTokens(K)||!$||!$.tokens)return K;const x=$.tokens,V=x.length,Y=K.data,se=Y.length;let _e=0;const Ue=Math.min(V,se);for(;_e<Ue&&x[_e]===Y[_e];)_e++;if(_e===V&&_e===se)return new P.SemanticTokensEdits([],K.resultId);let Ve=0;const Qe=Ue-_e;for(;Ve<Qe&&x[V-Ve-1]===Y[se-Ve-1];)Ve++;return new P.SemanticTokensEdits([{start:_e,deleteCount:V-_e-Ve,data:Y.subarray(_e,se-Ve)}],K.resultId)}_send($,K){if(j._isSemanticTokens($)){const x=this._nextResultId++;return this._previousResults.set(x,new z($.resultId,$.data)),(0,l.encodeSemanticTokensDto)({id:x,type:"full",data:$.data})}if(j._isSemanticTokensEdits($)){const x=this._nextResultId++;return j._isSemanticTokens(K)?this._previousResults.set(x,new z(K.resultId,K.data)):this._previousResults.set(x,new z($.resultId)),(0,l.encodeSemanticTokensDto)({id:x,type:"delta",deltas:($.edits||[]).map(V=>({start:V.start,deleteCount:V.deleteCount,data:V.data}))})}return null}}e.DocumentSemanticTokensAdapter=j;class ie{constructor($,K){this._documents=$,this._provider=K}async provideDocumentRangeSemanticTokens($,K,x){const V=this._documents.getDocument($),Y=await this._provider.provideDocumentRangeSemanticTokens(V,S.Range.to(K),x);return Y?this._send(Y):null}_send($){return(0,l.encodeSemanticTokensDto)({id:0,type:"full",data:$.data})}}e.DocumentRangeSemanticTokensAdapter=ie;class ae{constructor($,K,x,V,Y){this._documents=$,this._commands=K,this._provider=x,this._apiDeprecation=V,this._extension=Y,this._cache=new m.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving($){return typeof $.resolveCompletionItem=="function"}async provideCompletionItems($,K,x,V){const Y=this._documents.getDocument($),se=S.Position.to(K),_e=Y.getWordRangeAtPosition(se)||new P.Range(se,se),Ue=_e.with({end:se}),Ve=new M.StopWatch(!0),Qe=await this._provider.provideCompletionItems(Y,se,V,S.CompletionContext.to(x));if(!Qe||V.isCancellationRequested)return;const nt=Array.isArray(Qe)?new P.CompletionList(Qe):Qe,rt=ae.supportsResolving(this._provider)?this._cache.add(nt.items):this._cache.add([]),Je=new h.DisposableStore;this._disposables.set(rt,Je);const Ze=[],pt={x:rt,b:Ze,a:{replace:S.Range.from(_e),insert:S.Range.from(Ue)},c:nt.isIncomplete||void 0,d:Ve.elapsed()};for(let Fe=0;Fe<nt.items.length;Fe++){const At=nt.items[Fe],G=this._convertCompletionItem(At,[rt,Fe],Ue,_e);Ze.push(G)}return pt}async resolveCompletionItem($,K){if(typeof this._provider.resolveCompletionItem!="function")return;const x=this._cache.get(...$);if(!x)return;const V=await this._provider.resolveCompletionItem(x,K);if(!!V)return this._convertCompletionItem(V,$)}releaseCompletionItems($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}_convertCompletionItem($,K,x,V){const Y=this._disposables.get(K[0]);if(!Y)throw Error("DisposableStore is missing...");const se={x:K,a:$.label,b:$.kind!==void 0?S.CompletionItemKind.from($.kind):void 0,n:$.tags&&$.tags.map(S.CompletionItemTag.from),c:$.detail,d:typeof $.documentation=="undefined"?void 0:S.MarkdownString.fromStrict($.documentation),e:$.sortText!==$.label?$.sortText:void 0,f:$.filterText!==$.label?$.filterText:void 0,g:$.preselect||void 0,i:$.keepWhitespace?1:0,k:$.commitCharacters,l:$.additionalTextEdits&&$.additionalTextEdits.map(S.TextEdit.from),m:this._commands.toInternal($.command,Y)};$.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),se.h=$.textEdit.newText):typeof $.insertText=="string"?se.h=$.insertText:$.insertText instanceof P.SnippetString&&(se.h=$.insertText.value,se.i|=4);let _e;return $.textEdit?_e=$.textEdit.range:$.range&&(_e=$.range),P.Range.isRange(_e)?se.j=S.Range.from(_e):_e&&(!x?.isEqual(_e.inserting)||!V?.isEqual(_e.replacing))&&(se.j={insert:S.Range.from(_e.inserting),replace:S.Range.from(_e.replacing)}),se}}class te{constructor($,K,x){this._documents=$,this._provider=K,this._commands=x,this._cache=new m.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions($,K,x,V){const Y=this._documents.getDocument($),se=S.Position.to(K),_e=await this._provider.provideInlineCompletionItems(Y,se,{selectedCompletionInfo:x.selectedSuggestionInfo?{range:S.Range.to(x.selectedSuggestionInfo.range),text:x.selectedSuggestionInfo.text,isSnippetText:x.selectedSuggestionInfo.isSnippetText,completionKind:S.CompletionItemKind.to(x.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:x.triggerKind},V);if(!_e||V.isCancellationRequested)return;const Ue=(0,R.isArray)(_e)?{items:_e}:_e,Ve=this._cache.add(Ue.items);let Qe;return{pid:Ve,items:Ue.items.map((nt,rt)=>{let Je;return nt.command&&(Qe||(Qe=new h.DisposableStore,this._disposables.set(Ve,Qe)),Je=this._commands.toInternal(nt.command,Qe)),{text:nt.text,range:nt.range?S.Range.from(nt.range):void 0,command:Je,idx:rt}})}}disposeCompletions($){this._cache.delete($);const K=this._disposables.get($);K&&K.clear(),this._disposables.delete($)}handleDidShowCompletionItem($,K){const x=this._cache.get($,K);x&&ue.get(this._provider).fireOnDidShowCompletionItem({completionItem:x})}}class ue{constructor(){this._onDidShowCompletionItemEmitter=new w.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get($){let K=ue.map.get($);return K||(K=new ue,ue.map.set($,K)),K}fireOnDidShowCompletionItem($){this._onDidShowCompletionItemEmitter.fire($)}}e.InlineCompletionController=ue,ue.map=new WeakMap;class be{constructor($,K){this._documents=$,this._provider=K,this._cache=new m.Cache("SignatureHelp")}async provideSignatureHelp($,K,x,V){const Y=this._documents.getDocument($),se=S.Position.to(K),_e=this.reviveContext(x),Ue=await this._provider.provideSignatureHelp(Y,se,V,_e);if(Ue){const Ve=this._cache.add([Ue]);return{...S.SignatureHelp.from(Ue),id:Ve}}}reviveContext($){let K;if($.activeSignatureHelp){const x=S.SignatureHelp.to($.activeSignatureHelp),V=this._cache.get($.activeSignatureHelp.id,0);V?(K=V,K.activeSignature=x.activeSignature,K.activeParameter=x.activeParameter):K=x}return{...$,activeSignatureHelp:K}}releaseSignatureHelp($){this._cache.delete($)}}class pe{constructor($,K,x,V,Y){this._documents=$,this._commands=K,this._provider=x,this._logService=V,this._extension=Y,this._cache=new m.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints($,K,x){const V=this._documents.getDocument($),Y=S.Range.to(K),se=await this._provider.provideInlayHints(V,Y,x);if(!Array.isArray(se)||se.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${K}`);return}if(x.isCancellationRequested)return;const _e=this._cache.add(se);this._disposables.set(_e,new h.DisposableStore);const Ue={hints:[],cacheId:_e};for(let Ve=0;Ve<se.length;Ve++)this._isValidInlayHint(se[Ve],Y)&&Ue.hints.push(this._convertInlayHint(se[Ve],[_e,Ve]));return this._logService.trace(`[InlayHints] ${Ue.hints.length} inlay hints from '${this._extension.identifier.value}' for ${K}`),Ue}async resolveInlayHint($,K){if(typeof this._provider.resolveInlayHint!="function")return;const x=this._cache.get(...$);if(!x)return;const V=await this._provider.resolveInlayHint(x,K);if(!!V&&!!this._isValidInlayHint(V))return this._convertInlayHint(V,$)}releaseHints($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}_isValidInlayHint($,K){return $.label.length===0||Array.isArray($.label)&&$.label.every(x=>x.label.length===0)?(console.log("INVALID inlay hint, empty label",$),!1):!(K&&!K.contains($.position))}_convertInlayHint($,K){const x=this._disposables.get(K[0]);if(!x)throw Error("DisposableStore is missing...");const V={label:"",cacheId:K,tooltip:$.tooltip&&S.MarkdownString.from($.tooltip),position:S.Position.from($.position),kind:S.InlayHintKind.from($.kind??P.InlayHintKind.Other),whitespaceBefore:$.paddingLeft,whitespaceAfter:$.paddingRight};return typeof $.label=="string"?V.label=$.label:V.label=$.label.map(Y=>{let se={label:Y.label};return se.tooltip=Y.tooltip&&S.MarkdownString.from(Y.tooltip),P.Location.isLocation(Y.location)?se.location=S.location.from(Y.location):Y.command&&(se.command=this._commands.toInternal(Y.command,x)),se}),V}}class me{constructor($,K){this._documents=$,this._provider=K,this._cache=new m.Cache("DocumentLink")}async provideLinks($,K){const x=this._documents.getDocument($),V=await this._provider.provideDocumentLinks(x,K);if(!(!Array.isArray(V)||V.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:V.filter(me._validateLink).map(S.DocumentLink.from)};{const Y=this._cache.add(V),se={links:[],id:Y};for(let _e=0;_e<V.length;_e++){if(!me._validateLink(V[_e]))continue;const Ue=S.DocumentLink.from(V[_e]);Ue.cacheId=[Y,_e],se.links.push(Ue)}return se}}}static _validateLink($){return $.target&&$.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink($,K){if(typeof this._provider.resolveDocumentLink!="function")return;const x=this._cache.get(...$);if(!x)return;const V=await this._provider.resolveDocumentLink(x,K);if(!(!V||!me._validateLink(V)))return S.DocumentLink.from(V)}releaseLinks($){this._cache.delete($)}}class oe{constructor($,K){this._documents=$,this._provider=K}async provideColors($,K){const x=this._documents.getDocument($),V=await this._provider.provideDocumentColors(x,K);return Array.isArray(V)?V.map(se=>({color:S.Color.from(se.color),range:S.Range.from(se.range)})):[]}async provideColorPresentations($,K,x){const V=this._documents.getDocument($),Y=S.Range.to(K.range),se=S.Color.to(K.color),_e=await this._provider.provideColorPresentations(se,{document:V,range:Y},x);if(!!Array.isArray(_e))return _e.map(S.ColorPresentation.from)}}class Ee{constructor($,K){this._documents=$,this._provider=K}async provideFoldingRanges($,K,x){const V=this._documents.getDocument($),Y=await this._provider.provideFoldingRanges(V,K,x);if(!!Array.isArray(Y))return Y.map(S.FoldingRange.from)}}class Pe{constructor($,K,x){this._documents=$,this._provider=K,this._logService=x}async provideSelectionRanges($,K,x){const V=this._documents.getDocument($),Y=K.map(S.Position.to),se=await this._provider.provideSelectionRanges(V,Y,x);if(!(0,T.isNonEmptyArray)(se))return[];if(se.length!==Y.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const _e=[];for(let Ue=0;Ue<Y.length;Ue++){const Ve=[];_e.push(Ve);let Qe=Y[Ue],nt=se[Ue];for(;;){if(!nt.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(Ve.push(S.SelectionRange.from(nt)),!nt.parent)break;Qe=nt.range,nt=nt.parent}}return _e}}class Oe{constructor($,K){this._documents=$,this._provider=K,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession($,K,x){const V=this._documents.getDocument($),Y=S.Position.to(K),se=await this._provider.prepareCallHierarchy(V,Y,x);if(!se)return;const _e=this._idPool.nextId();return this._cache.set(_e,new Map),Array.isArray(se)?se.map(Ue=>this._cacheAndConvertItem(_e,Ue)):[this._cacheAndConvertItem(_e,se)]}async provideCallsTo($,K,x){const V=this._itemFromCache($,K);if(!V)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyIncomingCalls(V,x);if(!!Y)return Y.map(se=>({from:this._cacheAndConvertItem($,se.from),fromRanges:se.fromRanges.map(_e=>S.Range.from(_e))}))}async provideCallsFrom($,K,x){const V=this._itemFromCache($,K);if(!V)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyOutgoingCalls(V,x);if(!!Y)return Y.map(se=>({to:this._cacheAndConvertItem($,se.to),fromRanges:se.fromRanges.map(_e=>S.Range.from(_e))}))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,K){const x=this._cache.get($),V=S.CallHierarchyItem.from(K,$,x.size.toString(36));return x.set(V._itemId,K),V}_itemFromCache($,K){return this._cache.get($)?.get(K)}}class je{constructor($,K){this._documents=$,this._provider=K,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession($,K,x){const V=this._documents.getDocument($),Y=S.Position.to(K),se=await this._provider.prepareTypeHierarchy(V,Y,x);if(!se)return;const _e=this._idPool.nextId();return this._cache.set(_e,new Map),Array.isArray(se)?se.map(Ue=>this._cacheAndConvertItem(_e,Ue)):[this._cacheAndConvertItem(_e,se)]}async provideSupertypes($,K,x){const V=this._itemFromCache($,K);if(!V)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySupertypes(V,x);if(!!Y)return Y.map(se=>this._cacheAndConvertItem($,se))}async provideSubtypes($,K,x){const V=this._itemFromCache($,K);if(!V)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySubtypes(V,x);if(!!Y)return Y.map(se=>this._cacheAndConvertItem($,se))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,K){const x=this._cache.get($),V=S.TypeHierarchyItem.from(K,$,x.size.toString(36));return x.set(V._itemId,K),V}_itemFromCache($,K){return this._cache.get($)?.get(K)}}class st{constructor($,K){this.adapter=$,this.extension=K}}class et{constructor($,K,x,V,Y,se,_e){this._adapter=new Map,this._uriTransformer=K,this._proxy=$.getProxy(A.MainContext.MainThreadLanguageFeatures),this._documents=x,this._commands=V,this._diagnostics=Y,this._logService=se,this._apiDeprecation=_e}_transformDocumentSelector($){return S.DocumentSelector.from($,this._uriTransformer)}_createDisposable($){return new P.Disposable(()=>{this._adapter.delete($),this._proxy.$unregister($)})}_nextHandle(){return et._handlePool++}async _withAdapter($,K,x,V,Y){const se=this._adapter.get($);if(!se||!(se.adapter instanceof K))return V;const _e=Date.now();this._logService.trace(`[${se.extension.identifier.value}] INVOKE provider '${x.toString().replace(/[\r\n]/g,"")}'`);const Ue=x(se.adapter,se.extension);return Promise.resolve(Ue).catch(Ve=>{(0,C.isCancellationError)(Ve)||(this._logService.error(`[${se.extension.identifier.value}] provider FAILED`),this._logService.error(Ve))}).finally(()=>{this._logService.trace(`[${se.extension.identifier.value}] provider DONE after ${Date.now()-_e}ms`)}),i.CancellationToken.isCancellationToken(Y)?(0,u.raceCancellationError)(Ue,Y):Ue}_addNewAdapter($,K){const x=this._nextHandle();return this._adapter.set(x,new st($,K)),x}static _extLabel($){return $.displayName||$.name}registerDocumentSymbolProvider($,K,x,V){const Y=this._addNewAdapter(new _(this._documents,x),$),se=V&&V.label||et._extLabel($);return this._proxy.$registerDocumentSymbolProvider(Y,this._transformDocumentSelector(K),se),this._createDisposable(Y)}$provideDocumentSymbols($,K,x){return this._withAdapter($,_,V=>V.provideDocumentSymbols(r.URI.revive(K),x),void 0,x)}registerCodeLensProvider($,K,x){const V=this._nextHandle(),Y=typeof x.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(V,new st(new a(this._documents,this._commands.converter,x),$)),this._proxy.$registerCodeLensSupport(V,this._transformDocumentSelector(K),Y);let se=this._createDisposable(V);if(Y!==void 0){const _e=x.onDidChangeCodeLenses(Ue=>this._proxy.$emitCodeLensEvent(Y));se=P.Disposable.from(se,_e)}return se}$provideCodeLenses($,K,x){return this._withAdapter($,a,V=>V.provideCodeLenses(r.URI.revive(K),x),void 0,void 0)}$resolveCodeLens($,K,x){return this._withAdapter($,a,V=>V.resolveCodeLens(K,x),void 0,void 0)}$releaseCodeLenses($,K){this._withAdapter($,a,x=>Promise.resolve(x.releaseCodeLenses(K)),void 0,void 0)}registerDefinitionProvider($,K,x){const V=this._addNewAdapter(new c(this._documents,x),$);return this._proxy.$registerDefinitionSupport(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$provideDefinition($,K,x,V){return this._withAdapter($,c,Y=>Y.provideDefinition(r.URI.revive(K),x,V),[],V)}registerDeclarationProvider($,K,x){const V=this._addNewAdapter(new n(this._documents,x),$);return this._proxy.$registerDeclarationSupport(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$provideDeclaration($,K,x,V){return this._withAdapter($,n,Y=>Y.provideDeclaration(r.URI.revive(K),x,V),[],V)}registerImplementationProvider($,K,x){const V=this._addNewAdapter(new f(this._documents,x),$);return this._proxy.$registerImplementationSupport(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$provideImplementation($,K,x,V){return this._withAdapter($,f,Y=>Y.provideImplementation(r.URI.revive(K),x,V),[],V)}registerTypeDefinitionProvider($,K,x){const V=this._addNewAdapter(new g(this._documents,x),$);return this._proxy.$registerTypeDefinitionSupport(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$provideTypeDefinition($,K,x,V){return this._withAdapter($,g,Y=>Y.provideTypeDefinition(r.URI.revive(K),x,V),[],V)}registerHoverProvider($,K,x,V){const Y=this._addNewAdapter(new s(this._documents,x),$);return this._proxy.$registerHoverProvider(Y,this._transformDocumentSelector(K)),this._createDisposable(Y)}$provideHover($,K,x,V){return this._withAdapter($,s,Y=>Y.provideHover(r.URI.revive(K),x,V),void 0,void 0)}registerEvaluatableExpressionProvider($,K,x,V){const Y=this._addNewAdapter(new d(this._documents,x),$);return this._proxy.$registerEvaluatableExpressionProvider(Y,this._transformDocumentSelector(K)),this._createDisposable(Y)}$provideEvaluatableExpression($,K,x,V){return this._withAdapter($,d,Y=>Y.provideEvaluatableExpression(r.URI.revive(K),x,V),void 0,void 0)}registerInlineValuesProvider($,K,x,V){const Y=typeof x.onDidChangeInlineValues=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new p(this._documents,x),$);this._proxy.$registerInlineValuesProvider(se,this._transformDocumentSelector(K),Y);let _e=this._createDisposable(se);if(Y!==void 0){const Ue=x.onDidChangeInlineValues(Ve=>this._proxy.$emitInlineValuesEvent(Y));_e=P.Disposable.from(_e,Ue)}return _e}$provideInlineValues($,K,x,V,Y){return this._withAdapter($,p,se=>se.provideInlineValues(r.URI.revive(K),x,V,Y),void 0,void 0)}registerDocumentHighlightProvider($,K,x){const V=this._addNewAdapter(new E(this._documents,x),$);return this._proxy.$registerDocumentHighlightProvider(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$provideDocumentHighlights($,K,x,V){return this._withAdapter($,E,Y=>Y.provideDocumentHighlights(r.URI.revive(K),x,V),void 0,void 0)}registerLinkedEditingRangeProvider($,K,x){const V=this._addNewAdapter(new v(this._documents,x),$);return this._proxy.$registerLinkedEditingRangeProvider(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$provideLinkedEditingRanges($,K,x,V){return this._withAdapter($,v,async Y=>{const se=await Y.provideLinkedEditingRanges(r.URI.revive(K),x,V);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?et._serializeRegExp(se.wordPattern):void 0}},void 0,void 0)}registerReferenceProvider($,K,x){const V=this._addNewAdapter(new k(this._documents,x),$);return this._proxy.$registerReferenceSupport(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$provideReferences($,K,x,V,Y){return this._withAdapter($,k,se=>se.provideReferences(r.URI.revive(K),x,V,Y),void 0,Y)}registerCodeActionProvider($,K,x,V){const Y=new h.DisposableStore,se=this._addNewAdapter(new L(this._documents,this._commands.converter,this._diagnostics,x,this._logService,$,this._apiDeprecation),$);return this._proxy.$registerQuickFixSupport(se,this._transformDocumentSelector(K),{providedKinds:V?.providedCodeActionKinds?.map(_e=>_e.value),documentation:V?.documentation?.map(_e=>({kind:_e.kind.value,command:this._commands.converter.toInternal(_e.command,Y)}))},et._extLabel($),Boolean(x.resolveCodeAction)),Y.add(this._createDisposable(se)),Y}$provideCodeActions($,K,x,V,Y){return this._withAdapter($,L,se=>se.provideCodeActions(r.URI.revive(K),x,V,Y),void 0,void 0)}$resolveCodeAction($,K,x){return this._withAdapter($,L,V=>V.resolveCodeAction(K,x),void 0,void 0)}$releaseCodeActions($,K){this._withAdapter($,L,x=>Promise.resolve(x.releaseCodeActions(K)),void 0,void 0)}registerDocumentFormattingEditProvider($,K,x){const V=this._addNewAdapter(new y(this._documents,x),$);return this._proxy.$registerDocumentFormattingSupport(V,this._transformDocumentSelector(K),$.identifier,$.displayName||$.name),this._createDisposable(V)}$provideDocumentFormattingEdits($,K,x,V){return this._withAdapter($,y,Y=>Y.provideDocumentFormattingEdits(r.URI.revive(K),x,V),void 0,void 0)}registerDocumentRangeFormattingEditProvider($,K,x){const V=this._addNewAdapter(new O(this._documents,x),$);return this._proxy.$registerRangeFormattingSupport(V,this._transformDocumentSelector(K),$.identifier,$.displayName||$.name),this._createDisposable(V)}$provideDocumentRangeFormattingEdits($,K,x,V,Y){return this._withAdapter($,O,se=>se.provideDocumentRangeFormattingEdits(r.URI.revive(K),x,V,Y),void 0,void 0)}registerOnTypeFormattingEditProvider($,K,x,V){const Y=this._addNewAdapter(new U(this._documents,x),$);return this._proxy.$registerOnTypeFormattingSupport(Y,this._transformDocumentSelector(K),V,$.identifier),this._createDisposable(Y)}$provideOnTypeFormattingEdits($,K,x,V,Y,se){return this._withAdapter($,U,_e=>_e.provideOnTypeFormattingEdits(r.URI.revive(K),x,V,Y,se),void 0,void 0)}registerWorkspaceSymbolProvider($,K){const x=this._addNewAdapter(new q(K,this._logService),$);return this._proxy.$registerNavigateTypeSupport(x,typeof K.resolveWorkspaceSymbol=="function"),this._createDisposable(x)}$provideWorkspaceSymbols($,K,x){return this._withAdapter($,q,V=>V.provideWorkspaceSymbols(K,x),{symbols:[]},x)}$resolveWorkspaceSymbol($,K,x){return this._withAdapter($,q,V=>V.resolveWorkspaceSymbol(K,x),void 0,void 0)}$releaseWorkspaceSymbols($,K){this._withAdapter($,q,x=>x.releaseWorkspaceSymbols(K),void 0,void 0)}registerRenameProvider($,K,x){const V=this._addNewAdapter(new H(this._documents,x,this._logService),$);return this._proxy.$registerRenameSupport(V,this._transformDocumentSelector(K),H.supportsResolving(x)),this._createDisposable(V)}$provideRenameEdits($,K,x,V,Y){return this._withAdapter($,H,se=>se.provideRenameEdits(r.URI.revive(K),x,V,Y),void 0,void 0)}$resolveRenameLocation($,K,x,V){return this._withAdapter($,H,Y=>Y.resolveRenameLocation(r.URI.revive(K),x,V),void 0,void 0)}registerDocumentSemanticTokensProvider($,K,x,V){const Y=this._addNewAdapter(new j(this._documents,x),$),se=typeof x.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(Y,this._transformDocumentSelector(K),V,se);let _e=this._createDisposable(Y);if(se){const Ue=x.onDidChangeSemanticTokens(Ve=>this._proxy.$emitDocumentSemanticTokensEvent(se));_e=P.Disposable.from(_e,Ue)}return _e}$provideDocumentSemanticTokens($,K,x,V){return this._withAdapter($,j,Y=>Y.provideDocumentSemanticTokens(r.URI.revive(K),x,V),null,void 0)}$releaseDocumentSemanticTokens($,K){this._withAdapter($,j,x=>x.releaseDocumentSemanticColoring(K),void 0,void 0)}registerDocumentRangeSemanticTokensProvider($,K,x,V){const Y=this._addNewAdapter(new ie(this._documents,x),$);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Y,this._transformDocumentSelector(K),V),this._createDisposable(Y)}$provideDocumentRangeSemanticTokens($,K,x,V){return this._withAdapter($,ie,Y=>Y.provideDocumentRangeSemanticTokens(r.URI.revive(K),x,V),null,void 0)}registerCompletionItemProvider($,K,x,V){const Y=this._addNewAdapter(new ae(this._documents,this._commands.converter,x,this._apiDeprecation,$),$);return this._proxy.$registerSuggestSupport(Y,this._transformDocumentSelector(K),V,ae.supportsResolving(x),`${$.identifier.value}(${V.join("")})`),this._createDisposable(Y)}$provideCompletionItems($,K,x,V,Y){return this._withAdapter($,ae,se=>se.provideCompletionItems(r.URI.revive(K),x,V,Y),void 0,Y)}$resolveCompletionItem($,K,x){return this._withAdapter($,ae,V=>V.resolveCompletionItem(K,x),void 0,x)}$releaseCompletionItems($,K){this._withAdapter($,ae,x=>x.releaseCompletionItems(K),void 0,void 0)}registerInlineCompletionsProvider($,K,x){const V=this._addNewAdapter(new te(this._documents,x,this._commands.converter),$);return this._proxy.$registerInlineCompletionsSupport(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$provideInlineCompletions($,K,x,V,Y){return this._withAdapter($,te,se=>se.provideInlineCompletions(r.URI.revive(K),x,V,Y),void 0,void 0)}$handleInlineCompletionDidShow($,K,x){this._withAdapter($,te,async V=>{V.handleDidShowCompletionItem(K,x)},void 0,void 0)}$freeInlineCompletionsList($,K){this._withAdapter($,te,async x=>{x.disposeCompletions(K)},void 0,void 0)}registerSignatureHelpProvider($,K,x,V){const Y=Array.isArray(V)?{triggerCharacters:V,retriggerCharacters:[]}:V,se=this._addNewAdapter(new be(this._documents,x),$);return this._proxy.$registerSignatureHelpProvider(se,this._transformDocumentSelector(K),Y),this._createDisposable(se)}$provideSignatureHelp($,K,x,V,Y){return this._withAdapter($,be,se=>se.provideSignatureHelp(r.URI.revive(K),x,V,Y),void 0,void 0)}$releaseSignatureHelp($,K){this._withAdapter($,be,x=>x.releaseSignatureHelp(K),void 0,void 0)}registerInlayHintsProvider($,K,x){const V=typeof x.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Y=this._addNewAdapter(new pe(this._documents,this._commands.converter,x,this._logService,$),$);this._proxy.$registerInlayHintsProvider(Y,this._transformDocumentSelector(K),typeof x.resolveInlayHint=="function",V);let se=this._createDisposable(Y);if(V!==void 0){const _e=x.onDidChangeInlayHints(Ue=>this._proxy.$emitInlayHintsEvent(V));se=P.Disposable.from(se,_e)}return se}$provideInlayHints($,K,x,V){return this._withAdapter($,pe,Y=>Y.provideInlayHints(r.URI.revive(K),x,V),void 0,V)}$resolveInlayHint($,K,x){return this._withAdapter($,pe,V=>V.resolveInlayHint(K,x),void 0,x)}$releaseInlayHints($,K){this._withAdapter($,pe,x=>x.releaseHints(K),void 0,void 0)}registerDocumentLinkProvider($,K,x){const V=this._addNewAdapter(new me(this._documents,x),$);return this._proxy.$registerDocumentLinkProvider(V,this._transformDocumentSelector(K),typeof x.resolveDocumentLink=="function"),this._createDisposable(V)}$provideDocumentLinks($,K,x){return this._withAdapter($,me,V=>V.provideLinks(r.URI.revive(K),x),void 0,void 0)}$resolveDocumentLink($,K,x){return this._withAdapter($,me,V=>V.resolveLink(K,x),void 0,void 0)}$releaseDocumentLinks($,K){this._withAdapter($,me,x=>x.releaseLinks(K),void 0,void 0)}registerColorProvider($,K,x){const V=this._addNewAdapter(new oe(this._documents,x),$);return this._proxy.$registerDocumentColorProvider(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$provideDocumentColors($,K,x){return this._withAdapter($,oe,V=>V.provideColors(r.URI.revive(K),x),[],void 0)}$provideColorPresentations($,K,x,V){return this._withAdapter($,oe,Y=>Y.provideColorPresentations(r.URI.revive(K),x,V),void 0,void 0)}registerFoldingRangeProvider($,K,x){const V=this._nextHandle(),Y=typeof x.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(V,new st(new Ee(this._documents,x),$)),this._proxy.$registerFoldingRangeProvider(V,this._transformDocumentSelector(K),Y);let se=this._createDisposable(V);if(Y!==void 0){const _e=x.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Y));se=P.Disposable.from(se,_e)}return se}$provideFoldingRanges($,K,x,V){return this._withAdapter($,Ee,Y=>Y.provideFoldingRanges(r.URI.revive(K),x,V),void 0,void 0)}registerSelectionRangeProvider($,K,x){const V=this._addNewAdapter(new Pe(this._documents,x,this._logService),$);return this._proxy.$registerSelectionRangeProvider(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$provideSelectionRanges($,K,x,V){return this._withAdapter($,Pe,Y=>Y.provideSelectionRanges(r.URI.revive(K),x,V),[],V)}registerCallHierarchyProvider($,K,x){const V=this._addNewAdapter(new Oe(this._documents,x),$);return this._proxy.$registerCallHierarchyProvider(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$prepareCallHierarchy($,K,x,V){return this._withAdapter($,Oe,Y=>Promise.resolve(Y.prepareSession(r.URI.revive(K),x,V)),void 0,V)}$provideCallHierarchyIncomingCalls($,K,x,V){return this._withAdapter($,Oe,Y=>Y.provideCallsTo(K,x,V),void 0,V)}$provideCallHierarchyOutgoingCalls($,K,x,V){return this._withAdapter($,Oe,Y=>Y.provideCallsFrom(K,x,V),void 0,V)}$releaseCallHierarchy($,K){this._withAdapter($,Oe,x=>Promise.resolve(x.releaseSession(K)),void 0,void 0)}registerTypeHierarchyProvider($,K,x){const V=this._addNewAdapter(new je(this._documents,x),$);return this._proxy.$registerTypeHierarchyProvider(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$prepareTypeHierarchy($,K,x,V){return this._withAdapter($,je,Y=>Promise.resolve(Y.prepareSession(r.URI.revive(K),x,V)),void 0,V)}$provideTypeHierarchySupertypes($,K,x,V){return this._withAdapter($,je,Y=>Y.provideSupertypes(K,x,V),void 0,V)}$provideTypeHierarchySubtypes($,K,x,V){return this._withAdapter($,je,Y=>Y.provideSubtypes(K,x,V),void 0,V)}$releaseTypeHierarchy($,K){this._withAdapter($,je,x=>Promise.resolve(x.releaseSession(K)),void 0,void 0)}static _serializeRegExp($){return{pattern:$.source,flags:(0,I.regExpFlags)($)}}static _serializeIndentationRule($){return{decreaseIndentPattern:et._serializeRegExp($.decreaseIndentPattern),increaseIndentPattern:et._serializeRegExp($.increaseIndentPattern),indentNextLinePattern:$.indentNextLinePattern?et._serializeRegExp($.indentNextLinePattern):void 0,unIndentedLinePattern:$.unIndentedLinePattern?et._serializeRegExp($.unIndentedLinePattern):void 0}}static _serializeOnEnterRule($){return{beforeText:et._serializeRegExp($.beforeText),afterText:$.afterText?et._serializeRegExp($.afterText):void 0,previousLineText:$.previousLineText?et._serializeRegExp($.previousLineText):void 0,action:$.action}}static _serializeOnEnterRules($){return $.map(et._serializeOnEnterRule)}setLanguageConfiguration($,K,x){let{wordPattern:V}=x;if(V&&(0,I.regExpLeadsToEndlessLoop)(V))throw new Error(`Invalid language configuration: wordPattern '${V}' is not allowed to match the empty string.`);V?this._documents.setWordDefinitionFor(K,V):this._documents.setWordDefinitionFor(K,void 0),x.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",$,"Do not use."),x.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",$,"Do not use.");const Y=this._nextHandle(),se={comments:x.comments,brackets:x.brackets,wordPattern:x.wordPattern?et._serializeRegExp(x.wordPattern):void 0,indentationRules:x.indentationRules?et._serializeIndentationRule(x.indentationRules):void 0,onEnterRules:x.onEnterRules?et._serializeOnEnterRules(x.onEnterRules):void 0,__electricCharacterSupport:x.__electricCharacterSupport,__characterPairSupport:x.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Y,K,se),this._createDisposable(Y)}$setWordDefinitions($){for(const K of $)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=et,et._handlePool=0}),define(ye[189],Se([0,1,5,8,7,34,10,6]),function(Z,e,r,t,S,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class D{constructor(R,b,i,h){this._documents=b,this._commands=i,this._uriTransformer=h,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(r.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,b){await this._proxy.$changeLanguage(R,b);const i=this._documents.getDocumentData(R);if(!i)throw new Error(`document '${R.toString}' NOT found`);return i.document}async tokenAtPosition(R,b){const i=R.version,h=t.Position.from(b),l=await this._proxy.$tokensAtPosition(R.uri,h),o={type:S.StandardTokenType.Other,range:R.getWordRangeAtPosition(b)??new S.Range(b.line,b.character,b.line,b.character)};if(!l)return o;const m={range:t.Range.to(l.range),type:t.TokenType.to(l.type)};return!m.range.contains(b)||i!==R.version?o:m}createLanguageStatusItem(R,b,i){const h=this._handlePool++,l=this._proxy,o=this._ids,m=`${R.identifier.value}/${b}`;if(o.has(m))throw new Error(`LanguageStatusItem with id '${b}' ALREADY exists`);o.add(m);const M={selector:i,id:b,name:R.displayName??R.name,severity:S.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let C,w=new I.DisposableStore;const u=()=>{C?.dispose(),C=(0,A.disposableTimeout)(()=>{w.clear(),this._proxy.$setLanguageStatus(h,{id:m,name:M.name??R.displayName??R.name,source:R.displayName??R.name,selector:t.DocumentSelector.from(M.selector,this._uriTransformer),label:M.text,detail:M.detail??"",severity:M.severity===S.LanguageStatusSeverity.Error?P.default.Error:M.severity===S.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:M.command&&this._commands.toInternal(M.command,w),accessibilityInfo:M.accessibilityInformation,busy:M.busy})},0)},_={dispose(){w.dispose(),C?.dispose(),l.$removeLanguageStatus(h),o.delete(m)},get id(){return M.id},get name(){return M.name},set name(a){M.name=a,u()},get selector(){return M.selector},set selector(a){M.selector=a,u()},get text(){return M.text},set text(a){M.text=a,u()},get detail(){return M.detail},set detail(a){M.detail=a,u()},get severity(){return M.severity},set severity(a){M.severity=a,u()},get accessibilityInformation(){return M.accessibilityInformation},set accessibilityInformation(a){M.accessibilityInformation=a,u()},get command(){return M.command},set command(a){M.command=a,u()},get busy(){return M.busy},set busy(a){M.busy=a,u()}};return u(),_}}e.ExtHostLanguages=D}),define(ye[190],Se([0,1,12,5,28,14,4]),function(Z,e,r,t,S,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let I=class extends r.AbstractLoggerService{constructor(R,b){const i=new A.Emitter;super(b.logLevel,i.event);this._proxy=R.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(i)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,b,i){return new D(this._proxy,R,b,i)}};I=xe([$e(0,P.IExtHostRpcService),$e(1,S.IExtHostInitDataService)],I),e.ExtHostLoggerService=I;class D extends r.AbstractMessageLogger{constructor(R,b,i,h){super(h?.always);this.proxy=R,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(i),this.proxy.$createLogger(b,h).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,b){const i=[[R,b]];this.isLoggerCreated?this.doLog(i):this.buffer.push(...i)}doLog(R){this.proxy.$log(this.file,R)}}}),define(ye[191],Se([0,1,5,12,26]),function(Z,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(I){return I&&I.title}let A=class{constructor(D,T){this._logService=T,this._proxy=D.getProxy(r.MainContext.MainThreadMessageService)}showMessage(D,T,R,b,i){const h={source:{identifier:D.identifier,label:D.displayName||D.name}};let l;typeof b=="string"||P(b)?l=[b,...i]:(h.modal=b?.modal,h.useCustom=b?.useCustom,h.detail=b?.detail,l=i),h.useCustom&&(0,S.checkProposedApiEnabled)(D,"resolvers");const o=[];for(let m=0;m<l.length;m++){const M=l[m];if(typeof M=="string")o.push({title:M,handle:m,isCloseAffordance:!1});else if(typeof M=="object"){let{title:C,isCloseAffordance:w}=M;o.push({title:C,isCloseAffordance:!!w,handle:m})}else this._logService.warn("Invalid message item:",M)}return this._proxy.$showMessage(T,R,h,o).then(m=>{if(typeof m=="number")return l[m]})}};A=xe([$e(1,t.ILogService)],A),e.ExtHostMessageService=A}),define(ye[192],Se([0,1,21,4,92,6,22,9,13,2,62,5,8,7,38,165,89]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i,h,l,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class M{constructor(w,u,_,a,F){this._textDocumentsAndEditors=_,this._textDocuments=a,this._extensionStoragePaths=F,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new t.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new t.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new t.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=w.getProxy(b.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=w.getProxy(b.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=w.getProxy(b.MainContext.MainThreadNotebookEditors),this._commandsConverter=u.converter,u.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===12){const n=c.notebookEditor?.notebookUri,f=c.cell.handle,s=this._documents.get(n)?.getCell(f);if(s)return s.apiCell}return c}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(w=>w.apiEditor)}getEditorById(w){const u=this._editors.get(w);if(!u)throw new Error(`unknown text editor: ${w}. known editors: ${[...this._editors.keys()]} `);return u}getIdByEditor(w){for(const[u,_]of this._editors)if(_.apiEditor===w)return u}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(w,u){const _=this._documents.get(w);if(!_&&!u)throw new Error(`NO notebook document for '${w}'`);return _}_getProviderData(w){const u=this._notebookContentProviders.get(w);if(!u)throw new Error(`NO provider for '${w}'`);return u}registerNotebookContentProvider(w,u,_,a,F){if((0,I.isFalsyOrWhitespace)(u))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(u))throw new Error(`Notebook provider for '${u}' already registered`);this._notebookContentProviders.set(u,{extension:w,provider:_});let c;return _.onDidChangeNotebookContentOptions&&(c=_.onDidChangeNotebookContentOptions(()=>{const n=i.NotebookDocumentContentOptions.from(_.options);this._notebookProxy.$updateNotebookProviderOptions(u,n)})),this._notebookProxy.$registerNotebookProvider({id:w.identifier,location:w.extensionLocation},u,i.NotebookDocumentContentOptions.from(a),M._convertNotebookRegistrationData(w,F)),new h.Disposable(()=>{c?.dispose(),this._notebookContentProviders.delete(u),this._notebookProxy.$unregisterNotebookProvider(u)})}static _convertNotebookRegistrationData(w,u){if(!u)return;const _=u.filenamePattern.map(a=>i.NotebookExclusiveDocumentPattern.from(a)).filter(a=>a!==void 0);if(u.filenamePattern&&!_){console.warn(`Notebook content provider view options file name pattern is invalid ${u.filenamePattern}`);return}return{extension:w.identifier,providerDisplayName:w.displayName||w.name,displayName:u.displayName,filenamePattern:_,exclusive:u.exclusive||!1}}registerNotebookCellStatusBarItemProvider(w,u,_){const a=M._notebookStatusBarItemProviderHandlePool++,F=typeof _.onDidChangeCellStatusBarItems=="function"?M._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(a,_),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(a,F,u);let c;return F!==void 0&&(c=_.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(F))),new h.Disposable(()=>{this._notebookStatusBarItemProviders.delete(a),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(a,F),c&&c.dispose()})}async createNotebookDocument(w){const u=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:w.viewType,content:w.content&&i.NotebookData.from(w.content)});return T.URI.revive(u)}async openNotebookDocument(w){const u=this._documents.get(w);if(u)return u.apiNotebook;const _=await this._notebookDocumentsProxy.$tryOpenNotebook(w),a=this._documents.get(T.URI.revive(_));return(0,D.assertIsDefined)(a?.apiNotebook)}async showNotebookDocument(w,u){T.URI.isUri(w)&&(w=await this.openNotebookDocument(w));let _;typeof u=="object"?_={position:i.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selections:u.selections&&u.selections.map(i.NotebookRange.from),pinned:typeof u.preview=="boolean"?!u.preview:void 0}:_={preserveFocus:!1};const a=await this._notebookEditorsProxy.$tryShowNotebookDocument(w.uri,w.notebookType,_),F=a&&this._editors.get(a)?.apiEditor;if(F)return F;throw a?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(w,u,_,a){const F=this._notebookStatusBarItemProviders.get(w),c=T.URI.revive(u),n=this._documents.get(c);if(!n||!F)return;const f=n.getCellFromIndex(_);if(!f)return;const g=await F.provideCellStatusBarItems(f.apiCell,a);if(!g)return;const s=new P.DisposableStore,d=this._statusBarCache.add([s]),E=(Array.isArray(g)?g:[g]).map(v=>i.NotebookStatusBarItem.from(v,this._commandsConverter,s));return{cacheId:d,items:E}}$releaseNotebookCellStatusBarItems(w){this._statusBarCache.delete(w)}registerNotebookSerializer(w,u,_,a,F){if((0,I.isFalsyOrWhitespace)(u))throw new Error("viewType cannot be empty or just whitespace");const c=this._handlePool++;return this._notebookSerializer.set(c,_),this._notebookProxy.$registerNotebookSerializer(c,{id:w.identifier,location:w.extensionLocation},u,i.NotebookDocumentContentOptions.from(a),M._convertNotebookRegistrationData(w,F)),(0,P.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(c)})}async $dataToNotebook(w,u,_){const a=this._notebookSerializer.get(w);if(!a)throw new Error("NO serializer found");const F=await a.deserializeNotebook(u.buffer,_);return new l.SerializableObjectWithBuffers(i.NotebookData.from(F))}async $notebookToData(w,u,_){const a=this._notebookSerializer.get(w);if(!a)throw new Error("NO serializer found");const F=await a.serializeNotebook(i.NotebookData.to(u.value),_);return r.VSBuffer.wrap(F)}async $openNotebook(w,u,_,a,F){const{provider:c}=this._getProviderData(w),n=await c.openNotebook(T.URI.revive(u),{backupId:_,untitledDocumentData:a?.buffer},F);return new l.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(i.NotebookCellData.from)})}async $saveNotebook(w,u,_){const a=this.getNotebookDocument(T.URI.revive(u)),{provider:F}=this._getProviderData(w);return await F.saveNotebook(a.apiNotebook,_),!0}async $saveNotebookAs(w,u,_,a){const F=this.getNotebookDocument(T.URI.revive(u)),{provider:c}=this._getProviderData(w);return await c.saveNotebookAs(T.URI.revive(_),F.apiNotebook,a),!0}async $backupNotebook(w,u,_){const a=this.getNotebookDocument(T.URI.revive(u)),F=this._getProviderData(w),c=this._extensionStoragePaths.workspaceValue(F.extension)??this._extensionStoragePaths.globalValue(F.extension),n=String((0,S.hash)([a.uri.toString(),this._backupIdPool++])),f=T.URI.joinPath(c,n),g=await F.provider.backupNotebook(a.apiNotebook,{destination:f},_);return a.updateBackup(g),g.id}_createExtHostEditor(w,u,_){if(this._editors.has(u))throw new Error(`editor with id ALREADY EXSIST: ${u}`);const a=new m.ExtHostNotebookEditor(u,this._notebookEditorsProxy,w,_.visibleRanges.map(i.NotebookRange.to),_.selections.map(i.NotebookRange.to),typeof _.viewColumn=="number"?i.ViewColumn.to(_.viewColumn):void 0);this._editors.set(u,a)}$acceptDocumentAndEditorsDelta(w){if(w.value.removedDocuments)for(const _ of w.value.removedDocuments){const a=T.URI.revive(_),F=this._documents.get(a);F&&(F.dispose(),this._documents.delete(a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:F.apiNotebook.getCells().map(c=>c.document.uri)}),this._onDidCloseNotebookDocument.fire(F.apiNotebook));for(const c of this._editors.values())c.notebookData.uri.toString()===a.toString()&&this._editors.delete(c.id)}if(w.value.addedDocuments){const _=[];for(const a of w.value.addedDocuments){const F=T.URI.revive(a.uri);if(this._documents.has(F))throw new Error(`adding EXISTING notebook ${F} `);const c=this,n=new o.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(f){c._onDidChangeNotebookCells.fire(f)},emitCellOutputsChange(f){c._onDidChangeCellOutputs.fire(f)},emitCellMetadataChange(f){c._onDidChangeCellMetadata.fire(f)}},F,a);_.push(...a.cells.map(f=>o.ExtHostCell.asModelAddData(n.apiNotebook,f))),this._documents.get(F)?.dispose(),this._documents.set(F,n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:_}),this._onDidOpenNotebookDocument.fire(n.apiNotebook)}}if(w.value.addedEditors)for(const _ of w.value.addedEditors){if(this._editors.has(_.id))return;const a=T.URI.revive(_.documentUri),F=this._documents.get(a);F&&this._createExtHostEditor(F,_.id,_)}const u=[];if(w.value.removedEditors)for(const _ of w.value.removedEditors){const a=this._editors.get(_);a&&(this._editors.delete(_),this._activeNotebookEditor?.id===a.id&&(this._activeNotebookEditor=void 0),u.push(a))}if(w.value.visibleEditors){this._visibleNotebookEditors=w.value.visibleEditors.map(a=>this._editors.get(a)).filter(a=>!!a);const _=new Set;this._visibleNotebookEditors.forEach(a=>_.add(a.id));for(const a of this._editors.values()){const F=_.has(a.id);a._acceptVisibility(F)}this._visibleNotebookEditors=[...this._editors.values()].map(a=>a).filter(a=>a.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}w.value.newActiveEditor===null?this._activeNotebookEditor=void 0:w.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(w.value.newActiveEditor)),w.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=M,M._notebookStatusBarItemProviderHandlePool=0}),define(ye[193],Se([0,1,4,54,12,5,14,8]),function(Z,e,r,t,S,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class D{constructor(b,i){const h=D._Keys.nextId();b.$registerNotebookEditorDecorationType(h,I.NotebookDecorationRenderOptions.from(i)),this.value={key:h,dispose(){b.$removeNotebookEditorDecorationType(h)}}}}D._Keys=new t.IdGenerator("NotebookEditorDecorationType");let T=class{constructor(b,i,h){this._logService=b,this._extHostRpc=i,this._notebooksAndEditors=h,this._onDidChangeNotebookEditorSelection=new r.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new r.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(b){return new D(this._extHostRpc.getProxy(P.MainContext.MainThreadNotebookEditors),b).value}$acceptEditorPropertiesChanged(b,i){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,i);const h=this._notebooksAndEditors.getEditorById(b);i.visibleRanges&&h._acceptVisibleRanges(i.visibleRanges.ranges.map(I.NotebookRange.to)),i.selections&&h._acceptSelections(i.selections.selections.map(I.NotebookRange.to)),i.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:h.apiEditor,visibleRanges:h.apiEditor.visibleRanges}),i.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:h.apiEditor,selections:h.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const i in b)this._notebooksAndEditors.getEditorById(i)._acceptViewColumn(I.ViewColumn.to(b[i]))}};T=xe([$e(0,S.ILogService),$e(1,A.IExtHostRpcService)],T),e.ExtHostNotebookEditors=T}),define(ye[194],Se([0,1,16,10,20,4,6,22,2,25,12,5,39,8,7,65,158,26,38]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i,h,l,o,m,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let w=class{constructor(n,f,g,s,d){this._initData=f,this._extHostNotebook=g,this._commands=s,this._logService=d,this._activeExecutions=new I.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new P.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=n.getProxy(b.MainContext.MainThreadNotebookKernels);const p=new i.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new i.ApiCommandArgument("options","Select kernel options",E=>!0,E=>{if(E&&"notebookEditor"in E&&"id"in E){const v=this._extHostNotebook.getIdByEditor(E.notebookEditor);return{id:E.id,extension:E.extension,notebookEditorId:v}}else if(E&&"notebookEditor"in E){const v=this._extHostNotebook.getIdByEditor(E.notebookEditor);if(v===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${E.notebookEditor.document.uri.toString()}`);return{notebookEditorId:v}}return E})],i.ApiCommandResult.Void);this._commands.registerApiCommand(p)}createNotebookController(n,f,g,s,d,p){for(const ue of this._kernelData.values())if(ue.controller.id===f&&T.ExtensionIdentifier.equals(n.identifier,ue.extensionId))throw new Error(`notebook controller with id '${f}' ALREADY exist`);const E=this._handlePool++,v=this;this._logService.trace(`NotebookController[${E}], CREATED by ${n.identifier.value}, ${f}`);const k=()=>console.warn(`NO execute handler from notebook controller '${q.id}' of extension: '${n.identifier}'`);let L=!1;const y=new A.DisposableStore,O=new P.Emitter,U=new P.Emitter,q={id:F(n,f),notebookType:g,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:s||n.identifier.value,preloads:p?p.map(h.NotebookRendererScript.from):[]};let H=d??k,z;this._proxy.$addKernel(E,q).catch(ue=>{console.log(ue),L=!0});let j=0;const ie=()=>{if(L)return;const ue=++j;Promise.resolve().then(()=>{ue===j&&this._proxy.$updateKernel(E,q)})},ae=new I.ResourceMap,te={get id(){return f},get notebookType(){return q.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return q.label},set label(ue){q.label=ue??n.displayName??n.name,ie()},get detail(){return q.detail??""},set detail(ue){q.detail=ue,ie()},get description(){return q.description??""},set description(ue){q.description=ue,ie()},get kind(){return(0,M.checkProposedApiEnabled)(n,"notebookControllerKind"),q.kind??""},set kind(ue){(0,M.checkProposedApiEnabled)(n,"notebookControllerKind"),q.kind=ue,ie()},get supportedLanguages(){return q.supportedLanguages},set supportedLanguages(ue){q.supportedLanguages=ue,ie()},get supportsExecutionOrder(){return q.supportsExecutionOrder??!1},set supportsExecutionOrder(ue){q.supportsExecutionOrder=ue,ie()},get rendererScripts(){return q.preloads?q.preloads.map(h.NotebookRendererScript.to):[]},get executeHandler(){return H},set executeHandler(ue){H=ue??k},get interruptHandler(){return z},set interruptHandler(ue){z=ue,q.supportsInterrupt=Boolean(ue),ie()},createNotebookCellExecution(ue){if(L)throw new Error("notebook controller is DISPOSED");if(!ae.has(ue.notebook.uri))throw v._logService.trace(`NotebookController[${E}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ae.keys()).map(be=>be.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.notebook.uri.toString()}`);return v._createNotebookCellExecution(ue,F(n,this.id))},dispose:()=>{L||(this._logService.trace(`NotebookController[${E}], DISPOSED`),L=!0,this._kernelData.delete(E),y.dispose(),O.dispose(),U.dispose(),this._proxy.$removeKernel(E))},updateNotebookAffinity(ue,be){v._proxy.$updateNotebookPriority(E,ue.uri,be)},onDidReceiveMessage:U.event,postMessage(ue,be){return(0,M.checkProposedApiEnabled)(n,"notebookMessaging"),v._proxy.$postMessage(E,be&&v._extHostNotebook.getIdByEditor(be),ue)},asWebviewUri(ue){return(0,M.checkProposedApiEnabled)(n,"notebookMessaging"),(0,o.asWebviewUri)(ue,v._initData.remote)}};return this._kernelData.set(E,{extensionId:n.identifier,controller:te,onDidReceiveMessage:U,onDidChangeSelection:O,associatedNotebooks:ae}),te}$acceptNotebookAssociation(n,f,g){const s=this._kernelData.get(n);if(s){const d=this._extHostNotebook.getNotebookDocument(D.URI.revive(f));g?s.associatedNotebooks.set(d.uri,!0):s.associatedNotebooks.delete(d.uri),this._logService.trace(`NotebookController[${n}] ASSOCIATE notebook`,d.uri.toString(),g),s.onDidChangeSelection.fire({selected:g,notebook:d.apiNotebook})}}async $executeCells(n,f,g){const s=this._kernelData.get(n);if(!s)return;const d=this._extHostNotebook.getNotebookDocument(D.URI.revive(f)),p=[];for(const E of g){const v=d.getCell(E);v&&p.push(v.apiCell)}try{this._logService.trace(`NotebookController[${n}] EXECUTE cells`,d.uri.toString(),p.length),await s.controller.executeHandler.call(s.controller,p,d.apiNotebook,s.controller)}catch(E){this._logService.error(`NotebookController[${n}] execute cells FAILED`,E),console.error(E)}}async $cancelCells(n,f,g){const s=this._kernelData.get(n);if(!s)return;const d=this._extHostNotebook.getNotebookDocument(D.URI.revive(f));if(s.controller.interruptHandler)await s.controller.interruptHandler.call(s.controller,d.apiNotebook);else for(const p of g){const E=d.getCell(p);E&&this._activeExecutions.get(E.uri)?.cancel()}}$acceptKernelMessageFromRenderer(n,f,g){const s=this._kernelData.get(n);if(!s)return;const d=this._extHostNotebook.getEditorById(f);s.onDidReceiveMessage.fire(Object.freeze({editor:d.apiEditor,message:g}))}$cellExecutionChanged(n,f,g){const d=this._extHostNotebook.getNotebookDocument(D.URI.revive(n)).getCell(f);d&&this._onDidChangeCellExecutionState.fire({cell:d.apiCell,state:g??l.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(n,f){if(n.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(n.notebook.uri).getCellFromApiCell(n);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const d=new _(f,s,this._proxy);this._activeExecutions.set(s.uri,d);const p=d.onDidChangeState(()=>{d.state===u.Resolved&&(d.dispose(),p.dispose(),this._activeExecutions.delete(s.uri))});return d.asApiObject()}};w=xe([$e(4,R.ILogService)],w),e.ExtHostNotebookKernels=w;var u;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(u||(u={}));class _ extends A.Disposable{constructor(n,f,g){super();this._cell=f,this._proxy=g,this._handle=_.HANDLE++,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=u.Init,this._tokenSource=this._register(new S.CancellationTokenSource),this._collector=new a(10,s=>this.update(s)),this._executionOrder=f.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,n,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(n){await this._collector.addItem(n)}async update(n){const f=Array.isArray(n)?n:[n];return this._proxy.$updateExecution(this._handle,new C.SerializableObjectWithBuffers(f))}verifyStateForOutput(){if(this._state===u.Init)throw new Error("Must call start before modifying cell output");if(this._state===u.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(n){return n.map(f=>{const g=l.NotebookCellOutput.ensureUniqueMimeTypes(f.items,!0);return g===f.items?h.NotebookCellOutput.from(f):h.NotebookCellOutput.from({items:g,id:f.id,metadata:f.metadata})})}async updateOutputs(n,f,g){const s=this.validateAndConvertOutputs((0,r.asArray)(n));return this.updateSoon({editType:m.CellExecutionUpdateType.Output,append:g,outputs:s})}async updateOutputItems(n,f,g){return n=l.NotebookCellOutput.ensureUniqueMimeTypes((0,r.asArray)(n),!0),this.updateSoon({editType:m.CellExecutionUpdateType.OutputItems,items:n.map(h.NotebookCellOutputItem.from),outputId:f.id,append:g})}asApiObject(){const n=this;return Object.freeze({get token(){return n._tokenSource.token},get cell(){return n._cell.apiCell},get executionOrder(){return n._executionOrder},set executionOrder(g){n._executionOrder=g,n.update([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:n._executionOrder}])},start(g){if(n._state===u.Resolved||n._state===u.Started)throw new Error("Cannot call start again");n._state=u.Started,n._onDidChangeState.fire(),n.update({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:g})},end(g,s){if(n._state===u.Resolved)throw new Error("Cannot call resolve twice");n._state=u.Resolved,n._onDidChangeState.fire(),n._collector.flush(),n._proxy.$completeExecution(n._handle,new C.SerializableObjectWithBuffers({runEndTime:s,lastRunSuccess:g}))},clearOutput(g){return n.verifyStateForOutput(),n.updateOutputs([],g,!1)},appendOutput(g,s){return n.verifyStateForOutput(),n.updateOutputs(g,s,!0)},replaceOutput(g,s){return n.verifyStateForOutput(),n.updateOutputs(g,s,!1)},appendOutputItems(g,s){return n.verifyStateForOutput(),n.updateOutputItems(g,s,!0)},replaceOutputItems(g,s){return n.verifyStateForOutput(),n.updateOutputItems(g,s,!1)}})}}_.HANDLE=0;class a{constructor(n,f){this.delay=n,this.callback=f,this.batch=[],this.startedTimer=Date.now()}addItem(n){return this.batch.push(n),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const n=this.currentDeferred;this.currentDeferred=void 0;const f=this.batch;return this.batch=[],this.callback(f).finally(()=>n.complete())}}function F(c,n){return`${c.identifier.value}/${n}`}}),define(ye[195],Se([0,1,4,5,89,26]),function(Z,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(D,T){this._extHostNotebook=T,this._rendererMessageEmitters=new Map,this.proxy=D.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(D,T,R){const b=this._extHostNotebook.getEditorById(D);this._rendererMessageEmitters.get(T)?.fire({editor:b.apiEditor,message:R})}createRendererMessaging(D,T){if(!D.contributes?.notebookRenderer?.some(h=>h.id===T))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${T})`);const R=(0,P.isProposedApiEnabled)(D,"notebookEditor"),b=new WeakMap;return{onDidReceiveMessage:(h,l,o)=>{const m=R?h:M=>{const C={};b.set(C,M.editor),h({editor:C,message:M.message})};return this.getOrCreateEmitterFor(T).event(m,l,o)},postMessage:(h,l)=>{S.ExtHostNotebookEditor.apiEditorsToExtHost.has(h)&&([h,l]=[l,h]);const o=R?l:b.get(l),m=o&&S.ExtHostNotebookEditor.apiEditorsToExtHost.get(o);return this.proxy.$postMessage(m?.id,T,h)}}}getOrCreateEmitterFor(D){let T=this._rendererMessageEmitters.get(D);return T||(T=new r.Emitter({onLastListenerRemove:()=>{T?.dispose(),this._rendererMessageEmitters.delete(D)}}),this._rendererMessageEmitters.set(D,T),T)}}e.ExtHostNotebookRenderers=A}),define(ye[93],Se([0,1,5,6,3,14,12,159,50,28,30,109,21]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class h extends t.Disposable{constructor(m,M,C,w){super();this.id=m,this.name=M,this.logger=C,this.proxy=w,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(m){this.append(m+`
`)}append(m){this.write(m),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Append))}clear(){const m=this.offset;this.logger.flush(),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Clear,m)}replace(m){const M=this.offset;this.write(m),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Replace,M),this.visible&&this.logger.flush()}show(m,M){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof m=="boolean"?m:M))}hide(){this.proxy.$close(this.id)}write(m){this.offset+=i.VSBuffer.fromString(m).byteLength,this.logger.info(m)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=h;let l=class{constructor(m,M,C,w,u){this.extHostFileSystem=C,this.extHostFileSystemInfo=w,this.loggerService=u,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=m.getProxy(r.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(M.logsLocation,`output_logging_${(0,b.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(m){this.visibleChannelId=m;for(const[M,C]of this.channels)C.visible=M===this.visibleChannelId}createOutputChannel(m,M){if(m=m.trim(),!m)throw new Error("illegal argument `name`. must not be falsy");const C=this.doCreateOutputChannel(m,M);return C.then(w=>{this.channels.set(w.id,w),w.visible=w.id===this.visibleChannelId}),this.createExtHostOutputChannel(m,C)}async doCreateOutputChannel(m,M){const C=await this.createOutputDirectory(),w=this.extHostFileSystemInfo.extUri.joinPath(C,`${this.namePool++}-${m.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.loggerService.createLogger(w,{always:!0,donotRotate:!0,donotUseFormatters:!0}),_=await this.proxy.$register(m,!1,w,M.identifier.value);return new h(_,m,u,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(m,M){let C=!1;const w=()=>{if(C)throw new Error("Channel has been closed")};return{get name(){return m},append(u){w(),M.then(_=>_.append(u))},appendLine(u){w(),M.then(_=>_.appendLine(u))},clear(){w(),M.then(u=>u.clear())},replace(u){w(),M.then(_=>_.replace(u))},show(u,_){w(),M.then(a=>a.show(u,_))},hide(){w(),M.then(u=>u.hide())},dispose(){C=!0,M.then(u=>u.dispose())}}}};l=xe([$e(0,P.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,D.IExtHostConsumerFileSystem),$e(3,R.IExtHostFileSystemInfo),$e(4,A.ILoggerService)],l),e.ExtHostOutputService=l,e.IExtHostOutputService=(0,S.createDecorator)("IExtHostOutputService")}),define(ye[196],Se([0,1,10,20,4,6,5,2,7,15,16,34,61,26]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function l(o,m,M){const C=o.getProxy(A.MainContext.MainThreadQuickOpen);class w{constructor(s,d){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=d}showQuickPick(s,d,p=t.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(s),v=++this._instances,k=C.$show(v,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},p),L={},y=k.then(()=>L);return Promise.race([y,E]).then(O=>{if(O!==L)return E.then(U=>{const q=[];for(let H=0;H<U.length;H++){const z=U[H];typeof z=="string"?q.push({label:z,handle:H}):z.kind===D.QuickPickItemKind.Separator?q.push({type:"separator",label:z.label}):q.push({label:z.label,description:z.description,detail:z.detail,picked:z.picked,alwaysShow:z.alwaysShow,handle:H})}return d&&typeof d.onDidSelectItem=="function"&&(this._onDidSelectItem=H=>{d.onDidSelectItem(U[H])}),C.$setItems(v,q),k.then(H=>{if(typeof H=="number")return U[H];if(Array.isArray(H))return H.map(z=>U[z])})})}).then(void 0,O=>{if(!(0,T.isCancellationError)(O))return C.$setError(v,O),Promise.reject(O)})}$onItemSelected(s){this._onDidSelectItem&&this._onDidSelectItem(s)}showInput(s,d=t.CancellationToken.None){return this._validateInput=s?s.validateInput:void 0,C.$input(s,typeof this._validateInput=="function",d).then(void 0,p=>{if(!(0,T.isCancellationError)(p))return Promise.reject(p)})}$validateInput(s){return this._validateInput?(0,r.asPromise)(()=>this._validateInput(s)):Promise.resolve(void 0)}async showWorkspaceFolderPick(s,d=t.CancellationToken.None){const p=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!p)return;const E=await this._workspace.getWorkspaceFolders2();if(!!E)return E.find(v=>v.uri.toString()===p.uri.toString())}createQuickPick(s){const d=new n(s,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}createInputBox(s){const d=new f(s,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}$onDidChangeValue(s,d){const p=this._sessions.get(s);p&&p._fireDidChangeValue(d)}$onDidAccept(s){const d=this._sessions.get(s);d&&d._fireDidAccept()}$onDidChangeActive(s,d){const p=this._sessions.get(s);p instanceof n&&p._fireDidChangeActive(d)}$onDidChangeSelection(s,d){const p=this._sessions.get(s);p instanceof n&&p._fireDidChangeSelection(d)}$onDidTriggerButton(s,d){const p=this._sessions.get(s);p&&p._fireDidTriggerButton(d)}$onDidTriggerItemButton(s,d,p){const E=this._sessions.get(s);E instanceof n&&E._fireDidTriggerItemButton(d,p)}$onDidHide(s){const d=this._sessions.get(s);d&&d._fireDidHide()}}class u{constructor(s,d){this._extensionId=s,this._onDidDispose=d,this._id=n._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new S.Emitter,this._onDidChangeValueEmitter=new S.Emitter,this._onDidTriggerButtonEmitter=new S.Emitter,this._onDidHideEmitter=new S.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((d,p)=>{const E=d===D.QuickInputButtons.Back?-1:p;this._handlesToButtons.set(E,d)}),this.update({buttons:s.map((d,p)=>({...c(d),tooltip:d.tooltip,handle:d===D.QuickInputButtons.Back?-1:p}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const d=this._handlesToButtons.get(s);d&&this._onDidTriggerButtonEmitter.fire(d)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,P.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),C.$dispose(this._id))}update(s){if(!this._disposed){for(const d of Object.keys(s)){const p=s[d];this._pendingUpdate[d]=p===void 0?null:p}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){C.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}u._nextId=1;function _(g){if(g instanceof D.ThemeIcon)return{id:g.id};const s=F(g),d=a(g);return{dark:typeof s=="string"?I.URI.file(s):s,light:typeof d=="string"?I.URI.file(d):d}}function a(g){return typeof g=="object"&&"light"in g?g.light:g}function F(g){return typeof g=="object"&&"dark"in g?g.dark:g}function c(g){const s=_(g.iconPath);let d,p;return"id"in s?p=i.ThemeIcon.asClassName(s):d=s,{iconPath:d,iconClass:p}}class n extends u{constructor(s,d){super(s.identifier,d);this.extension=s,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new S.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new S.Emitter,this._onDidTriggerItemButtonEmitter=new S.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){s.some(p=>p.kind!==void 0)&&(0,h.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((p,E)=>{this._handlesToItems.set(E,p),this._itemsToHandles.set(p,E)});const d=[];for(let p=0;p<s.length;p++){const E=s[p];E.kind===D.QuickPickItemKind.Separator?d.push({type:"separator",label:E.label}):d.push({handle:p,label:E.label,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,buttons:E.buttons?.map((v,k)=>({...c(v),tooltip:v.tooltip,handle:k}))})}this.update({items:d})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(s){this._keepScrollPosition=s,this.update({keepScrollPosition:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(d=>this._itemsToHandles.has(d)),this.update({activeItems:this._activeItems.map(d=>this._itemsToHandles.get(d))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(d=>this._itemsToHandles.has(d)),this.update({selectedItems:this._selectedItems.map(d=>this._itemsToHandles.get(d))})}_fireDidChangeActive(s){const d=(0,R.coalesce)(s.map(p=>this._handlesToItems.get(p)));this._activeItems=d,this._onDidChangeActiveEmitter.fire(d)}_fireDidChangeSelection(s){const d=(0,R.coalesce)(s.map(p=>this._handlesToItems.get(p)));this._selectedItems=d,this._onDidChangeSelectionEmitter.fire(d)}_fireDidTriggerItemButton(s,d){const p=this._handlesToItems.get(s);if(!p||!p.buttons||!p.buttons.length)return;const E=p.buttons[d];E&&this._onDidTriggerItemButtonEmitter.fire({button:E,item:p})}}class f extends u{constructor(s,d){super(s,d);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,this.update({validationMessage:s,severity:s?b.default.Error:b.default.Ignore})}}return new w(m,M)}e.createExtHostQuickOpen=l});var Xe=this&&this.__classPrivateFieldSet||function(Z,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(Z,r):S?S.value=r:e.set(Z,r),r},Ie=this&&this.__classPrivateFieldGet||function(Z,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[197],Se([0,1,2,4,53,6,10,5,16,104,12,25,61,8,26]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i,h,l){"use strict";var o,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function M(d){if(d)return typeof d.iconPath=="string"?r.URI.file(d.iconPath):r.URI.isUri(d.iconPath)||i.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function C(d,p){if(!d.iconPath&&!p.iconPath)return 0;if(d.iconPath){if(!p.iconPath)return 1}else return-1;const E=typeof d.iconPath=="string"?d.iconPath:r.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,v=typeof p.iconPath=="string"?p.iconPath:r.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,T.comparePaths)(E,v)}function w(d,p){let E=0;if(d.strikeThrough!==p.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==p.faded)return d.faded?1:-1;if(d.tooltip!==p.tooltip)return(d.tooltip||"").localeCompare(p.tooltip||"");if(E=C(d,p),E!==0)return E;if(d.light&&p.light)E=C(d.light,p.light);else{if(d.light)return 1;if(p.light)return-1}if(E!==0)return E;if(d.dark&&p.dark)E=C(d.dark,p.dark);else{if(d.dark)return 1;if(p.dark)return-1}return E}function u(d,p){if(d.command!==p.command)return d.command<p.command?-1:1;if(d.title!==p.title)return d.title<p.title?-1:1;if(d.tooltip!==p.tooltip){if(d.tooltip!==void 0&&p.tooltip!==void 0)return d.tooltip<p.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(d.arguments===p.arguments)return 0;if(d.arguments)if(p.arguments){if(d.arguments.length!==p.arguments.length)return d.arguments.length-p.arguments.length}else return 1;else return-1;for(let E=0;E<d.arguments.length;E++){const v=d.arguments[E],k=p.arguments[E];if(v!==k)return v<k?-1:1}return 0}function _(d,p){let E=(0,T.comparePaths)(d.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(E!==0)return E;if(d.command&&p.command)E=u(d.command,p.command);else{if(d.command)return 1;if(p.command)return-1}if(E!==0)return E;if(d.decorations&&p.decorations)E=w(d.decorations,p.decorations);else{if(d.decorations)return 1;if(p.decorations)return-1}return E}function a(d,p){for(let E=0;E<d.length;E++)if(d[E]!==p[E])return!1;return!0}function F(d,p){return d.command===p.command&&d.title===p.title&&d.tooltip===p.tooltip&&(d.arguments&&p.arguments?a(d.arguments,p.arguments):d.arguments===p.arguments)}function c(d,p){return(0,D.equals)(d,p,F)}class n{constructor(p,E,v){this._extension=p,this._sourceControlHandle=v,o.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._visible=!0,Xe(this,o,E,"f")}get value(){return this._value}set value(p){p=p??"",Ie(this,o,"f").$setInputBoxValue(this._sourceControlHandle,p),this.updateValue(p)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(p){Ie(this,o,"f").$setInputBoxPlaceholder(this._sourceControlHandle,p),this._placeholder=p}get validateInput(){return(0,l.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(p){if((0,l.checkProposedApiEnabled)(this._extension,"scmValidation"),p&&typeof p!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=p,Ie(this,o,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!p)}get visible(){return this._visible}set visible(p){p=!!p,this._visible!==p&&(this._visible=p,Ie(this,o,"f").$setInputBoxVisibility(this._sourceControlHandle,p))}showValidationMessage(p,E){(0,l.checkProposedApiEnabled)(this._extension,"scmValidation"),Ie(this,o,"f").$showValidationMessage(this._sourceControlHandle,p,E)}$onInputBoxValueChange(p){this.updateValue(p)}updateValue(p){this._value=p,this._onDidChange.fire(p)}}e.ExtHostSCMInputBox=n,o=new WeakMap;class f{constructor(p,E,v,k,L){this._proxy=p,this._commands=E,this._sourceControlHandle=v,this._id=k,this._label=L,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=f._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(p){this._label=p,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,p)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(p){this._hideWhenEmpty=p,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(p){this._resourceStates=[...p],this._onDidUpdateResourceStates.fire()}getResourceState(p){return this._resourceStatesMap.get(p)}$executeResourceCommand(p,E){const v=this._resourceStatesCommandsMap.get(p);return v?(0,A.asPromise)(()=>this._commands.executeCommand(v.command,...v.arguments||[],E)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this._resourceStates].sort(_),v=(0,D.sortedDiff)(this._resourceSnapshot,p,_).map(y=>{const O=y.toInsert.map(U=>{const q=this._resourceHandlePool++;this._resourceStatesMap.set(q,U);const H=U.resourceUri;let z;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"){const Ee=new P.DisposableStore;z=this._commands.converter.toInternal(U.command,Ee),this._resourceStatesDisposablesMap.set(q,Ee)}else this._resourceStatesCommandsMap.set(q,U.command);const j=M(U.decorations),ie=U.decorations&&M(U.decorations.light)||j,ae=U.decorations&&M(U.decorations.dark)||j,te=[ie,ae],ue=U.decorations&&U.decorations.tooltip||"",be=U.decorations&&!!U.decorations.strikeThrough,pe=U.decorations&&!!U.decorations.faded,me=U.contextValue||"";return{rawResource:[q,H,te,ue,be,pe,me,z],handle:q}});return{start:y.start,deleteCount:y.deleteCount,toInsert:O}}),k=v.map(({start:y,deleteCount:O,toInsert:U})=>[y,O,U.map(q=>q.rawResource)]),L=v.reverse();for(const{start:y,deleteCount:O,toInsert:U}of L){const q=U.map(z=>z.handle),H=this._handlesSnapshot.splice(y,O,...q);for(const z of H)this._resourceStatesMap.delete(z),this._resourceStatesCommandsMap.delete(z),this._resourceStatesDisposablesMap.get(z)?.dispose(),this._resourceStatesDisposablesMap.delete(z)}return this._resourceSnapshot=p,k}dispose(){this._disposed=!0,this._onDidDispose.fire()}}f._handlePool=0;class g{constructor(p,E,v,k,L,y){this._extension=p,this._commands=v,this._id=k,this._label=L,this._rootUri=y,m.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new P.MutableDisposable,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=g._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Xe(this,m,E,"f"),this._inputBox=new n(p,Ie(this,m,"f"),this.handle),Ie(this,m,"f").$registerSourceControl(this.handle,k,L,y)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(p){this._count!==p&&(this._count=p,Ie(this,m,"f").$updateSourceControl(this.handle,{count:p}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(p){this._quickDiffProvider=p,Ie(this,m,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this._commitTemplate}set commitTemplate(p){p!==this._commitTemplate&&(this._commitTemplate=p,Ie(this,m,"f").$updateSourceControl(this.handle,{commitTemplate:p}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(p){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=p;const E=this._commands.converter.toInternal(p,this._acceptInputDisposables.value);Ie(this,m,"f").$updateSourceControl(this.handle,{acceptInputCommand:E})}get actionButton(){return(0,l.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(p){(0,l.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new P.DisposableStore,this._actionButton=p;const E=p!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;Ie(this,m,"f").$updateSourceControl(this.handle,{actionButton:E??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(p){if(this._statusBarCommands&&p&&c(this._statusBarCommands,p))return;this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=p;const E=(p||[]).map(v=>this._commands.converter.toInternal(v,this._statusBarDisposables.value));Ie(this,m,"f").$updateSourceControl(this.handle,{statusBarCommands:E})}get selected(){return this._selected}createResourceGroup(p,E){const v=new f(Ie(this,m,"f"),this._commands,this.handle,p,E),k=t.Event.once(v.onDidDispose)(()=>this.createdResourceGroups.delete(v));return this.createdResourceGroups.set(v,k),this.eventuallyAddResourceGroups(),v}eventuallyAddResourceGroups(){const p=[],E=[];for(const[v,k]of this.createdResourceGroups){k.dispose();const L=v.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(v),this.eventuallyUpdateResourceStates()});t.Event.once(v.onDidDispose)(()=>{this.updatedResourceGroups.delete(v),L.dispose(),this._groups.delete(v.handle),Ie(this,m,"f").$unregisterGroup(this.handle,v.handle)}),p.push([v.handle,v.id,v.label,v.features]);const y=v._takeResourceStateSnapshot();y.length>0&&E.push([v.handle,y]),this._groups.set(v.handle,v)}Ie(this,m,"f").$registerGroups(this.handle,p,E),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const p=[];this.updatedResourceGroups.forEach(E=>{const v=E._takeResourceStateSnapshot();v.length!==0&&p.push([E.handle,v])}),p.length>0&&Ie(this,m,"f").$spliceResourceStates(this.handle,p),this.updatedResourceGroups.clear()}getResourceGroup(p){return this._groups.get(p)}setSelectionState(p){this._selected=p,this._onDidChangeSelection.fire(p)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(p=>p.dispose()),Ie(this,m,"f").$unregisterSourceControl(this.handle)}}m=new WeakMap,g._handlePool=0,xe([(0,S.debounce)(100)],g.prototype,"eventuallyAddResourceGroups",null),xe([(0,S.debounce)(100)],g.prototype,"eventuallyUpdateResourceStates",null);let s=class Vi{constructor(p,E,v){this._commands=E,this.logService=v,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=p.getProxy(I.MainContext.MainThreadSCM),this._telemetry=p.getProxy(I.MainContext.MainThreadTelemetry),E.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===3){const L=this._sourceControls.get(k.sourceControlHandle);if(!L)return k;const y=L.getResourceGroup(k.groupHandle);return y?y.getResourceState(k.handle):k}else if(k&&k.$mid===4){const L=this._sourceControls.get(k.sourceControlHandle);return L?L.getResourceGroup(k.groupHandle):k}else if(k&&k.$mid===5){const L=this._sourceControls.get(k.handle);return L||k}return k}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(p,E,v,k){this.logService.trace("ExtHostSCM#createSourceControl",p.identifier.value,E,v,k),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const L=Vi._handlePool++,y=new g(p,this._proxy,this._commands,E,v,k);this._sourceControls.set(L,y);const O=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(p.identifier))||[];return O.push(y),this._sourceControlsByExtension.set(b.ExtensionIdentifier.toKey(p.identifier),O),y}getLastInputBox(p){this.logService.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const E=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(p.identifier)),v=E&&E[E.length-1];return v&&v.inputBox}$provideOriginalResource(p,E,v){const k=r.URI.revive(E);this.logService.trace("ExtHostSCM#$provideOriginalResource",p,k.toString());const L=this._sourceControls.get(p);return!L||!L.quickDiffProvider||!L.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.asPromise)(()=>L.quickDiffProvider.provideOriginalResource(k,v)).then(y=>y||null)}$onInputBoxValueChange(p,E){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",p);const v=this._sourceControls.get(p);return v&&v.inputBox.$onInputBoxValueChange(E),Promise.resolve(void 0)}$executeResourceCommand(p,E,v,k){this.logService.trace("ExtHostSCM#$executeResourceCommand",p,E,v);const L=this._sourceControls.get(p);if(!L)return Promise.resolve(void 0);const y=L.getResourceGroup(E);return y?y.$executeResourceCommand(v,k):Promise.resolve(void 0)}$validateInput(p,E,v){this.logService.trace("ExtHostSCM#$validateInput",p);const k=this._sourceControls.get(p);return!k||!k.inputBox.validateInput?Promise.resolve(void 0):(0,A.asPromise)(()=>k.inputBox.validateInput(E,v)).then(L=>{if(!L)return Promise.resolve(void 0);const y=h.MarkdownString.fromStrict(L.message);return y?Promise.resolve([y,L.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(p){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this._sourceControls.get(p)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=p,Promise.resolve(void 0)}};s._handlePool=0,s=xe([$e(2,R.ILogService)],s),e.ExtHostSCM=s});var Xe=this&&this.__classPrivateFieldSet||function(Z,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(Z,r):S?S.value=r:e.set(Z,r),r},Ie=this&&this.__classPrivateFieldGet||function(Z,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[198],Se([0,1,7,5,121,6,8,13]),function(Z,e,r,t,S,P,A,I){"use strict";var D,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(l,o,m,M,C=r.StatusBarAlignment.Left,w){D.set(this,void 0),T.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,Xe(this,D,l,"f"),Xe(this,T,o,"f"),this._entryId=R.ID_GEN++,this._extension=m,this._id=M,this._alignment=C,this._priority=this.validatePriority(w)}validatePriority(l){if(!!(0,I.isNumber)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(l){this._text=l,this.update()}set name(l){this._name=l,this.update()}set tooltip(l){this._tooltip=l,this.update()}set color(l){this._color=l,this.update()}set backgroundColor(l){l&&!R.ALLOWED_BACKGROUND_COLORS.has(l.id)&&(l=void 0),this._backgroundColor=l,this.update()}set command(l){this._command?.fromApi!==l&&(this._internalCommandRegistration.clear(),typeof l=="string"?this._command={fromApi:l,internal:Ie(this,T,"f").toInternal({title:"",command:l},this._internalCommandRegistration)}:l?this._command={fromApi:l,internal:Ie(this,T,"f").toInternal(l,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(l){this._accessibilityInformation=l,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ie(this,D,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let l;this._extension?this._id?l=`${this._extension.identifier.value}.${this._id}`:l=this._extension.identifier.value:l=this._id;let o;this._name?o=this._name:o=(0,S.localize)(0,null,this._extension.displayName||this._extension.name);let m=this._color;this._backgroundColor&&(m=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const M=this._tooltip?A.MarkdownString.fromStrict(this._tooltip):void 0;Ie(this,D,"f").$setEntry(this._entryId,l,o,this._text,M,this._command?.internal,m,this._backgroundColor,this._alignment===r.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,D=new WeakMap,T=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new r.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.ThemeColor("statusBarItem.warningForeground")]]);class b{constructor(l){this._messages=[],this._item=l.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,S.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(l){const o={message:l};return this._messages.unshift(o),this._update(),new r.Disposable(()=>{const m=this._messages.indexOf(o);m>=0&&(this._messages.splice(m,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(l,o){this._proxy=l.getProxy(t.MainContext.MainThreadStatusBar),this._commands=o,this._statusMessage=new b(this)}createStatusBarEntry(l,o,m,M){return new R(this._proxy,this._commands,l,o,m,M)}setStatusBarMessage(l,o){const m=this._statusMessage.setMessage(l);let M;return typeof o=="number"?M=setTimeout(()=>m.dispose(),o):typeof o!="undefined"&&o.then(()=>m.dispose(),()=>m.dispose()),new r.Disposable(()=>{m.dispose(),clearTimeout(M)})}}e.ExtHostStatusBar=i}),define(ye[70],Se([0,1,5,4,3]),function(Z,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(I){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(r.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,D){this._proxy.$registerExtensionStorageKeysToSync(I,D)}initializeExtensionStorage(I,D,T){return this._proxy.$initializeExtensionStorage(I,D).then(R=>R||T)}setValue(I,D,T){return this._proxy.$setValue(I,D,T)}$acceptValue(I,D,T){this._onDidChangeStorage.fire({shared:I,key:D,value:T})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,S.createDecorator)("IExtHostStorage")}),define(ye[71],Se([0,1,3,28,12,50,2]),function(Z,e,r,t,S,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,r.createDecorator)("IExtensionStoragePaths");let I=class{constructor(T,R,b){this._logService=R,this._extHostFileSystem=b,this._workspace=T.workspace??void 0,this._environment=T.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(i=>this._value=i)}async _getWorkspaceStorageURI(T){return A.URI.joinPath(this._environment.workspaceStorageHome,T)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,R=await this._getWorkspaceStorageURI(T);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:A.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(b){this._logService.error("[ExtHostStorage]",b);return}}workspaceValue(T){if(this._value)return A.URI.joinPath(this._value,T.identifier.value)}globalValue(T){return A.URI.joinPath(this._environment.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};I=xe([$e(0,t.IExtHostInitDataService),$e(1,S.ILogService),$e(2,P.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(ye[40],Se([0,1,4,5,3,2,14,6,7,122,15,161,20,36,144,61,13,10]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i,h,l,o,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,S.createDecorator)("IExtHostTerminalService");class C{constructor(g,s,d,p){this._proxy=g,this._id=s,this._creationOptions=d,this._name=p,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(v=>this._pidPromiseComplete=v);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},get state(){return E._state},sendText(v,k=!0){E._checkDisposed(),E._proxy.$sendText(E._id,v,k)},show(v){E._checkDisposed(),E._proxy.$show(E._id,v)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(g,s){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:g.name,shellPath:(0,m.withNullAsUndefined)(g.shellPath),shellArgs:(0,m.withNullAsUndefined)(g.shellArgs),cwd:(0,m.withNullAsUndefined)(g.cwd),env:(0,m.withNullAsUndefined)(g.env),icon:(0,m.withNullAsUndefined)(c(g.iconPath)),color:o.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:(0,m.withNullAsUndefined)(g.message),strictEnv:(0,m.withNullAsUndefined)(g.strictEnv),hideFromUser:(0,m.withNullAsUndefined)(g.hideFromUser),isFeatureTerminal:(0,m.withNullAsUndefined)(s?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,m.withNullAsUndefined)(s?.useShellEnvironment),location:s?.location||this._serializeParentTerminal(g.location,s?.resolvedExtHostIdentifier),disablePersistence:(0,m.withNullAsUndefined)(g.disablePersistence)})}async createExtensionTerminal(g,s,d,p){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:d,color:o.ThemeColor.isThemeColor(p)?p.id:void 0,location:this._serializeParentTerminal(g,s),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(g,s){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&s?{parentTerminal:s}:"viewColumn"in g?{viewColumn:g.viewColumn,preserveFocus:g.preserveFocus}:void 0:g}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(g){this._name=g}setExitCode(g){this._exitStatus=Object.freeze({code:g})}setDimensions(g,s){return g===this._cols&&s===this._rows||g===0||s===0?!1:(this._cols=g,this._rows=s,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(g){this._pidPromiseComplete?(this._pidPromiseComplete(g),this._pidPromiseComplete=void 0):this._pidPromise.then(s=>{s!==g&&(this._pidPromise=Promise.resolve(g))})}}e.ExtHostTerminal=C;class w{constructor(g){this._pty=g,this.id=0,this.shouldPersist=!1,this._onProcessData=new r.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new r.Emitter,this._onDidChangeProperty=new r.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new r.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,s){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${s}`)}async start(){}shutdown(){this._pty.close()}input(g){this._pty.handleInput?.(g)}resize(g,s){this._pty.setDimensions?.({columns:g,rows:s})}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(g){this._pty.onDidWrite(s=>this._onProcessData.fire(s)),this._pty.onDidClose?.((s=void 0)=>{this._onProcessExit.fire(s===void 0?void 0:s)}),this._pty.onDidOverrideDimensions?.(s=>{s&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:s.columns,rows:s.rows}})}),this._pty.onDidChangeName?.(s=>{this._onDidChangeProperty.fire({type:"title",value:s})}),this._pty.open(g||void 0),g&&this._pty.setDimensions?.(g),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=w;let u=1,_=class extends I.Disposable{constructor(g,s){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new r.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new r.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new r.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new r.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new r.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=s.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new l.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new r.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(g),this._register({dispose:()=>{for(const[d,p]of this._terminalProcesses)p.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(g=>g.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(g){return(g?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(g){return(g?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(g,s){const d=new C(this._proxy,(0,h.generateUuid)(),g,g.name),p=new w(g.pty);return d.createExtensionTerminal(g.location,this._serializeParentTerminal(g,s).resolvedExtHostIdentifier,c(g.iconPath),n(g.color)).then(E=>{const v=this._setupExtHostProcessListeners(E,p);this._terminalProcessDisposables[E]=v}),this._terminals.push(d),d.value}_serializeParentTerminal(g,s){if(s=s||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const d=g.location.parentTerminal;if(d){const p=this._terminals.find(E=>E.value===d);p&&(s.resolvedExtHostIdentifier=p._id)}}else g.location&&typeof g.location!="object"?s.location=g.location:s.location&&typeof s.location=="object"&&"splitActiveTerminal"in s.location&&(s.location={splitActiveTerminal:!0});return s}attachPtyToTerminal(g,s){if(!this._getTerminalById(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const p=new w(s),E=this._setupExtHostProcessListeners(g,p);this._terminalProcessDisposables[g]=E}async $acceptActiveTerminalChanged(g){const s=this._activeTerminal;if(g===null){this._activeTerminal=void 0,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const d=this._getTerminalById(g);d&&(this._activeTerminal=d,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(g,s){const d=this._getTerminalById(g);d&&this._onDidWriteTerminalData.fire({terminal:d.value,data:s})}async $acceptTerminalDimensions(g,s,d){const p=this._getTerminalById(g);p&&p.setDimensions(s,d)&&this._onDidChangeTerminalDimensions.fire({terminal:p.value,dimensions:p.value.dimensions})}async $acceptTerminalMaximumDimensions(g,s,d){this._terminalProcesses.get(g)?.resize(s,d)}async $acceptTerminalTitleChange(g,s){const d=this._getTerminalById(g);d&&(d.name=s)}async $acceptTerminalClosed(g,s){const d=this._getTerminalObjectIndexById(this._terminals,g);if(d!==null){const p=this._terminals.splice(d,1)[0];p.setExitCode(s),this._onDidCloseTerminal.fire(p.value)}}$acceptTerminalOpened(g,s,d,p){if(s){const k=this._getTerminalObjectIndexById(this._terminals,s);if(k!==null){this._terminals[k]._id=g,this._onDidOpenTerminal.fire(this.terminals[k]),this._terminals[k].isOpen=!0;return}}const E={name:p.name,shellPath:p.executable,shellArgs:p.args,cwd:typeof p.cwd=="string"?p.cwd:P.URI.revive(p.cwd),env:p.env,hideFromUser:p.hideFromUser},v=new C(this._proxy,g,E,d);this._terminals.push(v),this._onDidOpenTerminal.fire(v.value),v.isOpen=!0}async $acceptTerminalProcessId(g,s){const d=this._getTerminalById(g);d&&d._setProcessId(s)}async $startExtensionTerminal(g,s){const d=this._getTerminalById(g);if(!d)return{message:(0,T.localize)(0,null,g)};d.isOpen||await new Promise(E=>{const v=this.onDidOpenTerminal(async k=>{k===d.value&&(v.dispose(),E())})});const p=this._terminalProcesses.get(g);p?p.startSendingEvents(s):this._extensionTerminalAwaitingStart[g]={initialDimensions:s}}_setupExtHostProcessListeners(g,s){const d=new I.DisposableStore;d.add(s.onProcessReady(E=>this._proxy.$sendProcessReady(g,E.pid,E.cwd))),d.add(s.onDidChangeProperty(E=>this._proxy.$sendProcessProperty(g,E))),this._bufferer.startBuffering(g,s.onProcessData),d.add(s.onProcessExit(E=>this._onProcessExit(g,E))),this._terminalProcesses.set(g,s);const p=this._extensionTerminalAwaitingStart[g];return p&&s instanceof w&&(s.startSendingEvents(p.initialDimensions),delete this._extensionTerminalAwaitingStart[g]),d}$acceptProcessAckDataEvent(g,s){this._terminalProcesses.get(g)?.acknowledgeDataEvent(s)}$acceptProcessInput(g,s){this._terminalProcesses.get(g)?.input(s)}$acceptTerminalInteraction(g){const s=this._getTerminalById(g);s?.setInteractedWith()&&this._onDidChangeTerminalState.fire(s.value)}$acceptProcessResize(g,s,d){try{this._terminalProcesses.get(g)?.resize(s,d)}catch(p){if(p.code!=="EPIPE"&&p.code!=="ERR_IPC_CHANNEL_CLOSED")throw p}}$acceptProcessShutdown(g,s){this._terminalProcesses.get(g)?.shutdown(s)}$acceptProcessRequestInitialCwd(g){this._terminalProcesses.get(g)?.getInitialCwd().then(s=>this._proxy.$sendProcessProperty(g,{type:"initialCwd",value:s}))}$acceptProcessRequestCwd(g){this._terminalProcesses.get(g)?.getCwd().then(s=>this._proxy.$sendProcessProperty(g,{type:"cwd",value:s}))}$acceptProcessRequestLatency(g){return Promise.resolve(g)}registerLinkProvider(g){return this._linkProviders.add(g),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(g),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(g,s,d){if(this._profileProviders.has(s))throw new Error(`Terminal profile provider "${s}" already registered`);return this._profileProviders.set(s,d),this._proxy.$registerProfileProvider(s,g.identifier.value),new D.Disposable(()=>{this._profileProviders.delete(s),this._proxy.$unregisterProfileProvider(s)})}async $createContributedProfileTerminal(g,s){const d=new i.CancellationTokenSource().token;let p=await this._profileProviders.get(g)?.provideTerminalProfile(d);if(!d.isCancellationRequested){if(p&&!("options"in p)&&(p={options:p}),!p||!("options"in p))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in p.options){this.createExtensionTerminal(p.options,s);return}this.createTerminalFromOptions(p.options,s)}}async $provideLinks(g,s){const d=this._getTerminalById(g);if(!d)return[];this._terminalLinkCache.delete(g);const p=this._terminalLinkCancellationSource.get(g);p&&p.dispose(!0);const E=new i.CancellationTokenSource;this._terminalLinkCancellationSource.set(g,E);const v=[],k={terminal:d.value,line:s},L=[];for(const U of this._linkProviders)L.push(M.Promises.withAsyncBody(async q=>{E.token.onCancellationRequested(()=>q({provider:U,links:[]}));const H=await U.provideTerminalLinks(k,E.token)||[];E.token.isCancellationRequested||q({provider:U,links:H})}));const y=await Promise.all(L);if(E.token.isCancellationRequested)return[];const O=new Map;for(const U of y)U&&U.links.length>0&&v.push(...U.links.map(q=>{const H={id:u++,startIndex:q.startIndex,length:q.length,label:q.tooltip};return O.set(H.id,{provider:U.provider,link:q}),H}));return this._terminalLinkCache.set(g,O),v}$activateLink(g,s){const d=this._terminalLinkCache.get(g)?.get(s);!d||d.provider.handleTerminalLink(d.link)}_onProcessExit(g,s){this._bufferer.stopBuffering(g),this._terminalProcesses.delete(g),delete this._extensionTerminalAwaitingStart[g];const d=this._terminalProcessDisposables[g];d&&(d.dispose(),delete this._terminalProcessDisposables[g]),this._proxy.$sendProcessExit(g,s)}_getTerminalById(g){return this._getTerminalObjectById(this._terminals,g)}_getTerminalObjectById(g,s){const d=this._getTerminalObjectIndexById(g,s);return d!==null?g[d]:null}_getTerminalObjectIndexById(g,s){let d=null;return g.some((p,E)=>p._id===s?(d=E,!0):!1),d}getEnvironmentVariableCollection(g){let s=this._environmentVariableCollections.get(g.identifier.value);return s||(s=new a,this._setEnvironmentVariableCollection(g.identifier.value,s)),s}_syncEnvironmentVariableCollection(g,s){const d=(0,b.serializeEnvironmentVariableCollection)(s.map);this._proxy.$setEnvironmentVariableCollection(g,s.persistent,d.length===0?void 0:d)}$initEnvironmentVariableCollections(g){g.forEach(s=>{const d=s[0],p=new a(s[1]);this._setEnvironmentVariableCollection(d,p)})}$acceptDefaultProfile(g,s){this._defaultProfile=g,this._defaultAutomationProfile=s}_setEnvironmentVariableCollection(g,s){this._environmentVariableCollections.set(g,s),s.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(g,s)})}};_=xe([$e(1,A.IExtHostRpcService)],_),e.BaseExtHostTerminalService=_;class a{constructor(g){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new r.Emitter,this.map=new Map(g)}get persistent(){return this._persistent}set persistent(g){this._persistent=g,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(g,s){this._setIfDiffers(g,{value:s,type:D.EnvironmentVariableMutatorType.Replace})}append(g,s){this._setIfDiffers(g,{value:s,type:D.EnvironmentVariableMutatorType.Append})}prepend(g,s){this._setIfDiffers(g,{value:s,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(g,s){const d=this.map.get(g);(!d||d.value!==s.value||d.type!==s.type)&&(this.map.set(g,s),this._onDidChangeCollection.fire())}get(g){return this.map.get(g)}forEach(g,s){this.map.forEach((d,p)=>g.call(s,p,d,this))}delete(g){this.map.delete(g),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=a;let F=class extends _{constructor(g){super(!1,g)}createTerminal(g,s,d){throw new R.NotSupportedError}createTerminalFromOptions(g,s){throw new R.NotSupportedError}};F=xe([$e(0,A.IExtHostRpcService)],F),e.WorkerExtHostTerminalService=F;function c(f){if(!(!f||typeof f=="string"))return"id"in f?{id:f.id,color:f.color}:f}function n(f){return o.ThemeColor.isThemeColor(f)?f:void 0}});var Xe=this&&this.__classPrivateFieldSet||function(Z,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(Z,r):S?S.value=r:e.set(Z,r),r},Ie=this&&this.__classPrivateFieldGet||function(Z,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[199],Se([0,1,16,21,20,4,231,92,6,27,13,36,5,14,48,8,7,167,86,66]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i,h,l,o,m,M,C,w){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let _=class{constructor(k,L){this.resultsChangedEmitter=new P.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=k.getProxy(i.MainContext.MainThreadTesting),this.observer=new d(this.proxy),this.runTracker=new F(this.proxy),L.registerArgumentProcessor({processArgument:y=>y?.$mid===13?o.TestItem.toItemFromContext(y):y})}createTestController(k,L,y){if(this.controllers.has(k))throw new Error(`Attempt to insert a duplicate controller with ID "${k}"`);const O=new D.DisposableStore,U=O.add(new M.SingleUseTestCollection(k));U.root.label=L;const q=new Map,H=this.proxy,z={items:U.root.children,get label(){return L},set label(ie){L=ie,U.root.label=ie,H.$updateController(k,{label:L})},get refreshHandler(){return y},set refreshHandler(ie){y=ie,H.$updateController(k,{canRefresh:!!ie})},get id(){return k},createRunProfile:(ie,ae,te,ue,be)=>{let pe=(0,I.hash)(ie);for(;q.has(pe);)pe++;const me=new p(this.proxy,k,pe,ie,ae,te,ue,be);return q.set(pe,me),me},createTestItem(ie,ae,te){return new l.TestItemImpl(k,ie,ae,te)},createTestRun:(ie,ae,te=!0)=>this.runTracker.createTestRun(k,U,ie,ae,te),set resolveHandler(ie){U.resolveHandler=ie},get resolveHandler(){return U.resolveHandler},dispose:()=>{O.dispose()}};H.$registerTestController(k,L,!!y),O.add((0,D.toDisposable)(()=>H.$unregisterTestController(k)));const j={controller:z,collection:U,profiles:q};return this.controllers.set(k,j),O.add((0,D.toDisposable)(()=>this.controllers.delete(k))),O.add(U.onDidGenerateDiff(ie=>H.$publishDiff(k,ie))),z}createTestObserver(){return this.observer.checkout()}async runTests(k,L=S.CancellationToken.None){const y=c(k);if(!y)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const O=this.controllers.get(y.controllerId);if(!O)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:k.include?.map(U=>U.id)??[O.collection.root.id],profileGroup:E[y.kind],profileId:y.profileId,controllerId:y.controllerId}],exclude:k.exclude?.map(U=>U.id)},L)}$provideFileCoverage(k,L,y){return(0,r.mapFind)(this.runTracker.trackers,U=>U.id===k?U.getCoverage(L):void 0)?.provideFileCoverage(y)??Promise.resolve([])}$resolveFileCoverage(k,L,y,O){return(0,r.mapFind)(this.runTracker.trackers,q=>q.id===k?q.getCoverage(L):void 0)?.resolveFileCoverage(y,O)??Promise.resolve([])}$configureRunProfile(k,L){this.controllers.get(k)?.profiles.get(L)?.configureHandler?.()}async $refreshTests(k,L){await this.controllers.get(k)?.controller.refreshHandler?.(L)}$publishTestResults(k){this.results=Object.freeze(k.map(L=>(0,T.deepFreeze)(o.TestResults.to(L))).concat(this.results).sort((L,y)=>y.completedAt-L.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(k,L){const y=this.controllers.get(w.TestId.fromString(k).controllerId)?.collection;y&&(await y.expand(k,L<0?1/0:L),y.flushDiff())}$acceptDiff(k){this.observer.applyDiff(k)}async $runControllerTests(k,L){const y=this.controllers.get(k.controllerId);if(!y)return;const{collection:O,profiles:U}=y,q=U.get(k.profileId);if(!q)return;const H=k.testIds.map(ae=>O.tree.get(ae)).filter(R.isDefined),z=k.excludeExtIds.map(ae=>y.collection.tree.get(ae)).filter(R.isDefined).filter(ae=>H.some(te=>te.fullId.compare(ae.fullId)===2));if(!H.length)return;const j=new m.TestRunRequest(H.some(ae=>ae.actual instanceof l.TestItemRootImpl)?void 0:H.map(ae=>ae.actual),z.map(ae=>ae.actual),q),ie=this.runTracker.prepareForMainThreadTestRun(j,n.fromInternal(k,y.collection),L);try{await q.runHandler(j,L)}finally{ie.isRunning&&!L.isCancellationRequested&&await P.Event.toPromise(ie.onEnd),ie.dispose()}}$cancelExtensionTestRun(k){k===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(k)}};_=xe([$e(0,h.IExtHostRpcService)],_),e.ExtHostTesting=_;class a extends D.Disposable{constructor(k,L,y){super();this.dto=k,this.proxy=L,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new P.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new S.CancellationTokenSource(y)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:O}of this.tasks.values())O.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(k){return this.tasks.get(k)?.coverage}createRun(k){const L=this.dto.id,y=this.dto.controllerId,O=(0,b.generateUuid)(),U=new f(this.proxy,L,O),q=ie=>(ae,...te)=>{if(z){console.warn(`Setting the state of test "${ae.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(ae)||(this.ensureTestIsKnown(ae),ie(ae,...te))},H=(ie,ae)=>{const te=ae instanceof Array?ae.map(o.TestMessage.from):[o.TestMessage.from(ae)];if(ie.uri&&ie.range){const ue={range:o.Range.from(ie.range),uri:ie.uri};for(const be of te)be.location=be.location||ue}this.proxy.$appendTestMessagesInRun(L,O,w.TestId.fromExtHostTestItem(ie,y).toString(),te)};let z=!1;const j={isPersisted:this.dto.isPersisted,token:this.cts.token,name:k,get coverageProvider(){return U.coverageProvider},set coverageProvider(ie){U.coverageProvider=ie},enqueued:q(ie=>{this.proxy.$updateTestStateInRun(L,O,w.TestId.fromExtHostTestItem(ie,y).toString(),1)}),skipped:q(ie=>{this.proxy.$updateTestStateInRun(L,O,w.TestId.fromExtHostTestItem(ie,y).toString(),5)}),started:q(ie=>{this.proxy.$updateTestStateInRun(L,O,w.TestId.fromExtHostTestItem(ie,y).toString(),2)}),errored:q((ie,ae,te)=>{H(ie,ae),this.proxy.$updateTestStateInRun(L,O,w.TestId.fromExtHostTestItem(ie,y).toString(),6,te)}),failed:q((ie,ae,te)=>{H(ie,ae),this.proxy.$updateTestStateInRun(L,O,w.TestId.fromExtHostTestItem(ie,y).toString(),4,te)}),passed:q((ie,ae)=>{this.proxy.$updateTestStateInRun(L,O,w.TestId.fromExtHostTestItem(ie,this.dto.controllerId).toString(),3,ae)}),appendOutput:(ie,ae,te)=>{z||(te&&(this.dto.isIncluded(te)?this.ensureTestIsKnown(te):te=void 0),this.proxy.$appendOutputToRun(L,O,t.VSBuffer.fromString(ie),ae&&o.location.from(ae),te&&w.TestId.fromExtHostTestItem(te,y).toString()))},end:()=>{z||(z=!0,this.proxy.$finishedTestRunTask(L,O),this.tasks.delete(O),this.isRunning||this.dispose())}};return this.tasks.set(O,{run:j,coverage:U}),this.proxy.$startedTestRunTask(L,{id:O,name:k,running:!0}),j}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(k){if(!(k instanceof l.TestItemImpl))throw new l.InvalidTestItemError(k.id);if(this.sharedTestIds.has(w.TestId.fromExtHostTestItem(k,this.dto.controllerId).toString()))return;const L=[],y=this.dto.colllection.root;for(;;){const O=o.TestItem.from(k);if(L.unshift(O),this.sharedTestIds.has(O.extId)||(this.sharedTestIds.add(O.extId),k===y))break;k=k.parent||y}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,L)}}class F{constructor(k){this.proxy=k,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(k,L,y){return this.getTracker(k,L,y)}cancelRunById(k){for(const L of this.tracked.values())if(L.id===k){L.dispose();return}}cancelAllRuns(){for(const k of this.tracked.values())k.dispose()}createTestRun(k,L,y,O,U){const q=this.tracked.get(y);if(q)return q.createRun(O);const H=n.fromPublic(k,L,y,U),z=c(y);this.proxy.$startedExtensionTestRun({controllerId:k,profile:z&&{group:E[z.kind],id:z.profileId},exclude:y.exclude?.map(ie=>ie.id)??[],id:H.id,include:y.include?.map(ie=>ie.id)??[L.root.id],persist:U});const j=this.getTracker(y,H);return j.onEnd(()=>this.proxy.$finishedExtensionTestRun(H.id)),j.createRun(O)}getTracker(k,L,y){const O=new a(L,this.proxy,y);return this.tracked.set(k,O),O.onEnd(()=>this.tracked.delete(k)),O}}e.TestRunCoordinator=F;const c=v=>{if(!!v.profile){if(!(v.profile instanceof p))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return v.profile}};class n{constructor(k,L,y,O,U,q){this.controllerId=k,this.id=L,this.isPersisted=U,this.colllection=q,this.includePrefix=y.map(H=>H+"\0"),this.excludePrefix=O.map(H=>H+"\0")}static fromPublic(k,L,y,O){return new n(k,(0,b.generateUuid)(),y.include?.map(U=>w.TestId.fromExtHostTestItem(U,k).toString())??[k],y.exclude?.map(U=>w.TestId.fromExtHostTestItem(U,k).toString())??[],O,L)}static fromInternal(k,L){return new n(k.controllerId,k.runId,k.testIds,k.excludeExtIds,!0,L)}isIncluded(k){const L=w.TestId.fromExtHostTestItem(k,this.controllerId).toString()+"\0";for(const y of this.excludePrefix)if(L===y||L.startsWith(y))return!1;for(const y of this.includePrefix)if(L===y||L.startsWith(y))return!0;return!1}}e.TestRunDto=n;class f{constructor(k,L,y){this.proxy=k,this.runId=L,this.taskId=y}set coverageProvider(k){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!k||(this._coverageProvider=k,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(k){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(k))());try{return(await this.fileCoverage)?.map(o.TestCoverage.fromFile)??[]}catch(L){throw this.fileCoverage=void 0,L}}async resolveFileCoverage(k,L){const y=await this.fileCoverage;let O=y?.[k];return!this._coverageProvider||!y||!O?[]:(O.detailedCoverage||(O=y[k]=await this._coverageProvider.resolveFileCoverage?.(O,L)??O),O.detailedCoverage?.map(o.TestCoverage.fromDetailed)??[])}}class g extends C.IncrementalChangeCollector{constructor(k){super();this.emitter=k,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(k){this.added.add(k)}update(k){Object.assign(k.revived,o.TestItem.toPlain(k.item)),this.added.has(k)||this.updated.add(k)}remove(k){if(this.added.has(k)){this.added.delete(k);return}if(this.updated.delete(k),k.parent&&this.alreadyRemoved.has(k.parent)){this.alreadyRemoved.add(k.item.extId);return}this.removed.add(k)}getChangeEvent(){const{added:k,updated:L,removed:y}=this;return{get added(){return[...k].map(O=>O.revived)},get updated(){return[...L].map(O=>O.revived)},get removed(){return[...y].map(O=>O.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class s extends C.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(k){return this.items.get(k)}getMirroredTestDataByReference(k){return this.items.get(k.id)}createItem(k,L){return{...k,revived:o.TestItem.toPlain(k.item),depth:L?L.depth+1:0,children:new Set}}createChangeCollector(){return new g(this.changeEmitter)}}e.MirroredTestCollection=s;class d{constructor(k){this.proxy=k}checkout(){this.current||(this.current=this.createObserverData());const k=this.current;return k.observers++,{onDidChangeTest:k.tests.onDidChangeTests,get tests(){return[...k.tests.rootTests].map(L=>L.revived)},dispose:(0,A.once)(()=>{--k.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(k){return this.current?.tests.getMirroredTestDataByReference(k)}applyDiff(k){this.current?.tests.apply(k)}createObserverData(){const k=new s;return this.proxy.$subscribeToDiffs(),{observers:0,tests:k}}}class p{constructor(k,L,y,O,U,q,H=!1,z=void 0){this.controllerId=L,this.profileId=y,this._label=O,this.kind=U,this.runHandler=q,this._isDefault=H,this._tag=z,u.set(this,void 0),Xe(this,u,k,"f");const j=E[U];if(typeof j!="number")throw new Error(`Unknown TestRunProfile.group ${U}`);Ie(this,u,"f").$publishTestRunProfile({profileId:y,controllerId:L,tag:z?o.TestTag.namespace(this.controllerId,z.id):null,label:O,group:j,isDefault:H,hasConfigurationHandler:!1})}get label(){return this._label}set label(k){k!==this._label&&(this._label=k,Ie(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:k}))}get isDefault(){return this._isDefault}set isDefault(k){k!==this._isDefault&&(this._isDefault=k,Ie(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:k}))}get tag(){return this._tag}set tag(k){k?.id!==this._tag?.id&&(this._tag=k,Ie(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:k?o.TestTag.namespace(this.controllerId,k.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(k){k!==this._configureHandler&&(this._configureHandler=k,Ie(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!k}))}dispose(){Ie(this,u,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=p,u=new WeakMap;const E={[m.TestRunProfileKind.Coverage]:8,[m.TestRunProfileKind.Debug]:4,[m.TestRunProfileKind.Run]:2}}),define(ye[200],Se([0,1,4,16,5,90,8,7]),function(Z,e,r,t,S,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(R,b){this._extHostDocumentsAndEditors=b,this._onDidChangeTextEditorSelection=new r.Emitter,this._onDidChangeTextEditorOptions=new r.Emitter,this._onDidChangeTextEditorVisibleRanges=new r.Emitter,this._onDidChangeTextEditorViewColumn=new r.Emitter,this._onDidChangeActiveTextEditor=new r.Emitter,this._onDidChangeVisibleTextEditors=new r.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(S.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(i=>this._onDidChangeVisibleTextEditors.fire(i)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(i=>this._onDidChangeActiveTextEditor.fire(i))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const b=this._extHostDocumentsAndEditors.allEditors();return R?b:b.map(i=>i.value)}async showTextDocument(R,b,i){let h;typeof b=="number"?h={position:A.ViewColumn.from(b),preserveFocus:i}:typeof b=="object"?h={position:A.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selection:typeof b.selection=="object"?A.Range.from(b.selection):void 0,pinned:typeof b.preview=="boolean"?!b.preview:void 0}:h={preserveFocus:!1};const l=await this._proxy.$tryShowTextDocument(R.uri,h),o=l&&this._extHostDocumentsAndEditors.getEditor(l);if(o)return o.value;throw l?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,b){return new P.TextEditorDecorationType(this._proxy,R,b).value}$acceptEditorPropertiesChanged(R,b){const i=this._extHostDocumentsAndEditors.getEditor(R);if(!i)throw new Error("unknown text editor");if(b.options&&i._acceptOptions(b.options),b.selections){const h=b.selections.selections.map(A.Selection.to);i._acceptSelections(h)}if(b.visibleRanges){const h=t.coalesce(b.visibleRanges.map(A.Range.to));i._acceptVisibleRanges(h)}if(b.options&&this._onDidChangeTextEditorOptions.fire({textEditor:i.value,options:{...b.options,lineNumbers:A.TextEditorLineNumbersStyle.to(b.options.lineNumbers)}}),b.selections){const h=I.TextEditorSelectionChangeKind.fromValue(b.selections.source),l=b.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:i.value,selections:l,kind:h})}if(b.visibleRanges){const h=t.coalesce(b.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:i.value,visibleRanges:h})}}$acceptEditorPositionData(R){for(const b in R){const i=this._extHostDocumentsAndEditors.getEditor(b);if(!i)throw new Error("Unknown text editor");const h=A.ViewColumn.to(R[b]);i.value.viewColumn!==h&&(i._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:i.value,viewColumn:h}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=D}),define(ye[201],Se([0,1,2,3,5,6,7]),function(Z,e,r,t,S,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class I{constructor(R,b){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=R.getProxy(S.MainContext.MainThreadTimeline),b.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===11){const h=i.uri===void 0?void 0:r.URI.revive(i.uri);return this._itemsBySourceAndUriMap.get(i.source)?.get(D(h))?.get(i.handle)}return i}})}async $getTimeline(R,b,i,h,l){return this._providers.get(R)?.provideTimeline(r.URI.revive(b),i,h,l)}registerTimelineProvider(R,b,i,h){const l=new P.DisposableStore,o=this.convertTimelineItem(b.id,h,l).bind(this);let m;b.onDidChange&&(m=b.onDidChange(C=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...C,id:b.id}),this));const M=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...b,scheme:R,onDidChange:void 0,async provideTimeline(C,w,u,_){_?.resetCache&&(l.clear(),M.get(b.id)?.clear());const a=await b.provideTimeline(C,w,u);if(a==null)return;const F=o(C,_);return{...a,source:b.id,items:a.items.map(F)}},dispose(){for(const C of M.values())C.get(b.id)?.clear();m?.dispose(),l.dispose()}})}convertTimelineItem(R,b,i){return(h,l)=>{let o;if(l?.cacheResults){let m=this._itemsBySourceAndUriMap.get(R);m===void 0&&(m=new Map,this._itemsBySourceAndUriMap.set(R,m));const M=D(h);o=m.get(M),o===void 0&&(o=new Map,m.set(M,o))}return m=>{const{iconPath:M,...C}=m,w=`${R}|${m.id??m.timestamp}`;o?.set(w,m);let u,_,a;return m.iconPath&&(M instanceof A.ThemeIcon?a={id:M.id,color:M.color}:r.URI.isUri(M)?(u=M,_=M):{light:u,dark:_}=M),{...C,id:C.id??void 0,handle:w,source:R,command:m.command?b.toInternal(m.command,i):void 0,icon:u,iconDark:_,themeIcon:a,accessibilityInformation:m.accessibilityInformation}}}}registerTimelineProviderCore(R){if(this._providers.get(R.id))throw new Error(`Timeline Provider ${R.id} already exists.`);return this._proxy.$registerTimelineProvider({id:R.id,label:R.label,scheme:R.scheme}),this._providers.set(R.id,R),(0,P.toDisposable)(()=>{for(const i of this._itemsBySourceAndUriMap.values())i.get(R.id)?.clear();this._providers.delete(R.id),this._proxy.$unregisterTimelineProvider(R.id),R.dispose()})}}e.ExtHostTimeline=I;function D(T){return T?.toString()}}),define(ye[202],Se([0,1,6,11,2,5]),function(Z,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{constructor(D){this._openers=new Map,this._proxy=D.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,T,R,b){if(this._openers.has(T))throw new Error(`Opener with id '${T}' already registered`);const i=b.schemes.find(h=>!A.supportedSchemes.has(h));if(i)throw new Error(`Scheme '${i}' is not supported. Only http and https are currently supported.`);return this._openers.set(T,R),this._proxy.$registerUriOpener(T,b.schemes,D,b.label),(0,r.toDisposable)(()=>{this._openers.delete(T),this._proxy.$unregisterUriOpener(T)})}async $canOpenUri(D,T,R){const b=this._openers.get(D);if(!b)throw new Error(`Unknown opener with id: ${D}`);const i=S.URI.revive(T);return b.canOpenExternalUri(i,R)}async $openUri(D,T,R){const b=this._openers.get(D);if(!b)throw new Error(`Unknown opener id: '${D}'`);return b.openExternalUri(S.URI.revive(T.resolvedUri),{sourceUri:S.URI.revive(T.sourceUri)},R)}}e.ExtHostUriOpeners=A,A.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(ye[203],Se([0,1,5,2,6,15,25]),function(Z,e,r,t,S,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(T){this.handles=new Set,this.handlers=new Map,this._proxy=T.getProxy(r.MainContext.MainThreadUrls)}registerUriHandler(T,R){if(this.handles.has(A.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const b=I.HandlePool++;return this.handles.add(A.ExtensionIdentifier.toKey(T)),this.handlers.set(b,R),this._proxy.$registerUriHandler(b,T),(0,S.toDisposable)(()=>{this.handles.delete(A.ExtensionIdentifier.toKey(T)),this.handlers.delete(b),this._proxy.$unregisterUriHandler(b)})}$handleExternalUri(T,R){const b=this.handlers.get(T);if(!b)return Promise.resolve(void 0);try{b.handleUri(t.URI.revive(R))}catch(i){(0,P.onUnexpectedError)(i)}return Promise.resolve(void 0)}async createAppUri(T){return t.URI.revive(await this._proxy.$createAppUri(T))}}e.ExtHostUrls=I,I.HandlePool=0});var Xe=this&&this.__classPrivateFieldSet||function(Z,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(Z,r):S?S.value=r:e.set(Z,r),r},Ie=this&&this.__classPrivateFieldGet||function(Z,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[51],Se([0,1,4,11,2,131,151,65,5]),function(Z,e,r,t,S,P,A,I,D){"use strict";var T,R,b,i,h,l,o,m,M,C,w,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class _{constructor(d,p,E,v,k,L,y){T.set(this,void 0),R.set(this,void 0),b.set(this,void 0),i.set(this,void 0),h.set(this,void 0),l.set(this,void 0),o.set(this,""),m.set(this,void 0),M.set(this,!1),C.set(this,!1),w.set(this,!1),this._onMessageEmitter=new r.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new r.Emitter),this._onDidDispose=Ie(this,u,"f").event,Xe(this,T,d,"f"),Xe(this,R,p,"f"),Xe(this,m,E,"f"),Xe(this,i,v,"f"),Xe(this,h,k,"f"),Xe(this,l,L,"f"),Xe(this,w,a(L),"f"),Xe(this,b,y,"f")}dispose(){Xe(this,M,!0,"f"),Ie(this,u,"f").fire(),Ie(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(d){return Xe(this,C,!0,"f"),(0,I.asWebviewUri)(d,Ie(this,i,"f").remote)}get cspSource(){const d=Ie(this,l,"f").extensionLocation;if(d.scheme===t.Schemas.https||d.scheme===t.Schemas.http){let p=d.toString();return p.endsWith("/")||(p+="/"),p+" "+I.webviewGenericCspSource}return I.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ie(this,o,"f")}set html(d){this.assertNotDisposed(),Ie(this,o,"f")!==d&&(Xe(this,o,d,"f"),!Ie(this,C,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(d)&&(Xe(this,C,!0,"f"),Ie(this,b,"f").report("Webview vscode-resource: uris",Ie(this,l,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ie(this,R,"f").$setHtml(Ie(this,T,"f"),d))}get options(){return this.assertNotDisposed(),Ie(this,m,"f")}set options(d){this.assertNotDisposed(),Ie(this,R,"f").$setOptions(Ie(this,T,"f"),n(Ie(this,l,"f"),Ie(this,h,"f"),d)),Xe(this,m,d,"f")}async postMessage(d){if(Ie(this,M,"f"))return!1;const p=(0,A.serializeWebviewMessage)(d,{serializeBuffersForPostMessage:Ie(this,w,"f")});return Ie(this,R,"f").$postMessage(Ie(this,T,"f"),p.message,...p.buffers)}assertNotDisposed(){if(Ie(this,M,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=_,T=new WeakMap,R=new WeakMap,b=new WeakMap,i=new WeakMap,h=new WeakMap,l=new WeakMap,o=new WeakMap,m=new WeakMap,M=new WeakMap,C=new WeakMap,w=new WeakMap,u=new WeakMap;function a(s){try{const d=(0,P.normalizeVersion)((0,P.parseVersion)(s.engines.vscode));return!!d&&d.majorBase>=1&&d.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;class F{constructor(d,p,E,v,k){this.initData=p,this.workspace=E,this._logService=v,this._deprecationService=k,this._webviews=new Map,this._webviewProxy=d.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(d,p,E){const v=this.getWebview(d);if(v){const{message:k}=(0,A.deserializeWebviewMessage)(p,E.value);v._onMessageEmitter.fire(k)}}$onMissingCsp(d,p){this._logService.warn(`${p} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(d,p,E){const v=new _(d,this._webviewProxy,f(p),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(d,v),v._onDidDispose(()=>{this._webviews.delete(d)}),v}deleteWebview(d){this._webviews.delete(d)}getWebview(d){return this._webviews.get(d)}}e.ExtHostWebviews=F;function c(s){return{id:s.identifier,location:s.extensionLocation}}e.toExtensionData=c;function n(s,d,p){return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,enableForms:p.enableForms,portMapping:p.portMapping,localResourceRoots:p.localResourceRoots||g(s,d)}}e.serializeWebviewOptions=n;function f(s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots?.map(d=>S.URI.from(d))}}e.reviveOptions=f;function g(s,d){return[...(d?.getWorkspaceFolders()||[]).map(p=>p.uri),s.extensionLocation]}}),define(ye[204],Se([0,1,20,92,6,11,24,2,8,51,62,5,7]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(a,F){this.document=a,this._storagePath=F,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(a){return this._edits.add([a])}async undo(a,F){await this.getEdit(a).undo(),F||this.disposeBackup()}async redo(a,F){await this.getEdit(a).redo(),F||this.disposeBackup()}disposeEdits(a){for(const F of a)this._edits.delete(F)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const a=u(this.document.uri)+this._backupCounter++;return(0,A.joinPath)(this._storagePath,a)}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(a){const F=this._edits.get(a,0);if(!F)throw new Error("No edit found");return F}}class l{constructor(){this._documents=new Map}get(a,F){return this._documents.get(this.key(a,F))}add(a,F,c){const n=this.key(a,F.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${a} resource:${F.uri}`);const f=new h(F,c);return this._documents.set(n,f),f}delete(a,F){const c=this.key(a,F.uri);this._documents.delete(c)}key(a,F){return`${a}@@@${F}`}}var o;(function(_){_[_.Text=0]="Text",_[_.Custom=1]="Custom"})(o||(o={}));class m{constructor(){this._providers=new Map}addTextProvider(a,F,c){return this.add(0,a,F,c)}addCustomProvider(a,F,c){return this.add(1,a,F,c)}get(a){return this._providers.get(a)}add(a,F,c,n){if(this._providers.has(F))throw new Error(`Provider for viewType:${F} already registered`);return this._providers.set(F,{type:a,extension:c,provider:n}),new i.Disposable(()=>this._providers.delete(F))}}class M{constructor(a,F,c,n,f){this._extHostDocuments=F,this._extensionStoragePaths=c,this._extHostWebview=n,this._extHostWebviewPanels=f,this._editorProviders=new m,this._documents=new l,this._proxy=a.getProxy(b.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,F,c,n){const f=new S.DisposableStore;return C(c)?(f.add(this._editorProviders.addTextProvider(F,a,c)),this._proxy.$registerTextEditorProvider((0,T.toExtensionData)(a),F,n.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(a))):(f.add(this._editorProviders.addCustomProvider(F,a,c)),this.supportEditing(c)&&f.add(c.onDidChangeCustomDocument(g=>{const s=this.getCustomDocumentEntry(F,g.document.uri);if(w(g)){const d=s.addEdit(g);this._proxy.$onDidEdit(g.document.uri,F,d,g.label)}else this._proxy.$onContentChange(g.document.uri,F)})),this._proxy.$registerCustomEditorProvider((0,T.toExtensionData)(a),F,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(a))),i.Disposable.from(f,new i.Disposable(()=>{this._proxy.$unregisterEditorProvider(F)}))}async $createCustomDocument(a,F,c,n,f){const g=this._editorProviders.get(F);if(!g)throw new Error(`No provider found for '${F}'`);if(g.type!==1)throw new Error(`Invalid provide type for '${F}'`);const s=I.URI.revive(a),d=await g.provider.openCustomDocument(s,{backupId:c,untitledDocumentData:n?.buffer},f);let p;return this.supportEditing(g.provider)&&this._extensionStoragePaths&&(p=this._extensionStoragePaths.workspaceValue(g.extension)??this._extensionStoragePaths.globalValue(g.extension)),this._documents.add(F,d,p),{editable:this.supportEditing(g.provider)}}async $disposeCustomDocument(a,F){const c=this._editorProviders.get(F);if(!c)throw new Error(`No provider found for '${F}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${F}'`);const n=I.URI.revive(a),{document:f}=this.getCustomDocumentEntry(F,n);this._documents.delete(F,f),f.dispose()}async $resolveWebviewEditor(a,F,c,n,f,g){const s=this._editorProviders.get(c);if(!s)throw new Error(`No provider found for '${c}'`);const d=D.ViewColumn.to(f),p=this._extHostWebview.createNewWebview(F,n.webviewOptions,s.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(F,c,n.title,d,n.panelOptions,p),v=I.URI.revive(a);switch(s.type){case 1:{const{document:k}=this.getCustomDocumentEntry(c,v);return s.provider.resolveCustomEditor(k,E,g)}case 0:{const k=this._extHostDocuments.getDocument(v);return s.provider.resolveCustomTextEditor(k,E,g)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,F,c){this.getCustomDocumentEntry(F,a).disposeEdits(c)}async $onMoveCustomEditor(a,F,c){const n=this._editorProviders.get(c);if(!n)throw new Error(`No provider found for '${c}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const f=this._extHostWebviewPanels.getWebviewPanel(a);if(!f)throw new Error("No webview found");const g=I.URI.revive(F),s=this._extHostDocuments.getDocument(g);await n.provider.moveCustomTextEditor(s,f,r.CancellationToken.None)}async $undo(a,F,c,n){return this.getCustomDocumentEntry(F,a).undo(c,n)}async $redo(a,F,c,n){return this.getCustomDocumentEntry(F,a).redo(c,n)}async $revert(a,F,c){const n=this.getCustomDocumentEntry(F,a);await this.getCustomEditorProvider(F).revertCustomDocument(n.document,c),n.disposeBackup()}async $onSave(a,F,c){const n=this.getCustomDocumentEntry(F,a);await this.getCustomEditorProvider(F).saveCustomDocument(n.document,c),n.disposeBackup()}async $onSaveAs(a,F,c,n){const f=this.getCustomDocumentEntry(F,a);return this.getCustomEditorProvider(F).saveCustomDocumentAs(f.document,I.URI.revive(c),n)}async $backup(a,F,c){const n=this.getCustomDocumentEntry(F,a),g=await this.getCustomEditorProvider(F).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},c);return n.updateBackup(g),g.id}getCustomDocumentEntry(a,F){const c=this._documents.get(a,I.URI.revive(F));if(!c)throw new Error("No custom document found");return c}getCustomEditorProvider(a){const c=this._editorProviders.get(a)?.provider;if(!c||!this.supportEditing(c))throw new Error("Custom document is not editable");return c}supportEditing(a){return!!a.onDidChangeCustomDocument}}e.ExtHostCustomEditors=M;function C(_){return typeof _.resolveCustomTextEditor=="function"}function w(_){return typeof _.undo=="function"&&typeof _.redo=="function"}function u(_){const a=_.scheme===P.Schemas.file||_.scheme===P.Schemas.untitled?_.fsPath:_.toString();return(0,t.hash)(a)+""}});var Xe=this&&this.__classPrivateFieldSet||function(Z,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(Z,r):S?S.value=r:e.set(Z,r),r},Ie=this&&this.__classPrivateFieldGet||function(Z,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[205],Se([0,1,4,6,2,36,8,51,5,7]),function(Z,e,r,t,S,P,A,I,D,T){"use strict";var R,b,i,h,l,o,m,M,C,w,u,_,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class F extends t.Disposable{constructor(g,s,d,p,E,v,k){super();R.set(this,void 0),b.set(this,void 0),i.set(this,void 0),h.set(this,void 0),l.set(this,void 0),o.set(this,void 0),m.set(this,void 0),M.set(this,void 0),C.set(this,!0),w.set(this,!0),u.set(this,!1),_.set(this,this._register(new r.Emitter)),this.onDidDispose=Ie(this,_,"f").event,a.set(this,this._register(new r.Emitter)),this.onDidChangeViewState=Ie(this,a,"f").event,Xe(this,R,g,"f"),Xe(this,b,s,"f"),Xe(this,i,d,"f"),Xe(this,l,v,"f"),Xe(this,M,E,"f"),Xe(this,o,p,"f"),Xe(this,h,k,"f")}dispose(){Ie(this,u,"f")||(Xe(this,u,!0,"f"),Ie(this,_,"f").fire(),Ie(this,b,"f").$disposeWebview(Ie(this,R,"f")),Ie(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ie(this,h,"f")}get viewType(){return this.assertNotDisposed(),Ie(this,i,"f")}get title(){return this.assertNotDisposed(),Ie(this,o,"f")}set title(g){this.assertNotDisposed(),Ie(this,o,"f")!==g&&(Xe(this,o,g,"f"),Ie(this,b,"f").$setTitle(Ie(this,R,"f"),g))}get iconPath(){return this.assertNotDisposed(),Ie(this,m,"f")}set iconPath(g){this.assertNotDisposed(),Ie(this,m,"f")!==g&&(Xe(this,m,g,"f"),Ie(this,b,"f").$setIconPath(Ie(this,R,"f"),S.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return Ie(this,l,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ie(this,M,"f")=="number"&&Ie(this,M,"f")<0))return Ie(this,M,"f")}get active(){return this.assertNotDisposed(),Ie(this,w,"f")}get visible(){return this.assertNotDisposed(),Ie(this,C,"f")}_updateViewState(g){Ie(this,u,"f")||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(Xe(this,w,g.active,"f"),Xe(this,C,g.visible,"f"),Xe(this,M,g.viewColumn,"f"),Ie(this,a,"f").fire({webviewPanel:this}))}reveal(g,s){this.assertNotDisposed(),Ie(this,b,"f").$reveal(Ie(this,R,"f"),{viewColumn:g?A.ViewColumn.from(g):void 0,preserveFocus:!!s})}assertNotDisposed(){if(Ie(this,u,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,b=new WeakMap,i=new WeakMap,h=new WeakMap,l=new WeakMap,o=new WeakMap,m=new WeakMap,M=new WeakMap,C=new WeakMap,w=new WeakMap,u=new WeakMap,_=new WeakMap,a=new WeakMap;class c{constructor(g,s,d){this.webviews=s,this.workspace=d,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=g.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,P.generateUuid)()}createWebviewPanel(g,s,d,p,E={}){const v=typeof p=="object"?p.viewColumn:p,k={viewColumn:A.ViewColumn.from(v),preserveFocus:typeof p=="object"&&!!p.preserveFocus},L=(0,I.shouldSerializeBuffersForPostMessage)(g),y=c.newHandle();this._proxy.$createWebviewPanel((0,I.toExtensionData)(g),y,s,{title:d,panelOptions:n(E),webviewOptions:(0,I.serializeWebviewOptions)(g,this.workspace,E),serializeBuffersForPostMessage:L},k);const O=this.webviews.createNewWebview(y,E,g);return this.createNewWebviewPanel(y,s,d,v,E,O)}$onDidChangeWebviewPanelViewStates(g){const s=Object.keys(g);s.sort((d,p)=>{const E=g[d],v=g[p];return E.active?1:v.active?-1:+E.visible-+v.visible});for(const d of s){const p=this.getWebviewPanel(d);if(!p)continue;const E=g[d];p._updateViewState({active:E.active,visible:E.visible,viewColumn:A.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(g){this.getWebviewPanel(g)?.dispose(),this._webviewPanels.delete(g),this.webviews.deleteWebview(g)}registerWebviewPanelSerializer(g,s,d){if(this._serializers.has(s))throw new Error(`Serializer for '${s}' already registered`);return this._serializers.set(s,{serializer:d,extension:g}),this._proxy.$registerSerializer(s,{serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(g)}),new T.Disposable(()=>{this._serializers.delete(s),this._proxy.$unregisterSerializer(s)})}async $deserializeWebviewPanel(g,s,d,p){const E=this._serializers.get(s);if(!E)throw new Error(`No serializer found for '${s}'`);const{serializer:v,extension:k}=E,L=this.webviews.createNewWebview(g,d.webviewOptions,k),y=this.createNewWebviewPanel(g,s,d.title,p,d.panelOptions,L);await v.deserializeWebviewPanel(y,d.state)}createNewWebviewPanel(g,s,d,p,E,v){const k=new F(g,this._proxy,s,d,p,E,v);return this._webviewPanels.set(g,k),k}getWebviewPanel(g){return this._webviewPanels.get(g)}}e.ExtHostWebviewPanels=c;function n(f){return{enableFindWidget:f.enableFindWidget,retainContextWhenHidden:f.retainContextWhenHidden}}});var Xe=this&&this.__classPrivateFieldSet||function(Z,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(Z,r):S?S.value=r:e.set(Z,r),r},Ie=this&&this.__classPrivateFieldGet||function(Z,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[206],Se([0,1,4,6,51,5,7]),function(Z,e,r,t,S,P,A){"use strict";var I,D,T,R,b,i,h,l,o,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class M extends t.Disposable{constructor(u,_,a,F,c,n){super();I.set(this,void 0),D.set(this,void 0),T.set(this,void 0),R.set(this,void 0),b.set(this,!1),i.set(this,void 0),h.set(this,void 0),l.set(this,void 0),o.set(this,this._register(new r.Emitter)),this.onDidChangeVisibility=Ie(this,o,"f").event,m.set(this,this._register(new r.Emitter)),this.onDidDispose=Ie(this,m,"f").event,Xe(this,T,a,"f"),Xe(this,h,F,"f"),Xe(this,I,u,"f"),Xe(this,D,_,"f"),Xe(this,R,c,"f"),Xe(this,i,n,"f")}dispose(){Ie(this,b,"f")||(Xe(this,b,!0,"f"),Ie(this,m,"f").fire(),Ie(this,R,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ie(this,h,"f")}set title(u){this.assertNotDisposed(),Ie(this,h,"f")!==u&&(Xe(this,h,u,"f"),Ie(this,D,"f").$setWebviewViewTitle(Ie(this,I,"f"),u))}get description(){return this.assertNotDisposed(),Ie(this,l,"f")}set description(u){this.assertNotDisposed(),Ie(this,l,"f")!==u&&(Xe(this,l,u,"f"),Ie(this,D,"f").$setWebviewViewDescription(Ie(this,I,"f"),u))}get visible(){return Ie(this,i,"f")}get webview(){return Ie(this,R,"f")}get viewType(){return Ie(this,T,"f")}_setVisible(u){u===Ie(this,i,"f")||Ie(this,b,"f")||(Xe(this,i,u,"f"),Ie(this,o,"f").fire())}show(u){this.assertNotDisposed(),Ie(this,D,"f").$show(Ie(this,I,"f"),!!u)}assertNotDisposed(){if(Ie(this,b,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,D=new WeakMap,T=new WeakMap,R=new WeakMap,b=new WeakMap,i=new WeakMap,h=new WeakMap,l=new WeakMap,o=new WeakMap,m=new WeakMap;class C{constructor(u,_){this._extHostWebview=_,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=u.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(u,_,a,F){if(this._viewProviders.has(_))throw new Error(`View provider for '${_}' already registered`);return this._viewProviders.set(_,{provider:a,extension:u}),this._proxy.$registerWebviewViewProvider((0,S.toExtensionData)(u),_,{retainContextWhenHidden:F?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new A.Disposable(()=>{this._viewProviders.delete(_),this._proxy.$unregisterWebviewViewProvider(_)})}async $resolveWebviewView(u,_,a,F,c){const n=this._viewProviders.get(_);if(!n)throw new Error(`No view provider found for '${_}'`);const{provider:f,extension:g}=n,s=this._extHostWebview.createNewWebview(u,{},g),d=new M(u,this._proxy,_,a,s,!0);this._webviewViews.set(u,d),await f.resolveWebviewView(d,{state:F},c)}async $onDidChangeWebviewViewVisibility(u,_){this.getWebviewView(u)._setVisible(_)}async $disposeWebviewView(u){const _=this.getWebviewView(u);this._webviewViews.delete(u),_.dispose(),this._extHostWebview.deleteWebview(u)}getWebviewView(u){const _=this._webviewViews.get(u);if(!_)throw new Error("No webview found");return _}}e.ExtHostWebviewViews=C}),define(ye[94],Se([0,1,4,5,2,11,9,3,14]),function(Z,e,r,t,S,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class ji{constructor(b){this._onDidChangeWindowState=new r.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ji.InitialState,this._proxy=b.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(i=>this.$onDidChangeWindowFocus(i))}get state(){return this._state}$onDidChangeWindowFocus(b){b!==this._state.focused&&(this._state={...this._state,focused:b},this._onDidChangeWindowState.fire(this._state))}openUri(b,i){let h;if(typeof b=="string"){h=b;try{b=S.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,A.isFalsyOrWhitespace)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this._proxy.$openUri(b,h,i)}async asExternalUri(b,i){if((0,A.isFalsyOrWhitespace)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(b,i);return S.URI.from(h)}};T.InitialState={focused:!0},T=xe([$e(0,D.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,I.createDecorator)("IExtHostWindow")}),define(ye[207],Se([0,1,10,21,20,15,4,6,105,173,38]),function(Z,e,r,t,S,P,A,I,D,T,R){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function i(E,v){try{return JSON.stringify(E,v)}catch{return"null"}}const h="$$ref$$",l={[h]:-1};class o{constructor(v,k){this.jsonString=v,this.referencedBuffers=k}}function m(E,v=null,k=!1){const L=[];return{jsonString:(k?i:JSON.stringify)(E,(O,U)=>{if(typeof U=="undefined")return l;if(typeof U=="object"){if(U instanceof t.VSBuffer){const q=L.push(U)-1;return{[h]:q}}if(v)return v(O,U)}return U}),referencedBuffers:L}}e.stringifyJsonWithBufferRefs=m;function M(E,v,k){return JSON.parse(E,(L,y)=>{if(y){const O=y[h];if(typeof O=="number")return v[O];if(k&&y.$mid===1)return k.transformIncoming(y)}return y})}e.parseJsonAndRestoreBufferRefs=M;function C(E,v){return JSON.stringify(E,v)}function w(E){return E?(v,k)=>k&&k.$mid===1?E.transformOutgoing(k):k:null}var u;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));var _;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(_=e.ResponsiveState||(e.ResponsiveState={}));const a=()=>{},F=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class n extends I.Disposable{constructor(v,k=null,L=null){super();this[b]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=v,this._logger=k,this._uriTransformer=L,this._uriReplacer=w(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let y=0,O=R.ProxyIdentifier.count;y<O;y++)this._locals[y]=null,this._proxies[y]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new r.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(y=>this._receiveOneMessage(y))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(v=>{this._pendingRPCReplies[v].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(v){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(v){this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(v){this._responsiveState!==v&&(this._responsiveState=v,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(v){return this._uriTransformer?(0,D.transformIncomingURIs)(v,this._uriTransformer):v}getProxy(v){const{nid:k,sid:L}=v;return this._proxies[k]||(this._proxies[k]=this._createProxy(k,L)),this._proxies[k]}_createProxy(v,k){let L={get:(y,O)=>(typeof O=="string"&&!y[O]&&O.charCodeAt(0)===36&&(y[O]=(...U)=>this._remoteCall(v,O,U)),O===c?k:y[O])};return new Proxy(Object.create(null),L)}set(v,k){return this._locals[v.nid]=k,k}assertRegistered(v){for(let k=0,L=v.length;k<L;k++){const y=v[k];if(!this._locals[y.nid])throw new Error(`Missing proxy instance ${y.sid}`)}}_receiveOneMessage(v){if(this._isDisposed)return;const k=v.byteLength,L=f.read(v,0),y=L.readUInt8(),O=L.readUInt32();switch(y){case 1:case 2:{let{rpcId:U,method:q,args:H}=s.deserializeRequestJSONArgs(L);this._uriTransformer&&(H=(0,D.transformIncomingURIs)(H,this._uriTransformer)),this._receiveRequest(k,O,U,q,H,y===2);break}case 3:case 4:{let{rpcId:U,method:q,args:H}=s.deserializeRequestMixedArgs(L);this._uriTransformer&&(H=(0,D.transformIncomingURIs)(H,this._uriTransformer)),this._receiveRequest(k,O,U,q,H,y===4);break}case 5:{this._logger&&this._logger.logIncoming(k,O,0,"ack"),this._onDidReceiveAcknowledge(O);break}case 6:{this._receiveCancel(k,O);break}case 7:{this._receiveReply(k,O,void 0);break}case 9:{let U=s.deserializeReplyOKJSON(L);this._uriTransformer&&(U=(0,D.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReply(k,O,U);break}case 10:{const U=s.deserializeReplyOKJSONWithBuffers(L,this._uriTransformer);this._receiveReply(k,O,U);break}case 8:{let U=s.deserializeReplyOKVSBuffer(L);this._receiveReply(k,O,U);break}case 11:{let U=s.deserializeReplyErrError(L);this._uriTransformer&&(U=(0,D.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReplyErr(k,O,U);break}case 12:{this._receiveReplyErr(k,O,void 0);break}default:console.error("received unexpected message"),console.error(v)}}_receiveRequest(v,k,L,y,O,U){this._logger&&this._logger.logIncoming(v,k,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(L)}.${y}(`,O);const q=String(k);let H,z;if(U){const ie=new S.CancellationTokenSource;O.push(ie.token),H=this._invokeHandler(L,y,O),z=()=>ie.cancel()}else H=this._invokeHandler(L,y,O),z=a;this._cancelInvokedHandlers[q]=z;const j=s.serializeAcknowledged(k);this._logger&&this._logger.logOutgoing(j.byteLength,k,1,"ack"),this._protocol.send(j),H.then(ie=>{delete this._cancelInvokedHandlers[q];const ae=s.serializeReplyOK(k,ie,this._uriReplacer);this._logger&&this._logger.logOutgoing(ae.byteLength,k,1,"reply:",ie),this._protocol.send(ae)},ie=>{delete this._cancelInvokedHandlers[q];const ae=s.serializeReplyErr(k,ie);this._logger&&this._logger.logOutgoing(ae.byteLength,k,1,"replyErr:",ie),this._protocol.send(ae)})}_receiveCancel(v,k){this._logger&&this._logger.logIncoming(v,k,1,"receiveCancel");const L=String(k);this._cancelInvokedHandlers[L]&&this._cancelInvokedHandlers[L]()}_receiveReply(v,k,L){this._logger&&this._logger.logIncoming(v,k,0,"receiveReply:",L);const y=String(k);if(!this._pendingRPCReplies.hasOwnProperty(y))return;const O=this._pendingRPCReplies[y];delete this._pendingRPCReplies[y],O.resolveOk(L)}_receiveReplyErr(v,k,L){this._logger&&this._logger.logIncoming(v,k,0,"receiveReplyErr:",L);const y=String(k);if(!this._pendingRPCReplies.hasOwnProperty(y))return;const O=this._pendingRPCReplies[y];delete this._pendingRPCReplies[y];let U;L&&(L.$isError?(U=new Error,U.name=L.name,U.message=L.message,U.stack=L.stack):U=L),O.resolveErr(U)}_invokeHandler(v,k,L){try{return Promise.resolve(this._doInvokeHandler(v,k,L))}catch(y){return Promise.reject(y)}}_doInvokeHandler(v,k,L){const y=this._locals[v];if(!y)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(v));let O=y[k];if(typeof O!="function")throw new Error("Unknown method "+k+" on actor "+(0,R.getStringIdentifierForProxy)(v));return O.apply(y,L)}_remoteCall(v,k,L){if(this._isDisposed)return Promise.reject(P.canceled());let y=null;if(L.length>0&&S.CancellationToken.isCancellationToken(L[L.length-1])&&(y=L.pop()),y&&y.isCancellationRequested)return Promise.reject(P.canceled());const O=s.serializeRequestArguments(L,this._uriReplacer),U=++this._lastMessageId,q=String(U),H=new T.LazyPromise;y&&y.onCancellationRequested(()=>{const j=s.serializeCancel(U);this._logger&&this._logger.logOutgoing(j.byteLength,U,0,"cancel"),this._protocol.send(s.serializeCancel(U))}),this._pendingRPCReplies[q]=H,this._onWillSendRequest(U);const z=s.serializeRequest(U,v,k,O,!!y);return this._logger&&this._logger.logOutgoing(z.byteLength,U,0,`request: ${(0,R.getStringIdentifierForProxy)(v)}.${k}(`,L),this._protocol.send(z),H}}e.RPCProtocol=n,b=F,n.UNRESPONSIVE_TIME=3*1e3;class f{constructor(v,k){this._buff=v,this._offset=k}static alloc(v,k,L){let y=new f(t.VSBuffer.alloc(L+1+4),0);return y.writeUInt8(v),y.writeUInt32(k),y}static read(v,k){return new f(v,k)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(v){this._buff.writeUInt8(v,this._offset),this._offset+=1}readUInt8(){const v=this._buff.readUInt8(this._offset);return this._offset+=1,v}writeUInt32(v){this._buff.writeUInt32BE(v,this._offset),this._offset+=4}readUInt32(){const v=this._buff.readUInt32BE(this._offset);return this._offset+=4,v}static sizeShortString(v){return 1+v.byteLength}writeShortString(v){this._buff.writeUInt8(v.byteLength,this._offset),this._offset+=1,this._buff.set(v,this._offset),this._offset+=v.byteLength}readShortString(){const v=this._buff.readUInt8(this._offset);this._offset+=1;const L=this._buff.slice(this._offset,this._offset+v).toString();return this._offset+=v,L}static sizeLongString(v){return 4+v.byteLength}writeLongString(v){this._buff.writeUInt32BE(v.byteLength,this._offset),this._offset+=4,this._buff.set(v,this._offset),this._offset+=v.byteLength}readLongString(){const v=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+v).toString();return this._offset+=v,L}writeBuffer(v){this._buff.writeUInt32BE(v.byteLength,this._offset),this._offset+=4,this._buff.set(v,this._offset),this._offset+=v.byteLength}static sizeVSBuffer(v){return 4+v.byteLength}writeVSBuffer(v){this._buff.writeUInt32BE(v.byteLength,this._offset),this._offset+=4,this._buff.set(v,this._offset),this._offset+=v.byteLength}readVSBuffer(){const v=this._buff.readUInt32BE(this._offset);this._offset+=4;const k=this._buff.slice(this._offset,this._offset+v);return this._offset+=v,k}static sizeMixedArray(v){let k=0;k+=1;for(let L=0,y=v.length;L<y;L++){const O=v[L];switch(k+=1,O.type){case 1:k+=this.sizeLongString(O.value);break;case 2:k+=this.sizeVSBuffer(O.value);break;case 3:k+=this.sizeUInt32,k+=this.sizeLongString(O.value);for(let U=0;U<O.buffers.length;++U)k+=this.sizeVSBuffer(O.buffers[U]);break;case 4:break}}return k}writeMixedArray(v){this._buff.writeUInt8(v.length,this._offset),this._offset+=1;for(let k=0,L=v.length;k<L;k++){const y=v[k];switch(y.type){case 1:this.writeUInt8(1),this.writeLongString(y.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(y.value);break;case 3:this.writeUInt8(3),this.writeUInt32(y.buffers.length),this.writeLongString(y.value);for(let O=0;O<y.buffers.length;++O)this.writeBuffer(y.buffers[O]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const v=this._buff.readUInt8(this._offset);this._offset+=1;let k=new Array(v);for(let L=0;L<v;L++)switch(this.readUInt8()){case 1:k[L]=this.readLongString();break;case 2:k[L]=this.readVSBuffer();break;case 3:{const O=this.readUInt32(),U=this.readLongString(),q=[];for(let H=0;H<O;++H)q.push(this.readVSBuffer());k[L]=new R.SerializableObjectWithBuffers(M(U,q,null));break}case 4:k[L]=void 0;break}return k}}f.sizeUInt32=4;var g;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(g||(g={}));class s{static _useMixedArgSerialization(v){for(let k=0,L=v.length;k<L;k++)if(v[k]instanceof t.VSBuffer||v[k]instanceof R.SerializableObjectWithBuffers||typeof v[k]=="undefined")return!0;return!1}static serializeRequestArguments(v,k){if(this._useMixedArgSerialization(v)){const L=[];for(let y=0,O=v.length;y<O;y++){const U=v[y];if(U instanceof t.VSBuffer)L[y]={type:2,value:U};else if(typeof U=="undefined")L[y]={type:4};else if(U instanceof R.SerializableObjectWithBuffers){const{jsonString:q,referencedBuffers:H}=m(U.value,k);L[y]={type:3,value:t.VSBuffer.fromString(q),buffers:H}}else L[y]={type:1,value:t.VSBuffer.fromString(C(U,k))}}return{type:1,args:L}}return{type:0,args:C(v,k)}}static serializeRequest(v,k,L,y,O){switch(y.type){case 0:return this._requestJSONArgs(v,k,L,y.args,O);case 1:return this._requestMixedArgs(v,k,L,y.args,O)}}static _requestJSONArgs(v,k,L,y,O){const U=t.VSBuffer.fromString(L),q=t.VSBuffer.fromString(y);let H=0;H+=f.sizeUInt8(),H+=f.sizeShortString(U),H+=f.sizeLongString(q);let z=f.alloc(O?2:1,v,H);return z.writeUInt8(k),z.writeShortString(U),z.writeLongString(q),z.buffer}static deserializeRequestJSONArgs(v){const k=v.readUInt8(),L=v.readShortString(),y=v.readLongString();return{rpcId:k,method:L,args:JSON.parse(y)}}static _requestMixedArgs(v,k,L,y,O){const U=t.VSBuffer.fromString(L);let q=0;q+=f.sizeUInt8(),q+=f.sizeShortString(U),q+=f.sizeMixedArray(y);let H=f.alloc(O?4:3,v,q);return H.writeUInt8(k),H.writeShortString(U),H.writeMixedArray(y),H.buffer}static deserializeRequestMixedArgs(v){const k=v.readUInt8(),L=v.readShortString(),y=v.readMixedArray(),O=new Array(y.length);for(let U=0,q=y.length;U<q;U++){const H=y[U];typeof H=="string"?O[U]=JSON.parse(H):O[U]=H}return{rpcId:k,method:L,args:O}}static serializeAcknowledged(v){return f.alloc(5,v,0).buffer}static serializeCancel(v){return f.alloc(6,v,0).buffer}static serializeReplyOK(v,k,L){if(typeof k=="undefined")return this._serializeReplyOKEmpty(v);if(k instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(v,k);if(k instanceof R.SerializableObjectWithBuffers){const{jsonString:y,referencedBuffers:O}=m(k.value,L,!0);return this._serializeReplyOKJSONWithBuffers(v,y,O)}else return this._serializeReplyOKJSON(v,i(k,L))}static _serializeReplyOKEmpty(v){return f.alloc(7,v,0).buffer}static _serializeReplyOKVSBuffer(v,k){let L=0;L+=f.sizeVSBuffer(k);let y=f.alloc(8,v,L);return y.writeVSBuffer(k),y.buffer}static deserializeReplyOKVSBuffer(v){return v.readVSBuffer()}static _serializeReplyOKJSON(v,k){const L=t.VSBuffer.fromString(k);let y=0;y+=f.sizeLongString(L);let O=f.alloc(9,v,y);return O.writeLongString(L),O.buffer}static _serializeReplyOKJSONWithBuffers(v,k,L){const y=t.VSBuffer.fromString(k);let O=0;O+=f.sizeUInt32,O+=f.sizeLongString(y);for(const q of L)O+=f.sizeVSBuffer(q);let U=f.alloc(10,v,O);U.writeUInt32(L.length),U.writeLongString(y);for(const q of L)U.writeBuffer(q);return U.buffer}static deserializeReplyOKJSON(v){const k=v.readLongString();return JSON.parse(k)}static deserializeReplyOKJSONWithBuffers(v,k){const L=v.readUInt32(),y=v.readLongString(),O=[];for(let U=0;U<L;++U)O.push(v.readVSBuffer());return new R.SerializableObjectWithBuffers(M(y,O,k))}static serializeReplyErr(v,k){return k?this._serializeReplyErrEror(v,k):this._serializeReplyErrEmpty(v)}static _serializeReplyErrEror(v,k){const L=t.VSBuffer.fromString(i(P.transformErrorForSerialization(k),null));let y=0;y+=f.sizeLongString(L);let O=f.alloc(11,v,y);return O.writeLongString(L),O.buffer}static deserializeReplyErrError(v){const k=v.readLongString();return JSON.parse(k)}static _serializeReplyErrEmpty(v){return f.alloc(12,v,0).buffer}}var d;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(d||(d={}));var p;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(p||(p={}))}),define(ye[208],Se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const r=function(P){const A=I=>{self.removeEventListener("message",A);const D=I.data;Object.defineProperties(self,{postMessage:{value(T,R){D.postMessage(T,R)}},onmessage:{get(){return D.onmessage},set(T){D.onmessage=T}}}),D.addEventListener("message",T=>{self.dispatchEvent(new MessageEvent("message",{data:T.data}))}),D.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(P)};self.addEventListener("message",A)}.toString();class t extends EventTarget{constructor(P,A,I){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${r})('${A}'))`,T=new Blob([D],{type:"application/javascript"}),R=URL.createObjectURL(T),b=new MessageChannel,i=R,h={type:"_newWorker",id:i,port:b.port2,url:R,options:I};P(h,[b.port2]),this.postMessage=b.port1.postMessage.bind(b.port1),this.terminate=()=>{const l={type:"_terminateWorker",id:i};b.port1.postMessage(l),URL.revokeObjectURL(R),b.port1.close(),b.port2.close()},Object.defineProperties(this,{onmessage:{get(){return b.port1.onmessage},set(l){b.port1.onmessage=l}},onmessageerror:{get(){return b.port1.onmessageerror},set(l){b.port1.onmessageerror=l}}}),b.port1.addEventListener("messageerror",l=>{const o=new MessageEvent("messageerror",{data:l.data});this.dispatchEvent(o)}),b.port1.addEventListener("message",l=>{const o=new MessageEvent("message",{data:l.data});this.dispatchEvent(o)}),b.port1.start()}}e.NestedWorker=t}),define(ye[209],Se([0,1,3]),function(Z,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,r.createDecorator)("remoteAgentService")}),define(ye[210],Se([0,1,35,11,17,23,24,2,3,60,47,168,209]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,D.createDecorator)("pathService");let h=class qi{constructor(o,m,M,C){this.localUserHome=o,this.remoteAgentService=m,this.environmentService=M,this.contextService=C,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||P.OS)(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=w?.userHome||o})()}hasValidBasename(o,m,M){return typeof m=="string"||typeof m=="undefined"?this.resolveOS.then(C=>this.doHasValidBasename(o,C,m)):this.doHasValidBasename(o,m,M)}doHasValidBasename(o,m,M){return o.scheme===t.Schemas.file||o.scheme===t.Schemas.vscodeRemote?(0,r.isValidBasename)(M??(0,A.basename)(o),m===1):!0}get defaultUriScheme(){return qi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(o,m){if(o.remoteAuthority)return t.Schemas.vscodeRemote;const M=(0,T.getVirtualWorkspaceScheme)(m.getWorkspace());if(M)return M;const C=m.getWorkspace().folders[0];if(C)return C.uri.scheme;const w=m.getWorkspace().configuration;return w?w.scheme:t.Schemas.file}async userHome(o){return o?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(o=>o===1?S.win32:S.posix)}async fileURI(o){let m="";if(await this.resolveOS===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const C=o.indexOf("/",2);C===-1?(m=o.substring(2),o="/"):(m=o.substring(2,C),o=o.substring(C)||"/")}return I.URI.from({scheme:t.Schemas.file,authority:m,path:o,query:"",fragment:""})}};h=xe([$e(1,i.IRemoteAgentService),$e(2,b.IWorkbenchEnvironmentService),$e(3,R.IWorkspaceContextService)],h),e.AbstractPathService=h}),define(ye[95],Se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class r{constructor(A,I){this.line=A,this.character=I}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,I){return new r(0,0)}with(A){return new r(0,0)}}e.Position=r;class t{constructor(A,I,D,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(A,I),this.end=new r(D,T)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new t(0,0,0,0)}with(A){return new t(0,0,0,0)}}e.Range=t;var S;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(S=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ye[41],Se([0,1,16,29,27,35,9,3,17,15,95,10]),function(Z,e,r,t,S,P,A,I,D,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const i="\u27EA ",h=" characters skipped \u27EB",l=(i.length+h.length+5)*2;e.ISearchService=(0,I.createDecorator)("searchService");var o;(function(j){j[j.file=0]="file",j[j.text=1]="text"})(o=e.SearchProviderType||(e.SearchProviderType={}));var m;(function(j){j[j.File=1]="File",j[j.Text=2]="Text"})(m=e.QueryType||(e.QueryType={}));function M(j){return!!j.preview}e.resultIsMatch=M;function C(j){return!!j.resource}e.isFileMatch=C;function w(j){return!!j.message}e.isProgressMessage=w;var u;(function(j){j[j.Normal=0]="Normal",j[j.NewSearchStarted=1]="NewSearchStarted"})(u=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class _{constructor(ie){this.resource=ie,this.results=[]}}e.FileMatch=_;class a{constructor(ie,ae,te){this.ranges=ae;const ue=Array.isArray(ae)?ae:[ae];if(te&&te.matchLines===1&&F(ue)){ie=(0,A.getNLines)(ie,te.matchLines);let be="",pe=0,me=0;const oe=Math.floor(te.charsPerLine/5),Ee=[];for(const Pe of ue){const Oe=Math.max(Pe.startColumn-oe,0),je=Pe.startColumn+te.charsPerLine;if(Oe>me+oe+l){const st=i+(Oe-me)+h;be+=st+ie.slice(Oe,je),pe+=Oe-(me+st.length)}else be+=ie.slice(me,je);Ee.push(new n(0,Pe.startColumn-pe,Pe.endColumn-pe)),me=je}this.preview={text:be,matches:Array.isArray(this.ranges)?Ee:Ee[0]}}else{const be=Array.isArray(ae)?ae[0].startLineNumber:ae.startLineNumber;this.preview={text:ie,matches:(0,r.mapArrayOrNot)(ae,pe=>new c(pe.startLineNumber-be,pe.startColumn,pe.endLineNumber-be,pe.endColumn))}}}}e.TextSearchMatch=a;function F(j){const ie=j[0].startLineNumber;for(const ae of j)if(ae.startLineNumber!==ie||ae.endLineNumber!==ie)return!1;return!0}class c{constructor(ie,ae,te,ue){this.startLineNumber=ie,this.startColumn=ae,this.endLineNumber=te,this.endColumn=ue}}e.SearchRange=c;class n extends c{constructor(ie,ae,te){super(ie,ae,ie,te)}}e.OneLineRange=n;var f;(function(j){j.Default="default",j.FileNames="fileNames",j.Type="type",j.Modified="modified",j.CountDescending="countDescending",j.CountAscending="countAscending"})(f=e.SearchSortOrder||(e.SearchSortOrder={}));function g(j,ie=!0){const ae=j&&j.files&&j.files.exclude,te=ie&&j&&j.search&&j.search.exclude;if(!ae&&!te)return;if(!ae||!te)return ae||te;let ue=Object.create(null);return ue=S.mixin(ue,S.deepClone(ae)),ue=S.mixin(ue,S.deepClone(te),!0),ue}e.getExcludes=g;function s(j,ie){return j.excludePattern&&t.match(j.excludePattern,ie)?!1:j.includePattern||j.usingSearchPaths?j.includePattern&&t.match(j.includePattern,ie)?!0:j.usingSearchPaths?!!j.folderQueries&&j.folderQueries.some(ae=>{const te=ae.folder.fsPath;if(P.isEqualOrParent(ie,te)){const ue=D.relative(te,ie);return!ae.includePattern||!!t.match(ae.includePattern,ue)}else return!1}):!1:!0}e.pathIncludedInQuery=s;var d;(function(j){j[j.unknownEncoding=1]="unknownEncoding",j[j.regexParseError=2]="regexParseError",j[j.globParseError=3]="globParseError",j[j.invalidLiteral=4]="invalidLiteral",j[j.rgProcessError=5]="rgProcessError",j[j.other=6]="other",j[j.canceled=7]="canceled"})(d=e.SearchErrorCode||(e.SearchErrorCode={}));class p extends Error{constructor(ie,ae){super(ie);this.code=ae}}e.SearchError=p;function E(j){const ie=j.message;if((0,T.isCancellationError)(j))return new p(ie,d.canceled);try{const ae=JSON.parse(ie);return new p(ae.message,ae.code)}catch{return new p(ie,d.other)}}e.deserializeSearchError=E;function v(j){const ie={message:j.message,code:j.code};return new Error(JSON.stringify(ie))}e.serializeSearchError=v;function k(j){return j.type==="error"?!0:j.type==="success"}e.isSerializedSearchComplete=k;function L(j){return j.type==="success"}e.isSerializedSearchSuccess=L;function y(j){return!!j.path}e.isSerializedFileMatch=y;function O(j,ie){const ae=j.searchPath?j.searchPath:j.relativePath;return(0,A.fuzzyContains)(ae,ie)}e.isFilePatternMatch=O;class U{constructor(ie){this.path=ie,this.results=[]}addMatch(ie){this.results.push(ie)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=U;function q(j,ie){const ae={...j||{},...ie||{}};return Object.keys(ae).filter(te=>{const ue=ae[te];return typeof ue=="boolean"&&ue})}e.resolvePatternsForProvider=q;class H{constructor(ie,ae){this._parsedIncludeExpression=null,this._excludeExpression={...ie.excludePattern||{},...ae.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let te=ie.includePattern;ae.includePattern&&(te?te={...te,...ae.includePattern}:te=ae.includePattern),te&&(this._parsedIncludeExpression=t.parse(te))}matchesExcludesSync(ie,ae,te){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,ae,te))}includedInQuerySync(ie,ae,te){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,ae,te)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ie,ae,te))}includedInQuery(ie,ae,te){const ue=this._parsedExcludeExpression(ie,ae,te),be=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ie,ae,te):!0;return(0,b.isThenable)(ue)?ue.then(pe=>pe?!1:be()):be()}hasSiblingExcludeClauses(){return z(this._excludeExpression)}}e.QueryGlobTester=H;function z(j){for(const ie in j)if(typeof j[ie]!="boolean")return!0;return!1}}),define(ye[31],Se([0,1,16,10,20,4,22,11,100,24,9,13,2,124,3,12,137,47,30,28,14,8,7,41,5]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i,h,l,o,m,M,C,w,u,_,a,F,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function n(k,L,y){return new T.ExtUri(O=>d(O,y)).isEqual(k,L)}function f(k,L,y){return n(k.uri,L.uri,y)?0:(0,R.compare)(k.uri.toString(),L.uri.toString())}function g(k,L,y){return k.index!==L.index?k.index<L.index?-1:1:n(k.uri,L.uri,y)?(0,R.compare)(k.name,L.name):(0,R.compare)(k.uri.toString(),L.uri.toString())}function s(k,L,y,O){const U=k.slice(0).sort((H,z)=>y(H,z,O)),q=L.slice(0).sort((H,z)=>y(H,z,O));return(0,r.delta)(U,q,(H,z)=>y(H,z,O))}function d(k,L){const y=L.getCapabilities(k.scheme);return!(y&&y&1024)}class p extends M.Workspace{constructor(L,y,O,U,q,H,z){super(L,O.map(j=>new M.WorkspaceFolder(j)),U,q,z);this._name=y,this._isUntitled=H,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(z),O.forEach(j=>{this._workspaceFolders.push(j),this._structure.set(j.uri,j)})}static toExtHostWorkspace(L,y,O,U){if(!L)return{workspace:null,added:[],removed:[]};const{id:q,name:H,folders:z,configuration:j,transient:ie,isUntitled:ae}=L,te=[],ue=y;y?z.forEach((oe,Ee)=>{const Pe=i.URI.revive(oe.uri),Oe=p._findFolder(O||y,Pe,U);Oe?(Oe.name=oe.name,Oe.index=oe.index,te.push(Oe)):te.push({uri:Pe,name:oe.name,index:Ee})}):te.push(...z.map(({uri:oe,name:Ee,index:Pe})=>({uri:i.URI.revive(oe),name:Ee,index:Pe}))),te.sort((oe,Ee)=>oe.index<Ee.index?-1:1);const be=new p(q,H,te,!!ie,j?i.URI.revive(j):null,!!ae,oe=>d(oe,U)),{added:pe,removed:me}=s(ue?ue.workspaceFolders:[],be.workspaceFolders,f,U);return{workspace:be,added:pe,removed:me}}static _findFolder(L,y,O){for(let U=0;U<L.folders.length;U++){const q=L.workspaceFolders[U];if(n(q.uri,y,O))return q}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,y){return y&&this._structure.get(L)&&(L=(0,T.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let E=class{constructor(L,y,O,U){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new P.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=U,this._extHostFileSystemInfo=O,this._requestIdProvider=new D.Counter,this._barrier=new t.Barrier,this._proxy=L.getProxy(c.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(c.MainContext.MainThreadMessageService);const q=y.workspace;this._confirmedWorkspace=q?new p(q.id,q.name,[],!!q.transient,q.configuration?i.URI.revive(q.configuration):null,!!q.isUntitled,H=>d(H,O)):void 0}$initializeWorkspace(L,y){this._trusted=y,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?i.URI.from({scheme:I.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,y,O,...U){const q=[];if(Array.isArray(U)&&U.forEach(ae=>{i.URI.isUri(ae.uri)&&!q.some(te=>n(te.uri,ae.uri,this._extHostFileSystemInfo))&&q.push({uri:ae.uri,name:ae.name||(0,T.basenameOrAuthority)(ae.uri)})}),this._unconfirmedWorkspace||[y,O].some(ae=>typeof ae!="number"||ae<0)||O===0&&q.length===0)return!1;const H=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(y+O>H.length)return!1;const z=H.slice(0);z.splice(y,O,...q.map(ae=>({uri:ae.uri,name:ae.name||(0,T.basenameOrAuthority)(ae.uri),index:void 0})));for(let ae=0;ae<z.length;ae++){const te=z[ae];if(z.some((ue,be)=>be!==ae&&n(te.uri,ue.uri,this._extHostFileSystemInfo)))return!1}z.forEach((ae,te)=>ae.index=te);const{added:j,removed:ie}=s(H,z,g,this._extHostFileSystemInfo);if(j.length===0&&ie.length===0)return!1;if(this._proxy){const ae=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(ae,y,O,q).then(void 0,te=>{this._unconfirmedWorkspace=void 0;const ue={source:{identifier:L.identifier,label:L.displayName||L.name}};this._messageService.$showMessage(m.Severity.Error,(0,h.localize)(0,null,ae,te.toString()),ue,[])})}return this.trySetWorkspaceFolders(z),!0}getWorkspaceFolder(L,y){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,y)}async getWorkspaceFolder2(L,y){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,y)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,y){let O,U="";if(typeof L=="string"?(O=i.URI.file(L),U=L):typeof L!="undefined"&&(O=L,U=L.fsPath),!O)return U;const q=this.getWorkspaceFolder(O,!0);if(!q)return U;typeof y=="undefined"&&this._actualWorkspace&&(y=this._actualWorkspace.folders.length>1);let H=(0,T.relativePath)(q.uri,O);return y&&q.name&&(H=`${q.name}/${H}`),H}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=p.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:y,added:O,removed:U}=p.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=y||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:U}))}findFiles(L,y,O,U,q=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let H;if(y===null?H=!1:y&&(typeof y=="string"?H=y:H=y.pattern),q&&q.isCancellationRequested)return Promise.resolve([]);const{includePattern:z,folder:j}=v(_.GlobPattern.from(L));return this._proxy.$startFileSearch((0,b.withUndefinedAsNull)(z),(0,b.withUndefinedAsNull)(j),(0,b.withUndefinedAsNull)(H),(0,b.withUndefinedAsNull)(O),q).then(ie=>Array.isArray(ie)?ie.map(ae=>i.URI.revive(ae)):[])}async findTextInFiles(L,y,O,U,q=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const H=this._requestIdProvider.getNext(),z=typeof y.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:y.previewOptions,{includePattern:j,folder:ie}=v(_.GlobPattern.from(y.include)),ae=typeof y.exclude=="string"?y.exclude:y.exclude?y.exclude.pattern:void 0,te={ignoreSymlinks:typeof y.followSymlinks=="boolean"?!y.followSymlinks:void 0,disregardIgnoreFiles:typeof y.useIgnoreFiles=="boolean"?!y.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof y.useGlobalIgnoreFiles=="boolean"?!y.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof y.useParentIgnoreFiles=="boolean"?!y.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof y.useDefaultExcludes=="boolean"?!y.useDefaultExcludes:!0,fileEncoding:y.encoding,maxResults:y.maxResults,previewOptions:z,afterContext:y.afterContext,beforeContext:y.beforeContext,includePattern:j,excludePattern:ae},ue=!1;if(this._activeSearchCallbacks[H]=be=>{if(ue)return;const pe=i.URI.revive(be.resource);be.results.forEach(me=>{(0,F.resultIsMatch)(me)?O({uri:pe,preview:{text:me.preview.text,matches:(0,r.mapArrayOrNot)(me.preview.matches,oe=>new a.Range(oe.startLineNumber,oe.startColumn,oe.endLineNumber,oe.endColumn))},ranges:(0,r.mapArrayOrNot)(me.ranges,oe=>new a.Range(oe.startLineNumber,oe.startColumn,oe.endLineNumber,oe.endColumn))}):O({uri:pe,text:me.text,lineNumber:me.lineNumber})})},q.isCancellationRequested)return{};try{const be=await this._proxy.$startTextSearch(L,(0,b.withUndefinedAsNull)(ie),te,H,q);return delete this._activeSearchCallbacks[H],be||{}}catch(be){throw delete this._activeSearchCallbacks[H],be}}$handleTextSearchResult(L,y){this._activeSearchCallbacks[y]&&this._activeSearchCallbacks[y](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};E=xe([$e(0,u.IExtHostRpcService),$e(1,w.IExtHostInitDataService),$e(2,C.IExtHostFileSystemInfo),$e(3,o.ILogService)],E),e.ExtHostWorkspace=E,e.IExtHostWorkspace=(0,l.createDecorator)("IExtHostWorkspace");function v(k){let L,y;return k&&(typeof k=="string"?L=k:(L=k.pattern,y=i.URI.revive(k.baseUri))),{includePattern:L,folder:y}}}),define(ye[32],Se([0,1,27,4,31,5,7,141,81,13,10,3,14,12,2]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function o(F,c){if(c){const n=c.split(".");let f=F;for(let g=0;f&&g<n.length;g++)f=f[n[g]];return f}}function m(F){return F instanceof l.URI}function M(F){return F&&F.uri instanceof l.URI&&F.languageId&&typeof F.languageId=="string"}function C(F){return F&&!F.uri&&F.languageId&&typeof F.languageId=="string"}function w(F){return F&&F.uri instanceof l.URI&&(!F.name||typeof F.name=="string")&&(!F.index||typeof F.index=="number")}function u(F){if(m(F))return{resource:F};if(M(F))return{resource:F.uri,overrideIdentifier:F.languageId};if(C(F))return{overrideIdentifier:F.languageId};if(w(F))return{resource:F.uri};if(F===null)return{resource:null}}let _=class{constructor(c,n,f){this._proxy=c.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=f,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(c=>this._actual)}$initializeConfiguration(c){this._actual=new a(this._proxy,this._extHostWorkspace,c,this._logService),this._barrier.open()}$acceptConfigurationChanged(c,n){this.getConfigProvider().then(f=>f.$acceptConfigurationChanged(c,n))}};_=xe([$e(0,i.IExtHostRpcService),$e(1,S.IExtHostWorkspace),$e(2,h.ILogService)],_),e.ExtHostConfiguration=_;class a{constructor(c,n,f,g){this._onDidChangeConfiguration=new t.Emitter,this._proxy=c,this._logService=g,this._extHostWorkspace=n,this._configuration=I.Configuration.parse(f),this._configurationScopes=this._toMap(f.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(c,n){const f={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,f))}getConfiguration(c,n,f){const g=u(n)||{},s=this._toReadonlyValue(c?o(this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace),c):this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace));c&&this._validateConfigurationAccess(c,g,f?.identifier);function d(E){if(E==null)return null;if(typeof E=="boolean")return E?1:4;switch(E){case A.ConfigurationTarget.Global:return 1;case A.ConfigurationTarget.Workspace:return 4;case A.ConfigurationTarget.WorkspaceFolder:return 5}}const p={has(E){return typeof o(s,E)!="undefined"},get:(E,v)=>{this._validateConfigurationAccess(c?`${c}.${E}`:E,g,f?.identifier);let k=o(s,E);if(typeof k=="undefined")k=v;else{let L;const y=(O,U)=>{let q;const H=()=>{L=L||(0,r.deepClone)(s),q=q||o(L,U)};return(0,T.isObject)(O)?new Proxy(O,{get:(z,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return H(),()=>q;if(L)return q=q||o(L,U),q[j];const ie=z[j];return typeof j=="string"?y(ie,`${U}.${j}`):ie},set:(z,j,ie)=>(H(),q&&(q[j]=ie),!0),deleteProperty:(z,j)=>(H(),q&&delete q[j],!0),defineProperty:(z,j,ie)=>(H(),q&&Object.defineProperty(q,j,ie),!0)}):O};k=y(k,E)}return k},update:(E,v,k,L)=>{E=c?`${c}.${E}`:E;const y=d(k);return v!==void 0?this._proxy.$updateConfigurationOption(y,E,v,g,L):this._proxy.$removeConfigurationOption(y,E,g,L)},inspect:E=>{E=c?`${c}.${E}`:E;const v=(0,r.deepClone)(this._configuration.inspect(E,g,this._extHostWorkspace.workspace));if(v)return{key:E,defaultValue:v.default?.value,globalValue:v.user?.value,workspaceValue:v.workspace?.value,workspaceFolderValue:v.workspaceFolder?.value,defaultLanguageValue:v.default?.override,globalLanguageValue:v.user?.override,workspaceLanguageValue:v.workspace?.override,workspaceFolderLanguageValue:v.workspaceFolder?.override,languageIds:v.overrideIdentifiers}}};return typeof s=="object"&&(0,r.mixin)(p,s,!1),Object.freeze(p)}_toReadonlyValue(c){const n=f=>(0,T.isObject)(f)?new Proxy(f,{get:(g,s)=>n(g[s]),set:(g,s,d)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(s)}' of object`)},deleteProperty:(g,s)=>{throw new Error(`TypeError: Cannot delete read only property '${String(s)}' of object`)},defineProperty:(g,s)=>{throw new Error(`TypeError: Cannot define property '${String(s)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):f;return n(c)}_validateConfigurationAccess(c,n,f){const g=D.OVERRIDE_PROPERTY_REGEX.test(c)?4:this._configurationScopes.get(c),s=f?`[${f.value}] `:"";if(g===4){typeof n?.resource=="undefined"&&this._logService.warn(`${s}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){n?.resource&&this._logService.warn(`${s}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(c,n){const f=new I.ConfigurationChangeEvent(c,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(g,s)=>f.affectsConfiguration(g,u(s))})}_toMap(c){return c.reduce((n,f)=>(n.set(f[0],f[1]),n),new Map)}}e.ExtHostConfigProvider=a,e.IExtHostConfiguration=(0,b.createDecorator)("IExtHostConfiguration")});var Xe=this&&this.__classPrivateFieldSet||function(Z,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(Z,r):S?S.value=r:e.set(Z,r),r},Ie=this&&this.__classPrivateFieldGet||function(Z,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[96],Se([0,1,2,10,4,5,7,31,49,32,20,40,14,28,3,11,23,12,68,160,15]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i,h,l,o,m,M,C,w,u){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var a;(function(U){function q(z){if(z!=null)return z}U.from=q;function H(z){if(z!=null)return z}U.to=H})(a=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var F;(function(U){function q(z){if(z!=null)return z}U.from=q;function H(z){if(z!=null)return z}U.to=H})(F=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var c;(function(U){function q(z){if(z!=null)return z}U.from=q;function H(z){if(z!=null)return z}U.to=H})(c=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(U){function q(j){if(j){const ie=j;return ie&&!!ie.process}else return!1}U.is=q;function H(j){if(j==null)return;const ie={process:j.process,args:j.args};return j.options&&(ie.options=c.from(j.options)),ie}U.from=H;function z(j){if(j!=null)return new A.ProcessExecution(j.process,j.args,j.options)}U.to=z})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var f;(function(U){function q(z){if(z!=null)return z}U.from=q;function H(z){if(z!=null)return z}U.to=H})(f=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var g;(function(U){function q(j){if(j){const ie=j;return ie&&(!!ie.commandLine||!!ie.command)}else return!1}U.is=q;function H(j){if(j==null)return;const ie={};return j.commandLine!==void 0?ie.commandLine=j.commandLine:(ie.command=j.command,ie.args=j.args),j.options&&(ie.options=f.from(j.options)),ie}U.from=H;function z(j){if(!(j==null||j.command===void 0&&j.commandLine===void 0))return j.commandLine?new A.ShellExecution(j.commandLine,j.options):new A.ShellExecution(j.command,j.args?j.args:[],j.options)}U.to=z})(g=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var s;(function(U){function q(j){if(j){let ie=j;return ie&&ie.customExecution==="customExecution"}else return!1}U.is=q;function H(j){return{customExecution:"customExecution"}}U.from=H;function z(j,ie){return ie.get(j)}U.to=z})(s=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var d;(function(U){function q(H,z){let j;return H.scope!==void 0&&typeof H.scope!="number"?j=H.scope.uri:H.scope!==void 0&&typeof H.scope=="number"&&(H.scope===A.TaskScope.Workspace&&z&&z.workspaceFile?j=z.workspaceFile:j=w.USER_TASKS_GROUP_KEY),{id:H._id,workspaceFolder:j}}U.from=q})(d=e.TaskHandleDTO||(e.TaskHandleDTO={}));var p;(function(U){function q(H){if(H!=null)return{_id:H.id,isDefault:H.isDefault}}U.from=q})(p=e.TaskGroupDTO||(e.TaskGroupDTO={}));var E;(function(U){function q(j,ie){if(j==null)return[];const ae=[];for(let te of j){const ue=H(te,ie);ue&&ae.push(ue)}return ae}U.fromMany=q;function H(j,ie){if(j==null)return;let ae;j.execution instanceof A.ProcessExecution?ae=n.from(j.execution):j.execution instanceof A.ShellExecution?ae=g.from(j.execution):j.execution&&j.execution instanceof A.CustomExecution&&(ae=s.from(j.execution));const te=a.from(j.definition);let ue;return j.scope?typeof j.scope=="number"?ue=j.scope:ue=j.scope.uri:ue=A.TaskScope.Workspace,!te||!ue?void 0:{_id:j._id,definition:te,name:j.name,source:{extensionId:ie.identifier.value,label:j.source,scope:ue},execution:ae,isBackground:j.isBackground,group:p.from(j.group),presentationOptions:F.from(j.presentationOptions),problemMatchers:j.problemMatchers,hasDefinedMatchers:j.hasDefinedMatchers,runOptions:j.runOptions?j.runOptions:{reevaluateOnRerun:!0},detail:j.detail}}U.from=H;async function z(j,ie,ae){if(j==null)return;let te;n.is(j.execution)?te=n.to(j.execution):g.is(j.execution)?te=g.to(j.execution):s.is(j.execution)&&(te=s.to(j._id,ae));const ue=a.to(j.definition);let be;if(j.source&&(j.source.scope!==void 0?typeof j.source.scope=="number"?be=j.source.scope:be=await ie.resolveWorkspaceFolder(r.URI.revive(j.source.scope)):be=A.TaskScope.Workspace),!ue||!be)return;const pe=new A.Task(ue,be,j.name,j.source.label,te,j.problemMatchers);return j.isBackground!==void 0&&(pe.isBackground=j.isBackground),j.group!==void 0&&(pe.group=A.TaskGroup.from(j.group._id),pe.group&&j.group.isDefault&&(pe.group=new A.TaskGroup(pe.group.id,pe.group.label),j.group.isDefault&&(pe.group.isDefault=j.group.isDefault))),j.presentationOptions&&(pe.presentationOptions=F.to(j.presentationOptions)),j._id&&(pe._id=j._id),j.detail&&(pe.detail=j.detail),pe}U.to=z})(E=e.TaskDTO||(e.TaskDTO={}));var v;(function(U){function q(z){return z}U.from=q;function H(z){if(!!z)return Object.assign(Object.create(null),z)}U.to=H})(v=e.TaskFilterDTO||(e.TaskFilterDTO={}));class k{constructor(q,H,z){this._id=H,this._task=z,_.set(this,void 0),Xe(this,_,q,"f")}get task(){return this._task}terminate(){Ie(this,_,"f").terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}_=new WeakMap;var L;(function(U){function q(H){return{id:H._id,task:void 0}}U.from=q})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let y=class{constructor(q,H,z,j,ie,ae,te,ue){this._onDidExecuteTask=new S.Emitter,this._onDidTerminateTask=new S.Emitter,this._onDidTaskProcessStarted=new S.Emitter,this._onDidTaskProcessEnded=new S.Emitter,this._proxy=q.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=z,this._editorService=j,this._configurationService=ie,this._terminalService=ae,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=te,this._deprecationService=ue,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(q,H,z){if(!z)return new A.Disposable(()=>{});const j=this.nextHandle();return this._handlers.set(j,{type:H,provider:z,extension:q}),this._proxy.$registerTaskProvider(j,H),new A.Disposable(()=>{this._handlers.delete(j),this._proxy.$unregisterTaskProvider(j)})}registerTaskSystem(q,H){this._proxy.$registerTaskSystem(q,H)}fetchTasks(q){return this._proxy.$fetchTasks(v.from(q)).then(async H=>{const z=[];for(let j of H){const ie=await E.to(j,this._workspaceProvider,this._providedCustomExecutions2);ie&&z.push(ie)}return z})}get taskExecutions(){const q=[];return this._taskExecutions.forEach(H=>q.push(H)),q}terminateTask(q){if(!(q instanceof k))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(q._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(q,H,z){const j=this._providedCustomExecutions2.get(q.id);j&&(this._activeCustomExecutions2.set(q.id,j),this._terminalService.attachPtyToTerminal(H,await j.callback(z))),this._lastStartedTask=q.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(q)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(q){const H=await this.getTaskExecution(q);this._taskExecutionPromises.delete(q.id),this._taskExecutions.delete(q.id),this.customExecutionComplete(q),this._onDidTerminateTask.fire({execution:H})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(q){const H=await this.getTaskExecution(q.id);this._onDidTaskProcessStarted.fire({execution:H,processId:q.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(q){const H=await this.getTaskExecution(q.id);this._onDidTaskProcessEnded.fire({execution:H,exitCode:q.exitCode})}$provideTasks(q,H){const z=this._handlers.get(q);if(!z)return Promise.reject(new Error("no handler found"));const j=[],ie=(0,t.asPromise)(()=>z.provider.provideTasks(R.CancellationToken.None)).then(ae=>this.provideTasksInternal(H,j,z,ae));return new Promise(ae=>{ie.then(te=>{Promise.all(j).then(()=>{ae(te)})})})}async $resolveTask(q,H){const z=this._handlers.get(q);if(!z)return Promise.reject(new Error("no handler found"));if(H.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${H.definition.type}] cannot be resolved by provider of type [${z.type}].`);const j=await E.to(H,this._workspaceProvider,this._providedCustomExecutions2);if(!j)throw new Error("Unexpected: Task cannot be resolved.");const ie=await z.provider.resolveTask(j,R.CancellationToken.None);if(!ie)return;this.checkDeprecation(ie,z);const ae=E.from(ie,z.extension);if(!ae)throw new Error("Unexpected: Task cannot be resolved.");if(ie.definition!==j.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return s.is(ae.execution)&&await this.addCustomExecution(ae,ie,!0),await this.resolveTaskInternal(ae)}nextHandle(){return this._handleCounter++}async addCustomExecution(q,H,z){const j=await this._proxy.$createTaskId(q);!z&&!this._providedCustomExecutions2.has(j)&&(this._notProvidedCustomExecutions.add(j),this._activeCustomExecutions2.set(j,H.execution)),this._providedCustomExecutions2.set(j,H.execution)}async getTaskExecution(q,H){if(typeof q=="string"){const ie=this._taskExecutionPromises.get(q);if(!ie)throw new Error("Unexpected: The specified task is missing an execution");return ie}let z=this._taskExecutionPromises.get(q.id);if(z)return z;const j=new Promise((ie,ae)=>{function te(ue,be,pe){pe?ie(new k(ue,be.id,pe)):ae("Unexpected: Task does not exist.")}H?te(this,q,H):E.to(q.task,this._workspaceProvider,this._providedCustomExecutions2).then(ue=>te(this,q,ue))});return this._taskExecutionPromises.set(q.id,j),j.then(ie=>(this._taskExecutions.set(q.id,ie),ie),ie=>Promise.reject(ie))}checkDeprecation(q,H){q._deprecated&&this._deprecationService.report("Task.constructor",H.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(q){this._activeCustomExecutions2.get(q.id)&&this._activeCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.has(q.id)&&this._lastStartedTask!==q.id&&(this._providedCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.delete(q.id));let z=this._notProvidedCustomExecutions.values(),j=z.next();for(;!j.done;)!this._activeCustomExecutions2.has(j.value)&&this._lastStartedTask!==j.value&&(this._providedCustomExecutions2.delete(j.value),this._notProvidedCustomExecutions.delete(j.value)),j=z.next()}};y=xe([$e(0,i.IExtHostRpcService),$e(1,h.IExtHostInitDataService),$e(2,I.IExtHostWorkspace),$e(3,D.IExtHostDocumentsAndEditors),$e(4,T.IExtHostConfiguration),$e(5,b.IExtHostTerminalService),$e(6,M.ILogService),$e(7,C.IExtHostApiDeprecationService)],y),e.ExtHostTaskBase=y;let O=class extends y{constructor(q,H,z,j,ie,ae,te,ue){super(q,H,z,j,ie,ae,te,ue);this.registerTaskSystem(o.Schemas.vscodeRemote,{scheme:o.Schemas.vscodeRemote,authority:"",platform:m.PlatformToString(0)})}async executeTask(q,H){if(!H.execution)throw new Error("Tasks to execute must include an execution");const z=E.from(H,q);if(z===void 0)throw new Error("Task is not valid");if(s.is(z.execution))await this.addCustomExecution(z,H,!1);else throw new u.NotSupportedError;const j=await this.getTaskExecution(await this._proxy.$getTaskExecution(z),H);return this._proxy.$executeTask(z).catch(ie=>{throw new Error(ie)}),j}provideTasksInternal(q,H,z,j){const ie=[];if(j)for(let ae of j){this.checkDeprecation(ae,z),(!ae.definition||!q[ae.definition.type])&&this._logService.warn(`The task [${ae.source}, ${ae.name}] uses an undefined task type. The task will be ignored in the future.`);const te=E.from(ae,z.extension);te&&s.is(te.execution)?(ie.push(te),H.push(this.addCustomExecution(te,ae,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ie,extension:z.extension}}async resolveTaskInternal(q){if(s.is(q.execution))return q;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(q,H){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,H,z){}};O=xe([$e(0,i.IExtHostRpcService),$e(1,h.IExtHostInitDataService),$e(2,I.IExtHostWorkspace),$e(3,D.IExtHostDocumentsAndEditors),$e(4,T.IExtHostConfiguration),$e(5,b.IExtHostTerminalService),$e(6,M.ILogService),$e(7,C.IExtHostApiDeprecationService)],O),e.WorkerExtHostTask=O,e.IExtHostTask=(0,l.createDecorator)("IExtHostTask")}),define(ye[211],Se([0,1,16,73,29,76,22,11,17,24,9,13,2,232,127,79,47,88,210,41]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i,h,l,o,m,M,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let u=class{constructor(d,p,E,v){this.configurationService=d,this.workspaceContextService=p,this.editorGroupsService=E,this.pathService=v}text(d,p,E={}){d=this.getContentPattern(d,E);const v=this.configurationService.getValue(),k=p&&p.some(y=>!this.configurationService.getValue({resource:y}).search.useRipgrep);return{...this.commonQuery(p?.map(m.toWorkspaceFolder),E),type:2,contentPattern:d,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,usePCRE2:v.search.usePCRE2||k||!1,beforeContext:E.beforeContext,afterContext:E.afterContext,userDisabledExcludesAndIgnoreFiles:E.disregardExcludeSettings&&E.disregardIgnoreFiles}}getContentPattern(d,p){const E=this.configurationService.getValue();d.isRegExp&&(d.pattern=d.pattern.replace(/\r?\n/g,"\\n"));const v={...d,wordSeparators:E.editor.wordSeparators};return this.isCaseSensitive(d,p)&&(v.isCaseSensitive=!0),this.isMultiline(d)&&(v.isMultiline=!0),v}file(d,p={}){return{...this.commonQuery(d,p),type:1,filePattern:p.filePattern?p.filePattern.trim():p.filePattern,exists:p.exists,sortByScore:p.sortByScore,cacheKey:p.cacheKey}}handleIncludeExclude(d,p){return d?(d=Array.isArray(d)?d.map(n):n(d),p?this.parseSearchPaths(d):{pattern:a(...Array.isArray(d)?d:[d])}):{}}commonQuery(d=[],p={}){const E=this.handleIncludeExclude(p.includePattern,p.expandPatterns),v=this.handleIncludeExclude(p.excludePattern,p.expandPatterns),k=d.length>1,L=(E.searchPaths&&E.searchPaths.length?E.searchPaths.map(U=>this.getFolderQueryForSearchPath(U,p,v)):d.map(U=>this.getFolderQueryForRoot(U,p,v,k))).filter(U=>!!U),y={_reason:p._reason,folderQueries:L,usingSearchPaths:!!(E.searchPaths&&E.searchPaths.length),extraFileResources:p.extraFileResources,excludePattern:v.pattern,includePattern:E.pattern,onlyOpenEditors:p.onlyOpenEditors,maxResults:p.maxResults};if(p.onlyOpenEditors){const q=r.coalesce(r.flatten(this.editorGroupsService.groups.map(z=>z.editors.map(j=>j.resource)))).filter(z=>(0,w.pathIncludedInQuery)(y,z.fsPath)),H=this.commonQueryFromFileList(q);return{...y,...H}}const O=p.extraFileResources&&p.extraFileResources.filter(U=>(0,w.pathIncludedInQuery)(y,U.fsPath));return y.extraFileResources=O&&O.length?O:void 0,y}commonQueryFromFileList(d){const p=[],E=new A.ResourceMap,v={};let k=!1;return d.forEach(L=>{if(L.scheme===I.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(L)){const O=this.workspaceContextService.getWorkspaceFolder(L)?.uri??L.with({path:D.dirname(L.fsPath)});let U=E.get(O);U||(k=!0,U={folder:O,includePattern:{}},p.push(U),E.set(O,U));const q=D.relative(O.fsPath,L.fsPath);(0,b.assertIsDefined)(U.includePattern)[q.replace(/\\/g,"/")]=!0}else L.fsPath&&(k=!0,v[L.fsPath]=!0)}),{folderQueries:p,includePattern:v,usingSearchPaths:!0,excludePattern:k?void 0:{"**/*":!0}}}isCaseSensitive(d,p){if(p.isSmartCase){if(d.isRegExp){if(R.containsUppercaseCharacter(d.pattern,!0))return!0}else if(R.containsUppercaseCharacter(d.pattern))return!0}return!!d.isCaseSensitive}isMultiline(d){return d.isMultiline||d.isRegExp&&(0,h.isMultilineRegexSource)(d.pattern)||d.pattern.indexOf(`
`)>=0?!0:!!d.isMultiline}parseSearchPaths(d){const p=H=>D.isAbsolute(H)||/^\.\.?([\/\\]|$)/.test(H),v=(Array.isArray(d)?d:F(d)).map(H=>{const z=this.pathService.resolvedUserHome;return z?(0,P.untildify)(H,z.scheme===I.Schemas.file?z.fsPath:z.path):H}),k=t.groupBy(v,H=>p(H)?"searchPaths":"exprSegments"),L=(k.exprSegments||[]).map(H=>R.rtrim(H,"/")).map(H=>R.rtrim(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),c(H))),y={},O=this.expandSearchPathPatterns(k.searchPaths||[]);O&&O.length&&(y.searchPaths=O);const U=r.flatten(L),q=a(...U);return q&&(y.pattern=q),y}getExcludesForFolder(d,p){return p.disregardExcludeSettings?void 0:(0,w.getExcludes)(d,!p.disregardSearchExcludeSettings)}expandSearchPathPatterns(d){if(!d||!d.length)return[];const p=r.flatten(d.map(v=>{let{pathPortion:k,globPortion:L}=_(v);L&&(L=f(L));const y=this.expandOneSearchPath(k);return r.flatten(y.map(O=>this.resolveOneSearchPathPattern(O,L)))})),E=new Map;return p.forEach(v=>{const k=v.searchPath.toString(),L=E.get(k);L?v.pattern&&(L.pattern=L.pattern||{},L.pattern[v.pattern]=!0):E.set(k,{searchPath:v.searchPath,pattern:v.pattern?a(v.pattern):void 0})}),Array.from(E.values())}expandOneSearchPath(d){if(D.isAbsolute(d)){const p=this.workspaceContextService.getWorkspace().folders;return p[0]&&p[0].uri.scheme!==I.Schemas.file?[{searchPath:p[0].uri.with({path:d})}]:[{searchPath:i.URI.file(D.normalize(d))}]}if(this.workspaceContextService.getWorkbenchState()===2){const p=this.workspaceContextService.getWorkspace().folders[0].uri;if(d=n(d),d.startsWith("../")||d===".."){const v=D.posix.resolve(p.path,d);return[{searchPath:p.with({path:v})}]}const E=f(d);return[{searchPath:p,pattern:E}]}else{if(d==="./"||d===".\\")return[];{const p=d.replace(/^\.[\/\\]/,""),v=this.workspaceContextService.getWorkspace().folders.map(k=>{const L=p.match(new RegExp(`^${R.escapeRegExpCharacters(k.name)}(?:/(.*)|$)`));return L?{match:L,folder:k}:null}).filter(b.isDefined);if(v.length)return v.map(k=>{const L=k.match[1];return{searchPath:k.folder.uri,pattern:L&&f(L)}});{const k=d.match(/\.[\/\\](.+)[\/\\]?/),L=k?k[1]:d,y=l.localize(0,null,L);throw new Error(y)}}}}resolveOneSearchPathPattern(d,p){const E=d.pattern&&p?`${d.pattern}/${p}`:d.pattern||p,v=[{searchPath:d.searchPath,pattern:E}];return E&&!E.endsWith("**")&&v.push({searchPath:d.searchPath,pattern:E+"/**"}),v}getFolderQueryForSearchPath(d,p,E){const v=this.getFolderQueryForRoot((0,m.toWorkspaceFolder)(d.searchPath),p,E,!1);return v?{...v,includePattern:d.pattern}:null}getFolderQueryForRoot(d,p,E,v){let k;const L=i.URI.isUri(d)?d:d.uri;if(E.searchPaths){const H=E.searchPaths.filter(z=>(0,T.isEqual)(z.searchPath,L))[0];if(H&&!H.pattern)return null;H&&(k=H.pattern)}const y=this.configurationService.getValue({resource:L}),U={...this.getExcludesForFolder(y,p)||{},...k||{}},q=i.URI.isUri(d)?(0,T.basename)(d):d.name;return{folder:L,folderName:v?q:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:y.files&&y.files.encoding,disregardIgnoreFiles:typeof p.disregardIgnoreFiles=="boolean"?p.disregardIgnoreFiles:!y.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof p.disregardGlobalIgnoreFiles=="boolean"?p.disregardGlobalIgnoreFiles:!y.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof p.disregardParentIgnoreFiles=="boolean"?p.disregardParentIgnoreFiles:!y.search.useParentIgnoreFiles,ignoreSymlinks:typeof p.ignoreSymlinks=="boolean"?p.ignoreSymlinks:!y.search.followSymlinks}}};u=xe([$e(0,o.IConfigurationService),$e(1,m.IWorkspaceContextService),$e(2,M.IEditorGroupsService),$e(3,C.IPathService)],u),e.QueryBuilder=u;function _(s){const d=s.match(/[\*\{\}\(\)\[\]\?]/);if(d){const p=d.index,E=s.substr(0,p).match(/[/|\\][^/\\]*$/);if(E){let v=s.substr(0,E.index);return v.match(/[/\\]/)||(v+="/"),{pathPortion:v,globPortion:s.substr((E.index||0)+1)}}}return{pathPortion:s}}function a(...s){return s.length?s.reduce((d,p)=>(d[p]=!0,d),Object.create(null)):void 0}function F(s){return S.splitGlobAware(s,",").map(d=>d.trim()).filter(d=>!!d.length)}function c(s){return[`**/${s}/**`,`**/${s}`].map(p=>p.replace(/\*\*\/\*\*/g,"**"))}function n(s){return s.replace(/\\/g,"/")}function f(s){return n(s).replace(/^\.\//,"").replace(/\/+$/g,"")}function g(s,d){s=r.distinct(s,v=>v.toString());const p=[],E=d.getWorkspace();return s&&s.forEach(v=>{let k;if(d.getWorkbenchState()===2)k=(0,T.relativePath)(E.folders[0].uri,v),k&&k!=="."&&(k="./"+k);else{const L=d.getWorkspaceFolder(v);if(L){const y=L.name;if(E.folders.filter(U=>U.name===y).length===1){const U=(0,T.relativePath)(L.uri,v);U===""?k=`./${L.name}`:k=`./${L.name}/${U}`}else k=v.fsPath}}k&&p.push(k)}),p}e.resolveResourcesForSearchIncludes=g}),define(ye[212],Se([0,1,24,2,20,15,3,211,41,47]),function(Z,e,r,t,S,P,A,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function b(o,m){const M=m.activationEvents;if(!M)return Promise.resolve(void 0);const C=[],w=[];for(const n of M)if(/^workspaceContains:/.test(n)){const f=n.substr("workspaceContains:".length);f.indexOf("*")>=0||f.indexOf("?")>=0||o.forceUsingSearch?w.push(f):C.push(f)}if(C.length===0&&w.length===0)return Promise.resolve(void 0);let u;const _=new Promise((n,f)=>{u=n}),a=n=>u({activationEvent:n}),F=Promise.all(C.map(n=>i(o,n,a))).then(()=>{}),c=h(o,m.identifier,w,a);return Promise.all([F,c]).then(()=>{u(void 0)}),_}e.checkActivateWorkspaceContainsExtension=b;async function i(o,m,M){for(const C of o.folders)if(await o.exists(r.joinPath(t.URI.revive(C),m))){M(`workspaceContains:${m}`);return}}async function h(o,m,M,C){if(M.length===0)return Promise.resolve(void 0);const w=new S.CancellationTokenSource,u=o.checkExists(o.folders,M,w.token),_=setTimeout(async()=>{w.cancel(),o.logService.info(`Not activating extension '${m.value}': Timed out while searching for 'workspaceContains' pattern ${M.join(",")}`)},R);let a=!1;try{a=await u}catch(F){P.isCancellationError(F)||P.onUnexpectedError(F)}w.dispose(),clearTimeout(_),a&&C(`workspaceContains:${M.join(",")}`)}function l(o,m,M,C){const w=o.get(A.IInstantiationService),u=o.get(D.ISearchService),a=w.createInstance(I.QueryBuilder).file(m.map(F=>(0,T.toWorkspaceFolder)(t.URI.revive(F))),{_reason:"checkExists",includePattern:M,exists:!0});return u.fileSearch(a,C).then(F=>!!F.limitHit,F=>P.isCancellationError(F)?!1:Promise.reject(F))}e.checkGlobFileExists=l});var Xe=this&&this.__classPrivateFieldSet||function(Z,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(Z,r):S?S.value=r:e.set(Z,r),r},Ie=this&&this.__classPrivateFieldGet||function(Z,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[33],Se([0,1,119,17,72,24,10,6,22,2,12,5,32,171,70,31,26,169,15,25,21,146,7,82,3,28,71,14,59,63,40,4,212,67,148,11]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i,h,l,o,m,M,C,w,u,_,a,F,c,n,f,g,s,d,p,E,v,k,L,y){"use strict";var O,U,q;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,c.createDecorator)("IHostUtils");let H=class Gi extends I.Disposable{constructor(te,ue,be,pe,me,oe,Ee,Pe,Oe,je){super();this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ue,this._extHostContext=be,this._initData=Ee,this._extHostWorkspace=pe,this._extHostConfiguration=me,this._logService=oe,this._extHostTunnelService=Oe,this._extHostTerminalService=je,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(b.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(b.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(b.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._registry=new M.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new l.ExtHostStorage(this._extHostContext),this._secretState=new k.ExtHostSecretState(this._extHostContext),this._storagePath=Pe,this._instaService=te.createChild(new s.ServiceCollection([l.IExtHostStorage,this._storage],[k.IExtHostSecretState,this._secretState]));const st=new Set;this._initData.hostExtensions.forEach(et=>st.add(w.ExtensionIdentifier.toKey(et))),this._activator=this._register(new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(et,tt,$)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(et,C.transformErrorForSerialization(tt),$)},actualActivateExtension:async(et,tt)=>{if(st.has(w.ExtensionIdentifier.toKey(et)))return await this._mainThreadExtensionsProxy.$activateExtension(et,tt),new h.HostExtension;const $=this._registry.getExtensionDescription(et);return this._activateExtension($,tt)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),S.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(te){C.onUnexpectedError(te)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let te=[];try{te=this._registry.getAllExtensionDescriptions().map(me=>me.identifier).filter(me=>this.isActivated(me)).map(me=>this._deactivate(me))}catch{}await Promise.all(te)}isActivated(te){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(te):!1}_activateByEvent(te,ue){return this._activator.activateByEvent(te,ue)}_activateById(te,ue){return this._activator.activateById(te,ue)}activateByIdWithErrors(te,ue){return this._activateById(te,ue).then(()=>{const be=this._activator.getActivatedExtension(te);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(te=>this._registry)}getExtensionExports(te){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(te).exports:null}async _realPathExtensionUri(te){if(te.scheme!==y.Schemas.file)return te;const ue=await this._hostUtils.realpath(te.fsPath);return T.URI.file(ue)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const te=D.TernarySearchTree.forUris(ue=>P.extUriBiasedIgnorePathCase.ignorePathCasing(ue));for(const ue of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(ue)){const be=await this._realPathExtensionUri(ue.extensionLocation);te.set(be,ue)}return te})()),this._extensionPathIndex}_deactivate(te){let ue=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(te))return ue;const be=this._activator.getActivatedExtension(te);if(!be)return ue;try{typeof be.module.deactivate=="function"&&(ue=Promise.resolve(be.module.deactivate()).then(void 0,pe=>(this._logService.error(pe),Promise.resolve(void 0))))}catch(pe){this._logService.error(`An error occurred when deactivating the extension '${te.value}':`),this._logService.error(pe)}try{(0,I.dispose)(be.subscriptions)}catch(pe){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${te.value}':`),this._logService.error(pe)}return ue}async _activateExtension(te,ue){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier),this._doActivateExtension(te,ue).then(be=>{const pe=be.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(te.identifier,pe.codeLoadingTime,pe.activateCallTime,pe.activateResolvedTime,ue),this._logExtensionActivationTimes(te,ue,"success",pe),be},be=>{throw this._logExtensionActivationTimes(te,ue,"failure"),be})}_logExtensionActivationTimes(te,ue,be,pe){const me=z(te,ue);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...me,...pe||{},outcome:be})}_doActivateExtension(te,ue){const be=z(te,ue);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",be);const pe=this._getEntryPoint(te);if(!pe)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${te.identifier.value}, startup: ${ue.startup}, activationEvent: '${ue.activationEvent}'${te.identifier.value!==ue.extensionId.value?`, root cause: ${ue.extensionId.value}`:""}`),this._logService.flush();const me=new h.ExtensionActivationTimesBuilder(ue.startup);return Promise.all([this._loadCommonJSModule(te.identifier,(0,P.joinPath)(te.extensionLocation,pe),me),this._loadExtensionContext(te)]).then(oe=>(S.mark(`code/extHost/willActivateExtension/${te.identifier.value}`),Gi._callActivate(this._logService,te.identifier,oe[0],oe[1],me))).then(oe=>(S.mark(`code/extHost/didActivateExtension/${te.identifier.value}`),oe))}_loadExtensionContext(te){const ue=new _.ExtensionGlobalMemento(te,this._storage),be=new _.ExtensionMemento(te.identifier.value,!1,this._storage),pe=new L.ExtensionSecrets(te,this._secretState),me=te.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?a.ExtensionMode.Test:a.ExtensionMode.Development:a.ExtensionMode.Production,oe=this._initData.remote.isRemote?a.ExtensionKind.Workspace:a.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${te.identifier.value}`),Promise.all([ue.whenReady,be.whenReady,this._storagePath.whenReady]).then(()=>{const Ee=this;let Pe,Oe;const je=(0,m.isProposedApiEnabled)(te,"ipc")?this._initData.messagePorts?.get(w.ExtensionIdentifier.toKey(te.identifier)):void 0;return Object.freeze({globalState:ue,workspaceState:be,secrets:pe,subscriptions:[],get extensionUri(){return te.extensionLocation},get extensionPath(){return te.extensionLocation.fsPath},asAbsolutePath(st){return t.join(te.extensionLocation.fsPath,st)},get storagePath(){return Ee._storagePath.workspaceValue(te)?.fsPath},get globalStoragePath(){return Ee._storagePath.globalValue(te).fsPath},get logPath(){return t.join(Ee._initData.logsLocation.fsPath,te.identifier.value)},get logUri(){return T.URI.joinPath(Ee._initData.logsLocation,te.identifier.value)},get storageUri(){return Ee._storagePath.workspaceValue(te)},get globalStorageUri(){return Ee._storagePath.globalValue(te)},get extensionMode(){return me},get extension(){return Pe===void 0&&(Pe=new j(Ee,te.identifier,te,oe)),Pe},get extensionRuntime(){return(0,m.checkProposedApiEnabled)(te,"extensionRuntime"),Ee.extensionRuntime},get environmentVariableCollection(){return Ee._extHostTerminalService.getEnvironmentVariableCollection(te)},get messagePassingProtocol(){if(!Oe){if(!je)return;const st=E.Event.buffer(E.Event.fromDOMEventEmitter(je,"message",et=>et.data));je.start(),Oe={onDidReceiveMessage:st,postMessage:je.postMessage.bind(je)}}return Oe}})})}static _callActivate(te,ue,be,pe,me){return be=be||{activate:void 0,deactivate:void 0},this._callActivateOptional(te,ue,be,pe,me).then(oe=>new h.ActivatedExtension(!1,null,me.build(),be,oe,pe.subscriptions))}static _callActivateOptional(te,ue,be,pe,me){if(typeof be.activate=="function")try{me.activateCallStart(),te.trace(`ExtensionService#_callActivateOptional ${ue.value}`);const oe=typeof global=="object"?global:self,Ee=be.activate.apply(oe,[pe]);return me.activateCallStop(),me.activateResolveStart(),Promise.resolve(Ee).then(Pe=>(me.activateResolveStop(),Pe))}catch(oe){return Promise.reject(oe)}else return Promise.resolve(be)}_activateOneStartupFinished(te,ue){this._activateById(te.identifier,{startup:!1,extensionId:te.identifier,activationEvent:ue}).then(void 0,be=>{this._logService.error(be)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(S.getMarks());for(const te of this._registry.getAllExtensionDescriptions())if(te.activationEvents)for(const ue of te.activationEvents)ue==="onStartupFinished"&&this._activateOneStartupFinished(te,ue)}_handleEagerExtensions(){const te=this._activateByEvent("*",!0).then(void 0,me=>{this._logService.error(me)});this._register(this._extHostWorkspace.onDidChangeWorkspace(me=>this._handleWorkspaceContainsEagerExtensions(me.added)));const ue=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],be=this._handleWorkspaceContainsEagerExtensions(ue),pe=Promise.all([te,be]).then(()=>{});return Promise.race([pe,(0,A.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),pe}_handleWorkspaceContainsEagerExtensions(te){return te.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ue=>this._handleWorkspaceContainsEagerExtension(te,ue))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(te,ue){if(this.isActivated(ue.identifier))return;const be=!this._initData.remote.isRemote&&!!this._initData.remote.authority,pe={logService:this._logService,folders:te.map(oe=>oe.uri),forceUsingSearch:be,exists:oe=>this._hostUtils.exists(oe.fsPath),checkExists:(oe,Ee,Pe)=>this._mainThreadWorkspaceProxy.$checkExists(oe,Ee,Pe)},me=await(0,v.checkActivateWorkspaceContainsExtension)(pe,ue);if(!!me)return this._activateById(ue.identifier,{startup:!0,extensionId:ue.identifier,activationEvent:me.activationEvent}).then(void 0,oe=>this._logService.error(oe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(te){throw console.error(te),te}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:te,extensionTestsLocationURI:ue}=this._initData.environment;if(!te||!ue)throw new Error(r.localize(0,null));const be=await this._loadCommonJSModule(null,ue,new h.ExtensionActivationTimesBuilder(!1));if(!be||typeof be.run!="function")throw new Error(r.localize(1,null,ue.toString()));return new Promise((pe,me)=>{const oe=(Oe,je)=>{Oe?me(Oe):pe(typeof je=="number"&&je>0?1:0)},Ee=(0,P.originalFSPath)(ue),Pe=be.run(Ee,oe);Pe&&Pe.then&&Pe.then(()=>{pe(0)}).catch(Oe=>{me(Oe instanceof Error&&Oe.stack?Oe.stack:String(Oe))})})}async $extensionTestsExit(te){this._logService.info(`Extension host terminating: test runner requested exit with code ${te}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${te}`),this._logService.flush(),this._hostUtils.exit(te)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(te,ue){return this._resolvers[te]=ue,(0,I.toDisposable)(()=>{delete this._resolvers[te]})}async _activateAndGetResolver(te){const ue=te.indexOf("+");if(ue===-1)throw new Error("Not an authority that can be resolved!");const be=te.substr(0,ue);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this._resolvers[be]}}async $resolveAuthority(te,ue){this._logService.info(`$resolveAuthority invoked for authority (${ie(te)})`);const{authorityPrefix:be,resolver:pe}=await this._activateAndGetResolver(te);if(!pe)return{type:"error",error:{code:F.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${be}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(pe)),S.mark(`code/extHost/willResolveAuthority/${be}`);const me=await pe.resolve(te,{resolveAttempt:ue});S.mark(`code/extHost/didResolveAuthorityOK/${be}`);const oe={authority:te,host:me.host,port:me.port,connectionToken:me.connectionToken},Ee={extensionHostEnv:me.extensionHostEnv,isTrusted:me.isTrusted,authenticationSession:me.authenticationSessionForInitializingExtensions?{id:me.authenticationSessionForInitializingExtensions.id,providerId:me.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:oe,options:Ee,tunnelInformation:{environmentTunnels:me.environmentTunnels,features:me.tunnelFeatures}}}}catch(me){if(S.mark(`code/extHost/didResolveAuthorityError/${be}`),me instanceof a.RemoteAuthorityResolverError)return{type:"error",error:{code:me._code,message:me._message,detail:me._detail}};throw me}}async $getCanonicalURI(te,ue){this._logService.info(`$getCanonicalURI invoked for authority (${ie(te)})`);const{authorityPrefix:be,resolver:pe}=await this._activateAndGetResolver(te);if(!pe)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${be}`);const me=T.URI.revive(ue);if(typeof pe.getCanonicalURI=="undefined")return me;const oe=await(0,A.asPromise)(()=>pe.getCanonicalURI(me));return oe||me}$startExtensionHost(te){return this._registry.keepOnly(te),this._startExtensionHost()}$activateByEvent(te,ue){return ue===1?this._activateByEvent(te,!1):this._readyToRunExtensions.wait().then(be=>this._activateByEvent(te,!1))}async $activate(te,ue){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(te)?(await this._activateById(te,ue),!0):!1}async $deltaExtensions(te,ue){te.forEach(pe=>pe.extensionLocation=T.URI.revive(pe.extensionLocation));const be=await this.getExtensionPathIndex();return await Promise.all(ue.map(async pe=>{const me=this._registry.getExtensionDescription(pe);me&&be.delete(await this._realPathExtensionUri(me.extensionLocation))})),await Promise.all(te.map(async pe=>{const me=await this._realPathExtensionUri(pe.extensionLocation);be.set(me,pe)})),this._registry.deltaExtensions(te,ue),Promise.resolve(void 0)}async $test_latency(te){return te}async $test_up(te){return te.byteLength}async $test_down(te){let ue=u.VSBuffer.alloc(te),be=Math.random()%256;for(let pe=0;pe<te;pe++)ue.writeUInt8(be,pe);return ue}async $updateRemoteConnectionData(te){this._remoteConnectionData=te,this._onDidChangeRemoteConnectionData.fire()}};H=xe([$e(0,c.IInstantiationService),$e(1,e.IHostUtils),$e(2,g.IExtHostRpcService),$e(3,o.IExtHostWorkspace),$e(4,i.IExtHostConfiguration),$e(5,R.ILogService),$e(6,n.IExtHostInitDataService),$e(7,f.IExtensionStoragePaths),$e(8,d.IExtHostTunnelService),$e(9,p.IExtHostTerminalService)],H),e.AbstractExtHostExtensionService=H;function z(ae,te){return{id:ae.identifier.value,name:ae.name,extensionVersion:ae.version,publisherDisplayName:ae.publisher,activationEvents:ae.activationEvents?ae.activationEvents.join(","):null,isBuiltin:ae.isBuiltin,reason:te.activationEvent,reasonId:te.extensionId.value}}e.IExtHostExtensionService=(0,c.createDecorator)("IExtHostExtensionService");class j{constructor(te,ue,be,pe){O.set(this,void 0),U.set(this,void 0),q.set(this,void 0),Xe(this,O,te,"f"),Xe(this,U,ue,"f"),Xe(this,q,be.identifier,"f"),this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=t.normalize((0,P.originalFSPath)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=pe}get isActive(){return Ie(this,O,"f").isActivated(Ie(this,q,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ie(this,O,"f").getExtensionExports(Ie(this,q,"f"))}activate(){return Ie(this,O,"f").activateByIdWithErrors(Ie(this,q,"f"),{startup:!1,extensionId:Ie(this,U,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=j,O=new WeakMap,U=new WeakMap,q=new WeakMap;function ie(ae){const te=ae.indexOf("+");return te===-1?ae:ae.substring(0,te)}}),define(ye[97],Se([0,1,17,2,4,10,5,7,155,31,33,49,162,32,156,14,3,13,87,69]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i,h,l,o,m,M,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,m.createDecorator)("IExtHostDebugService");let u=class{constructor(s,d,p,E,v,k){this._workspaceService=d,this._extensionService=p,this._editorsService=E,this._configurationService=v,this._editorTabs=k,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new S.Emitter,this._onDidTerminateDebugSession=new S.Emitter,this._onDidChangeActiveDebugSession=new S.Emitter,this._onDidReceiveDebugSessionCustomEvent=new S.Emitter,this._debugServiceProxy=s.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new S.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new a(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(L=>{L.onDidChange(y=>{this.registerAllDebugTypes(L)}),this.registerAllDebugTypes(L)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(s,d){const p=s;if(typeof p.sourceReference=="number"&&p.sourceReference>0){let E=`debug:${encodeURIComponent(p.path||"")}`,v="?";return d&&(E+=`${v}session=${encodeURIComponent(d.id)}`,v="&"),E+=`${v}ref=${p.sourceReference}`,t.URI.parse(E)}else{if(p.path)return t.URI.file(p.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(s){const d=[];for(const p of s.getAllExtensionDescriptions())if(p.contributes){const E=p.contributes.debuggers;if(E&&E.length>0)for(const v of E)(0,l.isDebuggerMainContribution)(v)&&d.push(v.type)}this._debugServiceProxy.$registerDebugTypes(d)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const s=[];return this._breakpoints.forEach(d=>s.push(d)),s}addBreakpoints(s){this.startBreakpoints();const d=s.filter(v=>{const k=v.id;return this._breakpoints.has(k)?!1:(this._breakpoints.set(k,v),!0)});this.fireBreakpointChanges(d,[],[]);const p=[],E=new Map;for(const v of d)if(v instanceof I.SourceBreakpoint){let k=E.get(v.location.uri.toString());k||(k={type:"sourceMulti",uri:v.location.uri,lines:[]},E.set(v.location.uri.toString(),k),p.push(k)),k.lines.push({id:v.id,enabled:v.enabled,condition:v.condition,hitCondition:v.hitCondition,logMessage:v.logMessage,line:v.location.range.start.line,character:v.location.range.start.character})}else v instanceof I.FunctionBreakpoint&&p.push({type:"function",id:v.id,enabled:v.enabled,hitCondition:v.hitCondition,logMessage:v.logMessage,condition:v.condition,functionName:v.functionName});return this._debugServiceProxy.$registerBreakpoints(p)}removeBreakpoints(s){this.startBreakpoints();const d=s.filter(k=>this._breakpoints.delete(k.id));this.fireBreakpointChanges([],d,[]);const p=d.filter(k=>k instanceof I.SourceBreakpoint).map(k=>k.id),E=d.filter(k=>k instanceof I.FunctionBreakpoint).map(k=>k.id),v=d.filter(k=>k instanceof I.DataBreakpoint).map(k=>k.id);return this._debugServiceProxy.$unregisterBreakpoints(p,E,v)}startDebugging(s,d,p){return this._debugServiceProxy.$startDebugging(s?s.uri:void 0,d,{parentSessionID:p.parentSession?p.parentSession.id:void 0,lifecycleManagedByParent:p.lifecycleManagedByParent,repl:p.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:p.noDebug,compact:p.compact,debugUI:p.debugUI,suppressSaveBeforeStart:p.suppressSaveBeforeStart})}stopDebugging(s){return this._debugServiceProxy.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,d,p){if(!d)return new I.Disposable(()=>{});const E=this._configProviderHandleCounter++;return this._configProviders.push({type:s,handle:E,provider:d}),this._debugServiceProxy.$registerDebugConfigurationProvider(s,p,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,E),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(v=>v.provider!==d),this._debugServiceProxy.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(s,d,p){if(!p)return new I.Disposable(()=>{});if(!this.definesDebugType(s,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.getAdapterDescriptorFactoryByType(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:d,handle:E,factory:p}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(d,E),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(v=>v.factory!==p),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(s,d){if(!d)return new I.Disposable(()=>{});const p=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:s,handle:p,factory:d}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(E=>E.factory!==d)})}async $runInTerminal(s,d){return Promise.resolve(void 0)}async $substituteVariables(s,d){if(!this._variableResolver){const[v,k]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(v||[],this._editorsService,k)}let p;const E=await this.getFolder(s);return E&&(p={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(p,d)}createDebugAdapter(s,d){if(s.type==="implementation")return new n(s.implementation)}createSignService(){}async $startDASession(s,d){const p=this,E=await this.getSession(d);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(E.type),E).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const k=this.convertToDto(v),L=this.createDebugAdapter(k,E);if(!L)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const y=L;return this._debugAdapters.set(s,y),this.getDebugAdapterTrackers(E).then(O=>(O&&this._debugAdaptersTrackers.set(s,O),y.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const q=U,H={type:"response",seq:0,command:q.command,request_seq:q.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const z=await this._signService.sign(q.arguments.value);H.body={signature:z},y.sendResponse(H)}else throw new Error("no signer")}catch(z){H.success=!1,H.message=z.message,y.sendResponse(H)}}else O&&O.onDidSendMessage&&O.onDidSendMessage(U),U=(0,l.convertToVSCPaths)(U,!0),p._debugServiceProxy.$acceptDAMessage(s,U)}),y.onError(U=>{O&&O.onError&&O.onError(U),this._debugServiceProxy.$acceptDAError(s,U.name,U.message,U.stack)}),y.onExit(U=>{O&&O.onExit&&O.onExit((0,M.withNullAsUndefined)(U),void 0),this._debugServiceProxy.$acceptDAExit(s,(0,M.withNullAsUndefined)(U),void 0)}),O&&O.onWillStartSession&&O.onWillStartSession(),y.startSession()))})}$sendDAMessage(s,d){d=(0,l.convertToDAPaths)(d,!1);const p=this._debugAdaptersTrackers.get(s);p&&p.onWillReceiveMessage&&p.onWillReceiveMessage(d);const E=this._debugAdapters.get(s);E&&E.sendMessage(d)}$stopDASession(s){const d=this._debugAdaptersTrackers.get(s);this._debugAdaptersTrackers.delete(s),d&&d.onWillStopSession&&d.onWillStopSession();const p=this._debugAdapters.get(s);return this._debugAdapters.delete(s),p?p.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const d=[],p=[],E=[];if(s.added)for(const v of s.added){const k=v.id;if(k&&!this._breakpoints.has(k)){let L;if(v.type==="function")L=new I.FunctionBreakpoint(v.functionName,v.enabled,v.condition,v.hitCondition,v.logMessage);else if(v.type==="data")L=new I.DataBreakpoint(v.label,v.dataId,v.canPersist,v.enabled,v.hitCondition,v.condition,v.logMessage);else{const y=t.URI.revive(v.uri);L=new I.SourceBreakpoint(new I.Location(y,new I.Position(v.line,v.character)),v.enabled,v.condition,v.hitCondition,v.logMessage)}L._id=k,this._breakpoints.set(k,L),d.push(L)}}if(s.removed)for(const v of s.removed){const k=this._breakpoints.get(v);k&&(this._breakpoints.delete(v),p.push(k))}if(s.changed){for(const v of s.changed)if(v.id){const k=this._breakpoints.get(v.id);if(k){if(k instanceof I.FunctionBreakpoint&&v.type==="function"){const L=k;L.enabled=v.enabled,L.condition=v.condition,L.hitCondition=v.hitCondition,L.logMessage=v.logMessage,L.functionName=v.functionName}else if(k instanceof I.SourceBreakpoint&&v.type==="source"){const L=k;L.enabled=v.enabled,L.condition=v.condition,L.hitCondition=v.hitCondition,L.logMessage=v.logMessage,L.location=new I.Location(t.URI.revive(v.uri),new I.Position(v.line,v.character))}E.push(k)}}}this.fireBreakpointChanges(d,p,E)}$provideDebugConfigurations(s,d,p){return(0,P.asPromise)(async()=>{const E=this.getConfigProviderByHandle(s);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const v=await this.getFolder(d);return E.provideDebugConfigurations(v,p)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(s,d,p,E){return(0,P.asPromise)(async()=>{const v=this.getConfigProviderByHandle(s);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.getFolder(d);return v.resolveDebugConfiguration(k,p,E)})}$resolveDebugConfigurationWithSubstitutedVariables(s,d,p,E){return(0,P.asPromise)(async()=>{const v=this.getConfigProviderByHandle(s);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.getFolder(d);return v.resolveDebugConfigurationWithSubstitutedVariables(k,p,E)})}async $provideDebugAdapter(s,d){const p=this.getAdapterDescriptorFactoryByHandle(s);if(!p)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.getSession(d);return this.getAdapterDescriptor(p,E).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.convertToDto(v)})}async $acceptDebugSessionStarted(s){const d=await this.getSession(s);this._onDidStartDebugSession.fire(d)}async $acceptDebugSessionTerminated(s){const d=await this.getSession(s);d&&(this._onDidTerminateDebugSession.fire(d),this._debugSessions.delete(d.id))}async $acceptDebugSessionActiveChanged(s){this._activeDebugSession=s?await this.getSession(s):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(s,d){const p=await this.getSession(s);p&&p._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(s,d){const E={session:await this.getSession(s),event:d.event,body:d.body};this._onDidReceiveDebugSessionCustomEvent.fire(E)}convertToDto(s){if(s instanceof I.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof I.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(s){const d=this._adapterFactories.filter(p=>p.type===s);if(d.length>0)return d[0].factory}getAdapterDescriptorFactoryByHandle(s){const d=this._adapterFactories.filter(p=>p.handle===s);if(d.length>0)return d[0].factory}getConfigProviderByHandle(s){const d=this._configProviders.filter(p=>p.handle===s);if(d.length>0)return d[0].provider}definesDebugType(s,d){if(s.contributes){const p=s.contributes.debuggers;if(p&&p.length>0){for(const E of p)if(E.label&&E.type&&E.type===d)return!0}}return!1}getDebugAdapterTrackers(s){const p=s.configuration.type,E=this._trackerFactories.filter(v=>v.type===p||v.type==="*").map(v=>(0,P.asPromise)(()=>v.factory.createDebugAdapterTracker(s)).then(k=>k,k=>null));return Promise.race([Promise.all(E).then(v=>{const k=v.filter(L=>!!L);if(k.length>0)return new c(k)}),new Promise((v,k)=>{const L=setTimeout(()=>{clearTimeout(L),k(new Error("timeout"))},1e3)})]).catch(v=>{})}async getAdapterDescriptor(s,d){const p=d.configuration.debugServer;if(typeof p=="number")return Promise.resolve(new I.DebugAdapterServer(p));if(s){const v=await this._extensionService.getExtensionRegistry();return(0,P.asPromise)(()=>s.createDebugAdapterDescriptor(d,this.daExecutableFromPackage(d,v))).then(k=>{if(k)return k})}const E=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(d,E))}daExecutableFromPackage(s,d){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(s,d,p){(s.length>0||d.length>0||p.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:s,removed:d,changed:p}))}async getSession(s){if(s)if(typeof s=="string"){const d=this._debugSessions.get(s);if(d)return d}else{let d=this._debugSessions.get(s.id);if(!d){const p=await this.getFolder(s.folderUri),E=s.parent?this._debugSessions.get(s.parent):void 0;d=new _(this._debugServiceProxy,s.id,s.type,s.name,p,s.configuration,E),this._debugSessions.set(d.id,d),this._debugServiceProxy.$sessionCached(d.id)}return d}throw new Error("cannot find session")}getFolder(s){if(s){const d=t.URI.revive(s);return this._workspaceService.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};u=xe([$e(0,o.IExtHostRpcService),$e(1,T.IExtHostWorkspace),$e(2,R.IExtHostExtensionService),$e(3,b.IExtHostDocumentsAndEditors),$e(4,h.IExtHostConfiguration),$e(5,w.IExtHostEditorTabs)],u),e.ExtHostDebugServiceBase=u;class _{constructor(s,d,p,E,v,k,L){this._debugServiceProxy=s,this._id=d,this._type=p,this._name=E,this._workspaceFolder=v,this._configuration=k,this._parentSession=L}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(s){this._name=s,this._debugServiceProxy.$setDebugSessionName(this._id,s)}get parentSession(){return this._parentSession}_acceptNameChanged(s){this._name=s}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(s,d){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,s,d)}getDebugProtocolBreakpoint(s){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,s.id)}}e.ExtHostDebugSession=_;class a{constructor(s){this.value=Object.freeze({append(d){s.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.ExtHostDebugConsole=a;class F extends i.AbstractVariableResolverService{constructor(s,d,p,E,v){function k(){if(d){const L=d.activeEditor();if(L)return L.document.uri;const y=E.tabs.filter(O=>O.isActive);if(y.length>0){const O=y[0].resource;return O&&(O.primary||O.secondary)?O.primary??O.secondary:y[0].resource}}}super({getFolderUri:L=>{const y=s.filter(O=>O.name===L);if(y&&y.length>0)return y[0].uri},getWorkspaceFolderCount:()=>s.length,getConfigurationValue:(L,y)=>p.getConfiguration(void 0,L).get(y),getAppRoot:()=>C.cwd(),getExecPath:()=>C.env.VSCODE_EXEC_PATH,getFilePath:()=>{const L=k();if(L)return r.normalize(L.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const L=k();if(L){const y=v.getWorkspaceFolder(L);if(y)return r.normalize(y.uri.fsPath)}}},getSelectedText:()=>{if(d){const L=d.activeEditor();if(L&&!L.selection.isEmpty)return L.document.getText(L.selection)}},getLineNumber:()=>{if(d){const L=d.activeEditor();if(L)return String(L.selection.end.line+1)}}},void 0,Promise.resolve(C.env))}}e.ExtHostVariableResolverService=F;class c{constructor(s){this.trackers=s}onWillStartSession(){this.trackers.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.trackers.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.trackers.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(s):void 0)}onWillStopSession(){this.trackers.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.trackers.forEach(d=>d.onError?d.onError(s):void 0)}onExit(s,d){this.trackers.forEach(p=>p.onExit?p.onExit(s,d):void 0)}}class n extends D.AbstractDebugAdapter{constructor(s){super();this.implementation=s,s.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.implementation.handleMessage(s)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let f=class extends u{constructor(s,d,p,E,v,k){super(s,d,p,E,v,k)}createVariableResolver(s,d,p){return new F(s,d,p,this._editorTabs)}};f=xe([$e(0,o.IExtHostRpcService),$e(1,T.IExtHostWorkspace),$e(2,R.IExtHostExtensionService),$e(3,b.IExtHostDocumentsAndEditors),$e(4,h.IExtHostConfiguration),$e(5,w.IExtHostEditorTabs)],f),e.WorkerExtHostDebugService=f}),define(ye[213],Se([0,1,72,2,5,32,26,25,14,28,3,33,87,12,9]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let o=class{constructor(_,a,F,c,n,f,g){this._apiFactory=_,this._extensionRegistry=a,this._instaService=F,this._extHostConfiguration=c,this._extHostExtensionService=n,this._initData=f,this._logService=g,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),r.mark("code/extHost/willWaitForConfig");const _=await this._extHostConfiguration.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new M(this._apiFactory,a,this._extensionRegistry,_,this._logService)),this.register(this._instaService.createInstance(C,a)),this.register(this._instaService.createInstance(m)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,a,this._initData.environment.appUriScheme))}register(_){if("nodeModuleName"in _)if(Array.isArray(_.nodeModuleName))for(let a of _.nodeModuleName)this._factories.set(a,_);else this._factories.set(_.nodeModuleName,_);typeof _.alternativeModuleName=="function"&&this._alternatives.push(a=>_.alternativeModuleName(a))}};o=xe([$e(2,R.IInstantiationService),$e(3,P.IExtHostConfiguration),$e(4,b.IExtHostExtensionService),$e(5,T.IExtHostInitDataService),$e(6,h.ILogService)],o),e.RequireInterceptor=o;let m=class Hi{constructor(_){if(_.environment.appRoot&&Hi.aliased.size){const a=(0,l.escapeRegExpCharacters)(this.forceForwardSlashes(_.environment.appRoot.fsPath)),F="[a-z0-9_.-]",c=`@${F}+\\/${F}+|${F}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${a}/${n}\\/)(${c})(.*)$`,"i")}}alternativeModuleName(_){if(!this.re)return;const a=this.re.exec(this.forceForwardSlashes(_));if(!a)return;const[,F,c,n]=a,f=Hi.aliased.get(c);if(f!==void 0)return console.warn(`${c} as been renamed to ${f}, please update your imports`),F+f+n}forceForwardSlashes(_){return _.replace(/\\/g,"/")}};m.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"]]),m=xe([$e(0,T.IExtHostInitDataService)],m);class M{constructor(_,a,F,c,n){this._apiFactory=_,this._extensionPaths=a,this._extensionRegistry=F,this._configProvider=c,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(_,a){const F=this._extensionPaths.findSubstr(a);if(F){let c=this._extApiImpl.get(I.ExtensionIdentifier.toKey(F.identifier));return c||(c=this._apiFactory(F,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(F.identifier),c)),c}if(!this._defaultApiImpl){let c="";this._extensionPaths.forEach((n,f)=>c+=`	${f} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${c}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let C=class{constructor(_,a,F){this._extensionPaths=_,this.nodeModuleName="keytar",this._mainThreadTelemetry=a.getProxy(S.MainContext.MainThreadTelemetry);const{environment:c}=F,n=a.getProxy(S.MainContext.MainThreadKeytar);if(c.appRoot){let f=c.appRoot.fsPath;i.platform==="win32"&&(f=f.replace(/\\/g,"/")),f[f.length-1]==="/"&&(f=f.substr(0,f.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${f}/node_modules.asar/keytar`),this.alternativeNames.add(`${f}/node_modules/keytar`)}this._impl={getPassword:(f,g)=>n.$getPassword(f,g),setPassword:(f,g,s)=>n.$setPassword(f,g,s),deletePassword:(f,g)=>n.$deletePassword(f,g),findPassword:f=>n.$findPassword(f),findCredentials(f){return n.$findCredentials(f)}}}load(_,a){const F=this._extensionPaths.findSubstr(a);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:F?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(_){const a=_.length;if(a<=7||!this.alternativeNames)return;const F=a-7;if((_.charAt(F)==="/"||_.charAt(F)==="\\")&&_.endsWith("keytar")&&(_=_.replace(/\\/g,"/"),this.alternativeNames.has(_)))return"keytar"}};C=xe([$e(1,D.IExtHostRpcService),$e(2,T.IExtHostInitDataService)],C);let w=class{constructor(_,a,F){this._extensionPaths=_,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=F.getProxy(S.MainContext.MainThreadTelemetry);const c=F.getProxy(S.MainContext.MainThreadWindow);this._impl=(n,f)=>{const g=t.URI.parse(n);return f?this.callOriginal(n,f):g.scheme==="http"||g.scheme==="https"?c.$openUri(g,n,{allowTunneling:!0}):g.scheme==="mailto"||g.scheme===this._appUriScheme?c.$openUri(g,n,{}):this.callOriginal(n,f)}}load(_,a,F){const c=this._extensionPaths.findSubstr(a);return c&&(this._extensionId=c.identifier.value,this.sendShimmingTelemetry()),this._original=F(_),this._impl}callOriginal(_,a){return this.sendNoForwardTelemetry(),this._original(_,a)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=xe([$e(2,D.IExtHostRpcService)],w)}),define(ye[214],Se([0,1,10,15,72,6,2,5,207,12,44,59,28,136,14,64,33,40]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i,h,l,o,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class C{constructor(u,_,a,F,c){this._disposables=new P.DisposableStore,this._isTerminating=!1,this._hostUtils=a,this._rpcProtocol=new D.RPCProtocol(u,null,F),_=C._transform(_,this._rpcProtocol);const n=new b.ServiceCollection(...(0,R.getSingletonServiceDescriptors)());n.set(i.IExtHostInitDataService,{_serviceBrand:void 0,..._,messagePorts:c}),n.set(l.IExtHostRpcService,new l.ExtHostRpcService(this._rpcProtocol)),n.set(o.IURITransformerService,new o.URITransformerService(F)),n.set(m.IHostUtils,a);const f=new h.InstantiationService(n,!0);this._disposables.add(f.invokeFunction(p=>p.get(M.IExtHostTerminalService))),this._disposables.add(f.invokeFunction(p=>p.get(m.IExtHostExtensionService))),this._logService=f.invokeFunction(p=>p.get(T.ILogService)),S.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",_),this._extensionService=f.invokeFunction(p=>p.get(m.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const g=new WeakMap;this._extensionService.getExtensionPathIndex().then(p=>{Error.prepareStackTrace=(E,v)=>{let k="",L,y;for(const O of v)k+=`
	at ${O.toString()}`,y=O.getFileName(),!L&&y&&(L=p.findSubstr(A.URI.file(y)));return g.set(E,L),`${E.name||"Error"}: ${E.message||""}${k}`}});const s=this._rpcProtocol.getProxy(I.MainContext.MainThreadExtensionService),d=this._rpcProtocol.getProxy(I.MainContext.MainThreadErrors);t.setUnexpectedErrorHandler(p=>{const E=t.transformErrorForSerialization(p),v=g.get(p);v?s.$onExtensionRuntimeError(v.identifier,E):d.$onUnexpectedError(E)})}terminate(u){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${u}`),this._logService.flush(),this._disposables.dispose(),t.setUnexpectedErrorHandler(a=>{this._logService.error(a)}),this._rpcProtocol.dispose();const _=this._extensionService.deactivateAll();Promise.race([(0,r.timeout)(5e3),_]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(u,_){u.extensions.forEach(F=>F.extensionLocation=A.URI.revive(_.transformIncomingURIs(F.extensionLocation))),u.environment.appRoot=A.URI.revive(_.transformIncomingURIs(u.environment.appRoot));const a=u.environment.extensionDevelopmentLocationURI;return a&&(u.environment.extensionDevelopmentLocationURI=a.map(F=>A.URI.revive(_.transformIncomingURIs(F)))),u.environment.extensionTestsLocationURI=A.URI.revive(_.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=A.URI.revive(_.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=A.URI.revive(_.transformIncomingURIs(u.environment.workspaceStorageHome)),u.logsLocation=A.URI.revive(_.transformIncomingURIs(u.logsLocation)),u.logFile=A.URI.revive(_.transformIncomingURIs(u.logFile)),u.workspace=_.transformIncomingURIs(u.workspace),u}}e.ExtensionHostMain=C}),define(ye[215],Se([0,1,17,20,43,29,24,188,41]),function(Z,e,r,t,S,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(i,h,l){this.config=i,this.provider=h,this.sessionToken=l,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=i.filePattern,this.includePattern=i.includePattern&&P.parse(i.includePattern),this.maxResults=i.maxResults||void 0,this.exists=i.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=i.excludePattern&&P.parse(i.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(i=>i.cancel()),this.activeCancellationTokens=new Set}search(i){const h=this.config.folderQueries||[];return new Promise((l,o)=>{const m=M=>{this.resultCount++,i(M)};if(this.isCanceled)return l({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(M=>{const C=M.toString(),w=r.basename(C);this.globalExcludePattern&&this.globalExcludePattern(C,w)||this.matchFile(m,{base:M,basename:w})}),Promise.all(h.map(M=>this.searchInFolder(M,m))).then(M=>{l({limitHit:this.isLimitHit,stats:M[0]||void 0})},M=>{o(new Error((0,S.toErrorMessage)(M)))})})}async searchInFolder(i,h){const l=new t.CancellationTokenSource,o=this.getSearchOptionsForFolder(i),m=this.initDirectoryTree(),M=new D.QueryGlobTester(this.config,i),C=!M.hasSiblingExcludeClauses();let w;try{this.activeCancellationTokens.add(l),w=I.StopWatch.create();const u=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},o,l.token),_=w.elapsed(),a=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(u&&u.forEach(F=>{const c=r.posix.relative(i.folder.path,F.path);if(C){const n=r.basename(F.path);this.matchFile(h,{base:i.folder,relativePath:c,basename:n});return}this.addDirectoryEntries(m,i.folder,c,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(m,M,h),{providerTime:_,postProcessTime:a.elapsed()})}finally{l.dispose(),this.activeCancellationTokens.delete(l)}}getSearchOptionsForFolder(i){const h=(0,D.resolvePatternsForProvider)(this.config.includePattern,i.includePattern),l=(0,D.resolvePatternsForProvider)(this.config.excludePattern,i.excludePattern);return{folder:i.folder,excludes:l,includes:h,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries({pathToEntries:i},h,l,o){if(l===this.filePattern){const M=r.basename(this.filePattern);this.matchFile(o,{base:h,relativePath:this.filePattern,basename:M})}function m(M){const C=r.basename(M),w=r.dirname(M);let u=i[w];u||(u=i[w]=[],m(w)),u.push({base:h,relativePath:M,basename:C})}m(l)}matchDirectoryTree({rootEntries:i,pathToEntries:h},l,o){const m=this,M=this.filePattern;function C(w){const u=P.hasSiblingFn(()=>w.map(_=>_.basename));for(let _=0,a=w.length;_<a;_++){const F=w[_],{relativePath:c,basename:n}=F;if(l.matchesExcludesSync(c,n,M!==n?u:void 0))continue;const f=h[c];if(f)C(f);else{if(c===M)continue;m.matchFile(o,F)}if(m.isLimitHit)break}}C(i)}matchFile(i,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||i(h))}}class R{constructor(){this.sessions=new Map}fileSearch(i,h,l,o){const m=this.getSessionTokenSource(i.cacheKey),M=new T(i,h,m&&m.token);let C=0;const w=u=>{C+=u.length,l(u.map(_=>this.rawMatchToSearchItem(_)))};return this.doSearch(M,R.BATCH_SIZE,w,o).then(u=>({limitHit:u.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:C,detailStats:u.stats}}))}clearCache(i){const h=this.getSessionTokenSource(i);h&&h.cancel()}getSessionTokenSource(i){if(!!i)return this.sessions.has(i)||this.sessions.set(i,new t.CancellationTokenSource),this.sessions.get(i)}rawMatchToSearchItem(i){return i.relativePath?{resource:A.joinPath(i.base,i.relativePath)}:{resource:i.base}}doSearch(i,h,l,o){o.onCancellationRequested(()=>{i.cancel()});const m=C=>{C&&(M.push(C),h>0&&M.length>=h&&(l(M),M=[]))};let M=[];return i.search(m).then(C=>(M.length&&l(M),C),C=>(M.length&&l(M),Promise.reject(C)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(ye[216],Se([0,1,16,10,20,43,29,11,17,24,13,2,41]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class h{constructor(u,_,a,F){this.query=u,this.provider=_,this.fileUtils=a,this.processType=F,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(u,_){const a=this.query.folderQueries||[],F=new S.CancellationTokenSource;return _.onCancellationRequested(()=>F.cancel()),new Promise((c,n)=>{this.collector=new o(u);let f=!1;const g=(s,d)=>{if(!f&&!this.isLimitHit){const p=this.resultSize(s);M(s)&&typeof this.query.maxResults=="number"&&this.resultCount+p>this.query.maxResults&&(this.isLimitHit=!0,f=!0,F.cancel(),s=this.trimResultToSize(s,this.query.maxResults-this.resultCount));const E=this.resultSize(s);this.resultCount+=E,(E>0||!M(s))&&this.collector.add(s,d)}};Promise.all(a.map((s,d)=>this.searchInFolder(s,p=>g(p,d),F.token))).then(s=>{F.dispose(),this.collector.flush();const d=s.some(p=>!!p&&!!p.limitHit);c({limitHit:this.isLimitHit||d,messages:(0,r.flatten)(s.map(p=>p?.message?(0,R.isArray)(p.message)?p.message:[p.message]:[])),stats:{type:this.processType}})},s=>{F.dispose();const d=(0,P.toErrorMessage)(s);n(new Error(d))})})}resultSize(u){return M(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}trimResultToSize(u,_){const a=Array.isArray(u.ranges)?u.ranges:[u.ranges],F=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:a.slice(0,_),preview:{matches:F.slice(0,_),text:u.preview.text},uri:u.uri}}async searchInFolder(u,_,a){const F=new i.QueryGlobTester(this.query,u),c=[],n={report:s=>{if(!this.validateProviderResult(s))return;const d=u.folder.scheme===I.Schemas.file?A.hasSiblingPromiseFn(()=>this.fileUtils.readdir(T.dirname(s.uri))):void 0,p=T.relativePath(u.folder,s.uri);if(p){const E=F.includedInQuery(p,D.basename(p),d);(0,t.isThenable)(E)?c.push(E.then(v=>{v&&_(s)})):E&&_(s)}}},f=this.getSearchOptionsForFolder(u),g=await this.provider.provideTextSearchResults(l(this.query.contentPattern),f,n,a);return c.length&&await Promise.all(c),g}validateProviderResult(u){if(M(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(u){const _=(0,i.resolvePatternsForProvider)(this.query.includePattern,u.includePattern),a=(0,i.resolvePatternsForProvider)(this.query.excludePattern,u.excludePattern),F={folder:b.URI.from(u.folder),excludes:a,includes:_,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.fileUtils.toCanonicalName(u.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return F.usePCRE2=this.query.usePCRE2,F}}e.TextSearchManager=h;function l(w){return{isCaseSensitive:w.isCaseSensitive||!1,isRegExp:w.isRegExp||!1,isWordMatch:w.isWordMatch||!1,isMultiline:w.isMultiline||!1,pattern:w.pattern}}class o{constructor(u){this._onResult=u,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new C(512,_=>this.sendItems(_))}add(u,_){this._currentFileMatch&&(this._currentFolderIdx!==_||!T.isEqual(this._currentUri,u.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=_,this._currentFileMatch={resource:u.uri,results:[]}),this._currentFileMatch.results.push(m(u))}pushToCollector(){const u=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,u)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(u){this._onResult(u)}}e.TextSearchResultsCollector=o;function m(w){return M(w)?{preview:{matches:(0,r.mapArrayOrNot)(w.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:w.preview.text},ranges:(0,r.mapArrayOrNot)(w.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:w.text,lineNumber:w.lineNumber}}function M(w){return!!w.preview}e.extensionResultIsMatch=M;class C{constructor(u,_){this.maxBatchSize=u,this.cb=_,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(u,_){!u||this.addItemToBatch(u,_)}addItems(u,_){!u||this.addItemsToBatch(u,_)}addItemToBatch(u,_){this.batch.push(u),this.batchSize+=_,this.onUpdate()}addItemsToBatch(u,_){this.batch=this.batch.concat(u),this.batchSize+=_,this.onUpdate()}onUpdate(){this.totalNumberCompleted<C.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},C.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=C,C.TIMEOUT=4e3,C.START_BATCH_AFTER_COUNT=50}),define(ye[98],Se([0,1,6,5,3,215,14,64,12,2,216]),function(Z,e,r,t,S,P,A,I,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,S.createDecorator)("IExtHostSearch");let b=class{constructor(o,m,M){this.extHostRpc=o,this._uriTransformer=m,this._logService=M,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(o){return this._uriTransformer.transformOutgoingScheme(o)}registerTextSearchProvider(o,m){if(this._textSearchUsedSchemes.has(o))throw new Error(`a text search provider for the scheme '${o}' is already registered`);this._textSearchUsedSchemes.add(o);const M=this._handlePool++;return this._textSearchProvider.set(M,m),this._proxy.$registerTextSearchProvider(M,this._transformScheme(o)),(0,r.toDisposable)(()=>{this._textSearchUsedSchemes.delete(o),this._textSearchProvider.delete(M),this._proxy.$unregisterProvider(M)})}registerFileSearchProvider(o,m){if(this._fileSearchUsedSchemes.has(o))throw new Error(`a file search provider for the scheme '${o}' is already registered`);this._fileSearchUsedSchemes.add(o);const M=this._handlePool++;return this._fileSearchProvider.set(M,m),this._proxy.$registerFileSearchProvider(M,this._transformScheme(o)),(0,r.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(o),this._fileSearchProvider.delete(M),this._proxy.$unregisterProvider(M)})}$provideFileSearchResults(o,m,M,C){const w=i(M),u=this._fileSearchProvider.get(o);if(u)return this._fileSearchManager.fileSearch(w,u,_=>{this._proxy.$handleFileMatch(o,m,_.map(a=>a.resource))},C);throw new Error("unknown provider: "+o)}$clearCache(o){return this._fileSearchManager.clearCache(o),Promise.resolve(void 0)}$provideTextSearchResults(o,m,M,C){const w=this._textSearchProvider.get(o);if(!w||!w.provideTextSearchResults)throw new Error(`Unknown provider ${o}`);const u=i(M);return this.createTextSearchManager(u,w).search(a=>this._proxy.$handleTextMatch(o,m,a),C)}$enableExtensionHostSearch(){}createTextSearchManager(o,m){return new R.TextSearchManager(o,m,{readdir:M=>Promise.resolve([]),toCanonicalName:M=>M},"textSearchProvider")}};b=xe([$e(0,A.IExtHostRpcService),$e(1,I.IURITransformerService),$e(2,D.ILogService)],b),e.ExtHostSearch=b;function i(l){return{...l,folderQueries:l.folderQueries&&l.folderQueries.map(h),extraFileResources:l.extraFileResources&&l.extraFileResources.map(o=>T.URI.revive(o))}}e.reviveQuery=i;function h(l){return{...l,folder:T.URI.revive(l.folder)}}}),define(ye[217],Se([0,1,44,93,31,91,32,39,49,40,96,97,98,70,63,68,94,50,30,67,83,69,190,12,172]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i,h,l,o,m,M,C,w,u,_,a,F,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(F.ILoggerService,a.ExtHostLoggerService),(0,r.registerSingleton)(F.ILogService,c.ExtHostLogService),(0,r.registerSingleton)(o.IExtHostApiDeprecationService,o.ExtHostApiDeprecationService),(0,r.registerSingleton)(I.IExtHostCommands,I.ExtHostCommands),(0,r.registerSingleton)(A.IExtHostConfiguration,A.ExtHostConfiguration),(0,r.registerSingleton)(M.IExtHostConsumerFileSystem,M.ExtHostConsumerFileSystem),(0,r.registerSingleton)(b.IExtHostDebugService,b.WorkerExtHostDebugService),(0,r.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations),(0,r.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,r.registerSingleton)(C.IExtHostFileSystemInfo,C.ExtHostFileSystemInfo),(0,r.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService),(0,r.registerSingleton)(i.IExtHostSearch,i.ExtHostSearch),(0,r.registerSingleton)(h.IExtHostStorage,h.ExtHostStorage),(0,r.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,r.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService),(0,r.registerSingleton)(l.IExtHostTunnelService,l.ExtHostTunnelService),(0,r.registerSingleton)(m.IExtHostWindow,m.ExtHostWindow),(0,r.registerSingleton)(S.IExtHostWorkspace,S.ExtHostWorkspace),(0,r.registerSingleton)(w.IExtHostSecretState,w.ExtHostSecretState),(0,r.registerSingleton)(u.IExtHostTelemetry,u.ExtHostTelemetry),(0,r.registerSingleton)(_.IExtHostEditorTabs,_.ExtHostEditorTabs)}),define(ye[218],Se([0,1,44,3]),function(Z,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDragAndDropService=e.ITreeViewsDragAndDropService=void 0,e.ITreeViewsDragAndDropService=(0,t.createDecorator)("treeViewsDragAndDropService");class S{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(A){if(A&&this._dragOperations.has(A)){const I=this._dragOperations.get(A);return this._dragOperations.delete(A),I}}addDragOperationTransfer(A,I){this._dragOperations.set(A,I)}}e.TreeViewsDragAndDropService=S,(0,r.registerSingleton)(e.ITreeViewsDragAndDropService,S)}),define(ye[219],Se([0,1,123,24,2,4,6,10,7,13,16,8,20,152,218]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function o(C,w){if((0,T.isString)(C))return{label:C};if(C&&typeof C=="object"&&typeof C.label=="string"){let u;return Array.isArray(C.highlights)&&(u=C.highlights.filter(_=>_.length===2&&typeof _[0]=="number"&&typeof _[1]=="number"),u=u.length?u:void 0),{label:C.label,highlights:u}}}class m{constructor(w,u,_){this._proxy=w,this.commands=u,this.logService=_,this.treeViews=new Map,this.treeDragAndDropService=new l.TreeViewsDragAndDropService;function a(F){return F&&F.$treeViewId&&F.$treeItemHandle}u.registerArgumentProcessor({processArgument:F=>a(F)?this.convertArgument(F):Array.isArray(F)&&F.length>0?F.map(c=>a(c)?this.convertArgument(c):c):F})}registerTreeDataProvider(w,u,_){const a=this.createTreeView(w,{treeDataProvider:u},_);return{dispose:()=>a.dispose()}}createTreeView(w,u,_){if(!u||!u.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=u.dragAndDropController?.supportedMimeTypes,F=!!u.dragAndDropController?.handleDrag,c=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!u.showCollapseAll,canSelectMany:!!u.canSelectMany,dragAndDropMimeTypes:a,hasHandleDrag:F}),n=this.createExtHostTreeView(w,u,_);return{get onDidCollapseElement(){return n.onDidCollapseElement},get onDidExpandElement(){return n.onDidExpandElement},get selection(){return n.selectedElements},get onDidChangeSelection(){return n.onDidChangeSelection},get visible(){return n.visible},get onDidChangeVisibility(){return n.onDidChangeVisibility},get message(){return n.message},set message(f){n.message=f},get title(){return n.title},set title(f){n.title=f},get description(){return n.description},set description(f){n.description=f},reveal:(f,g)=>n.reveal(f,g),dispose:async()=>{await c,this.treeViews.delete(w),n.dispose()}}}$getChildren(w,u){const _=this.treeViews.get(w);return _?_.getChildren(u):Promise.reject(new Error((0,r.localize)(0,null,w)))}async $handleDrop(w,u,_,a,F,c){const n=this.treeViews.get(w);if(!n)return Promise.reject(new Error((0,r.localize)(1,null,w)));const f=h.TreeDataTransferConverter.toITreeDataTransfer(u);return F===w&&c&&await this.addAdditionalTransferItems(f,n,c,a),n.onDrop(f,_)}async addAdditionalTransferItems(w,u,_,a){const F=this.treeDragAndDropService.removeDragOperationTransfer(a);if(F)(await F)?.forEach((c,n)=>{c&&w.set(n,c)});else if(a&&u.handleDrag){const c=u.handleDrag(_,w);this.treeDragAndDropService.addDragOperationTransfer(a,c),await c}return w}async $handleDrag(w,u,_){const a=this.treeViews.get(w);if(!a)return Promise.reject(new Error((0,r.localize)(2,null,w)));const F=await this.addAdditionalTransferItems(new Map,a,u,_);if(!!F)return h.TreeDataTransferConverter.toTreeDataTransferDTO(F)}async $hasResolve(w){const u=this.treeViews.get(w);if(!u)throw new Error((0,r.localize)(3,null,w));return u.hasResolve}$resolve(w,u,_){const a=this.treeViews.get(w);if(!a)throw new Error((0,r.localize)(4,null,w));return a.resolveTreeItem(u,_)}$setExpanded(w,u,_){const a=this.treeViews.get(w);if(!a)throw new Error((0,r.localize)(5,null,w));a.setExpanded(u,_)}$setSelection(w,u){const _=this.treeViews.get(w);if(!_)throw new Error((0,r.localize)(6,null,w));_.setSelection(u)}$setVisible(w,u){const _=this.treeViews.get(w);if(!_)throw new Error((0,r.localize)(7,null,w));_.setVisible(u)}createExtHostTreeView(w,u,_){const a=new M(w,u,this._proxy,this.commands.converter,this.logService,_);return this.treeViews.set(w,a),a}convertArgument(w){const u=this.treeViews.get(w.$treeViewId);return u?u.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=m;class M extends A.Disposable{constructor(w,u,_,a,F,c){super();if(this.viewId=w,this.proxy=_,this.commands=a,this.logService=F,this.extension=c,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new P.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new P.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new P.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new P.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new P.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new i.CancellationTokenSource,c.contributes&&c.contributes.views)for(const g in c.contributes.views)for(const s of c.contributes.views[g])s.id===w&&(this._title=s.name);this.dataProvider=u.treeDataProvider,this.dndController=u.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(g=>this._onDidChangeData.fire({message:!1,element:g}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(g=>this._onDidChangeData.fire({message:!1,element:g})));let n,f;this._register(P.Event.debounce(this._onDidChangeData.event,(g,s)=>(g||(g={message:!1,elements:[]}),s.element!==!1&&(n||(n=new Promise(d=>f=d),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(s.element)?g.elements.push(...s.element):g.elements.push(s.element)),s.message&&(g.message=!0),g),200,!0)(({message:g,elements:s})=>{s.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const d=f;return n=null,this.refresh(s).then(()=>d())})),g&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!(0,T.isUndefinedOrNull)(w))}async getChildren(w){const u=w?this.getExtensionElement(w):void 0;if(w&&!u)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);let _=this.getChildrenNodes(w);return _||(_=await this.fetchChildrenNodes(u)),_?_.map(a=>a.item):void 0}getExtensionElement(w){return this.elements.get(w)}reveal(w,u){u=u||{select:!0,focus:!1};const _=(0,T.isUndefinedOrNull)(u.select)?!0:u.select,a=(0,T.isUndefinedOrNull)(u.focus)?!1:u.focus,F=(0,T.isUndefinedOrNull)(u.expand)?!1:u.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(c=>this.resolveTreeNode(w,c[c.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:c.map(f=>f.item)},{select:_,focus:a,expand:F})),c=>this.logService.error(c)):this.proxy.$reveal(this.viewId,void 0,{select:_,focus:a,expand:F})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,u){const _=this.getExtensionElement(w);_&&(u?this._onDidExpandElement.fire(Object.freeze({element:_})):this._onDidCollapseElement.fire(Object.freeze({element:_})))}setSelection(w){(0,R.equals)(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(w,u){const _=[];for(const a of w){const F=this.getExtensionElement(a);F&&_.push(F)}if(!(!this.dndController?.handleDrag||_.length===0))return await this.dndController.handleDrag(_,u),u}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(w,u){const _=this.getExtensionElement(u);if(!!_)return(0,I.asPromise)(()=>this.dndController?.handleDrop(w,_))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,u){if(!this.dataProvider.resolveTreeItem)return;const _=this.elements.get(w);if(_){const a=this.nodes.get(_);if(a){const F=await this.dataProvider.resolveTreeItem(a.extensionItem,_,u)??a.extensionItem;return a.item.tooltip=this.getTooltip(F.tooltip),a.item.command=this.getCommand(a.disposableStore,F.command),a.item}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(u=>u?this.resolveUnknownParentChain(u).then(_=>this.resolveTreeNode(u,_[_.length-1]).then(a=>(_.push(a),_))):Promise.resolve([]))}resolveParent(w){const u=this.nodes.get(w);return u?Promise.resolve(u.parent?this.elements.get(u.parent.item.handle):void 0):(0,I.asPromise)(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,u){const _=this.nodes.get(w);return _?Promise.resolve(_):(0,I.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(a=>this.createHandle(w,a,u,!0)).then(a=>this.getChildren(u?u.item.handle:void 0).then(()=>{const F=this.getExtensionElement(a);if(F){const c=this.nodes.get(F);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${a}`)}))}getChildrenNodes(w){if(w){let u;if(typeof w=="string"){const _=this.getExtensionElement(w);u=_?this.nodes.get(_):void 0}else u=w;return u&&u.children||void 0}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const u=new i.CancellationTokenSource(this._refreshCancellationSource.token);try{const _=w?this.nodes.get(w):void 0,a=await this.dataProvider.getChildren(w);if(u.token.isCancellationRequested)return;const F=await Promise.all((0,R.coalesce)(a||[]).map(async c=>{const n=await this.dataProvider.getTreeItem(c);return n&&!u.token.isCancellationRequested?this.createAndRegisterTreeNode(c,n,_):null}));return u.token.isCancellationRequested?void 0:(0,R.coalesce)(F)}finally{u.dispose()}}refresh(w){if(w.some(_=>!_))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new i.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const _=this.getHandlesToRefresh(w);if(_.length)return this.refreshHandles(_)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const u=new Set,_=w.map(F=>this.nodes.get(F));for(const F of _)if(F&&!u.has(F.item.handle)){let c=F;for(;c&&c.parent&&_.findIndex(n=>c&&c.parent&&n&&n.item.handle===c.parent.item.handle)===-1;){const n=this.elements.get(c.parent.item.handle);c=n?this.nodes.get(n):void 0}c&&!c.parent&&u.add(F.item.handle)}const a=[];return u.forEach(F=>{const c=this.elements.get(F);if(c){const n=this.nodes.get(c);n&&(!n.parent||!u.has(n.parent.item.handle))&&a.push(F)}}),a}refreshHandles(w){const u={};return Promise.all(w.map(_=>this.refreshNode(_).then(a=>{a&&(u[_]=a.item)}))).then(()=>Object.keys(u).length?this.proxy.$refresh(this.viewId,u):void 0)}refreshNode(w){const u=this.getExtensionElement(w);if(u){const _=this.nodes.get(u);if(_)return this.clearChildren(u),(0,I.asPromise)(()=>this.dataProvider.getTreeItem(u)).then(a=>{if(a){const F=this.createTreeNode(u,a,_.parent);return this.updateNodeCache(u,F,_,_.parent),_.dispose(),F}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,u,_){const a=this.createTreeNode(w,u,_);if(u.id&&this.elements.has(a.item.handle))throw new Error((0,r.localize)(8,null,u.id));return this.addNodeToCache(w,a),this.addNodeToParentCache(a,_),a}getTooltip(w){return D.MarkdownString.isMarkdownString(w)?b.MarkdownString.from(w):w}getCommand(w,u){return u?this.commands.toInternal(u,w):void 0}createTreeNode(w,u,_){const a=new A.DisposableStore,F=this.createHandle(w,u,_),c=this.getLightIconPath(u);return{item:{handle:F,parentHandle:_?_.item.handle:void 0,label:o(u.label,this.extension),description:u.description,resourceUri:u.resourceUri,tooltip:this.getTooltip(u.tooltip),command:this.getCommand(a,u.command),contextValue:u.contextValue,icon:c,iconDark:this.getDarkIconPath(u)||c,themeIcon:this.getThemeIcon(u),collapsibleState:(0,T.isUndefinedOrNull)(u.collapsibleState)?D.TreeItemCollapsibleState.None:u.collapsibleState,accessibilityInformation:u.accessibilityInformation},extensionItem:u,parent:_,children:void 0,disposableStore:a,dispose(){a.dispose()}}}getThemeIcon(w){return w.iconPath instanceof D.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:u,label:_,resourceUri:a},F,c){if(u)return`${M.ID_HANDLE_PREFIX}/${u}`;const n=o(_,this.extension),f=F?F.item.handle:M.LABEL_HANDLE_PREFIX;let g=n?n.label:a?(0,t.basename)(a):"";g=g.indexOf("/")!==-1?g.replace("/","//"):g;const s=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,d=this.getChildrenNodes(F)||[];let p,E=0;do{if(p=`${f}/${E}:${g}`,c||!this.elements.has(p)||s===p)break;E++}while(E<=d.length);return p}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon))return typeof w.iconPath=="string"||S.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return S.URI.isUri(w)?w:S.URI.file(w)}addNodeToCache(w,u){this.elements.set(u.item.handle,w),this.nodes.set(w,u)}updateNodeCache(w,u,_,a){this.elements.delete(u.item.handle),this.nodes.delete(w),u.item.handle!==_.item.handle&&this.elements.delete(_.item.handle),this.addNodeToCache(w,u);const F=this.getChildrenNodes(a)||[],c=F.filter(n=>n.item.handle===_.item.handle)[0];c&&F.splice(F.indexOf(c),1,u)}addNodeToParentCache(w,u){u?(u.children||(u.children=[]),u.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const u=this.nodes.get(w);if(u){if(u.children)for(const _ of u.children){const a=this.elements.get(_.item.handle);a&&this.clear(a)}u.children=void 0}}else this.clearAll()}clear(w){const u=this.nodes.get(w);if(u){if(u.children)for(const _ of u.children){const a=this.elements.get(_.item.handle);a&&this.clear(a)}this.nodes.delete(w),this.elements.delete(u.item.handle),u.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}M.LABEL_HANDLE_PREFIX="0",M.ID_HANDLE_PREFIX="1"}),define(ye[220],Se([0,1,20,15,4,34,2,112,233,106,56,46,5,177,176,39,178,32,179,180,181,164,182,49,33,183,184,187,189,191,93,166,196,197,198,70,40,200,219,8,7,203,51,94,31,73,153,186,60,91,96,97,98,12,64,14,28,192,150,63,68,174,201,149,71,50,206,204,205,175,30,199,202,67,69,83,194,95,195,11,138,193,147,185,6,26]),function(Z,e,r,t,S,P,A,I,D,T,R,b,i,h,l,o,m,M,C,w,u,_,a,F,c,n,f,g,s,d,p,E,v,k,L,y,O,U,q,H,z,j,ie,ae,te,ue,be,pe,me,oe,Ee,Pe,Oe,je,st,et,tt,$,K,x,V,Y,se,_e,Ue,Ve,Qe,nt,rt,Je,Ze,pt,Fe,At,G,Q,he,Be,qe,lt,ht,Ye,kt,Ae,De,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ee(ne){const de=ne.get(tt.IExtHostInitDataService),ge=ne.get(Ze.IExtHostFileSystemInfo),Te=ne.get(Ve.IExtHostConsumerFileSystem),ze=ne.get(c.IExtHostExtensionService),Le=ne.get(te.IExtHostWorkspace),Ge=ne.get(Q.IExtHostTelemetry),ot=ne.get(M.IExtHostConfiguration),at=ne.get(st.IURITransformerService),Ne=ne.get(et.IExtHostRpcService),ce=ne.get(y.IExtHostStorage),fe=ne.get(Ue.IExtensionStoragePaths),re=ne.get(je.ILoggerService),W=ne.get(je.ILogService),we=ne.get(x.IExtHostTunnelService),Re=ne.get(V.IExtHostApiDeprecationService),We=ne.get(ae.IExtHostWindow),He=ne.get(At.IExtHostSecretState),mt=ne.get(G.IExtHostEditorTabs);Ne.set(i.ExtHostContext.ExtHostFileSystemInfo,ge),Ne.set(i.ExtHostContext.ExtHostLogLevelServiceShape,re),Ne.set(i.ExtHostContext.ExtHostWorkspace,Le),Ne.set(i.ExtHostContext.ExtHostConfiguration,ot),Ne.set(i.ExtHostContext.ExtHostExtensionService,ze),Ne.set(i.ExtHostContext.ExtHostStorage,ce),Ne.set(i.ExtHostContext.ExtHostTunnelService,we),Ne.set(i.ExtHostContext.ExtHostWindow,We),Ne.set(i.ExtHostContext.ExtHostSecretState,He),Ne.set(i.ExtHostContext.ExtHostTelemetry,Ge),Ne.set(i.ExtHostContext.ExtHostEditorTabs,mt);const Et=Ne.set(i.ExtHostContext.ExtHostDecorations,ne.get(oe.IExtHostDecorations)),St=Ne.set(i.ExtHostContext.ExtHostDocumentsAndEditors,ne.get(F.IExtHostDocumentsAndEditors)),dt=Ne.set(i.ExtHostContext.ExtHostCommands,ne.get(o.IExtHostCommands)),vt=Ne.set(i.ExtHostContext.ExtHostTerminalService,ne.get(O.IExtHostTerminalService)),bt=Ne.set(i.ExtHostContext.ExtHostDebugService,ne.get(Pe.IExtHostDebugService)),Ut=Ne.set(i.ExtHostContext.ExtHostSearch,ne.get(Oe.IExtHostSearch)),It=Ne.set(i.ExtHostContext.ExtHostTask,ne.get(Ee.IExtHostTask)),Mt=Ne.set(i.ExtHostContext.ExtHostOutputService,ne.get(p.IExtHostOutputService)),Dt=Ne.set(i.ExtHostContext.ExtHostUrls,new j.ExtHostUrls(Ne)),_t=Ne.set(i.ExtHostContext.ExtHostDocuments,new a.ExtHostDocuments(Ne,St)),Qt=Ne.set(i.ExtHostContext.ExtHostDocumentContentProviders,new u.ExtHostDocumentContentProvider(Ne,St,W)),Vt=Ne.set(i.ExtHostContext.ExtHostDocumentSaveParticipant,new _.ExtHostDocumentSaveParticipant(W,_t,Ne.getProxy(i.MainContext.MainThreadBulkEdits))),wt=Ne.set(i.ExtHostContext.ExtHostNotebook,new $.ExtHostNotebookController(Ne,dt,St,_t,fe)),Yt=Ne.set(i.ExtHostContext.ExtHostNotebookDocuments,new kt.ExtHostNotebookDocuments(W,wt)),qt=Ne.set(i.ExtHostContext.ExtHostNotebookEditors,new Ye.ExtHostNotebookEditors(W,Ne,wt)),Xt=Ne.set(i.ExtHostContext.ExtHostNotebookKernels,new he.ExtHostNotebookKernels(Ne,de,wt,dt,W)),ai=Ne.set(i.ExtHostContext.ExtHostNotebookRenderers,new qe.ExtHostNotebookRenderers(Ne,wt)),Rt=Ne.set(i.ExtHostContext.ExtHostEditors,new U.ExtHostEditors(Ne,St)),Jt=Ne.set(i.ExtHostContext.ExtHostTreeViews,new q.ExtHostTreeViews(Ne.getProxy(i.MainContext.MainThreadTreeViews),dt,W)),li=Ne.set(i.ExtHostContext.ExtHostEditorInsets,new be.ExtHostEditorInsets(Ne.getProxy(i.MainContext.MainThreadEditorInsets),Rt,de)),jt=Ne.set(i.ExtHostContext.ExtHostDiagnostics,new C.ExtHostDiagnostics(Ne,W,ge)),Zt=Ne.set(i.ExtHostContext.ExtHostLanguages,new s.ExtHostLanguages(Ne,_t,dt.converter,at)),gt=Ne.set(i.ExtHostContext.ExtHostLanguageFeatures,new g.ExtHostLanguageFeatures(Ne,at,_t,dt,jt,W,Re)),ci=Ne.set(i.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(Ne,gt)),Lt=Ne.set(i.ExtHostContext.ExtHostFileSystemEventService,new f.ExtHostFileSystemEventService(Ne,W,St)),$t=Ne.set(i.ExtHostContext.ExtHostQuickOpen,(0,v.createExtHostQuickOpen)(Ne,Le,dt)),vi=Ne.set(i.ExtHostContext.ExtHostSCM,new k.ExtHostSCM(Ne,dt,W)),ui=Ne.set(i.ExtHostContext.ExtHostComments,(0,m.createExtHostComments)(Ne,dt,_t)),ei=Ne.set(i.ExtHostContext.ExtHostProgress,new E.ExtHostProgress(Ne.getProxy(i.MainContext.MainThreadProgress))),Ci=Ne.set(i.ExtHostContext.ExtHosLabelService,new pe.ExtHostLabelService(Ne)),bi=Ne.set(i.ExtHostContext.ExtHostTheming,new K.ExtHostTheming(Ne)),ti=Ne.set(i.ExtHostContext.ExtHostAuthentication,new Y.ExtHostAuthentication(Ne)),Di=Ne.set(i.ExtHostContext.ExtHostTimeline,new se.ExtHostTimeline(Ne,dt)),di=Ne.set(i.ExtHostContext.ExtHostWebviews,new ie.ExtHostWebviews(Ne,{remote:de.remote},Le,W,Re)),Gt=Ne.set(i.ExtHostContext.ExtHostWebviewPanels,new rt.ExtHostWebviewPanels(Ne,di,Le)),hi=Ne.set(i.ExtHostContext.ExtHostCustomEditors,new nt.ExtHostCustomEditors(Ne,_t,fe,di,Gt)),ki=Ne.set(i.ExtHostContext.ExtHostWebviewViews,new Qe.ExtHostWebviewViews(Ne,di)),Kt=Ne.set(i.ExtHostContext.ExtHostTesting,new pt.ExtHostTesting(Ne,dt)),Ii=Ne.set(i.ExtHostContext.ExtHostUriOpeners,new Fe.ExtHostUriOpeners(Ne));Ne.set(i.ExtHostContext.ExtHostInteractive,new Ae.ExtHostInteractive(Ne,wt,St,dt));const Pi=(0,ue.values)(i.ExtHostContext);Ne.assertRegistered(Pi);const ii=new Je.ExtHostBulkEdits(Ne,St),Ti=new l.ExtHostClipboard(Ne),fi=new d.ExtHostMessageService(Ne,W),wi=new w.ExtHostDialogs(Ne),ni=new L.ExtHostStatusBar(Ne,dt.converter);return h.ExtHostApiCommands.register(dt),function(Me,zt,Bt){const yt=function(){let X=!Me.isUnderDevelopment;function le(){X||(W.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function ke(ut){if(Array.isArray(ut))ut.forEach(ke);else if(typeof ut=="string")le();else{const Ct=ut;typeof Ct.scheme=="undefined"&&le(),typeof Ct.exclusive=="boolean"&&(0,ve.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return ut}}(),Ot={getSession(X,le,ke){return ti.getSession(Me,X,le,ke)},async hasSession(X,le){return(0,ve.checkProposedApiEnabled)(Me,"authSession"),!!await ti.getSession(Me,X,le,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(X,le,ke,ut){return ti.registerAuthenticationProvider(X,le,ke,ut)}},ri={registerCommand(X,le,ke){return dt.registerCommand(!0,X,le,ke,void 0,Me)},registerTextEditorCommand(X,le,ke){return dt.registerCommand(!0,X,(...ut)=>{const Ct=Rt.getActiveTextEditor();if(!Ct){W.warn("Cannot execute "+X+" because there is no active text editor.");return}return Ct.edit(Tt=>{le.apply(ke,[Ct,Tt,...ut])}).then(Tt=>{Tt||W.warn("Edits from command "+X+" were not applied.")},Tt=>{W.warn("An error occurred while running command "+X,Tt)})},void 0,void 0,Me)},registerDiffInformationCommand:(X,le,ke)=>((0,ve.checkProposedApiEnabled)(Me,"diffCommand"),dt.registerCommand(!0,X,async(...ut)=>{const Ct=St.activeEditor(!0);if(!Ct){W.warn("Cannot execute "+X+" because there is no active text editor.");return}const Tt=await Rt.getDiffInformation(Ct.id);le.apply(ke,[Tt,...ut])},void 0,void 0,Me)),executeCommand(X,...le){return dt.executeCommand(X,...le)},getCommands(X=!1){return dt.getCommands(X)}},Ei={get machineId(){return de.telemetryInfo.machineId},get sessionId(){return de.telemetryInfo.sessionId},get language(){return de.environment.appLanguage},get appName(){return de.environment.appName},get appRoot(){return de.environment.appRoot?.fsPath??""},get appHost(){return de.environment.appHost},get uriScheme(){return de.environment.appUriScheme},get clipboard(){return Ti.value},get shell(){return vt.getDefaultShell(!1)},get isTelemetryEnabled(){return Ge.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ge.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(de.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,le){return We.openUri(X,{allowTunneling:!!de.remote.authority,allowContributedOpeners:le?.allowContributedOpeners})},async asExternalUri(X){if(X.scheme===de.environment.appUriScheme)return Dt.createAppUri(X);try{return await We.asExternalUri(X,{allowTunneling:!!de.remote.authority})}catch(le){if((0,ht.matchesScheme)(X,lt.Schemas.http)||(0,ht.matchesScheme)(X,lt.Schemas.https))return X;throw le}},get remoteName(){return(0,me.getRemoteName)(de.remote.authority)},get remoteAuthority(){return(0,ve.checkProposedApiEnabled)(Me,"resolvers"),de.remote.authority},get uiKind(){return de.uiKind}};de.environment.extensionTestsLocationURI||Object.freeze(Ei);const yi=de.remote.isRemote?z.ExtensionKind.Workspace:z.ExtensionKind.UI,Ai={createTestController(X,le,ke){return ke&&(0,ve.checkProposedApiEnabled)(Me,"testRefresh"),Kt.createTestController(X,le,ke)},createTestObserver(){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Kt.createTestObserver()},runTests(X){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Kt.runTests(X)},get onDidChangeTestResults(){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Kt.results}},Ri={getExtension(X){const le=zt.getExtensionDescription(X);if(le)return new c.Extension(ze,Me.identifier,le,yi)},get all(){return zt.getAllExtensionDescriptions().map(X=>new c.Extension(ze,Me.identifier,X,yi))},get onDidChange(){return zt.onDidChange}},Fi={createDiagnosticCollection(X){return jt.createDiagnosticCollection(Me.identifier,X)},get onDidChangeDiagnostics(){return jt.onDidChangeDiagnostics},getDiagnostics:X=>jt.getDiagnostics(X),getLanguages(){return Zt.getLanguages()},setTextDocumentLanguage(X,le){return Zt.changeLanguage(X.uri,le)},match(X,le){return(0,R.score)(H.LanguageSelector.from(X),le.uri,le.languageId,!0)},registerCodeActionsProvider(X,le,ke){return gt.registerCodeActionProvider(Me,yt(X),le,ke)},registerCodeLensProvider(X,le){return gt.registerCodeLensProvider(Me,yt(X),le)},registerDefinitionProvider(X,le){return gt.registerDefinitionProvider(Me,yt(X),le)},registerDeclarationProvider(X,le){return gt.registerDeclarationProvider(Me,yt(X),le)},registerImplementationProvider(X,le){return gt.registerImplementationProvider(Me,yt(X),le)},registerTypeDefinitionProvider(X,le){return gt.registerTypeDefinitionProvider(Me,yt(X),le)},registerHoverProvider(X,le){return gt.registerHoverProvider(Me,yt(X),le,Me.identifier)},registerEvaluatableExpressionProvider(X,le){return gt.registerEvaluatableExpressionProvider(Me,yt(X),le,Me.identifier)},registerInlineValuesProvider(X,le){return gt.registerInlineValuesProvider(Me,yt(X),le,Me.identifier)},registerDocumentHighlightProvider(X,le){return gt.registerDocumentHighlightProvider(Me,yt(X),le)},registerLinkedEditingRangeProvider(X,le){return gt.registerLinkedEditingRangeProvider(Me,yt(X),le)},registerReferenceProvider(X,le){return gt.registerReferenceProvider(Me,yt(X),le)},registerRenameProvider(X,le){return gt.registerRenameProvider(Me,yt(X),le)},registerDocumentSymbolProvider(X,le,ke){return gt.registerDocumentSymbolProvider(Me,yt(X),le,ke)},registerWorkspaceSymbolProvider(X){return gt.registerWorkspaceSymbolProvider(Me,X)},registerDocumentFormattingEditProvider(X,le){return gt.registerDocumentFormattingEditProvider(Me,yt(X),le)},registerDocumentRangeFormattingEditProvider(X,le){return gt.registerDocumentRangeFormattingEditProvider(Me,yt(X),le)},registerOnTypeFormattingEditProvider(X,le,ke,...ut){return gt.registerOnTypeFormattingEditProvider(Me,yt(X),le,[ke].concat(ut))},registerDocumentSemanticTokensProvider(X,le,ke){return gt.registerDocumentSemanticTokensProvider(Me,yt(X),le,ke)},registerDocumentRangeSemanticTokensProvider(X,le,ke){return gt.registerDocumentRangeSemanticTokensProvider(Me,yt(X),le,ke)},registerSignatureHelpProvider(X,le,ke,...ut){return typeof ke=="object"?gt.registerSignatureHelpProvider(Me,yt(X),le,ke):gt.registerSignatureHelpProvider(Me,yt(X),le,typeof ke=="undefined"?[]:[ke,...ut])},registerCompletionItemProvider(X,le,...ke){return gt.registerCompletionItemProvider(Me,yt(X),le,ke)},registerInlineCompletionItemProvider(X,le){return(0,ve.checkProposedApiEnabled)(Me,"inlineCompletions"),gt.registerInlineCompletionsProvider(Me,yt(X),le)},registerDocumentLinkProvider(X,le){return gt.registerDocumentLinkProvider(Me,yt(X),le)},registerColorProvider(X,le){return gt.registerColorProvider(Me,yt(X),le)},registerFoldingRangeProvider(X,le){return gt.registerFoldingRangeProvider(Me,yt(X),le)},registerSelectionRangeProvider(X,le){return gt.registerSelectionRangeProvider(Me,X,le)},registerCallHierarchyProvider(X,le){return gt.registerCallHierarchyProvider(Me,X,le)},registerTypeHierarchyProvider(X,le){return gt.registerTypeHierarchyProvider(Me,X,le)},setLanguageConfiguration:(X,le)=>gt.setLanguageConfiguration(Me,X,le),getTokenInformationAtPosition(X,le){return(0,ve.checkProposedApiEnabled)(Me,"tokenInformation"),Zt.tokenAtPosition(X,le)},registerInlayHintsProvider(X,le){return(0,ve.checkProposedApiEnabled)(Me,"inlayHints"),gt.registerInlayHintsProvider(Me,X,le)},createLanguageStatusItem(X,le){return(0,ve.checkProposedApiEnabled)(Me,"languageStatus"),Zt.createLanguageStatusItem(Me,X,le)}},Mi={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(X,le,ke){const ut=await(A.URI.isUri(X)?Promise.resolve(Si.openTextDocument(X)):Promise.resolve(X));return Rt.showTextDocument(ut,le,ke)},createTextEditorDecorationType(X){return Rt.createTextEditorDecorationType(Me,X)},onDidChangeActiveTextEditor(X,le,ke){return Rt.onDidChangeActiveTextEditor(X,le,ke)},onDidChangeVisibleTextEditors(X,le,ke){return Rt.onDidChangeVisibleTextEditors(X,le,ke)},onDidChangeTextEditorSelection(X,le,ke){return Rt.onDidChangeTextEditorSelection(X,le,ke)},onDidChangeTextEditorOptions(X,le,ke){return Rt.onDidChangeTextEditorOptions(X,le,ke)},onDidChangeTextEditorVisibleRanges(X,le,ke){return Rt.onDidChangeTextEditorVisibleRanges(X,le,ke)},onDidChangeTextEditorViewColumn(X,le,ke){return Rt.onDidChangeTextEditorViewColumn(X,le,ke)},onDidCloseTerminal(X,le,ke){return vt.onDidCloseTerminal(X,le,ke)},onDidOpenTerminal(X,le,ke){return vt.onDidOpenTerminal(X,le,ke)},onDidChangeActiveTerminal(X,le,ke){return vt.onDidChangeActiveTerminal(X,le,ke)},onDidChangeTerminalDimensions(X,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"terminalDimensions"),vt.onDidChangeTerminalDimensions(X,le,ke)},onDidChangeTerminalState(X,le,ke){return vt.onDidChangeTerminalState(X,le,ke)},onDidWriteTerminalData(X,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),vt.onDidWriteTerminalData(X,le,ke)},get state(){return We.state},onDidChangeWindowState(X,le,ke){return We.onDidChangeWindowState(X,le,ke)},showInformationMessage(X,...le){return fi.showMessage(Me,P.default.Info,X,le[0],le.slice(1))},showWarningMessage(X,...le){return fi.showMessage(Me,P.default.Warning,X,le[0],le.slice(1))},showErrorMessage(X,...le){return fi.showMessage(Me,P.default.Error,X,le[0],le.slice(1))},showQuickPick(X,le,ke){return Array.isArray(X)&&X.some(ut=>ut.kind===z.QuickPickItemKind.Separator)&&(0,ve.checkProposedApiEnabled)(Me,"quickPickSeparators"),$t.showQuickPick(X,le,ke)},showWorkspaceFolderPick(X){return $t.showWorkspaceFolderPick(X)},showInputBox(X,le){return $t.showInput(X,le)},showOpenDialog(X){return wi.showOpenDialog(X)},showSaveDialog(X){return wi.showSaveDialog(X)},createStatusBarItem(X,le,ke){let ut,Ct,Tt;return typeof X=="string"?(ut=X,Ct=le,Tt=ke):(Ct=X,Tt=le),ni.createStatusBarEntry(Me,ut,Ct,Tt)},setStatusBarMessage(X,le){return ni.setStatusBarMessage(X,le)},withScmProgress(X){return Re.report("window.withScmProgress",Me,"Use 'withProgress' instead."),ei.withProgress(Me,{location:z.ProgressLocation.SourceControl},(le,ke)=>X({report(ut){}}))},withProgress(X,le){return ei.withProgress(Me,X,le)},createOutputChannel(X){return Mt.createOutputChannel(X,Me)},createWebviewPanel(X,le,ke,ut){return Gt.createWebviewPanel(Me,X,le,ke,ut)},createWebviewTextEditorInset(X,le,ke,ut){return(0,ve.checkProposedApiEnabled)(Me,"editorInsets"),li.createWebviewEditorInset(X,le,ke,ut,Me)},createTerminal(X,le,ke){return typeof X=="object"?"pty"in X?vt.createExtensionTerminal(X):vt.createTerminalFromOptions(X):vt.createTerminal(X,le,ke)},registerTerminalLinkProvider(X){return vt.registerLinkProvider(X)},registerTerminalProfileProvider(X,le){return vt.registerProfileProvider(Me,X,le)},registerTreeDataProvider(X,le){return Jt.registerTreeDataProvider(X,le,Me)},createTreeView(X,le){return Jt.createTreeView(X,le,Me)},registerWebviewPanelSerializer:(X,le)=>Gt.registerWebviewPanelSerializer(Me,X,le),registerCustomEditorProvider:(X,le,ke={})=>hi.registerCustomEditorProvider(Me,X,le,ke),registerFileDecorationProvider(X){return Et.registerFileDecorationProvider(X,Me.identifier)},registerUriHandler(X){return Dt.registerUriHandler(Me.identifier,X)},createQuickPick(){return $t.createQuickPick(Me)},createInputBox(){return $t.createInputBox(Me.identifier)},get activeColorTheme(){return bi.activeColorTheme},onDidChangeActiveColorTheme(X,le,ke){return bi.onDidChangeActiveColorTheme(X,le,ke)},registerWebviewViewProvider(X,le,ke){return ki.registerWebviewViewProvider(Me,X,le,ke?.webviewOptions)},get activeNotebookEditor(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.onDidChangeActiveNotebookEditor(X,le,ke)},get visibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),qt.onDidChangeNotebookEditorSelection(X,le,ke)},onDidChangeNotebookEditorVisibleRanges(X,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),qt.onDidChangeNotebookEditorVisibleRanges(X,le,ke)},showNotebookDocument(X,le){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.showNotebookDocument(X,le)},registerExternalUriOpener(X,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"externalUriOpener"),Ii.registerExternalUriOpener(Me.identifier,X,le,ke)},get tabs(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),mt.tabs},get activeTab(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),mt.activeTab},get onDidChangeTabs(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),mt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),mt.onDidChangeActiveTab},getInlineCompletionItemController(X){return(0,ve.checkProposedApiEnabled)(Me,"inlineCompletions"),g.InlineCompletionController.get(X)}},Si={get rootPath(){return Re.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Le.getPath()},set rootPath(X){throw t.readonly()},getWorkspaceFolder(X){return Le.getWorkspaceFolder(X)},get workspaceFolders(){return Le.getWorkspaceFolders()},get name(){return Le.name},set name(X){throw t.readonly()},get workspaceFile(){return Le.workspaceFile},set workspaceFile(X){throw t.readonly()},updateWorkspaceFolders:(X,le,...ke)=>Le.updateWorkspaceFolders(Me,X,le||0,...ke),onDidChangeWorkspaceFolders:function(X,le,ke){return Le.onDidChangeWorkspace(X,le,ke)},asRelativePath:(X,le)=>Le.getRelativePath(X,le),findFiles:(X,le,ke,ut)=>Le.findFiles(X,le,ke,Me.identifier,ut),findTextInFiles:(X,le,ke,ut)=>{(0,ve.checkProposedApiEnabled)(Me,"findTextInFiles");let Ct,Tt;return typeof le=="object"?(Ct=le,Tt=ke):(Ct={},Tt=le,ut=ke),Le.findTextInFiles(X,Ct||{},Tt,Me.identifier,ut)},saveAll:X=>Le.saveAll(X),applyEdit(X){return ii.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,le,ke,ut)=>Lt.createFileSystemWatcher(Le,Me,X,le,ke,ut),get textDocuments(){return _t.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw t.readonly()},openTextDocument(X){let le;const ke=X;if(typeof X=="string")le=Promise.resolve(A.URI.file(X));else if(A.URI.isUri(X))le=Promise.resolve(X);else if(!ke||typeof ke=="object")le=_t.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(ut=>_t.ensureDocumentData(ut).then(Ct=>Ct.document))},onDidOpenTextDocument:(X,le,ke)=>_t.onDidAddDocument(X,le,ke),onDidCloseTextDocument:(X,le,ke)=>_t.onDidRemoveDocument(X,le,ke),onDidChangeTextDocument:(X,le,ke)=>_t.onDidChangeDocument(X,le,ke),onDidSaveTextDocument:(X,le,ke)=>_t.onDidSaveDocument(X,le,ke),onWillSaveTextDocument:(X,le,ke)=>Vt.getOnWillSaveTextDocumentEvent(Me)(X,le,ke),get notebookDocuments(){return wt.notebookDocuments.map(X=>X.apiNotebook)},async openNotebookDocument(X,le){let ke;if(A.URI.isUri(X))ke=X,await wt.openNotebookDocument(X);else if(typeof X=="string")ke=A.URI.revive(await wt.createNotebookDocument({viewType:X,content:le}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(ke).apiNotebook},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(X,le,ke,ut){return wt.registerNotebookSerializer(Me,X,le,ke,(0,ve.isProposedApiEnabled)(Me,"notebookLiveShare")?ut:void 0)},registerNotebookContentProvider:(X,le,ke,ut)=>((0,ve.checkProposedApiEnabled)(Me,"notebookContentProvider"),wt.registerNotebookContentProvider(Me,X,le,ke,(0,ve.isProposedApiEnabled)(Me,"notebookLiveShare")?ut:void 0)),onDidChangeConfiguration:(X,le,ke)=>Bt.onDidChangeConfiguration(X,le,ke),getConfiguration(X,le){return le=arguments.length===1?void 0:le,Bt.getConfiguration(X,le,Me)},registerTextDocumentContentProvider(X,le){return Qt.registerTextDocumentContentProvider(X,le)},registerTaskProvider:(X,le)=>(Re.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(Me,X,le)),registerFileSystemProvider(X,le,ke){return(0,De.combinedDisposable)(ci.registerFileSystemProvider(Me,X,le,ke),Te.addFileSystemProvider(X,le))},get fs(){return Te.value},registerFileSearchProvider:(X,le)=>((0,ve.checkProposedApiEnabled)(Me,"fileSearchProvider"),Ut.registerFileSearchProvider(X,le)),registerTextSearchProvider:(X,le)=>((0,ve.checkProposedApiEnabled)(Me,"textSearchProvider"),Ut.registerTextSearchProvider(X,le)),registerRemoteAuthorityResolver:(X,le)=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),ze.registerRemoteAuthorityResolver(X,le)),registerResourceLabelFormatter:X=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),Ci.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,le,ke)=>Lt.onDidCreateFile(X,le,ke),onDidDeleteFiles:(X,le,ke)=>Lt.onDidDeleteFile(X,le,ke),onDidRenameFiles:(X,le,ke)=>Lt.onDidRenameFile(X,le,ke),onWillCreateFiles:(X,le,ke)=>Lt.getOnWillCreateFileEvent(Me)(X,le,ke),onWillDeleteFiles:(X,le,ke)=>Lt.getOnWillDeleteFileEvent(Me)(X,le,ke),onWillRenameFiles:(X,le,ke)=>Lt.getOnWillRenameFileEvent(Me)(X,le,ke),openTunnel:X=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),we.openTunnel(Me,X).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,ve.checkProposedApiEnabled)(Me,"resolvers"),we.getTunnels()},onDidChangeTunnels:(X,le,ke)=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),we.onDidChangeTunnels(X,le,ke)),registerPortAttributesProvider:(X,le)=>((0,ve.checkProposedApiEnabled)(Me,"portsAttributes"),we.registerPortsAttributesProvider(X,le)),registerTimelineProvider:(X,le)=>((0,ve.checkProposedApiEnabled)(Me,"timeline"),Di.registerTimelineProvider(X,le,Me.identifier,dt.converter)),get isTrusted(){return Le.trusted},requestWorkspaceTrust:X=>((0,ve.checkProposedApiEnabled)(Me,"workspaceTrust"),Le.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,le,ke)=>Le.onDidGrantWorkspaceTrust(X,le,ke)},mi={get inputBox(){return Re.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(Me)},createSourceControl(X,le,ke){return vi.createSourceControl(Me,X,le,ke)}},Oi={createCommentController(X,le){return ui.createCommentController(Me,X,le)}},Li={get activeDebugSession(){return bt.activeDebugSession},get activeDebugConsole(){return bt.activeDebugConsole},get breakpoints(){return bt.breakpoints},onDidStartDebugSession(X,le,ke){return bt.onDidStartDebugSession(X,le,ke)},onDidTerminateDebugSession(X,le,ke){return bt.onDidTerminateDebugSession(X,le,ke)},onDidChangeActiveDebugSession(X,le,ke){return bt.onDidChangeActiveDebugSession(X,le,ke)},onDidReceiveDebugSessionCustomEvent(X,le,ke){return bt.onDidReceiveDebugSessionCustomEvent(X,le,ke)},onDidChangeBreakpoints(X,le,ke){return bt.onDidChangeBreakpoints(X,le,ke)},registerDebugConfigurationProvider(X,le,ke){return bt.registerDebugConfigurationProvider(X,le,ke||z.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,le){return bt.registerDebugAdapterDescriptorFactory(Me,X,le)},registerDebugAdapterTrackerFactory(X,le){return bt.registerDebugAdapterTrackerFactory(X,le)},startDebugging(X,le,ke){return!ke||typeof ke=="object"&&"configuration"in ke?bt.startDebugging(X,le,{parentSession:ke}):bt.startDebugging(X,le,ke||{})},stopDebugging(X){return bt.stopDebugging(X)},addBreakpoints(X){return bt.addBreakpoints(X)},removeBreakpoints(X){return bt.removeBreakpoints(X)},asDebugSourceUri(X,le){return bt.asDebugSourceUri(X,le)}},Ni={registerTaskProvider:(X,le)=>It.registerTaskProvider(Me,X,le),fetchTasks:X=>It.fetchTasks(X),executeTask:X=>It.executeTask(Me,X),get taskExecutions(){return It.taskExecutions},onDidStartTask:(X,le,ke)=>It.onDidStartTask(X,le,ke),onDidEndTask:(X,le,ke)=>It.onDidEndTask(X,le,ke),onDidStartTaskProcess:(X,le,ke)=>It.onDidStartTaskProcess(X,le,ke),onDidEndTaskProcess:(X,le,ke)=>It.onDidEndTaskProcess(X,le,ke)},Ui={createNotebookController(X,le,ke,ut,Ct){return Xt.createNotebookController(Me,X,le,ke,ut,(0,ve.isProposedApiEnabled)(Me,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(X,le)=>wt.registerNotebookCellStatusBarItemProvider(Me,X,le),get onDidSaveNotebookDocument(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Yt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(X){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditorDecorationType"),qt.createNotebookEditorDecorationType(X)},createRendererMessaging(X){return ai.createRendererMessaging(Me,X)},onDidChangeNotebookDocumentMetadata(X,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Yt.onDidChangeNotebookDocumentMetadata(X,le,ke)},onDidChangeNotebookCells(X,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.onDidChangeNotebookCells(X,le,ke)},onDidChangeNotebookCellExecutionState(X,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),Xt.onDidChangeNotebookCellExecutionState(X,le,ke)},onDidChangeCellOutputs(X,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.onDidChangeCellOutputs(X,le,ke)},onDidChangeCellMetadata(X,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.onDidChangeCellMetadata(X,le,ke)},createConcatTextDocument(X,le){return(0,ve.checkProposedApiEnabled)(Me,"notebookConcatTextDocument"),new _e.ExtHostNotebookConcatDocument(wt,_t,X,le)}};return{version:de.version,authentication:Ot,commands:ri,comments:Oi,debug:Li,env:Ei,extensions:Ri,languages:Fi,notebooks:Ui,scm:mi,tasks:Ni,tests:Ai,window:Mi,workspace:Si,Breakpoint:z.Breakpoint,CallHierarchyIncomingCall:z.CallHierarchyIncomingCall,CallHierarchyItem:z.CallHierarchyItem,CallHierarchyOutgoingCall:z.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:r.CancellationTokenSource,CandidatePortSource:i.CandidatePortSource,CodeAction:z.CodeAction,CodeActionKind:z.CodeActionKind,CodeActionTriggerKind:z.CodeActionTriggerKind,CodeLens:z.CodeLens,Color:z.Color,ColorInformation:z.ColorInformation,ColorPresentation:z.ColorPresentation,ColorThemeKind:z.ColorThemeKind,CommentMode:z.CommentMode,CommentThreadCollapsibleState:z.CommentThreadCollapsibleState,CompletionItem:z.CompletionItem,CompletionItemKind:z.CompletionItemKind,CompletionItemTag:z.CompletionItemTag,CompletionList:z.CompletionList,CompletionTriggerKind:z.CompletionTriggerKind,ConfigurationTarget:z.ConfigurationTarget,CustomExecution:z.CustomExecution,DebugAdapterExecutable:z.DebugAdapterExecutable,DebugAdapterInlineImplementation:z.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:z.DebugAdapterNamedPipeServer,DebugAdapterServer:z.DebugAdapterServer,DebugConfigurationProviderTriggerKind:z.DebugConfigurationProviderTriggerKind,DebugConsoleMode:z.DebugConsoleMode,DecorationRangeBehavior:z.DecorationRangeBehavior,Diagnostic:z.Diagnostic,DiagnosticRelatedInformation:z.DiagnosticRelatedInformation,DiagnosticSeverity:z.DiagnosticSeverity,DiagnosticTag:z.DiagnosticTag,Disposable:z.Disposable,DocumentHighlight:z.DocumentHighlight,DocumentHighlightKind:z.DocumentHighlightKind,DocumentLink:z.DocumentLink,DocumentSymbol:z.DocumentSymbol,EndOfLine:z.EndOfLine,EnvironmentVariableMutatorType:z.EnvironmentVariableMutatorType,EvaluatableExpression:z.EvaluatableExpression,InlineValueText:z.InlineValueText,InlineValueVariableLookup:z.InlineValueVariableLookup,InlineValueEvaluatableExpression:z.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:z.InlineCompletionTriggerKind,EventEmitter:S.Emitter,ExtensionKind:z.ExtensionKind,ExtensionMode:z.ExtensionMode,ExternalUriOpenerPriority:z.ExternalUriOpenerPriority,FileChangeType:z.FileChangeType,FileDecoration:z.FileDecoration,FileSystemError:z.FileSystemError,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:z.FoldingRange,FoldingRangeKind:z.FoldingRangeKind,FunctionBreakpoint:z.FunctionBreakpoint,InlineCompletionItem:z.InlineSuggestion,InlineCompletionList:z.InlineSuggestions,Hover:z.Hover,IndentAction:T.IndentAction,Location:z.Location,MarkdownString:z.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:z.ParameterInformation,PortAutoForwardAction:z.PortAutoForwardAction,Position:z.Position,ProcessExecution:z.ProcessExecution,ProgressLocation:z.ProgressLocation,QuickInputButtons:z.QuickInputButtons,Range:z.Range,RelativePattern:z.RelativePattern,Selection:z.Selection,SelectionRange:z.SelectionRange,SemanticTokens:z.SemanticTokens,SemanticTokensBuilder:z.SemanticTokensBuilder,SemanticTokensEdit:z.SemanticTokensEdit,SemanticTokensEdits:z.SemanticTokensEdits,SemanticTokensLegend:z.SemanticTokensLegend,ShellExecution:z.ShellExecution,ShellQuoting:z.ShellQuoting,SignatureHelp:z.SignatureHelp,SignatureHelpTriggerKind:z.SignatureHelpTriggerKind,SignatureInformation:z.SignatureInformation,SnippetString:z.SnippetString,SourceBreakpoint:z.SourceBreakpoint,StandardTokenType:z.StandardTokenType,StatusBarAlignment:z.StatusBarAlignment,SymbolInformation:z.SymbolInformation,SymbolKind:z.SymbolKind,SymbolTag:z.SymbolTag,Task:z.Task,TaskGroup:z.TaskGroup,TaskPanelKind:z.TaskPanelKind,TaskRevealKind:z.TaskRevealKind,TaskScope:z.TaskScope,TerminalLink:z.TerminalLink,TerminalLocation:z.TerminalLocation,TerminalProfile:z.TerminalProfile,TextDocumentSaveReason:z.TextDocumentSaveReason,TextEdit:z.TextEdit,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:z.TextEditorLineNumbersStyle,TextEditorRevealType:z.TextEditorRevealType,TextEditorSelectionChangeKind:z.TextEditorSelectionChangeKind,TextDocumentChangeReason:z.TextDocumentChangeReason,ThemeColor:z.ThemeColor,ThemeIcon:z.ThemeIcon,TreeItem:z.TreeItem,TreeItemCollapsibleState:z.TreeItemCollapsibleState,TypeHierarchyItem:z.TypeHierarchyItem,UIKind:i.UIKind,Uri:A.URI,ViewColumn:z.ViewColumn,WorkspaceEdit:z.WorkspaceEdit,InlayHint:z.InlayHint,InlayHintLabelPart:z.InlayHintLabelPart,InlayHintKind:z.InlayHintKind,RemoteAuthorityResolverError:z.RemoteAuthorityResolverError,ResolvedAuthority:z.ResolvedAuthority,SourceControlInputBoxValidationType:z.SourceControlInputBoxValidationType,ExtensionRuntime:z.ExtensionRuntime,TimelineItem:z.TimelineItem,NotebookRange:z.NotebookRange,NotebookCellKind:z.NotebookCellKind,NotebookCellExecutionState:z.NotebookCellExecutionState,NotebookCellData:z.NotebookCellData,NotebookData:z.NotebookData,NotebookRendererScript:z.NotebookRendererScript,NotebookCellStatusBarAlignment:z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:z.NotebookEditorRevealType,NotebookCellOutput:z.NotebookCellOutput,NotebookCellOutputItem:z.NotebookCellOutputItem,NotebookCellStatusBarItem:z.NotebookCellStatusBarItem,NotebookControllerAffinity:z.NotebookControllerAffinity,PortAttributes:z.PortAttributes,LinkedEditingRanges:z.LinkedEditingRanges,TestResultState:z.TestResultState,TestRunRequest:z.TestRunRequest,TestMessage:z.TestMessage,TestTag:z.TestTag,TestRunProfileKind:z.TestRunProfileKind,TextSearchCompleteMessageType:Be.TextSearchCompleteMessageType,TreeDataTransfer:z.TreeDataTransfer,TreeDataTransferItem:z.TreeDataTransferItem,CoveredCount:z.CoveredCount,FileCoverage:z.FileCoverage,StatementCoverage:z.StatementCoverage,BranchCoverage:z.BranchCoverage,FunctionCoverage:z.FunctionCoverage,WorkspaceTrustState:z.WorkspaceTrustState,LanguageStatusSeverity:z.LanguageStatusSeverity,QuickPickItemKind:z.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=ee}),define(ye[221],Se([0,1,220,33,213,7,10,5,11]),function(Z,e,r,t,S,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class T extends S.RequireInterceptor{_installInterceptor(){}getModule(l,o){for(let m of this._alternatives){let M=m(l);if(M){l=M;break}}if(this._factories.has(l))return this._factories.get(l).load(l,o,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends t.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const l=this._extHostContext.getProxy(I.MainContext.MainThreadConsole);i(l,this._initData.environment.isExtensionDevelopmentDebug);const o=this._instaService.invokeFunction(r.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(T,o,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(l){return l.browser}async _loadCommonJSModule(l,o,m){o=o.with({path:b(o.path,".js")}),l&&performance.mark(`code/extHost/willFetchExtensionCode/${l.value}`);const M=await fetch(D.FileAccess.asBrowserUri(o).toString(!0));if(l&&performance.mark(`code/extHost/didFetchExtensionCode/${l.value}`),M.status!==200)throw new Error(M.statusText);const C=await M.text(),w=`${o.toString(!0)}#vscode-extension`,u=`${C}
//# sourceURL=${w}`;let _;try{_=new Function("module","exports","require",u)}catch(n){throw console.error(l?`Loading code for extension ${l.value} failed: ${n.message}`:`Loading code failed: ${n.message}`),console.error(`${o.toString(!0)}${typeof n.line=="number"?` line ${n.line}`:""}${typeof n.column=="number"?` column ${n.column}`:""}`),console.error(n),n}const a={},F={exports:a},c=n=>{const f=this._fakeModules.getModule(n,o);if(f===void 0)throw new Error(`Cannot load module '${n}'`);return f};try{return m.codeLoadingStart(),l&&performance.mark(`code/extHost/willLoadExtensionCode/${l.value}`),_(F,a,c),F.exports!==a?F.exports:a}finally{l&&performance.mark(`code/extHost/didLoadExtensionCode/${l.value}`),m.codeLoadingStop()}}async $setRemoteEnvironment(l){}async _waitForDebuggerAttachment(l=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const o=Date.now()+l;for(;Date.now()<o&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=R;function b(h,l){return h.endsWith(l)?h:h+l}function i(h,l){o("info","log"),o("log","log"),o("warn","warn"),o("error","error");function o(C,w){const u=console[C];console[C]=function(){h.$logExtensionHostMessage({type:"__$console",severity:w,arguments:M(arguments)}),l&&u.apply(console,arguments)}}const m=1e5;function M(C){const w=[],u=[];if(C.length)for(let _=0;_<C.length;_++){if(typeof C[_]=="undefined")C[_]="undefined";else if(C[_]instanceof Error){const a=C[_];a.stack?C[_]=a.stack:C[_]=a.toString()}u.push(C[_])}try{const _=JSON.stringify(u,function(a,F){if(F&&typeof F=="object"){if(w.indexOf(F)!==-1)return"[Circular]";w.push(F)}return F});return _.length>m?"Output omitted for a large object that exceeds the limits":_}catch(_){return`Output omitted for an object that cannot be inspected ('${_.toString()}')`}}}}),define(ye[222],Se([0,1,44,33,71,221]),function(Z,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(t.IExtHostExtensionService,P.ExtHostExtensionService),(0,r.registerSingleton)(S.IExtensionStoragePaths,S.ExtensionStoragePaths)}),define(ye[234],Se([0,1,21,4,170,214,208,17,72,11,2,217,222]),function(Z,e,r,t,S,P,A,I,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const b=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const i=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const h=fetch.bind(self);if(self.fetch=function(w,u){return w instanceof Request||/^file:/i.test(String(w))&&(w=T.FileAccess.asBrowserUri(R.URI.parse(String(w))).toString(!0)),h(w,u)},self.XMLHttpRequest=class extends XMLHttpRequest{open(w,u,_,a,F){return/^file:/i.test(u.toString())&&(u=T.FileAccess.asBrowserUri(R.URI.parse(u.toString())).toString(!0)),super.open(w,u,_??!0,a,F)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const w=self.Worker;Worker=function(u,_){/^file:/i.test(u.toString())&&(u=T.FileAccess.asBrowserUri(R.URI.parse(u.toString())).toString(!0));const F=`(${function(g){function s(E){return typeof E=="string"||E instanceof URL?String(E).replace(/^file:\/\//i,"vscode-file://vscode-app"):E}const d=fetch.bind(self);self.fetch=function(E,v){return E instanceof Request?d(E,v):d(s(E),v)},self.XMLHttpRequest=class extends XMLHttpRequest{open(E,v,k,L,y){return super.open(E,s(v),k??!0,L,y)}};const p=importScripts.bind(self);self.importScripts=(...E)=>{p(...E.map(s))},p(g)}.toString()}('${u}'))`;_=_||{},_.name=_.name||I.basename(u.toString());const c=new Blob([F],{type:"application/javascript"}),n=URL.createObjectURL(c);return new w(n,_)}}else self.Worker=class extends A.NestedWorker{constructor(w,u){super(i,w,{name:I.basename(w.toString()),...u})}};const l=new class{constructor(){this.pid=void 0}exit(w){b()}async exists(w){return!0}async realpath(w){return w}};class o{constructor(){const u=new MessageChannel,_=new t.Emitter;let a=!1;i(u.port2,[u.port2]),u.port1.onmessage=F=>{const{data:c}=F;if(!(c instanceof ArrayBuffer)){console.warn("UNKNOWN data received",c);return}const n=r.VSBuffer.wrap(new Uint8Array(c,0,c.byteLength));if((0,S.isMessageOfType)(n,2)){a=!0,M("received terminate message from renderer");return}_.fire(n)},this.protocol={onMessage:_.event,send:F=>{if(!a){const c=F.buffer.buffer.slice(F.buffer.byteOffset,F.buffer.byteOffset+F.buffer.byteLength);u.port1.postMessage(c,[c])}}}}}function m(w){return new Promise(u=>{const _=w.onMessage(a=>{_.dispose();const F=JSON.parse(a.toString());w.send((0,S.createMessageOfType)(0)),u({protocol:w,initData:F})});w.send((0,S.createMessageOfType)(1))})}let M=w=>b();function C(){D.mark("code/extHost/willConnectToRenderer");const w=new o;return{onmessage(u){m(w.protocol).then(_=>{D.mark("code/extHost/didWaitForInitData");const a=new P.ExtensionHostMain(_.protocol,_.initData,l,null,u);M=F=>a.terminate(F)})}}}e.create=C})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/865a677399f0c0a1e98e0b9eb7308f1297b6ace4/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
